INTRODUCTION
------------

This is the README file for the CAMx model that includes information about:
1) License agreement
2) CAMx e-mail contacts
3) Upgrading to the latest version of CAMx
4) The distributed test case

Further details about CAMx are provided in the Release Notes and in the CAMx
User's Guide, available from www.camx.com.


1. LICENSE AGREEMENT
--------------------

Read the "LICENSE" file included with the source code.
The LICENSE is also accessible from the CAMx website download page:
https://www.camx.com/download/
or directly via:
http://camx.com/Files/LICENSE.txt
You agree to the CAMx license terms by downloading the source code and using
the CAMx model.


2. CAMx E-MAIL CONTACTS
-----------------------

Join the CAMx User's Group by sending an e-mail message to:

 camxdevel at gmail dot com

with the words “subscribe CAMxusers” in the BODY of the message.  You will
receive an invitation to join the Google Group along with additional
information on how to use this service.

The camxusers group is meant for broadcasting useful information about CAMx
and its pre- and post-processors to all users that subscribe to this group, or
to ask about available datasets or issues that other users may have come across.
It is not meant for asking how to run CAMx, how to prepare inputs, or why CAMx
arrived at a particular prediction.

         ** PLEASE REFER TO THE CAMx USER'S GUIDE FIRST **


3. UPGRADING TO CAMx V7 FROM PREVIOUS VERSIONS
----------------------------------------------

V7.x is a major update from previous releases (v6.x). 
Version 7 introduces netCDF input file formats for all large gridded arrays:
meteorology, landcover, initial/boundary/top concentrations, point sources,
2-D and 3-D emissions.  Output concentration, deposition and Probing Tool files
are also generated in netCDF format (since v6.5). The Fortran binary I/O formats
are removed in v7.40, so no binary I/O files generated for v7.3 or earlier can
be used. Such input files must be regenerated or converted.

Multiple point, 2-D and 3-D emission files can be provided to CAMx and Probing
Tools, alleviating the need to merge component emissions into single input
files.

NOTE on Source Apportionment Technology (SAT): With this change, SAT input
      point source emission files are used to define emissions for BOTH the
      core model and the SAT application.  In earlier CAMx versions, separate
      sets of core and SAT point source files were listed and the model compared
      SAT point emissions to core model inputs to ensure consistency.  Now ALL
      SAT point emissions are always used for BOTH SAT and the core model.  A
      "leftover" capability remains available for gridded emissions, based on
      differences between SAT emission inputs and core model emission inputs,
      but not for point emissions. It is no longer necessary to provide a
      consistent list of point sources among all of the SAT point source
      files.  The list of points to model are now an internal concatonation
      of point source lists from each input SAT point source file.

NOTE on DDM and RTRAC: With this change, DDM and RTRAC input point source
      emission files can include stack lists that are entirely unique to
      these Probing Tools.  Earlier CAMx versions required a consistent list
      of point sources among the core model, DDM and RTRAC, which was
      onerous.  This restriction is removed.

See the User's Guide for more information on file formats, requirements and
restrictions.

Refer to the namelist template provided with the source code and the User's
Guide for a full list of namelist variables for this version.  Some new
variables have been added.

Visit www.camx.com to obtain the latest code, version-specific input files 
(e.g., chemistry parameters) and all test case I/O.


4. CAMx TEST CASE
-----------------

A test case is provided to help new CAMx User's get started and permit
performance benchmarking.  The test case is based on the US EPA's 2016 Modeling
Platform, with a single nested domain covering the Eastern U.S.  The test case
includes inputs and outputs for 2 days of simulation over June 10-11, 2016,
which are available at www.camx.com.

You can compare your results to the test case benchmark by displaying
the concentration outputs using graphics programs.  We expect concentrations
to agree within the limits of single precision calculation, namely relative
errors of about 1 in 100,000.

C**** NCF_METINIT_3D
c
      subroutine ncf_metinit_3d(igrd,ncol,nrow,nlay,height,press,depth,
     &                                          windu,windv,tempk,water)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines initalizes the met fields by reading the NetCDF
c   met files and loading the data into the global arrays.
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c
c     Output arguments:
c        height              layer interface height field (m)
c        press               layer midpoint pressure field (mb)
c        depth               layer depth (m)
c        windu               u-component wind field (m/s)
c        windv               u-component wind field (m/s)
c        tempk               temperature field (K)
c        water               water vapor field (ppm)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c     07/23/19   Staggered wind flag is now grid-specific
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      integer nlay
      real    height(ncol,nrow,nlay)
      real    press(ncol,nrow,nlay)
      real    depth(ncol,nrow,nlay)
      real    windu(ncol,nrow,nlay)
      real    windv(ncol,nrow,nlay)
      real    tempk(ncol,nrow,nlay)
      real    water(ncol,nrow,nlay)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       this_tstep, this_time_tflag, this_time_etflag
      integer       istag, i, j, k
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. is_netcdf_i3dmet(igrd) ) goto 9999
c
      write(action,'(A,I3)') 'Reading 3D met file for grid ',igrd
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(i3dmet(igrd),action,begdate,begtim,
     &                 this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = nlay
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- layer heights ---
c
      this_var = "z"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,height)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- pressure ---
c
      this_var = "pressure"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,press)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- temperature ---
c
      this_var = "temperature"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,tempk)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- humidity ---
c
      this_var = "humidity"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,water)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- U-component of wind ---
c
      this_var = "uwind"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,windu)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- V-component of wind ---
c
      this_var = "vwind"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,windv)
      if( ierr .NE. NF_NOERR) goto 7001
c
c-----Calculate layer depth
c
      do k = 1,nlay
        do j = 1,nrow
          do i = 1,ncol
            if (k.eq.1) then
              depth(i,j,k) = height(i,j,k)
            else
              depth(i,j,k) = height(i,j,k) - height(i,j,k-1)
            endif
            if(depth(i,j,k) .LE. 0.0 ) then
              write(iout,'(//,a)') 'ERROR in NCF_METINIT_3D:'
              write(iout,'(a,3i3)')
     &                  'Negative depth in metinit, i,j,k = ',i,j,k
              call camxerr()
            endif
          enddo
        enddo
      enddo
c
c-----Get staggered wind flag and Convert windu and windv 
c     if they are not staggered ---
c
      this_var = 'ISTAG'
      ierr = nf_get_att_int(i3dmet(igrd), NF_GLOBAL, 'ISTAG', istag)
      if( ierr .NE. NF_NOERR ) goto 7002
      lstagw(igrd) = .TRUE.
      if( istag .EQ. 0 ) lstagw(igrd) = .FALSE.
      if( lstagw(igrd) .NEQV. lstagw(1) ) then
        write(iout,'(//,a)') 'WARNING in RDMETHDR:'
        write(iout,'(A)') action(:istrln(action))
        write(iout,*)'Mismatch in staggered wind flag with master grid'
        write(iout,*) '         Master grid stagger is: ',lstagw(1)
        write(iout,*) '         Nested grid stagger is: ',lstagw(igrd)
        write(iout,*)
      endif
      if (.not.lstagw(igrd)) call cvtwind(ncol,nrow,nlay,windu,windv)
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_3D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_3D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_3D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine vd_gas(ilu,istress,iwet,iso2,io3,z0,deltaz,psih,ustar,
     &                 diffrat,henry,henso2,f0,rscale,ts,dstress,
     &                 solflux,rj,rlu,rac,rlcs,rlco,rgss,rgso,icdocn,vd)
c
c----CAMx v7.40 260801
c
c     VD_GAS calculates a deposition velocity for a specific gas species,
c     grid cell, and land use category.  The parallel resistance approach of
c     Wesely and Hicks (1977) is used with the improvements of Wesely (1989).
c     Surface resistance (rs) to water (landuse 7) is determined following
c     Sehmel (1980), as implemented in UAM-AERO (STI, 1996).
c
c      Copyright Ramboll
c 
c     Modifications: 
c        8/18/03       Relate drought stress to PDI index
c        3/21/03       Modified Ra calculation to use layer 1 midpoint height
c                      rather than default 10 m; changed drought stress effects
c                      to stomatal resistance to be consistent with effects in
c                      GLOBEIS
c        3/26/03       Added scaling factor to surface resistance (provided
c                      on chemparam file)
c
c     Input arguments: 
c        ilu                 land use index
c        istress             vegetation drought stress index
c        iwet                surface wetness index
c                            0 = dry
c                            1 = dew wetted
c                            2 = rain wetted
c        iso2                SO2 species flag (1=SO2,0=other)
c        io3                 O3 species flag (1=O3,0=other)
c        z0                  surface roughness length (m)
c        deltaz              Layer 1 midpoint height (m)
c        psih                similarity stability correction term 
c        ustar               friction velocity (m/s)
c        diffrat             ratio of molecular diffusivity of water to species
c        henry               Henry's Law constant (M/atm)
c        henso2              Henry's Law constant for SO2 (M/atm)
c        f0                  normalized reactivity parameter
c        rscale              user-defined surface resistance scaling factor
c        ts                  surface temperature (C)
c        dstress             adjustment factors for drought stress
c        solflux             Solar radiation flux (W/m2)
c        rj                  baseline minimum stomatal resistance (s/m)
c        rlu                 baseline upper canopy (cuticle) resistance (s/m)
c        rac                 baseline canopy height/density resistance (s/m)
c        rlcs                baseline SO2 lower canopy resistance (s/m)
c        rlco                baseline O3 lower canopy resistance (s/m)
c        rgss                baseline SO2 ground surface resistance (s/m)
c        rgso                baseline O3 ground surface resistance (s/m)
c        icdocn              flag indicating an over-ocean cell
c      
c     Output arguments: 
c        vd                  deposition velocity (m/s)
c      
c     Routines called: 
c        none 
c      
c     Called by: 
c        DRYDEP
c 
      real dstress(0:5)
c
      real*8 solflux
c
      data vk/0.4/, rmin/1.0/, rmax/1.e5/, d1/2./, d2/0.667/
      data vair/1.5e-5/, diffh2o/2.3e-5/
c
c-----Entry point
c
c-----Compute atmospheric resistance, RA
c
      ra = (alog(deltaz/z0) - psih)/(vk*ustar)
      ra = amax1(ra,rmin)
c
c-----Compute the deposition layer resistance, RD
c
      schmidt = vair*diffrat/diffh2o
      rd = d1*schmidt**d2/(vk*ustar)
      rd = amax1(rd,rmin)
c
c-----Compute the surface layer resistance over water, RS
c
      if (ilu.eq.7) then
        if (io3.eq.1 .and. icdocn.eq.1) then
          rs = 1./(1.e-4 + 5.0e-6*henry*ustar*ts**3.)
          rs = amax1(rs,1500.)
        else
          rs = 1./(3.9e-5*henry*ustar*(ts + 273.15))
          rs = amax1(rs,rmin)
        endif
        goto 100
      endif
c
c-----Compute stomatal resistance, RST
c     Adjust for vegetation drought stress
c
      rst = rmax
      if (ts.gt.0. .and. ts.lt.40.) then
        rst = diffrat*rj*(1. + (200./(solflux + 0.1))**2)*
     &        (400./(ts*(40.-ts)))
        rst = rst * dstress(istress)
      endif
      if (iwet.gt.0) rst = 3.*rst
      rst = amin1(rmax,rst)
c
c-----Compute mesophyll resistance, RM
c
      rm = 1./(henry/3000. + 100.*f0)
      rm = amax1(rmin,rm)
      rm = amin1(rmax,rm)
c
c-----Compute upper canopy resistance, RUC
c     Adjust for surface wetness
c
      if (iwet.eq.0) then
        ruc = rlu/(henry/henso2 + f0)
        ruc = amin1(rmax,ruc)
      else
        if (iwet.eq.1) then
          rlus = 100.
          if (ilu.eq.1) rlus = 50.
c 
c  --- original equations from Wesely 89 ---
c         rluo = 1./(1./3000. + 1./(3.*rlu))
c
          rluo = 1000. + rlu
        else
c 
c  --- original equations from Wesely 89 ---
c         rlus = 1./(1./5000. + 1./(3.*rlu))
c
          rlus = 2000. + rlu
          if (ilu.eq.1) rlus = 50.
          rluo = 1./(1./1000. + 1./(3.*rlu))
        endif
        if (iso2.eq.1) then
          ruc = rlus
        elseif (io3.eq.1) then
          ruc = rluo
        else
c 
c  --- original equations from Wesely 89 ---
c         ruc = 1./(1./(3.*rlu) + 1.e-7*henry + f0/rluo)
c
          ruc = 1./(henry/(henso2*rlus) + f0/rluo)
          ruc = amin1(rmax,ruc)
        endif
      endif
c
c-----Compute resistance to buoyant convection, RDC
c     (assume effect of local terrain slope is non-resolvable; this
c     factor is set to 1)
c
      rdc = 100.*(1. + 1000./(solflux + 10.))
      rdc = amin1(rmax,rdc)
c
c-----Compute resistance of exposed surfaces in lower canopy, RCL
c
      rlc = 1./(henry/(henso2*rlcs) + f0/rlco)
      rlc = amin1(rmax,rlc)
c
c-----Compute resistance of ground surface, RGS
c
      rgs = 1./(henry/(henso2*rgss) + f0/rgso)
      rgs = amin1(rmax,rgs)
c
c-----Determine total surface resistance over land, RS
c
      rs = 1./(rst + rm) + 1./ruc + 1./(rdc + rlc) + 1./(rac + rgs)
      rs = amax1(rmin,1./rs)
c
c-----Scale surface resistance for acids according to user-definition
c
 100  continue
      rs = rs*rscale
c
c-----Final deposition velocity for this cell, land use, and species
c
      vd = 1./(ra + rd + rs)
c
      return
      end

      subroutine bottddm(nn,dt,dx,nspcs,sen,nsen,con0,con,
     &                                          fpc,fmc,vel,area,av1d)
      use tracer
c  
c----CAMx v7.40 260801
c  
c     BOTTDDM performs horizontal advection of the sensitivity coefficients.
c     The advection algorithm is the positive-definite, mass conservative,
c     non-monotonic scheme of Bott (1989). The sensitivity coefficients are
c     calculated by the decoupled direct method. It is assumed that none of 
c     the sensitivity coefficients represents the sensitivity with respect to
c     a parameter involved in the advection step.  E.g., none of the
c     parameters is the wind velocity. Fourth order area preserving
c     polynomials are used for the interior computational cells. First and
c     second order polynomials are applied at the boundaries.  This
c     subroutine is and must be consistent with HADVBOT.
c  
c     The following definitions are used:  
c  
c              |-----------> Positive direction  
c  
c     | Boundary|<------------------Domain------------------->| Boundary| 
c  
c     |  SEN(1) |  SEN(2) |  ...  |  SEN(I) |  ...  | SEN(N-1)|  SEN(N) |  
c     | CON0(1) | CON0(2) |  ...  | CON0(I) |  ...  |CON0(N-1)| CON0(N) |  
c     |  CON(1) |  CON(2) |  ...  |  CON(I) |  ...  | CON(N-1)|  CON(N) |  
c  
c      VEL(1)-->|      VEL(I-1)-->|         |-->VEL(I)        |-->VEL(N-1)  
c  
c       FP(1)-->|       FP(I-1)-->|         |-->FP(I)         |-->FP(N-1)  
c      FPC(1)-->|      FPC(I-1)-->|         |-->FPC(I)        |-->FPC(N-1) 
c  
c       FM(2)<--|         FM(I)<--|         |<--FM(I+1)       |<--FM(N)  
c      FMC(2)<--|        FMC(I)<--|         |<--FMC(I+1)      |<--FMC(N) 
c             
c                              -->|   DX    |<-- 
c 
c      Copyright Ramboll
c  
c     Modifications:  
c       10/13/03   area weighting applied to winds rather than conc
c         9/1/09   Revised area weighting, removed from wind vector
c  
c     Input arguments:  
c        nn                  Number of cells  
c        dt                  Time step (s)  
c        dx                  Length of cell (m)  
c        nspcs               number of tracer species  
c        sen                 Sensitivity coefficient vector 
c                              (umol/m3/parameter unit) 
c        nsen                Number of sensitivity coefficients
c        con0                Concentration vector (umol/m3) at start of
c                            timestep
c        con                 Concentration vector (umol/m3) at end of
c                            timestep
c        fpc, fmc            Positive and negative concentration fluxes before
c                            the flux limiting renormalization step (umol/m)
c        vel                 Area-weighted wind speed vector (m/s)  
c        area                Area adjustment vector
c        av1d                Interfacial area adjustment vector
c  
c     Output arguments:  
c        sen                 Sensitivity coefficient vector 
c                              (umol/m3/parameter unit)  
c  
c     Routines called:  
c        none  
c  
c     Called by:  
c        XYADVEC  
c 
      include "camx.prm"
c
      real sen(MXCELLS,*)
      real con0(nn),con(nn),fpc(nn),fmc(nn),vel(nn),area(nn),av1d(nn)
c
      real a0(MXTRSP)
      real a1(MXTRSP)
      real a2(MXTRSP)
      real a3(MXTRSP)
      real a4(MXTRSP)
      real cn(MXCELLS)
      real fm(MXCELLS,MXTRSP)
      real fp(MXCELLS,MXTRSP)
c
      data small / 1.e-20/
c             
c-----Entry point 
c
c     Calculate Courant number vector
c 
      do i = 1,nn
        cn(i) = vel(i)*dt/dx
      enddo

c     Set all sensitivity fluxes to zero.
c
      do j = 1,nsen
        do i = 1,nn
          fm(i,j) = 0.
          fp(i,j) = 0.
        enddo
      enddo
c             
c-----First order polynomials for boundary inflow fluxes 
c             
c-----Left boundary 
c
      cp = amax1(0.,cn(1))
      if (fpc(1).lt.con0(1)) then
        do j=1,nsen
          fp(1,j) = cp*(sen(1,j)+0.5*(1.-cp)*(sen(2,j)-sen(1,j)))
        enddo
      else
        do j=1,nsen
          fp(1,j) = sen(1,j)
        enddo
      endif
c             
c-----Right boundary 
c  
      cm = -amin1(0.,cn(nn-1))
      if (fmc(nn).lt.con0(nn)) then
        do j=1,nsen
          fm(nn,j) = cm*(sen(nn,j)-0.5*(1.-cm)*(sen(nn,j)-sen(nn-1,j)))
        enddo
      else
        do j=1,nsen
          fm(nn,j) = sen(nn,j)
        enddo
      endif
c             
c-----Second order polynomials for fluxes from the first and last  
c     computational cells 
c             
c-----Leftmost computational cell 
c
      do j=1,nsen
        a0(j) = (-sen(1,j) + 26.*sen(2,j) - sen(3,j))/24.
        a1(j) = (-sen(1,j)                + sen(3,j))/16.
        a2(j) = ( sen(1,j) -  2.*sen(2,j) + sen(3,j))/48.
      enddo
      cm = -amin1(0.,cn(1))
      x1 = 1. - 2.*cm
      x2 = x1*x1
      if (fmc(2).gt.0.) then
        do j=1,nsen
          fm(2,j) = a0(j)*cm-a1(j)*(1.-x2)+a2(j)*(1.-x1*x2)
        enddo
      endif
c  
      cp = amax1(0.,cn(2) )
      x1 = 1. - 2.*cp
      x2 = x1*x1
      if (fpc(2).gt.0.) then
        do j=1,nsen
          fp(2,j) = a0(j)*cp+a1(j)*(1.-x2)+a2(j)*(1.-x1*x2)
        enddo
      endif
c
c-----Flux limiting renormalization
c
      if (fmc(2)+fpc(2)+small.gt.con0(2)) then
        denom = fmc(2)+fpc(2)+small
        wt = con0(2)/denom
        wtm = fmc(2)/denom
        wtp = fpc(2)/denom
        do j=1,nsen
          fm(2,j) = fm(2,j)*wt + sen(2,j)*wtm
     &            -(fm(2,j)+fp(2,j))*wt*wtm
          fp(2,j) = fp(2,j)*wt + sen(2,j)*wtp
     &            -(fm(2,j)+fp(2,j))*wt*wtp
        enddo
      endif
c
c-----Rightmost computational cell 
c
c
      do j=1,nsen
        a0(j) = (-sen(nn-2,j) + 26.*sen(nn-1,j) - sen(nn,j))/24.
        a1(j) = (-sen(nn-2,j)                   + sen(nn,j))/16.
        a2(j) = ( sen(nn-2,j) -  2.*sen(nn-1,j) + sen(nn,j))/48.
      enddo
      cm = -amin1(0.,cn(nn-2))
      x1 = 1. - 2.*cm
      x2 = x1*x1
      if (fmc(nn-1).gt.0.) then
        do j=1,nsen
          fm(nn-1,j) = a0(j)*cm-a1(j)*(1.-x2)+a2(j)*(1.-x1*x2)
        enddo
      endif
c  
      cp = amax1(0.,cn(nn-1) )
      x1 = 1. - 2.*cp
      x2 = x1*x1
      if (fpc(nn-1).gt.0.) then
        do j=1,nsen
          fp(nn-1,j) = a0(j)*cp+a1(j)*(1.-x2)+a2(j)*(1.-x1*x2)
        enddo
      endif
c
c-----Flux limiting renormalization
c
      if (fmc(nn-1)+fpc(nn-1)+small.gt.con0(nn-1)) then
        denom = fmc(nn-1)+fpc(nn-1)+small
        wt = con0(nn-1)/denom
        wtm = fmc(nn-1)/denom
        wtp = fpc(nn-1)/denom
        do j=1,nsen
          fm(nn-1,j) = fm(nn-1,j)*wt + sen(nn-1,j)*wtm
     &             -(fm(nn-1,j)+fp(nn-1,j))*wt*wtm
          fp(nn-1,j) = fp(nn-1,j)*wt + sen(nn-1,j)*wtp
     &             -(fm(nn-1,j)+fp(nn-1,j))*wt*wtp
        enddo
      endif
c
c-----Fourth order polynomials for fluxes from the interior cells 
c
      do 10 i = 3,nn-2
        do j=1,nsen
          a0(j) = (  9.*(sen(i+2,j) + sen(i-2,j)) - 
     &             116.*(sen(i+1,j) + sen(i-1,j)) +
     &             2134.*sen(i,j))/1920.
          a1(j) = ( -5.*(sen(i+2,j) - sen(i-2,j)) +  
     &              34.*(sen(i+1,j) - sen(i-1,j)))/384.
          a2(j) = (     -sen(i+2,j) + 
     &              12.*(sen(i+1,j) + sen(i-1,j)) - 
     &               22.*sen(i,j)   - sen(i-2,j))/384.
          a3(j) = (      sen(i+2,j) - 
     &               2.*(sen(i+1,j) - sen(i-1,j)) - sen(i-2,j))/768.
          a4(j) = (      sen(i+2,j) - 
     &               4.*(sen(i+1,j) + sen(i-1,j)) + 
     &                6.*sen(i,j)   + sen(i-2,j))/3840.
        enddo
        cm = -amin1(0.,cn(i-1))
        x1 = 1. - 2.*cm
        x2 = x1*x1
        x3 = x1*x2
        if (fmc(i).gt.0.) then
          do j=1,nsen
            fm(i,j) = a0(j)*cm - a1(j)*(1. - x2)    +
     &                           a2(j)*(1. - x3)    -
     &                           a3(j)*(1. - x1*x3) +
     &                           a4(j)*(1. - x2*x3)
          enddo
        endif
c 
        cp = amax1(0.,cn(i))
        x1 = 1. - 2.*cp
        x2 = x1*x1
        x3 = x1*x2
        if (fpc(i).gt.0.) then
          do j=1, nsen
            fp(i,j) = a0(j)*cp + a1(j)*(1. - x2)    +
     &                           a2(j)*(1. - x3)    +
     &                           a3(j)*(1. - x1*x3) +
     &                           a4(j)*(1. - x2*x3)
          enddo
        endif
c
c-----Flux limiting renormalization
c
        if (fmc(i)+fpc(i)+small.gt.con0(i)) then
          denom = fmc(i)+fpc(i)+small
          wt = con0(i)/denom
          wtm = fmc(i)/denom
          wtp = fpc(i)/denom
          do j=1,nsen
            fm(i,j) = fm(i,j)*wt + sen(i,j)*wtm
     &             -(fm(i,j)+fp(i,j))*wt*wtm
            fp(i,j) = fp(i,j)*wt + sen(i,j)*wtp
     &             -(fm(i,j)+fp(i,j))*wt*wtp
          enddo
        endif
10    continue
c
c-----Update sensitivities in computational cells 
c
      do i = 2,nn-1
c-----Test if negative or small concentration was reset in hadvbot to 1.0e-20.
        if (con(i).gt.1.0e-20) then
          do j=1,nsen
            sen(i,j) = sen(i,j) - area(i)*
     &                            (av1d(i)*(fp(i,j) - fm(i+1,j)) - 
     &                             av1d(i-1)*(fp(i-1,j) - fm(i,j)))
          enddo
        else
          do j=1,nsen
            sen(i,j) = 0.0
          enddo
        endif
      enddo
c
      return
      end

      subroutine nodemass(igrd)
      use filunit
      use chmstry
      use camxfld
c
c----CAMx v7.40 260801
c
c     NODEMASS re-initializes the mass summary arrays for the slices
c
c      Copyright Ramboll
c          
c     Modifications:
c
c     Input arguments:
c        igrd                grid index
c
c     Output arguments:
c        none
c
c     Subroutines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
c-----Entry point
c
c-----Compute residual
c
c-----Move current mass array to old mass array
c
      do l = 1,nspec
        xmsold(l,igrd) = xmass(l,igrd)
      enddo
c
c-----Zeros the mass and fluxes
c
      do l = 1,nspec
        armass(l,igrd) = 0.
        ptmass(l,igrd) = 0.
        do i=1,11
          fluxes(l+(i-1)*nspec,igrd) = 0.
        enddo
        xmschem(l,igrd) = 0.
        xmsfin(l,igrd) = 0.
        pigdump(l,igrd) = 0.
        pgmserr(l,igrd) = 0.
      enddo
c
      return
      end

c*** LOADCSA_SENS
c
      subroutine loadcsa_sens(filflg,numcol,numrow,numlay,ncsa,gridval,
     &                  icl_csa,jcl_csa,kcl_csa,numspc_csa,nspc,
     &                  ngas,nrad,nhet,sens,convfac)
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine loads the sensitivies which are stored in a
c     4-D array from/into a 2-D array in conclusion/preperation 
c     of the CSA chemistry routine.  The 2-D array contains the 
c     family of sensitivities for one cell and all modeled species.
c     The flag "filflg" determines wether the values in the 4-D
c     array are loaded into the 2-D array or vice-versa.  Sensitivities
c     are converted from umol/m3 to ppm for chemistry and back.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c       filflg     L  flag for determining which direction to fill
c                     .TRUE.  = put 2-D values into 4-D gridded array
c                     .FALSE. = put 4-D values into 2-D array
c       numcol     I  number of cells in X direction
c       numrow     I  number of cells in Y direction
c       numlay     I  number of layers 
c       ncsa       I  number of total CSA species
c       gridval    R  4-D array of CSA values
c       icl_csa    I  the X grid location of current cell
c       jcl_csa    I  the Y grid location of current cell
c       kcl_csa    I  the vertical grid location of current layer
c       numspc_csa I  number of CSA families
c       nspc       I  number of modeled species
c       ngas       I  number of gaseous species
c       nrad       I  number of radical species
c       nhet       I  number of heterogeneous rxns
c       sens       R  2-D array for this cell and species
c       convfac    R  conversion from ppm to umol/m3
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      logical filflg
      integer numcol
      integer numrow
      integer numlay
      integer ncsa
      real    gridval(numcol,numrow,numlay,ncsa)
      integer icl_csa
      integer jcl_csa
      integer kcl_csa
      integer numspc_csa
      integer nspc
      integer nrad
      real    sens(numspc_csa,nspc+nhet)
      real    convfac
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   icsa, ispc, idxcsa
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- task 1: load 4-D array
c
      if( filflg ) then
c
c  --- loop over the modeled species ---
c
        do ispc=nrad+1,ngas
c
c  --- loop over the number of CSA families ---
c
          do icsa=1,numspc_csa
c
c  --- calculate the index into the CSA species list ---
c
            idxcsa = iptddm(ispc)+icsa-1
            gridval(icl_csa,jcl_csa,kcl_csa,idxcsa) = sens(icsa,ispc)*convfac
c
c  --- next family ---
c
          enddo
c
c  --- next species ---
c
        enddo
c
c  --- radical species ---
c
        do ispc=1,nrad
          do icsa=1,numspc_csa
            idxcsa = iptddm(ispc)+icsa-1
            gridval(icl_csa,jcl_csa,kcl_csa,idxcsa) = sens(icsa,ispc)
          enddo
        enddo
c
c  --- particulate species & k_hetero -> no need to load these sensitivities back
c
c
c  --- task 2: load 2-D array
c
      else
c
c  --- loop over the modeled species ---
c
        do ispc=nrad+1,ngas
c
c  --- loop over the number of CSA families ---
c
          do icsa=1,numspc_csa
c
c  --- calculate the index into the CSA species list ---
c
            idxcsa = iptddm(ispc)+icsa-1
            sens(icsa,ispc) = gridval(icl_csa,jcl_csa,kcl_csa,idxcsa)/convfac
c
c  --- next family ---
c
          enddo
c
c  --- next species ---
c
        enddo
c
c  --- radical species ---
c
        do ispc=1,nrad
          do icsa=1,numspc_csa
            idxcsa = iptddm(ispc)+icsa-1
            sens(icsa,ispc) = gridval(icl_csa,jcl_csa,kcl_csa,idxcsa)
          enddo
        enddo
c
c  --- particulate species ---
c
        do ispc=ngas+1,nspc
          do icsa=1,numspc_csa
            idxcsa = iptddm(ispc)+icsa-1
            sens(icsa,ispc) = gridval(icl_csa,jcl_csa,kcl_csa,idxcsa)
          enddo
        enddo
c
c  --- k_hetero ---
c
        do ispc=nspc+1,nspc+nhet
          do icsa=1,numspc_csa
            sens(icsa,ispc) = 0.0 ! reset to zero
          enddo
        enddo
c
c  --- done ---
c
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

c**** SPECSA
c
      subroutine specsa(idate,begtim,jdate,endtim)
      use filunit
      use tracer
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets up the species names and pointers into the species
c   for all of the tracer species.  Pointers will be set up for both the
c   concentration array and the emissions array.
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Inputs:
c        idate  I   date of the beginning of the simulation (YYJJJ)
c        begtim R   hour of the begining of simulation
c        jdate  I   date of the ending of the simulation (YYJJJ)
c        endtim R   hour of the endng of simulation
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/26/96   --gwilson--    Original development
c     12/12/97   --gwilson--    Fixed bug in initializing the timing
c                               tracers
c     11/06/01   --cemery--     Input dates are now Julian
c     12/29/06   --bkoo--       Revised for the updated SOA scheme
c     11/4/09    -cemery-       Removed reference to input top conc array
c     11/12/09   --gwilson--    Added initialization of factor for
c                               applying new type of top boundary 
c     03/18/14   --bkoo--       Added tracer for SOAH
c     08/25/16   --bkoo--       Updated for new SOAP
c     01/06/19   --cemery--     Added PFE/PMN/PMG/PK/PCA/PAL/PSI/PTI
c     01/09/19   --cemery-      Added DMS
c     
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      integer   jdate
      real      begtim
      real      endtim     
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 name
      integer*8    mvsa3d, idxsa
      integer      ibegdt, ienddt, icls, ispc
      integer      ncount, ioff, idtnow, nhours, numic_spcs, numbc_spcs
      integer      numtc_spcs, num_icbc_specs, i, j, k, l
      real         molwt_cls(MXALCLS), timnow, btim, etim
      logical      lgasflg(MXALCLS), lwrtcls(MXALCLS), lfound_class
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ibegdt = idate
      btim = begtim/100.
      ienddt = jdate
      etim = endtim/100.
c
c   --- set flags for whether this class should be 
c       written to average file ---
c
      do i=1,MXALCLS
        lwrtcls(i) = .FALSE.
        molwt_cls(i) = 1.0
      enddo
      lwrtcls(ITRO3N) = .TRUE.
      lwrtcls(ITRO3V) = .TRUE.
      lwrtcls(ITRPS4) = .TRUE.
      lwrtcls(ITRPN3) = .TRUE.
      lwrtcls(ITRPN4) = .TRUE.
      lwrtcls(ITRPA2) = .TRUE.
      lwrtcls(ITRPA1) = .TRUE.
      lwrtcls(ITRPB2) = .TRUE.
      lwrtcls(ITRPB1) = .TRUE.
      lwrtcls(ITRPA0) = .TRUE.
      lwrtcls(ITRPB0) = .TRUE.
      lwrtcls(ITRPEC) = .TRUE.
      lwrtcls(ITRHOA) = .TRUE.
      lwrtcls(ITRPFC) = .TRUE.
      lwrtcls(ITRPFN) = .TRUE.
      lwrtcls(ITRPCC) = .TRUE.
      lwrtcls(ITRPCS) = .TRUE.
      lwrtcls(ITRPFE) = .TRUE.
      lwrtcls(ITRPMN) = .TRUE.
      lwrtcls(ITRPMG) = .TRUE.
      lwrtcls(ITRPK)  = .TRUE.
      lwrtcls(ITRPCA) = .TRUE.
      lwrtcls(ITRPAL) = .TRUE.
      lwrtcls(ITRPSI) = .TRUE.
      lwrtcls(ITRPTI) = .TRUE.
      lwrtcls(ITRHG0) = .TRUE.
      lwrtcls(ITRHG2) = .TRUE.
      lwrtcls(ITRPHG) = .TRUE.
c
c  --- define the names of the tracer clasess ---
c
      clsnam(ITRVOC) = 'VOC'
      lgasflg(ITRVOC) = .TRUE.
      molwt_cls(ITRVOC) = 14.5
c
      clsnam(ITRO3N) = 'O3N'
      lgasflg(ITRO3N) = .TRUE.
      molwt_cls(ITRO3N) = 48.0
c
      clsnam(ITRO3V) = 'O3V'
      lgasflg(ITRO3V) = .TRUE.
      molwt_cls(ITRO3V) = 48.0
c
      clsnam(ITROON) = 'OON'
      lgasflg(ITROON) = .TRUE.
      molwt_cls(ITROON) = 48.0
c
      clsnam(ITROOV) = 'OOV'
      lgasflg(ITROOV) = .TRUE.
      molwt_cls(ITROOV) = 48.0
c
      clsnam(ITRSO2) = 'SO2'
      lgasflg(ITRSO2) = .TRUE.
      molwt_cls(ITRSO2) = 64.0
c
      clsnam(ITRPS4) = 'PS4'
      lgasflg(ITRPS4) = .FALSE.
c
      clsnam(ITRDMS) = 'DMS'
      lgasflg(ITRDMS) = .TRUE.
      molwt_cls(ITRDMS) = 62.1
c
      clsnam(ITRNIT) = 'NIT'
      lgasflg(ITRNIT) = .TRUE.
      molwt_cls(ITRNIT) = 30.0
c
      clsnam(ITRRGN) = 'RGN'
      lgasflg(ITRRGN) = .TRUE.
      molwt_cls(ITRRGN) = 46.0
c
      clsnam(ITRTPN) = 'TPN'
      lgasflg(ITRTPN) = .TRUE.
      molwt_cls(ITRTPN) = 121.0
c
      clsnam(ITRNTR) = 'NTR'
      lgasflg(ITRNTR) = .TRUE.
      molwt_cls(ITRNTR) = 147.0
c
      clsnam(ITRHN3) = 'HN3'
      lgasflg(ITRHN3) = .TRUE.
      molwt_cls(ITRHN3) = 63.0
c
      clsnam(ITRPN3) = 'PN3'
      lgasflg(ITRPN3) = .FALSE.
c
      clsnam(ITRNH3) = 'NH3'
      lgasflg(ITRNH3) = .TRUE.
      molwt_cls(ITRNH3) = 17.0
c
      clsnam(ITRPN4) = 'PN4'
      lgasflg(ITRPN4) = .FALSE.
c
      clsnam(ITRARO) = 'ARO'
      lgasflg(ITRARO) = .TRUE.
      molwt_cls(ITRARO) = 99.2
c
      clsnam(ITRISP) = 'ISP'
      lgasflg(ITRISP) = .TRUE.
      molwt_cls(ITRISP) = 68.1
c
      clsnam(ITRTRP) = 'TRP'
      lgasflg(ITRTRP) = .TRUE.
      molwt_cls(ITRTRP) = 136.2
c
      clsnam(ITRAPN) = 'APN'
      lgasflg(ITRAPN) = .TRUE.
      molwt_cls(ITRAPN) = 136.2
c
      clsnam(ITRFC1) = 'FV1'
      lgasflg(ITRFC1) = .TRUE.
      molwt_cls(ITRFC1) = 124.1
c
c
      clsnam(ITRSQT) = 'SQT'
      lgasflg(ITRSQT) = .TRUE.
      molwt_cls(ITRSQT) = 204.4
c
      clsnam(ITRAG2) = 'AG2'
      lgasflg(ITRAG2) = .TRUE.
      molwt_cls(ITRAG2) = 150.0
c
      clsnam(ITRAG1) = 'AG1'
      lgasflg(ITRAG1) = .TRUE.
      molwt_cls(ITRAG1) = 150.0
c
      clsnam(ITRBG2) = 'BG2'
      lgasflg(ITRBG2) = .TRUE.
      molwt_cls(ITRBG2) = 180.0
c
      clsnam(ITRBG1) = 'BG1'
      lgasflg(ITRBG1) = .TRUE.
      molwt_cls(ITRBG1) = 180.0
c
      clsnam(ITRPA2) = 'PA2'
      lgasflg(ITRPA2) = .FALSE.
c
      clsnam(ITRPA1) = 'PA1'
      lgasflg(ITRPA1) = .FALSE.
c
      clsnam(ITRPB2) = 'PB2'
      lgasflg(ITRPB2) = .FALSE.
c
      clsnam(ITRPB1) = 'PB1'
      lgasflg(ITRPB1) = .FALSE.
c
      clsnam(ITRPA0) = 'PA0'
      lgasflg(ITRPA0) = .FALSE.
c
      clsnam(ITRPB0) = 'PB0'
      lgasflg(ITRPB0) = .FALSE.
c
      clsnam(ITRIVA) = 'IVA'
      lgasflg(ITRIVA) = .TRUE.
      molwt_cls(ITRIVA) = 212.0
c
      clsnam(ITRSVA) = 'SVA'
      lgasflg(ITRSVA) = .TRUE.
      molwt_cls(ITRSVA) = 220.0
c
      clsnam(ITRPEC) = 'PEC'
      lgasflg(ITRPEC) = .FALSE.
c
      clsnam(ITRHOA) = 'HOA'
      lgasflg(ITRHOA) = .FALSE.
c
      clsnam(ITRPFC) = 'PFC'
      lgasflg(ITRPFC) = .FALSE.
c
      clsnam(ITRPFN) = 'PFN'
      lgasflg(ITRPFN) = .FALSE.
c
      clsnam(ITRPCC) = 'PCC'
      lgasflg(ITRPCC) = .FALSE.
c
      clsnam(ITRPCS) = 'PCS'
      lgasflg(ITRPCS) = .FALSE.
c
      clsnam(ITRPFE) = 'PFE'
      lgasflg(ITRPFE) = .FALSE.
c
      clsnam(ITRPMN) = 'PMN'
      lgasflg(ITRPMN) = .FALSE.
c
      clsnam(ITRPMG) = 'PMG'
      lgasflg(ITRPMG) = .FALSE.
c
      clsnam(ITRPK) = 'PK_'
      lgasflg(ITRPK) = .FALSE.
c
      clsnam(ITRPCA) = 'PCA'
      lgasflg(ITRPCA) = .FALSE.
c
      clsnam(ITRPAL) = 'PAL'
      lgasflg(ITRPAL) = .FALSE.
c
      clsnam(ITRPSI) = 'PSI'
      lgasflg(ITRPSI) = .FALSE.
c
      clsnam(ITRPTI) = 'PTI'
      lgasflg(ITRPTI) = .FALSE.
c
      clsnam(ITRHG0) = 'HG0'
      lgasflg(ITRHG0) = .TRUE.
      molwt_cls(ITRHG0) = 200.6
c
      clsnam(ITRHG2) = 'HG2'
      lgasflg(ITRHG2) = .TRUE.
      molwt_cls(ITRHG2) = 253.1
c
      clsnam(ITRPHG) = 'PHG'
      lgasflg(ITRPHG) = .FALSE.
c
c  --- calculate the beginning of the various tracer types ---
c      there will be (ngroup+1) if there is an extra group for the 
c      "leftover" group  ----
c
      if( lsa_ioric ) then
          do icls=1,ntrcls
            lfound_class = .FALSE.
            do ispc=1,num_ioric
               if( spc_ioric(ispc)(1:3) .EQ. clsnam(idxcls(icls)) ) 
     &                                        lfound_class = .TRUE.
            enddo
            if( .NOT. lfound_class ) goto 7000
          enddo
          numic_spcs = ncls_ioric
      else
          numic_spcs = 1
          ncls_ioric = 1
      endif
      if( lsa_iorbc ) then
          do icls=1,ntrcls
            lfound_class = .FALSE.
            do ispc=1,num_iorbc
               if( spc_iorbc(ispc)(1:3) .EQ. clsnam(idxcls(icls)) ) 
     &                                        lfound_class = .TRUE.
            enddo
            if( .NOT. lfound_class ) goto 7001
          enddo
          numbc_spcs = ncls_iorbc
          numtc_spcs = 0
          if( .NOT. lsa_iortc ) numtc_spcs = 1
      else
          numtc_spcs = 0
          if( lbndry ) then
              numbc_spcs = 5 
          else
              numbc_spcs = 1 
          endif
      endif
      num_icbc_specs = numic_spcs + numbc_spcs + numtc_spcs
      if( ngroup .EQ. 0 ) then
          ncount = nregin
      else
          if( leftovr_area ) then
             ncount = (ngroup + 1) * nregin
          else
             ncount = ngroup * nregin
          endif
      endif
c
c  --- set the flag for gaseous species ---
c
      do i=1,ntrcls
        do j=iptcls(i),nptcls(i)
           lsagas(j) = lgasflg(idxcls(i))
           sa_mole_weight(j) = molwt_cls(idxcls(i))
        enddo
      enddo
c
c   --- load the species from the initial conditions file ---
c
      if( lsa_ioric ) then
         do icls=1,ntrcls
           ioff = 0
           do ispc=1,num_ioric
             if( spc_ioric(ispc)(1:3) .EQ. clsnam(idxcls(icls)) ) then
                ptname(iptcls(icls)+ioff) = spc_ioric(ispc)
                ptop_fac(iptcls(icls)+ioff) = 0.0
                lsagas(iptcls(icls)+ioff) = lgasflg(idxcls(icls))
                sa_mole_weight(iptcls(icls)+ioff) = molwt_cls(idxcls(icls))
                ioff = ioff + 1
             endif
           enddo
         enddo
c
c   --- set the names for the initial condition tracers ---
c
      else
         do i=1,ntrcls
            ptname(iptcls(i)) = clsnam(idxcls(i))//'000IC  '
            ptop_fac(iptcls(i)) = 0.0
         enddo
         num_ioric = 1
      endif
c
c   --- load the species from the boundary conditions file ---
c
      if( lsa_iorbc ) then
         do icls=1,ntrcls
           ioff = numic_spcs
           do ispc=1,num_iorbc
             if( spc_iorbc(ispc)(1:3) .EQ. clsnam(idxcls(icls)) ) then
                ptname(iptcls(icls)+ioff) = spc_iorbc(ispc)
                lsagas(iptcls(icls)+ioff) = lgasflg(idxcls(icls))
                sa_mole_weight(iptcls(icls)+ioff) = molwt_cls(idxcls(icls))
                if( lsa_iortc ) then 
                    ptop_fac(iptcls(icls)+ioff) = 1.0
                else
                    ptop_fac(iptcls(icls)+ioff) = 0.0
                endif
                ioff = ioff + 1
             endif
           enddo
           if( .NOT. lsa_iortc ) then
             ptname(iptcls(icls)+ioff) = clsnam(idxcls(icls))//'TOPBC  '
             ptop_fac(iptcls(icls)+ioff) = 1.0
           endif
         enddo
c
c   --- if stratifying by boundary there will be 5 boundary condition
c       tracers, otherwise there will be only one ---
c
      else
          if( lbndry ) then
              do i=1,ntrcls
                 ptname(iptcls(i) + numic_spcs-1 + IDXBNT) = clsnam(idxcls(i))//'NTHBC  '
                 ptname(iptcls(i) + numic_spcs-1 + IDXBES) = clsnam(idxcls(i))//'ESTBC  '
                 ptname(iptcls(i) + numic_spcs-1 + IDXBST) = clsnam(idxcls(i))//'STHBC  '
                 ptname(iptcls(i) + numic_spcs-1 + IDXBWS) = clsnam(idxcls(i))//'WSTBC  '
                 ptname(iptcls(i) + numic_spcs-1 + IDXBTP) = clsnam(idxcls(i))//'TOPBC  '
                 ptop_fac(iptcls(i) + numic_spcs-1 + IDXBNT) = 0.0
                 ptop_fac(iptcls(i) + numic_spcs-1 + IDXBES) = 0.0
                 ptop_fac(iptcls(i) + numic_spcs-1 + IDXBST) = 0.0
                 ptop_fac(iptcls(i) + numic_spcs-1 + IDXBWS) = 0.0
                 ptop_fac(iptcls(i) + numic_spcs-1 + IDXBTP) = 1.0
              enddo
          else
              do i=1,ntrcls
                 ptname(iptcls(i)+numic_spcs) = clsnam(idxcls(i))//'000BC  '
                 ptop_fac(iptcls(i)+numic_spcs) = 1.0
              enddo
          endif
      endif
c
c  --- construct the tracer names and put into names array ---
c
      if( ngroup .EQ. 0 ) then
          ioff = num_icbc_specs
          do i=1,nregin
             do k=1,ntrcls
                 write(name,'(A,I3.3,I3.3)') clsnam(idxcls(k)),1,i
                 ptname(iptcls(k)+ioff) = name
                 ptop_fac(iptcls(k)+ioff) = 0.0
             enddo
             ioff = ioff + 1
          enddo
      else
          ioff = num_icbc_specs
          if( leftovr_area ) then
             ncount = ngroup + 1
          else
             ncount = ngroup 
          endif
          do j=1,ncount
             do i=1,nregin
                do k=1,ntrcls
                   write(name,'(A,I3.3,I3.3)') clsnam(idxcls(k)),j,i
                   ptname(iptcls(k)+ioff) = name
                   ptop_fac(iptcls(k)+ioff) = 0.0
                enddo
                ioff = ioff + 1
             enddo
          enddo
      endif
c
c  --- calculate the number of timing tracers there will be and put
c      the names into the names array ---
c
      ntotsp = ipttim - 1 
      if( ntrtim .GT. 0 ) then
        if( etim .EQ. 0. ) then
            etim = 24.
            ienddt = ienddt - 1
        endif 
        timnow = btim
        idtnow = ibegdt
        nhours = (ienddt-ibegdt)*24 + INT( etim - btim ) 
        npttim = 1
        do i=1,nhours
           if( MOD( INT(timnow), 24/ntrtim ) .EQ. 0 .OR. i .EQ. 1) then
              do j=1,nregin
                  write(name,'(A,I3.3,I2.2,I3.3)') 'I',MOD(idtnow,1000),
     &                                                  INT(timnow),j
                  ptname(ntotsp+1) = name
                  ptop_fac(ntotsp+1) = 0.0
                  write(name,'(A,I3.3,I2.2,I3.3)') 'D',MOD(idtnow,1000),
     &                                                  INT(timnow),j
                  ptname(ntotsp+2) = name
                  ptop_fac(ntotsp+2) = 0.0
                  npttim = npttim + 2
                  ntotsp = ntotsp + 2
              enddo
           endif
           timnow = timnow + 1.0
           if( timnow .EQ. 24.0 ) then
               timnow = 0.
               idtnow = idtnow + 1
           endif
        enddo
      endif
c
c  --- if doing SOAP3, update the tracer species list with SOAP2
c      emissions species ---
c
      if( luse_soap3 .AND. lsoa ) then
         if( ngroup .EQ. 0 ) then
             ioff = 0
             do i=1,nregin
                do k=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                    write(name,'(A,I3.3,I3.3)') soap3_clsnam(k),1,i
                    ptname(soap3_iptcls(k)+ioff) = name
                enddo
                ioff = ioff + 1
             enddo
         else
             ioff = 0
             if( leftovr_area ) then
                ncount = ngroup + 1
             else
                ncount = ngroup
             endif
             do j=1,ncount
                do i=1,nregin
                   do k=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                      write(name,'(A,I3.3,I3.3)') soap3_clsnam(k),j,i
                      ptname(soap3_iptcls(k)+ioff) = name
                   enddo
                   ioff = ioff + 1
                enddo
             enddo
         endif
      endif
c
c  --- initialize all of the tracers concs to zero to start off ---
c
      mvsa3d = 0
      do i=1,ngrid
         mvsa3d = mvsa3d + DBLE(ncol(i)) * DBLE(nrow(i)) * DBLE(nlay(i))
      enddo
      mvsa3d = DBLE(mvsa3d) * DBLE(ntotsp)
      do idxsa=1,mvsa3d
        ptconc(idxsa) = 0.
      enddo
      do l=1,soap3_ntotsp
         lsamap(l) = l
      enddo
      do l=1,ntotsp
         do i=1,MXRECP
            conrcp(l,i) = 0.        
         enddo
      enddo
c
c  --- set the flag for outputting the species to average file
c      to true automatically for tracer species ---
c
      loutsa = .FALSE.
      if( lallout ) then
         do i=1,ntotsp
            loutsa(i) = .TRUE.
         enddo
      else
         do i=1,ntotsp
            loutsa(i) = .FALSE.
         enddo
         do j=1,ntrcls
           if( lwrtcls(idxcls(j)) ) then
              do i=iptcls(j),nptcls(j)
                 loutsa(i) = .TRUE.
              enddo
           endif
         enddo
      endif
c      
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in SPECSA:'
      write(iout,'(2A)',ERR=9999) 'You requested a tracer species ',
     &       'that is not included in your SA IC file.'
      write(iout,'(2A)',ERR=9999) 'Either disable the class or ',
     &       'supply the data in the SA IC file.'
      write(iout,'(10X,2A)',ERR=9999) 'SA species: ',clsnam(idxcls(icls))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in SPECSA:'
      write(iout,'(2A)',ERR=9999) 'You requested a tracer species ',
     &       'that is not included in your SA BC file.'
      write(iout,'(2A)',ERR=9999) 'Either disable the class or ',
     &       'supply the data in the SA BC file.'
      write(iout,'(10X,2A)',ERR=9999) 'SA species: ',clsnam(idxcls(icls))
      call camxerr()
c
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c*** HDRWSA
c
      subroutine hdrwsa(iounit,fname,ftype,nspcs,nzcell,
     &             idate,btim,jdate,etim,spec_units,spec_long_name,
     &                                          spec_desc,spec_coords)
      use filunit
      use grid
      use camxcom
      use camxfld
      use tracer
      use procan
      use ncf_iomod
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the header information to the output tracer
c     instantaneous files and tracer surface concentration files.
c     The data is written to the unit number in the argument list.
c
c      Copyright Ramboll
c
c    Argument description:
c      iounit         I  unit number of file to write
c      fname          C  name of file being written
c      ftype          C  file type of file being written 
c      nspcs          I  number of species to write to file
c      nzcell         I  number of layers (will be 1 for surface file)
c      idate          I   beginning date of simulation (YYJJJ)
c      btim           R   beginning time of simulation
c      jdate          I   ending date of simulation (YYJJJ)
c      etim           R   ending time of simulation
c      spec_units     C array of units for this each species
c      spec_long_name C array of "long names" for each each species
c      spec_desc      C array of desciption for this each species
c      spec_coords    C array of coordinates for this each species

c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c      1/20/99   Grid cell size on file should be meters for all
c                cartesian projections (UTM, LCP, PSP)
c      10/24/01  Removed BSWAP and converted integer strings to character*4
c      11/06/01  Input dates are now Julian
c      8/25/06   Surface output files now all UAM format, one file per grid
c      1/04/11   Revised for new header format
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer      iounit(*)
      character*(*) fname(*)
      character*10 ftype
      integer      nspcs
      integer      nzcell       
      integer      idate
      real         btim
      integer      jdate
      real         etim
      character*20 spec_units(*)
      character*20 spec_long_name(*)
      character*60 spec_desc(*)
      character*60 spec_coords(*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10 ncf_filtype
      character*4  ifile(10), note(60), ispec(10,MXTRSP)
      integer      i, j, ndate, ndlast, izero, ione, num_dims
      real         ttime, ttlast, zero, factr
      real         xorgf, yorgf, dxf, dyf
      logical      lwrite_file
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data zero /0.0/
      data izero /0/
      data ione  /1/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( tectyp .EQ. SA ) then
         ncf_filtype = "SA        "
      else if( tectyp .EQ. DDM .OR. tectyp .EQ. HDDM ) then
         ncf_filtype = "DDM       "
      else if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
         ncf_filtype = "RTRAC     "
      else
         ncf_filtype = "CPA       "
      endif
      ndate = idate
      ndlast = jdate
      ttime  = AINT(ANINT(btim)/100.) + amod(ANINT(btim),100.)/60.
      ttlast = AINT(ANINT(etim)/100.) + amod(ANINT(etim),100.)/60.
c
c   --- set scaling factor for coordinates ---
c
      iutm = iuzon
      plon = polelon
      plat = polelat
      t1   = tlat1
      t2   = tlat2
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
c
c   ---- put species names into integer array ----
c 
      nspcout = 0
      ptnameout = ' '
      do 10 j=1,nspcs
        if( loutsa(j) .OR. ftype .EQ. 'AIRQUALITY' ) then
            nspcout = nspcout + 1
            read(ptname(j),'(10A1)') (ispec(i,nspcout),i=1,10)
            if( lcdfout ) then
                if( lddm .OR. lhddm ) then
                   ptnameout(nspcout) = ptlong(j)
                else
                   ptnameout(nspcout)(1:10) = ptname(j)
                endif
            endif
        endif
   10 continue
c
c   --- master grid file header ---
c
      lwrite_file = .TRUE.
      read(ftype,'(10A1)') (ifile(i),i=1,10)
      read(runmsg(1:60),'(60A1)') (note(i),i=1,60)
      if( (lddm .OR. lhddm) .AND. .NOT. lddmcalc(1) ) lwrite_file = .FALSE.
      if( lwrite_file ) then
          n = 1
          nz = 1
          num_dims = 4
          if (nzcell.gt.1) nz = nlay(1)
          if( ltrace .AND. lsa_3davrg ) nz = nlay(1)
          if( lirr ) then
             nz = 1
             if( l3davg(n) ) nz = nlay(n)
          endif
           ntotspout = nspcout
          if( lcdfout ) then
              call ncf_set_vars_base()
              call ncf_set_tstep(idate,btim,jdate,etim)
          endif
          if( .NOT. lcdfout .OR. ftype .EQ. 'AIRQUALITY' ) then
             write(iounit(1),ERR=7000) ifile,note,itzon,nspcout,ndate,ttime,
     &                                                    ndlast,ttlast
             write(iounit(1),ERR=7000) plon,plat,iutm,orgx,orgy, 
     &                                   dx,dy,ncol(1),nrow(1), 
     &                                   nz,iproj,izero,t1,t2,zero
             write(iounit(1),ERR=7000) ione,ione,ncol(1),nrow(1)
             write(iounit(1),ERR=7000) ((ispec(i,j),i=1,10),j=1,nspcout)
             if( ftype .EQ. 'AIRQUALITY' ) goto 9999
          else if( lcdfout .AND. ftype .NE. 'AIRQUALITY' ) then
              action = 'Writing tracer output file: '//fname(1)(:istrln(fname(1)))
              call ncf_set_global(ncf_filtype,1,ndate,ttime*100.,ndlast,ttlast,
     &                                                       nz,nspcout)
              call ncf_wrt_dim(action,iounit(1),1,ncol(1),nrow(1),nz,nspcout)
              call ncf_wrt_global(action,iounit(1),nspcout,ptnameout,.FALSE.)
              if( tectyp .EQ. SA ) then
                 call ncf_wrt_global_sa(action,iounit(1))
              else if( tectyp .EQ. DDM .OR. tectyp .EQ. 'HDDM' ) then
                 call ncf_wrt_global_ddm(action,iounit(1))
              endif
              call ncf_wrt_vars_base(action,iounit(1))
              call ncf_wrt_vars_species(action,iounit(1),ncol(1),nrow(1),nz,
     &                        nspcout,ptnameout,spec_units,spec_long_name,
     &                                       spec_desc,spec_coords,num_dims)
              call ncf_enddef_file(action,iounit(1))
              call ncf_wrt_data_grid(action,iounit(1),1,ncol(1),nrow(1),
     &                           orgx,orgy,dx,dy,nz,cellat(iptr2d(1)),
     &                                   cellon(iptr2d(1)),topo(iptr2d(1)))
          endif
      endif
c
c   --- nested grid headers ---
c
      do n = 2,ngrid
         if( (lddm .OR. lhddm) .AND. .NOT. lddmcalc(n) ) cycle
         dxf   = dx/float(meshold(n))
         dyf   = dy/float(meshold(n))
         xorgf = orgx + dx*(inst1(n)-1)
         yorgf = orgy + dy*(jnst1(n)-1)
         nz = 1
         num_dims = 4
         if (nzcell.gt.1) nz = nlay(n)
         if( ltrace .AND. lsa_3davrg ) nz = nlay(1)
         if( lirr ) then
            nz = 1
            if( l3davg(n) ) nz = nlay(n)
         endif
         if( .NOT. lcdfout .OR. ftype .EQ. 'AIRQUALITY' ) then
            write(iounit(n),ERR=7000) ifile,note,itzon,nspcout,ndate,ttime,
     &                                                       ndlast,ttlast
            write(iounit(n),ERR=7000) plon,plat,iutm,xorgf,yorgf,dxf,dyf,
     &                                   ncol(n)-2,nrow(n)-2,nz,iproj,izero,
     &                                                        t1,t2,zero
            write(iounit(n),ERR=7000) ione,ione,ncol(n)-2,nrow(n)-2
            write(iounit(n),ERR=7000) ((ispec(i,j),i=1,10),j=1,nspcout)
            if( ftype .EQ. 'AIRQUALITY' ) goto 111
         else
          action = 'Writing tracer output file: '//fname(n)(:istrln(fname(n)))
          call ncf_set_global(ncf_filtype,n,ndate,ttime*100.,ndlast,ttlast,
     &                                                       nz,nspcout)
          call ncf_wrt_dim(action,iounit(n),n,ncol(n),nrow(n),nz,nspcout)
          call ncf_wrt_global(action,iounit(n),nspcout,ptnameout,.FALSE.)
          if( tectyp .EQ. SA ) then
             call ncf_wrt_global_sa(action,iounit(n))
          else if( tectyp .EQ. DDM .OR. tectyp .EQ. 'HDDM' ) then
             call ncf_wrt_global_ddm(action,iounit(n))
          endif
          call ncf_wrt_vars_base(action,iounit(n))
          call ncf_wrt_vars_species(action,iounit(n),ncol(n),nrow(n),nz,
     &                        nspcout,ptnameout,spec_units,spec_long_name,
     &                                         spec_desc,spec_coords,num_dims)
          call ncf_enddef_file(action,iounit(n))
          call ncf_wrt_data_grid(action,iounit(n),n,ncol(n),nrow(n),
     &                           orgx,orgy,dx,dy,nz,cellat(iptr2d(n)),
     &                                   cellon(iptr2d(n)),topo(iptr2d(n)))
         endif
      enddo
c
c  --- reset the output species name ---
c
  111 continue
      ptnameout = ' '
      do j=1,nspcs
         if( lddm .OR. lhddm ) then
             ptnameout(j) = ptlong(j)
         else
             ptnameout(j)(1:10) = ptname(j)
         endif
      enddo
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in HDRWSA:'
      write(iout,9000,ERR=9999)'Writing output tracer file: ',
     &                                     fname(n)(:istrln(fname(n)))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,2A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
c

c**** CLRBDYSA.F
c
      subroutine clrbdysa(igrid,nox,noy,noz,nspsa,saconc)
      use bndary
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine resets the boundary conditions to zero.  This is 
c   necessary since the routine that fills the boundary conditions
c   accumulates all some of the regular model species.  Without resetting
c   the arrays to zero first, the boundary conditions become VERY large.
c   Since only the boundary conditions get filled in this way, only the
c   boundary should be reset to zero.
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  array of concentrations to clear
c       Inputs:
c           igrid    I  grid number of this grid
c           nox      I  number of cells in X direction
c           noy      I  number of cells in Y direction
c           noz      I  number of vertical cells in grid
c           nspsa    I  number of species 
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/06/96   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   igrid
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      logical, external :: isbound
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer      ioff, izcl, icl, jcl, icls
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- do the WEST and EAST boundaries ----
c
      do 10 jcl=2,noy-1
c
c  --- West boundary ---
c
         do izcl=1,noz
c
c   --- if stratifying by boundary, put in seperate position ---
c
            if( lbndry ) then
               ioff = ncls_ioric-1 + IDXBWS
            else
               ioff = ncls_ioric
            endif
c
c   --- reset each boundary tracer to zero ----
c
            if( .NOT. lmpi .OR. 
     &                isbound( mibcon(1),mmxp(1),mmyp(1),1,0 ) ) then
               do icls=1,ntrcls
                  saconc(1,jcl,izcl,iptcls(icls)+ioff) = 0.
               enddo
            endif
c
c  --- East boundary ---
c
c   --- if stratifying by boundary, put in seperate position ---
c
            if( lbndry ) then
               ioff = ncls_ioric-1 + IDXBES
            else
               ioff = ncls_ioric
            endif
c
c   --- reset each boundary tracer to zero ----
c
            if( .NOT. lmpi .OR. 
     &        isbound( mibcon(1),mmxp(1),mmyp(1),mmxp(1),0 ) ) then
               do icls=1,ntrcls
                   saconc(nox,jcl,izcl,iptcls(icls)+ioff) = 0.
               enddo
            endif
         enddo
   10 continue
c
c  --- do the SOUTH and NORTH boundaries ----
c
      do 20 icl=2,nox-1
         do izcl=1,noz
c
c   --- stratifying by boundary, put in seperate position ---
c
            if( lbndry ) then
                ioff = ncls_ioric-1 + IDXBST
            else
                ioff = ncls_ioric
            endif
c
c   --- reset each boundary tracer to zero ----
c
            if( .NOT. lmpi .OR. 
     &              isbound( mibcon(1),mmxp(1),mmyp(1),0,1 ) ) then
                do icls=1,ntrcls
                   saconc(icl,1,izcl,iptcls(icls)+ioff) = 0.
                enddo
            endif
c
c  --- North boundary ---
c
c   --- if stratifying by boundary, put in seperate position ---
c
            if( lbndry ) then
                ioff = ncls_ioric-1 + IDXBNT
            else
                ioff = ncls_ioric
            endif
c
c   --- reset each boundary tracer to zero ----
c
            if( .NOT. lmpi .OR. 
     &          isbound( mibcon(1),mmxp(1),mmyp(1),0,mmyp(1) ) ) then
               do icls=1,ntrcls
                  saconc(icl,noy,izcl,iptcls(icls)+ioff) = 0.
               enddo
            endif
         enddo
   20 continue
c
c  --- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine bcmodfy(nspec,ncol1,nrow1,nlay1,ncol2,nrow2,nlay2,
     &                   i1g1,j1g1,i2g1,j2g1,i1g2,j1g2,i2g2,j2g2,
     &                   nmsh1,nmsh2,conc1,conc2)
      use filunit
c
c----CAMx v7.40 260801
c
c     BCMODFY set the portion of boundary conditions where two fine 
c     grids are attached to each other.  CAMx requires adjacent nests
c     to have the same layer structure (nlay1 == nlay2) and this is
c     is enforced here.
c                            
c      Copyright Ramboll
c            
c     Modifications:  
c        None
c
c     Input arguments:
c        nspec             number of species
c        ncol1             number of columns of grid 1
c        nrow1             number of rows of grid 1
c        nlay1             number of layers of grid 1
c        ncol2             number of columns of grid 2
c        nrow2             number of rows of grid 2
c        nlay2             number of layers of grid 2
c        i*g1,j*g1         starting/ending row/columns for grid 1
c        i*g2,j*g2         starting/ending row/columns for grid 2
c        nnmsh1            meshing factor for grid 1
c        nnmsh2            mehs number of grid 2
c        conc1             concentrations on grid 1 (umol/m3)
c        conc2             concentrations on grid 2 (umol/m3)
c
c     Output arguments:
c        conc1             concentrations on grid 1 (umol/m3)
c        conc2             concentrations on grid 2 (umol/m3)
c
c
c     Routines called:
c        SETBC1D
c
c     Called by:
c        SETBC
c
      include "camx.prm"
c
      real conc1(ncol1,nrow1,nlay1,nspec)
      real conc2(ncol2,nrow2,nlay2,nspec)
c
      real cnew1(MXCELLS)
      real cold1(MXCELLS)
      real cnew2(MXCELLS)
      real cold2(MXCELLS)
c
c-----Entry point
c
      do 50 ispc = 1,nspec
        nlay = nlay1
c
c-----Case 1: grid 2 is to the east of grid 1
c
        jbeg0 = max0(j1g1,j1g2)
        jend0 = min0(j2g1,j2g2)
        if (i2g1+1.eq.i1g2 .and. jend0.ge.jbeg0) then
c
          if (nlay1.ne.nlay2) then
            write(iout,'(//,a)') 'ERROR in BCMODFY:'
            write(iout,*) 'Illegal nest configuration'
            write(iout,*) 'nlay1 != nlay2: ',nlay1,nlay2
            call camxerr()
          endif
c
          do 10 k=1,nlay
c
c-----Load old concentrations
c
            jbeg1 = (jbeg0 - j1g1)*nmsh1
            jend1 = (jend0 - j1g1)*nmsh1
            n1 = 0
            do j=jbeg1,jend1
              n1 = n1 +1
              cold1(n1) = conc1(ncol2-1,j,k,ispc)
            enddo
c
            jbeg2 = (jbeg0 - j1g2)*nmsh2
            jend2 = (jend0 - j1g2)*nmsh2
            n2 = 0
            do j=jbeg2,jend2
              n2 = n2 + 1
              cold2(n2) = conc2(2,j+1,k,ispc)
            enddo
c
c-----Compute new concentrations
c
            call setbc1d(n1,n2,cnew1,cold2)
            call setbc1d(n2,n1,cnew2,cold1)
c
c-----Load new concentrations for the boundary cells
c
            n1 = 0
            do j=jbeg1,jend1
              n1 = n1 +1
              conc1(ncol2,j+1,k,ispc) = cold1(n1)
            enddo
c
            n2 = 0
            do j=jbeg2,jend2
              n2 = n2 + 1
              conc2(1,j+1,k,ispc) = cold2(n2)
            enddo
  10      continue
        endif
c
c-----Case 2: grid 2 is to the north of grid 1
c
        ibeg0 = max0(i1g1,i1g2)
        iend0 = min0(i2g1,i2g2)
        if (j2g1+1.eq.j1g2 .and. iend0.ge.ibeg0) then
c
          if (nlay1.ne.nlay2) then
            write(iout,'(//,a)') 'ERROR in BCMODFY:'
            write(iout,*) 'Illegal nest configuration'
            write(iout,*) 'nlay1 != nlay2: ',nlay1,nlay2
            call camxerr()
          endif
c
          do 20 k=1,nlay
c
c-----load old concentrations
c
            ibeg1 = (ibeg0 - i1g1)*nmsh1
            iend1 = (iend0 - i1g1)*nmsh1
            n1 = 0
            do i=ibeg1,iend1
              n1 = n1 + 1
              cold1(n1) = conc1(i,nrow1-1,k,ispc)
            enddo
c
            ibeg2 = (ibeg0 - i1g2)*nmsh2
            iend2 = (iend0 - i1g2)*nmsh2
            n2 = 0
            do i=ibeg2,iend2
              n2 = n2 + 1
              cold2(n2) = conc2(i+1,2,k,ispc)
            enddo
c
c-----compute new concentrations
c
            call setbc1d(n1,n2,cnew1,cold2)
            call setbc1d(n2,n1,cnew2,cold1)
c
c-----load new concentrations for the boundary cells
c
            n1 = 0
            do i=ibeg1,iend1
              n1 = n1 + 1
              conc1(i+1,nrow1,k,ispc) = cold1(n1)
            enddo
c
            n2 = 0
            do i=ibeg2,iend2
              n2 = n2 + 1
              conc2(i+1,1,k,ispc) = cold2(n1)
            enddo
c
  20      continue
        endif
c
  50  continue
c
      return
      end

      subroutine wetdeprt(m1,m2,m1rt,m2rt,ixcl,jycl,nlay,nrtsp,deltat,area,
     &                    depth,tempk,press,cwc,pwr,pws,pwg,cph,densfac,
     &                    conc,solmass,vegmass,fsurf)
      use chmstry
      use rtracchm
c
c----CAMx v7.40 260801
c 
c     This version is for the RTRAC species.
c     WETDEP modifies vertical concentration profiles for a given grid via 
c     precipitation processes.  This subroutine has been completely rewritten
c     for CAMx v4.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        05/01/03   Taken from WETDEP for regular model
c        06/15/03   Fixed bug in scaling of tmass
c        02/11/04   Updated empirical rainfall relationships
c        05/03/05   Revised gas scavenging calculation
c        06/20/05   Revised to handle liquid/frozen cloud and precip water
c        10/21/05   Added dissociation to Henry's Law for NH3, HNO3, SO2
c        08/31/06   Added map scale factor
c        10/29/09   Added flux of RTRAC species to surface model
c        12/22/09   Improved treatment of "c0" array
c        10/09/14   Restructured for subgrid convective model
c        03/17/16   Fixed bug to dissallow tmass<0 (Ondrej Vlcek, CHMI)
c        06/06/16   Simplified gas scavenging approach, removed rain evap
c        08/04/16   Revised mean PM size in the fine mode (<2.5um) to
c                   account for more efficient PM scavenging at the
c                   high end of the size distribution
c        08/26/21   Surface file doubles as (default) dep output or (flagged)
c                   surface model output
c
c     Input arguments:
c        m1                  number of slice columns
c        m2                  number of slice rows
c        m1rt                number of slice columns for RTRAC
c        m2rt                number of slice rows for RTRAC
c        ixcl                i-cell index
c        jycl                j-cell index
c        nlay                number of layers 
c        nrtsp               number of species in RTRAC array
c        deltat              time step (s)
c        area                cell area (m2)
c        depth               cell depth (m)
c        tempk               temperature field (K)
c        press               pressure field (mb)
c        cwc                 cloud water content (g/m3)
c        pwr                 rain water content (g/m3)
c        pws                 snow water content (g/m3)
c        pwg                 graupel water content (g/m3)
c        cph                 cloud water pH
c        densfac             factor to convert to umol/m3
c        conc                concentration field (umol/m3, ug/m3)
c        solmass             surface soil mass field (mol/ha, g/ha)
c        vegmass             surface veg mass field (mol/ha, g/ha)
c        fsurf               fractional landuse coverage
c             
c     Output arguments: 
c        conc                concentration field (umol/m3, ug/m3)
c        solmass             surface soil mass field (mol/ha, g/ha)
c        vegmass             surface veg mass field (mol/ha, g/ha)
c             
c     Routines called: 
c        SCAVRAT
c        HENRYFNC
c             
c     Called by: 
c        CIGDRIVE
c 
      implicit none
      include 'camx.prm'
      include 'deposit.inc'
      include 'rtracsrf.inc'
c
      integer m1,m2,m1rt,m2rt,ixcl,jycl,nlay,nrtsp
      real deltat,area,densfac
      real, dimension(nlay) :: tempk,press,cwc,pwr,pws,pwg,cph,depth
      real, dimension(MXLAYER,MXTRSP) :: conc
      real, dimension(m1rt,m2rt,nrtsp) :: solmass,vegmass
      real, dimension(m1,m2,NLUW89) :: fsurf

      logical lcloud,lgraupl
      integer kbot,ktop,k,l,n
      integer iwater
      real rd,rhoh2o,cellvol,rhoair,delc,delm,convfac,cmin,hlaw,
     &     dscav,gscav,ascav,psize,cwat,pwat,pwtr,rconst,
     &     depmas,dtfall,drpvel,delc0,ceqc,ceqp,ceqpp,pliq
c
      real pp
      real rr
      real volrat
      real tmass(MXTRSP)
      real c0(MXTRSP)
c
      data rd /287./         ! Dry air gas constant (J/K/kg)
      data rhoh2o /1.e6/     ! water density (g/m3)
      data rconst /8.206e-2/ ! gas constant (l.atm/mol.K)
c
c-----Entry point
c
c
c-----If precip is not getting to the ground, there is no wet dep
c
      if (pwr(1).lt.cwmin .and. pws(1).lt.cwmin .and.
     &    pwg(1).lt.cwmin) return
c
c-----Scan column for layers containing cloud top
c
      kbot = 1
      pp = pwr(1) + pws(1) + pwg(1)
      volrat = pp/rhoh2o                 ! drop volume/air volume
      rr = (volrat/1.0e-7)**1.27         ! rainfall rate (mm/hr)
c
      ktop = 0
      do k = 1,nlay
        if (cwc(k).lt.cwmin .and. ktop.ne.0) then
          goto 26
        endif
        if (cwc(k).ge.cwmin) ktop = k
      enddo
      ktop = nlay
  26  continue
c
      do l = 1,nrtsp
        tmass(l) = 0.
        c0(l)    = 0.
      enddo
c
c-----Loop over layers and species for precipitating columns
c
      pliq = 0.
      do 30 k = ktop,kbot,-1
        lcloud = .false.
        lgraupl = .false.
        if (pwg(k).ge.cwmin) lgraupl = .true.
        if (cwc(k).ge.cwmin) lcloud = .true.
        cellvol = area*depth(k)
        rhoair = 100.*press(k)/(rd*tempk(k))
        cwat = cwc(k)
        pwtr = pp + pliq
        if (tempk(k).lt.273.)
     &    cwat = max(0.,cwat*(tempk(k) - tamin)/(273. - tamin))
c
c-----Calculate scavenging for soluble gas species
c
        do 40 l = 1,nrtgas
          if( rthlaw(l).LT.1.e-6 ) goto 40
          convfac = densfac*(273./tempk(k))*(press(k)/1013.)
          cmin = rtlbnd(l)*convfac
          conc(k,l) = max(cmin,conc(k,l))
          call henryfnc(0,rthlaw(l),rttfact(l),tempk(k),cph(k),knh3,
     &                  khno3,kso2,hlaw)
          hlaw = hlaw*rconst*tempk(k)
          ceqc = conc(k,l)*(1. - 1./(1. + hlaw*cwat/rhoh2o))
          call henryfnc(0,rthlaw(l),rttfact(l),tempk(k),5.,knh3,
     &                  khno3,kso2,hlaw)
          hlaw = hlaw*rconst*tempk(k)
          pwat = pwtr
          if (tempk(k).lt.273. .and. rscale(l).gt.0.) pwat = 0.
          ceqp = conc(k,l)*(1. - 1./(1. + hlaw*pwat/rhoh2o))
          ceqpp = (conc(k,l) - ceqc)*(1. - 1./(1. + hlaw*pwat/rhoh2o))
c
          call scavrat(.false.,lcloud,lgraupl,tamin,rr,tempk(k),
     &                 rhoair,rtdrate(l),0.,0.,dscav,gscav,ascav,drpvel)
c
          dtfall = depth(k)/drpvel
          if (c0(l).lt.ceqp .or. ceqp.eq.0.) then
            delc  = ceqc*(1. - exp(-dscav*deltat)) +
     &              ceqpp*(1. - exp(-gscav*deltat))
            delc0 = ceqc*(1. - exp(-dscav*min(dtfall,deltat))) +
     &              ceqpp*(1. - exp(-gscav*min(dtfall,deltat)))
            if (ceqp.eq.0.) then
              delc  = min(delc,conc(k,l)-cmin)
              delc0 = min(delc0,conc(k,l)-cmin)
            else
              delc  = min(delc,ceqp-c0(l),conc(k,l)-cmin)
              delc0 = min(delc0,ceqp-c0(l),conc(k,l)-cmin)
            endif
          else
            delc  = (ceqp - c0(l))*(1. - exp(-gscav*deltat))
            delc0 = (ceqp - c0(l))*(1. - exp(-gscav*min(dtfall,deltat)))
          endif
          delm = delc*cellvol
          if (delm.lt.0.) then
            delm = max(delm,-tmass(l))
            delc = delm/cellvol
          endif
c
c-----Update the cell concentration and rain mass
c
          conc(k,l) = conc(k,l) - delc
          tmass(l) = max(tmass(l)+delm,0.)
          c0(l) = max(c0(l)+delc0,0.)
 40     continue
        pliq = pliq + cwat*(1. - exp(-dscav*min(dtfall,deltat)))
c
c-----Calculate scavenging for particulate species
c     Adjust geometric mean particle diameters <2.5um by 10x to account for
c     mass scavenging over the whole size distribiution (assuming geometric
c     standard deviation of 2.0)
c
        if (nrtaero .gt. 0) then
          do 50 l = nrtgas+1,nrtrac
            delc = 0.
            delm = 0.
            cmin = rtlbnd(l)
            conc(k,l) = amax1(cmin,conc(k,l))
            psize = 1.e-6*sqrt(rtlcut(l)*rtucut(l))
            if (psize.lt.2.5e-6) psize = psize*10.
c
            call scavrat(.true.,lcloud,lgraupl,tamin,rr,tempk(k),
     &               rhoair,0.,psize,rtdens(l),dscav,gscav,ascav,drpvel)
c
            delc = conc(k,l)*(1. - exp(-ascav*deltat))
            delc = amin1(delc,conc(k,l)-cmin)
c
            conc(k,l) = conc(k,l) - delc
            delm = delc*cellvol
            tmass(l) = tmass(l) + delm
 50       continue
        endif
 30   continue
c
c-----Increment surface mass array
c
      do l = 1,nrtrac
        depmas = 1.e-2*tmass(l)/area
        if( lsrfmodrt ) then
          do n = 1,NLUW89
            iwater = 7
            if (n.ne.iwater) then
              solmass(ixcl,jycl,l) = solmass(ixcl,jycl,l) +
     &                             fsoil(n)*fsurf(ixcl,jycl,n)*depmas
              vegmass(ixcl,jycl,l) = vegmass(ixcl,jycl,l) +
     &                      (1. - fsoil(n))*fsurf(ixcl,jycl,n)*depmas
            endif
          enddo
        else
          vegmass(ixcl,jycl,l) = vegmass(ixcl,jycl,l) + depmas
        endif
      enddo
c
      return
      end

      subroutine readar(igrd,idxfile,ncol,nrow,nlay_ems,iounit,iout_unit,
     &                                     aremis,nspcar,nspcem,nspcs)
      use chmstry
      use camxcom
      use filunit
c
c----CAMx v7.40 260801
c
c     READAR reads the time-variant records of the area source file for
c     the given grid and cycles through to current time/date to load 
c     area emission rates
c
c      Copyright Ramboll
c          
c     Modifications:
c        10/20/00  Added check for negative emission rates
c        05/01/03  Time span of emissions must now match emiss update interval
c        12/07/14  Revised for VBS emissions
c        01/08/16  Updated for Revised VBS emissions
c        11/21/25   Changed the way lemmap works - it now points the other direction
c
c     Input arguments:
c        igrd                grid index
c        idxfile             emissions file number
c        ncol                number of columns
c        nrow                number of rows
c        iounit              file unit for area emissions file
c        iout_unit           file unit number for output file
c        nspcar              number of input gridded emission species
c        nspcem              number of total emissons species
c        nspcs               number of model species
c
c     Output arguments:
c        aremis              area emissions rate (mole/s)
c
c     Routines Called:
c        none
c
c     Called by:
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
      include 'vbs.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      character*4 arspec(10)
      character*10 arspcname
      real aremis(ncol,nrow,nlay_ems,nspcem)
      real poa_em(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB,ncol,nrow)
      integer buffer_offset
      logical lcheck
c
      real argrid(MXCELLS,MXCELLS)
c
c-----Entry point
c
      buffer_offset = buffer_offset_iarem(igrd,idxfile)
c
      if (iounit.eq.0) goto 999
      kount = 1
 100  read(iounit,end=900) idat1,tim1,idat2,tim2 
      if (NINT(1000*tim2) .EQ. 0) then
        tim2 = 24.
        idat2 = idat1
      endif
      ichktm1 = NINT( 1000*(tim1) )
      if( le1day ) then
         ichktm2 = NINT( 1000*(tim2) )
      else
         ichktm2 = NINT( 1000*(tim2)+24000*(idat2-idat1) )
      endif
      if( ichktm2 .EQ. 0 ) ichktm2 = 24000
      ichkems = NINT( 1000*(dtems/60.) )
      if( (ichktm2 - ichktm1) .NE. ichkems ) then
          write(iout_unit,'(//,a)')'ERROR in READAR:'
          write(iout_unit,*) 'Time interval in surface emissions file does'
          write(iout_unit,*)  ' not match emissions update time interval.'
          write(iout_unit,*) '   Beginning Date/Time (Hour): ',idat1,tim1
          write(iout_unit,*) '   Ending Date/Time    (Hour): ',idat2,tim2
          write(iout_unit,*) '   Emiss Input interval(Hour): ',dtems/60.
          call camxerr()
      endif
      tim1 = 100.*aint(tim1) + 60.*amod(tim1,1.)
      tim2 = 100.*aint(tim2) + 60.*amod(tim2,1.)
      if (lvbs .and. LVBSPREPROC) then ! initialize temporary VBS POA emiss array
        poa_em = 0.0
      endif
      do 50 ll = 1,nspcar
        argrid = 0.
        read(iounit) idum,(arspec(i),i=1,10), ((argrid(i,j),
     &                    i=1+buffer_offset,ncol-buffer_offset),
     &                        j=1+buffer_offset,nrow-buffer_offset)
        write(arspcname,'(10A1)') arspec
C
c-----Check times only if LE1DAY = T, otherwise check both time and date
c
         lcheck = .FALSE.
         if (le1day) then
           if (abs(tim1-time).lt.0.01 .and. tim2.gt.time) lcheck = .TRUE.
         else
           if ((idat1.lt.date .or.
     &         (idat1.eq.date .and. abs(tim1-time).lt.0.01)) .and.
     &         (idat2.gt.date .or.
     &         (idat2.eq.date .and. tim2.gt.time)))
     &       lcheck = .TRUE.
         endif
         if( .NOT. lcheck ) goto 50
c
c-----Put the data into the global array ----
c
        if( lvbs .AND. LVBSPREPROC ) then
           do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
              if( arspcname .EQ. soap_emiss_names(isoa) ) then 
                 do i=1,ncol
                   poa_em(isoa,i,1) = argrid(i,2)
                   poa_em(isoa,i,nrow) = argrid(i,nrow-1)
                 enddo
                 do j=1,nrow
                   poa_em(isoa,1,j) = argrid(2,j)
                   poa_em(isoa,ncol,j) = argrid(ncol-1,j)
                 enddo
                 do j=1+buffer_offset,nrow-buffer_offset
                    do i=1+buffer_offset,ncol-buffer_offset
                      poa_em(isoa,i,j) = poa_em(isoa,i,j) + argrid(i,j)/(60.*dtems)
                    enddo
                 enddo
              endif
           enddo
        endif
c
        do ispc=1,nemspc
           if( arspcname(1:4) .EQ. 'POA ' .AND. luse_soap3 ) arspcname = 'POA_AV    '
           if( arspcname .EQ. emspcname(ispc) ) then   
             do i=1,ncol
               aremis(i,1,1,ispc) = argrid(i,2)
               aremis(i,nrow,1,ispc) = argrid(i,nrow-1)
             enddo
             do j=1,nrow
               aremis(1,j,1,ispc) = argrid(2,j)
               aremis(ncol,j,1,ispc) = argrid(ncol-1,j)
             enddo
             do j=1+buffer_offset,nrow-buffer_offset
                 do i=1+buffer_offset,ncol-buffer_offset
                   aremis(i,j,1,ispc) = aremis(i,j,1,ispc) + 
     &                                            argrid(i,j)/(60.*dtems) 
                enddo
             enddo
           endif
        enddo
c
 50   continue
c
c  --- calculate linear combination for VBS species and load it ---
c
      if(lvbs .AND. LVBSPREPROC ) then
         do ibin= 0,NVOLBIN
           do ispc=1,nemspc
              if( emspcname(ispc) .EQ. spname(kpap_c(ibin)) ) then
                 lemmap(ispc) = kpap_c(ibin)
                 aremis(:,:,1,ispc) = aremis(:,:,1,ispc) +
     &                            poa_em(IDX_SOAP_POA_OP,:,:) * poa_op_ef(ibin)
     &                          + poa_em(IDX_SOAP_POA_GV,:,:) * poa_gv_ef(ibin)
     &                          + poa_em(IDX_SOAP_POA_DV,:,:) * poa_dv_ef(ibin)
              endif
              if( emspcname(ispc) .EQ. spname(kpcp_c(ibin)) ) then
                 lemmap(ispc) = kpcp_c(ibin)
                 aremis(:,:,1,ispc) = aremis(:,:,1,ispc) +
     &                           poa_em(IDX_SOAP_POA_MC,:,:) * poa_mc_ef(ibin)
              endif
              if( emspcname(ispc) .EQ. spname(kpfp_c(ibin)) ) then
                 lemmap(ispc) = kpfp_c(ibin)
                 aremis(:,:,1,ispc) = aremis(:,:,1,ispc) +
     &                           poa_em(IDX_SOAP_POA_BB,:,:) * poa_bb_ef(ibin)
              endif
           enddo
         enddo
      endif
      write(iout_unit,'(a40,2(f7.0,i8.5),a,i3)')
     &      'Read area source file at ',tim1,idat1,tim2,idat2,
     &      ' grid',igrd
       call flush(iout_unit)
c
c-----Check times only if LE1DAY = T, otherwise check both time and date
c
      if (le1day) then
        if (abs(tim1-time).lt.0.01 .and. tim2.gt.time) goto 200
        if (tim1-time.ge.0.01) goto 900
      else
        if ((idat1.lt.date .or.
     &      (idat1.eq.date .and. abs(tim1-time).lt.0.01)) .and.
     &      (idat2.gt.date .or.
     &      (idat2.eq.date .and. tim2.gt.time)))
     &    goto 200
      endif
      goto 100
c 
c-----Convert emission rates from moles/(dtems-hours) to moles/s for gas
c     or g/(dtems-hours) to g/s for aero species
c 
 200  continue
      do 10 l = 1,nemspc
        do j = 1,nrow
          do i = 1,ncol
            do k=1,nlay_ems
              if (aremis(i,j,k,l).lt.0.) then
                write(iout_unit,'(//,a)') 'ERROR in READAR:'
                write(iout_unit,'(a,i3)') 'Negative emissions for grid:',igrd
                write(iout_unit,'(a,4i3)') '(i,j,k,l): ',i,j,k,l
                call camxerr()
              endif
            enddo
          enddo 
        enddo
 10   continue 
      goto 999
c
c-----End of file reached; if 1-day emissions requested, rewind and read 
c     through header once more.  Otherwise, report error and exit
c
 900  continue
      if (le1day) then
        if (kount.ge.2) then
          write(iout_unit,'(//,a)') 'ERROR in READAR:'
          write(iout_unit,*)'Cannot match model time with area source time'
          call camxerr()
        endif 
        rewind(iounit)
        read(iounit) idum 
        read(iounit) dum  
        read(iounit) idum  
        read(iounit) idum 
        kount = kount + 1
        goto 100
      else
        write(iout_unit,'(//,a)') 'ERROR in READAR:'
        write(iout_unit,*)'End of area source file reached'
        call camxerr()
      endif
c
 999  continue
c
      return
      end

      subroutine rassgn2d(ncol,nrow,io,jo,nmesh,ncolf,nrowf,cval,fval)
c
c----CAMx v7.40 260801
c
c     RASSGN2D assigns real fine grid values from coarse grid
c
c      Copyright Ramboll
c          
c     Modifications:
c        none
c
c     Input arguments:
c        ncol              number of columns in the parent grid
c        nrow              number of rows in the parent grid
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        cval              cell centered value on coarse grid
c
c     Output arguments:
c        fval              cell centered value on coarse grid
c
c     Subroutine called:
c        none
c
c     Called by:
c        CAMx
c        STARTUP
c
      real cval(ncol,nrow)
      real fval(ncolf,nrowf)
c
c-----Entry point
c
        do 40 jfin = 2,nrowf-1
          j = (jfin - 2)/nmesh + jo
          do 30 ifin = 2,ncolf-1
            i = (ifin - 2)/nmesh + io
            fval(ifin,jfin) = cval(i,j)
  30      continue
  40    continue
c
      return
      end

      subroutine wrtdep(tim2,idat2,igrd,iunit,nox,noy,nsptmp,nspdry,
     &                  vdep,depfld)
      use grid
      use chmstry
      use camxcom
c
c----CAMx v7.40 260801
c 
c     WRTDEP writes deposition fields.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        05/17/16       Added in-line Ix emissions to dep output
c 
c     Input arguments:
c        tim2                output time (HHMM)
c        idat2               output date (YYJJJ)
c        igrd                grid number
c        iunit               output unit
c        nox                 number of cells in x-direction
c        noy                 number of cells in y-direction
c        nsptmp              number of dep field species
c        nspdry              number of dry dep species
c        vdep                dry deposition velocities
c        depfld              deposition field to output
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c 
      include 'camx.prm'
      include 'flags.inc'
c
      real depfld(nox,noy,nsptmp),vdep(nox,noy,nspdry)
c
      character*4 ispec(10,4*MXSPEC+2)
c
      data nseg /1/
c
c-----Entry point
c
      ibegcel = 1
      iendcel = nox
      jbegcel = 1
      jendcel = noy
      if( igrd .GT. 1 ) then
        ibegcel = 2
        iendcel = nox-1
        jbegcel = 2
        jendcel = noy-1
      endif
c
c-----Determine time/date range
c
      idat1 = idat2
      etim = AINT(ANINT(tim2)/100.) + amod(ANINT(tim2),100.)/60.
      btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      if (btim.lt.0.) then
        btim = btim + 24.
        idat1 = idat1 - 1
        if (MOD(idat1,1000) .EQ. 0 ) then
          if ( MOD(INT(idat1/1000)-1,4) .EQ. 0 ) then
            idat1 = (INT(idat1/1000)-1)*1000 + 366
          else
            idat1 = (INT(idat1/1000)-1)*1000 + 365
          end if
        endif
      endif 
c
c-----Write gridded deposition field
c
      do l = 1,4*ndepspc
        read(depsp(l),'(10a1)') (ispec(n,l),n=1,10)
      enddo
      write(iunit) idat1,btim,idat2,etim
      do l = 1,ndepspc
        ll = ldepmap(l)
        write(iunit) nseg,(ispec(n,l),n=1,10),
     &               ((vdep(i,j,ll),i=ibegcel,iendcel),j=jbegcel,jendcel)
      enddo
      do l = 1,3*ndepspc
        ll = l + ndepspc
        write(iunit) nseg,(ispec(n,ll),n=1,10),
     &               ((depfld(i,j,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
      enddo
      if (lixemis) then
        l = 4*ndepspc + 1
        ll = 3*ndepspc + 1
        read(depsp(l),'(10a1)') (ispec(n,l),n=1,10)
        write(iunit) nseg,(ispec(n,l),n=1,10),
     &               ((depfld(i,j,ll),i=ibegcel,iendcel),j=jbegcel,jendcel)
        l = 4*ndepspc + 2
        ll = 3*ndepspc + 2
        read(depsp(l),'(10a1)') (ispec(n,l),n=1,10)
        write(iunit) nseg,(ispec(n,l),n=1,10),
     &               ((depfld(i,j,ll),i=ibegcel,iendcel),j=jbegcel,jendcel)
      endif
c
      return
      end

      subroutine pagrids()
      use filunit
      use grid
      use chmstry
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     Calculates the affected grid cells for each Process Analysis sub-domain
c     This is also called when probing tools is CSA
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Subroutines Called:
c
c     Called by:
c        STARTUP
c
      include "camx.prm"
      include "flags.inc"
c
c-----Entry point
c
c-----calculate the total number of PA cells
c
      npa_cels = 0
      do i = 1, npadom
         npa_cels = npa_cels + (j_ne(i)-j_sw(i)+1) *
     &               (i_ne(i)-i_sw(i)+1) * (t_lay(i)-b_lay(i)+1)
      enddo
c
c-----allocate the arrays dimensioned by number of cells ---
c
      call alloc_procan_cells(lcsa,npa_cels,nspec,nreact)
c
c-----write header for table of cells to the diag file ---
c
      if( lcsa ) then
         write(idiag,'(//,15X,A,/)')
     &        '*** Model Cells Treated by CSA ***'
      else
         write(idiag,'(//,15X,A,/)')
     &        '*** Model Cells Treated by Process Analysis ***'
      endif
c
      npa_cels = 0
      do ig = 1, npadom
         igrd = ipagrd(ig)
         write(idiag,'(5(5X,A))') 'Sub-Domain','Grid #','I-Cell',
     &                                           '  J-Cell','   Layer'
         write(idiag,'(3X,100A)') ('-',i=1,60)
         do j = j_sw(ig), j_ne(ig)
            do i = i_sw(ig), i_ne(ig)
               do k = b_lay(ig), t_lay(ig)
                  npa_cels  = npa_cels + 1
                  ipax   ( npa_cels ) = i
                  ipay   ( npa_cels ) = j
                  ipaz   ( npa_cels ) = k
                  ipanst ( npa_cels ) = ipagrd(ig)
                  ipadom ( npa_cels ) = ig
c
c  --- calculate the offset for this grid ---
c
                  n2d = i + (j-1)*ncol(igrd)
                  ipacl_2d ( iptr2d(igrd)-1+n2d ) = npa_cels
                  n3d = i + ncol(igrd)*(j - 1) + 
     &                                ncol(igrd)*nrow(igrd)*(k - 1)
                  ipacl_3d ( iptr3d(igrd)-1+n3d ) = npa_cels
c
c  --- check to see if the cell is contained in any nest ---
c
                  if( idfin( iptr2d(igrd)-1+n2d ) .GT. 0 ) goto 7001
c
c  --- write this cell to the table in diag file ---
c
                 write(idiag,'(5X,I5,5(8X,I5))') ig, ipagrd(ig), i, j, k
               enddo
            enddo
         enddo
         write(idiag,'(3X,100A)') ('-',i=1,60)
      enddo
      write(idiag,*)
      goto 9999
c
c-----error messages----
c
 7001 continue
      if( lcsa ) then
         write(iout,'(//,A)') 'ERROR in PAGRIDS:'
         write(iout,'(1X,2A)') 'Process Analysis domains cannot ',
     &                     'contain cells that are included in a nest.'
         write(iout,'(1X,A,I3)') 'Please redefine PA domain #',ig
         call camxerr()
      else
         write(iout,'(//,A)') 'ERROR in PAGRIDS:'
         write(iout,'(1X,2A)') 'CSA Analysis domain cannot ',
     &                     'contain cells that are included in a nest.'
         write(iout,'(1X,A,I3)') 'Please redefine CSA domain.'
         call camxerr()
      endif
c
 9999 continue
      return
      end

      SUBROUTINE tuv(nz, z, airlev, alb, coszen, 
     $     odcld, omcld, gcld, 
     $     odaer1, odaer2, omaer1, omaer2, gaer,
     $     rafcld)

      IMPLICIT NONE

**** Inputs:

* altitude grid

      INTEGER nz
      REAL z(nz)

* solar zenith angle 

      REAL coszen

* air profile

      REAL airlev(nz)

* cloud and aerosol 

      REAL odcld(nz), omcld(nz), gcld(nz)
      REAL odaer1(nz), omaer1(nz), gaer(nz)
      REAL odaer2(nz), omaer2(nz)

* surface albedo

      REAL alb

**** Output: Actinic flux cloudy/clear ratio as a funct of altitude

      REAL rafcld(nz)

**** Internal:

* internally computed optical depths (to avoid overwriting odcld, odaer)

      REAL dtrl(nz), dtcld(nz), dtaer(nz)

* Rayleigh scattering cross section from WMO 1985 (originally from
* Nicolet, M., On the molecular scattering in the terrestrial atmosphere:
* An empirical formula for its calculation in the homoshpere, Planet.
* Space Sci., 32, 1467-1468, 1984.
* computed at the selected wavelenth wc(nm) using the equations:
c         wmicrn =  wc/1.E3
c         IF( wmicrn .LE. 0.55) THEN
c            xx = 3.6772 + 0.389*wmicrn + 0.09426/wmicrn
c         ELSE
c            xx = 4. + 0.04
c         ENDIF
c         srayl(iw) = 4.02e-28/(wmicrn)**xx

      REAL srayl
      DATA srayl /2.922E-26/

* scale heights for air density

      REAL hscale
      DATA hscale /8.05e5/

* actinic flux (relative units) 

      REAL fdir(nz), fdn(nz), fup(nz)
      REAL actflx(2,nz)

* loop indices

      INTEGER i
* ___

* compute Rayleigh optical depths:
* include exponential tail integral at top (iz = nz)

      DO i = 1, nz-1
         dtrl(i) = (airlev(i+1)+airlev(i)) * 0.5 *
     $        (z(i+1)-z(i)) * 1.E5 * srayl
      ENDDO
      dtrl(nz) = hscale * airlev(nz) * 1.E5

**** clear sky calculation
** monochromatic radiative transfer:
* call rtlink for plane-parallel 2-stream
      
      DO i = 1, nz-1
         dtcld(i) = 0.
         dtaer(i) = odaer1(i)
      ENDDO
      CALL rtlpp2(nz, alb, coszen,
     $     dtrl,
     $     dtcld, omcld, gcld,
     $     dtaer,omaer1,gaer,
     $     fdir, fdn, fup)
      DO i = 1, nz
         actflx(1,i) = fdir(i) + fdn(i) + fup(i)
      ENDDO

**** cloudy sky calculation:

      DO i = 1, nz-1
         dtcld(i) = odcld(i)
         dtaer(i) = odaer2(i)
      ENDDO
      CALL rtlpp2(nz, alb, coszen,
     $     dtrl,
     $     dtcld, omcld, gcld,
     $     dtaer,omaer2,gaer,
     $     fdir, fdn, fup)
      DO i = 1, nz
         actflx(2,i) = fdir(i) + fdn(i) + fup(i)
      ENDDO

      DO i = 1, nz
         rafcld(i) = actflx(2,i)/actflx(1,i)
      ENDDO

      RETURN
      END

*==============================================================================

      SUBROUTINE rtlpp2(nz, ag, m0, 
     $     dtrl, 
     $     dtcld, omcld, gcld,
     $     dtaer,omaer,gaer,
     $     fdir, fdn, fup)
*_______________________________________________________________________

      IMPLICIT NONE

* input:

      INTEGER nz
      REAL ag
      REAL m0
      REAL dtrl(nz)
      REAL dtcld(nz), omcld(nz), gcld(nz)
      REAL dtaer(nz), omaer(nz), gaer(nz)

* output

      REAL fdir(nz), fdn(nz), fup(nz)

* local:
      REAL dt(nz), om(nz), g(nz)
      REAL fdiri(nz), fdni(nz), fupi(nz)
      REAL daaer, dtsct, dtabs, dsaer, dscld, dacld
      INTEGER i, ii

      LOGICAL delta
      DATA delta /.true./

* largest number of the machine:
      REAL largest
      PARAMETER(largest=1.E+36)

*_______________________________________________________________________

* initialize:

      DO 5 i = 1, nz
         fdir(i) = 0.
         fup(i) = 0.
         fdn(i) = 0.
 5    CONTINUE

* ----

*  set here any coefficients specific to rt scheme, 
* ----

      DO 10, i = 1, nz - 1

         dscld = dtcld(i)*omcld(i)
         dacld = dtcld(i)*(1.-omcld(i))

         dsaer = dtaer(i)*omaer(i)
         daaer = dtaer(i)*(1.-omaer(i))

         dtsct = dtrl(i) + dscld + dsaer
         dtabs = dacld + daaer

 	 dtabs = AMAX1(dtabs,1./largest)
 	 dtsct = AMAX1(dtsct,1./largest)

* invert z-coordinate:

         ii = nz - i
         dt(ii) = dtsct + dtabs
         om(ii) = dtsct/(dtsct + dtabs)
           IF(dtsct .EQ. 1./largest) om(ii) = 1./largest
         g(ii) = (gcld(i)*dscld + gaer(i)*dsaer)/dtsct

   10 CONTINUE

*  call rt routine:

      CALL pp2str(nz,m0,ag,dt,om,g,
     $        fdiri, fupi, fdni)

* put on upright z-coordinate

      DO 20, i = 1, nz
         ii = nz - i + 1
         fdir(i) = fdiri(ii)
         fup(i) = fupi(ii)
         fdn(i) = fdni(ii)
 20   CONTINUE
*_______________________________________________________________________

      RETURN
      END   

*==============================================================================

      SUBROUTINE pp2str(nz,mu,rsfc,tauu,omu,gu,
     $     fdr, fup, fdn)
*_______________________________________________________________________
* TWO-STREAM EQUATIONS FOR MULTIPLE LAYERS
* based on equations from Toon et al.,  Journal of Geophysical Research
* Volume 94, #D13  Nov. 20, 1989 Issue 
* programmed by:  Kathleen G. Mosher
* for Sasha Madronich, N.C.A.R. A.C.D.
*_______________________________________________________________________
* Now it contains 9 two-stream methods to choose from.
* programmed  on 05.26.94 by:  Irina V.Petropavlovskikh
* for Sasha Madronich, N.C.A.R. A.C.D.
*_______________________________________________________________________

      IMPLICIT NONE

*******
* input:
*******
      INTEGER nz
      REAL mu, rsfc
      REAL tauu(nz), omu(nz), gu(nz)

*******
* output:
*******
      REAL fup(nz),fdn(nz),fdr(nz)
      REAL eup(nz),edn(nz),edr(nz)

*******
* local:
*******

* internal coefficients and matrix
      REAL lam(nz),taun(nz),bgam(nz)
      REAL e1(nz),e2(nz),e3(nz),e4(nz)
      REAL cup(nz),cdn(nz),cuptn(nz),cdntn(nz)
      REAL tauc, mu1(nz)
      INTEGER row
      REAL a(2*nz),b(2*nz),d(2*nz),e(2*nz),y(2*nz)

*******
* other:
*******
      REAL pifs, fdn0
      REAL f, g, tau, om, tempg
      REAL gam1, gam2, gam3, gam4

* For calculations of Associated Legendre Polynomials for GAMA1,2,3,4
* in delta-function, modified quadrature, hemispheric constant,
* Hybrid modified Eddington-delta function metods, p633,Table1.
* W.E.Meador and W.R.Weaver, GAS,1980,v37,p.630
* W.J.Wiscombe and G.W. Grams, GAS,1976,v33,p2440, 
* uncomment the following two lines and the appropriate statements further
* down.
C     REAL YLM0, YLM2, YLM4, YLM6, YLM8, YLM10, YLM12, YLMS, BETA0,
C    >     BETA1, BETAn, amu1, subd

      REAL expon, expon0, expon1, divisr, temp, up, dn
      REAL ssfc
      REAL taug
      INTEGER nlayer, mrows, lev

      INTEGER i, j

* Some additional program constants:
      REAL eps, precis
      PARAMETER (eps = 1.E-3, precis = 1.E-7) 

*_______________________________________________________________________

* MU = cosine of solar zenith angle
* RSFC = surface albedo
* TAUU =  unscaled optical depth of each layer
* OMU  =  unscaled single scattering albedo
* GU   =  unscaled asymmetry factor
* KLEV = max dimension of number of layers in atmosphere
* NLAYER = number of layers in the atmosphere
* NLEVEL = nlayer + 1 = number of levels

* initial conditions:  pi*solar flux = 1;  diffuse incidence = 0

      pifs = 1.      
      fdn0 = 0.

      nlayer = nz - 1

************** compute coefficients for each layer:
* GAM1 - GAM4 = 2-stream coefficients, different for different approximations
* EXPON0 = calculation of e when TAU is zero
* EXPON1 = calculation of e when TAU is TAUN
* CUP and CDN = calculation when TAU is zero
* CUPTN and CDNTN = calc. when TAU is TAUN
* DIVISR = prevents division by zero

      tauc = 0.
      DO 10, i = 1, nlayer

         g = gu(i)
         tau = tauu(i)
         om = omu(i)

* stay away from 1 by precision.  For g, also stay away from -1

         tempg = AMIN1(abs(g),1. - precis)
         g = SIGN(tempg,g)
         om = AMIN1(om,1-precis)

* delta-scaling. Have to be done for delta-Eddington approximation, 
* delta discrete ordinate, Practical Improved Flux Method, delta function,
* and Hybrid modified Eddington-delta function methods approximations

         f = g*g
         g = (g - f)/(1 - f)
         taun(i) = (1 - om*f)*tau
         om = (1 - f)*om/(1 - om*f)       

*** the following gamma equations are from pg 16,289, Table 1

* Eddington approximation(Joseph et al., 1976, JAS, 33, 2452):

         gam1 = (7. - om*(4. + 3.*g))/4.
         gam2 = -(1. - om*(4. - 3.*g))/4.
         gam3 = (2. - 3.*g*mu)/4.
         gam4 = 1. - gam3
         mu1(i) = 0.5

* quadrature (Liou, 1973, JAS, 30, 1303-1326; 1974, JAS, 31, 1473-1475):

c         gam1 = 1.7320508*(2. - om*(1. + g))/.2
c         gam2 = 1.7320508*om*(1. - g)/2.
c         gam3 = (1. - 1.7320508*g*mu)/2
c         gam4 = 1. - gam3
         
* hemispheric mean (Toon et al., 1089, JGR, 94, 16287):

c          gam1 = 2. - om*(1. + g)
c          gam2 = om*(1. - g)
c          gam3 = (2. - g*mu)/4.
c          gam4 = 1. - gam3

* PIFM  (Zdunkovski et al.,1980, Conrib.Atmos.Phys., 53, 147-166):
c         GAM1 = 0.25*(8. - OM*(5. + 3.*G))
c         GAM2 = 0.75*OM*(1.-G)
c         GAM3 = 0.25*(2.-3.*G*MU)
c         GAM4 = 1. - GAM3

* delta discrete ordinates  (Schaller, 1979, Contrib.Atmos.Phys, 52, 17-26):
c         GAM1 = 0.5*1.7320508*(2. - OM*(1. + G))
c         GAM2 = 0.5*1.7320508*OM*(1.-G)
c         GAM3 = 0.5*(1.-1.7320508*G*MU)
c         GAM4 = 1. - GAM3

* Calculations of Associated Legendre Polynomials for GAMA1,2,3,4
* in delta-function, modified quadrature, hemispheric constant,
* Hybrid modified Eddington-delta function metods, p633,Table1.
* W.E.Meador and W.R.Weaver, GAS,1980,v37,p.630
* W.J.Wiscombe and G.W. Grams, GAS,1976,v33,p2440
c      YLM0 = 2.
c      YLM2 = -3.*G*MU
c      YLM4 = 0.875*G**3*MU*(5.*MU**2-3.)
c      YLM6=-0.171875*G**5*MU*(15.-70.*MU**2+63.*MU**4)
c     YLM8=+0.073242*G**7*MU*(-35.+315.*MU**2-693.*MU**4
c    *+429.*MU**6)
c     YLM10=-0.008118*G**9*MU*(315.-4620.*MU**2+18018.*MU**4
c    *-25740.*MU**6+12155.*MU**8)
c     YLM12=0.003685*G**11*MU*(-693.+15015.*MU**2-90090.*MU**4
c    *+218790.*MU**6-230945.*MU**8+88179.*MU**10)
c      YLMS=YLM0+YLM2+YLM4+YLM6+YLM8+YLM10+YLM12
c      YLMS=0.25*YLMS
c      BETA0 = YLMS
c
c         amu1=1./1.7320508
c      YLM0 = 2.
c      YLM2 = -3.*G*amu1
c      YLM4 = 0.875*G**3*amu1*(5.*amu1**2-3.)
c      YLM6=-0.171875*G**5*amu1*(15.-70.*amu1**2+63.*amu1**4)
c     YLM8=+0.073242*G**7*amu1*(-35.+315.*amu1**2-693.*amu1**4
c    *+429.*amu1**6)
c     YLM10=-0.008118*G**9*amu1*(315.-4620.*amu1**2+18018.*amu1**4
c    *-25740.*amu1**6+12155.*amu1**8)
c     YLM12=0.003685*G**11*amu1*(-693.+15015.*amu1**2-90090.*amu1**4
c    *+218790.*amu1**6-230945.*amu1**8+88179.*amu1**10)
c      YLMS=YLM0+YLM2+YLM4+YLM6+YLM8+YLM10+YLM12
c      YLMS=0.25*YLMS
c      BETA1 = YLMS
c
c         BETAn = 0.25*(2. - 1.5*G-0.21875*G**3-0.085938*G**5
c    *-0.045776*G**7)


* Hybrid modified Eddington-delta function(Meador and Weaver,1980,JAS,37,630):
c         subd=4.*(1.-G*G*(1.-MU))
c         GAM1 = (7.-3.*G*G-OM*(4.+3.*G)+OM*G*G*(4.*BETA0+3.*G))/subd
c         GAM2 =-(1.-G*G-OM*(4.-3.*G)-OM*G*G*(4.*BETA0+3.*G-4.))/subd
c         GAM3 = BETA0
c         GAM4 = 1. - GAM3
*****
* delta function  (Meador, and Weaver, 1980, JAS, 37, 630):
c         GAM1 = (1. - OM*(1. - beta0))/MU
c         GAM2 = OM*BETA0/MU
c         GAM3 = BETA0
c         GAM4 = 1. - GAM3
*****
* modified quadrature (Meador, and Weaver, 1980, JAS, 37, 630):
c         GAM1 = 1.7320508*(1. - OM*(1. - beta1))
c         GAM2 = 1.7320508*OM*beta1
c         GAM3 = BETA0
c         GAM4 = 1. - GAM3

* hemispheric constant (Toon et al., 1989, JGR, 94, 16287):
c         GAM1 = 2.*(1. - OM*(1. - betan))
c         GAM2 = 2.*OM*BETAn
c         GAM3 = BETA0
c         GAM4 = 1. - GAM3

*****

*  save mu1 for use in converting irradiance to actinic flux

c         mu1(i) = (1-om)/(gam1 - gam2)

* lambda = pg 16,290 equation 21
* big gamma = pg 16,290 equation 22
 
         lam(i) = sqrt(gam1*gam1 - gam2*gam2)

         IF( gam2 .NE. 0.) THEN
            bgam(i) = (gam1 - lam(i))/gam2
         ELSE
            bgam(i) = 0.
         ENDIF

         expon = EXP(-lam(i)*taun(i))

* e1 - e4 = pg 16,292 equation 44
         
         e1(i) = 1. + bgam(i)*expon
         e2(i) = 1. - bgam(i)*expon
         e3(i) = bgam(i) + expon
         e4(i) = bgam(i) - expon

* the following sets up for the C equations 23, and 24
* found on page 16,290
* prevent division by zero (if LAMBDA=1/MU, shift 1/MU^2 by EPS = 1.E-3
* which is approx equiv to shifting MU by 0.5*EPS* (MU)**3

         expon0 = EXP(-(tauc          )/mu)
         expon1 = EXP(-(tauc + taun(i))/mu)

         divisr = lam(i)*lam(i) - 1./(mu*mu)
         temp = AMAX1(eps,abs(divisr))
         divisr = SIGN(temp,divisr)

         up = om*pifs*((gam1 - 1./mu)*gam3 + gam4*gam2)/divisr
         dn = om*pifs*((gam1 + 1./mu)*gam4 + gam2*gam3)/divisr
         
* cup and cdn are when tau is equal to zero
* cuptn and cdntn are when tau is equal to taun

         cup(i) = up*expon0
         cdn(i) = dn*expon0
         cuptn(i) = up*expon1
         cdntn(i) = dn*expon1

         tauc = tauc + taun(i)

   10 CONTINUE

***************** set up matrix ******
* ssfc = pg 16,292 equation 37  where pi Fs is one (unity).

      ssfc = rsfc*mu*EXP(-tauc/mu)*pifs

* MROWS = the number of rows in the matrix

      mrows = 2*nlayer     
      
* the following are from pg 16,292  equations 39 - 43.
* set up first row of matrix:

      i = 1
      a(1) = 0.
      b(1) = e1(i)
      d(1) = -e2(i)
      e(1) = fdn0 - cdn(i)

      row=1

* set up odd rows 3 thru (MROWS - 1):

      i = 0
      DO 20, row = 3, mrows - 1, 2
         i = i + 1
         a(row) = e2(i)*e3(i) - e4(i)*e1(i)
         b(row) = e1(i)*e1(i + 1) - e3(i)*e3(i + 1)
         d(row) = e3(i)*e4(i + 1) - e1(i)*e2(i + 1)
         e(row) = e3(i)*(cup(i + 1) - cuptn(i)) + 
     $        e1(i)*(cdntn(i) - cdn(i + 1))
   20 CONTINUE

* set up even rows 2 thru (MROWS - 2): 

      i = 0
      DO 30, row = 2, mrows - 2, 2
         i = i + 1
         a(row) = e2(i + 1)*e1(i) - e3(i)*e4(i + 1)
         b(row) = e2(i)*e2(i + 1) - e4(i)*e4(i + 1)
         d(row) = e1(i + 1)*e4(i + 1) - e2(i + 1)*e3(i + 1)
         e(row) = (cup(i + 1) - cuptn(i))*e2(i + 1) - 
     $        (cdn(i + 1) - cdntn(i))*e4(i + 1)
   30 CONTINUE

* set up last row of matrix at MROWS:

      row = mrows
      i = nlayer
      
      a(row) = e1(i) - rsfc*e3(i)
      b(row) = e2(i) - rsfc*e4(i)
      d(row) = 0.
      e(row) = ssfc - cuptn(i) + rsfc*cdntn(i)

* solve tri-diagonal matrix:

      CALL tridag(a, b, d, e, y, mrows)

**** unfold solution of matrix, compute output fluxes:

      row = 1 
      lev = 1
      j = 1
      taug = 0.
      
* the following equations are from pg 16,291  equations 31 & 32

      fdr(lev) = 1.
      edr(lev) = mu
      edn(lev) = fdn0
      eup(lev) =  y(row)*e3(j) - y(row + 1)*e4(j) + cup(j)
      fdn(lev) = edn(lev)/mu1(lev)
      fup(lev) = eup(lev)/mu1(lev)

      DO 60, lev = 2, nlayer + 1
         taug = taug + taun(j)
         fdr(lev) = EXP(-taug/mu)
         edr(lev) = mu*fdr(lev)
         edn(lev) =  y(row)*e3(j) + y(row + 1)*e4(j) + cdntn(j)
         eup(lev) =  y(row)*e1(j) + y(row + 1)*e2(j) + cuptn(j)
         fdn(lev) = edn(lev)/mu1(j)
         fup(lev) = eup(lev)/mu1(j)

         row = row + 2
         j = j + 1
   60 CONTINUE
*_______________________________________________________________________

      RETURN
      END

*==============================================================================

      SUBROUTINE tridag(a,b,c,r,u,n)
*_______________________________________________________________________
* solves tridiagonal system.  From Numerical Recipies, p. 40
*_______________________________________________________________________

      IMPLICIT NONE

* input:
      INTEGER n
      REAL a, b, c, r
      DIMENSION a(n),b(n),c(n),r(n)

* output:
      REAL u
      DIMENSION u(n)

* local:
      INTEGER j
      REAL bet, gam
      DIMENSION gam(n)
*_______________________________________________________________________

      IF (b(1) .EQ. 0.) STOP 1001
      bet   = b(1)
      u(1) = r(1)/bet
      DO 11, j = 2, n   
         gam(j) = c(j - 1)/bet
         bet = b(j) - a(j)*gam(j)
         IF (bet .EQ. 0.) STOP 2002 
         u(j) = (r(j) - a(j)*u(j - 1))/bet
   11 CONTINUE
      DO 12, j = n - 1, 1, -1  
         u(j) = u(j) - gam(j + 1)*u(j + 1)
   12 CONTINUE
*_______________________________________________________________________

      RETURN
      END

C*** NCF_CNCPREP
c
      subroutine ncf_cncprep(timbeg,datebeg,timend,dateend,lfirst)
      use grid
      use chmstry
      use camxfld
      use filunit
      implicit none
c 
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_CNCPREP reads the initial conditions NETCDF file and checks
c     the global variables for consistency with user defined values.
c     It also prepares mapping variables that map the IC species list
c     to the internal CAMx species list
c 
c      Copyright Ramboll
c           
c     Input arguments: 
c         timbeg  R model begin time
c         begdat  I model begin date (YYJJJ)
c         timend  R model end time
c         dateend I model end date (YYJJJ)
c        lfirst  - .TRUE. if this is the first time this routine is called
c     Output arguments: 
c        none
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'ncf_iodat.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    timbeg
      integer datebeg
      real    timend
      integer dateend
      logical lfirst
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  spec_units(MXSPEC)
      character*20  spec_long_name(MXSPEC)
      character*60  spec_desc(MXSPEC)
      character*60  spec_coords(MXSPEC)
      character*10  icfil, name_in, this_var, avfil
      character*4   note(60), ifile(10)
      character*4   icspec(10,MXSPEC)
      real          orgx, orgy, dx, dy, dxf, dyf, orgxf, orgyf, zero
      integer       ierr, nlayer, num_dims, l, j, iproj, ione, i, n, izero
      integer       this_varid, itmp, ilen, isvoa
c
c-----------------------------------------------------------------------
c    Data Statements:
c-----------------------------------------------------------------------
c
      data icfil /'INITIAL   '/
      data avfil /'AVERAGE   '/
      data ione /1/
      data zero /0./
      data izero /0/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- set the string for error messages ---
c
      action = 'Reading the NetCDF initial conditions file.'
c
c --- get the type of file to make sure it is a boundary file ---
c
      this_var = 'CAMx_NAME'
      ierr = nf_get_att_text(iic, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iic, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7002
      endif
      if( name_in(:7) .NE. icfil(:7) ) goto 7001
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(iic,action,1,.TRUE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iic,action,datebeg,timbeg,datebeg,timbeg,.FALSE.)
c
c --- call routine to setup species mappping array ---
c
      call ncf_set_species_mapping(iic,action,spname,nspec,nicspc,licmap)
c
c --- assign values for the output file ---
c
      read(runmsg,'(60A1)') note
      read(avfil,'(10a1)') (ifile(n),n=1,10)
      do l = 1,navspc
        if(lavmap(l) .GT. 0 ) then
          spavnam(l) = spname(lavmap(l))
          read(spname(lavmap(l)),'(10a1)') (icspec(n,l),n=1,10)
        endif
      enddo
      if( l3davg(1) ) then
        nlayer = nlay(1)
        num_dims = 4
      else
        nlayer = 1
        num_dims = 4
      endif
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
c 
c --- Write average output concentration file headers ---
c
      if( lfirst ) then
          if( lcdfout ) then
            call ncf_set_vars_base()
            call ncf_set_tstep(datebeg,timbeg,dateend,timend)
            action = 'Writing master grid output average file.'
            call ncf_set_specatt_avrg(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
            call ncf_set_global('AVERAGE   ',1,datebeg,timbeg,dateend,timend,
     &                                                       nlayer,navspc)
            call ncf_wrt_dim(action,iavg(1),1,ncol(1),nrow(1),nlayer,navspc)
            call ncf_wrt_global(action,iavg(1),navspc,spavnam,.FALSE.)
            call ncf_wrt_vars_base(action,iavg(1))
            call ncf_wrt_vars_species(action,iavg(1),ncol(1),nrow(1),nlayer,
     &                              navspc,spavnam,spec_units,spec_long_name,
     &                                        spec_desc,spec_coords,num_dims)
            call ncf_enddef_file(action,iavg(1))
            call ncf_wrt_data_grid(action,iavg(1),1,ncol(1),nrow(1),
     &                           orgx,orgy,dx,dy,nlayer,cellat(iptr2d(1)),
     &                                   cellon(iptr2d(1)),topo(iptr2d(1)))
          else
            rewind(iavg(1))
            write(iavg(1)) ifile,note,itzon,navspc,datebeg,timbeg/100.,
     &                                                     dateend,timend/100.
            write(iavg(1)) polelon,polelat,iuzon,orgx,orgy,dx,dy,ncol(1),nrow(1),nlayer,
     &                                       iproj,izero,tlat1,tlat2,zero
            write(iavg(1)) ione,ione,ncol(1),nrow(1)
            write(iavg(1)) ((icspec(n,l),n=1,10),l=1,navspc)
          endif
      endif
      if( ngrid .EQ. 1 ) goto 9999
c
c-----Fine grid average headers
c
      do i = 2,ngrid 
        dxf   = dx/float(meshold(i))
        dyf   = dy/float(meshold(i))
        orgxf = orgx + dx*(inst1(i)-1)
        orgyf = orgy + dy*(jnst1(i)-1)
        if( l3davg(i) ) then
          nlayer = nlay(i)
        else
          nlayer = 1
        endif
        if( l3davg(i) ) then
          nlayer = nlay(i)
        else
          nlayer = 1
        endif
        if( lfirst ) then
          if( lcdfout ) then
             write(action,'(A,I2)') 'Writing output average file for grid: ',i
             call ncf_set_specatt_avrg(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
             call ncf_set_global('AVERAGE   ',i,datebeg,timbeg,dateend,timend,
     &                                                      nlayer,navspc)
             call ncf_wrt_dim(action,iavg(i),i,ncol(i),nrow(i),nlayer,navspc)
             call ncf_wrt_global(action,iavg(i),navspc,spavnam,.FALSE.)
             call ncf_wrt_vars_base(action,iavg(i))
             call ncf_wrt_vars_species(action,iavg(i),ncol(i),nrow(i),nlayer,
     &                            navspc,spavnam,spec_units,spec_long_name,
     &                                       spec_desc,spec_coords,num_dims)
             call ncf_enddef_file(action,iavg(i))
             call ncf_wrt_data_grid(action,iavg(i),i,ncol(i),nrow(i),
     &                           orgx,orgy,dx,dy,nlayer,cellat(iptr2d(i)),
     &                                  cellon(iptr2d(i)),topo(iptr2d(i)))
          else
             rewind(iavg(i))
             write(iavg(i)) ifile,note,itzon,navspc,datebeg,timbeg/100.,
     &                                                    dateend,timend/100.
             write(iavg(i)) polelon,polelat,iuzon,orgxf,orgyf,dxf,dyf,ncol(i)-2,
     &                       nrow(i)-2,nlayer,iproj,izero,tlat1,tlat2,zero
             write(iavg(i)) ione,ione,ncol(i)-2,nrow(i)-2
             write(iavg(i)) ((icspec(n,l),n=1,10),l=1,navspc)
          endif
        endif
      enddo 
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_CNCPREP:'
      write(iout,'(2A)',ERR=9999)'Reading global attributes from ',
     &                                          'initial conditions file.'
      write(iout,'(2A)',ERR=9999)'Cannot read: ',this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_CNCPREP:'
      write(iout,'(2A)',ERR=9999)'Reading the header of initial ',
     &                                        'conditions file.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_CNCPREP:'
      write(iout,'(2A)',ERR=9999)'Reading global attributes from ',
     &                                          'initial conditions file.'
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      lfirst = .FALSE.
      return
      end

      subroutine nodes_pass_sapnts(numprocs,iproc_id)
      use tracer
      use ptemiss
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes the point source array to the nodes.
c        A special routine is needed for this because the size of
c        array can be too large for one pass. Instead a pass for 
c        each species is needed.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c       numprocs       the number of processes
c       iproc_id       process ID
c     Output:  
c
c    Called by:
c    Subroutines called:
c       MPI_SEND
c       MPI_RECV
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c     
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numprocs
      integer iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real    :: array(MXPTSRC)
      integer :: i, ispc, ipts, ierr
      integer :: status(MPI_STATUS_SIZE)
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.NOT. lmpi .AND. iproc_id .GT. 0) return
c
c   --- loop over tracer species ---
c
      do ispc=1,soap3_ntotsp
c
c  --- process ID zero sends all of the messages,
c      to all of the other processes ---
c
         if (iproc_id .EQ. 0) then
c
c   --- load all points into local array ----
c
            do ipts=1,nptsrc
               array(ipts) = sapnts(ipts,ispc)
            enddo
c
c   --- send local array to the compute nodes ---
c
            do i=1,numprocs 
               call MPI_SEND(array,nptsrc,MPI_REAL,i,itag,MPI_COMM_WORLD,ierr)
            enddo
c
c  --- if this is a compute process, allocate the data structures
c      and wait for the data to arrive ---
c
         else
            call MPI_RECV(array,nptsrc,MPI_REAL,0,itag,MPI_COMM_WORLD,status,ierr)
c
c  --- load data back into global array ---
c
            do ipts=1,nptsrc
               sapnts(ipts,ispc) = array(ipts)
            enddo
         endif
         itag = itag + 1
      enddo
c
      end

c**** FILVDSA.F
c
      subroutine filvdsa(nox,noy,noz,nspcs,nspsa,nox_rt,noy_rt,nsprt,
     &                                     conc,vdep,vdepsa,vdeprt)
      use chmstry
      use tracer
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills the depostion velocity from the regular model
c   depostion velocities.  The tracer vdeps are a concentration
c   weighted average of the regular model vdeps.
c   
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           vdepsa   R  depostion velocity for tracer species
c       Inputs:
c           nox      I  number of X cells in the grid
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspcs    I  number of species in the grid
c           nspsa    I  number of tracer species
c           nox_rt   I  number of X cells in the grid (used for RTRAC array)
c           noy_rt   I  number of Y cells in the grid (used for RTRAC array)
c           nsprt    I  number of RTRAC species
c           conc     R  regular model concentrations
c           vdep     R  deposition velocity for regular model species
c           vdeprt   R  deposition velocities for RTRAC
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/06/96   --gwilson--    Original development
c     10/11/97   --gwilson--    Removed unused argument SACONC
c     01/30/02   --gwilson--    Added code for RTRAC probing tool
c     07/11/07   --gwilson--    Added code for RTCMC probing tool
c     05/24/13   --cemery--     RTCMC deposition can point to core species
c     11/17/20   --cemery--     RTCMC deposition is now consistent with
c                               RTRAC
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nox
      integer   noy
      integer   noz
      integer   nspcs
      integer   nspsa
      integer   nox_rt
      integer   noy_rt
      integer   nsprt
      real      vdep(nox,noy,nspcs)
      real      conc(nox,noy,noz,nspcs)
      real      vdepsa(nox,noy,nspsa)
      real      vdeprt(nox_rt,noy_rt,nsprt)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icl, jcl, ispc
      real    val
c
      real, allocatable, dimension(:,:,:) :: consum
      real, allocatable, dimension(:,:,:) :: vdsum
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- call routine to zero out the arrays ---
c
      call zeros(vdepsa,nox*noy*nspsa)
c
c   --- if doing RTRAC, load from the gridded arrays 
c       filled by DRYDEPRT ---
c
      if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
          do ispc=1,nspsa
             do icl=1,nox
                do jcl=1,noy
                  vdepsa(icl,jcl,ispc) = vdeprt(icl,jcl,ispc)
                enddo
             enddo
          enddo
          goto 9999
      endif
c
c  --- allocate the temporary arrays ---
c
      allocate( consum(nox,noy,MXTRCLS) )
      call zeros(consum,nox*noy*MXTRCLS)
c
      allocate( vdsum(nox,noy,MXTRCLS) )
      call zeros(vdsum,nox*noy*MXTRCLS)
c
c  ---- read concentrations for each species ----
c
      do 10 ispc=1,nspcs
c
c   --- if the species is a not a tracer species, skip it ---
c
          if( .NOT. lusespc(ispc) ) goto 10
c
c   --- loop over cells ---
c
          do icl=1,nox
              do jcl=1,noy
c
c   --- loop over all classes ----
c
                 do icls=1,ntrcls
c
c   --- add up the wieghted average deposition velocity ---
c
                    consum(icl,jcl,icls) = consum(icl,jcl,icls) + 
     &                         conc(icl,jcl,1,ispc) * fluxmap(ispc,icls)
                    vdsum(icl,jcl,icls) = vdsum(icl,jcl,icls) + 
     &                     conc(icl,jcl,1,ispc) * fluxmap(ispc,icls) *
     &                                                vdep(icl,jcl,ispc)
                 enddo
c
c  --- next cell ---
c
            enddo
          enddo
c
c  --- next species --
c
   10 continue
c
c  --- loop over cells and calculate the tracer vdeps ---
c
      do icl=1,nox
         do jcl=1,noy
c
c   --- loop over all classes ----
c
            do icls=1,ntrcls
c
c   --- loop over all classes ----
c
              val = 0.
              if( consum(icl,jcl,icls) .NE. 0. ) val =
     &                     vdsum(icl,jcl,icls) /  consum(icl,jcl,icls)
               if( npttrc(icls) .GT. 0 ) then
                   do ispc=ipttrc(icls),npttrc(icls)
                      vdepsa(icl,jcl,ispc) = val
                   enddo
               endif
            enddo
c
c  ---- next cell ---
c
        enddo
      enddo
c
c  --- seallocate the local arrays ----
c
      deallocate( consum )
      deallocate( vdsum )
c
c  --- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine piginit(numprocs,dt,npts,nrads,nspc,nspcems,pttrace,height,windu,
     &                                         windv,tempk,press)
      use filunit
      use grid
      use chmstry
      use pigsty
      use ptemiss
      use rtracchm
      use tracer
      use node_mod
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGINIT initializes PiG puffs from flagged sources
c
c      Copyright Ramboll
c          
c     Modifications: 
c        07/05/02    Added code for IRON-PiG
c        06/24/03    Removed thetapig
c        09/04/03    Removed adiabatic factor; improved plume rise
c                    entrainment; revamped puff initiation for "chained" puffs
c        11/12/03    Added RTRAC species injection
c        08/25/05    Added new PiG-OSAT pointers to allow different input
c                    point source lists across model restarts
c        02/02/06    Removed GREASD-PiG specific conditional code
c        12/20/06    Added plume height overrided
c        06/04/09    Added sigmax and multiple puff releases according to
c                    PIGMXDT
c        04/08/10    Minor mods for updated plume rise algorithm
c        11/06/12    Added check to make sure PiGged source does not
c                    trigger plume distribution override
c        04/16/13    Added update to Lslice when puff array space
c                    is recycled.
c        11/21/25   Changed the way lemmap works - it now points the other direction
c
c     Input arguments:
c        numprocs            number of MPI slices
c        dt                  time step size (s)
c        npts                number of point sources in the array
c        nrads               number of radical species
c        nspc                number of model species
c        nspcems             number of emissions species
c        pttrace             point source emissions (mol/s)
c        height              layer height (m)
c        windu               wind speed in x-direction (m/s)
c        windv               wind speed in y-direction (m/s)
c        tempk               air temprature (deg.K)
c        press               air pressure (mb)
c
c     Output arguments:
c        none
c
c     Subroutines Called:
c        PLUMERIS
c
c     Called By:
c        EMISTRNS
c
      include  "camx.prm"
      include  "flags.inc"
c
      integer numprocs
      real    dt
      integer npts
      integer nrads
      integer nspc
      integer nspcems
      real    pttrace(npts,nspcems)
      real    height(*)
      real    windu(*)
      real    windv(*)
      real    tempk(*)
      real    press(*)
c
      real hght1d(0:MXLAYER),wind1d(MXLAYER),tempk1d(MXLAYER),
     &     dtdz1d(MXLAYER),press1d(MXLAYER)
      real frctr(MXRECTR)
      real gamma,p0,t1,t2,frsum,xtmp,ytmp,w2,dz,
     &     dtheta,dstktmp,zstk,dtpuff,dtime,grav,wp,tp,zrise,
     &     trise,sigma,pwidth,rip,fp,qp2,cq1,cq2,rkp,xlmax,
     &     hstktmp, tstktmp, vstktmp
      integer nr,l,m1,lsrc,n,i,j,k,igrd0,ip,ic,igrd,ig,
     &        ii,jj,kk,n3d,n3d_full,npuff,ipuff,m,m0,is,iempty
      integer iprc, igr, iems, iemspec
      real xerf
c
      data gamma /0.286/
      data p0 /1000./
      data grav /9.8/
      data cq1,cq2 /0.4,3.0/
c
c-----Entry point
c
c-----Divide initial mass among PiG reactors: (1) partition according to 
c     ERF function; (2) correct for truncation of xerf to conserve mass
c
      frsum = 0.
      do nr = 1,nreactr
        t1 = nr*sqrt(2.)/nreactr
        t2 = (nr-1)*sqrt(2.)/nreactr
        frctr(nr) = xerf(t1) - xerf(t2)
        frsum = frsum + frctr(nr)
      enddo
      do nr = 1,nreactr
        frctr(nr) = frctr(nr)/frsum
      enddo
c
c-----Loop over all elevated point sources in domain (master grid)
c
      m1 = 1
      do 50 lsrc = 1,nosrc(1)
        n = idsrc(lsrc,1)
        if (.not.lpiglet(n)) goto 50
        iempty = 0
        do iemspec = 1,nemspc
           if( pttrace(n,iemspec) .GT. 0. ) iempty = 1
        enddo
c
c======================== Source Apportion Begin =======================
c
        if( ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                                      tectyp .EQ. RTCMC) ) then
           do is = 1,nrtrac
             if (sapnts(n,is).gt.0.) iempty = 1
           enddo
        endif
c
c========================= Source Apportion End ========================
c
        if (iempty.eq.0) goto 50
c
c-----Found a PiG point source with non-zero emissions; load local 1-D
c     vectors from finest grid
c
        i = isrc(lsrc,1)
        j = jsrc(lsrc,1)
        igrd0 = 1
        do ip = 1,ngrid
          do ic = 1,nchdrn(ip)
            igrd = idchdrn(ic,ip)
            ig = mapgrd(igrd)
            if (i.ge.inst1(ig) .and. i.le.inst2(ig) .and.             
     &          j.ge.jnst1(ig) .and. j.le.jnst2(ig)) 
     &      igrd0 = igrd
          enddo
        enddo

        if (igrd0.eq.1) then
          ii = i
          jj = j
        else
          xtmp = xstk(n,1) - (inst1(igrd0) - 1)*delx
          ytmp = ystk(n,1) - (jnst1(igrd0) - 1)*dely
          ii = 2 + FLOOR(xtmp/delx*meshold(igrd0))
          jj = 2 + FLOOR(ytmp/dely*meshold(igrd0))
        endif
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        ii = ii-mi0(igrd0)
        jj = jj-mj0(igrd0)
        if( ii .LT. 0 .OR. ii .GT. mmxp(igrd0) ) goto 50
        if( jj .LT. 0 .OR. jj .GT. mmyp(igrd0) ) goto 50
c
        hght1d(0) = 0.
        do k = 1,nlay(igrd0)
          n3d = ii + mmxp(igrd0)*(jj - 1) +
     &                         mmxp(igrd0)*mmyp(igrd0)*(k - 1)
          n3d_full = ii + ncol(igrd0)*(jj - 1) +
     &                         ncol(igrd0)*nrow(igrd0)*(k - 1)
          hght1d(k) = height(iptr3d(igrd0)-1+n3d_full)
          tempk1d(k) = tempk(iptr3d(igrd0)-1+n3d)
          press1d(k) = press(iptr3d(igrd0)-1+n3d)
          w2 = windu(iptr3d(igrd0)-1+n3d)*windu(iptr3d(igrd0)-1+n3d) +
     &         windv(iptr3d(igrd0)-1+n3d)*windv(iptr3d(igrd0)-1+n3d)
          wind1d(k) = amax1(sqrt(w2),0.1) 
        enddo
        do k = 1,nlay(igrd0)
          if (k.lt.nlay(igrd0)) then 
            dz = (hght1d(k+1) - hght1d(k-1))/2.  
            dtheta = (tempk1d(k+1)*(p0/press1d(k+1))**gamma -  
     &                tempk1d(k)*(p0/press1d(k))**gamma)  
            dtdz1d(k) = dtheta/dz  
          else
            dtdz1d(k) = dtdz1d(k-1)  
          endif  
        enddo
c
c-----Disable the plume distribution override for PiG
c
        if( flowrat(n) .LT. 0. ) then
            write(iout,'(//,a)') 'ERROR in PIGINIT:'
            write(iout,*) 'Found negative flow rate for a PiGged source.'
            write(iout,*) 'The plume distribution override is not ',
     &                    'allowed for PiGged sources.'
            write(iout,*) 'Either reset the flow rate ',
     &                                     'on all PiGged sources'
            write(iout,*) 'Or turn off PiG treatment.'
            call camxerr()
        endif
c
c-----Calculate plume rise
c
        dstktmp = abs(dstk(n))
        hstktmp = hstk(n)
        tstktmp = tstk(n)
        vstktmp = vstk(n)
        if (effph(n) .lt. 0.) then
          zstk = abs(effph(n))
        else
          call plumeris(nlay(igrd0),hght1d,tempk1d,dtdz1d,wind1d,
     &                  hstktmp,dstktmp,tstktmp,vstktmp,zstk) 
        endif
        do kk = 1,nlay(igrd0)
          if (hght1d(kk).gt.zstk) goto 15
        enddo
        kk = nlay(igrd0)
        if (zstk.gt.hght1d(kk)) zstk = hght1d(kk)
  15    continue
c
c-----Divide the emissions into several puffs if the length exceeds half
c     the finest grid cell size; divide into several puffs if the current
c     timestep exceeds a specific max timestep
c
        xlmax = 1.e6
        do ip = 1,ngrid
          xlmax = amin1(xlmax,deltay(ip)/2.)
        enddo
        npuff = int(wind1d(kk)*dt/xlmax - 0.1) + 1
        dtpuff = amin1(dt,pigmxdt)
        npuff = max(npuff,int(dt/dtpuff-0.01)+1)
        dtpuff = dt/float(npuff)
        dtime = dt
        do 40 ipuff = 1,npuff
          dtime = dtime - dtpuff
c
c-----Calculate initial cross-puff sigma accounting for turbulent 
c     entrainment during release
c
          wp = amax1(1.,vstktmp/2.)
          tp = (tempk1d(kk) + tstktmp)/2.
          zrise = zstk - hstktmp
          trise = zrise/wp
          pwidth = sqrt(2.)*dstktmp
          sigma =  pwidth
          rip = grav*pwidth*abs(tp - tempk1d(kk))/(tempk1d(kk)*wp*wp)
          fp = 1. + 4.*rip
          qp2 = fp*wp*wp*(cq1 + cq2*wind1d(kk)*wind1d(kk)/
     &          (wind1d(kk)*wind1d(kk) + wp*wp))
          rkp = 0.15*pwidth*sqrt(qp2)
          sigma = sqrt(sigma*sigma + 2.*rkp*trise)
c
c-----Looking for a spot for the pig; add to the first empty location
c
          do m = m1,npig
            if (ingrd(m).eq.0) then
              m0 = m
              m1 = m0 + 1
              goto 20
            endif
          enddo
          npig = npig + 1
          m0 = npig
          m1 = npig + 1
  20      continue
          if (m0.gt.MXPIG) then
            write(iout,'(//,a)') 'ERROR in PIGINIT:'
            write(iout,*) 'PiG number exceeds maximum of ',MXPIG
            write(iout,*) 'Increase MXPIG and recompile'
            call camxerr()
          endif
c
c-----Load puff variables
c
          lnewt(m0) = .true.
          lnewg(m0) = .true.
          idpig(m0) = n
          ingrd(m0) = igrd0
          xpigf(m0) = xstk(n,1)
          xpigb(m0) = xstk(n,1)
          ypigf(m0) = ystk(n,1)
          ypigb(m0) = ystk(n,1)
          zpig(m0)  = zstk
          sigz(m0)  = amin1(sigma,amax1(zrise,1.))
          sigx(m0)  = sigma
          sigy(m0)  = sigma
          agepigf(m0) = dtime + dtpuff
          agepigb(m0) = dtime
          htfms(m0) = 0.
          htfmb(m0) = 0.
          vtfms(m0) = 0.
          vtfmb(m0) = 0.
          if( lmpi ) then
              do iprc=1,numprocs
                 do igr=1,ngrid
                    Lslice(igr,iprc,m0) = 0
                  enddo
              enddo
          endif
c
c======================== Source Apportion Begin =======================
c
          if( ltrace .AND. (tectyp .NE. RTRAC .OR.
     &                                      tectyp .NE. RTCMC) ) then
             ipufmap(m0) = ipigmap(n)
             ipufgrp(m0) = ipiggrp(n)
          endif
c
c========================= Source Apportion End ========================
c
c
c-----Calculate 3-D puff dimensions and fill with concentrations
c
          axisz(m0) = 3.*sigz(m0)
          axisy(m0) = 3.*sigy(m0)
          fmspig(m0) = 1.
          pufftop(m0) = zstk + 1.5*sigz(m0)
          puffbot(m0) = zstk - 1.5*sigz(m0)
          if (puffbot(m0).lt.0.) then
            axisz(m0) = axisz(m0) + puffbot(m0)
            puffbot(m0) = 0.
          endif
          if (pufftop(m0).gt.hght1d(nlay(igrd0))) then
            axisz(m0) = axisz(m0) - 
     &                  (pufftop(m0) - hght1d(nlay(igrd0)))
            pufftop(m0) = hght1d(nlay(igrd0))
          endif
c
c-----Initialize all PiG concentrations to zero, then fill emissions
c     and initialize radicals
c
          do nr = 1,nreactr
            do l = nrads+1,nspc
              puffmass(l,nr,m0) = 0.
CPIG cgwilson              is = lemmap(l)
CPIG cgwilson              if( is .GT. 0 )
CPIG cgwilson     &           puffmass(l,nr,m0) = pttrace(n,is)*
CPIG cgwilson     &                                      dtpuff*1.e6*frctr(nr)
            enddo
            do l = 1,nrads
              puffmass(l,nr,m0) = 1.e-9 ! puffmass(radical) in ppm
            enddo
c
c======================== Source Apportion Begin =======================
c
            if( ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                        tectyp .EQ. RTCMC) ) then
               do is = 1,nrtrac
                 puffrt(is,nr,m0) = sapnts(n,is)*
     &                              dtpuff*1.e6*frctr(nr)
               enddo
            endif
c
c========================= Source Apportion End ========================
c
          enddo
  40    continue
  50  continue
c
      return
      end

      Module grid_dims                 
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This module contains very basic specification of grid dimensions and other 
c        parameters that will be used to dimension arrays and allocate memory.
c-----------------------------------------------------------------------
c
c    Parameter descriptions:
c     Input:
c       MAXGRDS=10    I  Maximum number of grids
c       NXPMAX=1000   I  Maximum number of points in x-direction 
c       NYPMAX=1000   I  Maximum number of points in y-direction
c       NZPMAX=132    I  Maximum number of points in z-direction
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
         integer, parameter :: MAXGRDS=10
         integer, parameter :: NXPMAX=1000
         integer, parameter :: NYPMAX=1000
         integer, parameter :: NZPMAX=132
c
c        maximum number of processors that can be used in a parallel run
c
         integer, parameter :: MAXMACH=256
c
         integer, parameter :: MAXDIM2=1000*2
c
      End Module grid_dims

      subroutine ddmebi(hddmjac,nrxn,nfam,njac,nhet,
     &                  dt,H2O,atm,O2,CH4,H2,
     &                  rk,y1,ysen,khetsen,
     &                  lN2O5,lHCL,lNTR2,lHNO3,lCLN2,lINTR,ierr)
c
c----CAMx v7.40 260801
c
c     DDMEBI advances the 1st order sensitivty coefficients one time
c     step using Backward Euler method.
c
c      Copyright Ramboll
c
c     History:
c        06/01/08   --bkoo--       Original development
c        09/21/13   --bkoo--       Updated for KHETERO sens
c        01/03/14   --bkoo--       Updated for organic nitrate hydrolysis rate sensitivities
c        12/07/14   --bkoo--       Revised the cutoff code (EPS)
c        02/29/16   --bkoo--       Revised for hetero N2O5 + HCL rxn
c        07/20/16   --bkoo--       Revised for hetero INTR hydrolysis
c        09/02/16   --bkoo--       Set KHETSEN array size with # of het rxns; revised for hetero SO2
c
c     Input arguments:
c        hddmjac           name of subroutine to calc full Jacobian
c        nrxn              number of reactions
c        nfam              number of sensitivity families
c        njac              number of gas and radical species (ngas)
c        nhet              number of heterogeneous rxns
c        dt                EBI solver time step (hr)
c        H2O               water vapor concentration (ppm)
c        atm               total gas concentration (M) in ppm
c        O2                oxygen concentration (ppm)
c        CH4               methane concentration (ppm)
c        H2                hydrogen concentration (ppm)
c        rk                reaction rate constant (ppm/hr)
c        y1                concentrations (radical+gas) at t+dt (ppm)
c        ysen              sensitivity (radical+gas) matrix (ppm)
c        khetsen           sensitivity to k_hetero (1/hr or 1/ppm-hr)
c        lN2O5             spc idx to N2O5
c        lHCL              spc idx to HCL
c        lNTR2             spc idx to NTR2
c        lHNO3             spc idx to HNO3
c        lCLN2             spc idx to CLN2
c        lINTR             spc idx to INTR
c
c     Output arguments:
c        ysen              sensitivity (radical+gas) matrix (ppm)
c        ierr              error flag from LU decomposition
c
c     Routines called:
c        HDDMJAC
c        SGEFA
c        SGESL
c
c     Called by:
c        EBISOLV
c
      implicit none

      integer  nrxn,nfam,njac,nhet,ierr
      integer  lN2O5,lHCL,lNTR2,lHNO3,lCLN2,lINTR
      real     dt,H2O,atm,O2,CH4,H2
      real     rk(nrxn),y1(njac+1),ysen(nfam,njac)
      real     khetsen(nfam,nhet)
      real     stmp1,stmp2,stmp3,stmp4

      external hddmjac

      real     r_eps
      parameter ( r_eps = 1.e25 ) ! 1/eps

      real     rjac(njac+1,njac+1),aa(njac,njac),bb(njac)
      real     flg

      integer  ipvt(njac)
      integer  i,j,ip
c
c---  Entry point
c
      ierr = 0
      y1(njac+1) = 0.0
c
c---  Get the Jacobian
c
      flg = 1.0   ! keep (effective) 1st-order rxns
      rjac = 0.0  ! initialize the Jacobian
      call hddmjac(njac,nrxn,H2O,atm,O2,CH4,H2,flg,rjac,y1,rk)
c
c---  Fill the coeff matrix
c
      do i = 1, njac
        do j = 1, njac
          aa(i,j) = -dt * rjac(i,j)
        enddo
        aa(i,i) = aa(i,i) + 1.0
      enddo
c
c---  Factor the coeff matrix
c
      call sgefa(aa,njac,njac,ipvt,ierr)
      if (ierr.ne.0) goto 990 ! zero determinant
c
c---  Solve for 1st order sensitivities
c
      do ip = 1, nfam

        stmp1 = y1(lN2O5)*H2O*dt*khetsen(ip,1)
        stmp2 = y1(lN2O5)*y1(lHCL)*dt*khetsen(ip,2)
        stmp3 = y1(lNTR2)*dt*khetsen(ip,3)
        stmp4 = y1(lINTR)*dt*khetsen(ip,4)
        do i = 1, njac
          bb(i) = ysen(ip,i)
        enddo
        if ( lN2O5.le.njac ) bb(lN2O5) = bb(lN2O5) - stmp1 - stmp2      ! add k_het sens term
        if ( lHCL .le.njac ) bb(lHCL)  = bb(lHCL)  - stmp2              ! add k_het sens term
        if ( lNTR2.le.njac ) bb(lNTR2) = bb(lNTR2) - stmp3              ! add k_het sens term
        if ( lINTR.le.njac ) bb(lINTR) = bb(lINTR) - stmp4              ! add k_het sens term
        if ( lHNO3.le.njac ) bb(lHNO3) = bb(lHNO3) + 2.*stmp1
     &                                     + stmp2 + stmp3 + stmp4      ! add k_het sens term
        if ( lCLN2.le.njac ) bb(lCLN2) = bb(lCLN2) + stmp2              ! add k_het sens term
        do i = 1, njac
          bb(i) = bb(i) * MIN(1.0, AINT( ABS(bb(i))*r_eps ))
        enddo

        call sgesl(aa,njac,njac,ipvt,bb,0)

        do i = 1, njac
          bb(i) = bb(i) * MIN(1.0, AINT( ABS(bb(i))*r_eps ))
          ysen(ip,i) = bb(i)
        enddo

      enddo
c
c---  Return point
c
990   return
      end

c*** PIGDRYSA
c
      subroutine pigdrysa(ncolx,nrowy,nlays,nrad,nspc,ntrac,
     &                    icell,jcell,idxpig,
     &                    deldry,saconc,dryfld)
      use grid
      use pigsty
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine puts the dry deposition from the PiG into the tracer
c     dry deposition array.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       ncolx   I  number of columns
c       nrowy   I  number of rows
c       nlays   I  number of layers
c       nrad    I  number of radical species
c       nspc    I  number of model species
c       ntrac   I  number of tracers
c       icell   I  the X grid location of current cell
c       jcell   I  the X grid location of current cell
c       idxpig  I  the index of the puff in PiG arrays
c       deldry  R  change in model dry depostion
c       saconc  R  gridded array of tracer concentrations
c       dryfld  R  gridded array of tracer dry depositions
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c       02/10/16  --bkoo--      Created
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   ncolx
      integer   nrowy
      integer   nlays
      integer   nrad
      integer   nspc
      integer   ntrac
      integer   icell
      integer   jcell
      integer   idxpig
      real      deldry(nspc)
      real      saconc(ncolx,nrowy,nlays,ntrac)
      real      dryfld(ncolx,nrowy,ntrac)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icls, ispc, itrc, i
      integer iOO, iO3
      real    delcls(MXALCLS)
      real    sumcls
      real    sumO3, sumOO, prodOO, destOO
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- get dry dep change for model species of each tracer class
c
      do icls = 1, ntrcls
         delcls(icls) = 0.
         do ispc = nrad+1, nspc
            delcls(icls) = delcls(icls)
     &                   + deldry(ispc) * fluxmap(ispc,icls)
         enddo
      enddo
c
c  --- update dry dep for O3 & OO tracers
c
      if ( lozone ) then

         sumO3 = 0.
         do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
            sumO3 = sumO3 + saconc(icell,jcell,1,i)
         enddo
         sumO3 = MAX(BNDLPT, sumO3)

         sumOO = 0.
         do i = iptcls(idxipt(ITROON)), nptcls(idxipt(ITROOV))
            sumOO = sumOO + saconc(icell,jcell,1,i)
         enddo
         sumOO = MAX(BNDLPT, sumOO)

         prodOO = MAX( 0.,  delcls(idxipt(ITRRGN)) )
         destOO = MAX( 0., -delcls(idxipt(ITRRGN)) )

         if ( delcls(idxipt(ITRO3V)) .GT. 0. ) then
c
c  --- this is not supposed to happen, but just in case ...
c      If this happens, just allocate it to O3V of this plume
c
            itrc = iemcls(idxipt(ITRO3V)) - 1 + 
     &                    ipufmap(idxpig) + ipufgrp(idxpig) * nregin

            dryfld(icell,jcell,itrc) = dryfld(icell,jcell,itrc)
     &                               + delcls(idxipt(ITRO3V))
         else
c
c  --- allocate O3 decrease based on relative contribution of O3X
c
            do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
               dryfld(icell,jcell,i) = dryfld(icell,jcell,i)
     &                               + delcls(idxipt(ITRO3V))
     &                               * saconc(icell,jcell,1,i) / sumO3
            enddo
         endif
c
c  --- allocate OO increase based on relative contribution of O3X
c           and OO decrease based on relative contribution of OOX
c
         iO3 = iptcls(idxipt(ITRO3N)) - 1
         do i = iptcls(idxipt(ITROON)), nptcls(idxipt(ITROOV))
            iO3 = iO3 + 1
            dryfld(icell,jcell,i) = dryfld(icell,jcell,i)
     &                    + prodOO * saconc(icell,jcell,1,iO3) / sumO3
     &                      - destOO * saconc(icell,jcell,1,i) / sumOO
         enddo
c
c  --- reset the dry dep change for the tracers already processed so that they will be skipped below
c
         delcls(idxipt(ITRO3N)) = 0.
         delcls(idxipt(ITRO3V)) = 0.
         delcls(idxipt(ITROON)) = 0.
         delcls(idxipt(ITROOV)) = 0.
      endif
c
c  --- loop over all tracer classes
c
      do icls = 1, ntrcls
c
c  --- skip if no change or already processed
c
         if ( delcls(icls) .EQ. 0. ) CYCLE
c
c  --- for all other tracers
c
         if ( delcls(icls) .GT. 0. ) then
c
c  --- if positive change, allocate it to this plume
c
            itrc = iemcls(icls) - 1 + 
     &                    ipufmap(idxpig) + ipufgrp(idxpig) * nregin

            dryfld(icell,jcell,itrc) = dryfld(icell,jcell,itrc)
     &                               + delcls(icls)
         else
c
c  --- if negative change, reduce dry dep based on relative contribution of the tracer
c
            sumcls = 0.
            do i = iptcls(icls), nptcls(icls)
               sumcls = sumcls + saconc(icell,jcell,1,i)
            enddo
            sumcls = MAX(BNDLPT, sumcls)

            do i = iptcls(icls), nptcls(icls)
               dryfld(icell,jcell,i) = dryfld(icell,jcell,i)
     &                              + delcls(icls)
     &                              * saconc(icell,jcell,1,i) / sumcls
            enddo
         endif
c
c  --- next tracer class ---
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

c*** REPARTSA.F
c
      subroutine repartsa(numcol,numrow,numlay,igrid,
     &                                  icell,jcell,kcell,modcon)
      use grid
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine repartitions the particulate and gaseous portions
c     nitric acid and ammonia tracers based on the ratio found in the
c     regular model.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol  I number of columns in this slice
c       numrow  I number of rows in this slice
c       numlay  I number of layers in this slice
c       igrid   I  grid number
c       icell   I  the X grid location of current cell
c       jcell   I  the X grid location of current cell
c       kcell   I  the vertical grid location of current layer
c       modcon  R  array of model species concentrations
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     09/28/03   --gwilson--  Original development
c     05/05/07   --gwilson--  Added code to make an adjustment to
c                             tracer species if there is stray from 
c                             the regular - added to handle mass errors
c                             in regular model chemistry routines
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer numlay
      integer igrid
      integer icell
      integer jcell
      integer kcell
      real    modcon(*)
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c    FUZZ  - fuzz value for comparing against lower bound
c    SMALL - small real value
c
      real FUZZ, SMALL
c
      parameter( FUZZ  = 10.0 )
      parameter( SMALL = 1.e-16 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer*8 idxcel, idxhno3, idxpno3, idxnh3, idxpnh4
      integer*8 idxpo1, idxpo2, idxpo3, idxpo4
      integer   i, ipno3, ipnh4, ipo1, ipo2, ipo3, ipo4
      real      wthno3, wtnh3, conhno3, conpno3, connh3, conpnh4
      real      ratio, sumtrac, contrac, conadjust
c
c-----------------------------------------------------------------------
c
      data wtnh3  /18.0/
      data wthno3 /62.0/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- calculate the index of the cell in the grid ---
c
      idxcel =  DBLE(ipsa3d(igrid)-1) + DBLE(icell) + 
     &    DBLE(numcol) * DBLE(jcell-1) + DBLE(numcol * numrow *(kcell-1))
c
      if( lnitrate ) then
c
c  --- calculate the ratio of gas to  particluate nitric acid ---
c
         conhno3 = modcon(khno3) * wthno3
         conpno3 = modcon(kpno3)
         ratio = 0.
         if( conhno3+conpno3 .GT. SMALL )
     &                    ratio = conhno3 / (conpno3 + conhno3)
c
c  --- get the sum of all tracer species ---
c
         contrac = SMALL
         ipno3 = iptcls(idxipt(ITRPN3)) - 1
         do i=iptcls(idxipt(ITRHN3)),nptcls(idxipt(ITRHN3))
            idxhno3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
            ipno3 = ipno3 + 1
            idxpno3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(ipno3-1)
            sumtrac = ptconc(idxhno3)*wthno3 + ptconc(idxpno3)
            if( sumtrac .GT. FUZZ*BNDLPT ) contrac = contrac + sumtrac
         enddo
         if( contrac .GT. SMALL ) then
             conadjust = (conhno3+conpno3) / contrac
         else
             conadjust = 1.0
         endif
c
c  --- adjust the nitric acid tracers ----
c
         ipno3 = iptcls(idxipt(ITRPN3)) - 1
         do i=iptcls(idxipt(ITRHN3)),nptcls(idxipt(ITRHN3))
            idxhno3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
            ipno3 = ipno3 + 1
            idxpno3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(ipno3-1)
c
c  --- adjust for mass imbalance, if needed ---
c
            sumtrac = ptconc(idxhno3)*wthno3 + ptconc(idxpno3)
            if( sumtrac .GT. FUZZ*BNDLPT ) sumtrac = conadjust * sumtrac
c
c  --- redistribute the gas and particulates ---
c
            ptconc(idxhno3) = (ratio * sumtrac ) / wthno3
            ptconc(idxhno3) = MAX(ptconc(idxhno3),BNDLPT)
            ptconc(idxpno3) = sumtrac - ptconc(idxhno3) * wthno3
            ptconc(idxpno3) = MAX(ptconc(idxpno3),BNDLPT)
         enddo
c
c  --- calculate the ratio of gas to particluate ammonia ---
c
         connh3 = modcon(knh3) * wtnh3
         conpnh4 = modcon(kpnh4)
         ratio = 0.
         if( connh3+conpnh4 .GT. SMALL )
     &                    ratio = connh3 / (conpnh4 + connh3)
c
c  --- get the sum of all tracer species ---
c
         contrac = SMALL
         ipnh4 = iptcls(idxipt(ITRPN4)) - 1
         do i=iptcls(idxipt(ITRNH3)),nptcls(idxipt(ITRNH3))
            idxnh3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                 DBLE(numlay) * DBLE(i-1)
            ipnh4 = ipnh4 + 1
            idxpnh4 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                             DBLE(numlay) * DBLE(ipnh4-1)
            sumtrac = ptconc(idxnh3)*wtnh3 + ptconc(idxpnh4)
            if( sumtrac .GT. FUZZ*BNDLPT ) contrac = contrac + sumtrac
         enddo
         if( contrac .GT. SMALL ) then
             conadjust = (connh3+conpnh4) / contrac
         else
             conadjust = 1.0
         endif
c
c  --- adjust the ammonia tracers ----
c
         ipnh4 = iptcls(idxipt(ITRPN4)) - 1
         do i=iptcls(idxipt(ITRNH3)),nptcls(idxipt(ITRNH3))
            idxnh3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                     DBLE(numlay) * DBLE(i-1)
            ipnh4 = ipnh4 + 1
            idxpnh4 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                 DBLE(numlay) * DBLE(ipnh4-1)	
c        
c  --- adjust for mass imbalance, if needed ---
c  
            sumtrac = ptconc(idxnh3)*wtnh3 + ptconc(idxpnh4)
            if( sumtrac .GT. FUZZ*BNDLPT ) sumtrac = conadjust * sumtrac
c
c  --- redistribute the gas and particulates ---
c
            ptconc(idxnh3) = ratio * sumtrac / wtnh3
            ptconc(idxnh3) = MAX(ptconc(idxnh3),BNDLPT)
            ptconc(idxpnh4) = sumtrac - ptconc(idxnh3) * wtnh3
            ptconc(idxpnh4) = MAX(ptconc(idxpnh4),BNDLPT)
         enddo
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine hr_pan9(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_PAN9 solves PAN and RCO3 using Hertel's equations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is RACM2_s21 with nitrate hydrolysis + GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real fwd, bck, self, A, B, C, Q
      real newRCO3, lsPAN, lsRCO3
c
c --- Entry Point
c
      N2 = M - O2
c
c
c --- New RCO3 excluding from PAN
c
      newRCO3 = dt*(0.0
     &       +          r( 14)
     &       + ( 0.784)*r( 15)
     &       + ( 0.900)*r( 16)
     &       + ( 0.500)*r( 17)
     &       +          r( 18)
     &       + ( 0.670)*r( 19)
     &       +          r( 24)
     &       + ( 0.250)*r( 25)
     &       + ( 0.250)*r( 26)
     &       +          r( 90)
     &       + ( 0.313)*r( 98)
     &       +          r(100)
     &       + ( 0.650)*r(119)
     &       + ( 0.090)*r(128)
     &       + ( 0.150)*r(129)
     &       + ( 0.100)*r(130)
     &       + ( 0.100)*r(133)
     &       + ( 0.280)*r(134)
     &       + ( 0.002)*r(135)
     &       +          r(149)
     &       +          r(154)
     &       +          r(193)
     &       + ( 0.230)*r(195)
     &       + ( 0.350)*r(196)
     &       + ( 0.700)*r(198)
     &       + ( 0.150)*r(233)
     &       + ( 0.500)*r(269)
     &       + ( 0.269)*r(272)
     &       + ( 1.160)*r(274)
     &       + ( 0.160)*r(310)
     &       +          r(343)
     &       + ( 0.538)*r(346)
     &       + ( 0.700)*r(348) )
c
c --- Loss of RCO3 excluding self-reaction
c
      lsRCO3 = 1.0 + dt*(0.0
     &       +          rk(166)*yh(lNO2)
     &       +          rk(191)*yh(lNO)
     &       +          rk(231)*yh(lHO2)
     &       +          rk(267)*yh(lMO2)
     &       +          rk(285)*yh(lETHP)
     &       +          rk(286)*yh(lHC3P)
     &       +          rk(287)*yh(lHC5P)
     &       +          rk(288)*yh(lHC8P)
     &       +          rk(289)*yh(lETEP)
     &       +          rk(290)*yh(lOLTP)
     &       +          rk(291)*yh(lOLIP)
     &       +          rk(292)*yh(lBENP)
     &       +          rk(293)*yh(lTLP1)
     &       +          rk(294)*yh(lTOLP)
     &       +          rk(295)*yh(lPER1)
     &       +          rk(296)*yh(lXYL1)
     &       +          rk(297)*yh(lXYLP)
     &       +          rk(298)*yh(lPER2)
     &       +          rk(299)*yh(lXYOP)
     &       +          rk(300)*yh(lISOP)
     &       +          rk(301)*yh(lAPIP)
     &       +          rk(302)*yh(lLIMP)
     &       +          rk(304)*yh(lRCO3)
     &       + ( 0.500)*rk(305)*yh(lACTP)
     &       +          rk(306)*yh(lMEKP)
     &       +          rk(307)*yh(lKETP)
     &       + ( 0.731)*rk(308)*yh(lMACP)
     &       +          rk(309)*yh(lMCP)
     &       +          rk(311)*yh(lUALP)
     &       +          rk(312)*yh(lBALP)
     &       +          rk(313)*yh(lBAL1)
     &       +          rk(314)*yh(lADDC)
     &       +          rk(315)*yh(lMCTP)
     &       +          rk(316)*yh(lORAP)
     &       +          rk(317)*yh(lOLNN)
     &       +          rk(318)*yh(lOLND)
     &       +          rk(319)*yh(lADCN)
     &       +          rk(320)*yh(lXO2)
     &       +          rk(341)*yh(lNO3) )
c
c --- Loss of PAN
c
      lsPAN = 1.0 + dt*(0.0
     &       + rk( 32)
     &       + rk( 33)
     &       + rk(120)*yh(lOH)
     &       + rk(167) )
c
c
c --- Forward reaction of RCO3 to PAN
c
      fwd  = dt*(0.0
     &       +          rk(166)*yh(lNO2) )
c
c --- Backward reactions of PAN to RCO3
c
      bck  = dt*(0.0
     &       +          rk( 32)
     &       +          rk(167) )
c
c --- RCO3 self-reaction
c
      self = dt*(0.0
     &       + ( 2.000)*rk(303) )
c
c --- Solve for RCO3
c
      A = self*lsPAN
      B = ( lsPAN*lsRCO3) - (fwd*bck)
      C = lsPAN*( y0(lACO3) + newRCO3 ) + bck*y0(lPAN)
      Q = -0.5 * ( B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C) )
c
c --- Update Concentrations
c
      y1(lACO3) = MAX(1.0E-18, MAX(Q/A, -C/Q) )
      y1(lPAN)  = MAX(1.0E-15, (y0(lPAN) + fwd*y1(lACO3)) / lsPAN )
c
      return
      end

c**** NCF_SET_SPECATT_SADEP
c
      subroutine ncf_set_specatt_sadep(spec_units,spec_long_name,
     &                                         spec_desc,spec_coords)
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the species varaible attributes for the SA
c   deposition output NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c       Outputs:
c            spec_units     C array of units for this each species
c            spec_long_name C array of "long names" for each each species
c            spec_desc      C array of desciption for this each species
c            spec_coords    C array of coordinates for this each species
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       character*20 spec_units(*)
       character*20 spec_long_name(*)
       character*60 spec_desc(*)
       character*60 spec_coords(*)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer nspcout, j
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      nspcout = 0
      do j=1,ntotsp
        if( loutsa(j) ) then
          nspcout = nspcout + 1
          if( lsagas(j) ) then
             spec_units(nspcout) = "mol ha-1"
          else
             spec_units(nspcout) = "g ha-1"
          endif
          spec_long_name(nspcout) = ptname(j)(:istrln(ptname(j)))//' Dry'
          if( ptname(j)(7:9) .EQ. 'IC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Initial Conditions"
          else if( ptname(j)(4:9) .EQ. '000BC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - All Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'NTHBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Northern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'ESTBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Eastern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'STHBC' ) then
                 spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Southern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'WSTBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Western Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'TOPBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Top Boundary Conditions"
          else
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" dry deposition - Group: "//ptname(j)(4:6)//
     &                                                    " Region: "//ptname(j)(7:9)
          endif
          spec_coords(nspcout) = "latitude longitude"
        endif
      enddo
c
      do j=1,ntotsp
        if( loutsa(j) ) then
          nspcout = nspcout + 1
          if( lsagas(j) ) then
             spec_units(nspcout) = "mol ha-1"
          else
             spec_units(nspcout) = "g ha-1"
          endif
          spec_long_name(nspcout) = ptname(j)(:istrln(ptname(j)))//' Wet'
          if( ptname(j)(7:9) .EQ. 'IC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Initial Conditions"
          else if( ptname(j)(4:9) .EQ. '000BC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - All Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'NTHBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Northern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'ESTBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Eastern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'STHBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Southern Boundary Conditions"
          else if( ptname(j)(4:9) .EQ. 'WSTBC' ) then
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Western Boundary Conditions"
          else
              spec_desc(nspcout) = ptname(j)(:3)
     &                         //" wet deposition - Group: "//ptname(j)(4:6)//
     &                                                    " Region: "//ptname(j)(7:9)
          endif
          spec_coords(nspcout) = "latitude longitude"
        endif
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c*** WCONSA
c
      subroutine wconsa(iendat, endtim, nox, noy, noz, nspsa, saconc)
      use camxcom
      use tracer
      use filunit
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the instantaneous file for the tracer
c     species.  
c
c      Copyright Ramboll
c
c    Argument description:
c      iendat  I  ending date for this hour
c      endtim  R  ending time for this hour
c      nox     I  number of X cells in domain
c      noy     I  number of Y cells in domain
c      noz     I  number of layers in domain
c      nspsa   I  number of species
c      saconc  R  array of concentrations (instantaneous)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c      10/24/01  Removed BSWAP and converted integer strings to character*4
c      11/06/01  Removed calls to JULDATE and CALDATE (all dates in Julian)
c      08/23/06  Revised to just write instant fields at end of simulation
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       integer   iendat
       real      endtim
       integer   nox
       integer   noy
       integer   noz
       integer   nspsa
       real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*4   ispec(10,MXTRSP)
      character*20  spec_units(4*MXSPEC+2+2*MXTRSP)
      character*20  spec_long_name(4*MXSPEC+2+2*MXTRSP)
      character*60  spec_desc(4*MXSPEC+2+2*MXTRSP)
      character*60  spec_coords(4*MXSPEC+2+2*MXTRSP)
      integer       idate, jdate
      integer       isegmt, i, j, k, l
      real          btim, etim
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- set up the dates and times for instantaneous files ---
c
      jdate = iendat
      btim = endtim 
      etim = endtim + 10.0
      idate = jdate
      if( etim .EQ. 24.0 ) then
         jdate = jdate + 1
         etim = 0.0
         if( MOD(jdate,1000) .GT. 365 ) then
            if( MOD(INT(jdate/1000),4) .EQ. 0 ) then
               if( MOD(jdate,1000) .EQ. 367 )
     &                     jdate = (INT(jdate/1000)+1)*1000 + 1
            else
               jdate = (INT(jdate/1000)+1)*1000 + 1
            endif
         endif
      endif
c
c   ---- put species names into integer array ----
c 
      do 10 j=1,ntotsp
          read(ptname(j),'(10A1)') (ispec(i,j),i=1,10)
   10 continue
c
c  --- call routine to write the header ---
c
      call hdrwsa( iowcon, confil, 'AIRQUALITY', 
     &                  nsaspc, noz, idate, btim, jdate, etim,
     &                                 spec_units,spec_long_name,
     &                                       spec_desc,spec_coords)
c
c   --- write the data for this hour ----
c
      isegmt = 1
      btim = AINT(ANINT(btim)/100.) + amod(ANINT(btim),100.)/60.
      etim = AINT(ANINT(etim)/100.) + amod(ANINT(etim),100.)/60.
      write(iowcon(IDXCRS),ERR=7000) idate, btim, jdate, etim 
      do 20 l=1,nsaspc
         do 30 k=1,noz
            write(iowcon(IDXCRS)) isegmt, (ispec(i,l),i=1,10), 
     &                              ((saconc(i,j,k,l),i=1,nox),j=1,noy)
   30    continue
   20 continue
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in WCONSA:'
      write(iout,9000,ERR=9999)'Writing output tracer file: ',
     &                           confil(IDXCRS)(:istrln(confil(IDXCRS)))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,2A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine getdelt(ncol,nrow,nlay,dx,dy,windu,windv,height,
     &                   mapscl,dtmx,kmax)
      use bndary
      use camxcom
c
c----CAMx v7.40 260801
c
c     GETDELT computes the time step size according to a maximum allowable
c     Courant number
c
c      Copyright Ramboll
c
c     Modifications:
c        11/30/99  Removed timestep calculation for horizontal diffusion
c        1/25/02   Made the CFL criterion a parameter
c        4/10/03   Now calculating max timestep by layer AND
c                  returning layer index of 'critical height'
c        1/16/06   Increased CFL to 0.9, reduced hmax to 10 m, revised kmax
c                  calculation to handle kmax = 1
c        5/25/06   CFL set according to advection solver
c        3/12/10   Increased Hmax for super-stepping to 2000 m (from 10 m)
c        11/3/15   Added map scale factor to timestep calculation
c        6/4/19    Using resultant X+Y winds instead of 1-D calculations
c        6/15/19   Revised application of map scale factor
c
c     Input arguments:
c        ncol                number of columne
c        nrow                number of rows
c        nlay                number of layers
c        dx                  cell sixe in x-direction (m)
c        dy                  cell size in y-direction (m)
c        windu               wind speed in x-direction (m/s)
c        windv               wind speed in y-direction (m/s)
c        height              layer height (m)
c        mapscl              map scale factor (unitless)
c
c     Output arguments:
c        dtmx                layer maximum time step size (s)
c        kmax                layer index of critical height hmax
c
c     Routines called:
c        none
c
c     Called by:
c        TIMESTEP
c
      implicit none
      include "camx.prm"
      include "flags.inc"
c
      integer ncol,nrow,nlay,kmax
      real dy,dx(nrow),windu(ncol,nrow,nlay),windv(ncol,nrow,nlay),
     &     height(ncol,nrow,nlay),mapscl(ncol,nrow)
      real dtmx(nlay)
c
      integer i,j,k,imid,jmid
      real hmax,cfl,tmpx,tmpy
      real uwind,vwind,uvwind
c
c-----Entry point
c
c
c  --- set height for super-stepping ---
c
      hmax = 9999999.
      if( lsuper ) hmax = 2000.
c
      cfl = 0.9
      if (iadvct.eq.3) cfl = 0.5
      do 30 k = 1,nlay
        dtmx(k) = 3600.
        tmpx = dtmx(k)
        tmpy = dtmx(k)
        do 20 j = 2,nrow-1
          do 10 i = 2,ncol-1
c
c-----Calculate maximum time step based on wind speed
c
            if (windu(i,j,k).gt.0. .and. windu(i-1,j,k).lt.0.) then
              uwind = abs(windu(i,j,k)) + abs(windu(i-1,j,k))
            else
              uwind = max(abs(windu(i,j,k)),abs(windu(i-1,j,k)))
            endif
            if (windv(i,j,k).gt.0. .and. windv(i,j-1,k).lt.0.) then
              vwind = abs(windv(i,j,k)) + abs(windv(i,j-1,k))
            else
              vwind = max(abs(windv(i,j,k)),abs(windv(i,j-1,k)))
            endif
            uvwind = sqrt(uwind**2 + vwind**2)
c           tmpx = cfl*dx(j)*mapscl(i,j)/(uvwind + 1.e-10)
c           tmpy = cfl*dy   *mapscl(i,j)/(uvwind + 1.e-10)
            tmpx = cfl*dx(j)/(uvwind + 1.e-10)/mapscl(i,j)
            tmpy = cfl*dy   /(uvwind + 1.e-10)/mapscl(i,j)
            dtmx(k) = min(dtmx(k),tmpx,tmpy)
 10       continue
 20     continue
 30   continue
c
c-----Determine layer index of 'critical height', which defines the depth
c     wherein the driving timestep for current grid will be determined 
c
      imid = ncol/2
      jmid = nrow/2
      do k = 2,nlay
        if (height(imid,jmid,k).gt.hmax) then 
          kmax = k-1
          kmax = max(1,kmax)
          goto 100
        endif
      enddo
      kmax = nlay
c
 100  return
      end

      subroutine hadvbot(nn,dt,dx,con,vel,area,areav,flxarr,fpc,fmc,
     &                   mynn)
c  
c----CAMx v7.40 260801
c  
c     HADVBOT performs horizontal advection using the positive-definite  
c     mass conservative non-monotonic scheme of Bott (1989). Fourth order  
c     area preserving polynomials are used for the interior computational 
c     cells. First and second order polynomials are applied at the boundaries. 
c  
c     The following definitions are used:  
c  
c              |-----------> Positive direction  
c  
c     |Boundary|<-----------------Domain----------------->|Boundary| 
c  
c     | CON(1) | CON(2) |  ...  | CON(I) |  ...  |CON(N-1)| CON(N) |  
c  
c     VEL(1)-->|     VEL(I-1)-->|        |-->VEL(I)       |-->VEL(N-1)  
c  
c      FP(1)-->|      FP(I-1)-->|        |-->FP(I)        |-->FP(N-1)  
c  
c      FM(2)<--|        FM(I)<--|        |<--FM(I+1)      |<--FM(N)  
c             
c                            -->|   DX   |<-- 
c 
c      Copyright Ramboll
c  
c     Modifications:  
c        Spr 2000  Fluxes extracted for advection of DDM sens coeffs
c        5/17/00   small modification to flux1,2 to improve mass accounting
c       10/13/03   area weighting applied to winds rather than conc
c       11/04/03   only single FLXARR vector passed back for use in
c                  ZRATES and probling tools
c         9/1/09   Revised area weighting, removed from wind vector
c  
c     Input arguments:  
c        nn                  Number of cells  
c        dt                  Time step (s)  
c        dx                  Length of cell (m)
c        con                 Concentration vector (umol/m3) 
c        vel                 Wind speed vector (m/s)  
c        area                Cell area adjustment vector (1/m2)
c        areav               Interfacial area adjustment vector (m2)
c  
c     Output arguments:  
c        con                 Concentration vector (umol/m3)  
c        flxarr              Conc change from interfacial mass flux (umol/m3)
c        fpc, fmc            Positive and negative concentration fluxes before
c                            the flux limiting renormalization step (umol/m3)
c                            (used in calculating DDM sensitivities)
c  
c     Routines called:  
c        none  
c  
c     Called by:  
c        XYADVEC
c        ZRATES
c 
      include "camx.prm"
c
      integer mynn
      real con(mynn),vel(mynn),area(mynn),areav(mynn),flxarr(mynn)
      real fpc(mynn), fmc(mynn)
c
      real cn(MXCELLS)
      real fm(MXCELLS)
      real fp(MXCELLS)
c
      data small / 1.e-20/
c             
c-----Entry point 
c 
c-----Set all fluxes to zero, calculate Courant number vector
c
      do i = 1,nn
        fm(i) = 0.
        fp(i) = 0.
        cn(i) = vel(i)*dt/dx
      enddo
c             
c-----First order polynomials for boundary inflow fluxes 
c             
c-----Left boundary 
c
      cp = amax1(0.,cn(1))
      fp(1) = amin1(con(1),
     &              cp*(con(1)+0.5*(1.-cp)*(con(2)-con(1))))
c             
c-----Right boundary 
c
      cm = -amin1(0.,cn(nn-1))
      fm(nn) = amin1(con(nn),
     &               cm*(con(nn)-0.5*(1.-cm)*(con(nn)-con(nn-1))))
c             
c-----Second order polynomials for fluxes from the first and last  
c     computational cells 
c             
c-----Leftmost computational cell 
c
      a0 = (-con(1) + 26.*con(2) - con(3))/24.
      a1 = (-con(1)              + con(3))/16.
      a2 = ( con(1) -  2.*con(2) + con(3))/48.
      cm = -amin1(0.,cn(1))
      x1 = 1. - 2.*cm
      x2 = x1*x1
      fm(2) = amax1(0., a0*cm-a1*(1.-x2)+a2*(1.-x1*x2))
      cp = amax1(0.,cn(2))
      x1 = 1. - 2.*cp
      x2 = x1*x1
      fp(2) = amax1(0., a0*cp+a1*(1.-x2)+a2*(1.-x1*x2))
c
c======================== DDM Begin =======================
c
c
c-----Save fluxes for calculating sensitivities
c
      fpc(1) = fp(1)
      fmc(nn) = fm(nn)
      fmc(2) = fm(2)
      fpc(2) = fp(2)
c
c======================== DDM End =======================
c
c  
c-----Flux limiting renormalization
c
      wt =  con(2)/amax1(con(2), fm(2)+fp(2)+small)
      fm(2) = fm(2)*wt
      fp(2) = fp(2)*wt
c             
c-----Rightmost computational cell 
c
      a0 = (-con(nn-2) + 26.*con(nn-1) - con(nn))/24.
      a1 = (-con(nn-2)                 + con(nn))/16.
      a2 = ( con(nn-2) -  2.*con(nn-1) + con(nn))/48.
      cm = -amin1(0.,cn(nn-2))
      x1 = 1. - 2.*cm
      x2 = x1*x1
      fm(nn-1) = amax1(0., a0*cm-a1*(1.-x2)+a2*(1.-x1*x2))
      cp = amax1(0.,cn(nn-1))
      x1 = 1. - 2.*cp
      x2 = x1*x1
      fp(nn-1) = amax1(0., a0*cp+a1*(1.-x2)+a2*(1.-x1*x2))
c
c======================== DDM Begin =======================
c
c
c-----Save fluxes for calculating sensitivities
c
      fmc(nn-1) = fm(nn-1)
      fpc(nn-1) = fp(nn-1)
c
c======================== DDM Begin =======================
c
c-----Flux limiting renormalization
c
      wt = con(nn-1)/amax1(con(nn-1),fm(nn-1)+fp(nn-1)+small)
      fm(nn-1) = fm(nn-1)*wt
      fp(nn-1) = fp(nn-1)*wt
c             
c-----Fourth order polynomials for fluxes from the interior cells 
c
      do i = 3,nn-2
        a0 = (   9.*(con(i+2) + con(i-2)) - 
     &         116.*(con(i+1) + con(i-1)) + 2134.*con(i))/1920.
        a1 = (  -5.*(con(i+2) - con(i-2)) +  
     &          34.*(con(i+1) - con(i-1)))/384.
        a2 = (      -con(i+2) + 
     &          12.*(con(i+1) + con(i-1)) - 
     &           22.*con(i)   - con(i-2))/384.
        a3 = (       con(i+2) - 
     &           2.*(con(i+1) - con(i-1)) - con(i-2))/768.
        a4 = (       con(i+2) - 
     &           4.*(con(i+1) + con(i-1)) + 
     &            6.*con(i)   + con(i-2))/3840.
        cm = -amin1(0.,cn(i-1))
        x1 = 1. - 2.*cm
        x2 = x1*x1
        x3 = x1*x2
        fm(i) = amax1(0., a0*cm - a1*(1. - x2)    +
     &                            a2*(1. - x3)    -
     &                            a3*(1. - x1*x3) +
     &                            a4*(1. - x2*x3))
        cp = amax1(0.,cn(i))
        x1 = 1. - 2.*cp
        x2 = x1*x1
        x3 = x1*x2
        fp(i) = amax1(0., a0*cp + a1*(1. - x2)    +
     &                            a2*(1. - x3)    +
     &                            a3*(1. - x1*x3) +
     &                            a4*(1. - x2*x3))
c
c======================== DDM Begin =======================
c
c
c------Save fluxes for calculating sensitivities
c
        fmc(i) = fm(i)
        fpc(i) = fp(i)
c
c======================== DDM End =======================
c
c
c-----Flux limiting renormalization
c
        wt = con(i)/amax1(con(i), fm(i)+fp(i)+small)
        fm(i) = fm(i)*wt
        fp(i) = fp(i)*wt
      enddo
c 
c-----Update concentrations in computational cells 
c
      flxarr(1) = (fp(1) - fm(2))
      do i = 2,nn-1
         flxarr(i) = (fp(i) - fm(i+1))
         con(i) = con(i) - 
     &            area(i)*(areav(i)*flxarr(i) - areav(i-1)*flxarr(i-1))
         con(i) = amax1(con(i),1.0e-20)
      enddo
c
      return
      end

      subroutine cpivot(nbeg,nend,ndim,a,b,ierr)
c
c----CAMx v7.40 260801
c
c     CPIVOT solves the equation, using column pivot method when number
c     of variables are greater than 3, or analytically otherwise
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        nbeg                first variable to be solved
c        nend                last variable to be solved
c        ndim                the size of the matrix
c        a                   coefficient matrix
c        b                   right hand side
c
c     Output arguments:
c        b                   solution
c        ierr                non-zero if determinant zero
c
c     Routines called:
c        none
c
c     Called by:
c        TRAP
c
      real a(ndim,ndim), b(ndim)
c
      data eps/1.0e-10/
c
c-----Entry point
c
      ierr=0
      if (nend-nbeg+1.eq.2) then
        det = a(nbeg,nbeg)*a(nend,nend)-a(nend,nbeg)*a(nbeg,nend)
        if (det.eq.0.0) then
           ierr=-1
           return
        endif
        bnbeg = b(nbeg)*a(nend,nend)-b(nend)*a(nbeg,nend)
        bnend = a(nbeg,nbeg)*b(nend)-a(nend,nbeg)*b(nbeg)
        b(nbeg) = bnbeg/det
        b(nend) = bnend/det
        return
      endif
c
      if (nend-nbeg+1.eq.3) then
        det   = a(nbeg,nbeg)    *a(nbeg+1,nbeg+1)*a(nend,nend)
     &        + a(nbeg+1,nbeg)  *a(nend,nbeg+1)  *a(nbeg,nend)
     &        + a(nend,nbeg)    *a(nbeg+1,nend)  *a(nbeg,nbeg+1)
     &        - a(nend,nbeg)    *a(nbeg+1,nbeg+1)*a(nbeg,nend)
     &        - a(nend,nbeg+1)  *a(nbeg+1,nend)  *a(nbeg,nbeg)
     &        - a(nend,nend)    *a(nbeg+1,nbeg)  *a(nbeg,nbeg+1)
        if (det.eq.0.0) then
           ierr=-2
           return
        endif
        bnbeg = b(nbeg)         *a(nbeg+1,nbeg+1)*a(nend,nend)
     &        + b(nbeg+1)       *a(nend,nbeg+1)  *a(nbeg,nend)
     &        + b(nend)         *a(nbeg+1,nend)  *a(nbeg,nbeg+1)
     &        - b(nend)         *a(nbeg+1,nbeg+1)*a(nbeg,nend)
     &        - a(nend,nbeg+1)  *a(nbeg+1,nend)  *b(nbeg)  
     &        - a(nend,nend)    *b(nbeg+1)       *a(nbeg,nbeg+1)
        bnbeg1= a(nbeg,nbeg)    *b(nbeg+1)       *a(nend,nend)
     &        + a(nbeg+1,nbeg)  *b(nend)         *a(nbeg,nend)
     &        + a(nend,nbeg)    *a(nbeg+1,nend)  *b(nbeg)  
     &        - a(nend,nbeg)    *b(nbeg+1)       *a(nbeg,nend)
     &        - b(nend)         *a(nbeg+1,nend)  *a(nbeg,nbeg)
     &        - a(nend,nend)    *a(nbeg+1,nbeg)  *b(nbeg)
        bnend = a(nbeg,nbeg)    *a(nbeg+1,nbeg+1)*b(nend)  
     &        + a(nbeg+1,nbeg)  *a(nend,nbeg+1)  *b(nbeg)
     &        + a(nend,nbeg)    *b(nbeg+1)       *a(nbeg,nbeg+1)
     &        - a(nend,nbeg)    *a(nbeg+1,nbeg+1)*b(nbeg)
     &        - a(nend,nbeg+1)  *b(nbeg+1)       *a(nbeg,nbeg)
     &        - b(nend)         *a(nbeg+1,nbeg)  *a(nbeg,nbeg+1)
 
        b(nbeg) = bnbeg/det
        b(nbeg+1) = bnbeg1/det
        b(nend) = bnend/det
c
        return
      endif
c
      do 100 icurrnt=nbeg,nend-1
c
c-----Find the maximum element in the column
c
         alarge=0.0
         do i=icurrnt,nend
           if (alarge.lt.abs(a(i,icurrnt))) then
             alarge=abs(a(i,icurrnt))
             m=i
           endif
         enddo
c
c-----Switch the rows
c
         do j=icurrnt,nend
           temp=a(icurrnt,j)
           a(icurrnt,j)=a(m,j)
           a(m,j)=temp
         enddo
         temp=b(icurrnt)
         b(icurrnt)=b(m)
         b(m)=temp
c
c-----Check for singularity
c
         if (abs(a(icurrnt,icurrnt)).le.eps) then
           ierr=icurrnt
           return
         endif
c
c-----Gaussian reduction
c
        b(icurrnt)=b(icurrnt)/a(icurrnt,icurrnt)
        do j=nend,icurrnt,-1
          a(icurrnt,j)=a(icurrnt,j)/a(icurrnt,icurrnt)
        enddo
        do k=icurrnt+1,nend
          b(k)=b(k)-b(icurrnt)*a(k,icurrnt)
          do j=nend,icurrnt,-1
            a(k,j)=a(k,j)-a(icurrnt,j)*a(k,icurrnt)
          enddo
        enddo
c
  100 continue
c
c-----Back substitution
c
      b(nend) = b(nend)/a(nend,nend)
      do i=nend-1,nbeg,-1
        do j=i+1,nend
          b(i)=b(i)-a(i,j)*b(j)
        enddo
      enddo
c
      return
      end

      subroutine setbc1d(nnew,nold,cnew,cold)
c
c----CAMx v7.40 260801
c
c     SETBC1D sets boundary conditions for the case in which two grids
c     share a common boundary
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        nnew                number of overlapping cells in grid receiving concs
c        nold                number of overlapping cells in grid supplying concs
c        cold                conc to supply (umol/m3)
c
c     Output arguments:
c        cnew                conc received (umol/m3)
c
c     Routines called:
c        none
c
c     Called by:
c        BCMODFY
c
      include "camx.prm"
c
      real cnew(nnew)
      real cold(nold)
c
      real xnew(MXCELLS+1)
      real xold(MXCELLS+1)
c
c-----Entry point
c
c-----Case 1: nnew = nold
c
      if (nnew.eq.nold) then
        do i=1,nnew
          cnew(i) = cold(i)
        enddo
      endif
c
      do i=1,nnew+1
        xnew(i) = i-1
      enddo
      do i=1,nold+1
        xold(i) = float(nnew)/nold*(i-1)
      enddo
c
c-----Case 2: nnew < nold (or dxnew > dxold)
c
      if (nnew.lt.nold) then
        dxbeg = 0.
        ibeg = 1
        do i1=2,nnew+1
          do i2=1,nold
            if (xnew(i1).gt.xold(i2) .and. xnew(i1).le.xold(i2+1)) then
              iend = i2
              dxend = xnew(i1) - xold(i2)
            endif
          enddo
c
          ctmp = dxbeg*cold(ibeg) + dxend*cold(iend)
          do l=ibeg+1,iend
            ctmp = ctmp + cold(l-1)*(xold(l)-xold(l-1))
          enddo
          cnew(i1-1) = ctmp/(dxbeg+dxend+xold(iend)-xold(ibeg))
          ibeg = iend
          dxbeg = xold(iend) - xnew(i1)
        enddo
      endif
c
c-----Case 3: nnew > nold (or dxnew < dxold)
c
      if (nnew.gt.nold) then
        do i1=2,nold+1
          do i2=2,nnew+1
            if (xnew(i2-1).ge.xold(i1-1) .and. 
     &          xnew(i2).le.xold(i1)) then
              cnew(i2-1) = cold(i1-1)
            endif
            if (xnew(i2-1).lt.xold(i1) .and. xnew(i2).gt.xold(i1)) then
              tmp1 = xnew(i2) - xold(i1)
              tmp2 = xold(i1) - xnew(i2-1)
              w1 = tmp1/(tmp1 + tmp2)
              cnew(i2-1) = cold(i1)*w1 + cold(i1-1)*(1.-w1)
            endif
          enddo
        enddo
      endif
c
      return
      end

      subroutine reado3col(ncol,nrow,time,date,name,o3coltim,o3coldat,
     &                     indx)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c     READO3COL reads the time varying records for 1 parameter from 
c     the ozone column file and and sets the next read time
c
c
c      Copyright Ramboll
c
c     Modifications:
c        11/06/01  CAMx now assumes that all input file dates are in
c                  Julian format (YYJJJ) if the simulation year is 2000
c                  or greater.
c        04/26/03  Add capability for snow cover and make more robust
c        02/22/11  Moved snow panel to 2D surface met file
c        03/31/12  Reads only time-varying ozone column
c
c     Input arguments:
c        ncol                number of columns
c        nrow                number of rows
c        time                simulation time (HHMM)
c        date                simulation date (YYJJJ)
c        name                name of variable(OZONE COL)
c
c     Output arguments:
c        o3coltim            next update time for O3 column map (HHMM)
c        o3coldat            next update date for O3 column map (YYJJJ)
c        indx                coarse grid codes for variable
c
c     Routines called:
c        NONE
c
c     Called by:
c        O3COL_UPD
c
      integer o3coldat, date
      integer id1,id2,i,j,ncol,nrow
      integer indx(ncol,nrow)
      real o3coltim,time
      real t1,t2
      character*10 title, namoz, name
c
      data namoz /'OZONE COL '/
c
c-----Entry point
c
c-----Read coarse grid ozone column
c
 100  read(io3col,'(a10,i10,f10.0,i10,f10.0)',end=800) title,id1,t1,id2,t2
      if (title.ne.namoz) then 
        write(iout,'(//,a)') 'ERROR in READO3COL:'
        write(iout,'(3a,i10,f10.3)')
     &                'Looking for: ',name,' at: ',date,time
        write(iout,*) 'Expecting keyword OZONE COL' 
        write(iout,*) 'Found: ',title
        call camxerr()
      endif 
c
      do j = nrow,1,-1
        read(io3col,'(9999i1)',end=900) (indx(i,j),i=1,ncol)
      enddo
c
c-----Check for correct time/date and set next update time/date
c
      if ((id1.lt.date .or. (id1.eq.date .and. t1.le.time)) .and.
     &    (id2.gt.date .or. (id2.eq.date .and. t2.gt.time))) then
        o3coldat = id2
        o3coltim = t2
        if (o3coltim.ge.2400.) then
          o3coltim = o3coltim - 2400.
          o3coldat = o3coldat + 1
          if( MOD(o3coldat,1000) .GT. 365 ) then
            if( MOD(INT(o3coldat/1000),4) .EQ. 0 ) then
               if( MOD(o3coldat,1000) .EQ. 367 )
     &                     o3coldat = (INT(o3coldat/1000)+1)*1000 + 1
            else
               o3coldat = (INT(o3coldat/1000)+1)*1000 + 1
            endif
         endif
        endif
        write(iout,'(a40,2(f7.0,i8.5))')
     &    'Read ozone column file at ',t1,id1,t2,id2
        goto 999
      else
        write(iout,'(a40,2(f7.0,i8.5))')
     &    'Skipped ozone column file at ',t1,id1,t2,id2
        goto 100
      endif
c
c-----Unexpected end of O3 column file
c
 800  continue
      write(iout,'(//,a)') 'ERROR in READO3COL:'
      write(iout,'(a,i10,f10.3)')
     &     'Unable to find O3 column data at: ',date,time
      call camxerr()
c
c-----Unexpected end of O3 column file
c
 900  continue
      write(iout,'(//,a)') 'ERROR in READO3COL:'
      write(iout,'(//,a)') 'Unexpected end O3 column file'
      write(iout,'(3a,i10,f10.3)')
     &                'Looking for: ',name,' at: ',date,time
      write(iout,*)' Make sure the number of columns and rows ',
     &                     'matches the coarse grid dimensions.'
      call camxerr()
c
c-----Normal return
c
 999  return
      end

      subroutine intrpcnc(nspec,ncol,nrow,nlay,io,jo,nmesh,
     &                    ncolf,nrowf,nlayf,conc,concf)
c
c----CAMx v7.40 260801
c
c     INTRPCNC interpolates coarse grid concentration fields to a fine grid
c
c      Copyright Ramboll
c          
c     Modifications:
c       11/05/12   Removed vertical nesting
c
c     Input arguments:
c        nspec             number of species
c        ncol              number of columns
c        nrow              number of rows
c        nlay              number of layers
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        nlayf             number of layers in fine grid
c        conc              species concentration on coarse grid
c
c     Output arguments:
c        concf             species concentration on fine grid
c
c     Subroutine called:
c        INTERP2D
c
c     Called by:
c        READCNC
c
      real    conc(ncol*nrow*nlay,nspec)
      real    concf(ncolf*nrowf*nlayf,nspec)
c
c-----Entry point
c
      do ispc = 1,nspec
        call interp2d(ncol,nrow,nlay,io,jo,nmesh,ncolf,nrowf,
     &                conc(1,ispc),concf(1,ispc))
      enddo
c
      return
      end

      subroutine virtdump(m1,m2,m3,npuf,ncol,nrow,nlay,nspec,
     &                    ipuf,jpuf,dx,dy,mapscl,height,tempk,
     &                    press,vdmpvec)
      use camxcom
      use pigsty
      use filunit
      use filunit
      use node_mod
      implicit none
c
c----CAMx v7.40 260801
c
c     VIRTDUMP computes the 'virtual' contribution of a single puff
c     through a vertical grid column
c
c      Copyright Ramboll
c
c     Modifications: 
c        8/31/06         Added map scale factor
c
c     Input arguments:
c        m1                 number of columns for this slice
c        m2                 number of columns for this slice
c        m1                 number of columns for this slice
c        npuf               puff number
c        ncol               number of grid columns
c        nrow               number of grid rows
c        nlay               number of grid layers
c        ipuf               i-cell index of puff location
c        jpuf               j-cell index of puff location
c        dx                 grid spacing in x (m)
c        dy                 grid spacing in y (m)
c        mapscl             map scale factor
c        height             gridded layer heights (m)
c        nspec              number of species in conc array
c        tempk              temperature field (K)
c        press              pressure field (mb)
c
c     Output arguments:
c        vdmpvec            gridded species concentration (umol/m3)
c                           from one puff 
c
c     Routines Called:
c        none
c
c     Called by:
c        PIGDRIVE
c        AVEPIG
c
      include "camx.prm"
c
      integer m1
      integer m2
      integer m3
      integer npuf
      integer ncol
      integer nrow
      integer nlay
      integer nspec
      integer ipuf
      integer jpuf
      real    dx
      real    dy
      real    mapscl(m1,m2)
      real    height(m1,m2,m3)
      real    tempk(m1,m2,m3)
      real    press(m1,m2,m3)
      real    vdmpvec(MXLAYER,MXSPEC)

      real virtdmp(MXSPEC)
      real wtfac(MXLAYER)
      real sumwt,deplyr,volcel
      integer i,j,kk,kpb,kpt,is,nr
c
c-----Entry point
c
      i = ipuf
      j = jpuf
c
c ---- if not in this slice, just return ---
c
      if( i .LT. ia .OR. i .GT. iz ) goto 9999
      if( j .LT. ja .OR. j .GT. jz ) goto 9999
c
c-----Initialize some vectors
c
      do kk = 1,nlay
        wtfac(kk) = 0.
        do is = 1,nspec
          vdmpvec(kk,is) = 0.
        enddo
      enddo
c
c-----Find layers containing top and bottom of puff
c
      kpb = 1
      kpt = nlay
      do kk = 1, nlay
        if (height(i,j,kk) .GE. pufftop(npuf)) then
          kpt = kk
          goto 16
        endif
      enddo
  16  continue
      do kk = nlay,1,-1
        if (height(i,j,kk) .LE. puffbot(npuf)) then
          kpb = kk + 1
          goto 17
        endif
      enddo
 17   continue
c
c-----Define layer weighting (depth of puff coverage weighted by density)     
c
      if (kpb.eq.kpt) then
        wtfac(kpb) = 1.
      else
        sumwt = 0.
        deplyr = pufftop(npuf) - height(i,j,kpt-1)
        wtfac(kpt) = deplyr*press(i,j,kpt)/tempk(i,j,kpt)
        sumwt = sumwt + wtfac(kpt)

        deplyr = height(i,j,kpb) - puffbot(npuf)
        wtfac(kpb)= deplyr*press(i,j,kpb)/tempk(i,j,kpb)
        sumwt = sumwt + wtfac(kpb)

        do kk = kpb+1,kpt-1
          deplyr = height(i,j,kk) - height(i,j,kk-1)
          wtfac(kk) = deplyr*press(i,j,kk)/tempk(i,j,kk)
          sumwt = sumwt + wtfac(kk)
        enddo

        do kk = kpb,kpt
          wtfac(kk) = wtfac(kk)/sumwt
        enddo
      endif
c
c----Combine reactor mass in this puff
c
      do is = 1,nspec
        virtdmp(is) = 0.
        do nr = 1,nreactr
          virtdmp(is) = virtdmp(is) + puffmass(is,nr,npuf)
        enddo
      enddo
c
c-----Puff mass is assigned to layers according to the fraction of
c     puff coverage, and converted to concentration (umol/m3) 
c
      do kk = kpb,kpt
        deplyr = height(i,j,1)
        if (kk.gt.1) deplyr = height(i,j,kk) - height(i,j,kk-1)
        volcel = deplyr*dx*dy/mapscl(i,j)**2
        do is = 1,nspec
          vdmpvec(kk,is) = virtdmp(is)*wtfac(kk)/volcel
        enddo
      enddo
c
 9999 continue
      return
      end

      subroutine hadvppm(nn,dt,dx,con,vel,area,areav,flxarr,mynn)
c  
c----CAMx v7.40 260801
c
c     HADVPPM performs advection using the one-dimensional implementation
c     of the piecewise parabolic method of Colella and Woodward (1984).
c     A piecewise continuous parabola is used as the intepolation polynomial.
c     The slope of the parabola at cell edges is computed from a cumulative
c     function of the advected quantity.  These slopes are further modified
c     so that the interpolation function is monotone.
c
c     This version based on CMAQ HPPM.F, v 1.1.1.1 9/14/98, written by
c     M.T. Odman (10/5/93), NCSC.  This version assumes constant grid cell
c     size.
c     
c     The following definitions are used:  
c  
c              |-----------> Positive direction  
c  
c     |Boundary|<-----------------Domain----------------->|Boundary| 
c  
c     | CON(1) | CON(2) |  ...  | CON(I) |  ...  |CON(N-1)| CON(N) |  
c  
c     VEL(1)-->|     VEL(I-1)-->|        |-->VEL(I)       |-->VEL(N-1)  
c  
c      FP(1)-->|      FP(I-1)-->|        |-->FP(I)        |-->FP(N-1)  
c  
c      FM(2)<--|        FM(I)<--|        |<--FM(I+1)      |<--FM(N)  
c             
c                            -->|   DX   |<-- 
c 
c      Copyright Ramboll
c  
c     Modifications:  
c        5/17/00   small modification to flux1,2 to improve mass accounting
c       10/13/03   area weighting applied to winds rather than conc
c       11/04/03   only single FLXARR vector passed back for use in
c                  ZRATES and probling tools
c         9/1/09   Revised area weighting, removed from wind vector
c  
c     Input arguments:  
c        nn                  Number of cells  
c        dt                  Time step (s)  
c        dx                  Length of cell (m)
c        con                 Concentration vector (umol/m3) 
c        vel                 Wind speed vector (m/s)  
c        area                Cell area adjustment vector (1/m2) 
c        areav               Interfacial area adjustment vector (m2) 
c  
c     Output arguments:  
c        con                 Concentration vector (umol/m3)  
c        flxarr              Conc change from interfacial mass flux (umol/m3)
c  
c     Routines called:  
c        none  
c  
c     Called by:  
c        XYADVEC  
c        ZRATES
c 
      include "camx.prm"
c
      integer mynn
      real con(mynn),vel(mynn),area(mynn),areav(mynn),flxarr(mynn)
c
c-----Local parameters
c     STEEPEN is a flag for discontinuty capturing (steepening)
c     This is disabled in this version as marked by c***
c
c***      logical STEEPEN
c***      parameter (STEEPEN=.false.)
c***      parameter (ETA1=20.0, ETA2=0.05, EPS=0.01)
      parameter (TWO3RDS=2./3.)
c
c***      real fm(MX1D),fp(MX1D),cm(MX1D),cl(MX1D),cr(MX1D),dc(MX1D),
c***     &     c6(MX1D),d2c(MX1D),eta(MX1D),etabar(MX1D),cld(MX1D),crd(MX1D)
c
      real fm(MXCELLS)
      real fp(MXCELLS)
      real cm(MXCELLS)
      real cl(MXCELLS)
      real cr(MXCELLS)
      real dc(MXCELLS)
      real c6(MXCELLS)
c
c-----Entry point 
c
c-----Set all fluxes to zero. Either positive or negative flux will
c     remain zero depending on the sign of the velocity
c
c***      zeta = dx*dx
      do i = 1,nn
        fm(i) = 0.
        fp(i) = 0.
      enddo
c
c-----Zero order polynomial at the boundary cells
c
      cm(2)  = con(2)
      cm(nn) = con(nn-1)
c
c-----First order polynomial at the next cells, no monotonicity constraint
c     needed
c
      cm(3)    = (con(3) + con(2))/2.
      cm(nn-1) = (con(nn-1) + con(nn-2))/2.
c
c-----Second order polynomial inside the domain
c
      do i = 3,nn-2
c
c-----Compute average slope in the i'th cell
c
        dc(i) = 0.5*(con(i+1) - con(i-1))
c      
c-----Guarantee that CM lies between CON(I) and CON(I+1)
c     monotonicity constraint
      
        if ((con(i+1) - con(i))*(con(i) - con(i-1)).gt.0.) then
          dc(i) = sign(1.,dc(i))*min(
     &                               abs(dc(i)),
     &                               2.*abs(con(i+1) - con(i)),
     &                               2.*abs(con(i) - con(i-1)))
        else
          dc(i) = 0.
        endif
      enddo
c
      do i = 3,nn-3
        cm(i+1) = con(i) + 
     &            0.5*(con(i+1) - con(i)) + (dc(i) - dc(i+1))/6.
      enddo
c
      do i = 2,nn-1
        cr(i) = cm(i+1)
        cl(i) = cm(i)
      enddo
c
c-----Optional discontinuty capturing
c     This is disbaled completely in this version 
c
c***      if (STEEPEN) then
c***        do i = 2,nn-1
c***          eta(i) = 0.
c***          cld(i) = con(i)
c***          crd(i) = con(i)
c***        enddo
c***c 
c***c-----Finite diff approximation to 2nd derivative
c***c
c***        do i = 3,nn-2
c***          d2c(i) = (con(i+1) - 2.*con(i) + con(i-1))/6.
c***        enddo
c***c
c***c-----No discontinuity detection near the boundary: cells 2, 3, NN-2, NN-1
c***c 
c***        do i = 4,nn-3  
c***c 
c***c-----Compute etabars
c***c 
c***          if ((-d2c(i+1)*d2c(i-1).gt.0.) .and.
c***     &        (abs(con(i+1) - con(i-1)) -
c***     &         EPS*min(abs(con(i+1)),abs(con(i-1))).gt.0.)) then
c***            etabar(i) = -zeta*(d2c(i+1) - d2c(i-1))/
c***     &                  (con(i+1) - con(i-1))
c***          else
c***            etabar(i) = 0.
c***          endif
c***          eta(i) = max(0.,min(ETA1*(etabar(i) - ETA2),1.)) 
c***          crd(i) = con(i+1) - 0.5*dc(i+1)
c***          cld(i) = con(i-1) + 0.5*dc(i-1)
c***        enddo
c***c
c***        do i = 2,nn-1
c***          cr(i) = cm(i+1) + eta(i)*(crd(i) - cm(i+1))
c***          cl(i) = cm(i) + eta(i)*(cld(i) - cm(i))
c***        enddo
c***      endif
c
c-----Generate piecewise parabolic distributions
c
      do i = 2,nn-1
c
c-----Monotonicity
c 
        if ((cr(i) - con(i))*(con(i) - cl(i)).gt.0.) then
          dc(i) = cr(i) - cl(i)
          c6(i) = 6.*(con(i) - 0.5*(cl(i) + cr(i)))
c
c-----Overshoot cases
c
          if (dc(i)*c6(i) .gt. dc(i)*dc(i)) then
            cl(i) = 3.*con(i) - 2.*cr(i)
          elseif (-dc(i)*dc(i) .gt. dc(i)*c6(i)) then
            cr(i) = 3.*con(i) - 2.*cl(i)
          endif
        else
          cl(i) = con(i)
          cr(i) = con(i)
        endif
        dc(i) = cr(i) - cl(i)
        c6(i) = 6.*(con(i) - 0.5*(cl(i) + cr(i)))
      enddo
c
c-----Compute fluxes from the parabolic distribution
c
      do i = 2,nn-1
        x = max(0., -vel(i-1)*dt/dx)
        fm(i) = x*(cl(i) + 0.5*x*(dc(i) + c6(i)*(1. - TWO3RDS*x)))
        x = max(0., vel(i)*dt/dx)
        fp(i) = x*(cr(i) - 0.5*x*(dc(i) - c6(i)*(1. - TWO3RDS*x)))
      enddo
c
c-----Compute fluxes from boundary cells assuming uniform distribution
c
      if (vel(1).gt.0.) then
        x = vel(1)*dt/dx
        fp(1) = x*con(1)
      endif
c
      if (vel(nn-1).lt.0.) then
        x = -vel(nn-1)*dt/dx
        fm(nn) = x*con(nn)
      endif
c
c-----Update concentrations
c
      flxarr(1) = (fp(1) - fm(2))
      do i = 2,nn-1
        flxarr(i) = (fp(i) - fm(i+1))
        con(i) = con(i) - 
     &           area(i)*(areav(i)*flxarr(i) - areav(i-1)*flxarr(i-1))
      enddo
c
      return
      end

c*** PIGWETSA
c
      subroutine pigwetsa(ncolx,nrowy,nlays,nrad,nspc,ntrac,
     &                    icell,jcell,kclbeg,kclend,idxpig,
     &                    delwet,saconc,wetfld)
      use grid
      use pigsty
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine puts the wet deposition from the PiG into the tracer
c     wet deposition array.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       ncolx   I  number of columns
c       nrowy   I  number of rows
c       nlays   I  number of layers
c       nrad    I  number of radical species
c       nspc    I  number of model species
c       ntrac   I  number of tracers
c       icell   I  the X grid location of current cell
c       jcell   I  the X grid location of current cell
c       kclbeg  I  the bottom vertical layer in the affected column
c       kclend  I  the top vertical layer in the affected column
c       idxpig  I  the index of the puff in PiG arrays
c       delwet  R  change in model wet depostion
c       saconc  R  gridded array of tracer concentrations
c       wetfld  R  gridded array of tracer wet depositions
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c       02/10/16  --bkoo--      Updated for OSAT3
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   ncolx
      integer   nrowy
      integer   nlays
      integer   nrad
      integer   nspc
      integer   ntrac
      integer   icell
      integer   jcell
      integer   kclbeg
      integer   kclend
      integer   idxpig
      real      delwet(nspc)
      real      saconc(ncolx,nrowy,nlays,ntrac)
      real      wetfld(ncolx,nrowy,ntrac)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icls, ispc, itrc, i, kcel
      integer iO3
      real    delcls(MXALCLS)
      real    sumO3, fracO3
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- get wet dep change for model species of each tracer class
c
c      Note: IRONWET enforces DELWET >= 0, therefore always DELCLS >= 0
c
      do icls = 1, ntrcls
         delcls(icls) = 0.
         do ispc = nrad+1, nspc
            delcls(icls) = delcls(icls)
     &                   + delwet(ispc) * fluxmap(ispc,icls)
         enddo
      enddo
c
c  --- update wet dep for O3 & OO tracers
c
      if ( lozone ) then
c
c  --- O3 is not supposed to increase, but just in case ...
c      If this happens, just allocate it to O3V of this plume
c
         itrc = iemcls(idxipt(ITRO3V)) - 1 + 
     &                 ipufmap(idxpig) + ipufgrp(idxpig) * nregin

         wetfld(icell,jcell,itrc) = wetfld(icell,jcell,itrc)
     &                            + delcls(idxipt(ITRO3V))
c
c  --- allocate OO increase based on relative contribution of O3X
c      across the layers this puff covers (layer weighting is ignored though)
c      assuming that RGN increase is completely due to NOx titration of O3
c      (this sounds inconsistent because no wet dep is allowed for negative O3 increment)
c
         sumO3 = 0.
         do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
            do kcel = kclbeg, kclend
               sumO3 = sumO3 + saconc(icell,jcell,kcel,i)
            enddo
         enddo
         sumO3 = MAX(BNDLPT, sumO3)

         iO3 = iptcls(idxipt(ITRO3N)) - 1
         do i = iptcls(idxipt(ITROON)), nptcls(idxipt(ITROOV))
            iO3 = iO3 + 1
            fracO3 = 0.
            do kcel = kclbeg, kclend
               fracO3 = fracO3 + saconc(icell,jcell,kcel,iO3) / sumO3
            enddo
            wetfld(icell,jcell,i) = wetfld(icell,jcell,i)
     &                            + delcls(idxipt(ITRRGN)) * fracO3
         enddo
c
c  --- reset the wet dep change for the tracers already processed so that they will be skipped below
c
         delcls(idxipt(ITRO3N)) = 0.
         delcls(idxipt(ITRO3V)) = 0.
         delcls(idxipt(ITROON)) = 0.
         delcls(idxipt(ITROOV)) = 0.
      endif
c
c  --- loop over all tracer classes
c
      do icls = 1, ntrcls
c
c  --- skip if no change or already processed
c
         if ( delcls(icls) .GT. 0. ) then
c
c  --- allocate positive change to this plume
c
            itrc = iemcls(icls) - 1 + 
     &                    ipufmap(idxpig) + ipufgrp(idxpig) * nregin

            wetfld(icell,jcell,itrc) = wetfld(icell,jcell,itrc)
     &                               + delcls(icls)
         endif
c
c  --- next tracer class ---
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine nodes_ipr_update(numprocs,iproc_id,numcells,numspecs)
      use procan
      use filunit
      implicit none
c
c
c----CAMx v7.40 260801
c
c     This routine will pass the cipr data for Process Analysis
c     from the compute nodes, where it is calculated to the master
c     where it will be written to the output file. The data can be
c     summed over all compute nodes because it will be zero in a PA
c     cell outside of the computational slice. This routine will be
c     called at each output time.
c     
c      Copyright Ramboll
c
c     Modifications:
c
c     Input arguments:
c        numprocs            the number of processes
c        iproc_id            the process ID for this processor
c        numcells            then number of total Process Aanalysis cells
c        numspecs            then number of total Process Aanalysis "species"
c
c     Output arguments:
c        none
c
c     Routines called:
c     
c     Called by:
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c     
c-----Argmument declarations
c
      integer numprocs
      integer iproc_id
      integer numcells
      integer numspecs
c     
c-----Local variables
c
      integer iprc, icl, ispc
      integer nbytes, ierr, status(MPI_STATUS_SIZE), i
      integer itmp_npastep(numcells,numspecs)
      real    tmp_cipr(numcells,numspecs)
c     
c-----Entry point
c
      if( .NOT. lmpi .AND. iproc_id .GT. 0 ) return
c
c  --- calculate the  number of values ---
c
      nbytes = numcells * numspecs
c
c  --- pass the actual PA data,
c      process ID zero recieves data into temp array ---
c  --- do each process seperately ---
c
      do iprc=1,NPAPRC
         if( iproc_id .EQ. 0 ) then
            do icl=1,numcells
              do ispc=1,numspecs
                 npastep(icl,ispc) = 0
                 cipr(iprc,icl,ispc) = 0.
              enddo
            enddo
            do i=1,numprocs 
               call MPI_RECV( tmp_cipr, nbytes, MPI_REAL, i, itag,
     &                                      MPI_COMM_WORLD, status, ierr)

               do icl=1,numcells
                 do ispc=1,numspecs
                    cipr(iprc,icl,ispc) = cipr(iprc,icl,ispc) +
     &                                       tmp_cipr(icl,ispc)
                 enddo 
               enddo 
            enddo
c
c  --- if this is a compute process, send the global array ---
c
         else
            do icl=1,numcells
              do ispc=1,numspecs
                 tmp_cipr(icl,ispc) = cipr(iprc,icl,ispc)
              enddo 
            enddo 
            call MPI_SEND( tmp_cipr, nbytes, MPI_REAL, 0, itag,
     &                                            MPI_COMM_WORLD, ierr)
         endif
         itag = itag + 1
      enddo
c
c  --- calculate the  number of counters ---
c
      nbytes = numcells * numspecs
c
c  --- pass the timestep counts,
c      process ID zero recieves data into temp array ---
c
      if( iproc_id .EQ. 0 ) then
         do i=1,numprocs 
            call MPI_RECV( itmp_npastep, nbytes , MPI_INTEGER, i, itag,
     &                                      MPI_COMM_WORLD, status, ierr)
            do icl=1,numcells
              do ispc=1,numspecs
                   npastep(icl,ispc) = npastep(icl,ispc) +
     &                                            itmp_npastep(icl,ispc)
              enddo 
            enddo 
         enddo
c
c  --- if this is a compute process, send the global array ---
c
      else
         call MPI_SEND( npastep, nbytes, MPI_INTEGER, 0, itag,
     &                                            MPI_COMM_WORLD, ierr)
c
c  --- zero out the arrays ---
c
      endif
c
c  --- return to the calling routine ---
c
      itag = itag + 1
      end

c*** WRTCPA
c
      subroutine wrtcpa(ngrd, iendat, endtim, igrd, nox, noy, noz, 
     &                                                  nspsa, saconc)
      use camxcom
      use tracer
      use filunit
      use grid
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the outptut file for the process analysis
c     gridded reaction rate data (CPA data).  This routine is writes 
c     the data for the coarse grid.  The format is the same as the 
c     coarse grid average concentration file for the regular model 
c     species.
c
c      Copyright Ramboll
c
c    Argument description:
c      ngrd    I  grid index
c      iendat  I  ending date for this hour
c      endtim  R  ending time for this hour
c      igrd    I  grid number
c      nox     I  number of X cells in domain
c      noy     I  number of Y cells in domain
c      noz     I  number of layers in domain
c      nspsa   I  number of species
c      saconc  R  array of concentrations (instantaneous)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       integer   ngrd
       integer   iendat
       real      endtim
       integer   igrd
       integer   nox
       integer   noy
       integer   noz
       integer   nspsa
       real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer       idate, jdate, ibegcel, iendcel, jbegcel, jendcel
      integer       isegmt, i, j, k, l
      character*4   ispec(10)
      real          btim, etim
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ibegcel = 1
      iendcel = nox
      jbegcel = 1
      jendcel = noy
      if( igrd .GT. 1 ) then
        ibegcel = 2
        iendcel = nox-1
        jbegcel = 2
        jendcel = noy-1
      endif
c
c   --- set layers based on the output flag ---
c
      nlayer = noz
      if( .NOT. l3davg(igrd) ) nlayer = 1 
      isegmt = 1
c
c   --- set up the dates and times ----
c
      jdate = iendat
      etim = ANINT(endtim)/100.
      idate = jdate
      if( dtout .GE. 60.0 ) then
          btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      else
          btim = ANINT( 1000*(etim - ANINT(dtout)/100.) )/1000.
      endif
      if( btim .LT. 0. ) then
          btim = btim + 24.0
          idate = idate - 1
      endif
      write(iowsfc(ngrd),ERR=7000) idate, btim, jdate, etim
      do l=1,nsaspc
        do k = 1,nlayer
c
c   --- fill the integer array with process analysis "species" ---
c
          read(ptname(l),'(10A1)') (ispec(i),i=1,10)
c
c   --- write concentration field ---
c
          write(iowsfc(ngrd)) isegmt,(ispec(i),i=1,10),
     &           ((saconc(i,j,k,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
        enddo
      enddo
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in WRTCPA'
      write(iout,9000,ERR=9999) 'Writing gridded output chemical ',
     &                'process analysis (.cpa) file.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,3A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

C**** NCF_READINP_LU
c
      subroutine ncf_readinp_lu(igrd,ncol,nrow,num_luse,fsurf,topo,
     &                                           lai,lrdlai,icdocn)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines reads the next hour of data in the landuse file and
c   loads the data into global arrays
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        num_luse            number of landuse categeries
c        fsurf               fractional landuse field
c        topo                topographic elevation (m MSL, optional)
c        lai                 lead area index field (optional)
c        lrdlai              flag indicating if LAI was read
c        icdocn              ocean cell flag
c
c     Output arguments:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      integer num_luse
      real    fsurf(ncol,nrow,num_luse)
      real    topo(ncol,nrow)
      real    lai(ncol,nrow)
      logical lrdlai
      integer icdocn(ncol,nrow)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  this_var
      character*10  namsrf(NLUZ03)
      integer       lumap(NLUZ03), mapvar(NLUZ03), i, j, l, ilu, ifresh
      integer       this_varid, ierr, data_start(4), data_count(4)
      real          areatot
c
      real, allocatable, dimension(:,:) :: array2d
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data namsrf   /'water     ',
     &               'ice       ',
     &               'lake      ',
     &               'eneedl    ',
     &               'ebroad    ',
     &               'dneedl    ',
     &               'dbroad    ',
     &               'tbroad    ',
     &               'ddecid    ',
     &               'eshrub    ',
     &               'dshrub    ',
     &               'tshrub    ',
     &               'sgrass    ',
     &               'lgrass    ',
     &               'crops     ',
     &               'rice      ',
     &               'sugar     ',
     &               'maize     ',
     &               'cotton    ',
     &               'icrops    ',
     &               'urban     ',
     &               'tundra    ',
     &               'swamp     ',
     &               'desert    ',
     &               'mwood     ',
     &               'tforest   '/
      data lumap / 7, 8, 7, 5, 5, 4, 4, 5, 4, 3,
     &             3, 3, 3,10, 2, 2, 2, 2, 2, 2,
     &             1,11, 9, 8, 6, 6/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- initialize the data ----
c
      lrdlai = .FALSE.
      topo = 0.
      fsurf = 0.
      lai = 0.
      icdocn = 0
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = 1
      data_start(4) = 1
      data_count(4) = 1
c
c  ---- allocate temperary array ---
c
      allocate( array2d(ncol,nrow) )
c
      if( .NOT. is_netcdf_isurf(igrd) ) goto 9999
      write(action,'(A,I3)') 'Reading landuse file for grid ',igrd
c
c  --- loop over all landuse species and check if it is in file ---
c
      do ilu=1,NLUZ03
        this_var = namsrf(ilu)
        ierr = nf_inq_varid(isurf(igrd), this_var, this_varid)
        if( ierr .NE. NF_NOERR) goto 7000
c
c   --- read data for this category ---
c
        ierr = nf_get_vara_real(isurf(igrd),this_varid,data_start,
     &                                            data_count,array2d)
        if( ierr .NE. NF_NOERR) goto 7001
c
c  ---- set ocean flag based on water ---
c
        if( namsrf(ilu) .EQ. 'water     ') then
            ifresh = 0
            do j=1,nrow
              do i=1,ncol
                if( array2d(i,j) .GT. 0. ) icdocn(i,j) = 1
              enddo
            enddo
        endif
c
c  ---- check for fresh water ---
c
        if( namsrf(ilu) .EQ. 'lake      ') then
            ifresh = 0
            do j=1,nrow
              do i=1,ncol
                if( array2d(i,j) .GT. 0. ) ifresh = 1
              enddo
            enddo
        endif
c
c   --- read data and load into global array ---
c
        if( idrydep .EQ. 2) then
            fsurf(:,:,ilu) = array2d(:,:)
        else
            fsurf(:,:,lumap(ilu)) = fsurf(:,:,lumap(ilu)) + array2d(:,:)
        endif
      enddo
c
c  --- make sure data is value for inline emissions ---
c
      if( ifresh .EQ. 0 .AND. lixemis ) then
        write(iout,'(//,A)') 'WARNING in NCF_READINP_LU:'
        write(iout,'(A)') 'No fresh water coverage found in LU file'
        write(iout,'(A,i3,a,2i4)') 'Grid = ', igrd
        write(iout,'(2A)') 'If you are running with in-line halogen',
     &                     ' emissions, halogens will be emitted'
        write(iout,'(A)') 'for all water bodies.'
        write(iout,'(2A)') 'Use the WATERMASK program to convert your LU',
     &                   ' file to differentiate between'
        write(iout,'(A,//)') 'ocean and fresh water bodies.'
        write(*,'(//,A)') 'WARNING in NCF_READINP_LU:'
        write(*,'(A)') 'No fresh water coverage found in LU file'
        write(*,'(A,i3,a,2i4)') 'Grid = ', igrd
        write(*,'(2A)') 'If you are running with in-line halogen',
     &                     ' emissions, halogens will be emitted'
        write(*,'(A)') 'for all water bodies.'
        write(*,'(2A)') 'Use the WATERMASK program to convert your LU',
     &                   ' file to differentiate between'
        write(*,'(A,//)') 'ocean and fresh water bodies.'
      endif
c
c  --- Leaf area index ---
c
      this_var = 'lai'
      ierr = nf_inq_varid(isurf(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
        lrdlai = .TRUE.
        ierr = nf_get_vara_int(isurf(igrd),this_varid,data_start,
     &                                            data_count,lai)
        if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c  --- topographic elevation ---
c
      this_var = 'topo'
      ierr = nf_inq_varid(isurf(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
        write(iout,'(a40,15x,a,i3)') 'Read TOPO field',' grid',igrd
        ierr = nf_get_vara_real(isurf(igrd),this_varid,data_start,
     &                                            data_count,topo)
        if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c --- Check that the LU data are reasonable and adjust out
c     minor inconsistencies ---
c
      do j = 1,nrow
        do i = 1,ncol
           areatot = 0.0
           do l = 1,num_luse
             areatot = areatot + fsurf(i,j,l)
           enddo
           if( areatot .LT. 0.95 .OR. areatot .GT. 1.05) goto 7002
           do l = 1,num_luse
             fsurf(i,j,l) = fsurf(i,j,l)/areatot
           enddo
         enddo
      enddo
c
c  ---- deallocate temperary array ---
c
      deallocate( array2d )
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_LU:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_LU:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 write(iout,'(//,A)') 'ERROR in NCF_READINP_LU::'
      write(iout,'(/,2A)') 'Sum of landuse fractions differs from 1.0 ',
     &                     'by more than 5%'
      write(iout,'(A,i3,a,2i4)')
     &       'Grid = ', igrd, '  Cell(i,j) = ', i, j
      write(iout,'(A)') 'Table of input landuse data follows:'
      write(iout,'(/,A)') ' Class    Fraction'
      write(iout,'(i6,F10.3)') (l,fsurf(i,j,l),l=1,num_luse)
      write(iout,'(A6,F10.3)') 'Total', areatot
      write(iout,'(/,A)') 'Check your input landuse data file'
      call camxerr()
c
 9999 continue
      return
      end

      subroutine parntchd(ngrid,ncol,nrow,inst1,inst2,jnst1,jnst2,
     &                    meshold,mapgrd,i1,i2,j1,j2,nmesh,nchdrn,
     &                    idchdrn)
      use filunit
c
c----CAMx v7.40 260801
c
c     PARNTCHD figures out the parent-children relationship and relative
c     mesh numbers between the grids
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        ngrid               number of grids
c        ncol                number of columns in each grid
c        nrow                number of rows in each grid
c        inst1/inst2         starting/ending i-indices relative to CG     
c        jnst1/jnst2         starting/ending j-indices relative to CG
c        meshold             meshing factor relative to CG
c
c     Output arguments:
c        mapgrd              grid mapping indices
c        i1/i2               starting/ending i-indices relative to parent 
c        j1/j2               starting/ending j-indices relative to parent
c        nmesh               meshing factor relative to parent
c        nchdrn              number of children per parent grid
c        idchdrn             indices of children per parent grid
c
c     Routines called:
c        none
c
c     Called by:
c        NSTPREP
c
      include "camx.prm"
c
      integer ncol(ngrid)
      integer nrow(ngrid)
      integer inst1(ngrid)
      integer inst2(ngrid)
      integer jnst1(ngrid)
      integer jnst2(ngrid)
      integer meshold(ngrid)
      integer i1(ngrid)
      integer i2(ngrid)
      integer j1(ngrid)
      integer j2(ngrid)
      integer nmesh(ngrid)
      integer nchdrn(ngrid)
      integer mapgrd(ngrid)
      integer idchdrn(MXCHDRN,ngrid)
c
      integer igen(MXGRID)
      integer itmp1(MXGRID)
      integer itmp2(MXGRID)
      integer jtmp1(MXGRID)
      integer jtmp2(MXGRID)
c
c-----Entry point
c
c-----Check for overlap
c
      do l1 = 2,ngrid
        do l2 = 2,ngrid
          if (l1.ne.l2) then
            if (inst1(l2).ge.inst1(l1) .and. 
     &          jnst1(l2).ge.jnst1(l1) .and. 
     &          inst1(l2).le.inst2(l1) .and. 
     &          jnst1(l2).le.jnst2(l1)) then
              if (inst2(l2).gt.inst2(l1) .or. 
     &            jnst2(l2).gt.jnst2(l1)) then
                write(iout,'(//,a)') 'ERROR in PARNTCHD:'
                write(iout,*) 'Two grids overlap: ',l1,l2
                call camxerr()
              endif
            endif
            if (inst2(l2).ge.inst1(l1) .and. 
     &          jnst1(l2).ge.jnst1(l1) .and. 
     &          inst2(l2).le.inst2(l1) .and. 
     &          jnst1(l2).le.jnst2(l1)) then
              if (inst1(l2).lt.inst1(l1) .or. 
     &            jnst2(l2).gt.jnst2(l1)) then
                write(iout,'(//,a)') 'ERROR in PARNTCHD:'
                write(iout,*) 'Two grids overlap: ',l1,l2
                call camxerr()
              endif
            endif
          endif
        enddo
      enddo
c
c-----Set up grids
c
      igen(1) = 1
      do igrd = 2,ngrid
        igen(igrd) = 2
      enddo
c
c-----Determine the generations by sorting
c
      do iter = 1,ngrid*ngrid
        indx = 0
        do l1 = 2,ngrid
          do l2 = 2,ngrid
            if (l1.ne.l2) then
              if (inst1(l2).ge.inst1(l1) .and. jnst1(l2).ge.jnst1(l1) 
     &                                   .and. 
     &            inst2(l2).le.inst2(l1) .and. jnst2(l2).le.jnst2(l1))
     &                                                              then
                if (igen(l2).le.igen(l1)) then
                  igen(l2) = igen(l1) + 1
                  indx = 1
                endif
              endif
            endif
          enddo
        enddo
        if (indx.eq.0) goto 50
      enddo
  50  continue
c
c-----Assign grid ID
c
      do itmp = 1,ngrid
        mapgrd(itmp) = itmp 
      enddo
c
      do iter = 1,ngrid*ngrid
        indx = 0
        do igrd = 2,ngrid-1
          if (igen(igrd).gt.igen(igrd+1)) then
            igntmp = igen(igrd)
            igen(igrd) = igen(igrd+1)
            igen(igrd+1) = igntmp
            igntmp = mapgrd(igrd)
            mapgrd(igrd) = mapgrd(igrd+1)
            mapgrd(igrd+1) = igntmp
            indx = 1
          endif
        enddo
        if (indx.eq.0) goto 60
      enddo
  60  continue
c
c-----Check if the user ordered the nested grids correctly
c
      do igrd = 2, ngrid
        if ( mapgrd(igrd).eq.igrd ) CYCLE
        write(iout,'(//,a)') 'ERROR in PARNTCHD:'
        write(iout,*) 'Nested grids must be listed after their parent ',
     &                'grid in the run control file (CAMx.in).'
        call camxerr()
      enddo
c
c-----Assign initial relative cell index range
c
      do igrd = 2,ngrid
        i1(igrd) = inst1(mapgrd(igrd)) 
        j1(igrd) = jnst1(mapgrd(igrd)) 
        i2(igrd) = inst2(mapgrd(igrd)) 
        j2(igrd) = jnst2(mapgrd(igrd)) 
      enddo
c
c-----Determine number of children and associated grid indices
c
      i1(1) = 1
      j1(1) = 1
      i2(1) = ncol(1)
      j2(1) = nrow(1)
      do ip = 1,ngrid
        nchdrn(ip) = 0
        do igrd = 2,ngrid
          if (igen(igrd).eq.igen(ip)+1) then
            if (i1(igrd).ge.i1(ip) .and. j1(igrd).ge.j1(ip) .and. 
     &          i2(igrd).le.i2(ip) .and. j2(igrd).le.j2(ip)) then
              nchdrn(ip) = nchdrn(ip) + 1
              idchdrn(nchdrn(ip),ip) = igrd
            endif
          endif
        enddo
      enddo
c
c-----Calculate relative cell index range
c
      mapgrd(1) = 1
      meshold(1) = 1
      nmesh(1) = 1
      i1(1) = 2
      j1(1) = 2 
      do ip=1,ngrid
        meshp = meshold(mapgrd(ip))
        do ic=1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          meshc= meshold(mapgrd(igrd))
          if (mod(meshc,meshp).ne.0) then
            write(iout,'(//,a)') 'ERROR in PARNTCHD:'
            write(iout,*) 'Inappropriate mesh number for grid ',
     &                     mapgrd(igrd), ' mesh # = ', meshc 
            call camxerr()
          endif
          nmesh(igrd) = meshold(mapgrd(igrd))/meshold(mapgrd(ip))
          itmp1(igrd) = (i1(igrd) - i1(ip))*meshold(mapgrd(ip)) + 2
          jtmp1(igrd) = (j1(igrd) - j1(ip))*meshold(mapgrd(ip)) + 2
          itmp2(igrd) = (i2(igrd) - i1(ip) + 1)*meshold(mapgrd(ip)) + 1
          jtmp2(igrd) = (j2(igrd) - j1(ip) + 1)*meshold(mapgrd(ip)) + 1
        enddo
      enddo
c
      i1(1) = 0
      j1(1) = 0 
      do igrd = 2,ngrid
        i1(igrd) = itmp1(igrd)
        j1(igrd) = jtmp1(igrd)
        i2(igrd) = itmp2(igrd)
        j2(igrd) = jtmp2(igrd)
      enddo
c
      return
      end

      subroutine drydeprt(m1,m2,m3,nrtsp,itzon,
     &                  tsurf,cellat,cellon,lrdlai,lai,pwc,cwc,height,
     &                  press,windu,windv,cod,water,fsurf,tempk,
     &                  snow,icdocn,vdep)
      use filunit
      use chmstry
      use bndary
      use camxcom
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c 
c     This version is for the RTRAC species.
c     DRYDEPRT is the driver for the calculation of gridded dry deposition 
c     velocities for a given grid. Deposition velocities are calculated for
c     each gas species and for each aerosol size bin, weighted by the
c     fractional land use specified for each cell.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        7/22/03   Taken from DRYDEP for regular model
c        11/19/04  Incorporated season-dependent roughness length
c        7/19/10   Added the Zhang et al (2003) dry deposition option
c        02/11/11  Removed optional roughness from AHO
c        04/02/12  Removed drought stress and snow flag; AHO
c                  file is now just ozone column
c        08/11/14  Snow cover changed to water equivalent depth
c        07/23/18  Updated VD_GAS_ZHANG call arguments for Bi-Di NH3
c
c     Input arguments:
c        ncol                number of columns 
c        nrow                number of rows 
c        nlay                number of layers 
c        nrtsp               number of species
c        itzon               time zone
c        tsurf               surface temperature field (K)
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        lrdlai              flag that LAI data were read
c        lai                 gridded LAI data from file
c        pwc                 precipitation water content (g/m3)
c        cwc                 cloud water content (g/m3)
c        height              layer interface height field (m)
c        press               layer pressure field (mb)
c        windu               layer U-component wind field (m/s)
c        windv               layer V-component wind field (m/s)
c        cod                 cloud optical depth field (unitless)
c        water               layer water vapor field (ppm)
c        fsurf               fractional landuse cover field (fraction)
c        tempk               layer temperature field (K)
c        snow                snow cover water equivalent (m)
c        icdocn              gridded ocean mask
c             
c     Output arguments: 
c        vdep                species-dependent deposition velocity field (m/s)
c             
c     Routines called: 
c        CALDATE
c        GETZNTH
c        MICROMET
c        VD_GAS
c        VD_AER
c        HENRYFNC
c             
c     Called by: 
c        EMISTRNS
c 
      include 'camx.prm'
      include 'deposit.inc'
      include 'camx_aero.inc'
      include 'flags.inc'
c
      integer :: m1,m2,m3,iday,iyear
      integer, dimension(12) :: nday
      real, dimension(m1,m2) :: tsurf, cellat, cellon, lai, snow
      integer, dimension(m1,m2) :: icdocn
      real, dimension(m1,m2,m3) :: height
      real, dimension(m1,m2,m3) :: press, windu, windv, cod,
     &                             water, tempk, pwc, cwc
      real, dimension(m1,m2,NLU) :: fsurf
      real, dimension(m1,m2,nspec) :: vdep

      real lai_ref_intpl,rlai,ref_lai,lai_f
      real tau,ctrns,fcld
      real*8 coszen,solflux
      logical ldark,lrdlai,lstable

      integer :: iflgnh3
      real :: rdum1, rdum2
c
      data pi/3.1415927/
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
      idate = date
      call caldate(idate)
      iyear = idate/10000
      month = (idate - 10000*iyear)/100
      if (mod(iyear,4).eq.0) nday(2)=29
      iday = idate - 100*(idate/100)
c
c-----Loop over rows and columns
c
      do 30 j = 2,m2-1 
        do 20 i = 2,m1-1
c
c-----Determine season
c
          mbin = month
          if (cellat(i,j).lt.0.) then
            mbin = mod(month+6,12)
            if (mbin.eq.0) mbin = 12
          endif
          latbin = 1
          if (abs(cellat(i,j)).gt.20.) then
            latbin = 2
          elseif (abs(cellat(i,j)).gt.35.) then
            latbin = 3
          elseif (abs(cellat(i,j)).gt.50.) then
            latbin = 4
          elseif (abs(cellat(i,j)).gt.75.) then
            latbin = 5
          endif
          if ((cellat(i,j).gt.50. .and. cellat(i,j).lt.75.) .and.
     &        (cellon(i,j).gt.-15. .and. cellon(i,j).lt.15.)) latbin = 3
          isesn = iseason(latbin,mbin)
c
c-----Use input snow cover to set season
c         
          if (snow(i,j).ge.0.001) isesn = 4  ! Snow cover check > 1 cm
c
c-----Determine cell-average relative LAI
c
          if (lrdlai) then
            ref_lai = 0.
            do m = 1,NLU
              lai_ref_intpl = lai_ref(m,mbin) +
     &                    float(min(nday(mbin),iday))/float(nday(mbin))*
     &                    (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              ref_lai = ref_lai + fsurf(i,j,m)*lai_ref_intpl
            enddo
            rlai = lai(i,j)/(ref_lai + 1.e-10)
          endif
c
c-----Calculate solar flux
c
          call getznth(cellat(i,j),cellon(i,j),time,date,itzon,
     &                 zenith,ldark)
          coszen = cos(DBLE(zenith)*DBLE(pi)/180.)
          tau = cod(i,j,m3)
          do k = m3-1,1,-1
            tau = tau + cod(i,j,k)
          enddo
          if (tau.lt.5.) then
            ctrns = 1.
            fcld  = 0.
          else
            ctrns = (5. - exp(-tau))/(4. + 0.42*tau)
            fcld  = 1.
          endif
          ctrns = 1.6*ctrns*coszen

          solflux = (990.*coszen - 30.)*
     &              (1. - fcld*(1. - ctrns))
          solflux = dmax1(DBLE(0.0),solflux)
c
c-----Load local met variables
c
          deltaz = height(i,j,1)/2.
          temp0 = tsurf(i,j) - 273.15
          prss0 = press(i,j,1) - 2.*deltaz*(press(i,j,2) - 
     &                             press(i,j,1))/height(i,j,2)
          ucomp = (windu(i,j,1) + windu(i-1,j,1))/2.
          vcomp = (windv(i,j,1) + windv(i,j-1,1))/2.
          wind = sqrt(ucomp**2 + vcomp**2)
          wind = amax1(0.1,wind)
c
c-----Determine surface wetness
c
          qwatr = 1.e-6*water(i,j,1)*18./28.8
          ev = qwatr*prss0/(qwatr + eps) 
          es = e0*exp((lv/rv)*(1./273. - 1./tsurf(i,j))) 
          rh = amin1(1.,ev/es)
          iwet = 0
          if (pwc(i,j,1).gt.cwmin) then
            iwet = 2
          elseif (cwc(i,j,1).gt.cwmin) then
            iwet = 1
          else
            dew = (1. - rh)*(wind + 0.6) 
            if (dew.lt.0.19) iwet = 1
          endif
c
c-----Loop over land use; surface roughness for water is dependent on
c     wind speed
c
          do l = 1,nrtrac
            vdep(i,j,l) = 0.
          enddo
          totland = 0.
c
          do 10 m = 1,NLU
            if (fsurf(i,j,m).lt.0.01) goto 10
            totland = totland + fsurf(i,j,m)
c
c-----Set surface roughness for Wesely (1989) scheme
c
            if (idrydep.eq.1) then
              z0 = z0lu(m,isesn)
              if (m.eq.7) z0 = amax1(z0,2.0e-6*wind**2.5)
c
c-----Set surface roughness and LAI for Zhang (2003) scheme
c
            else
              lai_f = lai_ref(m,mbin) +
     &                float(min(nday(mbin),iday))/float(nday(mbin))*
     &                (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              if (lrdlai) then
                lai_f = lai_f*rlai
                lai_f = amin1(lai_ref(m,15),lai_f)
                lai_f = amax1(lai_ref(m,14),lai_f)
              endif
              if (m.eq.1 .or. m.eq.3) then
                z0 = 2.0e-6*wind**2.5
              else
                if (z02(m).gt.z01(m)) then
                  z0 = z01(m) + (lai_f - lai_ref(m,14))/
     &                          (lai_ref(m,15) - lai_ref(m,14))*
     &                          (z02(m) - z01(m))
                else
                  z0 = z01(m)
                endif
              endif
            endif
c 
c-----Get surface layer micrometeorological parameters for this cell and
c     landuse type
c 
            call micromet(tempk(i,j,1),tsurf(i,j),press(i,j,1),prss0,
     &                    deltaz,wind,z0,pbl,ustar,el,psih,wstar,lstable)
            zl = deltaz/el
            if (zl.lt.0.) then
              zl = min(-5.,zl)
            else
              zl = max(5.,zl)
            endif
c
c-----Loop over GAS species, and calculate deposition velocity for this cell,
c     landuse, and current species.
c
            call henryfnc(0,henso20,tfactso2,tsurf(i,j),7.,1,1,1,
     &                    henso2)
            do 40 l = 1,nrtgas
              if (rthlaw(l).gt.1.e-6) then
                call henryfnc(0,rthlaw(l),rttfact(l),tsurf(i,j),7.,1,
     &                        1,1,henry)
                iflgso2 = 0
                iflgo3 = 0
                iflgnh3 = 0
                if (idrydep .eq. 1) then   ! Use Wesely (1989) algorithm
                  call vd_gas(m,0,iwet,iflgso2,iflgo3,z0,
     &                     deltaz,psih,ustar,rtdrate(l),henry,henso2,
     &                     rtreact(l),rtscale(l),temp0,dstress(0),
     &                     solflux,rj(m,isesn),rlu(m,isesn),
     &                     rac(m,isesn),rlcs(m,isesn),rlco(m,isesn),
     &                     rgss(m,isesn),rgso(m,isesn),icdocn(i,j),vd)
                elseif (idrydep .eq. 2) then ! Use Zhang (2003) algorithm
                  call vd_gas_zhang(deltaz,zl,z0,ustar,tempk(i,j,1),
     &                          tsurf(i,j),solflux,rh,fcld,
     &                          pwc(i,j,1),coszen,m,snow(i,j),iflgo3,
     &                          iflgnh3,rdum1,henry,henso2,rtreact(l),
     &                          rtdrate(l),rtscale(l),lai_f,vd,rdum2)
                endif
              else
                vd = 0.
              endif
              vdep(i,j,l) = vdep(i,j,l) + vd*fsurf(i,j,m)
 40         continue
c
c-----Loop over AEROSOL size bins, and calculate deposition velocity for
c     this cell and landuse
c
            if (nrtaero .gt. 0) then
              do 50 l = nrtgas+1,nrtrac
                diam = sqrt(rtlcut(l)*rtucut(l))*1.e-6
                if (idrydep.eq.1) then     ! Use Wesely (1989) algorithm
                  call vd_aer(z0,deltaz,psih,ustar,diam,rtdens(l),
     &                        tsurf(i,j),vd)
                elseif (idrydep.eq.2) then ! Use Zhang (2001) algorithm
                   call vd_aer_zhang(deltaz,zl,z0,ustar,diam,rtdens(l),
     &                               tsurf(i,j),tempk(i,j,1),m,lai_f,vd)
                endif
                vdep(i,j,l) = vdep(i,j,l) + vd*fsurf(i,j,m)
 50           continue
            endif

 10       continue
c
c-----Calculate final landuse-weighted deposition velocities
c
          totland = amax1(totland, 0.01)
          do l = 1,nrtrac
            vdep(i,j,l) = vdep(i,j,l)/totland
          enddo
c
 20     continue
 30   continue
c
      return
      end

c**** ADJBCDDM.F
c
      subroutine adjbcddm(adjwest,adjeast,adjsouth,adjnorth,
     &                                     nx,ny,nz,nspc,saconc)
      use bndary
      use chmstry
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine adjusts the boundary conditions for the DDM
c   species. This is necessary because the boundary conditions
c   change through time to reflect the interpolated met.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           adjwest  R  adjustment factors for West boundary
c           adjeast  R  adjustment factors for East boundary
c           adjsouth R  adjustment factors for South boundary
c           adjnorth R  adjustment factors for North boundary
c           nx       I  number of columns in field
c           ny       I  number of rows in field
c           nz       I  number of layers in field
c           nspc     I  number of species in the field
c       Inputs:
c           saconc   R  field of sensitivies
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     08/23/07   --gwilson--    Original development
c     04/30/19   --pkk--        Updated for deposition DDM
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      real    adjwest(MXCELLS,MXLAYER)
      real    adjeast(MXCELLS,MXLAYER)
      real    adjsouth(MXCELLS,MXLAYER)
      real    adjnorth(MXCELLS,MXLAYER)
      integer nx
      integer ny
      integer nz
      integer nspc
      real    saconc(nx,ny,nz,nspc)
c
c-----------------------------------------------------------------------
c    External functions:
c----------------------------------------------------------------------
c
      logical, external :: isbound
c
c-----------------------------------------------------------------------
c    Local variables:
c----------------------------------------------------------------------
c
      integer iddm, imod , iptr, ioff, nedge, i, j, k
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c  --- loop over all boundary condition sensitivities ---
c
      do iddm = 1, nbcddm
c
c  --- loop over all model species ---
c
         do imod = 1, nspec
c
c  --- loop over all layers ---
c
           do k = 1, nz
c
c  --- do West and East edges ---
c
              do j = 2, ny-1
c
c  --- load the west boundary ---
c
                 if( lbndry ) then
                    ioff = IDXBWS
                 else
                    ioff = 1
                 endif
                 iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                              nicddm + ndepddm + ioff - 1
                 if( .NOT. lmpi .OR.
     &                isbound( mibcon(1),mmxp(1),mmyp(1),1,0 ) ) then
                     saconc(1,j,k,iptr) = saconc(1,j,k,iptr) * adjwest(j,k)
                 endif
c
c  --- load the east boundary ---
c
                 if( lbndry ) then
                     ioff = IDXBES
                 else
                     ioff = 1
                 endif
                 iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                              nicddm + ndepddm + ioff - 1
                 if( .NOT. lmpi .OR.
     &              isbound( mibcon(1),mmxp(1),mmyp(1),mmxp(1),0 ) ) then
                       saconc(nx,j,k,iptr) = saconc(nx,j,k,iptr) * adjeast(j,k)
                 endif
              enddo
c
c  --- do South and North edges ---
c
              do i = 2, nx-1
c
c  --- load the south boundary ---
c
                if( lbndry ) then
                    ioff = IDXBST
                 else
                    ioff = 1
                 endif
                 iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                              nicddm + ndepddm + ioff - 1
                 if( .NOT. lmpi .OR.
     &                   isbound( mibcon(1),mmxp(1),mmyp(1),0,1 ) ) then
                      saconc(i,1,k,iptr) = saconc(i,1,k,iptr) * adjsouth(i,k)
                 endif
c
c  --- load the east boundary ---
c
                 if( lbndry ) then
                     ioff = IDXBNT
                 else
                     ioff = 1
                 endif
                 iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                              nicddm + ndepddm + ioff - 1
                 if( .NOT. lmpi .OR.
     &               isbound( mibcon(1),mmxp(1),mmyp(1),0,mmyp(1) ) ) then
                      saconc(i,ny,k,iptr) = saconc(i,ny,k,iptr) * adjnorth(i,k)
                 endif
              enddo
c
c  --- get the next layer ---
c
           enddo
c
c  --- get the next model species ---
c
         enddo
c
c  --- Get the next DDM boundary sensitivity ---
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine wrtsrf(lsrfmod,ngrd,tim2,idat2,iunit,nox,noy,nspdep,spname,
     &                  solmas,vegmas)
c
c----CAMx v7.40 260801
c 
c     WRTSRF writes surface model mass fields
c 
c      Copyright Ramboll
c           
c     Modifications: 
c     08/26/21 -cemery- RTRAC surface file doubles as (default) dep output
c                       or (flagged) surface model output
c     09/01/21 -cemery- Updated to not write nested grid buffer cells
c 
c     Input arguments:
c        lsrfmod             surface model flag
c        ngrd                grid index
c        tim2                output time (HHMM)
c        idat2               output date (YYJJJ)
c        iunit               output unit
c        nox                 number of cells in x-direction
c        noy                 number of cells in y-direction
c        nspdep              number of dep field species
c        spname              species name array
c        solmas              surface soil mass field to output
c        vegmas              surface veg mass field to output
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c 
      implicit none
c
      include 'camx.inc'
c
      logical lsrfmod
      integer ngrd
      integer idat2, iunit, nox, noy, nspdep
      real tim2
      real solmas(nox,noy,nspdep)
      real vegmas(nox,noy,nspdep)
      character*10 spname(nspdep)
c
      integer nseg, idat1, i, j, n, l
      integer ibegcel,iendcel,jbegcel,jendcel
      real tim1,btim,etim
      character*4 ispec(10)
c
      data nseg /1/
c
c-----Entry point
c
c-----Determine time/date range
c
      idat1 = idat2
      etim = AINT(ANINT(tim2)/100.) + amod(ANINT(tim2),100.)/60.
      btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      if (btim.lt.0.) then
        btim = btim + 24.
        idat1 = idat1 - 1
        if (MOD(idat1,1000) .EQ. 0 ) then
          if ( MOD(INT(idat1/1000)-1,4) .EQ. 0 ) then
            idat1 = (INT(idat1/1000)-1)*1000 + 366
          else
            idat1 = (INT(idat1/1000)-1)*1000 + 365
          end if
        endif
      endif
c
c-----Write the time stamp ---
c
      write(iunit) idat1,btim,idat2,etim
c
c-----Write gridded surface mass field
c
      ibegcel = 1
      iendcel = nox
      jbegcel = 1
      jendcel = noy
      if( ngrd .GT. 1 ) then
        ibegcel = 2
        iendcel = nox-1
        jbegcel = 2
        jendcel = noy-1
      endif

      do l = 1,nspdep
        if (lsrfmod) then
          ispec(1) = 'S'
          ispec(2) = '_'
        else
          ispec(1) = 'D'
          ispec(2) = '_'
        endif
        read(spname(l)(1:8),'(8a1)') (ispec(n),n=3,10)
        write(iunit) nseg,(ispec(n),n=1,10),
     &           ((solmas(i,j,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
      enddo
      do l = 1,nspdep
        if (lsrfmod) then
          ispec(1) = 'V'
          ispec(2) = '_'
        else
          ispec(1) = 'W'
          ispec(2) = '_'
        endif
        read(spname(l)(1:8),'(8a1)') (ispec(n),n=3,10)
        write(iunit) nseg,(ispec(n),n=1,10),
     &           ((vegmas(i,j,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
      enddo
c
      return
      end

      subroutine rd_sa_icfile()
      use tracer
      use grid
      use camxfld
      use chmstry
      use filunit
      implicit none
c     
c----CAMx v7.40 260801
c
c     Reads the source apportionment IC file and loads the values into
c     the tracer concentration array.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c  
c     Input arguments: 
c        none
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        INTRPCNC
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
      include 'camx.inc'
c
c-----Local variables
c
      character*10 spcname
      character*4  icspec(10)
      integer      nx, ny, nz, idat1, idat2, i, j, k, n
      integer      n3d, n4d, ip, ic, ig, igrd, ispc, idum, itr
      real         tim1, tim2, convfac
c
      real cinit(MXCELLS,MXCELLS)
c
c-----Entry point
c
      nx = ncol(1)
      ny = nrow(1)
      nz = nlay(1)
c
c-----Read through the header records to get to the first timestep
c
      rewind(ioric)
      do i=1,4
        read(ioric) 
      enddo
c
c-----Read through coarse grid concentration records until current time/date
c
 100  continue
      read(ioric,end=900) idat1,tim1,idat2,tim2
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      write(iout,'(a40,2(f7.0,i8.5))') 
     &      'Read SA initial condition file at ',tim1,idat1,tim2,idat2
      call flush(iout)
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.ge.time))) then
        do ispc = 1,num_ioric
          do k = 1,nz
            read(ioric) idum,(icspec(n),n=1,10), 
     &                  ((cinit(i,j),i=1,nx),j=1,ny) 
            write(spcname,'(10A1)') (icspec(n),n=1,10)
            do itr = 1,ntotsp
              if( spcname .NE. ptname(itr) ) cycle
              do j = 2,ny-1
                do i = 2,nx-1
                  n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                  n4d = n3d + nx*ny*nz*(itr - 1)
                  ptconc(n4d) = BNDLPT
                  ptconc(n4d) = amax1(ptconc(n4d),cinit(i,j))
                enddo
              enddo
            enddo
          enddo
        enddo
      else
        do ispc = 1,num_ioric
          do k = 1,nz
            read(ioric)
          enddo
        enddo
        goto 100
      endif
c
c-----If this is not a restart, interpolate coarse grid concentrations
c     to all fine grids
c
      if (ngrid.gt.1) then
          do ip = 1,ngrid
            do ic = 1,nchdrn(ip)
              ig = idchdrn(ic,ip)
              call intrpcnc(ntotsp,ncol(ip),nrow(ip),nlay(ip),i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                      ptconc(ipsa3d(ip)),ptconc(ipsa3d(ig)) )
            enddo
          enddo
      endif
c
c-----Convert from ppm to umol/m3
c
      do igrd = 1,ngrid
        nx = ncol(igrd)
        ny = nrow(igrd)
        nz = nlay(igrd)
        do itr = 1,ntotsp
          if( .NOT. lsagas(itr) .OR. ptname(itr)(7:10) .NE. 'IC  ' ) cycle
          do k = 1,nz
            do j = 2,ny-1
              do i = 2,nx-1
                n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                n4d = n3d + nx*ny*nz*(itr - 1)
                convfac = densfac*273./tempk(iptr3d(igrd)-1+n3d)*
     &                        press(iptr3d(igrd)-1+n3d)/1013.
                ptconc(ipsa3d(igrd)-1+n4d) = convfac*
     &                     AMAX1(BNDLPT, ptconc(ipsa3d(igrd)-1+n4d) )
              enddo
            enddo
          enddo
        enddo
      enddo
      goto 999

c-----End of IC file reached
c
 900  write(iout,'(//,a)') 'ERROR in RD_SA_ICFILE:'
      write(iout,*)'End of SA IC file'
      write(iout,*)'Make sure initial condition file contains the ',
     &                                   'simulation beginning hour.'
      call camxerr()
c
 999  continue
c
      return
      end

      subroutine broadcast_grid_dimens(iproc_id,num_procs)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use master_mod
      use node_mod
      use camx_includes
      use grid
c
c  --- for itag only ---
c
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by: 
c       NODES_ALLOC
c    Subroutines called:
c       NODES_PASS
c       NODES_PASS1
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: iproc_id
      integer :: num_procs
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: nm
      integer :: nm2
      integer :: ngr
      integer :: nints
      integer :: i
      integer :: j
c
      logical :: debug = .false.
c
c  --- local buffers for send. ---
c
      integer :: bufferCol(ngrid)
      integer :: bufferRow(ngrid)
      integer :: bufferLay(ngrid)
      integer :: bufferAll(0:num_procs,ngrid, 10)
      integer :: myBuff(2*num_procs)
c
      integer, dimension(5,7,ngrid,num_procs) :: buffer_ipaths
      integer, dimension(5,7,ngrid,num_procs) :: buffer_bpaths
      integer, dimension(6,  ngrid,num_procs) :: buffer_iget_paths
c
      integer :: iunit = 199
c
      logical :: activate_bpaths = .true.
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set up var values for master node ---
c
      if (iproc_id .eq. 0) then
         do nm=1, num_procs
            machs(nm) = nm
         enddo
c
         do ngr=1, ngrid
c
c  --- regular boundary ---
c
            nxbeg (0, ngr) = 1 
            nxend (0, ngr) = ncol(ngr)
            nybeg (0, ngr) = 1
            nyend (0, ngr) = nrow(ngr)
c
c  --- calculated boundary ---
c
            nxbegc(0, ngr) = 2
            nxendc(0, ngr) = ncol(ngr) - 1
            nybegc(0, ngr) = 2
            nyendc(0, ngr) = nrow(ngr) - 1
c
c  --- offset to the parent grid ---
c
            ixoff (0, ngr) = 0 
            iyoff (0, ngr) = 0
c
c  --- boundary flag bit ---
c
            ibcflg(0, ngr) = 1+2+4+8
c
            do nm=0, num_procs
               nodemxp(nm, ngr) = nxend(nm,ngr)-nxbeg(nm, ngr)+1
               nodemyp(nm, ngr) = nyend(nm,ngr)-nybeg(nm, ngr)+1
               nodemzp(nm, ngr) = nlay(ngr)      
               bufferAll(nm,ngr,1)  = nodemxp(nm,ngr)
               bufferAll(nm,ngr,2)  = nodemyp(nm,ngr)
               bufferAll(nm,ngr,3)  = nodemzp(nm,ngr)
               bufferAll(nm,ngr,4)  = nxbegc (nm,ngr)
               bufferAll(nm,ngr,5)  = nxendc (nm,ngr)
               bufferAll(nm,ngr,6)  = nybegc (nm,ngr)
               bufferAll(nm,ngr,7)  = nyendc (nm,ngr)
               bufferAll(nm,ngr,8)  = ixoff  (nm,ngr)
               bufferAll(nm,ngr,9)  = iyoff  (nm,ngr)
               bufferAll(nm,ngr,10) = ibcflg (nm,ngr)
            enddo 
            bufferCol(ngr) = ncol(ngr)
            bufferRow(ngr) = nrow(ngr)
            bufferLay(ngr) = nlay(ngr)
         enddo 
      endif
c
      call nodes_pass(machs,num_procs,MPI_INTEGER,itag,num_procs,iproc_id)
      call nodes_pass(ngrid,        1,MPI_INTEGER,itag,num_procs,iproc_id)
      call nodes_pass(bufferCol,ngrid,MPI_INTEGER,itag,num_procs,iproc_id)
      call nodes_pass(bufferRow,ngrid,MPI_INTEGER,itag,num_procs,iproc_id)
      call nodes_pass(bufferLay,ngrid,MPI_INTEGER,itag,num_procs,iproc_id)
      nints =ngrid*(num_procs+1)*10 
      call nodes_pass(bufferAll,nints,MPI_INTEGER,itag,num_procs,iproc_id)
c
      if (iproc_id .ne. 0) then
         do ngr = 1, ngrid
c
c  --- ncol, nrow, nlay were dynamically allocated ---
c
            ncol(ngr) = bufferCol(ngr)
            nrow(ngr) = bufferRow(ngr)
            nlay(ngr) = bufferLay(ngr)
            do nm=0, num_procs
               nodemxp  (nm,ngr) = bufferAll(nm,ngr,1)
               nodemyp  (nm,ngr) = bufferAll(nm,ngr,2)
               nodemzp  (nm,ngr) = bufferAll(nm,ngr,3)
               nodeia   (nm,ngr) = bufferAll(nm,ngr,4)
               nodeiz   (nm,ngr) = bufferAll(nm,ngr,5)
               nodeja   (nm,ngr) = bufferAll(nm,ngr,6)
               nodejz   (nm,ngr) = bufferAll(nm,ngr,7)
               nodei0   (nm,ngr) = bufferAll(nm,ngr,8)
               nodej0   (nm,ngr) = bufferAll(nm,ngr,9)
               nodeibcon(nm,ngr) = bufferAll(nm,ngr,10)
            enddo
         enddo
         if (nmachs .eq. 0) stop 'nmachs problem in broadcast...dim.f'
         nmachs = num_procs
      endif
c
      do ngr=1,ngrid
         mmxp(ngr)=nodemxp(iproc_id,ngr)        
         mmyp(ngr)=nodemyp(iproc_id,ngr)
         mmzp(ngr)=nodemzp(iproc_id,ngr)
         mia(ngr) =nodeia (iproc_id,ngr)
         miz(ngr) =nodeiz (iproc_id,ngr)
         mja(ngr) =nodeja (iproc_id,ngr)
         mjz(ngr) =nodejz (iproc_id,ngr)
         mi0(ngr) =nodei0 (iproc_id,ngr)
         mj0(ngr) =nodej0 (iproc_id,ngr)
         mibcon(ngr)=nodeibcon(iproc_id,ngr)
      enddo
c
      if (activate_bpaths) then
         do nm=1,num_procs
            if (iproc_id .eq. 0) then
               do i=1, 5
                  do j=1, 7
                     do ngr=1, ngrid
                        do nm2=1, num_procs
                           buffer_bpaths(i,j,ngr,nm2) = 
     &                                       inode_paths_master(i,j,ngr,nm,nm2)
                        enddo
                     enddo
                  enddo
               enddo
            endif
            call nodes_pass1(buffer_bpaths,5*7*ngrid*num_procs,
     &                       MPI_INTEGER,itag,iproc_id,nm      )
         enddo
c
         do i=1, 5
            do j=1, 7
               do ngr=1, ngrid
                  do nm2=1, num_procs
                     bpaths(i,j,ngr,nm2) = buffer_bpaths(i,j,ngr,nm2)
                  enddo
               enddo
            enddo
         enddo
c
         do ngr=2, ngrid
            do nm2=1, num_procs
               bpaths(5,5,ngr,nm2) = nm2
c
c  --- target node ---
c
            enddo
         enddo
      endif
c
      do nm=1,num_procs
         if (iproc_id .eq. 0) then
            do i=1, 5
               do j=1, 7
                  do ngr=1, ngrid
                     do nm2=1, num_procs
                        buffer_ipaths(i,j,ngr,nm2) =
     &                                       inode_paths_master(i,j,ngr,nm2,nm)
                     enddo
                  enddo
               enddo
            enddo
c
            do i=1, 6
               do ngr=1, ngrid
                  do nm2=1, num_procs
                     buffer_iget_paths(i,ngr,nm2) =
     &                                          iget_paths_master(i,ngr,nm2,nm)
                  enddo
               enddo
            enddo
         endif
         call nodes_pass1(buffer_ipaths,  5*7*ngrid*num_procs,
     &                    MPI_INTEGER,itag,iproc_id,nm        )
         call nodes_pass1(buffer_iget_paths,6*ngrid*num_procs,
     &                    MPI_INTEGER,itag,iproc_id,nm        )
       enddo  
c
      do i=1, 5
         do j=1, 7
            do ngr=1, ngrid
               do nm2=1, num_procs
                  ipaths(i,j,ngr,nm2) = buffer_ipaths(i,j,ngr,nm2)
               enddo
            enddo
         enddo
      enddo
c
      do i=1, 6
         do ngr=1, ngrid
            do nm2=1, num_procs
               iget_paths(i,ngr,nm2) = buffer_iget_paths(i,ngr,nm2)
            enddo
         enddo
      enddo
c
      do nm=1, num_procs
         if (iproc_id .eq. 0) then
            do i=1, 2   
               do j=1, num_procs
                  myBuff((i-1)*num_procs+j) = lbc_buffs(i,j,nm) 
               enddo 
            enddo
         endif
         call nodes_pass1(myBuff,2*num_procs,MPI_INTEGER,itag,iproc_id,nm)
         do j=1, num_procs
c
c  --- add 90000 for nbc overflow ---
c
            node_buffs(j)%nsend = 10*myBuff(j) + 90000
c
c  --- multiply 10 to meet the memory size needed by DDM, etc.
c      should change 10 to a variable later ---
c
            node_buffs(j)%nrecv = 10*myBuff(num_procs+j) + 90000
         enddo
      enddo
c
      do nm=1, num_procs
         if (iproc_id .eq. 0) then
            newbuff_nest = newbuff_nest1(nm)
            nbuff_nest   = nbuff_nest1(nm)
         endif
         call nodes_pass1(newbuff_nest,1,MPI_INTEGER,itag,iproc_id,nm)
         call nodes_pass1(nbuff_nest,  1,MPI_INTEGER,itag,iproc_id,nm)
      enddo
c
      if (debug .and. iproc_id .gt. 0) then
         do i=1, 5
            do j=1, 7
               do ngr=1, ngrid
                  do nm=1, num_procs
                     write(iunit,*) 'ipaths: ', i, j, 
     &                                           ngr, nm, ipaths(i,j,ngr,nm)
                  enddo
               enddo
            enddo
         enddo
c
         if (activate_bpaths) then
         do i=1, 5
            do j=1, 7
               do ngr=1, ngrid
                  do nm=1, num_procs
                     write(iunit,*) 'bpaths: ', i, j,
     &                                           ngr, nm, bpaths(i,j,ngr,nm)
                  enddo
               enddo
            enddo
         enddo
         endif
c
         do i=1, 6
            do ngr=1, ngrid
               do nm=1, num_procs
                  write(iunit,*) 'iget_paths: ', i,
     &                                         ngr, nm, iget_paths(i,ngr,nm)
               enddo
            enddo
         enddo
c
         do nm=1, num_procs
            write(iunit,*) "node_buffs(nm)%nsend: ", nm, node_buffs(nm)%nsend
            write(iunit,*) "node_buffs(nm)%nrecv: ", nm, node_buffs(nm)%nrecv
         enddo
         write(iunit,*) "newbuff_nest: ", newbuff_nest
         write(iunit,*) "nbuff_nest  : ", nbuff_nest
         close(iunit)
      endif
c
      return
      end

      subroutine vd_gas_zhang(z2,zl,z0_f,ustar,t2,ts,srad,rh,fcld,pp,
     &                        coszen,mlu,snow,io3,inh3,conc_nh3,henry,henso2,
     &                        f0,diffrat,rscale,lai_f,vd,fnet)
c
c----CAMx v7.40 260801
c 
c     VD_GAS_ZHANG is the driver to interface with the dry deposition module
c     of Zhang et al. (2003) developed by the Meteorological Service of Canada.
c     This routine prepares arguments to be used in the module.
c 
c     The DRYVD module considers fractions of multiple land uses.  Since we
c     call DRYVD for a single landuse and weight appropriately in DRYPEP later,
c     the land use fraction set to be 1 for the current land use category.
c
c     The list of gas species between CAMx and the Canadian model are 
c     not identical.  Any CAMx species not handled by the Canadian model
c     need to have their mesophyll resistances calculated.
c
c      Copyright Ramboll
c           
c     Modifications:
c        08/08/14      Reinstated snow depth calculation per original Zhang
c                      methodology.
c        07/23/18      Updated for Bi-Di NH3 drydep
c
c     Input arguments:
c        z2                  met reference height (m)
c        zl                  Z/L stability parameter
c        z0_f                surface roughness (m)
c        ustar               friction velocity (m/s)
c        t2                  temperature at z2 (K)
c        ts                  surface temperature (K)
c        srad                solar irradiance (W/m2)   
c        rh                  relative humidity (0-1) 
c        fcld                cloud fraction (0-1)
c        pp                  precipitation water content (g/m3)
c        coszen              cosine of solar zenith angle
c        mlu                 land use index (1-26)
c        snow                snow water equivalent (m)
c        io3                 ozone flag
c        inh3                ammonia flag
c        conc_nh3            ambient NH3 concentration (ug/m3)
c        henry               Henry's Law constant (M/atm)
c        henso2              Henry's Law constant of SO2 (M/atm)
c        f0                  Reactivity parameter
c        diffrat             Ratio of diffusivity (H2O:species)
c        rscale              Rs scaling for extremely soluble gasses
c        lai_f               leaf area index
c
c     Output arguments: 
c        vd                  deposition velocity (m/s)
c        fnet                net flux of NH3 exchange (ug/m2-s)
c             
c     Routines called: 
c        DRYVD 
c             
c     Called by: 
c        DRYDEP
c
      implicit none
c
c-----Arguments
c
      integer mlu
      integer io3
      integer inh3
      real z2
      real zl
      real z0_f
      real ustar
      real t2
      real ts
      real*8 srad
      real rh
      real fcld
      real pp
      real*8 coszen
      real snow
      real conc_nh3
      real henry
      real henso2
      real lai_f
      real f0,diffrat,rscale
      real vd
      real fnet
c
c-----Local variables
c
      real rhoh2o,diffh2o,rmin,rmax,sd,volrat,prec,alpha,beta,rm,di
      real*8 vdg

      real*8 z2_tmp,zl_tmp,z0_f_tmp,ustar_tmp,sd_tmp,t2_tmp
      real*8 ts_tmp,rh_tmp,fcld_tmp,prec_tmp
      real*8 rm_tmp,alpha_tmp,beta_tmp,di_tmp,lai_f_tmp,rscalsp_tmp,
     &       henry_tmp
      real*8 cnh3_tmp,fnet_tmp
c
c-----Data statements
c 
      data rhoh2o  /1.e6/         ! water density (g/m3)
      data diffh2o /2.30e-05/     ! water diffusivity (m2/s)
      data rmin/1.0/, rmax/100./  !min/max resistances (s/m)
c
c-----Entry point
c
c-----Set snow depth (cm)
c
      sd = snow*1000.  ! *100 for m->cm, *10 for SWE->depth
c
c-----Set precipitation rate
c
      volrat = pp/rhoh2o
      prec = (volrat/1.0e-7)**1.27    ! precipitation rate (mm/hr) 
c
c-----Set deposition params for species.
c     Mesophyll resistance follows Wesely (1989)
c
      alpha = henry/henso2
      beta = f0
      rm = 1./(henry/3000. + 100.*f0) 
      rm = max1(rmin,rm)
      rm = min1(rmax,rm)
c
c-----Set diffusivity of gas species
c
      di = diffh2o/diffrat      ! m2/s
      di = di*1.e4              ! cm2/s
c
c-----Call dry deposition velocity algorithm
c
      z2_tmp = z2
      zl_tmp = zl
      z0_f_tmp = z0_f
      ustar_tmp = ustar
      sd_tmp = sd
      t2_tmp = t2
      ts_tmp = ts
      rh_tmp = rh
      fcld_tmp = fcld
      prec_tmp = prec
      rm_tmp = rm
      alpha_tmp = alpha
      beta_tmp = beta
      di_tmp = di
      lai_f_tmp = lai_f
      rscalsp_tmp = rscale
      henry_tmp = henry
      cnh3_tmp = conc_nh3
      call drygas(z2_tmp,zl_tmp,z0_f_tmp,ustar_tmp,sd_tmp,
     &            t2_tmp,ts_tmp,srad,rh_tmp,fcld_tmp,prec_tmp,coszen,
     &            mlu,rm_tmp,alpha_tmp,beta_tmp,di_tmp,vdg,
     &            lai_f_tmp,rscalsp_tmp,henry_tmp,io3,inh3,cnh3_tmp,
     &            fnet_tmp)
      vd = vdg
      fnet = fnet_tmp
c
      return
      end
C
C=======================================================================
C
      subroutine drygas(z2,zl,z0_f,ustar,sd,t2,ts,srad,rh,fcld,prec,
     &                 coszen,mlu,rm,alpha,beta,di,vdg,lai_f,rscalsp,
     &                 henry,io3,inh3,c_nh3,f_net)
C
C-----------------------------------------------------------------------
C    References: 
C      Zhang et al., 2003.  Atmos. Chem. Phys. 3, 2067-2082 
C
C
C     LUC No.     Vegetation type
C     =====       ===============
C       1         water
C       2         ice
C       3         inland lake
C       4         evergreen needleleaf trees
C       5         evergreen broadleaf trees
C       6         deciduous needleleaf trees
C       7         deciduous broadleaf trees
C       8         tropical broadleaf trees
C       9         drought deciduous trees
C       10        evergreen broadleaf shrub
C       11        deciduous shrubs
C       12        thorn shrubs
C       13        short grass and forbs
C       14        long grass
C       15        crops
C       16        rice
C       17        sugar
C       18        maize
C       19        cotton
C       20        irrigated crops
C       21        urban
C       22        tundra
C       23        swamp
C       24        desert
C       25        mixed wood forests
C       26        transitional forest 
C-----------------------------------------------------------------------
C        KEY   VARIABLES
C-----------------------------------------------------------------------
C  ARGUMENTS:
C  z2       | Met reference height (m)
C  zl       | Z/L stability parameter
C  z0_f     | Surface roughness (m)
C  ustar    | friction velocity (m/s)
C  t2       | Temperature at Z2 (K)      
C  ts       | Surface temperature (K)             
C  srad     | Solar irradiance (w/m2)          
C  rh       | relative humidity (0.0-1.0)                
C  fcld     | Cloud fraction (0-1)              
C  prec     | hourly precipitation (mm/hour) 
C  sd       | Snow depth        (cm)
C  coszen   | Cosine of solar zenith angle
C  mlu      | Land Use type          
C  rm       | mesophyll resistance (s/m)           
C  alpha    | Scaling factor based on SO2 (no unit) 
C  beta     | Scaling factor based on O3  (no unit) 
C  di       | Gas diffusivity (cm2/s)
C  vdg      | gaseous dry deposition velocity (m/s) 
C  lai_f    | Leaf area index
C  rscalsp  | Scaling factor for highly soluble species
C  henry    | Henry's Law solubility
c  io3      | Ozone flag
c  inh3     | Ammonia flag
c  c_nh3    | NH3 concentration in the air (ug/m3)
c  f_net    | Net flux of NH3 exchange (ug/m2-s)
C
C  LOCAL VARIABLES:
C  brs      | Constant for stomatal resistance(W/m2)
C  bvpd     | Constant for water vapor pressure deficit  (kPa^-1)                   
C  fsun     | fraction of sunlit leaves (0.0-LAI)  
C  pardir   | visible beam radiation (W/m2)         
C  pardif   | diffuse visible radiation (W/m2)     
C  psi1     | Constant for leaf water potential(Mpa)
C  psi2     | Constant for leaf water potential(Mpa)
C  fsnow    | Snow fraction  (0-1)              
C  ra       | Aerodynamic resistance (s/m)         
C  racz     | IN-canopy aerodynamic resistance (s/m)         
C  rb       | quasi-laminar resistance (s/m)      
C  rc       | total surface resistance (s/m)     
C  rcut     | cuticle resistance (s/m )              
C  rcutdo   | Dry cuticle resistance for O3 (s/m)  
C  rcutds   | Dry cuticle resistance for SO2 (s/m)
C  rcutwo   | Wet cuticle resistance for O3 (s/m)  
C  rg       | Ground  resistance (s/m )                
C  rgo      | Ground  resistance for O3 (s/m)  
C  rgs      | Ground  resistance for SO2 (s/m) 
C  rsmin    | minimum stomatal resistance (s/m)    
C  rst      | Stomatal resistance (s/m)
C  sdmax    | Maximum snow depth over which snow
C           |   fraction for leaves is 1 (cm )
C  tmin     | Minimum temperature for stomatal opening (C)
C  tmax     | Maxmum temperature for stomatal opening (C)
C  topt     | Optimum temperature for stomatal opening (C) 
C  wst      | fraction of stomatal closure under wet conditions (0.0-0.5)
C  vdg      | gas dry deposition velocity (m/s)
C
C-----------------------------------------------------------------------
C
      implicit none
      include 'camx.prm'
      include 'deposit.inc'
c
c-----Arguments 
c
      integer mlu,io3,inh3
      real*8 z2
      real*8 zl
      real*8 z0_f
      real*8 ustar
      real*8 sd
      real*8 t2
      real*8 ts
      real*8 srad
      real*8 rh
      real*8 fcld 
      real*8 prec
      real*8 coszen
      real*8 rm
      real*8 alpha
      real*8 beta
      real*8 di
      real*8 rscalsp
      real*8 lai_f
      real*8 henry
      real*8 vdg
      real*8 c_nh3
      real*8 f_net
c
c-----Local variables for gaseous Vd submoudle 
c
      integer i
      real*8 es,temp,dair,dh2o,ra,rst,rdu,rdv,ww,rdm,
     &     rdn,rv,rn,ratio,sv,fv,pardir,pardif
      real*8 pshad,psun,rshad,rsun,gshad,gsun,fsun,fshd,gspar,t,bt,gt,
     &     d0,gd,psi,gw,coedew,dq,usmin,wst,racz,rgo_f,rgs_f
      real*8 rcuto_f,rcuts_f,fsnow,rsnows,vi,rb,dvh2o,rs,rcut,rg,rc
      real*8 tmax(NLUZ03),tmin(NLUZ03),topt(NLUZ03),rsmin(NLUZ03),
     &     brs(NLUZ03),bvpd(NLUZ03),psi1(NLUZ03),psi2(NLUZ03),
     &     rac1(NLUZ03),rac2(NLUZ03),rgo(NLUZ03),rgs(NLUZ03),
     &     rcutdo(NLUZ03),rcutwo(NLUZ03),rcutds(NLUZ03),sdmax(NLUZ03)
      logical is_rain,is_dew
c
c-----Parameters for Bi-Di NH3 drydep
c     Whaley et al., 2018 (https://doi.org/10.5194/acp-18-2011-2018)
c
      real*8, parameter :: CP_A = 2.7457D15 ! Constant A for Compensation Point Eq [K-ug/m3]
      real*8, parameter :: CP_B = 10378.D0  ! Constant B for Compensation Point Eq [K]
      real*8, parameter :: gamst(NLUZ03) = (/         ! Stomatal emission potential for NH3 [(mol/L)/(mol/L)]
     &      0.D0,    0.D0,    0.D0, 3000.D0, 3000.D0, !   LU# 01 - 05
     &    300.D0,  300.D0,  300.D0,  300.D0,  300.D0, !   LU# 06 - 10
     &    300.D0,  300.D0,  300.D0,  300.D0,  800.D0, !   LU# 11 - 15
     &    800.D0,  800.D0,  800.D0,  800.D0,  800.D0, !   LU# 16 - 20
     &      0.D0,   20.D0,  100.D0,    0.D0, 1000.D0, !   LU# 21 - 25
     &    300.D0 /)                                   !   LU# 26
      real*8, parameter :: gamg(NLUZ03)  = (/         ! Ground emission potential for NH3 [(mol/L)/(mol/L)]
     &      0.D0,    0.D0,    0.D0, 1000.D0, 1000.D0, !   LU# 01 - 05
     &   1000.D0,  200.D0,   20.D0,  500.D0,   20.D0, !   LU# 06 - 10
     &    200.D0,   20.D0, 2000.D0, 2000.D0,  800.D0, !   LU# 11 - 15
     &    800.D0,  800.D0,  800.D0,  800.D0,  800.D0, !   LU# 16 - 20
     &      0.D0,   20.D0,   20.D0,    0.D0, 1000.D0, !   LU# 21 - 25
     &     20.D0 /)                                   !   LU# 26
      real*8 :: x_st, x_g, x_c                        ! Compensation point conc [ug/m3]
      real*8 :: Rabi, Rsi, Racgi, Rcuti               ! Inverse resistance terms
C
C   In-canopy aerodynamic resistance  [s/m].
C   Rac1 and Rac2 are minimum and maximum Rac0 for each LUC. 
C
      DATA   Rac1            /
     &  0   ,  0   ,  0   ,  100 ,  250 , 
     &  60  ,  100 ,  300 ,  100 ,  60  ,
     &  20  ,  40  ,  20  ,  10  ,  10  ,
     &  10  ,  10  ,  10  ,  10  ,  20  ,
     &  40  ,  0   ,  20  ,  0   ,  100 ,
     &  100    /
      DATA   Rac2            /
     &  0   ,  0   ,  0   ,  100 ,  250 , 
     &  100 ,  250 ,  300 ,  100 ,  60  ,
     &  60  ,  40  ,  20  ,  40  ,  40  ,
     &  40  ,  40  ,  50  ,  40  ,  20  ,
     &  40  ,  0   ,  20  ,  0   ,  100 ,
     &  100    /
C
C   Dry and wet cuticle resistance for O3  [s/m].
C
      DATA   RcutdO          /
     & -999 , -999 , -999 , 4000 , 6000 , 
     & 4000 , 6000 , 6000 , 8000 , 6000 ,
     & 5000 , 5000 , 4000 , 4000 , 4000 ,
     & 4000 , 4000 , 5000 , 5000 , 4000 ,
     & 6000 , 8000 , 5000 , -999 , 4000 ,
     & 4000    /
      DATA   RcutwO          /
     & -999 , -999 , -999 ,  200 ,  400 , 
     &  200 ,  400 ,  400 ,  400 ,  400 ,
     &  300 ,  300 ,  200 ,  200 ,  200 ,
     &  200 ,  200 ,  300 ,  300 ,  200 ,
     &  400 ,  400 ,  300 , -999 ,  200 ,
     &  200    /
C
C   Ground resistance for O3  [s/m].
C
      DATA   RgO            /
     & 2000 , 2000 , 2000 ,  200 ,  200 , 
     &  200 ,  200 ,  200 ,  200 ,  200 ,
     &  200 ,  200 ,  200 ,  200 ,  200 ,
     &  200 ,  200 ,  200 ,  200 ,  500 ,
     &  500 ,  500 ,  500 ,  500 ,  200 ,
     &  200    /
C
C   Dry cuticle resistance for SO2  [s/m].
C
      DATA   RcutdS          /
     & -999 , -999 , -999 , 2000 , 2500 , 
     & 2000 , 2500 , 2500 , 6000 , 2000 ,
     & 2000 , 2000 , 1000 , 1000 , 1500 ,
     & 1500 , 2000 , 2000 , 2000 , 2000 ,
     & 4000 , 2000 , 1500 , -999 , 2500 ,
     & 2500    /
C
C   Ground resistance for SO2  [s/m].
C
      DATA   RgS            /
     &   20 ,   70 ,  20  ,  200 ,  100 , 
     &  200 ,  200 ,  100 ,  300 ,  200 ,
     &  200 ,  200 ,  200 ,  200 ,  200 ,
     &   50 ,  200 ,  200 ,  200 ,   50 ,
     &  300 ,  300 ,   50 ,  700 ,  200 ,
     &  200    /
C
C   Stomatal resistance related parameters. 
C   In sequence: rsmin, brs, tmin, tmax, topt, bvpd, psi1, psi2
C
      DATA   rsmin            /
     & -999 , -999 , -999 ,  250 ,  150 , 
     &  250 ,  150 ,  150 ,  250 ,  150 , 
     &  150 ,  250 ,  150 ,  100 ,  120 , 
     &  120 ,  120 ,  250 ,  125 ,  150 ,
     &  200 ,  150 ,  150 , -999 ,  150 , 
     &  150   /
      DATA   brs              /
     & -999 , -999 , -999 ,   44 ,   40 , 
     &   44 ,   43 ,   40 ,   44 ,   40 , 
     &   44 ,   44 ,   50 ,   20 ,   40 , 
     &   40 ,   50 ,   65 ,   65 ,   40 , 
     &   42 ,   25 ,   40 , -999 ,   44 , 
     &   43   /
      DATA   tmin             /
     & -999 , -999 , -999 ,   -5 ,    0 , 
     &   -5 ,    0 ,    0 ,    0 ,    0 , 
     &   -5 ,    0 ,    5 ,    5 ,    5 , 
     &    5 ,    5 ,    5 ,   10 ,    5 , 
     &    0 ,   -5 ,    0 , -999 ,   -3 , 
     &    0   /
      DATA   tmax             /
     & -999 , -999 , -999 ,   40 ,   45 , 
     &   40 ,   45 ,   45 ,   45 ,   45 , 
     &   40 ,   45 ,   40 ,   45 ,   45 , 
     &   45 ,   45 ,   45 ,   45 ,   45 , 
     &   45 ,   40 ,   45 , -999 ,   42 , 
     &   45   /
      DATA   topt             /
     & -999 , -999 , -999 ,   15 ,   30 , 
     &   15 ,   27 ,   30 ,   25 ,   30 , 
     &   15 ,   25 ,   30 ,   25 ,   27 , 
     &   27 ,   25 ,   25 ,   30 ,   25 , 
     &   22 ,   20 ,   20 , -999 ,   21 , 
     &   25   /
      DATA   bvpd             /
     & -999 , -999 , -999 ,  0.31,  0.27, 
     &  0.31,  0.36,  0.27,  0.31,  0.27,  
     &  0.27,  0.27,  0.0 ,  0.0 ,  0.0 ,  
     &  0.0 ,  0.0 ,  0.0 ,  0.0 ,  0.0 ,  
     &  0.31,  0.24,  0.27, -999 ,  0.34, 
     &  0.31   /
      DATA   psi1            /
     & -999 , -999 , -999 , -2.0 , -1.0 , 
     & -2.0 , -1.9 , -1.0 , -1.0 , -2.0 ,
     & -2.0 , -2.0 , -1.5 , -1.5 , -1.5 ,
     & -1.5 , -1.5 , -1.5 , -1.5 , -1.5 ,
     & -1.5 ,    0 , -1.5 , -999 , -2.0 ,
     & -2.0    /
      DATA   psi2            /
     & -999 , -999 , -999 , -2.5 , -5.0 , 
     & -2.5 , -2.5 , -5.0 , -4.0 , -4.0 ,
     & -4.0 , -3.5 , -2.5 , -2.5 , -2.5 ,
     & -2.5 , -2.5 , -2.5 , -2.5 , -2.5 ,
     & -3.0 , -1.5 , -2.5 , -999 , -2.5 ,
     & -3.0    /
C
C     Maximum snow depth over which snow fraction for leaves is 1.0
C     Snow fraction for ground is treated 2 times of that for leaves
C
      DATA SDMAX  / 
     &              9999. ,  10.  , 9999. ,  200. ,  200. ,
     &               200. , 200.  ,  200. ,  200. ,   30. ,
     &                20. ,  30.  ,   10. ,   20. ,   10. ,
     &                10. ,  10.  ,   10. ,   10. ,   10. ,
     &               200. ,  10.  ,   10. ,   10. ,  200. ,
     &               200.        /
C
C --- Define the function for saturation vapor pressure (mb) 
C
      ES(TEMP) = 6.108*EXP(17.27*(TEMP - 273.16)/(TEMP - 35.86))
C
C   Some constants 
C
      dair=0.369*29.+6.29  
      dh2o=0.369*18.+6.29

      VDG = 0.0
      I = MLU
C
C     Aerodynamic resistance above canopy
C
      IF(ZL.GE.0.) THEN
          Ra=(.74*DLOG(Z2/Z0_F)+4.7*ZL)/0.4/USTAR 
      ELSE
          Ra=0.74/0.4/USTAR*(DLOG(Z2/Z0_F)-
     &          2*DLOG((1+SQRT(1-9.*ZL))*0.5))
      ENDIF
      Ra=dmax1(Ra,dble(5.0))
      if (I.EQ.1.OR.I.EQ.3) THEN
        Ra=dmin1(Ra,dble(2000.))
      else
        Ra=dmin1(Ra,dble(1000.))
      end if 
C
C --- STOMATAL RESISTANCE FOR WATER VAPOR ONLY. STEPS FOR CALCULATING:
C     1. Calculate direct and diffuse PAR from solar radiation
C     2. Calculate sunlit and shaded leaf area, PAR for sunlit and shaded leafs 
C     3. Calculate stomatal conductance 
C     4. Calculate stomatal resistance for water vapor
C
C --- Set a big value for stomatal resistance when stomata are closed
      RST=99999.9        
C
C --  Only calculate stomatal resistance if there is solar radiation, 
C     leaf area index is not zero, and within reasonable temperature range
C
      IF ( SRAD.GE.0.1             .AND.
     &     TS.LT.(Tmax(I)+273.15)  .AND. 
     &     TS.GT.(Tmin(I)+273.15)  .AND.  
     &     LAI_F.GT.0.001           .AND.
     &     COSZEN.GT.0.001               ) THEN

C --  Calculate direct and diffuse PAR from solar radiation and solar zenith angle
 
      RDU=600.*EXP(-0.185/COSZEN)*COSZEN
      RDV=0.4*(600.-RDU)*COSZEN
      WW=-DLOG(COSZEN)/2.302585  
      WW=-1.195+0.4459*WW-0.0345*WW**2
      WW=1320*10**WW
      RDM=(720.*EXP(-0.06/COSZEN)-WW)*COSZEN
      RDN=0.6*(720-RDM-WW)*COSZEN
      RV=dmax1(dble(0.1),RDU+RDV) 
      RN=dmax1(dble(0.01),RDM+RDN) 
      RATIO=dmin1(dble(0.9),SRAD/(RV+RN))
      SV=RATIO*RV                            ! Total PAR 
      FV=dmin1(dble(0.99), (0.9-RATIO)/0.7)  
      FV=dmax1(dble(0.01),RDU/RV*(1.0-FV**0.6667))  !fraction of PAR in the direct beam 
      PARDIR=FV*SV                           ! PAR from direct radiation 
      PARDIF=SV-PARDIR                       ! PAR from diffuse radiation 
c  
C -- Calculate sunlit and shaded leaf area, PAR for sunlit and shaded leaves 
C
      IF (LAI_F.GT.2.5.AND.SRAD.GT.200.) THEN
      PSHAD=PARDIF*EXP(-0.5*LAI_F**0.8)
     & +0.07*PARDIR*(1.1-0.1*LAI_F)*EXP(-COSZEN)
      PSUN=PARDIR**0.8*.5/COSZEN+PSHAD
      ELSE
      PSHAD=PARDIF*EXP(-0.5*LAI_F**0.7)
     & +0.07*PARDIR*(1.1-0.1*LAI_F)*EXP(-COSZEN)
      PSUN=PARDIR*.5/COSZEN+PSHAD
      END IF
      RSHAD=RSmin(I)+BRS(I)*RSMIN(I)/PSHAD 
      RSUN=RSmin(I)+BRS(I)*RSMIN(I)/PSUN
      GSHAD=1./RSHAD
      GSUN=1./RSUN
      FSUN=2*COSZEN*(1.-EXP(-0.5*LAI_F/COSZEN))  ! Sunlit leaf area 
      FSHD=LAI_F-FSUN                    ! Shaded leaf area 

C -- Stomatal conductance before including effects of temperature, 
C                   vapor pressure defict and water stress.

      GSPAR=FSUN*GSUN+FSHD*GSHAD     

C --  function for temperature effect
      T=TS-273.15      
      BT=(Tmax(I)-TOPT(I))/(TMAX(I)-Tmin(I))
      GT=(Tmax(I)-T)/(TMAX(I)-TOPT(I))
      GT=GT**BT
      GT=GT*(T-Tmin(I))/(TOPT(I)-TMIN(I))  
C --  function for vapor pressure deficit 
      D0= ES(TS)*(1.- RH)/10.           !kPa 
      GD=1.-BVPD(I)*D0
C --  function for water stress 
      PSI=(-0.72-0.0013*SRAD)
c      PSI_S=(-0.395-0.043*(TS-273.15))*102.
      GW=(PSI-PSI2(I))/(PSI1(I)-PSI2(I))
      IF (GW.GT.1.0) GW=1.0
      IF (GW.LT.0.1) GW=0.1
      IF (GD.GT.1.0) GD=1.0
      IF (GD.LT.0.1) GD=0.1
C --  Stomatal resistance for water vapor 
      RST=1.0/(GSPAR*GT*GD*GW)    

      END IF
C
c   Decide if dew or rain occurs.
C
      IF (FCLD.LT.0.25) THEN
        Coedew=0.3  
      ELSE  IF (FCLD.GE.0.25.AND.FCLD.LT.0.75) THEN 
         Coedew=0.2  
      ELSE
        Coedew=0.1  
      END IF
         DQ=0.622/1000. * ES(TS)*(1.- RH)*1000.    ! unit g/kg 
	 DQ=dmax1(dble(0.0001),DQ)
         USMIN=1.5/DQ*Coedew  
 
      is_rain = .false.
      is_dew = .false.
      IF (TS.GT.273.15 .AND. PREC.GT.0.20) then
        is_rain = .true. 
      ELSE IF (TS.GT.273.15 .AND. USTAR.LT.USMIN)THEN 
        is_dew = .true. 
!bk - confirm these lines are redundant and remove
!bk      ELSE
!bk        is_rain = .false. 
!bk        is_dew = .false. 
      END IF
C
C   Decide fraction of stomatal blocking due to wet conditions 
C 
      Wst=0.
      if ((is_dew.or.is_rain).and.SRAD.GT.200.) then
      Wst=(SRAD-200.)/800.
      Wst=dmin1(Wst, dble(0.5)) 
      end if 
C
C -- In-canopy aerodynamic resistance 
C
        Racz = Rac1(I)+(LAI_F-lai_ref(I,14))/(lai_ref(I,15)
     &        -lai_ref(I,14)+1.D-10)*(Rac2(I)-Rac1(I)) 
        Racz = Racz*LAI_F**0.25/USTAR/USTAR 
C
C -- Ground resistance for O3 
C
      IF (I.GE.4.AND.TS.LT.272.15) THEN 
        RgO_F = dmin1( RgO(I)*2., RgO(I) * exp(0.2*(272.15-TS))) 
      ELSE
        RgO_F = RgO(I)
      END IF
C
C -- Ground resistance for SO2 
C
      IF (I.EQ.2) THEN 
	RgS_F = DMIN1(RgS(I)*(275.15-TS), dble(500.)) 
	RgS_F = DMAX1(RgS(I), dble(100.)) 
      ELSE IF (I.GE.4.AND.is_rain) THEN
        RgS_F = 50. 
      ELSE IF (I.GE.4.AND.is_dew) THEN
        RgS_F = 100. 
      ELSE IF (I.GE.4.AND.TS.LT.272.15) THEN
        RgS_F = dmin1( RgS(I)*2., RgS(I) * exp(0.2*(272.15-TS))) 
      ELSE 
        RgS_F =  RgS(I)
      END IF
C
C -- Cuticle resistance for O3 AND SO2  
C
      IF (RcutdO(I).LE.-1) THEN 
	RcutO_F = 1.E25 
	RcutS_F = 1.E25 
      ELSE IF (is_rain) THEN
	RcutO_F = RcutwO(I)/LAI_F**0.5/USTAR 
	RcutS_F = 50./LAI_F**0.5/USTAR 
	RcutS_F = DMAX1(RcutS_F, dble(20.)) 
      ELSE IF (is_dew) THEN
	RcutO_F = RcutwO(I)/LAI_F**0.5/USTAR 
	RcutS_F = 100./LAI_F**0.5/USTAR 
	RcutS_F = DMAX1(RcutS_F, dble(20.)) 
      ELSE IF (TS.LT.272.15) THEN
	RcutO_F = RcutdO(I)/exp(3.*RH)/LAI_F**0.25/USTAR 
	RcutS_F = RcutdS(I)/exp(3.*RH)/LAI_F**0.25/USTAR 
        RcutO_F = dmin1( RcutO_F*2., RcutO_F * exp(0.2*(272.15-TS))) 
        RcutS_F = dmin1( RcutS_F*2., RcutS_F * exp(0.2*(272.15-TS))) 
	RcutO_F = DMAX1(RcutO_F,dble(100.)) 
	RcutS_F = DMAX1(RcutS_F,dble(100.)) 
      ELSE 
	RcutO_F = RcutdO(I)/exp(3.*RH)/LAI_F**0.25/USTAR 
	RcutS_F = RcutdS(I)/exp(3.*RH)/LAI_F**0.25/USTAR 
	RcutO_F = DMAX1(RcutO_F,dble(100.)) 
	RcutS_F = DMAX1(RcutS_F,dble(100.)) 
      END IF
C
C If snow occurs, Rg and Rcut are adjusted by snow cover fraction
C
      fsnow= sd/sdmax(i)
      fsnow= dmin1(dble(1.0), fsnow)   !snow cover fraction for leaves 
      If (fsnow.GT.0.0001.and.I.GE.4) THEN
        RsnowS= DMIN1(70.*(275.15-TS), dble(500.)) 
        RsnowS= DMAX1(RSnowS, dble(100.)) 
        RcutS_F=1.0/((1.-fsnow)/RcutS_F+fsnow/RsnowS) 
        RcutO_F=1.0/((1.-fsnow)/RcutO_F+fsnow/2000.) 
        fsnow= dmin1(dble(1.0), fsnow*2.)   !snow cover fraction for ground 
        RgS_F=1.0/((1.-fsnow)/RgS_F+fsnow/RsnowS) 
        RgO_F=1.0/((1.-fsnow)/RgO_F+fsnow/2000.) 
      END IF

C
C -- Calculate diffusivity for each gas species
C
      VI=145.8*1.E-4*(TS*0.5+T2*0.5)**1.5/
     &                  (TS*0.5+T2*0.5+110.4)
C
C -- Calculate quasi-laminar resistance 
C
      Rb =5./USTAR*(VI/DI)**.666667   
C
C -- Calculate stomatal resistance for each species from the ratio of
C       diffusity of water vapor to the gas species
C
      DVh2o=0.001*TS**1.75*SQRT((29.+18.)/29./18.)
      DVh2o=DVh2o/(dair**0.3333+dh2o**0.3333)**2
      RS=RST*DVh2o/DI+RM 
C
C -- Scale cuticle and ground resistances for each species 
C
      Rcut = 1./(ALPHA/RcutS_F+BETA/RcutO_F)
      Rg = 1./(ALPHA/RgS_F+BETA/RgO_F)
C
C -- Bi-Directional NH3 flux calculation
C
      if (inh3.eq.1) then
        if (LAI_F.lt.0.5) then ! set a minimum LAI for stomatal exchange
          x_st = 0.D0
        else
          x_st = (CP_A/T2)*EXP(-CP_B/T2)*gamst(i)
        endif
        if (sd.gt.0.) then ! if there is snow cover
          x_g = 0.D0
	  else
          x_g = (CP_A/TS)*EXP(-CP_B/TS)*gamg(i)
        endif

        Rabi  = 1.D0/(Ra + Rb)
        Rsi   = (1.D0 - Wst)/Rs ! bkoo - verify with Leiming!
        Racgi = 1.D0/(Racz + Rg)
        Rcuti = 1.D0/Rcut

        if (i.ge.13 .and. i.le.20) then
          Rc = Rsi + Racgi + Rcuti
          Rc = dmax1(dble(10.0),1./Rc) !Set minimum surface resistance as 10 s/m
          VDG = 1.D0/(Ra + Rb + Rc)
          f_net = 0.D0
        else
          x_c = ((c_nh3*Rabi) + (x_st*Rsi) + (x_g*Racgi)) /
     &                 (Rabi + Rsi + Racgi + Rcuti)
          f_net = -(c_nh3 - x_c) * Rabi ! net flux [ug/m2-s] (positive flux = emiss)
          VDG = MAX( -f_net / c_nh3, 0.D0 )
          f_net = MAX( f_net, 0.D0 )
        endif
        RETURN
      endif
C
C -- Calculate total surface resistance  
C
      Rc = (1.-Wst)/Rs+1./(Racz+Rg)+1./Rcut 
      Rc=dmax1(dble(10.0),1./Rc)        !Set minimum surface resistance as 10 s/m 
      if (io3.eq.1 .and. i.eq.1) then
        Rc = 1./(1.d-4 + 5.0d-6*henry*ustar*(ts-273.15)**3.)
        Rc = dmax1(Rc,dble(1500.))
      endif
      Rc=Rc*rscalsp               !Scale for the extremely soluble gas
C
C -- Deposition velocity 
C
      VDG = 1./(RA+RB+RC)    

      RETURN
      END

c**** NCF_WRT_DATA_GRIDSMP
c
      subroutine ncf_wrt_data_gridsmp(action,iounit,grid_ncol,grid_nrow,
     &                       grid_xorig,grid_yorig,grid_deltax,grid_deltay)
      use ncf_iomod
      use filunit
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the variable data for the grid definiton 
c    variables to the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action      C name of file to open
c           iounit      I NetCDF file ID of file
c           grid_ncol   I number of grid cells in X direction
c           grid_nrow   I number of grid cells in Y direction
c           grid_xorig  R X coordinate of grid origin      
c           grid_yorig  R Y coordinate of grid origin      
c           grid_deltax R cell width in X direction
c           grid_deltay R cell width in Y direction
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
      integer       grid_ncol
      integer       grid_nrow
      real          grid_xorig
      real          grid_yorig
      real          grid_deltax
      real          grid_deltay
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 this_var
      real*8,       allocatable, dimension(:)   :: darray_1d
      real*8,       allocatable, dimension(:,:) :: darray_2d
      real,         allocatable, dimension(:,:) :: grid_lat
      real,         allocatable, dimension(:,:) :: grid_lon
      real,         allocatable, dimension(:,:) :: grid_mapscl
      real,         allocatable, dimension(:)   :: grid_xsize
      real          grid_ysize
      integer,      allocatable, dimension(:)   :: iarray_1d
      integer       this_varid, icol, irow, ilay, ierr, nlays
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- allocate the arrays for lat/lon for this grid ---
c
      allocate( grid_lat(grid_ncol,grid_nrow) )
      allocate( grid_lon(grid_ncol,grid_nrow) )
      allocate( grid_mapscl(grid_ncol,grid_nrow) )
      allocate( grid_xsize(grid_nrow) )
c
c  --- call routine to fill values ---
c
      if( llatlon ) then
          call grdprep(grid_ncol,grid_nrow,grid_lon,grid_lat,
     &       grid_mapscl,grid_xorig,grid_yorig,grid_deltax,
     &                         grid_deltay,grid_xsize,grid_ysize)
      else
          call grdprep(grid_ncol,grid_nrow,grid_lon,grid_lat,
     &       grid_mapscl,grid_xorig/1000.,grid_yorig/1000.,
     &            grid_deltax/1000.,grid_deltay/1000.,grid_xsize,grid_ysize)
      endif
c
c  --- variable for X coordinates ---
c
      this_var = "X"
      allocate( darray_1d(grid_ncol) )
      do icol=1,grid_ncol
        darray_1d(icol) = DBLE((grid_xorig + 
     &                           (REAL(icol)-0.5)*grid_deltax)/1000.)
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( darray_1d )
c
c  --- variable for Y coordinates ---
c
      this_var = "Y"
      allocate( darray_1d(grid_nrow) )
      do irow=1,grid_nrow
        darray_1d(irow) = DBLE((grid_yorig + 
     &                           (REAL(irow)-0.5)*grid_deltay)/1000.)
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( darray_1d )
c
c  --- variable for Layer heights ---
c
      this_var = "layer"
      allocate( iarray_1d(1) )
      iarray_1d(1) = 1
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_int(iounit,this_varid,iarray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( iarray_1d )
c
c  --- variable for longitude coordinates ---
c
      allocate( darray_2d(grid_ncol,grid_nrow) )
c
      this_var = "longitude"
      do icol=1,grid_ncol
        do irow=1,grid_nrow
           darray_2d(icol,irow) = DBLE(grid_lon(icol,irow))
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
c
c  --- variable for latitude coordinates ---
c
      this_var = "latitude"
      do icol=1,grid_ncol
        do irow=1,grid_nrow
           darray_2d(icol,irow) = DBLE(grid_lat(icol,irow))
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
c
c  --- deallocate local arrays ---
c
      deallocate( darray_2d )
      deallocate( grid_lat )
      deallocate( grid_lon )
      deallocate( grid_mapscl )
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot write data for the variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c**** NCF_SET_SPECATT_DEP
c
      subroutine ncf_set_specatt_dep(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the species varaible attributes for the deposition
c   output NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c       Outputs:
c            spec_units     C array of units for this each species
c            spec_long_name C array of "long names" for each each species
c            spec_desc      C array of desciption for this each species
c            spec_coords    C array of coordinates for this each species
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       character*20 spec_units(*)
       character*20 spec_long_name(*)
       character*60 spec_desc(*)
       character*60 spec_coords(*)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer l
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      do l = 1,ndepspc
        if( ldepmap(l) .GT. 0 ) then
c
           spec_units(l) = "m s-1"
           spec_long_name(l) = "Dry dep vel"
           spec_desc(l) = spname(ldepmap(l))(:istrln(spname(ldepmap(l))))
     &                              //" dry deposition velocity"
           spec_coords(l) = "latitude longitude"
c
           if( lgas(ldepmap(l)) ) then
             spec_units(ndepspc+l) = "mol ha-1"
           else
             spec_units(ndepspc+l) = "g ha-1"
           endif
           spec_long_name(ndepspc+l) = "Dry dep mass"
           spec_desc(ndepspc+l) = spname(ldepmap(l))(:istrln(spname(ldepmap(l))))
     &                              //" dry deposited mass"
           spec_coords(ndepspc+l) = "latitude longitude"
c
           if( lgas(ldepmap(l)) ) then
             spec_units(2*ndepspc+l) = "mol ha-1"
           else
             spec_units(2*ndepspc+l) = "g ha-1"
           endif
           spec_long_name(2*ndepspc+l) = "Wet dep mass"
           spec_desc(2*ndepspc+l) = spname(ldepmap(l))(:istrln(spname(ldepmap(l))))
     &                              //" wet deposited mass"
           spec_coords(2*ndepspc+l) = "latitude longitude"
c
           if( lgas(ldepmap(l)) ) then
             spec_units(3*ndepspc+l) = "mol l-1"
           else
             spec_units(3*ndepspc+l) = "g l-1"
           endif
           spec_long_name(3*ndepspc+l) = "Liquid conc"
           spec_desc(3*ndepspc+l) = spname(ldepmap(l))(:istrln(spname(ldepmap(l))))
     &                              //" liquid concentration"
           spec_coords(3*ndepspc+l) = "latitude longitude"
        endif
      enddo
c
      if (lixemis) then
        spec_units(4*ndepspc+1) = "mol m-2"
        spec_long_name(4*ndepspc+1) = "Oceanic halogen emissions"
        spec_desc(4*ndepspc+1) = "I2 oceanic emissions"
        spec_coords(4*ndepspc+1) = "latitude longitude"
        spec_units(4*ndepspc+2) = "mol m-2"
        spec_long_name(4*ndepspc+2) = "Oceanic halogen emissions"
        spec_desc(4*ndepspc+2) = "HOI oceanic emissions"
        spec_coords(4*ndepspc+2) = "latitude longitude"
      endif

      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

      subroutine sum1grd(ncola,nrowa,numcols,numrows,numlays,
     &                  nspmod,nspmod_tot,nsptrac,igroup,igrd,idx,
     &                    this_species,emssum,emsgrd,emsbas,emsoth,
     &                                        emslft,emstot,lemit)
      use grid
      use chmstry
      use tracer
c
c      Copyright Ramboll
c
c
c----CAMx v7.40 260801
c
c     SUM1GRD sums up the area emission of one species for a given group
c     in a given grid
c
c       07/19/02  --gwilson-- Added seperate source area map for each grids.
c       10/28/09  --gwilson-- Changed dimension of variables to accomodate
c                             the dynamic memory allocation
c       03/01/16  --gwilson-- Added partial source area map
c
c     Input argument:
c        numcols           number of columns in any grid
c        numrows           number of columns in any grid
c        numlays           number of columns in any grid
c        nspmod            number of model species
c        nspmod_tot        number of model species, including SOAP3 emissions species
c        nsptrac           number of tracer species
c        igroup            group ID
c        igrd              grid ID
c        idx               species ID
c        this_species      species name
c        emsgrd            the species emission in the grid
c
c     Output arguments:
c        emssum            emission summed over grid
c        emsbas            base emission
c        emsoth            "otherwise" emission
c        emslft            leftover emission
c        emstot            total emission
c        lemit             flag to determine if tracer class is emitted
c        
      include "camx.prm"
      include "soap.inc"
      include "soap3.inc"
c
      character*10 this_species
      integer   ncola
      integer   nrowa
      integer   numcols
      integer   numrows
      integer   numlays
      integer   nspmod
      integer   nspmod_tot
      integer   nsptrac
      integer   idx
      real      emssum(nspmod_tot,nsptrac)
      real      emsgrd(numcols,numrows,numlays)
      real      emsbas(nspmod_tot,nsptrac)
      real      emsoth(nspmod_tot,nsptrac)
      real*8    emslft(ncola,nrowa,nspmod_tot)
      real*8    emstot(ncola,nrowa,nspmod_tot)
      logical   lemit(*)
      integer   ipart
      real      frac
c
      logical   luse
c
c  --- Entry point ---
c
      luse = .FALSE.
      if( idx .LE. nspmod ) then
         do icls=1,ntrcls
           if( trspmap(idx,icls) .NE. 0.  .OR.
     &                         yhratmap(idx,icls) .NE. 0. .OR.
     &                         ylratmap(idx,icls) .NE. 0. ) then
             if( trspmap(idx,icls) .NE. 0. ) lemit(icls) = .TRUE. 
             luse = .TRUE.
           endif
         enddo
      endif
      if( idx .GT. nspmod  ) then
         do icls=ntrcls+1,soap3_ntrcls
             lemit(icls) = .TRUE. 
             luse = .TRUE.
         enddo
      endif
      if( .NOT. luse ) goto 9999
c
c   --- sum up the emissions excluding the boundary for this grid ---
c
      do 40 j=2,nrow(igrd)-1
        jcrs = (j - 2)/nmesh(igrd) + j1(igrd)
        if( igrd .eq. 1 ) jcrs = j
        do 50 i=2,ncol(igrd)-1
c
c   --- calculate the coarse grid offset ---
c
           icrs = (i - 2)/nmesh(igrd) + i1(igrd)
           if( igrd .eq. 1 ) icrs = i
c
c   --- skip cell if this grid has a child in this cell ---
c
           ijcl = i + (j-1)*ncol(igrd)
           if( idfin(iptr2d(igrd)-1+ijcl) .NE. 0 ) goto 50
c
c  --- get the region for this cell from mapping array,
c      the grid cell should be the coarse grid  ----
c
           do ipart=1,npartial(igroup,igrd)
              imap = igrmap(igroup,ipart,igrd,i,j)
              frac = frcmap(igroup,ipart,igrd,i,j)
              if( (imap .LE. 0 .AND. frac .GT. 0.) .OR. imap .GT. nregin ) goto 50
c
c  --- calculate the index into the tracer species for this gruoup/region ---
c
              if( ngroup .GT. 0 ) then
c
c   --- if group is base emissions, add to "leftover" group ----
c
                 if( igroup .EQ. 0 ) then
                   if( leftovr_area ) then
                      do icls=1,ntrcls
                        if( idx .LE. nspmod ) then
                           if( trspmap(idx,icls) .NE. 0. .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                              ipt = iemcls(icls)-1 + imap+ngroup*nregin
                              do k=1,numlays
                                emsbas(idx,ipt) = emsbas(idx,ipt) + emsgrd(i,j,k) * frac
                              enddo
                           endif
                        endif
                      enddo
                      if( idx .GT. nspmod ) then
                         isoa = nspmod
                         do icls=ntrcls+1,soap3_ntrcls
                           isoa = isoa + 1
                           iclass = icls - ntrcls + (IDX_SOAP_POA_OP-1)
                           ipt = soap3_iemcls(iclass)-1 + imap+ngroup*nregin
                           if( idx .EQ. isoa ) then
                              do k=1,numlays
                                  emsbas(isoa,ipt) = emsbas(isoa,ipt) +
     &                                                emsgrd(i,j,k) * frac
                              enddo
                           endif
                         enddo
                      endif
                   endif
                   do icls=1,ntrcls
                     if( idx .LE. nspmod ) then
                         if( trspmap(idx,icls) .NE. 0. .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                           do k=1,numlays
                             emstot(icrs,jcrs,idx) = 
     &                                  emstot(icrs,jcrs,idx) + emsgrd(i,j,k) * frac
                           enddo
                         endif
                     endif
                   enddo
                   if( idx .GT. nspmod ) then
                     isoa = nspmod
                     do icls=ntrcls+1,soap3_ntrcls
                         isoa = isoa + 1
                         if( idx .EQ. isoa ) then
                            do k=1,numlays
                              emstot(icrs,jcrs,isoa) = 
     &                                  emstot(icrs,jcrs,isoa) + emsgrd(i,j,k) * frac
                            enddo
                         endif
                      enddo
                   endif
c
c   --- otherwise, add to this group/region and subtract from "leftover" ---
c
                 else
                   do icls=1,ntrcls
                     if( idx .LE. nspmod ) then
                        if( trspmap(idx,icls) .NE. 0. .OR. 
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                          ipt = iemcls(icls)-1 + imap+(igroup-1)*nregin
                          do k=1,numlays
                              emssum(idx,ipt) = emssum(idx,ipt) + emsgrd(i,j,k) * frac
                              if( leftovr_area ) then
                                 ipt = iemcls(icls)-1 + imap+ngroup*nregin
                                 emsoth(idx,ipt) = emsoth(idx,ipt) + emsgrd(i,j,k) * frac
                              endif
                           enddo
                        endif
                     endif
                   enddo
                   if( idx .GT. nspmod ) then
                     isoa = nspmod
                     iclass = IDX_SOAP_POA_OP-1
                     do icls=ntrcls+1,soap3_ntrcls
                        iclass = iclass + 1
                        isoa = isoa + 1
                        if( this_species .NE. soap_emiss_names(iclass) ) cycle 
                        ipt = soap3_iemcls(iclass)-1 + imap+(igroup-1)*nregin
                        do k=1,numlays
                           emssum(isoa,ipt) = emssum(isoa,ipt) + emsgrd(i,j,k) * frac
                           if( leftovr_area ) then
                              ipt = soap3_iemcls(iclass)-1 + imap+ngroup*nregin
                              emsoth(isoa,ipt) = emsoth(isoa,ipt) + emsgrd(i,j,k) * frac
                           endif
                        enddo
                      enddo
                   endif
                   do icls=1,ntrcls
                     if( idx .LE. nspmod ) then
                        if( trspmap(idx,icls) .NE. 0. .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                          do k=1,numlays
                             emslft(icrs,jcrs,idx) = 
     &                               emslft(icrs,jcrs,idx) + emsgrd(i,j,k) * frac
                          enddo
                        endif
                     endif
                   enddo
                   if( idx .GT. nspmod ) then
                      iclass = IDX_SOAP_POA_OP-1
                      isoa = nspmod
                      do icls=ntrcls+1,soap3_ntrcls
                        iclass = iclass + 1
                        if( this_species .NE. soap_emiss_names(iclass) ) cycle 
                        do k=1,numlays
                             emslft(icrs,jcrs,idx) = emslft(icrs,jcrs,idx) +
     &                                          emsgrd(i,j,k) * frac
                        enddo
                      enddo
                   endif
                 endif
c
c   --- only using regular model emissions ---
c
              else
                 do icls=1,ntrcls
                   if( idx .LE. nspmod ) then
                      if( trspmap(idx,icls) .NE. 0. .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                         ipt = iemcls(icls) - 1 + imap
                         do k=1,numlays
                            emssum(idx,ipt) = emssum(idx,ipt) + emsgrd(i,j,k) * frac
                         enddo
                      endif
                   endif
                 enddo
                 if( idx .GT. nspmod ) then
                    isoa = nspmod
                    iclass = IDX_SOAP_POA_OP-1
                    do icls=ntrcls+1,soap3_ntrcls
                      iclass = iclass + 1
                      isoa = isoa + 1
                      if( this_species .NE. soap_emiss_names(iclass) ) cycle 
                      ipt = soap3_iemcls(iclass) - 1 + imap
                      do k=1,numlays
                         emssum(isoa,ipt) = emssum(isoa,ipt) + emsgrd(i,j,k) * frac
                      enddo
                    enddo
                 endif
              endif
           enddo
  50    continue
  40  continue
c
 9999 continue
      return
      end

      subroutine cpamech4(r, rk, dtfact, nr, pa, npa, npa_init, ldark )

      use filunit
      use tracer
      use procan
      implicit none
c
c----CAMx v7.40 260801
c
c     CPAMECH4 computes chemical process analysis (CPA) parameters
c
c     Mechanism is CB6r4 + SQT + GLY/MGLY SOA
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        PASETUP
c        CHEMDRIV
c
c --- Argument definitions:
c        r        - reaction rates (ppm/hr)
c        rk       - rate constants (ppm-n hr-1)
c        dtfact   - ratio of time step to averaging interval
c        nr       - number of reactions
c        pa       - output cpa parameter values
c        npa      - dimension of cpa parameter arrays
c        npa_init - number of cpa parameters calculated below
c        ldark    - flag set true at night
c
c --- Includes:
      include "camx.prm"
c
c --- Arguments:
c
      integer  nr, npa, npa_init
      real     r(nr), rk(nr), pa(MXCPA)
      real     dtfact
      logical  ldark
c
c --- Parameters:
c
c     Cut-point between NOx and VOC sensitive O3 production
c     Default = 0.35.  Recommended range is 0.15 to 0.35
      real     ratio_cut
      parameter (ratio_cut = 0.35)
c
c     Convert PPM to PPB
      real     ppbfact
      parameter (ppbfact = 1000.0)
c
c --- Local variables:
c
      integer  n, nn
      real     sum, sun, jno2, po3, do3, HO2toNO2
      real     NO2wOH, HO2wHO2, ratio_ind
      real     OH_new, HO2_new, OH_loss, HO2_loss, RO2_loss
      real     HOx_new, HOx_loss, HOx_CL
      real     newOH_O1D, newOH_O3, newOH_phot
      real     newHO2_O3, newHO2_pht
      real     frXNO2, frXRN3, frZRN3
      real     NO3wVOC, N2O5wH2O, PAN_prdNet, ON_prod, ON_dest
      real     NO2rcyHNO3, NOXrcyNTR, NOxNet, NOz_prod
c
c --- Entry point:
c
      nn = 0
      frXNO2 = 0.0
      frXRN3 = 0.0
      frZRN3 = 0.0
      sun = 1.0
      if (ldark) sun = 0.0
c
c --- J(NO2) photolysis rate (per hour)
c
      nn = nn + 1
      ptname(nn)  = 'J_NO2'
      cpadesc(nn) = 'J(NO2) photolysis rate'
      cpaunit(nn) = 'hr-1'
      jno2 =      rk(  1)
      PA(nn) =      jno2*(dtfact/ppbfact)
c
c --- J(O3O1D) photolysis rate (per hour)
c
      nn = nn + 1
      ptname(nn)  = 'J_O3O1D'
      cpadesc(nn) = 'J(O3) to O(1D) photolysis rate'
      cpaunit(nn) = 'hr-1'
      PA(nn) =      rk(  9)*(dtfact/ppbfact)
c
c --- J(HCHOr) photolysis rate (per hour)
c
      nn = nn + 1
      ptname(nn)  = 'J_HCHOr'
      cpadesc(nn) = 'J(HCHO) to 2 HO2 + CO photolysis rate'
      cpaunit(nn) = 'hr-1'
      PA(nn) =      rk( 97)*(dtfact/ppbfact)
c
c
c --- Net O3 production
c
      nn = nn + 1
      ptname(nn)  = 'PO3_net'
      cpadesc(nn) = 'Net O3 production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(  2)  ! O + O2 + M =
     &       + ( 0.150)*r( 57)  ! C2O3 + HO2 =
     &       + ( 0.150)*r( 65)  ! CXO3 + HO2 =
     &       + ( 0.150)*r(202)  ! OPO3 + HO2 =
     &       +          r(237)  ! SQT + O3 =
     &       -          r(  3)  ! O3 + NO =
     &       -          r(  7)  ! O + O3 =
     &       -          r(  8)  ! O3 =
     &       -          r(  9)  ! O3 =
     &       -          r( 12)  ! O3 + OH =
     &       -          r( 13)  ! O3 + HO2 =
     &       -          r( 26)  ! NO2 + O3 =
     &       -          r( 34)  ! NO3 + O3 =
     &       -          r(135)  ! ETH + O3 =
     &       -          r(138)  ! OLE + O3 =
     &       -          r(141)  ! IOLE + O3 =
     &       -          r(149)  ! ISOP + O3 =
     &       -          r(152)  ! ISPD + O3 =
     &       -          r(165)  ! TERP + O3 =
     &       -          r(191)  ! XOPN + O3 =
     &       -          r(195)  ! OPEN + O3 =
     &       -          r(211)  ! I + O3 =
     &       -          r(222)  ! I2O2 + O3 =
     &       -          r(237)  ! SQT + O3 =
c
      po3 = max(0.0, PA(nn))
      do3 = min(0.0, PA(nn))
c
c --- Calculate the P(H2O2)/P(HNO3) indicator ratio and apply to PO3
c
      HO2wHO2 = + r( 19) + r( 20)
      NO2wOH = + r( 45)
      ratio_ind = min( 10., HO2wHO2/max( 1.0E-12, NO2wOH ) )*sun
c
      nn =  nn + 2
      ptname(nn-1)  = 'PO3_VOCsns'
      cpadesc(nn-1) = 'Net O3 production rate under VOC-limited condition'
      cpaunit(nn-1) = 'ppb hr-1'
      ptname(nn)  = 'PO3_NOxsns'
      cpadesc(nn) = 'Net O3 production rate under NOx-limited condition'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn-1) = 0.0
      PA(nn)   = 0.0
      if (ratio_ind .GT. 0.0) then
        if (ratio_ind .LT. ratio_cut ) then
          PA(nn-1) = PO3
        else
          PA(nn)   = PO3
        endif
      endif
c
c --- Report the P(H2O2)/P(HNO3) indicator ratio
c
      if(.NOT. lcpacum) then
        nn =  nn + 1
        ptname(nn)   = 'PH2O2_PHN3'
        cpadesc(nn) = 'Ratio of production rates for H2O2/HNO3'
        cpaunit(nn) = 'dimensionless'
        if (ldark) then
          PA(nn) = 0.0
        else
          PA(nn) = ratio_ind * (dtfact/ppbfact)
        endif
      endif
c
c --- Ozone destruction calculation from OSAT
c
      nn = nn + 1
      ptname(nn)  = 'O3_dest'
      cpadesc(nn) = 'O3 destruction rate (same implementation as OSAT)'
      cpaunit(nn) = 'ppb hr-1'
c
c  +  O1D + H2O
c
      PA(nn) = 
     &       - r( 11)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
      PA(nn) = PA(nn)
     &       - r( 13)  ! O3 + HO2 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
      HO2toNO2 = 
     &       +          r( 25)  ! HO2 + NO =
     &       +          r( 33)  ! NO3 + HO2 =
c
      HO2_loss = 
     &       +          r( 13)  ! O3 + HO2 =
     &       +          r( 15)  ! HO2 + O =
     &       +          r( 18)  ! OH + HO2 =
     &       + ( 2.000)*r( 19)  ! HO2 + HO2 =
     &       + ( 2.000)*r( 20)  ! HO2 + HO2 + H2O =
     &       +          r( 25)  ! HO2 + NO =
     &       +          r( 33)  ! NO3 + HO2 =
     &       +          r( 57)  ! C2O3 + HO2 =
     &       +          r( 65)  ! CXO3 + HO2 =
     &       +          r( 72)  ! MEO2 + HO2 =
     &       +          r( 76)  ! XO2H + HO2 =
     &       +          r( 80)  ! XO2 + HO2 =
     &       +          r( 84)  ! XO2N + HO2 =
     &       +          r(100)  ! FORM + HO2 =
     &       + ( 0.800)*r(103)  ! HCO3 + HO2 =
     &       + ( 0.880)*r(145)  ! ISO2 + HO2 =
     &       + ( 0.175)*r(159)  ! EPX2 + HO2 =
     &       +          r(170)  ! BZO2 + HO2 =
     &       +          r(175)  ! TO2 + HO2 =
     &       +          r(179)  ! XLO2 + HO2 =
     &       +          r(185)  ! CRO + HO2 =
     &       +          r(202)  ! OPO3 + HO2 =
     &       +          r(214)  ! IO + HO2 =
c
      PA(nn) = PA(nn) - (
     &       + r( 12)  ! O3 + OH =
     &                     ) * (HO2_loss-HO2toNO2)/max( 1.0E-12, HO2_loss )
c
c  +  O3 + VOC
c
      PA(nn) = PA(nn)
     &       - r(135)  ! ETH + O3 =
     &       - r(138)  ! OLE + O3 =
     &       - r(141)  ! IOLE + O3 =
     &       - r(149)  ! ISOP + O3 =
     &       - r(152)  ! ISPD + O3 =
     &       - r(165)  ! TERP + O3 =
     &       - r(191)  ! XOPN + O3 =
     &       - r(195)  ! OPEN + O3 =
     &       - r(211)  ! I + O3 =
     &       - r(222)  ! I2O2 + O3 =
     &       - r(237)  ! SQT + O3 =
c
c  +  O(3P) + VOC
c
      PA(nn) = PA(nn)
c
c  +  Halogen catalytic destruction (the limiting reactions)
c
      PA(nn) = PA(nn)
     &       -          r(214)  ! IO + HO2 =
     &       - ( 0.400)*r(213)  ! IO + IO =
     &       -          r(216)  ! IO + NO2 =
c
      PA(nn) = min(PA(nn), do3)
c
c --- Net NO production
c
      nn = nn + 1
      ptname(nn)  = 'PNO_net'
      cpadesc(nn) = 'Net NO production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(  1)  ! NO2 =
     &       +          r(  5)  ! O + NO2 =
     &       +          r( 28)  ! NO3 =
     &       +          r( 30)  ! NO3 + NO2 =
     &       +          r( 42)  ! HONO + HONO =
     &       +          r( 43)  ! HONO =
     &       -          r(  3)  ! O3 + NO =
     &       -          r(  4)  ! O + NO + M =
     &       - ( 2.000)*r( 24)  ! NO + NO + O2 =
     &       -          r( 25)  ! HO2 + NO =
     &       -          r( 29)  ! NO3 + NO =
     &       -          r( 40)  ! NO + OH =
     &       -          r( 41)  ! NO + NO2 + H2O =
     &       -          r( 53)  ! C2O3 + NO =
     &       -          r( 61)  ! CXO3 + NO =
     &       -          r( 71)  ! MEO2 + NO =
     &       -          r( 75)  ! XO2H + NO =
     &       -          r( 79)  ! XO2 + NO =
     &       -          r( 83)  ! XO2N + NO =
     &       -          r(102)  ! HCO3 + NO =
     &       -          r(144)  ! ISO2 + NO =
     &       -          r(160)  ! EPX2 + NO =
     &       -          r(168)  ! BZO2 + NO =
     &       -          r(173)  ! TO2 + NO =
     &       -          r(178)  ! XLO2 + NO =
     &       -          r(199)  ! OPO3 + NO =
     &       -          r(215)  ! IO + NO =
     &       -          r(220)  ! OIO + NO =

      NOxNet = PA(nn)
c
c --- Net NO2 production
c
      nn = nn + 1
      ptname(nn)  = 'PNO2_net'
      cpadesc(nn) = 'Net NO2 production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(  3)  ! O3 + NO =
     &       +          r(  4)  ! O + NO + M =
     &       + ( 2.000)*r( 24)  ! NO + NO + O2 =
     &       +          r( 25)  ! HO2 + NO =
     &       +          r( 27)  ! NO3 =
     &       + ( 2.000)*r( 29)  ! NO3 + NO =
     &       +          r( 31)  ! NO3 + O =
     &       +          r( 32)  ! NO3 + OH =
     &       +          r( 33)  ! NO3 + HO2 =
     &       +          r( 34)  ! NO3 + O3 =
     &       + ( 2.000)*r( 35)  ! NO3 + NO3 =
     &       +          r( 37)  ! N2O5 =
     &       +          r( 38)  ! N2O5 =
     &       +          r( 42)  ! HONO + HONO =
     &       +          r( 44)  ! HONO + OH =
     &       +          r( 47)  ! HNO3 =
     &       +          r( 49)  ! PNA =
     &       + ( 0.590)*r( 50)  ! PNA =
     &       +          r( 51)  ! PNA + OH =
     &       +          r( 53)  ! C2O3 + NO =
     &       +          r( 55)  ! PAN =
     &       + ( 0.600)*r( 56)  ! PAN =
     &       +          r( 61)  ! CXO3 + NO =
     &       +          r( 63)  ! PANX =
     &       + ( 0.600)*r( 64)  ! PANX =
     &       +          r( 71)  ! MEO2 + NO =
     &       +          r( 75)  ! XO2H + NO =
     &       +          r( 79)  ! XO2 + NO =
     &       +          r( 92)  ! NTR1 =
     &       +          r(102)  ! HCO3 + NO =
     &       + ( 0.500)*r(136)  ! ETH + NO3 =
     &       + ( 0.500)*r(139)  ! OLE + NO3 =
     &       + ( 0.500)*r(142)  ! IOLE + NO3 =
     &       + ( 0.900)*r(144)  ! ISO2 + NO =
     &       + ( 0.350)*r(150)  ! ISOP + NO3 =
     &       + ( 0.142)*r(153)  ! ISPD + NO3 =
     &       +          r(160)  ! EPX2 + NO =
     &       + ( 0.444)*r(163)  ! INTR + OH =
     &       + ( 0.470)*r(166)  ! TERP + NO3 =
     &       + ( 0.918)*r(168)  ! BZO2 + NO =
     &       + ( 0.860)*r(173)  ! TO2 + NO =
     &       + ( 0.860)*r(178)  ! XLO2 + NO =
     &       + ( 0.500)*r(192)  ! XOPN + NO3 =
     &       +          r(199)  ! OPO3 + NO =
     &       +          r(201)  ! OPAN =
     &       + ( 0.500)*r(205)  ! OPAN + OH =
     &       +          r(206)  ! PANX + OH =
     &       +          r(215)  ! IO + NO =
     &       +          r(220)  ! OIO + NO =
     &       -          r(  1)  ! NO2 =
     &       -          r(  5)  ! O + NO2 =
     &       -          r(  6)  ! O + NO2 =
     &       -          r( 26)  ! NO2 + O3 =
     &       -          r( 36)  ! NO3 + NO2 =
     &       -          r( 41)  ! NO + NO2 + H2O =
     &       -          r( 45)  ! NO2 + OH =
     &       -          r( 48)  ! HO2 + NO2 =
     &       -          r( 54)  ! C2O3 + NO2 =
     &       -          r( 62)  ! CXO3 + NO2 =
     &       -          r(132)  ! ROR + NO2 =
     &       -          r(184)  ! CRO + NO2 =
     &       -          r(200)  ! OPO3 + NO2 =
     &       -          r(216)  ! IO + NO2 =

      NOxNet = NOxNet + PA(nn)
c
c --- Net NOx production
c
      nn = nn + 1
      ptname(nn)  = 'PNOx_net'
      cpadesc(nn) = 'Net NOx production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = NOxNet

c
c --- Total OH production
c
      nn = nn + 1
      ptname(nn)  = 'OH_prod'
      cpadesc(nn) = 'Total OH production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r( 11)  ! O1D + H2O =
     &       +          r( 13)  ! O3 + HO2 =
     &       +          r( 15)  ! HO2 + O =
     &       + ( 2.000)*r( 21)  ! H2O2 =
     &       +          r( 23)  ! H2O2 + O =
     &       +          r( 25)  ! HO2 + NO =
     &       +          r( 33)  ! NO3 + HO2 =
     &       +          r( 43)  ! HONO =
     &       +          r( 47)  ! HNO3 =
     &       + ( 0.410)*r( 50)  ! PNA =
     &       + ( 0.440)*r( 57)  ! C2O3 + HO2 =
     &       + ( 0.440)*r( 65)  ! CXO3 + HO2 =
     &       +          r( 88)  ! MEPX =
     &       +          r( 90)  ! ROOH =
     &       + ( 0.200)*r(103)  ! HCO3 + HO2 =
     &       + ( 0.190)*r(111)  ! GLYD =
     &       + ( 0.160)*r(135)  ! ETH + O3 =
     &       + ( 0.334)*r(138)  ! OLE + O3 =
     &       + ( 0.500)*r(141)  ! IOLE + O3 =
     &       + ( 0.120)*r(145)  ! ISO2 + HO2 =
     &       + ( 0.266)*r(149)  ! ISOP + O3 =
     &       + ( 0.461)*r(152)  ! ISPD + O3 =
     &       +          r(156)  ! HPLD =
     &       + ( 1.125)*r(159)  ! EPX2 + HO2 =
     &       + ( 0.125)*r(160)  ! EPX2 + NO =
     &       + ( 0.100)*r(161)  ! EPX2 + C2O3 =
     &       + ( 0.125)*r(162)  ! EPX2 + RO2 =
     &       + ( 0.570)*r(165)  ! TERP + O3 =
     &       + ( 0.500)*r(191)  ! XOPN + O3 =
     &       + ( 0.500)*r(195)  ! OPEN + O3 =
     &       + ( 0.440)*r(202)  ! OPO3 + HO2 =
     &       +          r(210)  ! HOI =
c
c --- OH from O(1D)
c
      nn = nn + 1
      ptname(nn)  = 'newOH_O1D'
      cpadesc(nn) = 'OH production rate from O(1D) + H2O'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = ( 2.000)*r( 11)  ! O1D + H2O =
      newOH_O1D = PA(nn)
c
c --- OH from O3 reactions with VOC
c
      nn = nn + 1
      ptname(nn)  = 'newOH_O3'
      cpadesc(nn) = 'OH production rate from O3 + VOC'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 0.160)*r(135)  ! ETH + O3 =
     &       + ( 0.334)*r(138)  ! OLE + O3 =
     &       + ( 0.500)*r(141)  ! IOLE + O3 =
     &       + ( 0.266)*r(149)  ! ISOP + O3 =
     &       + ( 0.461)*r(152)  ! ISPD + O3 =
     &       + ( 0.570)*r(165)  ! TERP + O3 =
     &       + ( 0.500)*r(191)  ! XOPN + O3 =
     &       + ( 0.500)*r(195)  ! OPEN + O3 =
      newOH_O3 = PA(nn)
c
c --- OH directly from photolysis, excluding from PNA
c
      nn = nn + 1
      ptname(nn)  = 'newOH_phot'
      cpadesc(nn) = 'OH production rate directly from photolysis, excluding from PNA'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r( 21)  ! H2O2 =
     &       +          r( 43)  ! HONO =
     &       +          r( 47)  ! HNO3 =
     &       +          r( 88)  ! MEPX =
     &       +          r( 90)  ! ROOH =
     &       + ( 0.190)*r(111)  ! GLYD =
     &       +          r(156)  ! HPLD =
     &       +          r(210)  ! HOI =
      newOH_phot = PA(nn)
c
c --- New OH
c
      nn = nn + 1
      ptname(nn)  = 'OH_new'
      cpadesc(nn) = 'New OH, i.e., newOH_O1D + newOH_O3 + newOH_phot'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = newOH_O1D + newOH_O3 + newOH_phot
      OH_new = PA(nn)
c
c --- OH from HONO
c
      nn = nn + 1
      ptname(nn)  = 'newOH_HONO'
      cpadesc(nn) = 'OH production rate from HONO photolysis'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) =           r( 43)  ! HONO =
c
c --- OH from HPLD
c
      nn = nn + 1
      ptname(nn)  = 'newOH_HPLD'
      cpadesc(nn) = 'OH production rate from HPALD photolysis'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) =           r(156)  ! HPLD =
c
c --- OH loss
c
      nn = nn + 1
      ptname(nn)  = 'OH_loss'
      cpadesc(nn) = 'OH loss'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 12)  ! O3 + OH =
     &       +          r( 14)  ! OH + O =
     &       + ( 2.000)*r( 16)  ! OH + OH =
     &       + ( 2.000)*r( 17)  ! OH + OH =
     &       +          r( 18)  ! OH + HO2 =
     &       +          r( 22)  ! H2O2 + OH =
     &       +          r( 32)  ! NO3 + OH =
     &       +          r( 40)  ! NO + OH =
     &       +          r( 44)  ! HONO + OH =
     &       +          r( 45)  ! NO2 + OH =
     &       +          r( 46)  ! HNO3 + OH =
     &       +          r( 51)  ! PNA + OH =
     &       +          r( 52)  ! SO2 + OH =
     &       + ( 0.600)*r( 87)  ! MEPX + OH =
     &       + ( 0.600)*r( 89)  ! ROOH + OH =
     &       +          r( 91)  ! NTR1 + OH =
     &       +          r( 93)  ! FACD + OH =
     &       +          r( 94)  ! AACD + OH =
     &       +          r( 95)  ! PACD + OH =
     &       +          r( 96)  ! FORM + OH =
     &       +          r(104)  ! ALD2 + OH =
     &       +          r(107)  ! ALDX + OH =
     &       +          r(110)  ! GLYD + OH =
     &       +          r(113)  ! GLY + OH =
     &       +          r(118)  ! MGLY + OH =
     &       +          r(119)  ! H2 + OH =
     &       +          r(120)  ! CO + OH =
     &       +          r(121)  ! CH4 + OH =
     &       +          r(122)  ! ETHA + OH =
     &       +          r(123)  ! MEOH + OH =
     &       +          r(124)  ! ETOH + OH =
     &       +          r(127)  ! ACET + OH =
     &       +          r(128)  ! PRPA + OH =
     &       +          r(129)  ! PAR + OH =
     &       + ( 0.300)*r(133)  ! ETHY + OH =
     &       +          r(134)  ! ETH + OH =
     &       +          r(137)  ! OLE + OH =
     &       +          r(140)  ! IOLE + OH =
     &       +          r(143)  ! ISOP + OH =
     &       +          r(151)  ! ISPD + OH =
     &       + ( 0.067)*r(155)  ! ISPX + OH =
     &       +          r(158)  ! EPOX + OH =
     &       +          r(163)  ! INTR + OH =
     &       +          r(164)  ! TERP + OH =
     &       + ( 0.882)*r(167)  ! BENZ + OH =
     &       + ( 0.900)*r(172)  ! TOL + OH =
     &       + ( 0.756)*r(177)  ! XYL + OH =
     &       +          r(182)  ! CRES + OH =
     &       +          r(186)  ! CRON + OH =
     &       +          r(190)  ! XOPN + OH =
     &       +          r(194)  ! OPEN + OH =
     &       +          r(197)  ! CAT1 + OH =
     &       +          r(205)  ! OPAN + OH =
     &       +          r(206)  ! PANX + OH =
     &       +          r(208)  ! ECH4 + OH =
     &       +          r(218)  ! OIO + OH =
     &       +          r(231)  ! DMS + OH =
     &       +          r(232)  ! DMS + OH + O2 =
      OH_loss = PA(nn)
c
c --- OH with H2
c
      nn = nn + 1
      ptname(nn)  = 'OHwH2'
      cpadesc(nn) = 'OH reacted with H2 (background H2)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(119)  ! H2 + OH =
c
c --- OH with EH2
c
      nn = nn + 1
      ptname(nn)  = 'OHwEH2'
      cpadesc(nn) = 'OH reacted with EH2 (emitted H2)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
c
c --- OH with CO
c
      nn = nn + 1
      ptname(nn)  = 'OHwCO'
      cpadesc(nn) = 'OH reacted with CO'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(120)  ! CO + OH =
c
c --- OH with CH4
c
      nn = nn + 1
      ptname(nn)  = 'OHwCH4'
      cpadesc(nn) = 'OH reacted with CH4 (background CH4)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(121)  ! CH4 + OH =
c
c --- OH with ECH4
c
      nn = nn + 1
      ptname(nn)  = 'OHwECH4'
      cpadesc(nn) = 'OH reacted with ECH4 (emitted CH4)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(208)  ! ECH4 + OH =
c
c --- OH with Isoprene
c
      nn = nn + 1
      ptname(nn)  = 'OHwISOP'
      cpadesc(nn) = 'OH reacted with Isoprene'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(143)  ! ISOP + OH =
c
c --- OH with Terpenes/Sesquiterpenes
c
      nn = nn + 1
      ptname(nn)  = 'OHwTERPS'
      cpadesc(nn) = 'OH reacted with Terpenes/Sesquiterpenes'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(164)  ! TERP + OH =
     &       +          r(236)  ! SQT + OH =
c
c --- OH with HRVOC
c
      nn = nn + 1
      ptname(nn)  = 'OHwHRVOC'
      cpadesc(nn) = 'OH reacted with HRVOC'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(134)  ! ETH + OH =
     &       +          r(137)  ! OLE + OH =
     &       +          r(140)  ! IOLE + OH =
c
c --- OH with Aromatics
c
      nn = nn + 1
      ptname(nn)  = 'OHwArom'
      cpadesc(nn) = 'OH reacted with aromatic VOC'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(167)  ! BENZ + OH =
     &       +          r(172)  ! TOL + OH =
     &       +          r(177)  ! XYL + OH =
c
c --- OH with Ethyne (acetylene)
c
      nn = nn + 1
      ptname(nn)  = 'OHwETHY'
      cpadesc(nn) = 'OH reacted with Ethyne (acetylene)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(133)  ! ETHY + OH =
c
c --- OH with Alkanes (except methane)
c
      nn = nn + 1
      ptname(nn)  = 'OHwAlkane'
      cpadesc(nn) = 'OH reacted with alkanes (except methane)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(122)  ! ETHA + OH =
     &       +          r(128)  ! PRPA + OH =
     &       +          r(129)  ! PAR + OH =
c
c --- OH with HCHO
c
      nn = nn + 1
      ptname(nn)  = 'OHwHCHO'
      cpadesc(nn) = 'OH reacted with HCHO'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 96)  ! FORM + OH =
c
c --- OH with Alcohols
c
      nn = nn + 1
      ptname(nn)  = 'OHwROH'
      cpadesc(nn) = 'OH reacted with Alcohols'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(123)  ! MEOH + OH =
     &       +          r(124)  ! ETOH + OH =
c
c --- OH with OVOC
c
      nn = nn + 1
      ptname(nn)  = 'OHwOVOC'
      cpadesc(nn) = 'OH reacted with OVOC except HCHO and ROH'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(104)  ! ALD2 + OH =
     &       +          r(107)  ! ALDX + OH =
     &       +          r(127)  ! ACET + OH =
c
c --- OH with VOC
c
      nn = nn + 1
      ptname(nn)  = 'OHwVOC'
      cpadesc(nn) = 'OH reacted with all VOC'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 96)  ! FORM + OH =
     &       +          r(104)  ! ALD2 + OH =
     &       +          r(107)  ! ALDX + OH =
     &       +          r(122)  ! ETHA + OH =
     &       +          r(123)  ! MEOH + OH =
     &       +          r(124)  ! ETOH + OH =
     &       +          r(127)  ! ACET + OH =
     &       +          r(128)  ! PRPA + OH =
     &       +          r(129)  ! PAR + OH =
     &       +          r(133)  ! ETHY + OH =
     &       +          r(134)  ! ETH + OH =
     &       +          r(137)  ! OLE + OH =
     &       +          r(140)  ! IOLE + OH =
     &       +          r(143)  ! ISOP + OH =
     &       +          r(164)  ! TERP + OH =
     &       +          r(167)  ! BENZ + OH =
     &       +          r(172)  ! TOL + OH =
     &       +          r(177)  ! XYL + OH =
     &       +          r(236)  ! SQT + OH =
c
c --- Total HCHO production
c
      nn = nn + 1
      ptname(nn)  = 'HCHO_prod'
      cpadesc(nn) = 'Total HCHO production rate'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 71)  ! MEO2 + NO =
     &       + ( 0.100)*r( 72)  ! MEO2 + HO2 =
     &       +          r( 73)  ! MEO2 + C2O3 =
     &       + ( 0.685)*r( 74)  ! MEO2 + RO2 =
     &       + ( 0.400)*r( 87)  ! MEPX + OH =
     &       +          r(101)  ! HCO3 =
     &       + ( 0.740)*r(111)  ! GLYD =
     &       +          r(123)  ! MEOH + OH =
     &       + ( 0.078)*r(124)  ! ETOH + OH =
     &       +          r(127)  ! ACET + OH =
     &       + ( 1.560)*r(134)  ! ETH + OH =
     &       +          r(135)  ! ETH + O3 =
     &       + ( 1.125)*r(136)  ! ETH + NO3 =
     &       + ( 0.781)*r(137)  ! OLE + OH =
     &       + ( 0.555)*r(138)  ! OLE + O3 =
     &       + ( 0.500)*r(139)  ! OLE + NO3 =
     &       + ( 0.128)*r(141)  ! IOLE + O3 =
     &       + ( 0.673)*r(144)  ! ISO2 + NO =
     &       + ( 0.120)*r(145)  ! ISO2 + HO2 =
     &       + ( 0.598)*r(146)  ! ISO2 + C2O3 =
     &       + ( 0.598)*r(147)  ! ISO2 + RO2 =
     &       + ( 0.600)*r(149)  ! ISOP + O3 =
     &       + ( 0.350)*r(150)  ! ISOP + NO3 =
     &       + ( 0.231)*r(152)  ! ISPD + O3 =
     &       + ( 0.260)*r(154)  ! ISPD =
     &       + ( 0.375)*r(159)  ! EPX2 + HO2 =
     &       + ( 0.375)*r(160)  ! EPX2 + NO =
     &       + ( 0.300)*r(161)  ! EPX2 + C2O3 =
     &       + ( 0.375)*r(162)  ! EPX2 + RO2 =
     &       + ( 0.592)*r(163)  ! INTR + OH =
     &       + ( 0.280)*r(164)  ! TERP + OH =
     &       + ( 0.240)*r(165)  ! TERP + O3 =
     &       +          r(188)  ! CRON =
     &       + ( 0.080)*r(195)  ! OPEN + O3 =
     &       + ( 0.140)*r(197)  ! CAT1 + OH =
     &       +          r(231)  ! DMS + OH =
     &       +          r(233)  ! DMS + NO3 =
c
c --- HCHO production from HRVOC at first generation
c
      nn = nn + 1
      ptname(nn)  = 'nwHCHO_HRV'
      cpadesc(nn) = 'HCHO production rate from HRVOC at first generation'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 1.560)*r(134)  ! ETH + OH =
     &       +          r(135)  ! ETH + O3 =
     &       + ( 1.125)*r(136)  ! ETH + NO3 =
     &       + ( 0.781)*r(137)  ! OLE + OH =
     &       + ( 0.555)*r(138)  ! OLE + O3 =
     &       + ( 0.500)*r(139)  ! OLE + NO3 =
     &       + ( 0.128)*r(141)  ! IOLE + O3 =
c
c --- HCHO production from Isoprene at first generation
c
      nn = nn + 1
      ptname(nn)  = 'nwHCHO_ISP'
      cpadesc(nn) = 'HCHO production rate from isoprene at first generation'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 0.600)*r(149)  ! ISOP + O3 =
     &       + ( 0.350)*r(150)  ! ISOP + NO3 =
     &       + ( 0.673)*r(144)  ! ISO2 + NO =
     &       + ( 0.120)*r(145)  ! ISO2 + HO2 =
     &       + ( 0.598)*r(146)  ! ISO2 + C2O3 =
     &       + ( 0.598)*r(147)  ! ISO2 + RO2 =
c
c --- Total HO2 production, excluding from PNA
c
      nn = nn + 1
      ptname(nn)  = 'HO2_prod'
      cpadesc(nn) = 'Total HO2 production rate, excluding from PNA'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 12)  ! O3 + OH =
     &       +          r( 14)  ! OH + O =
     &       +          r( 22)  ! H2O2 + OH =
     &       +          r( 23)  ! H2O2 + O =
     &       +          r( 32)  ! NO3 + OH =
     &       +          r( 52)  ! SO2 + OH =
     &       +          r( 71)  ! MEO2 + NO =
     &       + ( 0.900)*r( 73)  ! MEO2 + C2O3 =
     &       + ( 0.370)*r( 74)  ! MEO2 + RO2 =
     &       +          r( 75)  ! XO2H + NO =
     &       + ( 0.800)*r( 77)  ! XO2H + C2O3 =
     &       + ( 0.600)*r( 78)  ! XO2H + RO2 =
     &       + ( 0.800)*r( 85)  ! XO2N + C2O3 =
     &       +          r( 90)  ! ROOH =
     &       +          r( 93)  ! FACD + OH =
     &       +          r( 96)  ! FORM + OH =
     &       + ( 2.000)*r( 97)  ! FORM =
     &       +          r( 99)  ! FORM + NO3 =
     &       +          r(101)  ! HCO3 =
     &       +          r(102)  ! HCO3 + NO =
     &       +          r(106)  ! ALD2 =
     &       +          r(109)  ! ALDX =
     &       + ( 0.200)*r(110)  ! GLYD + OH =
     &       + ( 1.400)*r(111)  ! GLYD =
     &       +          r(113)  ! GLY + OH =
     &       + ( 2.000)*r(114)  ! GLY =
     &       +          r(115)  ! GLY + NO3 =
     &       +          r(116)  ! MGLY =
     &       +          r(119)  ! H2 + OH =
     &       +          r(120)  ! CO + OH =
     &       +          r(123)  ! MEOH + OH =
     &       + ( 0.900)*r(124)  ! ETOH + OH =
     &       +          r(131)  ! ROR + O2 =
     &       + ( 0.300)*r(133)  ! ETHY + OH =
     &       + ( 0.160)*r(135)  ! ETH + O3 =
     &       + ( 0.080)*r(138)  ! OLE + O3 =
     &       + ( 0.818)*r(144)  ! ISO2 + NO =
     &       + ( 0.728)*r(146)  ! ISO2 + C2O3 =
     &       + ( 0.728)*r(147)  ! ISO2 + RO2 =
     &       +          r(148)  ! ISO2 =
     &       + ( 0.066)*r(149)  ! ISOP + O3 =
     &       + ( 0.137)*r(151)  ! ISPD + OH =
     &       + ( 0.398)*r(152)  ! ISPD + O3 =
     &       + ( 0.760)*r(154)  ! ISPD =
     &       + ( 0.825)*r(160)  ! EPX2 + NO =
     &       + ( 0.660)*r(161)  ! EPX2 + C2O3 =
     &       + ( 0.825)*r(162)  ! EPX2 + RO2 =
     &       + ( 0.530)*r(167)  ! BENZ + OH =
     &       + ( 0.918)*r(168)  ! BZO2 + NO =
     &       +          r(169)  ! BZO2 + C2O3 =
     &       +          r(171)  ! BZO2 + RO2 =
     &       + ( 0.180)*r(172)  ! TOL + OH =
     &       + ( 0.860)*r(173)  ! TO2 + NO =
     &       +          r(174)  ! TO2 + C2O3 =
     &       +          r(176)  ! TO2 + RO2 =
     &       + ( 0.155)*r(177)  ! XYL + OH =
     &       + ( 0.860)*r(178)  ! XLO2 + NO =
     &       +          r(180)  ! XLO2 + C2O3 =
     &       +          r(181)  ! XLO2 + RO2 =
     &       +          r(182)  ! CRES + OH =
     &       +          r(188)  ! CRON =
     &       + ( 0.700)*r(189)  ! XOPN =
     &       +          r(193)  ! OPEN =
     &       + ( 0.560)*r(195)  ! OPEN + O3 =
     &       + ( 0.200)*r(197)  ! CAT1 + OH =
     &       + ( 0.800)*r(199)  ! OPO3 + NO =
c
c --- HO2 from O3 reactions with VOC
c
      nn = nn + 1
      ptname(nn)  = 'newHO2_O3'
      cpadesc(nn) = 'HO2 production rate from O3 + VOC'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 0.160)*r(135)  ! ETH + O3 =
     &       + ( 0.080)*r(138)  ! OLE + O3 =
     &       + ( 0.066)*r(149)  ! ISOP + O3 =
     &       + ( 0.398)*r(152)  ! ISPD + O3 =
     &       + ( 0.560)*r(195)  ! OPEN + O3 =
      newHO2_O3 = PA(nn)
c
c --- HO2 directly from photolysis, excluding from PNA
c
      nn = nn + 1
      ptname(nn)  = 'newHO2_pht'
      cpadesc(nn) = 'HO2 production rate directly from photolysis, excluding from PNA'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 90)  ! ROOH =
     &       + ( 2.000)*r( 97)  ! FORM =
     &       +          r(101)  ! HCO3 =
     &       +          r(106)  ! ALD2 =
     &       +          r(109)  ! ALDX =
     &       + ( 1.400)*r(111)  ! GLYD =
     &       + ( 2.000)*r(114)  ! GLY =
     &       +          r(116)  ! MGLY =
     &       +          r(148)  ! ISO2 =
     &       + ( 0.760)*r(154)  ! ISPD =
     &       +          r(188)  ! CRON =
     &       + ( 0.700)*r(189)  ! XOPN =
     &       +          r(193)  ! OPEN =
      newHO2_pht = PA(nn)
c
c --- New HO2
c
      nn = nn + 1
      ptname(nn)  = 'HO2_new'
      cpadesc(nn) = 'New HO2 production rate, i.e. newHO2_O3 + newHO2_pht'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = newHO2_O3 + newHO2_pht
      HO2_new = PA(nn)
      HOx_new = max(1.0E-15, (OH_new + HO2_new))
c
c --- HO2 from HCHO photolysis
c
      nn = nn + 1
      ptname(nn)  = 'nwHO2_HCHO'
      cpadesc(nn) = 'HO2 production rate from HCHO photolysis'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r( 97)  ! FORM =
c
c --- HO2 loss (except to HNO4) - computed above
c
      nn = nn + 1
      ptname(nn)  = 'HO2_loss'
      cpadesc(nn) = 'HO2 loss (except to HNO4)'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = HO2_loss
      HOx_loss = max(1.0E-15, (OH_loss + HO2_loss))
c
c --- HO2wHO2 - computed above
c
      nn = nn + 1
      ptname(nn)  = 'HO2wHO2'
      cpadesc(nn) = 'HO2 + HO2 self-reaction'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = HO2wHO2
c
c --- HOx chain length = HOx reacted / new HOx
c
      if(.NOT. lcpacum) then
        nn = nn + 1
        ptname(nn)  = 'HOx_CL'
        cpadesc(nn) = 'HOx chain length = HOx reacted / new HOx'
        cpaunit(nn) = 'dimensionless'
        PA(nn) = (HOx_loss/HOx_new)
     &           *sun*(dtfact/ppbfact)
      endif
c
c --- NO3 production
c
      nn = nn + 1
      ptname(nn)  = 'NO3_prod'
      cpadesc(nn) = 'NO3 production'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r(  6)  ! O + NO2 =
     &       +          r( 26)  ! NO2 + O3 =
     &       +          r( 37)  ! N2O5 =
     &       +          r( 38)  ! N2O5 =
     &       +          r( 46)  ! HNO3 + OH =
     &       + ( 0.410)*r( 50)  ! PNA =
     &       + ( 0.400)*r( 56)  ! PAN =
     &       + ( 0.400)*r( 64)  ! PANX =
     &       + ( 0.185)*r(163)  ! INTR + OH =
     &       +          r(223)  ! INO3 =
c
c --- NO3 production from N2O5
c
      nn = nn + 1
      ptname(nn)  = 'N2O5toNO3'
      cpadesc(nn) = 'NO3 production from N2O5'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 37)  ! N2O5 =
     &       +          r( 38)  ! N2O5 =
c
c --- NO3 loss
c
      nn = nn + 1
      ptname(nn)  = 'NO3_loss'
      cpadesc(nn) = 'NO3 loss'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 27)  ! NO3 =
     &       +          r( 28)  ! NO3 =
     &       +          r( 29)  ! NO3 + NO =
     &       +          r( 30)  ! NO3 + NO2 =
     &       +          r( 31)  ! NO3 + O =
     &       +          r( 32)  ! NO3 + OH =
     &       +          r( 33)  ! NO3 + HO2 =
     &       +          r( 34)  ! NO3 + O3 =
     &       + ( 2.000)*r( 35)  ! NO3 + NO3 =
     &       +          r( 36)  ! NO3 + NO2 =
     &       +          r( 99)  ! FORM + NO3 =
     &       +          r(105)  ! ALD2 + NO3 =
     &       +          r(108)  ! ALDX + NO3 =
     &       +          r(112)  ! GLYD + NO3 =
     &       +          r(115)  ! GLY + NO3 =
     &       +          r(117)  ! MGLY + NO3 =
     &       +          r(136)  ! ETH + NO3 =
     &       +          r(139)  ! OLE + NO3 =
     &       +          r(142)  ! IOLE + NO3 =
     &       +          r(150)  ! ISOP + NO3 =
     &       +          r(153)  ! ISPD + NO3 =
     &       +          r(157)  ! HPLD + NO3 =
     &       +          r(166)  ! TERP + NO3 =
     &       +          r(183)  ! CRES + NO3 =
     &       +          r(187)  ! CRON + NO3 =
     &       +          r(192)  ! XOPN + NO3 =
     &       +          r(196)  ! OPEN + NO3 =
     &       +          r(198)  ! CAT1 + NO3 =
     &       +          r(233)  ! DMS + NO3 =
c
c --- NO3 to N2O5
c
      nn = nn + 1
      ptname(nn)  = 'NO3toN2O5'
      cpadesc(nn) = 'NO3 conversion to N2O5'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 36)  ! NO3 + NO2 =
c
c --- RO2 loss
c
      nn = nn + 1
      ptname(nn)  = 'RO2_loss'
      cpadesc(nn) = 'RO2 loss'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 71)  ! MEO2 + NO =
     &       +          r( 72)  ! MEO2 + HO2 =
     &       + ( 0.100)*r( 73)  ! MEO2 + C2O3 =
     &       +          r( 74)  ! MEO2 + RO2 =
     &       +          r( 75)  ! XO2H + NO =
     &       +          r( 76)  ! XO2H + HO2 =
     &       + ( 0.200)*r( 77)  ! XO2H + C2O3 =
     &       +          r( 78)  ! XO2H + RO2 =
     &       +          r( 79)  ! XO2 + NO =
     &       +          r( 80)  ! XO2 + HO2 =
     &       + ( 0.200)*r( 81)  ! XO2 + C2O3 =
     &       +          r( 82)  ! XO2 + RO2 =
     &       +          r( 83)  ! XO2N + NO =
     &       +          r( 84)  ! XO2N + HO2 =
     &       + ( 0.200)*r( 85)  ! XO2N + C2O3 =
     &       +          r( 86)  ! XO2N + RO2 =
     &       + ( 0.918)*r(144)  ! ISO2 + NO =
     &       +          r(145)  ! ISO2 + HO2 =
     &       + ( 0.128)*r(146)  ! ISO2 + C2O3 =
     &       + ( 0.928)*r(147)  ! ISO2 + RO2 =
     &       +          r(148)  ! ISO2 =
     &       +          r(159)  ! EPX2 + HO2 =
     &       +          r(160)  ! EPX2 + NO =
     &       + ( 0.200)*r(161)  ! EPX2 + C2O3 =
     &       +          r(162)  ! EPX2 + RO2 =
     &       +          r(168)  ! BZO2 + NO =
     &       +          r(170)  ! BZO2 + HO2 =
     &       +          r(171)  ! BZO2 + RO2 =
     &       +          r(173)  ! TO2 + NO =
     &       +          r(175)  ! TO2 + HO2 =
     &       +          r(176)  ! TO2 + RO2 =
     &       +          r(178)  ! XLO2 + NO =
     &       +          r(179)  ! XLO2 + HO2 =
     &       +          r(181)  ! XLO2 + RO2 =
      RO2_loss = PA(nn)
c
c --- RO2 with NO
c
      nn = nn + 1
      ptname(nn)  = 'RO2wNO'
      cpadesc(nn) = 'RO2 reaction with NO'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 71)  ! MEO2 + NO =
     &       +          r( 75)  ! XO2H + NO =
     &       +          r( 79)  ! XO2 + NO =
     &       +          r( 83)  ! XO2N + NO =
     &       + ( 0.918)*r(144)  ! ISO2 + NO =
     &       +          r(160)  ! EPX2 + NO =
     &       +          r(168)  ! BZO2 + NO =
     &       +          r(173)  ! TO2 + NO =
     &       +          r(178)  ! XLO2 + NO =
c
c --- RO2 with HO2
c
      nn = nn + 1
      ptname(nn)  = 'RO2wHO2'
      cpadesc(nn) = 'RO2 reaction with HO2'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 72)  ! MEO2 + HO2 =
     &       +          r( 76)  ! XO2H + HO2 =
     &       +          r( 80)  ! XO2 + HO2 =
     &       +          r( 84)  ! XO2N + HO2 =
     &       +          r(145)  ! ISO2 + HO2 =
     &       +          r(159)  ! EPX2 + HO2 =
     &       +          r(170)  ! BZO2 + HO2 =
     &       +          r(175)  ! TO2 + HO2 =
     &       +          r(179)  ! XLO2 + HO2 =
c
c --- RO2 with NO3
c
      nn = nn + 1
      ptname(nn)  = 'RO2wNO3'
      cpadesc(nn) = 'RO2 reaction with NO3'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
c
c --- RO2 with RO2
c
      nn = nn + 1
      ptname(nn)  = 'RO2wRO2'
      cpadesc(nn) = 'RO2 reaction with RO2'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 0.100)*r( 73)  ! MEO2 + C2O3 =
     &       +          r( 74)  ! MEO2 + RO2 =
     &       + ( 0.200)*r( 77)  ! XO2H + C2O3 =
     &       +          r( 78)  ! XO2H + RO2 =
     &       + ( 0.200)*r( 81)  ! XO2 + C2O3 =
     &       +          r( 82)  ! XO2 + RO2 =
     &       + ( 0.200)*r( 85)  ! XO2N + C2O3 =
     &       +          r( 86)  ! XO2N + RO2 =
     &       + ( 0.128)*r(146)  ! ISO2 + C2O3 =
     &       + ( 0.928)*r(147)  ! ISO2 + RO2 =
     &       +          r(148)  ! ISO2 =
     &       + ( 0.200)*r(161)  ! EPX2 + C2O3 =
     &       +          r(162)  ! EPX2 + RO2 =
     &       +          r(171)  ! BZO2 + RO2 =
     &       +          r(176)  ! TO2 + RO2 =
     &       +          r(181)  ! XLO2 + RO2 =
c
c --- Production of ON compounds (not from ON)
c
      nn = nn + 1
      ptname(nn)  = 'ON_prod'
      cpadesc(nn) = 'Production of organic nitrate (ON) not from ON'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 0.500)*r( 83)  ! XO2N + NO =   0.500 NTR1
     &       +          r(132)  ! ROR + NO2 =   1.000 NTR1
     &       + ( 0.500)*r(136)  ! ETH + NO3 =   0.500 NTR1
     &       + ( 0.500)*r(139)  ! OLE + NO3 =   0.500 NTR1
     &       + ( 0.500)*r(142)  ! IOLE + NO3 =   0.500 NTR1
     &       + ( 0.500)*r( 83)  ! XO2N + NO =   0.500 NTR2
     &       + ( 0.650)*r(150)  ! ISOP + NO3 =   0.650 NTR2
     &       + ( 0.142)*r(153)  ! ISPD + NO3 =   0.142 NTR2
     &       + ( 0.530)*r(166)  ! TERP + NO3 =   0.530 NTR2
     &       + ( 0.082)*r(168)  ! BZO2 + NO =   0.082 NTR2
     &       + ( 0.140)*r(173)  ! TO2 + NO =   0.140 NTR2
     &       + ( 0.140)*r(178)  ! XLO2 + NO =   0.140 NTR2
     &       + ( 0.500)*r(192)  ! XOPN + NO3 =   0.500 NTR2
     &       + ( 0.500)*r(205)  ! OPAN + OH =   0.500 NTR2
     &       + ( 0.100)*r(144)  ! ISO2 + NO =   0.100 INTR
     &       +          r(184)  ! CRO + NO2 =   1.000 CRON
      ON_prod = PA(nn)
c
c --- Destruction of ON compounds (not to ON)
c
      nn = nn + 1
      ptname(nn)  = 'ON_dest'
      cpadesc(nn) = 'Destruction of organic nitrate (ON) not to ON'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 92)  ! NTR1 =
     &       +          r(207)  ! NTR2 =
     &       + ( 0.629)*r(163)  ! INTR + OH =
     &       +          r(229)  ! INTR =
     &       +          r(188)  ! CRON =
      ON_dest = PA(nn)
c
c --- HNO3 production
c
      nn = nn + 1
      ptname(nn)  = 'HNO3_prod'
      cpadesc(nn) = 'HNO3 production'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r( 39)  ! N2O5 + H2O =
     &       +          r( 45)  ! NO2 + OH =
     &       +          r( 99)  ! FORM + NO3 =
     &       +          r(105)  ! ALD2 + NO3 =
     &       +          r(108)  ! ALDX + NO3 =
     &       +          r(112)  ! GLYD + NO3 =
     &       +          r(115)  ! GLY + NO3 =
     &       +          r(117)  ! MGLY + NO3 =
     &       + ( 0.716)*r(153)  ! ISPD + NO3 =
     &       +          r(157)  ! HPLD + NO3 =
     &       +          r(183)  ! CRES + NO3 =
     &       +          r(187)  ! CRON + NO3 =
     &       +          r(196)  ! OPEN + NO3 =
     &       +          r(198)  ! CAT1 + NO3 =
     &       +          r(207)  ! NTR2 =
     &       +          r(224)  ! INO3 + H2O =
     &       +          r(229)  ! INTR =
     &       +          r(233)  ! DMS + NO3 =
c
c --- HNO3 production from NO2 with OH - computed above
c
      nn = nn + 1
      ptname(nn)  = 'NO2wOH'
      cpadesc(nn) = 'HNO3 production from OH + NO2'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = NO2wOH
c
c --- HNO3 production from N2O5 with H2O
c
      nn = nn + 1
      ptname(nn)  = 'N2O5wH2O'
      cpadesc(nn) = 'HNO3 production from N2O5 + H2O'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r( 39)  ! N2O5 + H2O =
      N2O5wH2O = PA(nn)
c
c --- NO2 or NO3 recycled from HNO3
c
      nn = nn + 1
      ptname(nn)  = 'NOXrcyHNO3'
      cpadesc(nn) = 'NO2 or NO3 recycled from HNO3 and organic nitrates'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 47)  ! HNO3 =
     &       +          r( 46)  ! HNO3 + OH =
      NO2rcyHNO3 = PA(nn)
c
c --- NO2, HONO or NO3 recycled from organic nitrates
c
      nn = nn + 1
      ptname(nn)  = 'NOXrcyNTR'
      cpadesc(nn) = 'NO2, HONO or NO3 recycled from organic nitrates'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 92)  ! NTR1 =
     &       + ( 0.444)*r(163)  ! INTR + OH =
     &       + ( 0.185)*r(163)  ! INTR + OH =
     &       +          r(188)  ! CRON =
      NOXrcyNTR = PA(nn)
c
c --- Net production of PAN compounds
c
      nn = nn + 1
      ptname(nn)  = 'PAN_prdNet'
      cpadesc(nn) = 'Net production of PAN species'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 54)  ! C2O3 + NO2 =
     &       +          r( 62)  ! CXO3 + NO2 =
     &       +          r(200)  ! OPO3 + NO2 =
     &       -          r( 55)  ! PAN =
     &       -          r( 56)  ! PAN =
     &       -          r( 63)  ! PANX =
     &       -          r( 64)  ! PANX =
     &       -          r(201)  ! OPAN =
     &       -          r(205)  ! OPAN + OH =
     &       -          r(206)  ! PANX + OH =
      PAN_prdNet = PA(nn)
c
c --- NO3 with VOC
c
      nn = nn + 1
      ptname(nn)  = 'NO3wVOC'
      cpadesc(nn) = 'NO3 reaction with VOC species'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       +          r( 99)  ! FORM + NO3 =
     &       +          r(105)  ! ALD2 + NO3 =
     &       +          r(108)  ! ALDX + NO3 =
     &       +          r(136)  ! ETH + NO3 =
     &       +          r(139)  ! OLE + NO3 =
     &       +          r(142)  ! IOLE + NO3 =
     &       +          r(150)  ! ISOP + NO3 =
     &       +          r(166)  ! TERP + NO3 =
     &       + ( 0.000)*r(238)  ! SQT + NO3 =
      NO3wVOC = PA(nn)
c
c --- NOz production
c
        nn = nn + 1
        ptname(nn)  = 'NOz_prod'
        cpadesc(nn) = 'NOz production (HNO3 + ONs + PANs)'
        cpaunit(nn) = 'ppb hr-1'
        NOz_prod = NO2wOH + NO3wVOC + N2O5wH2O
     &             + PAN_prdNet + ON_prod - ON_dest
        PA(nn) = NOz_prod
c
c --- Ozone Production Efficiency (OPE)
c
        nn = nn + 1
        ptname(nn)  = 'OPE'
        cpadesc(nn) = 'Ozone Production Efficiency (OPE)'
        cpaunit(nn) = 'dimensionless'
        if( abs(NOz_prod) .LT. 1.0E-6) NOz_prod = 1.0E-6
        PA(nn) = (PO3/NOz_prod)*sun*(dtfact/ppbfact)
c
c --- LN/Q calculation
c
      nn = nn + 1
      ptname(nn)  = 'LNoQ'
      cpadesc(nn) = 'LN/Q metric for ozone sensitivity'
      cpaunit(nn) = 'dimensionless'
      if( .NOT. lcpacum .AND. jno2 .GT. 2.0) then
        PA(nn) = NOz_prod / HOx_new
        PA(nn) = max( 0., min( 100., PA(nn) ))*sun*(dtfact/ppbfact)
      else
        PA(nn) = 0.0
      endif
c
c --- I production
c
      nn = nn + 1
      ptname(nn)  = 'I_prod'
      cpadesc(nn) = 'I atom production'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       + ( 2.000)*r(209)  ! I2 =
     &       +          r(210)  ! HOI =
     &       +          r(212)  ! IO =
     &       + ( 0.400)*r(213)  ! IO + IO =
     &       +          r(215)  ! IO + NO =
     &       +          r(217)  ! OIO =
     &       +          r(221)  ! I2O2 =
     &       +          r(223)  ! INO3 =
c
c --- Ozone destruction by I
c
      nn = nn + 1
      ptname(nn)  = 'I_O3dest'
      cpadesc(nn) = 'Ozone destruction by I atom'
      cpaunit(nn) = 'ppb hr-1'
      PA(nn) = 0.0
     &       -          r(214)  ! IO + HO2 =
     &       - ( 0.400)*r(213)  ! IO + IO =
     &       -          r(216)  ! IO + NO2 =
c
c --- Convert to ppb/hr
c
      Do n = 1,nn
        PA(n) = ppbfact*PA(n)
      End do
c
c --- Set num of outputs for first dummy call from PASETUP
c
      npa_init = nn
c
      return
      end

      subroutine pigevol(igrd,iproc_id)
      use filunit
      use grid
      use camxfld
      use o3colmap
      use camxcom
      use procan
      use chmstry
      use node_mod
c
c----CAMx v7.40 260801
c
c
c     PIGEVOL calls the PiG driver routine for puff chemistry, growth,
c     and dumping
c
c      Copyright Ramboll
c
c     Modifications:
c        2/02/06             Removed GRESDRIV, IRONDRIV renamed PIGDRIVE
c
c     Input arguments:
c        igrd                grid index
c        iproc_id            process ID for this slice
c
c     Output arguments:
c        none
c
c     Routines called:
c        PIGDRIVE
c
c     Called by:
c        CAMx
c        NESTING
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----Perform PiG evolution
c
      if( iproc_id .LE. 1 ) then
        write(*,'(a20,$)') 'pigdrive ......'
        call flush(6)
      endif
      write(iout,'(a20,$)') 'pigdrive ......'
      call pigdrive(mmxp(igrd),mmyp(igrd),mmzp(igrd),
     &              mi0(igrd),mj0(igrd),
     &              igrd,iptr2d(igrd),
     &              ncol(igrd),nrow(igrd),nlay(igrd),
     &              nspec,ndepspc*3+2,itzon,deltat(igrd),deltax(1,igrd),
     &              deltay(igrd),delx,dely,meshold(igrd),
     &              mapscl(iptr2d(igrd)),
     &              height(iptr3d(igrd)),
     &              rkv(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &              tsurf(iptr2d(igrd)),press(iptr3d(igrd)),
     &              water(iptr3d(igrd)),windu(iptr3d(igrd)),
     &              windv(iptr3d(igrd)),cldtrns(iptr3d(igrd)),
     &              cwc(iptr3d(igrd)),pwr(iptr3d(igrd)),
     &              pws(iptr3d(igrd)),pwg(iptr3d(igrd)),
     &              cph(iptr3d(igrd)),cellat(iptr2d(igrd)),
     &              cellon(iptr2d(igrd)),topo(iptr2d(igrd)),
     &              sfcz0(iptr2d(igrd)),albedo(iptr2d(igrd)),
     &              vdep(iptr1lay(igrd)),conc(iptr4d(igrd)),
     &              pigdump(1,igrd),
     &              pgmserr(1,igrd),fluxes(1,igrd),
     &              depfld(iptrdp(igrd)),ipsa2d(igrd),ipsa3d(igrd),
     &              ipsadep(igrd),ipacl_3d(iptr3d_full(igrd)),iproc_id )
      if( iproc_id .LE. 1 ) then
         write(*,'(a)') '   Done'
         call flush(6)
       endif
       write(iout,'(a)') '   Done'
       call flush(iout)
c
      return
      end

      subroutine sum1pnt(numcols,numrows,nspmod,nspmod_tot,nsptrac,
     &                igroup,idxfile,idx,this_species,numpts,emsbas,
     *                  emsoth,emslft,emstot,emspnt,emssum,izcel,idcompact,lemit)
      use grid
      use chmstry
      use pigsty
      use filunit
      use tracer
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c     SUM1PNT sums up the point emission of one species for a given group
c
c       07/19/02  --gwilson-- Added seperate source area map for each grid.
c       08/25/05  --cemery--  Revamped PiG pointer arrays for source group
c                             and region
c       11/16/06  --gwilson-- fixed bug in point source override for PiG sources
c       11/27/06  --gwilson-- fixed bug in calculating emissions table
c       10/28/09  --gwilson-- Changed dimension of variables to accomodate 
c                             the dynamic memory allocation
c       12/20/13  --gwilson-- Added compact point source file
c       03/01/16  --gwilson-- Added partial source area map
c       01/17/22  --gwilson-- Added conditional to bypass overrided 
c                             check when using only 1 region
c
c     Input argument:
c        numcols           max number of columns in any grid
c        numrows           max number of columns in any grid
c        nspmod            number of model species
c        nspmod_mod        number of model species including SOAP emissions species
c        nsptrac           number of tracer species
c        igroup            group ID
c        idxfile           file number
c        idx               species ID
c        this_species      species name
c        emspnt            the species emission for the group
c        idcompact         index of the source in master list
c
c     Output arguments:
c        emssum            emission summed over grid
c        emslft            leftover emission
c        emstot            total emission
c        lemit             flag to determine if tracer class is emitted
c
      include "camx.prm"
      include "flags.inc"
      include "soap.inc"
      include "soap3.inc"
c
      character*200 fname
      character*10  this_species
      integer   numcols
      integer   numrows
      integer   nspmod
      integer   nspmod_tot
      integer   nsptrac
      integer   igroup
      integer   idxfile
      integer   idx
      integer   numpts
      real*8    emslft(numcols,numrows,nspmod_tot)
      real*8    emstot(numcols,numrows,nspmod_tot)
      real      emspnt(MXPTSRC)
      real      emsbas(nspmod_tot,nsptrac)
      real      emsoth(nspmod_tot,nsptrac)
      real      emssum(nspmod_tot,nsptrac)
      integer   izcel(*)
      integer   idcompact(*)
      logical   lemit(*)
      logical   luse
      integer   ipart
      real      frac
      integer   istart
c
      real, allocatable, dimension(:) :: xloctmp
      real, allocatable, dimension(:) :: yloctmp
c
c  --- allocate the local arrays ---
c
      allocate( xloctmp(numpts) )
      allocate( yloctmp(numpts) )
c
c   --- set the file name for elevated points emissions file ---
c
      num_ptsfiles = num_iortpt(igroup)
      fname = tptfil(igroup,idxfile)
c
c  --- make sure this species is needed ---
c
      luse = .FALSE.
      if( idx .LE. nspmod ) then
         do icls=1,ntrcls
           if( trspmap(idx,icls) .NE. 0.  .OR.
     &                         yhratmap(idx,icls) .NE. 0. .OR.
     &                        ylratmap(idx,icls) .NE. 0. ) then
             if( trspmap(idx,icls) .NE. 0. ) lemit(icls) = .TRUE.
             luse = .TRUE.
           endif
         enddo
      endif
      if( idx .GT. nspmod ) then
         do icls=ntrcls+1,soap3_ntrcls
             lemit(icls) = .TRUE. 
             luse = .TRUE.
         enddo
      endif
      if( .NOT. luse ) goto 111
c
c   --- sum up the emissions for each point ---
c
      istart = idx_start_sapts(igroup,idxfile)
      if (llatlon) then
        do n = istart+1,istart+nptsrc_safile(igroup,idxfile)
          idxpt = idcompact(n)
          xloctmp(n) = xlocpt(n) - xorg
          yloctmp(n) = ylocpt(n) - yorg
        enddo
      else
        do n = istart+1,istart+nptsrc_safile(igroup,idxfile)
          idxpt = idcompact(n)
          xloctmp(n) = xlocpt(n)/1000. - xorg
          yloctmp(n) = ylocpt(n)/1000. - yorg
        enddo
      endif
      n = 0
      do 70 i=istart+1,istart+nptsrc_safile(igroup,idxfile)
         n = n+1
         idxpt = idcompact(n)
         icel = 1 + FLOOR( xloctmp(i)/delx )
         jcel = 1 + FLOOR( yloctmp(i)/dely )
         if(icel .LE. 0 .OR. icel .GT. ncol(1)) goto 70
         if(jcel .LE. 0 .OR. jcel .GT. nrow(1)) goto 70
         icrs = icel
         jcrs = jcel
c
c   --- find out if a nest contains this source  ---
c
         igrd = 1
         do ig = 2,ngrid
           xlocnst = xloctmp(i) - (inst1(ig)-1)*delx
           ylocnst = yloctmp(i) - (jnst1(ig)-1)*dely
           ii = 2 + FLOOR( xlocnst/delx * FLOAT( meshold(ig) ) )
           jj = 2 + FLOOR( ylocnst/dely * FLOAT( meshold(ig) ) )
           if( ii .GT. 1 .AND. jj .GT. 1 .AND. ii .LT. ncol(ig) .AND.
     &                                           jj .LT. nrow(ig) ) then
              igrd = ig
              icel = ii
              jcel = jj
            endif
         enddo
c
c  --- get the region for this cell from mapping array ----
c
        imap = igrmap(0,1,igrd,icel,jcel)
        frac = 1.0
c
c  --- change the region if the override is set ---
c
        if( nregin .GT. 1 ) then
           if( izcel(idcompact(n)) .LT. 0 ) then
               if( .NOT. lptoverride ) goto 7000
               imap = ABS( izcel(idcompact(n)) )
               frac = 1.0
           endif
        endif
        if( imap .LE. 0 .OR. imap .GT. nregin ) goto 7001
c
c  --- calculate the index into the tracer species for this group/region ---
c
        if( ngroup .GT. 0 ) then
c
c  --- if doing PiG and source is a PIG source, set the PiG map and group
c      pointers ---
c
          if( lpigsa(i) .AND. emspnt(n) .GT. 0. ) then
             ipigmap(i) = imap
             ipiggrp(i) = igroup-1
          endif
c
          do icls=1,ntrcls
             if( idx .LE. nspmod ) then
                if( trspmap(idx,icls) .NE. 0.  .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                   if( leftovr_area ) then
                       ipt = iemcls(icls)-1 + imap + ngroup*nregin
                       emsbas(idx,ipt) = emsbas(idx,ipt) + emspnt(n) * frac
                       emsoth(idx,ipt) = emsoth(idx,ipt) + emspnt(n) * frac
                   endif
                   ipt = iemcls(icls)-1 + imap +(igroup-1)*nregin
                   emssum(idx,ipt) = emssum(idx,ipt) + emspnt(n) * frac
                endif
             endif
          enddo
          if( idx .LE. nspmod ) then
              do icls=1,ntrcls
                  if( trspmap(idx,icls) .NE. 0.  .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                    emslft(icrs,jcrs,idx) = 
     &                         emslft(icrs,jcrs,idx) + emspnt(n) * frac
                    emstot(icrs,jcrs,idx) = 
     &                         emstot(icrs,jcrs,idx) + emspnt(n) * frac
                 endif
              enddo
          endif
          if( idx .GT. nspmod ) then
             isoa = nspmod
             iclass = IDX_SOAP_POA_OP-1
             do icls=ntrcls+1,soap3_ntrcls
                iclass = iclass + 1
                isoa = isoa + 1
                if( this_species .NE. soap_emiss_names(iclass) ) cycle
                if( leftovr_area ) then
                       ipt = soap3_iemcls(iclass)-1 + imap + ngroup*nregin
                       emsbas(idx,ipt) = emsbas(idx,ipt) + emspnt(n) * frac
                       emsoth(idx,ipt) = emsoth(idx,ipt) + emspnt(n) * frac
                endif
                ipt = soap3_iemcls(iclass)-1 + imap +(igroup-1)*nregin
                emssum(idx,ipt) = emssum(idx,ipt) + emspnt(n) * frac
                emslft(icrs,jcrs,idx) = 
     &                         emslft(icrs,jcrs,idx) + emspnt(n) * frac
                emstot(icrs,jcrs,idx) = 
     &                         emstot(icrs,jcrs,idx) + emspnt(n) * frac
             enddo
          endif
c
c   --- only using regular model emissions ---
c
        else
           do icls=1,ntrcls
              if( idx .LE. nspmod ) then
                  if( trspmap(idx,icls) .NE. 0.  .OR.
     &                                 yhratmap(idx,icls) .NE. 0. .OR.
     &                                 ylratmap(idx,icls) .NE. 0. ) then
                     ipt = iemcls(icls) - 1 + imap
                     emssum(idx,ipt) = emssum(idx,ipt) + emspnt(n) * frac
                  endif
               endif
           enddo
           if( idx .GT. nspmod ) then
               iclass = IDX_SOAP_POA_OP-1
               isoa = nspmod
               do icls=ntrcls+1,soap3_ntrcls
                   iclass = iclass + 1
                   if( this_species .NE. soap_emiss_names(iclass) ) cycle
                   ipt = soap3_iemcls(iclass) - 1 + imap
                   emssum(idx,ipt) = emssum(idx,ipt) + emspnt(n) * frac
               enddo
           endif
c
c  --- if doing PiG and source is a PIG source, set the PiG map and group
c      pointers ---
c
           if( lpigsa(n) .AND. emspnt(n) .GT. 0. ) then
              ipigmap(n) = imap
              ipiggrp(n) = 0
           endif
        endif
  70  continue
c
c  --- processed entire file ---
c
 111  continue
c
c  --- deallocate the local arrays ---
c
      deallocate( xloctmp )
      deallocate( yloctmp )
      goto 999

c
c----------------------------------------------------------------------
c  Error messages:
c----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in SUM1PNT:'
      write(iout,'(/,1X,2A )') 'A source was read that has the point ',
     &                   'source override trigger turned on.'
      write(iout,'(1X,2A)') 'If you intend to use point source ',
     &                     'override please set the namelist variable'
      write(iout,'(1X,2A)') 'SA_PT_Override to TRUE in the CAMx_Control namelist.'
      write(iout,'(1X,2A)') 'If you do not want point source override ',
     &                         'you need to set the kcell variable '
      write(iout,'(1X,2A)') 'in your point source file to zero.'
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in SUM1PNT:'
      write(iout,'(/,1X,A,A,I4)') 'Invalid region found in',
     &             ' point source override when reading point source file.'
      write(iout,'(1X,A,I4)') 'Region code      : ',imap
      write(iout,'(1X,A,I4)') 'Number of regions: ',nregin
      write(iout,'(10X,A,/,A)') 'Point source filename: ',
     &                                                 fname(:istrln(fname))
      write(iout,'(1X,2A)') 'Check the values in the point ',
     &                                                     'source overide.'
      call camxerr()
c
 999  continue
      return
      end

      subroutine nodes_pig_pass(igrd,numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c       NESTING
c    Subroutines called:
c       NODES_SEND_LSLICE_BACK
c       MPI_BARRIER
c       NODES_SEND_PIG_MISC_REAL8
c       NODES_SEND_PIG_MISC
c       NODES_PASS
c       NODES_SEND_PIG_BACK
c       NODES_SEND_PUFFMASS_BACK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    11/06/12  --gwilson-- fixed passing of PiG information for diag file  
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: igrd
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ierr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- pass the array that determines which slice the PiG is in ---
c
      call nodes_send_Lslice_back(Lslice,ngrid,npig,
     &                            MPI_REAL,itag,igrd,numprocs,iproc_id)
      call MPI_Barrier(MPI_COMM_WORLD,ierr)
c
c  --- pass the mass flux array ---
c
      call master_pass_xmass(pigdump,nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                               itag,numprocs,iproc_id                   )
      call master_pass_xmass(pgmserr,nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                               itag,numprocs,iproc_id                   )
c
c  --- pass the variables in the pigsty include file ---
c
      call nodes_send_pig_misc(npig,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(npigon,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_send_pig_misc(ipigint,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_send_pig_sum(nkill, 9,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_send_pig_sum(nage, ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_send_pig_sum_real(pigage,ngrid,   MPI_REAL,itag,numprocs,iproc_id)
c
      if (npig .eq. 0) goto 999
c
      call nodes_send_pig_back(ingrd,  npig,MPI_INTEGER,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(idpig,  npig,MPI_INTEGER,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(xpigf,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(xpigb,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(ypigf,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(ypigb,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(zpig,   npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(axisy,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(axisz,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(sigy,   npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(sigx,   npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(sigz,   npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(htfms,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(htfmb,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(vtfms,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(vtfmb,  npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(agepigf,npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(agepigb,npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(fmspig, npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(lnewt,  npig,MPI_LOGICAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(lnewg,  npig,MPI_LOGICAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(ipufmap,npig,MPI_INTEGER,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(ipufgrp,npig,MPI_INTEGER,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(pufftop,npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
      call nodes_send_pig_back(puffbot,npig,   MPI_REAL,itag,numprocs,
     &                                          iproc_id,lslice,npig,ngrid,igrd)
c
      call nodes_send_puffmass_back(puffmass,nspec,nreactr,npig,MPI_REAL,itag,
     &                              numprocs,iproc_id,lslice,npig,ngrid,igrd  )
c
      if( ltrace .AND. (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) ) then
         call nodes_send_puffmass_back(puffrt,ntotsp,MXRECTR,npig,MPI_REAL,itag,
     &                                 numprocs,iproc_id,lslice,npig,ngrid,igrd  )
      endif
c
 999  continue
      return
      end 

      subroutine partitionrt(numcol,numrow,numlay,nspc,igrd,icell,jcell,
     &                       kcell,conc)
      use filunit
      use chmstry
      use grid
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c 
c-----------------------------------------------------------------------
c   Description:
c     This routine performs gas-aerosol partitioning of RTRAC gas species 
c     using Koa theory.
c 
c      Copyright Ramboll
c           
c   Argument descriptions:
c     Inputs:
c       numcol  I number of columns in this slice
c       numrow  I number of rows in this slice
c       numlay  I number of layers in this slice
c       nspc    I number of host model species
c       igrd    I  umber of the grid containing the cell
c       icell   I  X index of the cell
c       jcell   I  Y index of the cell
c       kcell   I  Z index of the cell
c       conc    R  host model species concentrations (umol/m3, ug/m3)
c
c     Routines called: 
c             
c     Called by: 
c        CHEMDRIV
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     10/14/09  --jjung--   Original development
c      9/18/15  --cemery--  Bug fix on PTCONC gas units
c      8/25/16  --bkoo--    Updated for new SOAP
c      5/12/21  --cemery--  Minor update to skip species with Koa = 0
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c 
      implicit none
c     include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer numlay
      integer nspc
      integer igrd
      integer icell
      integer jcell
      integer kcell
      real    conc(nspc)
      real    eps
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      integer   ispc
      integer*8 idx
      integer*8 idxaer
      integer*8 idxcel

      real daero
      real Mom,fom,Kp,TSP
      real MwH2O,Mw,gas,aero
      real total
c
      data MwH2O /18.0/   !Mw of H2O (g/mol)
      data eps /1.0e-20/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Calculate array pointers for the current grid cell ---
c
      idxcel =  DBLE(ipsa3d(igrd)-1) + 
     &                 DBLE(icell) + DBLE(numcol)*DBLE(jcell-1) + 
     &                       DBLE(numcol)*DBLE(numrow)*DBLE(kcell-1)
c
c --- Calculate organic and total PM mass, and OM/PM ratio
c
      TSP = 0.0
      do ispc = ngas+1,nspc
         TSP = TSP + conc(ispc)
      enddo
      TSP = max(TSP,eps)
      if (TSP.eq.eps) then
         fom = 0.2 ! Set 20%
      else
         Mom = conc(kaoa2) + conc(kaoa1) + conc(kboa2) + conc(kboa1) +
     &         conc(kaoa0) + conc(kboa0) + conc(khoa)
         fom = Mom/TSP
      endif
      fom = max(fom,1.e-5)        ! Bound fom to 0.001%
c
c-----Loop over GAS species, and calculate partitioning for this cell
c
      do i = 1,nrtgas
         idx    = idxcel + DBLE(numcol)*DBLE(numrow)*DBLE(numlay)*DBLE(i-1)
         idxaer = idxcel + DBLE(numcol)*DBLE(numrow)*DBLE(numlay)*DBLE(nrtgas+i-1)
         ptconc(idx) = max(ptconc(idx),rtlbnd(i))
         ptconc(idxaer) = max(ptconc(idxaer),rtlbnd(nrtgas+i-i))
         if (eqkoa(i).eq.0.) cycle
         Mw = rtmolwt(i)
         gas = ptconc(idx)*Mw                   ! umol/m3 -> ug/m3
         total = gas + ptconc(idxaer)
         Kp = 1.0e-9/820.0*eqkoa(i)*fom
         aero = total*Kp*TSP/(Kp*TSP + 1.)
         daero = aero - ptconc(idxaer)
         if (daero.ge.0.0) then                         ! aerosol increase
            daero = min(daero,gas-rtlbnd(i)*Mw)
            if (daero.ge.gas) then                      ! Negative gas
              write(iout,*)'Error in PARTITIONRT:',
     &                     ' Partitioning more than available gas.'
              write(iout,*)'Available gas (ug/m3)',gas
              write(iout,*)'Mass subtracted (ug/m3)',daero
              write(iout,*)'Kp,Koa,TSP,organic fraction'
              write(iout,*) Kp,eqkoa(i),TSP,fom
              call camxerr() 
            endif
         else                                           ! aerosol decrease
            daero = -min(abs(daero),ptconc(idxaer)-rtlbnd(nrtgas+i-1))
            if (abs(daero).ge.ptconc(idxaer)) then      ! Negative aerosol
              write(iout,*)'Error in PARTITIONRT:',
     &                     ' Partitioning more than available aerosol.'
              write(iout,*)'Available aerosol (ug/m3)',ptconc(idxaer)
              write(iout,*)'Mass subtracted (ug/m3)',abs(daero)
              write(iout,*)'Kp,Koa,TSP,organic fraction'
              write(iout,*) Kp,eqkoa(i),TSP,fom
              call camxerr() 
            endif
         endif
         ptconc(idx)    = ptconc(idx)    - daero/Mw     ! Update gas conc
         ptconc(idxaer) = ptconc(idxaer) + daero        ! Update aerosol conc
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

!____________________________________________________________________________________________
SUBROUTINE EQSAM4clim(xTT,xAW,xsPM,xaPM,xPMS,xPMT,xRHO,xVOL,xPH,xHp,xGF,xWH2O,&
                      xYPa,xYPs,xYMa,xYMs,xYG,imask,neq,nleq,jmeq,Dd)
!____________________________________________________________________________________________
 IMPLICIT NONE
!bkoo SAVE
!____________________________________________________________________________________________
! WRITTEN BY SWEN METZGER (s.metzger@cyi.ac.cy), 2012-2014
!          The Cyprus Institute, www.cyi.ac.cy
!               *** COPYRIGHT 2012-2018+ ***
!
! Contact, w.r.t. EQSAM4clim modeling:
! Swen Metzger <swen.metzger@eco-serve.de>
! Founder, ResearchConcepts io GmbH, HRB 717519
! http://www.eco-serve.de/en/Publications.html
! http://www.researchconcepts.io
!
! Metzger, S., B. Steil, L. Xu, J. E. Penner, and J. Lelieveld, 
! New representation of water activity based on a single solute specific constant to 
! parameterize the hygroscopic growth of aerosols in atmospheric models, 
! Atmos. Chem. Phys., 12, 5429Ð5446, doi:10.5194/acp-12-5429-2012, 2012; 
! http://www.atmos-chem-phys.net/12/5429/2012/acp-12-5429-2012.html
!
! Metzger, S., B. Steil, M. Abdelkader, K. KlingmŸller, L. Xu, J.E. Penner, C. Fountoukis, 
! A. Nenes, and J. Lelieveld; Aerosol Water Parameterization: A single parameter framework; 
! Atmos. Chem. Phys., 16, 7213Ð7237, doi:10.5194/acp-16-7213-2016, 2016; 
! https://www.atmos-chem-phys.net/16/7213/2016/acp-16-7213-2016.html
!
! EUMETSAT ITT 15/210839 Validation Report, 12/2016: 
! Comparison of Metop - PMAp Version 2 AOD Products using Model Data
! http://www.eumetsat.int/website/wcm/idc/idcplg?IdcService=GET_FILE&dDocName=
! PDF_PMAP_V2_MODEL_COMP&RevisionSelectionMethod=LatestReleased&Rendition=Web
!____________________________________________________________________________________________
 CHARACTER(LEN=*),PARAMETER :: modstr  = 'EQSAM4clim'    ! name of module
 CHARACTER(LEN=*),PARAMETER :: modver  = 'v10'           ! module version
 CHARACTER(LEN=*),PARAMETER :: moddat  = '15Jan2018'     ! last modification date
!____________________________________________________________________________________________
! ' Hydrogen |   H2O           H2SO4          HNO3            HCl            NH3    '
! '    H+    |    1              2             3               4              5     '
! '  Index   |  eqh2o          eqhsa          eqhna          eqhca          eqxam   '
! '----------|----------------------------------------------------------------------'
! ' Ammonium |(NH4)3H(SO4)2  (NH4)2SO4       NH4HSO4        NH4NO3          NH4Cl   '
! '   NH4+   |    6              7             8               9             10     '
! '  Index   |  eqalc          eqasu          eqahs          eqano          eqacl   '
! '----------|----------------------------------------------------------------------'
! ' Sodium   | Na3H(SO4)2     Na2SO4          NaHSO4         NaNO3          NaCl    '
! '   Na+    |   11             12            13              14             15     '
! '  Index   |  eqslc          eqssu          eqshs          eqsno          eqscl   '
! '----------|----------------------------------------------------------------------'
! ' Potassium|  K3H(SO4)2      K2SO4           KHSO4          KNO3           KCl    '
! '    K+    |   16             17            18              19             20     '
! '  Index   |  eqplc          eqpsu          eqphs          eqpno          eqpcl   '
! '----------|----------------------------------------------------------------------'
! ' Calcium  |   ---           CaSO4          ---           Ca(NO3)2        CaCl2   '
! '   Ca++   |   21             22            23              24             25     '
! '  Index   |  eqc01          eqcsu          eqc02          eqcno          eqccl   '
! '----------|----------------------------------------------------------------------'
! ' Magnesium|   ---           MgSO4          ---           Mg(NO3)2        MgCl2   '
! '   Mg++   |   26             27            28              29             30     '
! '  Index   |  eqm01          eqmsu          eqm02          eqmno          eqmcl   '
!____________________________________________________________________________________________
INTEGER,PARAMETER                             :: dp = SELECTED_REAL_KIND(12,307)
!______________________________________________
REAL(dp),PARAMETER                            :: REALZERO=tiny(0._dp),ZERO=0._dp,ONE=1._dp
REAL(dp),PARAMETER                            :: TINYX=1.e-15_dp,eqT0=298.15_dp ![K]
REAL(dp),PARAMETER                            :: R=8.314409_dp            ![J/mol/K]
REAL(dp),PARAMETER                            :: eqR=R/101325._dp   ![atm*m^3/mol/K]
REAL(dp),PARAMETER                            :: sigma=0.0761_dp    ![J/m^2]
!______________________________________________
 LOGICAL,PARAMETER                            :: lke         =.FALSE.
 LOGICAL,PARAMETER                            :: lvola       =.TRUE.
 LOGICAL,PARAMETER                            :: lmixs       =.FALSE.
 LOGICAL,PARAMETER                            :: lrhdm       =.TRUE.
 LOGICAL,PARAMETER                            :: lHSO4       =.TRUE.
 LOGICAL,PARAMETER                            :: lH2SO4gas   =.FALSE.
 LOGICAL,PARAMETER                            :: lmetastable =.TRUE.  !bkoo - metastable liquid state
!______________________________________________
INTEGER,PARAMETER :: jMs=1
INTEGER,PARAMETER :: jDs=2
INTEGER,PARAMETER :: jZa=3
INTEGER,PARAMETER :: jWs=4
INTEGER,PARAMETER :: jNs=5
INTEGER,PARAMETER :: jNi=6
INTEGER,PARAMETER :: jRHD=7
INTEGER,PARAMETER :: jRHDc=8
INTEGER,PARAMETER :: jSOL=30
INTEGER,PARAMETER :: jVOL=2
INTEGER,PARAMETER :: jGAS=4
INTEGER,PARAMETER :: jKEQ=2
INTEGER,PARAMETER :: jAP=1
INTEGER,PARAMETER :: jDP=2
INTEGER,PARAMETER :: jGP=3
INTEGER,PARAMETER :: jSP=1
INTEGER,PARAMETER :: jSM=2
INTEGER,PARAMETER :: jSS=3
!______________________________________________
INTEGER,PARAMETER :: mciam =  1  ! ammonium        -  NH4+
INTEGER,PARAMETER :: mciso =  2  ! sodium          -  Na+
INTEGER,PARAMETER :: mcipo =  3  ! potassium       -  K+
INTEGER,PARAMETER :: mcica =  4  ! calcium         -  Ca++
INTEGER,PARAMETER :: mcimg =  5  ! magnesium       -  Mg++
INTEGER,PARAMETER :: mcati =  5
!______________________________________________
INTEGER,PARAMETER :: mdumm =  0  ! dummy
INTEGER,PARAMETER :: maisu =  1  ! sulfate         -  SO4--
INTEGER,PARAMETER :: maihs =  2  ! bisulfate       -  HSO4-
INTEGER,PARAMETER :: maino =  3  ! nitrate         -  NO3-
INTEGER,PARAMETER :: maicl =  4  ! chloride        -  Cl-
INTEGER,PARAMETER :: manio =  4
!______________________________________________
CHARACTER(len= 5), DIMENSION(0:jSOL)   :: ceqsolute
INTEGER,           DIMENSION(0:jSOL,5) :: ieqsolute
INTEGER,           DIMENSION(1:jVOL)   :: ieqvola
INTEGER,           DIMENSION(1:jGAS)   :: ieqgases
INTEGER,           DIMENSION(neq,nleq) :: imask
!_______________________________________________
LOGICAL,           DIMENSION(0:jSOL)   :: leqsolute
!_______________________________________________
INTEGER                                :: i,n,m,II,IJ,IK,Jp,Jm,Ip,Im,Is
INTEGER                                :: neq,neq1,neq2,nleq,nleq1,nleq2,jmeq
!______________________________________________
REAL(dp)                               :: T0T,AKW,X1,X2,X3,XZ,KEQ,Mw,Dw,COEF,Dd
!______________________________________________
REAL(dp),DIMENSION(0:mcati)  :: eqxpz,eqxpm
REAL(dp),DIMENSION(0:manio)  :: eqxmz,eqxmm
REAL(dp),DIMENSION(0:jSOL)   :: eqxyZ,eqxyA,eqxyB,eqxyC
REAL(dp),DIMENSION(8,0:jSOL) :: eqxy
!______________________________________________
LOGICAL :: leqskip_all,lhelp
!______________________________________________
LOGICAL, DIMENSION(neq) :: leqskip
!______________________________________________
INTEGER, DIMENSION(neq) :: NZeq,IWATeq,IDeq
!______________________________________________
INTEGER, DIMENSION(neq,0:jSOL) :: ieqsalt
!______________________________________________
REAL(dp),DIMENSION(neq) :: eqTT,eqAW,eqRH,eqsPM,eqPMs,eqaPM,eqPMt,eqWH2O,eqPH,eqGF,YY,YZ
REAL(dp),DIMENSION(neq) :: eqVOL,eqRHO,eqXPi,eqXMi,eqHPLUS,XRHDMIN,XRHDMAX,XRHDIFF,TSO4
REAL(dp),DIMENSION(neq) :: eqMolm,eqMs,eqNs,eqWs,eqNZm,eqRHDM
!_______________________________________________
REAL(dp),DIMENSION(neq,mcati,2)   :: eqyp
REAL(dp),DIMENSION(neq,manio,2)   :: eqym
REAL(dp),DIMENSION(neq,jGAS)      :: eqyg
REAL(dp),DIMENSION(neq,0:jSOL,3)  :: eqys
REAL(dp),DIMENSION(neq,0:jSOL)    :: eqxyRHD
REAL(dp),DIMENSION(neq,0:jSOL)    :: eqxyXS,eqxyMol,eqxyKe,eqxyGF
REAL(dp),DIMENSION(neq,0:mcati)   :: eqxp
REAL(dp),DIMENSION(neq,0:manio)   :: eqxm
!______________________________________________
REAL(dp),DIMENSION(neq,nleq,4)    :: xYG
REAL(dp),DIMENSION(neq,nleq,4)    :: xYMa,xYMs
REAL(dp),DIMENSION(neq,nleq,5)    :: xYPa,xYPs
REAL(dp),DIMENSION(neq,nleq)      :: xTT,xAW,xsPM,xPMs,xaPM,xPMt,xWH2O,xPH,xVOL,xRHO,xGF,xHp
!____________________________________________________________________________________________
! cation name     |            mciam      mciso      mcipo      mcica       mcimg
DATA eqxpz(0:mcati) / 1._dp,  1.0_dp,    1.0_dp,    1.0_dp,     2.0_dp,     2.0_dp     /
DATA eqxpm(0:mcati) / 1._dp,0.01805_dp,0.02299_dp,0.039098_dp,0.040080_dp,0.024305_dp /
!____________________________________________________________________________________________
! anion  name     |            maisu      maihs      maino      maicl
DATA eqxmz(0:manio) / 1._dp,  2.0_dp,    1.0_dp,    1.0_dp,    1.0_dp /
DATA eqxmm(0:manio) / 1._dp,0.09607_dp,0.09708_dp,0.062010_dp,0.03545_dp/
!____________________________________________________________________________________________
INTEGER,PARAMETER ::     eqdum =  0, &
          eqh2o =  1,    eqhsa =  2,    eqhna =  3,    eqhca =  4,    eqxam =  5,&
          eqalc =  6,    eqasu =  7,    eqahs =  8,    eqano =  9,    eqacl = 10,&
          eqslc = 11,    eqssu = 12,    eqshs = 13,    eqsno = 14,    eqscl = 15,&
          eqplc = 16,    eqpsu = 17,    eqphs = 18,    eqpno = 19,    eqpcl = 20,&
          eqc01 = 21,    eqcsu = 22,    eqc02 = 23,    eqcno = 24,    eqccl = 25,&
          eqm01 = 26,    eqmsu = 27,    eqm02 = 28,    eqmno = 29,    eqmcl = 30
!____________________________________________________________________________________________
DATA ieqvola (1:jVOL)  /eqacl,eqano/
DATA ieqgases(1:jGAS)  /eqhna,eqhca,eqxam,eqhsa/
!____________________________________________________________________________________________
INTEGER                ::     ieqsu(mcati)
DATA                          ieqsu/eqasu,eqssu,eqpsu,eqcsu,eqmsu/
INTEGER                ::     ieqhs(mcati)
DATA                          ieqhs/eqahs,eqshs,eqphs,mdumm,mdumm/
INTEGER                ::     ieqno(mcati)
DATA                          ieqno/eqano,eqsno,eqpno,eqcno,eqmno/
INTEGER                ::     ieqcl(mcati)
DATA                          ieqcl/eqacl,eqscl,eqpcl,eqccl,eqmcl/
!____________________________________________________________________________________________
INTEGER                ::     ieqams(manio)
DATA                          ieqams/eqasu,eqahs,eqano,eqacl/
INTEGER                ::     ieqsos(manio)
DATA                          ieqsos/eqssu,eqshs,eqsno,eqscl/
INTEGER                ::     ieqpos(manio)
DATA                          ieqpos/eqpsu,eqphs,eqpno,eqpcl/
INTEGER                ::     ieqcas(manio)
DATA                          ieqcas/eqcsu,mdumm,eqcno,eqccl/
INTEGER                ::     ieqmgs(manio)
DATA                          ieqmgs/eqmsu,mdumm,eqmno,eqmcl/
!____________________________________________________________________________________________
DATA leqsolute(0:jSOL)/.FALSE.,&
         .FALSE.,       .FALSE.,       .FALSE.,       .FALSE.,       .FALSE.,&
         .TRUE.,        .TRUE.,        .TRUE.,        .TRUE.,        .TRUE.,&
         .FALSE.,       .TRUE.,        .TRUE.,        .TRUE.,        .TRUE.,&
         .FALSE.,       .TRUE.,        .TRUE.,        .TRUE.,        .TRUE.,&
         .FALSE.,       .TRUE.,        .FALSE.,       .TRUE.,        .TRUE.,&
         .FALSE.,       .TRUE.,        .FALSE.,       .TRUE.,        .TRUE./
!____________________________________________________________________________________________
DATA ieqsolute(0:jSOL,jSS)/mdumm,&
          eqh2o,         eqhsa,         eqhna,         eqhca,         eqxam,&
          eqalc,         eqasu,         eqahs,         eqano,         eqacl,&
          eqslc,         eqssu,         eqshs,         eqsno,         eqscl,&
          eqplc,         eqpsu,         eqphs,         eqpno,         eqpcl,&
          eqc01,         eqcsu,         eqc02,         eqcno,         eqccl,&
          eqm01,         eqmsu,         eqm02,         eqmno,         eqmcl/
!____________________________________________________________________________________________
DATA ieqsolute(0:jSOL,jSP)/mdumm,&
          mdumm,         mdumm,         mdumm,         mdumm,         mciam,&
          mciam,         mciam,         mciam,         mciam,         mciam,&
          mciso,         mciso,         mciso,         mciso,         mciso,&
          mcipo,         mcipo,         mcipo,         mcipo,         mcipo,&
          mdumm,         mcica,         mcica,         mcica,         mcica,&
          mdumm,         mcimg,         mdumm,         mcimg,         mcimg/
!____________________________________________________________________________________________
DATA ieqsolute(0:jSOL,jSM)/mdumm,&
          mdumm,         maisu,         maino,         maicl,         mdumm,&
          maisu,         maisu,         maihs,         maino,         maicl,&
          maisu,         maisu,         maihs,         maino,         maicl,&
          maisu,         maisu,         maihs,         maino,         maicl,&
          mdumm,         maisu,         mdumm,         maino,         maicl,&
          mdumm,         maisu,         mdumm,         maino,         maicl/
!____________________________________________________________________________________________
DATA ceqsolute(0:jSOL)/ 'eqdum',                                             &
         'eqh2o',       'eqhsa',       'eqhna',       'eqhca',       'eqxam',&
         'eqalc',       'eqasu',       'eqahs',       'eqano',       'eqacl',&
         'eqslc',       'eqssu',       'eqshs',       'eqsno',       'eqscl',&
         'eqplc',       'eqpsu',       'eqphs',       'eqpno',       'eqpcl',&
         'eqc01',       'eqcsu',       'eqc02',       'eqcno',       'eqccl',&
         'eqm01',       'eqmsu',       'eqm02',       'eqmno',       'eqmcl'/
!____________________________________________________________________________________________
!        Ms   [kg/mol],&
DATA eqxy(jMs,0:jSOL)/  ZERO, &
       0.018020_dp,   0.098090_dp,   0.063020_dp,   0.036460_dp,   0.017040_dp,&
       0.247300_dp,   0.132170_dp,   0.115130_dp,   0.080060_dp,   0.053500_dp,&
       0.262120_dp,   0.142050_dp,   0.120070_dp,   0.085000_dp,   0.058440_dp,&
       0.310444_dp,   0.174266_dp,   0.136178_dp,   0.101108_dp,   0.074548_dp,&
       0.000000_dp,   0.136150_dp,   0.000000_dp,   0.164100_dp,   0.110980_dp,&
       0.000000_dp,   0.120375_dp,   0.000000_dp,   0.148325_dp,   0.095205_dp/
!____________________________________________________________________________________________
!        Ds   [kg/m^3],&
DATA eqxy(jDs,0:jSOL)/  ZERO, &
     997.000000_dp,1830.000000_dp,1513.000000_dp,1490.000000_dp, 696.000000_dp,&
    1775.000000_dp,1770.000000_dp,1780.000000_dp,1720.000000_dp,1519.000000_dp,&
    2565.000000_dp,2700.000000_dp,2430.000000_dp,2260.000000_dp,2170.000000_dp,&
    2490.000000_dp,2660.000000_dp,2320.000000_dp,2110.000000_dp,1988.000000_dp,&
    1700.000000_dp,2960.000000_dp,1700.000000_dp,2500.000000_dp,2150.000000_dp,&
    1000.000000_dp,2660.000000_dp,1000.000000_dp,2300.000000_dp,2325.000000_dp/
!____________________________________________________________________________________________
!        Za        [-],&
DATA eqxy(jZa,0:jSOL)/  ZERO, &
       1.000000_dp,   2.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,&
       3.000000_dp,   2.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,&
       3.000000_dp,   2.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,&
       3.000000_dp,   2.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,&
       3.000000_dp,   2.000000_dp,   3.000000_dp,   2.000000_dp,   2.000000_dp,&
       1.000000_dp,   2.000000_dp,   1.000000_dp,   2.000000_dp,   2.000000_dp/
!____________________________________________________________________________________________
!        Ws (T_o)  [%],&
DATA eqxy(jWs,0:jSOL)/  ZERO, &
       0.000000_dp,  70.000000_dp,  25.000000_dp,  15.000000_dp,  30.000000_dp,&
      53.300000_dp,  43.310000_dp,  76.000000_dp,  68.050000_dp,  28.340000_dp,&
      44.060000_dp,  21.940000_dp,  66.180000_dp,  47.700000_dp,  26.470000_dp,&
       0.000000_dp,  10.710000_dp,  33.600000_dp,  27.690000_dp,  26.230000_dp,&
       0.000000_dp,   0.210000_dp,   0.000000_dp,  59.020000_dp,  44.840000_dp,&
       0.000000_dp,  26.310000_dp,   0.000000_dp,  41.590000_dp,  35.900000_dp/
!____________________________________________________________________________________________
!        nu_s     [-],&
DATA eqxy(jNs,0:jSOL)/  ZERO, &
       2.000000_dp,   3.000000_dp,   2.000000_dp,   2.000000_dp,   1.000000_dp,&
       5.000000_dp,   3.000000_dp,   2.000000_dp,   2.000000_dp,   2.000000_dp,&
       5.000000_dp,   3.000000_dp,   2.000000_dp,   2.000000_dp,   2.000000_dp,&
       5.000000_dp,   3.000000_dp,   2.000000_dp,   2.000000_dp,   2.000000_dp,&
       5.000000_dp,   2.000000_dp,   5.000000_dp,   3.000000_dp,   3.000000_dp,&
       1.000000_dp,   2.000000_dp,   1.000000_dp,   3.000000_dp,   3.000000_dp/
!____________________________________________________________________________________________
!        nu_i     [-],&
DATA eqxy(jNi,0:jSOL)/  ZERO, &
       1.000000_dp,   1.761309_dp,   1.793689_dp,   2.681333_dp,   0.527416_dp,&
       1.616356_dp,   1.274822_dp,   1.253573_dp,   1.051480_dp,   1.243054_dp,&
       1.000000_dp,   1.278762_dp,   1.293906_dp,   1.160345_dp,   1.358377_dp,&
       1.000000_dp,   1.286445_dp,   1.308499_dp,   1.014102_dp,   1.256989_dp,&
       1.000000_dp,   1.271828_dp,   1.000000_dp,   1.586562_dp,   2.024869_dp,&
       1.000000_dp,   1.435281_dp,   1.000000_dp,   1.878693_dp,   2.107772_dp/
!____________________________________________________________________________________________
!        RHD (T_o) [-],&
DATA eqxy(jRHD,0:jSOL)/  ZERO, &
       1.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,   1.000000_dp,&
       0.690000_dp,   0.799700_dp,   0.400000_dp,   0.618300_dp,   0.771000_dp,&
       0.390000_dp,   0.930000_dp,   0.520000_dp,   0.737900_dp,   0.752800_dp,&
       1.000000_dp,   0.975000_dp,   0.860000_dp,   0.924800_dp,   0.842600_dp,&
       1.000000_dp,   0.990000_dp,   1.000000_dp,   0.490600_dp,   0.283000_dp,&
       1.000000_dp,   0.861300_dp,   1.000000_dp,   0.540000_dp,   0.328400_dp/
!____________________________________________________________________________________________
!        T-coef.   [-],&
DATA eqxy(jRHDc,0:jSOL)/  ZERO, &
       0.000000_dp,   0.000000_dp,   0.000000_dp,   0.000000_dp,   0.000000_dp,&
     186.000000_dp,  80.000000_dp, 384.000000_dp, 852.000000_dp, 239.000000_dp,&
       0.000000_dp,  80.000000_dp, -45.000000_dp, 304.000000_dp,  25.000000_dp,&
       0.000000_dp,  35.600000_dp,   0.000000_dp,   0.000000_dp, 159.000000_dp,&
       0.000000_dp,   0.000000_dp,   0.000000_dp, 509.400000_dp, 551.100000_dp,&
       0.000000_dp,-714.450000_dp,   0.000000_dp, 230.200000_dp,  42.230000_dp/
!____________________________________________________________________________________________
! GLOBAL INITIALIZATION
   nleq1=1
   nleq2=nleq
   neq1=1
   neq2=neq
!______________________________________
   DO n=nleq1,nleq2
!______________________________________
   DO i=neq1,neq2
      eqXPi(i)=ZERO
      eqXMi(i)=ZERO
      eqxp (i,0)=ZERO
      eqxp (i,1)=ZERO
      eqxp (i,2)=ZERO
      eqxp (i,3)=ZERO
      eqxp (i,4)=ZERO
      eqxp (i,5)=ZERO
      eqxm (i,0)=ZERO
      eqxm (i,1)=ZERO
      eqxm (i,2)=ZERO
      eqxm (i,3)=ZERO
      eqxm (i,4)=ZERO
      eqyg (i,1)=ZERO
      eqyg (i,2)=ZERO
      eqyg (i,3)=ZERO
      eqyg (i,4)=ZERO
      leqskip(i)=.TRUE.
      imask (i,n) = 1 ! comment line for 3-D implementation
   END DO
!______________________________________
! INPUT
   DO i=neq1,neq2
      eqWH2O(i)=xWH2O(i,n)
      eqTT  (i)=xTT  (i,n)
      eqAW  (i)=xAW  (i,n)
      eqRH  (i)=eqAW (i)
  END DO
   ! CATIONS [MOL/M^3(air)]
   DO IJ=1,mcati
   DO i=neq1,neq2
      eqxp (i,IJ)    =xYPa(i,n,IJ)
      eqXPi(i)=eqXPi(i)+eqxp(i,IJ)*eqxpz(IJ)
   END DO
   END DO ! mcati
   ! ANIONS [MOL/M^3(air)]
   DO IJ=1,manio
   DO i=neq1,neq2
      eqxm (i,IJ)    =xYMa(i,n,IJ)
      eqXMi(i)=eqXMi(i)+eqxm(i,IJ)*eqxmz(IJ)
   END DO
   END DO ! manio
    leqskip_all=.TRUE.
   DO i=neq1,neq2
      IF(eqXPi(i)+eqXMi(i) > TINYX) leqskip(i)=.FALSE.
      IF(imask (i,n) == 0) leqskip(i) =.TRUE.
      IF(.NOT.leqskip(i))  leqskip_all=.FALSE.
   END DO
!______________________________________
   IF(leqskip_all) GOTO 1000
!______________________________________
! DOMAINS
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      IWATeq(i)=2 ! SOLID+LIQUID AEROSOL
      IF(lmetastable.OR.eqWH2O(i) > REALZERO) &
      IWATeq(i)=1 ! METASTABLE AEROSOL
      TSO4(i) = eqxm(i,maihs)+eqxm(i,maisu)
      X1 = eqxmz (maihs)*eqxm(i,maihs)
      X2 = eqxmz (maisu)
      IF(lHSO4.AND.eqXPi(i)>ZERO.AND.eqXPi(i)<X1+X2) THEN
         Is=eqasu
         IF(eqxp(i,mciam) >= eqxm(i,maisu)*0.5_dp) Is=eqahs
         IF(eqxp(i,mcipo) >= eqxm(i,maisu)*0.5_dp) Is=eqphs
         IF(eqxp(i,mciso) >= eqxm(i,maisu)*0.5_dp) Is=eqshs
         IF(eqRH(i) >= eqxy(jRHD,Is)) X2=1.95_dp
      END IF
      X2 =            X2*eqxm(i,maisu)
      X3 = eqxpz (mciam)*eqxp(i,mciam)
      IDeq(i) = 0 ! SULFATE POOR
      IF(eqXPi(i) < TINYX .AND. TSO4(i) > TINYX) THEN
         IDeq(i) = 5 ! ONLY SULFURIC ACID
         eqxm(i,maisu)=eqxm(i,maihs)+eqxm(i,maisu)
         eqxm(i,maihs)=ZERO
      ELSE IF(eqXPi(i) > TINYX .AND. eqXPi(i) < TSO4(i)) THEN
         IDeq(i) = 4 ! SULFATE VERY RICH
         eqxm(i,maihs)=eqxm(i,maihs)+eqxm(i,maisu)
         eqxm(i,maisu)=ZERO
      ELSE IF(eqXPi(i) >= TSO4(i) .AND. eqXPi(i) < X1+X2) THEN
         IDeq(i) = 3 ! SULFATE RICH
         eqxm(i,maisu)=eqxm(i,maihs)+eqxm(i,maisu)
         eqxm(i,maihs)=ZERO
         XZ = MAX(ZERO,X1+X2-eqXPi(i))
         eqxm(i,maihs)=eqxm(i,maihs)+XZ
         eqxm(i,maisu)=eqxm(i,maisu)-XZ
      ELSE IF(eqXPi(i) >= X1+X2 .AND. eqXPi(i)-X3 < TSO4(i)) THEN
         IDeq(i) = 2 ! SULFATE NEUTRAL
      ELSE IF(eqXPi(i)-X3 >= TSO4(i)) THEN
         IDeq(i) = 1 ! SULFATE POOR / MINERAL CATION RICH
      END IF
      IF(IDeq(i) <= 2) THEN
         eqxm(i,maisu)=eqxm(i,maisu)+eqxm(i,maihs)
         eqxm(i,maihs)=ZERO
      END IF
   END DO
!______________________________________
! LOCAL INITIALIZATION
   Mw=eqxy(jMs,eqh2o)
   Dw=eqxy(jDs,eqh2o)
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      YY     (i)=ZERO
      eqWH2O (i)=ZERO
      eqMolm (i)=ZERO
      eqMs   (i)=ZERO
      eqNs   (i)=ZERO
      eqWs   (i)=ZERO
      eqNZm  (i)=ZERO
      NZeq   (i)=0
      eqPH   (i)=ZERO
      eqHPLUS(i)=ZERO
      eqsPM  (i)=ZERO
      eqaPM  (i)=ZERO
      eqPMs  (i)=ZERO
      eqPMt  (i)=ZERO
      eqVOL  (i)=ZERO
      eqGF   (i)=ONE
      eqRHO  (i)=ONE
      eqRHDM (i)=ONE
      eqXPi  (i)=ZERO
      eqXMi  (i)=ZERO
      XRHDMAX(i)=ZERO
      XRHDMIN(i)=ONE
      XRHDIFF(i)=ONE
   END DO
   DO IJ=1,mcati
      DO i=neq1,neq2
        eqyp(i,IJ,1) = ZERO
        eqyp(i,IJ,2) = ZERO
      END DO
   END DO
   DO IJ=1,manio
      DO i=neq1,neq2
        eqym(i,IJ,1) = ZERO
        eqym(i,IJ,2) = ZERO
      END DO
   END DO
   DO IS=0,jSOL
      eqxyA(Is)=ONE
      eqxyB(Is)=ZERO
      eqxyC(Is)=ZERO
      eqxyZ(Is)=ZERO
      DO i=neq1,neq2
         ieqsalt(i,Is)=0
         eqxyGF (i,Is)=ONE
         eqxyRHD(i,Is)=ONE
         eqxyKe  (i,Is)=ONE
         eqxyXS  (i,Is)=ONE
         eqxyMol (i,Is)=ZERO
         eqys(i,Is,jAP)=ZERO
         eqys(i,Is,jDP)=ZERO
         eqys(i,Is,jGP)=ZERO
      END DO
   END DO
!______________________________________
! NEUTRALIZATION/REACTION ORDER
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      IF(IDeq(i) < 3) THEN
          ieqsalt(i, 1)=eqcsu ; ieqsalt(i, 2)=eqmsu ; ieqsalt(i, 3)=eqpsu
          ieqsalt(i, 4)=eqssu ; ieqsalt(i, 5)=eqasu ; ieqsalt(i, 6)=eqcno
          ieqsalt(i, 7)=eqmno ; ieqsalt(i, 8)=eqpno ; ieqsalt(i, 9)=eqsno
          ieqsalt(i,10)=eqano ; ieqsalt(i,11)=eqccl ; ieqsalt(i,12)=eqmcl
          ieqsalt(i,13)=eqpcl ; ieqsalt(i,14)=eqscl ; ieqsalt(i,15)=eqacl
      END IF
      IF(IDeq(i) == 3) THEN
          ieqsalt(i, 1)=eqcsu ; ieqsalt(i, 2)=eqmsu
          ieqsalt(i, 3)=eqpsu ; ieqsalt(i, 4)=eqphs
          ieqsalt(i, 5)=eqssu ; ieqsalt(i, 6)=eqshs
          ieqsalt(i, 7)=eqasu ; ieqsalt(i, 8)=eqahs
      END IF
      IF(IDeq(i) == 4) THEN
          ieqsalt(i, 1)=eqcsu ; ieqsalt(i, 2)=eqmsu
          ieqsalt(i, 3)=eqphs ; ieqsalt(i, 4)=eqshs
          ieqsalt(i, 5)=eqahs ; ieqsalt(i, 6)=eqhsa
          ieqsalt(i, 7)=eqalc
      END IF
      IF(IDeq(i) == 5) THEN
          ieqsalt(i, 1)=eqhsa
          ieqsalt(i, 2)=eqalc
      END IF
   END DO
!______________________________________
! SOLUTE MOLALITY
   DO IJ=1,jSOL
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         Is=ieqsalt(i,IJ)
         IF(.NOT.leqsolute(Is)) CYCLE
         eqxyB(Is)=ZERO
         eqxyZ(Is)=eqxy(jNi,Is)
         eqxyMol(i,Is)=((eqxyKe(i,Is)/eqRH(i)-eqxyA(Is))/MW/eqxyZ(Is))**(ONE/eqxyZ(Is))
         !1st
         eqxyGF(i,Is) = (eqxy(jDs,Is)/(eqxy(jMs,Is)*Dw*eqxyMol(i,Is))+1._dp)**(1._dp/3._dp)
         IF(lke)    eqxyKe(i,Is) = exp(4._dp*Mw*sigma/(R*eqTT(i)*Dw*eqxyGF(i,Is)*Dd))
         eqxyXS(i,Is) = ONE/(ONE/(eqxy(jMs,Is)*eqxyMol(i,Is))+ONE)
         eqxyB   (Is) = eqxyXS(i,Is)**(ONE/(ONE+eqxyZ(Is)+eqxyXS(i,Is)))
         eqxyC   (Is) = ((eqxyKe(i,Is)/eqRH(i)-eqxyA(Is))/MW/eqxyZ(Is))**(ONE/eqxyZ(Is))
         IF(eqxyB(Is) < eqxyC(Is)) eqxyMol(i,Is) = eqxyC(Is)-eqxyB(Is)
         !2nd
         eqxyGF(i,Is) = (eqxy(jDs,Is)/(eqxy(jMs,Is)*Dw*eqxyMol(i,Is))+1._dp)**(1._dp/3._dp)
         IF(lke)    eqxyKe(i,Is) = exp(4._dp*Mw*sigma/(R*eqTT(i)*Dw*eqxyGF(i,Is)*Dd))
         eqxyXS(i,Is) = ONE/(ONE/(eqxy(jMs,Is)*eqxyMol(i,Is))+ONE)
         eqxyB   (Is) = eqxyXS(i,Is)**(ONE/(ONE+eqxyZ(Is)+eqxyXS(i,Is)))
         eqxyC   (Is) = ((eqxyKe(i,Is)/eqRH(i)-eqxyA(Is))/MW/eqxyZ(Is))**(ONE/eqxyZ(Is))
         IF(eqxyB(Is) < eqxyC(Is)) eqxyMol(i,Is) = eqxyC(Is)-eqxyB(Is)
         !3rd
         eqxyGF(i,Is) = (eqxy(jDs,Is)/(eqxy(jMs,Is)*Dw*eqxyMol(i,Is))+1._dp)**(1._dp/3._dp)
         IF(lke)    eqxyKe(i,Is) = exp(4._dp*Mw*sigma/(R*eqTT(i)*Dw*eqxyGF(i,Is)*Dd))
         eqxyXS(i,Is) = ONE/(ONE/(eqxy(jMs,Is)*eqxyMol(i,Is))+ONE)
         eqxyB   (Is) = eqxyXS(i,Is)**(ONE/(ONE+eqxyZ(Is)+eqxyXS(i,Is)))
         eqxyC   (Is) = ((eqxyKe(i,Is)/eqRH(i)-eqxyA(Is))/MW/eqxyZ(Is))**(ONE/eqxyZ(Is))
         IF(eqxyB(Is) < eqxyC(Is)) eqxyMol(i,Is) = eqxyC(Is)-eqxyB(Is)
         eqxyXS(i,Is) = ONE/(ONE/(eqxy(jMs,Is)*eqxyMol(i,Is))+ONE)
      END DO
   END DO
!______________________________________
! RELATIVE HUMIDITY OF DELIQUESCENCE
   DO IJ=1,jSOL
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         Is=ieqsalt(i,IJ)
         IF(IWATeq(i) == 2) THEN
            IF(.NOT.leqsolute(Is)) CYCLE
            IF(eqxy(jRHD,Is) >= ONE) CYCLE
            eqxyRHD (i,Is)=eqxy(jRHD,Is)*EXP(eqxy(jRHDc,Is)*(ONE/eqTT(i)-ONE/eqT0))
            eqxyRHD (i,Is)=eqxyRHD(i,Is)*eqxyKe(i,Is)
            eqxyRHD (i,Is)=MAX(ZERO,MIN(eqxyRHD(i,Is),0.999_dp))
         ELSE
            eqxyRHD (i,Is)=eqRH(i)
         END IF
      END DO
   END DO
!______________________________________
! EQUILIBRIUM
   DO IJ=1,jSOL
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         Is=ieqsalt(i,IJ)
         IF(.NOT.leqsolute(Is)) CYCLE
         Ip=ieqsolute(Is,jSP)
         Im=ieqsolute(Is,jSM)
         IF(Ip == 0 .OR. Im == 0 .OR. IDeq(i)==5) CYCLE
         IF(eqxp(i,Ip)*eqxm(i,Im) > REALZERO) THEN
            NZeq(i) = NZeq(i) + 1
            XZ = MAX(ZERO, MIN(eqxpz(Ip)*eqxp(i,Ip),eqxmz(Im )*eqxm(i,Im)))
            eqxp(i,Ip)   = MAX(ZERO,eqxp(i,Ip)-XZ/eqxpz(Ip))
            eqxm(i,Im)   = MAX(ZERO,eqxm(i,Im)-XZ/eqxmz(Im))
            eqys(i,Is,jAP) = eqys(i,Is,jAP)+XZ/eqxy(jZa,Is)
            eqNs(i)=eqNs(i)+eqys(i,Is,jAP)
         ELSE
            eqxyRHD(i,Is) = ONE
         END IF
      END DO
   END DO
!______________________________________
   IF(lrhdm) THEN
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      DO IJ=1,jSOL
         Is=ieqsalt(i,IJ)
         IF(.NOT.leqsolute(Is)) CYCLE
         IF(eqys(i,Is,jAP) > TINYX .AND. IWATeq(i) == 2) THEN
            eqNZm (i)=eqNZm(i)+ONE
            eqMs  (i)=eqMs(i)+eqxy(jMs,Is)
            XZ       =(ONE/(100._dp/eqxy(jWs,Is)-ONE))/eqxy(jMs,Is)
            eqMolm(i)=eqMolm(i)+XZ
            eqWs  (i)=MAX(0.1_dp,MIN(ONE,ONE/(ONE/(eqMolm(i)*eqMs(i))+ONE)))
            YY    (i)=ONE/MAX(ZERO,(0.25_dp*log(eqWs(i))+ONE))
            eqRHDM(i)=ONE/(ONE+Mw*YY(i)*(eqMolm(i))**YY(i))
         END IF
      END DO
   END DO
   END IF
   YY(:)=ONE
!______________________________________
! GAS/AEROSOL PARTITIONING OF SEMI-VOLATILES
   IF(lvola) THEN
   ! semi-volatiles
   DO IJ=1,jVOL
      Is=ieqvola(IJ)
      IF(.NOT.leqsolute(Is)) CYCLE
      Ip=ieqsolute(Is,jSP)
      Im=ieqsolute(Is,jSM)
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         IF(IDeq(i) >2) CYCLE
         XZ = eqys(i,Is,jAP)
         IF(XZ > TINYX) THEN
            YY(i)=ONE
            ! TEMPERATURE DEPENDENT EQUILIBRIUM CONSTANTS
            T0T=eqT0/eqTT(i)
            COEF=ONE+LOG(T0T)-T0T
            X1=ONE/(ONE/(eqxy(jMs,Is)*eqxyMol(i,Is))+ONE)
            X2=MAX(ZERO,MIN(2._dp*X1**2._dp,2._dp))
            XRHDMIN(i)=eqxyRHD(i,Is)
            IF(Is == eqacl) THEN
               ! NH4CL(S) <==> NH3(G) + HCL(G)   [ppb^2]
               X3   = 1.086E-16_dp ! [ppb^2]
               X3   = X3*EXP(-71.00_dp*(T0T-ONE)+2.400_dp*COEF)
               KEQ  = X3/(eqR*eqTT(i))/(eqR*eqTT(i)) ! [(mol^2/m^3(air))^2]
            END IF
            IF(Is == eqano) THEN
               ! NH4NO3(S) <==> NH3(G) + HNO3(G)
               ! ISORROPIA2
               X3   = 5.746E-17_dp ! [ppb^2]
               X3   = X3*EXP(-74.38_dp*(T0T-ONE)+6.120_dp*COEF)
               ! Mozurkewich (1993)
               !X3   = 4.199E-17_dp ! [ppb^2]
               !X3   = X3*EXP(-74.7351_dp*(T0T-ONE)+6.025_dp*COEF)
               ! SEQUILIB
               !X3   = 2.985e-17_dp ! [ppb^2]
               !X3   = X3*EXP(-75.11_dp*(T0T-ONE)+13.460_dp*COEF)
               KEQ   = X3/(eqR*eqTT(i))/(eqR*eqTT(i)) ! [(mol^2/m^3(air))^2]
            END IF
            COEF=X2
            IF(lmixs.AND.TSO4(i)>eqXPi(i)) THEN
!           IF(lmixs.AND.TSO4(i)>TINYX) THEN
               YY(i)=(XZ/(XZ+3._dp*TSO4(i)))**0.8_dp
               IF(lrhdm.AND.IWATeq(i)==2) &
               XRHDMIN(i)=eqRHDM(i)*YY(i)**0.25_dp+eqxyRHD(i,Is)   *(ONE-YY(i)**0.25_dp)
!              XRHDMIN(i)=eqRHDM(i)*YY(i)**0.25_dp+eqxyRHD(i,eqasu)*(ONE-YY(i)**0.25_dp)
               IF(eqRH(i)>=XRHDMIN(i)) THEN
                  COEF=X2*YY(i)
                  XZ=XZ*(ONE-COEF)
               END IF
            END IF
            IF(eqRH(i)<XRHDMIN(i)) THEN
               COEF=ONE
            ELSE
               IF(Is==eqacl) KEQ=KEQ*6.0_dp
            END IF
            KEQ=KEQ*COEF
            X1=eqxp(i,Ip)+eqxm(i,Im) ! [mol/m3(air)]
            X2=SQRT(X1*X1+4._dp*KEQ)
            X3=0.5_dp*(-X1+X2)
            X3=MIN(XZ,X3)
            eqxp(i,Ip)=eqxp(i,Ip)+X3
            eqxm(i,Im)=eqxm(i,Im)+X3
            eqys(i,Is,jAP)=MAX(0._dp,eqys(i,Is,jAP)-X3)
         END IF
      END DO
   END DO
   END IF
!______________________________________
! LIQUID/SOLID PARTITIONING
   DO IJ=1,jSOL
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         Is=ieqsalt(i,IJ)
         IF(.NOT.leqsolute(Is)) CYCLE
         IF(eqys(i,Is,jAP) < REALZERO) CYCLE
         IF(IWATeq(i) == 2) THEN
            XRHDIFF(i)=ONE
            XRHDMAX(i)=eqxyRHD(i,Is)
            IF(lrhdm.AND.eqNZm(i)>ONE.AND.Is/=eqcsu.AND.Is/=eqpsu) THEN
               XRHDMIN(i)=eqRHDM(i)
               YZ(i)=eqys(i,Is,jAP)/eqNs(i)
               XRHDMAX(i)=XRHDMIN(i)*YZ(i)**0.25_dp+XRHDMAX(i)*(ONE-YZ(i)**0.25_dp)
            ELSE
               XRHDMIN(i)=XRHDMAX(i)
            END IF
            IF(eqRH(i) < XRHDMAX(i)) THEN
               IF(eqRH(i)> XRHDMIN(i)   .AND.   XRHDMIN(i)<XRHDMAX(i)) &
               XRHDIFF(i)=(XRHDMAX(i)-eqRH(i))/(XRHDMAX(i)-XRHDMIN(i))
               eqys(i,Is,jDP) = MAX(0._dp,eqys(i,Is,jDP) + eqys(i,Is,jAP)*XRHDIFF(i))
               eqys(i,Is,jAP) = MAX(0._dp,eqys(i,Is,jAP) * (ONE-XRHDIFF(i)))
            END IF
         END IF
      END DO
   END DO
!______________________________________
! AEROSOL WATER [KG/M^3(AIR)]
   DO IJ=1,jSOL
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         Is=ieqsalt(i,IJ)
         IF(.NOT.leqsolute(Is)) CYCLE
         IF(eqxyMol(i,Is) > REALZERO) &
         eqWH2O(i) = eqWH2O(i) + eqys(i,Is,jAP)/eqxyMol(i,Is)
      END DO
   END DO
!______________________________________
! Remaining H+/OH- [MOL]
   DO IJ=1,mcati
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         eqXPi(i)=eqXPi(i)+eqxp(i,IJ)*eqxpz(IJ)
      END DO
   END DO
   DO IJ=1,manio
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         eqXMi(i)=eqXMi(i)+eqxm(i,IJ)*eqxmz(IJ)
      END DO
   END DO
!  DO i=neq1,neq2
!     IF(leqskip(i)) CYCLE
!     eqHPLUS(i)=eqXPi(i)-eqXMi(i)
!  END DO
!______________________________________
! RESIDUAL GASES
   DO IJ=1,jGAS
      Is=ieqgases(IJ)
      Ip=ieqsolute(Is,jSP)
      Im=ieqsolute(Is,jSM)
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         XZ=eqxm(i,Im)
         IF(Is == eqxam) XZ=eqxp(i,Ip)
         IF(Is == eqhsa) XZ=eqxm(i,maisu)+eqxm(i,maihs)
         IF(XZ < REALZERO) CYCLE
         IF(Is == eqhna) THEN
            eqyg(i,1)  = XZ
            eqxm(i,Im) = ZERO
         ELSE IF(Is == eqhca) THEN
            eqyg(i,2)  = XZ
            eqxm(i,Im) = ZERO
         ELSE IF(Is == eqxam) THEN
            eqyg(i,3)  = XZ
            eqxp(i,Ip) = ZERO
         ELSE IF(Is == eqhsa) THEN
            II=eqalc
            IF(eqxyMol(i,II) > REALZERO) &
            eqWH2O(i) = eqWH2O(i) + XZ/eqxyMol(i,II)
            IF(lH2SO4gas) THEN
               eqyg(i,4)  = XZ
               eqxm(i,maisu) = ZERO
               eqxm(i,maihs) = ZERO
            END IF
         END IF
      END DO
   END DO
!______________________________________
! OUTPUT
   DO IJ=1,mcati
      DO i=neq1,neq2
        IF(leqskip(i)) CYCLE
        eqyp (i,IJ,1)=eqyp(i,IJ,1)+eqxp(i,IJ)
        eqaPM(i)=eqaPM(i)+eqxp(i,IJ)
        eqPMt(i)=eqPMt(i)+eqxp(i,IJ)*eqxpm(IJ)
      END DO
   END DO
   DO IJ=1,manio
      DO i=neq1,neq2
        IF(leqskip(i)) CYCLE
        eqym (i,IJ,1)=eqym(i,IJ,1)+eqxm(i,IJ)
        eqaPM(i)=eqaPM(i)+eqxm(i,IJ)
        eqPMt(i)=eqPMt(i)+eqxm(i,IJ)*eqxmm(IJ)
      END DO
   END DO
   DO IJ=1,mcati
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         eqym(i,maisu,1) = eqym(i,maisu,1) + eqys(i,ieqsu(IJ),jAP)*eqxy(jZa,ieqsu(IJ))/eqxmz(ieqsolute(ieqsu(IJ),jSM))
         eqym(i,maisu,2) = eqym(i,maisu,2) + eqys(i,ieqsu(IJ),jDP)*eqxy(jZa,ieqsu(IJ))/eqxmz(ieqsolute(ieqsu(IJ),jSM))
         eqym(i,maihs,1) = eqym(i,maihs,1) + eqys(i,ieqhs(IJ),jAP)*eqxy(jZa,ieqhs(IJ))/eqxmz(ieqsolute(ieqhs(IJ),jSM))
         eqym(i,maihs,2) = eqym(i,maihs,2) + eqys(i,ieqhs(IJ),jDP)*eqxy(jZa,ieqhs(IJ))/eqxmz(ieqsolute(ieqhs(IJ),jSM))
         eqym(i,maino,1) = eqym(i,maino,1) + eqys(i,ieqno(IJ),jAP)*eqxy(jZa,ieqno(IJ))/eqxmz(ieqsolute(ieqno(IJ),jSM))
         eqym(i,maino,2) = eqym(i,maino,2) + eqys(i,ieqno(IJ),jDP)*eqxy(jZa,ieqno(IJ))/eqxmz(ieqsolute(ieqno(IJ),jSM))
         eqym(i,maicl,1) = eqym(i,maicl,1) + eqys(i,ieqcl(IJ),jAP)*eqxy(jZa,ieqcl(IJ))/eqxmz(ieqsolute(ieqcl(IJ),jSM))
         eqym(i,maicl,2) = eqym(i,maicl,2) + eqys(i,ieqcl(IJ),jDP)*eqxy(jZa,ieqcl(IJ))/eqxmz(ieqsolute(ieqcl(IJ),jSM))
      END DO
   END DO
   DO IJ=1,manio
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         eqyp(i,mciam,1) = eqyp(i,mciam,1) + eqys(i,ieqams(IJ),jAP)*eqxy(jZa,ieqams(IJ))/eqxpz(ieqsolute(ieqams(IJ),jSP))
         eqyp(i,mciam,2) = eqyp(i,mciam,2) + eqys(i,ieqams(IJ),jDP)*eqxy(jZa,ieqams(IJ))/eqxpz(ieqsolute(ieqams(IJ),jSP))
         eqyp(i,mciso,1) = eqyp(i,mciso,1) + eqys(i,ieqsos(IJ),jAP)*eqxy(jZa,ieqsos(IJ))/eqxpz(ieqsolute(ieqsos(IJ),jSP))
         eqyp(i,mciso,2) = eqyp(i,mciso,2) + eqys(i,ieqsos(IJ),jDP)*eqxy(jZa,ieqsos(IJ))/eqxpz(ieqsolute(ieqsos(IJ),jSP))
         eqyp(i,mcipo,1) = eqyp(i,mcipo,1) + eqys(i,ieqpos(IJ),jAP)*eqxy(jZa,ieqpos(IJ))/eqxpz(ieqsolute(ieqpos(IJ),jSP))
         eqyp(i,mcipo,2) = eqyp(i,mcipo,2) + eqys(i,ieqpos(IJ),jDP)*eqxy(jZa,ieqpos(IJ))/eqxpz(ieqsolute(ieqpos(IJ),jSP))
         eqyp(i,mcica,1) = eqyp(i,mcica,1) + eqys(i,ieqcas(IJ),jAP)*eqxy(jZa,ieqcas(IJ))/eqxpz(ieqsolute(ieqcas(IJ),jSP))
         eqyp(i,mcica,2) = eqyp(i,mcica,2) + eqys(i,ieqcas(IJ),jDP)*eqxy(jZa,ieqcas(IJ))/eqxpz(ieqsolute(ieqcas(IJ),jSP))
         eqyp(i,mcimg,1) = eqyp(i,mcimg,1) + eqys(i,ieqmgs(IJ),jAP)*eqxy(jZa,ieqmgs(IJ))/eqxpz(ieqsolute(ieqmgs(IJ),jSP))
         eqyp(i,mcimg,2) = eqyp(i,mcimg,2) + eqys(i,ieqmgs(IJ),jDP)*eqxy(jZa,ieqmgs(IJ))/eqxpz(ieqsolute(ieqmgs(IJ),jSP))
      END DO
   END DO
   ! PARTICULATE MATTER
   DO Is=1,jSOL
      IF(.NOT.leqsolute(Is)) CYCLE
      DO i=neq1,neq2
         IF(leqskip(i)) CYCLE
         eqsPM(i)=eqsPM(i)+eqys(i,Is,jDP)*eqxy(jNs,Is)
         eqaPM(i)=eqaPM(i)+eqys(i,Is,jAP)*eqxy(jNs,Is)
         eqPMt(i)=eqPMt(i)+eqys(i,Is,jAP)*eqxy(jMs,Is)
         eqPMs(i)=eqPMs(i)+eqys(i,Is,jDP)*eqxy(jMs,Is)
         eqVOL(i)=eqVOL(i)+eqys(i,Is,jAP)*eqxy(jMs,Is)/eqxy(jDs,Is)
         eqVOL(i)=eqVOL(i)+eqys(i,Is,jDP)*eqxy(jMs,Is)/eqxy(jDs,Is)
      END DO
   END DO
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      ! TOTAL PM      [KG/M^3(AIR)]
      eqPMt(i)=eqPMt(i)+eqPMs(i)
      ! TOTAL VOLUME  [M^3/M^3(AIR)]
      ! TOTAL DENSITY [KG/M^3]
      IF(eqVOL(i) > REALZERO) &
      eqRHO(i)=eqPMt(i)/eqVOL(i)
      ! AQUEOUS PHASE PROPERTIES
   END DO
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      eqGF(i) = ONE
      IF(eqWH2O(i) > 1.e-12_dp) THEN
         T0T=eqT0/eqTT(i)
         COEF=ONE+LOG(T0T)-T0T
         ! AUTODISSOCIATION CONSTANT (KW) OF WATER
         X1   = 1.010E-14_dp
         KEQ  = X1*EXP(-22.52_dp*(T0T-ONE) + 26.920_dp*COEF)
         ! H2O <==> H+ + OH- WITH KW [MOL^2/KG^2]
         AKW  = KEQ*eqRH(i)*eqWH2O(i)*eqWH2O(i)
         ! [OH-] = [H+] [MOL]
         AKW  = AKW**0.5_dp
         ! H+ PARAMETERIZATION
         XZ=eqXMi(i)-eqXPi(i)
         IF(IDeq(i) > 2) THEN
            eqHPLUS(i)=XZ+eqyg(i,3)-eqyg(i,1)
            XZ=(eqHPLUS(i)/eqWH2O(i)+AKW)*Dw*1.e-3_dp
         ELSE IF(IDeq(i) < 3) THEN
             eqHPLUS(i)=XZ+eqyg(i,3)
             XZ=(eqHPLUS(i)/eqWH2O(i)+AKW)*Dw*1.e-6_dp
         END IF
         ! AEROSOL PH
         IF (XZ > REALZERO) THEN
            ! HYDROGEN CONCENTRATION [MOL/L(H2O)]
            eqPH(i) = -LOG10(XZ)
         ELSE IF (XZ < REALZERO) THEN
            ! HYDROXY ION CONCENTRATION [MOL/L(H2O)]
            eqPH(i) = 14._dp + LOG10(-XZ)
            eqHPLUS(i)=ZERO
         END IF
         ! Growth Factor [-]
         eqGF(i) =(eqRHO(i)/Dw*eqWH2O(i)/eqPMt(i)+ONE)**(1._dp/3._dp)
      END IF
   END DO
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      ! AEROSOL WATER  [UG/M^3]
      eqWH2O(i) = eqWH2O(i)*1.E9_dp
      ! TOTAL PM      [UG/M^3(AIR)]
      eqPMt(i)=eqPMt(i)*1.E9_dp
      ! DRY PM        [UG/M^3(AIR)]
      eqPMs(i)=eqPMs(i)*1.E9_dp
      ! DRY PM        [UMOL/M^3(AIR)]
      eqsPM(i)=eqsPM(i)*1.E6_dp
      ! AQUEOUS PM    [UMOL/M^3(AIR)]
      eqaPM(i)=eqaPM(i)*1.E6_dp
      ! AQUEOUS H+    [MOL/M^3(AIR)]
      eqHPLUS(i)=eqHPLUS(i)!*1.E6_dp
      ! DENSITY [G/CM^3]
      eqRHO(i)=eqRHO(i)*1.e-3_dp
      eqVOL(i)=eqPMt(i)/eqRHO(i)
   END DO
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      xWH2O(i,n)=eqWH2O(i)
      xPMt (i,n)=eqPMt (i)
      xPMs (i,n)=eqPMs (i)
      xsPM (i,n)=eqsPM (i)
      xaPM (i,n)=eqaPM (i)
      xRHO (i,n)=eqRHO (i)
      xVOL (i,n)=eqVOL (i)
      xPH  (i,n)=eqPH  (i)
      xGF  (i,n)=eqGF  (i)
      xHp  (i,n)=eqHPLUS(i)
   END DO
   DO IJ=1,mcati
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
       xYPa(i,n,IJ)=eqyp(i,IJ,1)
       xYPs(i,n,IJ)=eqyp(i,IJ,2)
   END DO
   END DO
   DO IJ=1,manio
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
       xYMa(i,n,IJ)=eqym(i,IJ,1)
       xYMs(i,n,IJ)=eqym(i,IJ,2)
   END DO
   END DO
   DO IJ=1,jGAS
   DO i=neq1,neq2
      IF(leqskip(i)) CYCLE
      xYG(i,n,IJ)=eqyg(i,IJ)
   END DO
   END DO
!______________________________________
1000 CONTINUE  ! leqskip_all = .TRUE.
!______________________________________
END DO ! nleq1,nleq2
!____________________________________________________________________________________________
END SUBROUTINE EQSAM4clim
!____________________________________________________________________________________________

      Module node_mod                                               
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Variable descriptions:
c     Input:
c       nmachs          I  total number of procs
c       machs           I  processor IDs
c       mynum           I  current processor ID
c       master_num      I  processor ID of the master: default = 0
c
c       Grid index:
c
c    These variables are scalars that are set to the value 
c    for the current grid.
c       mxp             I  number of col in slice
c       myp             I  number of row in slice
c       mzp             I  number of layers in slice
c       ia              I  start index of col in computational slice
c       iz              I  end index of col in computational slice
c       ja              I  start index of row in computational slice
c       jz              I  end index of row in computational slice
c       i0              I  offset of start col of slice in full domain
c       j0              I  offset of start row of slice in full domain
c       ibcon           I  bcon flag value: max= 1+2+4+8=15
c                          bit 1=west, bit 2=east, bit 3=south, bit 4=north
c                          deternines if cell is on a true boundary
c
c    These variables are arrays that store values for all grids
c    for the current processor.
c       mmxp            I  number of col in slice
c       mmyp            I  number of row in slice
c       mmzp            I  number of layers in slice
c       mia             I  start index of col in computational slice
c       miz             I  end index of col in computational slice
c       mja             I  start index of row in computational slice
c       mjz             I  end index of row in computational slice
c       mi0             I  offset of start col of slice in full domain
c       mj0             I  offset of start row of slice in full domain
c       mibcon          I  bcon flag value: max= 1+2+4+8=15
c
c    These variables are 2-D arrays that store values for all grids
c    and all of the processor.
c       nodemxp         I  number of col in slice
c       nodemyp         I  number of row in slice
c       nodemzp         I  number of layers in slice
c       nodeia          I  start index of col in computational slice
c       nodeiz          I  end index of col in computational slice
c       nodeja          I  start index of row in computational slice
c       nodejz          I  end index of row in computational slice
c       nodei0          I  offset of start col of slice in full domain
c       nodej0          I  offset of start row of slice in full domain
c       nodeibcon       I  bcon flag value: max= 1+2+4+8=15
c       nodeedge        L  true if slice has an edge cell in master grid
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c       04/30/13     Added suface model
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid_dims, only : MAXGRDS,MAXMACH   ! MAXGRDS=10, MAXMACH=256
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer          :: nmachs
      integer          :: machs(MAXMACH)
      integer          :: mynum
      integer          :: master_num
c
c  ---- Variables: grid index ----
c
      integer          :: mxp
      integer          :: myp
      integer          :: mzp
      integer          :: ia
      integer          :: iz
      integer          :: ja
      integer          :: jz
      integer          :: i0
      integer          :: j0
      integer          :: ibcon
c
c  ---- One dimensional grid index, dimensioned by MAXGRDS ----
c
      integer, target  :: mmxp(MAXGRDS)
      integer, target  :: mmyp(MAXGRDS)
      integer, target  :: mmzp(MAXGRDS)
      integer          :: mia(MAXGRDS)
      integer          :: miz(MAXGRDS)
      integer          :: mja(MAXGRDS)
      integer          :: mjz(MAXGRDS)
      integer          :: mi0(MAXGRDS)
      integer          :: mj0(MAXGRDS)
      integer          :: mibcon(MAXGRDS)
c
c  ---- Two dimensional grid index, dimensioned by MAXMACH+1 and MAXGRDS ----
c
      integer          :: nodemxp(0:MAXMACH,MAXGRDS)
      integer          :: nodemyp(0:MAXMACH,MAXGRDS)
      integer          :: nodemzp(0:MAXMACH,MAXGRDS)
      integer          :: nodeia(0:MAXMACH,MAXGRDS)
      integer          :: nodeiz(0:MAXMACH,MAXGRDS)
      integer          :: nodeja(0:MAXMACH,MAXGRDS)
      integer          :: nodejz(0:MAXMACH,MAXGRDS)
      integer          :: nodei0(0:MAXMACH,MAXGRDS)
      integer          :: nodej0(0:MAXMACH,MAXGRDS)
      integer          :: nodeibcon(0:MAXMACH,MAXGRDS)
      logical          :: nodeedge(MAXMACH)
c
c     Neighborhood relationships 
c         5: beg_col, beg_row, end_col, end_row, destination_node_id
c         7: the 7th of the second dim of the ipaths(,7,,) array is used to determine
c            the loop limits in fdbackp (aggregation) for averaging the fm over the overlap
c            between the cm node and fm node, rather than always over the full
c            fm node.  It is not used for actually sending stuff.  The
c            ipaths(,6,,) part of the array is still used for sending the
c            block of averaged cm points from the fm node to the cm node.
c         6: means 6 isend_type(s), this 6 in iget_paths is the same as the 
c            first six elements in ipaths(,7,,)
c
      integer          :: ipaths(5,7,MAXGRDS,MAXMACH)
      integer          :: bpaths(5,7,MAXGRDS,MAXMACH)
      integer          :: iget_paths(6,MAXGRDS,MAXMACH)
c
c  ---- Could be the ierr flags for msg passing ----
c
      integer          :: irecv_req(MAXMACH)
      integer          :: isend_req(MAXMACH)
      integer          :: irecv_req_dp(MAXMACH)
      integer          :: isend_req_dp(MAXMACH)
      integer          :: irecv_req_smsol(MAXMACH)
      integer          :: isend_req_smsol(MAXMACH)
      integer          :: irecv_req_smveg(MAXMACH)
      integer          :: isend_req_smveg(MAXMACH)
      integer          :: irecv_req_pt(MAXMACH)
      integer          :: isend_req_pt(MAXMACH)
      integer          :: irecv_req_rad(MAXMACH)
      integer          :: isend_req_rad(MAXMACH)
      integer          :: irecv_req_dry(MAXMACH)
      integer          :: isend_req_dry(MAXMACH)
      integer          :: irecv_req_wet(MAXMACH)
      integer          :: isend_req_wet(MAXMACH)
      integer          :: irecv_req_rtsol(MAXMACH)
      integer          :: isend_req_rtsol(MAXMACH)
      integer          :: irecv_req_rtveg(MAXMACH)
      integer          :: isend_req_rtveg(MAXMACH)
c
c  ---- Values to measure the max length of array buffer ----
c
      integer          :: nbuff_feed
      integer          :: newbuff_nest
      integer          :: nbuff_nest
c
c  ---- An defined type to help transfer the bcon array buffer ----
c
      type nlbc_buffs
         real, pointer :: lbc_send_buff(:)
         real, pointer :: lbc_recv_buff(:)
         real, pointer :: lbc_dp_send_buff(:)
         real, pointer :: lbc_dp_recv_buff(:) 
         real, pointer :: lbc_smsol_send_buff(:)
         real, pointer :: lbc_smsol_recv_buff(:) 
         real, pointer :: lbc_smveg_send_buff(:)
         real, pointer :: lbc_smveg_recv_buff(:) 
         real, pointer :: lbc_pt_send_buff(:)
         real, pointer :: lbc_pt_recv_buff(:) 
         real, pointer :: lbc_rad_send_buff(:)
         real, pointer :: lbc_rad_recv_buff(:)
         real, pointer :: lbc_dry_send_buff(:)
         real, pointer :: lbc_dry_recv_buff(:) 
         real, pointer :: lbc_wet_send_buff(:)
         real, pointer :: lbc_wet_recv_buff(:) 
         real, pointer :: lbc_rtsol_send_buff(:)
         real, pointer :: lbc_rtsol_recv_buff(:)
         real, pointer :: lbc_rtveg_send_buff(:)
         real, pointer :: lbc_rtveg_recv_buff(:)
         integer       :: nsend
         integer       :: nrecv
      end type
c
      type (nlbc_buffs) :: node_buffs(MAXMACH)
c
      end module node_mod

      subroutine hr_nox3(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_NOX3 solves the NOx family using Hertel's equations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CB6r5h plus GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real jO3_O1D, rNO2_O3P, rO3P_O3, rO3wNO
      real totO1D, totNO, totNO2, totO3P, totO3
      real lsO1D, lsNO, lsNO2, lsO3P, lsO3
      real yldO3P, rNO_NO2, rNO2_NO
      real t1, t2, t3, t4, t5, f1, f2, f3, f4, s1, s2, A, B, C, Q
c
c --- Entry Point
c
      N2 = M - O2
c
c --- O1D loss
c
      lsO1D = 
     &       + rk( 10)*M
     &       + rk( 11)*H2O
c
c --- Yield of O3P from O1D
c
      yldO3P  = ( rk( 10)*M ) / lsO1D
c
c --- Conversion of NO2 to NO
c     (rNO2_NO = rate of NO2 to NO)
c
      rNO2_NO  = dt*(
     &       +          rk(  1)
     &       +          rk(  5)*yh(lO) )
c
c --- NO production terms except rNO2_NO
c     (totNO = initial NO + new production)
c
      totNO = y0(lNO) + dt*(
     &       +          r( 28)
     &       +          r( 30)
     &       +          r( 42)
     &       +          r( 43) )
c
c --- Net loss of NO
c     (net either NO or NO2 produced)
c
      lsNO = 1.0 + dt*(
     &       +          rk( 40)*yh(lOH)
     &       +          rk( 41)*yh(lNO2)*H2O
     &       +          rk( 83)*yh(lXO2N)
     &       + ( 0.100)*rk(144)*yh(lISO2)
     &       + ( 0.082)*rk(168)*yh(lBZO2)
     &       + ( 0.140)*rk(173)*yh(lTO2)
     &       + ( 0.140)*rk(178)*yh(lXLO2) )
c
c --- Conversion of NO to NO2 except O3+NO (rO3wNO)
c
      rNO_NO2 = dt*(
     &       +          rk(  4)*yh(lO)
     &       + ( 2.000)*rk( 24)*yh(lNO)*O2
     &       +          rk( 25)*yh(lHO2)
     &       +          rk( 29)*yh(lNO3)
     &       +          rk( 53)*yh(lC2O3)
     &       +          rk( 61)*yh(lCXO3)
     &       +          rk( 71)*yh(lMEO2)
     &       +          rk( 75)*yh(lXO2H)
     &       +          rk( 79)*yh(lXO2)
     &       +          rk(102)*yh(lHCO3)
     &       + ( 0.900)*rk(144)*yh(lISO2)
     &       +          rk(160)*yh(lEPX2)
     &       + ( 0.918)*rk(168)*yh(lBZO2)
     &       + ( 0.860)*rk(173)*yh(lTO2)
     &       + ( 0.860)*rk(178)*yh(lXLO2)
     &       +          rk(199)*yh(lOPO3)
     &       +          rk(215)*yh(lIO)
     &       +          rk(220)*yh(lOIO)
     &       +          rk(245)*yh(lCLO)
     &       +          rk(298)*yh(lBRO) )
c
c --- Remaining NO2 production
c
      totNO2 = y0(lNO2) + dt*(
     &       +          r( 27)
     &       +          r( 29)
     &       +          r( 31)
     &       +          r( 32)
     &       +          r( 33)
     &       +          r( 34)
     &       + ( 2.000)*r( 35)
     &       +          r( 37)
     &       +          r( 38)
     &       +          r( 42)
     &       +          r( 44)
     &       +          r( 47)
     &       +          r( 49)
     &       + ( 0.590)*r( 50)
     &       +          r( 51)
     &       +          r( 55)
     &       + ( 0.600)*r( 56)
     &       +          r( 63)
     &       + ( 0.600)*r( 64)
     &       +          r( 92)
     &       + ( 0.500)*r(136)
     &       + ( 0.500)*r(139)
     &       + ( 0.500)*r(142)
     &       + ( 0.350)*r(150)
     &       + ( 0.142)*r(153)
     &       + ( 0.444)*r(163)
     &       + ( 0.470)*r(166)
     &       + ( 0.500)*r(192)
     &       +          r(201)
     &       + ( 0.500)*r(205)
     &       +          r(206)
     &       +          r(247)
     &       +          r(248)
     &       +          r(250)
     &       +          r(290)
     &       +          r(300)
     &       + ( 0.150)*r(301)
     &       +          r(325)
     &       + ( 2.000)*r(326)
     &       +          r(327) )
c
c --- Net loss of NO2
c     (net either NO or NO2 produced)
c
      lsNO2 = 1.0 + dt*(
     &       +          rk(  6)*yh(lO)
     &       +          rk( 26)*yh(lO3)
     &       +          rk( 36)*yh(lNO3)
     &       +          rk( 41)*yh(lNO)*H2O
     &       +          rk( 45)*yh(lOH)
     &       +          rk( 48)*yh(lHO2)
     &       +          rk( 54)*yh(lC2O3)
     &       +          rk( 62)*yh(lCXO3)
     &       +          rk(132)*yh(lROR)
     &       +          rk(184)*yh(lCRO)
     &       +          rk(200)*yh(lOPO3)
     &       +          rk(216)*yh(lIO)
     &       +          rk(234)*yh(lOH)*H2O
     &       +          rk(246)*yh(lCLO)
     &       +          rk(289)*yh(lBR)
     &       +          rk(299)*yh(lBRO)
     &       +          rk(324)*yh(lI) )
c
c --- Production of O3P except NO2+hv
c
      totO3P = y0(lO) + dt*(
     &       +          r(  8)
     &       +          r(  9)*yldO3P
     &       +          r( 16)
     &       +          r( 27)
     &       +          r(212)
     &       +          r(293) )
c
c --- Net loss of O3P
c
      lsO3P = 1.0 + dt*(
     &       +          rk(  2)*O2*M
     &       +          rk(  4)*yh(lNO)
     &       +          rk(  5)*yh(lNO2)
     &       +          rk(  6)*yh(lNO2)
     &       +          rk(  7)*yh(lO3)
     &       +          rk( 14)*yh(lOH)
     &       +          rk( 15)*yh(lHO2)
     &       +          rk( 23)*yh(lH2O2)
     &       +          rk( 31)*yh(lNO3) )
c
c --- Production of O3 except O3P+O2
c
      totO3 = y0(lO3) + dt*(
     &       + ( 0.130)*r( 57)
     &       + ( 0.130)*r( 65)
     &       + ( 0.130)*r(202)
     &       + ( 0.000)*r(331) )
c
c --- Net loss of O3 except O3+NO (rO3wNO)
c
      lsO3 = 1.0 + dt*(
     &       +          rk(  7)*yh(lO)
     &       +          rk(  8)
     &       +          rk(  9)
     &       +          rk( 12)*yh(lOH)
     &       +          rk( 13)*yh(lHO2)
     &       +          rk( 26)*yh(lNO2)
     &       +          rk( 34)*yh(lNO3)
     &       +          rk(135)*yh(lETH)
     &       +          rk(138)*yh(lOLE)
     &       +          rk(141)*yh(lIOLE)
     &       +          rk(149)*yh(lISOP)
     &       +          rk(152)*yh(lISPD)
     &       +          rk(165)*yh(lTERP)
     &       +          rk(191)*yh(lXOPN)
     &       +          rk(195)*yh(lOPEN)
     &       +          rk(211)*yh(lI)
     &       +          rk(222)*yh(lI2O2)
     &       +          rk(238)*yh(lCL)
     &       +          rk(287)*yh(lBR)
     &       + ( 0.000)*rk(331)*yh(lSQT) )
c
c --- Specific reactions
c
      jO3_O1D  = rk(  9)
      rNO2_O3P = dt*rk(  1)
      rO3P_O3  = dt*rk(  2)*O2*M
      rO3wNO   = dt*rk(  3)
c
c --- Collect common terms
c
      t1 = rNO2_O3P / lsNO2
      t2 = rNO2_NO / lsNO2
      t3 = rNO_NO2 / lsNO
      t4 = rO3P_O3  / lsO3P
      t5 = t3*totNO - t2*totNO2
      f1 = 1.0 + t2 + t3
      f2 = t1*t4
      f3 = lsO3*lsNO + rO3wNO*totNO
      f4 = totO3 + totO3P * t4
c
c --- Solve for change in NO and NO2 
c
      A = rO3wNO * (f1 - f2)
      B = f1*f3 + rO3wNO*(f2*(totNO2 - totNO) + f4 + t5)
      C = rO3wNO*totNO*(f4 + totNO2 * f2) + f3*t5
      Q = -0.5 * (B + SIGN(1.0,B)*SQRT(B*B - 4.0*A*C))
      Q = MAX(Q/A ,C/Q)
c
c --- Update Concentrations
c
      y1(lNO)  = MAX(1.0E-15, (totNO + Q) / lsNO )
      y1(lNO2) = MAX(1.0E-15, (totNO2 - Q) / lsNO2 )
      s1 = totO3P + rNO2_O3P*y1(lNO2)
      s2 = t4*s1
      y1(lO3)  = MAX(1.0E-15, (totO3 + s2) / 
     &                             ( lsO3 + rO3wNO * y1(lNO) ) )
      y1(lO)   = MAX(1.0E-20, s1 / lsO3P )
      totO1D = jO3_O1D*y1(lO3)
      y1(lO1D) = MAX(1.0E-25, totO1D / lsO1D )
c
      return
      end

C**** PIGCOORD
c
      subroutine pigcoord(xpig,ypig,iipig,jjpig,ingrd)
      use grid
      use bndary
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGCOORD calculates the (I,J) and grid index location for a given
c     puff (X,Y) coordinate
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        xpig                x-coord of puff (km or deg)
c        ypig                y-coord of puff (km or deg)
c
c     Output arguments:
c        iipig               i-coord of puff
c        jjpig               j-coord of puff
c        ingrd               grid index containing puff coords
c
c     Subroutines Called:
c        none
c
c     Called by:
c        AVEPIG
c        PIGWALK
c        WALK1PUF
c        PIGDRIVE
c
      include "camx.prm"
c
      integer i,j,ingrd,ip,ic,igrd,ig,iipig,jjpig
      real xtmp,ytmp,xpig,ypig
c
c-----Entry point
c
      i = 1 + FLOOR(xpig/delx)
      j = 1 + FLOOR(ypig/dely)
c
      ingrd = 1
      do ip = 1,ngrid
        do ic = 1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          ig = mapgrd(igrd)
          if (i.ge.inst1(ig) .and. i.le.inst2(ig) .and.
     &        j.ge.jnst1(ig) .and. j.le.jnst2(ig))
     &      ingrd = igrd
        enddo
      enddo
c
      igrd = ingrd
      if (igrd.eq.1) then
        iipig = i
        jjpig = j
        if (j.le.1 .or. j.ge.nrow(1) .or. 
     &                      i.le.1 .or. i.ge.ncol(1)) ingrd = 0
      else
        xtmp = xpig - (inst1(igrd) - 1)*delx
        ytmp = ypig - (jnst1(igrd) - 1)*dely
        iipig = 2 + FLOOR(xtmp/delx*FLOAT(meshold(igrd)))
        jjpig = 2 + FLOOR(ytmp/dely*FLOAT(meshold(igrd)))
      endif
c
      return
      end

**** NCF_METINIT_2D
c
      subroutine ncf_metinit_2d(igrd,ncol,nrow,tsurf,snow,snowage,snowalb)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines initalizes the met fields by reading the NetCDF
c   met files and loading the data into the global arrays.
c 
c      Copyright Ramboll
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c
c     Output arguments:
c        tsurf               surface temperature field (K)
c        snow                snow cover water equivalent (m)
c        snowage             snow cover age (hr)
c        snowalb             snow cover albedo (unitless)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      real    tsurf(ncol,nrow)
      real    snow(ncol,nrow)
      real    snowage(ncol,nrow)
      real    snowalb(ncol,nrow)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       this_time_tflag, this_time_etflag
      integer       this_tstep, i, j, k
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. is_netcdf_i2dmet(igrd) ) goto 9999
c
c  --- initialize fields ---
c
      snow = 0.
      snowage = 0.
      snowalb = 0.
c
      write(action,'(A,I3)') 'Reading 2D met file for grid ',igrd
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(i2dmet(igrd),action,begdate,begtim,
     &                  this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = 1
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- surface temperature ---
c
      this_var = "sfctemperature"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                          data_count,tsurf)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- snow cover depth ---
c
      this_var = "snowewd"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                                data_count,snow)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- snow cover age ---
c
      this_var = "snowage"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                             data_count,snowage)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_2D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_2D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine pigprep(begdat,begtim,numprocs)
      use grid
      use pigsty
      use filunit
      use ptemiss
      use chmstry
      use camxfld
      use tracer
      use rtracchm
      use node_mod
c
c----CAMx v7.40 260801
c
c     PIGPREP prepares the PiG submodel
c
c      Copyright Ramboll
c          
c     Modifications:
c        6/27/00 - Added some diagnostics to ensure that the point source PiG
c                  list is consistent on a restart with that used in previous 
c                  run.
c                - Now writing PiG point source information to PiG restart
c                  file, and echoing this information to diagnostic file on 
c                  model startup.
c       11/06/01   Input dates are now Julian
c        7/05/02   Added code to accommodate IRON-PiG
c       06/24/03   Removed thetapig
c       02/16/05   Added code to accomodate RTRAC mass
c       08/24/05   Removed diagnostics that ensure consistent PiG lists on
c                  restarts; removed read/write of PiG header containing 
c                  point source parameters; read of GREASD restart file now 
c                  includes OSAT pointer to region and group
c        2/02/06   Removed GREASD-PiG specific file formats; both PiG options
c                  use the IRON file formats
c       06/04/09   Added sigmax
c
c     Input arguments:
c        begdat              model beginning date (YYJJJ)
c        begtim              model beginning time
c        numprocs            number of processors for MPI
c
c     Output arguments:
c        none
c
c     Routines Called:
c        none
c
c     Called by:
c        STARTUP
c
      implicit none
      include "camx.prm"
      include "flags.inc"
      include "netcdf.inc"
c
      character*200 action
      character*10 this_var
      integer begdat, this_varid, ierr
      real begtim
      integer numprocs, igroup
      integer idatpig,nsrc,irec,n,i,nr,is,m,ifile
      real timpig
c
      real xx(MXPTSRC)
      real yy(MXPTSRC)
      real hh(MXPTSRC)
      real dd(MXPTSRC)
      real tt(MXPTSRC)
      real vv(MXPTSRC)
      integer ipigflag(MXPTSRC)
c
      common /compigprep/ xx,yy,hh,dd,tt,vv,ipigflag

      integer istrln
c
c-----Entry point
c
      action = 'Reading NetCDF point source file.'
c
      nkill(1) = 0
      nkill(2) = 0
      nkill(3) = 0
      nkill(4) = 0
      nkill(5) = 0
      nkill(6) = 0
      nkill(7) = 0
      nkill(8) = 0
      nkill(9) = 0
      npig = 0
      nreactr = 1
      loverlap = .false.
      if( ipigflg .EQ. IRONPIG ) then
        nreactr = MXRECTR
        loverlap = OVERLAP
      endif
c
c  ---if this is a restart, then call routine to 
c     allocate arrays for puff concs ----
c

      if( lrstrt ) then
        call alloc_pigsty(nspec,nreactr,ngrid,numprocs,ipigflg)
      endif
      do n = 1,ngrid
        nage(n) = 0
        pigage(n) = 0.
        do is = 1,nspec
          pgmserr(is,n) = 0.
        enddo
      enddo
c
c-----Check FLEAK param
c
      if ((OVERLAP .or. LEAKON) .and. FLEAK .GT. 1.) then
        write(iout,'(//,a)') 'ERROR in PIGPREP:'
        write(iout,*) 'FLEAK must be <= 1.0'
        write(iout,*) 'FLEAK = ',FLEAK
        call camxerr()
      endif
c 
c-----Read PiG information if it is a restart run and if PiG file is
c     provided 
c
      if (lrstrt .AND. irstp.ne.0) then
c
c-----Read hourly data to current date/time
c
        irec = 0
 100    continue
        irec = irec + 1
        read(irstp,ERR=7000,END=7001) idatpig,timpig,npig,nreactr
c
        irec = irec + 1
        if (ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                                  tectyp .EQ. RTCMC) ) then
          read(irstp,ERR=7002,END=7001)
     &           (ingrd(n),idpig(n),xpigf(n),xpigb(n),ypigf(n),
     &           ypigb(n),zpig(n),axisy(n),axisz(n),sigy(n),sigx(n),
     &           sigz(n),pufftop(n),puffbot(n),htfms(n),htfmb(n),
     &           vtfms(n),vtfmb(n),agepigf(n),agepigb(n),fmspig(n),
     &           ((puffmass(i,nr,n),i=1,nspec),nr=1,nreactr),n=1,npig),
     &           (((puffrt(i,nr,n),i=1,nrtrac),nr=1,nreactr),n=1,npig)
        else
          read(irstp,ERR=7002,END=7001)
     &           (ingrd(n),idpig(n),xpigf(n),xpigb(n),ypigf(n),
     &           ypigb(n),zpig(n),axisy(n),axisz(n),sigy(n),sigx(n),
     &           sigz(n),pufftop(n),puffbot(n),htfms(n),htfmb(n),
     &           vtfms(n),vtfmb(n),agepigf(n),agepigb(n),fmspig(n),
     &           ipufmap(n),ipufgrp(n),
     &           ((puffmass(i,nr,n),i=1,nspec),nr=1,nreactr),n=1,npig)
        endif
        if (timpig.ge.2400.) then
          timpig = timpig - 2400.
          idatpig = idatpig + 1
          if (MOD(idatpig,1000) .GT. 365) then
            if (MOD(INT(idatpig/1000),4) .EQ. 0) then
              if (MOD(idatpig,1000) .EQ. 367)
     &          idatpig = (INT(idatpig/1000)+1)*1000 + 1
            else
              idatpig = (INT(idatpig/1000)+1)*1000 + 1
            endif
          endif
        endif
        write(iout,'(a,F10.1,i10.5,i10)') 'Read PiG file at  ',
     &                                timpig,idatpig,npig
        if (idatpig.lt.begdat .or. 
     &     (idatpig.eq.begdat .and. timpig.lt.begtim - 0.01)) goto 100
        if (idatpig.gt.begdat .or. 
     &     (idatpig.eq.begdat .and. timpig.gt.begtim + 0.01)) then
           write(iout,'(//,a)') 'ERROR in PIGPREP:'
           write(iout,*) 'Date or time in PiG file > beginning time'
           write(iout,'(2i10.5)') idatpig, timpig
           call camxerr()
        endif
      endif
c
c-----Echo PiG point source information to diagnostic file
c
      write(idiag,'(//,a)') 'PiG source information'
      write(idiag,'(80a)') ('-',m=1,80)
      write(idiag,'(a,a)') ' Pig Src   Pt Src     Xloc      Yloc   ',
     &                     ' Height   Diameter  Temperature  Velocity'
      write(idiag,'(a,a)') '    #         #        (km or deg)  ',
     &                '     (m)       (m)         (K)       (m/hr)'
      write(idiag,'(80a)') ('-',m=1,80)
      nsrc = 0
      do ifile=1,npoint_files
         if( is_netcdf_iptem(ifile) ) then
c
            this_var = "xcoord"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,xx)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "ycoord"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,yy)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkheight"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,hh)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkdiam"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,dd)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stktemp"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,tt)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkspeed"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iptem(ifile),this_varid,vv)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "pigflag"
            ierr = nf_inq_varid(iptem(ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_int(iptem(ifile),this_varid,ipigflag)
            if( ierr .NE. NF_NOERR ) goto 7004
         else
            rewind(iptem(ifile))
            do n = 1,5
              read(iptem(ifile))
            enddo
            read(iptem(ifile)) (xx(n),yy(n),hh(n),dd(n),tt(n),
     &                              vv(n),n=1,nptsrc_files(ifile))
            do n = 1,nptsrc_files(ifile)
                ipigflag(n) = 0
                if(dd(n).lt.0.) ipigflag(n) = 1
            enddo
         endif
         do n = 1,nptsrc_files(ifile)
           if (ipigflag(n) .GT. 0 ) then
             nsrc = nsrc + 1
             if (llatlon) then
                write(idiag,'(i5,2x,i10,2f10.3,f9.1,f9.2,f12.1,f13.0)')
     &          nsrc,n,xx(n),yy(n),hh(n),ABS(dd(n)),tt(n),vv(n)
              else
                write(idiag,'(i5,2x,i10,2f10.3,f9.1,f9.2,f12.1,f13.0)')
     &          nsrc,n,xx(n)/1000.,yy(n)/1000.,hh(n),ABS(dd(n)),tt(n),vv(n)
             endif
           endif
         enddo
      enddo
c
c   ---- what if this is SA run ---
c 
      nsrc = 0
      do igroup=1,ngroup
      do ifile=1,num_iortpt(igroup)
         if( is_netcdf_iortpt(igroup,ifile) ) then
c
            this_var = "xcoord"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,xx)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "ycoord"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,yy)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkheight"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,hh)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkdiam"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,dd)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stktemp"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,tt)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "stkspeed"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_real(iortpt(igroup,ifile),this_varid,vv)
            if( ierr .NE. NF_NOERR ) goto 7004
c
            this_var = "pigflag"
            ierr = nf_inq_varid(iortpt(igroup,ifile),this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7003
            ierr = nf_get_var_int(iortpt(igroup,ifile),this_varid,ipigflag)
            if( ierr .NE. NF_NOERR ) goto 7004
         else
            rewind(iortpt(igroup,ifile))
            do n = 1,5
              read(iortpt(igroup,ifile))
            enddo
            read(iortpt(igroup,ifile)) (xx(n),yy(n),hh(n),dd(n),tt(n),
     &                              vv(n),n=1,nptsrc_safile(igroup,ifile))
            do n = 1,nptsrc_safile(igroup,ifile)
                ipigflag(n) = 0
                if(dd(n).lt.0.) ipigflag(n) = 1
            enddo
         endif
         do n = 1,nptsrc_safile(igroup,ifile)
           if (ipigflag(n) .GT. 0 ) then
             nsrc = nsrc + 1
             if (llatlon) then 
                write(idiag,'(i5,2x,i10,2f10.3,f9.1,f9.2,f12.1,f13.0)')
     &            nsrc,n+idx_start_sapts(igroup,ifile),xx(n),
     &                      yy(n),hh(n),ABS(dd(n)),tt(n),vv(n)
             else
                write(idiag,'(i5,2x,i10,2f10.3,f9.1,f9.2,f12.1,f13.0)')
     &            nsrc,n+idx_start_sapts(igroup,ifile),xx(n)/1000.,
     &                      yy(n)/1000.,hh(n),ABS(dd(n)),tt(n),vv(n)
             endif
           endif
         enddo
      enddo
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c   Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in PIGPREP:'
      write(iout,*) 'Cannot read PiG restart file at record: ',irec
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in PIGPREP:'
      write(iout,*) 'Premature end-of-file found in PiG ',
     &              'restart file at record: ',irec
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in PIGPREP:'
      write(iout,'(a,i10.5,f10.1)') 
     &      'Cannot read data in PiG restart file at hour: ',
     &      idatpig,timpig
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in PIGPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in PIGPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      call camxerr()

c
c-----------------------------------------------------------------------
c   Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine aerochem_cf(h2o,tempk,press,cwc,cph,aph,ajno2,
     &                       cNV,con,dcprec,CG_part,fcsoa,convfac,
     &                       dtaq,dtaer,delcon,scNV,sddm,nfam,nsen,
     &                       ldoipr,ipa_cel,aero_flag,lpig,icig,ldark)
      use camxcom
      use chmstry
      use filunit
      use tracer
      use procan
c
c----CAMx v7.40 260801
c
c     AEROCHEM_CF drives the CF 2-section aerosol model in CAMx.
c     It calculates the following chemical transformations:
c        1. Condensation of organic gasses to SOA (SOAP or VBS)
c        2. Heterogeneous SOA from gas phase GLY/MGLY (CGLY scheme)
c        3. SOA photolysis and polymerisation (set parameters in soap.inc)
c        4. Aqueous inorganic reactions and SOA from GLY/MGLY/GLYD (RAQCHEM)
c        5. Inorganic gas-aerosol equilibrium partitioning by either:
c           ISORROPIA (NH4/Cl/NO3/SO4/Na) or 
c           EQSAM (NH4/Cl/NO3/SO4/Na/K/Mg/Ca)
c     The gas species are in ppm
c     The aerosol species are in (ug/m3)
c
c      Copyright Ramboll 
c
c     Modifications: 
c        1/9/02         Minor bug fixes (units conversions)
c        11/19/02       Incorporated RADM aqueous chemistry and ISORROPIA
c        12/9/02        Incorporated SOAP routine
c        10/24/05       Cloud pH is now passed in/out; Henry's Law values
c                       for SO2 and O3 no longer passed out
c        12/26/06       RAQCHEM now called each chemistry timestep
c        12/29/06       Revised for the updated SOA scheme
c        01/10/07       Added species mapping for CB05/SAPRC99
c        05/04/07       Added array (wt_save) to keep original total
c                       mass because ISORROPIA overwrites with lower
c                       bound value.
c        05/30/07       Skip call to RAQCHEM under high acid conditions.
c        05/13/08       Modified to skip ISORROPIA for certain PiG calls.
c        01/21/10       Added formation of mineral dust nitrate
c        07/31/13       Modified for new GREASD PiG chemistry 
c        08/23/13       Revised for DDM-PM; replaced hard-wired MW's with wtmol
c        03/18/14       Revised for benzene SOA
c        10/09/14       Added subgrid convective model
c        12/07/14       Revised for VBS
c        01/08/16       Updated for Revised VBS
c        08/25/16       Updated for new SOAP
c        09/16/16       Aqueous chemistry updates
c        09/14/17       Select metastable option in ISORROPIA and EQSAM
c        10/13/17       Modified to get aerosol pH from ISORROPIA
c        10/16/17       Added particle-phase SOA photolysis
c        11/22/17       Added PFE/PMN/PK/PCA/PMG option
c                       Updated for revised WTMOL
c                       Added EQSAM option
c        10/26/18       Updated DDM for SOA photolysis & revised RADM
c        05/16/24       Added CGLY implementation of GLY & MGLY reactive uptake
c                       forming non-volatile SOA
c
c     Input arguments:
c        h2o                 cell water vapor (ppm)
c        tempk               cell temperature (K)
c        press               cell pressure (mb)
c        cwc                 cloud water content (g/m3)
c        cph                 cloud water pH 
c        aph                 aerosol pH
c        ajno2               time-weighted accumulated NO2 photolysis rate ([1/hr]*[hr])
c        cNV                 NV product concentrations (ppm)
c        con                 species concentrations (ppm, ug/m3)
c        dcprec              change in SOA precursor concentrations [ppm]
c        convfac             conversion factor: umol/m3 = ppm * convfac
c        dtaq                aqueous chemistry time step (hours)
c        dtaer               general PM chemistry time step (hours)
c        delcon              delta concentrations for source apportionment
c        scNV                NV product sensitivities
c        sddm                DDM-PM sensitivity array
c        nfam                number of DDM parameters
c        nsen                number of model species used in DDM-PM
c        ldoipr              flag to determine whether to do IPR calculation
c        ipa_cel             pointer into PA sub-domain array
c        aero_flag           1 - do RAQCHEM (with ISORROPIA), NV SOA
c                            2 - do SOAP, RAQCHEM, ISORROPIA|EQSAM
c        lpig                T - PiG call (do only RAQCHEM)
c        icig                0 - CiG not activated (default to aero_flag)
c                            1 - CiG call (do only RAQCHEM)
c                            2 - Grid call, CiG called prior (skip RAQCHEM)
c        ldark               darkness flag
c
c     Output arguments:
c        con                 species concentrations (ppm, ug/m3)
c        cph                 cloud water pH 
c        aph                 aerosol pH
c        delcon              delta concentrations for source apportionment
c        CG_part             CG/SOA partition ratio for PSAT (dimensionless)
c        fcsoa               SOA chem factors for PSAT: fphot, fpoly, fra, cgly
c        sddm                DDM-PM sensitivity array
c
c     Routines called: 
c        SOAP
c        RAQCHEM
c        ISORROPIA
c 
c     Called by: 
c        IRONCHEM
c        CIGDRIVE
c        CHEMDRIV 
c
      implicit none
      include 'camx.prm' 
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'vbs.inc'
      include 'chmdbg.inc'
c
c========================== Process Analysis Begin =======================
c
      logical ldoipr
      integer ipa_cel
      real csulf,chno3,cnh3,cpso4,cpno3,cpnh4
c
c========================== Process Analysis End =======================
c
c========================= DDM Begin ===================================
c
      integer nfam, nsen, ierr, ip
      real scNV(nfam,NNV)
      real sddm(nfam,nsen)
c
c========================== DDM End ====================================
c
      real    h2o
      real    tempk
      real    press
      real    cwc
      real    cph
      real    aph
      real    ajno2
      real    cNV(NNV)
      real    con(*)
      real    convfac
      real    dtaq
      real    dtaer
      real    delcon(4,*)
      real    so2
      real    so4
      real    no3
      real    fra
      real    frb

      integer aero_flag
      integer icig

      logical lpig
      logical lnvoc
      logical lsvoc
      logical lradm
      logical lisor
      logical ldark ! darkness flag added for day-night difference in Fe_III
      logical ldosa

      integer ispc,is
      real qwatr,ev,es,rh
      real pres_pa
      real dt_sec
      real cold(MXSPEC), deln2o5
      real cw_kgm3
      real, parameter :: SMALL = 1.e-15
      real zero, tmp1, tmp2
      character*30 location
c
c-----Arrays for SOAP
c
      real soacon(NCG),cg(NCG),csatT(NCG)
      real preOM ! pre-existing OA mass (mole)
      real apoly(NSOAP), aphot(NSOAP+NNVOL)
      real fphot, fpolya, fpolyb, fcsoa(6)
      real dcprec(NPREC_S)
      real CG_part(NCG)
c
c-----Arrays for RADM aqueous chemistry
c
      real r_gas(15),r_aer(10),r_old(25)
      real r_1,r_2,r_3
      real csoac
c
c-----Variables for EQSAM4clim
c
      integer, parameter :: dp = SELECTED_REAL_KIND(12,307)
      real(dp) :: xTT,xAW,xWH2O,xYPa(5),xYMa(4)
      real(dp) :: xsPM,xaPM,xPMS,xPMT,xRHO,xVOL,xPH,xHp,xGF,
     &            xYPs(5),xYMs(4),xYG(4)
      real(dp), parameter :: Dd = 1.e-6_dp ! dry droplet diameter for the Kelvin effect (not used)
      integer, parameter :: jmeq = 1
c
c-----Variables for ISORROPIA need double precision
c
      integer imask(1,1)
      real*8 wi(5),wt(5),wt_save(5)
      real*8 rhi,tempi,cntrl(2)
      real*8 gasis(3),aerliq(12),aersld(9),other(6)
      character*15 scasi
c
c-----Variables for calcium nitrate
c
      real*8 dno3 ! calcium nitrate (mol/m3)
      logical lno3_isr ! flag to indicate non-zero nitrate for isorropia
c
c-----Variables for iron and manganese fractions in dust and other primary PM
c
      real fe_iii, mn_ii, fe_sol, mn_sol, fe_mmr, mn_mmr
c
c-----Speciation factors for elemental species (negative to fall back to background values)
c
      real, parameter :: f_FE_PRM = -1.0   , f_FE_CRS = -1.0    ! mass fraction of Fe in PRM or CRS
      real, parameter :: f_MN_PRM = -1.0   , f_MN_CRS = -1.0    ! mass fraction of Mn in PRM or CRS
      real, parameter :: f_CA_PRM = 0.0260 , f_CA_CRS = 0.0260  ! mass fraction of Ca in PRM or CRS
      real, parameter :: f_MG_PRM = -1.0   , f_MG_CRS = -1.0    ! mass fraction of Mn in PRM or CRS
      real, parameter :: f_K_PRM  = -1.0   , f_K_CRS  = -1.0    ! mass fraction of K in PRM or CRS
c 
c-----Entry point 
c
      lnvoc = .false.
      lsvoc = .false.
      lradm = .false.
      lisor = .false.
      ldosa = .false.
      csoac = 0.
      zero = 0.
      ierr = 0

      if (.not.lpig .and. icig.ne.1) then
        lnvoc = .true.
        if (aero_flag.eq.2) then
          lsvoc = .true.
          lisor = .true.
        endif
        ldosa = ltrace
      endif
      if (cwc.ge.cwmin .and. tempk.gt.tamin) then
        so2 = con(kso2)*1.e-6
        so4 = (con(kpso4)/wtmol(1)/convfac)*1.e-6
        no3 = (con(kpno3)/wtmol(3)/convfac)*1.e-6
        if (so4.lt.5.0e-7 .and. no3.lt.1.5e-6 .and. so2.lt.1.0e-6) then
          lradm = .true.
          lisor = .true.
        endif
        if (lpig) lisor = .false.
        if (icig.eq.1) lisor = .false.
        if (icig.eq.2) lradm = .false.
      endif

      location = 'on entry'
      do ispc = 1,nspec
         cold(ispc) = con(ispc)
         if (con(ispc)-con(ispc) .NE. zero) goto 7000
      enddo
      con(nspec+1) = 0.
      cph = 5.0
c
c-----Calculate relative humidity
c
      qwatr = 1.e-6*h2o*18./28.8 
      ev = qwatr*press/(qwatr + eps) 
      es = e0*exp((lv/rv)*(1./273. - 1./tempk)) 
      rh = 100.0*amin1(0.99,ev/es)
c
c-----Partitioning of non-volatile organic compounds.
c     Unit conversion is done here: [ppm] -> [ug/m3]
c
      if ( lnvoc ) then

        if ( lvbs ) then

          con(kPAS0) = con(kPAS0) + cNV(1) * convfac * mwPAS0
          con(kPBS0) = con(kPBS0) + cNV(2) * convfac * mwPBS0
          con(kPAP0) = con(kPAP0) + cNV(3) * convfac * mwPAP0
          con(kPCP0) = con(kPCP0) + cNV(4) * convfac * mwPCP0
          con(kPFP0) = con(kPFP0) + cNV(5) * convfac * mwPFP0
c
c========================= Process Analysis Begin ======================
c
          if ( ldoipr ) then
            cipr(IPR_OAERO,ipa_cel,kPAS0) = cipr(IPR_OAERO,ipa_cel,kPAS0)
     &                                           + con(kPAS0)-cold(kPAS0)
            cipr(IPR_OAERO,ipa_cel,kPBS0) = cipr(IPR_OAERO,ipa_cel,kPBS0)
     &                                           + con(kPBS0)-cold(kPBS0)
            cipr(IPR_OAERO,ipa_cel,kPAP0) = cipr(IPR_OAERO,ipa_cel,kPAP0)
     &                                           + con(kPAP0)-cold(kPAP0)
            cipr(IPR_OAERO,ipa_cel,kPCP0) = cipr(IPR_OAERO,ipa_cel,kPCP0)
     &                                           + con(kPCP0)-cold(kPCP0)
            cipr(IPR_OAERO,ipa_cel,kPFP0) = cipr(IPR_OAERO,ipa_cel,kPFP0)
     &                                           + con(kPFP0)-cold(kPFP0)
          endif
c
c========================= Process Analysis End ========================
c
        else ! SOAP
 
          con(kaoa0) = con(kaoa0) + cNV(1) * convfac * mwaoa0
          con(kboa0) = con(kboa0) + cNV(2) * convfac * mwboa0
c
c --- Scheme for reactive uptake of GLY and MGLY
c     forming non-volatile SOA. Estimate the anthro/bio fractions.
c
c     dcprec contains SOA precursor concentration change [ppm]
c
          tmp1 = dcprec(ISOAP_BNZA) + dcprec(ISOAP_TOLA)
     &              + dcprec(ISOAP_XYLA)
          tmp2 = MAX(tmp1 + dcprec(ISOAP_ISP), SMALL)
          fra =  MAX(MIN(0.999, tmp1/tmp2), 0.001)
          frb =  MAX(0.0, 1.0 - fra)
          fcsoa(4) = fra
          fcsoa(5) = con(kcgly) * convfac

          con(kaoa0) = con(kaoa0) + fra * con(kcgly) * convfac * mwaoa0
          con(kboa0) = con(kboa0) + frb * con(kcgly) * convfac * mwboa0
          con(kcgly) = bdnl(kcgly)
c
c========================= Process Analysis Begin ======================
c
          if ( ldoipr ) then
            cipr(IPR_OAERO,ipa_cel,kaoa0) = cipr(IPR_OAERO,ipa_cel,kaoa0)
     &                                         + con(kaoa0) - cold(kaoa0)
            cipr(IPR_OAERO,ipa_cel,kboa0) = cipr(IPR_OAERO,ipa_cel,kboa0)
     &                                         + con(kboa0) - cold(kboa0)
          endif
c
c========================= Process Analysis End ========================
c
c
c========================= DDM Begin ===================================
c
          if (lddm) then
            do ip = 1, nfam
              sddm(ip,jdpAOA0) = sddm(ip,jdpAOA0) 
     &              + scNV(ip,1) * convfac * mwaoa0
     &                + fra * sddm(ip,jdpCGLY) * convfac * mwaoa0
              sddm(ip,jdpBOA0) = sddm(ip,jdpBOA0) 
     &              + scNV(ip,2) * convfac * mwboa0
     &                + frb * sddm(ip,jdpCGLY) * convfac * mwboa0
              sddm(ip,jdpCGLY) = 0.0
            enddo
          endif
c
c========================== DDM End ====================================
c
        endif ! VBS or SOAP?

      endif ! lnvoc?
c
c-----Partitioning of semi-volatile organic compounds between the gas and
c     aerosol phases using the SOAP or VBS scheme.
c     CGs are in ppm; SOAs are in ug/m3; the unit conversion is done here.
c
      if ( lsvoc ) then

        if ( lvbs ) then

          cg(1)  = con(kVAS1) * convfac * mwVBS(1)
          cg(2)  = con(kVAS2) * convfac * mwVBS(2)
          cg(3)  = con(kVAS3) * convfac * mwVBS(3)
          cg(4)  = con(kVAS4) * convfac * mwVBS(4)
          cg(5)  = con(kVBS1) * convfac * mwVBS(5)
          cg(6)  = con(kVBS2) * convfac * mwVBS(6)
          cg(7)  = con(kVBS3) * convfac * mwVBS(7)
          cg(8)  = con(kVBS4) * convfac * mwVBS(8)
          cg(9)  = con(kVAP1) * convfac * mwVBS(9)
          cg(10) = con(kVAP2) * convfac * mwVBS(10)
          cg(11) = con(kVAP3) * convfac * mwVBS(11)
          cg(12) = con(kVAP4) * convfac * mwVBS(12)
          cg(13) = con(kVCP1) * convfac * mwVBS(13)
          cg(14) = con(kVCP2) * convfac * mwVBS(14)
          cg(15) = con(kVCP3) * convfac * mwVBS(15)
          cg(16) = con(kVCP4) * convfac * mwVBS(16)
          cg(17) = con(kVFP1) * convfac * mwVBS(17)
          cg(18) = con(kVFP2) * convfac * mwVBS(18)
          cg(19) = con(kVFP3) * convfac * mwVBS(19)
          cg(20) = con(kVFP4) * convfac * mwVBS(20)
          soacon(1)  = con(kPAS1)
          soacon(2)  = con(kPAS2)
          soacon(3)  = con(kPAS3)
          soacon(4)  = con(kPAS4)
          soacon(5)  = con(kPBS1)
          soacon(6)  = con(kPBS2)
          soacon(7)  = con(kPBS3)
          soacon(8)  = con(kPBS4)
          soacon(9)  = con(kPAP1)
          soacon(10) = con(kPAP2)
          soacon(11) = con(kPAP3)
          soacon(12) = con(kPAP4)
          soacon(13) = con(kPCP1)
          soacon(14) = con(kPCP2)
          soacon(15) = con(kPCP3)
          soacon(16) = con(kPCP4)
          soacon(17) = con(kPFP1)
          soacon(18) = con(kPFP2)
          soacon(19) = con(kPFP3)
          soacon(20) = con(kPFP4)
          preOM = con(kPAS0) / mwPAS0
     &          + con(kPBS0) / mwPBS0
     &          + con(kPAP0) / mwPAP0
     &          + con(kPCP0) / mwPCP0
     &          + con(kPFP0) / mwPFP0

          do ispc = 1, NVBS*NSET
            csatT(ispc) = csatV(ispc) * (cstempV(ispc)/tempk)
     &                                * exp((deltahV(ispc)/8.314)
     &                                * (1/cstempV(ispc)-1/tempk))
          enddo
          call soap(NSET*NVBS,mwVBS,soacon(:NSET*NVBS),cg(:NSET*NVBS),
     &              csatT(:NSET*NVBS),preOM,
     &              iout,igrdchm,ichm,jchm,kchm,ierr)
          location = 'after SOAP with ierr>0'
          if (ierr .GT. 0) goto 7000
c
c-----Save the CG/SOA partition ratio (dimensionless)
c
          do ispc = 1, NVBS*NSET
            CG_part(ispc) = cg(ispc) / (cg(ispc) + soacon(ispc) + SMALL)
          enddo

          con(kVAS1) = amax1(cg(1) /convfac/mwVBS(1) ,bdnl(kVAS1))
          con(kVAS2) = amax1(cg(2) /convfac/mwVBS(2) ,bdnl(kVAS2))
          con(kVAS3) = amax1(cg(3) /convfac/mwVBS(3) ,bdnl(kVAS3))
          con(kVAS4) = amax1(cg(4) /convfac/mwVBS(4) ,bdnl(kVAS4))
          con(kVBS1) = amax1(cg(5) /convfac/mwVBS(5) ,bdnl(kVBS1))
          con(kVBS2) = amax1(cg(6) /convfac/mwVBS(6) ,bdnl(kVBS2))
          con(kVBS3) = amax1(cg(7) /convfac/mwVBS(7) ,bdnl(kVBS3))
          con(kVBS4) = amax1(cg(8) /convfac/mwVBS(8) ,bdnl(kVBS4))
          con(kVAP1) = amax1(cg(9) /convfac/mwVBS(9) ,bdnl(kVAP1))
          con(kVAP2) = amax1(cg(10)/convfac/mwVBS(10),bdnl(kVAP2))
          con(kVAP3) = amax1(cg(11)/convfac/mwVBS(11),bdnl(kVAP3))
          con(kVAP4) = amax1(cg(12)/convfac/mwVBS(12),bdnl(kVAP4))
          con(kVCP1) = amax1(cg(13)/convfac/mwVBS(13),bdnl(kVCP1))
          con(kVCP2) = amax1(cg(14)/convfac/mwVBS(14),bdnl(kVCP2))
          con(kVCP3) = amax1(cg(15)/convfac/mwVBS(15),bdnl(kVCP3))
          con(kVCP4) = amax1(cg(16)/convfac/mwVBS(16),bdnl(kVCP4))
          con(kVFP1) = amax1(cg(17)/convfac/mwVBS(17),bdnl(kVFP1))
          con(kVFP2) = amax1(cg(18)/convfac/mwVBS(18),bdnl(kVFP2))
          con(kVFP3) = amax1(cg(19)/convfac/mwVBS(19),bdnl(kVFP3))
          con(kVFP4) = amax1(cg(20)/convfac/mwVBS(20),bdnl(kVFP4))
          con(kPAS1) = amax1(soacon(1) ,bdnl(kPAS1))
          con(kPAS2) = amax1(soacon(2) ,bdnl(kPAS2))
          con(kPAS3) = amax1(soacon(3) ,bdnl(kPAS3))
          con(kPAS4) = amax1(soacon(4) ,bdnl(kPAS4))
          con(kPBS1) = amax1(soacon(5) ,bdnl(kPBS1))
          con(kPBS2) = amax1(soacon(6) ,bdnl(kPBS2))
          con(kPBS3) = amax1(soacon(7) ,bdnl(kPBS3))
          con(kPBS4) = amax1(soacon(8) ,bdnl(kPBS4))
          con(kPAP1) = amax1(soacon(9) ,bdnl(kPAP1))
          con(kPAP2) = amax1(soacon(10),bdnl(kPAP2))
          con(kPAP3) = amax1(soacon(11),bdnl(kPAP3))
          con(kPAP4) = amax1(soacon(12),bdnl(kPAP4))
          con(kPCP1) = amax1(soacon(13),bdnl(kPCP1))
          con(kPCP2) = amax1(soacon(14),bdnl(kPCP2))
          con(kPCP3) = amax1(soacon(15),bdnl(kPCP3))
          con(kPCP4) = amax1(soacon(16),bdnl(kPCP4))
          con(kPFP1) = amax1(soacon(17),bdnl(kPFP1))
          con(kPFP2) = amax1(soacon(18),bdnl(kPFP2))
          con(kPFP3) = amax1(soacon(19),bdnl(kPFP3))
          con(kPFP4) = amax1(soacon(20),bdnl(kPFP4))
c
c========================= Process Analysis Begin ======================
c
          if ( ldoipr ) then
            cipr(IPR_OAERO,ipa_cel,kVAS1)=cipr(IPR_OAERO,ipa_cel,kVAS1)
     &                               + (con(kVAS1)-cold(kVAS1))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAS2)=cipr(IPR_OAERO,ipa_cel,kVAS2)
     &                               + (con(kVAS2)-cold(kVAS2))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAS3)=cipr(IPR_OAERO,ipa_cel,kVAS3)
     &                               + (con(kVAS3)-cold(kVAS3))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAS4)=cipr(IPR_OAERO,ipa_cel,kVAS4)
     &                               + (con(kVAS4)-cold(kVAS4))*convfac
            cipr(IPR_OAERO,ipa_cel,kVBS1)=cipr(IPR_OAERO,ipa_cel,kVBS1)
     &                               + (con(kVBS1)-cold(kVBS1))*convfac
            cipr(IPR_OAERO,ipa_cel,kVBS2)=cipr(IPR_OAERO,ipa_cel,kVBS2)
     &                               + (con(kVBS2)-cold(kVBS2))*convfac
            cipr(IPR_OAERO,ipa_cel,kVBS3)=cipr(IPR_OAERO,ipa_cel,kVBS3)
     &                               + (con(kVBS3)-cold(kVBS3))*convfac
            cipr(IPR_OAERO,ipa_cel,kVBS4)=cipr(IPR_OAERO,ipa_cel,kVBS4)
     &                               + (con(kVBS4)-cold(kVBS4))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAP1)=cipr(IPR_OAERO,ipa_cel,kVAP1)
     &                               + (con(kVAP1)-cold(kVAP1))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAP2)=cipr(IPR_OAERO,ipa_cel,kVAP2)
     &                               + (con(kVAP2)-cold(kVAP2))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAP3)=cipr(IPR_OAERO,ipa_cel,kVAP3)
     &                               + (con(kVAP3)-cold(kVAP3))*convfac
            cipr(IPR_OAERO,ipa_cel,kVAP4)=cipr(IPR_OAERO,ipa_cel,kVAP4)
     &                               + (con(kVAP4)-cold(kVAP4))*convfac
            cipr(IPR_OAERO,ipa_cel,kVCP1)=cipr(IPR_OAERO,ipa_cel,kVCP1)
     &                               + (con(kVCP1)-cold(kVCP1))*convfac
            cipr(IPR_OAERO,ipa_cel,kVCP2)=cipr(IPR_OAERO,ipa_cel,kVCP2)
     &                               + (con(kVCP2)-cold(kVCP2))*convfac
            cipr(IPR_OAERO,ipa_cel,kVCP3)=cipr(IPR_OAERO,ipa_cel,kVCP3)
     &                               + (con(kVCP3)-cold(kVCP3))*convfac
            cipr(IPR_OAERO,ipa_cel,kVCP4)=cipr(IPR_OAERO,ipa_cel,kVCP4)
     &                               + (con(kVCP4)-cold(kVCP4))*convfac
            cipr(IPR_OAERO,ipa_cel,kVFP1)=cipr(IPR_OAERO,ipa_cel,kVFP1)
     &                               + (con(kVFP1)-cold(kVFP1))*convfac
            cipr(IPR_OAERO,ipa_cel,kVFP2)=cipr(IPR_OAERO,ipa_cel,kVFP2)
     &                               + (con(kVFP2)-cold(kVFP2))*convfac
            cipr(IPR_OAERO,ipa_cel,kVFP3)=cipr(IPR_OAERO,ipa_cel,kVFP3)
     &                               + (con(kVFP3)-cold(kVFP3))*convfac
            cipr(IPR_OAERO,ipa_cel,kVFP4)=cipr(IPR_OAERO,ipa_cel,kVFP4)
     &                               + (con(kVFP4)-cold(kVFP4))*convfac
            cipr(IPR_OAERO,ipa_cel,kPAS1)=cipr(IPR_OAERO,ipa_cel,kPAS1)
     &                                  + con(kPAS1)-cold(kPAS1)
            cipr(IPR_OAERO,ipa_cel,kPAS2)=cipr(IPR_OAERO,ipa_cel,kPAS2)
     &                                  + con(kPAS2)-cold(kPAS2)
            cipr(IPR_OAERO,ipa_cel,kPAS3)=cipr(IPR_OAERO,ipa_cel,kPAS3)
     &                                  + con(kPAS3)-cold(kPAS3)
            cipr(IPR_OAERO,ipa_cel,kPAS4)=cipr(IPR_OAERO,ipa_cel,kPAS4)
     &                                  + con(kPAS4)-cold(kPAS4)
            cipr(IPR_OAERO,ipa_cel,kPBS1)=cipr(IPR_OAERO,ipa_cel,kPBS1)
     &                                  + con(kPBS1)-cold(kPBS1)
            cipr(IPR_OAERO,ipa_cel,kPBS2)=cipr(IPR_OAERO,ipa_cel,kPBS2)
     &                                  + con(kPBS2)-cold(kPBS2)
            cipr(IPR_OAERO,ipa_cel,kPBS3)=cipr(IPR_OAERO,ipa_cel,kPBS3)
     &                                  + con(kPBS3)-cold(kPBS3)
            cipr(IPR_OAERO,ipa_cel,kPBS4)=cipr(IPR_OAERO,ipa_cel,kPBS4)
     &                                  + con(kPBS4)-cold(kPBS4)
            cipr(IPR_OAERO,ipa_cel,kPAP1)=cipr(IPR_OAERO,ipa_cel,kPAP1)
     &                                  + con(kPAP1)-cold(kPAP1)
            cipr(IPR_OAERO,ipa_cel,kPAP2)=cipr(IPR_OAERO,ipa_cel,kPAP2)
     &                                  + con(kPAP2)-cold(kPAP2)
            cipr(IPR_OAERO,ipa_cel,kPAP3)=cipr(IPR_OAERO,ipa_cel,kPAP3)
     &                                  + con(kPAP3)-cold(kPAP3)
            cipr(IPR_OAERO,ipa_cel,kPAP4)=cipr(IPR_OAERO,ipa_cel,kPAP4)
     &                                  + con(kPAP4)-cold(kPAP4)
            cipr(IPR_OAERO,ipa_cel,kPCP1)=cipr(IPR_OAERO,ipa_cel,kPCP1)
     &                                  + con(kPCP1)-cold(kPCP1)
            cipr(IPR_OAERO,ipa_cel,kPCP2)=cipr(IPR_OAERO,ipa_cel,kPCP2)
     &                                  + con(kPCP2)-cold(kPCP2)
            cipr(IPR_OAERO,ipa_cel,kPCP3)=cipr(IPR_OAERO,ipa_cel,kPCP3)
     &                                  + con(kPCP3)-cold(kPCP3)
            cipr(IPR_OAERO,ipa_cel,kPCP4)=cipr(IPR_OAERO,ipa_cel,kPCP4)
     &                                  + con(kPCP4)-cold(kPCP4)
            cipr(IPR_OAERO,ipa_cel,kPFP1)=cipr(IPR_OAERO,ipa_cel,kPFP1)
     &                                  + con(kPFP1)-cold(kPFP1)
            cipr(IPR_OAERO,ipa_cel,kPFP2)=cipr(IPR_OAERO,ipa_cel,kPFP2)
     &                                  + con(kPFP2)-cold(kPFP2)
            cipr(IPR_OAERO,ipa_cel,kPFP3)=cipr(IPR_OAERO,ipa_cel,kPFP3)
     &                                  + con(kPFP3)-cold(kPFP3)
            cipr(IPR_OAERO,ipa_cel,kPFP4)=cipr(IPR_OAERO,ipa_cel,kPFP4)
     &                                  + con(kPFP4)-cold(kPFP4)
          endif
c
c========================== Process Analysis End =======================
c

        else ! SOAP

          cg(1)  = con(kacg2) * convfac * mwsoap(1)
          cg(2)  = con(kacg1) * convfac * mwsoap(2)
          cg(3)  = con(kbcg2) * convfac * mwsoap(3)
          cg(4)  = con(kbcg1) * convfac * mwsoap(4)
          soacon(1) = con(kaoa2)
          soacon(2) = con(kaoa1)
          soacon(3) = con(kboa2)
          soacon(4) = con(kboa1)
          preOM = con(khoa) / mwhoa
     &          + con(kaoa0) / mwaoa0
     &          + con(kboa0) / mwboa0
c
c========================= DDM Begin ===================================
c
          if (lddm) then
            call DDMSOAINI (convfac,sddm,nfam,nsen)
          endif
c
c========================== DDM End ====================================
c
          do ispc = 1, NSOAP
            csatT(ispc) = csatS(ispc) * (cstempS(ispc)/tempk)
     &                                * exp((deltahS(ispc)/8.314)
     &                                * (1/cstempS(ispc)-1/tempk))
          enddo

          call soap(NSOAP,mwsoap,soacon(:NSOAP),cg(:NSOAP),
     &              csatT(:NSOAP),preOM,
     &              iout,igrdchm,ichm,jchm,kchm,ierr)
          location = 'SOAP ierr>0'
          if (ierr .GT. 0) goto 7000
c
c-----Save the CG/SOA partition ratio for PSAT
c
          do ispc = 1, NSOAP
            CG_part(ispc) = cg(ispc) / (cg(ispc) + soacon(ispc) + SMALL)
          enddo
c
c-----Calculate SOA removal by particle-phase photolysis
c
          fphot = 1. - exp( -sfacJSOA * ajno2 ) ! fraction of SOA removed by photolysis
          fcsoa(1) = fphot

          do ispc = 1, NSOAP
            aphot(ispc) = soacon(ispc) * fphot
            soacon(ispc) = soacon(ispc) - aphot(ispc)
          enddo

          aphot(NSOAP+1) = con(kaoa0) * fphot
          con(kaoa0) = con(kaoa0) - aphot(NSOAP+1)
          aphot(NSOAP+2) = con(kboa0) * fphot
          con(kboa0) = con(kboa0) - aphot(NSOAP+2)
c
c-----Calculate fraction of polymerized SOA
c
          fpolya = 1. - exp( -kpolya * dtaer ) ! polymerized fraction for anthro SOA
          fcsoa(2) = fpolya

          do ispc = 1, NSOAA
            apoly(ispc) = soacon(ispc) * fpolya
            soacon(ispc) = soacon(ispc) - apoly(ispc)
            con(kaoa0) = con(kaoa0) + apoly(ispc)
          enddo

          fpolyb = 1. - exp( -kpolyb * dtaer ) ! polymerized fraction for bio SOA
          fcsoa(3) = fpolyb

          do ispc = NSOAA + 1, NSOAP
            apoly(ispc) = soacon(ispc) * fpolyb
            soacon(ispc) = soacon(ispc) - apoly(ispc)
            con(kboa0) = con(kboa0) + apoly(ispc)
          enddo
c
c========================= DDM Begin ===================================
c
          if (lddm) then
            call DDMSOAP (dtaer,ajno2,convfac,sddm,nfam,nsen,ierr,iout)
            if (ierr.lt.0) then
              write(iout,'(a,4i4)') ' igrd,i,j,k = ',
     &                                          igrdchm,ichm,jchm,kchm
              write(iout,*) ' T,DT = ',tempk,dtaer
              write(iout,*) ' CONVFAC = ',convfac
              write(iout,*) ' CG = ',con(kacg2),con(kacg1),
     &                               con(kbcg2),con(kbcg1)
              write(iout,*) ' SOA = ',con(kaoa2),con(kaoa1),
     &                                con(kboa2),con(kboa1),
     &                                con(kaoa0),con(kboa0)
              write(iout,*) ' APHOT = ',(aphot(ispc),ispc=1,NSOAP+2)
              write(iout,*) ' APOLY = ',(apoly(ispc),ispc=1,NSOAP)
              write(iout,*) ' HOA = ',con(khoa)
              do ip = 1, nfam
                write(iout,*) ' SI(',ip,') = ',
     &                               (sddm(ip,jdpACG2+is-1),is=1,NSOAP),
     &                              (sddm(ip,jdpAOA2+is-1),is=1,NSOAP),
     &                               sddm(ip,jdpAOA0),sddm(ip,jdpBOA0),
     &                                                 sddm(ip,jdpHOA)
              enddo
              call camxerr()
            endif
          endif
c
c========================== DDM End ====================================
c
          con(kacg2) = amax1(cg(1)/convfac/mwsoap(1),bdnl(kacg2))
          con(kacg1) = amax1(cg(2)/convfac/mwsoap(2),bdnl(kacg1))
          con(kbcg2) = amax1(cg(3)/convfac/mwsoap(3),bdnl(kbcg2))
          con(kbcg1) = amax1(cg(4)/convfac/mwsoap(4),bdnl(kbcg1))
          con(kaoa2) = amax1(soacon(1),bdnl(kaoa2))
          con(kaoa1) = amax1(soacon(2),bdnl(kaoa1))
          con(kboa2) = amax1(soacon(3),bdnl(kboa2))
          con(kboa1) = amax1(soacon(4),bdnl(kboa1))
          con(kaoa0) = amax1(con(kaoa0),bdnl(kaoa0))
          con(kboa0) = amax1(con(kboa0),bdnl(kboa0))
c
c========================= Process Analysis Begin ======================
c
          if ( ldoipr ) then
            cipr(IPR_OAERO,ipa_cel,kacg2) = cipr(IPR_OAERO,ipa_cel,kacg2)
     &                                 + (con(kacg2)-cold(kacg2))*convfac
            cipr(IPR_OAERO,ipa_cel,kacg1) = cipr(IPR_OAERO,ipa_cel,kacg1)
     &                                 + (con(kacg1)-cold(kacg1))*convfac
            cipr(IPR_OAERO,ipa_cel,kbcg2) = cipr(IPR_OAERO,ipa_cel,kbcg2)
     &                                 + (con(kbcg2)-cold(kbcg2))*convfac
            cipr(IPR_OAERO,ipa_cel,kbcg1) = cipr(IPR_OAERO,ipa_cel,kbcg1)
     &                                 + (con(kbcg1)-cold(kbcg1))*convfac
            cipr(IPR_OAERO,ipa_cel,kaoa2)=cipr(IPR_OAERO,ipa_cel,kaoa2)
     &                                 + con(kaoa2)-cold(kaoa2)
            cipr(IPR_OAERO,ipa_cel,kaoa1)=cipr(IPR_OAERO,ipa_cel,kaoa1)
     &                                 + con(kaoa1)-cold(kaoa1)
            cipr(IPR_OAERO,ipa_cel,kboa2)=cipr(IPR_OAERO,ipa_cel,kboa2)
     &                                 + con(kboa2)-cold(kboa2)
            cipr(IPR_OAERO,ipa_cel,kboa1)=cipr(IPR_OAERO,ipa_cel,kboa1)
     &                                 + con(kboa1)-cold(kboa1)
            cipr(IPR_OAERO,ipa_cel,kaoa0)=cipr(IPR_OAERO,ipa_cel,kaoa0)
     &                                 + con(kaoa0)-cold(kaoa0)
            cipr(IPR_OAERO,ipa_cel,kboa0)=cipr(IPR_OAERO,ipa_cel,kboa0)
     &                                 + con(kboa0)-cold(kboa0)
          endif
c
c========================== Process Analysis End =======================
c

        endif ! VBS or SOAP?

      endif ! lsvoc?
c
c-----Do RADM aqueous chemistry if CWC is above threshold
c     All conc units must be mol/mol (mixing ratio)
c

      if (lradm) then
        pres_pa = 100.*press
        dt_sec = dtaq*3600.
        cw_kgm3 = cwc/1000.
c
        r_gas(1)  = con(kso2)*1.e-6
        r_gas(2)  = con(khno3)*1.e-6
        r_gas(3)  = con(kn2o5)*1.e-6
        r_gas(4)  = co2*1.e-6
        r_gas(5)  = con(knh3)*1.e-6
        r_gas(6)  = con(khpo_c)*1.e-6
        r_gas(7)  = con(ko3)*1.e-6
        if (kfoa_c.lt.nspec+1) then
          r_gas(8) = con(kfoa_c)*1.e-6
        else
          r_gas(8) = foa*1.e-6
        endif
        if (kmhp_c.lt.nspec+1 .or. kohp_c.lt.nspec+1) then
          r_1 = con(kmhp_c) + con(kohp_c)
          r_gas(9) = r_1*1.e-6
          if( r_1 .NE. 0. ) r_1 = con(kmhp_c) / r_1
        else
          r_gas(9) = mhp*1.e-6
          r_1 = 0.0
        endif
        if (kpaa_c.lt.nspec+1 .or. kopa_c.lt.nspec+1) then
          r_2 = con(kpaa_c) + con(kopa_c)
          r_gas(10) = r_2*1.e-6
          if( r_2 .NE. 0. ) r_2 = con(kpaa_c) / r_2
        else
          r_gas(10) = paa*1.e-6
          r_2 = 0.0
        endif
        r_gas(11) = con(ksulf)*1.e-6
c
        if (kgly.lt.nspec+1) then
          r_gas(12) = con(kgly)*1.e-6
        else
          r_gas(12) = gly*1.e-6
        endif
        if (kmgly.lt.nspec+1) then
          r_gas(13) = con(kmgly)*1.e-6
        else
          r_gas(13) = mgly*1.e-6
        endif
        if (kglyd.lt.nspec+1) then
          r_gas(14) = con(kglyd)*1.e-6
        else
          r_gas(14) = glyd*1.e-6
        endif
        r_gas(15)  = con(koh)*1.e-6
c
        r_aer(1)  = (con(kpso4)/wtmol(1)/convfac)*1.e-6
        r_aer(2)  = (con(kpnh4)/wtmol(2)/convfac)*1.e-6
        r_aer(3)  = (con(kpno3)/wtmol(3)/convfac)*1.e-6

        if (f_CA_PRM.ge.0. .and. f_CA_CRS.ge.0.) then
          r_aer(4) = ((f_CA_PRM*con(kFPRM) + f_CA_CRS*con(kFCRS))/
     &                wtmol(8)/convfac)*1.e-6
        else
          r_aer(4) = (caco3/(wtmol(8)+wtmol(7))/convfac)*1.e-6
        endif
        if (kPCA.lt.nspec+1) then
          r_aer(4) = r_aer(4) + (con(kPCA)/wtmol(8)/convfac)*1.e-6
        endif

        if (f_MG_PRM.ge.0. .and. f_MG_CRS.ge.0.) then
          r_aer(5) = ((f_MG_PRM*con(kFPRM) + f_MG_CRS*con(kFCRS))/
     &                wtmol(9)/convfac)*1.e-6
        else
          r_aer(5) = (mgco3/(wtmol(9)+wtmol(7))/convfac)*1.e-6
        endif
        if (kPMG.lt.nspec+1) then
          r_aer(5) = r_aer(5) + (con(kPMG)/wtmol(9)/convfac)*1.e-6
        endif

        if (kNA.lt.nspec+1 .and. kPCL.lt.nspec+1) then
          if (con(kNA).gt.con(kPCL)) then
            r_aer(6) = (con(kPCL)/wtmol(4)/convfac)*1.e-6
          else
            r_aer(6) = (con(kNA)/wtmol(5)/convfac)*1.e-6
          endif
        else
          r_aer(6) = (nacl/(wtmol(5)+wtmol(4))/convfac)*1.e-6
        endif

        if ( ldark ) then
          fe_iii = 0.9  ! nighttime fraction partitioning of FE(III), GS 01july2011
        else
          fe_iii = 0.1  ! daytime fraction partitioning of FE(III), GS 01july2011
        endif
        fe_sol = 0.1    ! solubility of Fe, GS 01July2011
        if (f_FE_PRM.ge.0. .and. f_FE_CRS.ge.0.) then
          fe_mmr = ((f_FE_PRM*con(kFPRM) + f_FE_CRS*con(kFCRS))/
     &               wtmol(10)/convfac)*1.e-6
          r_aer(7) = fe_iii*fe_sol*fe_mmr ! GS 01July2011
        else
          r_aer(7) = (a3fe/wtmol(10)/convfac)*1.e-6
        endif
        if (kPFE.lt.nspec+1) then
          r_aer(7) = max(r_aer(7),
     &               fe_iii*fe_sol*(con(kPFE)/wtmol(10)/convfac)*1.e-6)
        endif

        mn_ii  = 1.0    ! fraction partitioning of MN(II), GS 01July2011
        mn_sol = 0.5    ! solubility of Mn, GS 28July2011
        if (f_MN_PRM.ge.0. .and. f_MN_CRS.ge.0.) then
          mn_mmr = ((f_MN_PRM*con(kFPRM) + f_MN_CRS*con(kFCRS))/ 
     &               wtmol(11)/convfac)*1.e-6
          r_aer(8) = mn_ii*mn_sol*mn_mmr ! GS 01July2011
        else
          r_aer(8) = (b2mn/wtmol(11)/convfac)*1.e-6
        endif
        if (kPMN.lt.nspec+1) then
          r_aer(8) = max(r_aer(8),
     &               mn_ii*mn_sol*(con(kPMN)/wtmol(11)/convfac)*1.e-6)
        endif

        if (f_K_PRM.ge.0. .and. f_K_CRS.ge.0.) then
          r_aer(9) = ((f_K_PRM*con(kFPRM) + f_K_CRS*con(kFCRS))/
     &                wtmol(6)/convfac)*1.e-6
        else
          r_aer(9) = (potcl/(wtmol(6)+wtmol(4))/convfac)*1.e-6
        endif
        if (kPK.lt.nspec+1) then
          r_aer(9) = r_aer(9) + (con(kPK)/wtmol(6)/convfac)*1.e-6
        endif
c
c----- SOA from GLY/MGLY/GLYD (SOAC)
c
        csoac = con(ksoac_c)
        r_aer(10) = (csoac/wtmol(12)/convfac)*1.e-6
c
c========================= DDM Begin ===================================
c
        if (lddm) then
          do is = 1, 15
            r_old(is) = r_gas(is)
          enddo
          do is = 1, 10
            r_old(is+15) = r_aer(is)
          enddo
          call DDMRADINI (con(kso2),con(kna),con(kpcl),
     &                    f_CA_PRM,f_CA_CRS,
     &                    convfac,wtmol,sddm,nfam,nsen,NWTMOL)
        endif
c
c========================== DDM End ====================================
c
        call raqchem(tempk,pres_pa,dt_sec,cw_kgm3,r_gas,r_aer,cph,
     &               idiag,iout,igrdchm,ichm,jchm,kchm,wtmol(12))
c
c========================= DDM Begin ===================================
c
        if (lddm) then
          call DDMRADM (r_1,r_gas(9)/r_old(9),r_2,r_gas(10)/r_old(10),
     &                  convfac,wtmol,sddm,nfam,nsen,NWTMOL,ierr,iout)
          if (ierr.lt.0) then
            write(iout,'(a,4i4)') ' igrd,i,j,k = ',
     &                                          igrdchm,ichm,jchm,kchm
            write(iout,*) ' T,P,CW,DT = ',tempk,pres_pa,cw_kgm3,dt_sec
            write(iout,*) ' CONVFAC = ',convfac
            write(iout,*) ' r1,r11,r2,r22 = ',r_1,r_gas(9)/r_old(9)
     &                                       ,r_2,r_gas(10)/r_old(10)
            write(iout,*) ' R_GAS = ',(r_old(is),is=1,15)
            write(iout,*) ' R_AER = ',(r_old(is+15),is=1,10)
            do ip = 1, nfam
              if (con(kna).gt.con(kpcl)) then
                r_3 = sddm(ip,jdpPCL )/wtmol(4)/convfac *1.e-6
              else
                r_3 = sddm(ip,jdpNA  )/wtmol(5)/convfac *1.e-6
              endif
              write(iout,*) ' SI(',ip,') = ',
     &      (sddm(ip,jdpNH3 )+sddm(ip,jdpPNH4)/wtmol(2)/convfac)*1.e-6,
     &      (sddm(ip,jdpHNO3)+sddm(ip,jdpN2O5)*2.0
     &                       +sddm(ip,jdpPNO3)/wtmol(3)/convfac)*1.e-6,
     &             sddm(ip,jdpFOA )*1.e-6, 0.0, sddm(ip,jdpSO2 )*1.e-6,
     &      (sddm(ip,jdpSULF)+sddm(ip,jdpPSO4)/wtmol(1)/convfac)*1.e-6,
     &                  sddm(ip,jdpH2O2)*1.e-6, sddm(ip,jdpO3  )*1.e-6,
     &                   ( sddm(ip,jdpMHP ) + sddm(ip,jdpOHP ) )*1.e-6,
     &                   ( sddm(ip,jdpPAA ) + sddm(ip,jdpOPA ) )*1.e-6,
     &          r_3,(f_CA_PRM*sddm(ip,jdpFPRM)
     &              +f_CA_CRS*sddm(ip,jdpFCRS))/wtmol(8)/convfac*1.e-6,
     &                    sddm(ip,jdpGLY)*1.e-6,sddm(ip,jdpMGLY)*1.e-6,
     &                     sddm(ip,jdpGLYD)*1.e-6,sddm(ip,jdpHO)*1.e-6,
     &                        sddm(ip,jdpBOA0)/wtmol(12)/convfac*1.e-6
            enddo
            call camxerr()
          endif
        endif
c
c========================== DDM End ====================================
c
        con(kso2)  = amax1(r_gas(1) *1.e6,bdnl(kso2))     ! SO2 (ppm)
        con(khno3) = amax1(r_gas(2) *1.e6,bdnl(khno3))    ! HNO3 (ppm)
        con(kn2o5) = amax1(r_gas(3) *1.e6,bdnl(kn2o5))    ! N2O5 gas (ppm)
        con(knh3)  = amax1(r_gas(5) *1.e6,bdnl(knh3))     ! NH3 (ppm)
        con(khpo_c)= amax1(r_gas(6) *1.e6,bdnl(khpo_c))   ! H2O2 (ppm)
        con(ko3)   = amax1(r_gas(7) *1.e6,bdnl(ko3))      ! O3 (ppm)
!bk        con(kfoa_c)= amax1(r_gas(8) *1.e6,bdnl(kfoa_c)) ! not changed by RADM
        con(kmhp_c)= amax1(r_gas(9) *1.e6*r_1,bdnl(kmhp_c))
        con(kohp_c)= amax1(r_gas(9) *1.e6*(1.-r_1),bdnl(kohp_c))
        con(kpaa_c)= amax1(r_gas(10)*1.e6*r_2,bdnl(kpaa_c))
        con(kopa_c)= amax1(r_gas(10)*1.e6*(1.-r_2),bdnl(kopa_c))
        con(ksulf) = amax1(r_gas(11)*1.e6,bdnl(ksulf))    ! H2SO4 (ppm)
c
        con(kgly)  = amax1(r_gas(12)*1.e6,bdnl(kgly))     ! GLY (ppm)
        con(kmgly) = amax1(r_gas(13)*1.e6,bdnl(kmgly))    ! MGLY (ppm)
        con(kglyd) = amax1(r_gas(14)*1.e6,bdnl(kglyd))    ! GLYD (ppm)
c
        con(kpso4) = amax1(r_aer(1)*convfac*wtmol(1)*1.e6,bdnl(kpso4)) ! PSO4 (ug/m3)
        con(kpnh4) = amax1(r_aer(2)*convfac*wtmol(2)*1.e6,bdnl(kpnh4)) ! PNH4 (ug/m3)
        con(kpno3) = amax1(r_aer(3)*convfac*wtmol(3)*1.e6,bdnl(kpno3)) ! PNO3 (ug/m3)
c
        con(ksoac_c) = amax1(r_aer(10)*convfac*wtmol(12)*1.e6,
     &                                                  bdnl(ksoac_c)) ! SOAC (ug/m3)
        fcsoa(6) = con(ksoac_c) - csoac                                ! delta SOAC for PSAT
c
        con(nspec+1) = 0.
c
c========================= Process Analysis Begin ======================
c
        if ( ldoipr ) then
          cipr(IPR_AQCHEM,ipa_cel,kso2 )=cipr(IPR_AQCHEM,ipa_cel,kso2 )
     &                                +(con(kso2 )-cold(kso2 ))*convfac
          cipr(IPR_AQCHEM,ipa_cel,khno3)=cipr(IPR_AQCHEM,ipa_cel,khno3)
     &                                +(con(khno3)-cold(khno3))*convfac
          cipr(IPR_AQCHEM,ipa_cel,kn2o5)=cipr(IPR_AQCHEM,ipa_cel,kn2o5)
     &                                +(con(kn2o5)-cold(kn2o5))*convfac
          cipr(IPR_AQCHEM,ipa_cel,knh3 )=cipr(IPR_AQCHEM,ipa_cel,knh3 )
     &                                +(con(knh3 )-cold(knh3 ))*convfac
          cipr(IPR_AQCHEM,ipa_cel,khpo_c)
     &                                 =cipr(IPR_AQCHEM,ipa_cel,khpo_c)
     &                              +(con(khpo_c)-cold(khpo_c))*convfac
          cipr(IPR_AQCHEM,ipa_cel,ko3  )=cipr(IPR_AQCHEM,ipa_cel,ko3  )
     &                                +(con(ko3  )-cold(ko3  ))*convfac
!bk          if (kfoa_c.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kfoa_c) ! not changed by RADM
!bk     &                                 =cipr(IPR_AQCHEM,ipa_cel,kfoa_c)
!bk     &                              +(con(kfoa_c)-cold(kfoa_c))*convfac
          if (kmhp_c.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kmhp_c)
     &                                 =cipr(IPR_AQCHEM,ipa_cel,kmhp_c)
     &                              +(con(kmhp_c)-cold(kmhp_c))*convfac
          if (kohp_c.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kohp_c)
     &                                 =cipr(IPR_AQCHEM,ipa_cel,kohp_c)
     &                              +(con(kohp_c)-cold(kohp_c))*convfac
          if (kpaa_c.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kpaa_c)
     &                                 =cipr(IPR_AQCHEM,ipa_cel,kpaa_c)
     &                              +(con(kpaa_c)-cold(kpaa_c))*convfac
          if (kopa_c.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kopa_c)
     &                                 =cipr(IPR_AQCHEM,ipa_cel,kopa_c)
     &                              +(con(kopa_c)-cold(kopa_c))*convfac
          cipr(IPR_AQCHEM,ipa_cel,ksulf)=cipr(IPR_AQCHEM,ipa_cel,ksulf)
     &                                +(con(ksulf)-cold(ksulf))*convfac
          if (kgly.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kgly)
     &                                   =cipr(IPR_AQCHEM,ipa_cel,kgly)
     &                                  +(con(kgly)-cold(kgly))*convfac
          if (kmgly.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kmgly)
     &                                  =cipr(IPR_AQCHEM,ipa_cel,kmgly)
     &                                +(con(kmgly)-cold(kmgly))*convfac
          if (kglyd.lt.nspec+1) cipr(IPR_AQCHEM,ipa_cel,kglyd)
     &                                  =cipr(IPR_AQCHEM,ipa_cel,kglyd)
     &                                +(con(kglyd)-cold(kglyd))*convfac
          cipr(IPR_AQCHEM,ipa_cel,kpso4)=cipr(IPR_AQCHEM,ipa_cel,kpso4)
     &                                  +con(kpso4)-cold(kpso4)
          cipr(IPR_AQCHEM,ipa_cel,kpnh4)=cipr(IPR_AQCHEM,ipa_cel,kpnh4)
     &                                  +con(kpnh4)-cold(kpnh4)
          cipr(IPR_AQCHEM,ipa_cel,kpno3)=cipr(IPR_AQCHEM,ipa_cel,kpno3)
     &                                  +con(kpno3)-cold(kpno3)
          cipr(IPR_AQCHEM,ipa_cel,ksoac_c)
     &                                =cipr(IPR_AQCHEM,ipa_cel,ksoac_c)
     &                                  +con(ksoac_c)-csoac
        endif
c
c========================== Process Analysis End =======================
c
      endif ! lradm?
c
c======================== Source Apportion Begin =======================
c
      if( ldosa ) then
         do ispc=1,ngas
           delcon(2,ispc) = delcon(2,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc))*convfac
         enddo
         do ispc=ngas+1,nspec
           delcon(2,ispc) = delcon(2,ispc) +
     &                               AMAX1(bdnl(ispc),con(ispc))
         enddo
         deln2o5 = delcon(2,kn2o5) - delcon(1,kn2o5)
         delcon(4,khno3) = delcon(4,khno3) - deln2o5 * 2.0
         delcon(4,kn2o5) = delcon(4,kn2o5) + deln2o5
      endif
c
c======================== Source Apportion End =======================
c
c
c-----Inorganic aerosol equilibrium chemistry with ISORROPIA
c     Convert conc units to mol/m3 (double precision)
c
      if (lisor) then
c
c========================= Process Analysis Begin ======================
c
        if ( ldoipr ) then
          csulf = con(ksulf)
          chno3 = con(khno3)
          cnh3  = con(knh3 )
          cpso4 = con(kpso4)
          cpno3 = con(kpno3)
          cpnh4 = con(kpnh4)
        endif
c
c========================== Process Analysis End =======================
c
        if ( leqsam ) then ! EQSAM

        xTT = DBLE(tempk)
        xAW = DBLE(rh/100.)

        xYPa(1) = DBLE((con(knh3) *convfac + con(kpnh4)/wtmol(2))*1.e-6) ! NH4+  [mol/m3]
        if (kNA.lt.nspec+1 .and. kPCL.lt.nspec+1) then
          xYPa(2) = DBLE(                     con(kna )/wtmol(5) *1.e-6) ! Na+   [mol/m3]
          xYMa(4) = DBLE((con(khcl)*convfac + con(kpcl)/wtmol(4))*1.e-6) ! Cl-   [mol/m3]
        else
          xYPa(2) = DBLE(                nacl/(wtmol(5)+wtmol(4))*1.e-6)
          xYMa(4) = DBLE(con(khcl)*convfac*1.e-6) + xYPa(2)
        endif
        if (f_K_PRM.ge.0. .and. f_K_CRS.ge.0.) then
          xYPa(3) = DBLE((f_K_PRM*con(kFPRM) + f_K_CRS*con(kFCRS))
     &                                                 /wtmol(6) *1.e-6) ! K+    [mol/m3]
        else
          xYPa(3) = DBLE(               potcl/(wtmol(6)+wtmol(4))*1.e-6)
          xYMa(4) = xYMa(4) + xYPa(3)
        endif
        if (kPK.lt.nspec+1) then
          xYPa(3) = xYPa(3) + DBLE(           con(kpk )/wtmol(6) *1.e-6)
        endif
        if (f_CA_PRM.ge.0. .and. f_CA_CRS.ge.0.) then
          xYPa(4) = DBLE((f_CA_PRM*con(kFPRM) + f_CA_CRS*con(kFCRS))
     &                                                 /wtmol(8) *1.e-6) ! Ca++  [mol/m3]
        else
          xYPa(4) = DBLE(               caco3/(wtmol(8)+wtmol(7))*1.e-6)
        endif
        if (kPCA.lt.nspec+1) then
          xYPa(4) = xYPa(4) + DBLE(           con(kpca)/wtmol(8) *1.e-6)
        endif
        if (f_MG_PRM.ge.0. .and. f_MG_CRS.ge.0.) then
          xYPa(5) = DBLE((f_MG_PRM*con(kFPRM) + f_MG_CRS*con(kFCRS))
     &                                                 /wtmol(9) *1.e-6) ! Mg++  [mol/m3]
        else
          xYPa(5) = DBLE(               mgco3/(wtmol(9)+wtmol(7))*1.e-6)
        endif
        if (kPMG.lt.nspec+1) then
          xYPa(5) = xYPa(5) + DBLE(           con(kpmg)/wtmol(9) *1.e-6)
        endif
        xYMa(1) = DBLE((con(ksulf)*convfac + con(kpso4)/wtmol(1))*1.e-6) ! SO4-- [mol/m3]
        xYMa(2) = 0.0_dp                                                 ! HSO4- [mol/m3]
        xYMa(3) = DBLE((con(khno3)*convfac + con(kpno3)/wtmol(3))*1.e-6) ! NO3-  [mol/m3]

        xWH2O = 0.0_dp ! set to zero to make the EQSAM metastable flag effective

        wt_save(2) = xYMa(1)
        wt_save(3) = xYPa(1)
        wt_save(4) = xYMa(3)
        wt_save(5) = xYMa(4)

        call EQSAM4clim(xTT,xAW,xsPM,xaPM,xPMS,xPMT,xRHO,xVOL,xPH,xHp,
     &                  xGF,xWH2O,xYPa,xYPs,xYMa,xYMs,xYG,
     &                  imask,1,1,jmeq,Dd)

        con(ksulf) = bdnl(ksulf)
        con(kpso4) = wt_save(2) - DBLE(con(ksulf)*1.e-6*convfac)
        con(kpso4) = amax1(con(kpso4)*wtmol(1)*1.e6,bdnl(kpso4))

        con(khno3) = REAL(xYG(1))*1.e6/convfac
        con(khno3) = amax1(con(khno3),bdnl(khno3))
        con(kpno3) = wt_save(4) - DBLE(con(khno3)*1.e-6*convfac)
        con(kpno3) = amax1(con(kpno3)*wtmol(3)*1.e6,bdnl(kpno3))

        con(knh3 ) = REAL(xYG(3))*1.e6/convfac
        con(knh3 ) = amax1(con(knh3),bdnl(knh3))
        con(kpnh4) = wt_save(3) - DBLE(con(knh3)*1.e-6*convfac)
        con(kpnh4) = amax1(con(kpnh4)*wtmol(2)*1.e6,bdnl(kpnh4))

        if (khcl.lt.nspec+1) then
          con(khcl ) = REAL(xYG(2))*1.e6/convfac
          con(khcl ) = amax1(con(khcl),bdnl(khcl))
        endif
        if (kpcl.lt.nspec+1) then
          con(kpcl ) = wt_save(5) - DBLE(con(khcl)*1.e-6*convfac)
          con(kpcl ) = amax1(con(kpcl)*wtmol(4)*1.e6,bdnl(kpcl))
        endif

        con(kph2o) = amax1(REAL(xWH2O),bdnl(kph2o))

        aph = REAL(xPH)
        aph = MIN(MAX(aph,-2.0),10.0)

        else ! ISORROPIA

        rhi = DBLE(rh/100.)
        tempi = DBLE(tempk)
        cntrl(1) = 0.d0                   ! 0 = forward problem
        cntrl(2) = 1.d0                   ! 1 = metastable liquid state

        if (kNA.lt.nspec+1 .and. kPCL.lt.nspec+1) then
          wi(1) = DBLE(con(kna)/wtmol(5)*1.e-6)                        ! total sodium
          wi(5) = DBLE((con(khcl)*convfac + con(kpcl)/wtmol(4))*1.e-6) ! total chloride
        else
          wi(1) = DBLE(nacl/(wtmol(5)+wtmol(4))*1.e-6)                 ! total sodium
          wi(5) = DBLE(con(khcl)*convfac*1.e-6) + wi(1)                ! total chloride
        endif
        wi(2) = DBLE((con(ksulf)*convfac + con(kpso4)/wtmol(1))*1.e-6) ! total sulfate
        wi(3) = DBLE((con(knh3) *convfac + con(kpnh4)/wtmol(2))*1.e-6) ! total ammonium
        wi(4) = DBLE((con(khno3)*convfac + con(kpno3)/wtmol(3))*1.e-6) ! total nitrate

        if (f_CA_PRM.ge.0. .and. f_CA_CRS.ge.0.) then
          dno3 = DBLE((f_CA_PRM*con(kFPRM) + f_CA_CRS*con(kFCRS))
     &                                               /wtmol(8) *1.e-6)
        else
          dno3 = DBLE(caco3/(wtmol(8)+wtmol(7))*1.e-6)
        endif
        if (kPCA.lt.nspec+1) then
          dno3 = dno3 + DBLE(con(kPCA)/wtmol(8)*1.e-6) ! half of CaCO3 is assumed to be replaced by Ca(NO3)2          
        endif
        if (dno3.lt.wi(4)) then
          wi(4) = wi(4) - dno3 ! exclude calcium nitrate
          lno3_isr = .true.
        else ! all nitrate is calcium nitrate
          con(khno3) = bdnl(khno3)
          con(kpno3) = amax1( (REAL(wi(4))*1.e6 - con(khno3)*convfac)
     &                                  * wtmol(3), bdnl(kpno3) )
          wi(4) = 0.d0
          lno3_isr = .false.
        endif
c
        do is = 1, 5
          wt_save(is) = wi(is)
        enddo
c
c========================= DDM Begin ===================================
c
        if (lddm) then
          call DDMISRINI (lno3_isr,f_CA_PRM,f_CA_CRS,
     &                    convfac,wtmol,sddm,nfam,nsen,NWTMOL,iout)
        endif
c
c========================== DDM End ====================================
c
        call isoropia(wi,rhi,tempi,cntrl,wt,gasis,aerliq,aersld,
     &                scasi,other)
c
c========================= DDM Begin ===================================
c
        if (lddm) then
          call DDMISRPIA (lno3_isr,f_CA_PRM,f_CA_CRS,
     &                    convfac,wtmol,sddm,nfam,nsen,NWTMOL,ierr,iout)
          if (ierr.lt.0) then
            write(iout,'(a,4i4)') ' igrd,i,j,k = ',
     &                                          igrdchm,ichm,jchm,kchm
            write(iout,*) ' RH,T = ',rhi,tempi
            write(iout,*) ' CONVFAC = ',convfac
            write(iout,*) ' WI = ',(wt_save(is),is=1,5)
            write(iout,*) ' LNO3_ISR = ',lno3_isr,f_CA_PRM,f_CA_CRS,
     &                     (sddm(ip,jdpFPRM),sddm(ip,jdpFCRS),ip=1,nfam)
            do ip = 1, nfam
              if (lno3_isr) then
                r_1 = (          sddm(ip,jdpHNO3)*convfac
     &                +          sddm(ip,jdpPNO3)/wtmol(3)
     &                -(f_CA_PRM*sddm(ip,jdpFPRM)
     &                 +f_CA_CRS*sddm(ip,jdpFCRS))/wtmol(8))*1.e-6
              else
                r_1 = 0.0
              endif
              write(iout,*) ' SI(',ip,') = ',
     &                                sddm(ip,jdpNA  )/wtmol(5) *1.e-6,
     &      (sddm(ip,jdpSULF)*convfac+sddm(ip,jdpPSO4)/wtmol(1))*1.e-6,
     &      (sddm(ip,jdpNH3 )*convfac+sddm(ip,jdpPNH4)/wtmol(2))*1.e-6,
     &                                                             r_1,
     &      (sddm(ip,jdpHCL )*convfac+sddm(ip,jdpPCL )/wtmol(4))*1.e-6
            enddo
            call camxerr()
          endif
        endif
c
c========================== DDM End ====================================
c 
c-----Load results back to local CON array (ppm for gas, ug/m3 for aerosol)
c 
        con(ksulf) = bdnl(ksulf)                                  ! sulfuric acid gas
        con(kpso4) = wt_save(2) - DBLE(con(ksulf)*1.e-6*convfac)  ! sulfate
        con(kpso4) = amax1(con(kpso4)*wtmol(1)*1.e6,bdnl(kpso4))
c
        if (lno3_isr) then
          con(khno3) = REAL(gasis(2))*1.e6/convfac                ! nitric acid gas
          con(khno3) = amax1(con(khno3),bdnl(khno3))    
          con(kpno3) = wt_save(4) - DBLE(con(khno3)*1.e-6*convfac)! nitrate
          con(kpno3) = con(kpno3) + dno3                          ! add calcium nitrate back
          con(kpno3) = amax1(con(kpno3)*wtmol(3)*1.e6,bdnl(kpno3))
        endif
c
        con(knh3 ) = REAL(gasis(1))*1.e6/convfac                  ! ammonia gas
        con(knh3 ) = amax1(con(knh3),bdnl(knh3))    
        con(kpnh4) = wt_save(3) - DBLE(con(knh3)*1.e-6*convfac)   ! ammonium
        con(kpnh4) = amax1(con(kpnh4)*wtmol(2)*1.e6,bdnl(kpnh4))
c
        if (khcl.lt.nspec+1) then
          con(khcl) = REAL(gasis(3))*1.e6/convfac                 ! HCl gas
          con(khcl) = amax1(con(khcl),bdnl(khcl))
        endif
        if (kpcl.lt.nspec+1) then
          con(kpcl) = wt_save(5) - DBLE(con(khcl)*1.e-6*convfac)  ! chloride
          con(kpcl) = amax1(con(kpcl)*wtmol(4)*1.e6,bdnl(kpcl))
        endif
c
        con(kph2o) = REAL(aerliq(8))                              ! aerosol water
        con(kph2o) = amax1(con(kph2o)*18.*1.e6,bdnl(kph2o))
c
        aph = LOG10(REAL(aerliq(8)*18.D-3/MAX(aerliq(1),1.D-20))) ! aerosol pH
        aph = MIN(MAX(aph,-2.0),10.0)

        endif ! leqsam?
c
c========================= Process Analysis Begin ======================
c
        if ( ldoipr ) then
          cipr(IPR_IAERO,ipa_cel,ksulf) = cipr(IPR_IAERO,ipa_cel,ksulf)
     &                                  + (con(ksulf)-csulf)*convfac
          cipr(IPR_IAERO,ipa_cel,khno3) = cipr(IPR_IAERO,ipa_cel,khno3)
     &                                  + (con(khno3)-chno3)*convfac
          cipr(IPR_IAERO,ipa_cel,knh3 ) = cipr(IPR_IAERO,ipa_cel,knh3 )
     &                                  + (con(knh3 )-cnh3 )*convfac
          cipr(IPR_IAERO,ipa_cel,kpso4) = cipr(IPR_IAERO,ipa_cel,kpso4)
     &                                  + con(kpso4)-cpso4
          cipr(IPR_IAERO,ipa_cel,kpno3) = cipr(IPR_IAERO,ipa_cel,kpno3)
     &                                  + con(kpno3)-cpno3
          cipr(IPR_IAERO,ipa_cel,kpnh4) = cipr(IPR_IAERO,ipa_cel,kpnh4)
     &                                  + con(kpnh4)-cpnh4
          if (khcl.lt.nspec+1)
     &      cipr(IPR_IAERO,ipa_cel,khcl) = cipr(IPR_IAERO,ipa_cel,khcl)
     &                                 + (con(khcl)-cold(khcl))*convfac
          if (kpcl.lt.nspec+1)
     &      cipr(IPR_IAERO,ipa_cel,kpcl) = cipr(IPR_IAERO,ipa_cel,kpcl)
     &                                   + con(kpcl)-cold(kpcl)
          cipr(IPR_IAERO,ipa_cel,kph2o) = cipr(IPR_IAERO,ipa_cel,kph2o)
     &                                  + con(kph2o)-cold(kph2o)
        endif
c
c========================== Process Analysis End =======================
c
      endif ! lisor?
c
      return
c
 7000 continue
      write(iout,'(//,2a)') 'ERROR in AEROCHEM_CF ', location
      write(iout,*) 'Possibly a bad concentration e.g. NaN or Inf'
      write(iout,*) 'igrd, i, j, k = ', igrdchm,ichm,jchm,kchm
      write(iout,'(/,a)') '#    Name   ppm or ug/m3'
      do ispc = 1,nspec
        write(iout,'(i3,2x,a7,e10.3)') ispc,spname(ispc),con(ispc)
      enddo
      call camxerr()
c
      end

      subroutine camxerr()
      use filunit
c   
c----CAMx v7.40 260801
c   
c     CAMXERR writes the final message whenever CAMx terminates
c             due to an error
c                             
c      Copyright Ramboll
c             
c     Modifications:   
c        none 
c 
c     Input arguments:
c        none 
c 
c     Output arguments: 
c        none 
c               
c     Routines Called:   
c        none 
c               
c     Called by:   
c        O3COLPREP
c        AREAPREP
c        AVGRCP
c        BCMODFY
c        BNDPREP
c        CHEMDRIV
c        CLCBWT
c        CLCEWT
c        CLCIWT
c        CNCPREP
c        DDMJAC
c        DIEHSOLV
c        DRYDEP
c        EMPREPSA
c        GETDEPTH
c        HDRRCP
c        HDRWSA
c        IEHSOLV
c        INIPTR
c        INSTSA
c        KTHERM
c        OPENFILS
c        PARNTCHD
c        IRONDRIVE
c        IRONGROW
c        GRESDRIVE
c        GRESGROW
c        PIGINIT
c        PIGPREP
c        PIGWALK
c        RADINIT
c        RADSLVR
c        RDARGRP
c        RDFGCON
c        RDFGSA
c        RDINSTSA
c        RDOPTSA
c        RDPTGRP
c        RDPTHDR
c        RDSUMBC
c        READO3COL
c        READAR
c        READARSA
c        READBND
c        READCHM
c        READCNC
c        READINP
c        READPT
c        READPTSA
c        METINIT
c        RERCP
c        RESMAP
c        SPECSA
c        STARTSA
c        STARTUP
c        SUMGRPS
c        TRAP
c        VNMSHCAL
c        VRTSLV
c 
      include "camx.prm"
      include "flags.inc"
      include "mpif.h"
c
c-----Entry point
c
      write(*,*) 
      write(*,*) 
      write(*,*) ' CAMx is stopping because an error has occurred'
      write(*,*) ' See the .out output file for details'
      write(*,*) 
      write(*,*) 
      call flush(6)
c
      write(iout,*) 
      write(iout,*) 
      write(iout,*) ' CAMx is stopping because of the error(s) ',
     &              'described above'
      write(iout,*) 
      write(iout,*) 
      call flush(iout)
c
      if( lcdfout ) call ncf_closefiles()
c
      if( lmpi ) call MPI_Abort(MPI_COMM_WORLD,1,ierr)
c
      call exit(1)
c
      end

      subroutine ve_gas(z0,deltaz,psih,ustar,diffrat,ve)
c
c----CAMx v7.40 260801
c
c     VE_GAS calculates an exchange/re-emission velocity for a specific gas 
c     species, grid cell, and land use category. 
c
c      Copyright Ramboll
c 
c     Modifications: 
c        12/08/09   ---jjung---    Original development (for RTRAC)
c        04/29/13   --cemery---    Updated for species in the core model
c                                  Exchange across water-air interface ignored
c
c     Input arguments: 
c        z0                  surface roughness length (m)
c        deltaz              Layer 1 midpoint height (m)
c        psih                similarity stability correction term 
c        ustar               friction velocity (m/s)
c        diffrat             ratio of molecular diffusivity of water to species
c      
c     Output arguments: 
c        ve                  re-emission velocity (m/s)
c      
c     Routines called: 
c        none 
c      
c     Called by: 
c        SRFMOD
c 
      implicit none

      real z0,deltaz,psih,ustar,diffrat,ve
c
      real vk,rmin,d1,d2,vair,diffh2o
      real ra,rd,re
      real schmidt
c
      data vk/0.4/, rmin/1.0/, d1/2./, d2/0.667/
      data vair/1.5e-5/, diffh2o/2.3e-5/
c
c-----Entry point
c
      re = 0.
c
c-----Compute atmospheric resistance, RA
c
      ra = (alog(deltaz/z0) - psih)/(vk*ustar)
      ra = amax1(ra,rmin)
c
c-----Compute the deposition layer resistance, RD
c
      schmidt = vair*diffrat/diffh2o
      rd = d1*schmidt**d2/(vk*ustar)
      rd = amax1(rd,rmin)
c
c-----Re-emission velocity for this cell, land use, and species
c
 100  continue
      ve = 1./(ra + rd + re)
c
      return
      end

      subroutine lsrate_pig(neq,t,y,rate,nr,r)
      implicit none
c
c----CAMx v7.40 260801
c
c     LSRATE_pig computes double precision species rates
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CAMx PiG NO/NO2/O3/HNO3/H2SO4
c
c     Routines Called:
c        LSRXN_pig
c
c     Called by:
c        LSODE
c
      include "camx.prm"
      include "chmdat.inc"
      include "lsbox.inc"
      include "ddmchm.inc"
c
      integer neq, nr, l
      double precision t
      double precision y(*)
      double precision rate(neq)
      double precision r(MXREACT)
      double precision loss(MXSPEC+1)
      double precision gain(MXSPEC+1)
c
c --- Entry point
c
c --- Get reaction rates, r
c
      call lsrxn_pig(dH2O,dM,dO2,dCH4,dH2,y,dbrk,r)
c
      do l = 1,neq
        Loss(l) = 0.0d0
        Gain(l) = 0.0d0
      enddo
c
c --- Calculate the species rates
c
c
c   NO2    NO     O    O3  HONO   O1D    OH  HNO3   NO3  N2O5
c   SO2  SULF   HO2    CO  FORM
c
        Loss(l_NO2 )= +         r(  1)+         r(  5)+         r( 10)
     &                +         r( 11)+         r( 15)+         r( 16)
c
        Gain(l_NO2 )= +         r(  3)+( 2.000)*r(  4)+         r( 12)
     &                +( 2.000)*r( 14)+         r( 15)+         r( 17)
     &                +         r( 23)
c
        Loss(l_NO  )= +         r(  3)+( 2.000)*r(  4)+         r(  5)
     &                +         r( 14)+         r( 23)
c
        Gain(l_NO  )= +         r(  1)+         r(  9)+         r( 13)
     &                +         r( 15)
c
        Loss(l_O   )= +         r(  2)
c
        Gain(l_O   )= +         r(  1)+         r(  7)+         r( 12)
c
        Loss(l_O3  )= +         r(  3)+         r(  6)+         r( 11)
c
        Gain(l_O3  )= +         r(  2)
c
        Loss(l_HONO)= +         r(  9)
c
        Gain(l_HONO)= +( 2.000)*r(  5)
c
        Loss(l_O1D )= +         r(  7)+         r(  8)
c
        Gain(l_O1D )= +         r(  6)
c
        Loss(l_OH  )= +         r( 10)+         r( 19)+         r( 20)
c
        Gain(l_OH  )= +( 2.000)*r(  8)+         r(  9)+         r( 23)
c
        Loss(l_HNO3)= 0.0
c
        Gain(l_HNO3)= +         r( 10)+( 2.000)*r( 18)
c
        Loss(l_NO3 )= +         r( 12)+         r( 13)+         r( 14)
     &                +         r( 15)+         r( 16)
c
        Gain(l_NO3 )= +         r( 11)+         r( 17)
c
        Loss(l_N2O5)= +         r( 17)+         r( 18)
c
        Gain(l_N2O5)= +         r( 16)
c
        Loss(l_SO2 )= +         r( 19)
c
        Gain(l_SO2 )= 0.0
c
        Loss(l_SULF)= 0.0
c
        Gain(l_SULF)= +         r( 19)
c
        Loss(l_HO2 )= +         r( 23)
c
        Gain(l_HO2 )= +         r( 19)+         r( 20)+( 2.000)*r( 21)
c
        Loss(l_CO  )= +         r( 20)
c
        Gain(l_CO  )= +         r( 21)+         r( 22)
c
        Loss(l_FORM)= +         r( 21)+         r( 22)
c
        Gain(l_FORM)= 0.0
c
c
      do l = 1,neq
        rate(l) = gain(l) -loss(l)
      enddo
c
      return
      end

      subroutine vdiffk(ns,nn,dt,vdep,depth,rho,rkv,con,nparddm,
     &                  fluxbot,fcup,fcdn,ldoipts)
      use procan
c
c----CAMx v7.40 260801
c
c     VDIFFK performs vertical diffusion of concentrations using 
c     an implicit method, where a tri-diagonal matrix is solved.
c     This version also performs vertical diffusion of sensitivities
c     if DDM is enabled.
c
c      Copyright Ramboll
c          
c     Modifications:
c        4/17/00   Revised diffusion equations to weight fluxes by density
c       10/10/08   Revised to move species loop into this routine for
c                  better efficiency
c
c     Input arguments:
c        ns                number of species
c        nn                number of layers
c        dt                time step (s)
c        vdep              deposition velocity (m/s)
c        depth             layer depth (m)
c        rho               atmospheric density (mb/K)
c        rkv               vertical diffusion coefficient (mb m2/s/K)
c        con               species concentrations (umol/m3) followed by 
c                          sensitivities (umol/m3/parameter unit).
c        nparddm           number of parameters for which sensitivities
c                          are calculated.  Should be zero if DDM is not
c                          enabled.
c        ldoipts           flag to calculate data for Process Analysis
c
c     Output arguments:
c        con               species concentrations (umol/m3) followed by
c                          sensitivities (umol/m3/parameter unit)
c        fcup              change in layer concentration due to flux across
c                          upper interface (umol/m3) -- FOR Process Analysis
c        fcdn              change in layer concentration due to flux across
c                          lower interface (umol/m3) -- FOR Process Analysis
c        fluxbot           Concentration removed by dry deposition (umol/m3)
c
c     Routines Called:
c        TRIDIAG
c
c     Called by:
c        DIFFUS
c
      implicit none
      include "camx.prm"
c
      integer ns,nn,nparddm
      real dt
      real vdep(ns)
      real con(nn+nn*nparddm,ns)
      real depth(nn)
      real rkv(nn)
      real rho(nn)
      real fluxbot(ns)
c
c======================== Process Analysis Begin ====================================
c
      logical ldoipts
c
      real aa_old(MXLAYER)
      real cc_old(MXLAYER)
      real fcup(MXLAYER,MXSPEC)
      real fcdn(MXLAYER,MXSPEC)
c
c========================= Process Analysis End =====================================
c
      integer k,l
      real rr(MXLAYER+MXLAYER*MXTRSP)
      real aa(MXLAYER)
      real bb(MXLAYER)
      real cc(MXLAYER)
c
c-----Entry point
c
      do l = 1,ns
        do k = 1,nn+nn*nparddm
          rr(k) = con(k,l)
        enddo
c
c-----Lower boundary condition
c
        aa(1) = 0.
        bb(1) = 1. + dt/depth(1)*
     &               (vdep(l) + 2.*rkv(1)/(depth(2)+depth(1))/rho(1))
c
c-----Upper boundary condition
c
        cc(nn) = 0.
        bb(nn) = 1. + dt/depth(nn)*
     &                2.*rkv(nn-1)/(depth(nn-1)+depth(nn))/rho(nn)
c
        do k = 2,nn
         aa(k) = -dt/depth(k)*2.*rkv(k-1)/(depth(k-1)+depth(k))/rho(k-1)
        enddo
        do k = 1,nn-1
         cc(k) = -dt/depth(k)*2.*rkv(k)/(depth(k+1)+depth(k))/rho(k+1)
        enddo
        do k = 2,nn-1
          bb(k) = 1.
     &            + dt/depth(k)*2.*rkv(k-1)/(depth(k-1)+depth(k))/rho(k)
     &            + dt/depth(k)*2.*rkv(k)/(depth(k+1)+depth(k))/rho(k)
        enddo
c
c======================== Process Analysis Begin ====================================
c
        if (ldoipts) then
          do k = 1,nn
            aa_old(k) = 0.
            cc_old(k) = 0.
            if (k.gt.1)  aa_old(k) = aa(k)*rho(k-1)
            if (k.lt.nn) cc_old(k) = cc(k)*rho(k+1)
          enddo
        endif
c 
c========================= Process Analysis End =====================================
c
c
c-----Solve the equations
c
        call tridiag(aa,bb,cc,rr,nn,1+nparddm)
c
c
c======================== Process Analysis Begin ====================================
c
        if (ldoipts) then
          do k = 2,nn-1
            fcup(k,l) = (rr(k)/rho(k) - rr(k+1)/rho(k+1))*cc_old(k)
            fcdn(k,l) = (rr(k)/rho(k) - rr(k-1)/rho(k-1))*aa_old(k)
          enddo
c
c-----Lower boundary
c
          fcup(1,l) = (rr(1)/rho(1) - rr(2)/rho(2))*cc_old(1)
          fcdn(1,l) = -rr(1)*dt/depth(1)*vdep(l)
c
c-----Upper boundary
c
          fcup(nn,l) =  0.0
          fcdn(nn,l) =  (rr(nn)/rho(nn) - rr(nn-1)/rho(nn-1))*aa_old(nn)
        endif
c 
c========================= Process Analysis End =====================================
c
        do k = 1,nn+nn*nparddm
          con(k,l) = rr(k)
        enddo
        fluxbot(l) = -con(1,l)*vdep(l)*dt/depth(1)
      enddo
c
      return
      end

c**** NCF_CHK_TSTEP
c
      subroutine ncf_chk_tstep(iounit,action,begin_date,begin_time,
     &                           ending_date,ending_time,ignore_date)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine checks that the time span in the file encompasses
c   the simulation period and that there is gridded data for each
c   tome period that will be accessed.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         iounit      I NCF file ID
c         action      C string that describes file being read
c         begin_date  I model begin date (YYJJJ)
c         begin_time  R model begin time
c         ending_date I model end date (YYJJJ)
c         ending_time R model end time
c         ignore_date L .FALSE. if date should not be checked
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit
      character*(*) action
      integer       begin_date
      real          begin_time
      integer       ending_date
      real          ending_time
      logical       ignore_date
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 this_var
      integer       sdate_mod, sdate_in, stime_mod, stime_in, nsteps
      integer       tstep_in, nvars_in, tflag_varid, etflag_varid
      integer       data_start(3), data_count(3), this_tstep, ierr
      integer       tflag_first(2), tflag_last(2)
      integer       etflag_first(2), etflag_last(2)
      real          date_time_beg, date_time_end
      real          date_time_tflag, date_time_etflag
      logical       lread_ok, lcheck_begtime, lcheck_endtime
c
      integer,      allocatable, dimension(:,:) :: tflag_in
      integer,      allocatable, dimension(:,:) :: etflag_in
c
c-----------------------------------------------------------------------
c    Parameters:
c-----------------------------------------------------------------------
c
      real FUZZ
      parameter( FUZZ = 0.01 )
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- assume all variables are available ----
c
      lread_ok = .TRUE.
c
c  --- get the time variables needed to check ---
c
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'SDATE', sdate_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'STIME', stime_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'TSTEP', tstep_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NVARS', nvars_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      if( .NOT. lread_ok ) goto 7001
c
c  --- allocate the arrays for the time flags ---
c
      allocate( tflag_in(2,nvars_in))
      allocate( etflag_in(2,nvars_in))
c
c  --- calculate date/time together ---
c
      if( ignore_date ) then
         if( begin_date/1000 .LE. 80 ) then
            date_time_beg = REAL(2000000+begin_date)+begin_time/2400.
            date_time_end = REAL(2000000+begin_date)+ending_time/2400.
         else
            date_time_beg = REAL(1900000+begin_date)+begin_time/2400.
            date_time_end = REAL(1900000+ending_date)+ending_time/2400.
         endif
      else
         if( begin_date/1000 .LE. 80 ) then
             date_time_beg = REAL(2000000+begin_date)+begin_time/2400.
             date_time_end = REAL(2000000+ending_date)+ending_time/2400.
          else
             date_time_beg = REAL(1900000+begin_date)+begin_time/2400.
             date_time_end = REAL(1900000+ending_date)+ending_time/2400.
          endif
      endif
c
c  --- get each time flag pair and check that 
c
      lcheck_begtime = .FALSE.
      lcheck_endtime = .FALSE.
      this_var = 'TFLAG'
      ierr = nf_inq_varid(iounit,this_var,tflag_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      this_var = 'ETFLAG'
      ierr = nf_inq_varid(iounit,this_var,etflag_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      data_start(1) = 1
      data_count(1) = 2
      data_start(2) = 1
      data_count(2) = nvars_in
      this_tstep = 0
 111  continue
      this_tstep = this_tstep + 1
      data_start(3) = this_tstep
      data_count(3) = 1
      ierr = nf_get_vara_int(iounit,tflag_varid,data_start,data_count,tflag_in)
      if( ierr .NE. NF_NOERR ) goto 222
      ierr = nf_get_vara_int(iounit,etflag_varid,data_start,data_count,etflag_in)
      if( ierr .NE. NF_NOERR ) goto 222
c
c  --- calculate date/time together ---
c
      if( ignore_date ) then
         if( begin_date/1000 .LE. 80 ) then
            date_time_tflag = REAL(2000000+begin_date)+REAL(tflag_in(2,1))/240000.
            date_time_etflag = REAL(2000000+begin_date)+REAL(etflag_in(2,1))/240000.
         else
            date_time_tflag = REAL(1900000+begin_date)+REAL(tflag_in(2,1))/240000.
            date_time_etflag = REAL(1900000+begin_date)+REAL(etflag_in(2,1))/240000.
         endif
      else
         date_time_tflag = REAL(tflag_in(1,1))+REAL(tflag_in(2,1))/240000.
         date_time_etflag = REAL(etflag_in(1,1))+REAL(etflag_in(2,1))/240000.
         call clean_date_time(date_time_tflag)
         call clean_date_time(date_time_etflag)
      endif
      if( this_tstep .EQ. 1 ) then
          tflag_first(1) = tflag_in(1,1)
          tflag_first(2) = tflag_in(2,1)
          etflag_first(1) = etflag_in(1,1)
          etflag_first(2) = etflag_in(2,1)
      endif
      tflag_last(1) = tflag_in(1,1)
      tflag_last(2) = tflag_in(2,1)
      etflag_last(1) = etflag_in(1,1)
      etflag_last(2) = etflag_in(2,1)
c
c  --- check if this time period covers the beginning episode time ---
c
      if( date_time_beg .GE. date_time_tflag .AND. date_time_beg .LE.
     &                              date_time_etflag) lcheck_begtime = .TRUE.
c
c  --- check if this time period covers the ending episode time ---
c
      if( date_time_end .GE. date_time_tflag .AND. date_time_end .LE.
     &                              date_time_etflag) lcheck_endtime = .TRUE.
c
      if( lcheck_begtime .AND. lcheck_endtime ) goto 9999
      goto 111
c
 222  continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Did not find suitable timesteps in the file ',
     &                                     'for this simulation period.'
      write(iout,'(A,4I10)') 'First timestep: ',tflag_first(1), tflag_first(2),
     &                                        etflag_first(1), etflag_first(2)
      write(iout,'(A,4I10)') 'Last timestep : ',tflag_last(1), tflag_last(2),
     &                                        etflag_last(1), etflag_last(2)
      write(iout,'(2A)') 'Check that the file contains all hours ',
     &                                               'to be simulated.'
      call camxerr()
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get global attributes for time span.',
     &                                                ' Looking for: '
      write(iout,'(10X,A)') 'SDATE'
      write(iout,'(10X,A)') 'STIME'
      write(iout,'(10X,A)') 'TSTEP'
      write(iout,'(10X,A)') 'NVARS'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return

      contains

      subroutine clean_date_time(date_time)
        ! handle datetime past end of year

        real, intent(inout) :: date_time
        integer :: nday, year,jday

        year=int(date_time)/1000
        jday = int(date_time) - year*1000
        if (mod(year,4)==0) then
                nday=366
        else
                nday=365
        endif

        if (jday>nday) then

          if (jday>nday+365) then
            print*,'dont go too far!'
            print*,date_time, year, jday, nday
            stop
          endif

          year = year+1
          jday = 1
          date_time = year*1000 + jday + mod(date_time, 1.0)

        endif
      end subroutine
      end
 

      subroutine mpi_feedback(inest,iparent,icode)
      use grid
      use camxfld
      use tracer
      use procan
      use rtracchm
      implicit none
c
c----CAMx v7.40 260801
c
c     This routine does the nest to parent feeback calculations for
c     an MPI run. It just calls the routines that perform the tasks
c     necessary for this operation. These include mass balance summary
c     calculations, as well as the sending/receiving routines needed
c     do feedback for all necessary fields.
c                          
c      Copyright Ramboll
c          
c     Modifications:
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c       04/30/13     Added surface model
c       08/26/21     RTRAC surface file doubles as (default)
c                    dep output or (flagged) surface model output
c
c     Input arguments:
c        inest    grid ID for the nest
c        iparent  grid ID for the parent
c        icode               flag to select when to sum mass on parent grid
c                              0 = sum both before and after aggregation
c                              1 = sum before aggregation
c                              2 = sum after aggregation
c                             >2 = do not sum
c
c     Output arguments:
c        none
c
c     Subroutines Called:
c
c     Called by:
c        NESTING
c
c     Argument declarations:
c
      include 'camx.prm'
      include 'flags.inc'
      include 'rtracsrf.inc'
c
      integer inest
      integer iparent
      integer icode
c
c     Local variables
c
c
c-----Entry point
c
c  ---- call routine to sum the mass on the parent prior to feedback ---
c
      call before_massum(iparent,icode)
c
c  ---- call routine to send nest values to slice containing parent ---
c
      call node_send_feed(inest,iparent,deltax(1,inest),
     &                          deltay(inest),depth(iptr3d(inest)))
c
c  ---- call routine so that parent slice recieves and loads the data ---
c
      call node_get_feed(inest,iparent,deltax(1,iparent),
     &                      deltay(iparent),depth(iptr3d(iparent)))
c
c  ---- call routine to sum the mass on the parent after feedback ---
c
      call after_massum(iparent,icode)
c
c  ---- now feedback the deposition fields ---
c
      call node_send_feed_dp(inest,iparent,
     &                             deltax(1,inest),deltay(inest))
      call node_get_feed_dp(inest,iparent,
     &                             deltax(1,iparent),deltay(iparent))
c
c  ---- feedback the surface model fields ---
c
      if (lsrfmod) then
        call node_send_feed_smsol(inest,iparent,
     &                             deltax(1,inest),deltay(inest))
        call node_get_feed_smsol(inest,iparent,
     &                             deltax(1,iparent),deltay(iparent))
        call node_send_feed_smveg(inest,iparent,
     &                             deltax(1,inest),deltay(inest))
        call node_get_feed_smveg(inest,iparent,
     &                             deltax(1,iparent),deltay(iparent))
      endif
c
c======================== Probing Tool Begin ===========================
c
c  ---- do the feedback again for probing tools ----
c
      if( ltrace .OR. lddm .OR. lhddm .OR. lirr ) then
         call node_send_feed_pt(inest,iparent,deltax(1,inest),
     &                         deltay(inest),depth(iptr3d(inest)))
         call node_get_feed_pt(inest,iparent,deltax(1,iparent),
     &                     deltay(iparent),depth(iptr3d(iparent)))
         if( lptdepout ) then
           call node_send_feed_dry(inest,iparent,
     &                             deltax(1,inest),deltay(inest))
           call node_get_feed_dry(inest,iparent,
     &                             deltax(1,iparent),deltay(iparent))
           call node_send_feed_wet(inest,iparent,
     &                             deltax(1,inest),deltay(inest))
           call node_get_feed_wet(inest,iparent,
     &                             deltax(1,iparent),deltay(iparent))
         endif
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
           call node_send_feed_rtsol(inest,iparent,
     &                              deltax(1,inest),deltay(inest))
           call node_get_feed_rtsol(inest,iparent,
     &                              deltax(1,iparent),deltay(iparent))
           call node_send_feed_rtveg(inest,iparent,
     &                              deltax(1,inest),deltay(inest))
           call node_get_feed_rtveg(inest,iparent,
     &                              deltax(1,iparent),deltay(iparent))
         endif
      endif
c
c======================== Probing Tool End ===========================
c
      return
      end

      subroutine nodes_pass1(iarray,nbytes,mpi_type,itag,
     &                       iproc_id,worker_id           )
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine will do the actual passing of data from node zero
c        to one of the process node.  The array in the argument list
c        will be passed, using the number of bytes and the type specified.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        iarray              array containing the data - scalar 
c                            variables are of length 1
c        nbytes              the number of bytes to pass
c        mpi_type            the MPI code for the variable type
c        itag                the tag ID for this transfer
c        iproc_id            the process ID for this processor
c     Output:  
c
c    Called by:
c       BROADCAST_GRID_DIMENS
c    Subroutines called:
c       MPI_SEND
c       MPI_RECV
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c     
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: nbytes
c
      real    :: iarray(nbytes)
c
      integer :: mpi_type
      integer :: itag
      integer :: iproc_id
      integer :: worker_id
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ierr
      integer :: status(MPI_STATUS_SIZE)
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- process ID zero sends all of the messages,
c      to all of the other processes ---
c
      if (iproc_id .EQ. 0) then
         call MPI_SEND(iarray,nbytes,mpi_type,worker_id,itag,
     &                 MPI_COMM_WORLD,ierr                  )
c
c  --- if this is a compute process, allocate the data
c      structures and wait for the data to arrive ---
c
      elseif (worker_id .eq. iproc_id) then
         call MPI_RECV(iarray,nbytes,mpi_type,0,itag,
     &                 MPI_COMM_WORLD,status,ierr    )
      endif
      itag = itag+1
c
      end

      subroutine o3colprep
      use filunit
      use grid
      use o3colmap
      implicit none
c
c----CAMx v7.40 260801
c
c     O3COLPREP reads the header records of the ozone column file,
c     and any optional constant codes
c
c      Copyright Ramboll
c
c     Modifications:
c        06/13/03   Added optional snow cover, land-ocean, drought, 
c                   and roughness maps; only snow cover is time-varying
c        02/11/11   Moved snow panel to 2D met file, removed roughness,
c                   removed albedo panel (now determined in SRFPREP)
c        03/30/12   Removed haze and drought stress codes
c        07/07/16   Removed ocean mask option
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Routines called:
c        none
c
c     Called by:
c        STARTUP
c
      include 'camx.prm'
      include 'flags.inc'
c
      character*10  title, name
      character*80  action
      character*180 line
      real          rdozn(NOZN)
      integer       i, j, nhdro3col
c
      data name    /'OZONE COL '/
c
c-----Entry point
c
      read(io3col,*)
      nhdro3col = 1
c
c-----Read ozone class and check inputs
c
      action = 'looking for ozone column header'
      read(io3col,'(a10,5f10.0)',err=900) title,(rdozn(i),i=1,NOZN)
      nhdro3col = nhdro3col + 1
      if (title.ne.name) then
        write(iout,'(//,a)') 'ERROR in O3COLPREP:'
        write(iout,*) 'After reading line: ',nhdro3col
        write(iout,*) 'Expecting keyword: ',name
        write(iout,*) 'Read from ozone column file: ',title
        write(iout,'(/,2A)') 'This version uses a different format for ',
     &                             'what was the Albedo/Haze/Ozone file.'
        write(iout,'(/,2A,/,A)') 'For more information refer to the User Guide ',
     &                         'and Release Notes included with ',
     &                          'this CAMx distribution.'
        call camxerr()
      endif
      if (lchem) then
        do i = 1,NOZN
          if (rdozn(i).ne.ozcl(i)) then
            write(iout,'(//,a)') 'ERROR in O3COLPREP:'
            write(iout,*) 'After reading line: ',nhdro3col
            write(iout,*) 'Mismatch in ozone class'
            write(iout,*) 'Photolysis rates  file: ',(ozcl(j),j=1,NOZN)
            write(iout,*) 'Ozone column file: ',(rdozn(j),j=1,NOZN)
            write(iout,'(/,2A)') 'This version uses a different format for ',
     &                             'what was the Albedo/Haze/Ozone file.'
            write(iout,'(/,2A,/,A)') 'For more information refer to the User Guide ',
     &                         'and Release Notes included with ',
     &                          'this CAMx distribution.'
            call camxerr()
          endif
        enddo
      endif
c
c-----Read any optional records -- these should not exist
c
      action = 'looking for headers for any optional constant inputs'
      read(io3col,'(a)',err=900) line
      nhdro3col = nhdro3col + 1
      read(line,'(a10)') title
      if (title.eq.name) then
        backspace(io3col)
        nhdro3col = nhdro3col - 1
        return
      endif

      write(iout,'(//,a)') 'ERROR in O3COLPREP:'
      write(iout,*) 'After reading line: ',nhdro3col
      write(iout,*) 'Unrecognized keyword in O3MAP file!'
      write(iout,*) 'Acceptable keyword is: OZONE COL'
      write(iout,*) 'O3MAP file should not contain any optional fields'
      write(iout,*) 'Review your ozone column file.'
      write(iout,'(/,2A)') 'This version uses a different format for ',
     &                             'what was the Albedo/Haze/Ozone file.'
      write(iout,'(/,2A,/,A)') 'For more information refer to the User Guide ',
     &                         'and Release Notes included with ',
     &                          'this CAMx distribution.'
      call camxerr()
c
c --- Trap read errors
c
 900  write(iout,'(//,a,i4)') 'ERROR in O3COLPREP reading line ',
     &                                                     nhdro3col+1
      write(iout,'(2a)') 'While ', action
      write(iout,'(/,2A)') 'This version uses a different format for ',
     &                             'what was the Albedo/Haze/Ozone file.'
      write(iout,'(/,2A,/,A)') 'For more information refer to the User Guide ',
     &                         'and Release Notes included with ',
     &                          'this CAMx distribution.'
      call camxerr()
c
      end

      subroutine nodes_send_walls_back(numprocs,iproc_id,ircp,thistag)

c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numprocs  -- number of MPI slices
c        iproc_id  -- process ID for this slice
c        ircp      -- index into arrays for this receptor
c        thistag   -- current msgtag ID
c     Output:  
c
c    Called by:
c       MASTER_UPDATE
c    Subroutines called:
c       MPI_RECV
c       MPI_SEND
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
      integer :: ircp
      integer :: thistag
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real    :: tmprcp(MXTRSP)
      real    :: tmpvol
      integer :: i, n
      integer :: ierr
      integer :: status(MPI_STATUS_SIZE)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. lmpi ) return
c
      if( iproc_id .EQ. 0 ) then
         do i=1, numprocs
            call MPI_RECV(tmpvol,1,MPI_REAL,i,thistag,
     &                    MPI_COMM_WORLD,status,ierr    )
            volrcp(ircp) = volrcp(ircp) + tmpvol
         enddo
      else
c
c  --- node sends data back to master ---
c
         tmpvol = volrcp(ircp)
         call MPI_SEND(tmpvol,1,MPI_REAL,0,thistag,MPI_COMM_WORLD,ierr)
      endif
      thistag = thistag+1
c
      if( iproc_id .EQ. 0 ) then
         do i=1, numprocs
            call MPI_RECV(tmprcp,ntotsp,MPI_REAL,i,thistag,
     &                    MPI_COMM_WORLD,status,ierr    )
            do n=1,ntotsp
               conrcp(n,ircp) = conrcp(n,ircp) + tmprcp(n)
            enddo
         enddo
      else
c
c  --- node sends data back to master ---
c
         do n=1,ntotsp
            tmprcp(n) = conrcp(n,ircp)
         enddo
         call MPI_SEND(tmprcp,ntotsp,MPI_REAL,0,thistag,MPI_COMM_WORLD,ierr)
      endif
      thistag = thistag+1
c
c  --- everything has been accumulated, now calculate ratio ---
c
      if( iproc_id .EQ. 0 ) then
         if( volrcp(ircp) .NE. 0. ) then
            do n=1,ntotsp
               conrcp(n,ircp) = conrcp(n,ircp) / volrcp(ircp)
            enddo
            volrcp(ircp) = 0.
         endif
c
c  --- re-initialize slice data to zero ---
c
      else
         volrcp(ircp) = 0.
         do n=1,ntotsp
            conrcp(n,ircp) = 0.
         enddo
      endif
c
      return
      end

c**** NCF_RD_SA_ICFILE
c
      subroutine ncf_rd_sa_icfile()
      use grid
      use camxfld
      use filunit
      use tracer
      implicit none
c     
c----CAMx v7.40 260801
c
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Reads the source apportionment IC file and loads the values into
c     the tracer concentration array. This version is for NetCDF files.
c 
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c       Outputs:
c           
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include  files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'chmdat.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  this_var
      integer       data_start(4), data_count(4), this_tstep, ispc, itr
      integer       this_varid, date_time_tflag, date_time_etflag, ierr
      integer       n3d, n4d, igrd, ip, ic, ig, i, j, k
      real          convfac
c
      real,         allocatable,  dimension(:,:,:) ::  cinit
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = nlay(1)
c
c   --- get the timestep that encompasses this date/time ---
c
      action = 'Reading NetCDF SA initial conditions file.'
      write(idiag,'(/,A)') TRIM(action)
      call flush(idiag)
      this_tstep = ncf_get_tstep(ioric,action,begdate,begtim,
     &                 date_time_tflag,date_time_etflag,.FALSE.,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  ---- allocate the temp array ---
c
      allocate( cinit(ncol(1),nrow(1),nlay(1)) )
c  
c   --- Initialize all tracer concs to lower bounds first
c  
      do itr=1,ntotsp
        do k=1,nlay(1)
          do j = 1,nrow(1)
            do i = 1,ncol(1)-1
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
              ptconc(n4d) = BNDLPT
            enddo
          enddo
        enddo
      enddo
c
c  ---- loop over model species in the IC file ---
c
      do ispc=1,num_ioric
          this_var = spc_ioric(ispc)
          do itr=1,ntotsp
            if( spc_ioric(ispc) .NE. ptname(itr) ) cycle
c
c  --- find this species in the file ---- 
c
             ierr = nf_inq_varid(ioric, this_var, this_varid)
             if( ierr .NE. NF_NOERR) goto 7000
             ierr = nf_get_vara_real(ioric,this_varid,data_start,
     &                                               data_count,cinit)
             if( ierr .NE. NF_NOERR) goto 7001
c
c   --- echo that species was found in this file ---
c
             write(idiag,'(2A)') '   --- Found species: ',TRIM(ptname(itr))
             call flush(idiag)
c
c  ---- put concs into the global array at correct offset ---
c
             do k=1,nlay(1)
               do j = 2,nrow(1)-1
                 do i = 2,ncol(1)-1
                    n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
                    n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
                    ptconc(n4d) = AMAX1(ptconc(n4d),cinit(i,j,k))
                 enddo
               enddo
             enddo
          enddo
c
c  --- next species ---
c
      enddo
c
c  --- Interpolate coarse grid concentrations to all fine grids ----
c
      if( ngrid .GT. 1 ) then
          do ip = 1,ngrid
            do ic = 1,nchdrn(ip)
              ig = idchdrn(ic,ip)
              call intrpcnc(ntotsp,ncol(ip),nrow(ip),nlay(ip),i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                      ptconc(ipsa3d(ip)),ptconc(ipsa3d(ig)) )
            enddo
          enddo
      endif
c
c-----Convert from ppm to umol/m3
c
      do igrd = 1,ngrid
        do ispc = 1,num_ioric
          do itr=1,ntotsp
            if( spc_ioric(ispc) .NE. ptname(itr) ) cycle
            if( .NOT. lsagas(itr) ) cycle
            do k = 1,nlay(igrd)
              do j = 1,nrow(igrd)
                do i = 1,ncol(igrd)
                  n3d = i + ncol(igrd)*(j - 1) + ncol(igrd)*nrow(igrd)*(k - 1)
                  n4d = n3d + ncol(igrd)*nrow(igrd)*nlay(igrd)*(itr - 1)
                  convfac = densfac*273./tempk(iptr3d(igrd)-1+n3d)*
     &                          press(iptr3d(igrd)-1+n3d)/1013.
                  ptconc(ipsa3d(igrd)-1+n4d) = convfac*
     &                       AMAX1(BNDLPT, ptconc(ipsa3d(igrd)-1+n4d) )
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
c
      deallocate( cinit )
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 write(iout,'(//,A)') 'ERROR in NCF_RD_SA_ICFILE:'
      write(iout,'(A)') TRIM(action)
      write(iout,'(2A)') 'Cannot find SA IC species in file: ',TRIM(this_var)
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 write(iout,'(//,A)') 'ERROR in NCF_RD_SA_ICFILE:'
      write(iout,'(A)') TRIM(action)
      write(iout,'(2A)') 'Error reading gridded data from SA IC species ',
     &                                    TRIM(this_var),' in SA IC file.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine srfmod(date,dtime,dx,dy,cellat,cellon,swe,snowrat,
     &                  snowfrc,snowalb,zenith,ctrns,ldrk,pwr,tempk,
     &                  temp0,press,press0,wind,depth,nspc,fsurf,
     &                  lrdlai,lai,solmas,vegmas,reemis)
c
      use chmstry
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine determines fraction of deposited material that is
c     sorbed to surface elements.  Unsorbed fraction is available for
c     re-emission.  Sorbed fraction undergoes chemistry on soil/vegetation
c     using information from the chemistry parameters input file.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       date    I  model date (YYJJJ)
c       dtime   R  time step (hours)
c       dx,dy   R  cell size (m)
c       cellat  R  latitude (deg)
c       cellon  R  longitude (deg)
c       swe     R  snow cover water equivalent (m)
c       snowrat R  snow water accumulation rate (m/hr)
c       snowfrc R  snow cover fraction
c       snowalb R  snow albedo
c       zenith  R  zenith angle (deg)
c       ctrns   R  cloud transmissivity (unitless)
c       ldrk    L  darkness flag
c       pwr     R  rain water content (g/m3)
c       tempk   R  layer 1 temperature (K)
c       temp0   R  surface temperature (K)
c       press   R  layer 1 pressure (mb)
c       press0  R  surface pressure (mb)
c       wind    R  layer 1 wind (m/s)
c       depth   R  layer 1 thickness (m)
c       nspc    I  number of surface model species
c       fsurf   R  fraction LU
c       lrdlai  L  LAI inputs were read
c       lai     R  gridded LAI
c       solmas  R  Soil mass (mol/ha)
c       vegmas  R  Vegetation mass (mol/ha)
c     Outputs:
c       solmas  R  Soil mass (mol/ha)
c       vegmas  R  Vegetation mass (mol/ha)
c       reemis  R  Re-emission rate (mol/s)
c
c   Called by:
c       CHEMDRIV 
c
c   Routines called:
c       CALDATE
c       MICROMET
c       VE_GAS
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     04/24/13   ---cemery---    Original development (from RTRAC)
c     08/22/14   ---cemery---    Extended Zhang LU to surface model
c     08/25/14   ---cemery---    Added snow effects to surface model
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
      include 'deposit.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer date
      integer nspc
      real    dtime
      real    dx, dy
      real    cellat, cellon
      real    swe
      real    snowrat
      real    snowfrc
      real    snowalb
      real    zenith
      real    ctrns
      real    pwr
      real    fsurf(NLU)
      real    tempk, temp0
      real    press, press0
      real    wind
      real    depth
      real    lai
      real    solmas(nspc)
      real    vegmas(nspc)
      real    reemis(nspc)
      logical ldrk
      logical lrdlai
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   l
      integer   isp
      integer   m
      integer   mbin, latbin
      integer   isesn
      integer   idate, iyear, month, iday
      integer   nday(12)
      real      fshads
      real      fshadv
      real      fzenith
      real      deg2rad
      real      zenang
      real      totland
      real      smkrat
      real      smjrat
      real      effrates
      real      effratev
      real      delcons
      real      delconv
      real      eps
      real      rhoh2o
      real      volrat
      real      rain
      real      snow
      real      pbl,ustar,el,psih,wstar
      real      ve
      real      z0
      real      ssorb,slch
      real      solemis,tmpsol
      real      vegemis,tmpveg
      real      smas,vmas
      real      vemis(nspc)
      real      ref_lai, lai_ref_intpl, rlai, lai_f
      logical lstable
      logical lsnow
c
      data deg2rad /0.01745329/
      data eps /1.0e-20/
      data rhoh2o /1.e6/     ! water density (g/m3)
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      idate = date
      call caldate(idate)
      iyear = idate/10000
      month = (idate - 10000*iyear)/100
      if (mod(iyear,4).eq.0) nday(2)=29
      iday = idate - 100*(idate/100)

      lsnow = .false.
      if (swe.ge.0.01) lsnow = .true.  ! Snow effects occur when > 10 cm deep
c
c-----Prepare for LU-dependent surface roughness calculation
c
      mbin = month
      if (cellat.lt.0.) then
        mbin = mod(month+6,12)
        if (mbin.eq.0) mbin = 12
      endif
      latbin = 1
      if (abs(cellat).gt.20.) then
        latbin = 2
      elseif (abs(cellat).gt.35.) then
        latbin = 3
      elseif (abs(cellat).gt.50.) then
        latbin = 4
      elseif (abs(cellat).gt.75.) then
        latbin = 5
      endif
      if ((cellat.gt.50. .and. cellat.lt.75.) .and.
     &    (cellon.gt.-15. .and. cellon.lt.15.)) latbin = 3
      isesn = iseason(latbin,mbin)
c
c-----Use input snow cover to set season, if specified
c
      if (swe.ge.0.001) isesn = 4   ! Snow cover check > 1 cm
c
c-----Determine cell-average relative LAI
c
      if (lrdlai .and. NLU.eq.NLUZ03) then
        ref_lai = 0.
        do m = 1,NLU
          lai_ref_intpl = lai_ref(m,mbin) +
     &                    float(min(nday(mbin),iday))/float(nday(mbin))*
     &                    (lai_ref(m,mbin+1) - lai_ref(m,mbin))
          ref_lai = ref_lai + fsurf(m)*lai_ref_intpl
        enddo
        rlai = lai/(ref_lai + 1.e-10)
      endif
c
c-----Loop over land use; surface roughness for water is dependent on
c     wind speed
c
      do l = 1,nspc
        vemis(l) = 0.
      enddo
      do 10 m = 1,NLU
        if (fsurf(m).lt.0.01) goto 10
c
c-----Set surface roughness for Wesely (1989) scheme
c
        if (NLU.eq.NLUW89) then
          z0 = z0lu(m,isesn)
          if (m.eq.7) z0 = amax1(z0,2.0e-6*wind**2.5)
c
c-----Set surface roughness and LAI for Zhang (2003) scheme
c
        else
          lai_f = lai_ref(m,mbin) +
     &            float(min(nday(mbin),iday))/float(nday(mbin))*
     &            (lai_ref(m,mbin+1) - lai_ref(m,mbin))
          if (lrdlai) then
            lai_f = lai_f*rlai
            lai_f = amin1(lai_ref(m,15),lai_f)
            lai_f = amax1(lai_ref(m,14),lai_f)
          endif
          if (m.eq.1 .or. m.eq.3) then
            z0 = 2.0e-6*wind**2.5
          else
            if (z02(m).gt.z01(m)) then
              z0 = z01(m) + (lai_f - lai_ref(m,14))/
     &                      (lai_ref(m,15) - lai_ref(m,14))*
     &                      (z02(m) - z01(m))
            else
              z0 = z01(m)
            endif
          endif
        endif
c
c-----Get surface layer micrometeorological parameters for this cell and
c     landuse type
c
        call micromet(tempk,temp0,press,press0,depth/2.,wind,z0,pbl,
     &                ustar,el,psih,wstar,lstable)
c
c-----Loop over species, and calculate re-emission velocity for this cell,
c     landuse, and current species.  Aggregated into cell-average re-emission
c     velocity.
c
        do l = 1,nspc
          isp = idsmsp(l)
          if ((NLU.eq.NLUW89 .and. m.eq.7) .or. (NLU.eq.NLUZ03 .and.
     &                                    (m.eq.1 .or. m.eq.3)))then
            ve = 0.
          else
            call ve_gas(z0,depth/2.,psih,ustar,diffrat(isp),ve)
          endif
          vemis(l) = vemis(l) + ve*fsurf(m)
        enddo
 10   continue
c
c-----Calculate fraction of sorbed and un-sorbed material:
c     Un-sorbed fraction is available for re-emission
c     Sorbed fraction remains on surface and undergoes chemistry, leaching
c     and vegetative penetration
c
      do l = 1,nspc
        ssorb = smssrb(l)
        if (lsnow) ssorb = smisrb(l)
        solemis = (vemis(l)/depth)*solmas(l)/(1. + ssorb) ! (mol/ha/s)
        vegemis = (vemis(l)/depth)*vegmas(l)/(1. + smvsrb(l)) ! (mol/ha/s)
        tmpsol  = MAX(eps,solmas(l) - solemis*dtime*3600.) ! (mol/ha)
        tmpveg  = MAX(eps,vegmas(l) - vegemis*dtime*3600.) ! (mol/ha)
        solemis = (solmas(l) - tmpsol)/(dtime*3600.)          ! (mol/ha/s)
        vegemis = (vegmas(l) - tmpveg)/(dtime*3600.)          ! (mol/ha/s)
        solmas(l) = tmpsol                                    ! (mol/ha)
        vegmas(l) = tmpveg                                    ! (mol/ha)
        reemis(l) = (solemis + vegemis)*dx*dy*1.e-4           ! (mol/s)
      enddo
c
c --- Calculate photolysis factors (shade, zenith, clouds, snow)
c
      zenang = deg2rad*zenith
      fshads = 0.0
      fshadv = 0.0
      fzenith = 0.0
      totland = 0.0

      if (.not.ldrk) then
        fshadv = 0.5
        do m = 1,NLU
          if (NLU.eq.NLUW89) then
            fshads = fshads + fsoil(m)*fsurf(m)
          else
            fshads = fshads + fsoilz(m)*fsurf(m)
          endif
          totland = totland + fsurf(m)
        enddo
        fshads = fshads/totland
        if (lsnow) then
          fshads = fshads + snowfrc*snowalb
          fshadv = fshadv + snowfrc*snowalb
        endif
        fzenith = COS(zenang)
      endif
c
c-----Chemical decay of precursor species to product species
c
      do l = 1,nsmrxn
        isp = idsmpre(l)
        smkrat = smskrat(l)
        smjrat = smsjrat(l)
        if (lsnow) then
          smkrat = smikrat(l)
          smjrat = smijrat(l)
        endif
        effrates = smkrat + smjrat*fshads*fzenith*ctrns
        effratev = smvkrat(l) + smvjrat(l)*fshadv*fzenith*ctrns
        delcons = solmas(isp)*(1. - EXP(-effrates*dtime*60.))
        delconv = vegmas(isp)*(1. - EXP(-effratev*dtime*60.))
        smas = MAX(eps,solmas(isp) - delcons)
        vmas = MAX(eps,vegmas(isp) - delconv)
        delcons = solmas(isp) - smas
        delconv = vegmas(isp) - vmas
        solmas(isp) = smas
        vegmas(isp) = vmas
        if (idsmprd(l).ne.0) then
          isp = idsmprd(l)
          solmas(isp) = solmas(isp) + delcons
          vegmas(isp) = vegmas(isp) + delconv
        endif
      enddo
c
c --- Apply decay rates for leaching, snow melt, and plant penetration
c     Accelerate if raining (1 mm/hr = e-folding in 1 hr)
c     Accelerate if snowing (1 cm/hr = e-folding in 1 day)
c
      rain = (pwr/rhoh2o/1.0e-7)**1.27       !rain rate (mm/hr)
      if (rain.lt.0.2) rain = 0.
      rain = rain/60.                        !mm/hr -> 1/min
      snow = 0.
      if (snowrat.gt.0.) 
     &  snow = 100.*10.*snowrat/(24.*60.)    !m/hr SWE -> cm/hr depth -> 1/min
      do l = 1,nspc
        slch = smlch(l)
        if (lsnow) then
          slch = 0.
          if (temp0.gt.272.) slch = smmlt(l)
        endif
        delcons = EXP(-(slch + rain + snow)*dtime*60.)
        delconv = EXP(-(smpen(l) + rain + snow)*dtime*60.)
        solmas(l) = MAX(eps,solmas(l)*delcons)
        vegmas(l) = MAX(eps,vegmas(l)*delconv)
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine wrtirr(iendat,endtim)
      use filunit
      use grid
      use camxfld
      use chmstry
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     This routine writes to the output file for the Integrated Reaction
c     Rates (IRR) data for the Process Analysis algorithm.  Each record 
c     contains the all of the data for once cell and species for the 
c     specified time period.
c     This routine also calls the subroutines that will write the 
c     gridded Chemical Process Analysis data.
c
c      Copyright Ramboll
c
c     Modifications:
c        8/25/06    CPA output files now all UAM format, one file per grid
c
c     Input arguments:
c        endtim     ending time for this period
c        iendat     ending date for this period
c
c     Subroutines Called:
c       WRTCGCPA
c       WRTFGCPA
c
c
c     Called by:
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
c
c-----Argument declarations
c
      integer iendat
      real    endtim 
c
c-----Local variables
c
      character*200 action
      integer       num_dims
      logical       loutspec(MXSPEC+MXTRSP)
c
c-----Entry point
c
c  --- loop over the number of sub-domain cells ---
c
      do icel=1,npa_cels
c
c  --- write out the record for this cell ---
c
           write(irr_unit,ERR=7000) iendat, endtim, 
     &              ipadom(icel), ipanst(icel),
     &                  ipax(icel), ipay(icel), ipaz(icel),
     &                                  (cirr(icel,i),i=1,nirrrxn)
c
c  --- next subdomain cell ---
c
      enddo
c
c  --- call routine to write the gridded CPA arrays ---
c
      if( lsfcfl ) then
         do igrd = 1,ngrid        
            if( .NOT. lcdfout ) then
                call wrtcpa(igrd,iendat,endtim,igrd,ncol(igrd),nrow(igrd),
     &                           nlay(igrd),ntotsp,ptconc(ipsa3d(igrd)))
            else
                nlayav = nlay(igrd)
                num_dims = 4
                if( .NOT. l3davg(igrd) ) then
                    nlayav = 1
                    num_dims = 3
                endif
                write(action,'(A,I2)') 'Writing CPA file for grid: ',igrd
                call ncf_wrt_data_tstep(action,iowsfc(igrd),ntotsp)
                loutspec = .TRUE.
                call ncf_wrt_data_species(action,iowsfc(igrd),igrd,num_dims,
     &               ncol(igrd),nrow(igrd),nlay(igrd),nlay(igrd),nlayav,
     &                 ntotsp,ptname,loutspec,ptconc(ipsa3d(igrd)),
     &                            height(iptr3d(igrd)))
            endif
         enddo
      endif
      goto 9999
c
c----Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in WRTIRR:'
      write(iout,'(1X,2A)',ERR=9999) 'Writing data to the output ',
     &                         'Integrated Reaction Rates (.irr) file.'
      write(iout,'(10X,A,I8.5,5X,A,F8.1)') 
     &      'Date: ',iendat,'Time: ',endtim
      call camxerr()
c
 9999 continue
      return
      end

c**** NCF_RDTCDDM.F
c
      subroutine ncf_rdtcddm(toptim,topdate)
      use filunit
      use grid
      use chmstry
      use camxfld
      use camxcom
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of top concentrations for the DDM
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  This
c   version is for the NetCDF files.
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c       Inputs:
c        toptim            model simulation time (HHMM)
c        topdate           model simulation date (YYJJJ)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     11/28/19   --gwilson--       Created
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer topdate
      real    toptim
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer ncf_chkfile
      integer ncf_get_tstep
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c----------------------------------------------------------------------
c
      character*200 action
      character*10  tcname, this_var, cspec, name_in
      integer       data_start(3), data_count(3), this_varid, i, j
      integer       nedge, ioff, ierr, this_tstep, ispc, n3d, iptr
      integer       itcdate_time_tflag, itcdate_time_etflag, ip, ic
      integer       ig, jerr, iddm, itmp
      logical       lexist, luse
c
      real, allocatable, dimension(:,:) :: tpconc
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
        ioff = IDXBTP
      else
        nedge = 1
        ioff = 1
      endif
c
c  --- open the TC ---
c
      tcname = 'AIRQUALITY'
      inquire(file=tcfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening DDM Top Conocentrations file.'
      ierr = ncf_chkfile(iortc,tcfil,action,tcname)
      if( ierr .NE. ISUCES ) then
         jerr = nf_open(tcfil,NF_NOWRITE,iortc)
         if( jerr .NE. NF_NOERR ) goto 7001
      else
         return
      endif
c
c --- get the type of file to make sure it is a IC file ---
c
      this_var = 'CAMx_NAME'
      tcname = 'TOPCONC   '
      ierr = nf_get_att_text(iortc, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iortc, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7003
       endif
      if( name_in(:7) .NE. tcname(:7) ) goto 7002
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(iortc,action,1,.TRUE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iortc,action,topdate,toptim,topdate,toptim,.FALSE.)
c
c  --- call routine to zero out the array ---
c
      allocate( tpconc(ncol(1),nrow(1)) )
c
c  --- set the parameters for how to read the this data ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
c
c  --- get the timestep for the first hour ---
c
      this_tstep = ncf_get_tstep(iortc,action,topdate,toptim,
     &          itcdate_time_tflag,itcdate_time_etflag,.FALSE.,.TRUE.)
      data_start(3) = this_tstep
      data_count(3) = 1
c
c  --- read the concentrations for each species ---
c
      do ispc=1,nspec
         this_var = spname(ispc)
         cspec = spname(ispc)
         ierr = nf_inq_varid(ioric,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) cycle
         ierr = nf_get_vara_real(iortc,this_varid,data_start,data_count,tpconc)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_RDTCDDM:'
           write(iout,*)'Cannot read top concenntration data for species: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c  --- find this species in the modeled species list ---
c
         do iddm=1,nbcddm
           luse = .FALSE.
           if( bcddmsp(iddm) .EQ. cspec ) luse = .TRUE. 
           if( bcddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE. 
           if( bcddmsp(iddm) .EQ. NAMVOC 
     &                               .AND. lvocsp(ispc) ) luse = .TRUE. 
           if( bcddmsp(iddm) .EQ. NAMNOX 
     &                               .AND. lnoxsp(ispc) ) luse = .TRUE. 
           if( bcddmsp(iddm) .EQ. NAMHRV 
     &                               .AND. lhrvoc(ispc) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
           if( luse ) then
              iptr = iptddm(ispc) + (iddm-1)*nedge + nicddm + ioff - 1
              do j=1,nrow(1)
              do i=1,ncol(1)
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(iptr - 1)
c
c  --- load the top concentrations ---
c
                 if( tpconc(i,j) .GT. bdnl(ispc) ) then
                     pttop(n3d) = tpconc(i,j)
                 else
                     pttop(n3d) = 0.0
                 endif
              enddo
              enddo
c
c  --- interpolate top con sens to all nested grids
c
              if( ngrid .GT. 1 ) then
                 do ip = 1,ngrid
                 do ic = 1,nchdrn(ip)
                    ig = idchdrn(ic,ip)
                    call interp2d(ncol(ip),nrow(ip),1,
     &                   i1(ig),j1(ig),nmesh(ig),ncol(ig),nrow(ig),
     &                   pttop( ipsa2d(ip) + ncol(ip)*nrow(ip)*(iptr - 1) ),
     &                   pttop( ipsa2d(ig) + ncol(ig)*nrow(ig)*(iptr - 1) ))
                 enddo
                 enddo
              endif
           endif
c
c  --- check the next BC DDM species ---
c
         enddo
c
c  --- read next species worth of data ---
c
      enddo
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in NCF_RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM does not exist: ',TRIM(tcfil)
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDTCDDM:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Could not open file: ',
     &                                   tcfil(:istrln(tcfil))
      write(iout,'(3A)') 'If this is a NCF file, check that its',
     &                   ' format is consistent with the NCF library',
     &                   ' used to build CAMx.'
      write(iout,'(2A)') 'The CAMx makefile supports netCDF3-Classic,',
     &                   ' and netCDF4 compressed or uncompressed.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM is not labelled ',TRIM(tcname)
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDTCDDM:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

c*** LOADDM
c
      subroutine loaddm(filflg,numcol,numrow,numlay,nddm,grsens,
     &                  icl,jcl,kcl,nsen,nspc,ngas,nrad,nhet,sens,
     &                  convfac)
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine loads the sensitivies which are stored in a
c     4-D array from/into a 2-D array in conclusion/preperation 
c     of the DDM chemistry routine.  The 2-D array contains the 
c     family of sensitivities for one cell and all modeled species.
c     The flag "filflg" determines wether the values in the 4-D
c     array are loaded into the 2-D array or vice-versa.  Sensitivities
c     are converted from umol/m3 to ppm for chemistry and back.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c       filflg  L  flag for determining which direction to fill
c                  .TRUE.  = put 2-D values into 4-D gridded array
c                  .FALSE. = put 4-D values into 2-D array
c       numcol  I  number of cells in X direction
c       numrow  I  number of cells in Y direction
c       numlay  I  number of layers 
c       nddm    I  number of total DDM species
c       grsens  R  4-D array of DDM sensitivities
c       icl     I  the X grid location of current cell
c       jcl     I  the Y grid location of current cell
c       kcl     I  the vertical grid location of current layer
c       nsen    I  number of DDM families
c       nspc    I  number of modeled species
c       ngas    I  number of gaseous species
c       nrad    I  number of radical species
c       nhet    I  number of heterogeneous rxns
c       sens    R  2-D array for this cell and species
c       convfac R  conversion from ppm to umol/m3
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     07/16/07   --bkoo--      Added radical array mapping
c     09/21/13   --bkoo--      Added PM array mapping
c     01/03/14   --bkoo--      Added organic nitrate hydrolysis rate sensitivities
c     02/29/16   --bkoo--      Revised SENS array for hetero N2O5 + HCL rxn
c     07/20/16   --bkoo--      Revised SENS array for hetero INTR hydrolysis
c     09/02/16   --bkoo--      Set SENS array size with # of het rxns
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      logical filflg
      integer numcol
      integer numrow
      integer numlay
      integer nddm
      real    grsens(numcol,numrow,numlay,nddm)
      integer icl
      integer jcl
      integer kcl
      integer nsen
      integer nspc
      integer nrad
      real    sens(nsen,nspc+nhet)
      real    convfac
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   isen, ispc, iddm
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- task 1: load 4-D array
c
      if( filflg ) then
c
c  --- loop over the modeled species ---
c
        do ispc=nrad+1,ngas
c
c  --- loop over the number of DDM families ---
c
          do isen=1,nsen
c
c  --- calculate the index into the DDM species list ---
c
            iddm = iptddm(ispc)+isen-1
            grsens(icl,jcl,kcl,iddm) = sens(isen,ispc)*convfac
c
c  --- next family ---
c
          enddo
c
c  --- next species ---
c
        enddo
c
c  --- radical species ---
c
        do ispc=1,nrad
          do isen=1,nsen
            iddm = iptddm(ispc)+isen-1
            grsens(icl,jcl,kcl,iddm) = sens(isen,ispc)
          enddo
        enddo
c
c  --- particulate species & k_hetero -> no need to load these sensitivities back
c
c
c  --- task 2: load 2-D array
c
      else
c
c  --- loop over the modeled species ---
c
        do ispc=nrad+1,ngas
c
c  --- loop over the number of DDM families ---
c
          do isen=1,nsen
c
c  --- calculate the index into the DDM species list ---
c
            iddm = iptddm(ispc)+isen-1
            sens(isen,ispc) = grsens(icl,jcl,kcl,iddm)/convfac
c
c  --- next family ---
c
          enddo
c
c  --- next species ---
c
        enddo
c
c  --- radical species ---
c
        do ispc=1,nrad
          do isen=1,nsen
            iddm = iptddm(ispc)+isen-1
            sens(isen,ispc) = grsens(icl,jcl,kcl,iddm)
          enddo
        enddo
c
c  --- particulate species ---
c
        do ispc=ngas+1,nspc
          do isen=1,nsen
            iddm = iptddm(ispc)+isen-1
            sens(isen,ispc) = grsens(icl,jcl,kcl,iddm)
          enddo
        enddo
c
c  --- k_hetero ---
c
        do ispc=nspc+1,nspc+nhet
          do isen=1,nsen
            sens(isen,ispc) = 0.0 ! reset to zero
          enddo
        enddo
c
c  --- done ---
c
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      INTEGER FUNCTION HLINDEX (NAME, N, NLIST)

C***********************************************************************
C
C  FUNCTION:
C
C    Searches for NAME in list NLIST and returns the subscript
C    (1...N) at which it is found, or returns 0 when NAME not
C    found in NLIST
C
C  PRECONDITIONS REQUIRED:  none
C
C  SUBROUTINES AND FUNCTIONS CALLED:  none
C
C  REVISION HISTORY:
C
C    5/88   Modified for ROMNET
C    9/94   Modified for Models-3 by CJC
C
C***********************************************************************

      IMPLICIT NONE
 
C.......   Arguments and their descriptions:

      CHARACTER*(*) NAME        !  Character string being searched for
      INTEGER       N           !  Length of array to be searched
      CHARACTER*(*) NLIST(*)    !  array to be searched

C.......   Local variable:

      INTEGER       I   !  loop counter

C.....................................................................
C.......   begin body of INDEX1()

      DO 100 I = 1, N

          IF ( NAME .EQ. NLIST( I ) ) THEN    ! Found NAME in NLIST
              HLINDEX = I
              RETURN
          ENDIF

100   CONTINUE

      HLINDEX = 0        !  not found
      RETURN

      END

      subroutine chemrxn(igrd,iproc_id)
      use filunit
      use grid
      use grid_nodes
      use chmstry
      use camxfld
      use camxcom
      use procan
c
      use master_mod
      use node_mod
c
c----CAMx v7.40 260801
c
c     CHEMRXN passes arrays from common blocks to CHEMDRIV
c
c      Copyright Ramboll
c            
c     Modifications:  
c        10/13/17 -bkoo-     Added aerosol pH to CHEMDRIV call (APH)
c        10/16/17 -bkoo-     Added time-weighted NO2 photolysis rate to CHEMDRIV call (AJNO2)
c
c     Input arguments:
c        igrd                grid index
c
c     Output arguments:
c        none
c
c     Routines called:
c        CHEMDRIV
c        MASSUM
c
c     Called by:
c        CAMx
c        NESTING
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----Entry point
c
      call massum(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &           igrd,nspec,ncol(igrd),nrow(igrd),nlay(igrd),
     &           deltax(1,igrd),deltay(igrd),depth(iptr3d(igrd)),
     &           mapscl(iptr2d(igrd)),conc(iptr4d(igrd)),xmstmp(1,igrd))
c
c  --- call routine to do the chemistry ---
c
      if( lchem ) then
        if( iproc_id .LE. 1 ) then
          write(*,'(a20,$)') 'chemdriv ......'
        endif
        write(iout,'(a20,$)') 'chemdriv ......'
        call flush(6)
        call chemdriv(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,igrd,
     &                ncol(igrd),nrow(igrd),nlay(igrd),
     &                deltat(igrd),itzon,idfin(iptr2d(igrd)),
     &                deltax(1,igrd),deltay(igrd),cldtrns(iptr3d(igrd)),
     &                water(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &                tsurf(iptr2d(igrd)),press(iptr3d(igrd)),
     &                height(iptr3d(igrd)),windu(iptr3d(igrd)),
     &                windv(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &                pwr(iptr3d(igrd)),cph(iptr3d(igrd)),
     &                aph(iptr3d(igrd)),ajno2(iptr3d(igrd)),
     &                cigwtr(iptr3d(igrd)),
     &                conc(iptr4d(igrd)),cellat(iptr2d(igrd)),
     &                cellon(iptr2d(igrd)),snow(iptr2d(igrd)),
     &                snowrat(iptr2d(igrd)),snowfrc(iptr2d(igrd)),
     &                snowalb(iptr2d(igrd)),topo(iptr2d(igrd)),
     &                fsurf(iptrlu(igrd)),albedo(iptr2d(igrd)),
     &                lrdlai(igrd),lai(iptr2d(igrd)),
     &                ldark(iptr2d(igrd)),solmas(iptrsm(igrd)),
     &                vegmas(iptrsm(igrd)),reemis(iptrsm(igrd)),
     &                l3davg(igrd),iptr2d(igrd),ipsa3d(igrd),
     &                ipacl_3d(iptr3d_full(igrd)),iproc_id)
        if( iproc_id .LE. 1 ) then
           write(*,'(a)') '   Done'
        endif
        write(iout,'(a)') '   Done'
        call flush(6)
        call flush(iout)
      endif
c
      call massum(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &            igrd,nspec,ncol(igrd),nrow(igrd),nlay(igrd),
     &            deltax(1,igrd),deltay(igrd),depth(iptr3d(igrd)),
     &            mapscl(iptr2d(igrd)),conc(iptr4d(igrd)),xmass(1,igrd))
c
      do l = 1,nspec 
        xmschem(l,igrd) = xmschem(l,igrd) + xmass(l,igrd) - 
     &                    xmstmp(l,igrd) 
      enddo
c
      return
      end

c***** RDARDDM.F
c
      subroutine rdarddm(igrid,ndate,ttime,nox,noy,nlay_ems,nddmspc,emisddm)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the DDM process
c   and fills the approproate arrays.  The emissions file for one grid
c   but each emissions groups is read.
c    Argument descriptions:
c     Outputs:
c       emisddm   R    array of emissions for DDM speices
c     Inputs:
c       igrid     I    grid number
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       nox       I    number of columns in grid
c       noy       I    number of rows in grid
c       nlay_ems  I    number of layers in emissions files
c       nddmspc   I    number of DDM species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c       10/24/01  Removed BSWAP and converted integer strings to character*4
c       07/19/02  Added seperate source area map for each grids.
c       05/01/03  Time span of emissions must now match emiss update interval
c       07/16/07 -bkoo-     Added HRVOC
c       03/01/16 -gwilson-  Added partial source area map
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      integer ndate
      real    ttime
      integer nox
      integer noy
      integer nlay_ems
      integer nddmspc
      real    emisddm(nox,noy,nlay_ems,nddmspc)
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  cname
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, igroup, idx, iseg
      integer       i, j, nedge, iptr, ispc, iddm, izone, nlays_in
      integer       imap, imod, ipart, idxfile, buffer_offset
      integer       nx, ny
      real          emstmp, bgtim, edtim, orgx, orgy, utmx, utmy
      real          dx, dy
      logical       lfound, luse, lpass
c
      real emsgrd(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c   --- initialize emissions to zero ---
c
      emisddm = 0.
c
c  --- if not doing emissions groups, just return here ---
c
      if( nemddm .EQ. 0 ) goto 9999
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c   --- loop over all of the groups ----
c
      do 10 igroup=1,ngroup
       do 11 idxfile=1,num_iortem(igrid,igroup)
c
c   --- skip if filename not supplied ---
c
        if( is_netcdf_iortem(igrid,igroup,idxfile) .OR. 
     &      .NOT. ltemfl(igrid,igroup,idxfile) .OR. .NOT. larsrc ) cycle
c
c   --- set the unit number for surface emissions file ---
c
        iounit = iortem(igrid,igroup,idxfile)
        fname = temfil(igrid,igroup,idxfile)
        buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
c
c   --- get the number of layers for this file ---
c
        rewind(iounit)
        read(iounit)
        read(iounit) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nlays_in
        read(iounit)
        read(iounit)
c
c   --- read the date and time, again ---
c
        lfound = .FALSE.
        lpass = .FALSE.
  111   continue
        read(iounit,END=222) ibgdat, bgtim, iendat, edtim
        if(NINT(edtim) .EQ. 0) then
          edtim = 24.
          iendat = ibgdat
        endif
        ichktm1 = NINT( 1000*(bgtim) )
        if( le1day ) then
           ichktm2 = NINT( 1000*(edtim) )
        else
           ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
        endif

        if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
        ichkems = NINT( 1000*(dtems/60.) )
        if( (ichktm2 - ichktm1) .NE. ichkems ) then
            write(iout,'(//,a)')'ERROR in READARDDM:'
            write(iout,*) 'Time interval in surface emissions file does'
            write(iout,*)  ' not match emissions update time interval.'
            write(iout,*) '   Beginning Date/Time (Hour): ',ibgdat,bgtim
            write(iout,*) '   Ending Date/Time    (Hour): ',iendat,edtim
            write(iout,*) '   Emiss Input interval(Hour): ',dtems/60.
            call camxerr()
        endif
        bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
        edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
         do 20 ispc=1,nspcem(igrid,igroup,idxfile)
             read(iounit,ERR=7000) iseg, (iname(i),i=1,10), 
     &            ((emsgrd(i,j),i=1,nox-2*buffer_offset),j=1,noy-2*buffer_offset)
             write(cname,'(10A1)') iname
             do k=1,nlays_in
                do i=1,nox
                   emsgrd(i,1) = emsgrd(i,1)
                   emsgrd(i,noy) = emsgrd(i,noy-2*buffer_offset)
                enddo
                do j=1,noy
                   emsgrd(1,j) = emsgrd(1,j)
                   emsgrd(nox,j) = emsgrd(nox-2*buffer_offset,j)
                enddo
             enddo
c
c   --- if date and time does not match this hour, skip this record ---
c
             if( le1day ) then
                 if( bgtim .NE. ttime ) goto 20
             else
                 if( ndate .NE. ibgdat .OR. bgtim .NE. ttime ) goto 20
             endif
             lfound  = .TRUE.
c
c   --- if the species is a not modelled or not used for DDM ----
c
             idx = idxems(igrid,igroup,idxfile,ispc)
             if( idx .LE. 0 ) goto 20
c
c  --- find this species in the modeled species list ---
c
             luse = .FALSE.
             do imod=1,nspec
                if( cname .EQ. spname(imod) ) then
                   do iddm=1,nemddm
                      luse = .FALSE.
                      if( emddmsp(iddm) .EQ. cname ) luse = .TRUE.
                      if( emddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE.
                      if( emddmsp(iddm) .EQ. NAMVOC
     &                               .AND. lvocsp(imod) ) luse = .TRUE.
                      if( emddmsp(iddm) .EQ. NAMNOX
     &                               .AND. lnoxsp(imod) ) luse = .TRUE.
                     if( emddmsp(iddm) .EQ. NAMHRV
     &                               .AND. lhrvoc(imod) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
                      if( luse ) then
                         do 30 j=2,noy-1
                            do 40 i=2,nox-1
                               imap = igrmap(0,1,igrid,i,j)
                               if( imap .LE. 0 .OR. imap .GT. nregin )
     &                                                          goto 40
c
c  --- convert to emissions time and put into array ---
c
                               emstmp = emsgrd(i,j)/(60.*dtems)
                               iptr = iptddm(imod) + nicddm + ndepddm +
     &                              nbcddm*nedge + (iddm-1)*ngroup*nregin +
     &                                               (imap-1)*ngroup + igroup - 1
                               emisddm(i,j,1,iptr) = emisddm(i,j,1,iptr) + emstmp
c
c  --- next cell ---
c
   40                       continue
   30                    continue
                      endif
c
c  --- next DDM emssions species ---
c
                   enddo
c
c  --- next modeled species ---
c
                endif
             enddo
c
c   --- next species ---
c
  20        continue
c
c   --- if the correct hour has not been found, 
c       go back and read some more else read next file ---
c
            if( .NOT. lfound ) then
               goto 111
            else
               do i=1,nspcem(igrid,igroup,idxfile) + 1
                   backspace(iounit)
               enddo
               goto 11
            endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222       continue
            if( le1day ) then
                rewind(iounit)
                read(iounit)
                read(iounit)
                read(iounit)
                read(iounit)
                if( lpass ) goto 7001
                if( .NOT. lpass ) lpass = .TRUE.
                goto 111
               else
                goto 7001
            endif
c
c   --- next file in this group/grid ---
c
  11     continue
c
c  --- get the next group ---
c
  10   continue
       goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in RDARDDM:' 
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 'ERROR: Reading emissions ',
     &                  'after hour ',ibgdat, bgtim,' in file: ',fname
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in RDARDDM:' 
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 
     &              'ERROR: Premature end-of-file',
     &              ' in emissions file after hour ',ibgdat, bgtim,
     &                                               ' in file: ',fname
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine banner( )
c
c----CAMx v7.40 260801
c
c     BANNER writes to the screen the license blurb for CAMx.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        none
c
c     Output arguments:
c        iounit
c
c     Routines called:
c        none
c
c     Called by:
c         MAIN
c
c-----Entry point
c
      write(*,'(/,1X,2A)') 'By running CAMx you accept the terms ',
     &                                           'of the CAMx LICENSE.'
      write(*,'(1X,2A)') 'The CAMx LICENSE is included with the ',
     &                     'CAMx source code and also available here:'
      write(*,'(2X,A,//)') 'http://www.camx.com/Files/LICENSE.txt'
      call system("sleep 5")
 
      return
      end

      subroutine startup(version,inptim,inpdate,emstim,emsdate,
     &                   ozntim,ozndate,bndtim,bnddate,toptim,topdate,
     &                   wrttim,wrtdate,endtim,enddate,numprocs)
      use filunit
      use grid
      use chmstry
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use ptemiss
      use pigsty
      use procan
      use tracer
      use rtracchm
     
      implicit none
c
c----CAMx v7.40 260801
c
c     STARTUP is the main initialization and setup routine for CAMx.
c     It performs the following tasks:
c        - initializes certain vector/array and scalar variables 
c        - reads and checks the user input file
c        - sets model simulation clock
c        - opens all I/O files
c        - reads all time-invariant files and look-up tables
c        - reads/writes headers from/to UAM-formatted I/O files
c        - calculates grid parameters
c        - initializes the PiG submodel
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        1/29/99   Added diagnostic printout of layer nesting, and error
c                  messages if layer nesting calculation is invalid
c        2/12/99   Removed assignment of negative longitude for xorg
c        4/26/99   Added Piecewise Parabolic Method for horizontal advection
c        5/24/99   Fixed bug in filling idfin array
c        10/20/00  Added CAMx version as first record on control file
c        11/06/01  Added Y2K flag; conversion of simulation date to Julian 
c                   now done immediately after reading from control file
c        1/21/02   Added RTRAC tech type to OSAT
c        1/25/02   Revised input I/O frequencies and max time step to minutes,
c                  and improved checks on values
c        7/5/02    Added code to handle new IRON-PiG option
c        1/10/03   Added prep of deposition output files 
c        03/21/03  Removed the OSAT technology type OPPAT
c        05/01/03  Added snow cover and other options to AHO file
c        11/10/03  Added sampling grid setup for RTRAC+IRONPIG
c        10/06/04  Restructured for namelist input
c        10/12/04  Added read of water vapor and vertical diffusivity as
c                  time-interpolated variables
c        10/14/04  Special checks added for mechanism 10
c        7/29/05   Added sampling grid setup for IRONPIG for average concs
c        12/15/08  Added code to handle averaging of radicals
c        03/15/09  Added code for deposition output for tracers
c        07/16/07 -bkoo-     Revised for HDDM
c        07/16/08 -bkoo-     Added code to print/check DDM turn-off flags
c        11/04/09  Removed setting nest grid boundary winds from parent
c        11/08/09  Removed ptconc from argument to rdinstsa
c        11/08/09  Fixed bug in checking parameter against nrad
c        01/04/11  Revised for new met input format
c        04/02/12  Removed drought stress and snow flag; AHO
c                  file is now just ozone column; replaced haze
c                  dimension with terrain height in photo file
c        11/05/12  Removed vertical nesting
c        04/30/13  Added surface model
c        08/23/13 -bkoo-     Enabled DDM with PM
c        4/07/14   Added top con file
c        02/21/20 -rlb- Added mechanism 1 (CB6r5)
c        04/01/21  Added routine to write TOPO to SA files
c        08/26/21  RTRAC surface file doubles as (default) dep output
c                  or (flagged) surface model output
c
c     Input arguments:
c        version             model version character string
c
c     Output arguments:
c        inptim              next time to read environmental fields (HHMM)
c        inpdate             next date to read environmental fields (YYJJJ)
c        emstim              next time to read emissions (HHMM)
c        emsdate             next date to read emissions (YYJJJ)
c        ozntim              next update time for ozone map (HHMM)  
c        ozndate             next update date for ozone map (YYJJJ) 
c        bndtim              next update time for boundary conditions (HHMM)  
c        bnddate             next update date for boundary conditions (YYJJJ) 
c        toptim              next update time for top concentrations (HHMM)  
c        topdate             next update date for top concentrations (YYJJJ) 
c        wrttim              next time to output concentrations (HHMM)
c        wrtdate             next date to output concentrations (YYJJJ)
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c        numprocs            number of processsors for MPI
c
c     Routines Called:
c        READNML,  READCHM,  READPHT,  O3COLPREP, BNDPREP,  GRDPREP,
c        NSTPREP,  IASSGN2D, INTERP2D, METINIT,  VNMSHCAL, SRFPREP, 
c        LUASSGN,  PNTPREP,  AREAPREP, CNCPREP,  PIGPREP,
c        FINWIND,  RASSGN3D, DEPPREP
c
c     Called by:
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
      include 'rtracsrf.inc'
      include 'vbs.inc'
c
      logical lddmtmp(MXGRID)
c
      integer istrln
c
      character*200 action
      character*20  version
      character*10  cparm
      character*20  spec_units(4*MXSPEC+2+2*MXTRSP)
      character*20  spec_long_name(4*MXSPEC+2+2*MXTRSP)
      character*60  spec_desc(4*MXSPEC+2+2*MXTRSP)
      character*60  spec_coords(4*MXSPEC+2+2*MXTRSP)
      integer       inpdate, emsdate, wrtdate, enddate, ozndate
      integer       bnddate, topdate, numprocs
      integer       numspcs, nlayer, lav, i, j, l, n, ip, ic 
      integer       igrd, ig, kg, kg1, kp
      integer       icheck, iparm, ism, ifile, numpts_lst
      real          inptim, emstim, wrttim, endtim, ozntim
      real          bndtim, toptim, dxmod, dymod, whr, wmn
      real          orgx,orgy
      logical       lfirst_call, li2
      logical       l_exist_ivoc, l_exist_hoa_xx, l_exist_pap
c
c-----Entry point
c
      lfirst_call = .TRUE.
      icur_unit = 6
      call initnml( )
      call readnml(version,enddate,endtim,numprocs)
c
c-----Initialize simulation clock
c
      time = begtim
      date = begdate
c
c-----Call routine to set up the pointers for grid vectors
c
      call iniptr(ncol,nrow)
c
c-----Allocate the arrays for Ozone Column
c
      call alloc_o3col(ngrid,ncol,nrow)
c
c----make sure arrays are large enough
c
      icheck = nspec+1
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
c  
c-----Call the pointer routine again to update for deposition arrays
c
      call iniptr(ncol,nrow)
c
c-----Allocate the arrays for time steps 
c
      call alloc_camxcom(ngrid)
c
c-----Allocate the arrays for gridded fields
c
      call alloc_camxfld(ngrid,ncol,nrow,nlay,nspec,navspc,
     &                                    ndepspc,nsmspc,l3davg)
c
c-----Read photolysis rates lookup table
c
      if (lchem .and. idmech.ne.10) call readpht()
c
c-----Read ozone column file header
c
      if (io3col .NE. 0 .AND. idmech .NE. 10) call o3colprep()
c
c-----Call routine to allocate arrays for boundary data ---
c
      call alloc_bndary(ngrid,ncol,nrow,nlay,nspec)
c
c-----Call routine to write the headers of all sampling grids
c
      if (lsample) then
        call smpprep(.false.,endtim,enddate)
      endif
c
c-----Call routine to allocate the arrays by row
c
      call alloc_grid_row(nrow)
c
c-----Calculate grid parameters for coarse grid
c
      call grdprep(ncol(1),nrow(1),cellon(1),cellat(1),mapscl(1),
     &                        xorg,yorg,delx,dely,deltax(1,1),deltay(1) )
c
c-----Call routine to allocate arrays by layer --
c
      call alloc_grid_lay()
c
c-----Call routine to allocate gridded 2D arrays
c
      call alloc_grid_2d(ncol, nrow)
c
c-----Calculate nested grid mapping parameters
c
      if (ngrid.gt.1) then
        call nstprep()
      else
        do j=1,nrow(1)
          do i=1,ncol(1)
            n = (j-1)*ncol(1) + i
            idfin(n) = 0
          enddo
        enddo
        mapgrd(1) = 1
        nchdrn(1) = 0
        meshold(1) = 1
        nmesh(1) = 1
      endif
c
c======================== Source Apportion Begin =======================
c
c   --- make sure that the parameters are large enough ---
c
      icheck = 0
      do i=1,ngrid
        icheck = MAX(icheck,nrow(i),ncol(i))
      enddo
      iparm = MXCELLS
      cparm = 'MXCELLS'
      if( icheck .GT. iparm ) goto 7000
c
      if( ltrace ) then
c
c   --- call routine to initialize the source apportionment
c       data structures ---
c
          call initsa(version,ncol,nrow,
     &                             begdate,begtim,enddate,endtim)
c
c   --- make sure that the parameters are large enough ---
c
          icheck = MAX(ntotsp,soap3_ntotsp)
          iparm = MXTRSP
          cparm = 'MXTRSP'
          if( icheck .GT. iparm ) goto 7000
          icheck = nlay(1)
          iparm = MXLAYER
          cparm = 'MXLAYER'
          if( icheck .GT. iparm ) goto 7000
c
c   --- call the pointer routine again to update for tracer arrays ---
c
          call iniptr(ncol,nrow)
          if( lrstrt ) then
             call rdinstsa(begdate,time,ncol(1),nrow(1),nlay(1),ntotsp)
          endif
c
c  ---- call routine to calculate the average reactivity
c       of boundary conditions ---
c
          if( tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC ) then
              call clcbwt(begdate,begtim,enddate,endtim,
     &                                        ncol(1),nrow(1),nlay(1))
          endif
c
c   --- call routine to write the header of the coarse grid
c       average surface tracer concentrations file ---
c
          if( lsfcfl ) then
             if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                call ncf_set_specatt_rtrac(spec_units,spec_long_name,spec_desc,
     &                                                           spec_coords)
             else
                call ncf_set_specatt_sa(spec_units,spec_long_name,spec_desc,
     &                                                         spec_coords)
             endif
             call hdrwsa(iowsfc,sfcfil,'AVERAGE   ',ntotsp,1,begdate,begtim,
     &                              enddate,endtim,spec_units,spec_long_name,
     &                                                  spec_desc,spec_coords)
          endif
c
c   --- call routine to write the header of the RTRAC
c       surface model mass file ---
c
          if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
             call ncf_set_specatt_rtrac_dep(spec_units,spec_long_name,spec_desc,
     &                                                           spec_coords)
             call hdrwsrf(lsrfmodrt,iowrtsrf,rtsrfout,ntotsp,1,
     &               begdate,begtim,enddate,endtim,spec_units,spec_long_name,
     &                                                  spec_desc,spec_coords)
          endif
c
c   --- call routine to write the header of the coarse grid
c       average surface tracer depositions file ---
c
          call ncf_set_specatt_sadep(spec_units,spec_long_name,spec_desc,
     &                                                         spec_coords)
          if( lptdepout ) call hdrdepsa(iowptdep,ptdepfil,notimespc,
     &                          begdate,begtim,enddate,endtim,spec_units,
     &                                 spec_long_name,spec_desc,spec_coords)
c
c   --- if doing ozone or nitrate species in SA, initialize the
c       number of IRR reactions ---
c
          if( lozone .OR. lnitrate ) nirrrxn =  nreact
c
c   --- call routine to write the headers of all sampling grids
c
          if ((tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND. lsample
     &                                             .AND. lsmptrc) then
             call smpprep(.TRUE.,endtim,enddate)
          endif
      endif
c
c========================= Source Apportion End ========================
c
c
c======================== DDM Begin ====================================
c
      if( lddm .OR. lhddm ) then
c
c   --- call routine to initialize the source apportionment
c       data structures ---
c
         call initsa(version,ncol,nrow,begdate,begtim,enddate,endtim)
c
c   --- if this is a restart, call routine to read the instantaneous files ---
c
         icheck = nddmsp*nspec
         iparm = MXTRSP
         cparm = 'MXTRSP'
         if( icheck .GT. iparm ) goto 7000
         icheck = ntotsp
         iparm = MXTRSP
         cparm = 'MXTRSP'
         if( icheck .GT. iparm ) goto 7000
c
c   --- call the pointer routine again to update for tracer arrays ---
c
         call iniptr(ncol,nrow)
         if( lrstrt ) then
            if( lddmcalc(1) )
     &       call rdinstsa(begdate,time,ncol(1),nrow(1),nlay(1),ntotsp)
         endif
c
c   --- call routine to write the header of the coarse grid
c       average surface tracer concentrations file ---
c
         if( lsfcfl ) then
             if( lcdfout ) then
                call ncf_set_specatt_ddm(spec_units,spec_long_name,spec_desc,
     &                                                         spec_coords)
             endif
             call hdrwsa(iowsfc,sfcfil,'AVERAGE   ',ntotsp,1,begdate,begtim,
     &                              enddate,endtim,spec_units,spec_long_name,
     &                                                  spec_desc,spec_coords)
         endif
      endif
c
c======================== DDM End ====================================
c
c-----Read BC/TC file header and set irregular boundary cells
c
      if( is_netcdf_ibc ) then
          call ncf_bndprep(begtim,begdate,endtim,enddate)
      else
          call bndprep(begtim,begdate,endtim,enddate)
      endif
      if (ltopcon) then
         if( is_netcdf_itc ) then
             call ncf_topprep(begtim,begdate,endtim,enddate)
         else
             call topprep(begtim,begdate,endtim,enddate)
         endif
      endif
c
c------Calculate grid parameters for fine grids
c
      do ip = 1,ngrid
        do ic = 1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          call interp2d(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                  nmesh(igrd),ncol(igrd),nrow(igrd),
     &                  cellat(iptr2d(ip)),cellat(iptr2d(igrd)) )
          call interp2d(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                  nmesh(igrd),ncol(igrd),nrow(igrd),
     &                  cellon(iptr2d(ip)),cellon(iptr2d(igrd)) )
          call interp2d(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                  nmesh(igrd),ncol(igrd),nrow(igrd),
     &                  mapscl(iptr2d(ip)),mapscl(iptr2d(igrd)) )
        enddo
      enddo
c
c-----Read met fields that are to be time-interpolated, for all grids,
c     to current time
c
      do igrd = 1,ngrid
        icheck = nlay(igrd)
        iparm = MXLAYER
        cparm = 'MXLAYER'
        if( icheck .GT. iparm ) goto 7000

        orgx = xorg
        orgy = yorg
        dxmod = delx
        dymod = dely
        if (igrd.gt.1) then
          dxmod = delx/meshold(igrd)
          dymod = dely/meshold(igrd)
          orgx = xorg + (inst1(igrd) - 1)*delx - dxmod
          orgy = yorg + (jnst1(igrd) - 1)*dely - dymod
        endif
        if( is_netcdf_i3dmet(igrd) ) then
          call ncf_metprep(igrd,begtim,begdate,endtim,enddate)
          call ncf_metinit_3d(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &               height(iptr3d(igrd)),press(iptr3d(igrd)),
     &               depth(iptr3d(igrd)),windu(iptr3d(igrd)),
     &               windv(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &               water(iptr3d(igrd)))
          call ncf_metinit_2d(igrd,ncol(igrd),nrow(igrd),
     &               tsurf(iptr2d(igrd)),snow(iptr2d(igrd)),
     &               snowage(iptr2d(igrd)),snowalb(iptr2d(igrd)))
          call ncf_metinit_kv(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &               rkv(iptr3d(igrd)))
        else
           call metinit(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &               endtim,enddate,orgx,orgy,dxmod,dymod,
     &               height(iptr3d(igrd)),press(iptr3d(igrd)),
     &               depth(iptr3d(igrd)),windu(iptr3d(igrd)),
     &               windv(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &               tsurf(iptr2d(igrd)),water(iptr3d(igrd)),
     &               rkv(iptr3d(igrd)),snow(iptr2d(igrd)),
     &               snowage(iptr2d(igrd)),snowalb(iptr2d(igrd)))
        endif
      enddo
c
c-----Loop over all grids to identify missing input fields
c
      do ip = 1,ngrid
        do ic = 1,nchdrn(ip)
          ig = idchdrn(ic,ip)

          icheck = nlay(ip)
          iparm = MXLAYER
          cparm = 'MXLAYER'
          if( icheck .GT. iparm ) goto 7000

          icheck = nlay(ig)
          iparm = MXLAYER
          cparm = 'MXLAYER'
          if( icheck .GT. iparm ) goto 7000
c
c-----Compare vertical layer structures to ensure consistency
c
          if( i3dmet(ig) .GT. 0 ) then
            call vnmshcal(ig,ncol(ip),nrow(ip),nlay(ip),i1(ig),j1(ig),
     &                    ncol(ig),nrow(ig),nlay(ig),height(iptr3d(ip)),
     &                    height(iptr3d(ig)))
          else
c
c-----Assign vertical grid structures that were not read to each grid
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Assigning heights from parent grid',
     &                             time, date,' grid',ig
            call rassgn3d(ncol(ip),nrow(ip),nlay(ip),
     &           i1(ig),j1(ig),nmesh(ig),ncol(ig),nrow(ig),
     &                        height(iptr3d(ip)),height(iptr3d(ig)) )
            call rassgn3d(ncol(ip),nrow(ip),nlay(ip),
     &           i1(ig),j1(ig),nmesh(ig),ncol(ig),nrow(ig),
     &                          depth(iptr3d(ip)),depth(iptr3d(ig)) )
c
c-----Interpolate wind fields that were not read to each grid
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating winds from parent grid',
     &                             time, date,' grid',ig
            call finwind(ncol(ip),nrow(ip),nlay(ip),i1(ig),
     &                 j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                 windu(iptr3d(ip)),windv(iptr3d(ip)),
     &                 windu(iptr3d(ig)),windv(iptr3d(ig)))
c 
c-----Interpolate pressure fields that were not read to each grid
c 
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating pressure from parent grid',
     &                             time, date,' grid',ig
            call interp2d(ncol(ip),nrow(ip),nlay(ip),
     &                    i1(ig),j1(ig),nmesh(ig),ncol(ig),nrow(ig),
     &                            press(iptr3d(ip)),press(iptr3d(ig)) )
c 
c-----Interpolate temperature fields that were not read to each grid
c 
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating temps from parent grid',
     &                             time, date,' grid',ig
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(ig),j1(ig),
     &                    nmesh(ig),ncol(ig),nrow(ig),
     &                    tempk(iptr3d(ip)),
     &                    tempk(iptr3d(ig)) )
c
c-----Interpolate water vapor fields that were not read to each grid
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating humidity from parent grid',
     &                             time, date,' grid',ig
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(ig),j1(ig),
     &                    nmesh(ig),ncol(ig),nrow(ig),
     &                    water(iptr3d(ip)),
     &                    water(iptr3d(ig)) )
          endif
c
c-----Interpolate diffusivity fields that were not read to each grid
c
          if (ikv(ig).eq. 0) then
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating VDiff from parent grid',
     &                             time, date,' grid',ig
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(ig),j1(ig),
     &                    nmesh(ig),ncol(ig),nrow(ig),
     &                    rkv(iptr3d(ip)),rkv(iptr3d(ig)) )
          endif
c
c-----Interpolate 2D surface temperature fields that were not read to each grid
c
          if (i2dmet(ig) .eq. 0) then
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating sfc temp from parent grid',
     &                             time, date,' grid',ig
            call interp2d(ncol(ip),nrow(ip),1,i1(ig),j1(ig), 
     &                    nmesh(ig),ncol(ig),nrow(ig),
     &                    tsurf(iptr2d(ip)),tsurf(iptr2d(ig)) ) 
          endif
        enddo
      enddo
c
c-----Read surface files and initialize arrays
c
      do igrd = 1,ngrid
        orgx = xorg
        orgy = yorg
        dxmod = delx
        dymod = dely
        if (igrd.gt.1) then
          dxmod = delx/meshold(igrd)
          dymod = dely/meshold(igrd)
          orgx = xorg + (inst1(igrd) - 1)*delx - dxmod
          orgy = yorg + (jnst1(igrd) - 1)*dely - dymod
        endif
        if (isurf(igrd).ne.0) lrdocn(igrd) = .true.
        if( is_netcdf_isurf(igrd) ) then
          call ncf_luseprep(igrd,begtim,begdate,endtim,enddate)
          call ncf_readinp_lu(igrd,ncol(igrd),nrow(igrd),nlu,
     &               fsurf(iptrlu(igrd)),topo(iptr2d(igrd)),
     &               lai(iptr2d(igrd)),lrdlai(igrd),
     &               icdocn(iptr2d(igrd)))
        else
           call srfprep(igrd,ncol(igrd),nrow(igrd),orgx,orgy,dxmod,dymod,
     &               fsurf(iptrlu(igrd)),topo(iptr2d(igrd)),
     &               lai(iptr2d(igrd)),lrdlai(igrd),
     &               icdocn(iptr2d(igrd)))
        endif
      enddo
c
c-----Assign fine grid landuse fractions and ocean mask
c
      do ip = 1,ngrid
        do ic = 1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          if (isurf(igrd).eq.0) then
            call luassgn(ncol(ip),nrow(ip),nlu,i1(igrd),j1(igrd),
     &                   nmesh(igrd),ncol(igrd),nrow(igrd),
     &                   fsurf(iptrlu(ip)),fsurf(iptrlu(igrd)) )
            call interp2d(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd), 
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    topo(iptr2d(ip)),topo(iptr2d(igrd)) ) 
            call iassgn2d(ncol(ip),nrow(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    icdocn(iptr2d(ip)),icdocn(iptr2d(igrd)))
            lrdocn(igrd) = .true.
            if (lrdlai(ip)) then
              call luassgn(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                     nmesh(igrd),ncol(igrd),nrow(igrd),
     &                     lai(iptr2d(ip)),lai(iptr2d(igrd)) )
              lrdlai(igrd) = .true.
            endif
          elseif (.NOT.lrdlai(igrd) .AND. lrdlai(ip)) then
            call luassgn(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                   nmesh(igrd),ncol(igrd),nrow(igrd),
     &                   lai(iptr2d(ip)),lai(iptr2d(igrd)) )
            lrdlai(igrd) = .true.
          endif
        enddo
      enddo
c
c-----Read emission file headers
c
      if (lptsrc) then
         call pntprep(begtim,begdate,endtim,enddate)
         call alloc_tracer_ptsrce(nptsrc)
         call alloc_tracer_sapnts(nptsrc,soap3_ntotsp)
      else
         call alloc_grid_ptsrc(MAX(1,MXPTSRC))
         call alloc_ptemiss_null(nspec)
         call alloc_tracer_ptsrce(1)
         call alloc_tracer_sapnts(1,1)
      endif
      if (larsrc) then
        do igrd = 1,ngrid
          dxmod = delx
          dymod = dely
          if (igrd.gt.1) then
            dxmod = delx/meshold(igrd)
            dymod = dely/meshold(igrd)
          endif
          do ifile=1,nemiss_files(igrd)
             if( is_netcdf_iarem(igrd,ifile) ) then
                write(action,'(2A,I3,A,I3)') 'Reading the NetCDF ',
     &                              'gridded emissions file. Grid: ',
     &                                           igrd,' File: ',ifile
                call ncf_areaprep(action,iarem(igrd,ifile),igrd,
     &                              begtim,begdate,endtim,enddate,
     &                                  buffer_offset_iarem(igrd,ifile))
             else
                call areaprep(igrd,ifile,begtim,begdate,endtim,enddate,
     &                  iarem(igrd,ifile),iout,idiag,dxmod,dymod)
             endif
             li2 = .FALSE.
             do i=1,nemspc
               if( emspcname(i)(1:3) .EQ. 'I2 ' .OR. 
     &             emspcname(i)(1:4) .EQ. 'HOI ' ) li2 = .TRUE.
             enddo
          enddo
          if (.not.li2 .AND. .not.lixemis .AND. .not.lixbypass .AND. 
     &        (idmech.eq.1 .OR. idmech.eq.3 .OR. idmech.eq.4 .OR. idmech.eq.7)) then
            write(iout,'(//,A)') 'ERROR in STARTUP:'
            write(iout,'(A)') 'You are running with iodine chemistry,'
            write(iout,'(A)') 'but in-line Ix emissions are not invoked,'
            write(iout,'(2A)')'and I2 and/or HOI are not found',
     &                    ' in an input gridded emissions file.'
            write(iout,'(A)') 'Either turn on in-line Ix emissions,'
            write(iout,'(2A)')'or add I2 and HOI emissions to',
     &                        ' the gridded emissions file,'
            write(iout,'(A)') 'or set the Ix emission flag to BYPASS'
            call camxerr()
          endif
        enddo
      endif
c
c   --- if doing VBS check that emissions are compatible ---
c
      l_exist_ivoc = .FALSE.
      l_exist_hoa_xx = .FALSE.
      if( lvbs .AND. LVBSPREPROC ) then
         numspcs = nemspc
         do i=1,numspcs
           if( emspcname(i) .eq. 'IVOG      ' ) l_exist_ivoc = .TRUE.
           if( emspcname(i) .eq. 'IVOD      ' ) l_exist_ivoc = .TRUE.
           if( emspcname(i) .eq. 'IVOA      ' ) l_exist_ivoc = .TRUE.
           if( emspcname(i) .eq. 'IVOB      ' ) l_exist_ivoc = .TRUE.
           if( emspcname(i) .eq. 'POA_OP    ' ) then
              l_exist_hoa_xx = .TRUE.
              l_exist_pap = .TRUE.
           endif
           if( emspcname(i) .eq. 'POA_GV    ' ) then
              l_exist_hoa_xx = .TRUE.
              l_exist_pap = .TRUE.
           endif
           if( emspcname(i) .eq. 'POA_DV    ' ) then
              l_exist_hoa_xx = .TRUE.
              l_exist_pap = .TRUE.
           endif
           if( emspcname(i) .eq. 'POA_MC    ' ) then
              l_exist_hoa_xx = .TRUE.
              do j=0,NVOLBIN
                nemspc = nemspc + 1
                emspcname(nemspc) = spname(kpcp_c(j))
              enddo
           endif
           if( emspcname(i) .eq. 'POA_BB    ' ) then
              l_exist_hoa_xx = .TRUE.
              do j=0,NVOLBIN
                nemspc = nemspc + 1
                emspcname(nemspc) = spname(kpfp_c(j))
              enddo
           endif
         enddo
         if( .NOT. l_exist_ivoc .OR. .NOT. l_exist_hoa_xx ) then
            write(iout,'(//,a)') 'ERROR in STARTUP:'
            write(iout,'(2A)')'Emissions source species are not compatible',
     &                                                       ' with VBS.'
            write(iout,'(2A)')'VBS requires IVOC and sector-specific',
     &                                                   ' HOA emissions.'
            call camxerr()
         endif
         if( l_exist_pap ) then
            do j=0,NVOLBIN
              nemspc = nemspc + 1
              emspcname(nemspc) = spname(kpap_c(j))
            enddo
         endif
      endif
c
c   --- call the pointer routine again to update for emissions arrays ---
c
      call iniptr(ncol,nrow)
c
c======================== Source Apportion Begin =======================
c
c
c   --- if this is a restart, call routine to read the
c       instantaneous files for fine grids ---
c
      if( (ltrace.OR.lddm.OR.lhddm) .AND. lrstrt .AND. ngrid .GT. 1 )
     &                               call rdfgsa(begdate,time)
c
c======================== Source Apportion End =======================
c
c
c======================== DDM Begin ====================================
c
      if( lddm .OR. lhddm ) then
c
c   --- get each emissions files to the correct place,
c       NOTE:  Done here for DDM because we need the point locations
c       from regular model ----
c
          do i=1,ngrid
            call emprepsa(begdate,begtim,i,numpts_lst)
            call ncf_emprepddm(i,begdate,begtim,enddate,endtim,numpts_lst)
          enddo
          do i=1,nptsrc
            lpigsa(i) = .FALSE.
          enddo
          if( ipigflg .EQ. GRESPIG ) then
             do i=1,nptsrc
               lpigsa(i) = lpiglet(i)
             enddo
          endif
      endif
c
c======================== DDM End ====================================
c
c  --- call routine to allocate the emissions arrray ---
c
      call alloc_emiss_array(ngrid,ncol,nrow,nlayers_ems,MAX(1,nemspc))
c
c-----Read IC or restart files headers and write output concentration
c     file headers 
c 
      if( is_netcdf_iic ) then
         call ncf_cncprep(begtim,begdate,endtim,enddate,lfirst_call)
      else
         call cncprep(endtim,enddate,lfirst_call) 
      endif
c
c-----Write deposition output file headers
c
      if (ldry .or. lwet) call depprep(endtim,enddate)
c
c======================== Source Apportion Begin =======================
c
      if( ltrace ) then
          if( lsfcfl .AND. lcdfout ) then
             do igrd=1,ngrid
                if( lddmcalc(igrd) ) then
                    write(action,'(2A,I3)') 'Writing TOPO to ',
     &                                   'SA average file. Grid: ',igrd
                    call ncf_wrt_topo(action,igrd,iowsfc(igrd),
     &                      ncol(igrd),nrow(igrd),topo(iptr2d(igrd)))
                    write(action,'(2A,I3)') 'Writing TOPO to ',
     &                                'SA deposition file. Grid: ',igrd
                    if( lptdepout ) call ncf_wrt_topo(action,igrd,
     &                           iowptdep(igrd),ncol(igrd),nrow(igrd),
     &                                              topo(iptr2d(igrd)))
                 endif
             enddo
          endif
          if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
c
c   --- get each emissions file to the correct place ----
c
              do i=1,nptsrc
                 lpigsa(i) = .FALSE.
              enddo
              do i=1,ngrid
                call empreprt(begdate,begtim,i)
                call ncf_empreprt(i,begdate,begtim,enddate,endtim,
     &                                        buffer_offset_iortem(i,1,1))
              enddo
c
c   ---- call routine to read the receptor definition file ---
c
              call rdrcprt()
c
c  --- call routine to write the header of receptor average file ---
c
              call hdrcprt(begdate,begtim,enddate,endtim)
c
c  ---- call routine to calculate the average reactivity
c       of initial conditions ---
c
          else
              if( .NOT. is_netcdf_iic ) then
                 call clciwt(begdate,begtim,enddate,endtim,
     &                    ncol(1),nrow(1),nlay(1),height(iptr3d(1)))
                 call cncprep(endtim,enddate,lfirst_call) 
              else
                 call ncf_clciwt(begdate,begtim,enddate,endtim,
     &                    ncol(1),nrow(1),nlay(1),height(iptr3d(1)))
                  call ncf_cncprep(begtim,begdate,endtim,enddate,lfirst_call)
              endif
c
c   --- get each emissions files to the correct place ----
c
              icheck = ntotsp
              iparm = MXTRSP
              cparm = 'MXTRSP'
              if( icheck .GT. iparm ) goto 7000
              do i=1,ngrid
                  call emprepsa(begdate,begtim,i,numpts_lst)
                  call ncf_emprepsa(i,begdate,begtim,enddate,endtim)
              enddo
              do i=1,nptsrc
                 lpigsa(i) = .FALSE.
              enddo
              if( ipigflg .EQ. GRESPIG ) then
                do i=1,nptsrc
                   lpigsa(i) = lpiglet(i)
                enddo
             endif
c
c  ---- call routine to calculate the average reactivity
c       of emissions ---
c
              call clcewt(enddate,endtim)
c
c   --- get each emissions files BACK to the correct place ----
c
              do i=1,ngrid
                  call emprepsa(begdate,begtim,i,numpts_lst)
              enddo
c
c   ---- call routine to read the receptor definition file ---
c
              call rercp()
c
c  --- call routine to write the header of receptor average file ---
c
              call hdrrcp(begdate,begtim,enddate,endtim)
c
c  --- call routine to get metfiles synced up again ---
c
              if( .NOT. is_netcdf_i3dmet(1) ) then
                 call metinit(1,ncol(1),nrow(1),nlay(1),
     &               endtim,enddate,xorg,yorg,delx,dely,
     &               height(iptr3d(1)),press(iptr3d(1)),
     &               depth(iptr3d(1)),windu(iptr3d(1)),
     &               windv(iptr3d(1)),tempk(iptr3d(1)),
     &               tsurf(iptr2d(1)),water(iptr3d(1)),
     &               rkv(iptr3d(1)),snow(iptr2d(1)),
     &               snowage(iptr2d(1)),snowalb(iptr2d(1)))
              endif
          endif
      endif
c
c-----Initialize point source locations and PiG submodel
c
      call pnt_update()
      if( ipigflg .NE. 0 ) call pigprep(begdate,begtim,numprocs)
c
c========================= Source Apportion End ========================
c
c======================== DDM Begin ====================================
c
          if( lddm .OR. lhddm ) then
c
c  --- print DDM turn-off flags (done here because we need mapgrd)
c
            do i=1,ngrid
              lddmtmp(i) = lddmcalc(i)
            enddo
            do i=1,ngrid
              lddmcalc(i) = lddmtmp( mapgrd(i) )
            enddo
            write(idiag,*) '    DDM turn-off flag table'
            write(idiag,*) '----------------------------------------'
            write(idiag,*) ' Internal  Original         Calculate'
            write(idiag,*) '   grid      grid              DDM?'
            write(idiag,*) '----------------------------------------'
            do i=1,ngrid
              write(idiag,'(1x,i6,4x,i6,9x,l10)') i,mapgrd(i),
     &                                                 lddmcalc(i)
            enddo
            write(idiag,*) '--------------------------------'

            do ip=1,ngrid
              if ( lddmcalc(ip) ) then
                do ic = 1,nchdrn(ip)
                  igrd = idchdrn(ic,ip)
                  if ( lddmcalc(igrd) ) CYCLE
                  write(iout,'(//,a)') 'ERROR in STARTUP:'
                  write(iout,*)
     &                     'DDM cannot be turned off in a nested grid',
     &                     'if its parent grid does DDM calculation.'
                  call camxerr()
                enddo
              endif
            enddo
c
c   ---- call routine to read the receptor definition file ---
c
          call rercp()
c
c  --- call routine to write the header of receptor average file ---
c
          call hdrrcpddm(begdate,begtim,enddate,endtim)
      endif
c
c======================== DDM End ====================================
c
c
c=================== Process Analysis Begin ==========================
c
c-----Call routine to initialize Process Analysis subdomains
c
      if( lproca ) then
         call pagrids()
c
c-----Call routine to write the header to the otuput files ---
c
         if( lipr ) call wrtiprhdr(begdate,begtim,enddate,endtim)
         if( lirr ) then
           call pasetup()
           icheck = ntotsp
           iparm = MXTRSP
           cparm = 'MXTRSP'
           if( icheck .GT. iparm ) goto 7000
           call wrtirrhdr(begdate,begtim,enddate,endtim)
           if( lsfcfl ) then
              if( l3davg(1) ) then
                  nlayer = nlay(1) 
              else
                  nlayer = 1
              endif
              call ncf_set_specatt_cpa(spec_units,spec_long_name,spec_desc,
     &                                                            spec_coords)
              call hdrwsa(iowsfc,sfcfil,'AVERAGE   ',ntotsp,nlayer,begdate,
     &                    begtim,enddate,endtim,spec_units,spec_long_name,
     &                                                  spec_desc,spec_coords)
           endif
           call alloc_procan_irr(ngrid,ncol,nrow,nlay,ntotsp,iout)
         endif
c
c----Need to allocate arrays that are used as arguments
c
      else
        if( .NOT. lcsa ) call alloc_procan_ipa(ngrid,ncol,nrow,nlay,tectyp,0)
      endif
c
c===================== Process Analysis End ============================
c
c-----Call routine to initialize CSA subdomain
c
      if( lcsa ) then
         call pagrids()
         call speccsa( )
         call wrt_csa_hdr(endtim,enddate)
      endif
c
c=================== CSA End ==========================
c
c
c-----Determine times and dates for next inputs/emissions/write
c
      inptim = time
      inpdate = date
      emstim = time 
      emsdate = date
      bndtim = time 
      bnddate = date
      toptim = time 
      topdate = date
      ozntim = time 
      ozndate = date

      whr = aint(time/100.)
      wmn = amod(time,100.)
      wrttim = 100.*(whr + aint((wmn + dtout)/60.)) +
     &             amod((wmn + dtout),60.)
      wrtdate = date
      if (wrttim.ge.2400.) then 
        wrttim = wrttim - 2400. 
        wrtdate = wrtdate + 1 
        if( MOD(wrtdate,1000) .GT. 365 ) then
           if( MOD(INT(wrtdate/1000),4) .EQ. 0 ) then
              if( MOD(wrtdate,1000) .EQ. 367 )
     &                   wrtdate = (INT(wrtdate/1000)+1)*1000 + 1
           else
              wrtdate = (INT(wrtdate/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c----Make sure all of the parameters used for local arrays are large enough ---
c
      do igrd=1,ngrid
         icheck = ncol(igrd)
         iparm = MXCELLS
         cparm = 'MXCELLS'
         if( icheck .GT. iparm ) goto 7000
         icheck = nrow(igrd)
         iparm = MXCELLS
         cparm = 'MXCELLS'
         if( icheck .GT. iparm ) goto 7000
         icheck = nlay(igrd)
         iparm = MXLAYER
         cparm = 'MXLAYER'
         if( icheck .GT. iparm ) goto 7000
         do ifile=1,nemiss_files(igrd)
            icheck = narspc(igrd,ifile)
         enddo
         iparm = MXPTSRC
         cparm = 'MXPTSRC'
         if( icheck .GT. iparm ) goto 7000
      enddo
      icheck = ntotsp
      iparm = MXTRSP
      cparm = 'MXTRSP'
      if( icheck .GT. iparm ) goto 7000
      icheck = ntrcls
      iparm = MXALCLS
      cparm = 'MXALCLS'
      if( icheck .GT. iparm ) goto 7000
      icheck = ntrcls
      iparm = MXTRCLS
      cparm = 'MXTRCLS'
      if( icheck .GT. iparm ) goto 7000
      do ism = 1,nsample
         icheck = ncolsmp(ism)
         iparm = MXCOLSMP
         cparm = 'MXCOLSMP'
         if( icheck .GT. iparm ) goto 7000
         icheck = nrowsmp(ism)
         iparm = MXROWSMP
         cparm = 'MXROWSMP'
         if( icheck .GT. iparm ) goto 7000
      enddo
      icheck = ngrid
      iparm = MXGRID
      cparm = 'MXGRID'
      if( icheck .GT. iparm ) goto 7000
      icheck = nptsrc
      iparm = MXPTSRC
      cparm = 'MXPTSRC'
      if( icheck .GT. iparm ) goto 7000
      icheck = nreact
      iparm = MXREACT
      cparm = 'MXREACT'
      if( icheck .GT. iparm ) goto 7000
      icheck = nreactr
      iparm = MXREACT
      cparm = 'MXREACT'
      if( icheck .GT. iparm ) goto 7000
      icheck = nspec+1
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
      icheck = navspc
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
      icheck = nbcspc
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
      icheck = nicspc
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
      do i=1,npoint_files
         icheck = nptspc(i)
         iparm = MXSPEC
         cparm = 'MXSPEC'
         if( icheck .GT. iparm ) goto 7000
      enddo
      icheck = nrtrac
      iparm = MXSPEC
      cparm = 'MXSPEC'
      if( icheck .GT. iparm ) goto 7000
c
c-----Everything worked correctly, return to calling routine
c
      call flush(iout)
      call flush(idiag)
      return
c
c-----Error message for array bounds
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in STARTUP:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,*) 'Please change the value for parameter: ',cparm
      write(iout,*) 'It should be set to a value of at least: ',icheck
      call flush(iout)
      call camxerr()
c
c-----Return point
c

      end

C**** NCF_GETDEPTH
c
      subroutine ncf_getdepth(nvar,ncols,nrows,nlays,ibgdhp,idtnow,btimhp,
     &                    timnow,iunit,height,depth)
      use filunit
      implicit none
c
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     GETDEPTH reads the 3D met file until to the current hour,
c     calculates layer depth, and passes back the data for OSAT calculations
c
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c        nvar   I number of variables on 3D met file
c        ncols  I number of columns
c        nrows  I number of rows
c        nlays  I number of layers
c        idtnow I current date (YYJJJ)
c        timnow R current time (HH.HH)
c        iunit  I height/pressure file unit number
c             
c     Output arguments: 
c        ibgdhp I date from height/pressure file (YYJJJ)
c        btimhp R time from height/pressure file (HH.HH) 
c        height R array of gridded layer heights (m)
c        depth  R array of gridded layer depths (m)
c             
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include "camx.prm"
      include "netcdf.inc"
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c
      integer nvar
      integer ncols
      integer nrows
      integer nlays
      integer ibgdhp
      integer idtnow
      real    btimhp
      real    timnow
      integer iunit
      real    height(ncols,nrows,nlays)
      real    depth(ncols,nrows,nlays)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       this_date, this_time_tflag, this_time_etflag
      integer       this_tstep, i, j, k
      real          this_time
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. is_netcdf_i3dmet(1) ) goto 9999
      action = 'Getting layer heights from 3DMet file for grid 1: '
c
c   --- get the timestep that encompasses this date/time ---
c
      this_date = idtnow
      this_time = timnow
      if( this_time .GE. 24. ) then
        this_time = ANINT(this_time - 24.)
        this_date = this_date + 1
        if( MOD(this_date,1000) .GT. 365 ) then
           if( MOD(INT(this_date/1000),4) .EQ. 0 ) then
              if( MOD(this_date,1000) .EQ. 367 )
     &           this_date = (INT(this_date/1000)+1)*1000 + 1
           else
              this_date = (INT(this_date/1000)+1)*1000 + 1
           endif
        endif
      endif
      this_tstep = ncf_get_tstep(i3dmet(1),action,this_date,this_time*100.,
     &                 this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncols
      data_start(2) = 1
      data_count(2) = nrows
      data_start(3) = 1
      data_count(3) = nlays
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- layer heights ---
c
      this_var = "z"
      ierr = nf_inq_varid(i3dmet(1), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(1),this_varid,data_start,
     &                                          data_count,height)
      if( ierr .NE. NF_NOERR) goto 7001
c
c  --- Calculate the depths from the heights ---
c
      do k = 1,nlays
        do j = 1,nrows
          do i = 1,ncols
            depth(i,j,k) = height(i,j,k)
            if( k .GT. 1 ) depth(i,j,k) = height(i,j,k) - height(i,j,k-1)
           enddo
         enddo
      enddo
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_GETFEPTH:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_GETFEPTH:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine readcnc
      use filunit
      use grid
      use chmstry
      use bndary
      use camxfld
      use camxcom
c 
c     
c----CAMx v7.40 260801
c
c     READCNC operates in two modes:
c        1) when LRSTRT = F, reads and cycles through the AIRQUALITY file
c           to current time/date, initializes coarse grid concentrations,
c           and maps concentrations to any nested grids
c        2) when LRSTRT = T, reads and cycles through the coarse and
c           fine grid INSTANT files (from previous run) to current
c           time/date, and initializes all grid concentrations directly
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        1/7/99    Added conditional to call rdfgcon for only if there are nests
c      10/31/01    Improved assignment of coarse grid IC's based on whether
c                  this is a restart or not
c      04/17/03    Changed the logic so it no longer requires such a large 
c                  local array. It was causing problems with stack size on the 
c                  latest PGI compiler.
c      04/20/04    Fixed bug in date/time loop
c      11/4/09     Removed input top concentrations
c  
c     Input arguments: 
c        none
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        INTRPCNC
c        RDFGCON
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
c
      character*4  icspec(10)
c
      real cinit(MXCELLS,MXCELLS)
c
c-----Entry point
c
      iunit = iic
      if (lrstrt) iunit = irstc
      nx = ncol(1)
      ny = nrow(1)
      nz = nlay(1)
c
c-----Read through coarse grid concentration records until current time/date
c
 100  read(iunit,end=900) idat1,tim1,idat2,tim2
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      write(iout,'(a40,2(f7.0,i8.5))') 
     &      'Read initial condition file at ',tim1,idat1,tim2,idat2
      call flush(iout)
c
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.ge.time))) then
        do lread = 1,nicspc
          do k = 1,nz
            read(iunit) idum,(icspec(n),n=1,10), 
     &                  ((cinit(i,j),i=1,nx),j=1,ny) 
            do 90 lmod = 1,nspec
              lic = licmap(lmod)
              if( lic .NE. lread ) goto 90
              do j = 1,ny
                do i = 1,nx
                  n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                  n4d = n3d + nx*ny*nz*(lmod - 1)
                  if (lrstrt) then
                    conc(n4d) = cinit(i,j)
                  else
                    conc(n4d) = bdnl(lmod)
                    conc(n4d) = amax1(conc(n4d),cinit(i,j))
                  endif
                enddo
              enddo
  90        continue
          enddo
        enddo
      else
        do lread = 1,nicspc
          do k = 1,nz
            read(iunit)
          enddo
        enddo
        goto 100
      endif
c
c-----If this is not a restart, interpolate coarse grid concentrations
c     to all fine grids
c
      if (.not.lrstrt) then
        if (ngrid.gt.1) then
          do ip = 1,ngrid
            do ic = 1,nchdrn(ip)
              ig = idchdrn(ic,ip)
              call intrpcnc(nspec,ncol(ip),nrow(ip),nlay(ip),i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                      conc(iptr4d(ip)),conc(iptr4d(ig)) )
            enddo
          enddo
        endif
c
c-----Convert from ppm to umol/m3
c
        do igrd = 1,ngrid
          nx = ncol(igrd)
          ny = nrow(igrd)
          nz = nlay(igrd)
          do l = 1,nspec
            do k = 1,nz
              do j = 1,ny
                do i = 1,nx
                  n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                  n4d = n3d + nx*ny*nz*(l - 1)
                  if (l.le.ngas) then
                    convfac = densfac*273./tempk(iptr3d(igrd)-1+n3d)*
     &                        press(iptr3d(igrd)-1+n3d)/1013.
                  else
                    convfac = 1.
                  endif
                  conc(iptr4d(igrd)-1+n4d) = convfac*
     &                     AMAX1( bdnl(l), conc(iptr4d(igrd)-1+n4d) )
                enddo
              enddo
            enddo
          enddo
        enddo
      else
c
c-----Otherwise, read fine grid concentrations from fine grid restart file
c
        if( ngrid .GT. 1 ) call rdfgcon(idat1,tim1)
      endif
      goto 999
c
c-----End of IC file reached
c
 900  write(iout,'(//,a)') 'ERROR in READCNC:'
      write(iout,*)'End of IC file'
      write(iout,*)'Make sure initial condition file contains the ',
     &                                   'simulation beginning hour.'
      call camxerr()
c
 999  continue
c
      return
      end

      subroutine metinit(igrd,ncol,nrow,nlay,endtim,enddate,orgx,orgy,
     &                   dxmod,dymod,height,press,depth,windu,windv,
     &                   tempk,tsurf,water,rkv,snow,snowage,snowalb)
      use filunit
      use camxcom
c
c----CAMx v7.40 260801
c
c     METINIT reads the grid-dependent meteorological variables that
c     are to be time-interpolated, until the model start time/date has
c     been reached
c                          
c      Copyright Ramboll
c          
c     Modifications:
c       11/06/01   CAMx now assumes that all input file dates are in
c                  Julian format (YYJJJ) if the simulation year is 2000
c                  or greater.  Added call to DATEERR for time mismatches.
c       10/12/04   Changed name from READZPWT to METINIT and added read of
c                  water vapor and vertical diffusivity
c       11/28/05   Added read of staggered wind flag on wind date/time record
c       01/04/11   Revised for new met input format
c       02/11/11   Moved snow field from AHO to 2D met file
c       08/08/14   Added new snow cover input fields
c       07/23/19   Staggered wind flag is now grid-specific
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        endtim              simulation end time (HHMM)
c        enddate             simulation end date (YYJJJ)
c        orgx                grid x-origin (km or deg)
c        orgy                grid y-origin (km or deg)
c        dxmod               grid spacing in x-direction (km or deg)
c        dymod               grid spacing in y-direction (km or deg)
c
c     Output arguments:
c        height              layer interface height field (m)
c        press               layer midpoint pressure field (mb)
c        depth               layer depth (m)
c        windu               u-component wind field (m/s)
c        windv               u-component wind field (m/s)
c        tempk               temperature field (K)
c        tsurf               surface temperature field (K)
c        water               water vapor field (ppm)
c        rkv                 vertical diffusivity field (m2/s)
c        snow                snow cover water equivalent (m)
c        snowage             snow cover age (hr)
c        snowalb             snow cover albedo (unitless)
c
c     Routines Called:
c        RDMETHDR
c        CVTWIND
c
c     Called by:
c        STARTUP
c
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer istrln
c
      integer igrd,ncol,nrow,nlay
      integer enddate
      real endtim
      real orgx,orgy,dxmod,dymod
      real snow(ncol,nrow),snowage(ncol,nrow),snowalb(ncol,nrow)
      real height(ncol,nrow,nlay)
      real press(ncol,nrow,nlay)
      real depth(ncol,nrow,nlay)
      real windu(ncol,nrow,nlay)
      real windv(ncol,nrow,nlay)
      real tempk(ncol,nrow,nlay)
      real tsurf(ncol,nrow)
      real water(ncol,nrow,nlay)
      real rkv(ncol,nrow,nlay)
c
      character*200 fname
      character*60 string
      character*10 namevar
      character*4 namvar(10)
      integer iunit,idt,n,m,i,j,k,idum
      real hr
      real arr3d(MXCELLS,MXCELLS,MXLAYER)
      real arr2d(MXCELLS,MXCELLS)
c
      common /arrdata/ arr2d, arr3d
c
c-----Entry point
c
c-----Read 3D met file
c
      iunit = i3dmet(igrd)
      if (iunit .GT. 0) then
c
        call rdmethdr(iunit,'3DMET     ',igrd,begtim,begdate,endtim,
     &                enddate,ncol,nrow,nlay,orgx,orgy,dxmod,dymod,
     &                iout,n3dmet(igrd))
c
 100    continue
        read(iunit,end=7000) idt,hr
        hr = 100*aint(hr) + anint(60.*amod(hr,1.))
        if (hr.ge.2400.) then
          hr = hr - 2400.
          idt = idt + 1
          if( MOD(idt,1000) .GT. 365 ) then
             if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                if( MOD(idt,1000) .EQ. 367 )
     &             idt = (INT(idt/1000)+1)*1000 + 1
             else
                idt = (INT(idt/1000)+1)*1000 + 1
             endif
          endif
        endif
        write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 3D met file at ',hr,idt,' grid',igrd
c
        if (idt.lt.date .or. (idt.eq.date .and. hr.lt.time)) then
          do n = 1,n3dmet(igrd)
            do k = 1,nlay
              read(iunit)
            enddo
          enddo
          goto 100
        endif
        if (idt.gt.date .or. (idt.eq.date .and. hr.gt.time)) goto 7001
c
        do n = 1,n3dmet(igrd)
          do k = 1,nlay
            read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                            ((arr3d(i,j,k),i=1,ncol),j=1,nrow)
          enddo
          write(namevar,'(10a1)') (namvar(m),m=1,10)
c
          if (namevar.eq.'ZGRID_M') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  height(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          elseif (namevar.eq.'PRESS_MB') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  press(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          elseif (namevar.eq.'TEMP_K') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  tempk(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          elseif (namevar.eq.'HUMID_PPM') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  water(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          elseif (namevar.eq.'UWIND_MpS') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  windu(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          elseif (namevar.eq.'VWIND_MpS') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  windv(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          endif
        enddo
c
c-----Calculate layer depth
c
        do k = 1,nlay
          do j = 1,nrow
            do i = 1,ncol
              if (k.eq.1) then
                depth(i,j,k) = height(i,j,k) 
              else
                depth(i,j,k) = height(i,j,k) - height(i,j,k-1)
              endif
              if (depth(i,j,k).le.0.0) then
                write(iout,'(//,a)') 'ERROR in METINIT:'
                write(iout,'(a,3i3)')
     &                    'Negative depth in metinit, i,j,k = ',i,j,k
                call camxerr()
              endif
            enddo
          enddo
        enddo
c             
c-----Convert windu and windv if they are not staggered 
c             
        if (.not.lstagw(igrd)) call cvtwind(ncol,nrow,nlay,windu,windv)
      endif
c
c-----Read 2D met file
c
      do j = 1,nrow
        do i = 1,ncol
          snow(i,j) = 0.
          snowage(i,j) = 0.
          snowalb(i,j) = 0.
        enddo
      enddo
c
      iunit = i2dmet(igrd)
      if (iunit.gt.0) then
c
        call rdmethdr(iunit,'2DMET     ',igrd,begtim,begdate,endtim,
     &                enddate,ncol,nrow,nlay,orgx,orgy,dxmod,dymod,
     &                iout,n2dmet(igrd))
c
 300    continue 
        read(iunit,end=7000) idt,hr
        hr = 100*aint(hr) + anint(60.*amod(hr,1.))
        if (hr.ge.2400.) then
          hr = hr - 2400.
          idt = idt + 1
          if( MOD(idt,1000) .GT. 365 ) then
             if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                if( MOD(idt,1000) .EQ. 367 )
     &             idt = (INT(idt/1000)+1)*1000 + 1
             else
                idt = (INT(idt/1000)+1)*1000 + 1
             endif
          endif
        endif
        write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 2D met file at ',hr,idt,' grid',igrd
c
        if (idt.lt.date .or. (idt.eq.date .and. hr.lt.time)) then
          do n = 1,n2dmet(igrd)
            read(iunit)
          enddo
          goto 300
        endif
        if (idt.gt.date .or. (idt.eq.date .and. hr.gt.time)) goto 7001
c
        do n = 1,n2dmet(igrd)
          read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                          ((arr2d(i,j),i=1,ncol),j=1,nrow)
          write(namevar,'(10a1)') (namvar(m),m=1,10)
          if (namevar.eq.'TSURF_K') then
            do j = 1,nrow
              do i = 1,ncol
                tsurf(i,j) = arr2d(i,j)
              enddo
            enddo
          elseif (namevar.eq.'SNOWEW_M') then
            do j = 1,nrow
              do i = 1,ncol
                snow(i,j) = arr2d(i,j)
              enddo
            enddo
          elseif (namevar.eq.'SNOWAGE_HR') then
            do j = 1,nrow
              do i = 1,ncol
                snowage(i,j) = arr2d(i,j)
              enddo
            enddo
          elseif (namevar.eq.'SNOWCOVER') then
            do j = 1,nrow
              do i = 1,ncol
                if (arr2d(i,j).gt.0.) then
                  snow(i,j) = .025          ! Make some assumptions
                  snowage(i,j) = 5.*24.     ! for backward compatibility
                endif 
              enddo
            enddo
          endif
        enddo
      endif
c
c-----Read vertical diffusivity file
c
      iunit = ikv(igrd)
      if (iunit.gt.0) then
c
        call rdmethdr(iunit,'KVMET     ',igrd,begtim,begdate,endtim,
     &                enddate,ncol,nrow,nlay,orgx,orgy,dxmod,dymod,
     &                iout,nkvmet(igrd))
c
 500    continue
        read(iunit,end=7000) idt,hr
        hr = 100*aint(hr) + anint(60.*amod(hr,1.))
        if (hr.ge.2400.) then
          hr = hr - 2400.
          idt = idt + 1
          if( MOD(idt,1000) .GT. 365 ) then
             if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                if( MOD(idt,1000) .EQ. 367 )
     &             idt = (INT(idt/1000)+1)*1000 + 1
             else
                idt = (INT(idt/1000)+1)*1000 + 1
             endif
          endif
        endif
        write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 3D VDiff file at ',hr,idt,' grid',igrd
c
        if (idt.lt.date .or. (idt.eq.date .and. hr.lt.time)) then
          do n = 1,nkvmet(igrd)
            do k=1,nlay
               read(iunit)
            enddo
          enddo
          goto 500
        endif
        if (idt.gt.date .or. (idt.eq.date .and. hr.gt.time)) goto 7001
c
        do n = 1,nkvmet(igrd)
          do k = 1,nlay
            read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                            ((arr3d(i,j,k),i=1,ncol),j=1,nrow)
          enddo
          write(namevar,'(10a1)') (namvar(m),m=1,10)
          if (namevar.eq.'KV_M2pS') then
            do k = 1,nlay
              do j = 1,nrow
                do i = 1,ncol
                  rkv(i,j,k) = arr3d(i,j,k)
                enddo
              enddo
            enddo
          endif
        enddo
      endif
c
c-----Read cloud/rain file header
c
      iunit = icld(igrd)
      if (iunit.gt.0) then
        call rdmethdr(iunit,'CLDMET    ',igrd,begtim,begdate,endtim,
     &                enddate,ncol,nrow,nlay,orgx,orgy,dxmod,dymod,
     &                iout,ncldmet(igrd))
      endif
c
      return
c
 7000 continue
      write(iout,'(//,a)')'ERROR in METINIT:'
      write(iout,*)'End of input file reached.  Make sure the file '
      write(iout,*)'is for the correct day and contains all hours.'
      inquire(unit=iunit,name=fname)
      write(iout,*) 'Filename = ',fname(:istrln(fname))
      write(iout,*)
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in METINIT:'
      write(iout,'(a,f10.1,i10.5)') 'Past current time/date ',time,date
      inquire(unit=iunit,name=fname)
      write(iout,*) 'Filename = ',fname(:istrln(fname))
      write(iout,*)
      call camxerr()
c
      end

subroutine ncf_set_compress_flag()
!
!----CAMx v7.40 260801
!
!     This routine just sets the compression flag for NetCDF based on the
!     the compiler directive. It needs to be a F90 routine so the preprocssor
!     directives can be used.
!
!      Copyright Ramboll
!
!     Modifications:
!        none
!
!     Input arguments:
!        none
!
!     Output arguments:
!        none
!
!     Routines called:
!        none
!
!
!     Called by:
!        READNML
!
use camx_includes
implicit none

#ifndef CHUNK
ncf_compress = .FALSE.
#endif

return
end

      subroutine node_send_nbc(ifm,icm)                                          
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use grid
      use camxfld
      use grid_dims
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       MKNEST_BUFF
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: nm
      integer :: itype
      integer :: mtp
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nv
      integer :: ispbeg
      integer :: i1c
      integer :: i2c
      integer :: j1c
      integer :: j2c
      integer :: k1c
      integer :: k2c
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: k1f
      integer :: k2f
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: nbuff_save
      integer (kind=8) :: maxbytes
      integer :: ierr
c
      real, allocatable, save :: buffnest(:)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      nbuff_save = 0
      itype = 6
      k1c = 1
      k2c = nlay(icm)
      k1f = 1
      k2f = nlay(ifm)
c
c  --- First, before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req(nm)=0
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_NBC:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_NBC:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_recv_buff(1),
     &                          node_buffs(nm)%nrecv,6000+icm,nm,irecv_req(nm))
         endif
      enddo
      if (nbuff_save .eq. 0) then
         if (allocated(buffnest)) deallocate (buffnest)
         allocate( buffnest( 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*nspec ) )
         nbuff_save = 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*nspec
      endif
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            i1c=bpaths(1,6,ifm,nm)
            i2c=bpaths(2,6,ifm,nm)
            j1c=bpaths(3,6,ifm,nm)
            j2c=bpaths(4,6,ifm,nm)
            i1f=bpaths(1,7,ifm,nm)
            i2f=bpaths(2,7,ifm,nm)
            j1f=bpaths(3,7,ifm,nm)
            j2f=bpaths(4,7,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            mtp = ( (j2f-j1f+1) + (i2f-i1f+1) )*2*(k2f-k1f+1)
            iptr=0
            iptr8=0
            do nv=1,nspec
               ispbeg=iptr4d(icm)+(nv-1)*mmzp(icm)*mmxp(icm)*mmyp(icm)
               call mknest_buff(conc(ispbeg),mtp,buffnest(1+iptr),
     &                          mmxp(icm),mmyp(icm),mmzp(icm),
     &                          mi0(icm),mj0(icm),
     &                          i1c,i2c,j1c,j2c,
     &                          i1f,i2f,j1f,j2f,
     &                          offxb,offxe,offyb,offye,
     &                          k1c,k2c,nmesh(ifm),nmesh(ifm),icm)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_NBC:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_NBC:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

            call par_init_put(node_buffs(nm)%lbc_send_buff(1),
     &                        node_buffs(nm)%nsend )
            call par_put_int(i1f,   1)
            call par_put_int(i2f,   1)
            call par_put_int(j1f,   1)
            call par_put_int(j2f,   1)
            call par_put_int(k1f,   1)
            call par_put_int(k2f,   1)
            call par_put_int(i1c,   1)
            call par_put_int(i2c,   1)
            call par_put_int(j1c,   1)
            call par_put_int(j2c,   1)
            call par_put_int(mia(icm)+mi0(icm),   1)
            call par_put_int(miz(icm)+mi0(icm),   1)
            call par_put_int(mja(icm)+mj0(icm),   1)
            call par_put_int(mjz(icm)+mj0(icm),   1)
            call par_put_int(mynum, 1)
            call par_put_int(nspec, 1)
            call par_put_int(iptr,  1)
            call par_put_float(buffnest(1),iptr)
            if (iget_paths(itype,ifm,nm) .ne. bpaths(5,5,ifm,nm)) then
               stop 'iget_paths and bpaths are inconsistent'
            endif
            isend_req(nm) = 0
            call par_send_noblock(iget_paths(itype,ifm,nm), 6000+icm, isend_req(nm))
         endif
      enddo
c
      deallocate( buffnest )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_nbc:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine mknest_buff:
c-----------------------------------------------------------------------
c
      subroutine mknest_buff(cnc,mtp,fcnc_snd,
     &                       m1,m2,m3,i0,j0,
     &                       i1c,i2c,j1c,j2c,
     &                       i1f,i2f,j1f,j2f,
     &                       offxb,offxe,offyb,offye,
     &                       k1c,k2c,nestratx,nestraty,icm)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_SEND_NBC
c       NODE_SEND_NBC_PT
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: cnc(m1,m2,m3)
c
      integer :: mtp
      real    :: fcnc_snd(mtp)
      integer :: m1
      integer :: m2
      integer :: m3
      integer :: i0
      integer :: j0
      integer :: i1c
      integer :: i2c
      integer :: j1c
      integer :: j2c
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: k1c
      integer :: k2c
      integer :: nestratx
      integer :: nestraty
      integer :: icm
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: k
      integer :: ii
      integer :: jj
      integer :: counter
      integer :: len_i
      integer :: len_j
      integer :: Li
      integer :: Lj
      integer :: kcrs
c
      real    :: tempbnd(mtp)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (i1c .eq. 1 .or. i2c .eq. ncol(icm) .or.
     &                                 j1c .eq. 1 .or. j2c .eq. nrow(icm)) then
         stop 'config is beyond the control of mknest_buff'
      endif 
c
      counter = 0
      len_i = i2f - i1f + 1
      len_j = j2f - j1f + 1 
c
      do kcrs=k1c,k2c
         k = kcrs
c
c  --- south ---
c
            Li=0
            do i=i1c, i2c
               do ii=1, nestratx
                  Li = Li + 1
                  tempbnd(Li)=cnc(i-i0,j1c-1-j0,kcrs)
               enddo
            enddo
            if (offxb+len_i .gt. Li) then 
               stop 'exception mknest_buff south'
            endif
            do i=offxb+1, offxb+len_i
               counter = counter + 1
               fcnc_snd(counter)=tempbnd(i)
            enddo
c
c  --- north ---
c
            Li=0
            do i=i1c, i2c
               do ii=1, nestratx
                  Li = Li + 1
                  tempbnd(Li)=cnc(i-i0,j2c+1-j0,kcrs)
               enddo
            enddo
            if (offxb+len_i .gt. Li) then
               stop 'exception mknest_buff north'
            endif
            do i=offxb+1, offxb+len_i
               counter = counter + 1
               fcnc_snd(counter)=tempbnd(i)
            enddo
c
c --- west ---
c
            Lj=0
            do j=j1c, j2c
               do jj=1, nestraty
                  Lj = Lj + 1
                  tempbnd(Lj)=cnc(i1c-1-i0,j-j0,kcrs)
               enddo
            enddo
            if (offyb+len_j .gt. Lj) then
               stop 'exception mknest_buff west'
            endif
            do j=offyb+1, offyb+len_j
               counter = counter + 1
               fcnc_snd(counter)=tempbnd(j)
            enddo
c
c  --- east ---
c
            Lj=0
            do j=j1c, j2c
               do jj=1, nestraty
                  Lj = Lj + 1
                  tempbnd(Lj)=cnc(i2c+1-i0,j-j0,kcrs)
               enddo
            enddo
            do j=offyb+1, offyb+len_j
               counter = counter + 1
               fcnc_snd(counter)=tempbnd(j)
            enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine mknest_buff:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_nbc_pt:
c-----------------------------------------------------------------------
c
      subroutine node_send_nbc_pt(ifm,icm)                                          
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use grid
      use camxfld
      use grid_dims
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       MKNEST_BUFF
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: nm
      integer :: itype
      integer :: mtp
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nv
      integer (kind=8) :: ispbeg
      integer :: i1c
      integer :: i2c
      integer :: j1c
      integer :: j2c
      integer :: k1c
      integer :: k2c
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: k1f
      integer :: k2f
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: nbuff_save_pt
      integer (kind=8) :: maxbytes
      integer :: ierr
c
      real, allocatable, save :: buffnest_pt(:)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      nbuff_save_pt = 0
      itype = 6
c
      k1c = 1
      k2c = nlay(icm)
      k1f = 1
      k2f = nlay(ifm)
c
c  --- First, before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_pt(nm)=0
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_NBC_PT:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_NBC_PT:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_pt_recv_buff(1),  !cbwpt
     &                           node_buffs(nm)%nrecv,6000+icm+pt_identifier,
     &                           nm,irecv_req_pt(nm)                         )
         endif
      enddo
      if (nbuff_save_pt .eq. 0) then
         if (allocated(buffnest_pt)) deallocate (buffnest_pt)
         allocate( buffnest_pt( 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*ntotsp ) )
         nbuff_save_pt = 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*ntotsp
      endif   
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            i1c=bpaths(1,6,ifm,nm)
            i2c=bpaths(2,6,ifm,nm)
            j1c=bpaths(3,6,ifm,nm)
            j2c=bpaths(4,6,ifm,nm)
            i1f=bpaths(1,7,ifm,nm)
            i2f=bpaths(2,7,ifm,nm)
            j1f=bpaths(3,7,ifm,nm)
            j2f=bpaths(4,7,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            mtp = ( (j2f-j1f+1) + (i2f-i1f+1) )*2*(k2f-k1f+1)
            iptr=0
            iptr8=0
            do nv=1,ntotsp
               ispbeg=ipsa3d(icm)+DBLE(nv-1)*DBLE(mmzp(icm))*DBLE(mmxp(icm))*DBLE(mmyp(icm))
               call mknest_buff(ptconc(ispbeg),mtp,buffnest_pt(1+iptr),
     &                          mmxp(icm),mmyp(icm),mmzp(icm),
     &                          mi0(icm),mj0(icm),
     &                          i1c,i2c,j1c,j2c,
     &                          i1f,i2f,j1f,j2f,
     &                          offxb,offxe,offyb,offye,
     &                          k1c,k2c,nmesh(ifm),nmesh(ifm),icm)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_NBC_PT:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_NBC_PT:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

            call par_init_put(node_buffs(nm)%lbc_pt_send_buff(1),  !cbwpt
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1f,   1)
            call par_put_int(i2f,   1)
            call par_put_int(j1f,   1)
            call par_put_int(j2f,   1)
            call par_put_int(k1f,   1)
            call par_put_int(k2f,   1)
            call par_put_int(i1c,   1)
            call par_put_int(i2c,   1)
            call par_put_int(j1c,   1)
            call par_put_int(j2c,   1)
            call par_put_int(mia(icm)+mi0(icm),   1)
            call par_put_int(miz(icm)+mi0(icm),   1)
            call par_put_int(mja(icm)+mj0(icm),   1)
            call par_put_int(mjz(icm)+mj0(icm),   1)
            call par_put_int(mynum, 1)
            call par_put_int(ntotsp,1)
            call par_put_int(iptr,  1)
            call par_put_float(buffnest_pt(1),iptr)
c
            if (iget_paths(itype,ifm,nm) .ne. bpaths(5,5,ifm,nm)) then
               stop 'iget_paths and bpaths are in-consistant'
            endif
            isend_req_pt(nm) = 0
            iptr=iptr+mtp
            iptr8=iptr8+DBLE(mtp)*DBLE(4)
            call par_send_noblock(iget_paths(itype,ifm,nm), 
     &                            6000+icm+pt_identifier, isend_req_pt(nm))
         endif
      enddo
c
      deallocate( buffnest_pt )
      nbuff_save_pt = 0
c
      return
      end

      subroutine chkpartial()
      use grid
      use tracer
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c     This routione checks for the integrity of the data read in the 
c     partial source area maps. The sum of the fractions in each grid
c     cell must be with an acceptable range of 100%. If it within the 
c     range then the values are normalized to ensure that the total 
c     equals 100%, to machine precision.
c
c      Copyright Ramboll
c          
c     Modifications:
c
c     Input arguments:
c
c     Output arguments:
c
c     Routines called:
c
c     Called by:
c
      include "camx.prm"
c
c-----External Functions
c
      integer istrln
c
c-----Local parameters ----
c
      real FUZZ
      parameter( FUZZ = 0.02 )
c
c-----Local variables ----
c
      integer icl, jcl, igrp, igrd, ipart
      real    sum_frac
c
c-----Entry point
c
c  --- loop over grids ---
c
      do igrd=1,ngrid
c
c  --- loop over groups, initializing the count ---
c
         do igrp=1,ngroup
c
c  --- loop over cells ---
c
            do icl=1,nxcell(igrd) 
              do jcl=1,nycell(igrd) 
                sum_frac = 0.
                do ipart=1,npartial(igrp,igrd)
                   sum_frac = sum_frac + frcmap(igrp,ipart,igrd,icl,jcl)
                enddo
c
c  --- if sum is zero then use regular model source map ---
c
                if( sum_frac .EQ. 0. ) then
                   frcmap(igrp,1,igrd,icl,jcl) = 1.0
                   igrmap(igrp,1,igrd,icl,jcl) = igrmap(0,1,igrd,icl,jcl)
                   sum_frac = 1.0
                endif
c
c  --- if sum is outside range, write an error ---
c
                if( ABS(1.0 - sum_frac) .GT. FUZZ) then
                   write(iout,'(//,a)') 'ERROR in CHKPARTIAL:'
                   write(iout,'(/,1X,2A)') 'The sum of the fractional ',
     &                                      'grid values do not add to 100%'
                   write(iout,'(1X,A,I5,A,I5)') 'Grid: ',igrd,
     &                                          '   Emissions group: ',igrp
                   write(iout,'(1X,A,I3,A,I3,A)') 'Cell: (',icl,',',jcl,')'
                   write(iout,'(1X,A,F8.2,A)') 'The total for this cell is: ',
     &                                                       sum_frac*100.,'%'
                   call camxerr()
                 endif
c
c  --- normalize the values to make sure it is exactly 100% ---
c
                 
                do ipart=1,npartial(igrp,igrd)
                   frcmap(igrp,ipart,igrd,icl,jcl) = 
     &                       frcmap(igrp,ipart,igrd,icl,jcl) / sum_frac
                enddo
c
c  --- next grid cell ---
c
              enddo
            enddo
c
c ---- next group ---
c
         enddo
c
c ---- next grid ---
c
      enddo
c
      return
      end

c*** DEQMCMC
c
      subroutine deqmcmc(y, rr, lrr, lpr)
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Calculate equilibrium (steady-state) species concentrations and 
c     update reaction rates for DLSODE in the RTRAC CMC solver
c
c      Copyright Ramboll
c
c    Argument descriptions:
c     Inputs:
c      y     D  species concentrations (ppm)
c      rr    D  time rate of change of species concentrations
c      lrr   L  only update rr if true
c      lpr   L  availability of prior rr
c     Outputs:
c      y     D  species concentrations (ppm)
c      rr    D  time rate of change of species concentrations
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real*8    y(MXTRSP+MXSPEC), rr(MXRX)
      logical   lrr, lpr
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, k, isp, irx
      real*8    gain, loss, rtmp
      logical   l1
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c ---  calculate rr if prior is not available
c
      if( .NOT. lpr ) then
         do i = 1,nrxnrtc
            irx = irxupdt(i)
            rr(i) = rkrtc(i)
            if( nrct(i) .GT. 0) then   ! this check should be superfluous
               do k = 1,nrct(i)
                     rr(i) = rr(i)*y(idxrct(i,k))
               enddo
            endif
         enddo
      endif
c
c ---  solve equilibrium species y(i)
c      accumulate production terms (gain)
c      accumulate destruction terms (loss) excluding y(i)
c      y(i) = gain/loss
c
      do i = 1,neqmrtc
         isp = ideqm(i)
         gain = 0.0D0
         do j = 1,nrxgain(i)
            irx = irxgain(i,j)
            rtmp = rkrtc(irx)*prdcoeqm(i,j)
            if( nrct(irx) .GT. 0 ) then
               do k = 1,nrct(irx)
                  rtmp = rtmp*y(idxrct(irx,k))
               enddo
            endif
            gain = gain + rtmp
         enddo
         rtmp = 0.0D0
         loss = 0.0D0
         do j = 1,nrxloss(i)
            irx = irxloss(i,j)
            rtmp = rkrtc(irx)
            l1 = .true.
            if( nrct(irx) .GT. 0 ) then
               do k = 1,nrct(irx)
                  if( idxrct(irx,k) .EQ. isp .AND. l1 )  then
                     l1 = .false.
                  else
                     rtmp = rtmp*y(idxrct(irx,k))
                  endif
               enddo
            endif
            loss = loss + rtmp
         enddo
         if( DABS(loss) .GT. 1.0D-75 ) then
            y(isp) = gain/loss
         else
            y(isp) = 0.0D0
         endif
      enddo
c
      if( .NOT. lrr) return
c
c ---  update rr using new equilibrium species concentrations
c
      do i = 1,nrxupdt
         irx = irxupdt(i)
         rr(irx) = rkrtc(irx)
         if( nrct(irx) .GT. 0) then   ! this check should be superfluous
            do k = 1,nrct(irx)
                  rr(irx) = rr(irx)*y(idxrct(irx,k))
            enddo
         endif
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine drvtuv(igrd,ncol,nrow,nlay,nspc,time,date,itzon,
     &                  idfin,cellat,cellon,height,press,tsurf,
     &                  tempk,water,conc,cod,alb,cldtrns)
      use o3colmap
      use chmstry
c
c----CAMx v7.40 260801
c
c     DRVTUV is the driver for the cloud/aerosol adjustment to
c     clear-sky photolysis rates.  A streamlined version of the TUV
c     radiative transfer model (based on v4.8) is called to calculate
c     actinic fluxes through the grid column for 2 cases: clear with
c     default haze, and cloudy with actual haze.  The ratio
c     of the two actinic flux profiles is used to apply to
c     the clear-sky lookup photolysis rates in KPHOTO.F.
c
c      Copyright Ramboll
c
c     Modifications:
c        03/29/11    Support in-line TUV with aerosol optical depth
c        04/02/12    Removed RADM cloud adjustment option, cloud/aerosol
c                    adjustments now always done with in-line TUV
c        04/20/13    Moved call to EMISTRNS, removed averaging across
c                    input times
c        08/11/14    Albedo now includes effects of snow
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        nspc                number of species
c        time                current time (HHMM)
c        date                current date (YYJJJ)
c        itzon               time zone
c        idfin               map of nested grids in this grid
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        height              current layer interface height field (m)
c        press               current layer pressure field (mb)
c        tsurf               current surface temperature field (K)
c        tempk               current layer temperature field (K)
c        water               current layer water vapor field (mb)
c        conc                concentration field (umol/m3, ug/m3)
c        cod                 layer cloud optical depth field (unitless)
c        alb                 surface UV albedo
c
c     Output arguments:
c        cldtrns             Cloud adjustment factor field (unitless) 
c
c     Routines called:
c        GETZNTH
c        TUV
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include 'camx.prm'
      include 'camx_aero.inc'
      include 'flags.inc'
c
c-----Arguments
c
      integer igrd, ncol, nrow, nlay, nspc, date, itzon
      integer idfin(ncol,nrow)
      real time
      real cellat(ncol,nrow), cellon(ncol,nrow), alb(ncol,nrow)
      real height(ncol,nrow,nlay)
      real press(ncol,nrow,nlay)
      real tsurf(ncol,nrow)
      real tempk(ncol,nrow,nlay)
      real water(ncol,nrow,nlay)
      real conc(ncol,nrow,nlay,nspc)
      real cod(ncol,nrow,nlay)
      real cldtrns(ncol,nrow,nlay)
c
c-----Local variables
c
      integer NELT
      parameter (NELT = 51)
      integer i, j, k, l
      integer iz, izz, nz, nn
      integer rh1d(MXLAYER)
      real tuvalb
      real prslev,tmplev
      real zen1, zen2, zen, coszen
      real dtdz, tavg
      real wvapor,qwatr,ev,es,rhfac
      real totext,totssa,totcon,sumcod
      real factr,odint
      real temp1d(MXLAYER),pres1d(MXLAYER)
      real rafcld(MXLAYER+1)
      real z(MXLAYER+1),midht1d(MXLAYER)
      real airlev(MXLAYER+1)
      real odcld(MXLAYER+1), omcld(MXLAYER+1), gcld(MXLAYER+1)
      real odaer1(MXLAYER+1), omaer1(MXLAYER+1), gaer(MXLAYER+1)
      real odaer2(MXLAYER+1), omaer2(MXLAYER+1)
      real frh(100)
      real eltod(NELT)
      logical ldark

      real RGAS
      parameter(RGAS = 1.3806503d-19) !cm3 mbar K-1 molec-1
c
c-----Aerosol optical depth profile from Elterman (1968).
c     These are vertical optical depths per km, in 1 km
c     intervals from 0 km to 50 km, at 340 nm.
c     Total integrated OD is 0.38 (~0.23 at 550 nm).
c
      data eltod/
     &     2.40E-01,1.06E-01,4.56E-02,1.91E-02,1.01E-02,7.63E-03,
     &     5.38E-03,5.00E-03,5.15E-03,4.94E-03,4.82E-03,4.51E-03,
     &     4.74E-03,4.37E-03,4.28E-03,4.03E-03,3.83E-03,3.78E-03,
     &     3.88E-03,3.08E-03,2.26E-03,1.64E-03,1.23E-03,9.45E-04,
     &     7.49E-04,6.30E-04,5.50E-04,4.21E-04,3.22E-04,2.48E-04,
     &     1.90E-04,1.45E-04,1.11E-04,8.51E-05,6.52E-05,5.00E-05,
     &     3.83E-05,2.93E-05,2.25E-05,1.72E-05,1.32E-05,1.01E-05,
     &     7.72E-06,5.91E-06,4.53E-06,3.46E-06,2.66E-06,2.04E-06,
     &     1.56E-06,1.19E-06,9.14E-07/
c
c-----Aerosol humidity adjustment parameter as f(RH); FLAG (2000)
c
      data frh/1.,1.,1.,1.,1.,
     &         1.,1.,1.,1.,1.,
     &         1.,1.,1.,1.0001,1.0001,
     &         1.0004,1.0006,1.0024,1.0056,1.0089,
     &         1.0097,1.0105,1.0111,1.0115,1.0118,
     &         1.0122,1.0126,1.0130,1.0135,1.0139,
     &         1.0173,1.0206,1.0254,1.0315,1.0377,
     &         1.0486,1.0596,1.0751,1.0951,1.1151,
     &         1.1247,1.1343,1.1436,1.1525,1.1615,
     &         1.1724,1.1833,1.1955,1.2090,1.2224,
     &         1.2368,1.2512,1.2671,1.2844,1.3018,
     &         1.3234,1.3450,1.3695,1.3969,1.4243,
     &         1.4628,1.5014,1.5468,1.5992,1.6516,
     &         1.6991,1.7466,1.7985,1.8549,1.9113,
     &         1.9596,2.0080,2.0596,2.1146,2.1695,
     &         2.2630,2.3565,2.4692,2.6011,2.7330,
     &         2.8461,2.9592,3.0853,3.2245,3.3637,
     &         3.5743,3.7849,4.0466,4.3594,4.6721,
     &         5.3067,5.9412,6.9627,8.3710,9.7793,
     &         12.4288,15.0773,18.0590,21.3709,22. /
c
c-----Entry point
c
      nz = nlay + 1
c
c-----Loop over all vertical grid columns; skip columns containing nested grids
c
c$omp parallel default(shared)
c$omp&  private(i,j,k,rafcld,zen,ldark,coszen,
c$omp&          sumcod,tuvalb,z,temp1d,pres1d,wvapor,
c$omp&          qwatr,ev,es,rh1d,midht1d,airlev,prslev,
c$omp&          tmplev,dtdz,tavg,iz,odcld,omcld,gcld,
c$omp&          izz,factr,odint,odaer1,omaer1,gaer,
c$omp&          odaer2,omaer2,totext,totssa,totcon,l,rhfac)
c$omp do schedule(static) collapse(2)
      do j = 2,nrow-1
        do i = 2,ncol-1
          do k = 1,nz
            rafcld(k) = 1.
          enddo
          if (idfin(i,j).gt.igrd) goto 100
c
c-----Get solar zenith angle
c
          call getznth(cellat(i,j),cellon(i,j),time,date,itzon,zen,
     &                 ldark)
          if (ldark) goto 100
          zen = min(zen,75.)
          coszen = COS(zen*3.1415/180.)
c
c-----Check if this is a cloud-free column; adjustmnet ratio = 1
c
          sumcod = 0.
          do k = 1,nlay
            sumcod = sumcod + cod(i,j,k)
          enddo
          if (sumcod.eq.0. .AND. naero.eq.0) goto 100
c
c-----Set albedo
c
          tuvalb = alb(i,j)
c
c-----Prepare 1-D met variables for TUV
c
          z(1) = 0.
          do k = 1,nlay
            z(k+1) = height(i,j,k)*1.e-3
            temp1d(k) = tempk(i,j,k)
            pres1d(k) = press(i,j,k)
            wvapor    = water(i,j,k)
            qwatr     = 1.e-6*wvapor*18./28.8
            ev        = qwatr*pres1d(k)/(qwatr + eps)
            es        = e0*exp((lv/rv)*(1./273. - 1./temp1d(k)))
            rh1d(k)   = nint(100.*max(0.01,min(0.95,ev/es)))
          enddo
          do k = 1,nlay
            midht1d(k) = (z(k) + z(k+1))*0.5
          enddo
c
c-----Interpolate temperature and pressure to layer interfaces, then
c     calculate air density
c
          prslev = pres1d(1) - (midht1d(1)-z(1))*
     &             (pres1d(2)-pres1d(1))/(midht1d(2)-midht1d(1))
          airlev(1) = prslev/(Rgas*tsurf(i,j))

          do iz = 2,nz-1
            prslev = pres1d(iz-1) + (z(iz)-midht1d(iz-1))*
     &      (pres1d(iz)-pres1d(iz-1))/(midht1d(iz)-midht1d(iz-1))
            tmplev = temp1d(iz-1) + (z(iz)-midht1d(iz-1))*
     &      (temp1d(iz)-temp1d(iz-1))/(midht1d(iz)-midht1d(iz-1))
            airlev(iz) = prslev/(Rgas*tmplev)
          enddo

          dtdz = (temp1d(nz-1) - temp1d(nz-2))/
     &           (midht1d(nz-1) - midht1d(nz-2))
          tmplev = temp1d(nz-1) + dtdz*(z(nz) - midht1d(nz-1))
          tavg = (tmplev + temp1d(nz-1))/2.
          prslev = pres1d(nz-1)*
     &             exp(-9.8*(z(nz) - midht1d(nz-1))/(2.*287.*tavg))
          airlev(nz) = prslev/(Rgas*tmplev)
c
c-----Set cloud params
c
          do iz = 1,nz-1
            odcld(iz) = cod(i,j,iz)
            omcld(iz) = 0.9999
            gcld(iz) = 0.85
          enddo
c
c-----Set aerosol params: all are assumed to be applicable at 340 nm.
c     For the default case, use the Elterman profile.
c     If aerosols are run, use PM concentration fields and optical
c       params provided by the chemparam file.
c
          izz = 1
          do 30 k = 1,NELT-1
            do iz = izz,nz-1
              if (midht1d(iz) .lt. float(k)) then
                factr = midht1d(iz) - float(k-1)
                odint = factr*eltod(k+1) + (1. - factr)*eltod(k)
                odaer1(iz) = odint*(z(iz+1) - z(iz))
                omaer1(iz) = 0.90
                gaer(iz) = 0.61
              else
                izz = iz
                goto 30
              endif
            enddo
            goto 31
 30       continue
c
 31       do iz = 1,nz-1
            if (naero.eq.0) then
              odaer2(iz) = odaer1(iz)
              omaer2(iz) = omaer1(iz)
            else
              totext = 0.
              totssa = 0.
              totcon = 0.
              do l = ngas+1,nspc
                rhfac = 1.
                if (rhadj(l).eq.1) rhfac = frh(rh1d(iz))
                totext = totext + bext(l)*rhfac*conc(i,j,iz,l)
                totssa = totssa + ssa(l)*conc(i,j,iz,l)
                totcon = totcon + conc(i,j,iz,l)
              enddo
              odaer2(iz) = totext*(z(iz+1)-z(iz))*1000.
              omaer2(iz) = max(0.20,min(0.99,totssa/totcon))
            endif
          enddo
c
c-----Call the tuv-cloud routine
c
          call tuv(nz,z,airlev,tuvalb,coszen,odcld,omcld,gcld,
     &             odaer1,odaer2,omaer1,omaer2,gaer,rafcld)
c
c-----Load 3-D CLDTRNS array
c
 100      do k = 1,nlay
            cldtrns(i,j,k) = 0.5 * (rafcld(k) + rafcld(k+1))
          enddo
        enddo
      enddo
c$omp end parallel
c
c-----Set boundary to be clear sky
c
      do j = 1,nrow
        do k = 1,nlay
          cldtrns(1,j,k) = 1.
          cldtrns(ncol,j,k) = 1.
        enddo
      enddo 
      do i = 1,ncol
        do k = 1,nlay
          cldtrns(i,1,k) = 1.
          cldtrns(i,nrow,k) = 1.
        enddo
      enddo 
       
      return
      end

      subroutine rdsrfmod(igrd,nox,noy,nsurf,endtim,enddate,
     &                    soilmass,vegiemass)
      use filunit
      use grid
      use chmstry
      use camxcom
      use camxfld
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads a surface model restart file and fills data into
c   the surface mass arrays.  It then writes the header of the new output
c   surface model file.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           igrd      I  grid index
c           nox       I  number of X cells in the grid
c           noy       I  number of Y cells in the grid
c           nsurf     I  number of surface model species
c           endtim    R  Simulation end time (HHMM)
c           enddate   I  Simulation end date (YYJJJ)
c       Outputs:
c           soilmass  R  surface soil mass (mol/ha, g/ha)
c           vegiemass R  surface veg mass (mol/ha, g/ha)
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/14/13   --cemery--    Original development
c     01/05/21   --gwilson--   Added option to write of NCF output files
c     09/08/21   --cemery--    Modified output species names for
c                              consistency with SAT and RTRAC dep output
c     08/21/23   --cemery--    Fixed bugs reading/writing nested grids
c                              (no buffer cells)
c     09/27/23   --cemery--    Added read of NCF restart files
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   igrd
      integer   nox
      integer   noy
      integer   nsurf
      integer   enddate
      real      endtim
      real      soilmass(nox,noy,nsurf)
      real      vegiemass(nox,noy,nsurf)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  spec_units(2*MXSPEC)
      character*20  spec_long_name(2*MXSPEC)
      character*60  spec_desc(2*MXSPEC)
      character*60  spec_coords(2*MXSPEC)
      character*10  this_var, name_in
      character*10  avfil, srfil, cfile, cspec, srfname, srfmodname(2*MXSPEC)
      character*4   ifile(10), note(60), ispec(10), mspec(10,2*MXSMSPC)
      integer       iunit, izero,ione, numxcells, numycells
      integer       isp, i, j, n, nadd
      integer       itzn, nspc, idat1, idat2
      integer       iutm, nx, ny, nz, idum, imod
      integer       itmp, ierr, ilen, this_varid
      integer       ismdate_time_tflag, ismdate_time_etflag, this_tstep
      integer       data_start(4), data_count(4)
      integer       iproj,istag
      real          tim1, tim2, orgx, orgy, plon, plat, dx, dy
      real          t1, t2
      real          dxf, dyf
      real          zero, rdum
c
      real, allocatable :: srfin(:,:)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data avfil /'AVERAGE   '/
      data srfil /'SURFACE   '/
      data izero,ione,zero /0,1,0./
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- initailize to lower bound ---
c
      do isp = 1,nsurf
        do j = 1,noy
          do i = 1,nox
            soilmass(i,j,isp) = 0.
            vegiemass(i,j,isp) = 0.
          enddo
        enddo
      enddo
c
c --- read restart file ---
c
      if (lrstrt) then
        iunit = ismin(igrd)
c
c --- NCF input ---
c
        if (is_netcdf_sm) then
          if (igrd.eq.1) then
            nadd = 0
            nx = nox
            ny = noy
          else
            nadd = 1
            nx = nox - 2
            ny = noy - 2
          endif
          nz = 1
          data_start(1) = 1
          data_count(1) = nx
          data_start(2) = 1
          data_count(2) = ny
          data_start(3) = 1
          data_count(3) = nz
          action = 'Reading the NetCDF surface model restart file.'
          allocate (srfin(nx,ny))
c
c --- get the type of file to make sure it is an average file ---
c
          this_var = 'CAMx_NAME'
          ierr = nf_get_att_text(iunit, NF_GLOBAL, this_var, name_in)
          if( name_in(:7) .NE. srfil(:7) ) goto 7001
c
c --- call routine to make sure grid defintion is consistent ---
c
          if (igrd.eq.1) then
            call ncf_chk_griddef(iunit,action,igrd,.FALSE.,.TRUE.,.FALSE.,
     &                           .FALSE.,itmp)
          else
            call ncf_chk_griddef(iunit,action,igrd,.FALSE.,.TRUE.,.TRUE.,
     &                           .FALSE.,itmp)
          endif
c
c --- call routine to make sure file spans the episode ---
c
          call ncf_chk_tstep(iunit,action,begdate,begtim,begdate,begtim,.FALSE.)
c
c --- get the timestep that encompasses this date/time ---
c
          this_tstep = ncf_get_tstep(iunit,action,begdate,begtim,
     &                 ismdate_time_tflag,ismdate_time_etflag,.FALSE.,.FALSE.)
          data_start(4) = this_tstep
          data_count(4) = 1
c
c --- read the concentrations for each species ---
c
          do isp = 1,nsurf
             srfname = 'S'//smspc(isp)(1:9)
             ilen = istrln(srfname)
             ierr = nf_inq_varid(iunit,srfname(:ilen),this_varid)
             if( ierr .NE. NF_NOERR  ) goto 7002
             ierr = nf_get_vara_real(iunit,this_varid,data_start,data_count,srfin)
             if( ierr .NE. NF_NOERR) goto 7002
             do j = 1,ny
               do i = 1,nx
                 soilmass(i+nadd,j+nadd,isp) = srfin(i,j)
               enddo
             enddo
             srfname = 'V'//smspc(isp)(1:9)
             ilen = istrln(srfname)
             ierr = nf_inq_varid(iunit,srfname(:ilen),this_varid)
             if( ierr .NE. NF_NOERR  ) goto 7002
             ierr = nf_get_vara_real(iunit,this_varid,data_start,data_count,srfin)
             if( ierr .NE. NF_NOERR) goto 7002
             do j = 1,ny
               do i = 1,nx
                 vegiemass(i+nadd,j+nadd,isp) = srfin(i,j)
               enddo
             enddo
          enddo
          write(iout,'(a40,f7.0,i8.5,a,i3)')
     &      'Read NCF surface model file at ',begtim, begdate,' grid',igrd
c
c --- close the input file ---
c
          ierr = nf_close(iunit)
c
c --- Binary input ---
c
        else
c
c --- read 1st input header record and check inputs ---
c
          read(iunit,ERR=7003) ifile,note,itzn,nspc,idat1,tim1,idat2,tim2
          if (INT(tim2) .EQ. 24 ) then
            idat2 = idat2 + 1
            tim2 = 0.
            if( MOD(idat2,1000) .GT. 365 ) then
               if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
                  if( MOD(idat2,1000) .EQ. 367 )
     &                       idat2 = (INT(idat2/1000)+1)*1000 + 1
               else
                  idat2 = (INT(idat2/1000)+1)*1000 + 1
               endif
            endif
          endif
          write(cfile,'(10A1)') (ifile(i),i=1,10)
          if( cfile .NE. avfil ) goto 7004
          tim1 = 100.*tim1
          tim2 = 100.*tim2
          if( idat1 .GT. begdate ) goto 7005
          if( idat1 .EQ. begdate .AND. tim1 .GT. begtim ) goto 7005
c
c --- read 2nd header record and check inputs ---
c
          read(iunit,ERR=7003) plon,plat,iutm,orgx,orgy,dx,dy,nx,ny,nz,
     &                         iproj,istag,t1,t2,rdum
          if( igrd .eq. 1 ) then 
             if (nx .NE. nox .OR. ny .NE. noy .OR. nz .NE. 1 ) goto 7006
             nadd = 0
          endif
          if( igrd .gt. 1 ) then
             if (nx .NE. nox-2 .OR. ny .NE. noy-2 .OR. nz .NE. 1 ) goto 7007
             nadd = 1
          endif
          allocate (srfin(nx,ny))
c
c --- skip the next 2 records ---
c
          read(iunit,ERR=7003)
          read(iunit,ERR=7003) 
c
c --- read the date and time and make sure it is the correct hour ---
c
  111     continue
          read(iunit,ERR=7008,END=7008) idat1, tim1, idat2, tim2
          tim1 = 100*tim1
          tim2 = 100*tim2
          if( INT(tim2) .EQ. 24 ) then
            idat2 = idat2 + 1
            tim2 = 0.
            if( MOD(idat2,1000) .GT. 365 ) then
               if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
                  if( MOD(idat2,1000) .EQ. 367 )
     &                         idat2 = (INT(idat2/1000)+1)*1000 + 1
               else
                  idat2 = (INT(idat2/1000)+1)*1000 + 1
               endif
            endif
          endif
          write(iout,'(a40,f7.0,i8.5,a,i3)')
     &      'Read binary surface model file at ',tim1, idat1,' grid',igrd

          if( (idat1 .LT. begdate .OR. 
     &        (idat1 .EQ. begdate .AND. tim1 .LE. begtim)) .AND.
     &        (idat2 .GT. begdate .OR. 
     &        (idat2 .EQ. begdate .AND. tim2 .GT. begtim))) then
c
c --- read the concentrations for each species ---
c
            call flush(6)
            do 20 isp = 1,nspc
              read(iunit) idum,(ispec(n),n=1,10),
     &                         ((srfin(i,j),i=1,nx),j=1,ny)
              write(cspec,'(10A1)') (ispec(n),n=1,10)
c
c --- find this species in the surface model species list ---
c
              do imod = 1,nsurf
                if( cspec(3:) .EQ. smspc(imod) ) then
                  do j = 1,ny
                    do i = 1,nx
                      if (cspec(1:1) .EQ. 'S') then
                        soilmass(i+nadd,j+nadd,imod) = srfin(i,j)
                      elseif (cspec(1:1) .EQ. 'V') then
                        vegiemass(i+nadd,j+nadd,imod) = srfin(i,j)
                      endif
                    enddo
                  enddo
                  goto 20
                endif
              enddo
              write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
              write(iout,'(A)') 'Species in surface mass file: '
              write(iout,'(A)') cspec(:istrln(cspec))
              write(iout,'(2A)') 'not found in surface model species',
     &                          ' list .. Stopping.'
              call camxerr()
 20         continue
c
c --- if not the right hour, read through it ---
c
          else
            do isp = 1,nspc
              read(iunit,ERR=7008) 
            enddo
            goto 111
          endif
c
c --- close the input file ---
c
          close(iunit)
        endif
        deallocate (srfin)
      endif
c
c --- Write output surface model file headers
c
      idat1 = begdate
      idat2 = enddate
      tim1 = begtim/100.
      tim2 = endtim/100.
      iutm = iuzon
      plon = polelon
      plat = polelat
      t1   = tlat1
      t2   = tlat2
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
      if (igrd.gt.1) then
        dxf  = dx/float(meshold(igrd))
        dyf  = dy/float(meshold(igrd))
        orgx = orgx + dx*(inst1(igrd)-1)
        orgy = orgy + dy*(jnst1(igrd)-1)
        dx = dxf
        dy = dyf
      endif
      if (igrd.eq.1) then
        numxcells = nox
        numycells = noy
      else
        numxcells = nox - 2 
        numycells = noy - 2 
      endif

      read(runmsg(1:60),'(60a1)') (note(n),n=1,60)
      read(avfil,'(10a1)') (ifile(n),n=1,10)
      do isp = 1,nsurf
         mspec(1,isp) = 'S'
         mspec(2,isp) = '_'
         read(smspc(isp)(1:8),'(8A1)') (mspec(i,isp),i=3,10)
         srfmodname(isp) = 'S_'//smspc(isp)(1:8)
      enddo
      do isp = 1,nsurf
         mspec(1,isp+nsurf) = 'V'
         mspec(2,isp+nsurf) = '_'
         read(smspc(isp)(1:8),'(8A1)') (mspec(i,isp+nsurf),i=3,10)
         srfmodname(isp+nsurf) = 'V_'//smspc(isp)(1:8)
      enddo
c
      if( lcdfout) then
         call ncf_set_vars_base()
         call ncf_set_tstep(begdate,begtim,enddate,endtim)
         call ncf_set_specatt_srfmod(spec_units,spec_long_name,spec_desc,
     &                                     spec_coords,2*nsurf,srfmodname)
      endif
      iunit = ismout(igrd)
      if( .NOT. lcdfout ) then
         write(iunit) ifile,note,itzon,2*nsurf,idat1,tim1,idat2,tim2
         write(iunit) plon,plat,iutm,orgx,orgy,dx,dy,numxcells,numycells,
     &             ione,iproj,izero,t1,t2,zero
         write(iunit) ione,ione,numxcells,numycells
         write(iunit) ((mspec(n,isp),n=1,10),isp=1,2*nsurf)
      else
         write(action,'(2A,I2)') 'Writing surface model ',
     &                                    'output file for grid ',igrd
         call ncf_set_global(srfil,igrd,idat1,tim1,idat2,tim2,
     &                                                       ione,2*nsurf)
         call ncf_wrt_dim(action,iunit,igrd,nox,noy,ione,2*nsurf)
         call ncf_wrt_global(action,iunit,2*nsurf,srfmodname,.FALSE.)
         call ncf_wrt_vars_base(action,iunit,igrd)
         call ncf_wrt_vars_species(action,iunit,numxcells,numycells,ione,
     &                    2*nsurf,srfmodname,spec_units,spec_long_name,
     &                                           spec_desc,spec_coords,4)
         call ncf_enddef_file(action,iunit)
         call ncf_wrt_data_grid(action,iunit,igrd,nox,noy,
     &                           orgx,orgy,dx,dy,ione,cellat(iptr2d(igrd)),
     &                                   cellon(iptr2d(igrd)),topo(iptr2d(igrd)))
      endif
 
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'ERROR:  NCF surface mass input file is not ',
     &                   'labelled SURFACE.'
      call camxerr()
c
 7002 write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,*)'Cannot find NCF surfce mass input file species: ',
     &              srfname(:ilen)
      call camxerr()

 7003 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A,i3)')'ERROR: Reading header of binary surface mass',
     &                     ' file for grid: ',igrd
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A)') 'ERROR: Binary surface mass input file is not ',
     &                   'labelled AVERAGE.'
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A)') 'ERROR: Binary surface mass input file is not for ',
     &                                          'correct time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',begdate
      write(iout,'(a,f10.1)') 'Time   : ',begtim
      write(iout,*) '   ***  Surface Model File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A)') 'ERROR: Binary surface mass input file does not',
     &                   ' appear to be for the correct grid.' 
      write(iout,*) '   ***  Grid *** ', igrd
      write(iout,*) 'No. of Cells : (',nox,',',noy,')'
      write(iout,*) 'No. of layers:  ',1
      write(iout,*) '   ***  Surface Model File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A)') 'ERROR: Binary surface mass input file does not',
     &                   ' appear to be for the correct grid.' 
      write(iout,*) '   ***  Grid *** ',igrd
      write(iout,*) 'No. of Cells : (',nox-2,',',noy-2,')'
      write(iout,*) 'No. of layers:  ',1
      write(iout,*) '   ***  Surface Model File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7008 continue
      write(iout,'(//,A)') 'ERROR in RDSRFMOD:'
      write(iout,'(2A)') 'ERROR: Premature end-of-file reached in ',
     &                                  'binary surface mass input file.'
      write(iout,'(2A)') 'Make sure the file contains the correct',
     &                   ' date/time.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

C**** NCF_READAR
c
      subroutine ncf_readar(igrd,ifile,iunit,ncol,nrow,nlay,nlay_ems,
     &                                                aremis,numspcs)
      use chmstry
      use camxcom
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_READAR reads the NetCDF gridded emissions file for 
c     the given grid and loads the data into global arrays for emissions
c     injection.
c
c      Copyright Ramboll
c
c     Input arguments:
c        igrd             grid index
c        ifile            index of file in list for this grid
c        ncol             number of columns
c        nrow             number of rows
c        nlay             number of layers in grid
c        nlay_ems         number of layers in emissions foles
c        iunit            file unit for area emissions file
c        numspcs          number of model species
c
c     Output arguments:
c        aremis              area emissions rate (mole/s)
c
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'vbs.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ifile 
      integer iunit
      integer ncol
      integer nrow
      integer nlay
      integer nlay_ems
      integer numspcs
      real    aremis(ncol,nrow,nlay_ems,numspcs)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  this_var
      integer       this_tstep, ierr, nlays_in, ispc, i, j, k, l, ibin
      integer       this_varid, data_start(4), data_count(4)
      integer       this_time_tflag, this_time_etflag, this_dimid
      integer       buffer_offset, itmp, jtmp, isoa, idx_poa, this_idx
c
      real, allocatable, dimension(:,:,:)   ::  argrid
      real, allocatable, dimension(:,:,:,:) ::  poa_em

c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set offset based on buffer or no buffer ---
c
      buffer_offset = buffer_offset_iarem(igrd,ifile)
c
      if( .NOT. is_netcdf_iarem(igrd,ifile) ) goto 9999
      write(action,'(2A,I3,A,I3)') 'Reading the NetCDF ',
     &                              'gridded emissions file. Grid: ',
     &                                           igrd,' File: ',ifile
c
c  ---- get the index for timestep containing this time ----
c
      this_tstep = ncf_get_tstep(iunit,action,date,time,
     &              this_time_tflag,this_time_etflag,le1day,.TRUE.)
c
c   ---- get the number of layers in this file ---
c
c  --- get the id for the layer dimension ---
c
      ierr = nf_inq_dimid(iunit, "LAY", this_dimid  )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_inq_dimlen(iunit,this_dimid,nlays_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
c  ---- allocate the temporary array ---
c
      allocate( argrid(ncol-2*buffer_offset,nrow-2*buffer_offset,nlays_in) )
      allocate( poa_em(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB,ncol,nrow,nlays_in) )
      poa_em = 0.0
c
c   --- if number of layers is not 1 make sure it matches grid ---
c
      if( nlays_in .NE. 1 .AND. nlays_in .NE. nlay ) goto 7002
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol-2*buffer_offset
      data_start(2) = 1
      data_count(2) = nrow-2*buffer_offset
      data_start(3) = 1
      data_count(3) = nlays_in
      data_start(4) = this_tstep
      data_count(4) = 1
      idx_poa = 0
      if( luse_soap3 ) then
         do ispc=1,nemspc
           if( emspcname(ispc) .EQ. soap_emiss_names(IDX_SOAP_POA_AV) ) then
             idx_poa = ispc
           endif 
         enddo
      endif
c
c  ---- loop over the list of emissions spcies ---
c
      do ispc=1,nemspc
          argrid = 0.
c
c  --- load data into temporary arrray ---
c
          this_var = emspcname(ispc)
          ierr = nf_inq_varid(iunit, this_var, this_varid)
          if( ierr .NE. NF_NOERR) cycle
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                               data_count,argrid)
          if( ierr .NE. NF_NOERR) goto 7001
          this_idx = ispc
          if( idx_poa .GT. 0 .AND. this_var(1:4) .EQ. 'POA ') then
             this_idx = idx_poa 
          endif 
c
c-----Put the data into the global array, if buffer cells are not
c     in file make edge cells same as neigboring cell ----
c
          do k=1,nlays_in
             do j=1+buffer_offset,nrow-buffer_offset
                jtmp = j-buffer_offset
                do i=1+buffer_offset,ncol-buffer_offset
                   itmp = i-buffer_offset
                   if (argrid(itmp,jtmp,k).lt.0.) then
                     write(iout,'(//,a)') 'ERROR in NCF_READAR:'
                     write(iout,'(A)') action(:istrln(action))
                     write(iout,'(a)') 'Negative emissions read.'
                     write(iout,'(a,3i3,a,i3)') 'Cell (i,j,k): ',
     &                           i+buffer_offset,j+buffer_offset,k,' Species: ',ispc
                     call camxerr()
                   endif
                   aremis(i,j,k,this_idx) = aremis(i,j,k,this_idx) + 
     &                                              argrid(itmp,jtmp,k)/(60.*dtems) 
                enddo
             enddo
          enddo
      enddo
c
c ---- handle VBS as special case ---
c
      if( lvbs .AND. LVBSPREPROC ) then
          do isoa=1,IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
             this_var = soap_emiss_names(isoa)
             ierr = nf_inq_varid(iunit, this_var, this_varid)
             if( ierr .EQ. NF_NOERR) then
                ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                             data_count,argrid)
                if( ierr .NE. NF_NOERR) goto 7001
                do k=1,nlays_in
                   do j=1+buffer_offset,nrow-buffer_offset
                      jtmp = j-buffer_offset
                      do i=1+buffer_offset,ncol-buffer_offset
                         itmp = i-buffer_offset
                            if (argrid(i,j,k).lt.0.) then
                           write(iout,'(//,a)') 'ERROR in NCF_READAR:'
                           write(iout,'(A)') action(:istrln(action))
                           write(iout,'(a)') 'Negative emissions read.'
                           write(iout,'(a,3i3,a,i3)') 'Cell (i,j,k): ',
     &                        i+buffer_offset,j+buffer_offset,k,' Species: ',ispc
                           call camxerr()
                         endif
                         poa_em(isoa,i,j,k) = argrid(itmp,jtmp,k)
                      enddo
                   enddo
                enddo
             endif
          enddo
c
          do ibin= 0,NVOLBIN
            do ispc=1,nemspc
               if( emspcname(ispc) .EQ. spname(kpap_c(ibin)) ) then
                  aremis(:,:,:,ispc) = aremis(:,:,:,ispc) +
     &                       ( poa_em(IDX_SOAP_POA_OP,:,:,:) * poa_op_ef(ibin)
     &                       + poa_em(IDX_SOAP_POA_GV,:,:,:) * poa_gv_ef(ibin)
     &                       + poa_em(IDX_SOAP_POA_DV,:,:,:) * poa_dv_ef(ibin) ) /
     &                                              (60.*dtems)
              endif
              if( emspcname(ispc) .EQ. spname(kpcp_c(ibin)) ) then
                     aremis(:,:,:,ispc) = aremis(:,:,:,ispc) +
     &                      ( poa_em(IDX_SOAP_POA_MC,:,:,:) * poa_mc_ef(ibin)  ) /
     &                                              (60.*dtems)
              endif
              if( emspcname(ispc) .EQ. spname(kpfp_c(ibin)) ) then
                aremis(:,:,:,ispc) = aremis(:,:,:,ispc) +
     &                      ( poa_em(IDX_SOAP_POA_BB,:,:,:) * poa_bb_ef(ibin) ) /
     &                                              (60.*dtems)
              endif
           enddo
         enddo
c
      endif
c
c  ---- deallocate the temporary array ---
c
      deallocate( argrid )
      deallocate( poa_em )
c
c  ---- write message to out file ---
c
      write(iout,'(a35,i5,a,f7.0,i8.5)') 'Read area source file ',
     &                                         ifile,' at ',time,date
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READAR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for layer dimension.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READAR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_READAR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Number of layers does not match: '
      write(iout,'(A,I4)') 'User supplied: ',nlay
      write(iout,'(A,I4)') 'Value in file: ',nlays_in
      call camxerr()
c
 9999 continue
      return
      end

**** READPTSA
c
      subroutine readptsa(idate,btim)
      use filunit
      use grid
      use camxcom
      use ptemiss
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions from each of the elevated
c   emissions files and calculates the emissions levels.  It then
c   places these emissions in the appropriate place in the point source
c   array used for tracer emissions.  The tracer to which the emissions
c   is assigned depends on the source group and the source region.
c
c      Copyright Ramboll
c
c     Inputs:
c          idate  I  date of current hour (YYJJJ)
c          btim   R  time of current hour
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/06/96   --gwilson--    Original development
c     12/10/96   --gwilson--    Added switch to skip emissions if PiG
c     02/01/97   --gwilson--    Put fuzz factor of 0.1 ppb to catch if
c                               emissions of leftover group is negative.
c     02/03/97   --gwilson--    Put code to ignore emissions on boundary.
c     01/20/99   --cemery---    Grid cell size from file should be meters
c                               for all cartesian projections (UTM, LCP,
c                               PSP)
c     11/06/01   --cemery--     Input dates are now Julian
c     07/19/02   --gwilson--    Added seperate source area map for each grids.
c     03/01/16   --gwilson--    Added partial source area map
c     01/17/22   --gwilson--    Added conditional to bypass overrided 
c                               check when using only 1 region
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c   FUZZ   R    fuzz factor used to determine if emissions are truly < 0
c
      real   FUZZ
c
      parameter( FUZZ = -0.0001 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      integer imap, i, j, ii, jj, ipart, idxbase
      integer ndate, icel, jcel, num_ptsfiles, isoa
      real    xloctmp, yloctmp, ttime, frac, xloccrs, yloccrs
      logical is_netcdf_file
c
      integer, allocatable, dimension(:)   :: izcel
      real,    allocatable, dimension(:,:) :: lefcls
      real,    allocatable, dimension(:,:) :: emscls
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   ---- allocate the large local arrays ---
c
      allocate( izcel(MXPTSRC) )
      izcel = 0
      allocate( lefcls(MXTRCLS,MXPTSRC) )
      allocate( emscls(MXTRCLS,MXPTSRC) )
c
c   --- set the date and times ---
c
      ndate = idate
      ttime = btim/100.0
c
c   --- initialize emissions to zero ---
c
      do i=1,nptsrc
         do j=1,nsaspc
            sapnts(i,j) = 0.
         enddo
      enddo
c
c  --- loop over groups ---
c
      do igroup = 1,ngroup
         num_ptsfiles = num_iortpt(igroup)
         do idxfile=1,num_ptsfiles
c
c   --- initialize emissions to zero ---
c
            do i=1,nptsrc
               do j=1,soap3_ntrcls
                  emscls(j,i) = 0. 
               enddo
            enddo
c
c   --- set the file name for elevated points emissions file ---
c
            is_netcdf_file = .FALSE. 
            if( igroup .EQ. 0 ) then
                write(fname,'(A,I3)') 'PTSOURCE -- UNIT ',iptem(idxfile)
                if( is_netcdf_iptem(idxfile) ) is_netcdf_file = .TRUE.
            else
                fname = tptfil(igroup,idxfile)
                if( is_netcdf_iortpt(igroup,idxfile) ) is_netcdf_file = .TRUE.
            endif
c
c  --- for each group, call routine to read the emissions for
c      the group ----
c
            if( is_netcdf_file ) then
               call ncf_rdptgrp(igroup,emscls,izcel)
            else
               call rdptgrp(ndate,ttime*100.,igroup,emscls,izcel)
            endif
c
c  --- if doing source groups calculate the 
c      left-over and put emissions into proper place in the emissions
c      array ---
c
            if( ngroup .GT. 0 ) then
               do 10 i=1,nptsrc
c
c  --- find index into the master list ---
c
                  idxbase = i
c
c  --- get the region for this cell from mapping array ----
c
                  if( .NOT.llatlon ) then
                     icel = FLOOR( (xlocpt(idxbase)/1000. - xorg) / delx ) + 1
                     jcel = FLOOR( (ylocpt(idxbase)/1000. - yorg) / dely ) + 1
                     xloccrs = xlocpt(idxbase)/1000. - xorg
                     yloccrs = ylocpt(idxbase)/1000. - yorg
                  else
                     icel = FLOOR( (xlocpt(idxbase) - xorg) / delx ) + 1
                     jcel = FLOOR( (ylocpt(idxbase) - yorg) / dely ) + 1
                     xloccrs = xlocpt(idxbase) - xorg
                     yloccrs = ylocpt(idxbase) - yorg
                  endif
                  if(icel .LE. 0 .OR. icel .GT. ncol(1)) goto 10
                  if(jcel .LE. 0 .OR. jcel .GT. nrow(1)) goto 10
c
c   --- find out if a nest contains this source  ---
c
                  igrd = 1
                  do ig = 2,ngrid
                    xloctmp = xloccrs - (inst1(ig)-1)*delx
                    yloctmp = yloccrs - (jnst1(ig)-1)*dely
                    if( xloctmp .GT. 0. .AND. yloctmp .GT. 0. ) then
                       ii = 2 + FLOOR( xloctmp/delx * FLOAT( meshold(ig) ))
                       jj = 2 + FLOOR( yloctmp/dely * FLOAT( meshold(ig) ))
                       if( ii .GT. 1 .AND. jj .GT. 1 .AND. ii .LT. ncol(ig)
     &                                    .AND. jj .LT. nrow(ig) ) then
                          igrd = ig
                          icel = ii
                          jcel = jj
                       endif
                    endif
                  enddo
                  imap = igrmap(0,1,igrd,icel,jcel)
                  frac = frcmap(0,1,igrd,icel,jcel)
                  if( nregin .GT. 1 .AND. izcel(idxbase) .LT. 0 ) then
                     if( .NOT. lptoverride ) then
                        write(iout,'(//,a)') 'ERROR in READPTSA:'
                        write(iout,'(/,1X,2A )') 'A source was read that has the point ',
     &                      'source override trigger turned on.'
                        write(iout,'(1X,2A)') 'If you intend to use point source ',
     &                     'override please set the namelist variable'
                        write(iout,'(1X,2A)') 'SA_PT_Override to TRUE in the CAMx_Control namelist.'
                        write(iout,'(1X,2A)') 'If you do not want point source override ',
     &                         'you need to set the kcell variable '
                        write(iout,'(1X,2A)') 'in your point source file to zero.'
                        call camxerr()
                     endif
                     imap = ABS( izcel(idxbase) )
                  endif
                  if( (imap .LE. 0 .AND. frac .GT. 0.) .OR. imap .GT. nregin ) then
                     write(iout,'(//,a)') 'ERROR in READPTSA:'
                     write(iout,'(/,1X,3A)') 'Invalid region found in',
     &                           ' point source override when reading ',
     &                                              'point source file.'
                     write(iout,'(1X,A,I4)') 'Region code      : ',imap
                     write(iout,'(1X,A,I4)') 'Number of regions: ',nregin
                     write(iout,'(10X,A,/,A)') 'Point source filename: ',
     &                                             fname(:istrln(fname))
                     write(iout,'(1X,2A)') 'Check the values in the ',
     &                                           'point source overide.'
                     call camxerr()
                  endif
c
c  --- calculate the leftover emissions to use in last source group ---
c
                  do icls=1,ntrcls
                     if( igroup .EQ. 0 ) then
                         lefcls(icls,idxbase) = emscls(icls,idxbase)
                     else
                         lefcls(icls,idxbase) = 
     &                         lefcls(icls,idxbase) - emscls(icls,idxbase)
c
c  --- put emissions into position in gridded tracer emissions array ---
c
                         ipos = iemcls(icls) - 1 + imap + (igroup-1)*nregin
                         sapnts(idxbase,ipos) = emscls(icls,idxbase) * frac
                     endif
                  enddo
                  if( luse_soap3 .AND. lsoa ) then
                     do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                        iclass = ntrcls + isoa - IDX_SOAP_POA_OP + 1
                        if( igroup .EQ. 0 ) then
                            lefcls(iclass,idxbase) = emscls(iclass,idxbase)
                        else
                            lefcls(iclass,idxbase) = 
     &                         lefcls(iclass,idxbase) - emscls(iclass,idxbase)
c
c  --- put emissions into position in gridded tracer emissions array ---
c
                            ipos = soap3_iemcls(isoa) - 1 + imap + (igroup-1)*nregin
                            sapnts(idxbase,ipos) = emscls(iclass,idxbase) * frac
                        endif
                     enddo
                  endif
c
c  --- next point source ----
c
   10         continue
c
c  --- only one group, just load emissions into arrays from
c      position 0 in gridded array ----
c
            else
               do 20 i=1,nptsrc
c
c  --- find index into the master list ---
c
                  idxbase = idx_point_in_list(igroup,idxfile,i)
                  if( idxbase .LT. 0 ) goto 20
c
c  --- get the region for this cell from mapping array ----
c
                  if( .NOT.llatlon ) then
                     icel = FLOOR( (xlocpt(idxbase)/1000. - xorg) / delx ) + 1
                     jcel = FLOOR( (ylocpt(idxbase)/1000. - yorg) / dely ) + 1
                     xloctmp = xlocpt(idxbase)/1000. - xorg
                     yloctmp = ylocpt(idxbase)/1000. - yorg
                  else
                     icel = FLOOR( (xlocpt(idxbase) - xorg) / delx ) + 1
                     jcel = FLOOR( (ylocpt(idxbase) - yorg) / dely ) + 1
                     xloctmp = xlocpt(idxbase) - xorg
                     yloctmp = ylocpt(idxbase) - yorg
                  endif
                  if(icel .LE. 0 .OR. icel .GT. ncol(1)) goto 20
                  if(jcel .LE. 0 .OR. jcel .GT. nrow(1)) goto 20
c
c   --- find out if a nest contains this source  ---
c
                  igrd = 1
                  do ig = 2,ngrid
                    xloctmp = xloctmp - (inst1(ig)-1)*delx
                    yloctmp = yloctmp - (jnst1(ig)-1)*dely
                    ii = 2 + FLOOR( xloctmp/delx * FLOAT( meshold(ig) ) )
                    jj = 2 + FLOOR( yloctmp/dely * FLOAT( meshold(ig) ) )
                    if( ii .GT. 1 .AND. jj .GT. 1 .AND. 
     &                      ii .LT. ncol(ig) .AND. jj .LT. nrow(ig) ) then
                       igrd = ig
                       icel = ii
                       jcel = jj
                     endif
                  enddo
                  imap = igrmap(0,1,igrd,icel,jcel)
                  frac = frcmap(0,1,igrd,icel,jcel)
                  if( nregin .GT. 1 .AND. izcel(idxbase) .LT. 0 ) then
                     if( .NOT. lptoverride ) then
                        write(iout,'(//,a)') 'ERROR in READPTSA:'
                        write(iout,'(/,1X,2A )') 'A source was read that has the point ',
     &                   'source override trigger turned on.'
                        write(iout,'(1X,2A)') 'If you intend to use point source ',
     &                     'override please set the namelist variable'
                        write(iout,'(1X,2A)') 'SA_PT_Override to TRUE in the CAMx_Control namelist.'
                        write(iout,'(1X,2A)') 'If you do not want point source override ',
     &                         'you need to set the kcell variable '
                        write(iout,'(1X,2A)') 'in your point source file to zero.'
                        call camxerr()
                     endif
                     imap = ABS( izcel(idxbase) )
                  endif
                  if( (imap .LE. 0 .AND. frac .GT. 0) .OR. imap .GT. nregin ) then
                     write(iout,'(//,a)') 'ERROR in READPTSA:'
                     write(iout,'(/,1X,A,A,I4)') 'Invalid region found in',
     &                           ' point source override when reading ',
     &                                              'point source file.'
                     write(iout,'(1X,A,I4)') 'Region code      : ',imap
                     write(iout,'(1X,A,I4)') 'Number of regions: ',nregin
                     write(iout,'(10X,A,/,A)') 'Point source filename: ',
     &                                             fname(:istrln(fname))
                     write(iout,'(1X,2A)') 'Check the values in the ',
     &                                           'point source overide.'
                     call camxerr()
                  endif
c
c   --- put emissions in array at correct offset ---
c
                  do icls=1,soap3_ntrcls
                     ipos = iemcls(icls) - 1 + imap
                     sapnts(idxbase,ipos) = emscls(icls,idxbase) * frac
                  enddo
c
c  --- next point source ----
c
   20          continue
            endif
c
c  --- get emissions file from the next group ----
c
          enddo
      enddo
c
c   ---- deallocate the large local arrays ---
c
      deallocate( izcel  )
      deallocate( lefcls )
      deallocate( emscls )
c
c  --- all files read ---
c
      return
      end

C**** WALK1PUF
c
      subroutine walk1puf(dt,igrd,nx,ny,nz,iipig,jjpig,ingrd,lkick,
     &                    xpig,ypig,pufftop,puffbot,windu,windv,
     &                    height,press,tempk)
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c     WALK1PUF calculates a new puff location by integrating dx/u(x) = dt
c     where u(x) = u(i-1) + (u(i) - u(i-1))*(x/deltax).  Each puff is
c     transported the entire dt or to the nearest cell interface,
c     whichever occurs first.
c
c      Copyright Ramboll
c
c     Modifications:
c        9/5/03              Modified to handle "chained" puff approach
c       6/14/10              Fix to alleviate occasional trapping of puffs
c                            at nested grid boundaries with converging winds.
c      10/29/20              Adjustments for single-precision error in
c                            puff position outside of (iipig,jjpig) cell
c
c     Input arguments:
c        dt                  remaining timestep (s)
c        igrd                grid index
c        nx                  number of cells in x-direction
c        ny                  number of cells in y-direction
c        nz                  number of layers
c        iipig               i-cell index of puff location 
c        jjpig               j-cell index of puff location 
c        ingrd               grid index of puff location
c        lkick               kick flag for too many iterations
c        xpig                x-coord of puff location (km or deg)
c        ypig                y-coord of puff location (km or deg)
c        pufftop             puff top height (m)
c        puffbot             puff bottom height (m)
c        windu               gridded wind speed in x-direction (m/s)
c        windv               gridded wind speed in y-direction (m/s)
c        height              gridded layer height (m)
c        press               gridded pressure (mb)
c        tempk               gridded temperature (K)
c
c     Output arguments:
c        dt                  remaining timestep (s)
c        xpig                x-coord of puff location (km or deg)
c        ypig                y-coord of puff location (km or deg)
c        iipig               i-cell index of puff location 
c        jjpig               j-cell index of puff location 
c        ingrd               grid index of puff location
c
c     Subroutines Called:
c        PIGCOORD
c
c     Called by:
c        PIGWALK
c
      include "camx.prm"
c
      integer igrd,nx,ny,nz,iipig,jjpig,ingrd
      real windu(nx,ny,nz),windv(nx,ny,nz),height(nx,ny,nz),
     &     press(nx,ny,nz),tempk(nx,ny,nz)
      real dt,wedge,sedge,xcell,xcell0,ycell,ycell0,ax,bx,ay,by,
     &     dtx,dty,dttmp,xpig,ypig,uup,uum,vvp,vvm,
     &     pufftop,puffbot,sumwt,deplyr
      integer iedge,i,j,kk,kpb,kpt
      logical lkick
c
      real wtfac(MXLAYER)
c 
c-----Entry point
c
      iedge = 0
c
c-----Find layers containing top and bottom of puff
c
      i = iipig
      j = jjpig
      kpb = 1
      kpt = nlay(igrd)
      do kk = 1,nlay(igrd)
        if (height(i,j,kk) .GE. pufftop) then
          kpt = kk
          goto 26
        endif
      enddo
  26  continue
      do kk = nlay(igrd),1,-1
        if (height(i,j,kk) .LE. puffbot) then
          kpb = kk + 1
          goto 27
        endif
      enddo
 27   continue
c
c-----Determine layer density-weighted u,v wind components over puff depth
c
      if (kpb.eq.kpt) then
        wtfac(kpb) = 1.
      else
        sumwt = 0.
        deplyr = pufftop - height(i,j,kpt-1)
        wtfac(kpt) = deplyr*press(i,j,kpt)/tempk(i,j,kpt)
        sumwt = sumwt + wtfac(kpt)
c
        deplyr = height(i,j,kpb) - puffbot
        wtfac(kpb) = deplyr*press(i,j,kpb)/tempk(i,j,kpb)
        sumwt = sumwt + wtfac(kpb)
c
        do kk = kpb+1,kpt-1
          deplyr = height(i,j,kk) - height(i,j,kk-1)
          wtfac(kk) = deplyr*press(i,j,kk)/tempk(i,j,kk)
          sumwt = sumwt + wtfac(kk)
        enddo
c
        do kk = kpb,kpt
          wtfac(kk) = wtfac(kk)/sumwt
        enddo
      endif
c
      uup = 0.
      uum = 0.
      vvp = 0.
      vvm = 0.
      do kk = kpb,kpt
        uup = uup + wtfac(kk)*windu(i,j,kk)
        uum = uum + wtfac(kk)*windu(i-1,j,kk)
        vvp = vvp + wtfac(kk)*windv(i,j,kk)
        vvm = vvm + wtfac(kk)*windv(i,j-1,kk)
      enddo
c
c-----Calculate puff distance from West/South cell edge
c
      if (igrd.eq.1) then
        wedge = (i - 1)*delx
        sedge = (j - 1)*dely
      else
        wedge = (inst1(igrd) - 1)*delx + (i - 2)*delx/meshold(igrd)
        sedge = (jnst1(igrd) - 1)*dely + (j - 2)*dely/meshold(igrd)
      endif
      xcell0 = (xpig - wedge)/delx*deltax(j,igrd)*meshold(igrd)
      ycell0 = (ypig - sedge)/dely*deltay(igrd)*meshold(igrd)

      xcell0 = min( max(xcell0,deltax(j,igrd)*0.001),deltax(j,igrd)*0.999 )
      ycell0 = min( max(ycell0,deltay(igrd)*0.001),deltay(igrd)*0.999 )
c
c-----Compute the new position after the whole time step
c
      ax = uum
      bx = (uup - uum)/deltax(j,igrd)
      if (abs(bx).lt.1.e-4) then
        ax = ax + bx*xcell0
        xcell = xcell0 + ax*dt
      else
        xcell = (-ax + (ax + bx*xcell0)*exp(bx*dt))/bx
      endif
c
      ay = vvm
      by = (vvp - vvm)/deltay(igrd)
      if (abs(by).lt.1.e-4) then
        ay = ay + by*ycell0
        ycell = ycell0 + ay*dt
      else
        ycell = (-ay + (ay + by*ycell0)*exp(by*dt))/by
      endif
c
c-----If the new position is beyond the boundaries of cell, compute
c     the time needed to reach the boundary (+ some fuzz)
c
      dtx = dt
      dty = dt
      if (xcell.gt.deltax(j,igrd)) then
        iedge = 1
        if (abs(bx).lt.1.e-4) then
          dtx = (deltax(j,igrd)*1.001 - xcell0)/ax
        else
          dtx = alog((ax + bx*deltax(j,igrd)*1.001)/(ax + bx*xcell0))/bx
        endif
      elseif (xcell.lt.0.) then
        iedge = 1
        if (abs(bx).lt.1.e-4) then
          dtx = (-deltax(j,igrd)*0.001 - xcell0)/ax
        else
          dtx = alog((ax - bx*deltax(j,igrd)*0.001)/(ax + bx*xcell0))/bx
        endif
      endif
      if (ycell.gt.deltay(igrd)) then
        iedge = 1
        if (abs(by).lt.1.e-4) then
          dty = (deltay(igrd)*1.001 - ycell0)/ay
        else
          dty = alog((ay + by*deltay(igrd)*1.001)/(ay + by*ycell0))/by
        endif
      elseif (ycell.lt.0.) then
        iedge = 1
        if (abs(by).lt.1.e-4) then
          dty = (-deltay(igrd)*0.001 - ycell0)/ay
        else
          dty = alog((ay - by*deltay(igrd)*0.001)/(ay + by*ycell0))/by
        endif
      endif
c
c-----If the puff reaches a boundary, compute the remaining time and new
c     position
c
      if (iedge.eq.1) then
        if (lkick) then
          dttmp = dt
          if (dtx.lt.dt) then
            ax = 0.
            bx = 0.
          endif
          if (dty.lt.dt) then
            ay = 0.
            by = 0.
          endif
        else
          dttmp = amin1(dtx,dty,dt)
        endif
        if (abs(bx).lt.1.e-4) then
          xcell = xcell0 + ax*dttmp
        else
          xcell = (-ax + (ax + bx*xcell0)*exp(bx*dttmp))/bx
        endif
        if (abs(by).lt.1.e-4) then
          ycell = ycell0 + ay*dttmp
        else
          ycell = (-ay + (ay + by*ycell0)*exp(by*dttmp))/by
        endif
        dt = dt - dttmp
      else
        dt = 0.
      endif
      xpig = wedge + xcell/deltax(j,igrd)*delx/meshold(igrd)
      ypig = sedge + ycell/deltay(igrd)*dely/meshold(igrd)
c
c-----Compute new ingrd, iipig, jjpig
c
      call pigcoord(xpig,ypig,iipig,jjpig,ingrd)
      if (ingrd.eq.0) dt = 0.
c
      return
      end

      subroutine nodes_topc(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes all of the data that is time-step
c        dependent to the compute nodes when in MPI mode.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numprocs            the number of processes
c        iproc_id            processes number of current process
c     Output:  
c
c    Called by:
c       BNDRY_UPDT
c    Subroutines called:
c       NODE_RECV_1SPECIES_DATA
c       MASTER_SEND_1SPECIES_DATA
c       NODES_PASS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     11/28/16   --bkoo--       Updated DDM for new top con
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: mvec2d
      integer :: mvecem
      integer :: ispc
      integer :: i
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.not. lmpi .and. iproc_id .gt. 0) return
c
c   --- calculate the number of bytes to send ---
c
      mvec2d = 0
      do i=1,ngrid
         mvec2d = mvec2d + nrow(i) * ncol(i)
      enddo
      mvecem = mvec2d * nspec
c
c  --- pass the fields that are dimensioned by mvecem ---
c
      do i=1,ngrid
         do ispc=1,nspec
            if (iproc_id .gt. 0) then
               call node_recv_1species_data  (ctop(iptr1lay(i)),i,
     &                                        1,1,nspec,ispc,itag )
            else
               call master_send_1species_data(ctop(iptr1lay(i)),i,
     &                                        1,1,nspec,ispc,itag )
            endif
            itag = itag + 1
         enddo
      enddo
c
c  --- If doing the probing tools, pass those fields ---
c
      if ( lddm .OR. lhddm ) then
         do i=1,ngrid
            do ispc=1,ntotsp
               if (iproc_id .gt. 0) then
                  call node_recv_1species_data  (pttop(ipsa2d(i)),i,
     &                                           1,1,ntotsp,ispc,itag)
               else
                  call master_send_1species_data(pttop(ipsa2d(i)),i,
     &                                           1,1,ntotsp,ispc,itag)
               endif
               itag = itag + 1
            enddo
         enddo
      endif
c
      end

c*** PIGDUMPSA
c
      subroutine pigdumpsa(ncolx,nrowy,nlays,nrad,nspc,ntrac,
     &                     icell,jcell,kclbeg,kclend,idxpig,
     &                     delconc,saconc)
      use grid
      use pigsty
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine puts the mass from the PiG into the tracer
c     concentration array.  The mass is added to the tracer species
c     from the region/group from which the PiG originated.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       ncolx   I  number of columns
c       nrowy   I  number of rows
c       nlays   I  number of layers
c       nrad    I  number of radical species
c       nspc    I  number of model species
c       ntrac   I  number of tracers
c       icell   I  the X grid location of current cell
c       jcell   I  the X grid location of current cell
c       kclbeg  I  the bottom vertical layer in the affected column
c       kclend  I  the top vertical layer in the affected column
c       idxpig  I  the index of the puff in PiG arrays
c       delconc R  change in model concentrations 
c       saconc  R  gridded array of tracer concentrations
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c       12/08/96  --gwilson--   Original development
c       11/10/97  --gwilson--   Removed unused argument: IGRID
c       08/25/05  --cemery--    Revamped to use puff-specific source 
c                               region/group pointers
c       02/10/16  --bkoo--      Updated for OSAT3
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   ncolx
      integer   nrowy
      integer   nlays
      integer   nrad
      integer   nspc
      integer   ntrac
      integer   icell
      integer   jcell
      integer   kclbeg
      integer   kclend
      integer   idxpig
      real      delconc(MXLAYER,MXSPEC+1)
      real      saconc(ncolx,nrowy,nlays,ntrac)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icls, ispc, itrc, i, kcel
      integer iOO, iO3
      real    delcls(MXALCLS)
      real    sumcls
      real    sumO3, sumOO, prodOO, destOO, OOtoO3
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- loop over all layers in the affected column ---
c  
      do kcel = kclbeg, kclend
c
c  --- get concentration change for model species of each tracer class
c
         do icls = 1, ntrcls
            delcls(icls) = 0.
            do ispc = nrad+1, nspc
               delcls(icls) = delcls(icls)
     &                      + delconc(kcel,ispc) * fluxmap(ispc,icls)
            enddo
         enddo
c
c  --- update O3 & OO tracers
c
         if ( lozone ) then

            sumO3 = 0.
            do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
               sumO3 = sumO3 + saconc(icell,jcell,kcel,i)
            enddo
            sumO3 = MAX(BNDLPT, sumO3)

            sumOO = 0.
            do i = iptcls(idxipt(ITROON)), nptcls(idxipt(ITROOV))
               sumOO = sumOO + saconc(icell,jcell,kcel,i)
            enddo
            sumOO = MAX(BNDLPT, sumOO)

            prodOO = MAX( 0.,  delcls(idxipt(ITRRGN)) )
            destOO = MAX( 0., -delcls(idxipt(ITRRGN)) )

            if ( delcls(idxipt(ITRO3V)) .GT. 0. ) then
c
c  --- this is not supposed to happen, but just in case ...
c
c  --- allocate O3 from NO2 destruction based on relative contribution of OOX
c
               OOtoO3 = MIN( destOO, delcls(idxipt(ITRO3V)) )

               iOO = iptcls(idxipt(ITROON)) - 1
               do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
                  iOO = iOO + 1
                  saconc(icell,jcell,kcel,i) = saconc(icell,jcell,kcel,i)
     &                  + OOtoO3 * saconc(icell,jcell,kcel,iOO) / sumOO
               enddo
c
c  --- allocate any remaining O3 increase to O3V of this plume
c
               itrc = iemcls(idxipt(ITRO3V)) - 1 + 
     &                       ipufmap(idxpig) + ipufgrp(idxpig) * nregin

               saconc(icell,jcell,kcel,itrc) = saconc(icell,jcell,kcel,itrc)
     &                                + delcls(idxipt(ITRO3V)) - OOtoO3
            else
c
c  --- allocate O3 decrease based on relative contribution of O3X
c
               do i = iptcls(idxipt(ITRO3N)), nptcls(idxipt(ITRO3V))
                  saconc(icell,jcell,kcel,i) = saconc(icell,jcell,kcel,i)
     &                             + delcls(idxipt(ITRO3V))
     &                             * saconc(icell,jcell,kcel,i) / sumO3
                  saconc(icell,jcell,kcel,i) =
     &                          MAX(BNDLPT, saconc(icell,jcell,kcel,i))
               enddo
            endif
c
c  --- allocate OO increase based on relative contribution of O3X
c           and OO decrease based on relative contribution of OOX
c
            iO3 = iptcls(idxipt(ITRO3N)) - 1
            do i = iptcls(idxipt(ITROON)), nptcls(idxipt(ITROOV))
               iO3 = iO3 + 1
               saconc(icell,jcell,kcel,i) = saconc(icell,jcell,kcel,i)
     &                  + prodOO * saconc(icell,jcell,kcel,iO3) / sumO3
     &                    - destOO * saconc(icell,jcell,kcel,i) / sumOO
               saconc(icell,jcell,kcel,i) =
     &                          MAX(BNDLPT, saconc(icell,jcell,kcel,i))
            enddo
c
c  --- reset the conc change for the tracers already processed so that they will be skipped below
c
            delcls(idxipt(ITRO3N)) = 0.
            delcls(idxipt(ITRO3V)) = 0.
            delcls(idxipt(ITROON)) = 0.
            delcls(idxipt(ITROOV)) = 0.
         endif
c
c  --- loop over all tracer classes
c
         do icls = 1, ntrcls
c
c  --- skip if no change or already processed
c
            if ( ABS(delcls(icls)) .LT. BNDLPT ) CYCLE
c
c  --- for all other tracers
c
            if ( delcls(icls) .GT. 0. ) then
c
c  --- if positive change, allocate it to this plume
c
               itrc = iemcls(icls) - 1 + 
     &                       ipufmap(idxpig) + ipufgrp(idxpig) * nregin

               saconc(icell,jcell,kcel,itrc) = saconc(icell,jcell,kcel,itrc)
     &                                       + delcls(icls)
            else
c
c  --- if negative change, reduce the tracer based on its relative contribution
c
               sumcls = 0.
               do i = iptcls(icls), nptcls(icls)
                  sumcls = sumcls + saconc(icell,jcell,kcel,i)
               enddo
               sumcls = MAX(BNDLPT, sumcls)

               do i = iptcls(icls), nptcls(icls)
                  saconc(icell,jcell,kcel,i) = saconc(icell,jcell,kcel,i)
     &                            + delcls(icls)
     &                            * saconc(icell,jcell,kcel,i) / sumcls
                  saconc(icell,jcell,kcel,i) =
     &                          MAX(BNDLPT, saconc(icell,jcell,kcel,i))
               enddo
            endif
c
c  --- next tracer class ---
c
         enddo
c
c  --- next affected layer ---
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine pntprep(begtim,begdate,endtim,enddate)
      use filunit
      use grid
      use chmstry
      use bndary
      use ptemiss
      use tracer
c 
c----CAMx v7.40 260801
c 
c     PNTPREP reads the header of binary point source emissions file,
c     initializes time-invariant point source variables, and maps the point
c     source species list to the internal CAMx species list
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        11/06/01  Input dates are now Julian
c        05/01/03  Fixed bug that lost sources in first modeled cell
c        04/15/09  Now checks number of point sources against the 
c                  parameter.
c 
c     Input arguments: 
c        begtim              model start time (HHMM) 
c        begdate             model start date (YYJJJ) 
c        endtim              model end time (HHMM) 
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        RDPTHDR
c        GEOPSP 
c             
c     Called by: 
c        STARTUP 
c 
      include 'camx.prm'
      include 'flags.inc'
c
      integer begdate,enddate
      integer ifle
c
      integer indxpt(MXPTSRC)
c
c-----Entry point
c
c-----Read the header
c
      nptsrc = 0
      if( ltrace .AND. tectyp .EQ. SA ) then
         call get_nptsrc_sa()
      else
         call get_nptsrc()
      endif
      if( ltrace ) then 
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) call get_nptsrc_rt()
      endif
      if( lddm .OR. lhddm ) call get_nptsrc_rt()
      if( ltrace .AND. tectyp .EQ. SA ) then
         call ncf_rdpthdr_sa(begtim,begdate,endtim,enddate)
         call rdpthdr_sa(begtim,begdate,endtim,enddate)
      else
         call ncf_rdpthdr(begtim,begdate,endtim,enddate)
         call rdpthdr(begtim,begdate,endtim,enddate)
      endif
      if( nptsrc .GT. MXPTSRC ) then
        write(iout,'(//,A)') 'ERROR in PNTPREP:'
        write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
        write(iout,*) 'Please change the value for parameter: MXPTSRC'
        write(iout,*) 'It should be set to a value of at least: ',nptsrc
        call flush(iout)
        call camxerr()
      endif
      if( ltrace .AND. tectyp .EQ. SA ) then
         call ncf_rdstacks_sa()
      else
         call ncf_rdstacks()
      endif
c
c-----Call routine to allocate arrays by point source 
c
      call alloc_grid_ptsrc(MAX(1,MXPTSRC))
c
c-----Convert location to grid coordinates, convert vexit from m/hr to m/s 
c     and make sure stack diameter is positive (PiG flag is negative diameter)
c  
c-----Coarse grid
c
      if (llatlon) then
        do n = 1,nptsrc
          xstk(n,1) = xloc(n) - xorg
          ystk(n,1) = yloc(n) - yorg
        enddo
      else
        do n = 1,nptsrc
          xstk(n,1) = xloc(n)/1000. - xorg
          ystk(n,1) = yloc(n)/1000. - yorg
        enddo
      endif
c
      do 30 n=1,nptsrc
        ii = 1 + FLOOR(xstk(n,1)/delx)
        jj = 1 + FLOOR(ystk(n,1)/dely)
        isrc(n,1) = ii
        jsrc(n,1) = jj
        indxpt(n) = 1
 30   continue
c
c-----Map source to coarse grid
c
      nsrc = 0
      do n=1,nptsrc
        if (indxpt(n).eq.1) then
          nsrc = nsrc + 1
          idsrc(nsrc,1) = n
          isrc(nsrc,1) = isrc(n,1) 
          jsrc(nsrc,1) = jsrc(n,1) 
        endif
      enddo
      nosrc(1) = nsrc
c
c-----Fine grids
c
      do igrd = 2,ngrid
        nsrc = 0
        do n = 1,nptsrc
          if (indxpt(n).eq.1) then
            xstk(n,igrd) = xstk(n,1) - (inst1(igrd) - 1)*delx
            ystk(n,igrd) = ystk(n,1) - (jnst1(igrd) - 1)*dely
            ii = 2 + FLOOR(xstk(n,igrd)/delx*FLOAT( meshold(igrd) ) )
            jj = 2 + FLOOR(ystk(n,igrd)/dely*FLOAT( meshold(igrd) ) )
c
            if (ii.gt.1 .and. ii.lt.ncol(igrd) .and.
     &          jj.gt.1 .and. jj.lt.nrow(igrd)) then
              nsrc = nsrc + 1
              idsrc(nsrc,igrd) = n
              isrc(nsrc,igrd) = ii
              jsrc(nsrc,igrd) = jj
            endif
          endif
          nosrc(igrd) = nsrc
        enddo
      enddo
c
      return
      end

      subroutine aggreg(ncolf,nrowf,nlayf,ncol,nrow,nlay,nspec,i1,j1,
     &                  i2,j2,nmesh,dxfin,dyfin,depfin,
     &                  dxcrs,dycrs,depcrs,concf,conc)
c
c----CAMx v7.40 260801
c  
c     AGGREG aggregates child (fine) grid concentrations to its parent (coarse)
c     grid using an arithmitic average
c                            
c      Copyright Ramboll
c            
c     Modifications:  
c        1/29/99   Fixed a bug in layer indexing of fine layer depth
c                  (kp vs. kg)  
c       11/05/12   Removed vertical nesting
c
c     Input arguments:
c        ncolf               number of columns on fine grid
c        nrowf               number of rows on fine grid
c        nlayf               number of layers on fine grid
c        ncol                number of columns on parent grid
c        nrow                number of rows on parent grid
c        nlay                number of layers on parent grid
c        nspec               number of species
c        i1,j1               starting indices of fine grid on parent grid
c        i2,j2               ending indices of fine grid on parent grid
c        nmesh               fine grid meshing factor relative to parent
c        dxfin               cell size in x-direction on fine grid
c        dyfin               cell size in y-direction on fine grid
c        depfin              layer depths on fine grid
c        dxcrs               cell size in x-direction on parent grid
c        dycrs               cell size in y-direction on parent grid
c        depcrs              layer depths on parent grid
c        concf               concentration array on fine grid
c
c     Output arguments:
c        conc                concentration array on parent grid
c
c     Routines called:
c        none
c
c     Called by:
c        AGGR00
c
      real    dxfin(nrowf)
      real    dxcrs(nrow)
      real    depfin(ncolf,nrowf,nlayf)
      real    depcrs(ncol,nrow,nlay)
      real    conc(ncol,nrow,nlay,nspec)
      real    concf(ncolf,nrowf,nlayf,nspec)
c
      real*8  asum, bsum, vol
c
c-----Entry point
c
c
c$omp parallel default(shared)
c$omp&  private(ispc,j,i,kp,ctmp,kg,jtmp,j0,itmp,i0,vol,asum,bsum)
c
c$omp do schedule(static)
c
      do 60 ispc = 1,nspec
        do 50 j = j1,j2
          do 40 i = i1,i2
            do 30 kp = 1,nlay
              kg = kp
                bsum = 0.0D0
                do jtmp = 1,nmesh
                 j0 = (j-j1)*nmesh+jtmp + 1
                  asum = 0.0D0
                  do itmp = 1,nmesh
                    i0 = (i-i1)*nmesh+itmp + 1
                    vol = DBLE(dxfin(j0))*DBLE(dyfin)*DBLE(depfin(i0,j0,kg))
                    asum = asum + DBLE(concf(i0,j0,kg,ispc))*vol
                  enddo
                  bsum = bsum + asum
                enddo
              conc(i,j,kp,ispc) = REAL(bsum)/
     &                         ( dxcrs(j)*dycrs*depcrs(i,j,kp) )
  30        continue
  40      continue
  50    continue
  60  continue
c
c  --- end of parallelized loop ---
c
c$omp end parallel
C
      return
      end

      subroutine chemdriv(m1,m2,m3,i0,j0,ia,iz,ja,jz,igrd,
     &                    ncol,nrow,nlay,dt,itzon,idfin,dx,dy,
     &                    cldtrns,water,tempk,tsurf,press,height,uwind,
     &                    vwind,cwc,pwr,cph,aph,ajno2,
     &                    cigwtr,conc,cellat,cellon,
     &                    snow,snowrat,snowfrc,snowalb,topo,fsurf,albedo,
     &                    lrdlai,lai,ldark,solmas,vegmas,reemis,l3dflag,
     &                    iptr2d,iptrsa,ipa_cel,iproc_id)
      use filunit
      use chmstry
      use o3colmap
      use bndary
      use camxcom
      use procan
      use tracer
      use rtracchm
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c     CHEMDRIV performs chemistry on the current grid for one time step.
c     It calls one of two ODE solvers: EBISOLV or LSCALL.
c       EBISOLV is the driver for the EBI solver with Hertel's solutions
c       LSCALL  is the driver for the LSODE solver
c
c     Mechanism specific subroutines are passed to the driver routines.
c
c     Local array element con(nspec+1) is used to store the concentrations
c     of non-used species, i.e., species that are in the chem solver but
c     not on the species list for this run
c
c      Copyright Ramboll
c
c     Modifications:
c        1/9/02        A minor bug fix related to fast aero routine
c                      (units conversion)
c        1/15/02       Added code to handle RTRAC
c        01/30/02      Added code for RTRAC probing tool
c        10/18/02      Updated AEROCHEM routine; added CWC for aqueous
c                      PM chemistry
c        03/14/03      Implemented Hg chemistry (Prakash Karamchandani, AER)
c        03/21/03      Removed the OSAT technology type OPPAT
c        04/2/03       Removed option for UAM-V type cloud adjustment
c        07/21/03      Added optional snow effect on UV albedo
c        04/21/04      Added CMU sectional aerosol chemistry
c        10/14/04      Added Mechanism 10
c        10/05/05      Added PA calls for Mech 4
c        10/06/05      Removed Mech 2
c        10/07/05      Cloud water content below 273 K is partitioned to
c                      liquid fraction like in wet dep
c        10/27/05      Added cloud water pH as a 3-D argument
c        01/12/06      Aqueous PM now called each timestep
c        11/28/06      Fixed bug in assigning ldchm flag
c        07/04/07      Added heterogeneous hydrolysis of N2O5
c        07/11/07      Added code for RTCMC probing tool
c        12/26/06 -bkoo-     Removed AEROCHEM_AQ (merged into AEROCHEM_CF/CMU)
c        12/29/06 -bkoo-     Added SOACHEM
c        01/08/07 -bkoo-     Added Mechanism 6 (CB05)
c                            Fixed titration rxn # for SAPRC99 (PA)
c        07/04/07 -bkoo-     Added heterogeneous hydrolysis of N2O5
c        07/16/07 -bkoo-     Revised for HDDM
c        04/24/08 -gyarwood- Added EBI solver
c        06/01/08 -bkoo-     Modified call to EBI for DDM
c        06/11/08 -bkoo-     Revised for rate constant sensitivity
c        07/16/08 -bkoo-     Added DDM turn-off flag
c        01/30/09 -bkoo-     Removed the CMC fast solver
c        12/08/09 -jjung-    Added new RTRAC surface model and
c                            partitioning algorithm
c        05/27/09 -jjung-    Added Mechanism 7 (CB6)
c        7/14/10  -cemery-   Added code for in-line TUV cloud adjustment
c        06/02/11 -pkaramchandani- Updated Hg chemistry code
c        04/02/12 -cemery-   Removed RADM cloud adjustment option, cloud/aerosol
c                            adjustments now always done with in-line TUV; AHO
c                            file is now just ozone column; replaced haze
c                            dimension with terrain height in photo file
c        04/04/12 -cemery-   Introduced 4-dim interpolation of J values over
c                            zenith, height, albedo, terrain
c        4/12/12  -cemery-   Added T and P adjustments to photolysis rates
c        07/23/12 -unopmongcol- Added Mechanism 1 (CB6-I)
c        10/08/12 -jjung-    Added Mechanism 2 (CB6r1)
c        04/29/13 -cemery-   Added surface model
c        05/24/13 -cemery-   RTCMC photolysis can point to core reactions
c        06/28/13 -bkoo-     Changed the last argument to LSCALL
c        08/23/13 -bkoo-     Revised for DDM-PM
c        09/21/13 -bkoo-     Updated DDM-PM for KHETERO
c        10/14/13 -bkoo-     Added pressure to KHETERO call
c        01/03/14 -bkoo-     Increased SDDM array size for organic nitrate 
c                            hydrolysis
c        03/18/14 -bkoo-     Revised for benzene SOA
c        06/27/14 -bkoo-     Added Mechanism 3 (CB6r2h)
c        08/11/14 -cemery-   Albedo now includes effects of snow
c        08/22/14 -cemery-   Extended Zhang LU to surface model, added snow
c        10/09/14 -cemery-   Added subgrid convective model
c        11/11/14 -bkoo-     Added Mechanism 4 (CB6r3)
c        12/07/14 -bkoo-     Revised for VBS
c        09/11/15 -bkoo-     Revised for SA v3
c        01/08/16 -bkoo-     Updated for DDMRATE
c                                        Revised VBS
c                                        Removal of IEH solver
c        02/29/16 -bkoo-     Revised SDDM array for hetero N2O5 + HCL rxn
c        07/05/16 -gyarwood- Added HR_XO
c        07/20/16 -bkoo-     Revised SDDM array for hetero INTR hydrolysis
c        08/25/16 -bkoo-     Updated for new SOAP
c        09/02/16 -bkoo-     Set SDDM array size with # of het rxns
c        09/16/16 -pk-       Added LDARK to AEROCHEM_CF & AEROCHEM_CMU calls
c        11/28/16 -bkoo-     Revised VBS precursors
c        10/13/17 -bkoo-     Added APH & AERPH to track aerosol pH
c        10/16/17 -bkoo-     Added AJNO2 to track time-weighted NO2 photolysis rate
c                            Expanded DELCON to store SOA-specific changes
c        01/12/18 -bkoo-     Removed BNZA/TOLA/XYLA/ISP/TRP
c        08/09/18 -bkoo-     Revised for rate term sensitivity
c        02/21/20 -rlb-      Added Mechanism 1 (CB6r5)
c        03/24/21 -gy-       Added CB7 (Mech 7)
c        04/05/21 -cemery-   RTCMC uses scaling factor for photolysis reactions
c                            that point to core mech reactions
c        04/23/21 -cemery-   Udpated CH4 to 1.85 ppm
c        08/10/21 -gy-       Added RACM2s21 (Mech 9)
c        11/03/23 -cemery-   Removed Mechanism 6 (CB05)
c        05/17/24 -cemery-   Removed CMU PM option
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        dt                  timestep (s)
c        itzon               time zone
c        idfin               map of nested grids in this grid
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        cldtrns             energy transmission coefficient (fraction)
c        water               water vapor (ppm)
c        tempk               temperature (K)
c        tsurf               surface temperature (K)
c        press               pressure (mb)
c        height              layer interface height (m)
c        uwind               u-component wind (m/s)
c        vwind               v-component wind (m/s)
c        cwc                 cloud water content (g/m3)
c        pwr                 precipitation water content (g/m3)
c        cph                 cloud water pH
c        aph                 aerosol pH
c        ajno2               time-weighted accumulated NO2 photolysis rate ([1/hr]*[hr])
c        cigwtr              subgrid cloud water (g/m3)
c        conc                species concentration (umol/m3,ug/m3)
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        snow                snow cover water equivalent (m)
c        snowrat             snow water accumulation rate (m/hr)
c        snowfrc             snow cover fraction
c        snowalb             snow albedo
c        topo                cell terrain altitude (m MSL)
c        fsurf               landuse fraction
c        albedo              surface albedo
c        lrdlai              LAI was read
c        lai                 gridded LAI
c        ldark               darkness flag (T=dark)
c        solmas              surface model soil mass (mol/ha)
c        vegmas              surface model vegetation mass (mol/ha)
c        l3dflag             save 3-D average concentrations
c        iptr2d              pointers into vectors for 2-D fields
c        iptrsa              pointers into vectors for tracer conc
c        ipa_cel             gridded array to identify if cell is
c                            in a IPRM sub-domain
c        iproc_id            process ID for this slice
c
c     Output arguments:
c        conc                species concentration (umol/m3,ug/m3)
c        solmas              surface model soil mass (mol/ha)
c        vegmas              surface model vegetation mass (mol/ha)
c        reemiss             surface model reemission rate (mol/s)
c
c     Routines called:
c        CHEM10
c        KTHERM
c        KHETERO
c        GETZNTH
c        KPHOTO
c        RECALIB
c        LOADDM
c        HDDMADJ
c        EBISOLV
c        LSCALL
c        HDDMCHEM
c        VBSCHEM
c        SOACHEM
c        LOADDMPM
c        AEROCHEM_CF
c        CALDATE
c        SRFMOD
c        HGGASCHEM
c        HGAQSCHEM
c        HGADSORB
c        O3PRDSA
c        OSATSA
c        PSATSA
c        REPARTSA
c        CHEMRT
c        PARTITIONRT
c        SRFMODRT
c        KRTC
c        KSCI
c        DLSDRV
c        SLSDRV
c        RBKDRV
c        CPAMECH
c        CPARAD
c        UPTIME
c        CAMXERR
c
c     Called by:
c        CHEMRXN
c
      implicit none
      include "camx.prm"
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'vbs.inc'
      include 'deposit.inc'
      include 'flags.inc'
      include 'chmdbg.inc'
      include 'rtracsrf.inc'
c
c----Argument declarations
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz

      integer igrd
      integer ncol
      integer nrow
      integer nlay
      real    dt
      integer itzon
      integer idfin(m1,m2)
      integer iproc_id
c
      real, dimension(m1,m2,m3) :: cldtrns,cph,aph,ajno2,
     &             water,tempk,press,cwc,pwr,uwind,vwind,cigwtr

      real, dimension(m1,m2,m3) :: height
c
      real    conc(m1,m2,m3,nspec)
c
      real    cellat(m1,m2)
      real    cellon(m1,m2)
      real    snow(m1,m2)
      real    snowrat(m1,m2)
      real    snowfrc(m1,m2)
      real    snowalb(m1,m2)
      real    topo(m1,m2)
      real    tsurf(m1,m2)
      real    fsurf(m1,m2,NLU)
      real    albedo(m1,m2)
      real    lai(m1,m2)
      real    dx(nrow)
      real    dy
c
      real solmas(m1,m2,nsmspc)
      real vegmas(m1,m2,nsmspc)
      real reemis(m1,m2,nsmspc)
c
      logical   ldark(m1,m2)
      logical   lrdlai
      logical   l3dflag
      logical   lrepart
      integer   iptr2d
      integer*8 iptrsa
      integer   ipa_cel(ncol,nrow,nlay)
c
c======================== Process Analysis Begin =======================
c
      logical ldoirr, ldoipr, ltrapirr
      real    titrt
      real    chg0, chg2, thg20
c
      real rrxn_irr(MXREACT)
      real patmp(MXTRSP)
c
c======================== Process Analysis End =========================
c
c========================= Hg Chemistry Begin ==========================
c
      real cl2c              ! Cl2 concentration (ppm)
      real chgiip, chgiipc   ! Adsorbed Hg concentrations (ug/m3)
      real brc, broc         ! Br and BrO concentrations (ppm)
      real henso2,tfso2      ! Henry's Law for SO2 (M/atm)
      real heno3,tfo3        ! Henry's Law for O3 (M/atm)
      real pm10              ! Total PM10 concentrations (ug/m3)
      integer iocean         ! Ocean flag: 1 = ocean, 0 = other
c
      real thg2                 ! Total Hg(2)
      real convhgfac            ! conv factor for hg (ppm to ug/m3)
c
c-----variables for Hg adsorption on primary particles
      real, parameter :: MWNA = 23.0 ! Mol. wt. of sodium
      real, parameter :: MWCL = 35.5 ! Mol. wt. of chlorine atom
      real, parameter :: MWNACL = MWNA + MWCL ! Mol. wt. of seasalt
      real, parameter :: RHOSEAS = 2.0E6 ! Density of seasalt (g/m3)

      real dfine, dcoarse       ! diameter of fine and coarse particles (um)
c
c-----surface area concentration (m2/m3) and volume concentrations (cm3/m3) of
c-----fine and coarse particles
      real safine,sacoarse,vfine,vcoarse
c
      real cna,cpcl,vseas,fseas ! Na,Cl concs; vol. conc of seasalt, fraction
                                ! of fine PM that is seasalt
c
c========================== Hg Chemistry End ===========================
c
c-----variables for SOACHEM/VBSCHEM
c
      real avgox(NOXID)    ! Average oxidant conc. (ppm)
      real con_prec(NPREC) ! Precursor conc. (ppm)
      real con_CG(NCG)     ! CG conc. (ppm)
      real con_NV(NNV)     ! Non-volatile product conc. (ppm)
      real CG_part(NCG)    ! CG partition coefficients for PSAT
      real dcprec(NPREC_S) ! change in SOA precursors for PSAT
      real yfac(5,NPREC_S) ! weighted SOA yields for PSAT
      real fcsoa(6)        ! SOA chem factors for PSAT
c
c======================== DDM Begin =======================
c
      real sddm(MXTRSP+NHETRXN*MXFDDM)
      real avgsen(MXFDDM*NOXID)   ! Average sensitivities of oxidants (ppm)
      real sen_prec(MXFDDM*NPREC) ! Sensitivities of precursors (ppm)
      real sen_CG(MXFDDM*NCG)     ! Sensitivities of CGs (ppm)
      real sen_NV(MXFDDM*NNV)     ! Sensitivities of NVs (ppm)
c
c======================== DDM End =======================
c
c-----subroutine names to be called by EBISOLV and LSCALL
c
      external ebirxn1, ebirate1, hr_hox1, hr_nox1, hr_nxy1, hr_pan1
      external ebirxn3, ebirate3, hr_hox3, hr_nox3, hr_nxy3, hr_pan3
      external ebirxn4, ebirate4, hr_hox4, hr_nox4, hr_nxy4, hr_pan4
      external ebirxn5, ebirate5, hr_hox5, hr_nox5, hr_nxy5, hr_pan5
      external ebirxn7, ebirate7, hr_hox7, hr_nox7, hr_nxy7, hr_pan7
      external ebirxn9, ebirate9, hr_hox9, hr_nox9, hr_nxy9, hr_pan9
      external hr_xo1, hr_xo3, hr_xo4, hr_xo7, hr_xo_dum
      external lsrate1
      external lsrate3
      external lsrate4
      external lsrate5
      external lsrate7
      external lsrate9
      external ddmrate1, hddmjac1
      external ddmrate3, hddmjac3
      external ddmrate4, hddmjac4
      external ddmrate5, hddmjac5
      external ddmrate7, hddmjac7
      external ddmrate9, hddmjac9
c
c-----Local variables
c
      integer   i,j,k,is,l,ij,irxn,ihg,iht,nj,nz,nn
      integer   icell, jcell, kcell
      integer*8 idx
      integer   ierr
      integer   aero_flag
      integer   iozon,irt_cel
      integer   ipa_idx
      integer   icsa_grid
      integer   lsm
      integer   nitsum(MXLAYER)
      integer   icig
c
      real dtchem,dtfact
      real tcell,pcell,convfac,cldph,aerph,ctrns,zenith,cliq
      real o2,ch4,atm,h2
      real con(MXSPEC+1)
      real avgcnc(MXSPEC+1)
      real hght,alb,trn
      real desto3,prdo3n,prdo3v
      real depth,press0,ucomp,vcomp,wind
      real avit(MXCELLS,MXCELLS)
      real sumit(MXLAYER)
c
c --- the delcon array stores the delta concentrations at
c     various stages of the chemistry process.
c
c    delcon(1,*)  -- change in concentration after just gas phase
c                    chemistry (no aerosol chemistry applied)
c    delcon(2,*)  -- change in concentration after gas phase
c                    and aqueous phase chemistry
c    delcon(3,*)  -- change in concentration after all chemistry
c                    is complete
c    delcon(4,*)  -- special instance to capture the change in
c                    concentration due to gas phase and aqueous 
c                    phase but also includes the transfer of
c                    some nitrate species during the aqueous phase
c
      integer ispc
      real    o3old, o3new
c
      real delcon(4,MXSPEC+1)
      real cold(MXSPEC)
      real cnew(MXSPEC)
      real rtcon(MXTRSP)
      real soil(MXSMSPC)
      real vegy(MXSMSPC)
      real reemit(MXSMSPC)
      real flu(NLU)
c
      integer ncol_csa(MXPADOM)
      integer nrow_csa(MXPADOM)
      integer nlay_csa(MXPADOM)
c
c-----Entry point
c
      call flush(6)
      call flush(iout)
c
      dtchem = dt/3600.
      con(nspec+1) = 0.
      ltrapirr = .FALSE.
c
c-----Aerosol timing parameters:
c     time_aero : time to call aerosol routine (HHMM)
c     date_aero : date to call aerosol routine (YYJJJ)
c     dt_aero   : time interval between calls to aerosol routines (min)
c     aero_dt   : actual time interval for each grid (hr) (accumulated dtchem)
c     aero_flag = 0 - no aerosol
c               = 1 - do RAQCHEM (with ISORROPIA), NV SOA
c               = 2 - do SOAP, RAQCHEM, ISORROPIA|EQSAM

      aero_flag = 0
      lrepart = .false.
      if( naero.GT.0 .AND. aeropt.EQ.'CF') then
         aero_flag = 1
         aero_dt(igrd) = aero_dt(igrd) + dtchem
         if ( (timec(igrd)-time_aero(igrd)) .ge. -0.01 .and.
     &        (datec(igrd) .eq. date_aero(igrd)) ) then
           aero_flag = 2
           lrepart = .true.   ! for PSAT SOA
         endif
      endif
c
c======================== CSA Begin =======================
c
      if( lcsa ) then
         do icsa_grid = 1,npadom
            ncol_csa(icsa_grid) = i_ne(icsa_grid) - i_sw(icsa_grid) + 1
            nrow_csa(icsa_grid) = j_ne(icsa_grid) - j_sw(icsa_grid) + 1
            nlay_csa(icsa_grid) = t_lay(icsa_grid) - b_lay(icsa_grid) + 1
         enddo
      endif
c
c======================== CSA End =======================
c
      igrdchm = igrd
      do 91 k = 1,nlay
c
c---Update list of variables private to each thread for updated
c---Hg treatment, PK, Ramboll 06/11
c
        nitsum(k)=1
        sumit(k)=1.
c
c$omp parallel default(shared)
c$omp&  private(i,j,l,is,ispc,con,
c$omp&  ij,iozon,trn,alb,hght,ctrns,
c$omp&  zenith,delcon,tcell,pcell,cliq,cldph,aerph,atm,O2,H2,CH4,
c$omp&  sddm,ldoipr,ldoirr,ipa_idx,titrt,irxn,rrxn_irr,
c$omp&  ierr,convfac,convhgfac,patmp,idx,nn,cold,cnew,avgcnc,o3old,
c$omp&  o3new,irt_cel,iocean,brc,broc,cl2c,henso2,tfso2,heno3,tfo3,
c$omp&  pm10,iht,ihg,ltrapirr,chg0,chg2,chgiip,chgiipc,thg2,
c$omp&  thg20,cna,cpcl,vseas,fseas,dfine,dcoarse,vfine,vcoarse,
c$omp&  safine,sacoarse,avgox,con_prec,dcprec,con_CG,con_NV,yfac,
c$omp&  CG_part,fcsoa,
c$omp&  avgsen,sen_prec,sen_CG,sen_NV,
c$omp&  nj,nz,rtcon,desto3,prdo3n,prdo3v,
c$omp&  depth,press0,vcomp,ucomp,wind,lsm,
c$omp&  flu,soil,vegy,reemit,icig)
c$omp&  copyin(/ijkgrd/)
c
c$omp do schedule(guided) collapse(2)
c
        do 90 j =  ja,jz   !2,nrow-1
          do 89 i = ia,iz   !2,ncol-1
            ltrapirr = .FALSE.
            ichm = i
            jchm = j
            kchm = k
            avit(i,j) = 0.
c
c-----skip chemistry if fine grid exists in this cell
c
            if (idfin(i,j).gt.igrd) goto 89
c
c-----For the gas phase species (numbered 1 to ngas)
c     Pass concentration to CON, converting from umol/m3 to ppm
c
            tcell = tempk(i,j,k)
            pcell = press(i,j,k)
            convfac = densfac*(273./tcell)*(pcell/1013.)
            cldph = cph(i,j,k)
            aerph = aph(i,j,k)
            tchm = tcell
            wchm = water(i,j,k)
            do is = 1,nrad
              con(is) = conc(i,j,k,is)
              if (con(is).lt.0.) then
                write(iout,'(//,a)') 'ERROR in CHEMDRIV:'
                write(iout,*) 'Negative concentration before chem'
                write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                write(iout,*) 'iproc_id = ',iproc_id
                do l = 1,nspec
                  write(iout,'(i3,2x,a7,e10.3)') l,spname(l),con(l)
                enddo
                call camxerr()
              endif
              con(is) = amax1(bdnl(is),con(is))
            enddo
            do is = nrad+1,ngas
              con(is) = conc(i,j,k,is)/convfac
              if (con(is).lt.0.) then
                write(iout,'(//,a)') 'ERROR in CHEMDRIV:'
                write(iout,*) 'Negative concentration before chem'
                write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                do l = 1,nspec
                  write(iout,'(i3,2x,a7,e10.3)') l,spname(l),con(l)
                enddo
                call camxerr()
              endif
              con(is) = amax1(bdnl(is),con(is))
            enddo
c
c-----Load any aerosols
c
            if (ngas.lt.nspec) then
              do is=ngas+1,nspec
                con(is) = conc(i,j,k,is)
                if (con(is).lt.0.) then
                  write(iout,'(//,a)') 'ERROR in CHEMDRIV:'
                  write(iout,*) 'Negative concentration before chem'
                  write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                  do l = 1,nspec
                    write(iout,'(i3,2x,a7,e10.3)') l,spname(l),con(l)
                  enddo
                  call camxerr()
                endif
                con(is) = amax1(bdnl(is),con(is))
              enddo
            endif
c
c-----Mechanism 10 is done here
c
            if (idmech.eq.10) then
               call chem10(dtchem,tcell,pcell,water(i,j,k),con)
               goto 88
            endif
c
c======================== DDM Begin ====================================
c
c  ---- load the sensitivities for this cell into 2-D array ---
c
            if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              call loaddm(.FALSE.,m1,m2,m3,ntotsp,ptconc(iptrsa),
     &                    i,j,k,nddmsp,nspec,ngas,nrad,NHETRXN,sddm,
     &                    convfac)
              if ( lhddm )
     &              call hddmadj(.FALSE.,nddmsp,con,sddm)
            endif
c
c  ---- load the CSA values for this cell into 2-D array ---
c
            if( lcsa ) then
               ipa_idx = ipa_cel(i+i0,j+j0,k)
               if( ipa_idx .GT. 0 ) then
                   icsa_grid = ipadom(ipa_idx)
                   icell = ipax(ipa_idx) - i_sw(icsa_grid) + 1
                   jcell = ipay(ipa_idx) - j_sw(icsa_grid) + 1
                   kcell = ipaz(ipa_idx) - b_lay(icsa_grid) + 1
                   call loadcsa_sens(.FALSE.,ncol_csa(icsa_grid),nrow_csa(icsa_grid),
     &                 nlay_csa(icsa_grid),ntotsp,csaconc(iptrcsa(icsa_grid)),
     &                 icell,jcell,kcell,nddmsp,nspec,ngas,nrad,NHETRXN,sddm,convfac)
              endif
           endif
c
c======================== DDM End =======================================
c
c-----Determine thermal rate constants
c
            call ktherm(tcell,pcell)
c
c-----Calculate the rate constant for heterogeneous hydrolysis of N2O5
c
            call khetero(tcell,pcell,water(i,j,k),con,
     &                           (lddm.AND.lddmcalc(igrd)),nddmsp,sddm)
c
c-----Load local values of ozone, terrain ht, albedo, zenith angle, altitude
c
            call getznth(cellat(i,j),cellon(i,j),timec(igrd),
     &                   datec(igrd),itzon,zenith,ldark(i,j))
            ldchm = ldark(i,j)
c
            alb   = albedo(i,j)
            ij = i + (j-1)*m1
            iozon = icdozn(iptr2d-1+ij)
            iocean = icdocn(iptr2d-1+ij)
c
            trn = topo(i,j)/1000.
            hght = height(i,j,k)/2000.
            if (k.gt.1) hght = (height(i,j,k) + height(i,j,k-1))/2000.
            ctrns = 0.
            if (.not.ldark(i,j)) ctrns = cldtrns(i,j,k)
c
c-----Determine photolysis rates through interpolation of look-up table
c
            call kphoto(iozon,alb,trn,hght,zenith,ctrns,ldark(i,j),
     &                  tcell,pcell)
c
c-----Accumulate JNO2 ([1/hr]*[hr])
c
            ajno2(i,j,k) = ajno2(i,j,k) + rk(jno2rxn) * dtchem
c
c======================== Source Apportion Begin =======================
c
c  --- store the current value of the species needed for tracer "chemistry" ----
c
            if( ltrace ) then
               o3old = con(ko3)
               do ispc=1,nrad
                  delcon(1,ispc) = -con(ispc)*convfac
                  delcon(2,ispc) = -con(ispc)*convfac
                  delcon(3,ispc) = -con(ispc)*convfac
                  delcon(4,ispc) = -con(ispc)*convfac
                  cold(ispc) = con(ispc)
               enddo
               do ispc=nrad+1,ngas
                  delcon(1,ispc) = -con(ispc)*convfac
                  delcon(2,ispc) = -con(ispc)*convfac
                  delcon(3,ispc) = -con(ispc)*convfac
                  delcon(4,ispc) = -con(ispc)*convfac
                  cold(ispc) = con(ispc)*convfac
               enddo
               do ispc=ngas+1,nspec
                  delcon(1,ispc) = -con(ispc)
                  delcon(2,ispc) = -con(ispc)
                  delcon(3,ispc) = -con(ispc)
                  delcon(4,ispc) = -con(ispc)
                  cold(ispc) = con(ispc)
               enddo
               delcon(1:4,nspec+1) = 0.0 ! species not in mechanism
c
c  --- call routine to recalibrate so that tracer species stays
c      on track with model species: needed because the numerics
c      cause tracer species to drift
c
               if( tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC )
     &                call recalib(m1,m2,m3,ntotsp,
     &                                      ptconc(iptrsa),i,j,k,cold)
c
c   --- if ozone or nitrate tracers are requested,
c       set the flag for process analysis -- this will save needed
c       information from the solver routines ---
c
c  --- set variables for OSAT3 ----
c
               if( lozone .OR. lnitrate ) then
                 ltrapirr = .TRUE.
                 do irxn=1,nreact
                     rrxn_irr(irxn) = 0.0
                 enddo
               endif
            endif
c
c========================= Source Apportion End ========================
c
c-----Assign SOA precursor concentrations before chemistry integration
c
            if( aero_flag .GT. 0 ) then
              if ( lvbs ) then
                if (idmech.eq.1 .or. idmech.eq.3 .or. idmech.eq.4) then ! cb6
                  con_prec(IVBS_BNZA) = con(kBENZ)
                  con_prec(IVBS_TOLA) = con(kTOL )
                  con_prec(IVBS_XYLA) = con(kXYL )
                  con_prec(IVBS_ISP) = con(kISOP)
                  con_prec(IVBS_TRP) = con(kTERP)
                  con_prec(IVBS_SQT) = con(kSQT )
                elseif (idmech.eq.5) then ! saprc07tc
                  con_prec(IVBS_BNZA) = con(kBENZ)
                  con_prec(IVBS_TOLA) = con(kTOLU) + con(kARO1)
                  con_prec(IVBS_XYLA) = con(kOXYL) + con(kMXYL) + con(kPXYL)
     &                                     + con(kB124) + con(kARO2)
                  con_prec(IVBS_ISP) = con(kISOP)
                  con_prec(IVBS_TRP) = con(kAPIN) + con(kTERP)
                  con_prec(IVBS_SQT) = con(kSESQ)
                elseif (idmech.eq.7) then ! cb7
                  con_prec(IVBS_BNZA) = con(kBENZ)
                  con_prec(IVBS_TOLA) = con(kTOL )
                  con_prec(IVBS_XYLA) = con(kXYL )
                  con_prec(IVBS_ISP) = con(kISOP)
                  con_prec(IVBS_TRP) = con(kAPIN) + con(kTERP)
                  con_prec(IVBS_SQT) = con(kSQT )
                elseif (idmech.eq.9) then ! RACM2s21
                  con_prec(IVBS_BNZA) = con(kBEN )
                  con_prec(IVBS_TOLA) = con(kTOL )
                  con_prec(IVBS_XYLA) = con(kXYM ) + con(kXYO) + con(kXYP)
                  con_prec(IVBS_ISP) = con(kISO )
                  con_prec(IVBS_TRP) = con(kAPI ) + con(kLIM)
                  con_prec(IVBS_SQT) = con(kSQT )
                endif
                con_prec(IVBS_IVOG) = con(kIVOG)
                con_prec(IVBS_IVOD) = con(kIVOD)
                con_prec(IVBS_IVOA) = con(kIVOA)
                con_prec(IVBS_IVOB) = con(kIVOB)
              else ! soap
                if (idmech.eq.1 .or. idmech.eq.3 .or. idmech.eq.4) then ! cb6
                  con_prec(ISOAP_BNZA)  = con(kBENZ)
                  con_prec(ISOAP_HPAR)  = 0.
                  con_prec(ISOAP_TOLA)  = con(kTOL )
                  con_prec(ISOAP_XYLA)  = con(kXYL )
                  con_prec(ISOAP_IVOA)  = con(kIVOA)
                  con_prec(ISOAP_IVC2)  = con(kIVC2)
                  con_prec(ISOAP_SVOA)  = con(kSVOA)
                  con_prec(ISOAP_ISP)  = con(kISOP)
                  con_prec(ISOAP_TRP)  = con(kTERP)
                  con_prec(ISOAP_APN) = 0.0
                  con_prec(ISOAP_SQT) = con(kSQT )
                elseif (idmech.eq.5) then ! saprc07tc
                  con_prec(ISOAP_BNZA) = con(kBENZ)
                  con_prec(ISOAP_HPAR)  = 0.
                  con_prec(ISOAP_TOLA) = con(kTOLU) + con(kARO1)
                  con_prec(ISOAP_XYLA) = con(kOXYL) + con(kMXYL) + con(kPXYL)
     &                                     + con(kB124) + con(kARO2)
                  con_prec(ISOAP_IVOA) = con(kIVOA)
                  con_prec(ISOAP_IVC1) = con(kIVC1)
                  con_prec(ISOAP_IVC2) = con(kIVC2)
                  con_prec(ISOAP_SVOA) = con(kSVOA)
                  con_prec(ISOAP_ISP) = con(kISOP)
                  con_prec(ISOAP_TRP) = con(kTERP)
                  con_prec(ISOAP_APN) = con(kAPIN)
                  con_prec(ISOAP_SQT) = con(kSESQ)
                elseif (idmech.eq.7) then ! cb7
                  con_prec(ISOAP_BNZA)  = con(kBENZ)
                  con_prec(ISOAP_HPAR)  = con(kHPAR)
                  con_prec(ISOAP_TOLA)  = con(kTOL )
                  con_prec(ISOAP_XYLA)  = con(kXYL )
                  con_prec(ISOAP_IVOA)  = con(kIVOA)
                  con_prec(ISOAP_IVC1)  = con(kIVC1)
                  con_prec(ISOAP_IVC1)  = con(kIVC1)
                  con_prec(ISOAP_IVC2)  = con(kIVC2)
                  con_prec(ISOAP_SVOA)  = con(kSVOA)
                  con_prec(ISOAP_ISP)  = con(kISOP)
                  con_prec(ISOAP_TRP)  = con(kTERP)
                  con_prec(ISOAP_APN) = con(kAPIN)
                  con_prec(ISOAP_SQT) = con(kSQT )
                elseif (idmech.eq.9) then ! RACM2s21
                  con_prec(ISOAP_BNZA) = con(kBEN )
                  con_prec(ISOAP_HPAR)  = 0.
                  con_prec(ISOAP_TOLA) = con(kTOL )
                  con_prec(ISOAP_XYLA) = con(kXYM ) + con(kXYO) + con(kXYP)
                  con_prec(ISOAP_IVOA) = con(kIVOA)
                  con_prec(ISOAP_IVC1) = con(kIVC1)
                  con_prec(ISOAP_IVC2) = con(kIVC2)
                  con_prec(ISOAP_SVOA) = con(kSVOA)
                  con_prec(ISOAP_ISP) = con(kISO )
                  con_prec(ISOAP_TRP) = con(kLIM )
                  con_prec(ISOAP_APN) = con(kAPI )
                  con_prec(ISOAP_SQT) = con(kSQT )
                endif
c
c======================== DDM Begin =======================
c
                if ( lddm ) then
                  if (idmech.eq.1 .or. idmech.eq.3 .or. idmech.eq.4) then ! cb6
                    do is = 1, nddmsp
                      sen_prec(         is) = sddm(iptddm(kBENZ)-1+is)
                      sen_prec(  nddmsp+is) = sddm(iptddm(kTOL )-1+is)
                      sen_prec(2*nddmsp+is) = sddm(iptddm(kXYL )-1+is)
                      sen_prec(3*nddmsp+is) = sddm(iptddm(kIVOA)-1+is)
                      sen_prec(4*nddmsp+is) = sddm(iptddm(kIVC1)-1+is)
                      sen_prec(5*nddmsp+is) = sddm(iptddm(kIVC2)-1+is)
                      sen_prec(6*nddmsp+is) = sddm(iptddm(kSVOA)-1+is)
                      sen_prec(7*nddmsp+is) = sddm(iptddm(kISOP)-1+is)
                      sen_prec(8*nddmsp+is) = sddm(iptddm(kTERP)-1+is)
                      sen_prec(9*nddmsp+is) = 0.0
                      sen_prec(10*nddmsp+is) = sddm(iptddm(kSQT )-1+is)
                    enddo
                  elseif (idmech.eq.5) then ! saprc07tc
                    do is = 1, nddmsp
                      sen_prec(         is) = sddm(iptddm(kBENZ)-1+is)
                      sen_prec(  nddmsp+is) = sddm(iptddm(kTOLU)-1+is)
     &                                      + sddm(iptddm(kARO1)-1+is)
                      sen_prec(2*nddmsp+is) = sddm(iptddm(kOXYL)-1+is)
     &                                      + sddm(iptddm(kMXYL)-1+is)
     &                                      + sddm(iptddm(kPXYL)-1+is)
     &                                      + sddm(iptddm(kB124)-1+is)
     &                                      + sddm(iptddm(kARO2)-1+is)
                      sen_prec(3*nddmsp+is) = sddm(iptddm(kIVOA)-1+is)
                      sen_prec(4*nddmsp+is) = sddm(iptddm(kIVC1)-1+is)
                      sen_prec(5*nddmsp+is) = sddm(iptddm(kIVC2)-1+is)
                      sen_prec(6*nddmsp+is) = sddm(iptddm(kSVOA)-1+is)
                      sen_prec(7*nddmsp+is) = sddm(iptddm(kISOP)-1+is)
                      sen_prec(8*nddmsp+is) = sddm(iptddm(kTERP)-1+is)
                      sen_prec(9*nddmsp+is) = sddm(iptddm(kAPIN)-1+is)
                      sen_prec(10*nddmsp+is) = sddm(iptddm(kSESQ)-1+is)
                    enddo
                  elseif (idmech.eq.7) then ! cb7
                    do is = 1, nddmsp
                      sen_prec(         is) = sddm(iptddm(kBENZ)-1+is)
                      sen_prec(  nddmsp+is) = sddm(iptddm(kTOL )-1+is)
                      sen_prec(2*nddmsp+is) = sddm(iptddm(kXYL )-1+is)
                      sen_prec(3*nddmsp+is) = sddm(iptddm(kIVOA)-1+is)
                      sen_prec(4*nddmsp+is) = sddm(iptddm(kIVC1)-1+is)
                      sen_prec(5*nddmsp+is) = sddm(iptddm(kIVC2)-1+is)
                      sen_prec(6*nddmsp+is) = sddm(iptddm(kSVOA)-1+is)
                      sen_prec(7*nddmsp+is) = sddm(iptddm(kISOP)-1+is)
                      sen_prec(8*nddmsp+is) = sddm(iptddm(kTERP)-1+is)
                      sen_prec(9*nddmsp+is) = sddm(iptddm(kAPIN)-1+is)
                      sen_prec(10*nddmsp+is) = sddm(iptddm(kSQT )-1+is)
                    enddo
                  elseif (idmech.eq.9) then ! RACM2s21
                    do is = 1, nddmsp
                      sen_prec(         is) = sddm(iptddm(kBEN )-1+is)
                      sen_prec(  nddmsp+is) = sddm(iptddm(kTOL )-1+is)
                      sen_prec(2*nddmsp+is) = sddm(iptddm(kXYM )-1+is)
     &                                      + sddm(iptddm(kXYO )-1+is)
     &                                      + sddm(iptddm(kXYP )-1+is)
                      sen_prec(3*nddmsp+is) = sddm(iptddm(kIVOA)-1+is)
                      sen_prec(4*nddmsp+is) = sddm(iptddm(kIVC1)-1+is)
                      sen_prec(5*nddmsp+is) = sddm(iptddm(kIVC2)-1+is)
                      sen_prec(6*nddmsp+is) = sddm(iptddm(kSVOA)-1+is)
                      sen_prec(7*nddmsp+is) = sddm(iptddm(kISO )-1+is)
                      sen_prec(8*nddmsp+is) = sddm(iptddm(kLIM )-1+is)
                      sen_prec(9*nddmsp+is) = sddm(iptddm(kAPI )-1+is)
                      sen_prec(10*nddmsp+is) = sddm(iptddm(kSQT )-1+is)
                    enddo
                  endif
                endif
c
c======================== DDM End =======================
c
              endif
            endif
c
c-----Chemistry integration, pass subroutines for mechanism used
c
            atm = 1.e6
            O2  = 2.095e5
            CH4 = 1.85
            H2  = 0.60
c
c======================== Process Analysis Begin =======================
c
            ldoipr = .FALSE.
            ldoirr = .FALSE.
            if( lproca ) then
               if( lipr ) then
                  if( ipa_cel(i+i0,j+j0,k) .GT. 0 )  then
                     ipa_idx = ipa_cel(i+i0,j+j0,k)
                     ldoipr = .TRUE.
                  endif
               endif
               if( lirr ) then
                  ltrapirr = .TRUE.
                  if( ipa_cel(i+i0,j+j0,k) .GT. 0 ) then
                     ipa_idx = ipa_cel(i+i0,j+j0,k)
                     ldoirr = .TRUE.
                  endif
                  titrt = 0.0
                  do irxn=1,nreact
                     rrxn_irr(irxn) = 0.0
                  enddo
               endif
            endif
c
c======================== Process Analysis End =========================
c
            if ( idsolv .EQ. IDEBI ) then
               if (idmech.eq.1) then
                   call ebisolv(ebirxn1,ebirate1,hr_hox1,hr_nox1,
     &                  hr_nxy1,hr_pan1,hr_xo1,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac1,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               elseif (idmech.eq.3) then
                   call ebisolv(ebirxn3,ebirate3,hr_hox3,hr_nox3,
     &                  hr_nxy3,hr_pan3,hr_xo3,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac3,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               elseif (idmech.eq.4) then
                   call ebisolv(ebirxn4,ebirate4,hr_hox4,hr_nox4,
     &                  hr_nxy4,hr_pan4,hr_xo4,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac4,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               elseif (idmech.eq.5) then
                   call ebisolv(ebirxn5,ebirate5,hr_hox5,hr_nox5,
     &                  hr_nxy5,hr_pan5,hr_xo_dum,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac5,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               elseif (idmech.eq.7) then
                   call ebisolv(ebirxn7,ebirate7,hr_hox7,hr_nox7,
     &                  hr_nxy7,hr_pan7,hr_xo7,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac7,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               elseif (idmech.eq.9) then
                   call ebisolv(ebirxn9,ebirate9,hr_hox9,hr_nox9,
     &                  hr_nxy9,hr_pan9,hr_xo_dum,
     &                  dtchem,water(i,j,k),atm,O2,
     &                  CH4,H2,tcell,ldark(i,j),con,avgcnc,avit(i,j),
     &                  hddmjac9,nddmsp,sddm,NOXID,avgsen,
     &                  (lddm.AND.lddmcalc(igrd)),
     &                  nirrrxn,rrxn_irr,ltrapirr)
               endif
c
            elseif ( idsolv .EQ. IDLSOD ) then
               if (idmech.eq.1) then
                  call lscall(lsrate1,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               elseif (idmech.eq.3) then
                  call lscall(lsrate3,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               elseif (idmech.eq.4) then
                  call lscall(lsrate4,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               elseif (idmech.eq.5) then
                  call lscall(lsrate5,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               elseif (idmech.eq.7) then
                  call lscall(lsrate7,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               elseif (idmech.eq.9) then
                  call lscall(lsrate9,dtchem,water(i,j,k),atm,
     &                        O2,CH4,H2,con,avgcnc,nirrrxn,
     &                        rrxn_irr,ierr,ltrapirr,0)
               endif
            endif
c
c======================== HDDM Begin ====================================
c
            if ( lhddm .AND. lddmcalc(igrd) ) then
              if (idmech.eq.1) then
                call hddmchem(hddmjac1,ebirxn1,ebirate1,ddmrate1,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              elseif (idmech.eq.3) then
                call hddmchem(hddmjac3,ebirxn3,ebirate3,ddmrate3,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              elseif (idmech.eq.4) then
                call hddmchem(hddmjac4,ebirxn4,ebirate4,ddmrate4,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              elseif (idmech.eq.5) then
                call hddmchem(hddmjac5,ebirxn5,ebirate5,ddmrate5,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              elseif (idmech.eq.7) then
                call hddmchem(hddmjac7,ebirxn7,ebirate7,ddmrate7,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              elseif (idmech.eq.9) then
                call hddmchem(hddmjac9,ebirxn9,ebirate9,ddmrate9,
     &                        nreact,ngas,ngas,
     &                        nddmsp,nrateddm,ntermddm,nhddm,
     &                        iprate,ipterm,wfterm,iphddm,
     &                        dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                        rk,avgcnc,sddm,ierr)
              endif
              if (ierr.ne.0) then
                write(iout,'(//,a)') 'ERROR in CHEMDRIV:'
                write(iout,*)
     &                'Zero determinant in SGEFA in HDDMCHEM at ',ierr
                write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                call camxerr()
              endif
            endif
c
c======================== HDDM End =======================================
c
c-----Perform gas-phase chemistry for SOA precursors
c
            if( aero_flag .GT. 0 ) then

              avgox(1) = amax1(avgcnc(kO)  , bdnl(kO)  )
              avgox(2) = amax1(avgcnc(kOH) , bdnl(kOH) )
              avgox(3) = amax1(avgcnc(kO3) , bdnl(kO3) )
              avgox(4) = amax1(avgcnc(kNO3), bdnl(kNO3))
              avgox(5) = amax1(avgcnc(kNO) , bdnl(kNO) )
              avgox(6) = amax1(avgcnc(kHO2), bdnl(kHO2))

              if ( lvbs ) then

                con_CG( 1) = con(kVAS1)
                con_CG( 2) = con(kVAS2)
                con_CG( 3) = con(kVAS3)
                con_CG( 4) = con(kVAS4)
                con_CG( 5) = con(kVBS1)
                con_CG( 6) = con(kVBS2)
                con_CG( 7) = con(kVBS3)
                con_CG( 8) = con(kVBS4)
                con_CG( 9) = con(kVAP1)
                con_CG(10) = con(kVAP2)
                con_CG(11) = con(kVAP3)
                con_CG(12) = con(kVAP4)
                con_CG(13) = con(kVCP1)
                con_CG(14) = con(kVCP2)
                con_CG(15) = con(kVCP3)
                con_CG(16) = con(kVCP4)
                con_CG(17) = con(kVFP1)
                con_CG(18) = con(kVFP2)
                con_CG(19) = con(kVFP3)
                con_CG(20) = con(kVFP4)
                call vbschem(iout,tcell,pcell,dtchem,
     &                       avgox,con_prec(:NPREC_V),
     &                       con_CG(:NVBS*NSET),con_NV(:NSET))
                if (.NOT.((idmech.eq.5 .and. kSESQ.lt.nspec+1) .OR.
     &                    (idmech.eq.7 .and. kSQT.lt.nspec+1)))
     &            con(kSQT) = amax1( con_prec(IVBS_SQT), bdnl(kSQT) )
                con(kIVOG) = amax1( con_prec(IVBS_IVOG), bdnl(kIVOG) )
                con(kIVOD) = amax1( con_prec(IVBS_IVOD), bdnl(kIVOD) )
                con(kIVOA) = amax1( con_prec(IVBS_IVOA), bdnl(kIVOA) )
                con(kIVOB) = amax1( con_prec(IVBS_IVOB), bdnl(kIVOB) )

                con(kVAS1) = con_CG( 1)
                con(kVAS2) = con_CG( 2)
                con(kVAS3) = con_CG( 3)
                con(kVAS4) = con_CG( 4)
                con(kVBS1) = con_CG( 5)
                con(kVBS2) = con_CG( 6)
                con(kVBS3) = con_CG( 7)
                con(kVBS4) = con_CG( 8)
                con(kVAP1) = con_CG( 9)
                con(kVAP2) = con_CG(10)
                con(kVAP3) = con_CG(11)
                con(kVAP4) = con_CG(12)
                con(kVCP1) = con_CG(13)
                con(kVCP2) = con_CG(14)
                con(kVCP3) = con_CG(15)
                con(kVCP4) = con_CG(16)
                con(kVFP1) = con_CG(17)
                con(kVFP2) = con_CG(18)
                con(kVFP3) = con_CG(19)
                con(kVFP4) = con_CG(20)

              else

                con_CG(1) = con(kACG2)
                con_CG(2) = con(kACG1)
                con_CG(3) = con(kBCG2)
                con_CG(4) = con(kBCG1)
c
c======================== DDM Begin =======================
c
                if ( lddm ) then
                  do is = 1, nddmsp
                    sen_CG(         is) = sddm(iptddm(kACG2)-1+is)
                    sen_CG(  nddmsp+is) = sddm(iptddm(kACG1)-1+is)
                    sen_CG(2*nddmsp+is) = sddm(iptddm(kBCG2)-1+is)
                    sen_CG(3*nddmsp+is) = sddm(iptddm(kBCG1)-1+is)
                  enddo
                endif
c
c======================== DDM End =======================
c
                call soachem(iout,tcell,pcell,dtchem,rk,
     &                       avgox,con_prec(:NPREC_S),dcprec(:NPREC_S),
     &                       con_CG(:NSOAP),con_NV(:NNVOL),yfac,
     &                       nddmsp,avgsen,sen_prec,sen_CG,sen_NV,lddm)
c
c======================== DDM Begin =======================
c
                if ( lddm ) then
                  if (.NOT.((idmech.eq.5 .and. kSESQ.lt.nspec+1) .OR.
     &                      (idmech.eq.7 .and. kSQT.lt.nspec+1))) then
                    do is = 1, nddmsp
                      sddm(iptddm(kSQT)-1+is) = sen_prec(10*nddmsp+is)
                    enddo
                  endif
                  do is = 1, nddmsp
                    sddm(iptddm(kIVOA)-1+is) = sen_prec(3*nddmsp+is)
                    sddm(iptddm(kIVC1)-1+is) = sen_prec(4*nddmsp+is)
                    sddm(iptddm(kIVC2)-1+is) = sen_prec(5*nddmsp+is)
                    sddm(iptddm(kSVOA)-1+is) = sen_prec(6*nddmsp+is)
                    sddm(iptddm(kACG2)-1+is) = sen_CG(         is)
                    sddm(iptddm(kACG1)-1+is) = sen_CG(  nddmsp+is)
                    sddm(iptddm(kBCG2)-1+is) = sen_CG(2*nddmsp+is)
                    sddm(iptddm(kBCG1)-1+is) = sen_CG(3*nddmsp+is)
                  enddo
                endif
c
c======================== DDM End =======================
c
                if (.NOT.((idmech.eq.5 .and. kSESQ.lt.nspec+1) .OR.
     &                    (idmech.eq.7 .and. kSQT.lt.nspec+1)))
     &            con(kSQT) = amax1( con_prec(ISOAP_SQT), bdnl(kSQT) )
                con(kIVOA) = amax1( con_prec(ISOAP_IVOA), bdnl(kIVOA) )
                con(kIVC1) = amax1( con_prec(ISOAP_IVC1), bdnl(kIVC1) )
                con(kIVC2) = amax1( con_prec(ISOAP_IVC2), bdnl(kIVC2) )
                con(kSVOA) = amax1( con_prec(ISOAP_SVOA), bdnl(kSVOA) )
                con(kACG2) = amax1( con_CG(ICG_ACG2), bdnl(kACG2) )
                con(kACG1) = amax1( con_CG(ICG_ACG1), bdnl(kACG1) )
                con(kBCG2) = amax1( con_CG(ICG_BCG2), bdnl(kBCG2) )
                con(kBCG1) = amax1( con_CG(ICG_BCG1), bdnl(kBCG1) )

              endif

            endif
c
c======================== Source Apportion Begin =======================
c
c  --- subtract the current values of the species from the before values
c      to get the delta values ---
c
            if( ltrace ) then
               do ispc=1,nrad
                 delcon(1,ispc) = delcon(1,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 delcon(4,ispc) = delcon(4,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 if( aeropt .NE. 'CF' .OR. aero_flag .EQ. 0 ) then
                     delcon(2,ispc) = delcon(2,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 endif
               enddo
               do ispc=nrad+1,ngas
                 delcon(1,ispc) = delcon(1,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 delcon(4,ispc) = delcon(4,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 if( aeropt .NE. 'CF' .OR. aero_flag .EQ. 0 ) then
                     delcon(2,ispc) = delcon(2,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
                 endif
               enddo
               do ispc=ngas+1,nspec
                 delcon(1,ispc) = delcon(1,ispc) +
     &                               AMAX1(bdnl(ispc),con(ispc))
                 delcon(4,ispc) = delcon(4,ispc) +
     &                               AMAX1(bdnl(ispc),con(ispc))
                 if( aeropt .NE. 'CF' .OR. aero_flag .EQ. 0 ) then
                     delcon(2,ispc) = delcon(2,ispc) +
     &                               AMAX1(bdnl(ispc),con(ispc))
                 endif
               enddo
            endif
c
c======================== Source Apportion End =======================
c
c======================= Process Analysis Begin ========================
c
            if( ldoipr ) then
c
c --- Chemistry change in umol/m3 units (except for HG chemistry) ----
c
               do is=1,nrad
                  cipr(IPR_CHEM, ipa_idx, is) =
     &               cipr(IPR_CHEM, ipa_idx, is) +
     &                           con(is)-conc(i,j,k,is)
               enddo
               do is=nrad+1,ngas
                  cipr(IPR_CHEM, ipa_idx, is) =
     &               cipr(IPR_CHEM, ipa_idx, is) +
     &                  con(is)*convfac-conc(i,j,k,is)
               enddo
            endif
c
c======================== Process Analysis End =========================
c
c
c========================= DDM Begin ===================================
c
c  --- put the changed values back into the gridded array ---
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              if( lhddm )
     &              call hddmadj(.TRUE.,nddmsp,con,sddm)
              call loaddm(.TRUE.,m1,m2,m3,ntotsp,ptconc(iptrsa),
     &                    i,j,k,nddmsp,nspec,ngas,nrad,NHETRXN,sddm,
     &                    convfac)
            endif
c
c========================= DDM End =====================================
c
c
c======================== CSA Begin ====================================
c
c  ---- load the CSA values for this cell into 2-D array ---
c
            if( lcsa ) then
               ipa_idx = ipa_cel(i+i0,j+j0,k)
               if( ipa_idx .GT. 0 ) then
                   icsa_grid = ipadom(ipa_idx)
                   icell = ipax(ipa_idx) - i_sw(icsa_grid) + 1
                   jcell = ipay(ipa_idx) - j_sw(icsa_grid) + 1
                   kcell = ipaz(ipa_idx) - b_lay(icsa_grid) + 1
                   call loadcsa_sens(.TRUE.,ncol_csa(icsa_grid),nrow_csa(icsa_grid),
     &                 nlay_csa(icsa_grid),ntotsp,csaconc(iptrcsa(icsa_grid)),
     &                 icell,jcell,kcell,nddmsp,nspec,ngas,nrad,NHETRXN,sddm,convfac)
              endif
           endif
c
c======================== CSA End ====================================
c
c-----Perform aerosol chemistry if it's time
c
            fcsoa = 0.
            CG_part = 0.
            if ( aero_flag.gt.0 ) then
              cliq = cwc(i,j,k)
              if (lcig(igrd)) cliq = amax1(cliq,cigwtr(i,j,k))
              if (tcell.lt.273.)
     &          cliq = amax1(0.,cliq*(tcell - tamin)/(273. - tamin))
              if( aeropt.eq.'CF' ) then
c
c======================== DDM Begin ====================================
c
c  ---- load the sensitivities for this cell into 2-D array ---
c
                if ( lddm ) then
                  call loaddmpm(.FALSE.,
     &                          m1,m2,m3,ntotsp,ptconc(iptrsa),
     &                          i,j,k,nddmsp,NSDDMPM,sddm,convfac)
                endif
c
c======================== DDM End =======================================
c
                icig = 0
                if (lcig(igrd)) icig = 2
                call aerochem_cf(water(i,j,k),tcell,pcell,cliq,cldph,
     &                           aerph,ajno2(i,j,k),con_NV,con,dcprec,
     &                           CG_part,fcsoa,convfac,dtchem,aero_dt(igrd),
     &                           delcon,sen_NV,sddm,nddmsp,NSDDMPM,
     &                           ldoipr,ipa_idx,aero_flag,.FALSE.,icig,
     &                           ldark(i,j))
c
c========================= DDM Begin ===================================
c
c  --- put the changed values back into the gridded array ---
c
                if ( lddm ) then
                  call loaddmpm(.TRUE.,
     &                          m1,m2,m3,ntotsp,ptconc(iptrsa),
     &                          i,j,k,nddmsp,NSDDMPM,sddm,convfac)
                endif
c
c========================= DDM End =====================================
c
              endif
            endif
c
c-----Prepare for surface model
c
            if (k.eq.1 .and. lsrfmod) then
              ij = i + (j-1)*m1
              depth = height(i,j,1)
              press0 = press(i,j,1) - depth*(press(i,j,2) - 
     &                        press(i,j,1))/height(i,j,2)
              ucomp = (uwind(i,j,1) + uwind(i-1,j,1))/2.
              vcomp = (vwind(i,j,1) + vwind(i,j-1,1))/2.
              wind = sqrt(ucomp**2 + vcomp**2)
              wind = amax1(0.1,wind)
              do l = 1,NLU
                flu(l) = fsurf(i,j,l)
              enddo
              do lsm = 1,nsmspc
                soil(lsm) = solmas(i,j,lsm)
                vegy(lsm) = vegmas(i,j,lsm)
              enddo

              call srfmod(datec(igrd),dtchem,dx(j+j0),dy,cellat(i,j),
     &                    cellon(i,j),snow(i,j),snowrat(i,j),
     &                    snowfrc(i,j),snowalb(i,j),zenith,ctrns,
     &                    ldark(i,j),pwr(i,j,1),tempk(i,j,1),tsurf(i,j),
     &                    press(i,j,1),press0,wind,depth,nsmspc,
     &                    flu,lrdlai,lai(i,j),soil,vegy,reemit)

              do lsm = 1,nsmspc
                solmas(i,j,lsm) = soil(lsm)
                vegmas(i,j,lsm) = vegy(lsm)
                reemis(i,j,lsm) = reemit(lsm)
              enddo
            endif
c
c========================= Hg Chemistry Begin ==========================
c
c-----Call Hg chemistry modules
c
            if (khg0.lt.nspec+1) then
c
c-----Assign Cl2, Br and BrO concentrations based on height(km), ocean
c-----and day/night
c
              do ihg = 1,NHTHAL
                if (hght .le. hthal(ihg)) then
                  iht = ihg
                  go to 115
                endif
              enddo
              iht = NHTHAL
 115          continue
              brc = 0.
              broc = 0.
              cl2c =  0.0

              if (.not. ldark(i,j)) then
                if (iocean .eq. 1) then
                  brc  = brwprof(iht)
                  broc = browprof(iht)
                  cl2c = cl2day(iht)
                else
                  brc  = brlprof(iht)
                  broc = brolprof(iht)
                endif
              else
                cl2c = cl2nite(iht)
              endif
c
c-----Gas-phase chemistry
c
c
c-----Put adsorbed Hg(II) into gas-phase Hg(2) for chemistry calculations
c-----convert adsorbed Hg(II) to ppm before adding
c
              convhgfac = MWHG*convfac
              thg2 = con(khg2) + (con(khgiip)+con(khgiipc))/convhgfac
              thg20 = thg2 ! For process analysis 
              call hggaschem(con(khg0),thg2,con(ko3),
     &                       con(kh2o2),con(koh),brc,broc,
     &                       tcell,pcell,dt)
              con(khg0) = max(bdnl(khg0),con(khg0))
              thg2 = max(bdnl(khg2),thg2)
c
c======================= Process Analysis Begin ========================
c
              if( ldoipr ) then
                chg0 = con(khg0)*convfac ! store HG0 in umol/m3
                chg2 = thg2*convfac ! store total HG2 in umol/m3
                cipr(IPR_CHEM, ipa_idx, khg0) =
     &            cipr(IPR_CHEM, ipa_idx, khg0) +
     &              chg0 - conc(i,j,k,khg0)
                cipr(IPR_CHEM, ipa_idx, khg2) =
     &            cipr(IPR_CHEM, ipa_idx, khg2) +
     &              chg2 - thg20*convfac
              endif
c
c======================== Process Analysis End =========================
c
c-----Aqueous-phase chemistry (conditional)
c
              cliq = cwc(i,j,k)
              if (tcell.lt.273.) then
                cliq = amax1(0.,cliq*(tcell - tamin)/(273. - tamin))
              endif
              if (cliq.ge.cwmin .and. tcell.ge.tamin ) then
c
c-----Calculate total PM concentrations
c
                henso2 = henry0(kso2)
                tfso2  = tfact(kso2)
                heno3  = henry0(ko3)
                tfo3   = tfact(ko3)
                pm10   = 0.
                do is = ngas+1,nspec
                  if (is.ne.kph2o) pm10 = pm10 + con(is)
                enddo
                call hgaqschem(con(khg0),thg2,con(ko3),
     &                         con(kso2),con(koh),con(kho2),
     &                         con(khcl),cl2c,pm10,cldph,cliq,
     &                         tcell,pcell,dt,henso2,tfso2,
     &                         heno3,tfo3)
                con(khg0) = max(bdnl(khg0),con(khg0))
                thg2 = max(bdnl(khg2),thg2)
c
c======================= Process Analysis Begin ========================
c
                if( ldoipr ) then
                  cipr(IPR_AQCHEM, ipa_idx, khg0) =
     &              cipr(IPR_AQCHEM, ipa_idx, khg0) +
     &                con(khg0)*convfac - chg0
                  cipr(IPR_AQCHEM, ipa_idx, khg2) =
     &              cipr(IPR_AQCHEM, ipa_idx, khg2) +
     &                thg2*convfac - chg2
                endif
c
c======================== Process Analysis End =========================
c
              endif
c
c-----Adsorption of Hg(2) to particles
c-----Calculate volume concentrations of fine & coarse primary particles
              vfine   = 0.
              if(kpec  < nspec+1)vfine = vfine + con(kpec)/roprt(kpec)
              if(khoa  < nspec+1)vfine = vfine + con(khoa)/roprt(khoa)
              if(kfprm < nspec+1)vfine = vfine + con(kfprm)/roprt(kfprm)

c-----Add sea-salt to vfine

              if(kna == nspec+1)then
                vseas = nacl/RHOSEAS
              else  ! If Na is a modeled species, then PCl is too
                cna = con(kna)/MWNA
                cpcl = con(kpcl)/MWCL
                if(cna < cpcl) then
                  vseas = cna*MWNACL/roprt(kna)
                else
                  vseas = cpcl*MWNACL/roprt(kpcl)
                end if
              end if
              vfine = vfine + vseas
              dfine = sqrt(dcut(kph2o,1)*dcut(kph2o,2)) !H2O is a reqd. species
c
              vcoarse = 0.
              if (kccrs < nspec+1) then
                vcoarse = vcoarse + con(kccrs)/roprt(kccrs)
                dcoarse = sqrt(dcut(kccrs,1)*dcut(kccrs,2))
              end if
              if (kcprm < nspec+1) then
                vcoarse = vcoarse + con(kcprm)/roprt(kcprm)
                dcoarse = sqrt(dcut(kcprm,1)*dcut(kcprm,2))
              end if
c
c-----calculate number conc, surface area conc of fine and coarse primary PM
              if (vfine > 0.)then
                fseas = vseas/vfine
                fseas = MAX(0.0,MIN(1.0,fseas))
                safine = 6.0 * vfine / dfine  ! Units: m2/m3
              else
                fseas = 1.0
                safine = 0.0
              end if
              if (vcoarse > 0.)then
                sacoarse = 6.0 * vcoarse / dcoarse  ! Units: m2/m3
              else
                sacoarse = 0.0
              end if
c
              if (safine > 0. .or. sacoarse > 0.) then
                chgiip  = 0.
                chgiipc = 0.
                chg2    = thg2 * convhgfac ! in ug/m3
                call hgadsorb(tcell,chg2,chgiip,chgiipc,fseas,safine,
     &                        sacoarse)
c
c-----assign total hg2 back to individual species
                con(khg2)    = chg2/convhgfac  ! back to ppm
                con(khg2)    = max(bdnl(khg2),con(khg2))
                con(khgiip)  = max(bdnl(khgiip),chgiip)
                con(khgiipc) = max(bdnl(khgiipc),chgiipc)
              else
                con(khg2)    = thg2
                con(khgiip)  = bdnl(khgiip)
                con(khgiipc) = bdnl(khgiipc)
              endif

            endif
c
c========================== Hg Chemistry End ===========================
c
c
c======================== Source Apportion Begin =======================
c
c  --- subtract the current values of the species from the before values
c      to get the delta values ---
c
            if( ltrace ) then
               do ispc=1,nrad
                  cnew(ispc) = con(ispc)*convfac
                  delcon(3,ispc) = delcon(3,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
               enddo
               do ispc=nrad+1,ngas
                  cnew(ispc) = con(ispc)*convfac
                  delcon(3,ispc) = delcon(3,ispc) +
     &                     AMAX1(bdnl(ispc),con(ispc)) * convfac
               enddo
               do ispc=ngas+1,nspec
                  cnew(ispc) = con(ispc)
                  delcon(3,ispc) = delcon(3,ispc) +
     &                               AMAX1(bdnl(ispc),con(ispc))
               enddo
               o3new = AMAX1(bdnl(ko3),con(ko3))
c
               if( ldark(i,j) ) then
                 desto3 = delcon(2,ko3)
                 prdo3n = 0.0
                 prdo3v = 0.0
               else
                 if( lozone ) then
                    call o3prdsa(rrxn_irr,convfac,delcon(2,ko3),
     &                                         prdo3n,prdo3v,desto3)
                    if( delcon(2,ko3) .lt. desto3 ) then
                       desto3 = delcon(2,ko3)
                       prdo3n = 0.0
                       prdo3v = 0.0
                    endif
                 endif
               endif
c
c  --- rrxn_irr: ppm -> umol/m3
c
               if( ltrapirr ) then
                  do irxn=1,nreact
                     rrxn_irr(irxn) = rrxn_irr(irxn) * convfac
                  enddo
               endif
c
c  --- SA: call routine to do the tracer species "chemistry", just makes
c      adjustments for production or decay of the regular model species ----
c
               if( lozone .OR. lnitrate ) then
                  call osatsa(m1,m2,m3,igrd,i,j,k,prdo3n,prdo3v,desto3,
     &                        nspec,delcon,convfac,cold,rrxn_irr,dtchem)
               endif
c
               if( lsulfate .OR. lnitrate .OR. lsoa 
     &                              .OR. lprimary .OR. lmercury ) then
                  call psatsa(m1,m2,m3,igrd,i,j,k,nspec,delcon,
     &                        NPREC_S,yfac,dcprec,CG_part,fcsoa,
     &                        convfac,lrepart)
                  call repartsa(m1,m2,m3,igrd,i,j,k,cnew)
               endif
            endif
c
c  --- RTRAC chemistry
c
            if( tectyp .EQ. RTRAC ) then
               if (nrtherm .GT. 0 .OR. nrtphot .GT. 0 ) then
                 if( ipa_cel(i+i0,j+j0,k) .GT. 0 )  then
                    irt_cel = ipa_cel(i+i0,j+j0,k)
                 else
                    irt_cel = -9
                 endif
                 call chemrt(m1,m2,m3,igrd,i,j,k,i0,j0,pcell,tcell,cold,cnew,
     &                     avgcnc(koh),avgcnc(ko3),avgcnc(kno3),dtchem,irt_cel)
               endif
               if( lparttn )
     &            call partitionrt(m1,m2,m3,nspec,igrd,i,j,k,cnew)
               if( k.eq.1 .and. lsrfmodrt )
     &            call srfmodrt(m1,m2,igrd,i,j,dtchem,zenith,ctrns,
     &                          ldark(i,j))
c
c  --- RTCMC chemistry
c
            else if( tectyp .EQ. RTCMC ) then
c
c  --- set rate constants
c
               if( ktype .EQ. 1 ) then
                  call krtc(tcell,pcell)
               else
                  call ksci(tcell,pcell)
               endif
               if( njschm .GT. 0 ) then
                  do nj = 1,njschm
                     srkrtc(ijschm(nj)) = 0.
                     if (ijpntr(nj).gt.0) then
                       srkrtc(ijschm(nj)) = rk(ijpntr(nj))*jscale(nj)
                     else
                       do nz = nzschm,1,-1
                          if( zenith .LE. zenschm(nz) )
     &                       srkrtc(ijschm(nj)) = rjschm(nz,nj)*ctrns
                       enddo
                     endif
                     rkrtc(ijschm(nj))  = DBLE( srkrtc(ijschm(nj)) )
                  enddo
               endif
c
c  --- do chemistry
c
               do l = 1,ntotsp
                  idx = DBLE(iptrsa-1) + DBLE(i) + 
     &                 DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                                 DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(l-1)
                  rtcon(l) = ptconc(idx)/convfac
               enddo
               if( isolv .EQ. 1) then
                  call dlsdrv(dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                           avgcnc,rtcon,ierr,.false.)
               elseif( isolv .EQ. 2) then
                  call slsdrv(dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                           avgcnc,rtcon,ierr,.false.)
               elseif( isolv .EQ. 3) then
                  call rbkdrv(dtchem,water(i,j,k),atm,O2,CH4,H2,
     &                           avgcnc,rtcon,ierr,.false.)
               endif
               do l = 1,ntotsp
                  idx = DBLE(iptrsa-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                               DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(l-1)
                  ptconc(idx) = rtcon(l)*convfac
               enddo
            endif
c
c========================= Source Apportion End ========================
c
c
c======================= Process Analysis Begin ========================
c
c --- Chemical reaction tracking in ppm units
c     Account for titration reaction in TRAP at night ---
c
            if( ldoirr ) then
              do irxn=1,nirrrxn
                cirr(ipa_idx, irxn) =
     &                   cirr(ipa_idx, irxn) + rrxn_irr(irxn)
              enddo
              if ( titrt .GT. 0.0 ) then
                if ( idmech.EQ.5 ) then
                  cirr(ipa_idx, 7) =
     &                     cirr(ipa_idx, 7) + titrt
                else
                  cirr(ipa_idx, 3) =
     &                     cirr(ipa_idx, 3) + titrt
                endif
              endif
            endif
c
c   --- calculate the chemical process analysis (CPA) variables
c       time weight CPA variables that are not cumulative by dtfact ---
c
            if( lirr .AND. (l3dflag .OR. k .EQ. 1) ) then
               nn = 0
               dtfact = dt/dtout/60.
               if( idmech.EQ.1 ) then
                 call cpamech1(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               elseif( idmech.EQ.3 ) then
                 call cpamech3(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               elseif( idmech.EQ.4 ) then
                 call cpamech4(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               elseif( idmech.EQ.5 ) then
                 call cpamech5(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               elseif( idmech.EQ.7 ) then
                 call cpamech7(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               elseif( idmech.EQ.9 ) then
                 call cpamech9(rrxn_irr,rk,dtfact,MXREACT,patmp,ntotsp,
     &                                                    nn,ldark(i,j))
               else
                 write(iout,'(//,a)') 'ERROR in CHEMDRIV:'
                 write(iout,'(2A,I2)')'Chemical Process Analysis (CPA)',
     &                   ' does not support chemical mechanism: ',idmech
                 write(iout,*)
     &                  'Please choose another mechanism and try again.'
                 call camxerr()
               endif
c
c  --- save the cloud adjustment to photolysis rates ---
c
               nn = nn + 1
               ptname(nn)  = 'J_CLDADJ'
               patmp(nn) = ctrns * dtfact
c
c  --- save the aerosol pH ---
c
               nn = nn + 1
               ptname(nn)  = 'AER_PH'
               patmp(nn) = aerph * dtfact
c    
c  --- save radical concentrations unless accumulating throught run ---
c
               if( .NOT. lcpacum)
     &           call cparad(con, ngas, patmp, ntotsp, nn, dtfact)
c
c  --- add CPA values to gridded array in native units ---
c
               do l=1,ntotsp
                 idx = DBLE(iptrsa-1) + DBLE(i) + 
     &                 DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                              DBLE(m1)*DBLE(m2)*DBLE(nlay)*DBLE(l-1)
                 ptconc(idx) = ptconc(idx) + patmp(l)
               enddo
            endif
c
c======================== Process Analysis End =========================
c
c-----Pass CON back to concentration, convert gases from ppm to umol/m3
c
 88         continue
            cph(i,j,k) = cldph
            aph(i,j,k) = aerph
            do is=1,nrad
              conc(i,j,k,is) = con(is)
            enddo
            do is=nrad+1,ngas
              conc(i,j,k,is) = con(is)*convfac
            enddo
            if (ngas.lt.nspec) then
              do is=ngas+1,nspec
                conc(i,j,k,is) = amax1(con(is),bdnl(is))
              enddo
            endif
c
  89      continue
  90    continue
c
c$omp end parallel
c       sumit(k) = 1.
c       nitsum(k) = 1
c       do i = ia,iz
c         do j =  ja,jz
c           sumit(k) = sumit(k) + avit(i,j)
c           if (idfin(i,j).le.igrd ) nitsum(k) = nitsum(k) + 1
c         enddo
c       enddo
c
  91  continue
c     write(idiag,'(a,2i5,2f8.1)')
c    &   ('EBI ',igrd,k,timec(igrd),sumit(k)/nitsum(k),k=1,nlay)
c
c-----If aerosol chemistry was called
c     - reset aero_dt & ajno2
c     - increase time_aero (& date_aero) by dt_aero (or multiple of dt_aero)
c
      if (aero_flag.EQ.2) then
        aero_dt(igrd) = 0.0
        ajno2 = 0.0
  92    continue
        call uptime(time_aero(igrd),date_aero(igrd),60.*dt_aero)
        if ( time_aero(igrd) .le. timec(igrd) .and.
     &       date_aero(igrd) .eq. datec(igrd) ) goto 92
      endif
c
      return
      end

      subroutine exptbl(iunits,rxntyp,rxnord,rxnpar)
      use chmstry
c 
c----CAMx v7.40 260801
c 
c     EXPTBL calculates a lookup table for temperature/pressure-dependent
c     rate constants using parameters from the chemistry parameters file.
c     The pressure and temperature dependance of the conversion factor from
c     cm3 molec-1 units to ppm units is accounted for.
c     The expression types supported are:
c       Type 1 Temperature independent
c       Type 2 UAM/OZIPM format Arrhenius
c       Type 3 Generalized temperature dependent
c       Type 4 Troe teperature/pressure dependent
c       Type 5 Equilibrium constant ratio to another reaction
c       Type 6 Lindemann-Hinshelwood used for OH + HNO3
c       Type 7 k = k1 + k2[M] used for OH + CO and HO2 self-reaction
c     During the model run rate constants are always interpolated from 
c     the lookup table.  The output rate constants in RKTBL have units
c     ppm-n hour-1.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        09/15/04            Accept rate constants in cms units
c        10/20/05            Restructured the definition of the bins in
c                            the temperature and pressure lookup table
c        07/21/06            Fixed bug in unit conversion for rxn type 7
c        01/08/07            Fixed bug in pressure dependence term
c        12/07/14            Fixed bug in adjustment factor for rxn type 5
c        06/29/15            Explicitly cast variables in expressions
c 
c     Input arguments: 
c        iunits              input units for rate expressions 
c                              1 = ppm and minutes (ppm)
c                              2 = molec/cm3 and sec (cms)
c        rxntyp              rate constant expression type
c        rxnord              order of reaction
c        rxnpar              rate constant expression parameters
c 
c     Output arguments: 
c        none
c             
c     Routines Called:
c        none
c             
c     Called by: 
c        READCHM
c
      include "camx.prm"
c
c-----Conversions from molecule cm-3 to ppm and from hr to min to sec
c       CF1 from gas law: (n/V) = NP/RT
c       CF1 = (6.022e23 * 1.013e5 * 1e-6 ) / (8.314 * 298.0)
c     The CF1 conversion is at 298 K and 1013 mb and the
c     adjustment "factor" below generalises to other conditions
c
      double precision darren
      double precision CF1, M2H, S2M
      parameter (CF1 = 2.462d13)
      parameter (M2H = 60.d0)
      parameter (S2M = 60.d0)
c
      double precision rxnpar(MXREACT,12)
      integer rxntyp(MXREACT)
      integer rxnord(MXREACT)
c
      double precision cf, cfm, rktmp, factor, af, afm
      double precision dtmp, dprs
      double precision rk0, rk1, rk2, rk3, ratio
      integer i, j, k, iref
      real del_t, del_p
c
c-----Entry point
c
      del_t = (TEMPHI - TEMPLO) / float(NTEMPR - 1)
      del_p = (PRESHI - PRESLO) / float(NPRESR - 1)
      do j = 1,NTEMPR
        tempr(j) = TEMPLO + float(j-1)*del_t
      enddo
      do k = 1,NPRESR
        presr(k) = PRESLO + float(k-1)*del_p
      enddo
c
c-----Fill lookup table
c
      do i = 1,nreact
        if (iunits .EQ. 1) then
          cf  = 1.d0
          cfm = 1.d0
        else
          cf  = S2M * CF1**dble( (rxnord(i)-1) )
          cfm = S2M * CF1**dble( (rxnord(i)) )
        endif
c
        do j = 1,NTEMPR
          dtmp = dble( tempr(j) )
c
          do k = 1,NPRESR
            dprs = dble( presr(k) )
            factor = (298.d0/dtmp)*(dprs/1013.d0)
            af     = cf  * factor**dble( rxnord(i)-1 )
            afm    = cfm * factor**dble( rxnord(i) )
c
            if (ABS(rxntyp(i)).eq.1) then
              rktbl(i,j,k) = sngl( rxnpar(i,1)*af*M2H )
c
            elseif (ABS(rxntyp(i)).eq.2) then
              rktmp = rxnpar(i,2)*(1.d0/298.d0 - 1.d0/dtmp)
              rktbl(i,j,k) = sngl( rxnpar(i,1)*dexp(rktmp)*af*M2H )
c
            elseif (ABS(rxntyp(i)).eq.3) then
              rktbl(i,j,k) = sngl( darren(rxnpar(i,1),rxnpar(i,2),
     &                       rxnpar(i,3),rxnpar(i,4),dtmp)*af*M2H )
c
            elseif (ABS(rxntyp(i)).eq.4) then
              rk0 = darren(rxnpar(i,1),rxnpar(i,2),
     &              rxnpar(i,3),rxnpar(i,4),dtmp)*afm*1.d6
              ratio = rk0/(darren(rxnpar(i,5),rxnpar(i,6),
     &              rxnpar(i,7),rxnpar(i,8),dtmp)*af)
              rktbl(i,j,k) =  sngl(
     &          (rk0/(1.d0+ratio))*rxnpar(i,9)**(1.d0/(1.d0+
     &          (0.43429d0*dlog(ratio)/rxnpar(i,10))**2.d0))*M2H )
c
            elseif (ABS(rxntyp(i)).eq.5) then
              iref = nint(rxnpar(i,1))
              if (iunits .EQ. 1) then
                af = factor**dble( rxnord(iref)-rxnord(i) )
              else
                af = (CF1*factor)**dble( rxnord(iref)-rxnord(i) )
              endif
              rktmp = darren(rxnpar(i,2),rxnpar(i,3),
     &                rxnpar(i,4),rxnpar(i,5),dtmp)*af
              rktbl(i,j,k) = sngl( rktbl(iref,j,k) / rktmp )
c
            elseif (ABS(rxntyp(i)).eq.6) then
              rk1 = darren(rxnpar(i,1),rxnpar(i,2),
     &              rxnpar(i,3),rxnpar(i,4),dtmp)*af
              rk2 = darren(rxnpar(i,5),rxnpar(i,6),
     &              rxnpar(i,7),rxnpar(i,8),dtmp)*af
              rk3 = darren(rxnpar(i,9),rxnpar(i,10),
     &              rxnpar(i,11),rxnpar(i,12),dtmp)*afm*1.d6
              rktbl(i,j,k) = sngl( (rk1 + (rk3 / 
     &                             (1.d0+(rk3/rk2))))*M2H )
c
            elseif (ABS(rxntyp(i)).eq.7) then
              rk1 = darren(rxnpar(i,1),rxnpar(i,2),
     &              rxnpar(i,3),rxnpar(i,4),dtmp)*af
              rk2 = darren(rxnpar(i,5),rxnpar(i,6),
     &              rxnpar(i,7),rxnpar(i,8),dtmp)*afm*1.d6
              rktbl(i,j,k) = sngl( ( rk1 + rk2 )*M2H )
c
            endif
          enddo
        enddo
      enddo
c
      return
      end
c
      function darren(a,ea,b,tref,dtmp)
c
c --- Calculate a rate constant using k = A*(T/Tref)^B*exp(-Ea/T)
c
      double precision darren
      double precision a,ea,b,tref,dtmp
c
      darren = a*((dtmp/tref)**b)*dexp(-ea/dtmp)
c
      end

      subroutine wrtirrhdr(ibgdat,btim,iendat,etim)
      use filunit
      use grid
      use chmstry
      use camxcom
      use procan
c
c----CAMx v7.40 260801
c
c     This routine writes the header to the output file for the Integrated
c     Reaction Rates (IRR) data for the Process Analysis algorithm.  The 
c     header data is designed to provide information about what data is 
c     contained in the rest of the file.
c
c      Copyright Ramboll
c
c     Modifications:
c        11/06/01  Input dates are now Julian
c        12/03/03  Fixed bug in writing orgin of coarse grid
c
c     Input arguments:
c        btim       starting time for this period
c        ibgdat     starting date for this period (YYJJJ)
c        etim       ending time for this period
c        iendat     ending date for this period (YYJJJ)
c
c     Subroutines Called:
c        none
c
c     Called by:
c        STARTUP
c
      include "camx.prm"
c
c-----Argument declarations
c
      integer ibgdat,iendat
      real    btim,etim 
c
c-----Local variables
c
c-----Entry point
c
c --- write the date and time of the simulation ---
c
      write(irr_unit,ERR=7000) runmsg
      write(irr_unit,ERR=7000) ibgdat, btim, iendat, etim 
c
c --- write the information about the grids ---
c
      write(irr_unit,ERR=7000) ngrid
      write(irr_unit,ERR=7000) xorg, yorg, ncol(1), nrow(1),
     &                                     delx, dely, iuzon
      do igrd=2,ngrid
        xsize = delx / FLOAT( meshold(igrd) )
        ysize = dely / FLOAT( meshold(igrd) )
        orgx = (inst1(igrd)-1)*delx + xorg - xsize
        orgy = (jnst1(igrd)-1)*dely + yorg - ysize
        write(irr_unit,ERR=7000) orgx, orgy, ncol(igrd), nrow(igrd), 
     &                                          xsize, ysize, iuzon
      enddo
c
c --- write out the sub-domain information ---
c
      write(irr_unit,ERR=7000) npadom
      do idom=1,npadom
         write(irr_unit,ERR=7000) ipagrd(idom), i_sw(idom), i_ne(idom),
     &                  j_sw(idom), j_ne(idom), b_lay(idom), t_lay(idom)
      enddo
c
c ---- write the number of reactions ----
c
      write(irr_unit,ERR=7000) nirrrxn
c      
      goto 9999
c
c----Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in WRTIRRHDR:'
      write(iout,'(1X,2A)',ERR=9999) 'Writing header to the output ',
     &                         'Integrated Reaction Rates (.irr) file.'
      call camxerr()
c
 9999 continue
      return
      end

*** EMPREPRT
c
      subroutine empreprt(idate,btim,igrid)
      use filunit
      use grid
      use chmstry
      use ptemiss
      use rtracchm
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads the emissions files for the RTRAC and moves the 
c   file pointer to the first hour to be used in this run.
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c      01/16/02   --gwilson-- original development
c      11/12/03   --cemery -- Changed to handle optional area/pt files, 
c                             and to check Rtrac point source file against 
c                             regular model pt file
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   igrid
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      integer MXOUT
c
      parameter (MXOUT = MAX(MXSPEC,MXTRSP))
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  namein
      character*4   ifname(10), ifnote(60)
      integer       nseg, nspect, ipt, numpts, numpts_lst, igrd, ii, jj
      integer       ispc, ibgdat, iendat, buffer_offset
      integer       idateb, idatee, nxcelt, nycelt, nzcelt
      integer       idum, izonet, iounit, isegm, npoint
      integer       i, j, ndate, seg4(4)
      real          tutmx, tutmy, tdxcel, tdycel
      real          tbegti, tendti, begtim, endtim, dum
      real          txorig, tyorig, ttime
      logical       luse
c
      character*4 iname(10,MXOUT)

      real,    allocatable, dimension(:) :: xlocin
      real,    allocatable, dimension(:) :: ylocin
      real,    allocatable, dimension(:) :: hstkin
      real,    allocatable, dimension(:) :: dstkin
      real,    allocatable, dimension(:) :: tstkin
      real,    allocatable, dimension(:) :: vstkin
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- set the date and time ---
c
      ndate = idate
      ttime = btim/100.0
      if( ttime .EQ. 24.0 ) then
         ndate = ndate + 1
         ttime = 0.
         if( MOD(ndate,1000) .GT. 365 ) then
            if( MOD(INT(ndate/1000),4) .EQ. 0 ) then
               if( MOD(ndate,1000) .EQ. 367 )
     &                     ndate = (INT(ndate/1000)+1)*1000 + 1
            else
               ndate = (INT(ndate/1000)+1)*1000 + 1
            endif
         endif
      endif
c
c   --- only read if surface emissions file is supplied ---
c
      if( .NOT. is_netcdf_iortem(igrid,1,1) .AND. ltemfl(igrid,1,1) 
     &                                           .AND. larsrc ) then
        iounit = iortem(igrid,1,1)
        fname = temfil(igrid,1,1)
c
c   --- rewind the file ----
c
        rewind(iounit,ERR=7005)
c
c   --- read the header of the emissions file ---
c
        read(iounit,ERR=7000) ifname, ifnote, nseg, nspect, idateb, 
     &                                        tbegti, idatee, tendti
        if( nspect .GT. MXSPEC ) then
          write(iout,'(//,A)') 'ERROR in EMPREPRT:'
          write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
          write(iout,*)
     &                    'Please change the value for parameter: MXTRSP'
          write(iout,*) 'It should be set to a value of at least: ',
     &                                                             nspect
          call flush(iout)
          call camxerr()
        endif
c
        read(iounit,ERR=7000) tutmx, tutmy, izonet, txorig,tyorig, 
     &                           tdxcel, tdycel, nxcelt, nycelt, nzcelt
        read(iounit,ERR=7000) seg4
        read(iounit,ERR=7000) ((iname(i,ispc),i=1,10),ispc=1,nspect)
        buffer_offset_iortem(igrid,1,1) = 0
        if( nxcelt .EQ. ncol(igrid)-2 .AND. nycelt .EQ. nrow(igrid)-2 )
     &                                buffer_offset_iortem(igrid,1,1) = 1
        buffer_offset = buffer_offset_iortem(igrid,1,1)
c
c   --- set up index for species names ---
c
        nspcem(igrid,1,1) = nspect
        do ispc=1,nspcem(igrid,1,1)
           write(namein,'(10A1)') (iname(i,ispc),i=1,10)
           luse = .FALSE.
           do j=1,ntotsp
             if(namein .EQ. ptname(j) ) then
                 idxems(igrid,1,1,ispc) = j
                 luse = .TRUE.
             endif
           enddo
c
c  --- if not found in model species list, write a message ----     
c   
           if( .NOT. luse ) then
                write(idiag,'(1X,4A)') 'Species in RTRAC ',
     &              'surface emissions file: ',namein(:istrln(namein)),
     &                      ' not found in species list ... Skipping.'
           endif
        enddo
c
c   --- read the data until the correct position in the file is reached ---
c
  111   continue
        read(iounit,ERR=7002,END=7003) ibgdat, begtim, iendat, endtim
        if( le1day ) then
           if( INT(begtim) .EQ. INT(ttime) ) goto 222
        else
           if( ibgdat .EQ. ndate .AND. 
     &                    INT(begtim) .EQ. INT(ttime) ) goto 222
        endif
        do ispc=1,nspcem(igrid,1,1)
            read(iounit,ERR=7002,END=7003) idum, 
     &          (dum,i=1,10),((dum,i=1+buffer_offset,ncol(igrid)-buffer_offset),
     &                                j=1+buffer_offset,nrow(igrid)-buffer_offset)
        enddo
        goto 111
  222   continue
        backspace(iounit)
c
      endif
c
c   --- point sources are only for the coarse grid -- grid #1 ---
c
      if( igrid .GT. 1 ) goto 9999
c
c   --- only read if elevated point source emissions file is supplied ---
c
      if( .NOT. ltptfl(1,1) ) goto 9999
      if( .NOT. lptsrc ) goto 9999
      if( is_netcdf_iortpt(1,1) ) goto 9999
      iounit = iortpt(1,1)
      fname = tptfil(1,1)
c
c   --- rewind the file ----
c
      rewind(iounit,ERR=7005)
c
c   --- read the header of the emissions file ---
c
      read(iounit,ERR=7000) ifname, ifnote, nseg, nspect, idateb, 
     &                                         tbegti, idatee, tendti
      if( nspect .GT. MXTRSP ) then
          write(iout,'(//,A)') 'ERROR in EMPREPRT:'
          write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
          write(iout,*)
     &                    'Please change the value for parameter: MXTRSP'
          write(iout,*) 'It should be set to a value of at least: ',
     &                                                             nspect
          call flush(iout)
          call camxerr()
      endif
c
      read(iounit,ERR=7000) tutmx, tutmy, izonet, txorig, tyorig, 
     &                          tdxcel, tdycel, nxcelt, nycelt, nzcelt
      read(iounit,ERR=7000) seg4
      read(iounit,ERR=7000) ((iname(i,ispc),i=1,10),ispc=1,nspect)
c
c   --- set up index for species names ---
c
      nspcpt(1,1) = nspect
      do ispc=1,nspcpt(1,1)
         write(namein,'(10A1)') (iname(i,ispc),i=1,10)
         luse = .FALSE.
         do j=1,ntotsp
           if(namein .EQ. ptname(j) ) then
               idxpts(1,1,ispc) = j
               luse = .TRUE.
           endif
         enddo
c
c  --- if not found in model species list, write a message ----
c  
         if( .NOT. luse ) then
              write(idiag,'(1X,4A)') 'Species in RTRAC ',
     &            'point emissions file: ',namein(:istrln(namein)),
     &                    ' not found in species list ... Skipping.'
         endif
      enddo
      read(iounit,ERR=7000) isegm, npoint
c
c --- allocate local arrays ---
c
      allocate( xlocin(npoint) )
      allocate( ylocin(npoint) )
      allocate( hstkin(npoint) )
      allocate( dstkin(npoint) )
      allocate( tstkin(npoint) )
      allocate( vstkin(npoint) )
c
      read(iounit,ERR=7002) (xlocin(i),ylocin(i),hstkin(i),
     &                     dstkin(i),tstkin(i),vstkin(i),i=1,npoint)
c
c  --- make sure this source is in the base inventory and flag it ---
c
      numpts_lst = nptsrc - npoint
      do ipt=1,npoint
        vstkin(ipt) = vstkin(ipt)/3600.
        numpts_lst = numpts_lst + 1 
        if (llatlon) then
          xstk(numpts_lst,1) = xlocin(ipt) - xorg
          ystk(numpts_lst,1) = ylocin(ipt) - yorg
        else
          xstk(numpts_lst,1) = xlocin(ipt)/1000. - xorg
          ystk(numpts_lst,1) = ylocin(ipt)/1000. - yorg
        endif
        do igrd = 2,ngrid
           xstk(numpts_lst,igrd) = xstk(numpts_lst,1) - (inst1(igrd) - 1)*delx
           ystk(numpts_lst,igrd) = ystk(numpts_lst,1) - (jnst1(igrd) - 1)*dely
           ii = 2 + FLOOR(xstk(numpts_lst,igrd)/delx*FLOAT( meshold(igrd) ) )
           jj = 2 + FLOOR(ystk(numpts_lst,igrd)/dely*FLOAT( meshold(igrd) ) )
           if (ii .GT. 1 .AND. ii .LT. ncol(igrd) .AND.
     &                    jj .GT. 1 .AND. jj .LT. nrow(igrd)) then
              nosrc(igrd) = nosrc(igrd) + 1
              idsrc(nosrc(igrd),igrd) = numpts_lst
              isrc(nosrc(igrd),igrd) = ii
              jsrc(nosrc(igrd),igrd) = jj
           endif
        enddo
        xlocpt(numpts_lst) = xlocin(ipt)
        ylocpt(numpts_lst) = ylocin(ipt)
        xloc(numpts_lst) = xlocin(ipt)
        yloc(numpts_lst) = ylocin(ipt)
        hstk(numpts_lst) = hstkin(ipt)
        dstk(numpts_lst) = dstkin(ipt)
        tstk(numpts_lst) = tstkin(ipt)
        vstk(numpts_lst) = vstkin(ipt)
        lpiglet(numpts_lst) = .FALSE.
        if( dstk(numpts_lst) .LT. 0 ) lpiglet(numpts_lst) = .TRUE.
        idx_point_in_list(1,1,ipt) = numpts_lst
      enddo
c
c  --- deallocate the local arrays ---
c
      deallocate( xlocin )
      deallocate( ylocin )
      deallocate( hstkin )
      deallocate( dstkin )
      deallocate( tstkin )
      deallocate( vstkin )
c
c   --- read the data until the correct position in the file is reached ---
c
  333 continue
      read(iounit,ERR=7002,END=7003) ibgdat, begtim, iendat, endtim
      if( le1day ) then
         if( begtim .EQ. ttime ) goto 444
      else
         if( ibgdat .EQ. ndate .AND. begtim .EQ. ttime ) goto 444
      endif
      read(iounit,ERR=7002) isegm, npoint
      read(iounit,ERR=7002) (idum,idum,idum,dum,dum,i=1,npoint)
      do ispc=1,nspcpt(1,1)
          read(iounit,ERR=7002,END=7003) idum,(dum,i=1,10),
     &                                            (dum,i=1,npoint)
      enddo
      goto 333
  444 continue
      backspace(iounit)
c
c  ---- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in EMPREPRT:'
      write(iout,'(/,1X,3A)') 'Reading header of ',
     &                     'emissions file: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in EMPREPRT:'
      write(iout,'(/,1X,2A)') 'Reading emissions grid in file: ',
     &                                        fname(:istrln(fname))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in EMPREPRT:'
      write(iout,'(/,1X,3A)') 'Premature end-of-file reading ',
     &                     'emissions file: ',fname(:istrln(fname))
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in EMPREPRT:'
      write(iout,'(1X,A,I10,2A)') 'Location for point: ',i,
     &     ' is not consistent with regular emissions in file: ',
     &                                        fname(:istrln(fname))
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in EMPREPRT:'
      write(iout,'(/,1X,3A)') 'Cannot access emissions file',
     &     ' provided for OSAT processing: ',fname(:istrln(fname))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

c*** EBISOLV
c
      subroutine ebisolv(ebirxn,ebirate,hr_hox,hr_nox,hr_nxy,hr_pan,
     &                   hr_xo,
     &                   dtin,H2O,atm,O2,CH4,H2,tcell,ldark,conc,
     &                   avgcnc,avgitr,hddmjac,nfam,sddm,noxin,avgsen,
     &                   lddm,nirrrxn,rrxn_irr,ldoirr)
      use chmstry
      use filunit
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c
c     EBISOLV solves gas-phase chemistry for one time step using
c     the Euler Backward Iterative method with Hertel's explicit
c     solutions for four groups of species.  Subroutines are generated
c     by the Chemical Mechanism Compiler (CMC).
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c        ebirxn            subroutine to calculate reaction rates
c        ebirate           subroutine to calculate species rates
c        hr_hox            subroutine to solve HOx group
c        hr_nox            subroutine to solve NOx group
c        hr_nxy            subroutine to solve NO3 and N2O5
c        hr_pan            subroutine to solve PAN and C2O3
c        hr_xo             subroutine to solve halogen oxides
c        dtin              time duration to be integrated (hr)
c        H2O               water vapor concentration (ppm)
c        atm               total gas concentration (M) in ppm
c        O2                oxygen concentration (ppm)
c        CH4               methane concentration (ppm)
c        H2                hydrogen concentration (ppm)
c        tcell             temperature (K)
c        ldark             logical flag for darkness
c        conc              state species concentrations (ppm)
c        hddmjac           subroutine to calculate Jacobian
c        nfam              number of sensitivity families
c        sddm              sensitivity matrix (ppm)
c        noxin             number of oxidants to store in avgsen
c        lddm              logical flag for DDM sensitivities
c        nirrrxn           number of reactions for IRR
c        ldoirr            logical flag to calculate IRR data
c
c    Outputs:
c        conc              state species concentrations (ppm)
c        avgcnc            average state species concentrations (ppm)
c        avgitr            average inetrations taken per step
c        sddm              sensitivity matrix (ppm)
c        avgsen            average sensitivities of oxidants (ppm)
c        rrxn_irr          integrated reaction rates for IRR
c
c    Subroutines called:
c        EBIRXN            calculate reaction rates
c        EBIRATE           calculate species rate of change
c        HR_HOX            solve HOx group (OH, HO2, HONO, PNA)
c        HR_NOX            solve NOx group (O1D, O, NO, NO2, O3)
c        HR_NXY            solve NO3 and N2O5
c        HR_PAN            solve PAN and C2O3
c        HR_XO             solve halogen oxides
c        DDMEBI
c        CAMXERR
c
c     Called by:
c        CHEMDRIV
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     03/14/08   --gyarwood--    Original development
c     06/01/08   --bkoo--        Added code for DDM
c     08/23/13   --bkoo--        Added avgsen for DDM-PM
c     09/21/13   --bkoo--        Updated DDM-PM for KHETERO
c     01/03/14   --bkoo--        Added organic nitrate hydrolysis rate sensitivities
c     03/18/14   --bkoo--        Added more oxidants to avgsen for benzene SOA
c     07/06/15   --gyarwood--    Report average iterations taken per step
c     07/06/15   --gyarwood--    Revise convergence test
c     02/29/16   --bkoo--        Revised for hetero N2O5 + HCL rxn
c     07/05/16   --gyarwood--    Added HR_XO
c     07/20/16   --bkoo--        Revised for hetero INTR hydrolysis
c     09/02/16   --bkoo--        Set SDDM/KHETSEN array size with # of het rxns
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include "camx.prm"
      include "ddmchm.inc"
      include "chmdbg.inc"
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real     dtin
      real     H2O, atm, O2, CH4, H2, tcell, avgitr
      real     conc(MXSPEC+1), avgcnc(MXSPEC+1)
      logical  ldark
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer    MXY, MXITER, MXSTEP, NXOSLV
      real       RTOL, ATOL, YMIN, YMAX, DTMIN
      parameter (MXY = MXSPEC+1)
      parameter (MXITER = 1000)
      parameter (MXSTEP = 1000)
      parameter (NXOSLV = 30)
      parameter (RTOL = 1.0e-3)
      parameter (ATOL = 1.0e-8)
      parameter (YMIN = 1.0e-18)
      parameter (YMAX = 1.0e3)
      parameter (DTMIN = 1.0e-5)
c
      integer  i, l, ny
      integer  istep, nstep, iter, niter, noconv
      real     y0(MXY), y1(MXY),  yh(MXY), yinit(MXY)
      real     loss(MXY), gain(MXY), rerr(MXY)
      real     rrxn(MXREACT)
      real     dtuse, dtmx, clock, wt
      logical  lavg
c
c-----------------------------------------------------------------------
c    Externals:
c-----------------------------------------------------------------------
c
      external ebirxn, ebirate, hr_hox, hr_nox, hr_nxy, hr_pan, hr_xo
c
c======================== DDM Begin =======================
c
      external hddmjac
      integer  nfam, noxin, ifam, ierr
      real     sddm(nfam,MXSPEC+NHETRXN)
      real     avgsen(nfam,noxin)
      real     ysen(nfam,MXSPEC+1)
      real     khetsen(nfam,NHETRXN)
      logical  lddm, lavgddm
c
c======================== DDM End =======================
c
c========================== Process Analysis Begin =====================
c
      integer  nirrrxn
      real     rrxn_irr(nirrrxn)
      logical  ldoirr
c
c=========================== Process Analysis End ======================
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Load concentrations
c
      ny = ngas
      yh(ny+1) = 0.0 
      y1(ny+1) = 0.0 
      y0(ny+1) = 0.0 
      do i = 1, ngas
        y1(i) = conc(i)
        yinit(i) = conc(i)
        y0(i) = conc(i)
        gain(i) = 0.0
        loss(i) = 0.0
      enddo
c
c --- Set solver parameters
c
      lavg = .true.
      clock = 0.0
      dtmx = 5.01/60.0
      dtmx = dtin/MAX(2, (1+INT(dtin/dtmx)))
      dtuse = dtmx
c
c======================== DDM Begin =======================
c
      if( lddm ) then
        do i = 1, ngas
          do ifam = 1, nfam
            ysen(ifam,i) = sddm(ifam,i)
          enddo
        enddo
        do ifam = 1, nfam
          ysen(ifam,ngas+1) = 0.0
        enddo
        do i = 1, NHETRXN
          do ifam = 1, nfam
            khetsen(ifam,i) = sddm(ifam,nspec+i)
          enddo
        enddo
        lavgddm = .false.
      endif
c
c======================== DDM End =======================
c
c========================== Process Analysis Begin =====================
c
      if (ldoirr) then
        do i = 1, nirrrxn
          rrxn_irr(i) = 0.0
        enddo
      endif
c
c=========================== Process Analysis End ======================
c
c
c --- Integrate in steps until clock reaches dtin
c     istep counts both succesful and non-converged steps
c     abort if istep = MXSTEP or dtuse < DTMIN
c
      niter = 0
      do istep = 1, MXSTEP
        nstep = istep
        if( istep .EQ. MXSTEP) goto 900
c
c --- Iterate this step to convergence
c
        do iter = 1, MXITER
          niter = niter + 1
          do l = 1, ny
            yh(l) = y1(l)
            y1(l) = 0.0
          enddo
c
c --- Calculate species rates
c
          call ebirxn(ny,nreact,yh,H2O,atm,O2,CH4,H2,rk,rrxn)
          call ebirate(ny,nreact,rrxn,gain,loss)
c
c --- Solve all species using Backward Euler method
c
          do 100 l = 1, ny
            y1(l) = (y0(l) + gain(l)*dtuse) 
     &                              / (1.0 + loss(l)*dtuse/yh(l))
            y1(l) = MIN(YMAX, MAX(YMIN,y1(l)))
 100      continue
c
c --- Solve four groups of species using Hertel's equations
c     for the Backward Euler method
c         y0 is the initial conc for this step
c         yh is the last iteration
c         y1 is the next iteration
c
          if( iter .GT. NXOSLV)
     &    call hr_xo (y0,y1,yh,H2O,atm,O2,CH4,H2,ny,rk,rrxn,
     &                 nreact,dtuse)
          call hr_hox(y0,y1,yh,H2O,atm,O2,CH4,H2,ny,rk,rrxn,
     &                 nreact,dtuse)
          call hr_nox(y0,y1,yh,H2O,atm,O2,CH4,H2,ny,rk,rrxn,
     &                 nreact,dtuse)
          call hr_nxy(y0,y1,yh,H2O,atm,O2,CH4,H2,ny,rk,rrxn,
     &                 nreact,dtuse)
          call hr_pan(y0,y1,yh,H2O,atm,O2,CH4,H2,ny,rk,rrxn,
     &                 nreact,dtuse)
c
c --- Check for convergence
c
          noconv = 0
          do l = 1, ny
             rerr(l) = MAX(YMIN,ABS(y1(l)-yh(l)))/MAX(ATOL,yh(l))
             noconv = MAX(noconv, INT(MIN(10.0, rerr(l)/RTOL)))
          enddo
          if( noconv .EQ. 0) goto 200
        enddo
 200    continue
c
c --- Update clock or reduce timestep and try again
c
        if( noconv .GT. 0) then
          dtuse = dtuse*0.5
          if( dtuse .LT. DTMIN) goto 900
          do l = 1, ny
            y1(l) = y0(l)
          enddo
        else
          clock = clock + dtuse
          if( lavg .AND. clock .GT. 0.5*dtin) then
            lavg = .false.
            wt = (clock - 0.5*dtin) / dtuse
            do i = 1, ngas
              avgcnc(i) = MAX(bdnl(i), (wt*y0(i) + (1.0-wt)*y1(i)) )
            enddo
c
c======================== DDM Begin =======================
c
            if ( lddm ) then
              do ifam = 1, nfam ! save sensitivities of previous step
                avgsen(ifam,1) = ysen(ifam,lO)
                avgsen(ifam,2) = ysen(ifam,lOH)
                avgsen(ifam,3) = ysen(ifam,lO3)
                avgsen(ifam,4) = ysen(ifam,lNO3)
                avgsen(ifam,5) = ysen(ifam,lNO)
                avgsen(ifam,6) = ysen(ifam,lHO2)
              enddo
              lavgddm = .true.
            endif
c
c======================== DDM End =======================
c
          endif
c
c======================== DDM Begin =======================
c
          if ( lddm ) then
            call ddmebi(hddmjac,nreact,nfam,ngas,NHETRXN,
     &                  dtuse,H2O,atm,O2,CH4,H2,
     &                  rk,y1,ysen,khetsen,
     &                  lN2O5,lHCL,lNTR2,lHNO3,lCLN2,lINTR,ierr)
            if (ierr.ne.0) then
              write(iout,'(//,a)') 'ERROR in EBISOLV:'
              write(iout,*) 
     &                 'Zero determinant in SGEFA in DDMEBI at ',ierr
              write(iout,*) 'igrd, i, j, k = ', igrdchm,ichm,jchm,kchm
              call camxerr()
            endif

            if ( lavgddm ) then ! calculate average sensitivities
              do ifam = 1, nfam
                avgsen(ifam,1) = ( wt * avgsen(ifam,1) +
     &                               (1.0-wt) * ysen(ifam,lO) )
                avgsen(ifam,2) = ( wt * avgsen(ifam,2) +
     &                               (1.0-wt) * ysen(ifam,lOH) )
                avgsen(ifam,3) = ( wt * avgsen(ifam,3) +
     &                               (1.0-wt) * ysen(ifam,lO3) )
                avgsen(ifam,4) = ( wt * avgsen(ifam,4) +
     &                               (1.0-wt) * ysen(ifam,lNO3) )
                avgsen(ifam,5) = ( wt * avgsen(ifam,5) +
     &                               (1.0-wt) * ysen(ifam,lNO) )
                avgsen(ifam,6) = ( wt * avgsen(ifam,6) +
     &                               (1.0-wt) * ysen(ifam,lHO2) )
              enddo
              lavgddm = .false.
            endif
          endif
c
c======================== DDM End =======================
c
c========================== Process Analysis Begin =====================
c
          if (ldoirr) then
            call ebirxn(ny,nreact,yh,H2O,atm,O2,CH4,H2,rk,rrxn)
            do i = 1, nirrrxn
              rrxn_irr(i) = rrxn_irr(i) + dtuse*rrxn(i)
            enddo
          endif
c
c=========================== Process Analysis End ======================
c
          if( clock/dtin .GT. 0.995) goto 300
          dtuse = MIN(dtuse*2.0, dtmx, dtin-clock)
          do l = 1, ny
            y0(l) = y1(l)
          enddo
        endif
c
c --- Next step
c
      enddo
c
c --- Save species concentrations in CAMx arrays
c
 300  continue
      avgitr = float(niter)/float(nstep)
      do i = 1, ngas
        conc(i) = MAX(bdnl(i), y1(i))
      enddo
c
c======================== DDM Begin =======================
c
      if ( lddm ) then
        do i = 1, ngas
          do ifam = 1, nfam
            sddm(ifam,i) = ysen(ifam,i)
          enddo
        enddo
      endif
c
c======================== DDM End =======================
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error handling:
c-----------------------------------------------------------------------
c
 900  continue
      write(iout,*)
      write(iout,*)' ERROR in the EBISOLV gas-phase chemistry solver'
      write(iout,*)
      write(iout,*) 'ldark, temp(K), water = ',
     &               ldark, tcell, H2O
      write(iout,*) 'M, O2, CH4, H2  = ',
     &               atm, O2, CH4, H2
      write(iout,'(a,i10,3i4)')' igrd, i, j, k =',
     &                           igrdchm,ichm,jchm,kchm
      write(iout,'(a,3f8.5,2i6)')' dtin, clock, dtuse, nstep, niter =',
     &                           dtin, clock, dtuse, nstep, niter
      write(iout,*) 'No  Name      New Conc    Init Conc   Rel Err'
      do l = 1,ngas
        write(iout,905) l, spname(l), y1(l), yinit(l), rerr(l)
      enddo
      write(iout,*) 'No   Rate Constant'
      do l = 1,nreact
        write(iout,910) l, rk(l)
      enddo
      write(iout,*)
c
      call camxerr()
c
 905  format(i3,2x,a7,1p5e12.3)
 910  format(i3,2x,1p3e12.3)
      end

      subroutine cigdrive(m1,m2,m3,i0,j0,ia,iz,ja,jz,igrd,ncol,nrow,
     &                    nlay,nspcs,nspdep,idfin,deltat,densfac,
     &                    dtout,deltax,deltay,mapscl,ldark,depth,tempk,
     &                    press,water,cigfrc,cigwtr,cigph,cigpcp,cwc,
     &                    cph,pwr,pws,pwg,conc,cigmas,depfld,fluxes,
     &                    xmschem,iptrsa,ipa_cel,wetfld,fsurf,rtconc,
     &                    solmass,vegmass,m1rt,m2rt,m3rt,nrtsp)
      use chmstry
      use filunit
      use tracer
      use rtracchm
c
c----CAMx v7.40 260801
c 
c     CIGDRIVE is the transport and chemistry driver for the cloud-in-grid
c     algorithm.  It splits vertical column concentration profiles into in-cloud
c     and ambient, applies convective mass transport matrices to both, calls
c     aqueous chemistry and wet deposition for both, then re-combines final
c     profiles. 
c
c     If CiG is not invoked, this routine just performs wet deposition for
c     the regular gridded concentrations.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        10/13/17 -bkoo-     Added a dummy argument to AEROCHEM_CF call (aerosol pH)
c        10/16/17 -bkoo-     Added a dummy argument to AEROCHEM_CF call (time-weighted JNO2)
c                            Changed DUMARR2 size
c
c     Input arguments:
c        m1                  number of slice columns
c        m2                  number of slice rows
c        m3                  number of slice layers
c        i0                  slice i-offset
c        j0                  slice j-offset
c        ia                  slice computational starting i-index
c        iz                  slice computational ending i-index
c        ja                  slice computational starting j-index
c        jz                  slice computational ending j-index
c        igrd                grid index 
c        ncol                number of grid columns 
c        nrow                number of grid rows 
c        nlay                number of grid layers 
c        nspcs               number of total species
c        nspdep              number of deposition species
c        idfin               map of nested grids in this grid
c        deltat              time step (s)
c        densfac             factor to convert umol/m3 to ppm
c        dtout               output frequency (minutes)
c        deltax              cell size in x-direction (m)
c        deltay              cell size in y-direction (m)
c        mapscl              map scale factor
c        ldark               darkness flag (T=dark)
c        depth               cell depth (m)
c        tempk               temperature field (K)
c        press               pressure field (mb)
c        water               humidity field (ppm)
c        cigfrc              CiG column fractional coverage
c        cigwtr              CiG cloud water (g/m3)
c        cigph               CiG cloud pH
c        cigpcp              CiG precipitation water (g/m3)
c        cph                 cloud water pH
c        cwc                 cloud water content (g/m3)
c        pwr                 rain water content (g/m3)
c        pws                 snow water content (g/m3)
c        pwg                 graupel water content (g/m3)
c        conc                concentration field (umol/m3, ug/m3)
c        cigmas              CiG tracer transport matrix
c             
c     Output arguments: 
c        conc                concentration field (umol/m3, ug/m3)
c        depfld              2-D array of wet deposited mass (mol/ha, g/ha)
c                            and surface liquid concentrations (mol/l, g/l)
c        fluxes              boundary mass fluxes (umol, ug)
c        xmschem             change in grid mass from chemistry (umol)
c             
c     Routines called: 
c        SCAVRAT
c        HENRYFNC
c             
c     Called by: 
c        EMISTRNS
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
      include 'soap.inc'
      include 'chmdbg.inc'
c
      integer m1,m2,m3,i0,j0,ia,iz,ja,jz
      integer igrd,ncol,nrow,nlay,nspcs,nspdep
      integer idfin(m1,m2)
      real deltat,densfac,dtout
      real deltax(nrow),deltay,mapscl(m1,m2)
      real depth(m1,m2,m3)
      real tempk(m1,m2,m3)
      real press(m1,m2,m3)
      real water(m1,m2,m3)
      real cigfrc(m1,m2)
      real cigwtr(m1,m2,m3)
      real cigph(m1,m2,m3)
      real cigpcp(m1,m2,m3)
      real cwc(m1,m2,m3)
      real cph(m1,m2,m3)
      real pwr(m1,m2,m3)
      real pws(m1,m2,m3)
      real pwg(m1,m2,m3)
      real conc(m1,m2,m3,nspcs)
      real depfld(m1,m2,3*nspdep)
      real cigmas(2,m3,m3,m1,m2)
      real*8 fluxes(nspcs,11),xmschem(nspcs)
      logical ldark(m1,m2)

      integer i,j,k,l,kk,ll,ks,ke,n,n1,n2
      integer aero_flag
      real dtchem,area,acig,aamb,tcell,pcell,wcell,
     &     convfac,cldph,cliq,volume,vol
      real tmassi,tmassf,terr
      real ftmp(MXSPEC),depfld1(MXSPEC),depfld2(MXSPEC)
      real con(MXLAYER,MXSPEC,2)
      real cnc(MXLAYER,MXSPEC)
      real dfac(MXLAYER)
      real cc(MXSPEC)
      real dtmp(MXSPEC)
      real dz(MXLAYER),tt(MXLAYER),pp(MXLAYER),cwtr(MXLAYER),
     &     ph(MXLAYER),rwtr(MXLAYER),swtr(MXLAYER),gwtr(MXLAYER)
      real dumvar
      real dumarr1(NNV),dumarr2(7,MXSPEC),dumarr3(MXFDDM*NNV),dumarr4(1)
      real dumarr5(NPREC_S)
      real fluxtmp(MXCELLS,MXCELLS,MXSPEC)
      real dchem(MXCELLS,MXCELLS,MXSPEC)
      common /comcigdrive/ fluxtmp, dchem
c
c======================== Probing Tool Begin ===========================
c
      integer*8 iptrsa
      integer nrtsp,m1rt,m2rt,m3rt
      integer ipa_cel(ncol,nrow,nlay)
      real wetfld(m1,m2,notimespc)
      real rtconc(m1rt,m2rt,m3rt,nrtsp)
      real fsurf(m1,m2,nlu)
      real solmass(m1rt,m2rt,nrtsp),vegmass(m1rt,m2rt,nrtsp)
      real cncrt(MXLAYER,MXTRSP)
c
c========================= Probing Tool End ============================
c
c-----Entry point
c
      do l = 1,nspec
        do j = 1,m2
          do i = 1,m1
            fluxtmp(i,j,l) = 0.
            dchem(i,j,l) = 0.
          enddo
        enddo
      enddo
      dtchem = deltat/3600.
      igrdchm = igrd
      aero_flag = 0
      if (aeropt.EQ.'CF') aero_flag = 1
c
c-----Loop over rows and columns
c
      do 10 j = ja,jz   !2,nrow-1
c
cae$omp parallel default(shared)
cae$omp&  private(i,l,ll,n,n1,n2,ftmp,depfld1,depfld2,k,kk,ks,ke,con,area,
cae$omp&  dz,tt,pp,acig,cnc,cwtr,ph,rwtr,swtr,gwtr,aamb,cncrt,tcell,pcell,
cae$omp&  wcell,convfac,cc,cldph,cliq,tmassi,tmassf,terr,dfac,volume,vol,
cae$omp&  dtmp,dumvar,dumarr1,dumarr2,dumarr3,dumarr4,dumarr5)
cae$omp&  copyin(/ijkgrd/)
c
cae$omp do schedule(dynamic)
c
        do 20 i = ia,iz    !2,ncol-1
          if (idfin(i,j).gt.igrd) goto 20

          do n = 1,2
            do l = 1,nspec
              do k = 1,nlay
                con(k,l,n) = 0.
              enddo
            enddo
          enddo
          do k = 1,nlay
            dfac(k) = press(i,j,k)/tempk(i,j,k)
          enddo
c
c-----Apply convective transfer matrices to split the column profile
c
          if (lcig(igrd) .AND. cigfrc(i,j).gt.0.) then
            
            do l = nrad+1,nspec
              tmassi = 0.
              tmassf = 0.
              do ks = 1,nlay    !Starting layer
                tmassi = tmassi + conc(i,j,ks,l)*depth(i,j,ks)
                do ke = 1,nlay  !Ending layer
                  con(ke,l,1) = con(ke,l,1) + 
     &              conc(i,j,ks,l)*cigmas(1,ke,ks,i,j)*dfac(ke)/dfac(ks)
                  con(ke,l,2) = con(ke,l,2) + 
     &              conc(i,j,ks,l)*cigmas(2,ke,ks,i,j)*dfac(ke)/dfac(ks)
                enddo
              enddo
c
c-----Check for conc < 0 and mass conservation
c
              do k = 1,nlay
                if (con(k,l,1).lt.0. .or. con(k,l,2).lt.0.) then
                  write(iout,'(//,a)') 'ERROR in CIGDRIVE:'
                  write(iout,'(2a)') 'Negative concentration after',
     &                               ' convective transport'
                  write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                  write(iout,*) 'Spec  Name   In-cloud  Ambient'
                  do kk = 1,nlay
                    write(iout,'(i3,2x,a7,2e10.3)') kk,spname(l),
     &                                          con(kk,l,1),con(kk,l,2)
                  enddo
                  call camxerr()
                endif
                tmassf = tmassf + depth(i,j,k)*(cigfrc(i,j)*con(k,l,1)
     &                                 + (1. - cigfrc(i,j))*con(k,l,2))
              enddo
              terr = abs(tmassf - tmassi)/tmassi
              if (terr.gt.0.002) then
                write(iout,'(//,a)')'ERROR in CIGDRIVE:'
                write(iout,*)'CiG transport matrix not conserving mass'
                write(iout,*)'Grid,I,J            : ',igrd,i,j
                write(iout,*)'Species             : ',spname(l)
                write(iout,*)'Starting/ending mass: ',tmassi,tmassf
                call camxerr()
              endif
            enddo
          else
            do l = nrad+1,nspec
              do k = 1,nlay
                con(k,l,2) = conc(i,j,k,l)
              enddo
            enddo
          endif
c
c-----Wet deposition
c
          if (lwet) then
            area = deltax(j+j0)*deltay/mapscl(i,j)**2
            do k = 1,nlay
              dz(k) = depth(i,j,k)
              tt(k) = tempk(i,j,k)
              pp(k) = press(i,j,k)
            enddo
c
c-----CIG profile first
c
            if (lcig(igrd) .AND. cigfrc(i,j).gt.0.) then
              acig = cigfrc(i,j)*area
              do l = nrad+1,nspec
                ftmp(l) = 0.
                depfld1(l) = 0.
                depfld2(l) = 0.
                do k = 1,nlay
                  cnc(k,l) = con(k,l,1)
                enddo
              enddo
              do k = 1,nlay
                cwtr(k) = cigwtr(i,j,k)
                ph(k)   = cigph(i,j,k)
                rwtr(k) = 0.
                swtr(k) = 0.
                gwtr(k) = 0.
                if (tt(k).ge.273.) then
                  rwtr(k) = cigpcp(i,j,k)
                else
                  gwtr(k) = cigpcp(i,j,k)
                endif
              enddo
              call wetdep(m1,m2,m3,i0,j0,i,j,igrd,ncol,nrow,nlay,nspec,
     &                    deltat,acig,dz,tt,pp,cwtr,rwtr,swtr,gwtr,ph,
     &                    densfac,dtout,ipa_cel,cnc,ftmp,
     &                    depfld1,depfld2,wetfld,iptrsa)
c
c-----Accumulate core model deposition fluxes
c
              do l = nrad+1,nspec
                do k = 1,nlay
                  con(k,l,1) = cnc(k,l)
                enddo
                fluxtmp(i,j,l) = fluxtmp(i,j,l) + ftmp(l)
                do ll = 1,ndepspc
                  if (l .eq. ldepmap(ll)) then
                    depfld(i,j,ndepspc+ll) = depfld(i,j,ndepspc+ll) +
     &                                       depfld1(l) 
                    depfld(i,j,2*ndepspc+ll) = depfld(i,j,2*ndepspc+ll)
     &                                         + depfld2(l)
                    goto 100
                  endif
                enddo
 100            continue
              enddo
c
            endif
c
c-----Ambient profile next
c
            aamb = area
            if (lcig(igrd) .AND. cigfrc(i,j).gt.0.)
     &         aamb = (1. - cigfrc(i,j))*area
            do l = nrad+1,nspec
              ftmp(l) = 0.
              depfld1(l) = 0.
              depfld2(l) = 0.
              do k = 1,nlay
                cnc(k,l) = con(k,l,2)
              enddo
            enddo
            do k = 1,nlay
              cwtr(k) = cwc(i,j,k)
              ph(k)   = cph(i,j,k)
              rwtr(k) = pwr(i,j,k)
              swtr(k) = pws(i,j,k)
              gwtr(k) = pwg(i,j,k)
            enddo
            call wetdep(m1,m2,m3,i0,j0,i,j,igrd,ncol,nrow,nlay,nspec,
     &                  deltat,aamb,dz,tt,pp,cwtr,rwtr,swtr,gwtr,ph,
     &                  densfac,dtout,ipa_cel,cnc,ftmp,
     &                  depfld1,depfld2,wetfld,iptrsa)
c
c-----Accumulate core model deposition fluxes
c
            do l = nrad+1,nspec
              do k = 1,nlay
                con(k,l,2) = cnc(k,l)
              enddo
              fluxtmp(i,j,l) = fluxtmp(i,j,l) + ftmp(l)
              do ll = 1,ndepspc
                if (l .eq. ldepmap(ll)) then
                  depfld(i,j,ndepspc+ll) = depfld(i,j,ndepspc+ll) +
     &                                     depfld1(l)
                  depfld(i,j,2*ndepspc+ll) = depfld(i,j,2*ndepspc+ll) +
     &                                       depfld2(l)
                  goto 101
                endif
              enddo
 101          continue
            enddo
c
c======================== Probing Tool Begin ===========================
c
c-----Wetdep for RTRAC
c
            if( ltrace .AND.
     &          (tectyp.EQ.RTRAC .OR. tectyp.EQ.RTCMC)) then
              do l = 1,nrtrac
                do k = 1,nlay
                  cncrt(k,l) = rtconc(i,j,k,l)
                enddo
              enddo
c 
              call wetdeprt(m1,m2,m1rt,m2rt,i,j,nlay,nrtrac,deltat,aamb,
     &                      dz,tt,pp,cwtr,rwtr,swtr,gwtr,ph,densfac,
     &                      cncrt,solmass,vegmass,fsurf)
c 
              do l = 1,nrtrac
                do k = 1,nlay
                  rtconc(i,j,k,l) = cncrt(k,l)
                enddo
              enddo
            endif
          endif
c
c========================= Probing Tool End ============================
c
c-----Aqueous chemistry
c
          if (lcig(igrd) .and. lchem .and. aeropt.EQ.'CF') then
            n1 = 2
            n2 = 2
            if (cigfrc(i,j).gt.0.) n1 = 1
            do k = 1,nlay
              ichm = i
              jchm = j
              kchm = k
c
              tcell = tempk(i,j,k)
              pcell = press(i,j,k)
              wcell = water(i,j,k)
              tchm = tcell
              wchm = wcell
              convfac = densfac*(273./tcell)*(pcell/1013.)
              volume = deltax(j+j0)*deltay*depth(i,j,k)/(mapscl(i,j)**2)
c
              do n = n1,n2   !Loop over in-cloud and ambient profiles
                if (n.eq.1) then
                  cldph = cigph(i,j,k)
                  cliq  = cigwtr(i,j,k)
                  vol   = cigfrc(i,j)*volume
                else
                  cldph = cph(i,j,k)
                  cliq  = cwc(i,j,k)
                  vol   = volume
                  if (cigfrc(i,j).gt.0.) vol = (1. - cigfrc(i,j))*volume
                endif
                if (tcell.lt.273.)
     &            cliq = amax1(0.,cliq*(tcell - tamin)/(273. - tamin))
c
c-----Sum mass and convert conc units before chemsitry
c
                do l = 1,nspec
                  dtmp(l) = con(k,l,n)*vol
                enddo
                do l = nrad+1,ngas
                  cc(l) = con(k,l,n)/convfac 
                enddo
                do l = ngas+1,nspec
                  cc(l) = con(k,l,n)
                enddo
                do l = nrad+1,nspec
                  if (cc(l).lt.0.) then
                    write(iout,'(//,a)') 'ERROR in CIGDRIVE:'
                    write(iout,*) 'Negative concentration before chem'
                    write(iout,*) 'igrd, i, j, k = ', igrd,i,j,k
                    do ll = nrad+1,nspec
                      write(iout,'(i3,2x,a7,e10.3)')ll,spname(ll),cc(ll)
                    enddo
                    call camxerr()
                  endif
                  cc(l) = amax1(bdnl(l),cc(l))
                enddo
c
                call aerochem_cf(wcell,tcell,pcell,cliq,cldph,
     &                           dumvar,dumvar,
     &                           dumarr1,cc,dumarr5,convfac,dtchem,dtchem,
     &                           dumarr2,dumarr3,dumarr4,1,1,.FALSE.,1,
     &                           aero_flag,.FALSE.,1,ldark(i,j))
c
c-----Update cloud pH, convert conc units, and sum mass after chemsitry
c
                if (n.eq.1) then
                  cigph(i,j,k) = cldph
                else
                  cph(i,j,k) = cldph
                endif
                do l = nrad+1,ngas
                  con(k,l,n) = amax1(cc(l)*convfac,bdnl(l))
                enddo
                do l = ngas+1,nspec
                  con(k,l,n) = amax1(cc(l),bdnl(l))
                enddo
                do l = 1,nspec
                  dtmp(l) = con(k,l,n)*vol - dtmp(l)
                  dchem(i,j,l) = dchem(i,j,l) + dtmp(l)
                enddo
c
              enddo
            enddo
          endif
c
c-----Update main concentration array
c
          if (lcig(igrd) .AND. cigfrc(i,j).gt.0.) then
            do l = nrad+1,nspec
              do k = 1,nlay
                conc(i,j,k,l) = cigfrc(i,j)*con(k,l,1) + 
     &                          (1. - cigfrc(i,j))*con(k,l,2)
              enddo
            enddo
          else
            do l = nrad+1,nspec
              do k = 1,nlay
                conc(i,j,k,l) = con(k,l,2) 
              enddo
            enddo
          endif
c
 20     continue
c
c  --- end of parallelized loop ---
c
cae$omp end parallel
c
 10   continue
c
c  --- load fluxes into global array ---
c
      do l = 1,nspec
        do j = ja,jz
          do i = ia,iz    !2,ncol-1
            fluxes(l,11) = fluxes(l,11) + fluxtmp(i,j,l)
            xmschem(l) = xmschem(l) + dchem(i,j,l)
           enddo
        enddo
      enddo
c
      call flush(6)
c
      return
      end

      subroutine vdiffacmx(ns,nddm,nz,deltat,temp0,press0,z0,delz,rkv,
     &                     qv,temp,press,wind,kpbl,fconv,con)
c
c----CAMx v7.40 260801
c
c     VDIFFACMX performs vertical diffusion of concentrations using
c     the Asymmetric Convective Model v2 (ACM2/ACM1; Pleim, 2007;2014). 
c
c     ACM2 portion of code is based on: 
c         Models-3/CMAQ vdiffacm2.F,v 1.13 2012/01/19 14:37:47 
c
c      Copyright Ramboll
c
c     Modifications:
c        5/27/16   Updated to parallel ACM2 speed improvements in CMAQ v5.1,
c                  remove K-theory solution and dry deposition (both done using
c                  CAMx K-theory solver), and extend to H/DDM
c
c     Input arguments:
c        ns                number of species
c        nddm              number of parameters for which sensitivities are
c                          calculated - should be zero if DDM is not enabled
c        nz                number of layers
c        deltat            timestep (s)
c        temp0             Surface temperature (K)
c        press0            Surface pressure (mb)
c        z0                Surface roughness (m)
c        delz              Layer depth (m)
c        rkv               Kv profile (m2/s)
c        qv                Humidity profile (mixing ratio) 
c        temp              Temperature profile (K)
c        press             Pressure profile (mb)
c        wind              Wind speed profile
c        con               Species concentrations (umol/m3, ug/m3) followed by
c                          sensitivities (umol/m3/parameter unit).
c
c     Output arguments:
c        kpbl              Layer index at the top of the PBL
c        fconv             Convective fraction to scale Kv
c        con               Species concentrations (umol/m3, ug/m3) followed by
c                          sensitivities (umol/m3/parameter unit).
c
c     Routines Called:
c        MICROMET
c        MATRIX
c
c     Called by:
c        DIFFUS
c
      implicit none
      include "camx.prm"
c
      integer ns,nz,nddm,kpbl
      real deltat,temp0,press0,z0,fconv
      real delz(nz),rkv(nz),qv(nz),temp(nz),press(nz),
     &     wind(nz)
      real con(nz+nz*nddm,ns)
c
      real theta,thbar
      parameter (theta = 0.5)         !Crank-Nicholson = 0.5 (semi-implicit)
      parameter (thbar = 1 - theta)
      logical lconv,lstable
      integer k,kk,nstep,n,l,m
      real gamma,vk
      real tv,pbl,zf,critk,ustar,el,psih,wstar,hoverl,dt,mbar,meddy,
     &     delc,lfac1,lfac2,rhopbl,rhosum,roplus,rz,dtacm,
     &     dfacp,dfacq
      real zz(0:MXLAYER)
      real dz(MXLAYER),dzinv(MXLAYER),zm(MXLAYER),thetav(MXLAYER),
     &     rho(MXLAYER),dzm(MXLAYER),dzminv(MXLAYER),seddy(MXLAYER)
      real mbarks(MXLAYER),mdwn(MXLAYER),mfac(MXLAYER),dfsp(MXLAYER),
     &     dfsq(MXLAYER)
      real aa(MXLAYER),bb(MXLAYER),ee(MXLAYER),dd(MXLAYER),uu(MXLAYER)
      real cc(MXLAYER,1+MXTRSP)
c
      data gamma /0.286/, vk /0.4/
c
c-----Entry point
c
c-----Determine vertical grid structure variables and thermodynamic profiles.
c
      zz(0) = 0.
      do k = 1,nz
        dz(k) = delz(k)
        zz(k) = zz(k-1) + dz(k)
        zm(k)  = (zz(k) + zz(k-1))/2.
        tv = temp(k)*(1. + 0.608*qv(k))
        thetav(k) = tv*(1000./press(k))**gamma
        rho(k) = press(k)/tv
        seddy(k) = rkv(k)
      enddo
      do k = 1,nz-1
        dzm(k) = zm(k+1) - zm(k)
      enddo
      dzm(nz) = 0.
c
c-----Get the PBL parameters
c
      kpbl = 1
      pbl = dz(1)
      do k = 2,nz-1
        if (kpbl .ne. k-1) goto 100
        zf = dz(k)/dz(k-1)
        critk = 0.03*dz(k-1)*dzm(k)*(1. + zf)/200.
        if (rkv(k-1) .gt. critk) then
          kpbl = k
          pbl = pbl + dz(k)
        endif
      enddo
 100  continue

      call micromet(temp(1),temp0,press(1),press0,dz(1)/2.,wind(1),z0,
     &              pbl,ustar,el,psih,wstar,lstable)

      lconv = .false.
      hoverl = pbl/el
      if (((thetav(1) - thetav(2)) .gt. 1.e-8 ) .and.
     &    (hoverl .lt. -0.1) .and.
     &    (kpbl .gt. 3)) lconv = .true.
      if (.not.lconv) return
c
c-----Initialize ACM2 arrays
c
      do k = 1,nz - 1
        mbarks(k) = 0.
        mdwn(k) = 0.
      enddo
      mdwn(nz) = 0.
c
c-----Calculate ACM2 non-local mixing rates
c
      do k = 1,nz
        dz(k) = dz(k)*rho(k)
        dzinv(k) = 1./dz(k)
      enddo
      do k = 1,nz-1
        roplus = (rho(k)+rho(k+1))/2.
        dzm(k) = dzm(k)*roplus
        dzminv(k) = 1./dzm(k)
        seddy(k) = seddy(k)*roplus*roplus*dzminv(k)
      enddo
      dzminv(nz) = 0.

      mbar = 0.
      rhopbl = 0.
      do k = 2,kpbl
        rhopbl = rhopbl + dz(k)
      enddo
      meddy = seddy(1)/rhopbl
      fconv = 1./(1. + ((vk/(-hoverl))**0.3333)/(0.72*vk))
      mbar = meddy*fconv
      do k = 1,kpbl-1
        mbarks(k) = mbar
        rhosum = 0.
        do kk = k,kpbl
          rhosum = rhosum + dz(kk)
        enddo
        mdwn(k) = mbar*rhosum*dzinv(k)
      enddo
      mbarks(kpbl) = mbar
      mdwn(kpbl) = mbarks(kpbl)
c
c-----Modify timestep for ACM2
c
      rz = rhopbl*dzinv(1)
      dtacm = 1./(mbar*rz)
      dt = min(0.75*dtacm,deltat)
c
c-----Determine number of steps to take
c
      nstep = int(deltat/dt + 0.99)
      dt   = deltat/real(nstep)
      dfacp = theta*dt
      dfacq = thbar*dt

      do k = 1,nz
        dfsp(k) = dfacp*dzinv(k)
        dfsq(k) = dfacq*dzinv(k)
      enddo
c
c-----Initialize matrix elements
c
      do k = 1,nz
        aa(k) = 0.
        bb(k) = 0.
        ee(k) = 0.
      enddo
      bb(1) = 1. + rhopbl*dfsp(1)*mbarks(1)
      lfac1 = dfsq(1)*rhopbl*mbarks(1)
      lfac2 = dfsq(1)*mdwn(2)*dz(2)
      do k = 2,kpbl
        aa (k) = -dfacp*mbarks(k)
        bb(k) = 1. + dfacp*mdwn(k)
        ee(k) = -dfsp(k-1)*dz(k)*mdwn(k)
        mfac(k) = dz(k+1)*dzinv(k)*mdwn(k+1)
      enddo
c
c-----Loop over species
c
      do 301 l = 1,ns
        do m = 1,1+nddm
          do k = 1,nz
            cc(k,m) = con((m-1)*nz+k,l)/rho(k)
          enddo
        enddo
c
c-----Loop over sub-steps
c
        do 300 n = 1,nstep
          do m = 1,1+nddm
            do k = 1,nz
              dd(k) = 0.
              uu(k) = 0.
            enddo
c
c-----Call MATRIX1 solver for ACM convection
c
            dd(1) = cc(1,m) - lfac1*cc(1,m) + lfac2*cc(2,m)
            do k = 2,kpbl
              delc = mbarks(k)*cc(1,m)
     &               - mdwn(k)*cc(k,m)
     &               + mfac(k)*cc(k+1,m)
              dd(k) = cc(k,m) + dfacq*delc
            enddo
            call matrix1(nz,kpbl,aa,bb,ee,dd,uu)
            do k = 1,kpbl
              cc(k,m) = uu(k)
            enddo
          enddo
300     continue

        do m = 1,1+nddm
          do k = 1,nz
            con((m-1)*nz+k,l) = cc(k,m)*rho(k)
          enddo
        enddo

301   continue

      return
      end
c
c-------------------------------------------------------------------------------
c
      SUBROUTINE MATRIX1 ( nz, KL, A, B, E, D, X )
c
c This routine taken from:
c Models-3/CMAQ matrix.F,v 1.5 2011/10/21 16:11:45
c
C-------------------------------------------------------------------------------
C Rather than solving the ACM2 banded tridiagonal matrix using LU decomposition,
C it is much faster to split the solution into the ACM1 convective solver
C followed by the tridiagonal solver.
C MATRIX1 is the ACM1 solver. When the PBL is convective, this solver is called
C followed by TRI. If not convective, only TRI is called.
C
C-- ACM1 Matrix is in this form (there is no subdiagonal:
C   B1 E2                     <- note E2 (flux from layer above), not E1
C   A2 B2 E3
C   A3    B3 E4
C   A4       B4 E5
C   A5          B5 E6
C   A6             B6
C-------------------------------------------------------------------------------

      IMPLICIT NONE

C Arguments:

      integer nz
      INTEGER KL     ! CBL layer height
      REAL A( nz )   ! matrix column one
      REAL B( nz )   ! diagnonal
      REAL E( nz )   ! superdiagonal
      REAL D( nz )   ! R.H.S.
      REAL X( nz )   ! returned solution

C Locals:

      INTEGER NLAYS
      INTEGER L
      REAL BETA
      REAL ALPHA, GAMA

      NLAYS = nz

C-- ACM1 matrix solver

      BETA = D( 1 )
      GAMA = B( 1 )
      ALPHA = 1.0

      DO L = 2, KL
         ALPHA = -ALPHA * E( L ) / B( L )
         BETA  = ALPHA * D( L ) + BETA
         GAMA = GAMA + ALPHA * A( L )
      END DO

      X( 1 )  = BETA / GAMA
      X( KL ) = ( D( KL ) - A( KL ) * X( 1 ) ) / B( KL )

C-- Back sub for Ux=y

      DO L = KL-1, 2, -1
         X( L ) = ( D( L ) - A( L ) * X( 1 ) - E( L+1 ) * X( L+1 ) )
     &            / B( L )
      END DO

      RETURN
      END

      subroutine khetero(tcell,pcell,H2O,con,lddm,nfam,sddm)
      use chmstry
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c     KHETERO estimates the rate constants for heterogeneous reactions of N2O5:
c       N2O5 + H2O -> 2 HNO3
c       N2O5 + HCL -> CLN2 + HNO3
c     Sets the rate constant for hydrolysis of organic nitrate:
c       NTR2       -> HNO3
c       INTR       -> HNO3
c     Sets the rate constant for heterogeneous reaction of SO2:
c       SO2        -> SULF
c     Sets the rate constant for heterogeneous reaction of GLY/MGLY to CGLY:
c       GLY       -> CGLY
c       MGLY      -> CGLY
c
c     Parameterization of N2O5 on aqueous particles:
c     Bertram and Thornton (2009) Atmos. Chem. Phys., 9, 8351-8363.
c
c     Mean molecular speed formula - Seinfeld and Pandis (1998)
c     Atmospheric Chemistry and Physics, p453.
c
c     NTR2 hydrolysis rate:
c     Liu et al. (2012) Aerosol Sci. Technol., 46, 1359-1369.
c
c     INTR hydrolysis rate:
c     Fisher et al. (2016) Atmos. Chem. Phys., 16, 5969-5991.
c
c     Organic nitrate partitioning ratio:
c     Rollins et al. (2013) J. Geophys. Res., 118, 6651-6662.
c
c     Heterogeneous SO2 reaction rate:
c     Zheng et al. (2015) Atmos. Chem. Phys., 15, 2031-2049.
c
c     Molecular diffusion coefficient:
c     Tang et al. (2014) Atmos. Chem. Phys., 14, 9233-9247.
c     (https://sites.google.com/site/mingjintang/home/diffusion)
c
c      Copyright Ramboll
c
c     Modifications:
c        01/30/2006  - bkoo -     Original development
c        07/04/2007  - bkoo -     Modified to use pointer to N2O5 hydrolysis
c                                 Extended for CMU_AERO
c        03/29/2011  -cemery-     Revised to allow for inert PM with gas-phase
c                                 chemistry
c        03/28/2012  -cemery-     Revised to set rate of 0.25/hr in the
c                                 absence of PM chemistry
c        09/21/2013  - bkoo -     Revised for DDM-PM
c        10/14/2013  - bkoo -     Added hydrolysis of organic nitrate
c        01/03/2014  - bkoo -     Updated DDM-PM for organic nitrate hydrolysis
c        03/18/2014  - bkoo -     Updated for benzene SOA
c        12/07/2014  - bkoo -     Modified for VBS
c                                 Cap khetN2O5 sens
c        01/08/2016  - bkoo -     Updated for Revised VBS
c        02/29/2016  - bkoo -     Updated heterogeneous rxn of N2O5
c        07/20/2016  - bkoo -     Added heterogeneous hydrolysis of INTR
c        08/25/2016  - bkoo -     Updated for new SOAP
c        09/02/2016  - bkoo -     Added het SO2 -> SULF; revised het rxn pointers
c        11/28/2016  - bkoo -     Revised N2O5 uptake rxn formula
c        07/07/2022  - gy   -     Force gas-phase k(N2O5+H2O) = 1E-22 
c        03/21/2024  - lhuang -   Added het GLY/MGLY -> CGLY
c        05/17/2024  - cemery -   Removed CMU PM option
c
c     Input arguments:
c        tcell          temperature (K)
c        pcell          pressure (mb)
c        H2O            water vapor concentration (ppm)
c        con            species concentrations (ppm or ug/m3)
c        lddm           logical flag for DDM sensitivities
c        nfam           number of sensitivity families
c        sddm           sensitivity matrix (ppm; ug/m3; 1/hr or 1/ppm-hr)
c                          sddm(:,nspec+1:nspec+2) [1/ppm-hr]
c                          sddm(:,nspec+3:nspec+5) [1/hr]
c
c     Output arguments:
c        sddm
c
c     Routines called:
c        NONE
c
c     Called by:
c        CHEMDRIV
c
      include 'camx.prm'
      include 'camx_aero.inc'
      include 'vbs.inc'
c
c-----Arguments
c
      real  tcell, pcell, H2O
      real  con(*)
c
c-----Local variables:
c
      real, parameter :: khon0  = 0.16667       ! [1/hr]; lifetime = 6 hr (particle-phase NTR2 hydrolysis)
      real, parameter :: khon20 = 1.0           ! [1/hr]; lifetime = 1 hr (particle-phase INTR hydrolysis)
      real, parameter :: alfa1  = 0.34,         ! partioning parameters for total ON
     &                   alfa2  = 0.66,
     &                   cstar1 = 0.73,
     &                   cstar2 = 1000.
      real, parameter :: fntr2  = 0.71          ! NTR2 / total ON
      real, parameter :: fintr  = 0.08          ! INTR / total ON

      real :: fcond                             ! condensable ON / total ON
      real :: khon                              ! psuedo gas-phase NTR2 hydrolysis rate constant [1/hr]
      real :: khon2                             ! psuedo gas-phase INTR hydrolysis rate constant [1/hr]
      real :: fp                                ! fraction of NTR2 or INTR in the particle phase
                                                ! (assuming the same fp for NTR2 and INTR)
      real :: ctoa                              ! total OA concentration [ug/m3]

      real :: qwatr, ev, es, rh                 ! relative humidity calculation

      real, parameter :: Rgc    = 8.314         ! gas constant [J/mol-K]
      real, parameter :: Pi     = 3.1415927     ! Pi
      real, parameter :: mwN2O5 = 0.108         ! MW of N2O5 [kg/mol]
      real, parameter :: mwSO2  = 0.064         ! MW of SO2 [kg/mol]
      real, parameter :: mwGLY  = 0.058         ! MW of GLY [kg/mol]
      real, parameter :: mwMGLY = 0.072         ! MW of MGLY [kg/mol]
      real, parameter :: rtau   = 1.66667e-3    ! reciprocal of minimum lifetime of N2O5 (10 min = 600 sec) [1/s]

      real, parameter :: Afac   = 3.2e-8        ! empirical pre-factor for gamma [s]
      real, parameter :: beta   = 1.15e6        ! parameter for k2f' [1/s]
      real, parameter :: delta  = 1.3e-1        ! parameter for k2f' [1/M]
      real, parameter :: k3k2b  = 6.0e-2        ! k3/k2b
      real, parameter :: k4k2b  = 29.0          ! k4/k2b
      real, parameter :: molarPH2O = 55.        ! molar concentration of aerosol water [M]; assume diluted aqueous phase

      real, parameter :: diff_N2O5 = 65.        ! Diffusivity of N2O5 at 296 K [Torr-cm2/s]
      real, parameter :: diff_SO2 = 94.         ! Diffusivity of SO2 at 296 K [Torr-cm2/s]
      real, parameter :: diff_GLY = 93.         ! Diffusivity of GLY at 298 K [Torr-cm2/s]; Tang et al. 2015, ACP
      real, parameter :: g1_SO2 = 2.e-5         ! lower limit of SO2 uptake coefficient
      real, parameter :: g2_SO2 = 5.e-5         ! upper limit of SO2 uptake coefficient

      real, parameter :: h2s = 3600.0           ! hour to second

      real :: vt                                ! total dry volume of fine particles
      real :: diam                              ! diameter of a fine particle [um]
      real :: nden                              ! number density of fine particles [#/cm3_air]
      real :: saden                             ! surface area density [um2/cm3_air]
      real :: cbarN2O5                          ! mean molecular speed of N2O5 [m/s]
      real :: cbarSO2                           ! mean molecular speed of SO2 [m/s]
      real :: cbarGLY                           ! mean molecular speed of GLY [m/s]
      real :: cbarMGLY                          ! mean molecular speed of MGLY [m/s]
      real :: k2fprime                          ! k2f' = k2f * [H2O] [1/s]
      real :: dc_N2O5                           ! diffusion coefficient of N2O5 [m2/s]
      real :: dc_SO2                            ! diffusion coefficient of SO2 [m2/s]
      real :: dc_GLY                            ! diffusion coefficient of GLY [m2/s]
      real :: dc_MGLY                           ! diffusion coefficient of MGLY [m2/s]
      real :: gamma_N2O5                        ! uptake coefficient of N2O5
      real :: gamma_SO2                         ! uptake coefficient of SO2
      real :: gamma_GLY                         ! uptake coefficient of GLY
      real :: gamma_MGLY                        ! uptake coefficient of MGLY
      real :: y_clno2                           ! product yield for ClNO2
      real :: kgasn2o5                          ! gas phase N2O5 + H2O rate constant

      real :: t1, t2
      real*8 :: r1, r2, rdenom
      real :: rscl
      real :: khet0, khet1, khet2, khet5, khet6, khet7

      integer :: l, isempty
      integer :: kwtr, isec, iaero
c
c======================== DDM Begin =======================
c
      logical :: lddm
      integer :: nfam
      integer :: ip
      real :: sddm(nfam,MXSPEC+NHETRXN)
      real :: stoa,sfp
      real :: const0,sad0
      real :: dvt,dsad,dr1r
c
c======================== DDM End =======================
c
c-----k N2O5 + H2O from IUPAC data sheet NOx33 converted [cm3/molecule-sec] -> [1/ppm-hr]
c
      kgasn2o5 = 1.0E-22*(298.0/tcell)*(pcell/1013.0)*8.87e16
c
c-----No PM chemistry:
c       N2O5 + H2O -> 2 HNO3      : reset to the IUPAC 2006 rate
c       N2O5 + HCL -> CLN2 + HNO3 : use the rate set in the CHEMPARAM input file
c       NTR2       -> HNO3        : use the rate set in the CHEMPARAM input file
c       INTR       -> HNO3        : use the rate set in the CHEMPARAM input file
c       SO2        -> SULF        : use the rate set in the CHEMPARAM input file
c
      if (aeropt.eq.'NONE' .or. aeropt.eq.'INERT') then
        rk(ihetrxn(1)) = kgasn2o5
        return
      endif
c
c-----Calculate RH
c
      qwatr = 1.e-6*H2O*18./28.8
      ev = qwatr*pcell/(qwatr + eps)
      es = e0*exp((lv/rv)*(1./273. - 1./tcell))
      rh = amin1(1.,ev/es)
c
c-----Hydrolysis of organic nitrate in the organic solution phase
c
      if (ihetrxn(3).gt.0 .or. ihetrxn(4).gt.0) then
        if (aeropt.eq.'CF') then
          ctoa = con(khoa)  + con(kaoa2) + con(kaoa1)
     &                      + con(kboa2) + con(kboa1)
     &                      + con(kaoa0) + con(kboa0)
          if (lvbs) then
            ctoa = con(kpas0)+con(kpas1)+con(kpas2)+con(kpas3)+con(kpas4)
     &            +con(kpbs0)+con(kpbs1)+con(kpbs2)+con(kpbs3)+con(kpbs4)
     &            +con(kpap0)+con(kpap1)+con(kpap2)+con(kpap3)+con(kpap4)
     &            +con(kpcp0)+con(kpcp1)+con(kpcp2)+con(kpcp3)+con(kpcp4)
     &            +con(kpfp0)+con(kpfp1)+con(kpfp2)+con(kpfp3)+con(kpfp4)
          endif
        else
          write(iout,'(//,a)') 'ERROR in KHETERO: invalid AEROPT'
          call camxerr()
        endif
        fp = 0.0
        if (ctoa.ge.0.0001) then
          fp = alfa1 / (1. + cstar1/ctoa) + alfa2 / (1. + cstar2/ctoa)
          fcond = fntr2
          if (ihetrxn(4).gt.0) fcond = fcond + fintr
          fp = fp / fcond
        endif
        if (rh.lt.0.2) then
          t1 = 0.0
          t2 = 0.0
        elseif (rh.ge.0.4) then
          t1 = fp * khon0
          t2 = fp * khon20
        else
          t1 = fp * khon0 * (rh - 0.2) / 0.2
          t2 = fp * khon20 * (rh - 0.2) / 0.2
        endif
        if (ihetrxn(3).gt.0) rk(ihetrxn(3)) = t1
        if (ihetrxn(4).gt.0) rk(ihetrxn(4)) = t2
c
c======================== DDM Begin =======================
c
        if ( lddm .and. aeropt.eq.'CF' ) then
          do ip = 1, nfam
            stoa = sddm(ip,khoa)
     &           + sddm(ip,kaoa2) + sddm(ip,kaoa1)
     &           + sddm(ip,kboa2) + sddm(ip,kboa1)
     &           + sddm(ip,kaoa0) + sddm(ip,kboa0)
            sfp = 0.0
            if (ctoa.ge.0.0001) then
              sfp = ( fp - ( 
     &                alfa1 / ((1. + cstar1/ctoa)*(1. + cstar1/ctoa))
     &              + alfa2 / ((1. + cstar2/ctoa)*(1. + cstar2/ctoa))
     &                      ) / fcond ) * stoa / ctoa
            endif
            if (rh.lt.0.2) then
              sddm(ip,nspec+3) = 0.0
              if (ihetrxn(4).gt.0) sddm(ip,nspec+4) = 0.0
            elseif (rh.ge.0.4) then
              sddm(ip,nspec+3) = sfp * khon0
              if (ihetrxn(4).gt.0) sddm(ip,nspec+4) = sfp * khon20
            else
              sddm(ip,nspec+3) = sfp * khon0 * (rh - 0.2) / 0.2
              if (ihetrxn(4).gt.0) sddm(ip,nspec+4) = sfp * khon20
     &                                       * (rh - 0.2) / 0.2
            endif
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----Heterogeneous rxn of N2O5 / SO2 on aerosol surface area
c
      khet1 = 0.0
      khet2 = 0.0
      khet5 = 0.0
      khet6 = 0.0
      khet7 = 0.0

      k2fprime = beta * ( 1. - exp(-delta*molarPH2O) )      ! [1/s]
      cbarN2O5 = sqrt( 8.0*Rgc*tcell / (Pi*mwN2O5) )        ! [m/s]
      dc_N2O5 = (diff_N2O5/7.6e6) * (1013.25/pcell) * (tcell/296.)**1.75 ! [m2/s]

      cbarSO2 = sqrt( 8.0*Rgc*tcell / (Pi*mwSO2) )          ! [m/s]
      dc_SO2 = (diff_SO2/7.6e6) * (1013.25/pcell) * (tcell/296.)**1.75 ! [m2/s]

      cbarGLY = sqrt( 8.0*Rgc*tcell / (Pi*mwGLY) )          ! [m/s]
      dc_GLY = (diff_GLY/7.6e6) * (1013.25/pcell) * (tcell/298.)**1.75 ! [m2/s]
      !dc_GLY = (0.0855e-4) * (1013.25/pcell) * (tcell/298.)**1.75  ! [m2/s] based on CMAQ

      cbarMGLY = sqrt( 8.0*Rgc*tcell / (Pi*mwMGLY) )          ! [m/s]
      dc_MGLY = (diff_GLY/7.6e6) * (1013.25/pcell) * (tcell/298.)**1.75 ![m2/s]

      if (rh.lt.0.5) then
        gamma_SO2 = g1_SO2
      else
        gamma_SO2 = g1_SO2 + (g2_SO2 - g1_SO2)*(rh - 0.5)/0.5
      endif
c
c-----CF PM chemistry
c
      if (aeropt.eq.'CF') then
        diam = sqrt(dcut(kph2o,1)*dcut(kph2o,2))            ! geometric mean dry diameter [um]
        !bk - limit hetero SO2 rxn only at dust particle surface
        saden = (6./diam) * ( con(kfprm)/roprt(kfprm)       ! dust particle surface area [m2/m3_air]
     &                      + con(kfcrs)/roprt(kfcrs) 
     &                      + con(kpfe) /roprt(kfcrs) 
     &                      + con(kpmn) /roprt(kfcrs) 
     &                      + con(kpca) /roprt(kfcrs) 
     &                      + con(kpmg) /roprt(kfcrs) 
     &                      + con(kpk)  /roprt(kfcrs) 
     &                      + con(kpal) /roprt(kfcrs) 
     &                      + con(kpsi) /roprt(kfcrs) 
     &                      + con(kpti) /roprt(kfcrs) )
        khet5 = saden / ( diam * 0.5e-6 / dc_SO2 +
     &                    4. / ( cbarSO2 * gamma_SO2 ) )    ! [1/s]
c
c-----Adjust dry diameter to wet diameter for N2O5 hydrolysis
c
        if (con(kph2o).le.bdnl(kph2o)) goto 800

        isempty = 1
        vt = 0.
        do l = ngas+1,nspec
          if (dcut(l,2).lt.(dcut(kph2o,2)+1.e-5)) then      ! fine
            if (l.ne.kph2o) then                            ! dry
              if (con(l).gt.bdnl(l)) isempty = 0
              vt = vt + con(l)/roprt(l)                     ! [ug/m3_air]/[g/m3]
            endif
          endif
        enddo
        if (isempty.eq.1) goto 800

        nden = vt / (diam*diam*diam*Pi/6.0)                 ! [ug/m3_air]/[um3-g/m3] = [#/m3_air] * 1.E-12
c
c======================== DDM Begin =======================
c
        if ( lddm ) then !bk - broken
        endif
c
c======================== DDM End =======================
c
        diam = diam * ( 1.0 +
     &         con(kph2o)/roprt(kph2o)/vt )**0.33333        ! wet diameter [um]
        saden = Pi*diam*diam*nden                           ! [m2/m3_air]
        r1 = k3k2b * (con(kph2o)/18.)/(con(kpno3)/62.)
        r2 = k4k2b * (con(kpcl)/35.)/(con(kpno3)/62.)
        rdenom = r1 + 1. + r2
        gamma_N2O5 = Afac * k2fprime * (1. - 1. / rdenom)
        y_clno2 = r2 / (r1 + r2)
        khet0 = saden / ( diam * 0.5e-6 / dc_N2O5 +
     &                    4. / ( cbarN2O5 * gamma_N2O5 ) )  ! [1/s]
        khet0 = MIN( khet0, rtau )                          ! check against upper limit [1/s]
        khet1 = (1. - y_clno2) * khet0
        khet2 = y_clno2 * khet0

c       Add GLY heterogeneous
        gamma_GLY = 0.001                                ! from CMAQ AEROSOL_CHEMISTRY.F
        gamma_MGLY = 0.09 * gamma_GLY                    ! from CMAQ AEROSOL_CHEMISTRY.F

        khet6 = saden / ( diam * 0.5e-6 / dc_GLY +
     &                    4. / ( cbarGLY * gamma_GLY ) )    ! [1/s]
        khet6 = MIN( khet6, rtau )                          ! check against upper limit [1/s]

        khet7 = saden / ( diam * 0.5e-6 / dc_MGLY +
     &                    4. / ( cbarMGLY * gamma_MGLY ) )    ! [1/s]
        khet7 = MIN( khet7, rtau )                          ! check against upper limit [1/s]
c
c======================== DDM Begin =======================
c
        if ( lddm ) then !bk - broken
        endif
c
c======================== DDM End =======================
c
      else
        write(iout,'(//,a)') 'ERROR in KHETERO: invalid AEROPT'
        call camxerr()
      endif
c
c --- adjust rk(N2O5); rk(N2O5) will be reset by KTHERM every timestep
c
 800  continue
      rk(ihetrxn(1)) = kgasn2o5 + ( khet1 * h2s / H2O )     ! add gas-phase rate; [1/ppm-hr]
      if (ihetrxn(2).gt.0) rk(ihetrxn(2)) = khet2 * h2s / con(khcl)
      if (ihetrxn(5).gt.0) rk(ihetrxn(5)) = khet5 * h2s     ! [1/hr]
      if (ihetrxn(6).gt.0) rk(ihetrxn(6)) = khet6 * h2s     ! [1/hr]
      if (ihetrxn(7).gt.0) rk(ihetrxn(7)) = khet7 * h2s     ! [1/hr]

      return

      end

      subroutine walk1pufz(dt,nx,ny,nz,ii,jj,zpig,height,ww)
c     use grid
c
c----CAMx v7.40 260801
c
c     WALK1PUFZ calculates a new puff vertical location by integrating
c     dz/w(z) = dt through a vertical column, where
c     w(z) = w(k-1) + (w(k) - w(k-1))*(z/depth).
c
c      Copyright Ramboll
c
c     Modifications:
c        10/19/16        Bug fix for puffs reaching layer interface when w=0
c
c     Input arguments:
c        dt                  remaining timestep (s)
c        nx                  number of cells in x-direction
c        ny                  number of cells in y-direction
c        nz                  number of layers
c        ii                  i-cell index of puff location 
c        jj                  j-cell index of puff location 
c        zpig                z-coord of puff location (m)
c        height              gridded layer height (m)
c        ww                  vertical velocity profile (m/s)
c
c     Output arguments:
c        zpig                z-coord of puff location (m)
c
c     Subroutines Called:
c        NONE
c
c     Called by:
c        PIGWALK
c
      implicit none
      include "camx.prm"
c
      integer nx,ny,nz,ii,jj
      real zpig,dt
      real windu(nx,ny,nz),windv(nx,ny,nz),height(nx,ny,nz),ww(0:nz)
      real depth,zcel0,zcell,az,bz,dtz,dttmp
      integer kount,iedge,kp,kk
      real zfrac
c
c-----Entry point
c
      dttmp = dt
      kount = 0
 10   iedge = 0
      kount = kount + 1
c
c-----Calculate distance between puff midpoint and layer interface below
c
      kp = nz
      do kk = 1,nz
        if (height(ii,jj,kk) .GE. zpig) then
          kp = kk
          goto 11
        endif
      enddo

 11   continue
      depth = height(ii,jj,kp)
      zcel0 = zpig
      if (kp.gt.1) then
        depth = height(ii,jj,kp) - height(ii,jj,kp-1)
        zcel0 = zpig - height(ii,jj,kp-1)
      endif
c
c-----Compute the new position after the whole time step
c
      iedge = 0
      az = ww(kp-1)
      bz = (ww(kp) - ww(kp-1))/depth
      if (abs(bz).lt.1.e-6) then
        zcell = zcel0 + az*dttmp
      else
        zcell = (-az + (az + bz*zcel0)*exp(bz*dttmp))/bz
      endif
c
c-----If the new position is beyond the layer boundaries, compute
c     the time needed to reach the boundary
c
      dtz = dttmp
      if (zcell.gt.depth) then
        iedge = 1
        if (abs(bz).lt.1.e-6) then
          dtz = (depth*1.001 - zcel0)/az
        else
          zfrac = (az + bz*depth*1.001)/(az + bz*zcel0)
          if (zfrac.le.0.) then
            iedge = 0
          else
            dtz = alog(zfrac)/bz
            if (dtz.gt.dttmp) then
              iedge = 0
              dtz = dttmp
            endif
          endif
        endif
      elseif (zcell.lt.0.) then
        iedge = 1
        if (abs(bz).lt.1.e-6) then
          dtz = (-depth*0.001 - zcel0)/az
        else
          zfrac = (az - bz*depth*0.001)/(az + bz*zcel0)
          if (zfrac.le.0.) then
            iedge = 0
          else
            dtz = alog(zfrac)/bz
            if (dtz.gt.dttmp) then
              iedge = 0
              dtz = dttmp
            endif
          endif
        endif
      endif
c
c-----If the puff reaches a boundary, compute the remaining time and new
c     position
c
      if (iedge.eq.1) then
        if (abs(bz).lt.1.e-6) then
          zcell = zcel0 + az*dtz
        else
          zcell = (-az + (az + bz*zcel0)*exp(bz*dtz))/bz
        endif
        dttmp = dttmp - dtz
      else
        dttmp = 0.
      endif
c
      zpig = max(0.,zcell)
      if (kp.gt.1) zpig = min(height(ii,jj,nz),
     &                        zcell + height(ii,jj,kp-1))

      if (kount.le.50 .and. dttmp.gt.0.) goto 10
c
      return
      end

c***** NCF_RDPTDDM
c
      subroutine ncf_rdptddm(ndate,ttime)
      use chmstry
      use grid
      use filunit
      use ptemiss
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of point source emissions for the DDM 
c   process and fills the approproate arrays.  This routine is for NETCDF 
c   files. 
c    Argument descriptions:
c     Outputs:
c     Inputs:
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     09/26/19  Original development
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx.inc'
      include 'netcdf.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer ndate
      real    ttime
c
c-----------------------------------------------------------------------
c   External functions:
c-----------------------------------------------------------------------
c
      integer ncf_get_tstep
      integer istrln
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname, action
      character*20  this_var
      character*10  cname
      integer       nedge, igroup, idxfile, iounit, this_tstep
      integer       ierr, idxpt, this_time_tflag, this_time_etflag
      integer       imod, idxbase, icel, jcel, igrd, ig, ii, jj
      integer       imap, iptr, this_varid,  data_start(2), data_count(2)
      integer       iddm, ispc
      real          xloccrs, yloccrs, xloctmp, yloctmp, emstmp, pi
      logical       luse
c
      real,    allocatable, dimension(:) ::  emispts
      integer, allocatable, dimension(:) ::  sa_region
      real,    allocatable, dimension(:) ::  effph_in
      real,    allocatable, dimension(:) ::  plume_bot
      real,    allocatable, dimension(:) ::  plume_top
c
      data pi /3.1415927/
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c   --- loop over all of the groups ----
c
      do 10 igroup=1,ngroup
        do 11 idxfile=1,num_iortpt(igroup)
c
c   --- skip if filename not supplied ---
c
          if( .NOT. is_netcdf_iortpt(igroup,idxfile) .OR. .NOT. 
     &            ltptfl(igroup,idxfile) .OR. .NOT. lptsrc ) goto 11
          write(action,'(2A,I3,A,I3)') 'Reading the DDM NetCDF point source',
     &            ' emissions file for Group: ',igroup,' File: ',idxfile
c
c   --- set the unit number for surface emissions file ---
c
          iounit = iortpt(igroup,idxfile)
          fname = tptfil(igroup,idxfile)
c
c  ---- allocate the temporary array ---
c
          allocate( emispts(nptsrc_safile(igroup,idxfile)) )
          allocate( sa_region(nptsrc_safile(igroup,idxfile)) )
          allocate( effph_in(nptsrc_safile(igroup,idxfile)) )
          allocate( plume_bot(nptsrc_safile(igroup,idxfile)) )
          allocate( plume_top(nptsrc_safile(igroup,idxfile)) )
          plume_bot = 0.
          plume_top = 0.
c
c  ---- get the region override flag ---
c
          sa_region = 0
          this_var = 'saoverride'
          ierr = nf_inq_varid(iounit, this_var, this_varid)
          if( ierr .NE. NF_NOERR ) cycle
          ierr = nf_get_var_int(iounit,this_varid,sa_region)
          if( ierr .NE. NF_NOERR ) goto 7001
c
c  ---- get the index for timestep containing this time ----
c
          this_tstep = ncf_get_tstep(iounit,action,ndate,ttime,
     &               this_time_tflag,this_time_etflag,le1day,.TRUE.)
c
c   --- set the indexes for what to read ---
c
          data_start(1) = 1
          data_count(1) = nptsrc_safile(igroup,idxfile)
          data_start(2) = this_tstep
          data_count(2) = 1
c
c  ---- plumerise ---
c
          this_var = 'plumerise'
          ierr = nf_inq_varid(iounit, this_var, this_varid)
          if( ierr .EQ. NF_NOERR) then
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                  data_count,effph_in)
             if( ierr .NE. NF_NOERR) goto 7001
          endif
c
c  ---- load plume bottom, if available ---
c
          this_var = 'plume_bottom'
          ierr = nf_inq_varid(iounit, this_var, this_varid)
          if( ierr .EQ. NF_NOERR) then
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                  data_count,plume_bot)
             if( ierr .NE. NF_NOERR) goto 7001
          endif
c
c  ---- load plume top, if available ---
c
          this_var = 'plume_top'
          ierr = nf_inq_varid(iounit, this_var, this_varid)
          if( ierr .EQ. NF_NOERR) then
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                  data_count,plume_top)
             if( ierr .NE. NF_NOERR) goto 7001
          endif
c
c   --- check integrity of data ---
c
          do idxpt=1,nptsrc_safile(igroup,idxfile)
             if( plume_bot(idxpt) .GT. 0 .AND. 
     &                    plume_top(idxpt) .LE. 0. ) goto 7002
             if( plume_bot(idxpt) .LE. 0 .AND. 
     &                    plume_top(idxpt) .GT. 0. ) goto 7002
             if( plume_bot(idxpt) .GT. 0. .AND.
     &           plume_bot(idxpt) .GT. plume_top(idxpt) ) goto 7002
          enddo
c          
c   --- read the emissions for this hour ---
c
          do ispc=1,nspec
c
c  --- see if this species is used by DDM ---
c
             luse = .FALSE.
             cname = spname(ispc)
             do iddm=1,nemddm
                 luse = .FALSE.
                 if( emddmsp(iddm) .EQ. cname ) luse = .TRUE.
                 if( emddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE.
                 if( emddmsp(iddm) .EQ. NAMVOC
     &                          .AND. lvocsp(ispc) ) luse = .TRUE.
                 if( emddmsp(iddm) .EQ. NAMNOX
     &                          .AND. lnoxsp(ispc) ) luse = .TRUE.
                 if( emddmsp(iddm) .EQ. NAMHRV
     &                                 .AND. lhrvoc(ispc) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, read and load it ---
c
                 if( .NOT. luse ) cycle
                 this_var = cname                 
                 ierr = nf_inq_varid(iounit, this_var, this_varid)
                 if( ierr .NE. NF_NOERR) cycle
                 ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emispts)
                 if( ierr .NE. NF_NOERR) goto 7000
                 do 30 idxpt=1,nptsrc_safile(igroup,idxfile)
                    idxbase = idx_point_in_list(igroup,idxfile,idxpt)
                    if( effph_in(idxpt) .GT. 0. )
     &                           effph(idxbase) = -effph_in(idxpt)
                    if( plume_bot(idxpt) .GT. 0. )
     &                           effph(idxbase) = -plume_bot(idxpt)
                    if( plume_top(idxpt) .GT. 0. )
     &                           flowrat(idxbase) = -plume_top(idxpt)
                    if( llatlon ) then
                       xloccrs = xlocpt(idxbase) - xorg
                       yloccrs = ylocpt(idxbase) - yorg
                    else
                       xloccrs = xlocpt(idxbase)/1000. - xorg
                       yloccrs = ylocpt(idxbase)/1000. - yorg
                    endif
                    icel = 1 + FLOOR( xloccrs/delx )
                    jcel = 1 + FLOOR( yloccrs/dely )
                    if( icel .LT. 1 .OR. icel .GT. ncol(1) ) goto 30
                    if( jcel .LT. 1 .OR. jcel .GT. nrow(1) ) goto 30
c
c   --- find out if a nest contains this source  ---
c
                    igrd = 1
                    do ig = 2,ngrid
                       xloctmp = xloccrs - (inst1(ig)-1)*delx
                       yloctmp = yloccrs - (jnst1(ig)-1)*dely
                       if( xloctmp .GT. 0. .AND. 
     &                                    yloctmp .GT. 0. ) then
                            ii = 2 + FLOOR( xloctmp/delx *
     &                                       FLOAT( meshold(ig) ) )
                            jj = 2 + FLOOR( yloctmp/dely *
     &                                              FLOAT( meshold(ig) ) )
                            if( ii .GT. 1 .AND. jj .GT. 1 .AND. 
     &                                     ii .LT. ncol(ig) .AND. 
     &                                             jj .LT. nrow(ig) ) then
                               igrd = ig
                               icel = ii
                               jcel = jj
                            endif
                        endif
                    enddo
c
c  --- get the region for this cell from mapping array ----
c
                    imap = igrmap(0,1,igrd,icel,jcel)
                    if( sa_region(idxpt) .GT. 0 ) then
                       if( .NOT. lptoverride ) goto 7001
                       imap = ABS( sa_region(idxpt) )
                    endif
                    if( imap .LE. 0 .OR. imap .GT. nregin ) goto 30
c
c  --- convert to emissions time and put into array ---
c
                    emstmp = emispts(idxpt)/(60.*dtems)
                    iptr = iptddm(ispc) + nicddm + 
     &                    nbcddm*nedge + (iddm-1)*ngroup*nregin +
     &                                        (imap-1)*ngroup + igroup - 1
                       if( emstmp .GT. bdnl(ispc) )
     &                                sapnts(idxbase,iptr) = 
     &                                     sapnts(idxbase,iptr) + emstmp
c
c  --- next point ---
c
   30            continue
c
c  --- next DDM species ---
c
              enddo
c
c  --- next model species ---
c
          enddo
c
c  --- deallocate local arrays --
c
          deallocate( emispts )
          deallocate( sa_region )
          deallocate( effph_in )
          deallocate( plume_bot )
          deallocate( plume_top )
c
c  --- get the next file ---
c
  11    continue
  10  continue
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTDDM: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable in file: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTDDM: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTDDM::'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Point source found with invalid plume ',
     &                                        'distribution values.'
      write(iout,'(A,I10)') 'Point source number in file: ',idxpt
      write(iout,'(A,F10.4)') 'Plume bottom: ',plume_bot(idxpt)
      write(iout,'(A,F10.4)') 'Plume top   : ',plume_top(idxpt)
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine pazero
      use grid
      use chmstry
      use procan
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c     Initializes or re-initializes the Process Analysis data structures
c     to zero.  This routine is called at the beginning of each time
c     step.
c
c     Subroutines Called:
c
c
c     Called by:
c        CAMX
c
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer i, j, k, igrd
c
c   ---- initialize the integrated process rates array to zero ---
c
      if( lipr ) then
         do i=1,NPAPRC
           do j=1,npa_cels
              do k=1,nspec
                 cipr(i,j,k) = 0.
              enddo
           enddo
         enddo 
c
c  ---- initialize the the number of steps to zero ---
c
         do i=1,npa_cels
           do j=1,nspec
             npastep(i,j) = 0
           enddo
         enddo 
      endif
c
c  --- zero out data structures for the integrated reaction rate data ---
c
      if( lirr ) then
c
c  ---- initialize the integrated reaction rates array to zero ---
c
        do i=1,npa_cels
            do j=1,nreact
               cirr(i,j) = 0.
            enddo
        enddo
c
c  --- zero out the gridded chemical process analysis array ---
c
        ptconc = 0.
      endif
c
      return
      end

      subroutine wrtipr(iendat,endtim)
      use filunit
      use chmstry
      use procan
c
c----CAMx v7.40 260801
c
c     This routine writes to the output file for the Integrated Process
c     Rate (IPR) data for the Process Analysis algorithm.  Each record 
c     contains the all of the data for once cell and species for the 
c     specified time period.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        endtim     ending time for this period
c        iendat     ending date for this period
c
c     Subroutines Called:
c
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
c-----Argument declarations
c
      integer iendat
      real    endtim 
c
c-----Local variables
c
c
c-----Entry point
c
c
c  --- loop over the species that should br written to output file
c      (as defines by regular model average species list)
c
      do 10 l=1,navspc
        ispc = lavmap(l)
c
c  --- skip the radical species ---
c
        if( ispc .LE. nrad ) goto 10
c
c  --- loop over the number of sub-domain cells ---
c
        do icel=1,npa_cels
c
c  --- calculate the average volume of cell,
c      and re-initialize the counter ---
c
           if( npastep(icel,ispc) .GT. 0 ) then
              cipr(IPR_VOL,icel,ispc) = cipr(IPR_VOL,icel,ispc) / 
     &                                          npastep(icel,ispc)
           else
              cipr(IPR_VOL,icel,ispc) = 0.0
           endif
c
c  --- write out the record for this cell ---
c
           write(ipr_unit,ERR=7000) iendat, endtim, 
     &                    spname(ispc), ipadom(icel), ipanst(icel),
     &                           ipax(icel), ipay(icel), ipaz(icel),
     &                                 (cipr(i,icel,ispc),i=1,NPAPRC)
c
c  --- next subdomain cell ---
c
        enddo
c
c  --- next species
c
   10 continue
c
c  --- re-initialize counters to zero ---
c
      do icel=1,npa_cels
         do ispc=1,nspec
           npastep(icel,ispc) = 0
         enddo
      enddo
      goto 9999
c
c----Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in WRTIPR:'
      write(iout,'(1X,2A)',ERR=9999) 'Writing data to the output ',
     &                         'Integrated Process Rate (.ipr) file.'
      write(iout,'(10X,A,I8.5,5X,A,F8.1)') 
     &      'Date: ',iendat,'Time: ',endtim
      call camxerr()
c
 9999 continue
      return
      end

      subroutine findtrop(nz,temp,hght,ktrop)
c
c----CAMx v7.40 260801
c
c     FINDTROP finds the tropopause in each vertical column based in input T/P
c     and layer heights. The method is based on the WMO definition of
c     the tropopause where temperature gradient changes from <-2K/km to
c     >-2K/km over at least a 2 km depth.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        nz                  Number of layers
c        temp                Temperature (K)
c        hght                Layer interface heights (m)
c
c     Output arguments:
c        ktrop               Layer index containing tropopause
c
c     Routines called:
c        none
c
c     Called by:
c        STRATO3
c
      implicit none
      integer nz
      integer ktrop
      real temp(nz),hght(nz)

      integer k,kp,km
      real dtdz1,dtdz2,zmid,zmidkp,zmidkm,zp2k,zm2k
c
c-----Entry point
c
c-----Scan vertical T-profile above 5 km
c
      do k = 1,nz-1
        if (hght(k).lt.5000.) cycle 
        zmid = (hght(k) + hght(k-1))/2.
        zp2k = zmid + 2000.          ! Alt 2km above this level
        do kp = k+1,nz
          zmidkp = (hght(kp) + hght(kp-1))/2.
          if (zmidkp.ge.zp2k .or. kp.eq.nz) exit
        enddo
        dtdz1 = (temp(kp) - temp(k))/(zmidkp - zmid)
c
c-----Check T-grad above and below layer and set layer index if trop found
c
        if (dtdz1.gt.-0.002) then
          ktrop = k
          goto 200
        endif
      enddo
c
c-----If we went through whole profile, set trop to top layer
c
      ktrop = nz
 200  continue

      return
      end

c**** STARTSA
c
      subroutine startsa(iounit,nopen)
      use grid
      use chmstry
      use filunit
      use ptemiss
      use procan
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the files needed for the source 
c     apportionment algorithm.  The output files are opened, the input
c     files are opened as needed.
c
c      Copyright Ramboll
c
c     Argument description:
c        Inputs:
c          iounit     I   unit number for output
c        Outputs:   
c          nopen    I   number of files opened
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     12/16/99   --gwilson--   Fixed a bug which caused the model to try
c                              and read a restart file for each find grid
c     07/19/02   --gwilson--   Added code for source area map for nests
c     10/06/04   --cemery --   Restructured for namelist input
c      8/23/06   --cemery--    Instantaneous restart files reduced to 1
c                              per grid type
c      8/25/06   --cemery--    Surface output files now all UAM format,
c                              one file per grid
c     03/15/09   --gwilson--   Added code for deposition output for tracers
c     05/07/12   --cemery--    Added flexi-nesting flag
c     03/01/16   --gwilson--   Added partial source area map
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      integer   iounit
      integer   nopen
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_chkfile
      integer ncf_get_nlayers
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*80 action
      character*10 cname
      integer      igrd, igrp, i, j, n, idxfile, ierr, nlays_in
      logical      lexist
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c-----if doing SA then point source files are read from SA_control section ----
c
      if( tectyp .EQ. SA .AND. luse_points ) then
         action = 'Reading point source filenames.'
         goto 7009
      endif
c
c   --- if option is turned off, just return ---
c
      if( .NOT. ltrace ) goto 9999
      nchar = istrln( flrtsa )
c
c  -- call routine to allocate arrays ----
c
      call alloc_tracer(ngroup,ngrid,ncol,nrow,nlay,nspec)
      call alloc_tracer_full(ngroup,ngrid,ncol,nrow)
      mapfil = ' '
c
c   --- intialize first time through to true ---
c
      lfirst = .TRUE.
      write(iounit,'(/,A,/)') 
     &            '           **** Source Apportionment Files ****'
c
c   --- source area mapping file ---
c
      if( nregin .GT. 0 ) then
         do 10 igrd = 1,ngrid
            write(action,'(A,I2)')
     &                        'Opening Source Area Map for grid: ',igrd
            mapfil(0,igrd) = SA_Source_Area_Map(igrd)
            fname = mapfil(0,igrd)
            if( fname .EQ. ' ' ) then
               if( igrd .EQ. 1 ) goto 7004
               lmapfl(0,igrd) = .FALSE.
               write(iounit,9000)
     &               'No Source Area Map file for Grid #         :',igrd
               goto 10
            endif
            inquire(file=mapfil(0,igrd),exist=lexist)
            if( .NOT. lexist ) goto 7000
            nopen =  nopen + 1
            call getunit(iormap(0,igrd))
            write(iounit,9001)
     &               'Source area map file for grid # ',igrd,'   (unit):',
     &                                                      iormap(0,igrd)
            write(iounit,9002) mapfil(0,igrd)(:istrln(mapfil(0,igrd)))
            lmapfl(0,igrd) = .TRUE.
   10    continue
         if( lpartial ) then
            do igrp=1,ngroup
               do 50 igrd = 1,ngrid
                 write(action,'(2A,I2,A,I2)') 'Opening Partial Source Area ',
     &                             'Map for grid: ',igrd,' group: ',igrp
                 mapfil(igrp,igrd) = Partial_Source_Area_Map(igrp,igrd)
                 fname = mapfil(igrp,igrd)
                 if( fname .EQ. ' ' ) then
                    lmapfl(igrp,igrd) = .FALSE.
                    write(iounit,9000)
     &                 'No Partial Source Area Map file for Grid # :',
     &                                             igrd,' group: ',igrp
                    goto 50
                 endif
                 inquire(file=mapfil(igrp,igrd),exist=lexist)
                 if( .NOT. lexist ) goto 7000
                 nopen =  nopen + 1
                 call getunit(iormap(igrp,igrd))
                 write(iounit,9003)
     &               'Partial Source area map file for grid # ',igrd,
     &                  ' group: ',igrp,'   (unit):',iormap(igrp,igrd)
                 write(iounit,9002) mapfil(igrp,igrd)
     &                              (:istrln(mapfil(igrp,igrd)))
                 lmapfl(igrp,igrd) = .TRUE.
   50          continue
            enddo
         endif
      endif
c
c   --- receptor definition file ----
c
      rcpfil = SA_Receptor_Definitions
      if( rcpfil .NE. ' ' ) then
         action = 'Opening SA Receptor Definition file.'
         fname = rcpfil
         inquire(file=rcpfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorrcp)
         write(iounit,9000)'SA Receptor definition file          (unit):',
     &                                                          iorrcp
         write(iounit,9002) rcpfil(:istrln(rcpfil))
         lrcpfil = .TRUE.
      else
         write(iounit,9000)'No SA Receptor definition file provided.'
         lrcpfil = .FALSE.
      endif
c
c   --- instantaneous file used for initialization ---
c
      if( lrstrt ) then
         action = 'Opening SA master grid Restart file.'
         inifil(IDXCRS) = SA_Master_Restart
         fname = inifil(IDXCRS)
         inquire(file=inifil(IDXCRS),exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorini(IDXCRS))
         write(iounit,9000)
     &                'SA master grid Restart file          (unit):',
     &                                                  iorini(IDXCRS)
         write(iounit,9002) inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
c
         if( ngrid .GT. 1 ) then
            action = 'Opening SA nested grid Restart file.'
            inifil(IDXFIN) = SA_Nested_Restart
            if( inifil(IDXFIN) .NE. ' ' ) then
                fname = inifil(IDXFIN)
                inquire(file=inifil(IDXFIN),exist=lexist)
                if( .NOT. lexist ) goto 7000
                nopen =  nopen + 1
                call getunit(iorini(IDXFIN))
                write(iounit,9000)
     &                  'SA nested grid Restart file          (unit):',
     &                                                    iorini(IDXFIN)
                write(iounit,9002) inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
            elseif (.not.lflexi) then
                goto 7003
            endif
         endif
      endif
c
c   --- figure out how many files in each grid/group ---
c
      num_iortem = 0
      do j=1,ngrid
         num_iortem(j,0) = nemiss_files(j)
         if( nemiss_files(j) .GT. MXFILES ) goto 7006
         do idxfile=1,nemiss_files(j)
            SA_Emiss_Group_Grid(0,j,idxfile) = Emiss_Grid(j,idxfile)
         enddo
      enddo
      if( npoint_files .GT. MXFILES ) goto 7006
      do idxfile=1,npoint_files
         SA_Points_Group(0,idxfile) = Point_Sources(idxfile)
      enddo
      do i=0,ngroup
         do j=1,ngrid
            do idxfile=1,MXFILES
              if( istrln(SA_Emiss_Group_Grid(i,j,idxfile)) .NE. 0 )  
     &                                     num_iortem(j,i) = idxfile
            enddo
         enddo
      enddo
      num_iortpt = 0
      do i=0,ngroup
        do idxfile=1,MXFILES
          if( istrln(SA_Points_Group(i,idxfile)) .NE. 0 )
     &                                      num_iortpt(i) = idxfile
        enddo
      enddo
      call alloc_tracer_emfiles(ngroup,ngrid,nemiss_files,npoint_files,
     &                                      num_iortem,num_iortpt,nspec)
c
c   --- emissions files for the source groupings ---
c
      do 20 i = 1,ngroup
c
c   --- surface emissions file --- 
c
         do 30 j = 1,ngrid
            action = 'Opening SA Gridded Emissions file.'
            if( num_iortem(j,i) .EQ. 0 ) then
                write(iounit,9003)
     &                 'Gridded Emissions file for grid#/group#    :',
     &                                               j,i,' Not supplied'
            else
                do idxfile=1,num_iortem(j,i)
                   if( .NOT. larsrc ) cycle
                   temfil(j,i,idxfile) = ' '
                   ltemfl(j,i,idxfile) = .FALSE.
                   is_netcdf_iortem(j,i,idxfile) = .FALSE.
                   temfil(j,i,idxfile) = SA_Emiss_Group_Grid(i,j,idxfile)
                   ltemfl(j,i,idxfile) = .TRUE.
                   fname = temfil(j,i,idxfile)
                   if( fname .EQ. ' ' ) goto 7007
                   inquire(file=temfil(j,i,idxfile),exist=lexist)
                   if( .NOT. lexist ) goto 7000
                   nopen = nopen + 1
                   call getunit(iortem(j,i,idxfile))
                   cname = 'EMISSIONS '
                   ierr = ncf_chkfile(iortem(j,i,idxfile),fname,action,cname)
                   if( ierr .EQ. ISUCES ) then
                     call nobinary()
                     is_netcdf_iortem(j,i,idxfile) = .FALSE.
                     open(unit=iortem(j,i,idxfile),file=fname,
     &                    ERR=7001,form='UNFORMATTED',status='UNKNOWN')
                   else
                     is_netcdf_iortem(j,i,idxfile) = .TRUE.
                     ierr = nf_open(fname,NF_NOWRITE,iortem(j,i,idxfile))
                     if( ierr .NE. NF_NOERR ) goto 7001
                     nlayers_ems = MAX(nlayers_ems,ncf_get_nlayers(iortem(j,i,idxfile),fname,action))
                   endif
                   write(iounit,9005)
     &                'Gridded Emissions for grid#/group#/file#   (unit):',
     &                                            j,i,idxfile,iortem(j,i,idxfile)
                   write(iounit,9002) temfil(j,i,idxfile)(:istrln(temfil(j,i,idxfile)))
                enddo
            endif
c
   30    continue
c
c   --- elevated point source emissions ----
c
         if( num_iortpt(i) .EQ. 0 ) then
            write(iounit,9004)
     &               'Point Source Emissions file for group#     :',
     &                                                 i,' Not supplied'
         else
            do idxfile=1,num_iortpt(i)
               if( .NOT. lptsrc ) cycle
               tptfil(i,idxfile) = ' '
               ltptfl(i,idxfile) = .FALSE.
               is_netcdf_iortpt(i,idxfile) = .FALSE.
               tptfil(i,idxfile) = SA_Points_Group(i,idxfile)
               fname = tptfil(i,idxfile)
               if( fname .EQ. ' ' ) goto 7008
               action = 'Opening SA Point Source file.'
               ltptfl(i,idxfile) = .TRUE.
               inquire(file=tptfil(i,idxfile),exist=lexist)
               if( .NOT. lexist ) goto 7000
               nopen = nopen + 1
               call getunit(iortpt(i,idxfile))
               cname = 'PTSOURCE  '
               ierr = ncf_chkfile(iortpt(i,idxfile),tptfil(i,idxfile),action,cname)
               if( ierr .EQ. ISUCES ) then
                 call nobinary()
                 is_netcdf_iortpt(i,idxfile) = .FALSE.
                 open(unit=iortpt(i,idxfile),file=tptfil(i,idxfile),ERR=7001,
     &                     form='UNFORMATTED',status='UNKNOWN')
               else
                 is_netcdf_iortpt(i,idxfile) = .TRUE.
                 ierr = nf_open(tptfil(i,idxfile),NF_NOWRITE,iortpt(i,idxfile))
                 if( ierr .NE. NF_NOERR ) goto 7001
               endif
               write(iounit,9007)
     &              'Point Source Emissions for group#    (unit):',
     &                                                    i,iortpt(i,idxfile)
               write(iounit,9002) tptfil(i,idxfile)(:istrln(tptfil(i,idxfile)))
            enddo
         endif
   20 continue
c
c   --- initial conditions file ---
c
      icfil = SA_Initial_Conditions
      if( icfil .NE. ' ' ) then
         action = 'Opening SA Initial Condition file.'
         fname = icfil
         inquire(file=icfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(ioric)
         cname = 'AIRQUALITY'
         ierr = ncf_chkfile(ioric,icfil,action,cname)
         if( ierr .EQ. ISUCES ) then
            call nobinary()
            is_netcdf_ioric = .FALSE.
            open(unit=ioric,file=icfil,ERR=7002,
     &                           form='UNFORMATTED',status='UNKNOWN')
          else
            is_netcdf_ioric = .TRUE.
            ierr = nf_open(icfil,NF_NOWRITE,ioric)
            if( ierr .NE. NF_NOERR ) goto 7001
          endif
          lsa_ioric = .TRUE.
          write(iounit,9000)'SA Initial Condition file            (unit):',
     &                                                          ioric
          write(iounit,9002) icfil(:istrln(icfil))
      else
         write(iounit,9000)'No SA Initial Condition file provided.'
         lsa_ioric = .FALSE.
      endif
c
c   --- boundary conditions file ---
c
      bcfil = SA_Boundary_Conditions
      if( bcfil .NE. ' ' ) then
         action = 'Opening SA Boundary Condition file.'
         fname = bcfil
         inquire(file=bcfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         call getunit(iorbc)
         nopen =  nopen + 1
         cname = 'BOUNDARY  '
         ierr = ncf_chkfile(iorbc,bcfil,action,cname)
         if( ierr .EQ. ISUCES ) then
            call nobinary()
            is_netcdf_iorbc = .FALSE.
            open(unit=iorbc,file=bcfil,ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
         else
            is_netcdf_iorbc = .TRUE.
            ierr = nf_open(bcfil,NF_NOWRITE,iorbc)
            if( ierr .NE. NF_NOERR ) goto 7001
         endif
         write(iounit,9000)'SA Boundary Condition file           (unit):',
     &                                                             iorbc
         write(iounit,9002) bcfil(:istrln(bcfil))
         lsa_iorbc = .TRUE.
      else
         write(iounit,9000)'No SA Boundary Condition file provided.'
         lsa_iorbc = .FALSE.
      endif
c
c
c   --- boundary conditions file ---
c
      tcfil = SA_Top_Concentrations
      if( tcfil .NE. ' ' ) then
         action = 'Opening SA Top Concentrations file.'
         if( .NOT. lsa_iorbc ) goto 7005
         lsa_iortc = .TRUE.
         fname = tcfil
         inquire(file=tcfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         if( is_netcdf_iorbc ) then
            ierr = nf_open(tcfil,NF_NOWRITE,iortc)
            if( ierr .NE. NF_NOERR ) goto 7001
         else
            call nobinary()
            call getunit(iortc)
            write(iounit,9000)'SA Top Concentrations file           (unit):',
     &                                                          iortc
            write(iounit,9002) tcfil(:istrln(tcfil))
            open(unit=iortc,file=tcfil,ERR=7002,
     &                           form='UNFORMATTED',status='UNKNOWN')
         endif
      else
         write(iounit,9000)'No SA Top Concentrations file provided.'
         lsa_iortc = .FALSE.
      endif
c
c   --- output filenames ---
c
      do 40 i=IDXCRS,IDXFIN
         if( i .EQ. IDXFIN .AND. ngrid .EQ. 1 ) goto 40
c
c   --- output instantaneous file ---
c
         confil(i) = flrtsa
         if( i .EQ. IDXCRS ) then
            confil(i)(nchar+1:) = '.sa.inst'
         else
            confil(i)(nchar+1:) = '.sa.finst'
         endif
         fname = confil(i)
         nopen = nopen + 1
         call getunit(iowcon(i))
         open(unit=iowcon(i),file=confil(i),ERR=7002,
     &                           form='UNFORMATTED',status='UNKNOWN')
         if( i .EQ. IDXCRS ) then
            write(iounit,9000)
     &                 'SA INST file for master grid         (unit):',
     &                                                         iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         else
            write(iounit,9000)
     &                 'SA INST file for nested grids        (unit):',
     &                                                         iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         endif
   40 continue
c
c    ---- surface concentrations file ----
c
      if( .NOT. lsfcfl ) then
         write(iounit,9006)
     &                 'SA Surface file                      (unit):',
     &                                                  ' Not supplied'
      else
         do n = 1,ngrid
            fname = flrtsa
            if( .NOT. lcdfout ) then
               write(fname(nchar+1:),'(a,i2.2)') '.sa.grd',n
               sfcfil(n) = fname
               nopen = nopen + 1
               call getunit(iowsfc(n))
               open(unit=iowsfc(n),file=sfcfil(n),ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
               write(iounit,9000)
     &                     'SA Surface file                      (unit):',
     &                                                            iowsfc(n)
               write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
            else
               write(fname(nchar+1:),'(a,i2.2,a)') '.sa.grd',n,'.nc'
               sfcfil(n) = fname
               nopen = nopen + 1
               action = 'Opening SA surface output file.'
               call ncf_createfile(fname,action,iowsfc(n))
               write(iounit,9000) 'SA Surface file:'
               write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
            endif
         enddo
c
c  --- if doing deposition output, open the files ---
c
         if( lptdepout ) then
            do n = 1,ngrid
               fname = flrtsa
               if( .NOT. lcdfout ) then
                  write(fname(nchar+1:),'(a,i2.2)') '.sa.depn.grd',n
                  ptdepfil(n) = fname
                  nopen = nopen + 1
                  call getunit(iowptdep(n))
                  open(unit=iowptdep(n),file=ptdepfil(n),ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
                  write(iounit,9000)
     &                     'SA Deposition file                   (unit):',
     &                                                      iowptdep(n)
                  write(iounit,9002) ptdepfil(n)(:istrln(ptdepfil(n)))
               else
                  write(fname(nchar+1:),'(a,i2.2,a)') '.sa.depn.grd',n,'.nc'
                  ptdepfil(n) = fname
                  nopen = nopen + 1
                  call ncf_createfile(fname,action,iowptdep(n))
                  action = 'Opening SA deposition output file.'
                  write(iounit,9000) 'SA Deposition file:'
                  write(iounit,9002) ptdepfil(n)(:istrln(ptdepfil(n)))
               endif
            enddo
         endif
      endif
c
c    ---- tracer receptor file ----
c
      if( lrcpfil ) then
         avgfil(1:) = flrtsa
         avgfil(nchar+1:) = '.sa.receptor'
         fname = avgfil
         nopen = nopen + 1
         call getunit(iowrcp)
         open(unit=iowrcp,file=avgfil,ERR=7002,form='FORMATTED',
     &                                               status='UNKNOWN')
         write(iounit,9000)
     &            'SA Receptor concentration file       (unit):',iowrcp
         write(iounit,9002) avgfil(:istrln(avgfil))
       endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,A,I8)
 9001 format(/,A,I2,A,I8)
 9002 format(2A)
 9003 format(/,A,I2,1X,I2,A,I8)
 9004 format(/,A,I2,A)
 9005 format(/,A,I2,1X,I2,1X,I2,1X,I8)
 9006 format(/,2A)
 9007 format(/,A,I2,1X,I8)
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Input file does not exist: ',
     &                                             fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Cannot open input file: ',
     &                                             fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(/,1X,2A)') 'Cannot open output file: ',
     &                                             fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(/,1X,3A,/,A)') 'Nested grid restart file for ',
     &                     tectyp(:istrln(tectyp)),' not supplied.',
     &                  ' Set Flexi_Nest = .true. to ignore this file.'
      call camxerr()
c
 7004 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(/,2A)') 'A source area mapping file must be ',
     &                'supplied for the master grid, Grid #1'
      call camxerr()
c
 7005 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(/,2A,/,A)') 'You supplied a file for ',
     &                            'SA_Top_Concentrations but not',
     &                                      'for SA_Boundary_Conditions.'
      write(iounit,'(/,2A,/,A)') 'Top concentrations for source ',
     &                       'apportionment are not',
     &                    'allowed without a boundary conditions file.'
      call camxerr()
c
 7006 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(1X,A)') 'Number of SA emissions files exceeds max.'
      write(iounit,'(1X,2A)') 'Increase parameter MXFILES and recompile.'
      write(iounit,'(1X,2A)') 'It must be at least: ',
     &                              MAX(npoint_files,nemiss_files(j))
      call camxerr()
c
 7007 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of gridded emissions '
      write(iounit,'(1X,2(A,I3))') 'filenames for grid: ',j, ' group: ',i
      write(iounit,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7008 continue
      write(iounit,'(//,A)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of point source '
      write(iounit,'(1X,A,I3)') 'filenames for group: ',i
      write(iounit,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7009 continue
      write(iounit,'(//,a)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'In this version the point source inventory ',
     &           'for a simulation using the SA '
      write(iounit,'(1X,2A)') 'probing tool is provided in the SA_Control ',
     &            'section of the CAMx control file.'
      write(iounit,'(1X,2A)') 'You have supplied filenames in the ',
     &                                         'CAMx_control section.'
      write(iounit,'(1X,2A)') 'Replace these filenames with blank strings ',
     &                              'and include the point source files'
      write(iounit,'(1X,2A)') 'in the SA_Control section.'
      call camxerr()
c
 7010 continue
      write(iounit,'(//,a)') 'ERROR in STARTSA:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A,/,1X,A)') 'In this version the leftover group is ',
     &           'not allowed when using point sources','in any source group.'
      write(iounit,'(1X,2A)') 'Your source groups contain point sources ',
     &            'and the leftover flag is set to .TRUE.'
      write(iounit,'(1X,2A,/,1X,A)') 'When using point sources in any SA emissions ',
     &                 'group you must supply the','entire inventory as emissions groups.'
      write(iounit,'(1X,2A,/,1X,A)') 'Make sure all point sources are included ',
     &         'in emissions groups and turn off','the leftover group flag.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine utmgeo(iway,iutmzon,rx4,ry4,rlon4,rlat4)
c  
c----CAMx v7.40 260801
c  
c     UTMGEO performs UTM to geodetic (lat/lon) translation:
c
c     This is a Fortran version of the BASIC program "Transverse Mercator
c     Conversion", Copyright 1986, Norman J. Berls (Stefan Musarra, 2/94)
c     Based on algorithm taken from "Map Projections Used by the USGS"
c     by John P. Snyder, Geological Survey Bulletin 1532, USDI.
c
c      Copyright Ramboll
c
c     Modifications:
c        12/12/02   Added logic for southern hemisphere UTM zones
c                   Use zones +1 to +60 for NH, -1 to -60 for SH
c                   Equator is defined as 0 km North for NH, 10,000 km N for SH
c        06/08/21   Fixed math errors for M and phi according to:
c                   Snyder, J.P., Map projections - a working manual,
c                   USGS professional paper 1395, 1987
c                   https://doi.org/10.3133/pp1395
c
c     Input arguments:  
c        iway                Conversion type
c                            0 = geodetic to UTM 
c                            1 = UTM to geodetic
c        iutmzon             UTM zone
c                            Northern hemisphere is zones +1 to +60
c                            Southern hemisphere is zones -1 to -60
c        rx4                 UTM easting (km) 
c        ry4                 UTM northing (km) 
c        rlon4               Longitude (deg, negative for W)
c        rlat4               Latitude (deg)
c              
c     Output arguments:  
c        iutmzon             UTM zone
c                            Northern/Southern hemisphere sign convention
c                            is enforced in output value for iutmzon
c        rx4                 UTM easting (km) 
c        ry4                 UTM northing (km) 
c        rlon4               Longitude (deg)
c        rlat4               Latitude (deg)
c              
c     Routines Called:  
c        none 
c              
c     Called by:  
c        GRDPREP  
c   
      implicit real*8 (a-h,o-z)
      real   rx4,ry4,rlon4,rlat4
      real*8 north
      logical lsouth
c      
      parameter(pi=3.14159265358979)
      parameter(degrad=pi/180., raddeg=1./degrad)
      parameter(semimaj=6378206.4, semimin=6356583.8)
c     parameter(e2=1.0-(semimin/semimaj)**2.)
c     parameter(e4=e2*e2, e6=e2*e4, ep2=e2/(1.-e2))
      parameter(scfa=.9996)
      parameter(north=0., east=500000.)
c
      e2=1.0-(semimin/semimaj)**2.0
      e4=e2*e2
      e6=e2*e4
      ep2=e2/(1.-e2)
c
c-----Entry point
c
c-----Set Zone parameters
c
      lsouth = .false.
      if( iutmzon .lt. 0 ) lsouth = .true.
      zone = abs(iutmzon)
      cm = zone*6.0 - 183.0
      cmr = cm*degrad
c
c-----Convert inputs from single to double precision
c
      if (iway.eq.1) then
        xx = DBLE(1000.*rx4)
        yy = DBLE(1000.*ry4)
        if (lsouth) yy = yy - 1.D7
      else
        dlat = DBLE(rlat4)
        dlon = DBLE(rlon4)
      endif
c
c-----Lat/Lon to UTM conversion
c
      if (iway.eq.0) then
	rlat = degrad*dlat
	rlon = degrad*dlon

	delam = dlon - cm
	if (delam.lt.-180.) delam = delam + 360.
	if (delam.gt.180.) delam = delam - 360.
	delam = delam*degrad
	
        f1 = (1. - e2/4. - 3.*e4/64. - 5.*e6/256)*rlat 
        f2 = 3.*e2/8. + 3.*e4/32. + 45.*e6/1024. 
        f2 = f2*sin(2.*rlat) 
        f3 = 15.*e4/256. + 45.*e6/1024. 
        f3 = f3*sin(4.*rlat) 
        f4 = 35.*e6/3072. 
        f4 = f4*sin(6.*rlat) 
        rm = semimaj*(f1 - f2 + f3 - f4) 
        if (dlat.eq.90. .or. dlat.eq.-90.) then 
          xx = 0. 
          yy = scfa*rm 
        else 
          rn = semimaj/sqrt(1. - e2*sin(rlat)**2) 
          t = tan(rlat)**2 
          c = ep2*cos(rlat)**2 
          a = cos(rlat)*delam 
           
          f1 = (1. - t + c)*a**3/6. 
          f2 = 5. - 18.*t + t**2 + 72.*c - 58.*ep2 
          f2 = f2*a**5/120. 
          xx = scfa*rn*(a + f1 + f2) 
          f1 = a**2/2. 
          f2 = 5. - t + 9.*c + 4.*c**2 
          f2 = f2*a**4/24. 
          f3 = 61. - 58.*t + t**2 + 600.*c - 330.*ep2 
          f3 = f3*a**6/720. 
          yy = scfa*(rm + rn*tan(rlat)*(f1 + f2 + f3)) 
        endif
	xx = xx + east
	yy = yy + north
c
c-----UTM to Lat/Lon conversion
c
      else
        xx = xx - east 
        yy = yy - north 
        e1 = sqrt(1. - e2) 
        e1 = (1. - e1)/(1. + e1) 
        rm = yy/scfa 
        u = 1. - e2/4. - 3.*e4/64. - 5.*e6/256. 
        u = rm/(semimaj*u) 
         
        f1 = 3.*e1/2. - 27.*e1**3./32. 
        f1 = f1*sin(2.*u) 
        f2 = 21.*e1**2/16. - 55.*e1**4/32. 
        f2 = f2*sin(4.*u) 
        f3 = 151.*e1**3./96. 
        f3 = f3*sin(6.*u) 
        rlat1 = u + f1 + f2 + f3 
        dlat1 = rlat1*raddeg 
        if (dlat1.ge.90. .or. dlat1.le.-90.) then 
          dlat1 = dmin1(dlat1,dble(90.) ) 
          dlat1 = dmax1(dlat1,dble(-90.) ) 
          dlon = cm 
        else 
          c1 = ep2*cos(rlat1)**2. 
          t1 = tan(rlat1)**2. 
          f1 = 1. - e2*sin(rlat1)**2. 
          rn1 = semimaj/sqrt(f1) 
          r1 = semimaj*(1. - e2)/sqrt(f1**3) 
          d = xx/(rn1*scfa) 
           
          f1 = rn1*tan(rlat1)/r1 
          f2 = d**2/2. 
          f3 = 5. + 3.*t1 + 10.*c1 - 4.*c1**2 - 9.*ep2 
          f3 = f3*d**2*d**2/24. 
          f4 = 61. + 90.*t1 + 298.*c1 + 45.*t1**2. - 252.*ep2 - 3.*c1**2
          f4 = f4*(d**2)**3./720. 
          rlat = rlat1 - f1*(f2 - f3 + f4) 
          dlat = rlat*raddeg 
           
          f1 = 1. + 2.*t1 + c1 
          f1 = f1*d**2*d/6. 
          f2 = 5. - 2.*c1 + 28.*t1 - 3.*c1**2 + 8.*ep2 + 24.*t1**2. 
          f2 = f2*(d**2)**2*d/120. 
          rlon = cmr + (d - f1 + f2)/cos(rlat1) 
          dlon = rlon*raddeg 
          if (dlon.lt.-180.) dlon = dlon + 360. 
          if (dlon.gt.180.) dlon = dlon - 360. 
        endif 
      endif
c
c-----Convert precision of outputs
c
      if (iway.eq.1) then
        rlat4 = REAL(dlat)
        rlon4 = REAL(dlon)
      else
        rx4 = REAL(xx/1000.)
        if (lsouth) yy = yy + 1.D7
        ry4 = REAL(yy/1000.)
      endif
c
      return
      end

c**** NCF_AREAPREP
c
      subroutine ncf_areaprep(action,iunit,igrd,
     &                     begtim,begdate,endtim,enddate,buffer_offset)
      use chmstry
      use bndary
      use grid
      use filunit
      implicit none
c 
c----CAMx v7.40 260801
c 
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_AREAPREP reads the NETCDF gridded emissions files and checks
c     the global variables for consistency with user defined values.
c     It also creates the global species list.
c                           
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         action        C string that describes what we are doing
c         iunit         I NetCDF file ID
c         igrd          I grid index
c         begtim        R model begin time
c         begdat        I model begin date (YYJJJ)
c         endtim        R model end time
c         enddate       I model end date (YYJJJ)
c         buffer_offset I cell offset for buffer cells in file (0 or 1)
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*200 action
      integer       iunit
      integer       igrd
      real          begtim
      integer       begdate
      real          endtim
      integer       enddate
      integer       buffer_offset
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10  emfil, name_in, this_var
      integer       ierr, i, j, n
      logical       lno_buffer_cells
c
c-----------------------------------------------------------------------
c    Data Statements:
c-----------------------------------------------------------------------
c
      data emfil /'EMISSIONS '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- get the type of file to make sure it is a emissions file ---
c
      this_var = 'CAMx_NAME'
      ierr = nf_get_att_text(iunit, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iunit, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7002
      endif
      if( name_in(:9) .NE. emfil(:9) ) goto 7001
c
c --- call routine to make sure grid defintion is consistent ---
c
      lno_buffer_cells = .TRUE.
      if( igrd .EQ. 1 ) lno_buffer_cells = .FALSE.
      call ncf_chk_griddef(iunit,action,igrd,.FALSE.,.TRUE.,
     &                         lno_buffer_cells,.FALSE.,buffer_offset)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iunit,action,begdate,begtim,enddate,endtim,le1day)
c
c --- call routine to setup species mappping array ---
c
      call ncf_set_emiss_mapping(iunit,action)
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_AREAPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get necessary global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_AREAPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',emfil(:istrln(emfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_AREAPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c**** NCF_SET_GLOBAL
c
      subroutine ncf_set_global(inname,igrd,begin_date,begin_time,
     &                       ending_date,ending_time,nlays,nspcs)
      use camxcom
      use grid
      use pigsty
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the global file attributes for the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         inname      C filetype of this kind of file
c         igrd        I grid index
c         begin_date  I model begin date (YYJJJ)
c         begin_time  R model begin time
c         ending_date I model end date (YYJJJ)
c         ending_time R model end time
c         nlays       I number of layers in this file
c         nspcs       I number of species in this file
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c     07/23/18   --bkoo--       Added ncf_bidi_nh3_drydep
c     07/23/19   Staggered wind flag is now grid-specific
c     04/28/21   --cemery--     Added ncf_strat_o3_profile
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
      include 'namelist.inc'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*10 inname
      integer      igrd
      integer      begin_date
      real         begin_time
      integer      ending_date
      real         ending_time
      integer      nlays
      integer      nspcs
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real xorg_grid, yorg_grid, delx_grid, dely_grid
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c
c --- get current date/time ---
c
      call getime(ncf_cdate,ncf_ctime)
      ncf_wdate = ncf_cdate
      ncf_wtime = ncf_ctime
c
c --- domain definition attributes ---
c
      xorg_grid = xorg
      yorg_grid = yorg
      delx_grid = delx
      dely_grid = dely
      if( igrd .GT. 1 ) then
        delx_grid   = delx/FLOAT( meshold(igrd) )
        dely_grid   = delx/FLOAT( meshold(igrd) )
        xorg_grid = xorg + delx*(inst1(igrd)-1)
        yorg_grid = yorg + dely*(jnst1(igrd)-1)
      endif
      ncf_iutm = iuzon
      ncf_istag = 0
      if (lstagw(igrd)) ncf_istag = 1
      ncf_xorig = xorg_grid*1000.
      ncf_yorig = yorg_grid*1000.
      ncf_xcell = delx_grid*1000.
      ncf_ycell = dely_grid*1000.
      if( llatlon ) then
         ncf_cproj = 0
         ncf_gdtyp = 1
         ncf_xorig = xorg_grid
         ncf_yorig = yorg_grid
         ncf_xcell = delx_grid
         ncf_ycell = dely_grid
      else if( lutm ) then
         ncf_cproj = 1
         ncf_gdtyp = 5
      else if( lambrt ) then
         ncf_cproj = 2
         ncf_gdtyp = 2
      else if( lrpolar ) then
         ncf_cproj = 3
         ncf_gdtyp = 4
      else if( lpolar ) then
         ncf_cproj = 4
         ncf_gdtyp = 6
      else if( lmerc ) then
         ncf_cproj = 5
         ncf_gdtyp = 7
      endif
      ncf_xcent = polelon
      ncf_ycent = polelat
      if (tlat1.gt.0.) then
        ncf_p_alp = min(tlat1,tlat2)
        ncf_p_bet = max(tlat1,tlat2)
      else
        ncf_p_alp = max(tlat1,tlat2)
        ncf_p_bet = min(tlat1,tlat2)
      endif
      ncf_p_gam = polelon
      ncf_nlays = nlays
      ncf_nrows = nrow(igrd)
      ncf_ncols = ncol(igrd)
      if( igrd .GT. 1 )  then
         ncf_nrows = nrow(igrd) - 2
         ncf_ncols = ncol(igrd) - 2
      endif
      ncf_nthik = 1
      ncf_nvars = nspcs + 1
c
c --- file description attributes ---
c
      ncf_name = inname
      ncf_note = runmsg
      ncf_itzon = itzon
      ncf_ftype = 1
      ncf_vgtyp = 6
      ncf_vgtop = 10000.
      ncf_vglvls = 0.
      ncf_gdnam = "CAMx v7.40"
      ncf_gdnam = "CAMx v7.40"
      ncf_ioapi_ver = "IOAPI-CAMx"
      ncf_execid = "CAMx"
      ncf_filedesc = inname
      ncf_sdate = Start_Date_Hour(1)*1000 + MOD(begin_date,1000)
      ncf_stime = begin_time*100
      if( dtout .LT. 60. ) then
        ncf_tstep = INT(dtout)*100
      else
        ncf_tstep = INT(dtout/60.)*10000
      endif
      ncf_grid_id = igrd
      ncf_i_grid_start = 1
      ncf_i_grid_end = ncol(1)
      ncf_j_grid_start = 1
      ncf_j_grid_end = nrow(1)
      if( igrd .GT. 1 ) then
         ncf_i_grid_start = inst1(igrd)
         ncf_i_grid_end = inst2(igrd)
         ncf_j_grid_start = jnst1(igrd)
         ncf_j_grid_end = jnst2(igrd)
      endif
      ncf_grid_mesh_factor = meshold(igrd)
c
c --- simulation description attributes ---
c
      ncf_flexi_nest = 0
      if( lflexi ) ncf_flexi_nest = 1
      ncf_advection = Advection_Solver
      ncf_chem_solver = Chemistry_Solver
      ncf_probing_tool = Probing_Tool
      ncf_total_species = nspec
      ncf_radical_species = nrad
      ncf_gas_species = ngas
      ncf_pm_species = naero
      ncf_reactions = nreact
      ncf_drydep = Drydep_Model
      ncf_wetdep = 0
      if( lwet ) ncf_wetdep = 1
      ncf_acm2 = 0
      if( lacm2 ) ncf_acm2 = 1
      ncf_cig_model = 0
      if( Subgrid_Convection ) ncf_cig_model = 1
      ncf_surface_model = 0
      if( lsrfmod ) ncf_surface_model = 1
      ncf_inline_ix_emiss = 0
      if( lixemis ) ncf_inline_ix_emiss = 1
      ncf_bidi_nh3_drydep = 0
      if( lbidinh3 ) ncf_bidi_nh3_drydep = 1
      ncf_strat_o3_profile = 0
      if( lstrato3 ) ncf_strat_o3_profile = 1
      ncf_super_stepping = 0
      if( lsuper ) ncf_super_stepping = 1
      ncf_gridded_emiss = 0
      if( larsrc ) ncf_gridded_emiss = 1
      ncf_point_emiss = 0
      if( lptsrc ) ncf_point_emiss = 1
      ncf_ignore_emiss_dates = 0
      if( le1day ) ncf_ignore_emiss_dates = 1
      ncf_output_3d = 0
      if( l3davg(igrd) ) ncf_output_3d = 1
      ncf_conventions = "CF-1.6"
      ncf_history = 'Generated by '//PRMVERSION
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c**** SPCSPRCSA
c
      subroutine spcsprcsa(namecls,numcls,coefcon,coeflux,
     &                     nameyld,numyld,yieldH,yieldL,molwt_in)
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine initializes the species variables that will be used
c   to determine the species that will be included in each tracer
c   species class
c    Argument descriptions:
c     Input:  
c     Output:  
c       namecls  C  array of regular model species in each tracer class
c       numcls   I  the number of species contributing to this class
c       coefcon  R  2-D array of coefficients for making linear combo
c                   this one for concentrations and emissions
c       coeflux  R  2-D array of coefficients for making linear combo
c                   this one for fluxes
c       nameyld  C  array of regular model species for the yields of
c                   each tracer class
c       numyld   I  number of regular model species for the yields of
c                   each tracer class
c       yieldH   R  high-NOx yield rates for each species in each class
c       yieldL   R  low-NOx yield rates for each species in each class
c       molwt_in R  molecular weight of model species
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     09/20/03   --gwilson--    Original development
c     08/20/06   --bkoo--       Added ETOH, MTBE & MBUT for updated SAPRC99
c                               Fixed wts99
c     12/29/06   --bkoo--       Revised for the updated SOA scheme
c     03/18/14   --bkoo--       Revised for benzene SOA
c     08/25/16   --bkoo--       Updated for new SOAP
c     01/12/18   --bkoo--       Removed SOA class (to be updated)
c     01/16/18   --gyarwood-    Change from SAPRC99 to SAPRC07T
c     01/06/19   --cemery--     Added PFE/PMN/PMG/PK/PCA/PAL/PSI/PTI
c     06/18/19   --bkoo--       Updated SOA class for SAPRC07T
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*10 namecls(MXALCLS,MXSPEC)
      integer      numcls(MXALCLS)
      real         coefcon(MXALCLS,MXSPEC)
      real         coeflux(MXALCLS,MXSPEC)
      character*10 nameyld(MXALCLS,MXSPEC)
      integer      numyld(MXALCLS)
      real         yieldH(MXALCLS,MXSPEC),yieldL(MXALCLS,MXSPEC)
      real         molwt_in(MXSPEC)
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c   NUMS07    I   number of SAPRC07T species used by PSAT treatment
c
      integer NUMS07
c
      parameter( NUMS07 = 70 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 s07nam(NUMS07)
      integer*4    i, j
      real         wts07(NUMS07)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data s07nam /
     &        'NO        ', 'NO2       ', 'HCHO      ', 'CCHO      ',
     &        'RCHO      ', 'ACET      ', 'MEK       ', 'MEOH      ',
     &        'ETHE      ', 'PRPE      ', 'BD13      ', 'ISOP      ',
     &        'APIN      ', 'ACYE      ', 'BENZ      ', 'TOLU      ',
     &        'MXYL      ', 'OXYL      ', 'PXYL      ', 'B124      ',
     &        'ETOH      ', 'ALK1      ', 'ALK2      ', 'ALK3      ',
     &        'ALK4      ', 'ALK5      ', 'OLE1      ', 'OLE2      ',
     &        'ARO1      ', 'ARO2      ', 'TERP      ', 'SESQ      ',
     &        'SO2       ', 'HONO      ', 'NO3       ', 'N2O5      ',
     &        'PAN       ', 'PAN2      ', 'MPAN      ', 'PBZN      ',
     &        'PNA       ', 'RNO3      ', 'XN        ', 'NPHE      ',
     &        'HNO3      ', 'NH3       ', 'IVOA      ', 'SVOA      ',
     &        'ACG2      ', 'ACG1      ', 'BCG2      ', 'BCG1      ',
     &        'HG0       ', 'HG2       ', 'PSO4      ', 'PNO3      ',
     &        'PNH4      ', 'PEC       ', 'HOA       ', 'FCRS      ',
     &        'FPRM      ', 'CCRS      ', 'CPRM      ', 'AOA2      ',
     &        'AOA1      ', 'BOA2      ', 'BOA1      ', 'AOA0      ',
     &        'BOA0      ', 'HGP       '/

      data wts07 /
     &         46.01      ,  46.01      ,  30.03      ,  44.05      ,
     &         58.08      ,  58.08      ,  72.11      ,  32.04      ,
     &         28.05      ,  42.08      ,  54.09      ,  68.12      ,
     &        136.23      ,  26.04      ,  78.11      ,  92.14      ,
     &        106.17      , 106.17      , 106.17      , 120.19      ,
     &         46.07      ,  30.07      ,  44.10      ,  58.12      ,
     &         72.15      , 113.56      ,  70.13      ,  70.13      ,
     &        113.18      , 120.19      , 136.23      , 204.35      ,
     &         64.06      ,  46.01      ,  62.00      , 108.01      ,
     &        121.05      , 135.08      , 147.09      , 183.12      ,
     &         79.01      , 119.1       ,  14.01      , 139.11      ,
     &         63.01      ,  17.03      , 212.0       , 212.0       ,
     &        150.0       , 150.0       , 180.0       , 180.0       ,
     &        200.59      , 200.59      ,   1.0       ,   1.0       ,
     &          1.0       ,   1.0       ,   1.0       ,   1.0       ,
     &          1.0       ,   1.0       ,   1.0       ,   1.0       ,
     &          1.0       ,   1.0       ,   1.0       ,   1.0       ,
     &          1.0       ,   1.0/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- initialize all arrays ---
c
      do i=1,MXALCLS
        numcls(i) = 0
        numyld(i) = 0
        do j=1,MXSPEC
          namecls(i,j) = ' '
          nameyld(i,j) = ' '
          coefcon(i,j) = 0.0
          coeflux(i,j) = 0.0
          yieldH(i,j) = 0.0
          yieldL(i,j) = 0.0
        enddo
      enddo
c
c  --- set the molecular weight for each modeled species ---
c
      do i=1,nspec
        molwt_in(i) = 1.0
        do j=1,NUMS07
           if( spname(i) .EQ. s07nam(j) ) molwt_in(i) = wts07(j)
        enddo
      enddo
c
c   --- if doing the OZONE or NITRATE species ---
c
      if( lozone .OR. lnitrate ) then
c
c  ---- NIT species ---
c
         numcls(ITRNIT) = 2
         namecls(ITRNIT,1) = 'NO'
         coefcon(ITRNIT,1) = 1.0
         coeflux(ITRNIT,1) = 1.0
         namecls(ITRNIT,2) = 'HONO'
         coefcon(ITRNIT,2) = 1.0
         coeflux(ITRNIT,2) = 1.0
c
c  ---- RGN species ---
c
         numcls(ITRRGN) = 3
         namecls(ITRRGN,1) = 'NO2'
         coefcon(ITRRGN,1) = 1.0
         coeflux(ITRRGN,1) = 1.0
         namecls(ITRRGN,2) = 'NO3'
         coefcon(ITRRGN,2) = 1.0
         coeflux(ITRRGN,2) = 1.0
         namecls(ITRRGN,3) = 'N2O5'
         coefcon(ITRRGN,3) = 2.0
         coeflux(ITRRGN,3) = 2.0
c
c  ---- TPN species ---
c
         numcls(ITRTPN) = 5
         namecls(ITRTPN,1) = 'PAN'
         coefcon(ITRTPN,1) = 1.0
         coeflux(ITRTPN,1) = 1.0
         namecls(ITRTPN,2) = 'PAN2'
         coefcon(ITRTPN,2) = 1.0
         coeflux(ITRTPN,2) = 1.0
         namecls(ITRTPN,3) = 'MPAN'
         coefcon(ITRTPN,3) = 1.0
         coeflux(ITRTPN,3) = 1.0
         namecls(ITRTPN,4) = 'PBZN'
         coefcon(ITRTPN,4) = 1.0
         coeflux(ITRTPN,4) = 1.0
         namecls(ITRTPN,5) = 'PNA'
         coefcon(ITRTPN,5) = 1.0
         coeflux(ITRTPN,5) = 1.0
c
c  ---- NTR species ---
c
         numcls(ITRNTR) = 3
         namecls(ITRNTR,1) = 'RNO3'
         coefcon(ITRNTR,1) = 1.0
         coeflux(ITRNTR,1) = 1.0
         namecls(ITRNTR,2) = 'XN'
         coefcon(ITRNTR,2) = 1.0
         coeflux(ITRNTR,2) = 1.0
         namecls(ITRNTR,3) = 'NPHE'
         coefcon(ITRNTR,3) = 1.0
         coeflux(ITRNTR,3) = 1.0
c
c  ---- HN3 species ---
c
         numcls(ITRHN3) = 1
         namecls(ITRHN3,1) = 'HNO3'
         coefcon(ITRHN3,1) = 1.0
         coeflux(ITRHN3,1) = 1.0
      endif
c
c   --- if doing the OZONE species ---
c
      if( lozone ) then
c
c  ---- VOC species ---
c
         numcls(ITRVOC) = 30
         namecls(ITRVOC,1) = 'HCHO'
         coefcon(ITRVOC,1) = 1.0
         coeflux(ITRVOC,1) = 1.0
         namecls(ITRVOC,2) = 'CCHO'
         coefcon(ITRVOC,2) = 2.0
         coeflux(ITRVOC,2) = 2.0
         namecls(ITRVOC,3) = 'RCHO'
         coefcon(ITRVOC,3) = 3.0
         coeflux(ITRVOC,3) = 3.0
         namecls(ITRVOC,4) = 'ACET'
         coefcon(ITRVOC,4) = 3.0
         coeflux(ITRVOC,4) = 3.0
         namecls(ITRVOC,5) = 'MEK'
         coefcon(ITRVOC,5) = 4.0
         coeflux(ITRVOC,5) = 4.0
         namecls(ITRVOC,6) = 'MEOH'
         coefcon(ITRVOC,6) = 1.0
         coeflux(ITRVOC,6) = 1.0
         namecls(ITRVOC,7) = 'ETHE'
         coefcon(ITRVOC,7) = 2.0
         coeflux(ITRVOC,7) = 2.0
         namecls(ITRVOC,8) = 'PRPE'
         coefcon(ITRVOC,8) = 3.0
         coeflux(ITRVOC,8) = 3.0
         namecls(ITRVOC,9) = 'BD13'
         coefcon(ITRVOC,9) = 4.0
         coeflux(ITRVOC,9) = 4.0
         namecls(ITRVOC,10) = 'ISOP'
         coefcon(ITRVOC,10) = 5.0
         coeflux(ITRVOC,10) = 5.0
         namecls(ITRVOC,11) = 'APIN'
         coefcon(ITRVOC,11) = 10.0
         coeflux(ITRVOC,11) = 10.0
         namecls(ITRVOC,12) = 'ACYE'
         coefcon(ITRVOC,12) = 2.0
         coeflux(ITRVOC,12) = 2.0
         namecls(ITRVOC,13) = 'BENZ'
         coefcon(ITRVOC,13) = 6.0
         coeflux(ITRVOC,13) = 6.0
         namecls(ITRVOC,14) = 'TOLU'
         coefcon(ITRVOC,14) = 7.0
         coeflux(ITRVOC,14) = 7.0
         namecls(ITRVOC,15) = 'MXYL'
         coefcon(ITRVOC,15) = 8.0
         coeflux(ITRVOC,15) = 8.0
         namecls(ITRVOC,16) = 'OXYL'
         coefcon(ITRVOC,16) = 8.0
         coeflux(ITRVOC,16) = 8.0
         namecls(ITRVOC,17) = 'PXYL'
         coefcon(ITRVOC,17) = 8.0
         coeflux(ITRVOC,17) = 8.0
         namecls(ITRVOC,18) = 'B124'
         coefcon(ITRVOC,18) = 9.0
         coeflux(ITRVOC,18) = 9.0
         namecls(ITRVOC,19) = 'ETOH'
         coefcon(ITRVOC,19) = 2.0
         coeflux(ITRVOC,19) = 2.0
         namecls(ITRVOC,20) = 'ALK1'
         coefcon(ITRVOC,20) = 2.0
         coeflux(ITRVOC,20) = 2.0
         namecls(ITRVOC,21) = 'ALK2'
         coefcon(ITRVOC,21) = 2.5
         coeflux(ITRVOC,21) = 2.5
         namecls(ITRVOC,22) = 'ALK3'
         coefcon(ITRVOC,22) = 4.0
         coeflux(ITRVOC,22) = 4.0
         namecls(ITRVOC,23) = 'ALK4'
         coefcon(ITRVOC,23) = 5.4
         coeflux(ITRVOC,23) = 5.4
         namecls(ITRVOC,24) = 'ALK5'
         coefcon(ITRVOC,24) = 8.3
         coeflux(ITRVOC,24) = 8.3
         namecls(ITRVOC,25) = 'OLE1'
         coefcon(ITRVOC,25) = 5.2
         coeflux(ITRVOC,25) = 5.2
         namecls(ITRVOC,26) = 'OLE2'
         coefcon(ITRVOC,26) = 5.4
         coeflux(ITRVOC,26) = 5.4
         namecls(ITRVOC,27) = 'ARO1'
         coefcon(ITRVOC,27) = 7.2
         coeflux(ITRVOC,27) = 7.2
         namecls(ITRVOC,28) = 'ARO2'
         coefcon(ITRVOC,28) = 8.8
         coeflux(ITRVOC,28) = 8.8
         namecls(ITRVOC,29) = 'TERP'
         coefcon(ITRVOC,29) = 10.0
         coeflux(ITRVOC,29) = 10.0
         namecls(ITRVOC,30) = 'SESQ'
         coefcon(ITRVOC,30) = 15.0
         coeflux(ITRVOC,30) = 15.0
c
c  ---- O3-NOx species ---
c
         numcls(ITRO3N) = 1
         namecls(ITRO3N,1) = 'O3'
         coefcon(ITRO3N,1) = 0.5
         coeflux(ITRO3N,1) = 1.0
c
c  ---- O3-VOC species ---
c
         numcls(ITRO3V) = 1
         namecls(ITRO3V,1) = 'O3'
         coefcon(ITRO3V,1) = 0.5
         coeflux(ITRO3V,1) = 1.0
c
c  ---- Odd-oxygen in RGN from O3N ---
c
         numcls(ITROON) = 3
         namecls(ITROON,1) = 'NO2'
         coefcon(ITROON,1) = 0.5
         coeflux(ITROON,1) = 1.0
         namecls(ITROON,2) = 'NO3'
         coefcon(ITROON,2) = 0.5
         coeflux(ITROON,2) = 1.0
         namecls(ITROON,3) = 'N2O5'
         coefcon(ITROON,3) = 1.0
         coeflux(ITROON,3) = 2.0
c
c  ---- Odd-oxygen in RGN from O3V ---
c
         numcls(ITROOV) = 3
         namecls(ITROOV,1) = 'NO2'
         coefcon(ITROOV,1) = 0.5
         coeflux(ITROOV,1) = 1.0
         namecls(ITROOV,2) = 'NO3'
         coefcon(ITROOV,2) = 0.5
         coeflux(ITROOV,2) = 1.0
         namecls(ITROOV,3) = 'N2O5'
         coefcon(ITROOV,3) = 1.0
         coeflux(ITROOV,3) = 2.0
      endif
c
c   --- if doing the SULFATE species ---
c
      if( lsulfate ) then
c
c  ---- SO2 species ---
c
        numcls(ITRSO2) = 1
        namecls(ITRSO2,1) = 'SO2'
        coefcon(ITRSO2,1) = 1.0
        coeflux(ITRSO2,1) = 1.0
c
c  ---- PS4 species ---
c
        numcls(ITRPS4) = 1
        namecls(ITRPS4,1) = 'PSO4'
        coefcon(ITRPS4,1) = 1.0
        coeflux(ITRPS4,1) = 1.0
      endif
c
c   --- if doing the NITRATE species ---
c
      if( lnitrate ) then
c
c  ---- NIT species ---
c
c         defined above
c
c  ---- RGN species ---
c
c         defined above
c
c  ---- TPN species ---
c
c         defined above
c
c  ---- NTR species ---
c
c         defined above
c
c  ---- HN3 species ---
c
c         defined above
c
c  ---- PN3 species ---
c
          numcls(ITRPN3) = 1
          namecls(ITRPN3,1) = 'PNO3'
          coefcon(ITRPN3,1) = 1.0
          coeflux(ITRPN3,1) = 1.0
c
c  ---- NH3 species ---
c
          numcls(ITRNH3) = 1
          namecls(ITRNH3,1) = 'NH3'
          coefcon(ITRNH3,1) = 1.0
          coeflux(ITRNH3,1) = 1.0
c
c  ---- PN4 species ---
c
          numcls(ITRPN4) = 1
          namecls(ITRPN4,1) = 'PNH4'
          coefcon(ITRPN4,1) = 1.0
          coeflux(ITRPN4,1) = 1.0
      endif
c
c   --- if doing the SOA species ---
c
      if( lsoa ) then
c
c  ---- ARO species ---
c
          numcls(ITRARO) = 8
          namecls(ITRARO,1) = 'BENZ'
          coefcon(ITRARO,1) = 1.0
          coeflux(ITRARO,1) = 1.0
          namecls(ITRARO,2) = 'TOLU'
          coefcon(ITRARO,2) = 1.0
          coeflux(ITRARO,2) = 1.0
          namecls(ITRARO,3) = 'ARO1'
          coefcon(ITRARO,3) = 1.0
          coeflux(ITRARO,3) = 1.0
          namecls(ITRARO,4) = 'OXYL'
          coefcon(ITRARO,4) = 1.0
          coeflux(ITRARO,4) = 1.0
          namecls(ITRARO,5) = 'MXYL'
          coefcon(ITRARO,5) = 1.0
          coeflux(ITRARO,5) = 1.0
          namecls(ITRARO,6) = 'PXYL'
          coefcon(ITRARO,6) = 1.0
          coeflux(ITRARO,6) = 1.0
          namecls(ITRARO,7) = 'B124'
          coefcon(ITRARO,7) = 1.0
          coeflux(ITRARO,7) = 1.0
          namecls(ITRARO,8) = 'ARO2'
          coefcon(ITRARO,8) = 1.0
          coeflux(ITRARO,8) = 1.0
c
c  ---- ISP species ---
c
          numcls(ITRISP) = 1
          namecls(ITRISP,1) = 'ISOP'
          coefcon(ITRISP,1) = 1.0
          coeflux(ITRISP,1) = 1.0
c
c  ---- TRP species ---
c
          numcls(ITRTRP) = 1
          namecls(ITRTRP,1) = 'TERP'
          coefcon(ITRTRP,1) = 1.0
          coeflux(ITRTRP,1) = 1.0
c
c  ---- APN species ---
c
          numcls(ITRAPN) = 1
          namecls(ITRAPN,1) = 'APIN'
          coefcon(ITRAPN,1) = 1.0
          coeflux(ITRAPN,1) = 1.0
c
c  ---- SQT species ---
c
          numcls(ITRSQT) = 1
          namecls(ITRSQT,1) = 'SESQ'
          coefcon(ITRSQT,1) = 1.0
          coeflux(ITRSQT,1) = 1.0
c
c  ---- AG2 species ---
c
          numcls(ITRAG2) = 1
          namecls(ITRAG2,1) = 'ACG2'
          coefcon(ITRAG2,1) = 1.0
          coeflux(ITRAG2,1) = 1.0
          numyld(ITRAG2) = 10
          nameyld(ITRAG2,1) = 'BENZ'
          yieldH(ITRAG2,1) = MAX(EPSYLD, y_h(1,1))
          yieldL(ITRAG2,1) = MAX(EPSYLD, y_l(1,1))
          nameyld(ITRAG2,2) = 'TOLU'
          yieldH(ITRAG2,2) = MAX(EPSYLD, y_h(1,2))
          yieldL(ITRAG2,2) = MAX(EPSYLD, y_l(1,2))
          nameyld(ITRAG2,3) = 'ARO1'
          yieldH(ITRAG2,3) = MAX(EPSYLD, y_h(1,2))
          yieldL(ITRAG2,3) = MAX(EPSYLD, y_l(1,2))
          nameyld(ITRAG2,4) = 'OXYL'
          yieldH(ITRAG2,4) = MAX(EPSYLD, y_h(1,3))
          yieldL(ITRAG2,4) = MAX(EPSYLD, y_l(1,3))
          nameyld(ITRAG2,5) = 'MXYL'
          yieldH(ITRAG2,5) = MAX(EPSYLD, y_h(1,3))
          yieldL(ITRAG2,5) = MAX(EPSYLD, y_l(1,3))
          nameyld(ITRAG2,6) = 'PXYL'
          yieldH(ITRAG2,6) = MAX(EPSYLD, y_h(1,3))
          yieldL(ITRAG2,6) = MAX(EPSYLD, y_l(1,3))
          nameyld(ITRAG2,7) = 'B124'
          yieldH(ITRAG2,7) = MAX(EPSYLD, y_h(1,3))
          yieldL(ITRAG2,7) = MAX(EPSYLD, y_l(1,3))
          nameyld(ITRAG2,8) = 'ARO2'
          yieldH(ITRAG2,8) = MAX(EPSYLD, y_h(1,3))
          yieldL(ITRAG2,8) = MAX(EPSYLD, y_l(1,3))
          nameyld(ITRAG2,9) = 'IVOA'
          yieldH(ITRAG2,9) = MAX(EPSYLD, y_h(1,4))
          yieldL(ITRAG2,9) = MAX(EPSYLD, y_l(1,4))
          nameyld(ITRAG2,10) = 'SVOA'
          yieldH(ITRAG2,10) = MAX(EPSYLD, y_h(1,5))
          yieldL(ITRAG2,10) = MAX(EPSYLD, y_l(1,5))
c
c  ---- AG1 species ---
c
          numcls(ITRAG1) = 1
          namecls(ITRAG1,1) = 'ACG1'
          coefcon(ITRAG1,1) = 1.0
          coeflux(ITRAG1,1) = 1.0
          numyld(ITRAG1) = 10
          nameyld(ITRAG1,1) = 'BENZ'
          yieldH(ITRAG1,1) = MAX(EPSYLD, y_h(2,1))
          yieldL(ITRAG1,1) = MAX(EPSYLD, y_l(2,1))
          nameyld(ITRAG1,2) = 'TOLU'
          yieldH(ITRAG1,2) = MAX(EPSYLD, y_h(2,2))
          yieldL(ITRAG1,2) = MAX(EPSYLD, y_l(2,2))
          nameyld(ITRAG1,3) = 'ARO1'
          yieldH(ITRAG1,3) = MAX(EPSYLD, y_h(2,2))
          yieldL(ITRAG1,3) = MAX(EPSYLD, y_l(2,2))
          nameyld(ITRAG1,4) = 'OXYL'
          yieldH(ITRAG1,4) = MAX(EPSYLD, y_h(2,3))
          yieldL(ITRAG1,4) = MAX(EPSYLD, y_l(2,3))
          nameyld(ITRAG1,5) = 'MXYL'
          yieldH(ITRAG1,5) = MAX(EPSYLD, y_h(2,3))
          yieldL(ITRAG1,5) = MAX(EPSYLD, y_l(2,3))
          nameyld(ITRAG1,6) = 'PXYL'
          yieldH(ITRAG1,6) = MAX(EPSYLD, y_h(2,3))
          yieldL(ITRAG1,6) = MAX(EPSYLD, y_l(2,3))
          nameyld(ITRAG1,7) = 'B124'
          yieldH(ITRAG1,7) = MAX(EPSYLD, y_h(2,3))
          yieldL(ITRAG1,7) = MAX(EPSYLD, y_l(2,3))
          nameyld(ITRAG1,8) = 'ARO2'
          yieldH(ITRAG1,8) = MAX(EPSYLD, y_h(2,3))
          yieldL(ITRAG1,8) = MAX(EPSYLD, y_l(2,3))
          nameyld(ITRAG1,9) = 'IVOA'
          yieldH(ITRAG1,9) = MAX(EPSYLD, y_h(2,4))
          yieldL(ITRAG1,9) = MAX(EPSYLD, y_l(2,4))
          nameyld(ITRAG1,10) = 'SVOA'
          yieldH(ITRAG1,10) = MAX(EPSYLD, y_h(2,5))
          yieldL(ITRAG1,10) = MAX(EPSYLD, y_l(2,5))
c
c  ---- BG2 species ---
c
          numcls(ITRBG2) = 1
          namecls(ITRBG2,1) = 'BCG2'
          coefcon(ITRBG2,1) = 1.0
          coeflux(ITRBG2,1) = 1.0
c
c  ---- BG1 species ---
c
          numcls(ITRBG1) = 1
          namecls(ITRBG1,1) = 'BCG1'
          coefcon(ITRBG1,1) = 1.0
          coeflux(ITRBG1,1) = 1.0
c
c  ---- PA2 species ---
c
          numcls(ITRPA2) = 1
          namecls(ITRPA2,1) = 'AOA2'
          coefcon(ITRPA2,1) = 1.0
          coeflux(ITRPA2,1) = 1.0
c
c  ---- PA1 species ---
c
          numcls(ITRPA1) = 1
          namecls(ITRPA1,1) = 'AOA1'
          coefcon(ITRPA1,1) = 1.0
          coeflux(ITRPA1,1) = 1.0
c
c  ---- PB2 species ---
c
          numcls(ITRPB2) = 1
          namecls(ITRPB2,1) = 'BOA2'
          coefcon(ITRPB2,1) = 1.0
          coeflux(ITRPB2,1) = 1.0
c
c  ---- PB1 species ---
c
          numcls(ITRPB1) = 1
          namecls(ITRPB1,1) = 'BOA1'
          coefcon(ITRPB1,1) = 1.0
          coeflux(ITRPB1,1) = 1.0
c
c  ---- PA0 species ---
c
          numcls(ITRPA0) = 1
          namecls(ITRPA0,1) = 'AOA0'
          coefcon(ITRPA0,1) = 1.0
          coeflux(ITRPA0,1) = 1.0
          ! SPECIAL CASE: non-volatile CG; anthro -> AOA0 directly (skip CG)
          numyld(ITRPA0) = 10
          nameyld(ITRPA0,1) = 'BENZ'
          yieldH(ITRPA0,1) = MAX(EPSYLD, y_h(3,1))
          yieldL(ITRPA0,1) = MAX(EPSYLD, y_l(3,1))
          nameyld(ITRPA0,2) = 'TOLU'
          yieldH(ITRPA0,2) = MAX(EPSYLD, y_h(3,2))
          yieldL(ITRPA0,2) = MAX(EPSYLD, y_l(3,2))
          nameyld(ITRPA0,3) = 'ARO1'
          yieldH(ITRPA0,3) = MAX(EPSYLD, y_h(3,2))
          yieldL(ITRPA0,3) = MAX(EPSYLD, y_l(3,2))
          nameyld(ITRPA0,4) = 'OXYL'
          yieldH(ITRPA0,4) = MAX(EPSYLD, y_h(3,3))
          yieldL(ITRPA0,4) = MAX(EPSYLD, y_l(3,3))
          nameyld(ITRPA0,5) = 'MXYL'
          yieldH(ITRPA0,5) = MAX(EPSYLD, y_h(3,3))
          yieldL(ITRPA0,5) = MAX(EPSYLD, y_l(3,3))
          nameyld(ITRPA0,6) = 'PXYL'
          yieldH(ITRPA0,6) = MAX(EPSYLD, y_h(3,3))
          yieldL(ITRPA0,6) = MAX(EPSYLD, y_l(3,3))
          nameyld(ITRPA0,7) = 'B124'
          yieldH(ITRPA0,7) = MAX(EPSYLD, y_h(3,3))
          yieldL(ITRPA0,7) = MAX(EPSYLD, y_l(3,3))
          nameyld(ITRPA0,8) = 'ARO2'
          yieldH(ITRPA0,8) = MAX(EPSYLD, y_h(3,3))
          yieldL(ITRPA0,8) = MAX(EPSYLD, y_l(3,3))
          nameyld(ITRPA0,9) = 'IVOA'
          yieldH(ITRPA0,9) = MAX(EPSYLD, y_h(3,4))
          yieldL(ITRPA0,9) = MAX(EPSYLD, y_l(3,4))
          nameyld(ITRPA0,10) = 'SVOA'
          yieldH(ITRPA0,10) = MAX(EPSYLD, y_h(3,5))
          yieldL(ITRPA0,10) = MAX(EPSYLD, y_l(3,5))
c
c  ---- PB0B species ---
c
          numcls(ITRPB0) = 1
          namecls(ITRPB0,1) = 'BOA0'
          coefcon(ITRPB0,1) = 1.0
          coeflux(ITRPB0,1) = 1.0
c
c  ---- IVA species ---
c
          numcls(ITRIVA) = 1
          namecls(ITRIVA,1) = 'IVOA'
          coefcon(ITRIVA,1) = 1.0
          coeflux(ITRIVA,1) = 1.0
c
c  ---- SVA species ---
c
          numcls(ITRSVA) = 1
          namecls(ITRSVA,1) = 'SVOA'
          coefcon(ITRSVA,1) = 1.0
          coeflux(ITRSVA,1) = 1.0
c
c  ---- HOA species ---
c
          numcls(ITRHOA) = 1
          namecls(ITRHOA,1) = 'HOA'
          coefcon(ITRHOA,1) = 1.0
          coeflux(ITRHOA,1) = 1.0
      endif
c
c   --- if doing the PRIMARY species ---
c
      if( lprimary ) then
c
c  ---- PEC species ---
c
          numcls(ITRPEC) = 1
          namecls(ITRPEC,1) = 'PEC'
          coefcon(ITRPEC,1) = 1.0
          coeflux(ITRPEC,1) = 1.0
c
c  ---- PFC species ---
c
          numcls(ITRPFC) = 1
          namecls(ITRPFC,1) = 'FCRS'
          coefcon(ITRPFC,1) = 1.0
          coeflux(ITRPFC,1) = 1.0
c
c  ---- PFN species ---
c
          numcls(ITRPFN) = 1
          namecls(ITRPFN,1) = 'FPRM'
          coeflux(ITRPFN,1) = 1.0
          coefcon(ITRPFN,1) = 1.0
c
c  ---- PCC species ---
c
          numcls(ITRPCC) = 1
          namecls(ITRPCC,1) = 'CCRS'
          coefcon(ITRPCC,1) = 1.0
          coeflux(ITRPCC,1) = 1.0
c
c  ---- PCS species ---
c
          numcls(ITRPCS) = 1
          namecls(ITRPCS,1) = 'CPRM'
          coefcon(ITRPCS,1) = 1.0
          coeflux(ITRPCS,1) = 1.0

          if( lmineral ) then
c
c  ---- PFE species ---
c
              numcls(ITRPFE) = 1
              namecls(ITRPFE,1) = 'PFE'
              coefcon(ITRPFE,1) = 1.0
              coeflux(ITRPFE,1) = 1.0
c
c  ---- PMN species ---
c
              numcls(ITRPMN) = 1
              namecls(ITRPMN,1) = 'PMN'
              coefcon(ITRPMN,1) = 1.0
              coeflux(ITRPMN,1) = 1.0
c
c  ---- PMG species ---
c
              numcls(ITRPMG) = 1
              namecls(ITRPMG,1) = 'PMG'
              coefcon(ITRPMG,1) = 1.0
              coeflux(ITRPMG,1) = 1.0
c
c  ---- PK species ---
c
              numcls(ITRPK) = 1
              namecls(ITRPK,1) = 'PK'
              coefcon(ITRPK,1) = 1.0
              coeflux(ITRPK,1) = 1.0
c
c  ---- PCA species ---
c
              numcls(ITRPCA) = 1
              namecls(ITRPCA,1) = 'PCA'
              coefcon(ITRPCA,1) = 1.0
              coeflux(ITRPCA,1) = 1.0
c
c  ---- PAL species ---
c
              numcls(ITRPAL) = 1
              namecls(ITRPAL,1) = 'PAL'
              coefcon(ITRPAL,1) = 1.0
              coeflux(ITRPAL,1) = 1.0
c
c  ---- PSI species ---
c
              numcls(ITRPSI) = 1
              namecls(ITRPSI,1) = 'PSI'
              coefcon(ITRPSI,1) = 1.0
              coeflux(ITRPSI,1) = 1.0
c
c  ---- PTI species ---
c
              numcls(ITRPTI) = 1
              namecls(ITRPTI,1) = 'PTI'
              coefcon(ITRPTI,1) = 1.0
              coeflux(ITRPTI,1) = 1.0
          endif
      endif
c
c   --- if doing the MERCURY species ---
c
      if( lmercury ) then
c       
c  ---- HG0 species ---
c
          numcls(ITRHG0) = 1
          namecls(ITRHG0,1) = 'HG0'
          coefcon(ITRHG0,1) = 1.0
          coeflux(ITRHG0,1) = 1.0
c       
c  ---- HG2 species ---
c
          numcls(ITRHG2) = 1
          namecls(ITRHG2,1) = 'HG2'
          coefcon(ITRHG2,1) = 1.0
          coeflux(ITRHG2,1) = 1.0
c       
c  ---- PHG species ---
c
          numcls(ITRPHG) = 1
          namecls(ITRPHG,1) = 'HGP'
          coefcon(ITRPHG,1) = 1.0
          coeflux(ITRPHG,1) = 1.0
      endif
c       
      goto 9999
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine nodes_send_puffmass_back(iarray,nspcs,nrctr,numpigs,
     &                                    mpi_type,thistag,numprocs,iproc_id,
     &                                    inslice,numpig,numgrid,igrd        )
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODES_PIG_PASS
c    Subroutines called:
c       MPI_RECV
c       MPI_SEND
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: iarray(nspcs,nrctr,MXPIG)
c
      integer :: nspcs
      integer :: nrctr
      integer :: numpigs
      integer :: mpi_type
      integer :: thistag
      integer :: numprocs
      integer :: iproc_id
      integer :: inslice(numgrid,numprocs,MXPIG)
      integer :: numpig
      integer :: numgrid
      integer :: igrd
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real    :: marray(nrctr,MXPIG)
c
      integer :: nbytes
      integer :: i
      integer :: ispc
      integer :: n
      integer :: k
      integer :: ierr
      integer :: status(MPI_STATUS_SIZE)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.NOT. lmpi) return
c
      nbytes = nrctr * numpigs
c
c  --- master receives data from nodes ---
c
      do ispc=1,nspcs
         if (iproc_id .eq. 0) then
            do i=1, numprocs
               call MPI_RECV(marray,nbytes,mpi_type,i,thistag,
     &                          MPI_COMM_WORLD,status,ierr       )
               do n=1,numpig
                  if (inslice(igrd,i,n) .eq. 1) then
                     do k=1,nrctr
                        iarray(ispc,k,n) = marray(k,n)
                     enddo
                  endif
               enddo
            enddo
         else
c
c  --- node sends data back to master ---
c
            do n=1,numpig
               if (inslice(igrd,iproc_id,n) .eq. 1) then
                  do k=1,nrctr
                     marray(k,n) = iarray(ispc,k,n)
                  enddo
               endif
            enddo
            call MPI_SEND(marray,nbytes,mpi_type,0,thistag,
     &                                          MPI_COMM_WORLD,ierr)
         endif
         thistag = thistag+1
      enddo
c
      return
      end

C***** NCF_RDPTGRP
c
      subroutine ncf_rdptgrp(igroup,emscls,izcel)
      use chmstry
      use filunit
      use ptemiss
      use tracer
      implicit none
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     11/21/25   --gwilson-- Changed the way lemmap works - it now points the other direction
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igroup
      real    emscls(MXTRCLS,*)
      integer izcel(*)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action, fname
      character*16  this_var
      integer       idx_poa_xx(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB), this_idx
      integer       this_tstep, ierr, idxfile, iounit, ispc
      integer       this_time_tflag, this_time_etflag, num_ptsfiles
      integer       idxpt, this_varid, data_start(2), data_count(2)
      integer       icls, idx_start, isoa, iemspec, this_class
c
      real,    allocatable, dimension(:) ::  emispts
      real,    allocatable, dimension(:) ::  emispts_in
      integer, allocatable, dimension(:) ::  sa_region
      real,    allocatable, dimension(:) ::  plume_bot
      real,    allocatable, dimension(:) ::  plume_top
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      idx_poa_xx = -9
      icls = ntrcls
      if( luse_soap3 ) then
         do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
            icls = icls + 1
            do iemspec = 1,nemspc
               if( emspcname(iemspec) .EQ. soap_emiss_names(isoa) )
     &                                       idx_poa_xx(isoa) = iemspec
            enddo
         enddo
      endif
c
c   --- skip if filename not supplied ---
c
      num_ptsfiles = num_iortpt(igroup)
      if( igroup .EQ. 0 ) num_ptsfiles = npoint_files
      do idxfile=1,num_ptsfiles
         if( .NOT. ltptfl(igroup,idxfile) ) cycle
         write(action,'(2A,I3,A,I3)') 'Reading the SA NetCDF point source',
     &            ' emissions file for Group: ',igroup,' File: ',idxfile
         idx_start = idx_start_sapts(igroup,idxfile)
c
c   --- set the unit number for file ---
c
         if( igroup .EQ. 0 ) then
             iounit = iptem(idxfile)
             write(fname,'(A,I3)') 'PTSOURCE -- UNIT ',iptem(idxfile)
             if( .NOT. is_netcdf_iptem(idxfile) ) cycle
         else
             if( .NOT. is_netcdf_iortpt(igroup,idxfile) ) cycle
             iounit = iortpt(igroup,idxfile)
             fname = tptfil(igroup,idxfile)
         endif
c
c  ---- allocate the temporary array ---
c
         allocate( emispts(nptsrc_safile(igroup,idxfile)) )
         allocate( emispts_in(nptsrc_safile(igroup,idxfile)) )
         allocate( sa_region(nptsrc_safile(igroup,idxfile)) )
         allocate( plume_bot(nptsrc_safile(igroup,idxfile)) )
         allocate( plume_top(nptsrc_safile(igroup,idxfile)) )
         plume_bot = 0.
         plume_top = 0.
c
c  ---- get the region override flag ---
c
         sa_region = 0
         this_var = 'saoverride'
         ierr = nf_inq_varid(iounit, this_var, this_varid)
         if( ierr .NE. NF_NOERR ) cycle
         ierr = nf_get_var_int(iounit,this_varid,sa_region)
         if( ierr .NE. NF_NOERR ) goto 7001
         do idxpt=1,nptsrc_safile(igroup,idxfile)
 1            if( sa_region(idxpt) .GT. 0 ) izcel(idxpt+idx_start) = -sa_region(idxpt)
         enddo
c
c  ---- get the index for timestep containing this time ----
c
         this_tstep = ncf_get_tstep(iounit,action,date,time,
     &               this_time_tflag,this_time_etflag,le1day,.TRUE.)
c
c   --- set the indexes for what to read ---
c
         data_start(1) = 1
         data_count(1) = nptsrc_safile(igroup,idxfile)
         data_start(2) = this_tstep
         data_count(2) = 1

         do idxpt = 1,nptsrc_safile(igroup,idxfile)
           effph(idxpt+idx_start) = 0.
           flowrat(idxpt+idx_start) = 0.
         enddo
c
c  ---- plumerise ---
c
         this_var = 'plumerise'
         ierr = nf_inq_varid(iounit, this_var, this_varid)
         if( ierr .EQ. NF_NOERR) then
            ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                  data_count,emispts_in)
            if( ierr .NE. NF_NOERR) goto 7001
c
c  --- Put the data into the global array ----
c
            do idxpt=1,nptsrc_safile(igroup,idxfile)
               if( emispts_in(idxpt) .GT. 0 ) 
     &               effph(idxpt+idx_start) = -emispts_in(idxpt)
            enddo
         endif
c
c   --- read the emissions for this hour ---
c
         do iemspec=1,nemspc
             if( lemmap(iemspec) .LE. 0 ) cycle
             ispc = iemspec
             this_var = emspcname(iemspec)
c
c  --- load data into temporary arrray ---
c
             ierr = nf_inq_varid(iounit, this_var, this_varid)
             if( ierr .NE. NF_NOERR) cycle
             emispts_in = 0.
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emispts_in)
             if( ierr .NE. NF_NOERR) goto 7001
c
c  --- put into regular model array ---
c
             if( this_var(1:4) .EQ. 'POA ') ispc = idx_poa_xx(IDX_SOAP_POA_AV)
             do idxpt=1,nptsrc_safile(igroup,idxfile)
                ptemis(idxpt+idx_start,ispc) = emispts_in(idxpt)/(60.*dtems)
             enddo
c
c  --- if not needed for source apportionment skip the rest ----
c
             if( .NOT. lusespc(lemmap(iemspec)) ) cycle
c
c   --- put into regular model array ---
c
              do idxpt=1,nptsrc_safile(igroup,idxfile)
                emispts(idxpt) = emispts_in(idxpt)/(60.*dtems)
c
c   --- load into the tracer emissions array ---
c
                do icls=1,ntrcls
                   this_class = icls
c
c   --- if this is the NOx emissions tracer and this is a 
c       PiG source, skip it (PiG treated elsewhere) ---
c
                   if( lpigsa(idxpt+idx_start) ) cycle
                   if( this_var(1:3) .EQ. 'POA') cycle
                   emscls(this_class,idxpt+idx_start) = 
     &                           emscls(this_class,idxpt+idx_start) + 
     &                              emispts(idxpt) * trspmap(lemmap(ispc),this_class)
                enddo
                if( this_var(1:4) .EQ. 'POA ' .AND. lsoa ) then
                   this_class = ntrcls + IDX_SOAP_POA_AV - IDX_SOAP_POA_OP + 1
                   emscls(this_class,idxpt+idx_start) = 
     &                       emscls(this_class,idxpt+idx_start) + 
     &                                                      emispts(idxpt)
                endif
              enddo
c
c   --- next species ---
c
         enddo
c
c   --- if doing SOAP3 now look for SOAP3 species and process separately ---

c
         icls = ntrcls
         if( luse_soap3 ) then
            do ispc=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                icls = icls + 1
c
c  --- load data into temporary arrray ---
c
                this_var = soap_emiss_names(ispc)
                ierr = nf_inq_varid(iounit, this_var, this_varid)
                if( ierr .NE. NF_NOERR) cycle
                emispts_in = 0.
                ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emispts_in)
                if( ierr .NE. NF_NOERR) goto 7001
                if( idx_poa_xx(ispc) .LE. 0 ) cycle
c
c  --- put into regular model array ---
c
                do idxpt=1,nptsrc_safile(igroup,idxfile)
                   ptemis(idxpt+idx_start,idx_poa_xx(ispc)) = emispts_in(idxpt)/(60.*dtems)
                enddo
c
c  --- if not needed for source apportionment skip the rest ----
c
                if( .NOT. lsoa ) cycle
c
c   --- put into regular model array ---
c
                do idxpt=1,nptsrc_safile(igroup,idxfile)
                   emispts(idxpt) = emispts_in(idxpt)/(60.*dtems)
                enddo
c
c   --- if this is the NOx emissions tracer and this is a 
c       PiG source, skip it (PiG treated elsewhere) ---
c
                do idxpt=1,nptsrc_safile(igroup,idxfile)
                   if( lpigsa(idxpt+idx_start) ) cycle
                   emscls(icls,idxpt+idx_start) = 
     &                  emscls(icls,idxpt+idx_start) + emispts(idxpt)
                enddo
c
c  --- next SOAP3 species ---
c
           enddo
         endif
c
c   --- get plume bottom, if available ---
c
         this_var = 'plume_bottom'
         ierr = nf_inq_varid(iounit, this_var, this_varid)
         if( ierr .EQ. NF_NOERR) then
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                        data_count,plume_bot)
             if( ierr .NE. NF_NOERR) goto 7001
         endif
c
c   --- get plume top, if available ---
c
         this_var = 'plume_top'
         ierr = nf_inq_varid(iounit, this_var, this_varid)
         if( ierr .EQ. NF_NOERR) then
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                        data_count,plume_top)
             if( ierr .NE. NF_NOERR) goto 7001
         endif
c
c  --- Put the data into the global array ----
c
         do idxpt=1,nptsrc_safile(igroup,idxfile)
            if( plume_top(idxpt) .GT. 0. ) then
               if( plume_bot(idxpt) .GE. plume_top(idxpt) ) goto 7002
               if( plume_bot(idxpt) .LT. 0. ) goto 7002
               effph(idxpt+idx_start) = -plume_bot(idxpt)
               flowrat(idxpt+idx_start) = -plume_top(idxpt)
            endif
         enddo
c
c   --- next file ---
c
         deallocate( emispts    )
         deallocate( emispts_in )
         deallocate( sa_region  )
         deallocate( plume_bot  )
         deallocate( plume_top  )
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTGRP: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTGRP: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTGRP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Point source found with invalid plume ',
     &                                        'distribution values.'
      write(iout,'(A,I10)') 'Point source number in file: ',idxpt
      write(iout,'(A,F10.4)') 'Plume bottom: ',plume_bot(idxpt)
      write(iout,'(A,F10.4)') 'Plume top   : ',plume_top(idxpt)
      call camxerr()
c
 9999 continue
c
      return
      end

c*** LOADDMPM
c
      subroutine loaddmpm(filflg,numcol,numrow,numlay,nddm,grsens,
     &                    icl,jcl,kcl,nfam,nsen,sddm,convfac)
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine loads the sensitivies which are stored in a
c     4-D array from/into a 2-D array in conclusion/preperation 
c     of the DDM-PM chemistry routine.  The 2-D array contains the 
c     family of sensitivities for one cell and all modeled species.
c     The flag "filflg" determines wether the values in the 4-D
c     array are loaded into the 2-D array or vice-versa.  Sensitivities
c     for gases are converted from umol/m3 to ppm for chemistry and back.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c       filflg  L  flag for determining which direction to fill
c                  .TRUE.  = put 2-D values into 4-D gridded array
c                  .FALSE. = put 4-D values into 2-D array
c       numcol  I  number of cells in X direction
c       numrow  I  number of cells in Y direction
c       numlay  I  number of layers 
c       nddm    I  number of total DDM species
c       grsens  R  4-D array of DDM sensitivities
c       icl     I  the X grid location of current cell
c       jcl     I  the Y grid location of current cell
c       kcl     I  the vertical grid location of current layer
c       nfam    I  numbder of DDM families
c       nsen    I  number of modeled species
c       sddm    R  2-D array for this cell and species
c       convfac R  conversion from ppm to umol/m3
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     08/02/05   --bkoo--       Modified from loaddm for DDM-PM
c     06/25/08   --bkoo--       Added SDDM initialization to zero
c     09/01/12   --bkoo--       Updated for v5
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
cbk      include 'camx.prm'
cbk      include 'tracer.com'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      logical filflg
      integer numcol
      integer numrow
      integer numlay
      integer nddm
      real    grsens(numcol,numrow,numlay,nddm)
      integer icl
      integer jcl
      integer kcl
      integer nfam
      integer nsen
      real    sddm(nfam,nsen)
      real    convfac
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   ifam, ispc, iddm
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- task 1: load 4-D array
c
      if ( filflg ) then
c
c  --- loop over the gas species ---
c
        do ispc = 1, NGDDMPM
          if ( jdpmap(ispc).eq.0 ) CYCLE
          do ifam = 1, nfam
            iddm = jdpmap(ispc) + ifam - 1
            grsens(icl,jcl,kcl,iddm) = sddm(ifam,ispc) * convfac
          enddo
        enddo
c
c  --- loop over the PM species ---
c
        do ispc = NGDDMPM+1, nsen
          if ( jdpmap(ispc).eq.0 ) CYCLE
          do ifam = 1, nfam
            iddm = jdpmap(ispc) + ifam - 1
            grsens(icl,jcl,kcl,iddm) = sddm(ifam,ispc)
          enddo
        enddo
c
c  --- task 2: load 2-D array
c
      else
c
c  --- SDDM initialization ---
c
        sddm = 0.0
c
c  --- loop over the gas species ---
c
        do ispc = 1, NGDDMPM
          if ( jdpmap(ispc).eq.0 ) CYCLE
          do ifam = 1, nfam
            iddm = jdpmap(ispc) + ifam - 1
            sddm(ifam,ispc) = grsens(icl,jcl,kcl,iddm) / convfac
          enddo
        enddo
c
c  --- loop over the PM species ---
c
        do ispc = NGDDMPM+1, nsen
          if ( jdpmap(ispc).eq.0 ) CYCLE
          do ifam = 1, nfam
            iddm = jdpmap(ispc) + ifam - 1
            sddm(ifam,ispc) = grsens(icl,jcl,kcl,iddm)
          enddo
        enddo
c
c  --- done ---
c
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine smpprep(lrtrac,endtim,enddate)
      use camxcom
      use camxfld
      use grid
      use chmstry
      use pigsty
      use filunit
      use tracer
      use rtracchm
      use ncf_iomod
c 
c----CAMx v7.40 260801
c 
c     SMPPREP writes headers to new SAMPLING GRID output files.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        8/2/05       Generalized for regular model species or
c                     RTRAC species.
c        1/04/11      Revised for new header format
c 
c     Input arguments: 
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        STARTUP 
c
      implicit none
      include 'flags.inc'
c
      integer MXOUT
      parameter (MXOUT = MAX(MXSPEC,MXTRSP))
c
      logical lrtrac
      integer enddate
      real endtim
      integer idat1,idat2,n,iunit,iutm,l,nsg,izero,ione,nav
      integer iproj
      real tim1,tim2,orgx,orgy,dx,dy,zero
      real plon,plat,t1,t2
      character*4 ifile(10),note(60)
      character*10 avfil
c
      character*4   smpspec(10,MXOUT)
      character*10  smpname(MXOUT), filedesc
      character*20  spec_units(MXSPEC)
      character*20  spec_long_name(MXSPEC)
      character*60  spec_desc(MXSPEC)
      character*60  spec_coords(MXSPEC)
      character*200 action
c
      integer istrln
c
      data avfil /'AVERAGE   '/
      data izero,ione /0,1/
      data zero /0./
c
c-----Entry point
c
      filedesc = avfil
      idat1 = begdate
      idat2 = enddate
      tim1 = begtim/100.
      tim2 = endtim/100.
      read(runmsg(1:60),'(60a1)') (note(n),n=1,60)
      read(avfil,'(10a1)') (ifile(n),n=1,10)
c
c-----Loop over sampling grids; prep grid and species info
c
      do nsg = 1,nsample
        iunit = isample(nsg)
        if (lrtrac) iunit = iowsmp(nsg)
c
        iutm = iuzon
        plon = polelon
        plat = polelat
        t1   = tlat1
        t2   = tlat2
        if (llatlon) then
          iproj = 0
          orgx = xorgsmp(nsg)
          orgy = yorgsmp(nsg)
          dx = delx/meshsmp(nsg)
          dy = dely/meshsmp(nsg)
        else
          orgx = 1000.*xorgsmp(nsg)
          orgy = 1000.*yorgsmp(nsg)
          dx = 1000.*delx/meshsmp(nsg)
          dy = 1000.*dely/meshsmp(nsg)
          if (lutm) then
            iproj = 1
          elseif (lambrt) then
            iproj = 2
          elseif (lrpolar) then
            iproj = 3
          elseif (lpolar) then
            iproj = 4
          elseif (lmerc) then
            iproj = 5
          endif
        endif
c
        if (lrtrac) then
          filedesc = 'RTRAC     '
          nav = nrtrac
          do l = 1,nrtrac
            read(ptname(l),'(10a1)') (smpspec(n,l),n=1,10)
          enddo
        else
          nav = navspc
          do l = 1,navspc
            read(spname(lavmap(l)),'(10a1)') (smpspec(n,l),n=1,10)
            smpname(l) = spname(lavmap(l))
            if( lgas(lavmap(l)) .AND. lgas_out_ppm ) then
               spec_units(l) = "ppmv"
            else
               spec_units(l) = "micrograms m-3"
            endif
            spec_long_name(l) = smpname(l)
            spec_desc(l) = smpname(l)(:istrln(smpname(l)))//" air concentration"
            spec_coords(l) = "latitude longitude"
          enddo
        endif
c
c-----Write header
c
        if( lcdfout ) then
          call ncf_set_vars_base()
          call ncf_set_tstep(begdate,begtim,enddate,endtim)
        endif
        if( .NOT. lcdfout ) then
           rewind(iunit)
           write(iunit) ifile,note,itzon,nav,idat1,tim1,idat2,tim2
           write(iunit) plon,plat,iutm,orgx,orgy,dx,dy,ncolsmp(nsg),
     &                  nrowsmp(nsg),ione,iproj,izero,t1,t2,zero
           write(iunit) ione,ione,ncolsmp(nsg),nrowsmp(nsg)
           write(iunit) ((smpspec(n,l),n=1,10),l=1,nav)
        else
           write(action,'(2A,I2)') 'Writing sampling ',
     &                                    'grid file for sampling grid: ',nsg
           call ncf_set_global_smp(filedesc,nsg,orgx,orgy,dx,dy,
     &                         idat1,tim1*100.,idat2,tim2,ione,navspc)
           call ncf_wrt_dim(action,iunit,nsg,ncolsmp(nsg),nrowsmp(nsg),ione,nav)
           call ncf_wrt_global(action,iunit,nav,smpname,.TRUE.)
           call ncf_wrt_vars_base(action,iunit,nsg)
           call ncf_wrt_vars_species(action,iunit,ncolsmp(nsg),nrowsmp(nsg),ione,
     &                                   navspc,smpname,spec_units,spec_long_name,
     &                                                     spec_desc,spec_coords,4)
           call ncf_enddef_file(action,iunit)
           call ncf_wrt_data_gridsmp(action,iunit,ncolsmp(nsg),nrowsmp(nsg),
     &                                                         orgx,orgy,dx,dy)
        endif
      enddo
c
      return
      end

      subroutine getalbedo(igrd,ncol,nrow,snow,snowage,tsurf,fsurf,
     &                     albedo,snowfrc,snowalb)
c
c----CAMx v7.40 260801
c 
c     GETALB calcualtes surface albedo for the specified grid, according
c     to landuse and snow cover.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        11/4/16        Reductions to critical SWE values for some LU
c        04/23/21       Updated water and bareen UV albedo
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        snow                snow cover water equivalent (m)
c        snowage             snow cover age (hr)
c        tsurf               surface temperature (K)
c        fsurf               fractional landuse cover field (fraction)
c             
c     Output arguments: 
c        albedo              surface net albedo (fraction)
c        snowfrc             net snow cover (fraction)
c        snowalb             surface snow albedo (fraction)
c             
c     Routines called: 
c        None
c             
c     Called by: 
c        EMISTRNS
c 
      implicit none
      include 'camx.prm'
      include 'camx.inc'
      include 'deposit.inc'
c
      integer :: igrd,ncol,nrow
      real, dimension(ncol,nrow) :: snow,snowage
      real, dimension(ncol,nrow) :: tsurf
      real, dimension(ncol,nrow) :: albedo
      real, dimension(ncol,nrow) :: snowfrc
      real, dimension(ncol,nrow) :: snowalb
      real, dimension(ncol,nrow,nlu) :: fsurf
c
      integer i,j,m
      real fsnow,age,c1,c2,albsno,snowc,delalb,old
      real albmax,albc1(2),albc2(2),albtot
      real snowcw(NLUW89),snowcz(NLUZ03)
      real albcw(NLUW89),albcz(NLUZ03)
c
      data albmax /0.85/
      data albc1 /0.94,0.82/
      data albc2 /0.58,0.46/
      data snowcw /.05,.01,.01,.20,.20,.20,.01,.01,.01,.01,.01/
      data snowcz /.01,.01,.01,.20,.20,.20,.20,.20,.20,.02,
     &             .02,.02,.01,.02,.01,.01,.01,.01,.01,.01,
     &             .05,.01,.01,.01,.20,.20/
      data albcw /.08,.05,.05,.05,.05,.05,.07,.10,.05,.05,.05/
      data albcz /.07,.50,.07,.05,.05,.05,.05,.05,.05,.05,
     &            .05,.05,.05,.05,.05,.05,.05,.05,.05,.05,
     &            .08,.05,.05,.10,.05,.05/
c
c-----Entry point
c
c-----Loop over rows and columns
c
      do 30 j = 2,nrow-1 
        do 20 i = 2,ncol-1
          snowfrc(i,j) = 0.
          albedo(i,j) = 0.
c
c-----Determine snow albedo based on snow age
c
          age = snowage(i,j)/24.  ! Convert from hr to days
          old = max(0.,age - dtinp/60./24.)
          c1 = albc1(1)
          c2 = albc2(1)
          if (tsurf(i,j).gt.272.) then
            c1 = albc1(2)
            c2 = albc2(2)
          endif
          if (snowalb(i,j).eq.0.) then
            albsno = albmax*(c1**(age**c2))
          else
            delalb = albmax*(c1**(age**c2) - c1**(old**c2))
            albsno = snowalb(i,j) + delalb
          endif
          albsno = max(0.4,albsno)
          snowalb(i,j) = albsno
c
c-----Determine snow cover fraction and snow albedo for each landuse
c
          do m = 1,nlu
            if (nlu .EQ. NLUW89) then
              snowc = snowcw(m)
            else
              snowc = snowcz(m)
            endif
            fsnow = 1. - exp(-2.6*snow(i,j)/snowc) + 
     &                   (snow(i,j)/snowc)*exp(-2.6)
            fsnow = max(0.,min(1.,fsnow))
c
c----Blend with default terrestrial (non-snow) albedo
c
            if (nlu .EQ. NLUW89) then
              if (m.eq.7) fsnow = 0.
              albtot = fsnow*albsno + (1.-fsnow)*albcw(m)
            else
              if (m.eq.1 .or. m.eq.3) fsnow = 0.
              albtot = fsnow*albsno + (1.-fsnow)*albcz(m)
            endif
            snowfrc(i,j) = snowfrc(i,j) + fsnow*fsurf(i,j,m)
            albedo(i,j) = albedo(i,j) + albtot*fsurf(i,j,m)
          enddo
c
 20     continue
 30   continue
c
      return
      end

      subroutine ncf_rdstacks_sa( )
      use chmstry
      use filunit
      use ptemiss
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_RDPTHDR_SA reads the stack data from the time invariant data in 
c     the NetCDF point source file and loads the data into global varables.
c     This version reads the SA point source files.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     12/20/19   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  this_var
      integer       this_varid, idxfile, ierr, idx_start, ipt, n, i
      integer       iounit, igroup
      real          pi
c
      real*4,  allocatable, dimension(:) :: darray
      integer, allocatable, dimension(:) :: iarray
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data pi /3.1415927/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over number of files ---
c
      do igroup=1,ngroup
      do idxfile=1,num_iortpt(igroup)
         iounit = iortpt(igroup,idxfile)
c
c   --- skip if this is a NetCDF file ---
c
         if( .NOT. is_netcdf_iortpt(igroup,idxfile) ) cycle
         action = 'Reading stack data from NetCDF point source file.'
c
c  --- set the index into stacks array ---
c
         idx_start = idx_start_sapts(igroup,idxfile)
c
c --- allocate the local array to read the stack data ---
c
         allocate( darray(nptsrc_safile(igroup,idxfile)) ) 
         allocate( iarray(nptsrc_safile(igroup,idxfile)) ) 
c
c  --- X coordinates ---
c
         this_var = "xcoord"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             xloc(ipt+idx_start) = darray(ipt)
         enddo
c
c  --- Y coordinates ---
c
         this_var = "ycoord"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             yloc(ipt+idx_start) = darray(ipt)
         enddo
c
c  --- stack height ---
c
         this_var = "stkheight"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             hstk(ipt+idx_start) = darray(ipt)
         enddo
c
c  --- stack diameter ---
c
         this_var = "stkdiam"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             dstk(ipt+idx_start) = ABS(darray(ipt))
         enddo
c
c  --- stack gas exit temperature ---
c
         this_var = "stktemp"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             tstk(ipt+idx_start) = darray(ipt)
         enddo
c
c  --- stack gas exit velocity ---
c
         this_var = "stkspeed"
         ierr = nf_inq_varid(iounit,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
         ierr = nf_get_var_real(iounit,this_varid,darray)
         if( ierr .NE. NF_NOERR ) goto 7001
         do ipt=1,nptsrc_safile(igroup,idxfile)
             vstk(ipt+idx_start) = darray(ipt)/3600.
         enddo
c
c  --- PiG flag ---
c
         if( ipigflg .NE. 0 ) then
            this_var = "pigflag"
            ierr = nf_inq_varid(iounit,this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7000
            ierr = nf_get_var_int(iounit,this_varid,iarray)
            if( ierr .NE. NF_NOERR ) goto 7001
            do ipt=1,nptsrc_safile(igroup,idxfile)
               lpiglet(ipt+idx_start) = .FALSE.
               if( iarray(ipt) .GT. 0 ) then
                    lpiglet(ipt+idx_start) = .TRUE.
               endif
            enddo         
         endif
c
c --- deallocate local arrays ---
c
         deallocate( darray )
         deallocate( iarray )
c
      enddo
      enddo
c
c  --- load  coordinates into array for porbing tools ---
c
      if( ltrace  .OR. lddm .OR. lhddm ) then
         call alloc_tracer_pts(MAX(nptsrc,1))
         if( lptsrc ) then
            do ipt = 1,nptsrc
               xlocpt(ipt) = xloc(ipt)
               ylocpt(ipt) = yloc(ipt)
            enddo
         endif
      endif
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDSTACKS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDSTACKS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine pigdiag(idiag,chtime,chdate,igrd,note)
      use grid
      use pigsty
c
c----CAMx v7.40 260801
c
c-----PIGDIAG outputs key info on each puff
c
c      Copyright Ramboll
c
      include 'camx.prm'
      include 'flags.inc'
c
      character*20 note
      character*8 chtime,chdate
c
      write(idiag,'(/,a,a8,1x,a8)') 'PiG puff info at : ',chtime,chdate
      write(idiag,'(a,i3)') 'Grid #: ',igrd
      write(idiag,'(a)') note
      write(idiag,'(2a)')
     & 'Puff Grid  Point   age       xf        xb        yf        yb ',
     & '     sy     sz     ax     ay     az   fmass  top   bot'
      write(idiag,'(2a)')
     & ' #     #    ID    (min)                 (km or deg)           ',
     & '             (meters)                         (meters)'
      write(idiag,'(2a)')
     & '-----  -- ------ ------- -------------------------------------',
     & '-- ----------------------------------  ---- -----------'
      do 100 n = 1,npig
c       if (ingrd(n).eq.0 .or. ingrd(n).ne.igrd) goto 100
        if (ingrd(n).eq.0) goto 100
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
        xdist = (xpigf(n) - xpigb(n))/
     &          delx*deltax(j,ingrd(n))*meshold(ingrd(n))
        ydist = (ypigf(n) - ypigb(n))/
     &          dely*deltay(ingrd(n))*meshold(ingrd(n))
        xlen  = sqrt(xdist**2 + ydist**2)     
        ay = axisy(n)
        az = axisz(n)
        ax = xlen + 3.*sigx(n)

        write(idiag,'(i5,i4,i7,f8.2,4f10.3,5f7.0,2x,f4.2,
     &                2f6.0)') 
     &                   n,ingrd(n),idpig(n),agepigf(n)/60.,xpigf(n),
     &                   xpigb(n),ypigf(n),ypigb(n),sigy(n),sigz(n),
     &                   ax,ay,az,fmspig(n),pufftop(n),puffbot(n)

cPuff Grid  Point   age       xf        xb        yf        yb      sy     sz     ax     ay     az   fmass  top   bot
c #     #    ID    (min)                 (km or deg)                        (meters)                         (meters)
c-----  -- ------ ------- --------------------------------------- ----------------------------------  ---- -----------
ciiiii  ii iiiiii ffff.ff -ffff.fff -ffff.fff -ffff.fff -ffff.fff fffff. fffff. fffff. fffff. fffff.  f.ff ffff. ffff.

 100  continue
      return
      end

      subroutine hddmchem(hddmjac,ebirxn,ebirate,ddmrate,
     &                    nrxn,nspc,njac,
     &                    nfam,nrfam,ntfam,nhfam,
     &                    ipr,ipt,wft,iph,
     &                    dt,H2O,atm,O2,CH4,H2,
     &                    rk,avgcnc,sddm,ierr)
c
c----CAMx v7.40 260801
c
c     HDDMCHEM advances the 1st and 2nd order sensitivty coefficients
c     one chemistry time step. This follows the CMAQ DDM-3D approach.
c
c      Copyright Ramboll
c
c     History:
c        07/16/07   --bkoo--       Original development
c        06/11/08   --bkoo--       Added rate constant sensitivity
c        12/07/14   --bkoo--       Revised the cutoff code (EPS)
c        01/08/16   --bkoo--       Updated for DDMRATE
c        08/09/18   --bkoo--       Added rate term sensitivity
c
c     Input arguments:
c        hddmjac           name of subroutine to calc full Jacobian
c        ebirxn            name of subroutine to calculate reaction rates
c        ebirate           name of subroutine to calculate species rates needed for the EBI solver
c        ddmrate           name of subroutine to calculate the remaining species rates
c        nrxn              number of reactions
c        nspc              number of state species
c        njac              nspc
c        nfam              number of sensitivity families
c        nrfam             number of rate constant sensitivity families
c        ntfam             number of rate term sensitivity families
c        nhfam             number of 2nd order sensitivity families
c        ipr               pointer array for rxns in rate constant groups;
c                            ipr(0,i) stores the number of rxns in the i-th group
c        ipt               pointer array for terms in rate term groups;
c                            ipt(0,j,i) = 1 if i-th group includes j-th rxn; otherwise, 0
c                            ipt(1,j,i) = # of reactants of j-th rxn included in the i-th group
c                            ipt(1+k,j,i) = pointer to k-th reactant of j-th rxn included ...
c                            ipt(2+ipt(1,j,i),j,i) = # of products of j-th rxn included ...
c                            ipt(2+ipt(1,j,i)+k,j,i) = pointer to k-th product of j-th rxn included ...
c        wft               weighting factors of reactant term sens in net product formation sens formula
c        iph               pointer array for 1st order sensitivity families
c                            to which 2nd order sensitivity is computed
c        dt                chemistry time step (hr)
c        H2O               water vapor concentration (ppm)
c        atm               total gas concentration (M) in ppm
c        O2                oxygen concentration (ppm)
c        CH4               methane concentration (ppm)
c        H2                hydrogen concentration (ppm)
c        rk                reaction rate constant (ppm/hr)
c        avgcnc            average state species concentrations (ppm)
c        sddm              sensitivity matrix sddm (ppm)
c
c     Output arguments:
c        sddm              updated sensitivity matrix
c        ierr              error flag from LU decomposition
c
c     Routines called:
c        HDDMJAC
c        EBIRXN
c        EBIRATE
c        DDMRATE
c        SGEFA
c        SGESL
c
c     Called by:
c        CHEMDRIV
c
      implicit none

      integer  nrxn,nspc,njac,nfam,nrfam,ntfam,nhfam,ierr
      integer  ipr(0:nrxn,nrfam),ipt(0:nspc,nrxn,ntfam),iph(2,nhfam)
      real     wft(nspc,nrxn,ntfam)
      real     dt,H2O,atm,O2,CH4,H2
      real     rk(nrxn),avgcnc(nspc+1)
      real     sddm(nfam,nspc)

      external hddmjac,ebirxn,ebirate,ddmrate

      real     r_eps
      parameter ( r_eps = 1.e18 ) ! 1/eps

      real     ymid(njac+1),rjac(njac+1,njac+1)
      real     aa(njac,njac),a1(njac,njac),bb(njac)
      real     sen1d(njac+1),smid(nfam,njac)
      real     rrxn(nrxn),rtmp(nrxn)
      real     gain(njac+1),loss(njac+1),prod(njac)
      real     flg

      integer  ipvt(njac)
      integer  i,j,n,ip,ipx,ipz1,ipz2,ip1,ip2,iptmp1,iptmp2
c
c---  Entry point
c
      ierr = 0
c
c---  Load concentrations
c
      do i = 1, nspc
        ymid(i) = avgcnc(i)
      enddo
      ymid(njac+1) = 0.0
c
c---  Get the Jacobian
c
      flg = 1.0   ! keep (effective) 1st-order rxns
      rjac = 0.0  ! initialize the Jacobian
      call hddmjac(njac,nrxn,H2O,atm,O2,CH4,H2,flg,rjac,ymid,rk)
c
c---  Fill the coeff matrix
c
      do i = 1, njac
        do j = 1, njac
          aa(i,j) = -0.5 * dt * rjac(i,j)
          a1(i,j) = -aa(i,j)
        enddo
        aa(i,i) = aa(i,i) + 1.0
        a1(i,i) = a1(i,i) + 1.0
      enddo
c
c---  Factor the coeff matrix
c
      call sgefa(aa,njac,njac,ipvt,ierr)
      if (ierr.ne.0) goto 990 ! zero determinant
c
c---  Fill the rxn rate vector if rate const (or term) sens to be computed
c
      if ( nrfam.gt.0 .or. ntfam.gt.0 ) then
        call ebirxn(njac,nrxn,ymid,H2O,atm,O2,CH4,H2,rk,rrxn)
      endif
c
c---  Solve for 1st order sensitivities
c
      ipz1 = nfam - nrfam - ntfam - nhfam
      ipz2 = nfam - ntfam - nhfam

      do ip = 1, nfam - nhfam

        do i = 1, nspc
          sen1d(i) = sddm(ip,i)
        enddo
        do i = 1, njac
          sen1d(i) = sen1d(i) * MIN(1.0, AINT( ABS(sen1d(i))*r_eps ))
        enddo

        prod = 0.0
        if ( ip .gt. ipz2 ) then ! rate terms sens
          ipx = ip - ipz2
          do j = 1, nrxn
            if ( ipt(0,j,ipx).eq.1 ) then
              rtmp = 0.0
              rtmp( j ) = rrxn( j )
              call ebirate(njac,nrxn,rtmp,gain,loss)
              call ddmrate(njac,nrxn,rtmp,gain,loss)
              do i = 1, ipt(1,j,ipx) ! loop over reactants selected
                prod(ipt(1+i,j,ipx)) = prod(ipt(1+i,j,ipx))
     &                               - loss(ipt(1+i,j,ipx)) * dt
     &                               * wft(1+i,j,ipx) ! weighting factors for net product formation sens
              enddo
              do i = 1, ipt(2+ipt(1,j,ipx),j,ipx) ! loop over products selected
                prod(ipt(2+ipt(1,j,ipx)+i,j,ipx))
     &                  = prod(ipt(2+ipt(1,j,ipx)+i,j,ipx))
     &                  + gain(ipt(2+ipt(1,j,ipx)+i,j,ipx)) * dt
              enddo
            endif
          enddo
        elseif ( ip .gt. ipz1 ) then ! rate constant sens
          rtmp = 0.0
          ipx = ip - ipz1
          do j = 1, ipr(0,ipx)
            rtmp( ipr(j,ipx) ) = rrxn( ipr(j,ipx) )
          enddo
          call ebirate(njac,nrxn,rtmp,gain,loss)
          call ddmrate(njac,nrxn,rtmp,gain,loss)
          do i = 1, njac
            prod(i) = ( gain(i) - loss(i) ) * dt
          enddo
        endif

        do i = 1, njac
          bb(i) = 0.0
          do j = 1, njac
            bb(i) = bb(i) + a1(i,j) * sen1d(j)
          enddo
          bb(i) = bb(i) + prod(i)
        enddo

        call sgesl(aa,njac,njac,ipvt,bb,0)

        do i = 1, njac
          bb(i) = bb(i) * MIN(1.0, AINT( ABS(bb(i))*r_eps ))
          smid(ip,i) = 0.5 * (sen1d(i) + bb(i))
        enddo
        do i = 1, nspc
          sddm(ip,i) = bb(i)
        enddo

      enddo
c
c---  Solve for 2nd order sensitivities
c
      do ip = nfam - nhfam + 1, nfam

        ip1 = iph(1, ip - nfam + nhfam)
        ip2 = iph(2, ip - nfam + nhfam)

        prod = 0.0
        iptmp1 = ip1
        iptmp2 = ip2
        do n = 1, 2 ! loop for two 1st-order sens parameters
          if ( iptmp1 .gt. ipz2 ) then ! rate terms sens
          ! NOT SUPPORTED YET (see RDOPTDDM.F)
          elseif ( iptmp1 .gt. ipz1 ) then ! rate constant sens
            rtmp = 0.0
            ipx = iptmp1 - ipz1
            do j = 1, ipr(0,ipx)
              rtmp( ipr(j,ipx) ) = rk( ipr(j,ipx) )
            enddo
            flg = 1.0   ! keep (effective) 1st-order rxns
            rjac = 0.0  ! initialize the Jacobian
            call hddmjac(njac,nrxn,H2O,atm,O2,CH4,H2,flg,rjac,ymid,rtmp)
            do i = 1, njac
              do j = 1, njac
                prod(i) = prod(i) + rjac(i,j) * smid(iptmp2,j)
              enddo
            enddo
            if ( iptmp1.eq.iptmp2 ) then
              prod = 2.0 * prod
              EXIT
            endif
          endif
          iptmp1 = ip2
          iptmp2 = ip1
        enddo

        do i = 1, njac
          sen1d(i) = smid(ip1,i)
        enddo
        sen1d(njac+1) = 0.0

        flg = 0.0   ! remove (effective) 1st-order rxns
        rjac = 0.0  ! initialize the Jacobian
        call hddmjac(njac,nrxn,H2O,atm,O2,CH4,H2,flg,rjac,sen1d,rk)

        do i = 1, nspc
          sen1d(i) = sddm(ip,i)
        enddo
        do i = 1, njac
          sen1d(i) = sen1d(i) * MIN(1.0, AINT( ABS(sen1d(i))*r_eps ))
        enddo

        do i = 1, njac
          bb(i) = 0.0
          do j = 1, njac
            bb(i) = bb(i) + a1(i,j) * sen1d(j)
            prod(i) = prod(i) + rjac(i,j) * smid(ip2,j)
          enddo
          bb(i) = bb(i) + dt * prod(i)
        enddo

        call sgesl(aa,njac,njac,ipvt,bb,0)

        do i = 1, njac
          bb(i) = bb(i) * MIN(1.0, AINT( ABS(bb(i))*r_eps ))
        enddo
        do i = 1, nspc
          sddm(ip,i) = bb(i)
        enddo

      enddo
c
c---  Return point
c
990   return
      end

c**** SPECCSA
c
      subroutine speccsa( )
      use filunit
      use chmstry
      use tracer
      use grid
      use procan
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets up the species names and pointers into the species
c   for all of the CSA species.  Pointers will be set up for both the
c   concentration array and the emissions array.
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/23/99   --gwilson--    Original development (taken from SPECDDM)
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 caffec, cinflu, srcnam
      integer      mvec4d, ispc, iaffec, icsa, mvecedge, i, l, idxcsa
      logical      lout, lsns
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- echo the table of species to the output file ---
c
      write(idiag,*) ' '
      write(idiag,*) ' Affected   Influencing   Source',
     &                   '                       Long            Short' 
      write(idiag,*) ' Species      Species      Type ',
     &                   '      Group   Region   Name            Name' 
      write(idiag,'(1X,79A)') ('-',i=1,79)
c
c  --- calculate the number of CSA species needed and allocate
c      some arrays ---
c
      nddmsp = ntermddm + nrateddm
      ntotsp = nspec * nddmsp

      if ( nddmsp .GT. MXFDDM ) goto 7000
      if ( ntotsp .GT. MXTRSP ) goto 7001
      
      lsns = .NOT. lmpi
      mvecedge = MAX(ncol(1),nrow(1))
      call alloc_ddm(lsns,ngrid,ncol,nrow,nlay,nlayers_ems,nspec,
     &                                    nddmsp,nhddm,mvecedge,iout)
      call alloc_csa_conc(npa_cels,npadom,ntotsp,
     &            i_sw,j_sw,b_lay,i_ne,j_ne,t_lay,iptrcsa)
c
c  --- loop over the modeled species and setup the names ---
c
      do ispc=1,nspec
c
c  --- set the pointer into the array for this family ---
c
          iptddm(ispc) = (ispc-1)*nddmsp + 1
          iaffec = ispc
          caffec = spname(ispc)
c
c  --- set the flag for determining if this species should
c      be output to average file ---
c
          lout = .FALSE.
          do i=1,navspc
            if( lavmap(i) .EQ. ispc ) lout = .TRUE.
          enddo
c
c  --- intialize the index into the array ---
c
          idxcsa = iptddm(ispc) - 1
c
c  --- loop over all of the rate constant sensitivity groups ---
c
          do icsa = 1,nrateddm
             cinflu = rateddm(icsa)
             srcnam = 'RATE'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxcsa,icsa,0,lout,0.0)
          enddo
c
c  --- loop over all of the rate term sensitivity groups ---
c
          do icsa = 1,ntermddm
             cinflu = termddm(icsa)
             srcnam = 'TERM'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxcsa,icsa,0,lout,0.0)
          enddo
c
c  --- get then next affect species ---
c
      enddo
      ntotsp = idxcsa
      ipttim = ntotsp + 1
      nsaspc = ntotsp
      write(idiag,'(1X,79A)') ('-',i=1,79)
      write(idiag,*) 
c
c  --- set the flag for gaseous species ---
c
      lsagas = .FALSE.
      do i=iptddm(nrad+1),iptddm(ngas)+nddmsp-1
         lsagas(i) = .TRUE.
      enddo
c
c  --- initialize all of the tracers concs to zero to start off ---
c
      csaconc = 0.
      csaavrg = 0.
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in SPECCSA:'
      write(iout,'(/,1X,A,I5)')
     &            'ERROR: Number of CSA families exceeds max: ',MXFDDM
      write(iout,'(1X,A,I5)')
     &        'You need room for at least this many families: ',nddmsp
      write(iout,'(1X,A)') 'Increase parameter MXFDDM in camx.prm'
      write(iout,'(1X,2A,I5)') 'Also increase parameter MXTRSP',
     &                     ' in camx.prm if it is less than ',ntotsp
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in SPECCSA:'
      write(iout,'(/,1X,A,I5)')
     &                 'Number of tracer species exceeds max: ',MXTRSP
      write(iout,'(1X,A,I5)')
     &         'You need room for at least this many tracers: ',ntotsp
      write(iout,'(1X,A)') 'Increase parameter MXTRSP in camx.prm'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine readnml(version,enddate,endtim,numprocs)
      use filunit
      use grid
      use chmstry
      use o3colmap
      use camxfld
      use camxcom
      use pigsty
      use procan
      use tracer
      use node_mod
      use rtracchm
c
      implicit none
c
c----CAMx v7.40 260801
c
c     READNML opens and reads the CAMx input namelist file called "CAMx.in"
c     that defines user inputs.  All namelist variables are mapped to 
c     internal variables and checked for appropriate/consistent values.
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        7/20/05       Moved PiG sampling grid inputs to main namelist, added
c                      new options for sampling standard species
c        7/11/07       Added new RTCMC Probing Tool option
c        07/16/07 -bkoo-     Revised for HDDM
c        04/24/08 -gyarwood- Added EBI chemistry solver option
c        06/11/08 -bkoo-     Added rate constant sensitivity
c        10/09/08      Added ACM2 option
c        07/16/08 -bkoo-     Added DDM turn-off flag
c        01/30/09 -bkoo-     Removed the CMC fast solver
c        10/29/09      Added code for RTRAC surface model
c        07/14/10      Added in-line TUV option
c        03/29/11      Added option for inert PM with gas-phase chemistry
c                      and support in-line TUV with aerosol optical depth
c        04/02/12      Removed RADM cloud adjustment option, cloud/aerosol
c                      adjustments now always done with in-line TUV; AHO
c                      file is now just ozone column; number of output
c                      species now determined internally from user list
c        05/07/12      Added flexi-nesting flag
c        04/30/13      Added Surface Model
c        12/05/13      Added "ALL" option for output average species
c        09/02/14      Added subgrid convective model
c        4/10/15       Added WRF polar and mercator projections
c        06/29/15      Added "ALLR" option to include radicals
c        09/11/15      Revised for SA v3
c        03/01/16      Added partial source area map
c        05/13/16      Added in-line Ix emissions flag
c        05/31/16      Extended ACM2 to H/DDM
c        11/09/16      Added Baker APCA point source override option
c        07/23/18      Added Bi-Di NH3 drydep flag
c                      Added ALLOC_LDDMCALC call
c        08/09/18      Added variables for rate term sensitivity
c        02/21/20      Added Mechanism 1 (CB6r5) -rlb-
c        03/18/21      Initialized lddmcalc for all probing tools
c        03/24/21      Added Mechanism 7 (CB7)
c        09/02/21      Added Mechanism 9 (RACM2)
c        11/03/23      Removed Mechanism 6 (CB05)
c
c     Input arguments:
c        version             model version character string
c
c     Output arguments:
c        none
c
c     Routines Called:
c        CVTDATE
c        JSTLFT
c        ISTRLN
c        TOUPPER
c        INIPTR
c        OPENFILS
c
c     Called by:
c        STARTUP
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
      include 'deposit.inc'
      include 'mpif.h'
      include 'rtracsrf.inc'
      include 'vbs.inc'
c
      logical   Dry_Deposition
      namelist /CAMx_Control/
     & Run_Message,Time_Zone,Restart,Start_Date_Hour,End_Date_Hour,
     & Maximum_Timestep,Met_Input_Frequency,Ems_Input_Frequency,
     & Output_Frequency,Map_Projection,UTM_Zone,Longitude_Pole,
     & Latitude_Pole,True_Latitude1,True_Latitude2,Number_of_Grids,
     & Master_SW_XCoord,Master_SW_YCoord,Master_Cell_XSize,
     & Master_Cell_YSize,Master_Grid_Columns,Master_Grid_Rows,
     & Number_of_Layers,Nest_Meshing_Factor,Nest_Beg_I_Index,
     & Nest_End_I_Index,Nest_Beg_J_Index,Nest_End_J_Index,
     & Diagnostic_Error_Check,Advection_Solver,Vadvection_Solver,
     & Chemistry_Solver,
     & Drydep_Model,PiG_Submodel,Probing_Tool,Chemistry,Super_Stepping,
     & Wet_Deposition,ACM2_Diffusion,Gridded_Emissions,Point_Emissions,
     & Ignore_Emission_Dates,Surface_Model,Subgrid_Convection,
     & Inline_Ix_Emissions,Bidi_NH3_Drydep,Strat_Ozone_Profile,
     & Root_Output_Name,Average_Output_3D,Output_Gas_Concs_PPM,
     & Output_3D_Grid,NetCDF_Format_Output,NetCDF_Use_Compression,
     & Output_Species_Names,PiG_Sampling_Grid,
     & Sample_Background,Number_of_Sampling_Grids,SG_Beg_I_Index,
     & SG_End_I_Index,SG_Beg_J_Index,SG_End_J_Index,SG_Mesh_Factor,
     & Flexi_Nest,Chemistry_Parameters,Photolyis_Rates,Photolysis_Rates,
     & Initial_Conditions,Boundary_Conditions,Top_Concentrations,
     & Ozone_Column,Point_Sources,Master_Grid_Restart,
     & Nested_Grid_Restart,PiG_Restart,Surface_Grid,Met2D_Grid,
     & Met3D_Grid,Cloud_Grid,Vdiff_Grid,Emiss_Grid,Srfmod_Grid,
     & Dry_Deposition

c
c======================== Probing Tool Begin ===========================
c
      namelist /SA_Control/
     & SA_File_Root,SA_Master_Sfc_Output,SA_Nested_Sfc_Output,
     & SA_Deposition_Output,
     & SA_Stratify_Boundary,SA_Number_of_Source_Regions,
     & SA_Number_of_Source_Groups,Use_Leftover_Group,
     & Use_Gridded_Leftover_Group,
     & Number_of_Timing_Releases,SA_Receptor_Definitions,
     & SA_Source_Area_Map,SA_Master_Restart,SA_Nested_Restart,
     & SA_Points_Group,SA_Emiss_Group_Grid,SA_Summary_Output,
     & SA_Treat_SULFATE_Class,SA_Treat_NITRATE_Class,
     & SA_Treat_SOA_Class,SA_Treat_PRIMARY_Class,
     & SA_Treat_MERCURY_Class,SA_Treat_OZONE_Class,SA_Use_APCA,
     & SA_Use_APCA_Ptoverride,SA_Use_Partial_SourceMap, 
     & Partial_Source_Area_Map,SA_PT_Override,SA_3D_Average,
     & SA_Initial_Conditions, SA_Boundary_Conditions, SA_Top_Concentrations
c
      namelist /DDM_Control/
     & DDM_File_Root,DDM_Master_Sfc_Output,DDM_Nested_Sfc_Output,
     & DDM_Stratify_Boundary,DDM_Number_of_Source_Regions,
     & DDM_Number_of_Source_Groups,Number_of_IC_Species_Groups,
     & IC_Species_Groups,Number_of_BC_Species_Groups,BC_Species_Groups,
     & Number_of_EM_Species_Groups,Emis_Species_Groups,
     & Number_of_DEP_Species_Groups,Dep_Species_Groups,
     & Number_of_Rate_Const_Groups,Rate_Const_Groups,
     & Number_of_Rate_Term_Groups,Rate_Term_Groups,
     & Number_of_HDDM_Sens_Groups,HDDM_parameters,
     & DDM_Receptor_Definitions,DDM_Source_Area_Map,
     & DDM_Initial_Conditions,DDM_Boundary_Conditions,
     & DDM_Top_Concentrations,DDM_Master_Restart,DDM_Nested_Restart,
     & DDM_Points_Group,DDM_Emiss_Group_Grid,DDM_Calc_Grid,
     & DDM_PT_Override
c
      namelist /RT_Control/
     & RT_File_Root,RT_Initial_Conditions,RT_Boundary_Conditions,
     & RT_Top_Concentrations,RT_Master_Restart,RT_Nested_Restart,
     & RT_Chemistry_Parameters,RT_Receptor_Definitions,RT_Point_Sources,
     & RT_Emiss_Grid,RT_PiG_Sample,RT_Surface_Model,RT_Partitioning,
     & RT_Srfmod_Grid
c
      namelist /PA_Control/
     & PA_File_Root,Number_of_PA_Domains,Within_CAMx_Grid,
     & PA_Beg_I_Index,PA_End_I_Index,PA_Beg_J_Index,PA_End_J_Index,
     & PA_Beg_K_Index,PA_End_K_Index
c
      namelist /CSA_Control/
     & CSA_File_Root,Number_of_CSA_Domains,Within_CAMx_Grid,
     & CSA_Beg_I_Index,CSA_End_I_Index,CSA_Beg_J_Index,CSA_End_J_Index,
     & CSA_Beg_K_Index,CSA_End_K_Index,Number_of_Rate_Const_Groups,
     & Rate_Const_Groups,Number_of_Rate_Term_Groups,Rate_Term_Groups
c
c======================== Probing Tool End =============================
c
      character*20  version
      integer       enddate
      real          endtim
      integer       numprocs
c      
      integer istrln,i,jj,l,lav,n,ibyr,ibmo,ibdy,ieyr,iemo,iedy
      integer ng
      character*200 ctlfil,filtmp
      character*100 action
      character*30  keyword
      character*20  namegrp
      integer   nemiss,cbdate,cedate,inp,ii,iifroot,nopen,igrd,icsa_grid
      logical   lexist, lacross
      logical   lmech1_ok, lmech2_ok, lmech3_ok, lmech4_ok
      logical   lmech5_ok, lmech6_ok, lmech7_ok, lmech8_ok
      logical   lmech9_ok, lmech10_ok
      logical   lixemspc, is_any_grid_emiss
c
      data inp /3/
      data ctlfil /'CAMx.in'/
c
c-----Entry point
c
c-----Open user control file and read core model parameters
c
      Emiss_Grid = ' '
      Dry_Deposition = .FALSE.
      inquire(file=ctlfil,exist=lexist)
      if( .NOT. lexist ) goto 7007
      open(unit=inp,file=ctlfil,STATUS='UNKNOWN',ERR=7005)
      namegrp = 'CAMx_Control'
      action = ' '
      read(inp,CAMx_Control,END=7100,ERR=7102)
c
      runmsg = Run_Message
      filroot = Root_Output_Name
      call jstlft( filroot )
      ii = istrln( filroot )
      if (filroot .EQ. ' ') goto 7006
c
c-----Open ASCII output, diagnostic, and mass reporting files
c
      filtmp = filroot
      filtmp(ii+1:) = '.out'
      call getunit(iout)
      action = 'Opening OUT message file.'
      open(unit=iout,file=filtmp(1:ii+4),status='UNKNOWN',ERR=7000)
c
      filtmp(ii+1:) = '.diag'
      call getunit(idiag)
      action = 'Opening DIAG diagnostic file.'
      open(unit=idiag,file=filtmp(1:ii+5),status='UNKNOWN',ERR=7000)
c
      filtmp(ii+1:) = '.mass'
      call getunit(imass)
      action = 'Opening MASS summary file.'
      open(unit=imass,file=filtmp(1:ii+5),status='UNKNOWN',ERR=7000)
      iifroot = ii
      nopen = 3
c
c-----Write model version to output and diagnostic files
c
      write(iout,8000) version(:istrln(version))
      write(idiag,8000) version(:istrln(version))
 8000 format(//,30x,20('*'),/,30x,a,/,30x,20('*'),//) 
      write(iout,8001) runmsg(:istrln(runmsg))
      write(idiag,8001) runmsg(:istrln(runmsg))
 8001 format(/,a,/)
c
c-----Set internal variables from namelist parameters and check inputs
c
c-----Clock management
c
      itzon = Time_Zone
      ibyr = Start_Date_Hour(1)
      ibmo = Start_Date_Hour(2)
      ibdy = Start_Date_Hour(3)
      begtim = float(Start_Date_hour(4))
      if (ibyr.eq.0 .or. ibmo.eq.0 .or. ibdy.eq.0) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)') 'Simulation start date contains zeros '
        write(iout,'(a,i5)') 'Year:  ',ibyr
        write(iout,'(a,i5)') 'Month: ',ibmo
        write(iout,'(a,i5)') 'Day:   ',ibdy
        call camxerr()
      endif
      if (ibyr.lt.1000) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)') 'Simulation start year must be 4-digit YYYY'
        write(iout,'(a,i5)') 'Year:  ',ibyr
        call camxerr()
      endif
      call cvtdate(ibyr,ibmo,ibdy,begtim,cbdate,begdate)
c
      ieyr = End_Date_Hour(1)
      iemo = End_Date_Hour(2)
      iedy = End_Date_Hour(3)
      endtim = float(End_Date_Hour(4))
      if (ieyr.eq.0 .or. iemo.eq.0 .or. iedy.eq.0)  then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)') 'Simulation end date contains zeros '
        write(iout,'(a,i5)') 'Year:  ',ieyr
        write(iout,'(a,i5)') 'Month: ',iemo
        write(iout,'(a,i5)') 'Day:   ',iedy
        call camxerr()
      endif
      if (ieyr.lt.1000) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)') 'Simulation end year must be 4-digit YYYY'
        write(iout,'(a,i5)') 'Year:  ',ieyr
        call camxerr()
      endif
      call cvtdate(ieyr,iemo,iedy,endtim,cedate,enddate)
c
      if( enddate .LT. begdate ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a,a)') 'Simulation end date is less than ',
     &                                 'simulation start date.'
        write(iout,'(a,i10.5)') 'Simulation start: ',begdate
        write(iout,'(a,i10.5)') 'Simulation end:   ',enddate
        call camxerr()
      elseif( enddate .EQ. begdate ) then
        if( endtim .LE. begtim ) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(a,a)') 'Simulation end time is less than ',
     &                                   'simulation start time.'
          write(iout,'(a,f10.0)') 'Simulation start: ',begtim
          write(iout,'(a,f10.0)') 'Simulation end:   ',endtim
          call camxerr()
        endif
      endif
c
c-----Max timestep and I/O frequencies
c
      dtmax = Maximum_Timestep
      dtinp = Met_Input_Frequency
      dtems = Ems_Input_Frequency
      dtout = Output_Frequency
c
      if( dtmax .LE. 1 .OR. dtinp .LE. 1. .or. dtems .LE. 1.
     &                                    .or. dtout .LE. 1.) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(/,a,/)')
     &            'I/O frequencies must be greater than 1 minute'
        write(iout,'(a,f6.3)')'Maximum time step   (DTMAX): ',dtmax
        write(iout,'(a,f6.3)')'Input interval      (DTINP): ',dtinp
        write(iout,'(a,f6.3)')'Emissions interval  (DTEMS): ',dtems
        write(iout,'(a,f6.3)')'Output interval     (DTOUT): ',dtout
        call camxerr()
      endif
      if( dtmax .GT. MAXDT ) then
        write(iout,'(//,A)') 'WARNING in READNML:'
        write(iout,'(A)') 
     &               'Invalid value specified for maximum time step.'
        write(iout,'(A)') 'A default value will be used instead.'
        write(iout,'(a,f6.0)')'Maximum time step (DTMAX)     : ',dtmax
        write(iout,'(a,f6.0)')'Default value to be used      : ',MAXDT
        dtmax = MAXDT
      endif
      if( (dtmax .GT. 60. .AND. amod(dtmax,60.) .GT. 0. ) .OR.
     &    (dtinp .GT. 60. .AND. amod(dtinp,60.) .GT. 0. ) .OR.
     &    (dtems .GT. 60. .AND. amod(dtems,60.) .GT. 0. ) .OR.
     &    (dtout .GT. 60. .AND. amod(dtout,60.) .GT. 0. )) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)')'An Input/Output interval is > 60 minutes.'
        write(iout,'(a)')'It must be an integer multiple of 60 minutes.'
        write(iout,'(a,f6.0)')'Maximum time step   (DTMAX): ',dtmax
        write(iout,'(a,f6.0)')'Input interval      (DTINP): ',dtinp
        write(iout,'(a,f6.0)')'Emissions interval  (DTEMS): ',dtems
        write(iout,'(a,f6.0)')'Output interval     (DTOUT): ',dtout
        call camxerr()
      endif
      if( (dtmax .LT. 60. .AND. amod(60.,dtmax) .GT. 0. ) .OR.
     &    (dtinp .LT. 60. .AND. amod(60.,dtinp) .GT. 0. ) .OR.
     &    (dtems .LT. 60. .AND. amod(60.,dtems) .GT. 0. ) .OR.
     &    (dtout .LT. 60. .AND. amod(60.,dtout) .GT. 0. )) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)')'An Input/Output interval is < 60 minutes.'
        write(iout,'(a)')'It must divide 60 minutes evenly.'
        write(iout,'(a,f6.0)')'Maximum time step   (DTMAX): ',dtmax
        write(iout,'(a,f6.0)')'Input interval      (DTINP): ',dtinp
        write(iout,'(a,f6.0)')'Emissions interval  (DTEMS): ',dtems
        write(iout,'(a,f6.0)')'Output interval     (DTOUT): ',dtout
        call camxerr()
      endif
      if( amod(amax1(dtinp,dtems),amin1(dtinp,dtems)) .GT. 0. .OR.
     &    amod(amax1(dtinp,dtout),amin1(dtinp,dtout)) .GT. 0. .OR.
     &    amod(amax1(dtems,dtout),amin1(dtems,dtout)) .GT. 0. ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)')'Input/Output intervals must be even multiples'
        write(iout,'(a)')'of each other.'
        write(iout,'(a,f6.0)')'Input interval      (DTINP): ',dtinp
        write(iout,'(a,f6.0)')'Emissions interval  (DTEMS): ',dtems
        write(iout,'(a,f6.0)')'Output interval     (DTOUT): ',dtout
        call camxerr()
      endif
c
c-----Projection parameters
c
      llatlon = .FALSE.
      lutm    = .FALSE.
      lrpolar = .FALSE.
      lambrt  = .FALSE.
      lpolar  = .FALSE.
      lmerc   = .FALSE.
      call jstlft( Map_Projection )
      call toupper( Map_Projection )
      if( Map_Projection .EQ. 'LATLON    ' ) then
         llatlon = .TRUE.
      elseif( Map_Projection .EQ. 'UTM       ' ) then
         lutm = .TRUE.
      elseif( Map_Projection .EQ. 'RPOLAR    ' ) then
        lrpolar = .TRUE.
      elseif( Map_Projection .EQ. 'LAMBERT   ' ) then
        lambrt = .TRUE.
      elseif( Map_Projection .EQ. 'POLAR     ' ) then
        lpolar = .TRUE.
      elseif( Map_Projection .EQ. 'MERCATOR  ' ) then
        lmerc  = .TRUE.
      else
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(3A)') 'Incorrect coordinate ID specified in ',
     &                     'control file: ',Map_Projection
        write(iout,'(1X,A)') 'Acceptable options are:'
        write(iout,'(10X,A)') 'LATLON'
        write(iout,'(10X,A)') 'UTM'
        write(iout,'(10X,A)') 'RPOLAR'
        write(iout,'(10X,A)') 'LAMBERT'
        write(iout,'(10X,A)') 'POLAR'
        write(iout,'(10X,A)') 'MERCATOR'
        call camxerr()
      endif
c
      if( lutm ) then
         iuzon = UTM_Zone
         if( iuzon .eq. 0 ) then
           write(iout,'(//,A)')'ERROR in READNML:'
           write(iout,'(A)')   '  The UTM zone can not be set to zero'
           write(iout,'(2A)')  '  Use +60 for the northern or -60 for',
     &                         ' the southern hemisphere'
           call camxerr()
         endif
      elseif( lrpolar .or. lambrt .or. lpolar .or. lmerc ) then
         polelon = Longitude_Pole
         polelat = Latitude_Pole
         if( lambrt .or. lpolar .or. lmerc ) then
           tlat1 = True_Latitude1
           if ( lambrt ) tlat2 = True_Latitude2
         endif
      endif
c
c-----Number of Grids
c
      ngrid = Number_of_Grids
c
c----Calculate number of emissions files for each grid ---
c
      is_any_grid_emiss = .FALSE.
      allocate(nemiss_files(ngrid))
      do igrd=1,ngrid
         nemiss_files(igrd) = 0
      enddo
      do igrd = 1,ngrid
        do i=1,MXNAM
          if( istrln(Emiss_Grid(igrd,i)) .NE. 0 ) then
            nemiss_files(igrd) = i
            is_any_grid_emiss = .TRUE.
          endif
        enddo
        do i=1,MXNAM
          if( istrln(Point_Sources(i)) .NE. 0 ) npoint_files = i
        enddo
      enddo
c
c----Call routine to allocate arrays for file units ---
c
      call alloc_filunit(ngrid,nemiss_files,MAX(npoint_files,1))
c
      nnest = ngrid - 1
      if( ngrid .LT. 1 ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(a)') 'Number of grids must be 1 or more'
        call camxerr()
      endif
c
c----Call routine to allocate arrays for grid definitions ---
c
      call alloc_grid()
c
c-----Master grid parameters
c
      xorg     = Master_SW_XCoord
      yorg     = Master_SW_YCoord
      delx     = Master_Cell_XSize
      dely     = Master_Cell_YSize
      ncol(1)  = Master_Grid_Columns
      nrow(1)  = Master_Grid_Rows
      nlay(1)  = Number_of_Layers
      inst1(1) = 2
      inst2(1) = ncol(1)-1
      jnst1(1) = 2
      jnst2(1) = nrow(1)-1
c
c-----Nested grid parameters
c
      if (ngrid.gt.1) then
        do n = 2,ngrid
          meshold(n) = Nest_Meshing_Factor(n)
          inst1(n)   = Nest_Beg_I_Index(n)
          inst2(n)   = Nest_End_I_Index(n)
          jnst1(n)   = Nest_Beg_J_Index(n)
          jnst2(n)   = Nest_End_J_Index(n)
          nlay(n)    = Number_of_Layers
        enddo
c
        do n = 2,ngrid
          if( inst1(n) .LE. 1 .OR. inst1(n) .GE. ncol(1) .OR.
     &        inst2(n) .LE. 1 .OR. inst2(n) .GE. ncol(1) .OR.
     &        jnst1(n) .LE. 1 .OR. jnst1(n) .GE. nrow(1) .OR.
     &        jnst2(n) .LE. 1 .OR. jnst2(n) .GE. nrow(1) ) then
              write(iout,'(//,a)') 'ERROR in READNML:'
              write(iout,'(a,i5)') 'For grid # ',n
              write(iout,'(2a)') 'Starting/ending indices exceed ',
     &                           'extent of coarse grid.'
              write(iout,'(a,2i5)') 'Nest column range   :',
     &                              inst1(n),inst2(n)
              write(iout,'(a,2i5)') 'Coarse column range :',
     &                              1,ncol(1)
              write(iout,'(a,2i5)') 'Nest row range      :',
     &                              jnst1(n),jnst2(n)
              write(iout,'(a,2i5)') 'Coarse row range    :',
     &                              1,nrow(1)
              call camxerr()
          endif
c
c-----Calculate dimensions for the grid and check for array overflow
c
          ncol(n) = (inst2(n) - inst1(n) + 1)*meshold(n) + 2
          nrow(n) = (jnst2(n) - jnst1(n) + 1)*meshold(n) + 2
        enddo
      endif
c
c-----Model options/flags
c
      call jstlft( Advection_Solver )
      call toupper( Advection_Solver )
      if( Advection_Solver .EQ. 'BOTT      ' ) then
        iadvct = 2
      elseif( Advection_Solver .EQ. 'PPM       ' ) then
        iadvct = 3
      else
        write(iout,'(//,a)') 'ERROR in READNML:' 
        write(iout,'(3A)') 'Incorrect horizontal advection solver ',
     &                'specified in control file: ',Advection_Solver
        write(iout,'(1X,A)')'Acceptable options are:'
        write(iout,'(10X,A)') 'BOTT'
        write(iout,'(10X,A)') 'PPM'
        call camxerr()
      endif
c
      call jstlft( Vadvection_Solver )
      call toupper( Vadvection_Solver )
      if( Vadvection_Solver .EQ. 'IMPLICIT  ' ) then
        lzppm = .false.
      elseif( Vadvection_Solver .EQ. 'PPM       ' ) then
        lzppm = .true.
      else
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(3A)') 'Incorrect vertical advection solver ',
     &                'specified in control file: ',Vadvection_Solver
        write(iout,'(1X,A)')'Acceptable options are:'
        write(iout,'(10X,A)') 'IMPLICIT'
        write(iout,'(10X,A)') 'PPM'
        call camxerr()
      endif
c
      call jstlft( Chemistry_Solver )
      call toupper( Chemistry_Solver )
      if( Chemistry_Solver .EQ. CDCMC ) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(/,1X,2A)')
     &                      'The CMC solver is no longer supported. ',
     &                      'Use the EBI solver instead.'
          call camxerr()
      else if( Chemistry_Solver .EQ. CDEBI ) then
          idsolv = IDEBI
      else if( Chemistry_Solver .EQ. CDLSOD ) then
          idsolv = IDLSOD
      else
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(/,1X,6A)') 'Invalid chemistry solver specified ',
     &                              'in control file: ',Chemistry_Solver
          write(iout,'(1X,A)') 'Acceptable options are: '
          write(iout,'(10X,A)') CDEBI
          write(iout,'(10X,A)') CDLSOD
          call camxerr()
      endif
      if( Dry_Deposition ) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(2A)') 'NOTE: This version uses a different ',
     &               'designation for the dry deposition option.'
          write(iout,'(6X,2A)') 'It is now a character ',
     &                         'variable called: Drydep_Model'
          write(iout,'(10X,A)') 'Acceptable options are: '
          write(iout,'(15X,A)') 'NONE'
          write(iout,'(15X,A)') 'WESELY89 - original scheme'
          write(iout,'(15X,A)') 'ZHANG03  - new scheme'
          write(iout,'(//)')
          call camxerr()
      endif
      call jstlft( Drydep_Model )
      call toupper( Drydep_Model )
      nlu = NLUZ03
      if( Drydep_Model .EQ. 'ZHANG03   ') then
          idrydep = 2
          ldry = .true.
      else if( Drydep_Model .EQ. 'WESELY89  ') then
          idrydep = 1
          ldry = .true.
          nlu = NLUW89
      else if( Drydep_Model .EQ. 'NONE      ' ) then
          idrydep = 0
          ldry = .false.
      else
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(2A)') 'NOTE: This version uses a different ',
     &               'designation for the dry deposition option.'
          write(iout,'(6X,2A)') 'It is now a character ',
     &                         'variable called: Drydep_Model'
          write(iout,'(/,1X,6A)') 'Invalid dry deposition option ',
     &                            'specified in control file: ',
     &                            Drydep_Model
          write(iout,'(1X,A)') 'Acceptable options are: '
          write(iout,'(10X,A)') 'NONE'
          write(iout,'(10X,A)') 'ZHANG03'
          write(iout,'(10X,A)') 'WESELY89'
          call camxerr()
      endif
c
      call jstlft( PiG_Submodel )
      call toupper( PiG_Submodel )
      ipigflg = 0
      if (PiG_Submodel .NE. 'NONE     ' .AND. PiG_Submodel .NE. '' .AND. PiG_Submodel .NE. ' ' ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(A)') 'This version does not support Plume-in-Grid treatment (PiG).'
        write(iout,'(32A)') 'Your CAMx control file sets the namelist ',
     &               'variable PiG_Submodel to: ',TRIM(PiG_Submodel)
        write(iout,'(2A)') 'Please remove this line from your CAMx.in file.'
        call camxerr()
      endif
c
c======================== Probing Tool Begin ===========================
c
      call jstlft( Probing_Tool )
      call toupper( Probing_Tool )
      if( Probing_Tool .NE. 'NONE      ' .AND.
     &    Probing_Tool .NE. SA     .AND.
     &    Probing_Tool .NE. RTRAC  .AND.
     &    Probing_Tool .NE. RTCMC  .AND.
     &    Probing_Tool .NE. DDM    .AND.
     &    Probing_Tool .NE. HDDM   .AND.
     &    Probing_Tool .NE. STRPA  .AND.
     &    Probing_Tool .NE. STRIPR .AND.
     &    Probing_Tool .NE. STRIRR .AND.
     &    Probing_Tool .NE. CSA) then
          write(iout,'(//,A)') 'ERROR in READNML:'
          write(iout,'(/,1X,6A)') 'Invalid technology type ',
     &             'specified in control file: ',Probing_Tool
          write(iout,'(1X,A)') 'Acceptable options are: '
          write(iout,'(10X,A)')'NONE'
          write(iout,'(10X,A)') SA
          write(iout,'(10X,A)') RTRAC
          write(iout,'(10X,A)') RTCMC
          write(iout,'(10X,A)') DDM
          write(iout,'(10X,A)') HDDM
          write(iout,'(10X,A)') STRPA
          write(iout,'(10X,A)') STRIPR
          write(iout,'(10X,A)') STRIRR
          write(iout,'(10X,A)') CSA
          call camxerr()
       endif
cbk       if( iadvct .ne. 2 .AND. Probing_Tool .EQ. DDM ) then
cbk          write(iout,'(//,a)') 'ERROR in READNML:'
cbk          write(iout,'(2a)') 'Advection solver used with DDM ',
cbk     &                                          'must be BOTT.'
cbk          write(iout,*)'Change the control file and try again.'
cbk          call camxerr()
cbk       endif
       if( idsolv .NE. IDEBI .AND. Probing_Tool .EQ. DDM ) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(2a)') 'Chemistry solver used with DDM ',
     &                                           'must be EBI.'
          write(iout,*)'Change the control file and try again.'
          call camxerr()
       endif
       if( ACM2_Diffusion .AND. ( Probing_Tool .EQ. STRIPR .OR.
     &                            Probing_Tool .EQ. STRPA )) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(a)') 'PA/IPR does not work with ACM2 diffusion.'
          write(iout,*)'Change the control file and try again.'
          call camxerr()
       endif
       if( Subgrid_Convection .AND. Probing_Tool .NE. 'NONE') then
          write(iout,'(2a)') 'Probing Tools do not work with the',
     &                       ' subgrid convection option.'
          write(iout,*)'Change the control file and try again.'
          call camxerr()
       endif
       if( Subgrid_Convection .AND. Flexi_Nest) then
          write(iout,'(2a)') 'Flexi-nesting is not allowed with the',
     &                       ' subgrid convection option.'
          write(iout,*)'Change the control file and try again.'
          call camxerr()
       endif
       if( Strat_Ozone_Profile .AND. Probing_Tool .NE. 'NONE' .AND.
     &                               Probing_Tool .NE. SA) then
          write(iout,'(2a)') 'The stratospheric ozone profile scheme',
     &                       ' only works with the SA Probing Tool.'
          write(iout,*)'Change the control file and try again.'
          call camxerr()
       endif
c
c======================== Probing Tool End =============================
c 
      lflexi = Flexi_Nest
      ldiag  = Diagnostic_Error_Check
      lrstrt = Restart
      lchem  = Chemistry
      lwet   = Wet_Deposition
      lacm2  = ACM2_Diffusion
      le1day = Ignore_Emission_Dates
      larsrc = Gridded_Emissions
      lptsrc = Point_Emissions
      lsuper = Super_Stepping
      lsrfmod = .FALSE.
      lbidinh3 = Bidi_NH3_Drydep
      lstrato3 = Strat_Ozone_Profile
      do i = 1,ngrid
        lcig(i) = Subgrid_Convection
      enddo
      lixemis   = .false.
      lixbypass = .false.
      call jstlft( Inline_Ix_Emissions )
      call toupper( Inline_Ix_Emissions )
      if (Inline_Ix_Emissions .EQ. 'TRUE      ') then
        lixemis = .true.
      elseif (Inline_Ix_Emissions .EQ. 'FALSE     ') then
        lixemis = .false.
      elseif (Inline_Ix_Emissions .EQ. 'BYPASS    ') then
        lixbypass = .true.
      else
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(3A)') 'Incorrect Ix emission option specified in ',
     &                             'control file: ',Inline_Ix_Emissions
        write(iout,'(1X,A)')'Acceptable options are: '
        write(iout,'(10X,A)') 'TRUE'
        write(iout,'(10X,A)') 'FALSE'
        write(iout,'(10X,A)') 'BYPASS'
        call camxerr()
      endif
c
c-----Output options and species
c
      do i=1,ngrid
         l3davg(i) = Average_Output_3D
         if( Output_3D_Grid(i) ) l3davg(i) = .TRUE.
      enddo
c
c  --- this variable is obsolete ---
c
      lcdfout = .TRUE.
      if( .NOT. NetCDF_Format_Output ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(A)') 'This version only supports NetCDF output files.'
        write(iout,'(2A)') 'Your CAMx control file sets the namelist ',
     &               'variable NetCDF_Format_Output to true.'
        write(iout,'(2A)') 'Please remove this line from your CAMx.in file and ',
     &                   'make sure to build NetCDF'
        write(iout,'(A)') 'into the CAMx executable.'
        call camxerr()
      endif
c
      ncf_compress = NetCDF_Use_Compression
      call ncf_set_compress_flag()
      lgas_out_ppm = Output_Gas_Concs_PPM
c
c-----Call routine to  set the NetCDF cache parameters ---
c
      if( lcdfout .AND. ncf_compress ) call ncf_set_cache()
c
      do n = MXNAM,1,-1
        if (Output_Species_Names(n).ne.' ') then
          navspc = n
          call alloc_chmstry_avg(navspc)
          do l = 1,navspc
            if (Output_Species_Names(n).eq.' ') then
              write(iout,'(//,a)') 'ERROR in READNML:'
              write(iout,'(a)')'An output species name is blank'
              write(iout,'(a,i5)')'at species number: ',l
              call camxerr()
            endif 
            spavg(l) = Output_Species_Names(l)
            if ((spavg(l).eq.'ALL' .or. spavg(l).eq.'ALLR') .and.
     &           navspc.ne.1) then
              write(iout,'(//,a)') 'ERROR in READNML:'
              write(iout,'(3a)')'If using "ALL" or "ALLR" as an',
     &              ' Output_Species_Name it must be the the',
     &              ' only name listed.'
              call camxerr()
            endif
          enddo
          goto 50
        endif
      enddo
      write(iout,'(//,a)') 'ERROR in READNML:'
      write(iout,'(a)')'Number of average species is zero.'
      write(iout,'(a)')'At least 1 species needs to be output.'
      call camxerr()
 50   continue
c
c-----PiG sampling grids
c
      lsample = .FALSE.
      lbckgrd = .FALSE.
      nsample = 0
c
c-----Echo run control parameters
c
      write(idiag,'(A,F10.0,I10.6,I10.5)')
     &         'Simulation start time/date : ',begtim,cbdate,begdate
      write(idiag,'(A,F10.0,I10.6,I10.5)')
     &         'Simulation end time/date   : ',endtim,cedate,enddate
      write(idiag,'(A,I10)')
     &         'Time zone                  : ',itzon
      write(idiag,'(A,F10.0)')
     &         'Max timestep (min)         : ',dtmax
      write(idiag,'(A,F10.0)')
     &         'Met Input interval (min)   : ',dtinp
      write(idiag,'(A,F10.0)')
     &         'Emiss Input interval (min) : ',dtems
      write(idiag,'(A,F10.0)')
     &         'Output interval (min)      : ',dtout
      write(idiag,'(A,A)')
     &         'Grid Projection Type       : ',Map_Projection
      if (lutm) then
        write(idiag,'(A,I10)')
     &         'UTM: zone number           : ',iuzon
      elseif (lrpolar) then
        write(idiag,'(A,2F10.3)')
     &         'RPOLAR: pole lon/lat        : ',polelon,polelat
      elseif (lambrt) then
        write(idiag,'(A,4F10.3)')
     &         'LAMBERT: pole lon/lat      : ',polelon,polelat
        write(idiag,'(A,4F10.3)')
     &         'LAMBERT: true latitudes    : ',tlat1,tlat2
      elseif (lpolar) then
        write(idiag,'(A,4F10.3)')
     &         'POLAR: pole lon/lat        : ',polelon,polelat
        write(idiag,'(A,4F10.3)')
     &         'POLAR: true latitude       : ',tlat1
      elseif (lmerc) then
        write(idiag,'(A,4F10.3)')
     &         'MERCATOR: pole lon/lat     : ',polelon,polelat
        write(idiag,'(A,4F10.3)')
     &         'MERCATOR: true latitude    : ',tlat1
      endif
      write(idiag,'(A,4F10.3)')
     &         'Master Grid SW Corner X/Y  : ',xorg,yorg
      write(idiag,'(A,4F10.3)')
     &         'Master Grid cell size      : ',delx,dely
      write(idiag,'(A,3I10)')
     &         'Master Grid NCOL NROW NLAY : ',ncol(1),nrow(1),nlay(1)
      write(idiag,*)
      write(idiag,'(A)')'CAMx control flags'
      write(idiag,'(A,L10)') 
     &         'Stop after diagnostic check: ',ldiag
      write(idiag,'(A,A)')
     &         'Horizontal Advection Solver: ',Advection_Solver
      write(idiag,'(A,A)')
     &         'Vertical Advection Solver  : ',Vadvection_Solver
      write(idiag,'(A,A)')
     &         'Chemistry Solver           : ',Chemistry_Solver
      write(idiag,'(A,A)')
     &         'Dry Deposition             : ',Drydep_Model
      write(idiag,'(A,A)')
     &         'Probing Tools              : ',Probing_Tool
      write(idiag,'(A,L10)') 
     &         'Flexi-Nest                 : ',lflexi 
      write(idiag,'(A,L10)') 
     &         'Restart                    : ',lrstrt 
      write(idiag,'(A,L10)') 
     &         'Chemistry                  : ',lchem
      write(idiag,'(A,L10)') 
     &         'Dry deposition             : ',ldry 
      write(idiag,'(A,L10)') 
     &         'Wet deposition             : ',lwet 
      write(idiag,'(A,L10)')
     &         'ACM2 Vertical Diffusion    : ',lacm2
      write(idiag,'(A,L10)') 
     &         'Super stepping advection   : ',lsuper
      write(idiag,'(A,L10)') 
     &         'Surface Model              : ',lsrfmod
      write(idiag,'(A,L10)') 
     &         'Subgrid Convection         : ',Subgrid_Convection
      write(idiag,'(A,L10)') 
     &         'Inline Ix Emissions        : ',lixemis
      write(idiag,'(A,L10)') 
     &         'Bypass Ix Emissions        : ',lixbypass
      write(idiag,'(A,L10)') 
     &         'Bidi NH3 Drydep            : ',lbidinh3
      write(idiag,'(A,L10)') 
     &         'Strat Ozone Profile        : ',lstrato3
      write(idiag,'(A,L10)') 
     &         'Area sources               : ',larsrc
      write(idiag,'(A,L10)') 
     &         'Point sources              : ',lptsrc
      write(idiag,'(A,L10)') 
     &         'Date-insensitive emissions : ',le1day
      do i=1,ngrid
         write(idiag,'(A,I3,L10)') 
     &         '3-D average file - Grid #  : ',i,l3davg(i)
      enddo
c
      if( nnest .GT. 0 ) then
        write(idiag,'(A,I3)')'Number of nested fine grids: ',nnest
        write(idiag,*)' Nest        x-range       ncol        y-range',
     &                '       nrow   mesh factor  nlay'      
        do n = 2,ngrid
          write(idiag,'(I5,2(5X,I5,1X,I5,5X,I5),5X,I5,5X,I5)')
     &          n,inst1(n),inst2(n),ncol(n),jnst1(n),jnst2(n),
     &          nrow(n),meshold(n),nlay(n)
        enddo
        write(idiag,*)
        write(idiag,*) '|',('-',i=1,74),'|'
        write(idiag,*) '|',(' ',i=1,74),'|'
        write(idiag,'(2A)') ' | NOTE:  The nest order listed above ',
     &       'is the original order specified in    |'
        write(idiag,'(2A)') ' |        the CAMx.in file.           ',
     &       '                                      |'
        write(idiag,'(2A)') ' |        CAMx may re-order the nests.',
     &      ' See the internal nest order provided |'
        write(idiag,'(2A)') ' |        in the table below.         ',
     &       '                                      |'
        write(idiag,*) '|',(' ',i=1,74),'|'
        write(idiag,*) '|',('-',i=1,74),'|'
      else
        write(idiag,*)'Fine grid nests are not specified.'
      endif
      write(idiag,*)
c
c-----Open the remaining I/O files
c
      call openfils(iifroot,nopen)
c
c-----Read chemistry parameters
c
      time = begtim
      date = begdate
      call readchm()
c
c-----Check number of average output species
c
      if( navspc .GT. nspec ) then
        write(iout,'(//,A)') 'ERROR in READNML:'
        write(iout,*) 'Number of average species to be output ',
     &               'is greater than number of species to model'
        write(iout,*) 'Average species (NAVSPC): ',navspc
        write(iout,*) 'Model species (NSPEC)   : ',nspec
        call camxerr()
      endif
c
c-----Map average species to model species
c
      write(idiag,*)
      ndepspc = 0
      if (spavg(1).eq.'ALL') then
        navspc = nspec - nrad
        lav = 0
        do l = nrad+1,nspec
          lav = lav + 1
          lavmap(lav) = l
          ndepspc = ndepspc + 1
          ldepmap(ndepspc) = l
          write(idiag,'(2(A,I5,2X,A))')
     &                   'Average species ',lav,spname(l),
     &                   ' mapped to modeled species ',l,spname(l)
        enddo
      elseif (spavg(1).eq.'ALLR') then
        navspc = nspec
        lav = 0
        do l = 1,nspec
          lav = lav + 1
          lavmap(lav) = l
          ndepspc = ndepspc + 1
          ldepmap(ndepspc) = l
          write(idiag,'(2(A,I5,2X,A))')
     &                   'Average species ',lav,spname(l),
     &                   ' mapped to modeled species ',l,spname(l)
        enddo
      else
        do lav = 1,navspc
          lavmap(lav) = 0
          do l = 1,nspec
            if( spavg(lav) .EQ. spname(l) ) then
              lavmap(lav) = l
              ndepspc = ndepspc + 1
              ldepmap(ndepspc) = l
              write(idiag,'(2(A,I5,2X,A))')
     &                   'Average species ',lav,spavg(lav),
     &                   ' mapped to modeled species ',l,spname(l)
            endif
          enddo
          if( lavmap(lav) .EQ. 0 ) then
            write(iout,'(//,a)') 'ERROR in STARTUP:'
            write(iout,*) 'Did not find average species: ',
     &            spavg(lav)(:istrln(spavg(lav))),' in chemparam list.'
            write(iout,*)'Either remove this name from the ',
     &                                    'average species list in your'
            write(iout,*)'CAMx control file, or use the appropriate ',
     &                                               'chemparam file.'
            call camxerr()
          endif
        enddo
      endif
      write(idiag,*)
c
c  --- read Probing Tool namelists ---
c
c   --- allocate the arrays for PiG --
c
      if( ipigflg .NE. 0 .AND. .NOT. lrstrt )
     &    call alloc_pigsty(nspec,nreactr,ngrid,
     &                                  MAX(1,numprocs-1),ipigflg)
      if( ipigflg .NE. 0 ) 
     &         call alloc_pigsty_vpconc(ncol,nrow,nlay,nspec,ngrid)
c
c  --- setup some pointers that depend on number of species ---
c
      if( lsample ) then
        ipsmp(1) = 1
        do i = 2,nsample
          ipsmp(i) = ipsmp(i-1) + ncolsmp(i-1)*nrowsmp(i-1)*navspc
        enddo
c
c   --- allocate the arrays for sampling that depend on species ---
c
         call alloc_pigsty_smpgrd(navspc,nsample,
     &                                    nrowsmp,ncolsmp,nsmpcels)
      endif
c
c======================== Probing Tool Begin ===========================
c
c  --- set Probing Tool switches according to technology type ---
c
      call alloc_lddmcalc(ngrid)
      ltrace = .FALSE.
      lddm   = .FALSE.
      lhddm  = .FALSE.
      lproca = .FALSE.
      lipr   = .FALSE.
      lirr   = .FALSE.
      lcsa   = .FALSE.
      lpartial = .FALSE.
      lptdepout = .FALSE.
      lsfcfl = .FALSE.
      tectyp = Probing_Tool
      lmech1_ok = .FALSE.
      lmech2_ok = .FALSE.
      lmech3_ok = .FALSE.
      lmech4_ok = .FALSE.
      lmech5_ok = .FALSE.
      lmech6_ok = .FALSE.
      lmech7_ok = .FALSE.
      lmech8_ok = .FALSE.
      lmech9_ok = .FALSE.
      lmech10_ok = .FALSE.
      if( tectyp .EQ. 'NONE      '  ) then
c
c---- call routines to allocate the arrays that need a pointer ---
c
         call alloc_tracer_null(nspec,lirr,ngrid,ncol,nrow)
         call alloc_procan_null()
         goto 8888
      elseif( tectyp .EQ. SA    ) then
         ltrace = .true.
         lsfcfl = .TRUE.
         verson = VERSA
         call alloc_procan_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         if (lvbs) goto 7009
         lmineral = .FALSE.
         ldmschm = .FALSE.
         if (kpfe.lt.nspec+1 .and. kpmn.lt.nspec+1 .and.
     &       kpmg.lt.nspec+1 .and. kpk.lt.nspec+1 .and.
     &       kpca.lt.nspec+1 .and. kpal.lt.nspec+1 .and.
     &       kpsi.lt.nspec+1 .and. kpti.lt.nspec+1) lmineral = .TRUE.
         if (kdms.lt.nspec+1) ldmschm = .TRUE.
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. RTRAC ) then
         ltrace = .true.
         lsfcfl = .TRUE.
         verson = VERRTRAC
         call alloc_procan_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. RTCMC ) then
         ltrace = .true.
         lsfcfl = .TRUE.
         verson = VERRTCMC
         call alloc_procan_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. DDM  ) then
         lddm = .TRUE.
         lsfcfl = .TRUE.
         verson = VERDDM
         call alloc_procan_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         if (lvbs) goto 7009
      elseif( tectyp .EQ. HDDM  ) then
         lhddm = .TRUE.
         lsfcfl = .TRUE.
         verson = VERHDDM
         call alloc_procan_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         if (lvbs) goto 7009
      elseif( tectyp .EQ. STRPA ) then
         lproca = .TRUE.
         lipr = .TRUE.
         lirr = .TRUE.
         lsfcfl = .TRUE.
         verson = VERPA
         call alloc_procan_init(ngrid,MXCPA)
         call alloc_ptwet_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         if (lvbs) goto 7009
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. STRIPR ) then
         lproca = .TRUE.
         lipr = .TRUE.
         verson = VERPA
         call alloc_tracer_null(nspec,lirr,ngrid,ncol,nrow)
         call alloc_procan_init(ngrid,MXCPA)
         call alloc_ptwet_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         lmech10_ok = .TRUE.
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. STRIRR ) then
         lproca = .TRUE.
         lirr = .TRUE.
         lsfcfl = .TRUE.
         verson = VERPA
         call alloc_procan_init(ngrid,MXCPA)
         call alloc_ptwet_null()
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
         if (lvbs) goto 7009
         lddmcalc = .TRUE.
      elseif( tectyp .EQ. CSA    ) then
         lcsa = .TRUE.
         lsfcfl = .TRUE.
         verson = VERCSA
         lmech1_ok = .TRUE.
         lmech3_ok = .TRUE.
         lmech4_ok = .TRUE.
         lmech5_ok = .TRUE.
         lmech7_ok = .TRUE.
         lmech9_ok = .TRUE.
      endif
      if( idmech.EQ.1 .AND. .NOT. lmech1_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 1.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.2 .AND. .NOT. lmech2_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 2.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.3 .AND. .NOT. lmech3_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 3.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.4 .AND. .NOT. lmech4_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 4.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.5 .AND. .NOT. lmech5_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 5.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.7 .AND. .NOT. lmech7_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 7.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.8 .AND. .NOT. lmech8_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 8.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.EQ.9 .AND. .NOT. lmech9_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 9.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
         call camxerr()
      endif
      if( idmech.eq.10 .AND. .NOT. lmech10_ok ) then
         write(iout,'(//,a)') 'ERROR in READNML:'
         write(iout,'(/,2A)') ' You have selected a probing tool that is ',
     &               'currently not supported with Mechanism 10.'
         write(iout,'(/,2A)') ' Turn off probing tools or select ',
     &                                         'another mechanism.'
        call camxerr()
      endif
c
c  --- CSA is not allowed for MPI ---
c
      if( lmpi .AND. lcsa ) then
        write(iout,'(//,a)') 'ERROR in READNML:'
        write(iout,'(/,1X,2A,/,A)') 'CSA is not allowed with MPI. Please',
     &                 ' turn off MPI and use OMP',' parallelization instead.'
        call camxerr()
      endif
c
c  --- Certain PM chemistry and probing tools are not allowed ---
c
      if( (aeropt.EQ.'INERT' .OR. 
     &     lvbs) .AND. tectyp.NE.'NONE      ') then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(/,2A)') ' Probing Tools are ',
     &     'not supported with the INERT or VBS Aerosol Schemes.'
          write(iout,'(2A)')' Either set Probing Tools = NONE or ',
     &                'choose the CF Aerosol Scheme with SOAP chemistry.'
          call camxerr()
      endif
c
c  --- DDM/HDDM is not allowed with EQSAM ---
c
      if( leqsam .AND. (lddm .OR. lhddm) ) then
          write(iout,'(//,a)') 'ERROR in READNML:'
          write(iout,'(/,2A)') ' DDM/HDDM is ',
     &     'not supported with the EQSAM aerosol option.'
          call camxerr()
      endif
c
      if( ltrace ) then
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
            namegrp = 'RT_Control'
            action =  'You must have the '//namegrp(:istrln(namegrp))//
     &          ' namelist group when probing tools is set to '//
     &                                    tectyp(:istrln(tectyp))//'.'
            read(inp,RT_Control,END=7100,ERR=7101)
            flrtsa = RT_File_Root
         else
            namegrp = 'SA_Control'
            action =  'You must have the '//namegrp(:istrln(namegrp))//
     &          ' namelist group when probing tools is set to '//
     &                                    tectyp(:istrln(tectyp))//'.'
            read(inp,SA_Control,END=7100,ERR=7103)
            flrtsa = SA_File_Root
            lptdepout = SA_Deposition_Output
            if( .NOT. ldry .AND. .NOT. lwet ) lptdepout = .FALSE.
         endif 
      elseif( lddm .OR. lhddm ) then
         namegrp = 'DDM_Control'
         action =  'You must have the '//namegrp(:istrln(namegrp))//
     &          ' namelist group when probing tools is set to '//
     &                                    tectyp(:istrln(tectyp))//'.'
         read(inp,DDM_Control,END=7100,ERR=7101)
         flrtsa = DDM_File_Root
      elseif( lproca ) then
         namegrp = 'PA_Control'
         action =  'You must have the '//namegrp(:istrln(namegrp))//
     &          ' namelist group when probing tools is set to '//
     &                                    tectyp(:istrln(tectyp))//'.'
         read(inp,PA_Control,END=7100,ERR=7101)
         flrtsa = PA_File_Root
      else if( lcsa ) then
            namegrp = 'CSA_Control'
            action =  'You must have the '//namegrp(:istrln(namegrp))//
     &          ' namelist group when probing tools is set to '//
     &                                    tectyp(:istrln(tectyp))//'.'
            read(inp,CSA_Control,END=7100,ERR=7101)
            flrtsa = CSA_File_Root
      endif
c
c======================== Probing Tool End =============================
c 
c
c======================== Source Apportion Begin =======================
c
      if( ltrace ) then
c
c  --- call routines to get the rest of the options ---
c
c
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
            lsrfmodrt = .FALSE.
            lparttn = RT_Partitioning
            if (lsrfmodrt .AND. idrydep .NE. 1) then
              write(iout,*)'The RTRAC Surface Model must be used',
     &                     ' with the WESELY89 deposition'
              write(iout,*)'Stopping'
              call camxerr()
            endif
            if (lsrfmodrt .AND. ipigflg.ne.0) then
              write(iout,*)'The RTRAC Surface Model cannot be used',
     &                     ' with the PiG model'
              write(iout,*)'Stopping'
              call camxerr()
            endif
            if (lparttn .AND. (aeropt.ne.'CF' .or. lvbs)) then
              write(iout,*)'RTRAC gas-aerosol partitioning must',
     &                     ' use the CF/SOAP aerosol scheme'
              write(iout,*)'Stopping'
              call camxerr()
            endif
            write(idiag,*)
            write(idiag,'(A,L10)')
     &                  'RTRAC Surface Model        : ',lsrfmodrt
            write(idiag,'(A,L10)')
     &                  'RTRAC Gas-PM Partitioning  : ',lparttn
c
            if( lsample ) then
               lsmptrc = RT_PiG_Sample
               write(idiag,*)
               write(idiag,'(A,L10)')
     &                  'Sample grid includes RTRAC : ',lsmptrc
               if( lsmptrc ) then
c
c  --- call routine to allocate the variables for RTRAC sampling ---
c
                  call alloc_tracer_sample_io(nsample,0)
                  iprtsmp(1) = 1
                  do i=2,nsample
                    iprtsmp(i) = iprtsmp(i-1) +
     &                           ncolsmp(i-1)*nrowsmp(i-1)*ntotsp
                  enddo
               endif
            endif
            write(idiag,*)
            call startrt(iout,nopen)
         else
            call rdoptsa()
            lptoverride = SA_PT_Override
            nemiss = ngroup
            if( leftovr_area ) nemiss = ngroup + 1
            write(idiag,'(A,L10)') 
     &           'Output Deposition Fields            : ',lptdepout
            write(idiag,'(A,L10)') 
     &           'Stratify Boundary                   : ',lbndry
            write(idiag,'(A,I10)') 
     &           'Number of source areas              : ',nregin
            write(idiag,'(A,I10)') 
     &           'Number of source groups             : ',nemiss
            write(idiag,'(A,L10)') 
     &           'Leftover group for griddded sources : ',leftovr_area
            write(idiag,'(A,I10)') 
     &           'Number of time releases             : ',ntrtim
            write(idiag,'(A,L10)')
     &           'Using Partial Source Area map       : ',lpartial
            write(idiag,*)
            call startsa(iout,nopen)
         endif
      endif
c
c======================== Source Apportion End =========================
c
c
c======================== DDM Begin ====================================
c
      if( lddm .OR. lhddm ) then
         call alloc_ddm_species(nspec)
         call rdoptddm()
         lptoverride = DDM_PT_Override
         write(idiag,'(A,I10)') 
     &            'Number of IC groups                 : ',nicddm
         if( nicddm .GT. 0 ) then
            do i = 1,nicddm
              write(idiag,'(24X,i3,'': '',A)') i,icddmsp(i)
            enddo
         else
            write(idiag,'(29X,A)') 'No IC species modeled.'
         endif
         write(idiag,'(A,I10)') 
     &            'Number of BC groups                 : ',nbcddm
         if( nbcddm .GT. 0 ) then
            do i = 1,nbcddm
              write(idiag,'(24X,i3,'': '',A)') i,bcddmsp(i)
            enddo
         else
            write(idiag,'(29X,A)') 'No BC species modeled.'
         endif
         write(idiag,'(A,I10)') 'Number of Deposition groups: ',ndepddm
         if( ndepddm .GT. 0 ) then
            do i = 1,ndepddm
              write(idiag,'(24X,i3,'': '',A)') i,depddmsp(i)
            enddo
         else
            write(idiag,'(29X,A)') 'No Depostion species modeled.'
         endif
         write(idiag,'(A,I10)') 
     &             'Number of EM groups                : ',nemddm
         if( nemddm .GT. 0 ) then
            lixemspc = .FALSE.
            do i = 1,nemddm
              write(idiag,'(24X,i3,'': '',A)') i,emddmsp(i)
              if ( emddmsp(i) .EQ. 'I2        ' .OR.
     &             emddmsp(i) .EQ. 'HOI       ' ) lixemspc = .TRUE.
            enddo
            if ( lixemis ) then
              write(idiag,'(2A)') 'WARNING: In-line Ix emissions are',
     &                            ' invoked, but DDM currently does'
              write(idiag,'(2A)') '      not account for sensitivities',
     &                            ' to the in-line emissions.'
              if ( lixemspc ) then
                write(iout,'(//,A)') 'ERROR in READNML:'
                write(iout,'(2A)') 'In-line Ix emissions are invoked,',
     &                            ' but DDM currently does not support'
                write(iout,'(2A)') 'in-line emissions. You need to',
     &                          ' either turn off in-line Ix emissions'
                write(iout,'(2A)') 'or remove I2 and HOI from the DDM',
     &                             ' emission species group list.'
                call camxerr()
              endif
            endif
         else
            write(idiag,'(29X,A)') 'No emission species modeled.'
         endif
         write(idiag,'(A,I10)') 
     &             'Number of rate const groups        : ',nrateddm
         if( nrateddm .GT. 0 ) then
            if( lddm ) then
              write(iout,'(//,a)') 'ERROR in READNML:'
              write(iout,'(2a)') 'Rate constant sensitivity cannot ',
     &                                           'be used with DDM.'
              call camxerr()
            endif
            do i = 1,nrateddm
              write(idiag,'(24X,i3,'': '',A)') i,rateddm(i)
              write(idiag,'(29X,99I4)') (iprate(n,i),n=1,iprate(0,i))
            enddo
         else
            write(idiag,'(29X,A)') 'No rate constant sens modeled.'
         endif
         write(idiag,'(A,I10)') 'Number of rate term groups : ',ntermddm
         if( ntermddm .GT. 0 ) then
            if( lddm ) then
              write(iout,'(//,a)') 'ERROR in READNML:'
              write(iout,'(2a)') 'Rate term sensitivity cannot ',
     &                                           'be used with DDM.'
              call camxerr()
            endif
            do i = 1,ntermddm
              write(idiag,'(24X,i3,'': '',A)') i,termddm(i)
              do n = 1, nreact
                if (ipterm(0,n,i).eq.1) then
                  write(idiag,'(29X,A,I4)') 'Rxn:',n
                  do l = 1, ipterm(1,n,i)
                    write(idiag,'(29X,2A,$)') '   [R]: ',
     &                    spname(ipterm(1+l,n,i))
                    if (wfterm(1+l,n,i).eq.1.0) then
                      write(idiag,*)
                    else
                      write(idiag,*) wfterm(1+l,n,i)
                    endif
                  enddo
                  do l = 1, ipterm(2+ipterm(1,n,i),n,i)
                  write(idiag,'(29X,2A)') '   [P]: ',
     &                    spname(ipterm(2+ipterm(1,n,i)+l,n,i))
                  enddo
                endif
              enddo
            enddo
         else
            write(idiag,'(29X,A)') 'No rate term sens modeled.'
         endif
         write(idiag,'(A,I10)') 
     &             'Number of HDDM sens groups         : ',nhddm
         if( nhddm .GT. 0 ) then
            do i = 1,nhddm
              write(idiag,'(24X,i3,'': '',A,'', '',A)') i,hddmsp(1,i),
     &                                                    hddmsp(2,i)
            enddo
         else
            write(idiag,'(29X,A)') 'No HDDM sensitivity modeled.'
         endif
         write(idiag,'(2A)') 'DDM turn-off flags are shown below ',
     &                       'after the nested-grid maps.'
         write(idiag,*)
         call startddm(iout,nopen)
      endif
c
c========================= DDM End =====================================
c
c
c======================== Process Analysis Begin =======================
c
c   --- echo the irmb specific flags ---
c
      if( lproca ) then
         call rdoptpa
         write(idiag,'(A,L10)') 'Integrated Process Rates   : ',lipr
         write(idiag,'(A,L10)') 'Integrated Reaction Rates  : ',lirr
         write(idiag,*)
      endif
c
      if( lipr ) then
         jj = istrln(flrtsa)
         call getunit(ipr_unit)
         filtmp = flrtsa
         filtmp(jj+1:) = '.ipr'
         nopen = nopen + 1
         open(unit=ipr_unit,file=filtmp(1:jj+4),form='UNFORMATTED',
     &                                  status= 'UNKNOWN',ERR=7000)
         write(iout,9000)
     &   'Cell Specific Process output         (unit):',ipr_unit
         write(iout,9002) filtmp(1:jj+4)
      endif
c
      if( lirr ) then
         jj = istrln(flrtsa)
         call getunit(irr_unit)
         filtmp = flrtsa
         filtmp(jj+1:) = '.irr'
         nopen = nopen + 1
         open(unit=irr_unit,file=filtmp(1:jj+4),form='UNFORMATTED',
     &                                  status= 'UNKNOWN',ERR=7000)
         write(iout,9000)
     &   'Cell Specific Rates output           (unit):',irr_unit
         write(iout,9002) filtmp(1:jj+4)
c
         if( lsfcfl ) then
            do n = 1,ngrid
               filtmp = flrtsa
               if( .NOT. lcdfout ) then
                  write(filtmp(jj+1:),'(a,i2.2)') '.cpa.grd',n
                  sfcfil(n) = filtmp
                  nopen = nopen + 1
                  call getunit(iowsfc(n))
                  open(unit=iowsfc(n),file=sfcfil(n),
     &                  form='UNFORMATTED',status= 'UNKNOWN',ERR=7000)
                  write(iout,9000)
     &                  'Gridded CPA file                     (unit):',
     &                                                     iowsfc(n)
                  write(iout,9002) filtmp(1:jj+10)
               else
                  write(filtmp(jj+1:),'(a,i2.2,a)') '.cpa.grd',n,'.nc'
                  sfcfil(n) = filtmp
                  nopen = nopen + 1
                  action = 'Opening output CPA file'
                  call ncf_createfile(filtmp,action,iowsfc(n))
                  write(iout,9000) 'Gridded CPA file:'
                  write(iout,9002) filtmp(1:jj+13)
               endif
            enddo
         endif
      endif
c
c========================= Process Analysis End ========================
c
c
c======================== CSA Begin =========================
c
      if( lcsa ) then
         call rdoptcsa
c
         do icsa_grid=1,npadom
            jj = istrln(flrtsa)
            filtmp = flrtsa
            write(filtmp(jj+1:),'(a,i2.2,a)') '.csa.grd',icsa_grid,'.nc'
            csa_outfile(icsa_grid) = filtmp
            nopen = nopen + 1
            write(action,'(A,I3)') 'Opening output file for CSA grid: ',icsa_grid
            call ncf_createfile(filtmp,action,iow_csa(icsa_grid))
            write(iout,9000) 'Gridded output file for CSA domain: ',icsa_grid
            write(iout,9002) filtmp(1:jj+13)
         enddo
c
c  --- allocate arrays for pointers ---
c
         call alloc_ddm_species(nspec)
      endif
c
c======================== CSA End =========================
c
c-----Everything worked correctly, return to calling routine
c
 8888 continue
      if( .NOT. ltrace .AND. lptsrc .AND.  npoint_files .LE. 0 ) goto 7104
      if( larsrc .AND. .NOT. is_any_grid_emiss ) goto 7105
      write(iout,*)
      write(iout,*)'Finished reading control file.'
      write(iout,'(A,I3)')'Number of input files opened: ',nopen
      write(iout,*)
      write(iout,*)
      if( ntrtim .GT. 0 ) then
        write(iout,*) '   ---------------------------------------------'
        write(iout,*) '   |                                           |'
        write(iout,*) '   |    NOTE:                                  |'
        write(iout,*) '   |    You have chosen to include timing      |'
        write(iout,*) '   |    tracers. Be aware that this will       |'
        write(iout,*) '   |    add a significant amount of memory     |'
        write(iout,*) '   |    to your application. The memory        |'
        write(iout,*) '   |    requirements may exceed available      |'
        write(iout,*) '   |    resources.                             |'
        write(iout,*) '   |                                           |'
        write(iout,*) '   ---------------------------------------------'
        write(iout,*)
      endif
      call flush(iout)
      call flush(idiag)
      return
c
 9000 format(/,A,I6)
 9002 format(2A)
c
c-----Error messages
c
 7000 continue
      write(*,'(//,A)') 'ERROR in READNML:'
      write(*,'(A)') action(:istrln(action))
      write(*,'(2A,//)') ' Could not open file: ',
     &                                 filtmp(:istrln(filtmp))
      call exit(1)
      stop
c
 7005 continue
      write(*,'(//,A)') 'ERROR in READNML:'
      write(*,'(2A,//)') ' Could not open control file: ',
     &                                   ctlfil(:istrln(ctlfil))
      call exit(1)
      stop
c
 7006 continue
      write(*,'(//,A)') 'ERROR in READNML:'
      write(*,'(A)') ' Root output file name is blank.'
      write(*,'(A)') ' A valid path/filename must be provided in '
      write(*,'(A,//)') ' the namelist variable: Root_Output_Name'
      call exit(1)
      stop
c
 7007 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A,//)') ' Cannot find control file: ',
     &                     ctlfil(:istrln(ctlfil))
      call exit(1)
      stop
c
 7009 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' VBS organic aerosol chemistry treatment cannot',
     &                ' be used with the chosen Probing Tool'
      write(*,'(A)') 'Set Probing_Tool = .FALSE.'
      call exit(1)
      stop
c
 7100 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' Cannot find namelist group: ',
     &                                  namegrp(:istrln(namegrp))
      write(*,'(1X,A)') action(:istrln(action))
      write(*,'(3A)') ' Please make sure the CAMx control file has ',
     &        'a section beginning with &',namegrp(:istrln(namegrp))
      write(*,'(A,//)') ' and terminated with a & character.'
      call exit(1)
      stop
c
 7101 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' Error reading the namelist group: ',
     &                                  namegrp(:istrln(namegrp))
      if( lddm .OR. lhddm ) then
         write(*,'(2A,/,2A,/)') ' This version allows for multiple gridded ',
     &                'emissions files.',' The namelist variable should ',
     &                'look like:  DDM_Emiss_Group_Grid(1,3,1)'
      endif
      write(*,'(2A)') ' It is probably a problem with ',
     &                         'syntax.  Please see the user''s'
      write(*,'(2A)') ' guide for examples ',
     &                'of possible problems with namelist syntax.'
      write(*,'(A,//)') ' Then review your namelist carefully.'
      call exit(1)
      stop
c
 7102 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' Error reading the namelist group: ',
     &                                  namegrp(:istrln(namegrp))
      write(*,'(2A)') ' It is probably a problem with ',
     &                         'syntax.  Please see the users'
      write(*,'(2A)') ' guide for examples ',
     &                'of possible problems with namelist syntax.'
      write(*,'(A,/)') ' Then review your namelist carefully.'
      write(*,'(2A)') ' Be aware that in this version some of the',
     &                ' namelist variables have changed.'
      write(*,'(/,2A,/,2A)') ' This version allows for multiple ',
     &                'emissions files.',' The namelist variables should ',
     &                'look like: '
      write(*,'(10x,A)') 'Emiss_Grid(1,1)'
      write(*,'(10x,A)') 'Point_Sources(1)'
      write(*,'(/,2A,/,2A)') ' The Inline_Ix_Emissions name list variable has changed.',
     &                ' It is now a text variable',' instead of a logical variable.',
     &                ' These settings will NOT work.'
      write(*,'(10X,A)') '.true.'
      write(*,'(10X,A)') '.false.'
      write(*,'(1X,A)')'Acceptable options are now.'
      write(*,'(10X,A)') "'TRUE'"
      write(*,'(10X,A)') "'FALSE'"
      write(*,'(10X,A)') "'BYPASS'"
      write(*,'(/,A,/,A,//)') 
     &  ' Please refer to the Release Notes and the template included ',
     &                               ' in the source code distribution.'
      call exit(1)
      stop
c
 7103 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' Error reading the namelist group: ',
     &                                  namegrp(:istrln(namegrp))
      write(*,'(2A)') ' It is probably a problem with ',
     &                         'syntax.  Please see the user''s'
      write(*,'(2A)') ' guide for examples ',
     &                'of possible problems with namelist syntax.'
      write(*,'(A,//)') ' Then review your namelist carefully.'
      write(*,'(1X,2A)') 'With this version the SA_Control namelist ',
     &                   'variables have changed'
      write(*,'(/,2A,/,2A)') ' This version allows for multiple ',
     &                'emissions files.',' The namelist variables should ',
     &                'look like: '
      write(*,'(10x,A)') 'SA_Emiss_Group_Grid(1,1,1)'
      write(*,'(10x,A)') 'SA_Points_Group(4,1)'
      write(*,'(1X,2A)') "See the User's Guide or the namelist template ",
     &           'for details.'
      call exit(1)
      stop
c
 7104 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' No point source files provided.'
      write(*,'(2A,//)') ' You requested point source emissions treatment ',
     &            'but did not supply any point source files.'
      call exit(1)
c
 7105 continue
      write(*,'(//,a)') 'ERROR in READNML:'
      write(*,'(2A)') ' No gridded emissions files provided.'
      write(*,'(2A,//)') ' You requested gridded emissions treatment ',
     &            'but did not supply any gridded emissions files.'
      call exit(1)
c
c-----Return point
c
      end

c**** RDCHMRT
c
      subroutine rdchmrt(version)
      use filunit
      use grid
      use ptemiss
      use chmstry
      use pigsty
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c      This routine reads the chemical parameters file for RTRAC 
c      technology of the source apportionment algorithm.  
c
c      Copyright Ramboll
c
c       Argument description:
c          Input:
c        version      C      model version character string
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/16/02   --gwilson--    Original development
c     11/12/03   --cemery--     Added secondary RTRAC species to primary
c                               RTRAC species
c     10/29/09   --cemery--     Added RTRAC surface model parameters
c     11/17/20   --cemery--     RTCMC dry/wet deposition is now
c                               consistent with RTRAC
c     04/05/21   --cemery--     Input reaction rates are molecular units
c     05/12/21   --cemery--     Moved Koa parameter to gas species list
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'rtracsrf.inc'
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      character*20 version
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer mvecedge
      real    rkoh, rko3, rkno3, adj
      character*200 line
      character*80  action
      character*10  camxv, camxvin, sptmp
c
      character*6 flag(MXTRSP)
      character*6 sectmp(MXTRSP)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data camxv  /'VERSION7.4'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- initalize some variables ---
c
      lrtgas = .TRUE.      
      lrtaero = .TRUE.      
      write(idiag,'(//,A,//)',ERR=7009) 
     &       ' ******* Reading RTRAC chemical definitions file.'
c
c  --- open the file ----
c
      open(unit=iorchm,file=chmfil,ERR=7010,status='OLD')
c
c  --- read and verify the version number ---
c
      action = 'Reading version number in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      camxvin = line(21:30)
      write(idiag,'(A)',ERR=7009) line(:istrln(line))
      call jstlft( camxvin )
      call toupper( camxvin )
      if (camxvin .NE. camxv ) then
        write(iout,'(//,A)') 'ERROR in RDCHMRT:'
        write(iout,'(/,A)') 
     &               ' CAMx version in RTRAC chemistry file INVALID'
        write(iout,'(2A)')  ' Expecting: ',camxv
        write(iout,'(2A)')  '     Found: ',camxvin
        write(iout,'(1X,3A)') 'Make sure you are using an RTRAC ',
     &                               'file designed for ',version
        call camxerr()
      endif
c
c  --- ignore the description record ----
c
      action = 'Reading description record in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      write(idiag,'(A)',ERR=7009) line(:istrln(line))
c
c  --- read the number of gas species ----
c
      action = 'Reading number of gas species in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      read(line,'(20X,I10)',ERR=7005) nrtgas
      write(idiag,'(A,I5)',ERR=7009) line(1:20), nrtgas
      if( nrtgas .LE. 0 ) lrtgas = .FALSE.
c
c  --- read the number of aero species ----
c
      action = 
     & 'Reading number of aerosol species in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      read(line,'(20X,I10)',ERR=7005) nrtaero
      write(idiag,'(A,I5)',ERR=7009) line(1:20), nrtaero
c     if (lparttn .AND. nrtaero.lt.nrtgas) then
c        write(iout,'(A)') 'RTRAC gas-aerosol partitioning is selected.'
c        write(iout,'(A,A)') 'You must list at least the same number',
c    &                 ' of aerosol tracers as gas tracers.'
c        write(iout,'(A,A)') 'NOTE: gas tracer 1 will partition to',
c    &                       ' aerosol tracer 1, etc.'
c        write(iout,'(A)') 'CAMx is stopping.'
c        call camxerr()
c     endif
      if( nrtaero .LE. 0 ) lrtaero = .FALSE.
c
c  --- read the number of photolysis reactions ----
c
      action = 
     & 'Reading number of photolysis reactions in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      read(line,'(20X,I10)',ERR=7005) nrtphot
      write(idiag,'(A,I5)',ERR=7009) line(1:20), nrtphot
c
c  --- read the number of thermal reactions ----
c
      action = 
     & 'Reading number of thermal reactions in RTRAC Chemistry file.'
      read(iorchm,'(A)',ERR=7000,END=7001) line     
      read(line,'(20X,I10)',ERR=7005) nrtherm
      write(idiag,'(A,I5)',ERR=7009) line(1:20), nrtherm
c
c  --- make sure that there is enough array space ---
c
      ntotsp = nrtgas + nrtaero
      soap3_ntotsp = ntotsp
      nrtrac = nrtgas + nrtaero
      nsaspc = ntotsp
      notimespc = ntotsp
c
c  --- make sure the arrays are allocated large enough ---
c
      if( ntotsp .GT. MXTRSP ) then
          write(iout,'(//,A)') 'ERROR in RDCHMRT:'
          write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
          write(iout,*) 'Please change the value for parameter: MXTRSP'
          write(iout,*) 'It should be set to a value of at least: ',ntotsp
          call flush(iout)
          call camxerr()
      endif
c
c  --- call routine to allocate the arrays ---
c
      mvecedge = MAX(ncol(1),nrow(1))
      call alloc_tracer_specs(ngrid,ncol,nrow,nlay,nlayers_ems,
     &                                      tectyp,mvecedge,iout)
      call alloc_rtracchm(ngrid,ncol,nrow,nspec,ntotsp)
      call alloc_tracer_vdep(ngrid,ncol,nrow,ntotsp)
c
c  --- if doing sampling grids, allocate the arrays ---
c
      if( lsmptrc ) 
     &  call alloc_tracer_sample(nsample,ncolsmp,nrowsmp,nrtsmpcels)

c  --- initialize the variables ---
c
      do i = 1,ntotsp
        jnum(i) = 0
        rtjfact(i) = 0.
        aoh(i) = 0.
        eaoh(i) = 0.
        boh(i) = 0.
        troh(i) = 0.
        ano3(i) = 0.
        eano3(i) = 0.
        bno3(i) = 0.
        trno3(i) = 0.
        ao3(i) = 0.
        eao3(i) = 0.
        bo3(i) = 0.
        tro3(i) = 0.
        flag(i) = ' '
        sectmp(i) = ' '
        eqkoa(i) = 0.
        khydro(i) = 0.
        kleach(i) = 0.
        kpen(i) = 0.
        kphot(i) = 0.
      enddo       
c
c  --- read the gas species identification records ---
c
      if( nrtgas .GT. 0 ) then
          action = 'Reading gas species identification'//
     &                       ' record in RTRAC Chemistry file.'
          read(iorchm,'(A)',ERR=7000,END=7001) line     
cae       write(idiag,'(A)',ERR=7009) line(:istrln(line))
          read(iorchm,'(A)',ERR=7000,END=7001) line     
cae       write(idiag,'(A)',ERR=7009) line(:istrln(line))
          do i = 1,nrtgas
            read(iorchm,'(A)',ERR=7000,END=7001) line     
c
c   --- parse the line ----
c
            sptmp = line(6:15)
            call jstlft( sptmp )
            flag(i) = line(16:21)
            call jstlft( flag(i) )
            call toupper( flag(i) )
            if( flag(i) .EQ. 'PRIM  ' ) then
               lsecnd(i) = .FALSE.
            else if( flag(i) .EQ.  'SEC   ' ) then
               lsecnd(i) = .TRUE.
               sectmp(i) = line(22:27)
               call jstlft( sectmp(i) )
               if( ipigflg .EQ. IRONPIG ) then
                 idx = 0
                 lreg(i) = .FALSE.
                 do ispc=1,i-1
                    if( ptname(ispc)(1:6) .EQ. sectmp(i) ) idx = ispc
                 enddo
                 if( idx .EQ. 0 ) goto 7011
                 ksec(i) = idx
               else
                 idx = 0
                 lreg(i) = .FALSE.
                 do ispc=1,nspec
                    if( spname(ispc)(1:6) .EQ. sectmp(i) ) then
                       idx = ispc
                       lreg(i) = .TRUE.
                       ksec(i) = idx
                    endif
                 enddo
                 if( .NOT. lreg(i) ) then
                    do ispc=1,i-1
                      if( ptname(ispc)(1:6) .EQ. sectmp(i) ) then
                         idx = ispc
                         ksec(i) = idx
                      endif
                    enddo
                 endif
                 if( idx .EQ. 0 ) goto 7004
               endif
            else
               goto 7003
            endif
c
c  ---- passes all checks, load into arrays ---
c
            ptname(i) = sptmp
            lsamap(i) = i
            lsagas(i) = .TRUE.
            loutsa(i) = .TRUE.
            read(line,'(27X,7F10.0)',ERR=7005) rtlbnd(i), 
     &        rthlaw(i), rttfact(i), rtmolwt(i), rtreact(i), rtscale(i),
     &        eqkoa(i)
            rtdrate(i) = sqrt(rtmolwt(i)/18.)
            sa_mole_weight(i) = rtmolwt(i)
          enddo
c
c  --- echo the data to the diag file ----
c
          write(idiag,'(A)') 'RTRAC gas species values'
          write(idiag,'(3A)') '     Name      P/S   Pname LowBnd (ppm)',
     &                        '   H (M/atm)   Tfact (K)  MW (g/mol)',
     &                        '  Reactivity      Rscale         Koa'
ciii  aaaaaaaaaaAAAAAAaaaaaa  -e.eeeE-ee  -e.eeeE-ee-fffffff.fff-fffffff.fff-fffffff.fff-fffffff.fff

          do i = 1,nrtgas
             write(idiag,'(I3,2X,A10,2A6,2E12.3,4F12.3,E12.3)',ERR=7009) i,
     &              ptname(i),flag(i),sectmp(i),rtlbnd(i),rthlaw(i), 
     &              rttfact(i),rtmolwt(i),rtreact(i),rtscale(i),eqkoa(i)
             if (eqkoa(i).lt.0.) then
               write(iout,'(//,A)') 'ERROR in RDCHMRT:'
               write(iout,'(3A)') 'Koa for ',ptname(i)(:istrln(ptname(i))),
     &                            ' is <0! --- Stopping'
               call camxerr() 
             endif
             if (istrln(ptname(i)).gt.8) goto 7012
          enddo
      endif
c
c  --- read the soil model data records
c
      if (lsrfmodrt) then
         action = 'Reading surface model species records'//
     &                       ' in RTRAC Chemistry file.'
         read(iorchm,'(A)',ERR=7000,END=7001) line
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         read(iorchm,'(A)',ERR=7000,END=7001) line
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         do i = 1,nrtgas
           read(iorchm,'(A)',ERR=7000,END=7001) line
           sptmp = line(6:15)
           call jstlft( sptmp )
           if (sptmp .NE. ptname(i)) goto 7020
           read(line,'(15X,4F10.0)',ERR=7005)
     &                     khydro(i),kleach(i),kpen(i),kphot(i)
           write(idiag,'(I3,2X,A10,4E10.3)',ERR=7009) i,
     &           ptname(i),khydro(i),kleach(i),kpen(i),kphot(i)
           if (khydro(i).lt.0. .or. kleach(i).lt.0.
     &         .or. kpen(i).lt.0. .or. kphot(i).lt.0.) then
             write(iout,'(//,A)') 'ERROR in RDCHMRT:'
             write(iout,'(3A)') 'Rates for ',ptname(i)(:istrln(ptname(i))),
     &                         ' are <0!'
             write(iout,'(A)') 'Only positive rates are allowed --- Stopping'
             call camxerr() 
           endif
         enddo
      endif
c
c  --- read the aerosol species identification records ---
c
      if( nrtaero .GT. 0 ) then
         action = 'Reading aerosol species identification'//
     &                       ' record in RTRAC Chemistry file.'
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         do j = 1,nrtaero
            i = nrtgas+j
            read(iorchm,'(A)',ERR=7000,END=7001) line     
c
c   --- parse the line ----
c
            sptmp = line(6:15)
            call jstlft( sptmp )
            ptname(i) = sptmp
            lsamap(i) = i
            lsagas(i) = .FALSE.
            loutsa(i) = .TRUE.
            sa_mole_weight(i) = 1.0
            read(line,'(15X,4F10.0)',ERR=7005) rtlbnd(i), 
     &                 rtdens(i), rtlcut(i), rtucut(i)
         enddo
c
c  --- echo the data to the diag file ----
c
         do j = 1,nrtaero
            i = nrtgas+j
            write(idiag,'(I3,2X,A10,E10.3,3F10.4)',ERR=7009) i,
     &              ptname(i), rtlbnd(i), rtdens(i), 
     &                                        rtlcut(i), rtucut(i)
            rtdens(i) = rtdens(i)*1.e6
            if (istrln(ptname(i)).gt.8) goto 7012
         enddo
      endif
c
c  --- read the phololysis reactions ---
c
      if( nrtphot .GT. 0 ) then
         action = 'Reading photolysis reaction'//
     &                           ' record in RTRAC Chemistry file.'
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         do irec=1,nrtphot
            read(iorchm,'(A)',ERR=7000,END=7001) line
            sptmp = line(1:10)
            call jstlft( sptmp )
            idx = 0
            do i = 1,nrtgas
               if( ptname(i) .EQ. sptmp ) idx = i
            enddo
            if( idx .EQ. 0 ) goto 7006
            read(line,'(10X,I10,F10.0)',ERR=7005) jnum(idx), 
     &                                               rtjfact(idx)
            iphot = 0
            do i = 1,nphot1
              if( jnum(idx) .EQ. idphot1(i) ) iphot = i
            enddo
            do i = 1,nphot2
              if( jnum(idx) .EQ. idphot2(i) .OR. 
     &                       jnum(idx) .EQ. idphot3(i) ) iphot = i
            enddo
            if( iphot .EQ. 0 ) goto 7007
         enddo
c
c   --- echo data to diag file ----
c
         do i = 1,nrtgas
            write(idiag,'(A10,I10,F10.4)',ERR=7009) ptname(i),
     &                                           jnum(i), rtjfact(i)
         enddo
      endif
c
c  --- read the thermal reactions ---
c
      if( nrtherm .GT. 0 ) then
         action = 'Reading thermal reaction'//
     &                       ' record in RTRAC Chemistry file.'
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         read(iorchm,'(A)',ERR=7000,END=7001) line     
         write(idiag,'(A)',ERR=7009) line(:istrln(line))
         do irec=1,nrtherm
            read(iorchm,'(A)',ERR=7000,END=7001) line     
            sptmp = line(1:10)
            call jstlft( sptmp )
            idx = 0
            do i = 1,nrtgas
               if( ptname(i) .EQ. sptmp ) idx = i
            enddo
            if( idx .EQ. 0 ) goto 7006
c
            sptmp = line(11:16)
            call jstlft( sptmp )
            if( sptmp .EQ.  'OH    ' ) then
                read(line,'(16X,2F12.0,2F10.0)',ERR=7005) aoh(idx), 
     &                                  eaoh(idx), boh(idx), troh(idx)
            else if( sptmp .EQ. 'NO3   ' ) then
                read(line,'(16x,2F12.0,2F10.0)',ERR=7005) ano3(idx), 
     &                               eano3(idx), bno3(idx), trno3(idx)
            else if( sptmp .EQ. 'O3    ' ) then
                read(line,'(16x,2F12.0,2F10.0)',ERR=7005) ao3(idx), 
     &                               eao3(idx), bo3(idx), tro3(idx)
            else
                goto 7008
            endif
         enddo
c
c   --- echo data to diag file ----
c
         do i = 1,nrtgas
            write(idiag,'(A10,A6,2E12.4,2F10.4)',ERR=7009) ptname(i),
     &                       ' OH  ',aoh(i), eaoh(i), boh(i), troh(i)
            write(idiag,'(A10,A6,2E12.4,2F10.4)',ERR=7009) ptname(i),
     &                    ' NO3 ',ano3(i), eano3(i), bno3(i), trno3(i)
            write(idiag,'(A10,A6,2E12.4,2F10.4)',ERR=7009) ptname(i),
     &                       ' O3  ',ao3(i), eao3(i), bo3(i), tro3(i)
         enddo
c
c-----Provide diagnostic info for checking rate expressions
c     See CHEMRT for explanation of function ARRHEN
c
        write(idiag,'(/,a)')
     &        'Diagnostic info for checking RTRAC rate expressions'
        write(idiag,'(/,a,/,a)')
     &        'Rates at 298 K and 1013 mbar in cm3 molec-1 s-1',
     &        '      Species        OH rate     O3 rate    NO3 rate'
        adj = 1.
        do i = 1,nrtgas
           rkoh  = arrhen(aoh(i),eaoh(i),boh(i),troh(i),298.)*adj
           rko3  = arrhen(ao3(i),eao3(i),bo3(i),tro3(i),298.)*adj
           rkno3 = arrhen(ano3(i),eano3(i),bno3(i),trno3(i),298.)*adj
           write(idiag,'(I5,1X,A10,1P3E12.4)') i, ptname(i),
     &                                           rkoh, rko3, rkno3
        enddo
        write(idiag,'(/,a,/,a)')
     &        'Rates at 273 K and 1013 mbar in cm3 molec-1 s-1',
     &        '      Species        OH rate     O3 rate    NO3 rate'
        adj = 298./273.
        do i = 1,nrtgas
           rkoh  = arrhen(aoh(i),eaoh(i),boh(i),troh(i),273.)*adj
           rko3  = arrhen(ao3(i),eao3(i),bo3(i),tro3(i),273.)*adj
           rkno3 = arrhen(ano3(i),eano3(i),bno3(i),trno3(i),273.)*adj
           write(idiag,'(I5,1X,A10,1P3E12.4)') i, ptname(i),
     &                                           rkoh, rko3, rkno3
        enddo
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') 'Premature end-of-file reached.'
      write(iout,'(1X,A)') action(:istrln(action))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,2A)') 'Invalid keyword for species type: ',
     &                                                    line(16:21)
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,3A)') 'Specified primary species: ',line(22:27),
     &                     ' is not in regular model species list'
      write(iout,'(1X,A)') 'nor in the RTRAC species list read so far.'
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      write(iout,'(1X,2A)') 'Any child RTRAC tracer must be listed after ',
     &                                          'its parent RTRAC tracer.'
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,3A)') 'Species listed not included in ',
     &               'list of gas species definitions.'
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,2A,I3)') 'Reaction # listed is not a ',
     &                    'photolysis reaction.  Rxn Id: ',jnum(idx)
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      call camxerr()
c
 7008 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,3A)') 'Invalid species for reaction: ',
     &                                               line(11:16)
      write(iout,'(1X,A)') 'Must be one of the following: '
      write(iout,'(10X,A)') 'OH'
      write(iout,'(10X,A)') 'NO3'
      write(iout,'(10X,A)') 'O3'
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      call camxerr()
c
 7009 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') 'Cannot write to the diag file.'
      call camxerr()
c
 7010 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') 'Cannot open file: ',chmfil(:istrln(chmfil))
      call camxerr()
c
 7011 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,3A)') 'Specified primary species: ',line(22:27),
     &                  ' is not in the RTRAC species list read so far.'
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      write(iout,'(1X,2A)') 'Any child RTRAC tracer must be listed after',
     &                                         ' its parent RTRAC tracer.'
      write(iout,'(1X,2A,/,1X,A)') 'Secondary RTRAC tracers can only map to',
     &                  ' other RTRAC tracers if IRON PiG',' is invoked.'
      call camxerr()
c
 7012 write(iout,'(//,a)') 'ERROR in RDCHMRT:'
      write(iout,'(2a)')   'Species: ',ptname(i)
      write(iout,'(2a)')   'Exceeds the 8-character maximum.',
     &                     ' Shorten the name.'
      call camxerr()
c
 7020 continue
      write(iout,'(//,A)') 'ERROR in RDCHMRT:'
      write(iout,'(1X,A)') action(:istrln(action))
      write(iout,'(1X,A,A,A)') 'Surface model gas species: ',sptmp,
     &                     ' does not match the RTRAC species list.'
      write(iout,'(1X,A,/,A)') 'Line read: ',line(:istrln(line))
      write(iout,'(1X,A,A)') 'Expecting species: ',ptname(i)
      write(iout,'(1X,2A,/,1X,A)') 'The surface model parameters must be',
     &        ' given in the same order as the RTRAC',' gas species list'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      write(idiag,'(//,A,//)',ERR=7009) 
     &       ' ******* Finished RTRAC chemical definitions file.'
      close(iorchm)
      return
      end

c**** NCF_CHK_GRIDDEF
c
      subroutine ncf_chk_griddef(iounit,action,igrd,lchk_layers,
     &        lchk_cells,l_allow_buffer_cells,is_met_file,buffer_offset)
      use filunit
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the global file attributes for the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         iounit               I NCF file ID
c         action               C string that describes file being read
c         igrd                 I grid number
c         lchk_layers          L .TRUE. if number of layers is to be checked
c         lchk_cells           L .TRUE. if number of cells is to be checked
c                                       (this is for the point source exception)
c         l_allow_buffer_cells L .TRUE. if it OK to  have buffer cells
c       Outputs:
c         buffer_offset        I number of buffer to add( 0 or 1)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit
      character*(*) action
      integer       igrd
      logical       lchk_layers
      logical       lchk_cells
      logical       l_allow_buffer_cells
      logical       is_met_file
      integer       buffer_offset
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 this_var
c
      integer ierr, itzon_in, iutm_in, ncols_in, nrows_in, nlays_in
      integer cproj_in, cproj_mod, gdtyp_in, gdtyp_mod
      integer this_dimid, ncols_match, nrows_match
      real*8  dble_xcent, dble_ycent, dble_xorig, dble_yorig
      real*8  dble_xcell, dble_ycell, dble_p_alp, dble_p_bet
      real    xcent_in, ycent_in, xorig_in, yorig_in, xcell_in, ycell_in
      real    p_alp_in, p_bet_in, xorig_grid, yorig_grid
      real    xorig_mod, yorig_mod, xcell_mod, ycell_mod
      real    delx_grid, dely_grid, delx_mod, dely_mod
      real    xorig_match, yorig_match
      logical lcheck_ok
c
c-----------------------------------------------------------------------
c    Parameters:
c-----------------------------------------------------------------------
c
      real FUZZ
      parameter( FUZZ = 0.01 )
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- get global variables for domain definition ----
c
      this_var = 'ITZON'
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'ITZON', itzon_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      this_var = 'XCENT'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'XCENT', dble_xcent)
      if( ierr .NE. NF_NOERR ) goto 7000
      xcent_in = REAL(dble_xcent)
c
      this_var = 'YCENT'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'YCENT', dble_ycent)
      if( ierr .NE. NF_NOERR ) goto 7000
      ycent_in = REAL(dble_ycent)
c
      this_var = 'IUTM'
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'IUTM', iutm_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      this_var = 'XORIG_BUF'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'XORIG_BUF', dble_xorig)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'XORIG'
         ierr = nf_get_att_double(iounit, NF_GLOBAL, 'XORIG', dble_xorig)
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      xorig_in = REAL(dble_xorig)
c
      this_var = 'YORIG_BUF'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'YORIG_BUF', dble_yorig)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'YORIG'
         ierr = nf_get_att_double(iounit, NF_GLOBAL, 'YORIG', dble_yorig)
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      yorig_in = REAL(dble_yorig)
c
      this_var = 'XCELL'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'XCELL', dble_xcell)
      if( ierr .NE. NF_NOERR ) goto 7000
      xcell_in = REAL(dble_xcell)
c
      this_var = 'YCELL'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'YCELL', dble_ycell)
      if( ierr .NE. NF_NOERR ) goto 7000
      ycell_in = REAL(dble_ycell)
c
      if( .NOT. is_met_file ) then
          this_var = 'COL'
          ierr = nf_inq_dimid(iounit, "COL", this_dimid  )
          if( ierr .NE. NF_NOERR ) goto 7006
          ierr = nf_inq_dimlen(iounit,this_dimid,ncols_in)
          if( ierr .NE. NF_NOERR ) goto 7006
      else
          this_var = 'NCOLS_BUF'
          ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NCOLS_BUF', ncols_in)
          if( ierr .NE. NF_NOERR ) then
            this_var = 'NCOLS'
            ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NCOLS', ncols_in)
            if( ierr .NE. NF_NOERR ) goto 7000
          endif
      endif
c
      if( .NOT. is_met_file ) then
         this_var = 'ROW'
         ierr = nf_inq_dimid(iounit, "ROW", this_dimid  )
         if( ierr .NE. NF_NOERR ) goto 7006
         ierr = nf_inq_dimlen(iounit,this_dimid,nrows_in)
         if( ierr .NE. NF_NOERR ) goto 7006
      else
         this_var = 'NROWS_BUF'
         ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NROWS_BUF', nrows_in)
         if( ierr .NE. NF_NOERR ) then
           this_var = 'NROWS'
           ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NROWS', nrows_in)
           if( ierr .NE. NF_NOERR ) goto 7000
         endif
      endif
c
      this_var = 'LAY'
      ierr = nf_inq_dimid(iounit, "LAY", this_dimid  )
      if( ierr .NE. NF_NOERR ) goto 7006
      ierr = nf_inq_dimlen(iounit,this_dimid,nlays_in)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = 'CPROJ'
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'CPROJ', cproj_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      this_var = 'GDTYP'
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'GDTYP', gdtyp_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      this_var = 'P_ALP'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'P_ALP', dble_p_alp)
      if( ierr .NE. NF_NOERR ) goto 7000
      p_alp_in = REAL(dble_p_alp)
c
      this_var = 'P_BET'
      ierr = nf_get_att_double(iounit, NF_GLOBAL, 'P_BET', dble_p_bet)
      if( ierr .NE. NF_NOERR ) goto 7000
      p_bet_in = REAL(dble_p_bet)
c
c  --- check that they all match user definition for this grid ---
c
      xorig_grid = xorg
      yorig_grid = yorg
      delx_grid = delx
      dely_grid = dely
      if( igrd .GT. 1 ) then
        delx_grid = delx/FLOAT( meshold(igrd) )
        dely_grid = delx/FLOAT( meshold(igrd) )
        xorig_grid = xorg + delx*(inst1(igrd)-1) - delx_grid
        yorig_grid = yorg + dely*(jnst1(igrd)-1) - dely_grid
      endif
      xorig_mod = xorig_grid*1000.
      yorig_mod = yorig_grid*1000.
      delx_mod = delx_grid*1000.
      dely_mod = dely_grid*1000.
      if( llatlon ) then
         cproj_mod = 0
         gdtyp_mod = 1
         xorig_mod = xorig_grid
         yorig_mod = yorig_grid
         delx_mod = delx_grid
         dely_mod = dely_grid
      else if( lutm ) then
         cproj_mod = 1
      else if( lambrt ) then
         cproj_mod = 2
         gdtyp_mod = 2
      else if( lrpolar ) then
         cproj_mod = 3
         gdtyp_mod = 4
      else if( lpolar ) then
         cproj_mod = 4
         gdtyp_mod = 6
      else if( lmerc ) then
         cproj_mod = 5
         gdtyp_mod = 7
      endif
c
c   --- stop if domain definition does not match ---
c
      ncols_match = ncol(igrd)
      nrows_match = nrow(igrd)
      xorig_match = xorig_mod
      yorig_match = yorig_mod
      lcheck_ok = .TRUE.
      if( ABS(xorig_match-xorig_in) .GT. FUZZ ) lcheck_ok = .FALSE.
      if( ABS(yorig_match-yorig_in) .GT. FUZZ ) lcheck_ok = .FALSE.
      if( l_allow_buffer_cells .AND. .NOT. lcheck_ok ) then
         lcheck_ok = .TRUE.
         xorig_match = xorig_mod+delx_mod
         yorig_match = yorig_mod+dely_mod
         if( ABS(xorig_match-xorig_in) .GT. FUZZ ) lcheck_ok = .FALSE.
         if( ABS(yorig_match-yorig_in) .GT. FUZZ ) lcheck_ok = .FALSE.
      endif
      if( ABS(delx_mod-xcell_in) .GT. FUZZ ) lcheck_ok = .FALSE.
      if( ABS(dely_mod-ycell_in) .GT. FUZZ ) lcheck_ok = .FALSE.
      if( lchk_cells .AND. ncols_in .NE. ncols_match ) lcheck_ok = .FALSE.
      if( lchk_cells .AND. nrows_in .NE. nrows_match ) lcheck_ok = .FALSE.
      if( l_allow_buffer_cells .AND. .NOT. lcheck_ok ) then
         ncols_match = ncols_match - 2
         nrows_match = nrows_match - 2
         lcheck_ok = .TRUE.
         if( lchk_cells .AND. ncols_in .NE. ncols_match ) lcheck_ok = .FALSE.
         if( lchk_cells .AND. nrows_in .NE. nrows_match ) lcheck_ok = .FALSE.
      endif
      if ( lchk_layers ) then
        if( nlays_in .NE. nlay(igrd) ) lcheck_ok = .FALSE.
      else
        if (nlays_in .GT. 1 .AND. nlays_in .NE. nlay(igrd) )
     &    lcheck_ok = .FALSE.
      endif
      if( .NOT. lcheck_ok ) goto 7001
      buffer_offset = 0
      if( ncols_in+2 .EQ. ncol(igrd) 
     &          .AND. nrows_in+2 .EQ. nrow(igrd)) buffer_offset = 1
c
c   --- stop if projection type does not match ---
c
      lcheck_ok = .TRUE.
      if( cproj_in .NE. cproj_mod ) goto 7002
c
c   --- stop if projection parameters do not match ---
c
      if( itzon_in .NE. itzon ) goto 7003
      if(  lutm ) then
         if( iutm_in .NE. iuzon ) goto 7004
      else
         lcheck_ok = .TRUE.
         if( ABS(xcent_in-polelon) .GT. FUZZ ) lcheck_ok = .FALSE.
         if( ABS(ycent_in-polelat) .GT. FUZZ ) lcheck_ok = .FALSE.
         if( .NOT. lcheck_ok ) goto 7005
         lcheck_ok = .TRUE.
         if( ABS(p_alp_in-tlat1) .GT. FUZZ ) lcheck_ok = .FALSE.
         if( ABS(p_bet_in-tlat2) .GT. FUZZ 
     &                       .AND. .NOT. lpolar ) lcheck_ok = .FALSE.
c
c  --- order of the poles doesn't matter ---
c
         if( .NOT. lcheck_ok .AND. .NOT. lpolar ) then
            if( ABS(p_alp_in-tlat2) .GT. FUZZ ) goto 7005
            if( ABS(p_bet_in-tlat1) .GT. FUZZ ) goto 7005
         endif
      endif
c 
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Domain definition does not match: '
      write(iout,'(/,10X,A)') 'User supplied:'
      write(iout,'(A,F15.2,A,F15.2,A)') 'Grid origin: (',
     &                                     xorig_mod,',',yorig_mod,')'
      write(iout,'(A,F15.2,A,F15.2,A)') 'Cell Width: (',
     &                                     delx_mod,',',dely_mod,')'
      if( lchk_cells) write(iout,'(A,I4,A,I4,A)') 'Number of cells: (',
     &                                 ncols_match,',',nrows_match,')'
      write(iout,'(A,I4)') 'Number of layers: ',nlay(igrd)
      write(iout,'(/,10X,A)') 'Values in file:'
      write(iout,'(A,F15.2,A,F15.2,A)') 'Grid origin: (',
     &                                     xorig_in,',',yorig_in,')'
      write(iout,'(A,F15.2,A,F15.2,A)') 'Cell Width: (',
     &                                     ycell_in,',',ycell_in,')'
      if( lchk_cells) write(iout,'(A,I4,A,I4,A)') 'Number of cells: (',
     &                                 ncols_in,',',nrows_in,')'
      write(iout,'(A,I4)') 'Number of layers: ',nlays_in
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Projection type does not match.'
      write(iout,'(A,I5)') 'User supplied: ',cproj_mod
      write(iout,'(A,I5)') 'Value in file: ',cproj_in
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Time zone does not match.'
      write(iout,'(A,I5)') 'User supplied: ',itzon
      write(iout,'(A,I5)') 'Value in file: ',itzon_in
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'UTM zone does not match.'
      write(iout,'(A,I5)') 'User supplied: ',iuzon
      write(iout,'(A,I5)') 'Value in file: ',iutm_in
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Projection parameters do not match.'
      write(iout,'(/,10X,A)') 'User supplied:'
      write(iout,'(A,F10.4)') 'Longitude of projection pole:',polelon
      write(iout,'(A,F10.4)') 'Latitude of projection pole:',polelat
      write(iout,'(A,F10.4)') '1st true latitude:',tlat1
      if( .NOT. lpolar ) write(iout,'(A,F10.4)') '2nd true latitude:',tlat2
      write(iout,'(/,10X,A)') 'Values in file:'
      write(iout,'(A,F10.4)') 'Longitude of projection pole:',xcent_in
      write(iout,'(A,F10.4)') 'Latitude of projection pole:',ycent_in
      write(iout,'(A,F10.4)') '1st true latitude:',p_alp_in
      if( .NOT. lpolar ) write(iout,'(A,F10.4)') '2nd true latitude:',p_bet_in
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in NCF_CHK_GRIDDEF:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for dimension:',
     &                            this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine hr_xo_dum(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_XO_DUM is a dummy routine for non-halogen mechanisms
c
c      Copyright Ramboll
c     ***PROTOTYPE CREATED BY HAND***
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
      return
      end

      subroutine lscall(lsrate,dtin,H2O,atm,O2,CH4,H2,conc,
     &                  avgcnc,nirrrxn,rrxn_irr,
     &                  ierr,ldoirr,lpig)
      use chmstry
      use filunit
      implicit none
c
c
c----CAMx v7.40 260801
c
c     LSCALL calls DLSODE for gas phase chemistry
c     DLSODE is a double precision Gear solver
c
c      Copyright Ramboll
c
c     Modifications:
c        8/4/08        Altered error tolerances according to weather
c                      LSODE is called for grid chemistry or PiG
c        6/28/13       Modified for new GREASD PiG chemistry
c
c
c     Input arguments:
c
c        lsrate            name of the routine which computes the
c                          reaction rates
c        dtin              time duration to be integrated (hr)
c        H2O               water vapor concentration (ppm)
c        atm               total gas concentration (M) in ppm
c        O2                oxygen concentration (ppm)
c        CH4               methane concentration (ppm)
c        H2                hydrogen concentration (ppm)
c        conc              state species concentrations (ppm)
c        nirrrxn           number of reactions for IPRM
c        ldoirr            logical flag to calculate IRR data
c        lpig              PiG chemistry flag (0 - no PiG; 1 - GREASD PiG; 2 - IRON PiG)
c
c     Output arguments:
c        conc              state species concentrations (ppm)
c        avgcnc            average state species concentrations (ppm)
c        rrxn_irr          integrated reaction rates for IRR
c        ierr              error flag (=1 if LSODE reports error)
c
c     Routines called:
c        DLSODE
c        CAMXERR
c
c     Called by:
c        CHEMDRIV
c        IRONCHEM
c
      include "camx.prm"
      include "ddmchm.inc"
      include 'chmdbg.inc'
      include 'lsbox.inc'
c
c-----argument delclarations ---
c
      real    conc(*)
      integer ierr
c
c --- Parameters for LSODE
c
      integer   LSDIM, LIW, LRW, ITOL, MF
      real*8    DATOL, DRTOL
      parameter (LSDIM = MXSPEC + 1)
      parameter (LIW = LSDIM + 20)
      parameter (LRW = LSDIM*LSDIM + 9*LSDIM + 22)
      parameter (ITOL = 1)
      parameter (MF = 22)
c
c --- Variables
c
      integer   i, l
      integer   itask, istate, iopt, neq
      integer   iwork(LIW) 
      real      dtin, H2O, atm, O2, CH4, H2
      real      avgcnc(MXSPEC + 1)
      real*8    t, tout 
      real*8    y(LSDIM), y0(LSDIM), rwork(LRW)
      integer   lpig
c
c --- lsode common block
c
      integer   mesflg, lunit
      common    /ehd001/ mesflg, lunit
c
c --- External subroutines
c     jdum is a dummy routine defined below
c
      external lsrate, jdum
c
c========================== Process Analysis Begin =============================
c
      integer irxn, nirrrxn
      real    rrxn_irr(nirrrxn)
      real*8  rrxn(MXREACT), rrdt(nirrrxn), ydd(LSDIM)
      logical ldoirr
c
c=========================== Process Analysis End ==============================
c
c --- Entry point
c
c
c --- Set error tolerances according to grid or PiG chem
c
      DRTOL = 1.0D-7
      DATOL = 1.0D-10
      if( lpig.gt.0 ) then
        DRTOL = 1.0D-5
        DATOL = 1.0D-9
      endif
c
c --- Fill some double precision values for LSODE
c
      if ( lpig.eq.GRESPIG ) then
        do i = 1, NRPIGCHEM
          if ( lrmap(i).eq.0 ) then
            dbrk(i) = 0.0D0
          else
            dbrk(i) = DBLE(rk(lrmap(i)))
          endif
        enddo
        neq = NSPIGCHEM
      else
        do i = 1,nreact
          dbrk(i) = DBLE(rk(i))
        enddo
        neq  = ngas
      endif
      dH2O = H2O
      dM   = atm
      dO2  = O2
      dCH4 = CH4
      dH2  = H2
c
c --- Load concentrations
c
      if ( lpig.eq.GRESPIG ) then
        do i = 1, NSPIGCHEM
          y(i)  = DBLE(conc(lsmap(i)))
          y0(i) = DBLE(conc(lsmap(i)))
        enddo
      else
        do i = 1,ngas
          y(i)  = DBLE(conc(i))
          y0(i) = DBLE(conc(i))
        enddo
      endif
      y(neq+1) = 0.0D0 
c
c --- Zero the working array elements that can pass options to LSODE
c
      do i = 1,12
        rwork(i) = 0.0D0
        iwork(i) = 0
      enddo
c
c --- Set variables that control LSODE
c
      t      = 0.0D0 
      itask  = 1 
      istate = 1 
      iopt   = 1 
      iwork(6) = 1000     ! max iterations
cgy      lunit  = idiag   ! comment out data statement in DLSODE if do this
cgy      mesflg  = 1      ! comment out data statement in DLSODE if do this
c
c========================== Process Analysis Begin =============================
c
      if (ldoirr) then
        do irxn = 1, nirrrxn
          rrdt(irxn) = 0.0
        enddo
      endif
c
c=========================== Process Analysis End ==============================
c
c --- Do chemistry for timestep using LSODE
c     Step out of LSODE at dt/2 and capture concentrations
c
      tout   = DBLE(dtin/2.0)
      call dlsode(lsrate,neq,y,t,tout,ITOL,DRTOL,DATOL,itask,istate, 
     1      iopt,rwork,LRW,iwork,LIW,jdum,MF,ldoirr,nirrrxn,rrxn,
     2      rrdt,ydd)
      if (istate .lt. 0) go to 900 
      if ( lpig.eq.GRESPIG ) then
        do i = 1, NSPIGCHEM
          avgcnc(lsmap(i)) = MAX(DBLE(bdnl(lsmap(i))),y(i))
        enddo
      else
        do i = 1,ngas
          avgcnc(i) = MAX(DBLE(bdnl(i)),y(i))
        enddo
      endif
      tout = DBLE(dtin)
      call dlsode(lsrate,neq,y,t,tout,ITOL,DRTOL,DATOL,itask,istate, 
     1      iopt,rwork,LRW,iwork,LIW,jdum,MF,ldoirr,nirrrxn,rrxn,
     2      rrdt,ydd)
      if (istate .lt. 0) go to 900 
c
c========================== Process Analysis Begin =============================
c
      if (ldoirr) then
        do irxn = 1, nirrrxn
          rrxn_irr(irxn) = rrdt(irxn) 
        enddo
      endif
c
c=========================== Process Analysis End ==============================
c
c
c --- Save species concentrations in CAMx arrays
c
      if ( lpig.eq.GRESPIG ) then
        do i = 1, NSPIGCHEM
          conc(lsmap(i)) = MAX(DBLE(bdnl(lsmap(i))),y(i))
        enddo
      elseif ( lpig.eq.IRONPIG ) then
        do i = 1,ngas
          conc(i) = y(i)
        enddo
      else
        do i = 1,ngas
          conc(i) = MAX(DBLE(bdnl(i)),y(i))
        enddo
      endif
c
      return
c
c --- Handle error codes from LSODE
c
 900  if ( lpig.gt.0 ) then 
        ierr = 1
        return
      else
        write(iout,*)
        write(iout,*)' ERROR reported in LSCALL by the LSODE solver'
        write(iout,*)' LSODE reporting ISTATE = ', istate
        write(iout,*)' look up this error code in the LSODE source code'
        write(iout,901) rwork(11),rwork(12),rwork(13),dtin
        write(iout,903) iwork(12),iwork(13),iwork(11)
        write(iout,*)
        write(iout,*) 'ldark, temp(K), water = ',
     &                 ldchm, tchm, wchm
        write(iout,*) 'M, O2, CH4, H2  = ',
     &                 atm, O2, CH4, H2
        if( igrdchm.GT.0 ) then
           write(iout,'(a,i10,3i4)')' igrd, i, j, k =',
     &                             igrdchm,ichm,jchm,kchm
        else
           write(iout,'(a,i10,3i4)')' PiG puff number, i, j =',
     &                            -igrdchm,ichm,jchm
        endif
        write(iout,*) 'No  Name    New Conc    Init Conc '
        do l = 1,ngas
          write(iout,905) l, spname(l), y(l), y0(l)
        enddo
        write(iout,*) 'No   Rate Constant'
        do l = 1,nreact
          write(iout,910) l, rk(l)
        enddo
        write(iout,*)
c
        call camxerr()
c
 905    format(i3,2x,a7,1p3d12.3)
 910    format(i3,2x,1p3e12.3)
 901    format('   last step size  = ', d12.3,/
     &         '   next step size  = ', d12.3,/
     &         '   current time    = ', d12.3,/
     &         '   total time step = ', d12.3)
 903    format('   # of steps ',i4,' # of f-s ',i4,' # of j-s ',i4)
      endif
c
      end 
c
      subroutine jdum (neq, t, y, ml, mu, pd, nrpd)
      use filunit
c
c --- This is a dummy subroutine that should never be called
c
      implicit none
      integer neq, ml, mu, nrpd
      real*8  t, y(neq), pd(nrpd,neq)
      include "camx.prm"
c
      write(iout,'(//,A)') ' ERROR in LSCALL:'
      write(iout,'(A)') ' Set LSODE parameter MF to 22, not 21'
      call camxerr()
c
      return
      end

c***** NCF_RDARRT.F
c
      subroutine ncf_rdarrt(igrid,ndate,ttime,nox,noy,nlay_ems,nrtarsp,emisrt)
      use tracer
      use filunit
      use grid
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the RTRAC process
c   and fills the approproate arrays.  The emissions file for one grid
c   but each emissions groups is read. This version is for NetCDF files.
c    Argument descriptions:
c     Outputs:
c       emisrt    R    array of emissions for RTRAC speices
c     Inputs:
c       igrid     I    grid number
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       nox       I    number of columns in grid
c       noy       I    number of rows in grid
c       nlay_ems  I    number of layers in emissions files
c       nrtarsp   I    number of RTRAC species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       06/09/18 -gwilson-  original development
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c       
c-----------------------------------------------------------------------
c   External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      integer ndate
      real    ttime
      integer nox
      integer noy
      integer nlay_ems
      integer nrtarsp
      real    emisrt(nox,noy,nlay_ems,nrtarsp)
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname, action
      character*10  this_var
      integer      nedge, iounit, ierr,  itmp, jtmp
      integer      nlays_in, ispc, data_start(4), data_count(4), this_date
      integer      this_time_tflag, this_time_etflag, this_tstep
      integer      iddm, i, j, k, imap,  this_varid, buffer_offset
      real         emstmp, this_time
      logical      luse
c
      real, allocatable, dimension(:,:,:) :: emsgrd
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c   --- skip if filename not supplied ---
c
      if( .NOT. is_netcdf_iortem(igrid,1,1) ) goto 9999
c
c   --- set the unit number for surface emissions file ---
c
      iounit = iortem(igrid,1,1)
      fname = temfil(igrid,1,1)
      buffer_offset = buffer_offset_iortem(igrid,1,1)
      write(action,'(2A,I3)') 'Reading the RTRAC NetCDF ',
     &                     'gridded emissions file. Grid: ',igrid
     &                                    
c
c   ---- get the number of layers in this file ---
c
      this_var = 'NLAYS'
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NLAYS', nlays_in)
      if( ierr .NE. NF_NOERR ) goto 7000
c
c   --- allocate the local array ---
c
      allocate( emsgrd(nox-2*buffer_offset,noy-2*buffer_offset,nlays_in) )
c
c   --- if number of layers is not 1 make sure it matches grid ---
c
      if( nlays_in .NE. 1 .AND. nlays_in .NE. nlay(igrid) ) goto 7001
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = nox-2*buffer_offset
      data_start(2) = 1
      data_count(2) = noy-2*buffer_offset
      data_start(3) = 1
      data_count(3) = nlays_in
c
c  ---- get the index for timestep containing this time ----
c
      this_date = ndate
      this_time = ttime
      this_tstep = ncf_get_tstep(iounit,action,
     &              ndate,ttime,this_time_tflag,this_time_etflag,
     &                                                       le1day,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  ---- loop over the list of emissions spcies ---
c
      do ispc=1,ntotsp
        this_var = ptname(ispc)
        ierr = nf_inq_varid(iounit, this_var, this_varid)
        if( ierr .NE. NF_NOERR) cycle
        ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emsgrd)
        if( ierr .NE. NF_NOERR) goto 7002
c
        do j=1+buffer_offset,nrow(igrid)-buffer_offset
          jtmp = j-buffer_offset
          do i=1+buffer_offset,ncol(igrid)-buffer_offset
            itmp = i-buffer_offset
            do k=1,nlays_in
c
c  --- convert to emissions time and put into array ---
c
                 emstmp = emsgrd(itmp,jtmp,k)/(60.*dtems)
                 emisrt(i,j,k,ispc) = emisrt(i,j,k,ispc) + emstmp
            enddo
c
c  --- next cell ---
c
          enddo
        enddo
c
c  --- next RTRAC emssions species ---
c
      enddo
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Number of layers does not match: '
      write(iout,'(A,I4)') 'User supplied: ',nlays_in
      write(iout,'(A,I4)') 'Value in file: ',nlay(igrid)
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine get_nptsrc_rt( )
      use filunit
      use ptemiss
      use tracer
      implicit none
c 
c----CAMx v7.40 260801
c 
c     GET_NPTSRC_RT loops over all of the elevated point source files 
c     for the source groups and calculates the total number of additonal
c     sources. This is to allocate the point source arrays appropriately.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        PNTPREP
c 
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----External functions
c
      integer istrln
c
c-----Local variables
c
      character*300 fname, action
      character*10  this_var
      integer       numpts, igroup, idxfile, num_ptsfiles, iounit
      integer       irec, ipt, ierr, this_dimid, this_varid
      integer       idxpt, idum
      real          tdummy
      logical       lbinary
c
c-----Entry point
c
c-----Allocate array for list of all points
c
c-----Loop over groups, group 0 is regular model
c
      numpts = 0
c
c-----Loop over groups, group 0 is regular model
c
      do igroup=1,ngroup
c
c-----Loop over number of files for this group
c
         num_ptsfiles = num_iortpt(igroup)
         do idxfile=1,num_ptsfiles
c
c-----Only continue if point source file is supplied
c
            if( .NOT. lptsrc ) goto 9999
c
c-----figure out how to deal with this file
c
            lbinary = .TRUE.
            if( .NOT. ltptfl(igroup,idxfile) ) cycle
            if( is_netcdf_iortpt(igroup,idxfile) ) lbinary = .FALSE.
            iounit = iortpt(igroup,idxfile)
            fname = tptfil(igroup,idxfile)
            write(action,'(2A)') 'Cannot read header of point source file: ',
     &                                                  fname(:istrln(fname))
c
c----process the binary file
c
            if( lbinary ) then
               rewind(iounit)
               do irec=1,4
                  read(iounit,ERR=7000)
               enddo
               read(iounit,ERR=7000) idum,numpts
               nptsrc_safile(igroup,idxfile) = numpts
               nptsrc = nptsrc + numpts
               if( nptsrc .GT.  MXPTSRC ) goto 7002
c
c-----this file is NetCDF format ---
c
            else
              ierr = nf_inq_dimid(iounit, "COL", this_dimid )
              if( ierr .NE. NF_NOERR ) goto 7001
              ierr = nf_inq_dimlen(iounit,this_dimid,numpts)
              if( ierr .NE. NF_NOERR ) goto 7001
              nptsrc_safile(igroup,idxfile) = numpts
              nptsrc = nptsrc + numpts
              if( nptsrc .GT.  MXPTSRC ) goto 7002
            endif
c
c-----if regular model inventory file just add to list ----
c
            nptsrc_safile(igroup,idxfile) = numpts
            if( numpts .GT.  MXPTSRC ) goto 7002
c
c----next file in this group
c
         enddo
c
c----next group
c
      enddo
c
      goto 9999
c
c---- error messages
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in GET_NPTSRC_RT:'
      write(iout,'(1X,2A)') action
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in GET_NPTSRC_RT'
      write(iout,'(A)') action
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in GET_NPTSRC_RT:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,*) 'Please change the value for parameter: ','MXPTSRC'
      write(iout,*) 'It should be set to a value of at least: ',nptsrc
      call flush(iout)
      call camxerr()
c
 9999 continue
      return
      end

C*** PIGCHMRT
c
      subroutine pigchmrt(pcell,tcell,oh,o3,no3,dtime,rtcon)
      use chmstry
      use rtracchm
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine performs IRON PiG chemistry adjustments on the reactive
c     tracer gasses using information from the host chemistry solution.  
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       pcell   R  cell pressure (mb)
c       tcell   R  cell temperature (K)
c       oh      R  OH radical concentration (ppm)
c       o3      R  ozone concentration (ppm)
c       no3     R  no3 radical concentration (ppm)
c       dtime   R  time step (hours)
c       rtcon   R  RTRAC concentration (ppm)
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    pcell
      real    tcell
      real    oh
      real    o3
      real    no3
      real    dtime
      real    rtcon(*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      real      factor
      real      prod
      real      rkoh
      real      rko3
      real      rkno3
      real      rkspc
      real      arrhen
c
      real drate(MXTRSP)
      real rtnew(MXTRSP)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- factor is a temp/press adjustment for second order
c     rate constants that were converted from cm3 molec-1 sec-1 to
c     ppm-1 min-1 at STP, also convert to per hour ---
c
      factor = (298.0/tcell)*(pcell/1013.) * 60.0
c
c --- calculate the total decay rate and any secondary production
c     rate for each tracer.  get host photolysis rates from rk in the
c     chmstry.inc include file ---
c
      do i=1,nrtgas
         if( jnum(i) .GT. 0 ) then
            rkspc = rk(jnum(i))
         else
            rkspc = 0.0
         endif 
         rkoh  = arrhen(aoh(i),eaoh(i),boh(i),troh(i),tcell) * factor
         rko3  = arrhen(ao3(i),eao3(i),bo3(i),tro3(i),tcell) * factor
         rkno3 = arrhen(ano3(i),eano3(i),bno3(i),trno3(i),tcell)
     &           * factor
         drate(i) = oh*rkoh + o3*rko3 + no3*rkno3 + rkspc*rtjfact(i)
         rtnew(i) = rtcon(i)*EXP(-drate(i)*dtime)
         rtnew(i) = AMAX1(rtlbnd(i),rtnew(i))
         if ( lsecnd(i) ) then
            prod = AMAX1(rtcon(ksec(i)) - rtnew(ksec(i)),0.0)
            rtnew(i) = rtnew(i) + prod
         endif
      enddo
c
      do i=1,nrtgas
         rtcon(i) = rtnew(i)
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

c**** NCF_GET_TSTEP
c
      function ncf_get_tstep(iounit,action,this_date,this_time,
     &         this_time_tflag,this_time_etflag,ignore_date,lstrict)
      use filunit
      implicit none
      integer ncf_get_tstep
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine retrieves the time step flags from the NetCDF file
c   and looks for a time span that encompasses the current data/time.
c   It returns the index in the time flag array.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         iounit            I NCF file ID
c         action            C string that describes file being read
c         this_date         I current model date (YYJJJ)
c         this_time         R current model time
c         this_time_tflag   R current model time
c         this_time_etflag  R current model time
c         ignore_date       L .FALSE. if not checking date
c         lstrict           L .TRUE. if must be strictly less than endtime
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit
      character*(*) action
      integer       this_date
      real          this_time
      real          this_time_tflag
      real          this_time_etflag
      logical       ignore_date
      logical       lstrict
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 this_var
      integer      tflag_varid, etflag_varid, this_tstep, tstep_in
      integer      data_start(3), data_count(3), nvars_in, ierr, i
      integer      tflag_first(2), tflag_last(2)
      integer      etflag_first(2), etflag_last(2)
      real         date_time, date_time_tflag, date_time_etflag
      logical      lread_ok
c
      integer,     allocatable, dimension(:,:) :: tflag_in
      integer,     allocatable, dimension(:,:) :: etflag_in
c
c-----------------------------------------------------------------------
c    Parameters:
c-----------------------------------------------------------------------
c
      real FUZZ
      parameter( FUZZ = 0.01 )
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- assume all variables are available ----
c
      lread_ok = .TRUE.
      ncf_get_tstep = -9
c
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'TSTEP', tstep_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NVARS', nvars_in)
      if( ierr .NE. NF_NOERR ) lread_ok = .FALSE.
      if( .NOT. lread_ok ) goto 7001
c
c  --- allocate the arrays for the time flags ---
c
      allocate( tflag_in(2,nvars_in))
      allocate( etflag_in(2,nvars_in))
c
c  --- calculate date/time together ---
c
      date_time = REAL(this_date)+this_time/2400.
c
c  --- get each time flag pair and check that 
c
      this_var = 'TFLAG'
      ierr = nf_inq_varid(iounit,this_var,tflag_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      this_var = 'ETFLAG'
      ierr = nf_inq_varid(iounit,this_var,etflag_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      data_start(1) = 1
      data_count(1) = 2
      data_start(2) = 1
      data_count(2) = nvars_in
      this_tstep = 0
 111  continue
      this_tstep = this_tstep + 1
      data_start(3) = this_tstep
      data_count(3) = 1
      ierr = nf_get_vara_int(iounit,tflag_varid,data_start,data_count,tflag_in)
      if( ierr .NE. NF_NOERR ) goto 222
      ierr = nf_get_vara_int(iounit,etflag_varid,data_start,data_count,etflag_in)
      if( ierr .NE. NF_NOERR ) goto 222
c
c  --- calculate date/time together ---
c
      if( ignore_date ) then
         date_time_tflag = REAL(this_date)+REAL(tflag_in(2,1))/240000.
         date_time_etflag = REAL(this_date)+REAL(etflag_in(2,1))/240000.
         if( etflag_in(2,1) .EQ. 0. ) date_time_etflag = date_time_etflag + 1.
      else
         if( MOD(tflag_in(1,1)/1000,100) .LE. 80 ) then
            date_time_tflag = REAL(tflag_in(1,1)-2000000)+REAL(tflag_in(2,1))/240000.
            date_time_etflag = REAL(etflag_in(1,1)-2000000)+REAL(etflag_in(2,1))/240000.
         else
            date_time_tflag = REAL(tflag_in(1,1)-1900000)+REAL(tflag_in(2,1))/240000.
            date_time_etflag = REAL(etflag_in(1,1)-1900000)+REAL(etflag_in(2,1))/240000.
         endif
      endif
      if( this_tstep .EQ. 1 ) then
          tflag_first(1) = tflag_in(1,1)
          tflag_first(2) = tflag_in(2,1)
          etflag_first(1) = etflag_in(1,1)
          etflag_first(2) = etflag_in(2,1)
      endif
      tflag_last(1) = tflag_in(1,1)
      tflag_last(2) = tflag_in(2,1)
      etflag_last(1) = etflag_in(1,1)
      etflag_last(2) = etflag_in(2,1)
c
c  --- check if this time period covers the beginning episode time ---
c
      if( lstrict ) then
          if( date_time .GE. date_time_tflag .AND. 
     &                        date_time .LT. date_time_etflag ) then
             ncf_get_tstep = this_tstep
             this_time_tflag = date_time_tflag
             this_time_etflag = date_time_etflag
             goto 9999
          endif
      else
          if( date_time .GE. date_time_tflag .AND. 
     &                        date_time .LE. date_time_etflag ) then
             ncf_get_tstep = this_tstep
             this_time_tflag = date_time_tflag
             this_time_etflag = date_time_etflag
             goto 9999
          endif
      endif
      goto 111
c
 222  continue
      write(iout,'(//,a)') 'ERROR in NCF_GET_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Did not find suitable timesteps in the file ',
     &                                     'for this time period.'
      write(iout,'(A,4I10)') 'First timestep: ',tflag_first(1), tflag_first(2),
     &                                        etflag_first(1), etflag_first(2)
      write(iout,'(A,4I10)') 'Last timestep : ',tflag_last(1), tflag_last(2),
     &                                        etflag_last(1), etflag_last(2)
      write(iout,'(2A)') 'Check that the file contains all hours ',
     &                                               'to be simulated.'
      call camxerr()
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_GET_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_GET_TSTEP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get global attributes for time span.',
     &                                                ' Looking for: '
      write(iout,'(10X,A)') 'TSTEP'
      write(iout,'(10X,A)') 'NVARS'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c**** RERCP
c
      subroutine rercp()
      use filunit
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads the receptor definition file and stores all of
c   the receptor data in common arrays to be used by the OSAT
c   version of the CAMx.
c
c      Copyright Ramboll
c
c     Argument description:
c      Inputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/27/96   --gwilson--    Original development
c     04/02/03   --gwilson--    Added grid number to recptors defined by
c                               cell index
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 line
      character*15  rcptmp
      integer       irec, ierr, idtmp, icl, jcl, icrs, jcrs
      integer       i
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- if the is no receptor file then just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
      irec = 0
      lwalls = .FALSE.
      nrecep = 0
c
c  --- open the file ---
c
      open(unit=iorrcp,file=rcpfil,ERR=7000,status='UNKNOWN')
c
c  --- read the data as character strings since we don't know what
c      type of receptor it is ---
c
  111 continue
      irec = irec + 1
      read(iorrcp,'(A)',IOSTAT=ierr,END=222) line
      if( ierr .NE. 0 ) then
         write(iout,'(//,a)') 'ERROR in RERCP:'
         write(iout,'(/,1X,2A,I5)') 'Reading the receptor ',
     &                    'definition file for OSAT at record: ',irec
         call camxerr()
      endif
c
c  ---- find out what kind of receptor is being provided ---
c
      rcptmp = line(1:15)
      if( rcptmp .EQ. CDPNT ) then
          idtmp = IDPNT
      else if( rcptmp .EQ. CDCEL ) then
          idtmp = IDCEL 
      else if( rcptmp .EQ. CDAVG ) then
          idtmp = IDAVG
      else if( rcptmp .EQ. CDWAL ) then
          idtmp = IDWAL
      else
          write(iout,'(//,a)') 'ERROR in RERCP:'
          write(iout,'(/,1X,4A)') 'Invalid receptor ',
     &        'code found in receptor definition file: ',
     &                               rcptmp(:istrln(rcptmp))
          write(iout,'(1X,2A)') 'Line read: ',line
          write(iout,'(1X,A)') 'Code must be one of the following:'
          write(iout,'(10X,A)') CDPNT
          write(iout,'(10X,A)') CDCEL
          write(iout,'(10X,A)') CDAVG
          write(iout,'(10X,A)') CDWAL
          call camxerr()
      endif
c
c   --- incrament counter and check for overflow ---
c
      nrecep = nrecep + 1
      if( nrecep .GT. MXRECP ) then
          write(iout,'(//,a)') 'ERROR in RERCP:'
          write(iout,'(/,1X,2A,I5)') 'Number of receptors in ',
     &              'receptor definition file exceeds maximum: ',MXRECP
          write(iout,'(1X,A)') 'Increase the paramater MXRECP.'
          call camxerr()
      endif
c
c   --- if it is a POINT type of receptor, just read the coordinates ---
c
      if( idtmp .EQ. IDPNT ) then
          idrcp(nrecep) = IDPNT
          rcpnam(nrecep) = line(21:30)
          read(line(31:50),'(2F10.0)',IOSTAT=ierr) recepx(nrecep), 
     &                                                   recepy(nrecep)
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Reading coordinates ',
     &                    'from receptor definition file.  Line read: '
             write(iout,'(A)') line
             call camxerr()
          endif
          if( recepy(nrecep) .GE. yorg ) then
              jcrs = FLOOR( (recepy(nrecep) - yorg) / 
     &                                   (deltay(1)/1000.0) ) + 1
          else 
              jcrs = -1
          endif
          if( jcrs .GT. 0 .AND. jcrs .LE. nycell(1) .AND. 
     &                               recepx(nrecep) .GE. xorg ) then
             icrs = FLOOR( (recepx(nrecep) - xorg) / 
     &                                   (deltax(jcrs,1)/1000.0) ) + 1
          else
              icrs = -1
          endif
          if( icrs .LE. 0 .OR. icrs .GT. nxcell(1)
     &                 .OR. jcrs .LE. 0 .OR. jcrs .GT. nycell(1) ) then
             write(iout,'(//,a)') 'WARNING in RERCP:'
             write(iout,'(1X,3A,F8.2,A,F8.2,A)')
     &                  'WARNING: Cell for receptor: ',rcpnam(nrecep),
     &                      'not in domain: (',
     &                       recepx(nrecep),',',recepy(nrecep),')'
             write(iout,'(1X,A)') '   Skipping receptor ...'
             nrecep = MAX0(0,nrecep-1)
             goto 111
          endif
c
c  --- find the grid in which this point is contained ---
c
          igrd = 1
          icl = icrs
          jcl = jcrs
          do ig = 2,ngrid
            if(icrs .GE. inst1(ig) .AND. icrs .LE. inst2(ig) .AND.
     &             jcrs .GE. jnst1(ig) .AND. jcrs .LE. jnst2(ig)) then
               xloctmp = (recepx(nrecep)-xorg) - (inst1(ig)-1)*delx
               yloctmp = (recepy(nrecep)-yorg) - (jnst1(ig)-1)*dely
               if( xloctmp .GT. 0. .AND. yloctmp .GT. 0. ) then
                  ii = 2 + FLOOR( xloctmp/delx * FLOAT( meshold(ig) ) )
                  jj = 2 + FLOOR( yloctmp/dely * FLOAT( meshold(ig) ) )
                  igrd = ig
                  icl = ii
                  jcl = jj
               endif
             endif
          enddo
          igrdrcp(nrecep) = igrd
          irecep(nrecep,1) = icl
          jrecep(nrecep,1) = jcl
      endif
c
c   --- if it is a SINGLE CELL type just read the cell indexes ---
c
      if( idtmp .EQ. IDCEL ) then
          idrcp(nrecep) = IDCEL
          rcpnam(nrecep) = line(21:30)
          nclrcp(nrecep) = 1
          read(line(31:60),'(3I10)',IOSTAT=ierr) igrdrcp(nrecep),
     &                            irecep(nrecep,1), jrecep(nrecep,1)
          if( ierr .NE. 0 ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Reading cell indexes ',
     &                      'from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A,/,A)') 'This version of CAMx requires',
     &           ' the grid number to be specified',' at each receptor.'
             call camxerr()
          endif
          igrd = igrdrcp(nrecep)
          if( igrd .LE. 0 .OR. igrd .GT. ngrid ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Invalid grid number read',
     &                     ' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A,/,A)') 'This version of CAMx requires',
     &           ' the grid number to be specified',' at each receptor.'
             call camxerr()
          endif
          if( jrecep(nrecep,1) .EQ. 0 ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Invalid cell indexes read',
     &                     ' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A,/,A)') 'This version of CAMx requires',
     &           ' the grid number to be specified',' at each receptor.'
             call camxerr()
          endif
          if(irecep(nrecep,1) .LE. 0 .OR. 
     &             irecep(nrecep,1).GT. nxcell(igrd) 
     &                     .OR. jrecep(nrecep,1) .LE. 0 .OR. 
     &                        jrecep(nrecep,1) .GT. nycell(igrd) ) then
             write(iout,'(//,a)') 'WARNING in RERCP:'
             write(iout,'(1X,3A,I5,A,I5,A)') 
     &                  'WARNING: Cell for receptor: ',rcpnam(nrecep),
     &                      'not in specified grid: (',
     &                       irecep(nrecep,1),',',jrecep(nrecep,1),')'
             write(iout,'(1X,A)') '   Skipping receptor ...'
             nrecep = MAX0(0,nrecep-1)
             goto 111
           endif
      endif
c
c   --- if it is a CELL AVERAGE type read the number of cells ---
c
      if( idtmp .EQ. IDAVG ) then
          idrcp(nrecep) = IDAVG
          rcpnam(nrecep) = line(21:30)
          read(line(31:50),'(2I10)',IOSTAT=ierr) igrdrcp(nrecep), 
     &                                              nclrcp(nrecep)
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Reading number of ',
     &               'cells from receptor definition file.  Line read:'
             write(iout,'(1X,2A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             write(iout,'(A)') line
             call camxerr()
          endif
          igrd = igrdrcp(nrecep)
          if( igrd .LE. 0 .OR. igrd .GT. ngrid ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Invalid grid number read',
     &                     ' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             call camxerr()
          endif
          if( nclrcp(nrecep) .LE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,I5)') 'Number of cells in ',
     &                        ' receptor definition file is invalid.'
             write(iout,'(1X,A,A)') 'Line read: ',line
             write(iout,'(1X,2A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             call camxerr()
          endif
          if( nclrcp(nrecep) .GT. MXCELR ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,I5)') 'Number of cells in ',
     &             ' receptor definition file exceeds maximum: ',MXCELR
             write(iout,'(1X,A,A)') 'Line read: ',line
             write(iout,'(1X,A)') 'Increase the paramater MXCELR.'
             call camxerr()
          endif
          do 10 i=1,nclrcp(nrecep)
              irec = irec + 1
              read(iorrcp,'(A)',IOSTAT=ierr) line
              if( ierr .NE. 0 ) then
                 write(iout,'(//,a)') 'ERROR in RERCP:'
                 write(iout,'(/,1X,A,A,I5)') 'Reading the ',
     &                      'receptor definition file at record: ',irec
                 call camxerr()
              endif
              read(line,'(2I10)',IOSTAT=ierr) irecep(nrecep,i), 
     &                                                jrecep(nrecep,i)
              if( ierr .NE. 0 ) then
                 write(iout,'(//,a)') 'ERROR in RERCP:'
                 write(iout,'(/,1X,A,A,A)') 'Reading cell ',
     &              'indexes from receptor definition file.  Line read:'
                 write(iout,'(A)') line
                 call camxerr()
              endif
              if( irecep(nrecep,i) .LE. 0 .OR. 
     &                 irecep(nrecep,i) .GT. nxcell(igrd) 
     &                     .OR. jrecep(nrecep,i) .LE. 0 .OR. 
     &                         jrecep(nrecep,i) .GT. nycell(igrd) ) then
                 write(iout,'(//,a)') 'WARNING in RERCP:'
                 write(iout,'(1X,3A,I5,A,I5,A)') 
     &                  'WARNING: Cell for receptor: ',rcpnam(nrecep),
     &                      'not in grid: (',
     &                       irecep(nrecep,i),',',jrecep(nrecep,i),')'
                 write(iout,'(1X,A)') '   Skipping receptor ...'
                 nrecep = MAX0(0,nrecep-1)
                 goto 111
               endif
   10     continue
      endif
c
c   --- if it is a WALL OF CELLS type read the extent in each direction ---
c
      if( idtmp .EQ. IDWAL ) then
          idrcp(nrecep) = IDWAL
          rcpnam(nrecep) = line(21:30)
          nclrcp(nrecep) = 1
          lwalls = .TRUE.
c
c   --- read the column indexes ---
c
          read(line(31:60),'(3I10)',IOSTAT=ierr) igrdrcp(nrecep), 
     &                                  iwalbg(nrecep), iwalnd(nrecep)
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,A)') 
     &            'Reading column indexes of ',
     &             CDWAL,' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             call camxerr()
          endif
          igrd = igrdrcp(nrecep)
          if( igrd .LE. 0 .OR. igrd .GT. ngrid ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Invalid grid number read',
     &                     ' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,2A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             call camxerr()
          endif
          if( iwalnd(nrecep) .EQ. 0 ) then
             write(iout,'(//,A)') 'ERROR in RERCP:'
             write(iout,'(/,1X,3A)') 'Invalid cell indexes read',
     &                     ' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             write(iout,'(1X,A)') 'This version of CAMx requires the',
     &                  ' grid number to be specified at each receptor.'
             call camxerr()
          endif
          if( iwalbg(nrecep) .LE. 0 .OR. 
     &                 iwalnd(nrecep) .GT. nxcell(igrd) ) then
            write(iout,'(//,a)') 'WARNING in RERCP:'
            write(iout,'(1X,3A,I5,A,I5,A)') 
     &         'WARNING: Columns for receptor: ',rcpnam(nrecep),
     &         ' not in domain: (',iwalbg(nrecep),',',iwalnd(nrecep),')'
            write(iout,'(1X,A)') '   Skipping receptor ...'
            nrecep = MAX0(0,nrecep-1)
            goto 111
          endif
c
c   --- read the row indexes ---
c
          irec = irec + 1
          read(iorrcp,'(A)',IOSTAT=ierr) line
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,I5)') 'Reading the ',
     &                      'receptor definition file at record: ',irec
             call camxerr()
          endif
          read(line(41:60),'(2I10)',IOSTAT=ierr) jwalbg(nrecep), 
     &                                                 jwalnd(nrecep)
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,A)') 'Reading row indexes of ',
     &             CDWAL,' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             call camxerr()
          endif
          if( jwalbg(nrecep) .LE. 0 .OR. 
     &                 jwalnd(nrecep) .GT. nycell(igrd) ) then
            write(iout,'(//,a)') 'WARNING in RERCP:'
            write(iout,'(1X,3A,I5,A,I5,A)') 
     &         'WARNING: Rows for receptor: ',rcpnam(nrecep),
     &         ' not in domain: (',jwalbg(nrecep),',',jwalnd(nrecep),')'
            write(iout,'(1X,A)') '   Skipping receptor ...'
            nrecep = MAX0(0,nrecep-1)
            goto 111
          endif
c
c   --- read the layer indexes ---
c
          irec = irec + 1
          read(iorrcp,'(A)',IOSTAT=ierr) line
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,I5)') 'Reading the ',
     &                      'receptor definition file at record: ',irec
             call camxerr()
          endif
          read(line(41:60),'(2I10)',IOSTAT=ierr) kwalbg(nrecep), 
     &                                                 kwalnd(nrecep)
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RERCP:'
             write(iout,'(/,1X,A,A,A)') 'Reading layer indexes of ',
     &             CDWAL,' from receptor definition file.  Line read:'
             write(iout,'(A)') line
             call camxerr()
          endif
          if( kwalbg(nrecep) .LE. 0 .OR. 
     &                 kwalnd(nrecep) .GT. nlay(igrd) ) then
            write(iout,'(//,a)') 'WARNING in RERCP:'
            write(iout,'(1X,3A,I5,A,I5,A)') 
     &         'WARNING: Layers for receptor: ',rcpnam(nrecep),
     &         ' not in domain: (',kwalbg(nrecep),',',kwalnd(nrecep),')'
            write(iout,'(1X,A)') '   Skipping receptor ...'
            nrecep = MAX0(0,nrecep-1)
            goto 111
          endif
       endif
c      
c  --- get next record ---
c
      goto 111
c      
c  --- close file and return to calling routine ---
c
  222 continue
      close(iorrcp)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RERCP:'
      write(iout,'(/,1X,2A)') 'Cannot open input file: ',
     &                                          rcpfil(:istrln(rcpfil))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine nodes_irr_update(numprocs,iproc_id,numcells,numreact)
      use procan
      use filunit
      implicit none
c
c
c----CAMx v7.40 260801
c
c     This routine will pass the cirr data for Process Analysis
c     from the compute nodes, where it is calculated to the master
c     where it will be written to the output file. The data can be
c     summed over all compute nodes because it will be zero in a PA
c     cell outside of the computational slice. This routine will be
c     called at each output time.
c
c      Copyright Ramboll
c
c     Modifications:
c
c     Input arguments:
c        numprocs            the number of processes
c        iproc_id            the process ID for this processor
c        numcells            then number of total Process Aanalysis cells
c        numreact            then number of total Process Aanalysis reactions
c
c     Output arguments:
c        none
c
c     Routines called:
c     
c     Called by:
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c     
c-----Argmument declarations
c
      integer numprocs
      integer iproc_id
      integer numcells
      integer numreact
c     
c-----Local variables
c
      integer icl, irxn
      integer nbytes, ierr, status(MPI_STATUS_SIZE), i
      real    tmp_cirr(numcells,numreact)
c     
c-----Entry point
c
      if( .NOT. lmpi ) return
c
c  --- calculate the  number of values ---
c
      nbytes = numcells * numreact
c
c  --- process ID zero recieves data into temp array ---
c
      if( iproc_id .EQ. 0 ) then
         do icl=1,numcells
           do irxn=1,numreact
             cirr(icl,irxn) = 0.
           enddo
         enddo
         do i=1,numprocs 
            call MPI_RECV( tmp_cirr, nbytes, MPI_REAL, i, itag,
     &                                 MPI_COMM_WORLD, status, ierr)
            do icl=1,numcells
               do irxn=1,numreact
                   cirr(icl,irxn) = cirr(icl,irxn) +
     &                                       tmp_cirr(icl,irxn)
               enddo 
            enddo 
         enddo
c
c  --- if this is a compute process, send the global array ---
c
      else
         call MPI_SEND( cirr, nbytes, MPI_REAL, 0, itag,
     &                                      MPI_COMM_WORLD, ierr)
      endif
c
c  --- return to the calling routine ---
c
      itag = itag + 1
      end

c*** YFLUXSA
c
      subroutine yfluxsa(numcol,numrow,numlay,nspc,saconc,icell,
     &                     jclbeg,jclend,kcell,area,av1d,fluxcls,cnccls)
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine updates the tracer concentrations arrays in the
c     common block variables by applying the appropriate flux value
c     calculated from the regular model transport routine.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol   I  number of columns in the grid
c       numrow   I  number of rows in the grid
c       numlay   I  number of layers in the grid
c       nspc     I  number of species
c       saconc   R  3-D concentration arrays
c       icell    I  cell index in the X direction
c       jclbeg   I  beginning cell in the Y direction
c       jclend   I  ending cell in the Y direction
c       kcell    I  the vertical grid location of current layer
c       area     R  area adjustment vector
c       av1d     R  interfacial area adjustment vector
c       fluxcls  R  flux for each tracer class
c       cnccls   R  regular model concentration for each tracer class
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     10/02/98   --gwilson--  Orignal development
c     10/30/01   --cemery--   Added map scale factor to flux div
c                             calculation 
c     11/04/03   --cemery--   Revised to parallel changes to reg model
c                             advection
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer     numcol
      integer     numrow
      integer     numlay
      integer     nspc
      real        saconc(numcol,numrow,numlay,nspc)
      integer     icell
      integer     jclbeg
      integer     jclend
      integer     kcell
      real        area(*),av1d(*)
      real        fluxcls(MXTRCLS,*)
      real        cnccls(MXTRCLS,*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i1d, ispc
c
      real flux(MXCELLS)
      real cnctmp(MXCELLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over all tracer classes ---
c
      do icls=1,ntrcls
c
c   --- loop over all tracer classes ---
c
          do ispc=iptcls(icls),nptcls(icls)
c
c   --- make sure all values are above lower bound, to start ----
c
            do jcel=jclbeg,jclend
              saconc(icell,jcel,kcell,ispc) =
     &                      AMAX1(saconc(icell,jcel,kcell,ispc),BNDLPT)
            enddo
c
c   --- normalize the flux on the boundary ---
c
            i1d = 1
            if( fluxcls(icls,i1d) .GE. 0 ) then
               flux(i1d) = saconc(icell,jclbeg-1,kcell,ispc) * 
     &                            fluxcls(icls,i1d) / cnccls(icls,i1d)
            else
               flux(i1d) = saconc(icell,jclbeg,kcell,ispc) * 
     &                          fluxcls(icls,i1d) / cnccls(icls,i1d+1)
            endif
c
c   --- loop over all interior cells in this row ---
c
            do jcel=jclbeg,jclend
              i1d = i1d + 1 
c
c   ---  apply flux to the tracer species ---
c
              if ( fluxcls(icls,i1d) .GE. 0. ) then
                 flux(i1d) = saconc(icell,jcel,kcell,ispc) *
     &                            fluxcls(icls,i1d) / cnccls(icls,i1d)
              else
                 flux(i1d) = saconc(icell,jcel+1,kcell,ispc) *
     &                          fluxcls(icls,i1d) / cnccls(icls,i1d+1)
              endif
              cnctmp(i1d) = saconc(icell,jcel,kcell,ispc) - 
     &         area(i1d)*(av1d(i1d)*flux(i1d) - av1d(i1d-1)*flux(i1d-1))
            enddo
c
c  --- put new concentrations back into 3-D array ---
c
            i1d = 1
            do jcel=jclbeg,jclend
              i1d = i1d + 1
              saconc(icell,jcel,kcell,ispc) = AMAX1(cnctmp(i1d),BNDLPT)
            enddo
          enddo
c
c   --- next tracer class 
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine readpht
      use filunit
      use chmstry
      use o3colmap
      implicit none
c
c----CAMx v7.40 260801
c
c     RDPHOT reads photolysis reaction rates as a function
c     of NZEN zenith angles, NHGHT altitudes above ground, NTRN terrain
c     height classes, NALB surface albedo classes, and NOZN ozone column
c     classes. Dimensions for all five of these parameters are set in the 
c     Inc/CAMx.prm file.
c
c      Copyright Ramboll
c
c     Modifications:
c        11/30/04      Revised to read altitude from file, instead
c                      of relying on data statement of heights
c        04/02/12      Removed RADM cloud adjustment option, cloud/aerosol
c                      adjustments now always done with in-line TUV; AHO
c                      file is now just ozone column; replaced haze
c                      dimension with terrain height in photo file
c        11/17/20      Moved definition of TUV photolysis file labels to
c                      READCHM.F
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Routines called:
c        none
c
c     Called by:
c        STARTUP
c
      include 'camx.prm'
      include 'flags.inc'
c
      character*80 record
      real         tmp3(3)
      integer      line, iozn, ialb, itrn, kount
      integer      i, k, k1, ihght, irxn, izen
c
c-----Entry Point
c
c-----Read photolysis rates for the primary photolysis reactions
c     declared in the CHEMPARAM file.
c       NPHOT1 is the number of primary photolysis reactions
c
c     The zenith angles are set in CHEMDAT
c
      line = 1
      read(iphot,'(a)',err=7000,end=7001) record
      if (record(1:20).ne.tuvlabl(idmech)) goto 7004

      do iozn = 1,NOZN
        do ialb = 1,NALB
          do itrn = 1,NTRN
            line = line + 1
            read(iphot,'(a)',err=7000,end=7001) record
            kount = 0
            k1 = 1
            do 10 k=k1,80
              if (kount.eq.3) goto 11
              if(record(k:k).eq.'=') then
                kount = kount + 1
                k1 = k + 1
                read(record(k1:80),*,err=7002) tmp3(kount)
                goto 10
              endif                
  10        continue
  11        continue
            if (kount.ne.3) goto 7003
            ozcl(iozn) = tmp3(1)
            albcl(ialb) = tmp3(2)
            trncl(itrn) = tmp3(3)
            if (ozcl(iozn).lt.250. or. ozcl(iozn).gt.600.) goto 7005
c
            do ihght = 1,NHGHT
              line = line + 1
              read(iphot,*,err=7000,end=7001) htint(ihght)
              do irxn = 1,nphot1
                line = line + 1
                read(iphot,'(1x,10f12.0)',err=7000,end=7001) 
     &              (prkn(izen,irxn,ihght,itrn,ialb,iozn),izen=1,NZEN)
              enddo
            enddo
          enddo
        enddo
      enddo
c
c-----Echo photolysis dimensions
c
      write(idiag,'(/,a)') 'Completed reading Photolysis file'
      write(idiag,'(a15,99f7.0)') 'Ozone classes :',(ozcl(i),i=1,NOZN)
      write(idiag,'(a15,99f7.3)') 'Albedo classes:',(albcl(i),i=1,NALB)
      write(idiag,'(a15,99f7.3)') 'Trn Ht classes:',(trncl(i),i=1,NTRN)
      write(idiag,'(a15,99f7.3)') 'Altitudes (km):',(htint(i),i=1,NHGHT)
      write(idiag,'(a15,99f7.3)') 'Zenith angles :',(zenint(i),i=1,NZEN)
      write(idiag,'(//)')
c
c-----Convert rates from per min to per hour
c
      do iozn = 1,NOZN
        do ialb = 1,NALB
          do itrn = 1,NTRN
            do ihght = 1,NHGHT
              do irxn = 1,nphot1
                do izen=1,NZEN
                  prkn(izen,irxn,ihght,itrn,ialb,iozn) =
     &            prkn(izen,irxn,ihght,itrn,ialb,iozn)*60.
                enddo
              enddo
            enddo
          enddo
        enddo
      enddo
c
      close(iphot)
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,2A,i5)') ' ERROR: Reading photolysis rates',
     &                  ' file at line: ', line
      write(iout,'(/,2A)') ' Does the rate file have the correct',
     &                 ' number of reactions?'
      write(iout,'(/,2A)') ' Make sure the photolysis rate file ',
     &                 'matches the mechanism you are running.'
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,A,/,A,i5)') ' ERROR: Reading photolysis rates',
     &                  ' End of file at line: ', line
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,A,/,A,i5,/,A)') 
     &            ' ERROR: Reading photolysis rates',
     &                  ' Reading header record at line: ', line,
     &                       record
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,A,/,A,i5,/,A)') 
     &            ' ERROR: Reading photolysis rates',
     &                  ' Reading header record at line: ', line,
     &                       record
      write(iout,*)'Did not find three = signs in header. Found ',kount
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,A,/,A,i5,/,A)') 
     &            ' ERROR: Reading photolysis rates',
     &                  ' Reading header record at line: ', line
      write(iout,'(/,a)') ' Photolysis label record is INVALID'
      write(iout,'(a,a)') '   Expecting: ',tuvlabl(idmech)
      write(iout,'(a,a)') '       Found: ',record(1:20)
      write(iout,'(2a,/,a)') ' Make sure you are using the correct ',
     &                       'version of the TUV processor for this',
     &                    ' version of CAMx and chemistry mechanism.'
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in READPHT:'
      write(iout,'(/,a)') ' Ozone Column is outside a reasonable range'
      write(iout,'(a,a)') '       Found: ',ozcl(iozn)
      write(iout,'(a,a)') ' Expecting Dobson Units between 250-600'
      write(iout,'(2a,/,a)') ' Make sure you are using the correct ',
     &                       'version of the TUV processor for this',
     &                    ' version of CAMx and chemistry mechanism.'
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine wrtiprhdr(ibgdat,btime,iendat,etime)
      use filunit
      use grid
      use chmstry
      use camxcom
      use procan
c
c----CAMx v7.40 260801
c
c     This routine writes the header to the output file for the Integrated
c     Process Rates (IPR) data for the Process Analysis algorithm.  The header 
c     data is designed to provide information about what data is contained
c     in the rest of the file.
c
c      Copyright Ramboll
c
c     Modifications:
c        11/06/01  Input dates are now Julian
c
c     Input arguments:
c        btime      ending time for this period
c        ibgdat     ending date for this period (YYJJJ)
c        etime      ending time for this period
c        iendat     ending date for this period (YYJJJ)
c
c     Subroutines Called:
c
c
c     Called by:
c        STARTUP
c
      include "camx.prm"
c
c-----Argument declarations
c
      integer ibgdat
      real    btime 
      integer iendat
      real    etime 
c
c-----Local variables
c
      character*25 prcnam(NPAPRC)
      character*10 iprname(MXSPEC)
      integer      niprspc
c
c-----Entry point
c
c  --- load process names into local array ---
c
      prcnam(IPR_INIT)    = 'Initial concentration    '
      prcnam(IPR_CHEM)    = 'Gas-phase chemistry      '
      prcnam(IPR_AEMIS)   = 'Area emissions           '
      prcnam(IPR_PTEMIS)  = 'Point source emissions   '
      prcnam(IPR_PIGEMIS) = 'Plume-in-Grid change     '
      prcnam(IPR_WADV)    = 'West boundary advection  '
      prcnam(IPR_EADV)    = 'East boundary advection  '
      prcnam(IPR_SADV)    = 'South boundary advection '
      prcnam(IPR_NADV)    = 'North boundary advection '
      prcnam(IPR_BADV)    = 'Bottom boundary advection'
      prcnam(IPR_TADV)    = 'Top boundary advection   '
      prcnam(IPR_DADV)    = 'Dilution in the vertical '
      prcnam(IPR_WDIF)    = 'West boundary diffusion  '
      prcnam(IPR_EDIF)    = 'East boundary diffusion  '
      prcnam(IPR_SDIF)    = 'South boundary diffusion '
      prcnam(IPR_NDIF)    = 'North boundary diffusion '
      prcnam(IPR_BDIF)    = 'Bottom boundary diffusion'
      prcnam(IPR_TDIF)    = 'Top boundary diffusion   '
      prcnam(IPR_DDEP)    = 'Dry deposition           '
      prcnam(IPR_WDEP)    = 'Wet deposition           '
      prcnam(IPR_IAERO)   = 'Inorganic aerosol chem   '
      prcnam(IPR_OAERO)   = 'Organic aerosol chem     '
      prcnam(IPR_AQCHEM)  = 'Aqueous chemistry        '
      prcnam(IPR_FINAL)   = 'Final concentration      '
      prcnam(IPR_CONV)    = 'Units conversion         '
      prcnam(IPR_VOL)     = 'Average cell volume      '
c
c --- fill name array with only non-radical species ---
c
      niprspc = 0
      do ispc=1,navspc
        if( lavmap(ispc) .GT. nrad ) then
           niprspc = niprspc + 1 
           iprname(niprspc) = spname(lavmap(ispc))
        endif
      enddo
c
c --- write the date and time of the simulation ---
c
      write(ipr_unit,ERR=7000) runmsg
      write(ipr_unit,ERR=7000) ibgdat, btime, iendat, etime 
c
c --- write the information about the grids ---
c
      write(ipr_unit,ERR=7000) ngrid
      write(ipr_unit,ERR=7000) xorg, yorg, ncol(1), nrow(1), delx, dely
      do igrd=2,ngrid
        xsize = delx / FLOAT( meshold(igrd) )
        ysize = dely / FLOAT( meshold(igrd) )
        orgx = (inst1(igrd)-1)*delx + xorg - xsize
        orgy = (jnst1(igrd)-1)*dely + yorg - ysize
        write(ipr_unit,ERR=7000) orgx, orgy, ncol(igrd), nrow(igrd), 
     &                                                    xsize, ysize
      enddo
c
c --- write the species output to file ---
c
      write(ipr_unit,ERR=7000) niprspc
      do ispc=1,niprspc
         write(ipr_unit,ERR=7000) iprname(ispc)
      enddo
c
c --- write out the sub-domain information ---
c
      write(ipr_unit,ERR=7000) npadom
      do idom=1,npadom
         write(ipr_unit,ERR=7000) ipagrd(idom), i_sw(idom), i_ne(idom),
     &                  j_sw(idom), j_ne(idom), b_lay(idom), t_lay(idom)
      enddo
c
c  ---- write the descriptions of the processes ---
c
      write(ipr_unit,ERR=7000) NPAPRC
      do i=1,NPAPRC
         write(ipr_unit,ERR=7000) prcnam(i)
      enddo
c
      goto 9999
c
c----Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in WRTIPRHDR:'
      write(iout,'(1X,2A)',ERR=9999) 'Writing header to the output ',
     &                         'Integrated Process Rate (.ipr) file.'
      call camxerr()
c
 9999 continue
      return
      end

c***** RDPTRT.F
c
      subroutine rdptrt(ndate,ttime)
      use filunit
      use grid
      use chmstry
      use ptemiss
      use bndary
      use camxcom
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the RTRAC process
c   and fills the approproate arrays.  The emissions file for one grid
c   but each emissions groups is read.
c    Argument descriptions:
c     Outputs:
c     Inputs:
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/24/01   --gwilson--   Originial development
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer ndate
      real    ttime
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  cname
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, idx, iseg
      integer       i, j, ispc
      integer       icel, jcel, npoint, idum, imod
      real          bgtim, edtim, xloctmp, yloctmp
      real          emstmp
      logical       lfound, lpass
c
      real emspnt(MXPTSRC), effph_in(MXPTSRC), flowrat_in(MXPTSRC)
c
      common /rtptdat/ emspnt, effph_in, flowrat_in
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c   --- skip if filename not supplied ---
c
      if( is_netcdf_iortpt(1,1) .OR. .NOT. ltptfl(1,1) 
     &                          .OR. .NOT. lptsrc ) goto 9999
c
c  --- initialize emissions to zero ---
c
      do i = 1,nptsrc
        do j = 1,ntotsp
         sapnts(i,j) = 0.
        enddo
      enddo
c
c   --- set the unit number for surface emissions file ---
c
      iounit = iortpt(1,1)
      fname = tptfil(1,1)
c
c   --- read the date and time, again ---
c
      lfound = .FALSE.
      lpass = .FALSE.
  111 continue
      read(iounit,END=222) ibgdat, bgtim, iendat, edtim
      bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
      edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c

      read(iounit,ERR=7000,END=7001) iseg, npoint
      if( npoint .GT. nptsrc ) goto 7002
      read(iounit,ERR=7000,END=7001) (idum, idum,
     &                idum, flowrat_in(i), effph_in(i),i=1,npoint)
      do i=1,npoint
        if(flowrat_in(i) .LT. 0. .AND. effph_in(i) .LT. 0. ) then
           if( ABS(effph_in(i)) .LT. ABS(flowrat_in(i)) ) then
              write(iout,'(//,a)')'ERROR in READPT:'
              write(iout,*) 'Invalid values found for flow rate and plume height.'
              write(iout,*) 'The plume distribution override is triggered. But the '
              write(iout,*) 'value for flow rate (base) is larger than value for ',
     &                   'plume height (top).'
              call camxerr()
           endif
        endif
        idxbase = idx_point_in_list(1,1,i)
        effph(idxbase) = effph_in(i)
        flowrat(idxbase) = flowrat_in(i)
      enddo
c
      do 20 ispc = 1,nspcpt(1,1)
        read(iounit,ERR=7000) iseg, (iname(i),i=1,10), 
     &                              (emspnt(i),i=1,npoint)
        write(cname,'(10A1)') iname
c
c   --- if date and time does not match this hour, skip this record ---
c
        if( le1day ) then
           if( abs(bgtim-ttime).ge.0.01 ) goto 20
        else
           if( ndate .NE. ibgdat .OR. abs(bgtim-ttime).ge.0.01 ) goto 20
        endif
        lfound  = .TRUE.
c
c   --- if the species is not modelled or not used for RTRAC ----
c
        idx = idxpts(1,1,ispc)
        if( idx .LE. 0 ) goto 20
c
c  --- find this species in the modeled species list ---
c
        do imod = 1,nrtrac
          if( cname .EQ. ptname(imod) ) then
             do 30 i = 1,npoint
               idxbase = idx_point_in_list(1,1,i)
               if( llatlon ) then
                  xloctmp = xlocpt(i) - xorg
                  yloctmp = ylocpt(i) - yorg
               else
                  xloctmp = xlocpt(i)/1000. - xorg
                  yloctmp = ylocpt(i)/1000. - yorg
               endif
               icel = 1 + FLOOR( xloctmp/delx )
               jcel = 1 + FLOOR( yloctmp/dely )
               if( icel .LT. 1 .OR. icel .GT. ncol(1) ) goto 30
               if( jcel .LT. 1 .OR. jcel .GT. nrow(1) ) goto 30
c
c  --- convert to emissions time and put into array ---
c
               emstmp = emspnt(i)/(60.*dtems)
               if( emstmp .GT. rtlbnd(imod) ) sapnts(idxbase,imod) = emstmp
c
c  --- next point ---
c
   30        continue
             goto 20
          endif
c
c  --- next RTRAC emssions species ---
c
        enddo
c
c  --- if not found in model species list, write a message ----     
c   
        write(idiag,'(1X,4A)') 'Species in RTRAC ',
     &            'point source file: ',cname(:istrln(cname)),
     &            ' not found in species list ... Skipping.'
c
c   --- next species ---
c
  20  continue
c
c   --- if the correct hour has not been found, 
c       go back and read some more else read next file ---
c
      if( .NOT. lfound ) then
         goto 111
      else
         goto 9999
      endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222 continue
      if( le1day ) then
          rewind(iounit)
          read(iounit)
          read(iounit)
          read(iounit)
          read(iounit)
          read(iounit)
          read(iounit)
          if( lpass ) goto 7001
          if( .NOT. lpass ) lpass = .TRUE.
          goto 111
      else
          goto 7001
      endif
c
c  --- get the next file ---
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in RDPTRT:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 'ERROR: Reading emissions ',
     &    'after hour ',ibgdat, bgtim,' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in RDPTRT:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)')
     &              'ERROR: Premature end-of-file',
     &              ' in point source file after hour ',ibgdat, bgtim,
     &                                ' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDPTGRP:'
      write(iout,'(/,1X,A,I10,2A)') 'Number of points: ',npoint,
     &     ' is not consistent with regular emissions in file: ',
     &                                            fname(:istrln(fname))
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      function xerf(x)
c
c     Returns the complementary error function erfc(x) with fractional error
c     everywhere less than 1.2e-7 (Numerical Recipes in Fortran, 2nd Ed., 1992)
c
c     modified by bkoo to return the error function erf(x) - (11/14/03)
c
      real xerf
      real erfcc,x
      real t,z
      z=abs(x)
      t=1./(1.+0.5*z)
      erfcc=t*exp(-z*z-1.26551223+t*(1.00002368+t*(.37409196+
     1     t*(.09678418+t*(-.18628806+t*(.27886807+t*(-1.13520398+
     2     t*(1.48851587+t*(-.82215223+t*.17087277)))))))))
      if (x.lt.0.) erfcc=2.-erfcc

      xerf = 1.-erfcc ! return erf(x)

      return
      end

      subroutine piggrow(n,nz,kpuff,dt,xlen,areamx,ztop,wind,temp1,
     &                   temp0,press1,press0,rkv,depth,z0,hshear,
     &                   vshear,pufang,shrang,delms,ldump)
      use pigsty
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGGROW performs the following functions:
c       (1) grows puffs
c       (2) calculates the mass to dump if horizontal growth restricted
c
c      Copyright Ramboll
c
c     Modifications:
c        1/10/06         Small modification to vertical puff growth limiting
c                        in stable conditions
c        06/17/09        Restructured puff sigmas to improve impacts of
c                        vertical directional shear on puff growth
c
c     Input arguments:
c        n                   puff index
c        nz                  number of grid layers
c        kpuff               layer index in which puff resides
c        dt                  time step (s)
c        xlen                puff length (m)
c        areamx              maximum horizontal area allowed (m2)
c        ztop                model top height (m)
c        wind                layer 1 wind (m/s)
c        temp1               layer 1 temperature (K)
c        temp0               surface temperature (K)
c        press1              layer 1 pressure (mb)
c        press0              surface pressure (mb)
c        temp0               surface temperature (K)
c        rkv                 vertical diffusivity profile (m2/s)
c        depth               layer depth profile (m)
c        z0                  surface roughness (m)
c        hshear              grid-resolved horz shear of horz wind (1/s)
c        vshear              grid-resolved vert shear of horz wind (1/s)
c        pufang              puff directional angle (rad)
c        shrang              shear directional angle (rad)

c
c     Output arguments:
c        delms               mass fraction to dump for all species 
c        ldump               switch is set on if leakage has occurred
c
c     Subroutines called:
c        MICROMET
c        SIGGROW
c
c     Called by:
c        PIGDRIVE
c 
      include "camx.prm"
c
      logical ldump,lstable
      integer n,nz,k,kpbl,kpuff
      real dt,areamx,wind,delms,ztop,temp1,temp0,press1,press0,
     &     hshear,vshear,pufang,shrang
      real rkv(nz),depth(nz),z0

      real sigzold,sigyold,fmsold,alimit,relsiz,
     &     pbl,zf,critk,ustar,wstar,psih,rkvavg,xlen,
     &     axisx,pufscl,pi,aa,bb,cc,dzbot,dztop,el
c
      data pi /3.1415927/
c
c-----Entry point
c
c-----Check for phantom puff
c
      if (fmspig(n).le.0.) then
        ingrd(n) = 0
        return
      endif
c
      delms   = 0.
      fmsold  = fmspig(n)
      sigyold = sigy(n)
      sigzold = sigz(n)
c
c-----Get the PBL parameters
c
      kpbl = 1
      pbl = depth(1)
      do k = 2,nz
        if (kpbl.ne.k-1) goto 102
        zf = depth(k)/depth(k-1)
        critk = 0.03*depth(k-1)*depth(k-1)*(1. + zf)/200.
        if (rkv(k-1).gt.critk) then
          kpbl = k
          pbl = pbl + depth(k)
        endif
      enddo
 102  continue

      call micromet(temp1,temp0,press1,press0,depth(1)/2.,wind,z0,pbl,
     &              ustar,el,psih,wstar,lstable)
c
c-----Grow puff spread
c
      rkvavg = rkv(kpuff) 
      if (kpuff.gt.1) rkvavg = (rkv(kpuff) + rkv(kpuff-1))/2.
      call siggrow(dt,zpig(n),pbl,ustar,wstar,lstable,rkvavg,
     &             htfms(n),htfmb(n),vtfms(n),vtfmb(n),SHRFLG,hshear,
     &             vshear,pufang,shrang,sigy(n),sigx(n),sigz(n))
c
c-----Set vertical extent of puff; limit puff bottom to zero (ground),
c     and limit puff top to model top or to zero growth if puff extends
c     above PBL depth
c
      dzbot = (zpig(n) - puffbot(n))*sigz(n)/sigzold
      dztop = (pufftop(n) - zpig(n))*sigz(n)/sigzold

      puffbot(n) = amax1(0.,zpig(n) - dzbot)
      if (lstable .or. kpbl.eq.1 .or. pufftop(n).lt.pbl) then
        pufftop(n) = zpig(n) + dztop
        if (.not.lstable .and. kpbl.gt.1 .and. pufftop(n).gt.pbl)
     &     pufftop(n) = pbl
      endif
      pufftop(n) = amin1(ztop,pufftop(n))
      zpig(n) = (pufftop(n) + puffbot(n))/2.
      axisz(n) = pufftop(n) - puffbot(n)
      axisy(n) = axisy(n)*sigy(n)/sigyold
c
c-----Skip dumping for new puffs
c
      if (lnewg(n)) goto 900
c
c-----Limit puff horizontal dimensions by FLEAK*AREAMX
c     Dump excess fraction due to expansion in this time step
c     (FLEAK is set in the .prm file)
c
      alimit = FLEAK*areamx
      axisx = xlen + 3.*sigx(n)
      pufscl = pi*(axisx/2.)*(1.5*sigy(n))
      if (LEAKON .and. pufscl.gt.alimit) then
        relsiz = alimit/pufscl
        fmspig(n) = amin1(fmsold,relsiz)
      endif
c
c-----Artificially shrink puffs older than AGEMAX so that 10% of puff mass
c     is released each timestep
c
      if (agepigf(n).ge.AGEMAX) then
        fmspig(n) = amax1(0.,fmsold - 0.1)
      endif
c
c-----Get puff mass fraction lost and recalculate the reactor width parameter
c     AXISY to correct reactor volume and conserve concentration 
c
      delms = (fmsold - fmspig(n))/fmsold
      if (delms.gt.1.e-5) then
        aa = 1.
        bb = xlen
        cc = -(xlen*axisy(n) + axisy(n)*axisy(n))*(1. - delms)
        axisy(n) = (-bb + sqrt(bb*bb - 4.*aa*cc))/(2.*aa)
        ldump = .true.
      endif
c
c-----Check for errors
c
 900  if (delms.lt.0.) then
        write(iout,'(//,a)') 'ERROR in PIGGROW:'
        write(iout,*) 'Negative puff leakage:'
        write(iout,*) 'Puff#,axis_y/z:'
        write(iout,*)  n,axisy(n),axisz(n)
        write(iout,*) 'New and old mass fraction in puff:'
        write(iout,*)  fmspig(n),fmsold
        call camxerr()
      endif
c
      return
      end

      subroutine plumeris(nlay,hght,temp,dtdz,wind,hstk,dstk,tstk,
     &                    vstk,prise)
c
c----CAMx v7.40 260801
c
c     PLUMERIS calculates plume rise above a given elevated point source.
c     Methodology based on the EPA TUPOS Gaussian Plume Model
c     (Turner, Chico, and Catalano, 1986)
c
c      Copyright Ramboll
c          
c     Modifications: 
c        04/07/10       Various updates to improve robustness
c
c     Input arguments:
c        nlay                number of layers
c        hght                layer interface heights (m)
c        temp                temperature (K)
c        dtdz                potential temperature lapse rate (K/m)
c        wind                total horizontal wind (m/s)
c        hstk                stack height (m)
c        dstk                stack diameter (m)
c        tstk                stack temperature (K)
c        vstk                stack velocity (m/s)
c
c     Output arguments:
c        prise               plume rise (m)
c
c     Routines called:
c        none
c
c     Called by:
c        EMISS
c        PIGINIT
c
      implicit none
c
c-----Arguments
c
      integer nlay
      real hstk,dstk,tstk,vstk,prise
      real hght(0:nlay)
      real temp(nlay)
      real dtdz(nlay)
      real wind(nlay)
c
c-----Local variables
c
      integer k,kstk,kstab,iuse
      real grav,rise,ztop,zbot,stkt,fr,dwfact,umrise,wsum,wavg,bflux0,
     &     bflux,ubrise1,ubrise2,ubrise,rflux,smrise,sbrise1,sbrise2,
     &     sbrise,zstab,tsum,ssum,tavg,savg,dtdztmp
      logical lfirst
c
      data grav /9.8/
c
c-----Entry point
c
      lfirst = .true.
      rise = 0.
      dwfact = 1.
      hstk = amax1(hstk,1.)
      hstk = amin1(hstk,hght(nlay-1))
      dstk = amax1(dstk,0.1)
      vstk = amax1(vstk,0.1)
c
c-----Find beginning layer; determine vertical coordinates relative
c     to stack-top 
c
      do k = 1,nlay-1
        if (hstk.lt.hght(k)) then
          kstk = k
          goto 5
        endif
      enddo
      goto 999
 5    continue
      ztop = hght(kstk) - hstk
      zbot = 0.
      zstab = 0.
      stkt = amax1(tstk,temp(kstk) + 1.)
c
c-----Determine downwash factor as a function of stack Froude number
c
      fr = temp(kstk)*vstk*vstk/(grav*dstk*(stkt - temp(kstk)))
      if (fr.ge.3.) then
        if (wind(kstk).ge.vstk) then
          goto 999
        elseif (wind(kstk).gt.vstk/1.5 .and. wind(kstk).lt.vstk) then
          dwfact = 3.*(vstk - wind(kstk))/vstk
        endif
      endif
c
c-----Set minimum windspeed profile to 1 m/s
c
      do k = 1,nlay
        wind(k) = amax1(wind(k),1.)
      enddo 
c
c-----Neutral-unstable momentum rise and stack buoyancy flux
c
      umrise = 3.*dstk*vstk/wind(kstk)
      if (umrise.gt.ztop) then
        wsum = wind(kstk)*ztop
        do k = kstk+1,nlay 
          wsum = wsum + wind(k)*(hght(k) - hght(k-1))
          wavg = wsum/(hght(k) - hstk)
          umrise = 3.*dstk*vstk/wavg
          if (umrise.lt.hght(k)-hstk) goto 10
        enddo
      endif
  10  bflux0 = grav*vstk*dstk*dstk*(stkt - temp(kstk))/(4.*stkt)
      bflux = bflux0
c
c-----Top of layer loop; determine stability
c
  20  continue
      if (lfirst) then
        kstab = kstk
        if (kstk.gt.1 .and. hstk.lt.((hght(kstk)+hght(kstk-1))/2.))
     &     kstab = kstk - 1
      else
        kstab = kstk-1
        bflux = rflux
        ztop = hght(kstk) - hstk
        zbot = hght(kstk-1) - hstk
      endif
      if (dtdz(kstab).gt.1.5e-3) then
        if (zstab.eq.0.) zstab = max(zbot,1.)
        goto 30 
      endif
c
c-----Neutral-unstable buoyancy rise
c
      ubrise1 = 30.*(bflux/wind(kstk))**0.6 + zbot
      ubrise2 = 24.*(bflux/wind(kstk)**3)**0.6 *
     &          (hstk + 200.*(bflux/wind(kstk)**3))**0.4 + zbot
      ubrise = amin1(ubrise1,ubrise2)
      iuse = 1
      if (ubrise.eq.ubrise2) iuse = 2
c
c-----Find maximum of neutral-unstable momentum and buoyancy rise
c
      if (lfirst .and. umrise.gt.ubrise) then
        rise = umrise
        goto 999
      else
        rise = ubrise
        if (rise.le.ztop) goto 999
      endif
c
c-----Neutral-unstable residual buoyancy flux 
c
      if (iuse.eq.1) then
        rflux = wind(kstk)*((rise - ztop)/30.)**(5./3.)
      else
        rflux = 0.0055*(rise - ztop)*wind(kstk)**3 /
     &          (1. + hstk/(rise - ztop))**(2./3.)
      endif
      kstk = kstk + 1
      if (kstk.gt.nlay .or. rflux.le.0.) goto 999
      lfirst = .false.
      goto 20
c
  30  continue
c
c-----Stable buoyancy rise
c
      sbrise1 = (1.8*bflux*temp(kstk)/(wind(kstk)*dtdz(kstab)) + 
     &           zbot*zbot*zbot)**(1./3.)
      sbrise2 = (4.1*bflux*temp(kstk)/(bflux0**(1./3.)*dtdz(kstab)) +
     &           zbot**(8./3.))**(3./8.)
      sbrise = amin1(sbrise1,sbrise2)
      iuse = 1
      if (sbrise.eq.sbrise2) iuse = 2
c
c-----Stable momentum rise
c
      if (lfirst) then
        dtdztmp = max(1.e-20,dtdz(kstab))
        smrise = 0.646*(vstk**2*dstk**2/(stkt*wind(kstk)))**(1./3.) *
     &           sqrt(temp(kstk))/(dtdztmp**(1./6.))
        if (smrise.gt.ztop) then
          wsum = wind(kstk)*ztop
          tsum = temp(kstk)*ztop
          ssum = dtdz(kstab)*ztop
          do k = kstk+1,nlay
            wsum = wsum + wind(k)*(hght(k) - hght(k-1))
            wavg = wsum/(hght(k) - hstk)
            tsum = tsum + temp(k)*(hght(k) - hght(k-1))
            tavg = tsum/(hght(k) - hstk)
            ssum = ssum + dtdz(k-1)*(hght(k) - hght(k-1))
            savg = max(1.e-20,ssum/(hght(k) - hstk))
            smrise = 0.646*(vstk**2*dstk**2/(stkt*wavg))**(1./3.) *
     &               sqrt(tavg)/(savg**(1./6.))
            if (smrise.lt.hght(k)-hstk) goto 40
          enddo
        endif
  40    smrise = amin1(smrise,umrise)
c
c-----Find maximum between stable momentum and (2/3)*bouyancy rise
c
        if (smrise.gt.(2.*sbrise/3.)) then
          rise = smrise
          goto 999
        endif
      endif
      if (sbrise.le.ztop) then
        rise = zstab + 2.*(sbrise - zstab)/3.
        goto 999
      else
        rise = sbrise
      endif
c
c-----Stable residual buoyancy flux
c
      if (iuse.eq.1) then
        rflux = bflux - 0.56*dtdz(kstab)*wind(kstk)/temp(kstk)*
     &          (ztop*ztop*ztop - zbot*zbot*zbot) 
      else
        rflux = bflux - 0.24*dtdz(kstab)*bflux0**(1./3.)/temp(kstk)*
     &          (ztop**(8./3.) - zbot**(8./3.))
      endif
      kstk = kstk + 1
      if (kstk.gt.nlay .or. rflux.le.0.) then
        rise = zstab + 2.*(sbrise - zstab)/3.
        goto 999
      endif
      lfirst = .false.
      goto 20
c
c-----Add stack height to downwash-corrected plume rise and return
c
 999  prise = hstk + dwfact*rise 
c
      return
      end

c**** STABSA
c
      subroutine stabsa(idate,begtim,jdate,endtim)
      use filunit
      use chmstry
      use tracer
      use rtracchm
      use grid
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the flags that determine if each species in the
c   species list should be added to the VOC or NOx tracers.  The carbon
c   number for the VOC species is also put into the appropriate place
c   in the array.
c      Inputs:
c        idate  I   date of the beginning of the simulation (YYJJJ)
c        begtim R   hour of the begining of simulation
c        jdate  I   date of the ending of the simulation (YYJJJ)
c        endtim R   hour of the endng of simulation
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/27/96   --gwilson--    Original development
c     09/20/03   --gwilson--    Completely changed the way tracer classes
c                               are identified to deal with PSAT
c     08/20/06   --bkoo--       Added ETOH, MTBE & MBUT for updated SAPRC99
c                               Fixed rkohsprc & rmirsprc
c     09/01/06   --bkoo--       Updated rkohcbiv for ISOP, MEOH & ETOH
c     12/29/06   --bkoo--       Revised for the updated SOA scheme
c     01/08/07   --bkoo--       Added Mechanism 6 (CB05)
c     07/16/07   --bkoo--       Added HRVOC
c     10/25/07   --gyarwood-    Make MIR and kOH values per carbon
c     10/25/09   --gwilson--    Fixed coded related to timing tracers
c     08/23/13   --bkoo--       Set LVOCSP flags of SOA precursors for DDM-PM
c     03/18/14   --bkoo--       Added BNZA
c     06/24/16   --bkoo--       Updated Mechanism 4 (CB6r4)
c     08/25/16   --bkoo--       Updated for new SOAP
c     11/27/17   --bkoo--       Updated for CB6r2h
c     01/12/18   --bkoo--       Removed BNZA/TOLA/XYLA/ISP/TRP
c     01/16/18   --bkoo--       Updated for SAPRC07T
c     06/18/19   --bkoo--       Expanded spcsoap & rkohsoap for SAPRC07T
c     02/21/20   --rlb--        Added Mechanism 1 (CB6r5)
c     03/25/21   --gy--         Added Mechanism 7 (CB7)
c     09/02/21   --gy--         Added Mechanism 9 (RACM2s21)
c     11/03/23   --cemery--     Removed CB05 (Mech 6)
c     05/13/25   --gy--         Update Mechanism 7 to CB7r2
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      integer   jdate
      real      begtim
      real      endtim
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c   NSASPRC    I    the number of VOC species names to be checked (SAPRC)
c   NSARC2     I    the number of VOC species names to be checked (RACM2)
c   NSACB6     I    the number of VOC species names to be checked (CB6)
c   NSACB7     I    the number of VOC species names to be checked (CB7)
c   NSASOAP    I    the number of SOA-producing VOC species for PSAT
c   MXSANAM    I    maximum size of the arrays
c   NHRVSPRC   I    the number of HRVOC species names (SAPRC)
c   NHRVRC2    I    the number of HRVOC species names (RACM2)
c   NHRVCB6    I    the number of HRVOC species names (CB6)
c   NHRVCB7    I    the number of HRVOC species names (CB7)
c   MXHRVNAM   I    maximum size of the HRVOC arrays
c
      integer   NSASPRC, NSACB6, NSACB7, NSARC2, MXSANAM
      integer   NSASOAP
      integer   NHRVSPRC, NHRVCB6, NHRVCB7, NHRVRC2, MXHRVNAM
c
      parameter( NSASPRC = 30 )
      parameter( NSARC2  = 27 )
      parameter( NSACB6  = 20 )
      parameter( NSACB7  = 39 )
      parameter( NSASOAP = 14 ) ! Only the precursors used for calculating
                                ! reactivity/yield weighting factors
      parameter( MXSANAM = MAX(NSASPRC,
     &                         NSACB6, NSACB7, NSARC2) )
      parameter( NHRVSPRC = 5 )
      parameter( NHRVRC2  = 4 )
      parameter( NHRVCB6  = 3 )
      parameter( NHRVCB7  = 3 )
      parameter( MXHRVNAM = MAX(NHRVSPRC,
     &                          NHRVCB6, NHRVCB7, NHRVRC2) )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 spcnam(MXSANAM), hrvnam(MXHRVNAM)
      character*10 spcsprc(NSASPRC), spcrc2(NSARC2),
     &             spccb6(NSACB6), spccb7(NSACB7)
      character*10 hrvsprc(NHRVSPRC), hrvrc2(NHRVRC2),
     &             hrvcb6(NHRVCB6), hrvcb7(NHRVCB7)
      character*10 spcsoap(NSASOAP)
      character*10 nameyld(MXALCLS,MXSPEC)
      character*10 nonam, no2nam, hononam, o3name, namecls(MXALCLS,MXSPEC)
      integer      numcls(MXALCLS), ispc, nnames, i
      integer      idxo3n, idxo3v, idxoon, idxoov
      integer      numyld(MXALCLS), nhrvoc, mvecedge
      real         carbon(MXSANAM), rkoh(MXSANAM), rmir(MXSANAM)
      real         carbsprc(NSASPRC),rkohsprc(NSASPRC),rmirsprc(NSASPRC)
      real         carbrc2(NSARC2),  rkohrc2(NSARC2),  rmirrc2(NSARC2)
      real         carbcb6(NSACB6),  rkohcb6(NSACB6),  rmircb6(NSACB6)
      real         carbcb7(NSACB7),  rkohcb7(NSACB7),  rmircb7(NSACB7)
      real         rkohsoap(NSASOAP)
      real         coefcon(MXALCLS,MXSPEC), coeflux(MXALCLS,MXSPEC)
      real         yieldH(MXALCLS,MXSPEC),yieldL(MXALCLS,MXSPEC)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data spcrc2  /'HCHO      ', 'ACD       ', 'ALD       ',
     &              'ACT       ', 'MEK       ', 'KET       ',
     &              'MOH       ', 'EOH       ', 'ROH       ',
     &              'ETEG      ', 'ISO       ', 'API       ',
     &              'LIM       ', 'BEN       ', 'TOL       ',
     &              'XYM       ', 'XYP       ', 'XYO       ',
     &              'ETH       ', 'HC3       ', 'HC5       ',
     &              'HC8       ', 'ETE       ', 'OLT       ',
     &              'OLI       ', 'ACE       ', 'DIEN      ' /
c
      data carbrc2  /1.0,          2.0,          3.0,
     &               3.0,          4.0,          5.0,
     &               1.0,          2.0,          3.0,
     &               2.0,          5.0,          10.0,
     &               10.0,         6.0,          7.1,
     &               8.9,          9.0,          8.9, 
     &               2.0,          3.6,          5.6,
     &               7.9,          2.0,          3.8,
     &               5.0,          2.0,          4.0 /
c
      data rkohrc2  /1.24E+04,     2.21E+04,     2.82E+04,
     &               2.05E+02,     1.64E+03,     4.28E+03,
     &               1.32E+03,     4.74E+03,     7.51E+03,
     &               2.17E+04,     1.48E+05,     7.82E+04,
     &               2.38E+05,     1.80E+03,     8.77E+03,
     &               3.41E+04,     2.11E+04,     2.01E+04,
     &               3.56E+02,     3.28E+03,     6.56E+03,
     &               1.67E+04,     1.21E+04,     4.52E+04,
     &               1.05E+05,     1.10E+03,     9.83E+04 /
c
      data rmirrc2  /3.41,         4.46,         6.67,
     &               0.47,         2.61,         4.97,
     &               0.36,         1.34,         2.18,
     &               4.62,         12.0,         12.7,
     &               14.9,         1.12,         5.23,
     &               21.6,         18.0,         17.7,
     &               0.18,         1.01,         1.05,
     &               3.46,         4.08,         5.36,
     &               13.4,         0.28,         8.67 /
c
      data hrvrc2  /'ETE       ','OLT       ','OLI       ',
     &              'DIEN      ' /
c
      data spcsprc /'HCHO      ','CCHO      ','RCHO      ',
     &              'ACET      ','MEK       ','MEOH      ',
     &              'ETHE      ','PRPE      ','BD13      ',
     &              'ISOP      ','APIN      ','ACYE      ',
     &              'BENZ      ','TOLU      ','MXYL      ',
     &              'OXYL      ','PXYL      ','B124      ',
     &              'ETOH      ','ALK1      ','ALK2      ',
     &              'ALK3      ','ALK4      ','ALK5      ',
     &              'OLE1      ','OLE2      ','ARO1      ',
     &              'ARO2      ','TERP      ','SESQ      '/
c
      data carbsprc /1.0,         2.0,         3.0,
     &               3.0,         4.0,         1.0,
     &               2.0,         3.0,         4.0,
     &               5.0,        10.0,         2.0,
     &               6.0,         7.0,         8.0,
     &               8.0,         8.0,         9.0,
     &               2.0,         2.0,         2.5,
     &               4.0,         5.4,         8.3,
     &               5.2,         5.4,         7.2,
     &               8.8,        10.0,        15.0/
c
      data rkohsprc  /1.25E4,     2.21E4,     2.93E4,
     &                2.77E2,     1.74E3,     1.32E3,
     &                1.21E4,     3.89E4,     9.83E4,
     &                1.49E5,     7.72E4,     1.12E3,
     &                1.80E3,     8.31E3,     3.41E4,
     &                2.01E4,     2.11E4,     4.80E4,
     &                4.74E3,     3.66E2,     1.62E3,
     &                3.40E3,     6.42E3,     1.40E4,
     &                5.33E4,     9.57E4,     1.16E4,
     &                4.56E4,     1.44E5,     1.44E5/
c
      data rmirsprc  /5.92,       6.00,       8.57,
     &                0.43,       2.23,       0.45,
     &                5.26,      10.23,      14.21,
     &               15.05,      12.79,       0.52,
     &                1.17,       7.69,      21.57,
     &               16.90,      12.92,      22.22,
     &                1.46,       0.18,       0.45,
     &                1.44,       4.77,       3.01,
     &               10.53,      15.30,       5.97,
     &               20.88,      11.48,       5.74/
c
      data hrvsprc /'ETHE      ','PRPE      ','BD13      ',
     &              'OLE1      ','OLE2      '/
c
      data spccb6  /'PAR       ','ETHA      ','MEOH      ',
     &              'ETOH      ','ETH       ','OLE       ',
     &              'IOLE      ','ISOP      ','TERP      ',
     &              'FORM      ','ALD2      ','ALDX      ',
     &              'TOL       ','XYL       ','PRPA      ',
     &              'BENZ      ','ETHY      ','ACET      ',
     &              'KET       ','SQT       '/
c
      data carbcb6  /1.,          2.,          1.,
     &               2.,          2.,          2.,
     &               4.,          5.,         10.,
     &               1.,          2.,          2.,
     &               7.,          8.,          3.,
     &               6.,          2.,          3.,
     &               1.,         15./
c
      data rkohcb6  /1.20E3,      3.56E2,      1.32E3,
     &               4.74E3,      1.16E4,      4.22E4,
     &               8.85E4,      1.48E5,      1.00E5,
     &               1.25E4,      2.21E4,      2.82E4,
     &               8.32E3,      2.73E4,      1.58E3,
     &               1.80E3,      1.11E3,      2.60E2,
     &               0.00E0,      2.96E5/
c
      data rmircb6  /0.509,       0.135,       0.480,
     &               1.53,        4.95,        9.66,
     &               16.0,        12.7,        9.91,
     &               4.87,        5.80,        8.35,
     &               7.39,        20.5,        0.541,
     &               1.39,        0.487,       0.564,
     &               4.86,        0.01/
c
      data hrvcb6  /'ETH       ','IOLE      ','OLE       '/
c
      data spccb7  /'ETHA      ', 'HPAR      ', 'IBTA      ',
     &              'PAR       ', 'PRPA      ', 'ETH       ',
     &              'IOLE      ', 'OLE       ', 'BENZ      ',
     &              'TOL       ', 'XYL       ', 'ETHY      ',
     &              'ISOP      ', 'APIN      ', 'SQT       ',
     &              'TERP      ', 'EDOH      ', 'ETOH      ',
     &              'IPOH      ', 'MEOH      ', 'NPOH      ',
     &              'PDOH      ', 'ROH       ', 'DEE       ',
     &              'DME       ', 'ETHR      ', 'ALD2      ',
     &              'ALDX      ', 'FORM      ', 'GLY       ',
     &              'MGLY      ', 'ACET      ', 'KET       ',
     &              'ESTR      ', 'ETAC      ', 'ETFM      ',
     &              'MEAC      ', 'MEFM      ', 'SXD5      '/
c
      data carbcb7/ 2.       , 12.       ,  4.       ,
     &              1.       ,  3.       ,  2.       ,
     &              4.       ,  2.       ,  6.       ,
     &              7.       ,  8.       ,  2.       ,
     &              5.       , 10.       , 15.       ,
     &              10.      ,  2.       ,  2.       ,
     &              3.       ,  1.       ,  3.       ,
     &              3.       ,  4.       ,  4.       ,
     &              2.       ,  4.       ,  2.       ,
     &              2.       ,  1.       ,  2.       ,
     &              3.       ,  3.       ,  1.       ,
     &              4.       ,  4.       ,  3.       ,
     &              3.       ,  2.       , 10.       /
c
      data rkohcb7  /3.56E+02  , 2.05E+04  , 3.07E+03  ,
     &               1.23E+03  , 1.58E+03  , 1.16E+04  ,
     &               8.85E+04  , 4.22E+04  , 1.80E+03  ,
     &               8.33E+03  , 2.73E+04  , 1.11E+03  ,
     &               1.48E+05  , 7.84E+04  , 2.96E+05  ,
     &               1.75E+05  , 2.14E+04  , 4.74E+03  ,
     &               7.52E+03  , 1.32E+03  , 8.60E+03  ,
     &               3.10E+04  , 1.27E+04  , 1.94E+04  ,
     &               4.09E+03  , 1.84E+04  , 2.21E+04  ,
     &               2.82E+04  , 1.26E+04  , 1.43E+04  ,
     &               1.93E+04  , 2.60E+02  , 2.95E+03  ,
     &               4.43E+03  , 2.48E+03  , 1.31E+03  ,
     &               5.16E+02  , 2.95E+02  , 3.10E+03  /
c
       data rmircb7  /0.166    , 2.960     , 1.347     ,
     &                0.382    , 0.439     , 4.016     ,
     &                14.60    , 8.464     , 1.110     ,
     &                6.842    , 16.81     , 0.433     ,
     &                9.747    , 9.507     , 9.793     ,
     &                11.07    , 3.197     , 1.418     ,
     &                0.993    , 0.378     , 3.339     ,
     &                3.026    , 3.453     , 4.241     ,
     &                0.594    , 4.457     , 5.023     ,
     &                8.025    , 3.983     , 10.77     ,
     &                17.50    , 0.562     , 2.017     ,
     &                1.276    , 3.453     , 0.290     ,
     &                0.146    , 0.084     , 0.766     /
c
      data hrvcb7  /'ETH       ','IOLE      ','OLE       '/
c
      data spcsoap /'BENZ      ',
     &              'TOL       ','TOLU      ','ARO1      ',
     &              'XYL       ','OXYL      ','MXYL      ',
     &              'PXYL      ','B124      ','ARO2      ',
     &              'IVOA      ','IVC1      ','IVC2      ',
     &              'SVOA      '/
c
      data rkohsoap / 1.80E3,
     &                8.32E3,     8.32E3,      8.32E3,
     &                2.73E4,     2.73E4,      2.73E4,
     &                2.73E4,     2.73E4,      2.73E4,
     &                1.98E4,     1.98E4,      1.98E4,
     &                1.98E4/
c
      data nonam  /'NO        '/
c
      data no2nam /'NO2       '/
c
      data hononam /'HONO      '/
c
      data o3name /'O3        '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- initialize the arrays for reactivity ---
c
      do i=1,nspec
         crbnum(i) = 0.
         rkohrt(i) = 0.
         rmirrt(i) = 0.
         lusespc(i) = .FALSE.
      enddo
c
c  --- calculate the beginning of the various tracer types ---
c      there will be (ngroup+1) if there is an extra group for the
c      "leftover" group  ----
c      
      if( lsa_ioric ) then
          numic_spcs = ncls_ioric
      else
          numic_spcs = 1
      endif
      if( lsa_iorbc ) then
          numbc_spcs = ncls_iorbc
          numtc_spcs = 0
          if( .NOT. lsa_iortc ) numtc_spcs = 1
      else
          numtc_spcs = 0
          if( lbndry ) then
              numbc_spcs = 5
          else
              numbc_spcs = 1
          endif
      endif
      nbdic = numic_spcs + numbc_spcs + numtc_spcs 
      if( ngroup .EQ. 0 ) then
          ncount = nregin 
      else
          if( leftovr_area ) then
             ncount = (ngroup + 1) * nregin
          else
             ncount = ngroup * nregin
          endif
      endif
c
c  ---- load the local arrays based on the mechanism ---
c
      if( idmech .EQ. 1 .OR. idmech .EQ. 4) then
         nnames = NSACB6
         call spccb6r4sa(namecls,numcls,coefcon,coeflux,
     &                      nameyld,numyld,yieldH,yieldL,mwspec)
         do i=1,nnames
            spcnam(i) = spccb6(i)
            carbon(i) = carbcb6(i)
            rkoh(i) = rkohcb6(i)/carbon(i)
            rmir(i) = rmircb6(i)/carbon(i)
         enddo
         nhrvoc = NHRVCB6
         do i=1,nhrvoc
            hrvnam(i) = hrvcb6(i)
         enddo
      elseif( idmech .EQ. 3 ) then
         nnames = NSACB6
         call spccb6r5hsa(namecls,numcls,coefcon,coeflux,
     &                      nameyld,numyld,yieldH,yieldL,mwspec)
         do i=1,nnames
            spcnam(i) = spccb6(i)
            carbon(i) = carbcb6(i)
            rkoh(i) = rkohcb6(i)/carbon(i)
            rmir(i) = rmircb6(i)/carbon(i)
         enddo
         nhrvoc = NHRVCB6
         do i=1,nhrvoc
            hrvnam(i) = hrvcb6(i)
         enddo
      elseif( idmech .EQ. 5 ) then
         nnames = NSASPRC
         call spcsprcsa(namecls,numcls,coefcon,coeflux,
     &                  nameyld,numyld,yieldH,yieldL,mwspec)
         do i=1,nnames
            spcnam(i) = spcsprc(i)
            carbon(i) = carbsprc(i)
            rkoh(i) = rkohsprc(i)/carbon(i)
            rmir(i) = rmirsprc(i)/carbon(i)
         enddo
         nhrvoc = NHRVSPRC
         do i=1,nhrvoc
            hrvnam(i) = hrvsprc(i)
         enddo
      elseif( idmech .EQ. 7 ) then
         nnames = NSACB7
         call spccb7sa(namecls,numcls,coefcon,coeflux,
     &                 nameyld,numyld,yieldH,yieldL,mwspec)
         do i=1,nnames
            spcnam(i) = spccb7(i)
            carbon(i) = carbcb7(i)
            rkoh(i) = rkohcb7(i)/carbon(i)
            rmir(i) = rmircb7(i)/carbon(i)
         enddo
         nhrvoc = NHRVCB7
         do i=1,nhrvoc
            hrvnam(i) = hrvcb7(i)
         enddo
      elseif( idmech .EQ. 9 ) then        ! RACM2s21
         nnames = NSARC2
         call spcrc2sa(namecls,numcls,coefcon,coeflux,
     &                 nameyld,numyld,yieldH,yieldL,mwspec)
         do i=1,nnames
            spcnam(i) = spcrc2(i)
            carbon(i) = carbrc2(i)
            rkoh(i) = rkohrc2(i)/carbon(i)
            rmir(i) = rmirrc2(i)/carbon(i)
         enddo
         nhrvoc = NHRVRC2
         do i=1,nhrvoc
            hrvnam(i) = hrvrc2(i)
         enddo
      else
         write(iout,'(//,a)') 'ERROR in STABSA:'
         write(iout,'(/,1X,A,I10)')
     &              'Unknown chemical mechanism ID number: ',idmech
         write(iout,'(/,1X,2A)')
     &              'Ozone source apportionment is not available ',
     &              'for this chemical mechanism'
         call camxerr()
      endif
c
c  --- make sure there is enough space ---
c
      ntrcls = 0
      do i=1,MXALCLS
        if( numcls(i) .GT. 0 ) ntrcls = ntrcls + 1
      enddo
c
c  --- call routine to allocate arrays by class ---
c
      call alloc_tracer_class(nspec)
      call zeros(trspmap,nspec*ntrcls)
      call zeros(fluxmap,nspec*ntrcls)
      call zeros(yhratmap,nspec*ntrcls)
      call zeros(ylratmap,nspec*ntrcls)
c
c  --- initialize the pointers into the gridded conc array ---
c
      ntrcls = 0
      iptrbeg = 1
      idxo3n = 0
      idxo3v = 0
      idxoon = 0
      idxoov = 0
      do i=1,MXALCLS
        if( numcls(i) .GT. 0 ) then
           ntrcls = ntrcls + 1
           iptcls(ntrcls) = iptrbeg
           ipttrc(ntrcls) = iptrbeg
           iptrbeg = iptrbeg + ncount + nbdic
           nptcls(ntrcls) = iptrbeg - 1
           npttrc(ntrcls) = iptrbeg - 1
           iemcls(ntrcls) = iptcls(ntrcls) + nbdic
           idxcls(ntrcls) = i
           idxipt(i) = ntrcls
           if( i .EQ. ITRO3N ) idxo3n = ntrcls
           if( i .EQ. ITRO3V ) idxo3v = ntrcls
           if( i .EQ. ITROON ) idxoon = ntrcls
           if( i .EQ. ITROOV ) idxoov = ntrcls
        endif
      enddo
      soap3_ntrcls = ntrcls 
      if( luse_soap3 .AND. lsoa ) soap3_ntrcls = ntrcls + (IDX_SOAP_POA_BB-IDX_SOAP_POA_OP)+1
      ipttim = iptrbeg
      iemtim = ipttim
c
c   --- adjust the pointers for O3N and O3V (together make up O3)
c
      if( idxo3n .GT. 0 .AND. idxo3v .GT. 0 ) then
        ipttrc(idxo3v) = 0
        npttrc(idxo3n) = npttrc(idxo3v)
        npttrc(idxo3v) = 0
      endif
c
c   --- adjust the pointers for OON and OOV (together make up RGN)
c
      if( idxoon .GT. 0 .AND. idxoov .GT. 0 ) then
        ipttrc(idxoov) = 0
        npttrc(idxoon) = npttrc(idxoov)
        npttrc(idxoov) = 0
      endif
c
c   --- calculate the number of tracers at first time step
c       (1 timing release is updated later) ---
c
      nreles = 0
      ntotsp = ipttim-1
      notimespc = ipttim-1
      nsaspc = ipttim-1
c
c  --- calculate the number of timing tracers there will be and put
c      the names into the names array ---
c
      if( ntrtim .GT. 0 ) then
        ibegdt = idate
        btim = begtim/100.
        ienddt = jdate
        etim = endtim/100.
        if( etim .EQ. 0. ) then
            etim = 24.
            ienddt = ienddt - 1
        endif
        timnow = btim
        idtnow = ibegdt
        nhours = (ienddt-ibegdt)*24 + INT( etim - btim )
        do i=1,nhours
           if( MOD( INT(timnow), 24/ntrtim ) .EQ. 0 .OR. i .EQ. 1) then
              do j=1,nregin
                  ntotsp = ntotsp + 2
              enddo
           endif
           timnow = timnow + 1.0
           if( timnow .EQ. 24.0 ) then
               timnow = 0.
               idtnow = idtnow + 1
           endif
        enddo
        if( ntotsp .GT. MXTRSP ) goto 7000
      endif
c
c   --- if doing SOAP3 set the number species that includes the SOAP3
c       emissions species ---
c
      soap3_ntotsp = ntotsp
      soap3_nsaspc = nsaspc
      if( luse_soap3 .AND. lsoa ) then
         soap3_clsnam(IDX_SOAP_POA_OP) = 'POP'
         soap3_clsnam(IDX_SOAP_POA_GV) = 'PGV'
         soap3_clsnam(IDX_SOAP_POA_DV) = 'PDV'
         soap3_clsnam(IDX_SOAP_POA_MC) = 'PMC'
         soap3_clsnam(IDX_SOAP_POA_IC) = 'PIC'
         soap3_clsnam(IDX_SOAP_POA_AV) = 'PAV'
         soap3_clsnam(IDX_SOAP_POA_BB) = 'PBB'
         do i=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
            soap3_iptcls(i) = iptrbeg
            iptrbeg = iptrbeg + ncount
            soap3_nptcls(i) = iptrbeg - 1
            soap3_iemcls(i) = soap3_iptcls(i)
         enddo
         soap3_ntotsp = iptrbeg-1
         soap3_nsaspc = iptrbeg-1
      endif
c
c   --- call routine to allocate the arrays that depend on total
c       tracer species ---
c
      if( .NOT. lddm .AND. .NOT. lhddm ) then
         mvecedge = MAX(ncol(1),nrow(1))
         call alloc_tracer_specs(ngrid,ncol,nrow,nlay,nlayers_ems,
     &                                       tectyp,mvecedge,iout)
         call alloc_tracer_vdep(ngrid,ncol,nrow,ntotsp)
      endif
c
      if( ntrtim .EQ. 0 ) npttim = 0
c
c   --- loop over the species in the chemparam file and 
c       intialize the flags ---
c
      do ispc=1,nspec
         lvocsp(ispc) = .FALSE.
         lnoxsp(ispc) = .FALSE.
         lo3sp(ispc) = .FALSE.
         lvocsoa(ispc) = .FALSE.
         lhrvoc(ispc) = .FALSE.
c
c   --- loop over the tracer classes ---
c
         do i=1,ntrcls
              itr = idxcls(i)
c
c   ---- loop over the model species making up this class ---
c
               do imod=1,numcls(itr)
c
c   --- check the name, if it matches load the global array ---
c
                 if( spname(ispc) .EQ. namecls(itr,imod) ) then
                     trspmap(ispc,i) = coefcon(itr,imod)
                     fluxmap(ispc,i) = coeflux(itr,imod)
                     lusespc(ispc) = .TRUE.
                 endif
               enddo
c
c   ---- loop over the model species for yields ---
c
               do imod=1,numyld(itr)
c
c   --- check the name, if it matches load the global array ---
c
                 if( spname(ispc) .EQ. nameyld(itr,imod) ) then
                     yhratmap(ispc,i) = yieldH(itr,imod)
                     ylratmap(ispc,i) = yieldL(itr,imod)
                 endif
               enddo
c
c   ---- next tracer class ---
c
         enddo
c
c   --- check for O3 species ----
c
         if( spname(ispc) .EQ. o3name ) then
              lo3sp(ispc) = .TRUE.
         endif
c
c   --- check for NOx species ----
c
         if( spname(ispc) .EQ. nonam .OR. 
     &           spname(ispc) .EQ. no2nam .OR. spname(ispc) .EQ. hononam ) then
              lnoxsp(ispc) = .TRUE.
         endif
c
c   ---- check for reactive VOC species ---
c
         do i=1,nnames
            if( spname(ispc) .EQ. spcnam(i) ) then
               lvocsp(ispc) = .TRUE.
               crbnum(ispc) = carbon(i)
               rkohrt(ispc) = rkoh(i)
               rmirrt(ispc) = rmir(i)
            endif
         enddo
c
c   ---- check for SOA-producing VOC species for PSAT ---
c   NOTE: 1. Carbon numbers and MIR values are irrelevant to PSAT
c         2. Only needed for calculating reactivity/yield weighting factors
c
         if( lsoa ) then
           do i=1,NSASOAP
              if( spname(ispc) .EQ. spcsoap(i) ) then
                 lvocsoa(ispc) = .TRUE.
                 rkohrt(ispc) = rkohsoap(i)
              endif
           enddo
         endif
c
c   ---- check for additional VOC species that produce SOA ---
c   NOTE: only for DDM, otherwise they should NOT be added
c
         if ( lddm ) then
            if ( idmech .NE. 5 .OR. idmech .NE. 7 ) then
               if (spname(ispc).EQ.'SQT       ') lvocsp(ispc) = .TRUE.
            endif
            if( spname(ispc) .EQ. 'IVOA      ' ) lvocsp(ispc) = .TRUE.
            if( spname(ispc) .EQ. 'IVC1      ' ) lvocsp(ispc) = .TRUE.
            if( spname(ispc) .EQ. 'IVC2      ' ) lvocsp(ispc) = .TRUE.
            if( spname(ispc) .EQ. 'SVOA      ' ) lvocsp(ispc) = .TRUE.
         endif
c
c   ---- check for HRVOC species ---
c   NOTE: set for DDM
c
         do i=1,nhrvoc
            if( spname(ispc) .EQ. hrvnam(i) ) lhrvoc(ispc) = .TRUE.
         enddo
c
c  --- next simulation species ---
c
      enddo
c      
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error Messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in STABSA:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,'(2A)') ' You are using timing tracers but have not ',
     &                       'allocated space for the timing releases.'
      write(iout,*) 'Please change the value for parameter MXTRSP.'
      write(iout,*) 'It should be set to a value of at least: ',ntotsp
      call flush(iout)
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in STABSA:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,'(2A)') ' You are using SOAP3 but have not ',
     &                       'allocated space for the timing releases.'
      write(iout,*) 'Please change the value for parameter MXTRSP.'
      write(iout,*) 'It should be set to a value of at least: ',soap3_ntotsp
      call flush(iout)
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine vd_aer(z0,deltaz,psih,ustar,diam,rhop,ts,vd)
c
c----CAMx v7.40 260801
c
c     VD_AER calculates a deposition velocity for a specific aerosol size
c     bin, grid cell, and land use category.  The parallel resistance approach 
c     of Slinn and Slinn (1980) is used, as implemented in UAM-AERO 
c     (STI, 1996).
c
c      Copyright Ramboll
c 
c     Modifications: 
c        3/21/03       Modified Ra calculation to use layer 1 midpoint height
c                      rather than default 10 m.
c        9/18/03       Removed small bug in final Vd equation
c
c     Input arguments: 
c        z0                  surface roughness length (m)
c        deltaz              Layer 1 midpoint height (m)
c        psih                similarity stability correction term 
c        ustar               friction velocity (m/s)
c        diam                log-mean sectional aerosol diameter (m)
c        rhop                aerosol density (g/m3)
c        ts                  surface temperature (K)
c      
c     Output arguments: 
c        vd                  deposition velocity (m/s)
c      
c     Routines called: 
c        none 
c      
c     Called by: 
c        DRYDEP
c 
      data vk/0.4/, rmin/1.0/, xmfp/6.5e-8/, g/9.8/, vabs/1.81e-2/
      data boltz/1.38e-20/, pi/3.1415927/, vair/1.5e-5/
c
c-----Entry point
c
c-----Speed correction factor and sedimendation velocity
c
      power = amin1(7.6,0.55*diam/xmfp)
      scf = 1. + (2.514 + 0.8*exp(-power))*xmfp/diam
      vsed = rhop*g*(diam*diam)*scf/(18.*vabs)
c
c-----Brownian diffusivity and Schmidt number
c
      difbrwn = boltz*ts*scf/(3.*pi*vabs*diam)
      schmidt = vair/difbrwn
c
c-----Stokes number
c
      stokes = vsed*(ustar*ustar)/(vair*g)
c
c-----Compute atmospheric resistance, RA
c
      ra = (alog(deltaz/z0) - psih)/(vk*ustar)
      ra = amax1(ra,rmin)
c
c-----Compute the deposition layer resistance, RD
c
      sc23 = schmidt**(-2./3.)
      power = -3./stokes
      if (power.lt.-37.) then
        xinert = 10.**(-37.)
      else
        xinert = 10.**(power)
      endif
      rd = 1./(ustar*(sc23 + xinert))
      rd = amax1(rd,rmin)
c
c-----Final deposition velocity for this cell, land use, and aerosol size
c
      vd = vsed + 1./(ra + rd + ra*rd*vsed)
c
      return
      end

      subroutine readbnd(bndtim,bnddate)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxfld
      use camxcom
c 
c----CAMx v7.40 260801
c 
c     READBND reads and cycles through the BOUNDARY file to the
c     current time/date, and loads coarse grid boundary concentrations
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments: 
c        bndtim                 model simulation time (HHMM)
c        bnddate                model simulation date (YYJJJ)
c             
c     Output arguments: 
c        bndtim                 next boundary update time (HHMM)
c        bnddate                next boundary update date (YYJJJ)
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
c
      character*4 bcspec(10)
      integer bnddate, ncells
c
      real, allocatable, dimension(:,:,:,:) :: bctmp
c
c-----Entry point
c
      ncells = MAX(ncol(1),nrow(1))
      nz = nlay(1)
      allocate( bctmp(ncells,nz,4,MXSPEC) )
c
c-----Read through coarse grid concentration records until current time/date
c
 100  read(ibc,end=900) idat1,tim1,idat2,tim2
      if (INT(tim2) .EQ. 24) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      do l = 1,nbcspc
        do n = 1,4
          nc = nrow(1)
          if (n.gt.2) nc = ncol(1)
          read(ibc) idum,(bcspec(j),j=1,10),iedge,
     &              ((bctmp(i,k,n,l),k=1,nz),i=1,nc) 
        enddo
      enddo
      write(iout,'(a40,2(f7.0,i8.5))')
     &  'Read boundary condition file at ',tim1,idat1,tim2,idat2
      call flush(iout)
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.gt.time))) then
c
c-----Load boundary concentrations; convert gasses from ppm to umol/m3,
c     PM stays at ug/m3
c
        do 60 l = 1,nspec
          lbc = lbcmap(l)
          do 50 k = 1,nz
c
            do 40 j = 2,nrow(1)-1
              i = 1
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(l - 1)
              if (l.le.ngas) then
                convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              else
                convfac = 1.
              endif
              conc(n4d) = convfac*bdnl(l)
              if (lbc.gt.0) then
                 if( bctmp(j,k,1,lbc).gt.bdnl(l) ) 
     &                   conc(n4d) = convfac*bctmp(j,k,1,lbc)
              endif
c
              i = ncol(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(l - 1)
              if (l.le.ngas) then
                convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              else
                convfac = 1.
              endif
              conc(n4d) = convfac*bdnl(l)
              if (lbc.gt.0 )then
                if( bctmp(j,k,2,lbc).gt.bdnl(l) ) 
     &                  conc(n4d) = convfac*bctmp(j,k,2,lbc)
              endif
 40         continue
c
            do 45 i = 2,ncol(1)-1
              j = 1
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(l - 1)
              if (l.le.ngas) then
                convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              else
                convfac = 1.
              endif
              conc(n4d) = convfac*bdnl(l)
              if (lbc.gt.0) then
                 if( bctmp(i,k,3,lbc).gt.bdnl(l) ) 
     &              conc(n4d) = convfac*bctmp(i,k,3,lbc)
              endif
c
              j = nrow(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(l - 1)
              if (l.le.ngas) then
                convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              else
                convfac = 1.
              endif
              conc(n4d) = convfac*bdnl(l)
              if (lbc.gt.0) then
                  if( bctmp(i,k,4,lbc).gt.bdnl(l) ) then
                       conc(n4d) = convfac*bctmp(i,k,4,lbc) 
                  endif
              endif
 45         continue 
 50       continue
 60     continue
      else
        goto 100
      endif
c
c-----Set next boundary update time
c
      bndtim = tim2
      bnddate = idat2
      if (bndtim.ge.2400.) then
        bndtim = bndtim - 2400.
        bnddate = bnddate + 1
        if( MOD(bnddate,1000) .GT. 365 ) then
           if( MOD(INT(bnddate/1000),4) .EQ. 0 ) then
              if( MOD(bnddate,1000) .EQ. 367 )
     &                     bnddate = (INT(bnddate/1000)+1)*1000 + 1
           else
              bnddate = (INT(bnddate/1000)+1)*1000 + 1
           endif
        endif
      endif
      goto 999
c
c-----End of BC file reached
c
 900  write(iout,'(//,a)') 'ERROR in READBND:'
      write(iout,*)'Premature End of BC file reached.'
      write(iout,*)'Make sure boundary file contains simulation ',
     &                                               'time period.'
      call camxerr()
c
 999  continue
c
c  --- dealocate the local array ---
c
      deallocate( bctmp )
      return
      end

      subroutine spfcn (n,ct,cs,ca,mw,cpx,tom,fval)
      implicit none
c
c SPFCN calculates the objective function for the bi-section solver in SOAP
c  - revised for new objective function by bkoo (05/27/05)
c     Total Organics in Mole (TOM) = SUM_i(C_i(aer)/MW_i) + C_pre/MW_pre
c     C_i(aer) = C_i(tot) - x_i * Cstar_i
c              = C_i(tot) - (C_i(aer)/MW_i/TOM) * Cstar_i
c  => C_i(aer) = C_i(tot) * TOM / (TOM + Cstar_i/MW_i)
c  => SUM_i(C_i(tot) * TOM / (TOM + Cstar_i/MW_i)) + C_pre/MW_pre - TOM = 0
c
c Called by SOAP
c
      integer     n,i
      real        ct(n),cs(n),ca(n),mw(n),cpx,tom,fval
c
      fval = 0.0
      do i = 1, n
        ca(i) = ct(i) * tom / ( tom + cs(i) / mw(i) )
        fval  = fval + ca(i) / mw(i)
      enddo
      fval = fval + cpx - tom
c
      return
      end

      subroutine readchm
      use filunit
      use grid
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c     READCHM reads the CAMx chemistry parameter file, which defines
c     the chemical system to be simulated
c
c      Copyright Ramboll
c  
c     Modifications:
c        10/26/99  Added check for zero Henry's law constants to avoid a
c                  divide by 0 later in the code
c        10/20/00  Added CAMx version as first record on chemistry parameters
c                  file
c        1/9/02    Aerosol size cut points and density now defined on
c                  chemistry parameters file; removed conversion of aerosol
c                  BDNL values from ug/m3 to umol/m3
c        1/18/02   Added EC, PFIN, and PCRS to mechanism 4 species list
c        12/12/02  Expanded species list for Mechanism 4
c        3/26/03   Added surface resistance scaling factor to gas params
c        4/21/04   Incorporated sectional PM (Mech 4 CMU)
c        10/14/04  Added Mechanism 10 (user defined)
c        10/05/05  Split gas-phase mechanism ID and aerosol option string
c                  to separate records in the chemistry parameters file
c        12/29/06 -bkoo-     Expanded species list for the updated SOA scheme
c        01/10/07 -bkoo-     PM modules now linked to mechanisms 4 thru 6
c        07/04/07 -bkoo-     Added code to set pointer to hydrolysis of N2O5
c        12/15/08 -gwilson-  Added code to handle averaging of radicals
c        11/20/10 -gwilson-  Consolidated radical and concentration arrays
c        03/29/11 -cemery-   Revised to allow for inert PM with gas-phase
c                            chemistry and to support in-line TUV with
c                            aerosol optical depth
c        04/12/12 -cemery-   Added T and P adjustments to photolysis rates
c        01/15/13 -cemery-   Replaced gas "diffrat" with "Molwt"; diffrat now
c                            calculated from Molwt when read
c        04/12/13 -cemery-   Added surface model species/reactions
c        06/28/13 -bkoo-     Added mapping for new GREASD PiG chemistry
c        10/14/13 -bkoo-     Added code to set pointer to hydrolysis of organic nitrate
c        03/18/14 -bkoo-     Added species for benzene SOA
c        08/25/14 -cemery-   Added snow effects to surface model
c        12/07/14 -bkoo-     Added VBS option
c        01/08/16 -bkoo-     Updated for SAPRC99->SAPRC07TC
c                                        Revised VBS
c                                        Removal of IEH solver
c        02/29/16 -bkoo-     Added pointer to heterogeneous rxn of N2O5 + HCL
c        07/20/16 -bkoo-     Added pointer to heterogeneous hydrolysis of INTR
c        08/25/16 -bkoo-     Updated for new SOAP
c        09/02/16 -bkoo-     Added pointer to het rxn of SO2; revised het rxn pointers
c        11/28/16 -bkoo-     Revised VBS precursors
c        10/18/17 -cemery-   Restructured chemparam file header for explicit
c                            choice of PM size and chemistry options (removed
c                            original SOAP)
c        11/22/17 -bkoo-     Added PFE/PMN/PK/PCA/PMG
c        01/12/18 -bkoo-     Removed BNZA/TOLA/XYLA/ISP/TRP
c        07/23/18 -bkoo-     Check NH3 if Bi-Di NH3 is on
c        01/06/19 -cemery-   Added PAL/PSI/PTI
c        01/09/19 -cemery-   Added DMS to CB6r4 (remains Mech 4)
c        11/17/20 -cemery-   Moved definition of TUV photolysis file labels here
c        04/15/21 -gwilson-  Now puts molwt into global array to be used later
c        08/10/21 -gy-       Removed check ngas < mchgas because unhelpful
c        09/08/21 -cemery-   Enforce 8-character max on species names
c                            (to accomodate deposition prefixes)
c        01/20/22 -gwilson-  Added "blank" species names for traditional tracers
c        03/31/23 -gy-       Fix bug molwt_spc not re-ordered in species sort
c        11/03/23 -cemery-   Removed CMU PM option (only CB05 was plugged into CMU)
c        04/05/24 -cemery-   SOAP3: rename species, POA->HOA (unevaporated POA)
c                                   add SVOA (evaporated POA)
c                                   updated yields
c        05/16/24 -cemery-   All gas mechs include heterogeneous (M)GLY->CGLY for
c                            SOAP BOA0
c                            Differentiate TERP+NO3 reaction from TERP+OH/O3
c                            Add SOA yields from APIN
c        04/26/25 -gwilson-  Add SOAP precursor species IVC1, IVC2, HPAR
c        04/25/26 -gyarwood- Master species list for CAMx v7.4 (428 species)
c
c     Input arguments: 
c        none 
c 
c     Output arguments: 
c        none 
c            
c     Routines called: 
c        ALLOC_CHMSTRY
c        ALLOC_SRFMOD
c        AEROSET
c        CAMXERR
c        EXPTBL
c        KTHERM
c        JSTLFT
c        TOUPPER
c            
c     Called by:
c        STARTUP
c
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
      include 'ddmchm.inc'
      include 'lsbox.inc'
      include 'soap.inc'
      include 'vbs.inc'
      include 'soap3.inc'
c
      integer istrln
c
      integer, parameter :: NRADNM = 65
c
      character*180    record, recpht1
      character*10     nametmp, splist(NSPNAM), radlist(NRADNM,10)
      character*10     blank,camxv,camxvin
      character*10     gasopt,siaopt
      character*20     soaopt
      character*10     tmpnam, tmpnam1
      integer          mchactv(10), mchgas(10), mchaero(10), mchrad(10)
      integer          mchrxn(10), mchphot(10)
c
      integer          jno2s07, jno2cb6, jno2cb7, jno2rc2
      integer          jo3s07, jo3cb6, jo3cb7, jo3rc2
      integer          jhcho1s07, jhcho1cb6, jhcho1cb7, 
     &                 jhcho1rc2
      integer          jhcho2s07, jhcho2cb6, jhcho2cb7, 
     &                 jhcho2rc2
      integer          jch3chos07, jch3chocb6, jch3chocb7, 
     &                 jch3chorc2
      integer          ipigs07, ipigcb6, ipigcb7, ipigrc2
      integer, dimension(NRPIGCHEM) :: lrmaps07, lrmapcb6r4,
     &                                 lrmapcb7, lrmaprc2
      integer          ihet01_s07, ihet01_cb6, ihet01_cb7,
     &                 ihet01_rc2
      integer          ihet02_cb6r5h
      integer          ihet03_cb6r4, ihet03_cb7, ihet03_rc2
      integer          ihet04_cb6r4, ihet04_rc2
      integer          ihet05_cb6r4, ihet05_cb7, ihet05_rc2
      integer          ihet06_cb6r4, ihet06_cb6r5, ihet06_cb6r5h,
     &                 ihet06_cb7, ihet06_s07, ihet06_rc2
      integer          ihet07_cb6r4, ihet07_cb6r5, ihet07_cb6r5h,
     &                 ihet07_cb7, ihet07_s07, ihet07_rc2
      integer, dimension(NSOAPRXN) :: iksoap_cb6, iksoap_cb7, iksoap_rc2,
     &                                iksoap_s07
c
      integer          npar(7)
      integer          nsec_c,  nphot, nerr, nhit, iaero, ierr, iref
      integer          ncms, nppm, num, iunits, isec
      integer          i, j, l, nn, n, m, nl
      integer          ibin
      integer          rhadj_tmp
      real             tdum(3), pdum(3), tmp
      real             bdnl_tmp,roprt_tmp,bext_tmp,ssa_tmp,molwt_spc
      real*8           dsec_i(MXSECT+1)
c
      double precision rxnpar(MXREACT,12)
      real             kdum(MXREACT,3)
      integer          rxntyp(MXREACT)
      integer          rxnord(MXREACT)
c
c-----Data that define the mechanism/solver options:
c
      data camxv  /'VERSION7.4'/
      data blank  /'BLANK     '/
c
      data (splist(j),j=1,270)
     &            /'APO2      ','AUTX      ','BZO2      ',
     &             'C2O3      ','CGLY      ','CRO       ',
     &             'CXO3      ','DPAR      ','EPX2      ',
     &             'HO2       ','HPO2      ','I         ',
     &             'IO        ','ISO2      ','MEO2      ',
     &             'O         ','O1D       ','OH        ',
     &             'OIO       ','OPO3      ','RO2       ',
     &             'ROR       ','TO2       ','TPO2      ',
     &             'XLO2      ','XO2       ','XO2H      ',
     &             'XO2N      ','XPAR      ','XPRP      ',
     &             'BR        ','BRO       ','CL        ',
     &             'CLO       ','HCO3      ','ARPX      ',
     &             'BACL      ','DEE       ','DME       ',
     &             'EDOH      ','EH2       ','ESTR      ',
     &             'ETAC      ','ETFM      ','ETHR      ',
     &             'FVC1      ','HACT      ','HKET      ',
     &             'HPAR      ','IBTA      ','IPOH      ',
     &             'MEAC      ','MEFM      ','NPOH      ',
     &             'PDOH      ','ROH       ','SXD5      ',
     &             'TPRD      ','AACD      ','ACET      ',
     &             'ALD2      ','ALDX      ','BENZ      ',
     &             'CAT1      ','CO        ','CRES      ',
     &             'CRON      ','DMS       ','ECH4      ',
     &             'EPOX      ','ETH       ','ETHA      ',
     &             'ETHY      ','ETOH      ','FACD      ',
     &             'FORM      ','GLY       ','GLYD      ',
     &             'H2O2      ','HCL       ','HI        ',
     &             'HIO3      ','HNO3      ','HOI       ',
     &             'HONO      ','HPLD      ','I2        ',
     &             'I2O2      ','INO3      ','INTR      ',
     &             'IOLE      ','ISOP      ','ISPD      ',
     &             'ISPX      ','IXOY      ','KET       ',
     &             'MEOH      ','MEPX      ','MGLY      ',
     &             'N2O5      ','NH3       ','NO        ',
     &             'NO2       ','NO3       ','NTR1      ',
     &             'NTR2      ','O3        ','OLE       ',
     &             'OPAN      ','OPEN      ','PACD      ',
     &             'PAN       ','PANX      ','PAR       ',
     &             'PNA       ','PRPA      ','ROOH      ',
     &             'SO2       ','SQT       ','SULF      ',
     &             'TERP      ','TOL       ','XOPN      ',
     &             'XYL       ','ACG1      ','ACG2      ',
     &             'AOA0      ','AOA1      ','AOA2      ',
     &             'BCG1      ','BCG2      ','BOA0      ',
     &             'BOA1      ','BOA2      ','CCRS      ',
     &             'CPRM      ','FCRS      ','FPRM      ',
     &             'HOA       ','IVC1      ','IVC2      ',
     &             'IVOA      ','NA        ','PAL       ',
     &             'PCA       ','PCL       ','PEC       ',
     &             'PFE       ','PH2O      ','PK        ',
     &             'PMG       ','PMN       ','PNH4      ',
     &             'PNO3      ','PSI       ','PSO4      ',
     &             'PTI       ','SVOA      ','CG1       ',
     &             'CG2       ','CG3       ','CG4       ',
     &             'POA       ','SOA1      ','SOA2      ',
     &             'SOA3      ','SOA4      ','SOPA      ',
     &             'SOPB      ','NTR       ','BR2       ',
     &             'BRCL      ','BRN2      ','BRN3      ',
     &             'CH3I      ','CL2       ','CLAD      ',
     &             'CLAO      ','CLN2      ','CLN3      ',
     &             'FMBR      ','FMCL      ','HBR       ',
     &             'HOBR      ','HOCL      ','IALK      ',
     &             'IBR       ','ICL       ','INO2      ',
     &             'MB2       ','MB2C      ','MB3       ',
     &             'MBC       ','MBC2      ','MI2       ',
     &             'MIB       ','MIC       ','SSBR      ',
     &             'SSCL      ','SSN3      ','HG0       ',
     &             'HG2       ','HGIIP     ','HGIIPC    ',
     &             'HGP       ','IVOB      ','IVOD      ',
     &             'IVOG      ','PAP0      ','PAP1      ',
     &             'PAP2      ','PAP3      ','PAP4      ',
     &             'PAS0      ','PAS1      ','PAS2      ',
     &             'PAS3      ','PAS4      ','PBS0      ',
     &             'PBS1      ','PBS2      ','PBS3      ',
     &             'PBS4      ','PCP0      ','PCP1      ',
     &             'PCP2      ','PCP3      ','PCP4      ',
     &             'PFP0      ','PFP1      ','PFP2      ',
     &             'PFP3      ','PFP4      ','VAP1      ',
     &             'VAP2      ','VAP3      ','VAP4      ',
     &             'VAS1      ','VAS2      ','VAS3      ',
     &             'VAS4      ','VBS1      ','VBS2      ',
     &             'VBS3      ','VBS4      ','VCP1      ',
     &             'VCP2      ','VCP3      ','VCP4      ',
     &             'VFP1      ','VFP2      ','VFP3      ',
     &             'VFP4      ','ACO3      ','ACTP      ',
     &             'ADCN      ','ADDC      ','APIP      ',
     &             'BAL1      ','BAL2      ','BALP      ',
     &             'BENP      ','CHO       ','ETEP      ',
     &             'ETHP      ','HC3P      ','HC5P      ',
     &             'HC8P      ','KETP      ','LIMP      '/
      data (splist(j),j=271,NSPNAM)
     &            /'MACP      ','MCP       ','MCTO      ',
     &             'MCTP      ','MEKP      ','MO2       ',
     &             'MVKP      ','OLIP      ','OLND      ',
     &             'OLNN      ','OLTP      ','ORAP      ',
     &             'PER1      ','PER2      ','TLP1      ',
     &             'TOLP      ','TR2       ','UALP      ',
     &             'XY2       ','XYL1      ','XYLP      ',
     &             'XYO2      ','XYOP      ','ACD       ',
     &             'ACE       ','ACT       ','ALD       ',
     &             'API       ','BEN       ','CSL       ',
     &             'DCB1      ','DCB2      ','DCB3      ',
     &             'DIEN      ','EOH       ','EPX       ',
     &             'ETE       ','ETEG      ','HC3       ',
     &             'HC5       ','HC8       ','HNO4      ',
     &             'ISHP      ','ISO       ','ISON      ',
     &             'LIM       ','MAHP      ','MCT       ',
     &             'MOH       ','NALD      ','OLI       ',
     &             'OLT       ','ONIT      ','OP1       ',
     &             'OP2       ','ORA1      ','ORA2      ',
     &             'PAA       ','PHEN      ','PPN       ',
     &             'UALD      ','XYM       ','XYO       ',
     &             'XYP       ','BZC3      ','BZO       ',
     &             'MAC3      ','MCO3      ','O3P       ',
     &             'RCO3      ','RO2C      ','RO2X      ',
     &             'TBUO      ','XACE      ','XACR      ',
     &             'XAF1      ','XAF2      ','XAF3      ',
     &             'XBAC      ','XBAL      ','XCCH      ',
     &             'XCO       ','XGLD      ','XGLY      ',
     &             'XHCH      ','XHO2      ','XIPR      ',
     &             'XMA3      ','XMAC      ','XMC3      ',
     &             'XMEK      ','XMEO      ','XMGL      ',
     &             'XMVK      ','XNO2      ','XOH       ',
     &             'XPD2      ','XRC3      ','XRCH      ',
     &             'XRN3      ','XTBU      ','Y6PX      ',
     &             'YAPX      ','YRPX      ','ZRN3      ',
     &             'ACRO      ','ACYE      ','AFG1      ',
     &             'AFG2      ','AFG3      ','ALK1      ',
     &             'ALK2      ','ALK3      ','ALK4      ',
     &             'ALK5      ','APIN      ','ARO1      ',
     &             'ARO2      ','B124      ','BALD      ',
     &             'BD13      ','CCHO      ','CO3H      ',
     &             'COOH      ','ETHE      ','HCHO      ',
     &             'IPRD      ','MACR      ','MEK       ',
     &             'MPAN      ','MVK       ','MXYL      ',
     &             'NPHE      ','OLE1      ','OLE2      ',
     &             'OXYL      ','PAN2      ','PBZN      ',
     &             'PRD2      ','PRPE      ','PXYL      ',
     &             'R6PX      ','RAPX      ','RCHO      ',
     &             'RNO3      ','RO3H      ','SESQ      ',
     &             'TOLU      ','XN        ','TR01      ',
     &             'TR02      ','TR03      ','TR04      ',
     &             'TR05      ','TR06      ','TR07      ',
     &             'TR08      ','TR09      '/
c
      data (radlist(j,1),j=1,26)
     &            /'O1D       ','O         ','I         ',
     &             'IO        ','OIO       ','OH        ',
     &             'HO2       ','C2O3      ','XO2       ',
     &             'XO2N      ','CXO3      ','MEO2      ',
     &             'TO2       ','ROR       ','HCO3      ',
     &             'CRO       ','BZO2      ','EPX2      ',
     &             'ISO2      ','OPO3      ','RO2       ',
     &             'XLO2      ','XO2H      ','XPRP      ',
     &             'XPAR      ','CGLY      '/
      data (radlist(j,3),j=1,28)
     &            /'O1D       ','O         ','CL        ',
     &             'CLO       ','BR        ','BRO       ',
     &             'I         ','IO        ','OIO       ',
     &             'OH        ','HO2       ','C2O3      ',
     &             'XO2       ','XO2N      ','CXO3      ',
     &             'MEO2      ','TO2       ','ROR       ',
     &             'HCO3      ','CRO       ','BZO2      ',
     &             'EPX2      ','ISO2      ','OPO3      ',
     &             'RO2       ','XLO2      ','XO2H      ',
     &             'CGLY      '/
      data (radlist(j,4),j=1,26)
     &            /'O1D       ','O         ','I         ',
     &             'IO        ','OIO       ','OH        ',
     &             'HO2       ','C2O3      ','XO2       ',
     &             'XO2N      ','CXO3      ','MEO2      ',
     &             'TO2       ','ROR       ','HCO3      ',
     &             'CRO       ','BZO2      ','EPX2      ',
     &             'ISO2      ','OPO3      ','RO2       ',
     &             'XLO2      ','XO2H      ','XPRP      ',
     &             'XPAR      ','CGLY      '/
      data (radlist(j,5),j=1,46)
     &            /'O1D       ','O3P       ','OH        ',
     &             'HO2       ','MCO3      ','RCO3      ',
     &             'MEO2      ','TBUO      ','BZO       ',
     &             'BZC3      ','MAC3      ','RO2C      ',
     &             'RO2X      ','XHO2      ','XOH       ',
     &             'XACE      ','XACR      ','XAF1      ',
     &             'XAF2      ','XAF3      ','XBAC      ',
     &             'XBAL      ','XCCH      ','XCO       ',
     &             'XGLD      ','XGLY      ','XHCH      ',
     &             'XIPR      ','XMA3      ','XMAC      ',
     &             'XMC3      ','XMEK      ','XMEO      ',
     &             'XMGL      ','XMVK      ','XNO2      ',
     &             'XPD2      ','XRC3      ','XRCH      ',
     &             'XRN3      ','XTBU      ','YRPX      ',
     &             'Y6PX      ','YAPX      ','ZRN3      ',
     &             'CGLY      '/
      data (radlist(j,7),j=1,29)
     &            /'O1D       ', 'O         ', 'OH        ',
     &             'HO2       ', 'C2O3      ', 'CXO3      ',
     &             'OPO3      ', 'MEO2      ', 'XO2       ',
     &             'XO2H      ', 'XO2N      ', 'ISO2      ',
     &             'APO2      ', 'TPO2      ', 'HPO2      ',
     &             'EPX2      ', 'BZO2      ', 'TO2       ',
     &             'XLO2      ', 'DPAR      ', 'RO2       ',
     &             'XPAR      ', 'CRO       ', 'ROR       ',
     &             'AUTX      ', 'CGLY      ',
     &             'I         ', 'IO        ', 'OIO       '/
      data (radlist(j,9),j=1,48)
     &            /'O1D       ', 'O         ', 'ADCN      ',
     &             'ADDC      ', 'APIP      ', 'BAL1      ',
     &             'BAL2      ', 'BALP      ', 'BENP      ',
     &             'CHO       ', 'ETEP      ', 'ETHP      ',
     &             'HC3P      ', 'HC5P      ', 'HC8P      ',
     &             'HO2       ', 'ISOP      ', 'KETP      ',
     &             'LIMP      ', 'MACP      ', 'MCP       ',
     &             'MCTO      ', 'MCTP      ', 'MEKP      ',
     &             'MO2       ', 'MVKP      ', 'ACO3      ',
     &             'ACTP      ', 'OH        ', 'OLIP      ',
     &             'OLND      ', 'OLNN      ', 'OLTP      ', 
     &             'ORAP      ', 'PER1      ', 'PER2      ',
     &             'RCO3      ', 'TLP1      ', 'TOLP      ',
     &             'TR2       ', 'UALP      ', 'XO2       ',
     &             'XY2       ', 'XYL1      ', 'XYLP      ',
     &             'XYO2      ', 'XYOP      ', 'CGLY      '/
c
      data (soap2_spec_names(j),j=1,NUM_SOAP_SPECIES)
     &            /'POA       ',
     &             'SOPA      ',
     &             'SOPB      ',
     &             'SOA2      ',
     &             'SOA1      ',
     &             'SOA4      ',
     &             'SOA3      ',
     &             'CG1       ',
     &             'CG2       ',
     &             'CG3       ',
     &             'CG4       '/
      data (soap3_spec_names(j),j=1,NUM_SOAP_SPECIES)
     &            /'HOA       ',
     &             'AOA0      ',
     &             'BOA0      ',
     &             'AOA1      ',
     &             'AOA2      ',
     &             'BOA1      ',
     &             'BOA2      ',
     &             'ACG2      ',
     &             'ACG1      ',
     &             'BCG2      ',
     &             'BCG1      '/
      data soap_emiss_names(IDX_SOAP_IVOC)   /'IVOC'/
      data soap_emiss_names(IDX_SOAP_IVOD)   /'IVOD'/
      data soap_emiss_names(IDX_SOAP_IVOA)   /'IVOA'/
      data soap_emiss_names(IDX_SOAP_IVC1)   /'IVC1'/
      data soap_emiss_names(IDX_SOAP_IVC2)   /'IVC2'/
      data soap_emiss_names(IDX_SOAP_IVOB)   /'IVOB'/
      data soap_emiss_names(IDX_SOAP_POA_OP) /'POA_OP'/
      data soap_emiss_names(IDX_SOAP_POA_GV) /'POA_GV'/
      data soap_emiss_names(IDX_SOAP_POA_DV) /'POA_DV'/
      data soap_emiss_names(IDX_SOAP_POA_MC) /'POA_MC'/
      data soap_emiss_names(IDX_SOAP_POA_IC) /'POA_IC'/
      data soap_emiss_names(IDX_SOAP_POA_AV) /'POA_AV'/
      data soap_emiss_names(IDX_SOAP_POA_BB) /'POA_BB'/
c
c-----Specify dimensions of each mechanism
c
      data mchrad   / 25,  0, 27, 25, 45,  0, 29,  0, 47,  0 /
      data mchrxn   /239,  0,332,238,567,  0,265,  0,374,  0 /
      data mchphot  / 34,  0, 54, 34, 41,  0, 37,  0, 34,  0 /
c
c-----Point to the NO + NO + O2 reaction within main mechanisms
c
      data ipigs07,ipigcb6,ipigcb7,ipigrc2
     &                              / 10, 24, 24, 52 /
c
c-----Pointers to heterogeneous reactions within main mechanisms
c
      data ihet01_s07,ihet01_cb6,ihet01_cb7,ihet01_rc2
     &                                  / 13, 39, 37, 65 / ! N2O5 + H2O -> 2 HNO3
      data ihet02_cb6r5h                           / 237 / ! N2O5 + HCL -> CLN2 + HNO3
      data ihet03_cb6r4,ihet03_cb7,ihet03_rc2
     &                                    / 207, 97, 371 / ! NTR2 -> HNO3
      data ihet04_cb6r4,ihet04_rc2              / 229, 0 / ! INTR -> HNO3
      data ihet05_cb6r4,ihet05_cb7,ihet05_rc2
     &                                    / 230, 52, 369 / ! SO2 -> SULF
      data ihet06_cb6r4,ihet06_cb6r5,ihet06_cb6r5h,ihet06_CB7,ihet06_s07,ihet06_rc2
     &                   / 234, 235, 328, 264, 566, 373 /  ! GLY -> CGLY
      data ihet07_cb6r4,ihet07_cb6r5,ihet07_cb6r5h,ihet07_CB7,ihet07_s07,ihet07_rc2
     &                   / 235, 236, 329, 265, 567, 374 /  ! MGLY -> CGLY
c
c-----Pointers to photolysis reactions with pressure adjustments
c
      data jno2s07,jno2cb6,jno2cb7,jno2rc2
     &                                  /  1, 1, 1, 1/
      data jo3s07,jo3cb6,jo3cb7,jo3rc2
     &                                  / 18, 9, 9, 3/
      data jhcho1s07,jhcho1cb6,jhcho1cb7,jhcho1rc2
     &                              /204, 97, 101, 11/
      data jhcho2s07,jhcho2cb6,jhcho2cb7,jhcho2rc2
     &                              /205, 98, 102, 10/
      data jch3chos07,jch3chocb6,jch3chocb7,jch3chorc2
     &                             /209, 106, 106, 12/
c
c-----Cross-reference PiG reactions to main mechanisms
c
      data lrmaps07  /  1,  2,  7, 10,  0, 18, 21, 20, 23, 25,
     &                  8, 17, 16,  9, 15, 11, 12, 13, 44, 29,
     &                204,205, 31 /
      data lrmapcb6r4 / 1,  2,  3, 24, 41,  9, 10, 11, 43, 45,
     &                 26, 27, 28, 29, 30, 36, 37, 39, 52,120,
     &                 97, 98, 25 /
      data lrmapcb7   / 1,  2,  3, 24,  0,  9, 10, 11, 39, 41,
     &                 26, 27, 28, 29, 30, 34, 35, 37, 51, 50,
     &                 101, 102, 25 /
      data lrmaprc2   / 1, 38, 36, 52,  0,  3, 41, 42,  7, 56,
     &                 37,  5,  6, 60, 61, 63, 64, 65, 69, 70,
     &                 11, 10, 50 /
c
c-----Cross-reference SOAP reactions to main mechanisms
c
c 19 reactions in this order
c
c 1       BNZA + OH
c 2       TOLA + OH
c 3       XYLA + OH
c 4       ISP + OH
c 5       ISP + O3
c 6       ISP + NO3
c 7       TRP + OH
c 8       TRP + O3
c 9       TRP + NO3
c 10      SQT + /OH
c 11      SQT + O3
c 12      SQT + NO3
c 13      APN + OH
c 14      APN + O3
c 15      APN + NO3
c 16      HPAR + OH
c 17      FVC1 + OH
c 18      FVC1 + O3
c 19      FVC1 + NO3
c
      data iksoap_cb6 /167, 172, 177, 143, 149, 150, 164, 165, 166,
     &                 237, 238, 239,  -9,  -9,  -9,  -9,  -9,  -9,
     &                  -9/
      data iksoap_cb7 /148, 152, 156, 178, 183, 184, 202, 206, 207,
     &                 208, 209, 210, 196, 200, 201, 230, 261, 262,
     &                 263/
      data iksoap_rc2 / 81,  82,  84,  86, 130, 145, 88,  132, 147,
     &                  -9,  -9,  -9,  87, 131, 146,  -9,  -9,  -9,
     &                  -9/
      data iksoap_s07 /536, 537, 540, 526, 527, 528, 558, 559, 560,
     &                 562, 563, 564, 530, 531, 532,  -9,  -9,  -9,
     &                  -9/
c
c-----Parameters for rate constant expressions and diagnostics
c
      data npar     /  1,  2,  4, 10,  5, 12,  8 /
      data tdum     / 298.,  273.,  273. /
      data pdum     / 1013., 1013., 500. /
c
c     Many rules about names, number and order of species are 
c     enforced here unless LCHEM is false.
c
c     Arrays MCHGAS, MCHAERO, MCHRXN and MCHPHOT allow for up to 10
c     gas-phase mechanisms to be called by RADDRIVR and CHEMDRIV.
c     The current mechanisms are:
c      1 = CB6r5
c      2 = Inactive
c      3 = CB6r5h (includes halogens)
c      4 = CB6r4
c      5 = SAPRC07TC
c      6 = Inactive
c      7 = CB7r3
c      8 = Inactive
c      9 = RACM2
c     10 = User-defined chemistry and species list
c
c     Radical species will be re-ordered according to the order defined
c     in RADLIST.
c     Only the species that are named in SPLIST will be allowed.
c     Update CHMDAT.INC & DDMCHM.INC if new species are added to SPLIST
c
c-----Entry point
c
      idmech = 0
      nphot1 = 0
      nphot2 = 0
      read(ichem,'(a)') record
      camxvin = record(21:30)
      call jstlft(camxvin)
      call toupper(camxvin)
      if (camxvin.ne.camxv) then
        write(iout,'(/,a)') ' CAMx version in CHEMPARAM file is INVALID'
        write(iout,'(a,a)') ' Expecting: ',camxv
        write(iout,'(a,a)') '     Found: ',camxvin
        goto 910
      endif
c
c-----Gas Mechanism ID
c
      read(ichem,'(a)') record
      read(record(21:80),'(a)',ERR=110,END=110) gasopt
      call jstlft(gasopt)
      call toupper(gasopt)
 110  continue
      if (lchem) then
        if (gasopt.NE.'CB6R5H'    .and.
     &      gasopt.NE.'CB6R5'     .and.
     &      gasopt.NE.'CB7R3'     .and.
     &      gasopt.NE.'RACM2'     .and.
     &      gasopt.NE.'SAPRC07TC' .and.
     &      gasopt.NE.'MECH10') then
          write(iout,'(/,3a)') ' Invalid gas chemistry mechanism',
     &                       ' in CHEMPARAM input file: ',gasopt
          if( gasopt .EQ. ' ' ) then
            write(iout,'(a)') ' You must specify the gas mechanism.'
          endif
          write(iout,'(a,10(/,10x,a))') 'Acceptable options are: ',
     &                           'CB6r5H   ',
     &                           'CB6r5    ',
     &                           'CB7r3    ',
     &                           'RACM2    ',
     &                           'SAPRC07TC',
     &                           'MECH10'
          goto 910
        endif
        if (gasopt.EQ.'CB6R5') then
          idmech = 1 
          tuvlabl = 'TUV4.8CAMx7.40_CB6r5'
        elseif (gasopt.EQ.'CB6R5H') then
          idmech = 3
          tuvlabl = 'TUV4.8CAMx7.40_CB6r5'
        elseif (gasopt.EQ.'CB6R4') then
          idmech = 4
          tuvlabl = 'TUV4.8CAMx7.40_CB6r4'
        elseif (gasopt.EQ.'SAPRC07TC') then
          idmech = 5
          tuvlabl = 'TUV4.8CAMx7.40_SPR07'
        elseif (gasopt.EQ.'CB7R3') then
          idmech = 7
          tuvlabl = 'TUV4.8CAMx7.40_CB7r3'
        elseif (gasopt.EQ.'RACM2') then
          idmech = 9
          tuvlabl = 'TUV4.8CAMx7.40_RACM2'
        elseif (gasopt.EQ.'MECH10') then
          idmech = 10
          tuvlabl = 'TUV4.8CAMx7.40_OSPM'
        endif

        write(iout,'(/,2a)') 'Gas Chemistry Mechanism      :',gasopt
        write(idiag,'(a,i4)')'Mechanism ID                 :',idmech
 
        nrad = 0
        if (idmech.eq.10) then
          write(iout,'(/,a,/,a)') ' You selected Mechamism 10:',
     &         ' This will use your customized CAMx/chem10.f subroutine'
        elseif ((idmech.eq.1 .OR. idmech.eq.3 .OR. idmech.eq.4 .OR.
     &        idmech.eq.7) .AND. .NOT.lixemis .AND. .NOT.lixbypass) then
          write(iout,'(/,a)') ' WARNING in READCHM:'
          write(iout,'(a)')
     &      ' You selected CB6r5, CB6r5h, CB6r4 or CB7r3,'
          write(iout,'(a)')' BUT did not turn on in-line Ix emissions.'
          write(iout,'(2a)')' Be sure to provide I2 and HOI emissions',
     &                     ' externally.'
        endif
        nrad = mchrad(idmech)      ! need to know NRAD for advection, etc.
        if (nrad.GT.NRADNM) then
          write(iout,'(/,2a)')'Number of radical species is ',
     &                        'greater than internal dimension.'
          write(iout,'(a,i3)') 'Number of radical species  : ',nrad
          write(iout,'(a,i3)') 'Maximum dimension (NRADNM) : ',NRADNM
          write(iout,'(2a)')'Increase the parameter NRADNM ',
     &                                   'in READCHM.F and recompile.'
          goto 910
        endif
      endif
c
c-----Options for the aerosol treatment: 'NONE','INERT','CF'
c
      read(ichem,'(a)') record
      read(record(21:80),'(a)',ERR=111,END=111) aeropt
      call jstlft(aeropt)
      call toupper(aeropt)
 111  continue
      if (aeropt.NE.'CF'     .and. 
     &    aeropt.NE.'NONE'   .and.
     &    aeropt.NE.'INERT') then
        write(iout,'(/,3a)') ' Invalid option for aerosol treatment',
     &                       ' in CHEMPARAM input file: ',aeropt
        if( aeropt .EQ. ' ' ) then
           write(iout,'(a)') ' You must specify the aerosol treatment.'
        endif
        write(iout,'(a,4(/,10x,a))') 'Acceptable options are: ',
     &                           'NONE     - None (NAERO must = 0)',
     &                           'INERT    - Inert PM',
     &                           'CF       - Static Coarse/Fine scheme'
        goto 910
      endif
      if (idmech.EQ.10 .and. (aeropt.EQ.'CF')) then
        write(iout,'(/,3a)') ' Invalid option for aerosol treatment',
     &                       ' in CHEMPARAM input file: ',aeropt
        write(iout,'(a,2(/,10x,a))') 'Acceptable options for MECH10: ',
     &      'NONE  - None (NAERO must = 0)',
     &      'INERT - Inert PM (PM chemistry performed in CAMx/chem10.f)'
        goto 910
      endif
      write(idiag,'(2a)')  'Aerosol Treatment            :',aeropt
c
c-----Options for Inorganic PM chemistry: 'ISORROPIA' or 'EQSAM'
c
      read(ichem,'(a)') record
      read(record(21:80),'(a)',ERR=112,END=112) siaopt
      call jstlft(siaopt)
      call toupper(siaopt)
 112  if (aeropt.NE.'NONE' .and. aeropt.NE.'INERT') then
        if (siaopt.NE.'ISORROPIA'.and. siaopt.NE.'EQSAM') then
          write(iout,'(/,3a)') ' Invalid option for inorganic PM',
     &                         ' chemistry in CHEMPARAM input file: ',
     &                         siaopt
          if( siaopt .EQ. ' ' ) then
             write(iout,'(2a)') ' You must specify the inorganic PM',
     &                          ' chemistry.'
          endif
          write(iout,'(2a,2(/,10x,a))') 'Acceptable inorganic PM',
     &                                  ' chemistry options are: ',
     &                           'ISORROPIA - ISORROPIA scheme',
     &                           'EQSAM     - EQSAM4clim scheme'
          goto 910
        endif
      else
        write(iout,'(/,2a)') ' Inorganic PM chemistry is ignored for',
     &                       ' aerosol options NONE and INERT'
      endif
      leqsam = .false.
      if (siaopt.EQ.'EQSAM') leqsam = .true.
      write(idiag,'(2a)')  'Inorganic PM Chemistry       :',siaopt
c
c-----Options for SOA chemistry: 'SOAP3.0' or 'VBS'
c
      read(ichem,'(a)') record
      read(record(21:80),'(a)',ERR=113,END=113) soaopt
      call jstlft(soaopt)
      call toupper(soaopt)
 113  if (aeropt.NE.'NONE' .and. aeropt.NE.'INERT') then
        if(  soaopt.NE.'SOAP3_COMPLX' .and.
     &       soaopt.NE.'SOAP3_COMPLX_NOEVAP' .and.
     &       soaopt.NE.'SOAP3_SIMPLE' .and. 
     &       soaopt.NE.'SOAP3_SIMPLE_NOEVAP' .and.
     &       soaopt.NE.'1.5DVBS') then
          write(iout,'(/,3a)') ' Invalid option for SOA chemistry',
     &                         ' in CHEMPARAM input file: ',soaopt
          if( soaopt .EQ. ' ' ) then
             write(iout,'(a)') ' You must specify the SOA chemistry.'
          endif
          write(iout,'(a,5(/,10x,a))') 'Acceptable SOA options are: ',
     &       'SOAP3_SIMPLE         - SOAP3 non-volatile SOA, POA evap',
     &       'SOAP3_SIMPLE_NOEVAP  - SOAP3 non-volatile SOA, no POA evap',
     &       'SOAP3_COMPLX         - SOAP3 volatile SOA, POA evap',
     &       'SOAP3_COMPLX_NOEVAP  - SOAP3 volatile SOA, no POA evap',
     &       '1.5DVBS              - 1.5D Volatility Basis Set'
          goto 910
        endif
      else
        write(iout,'(/,2a)') ' SOA chemistry is ignored for aerosol',
     &                       ' options NONE and INERT'
      endif
      lvbs   = .false.
      luse_soap3 = .FALSE.
      luse_soap3_simple = .FALSE.
      luse_soap3_complx = .FALSE.
      if (soaopt.EQ.'1.5DVBS') lvbs = .true.
      if( soaopt(1:12) .EQ. 'SOAP3_SIMPLE' ) then
         luse_soap3_simple = .TRUE.
         luse_soap3 = .TRUE.
      endif
      if( soaopt(1:12) .EQ. 'SOAP3_COMPLX' ) then
         luse_soap3_complx = .TRUE.
         luse_soap3 = .TRUE.
      endif
      if( soaopt(1:5) .EQ. 'SOAP3') then
         if( soaopt(13:) .EQ. '_NOEVAP') then
           do n = IDX_SOAP_POA_OP, IDX_SOAP_POA_BB
             do i = 1,2
               soap3_evap_factors(i,n) = 0.
             enddo
             soap3_evap_factors(3,n) = 1.
           enddo
         else
           do n = IDX_SOAP_POA_OP, IDX_SOAP_POA_BB
             do i = 1,3
               soap3_evap_factors(i,n) = soap3_evap_factors_complx(i,n)
             enddo
           enddo
         endif
         if (idmech.eq.1 .OR. idmech.eq.3 .OR. idmech.eq.4) then
           iksoap = iksoap_cb6
         elseif (idmech.eq.5) then
           iksoap = iksoap_s07
         elseif (idmech.eq.7) then
           iksoap = iksoap_cb7
         elseif (idmech.eq.9) then
           iksoap = iksoap_rc2
         elseif (idmech.eq.10) then
           write(iout,'(/,a)')'SOAP cannot be run with Mechanism 10'
           goto 910
         else
           if( lchem ) then
               write(iout,'(/,a,i3)')
     &                 'Dont know how to set SOAP rxns for mech #', idmech
               goto 910
           endif
         endif
      endif
      write(idiag,'(2a)')  'Organic PM Chemistry         :',soaopt
c
      read(ichem,'(a)') record
      write(idiag,'(2a)') 'Description                  :',
     &                    record(21:istrln(record))
      ncf_chemistry = record(21:istrln(record))
c
c-----Number of species
c
      read(ichem,'(a)') record
      read(record(21:80),*) ngas
      read(ichem,'(a)') record
      read(record(21:80),*) naero
      nspec = ngas + naero
      if (nspec.lt.1) then
        write(iout,'(/,a,i5,a)')
     &    ' Number of GAS + AERO species on CHEMPARAM file =', nspec,
     &    ' is less than 1'
          goto 910
      endif
      if (naero.EQ.0 .AND. (aeropt.EQ.'CF' .OR.
     &                      aeropt.EQ.'INERT')) then
        write(iout,'(//A)')
     &  ' Number of aerosols = 0 for CF or INERT PM options'
        write(iout,'(a)') ' Set aerosol treatment to NONE'
        goto 910
      endif
      if (naero.GT.0) then
        if (aeropt.EQ.'NONE') then
          write(iout,'(//A)')
     &      ' Aerosol species are requested with aerosol option = NONE'
          write(iout,'(a,2(/,10x,a))') 'Acceptable aerosol options: ',
     &                            'INERT  - Inert PM',
     &                            'CF     - Static Coarse/Fine scheme'
          goto 910
        endif
        read(record(21:),*,ERR=903,END=903) naero,dtaero,nsec_c,
     &                      (dsec_i(i),i=1,nsec_c+1)
        nbin = nsec_c
        write(idiag,'(a,i4)')   'Number of Aerosol Species    :',naero
        write(idiag,'(a,f5.1)') 'Aerosol Coupling Freq (min)  :',dtaero
        write(idiag,'(a,i4)')   'Number of Aerosol Size bins  :',nbin
      endif
      if( nspec .GT. MXSPEC ) then
         write(iout,'(//,A)') 'ERROR in READCHM:'
         write(iout,'(2a)') 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter MXSPEC: ',MXSPEC
         write(iout,*) 'It should be set to a value of at least: ',nspec
         goto 910
      endif
c
c-----Read number of reactions and check that the dimension parameter is large enough
c
      read(ichem,'(a)') record
      read(record(21:80),*) nreact
      if( nreact .GT. MXREACT ) then
         write(iout,'(//,A)') 'ERROR in READCHM:'
         write(iout,'(2a)') 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter MXREACT: ',MXREACT
         write(iout,*) 'It should be set to a value of at least: ',nreact
         goto 910
      endif
c
c-----Check number of species and number of reactions against chosen mechanism
c 
      if (lchem) then
c        if (ngas.gt.mchgas(idmech)) then
c          write(iout,'(/,a,i5,/,a,i5)')
c     &     ' Number of GAS species in CHEMPARAM file =', ngas,
c     &     ' greater than ngas for this mechanism =', mchgas(idmech)
c          goto 910
c        endif
c
c       if (aeropt.NE.'NONE' .AND. aeropt.NE.'INERT' .AND.
c    &      naero.gt.mchaero(idmech)) then
c         write(iout,'(/,a,i5,/,a,i5)')
c    &     ' Number of AERO species on CHEMPARAM file =', naero,
c    &     ' Max allowed for this mechanism =', mchaero(idmech)
c         goto 910
c       endif
c
        if (nreact.ne.mchrxn(idmech)) then
          write(iout,'(/,a,i5,/,a,i5)')
     &     ' Number of reactions on CHEMPARAM file =',nreact,
     &     ' not equal to reactions for this mechanism =',mchrxn(idmech)
          goto 910
        endif
      endif
c
c-----Read primary photolysis ID record
c
      read(ichem,'(a)') recpht1
      if( lchem ) read(recpht1(21:80),*) nphot1
c
c-----Read secondary (scaled) photolysis ID records
c
      read(ichem,'(a)') record
      read(record(21:80),*) nphot2
      if( lchem ) then
         if (nphot2.gt.0) then
           if (nphot1.eq.0) then
             write(iout,'(/,a)')
     &           'Need at least one primary photolysis reaction'
             goto 910
           endif
         endif
      endif
      nphot = nphot1 + nphot2
c
c-----Call routine to allocate the arrays
c
      call alloc_chmstry(ngrid,nspec,nemiss_files,npoint_files,
     &                                      nreact,nphot1,nphot2)
      mole_weight = 1.0
c
c-----Check photolysis ID records
c
      if( nphot .GT. 0 ) then
c
        if( idmech .GT. 0 ) then
           if(nphot.ne.mchphot(idmech)) then
             write(iout,'(/,a,i5,/,a,i5)')
     &        ' Chemistry mechanism requires', mchphot(idmech),
     &        ' photolysis reactions, but CHEMPARAM file has' , nphot
             goto 910
           endif
        endif
c
        if( lchem ) then
           if (nphot.ne.mchphot(idmech)) then
             write(iout,'(/,a,i5,/,a,i5)')
     &           ' Chemistry mechanism requires', mchphot(idmech),
     &        ' photolysis reactions, but CHEMPARAM file has' , nphot
             goto 910
           endif
        endif
c
        if (nphot1.gt.MXPHT1) then
          write(iout,'(2a)')'Number of photolysis reactions is ',
     &                              'greater than internal dimensions.'
          write(iout,'(a,i3)') 'Number of reactions needed  : ',nphot1
          write(iout,'(a,i3)') 'Maximum dimension (MXPHT1)  : ',MXPHT1
          write(iout,'(2a)')'Increase the parameter MXPHT1 ',
     &                                   'in CAMx.PRM and recompile.'
          goto 910
        endif
c
        if (nphot2.gt.MXPHT2) then
          write(iout,'(/,a,i5)') 
          write(iout,'(2a)')'Number of photolysis reactions is ',
     &                              'greater than internal dimensions.'
          write(iout,'(a,i3)') 'Number of reactions needed  : ',nphot2
          write(iout,'(a,i3)') 'Maximum dimension (MXPHT2)  : ',MXPHT2
          write(iout,'(2a)')'Increase the parameter MXPHT2 ',
     &                                   'in CAMx.PRM and recompile.'
          goto 910
        endif
c
c-----Read primary photolysis ID record
c
        if (nphot1.gt.0) then
          read(recpht1(21:180),*) nphot1,(idphot1(n),n=1,nphot1)
          write(idiag,'(a)') 'The primary photolysis reactions are'
          write(idiag,'(i6)') (idphot1(n),n=1,nphot1)
        endif
c
c-----Read secondary (scaled) photolysis ID records
c
        if (nphot2.gt.0) then
          do n = 1,nphot2
            read(ichem,'(a)') record
            if( lchem ) read(record(21:80),*) idphot2(n),idphot3(n),phtscl(n)
          enddo
          if( lchem ) then
             write(idiag,'(a)') 'The secondary photolysis reactions are'
             write(idiag,'(i6,a,i6,a,1pe10.3)')
     &            (idphot2(n),' =',idphot3(n),' *',phtscl(n),n=1,nphot2)
           endif
        endif
c
        if( lchem ) then
           nerr = 0
           do n = 1,nphot1
             if (idphot1(n).gt.nreact) nerr = 1
           enddo
c
           do n = 1,nphot2
             if (idphot2(n).gt.nreact) nerr = 1
             if (idphot3(n).gt.nreact) nerr = 1
             nhit = 0
             do nn = 1,nphot1
               if (idphot3(n).eq.idphot1(nn)) nhit = 1
             enddo
             if (nhit.eq.0) nerr = 1
           enddo
c
           if (nerr.eq.1) then
              write(iout,'(/,a)') 'ERROR in the CHEMPARAM file:'
              write(iout,'(a)')
     &        ' Bad reaction number in one of the photolysis reaction IDs.'
             goto 910
           endif
        endif
      endif
c
c-----Surface model flags
c
      read(ichem,'(a)') record
      read(record(21:80),*) nsmspc,nsmrxn
      if (lsrfmod) then
         if (nsmspc.eq.0 .or. nsmrxn.eq.0) then
           write(iout,'(/,a)') 'ERROR in READCHM'
           write(iout,'(3a)') 'Surface Model is invoked but chemistry',
     &                        ' parameters file specifies zero surface',
     &                        ' model species or reactions.'
           write(iout,'(a)') 'Review your chemistry parameters file'
           goto 910
         endif
         if (nsmspc.gt.MXSMSPC) then
           write(iout,'(/,a)') 'ERROR in READCHM'
           write(iout,'(2a)') 'Number of Surface Model species exceeds',
     &                        ' maximum'
           write(iout,'(a,i5)') 'Reset MXSMSPC in CAMx.prm to ',nsmspc
           write(iout,'(a)') 'Then re-compile CAMx.'
           goto 910
         endif
         call alloc_srfmod(nsmspc,nsmrxn)
      else
         nsmspc = 0
         nsmrxn = 0
      endif
c
c-----Species records, gases come first
c
c      write(idiag,'(a)') 'The state species are'
      write(idiag,'(a,i5)')
     &     ' Number of GAS species in CHEMPARAM file =', ngas
      read(ichem,'(a)') record
      if (ngas.gt.0) then
        read(ichem,'(a)') record
        write(idiag,'(a)') record(:istrln(record))
        do l=1,ngas
          read(ichem,'(5x,a10,2e10.0,4f10.0)')
     &               spname(l),bdnl(l),henry0(l),tfact(l),
     &               molwt_spc,f0(l),rscale(l)
          diffrat(l) = sqrt(molwt_spc/18.)
          rscale(l) = min(1.,rscale(l))
          rscale(l) = max(0.,rscale(l))
          mole_weight(l) = max(1.,molwt_spc)
          write(idiag,'(i3,2x,a10,2e10.2,4f10.2)')
     &               l,spname(l),bdnl(l),henry0(l),tfact(l),
     &               mole_weight(l),f0(l),rscale(l)
          if (istrln(spname(l)).gt.8) goto 907
        enddo
      endif
c
c-----Check over the gas phase species for deposition calculations
c
      if ((ldry .or. lwet) .and. ngas.gt.0) then
        do l = 1,ngas
          if (henry0(l).eq.0.) then
            write(iout,'(/,a,i5)')
     &      'The Henry0 value must be non-zero for species ',l
            goto 910
          endif
        enddo
      endif
c
c-----Reorder radicals to come first
c
      if (lchem .and. ngas.gt.0 .and. idmech.NE.10) then
        if (nrad.gt.0) then
          do i=1,nrad
            ierr = 1
            do j=1,ngas
              if (radlist(i,idmech).EQ.spname(j)) then
                nametmp = spname(i)
                spname(i) = spname(j)
                spname(j) = nametmp
                tmp = bdnl(i)
                bdnl(i) = bdnl(j)
                bdnl(j) = tmp
                tmp = henry0(i)
                henry0(i) = henry0(j)
                henry0(j) = tmp
                tmp = tfact(i)
                tfact(i) = tfact(j)
                tfact(j) = tmp
                tmp = diffrat(i)
                diffrat(i) = diffrat(j)
                diffrat(j) = tmp
                tmp = f0(i)
                f0(i) = f0(j)
                f0(j) = tmp
                tmp = rscale(i)
                rscale(i) = rscale(j)
                rscale(j) = tmp
                tmp = mole_weight(i)
                mole_weight(i) = mole_weight(j)
                mole_weight(j) = tmp
                ierr = 0
                EXIT
              endif
            enddo
            if (ierr.eq.1) then
              write(iout,'(/,2a)') 'You must include all of the ',
     &                'following radical species in CHEMPARAM file:'
              write(iout,'(6a10)') (radlist(l,idmech),l=1,nrad)
              goto 910
            endif
          enddo
        endif
      endif
c
c-----Read the aero species, if any
c
      if (naero.ne.0) then
        read(ichem,'(a)') record
        write(idiag,'(a)') record(:istrln(record))
        call flush(idiag)
        do l = ngas+1,nspec
          read(ichem,'(5x,a10,e10.0,2f10.0,i10,f10.0,i10)')
     &       spname(l),bdnl(l),roprt(l),bext(l),rhadj(l),ssa(l),ibin
          if (ibin .lt. 1 .OR. ibin.gt.nbin) then
            write(iout,'(/,3a)') 'PM size bin for species: ',
     &                           spname(l)(:istrln(spname(l))),
     &                       ' is outside range from CHEMPARAM header.'
            write(iout,'(a,i5)') 'PM size bin read:       ',ibin
            write(iout,'(a,i5)') 'Number of PM size bins: ',nbin
            goto 910
          endif
          dcut(l,1) = REAL(dsec_i(ibin))
          dcut(l,2) = REAL(dsec_i(ibin+1))
          write(idiag,'(i3,2x,a10,e10.2,2f10.2,i10,3f10.2)')
     &       l,spname(l),bdnl(l),roprt(l),bext(l),rhadj(l),
     &       ssa(l),(dcut(l,m),m=1,2)
          bext(l) = bext(l)*1.e-6
          roprt(l) = roprt(l)*1.e6
          if (istrln(spname(l)).gt.8) goto 907
        enddo
      endif
c
c-----Map species names to the internal name list.  The default setting
c     to nspec+1 allows species that are in the chem solvers to be
c     omitted from the species list for this run.  Testing if a named
c     pointer is set to nspec+1 is used to identify species that are not
c     in the run.  Named pointers (e.g., kno) are set by equivalence
c     in CHMDAT.INC
c
      if (lchem .and. idmech.NE.10) then
        do j = 1,NSPNAM
          kmap(j) = nspec+1
        enddo
c
        nn = nspec
        if (aeropt.eq.'INERT') nn = ngas
        do 10 j = 1,nn
          do i = 1,NSPNAM
            if (splist(i).eq.spname(j)) then
              kmap(i) = j
              goto 10
            endif
          enddo
          write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file.'
          write(iout,'(3a)') 'Species in chemparam file ',
     &     spname(j)(:istrln(spname(j))),' is not in the internal list.'
          write(iout,'(2a)') 'Please make sure you are using the ',
     &               'correct chemparam file for this version of CAMx.'
          goto 910
  10    continue
        spname(nspec+1) = blank
        bdnl(nspec+1) = 0.
        write(idiag,'(a)')'Internal species order is:'
        write(idiag,'(i4,1x,a10)') (i,spname(i),i=1,nspec)
c
c-----Check NH3 if Bi-Di NH3 is on
c
        if (lbidinh3 .and. knh3.eq.nspec+1) then
          write(iout,'(/,2a)') ' You must have NH3 to use the',
     &                         ' Bi-Di NH3 drydep scheme.'
          goto 910
        endif
c
c-----Check O3 if stratospheric ozone profile scheme is on
c
        if (lstrato3 .and. ko3.eq.nspec+1) then
          write(iout,'(/,2a)') ' You must have O3 to use the',
     &                         ' stratospheric ozone profile scheme.'
          goto 910
        endif
c
c-----Check species list for consistency with CF option
c
        if (naero.GT.0 .and. aeropt.NE.'INERT') then
c
c-----Check mandatory gas species for PM chemistry
c
          if (lvbs) then
            if (ksulf.eq.nspec+1 .or. khno3.eq.nspec+1 .or.
     &           knh3.eq.nspec+1 .or.  kso2.eq.nspec+1 .or.
     &          kh2o2.eq.nspec+1 .or.   ko3.eq.nspec+1 .or.
     &          kn2o5.eq.nspec+1 .or.
     &          kivoa.eq.nspec+1 .or. kivob.eq.nspec+1 .or.
     &          kivod.eq.nspec+1 .or. kivog.eq.nspec+1 .or.
     &          kvap1.eq.nspec+1 .or. kvap2.eq.nspec+1 .or.
     &          kvap3.eq.nspec+1 .or. kvap4.eq.nspec+1 .or.
     &          kvas1.eq.nspec+1 .or. kvas2.eq.nspec+1 .or.
     &          kvas3.eq.nspec+1 .or. kvas4.eq.nspec+1 .or.
     &          kvcp1.eq.nspec+1 .or. kvcp2.eq.nspec+1 .or.
     &          kvcp3.eq.nspec+1 .or. kvcp4.eq.nspec+1 .or.
     &          kvfp1.eq.nspec+1 .or. kvfp2.eq.nspec+1 .or.
     &          kvfp3.eq.nspec+1 .or. kvfp4.eq.nspec+1 .or.
     &          kvbs1.eq.nspec+1 .or. kvbs2.eq.nspec+1 .or.
     &          kvbs3.eq.nspec+1 .or. kvbs4.eq.nspec+1) then
              write(iout,'(/,2a)') ' You must have all of the',
     &                ' following gas species to use the VBS option:'
              write(iout,'(a)')' SULF, HNO3, NH3, SO2, H2O2, O3, N2O5,'
              write(iout,'(a)')' IVOA, IVOB, IVOD, IVOG,'
              write(iout,'(a)')' VAP1, VAP2, VAP3, VAP4, VAS1, VAS2,'
              write(iout,'(a)')' VAS3, VAS4, VCP1, VCP2, VCP3, VCP4,'
              write(iout,'(a)')' VFP1, VFP2, VFP3, VFP4, VBS1, VBS2,'
              write(iout,'(a)')' VBS3, VBS4.'
              goto 910
            endif
          else
            if( idmech .EQ. 7 ) then
               if (ksulf.eq.nspec+1  .or. khno3.eq.nspec+1 .or.
     &           knh3.eq.nspec+1  .or. kso2.eq.nspec+1 .or.
     &           kh2o2.eq.nspec+1 .or. ko3.eq.nspec+1 .or.
     &           kn2o5.eq.nspec+1 .or. kivoa.eq.nspec+1 .or.
     &           kivc1.eq.nspec+1 .or. kivc2.eq.nspec+1 .or.
     &           kacg2.eq.nspec+1 .or. kacg1.eq.nspec+1 .or.
     &           kbcg2.eq.nspec+1 .or. kbcg1.eq.nspec+1 .or.
     &           ksvoa.eq.nspec+1) then
                   write(iout,'(/,2a)') ' You must have all of the',
     &               ' following gas species to use the CF option:'
                   write(iout,'(a)')' SULF, HNO3, NH3, SO2, H2O2, O3, N2O5,'
                   write(iout,'(a)')' IVOA, IVC1, IVC2, SVOA, ACG2, ACG1,'
                   write(iout,'(a)')' BCG2, BCG1.'
                   goto 910
               endif
            else
               if (ksulf.eq.nspec+1  .or. khno3.eq.nspec+1 .or.
     &           knh3.eq.nspec+1  .or. kso2.eq.nspec+1 .or.
     &           kh2o2.eq.nspec+1 .or. ko3.eq.nspec+1 .or.
     &           kn2o5.eq.nspec+1 .or. kivoa.eq.nspec+1 .or.
     &           kacg2.eq.nspec+1 .or. kacg1.eq.nspec+1 .or.
     &           kbcg2.eq.nspec+1 .or. kbcg1.eq.nspec+1 .or.
     &           ksvoa.eq.nspec+1) then
                   write(iout,'(/,2a)') ' You must have all of the',
     &               ' following gas species to use the CF option:'
                   write(iout,'(a)')' SULF, HNO3, NH3, SO2, H2O2, O3, N2O5,'
                   write(iout,'(a)')' IVOA, SVOA, ACG2, ACG1, BCG2, BCG1.'
                   goto 910
               endif
            endif
          endif

          if (aeropt.EQ.'CF') then
            if (lvbs) then
c
c-----Check mandatory PM species for VBS mechanism
c
              if (kpso4.eq.nspec+1 .or. kpno3.eq.nspec+1 .or.
     &            kpnh4.eq.nspec+1 .or. kph2o.eq.nspec+1 .or.
     &            kpap0.eq.nspec+1 .or.
     &            kpap1.eq.nspec+1 .or. kpap2.eq.nspec+1 .or.
     &            kpap3.eq.nspec+1 .or. kpap4.eq.nspec+1 .or.
     &            kpas0.eq.nspec+1 .or.
     &            kpas1.eq.nspec+1 .or. kpas2.eq.nspec+1 .or.
     &            kpas3.eq.nspec+1 .or. kpas4.eq.nspec+1 .or.
     &            kpcp0.eq.nspec+1 .or.
     &            kpcp1.eq.nspec+1 .or. kpcp2.eq.nspec+1 .or.
     &            kpcp3.eq.nspec+1 .or. kpcp4.eq.nspec+1 .or.
     &            kpfp0.eq.nspec+1 .or.
     &            kpfp1.eq.nspec+1 .or. kpfp2.eq.nspec+1 .or.
     &            kpfp3.eq.nspec+1 .or. kpfp4.eq.nspec+1 .or.
     &            kpbs0.eq.nspec+1 .or.
     &            kpbs1.eq.nspec+1 .or. kpbs2.eq.nspec+1 .or.
     &            kpbs3.eq.nspec+1 .or. kpbs4.eq.nspec+1) then
                write(iout,'(/,2a)') ' You must have all of the',
     &                 ' following PM species to use the VBS option:'
                write(iout,'(a)')' PSO4, PNO3, PNH4, PH2O,'
                write(iout,'(a)')' PAP0, PAP1, PAP2, PAP3, PAP4,'
                write(iout,'(a)')' PAS0, PAS1, PAS2, PAS3, PAS4,'
                write(iout,'(a)')' PCP0, PCP1, PCP2, PCP3, PCP4,'
                write(iout,'(a)')' PFP0, PFP1, PFP2, PFP3, PFP4,'
                write(iout,'(a)')' PBS0, PBS1, PBS2, PBS3, PBS4.'
                goto 910
              endif
            else
c
c-----Check mandatory PM species for CF mechanism
c
              if (kpso4.eq.nspec+1 .or. kpno3.eq.nspec+1 .or.
     &            kpnh4.eq.nspec+1 .or. kph2o.eq.nspec+1 .or.
     &            kaoa2.eq.nspec+1 .or. kaoa1.eq.nspec+1 .or.
     &            kboa2.eq.nspec+1 .or. kboa1.eq.nspec+1 .or.
     &            kaoa0.eq.nspec+1 .or. kboa0.eq.nspec+1) then
                write(iout,'(/,2a)') ' You must have all of the',
     &                     ' following PM species to use the CF option:'
                write(iout,'(a)')' PSO4, PNO3, PNH4, PH2O,'
                write(iout,'(a)')' AOA2, AOA1, BOA2, BOA1, AOA0, BOA0.'
                goto 910
              endif
            endif
c
c-----Check for a consistent set of sea salt species, or none
c
            if (kna.eq.nspec+1 .and. kpcl.eq.nspec+1 .and.
     &                               khcl.eq.nspec+1) then
              continue
            elseif (kna.lt.nspec+1 .and. kpcl.lt.nspec+1 .and.
     &                                   khcl.lt.nspec+1) then
              continue
            elseif (kna.eq.nspec+1 .and. kpcl.eq.nspec+1 .and.
     &                                   khcl.lt.nspec+1) then
              continue
            else
              write(iout,'(/,2a)') ' You must have all or none of the',
     &               ' sea salt species to use the CF option:'
              write(iout,'(a)')' NA, PCL, HCL.'
              write(iout,'(a)')' Or, just HCL.'
              goto 910
            endif
          endif
        else
c
c-----Check for gas species for non-aerosol chemistry mechanisms
c
          if (kivoa.lt.nspec+1 .or. kivob.lt.nspec+1 .or.
     &        kivod.lt.nspec+1 .or. kivog.lt.nspec+1 .or.
     &        kacg2.lt.nspec+1 .or. kacg1.lt.nspec+1 .or.
     &        kbcg2.lt.nspec+1 .or. kbcg1.lt.nspec+1  .or.
     &        kvap1.lt.nspec+1 .or. kvap2.lt.nspec+1 .or.
     &        kvap3.lt.nspec+1 .or. kvap4.lt.nspec+1 .or.
     &        kvas1.lt.nspec+1 .or. kvas2.lt.nspec+1 .or.
     &        kvas3.lt.nspec+1 .or. kvas4.lt.nspec+1 .or.
     &        kvcp1.lt.nspec+1 .or. kvcp2.lt.nspec+1 .or.
     &        kvcp3.lt.nspec+1 .or. kvcp4.lt.nspec+1 .or.
     &        kvfp1.lt.nspec+1 .or. kvfp2.lt.nspec+1 .or.
     &        kvfp3.lt.nspec+1 .or. kvfp4.lt.nspec+1 .or.
     &        kvbs1.lt.nspec+1 .or. kvbs2.lt.nspec+1 .or.
     &        kvbs3.lt.nspec+1 .or. kvbs4.lt.nspec+1 .or.
     &        ksvoa.lt.nspec+1) then
            write(iout,'(/,a)') ' You must have none of the species'
            write(iout,'(a)')   ' IVOA, IVOB,'
            write(iout,'(a)')   ' IVOD, IVOG, ACG2, ACG1,'
            write(iout,'(a)')   ' BCG2, BCG1, VAP1, VAP2,'
            write(iout,'(a)')   ' VAP3, VAP4, VAS1, VAS2,'
            write(iout,'(a)')   ' VAS3, VAS4, VCP1, VCP2,'
            write(iout,'(a)')   ' VCP3, VCP4, VFP1, VFP2,'
            write(iout,'(a)')   ' VFP3, VFP4, VBS1, VBS2,'
            write(iout,'(a)')   ' VBS3, VBS4, SVOA'
            write(iout,'(a)')   ' with non-aerosol chemistry mechanisms.'
            goto 910
          endif
        endif
c
c-----Check for a consistent set of Mercury species, or none
c
        if (khg0.eq.nspec+1 .and. khg2.eq.nspec+1 .and.
     &      khgiip.eq.nspec+1 .and. khgiipc.eq.nspec+1) then
          continue
        elseif (khg0.lt.nspec+1 .and. khg2.lt.nspec+1 .and.
     &      khgiip.lt.nspec+1 .and. khgiipc.lt.nspec+1) then
          continue
        else
          write(iout,'(/,a)') ' You must have all or none of the '
          write(iout,'(a)')   ' Mercury gas-phase and adsorbed species '
          write(iout,'(a)')   ' HG0, HG2, HGIIP, HGIIPC'
          goto 910
        endif
        if (khg0.lt.nspec+1 .and. naero.lt.2 ) then
          write(iout,'(/,2a)') ' You must model PM10 to use the',
     &                         ' Mercury gas-phase chemistry.'
          write(iout,'(2a)')   ' HG0 and HG2 are included but',
     &          ' the number of aerosol species is less than 2'
          goto 910
        endif
        if (khg0.lt.nspec+1 .and. aeropt.ne.'CF') then
          write(iout,'(/,2a)') ' Mercury is currently available',
     &                         ' only with the CF option.'
          goto 910
        endif
        if (khg0.lt.nspec+1 .and. khcl.eq.nspec+1) then
          write(iout,'(/,2a)') ' Mercury chemistry requires HCl'
          goto 910
        endif
        if (khg0.lt.nspec+1 .and. lcig(1)) then
          write(iout,'(/,2a)') ' Mercury chemistry cannot be run',
     &                         ' with the sub-grid cloud model'
          write(iout,'(/,a)') ' Turn off sub-grid cloud option'
          goto 910
        endif
      endif
c
c-----Set up section diameters and check parameters for CF routine
c
      if (lchem .AND. aeropt.EQ.'CF') then
        ierr = 0
        call aeroset(dsec_i,ierr)
        if ( ierr .ne. 0 ) goto 910
      endif
c
c-----Reaction records
c
      if (lchem .AND. nreact.gt.0) then
        ncms = 0
        nppm = 0
        read(ichem,'(a)') record
        read(ichem,'(a)') record
        write(idiag,'(a)') 'The reaction rate parameters are'
        do i = 1,nreact
          read(ichem,'(a)') record
          read(record,*) num,rxntyp(i)
          if (abs(rxntyp(i)).lt.1 .or. abs(rxntyp(i)).gt.7) goto 902
          read(record,*,err=900) num,rxntyp(i),rxnord(i),
     &                           (rxnpar(i,j),j=1,npar(abs(rxntyp(i))))
c
          if (abs(rxntyp(i)).eq.5) then
            iref = nint(rxnpar(i,1))
            if (i.le.iref) goto 901
          endif
          if (abs(rxntyp(i)).eq.2 .or. abs(rxntyp(i)).eq.3) then
            if (rxnpar(i,1).gt.1.0D0) then
              nppm = nppm +1
            else
              ncms = ncms +1
            endif
          endif
c
          write(idiag,'(3i3,1p12d12.4)') num,rxntyp(i),rxnord(i),
     &                           (rxnpar(i,j),j=1,npar(abs(rxntyp(i))))
        enddo
c
c-----Decide what units the rate constants are provided in
c
        if (nppm.eq.0 .and. ncms.eq.0) then
          write(iout,'(/,a)') ' Unable to determine rate constant units'
          write(iout,*)       ' ncms, nppm = ', ncms, nppm
          goto 910
        elseif (nppm.gt.ncms) then
          write(idiag,'(/,a)') 'Rate constants input in ppm units'
          write(idiag,*)       'ncms, nppm = ', ncms, nppm
          iunits = 1
        else
          write(idiag,'(/,a)') 'Rate constants input in cms units'
          write(idiag,*)       'ncms, nppm = ', ncms, nppm
          iunits = 2
        endif
c
c-----Populate rate constant lookup table
c
        call exptbl(iunits,rxntyp,rxnord,rxnpar)
c
c-----Provide diagnostic info for checking rate expressions
c
        write(idiag,'(/,a,/,/,a)') 
     &        'Diagnostic info for checking rate expressions',
     &        'Rates at three temps and pressures in cm3 molec-1 s-1'
        do i=1,3
          call ktherm(tdum(i), pdum(i))
          do j=1,nreact
            kdum(j,i)=rk(j)/
     &           ( ( (298.0/tdum(i)) * (pdum(i)/1013.0) *
     &                   2.462e13 )**(rxnord(j)-1) ) / 3600.  ! cm3 molec-1 s-1
          enddo
        enddo
        write(idiag,'(a,3F12.1)') 'Temp= ', tdum
        write(idiag,'(a,3F12.1)') 'Pres= ', pdum
        write(idiag,'(a)') 'Rxn Type'
        write(idiag,'(2i3,1p3e12.4)')
     &       (j,rxntyp(j),kdum(j,1),
     &        kdum(j,2),kdum(j,3),j=1,nreact)
c
c-----Set pointers for photolysis reactions to receive T,P adjustments
c
        if (idmech.eq.5) then
          jno2rxn    = jno2s07
          jo3rxn     = jo3s07
          jhcho1rxn  = jhcho1s07
          jhcho2rxn  = jhcho2s07
          jch3chorxn = jch3chos07
        elseif (idmech.eq.7) then
          jno2rxn    = jno2cb7
          jo3rxn     = jo3cb7
          jhcho1rxn  = jhcho1cb7
          jhcho2rxn  = jhcho2cb7
          jch3chorxn = jch3chocb7
        elseif (idmech.eq.1 .OR. idmech.eq.3 .OR. idmech.eq.4) then
          jno2rxn    = jno2cb6
          jo3rxn     = jo3cb6
          jhcho1rxn  = jhcho1cb6
          jhcho2rxn  = jhcho2cb6
          jch3chorxn = jch3chocb6
        elseif (idmech.eq.9) then
          jno2rxn    = jno2rc2
          jo3rxn     = jo3rc2
          jhcho1rxn  = jhcho1rc2
          jhcho2rxn  = jhcho2rc2
          jch3chorxn = jch3chorc2
        else
          write(iout,'(/,a,i3)')
     &       'Must set T & P photolysis rxn indices for mech #', idmech
          goto 910
        endif
c
c-----Set pointers to heterogeneous rxns
c
        if (idmech.eq.1) then
          ihetrxn(1) = ihet01_cb6
          ihetrxn(2) = -999
          ihetrxn(3) = ihet03_cb6r4
          ihetrxn(4) = ihet04_cb6r4
          ihetrxn(5) = ihet05_cb6r4
          ihetrxn(6) = ihet06_cb6r5
          ihetrxn(7) = ihet07_cb6r5
        elseif (idmech.eq.3) then
          ihetrxn(1) = ihet01_cb6
          ihetrxn(2) = ihet02_cb6r5h
          ihetrxn(3) = ihet03_cb6r4
          ihetrxn(4) = -999
          ihetrxn(5) = -999
          ihetrxn(6) = ihet06_cb6r5h
          ihetrxn(7) = ihet07_cb6r5h
        elseif (idmech.eq.4) then
          ihetrxn(1) = ihet01_cb6
          ihetrxn(2) = -999
          ihetrxn(3) = ihet03_cb6r4
          ihetrxn(4) = ihet04_cb6r4
          ihetrxn(5) = ihet05_cb6r4
          ihetrxn(6) = ihet06_cb6r4
          ihetrxn(7) = ihet07_cb6r4
        elseif (idmech.eq.5) then
          ihetrxn(1) = ihet01_s07
          ihetrxn(2) = -999
          ihetrxn(3) = -999
          ihetrxn(4) = -999
          ihetrxn(5) = -999
          ihetrxn(6) = ihet06_s07
          ihetrxn(7) = ihet07_s07
        elseif (idmech.eq.7) then
          ihetrxn(1) = ihet01_cb7
          ihetrxn(2) = -999
          ihetrxn(3) = ihet03_cb7
          ihetrxn(4) = -999
          ihetrxn(5) = ihet05_cb7
          ihetrxn(6) = ihet06_cb7
          ihetrxn(7) = ihet07_cb7
        elseif (idmech.eq.9) then
          ihetrxn(1) = ihet01_rc2
          ihetrxn(2) = -999
          ihetrxn(3) = ihet03_rc2
          ihetrxn(4) = ihet04_rc2
          ihetrxn(5) = ihet05_rc2
          ihetrxn(6) = ihet06_rc2
          ihetrxn(7) = ihet07_rc2
        endif
        if (ihetrxn(1) .LE. 0) then
          write(iout,'(/,a,i3)')
     &       'Must set N2O5 hydrolysis rxn index for mech #', idmech
          goto 910
        endif
c
c-----Set reaction pointers for pig chemistry
c
        if (ipigflg .NE. 0) then
           if (naero.GT.0) then
             if (aeropt.EQ.'CF' .AND. ipigflg .EQ. IRONPIG) then
               write(iout,'(/,2a)')'IRON PiG cannot be run with',
     &                            ' CF PM option'
               write(iout,'(/,2a)')'Either turn off PiG or change',
     &                            ' to GREASD'
               goto 910
             endif
           endif
           if(idmech.eq.5) then
             ipigrxn = ipigs07
             lrmap   = lrmaps07
           elseif(idmech.eq.1 .OR. idmech.eq.3 .OR. idmech.eq.4) then
             ipigrxn = ipigcb6
             lrmap   = lrmapcb6r4
           elseif(idmech.eq.7) then
             ipigrxn = ipigcb7
             lrmap   = lrmapcb7
           elseif(idmech.eq.9) then
             ipigrxn = ipigrc2
             lrmap   = lrmaprc2
           elseif (idmech.eq.10) then
             write(iout,'(/,a)')'PiG cannot be run with Mechanism 10'
             goto 910
           else
             write(iout,'(/,a,i3)') 
     &       'Dont know how to set pig rxns for mech #', idmech
             goto 910
           endif

c ----- map species indexes for new GREASD PiG chemistry solver

           lsmap( 1) = kO
           lsmap( 2) = kO1D
           lsmap( 3) = kOH
           lsmap( 4) = kHO2
           lsmap( 5) = kNO3
           lsmap( 6) = kN2O5
           lsmap( 7) = kNO
           lsmap( 8) = kNO2
           lsmap( 9) = kO3
           lsmap(10) = kHONO
           lsmap(11) = kHNO3
           lsmap(12) = kCO
           if (idmech.eq.5 .or. idmech.eq.9) then
             lsmap(13) = kHCHO
           else
             lsmap(13) = kFORM
           endif
           lsmap(14) = kSO2
           lsmap(15) = kSULF
        endif
      endif
c
c======================== DDM Begin =======================
c
c---  Set species pointers via equivalences in ddmchm.inc
c     LMAP(non-model spc) = NGAS + 1 while KMAP(non-model spc) = NSPEC + 1,
c     which allows shorter local arrays in the chemistry solver routines.
c
      if (lchem .and. idmech.NE.10) then
        do i = 1, nspnam
          if (kmap(i).gt.ngas) then
            lmap(i) = ngas + 1
          else
            lmap(i) = kmap(i)
          endif
        enddo
      endif
c
c======================== DDM End   =======================
c
c  --- set the flag for determining if a species is gaseous ---
c
      do i=1,nrad
        lgas(i) = .FALSE.
      enddo
      do i=nrad+1,ngas
        lgas(i) = .TRUE.
      enddo
      do i=ngas+1,nspec
        lgas(i) = .FALSE.
      enddo
c
c-----Check for and process surface model records
c
      if (lsrfmod) then
        read(ichem,'(a)',err=904,end=904) record
        if (record(1:13).ne.'Surface Model') goto 904
c
c-----Species list and associated parameters
c
        read(ichem,'(a)',err=905,end=906) record
        do n = 1,nsmspc
          read(ichem,'(a)',err=905,end=906) record
          read(record,'(5x,a10,6e10.0)',err=905) smspc(n),smssrb(n),
     &                                  smlch(n),smvsrb(n),smpen(n),
     &                                  smisrb(n),smmlt(n)
          idsmsp(n) = 0
          do l = 1,nspec
            if (smspc(n).eq.spname(l)) idsmsp(n) = l
          enddo
          if (idsmsp(n) .eq. 0) then
            write(iout,'(/,2a)') 'Surface Model species cannot be ',
     &                           'found in master species list: '
            write(iout,'(a)') smspc(n)
            goto 910
          endif
        enddo
        write(idiag,'(/,a)') 'SURFACE MODEL PARAMETERS'
        write(idiag,'(2a)')'     Species     SoilSorb SoilLeach   ',
     &                     'VegSorb    VegPen'
        do n = 1,nsmspc
          write(idiag,'(i3,2x,a10,6(1pe10.2))') idsmsp(n),smspc(n),
     &                         smssrb(n),smlch(n),smvsrb(n),smpen(n),
     &                         smisrb(n),smmlt(n)
        enddo
c
c-----Reaction list and associated parameters
c
        read(ichem,'(a)',err=905,end=906)  record
        do n = 1,nsmrxn
          read(ichem,'(a)',err=905,end=906) record
          read(record,'(5x,2a10,6e10.0)',err=905) smpre(n),smprd(n),
     &                                         smskrat(n),smsjrat(n),
     &                                         smvkrat(n),smvjrat(n),
     &                                         smikrat(n),smijrat(n)
          idsmpre(n) = 0
          idsmprd(n) = 0
          do l = 1,nsmspc
            if (smpre(n).eq.smspc(l)) idsmpre(n) = l
            if (smprd(n).eq.smspc(l)) idsmprd(n) = l
          enddo
          if (idsmpre(n) .eq. 0) then
            write(iout,'(/,2a)')'Reaction precursor species cannot be ',
     &                          'found in Surface Model species list: '
            write(iout,'(a)') smpre(n)
            goto 910
          endif
          if (idsmprd(n) .eq. 0) then
            write(iout,'(/,2a)')'Reaction product species cannot be ',
     &                          'found in Surface Model species list: '
            write(iout,'(a)') smprd(n)
            if (smprd(n).eq.'          ') then
              write(iout,'(a)') 'Reaction product will be ignored'
            else
              goto 910
            endif
          endif
        enddo
        write(idiag,'(2a)')'     Precursor Product        Krate     ',
     &                     'Jrate'
        do n = 1,nsmrxn
          write(idiag,'(5x,2a10,6(1pe10.2))') smpre(n),smprd(n),
     &                                     smskrat(n),smsjrat(n),
     &                                     smvkrat(n),smvjrat(n),
     &                                     smikrat(n),smijrat(n)
        enddo
      endif
c
      write(idiag,*)
      call flush(idiag)
c
      return
c
 900  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file record:'
      write(iout,'(a)') record
      write(iout,'(4(a,i4))')
     &  'reaction number', num, ' of type', rxntyp(i),
     &  ' should have', npar(abs(rxntyp(i))), ' parameters'
      goto 910
c
 901  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file record:'
      write(iout,'(a)') record
      write(iout,'(a)')  'For reaction type 5'
      write(iout,'(a,i4)') 'reference reaction # ', iref
      write(iout,'(a,i4)') 'must come before this reaction', i
      goto 910
c
 902  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file record:'
      write(iout,'(a)') record
      write(iout,'(a)') 'Reaction type out of bounds (1-7)'
      write(iout,'(a,i4)') 'for reaction ', num
      write(iout,'(a,i4)') 'value was', rxntyp(i)
      goto 910
c
 903  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file record:'
      write(iout,'(/,a,/)') record
      write(iout,'(2a)') 'If you include aerosol species you must',
     &                   ' specify: number, coupling time step, '
      write(iout,'(a)')  'number of sizes, and size intervals'
      goto 910
c
 904  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file'
      write(iout,'(a)') 'Expecting record label: Surface Model.'
      write(iout,'(a)') 'You have selected the Surface Model treatment:'
      write(iout,'(3a)') 'Either provide a chemistry paramters file ',
     &                   'with Surface Model records or turn off ',
     &                   'Surface Model.'
      goto 910
c
 905  write(iout,'(//,2a)') 'ERROR: Reading CHEMPARAM Surface Model',
     &                      ' record'
      write(iout,'(/,a,/)') record
      write(iout,'(a)') 'Review your Surface Model input data'
      goto 910
c
 906  write(iout,'(//,2a)') 'ERROR: Reading CHEMPARAM Surface Model',
     &                     ' record'
      write(iout,'(a)') 'Unexpected end of file'
      write(iout,'(a)') 'Review your Surface Model input data'
      goto 910
c
 907  write(iout,'(//,a)') 'ERROR: Reading CHEMPARAM file'
      write(iout,'(2a)')   'Species: ',spname(l)
      write(iout,'(2a)')   'Exceeds the 8-character maximum.',
     &                     ' Shorten the name.'
      goto 910
c
 910  write(*,'(/,a)') 'ERROR in READCHM - see message in .out file'
      write(idiag,'(/,a)') 'ERROR in READCHM - see message in .out file'
      write(iout,'(//,a)') 'ERROR in READCHM.'
      call camxerr()
c
      end

      subroutine sumwt4(idx,ncolx,nrowy,nlays,depth,conwst,conest,
     &                  consth,connth,consum)
      use bndary
      use tracer
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c     
c     SUMWT4 sums up a species concentration for the four boundaries
c
c     11/12/09   --gwilson--    Now calculates the top concentration
c                               by averaging the top layer values
c
c
c     Input arguments:
c        idx             species ID
c        ncolx           the number of coarse grid columns
c        nrowy           the number of coarse grid rows
c        nlays           the number of coarse grid layers
c        depth           layer depth
c        conwst          west species concentration at west boundary
c        conest          east species concentration at east boundary
c        consth          south species concentration at south boundary
c        connth          north species concentration at north boundary
c
c     Output argumnets:
c        consum          sum of the species concentrations from the four
c                        boundaries
c
      include "camx.prm"
c
      real depth(ncolx,nrowy,nlays)
      real consum(MXSPEC,0:IDXBTP)
      real conwst(MXLAYER,MXCELLS)
      real conest(MXLAYER,MXCELLS)
      real consth(MXLAYER,MXCELLS)
      real connth(MXLAYER,MXCELLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- do the west and east boundaries first ----
c
      do jcl=1,nrowy
c
c   --- add contribution from WEST boundary ---
c
        sumthk = 0
        sumcon = 0
c
c   --- add the concentrations, weighting by layer thickness ---
c
        do izcl=1,nlays
            if( conwst(izcl,jcl) .GT. 0 ) then
              sumthk = sumthk + depth(1,jcl,izcl)
              sumcon = sumcon + 
     &                       conwst(izcl,jcl) * depth(1,jcl,izcl)
            endif
        enddo
        if( sumthk .GT. 0. ) then
            consum(idx,IDXBWS) = consum(idx,IDXBWS) + sumcon / sumthk
            consum(idx,0) = consum(idx,0) + sumcon / sumthk
        endif
        if( depth(1,jcl,nlays) .GT. 0. ) then
            consum(idx,IDXBTP) = consum(idx,IDXBTP) + 
     &                            conwst(nlays,jcl) / depth(1,jcl,nlays)
        endif
c
c   --- add contribution from EAST boundary ---
c
        sumthk = 0
        sumcon = 0
c
c   --- add the concentrations, weighting by layer thickness ---
c
        do izcl=1,nlays
            if( conest(izcl,jcl) .GT. 0. ) then
               sumthk = sumthk + depth(ncolx,jcl,izcl)
               sumcon = sumcon + 
     &                     conest(izcl,jcl) * depth(ncolx,jcl,izcl)
            endif
        enddo
        if( sumthk .GT. 0. ) then
            consum(idx,IDXBES) = consum(idx,IDXBES) + sumcon / sumthk
            consum(idx,0) = consum(idx,0) + sumcon / sumthk
        endif
        if( depth(ncolx,jcl,nlays) .GT. 0. ) then
            consum(idx,IDXBTP) = consum(idx,IDXBTP) + 
     &                       conest(nlays,jcl) / depth(ncolx,jcl,nlays)
        endif
      enddo
c
c   --- do the south and north bundarues ----
c
      do icl=1,ncolx
c
c   --- add contribution from SOUTH boundary ---
c
         sumthk = 0
         sumcon = 0
c
c   --- add the concentrations, weighting by layer thickness ---
c
         do izcl=1,nlays
             if( consth(izcl,icl) .GT. 0 ) then
                sumthk = sumthk + depth(icl,1,izcl)
                sumcon = sumcon + 
     &                     consth(izcl,icl) * depth(icl,1,izcl)
             endif
         enddo
         if( sumthk .GT. 0. ) then
           consum(idx,IDXBST) = consum(idx,IDXBST) + sumcon / sumthk
           consum(idx,0) = consum(idx,0) + sumcon / sumthk
         endif
         if( depth(icl,1,nlays) .GT. 0. ) then
            consum(idx,IDXBTP) = consum(idx,IDXBTP) + 
     &                       consth(nlays,icl) / depth(icl,1,nlays)
         endif
c
c   --- add contribution from NORTH boundary ---
c
         sumthk = 0
         sumcon = 0
c
         do izcl=1,nlays
             if( connth(izcl,icl) .GT. 0. ) then
                sumthk = sumthk + depth(icl,nrowy,izcl)
                sumcon = sumcon + 
     &                    connth(izcl,icl) * depth(icl,nrowy,izcl)
             endif
         enddo
         if( sumthk .GT. 0. ) then
           consum(idx,IDXBNT) = consum(idx,IDXBNT) + sumcon / sumthk
           consum(idx,0) = consum(idx,0) + sumcon / sumthk
         endif
         if( depth(icl,nrowy,nlays) .GT. 0. ) then
            consum(idx,IDXBTP) = consum(idx,IDXBTP) + 
     &                     connth(nlays,icl) / depth(icl,nrowy,nlays)
         endif
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine juldate(idate)
c 
c----CAMx v7.40 260801
c 
c     JULDATE converts date from calender (YYMMDD) format to Julian
c     (YYJJJ) format
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments: 
c        idate               calender date (YYMMDD) 
c             
c     Output arguments: 
c        idate               julian date (YYJJJ) 
c             
c     Routines Called: 
c        none 
c             
c     Called by: 
c        CVTDATE
c
      integer nday(12)
c
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
      iyear = idate/10000
      imonth = (idate - iyear*10000)/100
      iday = idate - iyear*10000 - imonth*100
c
      nday(2) = 28
      if (mod(iyear,4).eq.0) nday(2) = 29
      mday = 0
      do 10 n = 1,imonth-1
        mday = mday + nday(n)
 10   continue
      jday = mday + iday
      idate = iyear*1000 + jday
c
      return
      end

c*** O3PRDSA
c
      subroutine o3prdsa(rrxn_irr,convfac,delo3,prdo3n,prdo3v,desto3)
      use filunit
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine calculates the production/destruction of ozone
c     based on the chemical mechanism.  The production is in two
c     parts NOx-attributed and VOC-attributed.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       rrxn_irr   R  array of reactions from last chemistry step
c       delo3      R  change in Ozone
c       convfac    R  conversion factor (Mmoles to ug/m^3)
c     Outputs:
c       prdo3n     R  ozone production attributed to NOx
c       prdo3v     R  ozone production attributed to VOC
c       desto3     R  ozone destruction
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     07/20/04   --gwilson--  Original development
c     02/21/05   --gyarwood-  Add SAPRC mechanism
c     10/06/05   --gyarwood-  Removed mechanism 2
c     01/08/06   --bkoo--     Added Mechanism 6 (CB05)
c     08/22/06   --gyarwood-  Revised ozone destruction calculation
c     06/24/16   --bkoo--     Updated Mechanism 4 (CB6r4)
c     11/28/16   --bkoo--     Revised desto3 using automated CPA
c     11/27/17   --bkoo--     Updated based on new CPAMECH routines (CMC v5.2.6)
c     02/21/20   --rlb--      Added Mechanism 1 (CB6r5)
c     09/22/20   --gy--       Added Mechanism 3 (CB6r5h)
c     03/24/21   --gy--       Added Mechanism 7 (CB7)
c     09/02/21   --gy--       Added Mechanism 9 (RACM2s21)
c     11/03/23   --cemery--   Removed CB05 (Mech 6)
c     05/13/25   --gy--       Update Mechanism 7 to CB7r2
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real rrxn_irr(*)
      real delo3
      real convfac
      real prdo3n
      real prdo3v
      real desto3
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real prodo3, phno3, pho2h
      real HO2toNO2, HO2_loss
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Estimate daytime ozone destruction due to:
c       (1) O1D + water 
c       (2) HO2 + O3
c       (3) OH + O3 --> HO2 + O2 (subtracting HO2 reacting with NO)
c       (4) O(3P) + VOC 
c       (5) O3 + VOC
c     Get the rates for OH + NO2 and HO2 + HO2
c
c     1. Copy from CPAMECH?.F
c     2. Replace 'PA(nn)' with 'desto3'
c     3. Replace 'r(' with 'rrxn_irr('
c
      if( idmech .EQ. 3 ) then
c
c  +  O1D + H2O
c
        desto3 =
     &       - rrxn_irr( 11)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
        desto3 = desto3
     &       - rrxn_irr( 13)  ! O3 + HO2 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
        HO2toNO2 =
     &       +          rrxn_irr( 25)  ! HO2 + NO =
     &       +          rrxn_irr( 33)  ! NO3 + HO2 =
c
        HO2_loss =
     &       +          rrxn_irr( 13)  ! O3 + HO2 =
     &       +          rrxn_irr( 15)  ! HO2 + O =
     &       +          rrxn_irr( 18)  ! OH + HO2 =
     &       + ( 2.000)*rrxn_irr( 19)  ! HO2 + HO2 =
     &       + ( 2.000)*rrxn_irr( 20)  ! HO2 + HO2 + H2O =
     &       +          rrxn_irr( 25)  ! HO2 + NO =
     &       +          rrxn_irr( 33)  ! NO3 + HO2 =
     &       +          rrxn_irr( 57)  ! C2O3 + HO2 =
     &       +          rrxn_irr( 65)  ! CXO3 + HO2 =
     &       +          rrxn_irr( 72)  ! MEO2 + HO2 =
     &       +          rrxn_irr( 76)  ! XO2H + HO2 =
     &       +          rrxn_irr( 80)  ! XO2 + HO2 =
     &       +          rrxn_irr( 84)  ! XO2N + HO2 =
     &       +          rrxn_irr(100)  ! FORM + HO2 =
     &       + ( 0.800)*rrxn_irr(103)  ! HCO3 + HO2 =
     &       + ( 0.880)*rrxn_irr(145)  ! ISO2 + HO2 =
     &       + ( 0.175)*rrxn_irr(159)  ! EPX2 + HO2 =
     &       +          rrxn_irr(170)  ! BZO2 + HO2 =
     &       +          rrxn_irr(175)  ! TO2 + HO2 =
     &       +          rrxn_irr(179)  ! XLO2 + HO2 =
     &       +          rrxn_irr(185)  ! CRO + HO2 =
     &       +          rrxn_irr(202)  ! OPO3 + HO2 =
     &       +          rrxn_irr(214)  ! IO + HO2 =
     &       +          rrxn_irr(239)  ! CL + HO2 =
     &       +          rrxn_irr(243)  ! CLO + HO2 =
     &       +          rrxn_irr(288)  ! BR + HO2 =
     &       +          rrxn_irr(297)  ! BRO + HO2 =
     &       +          rrxn_irr(322)  ! I + HO2 =
c
        desto3 = desto3 - (
     &       + rrxn_irr( 12)  ! O3 + OH =
     &                     ) * (HO2_loss-HO2toNO2)/max( 1.0E-12, HO2_loss )
c
c  +  O3 + VOC
c
        desto3 = desto3
     &       - rrxn_irr(135)  ! ETH + O3 =
     &       - rrxn_irr(138)  ! OLE + O3 =
     &       - rrxn_irr(141)  ! IOLE + O3 =
     &       - rrxn_irr(149)  ! ISOP + O3 =
     &       - rrxn_irr(152)  ! ISPD + O3 =
     &       - rrxn_irr(165)  ! TERP + O3 =
c
c  +  O(3P) + VOC
c
!        desto3 = desto3
c
c  +  Halogen catalytic destruction (the limiting reactions)
c
        desto3 = desto3
     &       -          rrxn_irr(214)  ! IO + HO2 =
     &       - ( 0.400)*rrxn_irr(213)  ! IO + IO =
     &       -          rrxn_irr(242)  ! CLO + IO =
     &       -          rrxn_irr(296)  ! BRO + IO =
     &       -          rrxn_irr(216)  ! IO + NO2 =
     &       -          rrxn_irr(297)  ! BRO + HO2 =
     &       - ( 1.700)*rrxn_irr(294)  ! BRO + BRO =
     &       -          rrxn_irr(295)  ! BRO + CLO =
     &       -          rrxn_irr(296)  ! BRO + IO =
     &       -          rrxn_irr(299)  ! BRO + NO2 =
     &       -          rrxn_irr(243)  ! CLO + HO2 =
     &       - ( 1.400)*rrxn_irr(241)  ! CLO + CLO =
     &       -          rrxn_irr(242)  ! CLO + IO =
     &       -          rrxn_irr(295)  ! BRO + CLO =
c
        phno3 = rrxn_irr(45) + rrxn_irr(234)
        pho2h = rrxn_irr(19) + rrxn_irr(20)
c
      elseif( idmech .EQ. 1 .OR. idmech .EQ. 4) then
c
c --- CB6r5 Mechanism 1 and CB6r4 Mechanism 4 ---
c
c  +  O1D + H2O
c
        desto3 =
     &         - rrxn_irr( 11)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
        desto3 = desto3
     &         - rrxn_irr( 13)  ! O3 + HO2 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
        HO2toNO2 = 
     &         +          rrxn_irr( 25)  ! HO2 + NO =
     &         +          rrxn_irr( 33)  ! NO3 + HO2 =
c
        HO2_loss = 
     &         +          rrxn_irr( 13)  ! O3 + HO2 =
     &         +          rrxn_irr( 15)  ! HO2 + O =
     &         +          rrxn_irr( 18)  ! OH + HO2 =
     &         + ( 2.000)*rrxn_irr( 19)  ! HO2 + HO2 =
     &         + ( 2.000)*rrxn_irr( 20)  ! HO2 + HO2 + H2O =
     &         +          rrxn_irr( 25)  ! HO2 + NO =
     &         +          rrxn_irr( 33)  ! NO3 + HO2 =
     &         +          rrxn_irr( 57)  ! C2O3 + HO2 =
     &         +          rrxn_irr( 65)  ! CXO3 + HO2 =
     &         +          rrxn_irr( 72)  ! MEO2 + HO2 =
     &         +          rrxn_irr( 76)  ! XO2H + HO2 =
     &         +          rrxn_irr( 80)  ! XO2 + HO2 =
     &         +          rrxn_irr( 84)  ! XO2N + HO2 =
     &         +          rrxn_irr(100)  ! FORM + HO2 =
     &         + ( 0.800)*rrxn_irr(103)  ! HCO3 + HO2 =
     &         + ( 0.880)*rrxn_irr(145)  ! ISO2 + HO2 =
     &         + ( 0.175)*rrxn_irr(159)  ! EPX2 + HO2 =
     &         +          rrxn_irr(170)  ! BZO2 + HO2 =
     &         +          rrxn_irr(175)  ! TO2 + HO2 =
     &         +          rrxn_irr(179)  ! XLO2 + HO2 =
     &         +          rrxn_irr(185)  ! CRO + HO2 =
     &         +          rrxn_irr(202)  ! OPO3 + HO2 =
     &         +          rrxn_irr(214)  ! IO + HO2 =
c
        desto3 = desto3 - (
     &         + rrxn_irr( 12)  ! O3 + OH =
     &                       ) * (HO2_loss-HO2toNO2)/HO2_loss
c
c  +  O3 + VOC
c
        desto3 = desto3
     &         - rrxn_irr(135)  ! ETH + O3 =
     &         - rrxn_irr(138)  ! OLE + O3 =
     &         - rrxn_irr(141)  ! IOLE + O3 =
     &         - rrxn_irr(149)  ! ISOP + O3 =
     &         - rrxn_irr(152)  ! ISPD + O3 =
     &         - rrxn_irr(165)  ! TERP + O3 =
c
c  +  O(3P) + VOC
c
!        desto3 = desto3
c
c  +  Halogen catalytic destruction (the limiting reactions)
c
        desto3 = desto3
     &         -          rrxn_irr(214)  ! IO + HO2 =
     &         - ( 0.400)*rrxn_irr(213)  ! IO + IO =
     &         -          rrxn_irr(216)  ! IO + NO2 =
c
        phno3 = rrxn_irr(45) 
        pho2h = rrxn_irr(19) + rrxn_irr(20) 
c
      elseif( idmech .EQ. 5 ) then
c
c --- SAPRC07TC Mechanism 5 ---
c
c  +  O1D + H2O
c
        desto3 =
     &         - rrxn_irr( 20)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
        desto3 = desto3
     &         - rrxn_irr( 36)  ! HO2 + O3 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
        HO2toNO2 = 
     &         +          rrxn_irr( 31)  ! HO2 + NO =
     &         + ( 0.800)*rrxn_irr( 39)  ! NO3 + HO2 =
c
        HO2_loss = 
     &         +          rrxn_irr( 31)  ! HO2 + NO =
     &         +          rrxn_irr( 36)  ! HO2 + O3 =
     &         + ( 2.000)*rrxn_irr( 37)  ! HO2 + HO2 =
     &         + ( 2.000)*rrxn_irr( 38)  ! HO2 + HO2 + H2O =
     &         +          rrxn_irr( 39)  ! NO3 + HO2 =
     &         +          rrxn_irr( 43)  ! OH + HO2 =
     &         +          rrxn_irr( 47)  ! MEO2 + HO2 =
     &         +          rrxn_irr( 48)  ! MEO2 + HO2 =
     &         +          rrxn_irr( 53)  ! RO2C + HO2 =
     &         +          rrxn_irr( 58)  ! RO2X + HO2 =
     &         +          rrxn_irr( 67)  ! MCO3 + HO2 =
     &         +          rrxn_irr( 77)  ! RCO3 + HO2 =
     &         +          rrxn_irr( 88)  ! BZC3 + HO2 =
     &         +          rrxn_irr(100)  ! MAC3 + HO2 =
     &         +          rrxn_irr(112)  ! BZO + HO2 =
c
        desto3 = desto3 - (
     &         + rrxn_irr( 30)  ! OH + O3 =
     &                       ) * (HO2_loss-HO2toNO2)/HO2_loss
c
c  +  O3 + VOC
c
        desto3 = desto3
     &         - rrxn_irr(247)  ! AFG1 + O3 =
     &         - rrxn_irr(250)  ! AFG2 + O3 =
     &         - rrxn_irr(253)  ! AFG3 + O3 =
     &         - rrxn_irr(255)  ! MACR + O3 =
     &         - rrxn_irr(260)  ! MVK + O3 =
     &         - rrxn_irr(264)  ! IPRD + O3 =
     &         - rrxn_irr(275)  ! ACRO + O3 =
     &         - rrxn_irr(515)  ! ETHE + O3 =
     &         - rrxn_irr(519)  ! PRPE + O3 =
     &         - rrxn_irr(523)  ! BD13 + O3 =
     &         - rrxn_irr(527)  ! ISOP + O3 =
     &         - rrxn_irr(531)  ! APIN + O3 =
     &         - rrxn_irr(535)  ! ACYE + O3 =
     &         - rrxn_irr(549)  ! OLE1 + O3 =
     &         - rrxn_irr(553)  ! OLE2 + O3 =
     &         - rrxn_irr(559)  ! TERP + O3 =
     &         - rrxn_irr(563)  ! SESQ + O3 =
c
c  +  O(3P) + VOC
c
        desto3 = desto3
     &         - rrxn_irr(257)  ! MACR + O3P =
     &         - rrxn_irr(261)  ! MVK + O3P =
     &         - rrxn_irr(277)  ! ACRO + O3P =
     &         - rrxn_irr(517)  ! ETHE + O3P =
     &         - rrxn_irr(521)  ! PRPE + O3P =
     &         - rrxn_irr(525)  ! BD13 + O3P =
     &         - rrxn_irr(529)  ! ISOP + O3P =
     &         - rrxn_irr(533)  ! APIN + O3P =
     &         - rrxn_irr(551)  ! OLE1 + O3P =
     &         - rrxn_irr(555)  ! OLE2 + O3P =
     &         - rrxn_irr(561)  ! TERP + O3P =
c
        phno3 = rrxn_irr(25)
        pho2h = rrxn_irr(37) + rrxn_irr(38)
c
      elseif( idmech .EQ. 7) then
c
c --- CB7r2 Mechanism 7 ---
c
c  +  O1D + H2O
c
        desto3 =
     &         - rrxn_irr( 11)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
        desto3 = desto3
     &         - rrxn_irr( 13)  ! O3 + HO2 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
      HO2toNO2 =
     &       +          rrxn_irr( 25)  ! NO + HO2 =
     &       +          rrxn_irr( 32)  ! NO3 + HO2 =
c
      HO2_loss =
     &       +          rrxn_irr( 13)  ! O3 + HO2 =
     &       +          rrxn_irr( 15)  ! HO2 + O =
     &       +          rrxn_irr( 18)  ! OH + HO2 =
     &       + ( 2.000)*rrxn_irr( 19)  ! HO2 + HO2 =
     &       + ( 2.000)*rrxn_irr( 20)  ! HO2 + HO2 + H2O =
     &       +          rrxn_irr( 25)  ! NO + HO2 =
     &       +          rrxn_irr( 32)  ! NO3 + HO2 =
     &       +          rrxn_irr( 60)  ! C2O3 + HO2 =
     &       + ( 0.750)*rrxn_irr( 67)  ! CXO3 + HO2 =
     &       +          rrxn_irr( 73)  ! OPO3 + HO2 =
     &       +          rrxn_irr( 79)  ! MEO2 + HO2 =
     &       +          rrxn_irr( 84)  ! XO2H + HO2 =
     &       +          rrxn_irr( 87)  ! XO2 + HO2 =
     &       +          rrxn_irr( 90)  ! XO2N + HO2 =
     &       +          rrxn_irr(150)  ! BZO2 + HO2 =
     &       +          rrxn_irr(154)  ! TO2 + HO2 =
     &       +          rrxn_irr(158)  ! XLO2 + HO2 =
     &       +          rrxn_irr(171)  ! CRO + HO2 =
     &       + ( 0.940)*rrxn_irr(180)  ! ISO2 + HO2 =
     &       + ( 0.520)*rrxn_irr(198)  ! APO2 + HO2 =
     &       + ( 0.940)*rrxn_irr(204)  ! TPO2 + HO2 =
     &       +          rrxn_irr(233)  ! HPO2 + HO2 =
     &       +          rrxn_irr(236)  ! AUTX + HO2 =
     &       +          rrxn_irr(246)  ! IO + HO2 =
c
        desto3 = desto3 - (
     &         + rrxn_irr( 12)  ! O3 + OH =
     &                       ) * (HO2_loss-HO2toNO2)/HO2_loss
c
c  +  O3 + VOC
c
        desto3 = desto3
     &       - rrxn_irr(140)  ! ETH + O3 =
     &       - rrxn_irr(143)  ! OLE + O3 =
     &       - rrxn_irr(146)  ! IOLE + O3 =
     &       - rrxn_irr(162)  ! OPEN + O3 =
     &       - rrxn_irr(166)  ! XOPN + O3 =
     &       - rrxn_irr(183)  ! ISOP + O3 =
     &       - rrxn_irr(200)  ! APIN + O3 =
     &       - rrxn_irr(206)  ! TERP + O3 =
     &       - rrxn_irr(209)  ! SQT + O3 =
     &       - rrxn_irr(213)  ! TPRD + O3 =
c
c  +  Halogen catalytic destruction (the limiting reactions)
c
        desto3 = desto3
     &       -          rrxn_irr(246)  ! IO + HO2 =
     &       - ( 0.400)*rrxn_irr(245)  ! IO + IO =
     &       -          rrxn_irr(248)  ! IO + NO2 =
c
        phno3 = rrxn_irr(41) + rrxn_irr(42)
        pho2h = rrxn_irr(19) + rrxn_irr(20)
c
      elseif( idmech .EQ. 9) then
c
c --- RACM2s21 Mechanism 9 ---
c
c  +  O1D + H2O
c
        desto3 =
     &         - rrxn_irr( 42)  ! O1D + H2O =
c
c  +  HO2 + O3 (assuming no OH recycled)
c
        desto3 = desto3
     &         - rrxn_irr( 35)  ! O3 + HO2 =
c
c  +  OH + O3 (accounting for HO2 recycled to O3 via NO2 produced)
c
      HO2toNO2 =
     &       +          rrxn_irr( 50)  ! NO + HO2 =
     &       + ( 0.700)*rrxn_irr( 59)  ! NO3 + HO2 =

c
      HO2_loss =
     &       +          rrxn_irr( 35)  ! O3 + HO2 =
     &       +          rrxn_irr( 44)  ! OH + HO2 =
     &       + ( 2.000)*rrxn_irr( 45)  ! HO2 + HO2 =
     &       + ( 2.000)*rrxn_irr( 46)  ! HO2 + HO2 + H2O =
     &       +          rrxn_irr( 50)  ! NO + HO2 =
     &       +          rrxn_irr( 51)  ! NO + HO2 =
     &       +          rrxn_irr( 59)  ! NO3 + HO2 =
     &       +          rrxn_irr(212)  ! MO2 + HO2 =
     &       +          rrxn_irr(213)  ! ETHP + HO2 =
     &       +          rrxn_irr(214)  ! HC3P + HO2 =
     &       +          rrxn_irr(215)  ! HC5P + HO2 =
     &       +          rrxn_irr(216)  ! HC8P + HO2 =
     &       +          rrxn_irr(217)  ! ETEP + HO2 =
     &       +          rrxn_irr(218)  ! OLTP + HO2 =
     &       +          rrxn_irr(219)  ! OLIP + HO2 =
     &       +          rrxn_irr(220)  ! BENP + HO2 =
     &       +          rrxn_irr(221)  ! TLP1 + HO2 =
     &       +          rrxn_irr(222)  ! TOLP + HO2 =
     &       +          rrxn_irr(223)  ! PER1 + HO2 =
     &       +          rrxn_irr(224)  ! XYL1 + HO2 =
     &       +          rrxn_irr(225)  ! XYLP + HO2 =
     &       +          rrxn_irr(226)  ! PER2 + HO2 =
     &       +          rrxn_irr(227)  ! XYOP + HO2 =
     &       +          rrxn_irr(228)  ! ISOP + HO2 =
     &       +          rrxn_irr(229)  ! APIP + HO2 =
     &       +          rrxn_irr(230)  ! LIMP + HO2 =
     &       +          rrxn_irr(231)  ! ACO3 + HO2 =
     &       +          rrxn_irr(232)  ! RCO3 + HO2 =
     &       +          rrxn_irr(233)  ! ACTP + HO2 =
     &       +          rrxn_irr(234)  ! MEKP + HO2 =
     &       +          rrxn_irr(235)  ! KETP + HO2 =
     &       +          rrxn_irr(236)  ! MACP + HO2 =
     &       +          rrxn_irr(237)  ! MCP + HO2 =
     &       +          rrxn_irr(238)  ! MVKP + HO2 =
     &       +          rrxn_irr(239)  ! UALP + HO2 =
     &       +          rrxn_irr(240)  ! ADDC + HO2 =
     &       +          rrxn_irr(241)  ! CHO + HO2 =
     &       +          rrxn_irr(242)  ! MCTP + HO2 =
     &       +          rrxn_irr(243)  ! ORAP + HO2 =
     &       +          rrxn_irr(244)  ! OLNN + HO2 =
     &       +          rrxn_irr(245)  ! OLND + HO2 =
     &       +          rrxn_irr(246)  ! ADCN + HO2 =
     &       +          rrxn_irr(247)  ! XO2 + HO2 =
c
        desto3 = desto3 - (
     &         + rrxn_irr( 12)  ! O3 + OH =
     &                       ) * (HO2_loss-HO2toNO2)/HO2_loss
c
c  +  O3 + VOC
c
        desto3 = desto3
     &       - rrxn_irr(126)  ! ETE + O3 =
     &       - rrxn_irr(127)  ! OLT + O3 =
     &       - rrxn_irr(128)  ! OLI + O3 =
     &       - rrxn_irr(129)  ! DIEN + O3 =
     &       - rrxn_irr(130)  ! ISO + O3 =
     &       - rrxn_irr(131)  ! API + O3 =
     &       - rrxn_irr(132)  ! LIM + O3 =
     &       - rrxn_irr(133)  ! MACR + O3 =
     &       - rrxn_irr(134)  ! MVK + O3 =
     &       - rrxn_irr(135)  ! UALD + O3 =
     &       - rrxn_irr(136)  ! DCB1 + O3 =
     &       - rrxn_irr(137)  ! DCB2 + O3 =
     &       - rrxn_irr(138)  ! DCB3 + O3 =
     &       - rrxn_irr(139)  ! EPX + O3 =
     &       - rrxn_irr(140)  ! MCTO + O3 =
c
        phno3 = rrxn_irr(56)
        pho2h = rrxn_irr(45) + rrxn_irr(46)
c
      else
        write(iout,'(//,a)') 'ERROR in O3PRDSA:'
        write(iout,'(/,1X,A,I10)')
     &             'Unknown chemical mechanism ID number: ',idmech
        write(iout,'(/,1X,2A)')
     &             'Ozone source apportionment is not available ',
     &             'for this chemical mechanism'
        call camxerr()
      endif
c
c --- Assign ozone production to VOC or NOx ---
c
      desto3 = AMIN1(desto3*convfac,delo3)
      prodo3 = delo3 - desto3
      if( pho2h/phno3 .LE. 0.35) then
        prdo3n = 0.0
        prdo3v = prodo3
      else
        prdo3n = prodo3
        prdo3v = 0.0
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

C**** NCF_READINP_3D
c
      subroutine ncf_readinp_3d(igrd,ncol,nrow,nlay,height,phptim,hnext,
     &                             press,ppptim,pnext,windu,puptim,unext,
     &                                    windv,pvptim,vnext,tempk,ptptim,
     &                                            tnext,water,pwptim,wnext)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines reads the next hour of data in the 3D met file and
c   calculates the time/rate change based on the data for the current 
c   hour.
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        height              layer interface height field (m)
c        press               layer midpoint pressure field (mb)
c        windu               u-component wind field (m/s)
c        windv               u-component wind field (m/s)
c        tempk               temperature field (K)
c        water               water vapor field (ppm)
c
c     Output arguments:
c        phptim              time-rate change of layer interface height (m/s)
c        hnext                next layer interface height field (m)
c        ppptim              time-rate change of pressure (mb/s)
c        pnext                next pressure field (mb)
c        puptim              time-rate change of u-component wind (m/s2)
c        unext                next u-component wind field (m/s)
c        pvptim              time-rate change of v-component wind (m/s2)
c        vnext                next v-component wind field (m/s)
c        psptim              time-rate change of surface temperature (K/s)
c        tsnext               next surface temperature field (m/s)
c        ptptim              time-rate change of 3-D temperature (K/s)
c        tnext                next 3-D temperature field (m/s)
c        pwptim              time-rate change of 3-D water vapor (ppm/s)
c        wnext                next 3-D water vapor field (ppm)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     07/23/19   Staggered wind flag is now grid-specific
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      integer nlay
      real    height(ncol,nrow,nlay)
      real    phptim(ncol,nrow,nlay)
      real    hnext(ncol,nrow,nlay)
      real    press(ncol,nrow,nlay)
      real    ppptim(ncol,nrow,nlay)
      real    pnext(ncol,nrow,nlay)
      real    windu(ncol,nrow,nlay)
      real    puptim(ncol,nrow,nlay)
      real    unext(ncol,nrow,nlay)
      real    windv(ncol,nrow,nlay)
      real    pvptim(ncol,nrow,nlay)
      real    vnext(ncol,nrow,nlay)
      real    tempk(ncol,nrow,nlay)
      real    ptptim(ncol,nrow,nlay)
      real    tnext(ncol,nrow,nlay)
      real    water(ncol,nrow,nlay)
      real    pwptim(ncol,nrow,nlay)
      real    wnext(ncol,nrow,nlay)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       this_time_tflag, this_time_etflag
      integer       hdate, this_tstep, i, j, k
      real          whr, wmn, atim, htim
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. is_netcdf_i3dmet(igrd) ) goto 9999
c
      write(action,'(A,I3)') 'Reading 3D met file for grid ',igrd
c
c --- Find the date/time at the next update interval ---
c
      whr = aint(time/100.)
      wmn = anint(amod(time,100.))
      atim = 100.*whr + wmn
      htim = 100.*(whr + aint((wmn + dtinp)/60.)) +
     &             amod((wmn + dtinp),60.)
      hdate = date
      if (htim.ge.2400.) then
        htim = anint(htim - 2400.)
        hdate = hdate + 1
        if( MOD(hdate,1000) .GT. 365 ) then
           if( MOD(INT(hdate/1000),4) .EQ. 0 ) then
              if( MOD(hdate,1000) .EQ. 367 )
     &           hdate = (INT(hdate/1000)+1)*1000 + 1
           else
              hdate = (INT(hdate/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(i3dmet(igrd),action,hdate,htim,
     &               this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = nlay
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- layer heights ---
c
      this_var = "z"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,hnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- pressure ---
c
      this_var = "pressure"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,pnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- temperature ---
c
      this_var = "temperature"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,tnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- humidity ---
c
      this_var = "humidity"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,wnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- U-component of wind ---
c
      this_var = "uwind"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,unext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c ---- V-component of wind ---
c
      this_var = "vwind"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start,
     &                                          data_count,vnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
      if (.not.lstagw(igrd)) call cvtwind(ncol,nrow,nlay,unext,vnext)
c
c-----Calculate time rates of change for 3D met fields
c
      call timrates(ncol,nrow,nlay,height,hnext,phptim)
      call timrates(ncol,nrow,nlay,press,pnext,ppptim)
      call timrates(ncol,nrow,nlay,tempk,tnext,ptptim)
      call timrates(ncol,nrow,nlay,water,wnext,pwptim)
      call timrates(ncol,nrow,nlay,windu,unext,puptim)
      call timrates(ncol,nrow,nlay,windv,vnext,pvptim)
c
c  --- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5,a,i3)') 'Read 3D met file at ',htim,hdate,
     &                                                         ' grid',igrd
      call flush(iout)
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_3D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_3D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine hr_nxy9(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_NXY9 solves NO3 and N2O5 using Hertel's equations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is RACM2_s21 with nitrate hydrolysis + GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real self, fwd, bck
      real newNO3, lsNO3, lsN2O5, A, B, C, Q
c
c --- Entry Point
c
      N2 = M - O2
c
c
c --- New NO3 excluding from N2O5
c
      newNO3 = dt*(0.0
     &       + ( 0.200)*r(  9)
     &       +          r( 33)
     &       +          r( 37)
     &       +          r( 55)
     &       +          r( 57)
     &       +          r(120)
     &       +          r(121) )
c
c --- Loss of NO3 excluding self-reaction(s)
c
      lsNO3 = 1.0 + dt*(0.0
     &       +          rk(  5)
     &       +          rk(  6)
     &       +          rk( 58)*yh(lOH)
     &       +          rk( 59)*yh(lHO2)
     &       +          rk( 60)*yh(lNO)
     &       +          rk( 61)*yh(lNO2)
     &       +          rk( 63)*yh(lNO2)
     &       +          rk(141)*yh(lETE)
     &       +          rk(142)*yh(lOLT)
     &       +          rk(143)*yh(lOLI)
     &       +          rk(144)*yh(lDIEN)
     &       +          rk(145)*yh(lISO)
     &       +          rk(146)*yh(lAPI)
     &       +          rk(147)*yh(lLIM)
     &       +          rk(148)*yh(lHCHO)
     &       +          rk(149)*yh(lACD)
     &       +          rk(150)*yh(lALD)
     &       +          rk(151)*yh(lMACR)
     &       +          rk(152)*yh(lUALD)
     &       +          rk(153)*yh(lGLY)
     &       +          rk(154)*yh(lMGLY)
     &       +          rk(155)*yh(lPHEN)
     &       +          rk(156)*yh(lCSL)
     &       +          rk(157)*yh(lEPX)
     &       +          rk(158)*yh(lMCT)
     &       +          rk(159)*yh(lMPAN)
     &       +          rk(322)*yh(lMO2)
     &       +          rk(323)*yh(lETHP)
     &       +          rk(324)*yh(lHC3P)
     &       +          rk(325)*yh(lHC5P)
     &       +          rk(326)*yh(lHC8P)
     &       +          rk(327)*yh(lETEP)
     &       +          rk(328)*yh(lOLTP)
     &       +          rk(329)*yh(lOLIP)
     &       +          rk(330)*yh(lBENP)
     &       +          rk(331)*yh(lTLP1)
     &       +          rk(332)*yh(lTOLP)
     &       +          rk(333)*yh(lPER1)
     &       +          rk(334)*yh(lXYL1)
     &       +          rk(335)*yh(lXYLP)
     &       +          rk(336)*yh(lPER2)
     &       +          rk(337)*yh(lXYOP)
     &       +          rk(338)*yh(lISOP)
     &       +          rk(339)*yh(lAPIP)
     &       +          rk(340)*yh(lLIMP)
     &       +          rk(341)*yh(lACO3)
     &       +          rk(342)*yh(lRCO3)
     &       +          rk(343)*yh(lACTP)
     &       +          rk(344)*yh(lMEKP)
     &       +          rk(345)*yh(lKETP)
     &       +          rk(346)*yh(lMACP)
     &       +          rk(347)*yh(lMCP)
     &       +          rk(348)*yh(lMVKP)
     &       +          rk(349)*yh(lUALP)
     &       +          rk(350)*yh(lBALP)
     &       +          rk(351)*yh(lBAL1)
     &       +          rk(352)*yh(lADDC)
     &       +          rk(353)*yh(lMCTP)
     &       +          rk(354)*yh(lORAP)
     &       +          rk(355)*yh(lOLNN)
     &       +          rk(356)*yh(lOLND)
     &       +          rk(357)*yh(lADCN)
     &       +          rk(361)*yh(lXO2)
     &       +          rk(368)*yh(lDMS) )
c
c --- Loss of N2O5
c
      lsN2O5  = 1.0 + dt*(0.0
     &       +          rk( 64)
     &       +          rk( 65)*H2O )
c
c --- Forward reactions of NO3 to N2O5
c
      fwd  = dt*(0.0
     &       +          rk( 63)*yh(lNO2) )
c
c --- Backward reactions of N2O5 to NO3
c
      bck  = dt*(0.0
     &       +          rk( 64) )
c
c --- NO3 self-reaction excluding N2O5 production
c
      self = dt*(0.0
     &       + ( 2.000)*rk( 62) )
c
c --- Solve for NO3
c
      A = self*lsN2O5
      B = (lsN2O5*lsNO3) - (fwd*bck)
      C = lsN2O5*( y0(lNO3) + newNO3 ) + bck*y0(lN2O5)
      Q = -0.5 * ( B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C) )
c
c --- Update Concentrations
c
      y1(lNO3)  = MAX(1.0E-18, MAX(Q/A, -C/Q) )
      y1(lN2O5) = MAX(1.0E-15, (y0(lN2O5) + fwd*y1(lNO3)) / lsN2O5 )
c
      return
      end

      subroutine wrt_csa_hdr(endtim,enddate)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use camxcom
      use grid
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c         Writes the metadata and the other header variables to the
c         NetCDF for the CSA grids.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        endtim  - model end time (HHMM)
c        enddate - model end date (YYJJJ)
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       AVERAGE
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument delarations:
c-----------------------------------------------------------------------
c
      integer :: enddate
      real    :: endtim
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 :: action
c
      character*20, dimension(MXTRSP) :: spec_units
      character*20, dimension(MXTRSP) :: spec_long_name
      character*60, dimension(MXTRSP) :: spec_desc
      character*60, dimension(MXTRSP) :: spec_coords
c
      integer :: icsa_grid           
      integer :: nocl_grid           
      integer :: nrow_grid           
      integer :: nlay_grid           
      integer :: igrid_mod
      integer :: ncol_csa
      integer :: nrow_csa
      integer :: nlay_csa
c
      real :: dx_csa
      real :: dy_csa
      real :: dx_grid
      real :: dy_grid
      real :: orgx_csa
      real :: orgy_csa
      real :: orgx_grid
      real :: orgy_grid
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- loop over grids ---
c
      do icsa_grid = 1,npadom
         igrid_mod = ipadom(icsa_grid)
         dx_csa   = 1000.*(delx/float(meshold(igrid_mod)))
         dy_csa   = 1000.*(dely/float(meshold(igrid_mod)))
         orgx_grid = xorg + delx*(inst1(igrid_mod)-1) - dx_grid
         orgy_grid = yorg + dely*(jnst1(igrid_mod)-1) - dy_grid
         orgx_csa = 1000.*(orgx_grid + (i_sw(icsa_grid) - 1)*dx_grid)
         orgy_csa = 1000.*(orgy_grid + (j_sw(icsa_grid) - 1)*dy_grid)
         ncol_csa = i_ne(icsa_grid) - i_sw(icsa_grid) + 1
         nrow_csa = j_ne(icsa_grid) - j_sw(icsa_grid) + 1
         nlay_csa = t_lay(icsa_grid) - b_lay(icsa_grid) + 1
         if( llatlon ) then
            dx_csa   = dx_csa/1000.
            dy_csa   = dy_csa/1000.
            orgx_csa = orgx_csa/1000.
            orgy_csa = orgy_csa/1000.
         endif
c
         call ncf_set_vars_base()
         call ncf_set_tstep(begdate,begtim,enddate,endtim)
         write(action,'(A,I2)') 'Writing output file for CSA domain: ',
     &                                                         icsa_grid
         call ncf_set_specatt_ddm(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
         call ncf_set_global_csa('CSA       ',icsa_grid,begdate,begtim,
     &                                                  enddate,endtim)
         call ncf_wrt_dim(action,iow_csa(icsa_grid),icsa_grid,ncol_csa,
     &                                          nrow_csa,nlay_csa,ntotsp)
         call ncf_wrt_global(action,iow_csa(icsa_grid),ntotsp,ptname,.FALSE.)
         call ncf_wrt_vars_base(action,iow_csa(icsa_grid))
         call ncf_wrt_vars_species(action,iow_csa(icsa_grid),ncol_csa,
     &                     nrow_csa,nlay_csa,ntotsp,ptname,spec_units,
     &                           spec_long_name,spec_desc,spec_coords,4)
         call ncf_enddef_file(action,iow_csa(icsa_grid))
         call ncf_wrt_data_gridcsa(action,iow_csa(icsa_grid),icsa_grid,
     &             ncol_csa,nrow_csa,orgx_csa,orgy_csa,dx_csa,dy_csa,nlay_csa)
      enddo
c
      return
      end

      subroutine srfruf(m1,m2,m3,ncol,nrow,nlay,date,cellat,cellon,
     &                 windu,windv,fsurf,snow,lrdlai,lai,sfcz0)
c
c----CAMx v7.40 260801
c 
c     SRFRUF calculates surface roughness for the specified grid, according
c     to landuse, season, snow, and wind speed (water surfaces only).
c 
c      Copyright Ramboll
c           
c     Modifications:
c        8/10/09   Added Zhang (2003) LAI-based surface roughness calculation
c                  for 26 landuse categories
c        02/11/11  Removed optional roughness from AHO
c        04/02/12  Removed drought stress and snow flag; AHO
c                  file is now just ozone column
c        08/11/14  Snow cover changed to water equivalent depth
c
c     Input arguments:
c        m1                  number of columns (MPI slice)
c        m2                  number of rows (MPI slice)
c        m3                  number of layers (MPI slice)
c        ncol                number of columns 
c        nrow                number of rows 
c        nlay                number of layers 
c        date                model date
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        windu               layer U-component wind field (m/s)
c        windv               layer V-component wind field (m/s)
c        fsurf               fractional landuse cover field (fraction)
c        snow                snow cover water equivalent (m)
c             
c     Output arguments: 
c        sfcz0               surface roughness (m)
c             
c     Routines called: 
c        None
c             
c     Called by: 
c        EMISTRNS
c 
      implicit none
      include 'camx.prm'
      include 'deposit.inc'
      include 'flags.inc'
c
      integer :: m1,m2,m3,iday,iyear
      integer :: ncol,nrow,nlay,idate,date,month
      real, dimension(m1,m2) :: cellat, cellon, lai, sfcz0, snow
      integer, dimension(12) :: nday
      real, dimension(m1,m2,m3) :: windu, windv
      real, dimension(m1,m2,nlu) :: fsurf
      real lai_ref_intpl,rlai,ref_lai,lai_f
      logical lrdlai
c
      integer i,j,m,mbin,latbin,isesn
      real ucomp,vcomp,wind,totland,z0,z0sum
c
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
      idate = date
      call caldate(idate)
      iyear = idate/1000
      if (mod(iyear,4).eq.0) nday(2)=29
      month = (idate - 10000*int(idate/10000.))/100
      iday = idate - 100*int(idate/100.) !Julian day
c
c-----Loop over rows and columns
c
      do 30 j = 2,m2-1 
        do 20 i = 2,m1-1
c
c-----Determine season
c
          mbin = month
          if (cellat(i,j).lt.0.) then
            mbin = mod(month+6,12)
            if (mbin.eq.0) mbin = 12
          endif
          latbin = 1
          if (abs(cellat(i,j)).gt.20.) then
            latbin = 2
          elseif (abs(cellat(i,j)).gt.35.) then
            latbin = 3
          elseif (abs(cellat(i,j)).gt.50.) then
            latbin = 4
          elseif (abs(cellat(i,j)).gt.75.) then
            latbin = 5
          endif
          if ((cellat(i,j).gt.50. .and. cellat(i,j).lt.75.) .and.
     &        (cellon(i,j).gt.-15. .and. cellon(i,j).lt.15.)) latbin = 3
          isesn = iseason(latbin,mbin)
c
c-----Use input snow cover to set season, if specified
c
          if (snow(i,j).ge.0.001) isesn = 4   ! Snow cover check > 1 cm
c
c-----Determine cell-average relative LAI if it was read
c
          if (lrdlai .and. nlu.eq.26) then
            ref_lai = 0.
            do m = 1,nlu
              lai_ref_intpl = lai_ref(m,mbin) + iday/nday(mbin)*
     &                       (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              ref_lai = ref_lai + fsurf(i,j,m)*lai_ref_intpl
            enddo
            rlai = lai(i,j)/(ref_lai + 1.e-10)
          endif
c
c-----Load local met variables
c
          ucomp = (windu(i,j,1) + windu(i-1,j,1))/2.
          vcomp = (windv(i,j,1) + windv(i,j-1,1))/2.
          wind = sqrt(ucomp**2 + vcomp**2)
          wind = amax1(0.1,wind)
c
c-----Loop over land use; determine roughness depending on choice of deposition
c     model
c
          totland = 0.
          z0sum = 0.
          do 10 m = 1,nlu
            if (fsurf(i,j,m).lt.0.01) goto 10
            totland = totland + fsurf(i,j,m)
c
c-----Wesely (1989) landuse cats; surface roughness for water is dependent on
c     wind speed
c
            if (nlu .eq. 11) then
              z0 = z0lu(m,isesn)
              if (m.eq.7) z0 = amax1(z0,2.0e-6*wind**2.5)
c
c-----Zhang (2003) landuse cats; roughnes scaled by LAI
c
            else
              lai_f = lai_ref(m,mbin) +
     &                float(min(nday(mbin),iday))/float(nday(mbin))*
     &                (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              if (lrdlai) then
                lai_f = lai_f*rlai
                lai_f = amin1(lai_ref(m,15),lai_f)
                lai_f = amax1(lai_ref(m,14),lai_f)
              endif
              if (m.eq.1 .or. m.eq.3) then
                z0 = 2.0e-6*wind**2.5
              else
                if (z02(m).gt.z01(m)) then
                  z0 = z01(m) + (z02(m) - z01(m))*
     &                        (lai_f - lai_ref(m,14))/
     &                        (lai_ref(m,15) - lai_ref(m,14))
                else
                  z0 = z01(m)
                endif
              endif
            endif
c
            z0sum = z0sum + alog(z0)*fsurf(i,j,m)
 10       continue

          totland = amax1(totland, 0.01)
          sfcz0(i,j) = exp(z0sum)/totland
 20     continue
 30   continue
c
      return
      end

      subroutine MPI_BARRIER(COMM,IERROR)
      integer COMM
      integer IERROR
      end

      subroutine MPI_COMM_RANK(COMM,RANK,IERROR)
      integer COMM
      integer IERROR
      integer RANK
      end

      subroutine MPI_COMM_SIZE(COMM,SIZE,IERROR)
      integer COMM
      integer IERROR
      integer SIZE
      end

      subroutine MPI_FINALIZE(IERROR)
      integer IERROR
      end

      subroutine MPI_INIT(IERROR)
      integer IERROR
      IERROR = 1
      end

      subroutine MPI_SEND(BUF,COUNT,DATATYPE,DEST,TAG,COMM,IERROR)
      real    BUF
      integer COUNT
      integer DATATYPE
      integer DEST
      integer TAG
      integer COMM
      integer IERROR
      end

      subroutine MPI_RECV(BUF,COUNT,DATATYPE,SOURCE,TAG,COMM,
     &                                              STATUS,IERROR)
      real    BUF
      integer COUNT
      integer DATATYPE
      integer TAG
      integer COMM
      integer STATUS
      integer IERROR
      end

      subroutine MPI_ABORT(COMM,RANK,IERROR)
      integer COMM
      integer IERROR
      integer RANK
      end

      subroutine MPI_NULL_COPY_FN()
      end

      subroutine MPI_NULL_DELETE_FN()
      end

      subroutine MPI_DUP_FN()
      end

      subroutine kphoto(iozon,alb,terrain,hght,zenith,cldtrns,ldark,
     &                  temp,pres)
      use chmstry
      use o3colmap
      implicit none
c 
c----CAMx v7.40 260801
c 
c     KPHOTO adjusts all photolysis rate constants for height, ozone
c     column, surface albedo, terrain ht, and zenith angle
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        4/2/03        Removed option for UAM-V type cloud adjustment
c       10/14/04       Modifications to handle Mechanism 10 (no photo rates)
c        7/14/10       Added code for in-line TUV cloud adjustment
c        04/02/12      Removed RADM cloud adjustment option, cloud/aerosol
c                      adjustments now always done with in-line TUV; AHO
c                      file is now just ozone column; replaced haze
c                      dimension with terrain height in photo file
c        04/04/12      Introduced 4-dim interpolation of J values over
c                      zenith, height, albedo, terrain
c        04/12/12      Added T and P adjustments to photolysis rates
c 
c     Input arguments: 
c        iozon               ozone column index
c        alb                 surface albedo
c        terrain             terrain height (km)
c        hght                height AGL (km)
c        zenith              solar zenith angle (deg)
c        cldtrns             enery transmission coefficient
c        ldark               darkness flag (T=dark)
c        temp                temperature (K)
c        pres                pressure (mb)
c 
c     Output arguments: 
c        none
c 
c     Routines Called: 
c        none
c 
c     Called by: 
c        CHEMDRIV
c        PIGDRIVE
c
      include "camx.prm"
c
c-----Arguments
c
      integer iozon
      real alb,terrain,hght,zenith,cldtrns
      real temp,pres
      logical ldark
c
c-----Local
c
      integer nphot,irxn,ihght,izen,ialb,itrn
      integer i
      real tmp,w1,w2,w3,w4
      real prkn1111,prkn1112,prkn1121,prkn1122,prkn1211,prkn1212,
     &     prkn1221,prkn1222,prkn2111,prkn2112,prkn2121,prkn2122,
     &     prkn2211,prkn2212,prkn2221,prkn2222,tmp11,tmp12,tmp13,
     &     tmp14,tmp15,tmp16,tmp17,tmp18,tmp21,tmp22,tmp23,tmp24,
     &     tmp31,tmp32
      real tref,pref,adj1,adj2
      real no2tadj(NZEN),o3tadj(NZEN),hchotadj1(NZEN),hchotadj2(NZEN),
     &     hchopadj(NZEN),ch3chopadj(NZEN)
c
      data tref,pref /298.,1013./
c
c-----Photolysis T and P factors (%/K, %/mb) for 10 zenith angles from TUV
c
      data no2tadj
     &     /0.071,0.072,0.072,0.072,0.072,0.073,0.074,0.076,0.080,0.081/
      data o3tadj
     &     /0.265,0.268,0.275,0.288,0.308,0.339,0.384,0.447,0.485,0.454/
      data hchotadj1
     &     /0.024,0.024,0.024,0.025,0.026,0.026,0.028,0.030,0.031,0.032/
      data hchotadj2
     &     /0.033,0.033,0.033,0.033,0.033,0.034,0.034,0.036,0.036,0.038/
      data hchopadj
     &     /-.017,-.017,-.017,-.017,-.018,-.018,-.019,-.020,-.021,-.023/
      data ch3chopadj
     &     /-1.393E-03,-1.396E-03,-1.402E-03,-1.412E-03,-1.427E-03,
     &      -1.446E-03,-1.473E-03,-1.504E-03,-1.528E-03,-1.536E-03/
c
c-----Entry point
c
c-----If nphot is zero, nothing to do
c
      nphot = nphot1 + nphot2
      if (nphot.eq.0) return
c
c-----If dark, zero all the photolysis reaction rate constants
c
      if (ldark) then
        do irxn = 1,nphot1
          rk(idphot1(irxn)) = 0.
        enddo
        do irxn = 1,nphot2
          rk(idphot2(irxn)) = 0.
        enddo
        goto 999
      endif       
c
c-----Locate the point in height axis
c
      ihght = 1
      do i = 1,NHGHT-1
        if (hght.ge.htint(i)) ihght = i
      enddo
      tmp = (hght - htint(ihght))/(htint(ihght+1) - htint(ihght))
      w1 = 1. - tmp
c
      if (tmp.gt.1.) then ! If height exceeds upper limit
        ihght = NHGHT - 1
        w1 = 0.
      endif
c
c-----Locate the point in zenith angle axis
c
      izen = 1
      do i = 1,NZEN-1
        if (zenith.ge.zenint(i)) izen = i
      enddo
      tmp = (zenith - zenint(izen))/(zenint(izen+1) - zenint(izen))
      w2 = 1. - tmp
c
      if (tmp.gt.1.) then ! If zenith exceeds upper limit
        izen = NZEN-1
        w2 = 0.
      endif
c
c-----Locate the point in albedo axis
c
      ialb = 1
      do i = 1,NALB-1
        if (alb.ge.albcl(i)) ialb = i
      enddo
      tmp = (alb - albcl(ialb))/(albcl(ialb+1) - albcl(ialb))
      w3 = 1. - tmp
c
      if (tmp.lt.0.) then ! If albedo exceeds lower limit
        w3 = 1.
      endif
      if (tmp.gt.1.) then ! If albedo exceeds upper limit
        ialb = NALB-1
        w3 = 0.
      endif
c
c-----Locate the point in terrain axis
c
      itrn = 1
      do i = 1,NTRN-1
        if (terrain.ge.trncl(i)) itrn = i
      enddo
      tmp = (terrain - trncl(itrn))/(trncl(itrn+1) - trncl(itrn))
      w4 = 1. - tmp
c
      if (tmp.lt.0.) then ! If terrain exceeds lower limit
        w4 = 1.
      endif
      if (tmp.gt.1.) then ! If terrain exceeds upper limit
        itrn = NTRN-1
        w4 = 0.
      endif
c
c-----Set the primary photolysis rates using interpolation
c     in height, zenith angle, albedo, and terrain elevation
c
      do irxn = 1,nphot1
        prkn1111 = prkn(izen,  irxn,ihght,  itrn,  ialb,  iozon)
        prkn1112 = prkn(izen,  irxn,ihght+1,itrn,  ialb,  iozon)
        prkn1121 = prkn(izen+1,irxn,ihght,  itrn,  ialb,  iozon)
        prkn1122 = prkn(izen+1,irxn,ihght+1,itrn,  ialb,  iozon)
        prkn1211 = prkn(izen,  irxn,ihght,  itrn,  ialb+1,iozon)
        prkn1212 = prkn(izen,  irxn,ihght+1,itrn,  ialb+1,iozon)
        prkn1221 = prkn(izen+1,irxn,ihght,  itrn,  ialb+1,iozon)
        prkn1222 = prkn(izen+1,irxn,ihght+1,itrn,  ialb+1,iozon)
        prkn2111 = prkn(izen,  irxn,ihght,  itrn+1,ialb,  iozon)
        prkn2112 = prkn(izen,  irxn,ihght+1,itrn+1,ialb,  iozon)
        prkn2121 = prkn(izen+1,irxn,ihght,  itrn+1,ialb,  iozon)
        prkn2122 = prkn(izen+1,irxn,ihght+1,itrn+1,ialb,  iozon)
        prkn2211 = prkn(izen,  irxn,ihght,  itrn+1,ialb+1,iozon)
        prkn2212 = prkn(izen,  irxn,ihght+1,itrn+1,ialb+1,iozon)
        prkn2221 = prkn(izen+1,irxn,ihght,  itrn+1,ialb+1,iozon)
        prkn2222 = prkn(izen+1,irxn,ihght+1,itrn+1,ialb+1,iozon)
        tmp11 = w1*prkn1111 + (1.-w1)*prkn1112
        tmp12 = w1*prkn1121 + (1.-w1)*prkn1122
        tmp13 = w1*prkn1211 + (1.-w1)*prkn1212
        tmp14 = w1*prkn1221 + (1.-w1)*prkn1222
        tmp15 = w1*prkn2111 + (1.-w1)*prkn2112
        tmp16 = w1*prkn2121 + (1.-w1)*prkn2122
        tmp17 = w1*prkn2211 + (1.-w1)*prkn2212
        tmp18 = w1*prkn2221 + (1.-w1)*prkn2222
        tmp21 = w2*tmp11 + (1.-w2)*tmp12
        tmp22 = w2*tmp13 + (1.-w2)*tmp14
        tmp23 = w2*tmp15 + (1.-w2)*tmp16
        tmp24 = w2*tmp17 + (1.-w2)*tmp18
        tmp31 = w3*tmp21 + (1.-w3)*tmp22
        tmp32 = w3*tmp23 + (1.-w3)*tmp24
        rk(idphot1(irxn)) = w4*tmp31 + (1.-w4)*tmp32
      enddo
c
c-----Cloud/aerosol adjustment
c
      do irxn = 1,nphot1
        rk(idphot1(irxn)) = rk(idphot1(irxn))*cldtrns
      enddo
c
c-----Set secondary photolysis rates as ratios to primary rates
c
      do irxn = 1,nphot2
        rk(idphot2(irxn)) = rk(idphot3(irxn))*phtscl(irxn)
      enddo
c
c-----Apply T and P adjustments for current conditions
c
      adj1 = 1. + no2tadj(izen)*(temp - tref)/100.
      adj2 = 1. + no2tadj(izen+1)*(temp - tref)/100.
      rk(jno2rxn) = rk(jno2rxn)*(w2*adj1 + (1.-w2)*adj2)

      adj1 = 1. + o3tadj(izen)*(temp - tref)/100.
      adj2 = 1. + o3tadj(izen+1)*(temp - tref)/100.
      rk(jo3rxn) = rk(jo3rxn)*(w2*adj1 + (1.-w2)*adj2)

      adj1 = 1. + hchotadj1(izen)*(temp - tref)/100.
      adj2 = 1. + hchotadj1(izen+1)*(temp - tref)/100.
      rk(jhcho1rxn) = rk(jhcho1rxn)*(w2*adj1 + (1.-w2)*adj2)

      adj1 = 1. + hchotadj2(izen)*(temp - tref)/100.
     &           *hchopadj(izen)*(pres*tref/temp  - pref)/100.
      adj2 = 1. + hchotadj2(izen+1)*(temp - tref)/100.
     &           *hchopadj(izen+1) *(pres*tref/temp  - pref)/100.
      rk(jhcho2rxn) = rk(jhcho2rxn)*(w2*adj1 + (1.-w2)*adj2)

      adj1 = 1. + ch3chopadj(izen)*(pres*tref/temp  - pref)/100.
      adj2 = 1. + ch3chopadj(izen+1)*(pres*tref/temp  - pref)/100.
      rk(jch3chorxn) = rk(jch3chorxn)*(w2*adj1 + (1.-w2)*adj2)
c
 999  return
      end

      subroutine soachem(iout,tempk,press,dthr,rk,
     &                   avgox,cprec,dcprec,cCG,cNV,yfac,
     &                   nfam,avgsen,sen_prec,sen_CG,sen_NV,lddm)
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine solves the oxidation reactions for SOA precursors
c     assuming first-order decay and constant oxidant concentrations
c
c      Copyright Ramboll
c
c     Input arguments:
c        iout     standard output file unit
c        tempk    cell temperature [K]
c        press    cell pressure [mb]
c        dthr     time duration to be integrated [hr]
c        rk       gas-phase rate constants [ppm-n hr-1]
c        avgox    average oxidant concentrations [ppm]
c                 1 - O; 2 - OH; 3 - O3; 4 - NO3; 5 - NO; 6 - HO2
c        cprec    precursor concentrations [ppm]
c                 1 - BNZA; 2 - HPAR; 3 - TOLA; 4  - XYLA; 5 - IVOA; 6 - IVC1
c                 7 - IVC2; 8 - SVOA; 9 - ISP ; 10 - TRP ; 11 - APN; 12 - SQT
c                13 - FVC1
c        cCG      CG species concentrations [ppm]
c                 1 - ACG2; 2 - ACG1; 3 - BCG2; 4 - BCG1
c        cNV      NV products concentration [ppm]
c                 1 - CGA (anthro); 2 - CGB (bio)
c        yfac     weighted yield factors
c        nfam     number of sensitivity families
c        avgsen   average sensitivities of oxidants [ppm]
c        sen_prec sensitivities of precursors [ppm]
c        sen_CG   sensitivities of CGs [ppm]
c        sen_NV   sensitivities of NVs [ppm]
c        lddm     logical flag for DDM sensitivities
c
c     Output arguments:
c        cprec    precursor concentrations [ppm]
c        dcprec   change in precursor concentrations [ppm]
c        cCG      CG species concentrations [ppm]
c        cNV      NV products concentration [ppm]
c        yfac     3 weighted yields, fh, fn for each precursor
c        sen_prec sensitivities of precursors [ppm]
c        sen_CG   sensitivities of CGs [ppm]
c        sen_NV   sensitivities of NVs [ppm]
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     03/22/06  --bkoo--  Original development
c     06/20/06  --bkoo--  2-product model for isoprene
c     08/23/13  --bkoo--  Added code for DDM-PM
c     03/18/14  --bkoo--  Revised for benzene SOA
c     08/25/16  --bkoo--  Updated for new SOAP (SOAP2 begins)
c     04/22/19  --gy----  Updated hi/low NOx rate constants
c     04/05/24  --cemery-- Added SVOA (SOAP3 begins)
c     05/16/24  --lhuang-- Differentiate SOA yields from TERP and
c                          add SOA yields from APIN 
c     05/23/24  --gy----  Use rate constats from the gas-phase mechanism
c                         except IVOA & SVOA rate constants are local and
c                         RO2 rate constants are local and follow MCM
c     04/26/25 --gwilson-- Add SOAP precursor species IVC1, IVC2, HPAR
c     03/31/26  --gy----  Add FVC1 precursor from fire emissions
c
c-----------------------------------------------------------------------
c
      implicit none
      include 'soap.inc'
      include 'soap3.inc'
      include 'chmdat.inc'
c
c     soap.inc passes pointers iksoap() to access rate constants rk()
c            1 - BNZA + OH; 2 - TOLA + OH;   3 - XYLA + OH 
c            4 - ISP + OH ;  5 - ISP + O3;   6 - ISP + NO3
c            7 - TRP + OH ;  8 - TRP + O3;   9 - TRP + NO3
c           10 - SQT + OH ; 11 - SQT + O3;  12 - SQT + NO3
c           13 - APN + OH ; 14 - APN + O3;  15 - APN + NO3
c           16 - HPAR + OH; 17 - FVC1 + OH; 18 - FVC1 + O3
c           19 - FVC1 + NO3
c
      integer :: iout
      real    :: tempk,press,dthr
      real    :: avgox(NOXID),cprec(NPREC_S),cCG(NSOAP),cNV(NNVOL)
      real    :: dcprec(NPREC_S)
      real    :: yfac(5,NPREC_S)

      real    :: rk(*)

      real, parameter    :: eps = 1.e-12
c
c======================== DDM Begin =======================
c
      integer :: nfam,ifam
      real    :: avgsen(nfam,NOXID)
      real    :: sen_prec(nfam,NPREC)
      real    :: sen_CG(nfam,NCG)
      real    :: sen_NV(nfam,NNV)
      real    :: srh(nfam)
      real    :: ssumk,srk1(NOXID),sdprec
      logical :: lddm, luse_sqt, luse_apin, luse_hpar, luse_fvc1
c
c======================== DDM End =======================
c
c     [1/ppm-hr] = [cm3/molecule-sec]*3600*(6.022e23*1.e-12/8.314)*(P[Pa]/T[K])
      real, parameter  :: s2h = 3600.0 ! seconds per hour
      real, parameter  :: cf0 = 2.608e14 ! 3600*(6.022e23*1.e-12/8.314)
      real, parameter  :: rkivoa = 1.34E-11 ! OH + IVOA rate constant
      real, parameter  :: rkivc1 = 1.34E-11 ! OH + IVC1 rate constant
      real, parameter  :: rkivc2 = 1.34E-11 ! OH + IVC2 rate constant
      real, parameter  :: rksvoa = 1.6E-11  ! OH + SVOA rate constant
      real    :: cfac
      real    :: rk1(NOXID), rh, rl, ra, fh, fl, fn, sumk, dprec, cfrac
      real    :: dfac
      integer :: i, j, k
c 
c----Entry Point
c
      yfac(:,:) = 0.0
      dcprec = 0.0
c
c----check status of SQT, APIN and HPAR
c
      luse_sqt  = .FALSE.
      luse_apin = .FALSE.
      luse_hpar = .FALSE.
      luse_fvc1 = .FALSE.
      if(iksoap(10) .GT. 0) luse_sqt  = .TRUE.
      if(iksoap(13) .GT. 0) luse_apin = .TRUE.
      if(iksoap(16) .GT. 0) luse_hpar = .TRUE.
      if(iksoap(17) .GT. 0) luse_fvc1 = .TRUE.
c
c-----Conversion factor for 2nd-order rate constants from cms to ppm-hr
c
      cfac = cf0 * (press*100./tempk) ! [1/ppm-hr] = cfac * [cm3/molecule-sec]
c
c-----Re-set NV product concentrations to zero
c
      cNV = 0.0
c
c-----NOx-dependent pathways for HPAR, if active
c
      if( luse_hpar ) then
         rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )   ! HPAR RO2 + NO rate (hr-1)
         rl = 2.39e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2)  ! HPAR RO2 + HO2 rate (hr-1)
         ra = 2.20e+08*exp(-6200.0/tempk)*s2h                   ! HPAR RO autoxidation rate (hr-1)
         fh = (rh / (rh + rl)) * (rh / (rh + ra + rl))
         fl = 1.0 - fh
         yfac(1,ISOAP_HPAR) = y_h(1,ISOAP_HPAR)*fh + y_l(1,ISOAP_HPAR)*fl
         yfac(2,ISOAP_HPAR) = y_h(2,ISOAP_HPAR)*fh + y_l(2,ISOAP_HPAR)*fl
         yfac(3,ISOAP_HPAR) = y_h(3,ISOAP_HPAR)*fh + y_l(3,ISOAP_HPAR)*fl
         yfac(4,ISOAP_HPAR) = fh
c
c======================== DDM Begin =======================
c
         if ( lddm ) then
           do ifam = 1, nfam
             sen_NV(ifam,:) = 0.0 ! <- cNV reset
             srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
           enddo
         endif
c
c======================== DDM End =======================
c
         rk1(IOX_OH ) = rk(iksoap(16)) * avgox(IOX_OH ) ! HPAR + OH rate (hr-1)
         cfrac = 1. - exp(-rk1(IOX_OH )*dthr)
         dprec = cprec(ISOAP_HPAR) * cfrac
         dcprec(ISOAP_HPAR) = -dprec
         if (dprec.gt.eps) then
           cprec(ISOAP_HPAR) = cprec(ISOAP_HPAR) - dprec
           cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_HPAR)
           cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_HPAR)
           cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_HPAR)
c
c======================== DDM Begin =======================
c
           if ( lddm ) then
             do ifam = 1, nfam
               srk1(IOX_OH) = rk(iksoap(16)) * avgsen(ifam,IOX_OH)
               sdprec = sen_prec(ifam,ISOAP_HPAR) * cfrac
     &             + cprec(ISOAP_HPAR) * dthr * srk1(IOX_OH) ! because cprec has been updated
               sen_prec(ifam,ISOAP_HPAR) = sen_prec(ifam,ISOAP_HPAR) - sdprec
               sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_HPAR)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_HPAR)*srh(ifam) - y_l(1,ISOAP_HPAR)*srh(ifam) )
               sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_HPAR)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_HPAR)*srh(ifam) - y_l(2,ISOAP_HPAR)*srh(ifam) )
                 sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_HPAR)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_HPAR)*srh(ifam) - y_l(3,ISOAP_HPAR)*srh(ifam) )
             enddo
c
c======================== DDM End =======================
c
           endif
         endif
      endif   ! end check of luse_hpar
c
c-----NOx-dependent pathways for aromatics
c
      rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )   ! aromatic RO2 + NO rate (hr-1)
      rl = 2.39e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2)  ! aromatic RO2 + HO2 rate (hr-1)
      fh = rh / (rh + rl)
      fl = 1.0 - fh

      yfac(1,ISOAP_BNZA) = y_h(1,ISOAP_BNZA)*fh + y_l(1,ISOAP_BNZA)*fl
      yfac(2,ISOAP_BNZA) = y_h(2,ISOAP_BNZA)*fh + y_l(2,ISOAP_BNZA)*fl
      yfac(3,ISOAP_BNZA) = y_h(3,ISOAP_BNZA)*fh + y_l(3,ISOAP_BNZA)*fl
      yfac(4,ISOAP_BNZA) = fh

      yfac(1,ISOAP_TOLA) = y_h(1,ISOAP_TOLA)*fh + y_l(1,ISOAP_TOLA)*fl
      yfac(2,ISOAP_TOLA) = y_h(2,ISOAP_TOLA)*fh + y_l(2,ISOAP_TOLA)*fl
      yfac(3,ISOAP_TOLA) = y_h(3,ISOAP_TOLA)*fh + y_l(3,ISOAP_TOLA)*fl
      yfac(4,ISOAP_TOLA) = fh

      yfac(1,ISOAP_XYLA) = y_h(1,ISOAP_XYLA)*fh + y_l(1,ISOAP_XYLA)*fl
      yfac(2,ISOAP_XYLA) = y_h(2,ISOAP_XYLA)*fh + y_l(2,ISOAP_XYLA)*fl
      yfac(3,ISOAP_XYLA) = y_h(3,ISOAP_XYLA)*fh + y_l(3,ISOAP_XYLA)*fl
      yfac(4,ISOAP_XYLA) = fh
c
c======================== DDM Begin =======================
c
      if ( lddm ) then
        do ifam = 1, nfam
          sen_NV(ifam,:) = 0.0 ! <- cNV reset
          srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
        enddo
      endif
c
c======================== DDM End =======================
c
c     BNZA

      rk1(IOX_OH ) = rk(iksoap(1)) * avgox(IOX_OH ) ! BNZA + OH rate (hr-1)
      cfrac = 1. - exp(-rk1(IOX_OH )*dthr)
      dprec = cprec(ISOAP_BNZA) * cfrac
      dcprec(ISOAP_BNZA) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_BNZA) = cprec(ISOAP_BNZA) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_BNZA)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_BNZA)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_BNZA)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rk(iksoap(1)) * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_BNZA) * cfrac
     &             + cprec(ISOAP_BNZA) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_BNZA) = sen_prec(ifam,ISOAP_BNZA) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_BNZA)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_BNZA)*srh(ifam) - y_l(1,ISOAP_BNZA)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_BNZA)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_BNZA)*srh(ifam) - y_l(2,ISOAP_BNZA)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_BNZA)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_BNZA)*srh(ifam) - y_l(3,ISOAP_BNZA)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
 
c     TOLA

      rk1(IOX_OH ) = rk(iksoap(2)) * avgox(IOX_OH ) ! TOLA + OH rate (hr-1)
      cfrac = 1. - exp(-rk1(IOX_OH )*dthr)
      dprec = cprec(ISOAP_TOLA) * cfrac
      dcprec(ISOAP_TOLA) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_TOLA) = cprec(ISOAP_TOLA) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_TOLA)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_TOLA)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_TOLA)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rk(iksoap(2)) * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_TOLA) * cfrac
     &             + cprec(ISOAP_TOLA) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_TOLA) = sen_prec(ifam,ISOAP_TOLA) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_TOLA)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_TOLA)*srh(ifam) - y_l(1,ISOAP_TOLA)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_TOLA)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_TOLA)*srh(ifam) - y_l(2,ISOAP_TOLA)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_TOLA)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_TOLA)*srh(ifam) - y_l(3,ISOAP_TOLA)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif

c     XYLA

      rk1(IOX_OH ) = rk(iksoap(3)) * avgox(IOX_OH ) ! XYLA + OH rate (hr-1)
      cfrac = 1. - exp(-rk1(IOX_OH )*dthr)
      dprec = cprec(ISOAP_XYLA) * cfrac
      dcprec(ISOAP_XYLA) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_XYLA) = cprec(ISOAP_XYLA) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_XYLA)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_XYLA)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_XYLA)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rk(iksoap(3)) * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_XYLA) * cfrac
     &             + cprec(ISOAP_XYLA) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_XYLA) = sen_prec(ifam,ISOAP_XYLA) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_XYLA)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_XYLA)*srh(ifam) - y_l(1,ISOAP_XYLA)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_XYLA)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_XYLA)*srh(ifam) - y_l(2,ISOAP_XYLA)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_XYLA)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_XYLA)*srh(ifam) - y_l(3,ISOAP_XYLA)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----NOx-dependent pathways for ISOP
c
      rk1(IOX_OH ) = rk(iksoap(4)) * avgox(IOX_OH ) ! ISP + OH rate (hr-1)
      rk1(IOX_O3 ) = rk(iksoap(5)) * avgox(IOX_O3 ) ! ISP + O3 rate (hr-1)
      rk1(IOX_NO3) = rk(iksoap(6)) * avgox(IOX_NO3) ! ISP + NO3 rate (hr-1)
      sumk = rk1(IOX_OH ) + rk1(IOX_O3 ) + rk1(IOX_NO3)

      rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! isoprene RO2 + NO rate (hr-1)
      rl = 1.93e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! isoprene RO2 + HO2 rate (hr-1)

      fn = rk1(IOX_NO3) / sumk
      fh = (1.0 - fn) * rh / (rh + rl)
      fl = 1.0 - fh - fn

      yfac(1,ISOAP_ISP) = y_h(1,ISOAP_ISP)*fh + y_l(1,ISOAP_ISP)*fl + y_n(1,ISOAP_ISP)*fn
      yfac(2,ISOAP_ISP) = y_h(2,ISOAP_ISP)*fh + y_l(2,ISOAP_ISP)*fl + y_n(2,ISOAP_ISP)*fn
      yfac(3,ISOAP_ISP) = y_h(3,ISOAP_ISP)*fh + y_l(3,ISOAP_ISP)*fl + y_n(3,ISOAP_ISP)*fn
      yfac(4,ISOAP_ISP) = fh
      yfac(5,ISOAP_ISP) = fn

      cfrac = 1. - exp(-sumk*dthr)
      dprec = cprec(ISOAP_ISP) * cfrac
      dcprec(ISOAP_ISP) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_ISP) = cprec(ISOAP_ISP) - dprec
        cCG(ICG_BCG2) = cCG(ICG_BCG2) + dprec * yfac(1,ISOAP_ISP)
        cCG(ICG_BCG1) = cCG(ICG_BCG1) + dprec * yfac(2,ISOAP_ISP)
        cNV(INV_BIO) = cNV(INV_BIO) + dprec * yfac(3,ISOAP_ISP)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
            ssumk = rk(iksoap(4)) * avgsen(ifam,IOX_OH)
     &            + rk(iksoap(5)) * avgsen(ifam,IOX_O3)
     &            + rk(iksoap(6)) * avgsen(ifam,IOX_NO3)
            sdprec = sen_prec(ifam,ISOAP_ISP) * cfrac
     &             + cprec(ISOAP_ISP) * dthr * ssumk ! because cprec has been updated
            sen_prec(ifam,ISOAP_ISP) = sen_prec(ifam,ISOAP_ISP) - sdprec

            sen_CG(ifam,3) = sen_CG(ifam,3) + sdprec * yfac(1,ISOAP_ISP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(1,ISOAP_ISP)*srh(ifam) - y_l(1,ISOAP_ISP)*srh(ifam) )
     &                                      + dprec * fn * y_n(1,ISOAP_ISP)

            sen_CG(ifam,4) = sen_CG(ifam,4) + sdprec * yfac(2,ISOAP_ISP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(2,ISOAP_ISP)*srh(ifam) - y_l(2,ISOAP_ISP)*srh(ifam) )
     &                                      + dprec * fn * y_n(2,ISOAP_ISP)

            sen_NV(ifam,2) = sen_NV(ifam,2) + sdprec * yfac(3,ISOAP_ISP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(3,ISOAP_ISP)*srh(ifam) - y_l(3,ISOAP_ISP)*srh(ifam) )
     &                                      + dprec * fn * y_n(3,ISOAP_ISP)
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----NOx-dependent pathways for TERP (lumped monoterpenes)
c
      rk1(IOX_OH ) = rk(iksoap(7)) * avgox(IOX_OH ) ! TRP + OH rate (hr-1)
      rk1(IOX_O3 ) = rk(iksoap(8)) * avgox(IOX_O3 ) ! TRP + O3 rate (hr-1)
      rk1(IOX_NO3) = rk(iksoap(9)) * avgox(IOX_NO3) ! TRP + NO3 rate (hr-1)
      sumk = rk1(IOX_OH ) + rk1(IOX_O3 ) + rk1(IOX_NO3)

      rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! terpene RO2 + NO rate (hr-1)
      rl = 2.60e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! terpene RO2 + HO2 rate (hr-1)

      fn = rk1(IOX_NO3) / sumk
      fh = (1.0 - fn) * rh / (rh + rl)
      fl = 1.0 - fh - fn

      yfac(1,ISOAP_TRP) = y_h(1,ISOAP_TRP)*fh + y_l(1,ISOAP_TRP)*fl + y_n(1,ISOAP_TRP)*fn
      yfac(2,ISOAP_TRP) = y_h(2,ISOAP_TRP)*fh + y_l(2,ISOAP_TRP)*fl + y_n(2,ISOAP_TRP)*fn
      yfac(3,ISOAP_TRP) = y_h(3,ISOAP_TRP)*fh + y_l(3,ISOAP_TRP)*fl + y_n(3,ISOAP_TRP)*fn
      yfac(4,ISOAP_TRP) = fh
      yfac(5,ISOAP_TRP) = fn

      cfrac = 1. - exp(-sumk*dthr)
      dprec = cprec(ISOAP_TRP) * cfrac
      dcprec(ISOAP_TRP) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_TRP) = cprec(ISOAP_TRP) - dprec
        cCG(ICG_BCG2) = cCG(ICG_BCG2) + dprec * yfac(1,ISOAP_TRP)
        cCG(ICG_BCG1) = cCG(ICG_BCG1) + dprec * yfac(2,ISOAP_TRP)
        cNV(INV_BIO) = cNV(INV_BIO) + dprec * yfac(3,ISOAP_TRP)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
            ssumk = rk(iksoap(7)) * avgsen(ifam,IOX_OH)
     &            + rk(iksoap(8)) * avgsen(ifam,IOX_O3)
     &            + rk(iksoap(9)) * avgsen(ifam,IOX_NO3)
            sdprec = sen_prec(ifam,ISOAP_TRP) * cfrac
     &             + cprec(ISOAP_TRP) * dthr * ssumk ! because cprec has been updated
            sen_prec(ifam,ISOAP_TRP) = sen_prec(ifam,ISOAP_TRP) - sdprec

            sen_CG(ifam,3) = sen_CG(ifam,3) + sdprec * yfac(1,ISOAP_TRP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(1,ISOAP_TRP)*srh(ifam) - y_l(1,ISOAP_TRP)*srh(ifam) )
     &                                      + dprec * fn * y_n(1,ISOAP_TRP)

            sen_CG(ifam,4) = sen_CG(ifam,4) + sdprec * yfac(2,ISOAP_TRP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(2,ISOAP_TRP)*srh(ifam) - y_l(2,ISOAP_TRP)*srh(ifam) )
     &                                      + dprec * fn * y_n(2,ISOAP_TRP)

            sen_NV(ifam,2) = sen_NV(ifam,2) + sdprec * yfac(3,ISOAP_TRP)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(3,ISOAP_TRP)*srh(ifam) - y_l(3,ISOAP_TRP)*srh(ifam) )
     &                                      + dprec * fn * y_n(3,ISOAP_TRP)
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----NOx-dependent pathways for APIN (a-pinene), if active
c
      if( luse_apin ) then

        rk1(IOX_OH ) = rk(iksoap(13)) * avgox(IOX_OH ) ! APN + OH rate (hr-1)
        rk1(IOX_O3 ) = rk(iksoap(14)) * avgox(IOX_O3 ) ! APN + O3 rate (hr-1)
        rk1(IOX_NO3) = rk(iksoap(15)) * avgox(IOX_NO3) ! APN + NO3 rate (hr-1)
        sumk = rk1(IOX_OH ) + rk1(IOX_O3 ) + rk1(IOX_NO3)

        rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! a-pinene RO2 + NO rate (hr-1)
        rl = 2.60e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! a-pinene RO2 + HO2 rate (hr-1)

        fn = rk1(IOX_NO3) / sumk
        fh = (1.0 - fn) * rh / (rh + rl)
        fl = 1.0 - fh - fn

        yfac(1,ISOAP_APN) = y_h(1,ISOAP_APN)*fh + y_l(1,ISOAP_APN)*fl + y_n(1,ISOAP_APN)*fn
        yfac(2,ISOAP_APN) = y_h(2,ISOAP_APN)*fh + y_l(2,ISOAP_APN)*fl + y_n(2,ISOAP_APN)*fn
        yfac(3,ISOAP_APN) = y_h(3,ISOAP_APN)*fh + y_l(3,ISOAP_APN)*fl + y_n(3,ISOAP_APN)*fn
        yfac(4,ISOAP_APN) = fh
        yfac(5,ISOAP_APN) = fn

        cfrac = 1. - exp(-sumk*dthr)
        dprec = cprec(ISOAP_APN) * cfrac
        dcprec(ISOAP_APN) = -dprec
        if (dprec.gt.eps) then
          cprec(ISOAP_APN) = cprec(ISOAP_APN) - dprec
          cCG(ICG_BCG2) = cCG(ICG_BCG2) + dprec * yfac(1,ISOAP_APN)
          cCG(ICG_BCG1) = cCG(ICG_BCG1) + dprec * yfac(2,ISOAP_APN)
          cNV(INV_BIO) = cNV(INV_BIO) + dprec * yfac(3,ISOAP_APN)
c
c======================== DDM Begin =======================
c
          if ( lddm ) then
            do ifam = 1, nfam
              srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
              ssumk = rk(iksoap(13)) * avgsen(ifam,IOX_OH)
     &              + rk(iksoap(14)) * avgsen(ifam,IOX_O3)
     &              + rk(iksoap(15)) * avgsen(ifam,IOX_NO3)
              sdprec = sen_prec(ifam,ISOAP_APN) * cfrac
     &               + cprec(ISOAP_APN) * dthr * ssumk ! because cprec has been updated
              sen_prec(ifam,ISOAP_APN) = sen_prec(ifam,ISOAP_APN) - sdprec

              sen_CG(ifam,3) = sen_CG(ifam,3) + sdprec * yfac(1,ISOAP_APN)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(1,ISOAP_APN)*srh(ifam) - y_l(1,ISOAP_APN)*srh(ifam) )
     &                                        + dprec * fn * y_n(1,ISOAP_APN)

              sen_CG(ifam,4) = sen_CG(ifam,4) + sdprec * yfac(2,ISOAP_APN)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(2,ISOAP_APN)*srh(ifam) - y_l(2,ISOAP_APN)*srh(ifam) )
     &                                        + dprec * fn * y_n(2,ISOAP_APN)

              sen_NV(ifam,2) = sen_NV(ifam,2) + sdprec * yfac(3,ISOAP_APN)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(3,ISOAP_APN)*srh(ifam) - y_l(3,ISOAP_APN)*srh(ifam) )
     &                                        + dprec * fn * y_n(3,ISOAP_APN)
            enddo
          endif
c
c======================== DDM End =======================
c
        endif
      endif  ! end check of luse_apin
c
c-----NOx-dependent pathways for SQT (lumped sesquiterpenes)
c
c     use local rate constants if unavailable from gas-phase mechanism
c
      if( luse_sqt ) then
        rk1(IOX_OH ) = rk(iksoap(10)) * avgox(IOX_OH ) ! SQT + OH rate (hr-1)
        rk1(IOX_O3 ) = rk(iksoap(11)) * avgox(IOX_O3 ) ! SQT + O3 rate (hr-1)
        rk1(IOX_NO3) = rk(iksoap(12)) * avgox(IOX_NO3) ! SQT + NO3 rate (hr-1)
      else
        rk1(IOX_OH ) = 1.97e-10*cfac * avgox(IOX_OH ) ! MCM v3.2 b-caryophyllene
        rk1(IOX_O3 ) = 1.20e-14*cfac * avgox(IOX_O3 ) ! MCM v3.2 b-caryophyllene
        rk1(IOX_NO3) = 1.90e-11*cfac * avgox(IOX_NO3) ! MCM v3.2 b-caryophyllene
      endif
      sumk = rk1(IOX_OH ) + rk1(IOX_O3 ) + rk1(IOX_NO3)

      rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! sesquiterpene RO2 + NO rate (hr-1)
      rl = 2.75e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! sesquiterpene RO2 + HO2 rate (hr-1)

      fn = rk1(IOX_NO3) / sumk
      fh = (1.0 - fn) * rh / (rh + rl)
      fl = 1.0 - fh - fn

      yfac(1,ISOAP_SQT) = y_h(1,ISOAP_SQT)*fh + y_l(1,ISOAP_SQT)*fl + y_n(1,ISOAP_SQT)*fn
      yfac(2,ISOAP_SQT) = y_h(2,ISOAP_SQT)*fh + y_l(2,ISOAP_SQT)*fl + y_n(2,ISOAP_SQT)*fn
      yfac(3,ISOAP_SQT) = y_h(3,ISOAP_SQT)*fh + y_l(3,ISOAP_SQT)*fl + y_n(3,ISOAP_SQT)*fn
      yfac(4,ISOAP_SQT) = fh
      yfac(5,ISOAP_SQT) = fn

      cfrac = 1. - exp(-sumk*dthr)
      dprec = cprec(ISOAP_SQT) * cfrac
      dcprec(ISOAP_SQT) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_SQT) = cprec(ISOAP_SQT) - dprec
        cCG(ICG_BCG2) = cCG(ICG_BCG2) + dprec * yfac(1,ISOAP_SQT)
        cCG(ICG_BCG1) = cCG(ICG_BCG1) + dprec * yfac(2,ISOAP_SQT)
        cNV(INV_BIO) = cNV(INV_BIO) + dprec * yfac(3,ISOAP_SQT)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
c
            ssumk = rk(iksoap(10)) * avgsen(ifam,IOX_OH)
     &            + rk(iksoap(11)) * avgsen(ifam,IOX_O3)
     &            + rk(iksoap(12)) * avgsen(ifam,IOX_NO3)
            sdprec = sen_prec(ifam,ISOAP_SQT) * cfrac
     &             + cprec(ISOAP_SQT) * dthr * ssumk ! because cprec has been updated
            sen_prec(ifam,ISOAP_SQT) = sen_prec(ifam,ISOAP_SQT) - sdprec
            sen_CG(ifam,3) = sen_CG(ifam,3) + sdprec * yfac(1,ISOAP_SQT)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(1,ISOAP_SQT)*srh(ifam) - y_l(1,ISOAP_SQT)*srh(ifam) )
     &                                      + dprec * fn * y_n(1,ISOAP_SQT)

            sen_CG(ifam,4) = sen_CG(ifam,4) + sdprec * yfac(2,ISOAP_SQT)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(2,ISOAP_SQT)*srh(ifam) - y_l(2,ISOAP_SQT)*srh(ifam) )
     &                                      + dprec * fn * y_n(2,ISOAP_SQT)

            sen_NV(ifam,2) = sen_NV(ifam,2) + sdprec * yfac(3,ISOAP_SQT)
     &                                      + dprec * (1.0 - fn) *
     &             ( y_h(3,ISOAP_SQT)*srh(ifam) - y_l(3,ISOAP_SQT)*srh(ifam) )
     &                                      + dprec * fn * y_n(3,ISOAP_SQT)
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----NOx-dependent pathways for IVOA, IVC1, IVC2 and SVOA
c
      rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! IVOA RO2 + NO rate (hr-1)
      rl = 2.75e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! IVOA RO2 + HO2 rate (hr-1)
      fh = rh / (rh + rl)
      fl = 1.0 - fh

      yfac(1,ISOAP_IVOA) = y_h(1,ISOAP_IVOA)*fh + y_l(1,ISOAP_IVOA)*fl
      yfac(2,ISOAP_IVOA) = y_h(2,ISOAP_IVOA)*fh + y_l(2,ISOAP_IVOA)*fl
      yfac(3,ISOAP_IVOA) = y_h(3,ISOAP_IVOA)*fh + y_l(3,ISOAP_IVOA)*fl
      yfac(4,ISOAP_IVOA) = fh
c
      yfac(1,ISOAP_IVC1) = y_h(1,ISOAP_IVC1)*fh + y_l(1,ISOAP_IVC1)*fl
      yfac(2,ISOAP_IVC1) = y_h(2,ISOAP_IVC1)*fh + y_l(2,ISOAP_IVC1)*fl
      yfac(3,ISOAP_IVC1) = y_h(3,ISOAP_IVC1)*fh + y_l(3,ISOAP_IVC1)*fl
      yfac(4,ISOAP_IVC1) = fh
c
      yfac(1,ISOAP_IVC2) = y_h(1,ISOAP_IVC2)*fh + y_l(1,ISOAP_IVC2)*fl
      yfac(2,ISOAP_IVC2) = y_h(2,ISOAP_IVC2)*fh + y_l(2,ISOAP_IVC2)*fl
      yfac(3,ISOAP_IVC2) = y_h(3,ISOAP_IVC2)*fh + y_l(3,ISOAP_IVC2)*fl
      yfac(4,ISOAP_IVC2) = fh
c
      yfac(1,ISOAP_SVOA) = y_h(1,ISOAP_SVOA)*fh + y_l(1,ISOAP_SVOA)*fl
      yfac(2,ISOAP_SVOA) = y_h(2,ISOAP_SVOA)*fh + y_l(2,ISOAP_SVOA)*fl
      yfac(3,ISOAP_SVOA) = y_h(3,ISOAP_SVOA)*fh + y_l(3,ISOAP_SVOA)*fl
      yfac(4,ISOAP_SVOA) = fh
c
c======================== DDM Begin =======================
c
      if ( lddm ) then
        do ifam = 1, nfam
          srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
        enddo
      endif
c
c======================== DDM End =======================
c
      rk1(IOX_OH ) = rkivoa * cfac * avgox(IOX_OH ) ! IVOA + OH rate (hr-1)
      cfrac = 1. - exp(-rk1(IOX_OH )*dthr)

      dprec = cprec(ISOAP_IVOA) * cfrac
      dcprec(ISOAP_IVOA) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_IVOA) = cprec(ISOAP_IVOA) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_IVOA)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_IVOA)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_IVOA)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rkivoa * cfac * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_IVOA) * cfrac
     &             + cprec(ISOAP_IVOA) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_IVOA) = sen_prec(ifam,ISOAP_IVOA) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_IVOA)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_IVOA)*srh(ifam) - y_l(1,ISOAP_IVOA)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_IVOA)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_IVOA)*srh(ifam) - y_l(2,ISOAP_IVOA)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_IVOA)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_IVOA)*srh(ifam) - y_l(3,ISOAP_IVOA)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif

      dprec = cprec(ISOAP_IVC1) * cfrac
      dcprec(ISOAP_IVC1) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_IVC1) = cprec(ISOAP_IVC1) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_IVC1)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_IVC1)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_IVC1)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rkivc1 * cfac * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_IVC1) * cfrac
     &             + cprec(ISOAP_IVC1) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_IVC1) = sen_prec(ifam,ISOAP_IVC1) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_IVC1)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_IVC1)*srh(ifam) - y_l(1,ISOAP_IVC1)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_IVC1)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_IVC1)*srh(ifam) - y_l(2,ISOAP_IVC1)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_IVC1)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_IVC1)*srh(ifam) - y_l(3,ISOAP_IVC1)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif

      dprec = cprec(ISOAP_IVC2) * cfrac
      dcprec(ISOAP_IVC2) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_IVC2) = cprec(ISOAP_IVC2) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_IVC2)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_IVC2)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_IVC2)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rkivc2 * cfac * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_IVC2) * cfrac
     &             + cprec(ISOAP_IVC2) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_IVC2) = sen_prec(ifam,ISOAP_IVC2) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_IVC2)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_IVC2)*srh(ifam) - y_l(1,ISOAP_IVC2)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_IVC2)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_IVC2)*srh(ifam) - y_l(2,ISOAP_IVC2)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_IVC2)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_IVC2)*srh(ifam) - y_l(3,ISOAP_IVC2)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif

      rk1(IOX_OH ) = rksvoa * cfac * avgox(IOX_OH ) ! SVOA + OH rate (hr-1)
      cfrac = 1. - exp(-rk1(IOX_OH )*dthr)

      dprec = cprec(ISOAP_SVOA) * cfrac
      dcprec(ISOAP_SVOA) = -dprec
      if (dprec.gt.eps) then
        cprec(ISOAP_SVOA) = cprec(ISOAP_SVOA) - dprec
        cCG(ICG_ACG2) = cCG(ICG_ACG2) + dprec * yfac(1,ISOAP_SVOA)
        cCG(ICG_ACG1) = cCG(ICG_ACG1) + dprec * yfac(2,ISOAP_SVOA)
        cNV(INV_ANTH) = cNV(INV_ANTH) + dprec * yfac(3,ISOAP_SVOA)
c
c======================== DDM Begin =======================
c
        if ( lddm ) then
          do ifam = 1, nfam
            srk1(IOX_OH) = rksvoa * cfac * avgsen(ifam,IOX_OH)
            sdprec = sen_prec(ifam,ISOAP_SVOA) * cfrac
     &             + cprec(ISOAP_SVOA) * dthr * srk1(IOX_OH) ! because cprec has been updated
            sen_prec(ifam,ISOAP_SVOA) = sen_prec(ifam,ISOAP_SVOA) - sdprec
            sen_CG(ifam,1) = sen_CG(ifam,1) + sdprec * yfac(1,ISOAP_SVOA)
     &                                      + dprec *
     &            ( y_h(1,ISOAP_SVOA)*srh(ifam) - y_l(1,ISOAP_SVOA)*srh(ifam) )
            sen_CG(ifam,2) = sen_CG(ifam,2) + sdprec * yfac(2,ISOAP_SVOA)
     &                                      + dprec *
     &            ( y_h(2,ISOAP_SVOA)*srh(ifam) - y_l(2,ISOAP_SVOA)*srh(ifam) )
            sen_NV(ifam,1) = sen_NV(ifam,1) + sdprec * yfac(3,ISOAP_SVOA)
     &                                      + dprec *
     &            ( y_h(3,ISOAP_SVOA)*srh(ifam) - y_l(3,ISOAP_SVOA)*srh(ifam) )
          enddo
        endif
c
c======================== DDM End =======================
c
      endif
c
c-----NOx-dependent pathways for FVC1 (wildfire VOC) if active
c
      if( luse_fvc1 ) then

        rk1(IOX_OH ) = rk(iksoap(17)) * avgox(IOX_OH ) ! FVC1 + OH rate (hr-1)
        rk1(IOX_O3 ) = rk(iksoap(18)) * avgox(IOX_O3 ) ! FVC1 + O3 rate (hr-1)
        rk1(IOX_NO3) = rk(iksoap(19)) * avgox(IOX_NO3) ! FVC1 + NO3 rate (hr-1)
        sumk = rk1(IOX_OH ) + rk1(IOX_O3 ) + rk1(IOX_NO3)

        rh = 2.70e-12*exp(360.0/tempk)*cfac * avgox(IOX_NO )  ! FVC1 RO2 + NO rate (hr-1)
        rl = 2.47e-12*exp(1300.0/tempk)*cfac * avgox(IOX_HO2) ! FVC1 RO2 + HO2 rate (hr-1) (guaiacol)

        fn = rk1(IOX_NO3) / sumk
        fh = (1.0 - fn) * rh / (rh + rl)
        fl = 1.0 - fh - fn

        yfac(1,ISOAP_FVC1) = y_h(1,ISOAP_FVC1)*fh + y_l(1,ISOAP_FVC1)*fl + y_n(1,ISOAP_FVC1)*fn
        yfac(2,ISOAP_FVC1) = y_h(2,ISOAP_FVC1)*fh + y_l(2,ISOAP_FVC1)*fl + y_n(2,ISOAP_FVC1)*fn
        yfac(3,ISOAP_FVC1) = y_h(3,ISOAP_FVC1)*fh + y_l(3,ISOAP_FVC1)*fl + y_n(3,ISOAP_FVC1)*fn
        yfac(4,ISOAP_FVC1) = fh
        yfac(5,ISOAP_FVC1) = fn

        cfrac = 1. - exp(-sumk*dthr)
        dprec = cprec(ISOAP_FVC1) * cfrac
        dcprec(ISOAP_FVC1) = -dprec
        if (dprec.gt.eps) then
          cprec(ISOAP_FVC1) = cprec(ISOAP_FVC1) - dprec
          cCG(ICG_BCG2) = cCG(ICG_BCG2) + dprec * yfac(1,ISOAP_FVC1)
          cCG(ICG_BCG1) = cCG(ICG_BCG1) + dprec * yfac(2,ISOAP_FVC1)
          cNV(INV_BIO) = cNV(INV_BIO) + dprec * yfac(3,ISOAP_FVC1)
c
c======================== DDM Begin =======================
c
          if ( lddm ) then
            do ifam = 1, nfam
              srh(ifam) = (fl*rh - fh*rl) / (rh + rl)
              ssumk = rk(iksoap(17)) * avgsen(ifam,IOX_OH)
     &              + rk(iksoap(18)) * avgsen(ifam,IOX_O3)
     &              + rk(iksoap(19)) * avgsen(ifam,IOX_NO3)
              sdprec = sen_prec(ifam,ISOAP_FVC1) * cfrac
     &               + cprec(ISOAP_FVC1) * dthr * ssumk ! because cprec has been updated
              sen_prec(ifam,ISOAP_FVC1) = sen_prec(ifam,ISOAP_FVC1) - sdprec

              sen_CG(ifam,3) = sen_CG(ifam,3) + sdprec * yfac(1,ISOAP_FVC1)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(1,ISOAP_FVC1)*srh(ifam) - y_l(1,ISOAP_FVC1)*srh(ifam) )
     &                                        + dprec * fn * y_n(1,ISOAP_FVC1)

              sen_CG(ifam,4) = sen_CG(ifam,4) + sdprec * yfac(2,ISOAP_FVC1)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(2,ISOAP_FVC1)*srh(ifam) - y_l(2,ISOAP_FVC1)*srh(ifam) )
     &                                        + dprec * fn * y_n(2,ISOAP_FVC1)

              sen_NV(ifam,2) = sen_NV(ifam,2) + sdprec * yfac(3,ISOAP_FVC1)
     &                                        + dprec * (1.0 - fn) *
     &               ( y_h(3,ISOAP_FVC1)*srh(ifam) - y_l(3,ISOAP_FVC1)*srh(ifam) )
     &                                        + dprec * fn * y_n(3,ISOAP_FVC1)
            enddo
          endif
c
c======================== DDM End =======================
c
        endif
      endif  ! end check of luse_fvc1
c












c
      return
      end

      subroutine topprep(begtim,begdate,endtim,enddate)
      use filunit
      use grid
      use chmstry
      use bndary
c 
c----CAMx v7.40 260801
c 
c     TOPPREP reads the top concentrations file header and sets
c     variables that map the TC species list to the internal CAMx
c     species list
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        None
c 
c     Input arguments: 
c        begtim              model start time (HHMM)
c        begdate             model start date (YYJJJ)
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        STARTUP 
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      integer begdate
      integer enddate
c
      character*10 tcfil, infil, tcspc
      character*4  ifile(10), note(60)
c
      character*4 tcspec(10,MXSPEC)
      integer     indx(MXCELLS,MXCELLS), isoa
c
      data tcfil /'AIRQUALITY'/
c
c-----Entry point
c
c-----Read 1st TC header record and check inputs
c
      rewind(itc)
      read(itc) ifile,note,nseg,ntcspc,idat1,tim1,idat2,tim2
c
c----check for array overflow ---
c
      if( ntcspc .GT. MXSPEC ) then
         write(iout,'(//,A)') 'ERROR in TOPPREP:'
         write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter: MXSPEC'
         write(iout,*) 'It should be set to a value of at least: ',ntcspc
         call flush(iout)
         call camxerr()
      endif
c
      if(INT(tim2) .EQ. 24) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      write(infil,'(10a1)') (ifile(n),n=1,10)
      if (infil.ne.tcfil) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 1:'
        write(iout,*)'TC input file is not labelled AIRQUALITY'
        call camxerr()
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if (idat1.gt.begdate) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 2:'
        write(iout,*)'TC start date > simulation start date'
        write(iout,*)'  TC file: ',idat1
        write(iout,*)'Sim start: ',begdate
        call camxerr()
      elseif (idat1.eq.begdate .and. tim1.gt.begtim) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 3:'
        write(iout,*)'TC start time > simulation start time'
        write(iout,*)'  TC file: ',tim1
        write(iout,*)'Sim start: ',begtim
        call camxerr()
      elseif (idat2.lt.enddate) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 4:'
        write(iout,*)'TC end date < simulation end date'
        write(iout,*)'TC file: ',idat2
        write(iout,*)'Sim end: ',enddate
        call camxerr()
      elseif (idat2.eq.enddate .and. tim2.lt.endtim) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 5:'
        write(iout,*)'TC end time < simulation end time'
        write(iout,*)'TC file: ',tim2
        write(iout,*)'Sim end: ',endtim
        call camxerr()
      endif
c
c-----Read 2nd TC header record and check inputs
c
      read(itc) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if (.NOT.llatlon) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if (abs(dx-delx).gt.0.001 .or. abs(dy-dely).gt.0.001) then
        write(iout,'(//,a)') 'WARNING in TOPPREP:'
        write(iout,*)'TC cell size not equal to model cell size'
        write(iout,'(a,2f10.4)')'  TC file: ',dx,dy
        write(iout,'(a,2f10.4)')'    model: ',delx,dely
        write(iout,*)
      elseif (nx.ne.ncol(1) .or. ny.ne.nrow(1)) then
        write(iout,'(//,a)') 'ERROR in TOPPREP 6:'
        write(iout,*)'TC grid size not equal to model grid size'
        write(iout,*)'TC file: ',nx,ny
        write(iout,*)'  model: ',ncol(1),nrow(1)
        write(iout,*)
        call camxerr()
      endif 
c
c-----Read 3rd & 4th TC header 
c
      read(itc) 
      read(itc) ((tcspec(n,l),n=1,10),l=1,ntcspc)
c
c-----Map TC species to model species
c
      do 20 l = 1,nspec
        ltcmap(l) = 0
        do 15 ltc = 1,ntcspc
          write(tcspc,'(10a1)') (tcspec(n,ltc),n=1,10)
          if (tcspc.eq.'HNO2      ') tcspc = 'HONO      '
          if (tcspc.eq.'HCHO      ' .and. kHCHO.eq.nspec+1)
     &                                        tcspc = 'FORM      '
          do isoa=1,NUM_SOAP_SPECIES
             if( tcspc .EQ. soap2_spec_names(isoa) ) 
     &                           tcspc = soap3_spec_names(isoa)
          enddo
          if (tcspc.eq.spname(l)) then
            ltcmap(l) = ltc
            write(idiag,'(2(a,i5,2x,a))')'Topcon species   ',ltc,tcspc,
     &                   ' mapped to model species ',l,spname(l)
            goto 20
          endif
 15     continue
        write(idiag,*)'Did not find species: ',spname(l),' on TC file'
 20   continue
c
      return
      end

      subroutine sim_init(version,inptim,inpdate,emstim,emsdate,
     &                    ozntim,ozndate,bndtim,bnddate,toptim,topdate,
     &                    wrttim,wrtdate,endtim,enddate,numprocs,
     &                    iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use filunit
      use grid
      use chmstry
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use ptemiss
      use pigsty
      use procan
      use rtracchm
      use rtcmcchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine calls all of the routines needed to initialize the
c    model at the begining of the simulation. The startup routine is
c    called as well as number of routines to allocate and pass data
c    for MPI.
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       STARTUP
c       NODES_ALLOC
c       ZEROES
c       NODES_PASS
c       MPI_BARRIER
c       NODES_INIT
c       MASTER_SEND_GRIDDED_DATA
c       NODE_RECV_GRIDDED_DATA
c       CAMXERR
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c       02/11/11     Removed snow date/time and optional roughness from AHO
c       04/02/12     AHO file is now just ozone column; replaced haze
c                    dimension with terrain height in photo file
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'section.inc'
      include 'camx_aero_cmu.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*20  :: version
c
      real    :: inptim
      real    :: emstim
      real    :: ozntim
      real    :: bndtim
      real    :: toptim
      real    :: wrttim
      real    :: endtim
c
      integer :: inpdate
      integer :: emsdate
      integer :: ozndate
      integer :: bnddate
      integer :: topdate
      integer :: wrtdate
      integer :: enddate
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ilast
      integer :: istrt
      integer :: ism
      integer :: igrd
      integer :: nodes
      integer :: ierr
      integer :: nlayav
      integer :: istrln
c
      character*200 :: filtmp
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (iproc_id .EQ. 0) then
         call startup(version,inptim,inpdate,emstim,emsdate,
     &                ozntim,ozndate,bndtim,bnddate,toptim,topdate,
     &                wrttim,wrtdate,endtim,enddate,numprocs               )
c
c  --- Set some MPI variables ---
c
         do igrd=1,ngrid
            mmxp(igrd) = ncol(igrd)
            mmyp(igrd) = nrow(igrd)
            mmzp(igrd) = nlay(igrd)
         enddo
      endif
c
c  --- allocate the date for the nodes ---
c
      if (lmpi) then
         itag = 1
         numprocs = numprocs - 1
         call nodes_alloc(numprocs,iproc_id)
      endif
c  --- Set average concentrations to zero ---
c
      if (iproc_id .EQ. 0) then
         do igrd = 1,ngrid
            nlayav = nlay(igrd)
            if( .NOT. l3davg(igrd) ) nlayav = 1
            nodes=ncol(igrd)*nrow(igrd)*nlayav*navspc
            call zeros(avcnc(iptrav(igrd)),nodes)
            nodes = ncol(igrd)*nrow(igrd)*(3*ndepspc + 2)
            call zeros(depfld(iptrdp(igrd)),nodes)
            if( lptdepout ) then
               nodes = ncol(igrd)*nrow(igrd)*notimespc
               call zeros(ptdryfld(ipsadep(igrd)),nodes)
               call zeros(ptwetfld(ipsadep(igrd)),nodes)
            endif
         enddo
         if (lsample) then
            do ism = 1,nsample
               nodes = ncolsmp(ism)*nrowsmp(ism)*navspc
               call zeros(smpcnc(ipsmp(ism)),nodes)
            enddo
         endif
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to initialize the running averages ---
c
         if (ltrace .OR. lddm .OR. lhddm ) then
            do igrd=1,ngrid
               nlayav = nlay(igrd)
               if( .NOT. lsa_3davrg ) nlayav = 1
               nodes=ncol(igrd)*nrow(igrd)*nlayav*ntotsp
               call zeros(ptavrg(ipsa2d_avrg(igrd)),nodes)
            enddo
c
            if (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
               nodes = MXRTCEL * nspec
               call zeros(rcpdcy,nodes)
            endif
c
            if ((tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND.
     &                                       lsample .AND. lsmptrc) then
               do igrd = 1,nsample
                  nodes = ncolsmp(igrd)*nrowsmp(igrd)*nrtrac
                  call zeros(rtsmpcnc(iprtsmp(igrd)),nodes)
               enddo
            endif
         endif
c
c======================== Source Apportion End =========================
c
      endif
c
      if (lmpi) then
c
c  --- open a diag file and an out file for  
c
         call nodes_pass(iout,     1,  MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(idiag,    1,  MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(filroot,200,MPI_CHARACTER,itag,numprocs,iproc_id)
         if (iproc_id .GT. 0) then
            ilast = istrln(filroot)
            istrt = ilast
c
  111       continue
            if (istrt .EQ. 1 .OR. filroot(istrt:istrt) .EQ. '/') then
               if (istrt .EQ. 1) istrt = 0
               write(filtmp,'(2A,I3.3,A)') 
     &                           filroot(istrt+1:ilast),'.node',iproc_id,'.out'
               open(unit=iout,file=filtmp,status='UNKNOWN',ERR=7000)
               write(filtmp,'(2A,I3.3,A)') 
     &                          filroot(istrt+1:ilast),'.node',iproc_id,'.diag'
               open(unit=idiag,file=filtmp,status='UNKNOWN',ERR=7001)
            else
               istrt = istrt - 1
               if (istrt .GT. 0) goto 111
            endif
         endif
c
c  --- call routine to allocate all of the
c      data structures for the nodes ---
c
         call MPI_Barrier(MPI_COMM_WORLD, ierr)
         call nodes_init(numprocs,iproc_id)
c
         call nodes_pass(icur_unit,    1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(inptim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(inpdate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(emstim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(emsdate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ozntim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(ozndate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(bndtim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(bnddate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(toptim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(topdate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(wrttim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(wrtdate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(endtim,       1,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(enddate,      1,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(time_aero,ngrid,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(aero_dt,  ngrid,   MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(date_aero,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(dt_aero,      1,MPI_INTEGER,itag,numprocs,iproc_id)
c
         do igrd=1,ngrid
            if (iproc_id .eq. 0) then  
               call master_send_gridded_data(icdocn(iptr2d(igrd)),igrd,1,1,itag)
            else
               call node_recv_gridded_data(icdocn(iptr2d(igrd)),igrd,1,1,itag)
            endif
            itag = itag+1
         enddo
c
c  --- not doing MPI, set some variables ---
c
      endif
      return
c
c  --- Error messages ---
c
 7000 continue
      write(*,'(//,A)') 'ERROR in SIM_INIT:'
      write(*,'(A)') 'Compute node cannot open its .out file.'
      write(*,'(A)') 'Compute node: ',iproc_id
      write(*,'(2A,//)') ' Could not open file: ', filtmp(:istrln(filtmp))
      call camxerr()
c
 7001 continue
      write(*,'(//,A)') 'ERROR in SIM_INIT:'
      write(*,'(A)') 'Compute node cannot open its .diag file.'
      write(*,'(A)') 'Compute node: ',iproc_id
      write(*,'(2A,//)') ' Could not open file: ', filtmp(:istrln(filtmp))
      call camxerr()
c
      end

      subroutine irondry(nskip,nspec,nreactr,dx,dy,dz,mapscl,dt,
     &                   puffmass,axisz,vdep,depfld,flxdry)
c
c----CAMx v7.40 260801
c
c     IRONDRY calculates dry deposition for a given IRON PiG puff.
c     Material is depleted (+ puff increment) or added (- puff increment)
c     for the fraction of the puff that resides in the surface layer.
c
c      Copyright Ramboll
c
c     Modifications:
c        8/31/06         Added map scale factor
c        7/11/07         Added RTRAC/RTCMC
c
c     Input arguments:
c        nskip               number of species to skip
c        nspec               number of species
c        nreactr             number of puff reactor cells
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        dz                  thickness of deposition layer (m)
c        mapscl              map scale factor
c        dt                  time step (s)
c        puffmass            puff mass
c        axisz               puff size in z-direction (m)
c        vdep                dry deposition velocity (m/s)
c        depfld              dry deposited mass (mol/ha, g/ha)
c        flxdry              dry deposition flux (umol)
c  
c     Output arguments:
c        depfld              dry deposited mass (mol/ha, g/ha)
c        flxdry              dry deposition flux (umol)
c
c     Routines Called:
c        none
c
c     Called by:
c        PIGDRIVE
c
      implicit none
c
      integer nskip,nspec,nreactr
      real dz,dt,dx,dy,mapscl,axisz
      real puffmass(nspec,nreactr)
      real vdep(*)
      real depfld(*)
      real*8 flxdry(*)
c
      integer nr,is
      real pmass,fdep,dmass,flxbot
c
c-----Entry point
c
      do is = 1,nspec
        depfld(is) = 0.
        flxdry(is) = 0.
      enddo
c
c-----Loop over puff reactors and species
c
      do nr = 1,nreactr
        do is = nskip+1,nspec
c
c-----Get fraction of puff mass that deposits
c
          pmass = puffmass(is,nr)*amin1(1.,dz/axisz)
          fdep = 1. - exp(-vdep(is)*dt/dz)
c
c-----Calculate deposited mass and increment tracking arrays
c
          dmass = fdep*pmass
          puffmass(is,nr) = puffmass(is,nr) - dmass
          flxdry(is) = flxdry(is) - DBLE(dmass)
          flxbot = dmass/(dx*dy/mapscl**2)
          depfld(is) = depfld(is) + 1.e-2*flxbot
        enddo
      enddo
c
      return
      end

      subroutine node_get_nbc(ifm,icm)                                             
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid_dims
      use grid
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       MYOFFSET
c       PAR_BINTP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer, dimension(maxmach) :: i1f
      integer, dimension(maxmach) :: i2f
      integer, dimension(maxmach) :: j1f
      integer, dimension(maxmach) :: j2f
      integer, dimension(maxmach) :: k1f
      integer, dimension(maxmach) :: k2f
      integer, dimension(maxmach) :: iptv
      integer, dimension(maxmach) :: iptc
      integer, dimension(maxmach) :: i1c
      integer, dimension(maxmach) :: i2c
      integer, dimension(maxmach) :: j1c
      integer, dimension(maxmach) :: j2c
      integer, dimension(maxmach) :: ibeg
      integer, dimension(maxmach) :: iend
      integer, dimension(maxmach) :: jbeg
      integer, dimension(maxmach) :: jend
c
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: morder(nmachs)
      integer :: nnm
      integer :: nm
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: iptr
      integer :: machf
      integer :: nvar
      integer :: nwords
      integer :: nv
      integer :: nxc
      integer :: nyc
      integer :: nzc
      integer :: mtp
      integer :: ispbeg
c
      real, allocatable, save :: buffnest(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- make sure sends are all finished and de-allocated ---
c
      do nm=1,nmachs
         if (iget_paths(6,ifm,nm) .ne. 0) then
            call par_wait(isend_req(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            call par_wait(irecv_req(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(buffnest)) deallocate (buffnest)
         allocate( buffnest( 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*nspec ) )
         nbuff_save = 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*nspec
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(buffnest)) deallocate (buffnest)
         allocate (buffnest(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      iptr=0
      nnm = 0
      do nm=1,nmachs
         if (nm .ne. mynum) then
            nnm = nnm + 1
            morder(nnm) = nm
         endif
      enddo
c
      morder(nmachs) = mynum
      do nnm=1,nmachs
         nm = morder(nnm)
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            call par_assoc_buff(node_buffs(nm)%lbc_recv_buff(1),
     &                           node_buffs(nm)%nrecv           )
            call par_get_int(i1f(nm),1)
            call par_get_int(i2f(nm),1)
            call par_get_int(j1f(nm),1)
            call par_get_int(j2f(nm),1)
            call par_get_int(k1f(nm),1)
            call par_get_int(k2f(nm),1)
            call par_get_int(i1c(nm),1)
            call par_get_int(i2c(nm),1)
            call par_get_int(j1c(nm),1)
            call par_get_int(j2c(nm),1)
            call par_get_int(ibeg(nm),1)
            call par_get_int(iend(nm),1)
            call par_get_int(jbeg(nm),1)
            call par_get_int(jend(nm),1)
            call par_get_int(machf,  1)
            call par_get_int(nvar,   1)
            call par_get_int(nwords, 1)
            call par_get_float(buffnest(1+iptr),nwords)
            iptc(nm)=1+iptr
            iptv(nm)=0
            iptr=iptr+nwords
         endif
      enddo
c
      do nnm=1,nmachs
         nm = morder(nnm)
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            nxc=i2f(nm)-i1f(nm)+1
            nyc=j2f(nm)-j1f(nm)+1
            nzc=k2f(nm)-k1f(nm)+1
            mtp=(nxc + nyc)*2*nzc
            call myoffset(0,i1f(nm),nmesh(ifm),offxb)
            call myoffset(1,i2f(nm),nmesh(ifm),offxe)
            call myoffset(0,j1f(nm),nmesh(ifm),offyb)
            call myoffset(1,j2f(nm),nmesh(ifm),offye)
            do nv=1,nspec
               ispbeg=iptr4d(ifm)+(nv-1)*mmzp(ifm)*mmxp(ifm)*mmyp(ifm)
               call par_bintp(conc(ispbeg),buffnest(iptc(nm)+iptv(nm)),mtp,
     &                        mmxp(ifm),mmyp(ifm),mmzp(ifm), 
     &                        i1f(nm),i2f(nm),j1f(nm),j2f(nm),
     &                        k1f(nm),k2f(nm), mi0(ifm),mj0(ifm), 
     &                        i1c(nm),i2c(nm),j1c(nm),j2c(nm),
     &                        ibeg(nm),iend(nm),jbeg(nm),jend(nm),
     &                        offxb,offxe,offyb,offye,
     &                        icm,ifm,nm,nv )
               iptv(nm)=iptv(nm)+mtp
            enddo
         endif
      enddo
c
      deallocate( buffnest )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_nbc:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine par_bintp:
c-----------------------------------------------------------------------
c
      subroutine par_bintp(des,src,mtp,
     &                     m1,m2,m3,
     &                     i1f,i2f,j1f,j2f,
     &                     k1f,k2f,i0f,j0f,
     &                     i1c,i2c,j1c,j2c,
     &                     ibg,ind,jbg,jnd,
     &                     offxb,offxe,offyb,offye,
     &                     icm,ifm,nm,nv )
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod 
      use grid
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_GET_NBC
c       NODE_GET_NBC_PT
c    Subroutines called:
c       FI2CI
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: des(m1,m2,m3)
      real    :: src(mtp)
c
      integer :: mtp
      integer :: m1
      integer :: m2
      integer :: m3
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: k1f
      integer :: k2f
      integer :: i0f
      integer :: j0f
      integer :: i1c
      integer :: i2c
      integer :: j1c
      integer :: j2c
      integer :: ibg
      integer :: ind
      integer :: jbg
      integer :: jnd
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: icm
      integer :: ifm
      integer :: nm
      integer :: nv
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: k
      integer :: n
      integer :: counter
      integer :: curr
      integer :: currx
      integer :: curry
c
c  --- boundary thickness ---
c
      integer :: bthk
c
      logical :: mi0_flag
      logical :: mj0_flag
c
      integer :: ofxa
      integer :: ofxz
      integer :: ofya
      integer :: ofyz
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      parameter (bthk = 3)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ofxa = NOVERLP
      ofxz = NOVERLP
      ofya = NOVERLP
      ofyz = NOVERLP
      if (nodei0(nm,icm) .eq. 0) ofxa = 1
      if ((nodemxp(nm,icm) + nodei0(nm,icm)) .eq. ncol(icm)) ofxz = 1
      if (nodej0(nm,icm) .eq. 0) ofya = 1
      if ((nodemyp(nm,icm) + nodej0(nm,icm)) .eq. nrow(icm)) ofyz = 1
      mi0_flag = .false.
      mj0_flag = .false.
      do n=1, nmachs
         if (nodei0(n, 1) .gt. 0) mi0_flag = .true.
         if (nodej0(n, 1) .gt. 0) mj0_flag = .true.
      enddo
      counter = 1
c
      do k=k1f,k2f
c
c --- south ---
c
         call fi2ci(1+j0f,nmesh(ifm),j1(ifm),curry)
         if (abs(j1f-j0f) .le. 2*nmesh(ifm)) then
            do i=i1f, i2f
               call fi2ci(i,nmesh(ifm),i1(ifm),curr)
               if (curr .gt. nodei0(nm,icm)+nodemxp(nm,icm)-ofxz .or.
     &                                      curr .le. nodei0(nm,icm)+ofxa) then
c
c  --- do nothing ---
c
               else
                 if( curry .GE. jbg .AND. curry .LE. jnd ) 
     &                                     des(i-i0f,1,k) = src(counter)
                endif
               counter = counter + 1
            enddo
         else
            counter = counter + (i2f-i1f+1)
         endif
c
c  --- north ---
c
         call fi2ci(m2+j0f,nmesh(ifm),j1(ifm),curry)
         if (abs( (j2f-j0f)-mmyp(ifm) ) .le. 2*nmesh(ifm)) then
            do i=i1f, i2f
               call fi2ci(i,nmesh(ifm),i1(ifm),curr)
               if (curr .gt. nodei0(nm,icm)+nodemxp(nm,icm)-ofxz .or.
     &                                      curr .le. nodei0(nm,icm)+ofxa) then
c
c  --- do nothing ---
c
               else
                 if( curry .GE. jbg .AND. curry .LE. jnd ) 
     &                                    des(i-i0f,m2,k) = src(counter)
               endif
               counter = counter + 1
            enddo
         else
            counter = counter + (i2f-i1f+1)
         endif
c
c  --- west ---
c
         call fi2ci(1+i0f,nmesh(ifm),i1(ifm),currx)
         if (abs(i1f-i0f) .le. 2*nmesh(ifm)) then
            do j=j1f, j2f
               call fi2ci(j,nmesh(ifm),j1(ifm),curr)
               if (curr .gt. nodej0(nm,icm)+nodemyp(nm,icm)-ofyz .or.
     &                                      curr .le. nodej0(nm,icm)+ofya) then
c
c  --- do nothing ---
c
               else
                 if( currx .GE. ibg .AND. currx .LE. ind ) 
     &                               des(1, j-j0f,k) = src(counter)
               endif
               counter = counter + 1
            enddo
         else
            counter = counter + (j2f-j1f+1)
         endif
c
c  --- east ---
c
         call fi2ci(m1+i0f,nmesh(ifm),i1(ifm),currx)
         if (abs( (i2f-i0f)-mmxp(ifm) ) .le. 2*nmesh(ifm)) then
            do j=j1f, j2f
               call fi2ci(j,nmesh(ifm),j1(ifm),curr)
               if (curr .gt. nodej0(nm,icm)+nodemyp(nm,icm)-ofyz .or.
     &                                      curr .le. nodej0(nm,icm)+ofya) then
c
c  --- do nothing ---
c
               else
                 if( currx .GE. ibg .AND. currx .LE. ind ) 
     &                              des(m1,j-j0f,k) = src(counter)
               endif
               counter = counter + 1
            enddo
         else
            counter = counter + (j2f-j1f+1)
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine par_bintp:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine fi2ci:
c-----------------------------------------------------------------------
c
c    Called by:
c       PAR_BINTP
c
      subroutine fi2ci(fi,nmesh,i0,ci)
c
      implicit none
c
c-----------------------------------------------------------------------
c    Description:
c        fine index to coarse index
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: fi
      integer :: nmesh
      integer :: i0
      integer :: ci
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: temp
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      temp = (fi-2)/nmesh
      ci = temp + i0
c
      if( fi .eq. 1 ) ci = i0 - 1
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine fi2ci:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_nbc_pt:
c-----------------------------------------------------------------------
c
      subroutine node_get_nbc_pt(ifm,icm)                                             
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid_dims
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        probing tool
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       MYOFFSET
c       PAR_BINTP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer, dimension(maxmach) :: i1f
      integer, dimension(maxmach) :: i2f
      integer, dimension(maxmach) :: j1f
      integer, dimension(maxmach) :: j2f
      integer, dimension(maxmach) :: k1f
      integer, dimension(maxmach) :: k2f
      integer, dimension(maxmach) :: iptv
      integer, dimension(maxmach) :: iptc
      integer, dimension(maxmach) :: i1c
      integer, dimension(maxmach) :: i2c
      integer, dimension(maxmach) :: j1c
      integer, dimension(maxmach) :: j2c
      integer, dimension(maxmach) :: ibeg
      integer, dimension(maxmach) :: iend
      integer, dimension(maxmach) :: jbeg
      integer, dimension(maxmach) :: jend
c
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: morder(nmachs)
      integer :: nnm
      integer :: nm
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: iptr
      integer :: machf
      integer :: nvar
      integer :: nwords
      integer :: nv
      integer :: nxc
      integer :: nyc
      integer :: nzc
      integer :: mtp
      integer (kind=8) :: ispbeg
c
      real, allocatable, save :: buffnest_pt(:)
      integer, save           :: nbuff_save_pt=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- make sure sends are all finished and de-allocated ---
c
      do nm=1,nmachs
         if (iget_paths(6,ifm,nm) .ne. 0) then
            call par_wait(isend_req_pt(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_pt(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save_pt .eq. 0) then
         if (allocated(buffnest_pt)) deallocate (buffnest_pt)
         allocate( buffnest_pt( 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*ntotsp ) )
         nbuff_save_pt = 10*(mmxp(ifm)+mmyp(ifm))*mmzp(ifm)*ntotsp
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save_pt) then
         if (allocated(buffnest_pt)) deallocate (buffnest_pt)
         allocate (buffnest_pt(node_buffs(mynum)%nrecv))
         nbuff_save_pt=node_buffs(mynum)%nrecv
      endif
c
      iptr=0
      nnm = 0
      do nm=1,nmachs
         if (nm .ne. mynum) then
            nnm = nnm + 1
            morder(nnm) = nm
         endif
      enddo
c
      morder(nmachs) = mynum
      do nnm=1,nmachs
         nm = morder(nnm)
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            call par_assoc_buff(node_buffs(nm)%lbc_pt_recv_buff(1),  !cbwpt
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1f(nm),1)
            call par_get_int(i2f(nm),1)
            call par_get_int(j1f(nm),1)
            call par_get_int(j2f(nm),1)
            call par_get_int(k1f(nm),1)
            call par_get_int(k2f(nm),1)
            call par_get_int(i1c(nm),1)
            call par_get_int(i2c(nm),1)
            call par_get_int(j1c(nm),1)
            call par_get_int(j2c(nm),1)
            call par_get_int(ibeg(nm),1)
            call par_get_int(iend(nm),1)
            call par_get_int(jbeg(nm),1)
            call par_get_int(jend(nm),1)
            call par_get_int(machf,  1)
            call par_get_int(nvar,   1)
            call par_get_int(nwords, 1)
            call par_get_float(buffnest_pt(1+iptr),nwords)
            iptc(nm)=1+iptr
            iptv(nm)=0
            iptr=iptr+nwords
         endif
      enddo
c
      do nnm=1,nmachs
         nm = morder(nnm)
         if (ipaths(5,6,ifm,nm) .ne. 0) then
            nxc=i2f(nm)-i1f(nm)+1
            nyc=j2f(nm)-j1f(nm)+1
            nzc=k2f(nm)-k1f(nm)+1
            mtp=(nxc + nyc)*2*nzc
            call myoffset(0,i1f(nm),nmesh(ifm),offxb)
            call myoffset(1,i2f(nm),nmesh(ifm),offxe)
            call myoffset(0,j1f(nm),nmesh(ifm),offyb)
            call myoffset(1,j2f(nm),nmesh(ifm),offye)
            do nv=1,ntotsp
               ispbeg=ipsa3d(ifm)+DBLE(nv-1)*DBLE(mmzp(ifm))*DBLE(mmxp(ifm))*DBLE(mmyp(ifm))
               call par_bintp(ptconc(ispbeg),buffnest_pt(iptc(nm)+iptv(nm)),mtp,
     &                        mmxp(ifm),mmyp(ifm),mmzp(ifm), 
     &                        i1f(nm),i2f(nm),j1f(nm),j2f(nm),
     &                        k1f(nm),k2f(nm), mi0(ifm),mj0(ifm), 
     &                        i1c(nm),i2c(nm),j1c(nm),j2c(nm),
     &                        ibeg(nm),iend(nm),jbeg(nm),jend(nm),
     &                        offxb,offxe,offyb,offye,
     &                        icm, ifm, nm,nv )
               iptv(nm)=iptv(nm)+mtp
            enddo
         endif
      enddo
c
      deallocate( buffnest_pt )
      nbuff_save_pt = 0
c
      return
      end

C**** NCF_READINP_2D
c
      subroutine ncf_readinp_2d(igrd,ncol,nrow,tsurf,ptptim,
     &                                tnext,snow,snowage,snowrat)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines reads the next hour of data in the 2D met file and
c   calculates the time/rate change based on the data for the current 
c   hour.
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        tsurf               current surface temperature field (K)
c        snow                snow cover water equivalent (m)
c        snowage             snow cover age (hr)
c        snowrat             snow water accumulation rate (m/hr)
c
c     Output arguments:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      real    tsurf(ncol,nrow)
      real    ptptim(ncol,nrow)
      real    tnext(ncol,nrow)
      real    snow(ncol,nrow)
      real    snowage(ncol,nrow)
      real    snowrat(ncol,nrow)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       hdate, this_tstep, i, j, k
      integer       this_time_tflag, this_time_etflag
      real          snowold, whr, wmn, atim, htim
c
      real, allocatable, dimension(:,:) :: arr2d
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- allocate temperary array ---
c
      allocate( arr2d(ncol,nrow) )

      if( .NOT. is_netcdf_i2dmet(igrd) ) goto 9999
c
      write(action,'(A,I3)') 'Reading 2D met file for grid ',igrd
c
c --- Find the date/time at the next update interval ---
c
      whr = aint(time/100.)
      wmn = anint(amod(time,100.))
      atim = 100.*whr + wmn
      htim = 100.*(whr + aint((wmn + dtinp)/60.)) +
     &             amod((wmn + dtinp),60.)
      hdate = date
      if (htim.ge.2400.) then
        htim = anint(htim - 2400.)
        hdate = hdate + 1
        if( MOD(hdate,1000) .GT. 365 ) then
           if( MOD(INT(hdate/1000),4) .EQ. 0 ) then
              if( MOD(hdate,1000) .EQ. 367 )
     &           hdate = (INT(hdate/1000)+1)*1000 + 1
           else
              hdate = (INT(hdate/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(i2dmet(igrd),action,hdate,htim,
     &                 this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = 1
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- surface temperature ---
c
      this_var = "sfctemperature"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                          data_count,tnext)
      if( ierr .NE. NF_NOERR) goto 7001
c
c-----Calculate time rates of change for 2D met fields
c
      call timrates(ncol,nrow,1,tsurf,tnext,ptptim)
c
c ---- snow cover depth ---
c
      this_var = "snowewd"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                                data_count,arr2d)
         if( ierr .NE. NF_NOERR) goto 7001
         do j = 1,nrow
            do i = 1,ncol
              snowold = snow(i,j)
              snow(i,j) = arr2d(i,j)
              snowrat(i,j) = (snow(i,j) - snowold)/(dtinp/60.)
            enddo
         enddo
      endif
c
c ---- snow cover age ---
c
      this_var = "snowage"
      ierr = nf_inq_varid(i2dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i2dmet(igrd),this_varid,data_start,
     &                                             data_count,snowage)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c  ---- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5,a,i3)') 'Read 2D met file at ',htim,hdate,
     &                                                         ' grid',igrd
      call flush(iout)
c
c  ---- deallocate temperary array ---
c
      deallocate( arr2d )
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_2D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_2D:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine sumgrps(numcols,numrows,nspmod,nsptrac,ndlast,ttlast,
     &                      emstot,emslft,emsbas,emsoth,emssum,lemit)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use ptemiss
      use tracer
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c     
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c     
c     05/01/03  Time span of emissions must now match emiss update interval
c     10/28/09  Changed dimension of variables to accomodate the
c               dynamic memory allocation
c     12/20/13   -gwilson-  Added the compact point source file
c     03/01/16   -gwilson-  Added partial source area map
c     
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument Declarations:
c-----------------------------------------------------------------------
c
      integer numcols
      integer numrows
      integer nspmod
      integer nsptrac
      integer ndlast
      real    ttlast
      real*8  emstot(numcols,numrows,nspmod)
      real*8  emslft(numcols,numrows,nspmod)
      real    emsbas(nspmod,nsptrac)
      real    emsoth(nspmod,nsptrac)
      real    emssum(nspmod,nsptrac)
      logical lemit(*)
c
c-----------------------------------------------------------------------
c    Variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  this_species
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, igroup, idxfile, idx
      integer       npts_in_point, iseg, npoint, idum, ispc, i, j
      integer       igrid, num_emsfiles, num_ptsfiles, buffer_offset
      real          bgtim, edtim
      logical       lpass
c
      real,    allocatable, dimension(:,:,:) ::  emsgrd
      real,    allocatable, dimension(:)     ::  emspnt
      integer, allocatable, dimension(:)     ::  idcompact
      integer, allocatable, dimension(:)     ::  izcel_in
      integer, allocatable, dimension(:)     ::  izcel
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over all of the groups ----
c
      allocate( emspnt(nptsrc) )
      allocate( idcompact(nptsrc) )
      allocate( izcel(nptsrc) )
      allocate( izcel_in(nptsrc) )
      izcel = 0
c
      do 20 igroup=0,ngroup
c
c   --- only process if filename is supplied for group ---
c
         do 25 igrid=1,ngrid
            num_emsfiles = num_iortem(igrid,igroup)
            if( igroup .EQ. 0 ) num_emsfiles = nemiss_files(igrid)
            do 26 idxfile=1,num_emsfiles
              if( allocated(emsgrd) ) deallocate( emsgrd )
              if( .NOT. larsrc) goto 26
c
c   --- set the unit number for surface emissions file ---
c
              lpass = .FALSE.
              if( igroup .EQ. 0 ) then
                  if( is_netcdf_iarem(igrid,idxfile) ) goto 26
                  iounit = iarem(igrid,idxfile)
                  write(fname,'(A,I3)') 'EMISSIONS -- UNIT ',
     &                                                iarem(igrid,idxfile)
                  buffer_offset = buffer_offset_iarem(igrid,idxfile)
              else
                  if( is_netcdf_iortem(igrid,igroup,idxfile) ) goto 26
                  iounit = iortem(igrid,igroup,idxfile)
                  fname = temfil(igrid,igroup,idxfile)
                  buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
              endif
              allocate( emsgrd(ncol(igrid),nrow(igrid),1) )
c
c   --- read the date and time, again ---
c
  111         continue
              read(iounit,END=333) ibgdat, bgtim, iendat, edtim
              if( INT(edtim) .EQ. 0 ) then
                edtim = 24.
                iendat = ibgdat
              endif
              if( le1day ) iendat = ndlast
              ichktm1 = NINT( 1000*(bgtim) )
              if( le1day ) then
                ichktm2 = NINT( 1000*(edtim) )
              else
              ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
              endif
              if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
              ichkems = NINT( 1000*(dtems/60.) )
              if((ichktm2 - ichktm1) .NE. ichkems ) then
                write(iout,'(//,a)')'ERROR in SUMGRPS:'
                write(iout,*) 'Time interval in surface emissions file does'
                write(iout,*) ' not match emissions update time interval.'
                write(iout,*) '  Beginning Date/Time (Hour): ',ibgdat,bgtim
                write(iout,*) '  Ending Date/Time    (Hour): ',iendat,edtim
                write(iout,*) '  Emiss Input interval(Hour): ',dtems/60.
                call camxerr()
              endif
              bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
              edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
              do 30 ispc=1,nspcem(igrid,igroup,idxfile)
                  read(iounit) iseg, (iname(i),i=1,10), 
     &               ((emsgrd(i,j,1),i=1+buffer_offset,ncol(igrid)-buffer_offset),
     &                                 j=1+buffer_offset,nrow(igrid)-buffer_offset)
                  write(this_species,'(10A1)') iname
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
                  idx = idxems(igrid,igroup,idxfile,ispc)
                  if( luse_soap3 .AND. lsoa ) then
                     do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                       if( this_species .EQ. soap_emiss_names(isoa) ) then
                          idx = nspec + (isoa - IDX_SOAP_POA_OP + 1)
                       endif
                     enddo
                  endif
                  if( idx .LE. 0 ) goto 30
                  call sum1grd(numcols,numrows,ncol(igrid),nrow(igrid),1,
     &                      nspec,nspmod,nsptrac,igroup,igrid,idx,this_species,
     &                           emssum,emsgrd,emsbas,emsoth,emslft,emstot,lemit)
c
c   --- next species ---
c
  30          continue
c
c   --- check if end of simulation read ---
c
              if( iendat .LT. ndlast  .OR. (iendat .EQ. ndlast .AND. 
     &                          INT(edtim) .LT. INT(ttlast)) ) goto 111
              goto 26
c
c   --- if using 1 day emissions, we might need to keep going
c       to finish out the simulation ----
c
  333          continue
               if( le1day ) then
                    if( lpass ) goto 7005
                    lpass = .TRUE.
                    rewind(iounit)
                    read(iounit)
                    read(iounit)
                    read(iounit)
                    read(iounit)
                    goto 111
                 endif
   26       continue 
            if( allocated(emsgrd) ) deallocate( emsgrd )
   25    continue 
c
c   --- no longer a zero group for point sources ---
c
         if( igroup .EQ. 0 ) cycle
c
c   --- only process if filename is supplied for group ---
c
         do idxfile=1,num_iortpt(igroup)
            if( .NOT. lptsrc .OR. .NOT. ltptfl(igroup,idxfile) ) cycle
c
c   --- set the unit number for elevated points emissions file ---
c
            lpass = .FALSE.
            if( is_netcdf_iortpt(igroup,idxfile) ) cycle
            iounit = iortpt(igroup,idxfile)
            fname = tptfil(igroup,idxfile)
c
c   --- read the date and time, again ---
c
  222       continue
            read(iounit,END=444) ibgdat, bgtim, iendat, edtim
            if( INT(edtim) .EQ. 0 ) then
                edtim = 24.
                iendat = ibgdat
            endif
            if( le1day ) iendat = ndlast
            ichktm1 = NINT( 1000*(bgtim) )
            if( le1day ) then
              ichktm2 = NINT( 1000*(edtim) )
            else
              ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
            endif
            if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
            ichkems = NINT( 1000*(dtems/60.) )
            if( (ichktm2 - ichktm1) .NE. ichkems ) then
               write(iout,'(//,a)')'ERROR in SUMGRPS:'
               write(iout,*) 'Time interval in surface emissions file does'
               write(iout,*) ' not match emissions update time interval.'
               write(iout,*) '  Beginning Date/Time (Hour): ',ibgdat,bgtim
               write(iout,*) '  Ending Date/Time    (Hour): ',iendat,edtim
               write(iout,*) '  Emiss Input interval(Hour): ',dtems/60.
               call camxerr()
            endif
            bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
            edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
            read(iounit,ERR=7000,END=7001) iseg, npoint
            if( npoint .GT. nptsrc ) goto 7002
            read(iounit,ERR=7000,END=7001)  (idcompact(i), idum,
     &                                izcel_in(i), rdum, rdum,i=1,npoint)
            if( .NOT. lcompactpt(igroup,idxfile) ) then
               do i=1,npoint
                  idcompact(i) = i
                  izcel(i) = izcel_in(i)
               enddo
            else
               do i=1,npoint
                  izcel(idcompact(i)) = izcel_in(i)
               enddo
            endif
            do 60 ispc=1,nspcpt(igroup,idxfile)
               read(iounit) iseg, (iname(i),i=1,10), 
     &                                        (emspnt(i),i=1,npoint)
               write(this_species,'(10A1)') iname
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
               idx = idxpts(igroup,idxfile,ispc)
               if( luse_soap3 .AND. lsoa ) then
                  do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                    if( this_species .EQ. soap_emiss_names(isoa) ) then
                       idx = nspec + (isoa - IDX_SOAP_POA_OP + 1)
                    endif
                  enddo
               endif
               if( idx .LE. 0 ) goto 60
c
c   --- sum up the emissions for each point ---
c
               call sum1pnt(numcols,numrows,nspec,nspmod,nsptrac,igroup,idxfile,
     &                       idx,this_species,nptsrc,emsbas,emsoth,emslft,
     &                          emstot,emspnt,emssum,izcel,idcompact,lemit)
c
c   --- next species ---
c
  60        continue
            if( iendat .LT. ndlast .OR. (iendat .EQ. ndlast .AND. 
     &                          INT(edtim) .LT. INT(ttlast)) ) goto 222
c
            cycle
c
c   --- if using 1 day emissions, we might need to keep going
c       to finish out the simulation ----
c
 444        continue
            if( le1day ) then
                if( lpass ) goto 7005
                lpass = .TRUE.
                rewind(iounit)
                read(iounit)
                read(iounit)
                read(iounit)
                read(iounit)
                goto 222
            endif
c
c   --- next species ---
c
         enddo
c
c  --- get the next file ---
c
         if( igroup .EQ. 0 ) npts_in_list = npts_in_list + npoint
  20  continue
      deallocate( emspnt )
      deallocate( idcompact )
      deallocate( izcel )
      deallocate( izcel_in )
c
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in SUMGRPS:'
      write(iout,'(/,1X,A,I10.5,F10.1,2A)') 
     &      'Reading emissions after hour ',ibgdat, bgtim,
     &      ' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in SUMGRPS:'
      write(iout,'(/,1X,3A)') 'Premature end-of-file reading ',
     &                    'emissions from file: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in SUMGRPS:'
      write(iout,'(/,1X,A,I10,2A)') 'Number of points: ',npoint,
     &                   ' exceeds max in file: ',fname(:istrln(fname))
      write(iout,'(1X,2A,/,1X,A)') 'Make sure the Probing Tools ',
     &              'point source files are consistent with regular',
     &                                                   ' model file.'
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in SUMGRPS:'
      write(iout,'(/,1X,2A,/,10X,2A)') 'Emissions file does cover',
     &    ' entire simulation period.','File = ',fname(:istrln(fname))
      call camxerr()
c
      end

c*** RDFGSA 
c
      subroutine rdfgsa(idate,btim)
      use filunit
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine reads the instantaneous file for the tracer
c     species. 
c
c      Copyright Ramboll
c
c    Argument description:
c     Outputs:
c     Inputs:
c        idate   I   begining date of simulation (YYJJJ)
c        btim    R   begining time of simulation
c
c----------------------------------------------------------------------- 
c   LOG: 
c----------------------------------------------------------------------- 
c 
c     11/06/01   --cemery--     Input dates are now Julian
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*80 msg
      character*10 cname
      integer*8    idx
      integer      numfin, nspcs, ndate, indate
      integer      ixfb, jyfb, ixfe, jyfe, nhf, nvf
      integer      ifgptr, ifglvl, i, j, k, l, igrd, ifin
      integer      ibgdat
      real         ttime, timein, begtim
      logical      lmatch
c
      character*10 cspec(MXTRSP)
      integer      nfx(MXGRID)
      integer      nfy(MXGRID)
      integer      nfz(MXGRID)
      integer      irdgrd(MXGRID)
      logical      lread(MXGRID)
      real         cnctmp(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- initialize all of the tracer concs to zero ----
c
      do igrd=2,ngrid
         do l=1,nsaspc
            do k=1,nlay(igrd)
               do j=1,nrow(igrd)
                  do i=1,ncol(igrd)
                     idx = ipsa3d(igrd)-1 + DBLE(i) + 
     &                  DBLE(ncol(igrd))*DBLE(j-1) + 
     &                     DBLE(ncol(igrd))*DBLE(nrow(igrd))*DBLE(k-1) +
     &                       DBLE(ncol(igrd))*DBLE(nrow(igrd))*DBLE(nlay(igrd))*DBLE(l-1)
                     ptconc(idx) = 0.
                  enddo
               enddo
            enddo
         enddo
      enddo
c
c --- initialize the "read-in" flag ---
c
      do i=1,ngrid
        lread(i) = .FALSE.
      enddo
c
c --- if the file was not supplied then all of the grids are
c     to be assigned ----
c
      if( inifil(IDXFIN) .EQ. ' ' ) goto 222
c
c   --- open the fine grids instantaneous file ---
c
      open(unit=iorini(IDXFIN),file=inifil(IDXFIN),
     &                  form='UNFORMATTED',ERR=7000,status='UNKNOWN')
c
c   --- convert the date and time ---
c
      ndate = idate
      ttime = btim
      if( ttime .EQ. 2400.0 ) then
          ttime = 0.
          ndate = ndate + 1
          if( MOD(ndate,1000) .GT. 365 ) then
             if( MOD(INT(ndate/1000),4) .EQ. 0 ) then
                if( MOD(ndate,1000) .EQ. 367 )
     &                     ndate = (INT(ndate/1000)+1)*1000 + 1
             else
                ndate = (INT(ndate/1000)+1)*1000 + 1
             endif
          endif
      endif
c
c   --- file description header ---
c
      read(iorini(IDXFIN),ERR=7000) msg
      read(iorini(IDXFIN),ERR=7000) numfin, nspcs
      if( nspcs .GT. MXTRSP ) then
        write(iout,'(//,A)') 'ERROR in RDFGSA:'
        write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
        write(iout,*) 'Please change the value for parameter: MXTRSP'
        write(iout,*) 'It should be set to a value of at least: ',nspcs
        call flush(iout)
        call camxerr()
      endif
c
c  ---- species list ---
c
      read(iorini(IDXFIN),ERR=7000) (cspec(i),i=1,nspcs)
c
c  --- make sure species list is compatable, up to timing tracers ---
c
      do l=1,nspcs
         cname = cspec(l)
         if( cname .NE. ptname(l) ) goto 7004
      enddo
c
c  --- read the fine grid descriptions, and check for 
c      consistancy ---
c
      do ifin=1,numfin
          read(iorini(IDXFIN),ERR=7000) ixfb, jyfb, ixfe, jyfe, 
     &                   nhf, nvf, nfx(ifin), nfy(ifin), nfz(ifin), 
     &                                                  ifgptr, ifglvl
          do igrd=2,ngrid
             lmatch = .TRUE.
             if( ixfb .NE. inst1(igrd) ) lmatch = .FALSE.
             if( jyfb .NE. jnst1(igrd) ) lmatch = .FALSE.
             if( ixfe .NE. inst2(igrd) ) lmatch = .FALSE.
             if( jyfe .NE. jnst2(igrd) ) lmatch = .FALSE.
             if( nhf .NE. meshold(igrd) ) lmatch = .FALSE.
             if( nvf .NE. meshold(igrd) ) lmatch = .FALSE.
             if( nfx(ifin) .NE. ncol(igrd) ) lmatch = .FALSE.
             if( nfy(ifin) .NE. nrow(igrd) ) lmatch = .FALSE.
             if( nfz(ifin) .NE. nlay(igrd) ) lmatch = .FALSE.
             if( lmatch ) then 
               lread(mapgrd(igrd)) = .TRUE.
               irdgrd(mapgrd(igrd)) = ifin
             endif
          enddo
      enddo
c
c  --- make sure time span is correct ---
c
      read(iorini(IDXFIN),ERR=7000) timein, indate
      ibgdat = indate
      begtim = timein
      if( begtim .EQ. 2400.0 ) then
          begtim = 0.
          ibgdat = ibgdat + 1
          if( MOD(ibgdat,1000) .GT. 365 ) then
             if( MOD(INT(ibgdat/1000),4) .EQ. 0 ) then
                if( MOD(ibgdat,1000) .EQ. 367 )
     &                     ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
             else
                ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
             endif
          endif
      endif
      if( ibgdat .NE. ndate .OR. 
     &                        ABS(begtim-ttime) .GT. 0.00001 ) goto 7002
c
c   --- read the data for this hour ----
c
      do 50 ifin=1,numfin
         do 60 l=1,nspcs
            do 70 k=1,nfz(ifin)
               read(iorini(IDXFIN)) ((cnctmp(i,j),i=1,nfx(ifin)),
     &                                                  j=1,nfy(ifin))
c
c-----Find the grid in this setup ----
c
               do igrd = 2,ngrid
                  if( irdgrd(igrd) .EQ. ifin ) then
                     if( l .EQ. 1 .and. k .EQ. 1 )
     &                     write(iout,'(a40,f5.0,i8.5,a,i3)')
     &                        'Read fine grid restart file at ',
     &                                    timein, ibgdat,' grid',igrd
                     do 80 j=1,nrow(igrd)
                        do 90 i=1,ncol(igrd)
                           idx =  DBLE(ipsa3d(igrd)-1) + DBLE(i) + 
     &                       DBLE(ncol(igrd))*DBLE(j-1) + 
     &                        DBLE(ncol(igrd))*DBLE(nrow(igrd))*DBLE(k-1) +
     &                         DBLE(ncol(igrd))*DBLE(nrow(igrd))*DBLE(nlay(igrd))*DBLE(l-1)
                           ptconc(idx) = cnctmp(i,j)
   90                   continue
   80                continue
                  endif
               enddo
   70       continue
   60    continue
   50 continue
c
c  --- close file and return to calling routine ---
c
      close(iorini(IDXFIN))
c
c-----Load data for the grids not found in restart file----
c
  222 continue
      do ip = 1,ngrid
         do ic = 1,nchdrn(ip)
           ig = idchdrn(ic,ip)
           if( .NOT. lread(ig) ) then
              write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Assigning SA concs from parent grid at ',
     &                             btim, idate,' grid',ig
              call rassgn4d(ncol(ip),nrow(ip),nlay(ip),nsaspc,i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),
     &                      nrow(ig),nlay(ig),ptconc(ipsa3d(ip)),
     &                      ptconc(ipsa3d(ig)) )
           endif
         enddo
      enddo
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDFGSA:'
      write(iout,9000,ERR=9999)'Reading the header of the ',
     &   'tracer concentration initialization file for fine grids: ',
     &                          inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDFGSA:'
      write(iout,9000,ERR=9999) 'Tracer concentration ',
     &   'initialization file for fine grids is not for correct ',
     &        'time period; ',inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
      write(iout,9001,ERR=9999) 'Simulation Start: ',idate,btim
      write(iout,9001,ERR=9999) 'Initialization File: ',ibgdat,timein
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in RDFGSA:'
      write(iout,9000,ERR=9999) 'Species list for tracer ',
     &            'concentration initialization file for fine grids ',
     &         'is inconsistent with user parameters ',
     &                       inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
      write(iout,9004,ERR=9999) 'Species number: ',l,' should be ',
     &                      ptname(l),' and ',cname,' was read instead.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,6A)
 9001 format(1X,A,I10.5,F10.1)
 9004 format(1X,A,I5,5A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

C=====================================================================
C
C   DDM-PM SUBROUTINES FOR RADM
C
C   Subroutines included in this file:
C     DDMRADINI
C     DDMRADM
C     DDMRADUNIT
C     DDMRADEQL
C     DDMRADSUB1
C     DDMRADSUB2
C     DDMDAVIES
C     DDMRADRXN
C
C   Dependent upon:
C     tracer.com -> camx.prm  - for MXFDDM, NDDMSP & LDDM
C     ddmradm.inc
C
C   Log:
C     04/26/2005  bkoo - original development
C     06/25/2008  bkoo - added optional model species (FOA/MHP/OHP/PAA/OPA)
C     09/19/2013  bkoo - revised for CaCO3 which is now a model species
C     10/26/2018  bkoo - updated for revised RADM
C
C=====================================================================

      SUBROUTINE DDMRADINI (CSO2,CNA,CCL,fCA_PRM,fCA_CRS,CONVFAC,
     &                      WTMOL,SDDM,NFAM,NSEN,NWTMOL)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'

      INTEGER   NFAM, NSEN, NWTMOL
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      WTMOL(NWTMOL)             ! Molecular weight array
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac
      REAL      fCA_PRM, fCA_CRS          ! mass fraction of Ca on FPRM/FCRS
      REAL      CNA, CCL                  ! CNA = sodium conc; CCL = chloride conc
      REAL      CSO2                      ! SO2 [ppm]

      INTEGER   J
C
C     Check if SO2 is too small
C
      IF ( CSO2.LT.1.E-6 ) THEN
        IPAR = 0
        RETURN
      ENDIF
C
C     Convert to [mol/mol of air]/[p]
C
      DO J = 1, NFAM
C     LOADDMPM has initialized SDDM rows for non-model species to zero
        SINI(jTNH3 ,J) = ( SDDM(J,jdpNH3 ) +
     &                     SDDM(J,jdpPNH4)/WTMOL(2)/CONVFAC )*1.E-6
        SINI(jTHNO3,J) = ( SDDM(J,jdpHNO3) + SDDM(J,jdpN2O5)*2.0 +
     &                     SDDM(J,jdpPNO3)/WTMOL(3)/CONVFAC )*1.E-6
        SINI(jTFOA ,J) =   SDDM(J,jdpFOA )*1.E-6
        SINI(jTCO2 ,J) = 0.0
        SINI(jTSO2 ,J) =   SDDM(J,jdpSO2 )*1.E-6
        SINI(jTSVI ,J) = ( SDDM(J,jdpSULF) +
     &                     SDDM(J,jdpPSO4)/WTMOL(1)/CONVFAC )*1.E-6
        SINI(jTH2O2,J) =   SDDM(J,jdpH2O2)*1.E-6
        SINI(jTO3  ,J) =   SDDM(J,jdpO3  )*1.E-6
        SINI(jTMHP ,J) = ( SDDM(J,jdpMHP ) + SDDM(J,jdpOHP ) )*1.E-6
        SINI(jTPAA ,J) = ( SDDM(J,jdpPAA ) + SDDM(J,jdpOPA ) )*1.E-6
        SINI(jTGLY ,J) =   SDDM(J,jdpGLY )*1.E-6
        SINI(jTMGLY,J) =   SDDM(J,jdpMGLY)*1.E-6
        SINI(jTGLYD,J) =   SDDM(J,jdpGLYD)*1.E-6
        SINI(jTHO  ,J) =   SDDM(J,jdpHO  )*1.E-6
        IF (CNA.GT.CCL) THEN
          SINI(jTNACL,J) = SDDM(J,jdpPCL )/WTMOL(4)/CONVFAC*1.E-6
        ELSE
          SINI(jTNACL,J) = SDDM(J,jdpNA  )/WTMOL(5)/CONVFAC*1.E-6
        ENDIF
        ! assumed Ca is scaled from FPRM+FCRS
        ! Fe, Mn, Mg & K are assumed background constants
        SINI(jTCAC ,J) = (fCA_PRM*SDDM(J,jdpFPRM)+
     &                    fCA_CRS*SDDM(J,jdpFCRS))/WTMOL(8)/CONVFAC*1.E-6
        SINI(jTSOAC,J) = SDDM(J,jdpBOA0)/WTMOL(12)/CONVFAC*1.E-6

        SAVSISO2(J) = SINI(jTSO2,J)
        SAVSISVI(J) = SINI(jTSVI,J)

      ENDDO

      IPAR = 1

      RETURN
      END
C     END OF SUBROUTINE DDMRADINI


      SUBROUTINE DDMRADM (r_1,r_11,r_2,r_22,
     &                    CONVFAC,WTMOL,SDDM,NFAM,NSEN,NWTMOL,IERR,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'

      INTEGER   NFAM, NSEN, NWTMOL
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      WTMOL(NWTMOL)             ! Molecular weight array
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac
      REAL      r_1                       ! con(MHP    ;t)   /con(MHP+OHP;t)
      REAL      r_11                      ! con(MHP+OHP;t+dt)/con(MHP+OHP;t)
      REAL      r_2                       ! con(PAA    ;t)   /con(PAA+OPA;t)
      REAL      r_22                      ! con(PAA+OPA;t+dt)/con(PAA+OPA;t)
      INTEGER   IERR, IOUT

      INTEGER   J
C
C     Initialize error flag
C
      IERR = 1
C
C     Check if SO2 is too small
C
      IF ( IPAR.EQ.0 ) THEN
        DO J = 1, NFAM
          SDDM(J,jdpPSO4) = SDDM(J,jdpPSO4)
     &                    + SDDM(J,jdpSULF)*WTMOL(1)*CONVFAC
          SDDM(J,jdpHNO3) = SDDM(J,jdpHNO3) + SDDM(J,jdpN2O5)*2.0
          SDDM(J,jdpSULF) = 0.0
          SDDM(J,jdpN2O5) = 0.0
        ENDDO
        IERR = IPAR
        RETURN
      ENDIF
C
C     Check error from the previous routines
C
      IF ( IPAR.LT.0 ) THEN
        IERR = IPAR
        RETURN
      ENDIF
C
C     Assign the solution
C
      DO J = 1, NFAM
C     Currently sensitivities of HNO3/NO3 and NH3/NH4 are not properly
C     implemented since RADM uses initial partition factors to partition
C     them and total (gas+aerosol) does not change. Also, they will be
C     re-partitioned by the following ISORROPIA anyway. However, it should
C     be considered here that all N2O5 is added to HNO3/NO3 by RADM.
        SDDM(J,jdpHNO3) = SDDM(J,jdpHNO3) + SDDM(J,jdpN2O5)*2.0
        SDDM(J,jdpN2O5) = 0.0
        SDDM(J,jdpSULF) = 0.0
        SDDM(J,jdpPSO4) = SINI(jTSVI ,J)*WTMOL(1)*CONVFAC*1.E6
        SDDM(J,jdpSO2 ) = SINI(jTSO2 ,J)*1.E6
        SDDM(J,jdpH2O2) = SINI(jTH2O2,J)*1.E6
        SDDM(J,jdpO3  ) = SINI(jTO3  ,J)*1.E6
C     For SAPRC99, FOA/MHP/OHP/PAA/OPA are (optional) model species.
C     However, FOA is not changed by RADM, thus neither is the sensitivity.
C     CaCO3 is now also a model species, but not changed by RADM.
        SDDM(J,jdpMHP ) = SINI(jTMHP ,J)*1.E6*r_1 + r_11*
     &                   (SDDM(J,jdpMHP )*(1.-r_1)-SDDM(J,jdpOHP )*r_1)
        SDDM(J,jdpOHP ) = SINI(jTMHP ,J)*1.E6 - SDDM(J,jdpMHP )
        SDDM(J,jdpPAA ) = SINI(jTPAA ,J)*1.E6*r_2 + r_22*
     &                   (SDDM(J,jdpPAA )*(1.-r_2)-SDDM(J,jdpOPA )*r_2)
        SDDM(J,jdpOPA ) = SINI(jTPAA ,J)*1.E6 - SDDM(J,jdpPAA )
        SDDM(J,jdpGLY ) = SINI(jTGLY ,J)*1.E6
        SDDM(J,jdpMGLY) = SINI(jTMGLY,J)*1.E6
        SDDM(J,jdpGLYD) = SINI(jTGLYD,J)*1.E6
        ! RADM does not consume OH radical
        SDDM(J,jdpBOA0) = SINI(jTSOAC,J)*WTMOL(12)*CONVFAC*1.E6
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMRADM


      SUBROUTINE DDMRADUNIT (IEND,PRESATMOVERXL)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'

      INTEGER   IEND          ! 0 - at the start; 1 - at the end
      REAL      PRESATMOVERXL ! [M] = PRESATMOVERXL * [mol/mol of air]
      REAL      CONVFAC
      INTEGER   I, J
C
C     Initial check
C
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used
      IF ( IPAR.LE.0 ) RETURN             ! Check error from DDMRADEQL
C
C     Set conversion factor
C
      CONVFAC = PRESATMOVERXL
      IF (IEND.EQ.1) CONVFAC = 1. / CONVFAC
C
C     Unit conversion: [mol/mol of air]/[p] <-> [M]/[p]
C
      DO J = 1, NDDMSP
        DO I = 1, NINPT
          SINI(I,J) = SINI(I,J) * CONVFAC
        ENDDO
        SAVSISO2(J) = SAVSISO2(J) * CONVFAC
        SAVSISVI(J) = SAVSISVI(J) * CONVFAC
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMRADUNIT


      SUBROUTINE DDMRADEQL (NLIQS,LIQUID,STION,GM1,GM2,
     &                      XLNH3,XLHNO3,XLFOA,XLCO2,XLSO2,
     &                      XLH2O2,XLO3,XLMHP,XLPAA,
     &                      XLGLY,XLMGLY,XLGLYD,XLHO,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'

      INTEGER   NLIQS
      REAL      LIQUID(NLIQS) ! Liquid concentration array [M]
      REAL      STION         ! Ionic strength
      REAL      GM1           ! Activity coefficient for ions with absolute charge = 1
      REAL      GM2           ! Activity coefficient for ions with absolute charge = 2
      REAL      XLNH3         ! = NH3H  * XL
      REAL      XLHNO3        ! = HNO3H * XL
      REAL      XLFOA         ! = FOAH  * XL (new)
      REAL      XLCO2         ! = CO2H  * XL
      REAL      XLSO2         ! = SO2H  * XL
      REAL      XLH2O2        ! = H2O2H * XL
      REAL      XLO3          ! = O3H   * XL
      REAL      XLMHP         ! = MHPH  * XL
      REAL      XLPAA         ! = PAAH  * XL
      REAL      XLGLY         ! = GLYH  * XL
      REAL      XLMGLY        ! = MGLYH * XL
      REAL      XLGLYD        ! = GLYDH * XL
      REAL      XLHO          ! = HOH   * XL
      INTEGER   IOUT          ! Unit number of log file

      LOGICAL   LSEQ(NSENS)               ! If true, the eqn is solved
      LOGICAL   LSEN(NSENS)               ! If true, the sensitivity is solved
      REAL      AMAT(NSENS,NSENS)         ! Left-hand side matrix A
                                          ! Right-hand side vector B -> XMAT
      REAL      AA(NSENS,NSENS),BB(NSENS) ! These are passed to DDMEQNSLV solely
      INTEGER   IPVT(NSENS)               ! to allow their size to be adjustable

      REAL      SION, DGM11, DGM12, DGM21, DGM22
      REAL      CX, C1
      INTEGER   NDIM, iEQ, I, J, K
C
C     Initial check
C
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used
      IF ( IPAR.LE.0 ) RETURN             ! Check error from the previous call
C
C     Initialize arrays
C
      Y(jH     ) = LIQUID( 1)
      Y(jNH4   ) = LIQUID( 2)
      Y(jNO3   ) = LIQUID(14)
      Y(jHCO2  ) = LIQUID(23)
      Y(jHCO3  ) = LIQUID(12)
      Y(jHSO3  ) = LIQUID( 9)
      Y(jHSO4  ) = LIQUID( 7)
      Y(jOH    ) = LIQUID( 5)
      Y(jCO3   ) = LIQUID(11)
      Y(jSO3   ) = LIQUID( 8)
      Y(jSO4   ) = LIQUID( 6)
      Y(jNH3aq ) = LIQUID(15)
      Y(jHNO3aq) = LIQUID(32)
      Y(jFOAaq ) = LIQUID(22)
      Y(jCO2aq ) = LIQUID(13)
      Y(jSO2aq ) = LIQUID(10)
      Y(jH2O2aq) = LIQUID(17)
      Y(jO3aq  ) = LIQUID(18)
      Y(jMHPaq ) = LIQUID(24)
      Y(jPAAaq ) = LIQUID(25)
      Y(jGLYaq ) = LIQUID(34)
      Y(jMGLYaq) = LIQUID(35)
      Y(jGLYDaq) = LIQUID(36)
      Y(jHOaq  ) = LIQUID(37)
      DO I = 1, NSENS
        DO J = 1, NSENS
          AMAT(J,I) = 0.0
        ENDDO
      ENDDO
C     Initialize the solution matrix
C     - should be done here as this routine is called every (internal) timestep
      DO J = 1, NDDMSP
        DO I = 1, NSENS
          XMAT(I,J) = 0.0
        ENDDO
      ENDDO
      NDIM = 16 ! Should be consistent with the number of equations
      DO I = 1, NDIM
        LSEQ(I) = .TRUE.
        LSEN(I) = .TRUE.
      ENDDO
      DO I = NDIM + 1, NSENS
        LSEQ(I) = .FALSE.
        LSEN(I) = .FALSE.
      ENDDO
C
C     Select eqns & sensitivities to solve
C
      IF ( Y(jSO2aq ).LE.0.0 ) THEN
        CALL DDMEQNSUB (LSEQ(iMBSO2 ),LSEN(jSO2aq ))
        CALL DDMEQNSUB (LSEQ(iKS1   ),LSEN(jHSO3  ))
        CALL DDMEQNSUB (LSEQ(iKS2   ),LSEN(jSO3   ))
        NDIM = NDIM - 3
        DO J = 1, NDDMSP
          SINI(jTSO2,J) = 0.0 ! TSO2 is depleted
          SINI(jTSVI,J) = SAVSISVI(J) + SAVSISO2(J)
        ENDDO
      ENDIF
      IF ( Y(jNH3aq ).LE.0.0 ) THEN
        CALL DDMEQNSUB (LSEQ(iMBNH3 ),LSEN(jNH3aq ))
        CALL DDMEQNSUB (LSEQ(iKA    ),LSEN(jNH4   ))
        NDIM = NDIM - 2
      ENDIF
      IF ( Y(jHNO3aq).LE.0.0 ) THEN
        CALL DDMEQNSUB (LSEQ(iMBHNO3),LSEN(jHNO3aq))
        CALL DDMEQNSUB (LSEQ(iKN    ),LSEN(jNO3   ))
        NDIM = NDIM - 2
      ENDIF
      IF ( Y(jFOAaq ).LE.0.0 ) THEN
        CALL DDMEQNSUB (LSEQ(iMBFOA ),LSEN(jFOAaq ))
        CALL DDMEQNSUB (LSEQ(iKF    ),LSEN(jHCO2  ))
        NDIM = NDIM - 2
      ENDIF
C====================================================================
C     Fill the matrix A and constant vector B
C====================================================================
C
C     Activity coefficients
C
      SION = SQRT(STION)
      CALL DDMDAVIES (SION,GM1,GM2,DGM11,DGM12,DGM21,DGM22)
      CX = 1.     ! Equlibrium equations are now normalized
C
C     [H2O(aq)] <-> [H+] + [OH-]
C
      iEQ = iKW
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jOH)*GM1*GM1
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jH ,iEQ) = AMAT(jH ,iEQ) + CX/Y(jH)
        AMAT(jOH,iEQ) = AMAT(jOH,iEQ) + CX/Y(jOH)
CCC   ENDIF
C
C     [NH3(aq)] <-> [NH4+] + [OH-]
C
      iEQ = iKA
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jNH4)*Y(jOH)*GM1*GM1/Y(jNH3aq)
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jNH4  ,iEQ) = AMAT(jNH4  ,iEQ) + CX/Y(jNH4)
        AMAT(jOH   ,iEQ) = AMAT(jOH   ,iEQ) + CX/Y(jOH)
        AMAT(jNH3aq,iEQ) = AMAT(jNH3aq,iEQ) - CX/Y(jNH3aq)
      ENDIF
C
C     [HNO3(aq)] <-> [H+] + [NO3-]
C
      iEQ = iKN
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jNO3)*GM1*GM1/Y(jHNO3aq)
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jH     ,iEQ) = AMAT(jH     ,iEQ) + CX/Y(jH)
        AMAT(jNO3   ,iEQ) = AMAT(jNO3   ,iEQ) + CX/Y(jNO3)
        AMAT(jHNO3aq,iEQ) = AMAT(jHNO3aq,iEQ) - CX/Y(jHNO3aq)
      ENDIF
C
C     [HCOOH(aq)] <-> [H+] + [HCOO-]
C
      iEQ = iKF
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jHCO2)*GM1*GM1/Y(jFOAaq)
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jH    ,iEQ) = AMAT(jH    ,iEQ) + CX/Y(jH)
        AMAT(jHCO2 ,iEQ) = AMAT(jHCO2 ,iEQ) + CX/Y(jHCO2)
        AMAT(jFOAaq,iEQ) = AMAT(jFOAaq,iEQ) - CX/Y(jFOAaq)
CCC   ENDIF
C
C     [CO2(aq)] <-> [H+] + [HCO3-]
C
      iEQ = iKC1
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jHCO3)*GM1*GM1/Y(jCO2aq)
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jH    ,iEQ) = AMAT(jH    ,iEQ) + CX/Y(jH)
        AMAT(jHCO3 ,iEQ) = AMAT(jHCO3 ,iEQ) + CX/Y(jHCO3)
        AMAT(jCO2aq,iEQ) = AMAT(jCO2aq,iEQ) - CX/Y(jCO2aq)
CCC   ENDIF
C
C     [HCO3-] <-> [H+] + [CO3=]
C
      iEQ = iKC2
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jCO3)*GM2/Y(jHCO3)
        C1 = CX/GM2
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM21,DGM22,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM21)      ! Constant term
        AMAT(jH   ,iEQ) = AMAT(jH   ,iEQ) + CX/Y(jH)
        AMAT(jCO3 ,iEQ) = AMAT(jCO3 ,iEQ) + CX/Y(jCO3)
        AMAT(jHCO3,iEQ) = AMAT(jHCO3,iEQ) - CX/Y(jHCO3)
CCC   ENDIF
C
C     [SO2(aq)] <-> [H+] + [HSO3-]
C
      iEQ = iKS1
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jHSO3)*GM1*GM1/Y(jSO2aq)
        C1 = 2.*CX/GM1
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM11,DGM12,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM11)      ! Constant term
        AMAT(jH    ,iEQ) = AMAT(jH    ,iEQ) + CX/Y(jH)
        AMAT(jHSO3 ,iEQ) = AMAT(jHSO3 ,iEQ) + CX/Y(jHSO3)
        AMAT(jSO2aq,iEQ) = AMAT(jSO2aq,iEQ) - CX/Y(jSO2aq)
      ENDIF
C
C     [HSO3-] <-> [H+] + [SO3=]
C
      iEQ = iKS2
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jSO3)*GM2/Y(jHSO3)
        C1 = CX/GM2
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM21,DGM22,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM21)      ! Constant term
        AMAT(jH   ,iEQ) = AMAT(jH   ,iEQ) + CX/Y(jH)
        AMAT(jSO3 ,iEQ) = AMAT(jSO3 ,iEQ) + CX/Y(jSO3)
        AMAT(jHSO3,iEQ) = AMAT(jHSO3,iEQ) - CX/Y(jHSO3)
      ENDIF
C
C     [HSO4-] <-> [H+] + [SO4=]
C
      iEQ = iKS3
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = Y(jH)*Y(jSO4)*GM2/Y(jHSO4)
        C1 = CX/GM2
        CALL DDMRADSUB1 (NSENS,jOH,NIONS,C1,DGM21,DGM22,AMAT(1,iEQ))
        CALL DDMRADSUB2 (iEQ,C1,DGM21)      ! Constant term
        AMAT(jH   ,iEQ) = AMAT(jH   ,iEQ) + CX/Y(jH)
        AMAT(jSO4 ,iEQ) = AMAT(jSO4 ,iEQ) + CX/Y(jSO4)
        AMAT(jHSO4,iEQ) = AMAT(jHSO4,iEQ) - CX/Y(jHSO4)
CCC   ENDIF
C
C     Mass balance: NH3
C
      iEQ = iMBNH3
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTNH3,J)
        ENDDO
        AMAT(jNH3aq ,iEQ) = 1. + 1./XLNH3
        AMAT(jNH4   ,iEQ) = 1.
      ENDIF
C
C     Mass balance: HNO3
C
      iEQ = iMBHNO3
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTHNO3,J)
        ENDDO
        AMAT(jHNO3aq,iEQ) = 1. + 1./XLHNO3
        AMAT(jNO3   ,iEQ) = 1.
      ENDIF
C
C     Mass balance: FOA
C
      iEQ = iMBFOA
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTFOA,J)
        ENDDO
        AMAT(jFOAaq ,iEQ) = 1. + 1./XLFOA
        AMAT(jHCO2  ,iEQ) = 1.
CCC   ENDIF
C
C     Mass balance: CO2
C
      iEQ = iMBCO2
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTCO2,J) + SINI(jTCAC,J)
        ENDDO
        AMAT(jCO2aq ,iEQ) = 1. + 1./XLCO2
        AMAT(jHCO3  ,iEQ) = 1.
        AMAT(jCO3   ,iEQ) = 1.
CCC   ENDIF
C
C     Mass balance: SO2
C
      iEQ = iMBSO2
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTSO2,J) ! Renewed
        ENDDO
        AMAT(jSO2aq ,iEQ) = 1. + 1./XLSO2
        AMAT(jHSO3  ,iEQ) = 1.
        AMAT(jSO3   ,iEQ) = 1.
      ENDIF
C
C     Mass balance: S(VI)
C
      iEQ = iMBSVI
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = SINI(jTSVI,J) ! Renewed
        ENDDO
        AMAT(jHSO4  ,iEQ) = 1.
        AMAT(jSO4   ,iEQ) = 1.
CCC   ENDIF
C
C     Charge Balance
C
      iEQ = iCB
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XMAT(      iEQ,J) = -2.*SINI(jTCAC,J)
          ! Mg is assumed background constants
        ENDDO
        AMAT(jH   ,iEQ) =  1.
        AMAT(jNH4 ,iEQ) =  1.
        AMAT(jNO3 ,iEQ) = -1.
        AMAT(jHCO2,iEQ) = -1.
        AMAT(jHCO3,iEQ) = -1.
        AMAT(jHSO3,iEQ) = -1.
        AMAT(jHSO4,iEQ) = -1.
        AMAT(jOH  ,iEQ) = -1.
        AMAT(jCO3 ,iEQ) = -2.
        AMAT(jSO3 ,iEQ) = -2.
        AMAT(jSO4 ,iEQ) = -2.
CCC   ENDIF
C====================================================================
C
C     Solve the sensitivity eqns
C
      CALL DDMEQNSLV (NSENS,LSEQ,LSEN,AMAT,NDDMSP,XMAT,
     &                NDIM,AA,BB,IPVT,IPAR,IOUT)
      IF (IPAR.LT.0) THEN
        WRITE(IOUT,'(A)') ' Called by DDMRADEQL'
        RETURN
      ENDIF
C
C     Independent equilibria
C
      DO J = 1, NDDMSP
        IF (Y(jH2O2aq).LE.0.0) SINI(jTH2O2,J) = 0.0   ! If TH2O2 is depleted
        IF (Y(jO3aq  ).LE.0.0) SINI(jTO3  ,J) = 0.0   ! If TO3   is depleted
        IF (Y(jMHPaq ).LE.0.0) SINI(jTMHP ,J) = 0.0   ! If TMHP  is depleted
        IF (Y(jPAAaq ).LE.0.0) SINI(jTPAA ,J) = 0.0   ! If TPAA  is depleted
        IF (Y(jGLYaq ).LE.0.0) SINI(jTGLY ,J) = 0.0   ! If TGLY  is depleted
        IF (Y(jMGLYaq).LE.0.0) SINI(jTMGLY,J) = 0.0   ! If TMGLY is depleted
        IF (Y(jGLYDaq).LE.0.0) SINI(jTGLYD,J) = 0.0   ! If TGLYD is depleted
        ! RADM does not consume OH radical
        XMAT(jH2O2aq,J) = XLH2O2/(1.+XLH2O2) * SINI(jTH2O2,J) ! Renewed
        XMAT(jO3aq  ,J) = XLO3  /(1.+XLO3  ) * SINI(jTO3  ,J) ! Renewed
        XMAT(jMHPaq ,J) = XLMHP /(1.+XLMHP ) * SINI(jTMHP ,J) ! Renewed
        XMAT(jPAAaq ,J) = XLPAA /(1.+XLPAA ) * SINI(jTPAA ,J) ! Renewed
        XMAT(jGLYaq ,J) = XLGLY /(1.+XLGLY ) * SINI(jTGLY ,J) ! Renewed
        XMAT(jMGLYaq,J) = XLMGLY/(1.+XLMGLY) * SINI(jTMGLY,J) ! Renewed
        XMAT(jGLYDaq,J) = XLGLYD/(1.+XLGLYD) * SINI(jTGLYD,J) ! Renewed
        XMAT(jHOaq  ,J) = XLHO  /(1.+XLHO  ) * SINI(jTHO  ,J)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMRADEQL


      SUBROUTINE DDMRADSUB1 (N0,N1,N2,C,DGM1,DGM2,VEC)
      INTEGER   N0,N1,N2,K
      REAL      C,DGM1,DGM2,VEC(N0)
      DO K = 1, N1
        VEC(K) = C * DGM1
      ENDDO
      DO K = N1 + 1, N2
        VEC(K) = C * DGM2
      ENDDO
      RETURN
      END
C     END OF SUBROUTINE DDMRADSUB1


      SUBROUTINE DDMRADSUB2 (I,C,DGM1)
      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'
      INTEGER   I,J
      REAL      C,DGM1
      DO J = 1, NDDMSP
        XMAT(I,J) = -C*DGM1*(
     &                       2.*SINI(jTNACL,J) ! (z1)^2 * (SINI(Na) + SINI(Cl))
     &                      +4.*SINI(jTCAC ,J) ! (z2)^2 *  SINI(Ca)
     &                       ) ! Fe, Mn, Mg & K are assumed background constants
      ENDDO
      RETURN
      END
C     END OF SUBROUTINE DDMRADSUB2


      SUBROUTINE DDMDAVIES (SION,GM1,GM2,DGM11,DGM12,DGM21,DGM22)

      REAL      LN10
      PARAMETER (LN10=2.3025851)

      REAL      SION, GM1, GM2, DGM11, DGM12, DGM21, DGM22
      REAL      DGMLOG, DELI1, DELI2

      DGMLOG = -0.509 * ( 0.5/(SION*(1.+SION)*(1.+SION)) - 0.2 )
      DELI1  = 0.5 ! dI/dY1 where Y1 = ions with absolute charge = 1
      DELI2  = 2.0 ! dI/dY2 where Y2 = ions with absolute charge = 2
      DGM11  = LN10 * GM1 * DGMLOG * DELI1    ! dGM1/dY1
      DGM12  = LN10 * GM1 * DGMLOG * DELI2    ! dGM1/dY2
      DGM21  = LN10 * GM2 * 4.*DGMLOG * DELI1 ! dGM2/dY1
      DGM22  = LN10 * GM2 * 4.*DGMLOG * DELI2 ! dGM2/dY2

      RETURN
      END
C     END OF SUBROUTINE DDMDAVIES


      SUBROUTINE DDMRADRXN (BB,SIV,TS6,MN,FE,
     &                      RH2O2,RO3A,RO3B,RO3C,RMHP,RPAA,
     &                      RGLY3,RMGLY3,RGLYD3,
     &                      YGLY,YMGLY,YGLYD,
     &                      DSIV_SCALE,DTW,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmradm.inc'

      REAL      BB            ! Cloudwater pH
      REAL      SIV           ! [SO2(aq)] + [HSO3-] + [SO3=] (mol/liter)
      REAL      TS6           ! [SO4=] + [HSO4-]
      REAL      MN            ! Mn++ conc in cloudwater (mol/liter)
      REAL      FE            ! Fe+++ conc in cloudwater (mol/liter)
      REAL      RH2O2,RO3A,RO3B,RO3C,RMHP,RPAA
      REAL      RGLY3,RMGLY3,RGLYD3
      REAL      YGLY,YMGLY,YGLYD
      REAL      DSIV_SCALE
      REAL      DTW           ! Cloud chemistry timestep (sec)
      INTEGER   IOUT          ! Unit number of log file

      REAL      SH,C1,XSIV,XSVI
      REAL      R1XH,R1XH2O2,R1XHSO3
      REAL      R2XSO2,R2XHSO3,R2XSO3,R2XO3
      REAL      RO2A,RO2B,R3XSIV,R3XH,R3XSVI
      REAL      R4XH,R4XHSO3,R4XMHP
      REAL      R5XH,R5XHSO3,R5XPAA
      REAL      DR0,DR1,DR2,DR3,DR4,DR5,DR6,DR7,DR8 ! Sensitivities of rxn rates
      INTEGER   J
C
C     Initial check
C
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used
      IF ( IPAR.LE.0 ) RETURN             ! Check error from DDMRADEQL
C
C     Calculate coefficients
C
      SH      = Y(jH)*Y(jH)
C     R1
      C1      = 1.0 + 13.0*Y(jH)
      R1XH2O2 = Y(jHSO3  )*Y(jH)/C1
      R1XHSO3 = Y(jH2O2aq)*Y(jH)/C1
      R1XH    = Y(jH2O2aq)*Y(jHSO3  )/(C1*C1)
C     R2
      R2XSO2  = -RO3A*Y(jO3aq)
      R2XHSO3 = -RO3B*Y(jO3aq)
      R2XSO3  = -RO3C*Y(jO3aq)
      R2XO3   = -RO3A*Y(jSO2aq)-RO3B*Y(jHSO3)-RO3C*Y(jSO3)
C     R3
      RO2A    = -750.0*MN -2600.0*FE
      C1      = 1.0 + 75.0*(TS6**0.67)
      IF (BB.GE.4.2) THEN
        RO2B  = -2.51E13*MN*FE
        R3XSIV = (RO2A + RO2B*(Y(jH)**0.67))/C1
        R3XH   = (0.67*RO2B*SIV/(Y(jH)**0.33))/C1
      ELSE
        RO2B  = -3.72E7 *MN*FE
        R3XSIV = (RO2A + RO2B/(Y(jH)**0.74))/C1
        R3XH   = (-0.74*RO2B*SIV/(Y(jH)**1.74))/C1
      ENDIF
      R3XSVI = -R3XSIV*SIV*(0.67*75.0/(TS6**0.33))/C1
C     R4
      R4XH    = Y(jMHPaq)*Y(jHSO3)
      R4XHSO3 = Y(jH)*Y(jMHPaq)
      R4XMHP  = Y(jH)*Y(jHSO3)
C     R5
      C1      = -RPAA*Y(jH) -7.0E2
      R5XH    = -RPAA*Y(jPAAaq)*Y(jHSO3)
      R5XHSO3 = C1*Y(jPAAaq)
      R5XPAA  = C1*Y(jHSO3)

      DO J = 1, NDDMSP
        XSIV = XMAT(jSO2aq,J) + XMAT(jHSO3,J) + XMAT(jSO3,J)
        XSVI =                  XMAT(jHSO4,J) + XMAT(jSO4,J)
C
C     Oxidation by H2O2
C
        DR1 = -RH2O2 * ( R1XH2O2 * XMAT(jH2O2aq,J)
     &                 + R1XHSO3 * XMAT(jHSO3  ,J)
     &                 + R1XH    * XMAT(jH     ,J) )
C
C     Oxidation by O3
C
        DR2 = R2XSO2  * XMAT(jSO2aq,J)
     &      + R2XHSO3 * XMAT(jHSO3 ,J)
     &      + R2XSO3  * XMAT(jSO3  ,J)
     &      + R2XO3   * XMAT(jO3aq ,J)
C
C     Oxidation by O2 catalyzed by Fe and Mn ions
C
        DR3 = R3XSIV * XSIV
     &      + R3XH   * XMAT(jH  ,J)
     &      + R3XSVI * XSVI
C
C     Oxidation by MHP
C
        DR4 = -RMHP  * ( R4XH    * XMAT(jH     ,J)
     &                 + R4XHSO3 * XMAT(jHSO3  ,J)
     &                 + R4XMHP  * XMAT(jMHPaq ,J) )
C
C     Oxidation by PAA
C
        DR5 = R5XH    * XMAT(jH    ,J)
     &      + R5XHSO3 * XMAT(jHSO3 ,J)
     &      + R5XPAA  * XMAT(jPAAaq,J)
C
C     Oxidation of total S(IV)
C
        DR0 = DR1 + DR2 + DR3 + DR4 + DR5
C
C     GLY + OH
C
        DR6 = -RGLY3  * ( Y(jGLYaq ) * XMAT(jHOaq  ,J)
     &                  + Y(jHOaq  ) * XMAT(jGLYaq ,J) )
C
C     MGLY + OH
C
        DR7 = -RMGLY3 * ( Y(jMGLYaq) * XMAT(jHOaq  ,J)
     &                  + Y(jHOaq  ) * XMAT(jMGLYaq,J) )
C
C     GLYD + OH
C
        DR8 = -RGLYD3 * ( Y(jGLYDaq) * XMAT(jHOaq  ,J)
     &                  + Y(jHOaq  ) * XMAT(jGLYDaq,J) )
C
C     Update SINI
C
        SINI(jTH2O2,J) = SINI(jTH2O2,J) + DR1 * DTW * DSIV_SCALE
        SINI(jTO3  ,J) = SINI(jTO3  ,J) + DR2 * DTW * DSIV_SCALE
        SINI(jTMHP ,J) = SINI(jTMHP ,J) + DR4 * DTW * DSIV_SCALE
        SINI(jTPAA ,J) = SINI(jTPAA ,J) + DR5 * DTW * DSIV_SCALE
        SINI(jTSO2 ,J) = SINI(jTSO2 ,J) + DR0 * DTW * DSIV_SCALE
        SINI(jTSVI ,J) = SINI(jTSVI ,J) - DR0 * DTW * DSIV_SCALE
        SINI(jTGLY ,J) = SINI(jTGLY ,J) + DR6 * DTW
        SINI(jTMGLY,J) = SINI(jTMGLY,J) + DR7 * DTW
        SINI(jTGLYD,J) = SINI(jTGLYD,J) + DR8 * DTW
        SINI(jTSOAC,J) = SINI(jTSOAC,J) - (YGLY*DR6 + YMGLY*DR7 + YGLYD*DR8) * DTW
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMRADRXN

c**** NCF_WRT_GLOBAL_SA
c
      subroutine ncf_wrt_global_sa(action,iounit)
      use ncf_iomod
      use grid
      use filunit
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the Global attributes that are specific to
c   SA to the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action    C  name of file to open
c           iounit    I  NetCDF file ID of file
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
      include 'flags.inc'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ierr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'PROBING_TOOL', 10, tectyp)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( SA_Summary_Output ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'SUMMARY_OUTPUT',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'SUMMARY_OUTPUT',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lsulfate ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_SULFATE_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_SULFATE_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lnitrate ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_NITRATE_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_NITRATE_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lsoa ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_SOA_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_SOA_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lprimary ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_PRIMARY_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_PRIMARY_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lmercury ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_MERCURY_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_MERCURY_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lozone ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_OZONE_CLASS',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TREAT_OZONE_CLASS',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lapca ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_APCA', 
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_APCA',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lbndry ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'STRATIFY_BOUNDARY',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'STRATIFY_BOUNDARY',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lptdepout ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'DEPOSITION_OUTPUT',
     &                                                     NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'DEPOSITION_OUTPUT',
     &                                                     NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NUMBER_SOURCE_REGIONS',
     &                                                 NF_INT, 1, nregin)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NUMBER_SOURCE_GROUPS',
     &                                                 NF_INT, 1, ngroup)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( leftovr_area ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_LEFTOVER_GROUP',
     &                                                    NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_LEFTOVER_GROUP',
     &                                                    NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lpartial ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_PARTIAL_REGIONMAP',
     &                                                    NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'USE_PARTIAL_REGIONMAP',
     &                                                    NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      if( lptoverride ) then
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'POINT_SOURCE_OVERRIDE',
     &                                                    NF_INT, 1, 1)
      else
         ierr = nf_put_att_int(iounit, NF_GLOBAL, 'POINT_SOURCE_OVERRIDE',
     &                                                    NF_INT, 1, 0)
      endif
      if( ierr .NE. NF_NOERR ) goto 7000
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_GLOBAL_SA:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot write global atttributes to file.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

      subroutine uptime(time,date,deltat)
      implicit none
c
c----CAMx v7.40 260801
c
c     UPTIME increments simulation time/date for the given time step
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        time            current simulation time (HHMMM)
c        date            current simulation date (YYJJJ)
c        deltat          current model coarse grid timestep (s)
c
c     Output arguments:
c        time            new simulation time (HHMMM)
c        date            new simulation date (YYJJJ)
c
c     Routines called:
c        none
c
c     Called by:
c        CAMx
c
      integer date
      real    tmin
      real    deltat
c
      real time, hour
      real fuzz
c
c-----Entry point
c
      hour = aint(time/100.)
      tmin = time - 100.*hour
      tmin = tmin + deltat/60.
      fuzz = max(0.02,0.1*(deltat/60.))
      if (tmin.ge.60.-fuzz .and. tmin.le.60.+fuzz) then
        tmin = 0.
        hour = hour + 1.
        if (hour.ge.24.) then
          hour = hour - 24.
          date = date + 1
          if( MOD(date,1000) .GT. 365 ) then
             if( MOD(INT(date/1000),4) .EQ. 0 ) then
                if( MOD(date,1000) .EQ. 367 )
     &                     date = (INT(date/1000)+1)*1000 + 1
             else
                date = (INT(date/1000)+1)*1000 + 1
             endif
          endif
        endif
      endif
c
      time = 100.*hour + tmin
c
      return
      end

c*** RECALIB
c
      subroutine recalib(numcol,numrow,numlay,nspc,saconc,icl,jcl,kzcl,modcon)
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine recalibrates the tracer concentrations back to
c     the levels calculated in the regular model.  This is necessary
c     because the numerical algorithms used in the transport steps
c     cause the tracer species to stray from the regular model.
c     This is due to the sharp gradients at model boundary cells
c     and between source regions.  The regular model does not stratify
c     the concentrations by source region so these gradients do not 
c     appear in the regular model.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol  I  number of cells in X direction
c       numrow  I  number of cells in Y direction
c       numlay  I  number of layers
c       nspc    I  number of tracer species
c       saconc  R  tracer concentration array
c       icl     I  the X grid location of current cell
c       jcl     I  the Y grid location of current cell
c       kzcl    I  the vertical grid location of current layer
c       modcon  R  regular model concentrations
c
c     Modifications:
c       05/03/07   Added code to check for lower bound before 
c                  applying adjustment -- adjustment now only applied
c                  to the "significant" sources     
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer numlay
      integer nspc
      real    saconc(numcol,numrow,numlay,nspc)
      integer icl
      integer jcl
      integer kzcl
      real    modcon(*)
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c    FUZZ - fuzz value for comparing against lower bound
c
      real FUZZ
c
      parameter( FUZZ = 10.0 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer i
      real    modcls(MXALCLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- caluclate the conentrations for each tracer class ---
c
      do i=1,ntrcls
        modcls(i) = 0.
      enddo
      do ispc=1,nspec
        do i=1,ntrcls
           modcls(i) = modcls(i) + modcon(ispc) * fluxmap(ispc,i)
        enddo
      enddo
c
c  --- calculate the sum of the tracer species ----
c
      do icls=1,ntrcls
         trval = 0.
         if( npttrc(icls) .GT. 0. ) then
            do i=ipttrc(icls),npttrc(icls) 
               if( saconc(icl,jcl,kzcl,i) .GT. FUZZ*BNDLPT )
     &                       trval = trval + saconc(icl,jcl,kzcl,i)
            enddo
c
c   --- recalibrate the tracers, if necessary ---
c
            if( trval .NE. modcls(icls) .AND. trval .GT. 0 ) then
               do i=ipttrc(icls),npttrc(icls)
                  if( saconc(icl,jcl,kzcl,i) .GT. FUZZ*BNDLPT )
     &               saconc(icl,jcl,kzcl,i) = saconc(icl,jcl,kzcl,i) +
     &                                      ( modcls(icls) - trval ) *
     &                                  saconc(icl,jcl,kzcl,i) / trval
                  saconc(icl,jcl,kzcl,i) = 
     &                             MAX(saconc(icl,jcl,kzcl,i),BNDLPT)
                enddo
            endif
         endif
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      REAL FUNCTION HLCONST ( NAME, TEMP )

C-----------------------------------------------------------------------
C
C  FUNCTION: return the Henry's law constant for the specified substance
C            at the given temperature
C
C  revision history:
C    who        when           what
C  ---------  --------  -------------------------------------
C  S.Roselle  08/15/97  code written for Models-3
C  J.Gipson   06/18/01  added Henry's Law constants 50-55 for saprc99
C  W.Hutzell  07/03/01  added Henry's Law constants 56-57 for Atrazine
C                       and the daughter products from Atrazine and OH
C                       reactions.
C-----------------------------------------------------------------------

      IMPLICIT NONE

C...........INCLUDES and their descriptions

c      INCLUDE SUBST_IODECL    ! I/O definitions and declarations

C...........PARAMETERS and their descriptions:

      INTEGER       MXSPCS              ! Number of substances
      PARAMETER   ( MXSPCS = 59 )

C...........ARGUMENTS and their descriptions

      CHARACTER*(*) NAME                ! name of substance
      REAL          TEMP                ! temperature (K)

C...........SCRATCH LOCAL VARIABLES and their descriptions:

      CHARACTER*16  SUBNAME( MXSPCS )   ! list of substance names
      SAVE          SUBNAME

      INTEGER       SPC                 ! species index

      REAL          A( MXSPCS )         ! Henry's law constants at 298.15K (M/atm)
      SAVE          A
      REAL          E( MXSPCS )         ! enthalpy (like activation energy) (K)
      SAVE          E

C...........EXTERNAL FUNCTIONS and their descriptions:

      INTEGER       HLINDEX

c***********************************************************************
      DATA SUBNAME(  1), A(  1), E(  1) 
     &     / 'O3              ', 1.2E-02, 2.7E+03 /  ! Chameides 1984
      DATA SUBNAME(  2), A(  2), E(  2) 
     &     / 'HO2             ', 9.0E+03, 0.0E+00 /  ! Chameides 1984
      DATA SUBNAME(  3), A(  3), E(  3) 
     &     / 'H2O2            ', 9.7E+04, 6.6E+03 /  ! Chameides 1984
      DATA SUBNAME(  4), A(  4), E(  4) 
     &     / 'NH3             ', 5.8E+01, 4.1E+03 /  ! Chameides 1984
      DATA SUBNAME(  5), A(  5), E(  5) 
     &     / 'NO              ', 1.9E-03, 1.4E+03 /  ! Lide and Frederikse 1995
      DATA SUBNAME(  6), A(  6), E(  6) 
     &     / 'NO2             ', 1.2E-02, 2.5E+03 /  ! Chameides 1984
      DATA SUBNAME(  7), A(  7), E(  7) 
     &     / 'NO3             ', 1.2E+01, 1.9E+03 /  ! Chameides 1984
      DATA SUBNAME(  8), A(  8), E(  8) 
     &     / 'N2O5            ', 1.0E+30, 0.0E+00 /  ! "inf" Sander and Crutzen 1996
      DATA SUBNAME(  9), A(  9), E(  9) 
     &     / 'HNO2            ', 4.9E+01, 4.8E+03 /  ! Chameides 1984
      DATA SUBNAME( 10), A( 10), E( 10) 
     &     / 'HNO3            ', 2.6E+06, 8.7E+03 /  ! Chameides 1984
      DATA SUBNAME( 11), A( 11), E( 11) 
     &     / 'HNO4            ', 2.0E+04, 0.0E+00 /  ! Jacob et al. 1989
      DATA SUBNAME( 12), A( 12), E( 12) 
     &     / 'SO2             ', 1.2E+00, 3.1E+03 /  ! Chameides 1984
      DATA SUBNAME( 13), A( 13), E( 13) 
     &     / 'H2SO4           ', 1.0E+30, 0.0E+00 /  ! infinity
      DATA SUBNAME( 14), A( 14), E( 14) 
     &     / 'METHANE         ', 1.3E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 15), A( 15), E( 15) 
     &     / 'ETHANE          ', 2.0E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 16), A( 16), E( 16) 
     &     / 'PROPANE         ', 1.4E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 17), A( 17), E( 17) 
     &     / 'BUTANE          ', 1.1E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 18), A( 18), E( 18) 
     &     / 'PENTANE         ', 8.1E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 19), A( 19), E( 19) 
     &     / 'HEXANE          ', 6.0E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 20), A( 20), E( 20) 
     &     / 'OCTANE          ', 3.4E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 21), A( 21), E( 21) 
     &     / 'NONANE          ', 2.0E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 22), A( 22), E( 22) 
     &     / 'DECANE          ', 1.4E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 23), A( 23), E( 23) 
     &     / 'ETHENE          ', 4.7E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 24), A( 24), E( 24) 
     &     / 'PROPENE         ', 4.8E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 25), A( 25), E( 25) 
     &     / 'ISOPRENE        ', 1.3E-02, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 26), A( 26), E( 26) 
     &     / 'ACETYLENE       ', 4.1E-02, 1.8E+03 /  ! Wilhelm et al. 1977
      DATA SUBNAME( 27), A( 27), E( 27) 
     &     / 'BENZENE         ', 1.8E-01, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 28), A( 28), E( 28) 
     &     / 'TOLUENE         ', 1.5E-01, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 29), A( 29), E( 29) 
     &     / 'O-XYLENE        ', 2.0E-01, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 30), A( 30), E( 30) 
     &     / 'METHANOL        ', 2.2E+02, 0.0E+00 /  ! Snider and Dawson 1985
      DATA SUBNAME( 31), A( 31), E( 31) 
     &     / 'ETHANOL         ', 1.6E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 32), A( 32), E( 32) 
     &     / '2-CRESOL        ', 8.2E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 33), A( 33), E( 33) 
     &     / '4-CRESOL        ', 1.3E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 34), A( 34), E( 34) 
     &     / 'METHYLHYDROPEROX', 3.1E+02, 5.2E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 35), A( 35), E( 35) 
     &     / 'FORMALDEHYDE    ', 7.0E+03, 6.4E+03 /  ! Chameides 1984
      DATA SUBNAME( 36), A( 36), E( 36) 
     &     / 'ACETALDEHYDE    ', 1.3E+01, 5.7E+03 /  ! Benkelberg et al. 1995
      DATA SUBNAME( 37), A( 37), E( 37) 
     &     / 'GENERIC_ALDEHYDE', 4.2E+03, 0.0E+00 /  ! Graedel and Goldberg 1983
!pk      DATA SUBNAME( 38), A( 38), E( 38) 
!pk     &     / 'GLYOXAL         ', 3.6E+05, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 38), A( 38), E( 38) 
     &     / 'GLYOXAL         ', 4.2E+05, 7.5E+03 /  ! Ip et al., 2009
!pk
      DATA SUBNAME( 39), A( 39), E( 39) 
     &     / 'ACETONE         ', 3.2E+01, 5.8E+03 /  ! Betterton 1991
      DATA SUBNAME( 40), A( 40), E( 40) 
     &     / 'FORMIC_ACID     ', 3.7E+03, 5.7E+03 /  ! Chameides 1984
      DATA SUBNAME( 41), A( 41), E( 41) 
     &     / 'ACETIC_ACID     ', 5.2E+03, 0.0E+00 /  ! Johnson et al. 1996
!pk      DATA SUBNAME( 42), A( 42), E( 42) 
!pk     &     / 'METHYL_GLYOXAL  ', 3.2E+04, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 42), A( 42), E( 42) 
     &     / 'METHYL_GLYOXAL  ', 3.7E+03, 7.5E+03 /  ! Betterton and Hoffmann 1988
!pk
      DATA SUBNAME( 43), A( 43), E( 43) 
     &     / 'CO              ', 9.5E-04, 1.3E+03 /  ! Wilhelm et al. 1977
      DATA SUBNAME( 44), A( 44), E( 44) 
     &     / 'CO2             ', 3.1E-02, 2.4E+03 /  ! Chameides 1984
      DATA SUBNAME( 45), A( 45), E( 45) 
     &     / 'PAN             ', 2.9E+00, 5.9E+03 /  ! Pandis and Seinfeld 1989
      DATA SUBNAME( 46), A( 46), E( 46) 
     &     / 'MPAN            ', 1.7E+00, 0.0E+00 /  ! Kames and Schurath 1995
      DATA SUBNAME( 47), A( 47), E( 47) 
     &     / 'OH              ', 3.0E+01, 4.5E+03 /  ! Hanson et al. 1992
      DATA SUBNAME( 48), A( 48), E( 48) 
     &     / 'METHYLPEROXY_RAD', 2.0E+03, 6.6E+03 /  ! Lelieveld and Crutzen 1991
      DATA SUBNAME( 49), A( 49), E( 49) 
     &     / 'PEROXYACETIC_ACI', 8.4E+02, 5.3E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 50), A( 50), E( 50) 
     &     / 'PROPANOIC_ACID  ', 5.7E+03, 0.0E+00 /  ! Kahn et al. 1995
      DATA SUBNAME( 51), A( 51), E( 51) 
     &     / '2-NITROPHENOL   ', 7.0E+01, 4.6E+03 /  ! USEPA 1982
      DATA SUBNAME( 52), A( 52), E( 52) 
     &     / 'PHENOL          ', 1.9E+03, 7.3E+03 /  ! USEPA 1982
      DATA SUBNAME( 53), A( 53), E( 53) 
     &     / 'BIACETYL        ', 7.4E+01, 5.7E+03 /  ! Betteron 1991
      DATA SUBNAME( 54), A( 54), E( 54) 
     &     / 'BENZALDEHYDE    ', 4.2E+01, 4.6E+03 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 55), A( 55), E( 55) 
     &     / 'PINENE          ', 4.9E-02, 0.0E+00 /  ! Karl and Lindinger 1997
      DATA SUBNAME( 56), A( 56), E( 56) 
     &     / 'ATRA            ', 4.1E+05, 6.0E+03 /  ! CIBA Corp (1989) and Scholtz (1999)
      DATA SUBNAME( 57), A( 57), E( 57) 
     &     / 'DATRA           ', 4.1E+05, 6.0E+03 /  ! assumed same as Atrazine
      DATA SUBNAME( 58), A( 58), E( 58) 
     &     / 'ADIPIC_ACID     ', 2.0E+08, 0.0E+00 /  ! Saxena and Hildemann (1996)
!pk
      DATA SUBNAME( 59), A( 59), E( 59) 
     &     / 'GLYCOLALDEHYDE  ', 4.1E+04, 4.6E+03 /  ! Betterton and Hoffmann (1988)
!pk

C-----------------------------------------------------------------------
C  begin body of subroutine HLCONST

      SPC = HLINDEX( NAME, MXSPCS, SUBNAME )

      IF ( SPC .GT. 0 ) THEN
        HLCONST = A( SPC ) * EXP( E( SPC )
     &          * ( ( 298.0 - TEMP) / ( 298.0 * TEMP) ) )
      ELSE
        HLCONST = 0.0
      END IF

      RETURN
      END              

c*** DLSDRV
c
      subroutine dlsdrv(dtin,H2O,atm,O2,CH4,H2,conc,rtconc,
     &                  ierr,lpig)
      use chmstry
      use filunit
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Call the DLSODE solver for RTRAC CMC chemistry
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Input arguments:
c       dtin              time duration to be integrated (hr)
c       H2O               water vapor concentration (ppm)
c       atm               total gas concentration (M) in ppm
c       O2                oxygen concentration (ppm)
c       CH4               methane concentration (ppm)
c       H2                hydrogen concentration (ppm)
c       conc              state species concentrations (ppm)
c       lpig              PiG chemistry flag (T=puff chemistry)
c
c      Output arguments:
c       conc              state species concentrations (ppm)
c       ierr              error flag (=1 if LSODE reports error)
c
c     Routines called:
c      DLSODE
c      DPREPSLO
c      DSLOCMC
c      DEQMCMC
c      CAMXERR
c
c     Called by:
c      CHEMDRIV
c      PIGDRIVE
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include "camx.prm"
c
c --- lsode common block
c
      integer   mesflg, lunit
      common    /ehd001/ mesflg, lunit
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real     dtin, H2O, atm, O2, CH4, H2
      real     conc(MXSPEC+1), rtconc(MXTRSP)
      integer  ierr
      logical  lpig
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      external dratecmc, djaccmc
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      integer   LSDIM, LIW, LRW, ITOL
      parameter (LSDIM = MXTRSP)
      parameter (LIW = LSDIM + 20)
      parameter (LRW = LSDIM*LSDIM + 9*LSDIM + 22)
      parameter (ITOL = 1)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, mf
      integer   itask, istate, iopt, neq
      integer   iwork(LIW) 
      real*8    datol, drtol
      real*8    rrdt(MXRX), rrxn(MXRX)
      real*8    t, tout, fixed(6+mxspec)
      real*8    y(MXTRSP+MXSPEC), y0(MXTRSP+MXSPEC),
     &          rwork(LRW), rr(MXRX), ydd(LSDIM)
      logical   lrr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Optional diagnostic calculation of integrated reaction rates
c
      lrr = .false.
      if (lrr) then
         do i = 1,nrxnrtc
            rrdt(i) = 0.0D0
         enddo
      endif
c
c --- Zero the working array elements that can pass options to LSODE
c
      do i=1,12
        rwork(i) = 0.D0
        iwork(i) = 0
      enddo
c
c --- Load concentrations for LSODE
c
      do i = 1,ngasrtc
         y(i) = DBLE( rtconc(i) )
         y0(i) = y(i)
      enddo
c
      if( nfixrtc. GT. 0 ) then
         fixed(1) = atm
         fixed(2) = O2
         fixed(3) = atm-O2
         fixed(4) = H2O
         fixed(5) = H2
         fixed(6) = CH4
         if( ngas. GT. 0 ) then
            do i = 1,ngas
               fixed(6+i) = conc(i)
            enddo
         endif
         do i = 1,nfixrtc
            y(i+ngasrtc) = DBLE( fixed( idxfix(i+ngasrtc)) )
            y0(i+ngasrtc) = y(i+ngasrtc)
         enddo
      endif
c
c --- Set integration parameters for LSODE
c     mf sets Jacobian method: 21 = numeric, 22 = algebraic
c
      mf = 20 + ijac
      t = 0.D0 
      tout = DBLE( dtin )
      itask = 1 
      istate = 1 
      iopt = 0 
      lunit = idiag
      neq = nfstrtc
      drtol = DBLE(rtolrtc)
      datol = DBLE(atolrtc)
c
c --- Call LSODE to advance the fast species
c     Equilibrium species (if any) are solved within LSODE 
c     Slow species (if any) are advanced using the mid-point fast/eqm 
c     concentrations
c
      if( nslortc .LT. 1) then
        call dlsode(dratecmc,neq,y,t,tout,ITOL,drtol,datol,itask,istate,
     1       iopt,rwork,LRW,iwork,LIW,djaccmc,mf,lrr,nrxnrtc,rrxn,rrdt,
     2       ydd)
        if (istate .lt. 0) go to 900 
      else
        tout = tout/2.D0
        call dlsode(dratecmc,neq,y,t,tout,ITOL,drtol,datol,itask,istate,
     1       iopt,rwork,LRW,iwork,LIW,djaccmc,mf,lrr,nrxnrtc,rrxn,rrdt,
     2       ydd) 
        if( istate .LT. 0) go to 900 
        call dprepslo(y,rr)
        tout = DBLE( dtin )
        call dlsode(dratecmc,neq,y,t,tout,ITOL,drtol,datol,itask,istate,
     1       iopt,rwork,LRW,iwork,LIW,djaccmc,mf,lrr,nrxnrtc,rrxn,rrdt,
     2       ydd) 
        if( istate .LT. 0) go to 900 
        call dslocmc(y,rr,tout)
      endif
      if( neqmrtc .GT. 0) call deqmcmc(y,rr,.false.,.false.)
c
c --- Save species concentrations in CAMx arrays
c
      do i = 1,ngasrtc
         rtconc(i) = MAX(1.0E-18, SNGL( y(i) ))
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error handling:
c-----------------------------------------------------------------------
c
 900  if (lpig) then 
        ierr = 1
        return
      else
        write(iout,'(//,A)') ' ERROR in DLSDRV:'
        write(iout,'(/,A,I3,/,A)') ' LSODE reporting ISTATE = ',
     &     istate, ' Look up this ISTATE code in the LSODE source code'
        write(iout,901) rwork(11),rwork(12),rwork(13),dtin
        write(iout,902) iwork(12),iwork(13),iwork(11)
 901    format(/,'   last step size  = ', D12.3,/
     &           '   next step size  = ', D12.3,/
     &           '   current time    = ', D12.3,/
     &           '   total time step = ', D12.3)
 902    format('   # of steps ',i4,' # of f-s ',i4,' # of j-s ',i4)
        write(iout,'(/,A7,A10,2A12)')
     &        'Species','Name','C(t)','C(0)'
        write(iout,'(I5,3X,A10,2X,1P2E12.3)')
     &       (j,spnmrt(j),y(j),y0(j),j=1,ngasrtc+nfixrtc)
        call camxerr()
      endif
c
      end 

c**** RDICDDM.F
c
      subroutine rdicddm(nox,noy,noz,nspsa,saconc)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fils one hour of initial conditions for the DDM
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c   The values are left in PPM so that they can be interpolated to
c   the nests in a later step.
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  tracer concentrations
c       Inputs:
c           nox      I  number of X cells in the grid
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspsa    I  number of tracer species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/31/99   --gwilson--    Original development
c     10/24/01  Removed BSWAP and converted integer strings to character*4
c     07/16/07   --bkoo--       Added HRVOC
c     11/28/16   --bkoo--       Fixed a time check bug
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c  External functions:
c-----------------------------------------------------------------------
c
      integer ncf_chkfile
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10 aqfil, cfile, cspec
      character*4  ifile(10), note(60), ispec(10)
      integer      ispc, ifirst, iddm, i, j, n
      integer      iseg, nspc, idat1, idat2, ierr
      integer      izone, nx, ny, nz, ilay, idum, imod, isoa
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
      logical      lexist, luse
c
      real concic(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data aqfil /'AIRQUALITY'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- open the IC ---
c
      inquire(file=icfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening DDM Initial Conditions file.'
      ierr = ncf_chkfile(ioric,icfil,action,aqfil)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(file=icfil,unit=ioric,status='UNKNOWN',
     &                                   form='UNFORMATTED',ERR=7001)
      else
         return
      endif
c
c  --- call routine to zero out the array ---
c
      call zeros(saconc,nox*noy*noz*nspsa)
c
c  --- read 1st IC header record and check inputs ---
c
      read(ioric,ERR=7002) ifile,note,iseg,nspc,idat1,tim1,idat2,tim2
      write(cfile,'(10A1)') (ifile(i),i=1,10)
      if( cfile .NE. aqfil ) goto 7003
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. begdate .AND. .NOT. le1day ) goto 7004
      if( idat1 .EQ. begdate .AND. tim1 .GT. begtim
     &                              .AND. .NOT. le1day ) goto 7004
c
c  --- read 2nd IC header record and check inputs ---
c
      read(ioric,ERR=7002) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if( .NOT. llatlon ) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if( nx .NE. ncol(1) .OR. ny .NE. nrow(1) 
     &                                .OR. nz .NE. nlay(1) ) goto 7005
c
c  --- skip the next 2 records ---
c
      read(ioric,ERR=7002)
      read(ioric,ERR=7002) 
c
c  --- read the date and time and make sure it is the correct hour ---
c
  111 continue
      read(ioric,ERR=7007,END=7006) idat1, tim1, idat2, tim2
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100*tim1
      tim2 = 100*tim2
      if( (idat1 .LT. begdate .OR. 
     &       (idat1 .EQ. begdate .AND. tim1 .LE. begtim)) .AND.
     &            (idat2 .GT. begdate .OR. 
     &                (idat2 .EQ. begdate .AND. tim2 .GT. begtim))) then
c
c  --- read the concentrations for each species ---
c
         do ispc=1,nspc
c
c   --- loop over layers ---
c
            do ilay=1,nz
               read(ioric) idum,(ispec(n),n=1,10),
     &                                 ((concic(i,j),i=1,nx),j=1,ny)
               write(cspec,'(10A1)') ispec
               if(cspec .EQ. 'HNO2      ') cspec = 'HONO      '
               if(cspec .EQ. 'HCHO      ' .and. kHCHO.eq.nspec+1) 
     &                                            cspec = 'FORM      '
               do isoa=1,NUM_SOAP_SPECIES
                  if( cspec .EQ. soap2_spec_names(isoa) ) 
     &                           cspec = soap3_spec_names(isoa)
               enddo
c
c  --- find this species in the modeled species list ---
c
               do imod=1,nspec
                  if( cspec .EQ. spname(imod) ) then
                      ifirst = iptddm(imod) 
                      do iddm=1,nicddm
                         luse = .FALSE.
                         if( icddmsp(iddm) .EQ. cspec ) luse = .TRUE. 
                         if( icddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE. 
                         if( icddmsp(iddm) .EQ. NAMVOC 
     &                               .AND. lvocsp(imod) ) luse = .TRUE. 
                         if( icddmsp(iddm) .EQ. NAMNOX 
     &                               .AND. lnoxsp(imod) ) luse = .TRUE. 
                         if( icddmsp(iddm) .EQ. NAMHRV
     &                               .AND. lhrvoc(imod) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
                         if( luse ) then
                            do 10 j=2,ny-1
                               do i=2,nx-1
                                  if( concic(i,j) .GE. bdnl(imod) )
     &                               saconc(i,j,ilay,ifirst+iddm-1) = 
     &                                                       concic(i,j)
                               enddo
   10                       continue
                         endif
c
c  --- check the next IC DDM species ---
c
                      enddo
c
c  --- check the next modeled species ---
c
                  endif
               enddo
c
c  --- next layer ---
c
            enddo
c
c  --- read nect species worth of data ---
c
         enddo
c
c  --- if not the right hour, read through it ---
c
      else
         do ispc=1,nspc
            do ilay=1,nz
               read(ioric,ERR=7007) 
            enddo
         enddo
         goto 111
      endif
c
c  --- close the file and return to the calling routine ---
c
      close(ioric)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  IC file for DDM does not exist: ',
     &                                             icfil(:istrln(icfil))
      call camxerr()
c
 7001 continue 
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  Opening IC file for DDM: ',
     &                                             icfil(:istrln(icfil))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  Reading header of IC file for DDM: ',
     &                                             icfil(:istrln(icfil))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  IC input file for DDM is not labelled ',
     &                                                 'AIRQUALITY.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  IC input file for DDM is not for correct ',
     &                                                   'time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',begdate
      write(iout,'(a,f10.1)') 'Time   : ',begtim
      write(iout,*) '   ***  IC File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  IC input file does not appear to be for ',
     &                ' the correct grid.' 
      write(iout,*) '   ***  Coarse Grid ***'
      write(iout,*) 'No. of Cells : (',ncol(1),',',nrow(1),')'
      write(iout,*) 'No. of layers:  ',nlay(1)
      write(iout,*) '   ***  IC File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  Premature end-of-file reached in IC file ',
     &                                                      'for DDM.'
      write(iout,*) 'Make sure the file contains the correct date/time.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDICDDM:'
      write(iout,*) 'ERROR:  Reading IC file for DDM: ',
     &                                             icfil(:istrln(icfil))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine node_get_feed(ifm,icm,dx,dy,depths)                                 
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACKP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
      real    :: dx(*)
      real    :: dy
      real    :: depths(mmxp(icm),mmyp(icm),mmzp(icm))
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: k1crs
      integer :: k2crs
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: nfz
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r 
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(nspec)
c
      real, save, allocatable :: pbuff(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, nspec
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0 
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            
            call par_assoc_buff(node_buffs(nm)%lbc_recv_buff(1),
     &                          node_buffs(nm)%nrecv            )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(k1crs,1)
            call par_get_int(k2crs,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff)) deallocate (pbuff)
               allocate (pbuff(nwds))
               nbuff_save=nwds
            endif    
            call par_get_float(pbuff,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            nfz=k2crs-k1crs+1
            mtp=nfx*nfy*nfz
            iptr=0
            do nv=1,nspec
               ispbeg=iptr4d(icm)+(nv-1)*mmzp(icm)*mmxp(icm)*mmyp(icm)
               call unfdbackp(conc(ispbeg),pbuff(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mmzp(icm),
     &                        mi0(icm),mj0(icm),i1s,i2s,j1s,j2s,
     &                        k1crs,k2crs,mynum,nspec,nv,firstime,
     &                        commcl,ncol(icm),nrow(icm),dx,dy,depths         )
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c---------------------------------------------------------------------
c    END subroutine node_get_feed:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_dp
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_dp(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the deposition velocities.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node. 
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r 
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(navspc*3)
c
      real, save, allocatable :: pbuff_dp(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_dp(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_dp(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, navspc*3
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0 
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_dp_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_dp)) deallocate (pbuff_dp)
               allocate (pbuff_dp(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_dp,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,navspc*3
               ispbeg=iptrdp(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(depfld(ispbeg),pbuff_dp(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,navspc*3,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_dp
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_smsol
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_smsol(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the surface model.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node.
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(nsmspc)
c
      real, save, allocatable :: pbuff_smsol(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_smsol(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_smsol(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, nsmspc
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_smsol_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_smsol)) deallocate (pbuff_smsol)
               allocate (pbuff_smsol(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_smsol,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,nsmspc
               ispbeg=iptrsm(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(solmas(ispbeg),pbuff_smsol(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,nsmspc,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_smsol
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_smveg
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_smveg(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the surface model.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node.
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(nsmspc)
c
      real, save, allocatable :: pbuff_smveg(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_smveg(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_smveg(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, nsmspc
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_smveg_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_smveg)) deallocate (pbuff_smveg)
               allocate (pbuff_smveg(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_smveg,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,nsmspc
               ispbeg=iptrsm(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(vegmas(ispbeg),pbuff_smveg(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,nsmspc,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_smveg
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_dry
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_dry(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the dry deposition for tracers.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node. 
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r 
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(ntotsp)
c
      real, save, allocatable :: pbuff_dry(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_dry(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_dry(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, ntotsp
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0 
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_dry_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_dry)) deallocate (pbuff_dry)
               allocate (pbuff_dry(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_dry,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,notimespc
               ispbeg=ipsadep(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(ptdryfld(ispbeg),pbuff_dry(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,notimespc,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_dry
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_wet
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_wet(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the wet deposition for tracers.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node. 
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r 
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(ntotsp)
c
      real, save, allocatable :: pbuff_wet(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_wet(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_wet(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, ntotsp
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0 
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_wet_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_wet)) deallocate (pbuff_wet)
               allocate (pbuff_wet(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_wet,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,notimespc
               ispbeg=ipsadep(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(ptwetfld(ispbeg),pbuff_wet(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,notimespc,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_wet
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_pt
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_pt(ifm,icm,dx,dy,depths)                               
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        probing tool
c
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node. 
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACKP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
      real    :: depths(mmxp(icm),mmyp(icm),mmzp(icm))
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: k1crs
      integer :: k2crs
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: nfz
      integer (kind=8) :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r 
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(ntotsp)
c
      real, save, allocatable :: pbuff_pt(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_pt(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_pt(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, ntotsp
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0 
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_assoc_buff(node_buffs(nm)%lbc_pt_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(k1crs,1)
            call par_get_int(k2crs,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_pt)) deallocate (pbuff_pt)
               allocate (pbuff_pt(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_pt,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            nfz=k2crs-k1crs+1
            mtp=nfx*nfy*nfz
            iptr=0
            do nv=1,ntotsp
               ispbeg=ipsa3d(icm)+DBLE(nv-1)*DBLE(mmzp(icm))*DBLE(mmxp(icm))*DBLE(mmyp(icm))
               call unfdbackp(ptconc(ispbeg),pbuff_pt(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mmzp(icm),
     &                        mi0(icm),mj0(icm),i1s,i2s,j1s,j2s,
     &                        k1crs,k2crs,mynum,ntotsp,nv,firstime,
     &                        commcl,ncol(icm),nrow(icm),dx,dy,depths         )
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_pt
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_rtsol
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_rtsol(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use rtracchm
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the RTRAC surface model.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node.
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(ntotsp)
c
      real, save, allocatable :: pbuff_rtsol(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_rtsol(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_rtsol(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, ntotsp
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_rtsol_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_rtsol)) deallocate (pbuff_rtsol)
               allocate (pbuff_rtsol(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_rtsol,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,ntotsp
               ispbeg=ipsa2d(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(rtsolmas(ispbeg),pbuff_rtsol(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,ntotsp,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_rtsol
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_get_feed_rtveg
c-----------------------------------------------------------------------
c
      subroutine node_get_feed_rtveg(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use rtracchm
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the RTRAC surface model.
c        Get the portion of the coarse grid subdomain that will be filled
c        with fine grid info from each node.
c
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_WAIT
c       PAR_ASSOC_BUFF
c       PAR_GET_INT
c       PAR_GET_FLOAT
c       UNFDBACK_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: icm
      integer :: ifm
c
      real    :: dx(*)
      real    :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: nfx
      integer :: nfy
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: nv
      integer :: iptr
      integer :: nvar
      integer :: ibytes
      integer :: msgid
      integer :: ihostnum
      integer :: machf
      integer :: nwds
      integer :: n
      integer :: c
      integer :: r
      integer :: commcl(ncol(icm),nrow(icm))
c
      logical :: firstime(ntotsp)
c
      real, save, allocatable :: pbuff_rtveg(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      itype=6
c
c  --- make sure all sends are finished and send arrays are de-allocated ---
c
      do nm=1,nmachs
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            call par_wait(isend_req_rtveg(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
c  --- wait on receives ---
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            call par_wait(irecv_req_rtveg(nm),ibytes,msgid,ihostnum)
         endif
      enddo
c
      do n=1, ntotsp
         firstime = .true.
      enddo
      do c=1, ncol(icm)
         do r=1, nrow(icm)
            commcl(c,r) = 0
         enddo
      enddo
c
      do nm=1,nmachs
         if (iget_paths(itype,ifm,nm) .ne. 0) then

            call par_assoc_buff(node_buffs(nm)%lbc_rtveg_recv_buff(1),
     &                          node_buffs(nm)%nrecv               )
            call par_get_int(i1s,1)
            call par_get_int(i2s,1)
            call par_get_int(j1s,1)
            call par_get_int(j2s,1)
            call par_get_int(machf,1)
            call par_get_int(nvar,1)
            call par_get_int(nwds,1)
            if (nwds > nbuff_save) then
               if (allocated(pbuff_rtveg)) deallocate (pbuff_rtveg)
               allocate (pbuff_rtveg(nwds))
               nbuff_save=nwds
            endif
            call par_get_float(pbuff_rtveg,nwds)
            do c=i1s, i2s
               do r=j1s, j2s
                  commcl(c,r) = commcl(c,r) + 1
               enddo
            enddo
c
            nfx=i2s-i1s+1
            nfy=j2s-j1s+1
            mtp=nfx*nfy
            iptr=0
            do nv=1,ntotsp
               ispbeg=ipsa2d(icm)+(nv-1)*mmyp(icm)*mmxp(icm)
               call unfdback_dp(rtvegmas(ispbeg),pbuff_rtveg(1+iptr),mtp,
     &                        mmxp(icm),mmyp(icm),mi0(icm),mj0(icm),
     &                        i1s,i2s,j1s,j2s,mynum,ntotsp,nv,
     &                        firstime,commcl,ncol(icm),nrow(icm),dx,dy)
               iptr=iptr+mtp
            enddo
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_get_feed_rtveg
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine unfdbackp
c-----------------------------------------------------------------------
c
      subroutine unfdbackp(ac,acf,mtp,m1,m2,m3,
     &                     i0,j0,
     &                     i1s,i2s,j1s,j2s,k1crs,k2crs,mynum,
     &                     nspec,nv,firstime,commcl,ncol,nrow,
     &                     dx,dy,depths                       )
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_GET_FEED
c       NODE_GET_FEED_PT
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: ac(m1,m2,m3)
      real    :: acf(mtp)
c
      integer :: mtp
      integer :: m1
      integer :: m2
      integer :: m3
      integer :: i0
      integer :: j0
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: k1crs
      integer :: k2crs
      integer :: mynum
      integer :: nspec
      integer :: nv
      integer :: commcl(ncol,nrow)
      integer :: ncol
      integer :: nrow
c
      logical :: firstime(nspec)
c
      real, dimension(*)            :: dx
      real                          :: dy
      real, dimension(m1,m2,m3) :: depths
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: k
      integer :: indcf
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      indcf = 1
c
      do k=k1crs,k2crs
         do j=j1s,j2s
            do i=i1s,i2s
               if (commcl(i,j) .le. 1) then
                  ac(i-i0,j-j0,k) = 0.
               endif 
            enddo
         enddo
      enddo
      do j=j1s,j2s
         do i=i1s,i2s
            do k=k1crs,k2crs
               ac(i-i0,j-j0,k) = ac(i-i0,j-j0,k) + acf(indcf) /
     &                                 (dx(j)*dy*depths(i-i0,j-j0,k))
               indcf = indcf + 1
            enddo
         enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine unfdbackp
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine unfdback_dp
c-----------------------------------------------------------------------
c
      subroutine unfdback_dp(ac,acf,mtp,m1,m2,i0,j0,i1s,i2s,j1s,j2s,
     &                      mynum,nspec,nv,firstime,commcl,ncol,nrow,
     &                      dx,dy )
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_GET_FEED_DT
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: ac(m1,m2)
      real    :: acf(mtp)
c
      integer :: mtp
      integer :: m1
      integer :: m2
      integer :: i0
      integer :: j0
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mynum
      integer :: nspec
      integer :: nv
      integer :: commcl(ncol,nrow)
      integer :: ncol
      integer :: nrow
c
      logical :: firstime(nspec)
c
      real, dimension(*)            :: dx
      real                          :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: indcf
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      indcf = 1
c
      do j=j1s,j2s
        do i=i1s,i2s
           if (commcl(i,j) .le. 1) then
               ac(i-i0,j-j0) = 0.
            endif 
         enddo
      enddo
c
      do j=j1s,j2s
         do i=i1s,i2s
           ac(i-i0,j-j0) = ac(i-i0,j-j0) + acf(indcf) / (dx(j)*dy)
           indcf = indcf + 1
         enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine unfdback_dp
c-----------------------------------------------------------------------

      subroutine wetdep(m1,m2,m3,i0,j0,ixcl,jycl,igrd,ncol,nrow,nlay,
     &                  nspcs,deltat,area,depth,tempk,press,
     &                  cwc,pwr,pws,pwg,cph,densfac,dtout,ipa_cel,conc,
     &                  fluxtmp,depfld1,depfld2,wetfld,iptrsa)
      use chmstry
      use procan
      use tracer
c
c----CAMx v7.40 260801
c 
c     WETDEP modifies vertical concentration profiles for a given grid via 
c     precipitation processes.  This subroutine has been completely rewritten
c     for CAMx v4.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        06/15/03   Fixed bug in scaling of tmass
c        02/11/04   Updated empirical rainfall relationships
c        04/21/04   Incorporated sectional PM
c        05/03/05   Revised gas scavenging calculation
c        05/04/05   Revised DDM adjustments
c        06/20/05   Revised to handle liquid/frozen cloud and precip water
c        10/21/05   Added dissociation to Henry's Law for NH3, HNO3, SO2
c        08/31/06   Added map scale factor
c        07/16/07   Fixed PA bug - adjust cipr if evap
c        07/16/07 -bkoo-     Added check for HDDM
c        05/12/08 -cemery-   Revised deposited liquid concentration to use 
c                            correct rainfall volume
c        07/16/08 -bkoo-     Added DDM turn-off flag
c        07/16/08 -gwilson-  Now accumulates mass flux summary outside OMP loop
c        12/22/09 -cemery-   Improved treatment of "c0" array
c        09/23/13 -bkoo-     Placed levap-setting code outside of the spc loop
c                            Added DDM-PM code
c        10/09/14 -cemery-   Restructured for subgrid convective model
c        12/07/14 -bkoo-     Modified for VBS
c        03/17/16 -cemery-   Fixed bug to dissallow tmass<0 (Ondrej Vlcek, CHMI)
c        06/06/16 -cemery-   Simplified gas scavenging approach, removed
c                            rain evap
c        08/04/16 -cemery-   Revised mean PM size in the fine mode (<2.5um) to
c                            account for more efficient PM scavenging at the
c                            high end of the size distribution
c        08/16/21 -cemery-   Fixed calculation errors in wet deposition
c                            liquid concentration
c        02/24/22 -cemery-   Add SA c0trac for consistency with core model
c
c     Input arguments:
c        m1                  number of slice columns
c        m2                  number of slice rows
c        m3                  number of slice layers
c        i0                  slice i-offset
c        j0                  slice j-offset
c        ixcl                i-cell index
c        jycl                j-cell index
c        igrd                grid index 
c        ncol                number of grid columns
c        nrow                number of grid rows
c        nlay                number of grid layers 
c        nspcs               number of total species
c        deltat              time step (s)
c        area                cell area (m2)
c        depth               cell depth (m)
c        tempk               temperature field (K)
c        press               pressure field (mb)
c        cwc                 cloud water content (g/m3)
c        pwr                 rain water content (g/m3)
c        pws                 snow water content (g/m3)
c        pwg                 graupel water content (g/m3)
c        cph                 cloud water pH
c        densfac             factor to convert to umol/m3
c        dtout               output frequency (minutes)
c        ipa_cel             identify if cell is in a IPRM sub-domain
c        conc                concentration field (umol/m3, ug/m3)
c             
c     Output arguments: 
c        conc                concentration field (umol/m3, ug/m3)
c        fluxtmp             temporary array for fluxes
c        depfld1             wet deposited mass (mol/ha, g/ha)
c        depfld2             surface liquid concentrations (mol/l, g/l)
c        wetfld              wet depostion array for tracer species
c             
c     Routines called: 
c        SCAVRAT
c        HENRYFNC
c             
c     Called by: 
c        CIGDRIVE
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer nlay,nspcs,igrd
      real deltat,area,densfac,dtout
      real, dimension(nlay) :: tempk,press,cwc,pwr,pws,pwg,cph,depth
      real, dimension(nspcs) :: depfld1,depfld2,fluxtmp
      real, dimension(MXLAYER,MXSPEC) :: conc
c
      logical lcloud,ltop,lgraupl
      integer kbot,ktop,k,kzcl,l,isemptyf,isemptyc,kwtr,
     &        isec,isempty,iaero
      real rd,rhoh2o,cellvol,rhoair,delc,delm,convfac,cmin,hlaw,
     &     dscav,gscav,ascav,qtf,qtc,vtf,vtc,psizec,ascavf,
     &     roprta,psize,ascavc,qt,vt,cwat,pwat,pwtr,rconst,volume,
     &     dtfall,drpvel,delc0,ceqc,ceqp,ceqpp,pliq
c
      real pp
      real rr
      real volrat
      real c0(MXSPEC)
      real tmass(MXSPEC)
      real delr(MXSPEC)
c
c======================== Probing Tool Begin ===========================
c
      integer m1,m2,m3,i0,j0,ixcl,jycl
      integer ncol,nrow
      integer icls
      integer*8 iptrsa
      real fc2r,fr2c,fc2rc0,fr2cc0,cyctr
      logical lzerc
c
      real c0trac(MXTRSP)
      real tmtrac(MXTRSP)
      real delcls(MXALCLS)
      real c0cls(MXALCLS)
      real concls(MXALCLS)
      real cytcls(MXALCLS)
c
      integer ipa_cel(ncol,nrow,nlay), ipa_idx
      real, dimension(m1,m2,notimespc) :: wetfld
c
c========================= Probing Tool End ============================
c
      data rd /287./         ! Dry air gas constant (J/K/kg)
      data rhoh2o /1.e6/     ! water density (g/m3)
      data rconst /8.206e-2/ ! gas constant (l.atm/mol.K)
c
c-----Entry point
c
c-----If precip is not getting to the ground, there is no wet dep
c
      if (pwr(1).lt.cwmin .and. pws(1).lt.cwmin .and.
     &    pwg(1).lt.cwmin) return
c
c-----Scan column for layers containing cloud top
c
      kbot = 1
      pp = pwr(1) + pws(1) + pwg(1)
      volrat = pp/rhoh2o                 ! drop volume/air volume
      rr = (volrat/1.0e-7)**1.27         ! rainfall rate (mm/hr)
c
      ktop = 0
      do k = 1,nlay
        if (cwc(k).lt.cwmin .and. ktop.ne.0) then
          goto 26
        endif
        if (cwc(k).ge.cwmin) ktop = k
      enddo
      ktop = nlay
  26  continue
c
      do l = 1,nspec
        c0(l)    = 0.
        tmass(l) = 0.
      enddo
c
c-----Loop over layers and species for precipitating columns
c
      ltop = .true.
      pliq = 0.
      do 30 k = ktop,kbot,-1
        kzcl = k
        lcloud = .false.
        lgraupl = .false.
        if (cwc(k).ge.cwmin) lcloud = .true.
        if (pwg(k).ge.cwmin) lgraupl = .true.
        cellvol = area*depth(k)
        rhoair = 100.*press(k)/(rd*tempk(k))
        cwat = cwc(k)
        pwtr = pp + pliq
        if (tempk(k).lt.273.)
     &    cwat = max(0.,cwat*(tempk(k) - tamin)/(273. - tamin))
c
c======================== Probing Tool Begin ===========================
c
        if( ((lddm .OR. lhddm) .AND. lddmcalc(igrd)) .OR.
     &      (ltrace .AND. tectyp.NE.RTRAC .AND. tectyp.NE.RTCMC) ) then
          if (ltop) then
            do l = 1,ntotsp
              tmtrac(l) = 0.
              c0trac(l) = 0.
            enddo
          endif
          do icls = 1,ntrcls
            delcls(icls) = 0.
            concls(icls) = 0.
            c0cls(icls)  = 0.
            cytcls(icls) = 0.
          enddo
        endif
c
c======================== Probing Tool End =============================
c
c-----Calculate scavenging for soluble gas species
c
        do 40 l = nrad+1,ngas
          if( henry0(l).LT.1.e-6 ) goto 40
          convfac = densfac*(273./tempk(k))*(press(k)/1013.)
          cmin = bdnl(l)*convfac
          conc(k,l) = max(cmin,conc(k,l))
          call henryfnc(l,henry0(l),tfact(l),tempk(k),cph(k),knh3,
     &                  khno3,kso2,hlaw)
          hlaw = hlaw*rconst*tempk(k)
          ceqc = conc(k,l)*(1. - 1./(1. + hlaw*cwat/rhoh2o))
          call henryfnc(l,henry0(l),tfact(l),tempk(k),5.,knh3,
     &                  khno3,kso2,hlaw)
          hlaw = hlaw*rconst*tempk(k)
         
          pwat = pwtr
          if (tempk(k).lt.273. .and. rscale(l).gt.0.) pwat = 0.
          ceqp  = conc(k,l)*(1. - 1./(1. + hlaw*pwat/rhoh2o))
          ceqpp = (conc(k,l) - ceqc)*(1. - 1./(1. + hlaw*pwat/rhoh2o))
c
          call scavrat(.false.,lcloud,lgraupl,tamin,rr,tempk(k),
     &                 rhoair,diffrat(l),0.,0.,dscav,gscav,ascav,drpvel)
c
          dtfall = depth(k)/drpvel
          if (c0(l).lt.ceqp .or. ceqp.eq.0.) then
            delc  = ceqc*(1. - exp(-dscav*deltat)) +
     &              ceqpp*(1. - exp(-gscav*deltat))
            delc0 = ceqc*(1. - exp(-dscav*min(dtfall,deltat))) +
     &              ceqpp*(1. - exp(-gscav*min(dtfall,deltat)))
            if (ceqp.eq.0.) then
              delc  = min(delc,conc(k,l)-cmin)
              delc0 = min(delc0,conc(k,l)-cmin)
            else
              delc  = min(delc,ceqp-c0(l),conc(k,l)-cmin)
              delc0 = min(delc0,ceqp-c0(l),conc(k,l)-cmin)
            endif
          else
            delc  = (ceqp - c0(l))*(1. - exp(-gscav*deltat))
            delc0 = (ceqp - c0(l))*(1. - exp(-gscav*min(dtfall,deltat)))
          endif
          delm = delc*cellvol
          if (delm.lt.0.) then
            delm = max(delm,-tmass(l))
            delc = delm/cellvol
          endif
c
c======================== Probing Tool Begin ===========================
c
c  --- Accumulate OSAT/PSAT tracer adjustments by tracer class ---
c
          if( ltrace .AND. tectyp.NE.RTRAC .AND. tectyp.NE.RTCMC ) then
            cyctr = 0.5*min(conc(k,l),c0(l))
            if (pwat.eq.0) then 
              cyctr = cyctr*(1. - exp(-dscav*deltat))
            else
              cyctr = cyctr*(1. - exp(-(dscav+gscav)*deltat))
            endif
            do icls = 1,ntrcls
              concls(icls) = concls(icls) + conc(k,l)*fluxmap(l,icls)
              c0cls(icls)  = c0cls(icls)  + c0(l)*fluxmap(l,icls)
              delcls(icls) = delcls(icls) + delc*fluxmap(l,icls)
              cytcls(icls) = cytcls(icls) + cyctr*fluxmap(l,icls)
            enddo
          endif
c
c  --- For DDM convert delc to flux ---
c
          if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
            if( delc.GT.0. ) then
               fc2r = delc/conc(k,l)
               fr2c = 0.
               fc2rc0 = delc0/conc(k,l)
               fr2cc0 = 0.
            elseif( c0(l) .GT. 1.0e-20 ) then
               fc2r = 0.
               fr2c = -delc/c0(l)
               fc2rc0 = 0.
               fr2cc0 = -delc0/c0(l)
            else
               fc2r = 0.
               fr2c = 0.
               fc2rc0 = 0.
               fr2cc0 = 0.
            endif

            lzerc = .FALSE.
            if( conc(k,l)-delc .LE. 1.1*cmin ) lzerc = .TRUE.

            call adjddmc0(l,ixcl,jycl,kzcl,fc2r,fr2c,fc2rc0,fr2cc0,
     &                    c0trac,tmtrac,cellvol,lzerc,
     &                    m1,m2,m3,ntotsp,ptconc(iptrsa))
          endif
c
c-----PA change from wet deposition
c
          if( lipr ) then
            if( ipa_cel(ixcl+i0,jycl+j0,k) .GT. 0 ) then
              ipa_idx = ipa_cel(ixcl+i0,jycl+j0,k)
              cipr(IPR_WDEP,ipa_idx,l) = cipr(IPR_WDEP,ipa_idx,l) - delc
            endif
          endif
c
c========================= Probing Tool End ============================
c
c-----Update the cell concentration and rain mass
c
          conc(k,l) = conc(k,l) - delc
          c0(l) = max(c0(l)+delc0,0.)
          tmass(l) = max(tmass(l)+delm,0.)
 40     continue
        pliq = pliq + cwat*(1. - exp(-dscav*min(dtfall,deltat)))
c
c-----Calculate scavenging for particulate species
c
        if (naero .gt. 0) then
c
c-----Recalculate particle size for wet diameter
c     Adjust geometric mean particle diameters <2.5um by 10x to account for
c     mass scavenging over the whole size distribution (assuming geometric
c     standard deviation of 2.0)
c
c-----CF 2-bin scheme
c
          if (lchem .AND. aeropt.eq.'CF') then
            isemptyf = 1
            isemptyc = 1
            qtf = 0. ! fine dry total mass
            qtc = 0. ! coarse dry total mass
            vtf = 0. ! fine dry total volume
            vtc = 0. ! coarse dry total volume
            do l = ngas+1,nspec
              if (dcut(l,2).lt.(dcut(kph2o,2)+1.e-5)) then     ! fine
                if (l.ne.kph2o) then
                  if (conc(k,l).gt.bdnl(l)) isemptyf = 0
                  qtf = qtf + conc(k,l)
                  vtf = vtf + conc(k,l)/roprt(l)
                endif
              else                                             ! coarse
                if (conc(k,l).gt.bdnl(l)) isemptyc = 0
                qtc = qtc + conc(k,l)
                vtc = vtc + conc(k,l)/roprt(l)
                psizec = sqrt(dcut(l,1)*dcut(l,2))
              endif
            enddo
            ascavf = 0.
            if (isemptyf.eq.0) then
              roprta = (qtf + conc(k,kph2o)) /
     &                 (vtf + conc(k,kph2o)/roprt(kph2o))
              psize = sqrt(dcut(kph2o,1)*dcut(kph2o,2))
              psize = 1.e-6*psize*(1. + 
     &                conc(k,kph2o)/roprt(kph2o)/vtf)**0.33333
              if (psize.lt.2.5e-6) psize = psize*10.
              call scavrat(.true.,lcloud,lgraupl,tamin,rr,tempk(k),
     &                 rhoair,0.,psize,roprta,dscav,gscav,ascavf,drpvel)
            endif
            ascavc = 0.
            if (isemptyc.eq.0) then
              roprta = qtc/vtc
              psize = psizec*1.e-6
              call scavrat(.true.,lcloud,lgraupl,tamin,rr,tempk(k),
     &                 rhoair,0.,psize,roprta,dscav,gscav,ascavc,drpvel)
            endif
            do l = ngas+1,nspec
              if (dcut(l,2).lt.(dcut(kph2o,2)+1.e-5)) then
                delr(l) = 1. - exp(-ascavf*deltat)
              else
                delr(l) = 1. - exp(-ascavc*deltat)
              endif
            enddo
c
c-----Other scheme
c
          else
            do l = ngas+1,nspec
              psize = 1.e-6*sqrt(dcut(l,1)*dcut(l,2))
              if (psize.lt.2.5e-6) psize = psize*10.
              call scavrat(.true.,lcloud,lgraupl,tamin,rr,tempk(k),
     &                rhoair,0.,psize,roprt(l),dscav,gscav,ascav,drpvel)
              delr(l) = 1. - exp(-ascav*deltat)
            enddo
          endif
c
          do 50 l = ngas+1,nspec
            delc = 0.
            delm = 0.
            cmin = bdnl(l)
            conc(k,l) = max(cmin,conc(k,l))
            delc = conc(k,l)*delr(l)
            delc = min(delc,conc(k,l)-cmin)
c
            conc(k,l) = conc(k,l) - delc
            delm = delc*cellvol
            tmass(l) = tmass(l) + delm
c
c========================= Probing Tool Begin ============================
c
c-----PA change from wet deposition
c
            if( lipr ) then
              if( ipa_cel(ixcl+i0,jycl+j0,k) .GT. 0 ) then
                ipa_idx = ipa_cel(ixcl+i0,jycl+j0,k)
                cipr(IPR_WDEP,ipa_idx,l) = cipr(IPR_WDEP,ipa_idx,l) - 
     &                                     delc
              endif
            endif
c
            if( ltrace .AND. tectyp.NE.RTRAC .AND.
     &                       tectyp.NE.RTCMC ) then
              do icls = 1,ntrcls
                delcls(icls) = delcls(icls) + delc*fluxmap(l,icls)
              enddo
            endif
c
c  --- Adjust DDM sensitivities for PM species ---
c
            if ( lddm .AND. lddmcalc(igrd) ) then
              fc2r = delr(l)
              fr2c = 0.
              fc2rc0 = 0.
              fr2cc0 = 0.

              lzerc = .FALSE.
              if( conc(k,l) .LE. 1.1*cmin ) lzerc = .TRUE.

              call adjddmc0(l,ixcl,jycl,kzcl,fc2r,fr2c,fc2rc0,fr2cc0,
     &                      c0trac,tmtrac,cellvol,lzerc,
     &                      m1,m2,m3,ntotsp,ptconc(iptrsa))
            endif
c
c========================= Probing Tool End ============================
c
 50       continue
        endif
c
c======================== Source Apportion Begin =======================
c
c  --- Adjust OSAT/PSAT tracer by tracer class ---
c
        if( ltrace .AND. tectyp.NE.RTRAC .AND. tectyp.NE.RTCMC ) then
           call adjstc0(m1,m2,m3,igrd,ixcl,jycl,kzcl,delcls,concls,
     &                  cytcls,c0cls,c0trac,tmtrac,cellvol)
        endif
c
c======================== Source Apportion End =========================
c
        ltop = .false.
 30   continue
c
c-----Increment deposition flux arrays
c
      volume = 1.e-3*rr*area               ! mm/hr * m2 -> m3 (in 1 hr)
      do l = nrad+1,nspec
        fluxtmp(l) = -tmass(l)
        depfld1(l) = 1.e-2*tmass(l)/area   ! ug(mol) / m2 -> g(mol)/ha
        depfld2(l) = 1.e-9*tmass(l)/volume ! ug(mol) / m3 -> g(mol)/l
      enddo
c
c======================== Source Apportion Begin =======================
c
      if( lptdepout) then
        do l = 1,notimespc
          wetfld(ixcl,jycl,l) = wetfld(ixcl,jycl,l) + 
     &                          1.e-2*tmtrac(l)/area
        enddo
      endif
c
c======================== Source Apportion End =======================
c
      return
      end

C**** INITSA
c
      subroutine initsa(version,nxx,nxy,idate,begtim,jdate,endtim)
      use grid
      use tracer
      use rtracchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine calls all of the routines that set up the run for the
c   passive tracer algorithm.  The first thing done on routine OPENPT
c   is to set the flag for using passive tracer alogithm.  If this
c   flag is false coming out of the subroutine then all other routines
c   are skipped.
c
c      Copyright Ramboll
c
c     Argument description:
c      Inputs:
c         version C  version number of the model
c         nxx     I  number of cells in the X-direction
c         nxy     I  number of cells in the Y-direction
c         idate   I  beginning date of the simulation (YYJJJ)
c         begtim  R  beginning time of the simulation
c         jdate   I  ending date of the simulation (YYJJJ)
c         endtim  R  ending time of the simulation
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/27/96   --gwilson--    Original development
c     11/06/01   --cemery--     Input dates are now Julian
c     01/30/02   --gwilson--    Added code for RTRAC probing tool
c     07/11/07   --cemery--     Added code for RTCMC probing tool
c     07/16/07   --bkoo--       Added check for HDDM
c     03/01/16   --gwilson--    Added partial source area map
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      character*20 version
      integer      nxx(*)
      integer      nxy(*)
      integer      idate
      integer      jdate
      real         begtim
      real         endtim
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ip, ic, igrd, igrp, jfin, ifin, ipart
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- set the global variables to the passed arguments ---
c
      do igrd=1,ngrid
        nxcell(igrd) = nxx(igrd)
        nycell(igrd) = nxy(igrd)
      enddo 
c
c  --- if doing RTRAC, call routine to read chemistry definitions file ---
c 
      if( tectyp .EQ. RTRAC ) then
         call rdchmrt(version)
         ntrtim = 0 
         nsaspc = ntotsp
         ntrcls = 1
         iptcls(1) = 1
         nptcls(1) = ntotsp
         ipttim = ntotsp + 1
c
c  --- if doing RTCMC, call routine to read chemistry definitions file
c      and generate the chemistry solver ---
c
      elseif( tectyp .EQ. RTCMC ) then
         call rdschm(ldbg)
         call gencmc(ldbg)
         ntrtim = 0
         nsaspc = ntotsp
         ntrcls = 1
         iptcls(1) = 1
         nptcls(1) = ntotsp
         ipttim = ntotsp + 1
         call alloc_tracer_vdep(ngrid,ncol,nrow,ntotsp)
c
c  ---- call routine to read the source mapping file ---
c
      else
          if( nregin .GT. 0 ) then
              call resmap()
              if( lpartial ) then
                 call rdpartial_map()
                 call chkpartial()
              endif
c
c  --- now assign any values that were not read in ---
c
              do ip = 1,ngrid
                do 20 ic = 1,nchdrn(ip)
                  igrd = idchdrn(ic,ip)
                  do igrp=0,ngroup
                     if( .NOT. lmapfl(0,igrd) ) then
                        do jfin = 1,nrow(igrd)
                          j = (jfin - 2)/nmesh(igrd) + j1(igrd)
                          do ifin = 1,ncol(igrd)
                             i = (ifin - 2)/nmesh(igrd) + i1(igrd)
                             do ipart=1,npartial(igrp,igrd)
                               igrmap(igrp,ipart,igrd,ifin,jfin) =
     &                                          igrmap(igrp,ipart,ip,i,j)
                               frcmap(igrp,ipart,igrd,ifin,jfin) =
     &                                           frcmap(igrp,ipart,ip,i,j)
                             enddo
                          enddo
                        enddo
                     endif
                  enddo
   20           continue
              enddo
          endif
c
c   --- read the header of the initial conditions file to get init tracer species ---
c
          if( lsa_ioric ) then
             if( is_netcdf_ioric ) then
                call ncf_sa_icprep(begtim,idate,begtim,idate)
             else
                call sa_icprep(begtim,idate,endtim,jdate)
             endif
          endif
c
c   --- read the header of the initial conditions file to get init tracer species ---
c
          if( lsa_iorbc ) then
             if( is_netcdf_iorbc ) then
                call ncf_sa_bcprep(begtim,idate,endtim,jdate)
             else
                call sa_bcprep(begtim,idate,endtim,jdate)
             endif
             if( lsa_iortc ) then
                 if( is_netcdf_iorbc ) then
                     call ncf_sa_tcprep(begtim,idate,endtim,jdate)
                 else
                     call sa_tcprep(begtim,idate,endtim,jdate)
                 endif
             endif
          endif
c
c   ---- call routine to set the species flags ----
c
          call stabsa(idate,begtim,jdate,endtim)
c
c   ---- call routine to set up the tracer species lists ----
c
          if( ltrace ) then
            call specsa(idate,begtim,jdate,endtim)
          else if( lddm .OR. lhddm ) then
            call specddm( )
          endif
      endif
c
c  ---- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine nodes_tstep(numprocs,iproc_id)
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer

      implicit none
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes all of the data that is time-step
c        dependent to the compute nodes when in MPI mode.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c        numprocs            the number of processes
c        iproc_id            process number for this process
c     Output:
c
c    Called by:
c       CAMX
c    Subroutines called:
c       NODE_RECV_1SPECIES_DATA
c       MASTER_SEND_1SPECIES_DATA
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c       04/30/13     Added surface model
c       08/26/21     RTRAC surface file doubles as (default)
c                    dep output or (flagged) surface model output
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'rtracsrf.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c    
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ilay
      integer :: ispc
      integer :: i
      integer :: nlayav
      integer :: iptr_rtsolmas
c    
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      iptr_rtsolmas = 1
      if( .NOT. lmpi ) return
c
c  --- pass the fields that are dimensioned by mvecem ---
c
      do i=1,ngrid      
         do ilay=1,nlayers_ems
            do ispc=1,nemspc
               if( iproc_id .gt. 0 ) then
                 call node_recv_1species_data  (aremis(iptrem(i)), i,
     &                             nlayers_ems, ilay, nemspc, ispc, itag)
               else
                 call master_send_1species_data(aremis(iptrem(i)), i,
     &                             nlayers_ems, ilay, nemspc, ispc, itag)
               endif
               itag = itag + 1
            enddo
         enddo
c
c  --- pass the concentration fields ----
c
         do ilay=1,nlay(i)
            do ispc=1,nspec
               if( iproc_id .gt. 0 ) then
                 call node_recv_1species_data  (conc(iptr4d(i)), i,
     &                              nlay(i), ilay, nspec, ispc, itag)
               else
                 call master_send_1species_data(conc(iptr4d(i)), i,
     &                             nlay(i), ilay, nspec, ispc, itag)
               endif
               itag = itag + 1
            enddo
         enddo
c
         nlayav = nlay(i)
         if( .NOT. l3davg(i) ) nlayav = 1
         do ilay=1,nlayav
            do ispc=1,navspc
                if( iproc_id .gt. 0 ) then
                  call node_recv_1species_data  (avcnc(iptrav(i)), i,
     &                               nlayav, ilay, navspc, ispc, itag)
                else
                  call master_send_1species_data(avcnc(iptrav(i)), i,
     &                               nlayav, ilay, navspc, ispc, itag)
                endif
                itag = itag + 1
            enddo
         enddo
c
c
c  --- pass the surface model soil mass fields ----
c
         if (lsrfmod) then
           do ispc=1,nsmspc
              if( iproc_id .gt. 0 ) then
                call node_recv_1species_data (solmas(iptrsm(i)), i,
     &                                       1, 1, nsmspc, ispc, itag)
              else
                call master_send_1species_data(solmas(iptrsm(i)), i,
     &                                       1, 1, nsmspc, ispc, itag)
              endif
              itag = itag + 1
           enddo
c
c  --- pass the surface model veg mass fields ----
c
           do ispc=1,nsmspc
              if( iproc_id .gt. 0 ) then
                call node_recv_1species_data (vegmas(iptrsm(i)), i,
     &                                       1, 1, nsmspc, ispc, itag)
              else
                call master_send_1species_data(vegmas(iptrsm(i)), i,
     &                                       1, 1, nsmspc, ispc, itag)
              endif
              itag = itag + 1
           enddo
         endif
c
c  --- pass the emissions array for probing tools ----
c
         if( ltrace .OR. lddm .OR. lhddm ) then 
c
            do ilay=1,nlayers_ems
               do ispc=1,soap3_ntotsp
                  if( iproc_id .gt. 0 ) then
                    call node_recv_1species_data(saemis(ipsa3d_ems(i)), i,
     &                               nlayers_ems, ilay, soap3_ntotsp, ispc, itag)
                  else
                    call master_send_1species_data(saemis(ipsa3d_ems(i)), i,
     &                               nlayers_ems, ilay, soap3_ntotsp, ispc, itag)
                  endif
                  itag = itag + 1
               enddo
            enddo
c
c  --- pass the concentration fields for probing tools ----
c
            do ilay=1,nlay(i)
               do ispc=1,ntotsp
                   if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data  (ptconc(ipsa3d(i)), i,
     &                                  nlay(i), ilay, ntotsp, ispc, itag)
                   else
                     call master_send_1species_data(ptconc(ipsa3d(i)), i,
     &                                 nlay(i), ilay, ntotsp, ispc, itag)
                   endif
                   itag = itag + 1
               enddo
            enddo
c
c  --- pass the average concentration fields for probing tools ----
c
            nlayav = nlay(i)
            if( .NOT. lsa_3davrg ) nlayav = 1
            do ilay=1,nlayav
               do ispc=1,ntotsp
                   if( iproc_id .gt. 0 ) then
                        call node_recv_1species_data  (ptavrg(ipsa2d_avrg(i)), i,
     &                                     nlayav, ilay, ntotsp, ispc, itag)
                   else
                     call master_send_1species_data(ptavrg(ipsa2d_avrg(i)), i,
     &                                     nlayav, ilay, ntotsp, ispc, itag)
                   endif
                   itag = itag + 1
               enddo
            enddo
c
c  --- pass the dry depostion fields for probing tools ----
c
            if( lptdepout ) then
              do ispc=1,notimespc
                  if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data  (ptdryfld(ipsadep(i)), i,
     &                                           1, 1, notimespc, ispc, itag)
                  else
                    call master_send_1species_data(ptdryfld(ipsadep(i)), i,
     &                                           1, 1, notimespc, ispc, itag)
                  endif
                  itag = itag + 1
              enddo
c
c  --- pass the wet depostion fields for probing tools ----
c
              do ispc=1,notimespc
                  if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data  (ptwetfld(ipsadep(i)), i,
     &                                           1, 1, notimespc, ispc, itag)
                  else
                    call master_send_1species_data(ptwetfld(ipsadep(i)), i,
     &                                           1, 1, notimespc, ispc, itag)
                  endif
                  itag = itag + 1
              enddo
            endif
c
c  --- pass the RTRAC soil mass fields ----
c
            if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
              do ispc=1,ntotsp
                  if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data (rtsolmas(iptr_rtsolmas), i,
     &                                           1, 1, ntotsp, ispc, itag)
                  else
                    call master_send_1species_data(rtsolmas(iptr_rtsolmas), i,
     &                                           1, 1, ntotsp, ispc, itag)
                  endif
                  itag = itag + 1
              enddo
c
c  --- pass the RTRAC veg mass fields ----
c
              do ispc=1,ntotsp
                  if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data (rtvegmas(iptr_rtsolmas), i,
     &                                           1, 1, ntotsp, ispc, itag)
                  else
                    call master_send_1species_data(rtvegmas(iptr_rtsolmas), i,
     &                                           1, 1, ntotsp, ispc, itag)
                  endif
                  itag = itag + 1
              enddo
            endif
         endif
c
c  --- pass the IRR fields for process analysis ---
c
         if( lirr ) then
            do ilay=1,nlay(i)
              do ispc=1,ntotsp
                   if( iproc_id .gt. 0 ) then
                     call node_recv_1species_data  (ptconc(ipsa3d(i)), i,
     &                                  nlay(i), ilay, ntotsp, ispc, itag)
                   else
                     call master_send_1species_data(ptconc(ipsa3d(i)), i,
     &                                 nlay(i), ilay, ntotsp, ispc, itag)
                   endif
                   itag = itag + 1
               enddo
            enddo
         endif
      enddo
c
c  --- return to the calling routine ---
c
      end

      subroutine smpl1puf(lbckgrd,maxcol,maxrow,maxspec,ncol,
     &                    nrow,navspc,ismpbeg,jsmpbeg,mfac,meshnst,
     &                    inst1,jnst1,ia,iz,ja,jz,ioff,joff,dx,dy,sigx,
     &                    sigy,xpigf,xpigb,ypigf,ypigb,pdepth,pmass,
     &                    bdnl,convfac,avcnc)
c
c----CAMx v7.40 260801
c
c     SMPL1PUF calculates a single puff's concentration distribution on
c     the given sampling grid.  A 2-D Gaussian distribution is assumed
c     in the horizontal; uniform (well mixed) concentrations are assumed
c     in the vertical.
c
c      Copyright Ramboll
c
c     Modifications:
c        08/08/05       Moved from Rtrac, added option to include
c                       computational background concentrations
c
c     Input arguments:
c        lbckgrd             flag for adding background concs
c        maxcol              max number of sampling grid columns
c        maxrow              max number of sampling grid rows
c        maxspec             number of averaging species
c        ncol                number of sampling grid columns
c        nrow                number of sampling grid rows
c        navspc              number of averaging species
c        mfac                meshing factor for sampling grid in this nest
c        ismpbeg             starting I index of sample grid rel to master grid
c        jsmpbeg             starting J index of sample grid rel to master grid
c        meshnst             meshing factor for computational grid
c        inst1               starting I index of comp grid rel to master grid
c        jnst1               starting J index of comp grid rel to master grid
c        ia                  X beginning of computational part of this slice
c        iz                  X ending of computational part of this slice
c        ja                  Y beginning of computational part of this slice
c        jz                  Y ending of computational part of this slice
c        ioff                X offset of slice in full domain
c        joff                Y offset of slice in full domain
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        sigx                along-puff Gaussian standard deviation (m)
c        sigy                cross-puff Gaussian standard deviation (m)
c        xpigf               x-coord of puff front (m)
c        xpigb               x-coord of puff back (m)
c        ypigf               y-coord of puff front (m)
c        ypigb               y-coord of puff back (m)
c        pdepth              puff depth (m)
c        pmass               puff mass (umol)
c        bdnl                lower bounds conc (ppm)
c        convfac             units conversion factor for gasses
c        avcnc               background conc (ppm)
c                            (Initially interpolated gridded concs)
c
c     Output arguments:
c        avcnc               incremented background conc (ppm)
c
c     Subroutines Called:
c        none
c
c     Called by:
c        PIGSAMPL
c
      implicit none
      logical lbckgrd
      integer maxcol,maxrow,maxspec,ncol,nrow,navspc
      integer mfac
      integer ismpbeg
      integer jsmpbeg
      integer meshnst
      integer inst1
      integer jnst1
      integer ia
      integer iz
      integer ja
      integer jz
      integer ioff
      integer joff
      real dx,dy,sigx,sigy,xpigf,xpigb,ypigf,ypigb,pdepth,
     &     pmass(maxspec),bdnl(maxspec),convfac(maxcol,maxrow,maxspec),
     &     avcnc(maxcol,maxrow,maxspec)
      integer i,j,l,ic,jc
      real sigx2,sigy2,xpig,ypig,pi,phi,theta,xgrd,ygrd,xloc,yloc,dist,
     &     xloc2,yloc2,couple,cnc,sigmax
      real xc, yc, xf, yf
c
      data pi /3.1415927/
c
c-----Entry point
c
      sigx2 = sigx*sigx
      sigy2 = sigy*sigy
      sigmax = amax1(sigx,sigy)
c
c-----Determine puff orientation relative to sampling grid
c
      xpig = (xpigf + xpigb)/2.
      ypig = (ypigf + ypigb)/2.
      if (xpigf.eq.xpigb) then
        phi = pi/2.
      else
        phi = atan((ypigf - ypigb)/(xpigf - xpigb))
      endif
c
c-----Loop over rows/columns; calculate grid point orientation
c     relative to puff center point
c
      jc = (jsmpbeg - jnst1)*meshnst + 2
      jc = jc-joff
      yc = 0.5
      do 10 j = 1,nrow
        ic = (ismpbeg - inst1)*meshnst + 2
        ic = ic-ioff
        xc = 0.5
        yf = (j - 0.5)/float(mfac)
        if (yc.le.yf) then
          jc = jc + 1
          yc = yc + 1.
        endif
c
c  --- if this row is not in this slice, skip it all ---
c
        if( jc .LT. ja .OR. jc .GT. jz ) goto 10
        ygrd = (j - 0.5)*dy
        do 20 i = 1,ncol
          xf = (i - 0.5)/float(mfac)
          if (xc.le.xf) then
            ic = ic + 1
            xc = xc + 1.
          endif
c
c  --- if this row is not in this slice, skip it all ---
c
          if( ic .LT. ia .OR. ic .GT. iz ) goto 20
          xgrd = (i - 0.5)*dx
          dist = sqrt((xgrd - xpig)**2 + (ygrd - ypig)**2)
          if (xgrd.eq.xpig) then
            theta = pi/2.
          else
            theta = atan((ygrd - ypig)/(xgrd - xpig))
          endif
          theta = theta - phi
          xloc = dist*cos(theta)
          yloc = dist*sin(theta)
c
c-----Sample puff if grid point is within +/- 3*sigma of center point
c
          if (abs(xloc).le.3.*sigmax .and. abs(yloc).le.3.*sigmax) then
            xloc2 = xloc*xloc
            yloc2 = yloc*yloc
            couple = exp(-xloc2/(2.*sigx2))*exp(-yloc2/(2.*sigy2))
            do l = 1,navspc
              cnc = pmass(l)*couple/(2.*pi*sigx*sigy*pdepth)
              avcnc(i,j,l) = cnc/convfac(i,j,l) + avcnc(i,j,l)
              if (lbckgrd) avcnc(i,j,l) = amax1(avcnc(i,j,l),bdnl(l))
            enddo
          endif
   20   continue
   10 continue
      return
      end

      subroutine avgall(iproc_id,nsteps,dtradscl)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use camxcom
      use grid
      use camxfld
      use chmstry
      use pigsty
      use tracer
      use rtracchm
      use procan
      use node_mod
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c         Calls all of the routines that perform the averaging for 
c         the various concentation fields: regular model, probing tools,
c         probing tool receptors and PiG sampling
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c       iproc_id    process ID for this slice (MPI)
c       nsteps      number of steps at this time in the sumulation
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       NEWGRID
c       AVERAGE
c       AVEPIG
c       PIGSAMPL
c       AVGWAL
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     09/27/10 --gwilson-- the calculation for process analysis
c                          conversion factors is now done by a separate
c                          routine
c     11/06/12 --gwilson-- fixed Wall of Cells receptors for MPI
c     04/17/14 --gwilson-- added call to initialize Lslice array
c     07/01/19 --cemery--  Removed trapazoidal integration for radicals
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument delarations:
c-----------------------------------------------------------------------
c
      integer :: iproc_id
      integer :: nsteps
      real    :: dtradscl
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: igrd
      integer :: nlayav
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      call newgrid(1)
      nlayav = nlay(1)
      if( .NOT. l3davg(1) ) nlayav = 1
      call average(mxp,myp,mzp,.FALSE.,1,deltat(1)/2.0,dtradscl,
     &                ncol(1),nrow(1),nlay(1),nlayav,navspc,nspec,
     &                      lavmap,lgas,mole_weight,tempk(1),press(1),
     &                                                conc(1),avcnc(1) )
c
c========================= Process Analysis Begin ==============================
c
c  --- call routine to calculate conversion factors for PA
c
      if( lipr ) then
          call paconv(mxp,myp,mzp,deltat(1)/2.0,
     &             ncol(1),nrow(1),nlay(1),navspc,nspec,lavmap,
     &                           lgas,tempk(1),press(1),ipacl_3d(1))
      endif
c
c========================= Process Analysis End ==============================
c
c  --- Add PiG masses to average ---
c
      if (ipigflg .NE. 0 .AND. LVISPIG) then
         if( lmpi .AND. nsteps .EQ. 1 ) call init_Lslice(iproc_id,1,i0,j0)
         call avepig(iproc_id,1,deltat(1)/2.0,mxp,myp,mzp,i0,j0,
     &               ncol(1),nrow(1),nlay(1),nlayav,deltax(1,1),
     &               deltay(1),mapscl(1),height(1),navspc,nspec,
     &                               lavmap,tempk(1),press(1),avcnc(1))
      endif
c
c  --- Update running average of average specs on sampling grids ---
c
      if (lsample) then
         do igrd = 1,nsample
            if( ismpgrd(igrd) .EQ. 1 ) then
               call pigsampl(mxp,myp,mzp,i0,j0,.FALSE.,1,igrd,nspec,
     &                       navspc,ncolsmp(igrd),nrowsmp(igrd),
     &                       nrow(1),meshold(1),inst1(1),
     &                       jnst1(1),deltat(1)/2.0,delx,dely,
     &                       deltax(1,1),deltay(1),tempk(1),
     &                       press(1),conc(1),smpcnc(ipsmp(igrd)) )
            endif
         enddo
      endif
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to update the running averages ---
c
      if( ltrace .OR. lddm .OR. lhddm ) then
         if( ltrace .OR. lddmcalc(1) ) then
         nlayav = nlay(1)
         if( .NOT. lsa_3davrg ) nlayav = 1
         call average(mxp,myp,mzp,.TRUE.,1,deltat(1)/2.0,1.0,
     &                ncol(1),nrow(1),nlay(1),nlayav,ntotsp,ntotsp,
     &                         lsamap,lsagas,sa_mole_weight,tempk(1),
     &                                  press(1),ptconc(1),ptavrg(1) )
         endif
c
c  --- if WALL OF CELLS receptors exist, add averages ---
c
         if( lwalls ) then
            do igrd=1,ngrid
               if( .NOT.( ltrace .OR. lddmcalc(igrd) ) ) cycle
               call newgrid(igrd)
               call avgwal(igrd,mxp,myp,mzp,
     &                     ncol(igrd),i0,j0,ntotsp,deltat(igrd)/2.0,
     &                     deltax(1,igrd),deltay(igrd),depth(iptr3d(igrd)),
     &                     mapscl(iptr2d(igrd)),tempk(iptr3d(igrd)),
     &                     press(iptr3d(igrd)),ptconc(ipsa3d(igrd))     )
            enddo
         endif
c
c  --- Update running average on sampling grids ---
c
         if ((tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND.
     &        lsample .AND. lsmptrc) then
            do igrd = 1,nsample 
               if( ismpgrd(igrd) .EQ. 1 ) then
                  call pigsampl(mxp,myp,mzp,i0,j0,.TRUE.,1,igrd,nrtrac,
     &                          nrtrac,ncolsmp(igrd),nrowsmp(igrd),
     &                          nrow(1),meshold(1),inst1(1),
     &                          jnst1(1),deltat(1)/2.0,delx,dely,
     &                          deltax(1,1),deltay(1),tempk(1),
     &                          press(1),ptconc(1),rtsmpcnc(iprtsmp(igrd)) )
               endif
            enddo
         endif
      endif
c
c========================= CSA End ========================
c
      if( lcsa ) call csa_avrg(1)
c
c========================= CSA End ========================
c
c
c========================= Source Apportion End ========================
c
      return
      end

      subroutine ncf_sa_bcprep(begtim,begdate,endtim,enddate)
      use filunit
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_SA_BCPREP reads and checks the SA boundary condition  file.
c     It will determine the species in the file and populate the 
c     tracer array appropriately.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         begtim  R model begin time
c         begdat  I model begin date (YYJJJ)
c         endtim  R model end time
c         enddate I model end date (YYJJJ)
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    begtim
      integer begdate
      real    endtim
      integer enddate
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*(16*MAX(MXTRSP,2)) varlist
      character*200         action, fname
      character*10          bcfiltyp, name_in, this_var
      character*3           first_class
      integer               this_dimid, ierr, this_varid, itmp, nvars_in, l
c
      character*10,     allocatable :: bcspec(:)
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data bcfiltyp /'BOUNDARY  '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- skip if this is a NetCDF file ---
c
      action = 'Reading NetCDF SA boundary conditions file.'
c
c --- get the type of file to make sure it is a point source file ---
c
      this_var = 'CAMx_NAME'
      ierr = nf_get_att_text(iorbc, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iorbc, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7001
      endif
      if( name_in(:8) .NE. bcfiltyp(:8) ) goto 7000
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(iorbc,action,1,.TRUE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iorbc,action,begdate,begtim,
     &                                        enddate,endtim,.FALSE.)
c
c --- get the number of variables in the file ----
c
      this_var = 'NVARS'
      ierr = nf_get_att_int(iorbc, NF_GLOBAL, this_var, nvars_in)
      if( ierr .NE. NF_NOERR ) goto 7002
c
c  --- check that this number of tracer species is allowed ---
c
      if( nvars_in .GT. MXTRSP ) then
         write(iout,'(//,A)') 'ERROR in NCF_SA_BCPREP:'
         write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter: MXTRSP'
         write(iout,*) 'It should be set to a value of at least: ',nvars_in
         call flush(iout)
         call camxerr()
      endif
c
c  --- allocate and read the list of variable names ----
c
      varlist = ' '
      this_var = 'VAR-LIST'
      ierr = nf_get_att_text(iorbc, NF_GLOBAL, this_var, varlist)
      if( ierr .NE. NF_NOERR ) goto 7002
      num_iorbc = 0
      do l=1,nvars_in
         if( varlist(1+(l-1)*16:16+(l-1)*16) .NE. '                ' ) 
     &                                         num_iorbc = num_iorbc + 1
      enddo
      allocate( spc_iorbc(num_iorbc) )
      first_class = varlist(1:3)
      if (first_class .EQ. 'z  ' .OR. first_class .EQ. 'Z  ') 
     &    first_class = varlist(17:19)
      ncls_iorbc = 0
      do l=1,num_iorbc
         spc_iorbc(l) = varlist(1+(l-1)*16:10+(l-1)*16)
         if( spc_iorbc(l)(1:3) .EQ. first_class ) 
     &                                         ncls_iorbc = ncls_iorbc + 1
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_SA_BCPREP: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',bcfiltyp(:istrln(bcfiltyp))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_SA_BCPREP: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_SA_BCPREP: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine hddmadj(lpost,nfam,con,sddm)
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c     HDDMADJ applies pre- or post-HDDMCHEM adjustments to the HDDM
c     sensitivities.
c
c      Copyright Ramboll
c
c     History:
c        07/16/07   --bkoo--       Original development
c
c     Input arguments:
c        lpost             TRUE if this is post-HDDMCHEM adjustments
c        nfam              number of sensitivity families
c        con               state species concentrations (ppm)
c        sddm              sensitivity matrix sddm (ppm)
c
c     Output arguments:
c        sddm              updated sensitivity matrix
c
c     Routines called:
c        None
c
c     Called by:
c        CHEMDRIV
c
      implicit none
      include 'camx.prm'

      logical  lpost
      integer  nfam
      real     con(MXSPEC+1)
      real     sddm(nfam,MXSPEC)

      real     FUZZ
      parameter ( FUZZ = 10.0 )

      integer  i,ip
c
c---  Entry point
c
      if ( lpost ) then
c
c---  Post-HDDMCHEM adjustments
c
c---  Reset sensitivities for small concentrations
c
        do i = 1, ngas
          if ( con(i) .LE. FUZZ*bdnl(i) ) then
            do ip = 1, nfam
              sddm(ip,i) = 0.0
            enddo
          endif
        enddo

      else
c
c---  Pre-HDDMCHEM adjustments
c
c---  Reset sensitivities for small concentrations
c
        do i = 1, ngas
          if ( con(i) .LE. FUZZ*bdnl(i) ) then
            do ip = 1, nfam
              sddm(ip,i) = 0.0
            enddo
          endif
        enddo

      endif
c
c---  Return point
c
      return
      end

      subroutine xyadvec(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,igrd,
     &                   ncol,nrow,nlay,nrads,nspc,nspcsa,nadv,
     &                   deltat,dx,dy,windu,windv,depth,mapscl,conc,
     &                   lreadtop,ctop,ptrtop,fluxes,isaptr,
     &                   ipa_cel,iproc_id)
      use filunit
      use chmstry
      use bndary
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     XYADVEC drives 2-D advection of concentrations.  This version also
c     performs the 2-D advection on DDM sensitivies, if DDM is implemented.
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        4/23/99   Coarse grid outflow BC's set equal to concentration in
c                  the first inner computational cells
c        4/26/99   Added Piecewise Parabolic Method for horizontal advection
c       10/30/01   Revised map scale factor application to OSAT fluxes to be
c                  more consistent with how the fluxes are used.
c       12/07/01   added instructions for OMP and rearranged some loops
c                  to facilitate parallel processing
c       01/22/02   now only calls OSAT routines if not doing RTRAC
c       01/30/02   Added code for RTRAC probing tool
c        4/10/03   X/Y advection now uses layer-dependent timestep
c       10/13/03   area weighting applied to winds rather than conc
c       07/16/07 -bkoo-     Revised for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       11/04/09   Saving top-layer concentrations for zero-gradient vertical
c                  top boundary condition
c        3/12/10   Removed X/Y advection order flip
c        4/07/14   Added top con file
c       11/28/16 -bkoo-     Updated DDM for new top con
c       12/23/24   Fix logical tests for loading core and PT top cons
c
c     Input arguments:
c        igrd              grid index
c        ncol              number of columns
c        nrow              number of rows
c        nlay              number of layers
c        nrads             number of radicals
c        nspc              number of species
c        nspcsa            number of probing tool species
c        nadv              number of sub-steps per timestep
c        deltat            time step (s)
c        dx                cell size in x-direction (m)
c        dy                cell size in y-direction (m)
c        windu             wind speed in x-direction (m/s)
c        windv             wind speed in y-direction (m/s)
c        depth             layer depth (m)
c        mapscl            map-scale factor at cell centroids
c        conc              species concentrations (umol/m3)
c        lreadtop          top con read from input file
c        isaptr            pointer into tracer conc array for this grid
c        ipa_cel           gridded array to identify if cell is
c                          in a IPRM sub-domain
c        iproc_id          ID for this processor in MPI rank
c
c     Output arguments:
c        conc              species concentrations (umol/m3)
c        ctop              concentrations in top layer (umol/m3)
c        ptrtop            tracer/DDM concentrations in top layer (umol/m3)
c        fluxes            fluxes across the boundaries (umol)
c
c     Routines Called:
c        HADVBOT
c        HADVPPM
c        BOTTDDM
c
c     Called by:
c        EMISTRNS
c
      include "camx.prm"
      include "flags.inc"
c
c=================== Process Analysis Begin ============================
c
      integer ipa_cel(ncol,nrow,nlay)
c
c=================== Process Analysis End ==============================
c
      integer*8 isaptr
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon
      integer :: m_xi1,m_xi2,m_xj1,m_xj2
      integer :: m_yi1,m_yi2,m_yj1,m_yj2

      integer nadv(nlay)
      real, dimension(m1,m2,m3,nspc) :: conc
      real, dimension(m1,m2,m3) :: windu,windv
      real, dimension(m1,m2,m3) :: depth
      real :: mapscl(m1,m2), dx(nrow)
      real, dimension(m1,m2,nspc) :: ctop
      real, dimension(m1,m2,nspcsa) :: ptrtop
      real*8  fluxes(nspc,11)
      integer iproc_id
      integer*8 idx
c
      real*8  flux1,flux2
c
      real   c1d(MXCELLS)
      real   v1d(MXCELLS)
      real   a1d(MXCELLS)
      real   av1d(MXCELLS)
      real   flxarr(MXCELLS)
      real   c1d0(MXCELLS)
      real   fpc(MXCELLS)
      real   fmc(MXCELLS)
      real   fluxcls(MXTRCLS,MXCELLS)
      real   cnccls(MXTRCLS,MXCELLS)
      real   sen1d(MXCELLS,MXFDDM)
      real   sflxarr(MXCELLS)
      real*8 fluxtmp(MXSPEC+MXTRSP,8,MXLAYER)
c
      logical lreadtop
      logical, external :: isbound
c
      common /comxyadvec/ fluxtmp
c
c-----Entry point
c
      num1d = MAX(m1,m2,m3)
c
c-----Intialize the local flux array to zero
c
      do i=1,nspc
        do j=1,8
          do k=1,nlay
            fluxtmp(i,j,k) = 0.
          enddo
        enddo
      enddo
c
c-----Store current top layer concentration if no topcon file given
c
      if (.NOT.lreadtop) then   !<-- this needs to be an argument for reg, SA, RT
        do l = 1,nspc
          do j = 1,m2
            do i = 1,m1
              ctop(i,j,l) = conc(i,j,nlay,l)
            enddo
          enddo
        enddo
c
c======================== DDM Begin =======================
c
        if( (lddm .OR. lhddm) .AND. lddmcalc(igrd)) then
           do l = 1,nspc
             do iddm = 1,nddmsp
               do j = 1,m2
                 do i = 1,m1
                   ioff = iptddm(l) + iddm - 1
                   idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                 DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(nlay-1) + 
     &                                DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                   ptrtop(i,j,l) = ptconc(idx) * ptop_fac(ioff)
                 enddo
               enddo
             enddo
           enddo
        endif
c
c======================== DDM End =======================
c
      endif

      if( .NOT. lmpi ) then
         m_xj1 = 2
         m_xj2 = m2-1
         m_xi1 = 2
         m_xi2 = m1-1
         m_yi1 = 2
         m_yi2 = m1-1
         m_yj1 = 2
         m_yj2 = m2-1
      else
         m_xj1 = 1
         m_xj2 = m2
         m_xi1 = 1
         m_xi2 = m1
         m_yi1 = 1
         m_yi2 = m1
         m_yj1 = 1
         m_yj2 = m2
         if( btest(ibcon,0) ) then
           m_xi1 = 2
           m_yi1 = 2
         endif
         if( btest(ibcon,1) ) then
           m_xi2 = m1-1
           m_yi2 = m1-1
         endif
         if( btest(ibcon,2) ) then
           m_xj1 = 2
           m_yj1 = 2
         endif
         if( btest(ibcon,3) ) then
           m_xj2 = m2-1
           m_yj2 = m2-1
         endif
      endif
c
c-----Advection in x-direction
c
 100  continue
c
c$omp master
c
      if( iproc_id .LE. 1 ) then
         write(*,'(a20,$)') 'x advection ......'
      endif
      write(iout,'(a20,$)') 'x advection ......'
c
c$omp end master
c
c$omp parallel default(shared)
c$omp&  private(i,j,k,ispc,l,c1d,v1d,a1d,nn,iddm,c1d0,ioff,
c$omp&          sen1d,sflxarr,flxarr,flux1,flux2,fpc,fmc,
c$omp&          ipa_idx,fluxcls,cnccls,icls,
c$omp&          istep,dtuse,av1d)
c
c$omp do schedule(static)
c
      do 20 k = 1,nlay
        dtuse = deltat/nadv(k)
        do 21 istep = 1,nadv(k)
c
        do 10 j = m_xj1, m_xj2
          do i = 1,m1-1
            av1d(i) = dy*(depth(i,j,k) + depth(i+1,j,k))/
     &                (mapscl(i,j) + mapscl(i+1,j))
            v1d(i) = windu(i,j,k)
            a1d(i) = mapscl(i,j)*mapscl(i,j)/(dy*depth(i,j,k))
          enddo
          av1d(m1) = dy*depth(m1,j,k)/mapscl(m1,j)
          v1d(m1) = windu(m1,j,k)
          a1d(m1) = mapscl(m1,j)*mapscl(m1,j)/(dy*depth(m1,j,k))
c
c======================== Source Apportion Begin =======================
c
c
c  --- initialize the tracer fluxes/concs to zero ----
c
           if( ltrace ) then
           do i=1,num1d
             do icls=1,ntrcls
                fluxcls(icls,i) = 0.
                cnccls(icls,i) = 0.
             enddo
           enddo
           end if
c
c========================= Source Apportion End ========================
c
c
          do 22 ispc = nrads+1,nspc
c
            do i = 1,m1
              c1d(i) = conc(i,j,k,ispc)
            enddo
            if (btest(ibcon,0) .and. igrd.eq.1 .and. 
     &                          v1d(1).lt.0.) c1d(1) = c1d(2)
            if (btest(ibcon,1) .and. igrd.eq.1 .and. 
     &                          v1d(m1-1).gt.0.) c1d(m1) = c1d(m1-1)
c
c======================== DDM Begin =======================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
               do iddm=1,nddmsp
                 do i = 1,m1
                   c1d0(i) = c1d(i)
                   ioff = iptddm(ispc)+iddm-1
                   idx =  DBLE(isaptr-1) + DBLE(i) + 
     &               DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                             DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                   sen1d(i,iddm) = ptconc(idx)
                 enddo
                 if (igrd.eq.1 .and. v1d(1).lt.0.) 
     &                                  sen1d(1,iddm) = sen1d(2,iddm)
                 if (igrd.eq.1 .and. v1d(m1-1).gt.0.) 
     &                              sen1d(m1,iddm) = sen1d(m1-1,iddm)
               enddo
            endif
c
c======================== DDM End =======================
c

            if (iadvct.eq.2) then
              call hadvbot(m1,dtuse,dx(j+j0),c1d,v1d,a1d,av1d,flxarr,
     &                     fpc,fmc,num1d)
            elseif( iadvct .eq. 3) then
              call hadvppm(m1,dtuse,dx(j+j0),c1d,v1d,a1d,av1d,flxarr,
     &                     num1d)
            endif
c
c======================== DDM Begin =======================
c
            if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              if ( iadvct .eq. 2 ) then
                call bottddm(m1,dtuse,dx(j+j0),ntotsp,sen1d,
     &                       nddmsp,c1d0,c1d,fpc,fmc,v1d,a1d,av1d)
              elseif ( iadvct .eq. 3 ) then
                do iddm=1,nddmsp
                  call hadvppm(m1,dtuse,dx(j+j0),sen1d(1,iddm),
     &                                       v1d,a1d,av1d,sflxarr,num1d)
                enddo
              else ! this should never happen
                write(iout,'(//,a)') 'ERROR in XYADVEC:'
                write(iout,*) '(H)DDM must be used with BOTT or PPM.'
                call camxerr()
              endif
            endif
c
c======================== DDM End =======================
c
c
c=================== Process Analysis Begin ============================
c
            if( lipr ) then
c
c-----Change from X-direction horizontal advection
c 
              l = 1
              do i = 2,m1-1
                l = l+1
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja 
     &                                        .AND. j .LE. jz ) then
                     if( ipa_cel(i+i0,j+j0,k) .GT. 0 ) then
                       ipa_idx = ipa_cel(i+i0,j+j0,k)
c
c-----Flux at west boundary
c
                        cipr(IPR_WADV, ipa_idx, ispc) =
     &                            cipr(IPR_WADV, ipa_idx, ispc) + 
     &                                      a1d(l)*av1d(l-1)*flxarr(l-1)
c
c-----Flux at east boundary
c
                        cipr(IPR_EADV, ipa_idx, ispc) =
     &                       cipr(IPR_EADV, ipa_idx, ispc) - 
     &                                      a1d(l)*av1d(l)*flxarr(l)
c
c-----Average volume
                        cipr(IPR_VOL, ipa_idx, ispc) =
     &                  cipr(IPR_VOL, ipa_idx, ispc) + dx(j+j0)*dy*
     &                                                   depth(i,j,k)
                        npastep(ipa_idx,ispc) = npastep(ipa_idx,ispc)+1
                     endif
                 endif
              enddo
            endif
c
c==================== Process Analysis End =============================
c
c
c======================== Source Apportion Begin =======================
c
            if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                                         tectyp .NE. RTCMC ) then
               l = 0
               do i = 1,m1
                 l = l + 1
                 do icls=1,ntrcls
                     fluxcls(icls,l) = fluxcls(icls,l) + flxarr(l) *
     &                                              fluxmap(ispc,icls)
                     cnccls(icls,l) = cnccls(icls,l) +
     &                           conc(i,j,k,ispc) * fluxmap(ispc,icls)
                 enddo
               enddo
            endif
c
c======================== Source Apportion End =======================
c
            do i = m_xi1, m_xi2
              conc(i,j,k,ispc) = c1d(i)
            enddo
c
c======================== DDM Begin =======================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
               do iddm=1,nddmsp
                 do i = 2,m1-1
                   ioff = iptddm(ispc)+iddm-1
                   idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                              DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                   ptconc(idx) = sen1d(i,iddm)
                 enddo
               enddo
             endif
c
c======================== DDM End =======================
c
c-----Sum up fluxes in east and west sides
c
            flux1 = DBLE(flxarr(1)   *av1d(1)*dx(j+j0)*mapscl(2,j))
            flux2 = DBLE(flxarr(m1-1)*av1d(m1-1)*dx(j+j0)*mapscl(m1-1,j))

            if( 2 .GE. ia .AND. 2 .LE. iz .AND. j .GE. ja 
     &                                    .AND. j .LE. jz ) then
               if (flux1.gt.0.0) then
                 fluxtmp(ispc,7,k)  = fluxtmp(ispc,7,k)  + flux1
               else
                 fluxtmp(ispc,8,k)  = fluxtmp(ispc,8,k)  + flux1
               endif
            endif
            if( m1-1 .GE. ia .AND. m1-1 .LE. iz .AND. j .GE. ja 
     &                                          .AND. j .LE. jz ) then
               if (flux2.lt.0.0) then
                 fluxtmp(ispc,5,k)  = fluxtmp(ispc,5,k)  - flux2
               else
                 fluxtmp(ispc,6,k)  = fluxtmp(ispc,6,k)  - flux2
               endif
            endif
  22      continue
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to update the tracer concentrations
c      based on the calculated fluxes ---
c
          if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                                      tectyp .NE. RTCMC ) then
             call xfluxsa(m1,m2,m3,ntotsp,ptconc(isaptr),
     &                               2,m1-1,j,k,a1d,av1d,fluxcls,cnccls)
          endif
c
c======================== Source Apportion End =======================
c
c  --- next row, non-parallelized loop ---
c
  10    continue
c
c  --- next layer ---
c
  21  continue
  20  continue
c
c  --- end of parallelized loop ---
c
c$omp end parallel
c
c$omp master
c
      if( iproc_id .LE. 1) then
         write(*,'(a)') '   Done'
         call flush(6)
      endif
      write(iout,'(a)') '   Done'
      call  flush(iout)
c
c$omp end master
c
c-----Advection in y-direction
c
 200  continue
c
c$omp master
c
      if( iproc_id .LE. 1) then
         write(*,'(a20,$)') 'y advection ......'
      endif
      write(iout,'(a20,$)') 'y advection ......'
c
c$omp end master
c
c$omp parallel default(shared)
c$omp&  private(i,j,k,ispc,l,c1d,v1d,a1d,nn,iddm,c1d0,ioff,
c$omp&          sen1d,sflxarr,flxarr,flux1,flux2,fpc,fmc,
c$omp&          ipa_idx,fluxcls,cnccls,icls,
c$omp&          istep,dtuse,av1d)
c
c$omp do schedule(static)
c

      do 40 k = 1,nlay
        dtuse = deltat/nadv(k)
        do 41 istep = 1,nadv(k)
c
        do 30 i = m_yi1, m_yi2
          do j = 1, m2-1   !nrow-1
            av1d(j) = (dx(j+j0)*depth(i,j,k) + 
     &                 dx(j+j0+1)*depth(i,j+1,k))/
     &                (mapscl(i,j) + mapscl(i,j+1))
            v1d(j) = windv(i,j,k)
            a1d(j) = mapscl(i,j)*mapscl(i,j)/
     &               (dx(j+j0)*depth(i,j,k))
          enddo
          av1d(m2) = dx(m2+j0)*depth(i,m2,k)/mapscl(i,m2)
          v1d(m2) = windv(i,m2,k)
          a1d(m2) = mapscl(i,m2)*mapscl(i,m2)/
     &              (dx(m2+j0)*depth(i,m2,k))
c
c======================== Source Apportion Begin =======================
c
c  --- initialize the tracer fluxes/concs to zero ----
c
          if (ltrace) then
            do j=1,num1d
               do icls=1,ntrcls
                  fluxcls(icls,j) = 0.
                  cnccls(icls,j) = 0.
               enddo
            enddo
          endif
c
c========================= Source Apportion End ========================
c
         do 42 ispc = nrads+1,nspc
c
            do j = 1,m2  !nrow
              c1d(j) = conc(i,j,k,ispc)
            enddo
            if (btest(ibcon,2) .and. igrd.eq.1 .and. 
     &                            v1d(1).lt.0.) c1d(1) = c1d(2)
            if (btest(ibcon,3) .and. igrd.eq.1 .and. 
     &                            v1d(m2-1).gt.0.) c1d(m2) = c1d(m2-1)
c
c======================== DDM Begin =======================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
               do iddm=1,nddmsp
                 do j = 1, m2
                   c1d0(j) = c1d(j)
                   ioff = iptddm(ispc)+iddm-1
                   idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                              DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                   sen1d(j,iddm) = ptconc(idx)
                 enddo
                 if (igrd.eq.1 .and. v1d(1).lt.0.) 
     &                                     sen1d(1,iddm) = sen1d(2,iddm)
                 if (igrd.eq.1 .and. v1d(m2-1).gt.0.) 
     &                                 sen1d(m2,iddm) = sen1d(m2-1,iddm)
               enddo
            endif
c
c======================== DDM End =======================
c
            if (iadvct.eq.2) then
              call hadvbot(m2,dtuse,dy,c1d,v1d,a1d,av1d,flxarr,
     &                     fpc,fmc,num1d)
            elseif( iadvct .eq. 3) then
              call hadvppm(m2,dtuse,dy,c1d,v1d,a1d,av1d,flxarr,num1d)
            endif
c
c======================== DDM Begin =======================
c
            if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              if ( iadvct .eq. 2 ) then
                call bottddm(m2,dtuse,dy,ntotsp,sen1d,nddmsp,
     &                               c1d0,c1d,fpc,fmc,v1d,a1d,av1d)
              elseif ( iadvct .eq. 3 ) then
                do iddm=1,nddmsp
                  call hadvppm(m2,dtuse,dy,sen1d(1,iddm),
     &                                       v1d,a1d,av1d,sflxarr,num1d)
                enddo
              else ! this should never happen
                write(iout,'(//,a)') 'ERROR in XYADVEC:'
                write(iout,*) '(H)DDM must be used with BOTT or PPM.'
                call camxerr()
              endif
            endif
c
c======================== DDM End =======================
c
c
c=================== Process Analysis Begin ============================
c
            if( lipr ) then
c
c-----Change from Y-direction horizontal advection
c 
              l = 1
              do j = 2,m2-1
                l = l+1
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja 
     &                                         .AND. j .LE. jz ) then
                    if( ipa_cel(i+i0,j+j0,k) .GT. 0 ) then
                      ipa_idx = ipa_cel(i+i0,j+j0,k)
c
c-----Flux at south boundary
c
                      cipr(IPR_SADV, ipa_idx, ispc) =
     &                           cipr(IPR_SADV, ipa_idx, ispc) + 
     &                                      a1d(l)*av1d(l-1)*flxarr(l-1)
c
c-----Flux at north boundary
c
                      cipr(IPR_NADV, ipa_idx, ispc) =
     &                           cipr(IPR_NADV, ipa_idx, ispc) - 
     &                                          a1d(l)*av1d(l)*flxarr(l)
c
                    endif
                endif
              enddo
            endif
c
c==================== Process Analysis End =============================
c
c
c======================== Source Apportion Begin =======================
c
            if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                                          tectyp .NE. RTCMC ) then
               l = 0
               do j = 1, m2
                 l = l + 1
                 do icls=1,ntrcls
                     fluxcls(icls,l) = fluxcls(icls,l) + flxarr(l) *
     &                                              fluxmap(ispc,icls)
                     cnccls(icls,l) = cnccls(icls,l) +
     &                           conc(i,j,k,ispc) * fluxmap(ispc,icls)
                 enddo
              enddo
            endif
c
c======================== Source Apportion End =======================
c
            do j = m_yj1, m_yj2
              conc(i,j,k,ispc) = c1d(j)
            enddo
c
c======================== DDM Begin =======================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
               do iddm=1,nddmsp
                 do j = 2,m2-1
                   ioff = iptddm(ispc)+iddm-1
                   idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                            DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                   ptconc(idx) = sen1d(j,iddm)
                 enddo
               enddo
            endif
c
c======================== DDM End =======================
c
c
c-----Sum up fluxes in north and south sides
c
            flux1 = DBLE(flxarr(1)   *av1d(1)*dy*mapscl(i,2))
            flux2 = DBLE(flxarr(m2-1)*av1d(m2-1)*dy*mapscl(i,m2-1))
            if(i .GE. ia .AND. i .LE. iz .AND. 2 .GE. ja 
     &                                   .AND. 2 .LE. jz ) then
               if (flux1.gt.0.0) then
                 fluxtmp(ispc,3,k)  = fluxtmp(ispc,3,k)  + flux1
               else
                 fluxtmp(ispc,4,k)  = fluxtmp(ispc,4,k)  + flux1
               endif
            endif
            if(i .GE. ia .AND. i .LE. iz .AND. m2-1 .GE. ja 
     &                                   .AND. m2-1 .LE. jz ) then
               if (flux2.lt.0.0) then
                 fluxtmp(ispc,1,k)  = fluxtmp(ispc,1,k)  - flux2
               else
                 fluxtmp(ispc,2,k)  = fluxtmp(ispc,2,k)  - flux2
               endif
            endif
  42      continue
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to update the tracer concentrations
c      based on the calculated fluxes ---
c
         if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                                         tectyp .NE. RTCMC ) then
            call yfluxsa(m1,m2,m3,ntotsp,ptconc(isaptr),
     &                               i,2,m2-1,k,a1d,av1d,fluxcls,cnccls)
         endif
c
c======================== Source Apportion End =======================
c
  30    continue
c
c  --- next layer, end of parallelized loop ---
c
  41  continue
  40  continue
c
c$omp end parallel
c
c$omp master
c
      if( iproc_id .LE. 1) then
         write(*,'(a)') '   Done'
         call flush(6)
      endif
      write(iout,'(a)') '   Done'
      call flush(iout)
c
c$omp end master
c
 300  continue
c
c  ---- put fluxes into global array ----
c
      do i=1,nspc
        do j=1,8
          do k=1,nlay
            fluxes(i,j) = fluxes(i,j) + fluxtmp(i,j,k)
          enddo
        enddo
      enddo
c
      call flush(6)
      call flush(iout)
c
      return
      end

c**** NCF_RD_SA_TCFILE
c
      subroutine ncf_rd_sa_tcfile()
      use grid
      use camxfld
      use filunit
      use tracer
      implicit none
c     
c----CAMx v7.40 260801
c
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Reads the source apportionment TC file and loads the values into
c     the tracer concentration array. This version is for NetCDF files.
c 
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c       Outputs:
c           
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include  files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'chmdat.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  this_var
      integer       data_start(4), data_count(4), this_tstep, ispc
      integer       this_varid, date_time_tflag, date_time_etflag, ierr
      integer       n3d, i, j, k
      real          convfac
c
      real,         allocatable,  dimension(:,:,:) ::  tinit
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = 1
c
c   --- get the timestep that encompasses this date/time ---
c
      action = 'Reading NetCDF SA initial conditions file.'
      write(idiag,'(/,A)') TRIM(action)
      call flush(idiag)
      this_tstep = ncf_get_tstep(iortc,action,begdate,begtim,
     &                 date_time_tflag,date_time_etflag,.FALSE.,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  ---- allocate the temp array ---
c
      allocate( tinit(ncol(1),nrow(1),1) )
c
c  ---- loop over model species in the TC file ---
c
      do ispc=1,num_iorbc
          this_var = spc_iorbc(ispc)
c
c  --- find this species in the file ---- 
c
          ierr = nf_inq_varid(iortc, this_var, this_varid)
          if( ierr .NE. NF_NOERR) goto 7000
          ierr = nf_get_vara_real(iortc,this_varid,data_start,
     &                                               data_count,tinit)
          if( ierr .NE. NF_NOERR) goto 7001
c
c   --- echo that species was found in this file ---
c
          write(idiag,'(2A)') '   --- Found species: ',TRIM(this_var)
          call flush(idiag)
c
c  ---- put concs into the global array at correct offset ---
c
          do k=1,ncol(1)
            do j = 1,nrow(1)
               n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(ispc - 1)
               pttop(n3d) = BNDLPT
               pttop(n3d) = AMAX1(pttop(n3d),tinit(i,j,1))
            enddo
          enddo
c
c  --- next species ---
c
      enddo
c
      deallocate( tinit )
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 write(iout,'(//,A)') 'ERROR in NCF_RD_SA_TCFILE:'
      write(iout,'(A)') TRIM(action)
      write(iout,'(2A)') 'Cannot find SA TC species in file: ',TRIM(this_var)
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 write(iout,'(//,A)') 'ERROR in NCF_RD_SA_TCFILE:'
      write(iout,'(A)') TRIM(action)
      write(iout,'(2A)') 'Error reading gridded data from SA TC species ',
     &                                    TRIM(this_var),' in SA TC file.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

C**** NCF_READINP_CLD
c
      subroutine ncf_readinp_cld(igrd,ncol,nrow,nlay,cldwtr,ranwtr,
     &                      snowtr,gplwtr,cldod,cldph,cigfrc,cigtim,
     &                                    cigwtr,cigpcp,cigent,cigdet)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines reads the cloud data in the 3D met file.
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c
c     Output arguments:
c        cldwtr              cloud water content (g/m3)
c        ranwtr              rain water content (g/m3)
c        snowtr              snow water content (g/m3)
c        gplwtr              graupel water content (g/m3)
c        cldod               cloud optical depth
c        cldph               cloud water pH
c        cigfrc              convective cloud fraction (unitless)
c        cigtim              convective cloud timescale (s)
c        cigwtr              convective cloud water (g/m3)
c        cigpcp              convective cloud precip (g/m3)
c        cigent              convective cloud entrainment (kg/m2/s)
c        cigdet              convective cloud detrainment (kg/m2/s)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      integer nlay
      real    cldwtr(ncol,nrow,nlay)
      real    ranwtr(ncol,nrow,nlay)
      real    snowtr(ncol,nrow,nlay)
      real    gplwtr(ncol,nrow,nlay)
      real    cldod(ncol,nrow,nlay)
      real    cldph(ncol,nrow,nlay)
      real    cigfrc(ncol,nrow)
      real    cigtim(ncol,nrow)
      real    cigwtr(ncol,nrow,nlay)
      real    cigpcp(ncol,nrow,nlay)
      real    cigent(ncol,nrow,nlay)
      real    cigdet(ncol,nrow,nlay)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start_3d(4), data_count_3d(4)
      integer       data_start_2d(3), data_count_2d(3)
      integer       this_tstep, nfound, i, j, k
      integer       this_time_tflag, this_time_etflag
      real          whr, wmn, atim
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      call zeros(cldwtr,ncol*nrow*nlay)
      call zeros(ranwtr,ncol*nrow*nlay)
      call zeros(snowtr,ncol*nrow*nlay)
      call zeros(gplwtr,ncol*nrow*nlay)
      call zeros(cldod,ncol*nrow*nlay)
c
      if( .NOT. is_netcdf_i3dmet(igrd) ) goto 9999
c
      write(action,'(A,I3)') 'Reading Cloud data in 3D met file for grid ',igrd
c
c --- Find the date/time at the next update interval ---
c
      whr = aint(time/100.)
      wmn = anint(amod(time,100.))
      atim = 100.*whr + wmn
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(i3dmet(igrd),action,date,atim,
     &                this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start_3d(1) = 1
      data_count_3d(1) = ncol
      data_start_3d(2) = 1
      data_count_3d(2) = nrow
      data_start_3d(3) = 1
      data_count_3d(3) = nlay
      data_start_3d(4) = this_tstep
      data_count_3d(4) = 1
c
      data_start_2d(1) = 1
      data_count_2d(1) = ncol
      data_start_2d(2) = 1
      data_count_2d(2) = nrow
      data_start_2d(3) = this_tstep
      data_count_2d(3) = 1
c
c ---- cloud water content ----
c
      this_var = "cloudwater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cldwtr)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- rain water content ----
c
      this_var = "rainwater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,ranwtr)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- snow water content ----
c
      this_var = "snowater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,snowtr)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- graupel water content ----
c
      this_var = "grplwater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,gplwtr)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- cloud optical depth ---
c
      this_var = "cloudod"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cldod)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c-----Initialize cloud pH
c
      cldph = 5.
c
c --- if not doing convection in cloud just exit ---
c
      if( .NOT. lcig(igrd) ) goto 9999
c
c ---- convective cloud fraction ----
c
      nfound = 0
      this_var = "kf_cldfrac"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_2d,
     &                                             data_count_2d,cigfrc)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ----  convective cloud timescale ----
c
      this_var = "kf_tscale"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_2d,
     &                                             data_count_2d,cigtim)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- convective cloud water ---
c
      this_var = "kf_cldwater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cigwtr)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- convective cloud precip ---
c
      this_var = "kf_pcpwater"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cigpcp)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- convective cloud entrainment ---
c
      this_var = "kf_entrain"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cigent)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c ---- convective cloud detrainment ---
c
      this_var = "kf_detrain"
      ierr = nf_inq_varid(i3dmet(igrd), this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
         nfound = nfound + 1
         ierr = nf_get_vara_real(i3dmet(igrd),this_varid,data_start_3d,
     &                                             data_count_3d,cigdet)
         if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c  --- make sure everything is here for convection in cloud ---
c
      if( nfound .NE. 6 ) then
         lcig(igrd) = .false.
         write(iout,'(//,a)')'WARNING in NCF_READINP_CLD:'
         write(iout,'(a)') action
         write(iout,'(2a)')'Subgrid convective cloud data were not',
     &                       ' found on file'
         write(iout,'(2a)')'Convective treatment will not be',
     &                       ' applied for this grid'
         write(iout,*)
      endif
c
c  --- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5,a,i3)') 
     &    'Read cloud data from 3D met file at ',atim,date,' grid',igrd
      call flush(iout)
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_CLD:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READINP_CLD:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine pigwalk(dt) 
      use grid
      use filunit
      use camxfld
      use pigsty
c
c----CAMx v7.40 260801
c
c     PIGWALK transports PiG puffs for the duration of one input timestep
c
c      Copyright Ramboll
c
c     Modifications:
c        9/5/03              Revised to transport puff ends in "chained"
c                            puff approach
c        9/30/14             Added vertical advection of puff centerpoint
c
c     Input arguments:
c        dt                  time step (s)     
c
c     Output arguments:
c        none
c
c     Subroutines called:
c        PIGCOORD
c        WALK1PUF
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include "camx.prm"
c
      real dt,dtcell,xpig,ypig,dzbot,dztop,puffb,pufft,ztop
      real ww(0:MXLAYER)
      integer n,kount,igrd,iipig,jjpig,ingrdf,ingrdb
      integer nflip
      logical lkick
c
c-----Entry point
c
c-----Loop over all PiGs; find active puffs to move
c
      do 20 n = 1,npig
        if (ingrd(n).eq.0) goto 20
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,iipig,jjpig,igrd)
c
c-----Walk the leading (front) edge
c     New born PiGs walk for the duration of their age;
c     Older puffs walk for the duration of the current timestep
c
        call pigcoord(xpigf(n),ypigf(n),iipig,jjpig,ingrdf)
c
        if (lnewt(n)) then
          dtcell = agepigf(n)
        else
          dtcell = dt
          agepigf(n) = agepigf(n) + dt
        endif
c
        kount = 0
        nflip = 0
        lkick = .false.
  10    kount = kount + 1
        igrd = ingrdf
        call walk1puf(dtcell,igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &                iipig,jjpig,ingrdf,lkick,xpigf(n),ypigf(n),
     &                pufftop(n),puffbot(n),windu(iptr3d(igrd)),
     &                windv(iptr3d(igrd)),height(iptr3d(igrd)),
     &                press(iptr3d(igrd)),tempk(iptr3d(igrd)))
        if (igrd.ne.ingrdf) nflip = nflip + 1
        if (kount.gt.50 .and. dtcell.gt.0.) then
          if (nflip.ge.10) then
            nflip = 0
            lkick = .true.
            goto 10
          endif
          write(iout,'(//,a)') 'ERROR in PIGWALK:'
          write(iout,*) 'Number of steps > 50'
          write(iout,*) 'Front edge: Puff#,grid#,timestep left:'
          write(iout,*) n,ingrdf,dtcell
          write(iout,*) 'Location (i,j), puff top & bottom'
          write(iout,*) iipig,jjpig,pufftop(n),puffbot(n)
          call camxerr()
        endif
        if (dtcell.gt.0.) goto 10
        if (ingrdf.eq.0) then
          ingrd(n) = 0
          goto 20
        endif
c
c-----Walk the trailing (back) edge
c
        call pigcoord(xpigb(n),ypigb(n),iipig,jjpig,ingrdb)
c
        if (lnewt(n)) then
          dtcell = agepigb(n)
        else
          dtcell = dt
          agepigb(n) = agepigb(n) + dt
        endif
        if (dtcell.eq.0.) goto 30
c  
        kount = 0
        nflip = 0
        lkick = .false.
  11    kount = kount + 1
        igrd = ingrdb
        call walk1puf(dtcell,igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &                iipig,jjpig,ingrdb,lkick,xpigb(n),ypigb(n),
     &                pufftop(n),puffbot(n),windu(iptr3d(igrd)),
     &                windv(iptr3d(igrd)),height(iptr3d(igrd)),
     &                press(iptr3d(igrd)),tempk(iptr3d(igrd)))
        if (igrd.ne.ingrdb) nflip = nflip + 1
        if (kount.gt.50 .and. dtcell.gt.0.) then
          if (nflip.ge.10) then
            nflip = 0
            lkick = .true.
            goto 11
          endif
          write(iout,'(//,a)') 'ERROR in PIGWALK:'
          write(iout,*) 'Number of steps > 50'
          write(iout,*) 'Back edge: Puff#,grid#,timestep left:'
          write(iout,*) n,ingrdb,dtcell
          write(iout,*) 'Location (i,j), puff top & bottom'
          write(iout,*) iipig,jjpig,pufftop(n),puffbot(n)
          write(iout,*) 
          call camxerr()
        endif
        if (dtcell.gt.0.) goto 11
        if (ingrdb.eq.0) then
          ingrd(n) = 0
          goto 20
        endif
c
c-----Determine new puff center point coords, host grid, and puff length
c
 30     xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,iipig,jjpig,ingrd(n))
        igrd = ingrd(n)
        if (lnewt(n)) then
          lnewt(n) = .false.
          goto 20
        endif
c
c-----Calculate vertical velocity profile and move puff for full timestep
c
        call getdwdz(ncol(igrd),nrow(igrd),nlay(igrd),iipig,jjpig,
     &               deltax(jjpig,igrd),deltay(igrd),
     &               height(iptr3d(igrd)),press(iptr3d(igrd)),
     &               tempk(iptr3d(igrd)),windu(iptr3d(igrd)),
     &               windv(iptr3d(igrd)),ztop,ww)
c
        dzbot = zpig(n) - puffbot(n)
        dztop = pufftop(n) - zpig(n)
c
        call walk1pufz(dt,ncol(igrd),nrow(igrd),nlay(igrd),iipig,jjpig,
     &                 zpig(n),height(iptr3d(igrd)),ww)
c
        puffb = amax1(0.,zpig(n) - dzbot)
        pufft = amin1(ztop,zpig(n) + dztop)
        if (puffb.eq.0.) pufft = puffb + axisz(n)
        if (pufft.eq.ztop) puffb = pufft - axisz(n)
        puffbot(n) = puffb
        pufftop(n) = pufft
        zpig(n) = (pufftop(n) + puffbot(n))/2.
        axisz(n) = pufftop(n) - puffbot(n)
c
  20  continue
c
      return
      end
c
c-------------------------------------------------------------------------------
c
      subroutine getdwdz(ncol,nrow,nlay,i,j,dx,dy,
     &                   height,press,tempk,windu,windv,ztop,ww)
c
c-----GETDWDZ calculates the vertical velocity profile
c     
      implicit none
      include "camx.prm"
      integer ncol,nrow,nlay,i,j
      real dx,dy,ztop,height(ncol,nrow,nlay),
     &     press(ncol,nrow,nlay),tempk(ncol,nrow,nlay),
     &     windu(ncol,nrow,nlay),windv(ncol,nrow,nlay)
      integer kk
      real deplyr,uup,uum,vvp,vvm,rho,rhoxp,rhoxm,rhoyp,rhoym
      real ww(0:MXLAYER)
c 
c-----Entry point
c
      ztop = height(i,j,nlay)
      ww(0) = 0.
      do kk = 1,nlay
        deplyr = height(i,j,kk)
        if (kk.gt.1) deplyr = height(i,j,kk) - height(i,j,kk-1)
        rho  = press(i,j,kk)/tempk(i,j,kk)
        rhoxp = press(i+1,j,kk)/tempk(i+1,j,kk)
        rhoxm = press(i-1,j,kk)/tempk(i-1,j,kk)
        rhoyp = press(i,j+1,kk)/tempk(i,j+1,kk)
        rhoym = press(i,j-1,kk)/tempk(i,j-1,kk)
        uup = windu(i,j,kk)*(rhoxp + rho)/2.
        uum = windu(i-1,j,kk)*(rhoxm + rho)/2.
        vvp = windv(i,j,kk)*(rhoyp + rho)/2.
        vvm = windv(i,j-1,kk)*(rhoym + rho)/2.
        ww(kk) = ww(kk-1) - (deplyr/rho)*
     &                      ((uup - uum)/dx + (vvp - vvm)/dy)
      enddo
c
      return
      end

      subroutine wrtmass(igrd,chdate,chtime,ind)
      use filunit
      use chmstry
      use camxfld
c
c----CAMx v7.40 260801
c
c     WRTMASS writes out mass and fluxes at specified time,
c     and zeros out accumulation arrays
c
c      Copyright Ramboll
c          
c     Modifications:
c        5/16/00   Modified mass output to facilitate import to a spreadsheet
c        2/02/06   Removed GREASD-PiG specific mass output
c
c     Input arguments:
c        igrd                grid index
c        chtime              simulation time ('HH:MM:SS')
c        chdate              simulation date ('YY/MM/DD')
c        ind                 code to select whether to output or initialize
c
c     Output arguments:
c        none
c
c     Subroutines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
      real*8 fluxin,fluxout
      character*10 nammass(21)
      character*8 chdate,chtime
      data nammass/'Start Mass','Final Mass','Grid Emiss','Pnt Emiss ',
     &             'North IN  ','North OUT ','South IN  ','South OUT ',
     &             'East IN   ','East OUT  ','West IN   ','West OUT  ',
     &             'Top IN    ','Top OUT   ','Deposition','Chemistry ',
     &             'Nest Chnge','PiG Change','Net Change','Residual  ',
     &             'Mass Error'/
      data cf /1.e-6/
c
      real*8 xincrmnt(MXSPEC)
      real*8 pigdmp(MXSPEC)
c
c-----Entry point
c
c-----Compute residual
c
      if (ind.eq.1) then
        do l = nrad+1,nspec
          pigdmp(l) = pigdump(l,igrd)
        enddo
        do l = nrad+1,nspec
          fluxin = 0.
          do i = 1,9,2
            fluxin = fluxin + fluxes(l+(i-1)*nspec,igrd) 
          enddo
          fluxout = 0.
          do i = 2,10,2
            fluxout = fluxout + fluxes(l+(i-1)*nspec,igrd) 
          enddo
          fluxout = fluxout + fluxes(l+(11-1)*nspec,igrd) 
          xincrmnt(l) = fluxin + fluxout + armass(l,igrd) + 
     &                  ptmass(l,igrd) + xmschem(l,igrd) + 
     &                  xmsfin(l,igrd) + pigdmp(l)
          resid(l,igrd) = xmsold(l,igrd) + xincrmnt(l) - xmass(l,igrd)
        enddo
c
c-----Write mass and fluxes at this date/hour
c
        write(imass,*)
        write(imass,'(a10,3x,a5,2a10,21(3x,a10))') 
     &       'Species','Grid','Date','Time',(nammass(i),i=1,21)
        do l = nrad+1,nspec
          denom = max(xmsold(l,igrd), xmass(l,igrd),
     &            armass(l,igrd), ptmass(l,igrd),
     &            abs(xmschem(l,igrd)), abs(xmsfin(l,igrd)),
     &            abs(pigdmp(l)))
          do j = 1,11
            denom = max(abs(real(fluxes(l+(j-1)*nspec,igrd))),denom)
          enddo
          write(imass,'(3x,a10,i5,2x,a8,2x,a8,21(1pe13.4))') 
     &       spname(l),igrd,chdate,chtime,
     &       xmsold(l,igrd)*cf,xmass(l,igrd)*cf,armass(l,igrd)*cf,
     &       ptmass(l,igrd)*cf,(fluxes(l+(i-1)*nspec,igrd)*cf,i=1,11),
     &       xmschem(l,igrd)*cf,xmsfin(l,igrd)*cf,pigdmp(l)*cf,
     &       xincrmnt(l)*cf,resid(l,igrd)*cf,abs(resid(l,igrd)/denom)
        enddo
c
c-----Move current mass array to old mass array
c
        do l = nrad+1,nspec
          xmsold(l,igrd) = xmass(l,igrd)
        enddo
      endif
c
c-----Zeros the mass and fluxes
c
      do l = nrad+1,nspec
        armass(l,igrd) = 0.
        ptmass(l,igrd) = 0.
        do i=1,11
          fluxes(l+(i-1)*nspec,igrd) = 0.
        enddo
        xmschem(l,igrd) = 0.
        xmsfin(l,igrd) = 0.
        pigdmp(l) = 0.
        pigdump(l,igrd) = 0.
        pgmserr(l,igrd) = 0.
      enddo
c
      return
      end

      subroutine nobinary()
      use filunit
c   
c----CAMx v7.40 260801
c   
c     NOBINARY writes a message about Fortran binary formatted files
c              no longer supported and then calls routing to exit.
c                             
c      Copyright Ramboll
c             
c     Modifications:   
c        none 
c 
c     Input arguments:
c        none 
c 
c     Output arguments: 
c        none 
c               
c     Routines Called:   
c        none 
c               
c     Called by:   
c 
      include "camx.prm"
      include "flags.inc"
      include "mpif.h"
c
c-----Entry point
c
      write(iout,'(/)') 
      write(iout,*) ' ERROR: This version no longer supports Fortran binary UNFORMATTED files.'
      write(iout,*) '        Please convert all binary files to NetCDF format.'
      write(iout,'(/)') 
      call flush(6)
c
      call camxerr()
c
      end

c*** ADJDDMC0
c
      subroutine adjddmc0(ispc,ixcl,jycl,kzcl,fc2r,fr2c,fc2rc0,fr2cc0,
     &                    c0trac,tmtrac,cellvol,lzerc,
     &                    ncolx,nrowy,nlayz,nsens,snsconc)
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine makes Wet Dep adjustments to the DMM sensitivities.
c     The adjustments are based on the relative fluxes between cell
c     and rain for the affected species.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       ispc    I  index into regular model species order
c       ixcl    I  the X grid location of current cell
c       jycl    I  the Y grid location of current cell
c       kzcl    I  the vertical grid location of current layer
c       fc2r    R  relative flux from cell to rain
c       fr2c    R  relative flux from rain to cell
c       fc2rc0  R  relative C0 flux from cell to rain
c       fr2cc0  R  relative C0 flux from rain to cell
c       cellvol R  cell volume (m3)
c       lzerc   L  true if cell concentrations are at lower bound
c       ncolx   I  number of columns in this grid
c       nrowy   I  number of rows in this grid
c       nlayz   I  number of layers in this grid
c       nsens   I  number of DDM sensitivies
c       snsconc R  gridded array of sensitivities
c       tmtrac  R  total rain mass for sensitivities (umol units)
c     Output: 
c       snsconc R  gridded array of sensitivities
c       tmtrac  R  total rain mass for sensitivities (umol units)
c       c0trac  R  rain concentration for sensitivities (umol/m3 rain)
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c       04/08/03  --gwilson--   Original development
c       08/15/03  --gyarwood--  Revised adjustments
c       12/22/09  --cemery--    Improved treatment of "c0"
c       06/07/16  --cemery--    Removed code related to rain evap
c       05/22/19  --gyarwood--  On lzerc, set snsconc to 0.0 not BNDLPT
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   ispc
      integer   ixcl
      integer   jycl
      integer   kzcl
      real      fc2r
      real      fr2c
      real      fc2rc0
      real      fr2cc0
      real      c0trac(*)
      real      tmtrac(*)
      real      cellvol
      logical   lzerc
      integer   ncolx
      integer   nrowy
      integer   nlayz
      integer   nsens
      real      snsconc(ncolx,nrowy,nlayz,nsens)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer idxspec, i
      real    sum
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- adjust all the sensitivities associated with this species 
c       if lzerc is true, all the sensitivity is scavenged by rain ---
c
      if (lzerc) then
        do i=1,nddmsp
          idxspec = iptddm(ispc)+i-1
          sum = snsconc(ixcl,jycl,kzcl,idxspec)
          c0trac(idxspec) = c0trac(idxspec) +
     &                      fc2rc0*snsconc(ixcl,jycl,kzcl,idxspec)
          snsconc(ixcl,jycl,kzcl,idxspec) = 0.0
          tmtrac(idxspec) = tmtrac(idxspec) + sum * cellvol
        enddo
      else
        do i=1,nddmsp
          idxspec = iptddm(ispc)+i-1
          sum = (fc2r * snsconc(ixcl,jycl,kzcl,idxspec)) -
     &                                       (fr2c * c0trac(idxspec))
          snsconc(ixcl,jycl,kzcl,idxspec) = 
     &                           snsconc(ixcl,jycl,kzcl,idxspec) - sum
          tmtrac(idxspec) = tmtrac(idxspec) + sum * cellvol
          sum = (fc2rc0 * snsconc(ixcl,jycl,kzcl,idxspec)) -
     &                                       (fr2cc0 * c0trac(idxspec))
          c0trac(idxspec) = c0trac(idxspec) + sum
        enddo
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

c*** SRFMODRT
c
      subroutine srfmodrt(numcol,numrow,igrid,icell,jcell,dtime,zenith,
     &                    ctrns,ldrk)
      use grid
      use rtracchm
      use camxfld
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine performs chemistry adjustments on the reactive
c     tracer species in soil/vegetation using information from the
c     RTRAC chemistry input file.  
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol  I number of columns in this slice
c       numrow  I number of rows in this slice
c       igrid   I  number of the grid containing the cell
c       icell   I  X index of the cell
c       jcell   I  Y index of the cell
c       dtime   R  time step (hours)
c       zenith  R  solar zenith angle (rad)
c       ctrns   R  UV cloud transmissivity
c       ldrk    L  darkness flag
c
c   Routines called:
c
c   Called by:
c       CHEMDRIV 
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     12/08/09   ---jjung---    Original development
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
      include 'deposit.inc'
      include 'rtracsrf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer igrid
      integer icell
      integer jcell
      real    dtime
      real    zenith
      real    ctrns
      logical ldrk
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      integer   idx
      integer   idxcel
      integer   idxsrf
      integer   m
      integer   iwater
      real      fshads
      real      fshadv
      real      fzenith
      real      deg2rad
      real      zenang
      real      totland
      real      effkphots
      real      effkphotv
      real      dsolrate
      real      dvegrate
      real      eps
c
      data deg2rad /0.01745329/
      data eps /1.0e-20/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Calculate array pointers for the current grid cell ---
c
      idxcel =  ipsa2d(igrid)-1 + icell + numcol*(jcell-1)
      idxsrf =  iptrlu(igrid)-1 + icell + numcol*(jcell-1)
c
c --- Calculate photolysis reduction factors (shade, solar angle, clouds)
c
      zenang = amin1(zenith,60.0)
      zenang = deg2rad*zenang
      fshads = 0.0
      fshadv = 0.5
      totland = 0.0
      fzenith = 0.0
      if (.not.ldrk) then
        do m = 1,NLUW89
          idx = idxsrf + numcol*numrow*(m-1)
          fshads = fshads + fsoil(m)*fsurf(idx)
          totland = totland + fsurf(idx)
        enddo
        totland = amax1(totland,eps)
        fshads = fshads/totland
        fzenith = cos(zenang)
      endif
c
c --- Apply decay rates for photolysis, hydrolysis, leaching, and
c     plant penetration
c
      do i = 1,nrtgas
         effkphots = kphot(i)*fshads*fzenith*ctrns
         effkphotv = kphot(i)*fshadv*fzenith*ctrns
         dsolrate = kleach(i) + khydro(i) + effkphots
         dvegrate = kpen(i)   + khydro(i) + effkphotv
         idx = idxcel + numcol*numrow*(i-1)
         rtsolmas(idx) = rtsolmas(idx)*EXP(-dsolrate*dtime*60.)
         rtvegmas(idx) = rtvegmas(idx)*EXP(-dvegrate*dtime*60.)
         rtsolmas(idx) = MAX(1.e-20,rtsolmas(idx))
         rtvegmas(idx) = MAX(1.e-20,rtvegmas(idx))
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

C=====================================================================
C
C   MATRIX SOLVER SUBROUTINES FOR DDM-PM
C
C   Subroutines included in this file:
C     DDMEQNSUB
C     DDMEQNSLV
C
C   Dependent upon:
C     none
C
C   Log:
C     03/03/2005  bkoo - original development
C
C=====================================================================

      SUBROUTINE DDMEQNSUB (L1,L2)
      LOGICAL   L1,L2
      L1 = .FALSE.
      L2 = .FALSE.
      RETURN
      END
C     END OF SUBROUTINE DDMEQNSUB


      SUBROUTINE DDMEQNSLV (NSENS,LSEQ,LSEN,AMAT,NDDMSP,XLIQ,
     &                      NDIM,AA,BB,IPVT,IERR,IOUT)

      INTEGER   NSENS, NDDMSP, NDIM
      LOGICAL   LSEQ(NSENS)               ! Logical flag for eqns
      LOGICAL   LSEN(NSENS)               ! Logical flag for sensitivities
      REAL      AMAT(NSENS,NSENS),XLIQ(NSENS,NDDMSP)

      REAL      AA(NDIM,NDIM),BB(NDIM)    ! Now adjustable arrays
      INTEGER   IPVT(NDIM)
      INTEGER   IERR, IOUT

      INTEGER   IDX(NDIM)
      INTEGER   IEQN, JEQN, IVAR, JVAR, J, INFO, JOB
      INTEGER   NERR, MXERR
      PARAMETER( MXERR = 5 )              ! Max error count
      LOGICAL   LAFAC
      REAL      AFAC, RLMT
      PARAMETER( AFAC = 1.E-2 )           ! Adjustment factor
C
C     Initialization
C
      NERR = 0
      RLMT = 1.E37                        ! Limiting magnitude of the coeffs
C
C     Fill AA and BB
C
      JEQN = 0
      DO IEQN = 1, NSENS
        IF ( LSEQ(IEQN) ) THEN
          JEQN = JEQN + 1
          JVAR = 0
          DO IVAR = 1, NSENS
            IF ( LSEN(IVAR) ) THEN
              JVAR = JVAR + 1
              AA(JVAR,JEQN) = AMAT(IVAR,IEQN)
            ENDIF
          ENDDO
          IDX(JEQN) = IEQN                ! For BB
        ENDIF
      ENDDO
C
C     Adjust the magnitude of the coefficients to avoid "Floating exception" error
C
100   CONTINUE
      DO JEQN = 1, NDIM
        LAFAC = .FALSE.
        DO JVAR = 1, NDIM
          IF ( ABS(AA(JVAR,JEQN)) .GT. RLMT ) THEN
            LAFAC = .TRUE.
            EXIT
          ENDIF
        ENDDO
        IF ( LAFAC ) THEN
          DO JVAR = 1, NDIM
            AA(JVAR,JEQN) = AA(JVAR,JEQN) * AFAC
          ENDDO
          DO J = 1, NDDMSP
            XLIQ(IDX(JEQN),J) = XLIQ(IDX(JEQN),J) * AFAC
          ENDDO
        ENDIF
      ENDDO
C
C     Decompose matrix AA - check for zero determinant
C
      CALL SGEFA (AA,NDIM,NDIM,IPVT,INFO)
      IF (INFO.NE.0) THEN
        NERR = NERR + 1
        RLMT = 1.E11
        IF (NERR.LE.MXERR) GOTO 100
        WRITE(IOUT,'(//,A)') 'ERROR in DDMEQNSLV:'
        WRITE(IOUT,'(A)')    ' Zero determinant in SGEFA!'
        WRITE(IOUT,*)        ' info = ',INFO
        IERR = -1
        RETURN
      ENDIF
C
C     Solve the system
C
      JOB = 1                             ! Solve trans(AA) * X = BB
      DO J = 1, NDDMSP
        DO JEQN = 1, NDIM
          BB(JEQN) = XLIQ(IDX(JEQN),J)
        ENDDO
        CALL SGESL (AA,NDIM,NDIM,IPVT,BB,JOB)
C
C     Map the answers
C
        JVAR = 0
        DO IVAR = 1, NSENS
          XLIQ(IVAR,J) = 0.0              ! Clearing
          IF ( LSEN(IVAR) ) THEN
            JVAR = JVAR + 1
            XLIQ(IVAR,J) = BB(JVAR)
          ENDIF
        ENDDO
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMEQNSLV

c***** NCF_RDPTRT.F
c
      subroutine ncf_rdptrt(ndate,ttime)
      use tracer
      use ptemiss
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the RTRAC process
c   and fills the approproate arrays.  The emissions file for one grid
c   but each emissions groups is read. This version is for NetCDF files.
c    Argument descriptions:
c     Outputs:
c     Inputs:
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/13/19   --gwilson--   Originial development
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer ndate
      real    ttime
c
c-----------------------------------------------------------------------
c   External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname, action
      character*10  this_var, cname
      integer       ierr, iounit, this_tstep, idxpt, i, j
      integer       this_time_tflag, this_time_etflag, idx_start
      integer       data_start(2), data_count(2), this_varid, ispc
c
      real,    allocatable, dimension(:) ::  emispts
      integer, allocatable, dimension(:) ::  sa_region
      real,    allocatable, dimension(:) ::  effph_in
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
      action = 'Reading RTRAC point source file.'
c
c   --- skip if filename not supplied ---
c
      if( .NOT. is_netcdf_iortpt(1,1) .OR. .NOT. ltptfl(1,1) 
     &                             .OR. .NOT. lptsrc ) goto 9999
c
c  --- initialize emissions to zero ---
c
      do i = 1,nptsrc
        do j = 1,ntotsp
         sapnts(i,j) = 0.
        enddo
      enddo
c
c   --- set the unit number for surface emissions file ---
c
      iounit = iortpt(1,1)
      fname = tptfil(1,1)
c
c   --- allocate the local array ---
c
      allocate( emispts(nptsrc_safile(1,1)) )
      allocate( sa_region(nptsrc_safile(1,1)) )
      allocate( effph_in(nptsrc_safile(1,1)) )
c
c  ---- get the index for timestep containing this time ----
c
      this_tstep = ncf_get_tstep(iounit,action,ndate,ttime,
     &               this_time_tflag,this_time_etflag,le1day,.TRUE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = nptsrc_safile(1,1)
      data_start(2) = this_tstep
      data_count(2) = 1
      idx_start = nptsrc - nptsrc_safile(1,1)
c
c  ---- plumerise ---
c
      this_var = 'plumerise'
      ierr = nf_inq_varid(iounit, this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                  data_count,effph_in)
      if( ierr .NE. NF_NOERR) goto 7001
c
c  ---- put into global array ---
c
      do idxpt = 1,nptsrc_safile(1,1)
        if( effph_in(idxpt) .GT. 0 )
     &     effph(idxpt+idx_start) = -effph_in(idxpt)
      enddo
c
c   --- read the emissions for this hour ---
c
      do ispc=1,ntotsp
c
c   --- if species not in file just skip it ---
c
         this_var = ptname(ispc)
         ierr = nf_inq_varid(iounit, this_var, this_varid)
         if( ierr .NE. NF_NOERR) cycle
c
c  --- read data and load it into the global array ---
c
         ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emispts)
         if( ierr .NE. NF_NOERR) goto 7000
         do idxpt = 1,nptsrc_safile(1,1)
             sapnts(idxpt+idx_start,ispc) = emispts(idxpt)/(60.*dtems)
         enddo
c
c  ---- next species ---
c
      enddo
c
c  --- if not found in model species list, write a message ----     
c   
cae   write(idiag,'(1X,4A)') 'Species in RTRAC ',
cae  &            'point source file: ',cname(:istrln(cname)),
cae  &            ' not found in species list ... Skipping.'
c
c  --- get the next file ---
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTRT: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable in file: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTRT: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine addrcp(igrd,nox,noy,noz,nspsa,saconc)
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine adds the concentrations for each receptor and to
c     the running sum of concentrations.  This data will then be
c     averaged over all time steps in an hour to get hourly
c     average concentration at the receptor locations. 
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c         igrd   I  grid number for this grid
c         nox    I  number of X cells in grid
c         noy    I  number of Y cells in grid
c         nspsa  I  number of tracer species
c         saconc R  traxcer concentrations 
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c         
c    04/02/03  --gwilson--   Added grid number to recptors defined by
c                            cell index
c    05/07/12  --cemery--    Bug fix in interpolation algorithm
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real      dxcell
      real      dycell
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
      integer   igrd
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   ircp, i, j, icl, jcl
      integer   ixlow, ixhigh, iylow, iyhigh
      real      xnest, ynest
      real      xlow, xhigh, ylow, yhigh, xylow, xyhigh
      real      xcelwd, ycelwd, xcentr, ycentr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- if no receptor file is provided, just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
c  --- loop over all receptors ---
c
      do 10 ircp=1,nrecep
c
c  --- skip receptor if it is not in this grid ---
c
         if( igrdrcp(ircp) .NE. igrd ) goto 10
c
c  --- if receptor is a single cell type just add the concentrations ---
c
          if( idrcp(ircp) .EQ. IDCEL ) then
              icl = irecep(ircp,1)
              jcl = jrecep(ircp,1)
              do i=1,ntotsp
                 conrcp(i,ircp) = conrcp(i,ircp) + saconc(icl,jcl,1,i)
              enddo
c
c   --- if receptor is a cell average type calculate the average of 
c       each tracer concentration ---
c
          else if( idrcp(ircp) .EQ. IDAVG ) then
              do j=1,nclrcp(ircp)
                 icl = irecep(ircp,j)
                 jcl = jrecep(ircp,j)
                 do i=1,ntotsp
                     conrcp(i,ircp) = conrcp(i,ircp) + 
     &                               saconc(icl,jcl,1,i) / nclrcp(ircp)
                 enddo
              enddo
c
c  --- else if receptor is a point type, perform bilinear interpolation
c      at the location and add to receptor total ----
c
          else if( idrcp(ircp) .EQ. IDPNT ) then
c
c   --- calculate the cell containing the receptor ---
c
              icl = irecep(ircp,1)
              jcl = jrecep(ircp,1)
c
c   --- if the cell is on the boundary, don't do interpolation ---
c       (why would you have a receptor in a bounday cell?)
c
              if( icl .LE. 1 .OR. icl .GE. nox .OR. 
     &                           jcl .LE. 1 .OR. jcl .GE. noy ) then
                 do i=1,ntotsp
                   conrcp(i,ircp) = conrcp(i,ircp) + saconc(icl,jcl,1,i)
                 enddo
                 goto 10
              endif
c
c   --- find the locations of centers surrounding the receptor ---
c
              dxcell = delx / meshold(igrd)
              dycell = dely / meshold(igrd)
              xnest = xorg + FLOAT(inst1(igrd)-1)*delx - dxcell
              ynest = yorg + FLOAT(jnst1(igrd)-1)*dely - dycell
              xcentr = (FLOAT(icl)-1.5)*dxcell + xnest
              if( recepx(ircp) - xcentr .LE. dxcell ) then
                 ixlow = icl-1
                 xlow = xcentr
                 ixhigh = icl
                 xhigh =  (FLOAT(icl)-0.5)*dxcell + xnest
              else
                 ixlow = icl
                 xlow =  (FLOAT(icl)-0.5)*dxcell + xnest
                 ixhigh = icl+1
                 xhigh =  (FLOAT(icl)+0.5)*dxcell + xnest
              endif
              ycentr = (FLOAT(jcl)-1.5)*dycell + ynest
              if( recepy(ircp) - ycentr .LE. dycell ) then
                 iylow = jcl-1
                 ylow = ycentr
                 iyhigh = jcl
                 yhigh =  (FLOAT(jcl)-0.5)*dycell + ynest
              else
                 iylow = jcl
                 ylow =  (FLOAT(jcl)-0.5)*dycell + ynest
                 iyhigh = jcl+1
                 yhigh =  (FLOAT(jcl)+0.5)*dycell + ynest
              endif
              xcelwd = xhigh - xlow
              ycelwd = yhigh - ylow
              do i=1,ntotsp
c
c  --- interpolate to the X position, at both Y positions ---
c
                  xylow = (recepx(ircp) - xlow) / xcelwd * 
     &                                           saconc(ixhigh,iylow,1,i)
                  xylow = xylow + (xhigh - recepx(ircp)) / xcelwd * 
     &                                          saconc(ixlow,iylow,1,i)
                  xyhigh = (recepx(ircp) - xlow) / dxcell * 
     &                                          saconc(ixhigh,iyhigh,1,i)
                  xyhigh = xyhigh + (xhigh - recepx(ircp)) / 
     &                                dxcell * saconc(ixlow,iyhigh,1,i)
c
c  --- interpolate to the exact position using the high/low X values ----
c
                 conrcp(i,ircp) = conrcp(i,ircp) + 
     &                     (recepy(ircp) - ylow)/ycelwd * xyhigh +
     &                            (yhigh - recepy(ircp))/ycelwd * xylow
              enddo
          endif
c
c  --- next receptor ----
c
   10 continue
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine ironchem(dt,dtpig,aero_flag,wpuff,tpuff,ppuff,cwpuff,
     &                    phpuff,ldark,conpin,cback,avgcnc,convfac,
     &                    ierr1,ierr2)
      use chmstry
      use filunit
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c     IRONCHEM performs chemistry on the current puff reactor for one
c     time step.  It uses the LSODE solver exclusively for the gas-phase.
c
c     Local array element con(nspec+1) is used to store the concentrations
c     of non-used species, i.e., species that are in the chem solver but
c     not on the species list for this run.
c
c      Copyright Ramboll
c
c     Modifications:
c        10/06/05        Removed mechanism 2
c        01/12/06        Added PM chemistry calls for AERO_CF
c        12/26/06        Removed AEROCHEM_AQ (merged into AEROCHEM_CF)
c        01/08/07        Added mechanism 6 (CB05)
c        02/21/08        Added coupling time for puff aerosol chemistry
c        03/31/08        Puff killed before PM chemistry for concs < lower bound
c        05/13/08        Modified to skip ISOROPIA for background chemistry.
c        05/28/10        Added mechanism 7 (CB6)
c        07/20/12        Added Mechanism 1 (CB06 with Iodine chemistry)
c        10/10/12        Added mechanism 2 (CB6r1)
c        06/28/13        Modified for new GREASD PiG chemistry (RADM-AQ only)
c        03/18/14        Revised for benzene SOA (AEROCHEM_CF interface change)
c        06/27/14        Added Mechanism 3 (CB6r2h)
c        11/11/14        Added Mechanism 4 (CB6r3)
c        10/13/17        Added a dummy argument to AEROCHEM_CF call (aerosol pH)
c        10/16/17        Added a dummy argument to AEROCHEM_CF call (time-weighted JNO2)
c                        Changed DUMARR2 size
c        02/21/20        Added Mechanism 1 (CB6r5) -rlb-
c        03/24/21        Added Mechanism 7 (CB7)
c        02/15/22        Added Mechanism 9 (RACM2s21)
c
c     Input arguments:
c        dt                  gas/aqueous chemistry timestep (s)
c        dtpig               PiG coupling timestep (hr)
c        aero_flag           flag to determine which PM algorithm to call
c        wpuff               water vapor (ppm)
c        tpuff               temperature (K)
c        ppuff               pressure (mb)
c        cwpuff              cloud liquid water content (g/m3)
c        phpuff              cloud pH
c        ldark               darkness flag (T=dark)
c        conpin              puff species concentration (ppm,ug/m3)
c        cback               background species concentration (ppm,ug/m3)
c        convfac             conversion factor: umol/m3 = ppm * convfac
c
c     Output arguments:
c        conpin              puff species concentration (ppm,ug/m3)
c        avgcnc              time-step average puff concentrations
c        ierr1               error code (=1 if LSODE reports error)
c        ierr2               error code (=1 if neg concs for AEROCHEM)
c
c     Routines called:
c        LSCALL
c        AEROCHEM_CF
c
c     Called by:
c        PIGDRIVE
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
c
c-----Subroutine names to be called by LSODE
c
      external lsrate1
      external lsrate2
      external lsrate3
      external lsrate4
      external lsrate5
      external lsrate6
      external lsrate7
      external lsrate9
      external lsrate_pig
c
      real conpin(*)
      real cback(*)
      real avgcnc(*)
c
      real rrxn(MXREACT)
      real dt,dtpig,wpuff,tpuff,ppuff,cwpuff,phpuff,convfac,dtchem
      real atm,o2,ch4,h2,cliq
      real dumvar
      real dumarr1(NNV),dumarr2(7,MXSPEC),dumarr3(MXFDDM*NNV),dumarr4(1)
      real dumarr5(NPREC_S)
      real cold_so2,cold_pso4,cold_hno3,cold_pno3,cold_nh3,cold_pnh4,
     &     cold_na, cold_pcl
      real coldb_so2,coldb_pso4
      real so2frc

      integer is,ierr1,ierr2,aero_flag
      logical ldark
c
      real con(MXSPEC+1)
c
c-----Entry point
c
      dtchem = dt/3600.
      con(nspec+1) = 0.
      do is = 1,nspec
        con(is) = conpin(is)
      enddo
c
c-----Chemistry integration, pass subroutines for mechanism used
c
      atm = 1.e6
      O2  = 2.095e5
      CH4 = 1.75
      H2  = 0.50
c
      if (ipigflg.eq.GRESPIG) then
        call lscall(lsrate_pig,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.1) then
        call lscall(lsrate1,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.3) then
        call lscall(lsrate3,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.4) then
        call lscall(lsrate4,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.5) then
        call lscall(lsrate5,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.7) then
        call lscall(lsrate7,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      elseif (idmech.eq.9) then
        call lscall(lsrate9,dtchem,wpuff,atm,O2,CH4,H2,con,
     &              avgcnc,nreact,rrxn,ierr1,.FALSE.,ipigflg)
      endif
      if (ierr1 .ne. 0) return
c
c-----Perform aerosol chemistry if it's time
c
      if (aero_flag .gt. 0) then
        cliq = cwpuff
        if (tpuff.lt.273.)
     &    cliq = amax1(0.,cliq*(tpuff - tamin)/(273. - tamin))
        if (cliq.ge.cwmin .and. tpuff.gt.tamin) then
c
c-----Minimum conc check: kill the puff if below BDNL values
c
          ierr2 = 0
          if (con(kso2) .lt. 0. .or.
     &        con(khno3).lt. 0. .or.
     &        con(kn2o5).lt. 0. .or.
     &        con(knh3) .lt. 0. .or.
     &        con(kh2o2).lt. 0. .or.
     &        con(ko3)  .lt. 0. .or.
     &        con(ksulf).lt. 0.) ierr2 = 1
          do is = ngas+1,nspec
            if (is.ne.kph2o .and. con(is).lt.0.) ierr2 = 1
          enddo
          if (ierr2 .ne. 0) return
c
c-----Convert all SULF->PSO4, N2O5->HNO3 in cloud water before PM chemistry
c
          con(kpso4) = con(kpso4) + con(ksulf)*96.*convfac
          con(ksulf) = 0.
          con(khno3) = con(khno3) + 2.*con(kn2o5)
          con(kn2o5) = 0.
          cold_so2   = con(kso2)
          cold_pso4  = con(kpso4)
          cold_hno3  = con(khno3)
          cold_pno3  = con(kpno3)
          cold_nh3   = con(knh3)
          cold_pnh4  = con(kpnh4)
          cold_na    = con(kna)
          cold_pcl   = con(kpcl)
          con(kso2)  = con(kso2)  + cback(kso2)
          con(kpso4) = con(kpso4) + cback(kpso4)
          coldb_so2  = con(kso2)
          coldb_pso4 = con(kpso4)
          con(khno3) = con(khno3) + cback(khno3)
          con(kpno3) = con(kpno3) + cback(kpno3)
          con(knh3)  = con(knh3)  + cback(knh3)
          con(kpnh4) = con(kpnh4) + cback(kpnh4)
          con(kna)   = con(kna)   + cback(kna)
          con(kpcl)  = con(kpcl)  + cback(kpcl)
          so2frc = cold_so2/max(con(kso2),bdnl(kso2))
c
          call aerochem_cf(wpuff,tpuff,ppuff,cliq,phpuff,
     &                     dumvar,dumvar,
     &                     dumarr1,con,dumarr5,convfac,dtchem,dtpig,
     &                     dumarr2,dumarr3,dumarr4,1,1,
     &                     .FALSE.,1,aero_flag,.TRUE.,0,ldark)
c
          con(kso2)  = cold_so2  + (con(kso2)  - coldb_so2)*so2frc
          con(kpso4) = cold_pso4 + (con(kpso4) - coldb_pso4)*so2frc
          con(khno3) = cold_hno3
          con(kpno3) = cold_pno3
          con(knh3)  = cold_nh3
          con(kpnh4) = cold_pnh4
          con(kna)   = cold_na
          con(kpcl)  = cold_pcl
        endif
      endif
c
c-----Update input species arrays
c
      do is = 1,nrad
        con(is) = amax1(con(is),bdnl(is))
      enddo
      do is = 1,nspec
        conpin(is) = con(is)
      enddo
      conpin(nspec+1) = 0.
c
      return
      end

c*** GENCMC
c
      subroutine gencmc(ldbg)
      use chmstry
      use filunit
      use grid
      use pigsty
      use tracer
      use rtracchm
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c     Generate the rate and Jacobian terms needed by the RTRAC CMC 
c     solver
c
c      Copyright Ramboll
c
c    Argument descriptions:
c     Inputs:
c       ldbg        L     flag to turn on diagnostic statements
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c    11/13/20   --gyarwood--    Enable RTCMC to read deposition
c                               parameters
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include "camx.prm"
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      logical  ldbg
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer idxspc
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, k, l, n, icount, itmp, itm2, itm3, mvecedge
      logical   lok
      character*10   sptmp
      character*12   spctyp(4)
      real kdum(MXREACT,3), tdum(3), pdum(3)
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data spctyp  /'FAST        ',
     &              'SLOW        ',
     &              'EQUILIBRIUM ',
     &              'FIXED       '/
      data tdum    /  298.,  273., 273. /
      data pdum    / 1013., 1013., 500. /
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- Report the mechanism
c
      if ( ldbg ) then
         if( mtype .EQ. 1) then
            write(idiag,'(/,A)') ' CAMx format reactions'
         elseif( mtype .EQ. 2) then
            write(idiag,'(/,A)') ' SCICHEM format reactions'
         endif
         do i = 1,nrxnrtc
            write(idiag,'(I3,A1,$)') i, ' '
            do j = 1,MXRCT
               if( j .LT. nrct(i) ) then
                  write(idiag,'(A,A2,$)') namrct(i,j), '+ '
               elseif( j .EQ. nrct(i) ) then
                  write(idiag,'(A,A2,$)') namrct(i,j), ' '
               else
                  write(idiag,'(A12,$)') ' '
               endif
            enddo
            write(idiag,'(A3,$)') '-> '
            do j = 1,nprd(i)
               if( DABS(prdcoef(i,j)) .NE. 1.0D0 ) then
                  write(idiag,'(F6.3,X,A,$)') 
     &                                    ABS(prdcoef(i,j)), namprd(i,j)
               else
                  write(idiag,'(A,$)') namprd(i,j)
               endif
               if( j .LT. nprd(i) ) then
                  if( prdcoef(i,j+1) .LT. 0.0D0 ) then
                     write(idiag,'(A2,$)') '- '
                  else
                     write(idiag,'(A2,$)') '+ '
                  endif
               endif
            enddo
            write(idiag,'(X)') 
c            write(idiag,'(A3,I2,1P20E12.3)') '; ',
c     &            MOD(ityprtc(i),100), (rkprmrtc(i,j),j=1,nrkprm(i))
         enddo
c
         do i = 1,nrxnrtc
            write(idiag,'(I3,A1,$)') i, ' '
            do j = 1,MXRCT
               if( j .LT. nrct(i) ) then
                  write(idiag,'(3A,A3,$)') '[',namrct(i,j),']', ' + '
               elseif( j .EQ. nrct(i) ) then
                  write(idiag,'(3A,A3,$)') '[',namrct(i,j),']', ' '
               else
                  write(idiag,'(A15,$)') ' '
               endif
            enddo
            write(idiag,'(A3,$)') '-> '
            do j = 1,nprd(i)
               if( prdcoef(i,j) .NE. 1.0D0 ) then
                  write(idiag,'(A,F6.3,A,X,3A,$)') 
     &                       '(',prdcoef(i,j),')','[',namprd(i,j),']'
               else
                  write(idiag,'(3A,$)') '[',namprd(i,j),']'
               endif
               if( j .LT. nprd(i) ) then
                  write(idiag,'(A3,$)') ' + '
               endif
            enddo
            write(idiag,'(X)') 
         enddo
c
         if( ktype .EQ. 1) then
            write(idiag,'(/,A)') ' CAMx format rate expressions'
         elseif( ktype .EQ. 2) then
            write(idiag,'(/,A)') ' SCICHEM format rate expressions'
         endif
c
         write(idiag,'(A)') ' Rxn Type  Parameters'
         do i = 1,nrxnrtc
            write(idiag,'(2I4,1P20E12.3)') 
     &          i, MOD(ityprtc(i),100), (rkprmrtc(i,j), j=1,nrkprm(i))
         enddo
      endif
c
c --- Check that any requested fixed species (type = 4) are available
c     Robust against ngas=0 or nrad=0
c
      do k = 1,ngasrtc
         lok = .false.
         if( itypsp(k) .LT. 1 .OR. itypsp(k) .GT. 4 ) then
            write(iout,'(//,3A,/,A)') ' Error in GENCMC:',
     &        ' RTRAC species: ', spnmrt(k),
     &        ' must be type 1 through 4 '
            call camxerr()
         endif
         if( itypsp(k) .NE. 4 ) lok = .true.
         if( spnmrt(k) .EQ. nam_M 
     &      .OR. spnmrt(k) .EQ. nam_O2 
     &        .OR. spnmrt(k) .EQ. nam_N2 
     &          .OR. spnmrt(k) .EQ. nam_H2O 
     &            .OR. spnmrt(k) .EQ. nam_H2 
     &              .OR. spnmrt(k) .EQ. nam_CH4 ) lok = .true.
         if( idxspc(spnmrt(k),spname,ngas) .NE. 0 ) lok = .true.
         if( .NOT. lok ) then
            write(iout,'(//,3A,/,A)') ' Error in GENCMC:',
     &        ' RTRAC species: ', spnmrt(k),
     &        ' cannot be of type fixed concentration'      
            call camxerr()
         endif
      enddo
c
c --- Force any CAMx mechanism species to be fixed (type = 4)
c     and set pointers to locate concentrations for the fixed species
c
      do k = 1,ngasrtc
         idxfix(k) = -999
         if( spnmrt(k) .EQ. nam_M ) then
           idxfix(k) = 1
           itypsp(k) = 4
         elseif( spnmrt(k) .EQ. nam_O2 ) then
           idxfix(k) = 2
           itypsp(k) = 4
         elseif( spnmrt(k) .EQ. nam_N2 ) then
           idxfix(k) = 3
           itypsp(k) = 4
         elseif( spnmrt(k) .EQ. nam_H2O ) then
           idxfix(k) = 4
           itypsp(k) = 4
         elseif( spnmrt(k) .EQ. nam_H2 ) then
           idxfix(k) = 5
           itypsp(k) = 4
         elseif( spnmrt(k) .EQ. nam_CH4 ) then
           idxfix(k) = 6
           itypsp(k) = 4
         else
           itmp = 0
           if( ngas .GT. 0 ) itmp = idxspc(spnmrt(k),spname,ngas)
           if( itmp .NE. 0 ) then
              idxfix(k) = 6 + itmp
              itypsp(k) = 4
           endif
         endif
      enddo
c
c --- Sort species names by type: 1=fast, 2=slow, 3=eqm, 4=fixed
c     then count number of each type
c
      do l = 1,ngasrtc+1
         do k = 1,ngasrtc-1
            if( itypsp(k) .GT. itypsp(k+1)) then
               itmp = itypsp(k+1)
               itm2 = idxfix(k+1)
               sptmp = spnmrt(k+1)
               itypsp(k+1) = itypsp(k)
               idxfix(k+1) = idxfix(k)
               spnmrt(k+1) = spnmrt(k)
               itypsp(k) = itmp
               idxfix(k) = itm2
               spnmrt(k) = sptmp
            endif
         enddo
      enddo
      nfstrtc = 0
      nslortc = 0
      neqmrtc = 0
      nfixrtc = 0
      do k = 1,ngasrtc
         if( itypsp(k) .EQ. 1 ) nfstrtc = nfstrtc+1
         if( itypsp(k) .EQ. 2 ) nslortc = nslortc+1
         if( itypsp(k) .EQ. 3 ) neqmrtc = neqmrtc+1
         if( itypsp(k) .EQ. 4 ) nfixrtc = nfixrtc+1
      enddo
      if( nfstrtc .LT. 1 ) goto 8003
      if( nslortc .GT. MXSLO ) goto 8004
      if( neqmrtc .GT. MXEQM ) goto 8005
c
c --- Note: we later subtract NFIXRTC from NGASRTC
c
c --- Species diagnostics
c
      if ( ldbg ) then
         write(idiag, '(//,A)') ' Species sorted by GENCMC'
         write(idiag, '(/,A)')  ' Rxn  Name        Type        IdxFix'
         do i = 1, ngasrtc
            if( idxfix(i) .GT. 0 ) then
            write(idiag, '(I4,2X,A,2X,A,I6)') 
     &                      i, spnmrt(i), spctyp(itypsp(i)), idxfix(i)
            else
            write(idiag, '(I4,2X,A,2X,2A)') 
     &                      i, spnmrt(i), spctyp(itypsp(i)), '   N/A'
            endif
         enddo
         write(idiag, '(/,A,I4)') ' Number of fast species  = ', nfstrtc
         write(idiag, '(A,I4)')   ' Number of slow species  = ', nslortc
         write(idiag, '(A,I4)')   ' Number of eqm species   = ', neqmrtc
         write(idiag, '(A,I4,/)') ' Number of fixed species = ', nfixrtc
      endif
c
c --- Index the reactants and products
c
      do n = 1,nrxnrtc
         do k = 1, nrct(n)
            idxrct(n,k) = idxspc(namrct(n,k),spnmrt,ngasrtc)
         enddo
         do k = 1,nprd(n)
            idxprd(n,k) = idxspc(namprd(n,k),spnmrt,ngasrtc)
         enddo
      enddo
c
c --- Populate reaction data for fast species by counting and indexing 
c     the reactants and products
c
      do n = 1,nrxnrtc
         nrctfst(n) = 0
         if( nrct(n) .GT. 0 ) then
            do k = 1,nrct(n)
               if( idxrct(n,k) .LE. nfstrtc) then
                  nrctfst(n) = nrctfst(n)+1
                  idxrctfst(n,nrctfst(n)) = idxrct(n,k)
               endif
            enddo
         endif
         nprdfst(n) = 0
         if( nprd(n) .GT. 0 ) then
            do k = 1,nprd(n)
               if( idxprd(n,k) .LE. nfstrtc) then
                  nprdfst(n) = nprdfst(n)+1
                  idxprdfst(n,nprdfst(n)) = idxprd(n,k)
                  prdcofst(n,nprdfst(n)) = prdcoef(n,k)
               endif
            enddo
         endif
      enddo
c
c --- Populate Jacobian terms for fast species
c     for each reaction, first do reactant terms, then product terms
c
c --- Reactant terms
c
      njactrm = 0
      do n = 1,nrxnrtc
         if( nrctfst(n) .GT. 0 ) then
            do i = 1,nrctfst(n)
            do j = 1,nrctfst(n)
               njactrm = njactrm+1
               if( njactrm .GT. MXJACTRM-1 ) goto 8000
               ipd(njactrm) = idxrctfst(n,i)
               jpd(njactrm) = idxrctfst(n,j)
               idrxjac(njactrm) = n
               do k = 1,MXRCT-1
                  idspjac(njactrm,k) = MXTRSP + 1
               enddo
               nspjac(njactrm) = 0
               icount = 0
               do k = 1,nrct(n)
                  if( idxrct(n,k) .NE. idxrctfst(n,j) ) then
                     nspjac(njactrm) = nspjac(njactrm)+1
                     if( nspjac(njactrm) .GT. MXRCT-1 ) goto 8001
                     idspjac(njactrm,nspjac(njactrm)) = idxrct(n,k)
                  else
                     icount = icount+1
                     if( icount .GT. 1 ) then
                        nspjac(njactrm) = nspjac(njactrm)+1
                        if( nspjac(njactrm) .GT. MXRCT-1 ) goto 8001
                        idspjac(njactrm,nspjac(njactrm)) = idxrct(n,k)
                     endif
                  endif
               enddo
               coefjac(njactrm) = -1.0D0
c
c --- Look for an opportunity to combine two terms
c
               if( icount .EQ. 2 .AND. njactrm .GT. 1 ) then
                  if( idrxjac(njactrm) .EQ. idrxjac(njactrm-1) 
     &              .AND. ipd(njactrm) .EQ. ipd(njactrm-1) 
     &                 .AND. jpd(njactrm) .EQ. jpd(njactrm-1) ) then
                     njactrm = njactrm - 1
                     coefjac(njactrm) = coefjac(njactrm) - 1.0D0 
                  endif
               endif
            enddo
            enddo
         endif
c
c --- Product terms
c
         if( nprdfst(n) .GT. 0 .AND. nrctfst(n) .GT. 0 ) then
            do i = 1,nprdfst(n)
            do j = 1,nrctfst(n)
               njactrm = njactrm+1
               if( njactrm .GT. MXJACTRM-1 ) goto 8000
               ipd(njactrm) = idxprdfst(n,i)
               jpd(njactrm) = idxrctfst(n,j)
               idrxjac(njactrm) = n
               do k = 1,MXRCT-1
                  idspjac(njactrm,k) = MXTRSP + 1
               enddo
               nspjac(njactrm) = 0
               icount = 0
               do k = 1,nrct(n)
                  if( idxrct(n,k) .NE. idxrctfst(n,j) ) then
                     nspjac(njactrm) = nspjac(njactrm)+1
                     if( nspjac(njactrm) .GT. MXRCT-1 ) goto 8002
                     idspjac(njactrm,nspjac(njactrm)) = idxrct(n,k)
                  else
                     icount = icount+1
                     if( icount .GT. 1 ) then
                        nspjac(njactrm) = nspjac(njactrm)+1
                        if( nspjac(njactrm) .GT. MXRCT-1 ) goto 8002
                        idspjac(njactrm,nspjac(njactrm)) = idxrct(n,k)
                     endif
                  endif
               enddo
               coefjac(njactrm) = prdcofst(n,i)
c
c --- Look for an opportunity to combine two terms
c
               if( icount .EQ. 2 .AND. njactrm .GT. 1 ) then
                  if( idrxjac(njactrm) .EQ. idrxjac(njactrm-1) 
     &              .AND. ipd(njactrm) .EQ. ipd(njactrm-1) 
     &                 .AND. jpd(njactrm) .EQ. jpd(njactrm-1) ) then
                     njactrm = njactrm - 1
                     coefjac(njactrm) = coefjac(njactrm) + prdcofst(n,i)
                  endif
               endif
            enddo
            enddo
         endif
      enddo
c
c --- Sort Jacobian terms 
c        sort by pd(ipd,jpd) is easy to read for QA
c        sort by idspjac(k,1) may run faster 
c
      itm3 = njactrm+1
      do l = 1,njactrm+1
         do k = 1,njactrm-1
c            itmp = nfstrtc*ipd(k)+jpd(k)
c            itm2 = nfstrtc*ipd(k+1)+jpd(k+1)
            itm2 = idspjac(k+1,1)
            itmp = idspjac(k,1)
c            itm2 = k+1 ! defeat sort
c            itmp = k
            if( itmp .GT. itm2 ) then
               ipd(itm3) = ipd(k+1)
               jpd(itm3) = jpd(k+1)
               idrxjac(itm3) = idrxjac(k+1)
               nspjac(itm3) = nspjac(k+1)
               coefjac(itm3) = coefjac(k+1)
               ipd(k+1) = ipd(k)
               jpd(k+1) = jpd(k)
               idrxjac(k+1) = idrxjac(k)
               nspjac(k+1) = nspjac(k)
               coefjac(k+1) = coefjac(k)
               ipd(k) = ipd(itm3)
               jpd(k) = jpd(itm3)
               idrxjac(k) = idrxjac(itm3)
               nspjac(k) = nspjac(itm3)
               coefjac(k) = coefjac(itm3)
               do i = 1,MXRCT-1
                  idspjac(itm3,i) = idspjac(k+1,i)
                  idspjac(k+1,i) = idspjac(k,i)
                  idspjac(k,i) = idspjac(itm3,i)
               enddo
            endif
            scoefjac(k) = SNGL(coefjac(k))
         enddo
      enddo
c
      if( ldbg  .AND. ijac.EQ.2) then
         write(idiag,'(/,A,/)') ' Jacobian (pd) data:'
         itm2 = -1
         do i=1,njactrm
            itmp = nfstrtc*ipd(i)+jpd(i)
            if( itmp .NE. itm2 ) then
               itm2 = itmp
               write(idiag,'(5A,F6.3,A,I3,A,3(2A))')
     &         ' pd(',spnmrt(ipd(i)), ',', spnmrt(jpd(i)), ') = ',
     &         coefjac(i),'  * k(' , idrxjac(i),')',
     &         (' * ', spnmrt(idspjac(i,k)),k=1,nspjac(i))
c write FORTRAN
c               write(idiag,'(A,I4,A,I4,A,F6.3,A,I3,A,3(A,I4,A))')
c     &         '      pd(',ipd(i), ',', jpd(i), ') = ',
c     &         coefjac(i),'D0  * rkrtc(' , idrxjac(i),')',
c     &         (' * y(', (idspjac(i,k)),')',k=1,nspjac(i))
            else
               write(idiag,'(27X,A,F6.3,A,I3,A,3(2A))')
     &         '& + (',
     &         coefjac(i),') * k(' , idrxjac(i),')',
     &         (' * ', spnmrt(idspjac(i,k)),k=1,nspjac(i))
c write FORTRAN
c               write(idiag,'(5X,A,7X,A,F6.3,A,I3,A,3(A,I4,A))')
c     &         '&','+ (',
c     &         coefjac(i),'D0) * rkrtc(' , idrxjac(i),')',
c     &         (' * y(', (idspjac(i,k)),')',k=1,nspjac(i))
            endif
         enddo
         write(idiag, '(3(A,I5))') ' Number of Jacobian terms = ',
     &                          njactrm, ' (MXJACTRM = ',MXJACTRM,')'
      endif
c
c --- Subtract the number of fixed species from NGASRTC
c
      ngasrtc = ngasrtc - nfixrtc
c
c --- Populate reaction data for any slow species 
c
      if( nslortc .GT. 0 ) then
         do i = 1,nslortc
            idslo(i) = nfstrtc+i
            nslgain(i) = 0
            nslloss(i) = 0
            do n = 1,nrxnrtc
               if( nprd(n) .GT. 0 ) then
                  do k = 1,nprd(n)
                     if( idxprd(n,k) .EQ. idslo(i) ) then
                        nslgain(i) = nslgain(i)+1
                        islgain(i,nslgain(i)) = n
                        prdcoslo(i,nslgain(i)) = prdcoef(n,k)
                        spdcoslo(i,nslgain(i)) = SNGL(prdcoef(n,k))
                     endif
                  enddo
               endif
               if( nrct(n) .GT. 0 ) then
                  do k = 1,nrct(n)
                     if( idxrct(n,k) .EQ. idslo(i) ) then
                        nslloss(i) = nslloss(i)+1
                        islloss(i,nslloss(i)) = n
                     endif
                  enddo
               endif
            enddo
         enddo
      endif
c
      if ( ldbg .AND. nslortc .GT. 0 ) then
         write(idiag,'(//,A)') ' Slow species data:'
         do n = 1,nslortc
            write(idiag,'(/,A,I5,2X,2A)') 
     &               ' Species = ', n, ' Name = ', spnmrt(idslo(n))
            write(idiag,'(A,I5)') ' NRXLOSS = ', nslloss(n)
            write(idiag,'(10X,10I6)') (islloss(n,i),i=1,nslloss(n))
            write(idiag,'(A,I5)') ' NRXGAIN = ', nslgain(n)
            write(idiag,'(10X,10I6)') (islgain(n,i),i=1,nslgain(n))
            write(idiag,'(10X,10F6.3)') (prdcoslo(n,i),i=1,nslgain(n))
         enddo
      endif
c
c --- Populate reaction data for any equilibrium species 
c
      if( neqmrtc .GT. 0 ) then
         nrxupdt = 0
         do i = 1,neqmrtc
            ideqm(i) = nfstrtc+nslortc+i
            nrxgain(i) = 0
            nrxloss(i) = 0
            do n = 1,nrxnrtc
               if( nprd(n) .GT. 0 ) then
                  do k = 1,nprd(n)
                     if( idxprd(n,k) .EQ. ideqm(i) ) then
                        nrxgain(i) = nrxgain(i)+1
                        irxgain(i,nrxgain(i)) = n
                        prdcoeqm(i,nrxgain(i)) = prdcoef(n,k)
                        spdcoeqm(i,nrxgain(i)) = SNGL(prdcoef(n,k))
                     endif
                  enddo
               endif
               if( nrct(n) .GT. 0 ) then
                  itmp = 0
                  do k = 1,nrct(n)
                     if( idxrct(n,k) .EQ. ideqm(i) 
     &                                       .AND. itmp .EQ. 0 ) then
                        nrxloss(i) = nrxloss(i)+1
                        irxloss(i,nrxloss(i)) = n
                        itmp = 1
                        itm2 = 0
                        if( nrxupdt .EQ. 0 ) then
                           nrxupdt = 1
                           irxupdt(1) = irxloss(i,nrxloss(i))
                        else
                           do j = 1,nrxupdt
                              if( j .EQ. n ) itm2 = 1
                           enddo
                           if( itm2 .EQ. 0 ) then
                              nrxupdt = nrxupdt+1
                              irxupdt(nrxupdt) = irxloss(i,nrxloss(i))
                           endif
                        endif
                     endif
                  enddo
               endif
            enddo
         enddo
      endif
c
      if ( ldbg .AND. neqmrtc .GT. 0 ) then
         write(idiag,'(//,A)') ' Equilibrium species data:'
         do n = 1,neqmrtc
            write(idiag,'(/,A,I5,2X,2A)') 
     &               ' Species = ', n, ' Name = ', spnmrt(ideqm(n))
            write(idiag,'(A,I5)') ' NRXLOSS = ', nrxloss(n)
            write(idiag,'(10X,10I6)') (irxloss(n,i),i=1,nrxloss(n))
            write(idiag,'(A,I5)') ' NRXGAIN = ', nrxgain(n)
            write(idiag,'(10X,10I6)') (irxgain(n,i),i=1,nrxgain(n))
            write(idiag,'(10X,10F6.3)') (prdcoeqm(n,i),i=1,nrxgain(n))
         enddo
         write(idiag,'(/,A,I5)') ' NRXUPDT = ', nrxupdt
         write(idiag,'(11X,10I5)') (irxupdt(i),i=1,nrxupdt)
      endif
c
c --- Provide diagnostic info for checking rate expressions
c
      write(idiag,'(/,a,/,/,a)')
     &      ' Diagnostic info for checking RTCMC rate expressions',
     &      ' Rates at three temps and pressures in ppm-n min-1'
      do i=1,3
        if( ktype .EQ. 1 ) call krtc(tdum(i), pdum(i))
        if( ktype .EQ. 2 ) call ksci(tdum(i), pdum(i))
        do j=1,nrxnrtc
          kdum(j,i)=rkrtc(j)/60.0D0
        enddo
      enddo
      write(idiag,'(A,3F12.1)') ' Temp =  ', tdum
      write(idiag,'(A,3F12.1)') ' Pres =  ', pdum
      write(idiag,'(A)') ' Rxn Typ'
      write(idiag,'(2I4,1P3E12.4)')
     &     (j,MOD(ityprtc(j),100),kdum(j,1),
     &      kdum(j,2),kdum(j,3),j=1,nrxnrtc)
c
c --- Load original RTRAC species vectors
c
      nrtgas = ngasrtc
      nrtaero = 0
      ntotsp = ngasrtc
      soap3_ntotsp = ntotsp
      nrtrac = ngasrtc
      lrtgas = .true.
      lrtaero = .false.
c
c  --- make sure the arrays are allocated large enough ---
c
      if( MAX(ntotsp,ngasschm) .GT. MXTRSP ) then
        write(iout,'(//,A)') 'ERROR in GENCMC:'
        write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
        write(iout,*) 'Please change the value for parameter: MXTRSP'
        write(iout,*) 'It should be set to a value of at least: ',
     &                                             MAX(ntotsp,ngasschm)
        call flush(iout)
        call camxerr()
      endif
c
c  --- call routine to allocate the arrays ---
c
      mvecedge = MAX(ncol(1),nrow(1))
      call alloc_tracer_specs(ngrid,ncol,nrow,nlay,nlayers_ems,
     &                                       tectyp,mvecedge,iout)
      call alloc_rtracchm(ngrid,ncol,nrow,nspec,ntotsp)
c
c  --- if doing sampling grids, allocate the arrays ---
c
      if( lsample ) 
     &      call alloc_tracer_sample(nsample,ncolsmp,nrowsmp,nrtsmpcels)
c
      write(idiag,'(A)') 'Final RTCMC gas species values'
      write(idiag,'(A,A)')'     Name      LowBnd (ppm)   H (M/atm)   ',
     &                    'Tfact (K)  MW (g/mol) Reactivity      Rscale'
ciiii aaaaaaaaaa  -e.eeeE-ee  -e.eeeE-ee-fffffff.fff-fffffff.fff-fffffff.fff-fffffff.fff
      do i = 1, ngasrtc
         ptname(i) = spnmrt(i)
         lsamap(i) = i
         lsagas(i) = .TRUE.
         loutsa(i) = .TRUE.
         rtlbnd(i) = BNDLPT
         do j = 1,ngasschm
           if (spnmrt(i).eq.spnmschm(j)) then
             rthlaw(i) = hlawschm(j)
             rttfact(i) = tfacschm(j)
             rtmolwt(i) = molwschm(j)
             rtdrate(i) = sqrt(molwschm(j)/18.)
             rtreact(i) = reacschm(j)
             rtscale(i) = rsclschm(j)
           endif
         enddo
c
         write(idiag,'(i4,1x,a10,2e12.3,4f12.3)') 
     &         i,spnmrt(i),rtlbnd(i),rthlaw(i),rttfact(i),rtmolwt(i),
     &         rtreact(i),rtscale(i)
      enddo
      write(idiag,*)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error handling:
c-----------------------------------------------------------------------
c
 8000 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A,I4,/)') ' Processing reaction number',n
      write(iout,'(2(A,/),A,I8,A)') 
     &  ' Number of Jacobian terms for the requested RTRAC mechanism',
     &  ' exceeds the maximum set by the parameter MXJACTRM',
     &  ' (MXJACTRM = ',MXJACTRM,')',
     &  ' Increase MXJACTRM and re-compile CAMx.'
      call camxerr()
c
 8001 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A,I4,/)') ' Processing reaction number',n
      write(iout,'(A,/)') 
     &  ' Building Jacobian for the REACTANTS',
     &  ' nspjac(njactrm) > MXRCT-1, which should not happen'
      write(iout,'(A,2I4)') ' nspjac(njactrm) and MXRCT are: ', 
     &                                       nspjac(njactrm), MXRCT
      write(iout,'(A,3I4)') ' i, j, k values are: ', i, j, k
      call camxerr()
c
 8002 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A,I4,/)') ' Processing reaction number',n
      write(iout,'(A,/)') 
     &  ' Building Jacobian for the PRODUCTS',
     &  ' nspjac(njactrm) > MXRCT-1, which should not happen'
      write(iout,'(A,2I4)') ' nspjac(njactrm) and MXRCT are: ', 
     &                                       nspjac(njactrm), MXRCT
      write(iout,'(A,3I4)') ' i, j, k values are: ', i, j, k
c
 8003 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A)') ' There must be at least one fast species'
      call camxerr()
c
 8004 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A,I5)') 
     &   ' Increase the parameter MXSLO in RTCMC.COM to ', nslortc
      call camxerr()
c
 8005 write(iout,'(//,A,/)') ' ERROR in GENCMC:'
      write(iout,'(A,I5)') 
     &   ' Increase the parameter MXEQM in RTCMC.COM to ', neqmrtc
      call camxerr()
c
      end

      subroutine emiss_updt(emstim,emsdate,numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use filunit
      use camxcom
      use camxfld
      use grid
      use chmstry
      use ptemiss
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine reads is reponsible for updating the emissions arrays.
c    It will call the routines needed to read the emissions files for
c    the regular model as well as any Probing Tools. If MPI is activated,
c    it will then call the routines to pass the data to the computational 
c    slices.
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       READPT
c       RDPTRT
c       NCF_RDPTRT
c       READPTSA
c       RDPTDDM
c       FLUSH
c       READAR
c       EMASSIGN
c       RDARRT
c       READARSA
c       RDARDDM
c       NCF_RDARDDM
c       MPI_BARRIER
c       NODES_EMISS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: emstim
c
      integer :: emsdate
      integer :: numprocs
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: iproc_id
      integer :: ierr
      integer :: igrd
      integer :: ip
      integer :: ic
      integer :: ifile
c
      real    :: whr
      real    :: wmn
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (iproc_id .EQ. 0) then
         if (lptsrc) then
            write(*,'(a20,$)') 'readpt ......'
            call readpt()
            do ifile=1,npoint_files
              if( is_netcdf_iptem(ifile) ) then
                  call ncf_readpt(ifile,iptem(ifile),nptsrc,nspec,ptemis)
               endif
            enddo
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to read the points source emissions files
c      and load the tracer emission arrays ---
c
            if (ltrace .AND. .NOT. (lddm .OR. lhddm) ) then
               if (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                  call rdptrt(date,time)
                  call ncf_rdptrt(date,time)
               else
                  call readptsa(date,time)
               endif
            endif
c
c========================= Source Apportion End ========================
c
c============================= DDM Begin ===============================
c
c  --- call routine to read the points source emissions files
c      and load the tracer emission arrays ---
c
            if( lddm .OR. lhddm ) then
               call rdptddm(date,time)
               call ncf_rdptddm(date,time)
            endif
c
c============================= DDM End =================================
c
            write(*,'(a)') '   Done'
            call flush(6)
         endif
      endif
c
      if (iproc_id .EQ. 0) then
         if (larsrc) then
c
c  --- Read area emissions if data is available ---
c
            write(*,'(a20,$)') 'readar ......'
            do igrd = 1,ngrid
               call zeros(aremis(iptrem(igrd)),ncol(igrd)*nrow(igrd)*
     &                                              nlayers_ems*nemspc)
               do ifile=1,nemiss_files(igrd)
                  if (iarem(igrd,ifile) .GT. 0) then
                     if( is_netcdf_iarem(igrd,ifile) ) then
                        call ncf_readar(igrd,ifile,iarem(igrd,ifile),
     &                       ncol(igrd),nrow(igrd),nlay(igrd),
     &                         nlayers_ems,aremis(iptrem(igrd)),nemspc)
                     else
                        call readar(igrd,ifile,ncol(igrd),nrow(igrd),
     &                      nlayers_ems,iarem(igrd,ifile),iout, 
     &                         aremis(iptrem(igrd)),narspc(igrd,ifile),
     &                                                     nemspc,nspec)
                     endif
                  else
c
c  --- Otherwise assign values from the parent ---
c
                     if( tectyp .EQ. SA ) then
                         write(iout,'(//,a)') 'ERROR in EMISS_UPDT:'
                         write(iout,'(3a)') 'You are asking to flexinest ',
     &                         'emissions with Probing Tools option: ',tectyp
                         write(iout,'(a)') 'This is not allowed.'
                         write(iout,'(a)') 'You must supply an emissions ',
     &                                                  'file for each grid.'
                         call camxerr()
                     endif
                  endif
               enddo
            enddo
c
c  --- do the flex-nesting if needed ---
c
            do igrd = 2,ngrid
               if( nemiss_files(igrd) .LE. 0 ) then
                 do ip=1,ngrid
                    do ic=1,nchdrn(ip)
                       if(igrd .EQ. idchdrn(ic,ip)) then
                          write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                          'Assigning emissions from parent grid',
     &                                           time, date,' grid',igrd
                          call emassign(ncol(ip),nrow(ip),nlayers_ems,i1(igrd),
     &                            j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                              nemspc,aremis(iptrem(ip)),aremis(iptrem(igrd)))
                       endif
                    enddo
                 enddo
               endif
            enddo
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to read the emissions files and load
c      the tracer emission arrays ---
c
            if (ltrace) then
               do igrd=1,ngrid
                  if (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                     if (ltemfl(igrd,1,1)) then
                        call rdarrt(igrd,date,time,ncol(igrd),
     &                            nrow(igrd),nlayers_ems,ntotsp,
     &                                    saemis(ipsa3d_ems(igrd)))
                        call ncf_rdarrt(igrd,date,time,ncol(igrd),
     &                            nrow(igrd),nlayers_ems,ntotsp,
     &                                    saemis(ipsa3d_ems(igrd)))
                     endif
                  else
                     call readarsa(igrd,date,time,ncol(igrd),nrow(igrd),
     &                             nlayers_ems,soap3_ntotsp,deltax(1,igrd),deltay(igrd),
     &                                                  saemis(ipsa3d_ems(igrd)))
                  endif 
               enddo
c
c  --- do the flex-nesting if needed ---
c
               if(tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                  do igrd = 2,ngrid
                    if(.NOT. ltemfl(igrd,1,1)) then
                       do ip=1,ngrid
                          do ic=1,nchdrn(ip)
                             if(igrd .EQ. idchdrn(ic,ip)) then
                                 write(iout,'(a50,f7.0,i8.5,a,i3)')
     &                            'Assigning RTRAC emissions from parent grid',
     &                                                  time, date,' grid',igrd
                                 call emassign(ncol(ip),nrow(ip),nlayers_ems,i1(igrd),
     &                                         j1(igrd),nmesh(igrd),ncol(igrd),
     &                                         nrow(igrd),ntotsp,
     &                                         saemis(ipsa3d_ems(ip)),
     &                                         saemis(ipsa3d_ems(igrd)) )
                              endif
                          enddo
                       enddo
                    endif
                  enddo
               endif
            endif
c
c========================= Source Apportion End ========================
c
c
c============================= DDM Begin ===============================
c
c  --- call routine to read the emissions files and load
c      the DDM tracer emission arrays ---
c
            if( lddm .OR. lhddm ) then
                do igrd=1,ngrid
                  if( .NOT. lddmcalc(igrd) ) cycle
                  call rdarddm(igrd,date,time,ncol(igrd),nrow(igrd),
     &                     nlayers_ems,ntotsp,saemis(ipsa3d_ems(igrd)))
                  call ncf_rdarddm(igrd,date,time,ncol(igrd),nrow(igrd),
     &                     nlayers_ems,ntotsp,saemis(ipsa3d_ems(igrd)))
               enddo
            endif
c
c============================= DDM End =================================
c
            write(*,'(a)') '   Done'
            call flush(6)
         endif
      endif
c
c  --- send message to computes nodes to sync up ---
c
      if (iproc_id .EQ. 0) then
         whr = aint(emstim/100.)
         wmn = amod(emstim,100.)
         emstim = 100.*(whr + aint((wmn + dtems)/60.)) + amod((wmn+dtems),60.)
         if (emstim .ge. 2400.) then
            emstim = emstim - 2400.
            emsdate = emsdate + 1
            if (MOD(emsdate,1000) .GT. 365) then
               if (MOD(INT(emsdate/1000),4) .EQ. 0) then
                  if (MOD(emsdate,1000) .EQ. 367)
     &               emsdate = (INT(emsdate/1000)+1)*1000 + 1
               else
                  emsdate = (INT(emsdate/1000)+1)*1000 + 1
               endif
            endif
         endif
      endif
c
c  --- call the routine to pass the emissions values to the nodes ---
c
      if (lmpi) then
         call MPI_Barrier( MPI_COMM_WORLD, ierr)
         call nodes_emiss(numprocs,iproc_id)
      endif
c
      end

      subroutine nodes_bndconc(ioff,joff,m1,m2,ncol,nrow,nlay,
     &                                       nspec,nedge,conc,bndconc)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine will load the updated edge concentrations (boundary
c    conditions) passed from the master in the bndconc array and put 
c    it into the gridded conc array of the slices.
c
c    Argument descriptions:
c     Input:  
c       ioff    -- offset of origin for this slice in X-direction
c       joff    -- offset of origin for this slice in Y-direction
c       m1      -- number of columns in this slice
c       m2      -- number of rows in this slice
c       ncol    -- number of columns in master grid
c       nrow    -- number of rows in master grid
c       nlay    -- number of layers in master grid
c       nspec   -- number of species
c       nedge   -- maximum number of cells on an edge
c       conc    -- gridded conentrations
c     Output:  
c       bndconc -- concentrations on edge cells
c
c    Called by:
c       BNDRY_UPDT
c    Subroutines called:
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer ioff
      integer joff
      integer m1
      integer m2
      integer ncol
      integer nrow
      integer nlay
      integer nspec
      integer nedge
      real conc(m1,m2,nlay,nspec)
      real bndconc(4,nedge,nlay,nspec)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      logical, external :: isbound
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ilay, icl, jcl, ispc
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- Loop over species ---
c
      do ispc=1,nspec 
c
c  --- Loop over layers ---
c
         do ilay=1,nlay
c
c  --- North edge ---
c
           if( isbound( mibcon(1),mmxp(1),mmyp(1),0,mmyp(1) ) ) then
              do icl=1,mmxp(1)
                conc(icl,mmyp(1),ilay,ispc) =  
     &                            bndconc(IDNORTH,icl+mi0(1),ilay,ispc)
              enddo
           endif
c
c  --- South edge ---
c
           if( isbound( mibcon(1),mmxp(1),mmyp(1),0,1 ) ) then
              do icl=1,mmxp(1)
                conc(icl,1,ilay,ispc) =  
     &                             bndconc(IDSOUTH,icl+mi0(1),ilay,ispc)
              enddo
           endif
c
c  --- West edge ---
c
           if( isbound( mibcon(1),mmxp(1),mmyp(1),1,0 ) ) then
              do jcl=1,mmyp(1)
                conc(1,jcl,ilay,ispc) =  
     &                               bndconc(IDWEST,jcl+mj0(1),ilay,ispc)
              enddo
           endif
c
c  --- East edge ---
c
           if( isbound( mibcon(1),mmxp(1),mmyp(1),mmxp(1),0 ) ) then
              do jcl=1,mmyp(1)
                conc(mmxp(1),jcl,ilay,ispc) =  
     &                              bndconc(IDEAST,jcl+mj0(1),ilay,ispc)
              enddo
           endif
c
         enddo
c
      enddo
c
      end

C**** SA_SOAP3_EVAP_PTS
c
      subroutine sa_soap3_evap_pts( idx_pntid,idx_layer_beg,idx_layer_end,
     &                     numpts,num_trac_emiss,istart_hoa,iend_hoa,
     &                   istart_svoa,iend_svoa,evap_factors,temperature,
     &                               sa_pnt_emiss,pntemis_hoa,pntemis_svoa)
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine applies factors to evaporate POA to SVOA and
c     updates the emissions array so emissions are injected into
c     the appropriate model species.
c
c      Copyright Ramboll
c
c     Input arguments:
c        idx_pntid        idxex of this point source in global arrays
c        idx_layer_beg    index of the layer to inject the emissions into
c        idx_layer_end    index of the layer to inject the emissions into
c        numpts           number of points in arrays
c        num_trac_emiss   number of tracer emissions species
c        istart_hoa       starting index in array for HOA emissions
c        iend_hoa         ending index in array for HOA emissions
c        istart_svoa      starting index in array for SVOA emissions
c        iend_svoa        ending index in array for SVOA emissions
c        temperature      temperature in aloft layers
c        sa_pnt_emiss     point emissions rate for SA
c     Output arguments:
c        pntemis_hoa      point emissions by layer HOA tracer species
c        pntemis_svoa     point emissions by layer SVOA tracer species
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/24   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer idx_pntid
      integer idx_layer_beg
      integer idx_layer_end
      integer numpts
      integer istart_hoa
      integer iend_hoa
      integer istart_svoa
      integer iend_svoa
      integer num_trac_emiss
      real    evap_factors(3,NUM_SOAP_EMISS)
      real    temperature(*)
      real    sa_pnt_emiss(numpts,num_trac_emiss)
      real    pntemis_svoa(istart_svoa:iend_svoa,MXLAYER)
      real    pntemis_hoa(istart_hoa:iend_hoa,MXLAYER)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer klay, isoa, ispc_hoa, ispc_svoa, ispc_poa
      real    evap_fact, evap_mass, convfac
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
       pntemis_hoa = 0.
       pntemis_svoa = 0.
c
c ---- loop over model species ---
c
      ispc_svoa = istart_svoa - 1
      ispc_poa = -1
      do ispc_hoa=istart_hoa,iend_hoa
         ispc_svoa = ispc_svoa + 1
         ispc_poa = ispc_poa + 1
c
c  ---- loop over layers ---
c
          do klay=idx_layer_beg,idx_layer_end
c
c  --- see if POA species was found ---
c
              do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                 if( sa_pnt_emiss(idx_pntid,soap3_iemcls(isoa)+ispc_poa) .LE. 0. ) cycle
c
c ---- evaporate POA into SVOA ---
c
                 evap_fact = MIN(1.0,
     &                       (evap_factors(1,isoa) * temperature(klay)**2 + 
     &                        evap_factors(2,isoa) * temperature(klay) + 
     &                        evap_factors(3,isoa) ))
                 evap_mass = sa_pnt_emiss(idx_pntid,soap3_iemcls(isoa)+ispc_poa) * 
     &                       (1. - evap_fact)
                 pntemis_svoa(ispc_svoa,klay) = 
     &                pntemis_svoa(ispc_svoa,klay) + 
     &                 MAX(0., pntemis_svoa(ispc_svoa,klay) + 
     &                                  evap_mass/mole_weight(ksvoa))
c
c ---- back out the vcap emissions from each POA species ---
c
                 pntemis_hoa(ispc_hoa,klay) = pntemis_hoa(ispc_hoa,klay) +
     &             MAX( 0., sa_pnt_emiss(idx_pntid,soap3_iemcls(isoa)+ispc_poa) - evap_mass)
              enddo
          enddo
      enddo
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      Module master_mod                                          
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Local variable descriptions:
c     Input:
c       nmachines   I  total number of procs
c       machnum     I  processor IDs
c       nxbeg       I  beginning I-cell for domain for the slice
c       nxend       I  ending I-cell for full domain for the slice
c       nybeg       I  beginning J-cell for full domain for the slice
c       nyend       I  ending J-cell for full domain for the slice
c       nxbegc      I  beginning I-cell of computational domain for the slice
c       nxendc      I  ending I-cell of computational domain for the slice
c       nybegc      I  beginning J-cell of computational domain for the slice
c       nyendc      I  ending J-cell of computational domain for the slice
c       ixoff       I  offset for I-cell origin in full domain
c       iyoff       I  offset for J-cell origin in full domain
c       ibcflg      I  bcon flag value: max= 1+2+4+8=15
c                      bit 1=west, bit 2=east, bit 3=south, bit 4=north    
c                      deternines if cell is on a true boundary
c       ixb         I  
c       ixe         I  
c       iyb         I  
c       iye         I  
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid_dims   ! MAXGRDS=10, MAXMACH=256
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
c
      integer :: nmachines
      integer, dimension(MAXMACH) :: machnum
c
c     Two dimensional grid index, dimensioned by MAXMACH+1 and MAXGRDS
c
      integer, dimension(0:MAXMACH,MAXGRDS) :: nxbeg
      integer, dimension(0:MAXMACH,MAXGRDS) :: nxend
      integer, dimension(0:MAXMACH,MAXGRDS) :: nybeg
      integer, dimension(0:MAXMACH,MAXGRDS) :: nyend
      integer, dimension(0:MAXMACH,MAXGRDS) :: nxbegc
      integer, dimension(0:MAXMACH,MAXGRDS) :: nxendc
      integer, dimension(0:MAXMACH,MAXGRDS) :: nybegc
      integer, dimension(0:MAXMACH,MAXGRDS) :: nyendc
      integer, dimension(0:MAXMACH,MAXGRDS) :: ixoff
      integer, dimension(0:MAXMACH,MAXGRDS) :: iyoff
      integer, dimension(0:MAXMACH,MAXGRDS) :: ibcflg
      integer, dimension(0:MAXMACH,MAXGRDS) :: ixb
      integer, dimension(0:MAXMACH,MAXGRDS) :: ixe
      integer, dimension(0:MAXMACH,MAXGRDS) :: iyb
      integer, dimension(0:MAXMACH,MAXGRDS) :: iye
c
c     Neighborhood relationships
c         5: beg_col, beg_row, end_col, end_row, destination_node_id
c         7: the 7th of the second dim of the inode_paths_master(,7,,,) array is used to determine
c            the loop limits in fdbackp (aggregation) for averaging the fm over the overlap
c            between the cm node and fm node, rather than always over the full
c            fm node.  It is not used for actually sending stuff.  The
c            inode_paths_master(,6,,,) part of the array is still used for sending the
c            block of averaged cm points from the fm node to the cm node.
c         6: means 6 isend_type(s), this 6 is the same as the first six elements 
c            in inode_paths_master(,7,,,)
c
      integer, dimension(5,7,MAXGRDS,MAXMACH,MAXMACH) :: inode_paths_master
      integer, dimension(6,MAXGRDS,MAXMACH,MAXMACH)   :: iget_paths_master
c
c     length of the array buffer for boundary data transfer
c
      integer, dimension(MAXMACH)                     :: nbuff_nest1
      integer, dimension(MAXMACH)                     :: newbuff_nest1
      integer, dimension(2,MAXMACH,MAXMACH)           :: lbc_buffs
c
c     Some additional nesting parameters
c
      integer, dimension(NXPMAX,MAXGRDS) :: ipm
      integer, dimension(NYPMAX,MAXGRDS) :: jpm
c
      end Module

      subroutine setbc(ip)
      use grid
      use chmstry
      use camxfld
      use tracer
c
c----CAMx v7.40 260801
c
c     SETBC sets up boundary conditions for children grids
c
c      Copyright Ramboll
c          
c     Modifications:
c        01/22/02     Now only sets OSAT to lower bound if not in RTRAC
c        01/30/02     Added code for RTRAC probing tool
c        03/15/09     Added code for deposition output for tracers
c
c     Input arguments:
c        ip                  parent grid index 
c
c     Output arguments:
c        none
c
c     Routines Called:
c        BC1GRD
c        BCMODFY
c
c     Called By:
c        NESTING 
c
      include "camx.prm"
c
      integer*8 mvsa4d
      integer*8 idxsa
c
c-----Entry point
c
c-----When children grids are not connected
c
      do ic = 1,nchdrn(ip)
        ig = idchdrn(ic,ip)
        call bc1grd(nspec,ncol(ip),nrow(ip),nlay(ip),ncol(ig),nrow(ig),
     &              nlay(ig),i1(ig),j1(ig),nmesh(ig),
     &              conc(iptr4d(ip)),conc(iptr4d(ig)) )
c
c======================== Source Apportion Begin =======================
c
        if( ltrace .OR. ((lddm .OR. lhddm) .AND. lddmcalc(ip)) ) then
            call bc1grd(ntotsp,ncol(ip),nrow(ip),nlay(ip),ncol(ig),
     &              nrow(ig),nlay(ig),i1(ig),j1(ig),nmesh(ig),
     &              ptconc(ipsa3d(ip)),ptconc(ipsa3d(ig)) )
            if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                                         tectyp .NE. RTCMC ) then
               mvsa4d = DBLE(ipsa3d(ig)-1) +
     &             DBLE(ncol(ig))*DBLE(nrow(ig))*DBLE(nlay(ig))*DBLE(ntotsp)
               do idxsa=1,mvsa4d
                  ptconc(idxsa) = AMAX1( ptconc(idxsa),BNDLPT )
               enddo
            endif
        endif
c
c========================= Source Apportion End ========================
c
      enddo
c
c-----Modify BC's if some children are attached to each other
c
      do ic1 = 1,nchdrn(ip)
        ig1 = idchdrn(ic1,ip)
        do ic2 = 1,nchdrn(ip)
          ig2 = idchdrn(ic2,ip)
          call bcmodfy(nspec,ncol(ig1),nrow(ig1),nlay(ig1),ncol(ig2),
     &                 nrow(ig2),nlay(ig1),i1(ig1),j1(ig1),i2(ig1),
     &                 j2(ig1),i1(ig2),j1(ig2),i2(ig2),j2(ig2),
     &                 nmesh(ig1),nmesh(ig2),conc(iptr4d(ig1)),
     &                 conc(iptr4d(ig2)) )
c
c======================== Source Apportion Begin =======================
c
           if( ltrace .OR. ((lddm .OR. lhddm) .AND.
     &                      lddmcalc(ig1) .AND. lddmcalc(ig2)) ) then
               call bcmodfy(ntotsp,ncol(ig1),nrow(ig1),nlay(ig1),
     &                ncol(ig2),nrow(ig2),nlay(ig1),i1(ig1),j1(ig1),
     &                i2(ig1),j2(ig1),i1(ig2),j1(ig2),i2(ig2),j2(ig2),
     &                nmesh(ig1),nmesh(ig2),ptconc(ipsa3d(ig1)),
     &                ptconc(ipsa3d(ig2)) )
               if( ltrace .AND. tectyp .NE. RTRAC .AND.
     &                          tectyp .NE. RTCMC ) then
                   mvsa4d = DBLE(ipsa3d(ig1)-1) + 
     &                  DBLE(ncol(ig1))*DBLE(nrow(ig1))*DBLE(nlay(ig1))*DBLE(ntotsp)
                   do idxsa=1,mvsa4d
                      ptconc(idxsa) = AMAX1( ptconc(idxsa),BNDLPT )
                   enddo
                   mvsa4d = DBLE(ipsa3d(ig2)-1) + 
     &                 DBLE(ncol(ig2))*DBLE(nrow(ig2))*DBLE(nlay(ig2))*DBLE(ntotsp)
                   do idxsa=1,mvsa4d
                      ptconc(idxsa) = AMAX1( ptconc(idxsa),BNDLPT )
                   enddo
               endif
           endif
c
c========================= Source Apportion End ========================
c
        enddo
      enddo
c
      return
      end

      subroutine areaprep(igrid,idxfile,begtim,begdate,endtim,enddate,iounit,
     &                    iout_iounit,idiag_iounit,dxmod,dymod)
      use grid
      use chmstry
      use filunit
c 
c----CAMx v7.40 260801
c 
c     AREAPREP reads the header of binary area source emissions file,
c     and maps the area source species list to the internal CAMx species list
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        1/20/99   Grid cell size from file should be meters for all cartesian
c                  projections (UTM, LCP, PSP)
c        10/24/01  Removed BSWAP and converted integer strings to character*4
c        11/06/01  Input dates are now Julian
c        02/09/02  Added code to handle end of year dates
c        12/07/14  Revised for VBS emissions
c        01/08/16  Updated for Revised VBS emissions
c        05/13/16  Added checks for I2/HOI with in-line Ix emissions
c        11/22/17  Added checks for PFE/PMN/PK/PCA/PMG emissions
c        11/21/25   Changed the way lemmap works - it now points the other direction
c 
c     Input arguments: 
c        igrid               grid index
c        idxfile             file index
c        begtim              model start time (HHMM) 
c        begdate             model start date (YYJJJ) 
c        endtim              model end time (HHMM) 
c        enddate             model end date (YYJJJ)
c        iounit              area emissions file unit
c        iout_iounit         output message file unit
c        idiag_iounit        output diagnostic file unit
c        dxmod               model grid size in x-direction (deg or km) 
c        dymod               model grid size in y-direction (deg or km)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        STARTUP 
c 
      include 'camx.prm'
      include 'flags.inc'
      include 'vbs.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      character*4 ifile(10),note(60)
      integer begdate,enddate
      character*10 arfil,infil,arspc 
c
      character*4 arspec(10,MXSPEC)
c
      integer, parameter :: num_elem = 5
      integer :: idx_elem(num_elem)
      integer    idxar
      logical, allocatable, dimension(:) :: lfound
      logical lfound_poa(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB)
      logical lfound_svoa, lfound_hoa
c
      integer isoa
c
      data arfil /'EMISSIONS '/
c
c-----Entry point
c
c-----Read 1st AREA header record and check inputs 
c             
      rewind(iounit)
      read(iounit) ifile,note,nseg,narspc(igrid,idxfile),idat1,tim1,idat2,tim2
      allocate( lfound(narspc(igrid,idxfile)) )
c             
      if( INT(tim2) .EQ. 24 ) then
          idat2 = idat2 + 1
          tim2 = 0.
          if( MOD(idat2,1000) .GT. 365 ) then 
             if( MOD(INT(idat2/1000),4) .EQ. 0 ) then 
                if( MOD(idat2,1000) .EQ. 367 )
     &                    idat2 = (INT(idat2/1000)+1)*1000 + 1
             else
                idat2 = (INT(idat2/1000)+1)*1000 + 1 
             endif
          endif
      endif
      write(infil,'(10a1)') (ifile(n),n=1,10) 
      if (infil.ne.arfil) then 
        write(iout_iounit,'(//,a)') 'ERROR in AREAPREP:'
        write(iout_iounit,*)'AREA input file is not labelled EMISSIONS' 
        call camxerr()
      endif   
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if (idat1.gt.begdate) then 
        write(iout_iounit,'(//,a)') 'WARNING in AREAPREP:'
        write(iout_iounit,*)'AREA start date > simulation start date' 
        write(iout_iounit,*)'AREA file: ',idat1
        write(iout_iounit,*)'Sim start: ',begdate 
        if (.not.le1day) then
          write(iout_iounit,*)'CAMx expecting day-specific emissions: Stopping'
          call camxerr()
        endif
      elseif (idat1.eq.begdate .and. tim1.gt.begtim) then 
        write(iout_iounit,'(//,a)') 'ERROR in AREAPREP:'
        write(iout_iounit,*)'AREA start time > simulation start time' 
        write(iout_iounit,*)'AREA file: ',tim1
        write(iout_iounit,*)'Sim start: ',begtim 
        call camxerr()
      elseif (idat2.lt.enddate) then 
        write(iout_iounit,'(//,a)') 'WARNING in AREAPREP:'
        write(iout_iounit,*)'AREA end date < simulation end date' 
        write(iout_iounit,*)'AREA file: ',idat2
        write(iout_iounit,*)'  Sim end: ',enddate 
        if (.not.le1day) then
          write(iout_iounit,*)'CAMx expecting day-specific emissions: Stopping'
          call camxerr()
        endif
      elseif (idat2.eq.enddate .and. tim2.lt.endtim) then 
        write(iout_iounit,'(//,a)') 'WARNING in AREAPREP:'
        write(iout_iounit,*)'AREA end time < simulation end time' 
        write(iout_iounit,*)'AREA file: ',tim2
        write(iout_iounit,*)'  Sim end: ',endtim 
        call camxerr()
      endif 
c 
c-----Read 2nd AREA header record and check inputs 
c 
      read(iounit) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz 
      if (.NOT.llatlon) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if (abs(dx-dxmod).gt.0.001 .or. abs(dy-dymod).gt.0.001) then
        write(iout_iounit,'(//,a)') 'WARNING in AREAPREP:'
        write(iout_iounit,*)'AREA cell size not equal to model cell size'
        write(iout_iounit,'(a,2f10.4)')'AREA file: ',dx,dy
        write(iout_iounit,'(a,2f10.4)')'    model: ',dxmod,dymod
        write(iout_iounit,*)
      endif
      if (nx.ne.ncol(igrid) .or. ny.ne.nrow(igrid)) then
           if( nx .EQ. ncol(igrid)-2 .AND. ny .EQ. nrow(igrid)-2 ) then
              buffer_offset_iarem(igrid,idxfile) = 1
           else 
              write(iout_iounit,'(//,a)') 'ERROR in AREAPREP:'
              write(iout_iounit,*)'AREA grid size not equal to model grid size '
              write(iout_iounit,*)'   grid #: ',igrid
              write(iout_iounit,*)'AREA file: ',nx,ny,nz
              write(iout_iounit,*)'    model: ',ncol(igrid),nrow(igrid),nlay(igrid)
              write(iout_iounit,*)
              call camxerr()
           endif
      else
           buffer_offset_iarem(igrid,idxfile) = 0
      endif 
c 
c-----Read 3rd & 4th AREA header 
c 
      read(iounit) 
      read(iounit) ((arspec(n,l),n=1,10),l=1,narspc(igrid,idxfile)) 
c
c----Find this species in master list ---
c
      do l=1,narspc(igrid,idxfile)
        write(arspc,'(10a1)') (arspec(n,l),n=1,10) 
        if( arspc .EQ. 'HNO2      ') arspc = 'HONO      '
        if( arspc .EQ. 'HCHO      ' .AND. kHCHO .EQ. nspec+1)
     &                                       arspc = 'FORM      '
        do isoa=1,NUM_SOAP_SPECIES
             if( arspc(1:4) .EQ. 'POA ' ) cycle
             if( arspc .EQ. soap2_spec_names(isoa) )
     &                            arspc = soap3_spec_names(isoa)
        enddo
        if( arspc(1:4) .EQ. 'POA ' .AND. luse_soap3 ) arspc = 'POA_AV    '
        idxems_files(igrid,idxfile,l) = 0
c
c  --- find species in list ---
c
        lfound(l) = .FALSE.
        do ispc=1,nspec
           if(arspc .EQ. spname(ispc)) lfound(l) = .TRUE.
        enddo
        do ispc=1,NUM_SOAP_EMISS
           if( arspc .eq. soap_emiss_names(ispc) ) lfound(l) = .TRUE.
       enddo
        if( .NOT. lfound(l) ) cycle
        do k=1,nemspc
          if(arspc .EQ. emspcname(k) ) idxems_files(igrid,idxfile,l) = k
        enddo
        if( idxems_files(igrid,idxfile,l) .EQ. 0 ) then
           nemspc = nemspc + 1
           emspcname(nemspc) = arspc
           idxems_files(igrid,idxfile,l) = nemspc
           idxar = nemspc
        endif
      enddo
c 
c-----Map AREA species to model species 
c 
      do 15 lar = 1,narspc(igrid,idxfile)
        if( .NOT. lfound(lar) ) cycle
        write(arspc,'(10a1)') (arspec(n,lar),n=1,10) 
        if (arspc.eq.'HNO2      ') arspc = 'HONO      '
        if (arspc.eq.'HCHO      ' .and. kHCHO.eq.nspec+1)
     &                                        arspc = 'FORM      '
        do isoa=1,NUM_SOAP_SPECIES
             if( arspc(1:4) .EQ. 'POA ' ) cycle
             if( arspc .EQ. soap2_spec_names(isoa) )
     &                            arspc = soap3_spec_names(isoa)
        enddo
        if( arspc(1:4) .EQ. 'POA ' .AND. luse_soap3 ) arspc = 'POA_AV    '
c
c   --- update names for SOAP3 ---
c
        do isoa=1,NUM_SOAP_SPECIES
           if( arspc(1:4) .EQ. 'POA ' ) cycle
           if( arspc .EQ. soap2_spec_names(isoa) ) then
               arspc = soap3_spec_names(isoa)                   
           endif
        enddo
        do 20 l=1,nspec 
          
          if(arspc.eq.spname(l)) then 
            lemmap(idxems_files(igrid,idxfile,lar)) = l
            write(idiag_iounit,'(2(a,i5,2x,a))')
     &                   'Area source species ',lar,arspc, 
     &                   ' mapped to model species ',l,spname(l) 
            if (arspc.eq.'I2        ' .OR. arspc.eq.'HOI       ') then
              if (lixemis) then
                write(iout_iounit,'(//,A)') 'ERROR in AREAPREP:'
                write(iout_iounit,'(A)') 'In-line Ix emissions are invoked,'
                write(iout_iounit,'(2A)')'but I2 and/or HOI found',
     &                            ' in an input gridded emissions file.'
                write(iout_iounit,'(A)') 'Either turn off in-line Ix emissions'
                write(iout_iounit,'(2A)')'or remove I2 and HOI emissions from',
     &                            ' the gridded emissions file.'
                call camxerr()
              endif
            endif
            goto 15 
          endif 
c
c  --- check for SOAP3 species ---
c
          if( luse_soap3 ) then
            if( spname(l)(1:4) .NE. 'HOA ' ) cycle
            do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
              if( arspc .EQ. soap_emiss_names(isoa) ) then
                  lemmap(idxems_files(igrid,idxfile,lar)) = l
                  write(idiag_iounit,'(2(a,i5,2x,a))')
     &                   'Area source species ',lar,arspc, 
     &                   ' mapped to model species ',l,spname(l) 
              endif
            enddo
          endif
 20     continue 
        write(idiag_iounit,*)'AREA species: ',arspc,' not modeled'
 15   continue
c
c --- make sure that SVOA is in the list of emissions species ---
c
      if( luse_soap3 .AND. ksvoa .NE. nspec+1 ) then
          lfound_svoa = .FALSE.
          do i=1,nemspc
            if( emspcname(i)(1:5) .EQ. 'SVOA ' ) then
                lfound_svoa = .TRUE.
                lemmap(i) = ksvoa
                idx_ems_svoa = i
            endif
          enddo
          if( .NOT. lfound_svoa ) then
             nemspc = nemspc + 1
             emspcname(nemspc) = 'SVOA      ' 
             lemmap(nemspc) = ksvoa
             idx_ems_svoa = nemspc
          endif
      endif
      if( luse_soap3 .AND. khoa .NE. nspec+1 ) then
          lfound_hoa = .FALSE.
          do i=1,nemspc
            if( emspcname(i)(1:4) .EQ. 'POA ' ) then
                lfound_hoa = .TRUE.
                lemmap(i) = khoa
                idx_ems_hoa = i
            endif
          enddo
          if( .NOT. lfound_hoa ) then
             nemspc = nemspc + 1
             emspcname(nemspc) = 'POA       ' 
             lemmap(nemspc) = khoa
             idx_ems_hoa = nemspc
          endif
      endif
      if( luse_soap3 .AND. khoa .NE. nspec+1 ) then
          do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
             do i=1,nemspc
               if( soap_emiss_names(isoa) .EQ. emspcname(i) ) then
                   lfound_poa(isoa) = .TRUE.
               endif
             enddo
             if( .NOT. lfound_poa(isoa) ) then
                nemspc = nemspc + 1
                emspcname(nemspc) = soap_emiss_names(isoa)
             endif
          enddo
      endif
c
      write(idiag_iounit,*)
      deallocate( lfound )
c
 9999 continue
c             
      return
      end

c**** NCF_WRT_DATA_GRID
c
      subroutine ncf_wrt_data_grid(action,iounit,igrd,grid_ncol,grid_nrow,
     &               grid_xorig,grid_yorig,grid_deltax,grid_deltay,nlays,
     &                                       grid_lat,grid_lon,grid_topo)
      use ncf_iomod
      use filunit
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the variable data for the grid definiton 
c    variables to the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action      C name of file to open
c           iounit      I NetCDF file ID of file
c           igrd        I grid index for this grid
c           grid_ncol   I number of grid cells in X direction
c           grid_nrow   I number of grid cells in Y direction
c           grid_xorig  R X coordinate of grid origin      
c           grid_yorig  R Y coordinate of grid origin      
c           grid_dxcell R cell width in X direction
c           grid_dycell R cell width in Y direction
c           nlays       I number of layers in this file
c           grid_lat    R latitude value of cell center
c           grid_lon    R longitude value of cell center
c           grid_topo   R height above sea level of cell center
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c     03/15/21   --gwilson--    Changed TOPO to float from double
c     08/21/23   --cemery--     Fixed X,Y 1-D arrays to remove nested
c                               buffer cells
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
      integer       igrd
      integer       grid_ncol
      integer       grid_nrow
      real          grid_xorig
      real          grid_yorig
      real          grid_deltax
      real          grid_deltay
      integer       nlays
      real          grid_lat(grid_ncol,grid_nrow)
      real          grid_lon(grid_ncol,grid_nrow)
      real          grid_topo(grid_ncol,grid_nrow)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 this_var
      real          factor
      integer,      allocatable, dimension(:)   :: iarray_1d
      integer       this_varid, icol, irow, ilay, ierr, itmp, jtmp
      integer       ibegcel, iendcel, jbegcel, jendcel, buffer_offset
      integer       this_val
      real*4,       allocatable, dimension(:,:) :: rarray_2d
      real*8,       allocatable, dimension(:)   :: darray_1d
      real*8,       allocatable, dimension(:,:) :: darray_2d
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- variable for X coordinates ---
c
      factor = 1000.
      if( llatlon ) factor = 1.0
      this_var = "X"
      if( igrd .EQ. 1 ) then
         allocate( darray_1d(ncol(igrd)) )
         ibegcel = 1
         iendcel = ncol(igrd)
         buffer_offset = 0
      else
         allocate( darray_1d(ncol(igrd)-2) )
         ibegcel = 2
         iendcel = ncol(igrd)-1
         buffer_offset = 1
      endif
      this_val = 0
      do icol=ibegcel,iendcel
        this_val = this_val + 1
        darray_1d(this_val) = DBLE((grid_xorig + 
     &                           (REAL(icol)-0.5)*grid_deltax)/factor)
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( darray_1d )
c
c  --- variable for Y coordinates ---
c
      this_var = "Y"
      if( igrd .EQ. 1 ) then
         allocate( darray_1d(nrow(igrd)) )
         jbegcel = 1
         jendcel = nrow(igrd)
      else
         allocate( darray_1d(nrow(igrd)-2) )
         jbegcel = 2
         jendcel = nrow(igrd)-1
      endif
      this_val = 0
      do irow=jbegcel,jendcel
        this_val = this_val + 1
        darray_1d(this_val) = DBLE((grid_yorig + 
     &                           (REAL(irow)-0.5)*grid_deltay)/factor)
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( darray_1d )
c
c  --- variable for Layer heights ---
c
      this_var = "layer"
      allocate( iarray_1d(nlays) )
      do ilay=1,nlays
        iarray_1d(ilay) = ilay
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_int(iounit,this_varid,iarray_1d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( iarray_1d )
c
c  --- variable for longitude coordinates ---
c
      if( igrd .EQ. 1 ) then
         allocate( darray_2d(ncol(igrd),nrow(igrd)) )
         allocate( rarray_2d(ncol(igrd),nrow(igrd)) )
      else
         allocate( darray_2d(ncol(igrd)-2,nrow(igrd)-2) )
         allocate( rarray_2d(ncol(igrd)-2,nrow(igrd)-2) )
      endif
c
      this_var = "longitude"
      do icol=ibegcel,iendcel
        itmp = icol-buffer_offset
        do irow=jbegcel,jendcel
           jtmp = irow-buffer_offset
           darray_2d(itmp,jtmp) = DBLE(grid_lon(icol,irow))
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
c
c  --- variable for latitude coordinates ---
c
      this_var = "latitude"
      do icol=ibegcel,iendcel
        itmp = icol-buffer_offset
        do irow=jbegcel,jendcel
           jtmp = irow-buffer_offset
           darray_2d(itmp,jtmp) = DBLE(grid_lat(icol,irow))
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_double(iounit,this_varid,darray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
c
c  --- variable for topo ---
c
      this_var = "topo"
      do icol=ibegcel,iendcel
        itmp = icol-buffer_offset
        do irow=jbegcel,jendcel
           jtmp = irow-buffer_offset
           rarray_2d(itmp,jtmp) = grid_topo(icol,irow)
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_real(iounit,this_varid,rarray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( rarray_2d )
      deallocate( darray_2d )
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot write data for the variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c*** HDRRCPDDM
c
      subroutine hdrrcpddm(idate,btim,jdate,etim)
      use filunit
      use chmstry
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the header information for the receptor
c     output file for DDM.
c
c      Copyright Ramboll
c
c     Argument declarations:
c        idate   I   beginning date of simulation (YYJJJ)
c        btim    R   beginning time of simulation
c        jdate   I   ending date of simulation (YYJJJ)
c        etim    R   ending time of simulation
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c    07/18/01  --gyarwood--  Original development from HDRRCP for OSAT
c    04/02/03  --gwilson--   Added grid number to recptors defined by
c                            cell index
c    07/16/07  --bkoo--      Revised for HDDM
c    06/11/08  --bkoo--      Added rate constant sensitivity
c    08/09/18  --bkoo--      Added rate term sensitivity
c    01/08/19  --gwilson--   Revised for deposition DDM
c    04/30/19  --pkk--       Fix typo for nicddm instead of nbcddm
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   jdate
      real      etim
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*40 cdate
      integer      ndate, ndlast, itype, i, j, nbound, noutsen
      real         ttime, ttlast
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- if no receptor file is provided, just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
c  --- set up the date and time ---
c
      ndate = idate
      ttime = btim/100.0
      ndlast = jdate
      ttlast = etim/100.0
      if( ttlast .EQ. 0. ) then
          ttlast = 24.0
          ndlast = ndlast - 1
      endif
c
c  --- get the date and time and write header records ---
c
      call fdate( cdate )
      write(iowrcp,9010,ERR=7000) 'CAMx', runmsg, verson
      write(iowrcp,'(A)',ERR=7000) cdate(1:24)
c
c  --- write the dates and times of simuation ---
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9001,ERR=7000) ndate, ttime, ndlast, ttlast
      write(iowrcp,9008,ERR=7000)'Average Interval ',ANINT(dtout)/60.
c
c  --- write summaries of sensitivities requested ---
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of IC influencing species   ',
     &                                                            nicddm
      write(iowrcp,9003,ERR=7000) 'IC influencing species             '
      if (nicddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (icddmsp(i),i=1,nicddm)
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of IC sensitivities         ',
     &                                                      nspec*nicddm
      write(iowrcp,9000,ERR=7000)
c
      nbound = 1
      if (lbndry) nbound = 5
      if (nbcddm.EQ.0) nbound = 0
      write(iowrcp,9002,ERR=7000) 'Number of BC influencing species   ',
     &                                                            nbcddm
      write(iowrcp,9003,ERR=7000) 'BC influencing species             '
      if (nbcddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (bcddmsp(i),i=1,nbcddm)
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of boundary groups          ',
     &                                                            nbound
      write(iowrcp,9002,ERR=7000) 'Number of BC sensitivities         ',
     &                                               nspec*nbound*nbcddm
      write(iowrcp,9000,ERR=7000)
c
      write(iowrcp,9002,ERR=7000) 'Number of Deposition influencing species   ',
     &                                                            ndepddm
      write(iowrcp,9003,ERR=7000) 'Deposition influencing species             '
      if (ndepddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (depddmsp(i),i=1,ndepddm)
c
      write(iowrcp,9002,ERR=7000) 'Number of emiss influencing species',
     &                                                            nemddm
      write(iowrcp,9003,ERR=7000) 'Emissions influencing species      '
      if (nemddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (emddmsp(i),i=1,nemddm)
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of emission source areas    ',
     &                                                            nregin
      write(iowrcp,9002,ERR=7000) 'Number of emission categories      ',
     &                                                            ngroup
      write(iowrcp,9002,ERR=7000) 'Number of emission sensitivities   ',
     &                                        nspec*ngroup*nregin*nemddm
      write(iowrcp,9000,ERR=7000)
c
      write(iowrcp,9002,ERR=7000) 'Number of rate constant groups     ',
     &                                                          nrateddm
      write(iowrcp,9003,ERR=7000) 'Influencing rate constant groups   '
      if (nrateddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (rateddm(i),i=1,nrateddm)
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of rate const sensitivities ',
     &                                                    nspec*nrateddm
      write(iowrcp,9000,ERR=7000)
c
      write(iowrcp,9002,ERR=7000) 'Number of rate term groups     ',
     &                                                          ntermddm
      write(iowrcp,9003,ERR=7000) 'Influencing rate term groups   '
      if (ntermddm.gt.0)
     &        write(iowrcp,9003,ERR=7000)  (termddm(i),i=1,ntermddm)
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of rate term sensitivities ',
     &                                                    nspec*ntermddm
      write(iowrcp,9000,ERR=7000)
c
      write(iowrcp,9002,ERR=7000) 'Number of HDDM sensitivity groups  ',
     &                                                             nhddm
      write(iowrcp,9003,ERR=7000) 'Influencing HDDM sens parameters   '
      if (nhddm.gt.0) then
        do i=1,nhddm
          if (i.gt.1) write(iowrcp,9003,ERR=7000)
     &                            '                                   '
          write(iowrcp,9003,ERR=7000) hddmsp(1,i),hddmsp(2,i)
          if (i.lt.nhddm) write(iowrcp,9000,ERR=7000)
        enddo
      endif
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of HDDM sensitivities       ',
     &                                                       nspec*nhddm
      write(iowrcp,9000,ERR=7000)
c
c   --- write the sensitivity names to output ---
c
      write(iowrcp,9002,ERR=7000) 'Total number of sensitivities      ',
     &                                                            ntotsp
      noutsen = 0
      do i = 1,ntotsp
        if (loutsa(i)) 
     &    noutsen = noutsen + 1
      enddo
      write(iowrcp,9002,ERR=7000) 'Number of sensitivities output     ',
     &                                                           noutsen
      if (noutsen.EQ.0) goto 7001
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9003,ERR=7000) 'Short Sensitivity Names'
      do i = 1,ntotsp
        if (loutsa(i)) 
     &      write(iowrcp,9003,ERR=7000) ptname(i)
      enddo
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9003,ERR=7000) 'Long Sensitivity Names'
      do i = 1,ntotsp
        if (loutsa(i)) 
     &      write(iowrcp,9003,ERR=7000) ptlong(i)
      enddo
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9000,ERR=7000)
c
c   --- write the receptor definitions to output ---
c
      write(iowrcp,9002,ERR=7000) 'Number of receptors ',nrecep
      write(iowrcp,9004,ERR=7000)
c
c   --- do all receptors ---
c
      do i=1,nrecep
         if( idrcp(i) .EQ. IDPNT ) then
            itype = 0
            write(iowrcp,9005,ERR=7000) i, rcpnam(i), itype, 
     &                                              recepx(i), recepy(i)
         else if( idrcp(i) .EQ. IDCEL ) then
            itype = 1
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          irecep(i,1), jrecep(i,1)
         else if( idrcp(i) .EQ. IDAVG ) then
            itype = nclrcp(i)
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          irecep(i,1), jrecep(i,1)
            do j=2,nclrcp(i)
                 write(iowrcp,9011,ERR=7000) irecep(i,j), jrecep(i,j)
            enddo
         else if( idrcp(i) .EQ. IDWAL ) then
            itype = 3
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          iwalbg(i), iwalnd(i)
            write(iowrcp,9011,ERR=7000) jwalbg(i), jwalnd(i)
            write(iowrcp,9011,ERR=7000) kwalbg(i), kwalnd(i)
         endif
      enddo
c
c  --- write the header for rest of data ---
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9000,ERR=7000) 'Time Varying Sensitivity Data'
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in HDRRCPDDM:'
      write(iout,9020) 'Writing header of DDM receptor file.'
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in HDRRCPDDM:'
      write(iout,9020) 'Number of sensitivities requested'//
     &    ' for output is zero.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(2(:,A,','))
 9001 format(' File Duration  ,',2(I10.5,',',F10.2,','))
 9002 format(A,',',I10)
 9003 format(:,A,',',$)
 9004 format('  No,   Name,  ',2x,'Grid#,   Type,    Xloc,      Yloc,')
 9005 format(I4,',',1X,A10,',',1X,I4,', ,',2(F10.1,',',1X))
 9006 format(I4,',',1X,A10,',',1X,I4,',',1X,I4,',',2(I10,',',1X))
 9008 format(A,',',F10.4)
 9010 format(3(A,','))
 9011 format(20X,',,,',2(I10,',',1X))
 9020 format(/,1X,A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine emassign(ncol,nrow,nlay_ems,io,jo,nmesh,ncolf,nrowf,
     &                                            nspcems,cgems,fgems)
c
c----CAMx v7.40 260801
c
c     EMASSIGN assigns emissions to fine grid values from coarse grid
c
c      Copyright Ramboll
c          
c     Modifications:
c        none
c
c     Input arguments:
c        ncol              number of columns in the parent grid
c        nrow              number of rows in the parent grid
c        nlay_ems          number of layers in emissions filas
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        nspcems           number of emissions species
c        cgems             emissions value on coarse grid
c
c     Output arguments:
c        fgems             emissions value on fine grid
c
c     Subroutine called:
c        none
c
c     Called by:
c
      real cgems(ncol,nrow,nlay_ems,nspcems)
      real fgems(ncolf,nrowf,nlay_ems,nspcems)
c
c-----Entry point
c
        do k=1,nspcems
           do 40 jfin = 2,nrowf-1
             j = (jfin - 2)/nmesh + jo
             do 30 ifin = 2,ncolf-1
               i = (ifin - 2)/nmesh + io
               do ilay=1,nlay_ems
                   fgems(ifin,jfin,ilay,k) = cgems(i,j,ilay,k)/(nmesh*nmesh)
               enddo
  30         continue
  40       continue
        enddo
c
      return
      end

      subroutine average_csa(icsa_grid,m1,m2,m3,igrid_mod,dt,
     &                   ncol,nrow,nlay,nspc,
     &                   tempk,press,conc,avcnc,ipa_cel)
      use procan
      implicit none
c
c----CAMx v7.40 260801
c
c     AVERAGE computes time-averaged concentrations. This version is for CSA arrays.
c
c      Copyright Ramboll
c
c     Modifications: 
c
c     Input arguments:
c        icsa_grid          grid number for CSA domain
c        m1                 number of columns in met arrays
c        m2                 number of rows in met arrays
c        m3                 number of layers in met arrays
c        igrid_mod          index of modeling grid
c        dt                 time step for present grid concentration (s)
c        ncol               number of columns in conc arrays 
c        nrow               number of rows in conc arrays 
c        nlay               number of layers in conc arrays 
c        nspc               number of species in conc array
c        tempk              temperature field (K)
c        press              pressure field (mb)
c        conc               instant species concentration (umol/m3)
c        avcnc              average species concentration (gas=ppm)
c        ipa_cel            index of grid cell into CSA cells
c     Output arguments:
c        avcnc              average species concentration (gas=ppm)
c
c     Routines Called:
c        none
c
c     Called by:
c        CSA_AVRG
c
      include "camx.prm"
      include "camx.inc"
 
      integer icsa_grid
      integer m1
      integer m2
      integer m3
      integer igrid_mod
      integer ncol
      integer nrow
      integer nlay
      real    dt
      integer nspc
      real    tempk(m1,m2,m3),press(m1,m2,m3)
      real    avcnc(ncol,nrow,nlay,nspc)
      real    conc(ncol,nrow,nlay,nspc)
      integer ipa_cel(m1,m2,m3)
c
c-----Local variables ---
c
      integer lsp, i, j, k, icell, jcell, kcell, idxpa
      real    dtfact, convfac, tmp
c
c-----Entry point
c
c-----Increment running average
c
      dtfact = dt/(dtout*60.)
      do lsp = 1,nspc
        convfac = 1.
        do j = 2,m2-1
          do i = 2,m1-1
            do k=1,m3
                idxpa = ipa_cel(i,j,k)
                if( idxpa .GT. 0 ) then
                   if( ipanst(idxpa) .EQ. igrid_mod .AND. 
     &                     ipadom(idxpa) .EQ. icsa_grid ) then
                      icell = ipax(idxpa) - i_sw(ipadom(idxpa)) + 1
                      jcell = ipay(idxpa) - j_sw(ipadom(idxpa)) + 1
                      kcell = ipaz(idxpa) - b_lay(ipadom(idxpa)) + 1
                      tmp = 273./tempk(i,j,k)*press(i,j,k)/1013.
                      convfac = 1./(densfac*tmp)
                      avcnc(icell,jcell,kcell,lsp) = 
     &                      convfac*conc(icell,jcell,kcell,lsp)*dtfact +
     &                                      avcnc(icell,jcell,kcell,lsp)
                   endif
                endif
            enddo
          enddo
        enddo
      enddo
c
      return
      end

      subroutine zadvec(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,
     &                  iflag,igrd,ncol,nrow,nlay,nrads,ngaspc,nspc,
     &                  nsen,delt,dx,
     &                  dy,idfin,depth,entrn,dilut,tempk,press,species,
     &                  conc,lreadtop,rhoscl,ctop,lvupsolv,ptrtop,fluxes,
     &                  fluxtmp,isaptr,ipa_xy,ipa_lay,iproc_id)
      use filunit
      use chmstry
      use bndary
      use procan
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c     ZADVEC drives vertical transport of concentrations.  The operation
c     is performed on the regular model species (iflag=1), RTRAC species
c     (iflag=2), or source apportionment tracers (iflag=3).
c     This version also performs vertical transport of sensitivities 
c     in the regular model call (iflag = 1) if DDM is enabled.
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        12/3/99   Top boundary condition is converted from ppm to umol/m3
c                  using extrapolated density in an overlying layer
c                  that is assumed to be the same thickness as the top
c                  layer of the model
c       12/07/01   added instructions for OMP
c       01/30/02   Added code for RTRAC probing tool
c        3/06/06   Revised top BC approach; removed top dummy layer
c       05/01/07   Fixed bug that was causing PM PSAT species to
c                  be converted to micro-moles
c       07/16/07 -bkoo-     Added check for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       04/09/09   Improved definition of atmospheric density at top of model
c       11/04/09   Revised vertical advection solver technique, now
c                  employs zero-gradient top boundary condition
c       11/12/09   Added code to save fluxes and apply to the tracers
c        4/07/14   Added top con file
c       11/28/16 -bkoo-     Updated DDM for new top con
c        4/27/21   Added explicit PPM solver with time splitting 
c       12/23/24   Fix logical tests for loading core and PT top cons
c  
c     Input arguments:
c        iflag             call ID (1=reg, 2=RTRAC, 3=SAT)
c        igrd              grid index
c        ncol              number of columns
c        nrow              number of rows
c        nlay              number of layers
c        nrads             number of radicals
c        ngaspc            number of gas species
c        nspc              number of species
c        nsen              number of species X number of DDM parameters
c                          or number of tracer species
c                          or 1, whichever is larger
c        delt              time step (s)
c        dx                cell size in x-direction (m)
c        dy                cell size in y-direction (m)
c        idfin             map of nested grids in this grid
c        depth             layer depth (m)
c        entrn             entrainment rate (m/s)
c        dilut             dilution rate (m/s)
c        tempk             temperature (K)
c        press             pressure (mb)
c        species           species names
c        conc              species concentrations (umol/m3)
c        lreadtop          top con read from input file 
c        rhoscl            density scaling above top of model (unitless)
c        ctop              concentrations at model top
c                               (umol/m3 if from top layer, ppm if read)
c        lvupsolv          3-D flag to use upstream donor solver
c        ptrtop            DDM sensitivities at model top (like ctop)
c        fluxtmp           temporary array for fluxes
c        ipa_xy            2-D gridded array to identify if cell is
c                          in a IPRM sub-domain
c        ipa_lay           3-D gridded array to identify IPRM sub-domain
c                          each layer is in
c        iproc_id          ID for this processor in MPI rank
c
c     Output arguments:
c        conc              species concentrations (umol/m3)
c        fluxes            fluxes across the boundaries (umol)
c
c     Routines Called:
c        VRTSLV
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include "camx.prm"
      include "camx.inc"
      include "flags.inc"
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon
      integer :: m_zi1,m_zi2,m_zj1,m_zj2
c
      integer      ncol
      integer      nrow
      integer      nlay
      integer      nrads
      integer      ngaspc
      integer      nspc
      integer      igrd
      integer      nsen
      integer      iflag
      character*10 species(nspc)
      real         conc(m1,m2,m3,nspc)
      real         fluxtmp(m1,m2,m3,nspc)
      real         ctop(m1,m2,nspc)
      real         rhoscl(m1,m2)
      logical      lvupsolv(m1,m2,m3)
      real         ptrtop(m1,m2,nsen)
      integer*8    isaptr
      real, dimension(m1,m2,m3) :: entrn,dilut,tempk,press
      real, dimension(m1,m2,m3) :: depth
      real         dx(nrow)
      integer      idfin(m1,m2)
      logical      lreadtop
      real*8       fluxes(nspc,11)
      real         delt
      real         dy
      real         entrnfac
      integer      iproc_id
      integer ispc,j,i,k,numspcs
      real convfac
      real c1d(MXLAYER+1)
      real d1d(MXLAYER)
      real ent1d(MXLAYER)
      real dil1d(MXLAYER)
      real fluxlay(MXLAYER)
      logical lvus(MXLAYER)
c
c===========================DDM Begin=================================
c
      integer isen,ioff
      integer*8 idx
      real sen1d((MXLAYER+1),MXFDDM)
c
c===========================DDM End===================================
c
c=================== Process Analysis Begin ==========================
c
      integer ipa_xy(ncol,nrow)
      integer ipa_lay(ncol,nrow,nlay)
      integer ipa_idx
      logical ldoipts
      real fc1(MXLAYER)
      real fc2(MXLAYER)
      real fc3(MXLAYER)
c
c==================== Process Analysis End ===========================
c
c
c-----Entry point
c
! Set grid point limits
      m_zi1= ia-1
      m_zi2= iz+1
      m_zj1= ja-1
      m_zj2= jz+1

      if(btest(ibcon,0)) m_zi1 = ia
      if(btest(ibcon,1)) m_zi2 = iz
      if(btest(ibcon,2)) m_zj1 = ja
      if(btest(ibcon,3)) m_zj2 = jz
c
c  ---- Initialize the temp flux array to zero ---
c
      if( iflag .EQ. 1 ) call zeros(fluxtmp,m1*m2*m3*nspc)
c
c-----Vertical advection, entrainment, and dilution
c
      entrnfac = 1.
      if (lzppm) entrnfac = -1.
      numspcs = nspc
      if( iflag .GT. 1 ) numspcs = nsaspc

      if( iproc_id .LE. 1 ) then
        if( iflag .eq. 1 ) then
          write(*,'(a20,$)') 'z advection ......'
        elseif (iflag .eq.2 ) then
          write(*,'(a20,$)') 'RT z advection ...'
        else
          write(*,'(a20,$)') 'SA z advection ...'
        endif
      endif
      if( iflag .eq. 1 ) then
         write(iout,'(a20,$)') 'z advection ......'
      elseif (iflag .eq. 2 ) then
         write(iout,'(a20,$)') 'RT z advection ...'
      else
         write(iout,'(a20,$)') 'SA z advection ...'
      endif
c
c$omp parallel default(shared)
c$omp&  private(ispc,i,j,k,ent1d,dil1d,d1d,c1d,lvus,fluxlay,
c$omp&          convfac,isen,ioff,idx,sen1d,
c$omp&          ldoipts,ipa_idx,fc1,fc2,fc3)
c
c$omp do schedule(guided)
c
      do 40 ispc = nrads+1,numspcs
           do 60 j = m_zj1, m_zj2   !2,nrow-1
             do 50 i = m_zi1, m_zi2  !2,ncol-1
c
c-----Skip cells occupied by child grids
c
            sen1d = 0.
            if (idfin(i,j).gt.igrd) goto 50
            do k = 1,nlay
              ent1d(k) = entrnfac*entrn(i,j,k)
              dil1d(k) = dilut(i,j,k)
              d1d(k)   = depth(i,j,k)
              c1d(k)   = conc(i,j,k,ispc)
              lvus(k)  = lvupsolv(i,j,k)
            enddo
            if (lreadtop) then    !<--- from argument, core vs. PT specific
              convfac = 1.
              if ((iflag.LT.3 .AND. ispc .LE. ngaspc) .OR. !<---- this is not right for a SA/RT call
     &            (iflag.EQ.3 .AND. lsagas(ispc)))         !<---- this is not right for a SA/RT call
     &          convfac = densfac*(273./tempk(i,j,nlay))*
     &                            (press(i,j,nlay)/1013.)
              c1d(nlay+1) = convfac*ctop(i,j,ispc)
            else
              c1d(nlay+1) = rhoscl(i,j)*ctop(i,j,ispc) !<--- needs if/else
            endif
c
c================================DDM Begin============================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              do isen = 1,nddmsp
                ioff = iptddm(ispc)+isen-1
                do k = 1,nlay
                  idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                  sen1d(k,isen) = ptconc(idx)
                enddo
                if (lreadtop) then    !<--- from argument, DDM-specific
                  convfac = 1.
                  if (ispc .LE. ngaspc)
     &              convfac = densfac*(273./tempk(i,j,nlay))*
     &                                (press(i,j,nlay)/1013.)
                  sen1d(nlay+1,isen) = convfac*ptrtop(i,j,ioff)
                else
                  sen1d(nlay+1,isen) = rhoscl(i,j)*ptrtop(i,j,ioff) !<--- neds if/else
                endif
              enddo
            endif
c
c================================DDM End==============================
c
c
c======================== Process Analysis Begin =====================
c
            ldoipts = .FALSE.
            if ( .NOT. ltrace .AND. lipr ) then
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja
     &                                         .AND. j .LE. jz ) then
                   if( ipa_xy(i+i0,j+j0) .GT. 0 ) ldoipts = .TRUE.
                endif
            endif
c
c
c========================= Process Analysis End ======================
c
c-----Solve vertical mass adjustments using Crank-Nicholson solver
c
            if (lzppm) then
              call vadvppm(nlay,igrd,delt,d1d,c1d,ent1d,dil1d,sen1d,fluxlay,
     &                     fc1,fc2,fc3,ldoipts)
            else
              call vrtslv(nlay,i,j,igrd,delt,ent1d,dil1d,d1d,c1d,
     &                    lvus,fluxlay(nlay),fluxlay,sen1d,
     &                    species(ispc),fc1,fc2,fc3,ldoipts)
            endif
c
c======================== Process Analysis Begin =====================
c
            if( ldoipts ) then
               do k=1,nlay
                  if( ipa_lay(i+i0,j+j0,k) .GT. 0 ) then
                    ipa_idx = ipa_lay(i+i0,j+j0,k)
c
c-----Concentration change from vertical advection
c
                    cipr(IPR_BADV, ipa_idx, ispc) =
     &                            cipr(IPR_BADV, ipa_idx, ispc) + fc1(k)
c
                    cipr(IPR_TADV, ipa_idx, ispc) =
     &                           cipr(IPR_TADV, ipa_idx, ispc) + fc2(k)
c
                    cipr(IPR_DADV, ipa_idx, ispc) =
     &                           cipr(IPR_DADV, ipa_idx, ispc) + fc3(k)
c
                  endif
               enddo
            endif
c
c========================= Process Analysis End ======================
c
            do k = 1,nlay
              conc(i,j,k,ispc) = c1d(k)
            enddo

            if( iflag.EQ.1 ) then
               if(i .GE. ia .AND. i .LE. iz .AND. j .GE. ja 
     &                                     .AND. j .LE. jz ) then
                 if (fluxlay(nlay).lt.0) then
                   fluxtmp(i,j,1,ispc) = -fluxlay(nlay)*dx(j+j0)*dy*delt
                 else
                   fluxtmp(i,j,2,ispc) = -fluxlay(nlay)*dx(j+j0)*dy*delt
                 endif
               endif
            endif
c
c================================DDM Begin============================
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              do isen = 1, nddmsp
                ioff = iptddm(ispc)+isen-1
                do k = 1, nlay
                  idx =  DBLE(isaptr-1) + DBLE(i) + 
     &               DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                           DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                  ptconc(idx) = sen1d(k,isen)
                enddo
              enddo
            endif
c
c================================DDM End==============================
c

  50       continue
  60     continue
  40  continue
c
c$omp end parallel
c
c-----Put fluxes in global array
c
      if( iflag.EQ.1 ) then
         do j = 2,m2-1
           do i = 2,m1-1
             do ispc = 1,nspc
               fluxes(ispc,9) = fluxes(ispc,9) + DBLE(fluxtmp(i,j,1,ispc))
               fluxes(ispc,10) = fluxes(ispc,10) + DBLE(fluxtmp(i,j,2,ispc))
             enddo
           enddo
         enddo
      endif
c
      if( iproc_id .LE. 1 ) then
        write(*,'(a)') '   Done'
        call flush(6)
      endif
      write(iout,'(a)') '   Done'
      call flush(iout)
c
      return
      end

      subroutine cparad( rad, nr, pa, npa, nn, dtfact )
      use filunit
      use chmstry
      use camxcom
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     CPARAD saves radical concentrations for CPA output
c     and sets the CPA names and position numbers on the 
c     first call from PASETUP
c
c      Copyright Ramboll
c
c     Modifications:
c        10/6/22    Updated radical units to ppb
c
c     Input arguments:
c        rad                 radical concentrations array (ppm)
c        nr                  dimension of radical array
c        pa                  CPA parameter array (ppb units)
c        npa                 dimension of pa array
c        nn                  counter of CPA parameters filled
c        dtfact              ratio of time step to averaging interval
c
c     Output arguments:
c        pa                  CPA parameter array (ppb units)
c        nn                  counter of CPA parameters filled
c
c     Routines called:
c        none
c
c     Called by:
c        CHEMDRIV
c        PASETUP
c
      implicit none
      include 'camx.prm'
c
      integer npa, nr, nn, in_nn
      real    dtfact, ppbfact
      real    pa(npa), rad(nr)
c
c-----Entry point
c
      ppbfact = 1000.
      in_nn = nn
c
      nn = nn + 1
      ptname(nn)  = 'OH'
      cpadesc(nn)  = 'OH radical concentration'
      cpaunit(nn)  = 'ppb'
      pa(nn) = dtfact*rad(kOH)*ppbfact
c
      nn = nn + 1
      ptname(nn)  = 'HO2'
      cpadesc(nn)  = 'HO2 radical concentration'
      cpaunit(nn)  = 'ppb'
      pa(nn) = dtfact*rad(kHO2)*ppbfact
c
      return
      end

      subroutine fgavrg(iproc_id,igrd,nsteps,dtradscl)
      use grid
      use chmstry
      use camxfld
      use camxcom
      use pigsty
      use procan
      use rtracchm
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c     FGAVRG passes arrays from common blocks to AVERAGE
c
c      Copyright Ramboll
c  
c     Modifications:
c        11/10/03  Added RTRAC/PiG sampling grid
c        07/29/05  Added sampling grid for regular model species
c        12/15/08  Added code to handle averaging of radicals
c        07/16/07 -bkoo-     Added check for HDDM
c        07/16/08 -bkoo-     Added DDM turn-off flag
c        09/27/10 --gwilson-- the calculation for process analysis 
c                             conversion factors is now done by a separate
c                             routine
c        04/17/14 --gwilson-- added call to initialize Lslice array
c        07/01/19 --cemery--  Removed trapazoidal integration for radicals
c
c     Input arguments: 
c       iproc_id    process ID for this slice (MPI)
c       igrd        current grid index
c
c     Output arguments: 
c        none
c      
c     Routines called: 
c        AVERAGE
c      
c     Called by: 
c        NESTING
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----Entry point
c
      integer nlayav
      real    dtradscl
c
c-----Update cumulative time for this fine grid 
c
      nlayav = nlay(igrd)
      if( .NOT. l3davg(igrd) ) nlayav = 1

      call average(mxp,myp,mzp,.FALSE.,igrd,deltat(igrd)/2.0,dtradscl,
     &             ncol(igrd),nrow(igrd),nlay(igrd),nlayav,
     &             navspc,nspec,lavmap,lgas,mole_weight,
     &             tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &             conc(iptr4d(igrd)),
     &             avcnc(iptrav(igrd)) )
c
c========================= Process Analysis Begin ==============================
c
c  --- call routine to calculate conversion factors for PA
c
      if( lipr ) then
          call paconv(mxp,myp,mzp,deltat(igrd)/2.0,ncol(igrd),
     &                nrow(igrd),nlay(igrd),navspc,nspec,lavmap,
     &                lgas,tempk(iptr3d(igrd)),
     &                press(iptr3d(igrd)),ipacl_3d(iptr3d_full(igrd)) )
      endif
c
c========================= Process Analysis End ==============================
c

c
c-----Update PiG contribution
c
      if (ipigflg .NE. 0 .and. LVISPIG) then
         if( lmpi .AND. nsteps .EQ. 1 ) call init_Lslice(iproc_id,igrd,i0,j0)
         call avepig(iproc_id,igrd,deltat(igrd)/2.0,mxp,myp,mzp,
     &               i0,j0,ncol(igrd),nrow(igrd),nlay(igrd),nlayav,
     &               deltax(1,igrd),deltay(igrd),mapscl(iptr2d(igrd)),
     &               height(iptr3d(igrd)),
     &               navspc,nspec,lavmap,
     &               tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &               avcnc(iptrav(igrd)))
      endif
c
c-----Update running average of average specs on sampling grids
c
      if (lsample) then
        do lgrd = 1,nsample
          if (ismpgrd(lgrd).eq.igrd) then
            call pigsampl(mxp,myp,mzp,i0,j0,.FALSE.,igrd,lgrd,nspec,
     &                    navspc,ncolsmp(lgrd),nrowsmp(lgrd),
     &                    nrow(igrd),meshold(igrd),
     &                    inst1(igrd),jnst1(igrd),deltat(igrd)/2.0,
     &                    delx,dely,deltax(1,igrd),deltay(igrd),
     &                    tempk(iptr3d(igrd)),
     &                    press(iptr3d(igrd)),conc(iptr4d(igrd)),
     &                    smpcnc(ipsmp(lgrd)))
          endif
        enddo
      endif
c
c======================== Source Apportion Begin =======================
c
c   --- call routine to update the running averages ---
c
      if( ltrace .OR. ((lddm .OR. lhddm) .AND. lddmcalc(igrd)) ) then
         nlayav = nlay(igrd)
         if( .NOT. lsa_3davrg ) nlayav = 1
         call average(mxp,myp,mzp,.TRUE.,igrd,deltat(igrd)/2.0,1.,
     &                ncol(igrd),nrow(igrd),nlay(igrd),nlayav,
     &                ntotsp,ntotsp,lsamap,lsagas,sa_mole_weight,
     &                tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                ptconc(ipsa3d(igrd)),
     &                ptavrg(ipsa2d_avrg(igrd)) )
c
         if ((tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND.
     &        lsample .AND. lsmptrc ) then
            do lgrd = 1,nsample
              if (ismpgrd(lgrd).eq.igrd) then
                call pigsampl(mxp,myp,mzp,i0,j0,.TRUE.,igrd,lgrd,nrtrac,
     &                        nrtrac,ncolsmp(lgrd),nrowsmp(lgrd),
     &                        nrow(igrd),meshold(igrd),inst1(igrd),
     &                        jnst1(igrd),deltat(igrd)/2.0,delx,dely,
     &                        deltax(1,igrd),deltay(igrd),
     &                        tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                        ptconc(ipsa3d(igrd)),rtsmpcnc(iprtsmp(lgrd)))
              endif
            enddo
         endif
      endif
c
c========================= CSA Begin ========================
c
      if( lcsa ) call csa_avrg(igrd)
c
c========================= CSA End ========================
c
c========================= Source Apportion End ========================
c
      return
      end

C**** SIGGROW
c
      subroutine siggrow(delt,height,pbl,ustar,wstar,lstable,rkzeq,
     &                   htfms,htfmb,vtfms,vtfmb,shrflg,hshear,vshear,
     &                   pufang,shrang,sigy,sigx,sigz)
      implicit none
c
c----CAMx v7.40 260801
c
c     SIGGROW advances PiG puff spread (sigma) for one timestep 
c     due to turbulent diffusion.  Approach based on SCIPUFF (EPRI,2002)
c
c      Copyright Ramboll
c
c     Modifications:
c        06/17/09        Restructured puff sigmas to improve impacts of
c                        vertical directional shear on puff growth
c        07/31/13        Reduced default min horizontal turbulent parameters
c        10/30/15        Changed definition of SHRFLG=1 to apply growth by
c                        shear in PBL regardless of stability (continues to
c                        ignore shear growth above PBL)
c
c     Input arguments:
c        delt                timestep (s)
c        height              puff height (m)
c        pbl                 PBL height (m)
c        ustar               friction velocity (m/s)
c        wstar               convective velocity scale (m/s)
c        lstable             flag for PBL stability (T=stable)
c        rkzeq               equilibrium vertical diffusivity (m2/s)
c        htfms               horiz turb flux moment, shear (m2/s)
c        htfmb               horiz turb flux moment, buoyancy (m2/s)
c        vtfms               vert turb flux moment, shear (m2/s)
c        vtfmb               vert turb flux moment, buoyancy (m2/s)
c        shrflg              shear flag:
c                               0 = shear never applied;
c                               1 = shear applied only to PBL;
c                               2 = shear always applied
c        hshear              grid-resolved horz shear of horz wind (1/s)
c        vshear              grid-resolved vert shear of horz wind (1/s)
c        pufang              puff directional angle (rad)
c        shrang              shear directional angle (rad)
c        sigy                lateral puff spread (m)
c        sigx                longitudinal puff spread (m)
c        sigz                vertical puff spread (m)
c
c     Output arguments:
c        sigy                lateral puff spread (m)
c        sigx                longitudinal puff spread (m)
c        sigz                vertical puff spread (m)
c
c     Subroutines called:
c        none
c
c     Called by:
c        PIGGROW
c 
      integer shrflg

      real delt,height,pbl,ustar,wstar,rkzeq,hshear,vshear
      real htfms,htfmb,vtfms,vtfmb
      real pufang,shrang,vshearx,vsheary
      real sigy,sigx,sigz
      logical lstable
c
      real htlss,htlsb,vtls,q2s,q2b,rkx,rkz
      real aa,xpbl,pbleq
c
      data aa /0.75/
      data pbleq /1000./
c
c-----Entry point
c
      htlss = 300.
      htlsb = 1.
      vtls = 10.
      rkzeq = amax1(rkzeq,0.1)

      xpbl = pbl
      if (height.gt.pbl) then
        xpbl = amax1(pbleq,pbl)
        lstable = .true.
      endif
c
c-----Calculate horizontal diffusivity
c
      q2s = 0.10
      q2b = 0.
      if (height.le.xpbl) then
        htlss = 1./((0.3*xpbl)**2) + 1./((0.65*height)**2)
        htlss = sqrt(1./htlss)
        q2s = amax1(q2s,2.5*(1. - height/xpbl)*ustar**2)
        if (.not.lstable) then
          htlsb = 0.3*xpbl
          q2b = 0.13*(1. + 1.5*exp(height/xpbl))*wstar**2
        endif
      endif

      htfms = (htfms + delt*q2s)/(1. + delt*aa*sqrt(q2s)/htlss)
      htfms = amax1(htfms,1.)
      htfmb = (htfmb + delt*q2b)/(1. + delt*aa*sqrt(q2b)/htlsb)
      rkx = htfms + htfmb
c
c-----Calculate vertical diffusivity
c
      q2s = 0.01  
      q2b = 0.
      if (height.le.xpbl) then
        vtls = htlss
        q2s = amax1(q2s,1.5*(1. - height/xpbl)*ustar**2)
        if (.not.lstable) then
          q2b = 1.1*(height/xpbl)**(2./3.)*
     &              (1.05 - height/xpbl)*wstar**2
        endif
      endif

      vtfms = (vtfms + delt*aa*sqrt(q2s)*rkzeq/vtls) /
     &        (1. + delt*aa*sqrt(q2s)/vtls)
      vtfms = amax1(vtfms,0.1)
      vtfmb = (vtfmb + delt*aa*sqrt(q2b)*rkzeq/vtls) /
     &        (1. + delt*aa*sqrt(q2b)/vtls)
      rkz = vtfms + vtfmb
c
c-----Solve for new sigmas
c
      if (shrflg.eq.0 .or. (shrflg.eq.1 .and. height.gt.pbl)) then
        vshear = 0.
        hshear = 0.
      endif
      vshearx = vshear*abs(cos(pufang - shrang))
      vsheary = vshear*abs(sin(pufang - shrang))
      sigy = sqrt(sigy*sigy + 2.*delt*
     &           (sigy*sigy*hshear + sigy*sigz*vsheary + rkx))
      sigx = sqrt(sigx*sigx + 2.*delt*
     &           (sigx*sigx*hshear + sigx*sigz*vshearx + rkx))
      sigz = sqrt(sigz*sigz + 2.*delt*rkz) 
      sigy = amax1(sigy,sigz)
      sigx = amax1(sigx,sigz)
c
      return
      end

      subroutine updtmet(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,
     &                   igrd,ncol,nrow,nlay,nspec,ngas,nrtspc,
     &                   densfac,deltat,phpt,height,depth,pppt,
     &                   press,pupt,windu,pvpt,windv,pspt,tsurf,
     &                   ptpt,tempk,pwpt,water,pkpt,rkv,conc,saconc,
     &                   adjwest,adjeast,adjsouth,adjnorth)
      use bndary
      use tracer
      use rtracchm
c 
c----CAMx v7.40 260801
c  
c     UPDTMET updates the time-varying vertical layer structure for the
c     current time step and current grid, based upon linear interpolation
c     between last input time and next input time.  Also performs
c     a similar interpolation for meteorological fields, and rescales
c     the master grid boundary concentrations for the changing met.
c 
c      Copyright Ramboll
c 
c     Modifications:  
c       10/12/04   Water vapor and vertical diffusivity fields are now
c                  time-interpolated
c       10/04/05   Minimum water vapor of 1 ppm applied
c  
c     Input arguments:  
c        igrd                grid index 
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        nspec               number of species
c        ngas                number of gas species
c        nrtspc              number of RTRAC species
c        densfac             density conversion factor (mol/m3)
c        deltat              timestep (s)
c        phpt                time-rate change of layer interface height (m/s)
c        height              layer interface height (m)
c        pppt                time-rate change of pressure (mb/s)
c        press               presssure (mb)
c        pupt                time-rate change of u-component wind (m/s2)
c        windu               u-component wind field (m/s)
c        pvpt                time-rate change of v-component wind (m/s2)
c        windv               v-component wind field (m/s)
c        pspt                time-rate change of surface temperature (K/s)
c        tsurf               surface temperature (K)
c        ptpt                time-rate change of 3-D temperature (K/s)
c        tempk               3-D temperature (K)
c        pwpt                time-rate change of 3-D water vapor (ppm/s)
c        water               3-D water vapor (ppm)
c        pkpt                time-rate change of 3-D diffusivity (m2/s2)
c        rkv                 3-D diffusivity (m2/s)
c        conc                concentration arrray (umol/m3)
c             
c     Output arguments:  
c        height              layer interface height (m)
c        depth               layer depth (m) 
c        press               presssure (mb)
c        windu               u-component wind field (m/s)
c        windv               v-component wind field (m/s)
c        tsurf               surface temperature (K)
c        tempk               3-D temperature (K)
c        water               3-D water vapor (ppm)
c        rkv                 3-D diffusivity (m2/s)
c        conc                concentration arrray (umol/m3)
c        saconc              RTRAC concentration arrray
c        adjwest             adjustment factors for the West boundary
c        adjeast             adjustment factors for the East boundary
c        adjsouth            adjustment factors for the South boundary
c        adjnorth            adjustment factors for the North boundary
c             
c     Routines Called:  
c        none 
c             
c     Called by:  
c        EMISTRNS  
c 
      include 'camx.prm'
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon
c
      real, dimension(m1,m2,m3) :: depth, height, phpt

      real, dimension(m1,m2,m3) :: press, pppt, windu, pupt, windv, 
     &                             pvpt, tempk, ptpt, pwpt, water, 
     &                             pkpt, rkv
      real conc(m1,m2,m3,nspec)
      real saconc(m1,m2,m3,nrtspc)
      real adjwest(MXCELLS,MXLAYER)
      real adjeast(MXCELLS,MXLAYER)
      real adjsouth(MXCELLS,MXLAYER)
      real adjnorth(MXCELLS,MXLAYER)
      real :: tsurf(m1,m2), pspt(m1,m2)
      logical, external :: isbound
c
c-----Entry point 
c
c-----Initialize the adjusting factors to 1.0 ---
c
      do i=1,MXCELLS
         do k=1,MXLAYER
           adjwest(i,k) = 1.0
           adjeast(i,k) = 1.0
           adjsouth(i,k) = 1.0
           adjnorth(i,k) = 1.0
         enddo
      enddo
c
c-----Convert master grid boundary concs from umol/m3 to ppm
c
      if (igrd.eq.1) then
         do j = 1,m2
            do 10 i = 1,m1
               if( i .EQ. 1 .AND. j .EQ. 1 ) goto 10
               if( i .EQ. 1 .AND. j .EQ. m2 ) goto 10
               if( i .EQ. m1 .AND. j .EQ. 1 ) goto 10
               if( i .EQ. m1 .AND. j .EQ. m2 ) goto 10
               if (isbound(ibcon,m1,m2,i,j) ) then
                  do k = 1,nlay
                     convfac = densfac*273./tempk(i,j,k)*press(i,j,k)/1013.
                     do l = 1,ngas
                        conc(i,j,k,l) = conc(i,j,k,l)/convfac
                     enddo
                     if( i .eq. 1 ) then
                        adjwest(j,k) = 1.0/convfac
                     endif
                     if( i .eq. m1 ) then
                        adjeast(j,k) = 1.0/convfac
                     endif
                     if( j .eq. 1 ) then
                        adjsouth(i,k) = 1.0/convfac
                     endif
                     if( j .eq. m2 ) then
                        adjnorth(i,k) = 1.0/convfac
                     endif
                     if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                        do l = 1,nrtgas
                           saconc(i,j,k,l) = saconc(i,j,k,l)/convfac
                        enddo
                     endif
                  enddo
               endif
   10        continue
         enddo
      endif
c
c-----Update other parameters forward 1 timestep
c
      do 60 k = 1,nlay
        do 50 j = 1,m2  !nrow
          do 40 i = 1,m1    !ncol
            height(i,j,k) = height(i,j,k) + deltat*phpt(i,j,k)
            depth(i,j,k) = height(i,j,k)
            if (k.gt.1) depth(i,j,k) = 
     &                          height(i,j,k) - height(i,j,k-1)
            press(i,j,k) = press(i,j,k) + deltat*pppt(i,j,k)
            if (i+i0.lt.ncol .and. j+j0.lt.nrow) then
              windu(i,j,k) = windu(i,j,k) + deltat*pupt(i,j,k)
              windv(i,j,k) = windv(i,j,k) + deltat*pvpt(i,j,k)
            endif
            tempk(i,j,k) = tempk(i,j,k) + deltat*ptpt(i,j,k)
            water(i,j,k) = water(i,j,k) + deltat*pwpt(i,j,k)
            water(i,j,k) = amax1(water(i,j,k),1.)
            rkv(i,j,k)   = rkv(i,j,k) + deltat*pkpt(i,j,k)
            if (k.eq.1) tsurf(i,j) = tsurf(i,j) + deltat*pspt(i,j)
c
 40       continue
 50     continue
 60   continue
c
c-----Convert master grid boundary concs from ppm to umol/m3
c 
      if (igrd.eq.1) then
         do j = 1,m2
            do 20 i = 1,m1
               if( i .EQ. 1 .AND. j .EQ. 1 ) goto 20
               if( i .EQ. 1 .AND. j .EQ. m2 ) goto 20
               if( i .EQ. m1 .AND. j .EQ. 1 ) goto 20
               if( i .EQ. m1 .AND. j .EQ. m2 ) goto 20
               if (isbound(ibcon,m1,m2,i,j) ) then
                  do k = 1,nlay
                     convfac = densfac*273./tempk(i,j,k)*press(i,j,k)/1013.
                     do l = 1,ngas
                        conc(i,j,k,l) = conc(i,j,k,l)*convfac
                     enddo
                     if( i .eq. 1 ) then
                        adjwest(j,k) = adjwest(j,k) * convfac
                     endif
                     if( i .eq. m1 ) then
                        adjeast(j,k) = adjeast(j,k) * convfac
                     endif
                     if( j .eq. 1 ) then
                        adjsouth(i,k) = adjsouth(i,k) * convfac
                     endif
                     if( j .eq. m2 ) then
                        adjnorth(i,k) = adjnorth(i,k) * convfac
                     endif
                     if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                        do l = 1,nrtgas
                           saconc(i,j,k,l) = saconc(i,j,k,l)*convfac
                        enddo
                     endif
                  enddo
               endif
   20        continue
         enddo
      endif
c
      return
      end

C**** NCF_READBND
c
      subroutine ncf_readbnd(bndtim,bnddate,did_update)
      use chmstry
      use filunit
      use camxfld
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c 
c      Copyright Ramboll
c           
c     Arguments: 
c        bndtim     model simulation time (HHMM)
c        bnddate    model simulation date (YYJJJ)
c        did_update .TRUE. if new data was read
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
      include 'camx.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer bnddate
      real    bndtim
      logical did_update
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      integer       this_tstep, data_start(4), data_count(4), ispc
      integer       this_varid, n3d, n4d, i, j, k, ierr
      integer       this_time_tflag, this_time_etflag
      real          date_time, convfac
c
      real, allocatable, dimension(:,:,:) :: bctmp
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      did_update = .FALSE.
      action = 'Reading lateral boundary conditions file.'
c
c  --- check if current timestep still works ---
c
      date_time = REAL(bnddate)+bndtim/2400.
      if( date_time .GE. bnddate_time_tflag .AND. date_time .LT. 
     &                                  bnddate_time_etflag ) goto 9999
c
c  --- reading the file for more data so echo that ---
c
      did_update = .TRUE.
      write(*,'(a20,$)') 'ncf_readbnd ......'
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(ibc,action,bnddate,bndtim,
     &          bnddate_time_tflag,bnddate_time_etflag,.FALSE.,.TRUE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = nlay(1)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  --- allocate temporary array ---
c
      allocate( bctmp(ncol(1),nrow(1),nlay(1)) )
c
c  ---- loop over model species and skip if not in the IC file ---
c
      do ispc=1,nspec
c
c  --- skip if species not in file ---
c
         if( lbcmap(ispc) .LE. 0 ) then
c
c  --- West boundary ---
c
            do k=1,nlay(1)
               do j=2,nrow(1)-1
                 i = 1
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
                 n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
                 convfac = 1.
                 if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                 conc(n4d) = convfac*bdnl(ispc)
c
c  --- East boundary ---
c
                 i = ncol(1)
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
                 n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
                    convfac = 1.
                 if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                 conc(n4d) = convfac*bdnl(ispc)
               enddo
c
c  --- South boundary ---
c
               do i=2,ncol(1)-1
                 j = 1
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
                 n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
                 convfac = 1.
                 if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                 conc(n4d) = convfac*bdnl(ispc)
c
c  --- North boundary ---
c
                 j = nrow(1)
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
                 n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
                 convfac = 1.
                 if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                 conc(n4d) = convfac*bdnl(ispc)
               enddo
            enddo
            cycle
         endif
c
c  ---- load this species into local array ---
c
         this_varid = lbcmap(ispc)
         ierr = nf_get_vara_real(ibc,this_varid,data_start,data_count,bctmp)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_READBND:'
           write(iout,*)'Cannot read boundary conditions data for speices: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c  ---  Load boundary concentrations; convert gasses from ppm to umol/m3,
c       PM stays at ug/m3 ---
c
         do k=1,nlay(1)
c
c  --- West boundary ---
c
            do j=2,nrow(1)-1
              i = 1
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
              convfac = 1.
              if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              conc(n4d) = MAX(bdnl(ispc),bctmp(i,j,k))*convfac
c
c  --- East boundary ---
c
              i = ncol(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
              convfac = 1.
              if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              conc(n4d) = MAX(bdnl(ispc),bctmp(i,j,k))*convfac
            enddo
c
c  --- South boundary ---
c
            do i=2,ncol(1)-1
              j = 1
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
              convfac = 1.
              if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              conc(n4d) = MAX(bdnl(ispc),bctmp(i,j,k))*convfac
c
c  --- South boundary ---
c
              j = nrow(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
              n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(ispc - 1)
              convfac = 1.
              if( ispc .LE. ngas ) convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
              conc(n4d) = MAX(bdnl(ispc),bctmp(i,j,k))*convfac
            enddo
         enddo
      enddo
c
c  --- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5)') 'Read boundary condition file at ',
     &                                                  bndtim,bnddate
c
c  --- dealocate the local array ---
c
      deallocate( bctmp )
      write(*,'(a)') '   Done'
      call flush(6)
c
 9999 continue
      return
      end

c*** RDINSTSA
c
      subroutine rdinstsa(idate,btim,nox,noy,noz,nspsa)
      use filunit
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine reads the instantaneous file for the tracer
c     species.  A file is read for each grid nest and the data is
c     stored in the tracer concentration array.
c
c      Copyright Ramboll
c
c    Argument description:
c     Outputs:
c     Inputs: 
c        idate   I   begining date of simulation (YYJJJ)
c        btim    R   begining time of simulation
c        nox     I   number of X cells in grid
c        noy     I   number of Y cells in grid
c        noz     I   number of layers in grid
c        nspsa   I   number of species in conc array
c
c-----------------------------------------------------------------------
c   LOG:
c     1/20/99   Grid cell size from file should be meters for all
c               cartesian projections (UTM, LCP, PSP)
c     10/24/01  Removed BSWAP and converted integer strings to character*4
c     11/06/01  Input dates are now Julian
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 cname
      character*4  fname(10), fnote(60)
      integer      nsegs, nspcs, ibgdat, iendat
      integer      nzonin, noxgin, noygin, nzclin
      integer      ntoday, isegmt, ndate, numold
      integer      i, j, k, l
      real         begtim, endtim, xutmin, yutmin, xorgin, yorgin
      real         delxin, delyin, ttime
      logical      lmatch
c
      character*10 savename(MXTRSP)
      character*4  ispec(10,MXTRSP)
      real         cnctmp(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      numold = ntotsp
      ndate = idate
      ttime = btim / 100. 
c
c   --- open the coarse grid instantaneous file ---
c
      open(unit=iorini(IDXCRS),file=inifil(IDXCRS),
     &                    form='UNFORMATTED',ERR=7006,status='UNKNOWN')
c
c   --- file description header ---
c
      read(iorini(IDXCRS),ERR=7000,END=7000) fname, fnote, nsegs, 
     &                           nspcs, ibgdat, begtim, iendat, endtim
      if( nspcs .GT. MXTRSP ) then
        write(iout,'(//,A)') 'ERROR in RDINSTSA:'
        write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
        write(iout,*) 'Please change the value for parameter: MXTRSP'
        write(iout,*) 'It should be set to a value of at least: ',nspcs
        call flush(iout)
        call camxerr()
      endif
c
c  --- make sure this is the right file ---
c
      write(cname,'(10A1)') (fname(i),i=1,10) 
      if( cname .NE. 'AIRQUALITY' ) goto 7001
c
c  --- make sure time span is correct ---
c
      if( begtim .EQ. 24.0 ) then
          begtim = 0.
          ibgdat = ibgdat + 1
      endif
      if( MOD(ibgdat,1000) .GT. 365 ) then
          if( MOD(INT(ibgdat/1000),4) .EQ. 0 ) then
             if( MOD(ibgdat,1000) .EQ. 367 )
     &                     ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
          else
             ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
          endif
      endif
      if( ibgdat .NE. ndate .OR. 
     &                        ABS(begtim-ttime) .GT. 0.00001 ) goto 7002
c
c   --- region description header ----
c
      read(iorini(IDXCRS),ERR=7000) xutmin, yutmin, nzonin, 
     &            xorgin, yorgin, delxin, delyin, noxgin, noygin, nzclin
      lmatch = .TRUE.
      if( nzonin .NE. iuzon ) lmatch = .FALSE.
c
c   --- set scaling factor for coordinates ---
c
      if( .NOT.llatlon) then
         factr = 1000.0
      else
         factr = 1.0
      endif
      xorgin = xorgin/factr
      yorgin = yorgin/factr
      delxin = delxin/factr
      delyin = delyin/factr
      if( ABS(xorgin-xorg) .GT. 0.0001 ) lmatch = .FALSE.
      if( ABS(yorgin-yorg) .GT. 0.0001 ) lmatch = .FALSE.
      if( ABS(delxin-delx) .GT. 0.0001 ) lmatch = .FALSE.
      if( ABS(delyin-dely) .GT. 0.0001 ) lmatch = .FALSE.
      if( noxgin .NE. nox ) lmatch = .FALSE.
      if( noygin .NE. noy ) lmatch = .FALSE.
      if( nzclin .NE. noz ) lmatch = .FALSE.
      if( .NOT. lmatch ) goto 7003
c
c  --- segment description header ---
c
      read(iorini(IDXCRS),ERR=7000) 
c
c  ---- species list ---
c
      read(iorini(IDXCRS),ERR=7000) ((ispec(i,j),i=1,10),j=1,nspcs)
c
c  --- make sure species list is compatable, up to timing tracers ---
c
      do l=1,ipttim-1
         write(cname,'(10A1)') (ispec(i,l),i=1,10)
         if( cname .NE. ptname(l) ) goto 7004
      enddo
c
c  --- shift the species list around to get the previous timing tracers
c      in the list as well as the timing tracers for this run ---
c
      if( ntrtim .GT. 0 ) then
         ntoday = ntotsp - ipttim + 1
         ntotsp = nspcs + ntoday
         if( ntotsp .GT. MXTRSP ) then
           write(iout,'(//,A)') 'ERROR in RDINSTSA:'
           write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
           write(iout,'(2A)') ' You are using timing tracers but ',
     &               'have not allocated space for the timing releases.'
           write(iout,*) 'Please change the value for parameter: MXTRSP'
           write(iout,*) 'It should be set to a value of at least: ',
     &                                                            ntotsp
           call flush(iout)
           call camxerr()
         endif
c
c   --- call the pointer routine again to update for tracer arrays ---
c
         call iniptr(ncol,nrow)
c
c  --- call routine to re-allocate based on the real total
c      number of species ----
c
         do l=1,nspcs
            savename(l) = ptname(l)
         enddo
         call realloc_tracer_specs(ngrid,ncol,nrow,nlay,nlayers_ems,
     &                                                   numold,iout)
c 
         npttim = npttim + ntoday
         nreles = (nspcs - ipttim +1) / (2*nregin) 
         do l=ntoday,1,-1
            ptname(nspcs+l) = savename(ipttim-1+l)
            loutsa(nspcs+l) = .TRUE.
         enddo
         do l=1,ipttim-1
            ptname(l) = savename(l)
         enddo
         do l=ipttim,nspcs
            write(cname,'(10A1)') (ispec(i,l),i=1,10)
            ptname(l) = cname
         enddo
         nsaspc = nspcs
      endif
c
c   --- check for consistency with previous days's run ----
c
      if( nspcs .GT. ntotsp ) then
        write(iout,'(//,A)') 'ERROR in RDINSTSA:'
        write(iout,*) 'The number of species in the SA restart file ',
     &                                  'is inconsistent with this run.'
        write(iout,*) 'The are more species in the file ',
     &                             'than necessary for this applicaton.'
        write(iout,*) '  Number of species on file: ',nspcs
        write(iout,*) '  Number of tracer species requested: ',ntotsp
        write(iout,*) 'Make sure you used the correct options in the ',
     &                                              'CAMx control file.'
        call flush(iout)
        call camxerr()
      endif

c
c   --- read the data for this hour ----
c
      read(iorini(IDXCRS),ERR=7000) ibgdat, begtim, iendat, endtim
      do l=1,nspcs
         do k=1,noz
            read(iorini(IDXCRS)) isegmt, (ispec(i,l),i=1,10), 
     &                            ((cnctmp(i,j),i=1,nox),j=1,noy)
            call loadinstsa(nox,noy,noz,ntotsp,k,l,ptconc,cnctmp)
         enddo
      enddo
c
c  --- initialize all of the timing tracers concs to zero to start off ---
c
      do j=1,noy
        do i=1,nox
           cnctmp(i,j) = 0.
        enddo
      enddo
      do l=nspcs+1,nsaspc
         do k=1,noz
             call loadinstsa(nox,noy,noz,ntotsp,k,l,ptconc,cnctmp)
         enddo
         do i=1,MXRECP
            conrcp(l,i) = 0.
         enddo
      enddo
c
c  --- close file and return to calling routine ---
c
      close(iorini(IDXCRS))
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999)'Reading the header of the ',
     &    'tracer concentration initialization file for coarse grid: ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999) 'Tracer concentration ',
     &    'initilization file for coarse grid appears to be type: ',
     &                                                        cname
      write(iout,9000,ERR=9999) 'It should be type: AIRQUALITY'
      write(iout,9000,ERR=9999) 'Filename: ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999) 'Tracer concentration ',
     &   'initialization file for coarse grid is not for correct ',
     &                               'time period; ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      write(iout,9001,ERR=9999) 'Simulation Start: ',ndate,ttime
      write(iout,9001,ERR=9999) 'Initialization File: ',ibgdat,begtim
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999) 'Region definition from ',
     &  ' tracer concentration file for coarse grid does not match ',
     &                                           'simulation control.'
      write(iout,9000,ERR=9999) '      Initialization file: ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      write(iout,9003,ERR=9999) 'UTM zone',nzonin
      write(iout,9002,ERR=9999) 'Region origin',xorgin,yorgin
      write(iout,9002,ERR=9999) 'Cell spacing',delxin, delyin
      write(iout,9004,ERR=9999) 'Number of cells',noxgin,noygin
      write(iout,9003,ERR=9999) 'Vertical cells',nzclin
      write(iout,9000,ERR=9999) 
      write(iout,9000,ERR=9999) '      Simulation Control'
      write(iout,9003,ERR=9999) 'UTM zone',iuzon
      write(iout,9002,ERR=9999) 'Region origin',xorg,yorg
      write(iout,9002,ERR=9999) 'Cell spacing',delx, dely
      write(iout,9004,ERR=9999) 'Number of cells',nox,noy
      write(iout,9003,ERR=9999) 'Vertical cells',noz
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999) 'Species list for tracer ',
     &            'concentration initialization file for coarse grid',
     &          ' is inconsistent with user parameters ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      write(iout,9006,ERR=9999) 'Species number: ',l,' should be ',
     &                      ptname(l),' and ',cname,' was read instead.'
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in RDINSTSA:'
      write(iout,9000,ERR=9999) 'Opening the ',
     &    'tracer concentration initialization file for coarse grid: ',
     &                          inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
      write(iout,9005,ERR=9999) 'Make sure the name for output files ',
     &                           'reflects the correct simulation day.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,6A)
 9001 format(1X,A,I10.5,F10.1)
 9002 format(1X,A,T20,': (',F10.2,',',F10.2,')')
 9003 format(1X,A,T20,': ',I10)
 9004 format(1X,A,T20,': (',I10,',',I10,')')
 9005 format(10X,2A)
 9006 format(1X,A,I5,5A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine micromet(temp,temp0,press,press0,deltaz,wind,z0,pbl,
     &                    ustar,el,psih,wstar,lstable)
c 
c----CAMx v7.40 260801
c 
c     MICROMET calculates surface layer micro-meteorological flux-gradient
c     relationships and variables based on Louis (1979)
c  
c      Copyright Ramboll
c  
c     Modifications:
c        8/15/02    Specified limits for denominators from 1e-10 to 1e-20
c        3/21/03    Modified Z/L calculation to use input midpoint height
c                   (instead of default 10 m) and to increase range from 
c                   (-1 to +1) to (-2.5 to +1.5) 
c        8/20/03    added calculation of w* and logical for stability
c       11/05/12    added min windspeed of 0.1 m/s
c             
c     Input arguments:  
c        temp                Layer 1 temperature (K) 
c        temp0               Surface temperature (K)
c        press               Layer 1 pressure (mb)
c        press0              Surface pressure (mb)
c        deltaz              Layer 1 midpoint height (m)
c        wind                Layer 1 total wind speed (m/s)
c        z0                  Surface roughness length (m)
c        pbl                 PBL depth (m)
c             
c     Output arguments:  
c        ustar               friction velocity (m/s)
c        el                  Monin-Obukhov length (m)
c        psih                Similarity stability correction term
c        wstar               convective velocity scale (m/s)
c        lstable             stability logical (T=stable)
c             
c     Routines called:  
c        none  
c             
c     Called by:  
c        DRYDEP 
c        PIGGROW
c 
      logical lstable
      data vk/0.4/, g/9.8/, gamma/0.286/
c
c-----Entry point
c
c-----Calculate potential temperature and richardson number
c
      theta = temp*(1000./press)**gamma
      theta0 = temp0*(1000./press0)**gamma
      dtheta = theta - theta0
      thetabar = (theta + theta0)/2.
      wind = max(0.1,wind)
      ri = (g/thetabar)*deltaz*dtheta/wind**2
c
c-----Determine stability functions
c
      zscale = vk/alog(deltaz/z0)
      if (ri.le.0.) then
        lstable = .false.
        cm    = 69.56*sqrt(deltaz/z0)*zscale**2
        ch    = 49.82*sqrt(deltaz/z0)*zscale**2
        fm    = 1. - 9.4*ri/(1. + cm*sqrt(abs(ri)))
        fh    = 1. - 9.4*ri/(1. + ch*sqrt(abs(ri)))
      else
        lstable = .true.
        fm = 1./((1. + 4.7*ri)**2)
        fh = fm
      endif
c
c-----Calculate micromet variables
c
      ustar2 = fm*(wind*zscale)**2
      ustar2 = amax1(1.e-20,ustar2)
      ustar = sqrt(ustar2)
      thstar = 1.35*zscale**2*wind*dtheta*fh/ustar
      el = ustar2*temp/(vk*g*thstar + 1.e-20)
      elabs = abs(el) 
      wstar = 0.
      if (el.lt.0.) wstar = (pbl*ustar**3./(vk*elabs))**(1./3.)

      if (elabs.ge.1.e4) then 
        psih = 0.0 
      elseif (el.lt.0.) then 
        zoverl = amin1(2.5,deltaz/elabs)
        zmel = alog(zoverl) 
        psih = exp(0.598 + 0.39*zmel - 0.090*zmel*zmel) 
      else    
        zoverl = amin1(1.5,deltaz/elabs)
        psih = -5.*zoverl
      endif
c
      return
      end

      subroutine cvtwind(ncol,nrow,nlay,windu,windv)
c
c----CAMx v7.40 260801
c
c     CVTWIND converts the wind field from cell-centered to staggered on cell
c     interfaces (Arakawa C grid):
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        windu               cell centered windspeed in x-direction (m/s)
c        windv               cell centered windspeed in y-direction (m/s)
c
c     Output arguments:
c        windu               staggered windspeed in x-direction (m/s)
c        windv               staggered windspeed in y-direction (m/s)
c
c     Routines Called:
c        none
c
c     Called by:
c        METINIT
c        READINP
c
      real windu(ncol,nrow,nlay)
      real windv(ncol,nrow,nlay)
c
      do 10 k=1,nlay
c
c-----x-direction
c
        do j=1,nrow
          do i=1,ncol-1
            windu(i,j,k) = (windu(i,j,k) + windu(i+1,j,k))/2.
          enddo
        enddo
c
c-----y-direction
c
        do j=1,nrow-1
          do i=1,ncol
            windv(i,j,k) = (windv(i,j,k) + windv(i,j+1,k))/2.
          enddo
        enddo
c
  10  continue
c
      return
      end

      subroutine depprep(endtim,enddate)
      use camxcom
      use camxfld
      use filunit
      use grid
      use chmstry
c 
c----CAMx v7.40 260801
c 
c     DEPPREP generates new deposition output species names and writes 
c     headers to new DEPOSITION output files.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        8/25/06   Dep output files now all UAM format, one file per grid
c        1/04/11   Revised for new header format
c        05/17/16  Added in-line Ix emissions to dep output
c        09/08/21  Modified output species names for consistency with
c                  SAT and RTRAC dep output
c 
c     Input arguments: 
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        ISTRLN
c             
c     Called by: 
c        STARTUP 
c
      include 'camx.prm'
      include 'flags.inc'
c
      character*200 action
      character*20 spec_units(4*MXSPEC+2)
      character*20 spec_long_name(4*MXSPEC+2)
      character*60 spec_desc(4*MXSPEC+2)
      character*60 spec_coords(4*MXSPEC+2)
      character*4 ifile(10),note(60)
      integer enddate
      character*10 avfil,tmpnam
c
      integer ndps, ninline
      character*4 dpspec(10,4*MXSPEC+2)
c
      integer istrln   !--- external function
c
      data avfil /'AVERAGE   '/
      data izero,ione /0,1/
      data zero /0./
c
c-----Entry point
c
      idat1 = begdate
      idat2 = enddate
      tim1 = begtim/100.
      tim2 = endtim/100.
      iutm = iuzon
      plon = polelon
      plat = polelat
      t1   = tlat1
      t2   = tlat2
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
      read(runmsg(1:60),'(60a1)') (note(n),n=1,60)
      read(avfil,'(10a1)') (ifile(n),n=1,10)
      do l = 1,ndepspc
        if( ldepmap(l) .GT. 0 ) then
           tmpnam(3:10) = spname(ldepmap(l))(1:8)
c
           tmpnam(1:2) = 'R_'
           depsp(l) = tmpnam
           read(tmpnam,'(10a1)') (dpspec(n,l),n=1,10)
c
           tmpnam(1:2) = 'D_'
           depsp(ndepspc+l) = tmpnam
           read(tmpnam,'(10a1)') (dpspec(n,ndepspc+l),n=1,10)
c
           tmpnam(1:2) = 'W_'
           depsp(2*ndepspc+l) = tmpnam
           read(tmpnam,'(10a1)') (dpspec(n,2*ndepspc+l),n=1,10)
c
           tmpnam(1:2) = 'L_'
           depsp(3*ndepspc+l) = tmpnam
           read(tmpnam,'(10a1)') (dpspec(n,3*ndepspc+l),n=1,10)
        endif
      enddo
c
c-----If in-line Ix emissions are active, add species I2 and HOI
c
      ndps = 4*ndepspc
      ninline = 0
      if (lixemis) then
        ninline = 2
        ndps = ndps + 2
        tmpnam = 'I2_EMIS   '
        depsp(4*ndepspc+1) = tmpnam
        read(tmpnam,'(10a1)') (dpspec(n,4*ndepspc+1),n=1,10)
        tmpnam = 'HOI_EMIS  '
        depsp(4*ndepspc+2) = tmpnam
        read(tmpnam,'(10a1)') (dpspec(n,4*ndepspc+2),n=1,10)
      endif
c
c-----Master grid header
c
      if( lcdfout) then
          call ncf_set_vars_base()
          call ncf_set_specatt_dep(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
      endif
      if( .NOT. lcdfout ) then
         write(idep(1)) ifile,note,itzon,ndps,idat1,tim1,idat2,tim2
         write(idep(1)) plon,plat,iutm,orgx,orgy,dx,dy,ncol(1),nrow(1),
     &                  ione,iproj,izero,t1,t2,zero
         write(idep(1)) ione,ione,ncol(1),nrow(1)
         write(idep(1)) ((dpspec(n,l),n=1,10),l=1,ndps)
      else
          action = 'Writing master grid output deposition file.'
          call ncf_set_global('DEPOSITION',1,begdate,begtim,enddate,endtim,
     &                                                       ione,ndps)
          call ncf_wrt_dim(action,idep(1),1,ncol(1),nrow(1),ione,ndps)
          call ncf_wrt_global(action,idep(1),ndps,depsp,.FALSE.)
          call ncf_wrt_vars_base(action,idep(1))
          call ncf_wrt_vars_species(action,idep(1),ncol(1),nrow(1),ione,
     &                 ndps,depsp,spec_units,spec_long_name,
     &                                             spec_desc,spec_coords,4)
          call ncf_enddef_file(action,idep(1))
          call ncf_wrt_data_grid(action,idep(1),1,ncol(1),nrow(1),
     &                           orgx,orgy,dx,dy,ione,cellat(iptr2d(1)),
     &                                   cellon(iptr2d(1)),topo(iptr2d(1)))
      endif
      if( ngrid .EQ. 1 ) goto 9999
c
c-----Fine grid header
c
      do i = 2,ngrid
        dxf   = dx/float(meshold(i))
        dyf   = dy/float(meshold(i))
        orgxf = orgx + dx*(inst1(i)-1)
        orgyf = orgy + dy*(jnst1(i)-1)
        if( .NOT. lcdfout ) then
            write(idep(i)) ifile,note,itzon,ndps,idat1,tim1,idat2,tim2
            write(idep(i)) plon,plat,iutm,orgxf,orgyf,dxf,dyf,ncol(i)-2,
     &                 nrow(i)-2,ione,iproj,izero,t1,t2,zero
            write(idep(i)) ione,ione,ncol(i)-2,nrow(i)-2
            write(idep(i)) ((dpspec(n,l),n=1,10),l=1,ndps)
        else
          write(action,'(A,I2)') 'Writing output deposition file for grid: ',i
          call ncf_set_global('DEPOSITION',i,begdate,begtim,enddate,endtim,
     &                                                       ione,ndps)
          call ncf_wrt_dim(action,idep(i),i,ncol(i),nrow(i),ione,ndps)
          call ncf_wrt_global(action,idep(i),ndps,depsp,.FALSE.)
          call ncf_wrt_vars_base(action,idep(i))
          call ncf_wrt_vars_species(action,idep(i),ncol(i),nrow(i),ione,
     &                        ndps,depsp,spec_units,spec_long_name,
     &                                              spec_desc,spec_coords,4)
          call ncf_enddef_file(action,idep(i))
          call ncf_wrt_data_grid(action,idep(i),i,ncol(i),nrow(i),
     &                           orgxf,orgyf,dxf,dyf,ione,cellat(iptr2d(i)),
     &                                   cellon(iptr2d(i)),topo(iptr2d(i)))
        endif
      enddo
c
 9999 continue
      return
      end

      subroutine rpsgeo(iway,polelon,polelat,xloc,yloc,qlon,qlat)
c
c----CAMx v7.40 260801
c 
c     RPSGEO performs rotated polar stereographic to geodetic (lat/lon) 
c     translation (RAMS mapping projection)
c 
c      Copyright Ramboll
c 
c     Modifications: 
c        none 
c 
c     Input arguments: 
c        iway                Conversion type
c                            0 = geodetic to Polar Stereographic
c                            1 = Polar Stereographic to geodetic
c        polelat             Latitude of projection pole (deg) 
c        polelon             Longitude of projection pole (deg,negative for W) 
c        xloc/yloc           Projection coordinates (km) 
c        qlon/qlat           longitude/latitude (degrees) 
c 
c     Output arguments: 
c        xloc/yloc           Projection coordinates (km) 
c        qlon/qlat           longitude/latitude (deg) 
c 
c     Routines called: 
c        none 
c 
c     Called by: 
c        GRDPREP 
c
      parameter (erad=6.367e6,erad2=1.2734e7,pi180=3.14159265/180.)
c
c-----Entry point
c
      xloc = 1000.*xloc
      yloc = 1000.*yloc
c
c-----Evaluate sine and cosine of latitude and longitude of pole point p.
c
      sinplat = sin(polelat * pi180)
      cosplat = cos(polelat * pi180)
      sinplon = sin(polelon * pi180)
      cosplon = cos(polelon * pi180)
c
c-----Compute (x3,y3,z3) coordinates of the pole point where the origin is the 
c     center of the earth, the z axis is through the north pole, the x axis is
c     through the equator and prime meridian, and the y axis is through the
c     equator and 90 E.
c
      x3p = erad * cosplat * cosplon
      y3p = erad * cosplat * sinplon
      z3p = erad * sinplat
c
c-----Polar stereographic to lat/lon conversion
c
      if (iway.eq.1) then
c
c----Compute distance d from given point R on the polar stereographic plane
c    to the pole point P:
c
        d = sqrt (xloc**2 + yloc**2)
c 
c-----Compute angle QCP where C is the center of the Earth.  This is twice 
c     angle QAP where A is the antipodal point.  Angle QAP is the same as
c     angle RAP:
c
        alpha = 2. * atan2(d,erad2)
c
c-----Compute zq, the height of Q relative to the polar stereographic plane:
c
        zq = erad * (cos(alpha) - 1.)
c
c-----Compute the parameter t which is the the distance ratio AQ:AR
c
        t = (erad2 + zq) / erad2
        xq = t * xloc
        yq = t * yloc
c
c-----Transform location of Q from (x,y,z) coordinates to (x3,y3,z3):
c
        x3q = x3p - xq * sinplon - yq * cosplon * sinplat
     +        + zq * cosplat * cosplon
        y3q = y3p + xq * cosplon - yq * sinplon * sinplat 
     +        + zq * cosplat * sinplon
        z3q = z3p + yq * cosplat + zq * sinplat
c
c-----Compute the latitude and longitude of Q:
c
        qlon = atan2(y3q,x3q) / pi180
        r3q = sqrt(x3q ** 2 + y3q ** 2)
        qlat = atan2(z3q,r3q) / pi180
c
c-----Lat/lon to Polar Stereographic conversion
c
      else
        sinqlat = sin(qlat * pi180)
        cosqlat = cos(qlat * pi180)
        sinqlon = sin(qlon * pi180)
        cosqlon = cos(qlon * pi180)
c
        z3q = erad * sinqlat
        x3q = erad * cosqlat * cosqlon
        y3q = erad * cosqlat * sinqlon
c
c-----Transform q point from (x3,y3,z3) coordinates in the above system to
c     polar stereographic coordinates (x,y,z):
c
        xq = - sinplon * (x3q-x3p) + cosplon * (y3q-y3p)  
        yq =   cosplat * (z3q-z3p)
     +       - sinplat * ( cosplon * (x3q-x3p) + sinplon * (y3q-y3p) )
        zq =   sinplat * (z3q-z3p)
     +       + cosplat * ( cosplon * (x3q-x3p) + sinplon * (y3q-y3p) )
c
c-----Parametric equation for line from antipodal point at (0,0,-2 erad) to
c     point q has the following parameter (t) value on the polar stereographic
c     plane:
c
        t = erad2 / (erad2 + zq)
        xloc = xq*t
        yloc = yq*t
      endif
c
      xloc = xloc/1000.
      yloc = yloc/1000.
c
      return
      end

      program CAMx
      use filunit
      use grid
      use chmstry
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use ptemiss
      use pigsty
      use procan
      use rtracchm
      use tracer
c
      use master_mod  
      use node_mod   
c
c***********************************************************************
c
c                  CCCCCCC      AA      MM      MM                       
c                 CC          AA  AA    MMM    MMM   xx   xx  
c                 CC         AA    AA   MM MMMM MM    xx xx  
c                 CC         AAAAAAAA   MM  MM  MM     xxx  
c                 CC         AA    AA   MM      MM    xx xx
c                  CCCCCCC   AA    AA   MM      MM   xx   xx
c
c        C O M P R E H E N S I V E   A I R   Q U A L I T Y   M O D E L
c        -                           -                       - 
c                         with   E X T E N S I O N S
c                                  -
c
c                          VERSION  7.40 08-01-26
c
c                            Copyright 1996 - 2026
c                                  Ramboll 
c                      7250 Redwood Blvd, Suite 105
c                             Novato, CA  94945
c                             (415) 899 - 0700
c                                www.camx.com
c
c     Revision History:
c       08/01/26   Version 7.40 released (see Release_notes_7.40)
c       08/01/25   Version 7.32 released (see Release_notes_7.32)
c       06/24/24   Version 7.30 released (see Release_notes_7.30)
c       06/24/24   Version 7.30 released (see Release_notes_7.30)
c       04/30/22   Version 7.20 released (see Release_notes_7.20)
c       01/05/21   Version 7.10 released (see Release_notes_7.10)
c       05/31/20   Version 7.00 released (see Release_notes_7.00)
c       04/30/18   Version 6.50 released (see Release_notes_6.50)
c       12/23/16   Version 6.40 released (see Release_notes_6.40)
c       04/08/16   Version 6.30 released (see Release_notes_6.30)
c       03/23/15   Version 6.20 released (see Release_notes_6.20)
c       04/02/14   Version 6.10 released (see Release_notes_6.10)
c       05/06/13   Version 6.00 released (see Release_notes_6.00)
c       11/09/12   Version 5.41 released (see Release_notes_5.41)
c       10/10/11   Version 5.40 released (see Release_notes_5.40)
c       12/01/10   Version 5.30 released (see Release_notes_5.30)
c       06/15/10   Version 5.21 released (see Release_notes_5.21)
c       06/14/10   Version 5.20.1 released (see Release_notes_5.20.1)
c       04/02/10   Version 5.20 released (see Release_notes_5.20)
c       09/09/09   Version 5.10 released (see Release_notes_5.10)
c       04/06/09   Version 5.01 released (see Release_notes_5.01)
c       05/22/08   Version 4.51 released (see Release_notes_4.51)
c       10/25/06   Version 4.40 released (see Release_notes_4.40)
c       03/29/06   Version 4.31 released (see Release_notes_4.31)
c       02/15/06   Version 4.30 released (see Release_notes_4.30)
c       06/15/05   Version 4.20 released (see Release_notes_4.20)
c       12/06/04   Version 4.11.s released (see Release_notes_4.11.s)
c       08/01/04   Version 4.10.s released (see Release_notes_4.10.s)
c       12/05/03   Version 4.03 released (see Release_notes_4.03)
c       07/09/03   Version 4.02 released (see Release_notes_4.02)
c       06/17/03   Version 4.01 released (see Release_notes_4.01)
c       05/31/03   Version 4.00 released (see Release_notes_4.00)
c       11/15/01   Version 3.10 released (see Release_notes_3.10)
c        4/25/01   Version 3.01 released (see Release_notes_3.01)
c       12/30/00   Version 3.00 released (see Release_notes_3.00) 
c       12/30/99   Version 2.03 released (see Release_notes_2.03) 
c        9/13/99   Version 2.02 released (see Release_notes_2.02) 
c        5/10/99   Version 2.01 released (see Release_notes_2.01) 
c       12/30/98   Version 2.00 released, original development
c
c***********************************************************************
c  
      include 'camx.prm'
      include 'flags.inc'
      include 'ncf_iodat.inc'
      include 'mpif.h'
      include 'rtracsrf.inc'
c
c======================== Probing Tool Begin ===========================
c
c     linit   --  logical, if true,   initialize cipr(IPR_INIT ,*,*,*)
c                          otherwise, initialize cipr(IPR_FINAL,*,*,*)
c
      logical linit
c
c========================= Probing Tool End ============================
c
      integer inpdate,emsdate,ozndate,bnddate,topdate,wrtdate,enddate 
      integer icsa_grid, igrid_mod, ncol_csa, nrow_csa, nlay_csa, wrtcsa_date
      integer iproc_id, nlayav, ndps, num_dims
      real inptim,emstim,ozntim,bndtim,toptim,wrttim,endtim,wrt_csa_tim
      character*200 action
      character*20 version
      character*8 chtime, chdate
      logical lupdtdep(MXGRID), loutspec(MXSPEC+MXTRSP)
c
      data version /'CAMx v7.40, 08-01-26'/
c
c-----Entry point
c
      write(*,'(a,a)') 'Starting ',version
      if (version .NE. PRMVERSION) then
        write(iout,'(a)') 'ERROR in CAMx:'
        write(iout,'(a)') 'CAMx version does not match CAMx.prm file.'
        write(iout,'(2a)') 'Be sure to compile with the CAMx.prm file,',
     &                   'distributed with this version of the CAMx code.'
        write(iout,'(a)') 'Do not use CAMx.prm files from older versions.'
        call camxerr()
      endif
c
c----Initialize the MPI mechanism
c
      lmpi = .TRUE.
      call MPI_INIT( ierr )
      if( ierr .NE. 0 ) then
         write(*,*) 'Note: This is not an MPI run.'
         iproc_id = 0
         numprocs = 1
      endif
      if( lmpi ) then
         call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
         call MPI_COMM_RANK( MPI_COMM_WORLD, iproc_id, ierr )
      endif
      if( numprocs .EQ. 1 ) lmpi = .FALSE.
      nsteps = 0
      itag = 1
c
c-----Start model simulation
c
      ncf_cur_tstep = 1
      if( iproc_id .EQ. 0 ) then
         write(*,*)
         call banner()
         write(*,'(a20,$)') 'Model startup ......'
      endif
      call sim_init(version,inptim,inpdate,emstim,emsdate,ozntim,
     &              ozndate,bndtim,bnddate,toptim,topdate,wrttim,
     &              wrtdate,endtim,enddate,numprocs,iproc_id) 
      nlayav = nlay(1)
      if( .NOT. l3davg(1) ) nlayav = 1
c
c======================== CSA Begin =======================
c
      if( lcsa ) then
         wrtcsa_date = date
         whr = aint(time/100.)
         wmn = amod(time,100.)
         wrtcsa_tim = 100.*(whr + aint((wmn + 60.)/60.)) +
     &                                     amod((wmn + 60.),60.)
         if (wrtcsa_tim.ge.2400.) then
            wrtcsa_tim = wrtcsa_tim - 2400.
            wrtcsa_date = wrtcsa_date + 1
            if( MOD(wrtcsa_date,1000) .GT. 365 ) then
               if( MOD(INT(wrtcsa_date/1000),4) .EQ. 0 ) then
                   if( MOD(wrtcsa_date,1000) .EQ. 367 )
     &                 wrtcsa_date = (INT(wrtcsa_date/1000)+1)*1000 + 1
               else
                   wrtcsa_date = (INT(wrtcsa_date/1000)+1)*1000 + 1
               endif
            endif
         endif
         do igrd=1,ngrid
            call csa_reset(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &               nspec,ngas,nrad,NHETRXN,ipacl_3d(iptr3d_full(igrd)))
         enddo
         csaavrg = 0.

      endif
c
c======================== CSA Begin =======================
c
      if( iproc_id .EQ. 0 ) write(*,'(a)') '   Done'
      write(iout,*)
      write(idiag,*)
      write(iout,'(a)')'BEGIN SIMULATION'
      write(idiag,'(a)')'BEGIN SIMULATION'
      write(iout,'(a)') 'Starting main integration loop...'
      write(idiag,*)
      call flush(iout)
      call flush(idiag)
c
c--------------------  Main time-integration loop  ---------------------
c
  100 continue
      if( lmpi ) then
        call nodes_pass(date,1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(time,1,MPI_REAL,itag,numprocs,iproc_id)
      endif
      call chrtime(time,date,chtime,chdate)
      if( iproc_id .EQ. 0 ) then
         nsteps = nsteps + 1
         xyordr = mod(nsteps,2)
      endif
      if( (lmpi .AND. iproc_id .EQ. 1) .OR. .NOT. lmpi ) then
         write(*,*)
         write(*,'(a,a8,1x,a8)') 'Date/time: ',chdate,chtime
         write(*,*)
      endif
c
c-----Check if time-varying grid/met data are to be read
c
      if( lmpi ) then
        call MPI_Barrier(MPI_COMM_WORLD, ierr)
        call nodes_pass(bnddate,1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(bndtim,1,MPI_REAL,itag,numprocs,iproc_id)
        call nodes_pass(topdate,1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(toptim,1,MPI_REAL,itag,numprocs,iproc_id)
        call nodes_pass(inpdate,1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(inptim,1,MPI_REAL,itag,numprocs,iproc_id)
        call nodes_pass(emsdate,1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(emstim,1,MPI_REAL,itag,numprocs,iproc_id)
        call nodes_pass(nsteps,1,MPI_REAL,itag,numprocs,iproc_id)
        call nodes_pass(xyordr,1,MPI_REAL,itag,numprocs,iproc_id)
      endif
c
      write(iout,*)
      write(iout,'(a,a8,1x,a8)') 'Date/time: ',chdate,chtime
      write(iout,*)
c
      if( date .EQ. inpdate .AND. ABS(time-inptim) .LT. 0.01) then
          do i=1,ngrid
             lupdtdep(i) = .TRUE.
          enddo
          call nodes_pass(lupdtdep,ngrid,MPI_INTEGER,
     &                                        itag,numprocs,iproc_id)
          call tstep_init(inptim,inpdate,endtim,enddate,nsteps,
     &                    numprocs,iproc_id)
      endif
c
c-----Check if emissions data are to be read
c
      if( lmpi ) call MPI_Barrier(MPI_COMM_WORLD, ierr)
      if( date .EQ. emsdate .AND. ABS(time-emstim) .LT. 0.01)
     &                 call emiss_updt(emstim,emsdate,numprocs,iproc_id)
c
c-----Check if master grid boundary data are to be read
c
      call bndry_updt(mmxp,mmyp,mmzp,bndtim,bnddate,toptim,topdate,
     &                nsteps,numprocs,iproc_id)
c
c-----Check if ozone column data are to be read
c
      if( io3col .NE. 0 .AND. idmech .NE. 10 ) then
          call o3col_updt(ozndate,ozntim,numprocs,iproc_id)
          call nodes_pass(ozndate,1,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(ozntim,1,MPI_REAL,itag,numprocs,iproc_id)
      endif
      call newgrid(1)
c
c-----At this point we have a successful model startup
c     Stop model now if startup diagnostic flag is set
c
      if ( ldiag .and. nsteps.eq.1) then
        if( iproc_id .EQ. 0 ) then
            write(*,'(/,a,a8,1x,a8,/)')'Date/time: ',chdate,chtime
            write(*,'(a)')'SUCCESSFUL MODEL STARTUP'
            write(*,'(a)')'Diagnostic Initialization Test Complete'
        endif
        write(iout,'(/,a,a8,1x,a8,/)') 'Date/time: ',chdate,chtime
        write(iout,'(a)')'SUCCESSFUL MODEL STARTUP'
        write(iout,'(a)')'Diagnostic Initialization Test Complete'
        call flush(6)
        call MPI_Finalize(ierr)
        stop
      endif
c
c-----Update date/time for this timestep
c
      do ip=1,ngrid
        timec(ip) = time
        datec(ip) = date
      enddo
      call uptime(time,date,deltat(1))
c
c-----Initialize radical concentrations
c
      if( iproc_id .EQ. 0 .AND. lchem .and. nsteps.eq.1 
     &                                     .and. nrad.gt.0) then
        write(*,'(a20,$)') 'raddrivr ......'
        call raddrivr()
        write(*,'(a)') '   Done'
        call flush(6)
        call flush(iout)
      endif
      call chrtime(timec(1),datec(1),chtime,chdate)
c
c-----Master grid emission and transport
c
c  --- call routine to load all of the input data to
c      compute node processes ---
c
      if( lmpi .AND. nsteps .EQ. 1 ) then
         call MPI_Barrier(MPI_COMM_WORLD, ierr)
         call nodes_tstep(numprocs,iproc_id)
         if( LVISPIG .AND. ipigflg .NE. 0)
     &                call nodes_met_pig(numprocs,iproc_id)
      endif
      if( .NOT.lmpi .OR. iproc_id.GT.0 ) call avgall(iproc_id,nsteps,0.)
c
      call newgrid(1)
c
      call emistrns(1,chtime,chdate,
     &                        numprocs,iproc_id,lupdtdep(1))
c
c-----Computation for nested grids
c
      if( ngrid .GT. 1 ) call nesting(numprocs,iproc_id,lupdtdep,nsteps)
c
      if( .NOT. lmpi .OR. iproc_id .GT. 0 ) then
c
         call uptime(timec(1),datec(1),deltat(1))
         call chrtime(timec(1),datec(1),chtime,chdate)
c
c-----Evolve PiG puffs on master grid
c
         if( ipigflg .NE. 0 ) call pigevol(1,iproc_id)
      endif
      if( ipigflg .NE. 0 .AND. lmpi )
     &                 call nodes_pig_pass(1,numprocs,iproc_id)
c     
c-----Master grid chemical reactions
c
      if( .NOT. lmpi .OR. iproc_id .GT. 0 ) then
         call chemrxn(1,iproc_id)
c
c-----Update average concentrations
c
         call avgall(iproc_id,nsteps,2.)
      endif
c
c-----Check if concentration fields are to be written
c
      if( lmpi ) then
         if( date .EQ. wrtdate .AND. ABS(time-wrttim) .LT. 0.01 ) then
             call MPI_Barrier(MPI_COMM_WORLD, ierr)
             call master_update(numprocs, iproc_id)
             call MPI_Barrier(MPI_COMM_WORLD, ierr)
          endif
      endif
      call chrtime(time,date,chtime,chdate)
c
c========================= Process Analysis End ======================
c
      if( iproc_id .EQ. 0 ) then
         if( date .EQ. wrtdate .AND. ABS(time-wrttim) .LT. 0.01 ) then
c
c-----Regular model grid files
c
           write(*,'(a20,$)') 'wrtcon ......'
           write(iout,'(a20,$)') 'wrtcon ......'

             do igrd = 1,ngrid
               nlayav = nlay(igrd)
               num_dims = 4
               if( .NOT. l3davg(igrd) ) then
                  nlayav = 1
                  num_dims = 3
               endif
               if( .NOT. lcdfout) then
                   call wrtcon(0,time,date,iavg(igrd),igrd,ncol(igrd),
     &                     nrow(igrd),nlayav,navspc,avcnc(iptrav(igrd)))
               else
                   if( igrd .eq. 1 )  then
                       action = 'Writing average concentration file '//
     &                                                     'for master grid.'
                   else
                       write(action,'(2A,I2)') 'Writing average ',
     &                                  'concntration file for grid: ',igrd 
                   endif
                   call ncf_wrt_data_tstep(action,iavg(igrd),navspc)
                   loutspec = .TRUE.
                   call ncf_wrt_data_species(action,iavg(igrd),igrd,num_dims,
     &                ncol(igrd),nrow(igrd),nlay(igrd),nlayav,nlayav,navspc,
     &                spavnam,loutspec,avcnc(iptrav(igrd)),height(iptr3d(igrd)))
               endif
             enddo

           if( ldry .OR. lwet ) then
             do igrd = 1,ngrid
               if( .NOT. lcdfout ) then
                   call wrtdep(time,date,igrd,idep(igrd),ncol(igrd),nrow(igrd),
     &                             3*ndepspc+2,nspec,vdep(iptr1lay(igrd)),
     &                                            depfld(iptrdp(igrd)))
               else
                   if( igrd .eq. 1 )  then
                       action = 'Writing deposition file for master grid.'
                   else
                       write(action,'(2A,I2)') 'Writing deposition file ',
     &                                                  'for grid: ',igrd 
                   endif
                   ndps = 4*ndepspc
                   if( lixemis ) ndps = ndps + 2
                   call ncf_wrt_data_tstep(action,idep(igrd),ndps)
                   call ncf_wrt_data_dep(action,idep(igrd),igrd,ncol(igrd), 
     &                  nrow(igrd),nlay(igrd),3*ndepspc+2,nspec,depsp,
     &                             vdep(iptr1lay(igrd)),depfld(iptrdp(igrd)),
     &                              height(iptr3d(igrd)))
               endif
               if (lsrfmod) then
                 if( .NOT. lcdfout ) then
                    call wrtsrf(.TRUE.,igrd,time,date,ismout(igrd),
     &                       ncol(igrd),nrow(igrd),nsmspc,smspc,
     &                       solmas(iptrsm(igrd)),vegmas(iptrsm(igrd)))
                  else
                    if( igrd .eq. 1 )  then
                         action = 'Writing surface model file for master grid.'
                    else
                         write(action,'(2A,I2)') 'Writing surface model file',
     &                                                  'for grid: ',igrd 
                    endif
                    call ncf_wrt_data_tstep(action,ismout(igrd),nsmspc*2)
                    call ncf_wrt_data_srfmod(action,ismout(igrd),igrd,
     &                  ncol(igrd),nrow(igrd),nlay(igrd),nsmspc,
     &                    smspc,solmas(iptrsm(igrd)),vegmas(iptrsm(igrd)),
     &                            height(iptr3d(igrd)))
                  endif
               endif
             enddo
c
c======================== Source Apportion Begin =======================
c
             if( lptdepout ) then
                do igrd = 1,ngrid
                  if( .NOT. lcdfout ) then
                      call wrtdepsa(time,date,igrd,iowptdep(igrd),ncol(igrd),
     &                     nrow(igrd),notimespc,ptdryfld(ipsadep(igrd)),
     &                                         ptwetfld(ipsadep(igrd)))
                  else
                     if( igrd .eq. 1 )  then
                         action = 'Writing SA deposition file for master grid.'
                     else
                         write(action,'(2A,I2)') 'Writing SA deposition file',
     &                                                  ' for grid: ',igrd 
                     endif
                     call ncf_wrt_data_tstep(action,iowptdep(igrd),ntotspout)
                     call ncf_wrt_data_species(action,iowptdep(igrd),igrd,3,ncol(igrd),
     &                      nrow(igrd),nlay(igrd),1,1,ntotsp,ptdepname,loutsa,
     &                      ptdryfld(ipsadep(igrd)),height(iptr3d(igrd)))
                     call ncf_wrt_data_species(action,iowptdep(igrd),igrd,3,ncol(igrd),
     &                    nrow(igrd),nlay(igrd),1,1,ntotsp,ptdepname(ntotsp+1),
     &                    loutsa,ptwetfld(ipsadep(igrd)),height(iptr3d(igrd)))
                  endif
                enddo
             endif
             if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                do igrd = 1,ngrid
                   if( .NOT. lcdfout ) then
                     call wrtsrf(lsrfmodrt,igrd,time,date,iowrtsrf(igrd),
     &                                  ncol(igrd),nrow(igrd),ntotsp,ptname,
     &                                  rtsolmas(ipsa2d(igrd)),rtvegmas(ipsa2d(igrd)) )
                   else
                     call ncf_wrt_data_tstep(action,iowrtsrf(igrd),ntotsp*2)
                     call ncf_wrt_data_species(action,iowrtsrf(igrd),igrd,3,ncol(igrd),
     &                      nrow(igrd),nlay(igrd),1,1,ntotsp,ptdepname,loutsa,
     &                      rtsolmas(ipsa2d(igrd)),height(iptr3d(igrd)))
                     call ncf_wrt_data_species(action,iowrtsrf(igrd),igrd,3,ncol(igrd),
     &                      nrow(igrd),nlay(igrd),1,1,ntotsp,ptdepname(ntotsp+1),loutsa,
     &                      rtvegmas(ipsa2d(igrd)),height(iptr3d(igrd)))
                   endif
                   nodes = ncol(igrd)*nrow(igrd)*ntotsp
                   call zeros(rtsolmas(ipsa2d(igrd)),nodes)
                   call zeros(rtvegmas(ipsa2d(igrd)),nodes)
               enddo
             endif
c
c======================== Source Apportion End =======================
c
c
           endif
c
           do igrd = 1,ngrid
             nlayav = nlay(igrd)
             if( .NOT. l3davg(igrd) ) nlayav = 1
             nodes = ncol(igrd)*nrow(igrd)*nlayav*navspc
             call zeros(avcnc(iptrav(igrd)),nodes)
             nodes = ncol(igrd)*nrow(igrd)*(3*ndepspc + 2)
             call zeros(depfld(iptrdp(igrd)),nodes)
             if( lptdepout ) then
                nodes = ncol(igrd)*nrow(igrd)*notimespc
                call zeros(ptdryfld(ipsadep(igrd)),nodes)
                call zeros(ptwetfld(ipsadep(igrd)),nodes)
             endif
           enddo
c
c-----Write the PiG sampling grid output
c
           if( lsample ) then
               do igrd = 1,nsample
                  if( .NOT. lcdfout ) then
                      call wrtsmp(.FALSE.,time,date,isample(igrd),
     &                         ncolsmp(igrd),nrowsmp(igrd),1,
     &                         navspc,smpcnc(ipsmp(igrd)))
                   else
                      write(action,'(2A,I2)') 'Writing data to sampling ',
     &                                    'grid file for sampling grid: ',igrd
                      call ncf_wrt_data_tstep(action,isample(igrd),navspc)
                      loutspec = .TRUE.
                      call ncf_wrt_data_species(action,isample(igrd),igrd,3,
     &                     ncolsmp(igrd),nrowsmp(igrd),nlay(igrd),
     &                          1,1,navspc,spavnam,loutspec,smpcnc(ipsmp(igrd)),
     &                                 height(iptr3d(igrd)))
                   endif
               enddo
c            endif
             do igrd = 1,nsample
               nodes = ncolsmp(igrd)*nrowsmp(igrd)*navspc
               call zeros(smpcnc(ipsmp(igrd)),nodes)
             enddo
           endif
c
c======================== Source Apportion Begin =======================
c
           if( ltrace .OR. lddm .OR. lhddm ) then
               if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                  call wrrcprt(date,time)
               else
c
c   --- call routine to get the averages at the receptors and
c       write the receptor average file ----
c
                  do igrd=1,ngrid
                     nlayav = nlay(igrd)
                     if( .NOT. lsa_3davrg ) nlayav = 1
                     if( .NOT.( ltrace .OR. lddmcalc(igrd) ) ) cycle
                     call addrcp(igrd,ncol(igrd),nrow(igrd),nlayav,
     &                                   ntotsp,ptavrg(ipsa2d_avrg(igrd)))
                  enddo
                  if( ltrace ) call avgrcp(date,time)
                  if( lddm .OR. lhddm ) call avgrcpddm(date,time)
               endif
c
c
c   --- call routine to write the tracer gridded surface concentrations ---
c
              do igrd=1,ngrid
                if( .NOT.( ltrace .OR. lddmcalc(igrd) ) ) cycle
                nlayav = nlay(igrd)
                num_dims = 4
                if( .NOT. lsa_3davrg ) then
                   nlayav = 1
                   num_dims = 3
                endif
                if( .NOT. lcdfout ) then
                   call wsfcsa(igrd,date,time,ncol(igrd),nrow(igrd),nlayav,
     &                                        ntotsp,ptavrg(ipsa2d_avrg(igrd)))
                else
                   if( igrd .eq. 1 )  then
                       action = 'Writing tracer average concentration file '//
     &                                                     'for master grid.'
                   else
                       write(action,'(2A,I2)') 'Writing average ',
     &                                  'tracer concntration file for grid: ',igrd 
                   endif
                   call ncf_wrt_data_tstep(action,iowsfc(igrd),ntotspout)
                   call ncf_wrt_data_species(action,iowsfc(igrd),igrd,num_dims,ncol(igrd),
     &                      nrow(igrd),nlay(igrd),nlayav,nlayav,ntotsp,ptnameout,loutsa,
     &                         ptavrg(ipsa2d_avrg(igrd)),height(iptr3d(igrd)))
                endif
              enddo
c
c   --- call routine to re-initialize the running averages ---
c
              do igrd=1,ngrid
                 nlayav = nlay(igrd)
                 if( .NOT. lsa_3davrg ) nlayav = 1
                 if( .NOT.( ltrace .OR. lddmcalc(igrd) ) ) cycle
                 nodes=ncol(igrd)*nrow(igrd)*nlayav*ntotsp
                 call zeros(ptavrg(ipsa2d_avrg(igrd)),nodes)
              enddo
c
c   --- call routine to write the RTRAC/PiG sampling grid output
c
              if ((tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND.
     &             lsample .AND. lsmptrc ) then
                   do igrd = 1,nsample
                       if( .NOT. lcdfout ) then
                           call wrtsmp(.true.,time,date,iowsmp(igrd),
     &                          ncolsmp(igrd),nrowsmp(igrd),1,nrtrac,
     &                          rtsmpcnc(iprtsmp(igrd)))
                       else
                           write(action,'(2A,I2)') 'Writing data to RTRAC ',
     &                            'sampling grid file for sampling grid: ',igrd
                           call ncf_wrt_data_tstep(action,iowsmp(igrd),nrtrac)
                           loutspec = .TRUE.
                           call ncf_wrt_data_species(action,iowsmp(igrd),igrd,3,
     &                          ncolsmp(igrd),nrowsmp(igrd),nlay(igrd),1,1,
     &                          nrtrac,ptname,loutspec,rtsmpcnc(iprtsmp(igrd)),
     &                          height(iptr3d(igrd)))
                       endif
                    enddo
c                endif
                 do igrd = 1,nsample
                   nodes = ncolsmp(igrd)*nrowsmp(igrd)*nrtrac
                   call zeros(rtsmpcnc(iprtsmp(igrd)),nodes)
                 enddo
              endif
           endif
c
c========================= Source Apportion End ========================
c
c========================= Process Analysis Begin ======================
c
c-----Get final concentration
c
           if( lipr .OR. lirr ) then
              if( lipr .AND. .NOT. lmpi ) then
                linit = .FALSE.
                do igrd = 1,ngrid
                   call initipr(linit,iproc_id,igrd,nspec,ncol(igrd),
     &                        nrow(igrd), nlay(igrd),conc(iptr4d(igrd)))
                enddo
              endif
c
c-----Write PA results
c
              if( lipr ) call wrtipr(date,time)
              if( lirr ) call wrtirr(date,time)
c
c   --- call routine to zero out all Process Analysis data structures ---
c
              if( .NOT. lmpi ) call pazero( )
c
c-----Get initial concentration for next loop
c
              if( lipr .AND. .NOT. lmpi ) then
                 linit = .TRUE.
                 do igrd = 1,ngrid
                    call initipr(linit,iproc_id,igrd,nspec,ncol(igrd),
     &                        nrow(igrd),nlay(igrd),conc(iptr4d(igrd)))
                 enddo
              endif
           endif
c
c========================= Process Analysis End ========================
c
c
c
c======================== CSA Begin =======================
c
          if( lcsa ) then
             do icsa_grid=1,npadom
                igrid_mod = ipagrd(icsa_grid)
                ncol_csa = i_ne(icsa_grid) - i_sw(icsa_grid) + 1
                nrow_csa = j_ne(icsa_grid) - j_sw(icsa_grid) + 1
                nlay_csa = t_lay(icsa_grid) - b_lay(icsa_grid) + 1
                write(action,'(2A,I2)') 'Writing data to output file for ',
     &                                                  'CSA grid: ',icsa_grid
                call ncf_wrt_data_tstep(action,iow_csa(icsa_grid),ntotsp)
                call ncf_wrt_data_species_csa(action,iow_csa(icsa_grid),4,
     &                          ncol_csa,nrow_csa,nlay_csa,nlay_csa,nlay_csa,
     &                          ntotsp,ptname,csaavrg(iptrcsa(icsa_grid)),
     &                          height(iptr3d(igrid_mod)))
             enddo
          endif
c
c======================== CSA End =======================
c
           write(*,'(a)') '   Done'
           write(iout,'(a)') '   Done'
           call flush(6)
           call flush(iout)
c
c-----Write PiG restart file and diagnostics
c
           if( ipigflg .NE. 0 ) then
             write(*,'(a20,$)') 'wrtpig ......'
             write(iout,'(a20,$)') 'wrtpig ......'
             call wrtpig(date,time,begdate,begtim)
c            call pigdiag(idiag,chtime,chdate,1,'                    ')
             call pigmscl(nspec,ngrid,chtime,chdate,idiag,
     &                                                  pigdump,pgmserr)
             write(*,'(a)') '   Done'
             write(iout,'(a)') '   Done'
             call flush(6)
             call flush(iout)
           endif
c
c-----Write model mass
c
           do igrd = 1,ngrid
             call wrtmass(igrd,chdate,chtime,1)
           enddo
c
c-----Flush file units
c
           call flush(iout)
           call flush(idiag)
           call flush(imass)
           ncf_cur_tstep = ncf_cur_tstep + 1
         endif
      endif
c
      if( lmpi .AND. iproc_id .GT. 0 ) then
         if( date .EQ. wrtdate .AND. ABS(time-wrttim) .LT. 0.01 ) then
             do igrd = 1,ngrid
               call newgrid(igrd)
               nlayav = nlay(igrd)
               if( .NOT. l3davg(igrd) ) nlayav = 1
               nodes = mxp*myp*nlayav*navspc
               call zeros(avcnc(iptrav(igrd)),nodes)
               nodes = mxp*myp*(3*ndepspc + 2)
               call zeros(depfld(iptrdp(igrd)),nodes)
               call nodemass(igrd)
c
c========================= Source Apportion Begin ========================
c
               if( ltrace .OR. lddm .OR. lhddm ) then
                 nlayav = nlay(igrd)
                 if( .NOT. lsa_3davrg ) nlayav = 1
                 nodes=mxp*myp*nlayav*ntotsp
                 call zeros(ptavrg(ipsa2d_avrg(igrd)),nodes)
                 if( lptdepout ) then
                    nodes = mxp*myp*notimespc
                    call zeros(ptdryfld(ipsadep(igrd)),nodes)
                    call zeros(ptwetfld(ipsadep(igrd)),nodes)
                 endif
               endif
c
               if( (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) .AND.
     &             .not.lsrfmodrt ) then
                  nodes = mxp*myp*ntotsp
                  if (lsrfmod) then
                     call zeros(rtsolmas(ipsa2d(igrd)),nodes)
                     call zeros(rtvegmas(ipsa2d(igrd)),nodes)
                  endif
               endif
c
c========================= Source Apportion End ========================
c
             enddo 
             if( ipigflg .NE. 0 ) then
                 call zeros(nkill,9)
                 call zeros(nage,ngrid)
                 call zeros(pigage,ngrid)
             endif
             if( ipigflg .NE. 0 .AND. lsample ) then
                 do ismp=1,nsample
                   nodes = ncolsmp(ismp)*nrowsmp(ismp)*navspc
                   call zeros(smpcnc(ipsmp(ismp)),nodes)
                   if( (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC)
     &                                           .AND. lsmptrc ) then
                       nodes = ncolsmp(ismp)*nrowsmp(ismp)*nrtrac
                       call zeros(rtsmpcnc(iprtsmp(ismp)),nodes)
                   endif
                 enddo
             endif
         endif
      endif
c
      if( date .EQ. wrtdate .AND. ABS(time-wrttim) .LT. 0.01 ) then
         whr = aint(wrttim/100.)
         wmn = amod(wrttim,100.)
         wrttim = 100.*(whr + aint((wmn + dtout)/60.)) + 
     &                                     amod((wmn + dtout),60.)
         if (wrttim.ge.2400.) then
          wrttim = wrttim - 2400.
          wrtdate = wrtdate + 1
          if( MOD(wrtdate,1000) .GT. 365 ) then
              if( MOD(INT(wrtdate/1000),4) .EQ. 0 ) then
                 if( MOD(wrtdate,1000) .EQ. 367 )
     &                     wrtdate = (INT(wrtdate/1000)+1)*1000 + 1
              else
                 wrtdate = (INT(wrtdate/1000)+1)*1000 + 1
              endif
           endif
         endif
      endif
c
c-----Check for end of simulation
c
      if (date.lt.enddate) goto 100
      if (date.eq.enddate .and. time.lt.endtim - 0.01) goto 100
c
c------------------  End main time-integration loop  -------------------
c
c-----Send the instantaneous fields back to master ---
c
      if( lmpi ) then
         call MPI_Barrier(MPI_COMM_WORLD, ierr)
         call conc_update(numprocs, iproc_id)
         call MPI_Barrier(MPI_COMM_WORLD, ierr)
      endif
c
c-----Write final instantaneous restart files
c
      if( iproc_id .EQ. 0 ) then
          call wrtcon(1,time,date,iconc,1,ncol(1),nrow(1),nlay(1),
     &                                                   nspec,conc(1))
          if( ngrid .GT. 1) call wrfgcon(date,time)
          if( lcdfout ) then
             do i=1,ngrid
                if( igrd .eq. 1 )  then
                  action = 'Closing average concentration file '//
     &                                                     'for master grid.'
                else
                  write(action,'(2A,I2)') 'Closing average ',
     &                                  'concntration file for grid: ',i
                endif
                if( ldry .OR. lwet ) then 
                   if( igrd .eq. 1 )  then
                     action = 'Closing deposition file for master grid.'
                   else
                     write(action,'(2A,I2)') 'Closing deposition ',
     &                                            'file for grid: ',i
                   endif
                endif
             enddo
         endif
c
c======================== Source Apportion Begin =======================
c
          if( ltrace .OR. lddm .OR. lhddm ) then
             if( lddmcalc(1) ) call wconsa(date,time,ncol(1),nrow(1),
     &                                        nlay(1),ntotsp,ptconc(1))
             if( ngrid .GT. 1 ) call wfconsa(date,time)
          endif
      endif
c
c========================= Source Apportion End ========================
c
      call MPI_Barrier(MPI_COMM_WORLD, ierr)
      write(iout,'(/,a,a8,1x,a8,/)') 'Date/time: ',chdate,chtime
      write(iout,'(a)')'END SIMULATION'
      write(iout,'(a,i10)') 'TOTAL MASTER GRID TIME STEPS: ', nsteps
      if( iproc_id .EQ. 0 ) then
         write(*,'(/,a,a8,1x,a8,/)')'Date/time: ',chdate,chtime
         write(*,'(a)')'END SIMULATION'
         write(*,'(a,i10)') 'TOTAL MASTER GRID TIME STEPS: ', nsteps
      end if
c
c  --- call routine to close any open NetCDF datasets ---
c
      if( lcdfout .OR. lcsa ) call ncf_closefiles()
c
      if (lmpi) call MPI_Finalize(ierr)
      stop
      end

      subroutine rassgn3d(ncol,nrow,nlay,io,jo,nmesh,ncolf,nrowf,
     &                                                 rcval,rfval)
c
c----CAMx v7.40 260801
c
c     RASSGN3D assigns real fine grid values from coarse grid. This
c     version is for a 3-D array (rows,columns,layers)
c
c      Copyright Ramboll
c          
c     Modifications:
c        none
c
c     Input arguments:
c        ncol              number of columns in the parent grid
c        nrow              number of rows in the parent grid
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        rcval             cell centered value on coarse grid
c
c     Output arguments:
c        rfval             cell centered value on fine grid
c
c     Subroutine called:
c        none
c
c     Called by:
c        STARTUP
c        READINP
c
      real rcval(ncol,nrow,nlay)
      real rfval(ncolf,nrowf,nlay)
c
c-----Entry point
c
      do ilay=1,nlay
        do 40 jfin = 1,nrowf
          j = (jfin - 2)/nmesh + jo
          do 30 ifin = 1,ncolf
            i = (ifin - 2)/nmesh + io
                rfval(ifin,jfin,ilay) = rcval(i,j,ilay)
  30      continue
  40    continue
      enddo
c
      return
      end

      subroutine nodes_emiss(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes all of the data that is time-step
c        dependent to the compute nodes when in MPI mode.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numprocs            the number of processes
c        iproc_id            processes number of current process
c     Output:  
c
c    Called by:
c       EMISS_UPDT
c    Subroutines called:
c       NODE_RECV_1SPECIES_DATA
c       MASTER_SEND_1SPECIES_DATA
c       NODES_PASS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: mvec2d
      integer :: mvecem
      integer :: ispc
      integer :: ilay
      integer :: i
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.not. lmpi .and. iproc_id .gt. 0) return
c
c   --- calculate the number of bytes to send ---
c
      mvec2d = 0
      do i=1,ngrid
         mvec2d = mvec2d + nrow(i) * ncol(i)
      enddo
      mvecem = mvec2d * nspec
c
c  --- pass the fields that are dimensioned by mvecem ---
c
      do i=1,ngrid
         do ilay=1,nlayers_ems
            do ispc=1,nemspc
              if (iproc_id .gt. 0) then
                 call node_recv_1species_data  (aremis(iptrem(i)),i,
     &                                nlayers_ems,ilay,nemspc,ispc,itag )
              else
                 call master_send_1species_data(aremis(iptrem(i)),i,
     &                                nlayers_ems,ilay,nemspc,ispc,itag )
              endif
              itag = itag + 1
            enddo
         enddo
      enddo
c
      call nodes_pass(vstk,  nptsrc,      MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(flowrat,nptsrc,     MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(effph, nptsrc,      MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ptemis,nptsrc*nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lemmap,nspec,       MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- If doing the probiong tools, pass those fields ---
c
      if (ltrace .OR. lddm .OR. lhddm ) then
         call nodes_pass_sapnts(numprocs,iproc_id)
         do i=1,ngrid
            do ilay=1,nlayers_ems
               do ispc=1,soap3_ntotsp
                  if (iproc_id .gt. 0) then
                     call node_recv_1species_data  (saemis(ipsa3d_ems(i)),i,
     &                                   nlayers_ems,ilay,soap3_ntotsp,ispc,itag)
                  else
                     call master_send_1species_data(saemis(ipsa3d_ems(i)),i,
     &                                   nlayers_ems,ilay,soap3_ntotsp,ispc,itag)
                  endif
                  itag = itag + 1
               enddo
            enddo
         enddo
      endif
c
      end

      subroutine nodes_send_lslice_back(iarray,numgrid,numpig,mpi_type,
     &                                  thistag,igrd,numprocs,iproc_id )
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODES_PIG_PASS
c    Subroutines called:
c       MPI_RECV
c       MPI_SEND
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: iarray(numgrid,numprocs,MXPIG)
      integer :: numgrid
      integer :: numpig
      integer :: mpi_type
      integer :: thistag
      integer :: igrd
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
c  --- master node's buffer array ---
c
      integer, allocatable, dimension(:,:,:) :: marray
c
      integer :: i
      integer :: n
      integer :: nbytes
      integer :: ierr
      integer :: status(MPI_STATUS_SIZE)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c

      allocate(marray(numgrid,numprocs,numpig))
      if (.NOT. lmpi) return
c
c  --- Re-initialize the in-slice flag ---
c
      if (iproc_id .EQ. 0) then
         do i=1, numprocs
            do n=1,numpig
               iarray(igrd,i,n) = 0
            enddo
         enddo
      endif
      nbytes=numgrid*numprocs*numpig     
c
c  --- master receives data from nodes ---
c
      if (iproc_id .eq. 0) then
         do i=1, numprocs
            call MPI_RECV(marray,nbytes,mpi_type,i,thistag,
     &                    MPI_COMM_WORLD,status,ierr       )
            do n=1,numpig
               iarray(igrd,i,n) = marray(igrd,i,n)
            enddo
         enddo
      else
c
c  --- node sends data back to master ---
c
         call MPI_SEND(iarray,nbytes,mpi_type,0,thistag,MPI_COMM_WORLD,ierr)
      endif
      thistag = thistag + 1
c
      deallocate(marray)
c
      return
      end

      subroutine node_send_feed(ifm,icm,dx,dy,depths)                             
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid 
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACKP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
      real :: depths(mmxp(ifm),mmyp(ifm),mmzp(ifm))
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: k1crs
      integer :: k2crs
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: k1fine
      integer :: k2fine
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(a)')'Reduce your Probing Tool application.'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm,
     &                           machs(nm),irecv_req(nm)         )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff)) deallocate (pbuff)
         allocate(pbuff(mmzp(ifm)*mmxp(ifm)*mmyp(ifm)*nspec))
         nbuff_save = mmzp(ifm)*mmxp(ifm)*mmyp(ifm)*nspec
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff)) deallocate (pbuff)
         allocate (pbuff(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
c  -- Feed back this fine grid's portion of the each coarse grid node --
c
      k1fine=1
      k2fine=nlay(ifm)
      k1crs=1
      k2crs=nlay(icm)
      do nm=1,nmachs
         isend_req(nm)=0
         if (ipaths(1,itype,ifm,nm) .ne. 0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)*(k2crs-k1crs+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,nspec
               ispbeg=iptr4d(ifm)+(nv-1)*mmzp(ifm)*mmxp(ifm)*mmyp(ifm)
               call fdbackp(mtp, conc(ispbeg),pbuff(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),mmzp(ifm),
     &                      ncol(ifm),nrow(ifm),nlay(ifm),
     &                      i0,j0,
     &                      ifm,icm,i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),
     &                      dx,dy,depths,nv,k1crs,k2crs)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(a)')'Reduce your Probing Tool application.'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_send_buff(1),
     &                        node_buffs(nm)%nsend            )
            call par_put_int(i1s,1)
            call par_put_int(i2s,1)
            call par_put_int(j1s,1)
            call par_put_int(j2s,1)
            call par_put_int(k1crs,1)
            call par_put_int(k2crs,1)
            call par_put_int(mynum,1)
            call par_put_int(nvar,1)
            call par_put_int(iptr,1)
            call par_put_float(pbuff(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm,
     &                            isend_req(nm)                   )
         endif
      enddo
c
      deallocate( pbuff )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_dp:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_dp(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid 
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the deposition velocities.
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_dp(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_dp(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_DP:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_DP:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_dp_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm+dp_identifier,
     &                           machs(nm),irecv_req_dp(nm)                  )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_dp)) deallocate (pbuff_dp)
         allocate(pbuff_dp(mmxp(ifm)*mmyp(ifm)*navspc*3))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*navspc*3
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_dp)) deallocate (pbuff_dp)
         allocate (pbuff_dp(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_dp(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,navspc*3
               ispbeg=iptrdp(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp, depfld(ispbeg),pbuff_dp(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_DP:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_DP:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_dp_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_dp(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+dp_identifier,
     &                            isend_req_dp(nm)                             )
         endif
      enddo
c
      deallocate( pbuff_dp )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_dp:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_smsol:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_smsol(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the surface model.
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_smsol(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_smsol(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_SMSOL:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_SMSOL:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_smsol_recv_buff(1),
     & node_buffs(nm)%nrecv,5500+icm+smsol_identifier,
     &                           machs(nm),irecv_req_smsol(nm) )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_smsol)) deallocate (pbuff_smsol)
         allocate(pbuff_smsol(mmxp(ifm)*mmyp(ifm)*nsmspc))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*nsmspc
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_smsol)) deallocate (pbuff_smsol)
         allocate (pbuff_smsol(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_smsol(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,nsmspc
               ispbeg=iptrsm(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp,solmas(ispbeg),pbuff_smsol(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_SMSOL:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_SMSOL:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_smsol_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_smsol(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+smsol_identifier,
     &                            isend_req_smsol(nm) )
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_smsol:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_smveg:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_smveg(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the surface model.
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_smveg(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_smveg(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_SMVEG:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_SMVEG:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_smveg_recv_buff(1),
     & node_buffs(nm)%nrecv,5500+icm+smveg_identifier,
     &                           machs(nm),irecv_req_smveg(nm) )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_smveg)) deallocate (pbuff_smveg)
         allocate(pbuff_smveg(mmxp(ifm)*mmyp(ifm)*nsmspc))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*nsmspc
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_smveg)) deallocate (pbuff_smveg)
         allocate (pbuff_smveg(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_smveg(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,nsmspc
               ispbeg=iptrsm(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp,vegmas(ispbeg),pbuff_smveg(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_SMVEG:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_SMVEG:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_smveg_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_smveg(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+smveg_identifier,
     &                            isend_req_smveg(nm) )
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_smveg:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_pt:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_pt(ifm,icm,dx,dy,depths)                             
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid 
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        probing tool
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACKP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
      real :: depths(mmxp(ifm),mmyp(ifm),mmzp(ifm))
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: k1crs
      integer :: k2crs
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: k1fine
      integer :: k2fine
      integer (kind=8) :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_pt(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_pt(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_PT:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_PT:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_pt_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm+pt_identifier,
     &                           machs(nm),irecv_req_pt(nm)                  )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_pt)) deallocate (pbuff_pt)
         allocate(pbuff_pt(mmzp(ifm)*mmxp(ifm)*mmyp(ifm)*ntotsp))
         nbuff_save = mmzp(ifm)*mmxp(ifm)*mmyp(ifm)*ntotsp
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_pt)) deallocate (pbuff_pt)
         allocate (pbuff_pt(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
c --- Feed back this fine grid's portion of the each coarse grid node ---
c
      k1crs=1
      k2crs=nlay(icm)
      k1fine=1
      k2fine=nlay(ifm)
c
      do nm=1,nmachs
         isend_req_pt(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)*(k2crs-k1crs+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,ntotsp
               ispbeg=ipsa3d(ifm)+DBLE(nv-1)*DBLE(mmzp(ifm))*DBLE(mmxp(ifm))*DBLE(mmyp(ifm))
               call fdbackp(mtp, ptconc(ispbeg),pbuff_pt(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),mmzp(ifm),
     &                      ncol(ifm),nrow(ifm),nlay(ifm),
     &                      i0,j0,
     &                      ifm,icm,i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),
     &                      dx,dy,depths,nv,k1crs,k2crs)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_PT:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_PT:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_pt_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(k1crs,1)
            call par_put_int(k2crs,1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_pt(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+pt_identifier,
     &                            isend_req_pt(nm)                             )
         endif
      enddo
c
      deallocate( pbuff_pt )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_pt:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_dry:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_dry(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid 
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the deposition velocities. 
c        Feed back the fine grid's portion of each coarse grid node
c        This version is for the dry deposition tracer array.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_dry(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_dry(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_DRY:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_DRY:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_dry_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm+dry_identifier,
     &                           machs(nm),irecv_req_dry(nm)                  )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_dry)) deallocate (pbuff_dry)
         allocate(pbuff_dry(mmxp(ifm)*mmyp(ifm)*notimespc))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*notimespc
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_dry)) deallocate (pbuff_dry)
         allocate (pbuff_dry(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_dry(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,notimespc
               ispbeg=ipsadep(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp, ptdryfld(ispbeg),pbuff_dry(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_DRY:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_DRY:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
c
            call par_init_put(node_buffs(nm)%lbc_dry_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_dry(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+dry_identifier,
     &                            isend_req_dry(nm)                             )
         endif
      enddo
c
      deallocate( pbuff_dry )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_dp:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_wet:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_wet(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid 
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the deposition velocities. 
c        Feed back the fine grid's portion of each coarse grid node
c        This version is for the wet deposition tracer array.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_wet(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_wet(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_WET:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_WET:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_wet_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm+wet_identifier,
     &                           machs(nm),irecv_req_wet(nm)                  )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_wet)) deallocate (pbuff_wet)
         allocate(pbuff_wet(mmxp(ifm)*mmyp(ifm)*notimespc))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*notimespc
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_wet)) deallocate (pbuff_wet)
         allocate (pbuff_wet(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_wet(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,notimespc
               ispbeg=ipsadep(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp, ptwetfld(ispbeg),pbuff_wet(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_WET:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_WET:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_wet_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_wet(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+wet_identifier,
     &                            isend_req_wet(nm)                             )
         endif
      enddo
c
      deallocate( pbuff_wet )
      nbuff_save = 0
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_wet:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_rtsol:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_rtsol(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use rtracchm
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the RTRAC surface model.
c        Feed back the fine grid's portion of each coarse grid node
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_rtsol(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_rtsol(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_RTSOL:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_RTSOL:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_rtsol_recv_buff(1),
     & node_buffs(nm)%nrecv,5500+icm+rtsol_identifier,
     &                           machs(nm),irecv_req_rtsol(nm) )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_rtsol)) deallocate (pbuff_rtsol)
         allocate(pbuff_rtsol(mmxp(ifm)*mmyp(ifm)*ntotsp))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*ntotsp
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_rtsol)) deallocate (pbuff_rtsol)
         allocate (pbuff_rtsol(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_rtsol(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,ntotsp
               ispbeg=ipsa2d(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp,rtsolmas(ispbeg),pbuff_rtsol(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_RTSOL:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_RTSOL:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_rtsol_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_rtsol(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+rtsol_identifier,
     &                            isend_req_rtsol(nm) )
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_rtsol:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine node_send_feed_rtveg:
c-----------------------------------------------------------------------
c
      subroutine node_send_feed_rtveg(ifm,icm,dx,dy)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camxfld
      use grid
      use tracer
      use rtracchm
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c
c        This version is for the deposition velocities.
c        Feed back the fine grid's portion of each coarse grid node
c        This version is for the RTRAC surface model.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:
c     Output:
c
c    Called by:
c       NESTING
c    Subroutines called:
c       PAR_GET_NOBLOCK
c       MYOFFSET
c       FDBACK_DP
c       PAR_INIT_PUT
c       PAR_PUT_INT
c       PAR_PUT_FLOAT
c       PAR_SEND_NOBLOCK
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'chmdat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: ifm
      integer :: icm
c
      real :: dx(*)
      real :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i1s
      integer :: i2s
      integer :: j1s
      integer :: j2s
      integer :: mtp
      integer :: i1f
      integer :: i2f
      integer :: j1f
      integer :: j2f
      integer :: ispbeg
      integer :: nm
      integer :: itype
      integer :: itypef
      integer :: nv
      integer :: iptr
      integer (kind=8) :: iptr8
      integer :: nvar
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer (kind=8) :: maxbytes
c
      real, save, allocatable :: pbuff_rtveg(:)
      integer, save           :: nbuff_save=0
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      maxbytes = DBLE(2**15)*DBLE(2**16) - 1
      itype=6
c
c  --- before send anything, post the receives. ---
c
      do nm=1,nmachs
         irecv_req_rtveg(nm)=0
         if (iget_paths(itype,ifm,nm) .ne. 0) then
            iptr8 = DBLE(node_buffs(nm)%nrecv)*DBLE(4)
            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_RTVEG:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_RTVEG:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif
            call par_get_noblock(node_buffs(nm)%lbc_rtveg_recv_buff(1),
     &                           node_buffs(nm)%nrecv,5500+icm+rtveg_identifier,
     &                           machs(nm),irecv_req_rtveg(nm)                  )
         endif
      enddo
c
c  --- Allocate new temporary buffer if bigger than the old one. ---
c
      if (nbuff_save .eq. 0) then
         if (allocated(pbuff_rtveg)) deallocate (pbuff_rtveg)
         allocate(pbuff_rtveg(mmxp(ifm)*mmyp(ifm)*ntotsp))
         nbuff_save = mmxp(ifm)*mmyp(ifm)*ntotsp
      endif
      if (node_buffs(mynum)%nrecv > nbuff_save) then
         if (allocated(pbuff_rtveg)) deallocate (pbuff_rtveg)
         allocate (pbuff_rtveg(node_buffs(mynum)%nrecv))
         nbuff_save=node_buffs(mynum)%nrecv
      endif
c
      do nm=1,nmachs
         isend_req_rtveg(nm)=0
         if (ipaths(1,itype,ifm,nm).ne.0) then
            i1s=ipaths(1,itype,ifm,nm)
            i2s=ipaths(2,itype,ifm,nm)
            j1s=ipaths(3,itype,ifm,nm)
            j2s=ipaths(4,itype,ifm,nm)
            mtp=(i2s-i1s+1)*(j2s-j1s+1)
            itypef=7
            i1f=ipaths(1,itypef,ifm,nm)
            i2f=ipaths(2,itypef,ifm,nm)
            j1f=ipaths(3,itypef,ifm,nm)
            j2f=ipaths(4,itypef,ifm,nm)
            call myoffset(0,i1f,nmesh(ifm),offxb)
            call myoffset(1,i2f,nmesh(ifm),offxe)
            call myoffset(0,j1f,nmesh(ifm),offyb)
            call myoffset(1,j2f,nmesh(ifm),offye)
            iptr=0
            iptr8=0
c
            do nv=1,ntotsp
               ispbeg=ipsa2d(ifm)+(nv-1)*mmxp(ifm)*mmyp(ifm)
               call fdback_dp(mtp,rtvegmas(ispbeg),pbuff_rtveg(1+iptr),
     &                      mmxp(ifm),mmyp(ifm),i0,j0,ifm,icm,
     &                      i1f-i0,i2f-i0,j1f-j0,j2f-j0,
     &                      offxb,offxe,offyb,offye,
     &                      nmesh(ifm),nmesh(ifm),dx,dy,nv)
               iptr=iptr+mtp
               iptr8=iptr8+DBLE(mtp)*DBLE(4)
            enddo

            if( iptr8 .GT. maxbytes ) then
              write(*,'(//,a)')'ERROR in NODE_SEND_FEED_RTVEG:'
              write(*,'(a)')'Message Passing for tracer speices.'
              write(*,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(*,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              write(iout,'(//,a)')'ERROR in NODE_SEND_FEED_RTVEG:'
              write(iout,'(a)')'Message Passing for tracer speices.'
              write(iout,'(a)')'Number of bytes exceeds 2,147,483,648 (2^31).'
              write(iout,'(2a)')'Reduce your Probing Tool application or',
     &                        ' use a different number of cores for MPI.'
              call camxerr()
            endif

c
            call par_init_put(node_buffs(nm)%lbc_rtveg_send_buff(1),
     &                        node_buffs(nm)%nsend               )
            call par_put_int(i1s,  1)
            call par_put_int(i2s,  1)
            call par_put_int(j1s,  1)
            call par_put_int(j2s,  1)
            call par_put_int(mynum,1)
            call par_put_int(nvar, 1)
            call par_put_int(iptr, 1)
            call par_put_float(pbuff_rtveg(1),iptr)
            call par_send_noblock(ipaths(5,itype,ifm,nm),5500+icm+rtveg_identifier,
     &                            isend_req_rtveg(nm)                              )
         endif
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine node_send_feed_rtveg:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine fdbackp:
c-----------------------------------------------------------------------
c
      subroutine fdbackp(size_dat_coarse,dat_fine,dat_coarse,
     &                   m1,m2,m3, 
     &                   nx,ny,nz,
     &                   ioff,joff,
     &                   igrd,icm,
     &                   ibeg,iend,jbeg,jend,
     &                   offxb,offxe,offyb,offye,
     &                   nestratx,nestraty,
     &                   dx,dy,depths,nv,k1c,k2c)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use master_mod
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_SEND_FEED
c       NODE_SEND_FEED_PT
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real, dimension(m1,m2,m3) :: dat_fine
      real, dimension(*)        :: dat_coarse
c
      integer :: size_dat_coarse
      integer :: m1
      integer :: m2
      integer :: m3
      integer :: igrd
      integer :: icm
      integer :: nx
      integer :: ny
      integer :: nz
      integer :: ioff
      integer :: joff
      integer :: ibeg
      integer :: iend
      integer :: jbeg
      integer :: jend
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: nv
      integer :: k1c
      integer :: k2c
c
c  --- nmesh in x/y direction ---
c
      integer :: nestratx
      integer :: nestraty
c
      real, dimension(*)        :: dx
      real                      :: dy
      real, dimension(m1,m2,m3) :: depths
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: k
      integer :: indcf
      integer :: ii
      integer :: jj
      integer :: kcrs
      real*8  :: asum
      real*8  :: bsum
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      dat_coarse(1:size_dat_coarse) = 0
      indcf = 0
c
      do j = jbeg-offyb,jend+offye,nestraty
         do i = ibeg-offxb,iend+offxe,nestratx
            do kcrs=k1c,k2c
               indcf = indcf + 1 
               k = kcrs
               bsum = 0.0D0
               do jj = j, j+nestraty-1
                  asum = 0.0D0
                  do ii = i, i+nestratx-1
                     if (ii .lt. ibeg .or. ii .gt. iend .or. 
     &                   jj .lt. jbeg .or. jj .gt. jend) goto 3000
                     if( ii .LT. mia(igrd) ) goto 3000
                     if( ii .GT. miz(igrd) ) goto 3000
                     if( jj .LT. mja(igrd) ) goto 3000
                     if( jj .GT. mjz(igrd) ) goto 3000
                     asum = asum + DBLE(dat_fine(ii,jj,k)) * 
     &                         DBLE(dx(jj+joff))*DBLE(dy)*
     &                                         DBLE(depths(ii,jj,k))
c
 3000 continue
                  enddo
                  bsum = bsum + asum
               enddo
               dat_coarse(indcf) = dat_coarse(indcf) + REAL(bsum)
            enddo
         enddo
      enddo
      if (indcf .ne. size_dat_coarse) then
         stop 'size_dat_coarse and indcf not consistant in fdbackup'
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine fdbackp:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine fdback_dp:
c-----------------------------------------------------------------------
c
      subroutine fdback_dp(size_dat_coarse,dat_fine,dat_coarse,m1,m2,
     &                     ioff,joff,igrd,icm,ibeg,iend,jbeg,jend,
     &                     offxb,offxe,offyb,offye,nestratx,nestraty,
     &                     dx,dy,nv)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use master_mod
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       NODE_SEND_FEED_DP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real, dimension(m1,m2) :: dat_fine
      real, dimension(*)     :: dat_coarse
c
      integer :: size_dat_coarse
      integer :: m1
      integer :: m2
      integer :: igrd
      integer :: icm
      integer :: ioff
      integer :: joff
      integer :: ibeg
      integer :: iend
      integer :: jbeg
      integer :: jend
      integer :: offxb
      integer :: offxe
      integer :: offyb
      integer :: offye
      integer :: nv
c
c  --- nmesh in x/y direction ---
c
      integer :: nestratx
      integer :: nestraty
c
      real, dimension(*)        :: dx
      real                      :: dy
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
      integer :: indcf
      integer :: ii
      integer :: jj
      real*8  :: asum
      real*8  :: bsum
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      dat_coarse(1:size_dat_coarse) = 0
      indcf = 0
c
      do j = jbeg-offyb,jend+offye,nestraty
         do i = ibeg-offxb,iend+offxe,nestratx
            indcf = indcf + 1 
            bsum = 0.0D0
            do jj = j, j+nestraty-1
              asum = 0.0D0
              do ii = i, i+nestratx-1
                if (ii .lt. ibeg .or. ii .gt. iend .or. 
     &                     jj .lt. jbeg .or. jj .gt. jend) goto 3000
                if( ii .LT. mia(igrd) ) goto 3000
                if( ii .GT. miz(igrd) ) goto 3000
                if( jj .LT. mja(igrd) ) goto 3000
                if( jj .GT. mjz(igrd) ) goto 3000
                asum = asum + DBLE(dat_fine(ii,jj)) * 
     &                                      DBLE(dx(jj+joff))*DBLE(dy)
c
 3000 continue
              enddo
              bsum = bsum + asum 
            enddo
            dat_coarse(indcf) = dat_coarse(indcf) + REAL(bsum)
         enddo
      enddo
c
      if (indcf .ne. size_dat_coarse) then
         stop 'size_dat_coarse and indcf not consistant in fdback_dp'
      endif
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine fdback_dp:
c-----------------------------------------------------------------------

      subroutine diffus(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,lrtrc,losat,ldepfld,
     &                  igrd,ncol,nrow,nlay,nrads,nspc,ndpspc1,ndpspc2,
     &                  ndpspc3,deltat,dx,dy,idfin,vdep,rkx,rky,rkv,
     &                  depth,tempk,press,uwind,vwind,qvap,cwc,temps,
     &                  mapscl,sfcz0,snow,snowfrc,conc,fluxes,fluxtmp,
     &                  depfld1,depfld2,depfld3,fsurf,isaptr,iproc_id,
     &                  ipa_xy,ipa_lay,strz,strxy)
      use filunit
      use chmstry
      use bndary
      use procan
      use tracer
      use rtracchm
c
c----CAMx v7.40 260801
c
c     DIFFUS drives 3-D diffusion of concentrations.  This version also
c     performs diffusion of sensitivities if DDM is enabled.
c
c      Copyright Ramboll
c          
c     Modifications:
c        4/17/00   Revised diffusion equations to weight fluxes by density
c       12/07/01   added instructions for OMP
c        1/13/03   added deposited mass array
c       10/12/04   Multiple substeps as f(Kv) applied for vertical diffusion 
c       10/09/08   Added ACM2 option (DOES NOT WORK WITH DDM OR IPR)
c       10/10/08   Revised to move species loop into VDIFF routines for
c                  better efficiency
c       07/16/07 -bkoo-     Added check for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       04/29/13   Deposit to surface model fields
c       08/25/14   Extended Zhang LU to surface model, added snow effects
c       05/31/16   Revised ACM2 to parallel speed improvements in CMAQ v5.1,
c                  extended to H/DDM
c       08/26/21   RTRAC surface file doubles as (default) dep output
c                  or (flagged) surface model output
c
c     Input arguments:
c        lrtrc             flag that determines if this is for RTRAC
c        losat             flag that determines if this for tracers
c        ldepfld           flag that determines if dep fields are saved
c        igrd              grid index
c        ncol              number of columns
c        nrow              number of rows
c        nlay              number of layers
c        nrads             number of radicals
c        nspc              number of species
c                          or 1, whichever is larger
c        ndpspc1           number of species in first depostion array
c        ndpspc2           number of species in second depostion array
c        ndpspc3           number of species in third depostion array
c        deltat            time step (s)
c        dx                cell size in x-direction (m)
c        dy                cell size in y-direction (m)
c        idfin             map of nested grids in this grid
c        vdep              deposition velocity (m/s)
c        rkx/y             horizontal diffusion coefficient (m2/s)
c        rkv               vertical diffusion coefficient (m2/s)
c        depth             layer depth (m)
c        tempk             temperature (K)
c        press             pressure (mb)
c        uwind             u-component wind (m/s)
c        vwind             v-component wind (m/s)
c        qvap              water vapor (ppm)
c        cwc               cloud water content (g/m3)
c        temps             surface temperature (K)
c        mapscl            map-scale factor at cell centroid
c        sfcz0             surface roughness (m)
c        snow              snow cover equivalent water (m)
c        snowfrc           snow cover fraction
c        conc              species concentrations (umol/m3)
c        fsurf             fractional landuse coverage
c        fluxtmp           temporary array for fluxes
c        strz              string for labeling the z diffusion process
c        strxy             string for labeling the x/y diffusion process
c        ipa_xy            2-D gridded array to identify if cell is
c                          in a IPRM sub-domain
c        ipa_lay           3-D gridded array to identify which IPRM sub-domain
c                          each layer is in
c        iproc_id          ID for this processor in MPI rank
c
c     Output arguments:
c        conc              species concentrations (umol/m3)
c        fluxes            fluxes across the boundaries (umol)
c        depfld1           2-D array of dry deposited mass (mol/ha, g/ha)
c        depfld2           2-D array of dry deposited mass (mol/ha, g/ha)
c        depfld3           2-D array of dry deposited mass (mol/ha, g/ha)
c
c     Routines Called:
c        VDIFFIMP
c        VDIFFACM2
c        CALDATE
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include "camx.prm"
      include "flags.inc"
      include "deposit.inc"
      include "rtracsrf.inc"
c
c=============================DDM Begin================================
c
      integer   lk,isen,ioff
      integer*8 idx
      integer*8 isaptr
c
      real depmas
c
c=============================DDM End==================================
c
c======================== Process Analysis Begin ====================================
c
      integer ipa_idx
      integer ipa_xy(ncol,nrow)
      integer ipa_lay(ncol,nrow,nlay)
      logical ldoipts
c
      real fcup(MXLAYER,MXSPEC)
      real fcdn(MXLAYER,MXSPEC)
c
c========================= Process Analysis End =====================================
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon
c
      character*20 strz
      character*20 strxy
      logical      lrtrc
      logical      losat
      logical      ldepfld
      integer      igrd,ncol,nrow,nlay,nrads,nspc,ndpspc1,ndpspc2,
     &                                                    ndpspc3
      real         deltat
      real         dy
      real         fluxtmp(m1,m2,m3,nspc)
      real         conc(m1,m2,m3,nspc)
      real         vdep(m1,m2,nspc)
      real         depfld1(m1,m2,ndpspc1)
      real         depfld2(m1,m2,ndpspc2)
      real         depfld3(m1,m2,ndpspc3)
      real         fsurf(m1,m2,NLU)
      real, dimension(m1,m2,m3) :: rkx,rky,rkv,tempk,press
      real, dimension(m1,m2,m3) :: uwind,vwind,qvap,cwc
      real, dimension(m1,m2,m3) :: depth
      real, dimension(m1,m2)    :: temps,mapscl,sfcz0,snow,snowfrc
      real         dx(nrow)
      integer      idfin(m1,m2)
      real*8       fluxes(nspc,11)
      integer      iproc_id
c
      real    dtv,dtmp,rokp1,rhoavg,scl,dfxp,dfxm,dfyp,dfym,fxp,
     &        fxm,fyp,fym
      real    dzmid,press0,dpdz,z0,zz
      real    sfrac
      real    fconv
      integer n,i,j,k,l,ispc,ll,numspcs,lsm,nstepv,kpbl
c
      real    vdry(MXSPEC+MXTRSP)
      real    d1d(MXLAYER)
      real    rk1d(MXLAYER)
      real    rkro(MXLAYER)
      real    ro1d(MXLAYER)
      real    t1d(MXLAYER)
      real    p1d(MXLAYER)
      real    w1d(MXLAYER)
      real    qv1d(MXLAYER)
      real    cnc(MXCELLS,MXCELLS)
      real    rho(MXCELLS,MXCELLS)
      real    fluxbot(MXSPEC+MXTRSP)

      real, allocatable, dimension (:,:) :: c1d
c
c-----Entry point
c
c-----Vertical diffusion
c
      numspcs = nspc
      if( losat .or. lrtrc) numspcs = nsaspc
      if( iproc_id .LE. 1 ) then
        write(*,'(a20,$)') strz
      endif
      write(iout,'(a20,$)') strz
c
c  ---- Initialize the temp flux array to zero ---
c
      if( .NOT. losat ) call zeros(fluxtmp,m1*m2*m3*nspc)
c
c$omp parallel default(shared)
c$omp&  private(c1d,l,lk,i,j,k,lsm,idx,
c$omp&          ll,ro1d,d1d,rk1d,rkro,dzmid,dpdz,press0,t1d,p1d,w1d,
c$omp&          qv1d,vdry,z0,ioff,fluxbot,isen,rokp1,kpbl,fconv,sfrac,
c$omp&          ldoipts,fcup,fcdn,ipa_idx,n,dtv,dtmp,nstepv,zz,depmas)
c
      if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
          allocate( c1d(nlay+nlay*nddmsp,numspcs) )
      else
         allocate( c1d(nlay,numspcs) )
      endif
c
c$omp do schedule(guided)
c
      do 60 j = 2,m2-1
        do 50 i = 2,m1-1
c
c-----Skip cells occupied by child grids; load 1-D arrays
c
          if (idfin(i,j).gt.igrd) goto 50
c
c-----Determine max vertical diffusion time step
c
          dtv = deltat
          if (deltat.ge.300.) then
            do k = 1,nlay-1
              dtmp = 0.75*depth(i,j,k)*depth(i,j,k+1)/rkv(i,j,k)
              dtv = min(dtv,dtmp)
            enddo
            dtv = max(dtv,300.)
          endif
          nstepv = INT( 0.999*deltat/dtv ) + 1
          dtv = deltat/FLOAT( nstepv )
c
c-----Load 1-D variables
c
          z0 = sfcz0(i,j)
          dzmid = (depth(i,j,2) + depth(i,j,1))/2.
          dpdz  = (press(i,j,2) - press(i,j,1))/dzmid
          press0 = press(i,j,1) - dpdz*depth(i,j,1)/2.
          do k = 1,nlay
            ro1d(k) = press(i,j,k)/tempk(i,j,k)
            d1d(k) = depth(i,j,k)
            t1d(k) = tempk(i,j,k)
            p1d(k) = press(i,j,k)
            w1d(k) = sqrt(uwind(i,j,k)**2. + vwind(i,j,k)**2.)
            qv1d(k) = (qvap(i,j,k)/1.e6)*18./28.8
          enddo
          zz = 0.
          do k = 1,nlay-1
            zz = zz + depth(i,j,k)
            rk1d(k) = amin1(rkv(i,j,k),1000.,0.4*zz)
            rkro(k) = rkv(i,j,k)*(ro1d(k) + ro1d(k+1))/2.
          enddo
          rk1d(nlay) = 0.
          rkro(nlay) = 0.
          do l = nrads+1,numspcs
            vdry(l-nrads) = vdep(i,j,l)
          enddo

          do n = 1,nstepv
            do l = nrads+1,numspcs
              do k = 1,nlay
                c1d(k,l-nrads) = conc(i,j,k,l)
              enddo
            enddo

c
c=============================DDM Begin================================
c
c------Load sensitivities
c
            if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              do l = nrads+1,numspcs
                lk = nlay
                do isen = 1,nddmsp
                  ioff = iptddm(l)+isen-1
                  do k = 1,nlay
                    lk = lk + 1
                    idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                 DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                             DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                    c1d(lk,l-nrads) = ptconc(idx)
                  enddo
                enddo
              enddo
            endif
c
c=============================DDM End==================================
c
c
c======================== Process Analysis Begin ====================================
c
            ldoipts = .FALSE.
            if( .NOT. ltrace .AND. lipr ) then
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja
     &                                         .AND. j .LE. jz ) then
                   if(ipa_xy(i+i0,j+j0) .GT. 0) ldoipts = .TRUE.
                endif
            endif
c
c========================= Process Analysis End =====================================
c
            if (lacm2) then
              fconv = 0.
              if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
                call vdiffacmx(nspc-nrads,nddmsp,nlay,dtv,temps(i,j),
     &                         press0,z0,d1d,rk1d,qv1d,t1d,p1d,w1d,kpbl,
     &                         fconv,c1d)
              else
                call vdiffacmx(nspc-nrads,0,nlay,dtv,temps(i,j),
     &                         press0,z0,d1d,rk1d,qv1d,t1d,p1d,w1d,kpbl,
     &                         fconv,c1d)
              endif
              if (n.eq.1) then
                do k = 1,kpbl-1
                  rkro(k) = rkro(k)*(1. - fconv)
                enddo
              endif
            endif
            if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              call vdiffk(nspc-nrads,nlay,dtv,vdry,d1d,ro1d,rkro,c1d,
     &                    nddmsp,fluxbot,fcup,fcdn,ldoipts)
            else
              call vdiffk(nspc-nrads,nlay,dtv,vdry,d1d,ro1d,rkro,c1d,
     &                    0,fluxbot,fcup,fcdn,ldoipts)
            endif
c
c======================== Process Analysis Begin ====================================
c
            if( ldoipts ) then
              do l = nrads+1,numspcs
                do k = 1,nlay
                  if( ipa_lay(i+i0,j+j0,k) .GT. 0) then
                     ipa_idx  = ipa_lay(i+i0,j+j0,k)
                     if( k .GT. 1 ) then
                        cipr(IPR_BDIF, ipa_idx, l) =
     &                     cipr(IPR_BDIF, ipa_idx, l) + fcdn(k,l-nrads)
                     else
                        cipr(IPR_DDEP, ipa_idx, l) =
     &                     cipr(IPR_DDEP, ipa_idx, l) + fcdn(k,l-nrads)
                     endif
                     cipr(IPR_TDIF, ipa_idx, l) =
     &                     cipr(IPR_TDIF, ipa_idx, l) + fcup(k,l-nrads)
                  endif
                enddo
              enddo
            endif
c
c========================= Process Analysis End =====================================
c
            do l = nrads+1,numspcs
              do k = 1,nlay
                conc(i,j,k,l) = c1d(k,l-nrads)
              enddo

              if (lsrfmod .and. .NOT.losat) then
                lsm = 0
                do ll = 1,nsmspc
                  if (l .EQ. idsmsp(ll)) lsm = ll
                enddo
              endif

              if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja
     &                                      .AND. j .LE. jz ) then
     
                 fluxbot(l-nrads) = fluxbot(l-nrads)*depth(i,j,1)
                 if( .NOT. losat ) then
                   fluxtmp(i,j,1,l) = fluxtmp(i,j,1,l) +
     &                   fluxbot(l-nrads)*dx(j+j0)*dy/mapscl(i,j)**2.
                   do ll = 1,navspc
                     if( ldepfld .and. l .eq. lavmap(ll) ) then
                       depfld1(i,j,ll) = depfld1(i,j,ll) - 
     &                                   1.e-2*fluxbot(l-nrads)
                       goto 100
                     endif
                   enddo
 100               continue
                   if( lsrfmod .AND. lsm.NE.0) then
                     do ll = 1,NLU
                       if (NLU .eq. NLUW89 .and. ll.ne.7) then
                         sfrac = fsoil(ll)*fsurf(i,j,ll)
                       elseif (NLU .eq. NLUZ03 .and. ll.ne.1 .and.
     &                         ll.ne.3) then
                         sfrac = fsoilz(ll)*fsurf(i,j,ll)
                       endif
                     enddo
                     if (snow(i,j).ge.0.01)       ! Snow > 10 cm
     &                 sfrac = max(sfrac,snowfrc(i,j))
                     depmas = -1.e-2*fluxbot(l-nrads)
                     depfld2(i,j,lsm) = depfld2(i,j,lsm) + sfrac*depmas
                     depfld3(i,j,lsm) = depfld3(i,j,lsm) +
     &                                              (1. - sfrac)*depmas
                   endif
                 endif
              endif
c
c=============================Source Apportion Begin================================
c
              if( ldepfld .and. losat .AND. lptdepout 
     &                                    .AND. l .LE. ndpspc1 ) then
                depfld1(i,j,l) = depfld1(i,j,l) - 1.e-2*fluxbot(l-nrads)
              endif
              if( lrtrc ) then
                 depmas = -1.e-2*fluxbot(l-nrads)
                 if (lsrfmodrt ) then
                   do ll = 1,NLUW89
                     if (ll.ne.7) then
                       depfld1(i,j,l) = depfld1(i,j,l) +
     &                                    fsoil(ll)*fsurf(i,j,ll)*depmas
                       depfld2(i,j,l) = depfld2(i,j,l) +
     &                             (1. - fsoil(ll))*fsurf(i,j,ll)*depmas
                     endif
                   enddo
                 else
                   depfld1(i,j,l) = depfld1(i,j,l) + depmas
                 endif
              endif
            enddo
c
c=============================Source Apportion End ================================
c
c
c=============================DDM Begin================================
c
            if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
              do l = nrads+1,numspcs
                lk = nlay
                do isen = 1,nddmsp
                  ioff = iptddm(l)+isen-1
                  do k = 1,nlay
                    lk = lk + 1
                    idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                   DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                               DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                    ptconc(idx) = c1d(lk,l-nrads)
                  enddo
                enddo
              enddo
            endif
c
c=============================DDM End==================================
c
          enddo
  50    continue
  60  continue
c
      if( allocated( c1d ) ) deallocate( c1d )
c
c$omp end parallel
c
c-----Put fluxes in global array
c
      if( .NOT. losat ) then
         do j = 2,m2-1
           do i = 2,m1-1
             do l = 1,nspc
               fluxes(l,11) = fluxes(l,11) + DBLE(fluxtmp(i,j,1,l))
             enddo
           enddo
         enddo
      endif
c
c$omp master
c
      if( iproc_id .LE. 1 ) then
        write(*,'(a)') '   Done'
      endif
      write(iout,'(a)') '   Done'
      call flush(6)
      call flush(iout)
c
c-----Perform explicit horizontal diffusion
c
      if( iproc_id .LE. 1 ) then
        write(*,'(a20,$)') strxy
      endif
      write(iout,'(a20,$)') strxy
c
c$omp end master
c
c$omp parallel default(shared)
c$omp&  private(ispc,i,j,k,ioff,rho,cnc,rhoavg,scl,
c$omp&          dfxp,dfxm,dfyp,dfym,fxp,fxm,fyp,fym,isen,idx,ipa_idx)
c
c$omp do schedule(guided)
c
      do 91 ispc = nrads+1,numspcs
        do 90 k = 1,nlay
          do 80 j = 1,m2   !nrow
            do 70 i = 1,m1    !ncol
              rho(i,j) = press(i,j,k)/tempk(i,j,k)
              cnc(i,j) = conc(i,j,k,ispc)/rho(i,j)
  70        continue
  80      continue
c
c=============================DDM Begin================================
c
         if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
           do isen = 1,nddmsp
             ioff = iptddm(ispc)+isen-1
             do j=1,m2   !nrow
               do i = 1,m1   !ncol
                 idx =  DBLE(isaptr-1) + DBLE(i) + 
     &                DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                            DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                 sns(i,j,isen,ispc) = ptconc(idx)/rho(i,j)
                enddo
              enddo
           enddo
         endif
c
c=============================DDM End ================================
c
          do 85 j = 2,m2-1   !2,nrow-1
            do 75 i = 2,m1-1   !2,ncol-1
              if (idfin(i,j).gt.igrd) goto 75
c
              rhoavg = (rho(i,j) + rho(i+1,j))/2.
              scl = (mapscl(i,j) + mapscl(i+1,j))/2.
              dfxp = scl*rhoavg*rkx(i,j,k)*deltat/dx(j+j0)/dx(j+j0)
              rhoavg = (rho(i,j) + rho(i-1,j))/2.
              scl = (mapscl(i,j) + mapscl(i-1,j))/2.
              dfxm = scl*rhoavg*rkx(i-1,j,k)*deltat/dx(j+j0)/dx(j+j0)
c
              rhoavg = (rho(i,j) + rho(i,j+1))/2.
              scl = (mapscl(i,j) + mapscl(i,j+1))/2.
              dfyp = scl*rhoavg*rky(i,j,k)*deltat/dy/dy
              rhoavg = (rho(i,j) + rho(i,j-1))/2.
              scl = (mapscl(i,j) + mapscl(i,j-1))/2.
              dfym = scl*rhoavg*rky(i,j-1,k)*deltat/dy/dy
c
              fxp  = (cnc(i+1,j) - cnc(i,j))*dfxp
              fxm  = (cnc(i,j) - cnc(i-1,j))*dfxm
              fyp  = (cnc(i,j+1) - cnc(i,j))*dfyp
              fym  = (cnc(i,j) - cnc(i,j-1))*dfym
              conc(i,j,k,ispc) = conc(i,j,k,ispc) + mapscl(i,j)*
     &                           ((fxp - fxm) + (fyp - fym))
c
c======================== Process Analysis Begin ====================================
c
              if( .NOT. ltrace .AND. lipr ) then
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja
     &                                         .AND. j .LE. jz ) then
                    if ( ipa_lay(i+i0,j+j0,k) .GT. 0 ) then
                     ipa_idx = ipa_lay(i+i0,j+j0,k)
                     cipr(IPR_WDIF, ipa_idx, ispc) =
     &                       cipr( IPR_WDIF, ipa_idx, ispc) -
     &                                       mapscl(i,j)*fxm

                     cipr(IPR_EDIF, ipa_idx, ispc) =
     &                       cipr(IPR_EDIF, ipa_idx, ispc) +
     &                                       mapscl(i,j)*fxp

                     cipr(IPR_SDIF, ipa_idx, ispc) =
     &                       cipr(IPR_SDIF, ipa_idx, ispc) -
     &                                       mapscl(i,j)*fym

                     cipr(IPR_NDIF, ipa_idx, ispc) =
     &                       cipr(IPR_NDIF, ipa_idx, ispc) +
     &                                       mapscl(i,j)*fyp
                   endif
                 endif
              endif
c
c========================= Process Analysis End =====================================
c
c
c=============================DDM Begin================================
c
              if ( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
               do isen =1,nddmsp
                 fxp  = (sns(i+1,j,isen,ispc) - sns(i,j,isen,ispc))*dfxp
                 fxm  = (sns(i,j,isen,ispc) - sns(i-1,j,isen,ispc))*dfxm
                 fyp  = (sns(i,j+1,isen,ispc) - sns(i,j,isen,ispc))*dfyp
                 fym  = (sns(i,j,isen,ispc) - sns(i,j-1,isen,ispc))*dfym
                 ioff = iptddm(ispc)+isen-1
                 idx =  DBLE(isaptr-1) + DBLE(i) + 
     &               DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(k-1) + 
     &                            DBLE(m1)*DBLE(m2)*DBLE(m3)*DBLE(ioff-1)
                 ptconc(idx) = ptconc(idx) + mapscl(i,j)*
     &                                   ((fxp - fxm) + (fyp - fym))
               enddo
             endif
c
c=============================DDM End==================================
c
  75        continue
  85      continue
          call flush(6)
          call flush(iout)
  90    continue
  91  continue
c
c$omp end parallel
c$omp master
c
  92  continue
      if( iproc_id .LE. 1 ) then
        write(*,'(a)') '   Done'
      endif
      write(iout,'(a)') '   Done'
c
c$omp end master
c
      call flush(6)
      call flush(iout)
c
      return
      end

c*** ADJSTC0
c
      subroutine adjstc0(numcol,numrow,numlay,igrd,icl,jcl,kcl,delcls,
     &                   concls,cytcls,c0cls,c0trac,tmtrac,cellvol)
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine makes the wet dep adjustments to the tracer 
c     species.  The adjustments are based on the relative fluxes between 
c     cell and rain for the regular model species due to wet dep.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol  I number of columns in this slice
c       numrow  I number of rows in this slice
c       numlay  I number of layers in this slice
c       igrd    I grid number
c       icl     I the X grid location of current cell
c       jcl     I the X grid location of current cell
c       kcl     I the vertical grid location of current layer
c       delcls  R change in cell concentration for each tracer class
c       concls  R current cell concentration for each tracer class
c       cytcls  R amount of tracer cycled between air and rain for
c                 each tracer class
c       c0cls   R current rain concentration for each tracer class
c       cellvol R cell volume (m3)
c     Outputs 
c       c0trac  R rain concentration for tracers (umol/m3)
c       tmtrac  R total rain mass for tracers (umol)
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c       04/08/03  --gwilson--   Original development
c       08/15/03  --gyarwood--  Revise adjustments
c       09/20/03  --gwilson--   changes for PSAT
c       10/10/05  --gyarwood--  Revise adjustments
c       12/22/09  --cemery--    Improved treatment of "c0"
c       06/07/16  --cemery--    Removed code related to rain evap
c       02/24/22  --cemery--    Add c0trac for consistency with core model
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer numlay
      integer igrd
      integer icl
      integer jcl
      integer kcl
      integer icls
      real    delcls(*)
      real    concls(*)
      real    cytcls(*)
      real    c0cls(*)
      real    c0trac(*)
      real    tmtrac(*)
      real    cellvol
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      integer*8 idx, idxcel
      real      delrn, delpt
      real      trgas, trpcp, clsgas, clspcp, sumcls
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- calculate the index of the cell in the grid ---
c
      idxcel = DBLE(icl) + DBLE(numcol)*DBLE(jcl-1) + 
     &                       DBLE(numcol)*DBLE(numrow)*DBLE(kcl-1)
c
c   --- adjust the gas each tracer class ----
c
      do icls=1,ntrcls
         delrn = MAX(delcls(icls),0.0)
         delpt = -MIN(delcls(icls),0.0)
         do 20 i=iptcls(icls),nptcls(icls)
            if( .NOT. lsagas(i) ) goto 20
            idx = DBLE(ipsa3d(igrd)-1) + DBLE(idxcel) + 
     &         DBLE(numcol) * DBLE(numrow) * DBLE(numlay) * DBLE(i-1)
            trgas = ptconc(idx)
            trpcp = c0trac(i)
            clsgas = concls(icls)
            clspcp = c0cls(icls)
            clspcp = MAX(clspcp,1E-20)
            ptconc(idx) = trgas
     &                    + delpt*trpcp / clspcp
     &                      - delrn*trgas / clsgas
     &                        - cytcls(icls)*trgas / clsgas
     &                          + cytcls(icls)*(trgas + trpcp) /
     &                                             ( clsgas + clspcp )
            ptconc(idx) = MAX(BNDLPT,ptconc(idx))
            c0trac(i) = trpcp
     &                    - delpt*trpcp / clspcp
     &                      + delrn*trgas / clsgas
     &                        - cytcls(icls)*trpcp / clspcp
     &                          + cytcls(icls)*(trgas + trpcp) /
     &                                            ( clsgas + clspcp )
            c0trac(i) = MAX(BNDLPT,c0trac(i))
            tmtrac(i) = MAX(0.0,tmtrac(i) + cellvol*(c0trac(i)-trpcp))
   20    continue
      enddo
c
c   --- for particulates, make adjustment based on 
c       change in regular model concentration ---
c
      do icls=1,ntrcls
         sumcls = 0.
         do i=iptcls(icls),nptcls(icls)
            idx = DBLE(ipsa3d(igrd)-1) + DBLE(idxcel) + 
     &           DBLE(numcol) * DBLE(numrow) * DBLE(numlay) * DBLE(i-1)
            sumcls = sumcls + ptconc(idx)
         enddo
         if( sumcls .GT. 0 ) then
           do 30 i=iptcls(icls),nptcls(icls)
             if( lsagas(i) ) goto 30
             idx = DBLE(ipsa3d(igrd)-1) + DBLE(idxcel) + 
     &            DBLE(numcol) * DBLE(numrow) * DBLE(numlay) * DBLE(i-1)
             tmtrac(i) = tmtrac(i) + cellvol * delcls(icls) * 
     &                                           ptconc(idx) / sumcls
             ptconc(idx) = ptconc(idx) - 
     &                           delcls(icls) * ptconc(idx) / sumcls
   30      continue
         endif
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 return
      end

c**** RDSRFRT.F
c
      subroutine rdsrfrt(igrd,nox,noy,nspsa,solmas,vegmas)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of surface mass for the RTRAC
c   species. It then places these mass fields in the appropriate 
c   place in the gridded array used for RTRAC soil model.  
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           solmas   R  surface soil mass (mol/ha, g/ha)
c           vegmas   R  surface veg mass (mol/ha, g/ha)
c       Inputs:
c           igrd     I  grid index
c           nox      I  number of X cells in the grid
c           noy      I  number of Y cells in the grid
c           nspsa    I  number of tracer species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     10/29/09   --cemery--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   igrd
      integer   nox
      integer   noy
      integer   nspsa
      real      solmas(nox,noy,nspsa)
      real      vegmas(nox,noy,nspsa)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 aqfil, cfile, cspec
      character*4  ifile(10), note(60), ispec(10)
      integer      ispc, i, j, n
      integer      iseg, nspc, idat1, idat2
      integer      izone, nx, ny, nz, idum, imod
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
      logical      lexist, luse
c
      real srfin(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data aqfil /'AVERAGE'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      iunit = iorrtsrf(igrd)
c
c  --- initailize to lower bound ---
c
      do ispc=1,nspsa
         do j=1,noy
            do i=1,nox
               solmas(i,j,ispc) = 0.
               vegmas(i,j,ispc) = 0.
            enddo
         enddo
      enddo
      if (iunit.eq.0) goto 9999
c
c  --- open the file for this grid ---
c
      inquire(file=rtsrfin(igrd),exist=lexist)
      if( .NOT. lexist ) goto 7000
      open(file=rtsrfin(igrd),unit=iunit,status='UNKNOWN',
     &                                   form='UNFORMATTED',ERR=7001)
c
c  --- read 1st header record and check inputs ---
c
      read(iunit,ERR=7002) ifile,note,iseg,nspc,idat1,tim1,idat2,tim2
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
      endif
c     write(cfile,'(10A1)') (ifile(i),i=1,10)
c     if( cfile .NE. aqfil ) goto 7003
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. begdate .AND. .NOT. le1day ) goto 7004
      if( idat1 .EQ. begdate .AND. tim1 .GT. begtim
     &                              .AND. .NOT. le1day ) goto 7004
c
c  --- read 2nd header record and check inputs ---
c
      read(iunit,ERR=7002) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if( nx .NE. ncol(igrd) .OR. ny .NE. nrow(igrd) 
     &                                .OR. nz .NE. 1 ) goto 7005
c
c  --- skip the next 2 records ---
c
      read(iunit,ERR=7002)
      read(iunit,ERR=7002) 
c
c  --- read the date and time and make sure it is the correct hour ---
c
  111 continue
      read(iunit,ERR=7007,END=7006) idat1, tim1, idat2, tim2
      tim1 = 100*tim1
      tim2 = 100*tim2
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                       idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      if( (idat1 .LT. begdate .OR. 
     &       (idat1 .EQ. begdate .AND. tim1 .LE. begtim)) .AND.
     &            (idat2 .GT. begdate .OR. 
     &                (idat2 .EQ. begdate .AND. tim2 .GT. begtim))) then
c
c  --- read the concentrations for each species ---
c
         do ispc=1,nspc
c
           read(iunit) idum,(ispec(n),n=1,10),
     &                                 ((srfin(i,j),i=1,nx),j=1,ny)
           write(cspec,'(10A1)') ispec
c
c  --- find this species in the RTRAC species list ---
c
           luse = .FALSE.
           do imod=1,ntotsp
              if( cspec(3:) .EQ. ptname(imod) ) then
                  luse = .TRUE.
                  do 20 j=2,ny-1
                     do i=2,nx-1
                        if( srfin(i,j) .GE. 0. ) then
                           if (cspec(1:1) .EQ. 'S') then
                              solmas(i,j,imod) = srfin(i,j)
                           elseif (cspec(1:1) .EQ. 'V') then
                              vegmas(i,j,imod) = srfin(i,j)
                           endif
                        endif
                     enddo
   20             continue
              endif
c
c  --- check the next modeled species ---
c
           enddo
c
c  --- if not found in model species list, write a message ----
c
           if( .NOT. luse ) then
               write(iout,'(1X,4A)') 'Species in RTRAC ',
     &              'surface mass file: ',cspec(:istrln(cspec)),
     &              ' not found in RTRAC species list ... Stopping.'
               call camxerr()
           endif
c
c  --- read next species worth of data ---
c
         enddo
c
c  --- if not the right hour, read through it ---
c
      else
         do ispc=1,nspc
            read(iunit,ERR=7007) 
         enddo
         goto 111
      endif
c
c  --- close the file and return to the calling routine ---
c
      close(iunit)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 
     &   'ERROR:  RTRAC surface mass file does not exist: ',
     &                             rtsrfin(igrd)(:istrln(rtsrfin(igrd)))
      call camxerr()
c
 7001 continue 
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR:  Opening RTRAC surface mass file: ',
     &                             rtsrfin(igrd)(:istrln(rtsrfin(igrd)))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*)'ERROR: Reading header of RTRAC surface mass file: ',
     &                             rtsrfin(igrd)(:istrln(rtsrfin(igrd)))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR:  RTRAC surface mass file is not labelled ',
     &                                                 'AIRQUALITY.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR:  RTRAC surface mass input file is not for ',
     &                                          'correct time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',begdate
      write(iout,'(a,f10.1)') 'Time   : ',begtim
      write(iout,*) '   ***  RTRAC File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR: RTRTAC surface mass input file does not',
     &              ' appear to be for the correct grid.' 
      write(iout,*) '   ***  Grid ***'
      write(iout,*) 'No. of Cells : (',ncol(igrd),',',nrow(igrd),')'
      write(iout,*) 'No. of layers:  ',1
      write(iout,*) '   ***  RTRAC File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR:  Premature end-of-file reached in ',
     &                                  'RTRAC surface mass input file.'
      write(iout,*) 'Make sure the file contains the correct date/time.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDSRFRT:'
      write(iout,*) 'ERROR:  Reading RTRAC surface mass input file: ',
     &                             rtsrfin(igrd)(:istrln(rtsrfin(igrd)))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

c**** NCF_SET_TSTEP
c
      subroutine ncf_set_tstep(begin_date,begin_time,
     &                                       ending_date,ending_time)
      use ncf_iomod
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets the global file attributes for the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         begin_date  I model begin date (YYJJJ)
c         begin_time  R model begin time
c         ending_date I model end date (YYJJJ)
c         ending_time R model end time
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.inc'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer      begin_date
      real         begin_time
      integer      ending_date
      real         ending_time
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer this_date, date_now, num_steps, i
      real    time_now, this_hour, this_min
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c  --- initialize to start of simulation ---
c
c
c  --- initialize to start of simulation ---
c
      ncf_nsteps = 0
      date_now = begin_date
      time_now = begin_time
c
c  --- walk through time as the the simulation would output,
c      this is to figure out how many steps for allocation ---
c
 111  continue
      this_hour = AINT(time_now/100.)
      this_min = AMOD(time_now,100.)
      time_now = 100.*this_hour + this_min
      this_date = date_now
      if(time_now .GE. 2400.) then
        time_now = time_now - 2400.
        this_date = this_date + 1
        if( MOD(this_date,1000) .GT. 365 ) then
           if( MOD(INT(this_date/1000),4) .EQ. 0 ) then
              if( MOD(this_date,1000) .EQ. 367 )
     &                   this_date = (INT(this_date/1000)+1)*1000 + 1
           else
              this_date = (INT(this_date/1000)+1)*1000 + 1
           endif
        endif
      endif
      ncf_nsteps = ncf_nsteps + 1
      call uptime(time_now,date_now,dtout*60.)
      if(this_date .LT. ending_date) goto 111
      if(this_date .EQ. ending_date .AND. 
     &                     time_now .LT. ending_time - 0.01) goto 111
c
c  --- adjust for end of day ---
c
      if( time_now .GT. ending_time ) ncf_nsteps = ncf_nsteps - 1
c
c  --- call routine to allocate allocate the array ----
c
      call ncf_alloc_tstep(ncf_nsteps)
c
c  --- now walk through time again to fill the NetCDF variable ---
c
      num_steps = 0
      date_now = begin_date
      time_now = begin_time
c
c  --- walk through time as the the simulation would output,
c      this is to figure out how many steps for allocation ---
c
 222  continue
      this_hour = AINT(time_now/100.)
      this_min = AMOD(time_now,100.)
      time_now = 100.*this_hour + this_min
      this_date = date_now
      if(time_now .GE. 2400.) then
        time_now = time_now - 2400.
        this_date = this_date + 1
        if( MOD(this_date,1000) .GT. 365 ) then
           if( MOD(INT(this_date/1000),4) .EQ. 0 ) then
              if( MOD(this_date,1000) .EQ. 367 )
     &                   this_date = (INT(this_date/1000)+1)*1000 + 1
           else
              this_date = (INT(this_date/1000)+1)*1000 + 1
           endif
        endif
      endif
      num_steps = num_steps + 1
      if( num_steps .GT. ncf_nsteps ) goto 333
      ncf_tflag(1,num_steps) = 100000*(Start_Date_Hour(1)/100) +
     &                         this_date     
      ncf_tflag(2,num_steps) = time_now*100
      if( num_steps .GT. 1 ) then
         ncf_etflag(1,num_steps-1) = 100000*(Start_Date_Hour(1)/100) +
     &                               this_date
         ncf_etflag(2,num_steps-1) = time_now*100
      endif
      call uptime(time_now,date_now,dtout*60.)
      goto 222
c
c  --- reduce count by 1 because the ending is not a start date/time ---
c
 333  continue
c
c  --- finish with the ending time
c
      if( ncf_nsteps .GT. 0 ) then
         ncf_etflag(1,ncf_nsteps) = 100000*(Start_Date_Hour(1)/100) + ending_date
         ncf_etflag(2,ncf_nsteps) = ending_time*100
      endif
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

      subroutine vd_aer_zhang(z2,zl,z0_f,ustar,diam,rhop,ts,t2,mlu,
     &                        lai_f,vd)
c
c----CAMx v7.40 260801
c 
c     VD_AER_ZHANG is the driver to interface with the dry deposition module
c     of Zhang et al. (2001) developed by the Meteorological Service of Canada.
c     This routine prepares arguments to be used in the module.
c 
c     The DRYVD module considers fractions of multiple land uses.  Since we
c     call DRYVD for a single landuse and weight appropriately in DRYPEP later,
c     the land use fraction set to be 1 for the current land use category.
c
c      Copyright Ramboll
c           
c     Modifications:
c        None
c
c     Input arguments:
c        z2                  reference height (m)
c        zl                  Z/L stability parameter
c        z0_f                surface roughness (m)
c        ustar               friction velocity (m/s)
c        diam                log-mean sectional aerosol diameter (m)
c        rhop                aerosol density (g/m3)
c        ts                  surface temperature (K)
c        t2                  temperature at z2 (K)
c        mlu                 land use index
c        lai_f               Leaf area index
c
c     Output arguments: 
c        vd                  deposition velocity (cm/s)
c             
c     Routines called: 
c        DRYVD_PM
c             
c     Called by: 
c        DRYDEP
c
      implicit none
c
c-----Arguments
c
      integer mlu
      real z2
      real zl
      real z0_f
      real ustar
      real diam
      real rhop
      real ts
      real t2
      real lai_f
      real vd
c
c-----Local variables
c
      real vdp
c
c-----Entry point
c
c-----Call dry deposition velocity algorithm
c
      call dryvd_pm(z2,zl,z0_f,ustar,t2,ts,lai_f,mlu,vdp,diam,rhop)
      vd = vdp
c
      return
      end
C
C=======================================================================
C
      subroutine dryvd_pm(z2,zl,z0_f,ustar,t2,ts,lai_f,mlu,vdp,
     &                    diam,rhoprt)
C
C-----------------------------------------------------------------------
C    References: 
C      Zhang et al.,2001.  Atmos. Environ. 35, 4463-4470
C
C
C     LUC No.     Vegetation type
C     =====       ===============
C       1         water
C       2         ice
C       3         inland lake
C       4         evergreen needleleaf trees
C       5         evergreen broadleaf trees
C       6         deciduous needleleaf trees
C       7         deciduous broadleaf trees
C       8         tropical broadleaf trees
C       9         drought deciduous trees
C       10        evergreen broadleaf shrub
C       11        deciduous shrubs
C       12        thorn shrubs
C       13        short grass and forbs
C       14        long grass
C       15        crops
C       16        rice
C       17        sugar
C       18        maize
C       19        cotton
C       20        irrigated crops
C       21        urban
C       22        tundra
C       23        swamp
C       24        desert
C       25        mixed wood forests
C       26        transitional forest 
C-----------------------------------------------------------------------
C        Key   variables
C-----------------------------------------------------------------------
C  ARGUMENTS:
C  z2       | Met reference height (m)
C  zl       | Z/L stability parameter
C  z0_f     | Surface roughness (m)
C  ustar    | friction velocity (m/s)
C  t2       | Temperature at Z2 (K)
C  ts       | Surface temperature (K)
C  lai_f    | Leaf area index
C  mlu      | Land Use type
C  vdp      | particle dry deposition velocity (m/s)
C  diam     | log-mean sectional aerosol diameter (m)
C  rhoprt   | aerosol density (g/m3)
C
C  LOCAL VARIABLES:
C  ra       | Aerodynamic resistance (s/m)         
C  aest     | parameter for calculating eim 
C  binsize  ! radius of a size bin
C  eb       | Brownian collection efficiency 
C  eim      | impaction collection efficiency 
C  ein      | interception collection efficiency 
C  gama     | parameter for calculating EB 
C  pllp     | leaf dimenision for calculating EIN 
C
C-----------------------------------------------------------------------
C
      implicit none
c 
      include 'camx.prm'
      include 'deposit.inc'
c
c-----Arguments
c
      integer mlu
      real z2
      real zl
      real z0_f
      real ustar
      real t2
      real ts
      real vdp
      real diam
      real rhoprt
      real lai_f
c
c-----Local variables
c      
      integer i
      real aa1,aa2,aa3,amfp,roarow,boltzk,rhop,dair,dh2o,ra,pllp,
     &     binsize,tave,amu,anu,prii,priiv,vphil,cfac,taurel,amob,diff,
     &     schm,pdepv,st,eb,eim,ein,r1,rs,vdsize
      real aest(NLUZ03), pllp1(NLUZ03), pllp2(NLUZ03), gama(NLUZ03)
C
C   Parameters for collection efficiency 
C   PLLP1 and PLLP2 are minimum and maximum leaf dimension for each LUC. 
C
      data   aest       /
     & 100. , 50.  , 100. ,  1.0 ,  0.8 ,  
     &  1.1 , 0.8  ,  0.6 ,  1.0 ,  1.1 ,
     &  1.1 , 1.2  ,  1.2 ,  1.2 ,  1.2 ,
     &  1.2 , 1.2  ,  1.1 ,  1.2 ,  1.2 ,
     &  1.5 , 50.  ,  2.0 ,  50. ,  0.8 ,
     &  0.8         /
      data   gama       /
     &  0.5 , 0.54 ,  0.5 , 0.56 , 0.56 ,
     & 0.56 , 0.56 , 0.58 , 0.56 , 0.55 ,
     & 0.55 , 0.54 , 0.54 , 0.55 , 0.54 ,
     & 0.54 , 0.54 , 0.55 , 0.54 , 0.54 ,
     & 0.56 , 0.54 , 0.54 , 0.54 , 0.56 ,
     & 0.56        / 
      data   pllp1         /
     & -0.9 , -0.9 , -0.9 ,  2.0 ,  5.0 ,
     &  2.0 ,  5.0 ,  5.0 ,  5.0 ,  5.0 ,
     &  5.0 ,  2.0 ,  2.0 ,  2.0 ,  2.0 ,
     &  2.0 ,  5.0 ,  5.0 ,  5.0 ,  2.0 ,
     & 10.0 , -0.9 , 10.0 , -0.9 ,  5.0 ,
     &  5.0        /
      data   pllp2         /
     & -0.9 , -0.9 , -0.9 ,  2.0 ,  5.0 ,
     &  5.0 , 10.0 ,  5.0 , 10.0 ,  5.0 ,
     & 10.0 ,  5.0 ,  5.0 ,  5.0 ,  5.0 ,
     &  5.0 , 10.0 , 10.0 , 10.0 ,  5.0 ,
     & 10.0 , -0.9 , 10.0 , -0.9 ,  5.0 ,
     &  5.0        /
C
C ---  parameters for air dynamic properties 
      data aa1/1.257/, aa2/0.4/, aa3/1.1/
      data amfp /6.53E-8/, roarow/1.19/,
     &     boltzk/1.3806044503487214E-23/   
c
c --- Particle density
      RHOP = rhoprt * 1.0E-3 ! convert a unit from g/m3 to kg/m3

C   Some constants 
C
      dair=0.369*29.+6.29  
      dh2o=0.369*18.+6.29

      VDP = 0.0
      I = MLU
C
C     Aerodynamic resistance above canopy
C
      IF(ZL.GE.0.) THEN
          Ra=(.74*ALOG(Z2/Z0_F)+4.7*ZL)/0.4/USTAR 
      ELSE
          Ra=0.74/0.4/USTAR*(ALOG(Z2/Z0_F)-
     &          2*ALOG((1+SQRT(1-9.*ZL))*0.5))
      ENDIF
      Ra=amax1(RA,5.0)
      if (I.EQ.1.OR.I.EQ.3) THEN
        Ra=amin1(RA,2000.)
      else
        Ra=amin1(RA,1000.)
      end if 
C
C Loop 150 for particle species 
C
      if (lai_ref(I,15).EQ.lai_ref(I,14)) then
        PLLP = PLLP2(I)
      else
        PLLP = PLLP2(I)-(LAI_F-lai_ref(I,14))/(lai_ref(I,15)
     &           -lai_ref(I,14)+1.E-10)*(PLLP2(I)-PLLP1(I)) 
      endif 
      BINSIZE = diam/2.   ! radius, m

      TAVE=0.5*(T2+TS)
C
C     * AIR'S DYNAMIC VISCOSITY
C
      AMU=145.8*1.E-8*TAVE**1.5/(TAVE+110.4)
C
C     * AIR'S KINEMATIS VISCOSITY
C
      ANU=AMU/ROAROW
C
C     * CUNNINGHAM SLIP CORRECTION FACTOR AND RELAXATION TIME = vg/Grav.
C
      PRII=2./9.*9.81/AMU
      PRIIV=PRII*(RHOP-ROAROW)
      VPHIL=0.
      CFAC=1.+AMFP/BINSIZE*(AA1+AA2*EXP(-AA3*BINSIZE/AMFP))
      TAUREL=AMAX1(PRIIV*BINSIZE**2*CFAC/9.81,0.0)
C
C     * STOKES FRICTION AND DIFFUSION COEFFICIENTS.
C
      AMOB=6.*3.14*AMU*BINSIZE/CFAC
      DIFF=BOLTZK*TAVE/AMOB
      SCHM=ANU/DIFF
C
C     * GRAVITATIONAL SETTLING VELOCITY.
C
      PDEPV =TAUREL*9.81
C
C     * Efficiency by diffusion, impaction, interception and particle rebound.
C
      if (PLLP .le. 0.) then ! smooth surface
         St=TAUREL*USTAR*USTAR/ANU
      else ! vegetated surface
         St=TAUREL*USTAR/PLLP*1000.
      end if
      EB= SCHM**(-gama(I)) 
      EIM=( St/(St+AEST(I)))**2
      EIN=0.0
      if (PLLP .gt. 0.00) THEN
         EIN=(1000.*2.*BINSIZE/PLLP)**2*0.5 
      end if
      R1= EXP(-ST**0.5)
      IF (R1.LT.0.5) R1=0.5
      RS= 1./3./USTAR/(EB+EIM+EIN)/R1
C
C -- Deposition velocity 
C
      VDSIZE = PDEPV + 1./(RA+RS) 
      VDP = VDSIZE 

      RETURN
      END

      subroutine vbschem(iout,tempk,press,dthr,
     &                   avgox,cprec,cCG,cCGH)
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine solves the oxidation reactions for SOA precursors
c     assuming first-order decay and constant oxidant concentrations
c
c
c     Rate constant:
c        k = A exp(-E/T)                     ; A [cm3/molecule-sec] @ E [K]
c
c      Copyright Ramboll
c
c     Input arguments:
c        iout     standard output file unit
c        tempk    cell temperature [K]
c        press    cell pressure [mb]
c        dthr     time duration to be integrated [hr]
c        avgox    average oxidant concentrations [ppm]
c                 1 - O; 2 - OH; 3 - O3; 4 - NO3; 5 - NO; 6 - HO2
c        cprec    precursor concentrations [ppm]
c                 1 - BNZA; 2 - TOLA; 3 - XYLA; 4 - ISP; 5 - TRP; 6 - SQT;
c                 7 - IVOG; 8 - IVOD; 9 - IVOA;10 - IVOB; 11 - IVC1; 12 - IVC2
c                 
c        cCG      volatile VBS species concentrations [ppm]
c                 1 - VAS1; 5 - VBS1;  9 - VAP1; 13 - VCP1; 17 - VFP1;
c                 2 - VAS2; 6 - VBS2; 10 - VAP2; 14 - VCP2; 18 - VFP2;
c                 3 - VAS3; 7 - VBS3; 11 - VAP3; 15 - VCP3; 19 - VFP3;
c                 4 - VAS4; 8 - VBS4; 12 - VAP4; 16 - VCP4; 20 - VFP4
c        cCGH     non-volatile VBS species concentrations [ppm]
c                 1 - VAS0; 2 - VBS0;  3 - VAP0;  4 - VCP0;  5 - VFP0
c
c     Output arguments:
c        cprec    precursor concentrations [ppm]
c        cCG      volatile VBS species concentrations [ppm]
c        cCGH     non-volatile VBS species concentrations [ppm]
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     12/07/14  --bkoo--  Modified for VBS from SOACHEM
c     01/08/16  --bkoo--  Updated for Revised VBS
c     08/25/16  --bkoo--  Switched from VBS.INC to SOAP.INC
c     11/28/16  --bkoo--  Revised VBS precursors & reaction rates
c
c-----------------------------------------------------------------------
c
      implicit none
      include 'soap.inc'

      integer :: iout
      real    :: tempk,press,dthr
      real    :: avgox(NOXID),cprec(NPREC_V),cCG(NVBS*NSET),cCGH(NSET)

      integer, parameter :: nrxn = 27

      integer, parameter :: idO   = 1, idOH  = 2, idO3  = 3,
     &                      idNO3 = 4, idNO  = 5, idHO2 = 6

      integer, parameter :: idBNZA =  1, idTOLA =  2,
     &                      idXYLA =  3, idISP  =  4,
     &                      idTRP  =  5, idSQT  =  6,
     &                      idIVOG =  7, idIVOD =  8,
     &                      idIVOA =  9, idIVOB = 10,
     &                      idIVC1 = 10, idIVC2 = 11

      real, parameter    :: eps = 1.e-12

      real*8, parameter  :: rkpar(2,nrxn) = reshape( ! rate constant parameters
c                       A         E
     &           (/ 2.30d-12,  190.0d0,    ! rxn  1  BNZA + OH
     &              1.80d-12, -340.0d0,    ! rxn  2  TOLA + OH
     &              1.85d-11,    0.0d0,    ! rxn  3  XYLA + OH
     &              2.70d-12, -360.0d0,    ! rxn  4  ARO-O2 + NO
     &              1.90d-13,-1300.0d0,    ! rxn  5  ARO-O2 + HO2
c
     &              2.70d-11, -390.0d0,    ! rxn  6  ISP + OH
     &              1.03d-14, 1995.0d0,    ! rxn  7  ISP + O3
     &              3.03d-12,  448.0d0,    ! rxn  8  ISP + NO3
     &              2.39d-12, -365.0d0,    ! rxn  9  ISP-O2 + NO
     &              7.43d-13, -700.0d0,    ! rxn 10  ISP-O2 + HO2
c
     &              1.50d-11, -449.0d0,    ! rxn 11  TRP + OH
     &              1.20d-15,  821.0d0,    ! rxn 12  TRP + O3
     &              3.70d-12, -175.0d0,    ! rxn 13  TRP + NO3
     &              8.80d-13, -180.2d0,    ! rxn 14  TRP-O2 + NO
     &              4.10d-13, -790.0d0,    ! rxn 15  TRP-O2 + HO2
c
     &              1.97d-10,    0.0d0,    ! rxn 16  SQT + OH
     &              1.16d-14,    0.0d0,    ! rxn 17  SQT + O3
     &              1.90d-11,    0.0d0,    ! rxn 18  SQT + NO3
c
     &              4.00d-11,    0.0d0,    ! rxn 19  IVOG + OH
     &              4.00d-11,    0.0d0,    ! rxn 20  IVOD + OH
     &              4.00d-11,    0.0d0,    ! rxn 21  IVOA + OH - temporary
     &              4.00d-11,    0.0d0,    ! rxn 22  IVOB + OH
     &              4.00d-11,    0.0d0,    ! rxn 23  IVC1 + OH - temporary
     &              4.00d-11,    0.0d0,    ! rxn 24  IVC2 + OH - temporary
c
     &              2.00d-11,    0.0d0,    ! rxn 25  VAS? + OH
     &                 0.0d0,    0.0d0,    ! rxn 26  VBS? + OH
     &              4.00d-11,    0.0d0,    ! rxn 27  VAP? + OH
     &              4.00d-11,    0.0d0,    ! rxn 28  VCP? + OH
     &              4.00d-11,    0.0d0 /), ! rxn 29  VFP? + OH
     &           (/ 2, nrxn /) )

      real, parameter    :: yh(0:nvbs,NPREC_V) = reshape( ! high-NOx yield [ppm/ppm]
c                    bin0   bin1   bin2   bin3   bin4
     &           (/ 0.0  , 0.001, 0.079, 0.148, 0.222,    ! BNZA
     &              0.0  , 0.006, 0.145, 0.281, 0.432,    ! TOLA
     &              0.0  , 0.001, 0.127, 0.201, 0.301,    ! XYLA
     &              0.0  , 0.0  , 0.009, 0.006, 0.0  ,    ! ISP
     &              0.0  , 0.010, 0.101, 0.173, 0.451,    ! TRP
     &              0.0  , 0.092, 0.188, 0.968, 0.679,    ! SQT  - NOx-independent
     &              0.022, 0.098, 0.373, 0.699, 0.0  ,    ! IVOG - NOx-independent
     &              0.081, 0.135, 0.800, 0.604, 0.0  ,    ! IVOD - NOx-independent
     &              0.0  , 0.111, 0.523, 0.0  , 0.0  ,    ! IVOA - NOx-independent - temporary
     &              0.081, 0.135, 0.800, 0.604, 0.0  ,    ! IVOB - NOx-independent
     &              0.0369,0.0025,0.0934,0.1705,0.0  ,    ! IVC1 - NOx-independent - temporary
     &              0.0737,0.0050,0.1867,0.3409,0.0  /),  ! IVC2 - NOx-independent - temporary
     &           (/ nvbs+1, NPREC_V /) )

      real, parameter    :: yl(0:nvbs,NPREC_V) = reshape( ! low-NOx yield [ppm/ppm]
c                    bin0   bin1   bin2   bin3   bin4
     &           (/ 0.0  , 0.035, 0.108, 0.185, 0.268,    ! BNZA
     &              0.0  , 0.006, 0.145, 0.437, 0.281,    ! TOLA
     &              0.0  , 0.048, 0.195, 0.252, 0.364,    ! XYLA
     &              0.0  , 0.004, 0.013, 0.006, 0.0  ,    ! ISP
     &              0.0  , 0.087, 0.077, 0.309, 0.540,    ! TRP
     &              0.0  , 0.092, 0.188, 0.968, 0.679,    ! SQT  - NOx-independent
     &              0.022, 0.098, 0.373, 0.699, 0.0  ,    ! IVOG - NOx-independent
     &              0.081, 0.135, 0.800, 0.604, 0.0  ,    ! IVOD - NOx-independent
     &              0.0  , 0.111, 0.523, 0.0  , 0.0  ,    ! IVOA - NOx-independent - temporary
     &              0.081, 0.135, 0.800, 0.604, 0.0  ,    ! IVOB - NOx-independent
     &              0.0369,0.0025,0.0934,0.1705,0.0  ,    ! IVC1 - NOx-independent - temporary
     &              0.0737,0.0050,0.1867,0.3409,0.0  /),  ! IVC2 - NOx-independent - temporary
     &           (/ nvbs+1, NPREC_V /) )

      real, parameter    :: yy2(0:nvbs) =               ! TRP + NO3 yield [ppm/ppm]
c                    bin0   bin1   bin2   bin3   bin4
     &           (/ 0.314, 0.029, 0.0  , 0.862, 0.0   /)

      real, parameter    :: ya(2,nvbs) = reshape( ! yield for VAP aging
c                     VAS    VAP
     &           (/ 0.142, 0.864,    ! bin0
     &              0.129, 0.877,    ! bin1
     &              0.116, 0.889,    ! bin2
     &              0.137, 0.869 /), ! bin3
     &           (/ 2, nvbs /) )

      real, parameter    :: yf(2,nvbs) = reshape( ! yield for VFP aging
c                     VBS    VFP
     &           (/ 0.464, 0.538,    ! bin0
     &              0.313, 0.689,    ! bin1
     &              0.220, 0.783,    ! bin2
     &              0.156, 0.846 /), ! bin3
     &           (/ 2, nvbs /) )

c     [1/ppm-hr] = [cm3/molecule-sec]*3600*(6.022e23*1.e-12/8.314)*(P[Pa]/T[K])
      real*8, parameter  :: cf0 = 2.608d14 ! 3600*(6.022e23*1.e-12/8.314)
      real*8  :: cfac

      real    :: cVAS(0:nvbs),cVBS(0:nvbs),
     &           cVAP(0:nvbs),cVCP(0:nvbs),cVFP(0:nvbs)
      real    :: rktmp(nrxn), rk1(NOXID), rh, rl, rr, rr2, sumk, dprec
      real    :: fage, cfrac
      integer :: i, j, k, nchk, iprec

      logical, save :: lfirsttime = .true.
c
c-----Check consistency
c
!      if (lfirsttime) then
!        lfirsttime = .false.
!      endif
c
c-----Load VBS species
c
      cVAS(0) = 0.0
      cVBS(0) = 0.0
      cVAP(0) = 0.0
      cVCP(0) = 0.0
      cVFP(0) = 0.0
      do j = 1, nvbs
        cVAS(j) = cCG(j)
        cVBS(j) = cCG(j+nvbs)
        cVAP(j) = cCG(j+2*nvbs)
        cVCP(j) = cCG(j+3*nvbs)
        cVFP(j) = cCG(j+4*nvbs)
      enddo
c
c-----Conversion factor for rate constants
c
      cfac = cf0 * DBLE(press*100./tempk) ! [1/ppm-hr] = cfac * [cm3/molecule-sec]
c
c-----Rate constants in [1/ppm-hr]
c
      do i = 1, nrxn
        rktmp(i) = SNGL( rkpar(1,i)*dexp(-rkpar(2,i)/DBLE(tempk))*cfac )
      enddo
c
c-----Photochemical againg
c
      ! VAS?
      rk1(idOH ) = rktmp(23) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      do j = 1, nvbs
        dprec = cVAS(j) * cfrac
        if (dprec.gt.eps) then
          cVAS(j-1) = cVAS(j-1) + dprec
          cVAS(j)   = cVAS(j)   - dprec
        endif
      enddo
      ! VBS?
      rk1(idOH ) = rktmp(24) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      do j = 1, nvbs
        dprec = cVBS(j) * cfrac
        if (dprec.gt.eps) then
          cVBS(j-1) = cVBS(j-1) + dprec
          cVBS(j)   = cVBS(j)   - dprec
        endif
      enddo
      ! VAP?
      rk1(idOH ) = rktmp(25) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      do j = 1, nvbs
        dprec = cVAP(j) * cfrac
        if (dprec.gt.eps) then
          cVAS(j-1) = cVAS(j-1) + dprec * ya(1,j)
          cVAP(j-1) = cVAP(j-1) + dprec * ya(2,j)
          cVAP(j)   = cVAP(j)   - dprec
        endif
      enddo
      ! VCP?
      rk1(idOH ) = rktmp(26) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      do j = 1, nvbs
        dprec = cVCP(j) * cfrac
        if (dprec.gt.eps) then
          cVBS(j-1) = cVBS(j-1) + dprec * ya(1,j)
          cVCP(j-1) = cVCP(j-1) + dprec * ya(2,j)
          cVCP(j)   = cVCP(j)   - dprec
        endif
      enddo
      ! VFP?
      rk1(idOH ) = rktmp(27) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      do j = 1, nvbs
        dprec = cVFP(j) * cfrac
        if (dprec.gt.eps) then
          cVBS(j-1) = cVBS(j-1) + dprec * yf(1,j)
          cVFP(j-1) = cVFP(j-1) + dprec * yf(2,j)
          cVFP(j)   = cVFP(j)   - dprec
        endif
      enddo
c
c-----NOx-dependent pathways for aromatics
c
      rh = rktmp(4) * avgox(idNO )
      rl = rktmp(5) * avgox(idHO2)
      rh = rh / (rh + rl)
      rl = 1.0 - rh
      ! BNZA
      rk1(idOH ) = rktmp(1) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idBNZA) * cfrac
      if (dprec.gt.eps) then
        cprec(idBNZA) = cprec(idBNZA) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec *
     &              ( yh(j,idBNZA)*rh + yl(j,idBNZA)*rl )
        enddo
      endif
      ! TOLA
      rk1(idOH ) = rktmp(2) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idTOLA) * cfrac
      if (dprec.gt.eps) then
        cprec(idTOLA) = cprec(idTOLA) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec *
     &              ( yh(j,idTOLA)*rh + yl(j,idTOLA)*rl )
        enddo
      endif
      ! XYLA
      rk1(idOH ) = rktmp(3) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idXYLA) * cfrac
      if (dprec.gt.eps) then
        cprec(idXYLA) = cprec(idXYLA) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec *
     &              ( yh(j,idXYLA)*rh + yl(j,idXYLA)*rl )
        enddo
      endif
c
c-----NOx-dependent pathways for isoprene
c
      rh = rktmp( 9) * avgox(idNO )
      rl = rktmp(10) * avgox(idHO2)
      rh = rh / (rh + rl)
      rl = 1.0 - rh

      rk1(idOH ) = rktmp(6) * avgox(idOH )
      rk1(idO3 ) = rktmp(7) * avgox(idO3 )
      rk1(idNO3) = rktmp(8) * avgox(idNO3)
      sumk = rk1(idOH ) + rk1(idO3 ) + rk1(idNO3)
      cfrac = 1. - exp(-sumk*dthr)
      dprec = cprec(idISP ) * cfrac
      if (dprec.gt.eps) then
        cprec(idISP ) = cprec(idISP ) - dprec
        do j = 0, nvbs
          cVBS(j) = cVBS(j) + dprec *
     &              ( yh(j,idISP )*rh + yl(j,idISP )*rl )
        enddo
      endif
c
c-----NOx-dependent pathways for monoterpenes
c
      rh = rktmp(14) * avgox(idNO )
      rl = rktmp(15) * avgox(idHO2)
      rh = rh / (rh + rl)
      rl = 1.0 - rh

      rk1(idOH ) = rktmp(11) * avgox(idOH )
      rk1(idO3 ) = rktmp(12) * avgox(idO3 )
      rk1(idNO3) = rktmp(13) * avgox(idNO3)
      sumk = rk1(idOH ) + rk1(idO3 ) + rk1(idNO3)
      rr2 = rk1(idNO3) / sumk
      rr = 1. - rr2
      cfrac = 1. - exp(-sumk*dthr)
      dprec = cprec(idTRP ) * cfrac
      if (dprec.gt.eps) then
        cprec(idTRP ) = cprec(idTRP ) - dprec
        do j = 0, nvbs
          cVBS(j) = cVBS(j) + dprec * rr *
     &              ( yh(j,idTRP )*rh + yl(j,idTRP )*rl )
          cVBS(j) = cVBS(j) + dprec * rr2 * yy2(j)
        enddo
      endif
c
c-----NOx-independent pathways for sesquiterpenes
c
      rk1(idOH ) = rktmp(16) * avgox(idOH )
      rk1(idO3 ) = rktmp(17) * avgox(idO3 )
      rk1(idNO3) = rktmp(18) * avgox(idNO3)
      sumk = rk1(idOH ) + rk1(idO3 ) + rk1(idNO3)
      dprec = cprec(idSQT ) * ( 1. - exp(-sumk*dthr) )
      if (dprec.gt.eps) then
        cprec(idSQT ) = cprec(idSQT ) - dprec
        do j = 0, nvbs
          cVBS(j) = cVBS(j) + dprec * yh(j,idSQT )
        enddo
      endif
c
c-----NOx-independent pathways for IVOC
c
      ! IVOG
      rk1(idOH ) = rktmp(19) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idIVOG) * cfrac
      if (dprec.gt.eps) then
        cprec(idIVOG) = cprec(idIVOG) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec * yh(j,idIVOG)
        enddo
      endif
      ! IVOD
      rk1(idOH ) = rktmp(20) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idIVOD) * cfrac
      if (dprec.gt.eps) then
        cprec(idIVOD) = cprec(idIVOD) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec * yh(j,idIVOD)
        enddo
      endif
      ! IVOA
      rk1(idOH ) = rktmp(21) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idIVOA) * cfrac
      if (dprec.gt.eps) then
        cprec(idIVOA) = cprec(idIVOA) - dprec
        do j = 0, nvbs
          cVAS(j) = cVAS(j) + dprec * yh(j,idIVOA)
        enddo
      endif
      ! IVOB
      rk1(idOH ) = rktmp(22) * avgox(idOH )
      cfrac = 1. - exp(-rk1(idOH )*dthr)
      dprec = cprec(idIVOB) * cfrac
      if (dprec.gt.eps) then
        cprec(idIVOB) = cprec(idIVOB) - dprec
        do j = 0, nvbs
          cVBS(j) = cVBS(j) + dprec * yh(j,idIVOB)
        enddo
      endif
c
c-----Put VBS species back
c
      cCGH(1) = cVAS(0)
      cCGH(2) = cVBS(0)
      cCGH(3) = cVAP(0)
      cCGH(4) = cVCP(0)
      cCGH(5) = cVFP(0)
      do j = 1, nvbs
        cCG(j)        = cVAS(j)
        cCG(j+nvbs)   = cVBS(j)
        cCG(j+2*nvbs) = cVAP(j)
        cCG(j+3*nvbs) = cVCP(j)
        cCG(j+4*nvbs) = cVFP(j)
      enddo

      return
      end

      subroutine hr_nxy3(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_NXY3 solves NO3 and N2O5 using Hertel's equations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CB6r5h plus GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real self, fwd, bck
      real newNO3, lsNO3, lsN2O5, A, B, C, Q
c
c --- Entry Point
c
      N2 = M - O2
c
c
c --- New NO3 excluding from N2O5
c
      newNO3 = dt*(0.0
     &       +          r(  6)
     &       +          r( 26)
     &       +          r( 46)
     &       + ( 0.410)*r( 50)
     &       + ( 0.400)*r( 56)
     &       + ( 0.400)*r( 64)
     &       + ( 0.185)*r(163)
     &       +          r(223)
     &       +          r(249)
     &       + ( 0.850)*r(301) )
c
c --- Loss of NO3 excluding self-reaction(s)
c
      lsNO3 = 1.0 + dt*(0.0
     &       +          rk( 27)
     &       +          rk( 28)
     &       +          rk( 29)*yh(lNO)
     &       +          rk( 30)*yh(lNO2)
     &       +          rk( 31)*yh(lO)
     &       +          rk( 32)*yh(lOH)
     &       +          rk( 33)*yh(lHO2)
     &       +          rk( 34)*yh(lO3)
     &       +          rk( 36)*yh(lNO2)
     &       +          rk( 99)*yh(lFORM)
     &       +          rk(105)*yh(lALD2)
     &       +          rk(108)*yh(lALDX)
     &       +          rk(112)*yh(lGLYD)
     &       +          rk(115)*yh(lGLY)
     &       +          rk(117)*yh(lMGLY)
     &       +          rk(136)*yh(lETH)
     &       +          rk(139)*yh(lOLE)
     &       +          rk(142)*yh(lIOLE)
     &       +          rk(150)*yh(lISOP)
     &       +          rk(153)*yh(lISPD)
     &       +          rk(157)*yh(lHPLD)
     &       +          rk(166)*yh(lTERP)
     &       +          rk(183)*yh(lCRES)
     &       +          rk(187)*yh(lCRON)
     &       +          rk(192)*yh(lXOPN)
     &       +          rk(196)*yh(lOPEN)
     &       +          rk(198)*yh(lCAT1)
     &       +          rk(233)*yh(lDMS)
     &       +          rk(290)*yh(lBR) )
c
c --- Loss of N2O5
c
      lsN2O5  = 1.0 + dt*(0.0
     &       +          rk( 37)
     &       +          rk( 38)
     &       +          rk( 39)*H2O
     &       +          rk(251)*yh(lHCL) )
c
c --- Forward reactions of NO3 to N2O5
c
      fwd  = dt*(0.0
     &       +          rk( 36)*yh(lNO2) )
c
c --- Backward reactions of N2O5 to NO3
c
      bck  = dt*(0.0
     &       +          rk( 37)
     &       +          rk( 38) )
c
c --- NO3 self-reaction excluding N2O5 production
c
      self = dt*(0.0
     &       + ( 2.000)*rk( 35) )
c
c --- Solve for NO3
c
      A = self*lsN2O5
      B = (lsN2O5*lsNO3) - (fwd*bck)
      C = lsN2O5*( y0(lNO3) + newNO3 ) + bck*y0(lN2O5)
      Q = -0.5 * ( B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C) )
c
c --- Update Concentrations
c
      y1(lNO3)  = MAX(1.0E-18, MAX(Q/A, -C/Q) )
      y1(lN2O5) = MAX(1.0E-15, (y0(lN2O5) + fwd*y1(lNO3)) / lsN2O5 )
c
      return
      end

      subroutine pnt_update()
      use filunit
      use grid
      use chmstry
      use bndary
      use ptemiss
      use tracer
c 
c----CAMx v7.40 260801
c 
c     PNT_UPDATE updates indexing of points of point sources and
c     the grid locations. This is needed because sources may have been
c     added in probing tools files.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        RDPTHDR
c        GEOPSP 
c             
c     Called by: 
c        STARTUP 
c 
      include 'camx.prm'
      include 'flags.inc'

      integer ifle, icount
c
      integer indxpt(MXPTSRC)
      integer count_zero, count_outside, count_edge
c
c-----Entry point
c
c-----Coarse grid
c
      if (llatlon) then
        do n = 1,nptsrc
          xstk(n,1) = xloc(n) - xorg
          ystk(n,1) = yloc(n) - yorg
        enddo
      else
        do n = 1,nptsrc
          xstk(n,1) = xloc(n)/1000. - xorg
          ystk(n,1) = yloc(n)/1000. - yorg
        enddo
      endif
c
      count_zero = 0
      count_outside = 0
      count_edge = 0
      do 30 n=1,nptsrc
        ii = 1 + FLOOR(xstk(n,1)/delx)
        jj = 1 + FLOOR(ystk(n,1)/dely)
        isrc(n,1) = ii
        jsrc(n,1) = jj
        indxpt(n) = 1
        if (abs(dstk(n)) .LT. 0.01 .OR. abs(hstk(n)) .LT. 0.01 .OR.
     &                                     abs(vstk(n)) .LT. 0.01 ) then
          count_zero = count_zero + 1
       endif
c
c-----Note sources outside domain
c
        if (ii.lt.1 .or. ii.gt.ncol(1) .or. jj.lt.1 .or.
     &                               jj.gt.nrow(1)) then
          count_outside = count_outside + 1 
          indxpt(n) = 0
        elseif (ii.le.1 .or. ii.ge.ncol(1) .or.
     &                 jj.le.1 .or. jj.ge.nrow(1)) then
          count_edge = count_edge + 1 
          indxpt(n) = 0
        endif
 30   continue
c
c --- Write a summary of "suspect" sources ---
c
      if( count_zero .GT. 0 ) then
          write(idiag,'(2A,I10)') 'Number of sources found with ',
     &                                    'zero stack parameters: ',count_zero
          write(idiag,'(2A,/,3A20,/,3(13X,F5.3))') 'Zero stack parameters ',
     &                 'are replaced with defaults:','Height (m)','Diameter (m)',
     &                                        '   Exit Velo (m/s)',1.0, 0.1, 0.1
      endif
      if( count_outside .GT. 0 ) then
          write(idiag,'(/,2A,I10)') 'Number of sources found ',
     &                            'that are outside the domain: ',count_outside
          write(idiag,'(A)') 'These sources will be skipped.'
      endif
      if( count_edge .GT. 0 ) then
          write(idiag,'(/,2A,I10)') 'Number of sources found that ',
     &                            'are located in an edge cell: ',count_edge
          write(idiag,'(A)') 'These sources will be skipped.'
      endif
c
c-----Map source to coarse grid
c
      nsrc = 0
      do n=1,nptsrc
        if (indxpt(n).eq.1) then
          nsrc = nsrc + 1
          idsrc(nsrc,1) = n
          isrc(nsrc,1) = isrc(n,1) 
          jsrc(nsrc,1) = jsrc(n,1) 
        endif
      enddo
      nosrc(1) = nsrc
c
c-----Fine grids
c
      do igrd = 2,ngrid
        nsrc = 0
        do n = 1,nptsrc
          if (indxpt(n).eq.1) then
            xstk(n,igrd) = xstk(n,1) - (inst1(igrd) - 1)*delx
            ystk(n,igrd) = ystk(n,1) - (jnst1(igrd) - 1)*dely
            ii = 2 + FLOOR(xstk(n,igrd)/delx*FLOAT( meshold(igrd) ) )
            jj = 2 + FLOOR(ystk(n,igrd)/dely*FLOAT( meshold(igrd) ) )
c
            if (ii.gt.1 .and. ii.lt.ncol(igrd) .and.
     &          jj.gt.1 .and. jj.lt.nrow(igrd)) then
              nsrc = nsrc + 1
              idsrc(nsrc,igrd) = n
              isrc(nsrc,igrd) = ii
              jsrc(nsrc,igrd) = jj
            endif
          endif
          nosrc(igrd) = nsrc
        enddo
      enddo
c
      write(idiag,*)
      do igrd = 1,ngrid
        write(idiag,*) 'Point sources in grid #',igrd,' = ',nosrc(igrd)
      enddo
      write(idiag,*)
c
      return
      end

C**** NCF_READCNC
c
      subroutine ncf_readcnc()
      use camxfld
      use filunit
      use grid
      use chmstry
      implicit none
c 
c     
c----CAMx v7.40 260801
c
c     This routine reads the NetCDF initial conditions file and 
c     puts the concentrations in the gridded array for instantaneous
c     concentrations.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c  
c     Input arguments: 
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
      include 'camx.inc'
      include 'netcdf.inc'
c
      integer ncf_get_tstep
c
      character*200 action
      integer       data_start(4), data_count(4), ispc, i, j, k, l
      integer       this_varid, iunit, nx, ny, nz, n3d, n4d, igrd
      integer       ierr, ig, ip, ic, this_tstep
      integer       iicdate_time_tflag, iicdate_time_etflag
      real          convfac
c
      real, allocatable, dimension(:,:,:) :: cinit
c
      integer istrln
c
c-----Entry point
c
      iunit = iic
      nx = ncol(1)
      ny = nrow(1)
      nz = nlay(1)
      data_start(1) = 1
      data_count(1) = nx
      data_start(2) = 1
      data_count(2) = ny
      data_start(3) = 1
      data_count(3) = nz
c
c   --- get the timestep that encompasses this date/time ---
c
      if( is_netcdf_iic ) then
         action = 'Reading initial conditions file.'
         this_tstep = ncf_get_tstep(iic,action,begdate,begtim,
     &          iicdate_time_tflag,iicdate_time_etflag,.FALSE.,.TRUE.)
         data_start(4) = this_tstep
         data_count(4) = 1
      endif
c
c  ---- allocate the temp array ---
c
      allocate( cinit(nx,ny,nz) )
c
c  ---- loop over model species and skip if not in the IC file ---
c
      do ispc=1,nspec
c
c  --- initialize to lower bound ---
c
         do k=1,nz
           do j = 1,NY
             do i = 1,nx
                n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                n4d = n3d + nx*ny*nz*(ispc - 1)
                conc(n4d) = bdnl(ispc)
             enddo
           enddo
         enddo
c
c  --- skip if species not in file ---
c
         if( licmap(ispc) .LE. 0 ) cycle
         this_varid = licmap(ispc)
c
c  ---- load this species into local array ---
c
         ierr = nf_get_vara_real(iunit,this_varid,data_start,data_count,cinit)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_READCNC:'
           write(iout,*)'Cannot read initial conditions data for speices: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c  ---- put concs into the global array at correct offset --- 
c
         do k=1,nz
           do j = 1,ny
             do i = 1,nx
                n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                n4d = n3d + nx*ny*nz*(ispc - 1)
                conc(n4d) = bdnl(ispc)
                conc(n4d) = amax1(conc(n4d),cinit(i,j,k))
             enddo
           enddo
         enddo
      enddo
c
c----- Interpolate coarse grid concentrations to all fine grids ----
c
      if( ngrid .GT. 1 ) then
          do ip = 1,ngrid
            do ic = 1,nchdrn(ip)
              ig = idchdrn(ic,ip)
              call intrpcnc(nspec,ncol(ip),nrow(ip),nlay(ip),i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                      conc(iptr4d(ip)),conc(iptr4d(ig)) )
            enddo
          enddo
      endif
c
c-----Convert from ppm to umol/m3
c
      do igrd = 1,ngrid
        nx = ncol(igrd)
        ny = nrow(igrd)
        nz = nlay(igrd)
        do l = 1,nspec
          do k = 1,nz
            do j = 1,ny
              do i = 1,nx
                n3d = i + nx*(j - 1) + nx*ny*(k - 1)
                n4d = n3d + nx*ny*nz*(l - 1)
                if (l.le.ngas) then
                  convfac = densfac*273./tempk(iptr3d(igrd)-1+n3d)*
     &                        press(iptr3d(igrd)-1+n3d)/1013.
                else
                  convfac = 1.
                endif
                conc(iptr4d(igrd)-1+n4d) = convfac*
     &                     AMAX1( bdnl(l), conc(iptr4d(igrd)-1+n4d) )
              enddo
            enddo
          enddo
        enddo
      enddo
c
c  ---- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5)') 'Read initial condition file at ',
     &                                                  begtim,begdate
c
c  ---- deallocate the temp array ---
c
      deallocate( cinit )
c
      return
      end

      subroutine aggr00(igrd,ip,icode)
      use filunit
      use grid
      use chmstry
      use camxfld
      use camxcom
      use procan
      use tracer
      use node_mod
      use rtracchm
c
c----CAMx v7.40 260801
c
c     AGGR00 passes arrays from the common blocks to AGGREG
c
c      Copyright Ramboll 
c          
c     Modifications:
c        1/15/03     Added aggregation of deposition fields
c       03/15/09     Added code for deposition output for tracers
c       07/16/07 -bkoo-     Added check for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       10/29/09 -cemery-   Added code for RTRAC surface mass
c       04/30/13 -cemery-   Added surface model
c       08/26/21 -cemery-   RTRAC surface file doubles as (default)
c                           dep output or (flagged) surface model output
c
c     Input arguments:
c        igrd                grid index
c        ip                  parent grid index
c        icode               flag to select when to sum mass on parent grid
c                              0 = sum both before and after aggregation
c                              1 = sum before aggregation
c                              2 = sum after aggregation
c                             >2 = do not sum
c
c     Output arguments:
c        none
c
c     Subroutine called:
c        MASSUM
c        AGGREG
c
c     Called by:
c        NESTING
c
      implicit none
      include "camx.prm"
      include "flags.inc"
      include "rtracsrf.inc"
c
      integer igrd,ip,icode,l
c
c-----Entry point
c
      write(*,'(a20,$)') 'aggrg ......'
      write(iout,'(a20,$)') 'aggrg ......'
c
      if (icode.le.1) then
        call newgrid(ip)
        call massum(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &             ip,nspec,ncol(ip),nrow(ip),nlay(ip),deltax(1,ip),
     &             deltay(ip),depth(iptr3d(ip)),mapscl(iptr2d(ip)),
     &             conc(iptr4d(ip)),xmstmp(1,ip))
      endif
c
      call newgrid(igrd)
c
c  --- regular model species ----
c
      call aggreg(ncol(igrd),nrow(igrd),nlay(igrd),ncol(ip),nrow(ip),
     &            nlay(ip),nspec,i1(igrd),j1(igrd),i2(igrd),j2(igrd),
     &            nmesh(igrd),deltax(1,igrd),deltay(igrd),
     &            depth(iptr3d(igrd)),deltax(1,ip),deltay(ip),
     &            depth(iptr3d(ip)),conc(iptr4d(igrd)),
     &            conc(iptr4d(ip)) )
c
      call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),ndepspc*3+2,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),depfld(iptrdp(igrd)),
     &            deltax(1,ip),deltay(ip),depfld(iptrdp(ip)) )
c
      if (lsrfmod) then
        call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),nsmspc,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),solmas(iptrsm(igrd)),
     &            deltax(1,ip),deltay(ip),solmas(iptrsm(ip)) )
        call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),nsmspc,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),vegmas(iptrsm(igrd)),
     &            deltax(1,ip),deltay(ip),vegmas(iptrsm(ip)) )
      endif
c
c======================== Source Apportion Begin =======================
c
      if( ltrace .OR. ((lddm .OR. lhddm) .AND. lddmcalc(ip)) ) then
         call aggreg(ncol(igrd),nrow(igrd),nlay(igrd),ncol(ip),nrow(ip),
     &            nlay(ip),ntotsp,i1(igrd),j1(igrd),i2(igrd),j2(igrd),
     &            nmesh(igrd),deltax(1,igrd),deltay(igrd),
     &            depth(iptr3d(igrd)),deltax(1,ip),deltay(ip),
     &            depth(iptr3d(ip)),ptconc(ipsa3d(igrd)),
     &            ptconc(ipsa3d(ip)) )
         if( lptdepout ) then
            call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),
     &            notimespc,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),ptdryfld(ipsadep(igrd)),
     &            deltax(1,ip),deltay(ip),ptdryfld(ipsadep(ip)) )
            call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),
     &            notimespc,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),ptwetfld(ipsadep(igrd)),
     &            deltax(1,ip),deltay(ip),ptwetfld(ipsadep(ip)) )
         endif
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
            call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),ntotsp,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),rtsolmas(ipsa2d(igrd)),
     &            deltax(1,ip),deltay(ip),rtsolmas(ipsa2d(ip)) )
            call aggdep(ncol(igrd),nrow(igrd),ncol(ip),nrow(ip),ntotsp,
     &            i1(igrd),j1(igrd),i2(igrd),j2(igrd),nmesh(igrd),
     &            deltax(1,igrd),deltay(igrd),rtvegmas(ipsa2d(igrd)),
     &            deltax(1,ip),deltay(ip),rtvegmas(ipsa2d(ip)) )
         endif
      endif
c
c========================= Source Apportion End ========================
c
c
c========================= Process Analysis Begin ==============================
c
      if( lirr ) then
         call aggreg(ncol(igrd),nrow(igrd),nlay(igrd),ncol(ip),nrow(ip),
     &            nlay(ip),ntotsp,i1(igrd),j1(igrd),i2(igrd),j2(igrd),
     &            nmesh(igrd),deltax(1,igrd),deltay(igrd),
     &            depth(iptr3d(igrd)),deltax(1,ip),deltay(ip),
     &            depth(iptr3d(ip)),ptconc(ipsa3d(igrd)),
     &            ptconc(ipsa3d(ip)) )
      endif
c
c========================= Process Analysis End ==============================
c
      if (icode.eq.0 .or. icode.eq.2) then
        call newgrid(ip)
        call massum(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &              ip,nspec,ncol(ip),nrow(ip),nlay(ip),deltax(1,ip),
     &              deltay(ip),depth(iptr3d(ip)),mapscl(iptr2d(ip)),
     &              conc(iptr4d(ip)),xmass(1,ip))
        do l = 1,nspec 
          xmsfin(l,ip) = xmsfin(l,ip) + xmass(l,ip) - xmstmp(l,ip) 
        enddo
      endif
c
      write(*,'(a)') '   Done'
      write(iout,'(a)') '   Done'
      call flush(6)
      call flush(iout)
c
      return
      end

c*** HDRDEPSA
c
      subroutine hdrdepsa(iounit,fname,nspcs,idate,btim,jdate,etim,
     &                 spec_units,spec_long_name,spec_desc,spec_coords)
      use filunit
      use grid
      use camxcom
      use camxfld
      use tracer
      use ncf_iomod
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the header information to the output tracer
c     deposition files.
c
c      Copyright Ramboll
c
c    Argument description:
c      iounit         I  unit number of file to write
c      fname          C  name of file being written
c      nspcs          I  number of species to write to file
c      idate          I   beginning date of simulation (YYJJJ)
c      btim           R   beginning time of simulation
c      jdate          I   ending date of simulation (YYJJJ)
c      etim           R   ending time of simulation
c      spec_units     C array of units for this each species
c      spec_long_name C array of "long names" for each each species
c      spec_desc      C array of desciption for this each species
c      spec_coords    C array of coordinates for this each species
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c      1/20/99   Grid cell size on file should be meters for all
c                cartesian projections (UTM, LCP, PSP)
c      10/24/01  Removed BSWAP and converted integer strings to character*4
c      11/06/01  Input dates are now Julian
c      8/25/06   Surface output files now all UAM format, one file per grid
c      1/04/11   Revised for new header format
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit(*)
      character*(*) fname(*)
      integer       nspcs
      integer       idate
      real          btim
      integer       jdate
      real          etim
      character*20  spec_units(*)
      character*20  spec_long_name(*)
      character*60  spec_desc(*)
      character*60  spec_coords(*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  avgstring
      character*4   ifile(10), note(60), ispec(10,MXTRSP*2)
      character*1   dstring, wstring, underscore
      integer       i, j, l, ndate, ndlast, izero, ione, nspcout
      real          ttime, ttlast, zero, factr
      real          xorgf, yorgf, dxf, dyf
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data zero /0.0/
      data izero /0/
      data ione  /1/
      data dstring /'D'/
      data wstring /'W'/
      data underscore /'_'/
      data avgstring /'AVERAGE   '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ndate = idate
      ndlast = jdate
      ttime  = AINT(ANINT(btim)/100.) + amod(ANINT(btim),100.)/60.
      ttlast = AINT(ANINT(etim)/100.) + amod(ANINT(etim),100.)/60.
c
c   --- set scaling factor for coordinates ---
c
      iutm = iuzon
      plon = polelon
      plat = polelat
      t1   = tlat1
      t2   = tlat2
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
c
c   ---- put species names into integer array ----
c 
      nspcout = 0
      do j=1,nspcs
        if( loutsa(j) .OR. lcdfout ) then
          nspcout = nspcout + 1
          do i=1,9
             if( ptname(j)(i:i) .NE. ' ' ) then
               read(ptname(j)(i:i),'(A1)') ispec(i,nspcout)
             else
               read(underscore,'(A1)') ispec(i,nspcout)
             endif
          enddo
          read(dstring,'(A1)') ispec(i,nspcout)
          write(ptdepname(nspcout),'(10A1)') (ispec(i,nspcout),i=1,10)
        endif
      enddo
c
      do j=1,nspcs
        if( loutsa(j) .OR. lcdfout ) then
          nspcout = nspcout + 1
          do i=1,9
             if( ptname(j)(i:i) .NE. ' ' ) then
               read(ptname(j)(i:i),'(A1)') ispec(i,nspcout)
             else
               read(underscore,'(A1)') ispec(i,nspcout)
             endif
          enddo
          read(wstring,'(A1)') ispec(i,nspcout)
          write(ptdepname(nspcout),'(10A1)') (ispec(i,nspcout),i=1,10)
        endif
      enddo
      ntotspdep = nspcout
c
c   --- master grid file header ---
c
      if( lcdfout ) then
          call ncf_set_vars_base()
          call ncf_set_tstep(idate,btim,jdate,etim)
      endif
      if( .NOT. lcdfout ) then
         read(avgstring,'(10A1)') (ifile(i),i=1,10)
         read(runmsg(1:60),'(60A1)') (note(i),i=1,60)
         n = 1
         nz = 1
         write(iounit(1),ERR=7000) ifile,note,itzon,nspcout,ndate,ttime,
     &                                                 ndlast,ttlast
         write(iounit(1),ERR=7000) plon,plat,iutm,orgx,orgy,dx,dy,
     &                         ncol(1),nrow(1),nz,iproj,izero,t1,t2,zero
         write(iounit(1),ERR=7000) ione,ione,ncol(1),nrow(1)
         write(iounit(1),ERR=7000) ((ispec(i,j),i=1,10),j=1,nspcout)
      else
          action = 'Writing tracer deposition output file: '//
     &                                        fname(1)(:istrln(fname(1)))
          call ncf_set_global('DEPOSITION',1,ndate,ttime*100.,ndlast,ttlast,
     &                                                       1,ntotspdep)
          call ncf_wrt_dim(action,iounit(1),1,ncol(1),nrow(1),1,ntotspdep)
          call ncf_wrt_global(action,iounit(1),ntotspdep,ptdepname,.FALSE.)
          call ncf_wrt_global_sa(action,iounit(1))
          call ncf_wrt_vars_base(action,iounit(1))
          call ncf_wrt_vars_species(action,iounit(1),ncol(1),nrow(1),1,
     &                        nspcout,ptdepname,spec_units,spec_long_name,
     &                                             spec_desc,spec_coords,4)
          call ncf_enddef_file(action,iounit(1))
          call ncf_wrt_data_grid(action,iounit(1),1,ncol(1),nrow(1),
     &                           orgx,orgy,dx,dy,1,cellat(iptr2d(1)),
     &                                   cellon(iptr2d(1)),topo(iptr2d(1)))
      endif
c
c   --- nested grid headers ---
c
      do n = 2,ngrid
         dxf   = dx/float(meshold(n))
         dyf   = dy/float(meshold(n))
         xorgf = orgx + dx*(inst1(n)-1)
         yorgf = orgy + dy*(jnst1(n)-1)
         if( .NOT. lcdfout ) then
            write(iounit(n),ERR=7000) ifile,note,itzon,nspcout,ndate,ttime,
     &                                                    ndlast,ttlast
            write(iounit(n),ERR=7000) plon,plat,iutm,xorgf,yorgf,dxf,dyf,
     &                             ncol(n)-2,nrow(n)-2,nz,iproj,izero,
     &                             t1,t2,zero
            write(iounit(n),ERR=7000) ione,ione,ncol(n)-2,nrow(n)-2
            write(iounit(n),ERR=7000) ((ispec(i,j),i=1,10),j=1,nspcout)
         else
             action = 'Writing tracer deposition output file: '
     &                                    //fname(n)(:istrln(fname(n)))
             call ncf_set_global('DEPOSITION',n,ndate,ttime*100.,ndlast,ttlast,
     &                                                       1,ntotspdep)
             call ncf_wrt_dim(action,iounit(n),n,ncol(n),nrow(n),1,ntotspdep)
             call ncf_wrt_global(action,iounit(n),ntotspdep,ptdepname,.FALSE.)
             call ncf_wrt_global_sa(action,iounit(n))
             call ncf_wrt_vars_base(action,iounit(n))
             call ncf_wrt_vars_species(action,iounit(n),ncol(n),nrow(n),1,
     &                         nspcout,ptdepname,spec_units,spec_long_name,
     &                                               spec_desc,spec_coords,4)
             call ncf_enddef_file(action,iounit(n))
             call ncf_wrt_data_grid(action,iounit(n),n,ncol(n),nrow(n),
     &                           orgx,orgy,dx,dy,1,cellat(iptr2d(n)),
     &                                   cellon(iptr2d(n)),topo(iptr2d(n)))
         endif
      enddo
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in HDRWSA:'
      write(iout,9000,ERR=9999)'Writing output tracer ',
     &                  'deposition file: ',fname(n)(:istrln(fname(n)))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,2A,/,A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
c

      subroutine ve_gas_rt(ilu,z0,deltaz,psih,ustar,diffrat,henry,
     &                     rscale,tsurf,u10,ve)
c
c----CAMx v7.40 260801
c
c     VE_GAS_RT calculates an exchange/re-emission velocity for a specific gas 
c     species, grid cell, and land use category. 
c
c      Copyright Ramboll
c 
c     Modifications: 
c        12/08/09   ---jjung---    Original development
c
c     Input arguments: 
c        ilu                 land use index
c        z0                  surface roughness length (m)
c        deltaz              Layer 1 midpoint height (m)
c        psih                similarity stability correction term 
c        ustar               friction velocity (m/s)
c        diffrat             ratio of molecular diffusivity of water to species
c        henry               Henry's Law constant (M/atm)
c        rscale              user-defined surface resistance scaling factor
c        tsurf               surface temperature (K)
c        u10                 Wind speed at 10 m reference height (m/s)
c      
c     Output arguments: 
c        ve                  re-emission velocity (m/s)
c      
c     Routines called: 
c        none 
c      
c     Called by: 
c        REEMISRT
c 
      implicit none

      integer ilu
      real z0,deltaz,psih,ustar,diffrat,henry,rscale,tsurf,u10,ve
c
      real kwCO2
      real MwCO2,MwH2O
      real ka,Kaw,kw
      real vk,rmin,d1,d2,vair,diffh2o,rconst
      real ra,rd,re,rs
      real schmidt
c
      data vk/0.4/, rmin/1.0/, d1/2./, d2/0.667/
      data vair/1.5e-5/, diffh2o/2.3e-5/
      data MwCO2/44.0/, MwH2O/18.0/
      data rconst /8.206e-2/          ! gas constant (l.atm/mol.K)
c
c-----Entry point
c
c-----Compute atmospheric resistance, RA
c
      ra = (alog(deltaz/z0) - psih)/(vk*ustar)
      ra = amax1(ra,rmin)
c
c-----Compute the deposition layer resistance, RD
c
      schmidt = vair*diffrat/diffh2o
      rd = d1*schmidt**d2/(vk*ustar)
      rd = amax1(rd,rmin)
c
c-----Surface exchange resistance is determined only for water, RE
c
      if (ilu.ne.7) then
        re = 0.0
        goto 100
      endif
c
c-----Compute water side transfer coefficient (kw),
c     air side transfer coefficient (ka), Henry's Law (Kaw)
c
      kwCO2 = 0.45*u10**1.64
      kw = kwCO2*(MwCO2/MwH2O)**(1./4.)*sqrt(1./diffrat)
c
      ka = 1.0e-3 + 4.62*1.0e-4*sqrt(6.1+0.63*u10)*u10*
     &     (schmidt**(-0.67))
c
      Kaw = 1./(henry*rconst*tsurf)
c
c-----Compute the exchange resistance between air and water interface
c
      re = 1./ka + Kaw/kw
c
c-----Compute the surface exchange resistance over water, RS
c
      rs = 1./(3.9e-5*henry*ustar*tsurf)
      rs = amax1(rs,rmin)
      rs = rs*rscale
      re = amax1(rs,re)
c
c-----Final deposition velocity for this cell, land use, and species
c
 100  continue
      ve = 1./(ra + rd + re)
c
      return
      end

C**** NCF_RDSUMBC
c
      subroutine ncf_rdsumbc(idtnow,timnow,jdlast,ttlast,
     &                                   ncolx,nrowy,nlays,consum)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines reads the boundary condition data for the entire
c   simulation period and sums up the BC tracers for purposes of
c   calculating koh reactivity for these tracers.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         idtnow  I date of beginning of simulation
c         timnow  R time of beginning of simulation
c         jdlast  I date of end of sumulation
c         ttlast  R time of end of sumulation
c         ncolx   I number of columns  in master grid 
c         nrowy   I number of rows in master grid 
c         nlays   I number of layers in master grid 
c       Inputs:
c         consum  R sum of tracer concentrations
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer idtnow
      real    timnow
      integer jdlast
      real    ttlast
      integer ncolx
      integer nrowy
      integer nlays
      real    consum(MXSPEC,0:IDXBTP)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*4   iname(10)
      character*4   fname(10),note(60)
      character*10  filnote
      logical       lfound,lfrst
      integer       ncola, nrowa, nlaya, nvar, this_varid, ierr, ispc, j
      integer       this_time_tflag, this_time_etflag, this_tstep
      integer       data_start(4), data_count(4), ibgdhp, idum, izcl
      real          btimhp

      real, allocatable, dimension(:)     :: height
      real, allocatable, dimension(:)     :: depth
      real, allocatable, dimension(:,:,:) :: bctmp
c
      real conwst(MXLAYER,MXCELLS)
      real conest(MXLAYER,MXCELLS)
      real consth(MXLAYER,MXCELLS)
      real connth(MXLAYER,MXCELLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- allocate the local arrays ---
c
      ncola = maxval( ncol(1:ngrid) )
      nrowa = maxval( nrow(1:ngrid) )
      nlaya = maxval( nlay(1:ngrid) )
      allocate( height(ncola*nrowa*nspec) )
      allocate( depth(ncola*nrowa*nspec) )
      allocate( bctmp(ncol(1),nrow(1),nlay(1)) )
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = nlay(1)
c
      ibgdhp = 0
      btimhp = 0 
c
c   --- initialize the array to zero ---
c
      consum = 0.
c
c   --- read the 3D met file to get the layer heights ----
c
      if( .NOT. is_netcdf_i3dmet(1) ) then
         rewind(i3dmet(1))
         read(i3dmet(1),ERR=7001) fname,note,idum,nvar
         write(filnote,'(10a1)') (note(j),j=1,10)
         if (filnote.ne.'3DMET     ') then
           write(iout,'(//,a)') 'ERROR in RDSUMBC:'
           write(iout,*) 'Mismatch in file type.'
           write(iout,*) 'File is:'
           write(iout,*) filnote
           write(iout,*) 'Expecting:'
           write(iout,*) '3DMET'
           write(iout,*)
           call camxerr()
         endif
         do j = 1,3
           read(i3dmet(1),ERR=7001)
         enddo
      endif
c
  333 continue
      if( is_netcdf_i3dmet(1) ) then
         call ncf_getdepth(nvar,ncolx,nrowy,nlays,ibgdhp,idtnow,btimhp,timnow,
     &              i3dmet(1),height,depth)
      else
         call getdepth(nvar,ncolx,nrowy,nlays,ibgdhp,idtnow,btimhp,timnow,
     &              i3dmet(1),height,depth)
      endif
c
c   --- get the time step for this hour ---
c
      action = 'Reading lateral boundary conditions file.'
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(ibc,action,idtnow,timnow*100.,
     &          bnddate_time_tflag,bnddate_time_etflag,.FALSE.,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c   --- read boundary conditions for this hour ----
c
      do ispc=1,nspec
c
c  --- skip if species not needed ---
c
         if( lbcmap(ispc) .LE. 0 .OR. .NOT. 
     &              (lvocsp(ispc) .OR. lvocsoa(ispc)) ) cycle
c
c  ---- load this species into local array ---
c
         this_varid = lbcmap(ispc)
         ierr = nf_get_vara_real(ibc,this_varid,data_start,data_count,bctmp)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_RDSUMBC:'
           write(iout,*)'Cannot read boundary conditions data for speices: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
         do izcl=1,nlays
            do  j=1,nrowy
               conwst(izcl,j) = bctmp(1,j,izcl)
               conest(izcl,j) = bctmp(ncolx,j,izcl)
            enddo
            do  j=1,ncolx
               consth(izcl,j) = bctmp(j,1,izcl)
               connth(izcl,j) = bctmp(j,nrowy,izcl)
            enddo
         enddo
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
        call sumwt4(ispc,ncolx,nrowy,nlays,depth,conwst,conest,
     &                                          consth,connth,consum)
c
c   --- next species ---
c
      enddo
c
c   --- chack date and time, if it is still in the episode
c       go back to read the next hour ----
c
      timnow = timnow + 1.0
      if( timnow .GT. 24.0 ) then
          idtnow = idtnow + 1
          timnow = 0.0
          if( MOD(idtnow,1000) .GT. 365 ) then
             if( MOD(INT(idtnow/1000),4) .EQ. 0 ) then
                if( MOD(idtnow,1000) .EQ. 367 )
     &                     idtnow = (INT(idtnow/1000)+1)*1000 + 1
             else
                idtnow = (INT(idtnow/1000)+1)*1000 + 1
             endif
          endif
      endif
      if( idtnow .GT. jdlast .OR. 
     &          (idtnow .EQ. jdlast .AND. timnow .GE. ttlast) ) goto 444
c
c  --- process next hour ----
c
      goto 333
c
c  --- all concentrations are summed, return ---
c
  444 continue
c
c  --- deallocate the local arrays ---
c
      deallocate( height )
      deallocate( depth  )
      deallocate( bctmp  )
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDSUMBC:'
      write(iout,'(/,1X,A)') 'Reading 3D Met file'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c**** NCF_RDBCDDM.F
c
      subroutine ncf_rdbcddm(nox,noy,noz,nspsa,saconc,tpgrd,prgrd)
      use tracer
      use grid
      use chmstry
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fils one hour of boundary conditions for the DDM
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c   The values are left in PPM so that they can be interpolated to
c   the nests in a later step. This version is for NetCDF files.
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  tracer concentrations
c       Inputs:
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspsa    I  number of tracer species
c           tpgrd    I  3-D temperature field
c           prgrd    I  3-D pressure field
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'netcdf.inc'         
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
      real      tpgrd(nox,noy,noz)
      real      prgrd(nox,noy,noz)
c
c-----------------------------------------------------------------------
c   External functions:
c-----------------------------------------------------------------------
c
      integer ncf_chkfile
      integer ncf_get_tstep
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  bcname, cfile, this_var, name_in
      integer       ierr, jerr, this_tstep, i, j, k, ispc
      integer       data_start(4), data_count(4), this_varid
      integer       ibcdate_time_tflag, ibcdate_time_etflag
      integer       iddm, iptr, nedge, ioff, itmp
      logical       lexist, luse
      real          convfac 
c
      real, allocatable, dimension(:,:,:) :: bcgrid
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c  --- open the BC ---
c
      inquire(file=bcfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening DDM Boundary Conditions file.'
      bcname = 'BOUNDARY  '
      ierr = ncf_chkfile(iorbc,bcfil,action,bcname)
      if( ierr .NE. ISUCES ) then
         jerr = nf_open(bcfil,NF_NOWRITE,iorbc)
         if( jerr .NE. NF_NOERR ) goto 7001
      else
         return
      endif
c
c --- get the type of file to make sure it is a BC file ---
c
      this_var = 'CAMx_NAME'
      ierr = nf_get_att_text(iorbc, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iorbc, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7003
      endif
      if( name_in(:8) .NE. bcname(:8) ) goto 7002
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(iorbc,action,1,.TRUE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iorbc,action,begdate,begtim,begdate,begtim,.FALSE.)
c
c  --- call routine to zero out the array ---
c
      allocate( bcgrid(ncol(1),nrow(1),nlay(1)) )
c
c  --- set the parameters for how to read the this data ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = nlay(1)
c
c  --- get the timestep for the first hour ---
c
      this_tstep = ncf_get_tstep(iorbc,action,begdate,begtim,
     &          ibcdate_time_tflag,ibcdate_time_etflag,.FALSE.,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  --- read the concentrations for each species ---
c
      do ispc=1,nspec
c
c  ---- load this species into local array ---
c
         this_var = spname(ispc)
         ierr = nf_inq_varid(iorbc,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) cycle
         ierr = nf_get_vara_real(iorbc,this_varid,data_start,data_count,bcgrid)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_RDBCDDM:'
           write(iout,*)'Cannot read boundary conditions data for speices: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
            write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c  --- skip if this species is not used for DDM ---
c
         do iddm=1,nbcddm
            luse = .FALSE.
            if( bcddmsp(iddm) .EQ. spname(ispc) ) luse = .TRUE. 
            if( bcddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE. 
            if( bcddmsp(iddm) .EQ. NAMVOC 
     &                     .AND. lvocsp(ispc) ) luse = .TRUE. 
            if( bcddmsp(iddm) .EQ. NAMNOX 
     &                     .AND. lnoxsp(ispc) ) luse = .TRUE. 
            if( bcddmsp(iddm) .EQ. NAMHRV
     &                     .AND. lhrvoc(ispc) ) luse = .TRUE.
            if( .NOT. luse ) cycle
c
c  --- load into global array ---
c
            do k=1,noz
              do j=1,noy
c
c  --- get the gas conversion factor to umol/m3 ---
c
                 if( ispc .LE. ngas ) then
                    convfac = densfac*273./
     &                               tpgrd(1,j,k)*prgrd(1,j,k)/1013.
                 else
                    convfac = 1.
                 endif
c
c  --- load the west boundary ---
c
                 if( lbndry ) then
                    ioff = IDXBWS
                 else
                    ioff = 1
                 endif
                 iptr = iptddm(ispc) + (iddm-1)*nedge + nicddm + ioff - 1
                 if( bcgrid(1,j,k) .GT. bdnl(ispc) ) then
                     saconc(1,j,k,iptr) = bcgrid(1,j,k) * convfac
                 else
                     saconc(1,j,k,iptr) = 0.0
                 endif
c
c  --- load the east boundary ---
c
c  --- get the gas conversion factor to umol/m3 ---
c
                 if( ispc .LE. ngas ) then
                     convfac = densfac*273./
     &                          tpgrd(nox,j,k)*prgrd(nox,j,k)/1013.
                 else
                     convfac = 1.
                 endif
                 if( lbndry ) then
                     ioff = IDXBES
                 else
                     ioff = 1
                 endif
                 iptr = iptddm(ispc) + (iddm-1)*nedge + nicddm + ioff - 1
                 if( bcgrid(nox,j,k) .GT. bdnl(ispc) ) then
                     saconc(nox,j,k,iptr) = bcgrid(nox,j,k) * convfac
                 else
                    saconc(nox,j,k,iptr) = 0.0
                 endif
              enddo
c
c  --- load the south boundary ---
c
              do i=1,nox
c
c  --- get the gas conversion factor to umol/m3 ---
c
                 if( ispc .LE. ngas ) then
                    convfac = densfac*273./
     &                           tpgrd(i,1,k)*prgrd(i,1,k)/1013.
                 else
                    convfac = 1.
                 endif
                 if( lbndry ) then
                    ioff = IDXBST
                 else
                    ioff = 1
                 endif
                 iptr = iptddm(ispc) + (iddm-1)*nedge + nicddm + ioff - 1
                 if( bcgrid(i,1,k) .GT. bdnl(ispc) ) then
                     saconc(i,1,k,iptr) = bcgrid(i,1,k) * convfac
                 else
                     saconc(i,1,k,iptr) = 0.0
                 endif
c
c  --- load the east boundary ---
c
c
c  --- get the gas conversion factor to umol/m3 ---
c
                 if( ispc .LE. ngas ) then
                     convfac = densfac*273./
     &                                tpgrd(i,noy,k)*prgrd(i,noy,k)/1013.
                 else
                     convfac = 1.
                 endif
                 if( lbndry ) then
                     ioff = IDXBNT
                 else
                     ioff = 1
                 endif
                 iptr = iptddm(ispc) + (iddm-1)*nedge + nicddm + ioff - 1
                 if( bcgrid(i,noy,k) .GT. bdnl(ispc) ) then
                     saconc(i,noy,k,iptr) = bcgrid(i,noy,k) * convfac
                 else
                     saconc(i,noy,k,iptr) = 0.0
                 endif
              enddo
c
c  --- next layer --
c
            enddo
c
c  --- next DDM species ---
c
          enddo
c
c  --- check the next modeled species ---
c
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in NCF_RDBCDDM:'
      write(iout,*) 'ERROR:  BC file for DDM does not exist: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDBCDDM:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Could not open file: ',
     &                                   bcfil(:istrln(bcfil))
      write(iout,'(3A)') 'If this is a NCF file, check that its',
     &                   ' format is consistent with the NCF library',
     &                   ' used to build CAMx.'
      write(iout,'(2A)') 'The CAMx makefile supports netCDF3-Classic,',
     &                   ' and netCDF4 compressed or uncompressed.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDBCDDM:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Filetype is not correct.'
      write(iout,'(2A)',ERR=9999) 'Expecting    : ',bcname(:istrln(bcname))
      write(iout,'(2A)',ERR=9999) 'Value in file: ',name_in(:istrln(name_in))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDBCDDM:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine rassgn4d(ncol,nrow,nlay,nspec,io,jo,nmesh,ncolf,
     &                                         nrowf,nlayf,rcval,rfval)
c
c----CAMx v7.40 260801
c
c     RASSGN4D assigns real fine grid values from coarse grid. This
c     version is for a 4-D array (rows,columns,layers,species)
c
c      Copyright Ramboll
c          
c     Modifications:
c       11/05/12   Removed vertical nesting
c
c     Input arguments:
c        ncol              number of columns in the parent grid
c        nrow              number of rows in the parent grid
c        nlay              number of layers in parent grid
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        nlayf             number of layers in fine grid
c        rcval             cell centered value on coarse grid
c
c     Output arguments:
c        rfval             cell centered value on coarse grid
c
c     Subroutine called:
c        None
c
c     Called by:
c        RDFGCON
c
      real    rcval(ncol,nrow,nlay,nspec)
      real    rfval(ncolf,nrowf,nlayf,nspec)
c
c-----Entry point
c
c----Loop over species---
c
      do ispc=1,nspec
c
c----Loop over layers in parent grid---
c
         do ilay=1,nlay
c
c----Loop over fine grid layers in this parent layer---
c
              ilayf = ilay
c
c----Load in the grid---
c
              do 40 jfin = 1,nrowf
                j = (jfin - 2)/nmesh + jo
                do 30 ifin = 1,ncolf
                   i = (ifin - 2)/nmesh + io
                   rfval(ifin,jfin,ilayf,ispc) = rcval(i,j,ilay,ispc)
  30            continue
  40          continue
c
c----Next layer---
c
         enddo
c
c----Next species----
c
      enddo
c
      return
      end

      subroutine reemisrt(m1,m2,m3,i0,j0,ncols,nrows,nlays,nrtsp,delt,
     &                    tsurf,cellat,cellon,fsurf,height,press,windu,
     &                    windv,tempk,snow,smasfld,vmasfld,saconc)
      use camxcom
      use rtracchm
c
c----CAMx v7.40 260801
c 
c     REEMISS determines re-emission fluxes of volatile gas tracers from the
c     RTRAC surface model.  The gridded atmospheric RTRAC tracer concentrations 
c     are incremented and surface model mass is decremented accordingly.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        12/08/09   ---jjung---    Original development
c
c     Input arguments:
c        ncols               number of columns 
c        nrows               number of rows 
c        nlays               number of layers 
c        nrtsp               number of species
c        delt                time step size (s)
c        tsurf               surface temperature field (K)
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        fsurf               fractional landuse cover field (fraction)
c        height              layer interface height field (m)
c        press               layer pressure field (mb)
c        windu               layer U-component wind field (m/s)
c        windv               layer V-component wind field (m/s)
c        tempk               layer temperature field (K)
c        snow                snow cover water equivalent (m)
c        smasfld             RTRAC surface soil mass field (mol/ha)
c        vmasfld             RTRAC surface vegetation mass field (mol/ha)
c
c     Output arguments
c        saconc              RTRAC tracer concentration field (umol/m3,ug/m3)
c        smasfld             RTRAC surface soil mass field (mol/ha)
c        vmasfld             RTRAC surface vegetation mass field (mol/ha)
c             
c     Routines called: 
c        CALDATE
c        MICROMET
c        HENRYFNC
c        VE_GAS_RT
c             
c     Called by: 
c        EMISTRNS
c 
      implicit none
c
      include 'camx.prm'
      include 'deposit.inc'
      include 'rtracsrf.inc'
c
      integer :: m1,m2,m3,i0,j0
      integer :: ncols,nrows,nlays
      integer :: nrtsp
      real delt

      real, dimension(m1,m2) :: tsurf, cellat, cellon, snow
      real, dimension(ncols,nrows,nlays) :: height
      real, dimension(m1,m2,m3) :: press, windu, windv, tempk
      real, dimension(m1,m2,NLU) :: fsurf
      real saconc(m1,m2,m3,nrtsp)
      real smasfld(m1,m2,nrtsp) ! soil deposition
                                ! gas [=] mol/hectare, aerosol[=] g/hectare 
      real vmasfld(m1,m2,nrtsp) ! vegitation deposition
                                ! gas [=] mol/hectare, aerosol[=] g/hectare 

      integer idate,month
      integer i,j,l,m
      integer mbin,latbin,isesn
      real deltaz,temp0,prss0,ucomp,vcomp,wind
      real pbl,ustar,el,psih,wstar
      real henry,ve,rconst
      real soldepth,vegdepth
      real z0
      real Ksa
      real ptsolconc ! soil surface concentration, umol/m3, ug/m3
      real ptvegconc ! veg. surface concentration, umol/m3, ug/m3
      real reemis    ! overall reemission, umol/m2-s, ug/m2-s
      real resolemis ! soil reemission, umol/m2-s, ug/m2-s
      real revegemis ! vegitation reemission, umol/m2-s, ug/m2-s
      real dconc     ! umol/m3, ug/m3
      real tdconc(MXTRSP)
      real tdsolconc(MXTRSP)
      real tdvegconc(MXTRSP)
      real eps       ! default minimum value for deposition value
      real crrctn    ! air conc. correction in case of using eps
      logical lstable
      logical lcrrs  ! correction flag for soil
      logical lcrrv  ! correction flag for veg.
c
      data rconst /8.206e-2/                  ! gas constant (l.atm/mol.K)
      data soldepth/1.0e-3/, vegdepth/1.0e-4/ ! depth of deposit field, m
      data eps/1.0e-20/
c
c-----Entry point
c
      idate = date
      call caldate(idate)
      month = (idate - 10000*int(idate/10000.))/100

c-----Loop over rows and columns
c
      do 30 j = 2,m2-1 
        do 20 i = 2,m1-1
c
          do l = 1,nrtrac
             tdconc(l) = 0.
             tdsolconc(l) = 0.
             tdvegconc(l) = 0.
          enddo
c
c-----Determine season
c
          mbin = month
          if (cellat(i,j).lt.0.) then
            mbin = mod(month+6,12)
            if (mbin.eq.0) mbin = 12
          endif
          latbin = 1
          if (abs(cellat(i,j)).gt.20.) then
            latbin = 2
          elseif (abs(cellat(i,j)).gt.35.) then
            latbin = 3
          elseif (abs(cellat(i,j)).gt.50.) then
            latbin = 4
          elseif (abs(cellat(i,j)).gt.75.) then
            latbin = 5
          endif
          if ((cellat(i,j).gt.50. .and. cellat(i,j).lt.75.) .and.
     &        (cellon(i,j).gt.-15. .and. cellon(i,j).lt.15.)) latbin = 3
          isesn = iseason(latbin,mbin)
c
c-----Use input snow cover to set season, if specified
c
          if (snow(i,j).ge.0.001) isesn = 4   ! Snow cover check > 1 cm
c
c-----Load local met variables
c
          deltaz = height(i+i0,j+j0,1)/2.
          temp0 = tsurf(i,j)
          prss0 = press(i,j,1) - 2.*deltaz*(press(i,j,2) - 
     &                            press(i,j,1))/height(i+i0,j+j0,2)
          ucomp = (windu(i,j,1) + windu(i-1,j,1))/2.
          vcomp = (windv(i,j,1) + windv(i,j-1,1))/2.
          wind = sqrt(ucomp**2 + vcomp**2)
          wind = amax1(0.1,wind)
c
c-----Loop over land use; surface roughness for water is dependent on
c     wind speed
c
          do 10 m = 1,NLU
            if (fsurf(i,j,m).lt.0.01) goto 10
            z0 = z0lu(m,isesn)
            if (m.eq.7) z0 = amax1(z0,2.0e-6*wind**2.5)
c
c-----Get surface layer micrometeorological parameters for this cell and
c     landuse type
c 
            call micromet(tempk(i,j,1),temp0,press(i,j,1),prss0,
     &                    deltaz,wind,z0,pbl,ustar,el,psih,wstar,lstable)
c
c-----Loop over GAS species, and calculate re-emission velocity for this cell,
c     landuse, and current species.
c
            do 40 l = 1,nrtgas
              call henryfnc(0,rthlaw(l),rttfact(l),temp0,7.,1,1,1,henry)
              call ve_gas_rt(m,z0,deltaz,psih,ustar,rtdrate(l),henry,
     &                       rtscale(l),temp0,wind,ve)
              if (m.eq.7) then
cnowtr          Kaw = 1./(henry*rconst*tsurf(i,j))
cnowtr          ptsolconc = (smasfld(i,j,l)*1.0e-4/soldepth)*Kaw
cnowtr          resolemis = (vd-ve)*saconc(i,j,1,l)*1.0e-6 + 
cnowtr     &                ve*ptsolconc
                resolemis = 0.0
                revegemis = 0.0
                reemis = 0.0
              else
                Ksa = 0.411*1.53*0.59*fsoiloc(m)*eqkoa(l)
                ptsolconc = (smasfld(i,j,l)*1.0e2/soldepth)
                ptvegconc = (vmasfld(i,j,l)*1.0e2/vegdepth)
                resolemis = ve*(saconc(i,j,1,l)+ptsolconc)/(1.+Ksa)
                revegemis = ve*(saconc(i,j,1,l)+ptvegconc)/(1.+eqkoa(l))
                reemis = resolemis + revegemis
              endif
              dconc = reemis*delt/height(i+i0,j+j0,1)
              tdconc(l) = tdconc(l) + dconc*fsurf(i,j,m)
              if (reemis.gt.0.0) then
                tdsolconc(l) = tdsolconc(l) +
     &                dconc*fsurf(i,j,m)*(resolemis/reemis)
                tdvegconc(l) = tdvegconc(l) +
     &                dconc*fsurf(i,j,m)*(revegemis/reemis)
              endif   
 40         continue
 10       continue
          do l = 1, nrtgas
            crrctn = 0.
            lcrrs = .false.
            lcrrv = .false.
            if (smasfld(i,j,l).gt.eps) then
               smasfld(i,j,l) = smasfld(i,j,l) -
     &                       tdsolconc(l)*height(i+i0,j+j0,1)*1.0e-2
            else
               crrctn = crrctn + 
     &            (smasfld(i,j,l) - eps)*1.0e2*soldepth/height(i+i0,j+j0,1)
               smasfld(i,j,l) = eps
               lcrrs = .true.
            endif
            if (vmasfld(i,j,l).gt.eps) then
               vmasfld(i,j,l) = vmasfld(i,j,l) -
     &                       tdvegconc(l)*height(i+i0,j+j0,1)*1.0e-2
            else
               crrctn = crrctn + 
     &            (vmasfld(i,j,l) - eps)*1.0e2*vegdepth/height(i+i0,j+j0,1)
               vmasfld(i,j,l) = eps
               lcrrv = .true.
            endif
            if (.not. lcrrs .and. .not. lcrrv) then
               saconc(i,j,1,l) = saconc(i,j,1,l) + tdconc(l)
            elseif (.not. lcrrs .and. lcrrv) then
               saconc(i,j,1,l) = saconc(i,j,1,l) + tdsolconc(l) +
     &                          crrctn
            elseif (lcrrs .and. .not.lcrrv) then
               saconc(i,j,1,l) = saconc(i,j,1,l) + tdvegconc(l) +
     &                          crrctn
            elseif (lcrrs .and. lcrrv) then
               saconc(i,j,1,l) = saconc(i,j,1,l) + crrctn
            endif
            saconc(i,j,1,l) = MAX(rtlbnd(l),saconc(i,j,1,l))
          enddo
 20     continue
 30   continue
      return
      end

      subroutine khorz(igrid,ncol,nrow,nlay,numrows,joff,dx,dy,
     &                 deltat,windu,windv,idfin,rkx,rky)
      use filunit
      use bndary
c
c----CAMx v7.40 260801
c
c     KHORZ computes horizontal diffusion coefficients using a wind
c     deformation approach. RKX(i) is defined on the east wall of cell (i),
c     RKY(j) is defined on the northern wall of cell (j). RKX and RKY set 
c     to zero on grid boundaries, and for cell interfaces that are within 
c     child nested grids
c
c      Copyright Ramboll
c          
c     Modifications:
c        11/30/99  Form of Kh revised to be:
c                  Kh = Kh0 + c*dx*dx*(deformation)
c                  where Kh0 is dependent on advection solver and grid size.
c                  Max Kh is now grid size and timestep dependent
c                  Echos min/avg/max stats by layer to diag file
c        10/31/03  Reduced value of Kh0 by factor of 4
c         5/28/09  Reduced minimum horiz diffusion
c
c     Input arguments:
c        igrid               grid index
c        ncol                number of columns in this slice
c        nrow                number of rows in this slice
c        nlay                number of layers in this slice
c        numrows             number of rows in entire grid
c        joff                row offset of this slice in entire grid
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        deltat              timestep (s)
c        windu               wind speed in x-direction (m/s)
c        windv               wind speed in y-direction (m/s)
c        idfin               map of nested grids in this grid 
c
c     Output arguments:
c        rkx                 horiz diffusion coefficient in x (m2/s)
c        rky                 horiz diffusion coefficient in y (m2/s)
c
c     Routines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
      real    dx(numrows)
      real    windu(ncol,nrow,nlay)
      real    windv(ncol,nrow,nlay)
      real    rkx(ncol,nrow,nlay)
      real    rky(ncol,nrow,nlay)
      integer idfin(ncol,nrow)
c
c-----Entry point
c
      jmid = nrow/2
      diffac = 0.25/1.414
      difmin = 1.
      difmax = dx(jmid+joff)*dy/(32.*deltat)
      difmax = amin1(difmax,1.e5)
      kh0 = 0.003*dx(jmid+joff)*dy/deltat
c
      write(idiag,*)
      write(idiag,*)'Horizontal diffusion coefficients'
      write(idiag,*)'Stats (min, avg, max) for grid ',igrid
      do 50 k = 1,nlay
        xsum = 0.
        xcnt = 0.
        xmin = 1.e10
        xmax = 0.
        ysum = 0.
        ycnt = 0.
        ymin = 1.e10
        ymax = 0.
c
c-----Derive Kx
c
        do 20 j = 2,nrow-1
          do 10 i = 2,ncol-2
            if (idfin(i,j).gt.igrid .or. idfin(i+1,j).gt.igrid) then
              rkx(i,j,k) = 0.
              goto 10
            endif
c
            dudx = (windu(i+1,j,k) - windu(i-1,j,k))/(2.*dx(j+joff))
            dudy = (windu(i,j+1,k) - windu(i,j-1,k))/(2.*dy)
c
            dv1 = (windv(i,j,k) - windv(i,j-1,k))/dy
            dv2 = (windv(i+1,j,k) - windv(i+1,j-1,k))/dy
            dvdy = (dv1 + dv2)/2.
            dv1 = (windv(i+1,j,k) - windv(i,j,k))/dx(j+joff)
            dv2 = (windv(i+1,j-1,k) - windv(i,j-1,k))/dx(j+joff)
            dvdx = (dv1 + dv2)/2.
c
            deform = sqrt((dudy + dvdx)**2 + (dudx - dvdy)**2)
            rkx(i,j,k) = kh0 + diffac*dy*dx(j+joff)*deform
            rkx(i,j,k) = amin1(difmax,rkx(i,j,k))
            rkx(i,j,k) = amax1(difmin,rkx(i,j,k))
            xsum = xsum + rkx(i,j,k)
            xcnt = xcnt + 1.
            xmin = amin1(xmin,rkx(i,j,k))
            xmax = amax1(xmax,rkx(i,j,k))
  10      continue
          rkx(1,j,k) = 0.
          rkx(ncol-1,j,k) = 0.
  20    continue
c
c-----Derive Ky
c
        do 40 i = 2,ncol-1
          do 30 j = 2,nrow-2
            if (idfin(i,j).gt.igrid .or. idfin(i,j+1).gt.igrid) then
              rky(i,j,k) = 0.
              goto 30
            endif
c
            dvdy = (windv(i,j+1,k) - windv(i,j-1,k))/(2.*dy)
            dvdx = (windv(i+1,j,k) - windv(i-1,j,k))/(2.*dx(j+joff))
c
            du1 = (windu(i,j,k) - windu(i-1,j,k))/dx(j+joff)
            du2 = (windu(i,j+1,k) - windu(i-1,j+1,k))/dx(j+joff)
            dudx = (du1 + du2)/2.
            du1 = (windu(i,j+1,k) - windu(i,j,k))/dy
            du2 = (windu(i-1,j+1,k) - windu(i-1,j,k))/dy
            dudy = (du1 + du2)/2.
c
            deform = sqrt((dudy + dvdx)**2 + (dudx - dvdy)**2)
            rky(i,j,k) = kh0 + diffac*dy*dx(j+joff)*deform
            rky(i,j,k) = amin1(difmax,rky(i,j,k))
            rky(i,j,k) = amax1(difmin,rky(i,j,k))
            ysum = ysum + rky(i,j,k)
            ycnt = ycnt + 1.
            ymin = amin1(ymin,rky(i,j,k))
            ymax = amax1(ymax,rky(i,j,k))
  30      continue
          rky(i,1,k) = 0.
          rky(i,nrow-1,k) = 0.
  40    continue
        xsum = xsum/xcnt
        ysum = ysum/ycnt
        havg = (xsum + ysum)/2.
        hmin = amin1(xmin,ymin) 
        hmax = amax1(xmax,ymax)
        write(idiag,'(i2,3f10.0)') k,hmin,havg,hmax
  50  continue
c
      return
      end

c**** RDTCDDM.F
c
      subroutine rdtcddm()
      use filunit
      use grid
      use chmstry
      use camxfld
      use camxcom
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of top concentrations for the DDM
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c       Inputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     11/28/16   --bkoo--       Created
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c  External functions:
c-----------------------------------------------------------------------
c
      integer ncf_chkfile
c
c-----------------------------------------------------------------------
c    Local variables:
c----------------------------------------------------------------------
c
      character*200 action
      character*10 aqfil, cfile, cspec
      character*4  ifile(10), note(60), ispec(10)
      integer      iseg, nspc, idat1, idat2, ierr
      integer      izone, nx, ny, nz, nedge, ioff, isoa
      integer      ispc, imod, iddm, iptr, n3d
      integer      ip, ic, ig
      integer      i, j, k, n
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
      logical      lexist, luse
c
      real contop(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data aqfil /'AIRQUALITY'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
        ioff = IDXBTP
      else
        nedge = 1
        ioff = 1
      endif
c
c  --- open the TC ---
c
      inquire(file=tcfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening DDM Top Concentrations file.'
      ierr = ncf_chkfile(iortc,tcfil,action,aqfil)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(file=tcfil,unit=iortc,status='UNKNOWN',
     &                                   form='UNFORMATTED',ERR=7001)
      else
         return
      endif
c
c  --- read 1st TC header record and check inputs ---
c
      read(iortc,ERR=7002) ifile,note,iseg,nspc,idat1,tim1,idat2,tim2
      write(cfile,'(10A1)') (ifile(i),i=1,10)
      if( cfile .NE. aqfil ) goto 7003
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. date .AND. .NOT. le1day ) goto 7004
      if( idat1 .EQ. date .AND. tim1 .GT. time
     &                              .AND. .NOT. le1day ) goto 7004
c
c  --- read 2nd BC header record and check inputs ---
c
      read(iortc,ERR=7002) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if( .NOT. llatlon ) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if( nx .NE. ncol(1) .OR. ny .NE. nrow(1) ) goto 7005
c
c  --- skip the next 2 records ---
c
      read(iortc,ERR=7002)
      read(iortc,ERR=7002)
c
c  --- read the date and time and make sure it is the correct hour ---
c
  111 continue
      read(iortc,ERR=7007,END=7006) idat1, tim1, idat2, tim2
      if( INT(tim2) .EQ. 24 ) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = tim1*100
      tim2 = tim2*100
      if( (idat1 .LT. date .OR. 
     &       (idat1 .EQ. date .AND. tim1 .LE. time)) .AND.
     &            (idat2 .GT. date .OR. 
     &                (idat2 .EQ. date .AND. tim2 .GT. time))) then
c
c  --- read the concentrations for each species ---
c
         do ispc=1,nspc
            read(iortc,ERR=7007,END=7006) iseg, (ispec(n),n=1,10),
     &                                     ((contop(i,j),i=1,nx),j=1,ny)
            write(cspec,'(10A1)') ispec
            if( cspec .EQ. 'HNO2      ') cspec = 'HONO      '
            if( cspec .EQ. 'HCHO      ' .and. kHCHO.eq.nspec+1 ) 
     &                                             cspec = 'FORM      '
            do isoa=1,NUM_SOAP_SPECIES
             if( cspec .EQ. soap2_spec_names(isoa) ) 
     &                           cspec = soap3_spec_names(isoa)
           enddo
c
c  --- find this species in the modeled species list ---
c
            do imod=1,nspec
               if( cspec .EQ. spname(imod) ) then
                   do iddm=1,nbcddm
                      luse = .FALSE.
                      if( bcddmsp(iddm) .EQ. cspec ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMVOC 
     &                               .AND. lvocsp(imod) ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMNOX 
     &                               .AND. lnoxsp(imod) ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMHRV
     &                               .AND. lhrvoc(imod) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
                      if( luse ) then
                         iptr = iptddm(imod) + (iddm-1)*nedge + nicddm +
     &                                                 ndepddm + ioff - 1
                         do j=1,ny
                         do i=1,nx
                            n3d = i + nx*(j - 1) + nx*ny*(iptr - 1)
c
c  --- load the top concentrations ---
c
                            if( contop(i,j) .GT. bdnl(imod) ) then
                               pttop(n3d) = contop(i,j)
                            else
                               pttop(n3d) = 0.0
                            endif
                         enddo
                         enddo
c
c  --- interpolate top con sens to all nested grids
c
                         if ( ngrid.gt.1 ) then
                            do ip = 1,ngrid
                            do ic = 1,nchdrn(ip)
                               ig = idchdrn(ic,ip)
                               call interp2d(ncol(ip),nrow(ip),1,
     &                                       i1(ig),j1(ig),nmesh(ig),
     &                                       ncol(ig),nrow(ig),
     &                                       pttop( ipsa2d(ip) + ncol(ip)*nrow(ip)*(iptr - 1) ),
     &                                       pttop( ipsa2d(ig) + ncol(ig)*nrow(ig)*(iptr - 1) ))
                            enddo
                            enddo
                         endif
                      endif
c
c  --- check the next BC DDM species ---
c
                   enddo
c
c  --- check the next modeled species ---
c
               endif
            enddo
c
c  --- read next species worth of data ---
c
         enddo
c
c  --- if not the right hour, read through it ---
c
      else
         do ispc=1,nspc
            read(iortc,ERR=7007) 
         enddo
         goto 111
      endif
c
c  --- finally got the right hour, close the file ---
c
      close(iortc)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM does not exist: ',TRIM(tcfil)
      call camxerr()
c
 7001 continue 
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  Opening TC file for DDM: ',TRIM(tcfil)
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  Reading header of TC file for DDM: ',TRIM(tcfil)
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM is not labelled ',TRIM(aqfil)
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM is not for correct time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',date
      write(iout,'(a,f10.1)') 'Time   : ',time
      write(iout,*) '   ***  TC File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  TC file for DDM is not for correct grid.'
      write(iout,*) '   ***  Coarse Grid ***'
      write(iout,*) 'No. of Cells : (',ncol(1),',',nrow(1),')'
      write(iout,*) '   ***  TC File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  Premature end-of-file reached in TC file for DDM.'
      write(iout,*) 'Make sure the file contains the correct date/time.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDTCDDM:' 
      write(iout,*) 'ERROR:  Reading TC file for DDM: ',TRIM(tcfil)
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

c**** RDBCDDM.F
c
      subroutine rdbcddm(nox,noy,noz,nspsa,saconc,tpgrd,prgrd)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of boundary conditions for the DDM
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  tracer concentrations
c       Inputs:
c           nox      I  number of X cells in the grid
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspsa    I  number of tracer species
c           tpgrd    I  3-D temperature field
c           prgrd    I  3-D pressure field
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/31/99   --gwilson--    Original development
c     10/24/01  Removed BSWAP and converted integer strings to character*4
c     07/16/07   --bkoo--       Added HRVOC
c     11/4/09   -cemery-        Removed input top concentrations
c     11/28/16   --bkoo--       Added code to reset BC sens
c                               Fixed a time check bug
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
      real      tpgrd(nox,noy,noz)
      real      prgrd(nox,noy,noz)
c
c-----------------------------------------------------------------------
c    External functions:
c----------------------------------------------------------------------
c
      integer ncf_chkfile
c
c-----------------------------------------------------------------------
c    Local variables:
c----------------------------------------------------------------------
c
      character*200 action
      character*10 bnfil, cfile, cspec
      character*4  ifile(10), note(60), ispec(10)
      integer      ispc, iedge, ierr
      integer      iseg, nspc, idat1, idat2
      integer      izone, nx, ny, nz, imod, isoa
      integer      iddm, iptr, i, j, k, nedge
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
      logical      lexist, luse
c
      real conwst(MXCELLS,MXCELLS)
      real conest(MXCELLS,MXCELLS)
      real consth(MXCELLS,MXCELLS)
      real connth(MXCELLS,MXCELLS)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data bnfil /'BOUNDARY'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c  --- open the BC ---
c
      inquire(file=bcfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening DDM Boundary Conditions file.'
      ierr = ncf_chkfile(iorbc,bcfil,action,bnfil)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(file=bcfil,unit=iorbc,status='UNKNOWN',
     &                                   form='UNFORMATTED',ERR=7001)
      else
         return
      endif
c
c  --- read 1st BC header record and check inputs ---
c
      read(iorbc,ERR=7002) ifile,note,iseg,nspc,idat1,tim1,idat2,tim2
      write(cfile,'(10A1)') (ifile(i),i=1,10)
      if( cfile .NE. bnfil ) goto 7003
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. date .AND. .NOT. le1day ) goto 7004
      if( idat1 .EQ. date .AND. tim1 .GT. time
     &                              .AND. .NOT. le1day ) goto 7004
c
c  --- read 2nd BC header record and check inputs ---
c
      read(iorbc,ERR=7002) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if( .NOT. llatlon ) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if( nx .NE. ncol(1) .OR. ny .NE. nrow(1) 
     &                                .OR. nz .NE. nlay(1) ) goto 7005
c
c  --- skip the next 6 records ---
c
      read(iorbc,ERR=7002)
      read(iorbc,ERR=7002) 
      do i=1,4
        read(iorbc,ERR=7002) 
      enddo
c
c  --- read the date and time and make sure it is the correct hour ---
c
  111 continue
      read(iorbc,ERR=7007,END=7006) idat1, tim1, idat2, tim2
      if( INT(tim2) .EQ. 24 ) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = tim1*100
      tim2 = tim2*100
      if( (idat1 .LT. date .OR. 
     &       (idat1 .EQ. date .AND. tim1 .LE. time)) .AND.
     &            (idat2 .GT. date .OR. 
     &                (idat2 .EQ. date .AND. tim2 .GT. time))) then
c
c  --- read the concentrations for each species ---
c
         do ispc=1,nspc
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((conwst(k,j),k=1,nz),j=1,ny)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((conest(k,j),k=1,nz),j=1,ny)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((consth(k,i),k=1,nz),i=1,nx)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((connth(k,i),k=1,nz),i=1,nx)
            write(cspec,'(10A1)') ispec
            if( cspec .EQ. 'HNO2      ') cspec = 'HONO      '
            if( cspec .EQ. 'HCHO      ' .and. kHCHO.eq.nspec+1 ) 
     &                                             cspec = 'FORM      '
            do isoa=1,NUM_SOAP_SPECIES
             if( cspec .EQ. soap2_spec_names(isoa) ) 
     &                           cspec = soap3_spec_names(isoa)
           enddo
c
c  --- find this species in the modeled species list ---
c
            do imod=1,nspec
               if( cspec .EQ. spname(imod) ) then
                   do iddm=1,nbcddm
                      luse = .FALSE.
                      if( bcddmsp(iddm) .EQ. cspec ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMVOC 
     &                               .AND. lvocsp(imod) ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMNOX 
     &                               .AND. lnoxsp(imod) ) luse = .TRUE. 
                      if( bcddmsp(iddm) .EQ. NAMHRV
     &                               .AND. lhrvoc(imod) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
                      if( luse ) then
                         do k=1,nz
                            do j=1,ny
c
c  --- get the gas conversion factor to umol/m3 ---
c
                                  if( imod .LE. ngas ) then
                                   convfac = densfac*273./
     &                               tpgrd(1,j,k)*prgrd(1,j,k)/1013.
                                  else
                                   convfac = 1.
                                  endif
c
c  --- load the west boundary ---
c
                                  if( lbndry ) then
                                     ioff = IDXBWS
                                  else
                                     ioff = 1
                                  endif
                                  iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                         nicddm + ndepddm + ioff - 1
                                  if( conwst(k,j) .GT. bdnl(imod) ) then
                                    saconc(1,j,k,iptr) = conwst(k,j) * convfac
                                  else
                                    saconc(1,j,k,iptr) = 0.0
                                  endif
c
c  --- load the east boundary ---
c
c  --- get the gas conversion factor to umol/m3 ---
c
                                  if( imod .LE. ngas ) then
                                   convfac = densfac*273./
     &                               tpgrd(nx,j,k)*prgrd(nx,j,k)/1013.
                                  else
                                   convfac = 1.
                                  endif
                                  if( lbndry ) then
                                     ioff = IDXBES
                                  else
                                     ioff = 1
                                  endif
                                  iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                         nicddm + ndepddm + ioff - 1
                                  if( conest(k,j) .GT. bdnl(imod) ) then
                                    saconc(nx,j,k,iptr) = conest(k,j) * convfac
                                  else
                                    saconc(nx,j,k,iptr) = 0.0
                                  endif
                            enddo
c
c  --- load the south boundary ---
c
                            do i=1,nx
c
c  --- get the gas conversion factor to umol/m3 ---
c
                                  if( imod .LE. ngas ) then
                                   convfac = densfac*273./
     &                               tpgrd(i,1,k)*prgrd(i,1,k)/1013.
                                  else
                                   convfac = 1.
                                  endif
                                  if( lbndry ) then
                                     ioff = IDXBST
                                  else
                                     ioff = 1
                                  endif
                                  iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                          nicddm + ndepddm + ioff - 1
                                  if( consth(k,i) .GT. bdnl(imod) ) then
                                    saconc(i,1,k,iptr) = consth(k,i) * convfac
                                  else
                                    saconc(i,1,k,iptr) = 0.0
                                  endif
c
c  --- load the east boundary ---
c
c
c  --- get the gas conversion factor to umol/m3 ---
c
                                  if( imod .LE. ngas ) then
                                   convfac = densfac*273./
     &                               tpgrd(i,ny,k)*prgrd(i,ny,k)/1013.
                                  else
                                   convfac = 1.
                                  endif
                                  if( lbndry ) then
                                     ioff = IDXBNT
                                  else
                                     ioff = 1
                                  endif
                                  iptr = iptddm(imod) + (iddm-1)*nedge +
     &                                         nicddm + ndepddm + ioff - 1
                                  if( connth(k,i) .GT. bdnl(imod) ) then
                                    saconc(i,ny,k,iptr) = connth(k,i) * convfac
                                  else
                                    saconc(i,ny,k,iptr) = 0.0
                                  endif
                            enddo
                         enddo
                      endif
c
c  --- check the next BC DDM species ---
c
                   enddo
c
c  --- check the next modeled species ---
c
               endif
            enddo
c
c  --- read next species worth of data ---
c
         enddo
c
c  --- if not the right hour, read through it ---
c
      else
         do ispc=1,nspc
            do i=1,4
               read(iorbc,ERR=7007) 
            enddo
         enddo
         goto 111
      endif
c
c  --- finally got the right hour, close the file ---
c
      close(iorbc)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  BC file for DDM does not exist: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
 7001 continue 
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  Opening BC file for DDM: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  Reading header of BC file for DDM: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  BC input file for DDM is not labelled ',
     &                                                 'BOUNDARY.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  BC input file for DDM is not for correct ',
     &                                                   'time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',date
      write(iout,'(a,f10.1)') 'Time   : ',time
      write(iout,*) '   ***  BC File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  BC input file does not appear to be for ',
     &                ' the correct grid.' 
      write(iout,*) '   ***  Coarse Grid ***'
      write(iout,*) 'No. of Cells : (',ncol(1),',',nrow(1),')'
      write(iout,*) 'No. of layers:  ',nlay(1)
      write(iout,*) '   ***  BC File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  Premature end-of-file reached in BC file ',
     &                                                      'for DDM.'
      write(iout,*) 'Make sure the file contains the correct date/time.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDBCDDM:' 
      write(iout,*) 'ERROR:  Reading BC file for DDM: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine nstprep()
      use grid
      use filunit
      use tracer
c
c----CAMx v7.40 260801
c
c     NSTPREP sets up parameters for nested grids
c
c      Copyright Ramboll
c          
c     Modifications:
c        07/22/02  --gwilson--  Added code to fill in the source 
c                               area mappings for the nests
c        03/01/16  --gwilson--  Added partial source area map
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Routines Called:
c        PARNTCHD
c
c     Called by:
c        STARTUP
c
      include "camx.prm"
c                                   
      integer idprt(MXCELLS*MXCELLS*MXGRID)
c
      integer i, ipart, igrp
      logical long
c
c-----Entry point
c
c-----Identify parent-children relationship
c
      call  parntchd(ngrid,ncol,nrow,inst1,inst2,jnst1,jnst2,meshold,
     &               mapgrd,i1,i2,j1,j2,nmesh,nchdrn,idchdrn)
c
c---- echo the new order of grids ---
c
      write(idiag,*)
      write(idiag,*) '|',('-',i=1,74),'|'
      write(idiag,*) '|',(' ',i=1,74),'|'
      write(idiag,'(2A)') ' | NOTE:  The following table shows the ',
     &        'internal order of the nests as      |'
      write(idiag,'(2A)') 
     &          ' |        defined by the model.                ',
     &        '                             |'
      write(idiag,'(2A)') 
     &          ' |        The grid ID may have been re-calculated ',
     &                                  'by the model.             |'
      write(idiag,'(2A)') 
     &            ' |        The internal model order is the order in ',
     &    'which the nests will     |'
      write(idiag,'(2A)')
     &            ' |        appear in the fine grid output files.',
     &        '                             |'
      write(idiag,*) '|',(' ',i=1,74),'|'
      write(idiag,*) '|',('-',i=1,74),'|'
      write(idiag,*)
      write(idiag,*) '     Nest ID'
      write(idiag,*) ' Internal  Original   x-range      ncol     ',
     &                  '  y-range      nrow   mesh factor'
      do n = 2,ngrid
          i = mapgrd(n)
          write(idiag,'(1X,I5,4X,I5,2(3X,I5,3X,I5,3X,I5),5X,I5)')
     &          n,i,inst1(i),inst2(i),ncol(i),jnst1(i),jnst2(i),
     &                                              nrow(i),meshold(i)
      enddo
      write(idiag,*)
c
c-----Calculation of dx and dy for children grids
c
      do ip=1,ngrid
        do ic=1,nchdrn(ip)
          ig = idchdrn(ic,ip)
          nm = nmesh(ig)
          deltay(ig) = deltay(ip)/nm
          do j=j1(ig),j2(ig)
            do l=1,nm
              deltax((j-j1(ig))*nm + l + 1,ig) = deltax(j,ip)/nm
            enddo
          enddo
          deltax(1,ig) = deltax(j1(ig)-1,ip)/nm
          deltax(nrow(ig),ig) = deltax(j2(ig)+1,ip)/nm
        enddo
      enddo
c
c-----Define idfine for the area where fine cells exist
c
c-----Default: no fine cells
c
      idx = 1
      do igrid = 1,ngrid
        do n=1,ncol(igrid)*nrow(igrid)
          idfin(idx) = 0
          idx = idx + 1
        enddo
      enddo
c
c-----Determine idfin where fine grids exist
c
      do ip=1,ngrid
        ip_map = mapgrd(ip)
        long = .FALSE.
        do j = nrow(ip_map),1,-1 
          is = 1 + (j-1)*ncol(ip_map)
          ie = j*ncol(ip_map)
          do i=is,ie
           idprt(iptr2d(ip_map)-1+i) = ip
          enddo
        enddo
        do ic=1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          do j = j1(igrd),j2(igrd)
            do i = i1(igrd),i2(igrd) 
              idx = i + (j-1)*ncol(ip_map)
              idfin(iptr2d(ip_map)-1+idx) = igrd 
              idprt(iptr2d(ip_map)-1+idx) = igrd 
              if( ip .GE. 10 .OR. igrd .GE. 10 ) long = .TRUE.
            enddo 
          enddo 
        enddo   
        if( nchdrn(ip) .GT. 0 ) then 
          write(idiag,*)
          write(idiag,'(2A,I3)') ' The following map shows the ',
     &            'location of nests in grid #',ip
          do j = nrow(ip_map),1,-1 
            is = 1 + (j-1)*ncol(ip_map)
            ie = j*ncol(ip_map)
            if( .NOT. long ) then
                write(idiag,'(300i1)') 
     &                        (idprt(iptr2d(ip_map)-1+i),i=is,ie)
            else
                write(idiag,'(300i2)') 
     &                        (idprt(iptr2d(ip_map)-1+i),i=is,ie)
            endif
          enddo
        endif
      enddo
      write(idiag,*)
c        
c======================== Source Apportion Begin =======================
c                                   
c
c========================= Source Apportion End ========================
c
      return
      end

!**** NCF_WRT_VARS_SPECIES
!
      subroutine ncf_wrt_vars_species(action,iounit,numcols,numrows,numlays, &
                       nspcs,spnames,spunits,splong,spdesc,spcoord,num_dims)
      use camx_includes
      use chmstry
      use filunit
      use ncf_iomod
      implicit none
!
!----CAMx v7.40 260801
!
!-----------------------------------------------------------------------
!    Description:
!-----------------------------------------------------------------------
!
!   This routine writes the variable definitions and descriptions to 
!    the NetCDF file
!
!      Copyright Ramboll
!
!      Argument description:
!       Inputs:
!           action   C  name of file to open
!           iounit   I  NetCDF file ID of file
!           numcols  I  number of columns in the grid
!           numrows  I  number of columns in the grid
!           numlays  I  number of columns in the grid
!           numcols  I  number of columns in the grid
!           nspcs    I  number of species in the file
!           spnames  C  names of each species
!           spunits  C  units for each species
!           splong   C  long name for each species
!           spdesc   C  description of each species
!           spcoord  C  description of each species
!           num_dims I  number of dimensions in variable
!       Outputs:
!
!-----------------------------------------------------------------------
!    LOG:
!-----------------------------------------------------------------------
!
!     02/20/17   --gwilson--    Original development
!
!-----------------------------------------------------------------------
!    Include files:
!-----------------------------------------------------------------------
!
      include 'netcdf.inc'
!
!-----------------------------------------------------------------------
!    Argument declarations:
!-----------------------------------------------------------------------
!
      character*(*) action
      integer       iounit
      integer       numcols
      integer       numrows
      integer       numlays
      integer       nspcs
      character*(*) spnames(nspcs)
      character*(*) spunits(nspcs)
      character*(*) splong(nspcs)
      character*(*) spdesc(nspcs)
      character*(*) spcoord(nspcs)
      integer       num_dims
!
!-----------------------------------------------------------------------
!    External functions:
!-----------------------------------------------------------------------
!
      integer istrln
!
!-----------------------------------------------------------------------
!    Local variables:
!-----------------------------------------------------------------------
!
      character*14 this_species
      integer      ierr, ispc, spec_dimid(4), spec_chunk(4), spec_varid
!
!-----------------------------------------------------------------------
!    Entry point:
!-----------------------------------------------------------------------
!
      spec_chunk(1) = INT(REAL(numcols)/NCF_CHUNK_SIZE_VAR_X)
      if( spec_chunk(1) .GT. numcols ) goto 7002
      spec_chunk(2) = INT(REAL(numrows)/NCF_CHUNK_SIZE_VAR_Y)
      if( spec_chunk(2) .GT. numrows ) goto 7003
      spec_chunk(3) = MAX(1,INT(numlays/2))
      spec_chunk(4) = 1
!
      spec_dimid(1) = ncf_col_dimid
      spec_dimid(2) = ncf_row_dimid
      spec_dimid(3) = ncf_lay_dimid
      spec_dimid(4) = ncf_tstep_dimid
!
      if( num_dims .EQ.  3) then
         spec_dimid(3) = ncf_tstep_dimid
         spec_chunk(3) = 1
      endif
      do ispc=1,nspcs
!
!  --- define everything for this species ---
!
        this_species = spnames(ispc)(:istrln(spnames(ispc)))
        ncf_species_units = spunits(ispc)
        ncf_species_long_name = splong(ispc)
        ncf_species_var_desc = spdesc(ispc)
        ncf_species_coordinates = spcoord(ispc)
!
!  --- define the variable ---
!
        ierr = nf_def_var(iounit,this_species(:istrln(this_species)),  &
                          NF_FLOAT, num_dims, spec_dimid, spec_varid)
        if( ierr .NE. NF_NOERR ) goto 7000
!
!  --- add the attributes ---
!
        ierr = nf_put_att_text(iounit,spec_varid,'long_name', &
                istrln(ncf_species_long_name),ncf_species_long_name)
        if( ierr .NE. NF_NOERR ) goto 7000

        ierr = nf_put_att_text(iounit,spec_varid,'units', &
                        istrln(ncf_species_units),ncf_species_units)
        if( ierr .NE. NF_NOERR ) goto 7000

        ierr = nf_put_att_text(iounit,spec_varid,'var_desc', &
                  istrln(ncf_species_var_desc),ncf_species_var_desc)
        if( ierr .NE. NF_NOERR ) goto 7000

        ierr = nf_put_att_text(iounit,spec_varid,'coordinates', &
                 istrln(ncf_species_coordinates),ncf_species_coordinates)
        if( ierr .NE. NF_NOERR ) goto 7000
!
!  --- chunkers go here ... Irie! ----
!
#ifdef CHUNK
        if( ncf_compress ) then
          ierr = nf_def_var_chunking(iounit, spec_varid, &
                                            NF_CHUNKED, spec_chunk)
          if( ierr .NE. NF_NOERR ) goto 7001
!
          ierr = nf_def_var_deflate(iounit, spec_varid, NCF_SHUFFLE,  &
                                      NCF_DEFLATE, NCF_DEFLATE_LEVEL )
          if( ierr .NE. NF_NOERR ) goto 7001
        endif
#endif
!
      enddo
!
      goto 9999
!
!-----------------------------------------------------------------------
!    Error messages:
!-----------------------------------------------------------------------
!
 7000 continue
      write(iout,'(//,A)') 'ERROR in NCF_WRT_VARS_SPECIES:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot create file variable for species: ', &
                                    this_species(:istrln(this_species))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
!
 7001 continue
      write(iout,'(//,A)') 'ERROR in NCF_WRT_VARS_SPECIES:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot set chunk parameters for species: ', &
                                    this_species(:istrln(this_species))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
!
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_IODAT.INC:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot set chunk parameters for this file.'
      write(iout,'(2A,/,A)') 'The NCF_CHUNK_SIZE_VAR_X parameter causes the ', &
           'chunk value to be larger','than the number of columns.'
      write(iout,'(A,I3,A,I4)') 'Number of columns: ',numcols
      call camxerr()
!
 7003 continue
      write(iout,'(//,A)') 'ERROR in NCF_IODAT.INC:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot set chunk parameters for this file.'
      write(iout,'(2A,/,A)') 'The NCF_CHUNK_SIZE_VAR_Y parameter causes the ', &
           'chunk value to be larger','than the number of rows.'
      write(iout,'(A,I3,A,I4)') 'Number of rows: ',numrows
      call camxerr()
!
!-----------------------------------------------------------------------
!    Return point:
!-----------------------------------------------------------------------
!
 9999 continue
      return
      end

      subroutine pigmscl(nspcs,ngrid,chtime,chdate,idiag,pigdump,pgmserr)
      use pigsty
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGMSCL calculates total mass in all PiG puffs by grid
c
c      Copyright Ramboll
c
c     Modifications:
c        02/02/06            Renamed PIGMSCL from IRONMSCL
c        03/31/08            Added average puff age when killed
c
c     Input arguments:
c        nspcs               number of species
c        ngrid               number of grids
c        chtime              model time ('HH:MM:SS')
c        chdate              model date ('YY/MM/DD')
c        idiag               Diagnostic file unit number
c        pigdump             PiG dumped mass (umol)
c        pgmserr             error in PiG dumped mass (umol)
c
c     Output arguments:
c        none
c
c     Subroutines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
      integer nspcs, ngrid,idiag,igrd,l,n,nr,is
      real*8  pigmass(nspcs,ngrid)
      real*8  pigdump(nspcs,ngrid)
      real*8  pgmserr(nspcs,ngrid)

      real*8 relerr
      character*8 chdate,chtime
c
c-----Entry point
c
      do igrd = 1,ngrid
        npigon(igrd) = 0
        do l = 1,nspec
          pigmass(l,igrd) = 0.
        enddo
      enddo
c
      do n = 1,npig
        igrd = ingrd(n)
        if (igrd.ne.0) then
          npigon(igrd) = npigon(igrd) + 1
          do nr = 1,nreactr
            do l = 1,nspec
              pigmass(l,igrd) =  pigmass(l,igrd) + DBLE(puffmass(l,nr,n))
            enddo
          enddo
        endif
      enddo
c
      write(idiag,'(/,a,2x,a8,2x,a8)')
     &                      'PiG diagnostics at: ',chtime,chdate
      write(idiag,'(a,i5)') '# puffs killed by size      : ',nkill(1)
      write(idiag,'(a,i5)') '# puffs killed by mass/age  : ',nkill(2)
      write(idiag,'(a,i5)') '# puffs killed by bgnd LSODE: ',nkill(3)
      write(idiag,'(a,i5)') '# puffs killed by puff LSODE: ',nkill(4)
      write(idiag,'(a,i5)') '# puffs killed by stage 3   : ',nkill(5)
c     write(idiag,'(a,i5)') '# puffs killed by bgnd AQPM : ',nkill(6)
c     write(idiag,'(a,i5)') '# puffs killed by puff AQPM : ',nkill(7)
c     write(idiag,'(a,i5)') '# puffs killed by bgnd PM   : ',nkill(8)
      write(idiag,'(a,i5)') '# puffs killed by puff PM   : ',nkill(9)

      do igrd = 1,ngrid 
        write(idiag,'(a,i5,a,i5)') '# active puffs in grid: ',igrd, 
     &                             ' is ',npigon(igrd) 
        write(idiag,'(a,i5,a,i5)') '# puffs killed in grid: ',igrd, 
     &                             ' is ',nage(igrd) 
        if (nage(igrd).gt.0) then
          write(idiag,'(a,f5.0,a)') 'Average puff age when killed is: ',
     &                            pigage(igrd)/nage(igrd)/60.,' minutes'
        endif
        write(idiag,'(a,a)')
     &  'PiG mass:    Total (mol)  Dumped (mol)   Error (mol)',
     &  '     Error (%)'
        nage(igrd) = 0
        pigage(igrd) = 0.

        do is = 1,nspec
          if (abs(pigdump(is,igrd)).gt.0.) then
            relerr = 100.*pgmserr(is,igrd)/abs(pigdump(is,igrd))
          else
            relerr = 0.
          endif
          write(idiag,'(a,4(4x,1pe10.3))')
     &       spname(is),pigmass(is,igrd)/1.d6,pigdump(is,igrd)/1.d6,
     &       pgmserr(is,igrd)/1.d6,relerr
        enddo
      enddo 

      nkill(1) = 0
      nkill(2) = 0
      nkill(3) = 0
      nkill(4) = 0
      nkill(5) = 0
      nkill(6) = 0
      nkill(7) = 0
      nkill(8) = 0
      nkill(9) = 0
c
      return
      end

c**** KSCI
c
      subroutine ksci(temp, pres)
      use rtcmcchm
c 
c----CAMx v7.40 260801
c 
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     KSCI calculates temperature/pressure-dependent rate constants
c     for the RTRAC CMC solver.  The rate expressions follow the
c     SCICHEM conventions
c
c     The SCICHEM expression types supported are:
c
c     ID_RAD  = 0 Radiation dependent reaction rate identifier
c     ID_CONS = 1 Constant reaction rate identifier
c     ID_TEMP = 2 Temperature dependent reaction rate identifier
c     ID_PRES = 3 Pressure dependent reaction rate identifier
c     ID_H2O  = 4 H2O dependent reaction rate identifier
c     ID_M    = 5 M dependent reaction rate identifier
c     ID_LWC  = 6 LWC (and drop diam) dependent reaction rate identifier
c     ID_PRES2= 7 Pressure (type 2) dependent reaction rate identifier
c     ID_EQM  = 8 reverse decomposition rate dependent on forward rate
c     ID_O2   = 9 O2 dependent reaction rate identifier
c     ID_N2   =10 N2 dependent reaction rate identifier
c     ID_FOFF1=11 Falloff (type 1) reaction rate identifier
c     ID_FOFF2=12 Falloff (type 2) reaction rate identifier
c     ID_FOFF3=13 Falloff (type 3) reaction rate identifier
c     ID_CH4  =14 CH4 dependent reaction rate identifier
c     ID_H2OB =15 H2O dependent (type 2) reaction rate identifier
c 
c      Copyright Ramboll
c
c     Argument description:
c      Inputs:
c       temp         R     temperature (K)
c       pres         R     pressure (mbar)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c    13/04/07   --gyarwood--    Rate expressions for SCICHEM2012
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      real    temp, pres
c 
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      double precision darren
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real*8     cf1
      parameter (cf1 = 2.462D13)
c
      integer    i, iord, ityp, iref
      real*8     cf, cfm, rktmp, ppmpres, factor, t2h
      real*8     dpres, dtemp, dtemp2, dtemp3
      real*8     ratio, rk0, rk1, rk2, rk3
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      dpres = DBLE(pres)
      dtemp = DBLE(temp)
      dtemp2 = dtemp*dtemp
      dtemp3 = dtemp2*dtemp
c
c --- Conversions from molecule cm-3 to ppm and from hr to min to sec
c       cf1 from gas law: (n/V) = NP/RT
c       cf1 = (6.022e23 * 1.013e5 * 1e-12 ) / (8.314 * 298.0)
c     The cf1 conversion is at 298 K and 1013 mb and the
c     adjustment "factor" below generalises to other conditions
c
      if( itunit .EQ. 1 ) then
         t2h = 3600.0D0
      elseif( itunit .EQ. 2 ) then
         t2h = 60.0D0
      else
         t2h = 1.0D0
      endif
c
      do i = 1,nrxnrtc
        ityp = ityprtc(i)
        iord = max(1, nrct(i))
        if (icunit .EQ. 1) then
          cf  = cf1**DBLE((iord-1))
          cfm = cf1**DBLE((iord))
        else
          cf  = 1.0D0
          cfm = 1.0D0
        endif
        ppmpres = 1.0D6*dpres/1013.0D0
        factor = ( (298.D0/dtemp)*(dpres/1013.D0) )**DBLE((iord-1))
c
c --- Note that SCICHEM rate expression types are offset by +100
c     For reference: function darren(a,ea,b,tref,temp)
c                    darren = a*((temp/tref)**b)*dexp(-ea/temp)
c
c Intialize rate constants to zero
c
        rkrtc(i) = 0.0D0
c
c Type 0 is photolysis so nothing to do here
c
c Type 1 is a constant value; adjust for conc and time units
c
        if (ityp.EQ.101) then
          rkrtc(i) = DBLE(rkprmrtc(i,1))*cf*t2h
c
c Type 2 is k = A * B^T * exp(C/T)
c
        elseif (ityp.EQ.102) then
          rkrtc(i) = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                      DBLE(rkprmrtc(i,3)),300.0D0,dtemp)*cf*t2h
c
c Type 3 is Troe with k0 and kinf set = A * B^T and F = 0.6
c
        elseif (ityp.EQ.103) then
          rk0 = darren(DBLE(rkprmrtc(i,1)),0.0D0,DBLE(rkprmrtc(i,2)),
     &                               300.0D0,dtemp)*cfm*ppmpres
          ratio = rk0/(darren(DBLE(rkprmrtc(i,3)),0.0D0,
     &                         DBLE(rkprmrtc(i,4)),300.0D0,dtemp)*cf)
          rkrtc(i) = (rk0/(1.0D0+ratio))*0.6D0**(1.0D0/(1.0D0+
     &                                        LOG10(ratio)**2))*t2h
c
c Type 4 is type 2 with embedded [H2O] in ppm
c
        elseif (ityp.EQ.104) then
          rkrtc(i) = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                  DBLE(rkprmrtc(i,3)),300.0D0,dtemp)*t2h*cf/cf1
c
c Use of type 2 with embedded M, O2, N2, CH4, H2O, O2*M, H2
c
        elseif (ityp.EQ.105 .OR. ityp.EQ.109 .OR. ityp.EQ.110
     &             .OR. ityp.EQ.114 .OR. ityp.EQ.115
     &             .OR. ityp.EQ.117
     &             .OR. ityp.EQ.121 ) then
          rkrtc(i) = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                      DBLE(rkprmrtc(i,3)),300.0D0,dtemp)*cf*t2h
c
c Type 6 involves cloud water and is not supported
c
c
c k = k0 * (1 + 0.6*P) used for OH + CO
c
        elseif (ityp.EQ.107) then
          rkrtc(i) = DBLE(rkprmrtc(i,1))
     &                    * ( 1.0D0 + 0.6D0*ppmpres/1.0D6 )*t2h
c
c Type 8 sets a ratio to another rate constant k2 = k1 / ratio
c with ratio set using type 3 expression
c
        elseif (ityp.EQ.108) then
          factor = 1.0D0
          iref = NINT(rkprmrtc(i,1))
          if (icunit .EQ. 2) 
     &       cf  = cf1**(nrct(iref)-iord)
          rktmp = darren(DBLE(rkprmrtc(i,2)),
     &               DBLE(-rkprmrtc(i,3)),0.0D0,300.0D0,dtemp)*cf
          rkrtc(i) = rkrtc(iref) / rktmp 
c
c Troe with k0 and kinf set  = A * (B/300)^T
c
        elseif (ityp.EQ.111 .OR. ityp.EQ.112) then
          rk0 = darren(DBLE(rkprmrtc(i,1)),0.0D0,DBLE(rkprmrtc(i,2)),
     &                               300.0D0,dtemp)*cfm*ppmpres
          ratio = rk0/(darren(DBLE(rkprmrtc(i,3)),0.0D0,
     &                        DBLE(rkprmrtc(i,4)),300.0D0,dtemp)*cf)
          rkrtc(i) = (rk0/(1.0D0+ratio))*0.6D0**(1.0D0/(1.0D0+
     &                                        LOG10(ratio)**2))*t2h
c
c Type 13 is Lindeman-Hinshelwood used for OH + HNO3
c
        elseif (ityp.EQ.113) then
          rk1 = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                      0.0D0,300.0D0,dtemp)*cf
          rk2 = darren(DBLE(rkprmrtc(i,3)),DBLE(-rkprmrtc(i,4)),
     &                      0.0D0,300.0D0,dtemp)*cf
          rk3 = darren(DBLE(rkprmrtc(i,5)),DBLE(-rkprmrtc(i,6)),
     &                      0.0D0,300.0D0,dtemp)*cfm
          rkrtc(i) = ( rk1 + (rk3*ppmpres /
     &                    (1.0D0 + (rk3*ppmpres / rk2) ) ) )*t2h
c
c Type 22 is  k = A * (B/300)^T * exp(C/T); type 16 has M & O2 embedded
c (like Type 3 but with Tref = 300)
c
        elseif (ityp.EQ.116 .OR. ityp.EQ.122) then
          rkrtc(i) = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                      DBLE(rkprmrtc(i,3)),300.0D0,dtemp)*cf*t2h
c
c Type 18 is the full Troe with Fc and k = A * B^T * exp(C/T)
c
        elseif (ityp.EQ.118) then
          rk0 = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,3)),
     &              DBLE(rkprmrtc(i,2)),300.0D0,dtemp)*cfm*ppmpres
          ratio = rk0/(darren(DBLE(rkprmrtc(i,4)),DBLE(-rkprmrtc(i,6)),
     &                        DBLE(rkprmrtc(i,5)),300.0D0,dtemp)*cf)
          rkrtc(i) = (rk0/(1.0D0+ratio))*DBLE(rkprmrtc(i,7))**(1.0D0/(1.0D0+
     &                                        LOG10(ratio)**2))*t2h
c
c Type 19 and 20 are pressure dependent k = k0 + k1 * M
c with 20 having H2O embedded
c
        elseif (ityp.EQ.119 .OR. ityp.EQ.120) then
          rk1 = darren(DBLE(rkprmrtc(i,1)),DBLE(-rkprmrtc(i,2)),
     &                      0.0D0,300.0D0,dtemp)*cf
          rk2 = darren(DBLE(rkprmrtc(i,3)),DBLE(-rkprmrtc(i,4)),
     &                      0.0D0,300.0D0,dtemp)*cfm
          rkrtc(i) = ( rk1 + (rk2*ppmpres) )*t2h
c
        endif
        rkrtc(i) =  rkrtc(i)*factor
        srkrtc(i) =  SNGL( rkrtc(i) )
      enddo
c
      return
      end

c*** WSRFSA
c
      subroutine wsfcsa(ngrd, iendat, endtim, nox, noy, noz, nspsa, saavrg)
      use camxcom
      use tracer
      use filunit
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the surface concentrations for the tracer
c     species.
c
c      Copyright Ramboll
c
c    Argument description:
c      ngrd    I  grid index
c      iendat  I  ending date for this hour
c      endtim  R  ending time for this hour
c      nox     I  number of X cells in domain
c      noy     I  number of Y cells in domain
c      noz     I  number of layers in domain
c      nspsa   I  number of species
c      saavrg  R  array of surface concentrations (average)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       integer   ngrd
       integer   iendat
       real      endtim
       integer   nox
       integer   noy
       integer   noz
       integer   nspsa
       real      saavrg(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer       idate, jdate, ibegcel iendcel, jbegcel, jendcel
      integer       isegmt, i, j, l, nspcout, k
      character*4   ispec(10,MXTRSP)
      real          btim, etim
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ibegcel = 1
      iendcel = nox
      jbegcel = 1
      jendcel = noy
      if( ngrd .GT. 1 ) then
        ibegcel = 2
        iendcel = nox-1
        jbegcel = 2
        jendcel = noy-1
      endif
c
c   ---- put species names into integer array ----
c 
      isegmt = 1
      nspcout = 0
      do 10 j=1,ntotsp
          if( loutsa(j) ) then
             nspcout = nspcout + 1
             read(ptname(j),'(10A1)') (ispec(i,j),i=1,10)
          endif
   10 continue
c
c  --- write the surface concentration file if requested ----
c
      if( lsfcfl ) then
c
c   --- set up the dates and times for the surface file ---
c
          jdate = iendat
          etim = AINT(ANINT(endtim)/100.) + amod(ANINT(endtim),100.)/60.
          idate = jdate
          btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
          if( btim .LT. 0. ) then
              btim = btim + 24.0
              idate = idate - 1
              if (MOD(idate,1000) .EQ. 0 ) then
                if ( MOD(INT(idate/1000)-1,4) .EQ. 0 ) then
                  idate = (INT(idate/1000)-1)*1000 + 366
                else
                  idate = (INT(idate/1000)-1)*1000 + 365
                end if
              endif
          endif
          write(iowsfc(ngrd),ERR=7000) idate, btim, jdate, etim
          do 40 l=1,nsaspc
            do k = 1,noz
              if( loutsa(l) ) write(iowsfc(ngrd)) isegmt, 
     &           (ispec(i,l),i=1,10),((saavrg(i,j,k,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
            enddo
   40     continue
          if( ntrtim .GT. 0 ) then
             do 50 l=nsaspc+1,ntotsp
               do k = 1,noz
                  write(iowsfc(ngrd)) isegmt, (ispec(i,l),i=1,10), 
     &                                        ((0.0,i=2,nox-1),j=2,noy-1)
               enddo
   50        continue
          endif
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in WSFCSA:'
      write(iout,9000,ERR=9999)'Writing output tracer file: ',
     &                           sfcfil(ngrd)(:istrln(sfcfil(ngrd)))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,2A)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      SUBROUTINE RODAS(N,FCN,IFCN,X,Y,XEND,H,
     &                  RTOL,ATOL,ITOL,
     &                  JAC ,IJAC,MLJAC,MUJAC,DFX,IDFX,
     &                  MAS ,IMAS,MLMAS,MUMAS,
     &                  SOLOUT,IOUT,
     &                  WORK,LWORK,IWORK,LIWORK,RPAR,IPAR,IDID)
C ----------------------------------------------------------
C     NUMERICAL SOLUTION OF A STIFF (OR DIFFERENTIAL ALGEBRAIC)
C     SYSTEM OF FIRST 0RDER ORDINARY DIFFERENTIAL EQUATIONS  MY'=F(X,Y).
C     THIS IS AN EMBEDDED ROSENBROCK METHOD OF ORDER (3)4  
C     (WITH STEP SIZE CONTROL).
C     C.F. SECTIONS IV.7  AND VI.3
C
C     AUTHORS: E. HAIRER AND G. WANNER
C              UNIVERSITE DE GENEVE, DEPT. DE MATHEMATIQUES
C              CH-1211 GENEVE 24, SWITZERLAND 
C              E-MAIL:  Ernst.Hairer@math.unige.ch
C                       Gerhard.Wanner@math.unige.ch
C     
C     THIS CODE IS PART OF THE BOOK:
C         E. HAIRER AND G. WANNER, SOLVING ORDINARY DIFFERENTIAL
C         EQUATIONS II. STIFF AND DIFFERENTIAL-ALGEBRAIC PROBLEMS.
C         SPRINGER SERIES IN COMPUTATIONAL MATHEMATICS 14,
C         SPRINGER-VERLAG 1991, SECOND EDITION 1996.
C      
C     VERSION OF OCTOBER 28, 1996
C
C     INPUT PARAMETERS  
C     ----------------  
C     N           DIMENSION OF THE SYSTEM 
C
C     FCN         NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE
C                 VALUE OF F(X,Y):
C                    SUBROUTINE FCN(N,X,Y,F,RPAR,IPAR)
C                    DOUBLE PRECISION X,Y(N),F(N)
C                    F(1)=...   ETC.
C                 RPAR, IPAR (SEE BELOW)
C
C     IFCN        GIVES INFORMATION ON FCN:
C                    IFCN=0: F(X,Y) INDEPENDENT OF X (AUTONOMOUS)
C                    IFCN=1: F(X,Y) MAY DEPEND ON X (NON-AUTONOMOUS)
C
C     X           INITIAL X-VALUE
C
C     Y(N)        INITIAL VALUES FOR Y
C
C     XEND        FINAL X-VALUE (XEND-X MAY BE POSITIVE OR NEGATIVE)
C
C     H           INITIAL STEP SIZE GUESS;
C                 FOR STIFF EQUATIONS WITH INITIAL TRANSIENT, 
C                 H=1.D0/(NORM OF F'), USUALLY 1.D-2 OR 1.D-3, IS GOOD.
C                 THIS CHOICE IS NOT VERY IMPORTANT, THE CODE QUICKLY
C                 ADAPTS ITS STEP SIZE (IF H=0.D0, THE CODE PUTS H=1.D-6).
C
C     RTOL,ATOL   RELATIVE AND ABSOLUTE ERROR TOLERANCES. THEY
C                 CAN BE BOTH SCALARS OR ELSE BOTH VECTORS OF LENGTH N.
C
C     ITOL        SWITCH FOR RTOL AND ATOL:
C                   ITOL=0: BOTH RTOL AND ATOL ARE SCALARS.
C                     THE CODE KEEPS, ROUGHLY, THE LOCAL ERROR OF
C                     Y(I) BELOW RTOL*ABS(Y(I))+ATOL
C                   ITOL=1: BOTH RTOL AND ATOL ARE VECTORS.
C                     THE CODE KEEPS THE LOCAL ERROR OF Y(I) BELOW
C                     RTOL(I)*ABS(Y(I))+ATOL(I).
C
C     JAC         NAME (EXTERNAL) OF THE SUBROUTINE WHICH COMPUTES
C                 THE PARTIAL DERIVATIVES OF F(X,Y) WITH RESPECT TO Y
C                 (THIS ROUTINE IS ONLY CALLED IF IJAC=1; SUPPLY
C                 A DUMMY SUBROUTINE IN THE CASE IJAC=0).
C                 FOR IJAC=1, THIS SUBROUTINE MUST HAVE THE FORM
C                    SUBROUTINE JAC(N,X,Y,DFY,LDFY,RPAR,IPAR)
C                    DOUBLE PRECISION X,Y(N),DFY(LDFY,N)
C                    DFY(1,1)= ...
C                 LDFY, THE COLOMN-LENGTH OF THE ARRAY, IS
C                 FURNISHED BY THE CALLING PROGRAM.
C                 IF (MLJAC.EQ.N) THE JACOBIAN IS SUPPOSED TO
C                    BE FULL AND THE PARTIAL DERIVATIVES ARE
C                    STORED IN DFY AS
C                       DFY(I,J) = PARTIAL F(I) / PARTIAL Y(J)
C                 ELSE, THE JACOBIAN IS TAKEN AS BANDED AND
C                    THE PARTIAL DERIVATIVES ARE STORED
C                    DIAGONAL-WISE AS
C                       DFY(I-J+MUJAC+1,J) = PARTIAL F(I) / PARTIAL Y(J).
C
C     IJAC        SWITCH FOR THE COMPUTATION OF THE JACOBIAN:
C                    IJAC=0: JACOBIAN IS COMPUTED INTERNALLY BY FINITE
C                       DIFFERENCES, SUBROUTINE "JAC" IS NEVER CALLED.
C                    IJAC=1: JACOBIAN IS SUPPLIED BY SUBROUTINE JAC.
C
C     MLJAC       SWITCH FOR THE BANDED STRUCTURE OF THE JACOBIAN:
C                    MLJAC=N: JACOBIAN IS A FULL MATRIX. THE LINEAR
C                       ALGEBRA IS DONE BY FULL-MATRIX GAUSS-ELIMINATION.
C                    0<=MLJAC<N: MLJAC IS THE LOWER BANDWITH OF JACOBIAN 
C                       MATRIX (>= NUMBER OF NON-ZERO DIAGONALS BELOW
C                       THE MAIN DIAGONAL).
C
C     MUJAC       UPPER BANDWITH OF JACOBIAN  MATRIX (>= NUMBER OF NON-
C                 ZERO DIAGONALS ABOVE THE MAIN DIAGONAL).
C                 NEED NOT BE DEFINED IF MLJAC=N.
C
C     DFX         NAME (EXTERNAL) OF THE SUBROUTINE WHICH COMPUTES
C                 THE PARTIAL DERIVATIVES OF F(X,Y) WITH RESPECT TO X
C                 (THIS ROUTINE IS ONLY CALLED IF IDFX=1 AND IFCN=1;
C                 SUPPLY A DUMMY SUBROUTINE IN THE CASE IDFX=0 OR IFCN=0).
C                 OTHERWISE, THIS SUBROUTINE MUST HAVE THE FORM
C                    SUBROUTINE DFX(N,X,Y,FX,RPAR,IPAR)
C                    DOUBLE PRECISION X,Y(N),FX(N)
C                    FX(1)= ...
C                
C     IDFX        SWITCH FOR THE COMPUTATION OF THE DF/DX:
C                    IDFX=0: DF/DX IS COMPUTED INTERNALLY BY FINITE
C                       DIFFERENCES, SUBROUTINE "DFX" IS NEVER CALLED.
C                    IDFX=1: DF/DX IS SUPPLIED BY SUBROUTINE DFX.
C
C     ----   MAS,IMAS,MLMAS, AND MUMAS HAVE ANALOG MEANINGS      -----
C     ----   FOR THE "MASS MATRIX" (THE MATRIX "M" OF SECTION IV.8): -
C
C     MAS         NAME (EXTERNAL) OF SUBROUTINE COMPUTING THE MASS-
C                 MATRIX M.
C                 IF IMAS=0, THIS MATRIX IS ASSUMED TO BE THE IDENTITY
C                 MATRIX AND NEEDS NOT TO BE DEFINED;
C                 SUPPLY A DUMMY SUBROUTINE IN THIS CASE.
C                 IF IMAS=1, THE SUBROUTINE MAS IS OF THE FORM
C                    SUBROUTINE MAS(N,AM,LMAS,RPAR,IPAR)
C                    DOUBLE PRECISION AM(LMAS,N)
C                    AM(1,1)= ....
C                    IF (MLMAS.EQ.N) THE MASS-MATRIX IS STORED
C                    AS FULL MATRIX LIKE
C                         AM(I,J) = M(I,J)
C                    ELSE, THE MATRIX IS TAKEN AS BANDED AND STORED
C                    DIAGONAL-WISE AS
C                         AM(I-J+MUMAS+1,J) = M(I,J).
C
C     IMAS       GIVES INFORMATION ON THE MASS-MATRIX:
C                    IMAS=0: M IS SUPPOSED TO BE THE IDENTITY
C                       MATRIX, MAS IS NEVER CALLED.
C                    IMAS=1: MASS-MATRIX  IS SUPPLIED.
C
C     MLMAS       SWITCH FOR THE BANDED STRUCTURE OF THE MASS-MATRIX:
C                    MLMAS=N: THE FULL MATRIX CASE. THE LINEAR
C                       ALGEBRA IS DONE BY FULL-MATRIX GAUSS-ELIMINATION.
C                    0<=MLMAS<N: MLMAS IS THE LOWER BANDWITH OF THE
C                       MATRIX (>= NUMBER OF NON-ZERO DIAGONALS BELOW
C                       THE MAIN DIAGONAL).
C                 MLMAS IS SUPPOSED TO BE .LE. MLJAC.
C
C     MUMAS       UPPER BANDWITH OF MASS-MATRIX (>= NUMBER OF NON-
C                 ZERO DIAGONALS ABOVE THE MAIN DIAGONAL).
C                 NEED NOT BE DEFINED IF MLMAS=N.
C                 MUMAS IS SUPPOSED TO BE .LE. MUJAC.
C
C     SOLOUT      NAME (EXTERNAL) OF SUBROUTINE PROVIDING THE
C                 NUMERICAL SOLUTION DURING INTEGRATION. 
C                 IF IOUT=1, IT IS CALLED AFTER EVERY SUCCESSFUL STEP.
C                 SUPPLY A DUMMY SUBROUTINE IF IOUT=0. 
C                 IT MUST HAVE THE FORM
C                    SUBROUTINE SOLOUT (NR,XOLD,X,Y,CONT,LRC,N,
C                                       RPAR,IPAR,IRTRN)
C                    DOUBLE PRECISION X,Y(N),CONT(LRC)
C                    ....  
C                 SOLOUT FURNISHES THE SOLUTION "Y" AT THE NR-TH
C                    GRID-POINT "X" (THEREBY THE INITIAL VALUE IS
C                    THE FIRST GRID-POINT).
C                 "XOLD" IS THE PRECEEDING GRID-POINT.
C                 "IRTRN" SERVES TO INTERRUPT THE INTEGRATION. IF IRTRN
C                    IS SET <0, RODAS RETURNS TO THE CALLING PROGRAM.
C           
C          -----  CONTINUOUS OUTPUT: -----
C                 DURING CALLS TO "SOLOUT", A CONTINUOUS SOLUTION
C                 FOR THE INTERVAL [XOLD,X] IS AVAILABLE THROUGH
C                 THE FUNCTION
C                        >>>   CONTRO(I,S,CONT,LRC)   <<<
C                 WHICH PROVIDES AN APPROXIMATION TO THE I-TH
C                 COMPONENT OF THE SOLUTION AT THE POINT S. THE VALUE
C                 S SHOULD LIE IN THE INTERVAL [XOLD,X].
C           
C     IOUT        GIVES INFORMATION ON THE SUBROUTINE SOLOUT:
C                    IOUT=0: SUBROUTINE IS NEVER CALLED
C                    IOUT=1: SUBROUTINE IS USED FOR OUTPUT
C
C     WORK        ARRAY OF WORKING SPACE OF LENGTH "LWORK".
C                 SERVES AS WORKING SPACE FOR ALL VECTORS AND MATRICES.
C                 "LWORK" MUST BE AT LEAST
C                             N*(LJAC+LMAS+LE1+14)+20
C                 WHERE
C                    LJAC=N              IF MLJAC=N (FULL JACOBIAN)
C                    LJAC=MLJAC+MUJAC+1  IF MLJAC<N (BANDED JAC.)
C                 AND                  
C                    LMAS=0              IF IMAS=0
C                    LMAS=N              IF IMAS=1 AND MLMAS=N (FULL)
C                    LMAS=MLMAS+MUMAS+1  IF MLMAS<N (BANDED MASS-M.)
C                 AND
C                    LE1=N               IF MLJAC=N (FULL JACOBIAN)
C                    LE1=2*MLJAC+MUJAC+1 IF MLJAC<N (BANDED JAC.).
C                 IN THE USUAL CASE WHERE THE JACOBIAN IS FULL AND THE
C                 MASS-MATRIX IS THE INDENTITY (IMAS=0), THE MINIMUM
C                 STORAGE REQUIREMENT IS 
C                             LWORK = 2*N*N+14*N+20.
C                 IF IWORK(9)=M1>0 THEN "LWORK" MUST BE AT LEAST
C                          N*(LJAC+14)+(N-M1)*(LMAS+LE1)+20
C                 WHERE IN THE DEFINITIONS OF LJAC, LMAS AND LE1 THE
C                 NUMBER N CAN BE REPLACED BY N-M1.
C
C     LWORK       DECLARED LENGTH OF ARRAY "WORK".
C
C     IWORK       INTEGER WORKING SPACE OF LENGTH "LIWORK".
C                 "LIWORK" MUST BE AT LEAST N+20.
C
C     LIWORK      DECLARED LENGTH OF ARRAY "IWORK".
C
C     RPAR, IPAR  REAL AND INTEGER PARAMETERS (OR PARAMETER ARRAYS) WHICH  
C                 CAN BE USED FOR COMMUNICATION BETWEEN YOUR CALLING
C                 PROGRAM AND THE FCN, DFX, JAC, MAS, SOLOUT SUBROUTINES. 
C
C ----------------------------------------------------------------------
C 
C     SOPHISTICATED SETTING OF PARAMETERS
C     -----------------------------------
C              SEVERAL PARAMETERS OF THE CODE ARE TUNED TO MAKE IT WORK 
C              WELL. THEY MAY BE DEFINED BY SETTING WORK(1),..,WORK(4)
C              AS WELL AS IWORK(1),IWORK(2) DIFFERENT FROM ZERO.
C              FOR ZERO INPUT, THE CODE CHOOSES DEFAULT VALUES:
C
C    IWORK(1)  THIS IS THE MAXIMAL NUMBER OF ALLOWED STEPS.
C              THE DEFAULT VALUE (FOR IWORK(1)=0) IS 100000.
C
C    IWORK(2)  SWITCH FOR THE CHOICE OF THE COEFFICIENTS
C              IF IWORK(2).EQ.1  METHOD (SEE BOOK, PAGE 452)
C              IF IWORK(2).EQ.2  SAME METHOD WITH DIFFERENT PARAMETERS
C              IF IWORK(2).EQ.3  METHOD WITH COEFF. OF GERD STEINEBACH
C              THE DEFAULT VALUE (FOR IWORK(2)=0) IS IWORK(2)=1.
C
C    IWORK(3)  SWITCH FOR STEP SIZE STRATEGY
C              IF IWORK(3).EQ.1  MOD. PREDICTIVE CONTROLLER (GUSTAFSSON)
C              IF IWORK(3).EQ.2  CLASSICAL APPROACH
C              THE DEFAULT VALUE (FOR IWORK(3)=0) IS IWORK(3)=1.
C
C       IF THE DIFFERENTIAL SYSTEM HAS THE SPECIAL STRUCTURE THAT
C            Y(I)' = Y(I+M2)   FOR  I=1,...,M1,
C       WITH M1 A MULTIPLE OF M2, A SUBSTANTIAL GAIN IN COMPUTERTIME
C       CAN BE ACHIEVED BY SETTING THE PARAMETERS IWORK(9) AND IWORK(10).
C       E.G., FOR SECOND ORDER SYSTEMS P'=V, V'=G(P,V), WHERE P AND V ARE 
C       VECTORS OF DIMENSION N/2, ONE HAS TO PUT M1=M2=N/2.
C       FOR M1>0 SOME OF THE INPUT PARAMETERS HAVE DIFFERENT MEANINGS:
C       - JAC: ONLY THE ELEMENTS OF THE NON-TRIVIAL PART OF THE
C              JACOBIAN HAVE TO BE STORED
C              IF (MLJAC.EQ.N-M1) THE JACOBIAN IS SUPPOSED TO BE FULL
C                 DFY(I,J) = PARTIAL F(I+M1) / PARTIAL Y(J)
C                FOR I=1,N-M1 AND J=1,N.
C              ELSE, THE JACOBIAN IS BANDED ( M1 = M2 * MM )
C                 DFY(I-J+MUJAC+1,J+K*M2) = PARTIAL F(I+M1) / PARTIAL Y(J+K*M2)
C                FOR I=1,MLJAC+MUJAC+1 AND J=1,M2 AND K=0,MM.
C       - MLJAC: MLJAC=N-M1: IF THE NON-TRIVIAL PART OF THE JACOBIAN IS FULL
C                0<=MLJAC<N-M1: IF THE (MM+1) SUBMATRICES (FOR K=0,MM)
C                     PARTIAL F(I+M1) / PARTIAL Y(J+K*M2),  I,J=1,M2
C                    ARE BANDED, MLJAC IS THE MAXIMAL LOWER BANDWIDTH
C                    OF THESE MM+1 SUBMATRICES
C       - MUJAC: MAXIMAL UPPER BANDWIDTH OF THESE MM+1 SUBMATRICES
C                NEED NOT BE DEFINED IF MLJAC=N-M1
C       - MAS: IF IMAS=0 THIS MATRIX IS ASSUMED TO BE THE IDENTITY AND
C              NEED NOT BE DEFINED. SUPPLY A DUMMY SUBROUTINE IN THIS CASE.
C              IT IS ASSUMED THAT ONLY THE ELEMENTS OF RIGHT LOWER BLOCK OF
C              DIMENSION N-M1 DIFFER FROM THAT OF THE IDENTITY MATRIX.
C              IF (MLMAS.EQ.N-M1) THIS SUBMATRIX IS SUPPOSED TO BE FULL
C                 AM(I,J) = M(I+M1,J+M1)     FOR I=1,N-M1 AND J=1,N-M1.
C              ELSE, THE MASS MATRIX IS BANDED
C                 AM(I-J+MUMAS+1,J) = M(I+M1,J+M1)
C       - MLMAS: MLMAS=N-M1: IF THE NON-TRIVIAL PART OF M IS FULL
C                0<=MLMAS<N-M1: LOWER BANDWIDTH OF THE MASS MATRIX
C       - MUMAS: UPPER BANDWIDTH OF THE MASS MATRIX
C                NEED NOT BE DEFINED IF MLMAS=N-M1
C
C    IWORK(9)  THE VALUE OF M1.  DEFAULT M1=0.
C
C    IWORK(10) THE VALUE OF M2.  DEFAULT M2=M1.
C
C    WORK(1)   UROUND, THE ROUNDING UNIT, DEFAULT 1.D-16.
C
C    WORK(2)   MAXIMAL STEP SIZE, DEFAULT XEND-X.
C
C    WORK(3), WORK(4)   PARAMETERS FOR STEP SIZE SELECTION
C              THE NEW STEP SIZE IS CHOSEN SUBJECT TO THE RESTRICTION
C                 WORK(3) <= HNEW/HOLD <= WORK(4)
C              DEFAULT VALUES: WORK(3)=0.2D0, WORK(4)=6.D0
C
C    WORK(5)   THE SAFETY FACTOR IN STEP SIZE PREDICTION,
C              DEFAULT 0.9D0.
C
C-----------------------------------------------------------------------
C
C     OUTPUT PARAMETERS 
C     ----------------- 
C     X           X-VALUE WHERE THE SOLUTION IS COMPUTED
C                 (AFTER SUCCESSFUL RETURN X=XEND)
C
C     Y(N)        SOLUTION AT X
C  
C     H           PREDICTED STEP SIZE OF THE LAST ACCEPTED STEP
C
C     IDID        REPORTS ON SUCCESSFULNESS UPON RETURN:
C                   IDID= 1  COMPUTATION SUCCESSFUL,
C                   IDID= 2  COMPUT. SUCCESSFUL (INTERRUPTED BY SOLOUT)
C                   IDID=-1  INPUT IS NOT CONSISTENT,
C                   IDID=-2  LARGER NMAX IS NEEDED,
C                   IDID=-3  STEP SIZE BECOMES TOO SMALL,
C                   IDID=-4  MATRIX IS REPEATEDLY SINGULAR.
C
C   IWORK(14)  NFCN    NUMBER OF FUNCTION EVALUATIONS (THOSE FOR NUMERICAL
C                      EVALUATION OF THE JACOBIAN ARE NOT COUNTED)  
C   IWORK(15)  NJAC    NUMBER OF JACOBIAN EVALUATIONS (EITHER ANALYTICALLY
C                      OR NUMERICALLY)
C   IWORK(16)  NSTEP   NUMBER OF COMPUTED STEPS
C   IWORK(17)  NACCPT  NUMBER OF ACCEPTED STEPS
C   IWORK(18)  NREJCT  NUMBER OF REJECTED STEPS (DUE TO ERROR TEST),
C                      (STEP REJECTIONS IN THE FIRST STEP ARE NOT COUNTED)
C   IWORK(19)  NDEC    NUMBER OF LU-DECOMPOSITIONS (N-DIMENSIONAL MATRIX)
C   IWORK(20)  NSOL    NUMBER OF FORWARD-BACKWARD SUBSTITUTIONS
C --------------------------------------------------------- 
C *** *** *** *** *** *** *** *** *** *** *** *** ***
C          DECLARATIONS 
C *** *** *** *** *** *** *** *** *** *** *** *** ***
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION Y(N),ATOL(*),RTOL(*),WORK(LWORK),IWORK(LIWORK)
      DIMENSION RPAR(*),IPAR(*)
      LOGICAL AUTNMS,IMPLCT,JBAND,ARRET,PRED
      EXTERNAL FCN,JAC,DFX,MAS,SOLOUT
C *** *** *** *** *** *** ***
C        SETTING THE PARAMETERS 
C *** *** *** *** *** *** ***
      NFCN=0
      NACCPT=0
      NREJCT=0
      NSTEP=0
      NJAC=0
      NDEC=0
      NSOL=0
      ARRET=.FALSE.
C -------- NMAX , THE MAXIMAL NUMBER OF STEPS -----
      IF(IWORK(1).EQ.0)THEN
         NMAX=100000
      ELSE
         NMAX=IWORK(1)
         IF(NMAX.LE.0)THEN
            WRITE(6,*)' WRONG INPUT IWORK(1)=',IWORK(1)
            ARRET=.TRUE.
         END IF
      END IF
C -------- METH   COEFFICIENTS OF THE METHOD
      IF(IWORK(2).EQ.0)THEN
         METH=1
      ELSE
         METH=IWORK(2)
         IF(METH.LE.0.OR.METH.GE.4)THEN
            WRITE(6,*)' CURIOUS INPUT IWORK(2)=',IWORK(2)
            ARRET=.TRUE.
         END IF
      END IF
C -------- PRED   STEP SIZE CONTROL
      IF(IWORK(3).LE.1)THEN
         PRED=.TRUE.
      ELSE
         PRED=.FALSE.
      END IF
C -------- PARAMETER FOR SECOND ORDER EQUATIONS
      M1=IWORK(9)
      M2=IWORK(10)
      NM1=N-M1
      IF (M1.EQ.0) M2=N
      IF (M2.EQ.0) M2=M1
      IF (M1.LT.0.OR.M2.LT.0.OR.M1+M2.GT.N) THEN
       WRITE(6,*)' CURIOUS INPUT FOR IWORK(9,10)=',M1,M2
       ARRET=.TRUE.
      END IF
C -------- UROUND   SMALLEST NUMBER SATISFYING 1.D0+UROUND>1.D0  
      IF(WORK(1).EQ.0.D0)THEN
         UROUND=1.D-16
      ELSE
         UROUND=WORK(1)
         IF(UROUND.LT.1.D-16.OR.UROUND.GE.1.D0)THEN
            WRITE(6,*)' COEFFICIENTS HAVE 16 DIGITS, UROUND=',WORK(1)
            ARRET=.TRUE.
         END IF
      END IF
C -------- MAXIMAL STEP SIZE
      IF(WORK(2).EQ.0.D0)THEN
         HMAX=XEND-X
      ELSE
         HMAX=WORK(2)
      END IF
C -------  FAC1,FAC2     PARAMETERS FOR STEP SIZE SELECTION
      IF(WORK(3).EQ.0.D0)THEN
         FAC1=5.D0
      ELSE
         FAC1=1.D0/WORK(3)
      END IF
      IF(WORK(4).EQ.0.D0)THEN
         FAC2=1.D0/6.0D0
      ELSE
         FAC2=1.D0/WORK(4)
      END IF
      IF (FAC1.LT.1.0D0.OR.FAC2.GT.1.0D0) THEN
            WRITE(6,*)' CURIOUS INPUT WORK(3,4)=',WORK(3),WORK(4)
            ARRET=.TRUE.
         END IF
C --------- SAFE     SAFETY FACTOR IN STEP SIZE PREDICTION
      IF (WORK(5).EQ.0.0D0) THEN
         SAFE=0.9D0
      ELSE
         SAFE=WORK(5)
         IF (SAFE.LE.0.001D0.OR.SAFE.GE.1.0D0) THEN
            WRITE(6,*)' CURIOUS INPUT FOR WORK(5)=',WORK(5)
            ARRET=.TRUE.
         END IF
      END IF
C --------- CHECK IF TOLERANCES ARE O.K.
      IF (ITOL.EQ.0) THEN
          IF (ATOL(1).LE.0.D0.OR.RTOL(1).LE.10.D0*UROUND) THEN
              WRITE (6,*) ' TOLERANCES ARE TOO SMALL'
              ARRET=.TRUE.
          END IF
      ELSE
          DO I=1,N
             IF (ATOL(I).LE.0.D0.OR.RTOL(I).LE.10.D0*UROUND) THEN
                WRITE (6,*) ' TOLERANCES(',I,') ARE TOO SMALL'
                ARRET=.TRUE.
             END IF
          END DO
      END IF
C *** *** *** *** *** *** *** *** *** *** *** *** ***
C         COMPUTATION OF ARRAY ENTRIES
C *** *** *** *** *** *** *** *** *** *** *** *** ***
C ---- AUTONOMOUS, IMPLICIT, BANDED OR NOT ?
      AUTNMS=IFCN.EQ.0
      IMPLCT=IMAS.NE.0
      JBAND=MLJAC.LT.NM1
C -------- COMPUTATION OF THE ROW-DIMENSIONS OF THE 2-ARRAYS ---
C -- JACOBIAN AND MATRIX E
      IF(JBAND)THEN
         LDJAC=MLJAC+MUJAC+1
         LDE=MLJAC+LDJAC
      ELSE
         MLJAC=NM1
         MUJAC=NM1
         LDJAC=NM1
         LDE=NM1
      END IF
C -- MASS MATRIX
      IF (IMPLCT) THEN
          IF (MLMAS.NE.NM1) THEN
              LDMAS=MLMAS+MUMAS+1
              IF (JBAND) THEN
                 IJOB=4
              ELSE
                 IJOB=3
              END IF
          ELSE
              LDMAS=NM1
              IJOB=5
          END IF
C ------ BANDWITH OF "MAS" NOT LARGER THAN BANDWITH OF "JAC"
          IF (MLMAS.GT.MLJAC.OR.MUMAS.GT.MUJAC) THEN
              WRITE (6,*) 'BANDWITH OF "MAS" NOT LARGER THAN BANDWITH OF
     & "JAC"'
            ARRET=.TRUE.
          END IF
      ELSE
          LDMAS=0
          IF (JBAND) THEN
             IJOB=2
          ELSE
             IJOB=1
          END IF
      END IF
      LDMAS2=MAX(1,LDMAS)
C ------- PREPARE THE ENTRY-POINTS FOR THE ARRAYS IN WORK -----
      IEYNEW=21
      IEDY1=IEYNEW+N
      IEDY=IEDY1+N
      IEAK1=IEDY+N
      IEAK2=IEAK1+N
      IEAK3=IEAK2+N
      IEAK4=IEAK3+N
      IEAK5=IEAK4+N
      IEAK6=IEAK5+N
      IEFX =IEAK6+N
      IECON=IEFX+N
      IEJAC=IECON+4*N
      IEMAS=IEJAC+N*LDJAC
      IEE  =IEMAS+NM1*LDMAS
C ------ TOTAL STORAGE REQUIREMENT -----------
      ISTORE=IEE+NM1*LDE-1
      IF(ISTORE.GT.LWORK)THEN
         WRITE(6,*)' INSUFFICIENT STORAGE FOR WORK, MIN. LWORK=',ISTORE
         ARRET=.TRUE.
      END IF
C ------- ENTRY POINTS FOR INTEGER WORKSPACE -----
      IEIP=21
      ISTORE=IEIP+NM1-1
      IF(ISTORE.GT.LIWORK)THEN
         WRITE(6,*)' INSUFF. STORAGE FOR IWORK, MIN. LIWORK=',ISTORE
         ARRET=.TRUE.
      END IF
C ------ WHEN A FAIL HAS OCCURED, WE RETURN WITH IDID=-1
      IF (ARRET) THEN
         IDID=-1
         RETURN
      END IF
C -------- CALL TO CORE INTEGRATOR ------------
      CALL ROSCOR(N,FCN,X,Y,XEND,HMAX,H,RTOL,ATOL,ITOL,JAC,IJAC,
     &   MLJAC,MUJAC,DFX,IDFX,MAS,MLMAS,MUMAS,SOLOUT,IOUT,IDID,NMAX,
     &   UROUND,METH,IJOB,FAC1,FAC2,SAFE,AUTNMS,IMPLCT,JBAND,PRED,LDJAC,
     &   LDE,LDMAS2,WORK(IEYNEW),WORK(IEDY1),WORK(IEDY),WORK(IEAK1),
     &   WORK(IEAK2),WORK(IEAK3),WORK(IEAK4),WORK(IEAK5),WORK(IEAK6),
     &   WORK(IEFX),WORK(IEJAC),WORK(IEE),WORK(IEMAS),IWORK(IEIP),
     &   WORK(IECON),
     &   M1,M2,NM1,NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL,RPAR,IPAR)
      IWORK(14)=NFCN
      IWORK(15)=NJAC
      IWORK(16)=NSTEP
      IWORK(17)=NACCPT
      IWORK(18)=NREJCT
      IWORK(19)=NDEC
      IWORK(20)=NSOL
C ----------- RETURN -----------
      RETURN
      END
C
C
C
C  ----- ... AND HERE IS THE CORE INTEGRATOR  ----------
C
      SUBROUTINE ROSCOR(N,FCN,X,Y,XEND,HMAX,H,RTOL,ATOL,ITOL,JAC,IJAC,
     &  MLJAC,MUJAC,DFX,IDFX,MAS,MLMAS,MUMAS,SOLOUT,IOUT,IDID,NMAX,
     &  UROUND,METH,IJOB,FAC1,FAC2,SAFE,AUTNMS,IMPLCT,BANDED,PRED,LDJAC,
     &  LDE,LDMAS,YNEW,DY1,DY,AK1,AK2,AK3,AK4,AK5,AK6,FX,FJAC,E,FMAS,IP,
     &  CONT,
     &  M1,M2,NM1,NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL,RPAR,IPAR)
C ----------------------------------------------------------
C     CORE INTEGRATOR FOR RODAS
C     PARAMETERS SAME AS IN RODAS WITH WORKSPACE ADDED 
C ---------------------------------------------------------- 
C         DECLARATIONS 
C ---------------------------------------------------------- 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION Y(N),YNEW(N),DY1(N),DY(N),AK1(N),
     *  AK2(N),AK3(N),AK4(N),AK5(N),AK6(N),FX(N),RPAR(*),IPAR(*),
     *  FJAC(LDJAC,N),E(LDE,NM1),FMAS(LDMAS,NM1),ATOL(*),RTOL(*)
      DIMENSION CONT(4*N)
      INTEGER IP(NM1)
      LOGICAL REJECT,AUTNMS,IMPLCT,BANDED,LAST,PRED
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
      COMMON /CONROS/XOLD,HOUT,NN
c$omp threadprivate(/linal/)
c$omp threadprivate(/conros/)
C *** *** *** *** *** *** ***
C  INITIALISATIONS
C *** *** *** *** *** *** ***    
      NN=N 
      NN2=2*N
      NN3=3*N
      LRC=4*N
C ------- COMPUTE MASS MATRIX FOR IMPLICIT CASE ----------
      IF (IMPLCT) CALL MAS (NM1,FMAS,LDMAS,RPAR,IPAR)
C ------ SET THE PARAMETERS OF THE METHOD -----
      CALL ROCOE(METH,A21,A31,A32,A41,A42,A43,A51,A52,A53,A54,
     &    C21,C31,C32,C41,C42,C43,C51,C52,C53,C54,C61,
     &    C62,C63,C64,C65,GAMMA,C2,C3,C4,D1,D2,D3,D4,
     &    D21,D22,D23,D24,D25,D31,D32,D33,D34,D35)
C --- INITIAL PREPARATIONS
      IF (M1.GT.0) IJOB=IJOB+10
      POSNEG=SIGN(1.D0,XEND-X)
      HMAXN=MIN(ABS(HMAX),ABS(XEND-X))
      IF (ABS(H).LE.10.D0*UROUND) H=1.0D-6
      H=MIN(ABS(H),HMAXN) 
      H=SIGN(H,POSNEG) 
      REJECT=.FALSE.
      LAST=.FALSE.
      NSING=0
      IRTRN=1
      IF (AUTNMS) THEN
         HD1=0.0D0
         HD2=0.0D0
         HD3=0.0D0
         HD4=0.0D0
      END IF
C -------- PREPARE BAND-WIDTHS --------
      MBDIAG=MUMAS+1
      IF (BANDED) THEN
          MLE=MLJAC
          MUE=MUJAC
          MBJAC=MLJAC+MUJAC+1
          MBB=MLMAS+MUMAS+1
          MDIAG=MLE+MUE+1
          MDIFF=MLE+MUE-MUMAS
      END IF
      IF (IOUT.NE.0) THEN 
          XOLD=X
          IRTRN=1
          HOUT=H
          CALL SOLOUT(NACCPT+1,XOLD,X,Y,CONT,LRC,N,
     &                RPAR,IPAR,IRTRN)
          IF (IRTRN.LT.0) GOTO 179
      END IF
C --- BASIC INTEGRATION STEP  
 1    IF (NSTEP.GT.NMAX) GOTO 178
      IF (0.1D0*ABS(H).LE.ABS(X)*UROUND) GOTO 177
      IF (LAST) THEN
          H=HOPT
          IDID=1
          RETURN
      END IF
      HOPT=H
      IF ((X+H*1.0001D0-XEND)*POSNEG.GE.0.D0) THEN
         H=XEND-X
         LAST=.TRUE.
      END IF
C *** *** *** *** *** *** ***
C  COMPUTATION OF THE JACOBIAN
C *** *** *** *** *** *** ***
      CALL FCN(N,X,Y,DY1,RPAR,IPAR)
      NFCN=NFCN+1
      NJAC=NJAC+1
      IF (IJAC.EQ.0) THEN
C --- COMPUTE JACOBIAN MATRIX NUMERICALLY
         IF (BANDED) THEN
C --- JACOBIAN IS BANDED
            MUJACP=MUJAC+1
            MD=MIN(MBJAC,N)
            DO MM=1,M1/M2+1
               DO K=1,MD
                  J=K+(MM-1)*M2
 12               AK2(J)=Y(J)
                  AK3(J)=DSQRT(UROUND*MAX(1.D-5,ABS(Y(J))))
                  Y(J)=Y(J)+AK3(J)
                  J=J+MD
                  IF (J.LE.MM*M2) GOTO 12 
                  CALL FCN(N,X,Y,AK1,RPAR,IPAR)
                  J=K+(MM-1)*M2
                  J1=K
                  LBEG=MAX(1,J1-MUJAC)+M1
 14               LEND=MIN(M2,J1+MLJAC)+M1
                  Y(J)=AK2(J)
                  MUJACJ=MUJACP-J1-M1
                  DO L=LBEG,LEND
                     FJAC(L+MUJACJ,J)=(AK1(L)-DY1(L))/AK3(J) 
                  END DO
                  J=J+MD
                  J1=J1+MD
                  LBEG=LEND+1
                  IF (J.LE.MM*M2) GOTO 14
               END DO
            END DO
         ELSE
C --- JACOBIAN IS FULL
            DO I=1,N
               YSAFE=Y(I)
               DELT=DSQRT(UROUND*MAX(1.D-5,ABS(YSAFE)))
               Y(I)=YSAFE+DELT
               CALL FCN(N,X,Y,AK1,RPAR,IPAR)
               DO J=M1+1,N
                 FJAC(J-M1,I)=(AK1(J)-DY1(J))/DELT
               END DO
               Y(I)=YSAFE
            END DO
         END IF
      ELSE
C --- COMPUTE JACOBIAN MATRIX ANALYTICALLY
         CALL JAC(N,X,Y,FJAC,LDJAC,RPAR,IPAR)
      END IF
      IF (.NOT.AUTNMS) THEN
         IF (IDFX.EQ.0) THEN
C --- COMPUTE NUMERICALLY THE DERIVATIVE WITH RESPECT TO X
            DELT=SQRT(UROUND*MAX(1.D-5,ABS(X)))
            XDELT=X+DELT
            CALL FCN(N,XDELT,Y,AK1,RPAR,IPAR)
            DO J=1,N
               FX(J)=(AK1(J)-DY1(J))/DELT
            END DO
         ELSE
C --- COMPUTE ANALYTICALLY THE DERIVATIVE WITH RESPECT TO X
            CALL DFX(N,X,Y,FX,RPAR,IPAR)
         END IF
      END IF
   2  CONTINUE
C *** *** *** *** *** *** ***
C  COMPUTE THE STAGES
C *** *** *** *** *** *** ***
      FAC=1.D0/(H*GAMMA)
      CALL DECOMR(N,FJAC,LDJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &            M1,M2,NM1,FAC,E,LDE,IP,IER,IJOB,IMPLCT,IP)
      IF (IER.NE.0) GOTO 80
      NDEC=NDEC+1
C --- PREPARE FOR THE COMPUTATION OF THE 6 STAGES
      HC21=C21/H
      HC31=C31/H
      HC32=C32/H
      HC41=C41/H
      HC42=C42/H
      HC43=C43/H
      HC51=C51/H
      HC52=C52/H
      HC53=C53/H
      HC54=C54/H
      HC61=C61/H
      HC62=C62/H
      HC63=C63/H
      HC64=C64/H
      HC65=C65/H
      IF (.NOT.AUTNMS) THEN
         HD1=H*D1
         HD2=H*D2
         HD3=H*D3
         HD4=H*D4
      END IF
C --- THE STAGES
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY1,AK1,FX,YNEW,HD1,IJOB,.FALSE.)
      DO  I=1,N
         YNEW(I)=Y(I)+A21*AK1(I)
      END DO
      CALL FCN(N,X+C2*H,YNEW,DY,RPAR,IPAR)
      DO I=1,N
         YNEW(I)=HC21*AK1(I)
      END DO
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY,AK2,FX,YNEW,HD2,IJOB,.TRUE.)
      DO I=1,N
         YNEW(I)=Y(I)+A31*AK1(I)+A32*AK2(I) 
      END DO
      CALL FCN(N,X+C3*H,YNEW,DY,RPAR,IPAR)
      DO I=1,N
         YNEW(I)=HC31*AK1(I)+HC32*AK2(I)
      END DO
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY,AK3,FX,YNEW,HD3,IJOB,.TRUE.)
      DO I=1,N
         YNEW(I)=Y(I)+A41*AK1(I)+A42*AK2(I)+A43*AK3(I)
      END DO
      CALL FCN(N,X+C4*H,YNEW,DY,RPAR,IPAR)
      DO I=1,N
         YNEW(I)=HC41*AK1(I)+HC42*AK2(I)+HC43*AK3(I) 
      END DO
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY,AK4,FX,YNEW,HD4,IJOB,.TRUE.)
      DO I=1,N
         YNEW(I)=Y(I)+A51*AK1(I)+A52*AK2(I)+A53*AK3(I)+A54*AK4(I)
      END DO
      CALL FCN(N,X+H,YNEW,DY,RPAR,IPAR)
      DO I=1,N
         AK6(I)=HC52*AK2(I)+HC54*AK4(I)+HC51*AK1(I)+HC53*AK3(I) 
      END DO
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY,AK5,FX,AK6,0.D0,IJOB,.TRUE.)
C ------------ EMBEDDED SOLUTION ---------------
      DO I=1,N
         YNEW(I)=YNEW(I)+AK5(I)  
      END DO
      CALL FCN(N,X+H,YNEW,DY,RPAR,IPAR)
      DO I=1,N
         CONT(I)=HC61*AK1(I)+HC62*AK2(I)+HC65*AK5(I)
     &              +HC64*AK4(I)+HC63*AK3(I) 
      END DO
      CALL SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &    M1,M2,NM1,FAC,E,LDE,IP,DY,AK6,FX,CONT,0.D0,IJOB,.TRUE.)
C ------------ NEW SOLUTION ---------------
      DO  I=1,N
         YNEW(I)=YNEW(I)+AK6(I)  
      END DO
      NSOL=NSOL+6
      NFCN=NFCN+5 
C ------------ DENSE OUTPUT ----------
      IF (IOUT.NE.0) THEN
         DO I=1,N 
            CONT(I)=Y(I)
            CONT(I+NN2)=D21*AK1(I)+D22*AK2(I)+D23*AK3(I)+D24*AK4(I)
     &               +D25*AK5(I)
            CONT(I+NN3)=D31*AK1(I)+D32*AK2(I)+D33*AK3(I)+D34*AK4(I)
     &               +D35*AK5(I)
         END DO
      END IF
C *** *** *** *** *** *** ***
C  ERROR ESTIMATION  
C *** *** *** *** *** *** ***
      NSTEP=NSTEP+1
C ------------ COMPUTE ERROR ESTIMATION ----------------
      ERR=0.D0
      DO I=1,N
         IF (ITOL.EQ.0) THEN
            SK=ATOL(1)+RTOL(1)*MAX(ABS(Y(I)),ABS(YNEW(I)))
         ELSE
            SK=ATOL(I)+RTOL(I)*MAX(ABS(Y(I)),ABS(YNEW(I)))
         END IF
         ERR=ERR+(AK6(I)/SK)**2
      END DO
      ERR=SQRT(ERR/N)
C --- COMPUTATION OF HNEW
C --- WE REQUIRE .2<=HNEW/H<=6.
      FAC=MAX(FAC2,MIN(FAC1,(ERR)**0.25D0/SAFE))
      HNEW=H/FAC  
C *** *** *** *** *** *** ***
C  IS THE ERROR SMALL ENOUGH ?
C *** *** *** *** *** *** ***
      IF (ERR.LE.1.D0) THEN
C --- STEP IS ACCEPTED  
         NACCPT=NACCPT+1
         IF (PRED) THEN
C       --- PREDICTIVE CONTROLLER OF GUSTAFSSON
            IF (NACCPT.GT.1) THEN
               FACGUS=(HACC/H)*(ERR**2/ERRACC)**0.25D0/SAFE
               FACGUS=MAX(FAC2,MIN(FAC1,FACGUS))
               FAC=MAX(FAC,FACGUS)
               HNEW=H/FAC
            END IF
            HACC=H
            ERRACC=MAX(1.0D-2,ERR)
         END IF
         DO I=1,N 
            Y(I)=YNEW(I)
         END DO
         XOLD=X 
         X=X+H
         IF (IOUT.NE.0) THEN 
            DO I=1,N 
               CONT(NN+I)=Y(I)
            END DO
            IRTRN=1
            HOUT=H
            CALL SOLOUT(NACCPT+1,XOLD,X,Y,CONT,LRC,N,
     &                   RPAR,IPAR,IRTRN)
            IF (IRTRN.LT.0) GOTO 179
         END IF
         IF (ABS(HNEW).GT.HMAXN) HNEW=POSNEG*HMAXN
         IF (REJECT) HNEW=POSNEG*MIN(ABS(HNEW),ABS(H)) 
         REJECT=.FALSE.
         H=HNEW
         GOTO 1
      ELSE
C --- STEP IS REJECTED  
         REJECT=.TRUE.
         LAST=.FALSE.
         H=HNEW
         IF (NACCPT.GE.1) NREJCT=NREJCT+1
         GOTO 2
      END IF
C --- SINGULAR MATRIX
  80  NSING=NSING+1
      IF (NSING.GE.5) GOTO 176
      H=H*0.5D0
      REJECT=.TRUE.
      LAST=.FALSE.
      GOTO 2
C --- FAIL EXIT
 176  CONTINUE
      WRITE(6,979)X   
      WRITE(6,*) ' MATRIX IS REPEATEDLY SINGULAR, IER=',IER
      IDID=-4
      RETURN
 177  CONTINUE
      WRITE(6,979)X   
      WRITE(6,*) ' STEP SIZE T0O SMALL, H=',H
      IDID=-3
      RETURN
 178  CONTINUE
      WRITE(6,979)X   
      WRITE(6,*) ' MORE THAN NMAX =',NMAX,'STEPS ARE NEEDED' 
      IDID=-2
      RETURN
C --- EXIT CAUSED BY SOLOUT
 179  CONTINUE
      WRITE(6,979)X
 979  FORMAT(' EXIT OF RODAS AT X=',E18.4) 
      IDID=2
      RETURN
      END 
C
      FUNCTION CONTRO(I,X,CONT,LRC)
C ----------------------------------------------------------
C     THIS FUNCTION CAN BE USED FOR CONTINUOUS OUTPUT IN CONNECTION
C     WITH THE OUTPUT-SUBROUTINE FOR RODAS. IT PROVIDES AN
C     APPROXIMATION TO THE I-TH COMPONENT OF THE SOLUTION AT X.
C ----------------------------------------------------------
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION CONT(LRC)
      COMMON /CONROS/XOLD,H,N
c$omp threadprivate(/conros/)
      S=(X-XOLD)/H 
      CONTRO=CONT(I)*(1-S)+S*(CONT(I+N)+(1-S)*(CONT(I+N*2)
     &      +S*CONT(I+N*3)))
      RETURN
      END
C
      SUBROUTINE ROCOE(METH,A21,A31,A32,A41,A42,A43,A51,A52,A53,A54,
     &  C21,C31,C32,C41,C42,C43,C51,C52,C53,C54,C61,
     &  C62,C63,C64,C65,GAMMA,C2,C3,C4,D1,D2,D3,D4,
     &  D21,D22,D23,D24,D25,D31,D32,D33,D34,D35)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      GOTO (1,2,3), METH
 1      C2=0.386D0
        C3=0.21D0 
        C4=0.63D0
        BET2P=0.0317D0
        BET3P=0.0635D0
        BET4P=0.3438D0 
       D1= 0.2500000000000000D+00
       D2=-0.1043000000000000D+00
       D3= 0.1035000000000000D+00
       D4=-0.3620000000000023D-01
       A21= 0.1544000000000000D+01
       A31= 0.9466785280815826D+00
       A32= 0.2557011698983284D+00
       A41= 0.3314825187068521D+01
       A42= 0.2896124015972201D+01
       A43= 0.9986419139977817D+00
       A51= 0.1221224509226641D+01
       A52= 0.6019134481288629D+01
       A53= 0.1253708332932087D+02
       A54=-0.6878860361058950D+00
       C21=-0.5668800000000000D+01
       C31=-0.2430093356833875D+01
       C32=-0.2063599157091915D+00
       C41=-0.1073529058151375D+00
       C42=-0.9594562251023355D+01
       C43=-0.2047028614809616D+02
       C51= 0.7496443313967647D+01
       C52=-0.1024680431464352D+02
       C53=-0.3399990352819905D+02
       C54= 0.1170890893206160D+02
       C61= 0.8083246795921522D+01
       C62=-0.7981132988064893D+01
       C63=-0.3152159432874371D+02
       C64= 0.1631930543123136D+02
       C65=-0.6058818238834054D+01
       GAMMA= 0.2500000000000000D+00  

       D21= 0.1012623508344586D+02
       D22=-0.7487995877610167D+01
       D23=-0.3480091861555747D+02
       D24=-0.7992771707568823D+01
       D25= 0.1025137723295662D+01
       D31=-0.6762803392801253D+00
       D32= 0.6087714651680015D+01
       D33= 0.1643084320892478D+02
       D34= 0.2476722511418386D+02
       D35=-0.6594389125716872D+01
      RETURN
C
 2      C2=0.3507221D0
        C3=0.2557041D0 
        C4=0.6817790D0
        BET2P=0.0317D0
        BET3P=0.0047369D0
        BET4P=0.3438D0 
       D1= 0.2500000000000000D+00
       D2=-0.6902209999999998D-01
       D3=-0.9671999999999459D-03
       D4=-0.8797900000000025D-01
       A21= 0.1402888400000000D+01
       A31= 0.6581212688557198D+00
       A32=-0.1320936088384301D+01
       A41= 0.7131197445744498D+01
       A42= 0.1602964143958207D+02
       A43=-0.5561572550509766D+01
       A51= 0.2273885722420363D+02
       A52= 0.6738147284535289D+02
       A53=-0.3121877493038560D+02
       A54= 0.7285641833203814D+00
       C21=-0.5104353600000000D+01
       C31=-0.2899967805418783D+01
       C32= 0.4040399359702244D+01
       C41=-0.3264449927841361D+02
       C42=-0.9935311008728094D+02
       C43= 0.4999119122405989D+02
       C51=-0.7646023087151691D+02
       C52=-0.2785942120829058D+03
       C53= 0.1539294840910643D+03
       C54= 0.1097101866258358D+02
       C61=-0.7629701586804983D+02
       C62=-0.2942795630511232D+03
       C63= 0.1620029695867566D+03
       C64= 0.2365166903095270D+02
       C65=-0.7652977706771382D+01
       GAMMA= 0.2500000000000000D+00  

       D21=-0.3871940424117216D+02
       D22=-0.1358025833007622D+03
       D23= 0.6451068857505875D+02
       D24=-0.4192663174613162D+01
       D25=-0.2531932050335060D+01
       D31=-0.1499268484949843D+02
       D32=-0.7630242396627033D+02
       D33= 0.5865928432851416D+02
       D34= 0.1661359034616402D+02
       D35=-0.6758691794084156D+00
      RETURN
c
C Coefficients for RODAS with order 4 for linear parabolic problems
C Gerd Steinebach (1993)
  3     GAMMA = 0.25D0
	C2=3.d0*GAMMA
        C3=0.21D0 
        C4=0.63D0
	BET2P=0.D0
	BET3P=c3*c3*(c3/6.d0-GAMMA/2.d0)/(GAMMA*GAMMA)
        BET4P=0.3438D0 
       D1= 0.2500000000000000D+00
       D2=-0.5000000000000000D+00
       D3=-0.2350400000000000D-01
       D4=-0.3620000000000000D-01
       A21= 0.3000000000000000D+01
       A31= 0.1831036793486759D+01
       A32= 0.4955183967433795D+00
       A41= 0.2304376582692669D+01
       A42=-0.5249275245743001D-01
       A43=-0.1176798761832782D+01
       A51=-0.7170454962423024D+01
       A52=-0.4741636671481785D+01
       A53=-0.1631002631330971D+02
       A54=-0.1062004044111401D+01
       C21=-0.1200000000000000D+02
       C31=-0.8791795173947035D+01
       C32=-0.2207865586973518D+01
       C41= 0.1081793056857153D+02
       C42= 0.6780270611428266D+01
       C43= 0.1953485944642410D+02
       C51= 0.3419095006749676D+02
       C52= 0.1549671153725963D+02
       C53= 0.5474760875964130D+02
       C54= 0.1416005392148534D+02
       C61= 0.3462605830930532D+02
       C62= 0.1530084976114473D+02
       C63= 0.5699955578662667D+02
       C64= 0.1840807009793095D+02
       C65=-0.5714285714285717D+01
c
       D21= 0.2509876703708589D+02
       D22= 0.1162013104361867D+02
       D23= 0.2849148307714626D+02
       D24=-0.5664021568594133D+01
       D25= 0.0000000000000000D+00
       D31= 0.1638054557396973D+01
       D32=-0.7373619806678748D+00
       D33= 0.8477918219238990D+01
       D34= 0.1599253148779520D+02
       D35=-0.1882352941176471D+01
      RETURN
      END
C ******************************************
C     VERSION OF SEPTEMBER 18, 1995      
C ******************************************
C
      SUBROUTINE DECOMR(N,FJAC,LDJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &            M1,M2,NM1,FAC1,E1,LDE1,IP1,IER,IJOB,CALHES,IPHES)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E1(LDE1,NM1),
     &          IP1(NM1),IPHES(N)
      LOGICAL CALHES
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,14,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO J=1,N
         DO  I=1,N
            E1(I,J)=-FJAC(I,J)
         END DO
         E1(J,J)=E1(J,J)+FAC1
      END DO
      CALL DEC (N,LDE1,E1,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E1(I,J)=-FJAC(I,JM1)
         END DO
         E1(J,J)=E1(J,J)+FAC1
      END DO
 45   MM=M1/M2
      DO J=1,M2
         DO I=1,NM1
            SUM=0.D0
            DO K=0,MM-1
               SUM=(SUM+FJAC(I,J+K*M2))/FAC1
            END DO
            E1(I,J)=E1(I,J)-SUM
         END DO
      END DO
      CALL DEC (NM1,LDE1,E1,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO J=1,N
         DO I=1,MBJAC
            E1(I+MLE,J)=-FJAC(I,J)
         END DO
         E1(MDIAG,J)=E1(MDIAG,J)+FAC1
      END DO
      CALL DECB (N,LDE1,E1,MLE,MUE,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,MBJAC
            E1(I+MLE,J)=-FJAC(I,JM1)
         END DO
         E1(MDIAG,J)=E1(MDIAG,J)+FAC1
      END DO
  46  MM=M1/M2
      DO J=1,M2
         DO I=1,MBJAC
            SUM=0.D0
            DO K=0,MM-1
               SUM=(SUM+FJAC(I,J+K*M2))/FAC1
            END DO
            E1(I+MLE,J)=E1(I+MLE,J)-SUM
         END DO
      END DO
      CALL DECB (NM1,LDE1,E1,MLE,MUE,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO J=1,N
         DO I=1,N
            E1(I,J)=-FJAC(I,J)
         END DO
         DO I=MAX(1,J-MUMAS),MIN(N,J+MLMAS)
            E1(I,J)=E1(I,J)+FAC1*FMAS(I-J+MBDIAG,J)
         END DO
      END DO
      CALL DEC (N,LDE1,E1,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E1(I,J)=-FJAC(I,JM1)
         END DO
         DO I=MAX(1,J-MUMAS),MIN(NM1,J+MLMAS)
            E1(I,J)=E1(I,J)+FAC1*FMAS(I-J+MBDIAG,J)
         END DO
      END DO
      GOTO 45
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO J=1,N
         DO I=1,MBJAC
            E1(I+MLE,J)=-FJAC(I,J)
         END DO
         DO I=1,MBB
            IB=I+MDIFF
            E1(IB,J)=E1(IB,J)+FAC1*FMAS(I,J)
         END DO
      END DO
      CALL DECB (N,LDE1,E1,MLE,MUE,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  14  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,MBJAC
            E1(I+MLE,J)=-FJAC(I,JM1)
         END DO
         DO I=1,MBB
            IB=I+MDIFF
            E1(IB,J)=E1(IB,J)+FAC1*FMAS(I,J)
         END DO
      END DO
      GOTO 46
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO J=1,N
         DO I=1,N
            E1(I,J)=FMAS(I,J)*FAC1-FJAC(I,J)
         END DO
      END DO
      CALL DEC (N,LDE1,E1,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E1(I,J)=FMAS(I,J)*FAC1-FJAC(I,JM1)
         END DO
      END DO
      GOTO 45
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      IF (CALHES) CALL ELMHES (LDJAC,N,1,N,FJAC,IPHES) 
      CALHES=.FALSE.
      DO J=1,N-1
         J1=J+1
         E1(J1,J)=-FJAC(J1,J)
      END DO
      DO J=1,N
         DO I=1,J
            E1(I,J)=-FJAC(I,J)
         END DO
         E1(J,J)=E1(J,J)+FAC1
      END DO
      CALL DECH(N,LDE1,E1,1,IP1,IER)
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE DECOMR
C
C ***********************************************************
C
      SUBROUTINE DECOMC(N,FJAC,LDJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &            M1,M2,NM1,ALPHN,BETAN,E2R,E2I,LDE1,IP2,IER,IJOB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),
     &          E2R(LDE1,NM1),E2I(LDE1,NM1),IP2(NM1)
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,14,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO J=1,N
         DO I=1,N
            E2R(I,J)=-FJAC(I,J)
            E2I(I,J)=0.D0
         END DO
         E2R(J,J)=E2R(J,J)+ALPHN
         E2I(J,J)=BETAN
      END DO
      CALL DECC (N,LDE1,E2R,E2I,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E2R(I,J)=-FJAC(I,JM1)
            E2I(I,J)=0.D0
         END DO
         E2R(J,J)=E2R(J,J)+ALPHN
         E2I(J,J)=BETAN
      END DO
  45  MM=M1/M2
      ABNO=ALPHN**2+BETAN**2
      ALP=ALPHN/ABNO
      BET=BETAN/ABNO
      DO J=1,M2
         DO I=1,NM1
            SUMR=0.D0
            SUMI=0.D0
            DO K=0,MM-1
               SUMS=SUMR+FJAC(I,J+K*M2)
               SUMR=SUMS*ALP+SUMI*BET
               SUMI=SUMI*ALP-SUMS*BET
            END DO
            E2R(I,J)=E2R(I,J)-SUMR
            E2I(I,J)=E2I(I,J)-SUMI
         END DO
      END DO
      CALL DECC (NM1,LDE1,E2R,E2I,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO J=1,N
         DO I=1,MBJAC
            IMLE=I+MLE
            E2R(IMLE,J)=-FJAC(I,J)
            E2I(IMLE,J)=0.D0
         END DO
         E2R(MDIAG,J)=E2R(MDIAG,J)+ALPHN
         E2I(MDIAG,J)=BETAN
      END DO
      CALL DECBC (N,LDE1,E2R,E2I,MLE,MUE,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,MBJAC
            E2R(I+MLE,J)=-FJAC(I,JM1)
            E2I(I+MLE,J)=0.D0
         END DO
         E2R(MDIAG,J)=E2R(MDIAG,J)+ALPHN
         E2I(MDIAG,J)=E2I(MDIAG,J)+BETAN
      END DO
  46  MM=M1/M2
      ABNO=ALPHN**2+BETAN**2
      ALP=ALPHN/ABNO
      BET=BETAN/ABNO
      DO J=1,M2
         DO I=1,MBJAC
            SUMR=0.D0
            SUMI=0.D0
            DO K=0,MM-1
               SUMS=SUMR+FJAC(I,J+K*M2)
               SUMR=SUMS*ALP+SUMI*BET
               SUMI=SUMI*ALP-SUMS*BET
            END DO
            IMLE=I+MLE
            E2R(IMLE,J)=E2R(IMLE,J)-SUMR
            E2I(IMLE,J)=E2I(IMLE,J)-SUMI
         END DO
      END DO
      CALL DECBC (NM1,LDE1,E2R,E2I,MLE,MUE,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO  J=1,N
         DO  I=1,N
            E2R(I,J)=-FJAC(I,J)
            E2I(I,J)=0.D0
         END DO
      END DO
      DO J=1,N
         DO I=MAX(1,J-MUMAS),MIN(N,J+MLMAS)
            BB=FMAS(I-J+MBDIAG,J)
            E2R(I,J)=E2R(I,J)+ALPHN*BB
            E2I(I,J)=BETAN*BB
         END DO
      END DO
      CALL DECC(N,LDE1,E2R,E2I,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E2R(I,J)=-FJAC(I,JM1)
            E2I(I,J)=0.D0
         END DO
         DO I=MAX(1,J-MUMAS),MIN(NM1,J+MLMAS)
            FFMA=FMAS(I-J+MBDIAG,J)
            E2R(I,J)=E2R(I,J)+ALPHN*FFMA
            E2I(I,J)=E2I(I,J)+BETAN*FFMA
         END DO
      END DO
      GOTO 45
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO J=1,N
         DO I=1,MBJAC
            IMLE=I+MLE
            E2R(IMLE,J)=-FJAC(I,J)
            E2I(IMLE,J)=0.D0
         END DO
         DO I=MAX(1,MUMAS+2-J),MIN(MBB,MUMAS+1-J+N)
            IB=I+MDIFF
            BB=FMAS(I,J)
            E2R(IB,J)=E2R(IB,J)+ALPHN*BB
            E2I(IB,J)=BETAN*BB
         END DO
      END DO
      CALL DECBC (N,LDE1,E2R,E2I,MLE,MUE,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  14  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,MBJAC
            E2R(I+MLE,J)=-FJAC(I,JM1)
            E2I(I+MLE,J)=0.D0
         END DO
         DO I=1,MBB
            IB=I+MDIFF
            FFMA=FMAS(I,J)
            E2R(IB,J)=E2R(IB,J)+ALPHN*FFMA
            E2I(IB,J)=E2I(IB,J)+BETAN*FFMA
         END DO
      END DO
      GOTO 46
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO J=1,N
         DO I=1,N
            BB=FMAS(I,J)
            E2R(I,J)=BB*ALPHN-FJAC(I,J)
            E2I(I,J)=BB*BETAN
         END DO
      END DO
      CALL DECC(N,LDE1,E2R,E2I,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO J=1,NM1
         JM1=J+M1
         DO I=1,NM1
            E2R(I,J)=ALPHN*FMAS(I,J)-FJAC(I,JM1)
            E2I(I,J)=BETAN*FMAS(I,J)
         END DO
      END DO
      GOTO 45
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO J=1,N-1
         J1=J+1
         E2R(J1,J)=-FJAC(J1,J)
         E2I(J1,J)=0.D0
      END DO
      DO J=1,N
         DO I=1,J
            E2I(I,J)=0.D0
            E2R(I,J)=-FJAC(I,J)
         END DO
         E2R(J,J)=E2R(J,J)+ALPHN
         E2I(J,J)=BETAN
      END DO
      CALL DECHC(N,LDE1,E2R,E2I,1,IP2,IER)
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE DECOMC
C
C ***********************************************************
C
      SUBROUTINE SLVRAR(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          M1,M2,NM1,FAC1,E1,LDE1,Z1,F1,IP1,IPHES,IER,IJOB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E1(LDE1,NM1),
     &          IP1(NM1),IPHES(N),Z1(N),F1(N)
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,13,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO I=1,N
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,N
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
 48   CONTINUE
      MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM1=(Z1(JKM)+SUM1)/FAC1
            DO I=1,NM1
               IM1=I+M1
               Z1(IM1)=Z1(IM1)+FJAC(I,JKM)*SUM1
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE1,E1,Z1(M1+1),IP1)
 49   CONTINUE
      DO I=M1,1,-1
         Z1(I)=(Z1(I)+Z1(M2+I))/FAC1
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO I=1,N
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,Z1,IP1)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO I=1,N
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
  45  CONTINUE
      MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM1=(Z1(JKM)+SUM1)/FAC1
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               Z1(IM1)=Z1(IM1)+FJAC(I+MUJAC+1-J,JKM)*SUM1
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE1,E1,MLE,MUE,Z1(M1+1),IP1)
      GOTO 49
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S1=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            S1=S1-FMAS(I-J+MBDIAG,J)*F1(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
      DO I=1,NM1
         IM1=I+M1
         S1=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            S1=S1-FMAS(I-J+MBDIAG,J)*F1(J+M1)
         END DO
         Z1(IM1)=Z1(IM1)+S1*FAC1
      END DO
      IF (IJOB.EQ.14) GOTO 45
      GOTO 48
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO I=1,N
         S1=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            S1=S1-FMAS(I-J+MBDIAG,J)*F1(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,Z1,IP1)
      RETURN
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S1=0.0D0
         DO J=1,N
            S1=S1-FMAS(I,J)*F1(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
      DO I=1,NM1
         IM1=I+M1
         S1=0.0D0
         DO J=1,NM1
            S1=S1-FMAS(I,J)*F1(J+M1)
         END DO
         Z1(IM1)=Z1(IM1)+S1*FAC1
      END DO
      GOTO 48
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO I=1,N
         Z1(I)=Z1(I)-F1(I)*FAC1
      END DO
      DO MM=N-2,1,-1
          MP=N-MM
          MP1=MP-1
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 746
          ZSAFE=Z1(MP)
          Z1(MP)=Z1(I)
          Z1(I)=ZSAFE
 746      CONTINUE
          DO I=MP+1,N 
             Z1(I)=Z1(I)-FJAC(I,MP1)*Z1(MP)
          END DO
       END DO
       CALL SOLH(N,LDE1,E1,1,Z1,IP1)
       DO MM=1,N-2
          MP=N-MM
          MP1=MP-1
          DO I=MP+1,N 
             Z1(I)=Z1(I)+FJAC(I,MP1)*Z1(MP)
          END DO
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 750
          ZSAFE=Z1(MP)
          Z1(MP)=Z1(I)
          Z1(I)=ZSAFE
 750      CONTINUE
      END DO
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE SLVRAR
C
C ***********************************************************
C
      SUBROUTINE SLVRAI(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          M1,M2,NM1,ALPHN,BETAN,E2R,E2I,LDE1,Z2,Z3,
     &          F2,F3,CONT,IP2,IPHES,IER,IJOB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),
     &          IP2(NM1),IPHES(N),Z2(N),Z3(N),F2(N),F3(N)
      DIMENSION E2R(LDE1,NM1),E2I(LDE1,NM1)
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,13,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLC (N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
 48   ABNO=ALPHN**2+BETAN**2
      MM=M1/M2
      DO J=1,M2
         SUM2=0.D0
         SUM3=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUMH=(Z2(JKM)+SUM2)/ABNO
            SUM3=(Z3(JKM)+SUM3)/ABNO
            SUM2=SUMH*ALPHN+SUM3*BETAN
            SUM3=SUM3*ALPHN-SUMH*BETAN
            DO I=1,NM1
               IM1=I+M1
               Z2(IM1)=Z2(IM1)+FJAC(I,JKM)*SUM2
               Z3(IM1)=Z3(IM1)+FJAC(I,JKM)*SUM3
            END DO
         END DO
      END DO
      CALL SOLC (NM1,LDE1,E2R,E2I,Z2(M1+1),Z3(M1+1),IP2)
 49   CONTINUE
      DO I=M1,1,-1
         MPI=M2+I
         Z2I=Z2(I)+Z2(MPI)
         Z3I=Z3(I)+Z3(MPI)
         Z3(I)=(Z3I*ALPHN-Z2I*BETAN)/ABNO
         Z2(I)=(Z2I*ALPHN+Z3I*BETAN)/ABNO
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLBC (N,LDE1,E2R,E2I,MLE,MUE,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
  45  ABNO=ALPHN**2+BETAN**2
      MM=M1/M2
      DO J=1,M2
         SUM2=0.D0
         SUM3=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUMH=(Z2(JKM)+SUM2)/ABNO
            SUM3=(Z3(JKM)+SUM3)/ABNO
            SUM2=SUMH*ALPHN+SUM3*BETAN
            SUM3=SUM3*ALPHN-SUMH*BETAN
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               IIMU=I+MUJAC+1-J
               Z2(IM1)=Z2(IM1)+FJAC(IIMU,JKM)*SUM2
               Z3(IM1)=Z3(IM1)+FJAC(IIMU,JKM)*SUM3
            END DO
         END DO
      END DO
      CALL SOLBC (NM1,LDE1,E2R,E2I,MLE,MUE,Z2(M1+1),Z3(M1+1),IP2)
      GOTO 49
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S2=0.0D0
         S3=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            BB=FMAS(I-J+MBDIAG,J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLC(N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO I=1,NM1
         IM1=I+M1
         S2=0.0D0
         S3=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            JM1=J+M1
            BB=FMAS(I-J+MBDIAG,J)
            S2=S2-BB*F2(JM1)
            S3=S3-BB*F3(JM1)
         END DO
         Z2(IM1)=Z2(IM1)+S2*ALPHN-S3*BETAN
         Z3(IM1)=Z3(IM1)+S3*ALPHN+S2*BETAN
      END DO
      IF (IJOB.EQ.14) GOTO 45
      GOTO 48
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO I=1,N
         S2=0.0D0
         S3=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            BB=FMAS(I-J+MBDIAG,J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLBC(N,LDE1,E2R,E2I,MLE,MUE,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S2=0.0D0
         S3=0.0D0
         DO J=1,N
            BB=FMAS(I,J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLC(N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO I=1,NM1
         IM1=I+M1
         S2=0.0D0
         S3=0.0D0
         DO J=1,NM1
            JM1=J+M1
            BB=FMAS(I,J)
            S2=S2-BB*F2(JM1)
            S3=S3-BB*F3(JM1)
         END DO
         Z2(IM1)=Z2(IM1)+S2*ALPHN-S3*BETAN
         Z3(IM1)=Z3(IM1)+S3*ALPHN+S2*BETAN
      END DO
      GOTO 48
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO MM=N-2,1,-1
          MP=N-MM
          MP1=MP-1
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 746
          ZSAFE=Z2(MP)
          Z2(MP)=Z2(I)
          Z2(I)=ZSAFE 
          ZSAFE=Z3(MP)
          Z3(MP)=Z3(I)
          Z3(I)=ZSAFE
 746      CONTINUE
          DO I=MP+1,N 
             E1IMP=FJAC(I,MP1)
             Z2(I)=Z2(I)-E1IMP*Z2(MP)
             Z3(I)=Z3(I)-E1IMP*Z3(MP)
          END DO
       END DO
       CALL SOLHC(N,LDE1,E2R,E2I,1,Z2,Z3,IP2)
       DO MM=1,N-2
          MP=N-MM
          MP1=MP-1
          DO I=MP+1,N 
             E1IMP=FJAC(I,MP1)
             Z2(I)=Z2(I)+E1IMP*Z2(MP)
             Z3(I)=Z3(I)+E1IMP*Z3(MP)
          END DO
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 750
          ZSAFE=Z2(MP)
          Z2(MP)=Z2(I)
          Z2(I)=ZSAFE 
          ZSAFE=Z3(MP)
          Z3(MP)=Z3(I)
          Z3(I)=ZSAFE
 750      CONTINUE
      END DO
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE SLVRAI
C
C ***********************************************************
C
      SUBROUTINE SLVRAD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          M1,M2,NM1,FAC1,ALPHN,BETAN,E1,E2R,E2I,LDE1,Z1,Z2,Z3,
     &          F1,F2,F3,CONT,IP1,IP2,IPHES,IER,IJOB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E1(LDE1,NM1),
     &          E2R(LDE1,NM1),E2I(LDE1,NM1),IP1(NM1),IP2(NM1),
     &          IPHES(N),Z1(N),Z2(N),Z3(N),F1(N),F2(N),F3(N)
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,13,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      CALL SOLC (N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
 48   ABNO=ALPHN**2+BETAN**2
      MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         SUM2=0.D0
         SUM3=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM1=(Z1(JKM)+SUM1)/FAC1
            SUMH=(Z2(JKM)+SUM2)/ABNO
            SUM3=(Z3(JKM)+SUM3)/ABNO
            SUM2=SUMH*ALPHN+SUM3*BETAN
            SUM3=SUM3*ALPHN-SUMH*BETAN
            DO I=1,NM1
               IM1=I+M1
               Z1(IM1)=Z1(IM1)+FJAC(I,JKM)*SUM1
               Z2(IM1)=Z2(IM1)+FJAC(I,JKM)*SUM2
               Z3(IM1)=Z3(IM1)+FJAC(I,JKM)*SUM3
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE1,E1,Z1(M1+1),IP1)
      CALL SOLC (NM1,LDE1,E2R,E2I,Z2(M1+1),Z3(M1+1),IP2)
 49   CONTINUE
      DO I=M1,1,-1
         MPI=M2+I
         Z1(I)=(Z1(I)+Z1(MPI))/FAC1
         Z2I=Z2(I)+Z2(MPI)
         Z3I=Z3(I)+Z3(MPI)
         Z3(I)=(Z3I*ALPHN-Z2I*BETAN)/ABNO
         Z2(I)=(Z2I*ALPHN+Z3I*BETAN)/ABNO
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,Z1,IP1)
      CALL SOLBC (N,LDE1,E2R,E2I,MLE,MUE,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
  45  ABNO=ALPHN**2+BETAN**2
      MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         SUM2=0.D0
         SUM3=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM1=(Z1(JKM)+SUM1)/FAC1
            SUMH=(Z2(JKM)+SUM2)/ABNO
            SUM3=(Z3(JKM)+SUM3)/ABNO
            SUM2=SUMH*ALPHN+SUM3*BETAN
            SUM3=SUM3*ALPHN-SUMH*BETAN
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               FFJA=FJAC(I+MUJAC+1-J,JKM)
               Z1(IM1)=Z1(IM1)+FFJA*SUM1
               Z2(IM1)=Z2(IM1)+FFJA*SUM2
               Z3(IM1)=Z3(IM1)+FFJA*SUM3
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE1,E1,MLE,MUE,Z1(M1+1),IP1)
      CALL SOLBC (NM1,LDE1,E2R,E2I,MLE,MUE,Z2(M1+1),Z3(M1+1),IP2)
      GOTO 49
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S1=0.0D0
         S2=0.0D0
         S3=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            BB=FMAS(I-J+MBDIAG,J)
            S1=S1-BB*F1(J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      CALL SOLC(N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO I=1,NM1
         IM1=I+M1
         S1=0.0D0
         S2=0.0D0
         S3=0.0D0
         J1B=MAX(1,I-MLMAS)
         J2B=MIN(NM1,I+MUMAS)
         DO J=J1B,J2B
            JM1=J+M1
            BB=FMAS(I-J+MBDIAG,J)
            S1=S1-BB*F1(JM1)
            S2=S2-BB*F2(JM1)
            S3=S3-BB*F3(JM1)
         END DO
         Z1(IM1)=Z1(IM1)+S1*FAC1
         Z2(IM1)=Z2(IM1)+S2*ALPHN-S3*BETAN
         Z3(IM1)=Z3(IM1)+S3*ALPHN+S2*BETAN
      END DO
      IF (IJOB.EQ.14) GOTO 45
      GOTO 48
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO I=1,N
         S1=0.0D0
         S2=0.0D0
         S3=0.0D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            BB=FMAS(I-J+MBDIAG,J)
            S1=S1-BB*F1(J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,Z1,IP1)
      CALL SOLBC(N,LDE1,E2R,E2I,MLE,MUE,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         S1=0.0D0
         S2=0.0D0
         S3=0.0D0
         DO J=1,N
            BB=FMAS(I,J)
            S1=S1-BB*F1(J)
            S2=S2-BB*F2(J)
            S3=S3-BB*F3(J)
         END DO
         Z1(I)=Z1(I)+S1*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      CALL SOL (N,LDE1,E1,Z1,IP1)
      CALL SOLC(N,LDE1,E2R,E2I,Z2,Z3,IP2)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO I=1,NM1
         IM1=I+M1
         S1=0.0D0
         S2=0.0D0
         S3=0.0D0
         DO J=1,NM1
            JM1=J+M1
            BB=FMAS(I,J)
            S1=S1-BB*F1(JM1)
            S2=S2-BB*F2(JM1)
            S3=S3-BB*F3(JM1)
         END DO
         Z1(IM1)=Z1(IM1)+S1*FAC1
         Z2(IM1)=Z2(IM1)+S2*ALPHN-S3*BETAN
         Z3(IM1)=Z3(IM1)+S3*ALPHN+S2*BETAN
      END DO
      GOTO 48
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO I=1,N
         S2=-F2(I)
         S3=-F3(I)
         Z1(I)=Z1(I)-F1(I)*FAC1
         Z2(I)=Z2(I)+S2*ALPHN-S3*BETAN
         Z3(I)=Z3(I)+S3*ALPHN+S2*BETAN
      END DO
      DO MM=N-2,1,-1
          MP=N-MM
          MP1=MP-1
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 746
          ZSAFE=Z1(MP)
          Z1(MP)=Z1(I)
          Z1(I)=ZSAFE
          ZSAFE=Z2(MP)
          Z2(MP)=Z2(I)
          Z2(I)=ZSAFE 
          ZSAFE=Z3(MP)
          Z3(MP)=Z3(I)
          Z3(I)=ZSAFE
 746      CONTINUE
          DO I=MP+1,N 
             E1IMP=FJAC(I,MP1)
             Z1(I)=Z1(I)-E1IMP*Z1(MP)
             Z2(I)=Z2(I)-E1IMP*Z2(MP)
             Z3(I)=Z3(I)-E1IMP*Z3(MP)
          END DO
       END DO
       CALL SOLH(N,LDE1,E1,1,Z1,IP1)
       CALL SOLHC(N,LDE1,E2R,E2I,1,Z2,Z3,IP2)
       DO MM=1,N-2
          MP=N-MM
          MP1=MP-1
          DO I=MP+1,N 
             E1IMP=FJAC(I,MP1)
             Z1(I)=Z1(I)+E1IMP*Z1(MP)
             Z2(I)=Z2(I)+E1IMP*Z2(MP)
             Z3(I)=Z3(I)+E1IMP*Z3(MP)
          END DO
          I=IPHES(MP)
          IF (I.EQ.MP) GOTO 750
          ZSAFE=Z1(MP)
          Z1(MP)=Z1(I)
          Z1(I)=ZSAFE
          ZSAFE=Z2(MP)
          Z2(MP)=Z2(I)
          Z2(I)=ZSAFE 
          ZSAFE=Z3(MP)
          Z3(MP)=Z3(I)
          Z3(I)=ZSAFE
 750      CONTINUE
      END DO
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE SLVRAD
C
C ***********************************************************
C
      SUBROUTINE ESTRAD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          H,DD1,DD2,DD3,FCN,NFCN,Y0,Y,IJOB,X,M1,M2,NM1,
     &          E1,LDE1,Z1,Z2,Z3,CONT,F1,F2,IP1,IPHES,SCAL,ERR,
     &          FIRST,REJECT,FAC1,RPAR,IPAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E1(LDE1,NM1),IP1(NM1),
     &     SCAL(N),IPHES(N),Z1(N),Z2(N),Z3(N),F1(N),F2(N),Y0(N),Y(N)
      DIMENSION CONT(N),RPAR(1),IPAR(1)
      LOGICAL FIRST,REJECT
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
      HEE1=DD1/H
      HEE2=DD2/H
      HEE3=DD3/H
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,14,15), IJOB
C
   1  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO  I=1,N 
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  11  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,N 
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
  48  MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            SUM1=(CONT(J+K*M2)+SUM1)/FAC1
            DO I=1,NM1
               IM1=I+M1
               CONT(IM1)=CONT(IM1)+FJAC(I,J+K*M2)*SUM1
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE1,E1,CONT(M1+1),IP1) 
      DO I=M1,1,-1
         CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
      END DO
      GOTO 77
C
   2  CONTINUE
C ------  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO I=1,N 
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
      GOTO 77
C
  12  CONTINUE
C ------  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO I=1,N 
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
  45  MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            SUM1=(CONT(J+K*M2)+SUM1)/FAC1
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               CONT(IM1)=CONT(IM1)+FJAC(I+MUJAC+1-J,J+K*M2)*SUM1
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE1,E1,MLE,MUE,CONT(M1+1),IP1)
      DO I=M1,1,-1
         CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
      END DO
      GOTO 77
C
   3  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*F1(J)
         END DO
         F2(I)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  13  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      DO I=M1+1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*F1(J+M1)
         END DO
         IM1=I+M1
         F2(IM1)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 48
C
   4  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO I=1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*F1(J)
         END DO
         F2(I)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
      GOTO 77
C
  14  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO I=1,M1
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      DO I=M1+1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*F1(J+M1)
         END DO
         IM1=I+M1
         F2(IM1)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 45
C
   5  CONTINUE
C ------  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=1,N
            SUM=SUM+FMAS(I,J)*F1(J)
         END DO
         F2(I)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  15  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO I=1,M1
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      DO I=M1+1,N
         F1(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=1,NM1
            SUM=SUM+FMAS(I,J)*F1(J+M1)
         END DO
         IM1=I+M1
         F2(IM1)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 48
C
   6  CONTINUE
C ------  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ------  THIS OPTION IS NOT PROVIDED
      RETURN
C
   7  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO I=1,N 
         F2(I)=HEE1*Z1(I)+HEE2*Z2(I)+HEE3*Z3(I)
         CONT(I)=F2(I)+Y0(I)
      END DO
      DO MM=N-2,1,-1
         MP=N-MM
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 310
         ZSAFE=CONT(MP)
         CONT(MP)=CONT(I)
         CONT(I)=ZSAFE
 310     CONTINUE
         DO I=MP+1,N 
            CONT(I)=CONT(I)-FJAC(I,MP-1)*CONT(MP)
         END DO
      END DO
      CALL SOLH(N,LDE1,E1,1,CONT,IP1)
      DO MM=1,N-2
         MP=N-MM
         DO I=MP+1,N 
            CONT(I)=CONT(I)+FJAC(I,MP-1)*CONT(MP)
         END DO
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 440
         ZSAFE=CONT(MP)
         CONT(MP)=CONT(I)
         CONT(I)=ZSAFE
 440     CONTINUE
      END DO
C
C --------------------------------------
C
  77  CONTINUE
      ERR=0.D0
      DO  I=1,N
         ERR=ERR+(CONT(I)/SCAL(I))**2
      END DO
      ERR=MAX(SQRT(ERR/N),1.D-10)
C
      IF (ERR.LT.1.D0) RETURN
      IF (FIRST.OR.REJECT) THEN
          DO I=1,N
             CONT(I)=Y(I)+CONT(I)
          END DO
          CALL FCN(N,X,CONT,F1,RPAR,IPAR)
          NFCN=NFCN+1
          DO I=1,N
             CONT(I)=F1(I)+F2(I)
          END DO
          GOTO (31,32,31,32,31,32,33,55,55,55,41,42,41,42,41), IJOB
C ------ FULL MATRIX OPTION
  31      CONTINUE
          CALL SOL(N,LDE1,E1,CONT,IP1) 
          GOTO 88
C ------ FULL MATRIX OPTION, SECOND ORDER
 41      CONTINUE
         DO J=1,M2
            SUM1=0.D0
            DO K=MM-1,0,-1
               SUM1=(CONT(J+K*M2)+SUM1)/FAC1
               DO I=1,NM1
                  IM1=I+M1
                  CONT(IM1)=CONT(IM1)+FJAC(I,J+K*M2)*SUM1
               END DO
            END DO
         END DO
         CALL SOL(NM1,LDE1,E1,CONT(M1+1),IP1) 
         DO I=M1,1,-1
            CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
         END DO
         GOTO 88
C ------ BANDED MATRIX OPTION
 32      CONTINUE
         CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
         GOTO 88
C ------ BANDED MATRIX OPTION, SECOND ORDER
 42      CONTINUE
         DO J=1,M2
            SUM1=0.D0
            DO K=MM-1,0,-1
               SUM1=(CONT(J+K*M2)+SUM1)/FAC1
               DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
                  IM1=I+M1
                  CONT(IM1)=CONT(IM1)+FJAC(I+MUJAC+1-J,J+K*M2)*SUM1
               END DO
            END DO
         END DO
         CALL SOLB (NM1,LDE1,E1,MLE,MUE,CONT(M1+1),IP1)
         DO I=M1,1,-1
            CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
         END DO
          GOTO 88
C ------ HESSENBERG MATRIX OPTION
  33      CONTINUE
          DO MM=N-2,1,-1
             MP=N-MM
             I=IPHES(MP)
             IF (I.EQ.MP) GOTO 510
             ZSAFE=CONT(MP)
             CONT(MP)=CONT(I)
             CONT(I)=ZSAFE
 510         CONTINUE
             DO I=MP+1,N 
                CONT(I)=CONT(I)-FJAC(I,MP-1)*CONT(MP)
             END DO
          END DO
          CALL SOLH(N,LDE1,E1,1,CONT,IP1)
          DO MM=1,N-2
             MP=N-MM
             DO I=MP+1,N 
                CONT(I)=CONT(I)+FJAC(I,MP-1)*CONT(MP)
             END DO
             I=IPHES(MP)
             IF (I.EQ.MP) GOTO 640
             ZSAFE=CONT(MP)
             CONT(MP)=CONT(I)
             CONT(I)=ZSAFE
 640         CONTINUE
          END DO
C -----------------------------------
   88     CONTINUE
          ERR=0.D0 
          DO I=1,N
             ERR=ERR+(CONT(I)/SCAL(I))**2
          END DO
          ERR=MAX(SQRT(ERR/N),1.D-10)
       END IF
       RETURN
C -----------------------------------------------------------
  55   CONTINUE
       RETURN
       END
C
C     END OF SUBROUTINE ESTRAD
C
C ***********************************************************
C
      SUBROUTINE ESTRAV(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          H,DD,FCN,NFCN,Y0,Y,IJOB,X,M1,M2,NM1,NS,NNS,
     &          E1,LDE1,ZZ,CONT,FF,IP1,IPHES,SCAL,ERR,
     &          FIRST,REJECT,FAC1,RPAR,IPAR)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E1(LDE1,NM1),IP1(NM1),
     &     SCAL(N),IPHES(N),ZZ(NNS),FF(NNS),Y0(N),Y(N)
      DIMENSION DD(NS),CONT(N),RPAR(1),IPAR(1)
      LOGICAL FIRST,REJECT
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
      GOTO (1,2,3,4,5,6,7,55,55,55,11,12,13,14,15), IJOB
C
   1  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  11  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
  48  MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            SUM1=(CONT(J+K*M2)+SUM1)/FAC1
            DO I=1,NM1
               IM1=I+M1
               CONT(IM1)=CONT(IM1)+FJAC(I,J+K*M2)*SUM1
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE1,E1,CONT(M1+1),IP1) 
      DO I=M1,1,-1
         CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
      END DO
      GOTO 77
C
   2  CONTINUE
C ------  B=IDENTITY, JACOBIAN A BANDED MATRIX
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
      GOTO 77
C
  12  CONTINUE
C ------  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
  45  MM=M1/M2
      DO J=1,M2
         SUM1=0.D0
         DO K=MM-1,0,-1
            SUM1=(CONT(J+K*M2)+SUM1)/FAC1
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               CONT(IM1)=CONT(IM1)+FJAC(I+MUJAC+1-J,J+K*M2)*SUM1
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE1,E1,MLE,MUE,CONT(M1+1),IP1)
      DO I=M1,1,-1
         CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
      END DO
      GOTO 77
C
   3  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*FF(J)
         END DO
         FF(I+N)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  13  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO  I=1,M1
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      DO I=M1+1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*FF(J+M1)
         END DO
         IM1=I+M1
         FF(IM1+N)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 48
C
   4  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*FF(J)
         END DO
         FF(I+N)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
      GOTO 77
C
  14  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX, SECOND ORDER
      DO  I=1,M1
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      DO I=M1+1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*FF(J+M1)
         END DO
         IM1=I+M1
         FF(IM1+N)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 45
C
   5  CONTINUE
C ------  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      DO I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,N
         SUM=0.D0
         DO J=1,N
            SUM=SUM+FMAS(I,J)*FF(J)
         END DO
         FF(I+N)=SUM
         CONT(I)=SUM+Y0(I)
      END DO
      CALL SOL (N,LDE1,E1,CONT,IP1) 
      GOTO 77
C
  15  CONTINUE
C ------  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      DO  I=1,M1
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      DO I=M1+1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I)=SUM/H
      END DO
      DO I=1,NM1
         SUM=0.D0
         DO J=1,NM1
            SUM=SUM+FMAS(I,J)*FF(J+M1)
         END DO
         IM1=I+M1
         FF(IM1+N)=SUM
         CONT(IM1)=SUM+Y0(IM1)
      END DO
      GOTO 48
C
   6  CONTINUE
C ------  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ------  THIS OPTION IS NOT PROVIDED
      RETURN
C
   7  CONTINUE
C ------  B=IDENTITY, JACOBIAN A FULL MATRIX, HESSENBERG-OPTION
      DO  I=1,N
         SUM=0.D0
         DO K=1,NS
            SUM=SUM+DD(K)*ZZ(I+(K-1)*N)
         END DO
         FF(I+N)=SUM/H
         CONT(I)=FF(I+N)+Y0(I)
      END DO
      DO MM=N-2,1,-1
         MP=N-MM
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 310
         ZSAFE=CONT(MP)
         CONT(MP)=CONT(I)
         CONT(I)=ZSAFE
 310     CONTINUE
         DO I=MP+1,N 
            CONT(I)=CONT(I)-FJAC(I,MP-1)*CONT(MP)
         END DO
      END DO
      CALL SOLH(N,LDE1,E1,1,CONT,IP1)
      DO MM=1,N-2
         MP=N-MM
         DO I=MP+1,N 
            CONT(I)=CONT(I)+FJAC(I,MP-1)*CONT(MP)
         END DO
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 440
         ZSAFE=CONT(MP)
         CONT(MP)=CONT(I)
         CONT(I)=ZSAFE
 440     CONTINUE
      END DO
C
C --------------------------------------
C
  77  CONTINUE
      ERR=0.D0
      DO  I=1,N
         ERR=ERR+(CONT(I)/SCAL(I))**2
      END DO
      ERR=MAX(SQRT(ERR/N),1.D-10)
C
      IF (ERR.LT.1.D0) RETURN
      IF (FIRST.OR.REJECT) THEN
          DO I=1,N
             CONT(I)=Y(I)+CONT(I)
          END DO
          CALL FCN(N,X,CONT,FF,RPAR,IPAR)
          NFCN=NFCN+1
          DO I=1,N
             CONT(I)=FF(I)+FF(I+N)
          END DO
          GOTO (31,32,31,32,31,32,33,55,55,55,41,42,41,42,41), IJOB
C ------ FULL MATRIX OPTION
 31      CONTINUE
         CALL SOL (N,LDE1,E1,CONT,IP1) 
          GOTO 88
C ------ FULL MATRIX OPTION, SECOND ORDER
 41      CONTINUE
         DO J=1,M2
            SUM1=0.D0
            DO K=MM-1,0,-1
               SUM1=(CONT(J+K*M2)+SUM1)/FAC1
               DO I=1,NM1
                  IM1=I+M1
                  CONT(IM1)=CONT(IM1)+FJAC(I,J+K*M2)*SUM1
               END DO
            END DO
         END DO
         CALL SOL (NM1,LDE1,E1,CONT(M1+1),IP1) 
         DO I=M1,1,-1
            CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
         END DO
          GOTO 88
C ------ BANDED MATRIX OPTION
 32      CONTINUE
         CALL SOLB (N,LDE1,E1,MLE,MUE,CONT,IP1)
          GOTO 88
C ------ BANDED MATRIX OPTION, SECOND ORDER
 42      CONTINUE
         DO J=1,M2
            SUM1=0.D0
            DO K=MM-1,0,-1
               SUM1=(CONT(J+K*M2)+SUM1)/FAC1
               DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
                  IM1=I+M1
                  CONT(IM1)=CONT(IM1)+FJAC(I+MUJAC+1-J,J+K*M2)*SUM1
               END DO
            END DO
         END DO
         CALL SOLB (NM1,LDE1,E1,MLE,MUE,CONT(M1+1),IP1)
         DO I=M1,1,-1
            CONT(I)=(CONT(I)+CONT(M2+I))/FAC1
         END DO
          GOTO 88
C ------ HESSENBERG MATRIX OPTION
  33      CONTINUE
          DO MM=N-2,1,-1
             MP=N-MM
             I=IPHES(MP)
             IF (I.EQ.MP) GOTO 510
             ZSAFE=CONT(MP)
             CONT(MP)=CONT(I)
             CONT(I)=ZSAFE
 510         CONTINUE
             DO I=MP+1,N 
                CONT(I)=CONT(I)-FJAC(I,MP-1)*CONT(MP)
             END DO
          END DO
          CALL SOLH(N,LDE1,E1,1,CONT,IP1)
          DO MM=1,N-2
             MP=N-MM
             DO I=MP+1,N 
                CONT(I)=CONT(I)+FJAC(I,MP-1)*CONT(MP)
             END DO
             I=IPHES(MP)
             IF (I.EQ.MP) GOTO 640
             ZSAFE=CONT(MP)
             CONT(MP)=CONT(I)
             CONT(I)=ZSAFE
 640         CONTINUE
          END DO
C -----------------------------------
  88      CONTINUE
          ERR=0.D0 
          DO I=1,N
             ERR=ERR+(CONT(I)/SCAL(I))**2
          END DO
          ERR=MAX(SQRT(ERR/N),1.D-10)
       END IF
       RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
       END
C
C     END OF SUBROUTINE ESTRAV
C
C ***********************************************************
C
      SUBROUTINE SLVROD(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          M1,M2,NM1,FAC1,E,LDE,IP,DY,AK,FX,YNEW,HD,IJOB,STAGE1)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E(LDE,NM1),
     &          IP(NM1),DY(N),AK(N),FX(N),YNEW(N)
      LOGICAL STAGE1
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      IF (HD.EQ.0.D0) THEN
         DO  I=1,N
           AK(I)=DY(I)
         END DO
      ELSE
         DO I=1,N
            AK(I)=DY(I)+HD*FX(I)
         END DO
      END IF
C
      GOTO (1,2,3,4,5,6,55,55,55,55,11,12,13,13,15), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      IF (STAGE1) THEN
         DO I=1,N
            AK(I)=AK(I)+YNEW(I)
         END DO
      END IF
      CALL SOL (N,LDE,E,AK,IP)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      IF (STAGE1) THEN
         DO I=1,N
            AK(I)=AK(I)+YNEW(I)
         END DO
      END IF
 48   MM=M1/M2
      DO J=1,M2
         SUM=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM=(AK(JKM)+SUM)/FAC1
            DO I=1,NM1
               IM1=I+M1
               AK(IM1)=AK(IM1)+FJAC(I,JKM)*SUM
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE,E,AK(M1+1),IP)
      DO I=M1,1,-1
         AK(I)=(AK(I)+AK(M2+I))/FAC1
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      IF (STAGE1) THEN
         DO I=1,N
            AK(I)=AK(I)+YNEW(I)
         END DO
      END IF
      CALL SOLB (N,LDE,E,MLE,MUE,AK,IP)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      IF (STAGE1) THEN
         DO I=1,N
            AK(I)=AK(I)+YNEW(I)
         END DO
      END IF
  45  MM=M1/M2
      DO J=1,M2
         SUM=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM=(AK(JKM)+SUM)/FAC1
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               AK(IM1)=AK(IM1)+FJAC(I+MUJAC+1-J,JKM)*SUM
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE,E,MLE,MUE,AK(M1+1),IP)
      DO I=M1,1,-1
         AK(I)=(AK(I)+AK(M2+I))/FAC1
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   3  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX
      IF (STAGE1) THEN
      DO  I=1,N
         SUM=0.D0
         DO  J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*YNEW(J)
         END DO
         AK(I)=AK(I)+SUM
      END DO
      END IF
      CALL SOL (N,LDE,E,AK,IP)
      RETURN
C
C -----------------------------------------------------------
C
  13  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      IF (STAGE1) THEN
         DO I=1,M1
            AK(I)=AK(I)+YNEW(I)
         END DO
         DO I=1,NM1
            SUM=0.D0
            DO J=MAX(1,I-MLMAS),MIN(NM1,I+MUMAS)
                SUM=SUM+FMAS(I-J+MBDIAG,J)*YNEW(J+M1)
            END DO
            IM1=I+M1
            AK(IM1)=AK(IM1)+SUM
         END DO
      END IF
      IF (IJOB.EQ.14) GOTO 45
      GOTO 48
C
C -----------------------------------------------------------
C
   4  CONTINUE
C ---  B IS A BANDED MATRIX, JACOBIAN A BANDED MATRIX
      IF (STAGE1) THEN
      DO I=1,N
         SUM=0.D0
         DO J=MAX(1,I-MLMAS),MIN(N,I+MUMAS)
            SUM=SUM+FMAS(I-J+MBDIAG,J)*YNEW(J)
         END DO
         AK(I)=AK(I)+SUM
      END DO
      END IF
      CALL SOLB (N,LDE,E,MLE,MUE,AK,IP)
      RETURN
C
C -----------------------------------------------------------
C
   5  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX
      IF (STAGE1) THEN
      DO I=1,N
         SUM=0.D0
         DO J=1,N
            SUM=SUM+FMAS(I,J)*YNEW(J)
         END DO
         AK(I)=AK(I)+SUM
      END DO
      END IF
      CALL SOL (N,LDE,E,AK,IP)
      RETURN
C
C -----------------------------------------------------------
C
  15  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A FULL MATRIX, SECOND ORDER
      IF (STAGE1) THEN
         DO I=1,M1
            AK(I)=AK(I)+YNEW(I)
         END DO
         DO I=1,NM1
            SUM=0.D0
            DO J=1,NM1
               SUM=SUM+FMAS(I,J)*YNEW(J+M1)
            END DO
            IM1=I+M1
            AK(IM1)=AK(IM1)+SUM
         END DO
      END IF
      GOTO 48
C
C -----------------------------------------------------------
C
   6  CONTINUE
C ---  B IS A FULL MATRIX, JACOBIAN A BANDED MATRIX
C ---  THIS OPTION IS NOT PROVIDED
      IF (STAGE1) THEN
      DO 624 I=1,N
         SUM=0.D0
         DO 623 J=1,N
  623       SUM=SUM+FMAS(I,J)*YNEW(J)
  624    AK(I)=AK(I)+SUM
      CALL SOLB (N,LDE,E,MLE,MUE,AK,IP)
      END IF
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE SLVROD
C
C
C ***********************************************************
C
      SUBROUTINE SLVSEU(N,FJAC,LDJAC,MLJAC,MUJAC,FMAS,LDMAS,MLMAS,MUMAS,
     &          M1,M2,NM1,FAC1,E,LDE,IP,IPHES,DEL,IJOB)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION FJAC(LDJAC,N),FMAS(LDMAS,NM1),E(LDE,NM1),DEL(N)
      DIMENSION IP(NM1),IPHES(N)
      COMMON/LINAL/MLE,MUE,MBJAC,MBB,MDIAG,MDIFF,MBDIAG
c$omp threadprivate(/linal/)
C
      GOTO (1,2,1,2,1,55,7,55,55,55,11,12,11,12,11), IJOB
C
C -----------------------------------------------------------
C
   1  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX
      CALL SOL (N,LDE,E,DEL,IP)
      RETURN
C
C -----------------------------------------------------------
C
  11  CONTINUE
C ---  B=IDENTITY, JACOBIAN A FULL MATRIX, SECOND ORDER
      MM=M1/M2
      DO J=1,M2
         SUM=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM=(DEL(JKM)+SUM)/FAC1
            DO I=1,NM1
               IM1=I+M1
               DEL(IM1)=DEL(IM1)+FJAC(I,JKM)*SUM
            END DO
         END DO
      END DO
      CALL SOL (NM1,LDE,E,DEL(M1+1),IP)
      DO I=M1,1,-1
         DEL(I)=(DEL(I)+DEL(M2+I))/FAC1
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   2  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX
      CALL SOLB (N,LDE,E,MLE,MUE,DEL,IP)
      RETURN
C
C -----------------------------------------------------------
C
  12  CONTINUE
C ---  B=IDENTITY, JACOBIAN A BANDED MATRIX, SECOND ORDER
      MM=M1/M2
      DO J=1,M2
         SUM=0.D0
         DO K=MM-1,0,-1
            JKM=J+K*M2
            SUM=(DEL(JKM)+SUM)/FAC1
            DO I=MAX(1,J-MUJAC),MIN(NM1,J+MLJAC)
               IM1=I+M1
               DEL(IM1)=DEL(IM1)+FJAC(I+MUJAC+1-J,JKM)*SUM
            END DO
         END DO
      END DO
      CALL SOLB (NM1,LDE,E,MLE,MUE,DEL(M1+1),IP)
      DO I=M1,1,-1
         DEL(I)=(DEL(I)+DEL(M2+I))/FAC1
      END DO
      RETURN
C
C -----------------------------------------------------------
C
   7  CONTINUE
C ---  HESSENBERG OPTION
      DO MMM=N-2,1,-1
         MP=N-MMM
         MP1=MP-1
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 110
         ZSAFE=DEL(MP)
         DEL(MP)=DEL(I)
         DEL(I)=ZSAFE
 110     CONTINUE
         DO I=MP+1,N 
            DEL(I)=DEL(I)-FJAC(I,MP1)*DEL(MP)
         END DO
      END DO
      CALL SOLH(N,LDE,E,1,DEL,IP)
      DO MMM=1,N-2
         MP=N-MMM
         MP1=MP-1
         DO I=MP+1,N 
            DEL(I)=DEL(I)+FJAC(I,MP1)*DEL(MP)
         END DO
         I=IPHES(MP)
         IF (I.EQ.MP) GOTO 240
         ZSAFE=DEL(MP)
         DEL(MP)=DEL(I)
         DEL(I)=ZSAFE
 240     CONTINUE
      END DO
      RETURN
C
C -----------------------------------------------------------
C
  55  CONTINUE
      RETURN
      END
C
C     END OF SUBROUTINE SLVSEU
C
      SUBROUTINE DEC (N, NDIM, A, IP, IER)
C VERSION REAL DOUBLE PRECISION
      INTEGER N,NDIM,IP,IER,NM1,K,KP1,M,I,J
      DOUBLE PRECISION A,T
      DIMENSION A(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION.
C  INPUT..
C     N = ORDER OF MATRIX.
C     NDIM = DECLARED DIMENSION OF ARRAY  A .
C     A = MATRIX TO BE TRIANGULARIZED.
C  OUTPUT..
C     A(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U .
C     A(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW.
C     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE
C           SINGULAR AT STAGE K.
C  USE  SOL  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  DETERM(A) = IP(N)*A(1,1)*A(2,2)*...*A(N,N).
C  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1
      IF (N .EQ. 1) GO TO 70
      NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = K
        DO 10 I = KP1,N
          IF (DABS(A(I,K)) .GT. DABS(A(M,K))) M = I  
 10     CONTINUE
        IP(K) = M
        T = A(M,K)
        IF (M .EQ. K) GO TO 20
        IP(N) = -IP(N)
        A(M,K) = A(K,K)
        A(K,K) = T
 20     CONTINUE
        IF (T .EQ. 0.D0) GO TO 80
        T = 1.D0/T
        DO 30 I = KP1,N
 30       A(I,K) = -A(I,K)*T
        DO 50 J = KP1,N
          T = A(M,J)
          A(M,J) = A(K,J)
          A(K,J) = T
          IF (T .EQ. 0.D0) GO TO 45
          DO 40 I = KP1,N
 40         A(I,J) = A(I,J) + A(I,K)*T
 45       CONTINUE
 50       CONTINUE
 60     CONTINUE
 70   K = N
      IF (A(N,N) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DEC -------------------------
      END
C
C
      SUBROUTINE SOL (N, NDIM, A, B, IP)
C VERSION REAL DOUBLE PRECISION
      INTEGER N,NDIM,IP,NM1,K,KP1,M,I,KB,KM1
      DOUBLE PRECISION A,B,T
      DIMENSION A(NDIM,N), B(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B .
C  INPUT..
C    N = ORDER OF MATRIX.
C    NDIM = DECLARED DIMENSION OF ARRAY  A .
C    A = TRIANGULARIZED MATRIX OBTAINED FROM DEC.
C    B = RIGHT HAND SIDE VECTOR.
C    IP = PIVOT VECTOR OBTAINED FROM DEC.
C  DO NOT USE IF DEC HAS SET IER .NE. 0.
C  OUTPUT..
C    B = SOLUTION VECTOR, X .
C-----------------------------------------------------------------------
      IF (N .EQ. 1) GO TO 50
      NM1 = N - 1
      DO 20 K = 1,NM1
        KP1 = K + 1
        M = IP(K)
        T = B(M)
        B(M) = B(K)
        B(K) = T
        DO 10 I = KP1,N
 10       B(I) = B(I) + A(I,K)*T
 20     CONTINUE
      DO 40 KB = 1,NM1
        KM1 = N - KB
        K = KM1 + 1
        B(K) = B(K)/A(K,K)
        T = -B(K)
        DO 30 I = 1,KM1
 30       B(I) = B(I) + A(I,K)*T
 40     CONTINUE
 50   B(1) = B(1)/A(1,1)
      RETURN
C----------------------- END OF SUBROUTINE SOL -------------------------
      END
c
c
      SUBROUTINE DECH (N, NDIM, A, LB, IP, IER)
C VERSION REAL DOUBLE PRECISION
      INTEGER N,NDIM,IP,IER,NM1,K,KP1,M,I,J,LB,NA
      DOUBLE PRECISION A,T
      DIMENSION A(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION OF A HESSENBERG
C  MATRIX WITH LOWER BANDWIDTH LB
C  INPUT..
C     N = ORDER OF MATRIX A.
C     NDIM = DECLARED DIMENSION OF ARRAY  A .
C     A = MATRIX TO BE TRIANGULARIZED.
C     LB = LOWER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED, LB.GE.1).
C  OUTPUT..
C     A(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U .
C     A(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW.
C     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE
C           SINGULAR AT STAGE K.
C  USE  SOLH  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  DETERM(A) = IP(N)*A(1,1)*A(2,2)*...*A(N,N).
C  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     THIS IS A SLIGHT MODIFICATION OF
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1
      IF (N .EQ. 1) GO TO 70
      NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = K
        NA = MIN0(N,LB+K)
        DO 10 I = KP1,NA
          IF (DABS(A(I,K)) .GT. DABS(A(M,K))) M = I
 10     CONTINUE
        IP(K) = M
        T = A(M,K)
        IF (M .EQ. K) GO TO 20
        IP(N) = -IP(N)
        A(M,K) = A(K,K)
        A(K,K) = T
 20     CONTINUE
        IF (T .EQ. 0.D0) GO TO 80
        T = 1.D0/T
        DO 30 I = KP1,NA
 30       A(I,K) = -A(I,K)*T
        DO 50 J = KP1,N
          T = A(M,J)
          A(M,J) = A(K,J)
          A(K,J) = T
          IF (T .EQ. 0.D0) GO TO 45
          DO 40 I = KP1,NA
 40         A(I,J) = A(I,J) + A(I,K)*T
 45       CONTINUE
 50       CONTINUE
 60     CONTINUE
 70   K = N
      IF (A(N,N) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DECH ------------------------
      END
C
C
      SUBROUTINE SOLH (N, NDIM, A, LB, B, IP)
C VERSION REAL DOUBLE PRECISION
      INTEGER N,NDIM,IP,NM1,K,KP1,M,I,KB,KM1,LB,NA
      DOUBLE PRECISION A,B,T
      DIMENSION A(NDIM,N), B(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B .
C  INPUT..
C    N = ORDER OF MATRIX A.
C    NDIM = DECLARED DIMENSION OF ARRAY  A .
C    A = TRIANGULARIZED MATRIX OBTAINED FROM DECH.
C    LB = LOWER BANDWIDTH OF A.
C    B = RIGHT HAND SIDE VECTOR.
C    IP = PIVOT VECTOR OBTAINED FROM DEC.
C  DO NOT USE IF DECH HAS SET IER .NE. 0.
C  OUTPUT..
C    B = SOLUTION VECTOR, X .
C-----------------------------------------------------------------------
      IF (N .EQ. 1) GO TO 50
      NM1 = N - 1
      DO 20 K = 1,NM1
        KP1 = K + 1
        M = IP(K)
        T = B(M)
        B(M) = B(K)
        B(K) = T
        NA = MIN0(N,LB+K)
        DO 10 I = KP1,NA
 10       B(I) = B(I) + A(I,K)*T
 20     CONTINUE
      DO 40 KB = 1,NM1
        KM1 = N - KB
        K = KM1 + 1
        B(K) = B(K)/A(K,K)
        T = -B(K)
        DO 30 I = 1,KM1
 30       B(I) = B(I) + A(I,K)*T
 40     CONTINUE
 50   B(1) = B(1)/A(1,1)
      RETURN
C----------------------- END OF SUBROUTINE SOLH ------------------------
      END
C
      SUBROUTINE DECC (N, NDIM, AR, AI, IP, IER)
C VERSION COMPLEX DOUBLE PRECISION
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER N,NDIM,IP,IER,NM1,K,KP1,M,I,J
      DIMENSION AR(NDIM,N), AI(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION
C  ------ MODIFICATION FOR COMPLEX MATRICES --------
C  INPUT..
C     N = ORDER OF MATRIX.
C     NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI .
C     (AR, AI) = MATRIX TO BE TRIANGULARIZED.
C  OUTPUT..
C     AR(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; REAL PART.
C     AI(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; IMAGINARY PART.
C     AR(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C                                                    REAL PART.
C     AI(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C                                                    IMAGINARY PART.
C     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW.
C     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE
C           SINGULAR AT STAGE K.
C  USE  SOL  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1
      IF (N .EQ. 1) GO TO 70
      NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = K
        DO 10 I = KP1,N
          IF (DABS(AR(I,K))+DABS(AI(I,K)) .GT.
     &          DABS(AR(M,K))+DABS(AI(M,K))) M = I
 10     CONTINUE
        IP(K) = M
        TR = AR(M,K)
        TI = AI(M,K)
        IF (M .EQ. K) GO TO 20
        IP(N) = -IP(N)
        AR(M,K) = AR(K,K)
        AI(M,K) = AI(K,K)
        AR(K,K) = TR
        AI(K,K) = TI
 20     CONTINUE
        IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 80
        DEN=TR*TR+TI*TI
        TR=TR/DEN
        TI=-TI/DEN
        DO 30 I = KP1,N
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          AR(I,K)=-PRODR
          AI(I,K)=-PRODI
 30       CONTINUE
        DO 50 J = KP1,N
          TR = AR(M,J)
          TI = AI(M,J)
          AR(M,J) = AR(K,J)
          AI(M,J) = AI(K,J)
          AR(K,J) = TR
          AI(K,J) = TI
          IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 48
          IF (TI .EQ. 0.D0) THEN
            DO 40 I = KP1,N
            PRODR=AR(I,K)*TR
            PRODI=AI(I,K)*TR
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 40         CONTINUE
            GO TO 48
          END IF
          IF (TR .EQ. 0.D0) THEN
            DO 45 I = KP1,N
            PRODR=-AI(I,K)*TI
            PRODI=AR(I,K)*TI
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 45         CONTINUE
            GO TO 48
          END IF
          DO 47 I = KP1,N
            PRODR=AR(I,K)*TR-AI(I,K)*TI
            PRODI=AI(I,K)*TR+AR(I,K)*TI
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 47         CONTINUE
 48       CONTINUE
 50       CONTINUE
 60     CONTINUE
 70   K = N
      IF (DABS(AR(N,N))+DABS(AI(N,N)) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DECC ------------------------
      END
C
C
      SUBROUTINE SOLC (N, NDIM, AR, AI, BR, BI, IP)
C VERSION COMPLEX DOUBLE PRECISION
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER N,NDIM,IP,NM1,K,KP1,M,I,KB,KM1
      DIMENSION AR(NDIM,N), AI(NDIM,N), BR(N), BI(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B .
C  INPUT..
C    N = ORDER OF MATRIX.
C    NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI.
C    (AR,AI) = TRIANGULARIZED MATRIX OBTAINED FROM DEC.
C    (BR,BI) = RIGHT HAND SIDE VECTOR.
C    IP = PIVOT VECTOR OBTAINED FROM DEC.
C  DO NOT USE IF DEC HAS SET IER .NE. 0.
C  OUTPUT..
C    (BR,BI) = SOLUTION VECTOR, X .
C-----------------------------------------------------------------------
      IF (N .EQ. 1) GO TO 50
      NM1 = N - 1
      DO 20 K = 1,NM1
        KP1 = K + 1
        M = IP(K)
        TR = BR(M)
        TI = BI(M)
        BR(M) = BR(K)
        BI(M) = BI(K)
        BR(K) = TR
        BI(K) = TI
        DO 10 I = KP1,N
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(I) = BR(I) + PRODR
          BI(I) = BI(I) + PRODI
 10       CONTINUE
 20     CONTINUE
      DO 40 KB = 1,NM1
        KM1 = N - KB
        K = KM1 + 1
        DEN=AR(K,K)*AR(K,K)+AI(K,K)*AI(K,K)
        PRODR=BR(K)*AR(K,K)+BI(K)*AI(K,K)
        PRODI=BI(K)*AR(K,K)-BR(K)*AI(K,K)
        BR(K)=PRODR/DEN
        BI(K)=PRODI/DEN
        TR = -BR(K)
        TI = -BI(K)
        DO 30 I = 1,KM1
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(I) = BR(I) + PRODR
          BI(I) = BI(I) + PRODI
 30       CONTINUE
 40     CONTINUE
 50     CONTINUE
        DEN=AR(1,1)*AR(1,1)+AI(1,1)*AI(1,1)
        PRODR=BR(1)*AR(1,1)+BI(1)*AI(1,1)
        PRODI=BI(1)*AR(1,1)-BR(1)*AI(1,1)
        BR(1)=PRODR/DEN
        BI(1)=PRODI/DEN
      RETURN
C----------------------- END OF SUBROUTINE SOLC ------------------------
      END  
C
C
      SUBROUTINE DECHC (N, NDIM, AR, AI, LB, IP, IER)
C VERSION COMPLEX DOUBLE PRECISION
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER N,NDIM,IP,IER,NM1,K,KP1,M,I,J
      DIMENSION AR(NDIM,N), AI(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION
C  ------ MODIFICATION FOR COMPLEX MATRICES --------
C  INPUT..
C     N = ORDER OF MATRIX.
C     NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI .
C     (AR, AI) = MATRIX TO BE TRIANGULARIZED.
C  OUTPUT..
C     AR(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; REAL PART.
C     AI(I,J), I.LE.J = UPPER TRIANGULAR FACTOR, U ; IMAGINARY PART.
C     AR(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C                                                    REAL PART.
C     AI(I,J), I.GT.J = MULTIPLIERS = LOWER TRIANGULAR FACTOR, I - L.
C                                                    IMAGINARY PART.
C     LB = LOWER BANDWIDTH OF A (DIAGONAL NOT COUNTED), LB.GE.1.
C     IP(K), K.LT.N = INDEX OF K-TH PIVOT ROW.
C     IP(N) = (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER = 0 IF MATRIX A IS NONSINGULAR, OR K IF FOUND TO BE
C           SINGULAR AT STAGE K.
C  USE  SOL  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  IF IP(N)=O, A IS SINGULAR, SOL WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1
      IF (LB .EQ. 0) GO TO 70
      IF (N .EQ. 1) GO TO 70
      NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = K 
        NA = MIN0(N,LB+K)
        DO 10 I = KP1,NA
          IF (DABS(AR(I,K))+DABS(AI(I,K)) .GT.
     &          DABS(AR(M,K))+DABS(AI(M,K))) M = I
 10     CONTINUE
        IP(K) = M
        TR = AR(M,K)
        TI = AI(M,K)
        IF (M .EQ. K) GO TO 20
        IP(N) = -IP(N)
        AR(M,K) = AR(K,K)
        AI(M,K) = AI(K,K)
        AR(K,K) = TR
        AI(K,K) = TI
 20     CONTINUE
        IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 80
        DEN=TR*TR+TI*TI
        TR=TR/DEN
        TI=-TI/DEN
        DO 30 I = KP1,NA
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          AR(I,K)=-PRODR
          AI(I,K)=-PRODI
 30       CONTINUE
        DO 50 J = KP1,N
          TR = AR(M,J)
          TI = AI(M,J)
          AR(M,J) = AR(K,J)
          AI(M,J) = AI(K,J)
          AR(K,J) = TR
          AI(K,J) = TI
          IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 48
          IF (TI .EQ. 0.D0) THEN
            DO 40 I = KP1,NA
            PRODR=AR(I,K)*TR
            PRODI=AI(I,K)*TR
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 40         CONTINUE
            GO TO 48
          END IF
          IF (TR .EQ. 0.D0) THEN
            DO 45 I = KP1,NA
            PRODR=-AI(I,K)*TI
            PRODI=AR(I,K)*TI
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 45         CONTINUE
            GO TO 48
          END IF
          DO 47 I = KP1,NA
            PRODR=AR(I,K)*TR-AI(I,K)*TI
            PRODI=AI(I,K)*TR+AR(I,K)*TI
            AR(I,J) = AR(I,J) + PRODR
            AI(I,J) = AI(I,J) + PRODI
 47         CONTINUE
 48       CONTINUE
 50       CONTINUE
 60     CONTINUE
 70   K = N
      IF (DABS(AR(N,N))+DABS(AI(N,N)) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DECHC -----------------------
      END
C
C
      SUBROUTINE SOLHC (N, NDIM, AR, AI, LB, BR, BI, IP)
C VERSION COMPLEX DOUBLE PRECISION
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER N,NDIM,IP,NM1,K,KP1,M,I,KB,KM1
      DIMENSION AR(NDIM,N), AI(NDIM,N), BR(N), BI(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B .
C  INPUT..
C    N = ORDER OF MATRIX.
C    NDIM = DECLARED DIMENSION OF ARRAYS  AR AND AI.
C    (AR,AI) = TRIANGULARIZED MATRIX OBTAINED FROM DEC.
C    (BR,BI) = RIGHT HAND SIDE VECTOR.
C    LB = LOWER BANDWIDTH OF A.
C    IP = PIVOT VECTOR OBTAINED FROM DEC.
C  DO NOT USE IF DEC HAS SET IER .NE. 0.
C  OUTPUT..
C    (BR,BI) = SOLUTION VECTOR, X .
C-----------------------------------------------------------------------
      IF (N .EQ. 1) GO TO 50
      NM1 = N - 1
      IF (LB .EQ. 0) GO TO 25
      DO 20 K = 1,NM1
        KP1 = K + 1
        M = IP(K)
        TR = BR(M)
        TI = BI(M)
        BR(M) = BR(K)
        BI(M) = BI(K)
        BR(K) = TR
        BI(K) = TI
        DO 10 I = KP1,MIN0(N,LB+K)
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(I) = BR(I) + PRODR
          BI(I) = BI(I) + PRODI
 10       CONTINUE
 20     CONTINUE
 25     CONTINUE
      DO 40 KB = 1,NM1
        KM1 = N - KB
        K = KM1 + 1
        DEN=AR(K,K)*AR(K,K)+AI(K,K)*AI(K,K)
        PRODR=BR(K)*AR(K,K)+BI(K)*AI(K,K)
        PRODI=BI(K)*AR(K,K)-BR(K)*AI(K,K)
        BR(K)=PRODR/DEN
        BI(K)=PRODI/DEN
        TR = -BR(K)
        TI = -BI(K)
        DO 30 I = 1,KM1
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(I) = BR(I) + PRODR
          BI(I) = BI(I) + PRODI
 30       CONTINUE
 40     CONTINUE
 50     CONTINUE
        DEN=AR(1,1)*AR(1,1)+AI(1,1)*AI(1,1)
        PRODR=BR(1)*AR(1,1)+BI(1)*AI(1,1)
        PRODI=BI(1)*AR(1,1)-BR(1)*AI(1,1)
        BR(1)=PRODR/DEN
        BI(1)=PRODI/DEN
      RETURN
C----------------------- END OF SUBROUTINE SOLHC -----------------------
      END  
C
      SUBROUTINE DECB (N, NDIM, A, ML, MU, IP, IER)
      REAL*8 A,T
      DIMENSION A(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION OF A BANDED
C  MATRIX WITH LOWER BANDWIDTH ML AND UPPER BANDWIDTH MU
C  INPUT..
C     N       ORDER OF THE ORIGINAL MATRIX A.
C     NDIM    DECLARED DIMENSION OF ARRAY  A.
C     A       CONTAINS THE MATRIX IN BAND STORAGE.   THE COLUMNS  
C                OF THE MATRIX ARE STORED IN THE COLUMNS OF  A  AND
C                THE DIAGONALS OF THE MATRIX ARE STORED IN ROWS 
C                ML+1 THROUGH 2*ML+MU+1 OF  A.
C     ML      LOWER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C     MU      UPPER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C  OUTPUT..
C     A       AN UPPER TRIANGULAR MATRIX IN BAND STORAGE AND 
C                THE MULTIPLIERS WHICH WERE USED TO OBTAIN IT.  
C     IP      INDEX VECTOR OF PIVOT INDICES.
C     IP(N)   (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER     = 0 IF MATRIX A IS NONSINGULAR, OR  = K IF FOUND TO BE
C                SINGULAR AT STAGE K.
C  USE  SOLB  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  DETERM(A) = IP(N)*A(MD,1)*A(MD,2)*...*A(MD,N)  WITH MD=ML+MU+1.
C  IF IP(N)=O, A IS SINGULAR, SOLB WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     THIS IS A MODIFICATION OF
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1 
      MD = ML + MU + 1
      MD1 = MD + 1
      JU = 0
      IF (ML .EQ. 0) GO TO 70
      IF (N .EQ. 1) GO TO 70
      IF (N .LT. MU+2) GO TO 7
      DO 5 J = MU+2,N
      DO 5 I = 1,ML
  5   A(I,J) = 0.D0
  7   NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = MD
        MDL = MIN(ML,N-K) + MD
        DO 10 I = MD1,MDL
          IF (DABS(A(I,K)) .GT. DABS(A(M,K))) M = I
 10     CONTINUE
        IP(K) = M + K - MD
        T = A(M,K)
        IF (M .EQ. MD) GO TO 20
        IP(N) = -IP(N)
        A(M,K) = A(MD,K)
        A(MD,K) = T
 20     CONTINUE
        IF (T .EQ. 0.D0) GO TO 80
        T = 1.D0/T
        DO 30 I = MD1,MDL
 30       A(I,K) = -A(I,K)*T 
        JU = MIN0(MAX0(JU,MU+IP(K)),N)
        MM = MD
        IF (JU .LT. KP1) GO TO 55
        DO 50 J = KP1,JU
          M = M - 1
          MM = MM - 1
          T = A(M,J) 
          IF (M .EQ. MM) GO TO 35
          A(M,J) = A(MM,J)
          A(MM,J) = T
 35       CONTINUE
          IF (T .EQ. 0.D0) GO TO 45
          JK = J - K
          DO 40 I = MD1,MDL
            IJK = I - JK
 40         A(IJK,J) = A(IJK,J) + A(I,K)*T
 45       CONTINUE
 50       CONTINUE
 55     CONTINUE
 60     CONTINUE
 70   K = N
      IF (A(MD,N) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DECB ------------------------
      END
C
C
      SUBROUTINE SOLB (N, NDIM, A, ML, MU, B, IP)
      REAL*8 A,B,T
      DIMENSION A(NDIM,N), B(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B .
C  INPUT..
C    N      ORDER OF MATRIX A.
C    NDIM   DECLARED DIMENSION OF ARRAY  A .
C    A      TRIANGULARIZED MATRIX OBTAINED FROM DECB.
C    ML     LOWER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C    MU     UPPER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C    B      RIGHT HAND SIDE VECTOR.
C    IP     PIVOT VECTOR OBTAINED FROM DECB.
C  DO NOT USE IF DECB HAS SET IER .NE. 0.
C  OUTPUT..
C    B      SOLUTION VECTOR, X .
C-----------------------------------------------------------------------
      MD = ML + MU + 1
      MD1 = MD + 1
      MDM = MD - 1
      NM1 = N - 1
      IF (ML .EQ. 0) GO TO 25
      IF (N .EQ. 1) GO TO 50
      DO 20 K = 1,NM1
        M = IP(K)
        T = B(M)
        B(M) = B(K)
        B(K) = T
        MDL = MIN(ML,N-K) + MD
        DO 10 I = MD1,MDL
          IMD = I + K - MD
 10       B(IMD) = B(IMD) + A(I,K)*T
 20     CONTINUE
 25   CONTINUE
      DO 40 KB = 1,NM1
        K = N + 1 - KB
        B(K) = B(K)/A(MD,K)
        T = -B(K) 
        KMD = MD - K
        LM = MAX0(1,KMD+1)
        DO 30 I = LM,MDM
          IMD = I - KMD
 30       B(IMD) = B(IMD) + A(I,K)*T
 40     CONTINUE
 50   B(1) = B(1)/A(MD,1)
      RETURN
C----------------------- END OF SUBROUTINE SOLB ------------------------
      END
C
      SUBROUTINE DECBC (N, NDIM, AR, AI, ML, MU, IP, IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AR(NDIM,N), AI(NDIM,N), IP(N)
C-----------------------------------------------------------------------
C  MATRIX TRIANGULARIZATION BY GAUSSIAN ELIMINATION OF A BANDED COMPLEX
C  MATRIX WITH LOWER BANDWIDTH ML AND UPPER BANDWIDTH MU
C  INPUT..
C     N       ORDER OF THE ORIGINAL MATRIX A.
C     NDIM    DECLARED DIMENSION OF ARRAY  A.
C     AR, AI     CONTAINS THE MATRIX IN BAND STORAGE.   THE COLUMNS  
C                OF THE MATRIX ARE STORED IN THE COLUMNS OF  AR (REAL
C                PART) AND AI (IMAGINARY PART)  AND
C                THE DIAGONALS OF THE MATRIX ARE STORED IN ROWS 
C                ML+1 THROUGH 2*ML+MU+1 OF  AR AND AI.
C     ML      LOWER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C     MU      UPPER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C  OUTPUT..
C     AR, AI  AN UPPER TRIANGULAR MATRIX IN BAND STORAGE AND 
C                THE MULTIPLIERS WHICH WERE USED TO OBTAIN IT.  
C     IP      INDEX VECTOR OF PIVOT INDICES.
C     IP(N)   (-1)**(NUMBER OF INTERCHANGES) OR O .
C     IER     = 0 IF MATRIX A IS NONSINGULAR, OR  = K IF FOUND TO BE
C                SINGULAR AT STAGE K.
C  USE  SOLBC  TO OBTAIN SOLUTION OF LINEAR SYSTEM.
C  DETERM(A) = IP(N)*A(MD,1)*A(MD,2)*...*A(MD,N)  WITH MD=ML+MU+1.
C  IF IP(N)=O, A IS SINGULAR, SOLBC WILL DIVIDE BY ZERO.
C
C  REFERENCE..
C     THIS IS A MODIFICATION OF
C     C. B. MOLER, ALGORITHM 423, LINEAR EQUATION SOLVER,
C     C.A.C.M. 15 (1972), P. 274.
C-----------------------------------------------------------------------
      IER = 0
      IP(N) = 1 
      MD = ML + MU + 1
      MD1 = MD + 1
      JU = 0
      IF (ML .EQ. 0) GO TO 70
      IF (N .EQ. 1) GO TO 70
      IF (N .LT. MU+2) GO TO 7
      DO 5 J = MU+2,N
      DO 5 I = 1,ML
      AR(I,J) = 0.D0
      AI(I,J) = 0.D0
  5   CONTINUE
  7   NM1 = N - 1
      DO 60 K = 1,NM1
        KP1 = K + 1
        M = MD
        MDL = MIN(ML,N-K) + MD
        DO 10 I = MD1,MDL
          IF (DABS(AR(I,K))+DABS(AI(I,K)) .GT.
     &          DABS(AR(M,K))+DABS(AI(M,K))) M = I
 10     CONTINUE
        IP(K) = M + K - MD
        TR = AR(M,K)
        TI = AI(M,K)
        IF (M .EQ. MD) GO TO 20
        IP(N) = -IP(N)
        AR(M,K) = AR(MD,K)
        AI(M,K) = AI(MD,K)
        AR(MD,K) = TR
        AI(MD,K) = TI
 20     IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 80
        DEN=TR*TR+TI*TI
        TR=TR/DEN
        TI=-TI/DEN
        DO 30 I = MD1,MDL
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          AR(I,K)=-PRODR
          AI(I,K)=-PRODI
 30       CONTINUE
        JU = MIN0(MAX0(JU,MU+IP(K)),N)
        MM = MD
        IF (JU .LT. KP1) GO TO 55
        DO 50 J = KP1,JU
          M = M - 1
          MM = MM - 1
          TR = AR(M,J)
          TI = AI(M,J)
          IF (M .EQ. MM) GO TO 35
          AR(M,J) = AR(MM,J)
          AI(M,J) = AI(MM,J)
          AR(MM,J) = TR
          AI(MM,J) = TI
 35       CONTINUE
          IF (DABS(TR)+DABS(TI) .EQ. 0.D0) GO TO 48
          JK = J - K
          IF (TI .EQ. 0.D0) THEN
            DO 40 I = MD1,MDL
            IJK = I - JK
            PRODR=AR(I,K)*TR
            PRODI=AI(I,K)*TR
            AR(IJK,J) = AR(IJK,J) + PRODR
            AI(IJK,J) = AI(IJK,J) + PRODI
 40         CONTINUE
            GO TO 48
          END IF
          IF (TR .EQ. 0.D0) THEN
            DO 45 I = MD1,MDL
            IJK = I - JK
            PRODR=-AI(I,K)*TI
            PRODI=AR(I,K)*TI
            AR(IJK,J) = AR(IJK,J) + PRODR
            AI(IJK,J) = AI(IJK,J) + PRODI
 45         CONTINUE
            GO TO 48
          END IF
          DO 47 I = MD1,MDL
            IJK = I - JK
            PRODR=AR(I,K)*TR-AI(I,K)*TI
            PRODI=AI(I,K)*TR+AR(I,K)*TI
            AR(IJK,J) = AR(IJK,J) + PRODR
            AI(IJK,J) = AI(IJK,J) + PRODI
 47         CONTINUE
 48       CONTINUE
 50       CONTINUE
 55     CONTINUE
 60     CONTINUE
 70   K = N
      IF (DABS(AR(MD,N))+DABS(AI(MD,N)) .EQ. 0.D0) GO TO 80
      RETURN
 80   IER = K
      IP(N) = 0
      RETURN
C----------------------- END OF SUBROUTINE DECBC ------------------------
      END
C
C
      SUBROUTINE SOLBC (N, NDIM, AR, AI, ML, MU, BR, BI, IP)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AR(NDIM,N), AI(NDIM,N), BR(N), BI(N), IP(N)
C-----------------------------------------------------------------------
C  SOLUTION OF LINEAR SYSTEM, A*X = B ,
C                  VERSION BANDED AND COMPLEX-DOUBLE PRECISION.
C  INPUT..
C    N      ORDER OF MATRIX A.
C    NDIM   DECLARED DIMENSION OF ARRAY  A .
C    AR, AI TRIANGULARIZED MATRIX OBTAINED FROM DECB (REAL AND IMAG. PART).
C    ML     LOWER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C    MU     UPPER BANDWIDTH OF A (DIAGONAL IS NOT COUNTED).
C    BR, BI RIGHT HAND SIDE VECTOR (REAL AND IMAG. PART).
C    IP     PIVOT VECTOR OBTAINED FROM DECBC.
C  DO NOT USE IF DECB HAS SET IER .NE. 0.
C  OUTPUT..
C    BR, BI SOLUTION VECTOR, X (REAL AND IMAG. PART).
C-----------------------------------------------------------------------
      MD = ML + MU + 1
      MD1 = MD + 1
      MDM = MD - 1
      NM1 = N - 1
      IF (ML .EQ. 0) GO TO 25
      IF (N .EQ. 1) GO TO 50
      DO 20 K = 1,NM1
        M = IP(K)
        TR = BR(M)
        TI = BI(M)
        BR(M) = BR(K)
        BI(M) = BI(K)
        BR(K) = TR
        BI(K) = TI
        MDL = MIN(ML,N-K) + MD
        DO 10 I = MD1,MDL
          IMD = I + K - MD
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(IMD) = BR(IMD) + PRODR
          BI(IMD) = BI(IMD) + PRODI
 10     CONTINUE
 20     CONTINUE
 25     CONTINUE
      DO 40 KB = 1,NM1
        K = N + 1 - KB
        DEN=AR(MD,K)*AR(MD,K)+AI(MD,K)*AI(MD,K)
        PRODR=BR(K)*AR(MD,K)+BI(K)*AI(MD,K)
        PRODI=BI(K)*AR(MD,K)-BR(K)*AI(MD,K)
        BR(K)=PRODR/DEN
        BI(K)=PRODI/DEN
        TR = -BR(K)
        TI = -BI(K)
        KMD = MD - K
        LM = MAX0(1,KMD+1)
        DO 30 I = LM,MDM
          IMD = I - KMD
          PRODR=AR(I,K)*TR-AI(I,K)*TI
          PRODI=AI(I,K)*TR+AR(I,K)*TI
          BR(IMD) = BR(IMD) + PRODR
          BI(IMD) = BI(IMD) + PRODI
 30       CONTINUE
 40     CONTINUE
        DEN=AR(MD,1)*AR(MD,1)+AI(MD,1)*AI(MD,1)
        PRODR=BR(1)*AR(MD,1)+BI(1)*AI(MD,1)
        PRODI=BI(1)*AR(MD,1)-BR(1)*AI(MD,1)
        BR(1)=PRODR/DEN
        BI(1)=PRODI/DEN
 50   CONTINUE
      RETURN
C----------------------- END OF SUBROUTINE SOLBC ------------------------
      END
c
C
      subroutine elmhes(nm,n,low,igh,a,int)
C
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      real*8 a(nm,n)
      real*8 x,y
      real*8 dabs
      integer int(igh)
C
C     this subroutine is a translation of the algol procedure elmhes,
C     num. math. 12, 349-368(1968) by martin and wilkinson.
C     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
C
C     given a real general matrix, this subroutine
C     reduces a submatrix situated in rows and columns
C     low through igh to upper hessenberg form by
C     stabilized elementary similarity transformations.
C
C     on input:
C
C      nm must be set to the row dimension of two-dimensional
C        array parameters as declared in the calling program
C        dimension statement;
C
C      n is the order of the matrix;
C
C      low and igh are integers determined by the balancing
C        subroutine  balanc.      if  balanc  has not been used,
C        set low=1, igh=n;
C
C      a contains the input matrix.
C
C     on output:
C
C      a contains the hessenberg matrix.  the multipliers
C        which were used in the reduction are stored in the
C        remaining triangle under the hessenberg matrix;
C
C      int contains information on the rows and columns
C        interchanged in the reduction.
C        only elements low through igh are used.
C
C     questions and comments should be directed to b. s. garbow,
C     applied mathematics division, argonne national laboratory
C
C     ------------------------------------------------------------------
C
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
C
      do 180 m = kp1, la
       mm1 = m - 1
       x = 0.0d0
       i = m
C
       do 100 j = m, igh
          if (dabs(a(j,mm1)) .le. dabs(x)) go to 100
          x = a(j,mm1)
          i = j
  100   continue
C
       int(m) = i
       if (i .eq. m) go to 130
C    :::::::::: interchange rows and columns of a ::::::::::
       do 110 j = mm1, n
          y = a(i,j)
          a(i,j) = a(m,j)
          a(m,j) = y
  110   continue
C
       do 120 j = 1, igh
          y = a(j,i)
          a(j,i) = a(j,m)
          a(j,m) = y
  120   continue
C    :::::::::: end interchange ::::::::::
  130   if (x .eq. 0.0d0) go to 180
       mp1 = m + 1
C
       do 160 i = mp1, igh
          y = a(i,mm1)
          if (y .eq. 0.0d0) go to 160
          y = y / x
          a(i,mm1) = y
C
          do 140 j = m, n
  140      a(i,j) = a(i,j) - y * a(m,j)
C
          do 150 j = 1, igh
  150      a(j,m) = a(j,m) + y * a(j,i)
C
  160   continue
C
  180 continue
C
  200 return
C    :::::::::: last card of elmhes ::::::::::
      end

      SUBROUTINE SOLOUT (NR,XOLD,X,Y,CONT,LRC,N,RPAR,IPAR,IRTRN)
C --- Called after each step - may be used to print solution
C     Setting IRTRN will cause RODAS to terminate integration
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION Y(N),CONT(LRC)
      RETURN
      END
C

      subroutine raddrivr
      use grid
      use chmstry
      use bndary
      use camxfld
      use camxcom
c
c----CAMx v7.40 260801
c
c     RADDRIVR initializes radical concentrations for the grids
c
c      Copyright Ramboll
c
c     Modifications:  
c        12/11/00 - initialize radicals to 1.0e-10 - gy  
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Routines called:
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
c-----Entry point
c
c
c-----Initialize radicals
c
      do igrd = 1,ngrid
        do k = 1,nlay(igrd)
          do j = 2,nrow(igrd)-1
            do i = 2,ncol(igrd)-1
              n2d = i + (j-1)*ncol(igrd)
              n3d = n2d + ncol(igrd)*nrow(igrd)*(k-1)
              do l = 1,nrad
                n4d = n3d + ncol(igrd)*nrow(igrd)*nlay(igrd)*(l-1)
                conc(iptr4d(igrd)-1+n4d) = 1.0e-10
              enddo
            enddo
          enddo
  10      continue
        enddo
      enddo
c
      return
      end 

      subroutine nodes_met(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes all of the data that is time-step
c        dependent to the compute nodes when in MPI mode.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numprocs            the number of processes
c        iproc_id            processor ID for this process
c     Output:  
c
c    Called by:
c       EMISTRNS
c       TSTEP_INIT
c    Subroutines called:
c       NODES_PASS
c       MASTER_SEND_GRIDDED_DATA
c       NODE_RECV_GRIDDED_DATA
c       MASTER_SEND_1SPECIES_DATA
c       NODE_RECV_1SPECIES_DATA
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c     11/4/09  -cemery- Removed input top concentrations
c     08/08/14 -cemery- Added new snow cover input fields
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'deposit.inc'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'lsbox.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: nlaya
      integer :: mvec2d
      integer :: mvec3d
      integer :: ispc
      integer :: i
      integer :: mvec4d
      integer :: mvecem
      integer :: mveclu
      integer :: mvecdp
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.NOT. lmpi) return
c
      nlaya = maxval( nlay(1:ngrid) )
c
c  --- send the variables in the camx include file ---
c
      call nodes_pass(date,          1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(time,          1,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(datec,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(timec,     ngrid,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(deltat,    ngrid,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ntim,      ngrid,   MPI_REAL,itag,numprocs,iproc_id) 
      call nodes_pass(ntimcrs,   ngrid,   MPI_REAL,itag,numprocs,iproc_id) 
      call nodes_pass(nadv,nlaya*ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- calculate the number of bytes to send ---
c
      mvec2d = 0
      mvec3d = 0
      do i=1,ngrid
         mvec2d = mvec2d + nrow(i) * ncol(i)
         mvec3d = mvec3d + nrow(i) * ncol(i) * nlay(i)
      enddo
      mvecem = mvec2d * nspec
      mvec4d = mvec3d * nspec
      mveclu = mvec2d * nlu
      mvecdp = mvec2d * (nspec*3 + 2)
c
c  --- pass the fields that are dimensioned by mvec2d ---
c
      do i=1,ngrid
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(tsurf(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(tsurf(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(topo(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(topo(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pspt(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(pspt(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(snow(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(snow(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(snowage(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(snowage(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(snowrat(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(snowrat(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(snowfrc(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(snowfrc(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(snowalb(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(snowalb(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(albedo(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data(albedo(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
c
c  --- pass the fields that are dimensioned by mvec3d ---
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(depth(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (depth(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(height(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (height(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(phpt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (phpt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1

         if (iproc_id .eq. 0) then
            call master_send_gridded_data(windu(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (windu(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(windv(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (windv(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pupt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pupt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pvpt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pvpt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(tempk(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (tempk(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(ptpt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (ptpt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(press(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (press(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pppt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pppt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(rkv(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (rkv(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pkpt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pkpt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(water(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (water(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pwpt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pwpt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
cae         if (iproc_id .eq. 0) then
cae            call master_send_gridded_data(fcloud(iptr3d(i)),i,nlay(i),1,itag)
cae         else
cae            call node_recv_gridded_data  (fcloud(iptr3d(i)),i,nlay(i),1,itag)
cae         endif
cae         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cwc(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cwc(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pwr(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pwr(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pws(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pws(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pwg(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pwg(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cod(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cod(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cph(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cph(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigfrc(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data  (cigfrc(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigtim(iptr2d(i)),i,1,1,itag)
         else
            call node_recv_gridded_data  (cigtim(iptr2d(i)),i,1,1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigwtr(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cigwtr(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigph(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cigph(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigpcp(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cigpcp(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigent(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cigent(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(cigdet(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (cigdet(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(hnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (hnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(pnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (pnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(unxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (unxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(vnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (vnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(tnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (tnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(tsnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (tsnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(knxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (knxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
         if (iproc_id .eq. 0) then
            call master_send_gridded_data(wnxt(iptr3d(i)),i,nlay(i),1,itag)
         else
            call node_recv_gridded_data  (wnxt(iptr3d(i)),i,nlay(i),1,itag)
         endif
         itag = itag+1
c
c  --- pass the deposition arrays ---
c
         do ispc=1,ndepspc*3+2
            if (iproc_id .eq. 0) then
               call master_send_1species_data(depfld(iptrdp(i)),i,1,1,
     &                                            ndepspc*3+2,ispc,itag)
            else
               call node_recv_1species_data(depfld(iptrdp(i)),i,1,1,
     &                                            ndepspc*3+2,ispc,itag)
            endif
            itag = itag+1
         enddo
      enddo
c
c  --- pass the point source emissions arrays ---
c
      call nodes_pass(ptemis,nptsrc*nspec,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- pass the variables in the pigsty include file ---
c
      if (ipigflg .EQ. IRONPIG .OR. ipigflg .EQ. GRESPIG) then
         call nodes_pass(ipigint,1,MPI_INTEGER,itag,numprocs,iproc_id)
      endif
c
c  --- pass the variables in the lsbox include file ---
c
      call nodes_pass(idsolv,1,         MPI_INTEGER,itag,numprocs,iproc_id)   !add by cbwmpi
      call nodes_pass(dH2O,  1,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
      call nodes_pass(dM,    1,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
      call nodes_pass(dO2,   1,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
      call nodes_pass(dCH4,  1,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
      call nodes_pass(dH2,   1,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
      if (idsolv .EQ. IDLSOD) then
         call nodes_pass(dbrk,MXREACT,
     &                   MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
         call nodes_pass(rrk,MXREACT, MPI_REAL,itag,numprocs,iproc_id)
      endif
c
      end

      subroutine timadv(iproc_id,m1,m2,m3,joff,
     &                  igrd,nrow,nspc,deltat,dx,dy,
     &                  windu,windv,depth,mapscl,saconc)
      use filunit
      use chmstry
      use bndary
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c     TIMADV drives 2-D advection of timing tracers
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        02/05/03    --gwilson--  Removed SMOLAR advections solver.
c        none
c
c     Input arguments:
c        iproc_id          process ID for MPI
c        igrd              grid index
c        nrow              number of rows
c        nspc              number of species
c        deltat            time step (s)
c        dx                cell size in x-direction (m)
c        dy                cell size in y-direction (m)
c        windu             wind speed in x-direction (m/s)
c        windv             wind speed in y-direction (m/s)
c        depth             layer depth (m)
c        mapscl            map-scale factor at cell centroids
c        saconc            species concentrations (umol/m3)
c
c     Output arguments:
c        saconc             species concentrations (umol/m3)
c
c     Routines Called:
c        HADVSMO
c        HADVBOT
c
c     Called by:
c        EMISTRNS
c
      include "camx.prm"
      include "flags.inc"
c
      integer :: iproc_id
      integer :: m1,m2,m3,joff
c
      integer nrow
      integer nspc
      integer igrd
      real    deltat
      real    dy
      real    tcpu
      real    saconc(m1,m2,m3,nspc)
      real    windu(m1,m2,m3)
      real    windv(m1,m2,m3)
      real    depth(m1,m2,m3)
      real    mapscl(m1,m2)
      real    dx(nrow)
c
      integer num1d
c
      real c1d(MXCELLS)
      real v1d(MXCELLS)
      real a1d(MXCELLS)
      real av1d(MXCELLS)
      real flxarr(MXCELLS)
      real fpc(MXCELLS)
      real fmc(MXCELLS)
c
      integer :: m_xi1,m_xi2,m_xj1,m_xj2
      integer :: m_yi1,m_yi2,m_yj1,m_yj2
      integer :: i, j, ispc, k
c
      real dtime
c
c-----Entry point
c
      num1d = MAX( m1, m2 )
c
c======================== DDM End =======================
c
      if( .NOT. lmpi ) then
         m_xj1 = 2
         m_xj2 = m2-1
         m_xi1 = 2
         m_xi2 = m1-1
         m_yi1 = 2
         m_yi2 = m1-1
         m_yj1 = 2
         m_yj2 = m2-1
      else
         m_xj1 = 1
         m_xj2 = m2
         m_xi1 = 1
         m_xi2 = m1
         m_yi1 = 1
         m_yi2 = m1
         m_yj1 = 1
         m_yj2 = m2
         if( btest(ibcon,0) ) then
           m_xi1 = 2
           m_yi1 = 2
         endif
         if( btest(ibcon,1) ) then
           m_xi2 = m1-1
           m_yi2 = m1-1
         endif
         if( btest(ibcon,2) ) then
           m_xj1 = 2
           m_yj1 = 2
         endif
         if( btest(ibcon,3) ) then
           m_xj2 = m2-1
           m_yj2 = m2-1
         endif
      endif
c
c-----Advection in x-direction
c
c
c$omp master
c
      if( iproc_id .LE. 1 ) then
        write(*,'(a20,$)') '  SA x advect ......'  
        write(iout,'(a20,$)') '  SA x advect ......'  
      endif
c
c$omp end master
c
c$omp parallel default(shared)
c$omp&  private(i,j,k,ispc,c1d,v1d,a1d,av1d,flxarr,fpc,fmc)
c
c$omp do schedule(dynamic)
c
      do 20 k = 1,m3
        do 10 j = m_xj1, m_xj2
          do i = 1,m1-1
            av1d(i) = dy*(depth(i,j,k) + depth(i+1,j,k))/
     &                (mapscl(i,j) + mapscl(i+1,j))
            v1d(i) = windu(i,j,k)
            a1d(i) = mapscl(i,j)*mapscl(i,j)/(dy*depth(i,j,k))
          enddo
          av1d(m1) = dy*depth(m1,j,k)/mapscl(m1,j)
          v1d(m1) = windu(m1,j,k)
          a1d(m1) = mapscl(m1,j)*mapscl(m1,j)/(dy*depth(m1,j,k))
c
          do 21 ispc = ipttim,nsaspc
c
            do i = 1,m1
              c1d(i) = MAX( BNDLPT, saconc(i,j,k,ispc) )
            enddo
            if (btest(ibcon,0) .and. igrd.eq.1 .and.
     &                          v1d(1).lt.0.) c1d(1) = c1d(2)
            if (btest(ibcon,1) .and. igrd.eq.1 .and.
     &                          v1d(m1-1).gt.0.) c1d(m1) = c1d(m1-1)
            if (iadvct.eq.2) then
              call hadvbot(m1,deltat,dx(j+joff),c1d,v1d,a1d,av1d,flxarr,fpc,
     &                                                      fmc,num1d)
            elseif (iadvct.eq.3) then
              call hadvppm(m1,deltat,dx(j+joff),c1d,v1d,a1d,av1d,flxarr,num1d)
            endif
c
            do i = m_xi1, m_xi2
              saconc(i,j,k,ispc) = MAX( BNDLPT, c1d(i) )
            enddo
  21      continue
c
  10    continue
  20  continue
c
c$omp end parallel
c
c$omp master
c
      if( iproc_id .LE. 1 ) then
         write(*,'(a)') '   Done'
         write(iout,'(a)') '   Done'
         call flush(6)
         call flush(iout)
c
c-----Advection in y-direction
c
         write(*,'(a20,$)') '  SA y advect ......'  
         write(iout,'(a20,$)') '  SA y advect ......'  
      endif
c
c$omp end master
c
c
c$omp parallel default(shared)
c$omp&  private(i,j,k,ispc,c1d,v1d,a1d,av1d,flxarr,fpc,fmc)
c
c$omp do schedule(dynamic)
c
      do 40 k = 1,m3
        do 30 i = m_yi1, m_yi2
          do j = 1,m2-1
            av1d(j) = (dx(j+joff)*depth(i,j,k) +
     &                 dx(j+joff+1)*depth(i,j+1,k))/
     &                (mapscl(i,j) + mapscl(i,j+1))
            v1d(j) = windv(i,j,k)
            a1d(j) = mapscl(i,j)*mapscl(i,j)/
     &               (dx(j+joff)*depth(i,j,k))
          enddo
          av1d(m2) = dx(m2+joff)*depth(i,m2,k)/mapscl(i,m2)
          v1d(m2) = windv(i,m2,k)
          a1d(m2) = mapscl(i,m2)*mapscl(i,m2)/
     &              (dx(m2+joff)*depth(i,m2,k))
c
          do 41 ispc = ipttim,nsaspc
c
            do j = 1,m2  !nrow
              c1d(j) = MAX( BNDLPT, saconc(i,j,k,ispc) )
            enddo

            if (btest(ibcon,2) .and. igrd.eq.1 .and.
     &                            v1d(1).lt.0.) c1d(1) = c1d(2)
            if (btest(ibcon,3) .and. igrd.eq.1 .and.
     &                            v1d(m2-1).gt.0.) c1d(m2) = c1d(m2-1)
c
            if (iadvct.eq.2) then
              call hadvbot(m2,deltat,dy,c1d,v1d,a1d,av1d,flxarr,fpc,
     &                                                    fmc,num1d)
            elseif (iadvct.eq.3) then
              call hadvppm(m2,deltat,dy,c1d,v1d,a1d,av1d,flxarr,num1d)
            endif
c
  41      continue
c
  30    continue
c
  40  continue
c
c$omp end parallel
c
c$omp master
c
      if( iproc_id .LE. 1 ) then
         write(*,'(a)') '   Done'
         write(iout,'(a)') '   Done'
         call flush(6)
         call flush(iout)
      endif
c
c$omp end master
c
      return
      end

      subroutine zeros(a,n)
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c     ZEROS sets input array to zero
c
      dimension a(n)
c
      do i=1,n
        a(i) = 0.
      enddo
c
      return
      end

c*** HDRRCP
c
      subroutine hdrrcp(idate,btim,jdate,etim)
      use filunit
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine writes the header information for the receptor
c     average file.
c
c      Copyright Ramboll
c
c     Argument declarations:
c        idate   I   beginning date of simulation (YYJJJ)
c        btim    R   beginning time of simulation
c        jdate   I   ending date of simulation (YYJJJ)
c        etim    R   ending time of simulation
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c    04/14/97  --gwilson--  Changed the way number of source groups
c                           is specified
c    11/16/99  --gwilson--  Fixed a bug in writing the header to the 
c                           receptor file.  There was an extra line being
c                           written that messed up the browser.
c    04/02/03  --gwilson--  Added grid number to recptors defined by
c                           cell index
c         
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   jdate
      real      etim
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*40 cdate
      integer      ndate, ndlast, itype, i, j, nemiss
      real         ttime, ttlast
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- if no receptor file is provided, just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
c  --- set up the date and time ---
c
      ndate = idate
      ttime = btim/100.0
      ndlast = jdate
      ttlast = etim/100.0
      if( ttlast .EQ. 0. ) then
          ttlast = 24.0
          ndlast = ndlast - 1
      endif
c
c  --- get the date and time and write header records ---
c
      call fdate( cdate )
      write(iowrcp,9010,ERR=7000) 'CAMx', runmsg, verson
      write(iowrcp,'(A)',ERR=7000) cdate(1:24)
c
c  --- write the dates and times of simuation ---
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9001,ERR=7000) ndate, ttime, ndlast, ttlast
      write(iowrcp,9008,ERR=7000)'Average Interval ',ANINT(dtout)/60.
c
c  --- write the user specified tracer data ----
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9002,ERR=7000) 'Number of timing periods     ',
     &                                                           ntrtim
      write(iowrcp,9002,ERR=7000) 'Number of source areas       ',
     &                                                           nregin
c
c   --- set the number of emissions groups from the source groups ----
c
      if( leftovr_area .OR. ngroup .EQ. 0 ) then
          nemiss = ngroup + 1
      else
          nemiss = ngroup
      endif
      write(iowrcp,9002,ERR=7000) 'Number of emission groupings ',
     &                                                          nemiss
      write(iowrcp,9002,ERR=7000) 'Number of tracer species     ',
     &                                                        ntotsp
      do icls=1,ntrcls
         write(iowrcp,9012,ERR=7000) 'Number of ',clsnam(idxcls(icls)),
     &                   ' species        ',nptcls(icls)-iptcls(icls)+1
      enddo
      write(iowrcp,9002,ERR=7000) 'Number of INERT TIME species ',
     &                                                        npttim/2
      write(iowrcp,9002,ERR=7000) 'Number of DECAY TIME species ',
     &                                                        npttim/2
c
c   ---- write the tracer species names ----
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9000,ERR=7000) 'Tracer Names'
      do icls=1,ntrcls
          write(iowrcp,9003,ERR=7000) (ptname(i),
     &                                    i=iptcls(icls),nptcls(icls))
      enddo
      if( npttim .GT. 0 ) then
         write(iowrcp,9003,ERR=7000) (ptname(i),i=ipttim,ntotsp-1,2)
         write(iowrcp,9003,ERR=7000) (ptname(i),i=ipttim+1,ntotsp,2)
      else
         write(iowrcp,9003,ERR=7000) 
         write(iowrcp,9003,ERR=7000) 
      endif
      write(iowrcp,9003,ERR=7000)
c
      write(iowrcp,9002,ERR=7000) 'Number of receptors ',nrecep
      write(iowrcp,9004,ERR=7000)
c
c   --- do the other receptors ---
c
      do i=1,nrecep
         if( idrcp(i) .EQ. IDPNT ) then
            itype = 0
            write(iowrcp,9005,ERR=7000) i, rcpnam(i), itype, 
     &                                              recepx(i), recepy(i)
         else if( idrcp(i) .EQ. IDCEL ) then
            itype = 1
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          irecep(i,1), jrecep(i,1)
         else if( idrcp(i) .EQ. IDAVG ) then
            itype = nclrcp(i)
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          irecep(i,1), jrecep(i,1)
            do j=2,nclrcp(i)
                 write(iowrcp,9011,ERR=7000) irecep(i,j), jrecep(i,j)
            enddo
         else if( idrcp(i) .EQ. IDWAL ) then
            itype = 3
            write(iowrcp,9006,ERR=7000) i, rcpnam(i), itype, igrdrcp(i),
     &                                          iwalbg(i), iwalnd(i)
            write(iowrcp,9011,ERR=7000) jwalbg(i), jwalnd(i)
            write(iowrcp,9011,ERR=7000) kwalbg(i), kwalnd(i)
         endif
      enddo
c
c  --- write the header for rest of data ----
c
      write(iowrcp,9000,ERR=7000)
      write(iowrcp,9000,ERR=7000) 'Time Varying Tracer Data'
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in HDRRCP:'
      write(iout,9020,ERR=9999) 'Writing Header of Tracer average file.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(2(:,A,','))
 9001 format(' File Duration  ,',2(I10.5,',',F10.2,','))
 9002 format(A,',',I10)
 9003 format(500(:,A9,','))
 9004 format('  No,   Name,  ',2x,' Type,   Grid#,   Xloc,      Yloc,')
 9005 format(I4,',',1X,A10,',',1X,I4,', ,',2(F10.1,',',1X))
 9006 format(I4,',',1X,A10,',',1X,I4,',',1X,I4,',',2(I10,',',1X))
 9008 format(A,',',F10.4)
 9010 format(3(A,','))
 9011 format(23X,2(I10,',',1X))
 9012 format(3A,',',I10)
 9020 format(/,1X,2(A,','))
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine wrfgcon(iendat,endtim)
      use camxcom
      use filunit
      use camxfld
      use chmstry
      use grid
c
c----CAMx v7.40 260801
c
c     WRFGCON writes the instantaneous and average concentration fields
c     for the fine grids.
c
c      Copyright Ramboll
c
c     Modifications:
c        8/23/06             Now only writes instant restart file; only a
c                            single instant restart file is written
c                            at end of simulation
c
c     Input arguments:
c        iendat              current ending date (YYJJJ)
c        endtim              current ending time (HHMM)
c
c     Output arguments:
c        none
c
c     Rountines Called:
c        none
c
c     Called by:
c        CAMx
c
      include 'camx.prm'
c
      integer   iendat
      real      endtim
c
      integer   ifgptr(MXGRID)
      integer   ifglvl(MXGRID)
      real      cnctmp(MXCELLS,MXCELLS)
c
      integer   igrd, idx, i, j, k, l
c
c-----Entry point
c
c-----Set the fine grid pointers
c
      do i = 1,ngrid
        ifglvl(i) = 0
      enddo
      do i = 1,ngrid
        do j = 1,nchdrn(i)
          idch = idchdrn(j,i)
          ifgptr(idch) = i - 1 
          ifglvl(idch) = ifglvl(idch) + 1
          do k = 1,nchdrn(idch)
            ifglvl(idchdrn(k,idch)) = ifglvl(idchdrn(k,idch)) + 1
          enddo
        enddo
      enddo
c
c-----Write the file description header
c
      write(ifconc) runmsg
      write(ifconc) ngrid-1, nspec
      write(ifconc) (spname(i),i=1,nspec)
c
      do 20 igrd = 2,ngrid
        write(ifconc) inst1(igrd),jnst1(igrd),inst2(igrd),
     &                jnst2(igrd),meshold(igrd),meshold(igrd),
     &               ncol(igrd),nrow(igrd),nlay(igrd),
     &               ifgptr(igrd),ifglvl(igrd)
   20 continue
c
c-----Write time span
c
      write(ifconc) endtim, iendat
c
c-----Write the concentration data for this hour
c
      do 30 igrd = 2,ngrid
        do 40 l = 1,nspec
          do 50 k = 1,nlay(igrd)
            do 60 j = 1,nrow(igrd)
              do 70 i = 1,ncol(igrd)
                idx = i + ncol(igrd)*(j-1) + 
     &                ncol(igrd)*nrow(igrd)*(k-1) +
     &                ncol(igrd)*nrow(igrd)*nlay(igrd)*(l-1)
                cnctmp(i,j) = conc(iptr4d(igrd)-1+idx)
   70         continue
   60       continue
            write(ifconc) ((cnctmp(i,j),i=1,ncol(igrd)),j=1,nrow(igrd))
   50     continue
   40   continue
   30 continue
c
      return
      end

      subroutine aeroset(dsec_i,ierr)
      use camxcom
      use grid
      use chmstry
      use filunit
c
c----CAMx v7.40 260801
c
c     AEROSET prepares for the AERO chemistry routines in CAMx
c
c      Copyright Ramboll 
c  
c     Modifications:
c        12/29/06   --bkoo--     Added species mapping for the updated SOA scheme
c        01/10/07   --bkoo--     Included camx_aero.inc
c                                Set pointers for aqueous PM
c        03/18/14   --bkoo--     Added pointers for benzene SOA
c        12/07/14   --bkoo--     Set pointers for VBS species
c        01/08/16   --bkoo--     Updated for SAPRC99->SAPRC07TC
c                                            Revised VBS
c        08/25/16   --bkoo--     Updated for new SOAP
c        09/16/16   --pk--       Added pointers for GLY, MGLY & GLYD
c        09/16/16   --bkoo--     Set WTMOL here (moved from CHMDAT.F)
c        10/16/17   --bkoo--     Added sfacJSOA; removed LSOAP2
c        11/22/17   --bkoo--     Updated WTMOL and separated Ca & Mg from CO3
c        02/21/20   --rlb--      Added CB6r5 (idmech=1)
c        03/24/21   --gy--       Added CB7 (idmech=7)
c        02/15/22   --gy--       Added RACM2s21 (idmech=9)
c        11/03/23   --cemery--   Removed CB05 (Mech 6)
c        05/17/24   --cemery--   Removed CMU PM option
c
c     Input arguments: 
c        dsec_i              User supplied section cutpoints 
c 
c     Output arguments: 
c        ierr                Error flag
c            
c     Routines called: 
c        UPTIME
c            
c     Called by: 
c        READCHM
c 
      include 'camx.prm'
      include 'soap.inc'
      include 'vbs.inc'
      include 'section.inc'
      include 'section_aq.inc'
      include 'camx_aero.inc'
c
      real*8  dsec_i(nsecp1)
      integer ierr
c
      real    dtio
      integer nsteps, i, n
c     
c-----Entry point 
c
      ierr = 0
c
c-----Reset dtaero to hit output interval exactly
c
      dtio = amin1(60.,dtinp,dtems,dtout)
      nsteps = INT( 0.999*dtio/dtaero ) + 1
      dt_aero = dtio/nsteps
      do n = 1,ngrid
        time_aero(n) = time
        date_aero(n) = date
        call uptime(time_aero(n),date_aero(n),60.*dt_aero)
        aero_dt(n)  = 0.0
      enddo
c
c-----Set pointers for aqueous PM
c
      if (idmech.EQ.5) then ! SAPRC07TC
        khpo_c = kh2o2
        kfoa_c = kfacd
        kmhp_c = kcooh
        kpaa_c = kco3h
        kohp_c = krooh
        kopa_c = kro3h
        kgly_c = kgly
        kmgly_c = kmgly
        kglyd_c = kglyd
      elseif (idmech.EQ.9) then ! RACM2s21
        khpo_c = kh2o2
        kfoa_c = kora1
        kmhp_c = kop1
        kpaa_c = kpaa
        kohp_c = kop2
        kopa_c = nspec+1
        kgly_c = kgly
        kmgly_c = kmgly
        kglyd_c = nspec+1
      elseif (idmech.EQ.1 .or. idmech.EQ.3 
     &         .or. idmech.EQ.4 .or. idmech.EQ.7 ) then ! CB6 or CB7
!bkoo - to be updated: Add ISPX to hydroperoxides for CB6?
        khpo_c = kh2o2
        kfoa_c = kfacd
        kmhp_c = kmepx
        kpaa_c = kpacd
        kohp_c = krooh
        kopa_c = nspec+1
        kgly_c = kgly
        kmgly_c = kmgly
        kglyd_c = kglyd
      endif
c
      if (lvbs .and. LVBSPREPROC) then
        kpap_c(0) = kpap0
        kpap_c(1) = kpap1
        kpap_c(2) = kpap2
        kpap_c(3) = kpap3
        kpap_c(4) = kpap4
        kpcp_c(0) = kpcp0
        kpcp_c(1) = kpcp1
        kpcp_c(2) = kpcp2
        kpcp_c(3) = kpcp3
        kpcp_c(4) = kpcp4
        kpfp_c(0) = kpfp0
        kpfp_c(1) = kpfp1
        kpfp_c(2) = kpfp2
        kpfp_c(3) = kpfp3
        kpfp_c(4) = kpfp4
      endif
c
c-----SOAP parameters based on new chamber data (Hodzic et al., 2016, ACP)
c
      if( luse_soap3_simple ) then
         y_h      = yh_3simple
         y_l      = yl_3simple
         y_n      = yn_3simple
         csatS    = csatS_3simple
         cstempS  = cstempS_3simple
         deltahS  = deltahS_3simple
         kpolya   = kpolya_3simple
         kpolyb   = kpolyb_3simple
         sfacJSOA = sfacJSOA_3simple
      else if( luse_soap3_complx ) then
         y_h      = yh_3complx
         y_l      = yl_3complx
         y_n      = yn_3complx
         csatS    = csatS_3complx
         cstempS  = cstempS_3complx
         deltahS  = deltahS_3complx
         kpolya   = kpolya_3complx
         kpolyb   = kpolyb_3complx
         sfacJSOA = sfacJSOA_3complx
      endif
c
c-----Molecular weights for PM chemistry modules;
c     Used in AEROCHEM_CF, AEROCHEM_CMU, and DDM routines
c
      wtmol( 1) =  96.1 ! SO4
      wtmol( 2) =  18.  ! NH4
      wtmol( 3) =  62.  ! NO3
      wtmol( 4) =  35.5 ! Cl
      wtmol( 5) =  23.  ! Na
      wtmol( 6) =  39.1 ! K
      wtmol( 7) =  60.  ! CO3
      wtmol( 8) =  40.1 ! Ca
      wtmol( 9) =  24.3 ! Mg
      wtmol(10) =  55.8 ! Fe
      wtmol(11) =  54.9 ! Mn
      if (lvbs) then
        ksoac_c = kPBS0
        wtmol(12) = mwPBS0
      else
        ksoac_c = kboa0
        wtmol(12) = mwboa0
      endif
c
      return
      end

      subroutine avepig(iproc_id,igrd,dt,m1,m2,m3,ioff,joff,
     &                  ncol,nrow,nlay,nlayav,dx,dy,mapscl,height,
     &                              nspav,nspc,lspmap,tempk,press,avcnc)
      use filunit
      use chmstry
      use bndary
      use camxcom
      use pigsty
      use node_mod
      implicit none
c
c----CAMx v7.40 260801
c
c     AVEPIG computes the 'virtual' contribution of all puffs to the
c     gridded concentration fields and adds them to time-averaged 
c     concentrations
c
c      Copyright Ramboll
c
c     Modifications: 
c        none
c
c     Input arguments:
c        iproc_id           process ID for this slice (MPI)
c        igrd               grid index
c        dt                 time step for present grid concentration (s)
c        m1                 number of cells in X direction for this slice
c        m2                 number of cells in Y direction for this slice
c        m3                 number of layers for this slice
c        ioff               X offset of slice in full domain
c        joff               Y offset of slice in full domain
c        ncol               number of columns
c        nrow               number of rows
c        nlay               number of layers in instantaneous array
c        nlayav             number of layers in average array
c        dx                 grid spacing in x (m)
c        dy                 grid spacing in y (m)
c        mapscl             map scale factor
c        height             gridded layer heights (m)
c        nspav              number of average species
c        nspc               number of species in conc array
c        lspmap             mapping array for average species
c        tempk              temperature field (K)
c        press              pressure field (mb)
c        avcnc              average species concentration (gas=ppm,
c                                                          other=ug/m3)
c
c     Output arguments:
c        avcnc              average species concentration (gas=ppm,
c                                                          other=ug/m3)
c
c     Routines Called:
c        VIRTDUMP
c
c     Called by:
c        AVGALL
c        FGAVRG
c
      include "camx.prm"
      include "flags.inc"
c
      integer m1,m2,m3
      integer ioff, joff
      integer iproc_id,ncol,nrow,nlay,nlayav,nspav,nspc,igrd
      real tempk(m1,m2,m3),press(m1,m2,m3),
     &     avcnc(m1,m2,nlayav,nspav),height(m1,m2,m3),
     &     dx(nrow),dy,mapscl(m1,m2)
      real pcon
      integer lspmap(nspc)
      integer i,j,k,n,kpb,kpt,kk,l,lsp,idum
      real dt,dtfact,convfac,xpig,ypig

      real vdmpvec(MXLAYER,MXSPEC)
c
c-----Entry point
c
      dtfact = dt/(dtout*60.)
c
c-----Start puff loop
c
      do 50 n = 1,npig
c
c-----Skip puffs that are not in the current grid
c
        if (ingrd(n).ne.igrd) goto 50
c
c-----If running MPI, Skip puffs that are not in this slice
c
        if( lmpi ) then
           if( Lslice(igrd,iproc_id,n) .NE. 1 ) goto 50
        endif
c
c-----Locate the pig in the grid
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
        i = i-ioff
        j = j-joff
        do k = 1,nlay
          if (height(i,j,k).gt.zpig(n)) goto 15
        enddo
        k = nlay
  15    continue
c
c-----Find layers containing top and bottom of puff
c
        kpb = 1
        kpt = nlay
        do kk = 1,nlay
          if (height(i,j,kk) .GE. pufftop(n)) then
            kpt = kk
            goto 16
          endif
        enddo
  16    continue
        do kk = nlay,1,-1
           if (height(i,j,kk) .LE. puffbot(n)) then
             kpb = kk+1
             goto 17
          endif
        enddo
  17    continue
c
c-----Virtual dump of PUFFMASS into VDMPVEC (mass remains in PUFFMASS)
c
        call virtdump(m1,m2,m3,n,ncol,nrow,nlay,nspc,i,j,
     &                    dx(j+j0),dy,mapscl,height,tempk,press,vdmpvec)
c
c-----Put VDMPVEC into appropriate cells of AVCNC converting units from 
c     umol/m3 to ppm (gas) or ug/m3 (PM) 
c
        do l = 1,nspav
          lsp = lspmap(l)
          if (lsp.le.nrad) CYCLE
          do kk = kpb,kpt
            if (lsp.gt.ngas) then 
              convfac = 1.
            else
              if( .NOT. lgas_out_ppm ) then
                 convfac = densfac*273./tempk(i,j,kk)*
     &                     press(i,j,kk)/1013.
              else
                 convfac = mole_weight(lsp)
              endif
            endif
            pcon = dtfact*vdmpvec(kk,lsp)/convfac
            if( kk .LE. nlayav ) then
               avcnc(i,j,kk,l) = amax1(bdnl(lsp),avcnc(i,j,kk,l)+pcon)
            endif
          enddo
        enddo
  50  continue
c 
      return
      end

c***** RDPTDDM.F
c
      subroutine rdptddm(ndate,ttime)
      use filunit
      use grid
      use chmstry
      use ptemiss
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the DDM process
c   and fills the approproate arrays.  The emissions file for one grid
c   but each emissions groups is read.
c    Argument descriptions:
c     Outputs:
c     Inputs:
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     10/24/01  Removed BSWAP and converted integer strings to character*4
c     07/19/02  Added seperate source area map for each grids.
c     05/01/03  Time span of emissions must now match emiss update interval
c     07/16/07 -bkoo-     Added HRVOC
c     03/01/16 -gwilson-  Added partial source area map
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer ndate
      real    ttime
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  cname
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, igroup, idx, iseg
      integer       i, j, nedge, iptr, ispc, iddm, igrd
      integer       icel, jcel, imap, npoint, idum, imod, izcel(MXPTSRC)
      integer       idcompact(MXPTSRC), idxfile
      real          bgtim, edtim, emstmp, pi
      real          xloccrs, yloccrs, xloctmp, yloctmp
      logical       lfound, luse, lpass
c
      real emspnt(MXPTSRC), effph_in(MXPTSRC), flowrat_in(MXPTSRC)
c
      common /ddmptdat/ emspnt, effph_in, flowrat_in
c
      data pi /3.1415927/
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c  --- initialize emissions to zero ---
c
      do i=1,nptsrc
         do j=1,ntotsp
            sapnts(i,j) = 0.
         enddo
      enddo
c
c  --- set the number of BC edges --
c
      if( lbndry ) then
        nedge = 5
      else
        nedge = 1
      endif
c
c   --- loop over all of the groups ----
c
      do 10 igroup=1,ngroup
        do 11 idxfile=1,num_iortpt(igroup)
c
c   --- skip if filename not supplied ---
c
          if( is_netcdf_iortpt(igroup,idxfile) .OR. .NOT. 
     &            ltptfl(igroup,idxfile) .OR. .NOT. lptsrc ) cycle
c
c   --- set the unit number for surface emissions file ---
c
          iounit = iortpt(igroup,idxfile)
          fname = tptfil(igroup,idxfile)
c
c   --- read the date and time, again ---
c
          lfound = .FALSE.
          lpass = .FALSE.
  111     continue
          read(iounit,END=222) ibgdat, bgtim, iendat, edtim
          if(NINT(edtim) .EQ. 0) then
            edtim = 24.
            iendat = ibgdat
          endif
          ichktm1 = NINT( 1000*(bgtim) )
          if( le1day ) then
             ichktm2 = NINT( 1000*(edtim) )
          else
             ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
          endif
          if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
          ichkems = NINT( 1000*(dtems/60.) )
          if( (ichktm2 - ichktm1) .NE. ichkems ) then
              write(iout,'(//,a)')'ERROR in RDPTDDM:'
              write(iout,*) 'Time interval in surface emissions file does'
              write(iout,*)  ' not match emissions update time interval.'
              write(iout,*) '   Beginning Date/Time (Hour): ',ibgdat,bgtim
              write(iout,*) '   Ending Date/Time    (Hour): ',iendat,edtim
              write(iout,*) '   Emiss Input interval(Hour): ',dtems/60.
              call camxerr()
          endif
          bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
          edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
          read(iounit,ERR=7000,END=7001) iseg, npoint
c
          if( npoint .GT. MXPTSRC ) goto 7002
          read(iounit,ERR=7000,END=7001) (idcompact(i), idum,
     &                izcel(i), flowrat_in(i), effph_in(i),i=1,npoint)
          do i=1,npoint
            idxcp = i
            if( lcompactpt(igroup,idxfile) ) idxcp = idcompact(i)
            if(flowrat_in(idxcp) .LT. 0. .AND. effph_in(idxcp) .LT. 0. ) then
              if( ABS(effph_in(idxcp)) .LT. ABS(flowrat_in(idxcp)) ) then
                 write(iout,'(//,a)')'ERROR in READPT:'
                 write(iout,*) 'Invalid values found for flow rate and plume height.'
                 write(iout,*) 'The plume distribution override is triggered. But the '
                 write(iout,*) 'value for flow rate (base) is larger than value for ',
     &                      'plume height (top).'
                 call camxerr()
              endif
            endif
            idxbase = idx_point_in_list(igroup,idxfile,idxcp)
            effph(idxbase) = effph_in(idxcp)
            flowrat(idxbase) = flowrat_in(idxcp)
          enddo
c 
          do 20 ispc=1,nspcpt(igroup,idxfile)
              read(iounit,ERR=7000) iseg, (iname(i),i=1,10), 
     &                                        (emspnt(i),i=1,npoint)
              write(cname,'(10A1)') iname
c
c   --- if date and time does not match this hour, skip this record ---
c
               if( le1day ) then
                   if( bgtim .NE. ttime ) goto 20
               else
                   if( ndate .NE. ibgdat .OR. bgtim .NE. ttime ) goto 20
               endif
               lfound  = .TRUE.
c
c   --- if the species is a not modelled or not used for DDM ----
c
               idx = idxpts(igroup,idxfile,ispc)
               if( idx .LE. 0 ) goto 20
c
c  --- find this species in the modeled species list ---
c
               luse = .FALSE.
               do imod=1,nspec
                  if( cname .EQ. spname(imod) ) then
                     do iddm=1,nemddm
                        luse = .FALSE.
                        if( emddmsp(iddm) .EQ. cname ) luse = .TRUE.
                        if( emddmsp(iddm) .EQ. NAMALL  ) luse = .TRUE.
                        if( emddmsp(iddm) .EQ. NAMVOC
     &                                 .AND. lvocsp(imod) ) luse = .TRUE.
                        if( emddmsp(iddm) .EQ. NAMNOX
     &                                 .AND. lnoxsp(imod) ) luse = .TRUE.
                        if( emddmsp(iddm) .EQ. NAMHRV
     &                                 .AND. lhrvoc(imod) ) luse = .TRUE.
c
c  --- if this DDM species matches this modeled species, load it ---
c
                        if( luse ) then
                           do 30 i=1,npoint
                           if( emspnt(i) .LE. 0 ) cycle
                              idxcp = i
                              if( lcompactpt(igroup,idxfile) ) idxcp = idcompact(i)
                              idxbase = idx_point_in_list(igroup,idxfile,idxcp)
                              if( llatlon ) then
                                 xloccrs = xlocpt(idxbase) - xorg
                                 yloccrs = ylocpt(idxbase) - yorg
                              else
                                 xloccrs = xlocpt(idxbase)/1000. - xorg
                                 yloccrs = ylocpt(idxbase)/1000. - yorg
                              endif
                              icel = 1 + FLOOR( xloccrs/delx )
                              jcel = 1 + FLOOR( yloccrs/dely )
                              if( icel .LT. 1 .OR. icel .GT. ncol(1) ) 
     &                                                            goto 30
                              if( jcel .LT. 1 .OR. jcel .GT. nrow(1) ) 
     &                                                          goto 30
c
c   --- find out if a nest contains this source  ---
c
                              igrd = 1
                              do ig = 2,ngrid
                                 xloctmp = xloccrs - (inst1(ig)-1)*delx
                                 yloctmp = yloccrs - (jnst1(ig)-1)*dely
                                 if( xloctmp .GT. 0. .AND. 
     &                                           yloctmp .GT. 0. ) then
                                      ii = 2 + FLOOR( xloctmp/delx *
     &                                              FLOAT( meshold(ig) ) )
                                      jj = 2 + FLOOR( yloctmp/dely *
     &                                              FLOAT( meshold(ig) ) )
                                      if( ii .GT. 1 .AND. jj .GT. 1 .AND. 
     &                                     ii .LT. ncol(ig) .AND. 
     &                                             jj .LT. nrow(ig) ) then
                                         igrd = ig
                                         icel = ii
                                         jcel = jj
                                      endif
                                 endif
                              enddo
c
c  --- get the region for this cell from mapping array ----
c
                              imap = igrmap(0,1,igrd,icel,jcel)
                              if( izcel(i) .LT. 0 ) then
                                 if( .NOT. lptoverride ) goto 7003
                                 imap = ABS( izcel(i) )
                              endif
                              if( imap .LE. 0 .OR. imap .GT. nregin ) 
     &                                                         goto 30
c
c  --- convert to emissions time and put into array ---
c
                              emstmp = emspnt(i)/(60.*dtems)
                            iptr = iptddm(imod) + nicddm + ndepddm +
     &                            nbcddm*nedge + (iddm-1)*ngroup*nregin +
     &                                        (imap-1)*ngroup + igroup - 1
                                if( emstmp .GT. bdnl(imod) )
     &                                 sapnts(idxbase,iptr) = 
     &                                     sapnts(idxbase,iptr) + emstmp
c
c  --- next point ---
c
   30                      continue
                        endif
c
c  --- next DDM emssions species ---
c
                     enddo
c
c  --- next modeled species ---
c
                  endif
               enddo
c
c   --- next species ---
c
  20       continue
c
c   --- if the correct hour has not been found, 
c       go back and read some more else read next file ---
c
           if( .NOT. lfound ) then
              goto 111
           else
              do i=1,nspcpt(igroup,idxfile) + 3
                  backspace(iounit)
              enddo
              goto 11
           endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222      continue
           if( le1day ) then
               rewind(iounit)
               read(iounit)
               read(iounit)
               read(iounit)
               read(iounit)
               if( lpass ) goto 7001
               if( .NOT. lpass ) lpass = .TRUE.
               goto 111
           else
               goto 7001
           endif
c
c  --- get the next file ---
c
  11     continue
  10  continue
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)')'ERROR in RDPTDDM:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 'ERROR: Reading emissions ',
     &    'after hour ',ibgdat, bgtim,' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)')'ERROR in RDPTDDM:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)')
     &              'ERROR: Premature end-of-file',
     &              ' in point source file after hour ',ibgdat, bgtim,
     &                                ' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDPTDDM:'
      write(iout,'(/,1X,A,I10,2A)') 'Number of points: ',npoint,
     &                   ' exceeds max in file: ',fname(:istrln(fname))
      write(iout,'(1X,2A,/,1X,A)') 'Increase parameter MXPTSRC.'
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in RDPTDDM:'
      write(iout,'(/,1X,2A )') 'A source was read that has the point ',
     &                   'source override trigger turned on.'
      write(iout,'(1X,2A)') 'If you intend to use point source ',
     &                     'override please set the namelist variable'
      write(iout,'(1X,2A)') 'DDM_PT_Override to TRUE in the CAMx_Control namelist.'
      write(iout,'(1X,2A)') 'If you do not want point source override ',
     &                         'you need to set the kcell variable '
      write(iout,'(1X,2A)') 'in your point source file to zero.'
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine rdpartial_map()
      use filunit
      use grid
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c     This routione reads the partial source area map file and loads 
c     all of the data in the panels into the global arrays to be used
c     to aggregate the emissions into tracer regions.
c
c      Copyright Ramboll
c          
c     Modifications:
c
c     Input arguments:
c
c     Output arguments:
c
c     Routines called:
c
c     Called by:
c
      include "camx.prm"
c
c-----External Functions
c
      integer istrln
c
c-----Local variables ----
c
      character*(KEYLEN) keywrd
      integer            irowvl(MXCELLS), npart
      integer            ierr, ipart, igrp, igrd, irow, irec, jerr, i
      real               frcrow(MXCELLS)
c
c-----Entry point
c
c  --- loop over grrids ---
c
      do igrd=1,ngrid
c
c  --- loop over groups, initializing the count ---
c
       do 10 igrp=1,ngroup
         npart = 0
c
c  --- skip if file is not supplied ---
c
         if( .NOT. lmapfl(igrp,igrd) ) goto 10
c  
c  ---- open the file ---
c        
         open(unit=iormap(igrp,igrd),file=mapfil(igrp,igrd),status='UNKNOWN')
c
c-----write some information to the diag file ---
c
         write(idiag,'(A,I3)') 'Parsing Partial Source Map for Grid:',igrd
c
c  --- loop back here until out of map panels ---
c
  111    continue   
         npart = npart + 1
         if( npart .GT. MXPARTIAL ) then
             write(iout,'(//,a)') 'ERROR in RDPARTIAL_MAP:'
             write(iout,*) 'The number of partial source maps exceeds the maximum: ',MXPARTIAL
             write(iout,*) 'Increase MXPARTIAL and recompile'
             call camxerr()
         endif
         ipart = npart
c
c  --- create the keyword for this group and map ---
c
         write(keywrd,'(A,I2.2,A,I2.2,A)') '/SRCMAP',igrp,'-',ipart,'/'
c
c  --- call routine to find the keyword for this map ---
c
         call fndkey(ierr,iormap(igrp,igrd),keywrd)
c
c  --- read error, exit ---
c
         if( ierr .EQ. IRDERR ) then
             write(iout,'(//,a)') 'ERROR in RDPARTIAL_MAP'
             write(iout,'(/,1X,2A,I2,A,I2)') 'Reading the partial source ',
     &                    'area map file for grid: ',igrd,' group: ',igrp
             write(iout,'(10X,A,/,A)') 'Source map filename: ',
     &                       mapfil(igrp,igrd)(:istrln(mapfil(igrp,igrd)))
            call camxerr()
c
c  --- end of file just means packet was not found, no more panels
c      for this group/grid ---
c
         else if( ierr .EQ. IEOF ) then
             npart = npart - 1
c
c  --- panel was found, read and store the data ---
c
         else if( ierr .EQ. ISUCES ) then
             write(idiag,'(2A)') 'Parsing panel: ',keywrd(:istrln(keywrd))
             irec = 0
             do irow=nycell(igrd),1,-1
                irec = irec + 1
                read(iormap(igrp,igrd),'(500(:,I3,1X,F5.0))',IOSTAT=jerr)
     &                                (irowvl(i),frcrow(i),i=1,nxcell(igrd))
                if( jerr .NE. 0 ) then
                   write(iout,'(//,a)') 'ERROR in RDPARTIAL_MAP:'
                   write(iout,'(/,1X,2A,I4)') 'Reading the partial source ',
     &                                     'area map file: '
                   write(iout,'(/,1X,3A,I5)') 'Parsing data in panel: ',
     &                         keywrd(:istrln(keywrd)),' at record: ',irec
                   write(iout,'(10X,A,/,A)') 'Source map filename: ',
     &                         mapfil(igrp,igrd)(:istrln(mapfil(igrp,igrd)))
                   call camxerr()
                endif
c
c  --- check that region values are valid ---
c
                do i=1,nxcell(igrd)
                   if( (irowvl(i) .LE. 0 .AND. frcrow(i) .GT. 0.) 
     &                                   .OR. irowvl(i) .GT. nregin ) then
                      write(iout,'(//,a)') 'ERROR in RDPARTIAL_MAP:'
                      write(iout,'(/,1X,A,A,I4)') 'Mapping value read',
     &                      ' from map file is out of range: ',irowvl(i)
                      write(iout,'(/,1X,3A,I5)') 'Parsing data in panel: ',
     &                         keywrd(:istrln(keywrd)),' at record: ',irec
                      write(iout,'(10X,A,/,A)') 'Source map filename: ',
     &                               mapfil(igrp,igrd)(:istrln(mapfil(igrp,igrd)))
                      call camxerr()
                   endif
c
c  --- load the data into global array ---
c
                   igrmap(igrp,ipart,igrd,i,irow) = irowvl(i)
                   frcmap(igrp,ipart,igrd,i,irow) = frcrow(i)/100.
                enddo
            enddo
c
c  --- get next panel ---
c
            goto 111
         endif
c
c  ---- set global array value ---
c
         if( npart .GT. 0 ) npartial(igrp,igrd) = npart
  10   continue
       write(idiag,'(/)')
c
c ---- next grid ---
c
      enddo
c
      return
      end

C**** SOAP3_EVAP_PTS
c
      subroutine soap3_evap_pts( idx_pntid,idx_layer_beg,idx_layer_end,
     &                           evap_factors,temperature,pntemis_soap3,
     &                                         pntemis_svoa,pntemis_hoa)
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine applies factors to evaporate POA to SVOA and
c     updates the emissions array so emissions are injected into
c     the appropriate model species.
c
c      Copyright Ramboll
c
c     Input arguments:
c        idx_pntid        idxex of this point source in global arrays
c        idx_layer_beg    index of the layer to inject the emissions into
c        idx_layer_end    index of the layer to inject the emissions into
c        temperature      temperature in aloft layers
c        pntemis_soap3    point emissioons rate for POA_XX (grams/s)
c     Output arguments:
c        pntemis_svoa     point emissions rate for SVOA (moles/s)
c        pntemis_hoa      point emissions rate for HOA (grams/s)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/24   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer idx_pntid
      integer idx_layer_beg
      integer idx_layer_end
      real    evap_factors(3,NUM_SOAP_EMISS)
      real    temperature(*)
      real    pntemis_soap3(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB,MXLAYER)
      real    pntemis_svoa(MXLAYER)
      real    pntemis_hoa(MXLAYER)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer imod, iems, klay, isoa, ipt
      real    evap_fact, evap_mass, convfac, poa_emiss
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- don't change anything if SVOA or HOA not found ---
c
      if( ksvoa .EQ. nspec+1 ) goto 9999
      if( khoa .EQ. nspec+1 ) goto 9999
c
c  ---- loop over layers ---
c
      pntemis_hoa = 0.
      pntemis_svoa = 0.
      do klay=idx_layer_beg,idx_layer_end
c
c  --- see if POA species was found ---
c
           do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
              if( idx_ems_soap3(isoa) .LE. 0 ) cycle
              if( pntemis_soap3(isoa,klay) .LE. 0. ) cycle
c
c ---- evaporate POA into SVOA ---
c
              evap_fact = MIN(1.0,
     &                    (evap_factors(1,isoa) * temperature(klay)**2 + 
     &                     evap_factors(2,isoa) * temperature(klay) + 
     &                     evap_factors(3,isoa) ))
              evap_mass = pntemis_soap3(isoa,klay) * (1. - evap_fact)
              if( ksvoa .GT. 0 .and. ksvoa .NE. nspec+1 )
     &              pntemis_svoa(klay) = pntemis_svoa(klay) + 
     &                 MAX(0., pntemis_svoa(klay) + evap_mass/mole_weight(ksvoa))
c
c ---- back out the vcap emissions from each POA species ---
c
              pntemis_hoa(klay) =  pntemis_hoa(klay) +
     &             MAX( 0., pntemis_soap3(isoa,klay) - evap_mass)
            enddo
      enddo
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine master_update(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use grid_nodes
      use filunit
      use chmstry
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       NODE_SEND_1SPECIES_DATA
c       MASTER_RECV_1SPECIES_DATA
c       MASTER_PASS_REAL8
c
c      Copyright Ramboll
c
c     Modifications:
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c       11/06/12     Fixed Wall of Cells receptors for MPI
c       11/06/12     Added routine to pass RTRAC receptors
c       04/30/13     Added surface model
c       08/26/21     RTRAC surface file doubles as (default)
c                    dep output or (flagged) surface model output
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'rtracsrf.inc'
      include 'mpif.h'
c     
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ilay
      integer :: ispc
      integer :: ircp
      integer :: i
      integer :: nlayav
      real    :: rcptmp(MXTRSP)
      integer :: idx
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.NOT. lmpi) return
c
c  --- pass the fields that are dimensioned by mvec4d ---
c
      do i=1,ngrid
         nlayav = nlay(i)
         if( .NOT. l3davg(i) ) nlayav = 1
         do ilay=1,nlayav
            do ispc=1,navspc
               if (iproc_id .gt. 0) then
                  call node_send_1species_data(avcnc(iptrav(i)),i,
     &                                         nlayav,ilay,navspc,ispc,itag)
               else
                  call master_recv_1species_data(avcnc(iptrav(i)),i,
     &                                           nlayav,ilay,navspc,ispc,itag)
               endif
               itag=itag+1
            enddo
         enddo
         do ispc=1,ndepspc*3+2
            if (iproc_id .gt. 0) then
               call node_send_1species_data(depfld(iptrdp(i)),i,
     &                                      1,1,ndepspc*3+2,ispc,itag)
            else
               call master_recv_1species_data(depfld(iptrdp(i)),i,
     &                                      1,1,ndepspc*3+2,ispc,itag)
            endif
            itag=itag+1
         enddo
         do ispc=1,nspec
            if (iproc_id .gt. 0) then
               call node_send_1species_data(vdep(iptr1lay(i)),i,
     &                                      1,1,nspec,ispc,itag)
            else
               call master_recv_1species_data(vdep(iptr1lay(i)),i,
     &                                        1,1,nspec,ispc,itag)
            endif
            itag=itag+1
         enddo
         if (lsrfmod) then
           do ispc=1,nsmspc
             if( iproc_id .gt. 0 ) then
               call node_send_1species_data  (solmas(iptrsm(i)), i,
     &                                     1, 1, nsmspc, ispc, itag)
             else
               call master_recv_1species_data(solmas(iptrsm(i)), i,
     &                                     1, 1, nsmspc, ispc, itag)
             endif
             itag=itag+1
           enddo
           do ispc=1,nsmspc
             if( iproc_id .gt. 0 ) then
               call node_send_1species_data  (vegmas(iptrsm(i)), i,
     &                                     1, 1, nsmspc, ispc, itag)
             else
               call master_recv_1species_data(vegmas(iptrsm(i)), i,
     &                                     1, 1, nsmspc, ispc, itag)
             endif
             itag=itag+1
           enddo
         endif
      enddo
c
c  --- pass the probing tools concentration fields ---
c
      if( ltrace .OR. lddm .OR. lhddm .OR. lirr ) then
         do i=1,ngrid
           nlayav = nlay(i)
           if( .NOT. lsa_3davrg ) nlayav = 1
           do ilay=1,nlayav
c
c  --- pass the probing tool average concentration fields ---
c
              if( .NOT. lirr ) then
                 do ispc=1,ntotsp
                    if( iproc_id .gt. 0 ) then
                      call node_send_1species_data  (ptavrg(ipsa2d_avrg(i)), i,
     &                                     nlayav, ilay, ntotsp, ispc, itag)
                    else
                      call master_recv_1species_data(ptavrg(ipsa2d_avrg(i)), i,
     &                                     nlayav, ilay, ntotsp, ispc, itag)
                    endif
                    itag=itag+1
                 enddo
              endif
           enddo
c
c  --- pass the probing tool dry deposition fields ----
c
           if( lptdepout ) then
              do ispc=1,notimespc
                if( iproc_id .gt. 0 ) then
                  call node_send_1species_data  (ptdryfld(ipsadep(i)), i,
     &                                        1, 1, notimespc, ispc, itag)
                else
                  call master_recv_1species_data(ptdryfld(ipsadep(i)), i,
     &                                        1, 1, notimespc, ispc, itag)
                endif
                itag=itag+1
              enddo
c
c  --- pass the probing tool wet deposition fields ----
c
              do ispc=1,notimespc
                if( iproc_id .gt. 0 ) then
                  call node_send_1species_data  (ptwetfld(ipsadep(i)), i,
     &                                        1, 1, notimespc, ispc, itag)
                else
                  call master_recv_1species_data(ptwetfld(ipsadep(i)), i,
     &                                        1, 1, notimespc, ispc, itag)
                endif
                itag=itag+1
              enddo
           endif
c
c  --- pass the RTRAC soil mass fields ----
c
           if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
               if( lsrfmod ) then
                  do ispc=1,ntotsp
                    if( iproc_id .gt. 0 ) then
                      call node_send_1species_data  (rtsolmas(ipsa2d(i)), i,
     &                                         1, 1, ntotsp, ispc, itag)
                    else
                      call master_recv_1species_data(rtsolmas(ipsa2d(i)), i,
     &                                            1, 1, ntotsp, ispc, itag)
                    endif
                    itag=itag+1
                  enddo
c
c  --- pass the RTRAC veg mass fields ----
c
                  do ispc=1,ntotsp
                    if( iproc_id .gt. 0 ) then
                      call node_send_1species_data  (rtvegmas(ipsa2d(i)), i,
     &                                            1, 1, ntotsp, ispc, itag)
                    else
                      call master_recv_1species_data(rtvegmas(ipsa2d(i)), i,
     &                                         1, 1, ntotsp, ispc, itag)
                    endif
                    itag=itag+1
                  enddo
               endif
           endif
         enddo
c
c  --- pass the Wall of Cells rectpors ---
c
         if( lwalls ) then
           do ircp=1,nrecep
              if( idrcp(ircp) .EQ. IDWAL ) then
                  call nodes_send_walls_back(numprocs,iproc_id,ircp,itag)
              endif
           enddo
         endif
c
c  --- pass the Wall of Cells rectpors ---
c
         if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
             call nodes_send_rtrcp_back(numprocs,iproc_id,itag)
         endif
c
c  --- pass the CPA fields every hour ---
c
         if( lirr ) then
            do i=1,ngrid
               do ilay=1,nlay(i)
                  do ispc=1,ntotsp
                     if (iproc_id .gt. 0) then
                        call node_send_1species_data(ptconc(ipsa3d(i)),i,
     &                                      nlay(i),ilay,ntotsp,ispc,itag)
                     else
                        call master_recv_1species_data(ptconc(ipsa3d(i)),i,
     &                                      nlay(i),ilay,ntotsp,ispc,itag)
                     endif
                     itag=itag+1
                  enddo
               enddo
            enddo
         endif
      endif
c
c========================= Process Analysis Begin ======================
c
c  ---- send back to master node ---
c
      if( lipr ) then
         if( iproc_id .GT. 0 ) then
            do i=1,ngrid
              call initipr(.FALSE.,iproc_id,i,nspec,mmxp(i),
     &                                mmyp(i),nlay(i),conc(iptr4d(i)))
            enddo
         endif
         call nodes_ipr_update(numprocs,iproc_id,npa_cels,nspec)
      endif
      if( lirr ) call nodes_irr_update(numprocs,iproc_id,npa_cels,nreact)
c
c   --- call routine to zero out all Process Analysis data structures ---
c
      if( (lirr .OR. lipr) .AND. iproc_id .GT. 0 ) then
         call pazero()
         if( lipr ) then
            do i=1,ngrid
              call initipr(.TRUE.,iproc_id,i,nspec,mmxp(i),
     &                                mmyp(i),nlay(i),conc(iptr4d(i)))
            enddo
         endif
      endif
c
c========================= Process Analysis End ======================
c
c  --- pass the mass flux arrays ---
c
      call master_pass_xmass(xmass,     nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(xmass0,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(armass,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(ptmass,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(fluxes, nspec*11*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(xmschem,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(xmsold,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(resid,     nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(xmsfin,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(xmstmp,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(pigdump,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(pgmserr,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(tarmass,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(tptmass,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(tfluxes,nspec*12*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(tresid,    nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(txmschem,  nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
      call master_pass_xmass(txmsfin,   nspec*ngrid,MPI_DOUBLE_PRECISION,
     &                       itag,numprocs,iproc_id                      )
c
c  --- pass the pig sampling grid data ---
c
      if( ipigflg .NE. 0 .AND. lsample ) then
        call nodes_send_pig_sample(numprocs,iproc_id)
        if( lsmptrc ) call nodes_send_rt_sample(numprocs,iproc_id)
      endif
c
      end

c**** STARTDDM.F
c
      subroutine startddm(iounit,nopen)
      use grid
      use chmstry
      use filunit
      use procan
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the files needed for the source 
c     apportionment algorithm.  The output files are opened, the input
c     files are opened as needed.
c
c      Copyright Ramboll
c
c     Argument description:
c        Inputs:
c          iounit     I   unit number for output
c        Outputs:   
c          nopen    I   number of files opened
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     07/19/02   --gwilson--   Added code for source area map for nests
c     10/06/04   --cemery --   Restructured for namelist input
c      8/23/06   --cemery--    Instantaneous restart files reduced to 1
c                              per grid type
c      8/25/06   --cemery--    Surface output files now all UAM format,
c                              one file per grid
c     07/16/07   --bkoo--      Added check for HDDM
c     11/4/09    --cemery--    Removed input top concentrations
c     05/07/12   --cemery--    Added flexi-nesting flag
c     03/01/16   --gwilson--   Added partial source area map
c     11/28/16   --bkoo--      Added code for new top con
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      integer   iounit
      integer   nopen
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_chkfile
      integer ncf_get_nlayers
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*80 action
      character*10 cname
      integer      i, j, igrd, n, idxfile, ierr
      logical      lexist
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- if option is turned off, just return ---
c
      if( .NOT. lddm .AND. .NOT. lhddm ) goto 9999
      nchar = istrln( flrtsa )
c
c  -- call routine to allocate arrays ----
c
      call alloc_tracer(ngroup,ngrid,ncol,nrow,nlay,nspec)
      call alloc_tracer_full(ngroup,ngrid,ncol,nrow)
c
c   --- intialize first time through to true ---
c
      lfirst = .TRUE.
      write(iounit,'(/,A,/)') 
     &            '           **** DDM Files ****'
c
c   --- source area mapping file ---
c
      do 10 igrd = 1,ngrid
         write(action,'(A,I2)') 
     &   'Opening Source Area Map for grid: ',igrd
                                mapfil(0,igrd) = DDM_Source_Area_Map(igrd)
         fname = ' '
         fname = mapfil(0,igrd)
         if( nregin .LE. 0 ) then
            lmapfl(0,igrd) = .FALSE.
            goto 10
         endif 
         if( fname .EQ. ' ' ) then
            if( igrd .EQ. 1 ) goto 7004
            lmapfl(0,igrd) = .FALSE.
            write(iounit,9001)
     &              'No Source Area Map file for Grid #         :',igrd
            goto 10
         endif
         inquire(file=mapfil(0,igrd),exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iormap(0,igrd))
         write(iounit,9001)  'Source area map file for grid # ',igrd,
     &                                        '   (unit):',iormap(0,igrd)
         write(iounit,9002) mapfil(0,igrd)(:istrln(mapfil(0,igrd)))
         lmapfl(0,igrd) = .TRUE.
   10 continue
c
c   --- receptor definition file ----
c
      rcpfil = ' '
      rcpfil = DDM_Receptor_Definitions
      if( rcpfil .NE. ' ' ) then
         action = 'Opening DDM Receptor Definition file.'
         fname = rcpfil
         inquire(file=rcpfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorrcp)
         write(iounit,9000) 
     &       'DDM Receptor definition file         (unit):',iorrcp
         write(iounit,9002) rcpfil(:istrln(rcpfil))
         lrcpfil = .TRUE.
      else
         write(iounit,9000) 'No DDM Receptor definition file provided.'
         lrcpfil = .FALSE.
      endif
c
c   --- instantaneous file used for initialization ---
c
      if( lrstrt ) then
         action = 'Opening DDM master grid Restart file.'
         inifil(IDXCRS) = ' '
         inifil(IDXCRS) = DDM_Master_Restart
         fname = inifil(IDXCRS)
         inquire(file=inifil(IDXCRS),exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorini(IDXCRS))
         write(iounit,9000)'DDM master grid Restart file         (unit):',
     &                                                    iorini(IDXCRS)
         write(iounit,9002) inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
c
         if( ngrid .GT. 1 ) then
            action = 'Opening DDM nested grid Restart file.'
            inifil(IDXFIN) = ' '
            inifil(IDXFIN) = DDM_Nested_Restart
            if( inifil(IDXFIN) .NE. ' ' ) then
               fname = inifil(IDXFIN)
               inquire(file=inifil(IDXFIN),exist=lexist)
               if( .NOT. lexist ) goto 7000
               nopen =  nopen + 1
               call getunit(iorini(IDXFIN))
               write(iounit,9000)
     &                'DDM nested grid Restart file         (unit):',
     &                                                    iorini(IDXFIN)
               write(iounit,9002) inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
            elseif (.not.lflexi) then
               goto 7003
            endif
         endif
      endif
c
c   --- IC file for DDM ---
c
      if( nicddm .GT. 0 .AND. .NOT. lrstrt ) then
         action = 'Opening DDM Initial Conditions file.'
         icfil = ' '
         icfil = DDM_Initial_Conditions
         fname = icfil
         inquire(file=icfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(ioric)
         write(iounit,9000)'DDM Initial Conditions file          (unit):',
     &                                                             ioric
         write(iounit,9002) icfil(:istrln(icfil))
      endif
c
c   --- BC file for DDM ---
c
      if( nbcddm .GT. 0 ) then
         action = 'Opening DDM Boundary Conditions file.'
         bcfil = ' '
         bcfil = DDM_Boundary_Conditions
         fname = bcfil
         inquire(file=bcfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorbc)
         write(iounit,9000)'DDM Boundary Conditions file         (unit):',
     &                                                             iorbc
         write(iounit,9002) bcfil(:istrln(bcfil))
         if ( ltopcon ) then
           action = 'Opening DDM Top Concentrations file.'
           tcfil = ' '
           tcfil = DDM_Top_Concentrations
           fname = tcfil
           if( fname .EQ. ' ' ) goto 7007
           inquire(file=tcfil,exist=lexist)
           if( .NOT. lexist ) goto 7000
           nopen =  nopen + 1
           call getunit(iortc)
           write(iounit,9000)'DDM Top Concentrations file          (unit):',
     &                                                             iortc
           write(iounit,9002) tcfil(:istrln(tcfil))
         endif
      endif
c
c   --- figure out how many files in each grid/group ---
c
      num_iortem = 0
      do i=1,ngroup
         do j=1,ngrid
            do idxfile=1,MXFILES
              if( istrln(DDM_Emiss_Group_Grid(i,j,idxfile)) .NE. 0 )
     &                                      num_iortem(j,i) = idxfile
            enddo
         enddo
      enddo
      num_iortpt = 0
      do i=1,ngroup
        do idxfile=1,MXFILES
          if( istrln(DDM_Points_Group(i,idxfile)) .NE. 0 )
     &                                      num_iortpt(i) = idxfile
        enddo
      enddo
      call alloc_tracer_emfiles(ngroup,ngrid,nemiss_files,npoint_files,
     &                                      num_iortem,num_iortpt,nspec)
c
c   --- emissions files for the source groupings,
c       skip if not doing any emissions DDM species ---
c
      if( nemddm .EQ. 0 ) goto 111
      nlayers_ems = MAX(nlayers_ems,1)
      do 20 i=1,ngroup
c
c   --- surface emissions file --- 
c
         action = 'Opening DDM Gridded Emissions file.'
         do 30 j=1,ngrid
          if( num_iortem(j,i) .EQ. 0 ) then
               write(iounit,9003)
     &         'Gridded emissions file for grid#/group#    :',
     &                                     j,i,' Not supplied'
          else
           do idxfile=1,num_iortem(j,i)
             temfil(j,i,idxfile) = ' '
             temfil(j,i,idxfile) = DDM_Emiss_Group_Grid(i,j,idxfile)
             fname = temfil(j,i,idxfile)
             ltemfl(j,i,idxfile) = .TRUE.
             if( fname .EQ. ' ' ) goto 7005
             inquire(file=temfil(j,i,idxfile),exist=lexist)
             if( .NOT. lexist ) goto 7000
             nopen = nopen + 1
             cname = 'EMISSIONS '
             call getunit(iortem(j,i,idxfile))
             ierr = ncf_chkfile(iortem(j,i,idxfile),fname,action,cname)
             if( ierr .EQ. ISUCES ) then
               call nobinary()
               is_netcdf_iortem(j,i,idxfile) = .FALSE.
               open(unit=iortem(j,i,idxfile),file=fname,
     &                    ERR=7001,form='UNFORMATTED',status='UNKNOWN')
             else
               is_netcdf_iortem(j,i,idxfile) = .TRUE.
               ierr = nf_open(fname,NF_NOWRITE,iortem(j,i,idxfile))
               if( ierr .NE. NF_NOERR ) goto 7001
               nlayers_ems = MAX(nlayers_ems,ncf_get_nlayers(iortem(j,i,idxfile),fname,action))
             endif
             write(iounit,9005)
     &         'Gridded emissions for grid#/group#   (unit):',
     &                                                 j,i,iortem(j,i,idxfile)
             write(iounit,9002) temfil(j,i,idxfile)(:istrln(temfil(j,i,idxfile)))
           enddo
          endif
   30    continue
c
c   --- elevated point source emissions ----
c
         if( num_iortpt(i) .EQ. 0 ) then
            write(iounit,9004)
     &               'Point Source Emissions file for group#     :',
     &                                                 i,' Not supplied'
         else
             do idxfile=1,num_iortpt(i)
                tptfil(i,idxfile) = ' '
                tptfil(i,idxfile) = DDM_Points_Group(i,idxfile)
                fname = tptfil(i,idxfile)
                action = 'Opening DDM Point Source file.'
                if( fname .EQ. ' ' ) goto 7006
                ltptfl(i,idxfile) = .TRUE.
                inquire(file=tptfil(i,idxfile),exist=lexist)
                if( .NOT. lexist ) goto 7000
                nopen = nopen + 1
                call getunit(iortpt(i,idxfile))
                cname = 'PTSOURCE  '
                ierr = ncf_chkfile(iortpt(i,idxfile),tptfil(i,idxfile),action,cname)
                if( ierr .EQ. ISUCES ) then
                  call nobinary()
                  is_netcdf_iortpt(i,idxfile) = .FALSE.
                  open(unit=iortpt(i,idxfile),file=tptfil(i,idxfile),ERR=7001,
     &                        form='UNFORMATTED',status='UNKNOWN')
                else
                  is_netcdf_iortpt(i,idxfile) = .TRUE.
                  ierr = nf_open(tptfil(i,idxfile),NF_NOWRITE,iortpt(i,idxfile))
                  if( ierr .NE. NF_NOERR ) goto 7001
                endif
                write(iounit,9007)
     &                 'Point Source Emissions for group#    (unit):',
     &                                                      i,iortpt(i,idxfile)
                write(iounit,9002) tptfil(i,idxfile)(:istrln(tptfil(i,idxfile)))
             enddo
          endif
   20 continue
c
c   --- output filenames ---
c
  111 continue
      do 40 i=IDXCRS,IDXFIN
         if( i .EQ. IDXFIN .AND. ngrid .EQ. 1 ) goto 40
c
c   --- output instantaneous file ---
c
         confil(i)(1:) =  ' '
         confil(i)(1:) = flrtsa(1:nchar)
         if( i .EQ. IDXCRS ) then
            confil(i)(nchar+1:) = '.ddm.inst'
         else
            confil(i)(nchar+1:) = '.ddm.finst'
         endif
         fname = confil(i)
         nopen = nopen + 1
         call getunit(iowcon(i))
         open(unit=iowcon(i),file=confil(i),ERR=7002,
     &                              form='UNFORMATTED',status='UNKNOWN')
         if( i .EQ. IDXCRS ) then
            write(iounit,9000)
     &          'DDM INST file for master grid        (unit):',iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         else
            write(iounit,9000)
     &          'DDM INST file for nested grids       (unit):',iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         endif
   40 continue
c
c    ---- surface concentrations file ----
c
      if( .not.lsfcfl ) then
         write(iounit,9006)
     &              'DDM Surface file                     (unit):',
     &                                                ' Not supplied'
      else
         do n = 1,ngrid
            if (.NOT. lddmcalc(n) ) cycle
            if( .NOT. lcdfout ) then
               sfcfil(n) = ' '
               fname = flrtsa(1:nchar)
               write(fname(nchar+1:),'(a,i2.2)') '.ddm.grd',n
               sfcfil(n)(1:nchar+10) = fname
               nopen = nopen + 1
               call getunit(iowsfc(n))
               open(unit=iowsfc(n),file=sfcfil(n),ERR=7002,
     &                           form='UNFORMATTED',status='UNKNOWN')
               write(iounit,9000)
     &                   'DDM Surface file                     (unit):',
     &                                                      iowsfc(n)
               write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
            else
               sfcfil(n) = ' '
               fname = flrtsa(1:nchar)
               write(fname(nchar+1:),'(a,i2.2,a)') '.ddm.grd',n,'.nc'
               sfcfil(n)(1:nchar+13) = fname
               nopen = nopen + 1
               action = 'Opening DDM surface output file.'
               call ncf_createfile(sfcfil(n),action,iowsfc(n))
               write(iounit,9000) 'DDM Surface file:'
               write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
            endif
         enddo
      endif
c
c    ---- receptor file ----
c
      if( lrcpfil ) then
         avgfil(1:) = ' '
         avgfil(1:) = flrtsa(1:nchar)
         avgfil(nchar+1:) = '.ddm.receptor'
         fname = avgfil
         nopen = nopen + 1
         call getunit(iowrcp)
         open(unit=iowrcp,file=avgfil,ERR=7002,form='FORMATTED',
     &                                      status='UNKNOWN')
         write(iounit,9000) 
     &     'DDM Receptor concentration file       (unit):',iowrcp
         write(iounit,9002) avgfil(:istrln(avgfil))
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,A,I8)
 9001 format(/,A,I6,A,I8)
 9002 format(2A)
 9003 format(/,A,I2,1X,I2,A)
 9004 format(/,A,I2,A)
 9005 format(/,A,I2,1X,I2,1X,I8)
 9006 format(/,2A)
 9007 format(/,A,I6,2I8)
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Input file does not exist: ',fname
      call camxerr()
c
 7001 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Cannot open input file: ',fname
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(/,1X,2A)') 'Cannot open output file: ',fname
      call camxerr()
c
 7003 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(/,1X,3A,/,A)') 'Nested grid restart file for ',
     &                     tectyp(:istrln(tectyp)),' not supplied.',
     &                  ' Set Flexi_Nest = .true. to ignore this file.'
      call camxerr()
c
 7004 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(/,A)') 'A source area mapping file must be ',
     &                'supplied for the master grid, Grid #1'
      call camxerr()
c
 7005 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of gridded emissions '
      write(iounit,'(1X,A,I3)') 'filenames for grid: ',i
      write(iounit,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7006 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of point source '
      write(iounit,'(1X,A,I3)') 'filenames for grid: ',i
      write(iounit,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7007 continue
      write(iounit,'(//,A)') 'ERROR in STARTDDM:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(1X,2A)') 'You supplied a blank filename for the DDM ',
     &                  'Top Conenctrations file.'
      write(iounit,'(1X,2A)') 'But you did provide a Top Concntration file ',
     &                  'in the CAMx_Control section.'
      write(iounit,'(1X,2A)') 'This is not allowed. You must supply both ',
     &                     'or neither.'
      call camxerr()

c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine domain_decomp()
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use master_mod
      use camx_includes
      use grid_dims
      use grid
      use tracer
      use filunit
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by: 
c       NODES_ALLOC
c    Subroutines called:
c       PAR_EST_TIME
c       PAR_DECOMP
c       PAR_DECOMP_BOUNDS
c       PAR_NODE_PATHS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ngr
      integer :: idn
      integer :: isn
      integer :: ng
      integer :: mp_nzp
      integer :: numbuff
      integer :: jnode
      integer :: ncols
      integer :: nestvar
      integer :: num_lbc_buff
      integer :: num_nest_buff
      integer :: num_feed_buff
      integer :: itype
      integer :: ii1
      integer :: i2i
      integer :: jj1
      integer :: jj2
      integer :: ixy
      integer :: ixyz
      integer :: memf
      integer :: iinc
      integer :: icnt
      integer :: jinc
      integer :: jcnt
      integer :: icm
      integer :: ifm
      integer :: if1
      integer :: jf
      integer :: i
c
      real,    dimension(maxdim2)       :: vctr1
      real,    dimension(maxdim2)       :: vctr2
      real,    dimension(maxdim2)       :: vctr3
      real,    dimension(maxdim2)       :: vctr4
      real,    dimension(maxdim2)       :: vctr5
      real,    dimension(maxdim2)       :: vctr6
      real,    dimension(maxdim2)       :: vctr7
      real,    dimension(nxpmax*nypmax) :: scr2d1
c
      integer, dimension(maxgrds)       :: ninest
      integer, dimension(maxgrds)       :: njnest
      integer, dimension(maxgrds)       :: iparent
c
      integer :: nrowa, ncola, nlaya
c
c  --- Dummy nxtnest fill assuming telescoping grids ---
c
      integer, dimension(maxgrds)       :: nxtnest
      data nxtnest /0,1,2,3,4,5,6,7,8,9/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- check to make sure all parameters are large enough ---
c
      if( nmachines .GT. MAXMACH ) then
        write(iout,'(//,A)') 'ERROR in DOMAIN_DECOMP:'
        write(iout,*) 'Number of computational slices exceeds the ',
     &                                'maximum allowed by the model.'
        write(iout,'(A,I4)') '  Slices (CPUs) requested  : ',nmachines
        write(iout,'(A,I4)') '  Maximum allowed (MAXMACH): ',MAXMACH
        write(iout,*) 'Increase the paramter MAXMACH in ',
     &                              'grid_dims_mod.f and recompile.'
        call camxerr()
      endif
c
      ncola = maxval(ncol(1:ngrid) )
      if( ncola .GT. NXPMAX ) then
        write(iout,'(//,A)') 'ERROR in DOMAIN_DECOMP:'
        write(iout,*) 'Number of columns exceeds the ',
     &                                'maximum allowed by the model.'
        write(iout,'(A,I6)') '  Numer of columns needed : ',ncola
        write(iout,'(A,I6)') '  Maximum allowed (NXPMAX): ',NXPMAX
        write(iout,*) 'Increase the parameter NXPMAX in ',
     &                              'grid_dims_mod.f and recompile.'
        call camxerr()
      endif
c
      nrowa = maxval(nrow(1:ngrid) )
      if( nrowa .GT. NYPMAX ) then
        write(iout,'(//,A)') 'ERROR in DOMAIN_DECOMP:'
        write(iout,*) 'Number of rows exceeds the ',
     &                                'maximum allowed by the model.'
        write(iout,'(A,I6)') '  Numer of rows needed    : ',nrowa
        write(iout,'(A,I6)') '  Maximum allowed (NYPMAX): ',NYPMAX
        write(iout,*) 'Increase the parameter NYPMAX in ',
     &                              'grid_dims_mod.f and recompile.'
        call camxerr()
      endif
c
      nlaya = maxval(nlay(1:ngrid) )
      if( nlaya .GT. NZPMAX ) then
        write(iout,'(//,A)') 'ERROR in DOMAIN_DECOMP:'
        write(iout,*) 'Number of layers exceeds the ',
     &                                'maximum allowed by the model.'
        write(iout,'(A,I6)') '  Numer of layers needed  : ',nlaya
        write(iout,'(A,I6)') '  Maximum allowed (NZPMAX): ',NZPMAX
        write(iout,*) 'Increase the parameter NZPMAX in ',
     &                              'grid_dims_mod.f and recompile.'
        call camxerr()
      endif
c
      if( MAX(nrowa,ncola)*2 .GT. MAXDIM2 ) then
        write(iout,'(//,A)') 'ERROR in DOMAIN_DECOMP:'
        write(iout,*) 'Number of grid cells exceeds the ',
     &                                'maximum allowed by the model.'
        write(iout,'(A,I6)') '  Numer of cells needed    : ',MAX(nrowa,ncola)*2
        write(iout,'(A,I6)') '  Maximum allowed (MAXDIM2): ',MAXDIM2
        write(iout,*) 'Increase the parameter MAXDIM2 in ',
     &                              'grid_dims_mod.f and recompile.'
        call camxerr()
      endif
c
c  --- Decompose all grids into subdomains ---
c
c  --- set the variable that stores the parent grid index ---
c
      do icm=1,ngrid
         iparent(icm) = 1
      enddo
      do icm=1,ngrid
         do ifm=1,nchdrn(icm)
            iparent(idchdrn(ifm,icm)) = icm
         enddo
      enddo
c
      do ifm=2,ngrid
          ninest(ifm) = i1(ifm)
          njnest(ifm) = j1(ifm)
          nxtnest(ifm) = iparent(ifm)
      enddo
c
c  --- Fill IPM, JPM arrays with parent grid
c      index values for all fine grids. ---
c
      do ifm = 2,ngrid
         ipm(1,ifm) = ninest(ifm)
         iinc = 0
         icnt = 0
         do if1 = 2,ncol(ifm)
            ipm(if1,ifm) = ipm(if1-1,ifm) + iinc
            icnt = icnt + 1
            if (icnt >= nmesh(ifm)) then
               icnt = 0
               iinc = 1
            else
               iinc = 0
            endif
         enddo
         ipm(1,ifm) = ninest(ifm)-1
         jpm(1,ifm) = njnest(ifm)
         jinc = 0
         jcnt = 0
         do jf = 2,nrow(ifm)
            jpm(jf,ifm) = jpm(jf-1,ifm) + jinc
            jcnt = jcnt + 1
            if (jcnt >= nmesh(ifm)) then
               jcnt = 0
               jinc = 1
            else
               jinc = 0
            endif
         enddo
         jpm(1,ifm) = njnest(ifm)-1
      enddo   
c
c  --- Obtain estimates of the fraction of computational time (work)
c      required for each column in the region of the domain. ---
c
      do ngr = 1,ngrid
         do i=1,nxpmax*nypmax
c
c  --- Pass in dummy cputime ---
c
            scr2d1(i)=1.
         enddo
c
c  --- 1 is the previous "init" ---
c
         call PAR_est_time(ncol(ngr),nrow(ngr),idfin(iptr2d(ngr)),
     &                     scr2d1(1),scr2d1(1),1                  )
c
c  --- Decompose the grid taking into account the work numbers. ---
c
         call PAR_decomp(ncol(ngr),nrow(ngr),nmesh(ngr),nmachines,
     &                   scr2d1(1),vctr1(1),vctr2(1),vctr3(1),
     &                   vctr4(1),vctr5(1),vctr6(1),vctr7(1),
     &                   ixb(1,ngr),ixe(1,ngr),iyb(1,ngr),iye(1,ngr))
         write(idiag,*)
     &                 '!------------------------------------------------'
         write(idiag,*)
     &                 '!            Domain decomposition'
         write(idiag,*)
     &                 '!   grid# node# x-beg x-end y-beg y-end #cells'
         write(idiag,*)
     &                 '!------------------------------------------------'
         do jnode = 1,nmachines
            ncols= (1+ixe(jnode,ngr)-ixb(jnode,ngr))*
     &                                        (1+iye(jnode,ngr)-iyb(jnode,ngr))
            write(idiag, '('' ! '',7i6,f12.4)') ngr,jnode,
     &                              ixb(jnode,ngr),ixe(jnode,ngr),
     &                                      iyb(jnode,ngr),iye(jnode,ngr),ncols
         enddo
         write(idiag,*)
     &                 '!------------------------------------------------'
      enddo
c
c  --- Compute various bounds for the subdomains ---
c
      call PAR_decomp_bounds(ngrid,ncol,nrow,NOVERLP,NOVERLP)
c
c  --- Determine node sending paths and numbers of receiving nodes ---
c
c  --- Dummy ipm,jpm dimensioned above for now ---
c
      call PAR_node_paths(maxgrds,ngrid,ncol,nrow,
     &                    nxtnest,maxmach,ibcflg,
     &                    inode_paths_master      )
c
c  --- Compute send and receive buffer sizes. These will be maximum of
c      long timestep, turbulence, nest boundaries, and nest feedback.
c      Small timestep will use same buffers as they are always smaller. ---
c
      do idn=1,nmachines
         do isn=1,nmachines
            lbc_buffs(1,idn,isn)=0
            lbc_buffs(2,idn,isn)=0
         enddo
      enddo
      mp_nzp=0
      do ng=1,ngrid
         mp_nzp=max(mp_nzp,nlay(ng))
      enddo
c
c  --- Find number of nested variables to be communicated. ---
c
      do ng=1,ngrid
         nestvar=MAX(nspec,ntotsp)
c
c  --- Find number of lbc variables to be communicated. ---
c
         do isn=1,nmachines
            do idn=1,nmachines
               num_lbc_buff=0
               num_nest_buff=0
               num_feed_buff=0
               itype=1
               ii1=inode_paths_master(1,itype,ng,idn,isn)
               i2i=inode_paths_master(2,itype,ng,idn,isn)
               jj1=inode_paths_master(3,itype,ng,idn,isn)
               jj2=inode_paths_master(4,itype,ng,idn,isn)
               if (ii1.ne.0) then
                  ixy=(i2i-ii1+1)*(jj2-jj1+1)
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_lbc_buff=ixyz*MAX(nspec,ntotsp) + 200
               endif
               itype=5
               ii1=inode_paths_master(1,itype,ng,idn,isn)
               i2i=inode_paths_master(2,itype,ng,idn,isn)
               jj1=inode_paths_master(3,itype,ng,idn,isn)
               jj2=inode_paths_master(4,itype,ng,idn,isn)
               if (ii1.ne.0) then
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_nest_buff=ixyz*nestvar+2*(nestvar+100)
               endif
               itype=6
               ii1=inode_paths_master(1,itype,ng,idn,isn)
               i2i=inode_paths_master(2,itype,ng,idn,isn)
               jj1=inode_paths_master(3,itype,ng,idn,isn)
               jj2=inode_paths_master(4,itype,ng,idn,isn)
               if (ii1.ne.0) then
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_feed_buff=ixyz*nestvar+2*(nestvar+100)
               endif
               lbc_buffs(1,idn,isn)= max(lbc_buffs(1,idn,isn),
     &                                num_lbc_buff,num_nest_buff,num_feed_buff)
            enddo
         enddo
c
         do isn=1,nmachines
            do idn=1,nmachines
               num_lbc_buff=0
               num_nest_buff=0
               num_feed_buff=0
               itype=1
               ii1=inode_paths_master(1,itype,ng,isn,idn)
               i2i=inode_paths_master(2,itype,ng,isn,idn)
               jj1=inode_paths_master(3,itype,ng,isn,idn)
               jj2=inode_paths_master(4,itype,ng,isn,idn)
               if (ii1.ne.0) then
                  ixy=(i2i-ii1+1)*(jj2-jj1+1)
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_lbc_buff=ixyz*MAX(nspec,ntotsp) + 200
               endif
               itype=5
               ii1=inode_paths_master(1,itype,ng,isn,idn)
               i2i=inode_paths_master(2,itype,ng,isn,idn)
               jj1=inode_paths_master(3,itype,ng,isn,idn)
               jj2=inode_paths_master(4,itype,ng,isn,idn)
               if (ii1.ne.0) then
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_nest_buff=ixyz*nestvar+2*(nestvar+100)
               endif
               itype=6
               ii1=inode_paths_master(1,itype,ng,isn,idn)
               i2i=inode_paths_master(2,itype,ng,isn,idn)
               jj1=inode_paths_master(3,itype,ng,isn,idn)
               jj2=inode_paths_master(4,itype,ng,isn,idn)
               if (ii1.ne.0) then
                  ixyz=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)
                  num_feed_buff=ixyz*nestvar+2*(nestvar+100)
               endif
               lbc_buffs(2,idn,isn)= max(lbc_buffs(2,idn,isn),
     &                                num_lbc_buff,num_nest_buff,num_feed_buff)
            enddo
         enddo
      enddo
c
c  --- Check nest boundary receive buffer size ---
c
      itype=5
      do idn=1,nmachines
         newbuff_nest1(idn)=1
         nbuff_nest1(idn)=0
         do ng=1,ngrid
            numbuff=0
            do isn=1,nmachines
               ii1=inode_paths_master(1,itype,ng,idn,isn)
               i2i=inode_paths_master(2,itype,ng,idn,isn)
               jj1=inode_paths_master(3,itype,ng,idn,isn)
               jj2=inode_paths_master(4,itype,ng,idn,isn)
               memf=(i2i-ii1+1)*(jj2-jj1+1)*(mp_nzp)*nestvar
               numbuff=numbuff+memf
            enddo
            nbuff_nest1(idn)=max(nbuff_nest1(idn),numbuff)
         enddo
      enddo
c
      return
      end

      function nf_create( path, cmode, ncid )
      integer nf_create
      include 'tracer.inc'
c
      character*(*) path
      integer       cmode
      integer       ncdid

      write(*,'(//,a)') 'ERROR in NF_CREATE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      if( lcsa ) then
         write(*,'(A)') 'The CSA probing tools option requires NetCDF.'
      endif
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_create = 0
      end
c
      function nf_inq_varid( ncid, name, varid )
      integer nf_inq_varid
c
      integer      ncid
      character(*) name
      integer      varid
c
      write(*,'(//,a)') 'ERROR in NF_INQ_VARID:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_inq_varid = 0
      end
c
      function nf_put_var_int( ncid, varid, ivals )
      integer nf_put_var_int
c
      integer ncid
      integer varid
      integer ivals(*)
c
      write(*,'(//,a)') 'ERROR in NF_INQ_VAR_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_var_int = 0
      end

      function nf_put_vara_int( ncid, varid, start, count, ivals )
      integer nf_put_vara_int
c
      integer ncid
      integer varid
      integer start(*)
      integer count(*)
      integer ivals(*)
c
      write(*,'(//,a)') 'ERROR in NF_INQ_VARA_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_vara_int = 0
      end

      function nf_put_vara_double( ncid, varid, start, count, dvals )
      integer nf_put_vara_double
c
      integer ncid
      integer varid
      integer start(*)
      integer count(*)
      real*8  dvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_VARA_DOUBLE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
       nf_put_vara_double = 0
      end

      function nf_put_vara_real( ncid, varid, start, count, rvals )
      integer nf_put_vara_real
c
      integer ncid
      integer varid
      integer start(*)
      integer count(*)
      real    rvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_VARA_REAL:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
       nf_put_vara_real = 0
      end

      function nf_def_var( ncid, name, datatype, ndims, dimids, varid )
      integer      nf_def_var
c
      integer      ncid
      character(*) name
      integer      datatype
      integer      ndims
      integer      dimids(*)
      integer      varid
c
      write(*,'(//,a)') 'ERROR in NF_DEF_VAR:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_def_var = 0
      end
c
      function nf_put_var_real( ncid, varid, rvals )
      integer nf_put_var_real
c
      integer ncid
      integer varid
      real*4  rvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_VAR_REAL:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_var_real = 0
      end
c
      function nf_put_var_double( ncid, varid, dvals )
      integer nf_put_var_double
c
      integer ncid
      integer varid
      real*8  dvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_VAR_DOUBLE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_var_double = 0
      end
c
      function nf_put_att_text( ncid, varid, name, len, text )
      integer nf_put_att_text
c
      integer       ncid
      integer       varid
      character*(*) name
      integer       len
      character*(*) text
c
      write(*,'(//,a)') 'ERROR in NF_PUT_ATT_TEXT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_att_text = 0
      end
c
      function nf_close( ncid )
      integer nf_close
c
      integer ncid
c
      write(*,'(//,a)') 'ERROR in NF_CLOSE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call exit(1)
c
      nf_close = 0
      end
c
      function nf_set_default_format( format, old_format )
      integer nf_set_default_format
c
      integer format
      integer old_format
c
      write(*,'(//,a)') 'ERROR in NF_SET_DEFAULT_FORMAT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_set_default_format = 0
      end
c
      function nf_enddef( ncid )
      integer nf_enddef
c
      integer ncid
c
      write(*,'(//,a)') 'ERROR in NF_ENDDEF:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_enddef = 0
      end
c
      function nf_put_att_real( ncid, varid, name, xtype, len, rvals )
      integer nf_put_att_real
c
      integer       ncid
      integer       varid
      character*(*) name
      integer       xtype
      integer       len
      real          rvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_ATT_REAL:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_att_real = 0
      end
c
      function nf_put_att_double(ncid,varid,name,xtype,len,dvals)
      integer nf_put_att_double
      integer      ncid
      integer      varid
      character(*) name
      integer      xtype
      integer      len
      real*8       dvals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_ATT_DOUBLE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_att_double = 0
      end
c
      function nf_put_att_int( ncid, varid, name, xtype, len, ivals )
      integer nf_put_att_int
c
      integer       ncid
      integer       varid
      character*(*) name
      integer       xtype
      integer       len
      integer       ivals(*)
c
      write(*,'(//,a)') 'ERROR in NF_PUT_ATT_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_put_att_int = 0
      end
c
      function nf_def_dim( ncid, name, len, dimid )
      integer nf_def_dim
c
      integer      ncid
      integer      len
      integer      dimid
c
      write(*,'(//,a)') 'ERROR in NF_DEF_DIM:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_def_dim = 0
      end
c
      function nf_def_var_chunking(ncid, varid, storage, chunksizes)
c
      integer ncid
      integer varid
      integer storage
      integer chunksizes
c
      write(*,'(//,a)') 'ERROR in NF_DEF_VAR_CHUNKING:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_def_var_chunking = 0
      end
c
      function nf_def_var_deflate(ncid, varid, shuffle, deflate, deflate_level)
c
      integer ncid
      integer varid
      integer shuffle
      integer deflatE
      integer deflate_level
c
      write(*,'(//,a)') 'ERROR in NF_DEF_VAR_DEFLATE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_def_var_deflate = 0
      end
c
      function nf_set_chunk_cache(size, nelems, preemption);
c
      integer size
      integer nelems
      integer preemption
c
      write(*,'(//,a)') 'ERROR in NF_SET_CHUNK_CACHE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_set_chunk_cache = 0
      end
c
      function nf_open(path,mode,ncid)
      integer nf_open
      character*(*) path
      integer       mode
      integer       ncid
c
      write(*,'(//,a)') 'ERROR in NF_OPEN:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_open = 0
      end

      function nf_get_att_int(ncid,varid,name,ivals)
      integer nf_get_att_int
      integer       ncid
      integer       varid
      character*(*) name
      integer       ivals(1)
c
      write(*,'(//,a)') 'ERROR in NF_GET_ATT_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_att_int = 0
      end

      function nf_get_att_double(ncid,varid,name,dvals)
      integer nf_get_att_double
      integer       ncid
      integer       varid
      character*(*) name
      real*8        dvals(1)
c
      write(*,'(//,a)') 'ERROR in NF_GET_ATT_DOUBLE:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_att_double = 0
      end

      function nf_get_vara_int(ncid,varid,start,count,ivals)
      integer nf_get_vara_int
      integer ncid
      integer varid
      integer start(1)
      integer count(1)
      integer ivals(1) 
      write(*,'(//,a)') 'ERROR in NF_GET_VARA_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_vara_int = 0
      end
c
      function nf_get_att_text(ncid,varid,name,text)
      integer nf_get_att_text
      integer       ncid
      integer       varid
      character*(*) name
      character*(*) text
c
      write(*,'(//,a)') 'ERROR in NF_GET_ATT_TEXT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_att_text = 0
      end
c
      function nf_get_vara_real(ncid,varid,start,count,rvals)
      integer nf_get_vara_real
c
      integer ncid
      integer varid
      integer start
      integer count
      real    rvals
c
      write(*,'(//,a)') 'ERROR in NF_GET_VARA_REAL:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_vara_real = 0
      end

      function nf_inq_dimid(ncid,name,dimid)
      integer nf_inq_dimid
c
      integer       ncid
      character*(*) name
      integer       dimid
c
      write(*,'(//,a)') 'ERROR in NF_INQ_DIMID:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_inq_dimid = 0
      end

      function nf_get_var_real(ncid,varid,ivals)
      integer nf_get_var_real
c
      integer       ncid
      integer       varid
      real          rvals(1)
c
      write(*,'(//,a)') 'ERROR in NF_GET_VAR_REAL:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_var_real = 0
      end

      function nf_get_var_int(ncid,varid,ivals)
      integer nf_get_var_int
c
      integer       ncid
      integer       varid
      integer       ivals(1)
c
      write(*,'(//,a)') 'ERROR in NF_GET_VAR_INT:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_get_var_int = 0
      end

      function nf_inq_dimlen(ncid,dimid,len)
      integer nf_inq_dimlen
c
      integer       ncid
      integer       dimid
      integer       len
c
      write(*,'(//,a)') 'ERROR in NF_INQ_DIMLEN:'
      write(*,'(2A)') 'You have requested NetCDF output, but the ',
     &               'model has not been'
      write(*,'(A)') 'built with NetCDF support.'
      write(*,'(A,//)') 'Please recompile the model with the NCF option.'
      call camxerr()
c
      nf_inq_dimlen = 0
      end

      subroutine hr_xo7(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_XO7 solves halogen oxides by EBI iterations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     CB7r3 20March2026 + GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      integer iter, nit
      real TINY
      parameter (TINY = 1.0E-20)
      real gainI, lossI
      real gainIO, lossIO
      real gainOIO, lossOIO
      real r241, r242, r243, r244, r245, r246, r247, r248, r249, r250
      real r251, r252, r253, r255
c
c --- Entry Point
c
      N2 = M - O2
      r241 = r(241)
      r242 = r(242)
      r253 = r(253)
      r255 = r(255)
c
      nit = 2
c
      do iter = 1,nit
c
c --- Update reaction rates that change with iteration of y1
c
      r243 = rk(243)*y1(lI)*yh(lO3)
      r244 = rk(244)*y1(lIO)
      r245 = rk(245)*y1(lIO)*y1(lIO)
      r246 = rk(246)*y1(lIO)*yh(lHO2)
      r247 = rk(247)*y1(lIO)*yh(lNO)
      r248 = rk(248)*y1(lIO)*yh(lNO2)
      r249 = rk(249)*y1(lOIO)
      r250 = rk(250)*y1(lOIO)*yh(lOH)
      r251 = rk(251)*y1(lOIO)*y1(lIO)
      r252 = rk(252)*y1(lOIO)*yh(lNO)
c
c --- Gain and loss terms for the XO species
c
      gainI = 0.0
     &       + ( 2.000)*r241
     &       +          r242
     &       +          r244
     &       + ( 0.400)*r245
     &       +          r247
     &       +          r249
     &       +          r253
     &       +          r255
c
      lossI = 0.0
     &       +          r243
c
      gainIO = 0.0
     &       +          r243
     &       +          r252
c
      lossIO = 0.0
     &       +          r244
     &       + ( 2.000)*r245
     &       +          r246
     &       +          r247
     &       +          r248
     &       +          r251
c
      gainOIO = 0.0
     &       + ( 0.400)*r245
     &       +          r253
c
      lossOIO = 0.0
     &       +          r249
     &       +          r250
     &       +          r251
     &       +          r252
c
c --- EBI solution for the XO species
c
      y1(lI) = MIN(1.0, MAX(TINY,(y0(lI) + gainI*dt)
     &                         / (1.0 + lossI*dt/y1(lI))))
c
      y1(lIO) = MIN(1.0, MAX(TINY,(y0(lIO) + gainIO*dt)
     &                         / (1.0 + lossIO*dt/y1(lIO))))
c
      y1(lOIO) = MIN(1.0, MAX(TINY,(y0(lOIO) + gainOIO*dt)
     &                         / (1.0 + lossOIO*dt/y1(lOIO))))
c
      enddo ! Iterations
c
      return
      end

      subroutine tridiag(a,b,c,d,n,m)
c
c----CAMx v7.40 260801
c
c     TRIDIAG solves a tridiagnal matrix equation with multiple 
c     right-hand side arrays.
c
c      Copyright Ramboll
c          
c     Modifications:
c        none
c
c     Input arguments:
c        n                  size of the coefficient matrix
c        m                  number of right-hand side arrays
c        a                  first coefficient array 
c        b                  second coefficient array 
c        c                  third coefficient array 
c        d                  right-hand side arrays 
c 
c     Output arguments:
c        d                  solution arrays 
c
c     Routines called:
c        none
c
c     Called by:
c        VRTSLV
c        VDIFFIMP
c
      implicit none
      integer n,m
      real a(n),b(n),c(n),d(n,m)
      integer nm1,i,i1,k,j
c
c-----Entry point
c
      nm1=n-1
      do 10 i=1,nm1
        c(i)=-c(i)/b(i)
        i1=i+1
        b(i1)=c(i)*a(i1)+b(i1)
  10  continue
c
      do 40 k=1,m
        d(1,k)=d(1,k)/b(1)
        do 20 i=1,nm1
          i1=i+1
          d(i1,k)=(d(i1,k)-d(i,k)*a(i1))/b(i1)
  20    continue
c
        do 30 j=1,nm1
          i=n-j
          i1=i+1
          d(i,k)=d(i1,k)*c(i)+d(i,k)
  30    continue
  40  continue
c
      return
      end

      subroutine iniptr(numcols,numrows)
      use filunit
      use grid
      use chmstry
      use tracer
      use procan
      implicit none
c
c----CAMx v7.40 260801
c
c     This routine calculates the pointers into the concentration
c     and meterology arrays for each grid.  The arrays are vectors
c     so this routine calculates the pointer that stores the 
c     first element of the 2-D or 3-D or 4-D field.  Some checks
c     are also made to ensure there is no array overflow of the
c     vectors.
c
c      Copyright Ramboll
c          
c     Modifications:
c        10/8/99   Fixed a bug in assigning pointers for OSAT arrays for
c                  grids >= 3
c         9/3/02   Removed IPTRCL
c        1/13/03   Added IPTRDP for deposition output fields
c       11/10/03   Added IPSMP for RTRAC/PiG sampling grid output fields
c        7/29/05   Removed pointers for PiG sampling grid fields to READNML
c       04/30/13   Added surface model
c       09/02/14   Added subgrid convective model
c
c     Input arguments:
c        numcols   -- number of columns for each grid
c        numrows   -- number of columns for each grid
c
c     Output arguments:
c        nglay   -- maximum number of columns for each grid
c
c     Subroutine called:
c        none
c
c     Called by:
c        READNML
c
c-----Include files
c
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
c
c-----Argument declarations
c
      integer numcols(*)
      integer numrows(*)
c
c-----Local variables
c
      integer i
c
c-----Entry point
c
      iptr2d(1) = 1
      iptr2d_full(1) = 1
      iptr3d(1) = 1
      iptr3d_full(1) = 1
      iptr4d(1) = 1
      iptrav(1) = 1
      iptrem(1) = 1
      iptr1lay(1) = 1
      iptrlu(1) = 1
      iptrdp(1) = 1
      iptrsm(1) = 1
      ipsa2d(1) = 1
      ipsa2d_avrg(1) = 1
      ipsadep(1) = 1
      ipsa3d(1) = 1
      ipsa3d_ems(1) = 1
      iptrcig(1) = 1
      do i=2,ngrid
         iptr2d(i) = iptr2d(i-1) + numcols(i-1)*numrows(i-1)
         iptr2d_full(i) = iptr2d(i-1) + numcols(i-1)*numrows(i-1)
         iptr3d(i) = iptr3d(i-1) + numcols(i-1)*numrows(i-1)*nlay(i-1)
         iptr3d_full(i) = iptr3d(i)
         iptrcig(i) = iptrcig(i-1) + 
     &                2*nlay(i-1)*nlay(i-1)*numcols(i-1)*numrows(i-1)
         iptr4d(i) = iptr4d(i-1) + 
     &                       numcols(i-1)*numrows(i-1)*nlay(i-1)*nspec
         iptrem(i) = iptrem(i-1) + numcols(i-1)*numrows(i-1)*nlayers_ems*nemspc
         iptr1lay(i) = iptr1lay(i-1) + numcols(i-1)*numrows(i-1)*nspec
         if( nlu .GT. 0 ) then
            iptrlu(i) = iptrlu(i-1) + numcols(i-1)*numrows(i-1)*nlu
         else
            iptrlu(i) = 1
         endif
         iptrdp(i) = iptrdp(i-1) + numcols(i-1)*numrows(i-1)*
     &                             (ndepspc*3 + 2)
         iptrsm(i) = iptrsm(i-1) + numcols(i-1)*numrows(i-1)*nsmspc
         if( .NOT. l3davg(i-1) ) then 
             iptrav(i) = iptrav(i-1) + numcols(i-1)*numrows(i-1)*navspc
         else
             iptrav(i) = iptrav(i-1) + 
     &                       numcols(i-1)*numrows(i-1)*nlay(i-1)*navspc
         endif
         if( ltrace .OR. lddm .OR. lhddm .OR. lirr ) then
             if( lptdepout ) then
                 ipsadep(i) = ipsadep(i-1) + 
     &                              numcols(i-1)*numrows(i-1)*notimespc
             else
                 ipsadep(i) = 1
             endif
             ipsa2d(i) = ipsa2d(i-1) + numcols(i-1)*numrows(i-1)*ntotsp
             if( lsa_3davrg ) then
                ipsa2d_avrg(i) = ipsa2d_avrg(i-1) + 
     &                       numcols(i-1)*numrows(i-1)*nlay(i-1)*ntotsp
             else
                ipsa2d_avrg(i) = ipsa2d(i)
             endif
             ipsa3d(i) = ipsa3d(i-1) + DBLE(numcols(i-1))*
     &                      DBLE(numrows(i-1))*DBLE(nlay(i-1))*DBLE(ntotsp)
             ipsa3d_ems(i) = ipsa3d_ems(i-1) + DBLE(numcols(i-1))*
     &                    DBLE(numrows(i-1))*DBLE(nlayers_ems)*DBLE(soap3_ntotsp)
         else
             ipsadep(i) = 1
             ipsa2d(i) = 1
             ipsa2d_avrg(i) = 1
             ipsa3d(i) = 1
             ipsa3d_ems(i) = 1
         endif
      enddo
c
c----Return point
c
      return
      end

      subroutine hr_pan1(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_PAN1 solves PAN and RCO3 using Hertel's equations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CB6r5 plus GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      real fwd, bck, self, A, B, C, Q
      real newRCO3, lsPAN, lsRCO3
c
c --- Entry Point
c
      N2 = M - O2
c
c
c --- New RCO3 excluding from PAN
c
      newRCO3 = dt*(0.0
     &       +          r( 95)
     &       +          r(104)
     &       +          r(105)
     &       + ( 0.800)*r(110)
     &       +          r(112)
     &       +          r(116)
     &       +          r(117)
     &       +          r(118)
     &       + ( 0.500)*r(125)
     &       + ( 0.620)*r(126)
     &       +          r(127)
     &       + ( 0.269)*r(151)
     &       + ( 0.143)*r(152)
     &       + ( 0.208)*r(154)
     &       + ( 0.300)*r(189)
     &       + ( 0.600)*r(191)
     &       + ( 0.120)*r(195) )
c
c --- Loss of RCO3 excluding self-reaction
c
      lsRCO3 = 1.0 + dt*(0.0
     &       +          rk( 53)*yh(lNO)
     &       +          rk( 54)*yh(lNO2)
     &       +          rk( 57)*yh(lHO2)
     &       +          rk( 58)*yh(lRO2)
     &       +          rk( 60)*yh(lCXO3)
     &       +          rk( 73)*yh(lMEO2)
     &       +          rk( 77)*yh(lXO2H)
     &       +          rk( 81)*yh(lXO2)
     &       +          rk( 85)*yh(lXO2N)
     &       +          rk(146)*yh(lISO2)
     &       +          rk(161)*yh(lEPX2)
     &       +          rk(169)*yh(lBZO2)
     &       +          rk(174)*yh(lTO2)
     &       +          rk(180)*yh(lXLO2)
     &       +          rk(203)*yh(lOPO3) )
c
c --- Loss of PAN
c
      lsPAN = 1.0 + dt*(0.0
     &       + rk( 55)
     &       + rk( 56) )
c
c
c --- Forward reaction of RCO3 to PAN
c
      fwd  = dt*(0.0
     &       +          rk( 54)*yh(lNO2) )
c
c --- Backward reactions of PAN to RCO3
c
      bck  = dt*(0.0
     &       +          rk( 55)
     &       + ( 0.600)*rk( 56) )
c
c --- RCO3 self-reaction
c
      self = dt*(0.0
     &       + ( 2.000)*rk( 59) )
c
c --- Solve for RCO3
c
      A = self*lsPAN
      B = ( lsPAN*lsRCO3) - (fwd*bck)
      C = lsPAN*( y0(lC2O3) + newRCO3 ) + bck*y0(lPAN)
      Q = -0.5 * ( B + SIGN(1.0,B)*SQRT(B*B + 4.0*A*C) )
c
c --- Update Concentrations
c
      y1(lC2O3) = MAX(1.0E-18, MAX(Q/A, -C/Q) )
      y1(lPAN)  = MAX(1.0E-15, (y0(lPAN) + fwd*y1(lC2O3)) / lsPAN )
c
      return
      end

      subroutine RAQCHEM ( TEMP, PRES_PA, TAUCLD, 
     &                     WCAVG, GAS, AEROSOL, BB,
     &                     idiag, iout, igrd, iaq, jaq, kaq, mwboa0)

c  This is a stand-alone version of the aqueous phase chemistry from
c  CMAQ version 4 (November 2002) adapted for CAMx. 
c
c  08/23/13 -bkoo-   Revised for DDM-PM
c  10/26/18 -bkoo-   Updated DDM for revised oxidation rates & in-cloud SOA formation
c  05/12/26 -gy-     Set upper limit to ionic strength; improve crash messages; clean up
c
c  DESCRIPTION:
c    Compute concentration changes in cloud due to aqueous chemistry
c
c  Revision History:
c      No   Date   Who	What
c      -- -------- ---  -----------------------------------------
c      0  / /86    CW   BEGIN PROGRAM - Walceks's Original Code
c      1  / /86    RB   INCORPORATE INTO RADM
c      2  03/23/87 DH   REFORMAT
c      3  04/11/88 SJR  STREAMLINED CODE - ADDED COMMENTS
c      4  08/27/88 SJR  COMMENTS, MODIFIED FOR RPM
c      4a 03/15/96 FSB  Scanned hard copy to develop Models3
c                       Version.
c      5  04/24/96 FSB  Made into Models3 Format
c      6  02/18/97 SJR  Revisions to link with Models3
c      7  08/12/97 SJR  Revised for new concentration units (moles/mole)
c                       and new treatment of nitrate and nitric acid
c      9  12/15/98 David Wong at LM:
c             -- change division of XL, TEMP to multiplication of XL, TEMP
c                reciprocal, respectively
c             -- change / TOTOX / TSIV to / ( TOTOX * TSIV )
c     10  03/18/99 David Wong at LM:
c             -- removed "* 1.0" redundant calculation at TEMP1 calculation
c
c  Reference:
c     Walcek & Taylor, 1986, A theoretical Method for computing
c      vertical distributions of acidity and sulfate within cumulus
c      clouds, J. Atmos Sci.,  Vol. 43, no. 4 pp 339 - 355
c
c  Called by:  AEROCHEM_CF
c
c  Calls the following subroutines:  CAMXERR
c
c  Calls the following functions:  HLCONST
c
c  ARGUMENTS     TYPE      I/O       DESCRIPTION
c  ---------     ----  ------------  --------------------------------
c  GAS           real  input&output  Concentrations (mol/mol)
c                                    (1) = SO2   
c                                    (2) = HNO3  
c                                    (3) = N2O5  
c                                    (4) = CO2   
c                                    (5) = NH3   
c                                    (6) = H2O2  
c                                    (7) = O3    
c                                    (8) = FOA   formic acid
c                                    (9) = MHP   methyl hydroperoxide
c                                    (10)= PAA   peroxyacetic acid
c                                    (11)= H2SO4 
c                                    (12)= GLY   glyoxal
c                                    (13)= MGLY  methylglyoxal
c                                    (14)= GLYD  glycolaldehyde
c                                    (15)= HO    hydroxyl radical
c
c hint: search for species pointers, e.g., LHO finds where hydroxyl is used
c
c  AEROSOL       real  input&output  Concentrations (mol/mol)
c                                    (1) = SO4  
c                                    (2) = NH4  
c                                    (3) = NO3  
c                                    (4) = CACO3
c                                    (5) = MGCO3
c                                    (6) = NACL 
c                                    (7) = FE+++
c                                    (8) = MN++ 
c                                    (9) = KCL  
c                                    (10)= BOA0   biogenic non-volatile SOA

      IMPLICIT NONE

c---  Essential parameters

      integer     NGAS     ! local number of gasses for aqchem
      integer     NAER     ! local number of aerosols for aqchem
      REAL        MOLVOL   ! Molar volume at STP [ L/mol ] Non MKS units 
      REAL        STDATMPA ! standard atmosphere  [ Pa ]
      REAL        STDTEMP  ! Standard Temperature [ K ]
      parameter ( NGAS = 15 )
      parameter ( NAER = 10 )
      PARAMETER ( MOLVOL = 22.41410 )
      PARAMETER ( STDATMPA = 101325.0 )
      PARAMETER ( STDTEMP = 273.15 )

      INTEGER      NUMOX           ! number of oxidizing reactions
      PARAMETER  ( NUMOX =  5 )

      REAL         H2ODENS         ! density of water at 20 C and 1 ATM
      PARAMETER  ( H2ODENS = 1000.0 )  ! (kg/m3)

      INTEGER      NLIQS           ! number of liquid phase species
      PARAMETER  ( NLIQS = 37 )

      REAL         ONETHIRD       ! 1/3
      PARAMETER  ( ONETHIRD = 1.0 / 3.0 )

      REAL         TWOTHIRDS       ! 2/3
      PARAMETER  ( TWOTHIRDS = 2.0 / 3.0 )

      REAL, PARAMETER :: CONMIN = 1.0E-18

c---  Gas species pointers

      integer      lso2
      integer      lhno3
      integer      ln2o5
      integer      lco2
      integer      lnh3
      integer      lh2o2
      integer      lo3
      integer      lfoa
      integer      lmhp
      integer      lpaa
      integer      lh2so4

      parameter    (lso2   = 1 )
      parameter    (lhno3  = 2 )
      parameter    (ln2o5  = 3 )
      parameter    (lco2   = 4 )
      parameter    (lnh3   = 5 )
      parameter    (lh2o2  = 6 )
      parameter    (lo3    = 7 )
      parameter    (lfoa   = 8 )
      parameter    (lmhp   = 9 )
      parameter    (lpaa   = 10)
      parameter    (lh2so4 = 11)

c---  Additional gas species pointers for aqueous SOA formation

      integer, parameter :: lgly = 12
      integer, parameter :: lmgly = 13
      integer, parameter :: lglyd = 14
      integer, parameter :: lho = 15
    
c---  Aerosol species pointers

      integer      lso4
      integer      lnh4
      integer      lno3
      integer      lcaco3
      integer      lmgco3
      integer      lnacl
      integer      la3fe
      integer      lb2mn
      integer      lkcl
      parameter    (lso4   = 1 )
      parameter    (lnh4   = 2 )
      parameter    (lno3   = 3 )
      parameter    (lcaco3 = 4 )
      parameter    (lmgco3 = 5 )
      parameter    (lnacl  = 6 )
      parameter    (la3fe  = 7 )
      parameter    (lb2mn  = 8 )
      parameter    (lkcl   = 9 )

c---  Additional aerosol species pointer for aqueous SOA formation

      integer, parameter :: lorgc = 10

c---  Define limits for pH and ionic strength (Hermann et al., 2015)
c     pubs.acs.org/doi/pdf/10.1021/cr500447k 

      REAL, PARAMETER :: PHMIN = 0.01
      REAL, PARAMETER :: PHMAX = 10.0
      REAL, PARAMETER :: ISMAX = 0.2
      REAL, PARAMETER :: ISMIN = 1.0E-7

c---  ARGUMENTS and their descriptions

      REAL         PRES_PA         ! pressure (Pa)
      REAL         TAUCLD          ! timestep for cloud (s)
      REAL         TEMP            ! temperature (K)
      REAL         WCAVG           ! liquid water content (kg/m3)
      REAL         GAS    ( NGAS ) ! gas phase concentrations (mol/molV)
      REAL         AEROSOL( NAER ) ! aerosol concentrations (mol/molV)
      integer      idiag           ! unit number for diagnostic output
      integer      iout            ! unit number for message output
      integer      igrd            ! grid number
      integer      iaq             ! i grid cell index (column)
      integer      jaq             ! j grid cell index (row)
      integer      kaq             ! k grid cell index (layer)
      real         mwboa0          ! molecular weight of biogenic soa tracer

c---  LOCAL VARIABLES (scalars) and their descriptions:

      INTEGER      I20C            ! loop counter for do loop 20
      INTEGER      I30C            ! loop counter for do loop 30
      INTEGER      ITERAT          ! # iterations of aqueaous chemistry solver
      INTEGER      I7777C          ! aqueous chem iteration counter
      INTEGER      ICNTAQ          ! aqueous chem iteration counter
      INTEGER      IOX             ! index over oxidation reactions

      REAL         A               ! iron's anion concentration
      REAL         AC              ! H+ concentration in cloudwater (mol/liter)
      REAL         ACT1            ! activity corretion factor!single ions
      REAL         ACT2            ! activity factor correction!double ions
      REAL         ACTB            ! save previous ACT1
      REAL         AE              ! guess for H+ conc in cloudwater (mol/liter)
      REAL         B               ! manganese's anion concentration
      REAL         PRES_ATM        ! pressure (Atm)
      REAL         BB              ! lower limit guess of cloudwater pH
      REAL         CA              ! Calcium conc in cloudwater (mol/liter)
      REAL         CAA             ! inital Calcium in cloudwater (mol/liter)
      REAL         CL              ! Cl-  conc in cloudwater (mol/liter)
      REAL         CLA             ! initial Cl in cloudwater (mol/liter)
      REAL         CO2H            ! Henry's Law constant for CO2
      REAL         CO21            ! First dissociation constant for CO2
      REAL         CO22            ! Second dissociation constant for CO2
      REAL         CO212           ! CO21*CO22
      REAL         CO212H          ! CO2H*CO21*CO22
      REAL         CO21H           ! CO2H*CO21
      REAL         CO2L            ! CO2 conc in cloudwater (mol/liter)
      REAL         CO3             ! CO3= conc in cloudwater (mol/liter)
      REAL         CO3A            ! initial CO3 in cloudwater (mol/liter)
      REAL         DSIV_SCALE      ! mass conservation scale factor for S(IV)
      REAL         DTRMV           !
      REAL         DTS6            !
      REAL         DGLYDT          ! change in GLY (mol/liter/sec)
      REAL         DGLYDDT         ! change in GLYD (mol/liter/sec)
      REAL         DMGLYDT         ! change in MGLY (mol/liter/sec)
      REAL         DGLY1           ! change due to Rxn. in GLY for DTW(0) time step
      REAL         DGLYD1          ! change due to Rxn. in GLYD for DTW(0) time step
      REAL         DMGLY1          ! change due to Rxn. in MGLY for DTW(0) time step
      REAL         DORGC           ! change in ORGC for DTW(0) time step (mol/liter)
      REAL         FA              ! functional value ??
      REAL         FB              ! functional value ??
      REAL         FE              ! Fe+++ conc in cloudwater (mol/liter)
      REAL         FEA             ! initial Fe in cloudwater (mol/liter)
      REAL         FNH3            ! frac weight of NH3 to total ammonia
      REAL         FHNO3           ! frac weight of HNO3 to total NO3
      REAL         FOA1            ! First dissociation constant for FOA
      REAL         FOAH            ! Henry's Law constant for FOA
      REAL         FOA1H           ! FOAH*FOA1
      REAL         FOAL            ! FOA conc in cloudwater (mol/liter)
      REAL         FTST            !
      REAL         GLYH            ! Henry's Law constant for glyoxal
      REAL         GLYL            ! glyoxal conc in cloud water (mol/liter)
      REAL         GLYDH           ! Henry's Law constant for glycolaldehyde
      REAL         GLYDL           ! glycolaldehyde conc in cloud water (mol/liter)
      REAL         GM              !
      REAL         GM1             ! activity correction factor
      REAL         GM1LOG          !
      REAL         GM2             ! activity correction factor
      REAL         GM2LOG          !
      REAL         HA              !
      REAL         HB              !
      REAL         H2OW            !
      REAL         H2O2H           ! Henry's Law Constant for H2O2
      REAL         H2O2L           ! H2O2 conc in cloudwater (mol/liter)
      REAL         HCO2            ! HCO2 conc in cloudwater (mol/liter)
      REAL         HCO3            ! HCO3 conc in cloudwater (mol/liter)
      REAL         HNO3H           ! Henry's Law Constant for HNO3
      REAL         HNO31           ! First dissociation constant for HNO3
      REAL         HNO31H          !
      REAL         HNO3L           ! HNO3 conc in cloudwater (mol/liter)
      REAL         HOH             ! Henry's Law Constant for HO
      REAL         HSO3            ! HSO3 conc in cloudwater (mol/liter)
      REAL         HSO4            ! HSO4 concn in cloudwater (mol/liter)
      REAL         HTST            !
      REAL         K               ! K conc in cloudwater (mol/liter)
      REAL         KA              ! initial K in cloudwater (mol/liter)
      REAL         LGTEMP          ! log of TEMP
      REAL         MG              !
      REAL         MGA             ! inital Mg in cloudwater (mol/liter)
      REAL         MGLYH           ! Henry's Law Constant for methylglyoxal
      REAL         MGLYL           ! MGLY conc in cloud water (mol/liter)
      REAL         MHPH            ! Henry's Law Constant for MHP
      REAL         MHPL            ! MHP conc in cloudwater (mol/liter)
      REAL         MN              ! Mn++ conc in cloudwater (mol/liter)
      REAL         MNA             ! initial Mn in cloudwater (mol/liter)
      REAL         NA              ! Na conc in cloudwater (mol/liter)
      REAL         NAA             ! initial Na in cloudwater (mol/liter)
      REAL         NH31            ! First dissociation constant for NH3
      REAL         NH3H            ! Henry's Law Constant for NH3
      REAL         NH3DH20         !
      REAL         NH31HDH         !
      REAL         NH3L            ! NH3 conc in cloudwater (mol/liter)
      REAL         NH4             ! NH4+ conc in cloudwater (mol/liter)
      REAL         NH4ACCA         ! init NH4 acc conc in cloudwater (mol/liter)
      REAL         NO3             ! NO3 conc in cloudwater (mol/liter)
      REAL         NO3ACCA         ! init NO3 acc conc in cloudwater (mol/liter)
      REAL         O3H             ! Henry's Law Constant for O3
      REAL         O3L             ! O3 conc in cloudwater (mol/liter)
      REAL         OH              ! OH- ion conc in cloudwater (mol/liter)
      REAL         OHL             ! OH radical conc in cloudwater (mol/liter)
      REAL         ORGCA           ! initial SOA in cloudwater (mol/liter)
      REAL         ORGC            ! cloud-produced SOA in cloudwater (treated as primary)
      REAL         PAAH            ! Henry's Law Constant for PAA
      REAL         PAAL            ! PAA conc in cloudwater (mol/liter)
      REAL         PCO20           ! total CO2 partial pressure (atm)
      REAL         PCO2F           ! gas only CO2 partial pressure (atm)
      REAL         PFOA0           ! total ORGANIC acid partial pressure (atm)
      REAL         PFOAF           ! gas only ORGANIC ACID partial press (atm)
      REAL         PGLY0           ! total GLY partial pressure (atm)
      REAL         PGLYF           ! gas only GLY partial pressure (atm)
      REAL         PGLYD0          ! total GLY partial pressure (atm)
      REAL         PGLYDF          ! gas only GLYD partial pressure (atm)
      REAL         PH2O20          ! total H2O2 partial pressure (atm)
      REAL         PH2O2F          ! gas only H2O2 partial pressure (atm)
      REAL         PHNO30          ! total HNO3 partial pressure (atm)
      REAL         PHNO3F          ! gas only HNO3 partial pressure (atm)
      REAL         PHO0            ! total HO partial pressure (atm)
      REAL         PHOF            ! gas only HO partial pressure (atm)
      REAL         PMGLY0          ! total MGLY partial pressure (atm)
      REAL         PMGLYF          ! gas only MGLY partial pressure (atm)
      REAL         PMHP0           ! total MHP partial pressure (atm)
      REAL         PMHPF           ! gas only MHP partial pressure (atm)
      REAL         PNH30           ! total NH3 partial pressure (atm)
      REAL         PNH3F           ! gas only NH3 partial pressure (atm)
      REAL         PO30            ! total O3 partial pressure (atm)
      REAL         PO3F            ! gas only O3 partial pressure (atm)
      REAL         PPAA0           ! total PAA partial pressure (atm)
      REAL         PPAAF           ! gas only PAA partial pressure (atm)
      REAL         PSO20           ! total SO2 partial pressure (atm)
      REAL         PSO2F           ! gas only SO2 partial pressure (atm)
      REAL         RATE            !
      REAL         RECIPA1         !
      REAL         RECIPA2         !
      REAL         RECIPAP1        ! one over pressure (/atm)
      REAL         RGLY3           ! GLY rate constant, liter/(mol sec)
      REAL         RGLYD3          ! GLYD rate constant, liter/(mol sec)
      REAL         RH2O2           !
      REAL         RO3A, RO3B, RO3C
      REAL         RMGLY3          ! MGLY3 rate constant, liter/(mol sec)
      REAL         RMHP            !
      REAL         RPAA            !
      REAL         RT              ! gas const * temperature (liter atm/mol)
      REAL         SCVEFF          ! Scavenging efficiency (%)
      SAVE         SCVEFF
      DATA         SCVEFF / 100.0 / ! currently set to 100%
      REAL         SIV             ! dissolved so2 in cloudwater (mol/liter)
      REAL         SK6             !
      REAL         SK6TS6          !
      REAL         SO21            ! First dissociation constant for SO2
      REAL         SO22            ! Second dissociation constant for SO2
      REAL         SO2H            ! Henry's Law Constant for SO2
      REAL         SO212           ! SO21*SO22
      REAL         SO212H          ! SO21*SO22*SO2H
      REAL         SO21H           ! SO21*SO2H
      REAL         SO2L            ! SO2 conc in cloudwater (mol/liter)
      REAL         SO3             ! SO3= conc in cloudwater (mol/liter)
      REAL         SO4             ! SO4= conc in cloudwater (mol/liter)
      REAL         STION           ! ionic strength
      REAL         TAC             !
      REAL         TIMEW           ! cloud chemistry clock (sec)
      REAL         TGLY            ! total glyoxal available for oxidation
      REAL         TGLYD           ! total glycolaldehyde available for oxidation
      REAL         TMGLY           ! total methylglyoxal available for oxidation
      REAL         TH2O2
      REAL         TO3
      REAL         TMHP
      REAL         TPAA
      REAL         TOTAMM          ! total ammonium
      REAL         TOTNIT          ! total nitrate
      REAL         TS6             ! SO4 conc in cloudwater (mol/liter)
      REAL         TS6ACCA         ! init SO4 acc conc in cloudwater (mol/liter)
      REAL         TSIV            !
      REAL         TST             !
      REAL         XL              ! conversion factor (liter-atm/mol)
      REAL         ONE_OVER_XL     ! 1.0 / XL
      REAL         PRES_ATM_OVER_XL     ! PRES_ATM / XL
      REAL         XLCO2           !
      REAL         XLH2O2          !
      REAL         XLHNO3          !
      REAL         XLMHP           !
      REAL         XLNH3           !
      REAL         XLO3            !
      REAL         XLPAA           !
      REAL         XLSO2           !

      REAL         YGLY            ! Molar yield of SOA from GLY
      REAL         YMGLY           ! Molar yield of SOA from MGLY
      REAL         YGLYD           ! Molar yield of SOA from GLYD

c---  LOCAL VARIABLES (arrays) and their descriptions:

      REAL         LIQUID( NLIQS ) ! liquid concentration array (mol/liter)
      REAL         DSIVDT( 0:NUMOX ) ! rate of so2 oxid incloud (mol/liter/sec)
      REAL         DS4   ( 0:NUMOX ) ! S(IV) oxidized over timestep DTW(0)
      REAL         DTW   ( 0:NUMOX ) ! cloud chemistry timestep (sec)

      REAL         ONE_OVER_TEMP     ! 1.0 / TEMP

c---  EXTERNAL FUNCTIONS and their descriptions:

      REAL          HLCONST
      EXTERNAL      HLCONST
c
c---  Entry point
c
      ONE_OVER_TEMP = 1.0 / TEMP

c---  check for bad temperature, cloud air mass, or pressure

      IF ( TEMP .LE. 0.0 .OR. PRES_PA .LE. 0.0 ) THEN
         write(iout,'(//,A)') 'ERROR in RAQCHEM:'
         write(iout,'(/,A)') 
     &            'Error in RADM aqueous chemistry (RAQCHEM)'
         write(iout,'(A,3E10.3)') 
     &            'Invalid met data: T, P',TEMP,PRES_PA
         write(iout,'(a,4i4)') 
     &         'Grid, icell, jcell, kcell:', igrd, iaq, jaq, kaq
         call camxerr()
      END IF

c---  compute several conversion factors

      ICNTAQ = 0
      ITERAT = 0
      RT = ( MOLVOL / STDTEMP ) * TEMP             ! R * T (liter atm / mol)
      PRES_ATM = PRES_PA /  STDATMPA               ! pressure (atm)
      XL   = WCAVG * RT / H2ODENS     ! conversion factor (l-atm/mol)
      ONE_OVER_XL = 1.0 / XL
      PRES_ATM_OVER_XL = PRES_ATM / XL
      TST  = 0.999
      GM   = SCVEFF / 100.0
      ACT1 = 1.0
      ACT2 = 1.0
      GM2  = 1.0
      TIMEW = 0.0
      RECIPAP1 = 1.0 / PRES_ATM
c
c========================= DDM Begin ===================================
c
      CALL DDMRADUNIT (0,PRES_ATM_OVER_XL)
c
c========================== DDM End ====================================
c
c---  set equilibrium constants as a function of temperature
c     Henry's law constants

      SO2H  = HLCONST( 'SO2             ', TEMP )
      CO2H  = HLCONST( 'CO2             ', TEMP )
      NH3H  = HLCONST( 'NH3             ', TEMP )
      H2O2H = HLCONST( 'H2O2            ', TEMP )
      O3H   = HLCONST( 'O3              ', TEMP )
      HNO3H = HLCONST( 'HNO3            ', TEMP )
      MHPH  = HLCONST( 'METHYLHYDROPEROX', TEMP )
      PAAH  = HLCONST( 'PEROXYACETIC_ACI', TEMP )
      FOAH  = HLCONST( 'FORMIC_ACID     ', TEMP )

      GLYH  = HLCONST( 'GLYOXAL         ', TEMP )
      MGLYH = HLCONST( 'METHYL_GLYOXAL  ', TEMP )
      GLYDH = HLCONST( 'GLYCOLALDEHYDE  ', TEMP )
      HOH   = HLCONST( 'OH              ', TEMP )

c---  dissociation constants

      FOA1 = 1.71E-4

c---  From ERT book

      SK6 = 10.0**( 1180.0 * ONE_OVER_TEMP - 5.95 )

c---  From Maahs <1982>

      SO21 = 10.0**( 853.0 * ONE_OVER_TEMP ) / 5.495E4
      SO22 = 10.0**( 621.9 * ONE_OVER_TEMP ) / 1.897E9

c---  From Edwards et al. <1978>

      LGTEMP = ALOG( TEMP )

      CO21 = 
     &  10.0**( -5251.5 * ONE_OVER_TEMP - 15.94   * LGTEMP + 102.269 )
      CO22 =
     &   10.0**( -5401.4 * ONE_OVER_TEMP - 15.4096 * LGTEMP + 95.574 )
      H2OW =
     &   10.0**( -5839.5 * ONE_OVER_TEMP - 9.7618  * LGTEMP + 61.206 )

c---  From Morgan and Maas <1931>

      NH31 = 10.0**( -189.1 * ONE_OVER_TEMP - 4.117 )

c---  Schwartz and White <1981, 1983>

      HNO31 = 15.4

c---  Kinetic oxidation rates
c     From Jacobson  (1997)

      RH2O2 = 7.45E+07 * EXP( -15.96 * ( ( 298.0 / TEMP )  - 1.0 ) )

c     From Jacobson, 1997

      RMHP = 1.90E+07 * EXP( -12.75 * ( ( 298.0 / TEMP )  - 1.0 ) )
      RPAA = 3.60E+07 * EXP( -13.42 * ( ( 298.0 / TEMP )  - 1.0 ) )


c---  Aqueous-phase reaction rates of GLY, MGLY and GLYD with OH
      RGLY3  = 1.1E+09   ! Lim et al. 2013
      RMGLY3 = 7.0E+08   ! Lim et al. 2013
      RGLYD3 = 5.0E+08   ! Warneck et al. 2003

c---  Molar yields of aqueous SOA (assume oxalic acid)
c     Yields for GLY and MGLY are from Lim et al., 2013
c     Yield for GLYD is from Ortiz-Montalvo et al., 2012

c---  Also correct for molecular weight difference of oxalic acid (90.) and BOA0
      YGLY  = 0.77*90./mwboa0
      YMGLY = 0.62*90./mwboa0
      YGLYD = 0.67*90./mwboa0

c---  make initializations

      DO IOX = 0, NUMOX
        DSIVDT( IOX ) = 0.0
        DTW   ( IOX ) = 0.0
        DS4   ( IOX ) = 0.0
      END DO

      DGLY1  = 0.0
      DGLYD1 = 0.0
      DMGLY1 = 0.0
      DORGC  = 0.0
      FHNO3   = 1.0
      TOTNIT = GAS( LHNO3 ) + AEROSOL( LNO3 )
      IF ( TOTNIT .GT. 0.0 ) FHNO3   = GAS( LHNO3 ) / TOTNIT
      FNH3    = 1.0
      TOTAMM = GAS( LNH3 ) + AEROSOL( LNH4 )
      IF ( TOTAMM .GT. 0.0 ) FNH3    = GAS( LNH3 ) / TOTAMM

c---  initial concentration from accumulation-mode aerosol loading (mol/liter)
c     an assumption is made that all of the accumulation-mode
c     aerosol mass in incorporated into the cloud droplets

      TS6ACCA = ( AEROSOL( LSO4 )
     &        +   GAS    ( LH2SO4  ) ) * PRES_ATM_OVER_XL
      NO3ACCA =   AEROSOL( LNO3 )   * PRES_ATM_OVER_XL
      NH4ACCA =   AEROSOL( LNH4 )   * PRES_ATM_OVER_XL

c---  initial concentration from coarse-mode aerosol loading (mol/liter)
c     an assumption is made that all of the coarse-mode
c     aerosol mass in incorporated into the cloud droplets

      CLA     = ( AEROSOL( LNACL   )
     &        +   AEROSOL( LKCL    ) ) * PRES_ATM_OVER_XL
      CAA     =   AEROSOL( LCACO3  )   * PRES_ATM_OVER_XL
      MGA     =   AEROSOL( LMGCO3  )   * PRES_ATM_OVER_XL
      NAA     =   AEROSOL( LNACL   )   * PRES_ATM_OVER_XL
      KA      =   AEROSOL( LKCL    )   * PRES_ATM_OVER_XL
      FEA     =   AEROSOL( LA3FE   )   * PRES_ATM_OVER_XL
      MNA     =   AEROSOL( LB2MN   )   * PRES_ATM_OVER_XL
      CO3A    = ( AEROSOL( LCACO3  )
     &        +   AEROSOL( LMGCO3  ) ) * PRES_ATM_OVER_XL
      ORGCA   =   AEROSOL( LORGC ) * PRES_ATM_OVER_XL

c---  set constant factors that will be used in later multiplications (moles/atm)

      XLH2O2  = H2O2H * XL
      XLO3    = O3H   * XL
      XLMHP   = MHPH  * XL
      XLPAA   = PAAH  * XL
      XLSO2   = SO2H  * XL
      XLNH3   = NH3H  * XL
      XLHNO3  = HNO3H * XL
      XLCO2   = CO2H  * XL

      SO212   = SO21  * SO22
      SO21H   = SO21  * SO2H
      SO212H  = SO212 * SO2H
      CO212   = CO21  * CO22
      CO21H   = CO21  * CO2H
      CO212H  = CO22  * CO21H
      NH3DH20 = NH31  / H2OW
      NH31HDH = NH3H  * NH3DH20
      FOA1H   = FOA1  * FOAH
      HNO31H  = HNO31 * HNO3H

c---  If kinetic calculations are made, return to this point

      I20C = 0
20    CONTINUE  !  Time step loop

      I20C = I20C + 1
      IF ( I20C .GE. 1000 ) THEN
         write(iout,'(/,A)') 'Error in RADM aqueous chemistry (RAQCHEM)'
         write(iout,'(A)') 'EXCESSIVE LOOPING AT I20C'
         GO TO 999
      END IF

c---  Initial gas phase partial pressures (atm)
c     = initial partial pressure - amount deposited partial pressure

      PSO20  = GAS( LSO2  ) * PRES_ATM
     &       + DS4( 0 ) * XL
      PNH30  = GAS( LNH3  ) * PRES_ATM
     &       + ( NH4ACCA ) * XL
      PHNO30 = ( GAS( LHNO3 ) + 2.0 * GAS( LN2O5 ) ) * PRES_ATM
     &       + ( NO3ACCA ) * XL
      PH2O20 = GAS( LH2O2 ) * PRES_ATM 
      PO30   = GAS( LO3   ) * PRES_ATM 
      PFOA0  = GAS( LFOA  ) * PRES_ATM
      PMHP0  = GAS( LMHP  ) * PRES_ATM
      PPAA0  = GAS( LPAA  ) * PRES_ATM
      PCO20  = GAS( LCO2  ) * PRES_ATM
     &       + CO3A * XL

      PGLY0  = GAS( LGLY  ) * PRES_ATM
      PGLYD0 = GAS( LGLYD ) * PRES_ATM
      PMGLY0 = GAS( LMGLY ) * PRES_ATM
      PHO0   = GAS( LHO ) * PRES_ATM

c---  don't allow gas concentrations to go below zero

      PSO20  = MAX( PSO20,  0.0 )
      PNH30  = MAX( PNH30,  0.0 )
      PH2O20 = MAX( PH2O20, 0.0 )
      PO30   = MAX( PO30,   0.0 )
      PFOA0  = MAX( PFOA0,  0.0 )
      PMHP0  = MAX( PMHP0,  0.0 )
      PPAA0  = MAX( PPAA0,  0.0 )
      PCO20  = MAX( PCO20,  0.0 )
      PHNO30 = MAX( PHNO30, 0.0 )


      PGLY0  = MAX( PGLY0,  0.0 ) 
      PGLYD0 = MAX( PGLYD0, 0.0 ) 
      PMGLY0 = MAX( PMGLY0, 0.0 ) 
      PHO0   = MAX( PHO0,   0.0 ) 

c---  Molar concentrations of soluble aerosols (mol/liter)

      TS6     = TS6ACCA - DS4( 0 )

      ORGC    = ORGCA + DORGC

      CL      = CLA
      CA      = CAA
      MG      = MGA
      NA      = NAA
      K       = KA
      FE      = FEA
      MN      = MNA
      A       = 3.0 * FE
      B       = 2.0 * MN

c---  don't allow aerosol concentrations to go below zero

      TS6     = MAX( TS6,     0.0 )
      ORGC    = MAX( ORGC,    0.0 )
      CL      = MAX( CL,      0.0 )
      CA      = MAX( CA,      0.0 )
      MG      = MAX( MG,      0.0 )
      NA      = MAX( NA,      0.0 )
      K       = MAX( K,       0.0 )
      FE      = MAX( FE,      0.0 )
      MN      = MAX( MN,      0.0 )

      SK6TS6 = SK6 * TS6

c---  Solve the pH equation using a method of reiterative
c     bisections with initial guess range of 0.01 to 10.

      HA =  0.01
      HB = 10.0

      I7777C = 0
7777  CONTINUE  !  activity cenvergence loop (depends on nested pH iteration)

      I7777C = I7777C + 1
      IF ( I7777C .EQ. 50 ) THEN  !  escape from slow activity/pH convergence
         write(idiag,'(/,A)') 'HIGH LOOPING AT I7777C in RAQCHEM'
         write(idiag,'(a,4i5,f8.3)') 
     &         'Grid, icell, jcell, kcell, convergence:', 
     &                              igrd, iaq, jaq, kaq, TAC
         GO TO 7778
      END IF

      HA = MAX( HA - 0.8, PHMIN )
      HB = MIN( HB + 0.8, PHMAX )
      AE = 10.0**( -HA )

      RECIPA1 = 1.0 / ( AE * ACT1 )
      RECIPA2 = 1.0 / ( AE * AE * ACT2 )

c---  calculate final gas phase partial pressure of SO2, NH3, HNO3
c     HCOOH, and CO2 (atm)

      PSO2F = PSO20 / ( 1.0 + XLSO2 * ( 1.0 + SO21 * RECIPA1
     &      + SO212 * RECIPA2 ) )

      PNH3F = PNH30 / ( 1.0 + XLNH3 * ( 1.0 + NH3DH20 * AE ) )

      PFOAF = PFOA0 / ( 1.0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

      PHNO3F = PHNO30 / ( 1.0 + XLHNO3 * ( 1.0 + HNO31 * RECIPA1 ) )

      PCO2F = PCO20 / ( 1.0 + XLCO2 * ( 1.0 + CO21 * RECIPA1
     &      + CO212 * RECIPA2 ) )

c---  calculate liquid phase concentrations (moles/liter)

      SO4  = SK6TS6 / ( AE * GM2 + SK6 )
      HSO4 = TS6 - SO4
      SO3  = SO212H  * PSO2F  * RECIPA2
      HSO3 = SO21H   * PSO2F  * RECIPA1
      CO3  = CO212H  * PCO2F  * RECIPA2
      HCO3 = CO21H   * PCO2F  * RECIPA1
      OH   = H2OW    * RECIPA1
      NH4  = NH31HDH * PNH3F  * AE
      HCO2 = FOA1H   * PFOAF  * RECIPA1
      NO3  = HNO31H  * PHNO3F * RECIPA1

c---  compute functional value

      FA = AE + NH4 + 2.0 *  (CA + MG - CO3 - SO3 - SO4 ) - OH - HCO3
     &   - HSO3 - NO3 - HSO4 - HCO2

c---  Start iteration and bisection ****************<<<<<<<

      I30C = 0
30    CONTINUE  !  pH iteration loop

      I30C = I30C + 1
      IF ( I30C .GE. 1000 ) THEN
         write(iout,'(/,A)') 'Error in RADM aqueous chemistry (RAQCHEM)'
         write(iout,'(A)') 'EXCESSIVE LOOPING AT I30C'
         GO TO 999
      END IF

cpk   perform bisection on H+
      BB = ( HA + HB ) / 2.0
      AE = 10.0**( -BB )

      ICNTAQ = ICNTAQ + 1
      IF ( ICNTAQ .GE. 3000 ) THEN  !  abort on slow convergence accumulated over time steps
         write(iout,'(/,A)') 'Error in RADM aqueous chemistry (RAQCHEM)'
         write(iout,'(A)') 'EXCESSIVE LOOPING AT I3000C'
         GO TO 999
      END IF

      RECIPA1 = 1.0 / ( AE * ACT1 )
      RECIPA2 = 1.0 / ( AE * AE * ACT2 )

c---  calculate final gas phase partial pressure of SO2, NH3, HNO3
c     HCOOH, and CO2 (atm)

      PSO2F = PSO20 / ( 1.0 + XLSO2
     &      * ( 1.0 + SO21 * RECIPA1 + SO212 * RECIPA2 ) )

      PNH3F = PNH30 / ( 1.0 + XLNH3 * ( 1.0 + NH3DH20 * AE ) )

      PHNO3F = PHNO30 / ( 1.0 + XLHNO3 * ( 1.0 + HNO31 * RECIPA1 ) )

      PFOAF = PFOA0 / ( 1.0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

      PCO2F = PCO20 / ( 1.0 + XLCO2 * ( 1.0 + CO21 * RECIPA1
     &      + CO212 * RECIPA2 ) )

c---  calculate liquid phase concentrations (moles/liter)

      SO4  = SK6TS6 / ( AE * GM2 + SK6 )
      HSO4 = TS6 - SO4
      SO3  = SO212H  * PSO2F  * RECIPA2
      HSO3 = SO21H   * PSO2F  * RECIPA1
      CO3  = CO212H  * PCO2F  * RECIPA2
      HCO3 = CO21H   * PCO2F  * RECIPA1
      OH   = H2OW    * RECIPA1
      NH4  = NH31HDH * PNH3F  * AE
      HCO2 = FOA1H   * PFOAF  * RECIPA1
      NO3  = HNO31H  * PHNO3F * RECIPA1

c---  compute functional value

      FB = AE + NH4 + 2.0 * ( CA + MG - CO3 - SO3 - SO4 ) - OH - HCO3
     &   - HSO3 - NO3 - HSO4 - HCO2

c---  Calculate and check the sign of the product of the two functional values

      FTST = FA * FB
      IF ( FTST .LE. 0.0 ) THEN
        HB = BB
      ELSE
        HA = BB
        FA = FB
      END IF

c---  Check for pH convergence and iterate if not converged

      HTST = HA / HB
      IF ( HTST .LE. TST ) GO TO 30

c---  compute Ionic strength and activity coefficient by the Davies equation
c     bound ionic strenth to be within Davies equation applicability

      ACTB = ACT1
      STION = 0.5 * (AE + NH4 + OH + HCO3 + HSO3
     &      + 4.0 * (SO4 + CO3 + SO3 + CA + MG + MN)
     &      + NO3 + HSO4 + 9.0 * FE + NA + K + CL + A + B + HCO2)
      STION = MIN( MAX( STION, ISMIN ), ISMAX )
      GM1LOG = -0.509 * ( SQRT( STION )
     &       / ( 1.0 + SQRT( STION ) ) - 0.2 * STION )
      GM2LOG = GM1LOG * 4.0
      GM1  = 10.0**GM1LOG
      GM2  = MAX( 10.0**GM2LOG, ISMIN )
      ACT1 = MAX( GM1 * GM1, ISMIN )
      ACT2 = MAX( GM1 * GM1 * GM2, ISMIN )

c---  check for activity convergence and iterate if not converged

      TAC = ABS( ACTB - ACT1 ) / ACTB
      IF ( TAC .GE. 1.0E-2 ) GO TO 7777

c---  return an error if the pH is not in range

7778  CONTINUE
      IF ( ( HA .LT. PHMIN ) .OR. ( HA .GT. PHMAX ) ) THEN
         write(iout,'(/,A)') 'Error in RADM aqueous chemistry (RAQCHEM)'
         write(iout,'(A,f5.1)') 'PH VALUE OUT OF RANGE: ', ha
         GO TO 999
      END IF

c---  Make those concentration calculations which can be made outside
c     of the function.

      SO2L = SO2H * PSO2F
      AC = 10.0**( -BB )
      SIV = SO3 + HSO3 + SO2L

c---  Calculate final gas phase concentrations of oxidants (atm)

      PH2O2F = ( PH2O20 + XL * DS4( 1 ) ) / ( 1.0 + XLH2O2 )
      PO3F   = ( PO30   + XL * DS4( 2 ) ) / ( 1.0 + XLO3   )
      PMHPF  = ( PMHP0  + XL * DS4( 4 ) ) / ( 1.0 + XLMHP  )
      PPAAF  = ( PPAA0  + XL * DS4( 5 ) ) / ( 1.0 + XLPAA  )

      PGLYF  = ( PGLY0  + XL * DGLY1    ) / ( 1.0 + GLYH * XL )
      PMGLYF = ( PMGLY0 + XL * DMGLY1   ) / ( 1.0 + MGLYH * XL )
      PGLYDF = ( PGLYD0 + XL * DGLYD1   ) / ( 1.0 + GLYDH * XL )
      PHOF   = ( PHO0                   ) / ( 1.0 + HOH * XL)

      PH2O2F = MAX( PH2O2F, 0.0 )
      PO3F   = MAX( PO3F,   0.0 )
      PMHPF  = MAX( PMHPF,  0.0 )
      PPAAF  = MAX( PPAAF,  0.0 )

      PGLYF  = MAX( PGLYF,  0.0 )
      PMGLYF = MAX( PMGLYF, 0.0 )
      PGLYDF = MAX( PGLYDF, 0.0 )

c---  Calculate liquid phase concentrations of oxidants (moles/liter)

      H2O2L = PH2O2F * H2O2H
      O3L   = PO3F   * O3H
      MHPL  = PMHPF  * MHPH
      PAAL  = PPAAF  * PAAH
      FOAL  = PFOAF  * FOAH
      NH3L  = PNH3F  * NH3H
      CO2L  = PCO2F  * CO2H
      HNO3L = PHNO3F * HNO3H

      GLYL  = PGLYF  * GLYH
      MGLYL = PMGLYF * MGLYH
      GLYDL = PGLYDF * GLYDH
      OHL   = PHOF   * HOH

c---  load the liquid concentration array with current values

      LIQUID(  1 ) = AC
      LIQUID(  2 ) = NH4
      LIQUID(  3 ) = CA
      LIQUID(  4 ) = NA
      LIQUID(  5 ) = OH
      LIQUID(  6 ) = SO4
      LIQUID(  7 ) = HSO4
      LIQUID(  8 ) = SO3
      LIQUID(  9 ) = HSO3
      LIQUID( 10 ) = SO2L
      LIQUID( 11 ) = CO3
      LIQUID( 12 ) = HCO3
      LIQUID( 13 ) = CO2L
      LIQUID( 14 ) = NO3
      LIQUID( 15 ) = NH3L
      LIQUID( 16 ) = CL
      LIQUID( 17 ) = H2O2L
      LIQUID( 18 ) = O3L
      LIQUID( 19 ) = FE
      LIQUID( 20 ) = MN
      LIQUID( 21 ) = A
      LIQUID( 22 ) = FOAL
      LIQUID( 23 ) = HCO2
      LIQUID( 24 ) = MHPL
      LIQUID( 25 ) = PAAL
      LIQUID( 26 ) = 0.0
c      LIQUID( 27 ) = ORGN
c      LIQUID( 28 ) = PRIM
      LIQUID( 29 ) = MG
      LIQUID( 30 ) = K
      LIQUID( 31 ) = B
      LIQUID( 32 ) = HNO3L
c      LIQUID( 33 ) = PRIMCOR

      LIQUID( 34 ) = GLYL
      LIQUID( 35 ) = MGLYL
      LIQUID( 36 ) = GLYDL
      LIQUID( 37 ) = OHL

c
c========================= DDM Begin ===================================
c
      CALL DDMRADEQL (NLIQS,LIQUID,STION,GM1,GM2,
     &                XLNH3,XLHNO3,FOAH*XL,XLCO2,XLSO2,
     &                XLH2O2,XLO3,XLMHP,XLPAA,
     &                GLYH*XL,MGLYH*XL,GLYDH*XL,HOH*XL,IOUT)
c
c========================== DDM End ====================================
c
c---  if the maximum cloud lifetime has not been reached, the compute
c     the next timestep.

      IF ( TIMEW .LT. TAUCLD ) THEN

c---  make kinetics calculations
c     note: DS4(i) and DSIV(I) are negative numbers!

        DTRMV = 300.0
        ITERAT = ITERAT + 1

c---  Define the total S(iv) or H2O2 available for oxidation

        TSIV = PSO20 * ONE_OVER_XL
        TH2O2 = PH2O20 * ONE_OVER_XL

c---  Calculate sulfur iv oxidation rate due to H2O2 (Jacobson, 1997)

        DSIVDT( 1 ) = -RH2O2 * H2O2L * HSO3 * AC / ( 1.0D0 + 13.0 * AC )

        IF ( ( DSIVDT( 1 ) .EQ. 0.0 ) .OR. 
     &       ( TSIV .LE. CONMIN ) .OR.
     &       ( TH2O2 .LE. CONMIN ) ) THEN
          DTW(1) = DTRMV
        ELSE
          DTW( 1 ) = -0.05 * MIN( TH2O2, TSIV ) / DSIVDT( 1 )
        END IF

c---  Calculate sulfur iv oxidation rate due to O3 (Jacobson, 1997)

        RO3A = 2.4E4
        RO3B = 3.7E5 * EXP( -18.56 * ( ( 298.0 / TEMP ) - 1.0 ) )
        RO3C = 1.5E9 * EXP( -17.72 * ( ( 298.0 / TEMP ) - 1.0 ) )
        DSIVDT( 2 ) = -( RO3A * SO2L +
     &                   RO3B * HSO3 +
     &                   RO3C * SO3 ) * O3L
        TO3 = PO30 * ONE_OVER_XL

        IF ( ( DSIVDT( 2 ) .EQ. 0.0 ) .OR.
     &       ( TSIV .LE. CONMIN ) .OR.
     &       ( TO3 .LE. CONMIN ) ) THEN
          DTW( 2 ) = DTRMV
        ELSE
          DTW( 2 ) = -0.01 * MIN( TO3, TSIV ) / DSIVDT( 2 )
        END IF

c---  Calculate sulfur iv oxidation rate due to O2 catalyzed by Mn++ and Fe+++
c     (Martin and Good, 1991)
c     Implement sulfate inhibition based on Martin and Good, 1991

cpk, RE, September 2016: Martin and Good for Fe only and Mn only terms
        DSIVDT( 3 ) = - ( 750.0  * MN * SIV + 
     &                    2600.0 * FE * SIV ) 
cpk, RE, September 2016: use IT87 rate expression for synergistic term
        IF ( BB >= 4.2 )  THEN  ! 4.2  <= ph
           DSIVDT( 3 ) = DSIVDT( 3 ) - ( 2.51E13 * MN * FE * SIV ) * ( AC ** 0.67)
        ELSE
           DSIVDT( 3 ) = DSIVDT( 3 ) - ( 3.72E7 * MN * FE * SIV ) / ( AC ** 0.74)
        END IF
cpk, RE, September 2016: Apply MG91 correction for sulfate inhibition
        DSIVDT( 3 ) = DSIVDT( 3 ) / ( 1. + 75.0 * ( TS6 ** 0.67 ) )

        IF ( ( DSIVDT( 3 ) .EQ. 0.0 ) .OR. ( TSIV .LE. CONMIN ) ) THEN
          DTW( 3 ) = DTRMV
        ELSE
          DTW( 3 ) = -0.1 * TSIV / DSIVDT( 3 )
        END IF

c---  Calculate sulfur oxidation rate due to MHP (Jacobson, 1997)

        DSIVDT( 4 ) = -RMHP * AC * MHPL * HSO3
        TMHP = PMHP0 * ONE_OVER_XL
        IF ( ( DSIVDT( 4 ) .EQ. 0.0 ) .OR.
     &       ( TSIV .LE. CONMIN ) .OR.
     &       ( TMHP .LE. CONMIN ) ) THEN
          DTW( 4 ) = DTRMV
        ELSE
          DTW( 4 ) = -0.1 * MIN( TMHP, TSIV ) / DSIVDT( 4 )
        END IF

c---  Calculate sulfur oxidation due to PAA (Jacobson, 1997)

        DSIVDT( 5 ) = -( RPAA * AC + 7.00E2 ) * HSO3 * PAAL
        TPAA = PPAA0 * ONE_OVER_XL

        IF ( ( DSIVDT( 5 ) .EQ. 0.0 ) .OR.
     &       ( TSIV .LE. CONMIN ) .OR.
     &       ( TPAA .LE. CONMIN ) ) THEN
          DTW( 5 ) = DTRMV
        ELSE
          DTW( 5 ) = -0.1 * MIN( TPAA, TSIV ) / DSIVDT( 5 )
        END IF

c---  Calculate total sulfur iv oxidation rate

        DSIVDT( 0 ) = 0.0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

c---  Calculate a minimum time step required

        DTW( 0 ) = MIN( DTW( 1 ), DTW( 2 ), DTW( 3 ),
     &                  DTW( 4 ), DTW( 5 ) )

c---  check for large time step

        IF ( DTW( 0 ) .GT. 1.0E+18 ) THEN
          write(iout,'(/,A)') 
     &          'Warning in RADM aqueous chemistry (AQCHEM)'
          WRITE(iout,1001) 
     &          DSIVDT(0), TS6, DTW(0)
        ELSE

c---  CALCULATE IN-CLOUD SOA PRODUCTION
c     Reference:  Carlton, A.G., B.J. Turpin, K.E. Altieri, A. Reff,
c     S. Seitzinger, H.J. Lim, and B. Ervens (2007), Atmospheric Oxalic
c     Acid and SOA Production from Glyoxal: Results of Aqueous
c     Photooxidation Experiments, Atmos. Environ., 41(35), 7588-7602.

c---  Define the total glyoxal available for oxidation

          TGLY = PGLY0 * ONE_OVER_XL

c---  Calculate GLY oxidation due to OH

          DGLYDT = -RGLY3 * GLYL * OHL

c---  Define the total methylglyoxal available for oxidation

          TMGLY = PMGLY0 * ONE_OVER_XL

c---  Calculate MGLY oxidation due to OH

          DMGLYDT = -RMGLY3 * MGLYL * OHL
						
c---  Define the total glycolaldehyde available for oxidation

          TGLYD = PGLYD0 * ONE_OVER_XL

c---  Calculate GLYD oxidation due to OH

          DGLYDDT = -RGLYD3 * GLYDL * OHL
c---  calculate the change in sulfur iv for this time step

60        CONTINUE  ! return here if time step lengthened
          DTS6 = ABS( DTW( 0 ) * DSIVDT( 0 ) )

c---  If DSIV(0), sulfur iv oxidized during this time step would be
c     less than 5% of sulfur oxidized since time 0, then double DT

          IF ( DTW( 0 ) .LE. TAUCLD ) THEN
            IF ( DTS6 .LT. -0.05 * DS4( 0 ) ) THEN ! bkoo corrected sign to negative (09/15/2008)
              DTW( 0 ) = DTW( 0 ) * 2.0
              GO TO 60
            END IF
          END IF
        END IF
        DTW( 0 ) = MIN( DTW( 0 ), DTRMV )

c---  Set DTW( 0 ) to avoid overshooting - bkoo (09/16/2005)
        IF ( DSIVDT(0) .LT. 0.0 ) THEN
          DTW( 0 ) = MIN( DTW( 0 ), -TSIV*1.00001/DSIVDT(0) )
        ENDIF

c---  If the total time after this time increment will be greater than
c     TAUCLD sec., then set DTW(0) so that total time will be TAUCLD

        IF ( TIMEW + DTW( 0 ) .GT. TAUCLD ) DTW( 0 ) = TAUCLD - TIMEW
        IF ( TS6 .LT. 1.0E-11 ) DTW( 0 ) = TAUCLD - TIMEW
        IF ( ITERAT .GT. 100 ) then
          write(idiag,'(a,4i4,2f7.1)') 
     &    'AQCHEM: iterat > 100:', igrd, iaq, jaq, kaq, timew, taucld
          DTW( 0 ) = TAUCLD - TIMEW
        endif

cpk
c---  force mass balance for the specified timestep
c     for GLY, MGLY and GLYD, assume that OH is in steady state

        DGLYDT  = MAX( DGLYDT,  -TGLY  / DTW( 0 ) )
        DMGLYDT = MAX( DMGLYDT, -TMGLY / DTW( 0 ) )
        DGLYDDT  =MAX( DGLYDDT, -TGLYD / DTW( 0 ) )

c---  for S(IV), also limit by oxidants (except assume O2 in steady state)

        DSIVDT( 1 ) = MAX( DSIVDT( 1 ), -MIN( TSIV, TH2O2 ) / DTW( 0 ) )
        DSIVDT( 2 ) = MAX( DSIVDT( 2 ), -MIN( TSIV, TO3   ) / DTW( 0 ) )
        DSIVDT( 3 ) = MAX( DSIVDT( 3 ), -TSIV / DTW( 0 ) )
        DSIVDT( 4 ) = MAX( DSIVDT( 4 ), -MIN( TSIV, TMHP  ) / DTW( 0 ) )
        DSIVDT( 5 ) = MAX( DSIVDT( 5 ), -MIN( TSIV, TPAA  ) / DTW( 0 ) )

c---  recalculate the total S(iv) oxidation rate

        DSIVDT( 0 ) = 0.0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

c---  if the total S(iv) oxidation rate over the timestep exceeds the amount of
c     S(iv) available then scale the rates to conserve mass

        DSIV_SCALE = 1.0
        IF ( -DSIVDT( 0 ) * DTW( 0 ) .GT. TSIV ) THEN
          DSIV_SCALE = TSIV / ( -DSIVDT( 0 ) * DTW( 0 ) )
          DSIVDT( 0 ) = DSIVDT( 0 ) * DSIV_SCALE
          DSIVDT( 1 ) = DSIVDT( 1 ) * DSIV_SCALE
          DSIVDT( 2 ) = DSIVDT( 2 ) * DSIV_SCALE
          DSIVDT( 3 ) = DSIVDT( 3 ) * DSIV_SCALE
          DSIVDT( 4 ) = DSIVDT( 4 ) * DSIV_SCALE
          DSIVDT( 5 ) = DSIVDT( 5 ) * DSIV_SCALE
        END IF
c---  Set DSIV(I), I = 0,NUMOX, the amount of S(IV) oxidized by each
c     individual oxidizing agent, as well as the total.

        DO IOX = 0, NUMOX
          DS4( IOX ) = DS4( IOX ) + DTW( 0 ) * DSIVDT( IOX )
        END DO

        DGLY1  = DGLY1  + DTW( 0 ) * DGLYDT

        DMGLY1 = DMGLY1 + DTW( 0 ) * DMGLYDT

        DGLYD1 = DGLYD1 + DTW( 0 ) * DGLYDDT

c---  Calculate AORGC Production:

        DORGC = DORGC - ( ( YGLY*DGLYDT + YMGLY*DMGLYDT + YGLYD*DGLYDDT ) * DTW( 0 ) )

c
c========================= DDM Begin ===================================
c
        CALL DDMRADRXN (BB,SIV,TS6,MN,FE,
     &                  RH2O2,RO3A,RO3B,RO3C,RMHP,RPAA,
     &                  RGLY3,RMGLY3,RGLYD3,
     &                  YGLY,YMGLY,YGLYD,
     &                  DSIV_SCALE,DTW(0),IOUT)
c
c========================== DDM End ====================================
c
        TIMEW = TIMEW + DTW( 0 )

c---  Return to make additional time steps

        GO TO 20
      END IF

c
c========================= DDM Begin ===================================
c
      CALL DDMRADUNIT (1,PRES_ATM_OVER_XL)
c
c========================== DDM End ====================================
c
c---  At this point, TIMEW=TAUCLD
c     Compute the output concentrations and wetdeposition amounts

      TOTAMM = ( PNH3F  + ( NH4 + NH3L  ) * XL ) * RECIPAP1
      TOTNIT = ( PHNO3F + ( NO3 + HNO3L ) * XL ) * RECIPAP1

c---  gas concentrations (mol/molV)

      GAS( LSO2   ) = ( PSO2F   + XL *  SIV )   * RECIPAP1
      GAS( LNH3   ) = FNH3 * TOTAMM
      GAS( LH2O2  ) = ( PH2O2F  + XL *  H2O2L ) * RECIPAP1
      GAS( LO3    ) = ( PO3F    + XL *  O3L )   * RECIPAP1
      GAS( LCO2   ) = ( PCO2F   + XL *  CO2L )  * RECIPAP1
      GAS( LFOA   ) = ( PFOAF   + XL * ( FOAL
     &              +  HCO2 ) ) * RECIPAP1
      GAS( LMHP   ) = ( PMHPF   + XL *  MHPL )  * RECIPAP1
      GAS( LPAA   ) = ( PPAAF   + XL *  PAAL )  * RECIPAP1

      GAS( LGLY   ) = ( PGLYF  + XL *  GLYL )  * RECIPAP1
      GAS( LMGLY  ) = ( PMGLYF + XL *  MGLYL)  * RECIPAP1
      GAS( LGLYD  ) = ( PGLYDF + XL *  GLYDL)  * RECIPAP1

      GAS( LHNO3  ) = FHNO3 * TOTNIT
      GAS( LN2O5  ) = 0.0 ! assume all into aerosol
      GAS( LH2SO4 ) = 0.0 ! assume all into aerosol

c---  aerosol concentrations (mol/molV)

      AEROSOL( LSO4    ) = TS6    * XL * RECIPAP1
      AEROSOL( LNH4    ) = TOTAMM * (1.0 - FNH3)
      AEROSOL( LNO3    ) = TOTNIT * (1.0 - FHNO3)
      AEROSOL( LNACL   ) = NA     * XL * RECIPAP1
      AEROSOL( LA3FE   ) = FE     * XL * RECIPAP1
      AEROSOL( LB2MN   ) = MN     * XL * RECIPAP1
      AEROSOL( LCACO3  ) = CA     * XL * RECIPAP1
      AEROSOL( LMGCO3  ) = MG     * XL * RECIPAP1
      AEROSOL( LKCL    ) = K      * XL * RECIPAP1

      AEROSOL( LORGC   ) = ORGC   * XL * RECIPAP1

      RETURN

c---  diagnostic output before stopping for non-convergence

999   continue
      write(iout,'(//,a,4i5)') 
     &         'Grid, icell, jcell, kcell:', igrd, iaq, jaq, kaq

      write(iout,'(a,3i5)') 'Iterations pH, activity, combined:',
     &          I30C, I7777C, ICNTAQ 
      write(iout,'(a,2E12.4)') 'activity now, previous:', ACT1, ACTB
      write(iout,'(a,2E12.4)') 'pH now, previous      :', HA, HB

      write(iout,'(/,a)') 'gas concentrations (mol/mol)'
      write(iout,'(a,E10.4)') 'SO2   ',GAS( LSO2   )
      write(iout,'(a,E10.4)') 'NH3   ',GAS( LNH3   )
      write(iout,'(a,E10.4)') 'H2O2  ',GAS( LH2O2  )
      write(iout,'(a,E10.4)') 'O3    ',GAS( LO3    )
      write(iout,'(a,E10.4)') 'CO2   ',GAS( LCO2   )
      write(iout,'(a,E10.4)') 'FACD  ',GAS( LFOA   )
      write(iout,'(a,E10.4)') 'MEPX  ',GAS( LMHP   )
      write(iout,'(a,E10.4)') 'PAA   ',GAS( LPAA   )
      write(iout,'(a,E10.4)') 'GLY   ',GAS( LGLY   )
      write(iout,'(a,E10.4)') 'MGLY  ',GAS( LMGLY  )
      write(iout,'(a,E10.4)') 'GLYD  ',GAS( LGLYD  )
      write(iout,'(a,E10.4)') 'HNO3  ',GAS( LHNO3  )
      write(iout,'(a,E10.4)') 'N2O5  ',GAS( LN2O5  )
      write(iout,'(a,E10.4)') 'H2SO4 ',GAS( LH2SO4 )

      write(iout,'(/,a)') 'aerosol concentrations (mol/mol)'
      write(iout,'(a,E10.4)') 'SO4   ', AEROSOL( LSO4    ) 
      write(iout,'(a,E10.4)') 'NH4   ', AEROSOL( LNH4    )
      write(iout,'(a,E10.4)') 'NO3   ', AEROSOL( LNO3    )
      write(iout,'(a,E10.4)') 'NA    ', AEROSOL( LNACL   )
      write(iout,'(a,E10.4)') 'FE    ', AEROSOL( LA3FE   )
      write(iout,'(a,E10.4)') 'MN    ', AEROSOL( LB2MN   )
      write(iout,'(a,E10.4)') 'CA    ', AEROSOL( LCACO3  )
      write(iout,'(a,E10.4)') 'MG    ', AEROSOL( LMGCO3  )
      write(iout,'(a,E10.4)') 'K     ', AEROSOL( LKCL    )

      write(iout,'(/,a,E10.4,a)') 'TEMP  ', TEMP,    ' K'
      write(iout,'(a,E10.4,a)')   'PRES  ', PRES_PA, ' Pa'
      write(iout,'(a,E10.4,a)')   'Tstep ', TAUCLD,  ' s'
      write(iout,'(a,E10.4,a)')   'Tnow  ', TIMEW ,  ' s'
      write(iout,'(a,i5)')        'Nsteps', I20C
      write(iout,'(a,E10.4,a)')   'LWC   ', WCAVG,   ' kg/m3'

      call camxerr()

c---  formats

1001  FORMAT (1X, 'DSIVDT(0) =', F10.5,
     &       'TS6=', F10.5, 'DTW(0)=', F10.5)

      END

c**** NCF_WRT_TOPO
c
      subroutine ncf_wrt_topo(action,igrd,iounit,grid_ncol,grid_nrow,grid_topo)
      use ncf_iomod
      use filunit
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the variable data for the grid definiton 
c    variables to the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action      C name of file to open
c           igrd        I grid number
c           iounit      I NetCDF file ID of file
c           grid_ncol   I number of grid cells in X direction
c           grid_nrow   I number of grid cells in Y direction
c           grid_topo   R height above sea level of cell center
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       igrd
      integer       iounit
      integer       grid_ncol
      integer       grid_nrow
      real          grid_topo(grid_ncol,grid_nrow)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 this_var
      integer       this_varid, icol, irow, ierr, itmp, jtmp
      integer       ibegcel, iendcel, jbegcel, jendcel, buffer_offset
      real,         allocatable, dimension(:,:) :: rarray_2d
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set cell offset for nested grids --
c
      if( igrd .EQ. 1 ) then
         allocate( rarray_2d(grid_ncol,grid_nrow) )
         ibegcel = 1
         iendcel = grid_ncol
         jbegcel = 1
         jendcel = grid_nrow
         buffer_offset = 0
      else
         allocate( rarray_2d(grid_ncol-2,grid_nrow-2) )
         ibegcel = 2
         iendcel = grid_ncol-1
         jbegcel = 2
         jendcel = grid_nrow-1
         buffer_offset = 1
      endif
c
c  --- variable for topo ---
c
      this_var = "topo"
      do icol=ibegcel,iendcel
        itmp = icol-buffer_offset
        do irow=jbegcel,jendcel
           jtmp = irow-buffer_offset
           rarray_2d(itmp,jtmp) = grid_topo(icol,irow)
        enddo
      enddo
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_var_real(iounit,this_varid,rarray_2d)
      if( ierr .NE. NF_NOERR ) goto 7001
      deallocate( rarray_2d )
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_GRID:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot write data for the variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c**** NCF_WRT_GLOBAL
c
      subroutine ncf_wrt_global(action,iounit,nspcs,spcname,is_sample)
      use ncf_iomod
      use grid
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the Global attributes to the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action    C  name of file to open
c           iounit    I  NetCDF file ID of file
c           nspcs     I  numver of species in file
c           spcname   C name of each species
c           is_sample L .TRUE. of this is a sampling grif file
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c     07/23/18   --bkoo--       Added ncf_bidi_nh3_drydep
c     04/28/21   --cemery--     Added ncf_strat_o3_profile
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
      integer       nspcs
      character*(*) spcname(nspcs)
      logical       is_sample
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*80                     ioapi, exec_id
      character*((MXSPEC*4+MXTRSP)*16) string
      character*16                     varname(MXSPEC*4+2*MXTRSP)
      integer                          ierr, i, string_length
c
      data varname(1:NCF_BASE_VARS) 
     &                  /'X               ','Y               ',
     &                   'layer           ','TFLAG           ',
     &                   'ETFLAG          ','longitude       ',
     &                   'latitude        ','topo            ',
     &                   'z               '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'FTYPE', NF_INT,
     &                                                    1, ncf_ftype)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'CDATE', NF_INT,
     &                                                    1, ncf_cdate)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'CTIME', NF_INT,
     &                                                    1, ncf_ctime)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'WDATE', NF_INT,
     &                                                    1, ncf_wdate)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'WTIME', NF_INT,
     &                                                    1, ncf_wtime)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'SDATE', NF_INT,
     &                                                    1, ncf_sdate)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'STIME', NF_INT,
     &                                                    1, ncf_stime)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TSTEP', NF_INT,
     &                                                    1, ncf_tstep)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NTHIK', NF_INT,
     &                                                 1, ncf_nthik)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NCOLS', NF_INT,
     &                                                 1, ncf_ncols)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NROWS', NF_INT,
     &                                                 1, ncf_nrows)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NLAYS', NF_INT,
     &                                                 1, ncf_nlays)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NVARS', NF_INT,
     &                                                 1, ncf_nvars)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'GDTYP', NF_INT,
     &                                                   1, ncf_gdtyp)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'P_ALP', NF_DOUBLE,
     &                                           1, DBLE(ncf_p_alp) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
       ierr = nf_put_att_double(iounit, NF_GLOBAL, 'P_BET', NF_DOUBLE,
     &                                           1, DBLE(ncf_p_bet) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'P_GAM', NF_DOUBLE,
     &                                           1, DBLE(ncf_p_gam) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'XCENT', NF_DOUBLE,
     &                                           1, DBLE(ncf_xcent) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'YCENT', NF_DOUBLE,
     &                                           1, DBLE(ncf_ycent) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'XORIG', NF_DOUBLE, 
     &                                           1, DBLE(ncf_xorig) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'YORIG', NF_DOUBLE,
     &                                           1, DBLE(ncf_yorig) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'XCELL', NF_DOUBLE,
     &                                           1, DBLE(ncf_xcell) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_double(iounit, NF_GLOBAL, 'YCELL', NF_DOUBLE,
     &                                           1, DBLE(ncf_ycell) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'VGTYP', NF_INT,
     &                                                    1, ncf_vgtyp)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_real(iounit, NF_GLOBAL, 'VGTOP', NF_FLOAT, 
     &                                                    1, ncf_vgtop)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'VGLVLS', NF_INT,
     &                                            nlay(1)+1, ncf_vglvls)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'GDNAM',
     &                 istrln(ncf_gdnam), ncf_gdnam(:istrln(ncf_gdnam)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'UPNAM', 
     &                 istrln(ncf_upnam), ncf_upnam(:istrln(ncf_upnam)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'IOAPI_VERSION', 
     &                 istrln(ncf_ioapi_ver), ncf_ioapi_ver(:istrln(ncf_ioapi_ver)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'EXEC_ID', 
     &                 istrln(ncf_execid), ncf_execid(:istrln(ncf_execid)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      varname(1) = 'z               '
      do i=1,nspcs
        call jstlft( spcname(i) )
        varname(i+1) = spcname(i)
      enddo
      string = varname(1)
      string_length = 16
      do i=2,nspcs+1
        string_length = string_length + 16
        string = string(1:(i-1)*16) // TRIM(varname(i))
      enddo
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'VAR-LIST',
     &                              string_length, string(:string_length) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'FILEDESC', 
     &        istrln(ncf_filedesc), ncf_filedesc(:istrln(ncf_filedesc)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'HISTORY', 
     &             istrln(ncf_history), ncf_history(:istrln(ncf_history)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'IUTM', NF_INT,
     &                                                   1, ncf_iutm)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'ISTAG', NF_INT,
     &                                                   1, ncf_istag)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'CPROJ', NF_INT,
     &                                                   1, ncf_cproj)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'NSTEPS', NF_INT,
     &                                                 1, ncf_nsteps)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'CAMx_NAME',
     &                   istrln(ncf_name), ncf_name(:istrln(ncf_name)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'NOTE',
     &                   istrln(ncf_note), ncf_note(:istrln(ncf_note)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'ITZON', NF_INT,
     &                                                    1, ncf_itzon)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'UPDSC', 
     &                 istrln(ncf_upnam), ncf_upnam(:istrln(ncf_upnam)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'GRID_ID', NF_INT,
     &                                                    1, ncf_grid_id)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'I_GRID_START', NF_INT,
     &                                            1, ncf_i_grid_start)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'I_GRID_END', NF_INT,
     &                                            1, ncf_i_grid_end)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'J_GRID_START', NF_INT,
     &                                            1, ncf_j_grid_start)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'J_GRID_END', NF_INT,
     &                                            1, ncf_j_grid_end)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'GRID_MESH_FACTOR',
     &                                        NF_INT, 1, ncf_grid_mesh_factor)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'FLEXI_NEST', NF_INT,
     &                                              1, ncf_flexi_nest)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'ADVECTION', 
     &      istrln(ncf_advection), ncf_advection(:istrln(ncf_advection)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'CHEM_SOLVER', 
     &  istrln(ncf_chem_solver), ncf_chem_solver(:istrln(ncf_chem_solver)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'PROBING_TOOL', 
     &  istrln(ncf_probing_tool), ncf_probing_tool(:istrln(ncf_probing_tool)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'CHEMISTRY', 
     &         istrln(ncf_chemistry), ncf_chemistry(:istrln(ncf_chemistry)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'TOTAL_SPECIES', NF_INT,
     &                                              1, ncf_total_species)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'RADICAL_SPECIES', NF_INT,
     &                                            1, ncf_radical_species)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'GAS_SPECIES', NF_INT,
     &                                            1, ncf_gas_species)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'PM_SPECIES', NF_INT,
     &                                            1, ncf_pm_species)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'REACTIONS', NF_INT,
     &                                            1, ncf_reactions)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'DRYDEP', 
     &            istrln(ncf_drydep), ncf_drydep(:istrln(ncf_drydep)) )
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'WETDEP', NF_INT,
     &                                              1, ncf_wetdep)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'ACM2', NF_INT, 1, ncf_acm2)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'CIG_MODEL', NF_INT,
     &                                              1, ncf_cig_model)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'SURFACE_MODEL', NF_INT,
     &                                          1, ncf_surface_model)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'INLINE_IX_EMISS', NF_INT,
     &                                        1, ncf_inline_ix_emiss)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'BIDI_NH3_DRYDEP', NF_INT,
     &                                        1, ncf_bidi_nh3_drydep)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'STRAT_O3_PROFILE', NF_INT,
     &                                        1, ncf_strat_o3_profile)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'SUPER_STEPPING', NF_INT,
     &                                        1, ncf_super_stepping)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'GRIDDED_EMISS', NF_INT,
     &                                        1, ncf_gridded_emiss)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'POINT_EMISS', NF_INT,
     &                                        1, ncf_point_emiss)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'IGNORE_EMISS_DATES', NF_INT,
     &                                    1, ncf_ignore_emiss_dates)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_int(iounit, NF_GLOBAL, 'OUTPUT_3D', NF_INT,
     &                                            1, ncf_output_3d)
      if( ierr .NE. NF_NOERR ) goto 7000
c
cgwilson      ierr = nf_put_att_text(iounit, NF_GLOBAL, 'Conventions', 
cgwilson     &   istrln(ncf_conventions), ncf_conventions(:istrln(ncf_conventions)) )
cgwilson      if( ierr .NE. NF_NOERR ) goto 7000
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_GLOBAL:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot write global atttributes to file.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

      subroutine init_Lslice(iproc_id,igrd,ioff,joff)
c
      use pigsty
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c     This routine initializes the LSlice array for the first time step
c     of the day. This is only needed to identify the slice that owns 
c     the PiG when LVISIG is turned on. The AVEPIG routine needs to know
c     which slice owns each PiG.
c
c      Copyright Ramboll
c
c     Modifications:
c
c     Input arguments:
c        iproc_id            process ID
c        igrd                grid index 
c        ioff                X offset of this slice in complete domain
c        ioff                Y offset of this slice in complete domain
c
c     Output arguments:
c
c     Subroutines Called:
c        PIGCOORD
c
c     Called by:
c        AVEPIG
c
      include "camx.prm"
      include "flags.inc"
c
c-----Argunment delarations
c
      integer iproc_id
      integer igrd
      integer ioff
      integer joff
c
c------Local variables
c
      integer n, i, j, idum
      real    xpig, ypig
c
c-----Entry point
c
      do 10 n = 1,npig
        if( lmpi ) Lslice(igrd,iproc_id,n) = 0
c
c-----Skip puffs that are not in the current grid
c
        if(ingrd(n) .NE. igrd) goto 10
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
        if( i .LT. ia .OR. i .GT. iz ) goto 10
        if( j .LT. ja .OR. j .GT. jz ) goto 10
        if( lmpi ) Lslice(igrd,iproc_id,n) = 1
   10 continue
c
      return
      end

      subroutine cvtdate(nyr,nmo,ndy,time,ndate,jdate) 
c   
c----CAMx v7.40 260801
c   
c     CVTDATE converts year, month, day to calender (YYMMDD) and
c     julian (YYJJJ) dates
c                             
c      Copyright Ramboll
c             
c     Modifications:   
c        11/05/01  Added Y2K flag and conversion to Julian date
c 
c     Input arguments:
c        nyr                 year (YYYY)
c        nmo                 month (MM)
c        ndy                 day (DD)
c        time                time (HHMM)
c 
c     Output arguments: 
c        time                time (HHMM)
c        ndate               calender date (YYMMDD)
c        jdate               Julian date (YYJJJ)
c               
c     Routines Called:   
c        JULDATE
c               
c     Called by:   
c        READNML 
c 
      integer nday(12)
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
      nday(2) = 28
      if (mod(nyr,4).eq.0) then
        nday(2) = 29
      endif
c
c-----Convert hour 2400 to 0000 of the following day
c
      if (time.ge.2400.) then 
        time = time - 2400. 
        ndy = ndy + 1 
        if (ndy.gt.nday(nmo)) then 
          ndy = 1
          nmo = nmo + 1 
          if (nmo.gt.12) then
            nmo = 1
            nyr = nyr + 1
          endif
        endif
      endif
c
c-----Create calendar and Julian date stamps
c
      ndate = 10000*mod(nyr,100) + 100*nmo + ndy
      jdate = ndate
      call juldate(jdate)
c
      return
      end

      subroutine readpt( )
      use filunit
      use grid
      use chmstry
      use camxcom
      use ptemiss
c
c----CAMx v7.40 260801
c
c     READPT reads the time-variant records of the point source file and
c     cycles through to current time/date to load point emission rates
c
c      Copyright Ramboll
c          
c     Modifications:
c     05/01/03  Time span of emissions must now match emiss update interval
c     04/21/04  Now reads effective plume height which may overide plume
c               height calculation
c     04/14/04  Removed uncessary and errant check for plume rise distribution
c               flags
c     12/07/14  Revised for VBS emissions
c     01/08/16  Updated for Revised VBS emissions
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Routines Called:
c        none
c
c     Called by:
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap3.inc'
      include 'vbs.inc'
c
      character*4 ptspec(10)
      character*10 ptspcname
c
      real emispts(MXPTSRC)
c
      integer nptsrc_in
c
      data pi /3.1415927/
c
c-----Entry point
c
c----Initialize point emissions to zero
c
      ptemis = 0.
      do ifile=1,npoint_files
         if( is_netcdf_iptem(ifile) ) cycle
         kount = 1
 100     continue
         read(iptem(ifile),end=900) idat1,tim1,idat2,tim2
         if(NINT(1000*tim2) .EQ. 0) then
           tim2 = 24.
           idat2 = idat1
         endif
         ichktm1 = NINT( 1000*(tim1) )
         if( le1day ) then
            ichktm2 = NINT( 1000*(tim2) )
         else
            ichktm2 = NINT( 1000*(tim2)+24000*(idat2-idat1) )
         endif
         if( ichktm2 .EQ. 0 ) ichktm2 = 24000
         ichkems = NINT( 1000*(dtems/60.) )
         if( (ichktm2 - ichktm1) .NE. ichkems ) then
             write(iout,'(//,a)')'ERROR in READPT:'
             write(iout,*) 'Time interval in point emissions file does'
             write(iout,*)  ' not match emissions update time interval.'
             write(iout,*) '   Beginning Date/Time (Hour): ',idat1,tim1
             write(iout,*) '   Ending Date/Time    (Hour): ',idat2,tim2
             write(iout,*) '   Emiss Input interval(Hour): ',dtems/60.
             call camxerr()
         endif
         tim1 = 100.*aint(tim1) + 60.*amod(tim1,1.)
         tim2 = 100.*aint(tim2) + 60.*amod(tim2,1.)
         read(iptem(ifile)) idum,nptsrc_in
c
c  --- calculatate the total points and make sure it matches ----
c
         if( nptsrc_in .NE. nptsrc_files(ifile) ) then 
            write(iout,'(//,a)') 'ERROR in READPT:'
            write(iout,*)'Number of points read from point source files',
     &               ' differs from header value'
            write(iout,*)'Record: ',nptsrc_in,' Header: ',nptsrc_files(ifile) 
            call camxerr()
         endif 
c
         idx_start = idx_start_pts(ifile)
         read (iptem(ifile)) (idum,idum,idum,flowrat(n),effph(n),
     &                    n=idx_start+1,idx_start+nptsrc_in)
c
c----Verify that plume distribution override is valid
c
         do n=idx_start+1,idx_start+nptsrc_in
           if(flowrat(n) .LT. 0. .AND. effph(n) .LT. 0. ) then
              if( ABS(effph(n)) .LT. ABS(flowrat(n)) ) then
                 write(iout,'(//,a)')'ERROR in READPT:'
                 write(iout,*) 'Invalid values found for flow rate and plume height.'
                 write(iout,*) 'The plume distribution override is triggered. But the '
                 write(iout,*) 'value for flow rate (base) is larger than value for ',
     &                      'plume height (top).'
                 call camxerr()
              endif
           endif
         enddo
c
         do 50 ll = 1,nptspc(ifile) 
           read(iptem(ifile)) idum,(ptspec(i),i=1,10),(emispts(n),
     &                                 n=idx_start+1,idx_start+nptsrc_in)
           write(ptspcname,'(10A1)') ptspec
c
c   --- skip if not being modelled ---
c
           if(idxpnt_files(ifile,ll) .LE. 0 ) cycle
c
c----Load into the global array ---
c
           if(  lvbs .AND. LVBSPREPROC) then
             if( ptspcname .EQ. soap_emiss_names(IDX_SOAP_POA_OP) ) then
                 do l = 0, NVOLBIN
                    do ispc=1,nemspc
                       if( emspcname(ispc) .EQ. spname(kpap_c(l)) ) then
                          do n=idx_start+1,idx_start+nptsrc_in
                             ptemis(n,ispc) = emispts(n) * poa_op_ef(l)
                          enddo
                       endif 
                    enddo
                 enddo
                 goto 50
             endif
             if( ptspcname .EQ. soap_emiss_names(IDX_SOAP_POA_BB) ) then
                 do l = 0, NVOLBIN
                    do ispc=1,nemspc
                       if( emspcname(ispc) .EQ. spname(kpfp_c(l)) ) then
                          do n=idx_start+1,idx_start+nptsrc_in
                             ptemis(n,ispc) = emispts(n) * poa_bb_ef(l)
                          enddo
                       endif
                    enddo
                 enddo
                goto 50
             endif
           endif
           do n=idx_start+1,idx_start+nptsrc_in
             ptemis(n,idxpnt_files(ifile,ll)) = emispts(n)
           enddo
 50      continue
         write(iout,'(a40,2(f7.0,i8.5))')
     &       'Read point source file at ',tim1,idat1,tim2,idat2 
         call flush(iout)
c
c-----Check times only if LE1DAY = T, otherwise check both time and date
c
         if (le1day) then
           if (abs(tim1-time).lt.0.01 .and. tim2.gt.time) goto 200
           if (tim1-time.ge.0.01) goto 900
         else
           if ((idat1.lt.date .or.
     &      (idat1.eq.date .and. abs(tim1-time).lt.0.01)) .and.
     &      (idat2.gt.date .or.
     &      (idat2.eq.date .and. tim2.gt.time)))
     &    goto 200
         endif
         goto 100
c 
c-----Convert emission rates from moles/(dtems-hours) to moles/s for gas 
c     or g/(dtems-hours) to g/s for aero species 
c 
 200     do 10 l = 1,nemspc
           do n=idx_start+1,idx_start+nptsrc_in
             ptemis(n,l) = ptemis(n,l)/(60.*dtems) 
           enddo 
 10      continue 
c 
         goto 999
c
c-----End of file reached; if 1-day emissions requested, rewind and read 
c     through header once more.  Otherwise, report error and exit
c
 900     continue
         if (le1day) then
           if (kount.ge.2) then
             write(iout,'(//,a)')'ERROR in READPT:'
             write(iout,*)'Cannot match model time with point source time.'
             call camxerr()
           endif
           rewind(iptem(ifile))
           read(iptem(ifile)) idum 
           read(iptem(ifile)) dum  
           read(iptem(ifile)) idum  
           read(iptem(ifile)) idum 
           read(iptem(ifile)) idum 
           read(iptem(ifile)) dum
           kount = kount + 1
           goto 100
        else
           write(iout,'(//,a)')'ERROR in READPT:'
           write(iout,*)'End of point source file reached.  Make sure the '
           write(iout,*)
     &            'file is for the correct day and contains all hours.'
           call camxerr()
         endif
c
 999     continue
      enddo
c
      return
      end

c*** CSA_RESET
c
      subroutine csa_reset(igrid_mod,ncol_mod,nrow_mod,nlay_mod,
     &               nspc_mod,ngas_mod,nrad_mod,nhet,ipa_cel)
      use grid
      use camxfld
      use procan
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c      Reloads the regular model concentratons into the CSA gridded
c      array. This will happen each hour.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c         igrid_mod  number of columns in modeling grid
c         ncol_mod   number of columns in modeling grid
c         nrow_mod   number of rows in modeling grid
c         nlay_mod   number of layers in modeling grid
c         nspc_mod   total number of modelled species
c         ngas_mod   number of modeled gas species
c         nrad_mod   number of modeled radicals
c         nhet       number of heterogeneous rxns
c         conc_mod   gridded array of model concentrations for this grid
c         ipa_cel    index of model cell into CSA grid
c     Outputs:
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid_mod
      integer ncol_mod
      integer nrow_mod
      integer nlay_mod
      integer nspc_mod
      integer ngas_mod
      integer nrad_mod
      integer nhet
      integer ipa_cel(ncol_mod,nrow_mod,nlay_mod)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icl_mod, jcl_mod, kcl_mod, ipa_idx, icsa_grid
      integer icsa_icl, icsa_jcl, icsa_kcl, ncol_csa, nrow_csa, nlay_csa
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- loop over modelling cells ---
c
      do kcl_mod=1,nlay_mod
          do jcl_mod=1,nrow_mod
              do icl_mod=1,ncol_mod
c
c  --- skip if this cell is not in a CSA grid ---
c
                 ipa_idx = ipa_cel(icl_mod,jcl_mod,kcl_mod)
                 if( ipa_idx .LE. 0 ) cycle
c
c  --- get CSA grid values for this cell ---
c
                 icsa_grid = ipadom(ipa_idx)
                 icsa_icl = ipax(ipa_idx) - i_sw(icsa_grid) + 1
                 icsa_jcl = ipay(ipa_idx) - j_sw(icsa_grid) + 1
                 icsa_kcl = ipaz(ipa_idx) - b_lay(icsa_grid) + 1
                 ncol_csa = i_ne(icsa_grid) - i_sw(icsa_grid) + 1
                 nrow_csa = j_ne(icsa_grid) - j_sw(icsa_grid) + 1
                 nlay_csa = t_lay(icsa_grid) - b_lay(icsa_grid) + 1
c
c  --- call routine to load the model concs into CSA array ---
c
                 call loadcsa_conc(ncol_csa,nrow_csa,
     &             nlay_csa,ntotsp,csaconc(iptrcsa(icsa_grid)),
     &             icsa_icl,icsa_jcl,icsa_kcl,icl_mod,jcl_mod,
     &             kcl_mod,nddmsp,nspc_mod,ngas_mod,nrad_mod,nhet,
     &             ncol_mod,nrow_mod,nlay_mod,conc(iptr4d(igrid_mod)))
              enddo
          enddo
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

c*** RBKDRV
c
      subroutine rbkdrv(dtin,H2O,atm,O2,CH4,H2,conc,rtconc,
     &                  ierr,lpig)
      use chmstry
      use filunit
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Call the Rosenbrock solver (RODAS) for RTRAC CMC chemistry
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Input arguments:
c
c       dtin              time duration to be integrated (hr)
c       H2O               water vapor concentration (ppm)
c       atm               total gas concentration (M) in ppm
c       O2                oxygen concentration (ppm)
c       CH4               methane concentration (ppm)
c       H2                hydrogen concentration (ppm)
c       conc              state species concentrations (ppm)
c       rtconc            RTRAC species concentrations (ppm)
c       lpig              PiG chemistry flag (T=puff chemistry)
c
c      Output arguments:
c       rtconc            RTRAC species concentrations (ppm)
c       ierr              error flag (=1 if RODAS reports error)
c
c     Routines called:
c      RODAS
c      DPREPSLO
c      DSLOCMC
c      DEQMCMC
c      CAMXERR
c
c     Called by:
c      CHEMDRIV
c      PIGDRIVE
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include "camx.prm"
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real     dtin, H2O, atm, O2, CH4, H2
      real     conc(MXSPEC+1), rtconc(MXTRSP)
      integer  ierr
      logical  lpig
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      external rbratcmc, rbjaccmc, solout
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      integer   LDIM, LIW, LRW, ITOL
      parameter (LDIM = MXTRSP)
      parameter (LIW = LDIM + 20)
      parameter (LRW = 2*LDIM*LDIM + 14*LDIM + 20)
      parameter (ITOL = 0)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, izero, ione, mf
      integer   ipar, idid, neq
      integer   iwork(LIW) 
      real*8    datol, drtol
      real*8    t, tout, dstep, dpar, fixed(6+mxspec)
      real*8    y(MXTRSP+MXSPEC), y0(MXTRSP+MXSPEC),
     &          dwork(LRW), rr(MXRX)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ione = 1
      izero = 0
c
c --- Zero the working array elements that can pass options to RODAS
c
      dwork(1) = 0.D0
      dwork(2) = 0.D0
      dwork(3) = 0.D0
      dwork(4) = 0.D0
      dwork(5) = 0.D0
      iwork(1) = 0
      iwork(2) = 0
      iwork(3) = 0
      iwork(9) = 0
      iwork(10) = 0
c
c --- Load concentrations for RODAS
c
      do i = 1,ngasrtc
         y(i) = DBLE( rtconc(i) )
         y0(i) = y(i)
      enddo
c
      if( nfixrtc. GT. 0 ) then
         fixed(1) = atm
         fixed(2) = O2
         fixed(3) = atm-O2
         fixed(4) = H2O
         fixed(5) = H2
         fixed(6) = CH4
         if( ngas. GT. 0 ) then
            do i = 1,ngas
               fixed(6+i) = conc(i)
            enddo
         endif
         do i = 1,nfixrtc
            y(i+ngasrtc) = DBLE( fixed( idxfix(i+ngasrtc)) )
            y0(i+ngasrtc) = y(i+ngasrtc)
         enddo
      endif
c
c --- Set integration parameters for RODAS
c     mf sets Jacobian method: 0 = numeric, 1 = algebraic
c
      mf = ijac-1
      t = 0.0D0 
      tout = DBLE( dtin )
      dstep = tout/1.0D-4
      neq = nfstrtc
      datol = DBLE(atolrtc)
      drtol = DBLE(rtolrtc)
c
c --- Call RODAS to advance the fast species
c     Equilibrium species (if any) are solved within RODAS 
c     Slow species (if any) are advanced using the end-point fast/eqm 
c     concentrations
c
      call rodas(neq,rbratcmc,izero,t,y,tout,dstep,drtol,datol,ITOL,
     &     rbjaccmc,MF,neq,izero,rbratcmc,izero,rbratcmc,izero,izero,
     &     izero,solout,izero,dwork,LRW,iwork,LIW,dpar,ipar,idid)
      if( idid .LT. 0) go to 900 
      if( nslortc .LT. 1) then
        call dprepslo(y,rr)
        call dslocmc(y,rr,DBLE( dtin ))
      endif
      if( neqmrtc .GT. 0) call deqmcmc(y,rr,.false.,.false.)
c
c --- Save species concentrations in CAMx arrays
c
      do i = 1,ngasrtc
         rtconc(i) = MAX(1.0E-18, SNGL( y(i) ))
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error handling:
c-----------------------------------------------------------------------
c
 900  if (lpig) then 
        ierr = 1
        return
      else
        write(iout,'(//,A)') ' ERROR in RBKDRV:'
        write(iout,'(/,A,I3,/,A)') ' RODAS reporting IDID = ',
     &     idid, ' Look up this IDID code in the RODAS source code'
        write(iout,901) dstep, tout, dtin
        write(iout,902) iwork(16),iwork(14),iwork(15)
 901    format(/,'   last step size  = ', D12.3,/
     &           '   current time    = ', D12.3,/
     &           '   total time step = ', D12.3)
 902    format('   # of steps ',i4,' # of f-s ',i4,' # of j-s ',i4)
        write(iout,'(/,A7,A10,2A12)')
     &        'Species','Name','C(t)','C(0)'
        write(iout,'(I5,3X,A,2X,1P2E12.3)')
     &       (j,spnmrt(j),y(j),y0(j),j=1,ngasrtc+nfixrtc)
        call camxerr()
      endif
c
      end 

      subroutine grdprep(nx,ny,cellon,cellat,mapscl,
     &                                  orgx,orgy,dx,dy,xsize,ysize)
      use grid
c 
c----CAMx v7.40 260801
c 
c     GRDPREP calculates coarse grid parameters for the following projections:
c        0. Lat/lon grid
c        1. Universal Transverse Mercator (UTM)
c        2. Lambert Conformal
c        3. Rotated (RAMS) Polar Stereographic
c        4. (WRF) Polar Stereographic 
c        5. (WRF) Mercator
c                           
c      Copyright Ramboll
c
c     Modifications: 
c        4/10/15      Added WRF Polar Stereographic and Mercator projections
c                     (Polar different from original Rotated Polar Stereographic
c                     from RAMS)
c 
c     Input arguments: 
c        nx                  number of columns
c        ny                  number of rows
c
c     Output arguments: 
c        cellon              array of cell centroid longitude (deg)
c        cellat              array of cell centroid latitude (deg)
c        mapscl              array of map-scale factors centered on each cell
c        orgx                origin of grid in X direction
c        orgy                origin of grid in X direction
c        dx                  cell width of grid in X direction
c        dy                  cell width of grid in Y direction
c        xsize               array of cell width in X direction
c        ysize               cell width in y direction
c             
c     Routines Called: 
c        UTMGEO
c        PSPGEO
c        LCPGEO
c             
c     Called by: 
c        STARTUP
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer nx,ny
      real cellon(nx,ny), cellat(nx,ny), mapscl(nx,ny)
      real orgx, orgy, dx, dy
      real xsize(ny), ysize
c
      integer i,j
      real deg2km,deg2rad
      real xloc,yloc,xloce,xlocw,alon,alat
      real colat,colat1,colat2,expn,xdel,ydel,elon,wlon,elat,wlat
c
      data deg2km /111.1338/
      data deg2rad /0.01745329/
c
c-----Entry point
c
c-----Cartesian coordinates are selected
c     Input cell sizes (dx and dy) are already in km
c
      if( .NOT. llatlon ) then
c
c-----Determine xsize and ysize (m) for coarse grid
c
        ysize = 1000.*dy
        do 10 j=1,ny
          xsize(j) = 1000.*dx
c
c-----Calculate lat/lon at cell centroids, and map-scale factor
c
          yloc = orgy + dy*(float(j) - 0.5)
          do 15 i = 1,nx
            xloc = orgx + dx*(float(i) - 0.5)
            if (lambrt) then
              call lcpgeo(1,polelon,polelat,tlat1,tlat2,xloc,yloc,alon,alat)
              colat1 = deg2rad*(90. - tlat1)
              colat = deg2rad*(90. - alat)
              if (tlat1 .ne. tlat2) then
                colat2 = deg2rad*(90. - tlat2)
                expn = (log(sin(colat1))    - log(sin(colat2))) /
     &                 (log(tan(colat1/2.)) - log(tan(colat2/2.)))
                mapscl(i,j) = sin(colat2)/sin(colat)*
     &                       (tan(colat/2.)/tan(colat2/2.))**expn
              else
                mapscl(i,j) = sin(colat1)/sin(colat)*
     &                        (tan(colat/2.)/tan(colat1/2.))**cos(colat1)
              endif
            elseif (lpolar) then
              call pspgeo(1,polelon,polelat,tlat1,xloc,yloc,alon,alat)
              mapscl(i,j) = (1. + sin(deg2rad*abs(tlat1)))/
     &                      (1. + sin(deg2rad*sign(1.,tlat1)*alat))
            elseif (lmerc) then
              call mrcgeo(1,polelon,polelat,tlat1,xloc,yloc,alon,alat)
              colat1 = deg2rad*(90. - tlat1)
              colat = deg2rad*(90. - alat)
              mapscl(i,j) = sin(colat1)/sin(colat)
            else
              if (lutm) then
                call utmgeo(1,iuzon,xloc,yloc,alon,alat)
                xloce = xloc + dx/2. 
                call utmgeo(1,iuzon,xloce,yloc,elon,elat)
                xlocw = xloc - dx/2. 
                call utmgeo(1,iuzon,xlocw,yloc,wlon,wlat)
              elseif (lrpolar) then
                call rpsgeo(1,polelon,polelat,xloc,yloc,alon,alat)
                xloce = xloc + dx/2. 
                call rpsgeo(1,polelon,polelat,xloce,yloc,elon,elat)
                xlocw = xloc - dx/2. 
                call rpsgeo(1,polelon,polelat,xlocw,yloc,wlon,wlat)
              endif
              xdel = deg2km*(elon - wlon)*cos(deg2rad*alat)  
              ydel = deg2km*(elat - wlat) 
              mapscl(i,j) = dx/sqrt(xdel*xdel + ydel*ydel) 
            endif
            cellon(i,j) = alon
            cellat(i,j) = alat
 15       continue
 10     continue
c
c-----Lat/lon coordinates are selected
c
      else
c
c-----Determine xsize and ysize (m) on coarse grid
c
        ysize = 1000.*deg2km*dy
        do 20 j = 1,ny
          alat = orgy + dy*(float(j) - 0.5)
          xsize(j) = 1000.*deg2km*dx*cos(alat*deg2rad)
c
c-----Calculate lat/lon at cell centroids
c
          do 25 i = 1,nx
            alon = orgx + dx*(float(i) - 0.5)
            cellon(i,j) = alon
            cellat(i,j) = alat
            mapscl(i,j) = 1.
 25        continue
 20     continue
      endif
c
      return
      end

      subroutine readtop(toptim,topdate)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxfld
      use camxcom
c 
c----CAMx v7.40 260801
c 
c     READTOP reads and cycles through the TOPCON file to the
c     current time/date, and loads master grid top concentrations.
c     It then interpolates to all nested grids.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments: 
c        toptim                 model simulation time (HHMM)
c        topdate                model simulation date (YYJJJ)
c             
c     Output arguments: 
c        toptim                 next boundary update time (HHMM)
c        topdate                next boundary update date (YYJJJ)
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
c
      character*4 tcspec(10)
      integer topdate, ncells
c
      real, allocatable, dimension(:,:,:) :: tctmp
c
c-----Entry point
c
      allocate( tctmp(ncol(1),nrow(1),MXSPEC) )
c
c-----Read through records until current time/date
c
 100  read(itc,end=900) idat1,tim1,idat2,tim2
      if (INT(tim2) .EQ. 24) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      do l = 1,ntcspc
         read(itc) idum,(tcspec(m),m=1,10),
     &             ((tctmp(i,j,l),i=1,ncol(1)),j=1,nrow(1)) 
      enddo
      write(iout,'(a40,2(f7.0,i8.5))')
     &  'Read top concentrations file at ',tim1,idat1,tim2,idat2
      call flush(iout)
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.gt.time))) then
c
c-----Load top concentrations for master grid
c
        do 60 l = 1,nspec
          ltc = ltcmap(l)
          do 50 j = 1,nrow(1)
            do 40 i = 1,ncol(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(l - 1)
              ctop(n3d) = bdnl(l)
              if (ltc.gt.0) then
                 if( tctmp(i,j,ltc).gt.bdnl(l) ) 
     &               ctop(n3d) = tctmp(i,j,ltc)
              endif
c
 40         continue
 50       continue
 60     continue
      else
        goto 100
      endif
c
c-----Interpolate topcon to all nested grids
c
      if (ngrid.gt.1) then
        do ip = 1,ngrid
          do ic = 1,nchdrn(ip)
            ig = idchdrn(ic,ip)
            call intrpcnc(nspec,ncol(ip),nrow(ip),1,i1(ig),
     &                    j1(ig),nmesh(ig),ncol(ig),nrow(ig),1,
     &                    ctop(iptr1lay(ip)),ctop(iptr1lay(ig)))
          enddo
        enddo
      endif
c
c-----Set next topcon update time
c
      toptim = tim2
      topdate = idat2
      if (toptim.ge.2400.) then
        toptim = toptim - 2400.
        topdate = topdate + 1
        if( MOD(topdate,1000) .GT. 365 ) then
           if( MOD(INT(topdate/1000),4) .EQ. 0 ) then
              if( MOD(topdate,1000) .EQ. 367 )
     &                     topdate = (INT(topdate/1000)+1)*1000 + 1
           else
              topdate = (INT(topdate/1000)+1)*1000 + 1
           endif
        endif
      endif
      goto 999
c
c-----End of TC file reached
c
 900  write(iout,'(//,a)') 'ERROR in READTOP:'
      write(iout,*)'Premature End of TC file reached.'
      write(iout,*)'Make sure topcon file contains simulation ',
     &                                               'time period.'
      call camxerr()
c
 999  continue
c
c  --- dealocate the local array ---
c
      deallocate( tctmp )
      return
      end

C**** SOAP3_EVAP_AREA
c
      subroutine soap3_evap_area( igrd, ncol_grid, nrow_grid,
     &                    nlay_grid, nlay_ems, evap_factors,
     &                   temperature, hoa_evap_emis, svoa_evap_emis,
     &                                            area_emis, numspcs)
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine applies factors to evaporate POA to SVOA and
c     updates the emissions array so emissions are injected into
c     the appropriate model species.
c
c      Copyright Ramboll
c
c     Input arguments:
c        igrd             grid index
c        ncol_grid        number of columns
c        nrow_grid        number of rows
c        nlay_grid        number of layers in grid
c        nlay_ems         number of layers in emissions foles
c        numspcs          number of model species
c        temperature      temperature in aloft layers
c        area_evap_emis   area emissions rate (grams/s)
c     Output arguments:
c        hoa_evap_emis    area emissions rate (grams/s)
c        svoa_evap_emis   area emissions rate (grams/s)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/24   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol_grid
      integer nrow_grid
      integer nlay_grid
      integer nlay_ems
      integer numspcs
      real    evap_factors(3,NUM_SOAP_EMISS)
      real    temperature(ncol_grid,nrow_grid,nlay_grid)
      real    hoa_evap_emis(ncol_grid,nrow_grid,nlay_ems)
      real    svoa_evap_emis(ncol_grid,nrow_grid,nlay_ems)
      real    area_emis(ncol_grid,nrow_grid,nlay_ems,numspcs)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer imod, iems
      integer icl, jcl, klay, isoa, ipt
      real    evap_fact, evap_mass, convfac
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------

c
c  ---- don't change anything if SVOA or HOA not found ---
c
       if( idx_ems_svoa .LE. 0 ) goto 9999
c
c  --- loop over grid and update all affected species ----
c
       do klay=1,nlay_ems
         do jcl=1,nrow_grid
           do icl=1,ncol_grid
             hoa_evap_emis(icl,jcl,klay) = 0. 
             svoa_evap_emis(icl,jcl,klay) = 0. 
c
c  --- see if POA species was found ---
c
             do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                if( idx_ems_soap3(isoa) .LE. 0 ) cycle
                if( area_emis(icl,jcl,klay,idx_ems_soap3(isoa)) .LE. 0 ) cycle
c
c ---- evaporate POA into SVOA ---
c
                 evap_fact = MIN(1.0,
     &                       (evap_factors(1,isoa) * temperature(icl,jcl,klay)**2 + 
     &                        evap_factors(2,isoa) * temperature(icl,jcl,klay) + 
     &                        evap_factors(3,isoa) ))
                 evap_mass = area_emis(icl,jcl,klay,idx_ems_soap3(isoa)) * 
     &                       (1. - evap_fact)
                 if( ksvoa .NE. 0 .and. ksvoa .NE. numspcs+1 )
     &                svoa_evap_emis(icl,jcl,klay) = 
     &                     svoa_evap_emis(icl,jcl,klay) + 
     &                                 MAX( 0.,evap_mass/mole_weight(ksvoa) )
c
c ---- back out the evap emissions from each POA species ---
c
                 hoa_evap_emis(icl,jcl,klay) = hoa_evap_emis(icl,jcl,klay) + 
     &              MAX( 0.,area_emis(icl,jcl,klay,idx_ems_soap3(isoa)) - evap_mass)
             enddo
           enddo
         enddo
       enddo
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine aggdep(ncolf,nrowf,ncol,nrow,ndpspc,i1,j1,
     &                  i2,j2,nmesh,dxfin,dyfin,depfldf,
     &                  dxcrs,dycrs,depfld)
c
c----CAMx v7.40 260801
c  
c     AGGDEP aggregates child (fine) grid deposition fields to its parent
c     (coarse) grid using an arithmitic average
c                            
c      Copyright Ramboll 
c            
c     Modifications:  
c        none
c
c     Input arguments:
c        ncolf               number of columns on fine grid
c        nrowf               number of rows on fine grid
c        ncol                number of columns on parent grid
c        nrow                number of rows on parent grid
c        ndpspc              number of species (3*navspc)
c        i1,j1               starting indices of fine grid on parent grid
c        i2,j2               ending indices of fine grid on parent grid
c        nmesh               fine grid meshing factor relative to parent
c        dxfin               cell size in x-direction on fine grid
c        dyfin               cell size in y-direction on fine grid
c        depfldf             deposition array on fine grid
c        dxcrs               cell size in x-direction on parent grid
c        dycrs               cell size in y-direction on parent grid
c
c     Output arguments:
c        depfld              deposition array on parent grid
c
c     Routines called:
c        none
c
c     Called by:
c        AGGR00
c
      real dxfin(nrowf)
      real dxcrs(nrow)
      real depfld(ncol,nrow,ndpspc)
      real depfldf(ncolf,nrowf,ndpspc)
c
      real*8  asum, bsum
c
c-----Entry point
c
      do 60 ispc = 1,ndpspc
        do 50 j = j1,j2
          do 40 i = i1,i2
            bsum = 0.0D0
            areacrs = dxcrs(j)*dycrs
            tarea = 0.
            dtmp = 0.
            do jtmp = 1,nmesh
              asum = 0.0D0
              j0 = (j-j1)*nmesh+jtmp + 1
              do itmp = 1,nmesh
                i0 = (i-i1)*nmesh+itmp + 1
                area = dxfin(j0)*dyfin
                tarea = tarea + area
                asum = asum + DBLE(depfldf(i0,j0,ispc)*area)
              enddo
              bsum = bsum + asum
            enddo
            depfld(i,j,ispc) = REAL(bsum)/areacrs
  40      continue
  50    continue
  60  continue
c
      return
      end

      subroutine rdpthdr_sa(begtim,begdate,endtim,enddate)
      use filunit
      use grid
      use chmstry
      use bndary
      use ptemiss
      use tracer
      implicit none
c 
c----CAMx v7.40 260801
c 
c     RDPTHDR_SA reads the header of binary point source emissions file
c     in each soruce group, initializes time-invariant point source 
c     variables, and maps the point source species list to the internal 
c     CAMx species list
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        11/21/25   Changed the way lemmap works - it now points the other direction
c 
c     Input arguments: 
c        begtim              model start time (HHMM) 
c        begdate             model start date (YYJJJ) 
c        endtim              model end time (HHMM) 
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        PNTPREP
c 
      include 'camx.prm'
      include 'flags.inc'
      include 'vbs.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      integer begdate
      integer enddate
      real begtim
      real endtim
c
      character*10 ptfil, infil, ptspc, ptcompact
      character*4  ifile(10), note(60)
c
      character*4 ptspec(10,MXSPEC)
c
      logical lfound, lfound_hoa, lfound_svoa, lfound_poa
      integer ifle, igroup, iounit
c
      integer, parameter :: num_elem = 5
      integer :: idx_elem(num_elem)
      integer idx_start, numpts, n, l, lpt, i, j, k, idum
      integer idat1, idat2, nseg, izone, nx, ny, nz
      real tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
c
      integer isoa
c
      data ptfil /'PTSOURCE  '/
      data ptcompact /'PTSOURCECP'/
c
c-----Entry point
c
c-----Loop over groups and files in each group ---
c
       numpts = 0
       do igroup=1,ngroup 
       do ifle=1,num_iortpt(igroup)
        iounit = iortpt(igroup,ifle)
c
c-----skip if this is a NetCDF file ---
c
        if( is_netcdf_iortpt(igroup,ifle) ) cycle
c
c-----Read 1st PT header record and check inputs 
c             
        rewind(iounit)
        read(iounit) ifile,note,nseg,nspcpt(igroup,ifle),idat1,tim1,idat2,tim2
        if(INT(tim2) .EQ. 24) then
          tim2 = 0.
          idat2 = idat2 + 1
          if( MOD(idat2,1000) .GT. 365 ) then
             if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
                if( MOD(idat2,1000) .EQ. 367 ) 
     &                       idat2 = (INT(idat2/1000)+1)*1000 + 1
             else
                idat2 = (INT(idat2/1000)+1)*1000 + 1
             endif
          endif
        endif
        write(infil,'(10a1)') (ifile(n),n=1,10) 
        if (infil.ne.ptfil .AND. infil .ne. ptcompact) then 
          write(iout,'(//,a)') 'ERROR in RDPTHDR_SA:'
          write(iout,*)'PT input file is not labelled PTSOURCE or PTSOURCECP' 
          call camxerr()
        endif   
        tim1 = 100.*tim1
        tim2 = 100.*tim2
        if (idat1.gt.begdate) then 
          write(iout,'(//,a)') 'WARNING in RDPTHDR_SA:'
          write(iout,*)'PT start date > simulation start date' 
          write(iout,*)'  PT file: ',idat1 
          write(iout,*)'Sim start: ',begdate 
          if (.not.le1day) then
            write(iout,*)'CAMx expecting day-specific emissions: Stopping'
            call camxerr()
          endif
        elseif (idat1.eq.begdate .and. tim1.gt.begtim) then 
          write(iout,'(//,a)') 'WARNING in RDPTHDR_SA:'
          write(iout,*)'PT start time > simulation start time' 
          write(iout,*)'  PT file: ',tim1 
          write(iout,*)'Sim start: ',begtim 
          call camxerr()
        elseif (idat2.lt.enddate) then 
          write(iout,'(//,a)') 'WARNING in RDPTHDR_SA:'
          write(iout,*)'PT end date < simulation end date' 
          write(iout,*)'PT file: ',idat2
          write(iout,*)'Sim end: ',enddate 
          if (.not.le1day) then
            write(iout,*)'CAMx expecting day-specific emissions: Stopping'
            call camxerr()
          endif
        elseif (idat2.eq.enddate .and. tim2.lt.endtim) then 
          write(iout,'(//,a)') 'ERROR in RDPTHDR_SA:'
          write(iout,*)'PT end time < simulation end time' 
          write(iout,*)'PT file: ',tim2
          write(iout,*)'Sim end: ',endtim 
          call camxerr()
        endif 
c 
c-----Read 2nd PT header
c 
        read(iounit) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz 
c 
c-----Read 3rd & 4th PT header 
c 
        read(iounit)
        read(iounit) ((ptspec(n,l),n=1,10),l=1,nspcpt(igroup,ifle)) 
c 
c-----Map PT species to model species 
c 
        do 15 lpt = 1,nspcpt(igroup,ifle) 
           write(ptspc,'(10a1)') (ptspec(n,lpt),n=1,10) 
           if (ptspc.eq.'HNO2      ') ptspc = 'HONO      '
           if (ptspc.eq.'HCHO      ' .and. kHCHO.eq.nspec+1)
     &                                        ptspc = 'FORM      '
           do isoa=1,NUM_SOAP_SPECIES
              if( ptspc .EQ. 'POA ' ) cycle
              if( ptspc .EQ. soap2_spec_names(isoa) ) then
                  ptspc = soap3_spec_names(isoa)
              endif
           enddo
           if( ptspc(1:4) .EQ. 'POA ' .AND. luse_soap3 ) ptspc = 'POA_AV    '
c
c  --- check if species is not modelled ---
   
           lfound = .FALSE.
           do l = 1,nspec 
             if( ptspc .EQ. spname(l) ) then 
               write(idiag,'(2(a,i5,2x,a))')
     &                   'Point source species ',lpt,ptspc, 
     &                   ' mapped to model species ',l,spname(l) 
               lfound = .FALSE.
               do k=1,nemspc
                 if( ptspc .EQ. emspcname(k) ) then
                    lfound = .TRUE.
                    lemmap(k) = l
                    idxpts(igroup,ifle,lpt) = k
                 endif
               enddo
               if( .NOT. lfound ) then
                 nemspc = nemspc + 1
                 emspcname(nemspc) = ptspc
                 lemmap(nemspc) = l
                 idxpts(igroup,ifle,lpt) = nemspc
                 lfound = .TRUE.
               endif
             endif
           enddo
           if( .NOT. lfound .AND. luse_soap3 .AND. lsoa ) then
               do j=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                   if(ptspc .EQ. soap_emiss_names(j)) then
                      lfound_poa = .FALSE.
                      do k=1,nemspc
                         if( ptspc .EQ. emspcname(k) ) then
                              lfound_poa = .TRUE.
                              if( ksvoa .NE. nspec+1 ) lemmap(k) = ksvoa
                              idx_ems_svoa = k
                         endif
                      enddo
                      if( .NOT. lfound_poa ) then
                        nemspc = nemspc + 1
                        emspcname(nemspc) = ptspc
                        idxpts(igroup,ifle,lpt) = nemspc
                        if( ksvoa .NE. nspec+1) lemmap(nemspc) = ksvoa
                        idx_ems_svoa = nemspc
                      endif 
                   endif
               enddo
           endif
   15   continue 
        if( lvbs .AND. LVBSPREPROC ) then
           if( ptspc .EQ. 'POA_OP    ') then
               lemmap(lpt) = kpap_c(0)
               write(idiag,'(a,i5,2x,2a)') 'Point source species ',
     &                   lpt,ptspc,' mapped to model species PAP0-PAP5 (VBS)'
           endif
           if( ptspc .EQ. 'POA_BB    ') then
               lemmap(lpt) = kpfp_c(0) ! temporarily assign to PFP0
               write(idiag,'(a,i5,2x,2a)') 'Point source species ',
     &               lpt,ptspc,' mapped to model species PFP0-PFP5 (VBS)'
           endif
        endif
        if( ptspc .EQ. spname(l) ) then
          write(idiag,'(2(a,i5,2x,a))')
     &                 'Point source species ',lpt,ptspc,
     &                 ' mapped to model species ',l,spname(l)
        endif
c
c --- make sure that SVOA is in the list of emissions species ---
c
      if( luse_soap3 .AND. ksvoa .NE. nspec+1 ) then
          lfound_svoa = .FALSE.
          do i=1,nemspc
            if( emspcname(i)(1:5) .EQ. 'SVOA ' ) then
                lfound_svoa = .TRUE.
                lemmap(i) = ksvoa
                idx_ems_svoa = l
            endif
          enddo
          if( .NOT. lfound_svoa ) then
             nemspc = nemspc + 1
             emspcname(nemspc) = 'SVOA      '
             lemmap(nemspc) = ksvoa
             idx_ems_svoa = nemspc
             idxpts(igroup,ifle,lpt) = nemspc
          endif
      endif
      if( luse_soap3 .AND. khoa .NE. nspec+1 ) then
          lfound_hoa = .FALSE.
          do i=1,nemspc
            if( emspcname(i)(1:4) .EQ. 'POA ' ) then
                lfound_hoa = .TRUE.
                lemmap(i) = khoa
                idx_ems_poa = i
            endif
          enddo
          if( .NOT. lfound_hoa ) then
             nemspc = nemspc + 1
             emspcname(nemspc) = 'POA       '
             lemmap(i) = khoa
             idx_ems_poa = nemspc
          endif
      endif
c
c-----Read time invariant data (assume nseg=1)
c     check number of sources against max 
c
         read(iounit) idum,nptsrc_safile(igroup,ifle)
         idx_start_sapts(igroup,ifle) = numpts
         numpts = numpts + nptsrc_safile(igroup,ifle)
c
c---- next file and group
c
      enddo
      enddo
c
c----Call routine to allocate the arrays 
c
      call alloc_ptemiss(nspec,ngrid,nptsrc)
c
c  --- read rest of each file ---
c
      do igroup=1,ngroup 
      do ifle=1,num_iortpt(igroup)
         iounit = iortpt(igroup,ifle)
c
c-----skip if this is a NerCDF file ---
c
         if( is_netcdf_iortpt(igroup,ifle) ) cycle
         idx_start = idx_start_sapts(igroup,ifle)
         read(iounit) (xloc(n),yloc(n),hstk(n),dstk(n),tstk(n),
     &                     vstk(n),n=idx_start+1,idx_start+nptsrc_safile(igroup,ifle))
         do 30 n = idx_start+1,idx_start+nptsrc_safile(igroup,ifle)
           lpiglet(n) = .false.
           if (dstk(n).lt.0.) then
               lpiglet(n) = .true.
           endif
           vstk(n) = vstk(n)/3600.
c
c========================= Source Apportion End ========================
c
  30     continue
      enddo
      enddo
      write(idiag,*)
c
      return
      end

      subroutine before_massum(ip,icode)
      use filunit
      use grid
      use chmstry
      use camxfld
      use camxcom
      use procan
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c     This routine does the mass budget calculations for the 
c     slices when doing the nest feedback process. This routine
c     will do the calculations before feedback is performed and
c     store the values in temporary arrays.
c
c      Copyright Ramboll
c          
c     Modifications:
c
c     Input arguments:
c        ip                  parent grid index
c        icode               flag to select when to sum mass on parent grid
c                              0 = sum both before and after aggregation
c                              1 = sum before aggregation
c                              2 = sum after aggregation
c                             >2 = do not sum
c
c     Output arguments:
c        none
c
c     Subroutine called:
c        MASSUM
c        AGGREG
c
c     Called by:
c        NESTING
c
      include "camx.prm"
c
c-----Entry point
c
      if( icode .GT. 2 ) return
c
      if (icode.le.1) then
        call massum(mmxp(ip),mmyp(ip),mmzp(ip),mi0(ip),mj0(ip),
     &             mia(ip),miz(ip),mja(ip),mjz(ip),mibcon(ip),
     &             ip,nspec,ncol(ip),nrow(ip),nlay(ip),deltax(1,ip),
     &             deltay(ip),depth(iptr3d(ip)),mapscl(iptr2d(ip)),
     &             conc(iptr4d(ip)),xmstmp(1,ip))
      endif
c
      return
      end

      subroutine vadvppm(nn,igrd,dtin,dz,con,vel,dil,sens,fluxlay,
     &                   fc1,fc2,fc3,ldoipts)
      use tracer
c  
c----CAMx v7.40 260801
c
c     VADVPPM performs concentration adjustments due to vertical advection
c     and changes in layer structure that result from the time- and
c     space-varying vertical coordinate system.  This version performs works
c     on both concentrations and DDM sensitivities.
c
c     It uses the one-dimensional implementation of the piecewise parabolic
c     method of Colella and Woodward (1984).
c     A piecewise continuous parabola is used as the intepolation polynomial.
c     The slope of the parabola at cell edges is computed from a cumulative
c     function of the advected quantity.  These slopes are further modified
c     so that the interpolation function is monotone.
c
c     Upper boundary conditions:
c        This routine accomodates non-zero vertical velocities at the top of
c        the column; the top boundary condition is held in the conc vector
c        at location (N+1).
c     Lower boundary conditions:
c        Zero flux is specified at the ground
c
c     This version adapted from CAMx/HADVPPM.F for variable vertical grid
c     spacing following CMAQ/VPPM.F
c
c     The following definitions are used:  
c  
c              |-----------> Positive direction (upward)
c  
c     |<--------------------------Domain----------------->|Boundary
c  
c     | CON(1) | CON(2) |  ...  | CON(I) |  ...  | CON(N) | CON(N+1) 
c  
c     VEL(1)-->|     VEL(I-1)-->|        |-->VEL(I)       |-->VEL(N)  
c  
c      FP(1)-->|      FP(I-1)-->|        |-->FP(I)        |-->FP(N)  
c  
c      FM(2)<--|        FM(I)<--|        |<--FM(I+1)      |<--FM(N+1)  
c             
c                            -->|  DZ(I) |<-- 
c 
c      Copyright Ramboll
c  
c     Modifications:  
c        4/02/20   Original development
c        4/28/21   Added DDM sensitivities
c        8/30/22   Fixed sensitivity array dims to be consistent
c                  with ZADVEC and avoid accessing memory out-of-bounds
c  
c     Input arguments:  
c        nn                  Number of cells  
c        igrd                index of current grid
c        dtin                Time step (s)  
c        dz                  Layer depth vector (m)
c        con                 Concentration vector (umol/m3) 
c        vel                 Wind speed+entrainment vector (m/s)
c                                              -- positive = upward 
c        dil                 Layer depth dilution rate (m/s)
c                                              -- positive = increasing/diluting
c        sens                sensitivity coefficients(conc/parameter unit)
c        ldoipts             flag to calculate Process Analysis data
c  
c     Output arguments:  
c        con                 Concentration vector (umol/m3)  
c        sens                sensitivity coefficients(conc/parameter unit)
c        fluxlay             Flux across top of each layer (umol/m2/s)
c        fc1                 Conc entrained through bottom of layer (umol/m3)
c        fc2                 Conc entrained through top of layer (umol/m3)
c        fc3                 Conc diluted by layer expansion/contraction
c                            (umol/m3)
c  
c     Routines called:  
c        PPM
c  
c     Called by:  
c        ZADVEC  
c 
      implicit none
      include "camx.prm"
c
      integer nn
      integer igrd
      real dtin
      real dz(nn),con(nn+1),vel(nn),dil(nn),fluxlay(nn)
c
      integer i,n,nstep,isp
      integer nsp
      real x,y,cfl,dtmx,tmpz,vwind,dt
      real con1(MXLAYER+1)
      real con2(MXLAYER)
      real flxarr(MXLAYER)
      real fm(MXLAYER+1)
      real fp(MXLAYER)
cae   real cm(MXLAYER)
      real cl(MXLAYER)
      real cr(MXLAYER)
      real dc(MXLAYER)
      real c6(MXLAYER)
c
c-----Local parameters
c
      real, parameter :: TWO3RDS=2./3.
c
c===========================DDM Begin=================================
c
      real sens((MXLAYER+1),MXFDDM)
c
c     Note:  nddmsp is the total number of DDM parameters for which
c            sensitivities are tracked for the given species.
c
c===========================DDM End===================================
c
c
c================== Process Analysis Begin ===========================
c
      logical ldoipts
      real fc1(*)
      real fc2(*)
      real fc3(*)
c
c=================== Process Analysis End ============================
c
c
c-----Entry point 
c
      nsp = 1
      if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) nsp = nddmsp + 1
      do i = 1,nn
        fluxlay(i) = 0.
        fc1(i) = 0.
        fc2(i) = 0.
        fc3(i) = 0.
      enddo
c
c-----Time split based on CFL
c
      cfl = 0.9
      dtmx = dtin
      tmpz = cfl*dz(1)/(abs(vel(1)) + 1.e-10)
      dtmx = min(dtmx,tmpz)
      do i = 2,nn
        if (vel(i).gt.0. .and. vel(i-1).lt.0.) then
          vwind = abs(vel(i)) + abs(vel(i-1))
        else
          vwind = max(abs(vel(i)),abs(vel(i-1)))
        endif
        tmpz = cfl*dz(i)/(vwind + 1.e-10)
        dtmx = min(dtmx,tmpz)
      enddo
      nstep = INT( 0.999*dtin/dtmx ) + 1
      dt = dtin/FLOAT(nstep)
c
c-----Loop over timesteps
c
      do n = 1,nstep
c
c-----Loop over this species and all its DDM sensitivity paraemters
c
      do isp = 1,nsp

      if (isp.eq.1) then
        do i = 1,nn+1
          con1(i) = con(i)
        enddo
      else
c
c============================DDM Begin================================
c
c-----If sensitivities are requested, load additional arrays into con,
c     one array for each parameter sensitivity coefficient.
c     Both the concentration and sensitivities are loaded into the same
c     array and the equations are solved together.
c
c     Load all layers 1 through nn, and the upper boundary condition.
c
        if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
          do i = 1,nn+1
            con1(i) = sens(i,isp-1)
          enddo
        endif
c
c=============================DDM End=================================
c
      endif
c
c-----Set all fluxes to zero. Either positive or negative flux will
c     remain zero depending on the sign of the velocity
c
      do i = 1,nn
        fm(i+1) = 0.
        fp(i) = 0.
        flxarr(i) = 0.
      enddo
c
      call ppm(nn,dz,con1,cr,cl,dc,c6)
c
c-----Zero order polynomial at the boundary cells
c
cae   cm(2)  = con(2)
cae   cm(nn) = con(nn-1)
c
c-----First order polynomial at the next cells, no monotonicity constraint
c     needed
c
cae   cm(3)    = (con(3) + con(2))/2.
cae   cm(nn-1) = (con(nn-1) + con(nn-2))/2.
c
c-----Second order polynomial inside the domain
c
cae   do i = 3,nn-2
c
c-----Compute average slope in the i'th cell
c
cae     dc(i) = 0.5*(con(i+1) - con(i-1))
c      
c-----Guarantee that CM lies between CON(I) and CON(I+1)
c     monotonicity constraint
c     
cae     if ((con(i+1) - con(i))*(con(i) - con(i-1)).gt.0.) then
cae       dc(i) = sign(1.,dc(i))*min(
cae  &                               abs(dc(i)),
cae  &                               2.*abs(con(i+1) - con(i)),
cae  &                               2.*abs(con(i) - con(i-1)))
cae     else
cae       dc(i) = 0.
cae     endif
cae   enddo
c
cae   do i = 3,nn-3
cae     cm(i+1) = con(i) + 
cae  &            0.5*(con(i+1) - con(i)) + (dc(i) - dc(i+1))/6.
cae   enddo
c
cae   do i = 2,nn-1
cae     cr(i) = cm(i+1)
cae     cl(i) = cm(i)
cae   enddo
c
c-----Generate piecewise parabolic distributions
c
cae   do i = 2,nn-1
c
c-----Monotonicity
c 
cae     if ((cr(i) - con(i))*(con(i) - cl(i)).gt.0.) then
cae       dc(i) = cr(i) - cl(i)
cae       c6(i) = 6.*(con(i) - 0.5*(cl(i) + cr(i)))
c
c-----Overshoot cases
c
cae       if (dc(i)*c6(i) .gt. dc(i)*dc(i)) then
cae         cl(i) = 3.*con(i) - 2.*cr(i)
cae       elseif (-dc(i)*dc(i) .gt. dc(i)*c6(i)) then
cae         cr(i) = 3.*con(i) - 2.*cl(i)
cae       endif
cae     else
cae       cl(i) = con(i)
cae       cr(i) = con(i)
cae     endif
cae     dc(i) = cr(i) - cl(i)
cae     c6(i) = 6.*(con(i) - 0.5*(cl(i) + cr(i)))
cae   enddo
c
c-----Compute fluxes from the parabolic distribution
c
      do i = 2,nn
        y = max(0., -vel(i-1)*dt)
        x = y/dz(i)
        fm(i) = y*(cl(i) + 0.5*x*(dc(i) + c6(i)*(1. - TWO3RDS*x)))
        y = max(0., vel(i)*dt)
        x = y/dz(i)
        fp(i) = y*(cr(i) - 0.5*x*(dc(i) - c6(i)*(1. - TWO3RDS*x)))
      enddo
c
c-----Compute fluxes from boundary cells assuming uniform distribution
c
      if (vel(1).gt.0.) then
        y = vel(1)*dt
        fp(1) = y*con1(1)
      endif
c
      if (vel(nn).lt.0.) then
        y = -vel(nn)*dt
        fm(nn+1) = y*con1(nn+1)
      endif
c
c-----Update concentrations due to z-wind & cross-layer entrainment
c
      flxarr(1) = (fp(1) - fm(2))
      con2(1) = con1(1) - flxarr(1)/dz(1)
      do i = 2,nn
        flxarr(i) = (fp(i) - fm(i+1))
        con2(i) = con1(i) - (flxarr(i) - flxarr(i-1))/dz(i)
      enddo
c
c-----Account for layer dilution rate over this step, accumulate fluxes
c
      do i = 1,nn
        con2(i) = con2(i)*dz(i)/(dz(i) + dil(i)*dt)
      enddo
c
      if (isp.eq.1) then
        do i = 1,nn
          con(i) = con2(i)
          fluxlay(i) = fluxlay(i) + flxarr(i)/dtin
        enddo
c
c===================== Process Analysis Begin =========================
c
        if (ldoipts) then
          do i = 1,nn
            fc3(i) = fc3(i) - dt/dz(i)*dil(i)*con1(i)
          enddo
          fc1(1) = 0.
          do i = 2,nn
            fc1(i) = fc1(i) + flxarr(i-1)/dz(i)
          enddo
          do i = 1,nn
            fc2(i) = fc2(i) - flxarr(i)/dz(i)
          enddo
        endif
c
c====================== Process Analysis End ==========================
c
      else
c
c==============================DDM Begin===============================
c
        do i = 1,nn
          sens(i,isp-1) = con2(i)
        enddo
c
c===============================DDM End================================
c
      endif
c
      enddo ! End of species + DDM sensitivity loop

      enddo  !End timestep loop
c
      return
      end
c
c-------------------------------------------------------------------------------
c
      subroutine ppm(ni,ds,cn,cr,cl,dc,c6)

c-----Get PPM coefficients CR, CL, DC, and C6

      implicit none
      include "camx.prm"
c
c-----Arguments
c
      integer :: ni       ! number of layers
      real    :: ds(ni)   ! layer thickness
      real    :: cn(ni+1) ! column concentrations
      real    :: cr(ni)   ! layer r.h. (top) intercept
      real    :: cl(ni)   ! layer l.h. (bottom) intercept
      real    :: dc(ni)   ! cr - cl
      real    :: c6(ni)   ! coefficient of second-order term
c
c-----Local variables:
c
      integer i
      real a, b, c             ! temp lattice vars.
      real :: alpha (MXLAYER)  ! temp lattice var.
      real :: beta
      real :: chi   (MXLAYER)  ! lattice var. for dc
      real :: psi   (MXLAYER)  ! lattice var. for dc
      real :: mu    (MXLAYER)  ! lattice var. for cm
      real :: nu    (MXLAYER)  ! lattice var. for cm
      real :: lambda(MXLAYER)  ! lattice var. for cm
      real :: cm    (MXLAYER+1)! zone r.h. trial intercept
c
c-----Entry point
c
      do i = 2,ni-1
cae   do i = 3,ni-2
        alpha(i) = ds(i) + ds(i+1)
        beta     = ds(i-1) + ds(i)
        c        = ds(i)/(beta + ds(i+1))
        chi(i)   = c*(ds(i-1) + beta)/alpha(i)
        psi(i)   = c*(alpha(i) + ds(i+1))/beta
      enddo
      do i = 2,ni-2
cae   do i = 3,ni-3
        a     = ds(i)/alpha(i)
        b     = 2.0*ds(i+1)/alpha(i)
        c     = 1.0/(ds(i-1) + alpha(i) + ds(i+2))
        mu(i) = c*ds(i)*(ds(i-1) + ds(i))/(ds(i) + alpha(i))
        nu(i) = c*ds(i+1)*(ds(i+1) + ds(i+2))/(ds(i+1) + alpha(i))
        lambda(i) = a + mu(i)*b - 2.0*nu(i)*a
      enddo
c
c-----Zeroth order polynomial at the boundary cells
c
      cm(1)    = cn(1)
cae   cm(ni+1) = cn(ni)
      cm(ni+1) = cn(ni+1)
cae   cm(2)    = cn(2)
cae   cm(ni)   = cn(ni-1)
c
c-----First order polynomial at the next cells, no monotonicity constraint needed
c
      cm(2)  = (ds(1)*cn(2) + ds(2)*cn(1))/(ds(1) + ds(2))
      cm(ni) = (ds(ni-1)*cn(ni) + ds(ni)*cn(ni-1))/(ds(ni-1) + ds(ni))
cae   cm(3)  = (ds(2)*cn(3) + ds(3)*cn(2))/(ds(2) + ds(3))
cae   cm(ni-1) = (ds(ni-2)*cn(ni-1) + ds(ni-1)*cn(ni-2))/(ds(ni-2) + ds(ni-1))
c
c-----Second order polynomial inside the domain
c
      do i = 2,ni-1
cae   do i = 3,ni-2

c-----Compute average slope in i-th layer

        dc(i) = chi(i)*(cn(i+1) - cn(i)) + psi(i)*(cn(i) - cn(i-1)) ! equation (1.7)
c
c-----Guarantee that CM lies between CON(i) and CON(i+1) - monotonicity constraint
c
        if ((cn(i+1) - cn(i))*(cn(i) - cn(i-1)) .gt. 0.0) then
          dc(i) = sign(1.0,dc(i))* min(
     &                                 abs(dc(i)),
     &                                 2.0*abs(cn(i+1) - cn(i)),
     &                                 2.0*abs(cn(i) - cn(i-1)))
        else
          dc( i ) = 0.0
        endif           ! equation (1.8)
      enddo
c
      do i = 2,ni-2     ! equation (1.6)
cae   do i = 3,ni-3     ! equation (1.6)
        cm(i+1) = cn(i) + lambda(i)*(cn(i+1) - cn(i))
     &                  - mu(i)*dc(i+1) + nu(i)*dc(i)
      enddo
c
c-----Generate piecewise parabolic distributions
c
      do i = 1,ni
cae   do i = 2,ni-1
        cr(i) = cm(i+1) ! equation (1.15)
        cl(i) = cm(i)
c
c-----Monotonicity
c
        if ((cr(i) - cn(i))*(cn(i) - cl(i)) .gt. 0.0) then
          dc(i) = cr(i) - cl(i)  ! temporary computation of dc and c6
          c6(i) = 6.0*(cn(i) - 0.5*(cl(i) + cr(i)))
c
c-----Overshoot cases
c
          if (dc(i)*c6(i) .gt. dc(i)*dc(i)) then
            cl(i) = 3.0*cn(i) - 2.0*cr(i)
          elseif (-dc(i)*dc(i) .gt. dc(i)*c6(i)) then
            cr(i) = 3.0*cn(i) - 2.0*cl(i)
          endif
        else    ! local extremum: interpolation function is set to be a constant
          cl(i) = cn(i)
          cr(i) = cn(i)
        endif
        dc(i) = cr(i) - cl(i)    ! equation (1.5)
        c6(i) = 6.0*(cn(i) - 0.5*(cl(i) + cr(i)))
      enddo

      return
      end

      subroutine rdfgcon(idate,btim)
      use filunit
      use grid
      use chmstry
      use camxfld
c
c----CAMx v7.40 260801
c
c     RDFGCON reads the instantaneous file for the fine grids
c
c      Copyright Ramboll
c
c     Modifications:
c        04/39/09  --gwilson-- Fixed bug that caused the wrong
c                              grid to get initialized when doing
c                              flex-nesting with OMP on. Needed 
c                              to initialize the variable irdgrd.
c
c     Input arguments:
c        idate               beginning date of simulation (YYJJJ)
c        btim                beginning time of simulation (HHMM)
c
c     Output arguments:
c        none
c
c     Routines called:
c        none
c
c     Called by:
c        READCNC
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
      integer   idate
      real      btim
c
      character*60 msg
      character*10 cname
      integer      numfin, nspcs, ndate, indate
      integer      ixfb, jyfb, ixfe, jyfe, nhf, nvf
      integer      ifgptr, ifglvl, idx, i, j, k, l, igrd
      integer      ibgdat, isoa
      real         ttime, timein, begtim
      logical      lmatch
c
      character*10 cspec(MXSPEC)
      integer      nfx(MXGRID)
      integer      nfy(MXGRID)
      integer      nfz(MXGRID)
      integer      irdgrd(MXGRID)
      logical      lread(MXGRID)
      real         cnctmp(MXCELLS,MXCELLS)
c
c-----Entry point:
c
c --- initialize the "read-in" flag ---
c
      do i=1,ngrid
        lread(i) = .FALSE.
        irdgrd(i) = 0
      enddo
c
c --- if the file was not supplied then all of the grids are
c     to be assigned ----
c
      if(  irstf .LE. 0 ) goto 222
c
c --- otherwise get whatever grids are available ---
c
      ndate = idate
      ttime = btim
      if (ttime.eq.2400.) then
        ttime = 0.
        ndate = ndate + 1
          if( MOD(ndate,1000) .GT. 365 ) then
           if( MOD(INT(ndate/1000),4) .EQ. 0 ) then
              if( MOD(ndate,1000) .EQ. 367 )
     &                     ndate = (INT(ndate/1000)+1)*1000 + 1
           else
              ndate = (INT(ndate/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c-----File description header
c
      read(irstf,ERR=7000) msg
      read(irstf,ERR=7000) numfin, nspcs
      if( nspcs .GT. MXSPEC ) then
        write(iout,'(//,A)') 'ERROR in RDFGCON:'
        write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
        write(iout,*) 'Please change the value for parameter: MXSPEC'
        write(iout,*) 'It should be set to a value of at least: ',nspcs
        call flush(iout)
        call camxerr()
      endif
c
c-----Species list
c
      read(irstf,ERR=7000) (cspec(i),i=1,nspcs)
c
c-----Make sure species list is compatable
c
      do 10 l = 1,nspec
        do 20 lic = 1,nspcs
          cname = cspec(lic)
          if (cname.eq.'HNO2      ') cname = 'HONO      '
          if (cname.eq.'HCHO      ' .and. kHCHO.eq.nspec+1)
     &                                        cname = 'FORM      '
          do isoa=1,NUM_SOAP_SPECIES
             if( cname .EQ. soap2_spec_names(isoa) ) 
     &                           cname = soap3_spec_names(isoa)
          enddo
          if (cname.eq.spname(l)) then
            if( lic.ne.licmap(l) ) goto 7004
            goto 10
          endif
   20   continue
   10 continue
c
c-----Read the fine grid descriptions, and check for consistancy
c
      do 30 ifin=1,numfin
        read(irstf,ERR=7000) ixfb, jyfb, ixfe, jyfe, nhf, nvf, 
     &                           nfx(ifin), nfy(ifin), nfz(ifin), 
     &                           ifgptr, ifglvl
        do igrd = 2,ngrid
           lmatch = .TRUE.
           if( ixfb .NE. inst1(igrd) ) lmatch = .FALSE.
           if( jyfb .NE. jnst1(igrd) ) lmatch = .FALSE.
           if( ixfe .NE. inst2(igrd) ) lmatch = .FALSE.
           if( jyfe .NE. jnst2(igrd) ) lmatch = .FALSE.
           if( nhf .NE. meshold(igrd) ) lmatch = .FALSE.
           if( nvf .NE. meshold(igrd) ) lmatch = .FALSE.
           if( nfx(ifin) .NE. ncol(igrd) ) lmatch = .FALSE.
           if( nfy(ifin) .NE. nrow(igrd) ) lmatch = .FALSE.
           if( nfz(ifin) .NE. nlay(igrd) ) lmatch = .FALSE.
           if( lmatch ) then 
               lread(mapgrd(igrd)) = .TRUE.
               irdgrd(mapgrd(igrd)) = ifin
           endif
        enddo
   30 continue
c
c-----Make sure time span is correct
c
  111 continue
      read(irstf,ERR=7000,END=7002) timein, indate
      ibgdat = indate
      begtim = timein
      if (begtim.eq.2400.) then
        begtim = 0.
        ibgdat = ibgdat + 1
        if( MOD(ibgdat,1000) .GT. 365 ) then
           if( MOD(INT(ibgdat/1000),4) .EQ. 0 ) then
              if( MOD(ibgdat,1000) .EQ. 367 )
     &                       ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
           else
              ibgdat = (INT(ibgdat/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c-----Read the data for this hour
c
      do 70 ifin=1,numfin
        igrd = 0
        do n = 2,ngrid
          if( irdgrd(n) .EQ. ifin ) igrd = n
        enddo
        do 80 l=1,nspcs
          do 90 k=1,nfz(ifin)
            read(irstf) ((cnctmp(i,j),i=1,nfx(ifin)),
     &                                          j=1,nfy(ifin))
            do 91 lmod=1,nspec
              lic = licmap(lmod)
              if( lic .NE. l ) goto 91
c
c-----Find the grid in this setup and load into gridded array---
c
               if( igrd .NE. 0 ) then
                  do 11 j=1,nrow(igrd)
                    do 21 i=1,ncol(igrd)
                      idx = i + ncol(igrd)*(j-1) + 
     &                   ncol(igrd)*nrow(igrd)*(k-1) +
     &                   ncol(igrd)*nrow(igrd)*nlay(igrd)*(lmod-1)
                      conc(iptr4d(igrd)-1+idx) = cnctmp(i,j)
   21               continue
   11             continue
               endif
   91        continue
   90     continue
   80   continue
        if( igrd .NE. 0 ) write(iout,'(a40,f7.0,i8.5,a,i3)')
     &     'Read fine grid restart file at ',timein, indate,' grid',igrd
   70 continue
c
c-----Load data for the grids not found in restart file----
c
  222 continue
      do ip = 1,ngrid
         do ic = 1,nchdrn(ip)
           ig = idchdrn(ic,ip)
           if( .NOT. lread(ig) ) then
              write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Assigning concs from parent grid at ',
     &         btim, idate,' grid',ig
              call rassgn4d(ncol(ip),nrow(ip),nlay(ip),nspec,i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),nlay(ig),
     &                      conc(iptr4d(ip)),conc(iptr4d(ig)) )
           endif
         enddo
      enddo
c
      goto 9999
c
c-----Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDFGCON:'
      write(iout,9000,ERR=9999)'Reading the header of the ',
     &     'concentration initialization file for fine grids. '
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDFGCON:'
      write(iout,9000,ERR=9999) 'Concentration ',
     &   'initialization file for fine grids is not for correct ',
     &                               'time period; '
      write(iout,9001,ERR=9999) 'Premature EOF reached.'
      write(iout,9001,ERR=9999) 'Simulation Start: ',idate,btim
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in RDFGCON:'
      write(iout,9000,ERR=9999) 'Species list for ',
     &            'concentration initialization file for fine grids ',
     &          'is inconsistent with user parameters.'
      write(iout,9004,ERR=9999) 'Species number: ',l,' should be ',
     &                      spname(l),' and ',cname,' was read instead.'
      call camxerr()
c
c-----Format statements
c
 9000 format(/,1X,6A)
 9001 format(1X,A,I10.5,F10.1)
 9004 format(1X,A,I5,5A)
c
 9999 continue
c
      return
      end

      subroutine nodes_alloc(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use grid_nodes
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use rtcmcchm
      use tracer
      use grid_dims, only : maxgrds,maxmach 
      use camxfld   
      use master_mod 
      use node_mod  
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine allocates all of the data structures for the 
c        compute nodes when running in MPI mode.  
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numprocs            the number of processes
c     Output:  
c
c    Called by:
c       SIM_INIT
c    Subroutines called:
c       NODES_PASS
c       ALLOC_FILUNIT
c       ALLOC_GRID
c       ALLOC_GRID_NODES
c       BROADCAST_PROCID
c       DOMAIN_DECOMP
c       MPI_BARRIER
c       BROADCAST_GRID_DIMENS
c       INIPTR_NODE
c       INIT_FIELDS_NODE
c       ALLOC_CAMXCOM
c       ALLOC_CHMSTRY
c       ALLOC_CHMSTRY_AVG
c       ALLOC_GRID_ROW
c       ALLOC_GRID_LAY
c       ALLOC_GRID_PTSRC
c       ALLOC_GRID_2D_NODE
c       ALLOC_CAMXFLD_NODE
c       ALLOC_BNDARY
c       ALLOC_PTEMISS
c       ALLOC_O3COL_NODE
c       ALLOC_PIGSTY
c       ALLOC_PROCAN_IPA
c       ALLOC_TRACER_NULL
c       ALLOC_TRACER_CLASS
c       ALLOC_TRACR_SPECS
c       ALLOC_TRACER
c       ALLOC_TRACER_FULL
c       ALLOC_TRACER_PTS
c       ALLOC_TRACER_PTSRCE
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       12/15/08    --gwilson--  Added code to handle averaging of
c                                radicals
c       03/15/09     --gwilson-- Added code for deposition output 
c                                for tracers
c       10/29/09    --cemery--   Added code for RTRAC surface model
c       04/30/13    --cemery--   Added surface model
c       03/01/16    --gwilson--  Added partial source area map
c       07/23/18    --bkoo--     Added Bi-Di NH3 drydep flag
c                                Added ALLOC_LDDMCALC call
c                                Removed npartial & lddmcalc
c       08/09/18    --bkoo--     Added variables for rate term sensitivity
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'rtracsrf.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ierr, mvecedge
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.not. lmpi .and. iproc_id .gt. 0) return
c
c  --- send the variables for array dimensioning ---
c
      call nodes_pass(ngrid, 1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nspec, 1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nemspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nptsrc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ngas,  1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(naero, 1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrad,  1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nreact,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nphot1,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nphot2,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nlu,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(navspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ndepspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nsmspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nsmrxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lproca,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ltrace,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(tectyp,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(lsa_ioric,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(num_ioric,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ncls_ioric,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_ioric,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_iorbc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(num_iorbc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ncls_iorbc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iorbc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrd_sa_bc_hdr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_iortc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ncls_iortc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iortc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrd_sa_tc_hdr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_3davrg,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lptdepout,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lddm,  1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lhddm, 1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lirr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lptsrc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ntotsp,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(soap3_ntotsp,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nsaspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(notimespc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ntrcls,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(soap3_ntrcls,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ngroup,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lsrfmod,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsrfmodrt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lixemis,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lixbypass,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lbidinh3,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lstrato3,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lgas_out_ppm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lzppm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lparttn,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(nrtgas,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lrtgas,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(nrtaero,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lrtaero,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(nrtrac,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrtphot,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrtherm,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrcprt,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(isolv,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ijac,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(rtolrtc,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(atolrtc,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ktype,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrxnrtc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(icunit,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(itunit,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(njschm,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nzschm,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(mtype,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ngasrtc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nfstrtc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nslortc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(neqmrtc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nfixrtc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ngasschm,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(njactrm,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrxupdt,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nam_M,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(nam_O2,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(nam_N2,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(nam_H2O,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(nam_H2,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(nam_CH4,10,MPI_CHARACTER,itag,numprocs,iproc_id)
c
c  --- if this is a compute process, allocate the data structures ---
c
      if (iproc_id .gt. 0) allocate(nemiss_files(ngrid))
      call nodes_pass(nemiss_files,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(npoint_files,1,MPI_INTEGER,itag,numprocs,iproc_id)
      if (iproc_id .gt. 0) then
         call alloc_filunit(ngrid,nemiss_files,MAX(npoint_files,1))
         call alloc_grid()
      endif
c
c  --- pass the allocated variables needed later  ---
c
      call nodes_pass(ncol,       ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrow,       ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nlay,       ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nlayers_ems,    1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr2d,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr2d_full,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr3d,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr3d_full,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr4d,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptrav,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptrem,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptr1lay,   ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptrlu,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptrdp,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptrsm,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipsa3d,     ngrid,MPI_INTEGER8,itag,numprocs,iproc_id)
      call nodes_pass(ipsa3d_ems, ngrid,MPI_INTEGER8,itag,numprocs,iproc_id)
      call nodes_pass(ipsa2d,     ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipsa2d_avrg,ngrid,MPI_INTEGER8,itag,numprocs,iproc_id)
      call nodes_pass(iptrcig,    ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lchem,          1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(l3davg,     ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(nrateddm,       1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrateddm,       1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nhddm,          1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nddmsp,         1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jdpmap,  NSDDMPM,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- call the routines to setup the slices for each processor ---
c
      call alloc_grid_nodes(ngrid,numprocs)
      call broadcast_procid(iproc_id,numprocs)
      if (iproc_id .eq. 0) call domain_decomp()
      call MPI_Barrier(MPI_COMM_WORLD,ierr)
      call broadcast_grid_dimens(iproc_id,numprocs)
c
c  --- if this is a compute process, allocate the data
c      structures and wait for the data to arrive ---
c
      if (iproc_id .GT. 0) then
         call iniptr_node()         
         call init_fields_node(1)  
         call alloc_camxcom(ngrid)
         call alloc_chmstry(ngrid,nspec,nemiss_files,npoint_files,
     &                                        nreact,nphot1,nphot2)
         call alloc_chmstry_avg(navspc)
         call alloc_emiss_array(ngrid,mmxp,mmyp,nlayers_ems,MAX(1,nemspc))
         call alloc_grid_row(nrow) 
         call alloc_grid_lay()
         call alloc_grid_ptsrc(MAX(1,MXPTSRC))
         call alloc_grid_2d_node(maxgrds, mmxp, mmyp)
         call alloc_camxfld_node(nspec,ngrid,navspc,ndepspc,nsmspc,
     &                              ncol,nrow,nlay,l3davg,ncol(1),nrow(1))
         call alloc_bndary(ngrid,mmxp,mmyp,nlay,nspec)
         call alloc_ptemiss(nspec,ngrid,nptsrc)
         call alloc_o3col_node(ngrid, maxgrds, mmxp,mmyp) 
      endif
      call nodes_pass(nptspc,npoint_files,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lapca,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lapcapt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ipigflg,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nreactr,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(npa_cels,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lsample,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsmptrc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lbckgrd,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(nsample,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrtsmpcels,1,MPI_INTEGER,itag,numprocs,iproc_id)
      if( iproc_id .GT. 0 ) then
         call alloc_lddmcalc(ngrid)
         if( ipigflg .NE. 0 ) then
            call alloc_pigsty(nspec,nreactr,ngrid,numprocs,ipigflg)
            call alloc_pigsty_vpconc(mmxp,mmyp,mmzp,nspec,ngrid)
            if( lsample ) call alloc_pigsty_sample()
         endif
         call alloc_procan_ipa(ngrid,ncol,nrow,nlay,tectyp,iproc_id)
         if( lproca ) then
           call alloc_procan_init(ngrid,MXCPA)
         endif
         if( .NOT. ltrace .AND. .NOT. lddm .AND. .NOT. lhddm ) then
            call alloc_tracer_null(nspec,lirr,ngrid,ncol,nrow)
            if( lirr ) call alloc_procan_irr(ngrid,mmxp,mmyp,mmzp,
     &                                       ntotsp,iout)
         else
            if( lddm .OR. lhddm ) then
               allocate( rateddm(nrateddm) )
               allocate( iprate(0:nreact, nrateddm ) )
               allocate( termddm(ntermddm) )
               allocate( ipterm(0:ngas, nreact, ntermddm ) )
               allocate( wfterm(  ngas, nreact, ntermddm ) )
               allocate( ptwetfld(1) )
               allocate( hddmsp(2,nhddm) )
               mvecedge = MAX(ncol(1),nrow(1))
               call alloc_ddm(.TRUE.,ngrid,mmxp,mmyp,nlay,nlayers_ems,
     &                                nspec,nddmsp,nhddm,mvecedge,iout)
               call alloc_ddm_species(nspec)
            else
               mvecedge = MAX(ncol(1),nrow(1))
               call alloc_tracer_specs(ngrid,mmxp,mmyp,mmzp,nlayers_ems,
     &                                              tectyp,mvecedge,iout)
            endif
            call alloc_tracer_class(nspec)
            call alloc_tracer_vdep(ngrid,mmxp,mmyp,ntotsp)
            call alloc_tracer(ngroup,ngrid,mmxp,mmyp,mmzp,nspec)
            call alloc_tracer_full(ngroup,ngrid,ncol,nrow)
            call alloc_tracer_pts(MAX(nptsrc,1))
            if( lptsrc ) then
              call alloc_tracer_ptsrce(nptsrc)
              call alloc_tracer_sapnts(nptsrc,soap3_ntotsp)
            else
              call alloc_tracer_ptsrce(1)
              call alloc_tracer_sapnts(1,1)
            endif
         endif
      endif
      call nodes_pass(lpartial,1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  --- pass the sampling grid information and allocate the 
c      the gridded arrays for the slices ----
c
      if( ipigflg .GT. 0 .AND. lsample ) then
         call nodes_pass(ismp1,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(ismp2,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(jsmp1,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(jsmp2,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(meshsmp,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(ncolsmp,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(nrowsmp,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(ismpgrd,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(ipsmp,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(xorgsmp,nsample,MPI_REAL,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(yorgsmp,nsample,MPI_REAL,itag,
     &                                                numprocs,iproc_id)
         if( iproc_id .GT. 0 ) then
            call alloc_pigsty_smpgrd(navspc,nsample,
     &                                          nrowsmp,ncolsmp,nsmpcels)
            if( lsmptrc ) then
               call alloc_tracer_sample_io(nsample,iproc_id)
               call alloc_tracer_sample(nsample,ncolsmp,nrowsmp,nrtsmpcels)
            endif
         endif
         if( lsmptrc ) then
             call nodes_pass(iprtsmp,nsample,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         endif
      endif
c
c  --- call routine to find the slices with edge cells and send
c      the information to the slices ---
c
      if( iproc_id .EQ. 0 ) call find_edge()
      call nodes_pass(nodeedge,nmachs,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  --- return to the calling routine ---
c
      end

      subroutine lsrxn_pig(H2O,M,O2,CH4,H2,y,dbrk,r)
      implicit none
c
c----CAMx v7.40 260801
c
c     LSRXN_pig computes double precision fluxes for each reaction
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CAMx PiG NO/NO2/O3/HNO3/H2SO4
c
c     Routines Called:
c        none
c
c     Called by:
c        LSRATE_pig
c
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
      double precision H2O, M, O2, CH4, H2, N2
      double precision y(*)
      double precision dbrk(*)
      double precision r(*)
c
c --- Entry point
c
      N2  = M - O2
      r(  1) = dbrk(  1)*y(l_NO2)
      r(  2) = dbrk(  2)*y(l_O)*O2*M
      r(  3) = dbrk(  3)*y(l_O3)*y(l_NO)
      r(  4) = dbrk(  4)*y(l_NO)*y(l_NO)*O2
      r(  5) = dbrk(  5)*y(l_NO)*y(l_NO2)*H2O
      r(  6) = dbrk(  6)*y(l_O3)
      r(  7) = dbrk(  7)*y(l_O1D)*M
      r(  8) = dbrk(  8)*y(l_O1D)*H2O
      r(  9) = dbrk(  9)*y(l_HONO)
      r( 10) = dbrk( 10)*y(l_NO2)*y(l_OH)
      r( 11) = dbrk( 11)*y(l_NO2)*y(l_O3)
      r( 12) = dbrk( 12)*y(l_NO3)
      r( 13) = dbrk( 13)*y(l_NO3)
      r( 14) = dbrk( 14)*y(l_NO3)*y(l_NO)
      r( 15) = dbrk( 15)*y(l_NO3)*y(l_NO2)
      r( 16) = dbrk( 16)*y(l_NO3)*y(l_NO2)
      r( 17) = dbrk( 17)*y(l_N2O5)
      r( 18) = dbrk( 18)*y(l_N2O5)*H2O
      r( 19) = dbrk( 19)*y(l_SO2)*y(l_OH)
      r( 20) = dbrk( 20)*y(l_OH)*y(l_CO)
      r( 21) = dbrk( 21)*y(l_FORM)
      r( 22) = dbrk( 22)*y(l_FORM)
      r( 23) = dbrk( 23)*y(l_HO2)*y(l_NO)
c
      return
      end

      subroutine wrtsmp(lrtrac,tim2,idat2,iunit,nox,noy,noz,nsamp,
     &                  cncfld)
      use camxcom
      use chmstry
      use tracer

c
c----CAMx v7.40 260801
c 
c     WRTSMP writes average concentration fields from a PiG sampling grid
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        8/2/05       Generalized to output regular model species or
c                     RTRAC species.
c 
c     Input arguments:
c        tim2                output time (HHMM)
c        idat2               output date (YYJJJ)
c        iunit               output unit
c        nox                 number of cells in x-direction
c        noy                 number of cells in y-direction
c        noz                 number of layers
c        nsamp               number of species
c        cncfld              concentration field to output (ppm or ug/m3)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c 
      implicit none
      include 'camx.prm'
c
      integer MXOUT
      parameter (MXOUT = MAX(MXSPEC,MXTRSP))
c
      logical lrtrac
      integer idat2,iunit,nox,noy,noz,nsamp
      real tim2,cncfld(nox,noy,noz,nsamp)
      integer nseg,idat1,i,j,k,l,n
      real etim,btim
      character*4 ispec(10,MXOUT)
c
      data nseg /1/
c
c-----Entry point
c
c-----Determine time/date range
c
      idat1 = idat2 
      etim = AINT(ANINT(tim2)/100.) + amod(ANINT(tim2),100.)/60.
      btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      if (btim.lt.0.) then 
        btim = btim + 24. 
        idat1 = idat1 - 1 
        if (MOD(idat1,1000) .EQ. 0 ) then
          if ( MOD(INT(idat1/1000)-1,4) .EQ. 0 ) then
            idat1 = (INT(idat1/1000)-1)*1000 + 366
          else
            idat1 = (INT(idat1/1000)-1)*1000 + 365
          end if
        endif
      endif 
      write(iunit) idat1,btim,idat2,etim
c
c-----Load species names and write date stamp
c
      if (lrtrac) then
        do l = 1,nsamp
          read(ptname(l),'(10a1)') (ispec(n,l),n=1,10)
        enddo
      else
        do l = 1,nsamp
          read(spname(lavmap(l)),'(10a1)') (ispec(n,l),n=1,10)
        enddo
      endif
c
c-----Write gridded concentration field
c
      do l = 1,nsamp
        do k = 1,noz
          write(iunit) nseg,(ispec(n,l),n=1,10),
     &                 ((cncfld(i,j,k,l),i=1,nox),j=1,noy)
        enddo
      enddo
      call flush(iunit)
      return
      end

c**** RDOPTPA
c
      subroutine rdoptpa()
      use filunit
      use grid
      use procan
      use tracer
      implicit none
c  
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the user options and flags for the
c     process analysis algorithm.
c
c      Copyright Ramboll
c
c     Argument description:      
c           none
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/08/00   --gwilson--    Original development
c     10/06/04   --cemery --    Restructured for namelist input
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer      igrd, nox, noy, n
      logical      lerror
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- if option is turned off, just return ---
c
      if( .NOT. lproca ) goto 9999
c
c   ---- Number of Process Analysis domains
c
      npadom = Number_of_PA_Domains
c
c   ---- Allocate the arrays that are dimensioned by grids ---
c
      if( npadom .LE. 0 ) goto 7004
      call alloc_procan(ngrid,ncol,nrow,nlay,.FALSE.)
c
c   ---- PA domain definitions ---
c
      do n = 1,npadom
c
c   --- the grid number ---
c
         ipagrd(n) = Within_CAMx_Grid(n)
         if( ipagrd(n) .LE. 0 .OR. ipagrd(n) .GT. ngrid ) goto 7005
c
c   --- the cell indexes in the X adn Y directions
c
         i_sw(n) = PA_Beg_I_Index(n)
         i_ne(n) = PA_End_I_Index(n)
         j_sw(n) = PA_Beg_J_Index(n)
         j_ne(n) = PA_End_J_Index(n)
         b_lay(n) = PA_Beg_K_Index(n)
         t_lay(n) = PA_End_K_Index(n)
c
c   --- check for valid cell indexes ---
c
         lerror = .FALSE.
         igrd = ipagrd(n)
         if( igrd .GT. 1 ) then
            nox = (inst2(igrd) - inst1(igrd) + 1 ) * meshold(igrd) + 2
            noy = (jnst2(igrd) - jnst1(igrd) + 1 ) * meshold(igrd) + 2
         else
            nox = ncol(1)
            noy = nrow(1)
         endif
         if( i_sw(n) .LE. 0 .OR. i_sw(n) .GT. i_ne(n) ) lerror = .TRUE. 
         if( i_ne(n) .GT. nox ) lerror = .TRUE. 
         if( j_sw(n) .LE. 0 .OR. j_sw(n) .GT. j_ne(n) ) lerror = .TRUE. 
         if( j_ne(n) .GT. noy ) lerror = .TRUE. 
         if( b_lay(n) .LE. 0 .OR. b_lay(n) .GT. t_lay(n) ) 
     &                                                  lerror = .TRUE.
         if( t_lay(n) .GT. nlay(igrd) ) lerror = .TRUE.
         if( lerror ) goto 7006
      enddo
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in RDOPTPA:'
      write(iout,'(1X,2A,I3)') 'Invalid value for number of ',
     &                   'Process Annalysis domains: ',npadom
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in RDOPTPA:'
      write(iout,'(1X,2A,I3)') 'Invalid value for grid number for ',
     &                         'Process Analysis domain: ',ipagrd(n)
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in RDOPTPA:'
      write(iout,'(1X,A,I3,A)') 'Cell indexes for CSA sub-domain: ',n,
     &                                                 ' are invalid.'
      write(iout,'(10X,A,I3,10X,A)') 'Sub-Domain #',n,'Grid Definition'
      write(iout,'(14X,2A,18X,A,I3)') 'Beg ',' End','Grid #',igrd
      write(iout,'(A10,1X,2I5,20X,I5)') 'Rows    :',i_sw(n),i_ne(n),nox
      write(iout,'(A10,1X,2I5,20X,I5)') 'Columns :',j_sw(n),j_ne(n),noy
      write(iout,'(A10,1X,2I5,20X,I5)') 'Layers  :',
     &                                    b_lay(n),t_lay(n),nlay(igrd)
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c**** NCF_WRT_DATA_SPECIES
c
      subroutine ncf_wrt_data_species(action,iounit,igrd,num_dims,
     &          num_cols,num_rows,num_lays_grid,num_lays_conc,
     &               num_lays_out,nspcs,spec_name,is_output_species,
     &                                          cncfld,height)
      use ncf_iomod
      use grid
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the data for the timestep variables to the
c    NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action        C name of file to open
c           iounit        I NetCDF file ID of file
c           igrd          I grid number
c           num_dims      I number of dimensions in this data 
c           num_cols      I number of columns in this grid
c           num_rows      I number of rows in this grid
c           num_lays_grid I number of layers in the array
c           num_lays_conc I number of layers in the conc array
c           num_lays_out  I number of layers in the array
c           nspcs         I number of species in the file
c           cncfld        R gridded array of concentrations
c           height        R gridded array of layer heights   
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'netcdf.inc'
      include 'filunit.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
      integer       igrd
      integer       num_dims
      integer       num_cols
      integer       num_rows
      integer       num_lays_grid
      integer       num_lays_conc
      integer       num_lays_out
      integer       nspcs
      character*(*) spec_name(nspcs)
      logical       is_output_species(nspcs)
      real          cncfld(num_cols,num_rows,num_lays_conc,nspcs)      
      real          height(num_cols,num_rows,num_lays_grid)

c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*14 this_var
      integer      data_start(4), data_count(4), ispc, i, j, k
      integer      ierr, this_varid, ibegcel, iendcel, jbegcel, jendcel
      integer      buffer_offset, itmp, jtmp
      real,        allocatable, dimension(:,:,:) :: array_3d
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- set the position in the NetCDF variable to write ---
c
      data_start(3) = 1
      data_count(3) = num_lays_out
      data_start(4) = ncf_cur_tstep
      data_count(4) = 1
c
c  --- allocate the array that will be used to write the data ---
c
      if( igrd .EQ. 1 ) then
         data_start(1) = 1
         data_count(1) = num_cols
         data_start(2) = 1
         data_count(2) = num_rows
         ibegcel = 1
         iendcel = num_cols
         jbegcel = 1
         jendcel = num_rows
         buffer_offset = 0
         allocate( array_3d(num_cols,num_rows,num_lays_out) )
      else
         data_start(1) = 1
         data_count(1) = num_cols-2
         data_start(2) = 1
         data_count(2) = num_rows-2
         ibegcel = 2
         iendcel = num_cols-1
         jbegcel = 2
         jendcel = num_rows-1
         buffer_offset = 1
         allocate( array_3d(num_cols-2,num_rows-2,num_lays_out) )
      endif
      
c
c  --- first do the z variable ---
c
      do k=1,num_lays_out
         do j=jbegcel,jendcel
            jtmp = j-buffer_offset
            do i=ibegcel,iendcel
               itmp = i-buffer_offset
               array_3d(itmp,jtmp,k) = height(i,j,k)
            enddo
         enddo
      enddo
c
c  --- get the id for the z variable and write the data ---
c
      this_var = "z"
      ierr = nf_inq_varid(iounit,"z",this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_vara_real(iounit,this_varid,data_start,data_count,array_3d)
      if( ierr .NE. NF_NOERR ) goto 7001
c
c  --- loop over all variables in this file ---
c
      do ispc=1,nspcs
c
c  --- skip if not writing this species ---
c
         if( .NOT. is_output_species(ispc) ) cycle
c
c  --- get name for this variable, and get it's variable ID
c      in this file ---
c
         this_var = spec_name(ispc)
         call jstlft(this_var)
         ierr = nf_inq_varid(iounit,this_var(:istrln(this_var)),this_varid)
         if( ierr .NE. NF_NOERR ) goto 7000
c
c  --- load the data into the local array to write ---
c
         if( num_dims .EQ. 4 ) then
             do k=1,num_lays_out
               do j=jbegcel,jendcel
                  jtmp = j-buffer_offset
                  do i=ibegcel,iendcel
                     itmp = i-buffer_offset
                     array_3d(itmp,jtmp,k) = cncfld(i,j,k,ispc)
                   enddo
                enddo
             enddo
c
           ierr = nf_put_vara_real(iounit,this_varid,data_start,data_count,array_3d)
           if( ierr .NE. NF_NOERR ) goto 7001
         else
           do j=jbegcel,jendcel
             jtmp = j-buffer_offset
             do i=ibegcel,iendcel
                itmp = i-buffer_offset
                array_3d(itmp,jtmp,1) = cncfld(i,j,1,ispc)
             enddo
           enddo
c
           ierr = nf_put_vara_real(iounit,this_varid,data_start,data_count,array_3d)
           if( ierr .NE. NF_NOERR ) goto 7001
         endif
c
      enddo
c
c  ---- deallocate the array ---
c
      deallocate( array_3d )
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_SPECIES:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_DATA_SPECIES:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot write data for the variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c*** RDSCHM
c
      subroutine rdschm(ldbg)
      use filunit
      use chmstry
      use tracer
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine reads a SCICHEM chemical mechanism input file
c     (IMC format file) that defines the chemistry for the RTCMC
c     probing tool.
c
c     Assumtions:
c     - Species names must begin with a letter
c     - Line length < 240
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Outputs:    
c       ldbg         L      flag to turn on diagnostic statements
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c    04/13/07   --gyarwood--    Rate expressions for SCICHEM2012
c    05/24/13   --gyarwood--    Photolysis and deposition can point to
c                               core model rates
c    11/13/20   --gyarwood--    Enable RTCMC to read deposition
c                               parameters
c    04/05/21   --cemery--      Enable RTCMC to read scaling factor for
c                               photolysis reactions that point to core
c                               mech reactions
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      logical   ldbg
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer idxspc
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, k, nline
      logical   lhit, lend, lcont, lspec, ltabl, lequa
      character*1   letr
      character*8   word
      character*10  spec
      character*240 line
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      ldbg = .true.
c
      write(idiag,'(//,A,//)',ERR=7009)
     &       ' ******* Reading RTCMC chemical definitions file.'
c
c  --- open the file ----
c
      open(unit=iorchm,file=chmfil,ERR=7010,status='OLD')
c
c --- Set the names of fixed species
c
      nam_M   = 'M'
      nam_O2  = 'O2'
      nam_N2  = 'N2'
      nam_H2O = 'H2O'
      nam_H2  = 'H2'
      nam_CH4 = 'CH4'
c
c --- Allocate RTCMC variables
c
      call alloc_rtcmc(MXTRSP,MXSPEC,MXRX,
     &                 MXKPRM,MXPHOT,MXZEN,MXRCT,MXPRD,
     &                 MXJACTRM,MXEQM,MXSLO)
c
c --- Identify and read sections of the IMC format input file
c
      lend  = .false.
      lcont = .false.
      lspec = .false.
      ltabl = .false.
      lequa = .false.
      nline = 1
      read (iorchm, '(A)', end=200, err=8000) line
      if( istrln(line) .EQ. 0 ) goto 200

 100  read (line, '(A1)') letr
      if( letr .NE. '#' ) goto 8002
      read (line, '(A1,A6)') letr, word
      call toupper( word )
      if( word .EQ. 'CONTRO  ' ) then
         call rdscctl(iorchm, line, nline, lend)
         lcont = .true.
      elseif( word .EQ. 'SPECIE  ' ) then
         call rdscspc(iorchm, line, nline, lend)
         lspec = .true.
      elseif( word .EQ. 'TABLE   ' ) then
         call rdsctbl(iorchm, line, nline, lend)
         ltabl = .true.
      elseif( word .EQ. 'EQUATI  ' ) then
         if( mtype .EQ. 2 ) then
            call rdscmch(iorchm, line, nline, lend)
         else
            call rdozmch(iorchm, line, nline, lend)
         endif
         lequa = .true.
      else 
         read (iorchm, '(A)', end=200, err=8000) line
         nline = nline + 1
      endif
      if( lend .OR. istrln(line) .EQ. 0 ) goto 200
      goto 100

 200  if( .NOT. lcont ) then
         word = 'Control '
         goto 8003
      elseif( .NOT. lspec ) then
         word = 'Species '
         goto 8003
      elseif( .NOT. ltabl ) then
         word = 'Table   '
         goto 8003
      elseif( .NOT. lequa ) then
         word = 'Equation'
         goto 8003
      endif
c
c --- Check the mechanism
c
c --- Renumber the photolysis table to sequential reaction numbering
c
      write(idiag,'(/,A)')
     & ' Checking the mechanism read by RDSCHM'
      if( njschm .GT. 0 ) then
         do i = 1,njschm
            do j = 1,nrxnrtc
               if( ijschm(i) .EQ. lblrxn(j) ) then
                  k = ijschm(i)
                  ijschm(i) = j
                  if( ityprtc(ijschm(i)) .NE. 100 ) goto 8006
               endif
           enddo
         enddo
         write(idiag,'(/,A)')
     & '    Photolysis reaction labels renumbered as follows:'
         write(idiag,'(2X,12I5)') (ijschm(i),i=1,njschm)
         write(idiag,'(2(/,A))') 
     & '    when the reactions were renumbered sequentially'
      endif
c
c --- Index the species
c
      if ( nrct(1) .GT. 0 ) then
         ngasrtc = 1
         spnmrt(1) = namrct(1,1)
      elseif ( nprd(1) .GT. 0 ) then
         ngasrtc = 1
         spnmrt(1) = namprd(1,1)
      else
         goto 8004
      endif
c   
      do i = 1, nrxnrtc
         if( nrct(i) .GT. 0 ) then
            do j = 1, nrct(i)
               lhit = .false.
               do k = 1, ngasrtc
                  if( namrct(i,j) .EQ. spnmrt(k) ) lhit = .true.
               enddo
               if ( .NOT. lhit ) then
                  ngasrtc = ngasrtc + 1
                  if( ngasrtc .GT. MXTRSP ) goto 7002
                  spnmrt(ngasrtc) = namrct(i,j)
               endif
            enddo
         endif
         if( nprd(i) .GT. 0 ) then
            do j = 1, nprd(i)
               lhit = .false.
               do k = 1, ngasrtc
                  if( namprd(i,j) .EQ. spnmrt(k) ) lhit = .true.
               enddo
               if ( .NOT. lhit ) then
                  ngasrtc = ngasrtc + 1
                  if( ngasrtc .GT. MXTRSP ) goto 7002
                  spnmrt(ngasrtc) = namprd(i,j)
               endif
            enddo
         endif
      enddo
c
c --- Set attributes of the species found in the mechanism
c
      do i = 1, ngasrtc
         if( spnmrt(i) .EQ. nam_M
     &      .OR. spnmrt(i) .EQ. nam_O2
     &        .OR. spnmrt(i) .EQ. nam_N2
     &          .OR. spnmrt(i) .EQ. nam_H2O
     &            .OR. spnmrt(i) .EQ. nam_H2
     &              .OR. spnmrt(i) .EQ. nam_CH4 ) then
            itypsp(i) = 4
            goto 300
         endif
         do j = 1, ngasschm
            if( spnmrt(i) .EQ. spnmschm(j) ) then
               itypsp(i) = itypschm(j)
               goto 300
            elseif( j .EQ. ngasschm ) then
               spec = spnmrt(i)
               goto 8005
            endif
         enddo
 300     continue
      enddo
c
      if ( ldbg ) then
         write(idiag, '(/,A)') ' Species read by RDSCHM'
         write(idiag, '(/,A)') ' Rxn  Name        Type'
         do i = 1,ngasrtc
            write(idiag, '(I4,2X,A,2X,I2,2X,1PE10.3)') 
     &                            i, spnmrt(i), itypsp(i)
         enddo
         write(idiag, '(A)')
     &     '   Types are: 1=fast, 2=slow, 3=eqm, 4=fixed(ambient)'
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      write(idiag,'(//,A,//)',ERR=7009)
     &       ' ******* Finished RTCMC chemical definitions file.'
      close(iorchm)
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDSCHM:'
      write(iout,'(1X,A)') 'Number of RTRAC species exceeds max.'
      write(iout,'(1X,A,A)') 'Check the input reaction list,',
     &                       ' increase parameter MXTRSP and recompile.'
      call camxerr()
c
 7009 continue
      write(iout,'(//,A)') 'ERROR in RDSCHM:'
      write(iout,'(1X,A)') 'Cannot write to the diag file.'
      call camxerr()
c
 7010 continue
      write(iout,'(//,A)') 'ERROR in RDSCHM:'
      write(iout,'(1X,A)') 'Cannot open file: ',chmfil(:istrln(chmfil))
      call camxerr()
c
 8000 write(iout,'(//,A)') 
     &   ' ERROR in RDSCHM reading SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8002 write(iout,'(/,4(/,A))') 
     &   ' ERROR in RDSCHM:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Expecting this line to begin with the character # :', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8003 write(iout,'(/,3(/,A),A)') 
     &   ' ERROR in RDSCHM:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Failed to find and read the following section: ', word
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8004 write(iout,'(//,A)')
     &     ' Error in RDSCHM: first reaction has no species'
      call camxerr()
c
 8005 write(iout,'(/,4(/,A))') 
     &   ' ERROR in RDSCHM:',
     &   ' The SCICHEM IMC file contains the following species',
     &   ' in the EQUATION section, but not the SPECIES section:',
     &     spec
      call camxerr()
c
 8006 write(iout,'(/,A,/,A,I5,/,A)') 
     &   ' ERROR in RDSCHM:',
     &   ' Photolysis rate provided for reaction number label:', k,
     &   ' The reaction provided with this label is not photolysis type'
      call camxerr()
c
 8007 write(iout,'(/,4(/,A))') 
     &   ' ERROR in RDSCHM:',
     &   ' Illegal core model species selected as target for',
     &   ' setting dry deposition via pointer:',
     &     spec
      call camxerr()
c
      end
c
c*** RDSCCTL
c
      subroutine rdscctl(iinp, line, nline, lend)
      use filunit
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Read the CONTROL section of a SCICHEM chemical mechanism 
c     input file (IMC file).  
c
c     Look for the following SCICHEM keywords and input values:
c        rate_species_units:  ppm or molecules/cm3 (default)
c        rate_time_units:     hours, minutes, or seconds (default)
c     Look for several CAMx specific keywords:
c        solver:   DLS (default), SLS or ROS
c        jacobian: numeric (default) or algebraic
c     Ignore any other keywords
c
c     Assumtions:
c     - A line beginning with character "#" closes this section
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Inputs:
c       iinp         I      input unit number
c      Outputs:
c       line         C      current input line
c       nline        I      currentline number within input file
c       lend         L      end of file found
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer   istrln
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   iinp
      integer   nline
      logical   lend
      character*240 line
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      character*1   letr
      character*6   word, tunit(3)
      character*14  cunit(2)
      character*24  slver(3), jcban(2)
      data tunit/'second','minute','hour  '/
      data cunit/'molecules/cm-3','ppm           '/
      data slver/'LSODE (double precision)',
     &           'LSODE (single precision)',
     &           'Rosenbrock              '/
      data jcban/'Numeric                 ',
     &           'Algebraic               '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(/,3(/,A))')
     &     ' ----------------------------------------------',
     &     ' Diagnostic information for RTRAC CMC chemistry',
     &     ' ----------------------------------------------'
      write(idiag,'(/,A)') 
     &        ' Reading the Control section of the IMC file'
      write(idiag,'(/,A)') 
     &        '  Scan each line for recognized options'
c
c --- set default values for icunit, itunit, isolv, ijac,
c     rtolrtc, atolrtc
c
      icunit = 1
      itunit = 1
      isolv  = 1
      ijac   = 1
      mtype  = 2
      ktype  = 2
      rtolrtc = 1.0E-5
      atolrtc = 1.0E-18
c
c --- check for non-default values
c
      lend = .false.
 100  read (iinp, '(A)', end=8001, err=8000) line
      nline = nline + 1
      call jstlft( line )
      read (line, '(A6)') word
      call toupper( word )
      read (line, '(A1)') letr

      if( word .EQ. 'RATE_S' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+6),'(A6)') word
               call jstlft( word )
               call toupper( word )
               if( word(2:4) .EQ. 'PPM' ) then
                  icunit = 2
               elseif( word(2:4) .EQ. 'MOL' ) then
                  icunit = 1
               else
                  goto 8002
               endif
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word .EQ. 'RATE_T' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+6),'(A6)') word
               call jstlft( word )
               call toupper( word )
               if( word(2:4) .EQ. 'HOU' ) then
                  itunit = 3
               elseif( word(2:4) .EQ. 'MIN' ) then
                  itunit = 2
               elseif( word(2:4) .EQ. 'SEC' ) then
                  itunit = 1
               else
                  goto 8003
               endif
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word(1:4) .EQ. 'RTOL' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+16),*,err=8004) rtolrtc
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word(1:4) .EQ. 'ATOL' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+16),*,err=8005) atolrtc
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word .EQ. 'SOLVER' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+6),'(A6)') word
               call jstlft( word )
               call toupper( word )
               if( word(2:4) .EQ. 'DLS' ) then
                  isolv = 1
               elseif( word(2:4) .EQ. 'SLS' ) then
                  isolv = 2
               elseif( word(2:4) .EQ. 'ROS' ) then
                  isolv = 3
               endif
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word .EQ. 'JACOBI' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+6),'(A6)') word
               call jstlft( word )
               call toupper( word )
               if( word(2:4) .EQ. 'NUM' ) then
                  ijac = 1
               elseif( word(2:4) .EQ. 'ALG' ) then
                  ijac = 2
               endif
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( word .EQ. 'EQUATI' ) then
         do i=1,60
            read (line(i:i),'(A1)') letr
            if( letr .EQ. '=' ) then
               read (line(i+1:i+6),'(A6)') word
               call jstlft( word )
               call toupper( word )
               if( word(2:4) .EQ. 'CAM' ) then
                  mtype  = 1
                  ktype  = 1
               endif
            endif
         enddo
         write(idiag,'(2A)') '    Recognised line: ',
     &                              line(1:istrln(line))
      elseif( letr .EQ. '#' ) then
         goto 200
      else
         write(idiag,'(2A)') '    Ignored line: ',
     &                              line(1:istrln(line))
      endif
      goto 100
c
c --- report options selected and then return
c
 200  write(idiag,'(/,2(2A,/))')
     &     '    The chemistry solver will be: ', slver(isolv),
     &     '    The Jacobian method will be:  ', jcban(ijac)
      write(idiag,'(2(A,1PE10.3,/))')
     &     '    The relative error tolerance will be: ', rtolrtc,
     &     '    The absolute error tolerance will be: ', atolrtc
      write(idiag,'(4A,/)')
     &     '    Rate constants must be input with units: ',
     &       cunit(icunit)(1:istrln(cunit(icunit))),'/',tunit(itunit)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 8000 write(iout,'(//,A)')
     &   ' ERROR in RDSCCTL reading SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8001 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCCTL:',
     &   ' Unexpected end of SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8002 write(iout,'(/,4(/,A))')
     &   ' ERROR in RDSCCTL:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Failed to recognise the concentration units in: ', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8003 write(iout,'(/,4(/,A))')
     &   ' ERROR in RDSCCTL:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Failed to recognise the time units in: ', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8004 write(iout,'(/,4(/,A))')
     &   ' ERROR in RDSCCTL:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Failed to recognise value for RTOL in: ', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8005 write(iout,'(/,4(/,A))')
     &   ' ERROR in RDSCCTL:',
     &   ' Reading the SCICHEM IMC format input file',
     &   ' Failed to recognise value for ATOL in: ', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
      end

c*** RDSCSPC
c
      subroutine rdscspc(iinp, line, nline, lend)
      use filunit
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Read the SPECIES section of a SCICHEM chemical mechanism 
c     input file (IMC file)
c
c     Assumtions:
c     - Species names must begin with a letter
c     - A line beginning with character "#" closes this section
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Inputs:
c       iinp         I      input unit number
c      Outputs:
c       line         C      current input line
c       nline        I      currentline number within input file
c       lend         L      end of file found
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer   istrln
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   iinp
      integer   nline
      logical   lend
      character*240 line
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   nl, isp
      character*1   letr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(//,A)') 
     &            ' Reading the Species section of the IMC file'
c
      isp = 0
      lend = .false.

 100  read (iinp, '(A)', end=8001, err=8000) line
      nline = nline + 1
      call jstlft( line )
      read (line, '(A1)') letr
      if( letr .EQ. '#' ) then
         goto 200
      else
         isp = isp+1
         if( isp .GT. MXTRSP ) goto 7002
         letr = '-'
         hlawschm(isp) = 1.0
         tfacschm(isp) = 1.0
         molwschm(isp) = 1.0
         reacschm(isp) = 1.0
         rsclschm(isp) = 1.0
         read(line,*,ERR=8004) spnmschm(isp), letr, hlawschm(isp),
     &                         tfacschm(isp), molwschm(isp),
     &                         reacschm(isp), rsclschm(isp)
         if( letr .EQ. 'F' ) then
            itypschm(isp) = 1
         elseif( letr .EQ. 'S' ) then
            itypschm(isp) = 2
         elseif( letr .EQ. 'E' ) then
            itypschm(isp) = 3
         elseif( letr .EQ. 'A' ) then
            itypschm(isp) = 4
         else
            goto 8002
         endif
         if (istrln(spnmschm(isp)).gt.8) goto 8005
      endif
      goto 100

 200  ngasschm = isp
      if( ngasschm .EQ. 0 ) goto 8003
      write(idiag,'(A,I5,A)') '     ', ngasschm,
     &      ' species were found'
      do nl = 1,ngasschm
        write(idiag,'(a,a)') '     ',spnmschm(nl)
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDSCSPC:'
      write(iout,'(1X,A)') 'Number of RTRAC species exceeds max.'
      write(iout,'(1X,A,A)') 'Check the input species list,',
     &                       ' increase parameter MXTRSP and recompile.'
      call camxerr()
c
 8000 write(iout,'(//,A)')
     &   ' ERROR in RDSCSPC reading SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8001 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCSPC:',
     &   ' Unexpected end of SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8002 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCSPC:',
     &   ' Species type not recognized in: ', line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8003 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCSPC:',
     &   ' No species were specified'
      call camxerr()
c
 8004 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCSPC:',
     &   ' Could not read species line'
      write(iout,'(a)') line
      write(iout,'(2a)') 'Check that you have all the required',
     &                   ' parameters listed'
      call camxerr()
c
 8005 write(iout,'(//,a)') 'ERROR in RDSCSPC:'
      write(iout,'(2a)')   'Species: ',spnmschm(isp)
      write(iout,'(2a)')   'Exceeds the 8-character maximum.',
     &                     ' Shorten the name.'
      call camxerr()
c
      end

c*** RDSCTBL
c
      subroutine rdsctbl(iinp, line, nline, lend)
      use filunit
      use chmstry
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c     Read the TABLE section of a SCICHEM chemical mechanism 
c     input file (IMC file) dealing with photolysis
c
c     Assumtions:
c     - A line beginning with character "#" closes this section
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Inputs:
c       iinp         I  input unit number
c      Outputs:
c       line         C  current input line
c       nline        I  currentline number within input file
c       lend         L  end of file found
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   iinp
      integer   nline
      logical   lend
      character*240 line
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer   istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, k, idum, nrxn, npnt
      real      rdum(MXZEN)
      logical   lhit
      character*1   letr
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(//,A)')
     &         ' Reading the Table section of the IMC file'
      lend = .false.
c
c --- Read zenith angles
c     Determine how many zenith angles are being used
c     Code may be fragile because input file format is weakly defined 
c
      do i = 1,MXZEN
         zenschm(i) = 90.0
      enddo
      read (iinp, '(A)', end=8002, err=8000) line
      nline = nline + 1
      call jstlft( line )
      if( istrln(line) .EQ. 0 ) goto 8002
      read (line, * ) j
      if( j .NE. 0 ) goto 8002
      do i = 1,MXZEN-1
         read(line, * , err = 100, end = 100 ) 
     &                         idum, (rdum(k),k=1,i)
         j = i
      enddo
 100  nzschm = j
      read(line, *) idum, (zenschm(i),i=1,nzschm)
c
c --- Read photolysis rates
c
      nrxn = 0
      npnt = 0
      ijpntr = 0
      jscale = 1.

 101  read (iinp, '(A)', end=200, err=8000) line
      nline = nline + 1
      call jstlft( line )
      if( istrln(line) .EQ. 0 ) goto 200
      read (line, '(A1)' ) letr
      if( letr .EQ. '#' ) goto 300
      nrxn = nrxn+1
      if( nrxn .GT. MXPHOT ) goto 8004
      read(line, *) ijschm(nrxn)
      if( ijschm(nrxn) .EQ. 0 ) goto 8006
      if( ijschm(nrxn) .GT. MXRX ) goto 8003
      if( ijschm(nrxn) .LT. 0 ) then
         read(line, *) ijschm(nrxn), ijpntr(nrxn),jscale(nrxn)
         ijschm(nrxn) = abs(ijschm(nrxn))
         lhit = .false.
         do i = 1, nphot1 
            if( ijpntr(nrxn) .EQ. idphot1(i) ) lhit = .true.
         enddo
         do i = 1, nphot2 
            if( ijpntr(nrxn) .EQ. idphot2(i) ) lhit = .true.
         enddo
         if( .NOT. lhit ) goto 8007
         npnt = npnt + 1
      else
         read(line, *) ijschm(nrxn), (rjschm(i,nrxn),i=1,nzschm)
      endif
      goto 101

 200  lend = .true.
 300  njschm = nrxn
c
      if( njschm .EQ. 0 ) then
         write(idiag,'(A)') 
     &      '    No photolysis rates were specified'
      else
         do i = 1,njschm-1
            k = i
            do j = i+1,njschm
               if( ijschm(i) .EQ. ijschm(j) ) goto 8005
            enddo
         enddo
c
         write(idiag,'(/,A,/,2X,10F6.2)') 
     & '    Photolysis rates specified at the following zenith angles:',
     &                                   (zenschm(i),i=1,nzschm)
         write(idiag,'(A)') 
     &      '    for the following reaction label numbers:'
         write(idiag,'(2X,12I5)') (ijschm(i),i=1,njschm)
         write(idiag,'(2(/,A))') 
     &      '    NOTE: These label numbers may change when the',
     &      '          mechanism reactions are renumbered sequentially'
         if (npnt.eq.0) then
            write(idiag,'(a)')
     &      '    No photolysis rates point to core model mechanism reactions'
         else
            write(idiag,'(/,a,/,a)')
     &      '    Photolysis rates pointing to core model mechanism reactions',
     &      '    Rxn Pntr   Scaling'
           do i = 1,njschm
             if (ijpntr(i).ne.0)
     &         write(idiag,'(2x,2i5,e10.2)') ijschm(i),ijpntr(i),jscale(i)
           enddo
         endif
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 8000 write(iout,'(//,A)')
     &   ' ERROR in RDSCTBL reading SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8002 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCTBL:',
     &   ' Failed to find the list of zenith angles for photolysis'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8003 write(iout,'(/,2(/,A),I5,/,A)')
     &   ' ERROR in RDSCTBL:',
     &   ' Reaction number in photolysis table exceeds MXRX=', 
     &     MXRX, line
      write(iout,'(A,I5)') ' At input line ', nline
      write(iout,'(1X,A,A)') 'Check the input pholoysis list,',
     &                       ' increase parameter MXRX and recompile.'
      call camxerr()
c
 8004 write(iout,'(/,2(/,A),I5,/,A)')
     &   ' ERROR in RDSCTBL:',
     &   ' Number of photolysis reactions exceeds MXPHOT=', 
     &     MXPHOT, line
      write(iout,'(A,I5)') ' At input line ', nline
      write(iout,'(1X,A,A)') 'Check the input pholoysis list,',
     &                       ' increase parameter MXPHOT and recompile.'
      call camxerr()
c
 8005 write(iout,'(/,2(/,A),I5)')
     &   ' ERROR in RDSCTBL:',
     &   ' This photolysis reaction label is used more than once: ',
     &     ijschm(k)
      call camxerr()
c
 8006 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCTBL:',
     &   ' The photolysis reaction label cannot be zero in: ',
     &     line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8007 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCTBL:',
     &   ' Invalid photolysis reaction pointer in: ',
     &     line
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
      end

c*** RDSCMCH
c
      subroutine rdscmch(iinp, line, nline, lend)
      use filunit
      use rtcmcchm
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     Read the EQUATIONS section of a SCICHEM chemical mechanism 
c     input file (IMC file)
c
c     Assumtions:
c     - This is the last section of ythe IMC file
c     - End of file or blank line closes this section
c
c      Copyright Ramboll
c
c     Argument descriptions:
c      Inputs:
c       iinp         I      input unit number
c     Outputs:
c       line         C      current input line
c       nline        I      currentline number within input file
c       lend         L      end of file found
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   iinp
      integer   nline
      logical   lend
      character*240 line
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer   istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i, j, k, nsp, nrxn, l1, l2, l3
      integer   lr1(MXRCT), lr2(MXRCT), lp1(MXPRD), lp2(MXPRD)
      integer   lpc1(MXPRD), lpc2(MXPRD)
      real      tmp, rdum(MXKPRM)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(//,A)')
     &                ' Reading the Equations section of the IMC file'
c
      lend = .false.
      nrxn = 0

 101  read (iinp, '(A)', end=900, err=8000) line
      nline = nline + 1
      call jstlft( line )
      l3 = istrln( line )
      if( line(1:1) .EQ. '#' ) goto 1000
      if( l3 .EQ. 0 ) goto 900
      nrxn = nrxn + 1
      if( nrxn .GT. MXRX ) goto 8008
      read(line, *) lblrxn(nrxn)
c
c --- find reactants
c
      nsp = 0
      l1 = 0
      do i = 1,l3
         if( line(i:i) .EQ. '[' ) then
            nsp = nsp +1
            lr1(nsp) = i+1
         elseif( line(i:i) .EQ. ']' ) then
            lr2(nsp) = i-1
         elseif( line(i:i) .EQ. '>' ) then
            l1 = i-1
            goto 100
         endif
      enddo
 100  nrct(nrxn) = nsp
      if( l1 .EQ. 0 ) goto 8001
      if( nsp .GT. 0 ) then
         do i = 1,nsp
            read( line(lr1(i):lr2(i)), '(A)') namrct(nrxn,i)
         enddo
      endif
c
c --- find products and product coefficients
c
      nsp = 0
      l2 = 0
      lpc1(1) = 0
      do i = l1+1,l3
         if( line(i:i) .EQ. '[' ) then
            nsp = nsp +1
            lp1(nsp) = i+1
            lpc1(nsp+1) = 0
         elseif( line(i:i) .EQ. ']' ) then
            lp2(nsp) = i-1
         elseif( line(i:i) .EQ. '(' ) then
            lpc1(nsp+1) = i+1
         elseif( line(i:i) .EQ. ')' ) then
            lpc2(nsp+1) = i-1
         elseif( line(i:i) .EQ. ';' ) then
            l2 = i-1
            goto 200
         endif
      enddo
 200  nprd(nrxn) = nsp
      if( l2 .EQ. 0 ) goto 8002
      if( nsp .GT. 0 ) then
         do i = 1,nsp
            read( line(lp1(i):lp2(i)), '(A)' ) namprd(nrxn,i)
            call jstlft( namprd(nrxn,i) )
            if( lpc1(i) .GT. 0 ) then
               read(line(lpc1(i):lpc2(i)), *) tmp
               prdcoef(nrxn,i) = DBLE(tmp)
            else
               prdcoef(nrxn,i) = 1.0D0
            endif
         enddo
      endif
c
c --- Read rate constants 
c     Code may be fragile because input file format is weakly defined 
c     Determine how many parameters were input for each reaction
c
      j = 0
      do i = 1,MXKPRM
         rkprmrtc(nrxn,i) = 0.0
      enddo
      read( line(l2+2:l3), * ) ityprtc(nrxn)
      do i = 1,MXKPRM
         read( line(l2+2:l3), * , err = 300, end = 300 ) 
     &                         ityprtc(nrxn), (rdum(k),k=1,i)
         j = i
      enddo
 300  nrkprm(nrxn) = j
      read( line(l2+2:l3), * ) 
     &                ityprtc(nrxn), (rkprmrtc(nrxn,k),k=1,j)
      if( ityprtc(nrxn) .LT. 0 .OR. ityprtc(nrxn) .GT. 22) goto 8007
c
c --- Offset SCICHEM rate expression types by +100 
c
      ityprtc(nrxn) = 100 + ityprtc(nrxn)
c
c --- Express any reactants embedded into SCICHEM rate constants
c     and perform other changes or checks
c
      if( ityprtc(nrxn) .EQ. 105 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_M
      elseif( ityprtc(nrxn) .EQ. 109 
     &   .OR. ityprtc(nrxn) .EQ. 112 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_O2
      elseif( ityprtc(nrxn) .EQ. 116 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_M
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_O2
      elseif( ityprtc(nrxn) .EQ. 110 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_N2
      elseif( ityprtc(nrxn) .EQ. 114 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_CH4
      elseif( ityprtc(nrxn) .EQ. 104
     &   .OR. ityprtc(nrxn) .EQ. 115
     &   .OR. ityprtc(nrxn) .EQ. 120 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_H2O
      elseif( ityprtc(nrxn) .EQ. 117 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_H2O
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_H2O
      elseif( ityprtc(nrxn) .EQ. 121 ) then
         nrct(nrxn) = nrct(nrxn) + 1
         namrct(nrxn,nrct(nrxn)) = nam_H2
      elseif( ityprtc(nrxn) .EQ. 108 ) then
         if( NINT(rkprmrtc(nrxn,1)) .GE. nrxn ) goto 8003
      elseif( ityprtc(nrxn) .EQ. 106 ) then
         goto 8004
      endif
      goto 101
c
c --- End loop over input reactions
c
 900  lend = .true.
 1000 nrxnrtc = nrxn
      if( nrxnrtc .EQ. 0 ) goto 8005
      write(idiag,'(A,I5,A)') '     ', nrxnrtc,
     &      ' reactions were found'
c
c --- Check for duplicate reaction number labels
c
      do i = 1,nrxnrtc-1
         k = i
         do j = i+1,nrxnrtc
            if( lblrxn(i) .EQ. lblrxn(j) ) goto 8006
         enddo
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 8000 write(iout,'(//,A)')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8001 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file',
     &   ' Failed to find the token > in reaction:', 
     &     line(1:istrln(line))
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8002 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file',
     &   ' Failed to find the token ; in reaction:',
     &     line(1:istrln(line))
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8003 write(iout,'(/,4(/,A))')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file',
     &   ' Equilibrium rate constant specified in reaction:',
     &     line(1:istrln(line)),
     &   ' illegaly points to a reaction later in the mechansim'
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8004 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file',
     &   ' Rate expression type 6 is illegal in:',
     &     line(1:istrln(line))
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8005 write(iout,'(/,2(/,A))')
     &   ' ERROR in RDSCMCH:',
     &   ' No reactions were specified'
      call camxerr()
c
 8006 write(iout,'(/,2(/,A),I5)')
     &   ' ERROR in RDSCMCH:',
     &   ' This reaction label number is used more than once: ',
     &     lblrxn(k)
      call camxerr()
c
 8007 write(iout,'(/,3(/,A))')
     &   ' ERROR in RDSCMCH reading SCICHEM IMC format input file',
     &   ' Rate expression type not in range 0 to 22 in:',
     &     line(1:istrln(line))
      write(iout,'(A,I5)') ' At input line ', nline
      call camxerr()
c
 8008 write(iout,'(/,2(/,A),I5,/,A)')
     &   ' ERROR in RDSCMCH:',
     &   ' Number of reactions exceeds MXRX=', 
     &     MXRX, line
      write(iout,'(A,I5)') ' At input line ', nline
      write(iout,'(1X,A,A)') 'Check the input equation list,',
     &                       ' increase parameter MXRX and recompile.'
      call camxerr()
c
      end

c***** RDARRT.F
c
      subroutine rdarrt(igrid,ndate,ttime,nox,noy,
     &                                  nlay_ems,nrtarsp,emisrt)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions for the RTRAC process
c   and fills the approproate arrays.  The emissions file for one grid
c   is read.
c    Argument descriptions:
c     Outputs:
c       emisrt    R    array of emissions for RTRAC speices
c     Inputs:
c       igrid     I    grid number
c       ndate     I    julian day of current hour
c       ttime     R    current hour
c       nox       I    number of columns in grid
c       noy       I    number of rows in grid
c       nlays_ems I    number of layers in emissions files
c       nrtarsp   I    number of RTRAC species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c       10/24/01  Removed BSWAP and converted integer strings to character*4
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c       
c-----------------------------------------------------------------------
c   Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      integer ndate
      real    ttime
      integer nox
      integer noy
      integer nlay_ems
      integer nrtarsp
      real    emisrt(nox,noy,nlay_ems,nrtarsp)
c
c-----------------------------------------------------------------------
c   Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, idx, iseg
      integer       i, j, ispc, buffer_offset
      real          emstmp, bgtim, edtim
      logical       lfound, lpass
c
      real, allocatable, dimension(:,:) :: emsgrd
c
c-----------------------------------------------------------------------
c   Entry point:
c-----------------------------------------------------------------------
c
c   --- initialize emissions to zero ---
c
      do i=1,nox
         do j=1,noy
            do l=1,nrtarsp
               emisrt(i,j,1,l) = 0.
            enddo
         enddo
      enddo
c
c   --- skip if filename not supplied ---
c
      if( .NOT. ltemfl(igrid,1,1) .OR. .NOT. larsrc ) goto 9999
      if( is_netcdf_iortem(igrid,1,1) ) goto 9999
c
c   --- set the unit number for surface emissions file ---
c
      iounit = iortem(igrid,1,1)
      fname = temfil(igrid,1,1)
      buffer_offset = buffer_offset_iortem(igrid,1,1)
c
c   --- allocate the local array ---
c
      allocate( emsgrd(nox-2*buffer_offset,noy-2*buffer_offset) )
c
c   --- read the date and time, again ---
c
      lfound = .FALSE.
      lpass = .FALSE.
  111 continue
      read(iounit,END=222) ibgdat, bgtim, iendat, edtim
      bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
      edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
      do 20 ispc=1,nspcem(igrid,1,1)
         read(iounit,ERR=7000) iseg, (iname(i),i=1,10),((emsgrd(i,j),
     &                   i=1,nox-2*buffer_offset),j=1,noy-2*buffer_offset)
         do i=1,nox
           emsgrd(i,1) = emsgrd(i,1+buffer_offset)
           emsgrd(i,noy) = emsgrd(i,noy-buffer_offset)
         enddo
         do j=1,noy
           emsgrd(1,j) = emsgrd(1+buffer_offset,j)
           emsgrd(nox,j) = emsgrd(nox-buffer_offset,j)
         enddo
c
c   --- if date and time does not match this hour, skip this record ---
c
         if( le1day ) then
           if( abs(bgtim-ttime).ge.0.01 ) goto 20
         else
           if( ndate .NE. ibgdat .OR. abs(bgtim-ttime).ge.0.01 ) goto 20
         endif
         lfound  = .TRUE.
c
c   --- if the species is a not modeled or not used for RTRAC ----
c
         idx = idxems(igrid,1,1,ispc)
         if( idx .LE. 0 ) goto 20
c
c  --- if this RTRAC species matches this modeled species, load it ---
c
         do j=1+buffer_offset,noy-buffer_offset
            jtmp = j-buffer_offset
            do i=1+buffer_offset,nox-buffer_offset
               itmp = i-buffer_offset
c
c  --- convert to emissions time and put into array ---
c
               emstmp = emsgrd(itmp,jtmp)/(60.*dtems)
               emisrt(i,j,1,idx) = emstmp
c
c  --- next cell ---
c
            enddo
         enddo
c
c   --- next species ---
c
  20  continue
c
c   --- if the correct hour has not been found, 
c       go back and read some more else read next file ---
c
      if( .NOT. lfound ) then
         goto 111
      else
         do i=1,nspcem(igrid,1,1) + 1
            backspace(iounit)
         enddo
         goto 9999
      endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222 continue
      if( le1day ) then
         rewind(iounit)
         read(iounit)
         read(iounit)
         read(iounit)
         read(iounit)
         if( lpass ) goto 7001
         if( .NOT. lpass ) lpass = .TRUE.
         goto 111
      else
         goto 7001
      endif
c
c  --- get the next file ---
c
       deallocate( emsgrd )
       goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in RDARRT:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 'ERROR: Reading emissions ',
     &   'after hour ',ibgdat, bgtim,' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in RDARRT:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 
     &              'ERROR: Premature end-of-file',
     &              ' in emissions file after hour ',ibgdat, bgtim,
     &                              ' in file: ',fname(:istrln(fname))
      call camxerr()
c
c----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine average(m1,m2,m3,losat,igrd,dt,dtscl,ncol,nrow,nlay,
     &                   nlayav,nspav,nspc,lspmap,lgassp,molwt_in,
     &                   tempk,press,conc,avcnc)
      use chmstry
      use bndary
      use camxcom
      use procan
      use rtracchm
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c     AVERAGE computes time-averaged concentrations
c
c      Copyright Ramboll
c
c     Modifications: 
c        01/30/02    --gwilson--  Added code for RTRAC probing tool
c        12/15/08    --gwilson--  Added code to handle averaging of
c                                 radicals
c        09/27/10    --gwilson--  Removed the code to store process
c                                 analysis conversion factors. Now
c                                 handled by separate routine.
c        07/01/19    --cemery--   Removed trapazoidal integration for
c                                 radicals
c        04/15/21    --gwilson--  Only converts to PPM for gas species 
c                                 if flag is set accordingly
c        03/19/21    --gwilson--  Added molecular weight to argument list
c
c     Input arguments:
c        losat              .TRUE. if concentrations are tracer species
c        igrd               grid index
c        dt                 time step for present grid concentration (s)
c        dtscl              time step scaling for radicals (0 at beg dt,
c                                                           2 at end dt)
c        ncol               number of columns
c        nrow               number of rows
c        nlay               number of layers in instantaneous array
c        nlayav             number of layers in average array
c        nspav              number of average species
c        nspc               number of species in conc array
c        lspmap             mapping array for average species
c        lgassp             true if species is gas
c        molwt_in           molecular weight for each species
c        tempk              temperature field (K)
c        press              pressure field (mb)
c        conc               instant species concentration (umol/m3)
c        avcnc              average species concentration (gas=ppm,
c                                                          other=ug/m3)
c     Output arguments:
c        avcnc              average species concentration (gas=ppm,
c                                                          other=ug/m3)
c
c     Routines Called:
c        none
c
c     Called by:
c        AVGALL
c        FGAVRG
c
      implicit none
      include "camx.prm"
      include "flags.inc"
 
      logical losat
      integer m1,m2,m3
      integer igrd,ncol,nrow,nlay,nlayav,nspav,nspc
      real    dt,dtscl
      logical lgassp(nspc)
      integer lspmap(*)
      real    molwt_in(*)
      real    tempk(m1,m2,m3),press(m1,m2,m3)
      real    avcnc(m1,m2,nlayav,nspav)
      real    conc(m1,m2,m3,nspc)

      integer l,lsp,i,j,k
      real dtfact,convfac,tmp
c
c-----Entry point
c
c-----Increment running average
c
      do 40 l = 1,nspav
        lsp = lspmap(l) 
        convfac = 1.
        if( .NOT. lgas_out_ppm .AND. lgassp(lsp) ) convfac = molwt_in(lsp)
        dtfact = dt/(dtout*60.)
        if (.not.losat .and. lsp.le.nrad) dtfact = dtscl*dtfact
        do 30 j = 2,m2-1
          do i = 2,m1-1
c
            do k=1,nlayav
                if( lgassp(lsp) .AND. lgas_out_ppm ) then
                    tmp = 273./tempk(i,j,k)*press(i,j,k)/1013.
                    convfac = 1./(densfac*tmp)
                endif
                avcnc(i,j,k,l) = convfac*conc(i,j,k,lsp)*dtfact +
     &                                                  avcnc(i,j,k,l)
            enddo
          enddo
  30    continue
  40  continue
c
      return
      end

C**** NCF_METINIT_KV
c
      subroutine ncf_metinit_kv(igrd,ncol,nrow,nlay,rkv)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routines initalizes the met fields by reading the NetCDF
c   met files and loading the data into the global arrays.
c 
c      Copyright Ramboll
c           
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c
c     Output arguments:
c        rkv                 vertical diffusivity field (m2/s)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol
      integer nrow
      integer nlay
      real    rkv(ncol,nrow,nlay)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*20  this_var
      integer       this_varid, ierr, data_start(4), data_count(4)
      integer       this_tstep, this_time_tflag, this_time_etflag
      integer       i, j, k
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. is_netcdf_ikv(igrd) ) goto 9999
c
      write(action,'(A,I3)') 'Reading KV met file for grid ',igrd
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(ikv(igrd),action,begdate,begtim,
     &                this_time_tflag,this_time_etflag,.FALSE.,.FALSE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol
      data_start(2) = 1
      data_count(2) = nrow
      data_start(3) = 1
      data_count(3) = nlay
      data_start(4) = this_tstep
      data_count(4) = 1
c
c ---- layer heights ---
c
      this_var = "kv"
      ierr = nf_inq_varid(ikv(igrd), this_var, this_varid)
      if( ierr .NE. NF_NOERR) goto 7000
      ierr = nf_get_vara_real(ikv(igrd),this_varid,data_start,
     &                                          data_count,rkv)
      if( ierr .NE. NF_NOERR) goto 7001
c
c  --- successful completion ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_KV:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_METINIT_KV:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

c**** FILBDYSA.F
c
      subroutine filbdysa(igrid,nox,noy,noz,nspec,nspsa,conc,saconc)
      use bndary
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of boundary conditions and calculates 
c   the NOx and VOC levels.  It then places these concentrations in the 
c   appropriate place in the gridded array used for tracer concentrations.  
c   The O3 concentrations are placed into the concentration arrays
c   for the Ozone tracer species.
c
c      Copyright Ramboll
c
c      Argument description:
c           saconc   R  array of tracer concentrations
c       Inputs:
c           igrid    I  grid number of this grid
c           nox      I  number of cells in X direction
c           noy      I  number of cells in Y direction
c           noz      I  number of layers 
c           conc     R  array of regular model concentrations
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/06/96   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   igrid
      integer   nox
      integer   noy
      integer   noz
      integer   nspec
      integer   nspsa
      real      conc(nox,noy,noz,nspec)
      real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      logical, external :: isbound
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ioff, icl, jcl, izcl, ispc, icls
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- read concentrations for each species ----
c
      do 10 ispc=1,nspec
c
c   --- if the species is a not a tracer species skip it ---
c
          if( .NOT. lusespc(ispc) ) goto 10
c
c  --- do the WEST and EAST boundaries ----
c
          do 20 jcl=2,noy-1
c
c   --- if stratifying by boundary, put in seperate position ---
c
             if( lbndry ) then
                ioff = ncls_ioric-1 + IDXBWS
             else
                ioff = ncls_ioric
             endif
c
c  --- West boundary ---
c
            if( .NOT. lmpi .OR. 
     &                 isbound( mibcon(1),mmxp(1),mmyp(1),1,0 ) ) then
                do 30 izcl=1,noz
                   if( conc(1,jcl,izcl,ispc) .LE. 0 ) goto 30
c
c   --- loop over the tracer classes ---
c
                   do icls=1,ntrcls
                      saconc(1,jcl,izcl,iptcls(icls)+ioff) = 
     &                  saconc(1,jcl,izcl,iptcls(icls)+ioff) + 
     &                      conc(1,jcl,izcl,ispc) * trspmap(ispc,icls)
                   enddo
   30           continue
            endif
c
c  --- East boundary ---
c
c
c   --- if stratifying by boundary, put in seperate position ---
c
            if( lbndry ) then
               ioff = ncls_ioric-1 + IDXBES
            else
               ioff = ncls_ioric
            endif
            if( .NOT. lmpi .OR. 
     &             isbound( mibcon(1),mmxp(1),mmyp(1),mmxp(1),0 ) ) then
                do 40 izcl=1,noz
                   if( conc(nox,jcl,izcl,ispc) .LE. 0. ) goto 40
c
c   --- loop over the tracer classes ---
c
                   do icls=1,ntrcls
                       saconc(nox,jcl,izcl,iptcls(icls)+ioff) = 
     &                    saconc(nox,jcl,izcl,iptcls(icls)+ioff) + 
     &                      conc(nox,jcl,izcl,ispc) * trspmap(ispc,icls)
                   enddo
c
   40           continue
            endif
   20     continue
c
c  --- do the SOUTH and NORTH boundaries ----
c
          do 50 icl=2,nox-1
c
c  --- South boundary ---
c
c
c   --- stratifying by boundary, put in seperate position ---
c
             if( lbndry ) then
                 ioff = ncls_ioric-1 + IDXBST
             else
                 ioff = ncls_ioric
             endif
c
             if( .NOT. lmpi .OR. 
     &                  isbound( mibcon(1),mmxp(1),mmyp(1),0,1 ) ) then
                do 60 izcl=1,noz
                   if( conc(icl,1,izcl,ispc) .LE. 0. ) goto 60
c
c   --- loop over the tracer classes ---
c
                   do icls=1,ntrcls
                       saconc(icl,1,izcl,iptcls(icls)+ioff) = 
     &                    saconc(icl,1,izcl,iptcls(icls)+ioff) + 
     &                      conc(icl,1,izcl,ispc) * trspmap(ispc,icls)
                   enddo
c
   60           continue
              endif
c
c  --- North boundary ---
c
c
c   --- if stratifying by boundary, put in seperate position ---
c
             if( lbndry ) then
                 ioff = ncls_ioric-1 + IDXBNT
             else
                 ioff = ncls_ioric
             endif
c
             if( .NOT. lmpi .OR. 
     &           isbound( mibcon(1),mmxp(1),mmyp(1),0,mmyp(1) ) ) then
                do 70 izcl=1,noz
                   if( conc(icl,noy,izcl,ispc) .LE. 0. ) goto 70
c
c   --- loop over the tracer classes ---
c
                   do icls=1,ntrcls
                       saconc(icl,noy,izcl,iptcls(icls)+ioff) = 
     &                    saconc(icl,noy,izcl,iptcls(icls)+ioff) + 
     &                         conc(icl,noy,izcl,ispc) * trspmap(ispc,icls)
                   enddo
   70           continue
             endif
   50     continue
c
c  --- next species --
c
   10 continue
c
c  --- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine ktherm(tcell,pcell)
      use filunit
      use chmstry
c
c----CAMx v7.40 260801
c
c     KTHERM sets rate constants for thermo-chemical reactions
c
c      Copyright Ramboll
c
c     Modifications:
c       10/14/04       Modifications to handle Mechanism 10 (no thermal rxns)
c
c     Input arguments:
c        tcell               temperature (K)
c        pcell               pressure (mb)
c
c     Output arguments:
c        none
c
c     Routines Called:
c        none
c
c     Called by:
c        CHEMDRIV
c        PIGDRIVE
c        READCHM
c
      include "camx.prm"
c
c-----Entry point
c
c-----If nreact is zero, nothing to do
c
      if (nreact.eq.0) return
c
c-----Range check temperature and pressure
c
      if (tcell.le.TEMPLO .or. tcell.ge.TEMPHI) then
        write(iout,'(//,a)') 'ERROR in KTHERM:'
        write(iout,*) 'Temperature out of lookup table range'
        write(iout,*) 'Modify camx.prm to extend range to include'
        write(iout,'(A,F8.2)') 'Temp(K) = ', tcell
        call camxerr()
      endif
      if (pcell.le.PRESLO .or. pcell.ge.PRESHI) then
        write(iout,'(//,a)') 'ERROR in KTHERM:'
        write(iout,*) 'Pressure out of lookup table range'
        write(iout,*) 'Modify camx.prm to extend range to include'
        write(iout,'(A,F8.2)') 'Press(mb) = ', pcell
        call camxerr()
      endif
c
c-----Determine weighting factors for lookup table
c
      dtemp = (TEMPHI-TEMPLO) / (NTEMPR-1)
      j = int((tcell - tempr(1))/dtemp) + 1
      tmp = (tcell - tempr(j))/dtemp
      w1 = 1. - tmp
      dpres = (PRESHI-PRESLO) / (NPRESR-1)
      k = int((pcell - presr(1))/dpres) + 1
      tmp = (pcell - presr(k))/dpres
      w2 = 1. - tmp
c
c-----Look up rate constants
c
      do i = 1,nreact
        rk11 = rktbl(i,j,k)
        rk12 = rktbl(i,j,k+1)
        rk21 = rktbl(i,j+1,k)
        rk22 = rktbl(i,j+1,k+1)
        tmp1 = w1*rk11 + (1.-w1)*rk21
        tmp2 = w1*rk12 + (1.-w1)*rk22
        rk(i) = w2*tmp1 + (1.-w2)*tmp2
      enddo
c
      end

      subroutine lcpgeo(iway,stdlon,cenlat,truelat1,truelat2,xp,yp,lon,lat)
!
!----CAMx v7.40 260801
!
!     LCPGEO performs Lambert Conformal to geodetic (lat/lon) translation.
!     Code based on MODULE_LLXY.F from WRF v3.3.
!
!      Portions Copyright Ramboll
!
!     Modifications:
!        none
!
!     Routines called:
!        none
!
!     Called by:
!        GRDPREP
!
      implicit none
      real, parameter :: PI = 3.141592653589793
      real, parameter :: DEG_PER_RAD = 180./PI
      real, parameter :: RAD_PER_DEG = PI/180.
      real, parameter :: REARTH = 6370.
!
!-----Arguments
!
      integer          :: iway     ! Conversion direction
                                   ! 0 = geodetic to Lambert Conformal
                                   ! 1 = Lambert Conformal to geodetic
      real             :: stdlon   ! Longitude parallel to y-axis (-180->180E)
                                   ! Also used at (0,0) point
      real             :: cenlat   ! Latitude at (0,0) point (-90->+90)
      real             :: truelat1 ! (-90 -> 90 degrees N)
      real             :: truelat2 !   "   "  "   "     "
      real             :: xp       ! Cartesian X coordinate (km)
      real             :: yp       ! Cartesian Y coordinate (km)
      real             :: lat      ! Latitude (-90->90 deg N)
      real             :: lon      ! Longitude (-180->180 E)
!
!-----Locals 
!
      real             :: polex    ! Computed x-location of pole point
      real             :: poley    ! Computed y-location of pole point
      real             :: cone     ! Cone factor for LC projections
      real             :: hemi     ! 1 for NH, -1 for SH
      real             :: r0       ! Computed radius to (0,0) point
      real             :: rr
      real             :: r2
      real             :: rm
      real             :: arg
      real             :: tl1r
      real             :: ctl1r
      real             :: xnew
      real             :: ynew
      real             :: chi,chi1,chi2
      real             :: xx
      real             :: yy
      real             :: deltalon
!
!-----Entry point
!
      if (truelat1 .LT. 0.) then
        hemi = -1.0
      else
        hemi = 1.0
      endif
      if (ABS(truelat2) .GT. 90.) then
        truelat2 = truelat1
      endif
!
!-----First, see if this is a secant or tangent projection.  For tangent
!     projections, truelat1 = truelat2 and the cone is tangent to the
!     Earth's surface at this latitude.  For secant projections, the cone
!     intersects the Earth's surface at each of the distinctly different
!     latitudes
!
      if (ABS(truelat1 - truelat2) .GT. 0.1) then
        cone = ALOG10(COS(truelat1*RAD_PER_DEG)) - &
               ALOG10(COS(truelat2*RAD_PER_DEG))
        cone = cone/(ALOG10(TAN((45. - ABS(truelat1)/2.)*RAD_PER_DEG)) - &
                     ALOG10(TAN((45. - ABS(truelat2)/2.)*RAD_PER_DEG)))
      else
         cone = SIN(ABS(truelat1)*RAD_PER_DEG)
      endif
!
!-----Convert truelat1 to radian and compute COS for later use
!
      tl1r = truelat1*RAD_PER_DEG
      ctl1r = COS(tl1r)
!
!-----Compute the radius to our known (0,0) point
!
      r0 = REARTH*ctl1r/cone * &
           (TAN((90.*hemi - cenlat)*RAD_PER_DEG/2.) / &
            TAN((90.*hemi - truelat1)*RAD_PER_DEG/2.))**cone
!     arg = cone*(deltalon1*RAD_PER_DEG)
!     polex = -hemi*r0*SIN(arg)
!     poley = r0*COS(arg)
      polex = 0.
      poley = r0
!
!-------------------------------------------------------------------------------
!     Calculate lat/lon from x/y
!-------------------------------------------------------------------------------
! 
      if (iway .EQ. 1) then
        chi1 = (90. - hemi*truelat1)*RAD_PER_DEG
        chi2 = (90. - hemi*truelat2)*RAD_PER_DEG
! 
!-----See if we are in the southern hemispere and flip the indices
!     if we are
!
        xnew = hemi*xp
        ynew = hemi*yp
! 
!-----Compute radius**2 to i/j location
!
        xx = xnew - polex
        yy = poley - ynew
        r2 = (xx*xx + yy*yy)
        rr = SQRT(r2)/REARTH
!
!-----Convert to lat/lon
!
        if (r2 .EQ. 0.) then
          lat = hemi*90.
          lon = stdlon
        else
          lon = stdlon + DEG_PER_RAD*ATAN2(hemi*xx,yy)/cone
          lon = MOD(lon + 360.,360.)
          if (lon .GT. +180.) lon = lon - 360.
          if (lon .LT. -180.) lon = lon + 360.
!
!-----Latitude determined by solving an equation adapted from:
!     Maling, D.H., 1973: Coordinate Systems and Map Projections
!     Equations #20 in Appendix I.  
!           
          if (chi1 .EQ. chi2) then
            chi = 2.*ATAN((rr/TAN(chi1))**(1./cone)*TAN(chi1*0.5))
          else
            chi = 2.*ATAN((rr*cone/SIN(chi1))**(1./cone)*TAN(chi1*0.5)) 
          endif
          lat = (90.0 - chi*DEG_PER_RAD)*hemi
        endif
!
!-------------------------------------------------------------------------------
!     Calculate x/y from lat/lon
!-------------------------------------------------------------------------------
! 
      else
!
!-----Compute deltalon between known longitude and standard lon and ensure
!     it is not in the cut zone
!
      deltalon = lon - stdlon
      if (deltalon .GT. +180.) deltalon = deltalon - 360.
      if (deltalon .LT. -180.) deltalon = deltalon + 360.
!      
!-----Radius to desired point
!
        rm = REARTH*ctl1r/cone * &
             (TAN((90.*hemi - lat)*RAD_PER_DEG/2.) / &
              TAN((90.*hemi - truelat1)*RAD_PER_DEG/2.))**cone
        arg = cone*(deltalon*RAD_PER_DEG)
        xp = polex + hemi*rm*SIN(arg)
        yp = poley - rm*COS(arg)
! 
!-----Finally, if we are in the southern hemisphere, flip the i/j
!     values to a coordinate system where (1,1) is the SW corner
!     (what we assume) which is different than the original NCEP
!     algorithms which used the NE corner as the origin in the 
!     southern hemisphere (left-hand vs. right-hand coordinate?)
!
        xp = hemi*xp
        yp = hemi*yp
      endif
!
      return
      end

***** EMPREPSA
c
      subroutine emprepsa(idate,btim,igrid,numpts_lst)
      use filunit
      use grid
      use chmstry
      use ptemiss
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads the source group emissions files and moves the
c   file pointer to the first hour to be used in this run.  Each point
c   source and surace emissions files respresenting a source group is
c   read.
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   igrid
      integer   numpts_lst
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      integer MXOUT
      parameter (MXOUT = MAX(MXSPEC,MXTRSP))
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  namein, cfile
      character*4   ifname(10), ifnote(60)
      integer       ifile, nseg, nspect, igroup, isoa
      integer       ispc, ibgdat, iendat
      integer       idateb, idatee, nxcelt, nycelt, nzceltm npts_in_list
      integer       idum, izonet, iounit, isegm, npoint, idxpt_base
      integer       i, j, ndate, seg4(4), idxfile, num_emsfiles, num_ptsfiles
      integer       ii, jj, igrd, buffer_offset
      real          tutmx, tutmy, tdxcel, tdycel
      real          tbegti, tendti, begtim, endtim, dum
      real          txorig, tyorig, ttime, tdummy
c
      character*4 iname(10,MXOUT)
      real        txloc (MXPTSRC)
      real        tyloc (MXPTSRC)
      real        tstkhgt(MXPTSRC)
      real        tstkdiam(MXPTSRC)
      real        tstktemp(MXPTSRC)
      real        tstkvelo(MXPTSRC)
c
      common /comemprepsa/ txloc, tyloc, tstkhgt, tstkdiam, 
     &                     tstktemp, tstkvelo
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- allocate array for checking list ---
c
      if( lptsrc ) then
         xlocpt = xloc
         ylocpt = yloc
         idx_last_found = 1
      endif
c
c   --- set the date and time ---
c
      ndate = idate
      ttime = btim/100
      if( ttime .EQ. 24.0 ) then
         ndate = ndate + 1
         ttime = 0.
         if( MOD(ndate,1000) .GT. 365 ) then
            if( MOD(INT(ndate/1000),4) .EQ. 0 ) then
               if( MOD(ndate,1000) .EQ. 367 )
     &                        ndate = (INT(ndate/1000)+1)*1000 + 1
            else
               ndate = (INT(ndate/1000)+1)*1000 + 1
            endif
         endif
      endif
c
c   --- initialize postion zero, which is for the model emissions ----
c
      if( ltrace .AND. (tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC) ) then
         do idxfile=1,nemiss_files(igrid)
            if( larsrc .AND. ltrace ) then
                ltemfl(igrid,0,idxfile) = .TRUE.
            else
                ltemfl(igrid,0,idxfile) = .FALSE.
            endif
         enddo
      endif
c
c  --- calculate number of sources in base inventory ---
c
      if( tectyp .NE. SA ) then
         numpts_lst = 0
         do i=1,npoint_files
            numpts_lst = numpts_lst + nptsrc_files(i)
         enddo
      endif
c
c   --- loop over the source grouping files ----
c
      igroup_start = 1
      if( ltrace .AND. (tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC) ) 
     &                                               igroup_start = 0
      do 10 igroup=igroup_start,ngroup
           num_emsfiles = num_iortem(igrid,igroup)
           if( igroup .EQ. 0 ) num_emsfiles = nemiss_files(igrid)
           do 11 idxfile=1,num_emsfiles
c
c   --- only read if surface emissions file is supplied ---
c
             if( larsrc ) then
                if( igroup .EQ. 0 ) then
                   if( is_netcdf_iarem(igrid,idxfile)) cycle
                   iounit = iarem(igrid,idxfile)
                   write(fname,'(A,I3)') 'EMISSIONS -- UNIT ',
     &                                            iarem(igrid,idxfile)
                   buffer_offset = buffer_offset_iarem(igrid,idxfile)
                else
                   if( is_netcdf_iortem(igrid,igroup,idxfile)) cycle
                   iounit = iortem(igrid,igroup,idxfile)
                   fname = temfil(igrid,igroup,idxfile)
                endif
c
c   --- rewind the file ----
c
                rewind(iounit,ERR=7005)
c
c   --- read the header of the emissions file ---
c
                read(iounit,ERR=7000) ifname, ifnote, nseg, nspect, 
     &                                 idateb, tbegti, idatee, tendti
                if( nspect .GT. MXTRSP ) then
                  write(iout,'(//,A)') 'ERROR in EMPREPSA:'
                  write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
                  write(iout,*) 
     &                    'Please change the value for parameter: MXTRSP'
                  write(iout,*) 'It should be set to a value of at least: ',
     &                                                             nspect
                  call flush(iout)
                  call camxerr()
                endif
c
                read(iounit,ERR=7000) tutmx, tutmy, izonet, txorig, 
     &                 tyorig, tdxcel, tdycel, nxcelt, nycelt, nzcelt
                read(iounit,ERR=7000) seg4
                read(iounit,ERR=7000) 
     &                   ((iname(i,ispc),i=1,10),ispc=1,nspect)
                if( igroup .GT. 0 ) then
                   buffer_offset_iortem(igrid,igroup,idxfile) = 0
                   if( nxcelt .EQ. ncol(igrid)-2 .AND. nycelt .EQ. nrow(igrid)-2 )
     &                                buffer_offset_iortem(igrid,igroup,idxfile) = 1
                   buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
                endif
c
c   --- set up index for species names ---
c
                nspcem(igrid,igroup,idxfile) = nspect
                do 20 ispc=1,nspcem(igrid,igroup,idxfile)
                   write(namein,'(10A1)') (iname(i,ispc),i=1,10)
                   if(namein .EQ.'HNO2      ') namein = 'HONO      '
                   if(namein .EQ.'HCHO      ' .AND. kHCHO .eq. nspec+1 )
     &                                            namein = 'FORM      '
                   do isoa=1,NUM_SOAP_SPECIES
                        if( namein(1:4) .EQ. 'POA ' ) cycle
                        if( namein .EQ. soap2_spec_names(isoa) )
     &                            namein = soap3_spec_names(isoa)
                   enddo
                   if( namein(1:4) .EQ. 'POA ' .AND. luse_soap3 ) namein = 'POA_AV    '
                   do j=1,nspec
                     if(namein .EQ. spname(j) ) then
                         idxems(igrid,igroup,idxfile,ispc) = j
                         goto 20
                      endif
                   enddo
                   if( luse_soap3 .AND. lsoa ) then
                      do j=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                        if(namein .EQ. soap_emiss_names(j)) then
                           idxems(igrid,igroup,idxfile,ispc) = j
                           goto 20
                        endif
                      enddo
                   endif
  20            continue
c
c   --- read the data until the correct position in the file is reached ---
c
  111           continue
                read(iounit,ERR=7002,END=7003) ibgdat, begtim, 
     &                                              iendat, endtim
                if(NINT(endtim) .EQ. 0) then
                  endtim = 24.
                  iendat = ibgdat
                endif
                if( le1day ) then
                   if( INT(begtim*100) .EQ. INT(ttime*100) ) goto 222
                else
                   if( ibgdat .EQ. ndate .AND. 
     &                   INT(begtim*100) .EQ. INT(ttime*100) ) goto 222
                endif
                do ispc=1,nspcem(igrid,igroup,idxfile)
                    read(iounit,ERR=7002,END=7003) idum, 
     &                 (dum,i=1,10),((dum,i=1+buffer_offset,ncol(igrid)-buffer_offset),
     &                                     j=1+buffer_offset,nrow(igrid)-buffer_offset)
                enddo
                goto 111
  222           continue
                backspace(iounit)
             endif
   11     continue
c
c   --- point sources are only for the coarse grid -- grid #1 ---
c
          if( igrid .GT. 1 ) cycle
c
c   --- don't have group 0 with point sources ---
c
          if( igroup .EQ. 0 ) cycle
c
c   --- only read if elevated point source emissions file is supplied ---
c
          do idxfile=1,num_iortpt(igroup)
             if( ltptfl(igroup,idxfile) .AND. lptsrc ) then
                if( is_netcdf_iortpt(igroup,idxfile) ) cycle
                iounit = iortpt(igroup,idxfile)
                fname = tptfil(igroup,idxfile)
c
c   --- rewind the file ----
c
                rewind(iounit,ERR=7005)
c
c   --- read the header of the emissions file ---
c
                read(iounit,ERR=7000) ifname, ifnote, nseg, nspect, 
     &                                 idateb, tbegti, idatee, tendti
                if( nspect .GT. MXTRSP ) goto 7001
c
c   --- check to see if this is a compact file ---
c
                write(cfile,'(10A1)') ifname
                lcompactpt(igroup,idxfile) = .FALSE.
                if( cfile .EQ. 'PTSOURCECP' ) lcompactpt(igroup,idxfile) = .TRUE.
c
                read(iounit,ERR=7000) tutmx, tutmy, izonet, txorig, 
     &                 tyorig, tdxcel, tdycel, nxcelt, nycelt, nzcelt
                read(iounit,ERR=7000) seg4
                read(iounit,ERR=7000) 
     &                   ((iname(i,ispc),i=1,10),ispc=1,nspect)
c
c   --- set up index for species names ---
c
                nspcpt(igroup,idxfile) = nspect
                do 30 ispc=1,nspcpt(igroup,idxfile)
                   write(namein,'(10A1)') (iname(i,ispc),i=1,10)
                   if(namein .EQ.'HNO2      ') namein = 'HONO      '
                   if(namein .EQ.'HCHO      ' .AND. kHCHO .eq. nspec+1 )
     &                                            namein = 'FORM      '
                   do isoa=1,NUM_SOAP_SPECIES
                        if( namein(1:4) .EQ. 'POA ' ) cycle
                        if( namein .EQ. soap2_spec_names(isoa) )
     &                            namein = soap3_spec_names(isoa)
                   enddo
                   if( namein(1:4) .EQ. 'POA ' .AND. luse_soap3 ) namein = 'POA_AV    '
                   do j=1,nemspc
                     if(namein .EQ. emspcname(j) ) then
                         idxpts(igroup,idxfile,ispc) = j
                         goto 30
                      endif
                    enddo
  30            continue
                read(iounit,ERR=7000) isegm, npoint
                if( npoint .GT. MXPTSRC ) goto 7006
c
                read(iounit,ERR=7002) (txloc(i),tyloc(i),tstkhgt(i),tstkdiam(i),
     &                                     tstktemp(i),tstkvelo(i),i=1,npoint)
                if( tectyp .NE. SA ) then
                   do i=1,npoint
                      tstkvelo(i) = tstkvelo(i)/3600.
c
c  --- make sure this source is in the base inventory and flag it ---
c
                      numpts_lst = numpts_lst + 1
                      if( llatlon ) then
                          xstk(numpts_lst,1) = txloc(i) - xorg
                          ystk(numpts_lst,1) = tyloc(i) - yorg
                      else
                          xstk(numpts_lst,1) = txloc(i)/1000. - xorg
                          ystk(numpts_lst,1) = tyloc(i)/1000. - yorg
                      endif
                      do igrd = 2,ngrid
                         xstk(numpts_lst,igrd) = 
     &                      xstk(numpts_lst,1) - (inst1(igrd)-1)*delx
                         ystk(numpts_lst,igrd) = 
     &                      ystk(numpts_lst,1) - (jnst1(igrd)-1)*dely
                         ii = 2 + FLOOR(xstk(numpts_lst,igrd)/
     &                                 delx*FLOAT( meshold(igrd) ) )
                         jj = 2 + FLOOR(ystk(numpts_lst,igrd)/
     &                                dely*FLOAT( meshold(igrd) ) )
                         if (ii .GT. 1 .AND. ii .LT. ncol(igrd) .AND.
     &                        jj .GT. 1 .AND. jj .LT. nrow(igrd)) then
                            nosrc(igrd) = nosrc(igrd) + 1
                            if( nosrc(igrd) .GT. MXPTSRC ) then
                               npoint = nosrc(igrd)
                               goto 7006
                            endif 
                            idsrc(nosrc(igrd),igrd) = numpts_lst
                            isrc(nosrc(igrd),igrd) = ii
                            jsrc(nosrc(igrd),igrd) = jj
                         endif
                     enddo
                     xlocpt(numpts_lst) = txloc(i)
                     ylocpt(numpts_lst) = tyloc(i)
                     xloc(numpts_lst) = txloc(i)
                     yloc(numpts_lst) = tyloc(i)
                     hstk(numpts_lst) = tstkhgt(i)
                     dstk(numpts_lst) = tstkdiam(i)
                     tstk(numpts_lst) = tstktemp(i)
                     vstk(numpts_lst) = tstkvelo(i)
                     lpiglet(numpts_lst) = .FALSE.
                     if( dstk(numpts_lst) .LT. 0. ) lpiglet(numpts_lst) = .TRUE.
                     idx_point_in_list(igroup,idxfile,i) = numpts_lst
                   enddo
                endif
c
c   --- read the data until the correct position in the file is reached ---
c
  333           continue
                read(iounit,ERR=7002,END=7003) ibgdat, begtim, 
     &                                              iendat, endtim
                if(NINT(endtim) .EQ. 0) then
                  endtim = 24.
                  iendat = ibgdat
                endif
                if( le1day ) then
                   if( INT(begtim*100) .EQ. INT(ttime*100) ) goto 444
                else
                   if( ibgdat .EQ. ndate .AND. 
     &                INT(begtim*100) .EQ. INT(ttime*100) ) goto 444
                endif
                read(iounit,ERR=7002) isegm, npoint
                read(iounit,ERR=7002) (idum,idum,idum,dum,dum,i=1,npoint)
                do ispc=1,nspcpt(igroup,idxfile)
                    read(iounit,ERR=7002,END=7003) idum,(dum,i=1,10),
     &                                                (dum,i=1,npoint)
                enddo
                goto 333
  444           continue
                backspace(iounit)
c
             endif
          enddo
   10 continue
c
c  ---- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      write(iout,'(1X,3A)') 'Reading header of ',
     &                     'emissions file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,*)
     &                    'Please change the value for parameter: MXTRSP'
      write(iout,*) 'It should be set to a value of at least: ',
     &                                                             nspect
      call flush(iout)
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      write(iout,'(1X,2A)') 'Reading emissions grid in file: ',
     &                                        fname(:istrln(fname))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      write(iout,'(1X,3A)') 'Premature end-of-file reading ',
     &                     'emissions file: ',fname(:istrln(fname))
      write(iout,'(1X,A)') 'Make sure date/time matches the simulation '
      write(iout,'(1X,A)') 'or turn on single emissions flag.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      if( lddm .OR. lhddm ) then
         write(iout,'(1X,2A,/,A)') 'Point source found in DDM ',
     &               'point source file is not found ',' in the base inventory.'
      else
         write(iout,'(1X,2A,/,A)') 'Point source found in Source Apportionment ',
     &               'point source file is not found ',' in the base inventory.'
      endif
      write(iout,'(1X,2A)') '   File: ',fname(:istrln(fname))
      write(iout,'(1X,A,I10)') '   Point ID: ',i
      call camxerr()
c
 7005 continue
      if( igroup .EQ. 0 ) then
         if( iarem(igrid,1) .GT. 0 ) then
            write(iout,'(//,A)') 'ERROR in EMPREPSA:'
            write(iout,'(1X,2A)') 'Cannot access emissions file',
     &                             ' provided for OSAT processing. '
            write(iout,'(1X,2A)') 'If it is the same as the file ',
     &            'used for the regular model, you may have to make a '
            write(iout,'(1X,A)')'copy and specify the name of the copy.'
         else
            write(iout,'(//,A)') 'ERROR in EMPREPSA:'
            write(iout,'(1X,2A)') 'Flexi-nesting the emissions inputs',
     &              ' is not supported with a '
            write(iout,'(1X,2A)') 'Probing Tools application.'
            write(iout,'(1X,2A)') 'You must supply an emissions file ',
     &                                                 'for each grid.'
         endif
      else
         write(iout,'(//,A)') 'ERROR in EMPREPSA:'
         write(iout,'(1X,3A)') 'Cannot access emissions file',
     &     ' provided for OSAT processing: ',fname(:istrln(fname))
      endif
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in EMPREPSA:'
      write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
      write(iout,*) 'Please change the value for parameter: MXPTSRC'
      write(iout,*) 'It should be set to a value of at least: ',npoint
      call flush(iout)
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine bndry_updt(numcols,numrows,numlays,bndtim,bnddate,
     &                      toptim,topdate,nsteps,numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use filunit
      use camxcom
      use camxfld
      use chmstry
      use grid
      use bndary
      use node_mod
      use tracer
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       READBND
c       READTOP
c       FLUSH
c       NODE_RECV_1SPECIES_DATA
c       MASTER_SEND_1SPECIES_DATA
c       RDBCRT
c       NCF_RDBCRT
c       CLRBDYSA
c       FILBDYSA
c       CLRBDYDDM
c       ZEROS
c       RDBCDDM
c       NODES_PASS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     11/4/09 -cemery- Removed input top concentrations
c      4/7/14 -cemery- Added top con file
c     11/28/16 -bkoo-  Updated DDM for new top con
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numcols(*)
      integer :: numrows(*)
      integer :: numlays(*)
c
      real    :: bndtim
      real    :: toptim
c
      integer :: bnddate
      integer :: topdate
      integer :: nsteps
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer (kind=8) :: mvsa3d
      integer          :: ncola
      integer          :: nrowa
      integer          :: nmx1d
      integer          :: nedge
      integer          :: i
      integer (kind=8) :: idxsa
      integer          :: ierr
      integer (kind=8) :: numsa
      integer          :: bnddate_in
      real             :: bndtim_in
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c ---- save the dates coming in for later chack ---
c
      bnddate_in = bnddate
      bndtim_in = bndtim
c
c  --- If reading NetCDF BC file call routine to see if update is needed ---
c
      if( is_netcdf_ibc ) then
        if (iproc_id .EQ. 0) call ncf_readbnd(time,date,did_update_ibc)
        if( lmpi ) then
          call nodes_pass(did_update_ibc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
          if( did_update_ibc ) then
            nedge = MAX(ncol(1),nrow(1))
            if( iproc_id .EQ. 0 ) 
     &        call master_bndconc(ncol(1),nrow(1),nlay(1),
     &                                          nspec,nedge,conc,bndconc)
            call edge_pass(nodeedge,bndconc,4*nedge*nlay(1)*nspec,MPI_REAL,
     &                                             itag,numprocs,iproc_id) 
            if( iproc_id .NE. 0 ) then
              if( nodeedge(iproc_id) ) 
     &          call nodes_bndconc(mi0(1),mj0(1),
     &                        mmxp(1),mmyp(1),ncol(1),nrow(1),nlay(1),
     &                                         nspec,nedge,conc,bndconc)
            endif
          endif
        endif
c
c  --- Check if master grid boundary data are to be read ---
c
      else 
        if (date .EQ. bnddate_in .AND. ABS(time-bndtim_in) .LT. 0.01) then
          if (iproc_id .EQ. 0) then
             write(*,'(a20,$)') 'readbnd ......'
             call readbnd(bndtim,bnddate)
             write(*,'(a)') '   Done'
             call flush(6)
          endif
c
c   --- if doing MPI, update edge cells on each slice ---
c
          if( lmpi ) then
            nedge = MAX(ncol(1),nrow(1))
            if( iproc_id .EQ. 0 ) 
     &        call master_bndconc(ncol(1),nrow(1),nlay(1),
     &                                          nspec,nedge,conc,bndconc)
            call edge_pass(nodeedge,bndconc,4*nedge*nlay(1)*nspec,MPI_REAL,
     &                                             itag,numprocs,iproc_id) 
            if( iproc_id .NE. 0 ) then
              if( nodeedge(iproc_id) ) 
     &          call nodes_bndconc(mi0(1),mj0(1),
     &                        mmxp(1),mmyp(1),ncol(1),nrow(1),nlay(1),
     &                                         nspec,nedge,conc,bndconc)
            endif
          endif
        endif
      endif
c
c========================= Source Apportion Begin ======================
c
c  --- call routine to clear the old boundary cells and then
c      call routine to fill with new boundary concentrations ---
c
c  --- For the Master Grid ---
c
      if (did_update_ibc .OR. (date .EQ. bnddate_in .AND. ABS(time-bndtim_in) .LT. 0.01)) then
        if (iproc_id .eq. 0) then
          if (ltrace) then
            if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
              call rdbcrt(nsteps,numcols(1),numrows(1),numlays(1),
     &                        ntotsp,ptconc(1),tempk(1),press(1)      )
              call ncf_rdbcrt(numcols(1),numrows(1),numlays(1),
     &                        ntotsp,ptconc(1),tempk(1),press(1)      )
            else
              if( .NOT. lsa_iorbc ) then
                call clrbdysa(1,numcols(1),numrows(1),
     &                          numlays(1),ntotsp,ptconc(1))
                call filbdysa(1,numcols(1),numrows(1),numlays(1),
     &                          nspec,ntotsp,conc(1),ptconc(1)     )
              endif
            endif
c
c  --- make sure it is not below lower bound ---
c
            mvsa3d = 0
            ncola = 0
            nrowa = 0
            do i=1,ngrid
               ncola = MAX(ncola,numcols(i))
               nrowa = MAX(nrowa,numrows(i))
               mvsa3d = mvsa3d + DBLE(numrows(i)) * DBLE(numcols(i)) * DBLE(numlays(i))
            enddo
            nmx1d  = MAX( nrowa, ncola )
            numsa = mvsa3d*DBLE(ntotsp)
            do idxsa=1,numsa
               ptconc(idxsa) = AMAX1(ptconc(idxsa),BNDLPT)
            enddo
          endif
c
c========================= Source Apportion End ========================
c
c
c============================= DDM Begin ===============================
c
c  --- For the Master Grid ---
c
          if( (lddm.OR.lhddm) .AND. nbcddm .GT. 0 ) then
            call rdbcddm(numcols(1),numrows(1),numlays(1),
     &                      ntotsp,ptconc(1),tempk(1),press(1))
            call ncf_rdbcddm(numcols(1),numrows(1),numlays(1),
     &                      ntotsp,ptconc(1),tempk(1),press(1))
          endif
        endif
c
c  --- update the DDM boundary sensitivites for the MPI slices ---
c
        if( (lddm.OR.lhddm) .AND. lmpi ) then
          nedge = MAX(ncol(1),nrow(1))
          if( iproc_id .EQ. 0 )
     &      call master_bndconc(ncol(1),nrow(1),nlay(1),
     &                                    ntotsp,nedge,ptconc,bndddm)
          call edge_pass(nodeedge,bndddm,4*nedge*nlay(1)*ntotsp,
     &                               MPI_REAL,itag,numprocs,iproc_id)
          if( iproc_id .NE. 0 ) then
            if( nodeedge(iproc_id) )
     &        call nodes_bndconc(mi0(1),mj0(1),
     &                      mmxp(1),mmyp(1),ncol(1),nrow(1),nlay(1),
     &                                     ntotsp,nedge,ptconc,bndddm)
          endif
        endif
c
c============================= DDM End =================================
c
c========================= Source Apportion Begin ======================
c
c  --- update the RTRAC boundary conditions for the MPI slices ---
c
        if( lmpi .AND. ltrace .AND.
     &           (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) ) then
          nedge = MAX(ncol(1),nrow(1))
          if( iproc_id .EQ. 0 )
     &      call master_bndconc(ncol(1),nrow(1),nlay(1),
     &                                    ntotsp,nedge,ptconc,bndrt)
          call edge_pass(nodeedge,bndrt,4*nedge*nlay(1)*ntotsp,
     &                               MPI_REAL,itag,numprocs,iproc_id)
          if( iproc_id .NE. 0 ) then
            if( nodeedge(iproc_id) )
     &        call nodes_bndconc(mi0(1),mj0(1),
     &                      mmxp(1),mmyp(1),ncol(1),nrow(1),nlay(1),
     &                                     ntotsp,nedge,ptconc,bndrt)
          endif
        endif
c
c========================= Source Apportion End ========================
c
      endif
c
c========================= Source Apportion Begin ======================
c
      if( ltrace .AND. lsa_iorbc ) then
         if( iproc_id .EQ. 0 ) then
            if( is_netcdf_iorbc ) then
               call ncf_rd_sa_bcfile()
            else
               if( date .EQ. sa_bnddate
     &                      .AND. ABS(time-sa_bndtim) .LT. 0.01) then
                  call rd_sa_bcfile()
               endif
            endif
            if( lsa_iortc ) then
               if( is_netcdf_iortc ) then
                  call ncf_rd_sa_tcfile()
               else
                   if( date .EQ. sa_bnddate
     &                      .AND. ABS(time-sa_bndtim) .LT. 0.01) then
                      call rd_sa_tcfile()
                   endif
               endif
            endif
         endif
         if( lmpi ) then
             nedge = MAX(ncol(1),nrow(1))
             if( iproc_id .EQ. 0 )
     &                call master_bndconc(ncol(1),nrow(1),nlay(1),
     &                                    ntotsp,nedge,ptconc,bndsa)
             call edge_pass(nodeedge,bndsa,4*nedge*nlay(1)*ntotsp,
     &                               MPI_REAL,itag,numprocs,iproc_id)
             if( iproc_id .NE. 0 ) then
               if( nodeedge(iproc_id) )
     &                call nodes_bndconc(mi0(1),mj0(1),
     &                      mmxp(1),mmyp(1),ncol(1),nrow(1),nlay(1),
     &                                     ntotsp,nedge,ptconc,bndsa)
             endif
         endif
      endif
c
c========================= Source Apportion End ======================
c
c
c  --- Check if master grid topcon data are to be read ---
c
      if (ltopcon) then
        if( is_netcdf_itc ) then
          if( iproc_id .EQ. 0) call ncf_readtop(time,date,did_update_itc)
          if( lmpi )
     &      call nodes_pass(did_update_itc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
        else
          if( date .EQ. topdate .AND. ABS(time-toptim) .LT. 0.01) then
            if (iproc_id .EQ. 0) then
              write(*,'(a20,$)') 'readtop ......'
              call readtop(toptim,topdate)
              write(*,'(a)') '   Done'
              call flush(6)
            endif
            if( lmpi ) then
               call nodes_pass(topdate,1,MPI_INTEGER,itag,numprocs,iproc_id)
               call nodes_pass(toptim,1,MPI_REAL,itag,numprocs,iproc_id)
            endif
          endif
        endif
c
c============================= DDM Begin ===============================
c
        if( did_update_itc .OR. (date .EQ. topdate .AND. ABS(time-toptim) .LT. 0.01)) then
          if (iproc_id .EQ. 0) then
            if ((lddm.OR.lhddm) .AND. nbcddm .GT. 0) then
              call rdtcddm()
              call ncf_rdtcddm(toptim,topdate)
            endif
          endif
c
c============================= DDM End =================================
c
c   --- if doing MPI, update topcon on each slice ---
c
          if( lmpi ) then
            call MPI_Barrier( MPI_COMM_WORLD, ierr)
            call nodes_topc(numprocs,iproc_id) ! this also updates DDM top con sens
          endif
        endif
      endif
c
      end

      subroutine get_nptsrc( )
      use filunit
      use chmstry
      use ptemiss
      implicit none
c 
c----CAMx v7.40 260801
c 
c     GET_NPTSRC loops over all of the elevated point source files 
c     and retrieves the number of point sources in each file. It then 
c     calculates the total number in the inventory.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        PNTPREP
c 
      include 'camx.prm'
      include 'netcdf.inc'
c
c-----Local variables
c
      integer idxfile, ierr, this_dimid, irec, idum
c
c-----Entry point
c
c-----Loop over all of the files
c
      do idxfile=1,npoint_files
c
c-----this file is old style binary ---
c
        if( .NOT. is_netcdf_iptem(idxfile) ) then
c
c-----Read 1st PT header record and check inputs 
c             
           rewind(iptem(idxfile))
           do irec=1,4
              read(iptem(idxfile))
           enddo
c 
           read(iptem(idxfile)) idum,nptsrc_files(idxfile)
        else
c
c-----this file is NetCDF format ---
c
           ierr = nf_inq_dimid(iptem(idxfile), "COL", this_dimid )
           if( ierr .NE. NF_NOERR ) goto 7000
           ierr = nf_inq_dimlen(iptem(idxfile),this_dimid,
     &                                    nptsrc_files(idxfile))
           if( ierr .NE. NF_NOERR ) goto 7000
        endif
      enddo
c
c---- all files processed, now calculate starting points ---
c
      idx_start_pts(1) = 0
      nptsrc = nptsrc_files(1)
      do idxfile=2,npoint_files
         idx_start_pts(idxfile) = nptsrc
         nptsrc = nptsrc + nptsrc_files(idxfile)
      enddo
c       
      goto 9999
c
c---- error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in GET_NPTSRC'
      write(iout,'(A,I3)') 'Reading the NetCDF elevated point source file:',idxfile
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

      subroutine massum(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,
     &                  igrid,nospec,ncol,nrow,nlay,dx,dy,
     &                  depth,mapscl,conc,xmass)
      use bndary
c
c----CAMx v7.40 260801
c
c     MASSUM sums up mass on a given grid, not including boundary cells
c
c      Copyright Ramboll
c
c     Modifications:
c        8/31/06         Added map scale factor
c
c     Input arguments:
c        igrid               grid index
c        nospec              number of species
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        depth               cell depth (m)
c        mapscl              map scale factor
c        conc                concentration field (umol/m3)
c
c     Output arguments:
c        xmass               grid mass (umol)
c
c     Routines called:
c        none
c
c     Called by:
c        CAMx
c        AGGR00
c        CHEMRXN
c
      include "camx.prm"
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon

      real*8 xmass(nospec)
      real   mapscl(m1,m2)
      real   conc(m1,m2,m3,nospec)
      real   dx(nrow)
      real   depth(m1,m2,m3)
c
      real*8 dtmp

c
c-----Entry point
c
      do 50 is = 1,nospec
        xmass(is) = 0.
        do 30 k = 1,nlay
          do 20 j = ja,jz  !2,nrow-1
            do i = ia,iz !2,ncol-1
              dtmp = DBLE(conc(i,j,k,is)*dx(j+j0)
     &                         *dy*depth(i,j,k)/(mapscl(i,j)**2))
              xmass(is) = xmass(is) + dtmp
            enddo
  20      continue
  30    continue
c
  50  continue
c
      return
      end

      subroutine sumicwt(ncolx,nrowy,nlays,deltax,depth,congrd,consum)
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c     SUMICWT sums up species concentrations from initial condition
c
c     Input arguments:
c        ncolx           the number of coarse grid columns
c        nrowy           the number of coarse grid rows
c        nlays           the number of coarse grid layers
c        depth           layer depth
c        congrd          species concentration for the grid
c
c     Output argumnets:
c        consum          sum of the species concentrations
c
      real    depth(ncolx,nrowy,nlays)
      real    congrd(ncolx,nrowy,nlays)
      real    deltax(nrowy)
c
c   --- calculate the average over all vertical cells,
c       weight by layer depth and cell width ---
c
      do 80 j=2,nrowy-1
         do 90 i=2,ncolx-1
            sumthk = 0
            sumcon = 0
            do 11 izcl=1,nlays
               sumthk = sumthk + depth(i,j,izcl) * deltax(j)
               sumcon = sumcon + 
     &              congrd(i,j,izcl) * depth(i,j,izcl) * deltax(j)
   11       continue
            if( sumthk .GT. 0. ) consum = consum + sumcon / sumthk
   90    continue
   80 continue
c
      return
      end

      subroutine chem10(dt,tcell,pcell,H2O,con)
      use filunit
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c     CHEM10 performs simple chemistry defined by the user.
c     You must hard code the reactions you want below.
c     Follow the guidelines and safety checks given as examples.
c                          
c      Copyright Ramboll
c
c     Modifications:
c        07/25/05      Corrected the exponential decay example
c
c     Input arguments:
c        dt                time duration to be integrated (hr)
c        H2O               water vapor concentration (ppm)
c        tcell             temperature (K)
c        pcell             pressure (mbar)
c        con               state species concentrations (ppm or ug/m3)
c
c     Output arguments:
c        con               state species concentrations (ppm or ug/m3)
c
c     Routines called:
c        NONE
c
c     Called by:
c        CHEMDRIV
c
      include "camx.prm"
      include 'chmdbg.inc'
c
c-----Arguments
c
      real dt
      real tcell
      real pcell
      real H2O
      real con(*)
c
c-----Local variables:
c
      real    rate, dc
      integer l
c
      real concin(MXSPEC+1)
c
c-----Entry point
c
      do l=1,nspec
        concin(l) = con(l)
      enddo
c
c=====Follow these guidelines for implementing reactions================
c
c --- For a reaction A --> B with rate in units hr-1
c
c     The species A and B are completely defined by the user, and therefore
c     do not appear in the universe of known CAMx species.  You must
c     be very careful to access specific species pointers in the CON array
c     in the order that the species appear in the chemistry parameters file.
c
c --- You can calculate a rate constant (k) using the expression:
c               k = A*(Tcell/Tref)^B*exp(Ea/Tcell)
c     by calling the CAMx function arren(Aa,Ea,B,Tref,Tcell).
c     See the subroutine EXPTBL for more complex expressions.
c
c --- Set the reaction rate in units hr-1, 
c
c        rate = 1.0 (for example)
c     or
c        rate = arren(Aa,Ea,B,tref,tcell)
c
c --- Be sure that the species A is the first species listed in the
c     chemistry parameters file.  Then decay A = species 1.

c        dc = con(1)*(1.0 - EXP(-rate*dt))
c        con(1) = con(1) - dc
c
c --- Be sure that the species B is the second species listed in the
c     chemistry parameters file.  Then increase B = species 2.
c
c        con(2) = con(2) + dc
c=======================================================================
c
      rate = 1.0
      dc = con(1)*(1.0 - EXP(-rate*dt))
      con(1) = con(1) - dc
      con(2) = con(2) + dc
c
c --- Check for negative concentrations
c
      do l=1,nspec
        if (con(l).lt.0.0) goto 900
        con(l) = amax1(con(l),bdnl(l))
      enddo
c
      return
c
c-----Error reporting on negative concentration
c
 900  write(iout,'(//,a)') ' ERROR in User Defined subroutine CHEM10:'
      write(iout,'(/,a)')  ' Negative Concentraion'
      write(iout,*) 'dt, temp(K), pressure(mbar), water(ppm) = ',
     &     dt, tcell, pcell, H2O
      write(iout,'(a,4i4)') ' igrd, i, j, k = ', igrdchm,ichm,jchm,kchm 
      write(iout,*) 'No  Name     New Conc  Conc In'
      do l=1,nspec
        write(iout,800) l,spname(l),con(l),concin(l)
      enddo
      call camxerr()
 800  format(i3,2x,a7,1p3e10.3)
      end

      subroutine init_fields_node(init)                  
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use node_mod
      use camx_includes
      use grid  
      use tracer
      use procan
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by: 
c       NODES_ALLOC
c
c      Copyright Ramboll
c
c     Modifications:
c       03/15/09     Added code for deposition output for tracers
c       10/29/09     Added code for RTRAC surface model
c       04/30/13     Added surface model
c       08/26/21     RTRAC surface file doubles as (default)
c                    dep output or (flagged) surface model output
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'rtracsrf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: init
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ng
      integer :: nm
      integer :: itype
      integer :: ii1
      integer :: jj1
      integer :: i2i
      integer :: jj2
      integer :: memf
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- Get all necessary fields from master. ---
c
c  --- bwang: this call has been moved to somewhere else. ---
c  --- call node_getinit() ---
c
c  --- Can we use existing memory for the nesting communication buffers?
c      If not, allocate new buffers or compute buffer sizes. ---
c
c  --- Check feedback buffer. ---
c
      itype=6
      nbuff_feed=0
      do ng=1,ngrid
         do nm=1,nmachs
            ii1=ipaths(1,itype,ng,nm)
            i2i=ipaths(2,itype,ng,nm)
            jj1=ipaths(3,itype,ng,nm)
            jj2=ipaths(4,itype,ng,nm)
            memf=(i2i-ii1+1)*(jj2-jj1+1)*(nlay(ng))*(4+nspec)
            nbuff_feed=max(nbuff_feed,memf)
         enddo
      enddo
c
c  --- Allocate long time step send and receive buffers ---
c
      if (init .NE. 1) then
         do nm=1,nmachs
            if( associated(node_buffs(nm)%lbc_send_buff))
     &                                 deallocate(node_buffs(nm)%lbc_send_buff)
            if( associated(node_buffs(nm)%lbc_recv_buff))
     &                                 deallocate(node_buffs(nm)%lbc_recv_buff)
         enddo
      endif
c
      do nm=1,nmachs
         if( node_buffs(nm)%nsend > 0)
     &             allocate(node_buffs(nm)%lbc_send_buff(node_buffs(nm)%nsend))
         if( node_buffs(nm)%nrecv > 0)
     &             allocate(node_buffs(nm)%lbc_recv_buff(node_buffs(nm)%nrecv))
      enddo
c
      if (init .NE. 1) then
         do nm=1,nmachs
           if( associated(node_buffs(nm)%lbc_dp_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_dp_send_buff)
           if( associated(node_buffs(nm)%lbc_dp_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_dp_recv_buff)
         enddo
      endif
c
      do nm=1,nmachs
         if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_dp_send_buff(node_buffs(nm)%nsend))
         if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_dp_recv_buff(node_buffs(nm)%nrecv))
      enddo
c
c  --- allocate lbc_smsol_send/recv_buff ---
c
      if( lsrfmod ) then
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_smsol_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_smsol_send_buff)
               if( associated(node_buffs(nm)%lbc_smsol_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_smsol_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_smsol_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_smsol_recv_buff(node_buffs(nm)%nrecv))
         enddo
c
c  --- allocate lbc_smveg_send/recv_buff ---
c
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_smveg_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_smveg_send_buff)
               if( associated(node_buffs(nm)%lbc_smveg_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_smveg_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_smveg_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_smveg_recv_buff(node_buffs(nm)%nrecv))
         enddo
      endif
c
c  --- allocate lbc_pt_send/recv_buff ---
c
      if( ltrace .OR. lddm .OR. lhddm .OR. lirr ) then 
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_pt_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_pt_send_buff)
               if( associated(node_buffs(nm)%lbc_pt_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_pt_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_pt_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_pt_recv_buff(node_buffs(nm)%nrecv))
         enddo
      endif
c
c  --- allocate lbc_rad_send/recv_buff ---
c
      if (init .NE. 1) then
         do nm=1,nmachs
            if( associated(node_buffs(nm)%lbc_rad_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_rad_send_buff)
            if( associated(node_buffs(nm)%lbc_rad_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_rad_recv_buff)
         enddo
      endif
c
      do nm=1,nmachs
         if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_rad_send_buff(node_buffs(nm)%nsend))
         if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_rad_recv_buff(node_buffs(nm)%nrecv))
      enddo
c
c  --- allocate lbc_dry_send/recv_buff ---
c
      if( lptdepout ) then
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_dry_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_dry_send_buff)
               if( associated(node_buffs(nm)%lbc_dry_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_dry_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_dry_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_dry_recv_buff(node_buffs(nm)%nrecv))
         enddo
      endif
c
c  --- allocate lbc_wet_send/recv_buff ---
c
      if( lptdepout ) then
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_wet_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_wet_send_buff)
               if( associated(node_buffs(nm)%lbc_wet_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_wet_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_wet_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_wet_recv_buff(node_buffs(nm)%nrecv))
         enddo
      endif
c
c  --- allocate lbc_rtsol_send/recv_buff ---
c
      if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_rtsol_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_rtsol_send_buff)
               if( associated(node_buffs(nm)%lbc_rtsol_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_rtsol_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_rtsol_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_rtsol_recv_buff(node_buffs(nm)%nrecv))
         enddo
c
c  --- allocate lbc_rtveg_send/recv_buff ---
c
         if (init .NE. 1) then
            do nm=1,nmachs
               if( associated(node_buffs(nm)%lbc_rtveg_send_buff))
     &                              deallocate(node_buffs(nm)%lbc_rtveg_send_buff)
               if( associated(node_buffs(nm)%lbc_rtveg_recv_buff))
     &                              deallocate(node_buffs(nm)%lbc_rtveg_recv_buff)
            enddo
         endif
c
         do nm=1,nmachs
            if( node_buffs(nm)%nsend > 0)
     &          allocate(node_buffs(nm)%lbc_rtveg_send_buff(node_buffs(nm)%nsend))
            if( node_buffs(nm)%nrecv > 0)
     &          allocate(node_buffs(nm)%lbc_rtveg_recv_buff(node_buffs(nm)%nrecv))
         enddo
      endif
c
      return
      end

      subroutine wrtcon(iflag,tim2,idat2,iunit,igrd,nox,noy,noz,
     &                  nsptmp,cncfld)
      use grid
      use chmstry
      use camxcom
c
c----CAMx v7.40 260801
c 
c     WRTCON writes average and instantaneous concentration fields; for
c     average files, optionally writes only layer 1; for instantaneous files,
c     writes all layers.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        1/20/99   Grid cell size on file should be meters for all cartesian
c                  projections (UTM, LCP, PSP)
c        10/24/01  Removed BSWAP and converted integer strings to character*4
c        8/23/06   Only a single instant restart file is written at end of
c                  simulation
c        12/15/08  Added code to handle averaging of radicals
c        01/04/11  Revised for new header format
c 
c     Input arguments:
c        iflag               output type flag (0=average/1=instantaneous)
c        tim2                output time (HHMM)
c        idat2               output date (YYJJJ)
c        iunit               output unit
c        igrd                grid number
c        nox                 number of cells in x-direction
c        noy                 number of cells in y-direction
c        noz                 number of layers
c        nsptmp              number of species
c        cncfld              concentration field to output (ppm or umol/m3)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c 
      include 'camx.prm'
      include 'flags.inc'
c
      real cncfld(nox,noy,noz,nsptmp)
c
      character*4 ifile(10), note(60)
      character*10 cnfil
c
      character*4 ispec(10,MXSPEC)
      integer     buffer_offset
c
c-----Data statements
c
      data cnfil /'INSTANT   '/
      data nseg,izero,ione /1,0,1/
      data zero /0./
c
c-----Entry point
c
       buffer_offset = 0
c
c-----Determine time/date range
c
      idat1 = idat2
      etim = AINT(ANINT(tim2)/100.) + amod(ANINT(tim2),100.)/60.
      btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      if (btim.lt.0.) then
        btim = btim + 24.
        idat1 = idat1 - 1
        if (MOD(idat1,1000) .EQ. 0 ) then
          if ( MOD(INT(idat1/1000)-1,4) .EQ. 0 ) then
            idat1 = (INT(idat1/1000)-1)*1000 + 366
          else
            idat1 = (INT(idat1/1000)-1)*1000 + 365
          endif
        endif
      endif
      idat3 = idat2
      etim3 = etim + 0.1
      if (etim3.gt.24.) then
        etim3 = etim3 - 24.
        idat3 = idat3 + 1
        if( MOD(idat3,1000) .GT. 365 ) then
            if( MOD(INT(idat3/1000),4) .EQ. 0 ) then
               if( MOD(idat3,1000) .EQ. 367 )
     &                     idat3 = (INT(idat3/1000)+1)*1000 + 1
            else
               idat3 = (INT(idat3/1000)+1)*1000 + 1
            endif
         endif
      endif
c
c-----For instantaneous files, write the header
c
      nlayer = noz
      if (iflag.eq.1) then
        read(cnfil,'(10a1)') (ifile(n),n=1,10)
        read(runmsg(1:60),'(60a1)') (note(n),n=1,60)
        iutm = iuzon
        plon = polelon
        plat = polelat
        t1   = tlat1
        t2   = tlat2
        if (llatlon) then
          iproj = 0
          orgx = xorg
          orgy = yorg
          dx = delx
          dy = dely
        else
          orgx = 1000.*xorg
          orgy = 1000.*yorg
          dx = 1000.*delx
          dy = 1000.*dely
          if (lutm) then
            iproj = 1
          elseif (lambrt) then
            iproj = 2
          elseif (lrpolar) then
            iproj = 3
          elseif (lpolar) then
            iproj = 4
          elseif (lmerc) then
            iproj = 5
          endif
        endif
        do l=1,nsptmp
          read(spname(l),'(10a1)') (ispec(n,l),n=1,10) 
        enddo
c
        write(iunit) ifile,note,itzon,nsptmp,idat2,etim,idat3,etim3
        write(iunit) plon,plat,iutm,orgx,orgy,dx,dy,
     &               nox,noy,noz,iproj,izero,t1,t2,zero
        write(iunit) ione,ione,nox,noy
        write(iunit) ((ispec(n,l),n=1,10),l=1,nsptmp)
        write(iunit) idat2,etim,idat3,etim3
      else
        if( igrd. GT. 1 ) buffer_offset = 1
        do l = 1,nsptmp
          if( lavmap(l) .NE. 0 ) read(spname(lavmap(l)),'(10a1)') 
     &                                             (ispec(n,l),n=1,10)
        enddo
        if( .NOT. l3davg(igrd) ) nlayer = 1 
        write(iunit) idat1,btim,idat2,etim
      endif
c
c-----Write gridded concentration field
c
      do l = 1,nsptmp
        do k = 1,nlayer
          write(iunit) nseg,(ispec(n,l),n=1,10),
     &                 ((cncfld(i,j,k,l),i=1+buffer_offset,nox-buffer_offset),
     &                                    j=1+buffer_offset,noy-buffer_offset)
        enddo
      enddo
c
      return
      end

      subroutine vrtslv(nlay,ii,jj,igrd,dtin,entrn,dilut,depth,conc,
     &                   lvupsolv,fluxtop,fluxlay,sens,spec,fc1,fc2,
     &                                                    fc3,ldoipts)
      use filunit
      use tracer
c
c----CAMx v7.40 260801
c 
c     VRTSLV performs column mass adjustments due to vertical advection and
c     changes in layer structure that result from the time- and space-varying
c     vertical coordinate system.  This version performs the mass adjustments
c     for both the concentrations and the sensitivities.
c     The system is solved using a fully implicit backward Euler approach in
c     time and a hybrid centered/upstream-donor approach in space.  The latter
c     (upstream) is used if the vertical CFL>1, or if centered difference results in
c     a local negative concentrations locally.
c
c     The difference equations are generalized to allow for three time 
c     differencing options, depending on the value of the parameter "mu":
c        1) Crank-Nicholson semi-implicit (mu=0.5)
c        2) Fully explicit forward Euler (mu=0)
c        3) Fully implicit backward Euler (mu=1) !Current implementation!
c     Upper boundary conditions:
c        This routine accomodates non-zero vertical velocities at the top of
c        the column; the top boundary condition is held in the conc vector
c        at location (nlay+1).
c     Lower boundary conditions:
c        Zero flux is specified at the ground
c
c      Copyright Ramboll
c
c     Modifications: 
c        12/3/99   This routine is now fully implicit, and calculation
c                  of sub-timesteps has been removed.
c        3/06/06   Revised top BC approach; removed top dummy layer
c       07/16/07 -bkoo-     Added check for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       11/04/09   Revised for hybrid centered/upstream-donor technique
c       08/30/22   Fixed sensitivity array dims to be consistent
c                  with ZADVEC and avoid accessing memory out-of-bounds
c
c     Input arguments: 
c        nlay                number of layers
c        ii                  column index
c        jj                  row index
c        dtin                timestep (s)
c        entrn               entrainment rate (m/s) 
c        dilut               dilution rate (m/s)
c        depth               layer depth (m)
c        conc                species concentration (umol/m3)
c        lvupsolv            flag to use upstream donor solver
c        sens                sensitivity coefficients(umol/m3/parameter unit)
c        spec                species name
c        ldoipts             flag to calculate Process Analysis data
c 
c     Output arguments: 
c        conc                species concentration (umol/m3)
c        fluxtop             flux across the top boundary (umol/(m2*s))
c        fluxlay             flux across top of each layer (umol/(m2*s))
c        sens                sensitivity coefficients(umol/m3/parameter unit)
c        fc1                 conc entrained through bottom of layer (umol/m3)
c        fc2                 conc entrained through top of layer (umol/m3)
c        fc3                 conc diluted by layer expansion/contraction
c                            (umol/m3)
c 
c     Routines Called: 
c        TRIDIAG
c 
c     Called by: 
c        ZADVEC 
c
      implicit none
      include "camx.prm"
c
      real mu
      parameter (mu = 1.0)

      character*10 spec
      integer nlay
      integer ii,jj,igrd
      real conc(nlay+1),entrn(nlay),dilut(nlay),depth(nlay)
c
      real dtin,deltac
      real fluxtop
c
      integer nsteps,k,kk,ineg
      real dt
      logical lvupsolv(nlay)
c
      real pn(MXLAYER)
      real pnp1(MXLAYER)
      real aa(MXLAYER)
      real bb(MXLAYER)
      real cc(MXLAYER)
      real rr(MXLAYER*(MXFDDM+1))
      real zrp(MXLAYER)
      real zrm(MXLAYER)
      real fluxlay(MXLAYER)
c
c===========================DDM Begin=================================
c
      integer ls,lrr,isen
      real sens((MXLAYER+1),MXFDDM)
c
c     Note:  nddmsp is the total number of DDM parameters for which
c            sensitivities are calculated.
c
c===========================DDM End===================================
c
c
c================== Process Analysis Begin ===========================
c
      logical ldoipts
      real fc1(*)
      real fc2(*)
      real fc3(*)
c
c=================== Process Analysis End ============================
c
c-----Entry point
c
      dt = dtin
      nsteps = 1
c
c-----Calculate some constants
c
      fluxtop = 0.
      do k = 1,nlay
        pn(k) = (1. - mu)*dt/depth(k)
        pnp1(k) = mu*dt/depth(k)
      enddo
      do k = 1,nlay-2
        zrp(k) = depth(k+1)/(depth(k+1) + depth(k))
        zrm(k) = depth(k)/(depth(k+1) + depth(k))
      enddo
      do k = nlay-1,nlay
        zrp(k) = 0.
        zrm(k) = 1.
        if (entrn(k).lt.0.) then
          zrp(k) = 1.
          zrm(k) = 0.
        endif
      enddo
c
c-----Check upstream donor flag for hybrid case
c
      do k = 1,nlay-2
        if (lvupsolv(k)) then
          zrp(k) = 0.
          zrm(k) = 1.
          if (entrn(k).lt.0.) then
            zrp(k) = 1.
            zrm(k) = 0.
          endif
        endif
      enddo
c
c-----Calculate matrix coefficients A,B & C, and array R for the equation
c        n+1     n+1     n+1   n
c     A*c   + B*c   + C*c   = R
c        k-1     k       k+1
c
 100  continue
c
      do k = 2,nlay-1
        aa(k) = pnp1(k)*zrp(k-1)*entrn(k-1)
        bb(k) = 1. + pnp1(k)*
     &          (zrm(k-1)*entrn(k-1) - zrp(k)*entrn(k) + dilut(k))
        cc(k) = -pnp1(k)*zrm(k)*entrn(k)
        rr(k) = -pn(k)*zrp(k-1)*entrn(k-1)*conc(k-1) +
     &          conc(k)*(1. - pn(k)*
     &          (zrm(k-1)*entrn(k-1) - zrp(k)*entrn(k) + dilut(k))) +
     &          pn(k)*zrm(k)*entrn(k)*conc(k+1)
      enddo
c
c-----Lower boundary conditions
c
      k = 1
      aa(k) = 0.
      bb(k) = 1. + pnp1(k)*(-zrp(k)*entrn(k) + dilut(k))
      cc(k) = -pnp1(k)*zrm(k)*entrn(k)
      rr(k) = conc(k)*(1. - pn(k)*(-zrp(k)*entrn(k) + dilut(k))) +
     &        pn(k)*zrm(k)*entrn(k)*conc(k+1)
c
c-----Upper boundary conditions
c
      k = nlay
      aa(k) = pnp1(k)*zrp(k-1)*entrn(k-1)
      bb(k) = 1. + pnp1(k)*
     &        (zrm(k-1)*entrn(k-1) - zrp(k)*entrn(k) + dilut(k))
      cc(k) = 0.
      rr(k) = -pn(k)*zrp(k-1)*entrn(k-1)*conc(k-1) +
     &        conc(k)*(1. - pn(k)*
     &        (zrm(k-1)*entrn(k-1) - zrp(k)*entrn(k) + dilut(k))) +
     &        zrm(k)*entrn(k)*conc(k+1)*dt/depth(k)
c
c============================DDM Begin================================
c
c-----If sensitivities are requested, load additional arrays into rr,
c     one array for each sensitivity coefficient.  Additional right-hand
c     side arrays rr are calculated for the equation
c        n+1     n+1     n+1    n
c     A*s   + B*s   + C*s   = r
c        k-1     k       k+1
c     The right-hand side arrays for both the concentration and
c     sensitivity equations are loaded into the same array rr, and
c     the equations are solved together.
c
c     Load the lower boundary condition, then layers
c     2 through nlay-1, finally the upper boundary condition.
c
        if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
          ls = 0
          lrr = nlay
          do isen = 1,nddmsp
            ls = ls + 1
            lrr = lrr + 1
            k = 1
            rr(lrr) = sens(k,isen)*
     &                (1. - pn(k)*(-zrp(k)*entrn(k) + dilut(k))) +
     &                pn(k)*zrm(k)*entrn(k)*sens(k+1,isen)
            do k = 2,nlay-1
              ls = ls + 1
              lrr = lrr + 1
              rr(lrr) = -pn(k)*zrp(k-1)*entrn(k-1)*sens(k-1,isen) +
     &                  sens(k,isen)*(1. - pn(k)*
     &                           (zrm(k-1)*entrn(k-1) -
     &                            zrp(k)*entrn(k) +
     &                            dilut(k))) +
     &                  pn(k)*zrm(k)*entrn(k)*sens(k+1,isen)
            enddo
 
            ls = ls + 1
            lrr = lrr + 1
            k = nlay
            rr(lrr) = -pn(k)*zrp(k-1)*entrn(k-1)*sens(k-1,isen) +
     &                sens(k,isen)*(1. - pn(k)*
     &                         (zrm(k-1)*entrn(k-1) - 
     &                          zrp(k)*entrn(k) + 
     &                          dilut(k))) +
     &                zrm(k)*entrn(k)*sens(k+1,isen)*dt/depth(k)
            ls = ls + 1
          enddo
        endif
c
c=============================DDM End=================================
c
c-----Solve the equations
c
      if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
         call tridiag(aa,bb,cc,rr,nlay,nddmsp+1)
      else
         call tridiag(aa,bb,cc,rr,nlay,1)
      endif
c
      if (nsteps.lt.nlay) then
        ineg = 0
        do k = 1,nlay
          deltac = (rr(k) - conc(k))/conc(k)
          if (deltac.le.-0.99) then
            if( k.gt.1 ) then
              if( entrn(k-1).gt.0.) then
                zrp(k-1) = 0.
                zrm(k-1) = 1.
              endif
            endif
            if (entrn(k).lt.0.) then
              zrp(k) = 1.
              zrm(k) = 0.
            endif
            ineg = 1
          endif
        enddo
        if (ineg.eq.1) then
          nsteps = nsteps + 1
          goto 100
        endif
      endif
c
      fluxlay(1) = -(rr(1) - conc(1))*depth(1)/dt
      do k = 2,nlay
        fluxlay(k) = -(rr(k) - conc(k))*depth(k)/dt + fluxlay(k-1)
      enddo
      fluxtop =  fluxlay(nlay)
c
c===================== Process Analysis Begin =========================
c
      if (ldoipts) then
        do k = 1,nlay
          fc3(k) = -dt/depth(k)*dilut(k)*conc(k)
        enddo
        fc1(1) = 0.
        do k = 2,nlay
          fc1(k) = fluxlay(k-1)/depth(k)*dt
        enddo
        do k = 1,nlay
          fc2(k) = -fluxlay(k)/depth(k)*dt
        enddo
      endif
c
c====================== Process Analysis End ==========================
c
      do k = 1,nlay
        if (rr(k).le.0.) then 
          write(iout,'(//,a)') 'ERROR in VRTSLV:'
          write(iout,*) 'Negative concentration ',
     &                  'when doing advection in z-direction'
          write(iout,*) 'Grid: ',igrd
          write(iout,*) 'Location (I,J,K): ',ii,jj,k
          write(iout,*) 'Species: ',spec 
          write(iout,'(a,i3,a,i3)')'Number of steps: ',nsteps
          do kk = 1,nlay 
            write(iout,'(i3,6e12.4,f5.1,6f7.3)') kk,rr(kk), 
     &            conc(kk),depth(kk),entrn(kk),dilut(kk)
          enddo 
          call camxerr()
        endif
        conc(k) = rr(k)
      enddo
c
c==============================DDM Begin===============================
c
      if( (lddm .OR. lhddm) .AND. lddmcalc(igrd) ) then
        ls = -1
        lrr = nlay
        do isen = 1,nddmsp
          ls = ls + 1
          do k = 1, nlay
            ls = ls + 1
            lrr = lrr + 1
            sens(k,isen) = rr(lrr)
          enddo
        enddo
      endif
c
c===============================DDM End================================
c
      return
      end

      subroutine timrates(ncol,nrow,nlay,fnow,fnxt,pfpt)
      use bndary
      use camxcom
c  
c----CAMx v7.40 260801
c 
c     TIMRATES calculates local (Eulerian) time-rate of change of the 
c     input field for a given grid.
c  
c      Copyright Ramboll
c  
c     Modifications:   
c        none
c   
c     Input arguments:   
c        ncol                number of columns  
c        nrow                number of rows  
c        nlay                number of layers  
c        fnow                current parameter field 
c        fnxt                future parameter field
c              
c     Output arguments:   
c        pfpt                time-rate change of parameter field
c              
c     Routines Called:   
c        none  
c              
c     Called by:   
c        READINP
c        INTRPDAT
c
      include 'camx.prm'
c
      real fnow(ncol,nrow,nlay),fnxt(ncol,nrow,nlay),
     &     pfpt(ncol,nrow,nlay)
c
c-----Entry point
c
      do 10 k = 1,nlay 
        do 15 j = 1,nrow 
          do 20 i = 1,ncol 
            pfpt(i,j,k) = (fnxt(i,j,k) - fnow(i,j,k))/(60.*dtinp)
 20       continue 
 15     continue 
 10   continue 
c
      return
      end

      Module rtcmcchm
      include 'rtcmcchm.inc'
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This allocates the dynamic memory arrays in the RTCMCCHM.COM
c        include file.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c       11/17/20    RTCMC dry/wet deposition is now consistent with RTRAC
c       04/05/21    Enable scaling factor for photolysis reactions
c                   that point to core mech reactions
c-----------------------------------------------------------------------
c
      Contains
c
c-----------------------------------------------------------------------
c   BEGIN SUBROUTINE ALLOC_RTCMC
c-----------------------------------------------------------------------
c
         subroutine alloc_rtcmc(numtracs,numspec,numrxn,
     &                          numkprm,numphot,numzen,numrct,numprd,
     &                          numjactrm,numeqm,numslo)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
         use camx_includes
         implicit none
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        numtracs   I  number of RTCMC species
c        numspec    I  number of core model species
c        numrxn     I  number of RTCMC reactions
c        numkprm    I  number of rate constant parameters
c        numphot    I  number of photolysis reactions
c        numzen     I  number of photolysis reaction zenith angles
c        numrct     I  number of reactants in each reaction
c        numprd     I  number of products in each reaction
c        numjactrm  I  number of Jacobian terms (an estimate)
c        numeqm     I  number of equilibrium species
c        numslo     I  number of slow species
c     Output:  
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
         integer :: numtracs
         integer :: numspec
         integer :: numrxn
         integer :: numkprm
         integer :: numphot
         integer :: numzen
         integer :: numrct
         integer :: numprd
         integer :: numjactrm
         integer :: numeqm
         integer :: numslo
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
         allocate( ityprtc  (numrxn) )
         allocate( nrkprm   (numrxn) )
         allocate( rkprmrtc (numrxn,numkprm) )
c
         allocate( ijschm   (numphot) )
         allocate( ijpntr   (numphot) )
         allocate( jscale   (numphot) )
         allocate( zenschm  (numzen) )
         allocate( rjschm   (numzen,numphot) )
c
         allocate( itypsp(numtracs+numspec) )
         allocate( itypschm(numtracs+numspec) )
         allocate( lblrxn(numrxn) )
         allocate( nrct(numrxn) )
         allocate( nprd(numrxn) )
         allocate( idxrct(numrxn,numrct) )
         allocate( idxprd(numrxn,numprd) )
         allocate( conschm(numtracs+numspec) )
         allocate( spdcoef(numrxn,numprd) )
         allocate( prdcoef(numrxn,numprd) )
         allocate( spnmrt(numtracs+numspec) )
         allocate( spnmschm(numtracs+numspec) )
         allocate( hlawschm(numtracs+numspec) )
         allocate( tfacschm(numtracs+numspec) )
         allocate( molwschm(numtracs+numspec) )
         allocate( reacschm(numtracs+numspec) )
         allocate( rsclschm(numtracs+numspec) )
         allocate( namrct(numrxn,numrct) )
         allocate( namprd(numrxn,numprd) )
c
         allocate( nrctfst(numrxn) )
         allocate( nprdfst(numrxn) )
         allocate( idxrctfst(numrxn,numrct) )
         allocate( idxprdfst(numrxn,numprd) )
         allocate( prdcofst(numrxn,numprd) )
c
         allocate( ipd(numjactrm) )
         allocate( jpd(numjactrm) )
         allocate( idrxjac(numjactrm) )
         allocate( nspjac(numjactrm) )
         allocate( idspjac(numjactrm,numrct-1) )
         allocate( scoefjac(numjactrm) )
         allocate( coefjac(numjactrm) )
c
         allocate( idslo(numslo) )
         allocate( nslgain(numslo) )
         allocate( nslloss(numslo) )
         allocate( islgain(numslo,numrxn) )
         allocate( islloss(numslo,numrxn) )
         allocate( spdcoslo(numslo,numrxn) )
         allocate( prdcoslo(numslo,numrxn) )
c
         allocate( ideqm(numeqm) )
         allocate( nrxgain(numeqm) )
         allocate( nrxloss(numeqm) )
         allocate( irxgain(numeqm,numrxn) )
         allocate( irxloss(numeqm,numrxn) )
         allocate( irxupdt(numrxn) )
         allocate( spdcoeqm(numeqm,numrxn) )
         allocate( prdcoeqm(numeqm,numrxn) )
c
         allocate( idxfix(numtracs+numspec) )
c
         return
         end subroutine
c
c-----------------------------------------------------------------------
c   END SUBROUTINE ALLOC_RTCMC
c-----------------------------------------------------------------------
c
      end Module

      subroutine caldate(idate)
c  
c----CAMx v7.40 260801
c  
c     CALDATE converts date from Julian (YYJJJ) format to calender
c     (YYMMDD) format
c                            
c      Copyright Ramboll
c            
c     Modifications:  
c        none
c  
c     Input arguments:  
c        idate               julian date (YYJJJ)  
c              
c     Output arguments:  
c        idate               calender date (YYMMDD)  
c              
c     Routines Called:  
c        none
c              
c     Called by:  
c        DRYDEP
c        DRYDEPRT
c        CHRTIME
c        PIGDRIVE
c
      integer nday(12)
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
c-----If it is already in calender date, return
c
      if (idate.gt.100000) goto 9999
      iyear = idate/1000
      jday = idate - iyear*1000
c
      nday(2) = 28
      if (mod(iyear,4).eq.0) nday(2) = 29
      mday = 0
      do 10 imonth = 1,12
        mday = mday + nday(imonth)
        if (mday.ge.jday) go to 20
 10   continue
 20   iday = jday - (mday - nday(imonth))
      idate = iyear*10000 + imonth*100 + iday
c
 9999 return
      end

      subroutine depsmry(igrid,ncol,nrow,nspc,vdep)
      use filunit
      use chmstry
      use bndary
c 
c----CAMx v7.40 260801
c
c     DEPSMRY finds the maximum, minimum, and mean of deposition
c     velocity, and writes out a table
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments: 
c        igrid               grid index
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        nspc                number of species
c        vdep                deposition velocity (m/s)
c
c     Output arguments:
c        none
c     
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c
      include "camx.prm"
c
      real vdep(ncol,nrow,nspc)
c
c-----Entry point
c
      write(idiag,*)
      write(idiag,'(a,i3)') 'DRY DEPOSITION VELOCITY (cm/s) FOR GRID ',
     &                      igrid
      write(idiag,'(a,3a12)') 'SPECIES   ','MAX','MIN','MEAN'
c
c-----Determin min, max, avg for each species
c
      do 100 l=1,nspc
        vmax = 0.
        csum = 0.
        kount = 0
        vmin = 1.e6
        do 30 j = 2,nrow-1
          do i = 2,ncol-1
            kount = kount + 1
            vmax = amax1(vmax,vdep(i,j,l))
            vmin = amin1(vmin,vdep(i,j,l))
            csum = csum + vdep(i,j,l)
          enddo
  30    continue
        vmean = csum/kount
        write(idiag,'(a10,3e12.3)') spname(l),vmax*100.,vmin*100.,
     &                              vmean*100.
  100 continue
      write(idiag,*)
      call flush(idiag)
c
      return
      end

c*** LOADCSA_CONC
c
      subroutine loadcsa_conc(ncol_csa,nrow_csa,nlay_csa,ncsa,gridcsa,
     &         icl_csa,jcl_csa,kcl_csa,icl_mod,jcl_mod,kcl_mod,
     &         numspc_csa,nspc,ngas,nrad,nhet,ncol_mod,nrow_mod,nlay_mod,gridmod)
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine loads the regular model concentrations into the
c     appropriate location for the CSA grids. This is done each hour.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c       ncol_csa   I  number of cells in X direction in CSA grid
c       nrow_csa   I  number of cells in Y direction in CSA grid
c       nlay_csa   I  number of layers in CSA grid
c       ncsa       I  number of total CSA species
c       gridcsa    R  4-D array of CSA values
c       icl_csa    I  the X grid location of current cell of CSA grid
c       jcl_csa    I  the Y grid location of current cell of CSA grid
c       kcl_csa    I  the vertical grid location of current layer of CSA grid
c       icl_mod    I  the X grid location of current cell of model grid
c       jcl_mod    I  the Y grid location of current cell of model grid
c       kcl_mod    I  the vertical grid location of current layer of model grid
c       numspc_csa I  number of CSA families
c       nspc       I  number of modeled species
c       ngas       I  number of gaseous species
c       nrad       I  number of radical species
c       nhet       I  number of heterogeneous rxns
c       ncol_mod   I  number of cells in X direction in modelling grid
c       nrow_mod   I  number of cells in Y direction in modelling grid
c       nlay_mod   I  number of layers in modelling grid
c       gridmod    R  gridded array of regular model  concentrations
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer ncol_csa
      integer nrow_csa
      integer nlay_csa
      integer ncsa
      real    gridcsa(ncol_csa,nrow_csa,nlay_csa,ncsa)
      integer icl_csa
      integer jcl_csa
      integer kcl_csa
      integer icl_mod
      integer jcl_mod
      integer kcl_mod
      integer numspc_csa
      integer nspc
      integer ngas
      integer nrad
      integer nhet
      integer ncol_mod
      integer nrow_mod
      integer nlay_mod
      real    gridmod(ncol_mod,nrow_mod,nlay_mod,nspc)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   icsa, ispc, idxcsa
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- loop over the modeled species ---
c
      do ispc=nrad+1,ngas
c
c  --- loop over the number of CSA families ---
c
         do icsa=1,numspc_csa
c
c  --- calculate the index into the CSA species list ---
c
            idxcsa = iptddm(ispc)+icsa-1
            gridcsa(icl_csa,jcl_csa,kcl_csa,idxcsa) = 
     &                  gridmod(icl_mod,jcl_mod,kcl_mod,ispc)
c
c  --- next family ---
c
         enddo
c
c  --- next species ---
c
      enddo
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine nodes_met_pig(numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine passes all of the PiG data that is time-step
c        dependent to the compute nodes when in MPI mode.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       EMISTRNS
c    Subroutines called:
c       NODES_PASS
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'mpif.h'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: numprocs
      integer :: iproc_id 
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: nslice
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- pass the mass flux array
c
      call nodes_pass(nreactr,          1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(loverlap,         1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  --- pass the variables in the pigsty include file ---
c
      call nodes_pass(npig,      1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(npigon,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipigint,   1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ingrd,  npig,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idpig,  npig,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(xpigf,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(xpigb,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ypigf,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ypigb,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(zpig,   npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(axisy,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(axisz,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(sigy,   npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(sigx,   npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(sigz,   npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(htfms,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(htfmb,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(vtfms,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(vtfmb,  npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(agepigf,npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(agepigb,npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(fmspig, npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lnewt,  npig,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lnewg,  npig,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ipufmap,npig,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipufgrp,npig,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(pufftop,npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(puffbot,npig,   MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lsample,   1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsmptrc,   1,MPI_LOGICAL,itag,numprocs,iproc_id)
      nslice =  ngrid*(numprocs-1)*MXPIG
      call nodes_pass(Lslice,nslice,MPI_LOGICAL,itag,numprocs,iproc_id)
c
      call nodes_pass(puffmass,nspec*nreactr*npig,
     &                MPI_REAL,itag,numprocs,iproc_id)
c
      if( ltrace .AND. (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) ) then
         call nodes_pass(puffrt,ntotsp*MXRECTR*npig,
     &                   MPI_REAL,itag,numprocs,iproc_id)
      endif
c
      return
      end

c*** CYCTPNSA
c
      subroutine cyctpnsa(nspc,convfac,cold,delcon,rrxn_irr,
     &                    destRGN,prodRGN,NIT2RGN,RGN2NIT,
     &                    alphaRGN,betaRGN,gammaRGN,alphaNIT,cycNIT,
     &                    alphaNTR,betaNTR,alphaHN3,alphaTPN,betaTPN,
     &                    gammaTPN,cycTPN)
      use filunit
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine calculates the coefficients used in the chemistry
c     calculations of the nitrate species in SA.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       nspc       I  number of model species
c       convfac    R  conversion from ppm to umole/m3
c       cold       R  array of concentrations at last time step
c       delcon     R  array of change in concentrations
c       rrxn_irr   R  array of integrated reaction rates
c     Outputs:
c       destRGN    R  negative change in RGN (zero if RGN increasing)
c       prodRGN    R  positive change in RGN (zero if RGN decreasing)
c       NIT2RGN    R  conversion of NIT to RGN
c       RGN2NIT    R  conversion of RGN to NIT
c       alphaRGN   R  conversion of RGN to NTR
c       betaRGN    R  conversion of RGN to TPN (excluding cycTPN)
c       gammaRGN   R  conversion of RGN to NH3
c       alphaNIT   R  conversion of NIT to NTR
c       cycNIT     R  interconversion of NIT and RGN
c       alphaNTR   R  conversion of NTR to RGN
c       betaNTR    R  conversion of NTR to HN3
c       alphaHN3   R  conversion of HN3 to RGN
c       alphaTPN   R  conversion of TPN to HN3
c       betaTPN    R  conversion of TPN to RGN (excluding cycTPN)
c       gammaTPN   R  conversion of TPN to NTR
c       cycTPN     R  interconversion of TPN and RGN
c
c   Definitions of tracer families for reference:
c       NIT - sum of NO and HONO
c       RGN - sum of NO2, NO3, 2*N2O5 and INO3
c       TPN - sum of PAN compounds (and species that behave like PAN)
c       NIT - sum of organic nitrates (except those that behave like PAN)
c       HN3 - nitric acid (HNO3)
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     09/28/03   --gwilson--  Original development
c     12/29/06   --bkoo--     Revised for the updated SOA scheme
c     01/08/06   --bkoo--     Added Mechanism 6 (CB05)
c     05/17/07   --gwilson--  Changes to improve handling of small
c                             concentrations near lower bounds
c     12/22/13   --gwilson--  Added Mechanism 2 (CB6r2)
c     03/15/16   --gyarwood-  Changed for OSAT3 (NO2 apportioned)
c     06/24/16   --bkoo--     Updated Mechanism 4 (CB6r4)
c     10/16/17   --bkoo--     Changed DELCON size
c     11/27/17   --bkoo--     Updated for CB6r2h
c     01/16/18   --gyarwood-  Added SAPRC07T
c     02/21/20   --rlb--      Added Mechanism 1 (CB6r5)
c     09/22/20   --gy--       Added Mechanism 3 (CB6r5h)
c     03/24/21   --gy--       Added Mechanism 7 (CB7)
c     07/06/21   --gy--       Revised Mechanism 7 for CB7r1
c     09/03/21   --gy--       Added Mechanism 9 (RACM2s21)
c     11/03/23   --cemery--   Removed CB05 (Mech 6)
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer nspc
      real convfac
      real cold(nspc)
      real delcon(5,MXSPEC+1)
      real rrxn_irr(*)
      real destRGN
      real prodRGN
      real NIT2RGN
      real RGN2NIT
      real alphaRGN
      real betaRGN
      real gammaRGN
      real alphaNIT
      real cycNIT
      real alphaNTR
      real betaNTR
      real alphaHN3
      real alphaTPN
      real betaTPN
      real gammaTPN
      real cycTPN
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real FUZZ
      parameter (FUZZ = 10.0)

      real lossPAN,lossPNA,lossPANX,lossPAN2,lossPBZN,lossMPAN,
     &     lossOPAN, lossINTR, lossPPN, lossHNO4
      real prodPAN,prodPNA,prodPANX,prodPAN2,prodPBZN,prodMPAN,
     &     prodOPAN, prodINTR, prodPPN, prodHNO4
      real cycPAN, cycPNA, cycPANX, cycPAN2, cycPBZN, cycMPAN,
     &     cycOPAN, cycINTR, cycPPN, cycHNO4
      real sumRGN, sumTPN
      real delRGN, delNIT, delTPN
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      alphaNTR = 0.0
      betaNTR = 0.0
      alphaTPN = 0.0
      gammaTPN = 0.0
      betaTPN = 0.0
      cycTPN = 0.0
c
c  --- CB6r5h
c
      if( idmech .EQ. 3 ) then

        sumRGN = cold(kno2) + cold(kno3) + 2.*cold(kn2o5) + cold(kino3)
     &           + cold(kbrn3) + cold(kbrn2) + cold(kcln3) + cold(kcln2)
        delRGN = delcon(2,kno2) + delcon(2,kno3) + 2.*delcon(2,kn2o5)
     &           + delcon(2,kino3) + delcon(2,kbrn3) + delcon(2,kbrn2)
     &             + delcon(2,kcln3) + delcon(2,kcln2)
        delNIT = delcon(2,kno) + delcon(2,khono)
        cycNIT = MIN( 0.9999, 1. - EXP(-rrxn_irr(1)/sumRGN) )
        alphaNIT = MAX( 0.0, rrxn_irr(83) )

        if( (cold(kntr1) + cold(kntr2) + cold(kcron)) .GT. FUZZ*convfac*
     &                  (bdnl(kntr1) + bdnl(kntr2) + bdnl(kcron)) ) then
           alphaNTR = rrxn_irr(92)
           betaNTR  = rrxn_irr(207)
        endif

        alphaHN3 = rrxn_irr(46) + rrxn_irr(47)

        if( cold(khno3) .LT. FUZZ*convfac*bdnl(khno3) ) alphaHN3 = 0.0

        gammaRGN = MAX( 0.0, delcon(4,kHNO3) - alphaTPN - betaNTR
     &                                                    + alphaHN3 )
        sumTPN = cold(kpan) + cold(kpanx)
     &           + cold(kopan) + cold(kpna) + cold(kintr)
        delTPN = delcon(2,kpan) + delcon(2,kpanx)
     &           + delcon(2,kopan) + delcon(2,kpna) + delcon(2,kintr)

        if( sumTPN .GT. FUZZ*convfac*(bdnl(kpan) + bdnl(kpanx)
     &                  + bdnl(kopan) + bdnl(kpna) + bdnl(kintr)) ) then
           alphaTPN = rrxn_irr(229)
           gammaTPN = 0.5 * rrxn_irr(205)
           lossPAN = cold(kpan) *
     &         (1. - EXP(-(rrxn_irr(55)+rrxn_irr(56))/cold(kpan)) )
           prodPAN = cold(kno2) * (1. - EXP(-rrxn_irr(54)/cold(kno2)) )
           cycPAN = 0.5 * MIN(lossPAN, prodPAN)

           lossPANX = cold(kpanx) *
     &         (1. - EXP(-(rrxn_irr(63)+rrxn_irr(64)+rrxn_irr(206))
     &                                                   /cold(kpanx)) )
           prodPANX = cold(kno2) * (1. - EXP(-rrxn_irr(62)/cold(kno2)) )
           cycPANX = 0.5 * MIN(lossPANX, prodPANX)

           lossOPAN = cold(kopan) *
     &         (1. - EXP(-(rrxn_irr(201)+rrxn_irr(205))/cold(kopan)) )
           prodOPAN = cold(kno2) * (1. - EXP(-rrxn_irr(200)/cold(kno2)) )
           cycOPAN = 0.5 * MIN(lossOPAN, prodOPAN)

           lossPNA = cold(kpna) *
     &         (1. - EXP(-(rrxn_irr(49)+rrxn_irr(50)+rrxn_irr(51))
     &                                                   /cold(kpna)) )
           prodPNA = cold(kno2) * (1. - EXP(-rrxn_irr(48)/cold(kno2)) )
           cycPNA = 0.5 * MIN(lossPNA, prodPNA)

           lossINTR = cold(kintr) *
     &         (1. - EXP(-0.894*rrxn_irr(163)/cold(kintr)) )
           prodINTR = cold(kno2) * (1. - EXP(-0.1*rrxn_irr(144)/cold(kno2)) )
           cycINTR = 0.5 * AMIN1(lossINTR, prodINTR)

           cycTPN = cycPAN * cold(kpan)/sumTPN +
     &                cycPANX * cold(kpanx)/sumTPN +
     &                  cycOPAN * cold(kopan)/sumTPN +
     &                    cycPNA * cold(kpna)/sumTPN +
     &                      cycINTR * cold(kintr)/sumTPN

        endif

        alphaRGN = MAX( 0.0, delcon(2,kntr1) + delcon(2,kntr2) + delcon(2,kCRON)
     &                                       - alphaNIT - alphaTPN + betaNTR )
c
c  --- CB6r4 and CB6r5
c
      elseif( idmech .EQ. 1 .OR. idmech .EQ. 4 ) then

        sumRGN = cold(kno2) + cold(kno3) + 2.*cold(kn2o5) + cold(kino3)
        delRGN = delcon(2,kno2) + delcon(2,kno3) + 2.*delcon(2,kn2o5)
     &                                                + delcon(2,kino3)
        delNIT = delcon(2,kno) + delcon(2,khono)
        cycNIT = MIN( 0.9999, 1. - EXP(-rrxn_irr(1)/sumRGN) )
        alphaNIT = MAX( 0.0, rrxn_irr(83) )

        if( (cold(kntr1) + cold(kntr2) + cold(kcron)) .GT. FUZZ*convfac*
     &                  (bdnl(kntr1) + bdnl(kntr2) + bdnl(kcron)) ) then
           alphaNTR = rrxn_irr(92)
           betaNTR  = rrxn_irr(207)
        endif

        alphaHN3 = rrxn_irr(46) + rrxn_irr(47)

        if( cold(khno3) .LT. FUZZ*convfac*bdnl(khno3) ) alphaHN3 = 0.0

        gammaRGN = MAX( 0.0, delcon(4,kHNO3) - alphaTPN - betaNTR
     &                                                    + alphaHN3 )
        sumTPN = cold(kpan) + cold(kpanx)
     &           + cold(kopan) + cold(kpna) + cold(kintr)
        delTPN = delcon(2,kpan) + delcon(2,kpanx)
     &           + delcon(2,kopan) + delcon(2,kpna) + delcon(2,kintr)

        if( sumTPN .GT. FUZZ*convfac*(bdnl(kpan) + bdnl(kpanx)
     &                  + bdnl(kopan) + bdnl(kpna) + bdnl(kintr)) ) then
           alphaTPN = rrxn_irr(229)
           gammaTPN = 0.5 * rrxn_irr(205)
           lossPAN = cold(kpan) *
     &         (1. - EXP(-(rrxn_irr(55)+rrxn_irr(56))/cold(kpan)) )
           prodPAN = cold(kno2) * (1. - EXP(-rrxn_irr(54)/cold(kno2)) )
           cycPAN = 0.5 * MIN(lossPAN, prodPAN)

           lossPANX = cold(kpanx) *
     &         (1. - EXP(-(rrxn_irr(63)+rrxn_irr(64)+rrxn_irr(206))
     &                                                   /cold(kpanx)) )
           prodPANX = cold(kno2) * (1. - EXP(-rrxn_irr(62)/cold(kno2)) )
           cycPANX = 0.5 * MIN(lossPANX, prodPANX)

           lossOPAN = cold(kopan) *
     &         (1. - EXP(-(rrxn_irr(201)+rrxn_irr(205))/cold(kopan)) )
           prodOPAN = cold(kno2) * (1. - EXP(-rrxn_irr(200)/cold(kno2)) )
           cycOPAN = 0.5 * MIN(lossOPAN, prodOPAN)

           lossPNA = cold(kpna) *
     &         (1. - EXP(-(rrxn_irr(49)+rrxn_irr(50)+rrxn_irr(51))
     &                                                   /cold(kpna)) )
           prodPNA = cold(kno2) * (1. - EXP(-rrxn_irr(48)/cold(kno2)) )
           cycPNA = 0.5 * MIN(lossPNA, prodPNA)

           lossINTR = cold(kintr) *
     &         (1. - EXP(-0.894*rrxn_irr(163)/cold(kintr)) )
           prodINTR = cold(kno2) * (1. - EXP(-0.1*rrxn_irr(144)/cold(kno2)) )
           cycINTR = 0.5 * AMIN1(lossINTR, prodINTR)

           cycTPN = cycPAN * cold(kpan)/sumTPN +
     &                cycPANX * cold(kpanx)/sumTPN +
     &                  cycOPAN * cold(kopan)/sumTPN +
     &                    cycPNA * cold(kpna)/sumTPN +
     &                      cycINTR * cold(kintr)/sumTPN

        endif

        alphaRGN = MAX( 0.0, delcon(2,kntr1) + delcon(2,kntr2) + delcon(2,kCRON)
     &                                       - alphaNIT - alphaTPN + betaNTR ) 
c
c  --- CB7r2
c
      elseif( idmech .EQ. 7 ) then

        sumRGN = cold(kno2) + cold(kno3) + 2.*cold(kn2o5) + cold(kino3)
        delRGN = delcon(2,kno2) + delcon(2,kno3) + 2.*delcon(2,kn2o5)
     &                                                + delcon(2,kino3)
        delNIT = delcon(2,kno) + delcon(2,khono)
        cycNIT = MIN( 0.9999, 1. - EXP(-rrxn_irr(1)/sumRGN) )
        alphaNIT = MAX( 0.0, rrxn_irr(89) + 0.082*rrxn_irr(149) +
     &                    0.14*rrxn_irr(153) + 0.14*rrxn_irr(157) +
     &                      0.02*rrxn_irr(192) + 0.23*rrxn_irr(197) +
     &                        0.25*rrxn_irr(203) + rrxn_irr(231) + 
     &                          0.4*rrxn_irr(209) + 0.12*rrxn_irr(235) )
        if( (cold(kntr1) + cold(kntr2) + cold(kcron)) .GT. FUZZ*convfac*
     &                  (bdnl(kntr1) + bdnl(kntr2) + bdnl(kcron)) ) then
           alphaNTR = rrxn_irr(94) + rrxn_irr(95) + rrxn_irr(96) + 
     &                  0.45*rrxn_irr(195) + rrxn_irr(174)
           betaNTR  = rrxn_irr(97) + rrxn_irr(173)
        endif

        alphaHN3 = rrxn_irr(43) + rrxn_irr(44)

        if( cold(khno3) .LT. FUZZ*convfac*bdnl(khno3) ) alphaHN3 = 0.0

        gammaRGN = MAX( 0.0, delcon(4,kHNO3) - alphaTPN - betaNTR
     &                                                    + alphaHN3 )
        sumTPN = cold(kpan) + cold(kpanx)
     &           + cold(kopan) + cold(kpna) + cold(kintr)
        delTPN = delcon(2,kpan) + delcon(2,kpanx)
     &           + delcon(2,kopan) + delcon(2,kpna) + delcon(2,kintr)

        if( sumTPN .GT. FUZZ*convfac*(bdnl(kpan) + bdnl(kpanx)
     &                  + bdnl(kopan) + bdnl(kpna) + bdnl(kintr)) ) then
           alphaTPN = 0.0
           gammaTPN = 0.5 * rrxn_irr(72)
           lossPAN = cold(kpan) *
     &         (1. - EXP(-(rrxn_irr(58)+rrxn_irr(59))/cold(kpan)) )
           prodPAN = cold(kno2) * (1. - EXP(-rrxn_irr(57)/cold(kno2)) )
           cycPAN = 0.5 * MIN(lossPAN, prodPAN)

           lossPANX = cold(kpanx) *
     &         (1. - EXP(-(rrxn_irr(65)+rrxn_irr(66))/cold(kpanx)) )
           prodPANX = cold(kno2) * (1. - EXP(-rrxn_irr(64)/cold(kno2)) )
           cycPANX = 0.5 * MIN(lossPANX, prodPANX)

           lossOPAN = cold(kopan) *
     &         (1. - EXP(-(rrxn_irr(71)+0.5*rrxn_irr(72))/cold(kopan)) )
           prodOPAN = cold(kno2) * (1. - EXP(-rrxn_irr(70)/cold(kno2)) )
           cycOPAN = 0.5 * MIN(lossOPAN, prodOPAN)

           lossPNA = cold(kpna) *
     &         (1. - EXP(-(rrxn_irr(46)+rrxn_irr(47)+rrxn_irr(48))
     &                                                   /cold(kpna)) )
           prodPNA = cold(kno2) * (1. - EXP(-rrxn_irr(45)/cold(kno2)) )
           cycPNA = 0.5 * MIN(lossPNA, prodPNA)

           lossINTR = cold(kintr) *
     &         (1. - EXP(-0.9*rrxn_irr(195)/cold(kintr)) )
           prodINTR = cold(kno2) * (1. - EXP(-0.1*rrxn_irr(179)/cold(kno2)) )
           cycINTR = 0.5 * AMIN1(lossINTR, prodINTR)

           cycTPN = cycPAN * cold(kpan)/sumTPN +
     &                cycPANX * cold(kpanx)/sumTPN +
     &                  cycOPAN * cold(kopan)/sumTPN +
     &                    cycPNA * cold(kpna)/sumTPN +
     &                      cycINTR * cold(kintr)/sumTPN

        endif

        alphaRGN = MAX( 0.0, delcon(2,kntr1) + delcon(2,kntr2) + delcon(2,kCRON)
     &                                       - alphaNIT - alphaTPN + betaNTR ) 
c
c  --- SAPRC07T
c
      elseif( idmech .EQ. 5 ) then

        sumRGN = cold(kno2) + cold(kno3) + 2.*cold(kn2o5)
        delRGN = delcon(2,kno2) + delcon(2,kno3) + 2.*delcon(2,kn2o5)
        delNIT = delcon(2,kno) + delcon(2,khono)
        cycNIT = MIN( 0.9999, 1. - EXP(-rrxn_irr(1)/sumRGN) )
        alphaNIT = MAX( 0.0, (
     &              +      rrxn_irr(109)+      rrxn_irr(443)                     ! RNO3
     &              +      rrxn_irr(445)+0.500*rrxn_irr(446)+0.500*rrxn_irr(447)
     &              +0.500*rrxn_irr(448)+      rrxn_irr(449)+      rrxn_irr(450)
     &              +      rrxn_irr(451)+      rrxn_irr(452)
     &              +      rrxn_irr(111)                                         ! NPHE
     &              +      rrxn_irr( 57)+      rrxn_irr(135)+0.500*rrxn_irr(137) ! XN
     &              +0.500*rrxn_irr(138)+0.500*rrxn_irr(139)+      rrxn_irr(240)
     &              +      rrxn_irr(242)+0.500*rrxn_irr(256)+0.278*rrxn_irr(265)
     &              +      rrxn_irr(444)
     &              +0.500*rrxn_irr(446)+0.500*rrxn_irr(447)+0.500*rrxn_irr(448)
     &              +      rrxn_irr(516)+      rrxn_irr(520)
     &              +0.525*rrxn_irr(524)+0.813*rrxn_irr(528)+0.301*rrxn_irr(532)
     &              +0.226*rrxn_irr(550)+0.254*rrxn_irr(554)+0.485*rrxn_irr(560)
     &              +0.485*rrxn_irr(564)
     &                        ) )

        if( (cold(krno3) + cold(kxn)) .GT. FUZZ*convfac*
     &                  (bdnl(krno3) + bdnl(kxn)) ) then
           alphaNTR = 0.019*rrxn_irr(269)+rrxn_irr(270)
           betaNTR  = 0.0
        endif

        alphaHN3 = rrxn_irr(28) + rrxn_irr(27)

        if( cold(khno3) .LT. FUZZ*convfac*bdnl(khno3) ) alphaHN3 = 0.0

        gammaRGN = MAX( 0.0, delcon(4,kHNO3) - alphaTPN - betaNTR
     &                                                    + alphaHN3 )

        sumTPN = cold(kpan) + cold(kpan2)
     &           + cold(kmpan) + cold(kpbzn) + cold(kpna)
        delTPN = delcon(2,kpan) + delcon(2,kpan2)
     &           + delcon(2,kmpan) + delcon(2,kpbzn) + delcon(2,kpna)

        if( sumTPN .GT. FUZZ*convfac*(bdnl(kpan) + bdnl(kpan2)
     &                  + bdnl(kmpan) + bdnl(kpbzn) + bdnl(kpna)) ) then
           alphaTPN = 0.0
           gammaTPN = 0.0
           lossPAN = cold(kpan) *
     &         (1. - EXP(-(rrxn_irr(64)+rrxn_irr(65))/cold(kpan)) )
           prodPAN = cold(kno2) * (1. - EXP(-rrxn_irr(63)/cold(kno2)) )
           cycPAN = 0.5 * MIN(lossPAN, prodPAN)

           lossPAN2 = cold(kpan2) *
     &         (1. - EXP(-(rrxn_irr(74)+rrxn_irr(75)+rrxn_irr(214))
     &                                                   /cold(kpan2)) )
           prodPAN2 = cold(kno2) * (1. - EXP(-rrxn_irr(72)/cold(kno2)) )
           cycPAN2 = 0.5 * MIN(lossPAN2, prodPAN2)

           lossMPAN = cold(kmpan) *
     &         (1. - EXP(-(rrxn_irr(97)+rrxn_irr(98))/cold(kmpan)) )
           prodMPAN = cold(kno2) * (1. - EXP(-rrxn_irr(96)/cold(kno2)) )
           cycMPAN = 0.5 * MIN(lossMPAN, prodMPAN)

           lossPBZN = cold(kpbzn) *
     &         (1. - EXP(-(rrxn_irr(85)+rrxn_irr(86))/cold(kpbzn)) )
           prodPBZN = cold(kno2) * (1. - EXP(-rrxn_irr(84)/cold(kno2)) )
           cycPBZN = 0.5 * MIN(lossPBZN, prodPBZN)

           lossPNA = cold(kpna) *
     &         (1. - EXP(-(rrxn_irr(33)+rrxn_irr(34)+rrxn_irr(35))
     &                                                   /cold(kpna)) )
           prodPNA = cold(kno2) * (1. - EXP(-rrxn_irr(32)/cold(kno2)) )
           cycPNA = 0.5 * AMIN1(lossPNA, prodPNA)

           cycTPN = cycPAN * cold(kpan)/sumTPN +
     &                cycPAN2 * cold(kpan2)/sumTPN +
     &                  cycMPAN * cold(kmpan)/sumTPN +
     &                    cycPBZN * cold(kpbzn)/sumTPN +
     &                      cycPNA * cold(kpna)/sumTPN

        endif

        alphaRGN = MAX( 0.0, delcon(2,krno3) + delcon(2,kxn) + delcon(2,knphe)
     &                                       - alphaNIT - alphaTPN + betaNTR ) 
c
c  --- RACM2s21
c
      elseif( idmech .EQ. 9 ) then

        sumRGN = cold(kno2) + cold(kno3) + 2.*cold(kn2o5)
        delRGN = delcon(2,kno2) + delcon(2,kno3) + 2.*delcon(2,kn2o5)
        delNIT = delcon(2,kno) + delcon(2,khono)
        cycNIT = MIN( 0.9999, 1. - EXP(-rrxn_irr(1)/sumRGN) )
        alphaNIT = MAX( 0.0, rrxn_irr(209) + rrxn_irr(210) +
     &                              0.12*rrxn_irr(128) + rrxn_irr(211) )

        if( (cold(konit) + cold(kison) + cold(knald)) .GT. FUZZ*convfac*
     &                  (bdnl(konit) + bdnl(kison) + bdnl(knald)) ) then
           alphaNTR = rrxn_irr(31) + rrxn_irr(123)
           betaNTR  = 0.0
        endif

        alphaHN3 = rrxn_irr(8) + rrxn_irr(57)

        if( cold(khno3) .LT. FUZZ*convfac*bdnl(khno3) ) alphaHN3 = 0.0

        gammaRGN = MAX( 0.0, delcon(4,kHNO3) - alphaTPN - betaNTR
     &                                                    + alphaHN3 )
        sumTPN = cold(kpan) + cold(kppn)
     &                   + cold(kmpan) + cold(khno4)
        delTPN = delcon(2,kpan) + delcon(2,kppn)
     &                   + delcon(2,kmpan) + delcon(2,khno4)

        if( sumTPN .GT. FUZZ*convfac*(bdnl(kpan) + bdnl(kppn)
     &                          + bdnl(kmpan) + bdnl(khno4) ) ) then
           alphaTPN = 0.0
           gammaTPN = 0.0
           lossPAN = cold(kpan) *
     &         (1. - EXP(-(rrxn_irr(32)+rrxn_irr(33)+
     &                        rrxn_irr(120)+rrxn_irr(167))/cold(kpan)) )
           prodPAN = cold(kno2) * (1. - EXP(-rrxn_irr(166)/cold(kno2)) )
           cycPAN = 0.5 * MIN(lossPAN, prodPAN)

           lossPPN = cold(kppn) *
     &            (1. - EXP(-(rrxn_irr(121)+rrxn_irr(169))/cold(kppn)) )
           prodPPN = cold(kno2) * (1. - EXP(-rrxn_irr(168)/cold(kno2)) )
           cycPPN = 0.5 * MIN(lossPPN, prodPPN)

           lossMPAN = cold(kmpan) *
     &         (1. - EXP(-(rrxn_irr(122)+
     &                       rrxn_irr(159)+rrxn_irr(171))/cold(kmpan)) )
           prodMPAN = cold(kno2) * (1. - EXP(-rrxn_irr(170)/cold(kno2)))
           cycMPAN = 0.5 * MIN(lossMPAN, prodMPAN)

           lossHNO4 = cold(kpna) *
     &         (1. - EXP(-(rrxn_irr(9)+rrxn_irr(67)+rrxn_irr(68))
     &                                                    /cold(kpna)) )
           prodHNO4 = cold(kno2) * (1. - EXP(-rrxn_irr(66)/cold(kno2)) )
           cycHNO4 = 0.5 * MIN(lossHNO4, prodHNO4)

           cycTPN = cycPAN * cold(kpan)/sumTPN +
     &                cycPPN * cold(kppn)/sumTPN +
     &                  cycMPAN * cold(kmpan)/sumTPN +
     &                    cycHNO4 * cold(khno4)/sumTPN 

        endif

        alphaRGN = MAX( 0.0, delcon(2,konit) + delcon(2,kison) +
     &                            delcon(2,knald)
     &                                 - alphaNIT - alphaTPN + betaNTR )
c
c  ---- stop if the mechanism is undefined -----
c
      else
         write(iout,'(//,a)') 'ERROR in CYCTPNSA:'
         write(iout,'(/,1X,A,I10)')
     &              'Unknown chemical mechanism ID number: ',idmech
         write(iout,'(/,1X,2A)')
     &              'Ozone source apportionment is not available ',
     &              'for this chemical mechanism'
         call camxerr()
      endif

c
c   --- set output variables that share definitions ---
c
      destRGN = MAX( 0., -delRGN )
      prodRGN = MAX( 0.,  delRGN )

      NIT2RGN = MAX( 0., -(delNIT + alphaNIT) )
      RGN2NIT = MAX( 0., delNIT + alphaNIT )

      betaTPN = MAX( 0., -delTPN )
      betaRGN = MAX( 0.,  delTPN )

      cycTPN  = MAX( 0., MIN( cycTPN,
     &                    0.33*(sumRGN-alphaRGN-betaRGN-gammaRGN),
     &                      0.33*(sumTPN-alphaTPN-betaTPN-gammaTPN) ) )

      betaTPN = betaTPN + cycTPN
      betaRGN = betaRGN + cycTPN
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine vnmshcal(igrd,ncol,nrow,nlay,i1,j1,ncolf,nrowf,nlayf,
     &                    height,heightf)
      use filunit
c
c----CAMx v7.40 260801
c
c     VNMSHCAL compares the vertical mesh between the coarse grid and
c     the target fine grid to ensure each layer interface matches to
c     within 5%.
c
c      Copyright Ramboll
c 
c     Modifications:  
c        1/28/99   Changed check on fine/coarse layer interface matching
c                  from absolute (0.1 m) to relative (5%)
c       11/05/12   Removed vertical nesting
c  
c     Input arguments:  
c        igrd                grid number of fine grid
c        ncol                number of columns in coarse grid
c        nrow                number of rows in coarse grid
c        nlay                number of layers on coarse grid
c        i1                  starting i index for the fine grid 
c        j1                  starting j index for the fine grid 
c        ncolf               number of columns in fine grid
c        nrowf               number of rows in fine grid
c        nlayf               number of layers on fine grid
c        height              layer interface height on coarse grid(m)
c        heightf             layer interface height on fine grid(m)
c             
c     Output arguments:  
c        none
c
c     Routines called:
c        none
c
c     Called by:
c        STARTUP 
c
      implicit none
      include "camx.prm"
c
      integer igrd,ncol,nrow,nlay,i1,j1,ncolf,nrowf,nlayf
      real    height(ncol,nrow,nlay)
      real    heightf(ncolf,nrowf,nlayf)
c
      integer k,kp
      real dht(MXLAYER)
c
c------Entry point
c
      do kp = 1,nlay
        dht(kp) = abs(heightf(2,2,kp) - height(i1,j1,kp))/
     &            height(i1,j1,kp)
      enddo
c
      do kp = 1,nlay
        if (dht(kp).gt.0.05) then
          write(iout,'(//,a)') 'ERROR in VNMSHCAL:'
          write(iout,*) 'Inconsistent vertical grid structure!'
          write(iout,'(a,i2)') '    Grid 1    Grid ',igrd 
          do k = 1,nlay
            write(iout,'(e10.1)') height(i1,j1,k), height(2,2,k)
          enddo
          call camxerr()
        endif
      enddo
c
      return
      end

c**** SPCCB6r5hSA
c
      subroutine spccb6r5hsa(namecls,numcls,coefcon,coeflux,
     &                      nameyld,numyld,yieldH,yieldL,molwt)
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine initializes the species variables that will be used
c   to determine the species that will be included in each tracer
c   species class
c    Argument descriptions:
c     Input:  
c     Output:  
c       namecls   C  array of regular model species in each tracer class
c       numcls    I  the number of species contributing to this class
c       coefcon   R  2-D array of coefficients for making linear combo
c                   this one for concentrations and emissions
c       coeflux   R  2-D array of coefficients for making linear combo
c                   this one for fluxes
c       nameyld   C  array of regular model species for the yields of
c                   each tracer class
c       numyld    I  number of regular model species for the yields of
c                   each tracer class
c       yieldH    R  high-NOx yield rates for each species in each class
c       yieldL    R  low-NOx yield rates for each species in each class
c       molwt    R  molecular weight of model species
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     09/22/22   --gy--         Created based on spccb6r4sa.f
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*10 namecls(MXALCLS,MXSPEC)
      integer      numcls(MXALCLS)
      real         coefcon(MXALCLS,MXSPEC)
      real         coeflux(MXALCLS,MXSPEC)
      character*10 nameyld(MXALCLS,MXSPEC)
      integer      numyld(MXALCLS)
      real         yieldH(MXALCLS,MXSPEC),yieldL(MXALCLS,MXSPEC)
      real         molwt(MXSPEC)
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c   NUMCB6r5h     I  number of CB6r5h species used by PSAT treatment
c
      integer NUMCB6r5h
c
      parameter( NUMCB6r5h= 68 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 cb6r5hnam(NUMCB6r5h)
      integer*4    i, j
      real         wtcb6r5h(NUMCB6r5h)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data cb6r5hnam /
     &         'NO        ', 'NO2       ', 'PAR       ', 'ETHA      ',
     &         'MEOH      ', 'ETOH      ', 'ETH       ', 'OLE       ',
     &         'IOLE      ', 'ISOP      ', 'TERP      ', 'FORM      ',
     &         'ALD2      ', 'ALDX      ', 'TOL       ', 'XYL       ',
     &         'ACET      ', 'BENZ      ', 'ETHY      ', 'KET       ',
     &         'PRPA      ', 'SO2       ', 'HONO      ', 'NO3       ',
     &         'N2O5      ', 'PAN       ', 'PANX      ', 'PNA       ',
     &         'NTR1      ', 'NTR2      ', 'HNO3      ', 'CRON      ',
     &         'INTR      ', 'OPAN      ', 'INO3      ', 'NH3       ',
     &         'IVOA      ', 'SVOA      ', 'SQT       ', 'ACG2      ',
     &         'ACG1      ', 'BCG2      ', 'BCG1      ', 'HG0       ',
     &         'HG2       ', 'PSO4      ', 'PNO3      ', 'PNH4      ',
     &         'PEC       ', 'HOA       ', 'FCRS      ', 'FPRM      ',
     &         'CCRS      ', 'CPRM      ', 'AOA2      ', 'AOA1      ',
     &         'BOA2      ', 'BOA1      ', 'AOA0      ', 'BOA0      ',
     &         'HGP       ', 'DMS       ', 'BRN3      ', 'BRN2      ',
     &         'CLN3      ', 'CLN2      ', 'IVC1      ', 'IVC2      '/

      data wtcb6r5h /
     &          46.0       ,  46.0       ,  14.43      ,  30.07,
     &          32.04      ,  46.07      ,  28.05      ,  27.65,
     &          56.11      ,  68.12      , 136.23      ,  30.03,
     &          44.05      ,  43.65      ,  92.14      , 106.17,
     &          58.08      ,  78.11      ,  26.04      ,  28.82,
     &          44.10      ,  64.0       ,  46.0       ,  62.0,
     &         108.0       , 121.0       , 135.0       ,  79.0,
     &         119.1       , 135.1       ,  63.0       , 153.1,
     &         147.1       , 161.0       , 188.9       ,  17.0,
     &         212.0       , 212.0       , 204.0       , 150.0,
     &         150.0       , 180.0       , 180.0       , 200.6,
     &         200.6       ,   1.0       ,   1.0       ,   1.0,
     &           1.0       ,   1.0       ,   1.0       ,   1.0,
     &           1.0       ,   1.0       ,   1.0       ,   1.0,
     &           1.0       ,   1.0       ,   1.0       ,   1.0,
     &           1.0       ,  62.1       , 141.9       , 125.9,
     &          97.5       ,  81.5       , 212.0       , 212.0/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  ---- initialize all arrays ---
c
      do i=1,MXALCLS
        numcls(i) = 0
        numyld(i) = 0
        do j=1,MXSPEC
          namecls(i,j) = ' '
          nameyld(i,j) = ' '
          coefcon(i,j) = 0.0
          coeflux(i,j) = 0.0
          yieldH(i,j) = 0.0
          yieldL(i,j) = 0.0
        enddo
      enddo
c
c  --- set the molecular weight for each modeled species ---
c
      do i=1,nspec
        molwt(i) = 1.0
        do j=1,NUMCB6r5h
           if( spname(i) .EQ. cb6r5hnam(j) ) molwt(i) = wtcb6r5h(j)
        enddo
      enddo
c
c   --- if doing the OZONE or NITRATE species ---
c
      if( lozone .OR. lnitrate ) then
c
c  ---- NIT species ---
c
         numcls(ITRNIT) = 2
         namecls(ITRNIT,1) = 'NO'
         coefcon(ITRNIT,1) = 1.0
         coeflux(ITRNIT,1) = 1.0
         namecls(ITRNIT,2) = 'HONO'
         coefcon(ITRNIT,2) = 1.0
         coeflux(ITRNIT,2) = 1.0
c
c  ---- RGN species ---
c
         numcls(ITRRGN) = 8
         namecls(ITRRGN,1) = 'NO2'
         coefcon(ITRRGN,1) = 1.0
         coeflux(ITRRGN,1) = 1.0
         namecls(ITRRGN,2) = 'NO3'
         coefcon(ITRRGN,2) = 1.0
         coeflux(ITRRGN,2) = 1.0
         namecls(ITRRGN,3) = 'N2O5'
         coefcon(ITRRGN,3) = 2.0
         coeflux(ITRRGN,3) = 2.0
         namecls(ITRRGN,4) = 'INO3'
         coefcon(ITRRGN,4) = 1.0
         coeflux(ITRRGN,4) = 1.0
         namecls(ITRRGN,5) = 'BRN3'
         coefcon(ITRRGN,5) = 1.0
         coeflux(ITRRGN,5) = 1.0
         namecls(ITRRGN,6) = 'CLN3'
         coefcon(ITRRGN,6) = 1.0
         coeflux(ITRRGN,6) = 1.0
         namecls(ITRRGN,7) = 'BRN2'
         coefcon(ITRRGN,7) = 1.0
         coeflux(ITRRGN,7) = 1.0
         namecls(ITRRGN,8) = 'CLN2'
         coefcon(ITRRGN,8) = 1.0
         coeflux(ITRRGN,8) = 1.0
c
c  ---- TPN species ---
c
         numcls(ITRTPN) = 5
         namecls(ITRTPN,1) = 'PAN'
         coefcon(ITRTPN,1) = 1.0
         coeflux(ITRTPN,1) = 1.0
         namecls(ITRTPN,2) = 'PANX'
         coefcon(ITRTPN,2) = 1.0
         coeflux(ITRTPN,2) = 1.0
         namecls(ITRTPN,3) = 'PNA'
         coefcon(ITRTPN,3) = 1.0
         coeflux(ITRTPN,3) = 1.0
         namecls(ITRTPN,4) = 'OPAN'
         coefcon(ITRTPN,4) = 1.0
         coeflux(ITRTPN,4) = 1.0
         namecls(ITRTPN,5) = 'INTR'
         coefcon(ITRTPN,5) = 1.0
         coeflux(ITRTPN,5) = 1.0
c
c  ---- NTR species ---
c
         numcls(ITRNTR) = 3
         namecls(ITRNTR,1) = 'NTR1'
         coefcon(ITRNTR,1) = 1.0
         coeflux(ITRNTR,1) = 1.0
         namecls(ITRNTR,2) = 'NTR2'
         coefcon(ITRNTR,2) = 1.0
         coeflux(ITRNTR,2) = 1.0
         namecls(ITRNTR,3) = 'CRON'
         coefcon(ITRNTR,3) = 1.0
         coeflux(ITRNTR,3) = 1.0
c
c  ---- HN3 species ---
c
         numcls(ITRHN3) = 1
         namecls(ITRHN3,1) = 'HNO3'
         coefcon(ITRHN3,1) = 1.0
         coeflux(ITRHN3,1) = 1.0
      endif
c
c   --- if doing the OZONE species ---
c
      if( lozone ) then
c
c  ---- VOC species ---
c
         numcls(ITRVOC) = 19
         namecls(ITRVOC,1) = 'PAR'
         coefcon(ITRVOC,1) = 1.0
         coeflux(ITRVOC,1) = 1.0
         namecls(ITRVOC,2) = 'ETHA'
         coefcon(ITRVOC,2) = 2.0
         coeflux(ITRVOC,2) = 2.0
         namecls(ITRVOC,3) = 'MEOH'
         coefcon(ITRVOC,3) = 1.0
         coeflux(ITRVOC,3) = 1.0
         namecls(ITRVOC,4) = 'ETOH'
         coefcon(ITRVOC,4) = 2.0
         coeflux(ITRVOC,4) = 2.0
         namecls(ITRVOC,5) = 'ETH'
         coefcon(ITRVOC,5) = 2.0
         coeflux(ITRVOC,5) = 2.0
         namecls(ITRVOC,6) = 'OLE'
         coefcon(ITRVOC,6) = 2.0
         coeflux(ITRVOC,6) = 2.0
         namecls(ITRVOC,7) = 'IOLE'
         coefcon(ITRVOC,7) = 4.0
         coeflux(ITRVOC,7) = 4.0
         namecls(ITRVOC,8) = 'ISOP'
         coefcon(ITRVOC,8) = 5.0
         coeflux(ITRVOC,8) = 5.0
         namecls(ITRVOC,9) = 'TERP'
         coefcon(ITRVOC,9) = 10.0
         coeflux(ITRVOC,9) = 10.0
         namecls(ITRVOC,10) = 'FORM'
         coefcon(ITRVOC,10) = 1.0
         coeflux(ITRVOC,10) = 1.0
         namecls(ITRVOC,11) = 'ALD2'
         coefcon(ITRVOC,11) = 2.0
         coeflux(ITRVOC,11) = 2.0
         namecls(ITRVOC,12) = 'ALDX'
         coefcon(ITRVOC,12) = 2.0
         coeflux(ITRVOC,12) = 2.0
         namecls(ITRVOC,13) = 'TOL'
         coefcon(ITRVOC,13) = 7.0
         coeflux(ITRVOC,13) = 7.0
         namecls(ITRVOC,14) = 'XYL'
         coefcon(ITRVOC,14) = 8.0
         coeflux(ITRVOC,14) = 8.0
         namecls(ITRVOC,15) = 'PRPA'
         coefcon(ITRVOC,15) = 3.0
         coeflux(ITRVOC,15) = 3.0
         namecls(ITRVOC,16) = 'BENZ'
         coefcon(ITRVOC,16) = 6.0
         coeflux(ITRVOC,16) = 6.0
         namecls(ITRVOC,17) = 'ETHY'
         coefcon(ITRVOC,17) = 2.0
         coeflux(ITRVOC,17) = 2.0
         namecls(ITRVOC,18) = 'ACET'
         coefcon(ITRVOC,18) = 3.0
         coeflux(ITRVOC,18) = 3.0
         namecls(ITRVOC,19) = 'KET'
         coefcon(ITRVOC,19) = 1.0
         coeflux(ITRVOC,19) = 1.0
c
c  ---- O3-NOx species ---
c
         numcls(ITRO3N) = 1
         namecls(ITRO3N,1) = 'O3'
         coefcon(ITRO3N,1) = 0.5
         coeflux(ITRO3N,1) = 1.0
c
c  ---- O3-VOC species ---
c
         numcls(ITRO3V) = 1
         namecls(ITRO3V,1) = 'O3'
         coefcon(ITRO3V,1) = 0.5
         coeflux(ITRO3V,1) = 1.0
c
c  ---- Odd-oxygen in RGN from O3N ---
c
         numcls(ITROON) = 8
         namecls(ITROON,1) = 'NO2'
         coefcon(ITROON,1) = 0.5
         coeflux(ITROON,1) = 1.0
         namecls(ITROON,2) = 'NO3'
         coefcon(ITROON,2) = 0.5
         coeflux(ITROON,2) = 1.0
         namecls(ITROON,3) = 'N2O5'
         coefcon(ITROON,3) = 1.0
         coeflux(ITROON,3) = 2.0
         namecls(ITROON,4) = 'INO3'
         coefcon(ITROON,4) = 0.5
         coeflux(ITROON,4) = 1.0
         namecls(ITROON,5) = 'BRN3'
         coefcon(ITROON,5) = 0.5
         coeflux(ITROON,5) = 1.0
         namecls(ITROON,6) = 'CLN3'
         coefcon(ITROON,6) = 0.5
         coeflux(ITROON,6) = 1.0
         namecls(ITROON,7) = 'BRN2'
         coefcon(ITROON,7) = 0.5
         coeflux(ITROON,7) = 1.0
         namecls(ITROON,8) = 'CLN2'
         coefcon(ITROON,8) = 0.5
         coeflux(ITROON,8) = 1.0
c
c  ---- Odd-oxygen in RGN from O3V ---
c
         numcls(ITROOV) = 8
         namecls(ITROOV,1) = 'NO2'
         coefcon(ITROOV,1) = 0.5
         coeflux(ITROOV,1) = 1.0
         namecls(ITROOV,2) = 'NO3'
         coefcon(ITROOV,2) = 0.5
         coeflux(ITROOV,2) = 1.0
         namecls(ITROOV,3) = 'N2O5'
         coefcon(ITROOV,3) = 1.0
         coeflux(ITROOV,3) = 2.0
         namecls(ITROOV,4) = 'INO3'
         coefcon(ITROOV,4) = 0.5
         coeflux(ITROOV,4) = 1.0
         namecls(ITROOV,5) = 'BRN3'
         coefcon(ITROOV,5) = 0.5
         coeflux(ITROOV,5) = 1.0
         namecls(ITROOV,6) = 'CLN3'
         coefcon(ITROOV,6) = 0.5
         coeflux(ITROOV,6) = 1.0
         namecls(ITROOV,7) = 'BRN2'
         coefcon(ITROOV,7) = 0.5
         coeflux(ITROOV,7) = 1.0
         namecls(ITROOV,8) = 'CLN2'
         coefcon(ITROOV,8) = 0.5
         coeflux(ITROOV,8) = 1.0
      endif
c
c   --- if doing the SULFATE species ---
c
      if( lsulfate ) then
c
c  ---- SO2 species ---
c
        numcls(ITRSO2) = 1
        namecls(ITRSO2,1) = 'SO2'
        coefcon(ITRSO2,1) = 1.0
        coeflux(ITRSO2,1) = 1.0
c
c  ---- PS4 species ---
c
        numcls(ITRPS4) = 1
        namecls(ITRPS4,1) = 'PSO4'
        coefcon(ITRPS4,1) = 1.0
        coeflux(ITRPS4,1) = 1.0
c
c  ---- DMS species ---
c
        if( ldmschm ) then
          numcls(ITRDMS) = 1
          namecls(ITRDMS,1) = 'DMS'
          coefcon(ITRDMS,1) = 1.0
          coeflux(ITRDMS,1) = 1.0
        endif
      endif
c
c   --- if doing the NITRATE species ---
c
      if( lnitrate ) then
c
c  ---- NIT species ---
c
c         defined above
c
c  ---- RGN species ---
c
c         defined above
c
c  ---- TPN species ---
c
c         defined above
c
c  ---- NTR species ---
c
c         defined above
c
c  ---- HN3 species ---
c
c         defined above
c
c  ---- PN3 species ---
c
          numcls(ITRPN3) = 1
          namecls(ITRPN3,1) = 'PNO3'
          coefcon(ITRPN3,1) = 1.0
          coeflux(ITRPN3,1) = 1.0
c
c  ---- NH3 species ---
c
          numcls(ITRNH3) = 1
          namecls(ITRNH3,1) = 'NH3'
          coefcon(ITRNH3,1) = 1.0
          coeflux(ITRNH3,1) = 1.0
c
c  ---- PN4 species ---
c
          numcls(ITRPN4) = 1
          namecls(ITRPN4,1) = 'PNH4'
          coefcon(ITRPN4,1) = 1.0
          coeflux(ITRPN4,1) = 1.0
      endif
c
c   --- if doing the SOA species ---
c
      if( lsoa ) then
c
c  ---- ARO species ---
c
          numcls(ITRARO) = 3
          namecls(ITRARO,1) = 'BENZ'
          coefcon(ITRARO,1) = 1.0
          coeflux(ITRARO,1) = 1.0
          namecls(ITRARO,2) = 'TOL'
          coefcon(ITRARO,2) = 1.0
          coeflux(ITRARO,2) = 1.0
          namecls(ITRARO,3) = 'XYL'
          coefcon(ITRARO,3) = 1.0
          coeflux(ITRARO,3) = 1.0
c
c  ---- ISP species ---
c
          numcls(ITRISP) = 1
          namecls(ITRISP,1) = 'ISOP'
          coefcon(ITRISP,1) = 1.0
          coeflux(ITRISP,1) = 1.0
c
c  ---- TRP species ---
c
          numcls(ITRTRP) = 1
          namecls(ITRTRP,1) = 'TERP'
          coefcon(ITRTRP,1) = 1.0
          coeflux(ITRTRP,1) = 1.0
c
c  ---- APN species ---
c
          numcls(ITRAPN) = 1
          namecls(ITRAPN,1) = 'APIN'
          coefcon(ITRAPN,1) = 1.0
          coeflux(ITRAPN,1) = 1.0
c
c  ---- SQT species ---
c
          numcls(ITRSQT) = 1
          namecls(ITRSQT,1) = 'SQT'
          coefcon(ITRSQT,1) = 1.0
          coeflux(ITRSQT,1) = 1.0
c
c  ---- AG2 species ---
c
          numcls(ITRAG2) = 1
          namecls(ITRAG2,1) = 'ACG2'
          coefcon(ITRAG2,1) = 1.0
          coeflux(ITRAG2,1) = 1.0
          numyld(ITRAG2) = 7
          nameyld(ITRAG2,1) = 'BENZ'
          yieldH(ITRAG2,1) = MAX(EPSYLD, y_h(1,ISOAP_BNZA))
          yieldL(ITRAG2,1) = MAX(EPSYLD, y_l(1,ISOAP_BNZA))
          nameyld(ITRAG2,2) = 'TOL'
          yieldH(ITRAG2,2) = MAX(EPSYLD, y_h(1,ISOAP_TOLA))
          yieldL(ITRAG2,2) = MAX(EPSYLD, y_l(1,ISOAP_TOLA))
          nameyld(ITRAG2,3) = 'XYL'
          yieldH(ITRAG2,3) = MAX(EPSYLD, y_h(1,ISOAP_XYLA))
          yieldL(ITRAG2,3) = MAX(EPSYLD, y_l(1,ISOAP_XYLA))
          nameyld(ITRAG2,4) = 'IVOA'
          yieldH(ITRAG2,4) = MAX(EPSYLD, y_h(1,ISOAP_IVOA))
          yieldL(ITRAG2,4) = MAX(EPSYLD, y_l(1,ISOAP_IVOA))
          nameyld(ITRAG2,5) = 'IVC1'
          yieldH(ITRAG2,5) = MAX(EPSYLD, y_h(1,ISOAP_IVC1))
          yieldL(ITRAG2,5) = MAX(EPSYLD, y_l(1,ISOAP_IVC1))
          nameyld(ITRAG2,6) = 'IVC2'
          yieldH(ITRAG2,6) = MAX(EPSYLD, y_h(1,ISOAP_IVC2))
          yieldL(ITRAG2,6) = MAX(EPSYLD, y_l(1,ISOAP_IVC2))
          nameyld(ITRAG2,7) = 'SVOA'
          yieldH(ITRAG2,7) = MAX(EPSYLD, y_h(1,ISOAP_SVOA))
          yieldL(ITRAG2,7) = MAX(EPSYLD, y_l(1,ISOAP_SVOA))
c
c  ---- AG1 species ---
c
          numcls(ITRAG1) = 1
          namecls(ITRAG1,1) = 'ACG1'
          coefcon(ITRAG1,1) = 1.0
          coeflux(ITRAG1,1) = 1.0
          numyld(ITRAG1) = 7
          nameyld(ITRAG1,1) = 'BENZ'
          yieldH(ITRAG1,1) = MAX(EPSYLD, y_h(2,ISOAP_BNZA))
          yieldL(ITRAG1,1) = MAX(EPSYLD, y_l(2,ISOAP_BNZA))
          nameyld(ITRAG1,2) = 'TOL'
          yieldH(ITRAG1,2) = MAX(EPSYLD, y_h(2,ISOAP_TOLA))
          yieldL(ITRAG1,2) = MAX(EPSYLD, y_l(2,ISOAP_TOLA))
          nameyld(ITRAG1,3) = 'XYL'
          yieldH(ITRAG1,3) = MAX(EPSYLD, y_h(2,ISOAP_XYLA))
          yieldL(ITRAG1,3) = MAX(EPSYLD, y_l(2,ISOAP_XYLA))
          nameyld(ITRAG1,4) = 'IVOA'
          yieldH(ITRAG1,4) = MAX(EPSYLD, y_h(2,ISOAP_IVOA))
          yieldL(ITRAG1,4) = MAX(EPSYLD, y_l(2,ISOAP_IVOA))
          nameyld(ITRAG1,5) = 'IVC1'
          yieldH(ITRAG1,5) = MAX(EPSYLD, y_h(2,ISOAP_IVC1))
          yieldL(ITRAG1,5) = MAX(EPSYLD, y_l(2,ISOAP_IVC1))
          nameyld(ITRAG1,6) = 'IVC2'
          yieldH(ITRAG1,6) = MAX(EPSYLD, y_h(2,ISOAP_IVC2))
          yieldL(ITRAG1,6) = MAX(EPSYLD, y_l(2,ISOAP_IVC2))
          nameyld(ITRAG1,7) = 'SVOA'
          yieldH(ITRAG1,7) = MAX(EPSYLD, y_h(2,ISOAP_SVOA))
          yieldL(ITRAG1,7) = MAX(EPSYLD, y_l(2,ISOAP_SVOA))
c
c  ---- BG2 species ---
c
          numcls(ITRBG2) = 1
          namecls(ITRBG2,1) = 'BCG2'
          coefcon(ITRBG2,1) = 1.0
          coeflux(ITRBG2,1) = 1.0
c
c  ---- BG1 species ---
c
          numcls(ITRBG1) = 1
          namecls(ITRBG1,1) = 'BCG1'
          coefcon(ITRBG1,1) = 1.0
          coeflux(ITRBG1,1) = 1.0
c
c  ---- PA2 species ---
c
          numcls(ITRPA2) = 1
          namecls(ITRPA2,1) = 'AOA2'
          coefcon(ITRPA2,1) = 1.0
          coeflux(ITRPA2,1) = 1.0
c
c  ---- PA1 species ---
c
          numcls(ITRPA1) = 1
          namecls(ITRPA1,1) = 'AOA1'
          coefcon(ITRPA1,1) = 1.0
          coeflux(ITRPA1,1) = 1.0
c
c  ---- PB2 species ---
c
          numcls(ITRPB2) = 1
          namecls(ITRPB2,1) = 'BOA2'
          coefcon(ITRPB2,1) = 1.0
          coeflux(ITRPB2,1) = 1.0
c
c  ---- PB1 species ---
c
          numcls(ITRPB1) = 1
          namecls(ITRPB1,1) = 'BOA1'
          coefcon(ITRPB1,1) = 1.0
          coeflux(ITRPB1,1) = 1.0
c
c  ---- PA0 species ---
c
          numcls(ITRPA0) = 1
          namecls(ITRPA0,1) = 'AOA0'
          coefcon(ITRPA0,1) = 1.0
          coeflux(ITRPA0,1) = 1.0
          ! SPECIAL CASE: non-volatile CG; ARO -> AOA0 directly (skip CG)
          numyld(ITRPA0) = 7
          nameyld(ITRPA0,1) = 'BENZ'
          yieldH(ITRPA0,1) = MAX(EPSYLD, y_h(3,ISOAP_BNZA))
          yieldL(ITRPA0,1) = MAX(EPSYLD, y_l(3,ISOAP_BNZA))
          nameyld(ITRPA0,2) = 'TOL'
          yieldH(ITRPA0,2) = MAX(EPSYLD, y_h(3,ISOAP_TOLA))
          yieldL(ITRPA0,2) = MAX(EPSYLD, y_l(3,ISOAP_TOLA))
          nameyld(ITRPA0,3) = 'XYL'
          yieldH(ITRPA0,3) = MAX(EPSYLD, y_h(3,ISOAP_XYLA))
          yieldL(ITRPA0,3) = MAX(EPSYLD, y_l(3,ISOAP_XYLA))
          nameyld(ITRPA0,4) = 'IVOA'
          yieldH(ITRPA0,4) = MAX(EPSYLD, y_h(3,ISOAP_IVOA))
          yieldL(ITRPA0,4) = MAX(EPSYLD, y_l(3,ISOAP_IVOA))
          nameyld(ITRPA0,5) = 'IVC1'
          yieldH(ITRPA0,5) = MAX(EPSYLD, y_h(3,ISOAP_IVC1))
          yieldL(ITRPA0,5) = MAX(EPSYLD, y_l(3,ISOAP_IVC1))
          nameyld(ITRPA0,6) = 'IVC1'
          yieldH(ITRPA0,6) = MAX(EPSYLD, y_h(3,ISOAP_IVC2))
          yieldL(ITRPA0,6) = MAX(EPSYLD, y_l(3,ISOAP_IVC2))
          nameyld(ITRPA0,7) = 'SVOA'
          yieldH(ITRPA0,7) = MAX(EPSYLD, y_h(3,ISOAP_SVOA))
          yieldL(ITRPA0,7) = MAX(EPSYLD, y_l(3,ISOAP_SVOA))
c
c  ---- PB0 species ---
c
          numcls(ITRPB0) = 1
          namecls(ITRPB0,1) = 'BOA0'
          coefcon(ITRPB0,1) = 1.0
          coeflux(ITRPB0,1) = 1.0
c
c  ---- IVA species ---
c
          numcls(ITRIVA) = 3
          namecls(ITRIVA,1) = 'IVOA'
          coefcon(ITRIVA,1) = 1.0
          coeflux(ITRIVA,1) = 1.0
          namecls(ITRIVA,2) = 'IVC1'
          coefcon(ITRIVA,2) = 1.0
          coeflux(ITRIVA,2) = 1.0
          namecls(ITRIVA,3) = 'IVC1'
          coefcon(ITRIVA,3) = 1.0
          coeflux(ITRIVA,3) = 1.0
c
c  ---- SVA species ---
c
          numcls(ITRSVA) = 1
          namecls(ITRSVA,1) = 'SVOA'
          coefcon(ITRSVA,1) = 1.0
          coeflux(ITRSVA,1) = 1.0
c
c  ---- HOA species ---
c
          numcls(ITRHOA) = 1
          namecls(ITRHOA,1) = 'HOA'
          coefcon(ITRHOA,1) = 1.0
          coeflux(ITRHOA,1) = 1.0
      endif
c
c  --- if doing the PRIMARY species ---
c
      if( lprimary ) then
c
c  ---- PEC species ---
c
          numcls(ITRPEC) = 1
          namecls(ITRPEC,1) = 'PEC'
          coefcon(ITRPEC,1) = 1.0
          coeflux(ITRPEC,1) = 1.0
c
c  ---- PFC species ---
c
          numcls(ITRPFC) = 1
          namecls(ITRPFC,1) = 'FCRS'
          coefcon(ITRPFC,1) = 1.0
          coeflux(ITRPFC,1) = 1.0
c
c  ---- PFN species ---
c
          numcls(ITRPFN) = 1
          namecls(ITRPFN,1) = 'FPRM'
          coeflux(ITRPFN,1) = 1.0
          coefcon(ITRPFN,1) = 1.0
c
c  ---- PCC species ---
c
          numcls(ITRPCC) = 1
          namecls(ITRPCC,1) = 'CCRS'
          coefcon(ITRPCC,1) = 1.0
          coeflux(ITRPCC,1) = 1.0
c
c  ---- PCS species ---
c
          numcls(ITRPCS) = 1
          namecls(ITRPCS,1) = 'CPRM'
          coefcon(ITRPCS,1) = 1.0
          coeflux(ITRPCS,1) = 1.0

          if( lmineral ) then
c
c  ---- PFE species ---
c
              numcls(ITRPFE) = 1
              namecls(ITRPFE,1) = 'PFE'
              coefcon(ITRPFE,1) = 1.0
              coeflux(ITRPFE,1) = 1.0
c
c  ---- PMN species ---
c
              numcls(ITRPMN) = 1
              namecls(ITRPMN,1) = 'PMN'
              coefcon(ITRPMN,1) = 1.0
              coeflux(ITRPMN,1) = 1.0
c
c  ---- PMG species ---
c
              numcls(ITRPMG) = 1
              namecls(ITRPMG,1) = 'PMG'
              coefcon(ITRPMG,1) = 1.0
              coeflux(ITRPMG,1) = 1.0
c
c  ---- PK species ---
c
              numcls(ITRPK) = 1
              namecls(ITRPK,1) = 'PK'
              coefcon(ITRPK,1) = 1.0
              coeflux(ITRPK,1) = 1.0
c
c  ---- PCA species ---
c
              numcls(ITRPCA) = 1
              namecls(ITRPCA,1) = 'PCA'
              coefcon(ITRPCA,1) = 1.0
              coeflux(ITRPCA,1) = 1.0
c
c  ---- PAL species ---
c
              numcls(ITRPAL) = 1
              namecls(ITRPAL,1) = 'PAL'
              coefcon(ITRPAL,1) = 1.0
              coeflux(ITRPAL,1) = 1.0
c
c  ---- PSI species ---
c
              numcls(ITRPSI) = 1
              namecls(ITRPSI,1) = 'PSI'
              coefcon(ITRPSI,1) = 1.0
              coeflux(ITRPSI,1) = 1.0
c
c  ---- PTI species ---
c
              numcls(ITRPTI) = 1
              namecls(ITRPTI,1) = 'PTI'
              coefcon(ITRPTI,1) = 1.0
              coeflux(ITRPTI,1) = 1.0
          endif
      endif
c
c   --- if doing the MERCURY species ---
c
      if( lmercury ) then
c       
c  ---- HG0 species ---
c
          numcls(ITRHG0) = 1
          namecls(ITRHG0,1) = 'HG0'
          coefcon(ITRHG0,1) = 1.0
          coeflux(ITRHG0,1) = 1.0
c       
c  ---- HG2 species ---
c
          numcls(ITRHG2) = 1
          namecls(ITRHG2,1) = 'HG2'
          coefcon(ITRHG2,1) = 1.0
          coeflux(ITRHG2,1) = 1.0
c       
c  ---- PHG species ---
c
          numcls(ITRPHG) = 1
          namecls(ITRPHG,1) = 'HGP'
          coefcon(ITRPHG,1) = 1.0
          coeflux(ITRPHG,1) = 1.0
      endif
c       
      goto 9999
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c**** RDOPTSA
c
      subroutine rdoptsa()
      use filunit
      use grid
      use procan
      use tracer
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the user options and flags for the
c     source apportionment algorithm.  
c
c      Copyright Ramboll
c
c     Argument description:
c           none
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/16/96   --gwilson--    Original development
c     02/10/97   --cemery--     Added read of fileroot for SA output files
c     04/14/97   --gwilson--    Changed the way number of source groups
c                               is specified
c     04/28/97   --gwilson--    Added flag for OPPAT
c     05/22/97   --gwilson--    Added flag for APCA
c     01/10/02   --cemery --    Eliminated the read for fine grid
c                               flag if no nests 
c     03/21/03   --gwilson--    Removed the OSAT technology type OPPAT
c     10/06/04   --cemery --    Restructured for namelist input
c     10/07/12   --gwilson--    Disabled timing tracers
c     09/11/15   --bkoo--       Revised for SA v3
c     03/01/16   --gwilson--    Added partial source area map
c     11/09/16   --cemery--     Added Baker APCA point source override option
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'namelist.inc'
      include 'flags.inc'
      include 'soap.inc'
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer nemiss, ncount
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c
c   --- if option is turned off, just return ---
c
      if( .NOT. ltrace ) goto 9999
c
c   --- flag for stratifying the boundary by edge ---
c
      lbndry = SA_Stratify_Boundary
c
c   --- flag for writing 3D average ---
c
      lsa_3davrg = SA_3D_Average
c
c   --- number of source regions ---
c
      nregin = SA_Number_of_Source_Regions
c
c   --- number of source emissions groupings ---
c
      nemiss = SA_Number_of_Source_Groups
c
c   --- flag for determining if the leftover group should be used ---
c
      if( Use_Leftover_Group ) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(/,1X,A)') 'The Use_Leftover_Group flag is obsolete.'
         write(iout,'(1X,2A)') 'This version allows the leftover group for ',
     &                         'gridded sources only.'
         write(iout,'(1X,2A)') 'You must include all of the point sources ',
     &                         'in emissions groups.'
         write(iout,'(1X,2A,/,1X,A)') 'To turn on the leftover group for ',
     &                               'gridded sources only set the',
     &                               'flag Use_Gridded_Leftover_Group to true.'
         call camxerr()
      endif
      leftovr_area = Use_Gridded_Leftover_Group
c
c   --- flag for determining what type of output to produce ----
c
      lallout = (.NOT. SA_Summary_Output )
c
c   --- set the number of source groups from the emissions groups ---
c
      if( nemiss .EQ. 1 .AND. leftovr_area ) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(/,1X,2A)') 'Cannot have leftover group ',
     &                           'with only one source group.'
         write(iout,'(1X,2A)') 'Set number of groups to 2 or turn ',
     &                         'off leftover group.'
         call camxerr()
      endif
      if( leftovr_area ) then
          ngroup = nemiss - 1
      else
          ngroup = nemiss 
      endif
c
c   --- check for array overflow ---
c
      if( ngroup .GT. MXTEMF-1 ) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(/,1X,A,I4,A)')'Number of source groupings ',
     &                ngroup,' exceeds maximum.  Increase MXTEMF.'
         call camxerr()
      endif
      if( ngroup .LT. 0 ) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(1X,A,I4,A)')'Number of emissions groups ',nemiss,
     &                            ' is invalid.'
         call camxerr()
      endif
c
c   --- number of timing releases per day ----
c
      ntrtim = Number_of_Timing_Releases
c
c   --- disable timing tracers ---
c
      if( ntrtim .NE. 0 ) goto 7002
c
c   --- set flag for partial source are map ---
c
      if( SA_Use_Partial_SourceMap ) lpartial = .TRUE.
c
c   --- if doing SA, get the classes that should be treat ---
c	
      if( tectyp .EQ. SA ) then
         ncount = 0
         lsulfate = .FALSE.
         lnitrate = .FALSE.
         lsoa     = .FALSE.
         lprimary = .FALSE.
         lmercury = .FALSE.
         lozone   = .FALSE.
         lapca    = .FALSE.
         lapcapt  = .FALSE.
         if( SA_Treat_SULFATE_Class ) then
            lsulfate = .TRUE.
            ncount = ncount + 1
         endif
         if( SA_Treat_NITRATE_Class ) then
            lnitrate = .TRUE.
            if( SA_Use_APCA ) lapca = .TRUE.
            if( lbidinh3 .AND. .NOT. lapca ) goto 7004
            ncount = ncount + 1
         endif
         if( SA_Treat_SOA_Class ) then
            lsoa = .TRUE.
            ncount = ncount + 1
         endif
         if( SA_Treat_PRIMARY_Class ) then
            lprimary = .TRUE.
            ncount = ncount + 1
         endif
         if( SA_Treat_MERCURY_Class ) then
            lmercury = .TRUE.
            ncount = ncount + 1
         endif
         if( SA_Treat_OZONE_Class ) then
            lozone = .TRUE.
            ncount = ncount + 1
            if( SA_Use_APCA ) lapca = .TRUE.
            if( SA_Use_APCA_Ptoverride ) lapcapt = .TRUE.
         endif
         if( ncount .LE. 0 ) goto 7001
      endif
c
c-----Make sure that if you are treating PM classes with SA
c     that PM is used in this run
c
      if( aeropt(1:4) .EQ. 'NONE' ) then
         if( lsulfate ) goto 7003
         if( lnitrate ) goto 7003
         if( lsoa ) goto 7003
         if( lprimary ) goto 7003
      endif
c
c   --- Need the biogenics group if doing APCA ---
c
      if( lapca .AND. ngroup .EQ. 0 .AND. .NOT.lapcapt) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(/,1X,3A)')'Need biogenic sources as a separate ',
     &                          'emissions group when doing APCA.'
         call camxerr()
      endif
c
c   --- do not allow APCA with only one group ---
c
      if( ngroup .EQ. 1 .AND.  lapca .AND. .NOT. leftovr_area ) then
         write(iout,'(//,a)') 'ERROR in RDOPTSA:'
         write(iout,'(/,1X,A,A)')'You asked to use APCA for SA but only',
     &                                           ' provided 1 source group.'
         write(iout,'(1X,A)')'APCA treatment requires at least 2 source groups.'
         call camxerr()
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(/,1X,2A)') 'The SA technology type was ',
     &     'specified but no classes are selected for treatment.'
      write(iout,'(1X,2A)') 'Please activate at least one SA class ',
     &                          'in the CAMx control file.'
      write(iout,'(1X,2A)') 'With this version the SA_Control namelist ',
     &                   'variables have changed significantly.'
      write(iout,'(1X,2A)') 'In particular, the OSAT/APCA options and ',
     &           'PSAT options have been consolidated.' 
      write(iout,'(1X,2A)') 'Include the following for all ',
     &           'source apportionment types: OSAT/APCA/PSAT'
      write(iout,'(1X,A)') '    SA_Treat_SULFATE_Class'
      write(iout,'(1X,A)') '    SA_Treat_NITRATE_Class'
      write(iout,'(1X,A)') '    SA_Treat_SOA_Class'
      write(iout,'(1X,A)') '    SA_Treat_PRIMARY_Class'
      write(iout,'(1X,A)') '    SA_Treat_MERCURY_Class'
      write(iout,'(1X,A)') '    SA_Treat_OZONE_Class'
      write(iout,'(1X,A)') '    SA_Treat_SOAP3_Class'
      write(iout,'(1X,A)') '    SA_Use_APCA'
      write(iout,'(1X,2A)') "See the User's Guide or the namelist template ",
     &           'for details.'
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(/,1X,2A)') 'The CAMx model no longer supports ',
     &                                             'timing tracers.'
      write(iout,'(1X,2A)') 'Please remove the Number_of_Timing_Releases ',
     &                          'variable from the SA_Control namelist.'
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(2a)') 'At least one PM class is being treated by',
     &                        ' the Source Apportionment (SA).'
      write(iout,'(2a)') 'But the chemistry parameters file does not ',
     &                                        'include PM species.'
      write(iout,'(2a/,a)') 'Please run with a PM chemparam file or',
     &  ' turn off treatment of PM class in ','the SA_Control namelist.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(2a)') 'In order to run BiDI with ',
     &                 'the Source Apportionment (SA) you must have'
      write(iout,'(a)') 'Biogenics sources as group 1.'
      write(iout,'(2a)') 'Make sure that the group 1 emissions ',
     &                           'files contain Biogenic sources '
      write(iout,'(a)') 'and turn on the SA_Use_APCA flag.'
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(2a)') 'You requested the SOAP3 class treatment in',
     &                        ' the Source Apportionment (PSAT).'
      write(iout,'(2a)') 'But the chemistry parameters file does not ',
     &                                        'include SOAP3.'
      write(iout,'(2a/,a)') 'Please run with a SOAP3 chemparam file or',
     &  ' turn off treatment of SOAP3 class in ','the SA_Control namelist.'
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in RDOPTSA:'
      write(iout,'(2a)') 'You requested the SOAP3 class treatment in',
     &                        ' the Source Apportionment (PSAT).'
      write(iout,'(2a)') 'But you did not select the SOA class.'
      write(iout,'(2a/,a)') 'This is not allowed. PLease turn on SOA class.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine mrcgeo(iway,cenlon,cenlat,truelat1,xp,yp,lon,lat)
!
!----CAMx v7.40 260801
!
!     MRCGEO performs Mercator to geodetic (lat/lon) translation.
!     Code based on MODULE_LLXY.F from WRF v3.3.
!
!      Copyright Ramboll
!
!     Modifications:
!        none
!
!     Routines called:
!        none
!
!     Called by:
!        GRDPREP
!
      implicit none
      real, parameter :: PI = 3.141592653589793
      real, parameter :: DEG_PER_RAD = 180./PI
      real, parameter :: RAD_PER_DEG = PI/180.
      real, parameter :: REARTH = 6370.
!
!-----Arguments
!
      integer          :: iway     ! Conversion direction
                                   ! 0 = geodetic to Polar Stereographic
                                   ! 1 = Polar Stereographic to geodetic
      real             :: cenlon   ! Longitude at (0,0) point (-180->180E)
      real             :: cenlat   ! Latitude at (0,0) point (-90->+90)
      real             :: truelat1 ! True latitude (-90 -> 90 degrees N)
      real             :: xp       ! Cartesian X coordinate (km)
      real             :: yp       ! Cartesian Y coordinate (km)
      real             :: lat      ! Latitude (-90->90 deg N)
      real             :: lon      ! Longitude (-180->180 E)
!
!-----Locals
!
      real             :: clain
      real             :: dlon
      real             :: deltalon
      real             :: r0
!
!-----Entry point
!
!-----Preliminary variables
!
      clain = COS(RAD_PER_DEG*truelat1)
      dlon = 1./(REARTH*clain)
!  
!-----Compute distance from equator to origin
!  
      r0 = 0.
      if (cenlat .NE. 0.) then
        r0 = (ALOG(TAN(0.5*((cenlat + 90.)*RAD_PER_DEG))))/dlon
      endif
!
!-------------------------------------------------------------------------------
!     Calculate lat/lon from x/y
!-------------------------------------------------------------------------------
!
      if (iway .EQ. 1) then
        lat = 2.*ATAN(EXP(dlon*(r0 + yp)))*DEG_PER_RAD - 90.
        lon = xp*dlon*DEG_PER_RAD + cenlon
        if (lon .GT.  180.) lon = lon - 360.
        if (lon .LT. -180.) lon = lon + 360.
!
!-------------------------------------------------------------------------------
!     Calculate x/y from lat/lon
!-------------------------------------------------------------------------------
!
      else
        deltalon = lon - cenlon
        if (deltalon .LT. -180.) deltalon = deltalon + 360.
        if (deltalon .GT.  180.) deltalon = deltalon - 360.
        xp = deltalon/(dlon*DEG_PER_RAD)
        yp = ALOG(TAN(0.5*((lat + 90.)*RAD_PER_DEG)))/dlon - r0
      endif
!
      return
      end

C**** SA_SOAP3_EVAP_AREA
c
      subroutine sa_soap3_evap_area( igrd, ncol_grid, nrow_grid,
     &              nlay_grid, nlay_ems, evap_factors, temperature, 
     &               istart_hoa, iend_hoa, hoa_area_emis, istart_svoa,
     &                     iend_svoa, svoa_area_emis, area_emis, numspcs)
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine applies factors to evaporate POA to SVOA and
c     updates the emissions array so emissions are injected into
c     the appropriate model species.
c
c      Copyright Ramboll
c
c     Input arguments:
c        igrd             grid index
c        ncol_grid        number of columns
c        nrow_grid        number of rows
c        nlay_grid        number of layers in grid
c        nlay_ems         number of layers in emissions foles
c        numspcs          number of model species
c        temperature      temperature in aloft layers
c        istart_hoa       begin index of array for HOA 
c        iend_hoa         end index of array for HOA 
c        istart_svoa      begin index of array for HOA 
c        iend_svoa        end index of array for HOA 
c        area_emis        area emissions rate (grams/s)
c     Output arguments:
c        hoa_area_emis    area emissions rate (grams/s)
c        svoa_area_emis   area emissions rate (grams/s)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/24   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrd
      integer ncol_grid
      integer nrow_grid
      integer nlay_grid
      integer nlay_ems
      integer numspcs
      real    evap_factors(3,NUM_SOAP_EMISS)
      real    temperature(ncol_grid,nrow_grid,nlay_grid)
      integer istart_hoa
      integer iend_hoa
      real    hoa_area_emis(ncol_grid,nrow_grid,nlay_ems,istart_hoa:iend_hoa)
      integer istart_svoa
      integer iend_svoa
      real    svoa_area_emis(ncol_grid,nrow_grid,nlay_ems,istart_svoa:iend_svoa)
      real    area_emis(ncol_grid,nrow_grid,nlay_ems,numspcs)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer imod, iems, icl, jcl, klay, isoa, ipt, ioff_svoa, ioff_soa
      integer ispc_hoa
      real    evap_fact, evap_mass, convfac
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- loop over all HOA emissiosn species ---
c
      ioff_svoa = 0
      ioff_soa = 0
      hoa_area_emis = 0.
      svoa_area_emis = 0.
      do ispc_hoa=istart_hoa,iend_hoa
c
c  --- loop over grid and update all affected species ----
c
          do klay=1,nlay_ems
           do jcl=1,nrow_grid
             do icl=1,ncol_grid
c
c  --- add in the emitted HOA emissions ---
c
                hoa_area_emis(icl,jcl,klay,ispc_hoa) = 
     &                  hoa_area_emis(icl,jcl,klay,ispc_hoa) +
     &                              area_emis(icl,jcl,klay,ispc_hoa)
c
c  --- see if POA species was found ---
c
                do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                   if( area_emis(icl,jcl,klay,soap3_iemcls(isoa)+ioff_soa) .LE. 0 ) cycle
c
c ---- evaporate POA into SVOA ---
c
                   evap_fact = MIN(1.0,
     &                         (evap_factors(1,isoa) * temperature(icl,jcl,klay)**2 + 
     &                          evap_factors(2,isoa) * temperature(icl,jcl,klay) + 
     &                          evap_factors(3,isoa) ))
                   evap_mass = area_emis(icl,jcl,klay,soap3_iemcls(isoa)+ioff_soa) * 
     &                         (1. - evap_fact)
                   svoa_area_emis(icl,jcl,klay,iemcls(idxipt(ITRSVA))+ioff_svoa) = 
     &                     svoa_area_emis(icl,jcl,klay,iemcls(idxipt(ITRSVA))+ioff_svoa) +
     &                                                 MAX(0.,evap_mass/mole_weight(ksvoa) )
c
c ---- back out the evap emissions from each POA species ---
c
                   hoa_area_emis(icl,jcl,klay,ispc_hoa) = 
     &              hoa_area_emis(icl,jcl,klay,ispc_hoa) + 
     &                MAX(0.,area_emis(icl,jcl,klay,soap3_iemcls(isoa)+ioff_soa) 
     &                                                           - evap_mass)
                enddo
              enddo
            enddo
          enddo
          ioff_svoa = ioff_svoa + 1
          ioff_soa = ioff_soa + 1
       enddo
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine openfils(ii,nopen)
      use camxcom
      use camxfld
      use filunit
      use chmstry
      use o3colmap
      use grid
      use pigsty
      use tracer
      use procan
      implicit none
c
c----CAMx v7.40 260801
c
c     OPENFILS opens Fortran I/O files
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        7/5/02    Changed to account for new type of PiG flag
c        8/30/02   Modified to read combined cloud/rain file, and now
c                  water vapor and cloud/rain files can be provided for each
c                  nest
c        01/30/02  Added code for RTRAC probing tool
c        1/10/03   Added open of deposition output file
c        4/2/03    Removed option for UAM-V type cloud file
c        3/3/04    Added checks for reading water files
c                  if either chemistry, dry dep or wet dep is on
c        3/19/04   Added checks for reading AHO file if
c                  if either chemistry or dry dep is on
c        10/4/04   Restructured for namelist input
c        6/21/05   Cloud/rain header modified for new structure
c        8/02/05   Added open of general PiG sampling grid files
c        8/25/05   PiG restart file is now optional
c        8/23/06   Instantaneous restart files reduced to 1 per grid type
c        8/25/06   Average and deposition output files now all UAM format,
c                  one file per grid
c        11/4/09   Removed input top concentrations
c        1/04/11   Revised for new met input format
c        04/02/12  Removed drought stress and snow flag; AHO
c                  file is now just ozone column
c        05/07/12  Added flexi-nesting flag
c        04/30/13  Added surface model
c        4/07/14   Added top con file
c        09/02/14  Added subgrid convective model
c        09/28/23  Added NCF surface model restart input file
c
c     Input arguments:
c        ii                  Length of fileroot string 
c        nopen               number of files opened
c
c     Output arguments:
c        none
c
c     Routines Called:
c        none
c
c     Called by:
c        READNML
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
      include 'netcdf.inc'
c
c-----External functions
c
      integer istrln
      integer ncf_chkfile
      integer ncf_get_nlayers
c
      character*200 filtmp
      character*80  action
      character*10  cname
      character*4   name(10)
      logical       lexist
      integer       nopen,nfils,ii,n,ifile,ierr
c
c-----Entry point
c
c-----Open text output files
c
      nlayers_ems = 1
      filtmp = ' '
      filtmp = filroot
      write(iout,9000) 'Output OUT message file              (unit):',
     &                                                             iout
      write(iout,9003) filtmp(1:ii),'.out'
      write(iout,9000) 'Output DIAG diagnostic file          (unit):',
     &                                                             idiag
      write(iout,9003) filtmp(1:ii),'.diag'
      write(iout,9000) 'Output MASS summary file             (unit):',
     &                                                             imass
      write(iout,9003) filtmp(1:ii),'.mass'
c
c-----Open master grid instantaneous concentration output file
c
      filtmp(ii+1:) = '.inst'
      nopen = nopen + 1
      call getunit(iconc)
      action = 'Opening output INST file for master grid.'
      open(unit=iconc,file=filtmp(1:ii+5),form='UNFORMATTED',
     &                                    status= 'UNKNOWN',ERR=7000)
      write(iout,9000) 'Output INST file for master grid     (unit):',
     &                                                           iconc
      write(iout,9002) filtmp(1:ii+5)
c
c-----Open fine grid instantaneous concentration output file
c
      nfils = 4
      if (ngrid.gt.1) then
        filtmp(ii+1:) = '.finst'
        nopen = nopen + 1
        call getunit(ifconc)
        action = 'Opening output INST file for nest grids.'
        open(unit=ifconc,file=filtmp(1:ii+6),form='UNFORMATTED',
     &                                    status= 'UNKNOWN',ERR=7000)
        write(iout,9000) 'Output INST file for nest grids      (unit):',
     &                                                            ifconc
        write(iout,9002) filtmp(1:ii+6)
        nfils = nfils + 1
      endif
c
c-----Open average concentration output file(s)
c
      if (navspc.gt.0) then
        filtmp(ii+1:) = '.avrg'
        do n = 1,ngrid
          if( .NOT. lcdfout ) then
             write(filtmp(ii+6:),'(a,i2.2)') '.grd',n
             nopen = nopen + 1
             call getunit(iavg(n))
             action = 'Opening output AVERAGE file'
             open(unit=iavg(n),file=filtmp(1:ii+11),form='UNFORMATTED',
     &                                    status='UNKNOWN',ERR=7000)
             write(iout,9000) 
     &           'Output AVERAGE file                  (unit):',iavg(n)
             write(iout,9002) filtmp(1:ii+11)
             nfils = nfils + 1
          else
             write(filtmp(ii+6:),'(a,i2.2,a)') '.grd',n,'.nc'
             action = 'Opening output AVERAGE file for NCF'
             call ncf_createfile(filtmp,action,iavg(n))
             nopen = nopen + 1
             write(iout,9000) 'Output AVERAGE file:'
             write(iout,9002) filtmp(1:ii+14)
             nfils = nfils + 1
          endif
        enddo
      endif
c
c-----Open deposition output file(s)
c
      if (navspc.gt.0 .and. (ldry .or. lwet)) then
        filtmp(ii+1:) = '.depn'
        do n = 1,ngrid
          if( .NOT. lcdfout ) then
             write(filtmp(ii+6:),'(a,i2.2)') '.grd',n
             nopen = nopen + 1
             call getunit(idep(n))
             action = 'Opening output DEPOSITION file'
             open(unit=idep(n),file=filtmp(1:ii+11),form='UNFORMATTED',
     &                                   status= 'UNKNOWN',ERR=7000)
             write(iout,9000) 
     &           'Output DEPOSITION file               (unit):',idep(n)
             write(iout,9002) filtmp(1:ii+11)
             nfils = nfils + 1
          else
             write(filtmp(ii+6:),'(a,i2.2,a)') '.grd',n,'.nc'
             nopen = nopen + 1
             action = 'Opening output DEPOSITION file'
             call ncf_createfile(filtmp,action,idep(n))
             write(iout,9000) 'Output DEPOSITION file:'
             write(iout,9002) filtmp(1:ii+14)
             nfils = nfils + 1
          endif
        enddo
      endif
c
c-----Open surface model output file(s)
c
      if (lsrfmod) then
        filtmp(ii+1:) = '.srf'
        do n = 1,ngrid
          if( .NOT. lcdfout ) then
             write(filtmp(ii+5:),'(a,i2.2)') '.grd',n
             nopen = nopen + 1
             call getunit(ismout(n))
             action = 'Opening output SURFACE MODEL file'
             open(unit=ismout(n),file=filtmp(1:ii+11),form='UNFORMATTED',
     &                                   status= 'UNKNOWN',ERR=7000)
             write(iout,9000)
     &           'Output SURFACE MODEL file:           (unit):',ismout(n)
             write(iout,9002) filtmp(1:ii+11)
             nfils = nfils + 1
           else
             write(filtmp(ii+5:),'(a,i2.2,a)') '.grd',n,'.nc'
             nopen = nopen + 1
             action = 'Opening output SURFACE MODEL file'
             call ncf_createfile(filtmp,action,ismout(n))
             write(iout,9000) 'Output SURFACE MODEL file:'
             write(iout,9002) filtmp(1:ii+14)
             nfils = nfils + 1
           endif
        enddo
      endif
c
c-----Open PiG output file
c
      if( ipigflg .NE. 0 ) then
        filtmp(ii+1:) = '.pig'
        nopen = nopen + 1
        call getunit(ipig)
        action = 'Opening output PiG file.'
        open(unit=ipig,file=filtmp(1:ii+4),form='UNFORMATTED',
     &                             status= 'UNKNOWN',ERR=7000)
        write(iout,9000) 'Output PiG file                      (unit):',
     &                                                              ipig
        write(iout,9002) filtmp(1:ii+4)
        nfils = nfils + 1
c
c-----Open PiG sampling grid output file(s)
c
        if (lsample) then
          filtmp(ii+1:) = '.smp'
          do n = 1,nsample
            if( .NOT. lcdfout ) then
               write(filtmp(ii+5:),'(i2.2,a)') n
               nopen = nopen + 1
               call getunit(isample(n))
               action = 'Opening output PiG sampling grid file.'
               open(unit=isample(n),file=filtmp(1:ii+6),form='UNFORMATTED',
     &              status='UNKNOWN',ERR=7000)
               write(iout,9000)
     &                   'PiG Sampling Grid output file        (unit):',
     &                                                        isample(n)
               write(iout,9002) filtmp(1:ii+6)
             else
               write(filtmp(ii+5:),'(i2.2,a)') n,'.nc'
               nopen = nopen + 1
               call getunit(isample(n))
               action = 'Opening output PiG sampling grid file.'
               call ncf_createfile(filtmp,action,isample(n))
               write(iout,9000) 'PiG Sampling Grid output file:'
               write(iout,9002) filtmp(1:ii+9)
             endif
          enddo
        endif
      endif
c
c-----Open chemistry parameters input file
c
      filtmp = Chemistry_Parameters
      action = 'Opening Chemistry Parameters file.'
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(ichem)
      open(unit=ichem,file=filtmp,status='OLD',ERR=7000)
      write(iout,9000) 'Chemistry Parameters file            (unit):',
     &                                                           ichem
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open photoloysis rates input file
c
      if( lchem ) then
        filtmp = Photolyis_Rates
        action = 'Opening Photolysis Rates file.'
        inquire(file=filtmp,exist=lexist)
        if( .NOT. lexist .OR. filtmp .EQ. ' ' ) then
          filtmp = Photolysis_Rates
          inquire(file=filtmp,exist=lexist)
          if( .NOT. lexist ) goto 7002
        endif
        nopen = nopen + 1
        call getunit(iphot)
        open(unit=iphot,file=filtmp,status='OLD',ERR=7000) 
        write(iout,9000) 'Photolysis Rates file                (unit):',
     &                                                             iphot
        write(iout,9002) filtmp(:istrln(filtmp))
        nfils = nfils + 1
      else
        iphot = 0
        write(iout,9000) 'Photolysis Rates file                      :'
        write(iout,9002) '   Ignored.' 
      endif
c
c-----Open initial conditions input file
c
      if( .NOT. lrstrt ) then
        filtmp = Initial_Conditions
        action = 'Opening Initial Conditions file.'
        is_netcdf_iic = .FALSE.
        inquire(file=filtmp,exist=lexist)
        if( .NOT. lexist ) goto 7002
        nopen = nopen + 1
        call getunit(iic)
        cname = 'AIRQUALITY'
        ierr = ncf_chkfile(iic,filtmp,action,cname)
        if( ierr .EQ. ISUCES ) then
           call nobinary()
           open(unit=iic,file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
        else
           is_netcdf_iic = .TRUE.
           ierr = nf_open(filtmp,NF_NOWRITE,iic)
           if( ierr .NE. NF_NOERR ) goto 7000
        endif
        write(iout,9000) 'Initial Conditions file              (unit):',
     &                                                               iic
        write(iout,9002) filtmp(:istrln(filtmp))
        nfils = nfils + 1
      else
        iic = 0
        write(iout,9000) 'Initial Conditions file                    :'
        write(iout,9002) '   Ignored.'
      endif
c
c-----Open boundary conditions input file
c
      filtmp = Boundary_Conditions
      action = 'Opening Boundary Conditions file.'
      is_netcdf_ibc = .FALSE.
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(ibc)
      cname = 'BOUNDARY  '
      ierr = ncf_chkfile(ibc,filtmp,action,cname)
      if( ierr .EQ. ISUCES ) then
           call nobinary()
           open(unit=ibc,file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
      else
         is_netcdf_ibc = .TRUE.
         ierr = nf_open(filtmp,NF_NOWRITE,ibc)
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      write(iout,9000) 'Boundary Conditions file             (unit):',
     &                                                             ibc
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open top concentration input file
c
      filtmp = Top_Concentrations
      if( filtmp .NE. ' ' ) then
        action = 'Opening Top Concentrations file.'
        is_netcdf_itc = .FALSE.
        inquire(file=filtmp,exist=lexist)
        if( .NOT. lexist ) goto 7002
        nopen = nopen + 1
        call getunit(itc)
        cname = 'AIRQUALITY'
        ierr = ncf_chkfile(itc,filtmp,action,cname)
        if( ierr .EQ. ISUCES ) then
           call nobinary()
           open(unit=itc,file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
        else
           is_netcdf_itc = .TRUE.
           ierr = nf_open(filtmp,NF_NOWRITE,itc)
           if( ierr .NE. NF_NOERR ) goto 7000
        endif
        write(iout,9000) 'Top Concentrations file              (unit):',
     &                                                             itc
        write(iout,9002) filtmp(:istrln(filtmp))
        ltopcon = .true.
        nfils = nfils + 1
      else
        write(iout,9000) 'Top Concentrations file                    :'
        write(iout,9002) '   Ignored.'
        ltopcon = .false.
        if( lstrato3 ) goto 7011
      endif
c
c-----Open ozone column input file
c
      filtmp = Ozone_Column
      if( filtmp .NE. ' ' ) then
        action = 'Opening ozone column file.'
        inquire(file=filtmp,exist=lexist)
        if( .NOT. lexist ) goto 7002
        nopen = nopen + 1
        call getunit(io3col)
        open(unit=io3col,file=filtmp,status='OLD',ERR=7000)
        write(iout,9000) 'Ozone column file                    (unit):',
     &                                                            io3col
        write(iout,9002) filtmp(:istrln(filtmp))
        nfils = nfils + 1
      else
        io3col = 0
        if( lchem ) goto 7010
        write(iout,9000) 'Ozone column file                          :'
        write(iout,9002) '   Ignored.'
      endif
c
c-----Open point source emissions input file
c
      luse_points = .FALSE.
      if( lptsrc ) then
        do ifile=1,npoint_files
           filtmp = Point_Sources(ifile)
           action = 'Opening Point Source Emissions file.'
           if( filtmp .EQ. ' ' ) goto 7008
           inquire(file=filtmp,exist=lexist)
           if( .NOT. lexist ) goto 7002
           nopen = nopen + 1
           call getunit(iptem(ifile))
           cname = 'PTSOURCE  '
           ierr = ncf_chkfile(iptem(ifile),filtmp,action,cname)
           if( ierr .EQ. ISUCES ) then
              call nobinary()
              is_netcdf_iptem(ifile) = .FALSE.
              open(unit=iptem(ifile),file=filtmp,
     &                        form='UNFORMATTED',status='OLD',ERR=7000)
           else
              is_netcdf_iptem(ifile) = .TRUE.
              ierr = nf_open(filtmp,NF_NOWRITE,iptem(ifile))
              if( ierr .NE. NF_NOERR ) goto 7000
           endif
           write(iout,9000) 'Point Source Emissions file          (unit):',
     &                                                           iptem(ifile)
           write(iout,9002) filtmp(:istrln(filtmp))
           nfils = nfils + 1
           luse_points = .TRUE.
        enddo
      else
        npoint_files = 0
        iptem(1) = 0
        write(iout,9000) 'Point Source Emissions file                :'
        write(iout,9002) '   Ignored.'
      endif
c
c-----if doing SA then point source files are read from SA_control section ----
c
      if( tectyp .EQ. SA .AND. luse_points ) then
         action = 'Reading point source filenames.'
         goto 7006
      endif
c
c-----Open master grid restart input file
c
      if( lrstrt ) then
        filtmp = Master_Grid_Restart
        action = 'Opening Restart file for master grid.'
        inquire(file=filtmp,exist=lexist)
        if( .NOT. lexist ) goto 7002
        nopen = nopen + 1
        call getunit(irstc)
        open(unit=irstc,file=filtmp,form='UNFORMATTED',
     &                                       status='OLD',ERR=7005)
        write(iout,9000) 'Master grid Restart file             (unit):',
     &                                                             irstc
        write(iout,9002) filtmp(:istrln(filtmp))
        nfils = nfils + 1
c
c-----Open fine grid restart input file
c
        if( ngrid .GT. 1 ) then
          filtmp = Nested_Grid_Restart
          action = 'Opening Restart file for nest grids.'
          if( filtmp .EQ. ' ' ) then
             if (lflexi) then
               irstf = 0
               write(iout,9001)
     &                  'Nest grid Restart file                     :'
               write(iout,9002) '   Ignored.'
             else
               goto 7003
             endif
          else
             inquire(file=filtmp,exist=lexist)
             if( .NOT. lexist ) goto 7003
             nopen = nopen + 1
             call getunit(irstf)
             open(unit=irstf,file=filtmp,form='UNFORMATTED',
     &                                         status='OLD',ERR=7005)
             write(iout,9000)
     &              'Nest grid Restart file               (unit):',irstf
             write(iout,9002) filtmp(:istrln(filtmp))
             nfils = nfils + 1
          endif
        endif
c
c-----Open PiG restart input file
c
        if( ipigflg .NE. 0 ) then
          filtmp = PiG_Restart
          if( filtmp .EQ. ' ' ) then
             irstp = 0
             write(iout,9001)
     &                   'PiG Restart file                           :'
             write(iout,9002) '   Ignored.'
          else
             action = 'Opening PiG Restart file.'
             inquire(file=filtmp,exist=lexist)
             if( .NOT. lexist ) goto 7002
             nopen = nopen + 1
             call getunit(irstp)
             open(unit=irstp,file=filtmp,form='UNFORMATTED',
     &                                status='OLD',ERR=7005)
             write(iout,9000)
     &         'PiG Restart file                     (unit):',irstp
             write(iout,9002) filtmp(:istrln(filtmp))
             nfils = nfils + 1
          endif
        endif
      endif
c
c-----Open master grid 2D Surface input file
c
      filtmp = Surface_Grid(1)
      write(action,'(A,I4)') 'Opening 2D Surface file for grid:',1
      is_netcdf_isurf(1) = .FALSE.
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(isurf(1))
      cname = 'AVERAGE   '
      ierr = ncf_chkfile(isurf(1),filtmp,action,cname)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(unit=isurf(1),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
      else
         is_netcdf_isurf(1) = .TRUE.
         ierr = nf_open(filtmp,NF_NOWRITE,isurf(1))
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      write(iout,9001)
     &        '2D Surface file for grid # ',1,'        (unit):',isurf(1)
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open nested grid 2D Surface input file(s)
c
      do n = 2,ngrid
        filtmp = Surface_Grid(n)
        write(action,'(A,I4)') 'Opening 2D Surface file for grid:',n
        is_netcdf_isurf(n) = .FALSE.
        if( filtmp .EQ. ' ')  then
           if (lflexi) then
             isurf(n) = 0
             write(iout,9001)
     &                 '2D Surface file for grid # ',n,'              :'
             write(iout,9002) '   Ignored.'
           else
             goto 7003
           endif
        else
           inquire(file=filtmp,exist=lexist)
           if( .NOT. lexist ) goto 7003
           nopen = nopen + 1
           call getunit(isurf(n))
           cname = 'AVERAGE   '
           ierr = ncf_chkfile(isurf(n),filtmp,action,cname)
           if( ierr .EQ. ISUCES ) then 
              call nobinary()
              open(unit=isurf(n),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
           else
              is_netcdf_isurf(n) = .TRUE.
              ierr = nf_open(filtmp,NF_NOWRITE,isurf(n))
              if( ierr .NE. NF_NOERR ) goto 7000
           endif
           write(iout,9001)
     &             '2D Surface file for grid # ',n,'        (unit):',
     &                                                         isurf(n)
           write(iout,9002) filtmp(:istrln(filtmp))
           nfils = nfils + 1
        endif
      enddo
c
c-----Open master grid 3D Met input file
c
      filtmp = Met3d_Grid(1)
      is_netcdf_i3dmet(1) = .FALSE.
      write(action,'(A,I4)') 'Opening 3D Met file for grid:',1
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(i3dmet(1))
      cname = 'AVERAGE   '
      ierr = ncf_chkfile(i3dmet(1),filtmp,action,cname)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(unit=i3dmet(1),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
      else
         is_netcdf_i3dmet(1) = .TRUE.
         ierr = nf_open(filtmp,NF_NOWRITE,i3dmet(1))
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      write(iout,9001)'3D Met file for grid # ',1,'            (unit):',
     &                                                         i3dmet(1)
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open nested grid 3D Met input file(s)
c
      do n = 2,ngrid
        filtmp = Met3D_Grid(n)
        write(action,'(A,I4)') 'Opening 3D Met file for grid:',n
        is_netcdf_i3dmet(n) = .FALSE.
        if( filtmp .EQ. ' ' ) then
          if (lflexi) then
            i3dmet(n) = 0
            write(iout,9001)
     &                 '3D Met file for grid # ',n,'                  :'
            write(iout,9002) '   Ignored.'
          else
            goto 7003
          endif
        else
          inquire(file=filtmp,exist=lexist)
          if( .NOT. lexist ) goto 7003
          nopen = nopen + 1
          call getunit(i3dmet(n))
          cname = 'AVERAGE   '
          ierr = ncf_chkfile(i3dmet(n),filtmp,action,cname)
          if( ierr .EQ. ISUCES ) then
             call nobinary()
             open(unit=i3dmet(n),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
          else
             is_netcdf_i3dmet(n) = .TRUE.
             ierr = nf_open(filtmp,NF_NOWRITE,i3dmet(n))
             if( ierr .NE. NF_NOERR ) goto 7000
          endif
          write(iout,9001)
     &                '3D Met file for grid # ',n,'            (unit):',
     &                                                         i3dmet(n)
          write(iout,9002) filtmp(:istrln(filtmp))
          nfils = nfils + 1
        endif
      enddo
c
c-----Open master grid 2D Met input file
c
      filtmp = Met2D_Grid(1)
      write(action,'(A,I4)') 'Opening 2D Met file for grid:',1
      is_netcdf_i2dmet(1) = .FALSE.
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(i2dmet(1))
      cname = 'AVERAGE   '
      ierr = ncf_chkfile(i2dmet(1),filtmp,action,cname)
      if( ierr .EQ. ISUCES ) then
           call nobinary()
           open(unit=i2dmet(1),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
      else
         is_netcdf_i2dmet(1) = .TRUE.
         ierr = nf_open(filtmp,NF_NOWRITE,i2dmet(1))
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      write(iout,9001)
     &              '2D Met file for grid # ',1,'            (unit):',
     &                                                       i2dmet(1)
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open nested grid 2D Met input file(s)
c
      do n = 2,ngrid
        filtmp = Met2D_Grid(n)
        write(action,'(A,I4)') 'Opening 2D Met file for grid:',n
        is_netcdf_i2dmet(n) = .FALSE.
        if( filtmp .EQ. ' ' ) then
           if (lflexi) then
             i2dmet(n) = 0
             write(iout,9001)
     &                 '2D Met file for grid # ',n,'                  :'
             write(iout,9002) '   Ignored.'
           else
             goto 7003
           endif
         else
           inquire(file=filtmp,exist=lexist)
           if( .NOT. lexist ) goto 7003
           nopen = nopen + 1
           call getunit(i2dmet(n))
           cname = 'AVERAGE   '
           ierr = ncf_chkfile(i2dmet(n),filtmp,action,cname)
           if( ierr .EQ. ISUCES ) then
              call nobinary()
              open(unit=i2dmet(n),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
           else
              is_netcdf_i2dmet(n) = .TRUE.
              ierr = nf_open(filtmp,NF_NOWRITE,i2dmet(n))
              if( ierr .NE. NF_NOERR ) goto 7000
           endif
           write(iout,9001)
     &               '2D Met file for grid # ',n,'            (unit):',
     &                                                        i2dmet(n)
           write(iout,9002) filtmp(:istrln(filtmp))
           nfils = nfils + 1
         endif
      enddo
c
c-----Open master grid 3D VDiff input file
c
      filtmp = Vdiff_Grid(1)
      write(action,'(A,I4)')
     &                'Opening 3D Vertical Diffusivity file for grid:',1
      is_netcdf_ikv(1) = .FALSE.
      inquire(file=filtmp,exist=lexist)
      if( .NOT. lexist ) goto 7002
      nopen = nopen + 1
      call getunit(ikv(1))
      cname = 'AVERAGE   '
      ierr = ncf_chkfile(ikv(1),filtmp,action,cname)
      if( ierr .EQ. ISUCES ) then
         call nobinary()
         open(unit=ikv(1),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
      else
         is_netcdf_ikv(1) = .TRUE.
         ierr = nf_open(filtmp,NF_NOWRITE,ikv(1))
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      write(iout,9001)
     &             '3D VDiff file for grid # ',1,'             (unit):',
     &                                                          ikv(1)
      write(iout,9002) filtmp(:istrln(filtmp))
      nfils = nfils + 1
c
c-----Open nested grid 3D VDiff input file(s)
c
      do n = 2,ngrid
        filtmp = Vdiff_Grid(n)
        write(action,'(A,I4)')
     &                'Opening 3D Vertical Diffusivity file for grid:',n
        is_netcdf_ikv(n) = .FALSE.
        if( filtmp .EQ. ' ' ) then
           if (lflexi) then
             ikv(n) = 0
             write(iout,9001)
     &              '3D VDiff file for grid # ',n,'                   :'
             write(iout,9002) '   Ignored.'
           else
             goto 7003
           endif
        else
           inquire(file=filtmp,exist=lexist)
           if( .NOT. lexist ) goto 7003
           nopen = nopen + 1
           call getunit(ikv(n))
           cname = 'AVERAGE   '
           ierr = ncf_chkfile(ikv(n),filtmp,action,cname)
           if( ierr .EQ. ISUCES ) then
              call nobinary()
              open(unit=ikv(n),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
           else
              is_netcdf_ikv(n) = .TRUE.
              ierr = nf_open(filtmp,NF_NOWRITE,ikv(n))
              if( ierr .NE. NF_NOERR ) goto 7000
           endif
           write(iout,9001)
     &             '3D VDiff file for grid # ',n,'             (unit):',
     &                                                           ikv(n)
           write(iout,9002) filtmp(:istrln(filtmp))
           nfils = nfils + 1
        endif
      enddo
c
c-----Open master grid 3D Cloud/rain input file
c
      icld = 0
      if(  .NOT. is_netcdf_i3dmet(1) ) then
         filtmp = Cloud_Grid(1)
         write(action,'(A,I4)') 'Opening 3D Cloud/Rain file for grid:',1
         if( filtmp .EQ. ' ' ) then
            if( lwet .or. lcig(1) ) goto 7002
            icld(1) = 0
            write(iout,9001)
     &                 '3D Cloud/Rain file for grid # ',1,'           :'
            write(iout,9002) '   Ignored.' 
         else
            call nobinary()
            inquire(file=filtmp,exist=lexist)
            if( .NOT. lexist ) goto 7002
            nopen = nopen + 1
            call getunit(icld(1))
            open(unit=icld(1),file=filtmp,form='UNFORMATTED',
     &                                            status='OLD',ERR=7000)
            write(iout,9001)
     &               '3D Cloud/Rain file for grid # ',1,'     (unit):',
     &                                                          icld(1)
            write(iout,9002) filtmp(:istrln(filtmp))
            nfils = nfils + 1
c
c-----Open nested grid 3D Cloud/rain input file(s)
c
            do n = 2,ngrid
              if( is_netcdf_i3dmet(n) ) cycle
              filtmp = Cloud_Grid(n)
              write(action,'(A,I4)')
     &                          'Opening 3D Cloud/Rain file for grid:',n
              if( filtmp .EQ. ' ' ) then
                 if (lcig(n)) goto 7002
                 if (lflexi .or. .not.lwet) then
                   icld(n) = 0
                   write(iout,9001)
     &                 '3D Cloud/Rain file for grid # ',n,'           :'
                   write(iout,9002) '   Ignored.'
                 else
                   goto 7003
                 endif
              else
                 call nobinary()
                 inquire(file=filtmp,exist=lexist)
                 if( .NOT. lexist ) goto 7003
                 nopen = nopen + 1
                 call getunit(icld(n))
                 open(unit=icld(n),file=filtmp,form='UNFORMATTED',
     &                                           status='OLD',ERR=7000)
                 write(iout,9001)
     &               '3D Cloud/Rain file for grid # ',n,'     (unit):',
     &                                                          icld(n)
                 write(iout,9002) filtmp(:istrln(filtmp))
                 nfils = nfils + 1
c
              endif
            enddo
         endif
       endif
c
c-----Open master grid 2D Emissions input file
c
      if( larsrc ) then
         do ifile=1,nemiss_files(1)
            filtmp = Emiss_Grid(1,ifile)
            write(action,'(A,I4)') 
     &                     'Opening Gridded Emissions file for grid:',1
            if( filtmp .EQ. ' ' ) goto 7007
            inquire(file=filtmp,exist=lexist)
            if( .NOT. lexist ) goto 7002
            nopen = nopen + 1
            call getunit(iarem(1,ifile))
            cname = 'EMISSIONS '
            ierr = ncf_chkfile(iarem(1,ifile),filtmp,action,cname)
            if( ierr .EQ. ISUCES ) then
                 call nobinary()
                 is_netcdf_iarem(1,ifile) = .FALSE.
                 open(unit=iarem(1,ifile),file=filtmp,form='UNFORMATTED',
     &                                             status='OLD',ERR=7000)
            else
               is_netcdf_iarem(1,ifile) = .TRUE.
               ierr = nf_open(filtmp,NF_NOWRITE,iarem(1,ifile))
               if( ierr .NE. NF_NOERR ) goto 7000
               nlayers_ems = MAX(nlayers_ems,ncf_get_nlayers(iarem(1,ifile),filtmp,action))
            endif
            write(iout,9001)
     &              'Gridded Emissions file for grid # ',1,' (unit):',
     &                                                         iarem(1,ifile)
            write(iout,9002) filtmp(:istrln(filtmp))
            nfils = nfils + 1
         enddo
c
c-----Open nested grid 2D Emissions input file(s)
c
         do n = 2,ngrid
           do ifile=1,nemiss_files(n)
             filtmp = Emiss_Grid(n,ifile)
             write(action,'(A,I4)') 
     &                     'Opening Gridded Emissions file for grid:',n
             if( filtmp .EQ. ' ' ) then
                if (lflexi) then
                  iarem(n,ifile) = 0
                  write(iout,9001)
     &                'Gridded Emissions file for grid # ',n,'       :'
                  write(iout,9002) '   Ignored.' 
                else
                  goto 7003
                endif
             else
                inquire(file=filtmp,exist=lexist)
                if( .NOT. lexist ) goto 7003
                nopen = nopen + 1
                call getunit(iarem(n,ifile))
                cname = 'EMISSIONS '
                ierr = ncf_chkfile(iarem(n,ifile),filtmp,action,cname)
                if( ierr .EQ. ISUCES ) then
                      call nobinary()
                      is_netcdf_iarem(n,ifile) = .FALSE.
                      open(unit=iarem(n,ifile),file=filtmp,
     &                        form='UNFORMATTED',status='OLD',ERR=7000)
                else
                   is_netcdf_iarem(n,ifile) = .TRUE.
                   ierr = nf_open(filtmp,NF_NOWRITE,iarem(n,ifile))
                   if( ierr .NE. NF_NOERR ) goto 7000
                   nlayers_ems = MAX(nlayers_ems,ncf_get_nlayers(iarem(n,ifile),filtmp,action))
                endif
                write(iout,9001)
     &                'Gridded Emissions file for grid # ',n,' (unit):',
     &                                                          iarem(n,ifile)
                write(iout,9002) filtmp(:istrln(filtmp))
                nfils = nfils + 1
             endif
           enddo
         enddo
      else
        do n = 1,ngrid
          nemiss_files(n) = 0
          iarem(n,1) = 0
          write(iout,9001)
     &              'Gridded Emissions file for grid # ',n,'       :'
          write(iout,9002) '   Ignored.' 
        enddo
      endif
c
c-----Open input surface model mass files for every grid 
c
      do n = 1,ngrid
        ismin(n) = 0
      enddo
      if (lsrfmod .and. lrstrt) then
        do n = 1,ngrid
          filtmp = Srfmod_Grid(n)
          write(action,'(A,I4)') 
     &                  'Opening Restart Surface Model file for grid:',n
          inquire(file=filtmp,exist=lexist)
          if( .NOT. lexist ) goto 7002
          nopen = nopen + 1
          call getunit(ismin(n))

          cname = 'AVERAGE   '
          ierr = ncf_chkfile(ismin(n),filtmp,action,cname)
          if( ierr .EQ. ISUCES ) then
             call nobinary()
             is_netcdf_sm = .FALSE.
             open(unit=ismin(n),file=filtmp,form='UNFORMATTED',
     &                                          status='OLD',ERR=7000)
          else
             is_netcdf_sm = .TRUE.
             ierr = nf_open(filtmp,NF_NOWRITE,ismin(n))
             if( ierr .NE. NF_NOERR ) goto 7000
          endif
          write(iout,9001)
     &            'Restart Surface Model file for grid # ',n,' (unit):',
     &                                                          ismin(n)
          write(iout,9002) filtmp(:istrln(filtmp))
          nfils = nfils + 1
        enddo
      endif
c
      goto 9999
c
c  --- Format statements ---
c
 9000 format(/,A,I8)
 9001 format(/,A,I2,A,I8)
 9002 format(2A)
 9003 format(3A)
c
c  --- Error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Could not open file: ',
     &                                   filtmp(:istrln(filtmp))
      write(iout,'(3A)') 'If this is a NCF file, check that its',
     &                   ' format is consistent with the NCF library',
     &                   ' used to build CAMx.'
      write(iout,'(2A)') 'The CAMx makefile supports netCDF3-Classic,',
     &                   ' and netCDF4 compressed or uncompressed'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      if( filtmp .EQ. ' ' ) then
         write(iout,'(A)') 'Blank filename provided in control file'
      else
         write(iout,'(2A)') 'Input file does not exist: ',
     &                                       filtmp(:istrln(filtmp))
      endif
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      if( filtmp .EQ. ' ' ) then
         write(iout,'(A)') 'Blank filename provided in control file'
         write(iout,'(2A)') 'If this file is for a nested grid, set',
     &                      ' the namelist variable '
         write(iout,'(5X,A,/,A)')  'Flexi_Nest = .true.',
     &                             'to ignore this file.'
      else
         write(iout,'(2A)') 'Input file does not exist: ',
     &                                       filtmp(:istrln(filtmp))
      endif
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Could not open file: ',
     &                                   filtmp(:istrln(filtmp))
      write(iout,'(10X,2A)') 'Make sure the names of restart files ',
     &                       'are for the previous simulation period.'
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'In this version the point source inventory ',
     &           'for a simulation using the SA '
      write(iout,'(2A)') 'probing tool is provided in the SA_Control ',
     &            'section of the CAMx control file.'
      write(iout,'(2A)') 'You have supplied filenames in the ',
     &                                         'CAMx_control section.'
      write(iout,'(2A)') 'Replace these filenames with blank strings ',
     &        'and include the point source files in the SA_Control section.'
      write(iout,'(2A)') 'Replace these filenames with blank strings ',
     &                                'and include the point source '
      write(iout,'(2A)') 'files in the SA_Control section.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of gridded emissions filenames.'
      write(iout,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7008 continue
      write(iout,'(//,A)') 'ERROR in OPENFILS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(1X,2A)') 'You supplied a blank filename in the middle ',
     &                  'of the list of point source filenames.'
      write(iout,'(1X,2A)') 'Check the numbering of the list of files.'
      call camxerr()
c
 7010 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(2A)') 'The chemistry flag is set but no ',
     &                         'Ozone Column file is supplied.'
      write(iout,'(2A)')'Either supply an Ozone Column file ',
     &                         'or set the Chemistry flag to false.'
      write(iout,'(2A)')'If using Mechanism 10 just supply ',
     &                  'a dummy file for the Ozone Column file.'
      call camxerr()
c
 7011 continue
      write(iout,'(//,a)') 'ERROR in OPENFILS:'
      write(iout,'(2A)') 'The Stratospheric Ozone treatment is selected',
     &                   ' but no Top Concentration file is supplied.'
      write(iout,'(2A)')'Either supply a Top Concentration file',
     &                  ' containing Ozone'
      write(iout,'(A)') 'or set the Stratospheric Ozone flag to false.'
      call camxerr()
c
 9999 continue
      return
      end

c**** RDOPTDDM
c
      subroutine rdoptddm()
      use filunit
      use grid
      use chmstry
      use procan
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the user options and flags for the
c     source apportionment algorithm.  This version is for the
c     DDM technology type, which has different options.
c
c      Copyright Ramboll
c
c     Argument description:
c           none
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/23/99   --gwilson--    Original development
c     07/19/01   --gyarwood-    Initialize ngroup, nregin, lbndry
c     10/06/04   --cemery  -    Restructured for namelist input
c     07/16/07   --bkoo--       Revised for HDDM
c     06/11/08   --bkoo--       Added rate constant sensitivity
c     07/16/08   --bkoo--       Added DDM turn-off flag
c     07/23/18   --bkoo--       Removed memory allocation for lddmcalc
c     08/09/18   --bkoo--       Added rate term sensitivity
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Local Variables:
c-----------------------------------------------------------------------
c
      character*200 strtmp
      character*10  tmpnam
      integer i, j, k1, k2, k3, n
      integer numrxn,numreac,numprod,idxrxn,idxspc
      integer, allocatable :: reactmp(:,:), prodtmp(:,:)
      real,    allocatable :: coeftmp(:,:)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- if option is turned off, just return ---
c
      if( .NOT. lddm .AND. .NOT. lhddm ) goto 9999
c
c  --- check that switches are compatible ---
c
      if( naero .GT. 0 .AND. lhddm ) then
         write(iout,'(//,a)') 'ERROR in RDOPTDDM:'
         write(iout,*) 'Cannot use HDDM with Aerosol chemistry.'
         write(iout,*)
     &   '  Turn off HDDM or use a different chemical mechanism.'
         call camxerr()
      endif
!bk      if( naero .GT. 0 ) then
!bk         write(iout,'(//,a)') 'ERROR in RDOPTDDM:'
!bk         write(iout,*) 'Cannot use DDM with Aerosol chemistry'
!bk         write(iout,*) 'in this version of CAMx.'
!bk         write(iout,*)
!bk     &   '  Turn off DDM or run a gas-only chemical mechanism.'
!bk         call camxerr()
!bk      endif
c
c   --- get the number of Initial conditions species ---
c
      nicddm =  Number_of_IC_Species_Groups
      if( nicddm .GT. 0 ) then
         do i = 1,nicddm
           icddmsp(i) = IC_Species_Groups(i)
           call toupper( icddmsp(i) )
           call jstlft( icddmsp(i) )
         enddo
      endif
c
c   --- get the number of boundary conditions species ---
c
      lbndry = .FALSE.
      nbcddm = Number_of_BC_Species_Groups
      if( nbcddm .GT. 0 ) then
         do i = 1,nbcddm
           bcddmsp(i) = BC_Species_Groups(i)
           call toupper( bcddmsp(i) )
           call jstlft( bcddmsp(i) )
         enddo
c
c   --- flag for stratifying the boundary by edge ---
c
         lbndry = DDM_Stratify_Boundary
      endif
c
c   --- get the number of Deposition conditions species ---
c
      ndepddm =  Number_of_DEP_Species_Groups
      if( ndepddm .GT. 0 ) then
         do i = 1,ndepddm
           depddmsp(i) = Dep_Species_Groups(i)
           call toupper( depddmsp(i) )
           call jstlft( depddmsp(i) )
         enddo
      endif
c
c   --- get the number of emissions species ---
c
      ngroup = 0
      nregin = 0
      nemddm = Number_of_EM_Species_Groups
      if( nemddm .GT. 0 ) then
         do i=1,nemddm
           emddmsp(i) = Emis_Species_Groups(i)
           call toupper( emddmsp(i) )
           call jstlft( emddmsp(i) )
         enddo
c
c   --- number of source regions ---
c
        nregin = DDM_Number_of_Source_Regions
        if( nregin .EQ. 0 ) then
           write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
           write(iout,'(/,1X,2A,/,A)') 'When requesting ',
     &                'emissions species for DDM you must ',
     &                'provide at least 1 emissions region.'
           call camxerr()
        endif
c
c   --- number of source emissions groupings ---
c
        ngroup = DDM_Number_of_Source_Groups
        if( ngroup .EQ. 0 ) then
           write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
           write(iout,'(/,1X,2A,/,A)') 'When requesting ',
     &                'emissions species for DDM you must ',
     &                'provide at least 1 emissions group.'
           call camxerr()
        endif
      endif
c
c   --- leftover and 3D average is always false with DDM ---
c
      leftovr_area = .FALSE.
      lsa_3davrg = .FALSE.
c
c   --- check for array overflow ---
c
      if( ngroup .GT. MXTEMF-1 ) then
         write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
         write(iout,'(/,1X,A,I4,A)') 
     &                  'Number of source groupings ',ngroup,
     &                  ' exceeds maximum.  Increase MXTEMF.'
         call camxerr()
      endif
      if( ngroup .LT. 0 ) then
         write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
         write(iout,'(1X,A,I4,A)') 
     &                  'Number of emissions groups ',ngroup,
     &                                         ' is invalid.'
         call camxerr()
      endif
c
c   --- number of timing realeases is always zero for DDM ---
c
      ntrtim = 0
c
c   --- number of rate constant sensitivity groups ---
c
      nrateddm = Number_of_Rate_Const_Groups
      allocate( rateddm(nrateddm) )
      allocate( iprate(0:nreact, nrateddm ) )
      iprate = 0
      do i = 1, nrateddm
        strtmp = ADJUSTL(Rate_Const_Groups(i))
        j = INDEX(strtmp,':')
        if (j.eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
          write(iout,'(1X,A,I3,A)')
     &        'Delimiter (:) is not found in Rate_Const_Groups(',i,').'
          call camxerr()
        endif
        rateddm(i) = strtmp(:j-1)
        do
          strtmp = strtmp(j+1:)
          j = INDEX(strtmp,',')
          if (j.eq.0) then
            j = LEN_TRIM(strtmp) + 1
            if (j.eq.1) EXIT
          endif
          iprate(0,i) = iprate(0,i) + 1
          if (iprate(0,i).gt.nreact) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &            'Too many rxns (>nreact) in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
          if ( VERIFY( TRIM( ADJUSTL( strtmp(:j-1) ) ), '1234567890' )
     &                                                    .ne. 0 ) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &                 'Invalid rxn index in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
          read(strtmp(:j-1),'(I5)') iprate(iprate(0,i),i)
          if ( iprate(iprate(0,i),i).lt.1 .or.
     &         iprate(iprate(0,i),i).gt.nreact ) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &            'Out-of-range rxn index in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
        enddo
        if (iprate(0,i).eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
          write(iout,'(1X,A,I3,A)')
     &                   'No rxn is found in Rate_Const_Groups(',i,').'
          call camxerr()
        endif
      enddo
c
c   --- number of rate term sensitivity groups ---
c
      ntermddm = Number_of_Rate_Term_Groups
      allocate( termddm(ntermddm) )
      termddm = ' '
      allocate( ipterm(0:ngas, nreact, ntermddm ) )
      ipterm = 0
      allocate( wfterm(  ngas, nreact, ntermddm ) )
      wfterm = 1.0
      allocate( reactmp(ngas,nreact) )
      allocate( prodtmp(ngas,nreact) )
      allocate( coeftmp(ngas,nreact) )
      do i = 1, ntermddm
        numrxn = 0
        reactmp = 0
        prodtmp = 0
        coeftmp = 1.0
        do n = 1, MXNAM
          strtmp = ADJUSTL(Rate_Term_Groups(i,n))
          if ( LEN_TRIM(strtmp).eq.0 ) CYCLE
          j = INDEX(strtmp,':')
          if (j.eq.0) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &          'Delimiter (:) is not found in Rate_Term_Groups(',i,').'
            call camxerr()
          endif
          if ( LEN_TRIM(termddm(i)).eq.0 ) then
            termddm(i) = strtmp(:j-1)
          else
            if ( termddm(i).ne.strtmp(:j-1) ) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A)')
     &                   'Inconsistent name of Rate_Term_Groups(',i,').'
              call camxerr()
            endif
          endif
          do
            strtmp = strtmp(j+1:)
            j = INDEX(strtmp,',')
            if (j.eq.0) then
              j = LEN_TRIM(strtmp) + 1
              if (j.eq.1) EXIT
            endif
            k1 = INDEX(strtmp(:j-1),'[R')
            k2 = INDEX(strtmp(:j-1),'[P')
            k3 = INDEX(strtmp(:j-1),']')
            if (k1+k2.eq.0 .or. k3.eq.0 .or. k3.lt.k1+k2+2) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A)')
     &                     'Invalid keyword in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            if ( VERIFY( TRIM( ADJUSTL( strtmp(:k1+k2-1) ) ),
     &                                     '1234567890' ) .ne. 0 ) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A)')
     &                   'Invalid rxn index in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            read(strtmp(:k1+k2-1),*) idxrxn
            if ( idxrxn.lt.1 .or. idxrxn.gt.nreact ) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A)')
     &              'Out-of-range rxn index in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            numrxn = numrxn + 1
            ipterm(0,idxrxn,i) = 1
            tmpnam = strtmp(k3+1:j-1)
            do idxspc = 1, ngas
              if (tmpnam.eq.spname(idxspc)) EXIT
            enddo
            if (idxspc.gt.ngas) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A,I3,A)')
     &          'Invalid spc name in rxn(',idxrxn,
     &                                   ') of Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            if (k1.gt.0) then ! Reactant
              reactmp(idxspc,idxrxn) = 1
            else              ! Product
              prodtmp(idxspc,idxrxn) = 1
            endif
            if (strtmp(k1+k2+2:k1+k2+2).eq.'#') then
              if ( k2.ne.0 ) then ! Check if a weighting factor is assigned to a product; may be allowed later
                write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
                write(iout,'(1X,A)')
     &                        'Products must not have weighting factors'
                call camxerr()
              endif
              if ( VERIFY( TRIM( ADJUSTL( strtmp(k1+k2+3:k3-1) ) ),
     &                                '1234567890.+-Ee' ) .ne. 0 ) then
                write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
                write(iout,'(1X,A,I3,A)')
     &                 'Invalid coefficient in Rate_Term_Groups(',i,').'
                call camxerr()
              endif
              read(strtmp(k1+k2+3:k3-1),*) coeftmp(idxspc,idxrxn)
            endif
          enddo
        enddo ! loop n
        if (numrxn.eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
          write(iout,'(1X,A,I3,A)')
     &                     'No rxn is found in Rate_Term_Groups(',i,').'
          call camxerr()
        endif
        do idxrxn = 1, nreact
          numreac = 0
          do idxspc = 1, ngas
            if ( reactmp(idxspc,idxrxn).eq.0 ) CYCLE
            numreac = numreac + 1
            ipterm(1+numreac,idxrxn,i) = idxspc
            wfterm(1+numreac,idxrxn,i) = coeftmp(idxspc,idxrxn)
          enddo
          ipterm(1,idxrxn,i) = numreac
          numprod = 0
          do idxspc = 1, ngas
            if ( prodtmp(idxspc,idxrxn).eq.0 ) CYCLE
            numprod = numprod + 1
            if ( 2+numreac+numprod.gt.ngas ) then
              write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
              write(iout,'(1X,A,I3,A,I3,A)')
     &          'Too many spc selected in rxn(',idxrxn,
     &                                  ') of Rate_Const_Groups(',i,').'
              call camxerr()
            endif
            ipterm(2+numreac+numprod,idxrxn,i) = idxspc
          enddo
          ipterm(2+numreac,idxrxn,i) = numprod
        enddo ! loop idxrxn
      enddo ! loop i
      deallocate( reactmp )
      deallocate( prodtmp )
      deallocate( coeftmp )
c
c   --- number of HDDM sensitivity groups ---
c
      nhddm = Number_of_HDDM_Sens_Groups
      if ( .NOT. lhddm .AND. nhddm .GT. 0 ) then
        write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
        write(iout,'(1X,A)')
     &              'Number_of_HDDM_Sens_Groups must be 0 if not HDDM.'
        call camxerr()
      endif
      allocate( hddmsp(2,nhddm) )
      do i = 1,nhddm
        do j = 1, 2
          hddmsp(j,i) = HDDM_parameters(i,j)
          call toupper( hddmsp(j,i) )
          call jstlft( hddmsp(j,i) )
          if ( hddmsp(j,i)(:4).eq.'TERM' ) then !bk_dbg=>
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A)')
     &        'Rate term sensitivity is currently limited to 1st-order.'
            call camxerr()
          endif                                 !bk_dbg<=
        enddo
      enddo
c
c   --- set DDM turn-off flags ---
c
!bk - now allocated in ALLOC_LDDMCALC
!bk      allocate( lddmcalc(ngrid) )
      do i = 1, ngrid
        lddmcalc(i) = DDM_Calc_Grid(i)
        if ( lddmcalc(i) .OR. nbcddm.EQ.0 ) CYCLE
        write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
        write(iout,'(1X,A)')
     &               'Flexi-DDM is not allowed with sensitivity to BC.'
        call camxerr()
      enddo
c
c   --- dummy array for tracer wetdep field ---
c
      allocate( ptwetfld(1) )
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine ncf_rdpthdr_rt(begtim,begdate,endtim,enddate)
      use filunit
      use ptemiss
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_RDPTHDR_RT reads the header information from the global section
c     of the NetCDF point source file. This version is for RTRAC.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         begtim  R model begin time
c         begdat  I model begin date (YYJJJ)
c         endtim  R model end time
c         enddate I model end date (YYJJJ)
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/13/19   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    begtim
      integer begdate
      real    endtim
      integer enddate
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action, fname
      character*10  pntfil, name_in, this_var
      integer       this_dimid, this_varid, ierr, tmpmap(MXSPEC), numpts
      integer       ipt, iounit, idxpt_base, itmp
c
      real, allocatable, dimension(:) :: txloc
      real, allocatable, dimension(:) :: tyloc
      real, allocatable, dimension(:) :: tstkhght
      real, allocatable, dimension(:) :: tstkdiam
      real, allocatable, dimension(:) :: tstktemp
      real, allocatable, dimension(:) :: vstktemp
      real, allocatable, dimension(:) :: iarray
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data pntfil /'PTSOURCE  '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over number of files ---
c
      iounit = iortpt(1,1)
      if( .NOT. is_netcdf_iortpt(1,1) ) goto 9999
      write(action,'(2A,I3)')  'Reading NetCDF RTRAC point source file.'
      fname = tptfil(1,1)
c
c --- get the type of file to make sure it is a point source file ---
c
      this_var = 'CAMx_NAME'
      name_in = ' '
      ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7009
      endif
      if( name_in(:8) .NE. pntfil(:8) ) goto 7001
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iounit,action,begdate,begtim,
     &                                        enddate,endtim,le1day)
c
c --- call routine to setup species mappping array ---
c
      call ncf_set_emsrt_mapping(iounit,action)
c
c --- get the number of points (used as dimension for columns) ---
c
      ierr = nf_inq_dimid(iounit, "COL", this_dimid )
      if( ierr .NE. NF_NOERR ) goto 7002
      ierr = nf_inq_dimlen(iounit,this_dimid,numpts)
      if( ierr .NE. NF_NOERR ) goto 7002
c
c  --- check that parameters are the same ---
c
      allocate( txloc(numpts) )
      allocate( tyloc(numpts) )
      allocate( tstkhght(numpts) )
      allocate( tstkdiam(numpts) )
      allocate( tstktemp(numpts) )
      allocate( vstktemp(numpts) )
      allocate( iarray(numpts) )
      this_var = "xcoord"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,txloc)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = "ycoord"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,tyloc)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = "stkheight"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,tstkhght)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = "stkdiam"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,tstkdiam)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = "stktemp"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,tstktemp)
      if( ierr .NE. NF_NOERR ) goto 7006
c
      this_var = "stkspeed"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_real(iounit,this_varid,vstktemp)
      if( ierr .NE. NF_NOERR ) goto 7006
      do ipt=1,numpts
        vstktemp(ipt) = vstktemp(ipt)/3600.
      enddo
c
c --- get pig flag ---
c
      this_var = "pigflag"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7005
      ierr = nf_get_var_int(iounit,this_varid,iarray)
      if( ierr .NE. NF_NOERR ) goto 7006
      do ipt=1,numpts
c
c  --- make sure this source is in the base inventory and flag it ---
c
            idx_point_in_list(1,1,ipt) = idxpt_base
            if( iarray(ipt) .GT. 0 ) lpigsa(idxpt_base) = .TRUE.
      enddo
      deallocate( txloc )
      deallocate( tyloc )
      deallocate( tstkhght )
      deallocate( tstkdiam )
      deallocate( tstktemp )
      deallocate( vstktemp )
      deallocate( iarray )
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get necessary global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',pntfil(:istrln(pntfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension value for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(1X,2A,/,A)') 'Point source found in Source Apportionment ',
     &               'point source file is not found ',' in the base inventory.'
      write(iout,'(1X,2A)') '   File: ',fname(:istrln(fname))
      write(iout,'(1X,A,I10)') '   Point ID: ',ipt
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7007 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'List of point sources does not match the ',
     &                                          'regular model file.'
      write(iout,'(A,I10,A)') 'Location of point source: ',ipt,
     &                                             ' does not match.'
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7008 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'PiG flag for sources in file is ',
     &                       'inconsistent with regular model file.'
      write(iout,'(A,I10,A)') 'Flag for point source: ',ipt,
     &                                             ' does not match.'
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7009 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDPTHDR_RT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine getdepth(nvar,ncols,nrows,nlays,ibgdhp,idtnow,btimhp,
     &                    timnow,iunit,height,depth)
      use filunit
c
c----CAMx v7.40 260801
c
c     GETDEPTH reads the 3D met file until to the current hour,
c     calculates layer depth, and passes back the data for OSAT calculations
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        11/06/01  Added Y2K flag
c        01/04/11  Revised for new met input format
c 
c     Input arguments: 
c        nvar                number of variables on 3D met file
c        ncols               number of columns
c        nrows               number of rows
c        nlays               number of layers
c        idtnow              current date (YYJJJ)
c        timnow              current time (HH.HH)
c        iunit               height/pressure file unit number
c             
c     Output arguments: 
c        ibgdhp              date from height/pressure file (YYJJJ)
c        btimhp              time from height/pressure file (HH.HH) 
c        height              array of gridded layer heights (m)
c        depth               array of gridded layer depths (m)
c             
c     Routines Called: 
c        None
c             
c     Called by: 
c        RDSUMBC
c
      implicit none
      include "camx.prm"
c
      integer nvar,ncols,nrows,nlays,ibgdhp,idtnow,iunit
      real btimhp,timnow
      real height(ncols,nrows,nlays),depth(ncols,nrows,nlays)
c
      character*4 namvar(10)
      character*10 namevar
      integer idum,n,k,i,j,m
      real arr3d(MXCELLS,MXCELLS,MXLAYER)
      logical lfound
c
c-----Read Height pressure file to current time/date
c
  333 continue
      if( (ibgdhp .EQ. idtnow .AND. btimhp .LT. timnow) .OR.
     &     ibgdhp .LT. idtnow ) then
         lfound = .false.
         read(iunit,end=7001,err=7001) ibgdhp,btimhp
         do n = 1,nvar
           do k = 1,nlays
             read(iunit,ERR=7001) idum,(namvar(m),m=1,10),
     &                            ((arr3d(i,j,k),i=1,ncols),j=1,nrows)
           enddo
           write(namevar,'(10a1)') (namvar(m),m=1,10)
           if (namevar.eq.'ZGRID_M') then
             lfound = .true.
             do k = 1,nlays
               do j = 1,nrows
                 do i = 1,ncols
                   height(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
         enddo
         if( idtnow .EQ. ibgdhp .AND. btimhp .LT. timnow ) goto 333
         if( ibgdhp .LT. idtnow ) goto 333
c
c-----Calculate the depths from the heights
c
         if (.not.lfound) goto 7002
         do k = 1,nlays
           do j = 1,nrows
             do i = 1,ncols
               depth(i,j,k) = height(i,j,k)
               if( k .GT. 1 ) 
     &            depth(i,j,k) = height(i,j,k) - height(i,j,k-1)
             enddo
           enddo
         enddo
      endif
c
      return
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in GETDEPTH:'
      write(iout,'(/,1X,A)') 'Reading 3D Met file'
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in GETDEPTH:'
      write(iout,'(/,1X,A)') 'Did not find ZGRID_M in 3D met file'
      call camxerr()
      end

c
c-----------------------------------------------------------------------
c    BEGIN subroutine tstep_init:
c-----------------------------------------------------------------------
c
      subroutine tstep_init(inptim,inpdate,endtim,enddate,nsteps,
     &                      numprocs,iproc_id)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use filunit
      use grid
      use chmstry
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use ptemiss
      use procan
      use rtracchm
      use rtcmcchm
      use tracer
      use master_mod
      use node_mod
c
      implicit none
c  
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine updates all of the met fields at the update time-step.
c    It is called when any of the input fields need to be updated
c    (usually every hour), and reads ICs if this is the start of the run.
c    It calls the routines responsible for reading the appropriate files
c    and then passes the information to the slices for MPI.
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       CAMX
c    Subroutines called:
c       READINP
c       INTRPDAT
c       DRVTUV
c       FLUSH
c       READCNC
c       WRTMASS
c       MASSUM
c       RDICRT
c       NCF_RDICRT
c       INTRPCNC
c       CVTICRT
c       FILAQSA
c       RDICDDM
c       NCF_RDICDDM
c       CVTICDDM
c       INITIPR
c       NODE_RECV_1SPECIES_DATA
c       MASTER_SEND_1SPECIES_DATA
c       TIMESTEP
c       MPI_BARRIER
c       NODES_MET
c       NEWGRID
c       KHORZ
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       10/29/09 -cemery- Added RTRAC surface model
c        7/14/10       Added code for in-line TUV cloud adjustment
c       03/29/11       Support in-line TUV with aerosol optical depth
c       04/02/12       Removed RADM cloud adjustment option, cloud/aerosol
c                      adjustments now always done with in-line TUV
c       05/14/13       Added surface model
c       08/11/14       Albedo now includes effects of snow
c       09/02/14       Added subgrid convective model
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
      include 'rtracsrf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    :: inptim,endtim
c
      integer :: inpdate,enddate
      integer :: nsteps
      integer :: numprocs
      integer :: iproc_id
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: igrd
      integer :: l
      integer :: ip
      integer :: ic
      integer :: ig
      integer :: ierr
      integer :: ilay
      integer :: ispc
c
      real    :: whr
      real    :: wmn
c
      character*8  :: chtime
      character*8  :: chdate
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (iproc_id .EQ. 0) then 
         write(*,'(a20,$)') 'readinp ......'
         do igrd = 1,ngrid
            if( is_netcdf_i3dmet(igrd) ) then
                call ncf_readinp_2d(igrd,ncol(igrd),nrow(igrd),
     &                   tsurf(iptr2d(igrd)),pspt(iptr2d(igrd)),
     &                   tsnxt(iptr2d(igrd)),snow(iptr2d(igrd)),
     &                   snowage(iptr2d(igrd)),snowrat(iptr2d(igrd)))
                call ncf_readinp_3d(igrd,ncol(igrd),
     &                        nrow(igrd),nlay(igrd),
     &                        height(iptr3d(igrd)),phpt(iptr3d(igrd)),
     &                        hnxt(iptr3d(igrd)),press(iptr3d(igrd)),
     &                        pppt(iptr3d(igrd)),pnxt(iptr3d(igrd)),
     &                        windu(iptr3d(igrd)),pupt(iptr3d(igrd)),
     &                        unxt(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                        pvpt(iptr3d(igrd)),vnxt(iptr3d(igrd)),
     &                        tempk(iptr3d(igrd)),ptpt(iptr3d(igrd)),
     &                        tnxt(iptr3d(igrd)),water(iptr3d(igrd)),
     &                        pwpt(iptr3d(igrd)),wnxt(iptr3d(igrd)))
                call ncf_readinp_cld(igrd,ncol(igrd),
     &                        nrow(igrd),nlay(igrd),
     &                        cwc(iptr3d(igrd)),pwr(iptr3d(igrd)),
     &                        pws(iptr3d(igrd)),pwg(iptr3d(igrd)),
     &                        cod(iptr3d(igrd)),cph(iptr3d(igrd)),
     &                        cigfrc(iptr2d(igrd)),cigtim(iptr2d(igrd)),
     &                        cigwtr(iptr3d(igrd)),cigpcp(iptr3d(igrd)),
     &                        cigent(iptr3d(igrd)),cigdet(iptr3d(igrd)))
                call ncf_readinp_kv(igrd,ncol(igrd),
     &                        nrow(igrd),nlay(igrd),
     &                        rkv(iptr3d(igrd)),pkpt(iptr3d(igrd)),
     &                        knxt(iptr3d(igrd)) )
            else
                call readinp(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &                   height(iptr3d(igrd)),phpt(iptr3d(igrd)),
     &                   hnxt(iptr3d(igrd)),
     &                   press(iptr3d(igrd)),pppt(iptr3d(igrd)),
     &                   pnxt(iptr3d(igrd)),
     &                   windu(iptr3d(igrd)),pupt(iptr3d(igrd)),
     &                   unxt(iptr3d(igrd)),
     &                   windv(iptr3d(igrd)),pvpt(iptr3d(igrd)),
     &                   vnxt(iptr3d(igrd)),
     &                   tsurf(iptr2d(igrd)),pspt(iptr2d(igrd)),
     &                   tsnxt(iptr2d(igrd)),
     &                   tempk(iptr3d(igrd)),ptpt(iptr3d(igrd)),
     &                   tnxt(iptr3d(igrd)),
     &                   water(iptr3d(igrd)),pwpt(iptr3d(igrd)),
     &                   wnxt(iptr3d(igrd)),
     &                   rkv(iptr3d(igrd)),pkpt(iptr3d(igrd)),
     &                   knxt(iptr3d(igrd)),
     &                   cwc(iptr3d(igrd)),
     &                   pwr(iptr3d(igrd)),pws(iptr3d(igrd)),
     &                   pwg(iptr3d(igrd)),cod(iptr3d(igrd)),
     &                   cph(iptr3d(igrd)),snow(iptr2d(igrd)),
     &                   snowage(iptr2d(igrd)),snowrat(iptr2d(igrd)),
     &                   cigfrc(iptr2d(igrd)),cigtim(iptr2d(igrd)),
     &                   cigwtr(iptr3d(igrd)),cigpcp(iptr3d(igrd)),
     &                   cigent(iptr3d(igrd)),cigdet(iptr3d(igrd)))
            endif
         enddo
c
c  --- Estimate those fields that were not read ---
c
         call intrpdat()
c
c-----Calculate surface albedo fields
c
         do igrd = 1,ngrid
           call getalbedo(igrd,ncol(igrd),nrow(igrd),snow(iptr2d(igrd)),
     &                    snowage(iptr2d(igrd)),tsurf(iptr2d(igrd)),
     &                    fsurf(iptrlu(igrd)),albedo(iptr2d(igrd)),
     &                    snowfrc(iptr2d(igrd)),snowalb(iptr2d(igrd)))
         enddo
c
         write(*,'(a)') '   Done'
         call flush(6)
c
c  --- Increment next met read time/date
c
         whr = aint(inptim/100.)
         wmn = amod(inptim,100.)
         inptim = 100.*(whr + aint((wmn + dtinp)/60.)) + amod((wmn+dtinp),60.)
         if (inptim .GE. 2400.) then
            inptim = inptim - 2400.
            inpdate = inpdate + 1
            if (MOD(inpdate,1000) .GT. 365) then
               if (MOD(INT(inpdate/1000),4) .EQ. 0) then
                  if (MOD(inpdate,1000) .EQ. 367)
     &               inpdate = (INT(inpdate/1000)+1)*1000 + 1
               else
                  inpdate = (INT(inpdate/1000)+1)*1000 + 1
               endif
            endif
         endif
c
      endif
c
c  --- Initialize concentrations from an AIRQUALITY file or RESTART files ---
c
      if (nsteps .EQ. 1) then
         if (iproc_id .EQ. 0) then
            if( .NOT. lrstrt .AND. is_netcdf_iic ) then
               call ncf_readcnc()
            else
               call readcnc()
            endif
            do igrd = 1,ngrid
               call wrtmass(igrd,chdate,chtime,0)
               call massum(ncol(igrd),nrow(igrd),nlay(igrd),0,0,
     &                     2,ncol(igrd)-1,2,nrow(igrd)-1,15,
     &                     igrd,nspec,ncol(igrd),nrow(igrd),
     &                     nlay(igrd),deltax(1,igrd),deltay(igrd),
     &                     depth(iptr3d(igrd)),mapscl(iptr2d(igrd)),
     &                     conc(iptr4d(igrd)),xmass0(1,igrd)        )
               do l = 1,nspec
                  xmsold(l,igrd) = xmass0(l,igrd)
               enddo
            enddo
c
c --- Initialize surface model mass fields
c
            if (lsrfmod) then
              do igrd = 1,ngrid
                call rdsrfmod(igrd,ncol(igrd),nrow(igrd),nsmspc,
     &                        endtim,enddate,solmas(iptrsm(igrd)),
     &                        vegmas(iptrsm(igrd)))
              enddo 
              if (lrstrt) then
                do ip = 1,ngrid
                  do ic = 1,nchdrn(ip)
                    ig = idchdrn(ic,ip)
                    if( ismin(ig) .EQ. 0 ) then
                      write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                    'Assigning srf mass from parent grid at ',
     &                    begtim,begdate,' grid',ig
                      call rassgn4d(ncol(ip),nrow(ip),1,nsmspc,i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),1,
     &                      solmas(iptrsm(ip)),solmas(iptrsm(ig)) )
                      call rassgn4d(ncol(ip),nrow(ip),1,nsmspc,i1(ig),
     &                      j1(ig),nmesh(ig),ncol(ig),nrow(ig),1,
     &                      vegmas(iptrsm(ip)),vegmas(iptrsm(ig)) )
                    endif
                  enddo
                enddo
              endif
            endif
c
c======================== Source Apportion Begin =======================
c
c  --- if this is not a restart, call routine to fill the initial
c      conditions arrays for the tracers ---
c
            if (ltrace .AND. .NOT. lrstrt) then
               if (tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                  call rdicrt(ncol(1),nrow(1),nlay(1),ntotsp,ptconc(1))
                  call ncf_rdicrt(ncol(1),nrow(1),nlay(1),ntotsp,ptconc(1))
c
c  --- interpolate initial conditions to nests ---
c
                  if (ngrid.gt.1) then
                     do ip = 1,ngrid
                        do ic = 1,nchdrn(ip)
                           ig = idchdrn(ic,ip)
                           call intrpcnc(ntotsp,ncol(ip),nrow(ip),
     &                                   nlay(ip),i1(ig),j1(ig),nmesh(ig),
     &                                   ncol(ig),nrow(ig),nlay(ig),
     &                                   ptconc(ipsa3d(ip)),
     &                                   ptconc(ipsa3d(ig)) )
                        enddo
                     enddo
                  endif
c
c --- call routine to convert IC to ug/m ---
c
                  do igrd=1,ngrid
                     call cvticrt(igrd,ncol(igrd),nrow(igrd),
     &                            nlay(igrd),ntotsp,ptconc(ipsa3d(igrd)),
     &                            tempk(iptr3d(igrd)),press(iptr3d(igrd)))
                  enddo
               else
                  if( lsa_ioric ) then
                     if( is_netcdf_ioric ) then
                        call ncf_rd_sa_icfile()
                     else
                        call rd_sa_icfile()
                     endif
                  else
                     do igrd = 1,ngrid
                       call filaqsa(ncol(igrd),nrow(igrd),
     &                            nlay(igrd),nspec,ntotsp,
     &                            conc(iptr4d(igrd)),ptconc(ipsa3d(igrd)) )
                     enddo
                  endif
               endif
            endif
            if (ltrace .AND. tectyp .EQ. RTRAC .AND. lsrfmodrt) then
               do igrd = 1,ngrid
                  call rdsrfrt(igrd,ncol(igrd),nrow(igrd),ntotsp,
     &                         rtsolmas(ipsa2d(igrd)),
     &                         rtvegmas(ipsa2d(igrd)))
               enddo
            endif
c
c========================= Source Apportion End ========================
c
c============================= DDM Begin ===============================
c
c  --- call routine to read the IC file for DDM ---
c
            if((lddm.OR.lhddm) .AND. .NOT.lrstrt .AND. nicddm.GT.0) then
               call rdicddm(ncol(1),nrow(1),nlay(1),ntotsp,ptconc(1))
               call ncf_rdicddm(ncol(1),nrow(1),nlay(1),ntotsp,ptconc(1))
c
c  --- interpolate initial conditions to nests ---
c 
               if (ngrid.gt.1) then
                  do ip = 1,ngrid
                     do ic = 1,nchdrn(ip)
                        ig = idchdrn(ic,ip)
                        call intrpcnc(ntotsp,ncol(ip),nrow(ip),
     &                                nlay(ip),i1(ig),j1(ig),nmesh(ig),
     &                                ncol(ig),nrow(ig),nlay(ig),
     &                                ptconc(ipsa3d(ip)),
     &                                ptconc(ipsa3d(ig))               )
                     enddo
                  enddo
               endif
c
c --- call routine to convert IC to ug/m ----
c
               do igrd=1,ngrid
                  call cvticddm(igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &                          ntotsp,lsagas,ptconc(ipsa3d(igrd)),
     &                          tempk(iptr3d(igrd)),press(iptr3d(igrd)) )
               enddo
            endif
c
c============================= DDM End =================================
c
c========================= Process Analysis Begin ======================
c
            if (lipr .OR. lirr) then
               if (.NOT. lcpacum) call pazero()
               if (lipr) then
                  do igrd = 1,ngrid
                     call initipr(.TRUE.,iproc_id,igrd,nspec,ncol(igrd),
     &                                     nrow(igrd),nlay(igrd),
     &                                              conc(iptr4d(igrd)))
                  enddo
               endif
            endif
c
c========================= Process Analysis End ========================
c
         endif
c
c  --- send initial field to compute nodes ---
c
         if (lmpi) then
            do igrd=1,ngrid
               do ilay=1,nlay(igrd)
                  do ispc=1,nspec
                     if (iproc_id .gt. 0) then
                        call node_recv_1species_data(conc(iptr4d(igrd)),
     &                       igrd,nlay(igrd),ilay,nspec,ispc,itag       )
                     else
                        call master_send_1species_data(conc(iptr4d(igrd)),
     &                                                 igrd,nlay(igrd),ilay,
     &                                                 nspec,ispc,itag      )
                     endif
                     itag = itag+1
                  enddo
               enddo
            enddo
c
c========================= Probing Tools Begin ======================
c
c
c   --- pass the initial concentrations for probing tools ---
c
             if( ltrace .OR. lddm .OR. lhddm .OR. lirr ) then
                do igrd=1,ngrid
                   do ilay=1,nlay(igrd)
                      do ispc=1,ntotsp
                         if( iproc_id .GT. 0 ) then
                           call node_recv_1species_data  (ptconc(ipsa3d(igrd)),
     &                           igrd, nlay(igrd), ilay, ntotsp, ispc, itag)
                         else
                           call master_send_1species_data (ptconc(ipsa3d(igrd)),
     &                           igrd, nlay(igrd), ilay, ntotsp, ispc, itag)
                         endif
                         itag=itag+1
                      enddo
                   enddo
                enddo
             endif
         endif
c
c========================= Probing Tools End ========================
c
      endif
c
c  --- Calculate timestep ---
c
      if (iproc_id .EQ. 0) then
         write(*,'(a20,$)') 'timestep ......'
         call timestep()
         write(*,'(a)') '   Done'
         call flush(6)
      endif
c
c========================= Process Analysis Begin ========================
c
c  --- update the process analysis data ---
c
      if(  iproc_id .GT. 0 .AND. (lipr .OR. lirr) ) then
          if( .NOT. lcpacum ) call pazero()
          if( lipr ) then
              do igrd = 1,ngrid
                 call initipr(.TRUE.,iproc_id,igrd,nspec,mmxp(igrd),
     &                         mmyp(igrd),nlay(igrd),conc(iptr4d(igrd)))
              enddo
           endif
      endif
c
c========================= Process Analysis End ========================
c
c --- force the nodes to wait for the master ---
c
      if (lmpi) then
         call MPI_Barrier(MPI_COMM_WORLD, ierr)
         call nodes_met(numprocs,iproc_id)
      endif
c
      if (.NOT. lmpi .OR. iproc_id .GT. 0) then
c
c  --- calculate the initial mass on the slices ---
c
         if (nsteps .EQ. 1) then
            do igrd=1,ngrid
               if( iproc_id .GT. 0 ) then
                  call massum(mmxp(igrd),mmyp(igrd),mmzp(igrd),mi0(igrd),
     &                     mj0(igrd),mia(igrd),miz(igrd),mja(igrd),
     &                     mjz(igrd),mibcon(igrd),igrd,nspec,ncol(igrd),
     &                     nrow(igrd),nlay(igrd),deltax(1,igrd),
     &                     deltay(igrd),depth(iptr3d(igrd)),
     &                     mapscl(iptr2d(igrd)),conc(iptr4d(igrd)),
     &                     xmass0(1,igrd))
                  do l = 1,nspec
                     xmsold(l,igrd) = xmass0(l,igrd)
                     xmass(l,igrd) = xmass0(l,igrd)
                  enddo
               endif
            enddo
         endif
c
c-----Calculate horizontal diffusion coefficients
c
         if (iproc_id .LE. 1) write(*,'(a20,$)') 'khorz ......'
         do igrd = 1,ngrid
            call newgrid(igrd)
            call khorz(igrd,mmxp(igrd),mmyp(igrd),
     &                 nlay(igrd),nrow(igrd),j0,
     &                 deltax(1,igrd),deltay(igrd),deltat(igrd),
     &                 windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                 idfin(iptr2d(igrd)),rkx(iptr3d(igrd)),
     &                 rky(iptr3d(igrd))                        )
         enddo
         if (iproc_id .LE. 1) write(*,'(a)') '   Done'
         call flush(6)
c
c-----Calculate subgrid convective transport matrices
c
         if (iproc_id .LE. 1) write(*,'(a20,$)') 'convtrans ......'
         do igrd = 1,ngrid
            if (lcig(igrd)) then
             call convtrans(igrd,dtinp,mmxp(igrd),mmyp(igrd),nlay(igrd),
     &                       deltat(igrd),idfin(iptr2d(igrd)),
     &                       depth(iptr3d(igrd)),press(iptr3d(igrd)),
     &                       tempk(iptr3d(igrd)),cigfrc(iptr2d(igrd)),
     &                       cigtim(iptr2d(igrd)),cigent(iptr3d(igrd)),
     &                       cigdet(iptr3d(igrd)),cigmas(iptrcig(igrd)))
            endif
         enddo
         if (iproc_id .LE. 1) write(*,'(a)') '   Done'
         call flush(6)
      endif
c
      end
c
c-----------------------------------------------------------------------
c    END subroutine tstep_init:
c-----------------------------------------------------------------------
c

      subroutine convtrans(igrid,dtinp,ncol,nrow,nlay,deltat,idfin,
     &                     depth,press,temp,cigfrc,cigtim,cigent,cigdet,
     &                     cigmas)
      use filunit
c
c----CAMx v7.40 260801
c
c     CONVTRANS integrates cloud-in-grid mass transport matrices based on input
c     K-F entrainment/detrainment fluxes.  Assuming a steady-state sub-grid
c     cloud environment, these CiG matrices are calculated for each convective
c     column over an entire grid for the duration of the column-specific
c     convective time scale and then used in CIGDRIVE for all timesteps between
c     the meteorological update times (usually 1 hour).
c
c      Copyright Ramboll
c
c     Modifications:
c        None
c
c     Input arguments:
c        igrid               grid index
c        dtinp               met input frequency (min)
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        deltat              time step (s)
c        idfin               map of nested grids in this grid
c        depth               layer depth field (m)
c        press               pressure field (mb)
c        temp                temperature field (K)
c        cigfrc              CiG cloud fraction field
c        cigtim              CiG cloud timescale (s)
c        cigent              CiG sub-grid cloud entrainment rate (kg/m2/s)
c        cigdet              CiG sub-grid cloud detrainment rate (kg/m2/s)
c
c     Output arguments:
c        cigmas              CiG transport matrix (unitless)
c
c     Routines called:
c        None
c
c     Called by:
c        TSTEP_INIT
c
      implicit none
      include "camx.prm"

      integer igrid,ncol,nrow,nlay
      integer idfin(ncol,nrow)
      real deltat,dtinp
      real depth(ncol,nrow,nlay)
      real press(ncol,nrow,nlay)
      real temp(ncol,nrow,nlay)
      real cigfrc(ncol,nrow)
      real cigtim(ncol,nrow)
      real cigent(ncol,nrow,nlay)
      real cigdet(ncol,nrow,nlay)
      real cigmas(2,nlay,nlay,ncol,nrow)

      integer i,j,k,kk,l,n,ntimes,ks,ke
      real timescale,dt,dcflx,daflx
      real fm,fp,crat
      real tmassi,tmassf,terr
      real dz(MXLAYER)
      real rho(MXLAYER)
      real entc(MXLAYER),detc(MXLAYER)
      real enta(MXLAYER),deta(MXLAYER)
      real cflx(MXLAYER),aflx(MXLAYER)
      real aatrac(MXLAYER,MXLAYER),actrac(MXLAYER,MXLAYER)
      real cctrac(MXLAYER,MXLAYER),catrac(MXLAYER,MXLAYER)
      real aanew(MXLAYER,MXLAYER),acnew(MXLAYER,MXLAYER)
      real ccnew(MXLAYER,MXLAYER),canew(MXLAYER,MXLAYER)
c
c-----Entry point
c
      do j = 1,nrow
        do i = 1,ncol
          do l = 1,nlay
            do k = 1,nlay
              do n = 1,2
                cigmas(n,k,l,i,j) = 0.
              enddo
            enddo
          enddo
        enddo
      enddo
c
c-----Loop over vertical grid columns, skipping any covered by a nest or 
c     without active sub-grid convection
c
      do 20 j = 2,nrow-1
        do 10 i = 2,ncol-1
          if (idfin(i,j).gt.igrid) goto 10
          if (cigfrc(i,j).eq.0. .or. cigtim(i,j).eq.0.) goto 10
c
c-----Set hydrostatic density profiles (kg/m3) and entrainment/detrainment
c     rates (kg/m2/s)
c
          timescale = min(cigtim(i,j),60.*dtinp)
          crat  = cigfrc(i,j)/(1. - cigfrc(i,j))
          do k = 1,nlay
            dz(k) = depth(i,j,k)
            rho(k) = 100.*press(i,j,k)/(287.*temp(i,j,k))
            entc(k) = cigent(i,j,k)
            detc(k) = cigdet(i,j,k)
            enta(k) = entc(k)*crat
            deta(k) = detc(k)*crat
          enddo
c
c-----Calculate in-cloud and ambient net vertical fluxes (kg/m2/s)
c
          cflx(1) = entc(1) - detc(1)
          aflx(1) = deta(1) - enta(1)
          do k = 2,nlay
            cflx(k) = cflx(k-1) + entc(k) - detc(k)
            aflx(k) = aflx(k-1) - enta(k) + deta(k)
          enddo
c
c-----Initialize tracer matrix
c
          do l = 1,nlay
            do k = 1,nlay
              cctrac(k,l) = 0.
              aatrac(k,l) = 0.
              catrac(k,l) = 0.
              actrac(k,l) = 0.
            enddo
            cctrac(l,l) = 1.
            aatrac(l,l) = 1.
          enddo
c
c-----Check time step, determine integration step for first-order upstream
c     transport technique
c
          dt = timescale
 100      continue
          do k = 1,nlay
            dcflx = cflx(k)
            daflx = aflx(k)
            if (k.gt.1) then
              dcflx = max(abs(cflx(k-1)),abs(cflx(k)))
              daflx = max(abs(aflx(k-1)),abs(aflx(k)))
            endif
            if ((dcflx + detc(k))*dt/dz(k).gt.rho(k)/2. .or.
     &          (daflx + enta(k))*dt/dz(k).gt.rho(k)/2.) then
              dt = dt/2.
              goto 100
            endif
          enddo
c
c-----Loop for the duration of the input timestep
c
          ntimes = nint(timescale/dt)
          dt = timescale/float(ntimes)
          do n = 1,ntimes
c
c-----Cloud tracer change
c
          do l = 1,nlay
            do k = 1,nlay
              if (k.eq.1) then
                dcflx = -cflx(k)*cctrac(k,l)
                if (cflx(k).lt.0.) dcflx = -cflx(k)*cctrac(k+1,l)
              else
                fm = cflx(k-1)*cctrac(k-1,l)
                if (cflx(k-1).lt.0.) fm = cflx(k-1)*cctrac(k,l)
                fp = cflx(k)*cctrac(k,l)
                if (cflx(k).lt.0.) then
                  fp = 0.
                  if (k.lt.nlay) fp = cflx(k)*cctrac(k+1,l)
                endif
                dcflx = fm - fp
              endif
              ccnew(k,l) = cctrac(k,l) + (dt/dz(k))*(1./rho(k))*
     &          (dcflx + entc(k)*catrac(k,l)*crat - detc(k)*cctrac(k,l))

              if (k.eq.1) then
                daflx = -aflx(k)*catrac(k,l)
                if (aflx(k).lt.0.) daflx = -aflx(k)*catrac(k+1,l)
              else
                fm = aflx(k-1)*catrac(k-1,l)
                if (aflx(k-1).lt.0.) fm = aflx(k-1)*catrac(k,l)
                fp = aflx(k)*catrac(k,l)
                if (aflx(k).lt.0.) then
                  fp = 0.
                  if (k.lt.nlay) fp = aflx(k)*catrac(k+1,l)
                endif
                daflx = fm - fp
              endif
              canew(k,l) = catrac(k,l) + (dt/dz(k))*(1./rho(k))*
     &          (daflx - enta(k)*catrac(k,l) + deta(k)*cctrac(k,l)/crat)
            enddo
            do k = 1,nlay
              cctrac(k,l) = ccnew(k,l)
              catrac(k,l) = canew(k,l)
            enddo
          enddo
c
c-----Ambient tracer change
c
          do l = 1,nlay
            do k = 1,nlay
              if (k.eq.1) then
                daflx = -aflx(k)*aatrac(k,l)
                if (aflx(k).lt.0.) daflx = -aflx(k)*aatrac(k+1,l)
              else
                fm = aflx(k-1)*aatrac(k-1,l)
                if (aflx(k-1).lt.0.) fm = aflx(k-1)*aatrac(k,l)
                fp = aflx(k)*aatrac(k,l)
                if (aflx(k).lt.0.) then
                  fp = 0.
                  if (k.lt.nlay) fp = aflx(k)*aatrac(k+1,l)
                endif
                daflx = fm - fp
              endif
              aanew(k,l) = aatrac(k,l) + (dt/dz(k))*(1./rho(k))*
     &         (daflx - enta(k)*aatrac(k,l) + deta(k)*actrac(k,l)/crat)

              if (k.eq.1) then
                dcflx = -cflx(k)*actrac(k,l)
                if (cflx(k).lt.0.) dcflx = -cflx(k)*actrac(k+1,l)
              else
                fm = cflx(k-1)*actrac(k-1,l)
                if (cflx(k-1).lt.0.) fm = cflx(k-1)*actrac(k,l)
                fp = cflx(k)*actrac(k,l)
                if (cflx(k).lt.0.) then
                  fp = 0.
                  if (k.lt.nlay) fp = cflx(k)*actrac(k+1,l)
                endif
                dcflx = fm - fp
              endif
              acnew(k,l) = actrac(k,l) + (dt/dz(k))*(1./rho(k))*
     &          (dcflx + entc(k)*aatrac(k,l)*crat - detc(k)*actrac(k,l))
            enddo
            do k = 1,nlay
              aatrac(k,l) = aanew(k,l)
              actrac(k,l) = acnew(k,l)
            enddo
          enddo

          enddo  ! End time loop
c
c-----Load CiG transport matrix array
c
          do ks = 1,nlay    !Starting layer
            do ke = 1,nlay  !Ending layer
              cigmas(1,ke,ks,i,j) = cctrac(ke,ks) + actrac(ke,ks)/crat
              cigmas(2,ke,ks,i,j) = aatrac(ke,ks) + catrac(ke,ks)*crat
            enddo
          enddo
c
c-----Check that transport matrices conserve mass
c
          do ks = 1,nlay
            tmassi = rho(ks)*dz(ks)
            tmassf = 0.
            do ke = 1,nlay
              if (cigmas(1,ke,ks,i,j).lt.0. .or.
     &            cigmas(2,ke,ks,i,j).lt.0.) then
                write(iout,'(//,a)') 'ERROR in CONVTRANS:'
                write(iout,'(2a)') 'Negative tracer after',
     &                             ' convective transport'
                write(iout,*) 'igrid, i, j, ks, ke = ',igrid,i,j,ks,ke
                write(iout,*) 'Spec  Name   In-cloud  Ambient'
                do kk = 1,nlay
                  write(iout,'(2i3,2e10.3)')
     &                   ks,kk,cigmas(1,kk,ks,i,j),cigmas(2,kk,ks,i,j)
                enddo
                call camxerr()
              endif
              tmassf = tmassf + rho(ke)*dz(ke)*
     &                 (cigmas(1,ke,ks,i,j)*cigfrc(i,j) +
     &                  cigmas(2,ke,ks,i,j)*(1.-cigfrc(i,j)))
            enddo
            terr = abs(tmassf - tmassi)/tmassi
            if (terr.gt.0.001) then
              write(iout,'(//,a)')'ERROR in CONVTRANS:'
              write(iout,*)'CiG transport matrix not conserving mass'
              write(iout,*)'Grid,I,J,K          : ',igrid,i,j,ks
              write(iout,*)'Starting/ending mass: ',tmassi,tmassf
              call camxerr()
            endif
          enddo
c
 10     continue
 20   continue

      return
      end

c**** NCF_TOPPREP
c
      subroutine ncf_topprep(begtim,begdate,endtim,enddate)
      use chmstry
      use bndary
      use grid
      use filunit
      implicit none
c 
c----CAMx v7.40 260801
c 
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_TOPPREP reads the boundary conditions NETCDF file and checks
c     the global varibles for consistency with user defined values.
c     It also prepares mapping variables that map the TC species list
c     to the internal CAMx species list
c                           
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         begtim  R model begin time
c         begdat  I model begin date (YYJJJ)
c         endtim  R model end time
c         enddate I model end date (YYJJJ)
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
      include 'soap.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    begtim
      integer begdate
      real    endtim
      integer enddate
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  tcfil, name_in, this_var
      integer       ierr, i, j, n, itmp
c
c-----------------------------------------------------------------------
c    Data Statements:
c-----------------------------------------------------------------------
c
      data tcfil /'TOPCONC   '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- set the string for error messages ---
c
      action = 'Reading the NetCDF top boundary conditions file.'
c
c --- get the type of file to make sure it is a boundary file ---
c
      this_var = 'CAMx_NAME'
      ierr = nf_get_att_text(itc, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(itc, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7002
      endif
      if( name_in(:7) .NE. tcfil(:7) ) goto 7001
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(itc,action,1,.FALSE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sire file spans the episode ---
c
      call ncf_chk_tstep(itc,action,begdate,begtim,enddate,endtim,.FALSE.)
c
c --- call routine to setup species mappping array ---
c
      call ncf_set_species_mapping(itc,action,spname,nspec,ntcspc,ltcmap)
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_BNDPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get necessary global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_BNDPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',tcfil(:istrln(tcfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_BNDPREP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine nodes_init(numprocs,iproc_id)
      use grid
      use chmstry
      use filunit
      use o3colmap
      use bndary
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use rtcmcchm
      use tracer
      use node_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c     This routine initializes all of the data for the compute
c     nodes when running in MPI mode.  All of the I/O is
c     handled by the master process (ID = 0). All other processes
c     will do computation but need to have data structures 
c     allocated and filled through message passing from the
c     master node.
c     
c      Copyright Ramboll
c
c     Modifications:
c       12/15/08    Added code to handle averaging of radicals
c       03/15/09    Added code for deposition output for tracers
c       10/29/09    Added code for RTRAC surface model
c       11/4/09     Removed input top concentrations
c       01/04/11    Revised for new met input format
c       11/06/12    Fixed Wall of Cells receptors for MPI
c       11/06/12    Pass receptor information for RTRAC
c       04/30/13    Added surface model
c       05/24/13    Pass RTCMC photolysis/dep pointers
c       09/02/14    Added subgrid convective model
c       12/07/14    Added VBS parameters
c       01/08/16    Updated for Revised VBS & Removal of IEH solver
c       03/01/15    Added partial source area map
c       08/25/16    Updated for new SOAP
c       09/02/16    Renamed pointers to het rxns (-> ihetrxn)
c       09/16/16    Added WTMOL & pointers for in-cloud SOA species
c       10/16/17    Added sfacJSOA; removed LSOAP2
c       07/23/18    Added Bi-Di NH3 drydep flag
c                   Added npartial
c       08/09/18    Added variables for rate term sensitivity
c       07/23/19    Staggered wind flag is now grid-specific
c       11/17/20    RTCMC dry/wet deposition is now consistent with
c                   RTRAC
c
c     Input arguments:
c        numprocs            the number of processes
c        iproc_id            process number for current process
c
c     Output arguments:
c        none
c
c     Routines called:
c     
c     Called by:
c        CAMx
c
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
      include 'camx_aero.inc'
      include 'soap.inc'
      include 'vbs.inc'
      include 'ddmchm.inc'
      include 'rtracsrf.inc'
      include 'soap3.inc'
      include 'mpif.h'
c
c----Argument declarations
c
      integer numprocs
      integer iproc_id
c     
c-----Local variables
c
      integer ncola, nrowa, nlaya, igrd, ispc, ilay, ierr, i
      integer nfilcnt, mvec2d, mvec3d, max_emissfiles, max_ptfiles
c     
c-----Entry point
c
      if( .NOT. lmpi .AND. iproc_id .GT. 0 ) return
c
c   --- calculate the number of bytes to send ---
c
      nrowa = maxval(nrow(1:ngrid) )
      ncola = maxval(ncol(1:ngrid) )
      nlaya = maxval(nlay(1:ngrid) )
c
c  --- find the number of output files --
c
      nfilcnt = 1
      if( ngrid .GT. 1 ) nfilcnt = 2
c
c  --- send the other variables in the filunit include file ---
c
      call nodes_pass(icur_unit,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(imass,    1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iconc,    nfilcnt,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ifconc,   nfilcnt,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipig,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ichem,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iphot,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iic,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iic,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ibc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_ibc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(itc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_itc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(io3col,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iptem,npoint_files,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iptem,npoint_files,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(idxpnt_files,npoint_files*MXSPEC,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(irstc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(irstf,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(irstp,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipr_unit,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(irr_unit,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iavg,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idep,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ismin,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_sm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ismout,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      max_emissfiles = MAXVAL( nemiss_files(1:ngrid) )
      call nodes_pass(iarem,ngrid*max_emissfiles,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(buffer_offset_iarem,ngrid*max_emissfiles,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iarem,ngrid*max_emissfiles,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(idxems_files,ngrid*max_emissfiles*MXSPEC,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(isurf,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_isurf,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(i3dmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_i3dmet,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(i2dmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_i2dmet,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ikv,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_ikv,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(icld,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lcig,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(n3dmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(n2dmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nkvmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ncldmet,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nsrfvar,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- send the variables for the o3colmap include file ---
c
      call nodes_pass(lrdocn,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrdlai,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  --- send the variables in the flags include file ----
c
      call nodes_pass(iadvct,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lrstrt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lflexi,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(idrydep,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ldry,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lwet,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lutm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(llatlon,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrpolar,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lambrt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lpolar,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lmerc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lstagw,MXGRID,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(larsrc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lptsrc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ltopcon,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ltrace,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_ioric,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(num_ioric,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ncls_ioric,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_ioric,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_iorbc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(num_iorbc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ncls_iorbc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iorbc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrd_sa_bc_hdr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsa_iortc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ncls_iortc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(is_netcdf_iortc,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrd_sa_tc_hdr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(tectyp,  10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(lapca,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lapcapt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lpartial,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lptdepout,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lproca,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lipr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lirr,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lcpacum,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lddm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lhddm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lddmcalc,ngrid,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsrfmod,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsrfmodrt,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lixemis,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lixbypass,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lbidinh3,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lstrato3,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lgas_out_ppm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lzppm,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lparttn,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(le1day,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lairqul,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ldiag,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lacm2,1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  --- send the other variables in the chmstry include file ----
c
      call nodes_pass(idmech,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idsolv,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nicspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nbcspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ntcspc,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(aeropt,10,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(leqsam,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(jno2rxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jo3rxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jhcho1rxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jhcho2rxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jch3chorxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(hthal,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(brlprof,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(brwprof,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(brolprof,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(browprof,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(cl2day,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(cl2nite,NHTHAL,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(kmap,NSPNAM,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(henso20,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tfactso2,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(cwmin,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tamin,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(nbin,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ipigrxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lsmap,NSPIGCHEM,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lrmap,NRPIGCHEM,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ihetrxn,NHETRXN,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- send the variables in the soap include file ----
c
      call nodes_pass(kpolya,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(kpolyb,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(sfacJSOA,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(csatS,NSOAP,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(cstempS,NSOAP,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(deltahS,NSOAP,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(y_h,3*NPREC_S,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(y_l,3*NPREC_S,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(iksoap,NSOAPRXN,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- send the variables in the vbs include file ----
c
      call nodes_pass(lvbs,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      if ( lvbs .and. LVBSPREPROC ) then
        call nodes_pass(kpap_c,NVOLBIN+1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(kpcp_c,NVOLBIN+1,MPI_INTEGER,itag,numprocs,iproc_id)
        call nodes_pass(kpfp_c,NVOLBIN+1,MPI_INTEGER,itag,numprocs,iproc_id)
      endif
c
c  --- send WTMOL for the PM chemistry ---
c
      call nodes_pass(wtmol,NWTMOL,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- send the pointers for the PM chemistry ---
c
      call nodes_pass(kso2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kh2o2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kform_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(khono_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ko3_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(koh_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kho2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kno3_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kno_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kno2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpan_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kacg2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kacg1_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kbcg2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kbcg1_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(khno3_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(knh3_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kh2so4_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(khcl_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kaoa2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kaoa1_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kboa2_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kboa1_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kaoa0_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kboa0_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kcrst_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(khoa_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpec_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kph2o_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpcl_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kna_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpnh4_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpno3_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpso4_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kn2o5_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(khpo_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kfoa_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kmhp_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kpaa_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kohp_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kopa_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kgly_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kmgly_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kglyd_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ksoac_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ngas_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nspec_c,1,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- send the other variables in the chmstry include file ----
c
      max_emissfiles = MAXVAL( nemiss_files(1:ngrid) )
      call nodes_pass(narspc,ngrid*max_emissfiles,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lgas,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(luse_soap3,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(luse_soap3_complx,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(luse_soap3_simple,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(idx_ems_soap3,IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idx_ems_svoa,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idx_ems_hoa,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idx_ems_poa,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(emspcname,10*nspec,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(ltdep,nreact,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lpdep,nreact,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(bdnl,nspec+1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(idphot1,nphot1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idphot2,nphot2,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idphot3,nphot2,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(phtscl,nphot2,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(spname,10*(nspec+1),MPI_CHARACTER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(depsp,10*(4*nspec+2),MPI_CHARACTER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(lbcmap,nspec,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ltcmap,nspec,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lavmap,nspec+nrad,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(licmap,nspec,MPI_INTEGER,itag,
     &                                              numprocs,iproc_id)
      call nodes_pass(ldepmap,nspec,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lemmap,nspec,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(rktbl,nreact*NTEMPR*NPRESR,MPI_REAL,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(prkn,NZEN*nphot1*NHGHT*NTRN*NALB*NOZN,
     &                                MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tempr,NTEMPR,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(presr,NPRESR,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(htint,NHGHT,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(zenint,NZEN,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(henry0,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tfact,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(diffrat,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(f0,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rscale,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(mole_weight,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(roprt,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dcut,nspec*2,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(bext,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ssa,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rhadj,nspec,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(soap2_spec_names,10*NUM_SOAP_SPECIES,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(soap3_spec_names,10*NUM_SOAP_SPECIES,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(soap_emiss_names,10*NUM_SOAP_EMISS,MPI_CHARACTER,itag,numprocs,iproc_id)
      call nodes_pass(soap3_evap_factors,3*NUM_SOAP_EMISS,MPI_REAL,itag,numprocs,iproc_id)
c
      if( lsrfmod ) then
         if (iproc_id .GT. 0) call alloc_srfmod(nsmspc,nsmrxn)
         call nodes_pass(idsmsp,nsmspc,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(idsmpre,nsmrxn,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(idsmprd,nsmrxn,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(smskrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smsjrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smvkrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smvjrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smikrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smijrat,nsmrxn,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smssrb,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smvsrb,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smisrb,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smlch,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smpen,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(smmlt,nsmspc,MPI_REAL,itag,numprocs,iproc_id)
      endif
c
c  --- send the other variables in the grid include file ----
c
      call nodes_pass(iuzon,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(itzon,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nnest,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(xorg,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(yorg,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(delx,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dely,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(polelon,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(polelat,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tlat1,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tlat2,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(deltay,ngrid,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ntim,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ntimcrs,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(i1,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(j1,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(i2,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(j2,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nmesh,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nchdrn,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(idchdrn,MXCHDRN*ngrid,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(nosrc,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(inst1,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(inst2,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jnst1,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jnst2,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(meshold,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(mapgrd,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  --- send the variables in the camx include file ----
c
      call nodes_pass(begdate,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(begtim,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dtinp,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dtems,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dtout,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dtmax,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(densfac,1,MPI_REAL,itag,numprocs,iproc_id)

c  --- send variables that depend on rows, cols or layers ---
c
      call nodes_pass(deltax,ngrid*nrowa,MPI_REAL,itag,
     &                                                numprocs,iproc_id)
      do igrd=1,ngrid
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(idfin(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data  (idfin(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(ldark(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data(ldark(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(cellon(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data(cellon(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(cellat(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data(cellat(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(lai(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data(lai(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(mapscl(iptr2d(igrd)), igrd, 1, 1, itag)
        else
          CALL node_recv_gridded_data(mapscl(iptr2d(igrd)), igrd, 1, 1, itag)
        end if
        itag = itag+1
        if (iproc_id .eq. 0) then
          CALL master_send_gridded_data(fsurf(iptrlu(igrd)), igrd, nlu, 1, itag)
        else
          CALL node_recv_gridded_data(fsurf(iptrlu(igrd)), igrd, nlu, 1, itag)
        end if
        itag = itag+1
      enddo
c
c  --- send variables that depend on point sources ---
c
      call nodes_pass(idsrc,MXPTSRC*ngrid,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(isrc,MXPTSRC*ngrid,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(jsrc,MXPTSRC*ngrid,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
c
c  --- pass the arrays for point source data ---
c
      call nodes_pass(hstk,nptsrc,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(dstk,nptsrc,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(tstk,nptsrc,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lpiglet,nptsrc,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(xstk,nptsrc*ngrid,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ystk,nptsrc*ngrid,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- send the other variables in the o3colmap include file ----
c
      call nodes_pass(albcl,NALB,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(trncl,NTRN,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ozcl,NOZN,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- pass the variables in the deposit include file ---
c
      call nodes_pass(rgso,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(z0lu,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rj,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rlu,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rac,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rlcs,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rlco,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rgss,NLUW89*5,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lai_ref,NLUZ03*15,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(iseason,5*12,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(dstress,6,MPI_REAL,itag,numprocs,iproc_id)
c
c  --- pass the variables in the camx_aero include file ---
c
      call nodes_pass(nacl,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(co2 ,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(foa,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(mhp,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(paa,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(caco3,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(mgco3,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(a3fe,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(b2mn,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(potcl,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(eps,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(e0,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lv,1,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rv,1,MPI_REAL,itag,numprocs,iproc_id)
c
c ----- Chemistry parameters ---
c
      call nodes_pass(lmap,NSPNAM,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nirrrxn,1,MPI_INTEGER,itag,numprocs,iproc_id)
      if( lproca ) then
         mvec2d = 0
         mvec3d = 0
         do i=1,ngrid
            mvec2d = mvec2d + nrow(i) * ncol(i)
            mvec3d = mvec3d + nrow(i) * ncol(i) * nlay(i)
         enddo
         call nodes_pass(ptname,10*MXCPA,MPI_CHARACTER,itag,numprocs,iproc_id)
         call nodes_pass(cpadesc,60*MXCPA,MPI_CHARACTER,itag,numprocs,iproc_id)
         call nodes_pass(cpaunit,20*MXCPA,MPI_CHARACTER,itag,numprocs,iproc_id)
         call nodes_pass(ptop_fac,MXCPA,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(loutsa,MXCPA,MPI_LOGICAL,itag,numprocs,iproc_id)
         call nodes_pass(ipacl_2d,mvec2d,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipacl_3d,mvec3d,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipadom,npa_cels,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipax,npa_cels,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipay,npa_cels,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipaz,npa_cels,MPI_INTEGER,itag,numprocs,iproc_id)
         call nodes_pass(ipanst,npa_cels,MPI_INTEGER,itag,numprocs,iproc_id)
      endif
c
c ----- pass variables in the tracer include file ----
c       if not doing probing tools, just skip this ---
c
      if( .NOT. ltrace .and. .NOT. lddm .AND. .NOT. lhddm ) goto 111
      call nodes_pass(num_iortem,ngrid*(ngroup+2),MPI_INTEGER,
     &                                      itag,numprocs,iproc_id)
      call nodes_pass(num_iortpt,ngroup+2,MPI_INTEGER,
     &                                      itag,numprocs,iproc_id)
      if( iproc_id .GT. 0) call alloc_tracer_emfiles(ngroup,ngrid,
     &           nemiss_files,npoint_files,num_iortem,num_iortpt,nspec)
c
c========================= Probing Tools Begin =======================
c
c ----- call routine to allocate the RTRAC data structures ---
c
      if( iproc_id .GT. 0) then
         if( tectyp .EQ. RTRAC ) then
            call alloc_rtracchm(ngrid,mmxp,mmyp,nspec,ntotsp)
         elseif ( tectyp .EQ. RTCMC ) then
            call alloc_rtracchm(ngrid,mmxp,mmyp,nspec,ntotsp)
            call alloc_rtcmc(MXTRSP,MXSPEC,MXRX,
     &                       MXKPRM,MXPHOT,MXZEN,MXRCT,MXPRD,
     &                       MXJACTRM,MXEQM,MXSLO)
         endif
      endif
c
c ----- Variables for gridded tracer emissions data
c
      call nodes_pass(ipigmap,nptsrc,MPI_INTEGER,itag,
     &                                          numprocs,iproc_id)
      call nodes_pass(ipiggrp,nptsrc,MPI_INTEGER,itag,
     &                                          numprocs,iproc_id)
      do igrd=1,ngrid
        do ilay=1,nlayers_ems
          do ispc=1,soap3_ntotsp
            if (iproc_id .eq. 0) then
              CALL master_send_1species_data(saemis(ipsa3d_ems(igrd)), igrd, 
     &                               nlayers_ems, ilay, soap3_ntotsp, ispc, itag)
            else
              CALL node_recv_1species_data(saemis(ipsa3d_ems(igrd)), igrd, 
     &                               nlayers_ems, ilay, soap3_ntotsp, ispc, itag)
            endif
            itag = itag+1
          enddo
        enddo
      enddo
      if( lptsrc ) then
         call nodes_pass_sapnts(numprocs,iproc_id)
         call nodes_pass(xlocpt,nptsrc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(ylocpt,nptsrc,MPI_REAL,itag,numprocs,iproc_id)
         call nodes_pass(lpigsa,nptsrc,MPI_LOGICAL,itag,numprocs,iproc_id)
      endif
      call nodes_pass(nreles,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(ntrtim,1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lreles,1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  ---- Variables for tracer names ----
c
      call nodes_pass(ptname,10*soap3_ntotsp,MPI_CHARACTER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(ptop_fac,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(lsamap,soap3_ntotsp,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lsagas,soap3_ntotsp,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(sa_mole_weight,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
      if( tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC ) then
          call nodes_pass(trspmap,nspec*ntrcls,MPI_REAL,itag,
     &                                              numprocs,iproc_id)
          call nodes_pass(fluxmap,nspec*ntrcls,MPI_REAL,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(yhratmap,nspec*ntrcls,MPI_REAL,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(ylratmap,nspec*ntrcls,MPI_REAL,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(lusespc,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
c
          call nodes_pass(clsnam,3*MXALCLS,MPI_CHARACTER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(soap3_clsnam,3*(IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1),
     &                            MPI_CHARACTER,itag,numprocs,iproc_id)
          call nodes_pass(iptcls,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(soap3_iptcls,IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1,
     &                              MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nptcls,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(soap3_nptcls,IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1,
     &                              MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(ipttrc,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(npttrc,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(idxcls,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(idxipt,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(iemcls,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(soap3_iemcls,IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1,
     &                              MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nemcls,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(nsaspc,MXALCLS,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
          call nodes_pass(npttim,1,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(ipttim,1,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(iemtim,1,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nbdic, 1,MPI_INTEGER,itag,numprocs,iproc_id)
      endif
c
c  ---- Variables for turning parts of SA ---
c
      call nodes_pass(lsulfate,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lnitrate,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lsoa,    1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lprimary,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lmercury,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lozone,  1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lmineral,1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(ldmschm ,1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c   ---- Variables for user options and flags ---
c
      call nodes_pass(loutsa,ntotsp,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass (ngroup,  1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass (nchar,   1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lrestrt, 1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(leftovr_area, 1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lbndry,  1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lallout, 1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  ---- Variables for region mapping ---
c
      call nodes_pass(nxcell,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nycell,ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(npartial,(ngroup+1)*ngrid,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(igrmap,(ngroup+1)*MXPARTIAL*ngrid*ncola*nrowa,
     &                             MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(frcmap,(ngroup+1)*MXPARTIAL*ngrid*ncola*nrowa,
     &                                MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(nregin,    1,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  ---- Variables for receptor data ---
c
      call nodes_pass(conrcp,ntotsp*MXRECP,MPI_REAL,itag,
     &                                                numprocs,iproc_id)
      call nodes_pass(rcpnam,10*MXRECP,MPI_CHARACTER,itag,
     &                                                numprocs,iproc_id) 
      call nodes_pass(idrcp,  MXRECP,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
      call nodes_pass(igrdrcp,MXRECP,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
      call nodes_pass(irecep,MXRECP*MXCELR,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
      call nodes_pass(jrecep,MXRECP*MXCELR,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
      call nodes_pass(nclrcp,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iwalbg,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(iwalnd,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jwalbg,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(jwalnd,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kwalbg,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(kwalnd,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(recepx,MXRECP,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(recepy,MXRECP,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(nrecep,     1,MPI_INTEGER,itag,numprocs,iproc_id)
      call nodes_pass(lwalls,     1,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lrcpfil,    1,MPI_LOGICAL,itag,numprocs,iproc_id)
c
c  ---- Variables for species order and species flags ----
c
      max_ptfiles = MAXVAL(num_iortpt)
      call nodes_pass(idxpts,(ngroup+2)*max_ptfiles*nspec*100,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(idx_point_in_list,(ngroup+2)*max_ptfiles,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(nspcpt,(ngroup+2)*max_ptfiles,MPI_INTEGER,itag,
     &                                               numprocs,iproc_id)
      call nodes_pass(lvocsp,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lvocsoa,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lhrvoc,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lnoxsp,nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(lo3sp, nspec,MPI_LOGICAL,itag,numprocs,iproc_id)
      call nodes_pass(crbnum,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(mwspec,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rkohrt,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(rmirrt,nspec,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(wtkoh,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(wtmir,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(yhrates,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
      call nodes_pass(ylrates,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
c
      if( tectyp .EQ. RTRAC ) then
          call nodes_pass(lsecnd,ntotsp,MPI_LOGICAL,itag,numprocs,iproc_id)
          call nodes_pass(lreg,ntotsp,MPI_LOGICAL,itag,numprocs,iproc_id)
          call nodes_pass(ksec,ntotsp,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(rtlbnd,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rthlaw,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rttfact,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtmolwt,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtdrate,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtreact,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtscale,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtdens,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtlcut,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtucut,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(jnum,ntotsp,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(rtjfact,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(aoh,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(eaoh,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(boh,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(troh,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(ano3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(eano3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(bno3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(trno3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(ao3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(eao3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(bo3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(tro3,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(fsoil,NLUW89,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(fsoilz,NLUZ03,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(fsoiloc,NLUW89,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(eqkoa,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(khydro,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(kleach,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(kpen,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(kphot,ntotsp,MPI_REAL,itag,numprocs,iproc_id) 
          if( lrcpfil ) then
              mvec3d = 0
              do i=1,ngrid
                 mvec3d = mvec3d + nrow(i) * ncol(i) * nlay(i)
              enddo
              call nodes_pass(ipacl_3d,mvec3d,MPI_INTEGER,
     &                                         itag,numprocs,iproc_id)
          endif
      elseif( tectyp .EQ. RTCMC ) then
          call nodes_pass(ityprtc,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nrkprm,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(rkprmrtc,MXRX*MXKPRM,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(srkrtc,MXRX,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rkrtc,MXRX,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(rthlaw,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rttfact,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtdrate,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtreact,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtscale,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtdens,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtlcut,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rtucut,ntotsp,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(ijschm,MXPHOT,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(ijpntr,MXPHOT,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(jscale,MXPHOT,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(zenschm,MXZEN,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rjschm,MXZEN*MXPHOT,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(itypsp,MXTRSP+MXSPEC,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(itypschm,MXTRSP+MXSPEC,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(lblrxn,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nrct,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nprd,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idxrct,MXRX*MXRCT,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idxprd,MXRX*MXPRD,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(conschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(spdcoef,MXRX*MXPRD,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(prdcoef,MXRX*MXPRD,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(spnmrt,MXTRSP+MXSPEC*10,MPI_CHARACTER,itag,numprocs,iproc_id)
          call nodes_pass(spnmschm,MXTRSP+MXSPEC,MPI_CHARACTER,itag,numprocs,iproc_id)
          call nodes_pass(hlawschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(tfacschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(molwschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(reacschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(rsclschm,MXTRSP+MXSPEC,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(namrct,MXRX*MXRCT,MPI_CHARACTER,itag,numprocs,iproc_id)
          call nodes_pass(namprd,MXRX*MXPRD,MPI_CHARACTER,itag,numprocs,iproc_id)
          call nodes_pass(nrctfst,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nprdfst,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idxrctfst,MXRX*MXRCT,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idxprdfst,MXRX*MXPRD,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(prdcofst,MXRX*MXPRD,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(ipd,MXJACTRM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(jpd,MXJACTRM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idrxjac,MXJACTRM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nspjac,MXJACTRM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(idspjac,MXJACTRM*(MXRCT-1),MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(scoefjac,MXJACTRM,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(coefjac,MXJACTRM,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(idslo,MXSLO,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nslgain,MXSLO,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nslloss,MXSLO,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(islgain,MXSLO*MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(islloss,MXSLO*MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(spdcoslo,MXSLO*MXRX,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(prdcoslo,MXSLO*MXRX,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(ideqm,MXEQM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nrxgain,MXEQM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(nrxloss,MXEQM,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(irxgain,MXEQM*MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(irxloss,MXEQM*MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(irxupdt,MXRX,MPI_INTEGER,itag,numprocs,iproc_id)
          call nodes_pass(spdcoeqm,MXEQM*MXRX,MPI_REAL,itag,numprocs,iproc_id)
          call nodes_pass(prdcoeqm,MXEQM*MXRX,MPI_DOUBLE_PRECISION,itag,numprocs,iproc_id)
          call nodes_pass(idxfix,MXTRSP+MXSPEC,MPI_INTEGER,itag,numprocs,iproc_id)
          if( lrcpfil ) then
              mvec3d = 0 
              do i=1,ngrid
                 mvec3d = mvec3d + nrow(i) * ncol(i) * nlay(i)
              enddo
              call nodes_pass(ipacl_3d,mvec3d,MPI_INTEGER,
     &                                         itag,numprocs,iproc_id)
          endif
      endif
c
c========================= Probing Tools End =======================
c
c======================== DDM Begin ================================
c
c  --- Tracer species map for DDM ----
c
      if( lddm .OR. lhddm ) then
c
         call nodes_pass(icddmsp,10*nspec,MPI_CHARACTER,itag,
     &                                                numprocs,iproc_id) 
c
         call nodes_pass(bcddmsp,10*nspec,MPI_CHARACTER,itag,
     &                                                numprocs,iproc_id) 
c
         call nodes_pass(emddmsp,10*nspec,MPI_CHARACTER,itag,
     &                                                numprocs,iproc_id) 
c
         call nodes_pass(nicddm,  1,MPI_INTEGER,itag,numprocs,iproc_id)
c
         call nodes_pass(ndepddm, 1,MPI_INTEGER,itag,numprocs,iproc_id)
c
         call nodes_pass(nbcddm,  1,MPI_INTEGER,itag,numprocs,iproc_id)
c
         call nodes_pass(nemddm,  1,MPI_INTEGER,itag,numprocs,iproc_id)
c
c  ----- Species list and pointers into arrays for DDM species ---
c
         call nodes_pass(ptlong,14*ntotsp,MPI_CHARACTER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(iptddm,  nspec,MPI_INTEGER,itag,
     &                                                numprocs,iproc_id)
         call nodes_pass(rateddm, 10*nrateddm, MPI_CHARACTER,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(termddm, 10*ntermddm, MPI_CHARACTER,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(hddmsp, 10*nhddm,MPI_CHARACTER,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(iprate,(nreact+1)*nrateddm, MPI_INTEGER,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(ipterm,(ngas+1)*nreact*ntermddm, MPI_INTEGER,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(wfterm,    ngas*nreact*ntermddm, MPI_REAL,
     &                                          itag,numprocs,iproc_id)
         call nodes_pass(iphddm,2*nhddm,MPI_INTEGER,
     &                                          itag,numprocs,iproc_id)
       endif
c
c======================== DDM End ==================================
c
c  --- return to the calling routine ---
c
  111 continue
      end

c
c assorted routines from NETLIB LINPAC archive
c note modified array declarations at "cgy" to allow
c array bounds checking using f77 -C option
c
      double precision function dasum(n,dx,incx)
c
c     takes the sum of the absolute values.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dtemp
      integer i,incx,m,mp1,n,nincx
c
      dasum = 0.0d0
      dtemp = 0.0d0
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dtemp = dtemp + dabs(dx(i))
   10 continue
      dasum = dtemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dabs(dx(i))
   30 continue
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,6
        dtemp = dtemp + dabs(dx(i)) + dabs(dx(i + 1)) + dabs(dx(i + 2))
     *  + dabs(dx(i + 3)) + dabs(dx(i + 4)) + dabs(dx(i + 5))
   50 continue
   60 dasum = dtemp
      return
      end
      subroutine daxpy(n,da,dx,incx,dy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*),da
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (da .eq. 0.0d0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dy(iy) = dy(iy) + da*dx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dy(i) = dy(i) + da*dx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        dy(i) = dy(i) + da*dx(i)
        dy(i + 1) = dy(i + 1) + da*dx(i + 1)
        dy(i + 2) = dy(i + 2) + da*dx(i + 2)
        dy(i + 3) = dy(i + 3) + da*dx(i + 3)
   50 continue
      return
      end
      subroutine dgeco(a,lda,n,ipvt,rcond,z)
cgy      integer lda,n,ipvt(1)
cgy      double precision a(lda,1),z(1)
      integer lda,n,ipvt(n)
      double precision a(lda,n),z(n)
      double precision rcond
c
c     dgeco factors a double precision matrix by gaussian elimination
c     and estimates the condition of the matrix.
c
c     if  rcond  is not needed, dgefa is slightly faster.
c     to solve  a*x = b , follow dgeco by dgesl.
c     to compute  inverse(a)*c , follow dgeco by dgesl.
c     to compute  determinant(a) , follow dgeco by dgedi.
c     to compute  inverse(a) , follow dgeco by dgedi.
c
c     on entry
c
c        a       double precision(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        rcond   double precision
c                an estimate of the reciprocal condition of  a .
c                for the system  a*x = b , relative perturbations
c                in  a  and  b  of size  epsilon  may cause
c                relative perturbations in  x  of size  epsilon/rcond .
c                if  rcond  is so small that the logical expression
c                           1.0 + rcond .eq. 1.0
c                is true, then  a  may be singular to working
c                precision.  in particular,  rcond  is zero  if
c                exact singularity is detected or the estimate
c                underflows.
c
c        z       double precision(n)
c                a work vector whose contents are usually unimportant.
c                if  a  is close to a singular matrix, then  z  is
c                an approximate null vector in the sense that
c                norm(a*z) = rcond*norm(a)*norm(z) .
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     linpack dgefa
c     blas daxpy,ddot,dscal,dasum
c     fortran dabs,dmax1,dsign
c
c     internal variables
c
      double precision ddot,ek,t,wk,wkm
      double precision anorm,s,dasum,sm,ynorm
      integer info,j,k,kb,kp1,l
c
c
c     compute 1-norm of a
c
      anorm = 0.0d0
      do 10 j = 1, n
         anorm = dmax1(anorm,dasum(n,a(1,j),1))
   10 continue
c
c     factor
c
      call dgefa(a,lda,n,ipvt,info)
c
c     rcond = 1/(norm(a)*(estimate of norm(inverse(a)))) .
c     estimate = norm(z)/norm(y) where  a*z = y  and  trans(a)*y = e .
c     trans(a)  is the transpose of a .  the components of  e  are
c     chosen to cause maximum local growth in the elements of w  where
c     trans(u)*w = e .  the vectors are frequently rescaled to avoid
c     overflow.
c
c     solve trans(u)*w = e
c
      ek = 1.0d0
      do 20 j = 1, n
         z(j) = 0.0d0
   20 continue
      do 100 k = 1, n
         if (z(k) .ne. 0.0d0) ek = dsign(ek,-z(k))
         if (dabs(ek-z(k)) .le. dabs(a(k,k))) go to 30
            s = dabs(a(k,k))/dabs(ek-z(k))
            call dscal(n,s,z,1)
            ek = s*ek
   30    continue
         wk = ek - z(k)
         wkm = -ek - z(k)
         s = dabs(wk)
         sm = dabs(wkm)
         if (a(k,k) .eq. 0.0d0) go to 40
            wk = wk/a(k,k)
            wkm = wkm/a(k,k)
         go to 50
   40    continue
            wk = 1.0d0
            wkm = 1.0d0
   50    continue
         kp1 = k + 1
         if (kp1 .gt. n) go to 90
            do 60 j = kp1, n
               sm = sm + dabs(z(j)+wkm*a(k,j))
               z(j) = z(j) + wk*a(k,j)
               s = s + dabs(z(j))
   60       continue
            if (s .ge. sm) go to 80
               t = wkm - wk
               wk = wkm
               do 70 j = kp1, n
                  z(j) = z(j) + t*a(k,j)
   70          continue
   80       continue
   90    continue
         z(k) = wk
  100 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
c
c     solve trans(l)*y = w
c
      do 120 kb = 1, n
         k = n + 1 - kb
         if (k .lt. n) z(k) = z(k) + ddot(n-k,a(k+1,k),1,z(k+1),1)
         if (dabs(z(k)) .le. 1.0d0) go to 110
            s = 1.0d0/dabs(z(k))
            call dscal(n,s,z,1)
  110    continue
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
  120 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
c
      ynorm = 1.0d0
c
c     solve l*v = y
c
      do 140 k = 1, n
         l = ipvt(k)
         t = z(l)
         z(l) = z(k)
         z(k) = t
         if (k .lt. n) call daxpy(n-k,t,a(k+1,k),1,z(k+1),1)
         if (dabs(z(k)) .le. 1.0d0) go to 130
            s = 1.0d0/dabs(z(k))
            call dscal(n,s,z,1)
            ynorm = s*ynorm
  130    continue
  140 continue
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
      ynorm = s*ynorm
c
c     solve  u*z = v
c
      do 160 kb = 1, n
         k = n + 1 - kb
         if (dabs(z(k)) .le. dabs(a(k,k))) go to 150
            s = dabs(a(k,k))/dabs(z(k))
            call dscal(n,s,z,1)
            ynorm = s*ynorm
  150    continue
         if (a(k,k) .ne. 0.0d0) z(k) = z(k)/a(k,k)
         if (a(k,k) .eq. 0.0d0) z(k) = 1.0d0
         t = -z(k)
         call daxpy(k-1,t,a(1,k),1,z(1),1)
  160 continue
c     make znorm = 1.0
      s = 1.0d0/dasum(n,z,1)
      call dscal(n,s,z,1)
      ynorm = s*ynorm
c
      if (anorm .ne. 0.0d0) rcond = ynorm/anorm
      if (anorm .eq. 0.0d0) rcond = 0.0d0
      return
      end
      subroutine dgesl(a,lda,n,ipvt,b,job)
cgy      integer lda,n,ipvt(1),job
cgy      double precision a(lda,1),b(1)
      integer lda,n,ipvt(n),job
      double precision a(lda,n),b(n)
c
c     dgesl solves the double precision system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgeco or dgefa.
c
c     on entry
c
c        a       double precision(lda, n)
c                the output from dgeco or dgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from dgeco or dgefa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgeco has set rcond .gt. 0.0
c        or dgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c
c     internal variables
c
      double precision ddot,t
      integer k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call daxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call daxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = ddot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + ddot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end
      subroutine  dscal(n,da,dx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision da,dx(*)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        dx(i) = da*dx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dx(i) = da*dx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dx(i) = da*dx(i)
        dx(i + 1) = da*dx(i + 1)
        dx(i + 2) = da*dx(i + 2)
        dx(i + 3) = da*dx(i + 3)
        dx(i + 4) = da*dx(i + 4)
   50 continue
      return
      end
*DECK DSDOT
      DOUBLE PRECISION FUNCTION DSDOT (N, SX, INCX, SY, INCY)
C***BEGIN PROLOGUE  DSDOT
C***PURPOSE  Compute the inner product of two vectors with extended
C            precision accumulation and result.
C***LIBRARY   SLATEC (BLAS)
C***CATEGORY  D1A4
C***TYPE      DOUBLE PRECISION (DSDOT-D, DCDOT-C)
C***KEYWORDS  BLAS, COMPLEX VECTORS, DOT PRODUCT, INNER PRODUCT,
C             LINEAR ALGEBRA, VECTOR
C***AUTHOR  Lawson, C. L., (JPL)
C           Hanson, R. J., (SNLA)
C           Kincaid, D. R., (U. of Texas)
C           Krogh, F. T., (JPL)
C***DESCRIPTION
C
C                B L A S  Subprogram
C    Description of Parameters
C
C     --Input--
C        N  number of elements in input vector(s)
C       SX  single precision vector with N elements
C     INCX  storage spacing between elements of SX
C       SY  single precision vector with N elements
C     INCY  storage spacing between elements of SY
C
C     --Output--
C    DSDOT  double precision dot product (zero if N.LE.0)
C
C     Returns D.P. dot product accumulated in D.P., for S.P. SX and SY
C     DSDOT = sum for I = 0 to N-1 of  SX(LX+I*INCX) * SY(LY+I*INCY),
C     where LX = 1 if INCX .GE. 0, else LX = 1+(1-N)*INCX, and LY is
C     defined in a similar way using INCY.
C
C***REFERENCES  C. L. Lawson, R. J. Hanson, D. R. Kincaid and F. T.
C                 Krogh, Basic linear algebra subprograms for Fortran
C                 usage, Algorithm No. 539, Transactions on Mathematical
C                 Software 5, 3 (September 1979), pp. 308-323.
C***ROUTINES CALLED  (NONE)
C***REVISION HISTORY  (YYMMDD)
C   791001  DATE WRITTEN
C   890831  Modified array declarations.  (WRB)
C   890831  REVISION DATE from Version 3.2
C   891214  Prologue converted to Version 4.0 format.  (BAB)
C   920310  Corrected definition of LX in DESCRIPTION.  (WRB)
C   920501  Reformatted the REFERENCES section.  (WRB)
C***END PROLOGUE  DSDOT
      REAL SX(*),SY(*)
C***FIRST EXECUTABLE STATEMENT  DSDOT
      DSDOT = 0.0D0
      IF (N .LE. 0) RETURN
      IF (INCX.EQ.INCY .AND. INCX.GT.0) GO TO 20
C
C     Code for unequal or nonpositive increments.
C
      KX = 1
      KY = 1
      IF (INCX .LT. 0) KX = 1+(1-N)*INCX
      IF (INCY .LT. 0) KY = 1+(1-N)*INCY
      DO 10 I = 1,N
        DSDOT = DSDOT + DBLE(SX(KX))*DBLE(SY(KY))
        KX = KX + INCX
        KY = KY + INCY
   10 CONTINUE
      RETURN
C
C     Code for equal, positive, non-unit increments.
C
   20 NS = N*INCX
      DO 30 I = 1,NS,INCX
        DSDOT = DSDOT + DBLE(SX(I))*DBLE(SY(I))
   30 CONTINUE
      RETURN
      END
      integer function isamax(n,sx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),smax
      integer i,incx,ix,n
c
      isamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      isamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      smax = abs(sx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(abs(sx(ix)).le.smax) go to 5
         isamax = i
         smax = abs(sx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 smax = abs(sx(1))
      do 30 i = 2,n
         if(abs(sx(i)).le.smax) go to 30
         isamax = i
         smax = abs(sx(i))
   30 continue
      return
      end
      real function sasum(n,sx,incx)
c
c     takes the sum of the absolute values.
c     uses unrolled loops for increment equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),stemp
      integer i,incx,m,mp1,n,nincx
c
      sasum = 0.0e0
      stemp = 0.0e0
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        stemp = stemp + abs(sx(i))
   10 continue
      sasum = stemp
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,6)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        stemp = stemp + abs(sx(i))
   30 continue
      if( n .lt. 6 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,6
        stemp = stemp + abs(sx(i)) + abs(sx(i + 1)) + abs(sx(i + 2))
     *  + abs(sx(i + 3)) + abs(sx(i + 4)) + abs(sx(i + 5))
   50 continue
   60 sasum = stemp
      return
      end
      subroutine saxpy(n,sa,sx,incx,sy,incy)
c
c     constant times a vector plus a vector.
c     uses unrolled loop for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),sa
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if (sa .eq. 0.0) return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        sy(iy) = sy(iy) + sa*sx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,4)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sy(i) = sy(i) + sa*sx(i)
   30 continue
      if( n .lt. 4 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,4
        sy(i) = sy(i) + sa*sx(i)
        sy(i + 1) = sy(i + 1) + sa*sx(i + 1)
        sy(i + 2) = sy(i + 2) + sa*sx(i + 2)
        sy(i + 3) = sy(i + 3) + sa*sx(i + 3)
   50 continue
      return
      end
      real function sdot(n,sx,incx,sy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*),stemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      stemp = 0.0e0
      sdot = 0.0e0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        stemp = stemp + sx(ix)*sy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      sdot = stemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        stemp = stemp + sx(i)*sy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        stemp = stemp + sx(i)*sy(i) + sx(i + 1)*sy(i + 1) +
     *   sx(i + 2)*sy(i + 2) + sx(i + 3)*sy(i + 3) + sx(i + 4)*sy(i + 4)
   50 continue
   60 sdot = stemp
      return
      end
      subroutine sgefa(a,lda,n,ipvt,info)
cgy      integer lda,n,ipvt(1),info
cgy      real a(lda,1)
      integer lda,n,ipvt(n),info
      real a(lda,n)
c
c     sgefa factors a real matrix by gaussian elimination.
c
c     sgefa is usually called by sgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for sgeco) = (1 + 9/n)*(time for sgefa) .
c
c     on entry
c
c        a       real(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgesl or sgedi will divide by zero
c                     if called.  use  rcond  in sgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c
c     internal variables
c
      real t
      integer isamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = isamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0e0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0e0/a(k,k)
            call sscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call saxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0e0) info = n
      return
      end
      subroutine sgesl(a,lda,n,ipvt,b,job)
cgy      integer lda,n,ipvt(1),job
cgy      real a(lda,1),b(1)
      integer lda,n,ipvt(n),job
      real a(lda,n),b(n)
c
c     sgesl solves the real system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by sgeco or sgefa.
c
c     on entry
c
c        a       real(lda, n)
c                the output from sgeco or sgefa.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c        ipvt    integer(n)
c                the pivot vector from sgeco or sgefa.
c
c        b       real(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b  where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if sgeco has set rcond .gt. 0.0
c        or sgefa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call sgeco(a,lda,n,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call sgesl(a,lda,n,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sdot
c
c     internal variables
c
      real sdot,t
      integer k,kb,l,nm1
c
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve  l*y = b
c
         if (nm1 .lt. 1) go to 30
         do 20 k = 1, nm1
            l = ipvt(k)
            t = b(l)
            if (l .eq. k) go to 10
               b(l) = b(k)
               b(k) = t
   10       continue
            call saxpy(n-k,t,a(k+1,k),1,b(k+1),1)
   20    continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/a(k,k)
            t = -b(k)
            call saxpy(k-1,t,a(1,k),1,b(1),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            t = sdot(k-1,a(1,k),1,b(1),1)
            b(k) = (b(k) - t)/a(k,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (nm1 .lt. 1) go to 90
         do 80 kb = 1, nm1
            k = n - kb
            b(k) = b(k) + sdot(n-k,a(k+1,k),1,b(k+1),1)
            l = ipvt(k)
            if (l .eq. k) go to 70
               t = b(l)
               b(l) = b(k)
               b(k) = t
   70       continue
   80    continue
   90    continue
  100 continue
      return
      end
      subroutine sscal(n,sa,sx,incx)
c
c     scales a vector by a constant.
c     uses unrolled loops for increment equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sa,sx(*)
      integer i,incx,m,mp1,n,nincx
c
      if( n.le.0 .or. incx.le.0 )return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      nincx = n*incx
      do 10 i = 1,nincx,incx
        sx(i) = sa*sx(i)
   10 continue
      return
c
c        code for increment equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sx(i) = sa*sx(i)
   30 continue
      if( n .lt. 5 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        sx(i) = sa*sx(i)
        sx(i + 1) = sa*sx(i + 1)
        sx(i + 2) = sa*sx(i + 2)
        sx(i + 3) = sa*sx(i + 3)
        sx(i + 4) = sa*sx(i + 4)
   50 continue
      return
      end
      subroutine sgbfa(abd,lda,n,ml,mu,ipvt,info)
cgy      integer lda,n,ml,mu,ipvt(1),info
cgy      real abd(lda,1)
      integer lda,n,ml,mu,ipvt(n),info
      real abd(lda,n)
c
c     sgbfa factors a real band matrix by elimination.
c
c     sgbfa is usually called by sgbco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c
c     on entry
c
c        abd     real(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that sgbsl will divide by zero if
c                     called.  use  rcond  in sgbco for a reliable
c                     indication of singularity.
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sscal,isamax
c     fortran max0,min0
c
c     internal variables
c
      real t
      integer i,isamax,i0,j,ju,jz,j0,j1,k,kp1,l,lm,m,mm,nm1
c
c
      m = ml + mu + 1
      info = 0
c
c     zero initial fill-in columns
c
      j0 = mu + 2
      j1 = min0(n,m) - 1
      if (j1 .lt. j0) go to 30
      do 20 jz = j0, j1
         i0 = m + 1 - jz
         do 10 i = i0, ml
            abd(i,jz) = 0.0e0
   10    continue
   20 continue
   30 continue
      jz = j1
      ju = 0
c
c     gaussian elimination with partial pivoting
c
      nm1 = n - 1
      if (nm1 .lt. 1) go to 130
      do 120 k = 1, nm1
         kp1 = k + 1
c
c        zero next fill-in column
c
         jz = jz + 1
         if (jz .gt. n) go to 50
         if (ml .lt. 1) go to 50
            do 40 i = 1, ml
               abd(i,jz) = 0.0e0
   40       continue
   50    continue
c
c        find l = pivot index
c
         lm = min0(ml,n-k)
         l = isamax(lm+1,abd(m,k),1) + m - 1
         ipvt(k) = l + k - m
c
c        zero pivot implies this column already triangularized
c
         if (abd(l,k) .eq. 0.0e0) go to 100
c
c           interchange if necessary
c
            if (l .eq. m) go to 60
               t = abd(l,k)
               abd(l,k) = abd(m,k)
               abd(m,k) = t
   60       continue
c
c           compute multipliers
c
            t = -1.0e0/abd(m,k)
            call sscal(lm,t,abd(m+1,k),1)
c
c           row elimination with column indexing
c
            ju = min0(max0(ju,mu+ipvt(k)),n)
            mm = m
            if (ju .lt. kp1) go to 90
            do 80 j = kp1, ju
               l = l - 1
               mm = mm - 1
               t = abd(l,j)
               if (l .eq. mm) go to 70
                  abd(l,j) = abd(mm,j)
                  abd(mm,j) = t
   70          continue
               call saxpy(lm,t,abd(m+1,k),1,abd(mm+1,j),1)
   80       continue
   90       continue
         go to 110
  100    continue
            info = k
  110    continue
  120 continue
  130 continue
      ipvt(n) = n
      if (abd(m,n) .eq. 0.0e0) info = n
      return
      end
      subroutine sgbsl(abd,lda,n,ml,mu,ipvt,b,job)
cgy      integer lda,n,ml,mu,ipvt(1),job
cgy      real abd(lda,1),b(1)
      integer lda,n,ml,mu,ipvt(n),job
      real abd(lda,n),b(n)
c
c     sgbsl solves the real band system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by sgbco or sgbfa.
c
c     on entry
c
c        abd     real(lda, n)
c                the output from sgbco or sgbfa.
c
c        lda     integer
c                the leading dimension of the array  abd .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c
c        mu      integer
c                number of diagonals above the main diagonal.
c
c        ipvt    integer(n)
c                the pivot vector from sgbco or sgbfa.
c
c        b       real(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b , where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if sgbco has set rcond .gt. 0.0
c        or sgbfa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call sgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call sgbsl(abd,lda,n,ml,mu,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas saxpy,sdot
c     fortran min0
c
c     internal variables
c
      real sdot,t
      integer k,kb,l,la,lb,lm,m,nm1
c
      m = mu + ml + 1
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve l*y = b
c
         if (ml .eq. 0) go to 30
         if (nm1 .lt. 1) go to 30
            do 20 k = 1, nm1
               lm = min0(ml,n-k)
               l = ipvt(k)
               t = b(l)
               if (l .eq. k) go to 10
                  b(l) = b(k)
                  b(k) = t
   10          continue
               call saxpy(lm,t,abd(m+1,k),1,b(k+1),1)
   20       continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/abd(m,k)
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = -b(k)
            call saxpy(lm,t,abd(la,k),1,b(lb),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = sdot(lm,abd(la,k),1,b(lb),1)
            b(k) = (b(k) - t)/abd(m,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (ml .eq. 0) go to 90
         if (nm1 .lt. 1) go to 90
            do 80 kb = 1, nm1
               k = n - kb
               lm = min0(ml,n-k)
               b(k) = b(k) + sdot(lm,abd(m+1,k),1,b(k+1),1)
               l = ipvt(k)
               if (l .eq. k) go to 70
                  t = b(l)
                  b(l) = b(k)
                  b(k) = t
   70          continue
   80       continue
   90    continue
  100 continue
      return
      end
      subroutine scopy(n,sx,incx,sy,incy)
c
c     copies a vector, x, to a vector, y.
c     uses unrolled loops for increments equal to 1.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      real sx(*),sy(*)
      integer i,incx,incy,ix,iy,m,mp1,n
c
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        sy(iy) = sx(ix)
        ix = ix + incx
        iy = iy + incy
   10 continue
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,7)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        sy(i) = sx(i)
   30 continue
      if( n .lt. 7 ) return
   40 mp1 = m + 1
      do 50 i = mp1,n,7
        sy(i) = sx(i)
        sy(i + 1) = sx(i + 1)
        sy(i + 2) = sx(i + 2)
        sy(i + 3) = sx(i + 3)
        sy(i + 4) = sx(i + 4)
        sy(i + 5) = sx(i + 5)
        sy(i + 6) = sx(i + 6)
   50 continue
      return
      end
      double precision function ddot(n,dx,incx,dy,incy)
c
c     forms the dot product of two vectors.
c     uses unrolled loops for increments equal to one.
c     jack dongarra, linpack, 3/11/78.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dy(*),dtemp
      integer i,incx,incy,ix,iy,m,mp1,n
c
      ddot = 0.0d0
      dtemp = 0.0d0
      if(n.le.0)return
      if(incx.eq.1.and.incy.eq.1)go to 20
c
c        code for unequal increments or equal increments
c          not equal to 1
c
      ix = 1
      iy = 1
      if(incx.lt.0)ix = (-n+1)*incx + 1
      if(incy.lt.0)iy = (-n+1)*incy + 1
      do 10 i = 1,n
        dtemp = dtemp + dx(ix)*dy(iy)
        ix = ix + incx
        iy = iy + incy
   10 continue
      ddot = dtemp
      return
c
c        code for both increments equal to 1
c
c
c        clean-up loop
c
   20 m = mod(n,5)
      if( m .eq. 0 ) go to 40
      do 30 i = 1,m
        dtemp = dtemp + dx(i)*dy(i)
   30 continue
      if( n .lt. 5 ) go to 60
   40 mp1 = m + 1
      do 50 i = mp1,n,5
        dtemp = dtemp + dx(i)*dy(i) + dx(i + 1)*dy(i + 1) +
     *   dx(i + 2)*dy(i + 2) + dx(i + 3)*dy(i + 3) + dx(i + 4)*dy(i + 4)
   50 continue
   60 ddot = dtemp
      return
      end
      subroutine dgbfa(abd,lda,n,ml,mu,ipvt,info)
cgy      integer lda,n,ml,mu,ipvt(1),info
cgy      double precision abd(lda,1)
      integer lda,n,ml,mu,ipvt(n),info
      double precision abd(lda,n)
c
c     dgbfa factors a double precision band matrix by elimination.
c
c     dgbfa is usually called by dgbco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c
c     on entry
c
c        abd     double precision(lda, n)
c                contains the matrix in band storage.  the columns
c                of the matrix are stored in the columns of  abd  and
c                the diagonals of the matrix are stored in rows
c                ml+1 through 2*ml+mu+1 of  abd .
c                see the comments below for details.
c
c        lda     integer
c                the leading dimension of the array  abd .
c                lda must be .ge. 2*ml + mu + 1 .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c                0 .le. ml .lt. n .
c
c        mu      integer
c                number of diagonals above the main diagonal.
c                0 .le. mu .lt. n .
c                more efficient if  ml .le. mu .
c     on return
c
c        abd     an upper triangular matrix in band storage and
c                the multipliers which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgbsl will divide by zero if
c                     called.  use  rcond  in dgbco for a reliable
c                     indication of singularity.
c
c     band storage
c
c           if  a  is a band matrix, the following program segment
c           will set up the input.
c
c                   ml = (band width below the diagonal)
c                   mu = (band width above the diagonal)
c                   m = ml + mu + 1
c                   do 20 j = 1, n
c                      i1 = max0(1, j-mu)
c                      i2 = min0(n, j+ml)
c                      do 10 i = i1, i2
c                         k = i - j + m
c                         abd(k,j) = a(i,j)
c                10    continue
c                20 continue
c
c           this uses rows  ml+1  through  2*ml+mu+1  of  abd .
c           in addition, the first  ml  rows in  abd  are used for
c           elements generated during the triangularization.
c           the total number of rows needed in  abd  is  2*ml+mu+1 .
c           the  ml+mu by ml+mu  upper left triangle and the
c           ml by ml  lower right triangle are not referenced.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c     fortran max0,min0
c
c     internal variables
c
      double precision t
      integer i,idamax,i0,j,ju,jz,j0,j1,k,kp1,l,lm,m,mm,nm1
c
c
      m = ml + mu + 1
      info = 0
c
c     zero initial fill-in columns
c
      j0 = mu + 2
      j1 = min0(n,m) - 1
      if (j1 .lt. j0) go to 30
      do 20 jz = j0, j1
         i0 = m + 1 - jz
         do 10 i = i0, ml
            abd(i,jz) = 0.0d0
   10    continue
   20 continue
   30 continue
      jz = j1
      ju = 0
c
c     gaussian elimination with partial pivoting
c
      nm1 = n - 1
      if (nm1 .lt. 1) go to 130
      do 120 k = 1, nm1
         kp1 = k + 1
c
c        zero next fill-in column
c
         jz = jz + 1
         if (jz .gt. n) go to 50
         if (ml .lt. 1) go to 50
            do 40 i = 1, ml
               abd(i,jz) = 0.0d0
   40       continue
   50    continue
c
c        find l = pivot index
c
         lm = min0(ml,n-k)
         l = idamax(lm+1,abd(m,k),1) + m - 1
         ipvt(k) = l + k - m
c
c        zero pivot implies this column already triangularized
c
         if (abd(l,k) .eq. 0.0d0) go to 100
c
c           interchange if necessary
c
            if (l .eq. m) go to 60
               t = abd(l,k)
               abd(l,k) = abd(m,k)
               abd(m,k) = t
   60       continue
c
c           compute multipliers
c
            t = -1.0d0/abd(m,k)
            call dscal(lm,t,abd(m+1,k),1)
c
c           row elimination with column indexing
c
            ju = min0(max0(ju,mu+ipvt(k)),n)
            mm = m
            if (ju .lt. kp1) go to 90
            do 80 j = kp1, ju
               l = l - 1
               mm = mm - 1
               t = abd(l,j)
               if (l .eq. mm) go to 70
                  abd(l,j) = abd(mm,j)
                  abd(mm,j) = t
   70          continue
               call daxpy(lm,t,abd(m+1,k),1,abd(mm+1,j),1)
   80       continue
   90       continue
         go to 110
  100    continue
            info = k
  110    continue
  120 continue
  130 continue
      ipvt(n) = n
      if (abd(m,n) .eq. 0.0d0) info = n
      return
      end
      subroutine dgefa(a,lda,n,ipvt,info)
cgy      integer lda,n,ipvt(1),info
cgy      double precision a(lda,1)
      integer lda,n,ipvt(n),info
      double precision a(lda,n)
c
c     dgefa factors a double precision matrix by gaussian elimination.
c
c     dgefa is usually called by dgeco, but it can be called
c     directly with a saving in time if  rcond  is not needed.
c     (time for dgeco) = (1 + 9/n)*(time for dgefa) .
c
c     on entry
c
c        a       double precision(lda, n)
c                the matrix to be factored.
c
c        lda     integer
c                the leading dimension of the array  a .
c
c        n       integer
c                the order of the matrix  a .
c
c     on return
c
c        a       an upper triangular matrix and the multipliers
c                which were used to obtain it.
c                the factorization can be written  a = l*u  where
c                l  is a product of permutation and unit lower
c                triangular matrices and  u  is upper triangular.
c
c        ipvt    integer(n)
c                an integer vector of pivot indices.
c
c        info    integer
c                = 0  normal value.
c                = k  if  u(k,k) .eq. 0.0 .  this is not an error
c                     condition for this subroutine, but it does
c                     indicate that dgesl or dgedi will divide by zero
c                     if called.  use  rcond  in dgeco for a reliable
c                     indication of singularity.
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,dscal,idamax
c
c     internal variables
c
      double precision t
      integer idamax,j,k,kp1,l,nm1
c
c
c     gaussian elimination with partial pivoting
c
      info = 0
      nm1 = n - 1
      if (nm1 .lt. 1) go to 70
      do 60 k = 1, nm1
         kp1 = k + 1
c
c        find l = pivot index
c
         l = idamax(n-k+1,a(k,k),1) + k - 1
         ipvt(k) = l
c
c        zero pivot implies this column already triangularized
c
         if (a(l,k) .eq. 0.0d0) go to 40
c
c           interchange if necessary
c
            if (l .eq. k) go to 10
               t = a(l,k)
               a(l,k) = a(k,k)
               a(k,k) = t
   10       continue
c
c           compute multipliers
c
            t = -1.0d0/a(k,k)
            call dscal(n-k,t,a(k+1,k),1)
c
c           row elimination with column indexing
c
            do 30 j = kp1, n
               t = a(l,j)
               if (l .eq. k) go to 20
                  a(l,j) = a(k,j)
                  a(k,j) = t
   20          continue
               call daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
   30       continue
         go to 50
   40    continue
            info = k
   50    continue
   60 continue
   70 continue
      ipvt(n) = n
      if (a(n,n) .eq. 0.0d0) info = n
      return
      end
      integer function idamax(n,dx,incx)
c
c     finds the index of element having max. absolute value.
c     jack dongarra, linpack, 3/11/78.
c     modified 3/93 to return if incx .le. 0.
c     modified 12/3/93, array(1) declarations changed to array(*)
c
      double precision dx(*),dmax
      integer i,incx,ix,n
c
      idamax = 0
      if( n.lt.1 .or. incx.le.0 ) return
      idamax = 1
      if(n.eq.1)return
      if(incx.eq.1)go to 20
c
c        code for increment not equal to 1
c
      ix = 1
      dmax = dabs(dx(1))
      ix = ix + incx
      do 10 i = 2,n
         if(dabs(dx(ix)).le.dmax) go to 5
         idamax = i
         dmax = dabs(dx(ix))
    5    ix = ix + incx
   10 continue
      return
c
c        code for increment equal to 1
c
   20 dmax = dabs(dx(1))
      do 30 i = 2,n
         if(dabs(dx(i)).le.dmax) go to 30
         idamax = i
         dmax = dabs(dx(i))
   30 continue
      return
      end
      subroutine dgbsl(abd,lda,n,ml,mu,ipvt,b,job)
cgy      integer lda,n,ml,mu,ipvt(1),job
cgy      double precision abd(lda,1),b(1)
      integer lda,n,ml,mu,ipvt(n),job
      double precision abd(lda,n),b(n)
c
c     dgbsl solves the double precision band system
c     a * x = b  or  trans(a) * x = b
c     using the factors computed by dgbco or dgbfa.
c
c     on entry
c
c        abd     double precision(lda, n)
c                the output from dgbco or dgbfa.
c
c        lda     integer
c                the leading dimension of the array  abd .
c
c        n       integer
c                the order of the original matrix.
c
c        ml      integer
c                number of diagonals below the main diagonal.
c
c        mu      integer
c                number of diagonals above the main diagonal.
c
c        ipvt    integer(n)
c                the pivot vector from dgbco or dgbfa.
c
c        b       double precision(n)
c                the right hand side vector.
c
c        job     integer
c                = 0         to solve  a*x = b ,
c                = nonzero   to solve  trans(a)*x = b , where
c                            trans(a)  is the transpose.
c
c     on return
c
c        b       the solution vector  x .
c
c     error condition
c
c        a division by zero will occur if the input factor contains a
c        zero on the diagonal.  technically this indicates singularity
c        but it is often caused by improper arguments or improper
c        setting of lda .  it will not occur if the subroutines are
c        called correctly and if dgbco has set rcond .gt. 0.0
c        or dgbfa has set info .eq. 0 .
c
c     to compute  inverse(a) * c  where  c  is a matrix
c     with  p  columns
c           call dgbco(abd,lda,n,ml,mu,ipvt,rcond,z)
c           if (rcond is too small) go to ...
c           do 10 j = 1, p
c              call dgbsl(abd,lda,n,ml,mu,ipvt,c(1,j),0)
c        10 continue
c
c     linpack. this version dated 08/14/78 .
c     cleve moler, university of new mexico, argonne national lab.
c
c     subroutines and functions
c
c     blas daxpy,ddot
c     fortran min0
c
c     internal variables
c
      double precision ddot,t
      integer k,kb,l,la,lb,lm,m,nm1
c
      m = mu + ml + 1
      nm1 = n - 1
      if (job .ne. 0) go to 50
c
c        job = 0 , solve  a * x = b
c        first solve l*y = b
c
         if (ml .eq. 0) go to 30
         if (nm1 .lt. 1) go to 30
            do 20 k = 1, nm1
               lm = min0(ml,n-k)
               l = ipvt(k)
               t = b(l)
               if (l .eq. k) go to 10
                  b(l) = b(k)
                  b(k) = t
   10          continue
               call daxpy(lm,t,abd(m+1,k),1,b(k+1),1)
   20       continue
   30    continue
c
c        now solve  u*x = y
c
         do 40 kb = 1, n
            k = n + 1 - kb
            b(k) = b(k)/abd(m,k)
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = -b(k)
            call daxpy(lm,t,abd(la,k),1,b(lb),1)
   40    continue
      go to 100
   50 continue
c
c        job = nonzero, solve  trans(a) * x = b
c        first solve  trans(u)*y = b
c
         do 60 k = 1, n
            lm = min0(k,m) - 1
            la = m - lm
            lb = k - lm
            t = ddot(lm,abd(la,k),1,b(lb),1)
            b(k) = (b(k) - t)/abd(m,k)
   60    continue
c
c        now solve trans(l)*x = y
c
         if (ml .eq. 0) go to 90
         if (nm1 .lt. 1) go to 90
            do 80 kb = 1, nm1
               k = n - kb
               lm = min0(ml,n-k)
               b(k) = b(k) + ddot(lm,abd(m+1,k),1,b(k+1),1)
               l = ipvt(k)
               if (l .eq. k) go to 70
                  t = b(l)
                  b(l) = b(k)
                  b(k) = t
   70          continue
   80       continue
   90    continue
  100 continue
      return
      end
      double precision function d1mach(i)
      integer i
c
c  double-precision machine constants
c  d1mach( 1) = b**(emin-1), the smallest positive magnitude.
c  d1mach( 2) = b**emax*(1 - b**(-t)), the largest magnitude.
c  d1mach( 3) = b**(-t), the smallest relative spacing.
c  d1mach( 4) = b**(1-t), the largest relative spacing.
c  d1mach( 5) = log10(b)
c
      integer small(2)
      integer large(2)
      integer right(2)
      integer diver(2)
      integer log10(2)
      integer sc, cray1(38), j
      common /d9mach/ cray1
      save small, large, right, diver, log10, sc
      double precision dmach(5)
      double precision b, x
      equivalence (dmach(1),small(1))
      equivalence (dmach(2),large(1))
      equivalence (dmach(3),right(1))
      equivalence (dmach(4),diver(1))
      equivalence (dmach(5),log10(1))
c  this version adapts automatically to most current machines.
c  r1mach can handle auto-double compiling, but this version of
c  d1mach does not, because we do not have quad constants for
c  many machines yet.
c  to compile on older machines, add a c in column 1
c  on the next line
      data sc/0/
c  and remove the c from column 1 in one of the sections below.
c  constants for even older machines can be obtained by
c          mail netlib@research.bell-labs.com
c          send old1mach from blas
c  please send corrections to dmg or ehg@bell-labs.com.
c
c     machine constants for the honeywell dps 8/70 series.
c      data small(1),small(2) / o402400000000, o000000000000 /
c      data large(1),large(2) / o376777777777, o777777777777 /
c      data right(1),right(2) / o604400000000, o000000000000 /
c      data diver(1),diver(2) / o606400000000, o000000000000 /
c      data log10(1),log10(2) / o776464202324, o117571775714 /, sc/987/
c
c     machine constants for pdp-11 fortrans supporting
c     32-bit integers.
c      data small(1),small(2) /    8388608,           0 /
c      data large(1),large(2) / 2147483647,          -1 /
c      data right(1),right(2) /  612368384,           0 /
c      data diver(1),diver(2) /  620756992,           0 /
c      data log10(1),log10(2) / 1067065498, -2063872008 /, sc/987/
c
c     machine constants for the univac 1100 series.
c      data small(1),small(2) / o000040000000, o000000000000 /
c      data large(1),large(2) / o377777777777, o777777777777 /
c      data right(1),right(2) / o170540000000, o000000000000 /
c      data diver(1),diver(2) / o170640000000, o000000000000 /
c      data log10(1),log10(2) / o177746420232, o411757177572 /, sc/987/
c
c     on first call, if no data uncommented, test machine types.
      if (sc .ne. 987) then
         dmach(1) = 1.d13
         if (      small(1) .eq. 1117925532
     *       .and. small(2) .eq. -448790528) then
*           *** ieee big endian ***
            small(1) = 1048576
            small(2) = 0
            large(1) = 2146435071
            large(2) = -1
            right(1) = 1017118720
            right(2) = 0
            diver(1) = 1018167296
            diver(2) = 0
            log10(1) = 1070810131
            log10(2) = 1352628735
         else if ( small(2) .eq. 1117925532
     *       .and. small(1) .eq. -448790528) then
*           *** ieee little endian ***
            small(2) = 1048576
            small(1) = 0
            large(2) = 2146435071
            large(1) = -1
            right(2) = 1017118720
            right(1) = 0
            diver(2) = 1018167296
            diver(1) = 0
            log10(2) = 1070810131
            log10(1) = 1352628735
         else if ( small(1) .eq. -2065213935
     *       .and. small(2) .eq. 10752) then
*               *** vax with d_floating ***
            small(1) = 128
            small(2) = 0
            large(1) = -32769
            large(2) = -1
            right(1) = 9344
            right(2) = 0
            diver(1) = 9472
            diver(2) = 0
            log10(1) = 546979738
            log10(2) = -805796613
         else if ( small(1) .eq. 1267827943
     *       .and. small(2) .eq. 704643072) then
*               *** ibm mainframe ***
            small(1) = 1048576
            small(2) = 0
            large(1) = 2147483647
            large(2) = -1
            right(1) = 856686592
            right(2) = 0
            diver(1) = 873463808
            diver(2) = 0
            log10(1) = 1091781651
            log10(2) = 1352628735
         else if ( small(1) .eq. 1120022684
     *       .and. small(2) .eq. -448790528) then
*           *** convex c-1 ***
            small(1) = 1048576
            small(2) = 0
            large(1) = 2147483647
            large(2) = -1
            right(1) = 1019215872
            right(2) = 0
            diver(1) = 1020264448
            diver(2) = 0
            log10(1) = 1072907283
            log10(2) = 1352628735
         else if ( small(1) .eq. 815547074
     *       .and. small(2) .eq. 58688) then
*           *** vax g-floating ***
            small(1) = 16
            small(2) = 0
            large(1) = -32769
            large(2) = -1
            right(1) = 15552
            right(2) = 0
            diver(1) = 15568
            diver(2) = 0
            log10(1) = 1142112243
            log10(2) = 2046775455
         else
c
c------------------------------------------
c  --- Modified by Gary Wilson / Ramboll
c         Fri Oct 29 16:52:14 PDT 2010
c      Use F90 Intrinsic functions to get
c      the value of d1mach(4)
c------------------------------------------
c
             x = 1.0D0
             b = RADIX(X)
             dmach(4) = b**(1-DIGITS(x))
             if( i .NE. 4 ) then
               write(iout,'(//,A)') 'ERROR in LINPAC:'
               write(iout,'(/,2A)') ' This version only supports ',
     &                                'D1MACH for an argument of 4.'
               write(iout,'(2A)')  ' Other values returned from ',
     &                               'D1MACH are not accurate.'
               call camxerr()
             endif
c
c------------------------------------------
c
CENVIRON            dmach(2) = 1.d27 + 1
CENVIRON            dmach(3) = 1.d27
CENVIRON            large(2) = large(2) - right(2)
CENVIRON            if (large(2) .eq. 64 .and. small(2) .eq. 0) then
CENVIRON               cray1(1) = 67291416
CENVIRON               do 10 j = 1, 20
CENVIRON                  cray1(j+1) = cray1(j) + cray1(j)
CENVIRON 10               continue
CENVIRON               cray1(22) = cray1(21) + 321322
CENVIRON               do 20 j = 22, 37
CENVIRON                  cray1(j+1) = cray1(j) + cray1(j)
CENVIRON 20               continue
CENVIRON               if (cray1(38) .eq. small(1)) then
CENVIRON*                  *** cray ***
CENVIRON                  call i1mcry(small(1), j, 8285, 8388608, 0)
CENVIRON                  small(2) = 0
CENVIRON                  call i1mcry(large(1), j, 24574, 16777215, 16777215)
CENVIRON                  call i1mcry(large(2), j, 0, 16777215, 16777214)
CENVIRON                  call i1mcry(right(1), j, 16291, 8388608, 0)
CENVIRON                  right(2) = 0
CENVIRON                  call i1mcry(diver(1), j, 16292, 8388608, 0)
CENVIRON                  diver(2) = 0
CENVIRON                  call i1mcry(log10(1), j, 16383, 10100890, 8715215)
CENVIRON                  call i1mcry(log10(2), j, 0, 16226447, 9001388)
CENVIRON               else
CENVIRON                  write(*,9000)
CENVIRON                  stop 779
CENVIRON                  end if
CENVIRON            else
CENVIRON               write(*,9000)
CENVIRON               stop 779
CENVIRON               end if
            end if
         sc = 987
         end if
*    sanity check
      if (dmach(4) .ge. 1.0d0) stop 778
      if (i .lt. 1 .or. i .gt. 5) then
         write(*,*) 'd1mach(i): i =',i,' is out of bounds.'
         stop
         end if
      d1mach = dmach(i)
      return
 9000 format(/' adjust d1mach by uncommenting data statements'/
     *' appropriate for your machine.')
* /* standard c source for d1mach -- remove the * in column 1 */
*#include <stdio.h>
*#include <float.h>
*#include <math.h>
*double d1mach_(long *i)
*{
*	switch(*i){
*	  case 1: return dbl_min;
*	  case 2: return dbl_max;
*	  case 3: return dbl_epsilon/flt_radix;
*	  case 4: return dbl_epsilon;
*	  case 5: return log10((double)flt_radix);
*	  }
*	fprintf(stderr, "invalid argument: d1mach(%ld)\n", *i);
*	exit(1); return 0; /* some compilers demand return values */
*}
      end
      subroutine i1mcry(a, a1, b, c, d)
**** special computation for old cray machines ****
      integer a, a1, b, c, d
      a1 = 16777216*b + c
      a = 16777216*a1 + d
      end

      real function r1mach(i)
      integer i
c
c  single-precision machine constants
c  r1mach(1) = b**(emin-1), the smallest positive magnitude.
c  r1mach(2) = b**emax*(1 - b**(-t)), the largest magnitude.
c  r1mach(3) = b**(-t), the smallest relative spacing.
c  r1mach(4) = b**(1-t), the largest relative spacing.
c  r1mach(5) = log10(b)
c
      integer small(2)
      integer large(2)
      integer right(2)
      integer diver(2)
      integer log10(2)
c     needs to be (2) for autodouble, harris slash 6, ...
      integer sc
      save small, large, right, diver, log10, sc
      real rmach(5)
      equivalence (rmach(1),small(1))
      equivalence (rmach(2),large(1))
      equivalence (rmach(3),right(1))
      equivalence (rmach(4),diver(1))
      equivalence (rmach(5),log10(1))
      integer j, k, l, t3e(3)
      data t3e(1) / 9777664 /
      data t3e(2) / 5323660 /
      data t3e(3) / 46980 /
c  this version adapts automatically to most current machines,
c  including auto-double compilers.
c  to compile on older machines, add a c in column 1
c  on the next line
      data sc/0/
c  and remove the c from column 1 in one of the sections below.
c  constants for even older machines can be obtained by
c          mail netlib@research.bell-labs.com
c          send old1mach from blas
c  please send corrections to dmg or ehg@bell-labs.com.
c
c     machine constants for the honeywell dps 8/70 series.
c      data rmach(1) / o402400000000 /
c      data rmach(2) / o376777777777 /
c      data rmach(3) / o714400000000 /
c      data rmach(4) / o716400000000 /
c      data rmach(5) / o776464202324 /, sc/987/
c
c     machine constants for pdp-11 fortrans supporting
c     32-bit integers (expressed in integer and octal).
c      data small(1) /    8388608 /
c      data large(1) / 2147483647 /
c      data right(1) /  880803840 /
c      data diver(1) /  889192448 /
c      data log10(1) / 1067065499 /, sc/987/
c      data rmach(1) / o00040000000 /
c      data rmach(2) / o17777777777 /
c      data rmach(3) / o06440000000 /
c      data rmach(4) / o06500000000 /
c      data rmach(5) / o07746420233 /, sc/987/
c
c     machine constants for the univac 1100 series.
c      data rmach(1) / o000400000000 /
c      data rmach(2) / o377777777777 /
c      data rmach(3) / o146400000000 /
c      data rmach(4) / o147400000000 /
c      data rmach(5) / o177464202324 /, sc/987/
c
      if (sc .ne. 987) then
*        *** check for autodouble ***
         small(2) = 0
         rmach(1) = 1e13
         if (small(2) .ne. 0) then
*           *** autodoubled ***
            if (      small(1) .eq. 1117925532
     *          .and. small(2) .eq. -448790528) then
*              *** ieee big endian ***
               small(1) = 1048576
               small(2) = 0
               large(1) = 2146435071
               large(2) = -1
               right(1) = 1017118720
               right(2) = 0
               diver(1) = 1018167296
               diver(2) = 0
               log10(1) = 1070810131
               log10(2) = 1352628735
            else if ( small(2) .eq. 1117925532
     *          .and. small(1) .eq. -448790528) then
*              *** ieee little endian ***
               small(2) = 1048576
               small(1) = 0
               large(2) = 2146435071
               large(1) = -1
               right(2) = 1017118720
               right(1) = 0
               diver(2) = 1018167296
               diver(1) = 0
               log10(2) = 1070810131
               log10(1) = 1352628735
            else if ( small(1) .eq. -2065213935
     *          .and. small(2) .eq. 10752) then
*              *** vax with d_floating ***
               small(1) = 128
               small(2) = 0
               large(1) = -32769
               large(2) = -1
               right(1) = 9344
               right(2) = 0
               diver(1) = 9472
               diver(2) = 0
               log10(1) = 546979738
               log10(2) = -805796613
            else if ( small(1) .eq. 1267827943
     *          .and. small(2) .eq. 704643072) then
*              *** ibm mainframe ***
               small(1) = 1048576
               small(2) = 0
               large(1) = 2147483647
               large(2) = -1
               right(1) = 856686592
               right(2) = 0
               diver(1) = 873463808
               diver(2) = 0
               log10(1) = 1091781651
               log10(2) = 1352628735
            else
               write(*,9010)
               stop 777
               end if
         else
            rmach(1) = 1234567.
            if (small(1) .eq. 1234613304) then
*              *** ieee ***
               small(1) = 8388608
               large(1) = 2139095039
               right(1) = 864026624
               diver(1) = 872415232
               log10(1) = 1050288283
            else if (small(1) .eq. -1271379306) then
*              *** vax ***
               small(1) = 128
               large(1) = -32769
               right(1) = 13440
               diver(1) = 13568
               log10(1) = 547045274
            else if (small(1) .eq. 1175639687) then
*              *** ibm mainframe ***
               small(1) = 1048576
               large(1) = 2147483647
               right(1) = 990904320
               diver(1) = 1007681536
               log10(1) = 1091781651
            else if (small(1) .eq. 1251390520) then
*              *** convex c-1 ***
               small(1) = 8388608
               large(1) = 2147483647
               right(1) = 880803840
               diver(1) = 889192448
               log10(1) = 1067065499
            else
               do 10 l = 1, 3
                  j = small(1) / 10000000
                  k = small(1) - 10000000*j
                  if (k .ne. t3e(l)) go to 20
                  small(1) = j
 10               continue
*              *** cray t3e ***
               call i1mcra(small, k, 16, 0, 0)
               call i1mcra(large, k, 32751, 16777215, 16777215)
               call i1mcra(right, k, 15520, 0, 0)
               call i1mcra(diver, k, 15536, 0, 0)
               call i1mcra(log10, k, 16339, 4461392, 10451455)
               go to 30
 20            call i1mcra(j, k, 16405, 9876536, 0)
               if (small(1) .ne. j) then
                  write(*,9020)
                  stop 777
                  end if
*              *** cray 1, xmp, 2, and 3 ***
               call i1mcra(small(1), k, 8195, 8388608, 1)
               call i1mcra(large(1), k, 24574, 16777215, 16777214)
               call i1mcra(right(1), k, 16338, 8388608, 0)
               call i1mcra(diver(1), k, 16339, 8388608, 0)
               call i1mcra(log10(1), k, 16383, 10100890, 8715216)
               end if
            end if
 30      sc = 987
         end if
*     sanity check
      if (rmach(4) .ge. 1.0) stop 776
      if (i .lt. 1 .or. i .gt. 5) then
         write(*,*) 'r1mach(i): i =',i,' is out of bounds.'
         stop
         end if
      r1mach = rmach(i)
      return
 9010 format(/' adjust autodoubled r1mach by getting data'/
     *' appropriate for your machine from d1mach.')
 9020 format(/' adjust r1mach by uncommenting data statements'/
     *' appropriate for your machine.')
* /* c source for r1mach -- remove the * in column 1 */
*#include <stdio.h>
*#include <float.h>
*#include <math.h>
*float r1mach_(long *i)
*{
*       switch(*i){
*         case 1: return flt_min;
*         case 2: return flt_max;
*         case 3: return flt_epsilon/flt_radix;
*         case 4: return flt_epsilon;
*         case 5: return log10((double)flt_radix);
*         }
*       fprintf(stderr, "invalid argument: r1mach(%ld)\n", *i);
*       exit(1); return 0; /* else complaint of missing return value */
*}
      end
      subroutine i1mcra(a, a1, b, c, d)
**** special computation for cray machines ****
      integer a, a1, b, c, d
      a1 = 16777216*b + c
      a = 16777216*a1 + d
      end

c*** OSATSA
c
      subroutine osatsa(numcol,numrow,numlay,igrid,icell,jcell,kcell,
     &                              prdO3N,prdO3V,desto3,nspc,delcon,
     &                                   convfac,cold,rrxn_irr,dtime)
      use grid
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine makes the "chemistry" adjustments to the tracer 
c     species.  The adjustments are based on the differences in 
c     concentrations of the regular model species before and after
c     the regular model chemistry.  This is essentially an adjustment
c     for production or decay.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol    I  number of columns in this slice
c       numrow    I  number of rows in this slice
c       numlay    I  number of layers in this slice
c       igrid     I  grid number
c       icell     I  the X grid location of current cell
c       jcell     I  the X grid location of current cell
c       kcell     I  the vertical grid location of current layer
c       prdO3N    R  ozone production attributed to NOx
c       prdO3V    R  ozone production attributed to VOC
c       desto3    R  ozone destruction
c       nspc      I  number of model species
c       delcon    R  array of change in each species contrntrations
c       convfac   R  conversion factor used for lower bound value
c       cold      R  array of concentrations at last time step
c       rrxn_irr  R  array of reactions from last chemistry step
c       dtime     R  change in time for current time step 
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     05/22/97   --gwilson--  Now re-calculates the sum of VOC after
c                             adjustment using wtkoh.
c     09/20/03   --gwilson--  Changed the individual species args to
c                             a vector
c     07/20/04   --gwilson--  Changed for OSAT2 (ozone destruction)
c     07/27/15   --gyarwood-  Changed for OSAT3 (NO2 apportioned)
c     09/11/15   --bkoo--     Merged APCA
c     08/25/16   --gyarwood-  Updated for CB6r4
c     11/09/16   --cemery--   Added Baker APCA point source override option
c     10/16/17   --bkoo--     Changed DELCON size
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   numcol
      integer   numrow
      integer   numlay
      integer   igrid
      integer   icell
      integer   jcell
      integer   kcell
      real      prdO3N
      real      prdO3V
      real      desto3
      integer   nspc
      real      delcon(4,nspc+1)
      real      convfac
      real      cold(*)
      real      rrxn_irr(*)
      real      dtime
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer*8 idxcel, idx
      integer*8 idx_NIT, idx_HN3, idx_TPN, idx_NTR, idx_OO
      integer   i, i_N, iHN3, iTPN, iNTR, iOO, iVOC
      integer   istr1,istr2

      real      ptc1d(MXTRSP)
      real      sumNIT, sumHN3, sumTPN, sumNTR, sumRGN
      real      sumOO, sumO3, sumkOH, sumMIR, delVOC
      real      destRGN, prodRGN, NIT2RGN, RGN2NIT
      real      alphaRGN, betaRGN, gammaRGN, alphaNIT, cycNIT
      real      alphaNTR, betaNTR, alphaHN3
      real      alphaTPN, betaTPN, gammaTPN, cycTPN
      real      pairNOX, prodOO, destOO, OOtoO3, pairOO

      real      bioNIT, bioVOC, facbio, O3used
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- calculate the index of the cell in the grid ---
c
      idxcel =  ipsa3d(igrid)-1 + DBLE(icell) + DBLE(numcol) * 
     &                DBLE(jcell-1) + DBLE(numcol) * DBLE(numrow) * 
     &                                                    DBLE(kcell-1)
      istr1 = 4
      istr2 = 6
      if (lapcapt) then
        istr1 = 7
        istr2 = 9
      endif

      do i = 1, ntotsp
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                 DBLE(numlay) * DBLE(i-1)
         ptc1d(i) = ptconc(idx)
      enddo
c
c  --- get the sum of the tracer species for N ----
c
      sumNIT = 0.
      bioNIT = 0.
      do i=iptcls(idxipt(ITRNIT)),nptcls(idxipt(ITRNIT))
         sumNIT = sumNIT + ptc1d(i)
         if( ptname(i)(istr1:istr2) .EQ. '001' ) bioNIT = bioNIT + ptc1d(i)
      enddo
      sumNIT = MAX(BNDLPT, sumNIT)
      bioNIT = MAX(BNDLPT, bioNIT)
c
c  --- get the sum of the tracer species for HN3 ----
c
      sumHN3 = 0.
      do i=iptcls(idxipt(ITRHN3)),nptcls(idxipt(ITRHN3))
         sumHN3 = sumHN3 + ptc1d(i)
      enddo
      sumHN3 = MAX(BNDLPT, sumHN3)
c
c  --- get the sum of the tracer species for TPN ----
c
      sumTPN = 0.
      do i=iptcls(idxipt(ITRTPN)),nptcls(idxipt(ITRTPN))
         sumTPN = sumTPN + ptc1d(i)
      enddo
      sumTPN = MAX(BNDLPT, sumTPN)
c
c  --- get the sum of the tracer species for NTR ----
c
      sumNTR = 0.
      do i=iptcls(idxipt(ITRNTR)),nptcls(idxipt(ITRNTR))
         sumNTR = sumNTR + ptc1d(i)
      enddo
      sumNTR = MAX(BNDLPT, sumNTR)
c
c  --- get the sum of the tracer species for RGN ----
c
      sumRGN = 0.
      do i=iptcls(idxipt(ITRRGN)),nptcls(idxipt(ITRRGN))
         sumRGN = sumRGN + ptc1d(i)
      enddo
      sumRGN = MAX(BNDLPT, sumRGN)
c
c  --- call routine to calculate the cycle coefficients ---
c
      call cyctpnsa(nspec,convfac,cold,delcon,rrxn_irr,
     &              destRGN,prodRGN,NIT2RGN,RGN2NIT,
     &              alphaRGN,betaRGN,gammaRGN,alphaNIT,cycNIT,
     &              alphaNTR,betaNTR,alphaHN3,alphaTPN,betaTPN,
     &              gammaTPN,cycTPN)
c
c  --- adjust RGN, NIT, HN3, TPN and NTR tracers ----
c
      i_N  = iptcls(idxipt(ITRNIT)) - 1
      iHN3 = iptcls(idxipt(ITRHN3)) - 1
      iTPN = iptcls(idxipt(ITRTPN)) - 1
      iNTR = iptcls(idxipt(ITRNTR)) - 1
c
      do i=iptcls(idxipt(ITRRGN)),nptcls(idxipt(ITRRGN))
         i_N  = i_N  + 1
         iHN3 = iHN3 + 1
         iTPN = iTPN + 1
         iNTR = iNTR + 1
c
         pairNOX = ptc1d(i) + ptc1d(i_N)
c
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                            DBLE(numlay) * DBLE(i-1)
         ptconc(idx) =
     &      sumRGN * ( (1.0 - cycNIT) * ptc1d(i) / sumRGN +
     &                 (cycNIT * pairNOX / (sumNIT + sumRGN)) )
     &      + NIT2RGN * ptc1d(i_N) / sumNIT
     &          - (RGN2NIT + alphaRGN + betaRGN +
     &                           gammaRGN) * ptc1d(i) / sumRGN
     &              + alphaNTR * ptc1d(iNTR) / sumNTR
     &                   + alphaHN3 * ptc1d(iHN3) / sumHN3
     &                        + betaTPN * ptc1d(iTPN) / sumTPN
c
         idx_NIT = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                            DBLE(numlay) * DBLE(i_N-1)
         ptconc(idx_NIT) =
     &      sumNIT * ( (1.0-cycNIT) * ptc1d(i_N) / sumNIT +
     &                 (cycNIT * pairNOX / (sumNIT + sumRGN)) )
     &      + RGN2NIT * ptc1d(i) / sumRGN
     &         - (NIT2RGN + alphaNIT) * ptc1d(i_N) / sumNIT
c
         idx_HN3 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                            DBLE(numlay) * DBLE(iHN3-1)
         ptconc(idx_HN3) = ptconc(idx_HN3)
     &      + gammaRGN * ptc1d(i) / sumRGN
     &         + betaNTR * ptc1d(iNTR) / sumNTR
     &            + alphaTPN * ptc1d(iTPN) / sumTPN
     &               - alphaHN3 * ptc1d(iHN3) / sumHN3
c
         idx_TPN = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                        DBLE(numlay) * DBLE(iTPN-1)
         ptconc(idx_TPN) = ptconc(idx_TPN)
     &      + betaRGN * ptc1d(i) / sumRGN
     &         - (alphaTPN + betaTPN + gammaTPN) * ptc1d(iTPN) / sumTPN
c
         idx_NTR = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                            DBLE(numlay) * DBLE(iNTR-1)
         ptconc(idx_NTR) = ptconc(idx_NTR)
     &      + alphaNIT * ptc1d(i_N) / sumNIT
     &         + alphaRGN * ptc1d(i) / sumRGN
     &            + gammaTPN * ptc1d(iTPN) / sumTPN
     &               - (alphaNTR + betaNTR) * ptc1d(iNTR) / sumNTR
c
         ptconc(idx)     = MAX(BNDLPT,ptconc(idx))
         ptconc(idx_NIT) = MAX(BNDLPT,ptconc(idx_NIT))
         ptconc(idx_HN3) = MAX(BNDLPT,ptconc(idx_HN3))
         ptconc(idx_TPN) = MAX(BNDLPT,ptconc(idx_TPN))
         ptconc(idx_NTR) = MAX(BNDLPT,ptconc(idx_NTR))
      enddo
c
c   --- if no O3 tracer, return here ---
c
      if( .NOT. lozone ) return
c
c  --- get the sum of the tracer species for O3N/O3V ----
c
      sumO3 = 0.
      do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3V))
         sumO3 = sumO3 + ptc1d(i)
      enddo
      sumO3 = MAX(BNDLPT, sumO3)
c
c  --- get the sum of the tracer species for OON/OOV ----
c
      sumOO = 0.
      do i=iptcls(idxipt(ITROON)),nptcls(idxipt(ITROOV))
         sumOO = sumOO + ptc1d(i)
      enddo
      sumOO = MAX(BNDLPT, sumOO)
c
c   --- set the local variable for VOC species concs ---
c
      delVOC = 0.
      do i=1,nspec
        if( lvocsp(i) ) delVOC = delVOC + delcon(1,i) * crbnum(i)
      enddo
c
c   --- loop over the VOC tracer species, calculate reactivity ---
c
      sumkOH = 0.
      sumMIR = 0.
      bioVOC = 0.
      do i=iptcls(idxipt(ITRVOC)),nptcls(idxipt(ITRVOC))
         sumkOH = sumkOH + ptc1d(i) * wtkoh(i)
         sumMIR = sumMIR + ptc1d(i) * wtmir(i)
         if( ptname(i)(istr1:istr2) .EQ. '001' )
     &                        bioVOC = bioVOC + ptc1d(i) * wtmir(i)
      enddo
      sumkOH = MAX(BNDLPT, sumkOH)
      sumMIR = MAX(BNDLPT, sumMIR)
      bioVOC = MAX(BNDLPT, bioVOC)
c
c   ---- decay VOC tracers ---
c
      do i=iptcls(idxipt(ITRVOC)),nptcls(idxipt(ITRVOC))
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(i-1)
         ptconc(idx) = ptconc(idx) + 
     &                 delVOC * ptc1d(i) * wtkoh(i) / sumkOH
         ptconc(idx) = MAX(BNDLPT,ptconc(idx))
      enddo
c
c  --- update OON/OOV and allocate any ozone from NO2 destruction ---
c
      prodOO = prodRGN
      destOO = destRGN

      OOtoO3 = MIN( destOO, prdO3N + prdO3V )
      if( prdO3V .GT. 0.) then
         prdO3V = prdO3V - OOtoO3
      else
         prdO3N = prdO3N - OOtoO3
      endif
c
      iOO = iptcls(idxipt(ITROON)) - 1
      do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3V))
         iOO = iOO + 1
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                             DBLE(numlay) * DBLE(i-1)
         idx_OO = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                             DBLE(numlay) * DBLE(iOO-1)
         pairOO = ptc1d(i) + ptc1d(iOO)
         ptconc(idx) =
     &      sumO3 * ( (1.0 - cycNIT) * ptc1d(i) / sumO3 +
     &                 (cycNIT * pairOO / (sumO3 + sumOO)) )
     &         + OOtoO3 * ptc1d(iOO) / sumOO
         ptconc(idx_OO) =
     &      sumOO * ( (1.0-cycNIT) * ptc1d(iOO) / sumOO +
     &                 (cycNIT * pairOO / (sumO3 + sumOO)) )
     &         - destOO * ptc1d(iOO) / sumOO
     &            + prodOO * ptc1d(i) / sumO3
         ptconc(idx_OO) = MAX(BNDLPT,ptconc(idx_OO))
      enddo
c
c  --- allocate any ozone destruction across all tracers ---
c
      if( desto3 .LT. 0. ) then
         do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3V))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                             DBLE(numlay) * DBLE(i-1)
            ptconc(idx) = ptconc(idx) + desto3 * ptc1d(i) / sumO3
         enddo
      endif
c
c  --- APCA
c
      if ( lapca ) then
c
c  --- set the biogenics contribution factor ---
c
         facbio = MIN( bioNIT/sumNIT, bioVOC/sumMIR )
c
c  --- allocate VOC sensitive ozone production based on MIRs,
c      increase the O3V tracers except where limited by APCA ---
c
         if( prdO3V .GT. 0. ) then
            O3used = 0.
            iVOC = iptcls(idxipt(ITRVOC)) - 1
            do i=iptcls(idxipt(ITRO3V)),nptcls(idxipt(ITRO3V))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(i-1)
               iVOC = iVOC + 1
c
c  --- add O3 to biogenics group (group 1) based on it's
c      mimimum potential contribution ---
c
               if( ptname(i)(istr1:istr2) .EQ. '001' ) then
                  ptconc(idx) = ptconc(idx) + facbio * prdO3V *
     &                          ptc1d(iVOC) * wtmir(iVOC) / bioVOC
                  O3used = O3used + facbio * prdO3V *
     &                          ptc1d(iVOC) * wtmir(iVOC) / bioVOC
c
c  --- add O3 to other groups based on contribution of VOC conc ---
c
               else
                  ptconc(idx) = ptconc(idx) + prdO3V *
     &                          ptc1d(iVOC) * wtmir(iVOC) / sumMIR
                  O3used = O3used + prdO3V *
     &                          ptc1d(iVOC) * wtmir(iVOC) / sumMIR
               endif
            enddo
c
c  --- add any ozone not accounted for to O3N tracers, based on
c      contribution to anthropognic NOx ---
c
            if( sumNIT .GT. bioNIT .AND. prdO3V .GT. O3used ) then
               i_N = iptcls(idxipt(ITRNIT)) - 1
               do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3N))
                  idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                 DBLE(numlay) * DBLE(i-1)
                  i_N = i_N + 1
                  if( ptname(i)(istr1:istr2) .NE. '001' ) then
                     ptconc(idx) = ptconc(idx) + (prdO3V - O3used) *
     &                             ptc1d(i_N) / (sumNIT - bioNIT)
                  endif
               enddo
            endif
         endif
c
c  --- allocate NOx sensitive ozone production,
c      increase the O3N tracers except where limited by APCA ---
c
         if( prdO3N .GT. 0. ) then
            O3used = 0.
            i_N = iptcls(idxipt(ITRNIT)) - 1
            do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3N))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
               i_N = i_N + 1
c
c  --- add O3 to biogenics group (group 1) based on it's
c      mimimum potential contribution ---
c
               if( ptname(i)(istr1:istr2) .EQ. '001' ) then
                  ptconc(idx) = ptconc(idx) + facbio * prdO3N *
     &                                        ptc1d(i_N) / bioNIT
                  O3used = O3used + facbio * prdO3N *
     &                                        ptc1d(i_N) / bioNIT
c
c  --- add O3 to other groups based on contribution of NOx conc ---
c
               else
                  ptconc(idx) = ptconc(idx) + prdO3N *
     &                                        ptc1d(i_N) / sumNIT
                  O3used = O3used + prdO3N * ptc1d(i_N) / sumNIT
               endif
            enddo
c
c  --- add any ozone not accounted for to O3V tracers, based on
c      contribution to anthropognic VOC ---
c
            if( sumMIR .GT. bioVOC .AND. prdO3N .GT. O3used ) then
               iVOC = iptcls(idxipt(ITRVOC)) - 1
               do i=iptcls(idxipt(ITRO3V)),nptcls(idxipt(ITRO3V))
                  idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
                  iVOC = iVOC + 1
                  if( ptname(i)(istr1:istr2) .NE. '001' ) then
                     ptconc(idx) = ptconc(idx) + (prdO3N - O3used) *
     &                  ptc1d(iVOC) * wtmir(iVOC) / (sumMIR - bioVOC)
                  endif
               enddo
            endif
         endif
c
c  --- OSAT
c
      else
c
c  --- allocate VOC sensitive ozone production based on MIRs,
c      increase the O3V tracers ---
c
         if( prdO3V .GT. 0. ) then
            iVOC = iptcls(idxipt(ITRVOC)) - 1
            do i=iptcls(idxipt(ITRO3V)),nptcls(idxipt(ITRO3V))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                    DBLE(numlay) * DBLE(i-1)
               iVOC = iVOC + 1
               ptconc(idx) = ptconc(idx) + prdO3V *
     &                       ptc1d(iVOC) * wtmir(iVOC) / sumMIR
            enddo
         endif
c
c  --- allocate NOx sensitive ozone production,
c      increase the O3N tracers ---
c
         if( prdO3N .GT. 0. ) then
            i_N = iptcls(idxipt(ITRNIT)) - 1
            do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3N))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                DBLE(numlay) * DBLE(i-1)
               i_N = i_N + 1
               ptconc(idx) = ptconc(idx) + prdO3N *
     &                                     ptc1d(i_N) / sumNIT
            enddo
         endif
c
      endif ! APCA?
c
c  --- lower bound of ozone tracers
c
      do i=iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3V))
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                             DBLE(numlay) * DBLE(i-1)
         ptconc(idx) = MAX(BNDLPT,ptconc(idx))
      enddo
c
c  --- decay the timing tracer species --- 
c
      if(ntrtim .GT. 0 ) then
         do i=ipttim+1,nsaspc,2
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                            DBLE(numlay) * DBLE(i-1)
            ptconc(idx) = ptconc(idx) * EXP( -0.08333333 * dtime )
            ptconc(idx) = MAX(BNDLPT,ptconc(idx))
         enddo
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine chrtime(time,date,chtime,chdate)
      implicit none
c
c----CAMx v7.40 260801
c
c     CHRTIME translates date/time variables to character strings for output
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        time            current simulation time (HHMMM)
c        date            current simulation date (YYJJJ)
c
c     Output arguments:
c        chtime          current simulation time ('HH:MM:SS')
c        chdate          current simulation date (YY/MM/DD)
c
c     Routines called:
c        none
c
c     Called by:
c        CAMx
c        NESTING
c
      integer date,ndate,iyr,imo,idy,ihr,imn,isc
      real time,rmn
      character*8 chtime,chdate
c
c-----Entry point
c
      ihr = int(time/100.)
      rmn = amod(time,100.)
      imn = int(rmn)
      isc = nint(60.*(rmn - float(imn)))
      if (isc.eq.60) then
        isc = 0
        imn = imn + 1
        if (imn.eq.60) then
          imn = 0
          ihr = ihr + 1
        endif
      endif
      write(chtime,'(i2.2,a,i2.2,a,i2.2)') ihr,':',imn,':',isc
c
      ndate = date
      call caldate(ndate)
      iyr = ndate/10000
      imo = mod(ndate,10000)/100
      idy = mod(ndate,100)
      write(chdate,'(i2.2,a,i2.2,a,i2.2)') iyr,'/',imo,'/',idy
c
      return
      end

C**** NOXCHEM
c
      subroutine noxchem(dt,bdnlo3,bdnlno,cno,cno2,co3,rnono)
      implicit none
c
c----CAMx v7.40 260801
c
c     NOXCHEM updates NOx and O3 concentrations in very highly concentrated
c     NOx puffs. It applies the NO + NO self-reaction and titrates O3 against 
c     NO. The titration is essentially complete because NO >> O3.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        dt                  time step (s)
c        bdnlo3              lower bound ozone concentration (ppm)
c        bdnlno              lower bound NO concentration (ppm)
c        cno                 NO concentration (ppm)
c        cno2                NO2 concentration (ppm)
c        co3                 O3 concentration (ppm)
c        rnono               NO self-reaction rate constant (ppm-1 hr-1)
c  
c     Output arguments:
c        cno                 NO concentration (ppm)
c        cno2                NO2 concentration (ppm)
c        co3                 O3 concentration (ppm)
c
c     Routines Called:
c        none
c
c     Called by:
c        PIGDRIVE
c
      real cno,cno2,co3,dt,bdnlo3,bdnlno
      real rnono,tmp
c
c-----Entry point
c
c-----NO-NO self reaction
c
      tmp = cno/(1. + rnono*dt*cno/3600.)
      cno2 = cno2 + (cno - tmp)
      cno = tmp 
c
c-----NO-O3 titration is essentially complete because NO is very high
c
      if (cno.le.bdnlno .or. co3.le.bdnlo3) goto 999
      if (co3.le.cno) then
        tmp = co3 - bdnlo3
        co3 = bdnlo3
        cno2 = cno2 + tmp
        cno = amax1((cno-tmp),bdnlno)
      else
        tmp = cno - bdnlno
        cno = bdnlno
        cno2 = cno2 + tmp
        co3 = amax1((co3-tmp),bdnlo3)
      endif
 999  continue
c
      return
      end

      subroutine pasetup
      use filunit
      use grid
      use chmstry
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     This routine initializes some of the data strucutures for the
c     Process Analysis algorithm.  The "species" names array is filled 
c     and the arrays are checked to make sure they have been allocated 
c     properly.  The pointers into the gridded arrays are initialized.
c
c      Copyright Ramboll
c
c     Modifications:
c        10/13/17 -bkoo-     Added aerosol pH to CPA variable list
c
c     Input arguments:
c        none
c
c     Subroutines Called:
c        CPAMECH
c
c     Called by:
c        STARTUP
c
      implicit none
      include 'camx.prm'
c
c-----Argument declarations
c
c-----Local variables
c
      real padum(MXCPA)
      real dtfact
      integer i,  npa_init
c
      real rdum(MXREACT)
      real rkdum(MXREACT)
c
c-----Entry point
c
c  --- set flag to determine whether CPA variables are cumulative ---
c
      lcpacum = .false.
c            
c  --- initialize the number of reactions ---
c
      nirrrxn =  nreact
c
c  --- set the number of species and initialize species names ---
c
c   --- dummy array set to zero for first call ---
c
      do i=1,nreact
       rdum(i) = 0.0
       rkdum(i) = 0.0
      enddo
      dtfact = 0.
c
c   --- dummy call sets number of CPA outputs and defines 
c       variable output names ---
c
      if(idmech .EQ. 1) then
         call cpamech1(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      elseif(idmech .EQ. 3) then
         call cpamech3(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      elseif(idmech .EQ. 4) then
         call cpamech4(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      elseif(idmech .EQ. 5) then
         call cpamech5(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      elseif(idmech .EQ. 7) then
         call cpamech7(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      elseif(idmech .EQ. 9) then
         call cpamech9(rdum,rkdum,dtfact,nreact,padum,MXCPA,
     &                                           npa_init,.false.)
      else
          goto 7001
      endif
c
c  --- add the cloud adjustment to photolysis rates ---
c
      npa_init = npa_init + 1
      ptname(npa_init)  = 'J_CLDADJ'
      cpadesc(npa_init) = 'Cloud/haze adjustment factor'
      cpaunit(npa_init) = 'dimensionless'
c
c  --- add the aerosol pH ---
c
      npa_init = npa_init + 1
      ptname(npa_init)  = 'AER_PH'
      cpadesc(npa_init) = 'aerosol pH'
      cpaunit(npa_init) = 'dimensionless'
c     
c  --- set names of radical concentrations to be saved by CPA 
c      don't save if CPA is set to accumulate values ---
c       
      if(.NOT.lcpacum)
     &     call cparad(rdum, nrad, padum, MXCPA, npa_init, 0.0)
c
      if( npa_init .GT. MXCPA ) then
         write(iout,'(//,a)') 'ERROR in PASETUP:'
         write(iout,*) 'Number of outputs requested exceeds limit.'
         write(iout,*)
     &     'Increase the parameter MXCPA in include file procan.inc'
         write(iout,'(1X,A,I5)')
     &         'You need room for at least this many species: ',npa_init
         call camxerr()
      endif
c
      ntotsp = npa_init
      nsaspc = npa_init
c
c  --- define the pointers for each grid ---
c
      ipsa3d(1) = 1
      do i=2,ngrid
         ipsa3d(i) = ipsa3d(i-1) + 
     &       DBLE(ncol(i-1))*DBLE(nrow(i-1))*DBLE(nlay(i-1))*DBLE(ntotsp)
      enddo
c
c   --- set the output flags for all species ----
c
      do i=1,MXCPA
        loutsa(i) = .TRUE.
      enddo
      lfirst = .TRUE.
c
c   --- report the CPA configuration to the *.diag file ---
c
      write(idiag,'(//,A)') ' Chemical Process Analysis (CPA) is active'
      write(idiag,'(A,I5)') ' Number of CPA parameters = ', npa_init
      write(idiag,'(A)')    ' The parameter names are:'
      write(idiag,'(10X,A)') (ptname(i), i=1,npa_init)
      if(lcpacum) write(idiag,'(A)')
     &  ' The flag to accumulate parameters is set true'
      write(idiag,'(//)')
c
c   --- done ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c   Error messages:
c-----------------------------------------------------------------------
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in PASETUP:'
      write(iout,'(2A,I2)') 'Chemical Process Analysis (CPA) does ',
     &                       'not support chemical mechanism: ',idmech
      write(iout,*) 'Please choose another mechanism and try again.'
      call camxerr()
      goto 9999
c
c-----------------------------------------------------------------------
c   Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

c*** PSATSA

      subroutine psatsa(numcol,numrow,numlay,igrid,icell,jcell,kcell,
     &                  nspc,delcon,nprec_soap,yfac,dcprec,CG_part,
     &                  fcsoa,convfac,lrepart)
      use grid
      use chmstry
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine makes the "chemistry" adjustments to the tracer 
c     species for PSAT.  The adjustments are based on the differences in 
c     concentrations of the regular model species before and after
c     the regular model chemistry.  This is essentially an adjustment
c     for production or decay.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol     I number of columns in this slice
c       numrow     I number of rows in this slice
c       numlay     I number of layers in this slice
c       igrid      I  grid number
c       icell      I  the X grid location of current cell
c       jcell      I  the X grid location of current cell
c       kcell      I  the vertical grid location of current layer
c       nspc       I  number of model species
c       delcon     R  array of change in concentrations total
c       nprec_soap I  number of SOA precursors
c       yfac       R  array of 3 weighted yields, yh, yn for each precursor
c       dcprec     R  array of SOA precursor changes (-ve) [ppm]
c       CG_part    R  array of CG partition ratios [dimensionless]
c       fcsoa      R  SOA chem factors: fphot, fpoly, fra, cgly, csoac
c       convfac    R  conversion factor: umol/m3 = ppm * convfac
c       lrepart    L  repartition gas/aerosol SOA when true
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     09/28/03   --gwilson--  Original development
c     12/29/06   --bkoo--     Revised for the updated SOA scheme
c     05/04/07   --gwilson--  Changed call to cyctpnsa so that conversion
c                             factor is set for lower bound values -
c                             the conversion is passed here from chemdriv
c     03/18/14   --bkoo--     Revised for benzene SOA
c     08/25/16   --bkoo--     Updated for new SOAP
c     10/16/17   --bkoo--     Fixed DELARO that was missing IVOA changes
c                             Updated for SOA photolysis
c     01/12/18   --bkoo--     Removed BNZA/TOLA/XYLA/ISP/TRP
c     01/09/19   --cemery--   Added DMS
c     06/18/19   --bkoo--     Updated delARO/delTRP/delSQT for SAPRC07T
c     06/18/25   --gy--       Re-engineer SOA using dcprec & CG_part
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   numcol
      integer   numrow
      integer   numlay
      integer   igrid
      integer   icell
      integer   jcell
      integer   kcell
      integer   nspc
      real      delcon(4,nspc+1)
      integer   nprec_soap
      real      yfac(5,nprec_soap)
      real      dcprec(nprec_soap)
      real      CG_part(NCG)
      real      fcsoa(6)
      real      convfac
      logical   lrepart
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   iaro, iiva, isva, iag2, iag1 
      integer   ipa2, ipa1, ipa0, ihoa
      integer   iisp, itrp, iapn, isqt, ibg1, ibg2, ifc1
      integer   ipb2, ipb1, ipb0
      integer   iso2, idms, ihg0, i
      integer*8 idxcel, idx, jdx, kdx, ldx, mdx, ndx
      integer*8 idx0, idx2, n0dx, n1dx, n2dx, ng1dx, ng2dx
      real      delARO, delISP, delTRP, delSQT, delso2, delps4, deldms, delhg2
      real      delIVA, delSVA, delHOA, delAPN, delFC1
      real      delBNZA, delTOLA, delXYLA, delIVOA, delIVC1, delIVC2, delHPAR
      real      sumARO, sumISP, sumTRP, sumSQT, sumso2, sumps4, sumdms
      real      sumhg0, sumhg2, sumIVA, sumSVA, sumHOA, sumAPN, sumFC1
      real      sumBG2, sumBG1, sumPA2, sumPA1, sumPB2, sumPB1
      real      sumPA0, sumPB0, wtdARO, wtdIVA, wtdTRP, sumpair
      real      fphot, fpolya, fpolyb, apoly1, apoly2, fra, frb, cgly, csoac
      real      dcpum(NPREC_S)
c
      real, parameter :: SMALL = 1.e-15
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- calculate the index of the cell in the grid ---
c
      idxcel =  DBLE(ipsa3d(igrid)-1) + DBLE(icell) + 
     &            DBLE(numcol) * DBLE(jcell-1) + 
     &                 DBLE(numcol) * DBLE(numrow) * DBLE(kcell-1)
c
c----------------------------------------------------------------------
c  ---  SOA tracers ----
c----------------------------------------------------------------------
c
      if( lsoa ) then
         dcpum = dcprec * convfac  ! array of precursor changes (-ve) in umol/m3
         fphot  = fcsoa(1)
         fpolya = fcsoa(2)
         fpolyb = fcsoa(3)
         fra    = fcsoa(4)
         frb    = MAX(0., 1.0 - fra)
         cgly   = fcsoa(5)
         csoac  = fcsoa(6)
         apoly1 = 0.
         apoly2 = 0.
c
c --- compute concentration changes for any mechanism ---
c     safe because inactive species have kSPC=nspc+1 and delcon(*,nspc+1)=0.0
c
         delBNZA = delcon(1,kbenz)                                      !CB & SAPRC
     &           + delcon(1,kben )                                      !RACM2
         delTOLA = delcon(1,ktol )                                      !CB & RACM2
     &           + delcon(1,ktolu) + delcon(1,karo1)                    !SAPRC
         delXYLA = delcon(1,kxyl )                                      !CB
     &           + delcon(1,kmxyl) + delcon(1,koxyl) + delcon(1,kpxyl)  !SAPRC
     &           + delcon(1,kb124) + delcon(1,karo2)                    !SAPRC
     &           + delcon(1,kxym ) + delcon(1,kxyo ) + delcon(1,kxyp )  !RACM2
         delARO  = delBNZA + delTOLA + delXYLA

         delIVOA = delcon(1,kivoa)                                      !SOAP3
         delIVC1 = delcon(1,kivc1)                                      !SOAP3
         delIVC2 = delcon(1,kivc2)                                      !SOAP3
         delHPAR = delcon(1,khpar)                                      !CB7r2
         delIVA  = delIVOA + delIVC1 + delIVC2 + delHPAR 

         delSVA = delcon(1,ksvoa)                                       !SOAP3
         delHOA = delcon(3,khoa )                                       !SOAP3

         delISP = delcon(1,kisop)                                       !CB & SAPRC
     &          + delcon(1,kiso )                                       !RACM2

         delTRP = delcon(1,kterp)                                       !CB & SAPRC
     &          + delcon(1,klim)                                        !RACM2

         delAPN = delcon(1,kapin)                                       !CB7 & SAPRC
     &          + delcon(1,kapi)                                        !RACM2
c
         delFC1 = delcon(1,kfvc1)                                       !CB7
c
         delSQT = delcon(1,ksqt )                                       !CB & RACM2(in SOACHEM)
     &          + delcon(1,ksesq)                                       !SAPRC
c
c  --- sum the Anthropogenic tracer species ---
c
         sumARO = SMALL
         wtdARO = SMALL
         do i=iptcls(idxipt(ITRARO)),nptcls(idxipt(ITRARO))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                DBLE(numlay) * DBLE(i-1)
            sumARO = sumARO + ptconc(idx)
            wtdARO = wtdARO + ptconc(idx)*wtkoh(i)
         enddo

         sumIVA = SMALL
         wtdIVA = SMALL
         do i=iptcls(idxipt(ITRIVA)),nptcls(idxipt(ITRIVA))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumIVA = sumIVA + ptconc(idx)
            wtdIVA = wtdIVA + ptconc(idx)*wtkoh(i)
         enddo

         sumSVA = SMALL
c        wtdSVA not needed because SVA isn't a combined tracer
         do i=iptcls(idxipt(ITRSVA)),nptcls(idxipt(ITRSVA))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumSVA = sumSVA + ptconc(idx)
         enddo

         sumHOA = SMALL
         do i=iptcls(idxipt(ITRHOA)),nptcls(idxipt(ITRHOA))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                              DBLE(numlay) * DBLE(i-1)
            sumHOA = sumHOA + ptconc(idx)
         enddo

c
c  --- Adjust the Anthropogenic tracer species ---
c      dcpum values are negative because precursors are destroyed
c      SPECIAL CASE: adjust PA0 directly (skip CG)
c
         iaro  = iptcls(idxipt(ITRARO)) - 1
         iiva  = iptcls(idxipt(ITRIVA)) - 1
         isva  = iptcls(idxipt(ITRSVA)) - 1
         iag2  = iptcls(idxipt(ITRAG2)) - 1
         iag1  = iptcls(idxipt(ITRAG1)) - 1
         ipa2  = iptcls(idxipt(ITRPA2)) - 1
         ipa1  = iptcls(idxipt(ITRPA1)) - 1
         ipa0  = iptcls(idxipt(ITRPA0)) - 1
         ihoa  = iptcls(idxipt(ITRHOA)) - 1

         do i=iptcls(idxipt(ITRPA0)),nptcls(idxipt(ITRPA0))

            iaro = iaro + 1
            jdx  = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(iaro-1)
            iiva = iiva + 1
            kdx  = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(iiva-1)
            isva = isva + 1
            ldx  = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(isva-1)
            iag2 = iag2 + 1
            ng2dx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(iag2-1)
            iag1 = iag1 + 1
            ng1dx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(iag1-1)
            ipa2 = ipa2 + 1
            n2dx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(ipa2-1)
            ipa1 = ipa1 + 1
            n1dx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(ipa1-1)
            ipa0 = ipa0 + 1
            n0dx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(ipa0-1)
            ihoa = ihoa + 1
            mdx  = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                               DBLE(numlay) * DBLE(ihoa-1)

c --- PA2 & AG2
            ptconc(ng2dx) = ptconc(ng2dx) -
     &                    ( dcpum(ISOAP_BNZA) * yfac(1,ISOAP_BNZA)  
     &                    + dcpum(ISOAP_TOLA) * yfac(1,ISOAP_TOLA)  
     &                    + dcpum(ISOAP_XYLA) * yfac(1,ISOAP_XYLA) )
     &                                          * ptconc(jdx) / sumARO
            ptconc(ng2dx) = ptconc(ng2dx) -
     &                    ( dcpum(ISOAP_IVOA) * yfac(1,ISOAP_IVOA)  
     &                    + dcpum(ISOAP_IVC1) * yfac(1,ISOAP_IVC1)  
     &                    + dcpum(ISOAP_IVC2) * yfac(1,ISOAP_IVC2)  
     &                    + dcpum(ISOAP_HPAR) * yfac(1,ISOAP_HPAR) )
     &                                          * ptconc(kdx) / sumIVA
            ptconc(ng2dx) = ptconc(ng2dx) 
     &                    - dcpum(ISOAP_SVOA) * yfac(1,ISOAP_SVOA) *
     &                                            ptconc(ldx) / sumSVA
            if( lrepart ) then
               sumpair = ptconc(ng2dx)*mwsoap(1) + ptconc(n2dx)
     &                                                         + SMALL
               ptconc(ng2dx) = (CG_part(1) * sumpair ) / mwsoap(1)
               ptconc(n2dx)  = (1.0-CG_part(1)) * sumpair

               ptconc(n2dx)  = ptconc(n2dx) * (1.0-fphot)
               apoly2        = ptconc(n2dx) * fpolya
               ptconc(n2dx)  = ptconc(n2dx) - apoly2
            endif

            ptconc(ng2dx) = MAX(BNDLPT,ptconc(ng2dx))
            ptconc(n2dx)  = MAX(BNDLPT,ptconc(n2dx))

c --- PA1 & AG1
            ptconc(ng1dx) = ptconc(ng1dx) -
     &                    ( dcpum(ISOAP_BNZA) * yfac(2,ISOAP_BNZA)  
     &                    + dcpum(ISOAP_TOLA) * yfac(2,ISOAP_TOLA)  
     &                    + dcpum(ISOAP_XYLA) * yfac(2,ISOAP_XYLA) )
     &                                          * ptconc(jdx) / sumARO
            ptconc(ng1dx) = ptconc(ng1dx) -
     &                    ( dcpum(ISOAP_IVOA) * yfac(2,ISOAP_IVOA)  
     &                    + dcpum(ISOAP_IVC1) * yfac(2,ISOAP_IVC1)  
     &                    + dcpum(ISOAP_IVC2) * yfac(2,ISOAP_IVC2)  
     &                    + dcpum(ISOAP_HPAR) * yfac(2,ISOAP_HPAR) )
     &                                          * ptconc(kdx) / sumIVA
            ptconc(ng1dx) = ptconc(ng1dx)
     &                    - dcpum(ISOAP_SVOA) * yfac(2,ISOAP_SVOA) *
     &                                            ptconc(ldx) / sumSVA

            if( lrepart ) then
               sumpair = ptconc(ng1dx)*mwsoap(1) + ptconc(n1dx)
               ptconc(ng1dx) = (CG_part(2) * sumpair ) / mwsoap(2)
     &                                                         + SMALL
               ptconc(n1dx)  = (1.0-CG_part(2)) * sumpair

               ptconc(n1dx)  = ptconc(n1dx) * (1.0-fphot)
               apoly1        = ptconc(n1dx) * fpolya
               ptconc(n1dx)  = ptconc(n1dx) - apoly1
            endif

            ptconc(ng1dx) = MAX(BNDLPT,ptconc(ng1dx))
            ptconc(n1dx)  = MAX(BNDLPT,ptconc(n1dx))


c --- PA0 (SPECIAL CASE: convert dcpum to ug/m3)
            ptconc(n0dx) = ptconc(n0dx) - mwaoa0 * 
     &                   ( dcpum(ISOAP_BNZA) * yfac(3,ISOAP_BNZA)  
     &                   + dcpum(ISOAP_TOLA) * yfac(3,ISOAP_TOLA)  
     &                   + dcpum(ISOAP_XYLA) * yfac(3,ISOAP_XYLA) )
     &                                          * ptconc(jdx) / sumARO
            ptconc(n0dx) = ptconc(n0dx) - mwaoa0 *
     &                   ( dcpum(ISOAP_IVOA) * yfac(3,ISOAP_IVOA)  
     &                   + dcpum(ISOAP_IVC1) * yfac(3,ISOAP_IVC1)  
     &                   + dcpum(ISOAP_IVC2) * yfac(3,ISOAP_IVC2)  
     &                   + dcpum(ISOAP_HPAR) * yfac(3,ISOAP_HPAR) )
     &                                          * ptconc(kdx) / sumIVA
            ptconc(n0dx) = ptconc(n0dx) - mwaoa0 *
     &                   ( dcpum(ISOAP_SVOA) * yfac(3,ISOAP_SVOA) )
     &                                          * ptconc(ldx) / sumSVA  

            if( lrepart ) then
               ptconc(n0dx)  = ptconc(n0dx) * (1.0-fphot)
               ptconc(n0dx)  = ptconc(n0dx) + apoly1 + apoly2
            endif

            ptconc(n0dx)  = ptconc(n0dx) 
     &                    + cgly * fra * mwaoa0 * ptconc(jdx) / sumARO

            ptconc(n0dx) = MAX(BNDLPT,ptconc(n0dx))

c --- ARO (SPECIAL CASE: combination tracer)
            ptconc(jdx) = ptconc(jdx) + delARO *
     &                               ptconc(jdx)*wtkoh(iaro) / wtdARO
            ptconc(jdx) = MAX(BNDLPT,ptconc(jdx))

c --- IVA (SPECIAL CASE: combination tracer)
            ptconc(kdx) = ptconc(kdx) + delIVA *
     &                               ptconc(kdx)*wtkoh(iiva) / wtdIVA
            ptconc(kdx) = MAX(BNDLPT,ptconc(kdx))

c --- SVA
            ptconc(ldx) = ptconc(ldx) + delSVA * ptconc(ldx) / sumSVA
            ptconc(ldx) = MAX(BNDLPT,ptconc(ldx))

c --- HOA (expect delHOA=0 but adjustment is safe)
            ptconc(mdx) = ptconc(mdx) + delHOA * ptconc(mdx) / sumHOA
            ptconc(mdx) = MAX(BNDLPT,ptconc(mdx))

         enddo  ! end Anthropogenic

c
c  --- sum the Biogenic tracer species ---
c
         sumISP = SMALL
         do i=iptcls(idxipt(ITRISP)),nptcls(idxipt(ITRISP))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                DBLE(numlay) * DBLE(i-1)
            sumISP = sumISP + ptconc(idx)
         enddo

         sumTRP = SMALL
         wtdTRP = SMALL
         do i=iptcls(idxipt(ITRTRP)),nptcls(idxipt(ITRTRP))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumTRP = sumTRP + ptconc(idx)
            wtdTRP = wtdTRP + ptconc(idx)*wtkoh(i)
         enddo

         sumAPN = SMALL
         do i=iptcls(idxipt(ITRAPN)),nptcls(idxipt(ITRAPN))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumAPN = sumAPN + ptconc(idx)
         enddo

         sumFC1 = SMALL
         do i=iptcls(idxipt(ITRFC1)),nptcls(idxipt(ITRFC1))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumFC1 = sumFC1 + ptconc(idx)
         enddo

         sumSQT = SMALL
         do i=iptcls(idxipt(ITRSQT)),nptcls(idxipt(ITRSQT))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(i-1)
            sumSQT = sumSQT + ptconc(idx)
         enddo

c
c  --- Adjust the Biogenic tracer species ---
c      dcpum values are negative because precursors are destroyed
c      SPECIAL CASE: adjust PB0 directly (skip CG)
c

         iisp  = iptcls(idxipt(ITRISP)) - 1
         itrp  = iptcls(idxipt(ITRTRP)) - 1
         iapn  = iptcls(idxipt(ITRAPN)) - 1
         ifc1  = iptcls(idxipt(ITRFC1)) - 1
         isqt  = iptcls(idxipt(ITRSQT)) - 1
         ibg2  = iptcls(idxipt(ITRBG2)) - 1
         ibg1  = iptcls(idxipt(ITRBG1)) - 1
         ipb2  = iptcls(idxipt(ITRPB2)) - 1
         ipb1  = iptcls(idxipt(ITRPB1)) - 1
         ipb0  = iptcls(idxipt(ITRPB0)) - 1

         do i=iptcls(idxipt(ITRPB0)),nptcls(idxipt(ITRPB0))

            iisp = iisp + 1
            jdx  = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(iisp-1)
            itrp = itrp + 1
            kdx  = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(itrp-1)
            isqt = isqt + 1
            ldx  = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(isqt-1)
            iapn = iapn + 1
            mdx  = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(iapn-1)
            ifc1 = ifc1 + 1
            ndx  = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ifc1-1)
            ibg2 = ibg2 + 1
            ng2dx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ibg2-1)
            ibg1 = ibg1 + 1
            ng1dx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ibg1-1)
            ipb2 = ipb2 + 1
            n2dx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ipb2-1)
            ipb1 = ipb1 + 1
            n1dx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ipb1-1)
            ipb0 = ipb0 + 1
            n0dx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(ipb0-1)

c --- PB2 & BG2
            ptconc(ng2dx) = ptconc(ng2dx)  
     &                    - dcpum(ISOAP_ISP) * yfac(1,ISOAP_ISP) *
     &                                            ptconc(jdx) / sumISP
     &                    - dcpum(ISOAP_TRP) * yfac(1,ISOAP_TRP) *
     &                                            ptconc(kdx) / sumTRP
     &                    - dcpum(ISOAP_SQT) * yfac(1,ISOAP_SQT) *
     &                                            ptconc(ldx) / sumSQT
     &                    - dcpum(ISOAP_APN) * yfac(1,ISOAP_APN) *
     &                                            ptconc(mdx) / sumAPN 
     &                    - dcpum(ISOAP_FVC1) * yfac(1,ISOAP_FVC1) *
     &                                            ptconc(ndx) / sumFC1 

            if( lrepart ) then
               sumpair = ptconc(ng2dx)*mwsoap(3) + ptconc(n2dx)
     &                                                         + SMALL
               ptconc(ng2dx) = (CG_part(3) * sumpair ) / mwsoap(3)
               ptconc(n2dx)  = (1.0-CG_part(3)) * sumpair

               ptconc(n2dx)  = ptconc(n2dx) * (1.0-fphot)
               apoly2        = ptconc(n2dx) * fpolyb
               ptconc(n2dx)  = ptconc(n2dx) - apoly2
            endif

            ptconc(ng2dx) = MAX(BNDLPT,ptconc(ng2dx))
            ptconc(n2dx)  = MAX(BNDLPT,ptconc(n2dx))

c --- PB1 & BG1
            ptconc(ng1dx) = ptconc(ng1dx)
     &                    - dcpum(ISOAP_ISP) * yfac(2,ISOAP_ISP) *
     &                                            ptconc(jdx) / sumISP
     &                    - dcpum(ISOAP_TRP) * yfac(2,ISOAP_TRP) *
     &                                            ptconc(kdx) / sumTRP
     &                    - dcpum(ISOAP_SQT) * yfac(2,ISOAP_SQT) *
     &                                            ptconc(ldx) / sumSQT
     &                    - dcpum(ISOAP_APN) * yfac(2,ISOAP_APN) *
     &                                            ptconc(mdx) / sumAPN 
     &                    - dcpum(ISOAP_FVC1) * yfac(2,ISOAP_FVC1) *
     &                                            ptconc(ndx) / sumFC1 

            if( lrepart ) then
               sumpair = ptconc(ng1dx)*mwsoap(4) + ptconc(n1dx)
     &                                                         + SMALL
               ptconc(ng1dx) = (CG_part(4) * sumpair ) / mwsoap(4)
               ptconc(n1dx)  = (1.0-CG_part(4)) * sumpair

               ptconc(n1dx)  = ptconc(n1dx) * (1.0-fphot)
               apoly1        = ptconc(n1dx) * fpolyb
               ptconc(n1dx)  = ptconc(n1dx) - apoly1
            endif

            ptconc(ng1dx) = MAX(BNDLPT,ptconc(ng1dx))
            ptconc(n1dx)  = MAX(BNDLPT,ptconc(n1dx))

c --- PB0 (SPECIAL CASE: convert dcpum to ug/m3)
            ptconc(n0dx) = ptconc(n0dx) + mwboa0 * (
     &                   - dcpum(ISOAP_ISP) * yfac(3,ISOAP_ISP) *
     &                                            ptconc(jdx) / sumISP
     &                   - dcpum(ISOAP_TRP) * yfac(3,ISOAP_TRP) *
     &                                            ptconc(kdx) / sumTRP
     &                   - dcpum(ISOAP_SQT) * yfac(3,ISOAP_SQT) *
     &                                            ptconc(ldx) / sumSQT
     &                   - dcpum(ISOAP_APN) * yfac(3,ISOAP_APN) *
     &                                            ptconc(mdx) / sumAPN
     &                   - dcpum(ISOAP_FVC1) * yfac(3,ISOAP_FVC1) *
     &                                            ptconc(ndx) / sumFC1 )

            if( lrepart ) then
               ptconc(n0dx)  = ptconc(n0dx) * (1.0-fphot)
               ptconc(n0dx)  = ptconc(n0dx) + apoly1 + apoly2
            endif

            ptconc(n0dx)  = ptconc(n0dx)
     &                    + cgly * frb * mwboa0 * ptconc(jdx) / sumISP
     &                    +               csoac * ptconc(jdx) / sumISP

            ptconc(n0dx) = MAX(BNDLPT,ptconc(n0dx))

c --- ISP
            ptconc(jdx) = ptconc(jdx) + delISP * ptconc(jdx) / sumISP
            ptconc(jdx) = MAX(BNDLPT,ptconc(jdx))

c --- TRP (SPECIAL CASE: might be combination tracer)
            ptconc(kdx) = ptconc(kdx) + delTRP *
     &                               ptconc(kdx)*wtkoh(itrp) / wtdTRP
            ptconc(kdx) = MAX(BNDLPT,ptconc(kdx))

c --- SQT
            ptconc(ldx) = ptconc(ldx) + delSQT * ptconc(ldx) / sumSQT
            ptconc(ldx) = MAX(BNDLPT,ptconc(ldx))

c --- APN
            ptconc(mdx) = ptconc(mdx) + delAPN * ptconc(mdx) / sumAPN
            ptconc(mdx) = MAX(BNDLPT,ptconc(mdx))

c --- FC1
            ptconc(ndx) = ptconc(ndx) + delFC1 * ptconc(ndx) / sumFC1
            ptconc(ndx) = MAX(BNDLPT,ptconc(ndx))

         enddo  ! end Biogenic

      endif
c
c----------------------------------------------------------------------
c  ---  Sulfate tracers ---
c----------------------------------------------------------------------
c
      if( lsulfate ) then
         delso2 = delcon(3,kso2)
         delps4 = delcon(3,kpso4)
c
c  --- sum the tracer species for SO2 ---
c
         sumso2 = SMALL
         do i=iptcls(idxipt(ITRSO2)),nptcls(idxipt(ITRSO2))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(i-1)
            sumso2 = sumso2 + ptconc(idx)
         enddo
c
c  --- sum the tracer species for DMS ---
c
         if( ldmschm ) then
            idms = iptcls(idxipt(ITRDMS)) - 1
            deldms = delcon(1,kdms)
            sumdms = SMALL
            do i=iptcls(idxipt(ITRDMS)),nptcls(idxipt(ITRDMS))
               idx = idxcel + numcol * numrow * numlay * (i-1)
               sumdms = sumdms + ptconc(idx)
            enddo
         endif
c
c  --- if PSO4 change is positive, adjust PS4 
c      tracers based on distribtion of SO2 ---
c
         if( delps4 .GT. 0. ) then
            iso2 = iptcls(idxipt(ITRSO2)) - 1
            do i=iptcls(idxipt(ITRPS4)),nptcls(idxipt(ITRPS4))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
               iso2 = iso2 + 1
               jdx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                               DBLE(numlay) * DBLE(iso2-1)
               ptconc(idx) = ptconc(idx) + delps4 * ptconc(jdx) / sumso2
               ptconc(idx) = MAX(BNDLPT,ptconc(idx))
            enddo
c
c  --- if PSO4 change is negative, adjust PS4 
c      tracers based on distribtion of PS4 ---
c
         else
c
c  --- sum the tracer species for PS4 ---
c
            sumps4 = SMALL
            do i=iptcls(idxipt(ITRPS4)),nptcls(idxipt(ITRPS4))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(i-1)
               sumps4 = sumps4 + ptconc(idx)
            enddo
            do i=iptcls(idxipt(ITRPS4)),nptcls(idxipt(ITRPS4))
               idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                    DBLE(numlay) * DBLE(i-1)
               ptconc(idx) = ptconc(idx) + delps4 * ptconc(idx) / sumps4
               ptconc(idx) = MAX(BNDLPT,ptconc(idx))
            enddo
         endif
c
c  --- adjust SO2 tracers based on change in SO2 (and DMS) ---
c
         do i=iptcls(idxipt(ITRSO2)),nptcls(idxipt(ITRSO2))
            idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                  DBLE(numlay) * DBLE(i-1)
            ptconc(idx) = ptconc(idx) + delso2 * ptconc(idx) / sumso2
            if( ldmschm ) then
               idms = idms + 1
               jdx = idxcel + numcol * numrow * numlay * (idms-1)
               ptconc(idx) = ptconc(idx) - deldms * ptconc(jdx) / sumdms
            endif
            ptconc(idx) = MAX(BNDLPT,ptconc(idx))
         enddo
c
c  --- adjust DMS tracers based on change in DMS ---
c
         if( ldmschm ) then
           do i=iptcls(idxipt(ITRDMS)),nptcls(idxipt(ITRDMS))
              idx = idxcel + numcol * numrow * numlay * (i-1)
              ptconc(idx) = ptconc(idx) + deldms * ptconc(idx) / sumdms
              ptconc(idx) = MAX(BNDLPT,ptconc(idx))
           enddo
         endif
      endif
c
c----------------------------------------------------------------------
c  ---  Mercury tracers ----
c----------------------------------------------------------------------
c
      if( lmercury ) then
         delhg2 = delcon(3,khg2)

c  --- sum the HG tracer species ---
c
         sumhg0 = SMALL
         do i=iptcls(idxipt(ITRHG0)),nptcls(idxipt(ITRHG0))
            idx0 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(i-1)
            sumhg0 = sumhg0 + ptconc(idx0)
         enddo
         sumhg2 = SMALL
         do i=iptcls(idxipt(ITRHG2)),nptcls(idxipt(ITRHG2))
            idx2 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(i-1)
            sumhg2 = sumhg2 + ptconc(idx2)
         enddo
c
c  --- HG0 being oxidized to HG2 ----
c
         if( delhg2 .GT. 0 ) then
            ihg0 = iptcls(idxipt(ITRHG0)) - 1
            do i=iptcls(idxipt(ITRHG2)),nptcls(idxipt(ITRHG2))
               idx2 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(i-1)
               ihg0 = ihg0 + 1
               idx0 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                DBLE(numlay) * DBLE(ihg0-1)
               ptconc(idx2) = ptconc(idx2) + 
     &                                   delhg2 * ptconc(idx0) / sumhg0
               ptconc(idx2) = MAX(BNDLPT,ptconc(idx2))
               ptconc(idx0) = ptconc(idx0) - 
     &                                   delhg2 * ptconc(idx2) / sumhg2
               ptconc(idx0) = MAX(BNDLPT,ptconc(idx0))
            enddo
c
c  --- HG2 beign reduced to HG0 ----
c
         else
            ihg0 = iptcls(idxipt(ITRHG0)) - 1
            do i=iptcls(idxipt(ITRHG2)),nptcls(idxipt(ITRHG2))
               idx2 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                      DBLE(numlay) * DBLE(i-1)
               ihg0 = ihg0 + 1
               idx0 = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                   DBLE(numlay) * DBLE(ihg0-1)
               ptconc(idx2) = ptconc(idx2) + 
     &                                  delhg2 * ptconc(idx2) / sumhg2
               ptconc(idx2) = MAX(BNDLPT,ptconc(idx2))
               ptconc(idx0) = ptconc(idx0) - 
     &                                  delhg2 * ptconc(idx0) / sumhg0
               ptconc(idx0) = MAX(BNDLPT,ptconc(idx0))
            enddo
         endif
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end

      subroutine scavrat(laero,lcloud,lgraupl,tamin,pmm,temp,rhoair,
     &                   difrat,prtdia,rhoprt,dscav,gscav,ascav,drpvel)
c
c----CAMx v7.40 260801
c 
c     SCAVRAT calculates wet scavenging rates for gases and aerosols.
c     Rates are determined for:
c       1) Uptake of cloud water with dissolved gasses
c       2) Uptake of ambient gasses into precip via diffusion
c       3) Uptake of cloud water with PM (all PM in cloudy layers is assumed
c          to reside in cloud water)
c       4) Uptake of ambient PM into precip, dependent on particle size and 
c          ice form
c     Super-cooled liquid cloud water is assumed to exist in the temperature
c     range Tamin < T < 273K using a ramp function (100% liquid at 273 to 
c     0% liquid at Tamin).
c 
c      Copyright Ramboll
c           
c     Modifications:
c        02/11/04   Updated empirical rainfall relationships
c        05/03/05   Revised gas scavenging calculations
c        06/20/05   Revised to handle liquid/frozen cloud and precip water
c        10/21/05   Henry's Law calculation moved out to WETDEP
c        12/22/09   Simplified characterization of "gscav"
c        06/06/16   Revised gas scavenging rates consistent with WETDEP changes
c
c     Input arguments:
c        laero               aerosol flag
c        lcloud              in-cloud flag (F=no cloud water)
c        lgraupl             graupel frozen precip flag
c        tamin               minimum temperature for liquid cloud water
c        pmm                 precip rate (mm/hr)
c        temp                temperature (K)
c        rhoair              atmospheric density (kg/m3)
c        difrat              Ratio of H2O to gas diffusivity
c        prtdia              mean aerosol size (m)
c        rhoprt              aerosol density (g/m3)
c             
c     Output arguments: 
c        dscav               Gas scavenging rate in cloud water (1/s)
c        gscav               Gas scavenging rate diffusing into precip (1/s)
c        ascav               Aerosol scavenging rate (1/s)
c        drpvel              Precip fall speed (m/s)
c             
c     Routines called: 
c        none
c             
c     Called by: 
c        WETDEP
c 
      implicit none
      real tamin,pmm,temp,rhoair,difrat,prtdia,rhoprt,dscav,
     &     gscav,ascav,drpvel
      logical laero,lcloud,lgraupl
c
      real pi,difh2o,boltz,xmfp,cldeff,drpdia,cscav,diff,term1,
     &     term2,reynold,power,scf,difbrwn,schmidt,stoke,top,bot,star,
     &     terma,termb,phi,term3,eff,drpmas
      real nuair,muair,muh2o,kc
c
c-----Constants
c
      data pi /3.1415927/
      data difh2o /2.3e-5/   !m2/s
      data muair /1.8e-5/    !kg/ms
      data muh2o /1.e-3/     !kg/ms
      data boltz /1.38e-23/  !J/K
      data xmfp /6.5e-8/     !m
      data cldeff /0.9/
c
c-----Entry point
c
      dscav = 0.
      gscav = 0.
      ascav = 0.
      eff   = 1.
c
c-----Calculate environmental parameters
c
      nuair = muair/rhoair                 !air molecular diffusivity (m2/s)
      drpdia = 9.0e-4*(pmm**0.21)          !rain drop diameter (m)
      drpmas = 1.e6*(pi/6.)*(drpdia)**3    !rain drop mass (g)
      if (temp.gt.273.) then
        drpvel = 3.1e3*drpdia              !rain drop fall speed (m/s)
      elseif (lgraupl) then
        drpdia = (17.*1000.*drpmas)**0.38  !graupel diameter (mm)
        drpvel = 1.10*drpdia**0.61         !graupel fall speed (m/s)
        drpdia = 1.e-3*drpdia              !(m)
      else
        drpdia = (29.*1000.*drpmas)**0.56  !snow diameter (mm)
        drpvel = 0.83*drpdia**0.20         !snow fall speed (m/s)
        drpdia = 1.e-3*drpdia              !(m)
      endif
      cscav = 4.2e-7*pmm*cldeff/drpdia     !cloud scavenging rate (1/s)

      if (laero) goto 1000 
c
c-----Gas scavenging
c
      if (temp.le.tamin) return
      if (lcloud) then
        dscav = cscav
      endif
c
c-----Calculate scavenging rate for ambient gas diffusing into precip
c
        diff  = difh2o/difrat
        term1 = (drpvel*drpdia/nuair)**0.5
        term2 = (nuair/diff)**0.333
        kc    = diff/drpdia*(2. + 0.6*term1*term2)
        gscav = 1.67e-6*pmm*kc/(drpdia*drpvel)
c
      return
c
c-----Aerosol scavenging
c
 1000 continue
c
c-----Scavenging rate for aerosol in cloud water is set equal to
c     cloud water scavenging rate
c
      if (lcloud) then
        ascav = cscav
      else
c
c-----Calculate scavenging rate of dry aerosols below cloud as f(size)
c
        reynold = drpdia*drpvel/(2.*nuair)
        power = amin1(7.6,0.55*prtdia/xmfp)
        scf = 1. + (2.514 + 0.8*exp(-power))*xmfp/prtdia
        difbrwn = boltz*temp*scf/(3.*pi*muair*prtdia)
        schmidt = nuair/difbrwn
        stoke = drpvel*prtdia*prtdia*rhoprt*scf/(9000.*muair*drpdia)

        top = 1.2 + alog(1. + reynold)/12.
        bot = 1.0 + alog(1. + reynold)
        star = amin1(top/bot,stoke)

        terma = reynold**0.5 * schmidt**0.333
        termb = reynold**0.5 * schmidt**0.5
        term1 = 4./(reynold*schmidt)*(1. + 0.4*terma + 0.16*termb)
        phi = prtdia/drpdia
        term2 = 4.*phi*(muair/muh2o + (1. + 2.*reynold**0.5)*phi)
        term3 = (stoke - star)/(stoke - star + 2./3.)
        term3 = ((1.e6/rhoprt)**0.5)*term3**1.5
        eff = term1 + term2 + term3
        if (temp.le.273. .and. .not.lgraupl) eff = amax1(eff,1.e-3)

        ascav = cscav*eff/cldeff
      endif

      return
      end

c**** SPECDDM
c
      subroutine specddm( )
      use filunit
      use chmstry
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine sets up the species names and pointers into the species
c   for all of the DDM species.  Pointers will be set up for both the
c   concentration array and the emissions array.
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/23/99   --gwilson--    Original development
c     10/03/03   --gwilson--    Added flag for gaseous species
c     07/16/07   --bkoo--       Revised for HDDM
c     06/11/08   --bkoo--       Added rate constant sensitivity
c     11/12/09   --gwilson--    Added initialization of factor for
c                               applying new type of top boundary
c     08/23/13   --bkoo--       Added PM species for DDM
c     03/18/14   --bkoo--       Added species for benzene SOA
c     08/25/16   --bkoo--       Updated DDM-PM species mapping for new SOAP
c     11/28/16   --bkoo--       Corrected top fac argument in filspddm call
c                               Added pttop initialization
c     08/09/18   --bkoo--       Added rate term sensitivity
c     10/26/18   --bkoo--       Updated DDM-PM species mapping for in-cloud
c                               SOA formation & revised CA scaling
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'camx_aero.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*10 caffec, cinflu, srcnam
      character*3  edgnam(5)
      integer      ispc, iaffec, iddm, mvecedge, nedge, i, l
      integer*8    idxsa, mvec4d
      logical      lout, lsns
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data nedge /5/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- load the names of the boundary edges ---
c
      edgnam(IDXBWS) = 'WST'
      edgnam(IDXBES) = 'EST'
      edgnam(IDXBST) = 'STH'
      edgnam(IDXBNT) = 'NTH'
      edgnam(IDXBTP) = 'TOP'
c
c  --- echo the table of species to the output file ---
c
      write(idiag,*) ' '
      write(idiag,*) ' Affected   Influencing   Source',
     &                   '                       Long            Short' 
      write(idiag,*) ' Species      Species      Type ',
     &                   '      Group   Region   Name            Name' 
      write(idiag,'(1X,79A)') ('-',i=1,79)
c
c  --- calculate the number of DDM families per model species ---
c
      if( lbndry ) then
          nbdic = 5 * nbcddm + nicddm + ndepddm
      else
          nbdic = nbcddm + nicddm + ndepddm
      endif

      nddmsp = nbdic + nemddm * nregin * ngroup + nrateddm
     &                                          + ntermddm + nhddm
c
c  --- calculate the number of DDM species needed and allocate
c      some arrays ---
c
      ntotsp = nspec * nddmsp
      soap3_ntotsp = ntotsp

      if ( nddmsp .GT. MXFDDM ) goto 7000
      if ( ntotsp .GT. MXTRSP ) goto 7001
      
      lsns = .NOT. lmpi
      mvecedge = MAX(ncol(1),nrow(1))
      call alloc_ddm(lsns,ngrid,ncol,nrow,nlay,nlayers_ems,nspec,
     &                                 nddmsp,nhddm,mvecedge,iout)
c
c  --- loop over the modeled species and setup the names ---
c
      do ispc=1,nspec
c
c  --- set the pointer into the array for this family ---
c
          iptddm(ispc) = (ispc-1)*nddmsp + 1
          iaffec = ispc
          caffec = spname(ispc)
c
c  --- set the flag for determining if this species should
c      be output to average file ---
c
          lout = .FALSE.
          do i=1,navspc
            if( lavmap(i) .EQ. ispc ) lout = .TRUE.
          enddo
c
c  --- intialize the index into the array ---
c
          idxddm = iptddm(ispc) - 1
c
c  --- loop over all of the DDM initial condition species ---
c
          do iddm = 1,nicddm
             cinflu = icddmsp(iddm)
             srcnam = 'IC'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxddm,0,0,lout,0.0)
          enddo
c
c  --- loop over all of the DDM depostion species ---
c
          do iddm = 1,ndepddm
             cinflu = depddmsp(iddm)
             srcnam = 'DEP'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxddm,0,0,lout,0.0)
          enddo
c
c  --- loop over all of the DDM boundary condition species ---
c
          do iddm = 1,nbcddm
             cinflu = bcddmsp(iddm)
c
c  --- if the stratify boundary is off, just fill the one species name ---
c
             if( .NOT. lbndry ) then
                srcnam = 'BCALL'
c
c  --- call routine to fill the family of species names ---
c
                call filspddm(iaffec,caffec,cinflu,
     &                                     srcnam,idxddm,0,0,lout,1.0)
c
c  --- otherwise, loop over all of the boundary edges ---
c
             else
                do i=1,nedge
                   srcnam = 'BC'//edgnam(i)(1:3)
c
c  --- call routine to fill the family of species names ---
c
                   if ( i.eq.IDXBTP ) then
                     call filspddm(iaffec,caffec,cinflu,
     &                                       srcnam,idxddm,0,0,lout,1.0)
                   else
                     call filspddm(iaffec,caffec,cinflu,
     &                                       srcnam,idxddm,0,0,lout,0.0)
                   endif
                enddo
             endif
          enddo
c
c  --- loop over all of the DDM emissions condition species ---
c
          do iddm = 1,nemddm
             cinflu = emddmsp(iddm)
             srcnam = 'EM'
c
c  --- call routine to fill the family of species names ---
c
              call filspddm(iaffec,caffec,cinflu,srcnam,idxddm,
     &                                    MAX(1,ngroup),nregin,lout,0.0)
          enddo
c
c  --- loop over all of the rate constant sensitivity groups ---
c
          do iddm = 1,nrateddm
             cinflu = rateddm(iddm)
             srcnam = 'RATE'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxddm,iddm,0,lout,0.0)
          enddo
c
c  --- loop over all of the rate term sensitivity groups ---
c
          do iddm = 1,ntermddm
             cinflu = termddm(iddm)
             srcnam = 'TERM'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxddm,iddm,0,lout,0.0)
          enddo
c
c  --- loop over all of the HDDM sensitivity groups ---
c
          do iddm = 1,nhddm
             cinflu = ' '
             srcnam = 'HDDM'
c
c  --- call routine to fill the family of species names ---
c
             call filspddm(iaffec,caffec,cinflu,
     &                                    srcnam,idxddm,iddm,0,lout,0.0)
          enddo
c
c  --- get then next affect species ---
c
      enddo
      ntotsp = idxddm
      soap3_ntotsp = ntotsp
      ipttim = ntotsp + 1
      nsaspc = ntotsp
      write(idiag,'(1X,79A)') ('-',i=1,79)
      write(idiag,*) 
c
c  --- set the flag for gaseous species ---
c
      lsagas = .FALSE.
      do i=iptddm(nrad+1),iptddm(ngas)+nddmsp-1
         lsagas(i) = .TRUE.
      enddo
c
c  --- initialize all of the tracers concs to zero to start off ---
c
      mvec4d = 0
      do i=1,ngrid
         mvec4d = mvec4d + DBLE(ncol(i)) * DBLE(nrow(i)) * DBLE(nlay(i))
      enddo
      mvec4d = mvec4d * DBLE(ntotsp)
      do idxsa=1,mvec4d
         ptconc(idxsa) = 0.
      enddo
      pttop = 0.
      do l=1,ntotsp
         do i=1,MXRECP
            conrcp(l,i) = 0.
         enddo
      enddo
c
c  --- set pointers for DDM-PM species
c
      if (lchem .AND. aeropt.EQ.'CF') then
         jdpmap(jdpSO2 ) = kso2
         jdpmap(jdpH2O2) = khpo_c
         jdpmap(jdpO3  ) = ko3
         jdpmap(jdpFOA ) = kfoa_c
         jdpmap(jdpMHP ) = kmhp_c
         jdpmap(jdpOHP ) = kohp_c
         jdpmap(jdpPAA ) = kpaa_c
         jdpmap(jdpOPA ) = kopa_c
         jdpmap(jdpN2O5) = kn2o5
         jdpmap(jdpHNO3) = khno3
         jdpmap(jdpNH3 ) = knh3
         jdpmap(jdpSULF) = ksulf
         jdpmap(jdpHCL ) = khcl
         jdpmap(jdpACG2 ) = kacg2
         jdpmap(jdpACG1 ) = kacg1
         jdpmap(jdpBCG2 ) = kbcg2
         jdpmap(jdpBCG1 ) = kbcg1
         jdpmap(jdpGLY ) = kgly_c
         jdpmap(jdpMGLY) = kmgly_c
         jdpmap(jdpGLYD) = kglyd_c
         jdpmap(jdpHO  ) = koh
         jdpmap(jdpNA  ) = kna
         jdpmap(jdpPSO4) = kpso4
         jdpmap(jdpPNH4) = kpnh4
         jdpmap(jdpPNO3) = kpno3
         jdpmap(jdpPCL ) = kpcl
         jdpmap(jdpAOA2) = kaoa2
         jdpmap(jdpAOA1) = kaoa1
         jdpmap(jdpBOA2) = kboa2
         jdpmap(jdpBOA1) = kboa1
         jdpmap(jdpAOA0) = kaoa0
         jdpmap(jdpBOA0) = kboa0
         jdpmap(jdpHOA ) = khoa
         jdpmap(jdpPH2O) = kph2o
         jdpmap(jdpFPRM) = kfprm
         jdpmap(jdpFCRS) = kfcrs
         jdpmap(jdpCGLY) = kcgly
         do i = 1, NSDDMPM
            if ( jdpmap(i).eq.nspec+1 ) then
               jdpmap(i) = 0
            else
               jdpmap(i) = iptddm( jdpmap(i) )
            endif
         enddo
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,A)') 'ERROR in SPECDDM:'
      write(iout,'(/,1X,A,I5)')
     &            'ERROR: Number of DDM families exceeds max: ',MXFDDM
      write(iout,'(1X,A,I5)')
     &        'You need room for at least this many families: ',nddmsp
      write(iout,'(1X,A)') 'Increase parameter MXFDDM in camx.prm'
      write(iout,'(1X,2A,I5)') 'Also increase parameter MXTRSP',
     &                     ' in camx.prm if it is less than ',ntotsp
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in SPECDDM:'
      write(iout,'(/,1X,A,I5)')
     &                 'Number of tracer species exceeds max: ',MXTRSP
      write(iout,'(1X,A,I5)')
     &         'You need room for at least this many tracers: ',ntotsp
      write(iout,'(1X,A)') 'Increase parameter MXTRSP in camx.prm'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

C**** NCF_READTOP
c
      subroutine ncf_readtop(toptim,topdate,did_update)
      use chmstry
      use filunit
      use camxfld
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c 
c      Copyright Ramboll
c           
c     Arguments: 
c        toptim            model simulation time (HHMM)
c        topdate           model simulation date (YYJJJ)
c        did_update .TRUE. if new data was read
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
      include 'camx.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer topdate
      real    toptim
      logical did_update
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      integer       this_tstep, data_start(4), data_count(4), ispc
      integer       this_varid, n3d, i, j, ierr, ic, ip, ig
      real          date_time
c
      real, allocatable, dimension(:,:,:) :: tctmp
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      did_update = .FALSE.
      action = 'Reading top boundary conditions file.'
c
c  --- check if current timestep still works ---
c
      date_time = REAL(topdate)+toptim/2400.
      if( date_time .GE. topdate_time_tflag .AND. date_time 
     &                             .LT. topdate_time_etflag ) goto 9999
c
c  --- reading the file for more data so echo that ---
c
      did_update = .TRUE.
      write(*,'(a20,$)') 'ncf_readtop ......'
c
c   --- get the timestep that encompasses this date/time ---
c
      this_tstep = ncf_get_tstep(itc,action,topdate,toptim,
     &        topdate_time_tflag,topdate_time_etflag,.FALSE.,.TRUE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = 1
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  --- allocate temporary array ---
c
      allocate( tctmp(ncol(1),nrow(1),1) )
c
c  ---- loop over model species and skip if not in the IC file ---
c
      do ispc=1,nspec
c
c  ---  if species not in file, set to lower bound ---
c
         if( ltcmap(ispc) .LE. 0 ) then
c
c --- Load top concentrations for master grid ---
c
            do j=1,nrow(1)
              do i=1,ncol(1)
                 n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(ispc - 1)
                 ctop(n3d) = bdnl(ispc)
              enddo
            enddo
            cycle
         endif
c
c  ---- load this species into local array ---
c
         this_varid = ltcmap(ispc)
         ierr = nf_get_vara_real(itc,this_varid,data_start,data_count,tctmp)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_READTOP:'
           write(iout,*)'Cannot read boundary conditions data for speices: ',
     &                                   spname(ispc)(:istrln(spname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c --- Load top concentrations for master grid ---
c
         do j=1,nrow(1)
           do i=1,ncol(1)
              n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(ispc - 1)
              ctop(n3d) = bdnl(ispc)
              if( tctmp(i,j,1) .GT. bdnl(ispc) ) ctop(n3d) = tctmp(i,j,1)
            enddo
         enddo
      enddo
c
c  --- dealocate the local array ---
c
      deallocate( tctmp )
c
c --- interpolate topcon to all nested grids
c
      if( ngrid .GT. 1) then
        do ip = 1,ngrid
          do ic = 1,nchdrn(ip)
            ig = idchdrn(ic,ip)
            call intrpcnc(nspec,ncol(ip),nrow(ip),1,i1(ig),
     &                    j1(ig),nmesh(ig),ncol(ig),nrow(ig),1,
     &                    ctop(iptr1lay(ip)),ctop(iptr1lay(ig)))
          enddo
        enddo
      endif
c
c  ---- write message to out file ---
c
      write(iout,'(a40,f7.0,i8.5)') 'Read boundary condition file at ',
     &                                                   toptim,topdate
c
      write(*,'(a)') '   Done'
      call flush(6)
c
 9999 continue
      return
      end

C***** RDPTGRP
c
      subroutine rdptgrp(ndate,ttime,igroup,emscls,izcel)
      use filunit
      use grid
      use camxcom
      use chmstry
      use ptemiss
      use tracer
c
c      Copyright Ramboll
c
c
c----CAMx v7.40 260801
c
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     08/18/99  --gwilson--   Added code to implement the override
c                             flag for the source area of point sources
c     10/24/01  Removed BSWAP and converted integer strings to character*4
c     07/05/02  Changed to account for new type of the PiG flag
c     05/01/03  Time span of emissions must now match emiss update interval
c     09/25/03  Significant changes to handle PSAT
c     03/01/16  Fixed bug in point source override and compact ptsrce file
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer ndate
      real    ttime
      integer igroup
      real    emscls(MXTRCLS+1,*)
      integer izcel(*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  ptspcname
      character*4   iname(10)
      integer       ibgdat, iendat, iounit, idx, iseg, idxfile
      integer       npoint, ispc, i, idum, idxcp, idcompact(MXPTSRC)
      integer       num_ptsfiles, idx_start, isoa, iclass
      real          bgtim, edtim, rdum
      logical       lfound, lfirst_pass, luse_this_species
      logical       luse_model_species
c
      integer, allocatable, dimension(:) :: izcel_in
      real,    allocatable, dimension(:) :: emspts_in
      real,    allocatable, dimension(:) :: emspts
      real,    allocatable, dimension(:) :: flowrat_in
      real,    allocatable, dimension(:) :: effph_in
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- allocate local arrays ----
c
      allocate( izcel_in(nptsrc) )
      allocate( emspts_in(nptsrc) )
      allocate( emspts(nptsrc) )
      allocate( flowrat_in(nptsrc) )
      allocate( effph_in(nptsrc) )
c
c   --- skip if filename not supplied ---
c
      num_ptsfiles = num_iortpt(igroup)
      if( igroup .EQ. 0 ) num_ptsfiles = npoint_files
      do idxfile=1,num_ptsfiles
         if( .NOT. ltptfl(igroup,idxfile) ) cycle
         idx_start = idx_start_sapts(igroup,idxfile)
c
c   --- set the unit number for file ---
c
         if( igroup .EQ. 0 ) then
             if( is_netcdf_iptem(idxfile) ) cycle
             iounit = iptem(idxfile)
             write(fname,'(A,I3)') 'PTSOURCE -- UNIT ',iptem(idxfile)
             do i=1,nspcpt(igroup,idxfile)
                 backspace(iounit)
             enddo
             backspace(iounit)
             backspace(iounit)
             backspace(iounit)
         else
             if( is_netcdf_iortpt(igroup,idxfile) ) cycle
             iounit = iortpt(igroup,idxfile)
             fname = tptfil(igroup,idxfile)
         endif
         lfirst_pass = .TRUE.
c
c  --- gary wants this flush ---
c
         call flush(6)
c
c   --- read the date and time, again ---
c
         lfound = .FALSE.
  111    continue
         read(iounit,END=222) ibgdat, bgtim, iendat, edtim
         if(NINT(edtim) .EQ. 0) then
           edtim = 24.
           iendat = ibgdat
         endif
         ichktm1 = NINT( 1000*(bgtim) )
         if( le1day ) then
            ichktm2 = NINT( 1000*(edtim) )
         else
            ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
         endif
         if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
         ichkems = NINT( 1000*(dtems/60.) )
         if( (ichktm2 - ichktm1) .NE. ichkems ) then
             write(iout,'(//,a)')'ERROR in RDPTGRP:'
             write(iout,*) 'Time interval in surface emissions file does'
             write(iout,*)  ' not match emissions update time interval.'
             write(iout,*) '   Beginning Date/Time (Hour): ',ibgdat,bgtim
             write(iout,*) '   Ending Date/Time    (Hour): ',iendat,edtim
             write(iout,*) '   Emiss Input interval(Hour): ',dtems/60.
             call camxerr()
         endif
         bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
         edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the number of points and point locations ---
c
          read(iounit,ERR=7000) iseg, npoint
          if( npoint .LE. 0 ) cycle
          read(iounit,ERR=7000,END=7001)  (idcompact(i), idum,
     &             izcel_in(i), flowrat_in(i), effph_in(i),i=1,npoint)
          do i=1,npoint
            idxcp = i
            if( lcompactpt(igroup,idxfile) ) idxcp = idcompact(i)
            izcel(i+idx_start) = izcel_in(i)
            flowrat(i+idx_start) = flowrat_in(i)
            effph(i+idx_start) = effph_in(i)
            if( flowrat(i) .LT. 0. .AND. effph(i) .LT. 0. .AND.
     &                    ABS(effph(i)) .LT. ABS(flowrat(i)) ) goto 7003
          enddo
c
c   --- read the emissions for this hour ---
c
          do 10 ispc=1,nspcpt(igroup,idxfile)
             read(iounit,ERR=7000,END=7001) iseg, (iname(i),i=1,10),
     &                                         (emspts_in(i),i=1,npoint)
           write(ptspcname,'(10A1)') iname
c
c   --- if date and time does not match this hour, skip this record ---
c
              if( le1day ) then
                  if( bgtim .NE. ttime ) goto 10
              else
                  if( ndate .NE. ibgdat .OR. bgtim .NE. ttime ) goto 10
              endif
              lfound  = .TRUE.
c
c   --- if the species is a not modelled or not a tracer species skip it ---
c
              idx = idxpts(igroup,idxfile,ispc)
              if( idx .LE. 0 ) goto 10
c
c   --- put emissions into regular model array ---
c
              do i=1,npoint
                idxcp = i
                if( lcompactpt(igroup,idxfile) ) idxcp = idcompact(i)
                ptemis(idxcp+idx_start,idx) = emspts_in(i)/(60.*dtems)
              enddo
c
c  --- skip the rest if not an SA species ---
c
              luse_this_species = .FALSE.
              luse_model_species = .FALSE.
              if( lusespc(idx) ) then
                 luse_this_species = .TRUE.
                 luse_model_species = .TRUE.
              endif
              do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                if( luse_soap3 .AND. lsoa .AND.
     &             ptspcname .EQ. soap_emiss_names(isoa) ) 
     &                               luse_this_species = .TRUE.
              enddo
              if( luse_soap3 .and. lsoa ) then
                if( ptspcname(1:4) .EQ. 'POA ' )
     &                  ptspcname = soap_emiss_names(IDX_SOAP_POA_AV)
                if( ptspcname(1:4) .EQ. 'POA_') luse_this_species = .TRUE.
              endif
              if( .NOT. luse_this_species ) goto 10
c
c   --- convert to PPM (PPMC) ----
c
              do i=1,npoint
                idxcp = i
                if( lcompactpt(igroup,idxfile) ) idxcp = idcompact(i)
                emspts(idxcp) = emspts_in(i)/(60.*dtems)
c
c   --- put into regular model array ---
c
                if( luse_model_species ) 
     &             ptemis(i+idx_start,idx) = emspts_in(i)/(60.*dtems)
c
c   --- load into the tracer emissions array ---
c
                 do 20 icls=1,ntrcls
c
c   --- if this is the NOx emissions tracer and this is a 
c       PiG source, skip it (PiG treated elsewhere) ---
c
c   --- gary wants this call to flush ---
c
                     call flush(6)
                     if( lpigsa(idxcp+idx_start) ) goto 20
                        emscls(iclass,idxcp+idx_start) = 
     &                      emscls(iclass,idxcp+idx_start) + emspts(idxcp)
   20            continue
                 iclass =  ntrcls - 1
                 do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                     iclass = iclass + 1
                     if( lpigsa(idxcp+idx_start) ) cycle
                     if( ptspcname .EQ. soap_emiss_names(isoa) ) then
                        emscls(iclass,idxcp+idx_start) = 
     &                      emscls(iclass,idxcp+idx_start) + emspts(idxcp)
                     endif
                 enddo
              enddo
c
c   --- next species ---
c
  10      continue
c
c   --- if the correct hour has not been found,
c       go back and read some more else read next file ---
c
          if( .NOT. lfound ) then
             goto 111
          else
             cycle
          endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222    continue
         if( le1day .AND. lfirst_pass ) then
             lfirst_pass = .FALSE.
             rewind(iounit)
             read(iounit)
             read(iounit)
             read(iounit)
             read(iounit)
             read(iounit)
             read(iounit)
             goto 111
         else
             goto 7001
         endif
         cycle
      enddo
      goto 9999
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDPTGRP:'
      write(iout,'(/,1X,A,I8.5,F8.1,2A)') 
     &      'Reading emissions after hour ',ibgdat, bgtim,' in file: ',
     &                                            fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDPTGRP:'
      write(iout,'(/,1X,3A)') 'Premature end-of-file reading ',
     &                  'emissions from file: ',fname(:istrln(fname))
      write(iout,'(1X,3A)') 'Make sure the file congtains all of the',
     &                  ' hours in the simulation.'
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDPTGRP:'
      write(iout,'(/,1X,A,I10,2A)') 'Number of points: ',npoint,
     &     ' is not consistent with regular emissions in file: ',
     &                                            fname(:istrln(fname))
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)')'ERROR in RDPTGRP:'
      write(iout,*) 'Invalid values found for flow rate and plume height.'
      write(iout,*) 'The plume distribution override is triggered. But the '
      write(iout,*) 'value for flow rate (base) is larger than value for ',
     &                      'plume height (top).'
      call camxerr()
c
 9999 continue
c
c   --- deallocate local arrays ----
c
      deallocate( izcel_in )
      deallocate( emspts_in )
      deallocate( emspts )
      deallocate( flowrat_in )
      deallocate( effph_in )
c
      return
      end

      subroutine emiss(igrd,m1,m2,m3,i0,j0,ia,iz,ja,jz,
     &                 nspc,nspecem,nlu,ndpspc,densfac,lspmap,lprobe,nsrc,
     &                 idsrc,isrc,jsrc,ncol,nrow,nlay,nlay_ems,deltat,
     &                 dx,dy,mapscl,height,depth,windu,windv,tempk,press,
     &                 icdocn,fsurf,tsurf,eflxnh3,
     &                 aremis,pttrace,numpts,armass,
     &                 ptmass,reemis,conc,depfld,ipa_cel)
      use bndary
      use chmstry
      use filunit
      use ptemiss
      use procan
      use tracer
c
c----CAMx v7.40 260801
c
c     EMISS updates species concentrations due to emissions
c
c      Copyright Ramboll
c          
c     Modifications: 
c        10/29/01   Map scale factor added to emissions increment
c        04/21/04   Added optional plume rise override
c        04/08/10   Updates to plume rise algorithm (multi-layer injection)
c        01/15/13   Allow user-set multi-layer injection using EFFPH and FLOWRAT
c        04/29/13   Inject surface model re-emissions
c        12/18/15   Add oceanic I2/HOI emissions from O3 dep
c        07/23/18   Updated for Bi-Di NH3 drydep
c
c     Input arguments:
c        igrd                grid number
c        nspc                number of species
c        nlu                 number of land use categories
c        ndpspc              number of deposition species inc. I2,HOI emissions
c        densfac             gas concentration conversion factor
c        lspmap              emissions source species map
c        lprobe              flag for a Probing Tool call
c        nsrc                number of point sources
c        idsrc               point source ID map
c        isrc                grid column index for point sources
c        jsrc                grid row index for point sources
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        nlay_ems            number of layers in emissions files
c        deltat              time step size (s)
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        mapscl              map scale factor
c        height              layer height (m)
c        depth               layer depth (m)
c        windu               wind speed in x-direction (m/s)
c        windv               wind speed in y-direction (m/s)
c        tempk               air temprature (K)
c        press               air pressure (mb)
c        icdocn              ocean map
c        fsurf               landuse fraction
c        tsurf               surface temperature (K)
c        eflxnh3             emiss flux of Bi-Di NH3 drydep (umol/m2-s)
c        aremis              area source strength (mol/s)
c        pttrace             point source strength (mol/s)
c        numpts              number of point sources
c        armass              mass from area source emission (umol)
c        ptmass              mass from point source emission (umol)
c        reemis              emissions from surface model (mol/s)
c        conc                species concentrations (umol/m3)
c        depfld              deposited mass carrying I2,HOI emissions (mol)
c        ipa_cel             gridded array to identify if cell is
c                            in a IPRM sub-domain
c
c     Output arguments:
c        conc                species concentrations (umol/m3)
c        armass              mass from area source emission (umol)
c        ptmass              mass from point source emission (umol)
c
c     Routines called:
c        PLUMERIS
c        IXEMIS
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include  "camx.prm"
      include  "flags.inc"
      include  "soap.inc"
      include  "soap3.inc"
c
c-----Input arguments
c
      integer :: igrd
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz
      integer :: nspc,nspecem,nsrc,ncol,nrow,nlay,nlay_ems,numpts
      integer :: nlu
      integer :: ndpspc
      real    :: deltat,dy
      real    :: densfac
      logical :: lprobe
      integer icdocn(m1,m2)
      integer lspmap(*)
      real*8  armass(*)
      real*8  ptmass(*)
      integer idsrc(*)
      integer isrc(*)
      integer jsrc(*)
      real    pttrace(numpts,nspecem)
      real    conc(m1,m2,m3,nspc)
      real    aremis(m1,m2,nlay_ems,nspecem)
      real    reemis(m1,m2,nsmspc)
      real    dx(nrow)
      real    mapscl(m1,m2)
      real, dimension(m1,m2,m3) :: windu,windv,tempk,press
      real, dimension(m1,m2,m3) :: height, depth
      real, dimension(m1,m2)    :: tsurf
      real, dimension(m1,m2)    :: eflxnh3
      real, dimension(m1,m2,nlu) :: fsurf
      real, dimension(m1,m2,ndpspc) :: depfld
c
c======================== Process Analysis Begin ====================================
c
      integer ipa_cel(ncol,nrow,nlay)
      integer ipa_idx
c
c========================= Process Analysis End =====================================
c
c-----Local variables
c
      integer l,i,j,k,kstk,kt,kb,lsrc,n
      integer ll,lsm,iems,iflgbidi,imap,ipart
      real frac
      real hght1d(0:MXLAYER)
      real wind1d(MXLAYER)
      real tempk1d(MXLAYER)
      real dtdz1d(MXLAYER)
      real pfrac(MXLAYER)
      real gamma,p0,grav
      real i2flx,hoiflx
      real cellarea,vol,dconc,w2,dz,dtheta,zstk,zbot,ztop,dstkabs,wp,tp,zrise,
     &     trise,pwidth,rip,fp,qp2,cq1,cq2,rkp,bot,top,fwtr,co3,convfac,
     &    hstktmp, tstktmp, vstktmp
      real*8  dmass
      real    pnt_emiss_svoa(MXLAYER)
      real    pnt_emiss_hoa, pnt_emiss_poa(MXLAYER)
      real    pnt_emiss_soap3(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB,MXLAYER)
      real    sa_pnt_emiss_hoa
      integer isoa
      logical evap_this_species, lspec_soap3

      real, allocatable, dimension(:,:,:)   :: hoa_evap_area_emiss
      real, allocatable, dimension(:,:,:)   :: svoa_evap_area_emiss
      real, allocatable, dimension(:,:,:,:) :: sa_hoa_evap_area_emiss
      real, allocatable, dimension(:,:,:,:) :: sa_svoa_evap_area_emiss
      real, allocatable, dimension(:,:)     :: sa_pnt_emiss_poa
      real, allocatable, dimension(:,:)     :: sa_pnt_emiss_svoa
c
      data gamma,p0,grav /0.286,1000.,9.8/
      data cq1,cq2 /0.4,3.0/
c
c-----Entry point
c
c----allocate data structures for SA HOA emissions for points ---
c
      if( luse_soap3 ) then
         allocate( hoa_evap_area_emiss(m1,m2,nlay_ems) )
         allocate( svoa_evap_area_emiss(m1,m2,nlay_ems) )
         if( lprobe .AND. lsoa ) then
            allocate( sa_hoa_evap_area_emiss(m1,m2,nlay_ems,iemcls(idxipt(ITRHOA)):nptcls(idxipt(ITRHOA))) )
            allocate( sa_svoa_evap_area_emiss(m1,m2,nlay_ems,iemcls(idxipt(ITRSVA)):nptcls(idxipt(ITRSVA))) )
            allocate( sa_pnt_emiss_poa(iemcls(idxipt(ITRHOA)):nptcls(idxipt(ITRHOA)),MXLAYER) )
            allocate( sa_pnt_emiss_svoa(iemcls(idxipt(ITRSVA)):nptcls(idxipt(ITRHOA)),MXLAYER) )
            sa_pnt_emiss_hoa = 0.
            sa_pnt_emiss_poa = 0.
            sa_pnt_emiss_svoa = 0.
            sa_hoa_evap_area_emiss = 0.
            sa_svoa_evap_area_emiss = 0.
         endif
      endif
c
c-----Update concentration due to area source
c
      if (larsrc) then
c
c-----If doing SOAP3, call routine to update emissions for POA evap ---
c
        if( luse_soap3 .AND. .NOT. lprobe ) then
             call soap3_evap_area( igrd, m1, m2, m3, nlay_ems,
     &              soap3_evap_factors, tempk, hoa_evap_area_emiss, 
     &                                  svoa_evap_area_emiss, aremis, nspecem)
        endif
        if( lprobe .AND. luse_soap3 .AND. lsoa ) then
             call SA_soap3_evap_area( igrd, m1, m2, m3, nlay_ems,
     &              soap3_evap_factors, tempk, iemcls(idxipt(ITRHOA)),
     &                    nptcls(idxipt(ITRHOA)), sa_hoa_evap_area_emiss, 
     &                          iemcls(idxipt(ITRSVA)),nptcls(idxipt(ITRSVA)),
     &                            sa_svoa_evap_area_emiss, aremis, soap3_ntotsp)
        endif
c
c$omp parallel default(shared)
c$omp&  private(l,i,j,k,iems,ll,lsm,cellarea,vol,dmass,dconc,ipa_idx,
c$omp&          i2flx,hoiflx,fwtr,co3,convfac,w2,iflgbidi,imap,ipart,frac,
c$omp&          isoa,lspec_soap3)
c
c$omp do schedule(static)
c
        do iems = 1,nspecem
          if( .NOT. lprobe ) then
            l = lspmap(iems)
            lspec_soap3 = .FALSE.
            if( luse_soap3 ) then
               do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                   if( iems .EQ. idx_ems_soap3(isoa) ) luse_soap3 = .TRUE.
               enddo
            endif
            if( lspec_soap3 ) cycle 
          else
            lspec_soap3 = .FALSE.
            l = iems
            do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
               if( iems .GE. soap3_iemcls(isoa) .AND. 
     &                        iems .LE. soap3_nptcls(isoa) ) lspec_soap3 = .TRUE.
            enddo
            if( lspec_soap3 ) cycle 
          endif
          if( iems .LE. 0 .AND. l .NE. ki2 .AND. l .NE. khoi ) cycle     
          if (lsrfmod) then
            lsm = 0
            do ll = 1,nsmspc
              if (l .EQ. idsmsp(ll)) lsm = ll
            enddo
          endif
          iflgbidi = 0
          if (lbidinh3) then
            if (lprobe) then
              !bk - assume that ITRNH3 is the only tracer group that includes NH3 (for SA)
              !     and NAMALL is the only species group that includes NH3 (for DDM/HDDM);
              !     this achieves better efficiency at the cost of some flexibility
              if (ltrace .AND. tectyp.NE.RTRAC .AND. tectyp.NE.RTCMC) then
                do ll = 1,ntrcls
                  if (idxcls(ll).eq.ITRNH3) then
                    do imap = 1,nregin
                      if (l.eq.(iemcls(ll)-1+imap+(IGRPBIDI-1)*nregin))
     &                       iflgbidi = imap
                    enddo
                  endif
                enddo
              else if (lddm .OR. lhddm) then
                do ll = 1,nemddm
                  if (emddmsp(ll).eq.'NH3       ' .or. emddmsp(ll).eq.NAMALL) then
                    do imap = 1,nregin
                      if (l.eq.(iptddm(knh3)+nbdic+(ll-1)*ngroup*nregin+(imap-1)*ngroup+IGRPBIDI-1))
     &                       iflgbidi = imap
                    enddo
                  endif
                enddo
              endif
            else
              if (l.eq.knh3) iflgbidi = 1
            endif
          endif
          do i = 2, m1-1
            do j = 2, m2-1
              do k=1,nlayers_ems
c
c  --- calculate cell volume ---
c
                  cellarea = dx(j+j0)*dy/(mapscl(i,j)**2.)
                  vol = cellarea*depth(i,j,k)
c
c------Standard gridded emissions
c
                  dmass = 0.
                  dconc = 0.
                  if( .NOT. lprobe ) then
                      if( luse_soap3 .AND. iems .EQ. idx_ems_svoa ) then
                          dmass = DBLE((aremis(i,j,k,iems)+svoa_evap_area_emiss(i,j,k))*deltat*1e6)
                      else if( luse_soap3 .AND. emspcname(iems)(1:4) .EQ. 'POA_' .AND.
     &                                                  aremis(i,j,k,iems) .GT. 0. ) then
                          dmass = DBLE(hoa_evap_area_emiss(i,j,k)*deltat*1e6)
                          hoa_evap_area_emiss(i,j,k) = 0.
                      else
                          dmass = DBLE(aremis(i,j,k,iems)*deltat*1e6)
                      endif
                  endif
                  if( lprobe ) then
                     if( lsoa .AND. luse_soap3 ) then
                         if( iems .GE. iemcls(idxipt(ITRHOA))
     &                             .AND. iems .LE. nptcls(idxipt(ITRHOA)) ) then
                           if( luse_soap3 ) then
                                 dmass = dmass + DBLE(((sa_hoa_evap_area_emiss(i,j,k,iems)))*deltat*1e6)
                                 sa_hoa_evap_area_emiss(i,j,k,iems) = 0.
                            endif
                         elseif( iems .GE. iemcls(idxipt(ITRSVA))
     &                             .AND. iems .LE. nptcls(idxipt(ITRSVA)) ) then
                                 dmass = dmass + DBLE((aremis(i,j,k,iems)+sa_svoa_evap_area_emiss(i,j,k,iems))*deltat*1e6)
                                 sa_svoa_evap_area_emiss(i,j,k,iems) = 0.
                         else
                                dmass = DBLE(aremis(i,j,k,iems)*deltat*1e6)
                         endif
                     else
                       dmass = DBLE(aremis(i,j,k,iems)*deltat*1e6)
                     endif
                  endif
c
c------Re-emissions from Bi-Di NH3 drydep
c
                  if( iflgbidi .GT. 0 ) then
                    if (lprobe) then
                      if (ltrace .AND. tectyp.NE.RTRAC .AND. tectyp.NE.RTCMC) then
                        do ipart = 1,npartial(IGRPBIDI,igrd)
                          imap = igrmap(IGRPBIDI,ipart,igrd,i+i0,j+j0)
                          frac = frcmap(IGRPBIDI,ipart,igrd,i+i0,j+j0)
                          if (imap.EQ.iflgbidi) dmass = dmass
     &                          + DBLE(eflxnh3(i,j)*cellarea*deltat*frac) ! [umol]
                        enddo
                      else if ((lddm .OR. lhddm) .AND. ngroup .GT. 0 ) then
                        imap = igrmap(0,1,igrd,i+i0,j+j0)
                        if (imap.EQ.iflgbidi) dmass = dmass
     &                              + DBLE(eflxnh3(i,j)*cellarea*deltat) ! [umol]
                      endif
                    else
                      dmass = dmass + DBLE(eflxnh3(i,j)*cellarea*deltat) ! [umol]
                    endif
                  endif
c
c------Re-emissions from surface model
c
                 if (lsrfmod .and. lsm .NE. 0)
     &                 dmass = dmass + DBLE(reemis(i,j,lsm)*deltat*1.d6)
c
c------Oceanic halogen emissions related to ozone deposition
c
                 if (k .eq. 1 .AND. lixemis .AND. icdocn(i,j).GT.0 
     &                      .AND. .NOT.lprobe .AND.
     &                               (l.EQ.ki2 .OR. l.EQ.khoi)) then
                   w2 = sqrt(windu(i,j,1)**2. + windv(i,j,1)**2.)
                   w2 = amax1(w2,0.1)
                   if (nlu.EQ.NLUW89) then
                     fwtr = fsurf(i,j,7)
                   else
                     fwtr = fsurf(i,j,1)
                   endif
                   convfac = densfac*(273./tempk(i,j,1))*
     &                                           (press(i,j,1)/1013.)
                   co3 = 1000.*conc(i,j,1,ko3)/convfac
                   call ixemis(dx(j+j0),dy,mapscl(i,j),icdocn(i,j),fwtr,
     &                            co3,tsurf(i,j),w2,i2flx,hoiflx)
                   if (l.eq.ki2)
     &               dmass = dmass + DBLE(i2flx*deltat*1.d6)
                     depfld(i,j,ndpspc-1) = depfld(i,j,ndpspc-1) + 
     &                                   i2flx*deltat/
     &                                   (dx(j+j0)*dy)*(mapscl(i,j)**2)
                   if (l.eq.khoi)
     &               dmass = dmass + DBLE(hoiflx*deltat*1.d6)
                     depfld(i,j,ndpspc) = depfld(i,j,ndpspc) + 
     &                                 hoiflx*deltat/
     &                                 (dx(j+j0)*dy)*(mapscl(i,j)**2)
                 endif
                 dconc = REAL(dmass)/vol
                 if( i .GE. ia .and. i .LE. iz .AND. 
     &                     j .GE. ja .AND. j .LE. jz ) armass(l) = armass(l) + dmass
                 conc(i,j,k,l) = conc(i,j,k,l) + dconc
              enddo
c
c======================== Process Analysis Begin ====================================
c
c----- if surface layer in this column is in a sub-domain
c      then track the area emissions in this grid cell ---
c
              if( (.NOT. ltrace) .AND. lipr ) then 
                   if( i .GE. ia .and. i .LE. iz .AND. 
     &                               j .GE. ja .AND. j .LE. jz ) then
                      if( ipa_cel(i+i0,j+j0,1) .GT. 0 ) then
                        ipa_idx = ipa_cel(i+i0,j+j0,1)
                        cipr(IPR_AEMIS, ipa_idx, l) =
     &                                      cipr(IPR_AEMIS, ipa_idx, l) + dconc
                      endif
                  endif
              endif
c
c========================= Process Analysis End =====================================
c
             enddo
          enddo
        enddo
c
c  --- end of parallelized loop ---
c
c$omp end parallel
c
      endif
c
c-----Update concentration due to point sources
c
      if (lptsrc) then
        do 50 lsrc = 1,nsrc
          n = idsrc(lsrc)
          i = isrc(lsrc)-i0
          j = jsrc(lsrc)-j0
          if (i < 2 .or. i >= m1 .or. j < 2 .or. j >= m2) goto 50
          hght1d(0) = 0.
          do k = 1,nlay
            hght1d(k) = height(i,j,k)
            tempk1d(k) = tempk(i,j,k)
            w2 = windu(i,j,k)*windu(i,j,k) + windv(i,j,k)*windv(i,j,k)
            wind1d(k) = amax1(sqrt(w2),0.1)
            if (k.lt.nlay) then
              dz = height(i,j,k+1)/2. 
              if (k.gt.1) dz = (height(i,j,k+1) - 
     &                          height(i,j,k-1))/2. 
              dtheta = (tempk(i,j,k+1)*(p0/press(i,j,k+1))**gamma - 
     &                  tempk(i,j,k)*(p0/press(i,j,k))**gamma) 
              dtdz1d(k) = dtheta/dz 
            else
              dtdz1d(k) = dtdz1d(k-1)
            endif 
          enddo
c
c-----Apply plume rise OVERRIDE if effph is negative
c
          if (effph(n) .lt. 0. .and. flowrat(n) .ge. 0.) then
            zstk = abs(effph(n))
            do kstk = 1,nlay
              if (hght1d(kstk).gt.zstk) goto 14
            enddo
            kstk = nlay
            zstk = hght1d(kstk-1) + 1.
  14        zbot = max(0.,zstk - 1.)
            ztop = min(hght1d(nlay),zstk + 1.)
c
c-----Handle unique situation for EPS3 point source files
c
          else if(effph(n) .LT. 0. .AND. flowrat(n) .LT. 0. .AND.
     &            effph(n) .EQ. flowrat(n) ) then
            zstk = abs(effph(n))
            do kstk = 1,nlay
              if (hght1d(kstk).gt.zstk) goto 13
            enddo
            kstk = nlay
            zstk = hght1d(kstk-1) + 1.
  13        zbot = max(0.,zstk - 1.)
            ztop = min(hght1d(nlay),zstk + 1.)
c
c-----Apply plume layer distribution if stack height is also negative ---
c
          else if(effph(n) .LT. 0. .AND. flowrat(n) .LT. 0. .AND.
     &            effph(n) .NE. flowrat(n) ) then
            zstk = 0.5*( ABS( effph(n) ) + ABS( flowrat(n) ) )
            do kstk = 1,nlay
              if (hght1d(kstk) .GT. zstk) goto 18
            enddo
            kstk = nlay
  18        zbot = MAX(0., MIN( ABS( flowrat(n) ), ABS( effph(n) ) ) )
            ztop = MIN( hght1d(nlay),
     &                     MAX( ABS( effph(n) ), ABS( flowrat(n) ) ) )
          else
c
c-----Calculate plume rise
c
            dstkabs = abs(dstk(n))
            hstktmp = hstk(n)
            tstktmp = tstk(n)
            vstktmp = vstk(n)
            call plumeris(nlay,hght1d,tempk1d,dtdz1d,wind1d,hstktmp,
     &                    dstkabs,tstktmp,vstktmp,zstk)
            do kstk = 1,nlay
              if (hght1d(kstk).gt.zstk) goto 15
            enddo
            kstk = nlay
            zstk = hght1d(kstk-1) + 1.
c
c-----Determine plume depth
c
  15        wp = amax1(1.,vstktmp/2.)
            tp = (tempk1d(kstk) + tstktmp)/2.
            zrise = zstk - hstktmp
            trise = zrise/wp
            pwidth = sqrt(2.)*dstkabs
            rip = grav*pwidth*abs(tp - tempk1d(kstk))/
     &            (tempk1d(kstk)*wp*wp)
            fp = 1. + 4.*rip
            qp2 = fp*wp*wp*(cq1 + cq2*wind1d(kstk)*wind1d(kstk)/
     &            (wind1d(kstk)*wind1d(kstk) + wp*wp))
            rkp = 0.15*pwidth*sqrt(qp2)
            pwidth = 3.*sqrt(pwidth*pwidth + 2.*rkp*trise)
            pwidth = max(1.,min(pwidth,zrise))
            zbot = max(hght1d(0),zstk - pwidth/2.)
            ztop = min(hght1d(nlay),zstk + pwidth/2.)
          endif
c
c-----Calculate layers to receive emission injection
c
          pwidth = ztop - zbot
          do k = 1,nlay
            pfrac(k) = 0.
          enddo
          do kt = kstk,nlay
            if (hght1d(kt).ge.ztop) goto 16
          enddo
          kt = nlay 
  16      do kb = 1,kstk
            if (hght1d(kb).gt.zbot) goto 17
          enddo
  17      do k = kb,kt
            bot = max(hght1d(k-1),zbot)
            top = min(hght1d(k),ztop)
            pfrac(k) = (top - bot)/pwidth
          enddo
c
c  --- if doing SOAP3, call routine to update emissions for evaporative ---
c
          if( luse_soap3 .AND. .NOT. lprobe ) then
             pnt_emiss_soap3 = 0.
             pnt_emiss_svoa = 0.
             pnt_emiss_hoa = 0.
             pnt_emiss_poa = 0.
             do iems = 1,nspecem
                do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                   if( emspcname(iems) .EQ. soap_emiss_names(isoa) ) then
                     do k = kb,kt
                        pnt_emiss_soap3(isoa,k) = pnt_emiss_soap3(isoa,k) + 
     &                                                pttrace(n,iems)*pfrac(k)
                     enddo
                   endif
                   if( emspcname(iems)(1:4) .EQ. 'POA ' ) then
                      do k = kb,kt
                         pnt_emiss_soap3(IDX_SOAP_POA_AV,k) = 
     &                             pnt_emiss_soap3(IDX_SOAP_POA_AV,k) +
     &                                             pttrace(n,iems)*pfrac(k)
                       enddo
                   endif
                enddo
             enddo
             call soap3_evap_pts( n, kb, kt, soap3_evap_factors, tempk1d, 
     &                  pnt_emiss_soap3, pnt_emiss_svoa, pnt_emiss_poa)
          endif
          if( luse_soap3 .AND. lprobe .AND. lsoa ) then
             call SA_soap3_evap_pts( n, kb, kt, numpts, soap3_ntotsp,
     &                   iemcls(idxipt(ITRHOA)),nptcls(idxipt(ITRHOA)), 
     &                     iemcls(idxipt(ITRSVA)),nptcls(idxipt(ITRSVA)), 
     &                              soap3_evap_factors, tempk1d, pttrace,
     &                                 sa_pnt_emiss_poa,sa_pnt_emiss_svoa)
          endif
          do 40 iems = 1,nspecem
            l = lspmap(iems)
            if( l .LE. 0 .OR. l .GT. nspc ) cycle
            if( .NOT. lprobe .AND. luse_soap3 .and. emspcname(iems)(1:4) .EQ. 'POA ' ) cycle
            if( .NOT. lprobe ) then
              if( emspcname(iems)(1:4) .EQ. 'HOA ' ) pnt_emiss_hoa = pttrace(n,iems)
            else
              if( ptname(iems)(1:4) .EQ. 'HOA0' ) then
                 sa_pnt_emiss_hoa = pttrace(n,iems)
              endif
           endif
c
c  --- adjust SOAP3 species for evap ---
c
            if (lpiglet(n) .AND. ipigflg .NE. 0) goto 40
            do k = kb,kt
              dmass = 0.
              dconc = 0.
c
c  --- emissions species is emitted HOA, just load it ---
c
              vol = dx(j+j0)*dy*depth(i,j,k)/(mapscl(i,j)**2.)
              if( .NOT. lprobe ) then
                  if( luse_soap3 .AND. iems .EQ. idx_ems_svoa ) then
                      dmass = dmass+DBLE((pttrace(n,iems)*pfrac(k)+pnt_emiss_svoa(k))*deltat*1e6)
                  elseif( luse_soap3 .AND. emspcname(iems)(1:4) .EQ. 'POA_' 
     &                                  .AND. pttrace(n,iems) .GT. 0.  ) then 
                      dmass = DBLE(pnt_emiss_poa(k)*deltat*1e6)
                  elseif( luse_soap3 .AND. iems .EQ. idx_ems_hoa ) then 
                      dmass = DBLE(pnt_emiss_hoa*pfrac(k)*deltat*1e6)
                  else
                      dmass = DBLE(pttrace(n,iems)*deltat*1e6*pfrac(k))
                  endif
              endif
              if( lprobe ) then
                 if( iems .LT. iemcls(idxipt(ITRHOA))
     &                             .OR. iems .GT. nptcls(idxipt(ITRHOA)) ) then
                     dmass = DBLE(pttrace(n,iems)*deltat*1e6*pfrac(k))
                 endif
                 if( lsoa .AND. luse_soap3 ) then
                     if( iems .GE. iemcls(idxipt(ITRSVA)) 
     &                             .AND. iems .LE. nptcls(idxipt(ITRSVA)) ) then
                         dmass = dmass + DBLE(sa_pnt_emiss_svoa(l,k)*pfrac(k)*deltat*1e6)
                     endif
                     if( iems .GE. iemcls(idxipt(ITRHOA))
     &                             .AND. iems .LE. nptcls(idxipt(ITRHOA)) ) then
                        if( luse_soap3 ) then
                            dmass = DBLE((sa_pnt_emiss_hoa+sa_pnt_emiss_poa(l,k))*pfrac(k)*deltat*1e6)
                        else
                            dmass = DBLE(pttrace(n,iems)*deltat*1e6*pfrac(k))
                        endif
                     endif
                 endif 
              endif
              dconc = REAL(dmass)/vol
              if( i .GE. ia .and. i .LE. iz .AND. 
     &            j .GE. ja .AND. j .LE. jz ) ptmass(l) =  
     &                                               ptmass(l) + dmass
              conc(i,j,k,l) = conc(i,j,k,l) + dconc
              dmass = 0.
c
c======================== Process Analysis Begin ====================================
c
c   --- if layer containing plume for this cell is in a sub-domain
c       then track the point source emissions for this cell ----
c
              if( (.NOT. ltrace) .AND. lipr ) then 
                 if( i .GE. ia .and. i .LE. iz .AND. 
     &                           j .GE. ja .AND. j .LE. jz ) then
                    if( ipa_cel(i+i0,j+j0,k) .GT. 0 ) then
                        ipa_idx = ipa_cel(i+i0,j+j0,k)
                        cipr(IPR_PTEMIS, ipa_idx, l) =
     &                              cipr(IPR_PTEMIS, ipa_idx, l) + dconc
                     endif
                  endif
              endif
c
c========================= Process Analysis End =====================================
c
            enddo
 40       continue
 50     continue
      endif
c
c----allocate data structures for SA HOA emissions for points ---
c
      if( luse_soap3 .AND. lprobe .AND. lsoa ) then
         deallocate( sa_pnt_emiss_poa )
         deallocate( sa_pnt_emiss_svoa )
         deallocate( hoa_evap_area_emiss )
      endif
c
      return
      end

c**** RDOPTCSA
c
      subroutine rdoptcsa()
      use filunit
      use grid
      use chmstry
      use procan
      use tracer
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the user options and flags for the
c     CSA algorithm.  
c
c      Copyright Ramboll
c
c     Argument description:
c           none
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     04/26/19   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Local Variables:
c-----------------------------------------------------------------------
c
      character*200 strtmp
      character*10  tmpnam
      integer i, j, k1, k2, k3, n, igrd, nox, noy
      integer numrxn,numreac,numprod,idxrxn,idxspc
      logical lerror
c
      integer, allocatable :: reactmp(:,:), prodtmp(:,:)
      real,    allocatable :: coeftmp(:,:)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- if option is turned off, just return ---
c
      if( .NOT. lcsa ) goto 9999
c
c  --- check that switches are compatible ---
c
      if( naero .GT. 0 ) then
         write(iout,'(//,a)') 'ERROR in RDOPTCSA:'
         write(iout,*) 'Cannot use CSA with Aerosol chemistry.'
         write(iout,*)
     &   '  Turn off CSA or use a different chemical mechanism.'
         call camxerr()
      endif
c
c   --- number of rate constant sensitivity groups ---
c
      nrateddm = Number_of_Rate_Const_Groups
      allocate( rateddm(nrateddm) )
      allocate( iprate(0:nreact, nrateddm ) )
      iprate = 0
      do i = 1, nrateddm
        strtmp = ADJUSTL(Rate_Const_Groups(i))
        j = INDEX(strtmp,':')
        if (j.eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
          write(iout,'(1X,A,I3,A)')
     &        'Delimiter (:) is not found in Rate_Const_Groups(',i,').'
          call camxerr()
        endif
        rateddm(i) = strtmp(:j-1)
        do
          strtmp = strtmp(j+1:)
          j = INDEX(strtmp,',')
          if (j.eq.0) then
            j = LEN_TRIM(strtmp) + 1
            if (j.eq.1) EXIT
          endif
          iprate(0,i) = iprate(0,i) + 1
          if (iprate(0,i).gt.nreact) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &            'Too many rxns (>nreact) in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
          if ( VERIFY( TRIM( ADJUSTL( strtmp(:j-1) ) ), '1234567890' )
     &                                                    .ne. 0 ) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &                 'Invalid rxn index in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
          read(strtmp(:j-1),'(I5)') iprate(iprate(0,i),i)
          if ( iprate(iprate(0,i),i).lt.1 .or.
     &         iprate(iprate(0,i),i).gt.nreact ) then
            write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
            write(iout,'(1X,A,I3,A)')
     &            'Out-of-range rxn index in Rate_Const_Groups(',i,').'
            call camxerr()
          endif
        enddo
        if (iprate(0,i).eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTDDM:'
          write(iout,'(1X,A,I3,A)')
     &                   'No rxn is found in Rate_Const_Groups(',i,').'
          call camxerr()
        endif
      enddo
c
c   --- number of rate term sensitivity groups ---
c
      ntermddm = Number_of_Rate_Term_Groups
      allocate( termddm(ntermddm) )
      termddm = ' '
      allocate( ipterm(0:ngas, nreact, ntermddm ) )
      ipterm = 0
      allocate( wfterm(  ngas, nreact, ntermddm ) )
      wfterm = 1.0
      allocate( reactmp(ngas,nreact) )
      allocate( prodtmp(ngas,nreact) )
      allocate( coeftmp(ngas,nreact) )
      do i = 1, ntermddm
        numrxn = 0
        reactmp = 0
        prodtmp = 0
        coeftmp = 1.0
        do n = 1, MXNAM
          strtmp = ADJUSTL(Rate_Term_Groups(i,n))
          if ( LEN_TRIM(strtmp).eq.0 ) CYCLE
          j = INDEX(strtmp,':')
          if (j.eq.0) then
            write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
            write(iout,'(1X,A,I3,A)')
     &          'Delimiter (:) is not found in Rate_Term_Groups(',i,').'
            call camxerr()
          endif
          if ( LEN_TRIM(termddm(i)).eq.0 ) then
            termddm(i) = strtmp(:j-1)
          else
            if ( termddm(i).ne.strtmp(:j-1) ) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A)')
     &                   'Inconsistent name of Rate_Term_Groups(',i,').'
              call camxerr()
            endif
          endif
          do
            strtmp = strtmp(j+1:)
            j = INDEX(strtmp,',')
            if (j.eq.0) then
              j = LEN_TRIM(strtmp) + 1
              if (j.eq.1) EXIT
            endif
            k1 = INDEX(strtmp(:j-1),'[R')
            k2 = INDEX(strtmp(:j-1),'[P')
            k3 = INDEX(strtmp(:j-1),']')
            if (k1+k2.eq.0 .or. k3.eq.0 .or. k3.lt.k1+k2+2) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A)')
     &                     'Invalid keyword in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            if ( VERIFY( TRIM( ADJUSTL( strtmp(:k1+k2-1) ) ),
     &                                     '1234567890' ) .ne. 0 ) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A)')
     &                   'Invalid rxn index in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            read(strtmp(:k1+k2-1),*) idxrxn
            if ( idxrxn.lt.1 .or. idxrxn.gt.nreact ) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A)')
     &              'Out-of-range rxn index in Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            numrxn = numrxn + 1
            ipterm(0,idxrxn,i) = 1
            tmpnam = strtmp(k3+1:j-1)
            do idxspc = 1, ngas
              if (tmpnam.eq.spname(idxspc)) EXIT
            enddo
            if (idxspc.gt.ngas) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A,I3,A)')
     &          'Invalid spc name in rxn(',idxrxn,
     &                                   ') of Rate_Term_Groups(',i,').'
              call camxerr()
            endif
            if (k1.gt.0) then ! Reactant
              reactmp(idxspc,idxrxn) = 1
            else              ! Product
              prodtmp(idxspc,idxrxn) = 1
            endif
            if (strtmp(k1+k2+2:k1+k2+2).eq.'#') then
              if ( k2.ne.0 ) then ! Check if a weighting factor is assigned to a product; may be allowed later
                write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
                write(iout,'(1X,A)')
     &                        'Products must not have weighting factors'
                call camxerr()
              endif
              if ( VERIFY( TRIM( ADJUSTL( strtmp(k1+k2+3:k3-1) ) ),
     &                                '1234567890.+-Ee' ) .ne. 0 ) then
                write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
                write(iout,'(1X,A,I3,A)')
     &                 'Invalid coefficient in Rate_Term_Groups(',i,').'
                call camxerr()
              endif
              read(strtmp(k1+k2+3:k3-1),*) coeftmp(idxspc,idxrxn)
            endif
          enddo
        enddo ! loop n
        if (numrxn.eq.0) then
          write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
          write(iout,'(1X,A,I3,A)')
     &                     'No rxn is found in Rate_Term_Groups(',i,').'
          call camxerr()
        endif
        do idxrxn = 1, nreact
          numreac = 0
          do idxspc = 1, ngas
            if ( reactmp(idxspc,idxrxn).eq.0 ) CYCLE
            numreac = numreac + 1
            ipterm(1+numreac,idxrxn,i) = idxspc
            wfterm(1+numreac,idxrxn,i) = coeftmp(idxspc,idxrxn)
          enddo
          ipterm(1,idxrxn,i) = numreac
          numprod = 0
          do idxspc = 1, ngas
            if ( prodtmp(idxspc,idxrxn).eq.0 ) CYCLE
            numprod = numprod + 1
            if ( 2+numreac+numprod.gt.ngas ) then
              write(iout,'(//,A)') 'ERROR in RDOPTCSA:'
              write(iout,'(1X,A,I3,A,I3,A)')
     &          'Too many spc selected in rxn(',idxrxn,
     &                                  ') of Rate_Const_Groups(',i,').'
              call camxerr()
            endif
            ipterm(2+numreac+numprod,idxrxn,i) = idxspc
          enddo
          ipterm(2+numreac,idxrxn,i) = numprod
        enddo ! loop idxrxn
      enddo ! loop i
      deallocate( reactmp )
      deallocate( prodtmp )
      deallocate( coeftmp )
c
c   ---- Number of Process Analysis domains
c
      npadom = Number_of_CSA_Domains
c
c   ---- Allocate the arrays that are dimensioned by grids ---
c
      if( npadom .LE. 0 ) goto 7000
      call alloc_procan(ngrid,ncol,nrow,nlay,.TRUE.)
c
c   ---- CSA domain definitions ---
c
      do n = 1,npadom
c
c   --- the grid number ---
c
         ipagrd(n) = Within_CAMx_Grid(n)
         if( ipagrd(n) .LE. 0 .OR. ipagrd(n) .GT. ngrid ) goto 7001
c
c   --- the cell indexes in the X and Y directions
c
         i_sw(n) = CSA_Beg_I_Index(n)
         i_ne(n) = CSA_End_I_Index(n)
         j_sw(n) = CSA_Beg_J_Index(n)
         j_ne(n) = CSA_End_J_Index(n)
         b_lay(n) = CSA_Beg_K_Index(n)
         t_lay(n) = CSA_End_K_Index(n)
c
c   --- check for valid cell indexes ---
c
         lerror = .FALSE.
         igrd = ipagrd(n)
         if( igrd .GT. 1 ) then
            nox = (inst2(igrd) - inst1(igrd) + 1 ) * meshold(igrd) + 2
            noy = (jnst2(igrd) - jnst1(igrd) + 1 ) * meshold(igrd) + 2
         else
            nox = ncol(1)
            noy = nrow(1)
         endif
         if( i_sw(n) .LE. 0 .OR. i_sw(n) .GT. i_ne(n) ) lerror = .TRUE. 
         if( i_ne(n) .GT. nox ) lerror = .TRUE. 
         if( j_sw(n) .LE. 0 .OR. j_sw(n) .GT. j_ne(n) ) lerror = .TRUE. 
         if( j_ne(n) .GT. noy ) lerror = .TRUE. 
         if( b_lay(n) .LE. 0 .OR. b_lay(n) .GT. t_lay(n) ) 
     &                                                  lerror = .TRUE.
         if( t_lay(n) .GT. nlay(igrd) ) lerror = .TRUE.
         if( lerror ) goto 7002
      enddo
c
c   --- dummy array for tracer wetdep field ---
c
      allocate( ptwetfld(1) )
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDOPTCSA:'
      write(iout,'(1X,2A,I3)') 'Invalid value for number of ',
     &                   'CSA domains: ',npadom
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDOPTCSA:'
      write(iout,'(1X,2A,I3)') 'Invalid value for grid number for ',
     &                         'CSA domain: ',ipagrd(n)
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDOPTCSA:'
      write(iout,'(1X,A,I3,A)') 'Cell indexes for CSA sub-domain: ',n,
     &                                                 ' are invalid.'
      write(iout,'(10X,A,I3,10X,A)') 'Sub-Domain #',n,'Grid Definition'
      write(iout,'(14X,2A,18X,A,I3)') 'Beg ',' End','Grid #',igrd
      write(iout,'(A10,1X,2I5,20X,I5)') 'Rows    :',i_sw(n),i_ne(n),nox
      write(iout,'(A10,1X,2I5,20X,I5)') 'Columns :',j_sw(n),j_ne(n),noy
      write(iout,'(A10,1X,2I5,20X,I5)') 'Layers  :',
     &                                    b_lay(n),t_lay(n),nlay(igrd)
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine initnml()
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
      use o3colmap
      use camxfld
      use camxcom
      use pigsty
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c         This routine initializes the namelist variables
c         to default values.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c    Called by:
c       STARTUP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers 
c       10/29/09     Added code for RTRAC surface model
c       01/04/11     Revised for new met input format
c       05/07/12     Added flexi-nesting flag
c       04/30/13     Added surface model
c       09/02/14     Added subgrid convective model
c       04/10/15     Added WRF polar and mercator projections
c       09/11/15     Revised for SA v3
c       03/01/16     Added partial source area map
c       05/13/16     Added in-line Ix emissions flag
c       11/09/16     Added Baker APCA point source override option
c       07/23/18     Added Bi-Di NH3 drydep flag
c       08/09/18     Added variables for rate term sensitivity
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: n
      integer :: m
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      Flexi_Nest              = .false.
      Restart                 = .false.
      Chemistry               = .false.
      Wet_Deposition          = .false.
      ACM2_Diffusion          = .false.
      Gridded_Emissions       = .false.
      Point_Emissions         = .false.
      Ignore_Emission_Dates   = .false.
      Diagnostic_Error_Check  = .false.
      PiG_Sampling_Grid       = .false.
      Sample_Background       = .false.
      Average_Output_3D       = .false.
      Output_Gas_Concs_PPM    = .true.
      Super_Stepping          = .true.
      Surface_Model           = .false.
      Subgrid_Convection      = .false.
      Bidi_NH3_Drydep         = .false.
      Strat_Ozone_Profile     = .false.
      NetCDF_Format_Output    = .true.
      do i = 1,MXNAM
        Output_3D_Grid(i)    = .false.
      enddo

      Root_Output_Name     = ' '
      Chemistry_Parameters = ' '
      Photolyis_Rates      = ' '
      Photolysis_Rates     = ' '
      Ozone_Column         = ' '
      Initial_Conditions   = ' '
      Boundary_Conditions  = ' '
      Top_Concentrations   = ' '
      Master_Grid_Restart  = ' '
      Nested_Grid_Restart  = ' '
      PiG_Restart          = ' '
      do i = 1,MXNAM
        Point_Sources(i)   = ' '
        Surface_Grid(i)    = ' '
        Met2D_Grid(i)      = ' '
        Met3D_Grid(i)      = ' '
        Cloud_Grid(i)      = ' '
        Vdiff_Grid(i)      = ' '
        Srfmod_Grid(i)     = ' '
      enddo
      do i = 1,MXGRID
       do n = 1,MXNAM
            Emiss_Grid(i,n) = ' '
        enddo
      enddo
      Run_Message          = ' '
      Map_Projection       = ' '
      Advection_Solver     = ' '
      Vadvection_Solver    = ' '
      Chemistry_Solver     = ' '
      PiG_Submodel         = ' '
      Probing_Tool         = ' '
      Inline_Ix_Emissions  = ' '
      do i = 1,MXNAM
        Output_Species_Names(i) = ' '
      enddo

      Time_Zone = 0
      do i = 1,4
        Start_Date_Hour(i)     = 0
        End_Date_Hour(i)       = 0
      enddo
      UTM_Zone                 = 0
      Number_of_Grids          = 0
      Master_Grid_Columns      = 0
      Master_Grid_Rows         = 0
      Number_of_Layers         = 0
      do i = 1,MXNAM
        Nest_Meshing_Factor(i) = 0
        Nest_Beg_I_Index(i)    = 0
        Nest_End_I_Index(i)    = 0
        Nest_Beg_J_Index(i)    = 0
        Nest_End_J_Index(i)    = 0
      enddo

      Maximum_Timestep         = 15.
      Met_Input_Frequency      = 60.
      Ems_Input_Frequency      = 60.
      Output_Frequency         = 60.
      Longitude_Pole           = 0.
      Latitude_Pole            = 0.
      True_Latitude1           = 0.
      True_Latitude2           = 0.
      Master_SW_XCoord         = 0.
      Master_SW_YCoord         = 0.
      Master_Cell_XSize        = 0.
      Master_Cell_YSize        = 0.

      Number_of_Sampling_Grids     = 0
      do n = 1,MXNAM
        SG_Beg_I_Index(n)          = 0
        SG_End_I_Index(n)          = 0
        SG_Beg_J_Index(n)          = 0
        SG_End_J_Index(n)          = 0
        SG_Mesh_Factor(n)          = 0.
      enddo
c
c  --- Defaults for NetCDF chunking parameters ---
c
      NetCDF_Use_Compression = .FALSE.
c
c======================== Probing Tool Begin ===========================
c
      SA_Master_Sfc_Output  = .false.
      SA_Nested_Sfc_Output  = .false.
      SA_Deposition_Output  = .false.
      SA_Stratify_Boundary  = .false.
      Use_Leftover_Group    = .false.
      Use_Gridded_Leftover_Group    = .false.
      SA_Summary_Output     = .false.
      SA_PT_Override        = .false.
      SA_3D_Average         = .false.

      DDM_Master_Sfc_Output = .false.
      DDM_Nested_Sfc_Output = .false.
      DDM_Stratify_Boundary = .false.
      DDM_PT_Override       = .false.

      SA_File_Root                     = ' '
      SA_Receptor_Definitions          = ' '
      SA_Initial_Conditions            = ' '
      SA_Boundary_Conditions           = ' '
      SA_Top_Concentrations            = ' '
      do n = 1,MXNAM
        SA_Source_Area_Map(n)          = ' '
      enddo
      SA_Master_Restart                = ' '
      SA_Nested_Restart                = ' '
      do n = 0,MXNAM
        do i = 1,MXFILES
           SA_Points_Group(n,i)        = ' '
        enddo
      enddo
      do n = 1,MXGRID
        do m = 0,MXNAM
          do i = 1,MXFILES
            SA_Emiss_Group_Grid(m,n,i) = ' '
          enddo
        enddo
      enddo
      SA_Treat_SULFATE_Class = .false.
      SA_Treat_NITRATE_Class = .false.
      SA_Treat_SOA_Class     = .false.
      SA_Treat_PRIMARY_Class = .false.
      SA_Treat_MERCURY_Class = .false.
      SA_Treat_OZONE_Class   = .false.
      SA_Use_APCA            = .false.
      SA_Use_APCA_Ptoverride = .false.
      SA_Use_Partial_SourceMap = .false.
      Partial_Source_Area_Map  = ' '

      DDM_File_Root                     = ' '
      DDM_Receptor_Definitions          = ' '
      do n = 1,MXNAM
        DDM_Source_Area_Map(n)          = ' '
      enddo
      DDM_Initial_Conditions            = ' '
      DDM_Boundary_Conditions           = ' '
      DDM_Top_Concentrations            = ' '
      DDM_Master_Restart                = ' '
      DDM_Nested_Restart                = ' '
      do n = 1,MXNAM
        do i = 1,MXFILES
           DDM_Points_Group(n,i)        = ' '
        enddo
        do m = 1,MXNAM
          HDDM_parameters(m,n)          = ' '
          Rate_Term_Groups(m,n)     = ' '
        enddo
        IC_Species_Groups(n)            = ' '
        BC_Species_Groups(n)            = ' '
        Emis_Species_Groups(n)          = ' '
        Rate_Const_Groups(n)            = ' '
        DDM_Calc_Grid(n)                = .TRUE.
      enddo
      do n = 1,MXGRID
        do m = 1,MXNAM
          do i = 1,MXFILES
            DDM_Emiss_Group_Grid(m,n,i) = ' '
          enddo
        enddo
      enddo

      RT_File_Root                  = ' '
      RT_Initial_Conditions         = ' '
      RT_Boundary_Conditions        = ' '
      RT_Top_Concentrations         = ' '
      RT_Master_Restart             = ' '
      RT_Nested_Restart             = ' '
      RT_Chemistry_Parameters       = ' '
      RT_Receptor_Definitions       = ' '
      RT_Point_Sources              = ' '
      do m = 1,MXNAM
        RT_Emiss_Grid(m)            = ' '
        RT_Srfmod_Grid(m)           = ' '
      enddo
      RT_PiG_Sample                 = .false.
      RT_Surface_Model              = .false.
      RT_Partitioning               = .false.

      PA_File_Root                  = ' '

      SA_Number_of_Source_Regions  = 0
      SA_Number_of_Source_Groups   = 0
      Number_of_Timing_Releases    = 0

      DDM_Number_of_Source_Regions = 0
      DDM_Number_of_Source_Groups  = 0
      Number_of_IC_Species_Groups  = 0
      Number_of_BC_Species_Groups  = 0
      Number_of_EM_Species_Groups  = 0
      Number_of_Rate_Const_Groups  = 0
      Number_of_HDDM_Sens_Groups   = 0
      Number_of_Rate_Term_Groups   = 0

      Number_of_PA_Domains         = 0
      do n = 1,MXNAM
        Within_CAMx_Grid(n)        = 0
        PA_Beg_I_Index(n)          = 0
        PA_End_I_Index(n)          = 0
        PA_Beg_J_Index(n)          = 0
        PA_End_J_Index(n)          = 0
        PA_Beg_K_Index(n)          = 0
        PA_End_K_Index(n)          = 0
      enddo

      CSA_File_Root                 = ' '
      Number_of_CSA_Domains         = 0
      do n = 1,MXNAM
        CSA_Beg_I_Index(n)          = 0
        CSA_End_I_Index(n)          = 0
        CSA_Beg_J_Index(n)          = 0
        CSA_End_J_Index(n)          = 0
        CSA_Beg_K_Index(n)          = 0
        CSA_End_K_Index(n)          = 0
      enddo
c
c======================== Probing Tool End =============================
c
      end

      subroutine bndprep(begtim,begdate,endtim,enddate)
      use filunit
      use grid
      use chmstry
      use bndary
c 
c----CAMx v7.40 260801
c 
c     BNDPREP reads the boundary conditions file header and sets
c     mapping variables to allow for irregular coarse grid boundaries.
c     It also prepares mapping variables that map the BC species list
c     to the internal CAMx species list
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c        1/20/99   Grid cell size from file should be meters for all cartesian
c                  projections (UTM, LCP, PSP)
c        10/24/01  Removed BSWAP and converted integer strings to character*4
c        10/31/01  Revised diagnostic checks on ibeg and jbeg for irregular
c                  boundaries
c        11/06/01  Input dates are now Julian
c 
c     Input arguments: 
c        begtim              model start time (HHMM)
c        begdate             model start date (YYJJJ)
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        STARTUP 
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      integer begdate
      integer enddate
c
      character*10 bcfil, infil, bcspc
      character*4  ifile(10), note(60)
c
      character*4 bcspec(10,MXSPEC)
      integer     indx(MXCELLS,MXCELLS)
c
      integer isoa
c
      data bcfil /'BOUNDARY  '/
c
c-----Entry point
c
c-----Read 1st BC header record and check inputs
c
      rewind(ibc)
      read(ibc) ifile,note,nseg,nbcspc,idat1,tim1,idat2,tim2
c
c----check for array overflow ---
c
      if( nbcspc .GT. MXSPEC ) then
         write(iout,'(//,A)') 'ERROR in BNDPREP:'
         write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter: MXSPEC'
         write(iout,*) 'It should be set to a value of at least: ',nbcspc
         call flush(iout)
         call camxerr()
      endif
c
      if(INT(tim2) .EQ. 24) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      write(infil,'(10a1)') (ifile(n),n=1,10)
      if (infil.ne.bcfil) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 1:'
        write(iout,*)'BC input file is not labelled BOUNDARY'
        call camxerr()
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if (idat1.gt.begdate) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 2:'
        write(iout,*)'BC start date > simulation start date'
        write(iout,*)'  BC file: ',idat1
        write(iout,*)'Sim start: ',begdate
        call camxerr()
      elseif (idat1.eq.begdate .and. tim1.gt.begtim) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 3:'
        write(iout,*)'BC start time > simulation start time'
        write(iout,*)'  BC file: ',tim1
        write(iout,*)'Sim start: ',begtim
        call camxerr()
      elseif (idat2.lt.enddate) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 4:'
        write(iout,*)'BC end date < simulation end date'
        write(iout,*)'BC file: ',idat2
        write(iout,*)'Sim end: ',enddate
        call camxerr()
      elseif (idat2.eq.enddate .and. tim2.lt.endtim) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 5:'
        write(iout,*)'BC end time < simulation end time'
        write(iout,*)'BC file: ',tim2
        write(iout,*)'Sim end: ',endtim
        call camxerr()
      endif
c
c-----Read 2nd BC header record and check inputs
c
      read(ibc) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if (.NOT.llatlon) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if (abs(dx-delx).gt.0.001 .or. abs(dy-dely).gt.0.001) then
        write(iout,'(//,a)') 'WARNING in BNDPREP:'
        write(iout,*)'BC cell size not equal to model cell size'
        write(iout,'(a,2f10.4)')'  BC file: ',dx,dy
        write(iout,'(a,2f10.4)')'    model: ',delx,dely
        write(iout,*)
      elseif (nx.ne.ncol(1) .or. ny.ne.nrow(1) .or. nz.ne.nlay(1)) then
        write(iout,'(//,a)') 'ERROR in BNDPREP 6:'
        write(iout,*)'BC grid size not equal to model grid size'
        write(iout,*)'BC file: ',nx,ny,nz
        write(iout,*)'  model: ',ncol(1),nrow(1),nlay(1)
        write(iout,*)
        call camxerr()
      endif 
c
c-----Read 3rd & 4th BC header 
c
      read(ibc)
      read(ibc) ((bcspec(n,l),n=1,10),l=1,nbcspc)
c
c-----Map BC species to model species
c
      do 20 l = 1,nspec
        lbcmap(l) = 0
        do 15 lbc = 1,nbcspc
          write(bcspc,'(10a1)') (bcspec(n,lbc),n=1,10)
          if (bcspc.eq.'HNO2      ') bcspc = 'HONO      '
          if (bcspc.eq.'HCHO      ' .and. kHCHO.eq.nspec+1)
     &                                        bcspc = 'FORM      '
          do isoa=1,NUM_SOAP_SPECIES
             if( bcspc .EQ. soap2_spec_names(isoa) ) 
     &                           bcspc = soap3_spec_names(isoa)
          enddo
c
c   --- update names for SOAP3 ---
c
          do isoa=1,NUM_SOAP_SPECIES
            if( bcspc .EQ. soap2_spec_names(isoa) ) 
     &                     bcspc = soap3_spec_names(isoa)                     
          enddo
          if (bcspc.eq.spname(l) ) then
            lbcmap(l) = lbc
            write(idiag,'(2(a,i5,2x,a))')'Boundary species ',lbc,bcspc,
     &                   ' mapped to model species ',l,spname(l)
            goto 20
          endif
 15     continue
        write(idiag,*)'Did not find species: ',spname(l),' on BC file'
 20   continue
c
c-----Read time invariant data (assume nseg=1)
c     assign coarse grid starting/ending indices for each row/column
c
      do 25 nedge = 1,4
        read(ibc) isegm,iedge,ncells,((indx(n,i),n=1,4),i=1,ncells)
        do 30 i = 1,ncells
          if (nedge.eq.1) then 
            if (indx(1,i).eq.0) then
              ibeg(i) = -999
            else
              ibeg(i) = indx(1,i)
            endif
          elseif (nedge.eq.2) then
            if (indx(1,i).eq.0) then
              iend(i) = -999
            else
              iend(i) = indx(1,i)
            endif
          elseif (nedge.eq.3) then
            if (indx(1,i).eq.0) then
              jbeg(i) = -999
            else
              jbeg(i) = indx(1,i)
            endif
          else
            if (indx(1,i).eq.0) then
              jend(i) = -999
            else
              jend(i) = indx(1,i)
            endif
          endif 
  30    continue
  25  continue
c
c-----Ensure at the very least that rows 1 & ny, and columns 1 & nx
c     are boundary cells
c
      ibeg(1) = -999
      iend(1) = -999
      ibeg(nrow(1)) = -999
      iend(nrow(1)) = -999
      jbeg(1) = -999
      jend(1) = -999
      jbeg(ncol(1)) = -999
      jend(ncol(1)) = -999
      do i = 2,ncol(1)-1
        if (jbeg(i) .NE. 2 ) then
          write(iout,'(//,A)') 'ERROR in BNDPREP 7:'
          write(iout,*) 'ERROR: First computational cell in col',i,
     &                                                  ' is',jbeg(i)
          write(iout,*) 'This does not define a rectangular grid.'
          write(iout,*) 'The CAMx boundary must be the edge cells.'
          call camxerr()
        endif
        if (jend(i) .NE. nrow(1)-1 ) then
          write(iout,'(//,A)') 'ERROR in BNDPREP 8:'
          write(iout,*)'ERROR:  Last computational cell in col',i,
     &                                                   ' is',jend(i)
          write(iout,*) 'This does not define a rectangular grid.'
          write(iout,*) 'The CAMx boundary must be the edge cells.'
          call camxerr()
        endif
      enddo
      do j = 2,nrow(1)-1
        if (ibeg(j) .NE. 2) then
          write(iout,'(//,A)') 'ERROR in BNDPREP 10:'
          write(iout,*)'ERROR: First computational cell in row',j,
     &                                                   ' is',ibeg(j)
          write(iout,*) 'This does not define a rectangular grid.'
          write(iout,*) 'The CAMx boundary must be the edge cells.'
          call camxerr()
        endif
        if (iend(j) .NE. ncol(1)-1 ) then
          write(iout,'(//,A)') 'ERROR in BNDPREP 11:'
          write(idiag,*)'ERORR:  Last computational cell in row',j,
     &                                                  ' is',ibeg(j)
          write(iout,*) 'This does not define a rectangular grid.'
          write(iout,*) 'The CAMx boundary must be the edge cells.'
          call camxerr()
        endif
      enddo
c
c-----Echo coarse grid boundary definition, and check that if nested grids
c     are specified, their boundaries are not outside the coarse
c     grid region
c
      do 50 j = 1,nrow(1)
        do 40 n = 2,ngrid
          if (j.lt.jnst1(n) .or. j.gt.jnst2(n)) goto 40
          if (ibeg(j).eq.-999 .or. inst1(n).lt.ibeg(j) .or.
     &        inst2(n).gt.iend(j)) then
            write(iout,'(//,a)') 'ERROR in BNDPREP 12:'
            write(iout,*)'Nested grid extends into coarse grid',
     &                   ' boundary region -- Nest = ',n
            write(iout,*)'j,ibeg,iend,inst1,inst2: ',
     &                    j,ibeg(j),iend(j),inst1(n),inst2(n)
            call camxerr()
          endif
 40     continue
 50   continue
      do 70 i = 1,ncol(1)
        do 60 n = 2,ngrid
          if (i.lt.inst1(n) .or. i.gt.inst2(n)) goto 60
          if (jbeg(i).eq.-999 .or. jnst1(n).lt.jbeg(i) .or.
     &        jnst2(n).gt.jend(i)) then
            write(iout,'(//,a)') 'ERROR in BNDPREP 13:'
            write(iout,*)'Nested grid extends into coarse grid',
     &                   ' boundary region -- Nest = ',n
            write(iout,*)'i,jbeg,jend,jnst1,jnst2: ',
     &                    i,jbeg(i),jend(i),jnst1(n),jnst2(n)
            call camxerr()
          endif
 60     continue
 70   continue
c 
      return
      end

C=====================================================================
C
C   DDM-PM SUBROUTINES FOR SOAP
C
C   Subroutines included in this file:
C     DDMSOAINI
C     DDMSOAP
C     DDMSOATRV (trivial solutions)
C     DDMSOAAP (absorptive partitioning)
C
C   Dependent upon:
C     tracer.com -> camx.prm  - for MXFDDM, NDDMSP & LDDM
C     ddmsoap.inc
C     soap.inc
C
C   Log:
C     05/20/2005  bkoo - original development
C     06/25/2008  bkoo - revised for CAMx v4.5 SOA module update
C     03/18/2014  bkoo - revised for benzene SOA
C     08/25/2016  bkoo - updated for new SOAP
C     10/09/2018  gy   - updated for aerosol photolysis
C
C=====================================================================

      SUBROUTINE DDMSOAINI (CONVFAC,SDDM,NFAM,NSEN)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmsoap.inc'
      INCLUDE 'soap.inc'

      INTEGER   NFAM, NSEN
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac

      INTEGER   I, J
      logical, save :: lfirsttime = .true.

      if (lfirsttime) then
        lfirsttime = .false.
        if (NSENS.ne.NSOAP) stop'ERROR in DDMSOAINI: NSENS .ne. NSOAP'
      endif

      DO J = 1, NFAM
        SIPA(J) = SDDM(J,jdpAOA0)
        SIPB(J) = SDDM(J,jdpBOA0)
        SPRE(J) = SDDM(J,jdpHOA )/MWHOA
     &          + SDDM(J,jdpAOA0)/MWAOA0
     &          + SDDM(J,jdpBOA0)/MWBOA0  ! [mole]/[p]
        DO I = 1, NSENS
          SINI(I,J) = SDDM(J,jdpACG2 +I-1)*CONVFAC*MWSOAP(I)
     &              + SDDM(J,jdpAOA2+I-1) ! [ug/m3]/[p]
          XMAT(I,J) = 0.0                 ! Initialize the solution matrix
        ENDDO
      ENDDO

      IPAR = 1

      RETURN
      END
C     END OF SUBROUTINE DDMSOAINI


      SUBROUTINE DDMSOAP (DT,AJNO2,CONVFAC,SDDM,NFAM,NSEN,IERR,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmsoap.inc'
      INCLUDE 'soap.inc'

      INTEGER   NFAM, NSEN
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac
      REAL      DT                        ! Time step [hours]
      REAL      AJNO2                     ! Accumulated NO2 photolysis rate ([1/hr]*[hr])
      INTEGER   IERR, IOUT

      REAL      XGAS(NSENS,MXFDDM)        ! Solution matrix for gases
      REAL      FPOLYA, FPOLYB, SPOLY, FPHOTR
      INTEGER   I, J
C
C     Initialize error flag
C
      IERR = 1
C
C     Check error from the previous routines
C
      IF ( IPAR.LT.0 ) THEN
        IERR = IPAR
        RETURN
      ENDIF
C
C     Calculate the sensitivities of gas species
C
      DO J = 1, NDDMSP
        DO I = 1, NSENS
          XGAS(I,J) = SINI(I,J) - XMAT(I,J)
        ENDDO
      ENDDO
C
C     Calculate changes due to aerosol photolysis followed by polymerization
C
      FPHOTR = EXP( -SFACJSOA * AJNO2 )   ! Fraction of remaining SOA after photolysis
      FPOLYA = 1.0 - EXP( -KPOLYA * DT )  ! polymerized fraction for anthro SOA
      FPOLYB = 1.0 - EXP( -KPOLYB * DT )  ! polymerized fraction for bio SOA
      DO J = 1, NDDMSP
        SIPA(J) = FPHOTR * SIPA(J)
        SIPB(J) = FPHOTR * SIPB(J)
        DO I = 1, NSOAA
          XMAT(I,J) = FPHOTR * XMAT(I,J)
          SPOLY = FPOLYA * XMAT(I,J)
          XMAT(I,J) = XMAT(I,J) - SPOLY
          SIPA(J) = SIPA(J) + SPOLY
        ENDDO
        DO I = NSOAA+1, NSENS
          XMAT(I,J) = FPHOTR * XMAT(I,J)
          SPOLY = FPOLYB * XMAT(I,J)
          XMAT(I,J) = XMAT(I,J) - SPOLY
          SIPB(J) = SIPB(J) + SPOLY
        ENDDO
      ENDDO
C
C     Assign the solution
C
      DO J = 1, NFAM
        DO I = 1, NSENS
          SDDM(J,jdpACG2 +I-1) = XGAS(I,J)/MWSOAP(I)/CONVFAC
          SDDM(J,jdpAOA2+I-1) = XMAT(I,J)
        ENDDO
        SDDM(J,jdpAOA0) = SIPA(J)
        SDDM(J,jdpBOA0) = SIPB(J)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMSOAP


      SUBROUTINE DDMSOATRV (CTOT,CSAT,CPRE,MSOA,CAER,IDX,ICASE,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmsoap.inc'

      REAL      CTOT
      REAL      CSAT
      REAL      CPRE          ! Only for CASE 3 (pre-existing OA in mole)
      REAL      MSOA          ! Only for CASE 3 (MW_soa)
      REAL      CAER          ! Only for CASE 3
      INTEGER   IDX           ! Index in the base set of SOA species
      INTEGER   ICASE         ! Case ID: must be 1, 2, or 3
      INTEGER   IOUT          ! Unit number of log file

      REAL      C1, C2, C3
      INTEGER   J
C     
C     Initial check
C     
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used

      GOTO (100, 200, 300) ICASE
      WRITE(IOUT,'(//,A)') 'ERROR in DDMSOATRV:'
      WRITE(IOUT,'(A,I5)')  ' Invalid ICASE - ',ICASE
      IPAR = -1
      RETURN
C
C     CASE 1: non-solution-forming case OR pure component w/o pre-existing OA
C
100   CONTINUE
      IF (CTOT.LE.CSAT) GOTO 200
      DO J = 1, NDDMSP
        XMAT(IDX,J) = SINI(IDX,J)
      ENDDO
      RETURN
C
C     CASE 2: insignificant total concentration OR below threshold for partitioning
C
200   CONTINUE
      DO J = 1, NDDMSP
        XMAT(IDX,J) = 0.0
      ENDDO
      RETURN
C
C     CASE 3: analytical solution of a trivial case
C
300   CONTINUE
      C1 = CAER + MSOA * CPRE
      C2 = CTOT - CAER
      C3 = C1 + CSAT - C2
      IF (C3.EQ.0.0) THEN
        WRITE(IOUT,'(//,A)') 'ERROR in DDMSOATRV:'
        WRITE(IOUT,'(A)')    ' Zero denominator!'
        IPAR = -1
        RETURN
      ENDIF
      DO J = 1, NDDMSP
        XMAT(IDX,J) = ( C1*SINI(IDX,J) + MSOA*C2*SPRE(J) ) / C3
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMSOATRV


      SUBROUTINE DDMSOAAP (CTOT,CSAT,MSOA,TOM,NSOL,IDX,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmsoap.inc'

      REAL      CTOT(NSENS)
      REAL      CSAT(NSENS)
      REAL      MSOA(NSENS)
      REAL      TOM           ! Total Organic Matter (moles)
      INTEGER   NSOL, IDX(NSENS)
      INTEGER   IOUT          ! Unit number of log file

      REAL      DENOM, DTOM
      REAL      SUM1, SUM2, T1(NSENS), T2(NSENS)
      INTEGER   I, J
C     
C     Initial check
C     
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used
C
C     Calculate the sensitivity of TOM
C
      DO J = 1, NDDMSP
        SUM1 = 0.0
        SUM2 = 0.0
        DO I = 1, NSOL
          DENOM = MSOA(I)*TOM + CSAT(I)
          T1(I) = SINI(IDX(I),J) * TOM / DENOM
          T2(I) = CTOT(I)*CSAT(I) / (DENOM*DENOM)
          SUM1  = SUM1 + T1(I)
          SUM2  = SUM2 + T2(I)
        ENDDO
        IF (SUM2.EQ.1.0) THEN
          WRITE(IOUT,'(//,A)') 'ERROR in DDMSOAAP:'
          WRITE(IOUT,'(A)')    ' Zero denominator!'
          IPAR = -1
          RETURN
        ENDIF
        DTOM = (SUM1 + SPRE(J)) / (1. - SUM2)
        DO I = 1, NSOL
          XMAT(IDX(I),J) = (T1(I) + T2(I)*DTOM) * MSOA(I)
        ENDDO
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMSOAAP

c**** NCF_WRT_VARS_BASE
c
      subroutine ncf_wrt_vars_base(action,iounit)
      use filunit
      use grid
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine writes the variable definitions and descriptions to 
c    the NetCDF file
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c           action  C  name of file to open
c           iounit  I  NetCDF file ID of file
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c     03/15/21   --gwilson--    Changed TOPO to float from double
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'netcdf.inc'
      include 'ncf_iodat.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      character*(*) action
      integer       iounit
      integer       nspcs
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ierr, grid_dimid(2), z_dimid(4), time_dimid(3), this_varid
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      grid_dimid(1) = ncf_col_dimid
      grid_dimid(2) = ncf_row_dimid
c
      z_dimid(1) = ncf_col_dimid
      z_dimid(2) = ncf_row_dimid
      z_dimid(3) = ncf_lay_dimid
      z_dimid(4) = ncf_tstep_dimid
c
      time_dimid(1) = ncf_date_time_dimid
      time_dimid(2) = ncf_var_dimid
      time_dimid(3) = ncf_tstep_dimid
c
      ierr = nf_def_var(iounit, "X", NF_DOUBLE, 1, 
     &                                      ncf_col_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                                    istrln(ncf_x_units),ncf_x_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                              istrln(ncf_x_long_name),ncf_x_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                                istrln(ncf_x_var_desc),ncf_x_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "Y", NF_DOUBLE, 1, 
     &                                      ncf_row_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                                    istrln(ncf_y_units),ncf_y_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                            istrln(ncf_y_long_name),ncf_y_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                             istrln(ncf_y_var_desc),ncf_y_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "layer", NF_INT, 1, 
     &                                ncf_lay_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                           istrln(ncf_layer_units),ncf_layer_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                   istrln(ncf_layer_long_name),ncf_layer_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                     istrln(ncf_layer_var_desc),ncf_layer_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "TFLAG", NF_INT, 3, 
     &                                  time_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                          istrln(ncf_tflag_units),ncf_tflag_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                  istrln(ncf_tflag_long_name),ncf_tflag_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                     istrln(ncf_tflag_var_desc),ncf_tflag_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000

      ierr = nf_def_var(iounit, "ETFLAG", NF_INT, 3, 
     &                                 time_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                        istrln(ncf_etflag_units),ncf_etflag_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                istrln(ncf_etflag_long_name),ncf_etflag_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                  istrln(ncf_etflag_var_desc),ncf_etflag_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "longitude", NF_DOUBLE, 2, 
     &                              grid_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                  istrln(ncf_longitude_units),ncf_longitude_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &          istrln(ncf_longitude_long_name),ncf_longitude_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &             istrln(ncf_longitude_var_desc),ncf_longitude_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'coordinates',
     &        istrln(ncf_longitude_coordinates),ncf_longitude_coordinates)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "latitude", NF_DOUBLE, 2, 
     &                                grid_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                   istrln(ncf_latitude_units),ncf_latitude_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &          istrln(ncf_latitude_long_name),ncf_latitude_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &             istrln(ncf_latitude_var_desc),ncf_latitude_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'coordinates',
     &       istrln(ncf_latitude_coordinates),ncf_latitude_coordinates)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "topo", NF_FLOAT, 2, 
     &                                grid_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                   istrln(ncf_topo_units),ncf_topo_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &          istrln(ncf_topo_long_name),ncf_topo_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &             istrln(ncf_topo_var_desc),ncf_topo_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'coordinates',
     &       istrln(ncf_topo_coordinates),ncf_topo_coordinates)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      ierr = nf_def_var(iounit, "z", NF_FLOAT, 4, 
     &                                         z_dimid, this_varid)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'units',
     &                                 istrln(ncf_z_units),ncf_z_units)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'long_name',
     &                        istrln(ncf_z_long_name),ncf_z_long_name)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'var_desc',
     &                           istrln(ncf_z_var_desc),ncf_z_var_desc)
      if( ierr .NE. NF_NOERR ) goto 7000
      ierr = nf_put_att_text(iounit,this_varid,'coordinates',
     &                     istrln(ncf_z_coordinates),ncf_z_coordinates)
      if( ierr .NE. NF_NOERR ) goto 7000
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_WRT_VARS_BASE:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot create file variable for grid variables.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

C***** RDARGRP
c
      subroutine rdargrp(igrid,ndate,ttime,nox,noy,nlay_ems,
     &                                          numcls,igroup,emscls)
      use filunit
      use grid
      use bndary
      use camxcom
      use tracer
      implicit none
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c      10/24/01  Removed BSWAP and converted integer strings to character*4
c      05/01/03  Time span of emissions must now match emiss update interval
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      integer ndate
      real    ttime
      integer nox
      integer noy
      integer nlay_ems
      integer numcls
      integer igroup
      real    emscls(soap3_ntrcls,nox,noy,nlay_ems)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*10  this_species
      character*4   iname(10)
      integer       ispc, num_emsfiles, idxfile, itmp, jtmp, isoa
      integer       ibgdat, iendat, iounit, idx, iseg, i, j
      integer       ichkems, ichktm1, ichktm2, icls, buffer_offset
      real          bgtim, edtim
      logical       lfound, use_this_file, use_this_species
c
      real,allocatable, dimension(:,:) :: emsgrd
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- initalize the array ---
c
      emscls = 0.
c
c   --- allocate loacal array ---
c
      allocate( emsgrd(nox,noy) )
c
c   --- skip if filename not supplied ---
c
      if( .NOT. larsrc ) goto 9999
      num_emsfiles = num_iortem(igrid,igroup)
      if( igroup .EQ. 0 ) num_emsfiles = nemiss_files(igrid)
c
c   --- loop over all files ---
c
      do 10 idxfile=1,num_emsfiles
        use_this_file = .TRUE.
c
c   --- set the unit number for surface emissions file ---
c
        if( igroup .EQ. 0 ) then
            iounit = iarem(igrid,idxfile)
            buffer_offset = buffer_offset_iarem(igrid,idxfile)
            if( is_netcdf_iarem(igrid,idxfile) ) then
                use_this_file = .FALSE.
            else
                write(fname,'(A,I3)') 'EMISSIONS -- UNIT ',iarem(igrid,idxfile)
c
c    --- if emissions is regular model emissions file, backup one hour ---
c
                do i=1,nspcem(igrid,igroup,idxfile)
                    backspace(iounit)
                enddo
                backspace(iounit)
            endif
        else
            iounit = iortem(igrid,igroup,idxfile)
            fname = temfil(igrid,igroup,idxfile)
            if( is_netcdf_iortem(igrid,igroup,idxfile) ) use_this_file = .FALSE.
            buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
        endif
        if( .NOT. use_this_file ) cycle
c
c   --- read the date and time, again ---
c
        lfound = .FALSE.
  111   continue
        read(iounit) ibgdat, bgtim, iendat, edtim
        if(NINT(edtim) .EQ. 0) then
           edtim = 24.
           iendat = ibgdat
        endif
        ichktm1 = NINT( 1000*(bgtim) )
        if( le1day ) then
           ichktm2 = NINT( 1000*(edtim) )
         else
           ichktm2 = NINT( 1000*(edtim)+24000*(iendat-ibgdat) )
        endif
        if( NINT(edtim) .EQ. 0 ) ichktm2 = 24000
        ichkems = NINT( 1000*(dtems/60.) )
        if( (ichktm2 - ichktm1) .NE. ichkems ) then
           write(iout,'(//,a)')'ERROR in RDARGRP:'
           write(iout,*) 'Time interval in surface emissions file does'
           write(iout,*)  ' not match emissions update time interval.'
           write(iout,*) '   Beginning Date/Time (Hour): ',ibgdat,bgtim
           write(iout,*) '   Ending Date/Time    (Hour): ',iendat,edtim
           write(iout,*) '   Emiss Input interval(Hour): ',dtems/60.
           call camxerr()
        endif
        bgtim = 100.*aint(bgtim) + 60.*amod(bgtim,1.)
        edtim = 100.*aint(edtim) + 60.*amod(edtim,1.)
c
c   --- read the emissions for this hour ---
c
        do 20 ispc=1,nspcem(igrid,igroup,idxfile)
            emsgrd = 0.
            read(iounit,ERR=7000) iseg, (iname(i),i=1,10), 
     &                         ((emsgrd(i,j),i=1+buffer_offset,nox-buffer_offset),
     &                                            j=1+buffer_offset,noy-buffer_offset)
            write(this_species,'(10A1)') iname
c
c   --- if date and time does not match this hour, skip this record ---
c
            if( le1day ) then
                if( bgtim .NE. ttime ) goto 10
            else
                if( ndate .NE. ibgdat .OR. bgtim .NE. ttime ) goto 10
            endif
            lfound  = .TRUE.
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
            idx = idxems(igrid,igroup,idxfile,ispc)
            if( idx .LE. 0 ) goto 20
            use_this_species = lusespc(idx)
            if( luse_soap3 .and. lsoa ) then
                if( this_species(1:4) .EQ. 'POA ' ) 
     &                     this_species = soap_emiss_names(IDX_SOAP_POA_AV)
                if( this_species(1:4) .EQ. 'POA_') use_this_species = .TRUE.
            endif
            if( .NOT. use_this_species ) goto 20
c
c   --- load the species into the cells in tracer array ----
c
            if( luse_soap3 .AND. lsoa ) then
               icls = ntrcls
               do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                  icls = icls + 1
                  if( this_species .EQ. soap_emiss_names(isoa) ) then
                     do j=1+buffer_offset,noy-buffer_offset
                        jtmp = j-buffer_offset
                        do i=1+buffer_offset,nox-buffer_offset
                           itmp = i-buffer_offset
                           emscls(icls,i,j,1) = emscls(icls,i,j,1) +
     &                               (emsgrd(itmp,jtmp)/(60.*dtems))
                        enddo
                     enddo
                  endif
               enddo
            endif
            do j=1+buffer_offset,noy-buffer_offset
               jtmp = j-buffer_offset
               do i=1+buffer_offset,nox-buffer_offset
                  do icls=1,ntrcls
                     itmp = i-buffer_offset
                     emscls(icls,i,j,1) = emscls(icls,i,j,1) +
     &                      (emsgrd(itmp,jtmp)/(60.*dtems)) * trspmap(idx,icls)
                  enddo
               enddo
            enddo
c
c   --- next species ---
c
  20    continue
c
c   --- if the correct hour has not been found, 
c       go back and read some more else read next file ---
c
        if( .NOT. lfound ) then
           goto 111
        else
           if( idxfile .LT. num_emsfiles ) then
              goto 10
           else
              goto 9999
           endif
        endif
c
c   --- if using 1 day emissions, we need to rewind the file to
c       get the current hour ---
c
  222   continue
        if( le1day ) then
            rewind(iounit)
            read(iounit)
            read(iounit)
            read(iounit)
            read(iounit)
            goto 111
        else
           goto 7001
        endif
c
c  --- next file in grid/group ---
c
      deallocate( emsgrd )
 10   continue
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDARGRP:'
      write(iout,'(/,1X,2A,I8.5,F8.1,2A)') 'Reading emissions ',
     &   'after hour ',ibgdat, bgtim,' in file: ',fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDARGRP:'
      write(iout,'(/,1X,2A,I8.5,F4.1,2A)') 'Premature end-of-file',
     &              ' in emissions file after hour ',ibgdat, bgtim,
     &              ' in file: ',fname(:istrln(fname))
      call camxerr()
c
 9999 continue
c
      return
      end

      subroutine emistrns(igrd,chtime,chdate,
     &                               numprocs,iproc_id,lupdtdep)
      use filunit
      use grid
      use grid_nodes
      use chmstry
      use bndary
      use o3colmap
      use camxfld
      use camxcom
      use pigsty
      use ptemiss
      use procan
      use rtracchm
      use rtcmcchm
      use tracer
c
      use master_mod
      use node_mod 

      implicit none
c
c----CAMx v7.40 260801
c
c     EMISTRNS performs the following tasks for one grid:
c        1.  Injects new PiG puffs and moves all puffs
c        2.  Determines mass-conserving vertical velocity parameters
c        3.  Updates concentrations due to emissions
c        4.  Performs 3-D transport
c        5.  Performs wet scavenging 
c        6.  Updates met fields to current time step
c        7.  Performs 3-D diffusion
c
c      Copyright Ramboll
c            
c     Modifications:  
c        01/30/02   Added code for RTRAC probing tool
c        10/12/04   Water vapor and vertical diffusivity fields are now
c                   time-interpolated
c        10/12/04   PIGINIT and PIGWALK moved into this routine, and
c                   IRONDRIV+GRESDRIV moved out to NESTING and CAMx
c        05/07/07   Added calls to subroutines to update Probing Tools
c                   boundary conditions after met is updated
c       03/15/09    Added code for deposition output for tracers
c       07/16/07 -bkoo-     Added check for HDDM
c       07/16/08 -bkoo-     Added DDM turn-off flag
c       10/29/09 -cemery-   Added code for RTRAC surface mass
c       11/04/09    Revised vertical advection solver technique, now
c                   employs zero-gradient top boundary condition
c       04/02/12    Removed drought stress and snow flag; AHO
c                   file is now just ozone column
c       04/30/13    Added surface model emissions, deposition
c       04/07/14    Added top con file
c       08/11/14    Albedo now includes effects of snow
c       10/09/14    Added subgrid convective model
c       12/18/15    Added oceanic I2/HOI emissions from O3 dep
c       07/23/18    Added emiss flux of Bi-Di NH3 drydep (eflxnh3)
c       07/10/19    Added stratospheric O3 adjustment
c       11/17/20    RTCMC dry/wet deposition is now consistent with RTRAC
c       08/26/21    RTRAC surface file doubles as (default) dep output
c                   or (flagged) surface model output
c
c     Input arguments:
c        igrd                grid index
c        chtime              simulation time ('HH:MM:SS')
c        chdate              simulation date ('YY/MM/DD')
c
c     Output arguments:
c        none
c
c     Routines called:
c        PIGINIT
c        PIGWALK
c        ZRATES
c        EMISS
c        XYADVEC
c        ZADVEC
c        WETDEP
c        UPDTMET
c        DIFFUS
c
c     Called by:
c        CAMx
c        NESTING
c
      include 'camx.prm'
      include 'flags.inc'
      include 'deposit.inc'
      include 'mpif.h'
      include 'rtracsrf.inc'
c
      character*8 chtime, chdate
      integer     igrd, i
      integer     numprocs, iproc_id
      logical lupdtdep
      logical lrdtop
      logical lvupsolv(MXCELLS*MXCELLS*MXLAYER)
      real rhoscl(MXCELLS*MXCELLS)
      integer mxp_rt, myp_rt, nsp_rt
c
      common /com1emistrns/ rhoscl,lvupsolv
c
c======================== Source Apportion Begin =======================
c
      real*8 ardum(MXTRSP)
      real*8 ptdum(MXTRSP)
      real*8 fluxdum(MXTRSP*11)
      real*8 depdum(1)
      real cigdum1(1,1,1,1)
      real cigdum2(1,1,1)
      real adjwest(MXCELLS,MXLAYER)
      real adjeast(MXCELLS,MXLAYER)
      real adjsouth(MXCELLS,MXLAYER)
      real adjnorth(MXCELLS,MXLAYER)
c
      common /com2emistrns/ ptdum, ardum, fluxdum
c
c========================= Source Apportion End ========================
c
c-----Entry point
c
      if( .NOT. lmpi .OR. (iproc_id .eq. 1) ) then
         write(*,'(/,a,i3)')           ' Processing grid: ',igrd
         write(*,'(a,f7.1)')           '    Timestep (s): ',deltat(igrd)
         write(*,'(a,2x,a8,1X,a8,/)')  '  Grid Date/Time: ',
     &                                                     chdate,chtime
         call flush(6)
      endif
      if( .not. LMPI .or. (iproc_id .gt. 0) ) then  !cbwmpi
         write(iout,'(/,a,i3)')          ' Processing grid: ',igrd
         write(iout,'(a,f7.1)')          '        Timestep: ',
     &                                                     deltat(igrd)
         write(iout,'(a,2x,a8,1x,a8,/)') '  Grid Date/Time: ',
     &                                                     chdate,chtime
      endif
c
c-----Initialize new pig puffs
c
      if (ipigflg .NE. 0 .AND. ipigint .EQ. igrd) then
        if( iproc_id .eq. 0 ) then
           write(*,'(a20,$)') 'piginit ......'
           write(iout,'(a20,$)') 'piginit ......'
           call piginit(numprocs,deltat(igrd),nptsrc,nrad,nspec,nemspc,
     &                           ptemis,height,windu,windv,tempk,press)
           write(*,'(a)') '   Done'
           call flush(6)
           write(iout,'(a)') '   Done'
           call flush(iout)
c
c-----Update PiG locations 
c
           write(*,'(a20,$)') 'pigwalk ......'
           write(iout,'(a20,$)') 'pigwalk ......'
           call pigwalk(deltat(igrd))
           write(*,'(a)') '   Done'
           call flush(6)
           write(iout,'(a)') '   Done'
           call flush(iout)
        endif
c
        if( lmpi ) call nodes_met_pig(numprocs,iproc_id)
c       
      endif
c
c-----Inject emissions
c
      if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
        write(*,'(a20,$)') 'emiss ......'
      endif
      if( .NOT. lmpi .OR. (iproc_id .GT. 0) ) then
        write(iout,'(a20,$)') 'emiss ......'
        call emiss(igrd,mxp,myp,mzp,i0,j0,ia,iz,ja,jz,
     &           nspec,nemspc,nlu,3*ndepspc+2,densfac,
     &           lemmap,.FALSE.,
     &           nosrc(igrd),idsrc(1,igrd),isrc(1,igrd),
     &           jsrc(1,igrd),ncol(igrd),nrow(igrd),
     &           nlay(igrd),nlayers_ems,
     &           deltat(igrd),deltax(1,igrd),deltay(igrd),
     &           mapscl(iptr2d(igrd)),
     &           height(iptr3d(igrd)),depth(iptr3d(igrd)),
     &           windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &           tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &           icdocn(iptr2d(igrd)),fsurf(iptrlu(igrd)),
     &           tsurf(iptr2d(igrd)),eflxnh3(iptr2d(igrd)),
     &           aremis(iptrem(igrd)),ptemis,MAX(nptsrc,1),
     &           armass(1,igrd),ptmass(1,igrd),
     &           reemis(iptrsm(igrd)),
     &           conc(iptr4d(igrd)),
     &           depfld(iptrdp(igrd)),ipacl_3d(iptr3d_full(igrd)))
c
c======================== Source Apportion Begin =======================
c
c  --- call routine with tracer species arrays, send dummy
c      arguemnts for the total mass arrays ---
c
        if( ltrace .OR. ((lddm .OR. lhddm) .AND. lddmcalc(igrd)) ) then
           call emiss(igrd,mxp,myp,mzp,i0,j0,ia,iz,ja,jz,
     &              ntotsp,soap3_ntotsp,nlu,1,densfac,lsamap,.TRUE.,
     &              nosrc(igrd),idsrc(1,igrd),isrc(1,igrd),jsrc(1,igrd),
     &              ncol(igrd),nrow(igrd),nlay(igrd),nlayers_ems,deltat(igrd),
     &              deltax(1,igrd),deltay(igrd),mapscl(iptr2d(igrd)),
     &              height(iptr3d(igrd)),
     &              depth(iptr3d(igrd)),windu(iptr3d(igrd)),
     &              windv(iptr3d(igrd)),
     &              tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &              icdocn(iptr2d(igrd)),fsurf(iptrlu(igrd)),
     &              tsurf(iptr2d(igrd)),eflxnh3(iptr2d(igrd)),
     &              saemis(ipsa3d_ems(igrd)),sapnts,MAX(nptsrc,1),
     &              ardum,ptdum,ardum,ptconc(ipsa3d(igrd)),
     &              depdum,ipacl_3d(iptr3d_full(igrd)) )
           if( tectyp .EQ. RTRAC .AND. lsrfmodrt ) then
              call reemisrt(mxp,myp,mzp,i0,j0,ncol(igrd),nrow(igrd),
     &                      nlay(igrd),nrtrac,deltat(igrd),
     &                      tsurf(iptr2d(igrd)),cellat(iptr2d(igrd)),
     &                      cellon(iptr2d(igrd)),fsurf(iptrlu(igrd)),
     &                      height(iptr3d(igrd)),
     &                      press(iptr3d(igrd)),windu(iptr3d(igrd)),
     &                      windv(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &                      snow(iptr2d(igrd)),rtsolmas(ipsa2d(igrd)),
     &                      rtvegmas(ipsa2d(igrd)),ptconc(ipsa3d(igrd)))
           endif
        endif
c
c========================= Source Apportion End ========================
c
        if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
          write(*,'(a)') '   Done'
          call flush(6)
        endif
        write(iout,'(a)') '   Done'
        call flush(iout)
c
c-----Determine mass-conserving vertical velocity parameters
c
        if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
          write(*,'(a20,$)') 'zrates ......'
        endif
        write(iout,'(a20,$)') 'zrates ......'
      endif
      if( iproc_id .gt. 0 ) then
          call node_send_lbc(iproc_id, nspec,igrd)
          if( ltrace .OR. lddm .OR. lhddm )
     &        call node_send_lbc_pt(iproc_id, ntotsp, igrd)
      endif
      if( iproc_id .GT. 0 ) then
          call node_get_lbc(iproc_id, nspec,igrd)
          if( ltrace .OR. lddm .OR. lhddm )
     &         call node_get_lbc_pt(iproc_id, ntotsp, igrd)
      endif
      if( .NOT. lmpi .OR. (iproc_id .GT. 0) ) then
        call zrates(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,igrd,
     &            ncol(igrd),nrow(igrd),nlay(igrd),
     &            nadv(1,igrd),deltat(igrd),deltax(1,igrd),
     &            deltay(igrd),depth(iptr3d(igrd)),
     &            phpt(iptr3d(igrd)),pppt(iptr3d(igrd)),
     &            ptpt(iptr3d(igrd)),windu(iptr3d(igrd)),
     &            windv(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &            press(iptr3d(igrd)),mapscl(iptr2d(igrd)),
     &            dilut(iptr3d(igrd)),entrn(iptr3d(igrd)),
     &            rhoscl,lvupsolv)
      endif
c
      if( .NOT. lmpi .OR. (iproc_id .GT. 0) ) then
          if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
            write(*,'(a)') '   Done'
            call flush(6)
          endif
          write(iout,'(a)') '   Done'
          call flush(iout)
c
c======================= Source Apportion Begin ========================
c
c
c  --- if this is the master grid, update the boundary
c      conditions for the tracer species ---
c
          if( ltrace .AND. .NOT. lsa_iorbc .AND. igrd .EQ. 1 .AND. 
     &                  tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC ) then
             call clrbdysa(1,mmxp(1),mmyp(1),mmzp(1),ntotsp,ptconc(1))
             call filbdysa(1,mmxp(1),mmyp(1),mmzp(1),nspec,ntotsp,
     &                                              conc(1),ptconc(1))
          endif
c
c======================== DDM Begin =======================
c
c-----Optionally make stratospheric O3 adjustment
c
          if (lstrato3 .and. ltopcon) then
            call strato3(mxp,myp,mzp,ia,iz,ja,jz,ibcon,igrd,nspec,
     &                   idfin(iptr2d(igrd)),height(iptr3d(igrd)),
     &                   tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                   conc(iptr4d(igrd)),topo(iptr2d(igrd)),
     &                   ctop(iptrem(igrd)))
          endif
c
c-----Perform 2-D transport
c
          call xyadvec(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &             igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &             nrad,nspec,MAX(1,ntotsp),nadv(1,igrd),
     &             deltat(igrd),deltax(1,igrd),deltay(igrd),
     &             windu(iptr3d(igrd)),
     &             windv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &             mapscl(iptr2d(igrd)),conc(iptr4d(igrd)),
     &             ltopcon,ctop(iptr1lay(igrd)),pttop,
     &             fluxes(1,igrd),ipsa3d(igrd),
     &             ipacl_3d(iptr3d_full(igrd)),iproc_id )
          call flush(6)
          call flush(iout)
c
c======================== Source Apportion Begin =======================
c
c  --- call routine to load the top concentration for tracers ---
c
          if( ltrace .AND. 
     &              tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC ) then
              if( .NOT. lsa_iortc ) call filptopsa(igrd,mxp,myp,
     &                     nspec,ntotsp,ctop(iptr1lay(igrd)),pttop)
          endif
c
c======================== Source Apportion End =======================
c
c
c-----Perform vertical transport
c
          call zadvec(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &             1,igrd,ncol(igrd),nrow(igrd),
     &             nlay(igrd),nrad,ngas,nspec,MAX(1,ntotsp),deltat(igrd),
     &             deltax(1,igrd),deltay(igrd),
     &             idfin(iptr2d(igrd)),depth(iptr3d(igrd)),
     &             entrn(iptr3d(igrd)),dilut(iptr3d(igrd)),
     &             tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &             spname,conc(iptr4d(igrd)),ltopcon,rhoscl,
     &             ctop(iptr1lay(igrd)),lvupsolv,pttop,fluxes(1,igrd),
     &             fluxtmp,ipsa3d(igrd),ipacl_2d(iptr2d_full(igrd)),
     &             ipacl_3d(iptr3d_full(igrd)),iproc_id )
          call flush(6)
          call flush(iout)
c
c======================== Source Apportion Begin =======================
c
          if( ltrace ) then
c
             if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                 call xyadvec(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,igrd,
     &                ncol(igrd),nrow(igrd),nlay(igrd),
     &                0,ntotsp,ntotsp,nadv(1,igrd),deltat(igrd),
     &                deltax(1,igrd),deltay(igrd),windu(iptr3d(igrd)),
     &                windv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &                mapscl(iptr2d(igrd)),ptconc(ipsa3d(igrd)),
     &                .FALSE.,pttop,pttop,fluxdum,ipsa3d(igrd),
     &                ipacl_3d(iptr3d_full(igrd)),iproc_id )
c
c  --- call routine with tracer species arrays, send dummy
c      arguments for the total mass arrays ---
c
                 call zadvec(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &                2,igrd,ncol(igrd),nrow(igrd),
     &                nlay(igrd),0,nrtgas,ntotsp,1,deltat(igrd),deltax(1,igrd),
     &                deltay(igrd),idfin(iptr2d(igrd)),
     &                depth(iptr3d(igrd)),entrn(iptr3d(igrd)),
     &                dilut(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &                press(iptr3d(igrd)),ptname,ptconc(ipsa3d(igrd)),
     &                .FALSE.,rhoscl,pttop,lvupsolv,pttop,fluxdum,fluxtmp,
     &                ipsa3d(igrd),ipacl_2d(iptr2d_full(igrd)),
     &                ipacl_3d(iptr3d_full(igrd)),iproc_id )
             else
                 lrdtop = .FALSE.
                 if (lsa_iortc .OR. ltopcon) lrdtop = .TRUE. 
                 call zadvec(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &                3,igrd,ncol(igrd),nrow(igrd),
     &                nlay(igrd),0,0,ntotsp,1,deltat(igrd),
     &                deltax(1,igrd),deltay(igrd),
     &                idfin(iptr2d(igrd)),depth(iptr3d(igrd)),
     &                entrn(iptr3d(igrd)),dilut(iptr3d(igrd)),
     &                tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                ptname,ptconc(ipsa3d(igrd)),lrdtop,rhoscl,
     &                pttop,lvupsolv,pttop,fluxdum,fluxtmp,
     &                ipsa3d(igrd),ipacl_2d(iptr2d_full(igrd)),
     &                ipacl_3d(iptr3d_full(igrd)),iproc_id )
c
c   --- call routine to recalibrate the tracers ----
c
                 call caliball(mxp,myp,mzp,nspec,ntotsp,
     &                conc(iptr4d(igrd)),ptconc(ipsa3d(igrd)))
c
             endif
c
c----- call routine to advect the timing tracers horizontally ---
c
             if( npttim .GT. 0 ) call timadv(iproc_id,mxp,myp,mzp,j0,
     &             igrd,nrow(igrd),ntotsp,
     &             deltat(igrd),deltax(1,igrd),deltay(igrd),
     &             windu(iptr3d(igrd)),
     &             windv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &             mapscl(iptr2d(igrd)),ptconc(ipsa3d(igrd)))
          endif
      endif
c
c========================= Source Apportion End ========================
c
c-----Update vertical grid and environmental fields for this timestep
c
      if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
         write(*,'(a20,$)') 'updtmet ......'
      endif
      write(iout,'(a20,$)') 'updtmet ......'
      call updtmet(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &             igrd,ncol(igrd),nrow(igrd),nlay(igrd),
     &             nspec,ngas,ntotsp,densfac,deltat(igrd),
     &             phpt(iptr3d(igrd)),height(iptr3d(igrd)),
     &             depth(iptr3d(igrd)),pppt(iptr3d(igrd)),
     &             press(iptr3d(igrd)),pupt(iptr3d(igrd)),
     &             windu(iptr3d(igrd)),pvpt(iptr3d(igrd)),
     &             windv(iptr3d(igrd)),pspt(iptr2d(igrd)),
     &             tsurf(iptr2d(igrd)),
     &             ptpt(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &             pwpt(iptr3d(igrd)),water(iptr3d(igrd)),
     &             pkpt(iptr3d(igrd)),rkv(iptr3d(igrd)),
     &             conc(iptr4d(igrd)),ptconc(ipsa3d(igrd)),
     &             adjwest,adjeast,adjsouth,adjnorth)
      if( ldry .OR. lacm2 .OR. ipigflg .NE. 0 ) then
        call srfruf(mxp,myp,mzp,ncol(igrd),nrow(igrd),nlay(igrd),
     &            datec(igrd),cellat(iptr2d(igrd)),cellon(iptr2d(igrd)),
     &            windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &            fsurf(iptrlu(igrd)),snow(iptr2d(igrd)),
     &            lrdlai(igrd),lai(iptr2d(igrd)),sfcz0(iptr2d(igrd)))
      endif
      if( .NOT. lmpi .OR. (iproc_id .EQ. 1) ) then
         write(*,'(a)') '   Done'
      endif
      write(iout,'(a)') '   Done'
      call flush(6)
      call flush(iout)
c
c-----Calculate dry deposition rates
c
      if( .NOT. lmpi .OR. (iproc_id .GT. 0) ) then
          if (ldry) then
           if( lupdtdep ) then
            lupdtdep = .FALSE.
            if( .NOT. lmpi .OR. iproc_id .EQ. 1 ) then
               write(*,'(a20,$)') 'drydep ......'
            endif
            write(iout,'(a20,$)') 'drydep ......'
            call drydep(mxp,myp,mzp,
     &              itzon,tsurf(iptr2d(igrd)),cellat(iptr2d(igrd)),
     &              cellon(iptr2d(igrd)),lrdlai(igrd),lai(iptr2d(igrd)),
     &              pwr(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &              height(iptr3d(igrd)),press(iptr3d(igrd)),
     &              windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &              cod(iptr3d(igrd)),
     &              water(iptr3d(igrd)),fsurf(iptrlu(igrd)),
     &              tempk(iptr3d(igrd)),snow(iptr2d(igrd)),
     &              icdocn(iptr2d(igrd)),conc(iptr4d(igrd)),
     &              vdep(iptr1lay(igrd)),eflxnh3(iptr2d(igrd)))
            call depsmry(igrd,mxp,myp,nspec,vdep(iptr1lay(igrd)) )
c
c======================== Source Apportion Begin =======================
c
            if( ltrace .AND. (tectyp.EQ.RTRAC .OR. tectyp.EQ.RTCMC)) then
               call drydeprt(mxp,myp,mzp,nrtrac,itzon,
     &                  tsurf(iptr2d(igrd)),cellat(iptr2d(igrd)),
     &                  cellon(iptr2d(igrd)),lrdlai(igrd),
     &                  lai(iptr2d(igrd)),
     &                  pwr(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &                  height(iptr3d(igrd)),press(iptr3d(igrd)),
     &                  windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                  cod(iptr3d(igrd)),
     &                  water(iptr3d(igrd)),fsurf(iptrlu(igrd)),
     &                  tempk(iptr3d(igrd)),
     &                  snow(iptr2d(igrd)),icdocn(iptr2d(igrd)),
     &                  vdeprt(ipsa2d(igrd)))
            endif
c
c========================= Source Apportion End ========================
c
            if( .NOT. lmpi .OR. iproc_id .EQ. 1 ) then
              write(*,'(a)') '   Done'
            endif
            write(iout,'(a)') '   Done'
            call flush(6)
            call flush(iout)
           endif
          else
            call zeros(vdep(iptr1lay(igrd)),mxp*myp*nspec)
          endif
c
c======================= Source Apportion Begin ========================
c
c
c  --- if this is the master grid, update the boundary
c      conditions for the tracer species ---
c
          if( ltrace .AND. .NOT. lsa_iorbc .AND. igrd .EQ. 1 .AND. 
     &                 tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC ) then
             call clrbdysa(1,mmxp(1),mmyp(1),mmzp(1),ntotsp,ptconc(1))
             call filbdysa(1,mmxp(1),mmyp(1),mmzp(1),nspec,ntotsp,
     &                                                  conc(1),ptconc(1))
          endif
c
c======================== DDM Begin =======================
c
          if( (lddm.OR.lhddm) .and. nbcddm .GT. 0 
     &                              .and. igrd .EQ. 1 ) then
               call adjbcddm(adjwest,adjeast,adjsouth,adjnorth,mmxp(1),
     &                              mmyp(1),mmzp(1),ntotsp,ptconc(1))
          endif
c
c======================== DDM End =======================
c
c
c========================= Source Apportion End ========================
c
c   --- call routine to calculate the depostion velocities
c       for the tracer species ---
c
          if( ltrace ) then
             mxp_rt = 1
             myp_rt = 1
             nsp_rt = 1
             if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                mxp_rt = mxp
                myp_rt = myp
                nsp_rt = ntotsp
             endif
             if( ldry ) call filvdsa(mxp,myp,mzp,nspec,ntotsp,
     &                     mxp_rt,myp_rt,nsp_rt,conc(iptr4d(igrd)),
     &                                     vdep(iptr1lay(igrd)),ptvdep,
     &                                             vdeprt(ipsa2d(igrd)))
          endif
c
c-----Perform 3-D Diffusion
c
          call diffus(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,.FALSE.,.FALSE.,
     &          .TRUE.,igrd,ncol(igrd),nrow(igrd),nlay(igrd),nrad,nspec,
     &          ndepspc*3,nsmspc,nsmspc,deltat(igrd),deltax(1,igrd),
     &          deltay(igrd),
     &          idfin(iptr2d(igrd)),vdep(iptr1lay(igrd)),
     &          rkx(iptr3d(igrd)),rky(iptr3d(igrd)),
     &          rkv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &          tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &          windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &          water(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &          tsurf(iptr2d(igrd)),mapscl(iptr2d(igrd)),
     &          sfcz0(iptr2d(igrd)),snow(iptr2d(igrd)),
     &          snowfrc(iptr2d(igrd)),conc(iptr4d(igrd)),
     &          fluxes(1,igrd),fluxtmp,depfld(iptrdp(igrd)),
     &          solmas(iptrsm(igrd)),vegmas(iptrsm(igrd)),
     &          fsurf(iptrlu(igrd)),ipsa3d(igrd),
     &          iproc_id,ipacl_2d(iptr2d_full(igrd)),
     &          ipacl_3d(iptr3d_full(igrd)),
     &          '  z diffusion ......','     x/y diff ......')
          call flush(6)
          call flush(iout)
c
c======================== Source Apportion Begin =======================
c
          if( ltrace ) then
c
c  --- call routine with tracer species arrays, send dummy
c      arguments for the total mass arrays ---
c
               if( lptdepout ) then
                   call diffus(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &                  .FALSE.,.TRUE.,.TRUE.,igrd,ncol(igrd),nrow(igrd),
     &                  nlay(igrd),0,ntotsp,notimespc,1,1,deltat(igrd),
     &                  deltax(1,igrd),
     &                  deltay(igrd),idfin(iptr2d(igrd)),ptvdep,
     &                  rkx(iptr3d(igrd)),rky(iptr3d(igrd)),
     &                  rkv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &                  tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                  windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                  water(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &                  tsurf(iptr2d(igrd)),mapscl(iptr2d(igrd)),
     &                  sfcz0(iptr2d(igrd)),snow(iptr2d(igrd)),
     &                  snowfrc(iptr2d(igrd)),ptconc(ipsa3d(igrd)),
     &                  fluxdum,fluxtmp,ptdryfld(ipsadep(igrd)),depdum,
     &                  depdum,fsurf(iptrlu(igrd)),ipsa3d(igrd),
     &                  iproc_id,ipacl_2d(iptr2d_full(igrd)),
     &                  ipacl_3d(iptr3d_full(igrd)),
     &                  '  SA z diffus ......','  SA x/y diff ......')
               elseif( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
                   call diffus(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &                  .TRUE.,.TRUE.,.TRUE.,igrd,ncol(igrd),nrow(igrd),
     &                  nlay(igrd),0,ntotsp,ntotsp,ntotsp,1,
     &                  deltat(igrd),
     &                  deltax(1,igrd),deltay(igrd),idfin(iptr2d(igrd)),
     &                  ptvdep,rkx(iptr3d(igrd)),rky(iptr3d(igrd)),
     &                  rkv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &                  tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                  windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                  water(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &                  tsurf(iptr2d(igrd)),mapscl(iptr2d(igrd)),
     &                  sfcz0(iptr2d(igrd)),snow(iptr2d(igrd)),
     &                  snowfrc(iptr2d(igrd)),ptconc(ipsa3d(igrd)),
     &                  fluxdum,fluxtmp,rtsolmas(ipsa2d(igrd)),
     &                  rtvegmas(ipsa2d(igrd)),depdum,
     &                  fsurf(iptrlu(igrd)),ipsa3d(igrd),
     &                  iproc_id,ipacl_2d(iptr2d_full(igrd)),
     &                  ipacl_3d(iptr3d_full(igrd)),
     &                  '  SA z diffus ......','  SA x/y diff ......')
               else
                   call diffus(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,ibcon,
     &                  .FALSE.,.TRUE.,.FALSE.,igrd,ncol(igrd),nrow(igrd),
     &                  nlay(igrd),0,ntotsp,notimespc,1,1,deltat(igrd),
     &                  deltax(1,igrd),
     &                  deltay(igrd),idfin(iptr2d(igrd)),ptvdep,
     &                  rkx(iptr3d(igrd)),rky(iptr3d(igrd)),
     &                  rkv(iptr3d(igrd)),depth(iptr3d(igrd)),
     &                  tempk(iptr3d(igrd)),press(iptr3d(igrd)),
     &                  windu(iptr3d(igrd)),windv(iptr3d(igrd)),
     &                  water(iptr3d(igrd)),cwc(iptr3d(igrd)),
     &                  tsurf(iptr2d(igrd)),mapscl(iptr2d(igrd)),
     &                  sfcz0(iptr2d(igrd)),snow(iptr2d(igrd)),
     &                  snowfrc(iptr2d(igrd)),ptconc(ipsa3d(igrd)),
     &                  fluxdum,fluxtmp,depdum,depdum,depdum,
     &                  fsurf(iptrlu(igrd)),ipsa3d(igrd),
     &                  iproc_id,ipacl_2d(iptr2d_full(igrd)),
     &                  ipacl_3d(iptr3d_full(igrd)),
     &                  '  SA z diffus ......','  SA x/y diff ......')
               endif
          endif
c
c-----Subgrid Cloud-in-Grid transport, wet scavenging, aqueous chemistry
c
          if (lwet .or. lcig(igrd)) then
            if( .NOT. lmpi .OR. iproc_id .EQ. 1 ) then
              write(*,'(a20,$)') ' cigdrive ......'
            endif
            write(iout,'(a20,$)') ' cigdrive ......'
            if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
              call cigdrive(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,igrd,
     &                    ncol(igrd),nrow(igrd),nlay(igrd),nspec,
     &                    ndepspc*3,idfin(iptr2d(igrd)),deltat(igrd),
     &                    densfac,dtout,deltax(1,igrd),deltay(igrd),
     &                    mapscl(iptr2d(igrd)),ldark(iptr2d(igrd)),
     &                    depth(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &                    press(iptr3d(igrd)),water(iptr3d(igrd)),
     &                    cigfrc(iptr2d(igrd)),cigwtr(iptr3d(igrd)),
     &                    cigph(iptr3d(igrd)),cigpcp(iptr3d(igrd)),
     &                    cwc(iptr3d(igrd)),cph(iptr3d(igrd)),
     &                    pwr(iptr3d(igrd)),pws(iptr3d(igrd)),
     &                    pwg(iptr3d(igrd)),conc(iptr4d(igrd)),
     &                    cigmas(iptrcig(igrd)),depfld(iptrdp(igrd)),
     &                    fluxes(1,igrd),xmschem(1,igrd),ipsa3d(igrd),
     &                    ipacl_3d(iptr3d_full(igrd)),
     &                    ptwetfld(MAX(ipsadep(igrd),1)),
     &                    fsurf(iptrlu(igrd)),ptconc(ipsa3d(igrd)),
     &                    rtsolmas(ipsa2d(igrd)),rtvegmas(ipsa2d(igrd)),
     &                    mxp,myp,mzp,nrtrac)
            else
              call cigdrive(mxp,myp,mzp,i0,j0,ia,iz,ja,jz,igrd,
     &                 ncol(igrd),nrow(igrd),nlay(igrd),nspec,ndepspc*3,
     &                 idfin(iptr2d(igrd)),deltat(igrd),densfac,
     &                 dtout,deltax(1,igrd),deltay(igrd),
     &                 mapscl(iptr2d(igrd)),ldark(iptr2d(igrd)),
     &                 depth(iptr3d(igrd)),tempk(iptr3d(igrd)),
     &                 press(iptr3d(igrd)),water(iptr3d(igrd)),
     &                 cigfrc(iptr2d(igrd)),cigwtr(iptr3d(igrd)),
     &                 cigph(iptr3d(igrd)),cigpcp(iptr3d(igrd)),
     &                 cwc(iptr3d(igrd)),cph(iptr3d(igrd)),
     &                 pwr(iptr3d(igrd)),pws(iptr3d(igrd)),
     &                 pwg(iptr3d(igrd)),conc(iptr4d(igrd)),
     &                 cigmas(iptrcig(igrd)),depfld(iptrdp(igrd)),
     &                 fluxes(1,igrd),xmschem(1,igrd),ipsa3d(igrd),
     &                 ipacl_3d(iptr3d_full(igrd)),
     &                 ptwetfld(MAX(ipsadep(igrd),1)),
     &                 fsurf(iptrlu(igrd)),cigdum1,cigdum2,cigdum2,1,1,1,1)
            endif
            if( .NOT. lmpi .OR. iproc_id .EQ. 1 ) then
               write(*,'(a)') '   Done'
            endif
            write(iout,'(a)') '   Done'
            call flush(6)
            call flush(iout)
          endif      !lwet,lcig
c
c  --- call routine to do haze adjustment ---
c
          if( lchem ) then
            if( iproc_id .LE. 1 ) then
               write(*,'(a20,$)') 'TUV ......'
            endif
            write(iout,'(a20,$)') 'TUV ......'
            call flush(6)
            call drvtuv(igrd,mxp,myp,mzp,
     &                  nspec,time,date,itzon,
     &                  idfin(iptr2d(igrd)),
     &                  cellat(iptr2d(igrd)),cellon(iptr2d(igrd)),
     &                  height(iptr3d(igrd)),press(iptr3d(igrd)), 
     &                  tsurf(iptr2d(igrd)),tempk(iptr3d(igrd)),
     &                  water(iptr3d(igrd)),conc(iptr4d(igrd)),
     &                  cod(iptr3d(igrd)),albedo(iptr2d(igrd)),
     &                  cldtrns(iptr3d(igrd)))
            if( iproc_id .LE. 1 ) then
               write(*,'(a)') '   Done'
            endif
            write(iout,'(a)') '   Done'
            call flush(6)
            call flush(iout)
          endif
      endif   !end of if( .not. LMPI .or. (iproc_id .gt. 0) ) on line332
c
      return
      end

      subroutine wrtdepsa(tim2,idat2,igrd,iunit,nox,noy,nspdep,
     &                                               dryfld,wetfld)
      use grid
      use chmstry
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c 
c     WRTDEPSA writes deposition fields for the Source Apportionment
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments:
c        tim2                output time (HHMM)
c        idat2               output date (YYJJJ)
c        igrd                grid number
c        iunit               output unit
c        nox                 number of cells in x-direction
c        noy                 number of cells in y-direction
c        nspdep              number of dep field species
c        dryfld              dry deposition field to output
c        wetfld              dry deposition field to output
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c 
      include 'camx.prm'
c
      real dryfld(nox,noy,nspdep)
      real wetfld(nox,noy,nspdep)
c
      character*4 ispec(10,MXTRSP)
      character*1 dstring, wstring, underscore
c
      data nseg /1/
      data dstring /'D'/
      data wstring /'W'/
      data underscore /'_'/
c
c-----Entry point
c
      ibegcel = 1
      iendcel = nox
      jbegcel = 1
      jendcel = noy
      if( igrd .GT. 1 ) then
        ibegcel = 2
        iendcel = nox-1
        jbegcel = 2
        jendcel = noy-1
      endif
c
c-----Determine time/date range
c
      idat1 = idat2
      etim = AINT(ANINT(tim2)/100.) + amod(ANINT(tim2),100.)/60.
      btim = ANINT( 1000*(etim - ANINT(dtout)/60.) )/1000.
      if (btim.lt.0.) then
        btim = btim + 24.
        idat1 = idat1 - 1
        if (MOD(idat1,1000) .EQ. 0 ) then
          if ( MOD(INT(idat1/1000)-1,4) .EQ. 0 ) then
            idat1 = (INT(idat1/1000)-1)*1000 + 366
          else
            idat1 = (INT(idat1/1000)-1)*1000 + 365
          end if
        endif
      endif 
c
c-----Write the time stamp ---
c
      write(iunit) idat1,btim,idat2,etim
c
c-----Write gridded dry deposition field
c
      do l = 1,notimespc
        do n=1,9
          if( ptname(l)(n:n) .NE. ' ' ) then
             read(ptname(l)(n:n),'(a1)') ispec(n,l)
          else
             read(underscore,'(a1)') ispec(n,l)
          endif
        enddo
        read(dstring,'(a1)') ispec(10,l)
      enddo
      do l = 1,notimespc
        if( loutsa(l) ) then
           write(iunit) nseg,(ispec(n,l),n=1,10),
     &               ((dryfld(i,j,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
        endif
      enddo
c
c-----Write gridded wet deposition field
c
      do l = 1,notimespc
        do n=1,9
          if( ptname(l)(n:n) .NE. ' ' ) then
             read(ptname(l)(n:n),'(a1)') ispec(n,l)
          else
             read(underscore,'(a1)') ispec(n,l)
          endif
        enddo
        read(wstring,'(a1)') ispec(10,l)
      enddo
      do l = 1,notimespc
        if( loutsa(l) ) then
           write(iunit) nseg,(ispec(n,l),n=1,10),
     &               ((wetfld(i,j,l),i=ibegcel,iendcel),j=jbegcel,jendcel)
        endif
      enddo
c
      return
      end

c**** CLCIWT
c
      subroutine clciwt(idate,btim,jdate,etim,ncolx,nrowy,nlays,
     &                  height)
      use filunit
      use grid
      use chmstry
      use bndary
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine calculates the weighted reactivity factor for VOC
c   species for the initial conditions.  The mass is weighted by layer
c   thickness giving the weighted average for the cell.  The average
c   over all cells is then calculated.
c
c      Copyright Ramboll
c
c      Argument description:
c        idate   I   beginning date of simulation (YYJJJ)
c        btim    R   beginning time of simulation
c        jdate   I   ending date of simulation (YYJJJ)
c        etim    R   ending time of simulation
c        ncolx   I   number of columns in coarse grid
c        nrowy   I   number of rows in coarse grid
c        nlays   I   number of layers in coarse grid
c        height  R   vertical grid structure at current time
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/04/96   --gwilson--    Original development
c     11/06/01   --cemery--     Input dates are now Julian
c     11/20/03   --gwilson--    Fixed bug when using the species map
c                               to get the index of modeled species
c     11/16/06   --gwilson--    Removed the rewind of the output file
c     01/04/11   --cemery--     Revised for new met input format
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   jdate
      real      etim
      integer   ncolx
      integer   nrowy
      integer   nlays
      real height(ncolx,nrowy,nlays)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*4  iname(10)
      integer      idx, iseg, ispc, izcl, i, j, k, numic_tracers
      integer      ibegic, iendic, ibgdhp, idtnow, iunit, ioff
      real         btimic, etimic, btimhp, timnow
      logical      lfound
c
      real sumvoc(MXTRCLS)
      real sumkoh(MXTRCLS)
      real summir(MXTRCLS)
      real sumyld(MXTRCLS)
      real yldhvoc(MXTRCLS), yldlvoc(MXTRCLS)
      real consum(MXSPEC)
      real congrd(MXCELLS*MXCELLS*MXLAYER)
c
      real, allocatable, dimension(:,:,:) :: tmp3d
      real, allocatable, dimension(:,:,:) :: depth
c
c-----------------------------------------------------------------------
c    Common Blocks:
c-----------------------------------------------------------------------
c
       common /comclciwt/ congrd
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- call routine to get the file pointers to the proper place ---
c
      if( .NOT. lrstrt ) then
         iunit = iic
      else
         iunit = irstc
      endif
      ibgdhp = 0
      btimhp = 0.0
c
c  ---- allocate the temp array ---
c
      allocate( tmp3d(ncolx,nrowy,nlays) )
      allocate( depth(ncolx,nrowy,nlays) )
c
c  --- set the current date and time ----
c
      idtnow = idate
      timnow = btim/100.0
c
c   --- determine depth array from height ---
c
      do k = 1,nlays
        do j = 1,nrowy
          do i = 1,ncolx
            depth(i,j,k) = height(i,j,k)
            if( k .GT. 1 ) 
     &         depth(i,j,k) = height(i,j,k) - height(i,j,k-1)
          enddo
        enddo
      enddo
c
c   --- initialize the array to zero ---
c
      do i=1,nspec
        consum(i) = 0.
      enddo
c
c   --- read the initial conditions ----
c
  111 continue
      read(iunit,ERR=7001,END=7002) ibegic, btimic, iendic, etimic
      lfound = .TRUE.
      if( ibegic .EQ. idtnow .AND. btimic .GT. timnow) lfound = .FALSE.
      if( ibegic .GT. idtnow ) lfound = .FALSE.
      do 10 ispc=1,nicspc
          do izcl = 1,nlays
              read(iunit,ERR=7001,END=7002) iseg, (iname(i),i=1,10), 
     &                    ((tmp3d(i,j,izcl),i=1,ncolx),j=1,nrowy)
          enddo
          do k=1,nlays
            do j=1,nrowy
              do i=1,ncolx
                n3d = i + (j-1)*ncolx + (k-1)*ncolx*nrowy
                congrd(n3d) = tmp3d(i,j,k)
              enddo
            enddo
          enddo
c
c   --- if record does not span this hour, skip it ----
c
         if( .NOT. lfound ) goto 10
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
          idx = 0
          do i=1,nspec
            if( licmap(i) .EQ. ispc ) idx = i
          enddo
          if( idx .LE. 0 ) goto 10
          call sumicwt(ncolx,nrowy,nlays,deltax,
     &                                     depth,congrd,consum(idx))
c
c   --- next species ---
c
   10 continue
c
c  --- if hour not found, go back and read it ---
c
      if( .NOT. lfound ) goto 111
c
c  --- all concentrations are summed, calculate the weghted fraction ----
c
      do icls=1,ntrcls
         sumvoc(icls) = 0.
         sumkoh(icls) = 0.
         summir(icls) = 0.
         sumyld(icls) = 0.
         yldhvoc(icls) = 0.
         yldlvoc(icls) = 0.
      enddo
      do i=1,nspec
         if( (lvocsp(i) .OR. lvocsoa(i)) .AND. consum(i) .GT. 0. ) then
            do icls=1,ntrcls
               sumvoc(icls) = sumvoc(icls) + consum(i) * trspmap(i,icls)
               sumkoh(icls) = sumkoh(icls) + consum(i) * rkohrt(i) * 
     &                                                   trspmap(i,icls)
               summir(icls) = summir(icls) + consum(i) * rmirrt(i) * 
     &                                                   trspmap(i,icls)
               if( yhratmap(i,icls) .GT. 0. .OR.
     &             ylratmap(i,icls) .GT. 0. ) then
                    sumyld(icls) = sumyld(icls) + consum(i)
                    yldhvoc(icls) = yldhvoc(icls) +
     &                                      consum(i) * yhratmap(i,icls)
                    yldlvoc(icls) = yldlvoc(icls) +
     &                                      consum(i) * ylratmap(i,icls)
               endif
            enddo 
         endif
      enddo
      numic_tracers = 1
      if( lsa_ioric ) numic_tracers = ncls_ioric
      do icls=1,ntrcls 
         do ioff=1,numic_tracers
            if( sumvoc(icls) .GT. 0. ) then
                wtkoh(iptcls(icls)+ioff-1) = sumkoh(icls) / sumvoc(icls)
                wtmir(iptcls(icls)+ioff-1) = summir(icls) / sumvoc(icls)
            else
                wtkoh(iptcls(icls)+ioff-1) = 0.
                wtmir(iptcls(icls)+ioff-1) = 0.
            endif
            if( sumyld(icls) .GT. 0. ) then
                yhrates(iptcls(icls)+ioff-1) = yldhvoc(icls) / sumyld(icls)
                ylrates(iptcls(icls)+ioff-1) = yldlvoc(icls) / sumyld(icls)
            else       
                yhrates(iptcls(icls)+ioff-1) = 0.
                ylrates(iptcls(icls)+ioff-1) = 0.
            endif
        enddo
      enddo
c
c  --- rewind the files to be used by the regular model ----
c
      rewind(iunit)
      rewind(i3dmet(1))
c
c  --- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in CLCIWT:'
      write(iout,'(/,1X,A)') 'Reading initial conditions.'
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in CLCIWT:'
      write(iout,'(/,1X,2A)') 'ERROR: Premature end-of-file reading ',
     &                                            'initial conditions.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
c  ---- deallocate the temp array ---
c
      deallocate( tmp3d )
      deallocate( depth )
c
      return
      end

c**** CLCBWT
c
      subroutine clcbwt(idate,btim,jdate,etim,ncolx,nrowy,nlays)
      use filunit
      use chmstry
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine calculates the weighted reactivity factor for VOC
c   species for the boundary conditions.  The mass is weighted by layer
c   thickness giving the weighted average for the cell.  The average
c   over all cells is then calculated.  The averages are calculated for
c   the entire bounday and for each boundary seperately.
c
c      Copyright Ramboll
c
c     Argument declarations:
c        idate   I   beginning date of simulation (YYJJJ)
c        btim    R   beginning time of simulation
c        jdate   I   ending date of simulation (YYJJJ)
c        etim    R   ending time of simulation
c        ncolx    I   number of columns in coarse grid
c        nrowy    I   number of rows in coarse grid
c        nlays    I   number of layers in coarse grid
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/29/96   --gwilson--    Original development
c     11/06/01   --cemery--     Input dates are now Julian
c     11/4/09    -cemery-       Removed input top concentrations
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   idate
      real      btim
      integer   jdate
      real      etim
      integer   ncolx
      integer   nrowy
      integer   nlays
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer      ndate, jdlast, i, j, numbc_tracers, numic_tracers
      integer      idtnow, ioff
      real         ttime, ttlast, timnow
c
      real sumvoc(MXTRCLS)
      real sumkoh(MXTRCLS)
      real summir(MXTRCLS)
      real sumyld(MXTRCLS)
      real yldhvoc(MXTRCLS), yldlvoc(MXTRCLS)
      real consum(MXSPEC,0:IDXBTP)
      real, parameter :: SMALL = 1.e-12
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- call routine to get the file pointers to the proper place ---
c
      if( is_netcdf_ibc ) then
          call ncf_bndprep(btim,idate,etim,jdate)
      else
          call bndprep(btim,idate,etim,jdate)
      endif
c
c   --- set ending date and time to be consistent with how time is 
c       counted here ----
c      
  222 continue
      ndate = idate
      ttime = btim/100.0
      jdlast = jdate
      ttlast = etim/100.0
      if( ttlast .EQ. 0. ) then
         jdlast = jdlast - 1
         ttlast = 24.0
      endif
      if( MOD(jdlast,1000) .EQ. 0 ) then
        jdlast = (INT(jdlast/1000)-1)*1000 + 365
      endif
c
c  --- initialize the dates and times ---
c
      idtnow = ndate
      timnow = ttime
c
      if( .NOT. is_netcdf_ibc ) then
         call rdsumbc(idtnow,timnow,jdlast,ttlast,ncolx,nrowy,nlays,consum)
      else
         call ncf_rdsumbc(idtnow,timnow,jdlast,ttlast,ncolx,nrowy,nlays,consum)
         bnddate_time_tflag = 0
         bnddate_time_etflag = 0
      endif
c
c   --- calculate the fractions ---
c
      if( lbndry .AND. .NOT. lsa_iorbc ) then
         do j=1,IDXBTP
            do icls=1,ntrcls
               sumvoc(icls) = SMALL
               sumkoh(icls) = SMALL
               summir(icls) = SMALL
               sumyld(icls) = SMALL
               yldhvoc(icls) = 0.
               yldlvoc(icls) = 0.
            enddo
            do i=1,nspec
               if( consum(i,j) .GT. 0. ) then
                   do icls=1,ntrcls
                      sumvoc(icls) = sumvoc(icls) + 
     &                                     consum(i,j) * trspmap(i,icls)
                      sumkoh(icls) = sumkoh(icls) + 
     &                        consum(i,j) * rkohrt(i)  * trspmap(i,icls)
                      summir(icls) = summir(icls) + 
     &                        consum(i,j) * rmirrt(i)  * trspmap(i,icls)
                      if( yhratmap(i,icls) .GT. 0. .OR.
     &                    ylratmap(i,icls) .GT. 0. ) then
                          sumyld(icls) = sumyld(icls) + consum(i,j)
                          yldhvoc(icls) = yldhvoc(icls) + 
     &                                     consum(i,j) * yhratmap(i,icls)
                          yldlvoc(icls) = yldlvoc(icls) + 
     &                                     consum(i,j) * ylratmap(i,icls)
                      endif
                   enddo
               endif
            enddo
            do icls=1,ntrcls
               if( sumvoc(icls) .GT. 0. ) then
                   wtkoh(iptcls(icls)+j) = sumkoh(icls) / sumvoc(icls)
                   wtmir(iptcls(icls)+j) = summir(icls) / sumvoc(icls)
               else
                   wtkoh(iptcls(icls)+j) = 0.
                   wtmir(iptcls(icls)+j) = 0.
               endif
               if( sumyld(icls) .GT. 0. ) then
                   yhrates(iptcls(icls)+j) = yldhvoc(icls) / sumyld(icls)
                   ylrates(iptcls(icls)+j) = yldlvoc(icls) / sumyld(icls)
               else
                   yhrates(iptcls(icls)+j) = 0.
                   ylrates(iptcls(icls)+j) = 0.
               endif
            enddo
         enddo
      else
         do icls=1,ntrcls
            sumvoc(icls) = SMALL
            sumkoh(icls) = SMALL
            summir(icls) = SMALL
            sumyld(icls) = SMALL
            yldhvoc(icls) = 0.
            yldlvoc(icls) = 0.
         enddo
         do i=1,nspec
            if( consum(i,0) .GT. 0. ) then
                do icls=1,ntrcls
                    sumvoc(icls) = sumvoc(icls) + 
     &                                     consum(i,0) * trspmap(i,icls)
                    sumkoh(icls) = sumkoh(icls) + 
     &                        consum(i,0) * rkohrt(i)  * trspmap(i,icls)
                    summir(icls) = summir(icls) + 
     &                        consum(i,0) * rmirrt(i)  * trspmap(i,icls)
                    if( yhratmap(i,icls) .GT. 0. .OR.
     &                  ylratmap(i,icls) .GT. 0. ) then
                       sumyld(icls) = sumyld(icls) + consum(i,0)
                       yldhvoc(icls) = yldhvoc(icls) + 
     &                                     consum(i,0) * yhratmap(i,icls)
                       yldlvoc(icls) = yldlvoc(icls) + 
     &                                     consum(i,0) * ylratmap(i,icls)
                    endif
                enddo
            endif
         enddo
         numbc_tracers = 1
         if( lsa_iorbc ) numbc_tracers = ncls_iorbc
         numic_tracers = 1
         if( lsa_ioric ) numic_tracers = ncls_ioric
         do icls=1,ntrcls
            do ioff=1,numbc_tracers
               if( sumvoc(icls) .GT. 0. ) then
                  wtkoh(iptcls(icls)+numic_tracers+ioff-1) = 
     &                                    sumkoh(icls) / sumvoc(icls)
                  wtmir(iptcls(icls)+numic_tracers+ioff-1) = 
     &                                    summir(icls) / sumvoc(icls)
               else
                  wtkoh(iptcls(icls)+numic_tracers+ioff-1) = 0.
                  wtmir(iptcls(icls)+numic_tracers+ioff-1) = 0.
               endif
               if( sumyld(icls) .GT. 0. ) then
                  yhrates(iptcls(icls)+numic_tracers+ioff-1) = 
     &                                    yldhvoc(icls) / sumyld(icls)
                  ylrates(iptcls(icls)+numic_tracers+ioff-1) = 
     &                                    yldlvoc(icls) / sumyld(icls)
               else
                  yhrates(iptcls(icls)+numic_tracers+ioff-1) = 0.
                  ylrates(iptcls(icls)+numic_tracers+ioff-1) = 0.
               endif
            enddo
            do ioff=1,ncls_iortc
               if( sumvoc(icls) .GT. 0. ) then
                  wtkoh(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) =
     &                                    sumkoh(icls) / sumvoc(icls)
                  wtmir(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) =
     &                                    summir(icls) / sumvoc(icls)
               else
                  wtkoh(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) = 0.
                  wtmir(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) = 0.
               endif
               if( sumyld(icls) .GT. 0. ) then
                  yhrates(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) =
     &                                    yldhvoc(icls) / sumyld(icls)
                  ylrates(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) =
     &                                    yldlvoc(icls) / sumyld(icls)
               else
                  yhrates(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) = 0.
                  ylrates(iptcls(icls)+numic_tracers+numbc_tracers+ioff-1) = 0.
               endif
            enddo
         enddo
      endif
c
c  --- return to the calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 8000 format(A10,F10.0)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine readinp(igrd,ngcol,ngrow,nglay,hght,phptim,hnext,
     &                   presure,ppptim,pnext,wndu,puptim,unext,wndv,
     &                   pvptim,vnext,tsrf,psptim,tsnext,temper,ptptim,
     &                   tnext,vapor,pwptim,wnext,rkvgrd,pkptim,knext,
     &                   cldwtr,ranwtr,snowtr,gplwtr,cldod,cldph,
     &                   snow,snowage,snowrat,
     &                   cigfrc,cigtim,cigwtr,cigpcp,cigent,cigdet)
      use filunit
      use grid
      use camxcom
c 
c----CAMx v7.40 260801
c 
c     READINP cycles through and reads all time-variant meteorological 
c     input files.  The following files are read:
c     - 3D met fields        at next update date/time, nested grids optional
c     - 2D met fields        at next update date/time, nested grids optional
c     - 3D Kv fields         at next update date/time, nested grids optional
c     - 3D Cloud/rain fields     at current date/time, nested grids optional
c     The time-rate of change for all time-interpolated fields are also
c     determined.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        1/13/99   Added checks to convert input hours at 2400 to 0 on the
c                  following day
c       11/06/01   CAMx now assumes that all input file dates are in
c                  Julian format (YYJJJ) if the simulation year is 2000
c                  or greater.  Added call to DATEERR for time mismatches.
c        8/30/02   Cloud and rain files combined into one file (CAMx formatted
c                  file only), and now cloud/rain and water vapor files can be 
c                  read in for each nest
c        1/23/03   Cloud file contains new parameters:
c                  -cloud water content (cwc)
c                  -precip water content (pwc)
c                  -optical depth (cod)
c        4/2/03    Removed option for UAM-V type cloud file
c        3/3/04    Added checks for reading water files
c                  if either chemistry, dry dep or wet dep is on
c       10/12/04   Water vapor and vertical diffusivity fields are now
c                  time-interpolated
c        6/21/05   Cloud file contains new parameters:
c                  -cloud water content (cwc)
c                  -rain water content (pwr)
c                  -snow water content (pws)
c                  -graupel water content (pwg)
c                  -optical depth (cod)
c       10/24/05   Cloud water pH initialized at 5
c       12/12/05   Date/time handling improved to handle small clock drift
c        7/14/10   Added code for in-line TUV cloud adjustment
c       01/04/11   Revised for new met input format
c       02/11/11   Moved snow field from AHO to 2D met file
c       03/29/11   Support in-line TUV with aerosol optical depth
c       04/02/12   Removed RADM cloud adjustment option, cloud/aerosol 
c                  adjustments now always done with in-line TUV
c       08/08/14   Added new snow cover input fields
c       09/02/14   Added subgrid convective model
c       07/23/19   Staggered wind flag is now grid-specific
c 
c     Input arguments: 
c        igrd                grid index
c        ngcol               number of columns
c        ngrow               number of rows
c        nglay               number of layers
c        hght                current layer interface field (m)
c        presure             current pressure field (mb)
c        wndu                current u-component wind field (m/s)
c        wndv                current v-component wind field (m/s)
c        tsrf                current surface temperature field (K)
c        temper              current temperature field (K)
c        vapor               current water vapor field (ppm)
c        rkvgrd              current vertical exchange coefficient (m2/s)
c 
c     Output arguments: 
c        phptim              time-rate change of layer interface height (m/s)
c        hnext                next layer interface height field (m)
c        ppptim              time-rate change of pressure (mb/s)
c        pnext                next pressure field (mb)
c        puptim              time-rate change of u-component wind (m/s2)
c        unext                next u-component wind field (m/s)
c        pvptim              time-rate change of v-component wind (m/s2)
c        vnext                next v-component wind field (m/s)
c        psptim              time-rate change of surface temperature (K/s)
c        tsnext               next surface temperature field (m/s)
c        ptptim              time-rate change of 3-D temperature (K/s)
c        tnext                next 3-D temperature field (m/s)
c        pwptim              time-rate change of 3-D water vapor (ppm/s)
c        wnext                next 3-D water vapor field (ppm)
c        pkptim              time-rate change of 3-D vertical diff (m2/s2)
c        knext                next 3-D vertical diffusivity field (m2/s)
c        cldwtr              cloud water content (g/m3)
c        ranwtr              rain water content (g/m3)
c        snowtr              snow water content (g/m3)
c        gplwtr              graupel water content (g/m3)
c        cldod               cloud optical depth 
c        cldph               cloud water pH
c        snow                snow cover water equivalent (m)
c        snowage             snow cover age (hr)
c        snowrat             snow water accumulation rate (m/hr)
c        cigfrc              convective cloud fraction (unitless)
c        cigtim              convective cloud timescale (s)
c        cigwtr              convective cloud water (g/m3)
c        cigpcp              convective cloud precip (g/m3)
c        cigent              convective cloud entrainment (kg/m2/s)
c        cigdet              convective cloud detrainment (kg/m2/s)
c 
c     Routines Called: 
c        TIMRATES
c        CVTWIND
c        ZEROS
c        RASSGN3D
c        INTRP2D
c        INTRPV
c 
c     Called by: 
c        TSTEP_INIT
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer igrd,ngcol,ngrow,nglay
      real snow(ngcol,ngrow),snowage(ngcol,ngrow),snowrat(ngcol,ngrow)
      real hnext(ngcol,ngrow,nglay),pnext(ngcol,ngrow,nglay),
     &     unext(ngcol,ngrow,nglay),vnext(ngcol,ngrow,nglay),
     &     tnext(ngcol,ngrow,nglay),wnext(ngcol,ngrow,nglay),
     &     knext(ngcol,ngrow,nglay)
      real hght(ngcol,ngrow,nglay),phptim(ngcol,ngrow,nglay),
     &     presure(ngcol,ngrow,nglay),ppptim(ngcol,ngrow,nglay),
     &     wndu(ngcol,ngrow,nglay),puptim(ngcol,ngrow,nglay),
     &     wndv(ngcol,ngrow,nglay),pvptim(ngcol,ngrow,nglay),
     &     temper(ngcol,ngrow,nglay),ptptim(ngcol,ngrow,nglay),
     &     vapor(ngcol,ngrow,nglay),pwptim(ngcol,ngrow,nglay),
     &     rkvgrd(ngcol,ngrow,nglay),pkptim(ngcol,ngrow,nglay)
      real cldwtr(ngcol,ngrow,nglay),
     &     ranwtr(ngcol,ngrow,nglay),snowtr(ngcol,ngrow,nglay),
     &     gplwtr(ngcol,ngrow,nglay),cldod(ngcol,ngrow,nglay),
     &     cldph(ngcol,ngrow,nglay)
      real cigfrc(ngcol,ngrow),cigtim(ngcol,ngrow),
     &     cigwtr(ngcol,ngrow,nglay),cigpcp(ngcol,ngrow,nglay),
     &     cigent(ngcol,ngrow,nglay),cigdet(ngcol,ngrow,nglay)
      real tsrf(ngcol,ngrow),psptim(ngcol,ngrow),tsnext(ngcol,ngrow)
c
      integer hdate,iunit,idt,i,j,k,m,n,idum
      integer icigf,icigw,icigp,icige,icigd
      real whr,wmn,atim,htim,hr,snowold
      real arr3d(MXCELLS,MXCELLS,MXLAYER)
      real arr2d(MXCELLS,MXCELLS)
      character*60 string
      character*10 namevar
      character*4 namvar(10)
c
      common /dataarr/ arr2d, arr3d
c
c-----Entry point
c
c-----Find the date/time at the next update interval
c
      whr = aint(time/100.)
      wmn = anint(amod(time,100.))
      atim = 100.*whr + wmn
      htim = 100.*(whr + aint((wmn + dtinp)/60.)) +
     &             amod((wmn + dtinp),60.)
      hdate = date
      if (htim.ge.2400.) then
        htim = anint(htim - 2400.)
        hdate = hdate + 1
        if( MOD(hdate,1000) .GT. 365 ) then
           if( MOD(INT(hdate/1000),4) .EQ. 0 ) then
              if( MOD(hdate,1000) .EQ. 367 )
     &           hdate = (INT(hdate/1000)+1)*1000 + 1
           else
              hdate = (INT(hdate/1000)+1)*1000 + 1
           endif
        endif
      endif
c
c-----Read 3D met file
c
      iunit = i3dmet(igrd)
      if( iunit .GT. 0 ) then
         write(string,'(A,I5)') 'Reading 3D met file for grid:',igrd
 101     continue
         read(iunit,end=7000) idt,hr
         hr = 100*aint(hr) + anint(60.*amod(hr,1.))
         if (hr.ge.2400.) then
           hr = hr - 2400.
           idt = idt + 1
           if( MOD(idt,1000) .GT. 365 ) then
              if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                 if( MOD(idt,1000) .EQ. 367 )
     &              idt = (INT(idt/1000)+1)*1000 + 1
              else
                 idt = (INT(idt/1000)+1)*1000 + 1
              endif
           endif
         endif
         write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 3D met file at ',hr,idt,' grid',igrd
         call flush(iout)
c
         if (idt.lt.hdate .or. (idt.eq.hdate .and. hr.lt.htim)) then
           do n = 1,n3dmet(igrd)
             do k = 1,nglay
               read(iunit)
             enddo
           enddo
           goto 101
         endif
         if (idt.gt.hdate .or. (idt.eq.hdate .and. hr.gt.htim))
     &     goto 7001
c
         do n = 1,n3dmet(igrd)
           do k = 1,nglay
            read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                           ((arr3d(i,j,k),i=1,ngcol),j=1,ngrow)
           enddo
           write(namevar,'(10a1)') (namvar(m),m=1,10)
           if (namevar.eq.'ZGRID_M') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   hnext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           elseif (namevar.eq.'PRESS_MB') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   pnext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           elseif (namevar.eq.'TEMP_K') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   tnext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           elseif (namevar.eq.'HUMID_PPM') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   wnext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           elseif (namevar.eq.'UWIND_MpS') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   unext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           elseif (namevar.eq.'VWIND_MpS') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   vnext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
         enddo
c
c-----Convert wind vectors if they are not staggered
c
         if (.not.lstagw(igrd)) call cvtwind(ngcol,ngrow,nglay,unext,
     &                                       vnext)
c
c-----Calculate time rates of change for 3D met fields
c
         call timrates(ngcol,ngrow,nglay,hght,hnext,phptim)
         call timrates(ngcol,ngrow,nglay,presure,pnext,ppptim)
         call timrates(ngcol,ngrow,nglay,temper,tnext,ptptim)
         call timrates(ngcol,ngrow,nglay,vapor,wnext,pwptim)
         call timrates(ngcol,ngrow,nglay,wndu,unext,puptim)
         call timrates(ngcol,ngrow,nglay,wndv,vnext,pvptim)
      endif
c
c-----Read 2D met file
c
      iunit = i2dmet(igrd)
      if( iunit .GT. 0 ) then
         write(string,'(A,I5)') 'Reading 2D met file for grid:',igrd
 102     continue
         read(iunit,end=7000) idt,hr
         hr = 100*aint(hr) + anint(60.*amod(hr,1.))
         if (hr.ge.2400.) then
           hr = hr - 2400.
           idt = idt + 1
           if( MOD(idt,1000) .GT. 365 ) then
              if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                 if( MOD(idt,1000) .EQ. 367 )
     &              idt = (INT(idt/1000)+1)*1000 + 1
              else
                 idt = (INT(idt/1000)+1)*1000 + 1
              endif
           endif
         endif
         write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 2D met file at ',hr,idt,' grid',igrd
         call flush(iout)
c
         if (idt.lt.hdate .or. (idt.eq.hdate .and. hr.lt.htim)) then
           do n = 1,n2dmet(igrd)
             read(iunit)
           enddo
           goto 102
         endif
         if (idt.gt.hdate .or. (idt.eq.hdate .and. hr.gt.htim))
     &     goto 7001
c
         do n = 1,n2dmet(igrd)
           read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                          ((arr2d(i,j),i=1,ngcol),j=1,ngrow)
           write(namevar,'(10a1)') (namvar(m),m=1,10)
           if (namevar.eq.'TSURF_K') then
             do j = 1,ngrow
               do i = 1,ngcol
                 tsnext(i,j) = arr2d(i,j)
               enddo
             enddo
           elseif (namevar.eq.'SNOWEW_M') then
             do j = 1,ngrow
               do i = 1,ngcol
                 snowold = snow(i,j)
                 snow(i,j) = arr2d(i,j)
                 snowrat(i,j) = (snow(i,j) - snowold)/(dtinp/60.)
               enddo
             enddo
           elseif (namevar.eq.'SNOWAGE_HR') then
             do j = 1,ngrow
               do i = 1,ngcol
                 snowage(i,j) = arr2d(i,j)
               enddo
             enddo
           elseif (namevar.eq.'SNOWCOVER') then
             do j = 1,ngrow
               do i = 1,ngcol
                 if (arr2d(i,j).gt.0.) then
                   snow(i,j) = .025          ! Make some assumptions
                   snowage(i,j) = 5.*24.     ! for backward compatibility
                   snowrat(i,j) = 0.
                 endif
               enddo
             enddo
           endif
         enddo
c
c-----Calculate time rates of change for 2D met fields
c
         call timrates(ngcol,ngrow,1,tsrf,tsnext,psptim)
      endif
c
c-----Read 3D VDiff file
c
      iunit = ikv(igrd)
      if( iunit .GT. 0 ) then
         write(string,'(A,I5)') 'Reading 3D VDiff file for grid:',igrd
 103     continue
         read(iunit,end=7000) idt,hr
         hr = 100*aint(hr) + anint(60.*amod(hr,1.))
         if (hr.ge.2400.) then
           hr = hr - 2400.
           idt = idt + 1
           if( MOD(idt,1000) .GT. 365 ) then
              if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                 if( MOD(idt,1000) .EQ. 367 )
     &              idt = (INT(idt/1000)+1)*1000 + 1
              else
                 idt = (INT(idt/1000)+1)*1000 + 1
              endif
           endif
         endif
         write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 3D VDiff file at ',hr,idt,' grid',igrd
         call flush(iout)
c
         if (idt.lt.hdate .or. (idt.eq.hdate .and. hr.lt.htim)) then
           do n = 1,nkvmet(igrd)
             do k = 1,nglay
               read(iunit)
             enddo
           enddo
           goto 103
         endif
         if (idt.gt.hdate .or. (idt.eq.hdate .and. hr.gt.htim))
     &     goto 7001
c
         do n = 1,nkvmet(igrd)
           do k = 1,nglay
            read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                           ((arr3d(i,j,k),i=1,ngcol),j=1,ngrow)
           enddo
           write(namevar,'(10a1)') (namvar(m),m=1,10)
           if (namevar.eq.'KV_M2pS') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   knext(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
         enddo
c
c-----Calculate time rates of change for 3D vertical diffusivity
c
         call timrates(ngcol,ngrow,nglay,rkvgrd,knext,pkptim)
      endif
c
c-----Read 3D cloud file
c
      iunit = icld(igrd)
      if (igrd.eq.1 .and. iunit.eq.0) then
         call zeros(cldwtr,ngcol*ngrow*nglay)
         call zeros(ranwtr,ngcol*ngrow*nglay)
         call zeros(snowtr,ngcol*ngrow*nglay)
         call zeros(gplwtr,ngcol*ngrow*nglay)
         call zeros(cldod, ngcol*ngrow*nglay)
      elseif (iunit.gt.0) then
         write(string,'(A,I5)') 'Reading 3D Cloud file for grid:',igrd
 104     continue
         read(iunit,end=7000) idt,hr
         hr = 100*aint(hr) + anint(60.*amod(hr,1.))
         if (hr.ge.2400.) then
           hr = hr - 2400.
           idt = idt + 1
           if( MOD(idt,1000) .GT. 365 ) then
              if( MOD(INT(idt/1000),4) .EQ. 0 ) then
                 if( MOD(idt,1000) .EQ. 367 )
     &              idt = (INT(idt/1000)+1)*1000 + 1
              else
                 idt = (INT(idt/1000)+1)*1000 + 1
              endif
           endif
         endif
         write(iout,'(a40,f7.0,i8.5,a,i3)')
     &        'Read 3D Cloud file at ',hr,idt,' grid',igrd
         call flush(iout)
c
         if (idt.lt.date .or. (idt.eq.date .and. hr.lt.atim)) then
           do n = 1,ncldmet(igrd)
             do k = 1,nglay
               read(iunit)
             enddo
           enddo
           goto 104
         endif
         if (idt.gt.date .or. (idt.eq.date .and. hr.gt.atim))
     &     goto 7002
c
         icigf = 0 
         icigw = 0 
         icigp = 0 
         icige = 0 
         icigd = 0 
         do n = 1,ncldmet(igrd)
           do k = 1,nglay
            read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                           ((arr3d(i,j,k),i=1,ngcol),j=1,ngrow)
           enddo
           write(namevar,'(10a1)') (namvar(m),m=1,10)
           if (namevar.eq.'CLODW_GpM3') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cldwtr(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'RAINW_GpM3') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   ranwtr(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'SNOWW_GpM3') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   snowtr(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'GRPLW_GpM3') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   gplwtr(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'CLOUDOD') then
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cldod(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'KFFRAC' .and. lcig(igrd)) then
             icigf = 1
             do j = 1,ngrow
               do i = 1,ngcol
                 cigfrc(i,j) = arr3d(i,j,1)
               enddo
             enddo
             do j = 1,ngrow
               do i = 1,ngcol
                 cigtim(i,j) = arr3d(i,j,2)
               enddo
             enddo
           endif
           if (namevar.eq.'KFWTR_GpM3' .and. lcig(igrd)) then
             icigw = 1
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cigwtr(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'KFPCP_GpM3' .and. lcig(igrd)) then
             icigp = 1
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cigpcp(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'KFE_KGpM2S' .and. lcig(igrd)) then
             icige = 1
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cigent(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
           if (namevar.eq.'KFD_KGpM2S' .and. lcig(igrd)) then
             icigd = 1
             do k = 1,nglay
               do j = 1,ngrow
                 do i = 1,ngcol
                   cigdet(i,j,k) = arr3d(i,j,k)
                 enddo
               enddo
             enddo
           endif
         enddo
         if (lcig(igrd) .and. icigf+icigw+icigp+icige+icigd.ne.5) then
           lcig(igrd) = .false.
           write(iout,'(//,a)')'WARNING in READINP:'
           write(iout,'(a)') string
           write(iout,'(2a)')'Subgrid convective cloud data were not',
     &                       ' found on file'
           write(iout,'(2a)')'Convective treatment will not be',
     &                       ' applied for this grid'
           write(iout,*)
         endif
c
c-----Initialize cloud pH
c
         do k = 1,nglay
           do j = 1,ngrow
             do i = 1,ngcol
               cldph(i,j,k) = 5.
             enddo
           enddo
         enddo
c
      endif
c
      return
c
 7000 continue
      write(iout,'(//,a)')'ERROR in READINP:'
      write(iout,'(a)') string
      write(iout,*)'End of input file reached.  Make sure the file '
      write(iout,*)'is for the correct day and contains all hours.'
      write(iout,*)
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in READINP:'
      write(iout,'(a)') string
      write(iout,'(a,f10.1,i10.5)') 
     &      'Past expected time/date ',htim,hdate
      write(iout,*)
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in READINP:'
      write(iout,'(a)') string
      write(iout,'(a,f10.1,i10.5)') 
     &      'Past expected time/date ',atim,date
      write(iout,*)
      call camxerr()
c
      end

      subroutine sa_bcprep(begtim,begdate,endtim,enddate)
      use tracer
      use filunit
      use grid
      implicit none
c 
c----CAMx v7.40 260801
c 
c     SA_BCPREP reads the boundary conditions file for Source Appointionment
c     and sets up the data structures to map the species into the 
c     tracer arrays.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c     Input arguments: 
c        begtim              model start time (HHMM)
c        begdate             model start date (YYJJJ)
c        endtim              model end time (HHMM)
c        enddate             model end date (YYJJJ)
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        INITSA 
c
      include 'camx.prm'
      include 'flags.inc'
c
c     Argument delcarations:
c
      integer begdate
      real    begtim
      integer enddate
      real    endtim
c
c     Local variables 
c
      character*10 bcname, infil, bcspc
      character*4  ifile(10), note(60)
      character*3  first_class
      integer      nseg, idat1, idat2, n, nx, ny, nz, izone
      integer      l
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
c
      character*4 bcspec(10,MXTRSP)
c
      data bcname /'BOUNDARY  '/
c
c-----Entry point
c
c-----Read 1st BC header record and check inputs
c
      sa_bnddate = begdate
      lrd_sa_bc_hdr = .TRUE.
      rewind(iorbc)
      read(iorbc) ifile,note,nseg,num_iorbc,idat1,tim1,idat2,tim2
c
c----check for array overflow ---
c
      if( num_iorbc .GT. MXTRSP ) then
         write(iout,'(//,A)') 'ERROR in SA_BCPREP:'
         write(iout,*) 'A parameter in the camx.prm is not ',
     &                                        'sufficiently large.'
         write(iout,*) 'Please change the value for parameter: MXTRSP'
         write(iout,*) 'It should be set to a value of at least: ',num_iorbc
         call flush(iout)
         call camxerr()
      endif
      allocate( spc_iorbc(num_iorbc) )
c
      if(INT(tim2) .EQ. 24) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
c
      write(infil,'(10a1)') (ifile(n),n=1,10)
      if( infil .NE. bcname ) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'BC input file is not labelled BOUNDARY'
        call camxerr()
      endif
c
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. begdate ) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC start date > simulation start date'
        write(iout,*)'  BC file: ',idat1
        write(iout,*)'Sim start: ',begdate
        call camxerr()
      elseif( idat1 .EQ. begdate .AND. tim1 .gt. begtim) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC start time > simulation start time'
        write(iout,*)'  BC file: ',tim1
        write(iout,*)'Sim start: ',begtim
        call camxerr()
      elseif( idat2 .LT. enddate) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC end date < simulation end date'
        write(iout,*)'BC file: ',idat2
        write(iout,*)'Sim end: ',enddate
        call camxerr()
      elseif( idat2 .EQ. enddate .AND. tim2 .lt. endtim) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC end time < simulation end time'
        write(iout,*)'BC file: ',tim2
        write(iout,*)'Sim end: ',endtim
        call camxerr()
      endif
c
c-----Read 2nd BC header record and check inputs
c
      read(iorbc) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if(.NOT. llatlon ) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if( ABS(dx-delx) .GT. 0.001 .OR. ABS(dy-dely) .GT. 0.001 ) then
        write(iout,'(//,a)') 'WARNING in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC cell size not equal to model cell size'
        write(iout,'(a,2f10.4)')'  BC file: ',dx,dy
        write(iout,'(a,2f10.4)')'    model: ',delx,dely
        write(iout,*)
      elseif( nx .NE. ncol(1) .OR. ny .NE. nrow(1) .OR. nz .NE. nlay(1) ) then
        write(iout,'(//,a)') 'ERROR in SA_BCPREP:'
        write(iout,*)'Source Apportionment BC grid size not equal to model grid size'
        write(iout,*)'BC file: ',nx,ny,nz
        write(iout,*)'  model: ',ncol(1),nrow(1),nlay(1)
        write(iout,*)
        call camxerr()
      endif 
c
c-----Read 3rd & 4th BC header 
c
      ncls_iorbc = 0
      read(iorbc)
      read(iorbc) ((bcspec(n,l),n=1,10),l=1,num_iorbc)
      write(first_class,'(3A1)') (bcspec(n,1),n=1,3)
      do l=1,num_iorbc
        write(spc_iorbc(l),'(10A1)') (bcspec(n,l),n=1,10)
        if( spc_iorbc(l)(1:3) .EQ. first_class ) ncls_iorbc = ncls_iorbc + 1
      enddo
c
      return
      end

      subroutine cncprep(endtim,enddate,lfirst)
      use camxcom
      use camxfld
      use filunit
      use grid
      use chmstry
      use ncf_iomod
c 
c----CAMx v7.40 260801
c 
c     CNCPREP reads the AIRQUALITY or INSTANT file header (depending on
c     whether this is a restart or not) and maps file species names to
c     the internal CAMx species list. The routine then writes headers
c     to new AVERAGE files
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        1/20/99   Grid cell size on file should be meters for all cartesian
c                  projections (UTM, LCP, PSP)
c        10/24/01  Removed BSWAP and converted integer strings to character*4
c        10/31/01  Added logic to ensure that a cold start reads an AIRQUALITY
c                  file and a restart reads an INSTANT file
c        11/06/01  Input dates are now Julian
c        8/25/06   Average output files now all UAM format, one file per grid
c        11/16/06  Now rewinds the files before writing the header
c        01/04/11  Revised for new header format
c 
c     Input arguments: 
c        endtim  - model end time (HHMM)
c        enddate - model end date (YYJJJ)
c        lfirst  - .TRUE. if this is the first time this routine is called
c             
c     Output arguments: 
c        none
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        STARTUP 
c
      implicit none
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
c
      integer enddate
      real endtim
      logical lfirst
c
      character*200 action
      character*20 spec_units(MXSPEC)
      character*20 spec_long_name(MXSPEC)
      character*60 spec_desc(MXSPEC)
      character*60 spec_coords(MXSPEC)
      character*4 ifile(10),note(60)
      character*4 icspec(10,MXSPEC)
      character*10 aqfil,infil,cnfil,avfil,icspc
      integer izero,ione,iunit,iseg,idat1,idat2,iutm,
     &        nx,ny,nz,iproj,idum,i,j,n,l,lic,nlayer,num_dims
      real zero,tim1,tim2,plon,plat,orgx,orgy,dx,dy,t1,t2,
     &     dxf,dyf,orgxf,orgyf
c
      integer isoa
c
      data aqfil /'AIRQUALITY'/
      data cnfil /'INSTANT   '/
      data avfil /'AVERAGE   '/
      data izero,ione /0,1/
      data zero /0./
c
      integer istrln   !--- external function
c
c-----Entry point
c
      lairqul = .false.
      iunit = iic
      if (lrstrt) iunit = irstc
c
c-----Read 1st IC header record and check inputs
c
      read(iunit,ERR=7000,END=7000) ifile,note,iseg,nicspc,idat1,
     &                                             tim1,idat2,tim2
      if (INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      write(infil,'(10a1)') (ifile(n),n=1,10)
      if (.not.lrstrt .and. infil.ne.aqfil) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,*)'This is a cold start from Initial Conditions'
        write(iout,*)'IC input file is not labelled AIRQUALITY'
        call camxerr()
      endif
      if (lrstrt .and. infil.ne.cnfil) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,*)'This is a restart from a Restart File'
        write(iout,*)'IC input file is not labelled INSTANT'
        call camxerr()
      endif
      if (infil.eq.aqfil) lairqul = .true.
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if (idat1.gt.begdate) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,*)'IC start date > simulation start date'
        write(iout,*)'  IC file: ',idat1
        write(iout,*)'Sim start: ',begdate
        call camxerr()
      elseif (idat1.eq.begdate .and. tim1.gt.begtim) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,*)'IC start time > simulation start time'
        write(iout,*)'  IC file: ',tim1
        write(iout,*)'Sim start: ',begtim
        call camxerr()
      endif
c
c-----Read 2nd IC header record and check inputs
c
      read(iunit,ERR=7001) plon,plat,iutm,orgx,orgy,dx,dy,nx,ny,nz,
     &                     iproj,idum,t1,t2
      if (.NOT.llatlon) then
        orgx = orgx/1000.
        orgy = orgy/1000.
        dx = dx/1000.
        dy = dy/1000.
      endif
      if (abs(orgx-xorg).gt.0.001 .or. abs(orgy-yorg).gt.0.001) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,'(a)') 'Reading IC/Restart file'
        write(iout,*)'Met origin not equal to model origin'
        write(iout,'(a,2f12.4)')'  IC file: ',orgx,orgy
        write(iout,'(a,2f12.4)')'    Model: ',xorg,yorg
        write(iout,*)
        call camxerr()
      endif
      if (abs(dx-delx).gt.0.001 .or. abs(dy-dely).gt.0.001) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,'(a)') 'Reading IC/Restart file'
        write(iout,*)'IC cell size not equal to model cell size'
        write(iout,'(a,2f10.4)')'  IC file: ',dx,dy
        write(iout,'(a,2f10.4)')'    model: ',delx,dely
        write(iout,*)
        call camxerr()
      elseif (nx.ne.ncol(1) .or. ny.ne.nrow(1) 
     &                          .or. nz.ne.nlay(1)) then
        write(iout,'(//,a)') 'ERROR in CNCPREP:'
        write(iout,'(a)') 'Reading IC/Restart file'
        write(iout,*)'IC grid size not equal to model grid size'
        write(iout,*)'IC file: ',nx,ny,nz
        write(iout,*)'  model: ',ncol(1),nrow(1),nlay(1)
        write(iout,*)
        call camxerr()
      endif 
c
c-----Read 3rd & 4th IC header 
c
      read(iunit,ERR=7001) 
      read(iunit,ERR=7001) ((icspec(n,l),n=1,10),l=1,nicspc)
c
c-----Map IC species to model species
c
      do 20 l = 1,nspec
        licmap(l) = 0
        do 15 lic = 1,nicspc
          write(icspc,'(10a1)') (icspec(n,lic),n=1,10)
          if (icspc(1:5) .EQ. 'HNO2 ') icspc = 'HONO      '
          if (icspc(1:5) .EQ. 'HCHO ' .AND. kHCHO .EQ. nspec+1) 
     &                                              icspc = 'FORM      '
          if( icspc(1:4) .EQ. 'POA ' ) icspc = 'HOA       '
          do isoa=1,NUM_SOAP_SPECIES
             if( icspc .EQ. soap2_spec_names(isoa) ) 
     &                           icspc = soap3_spec_names(isoa)
          enddo
          if (icspc.eq.spname(l) ) then
            licmap(l) = lic
            write(idiag,'(2(a,i5,2x,a))')
     &                   'Initial species ',lic,icspc,
     &                   ' mapped to model species ',l,spname(l)
            goto 20
          endif
 15     continue
        write(idiag,*)'Did not find species: ',spname(l),' on IC file'
        if (.not.lairqul) then
          write(iout,'(//,a)') 'ERROR in CNCPREP:'
          write(iout,*)'The INSTANT file must contain the same ',
     &                 'species as specified in the CHEMPARAM file'
          call camxerr()
        endif
 20   continue
      write(idiag,*)
c
c-----Write average output concentration file headers
c
      idat1 = begdate
      idat2 = enddate
      tim1 = begtim/100.
      tim2 = endtim/100.
      iutm = iuzon
      plon = polelon
      plat = polelat
      t1   = tlat1
      t2   = tlat2
      if (llatlon) then
        iproj = 0
        orgx = xorg
        orgy = yorg
        dx = delx
        dy = dely
      else
        orgx = 1000.*xorg
        orgy = 1000.*yorg
        dx = 1000.*delx
        dy = 1000.*dely
        if (lutm) then
          iproj = 1
        elseif (lambrt) then
          iproj = 2
        elseif (lrpolar) then
          iproj = 3
        elseif (lpolar) then
          iproj = 4
        elseif (lmerc) then
          iproj = 5
        endif
      endif
      read(runmsg(1:60),'(60a1)') (note(n),n=1,60)
      read(avfil,'(10a1)') (ifile(n),n=1,10)
      do l = 1,navspc
        if(lavmap(l) .GT. 0 ) then 
          read(spname(lavmap(l)),'(10a1)') (icspec(n,l),n=1,10)
          spavnam(l) = spname(lavmap(l))
        endif
      enddo
      if( l3davg(1) ) then
        nlayer = nlay(1)
        num_dims = 4
      else
        nlayer = 1 
        num_dims = 4
      endif
c
c-----Master grid average header
c
      if( lcdfout .AND. lfirst ) then
          call ncf_set_vars_base()
          call ncf_set_tstep(begdate,begtim,enddate,endtim)
      endif
      if( .NOT. lcdfout) then
          rewind(iavg(1))
          write(iavg(1)) ifile,note,itzon,navspc,idat1,tim1,idat2,tim2
          write(iavg(1)) plon,plat,iutm,orgx,orgy,dx,dy,nx,ny,nlayer,
     &                                       iproj,izero,t1,t2,zero
          write(iavg(1)) ione,ione,nx,ny
          write(iavg(1)) ((icspec(n,l),n=1,10),l=1,navspc)
      else if( lcdfout .AND. lfirst ) then
          action = 'Writing master grid output average file.'
          call ncf_set_specatt_avrg(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
          call ncf_set_global('AVERAGE   ',1,begdate,begtim,enddate,endtim,
     &                                                       nlayer,navspc)
          call ncf_wrt_dim(action,iavg(1),1,ncol(1),nrow(1),nlayer,navspc)
          call ncf_wrt_global(action,iavg(1),navspc,spavnam,.FALSE.)
          call ncf_wrt_vars_base(action,iavg(1))
          call ncf_wrt_vars_species(action,iavg(1),ncol(1),nrow(1),nlayer,
     &                              navspc,spavnam,spec_units,spec_long_name,
     &                                        spec_desc,spec_coords,num_dims)
          call ncf_enddef_file(action,iavg(1))
          call ncf_wrt_data_grid(action,iavg(1),1,ncol(1),nrow(1),
     &                           orgx,orgy,dx,dy,nlayer,cellat(iptr2d(1)),
     &                                   cellon(iptr2d(1)),topo(iptr2d(1)))
      endif
      if( ngrid .EQ. 1 ) goto 9999
c
c-----Fine grid average headers
c
      do i = 2,ngrid 
        dxf   = dx/float(meshold(i))
        dyf   = dy/float(meshold(i))
        orgxf = orgx + dx*(inst1(i)-1)
        orgyf = orgy + dy*(jnst1(i)-1)
        if( l3davg(i) ) then
          nlayer = nlay(i)
        else
          nlayer = 1
        endif
        if( .NOT. lcdfout ) then
           rewind(iavg(i))
           write(iavg(i)) ifile,note,itzon,navspc,idat1,tim1,idat2,tim2
           write(iavg(i)) plon,plat,iutm,orgxf,orgyf,dxf,dyf,ncol(i)-2,
     &                       nrow(i)-2,nlayer,iproj,izero,t1,t2,zero
           write(iavg(i)) ione,ione,ncol(i)-2,nrow(i)-2
           write(iavg(i)) ((icspec(n,l),n=1,10),l=1,navspc)
        else if( lcdfout .AND. lfirst ) then
          write(action,'(A,I2)') 'Writing output average file for grid: ',i
          call ncf_set_specatt_avrg(spec_units,spec_long_name,spec_desc,
     &                                                        spec_coords)
          call ncf_set_global('AVERAGE   ',i,begdate,begtim,enddate,endtim,
     &                                                      nlayer,navspc)
          call ncf_wrt_dim(action,iavg(i),i,ncol(i),nrow(i),nlayer,navspc)
          call ncf_wrt_global(action,iavg(i),navspc,spavnam,.FALSE.)
          call ncf_wrt_vars_base(action,iavg(i))
          call ncf_wrt_vars_species(action,iavg(i),ncol(i),nrow(i),nlayer,
     &                            navspc,spavnam,spec_units,spec_long_name,
     &                                       spec_desc,spec_coords,num_dims)
          call ncf_enddef_file(action,iavg(i))
          call ncf_wrt_data_grid(action,iavg(i),i,ncol(i),nrow(i),
     &                           orgxf,orgyf,dxf,dyf,nlayer,cellat(iptr2d(i)),
     &                                  cellon(iptr2d(i)),topo(iptr2d(i)))
        endif
      enddo 
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in CNCPREP:'
      write(iout,'(A)',ERR=9999)'Reading restart file for coarse grid.'
      write(iout,'(2A)',ERR=9999)'Make sure the filename is specified ',
     &          'correctly and the previous day finished correctly.'
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in CNCPREP:'
      write(iout,'(2A)',ERR=9999)'Reading the header of restart file ',
     &                                  'for coarse grid.'      
      call camxerr()
c
 9999 continue
      lfirst = .FALSE.
      return
      end

C**** NCF_READPT
c
      subroutine ncf_readpt(ifile,iunit,numpts,numspcs,pntems)
      use chmstry
      use camxcom
      use filunit
      use ptemiss
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_READPT reads the NetCDF pint source emissions file 
c     loads the data into global arrays for emissions injection.
c
c      Copyright Ramboll
c
c     Input arguments:
c        ifile               index of file in list for this grid
c        iunit               file unit for area emissions file
c        numpnts             total number of point sources
c        numspcs             number of emissions species
c
c     Output arguments:
c        pntems              point source emissions rate (mole/s)
c
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson-- Original development
c     11/21/25   --gwilson-- Changed the way lemmap works - it now points the other direction
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'vbs.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer ifile 
      integer iunit
      integer numpts
      integer numspcs
      real    pntems(numpts,numspcs)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*16  this_var
      integer       this_tstep, ierr, ispc, ipt, ibin, ipoa
      integer       idx_start, this_time_tflag, this_time_etflag
      integer       this_varid, data_start(2), data_count(2)
      integer       idx_poa(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB)
      integer       iemspec
      real          pi
      logical       lfound_poa(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB)
c
      real, allocatable, dimension(:) ::  emispts
      real, allocatable, dimension(:) ::  plume_bot
      real, allocatable, dimension(:) ::  plume_top
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data pi /3.1415927/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      idx_poa = -9
      if( luse_soap3 ) then
         do ipoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
            lfound_poa(ipoa) = .FALSE.
            do ispc = 1,nemspc
               if( emspcname(ispc) .EQ. soap_emiss_names(ipoa) )
     &                                       idx_poa(ipoa) = ispc
            enddo
         enddo
      endif
c
      if( .NOT. is_netcdf_iptem(ifile) ) goto 9999
      write(action,'(2A,I3)') 'Reading the NetCDF point source',
     &                               ' emissions file. File: ',ifile
      idx_start = idx_start_pts(ifile)
c
c  ---- allocate the temporary array ---
c
      allocate( emispts(nptsrc_files(ifile)) )
      allocate( plume_bot(nptsrc_files(ifile)) )
      allocate( plume_top(nptsrc_files(ifile)) )
      emispts = 0.
      plume_bot = 0.
      plume_top = 0.
c
c  ---- get the index for timestep containing this time ----
c
      this_tstep = ncf_get_tstep(iunit,action,date,time,
     &               this_time_tflag,this_time_etflag,le1day,.TRUE.)
c
c   --- set the indexes for what to read ---
c
      data_start(1) = 1
      data_count(1) = nptsrc_files(ifile)
      data_start(2) = this_tstep
      data_count(2) = 1
c
      do ipt=1,nptsrc_files(ifile)
         effph(ipt+idx_start) = 0.
         flowrat(ipt+idx_start) = 0.
      enddo
c
c  ---- plumerise ---
c
      this_var = 'plumerise'
      ierr = nf_inq_varid(iunit, this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                  data_count,emispts)
          if( ierr .NE. NF_NOERR) goto 7001
c
c  --- Put the data into the global array ----
c
          do ipt=1,nptsrc_files(ifile)
             if( emispts(ipt) .GT. 0. ) effph(ipt+idx_start) = -emispts(ipt)
          enddo
      endif
c
c  ---- loop over the list of emissions spcies ---
c
      do iemspec=1,nemspc
          emispts = 0.
          if( lemmap(iemspec) .LE. 0 ) cycle
          ispc = iemspec
c
c  --- load data into temporary arrray ---
c
          this_var = emspcname(iemspec)
          ierr = nf_inq_varid(iunit, this_var, this_varid)
          if( ierr .NE. NF_NOERR) cycle
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                               data_count,emispts)
          if( ierr .NE. NF_NOERR) goto 7001
c
c--- if this is a POA_XX species set the flag for it ---
c
          do ipoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
            if( this_var .EQ. soap_emiss_names(ipoa) ) lfound_poa(ipoa) = .TRUE.
          enddo
c
c-----Put the data into the global array ----
c
          if( this_var(1:4) .EQ. 'POA ') ispc = idx_poa(IDX_SOAP_POA_AV)
          do ipt=1,nptsrc_files(ifile)
             pntems(idx_start+ipt,ispc) = 
     &          pntems(idx_start+ipt,ispc) + emispts(ipt)/(60.*dtems)
          enddo

c
c ---- next species ---
c
      enddo
c
c  ---- if doing SOAP3, loop over the list of SOAP emissions spcies ---
c
      do ispc=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
          if( lfound_poa(ispc) ) cycle
c
c  --- load data into temporary arrray ---
c
          this_var = soap_emiss_names(ispc)
          ierr = nf_inq_varid(iunit, this_var, this_varid)
          if( ierr .NE. NF_NOERR) cycle
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                               data_count,emispts)
          if( ierr .NE. NF_NOERR) goto 7001
          if( idx_poa(ispc) .LE. 0 ) cycle
c
c-----Put the data into the global array ----
c
          do ipt=1,nptsrc_files(ifile)
             pntems(idx_start+ipt,idx_poa(ispc)) = 
     &           pntems(idx_start+ipt,idx_poa(ispc)) + emispts(ipt)/(60.*dtems)
          enddo
c
c ---- next species ---
c
      enddo
c
c   --- get plume bottom, if available ---
c
      this_var = 'plume_bottom'
      ierr = nf_inq_varid(iunit, this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                  data_count,plume_bot)
          if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c   --- get plume top, if available ---
c
      this_var = 'plume_top'
      ierr = nf_inq_varid(iunit, this_var, this_varid)
      if( ierr .EQ. NF_NOERR) then
          ierr = nf_get_vara_real(iunit,this_varid,data_start,
     &                                  data_count,plume_top)
          if( ierr .NE. NF_NOERR) goto 7001
      endif
c
c  --- Put the data into the global array ----
c
      do ipt=1,nptsrc_files(ifile)
          if( plume_top(ipt) .GT. 0. ) then
             if( plume_bot(ipt) .GE. plume_top(ipt) ) goto 7002
             if( plume_bot(ipt) .LT. 0. ) goto 7002
             effph(ipt+idx_start) = -plume_bot(ipt)
             flowrat(ipt+idx_start) = -plume_top(ipt)
          endif
      enddo
c
c  ---- deallocate the temporary array ---
c
      deallocate( emispts )
      deallocate( plume_bot )
      deallocate( plume_top )
c
c  --- write message to out file ---
c
      write(iout,'(a35,i5,a,f7.0,i8.5)') 'Read point source file ',
     &                                         ifile,' at ',time,date
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_READPT: '
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_READPT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_READPT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Point source found with invalid plume ',
     &                                        'distribution values.'
      write(iout,'(A,I10)') 'Point source number in file: ',ipt
      write(iout,'(A,F10.4)') 'Plume bottom: ',plume_bot(ipt)
      write(iout,'(A,F10.4)') 'Plume top   : ',plume_top(ipt)
      call camxerr()
c
 9999 continue
      return
      end

      subroutine get_nptsrc_sa( )
      use tracer
      use chmstry
      use ptemiss
      implicit none
c 
c----CAMx v7.40 260801
c 
c     GET_NPTSRC_SA the elevated point source files 
c     for the source groups and calculates the total number in the inventory.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        PNTPREP
c 
      include 'camx.prm'
      include 'filunit.inc'
      include 'netcdf.inc'
c
c-----Local variables
c
      integer idxfile, ierr, this_dimid, irec, idum, igroup
c
c-----Entry point
c
c-----Loop over groups
c
      do igroup=1,ngroup
c
c-----All files in this group
c
         do idxfile=1,num_iortpt(igroup)
           if( .NOT. ltptfl(igroup,idxfile) ) cycle
c
c-----this file is old style binary ---
c
           if( .NOT. is_netcdf_iortpt(igroup,idxfile) ) then
              do irec=1,4
                 read(iortpt(igroup,idxfile))
              enddo
              read(iortpt(igroup,idxfile)) idum,nptsrc_safile(igroup,idxfile)
              nptsrc = nptsrc + nptsrc_safile(igroup,idxfile)
c
c-----this file is NetCDF format ---
c
           else
              ierr = nf_inq_dimid(iortpt(igroup,idxfile), "COL", this_dimid )
              if( ierr .NE. NF_NOERR ) goto 7000
              ierr = nf_inq_dimlen(iortpt(igroup,idxfile),this_dimid,
     &                                    nptsrc_safile(igroup,idxfile))
              if( ierr .NE. NF_NOERR ) goto 7000
              nptsrc = nptsrc + nptsrc_safile(igroup,idxfile)
           endif
         enddo
      enddo
c
      goto 9999
c
c---- error messages
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in GET_NPTSRC'
      write(iout,'(A,I3)') 'Reading the NetCDF elevated point source file:',idxfile
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
      return
      end

c*** AVGWAL
c
      subroutine avgwal(igrd,numcol,numrow,numlay,nrows,
     &                  ioff,joff,nspsa,dtime,deltax,deltay,depth,mapscl,
     &                  tempk,press,saconc)
      use bndary
      use camxcom
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine calculates the average concentrations for the
c     WALL OF CELLS types of receptors.  It is not called unless
c     at least one receptor of this type is specified.  The average
c     is taken over all cells in the wall (including layers).  The 
c     concentraions in each cell are weighted by cell volume.
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c         igrd   I  grid number
c         numrow I  number of X cells in grid for this slice
c         numcol I  number of Y cells in grid for this slice
c         numlay I  number of layers for this slice
c         nrows  I  number of rows in entire grid
c         ioff   I  offset of slice in entire grid in X direction
c         joff   I  offset of slice in entire grid in Y direction
c         nspsa  I  number of tracer species
c         dtime  R  time step for present concs
c         deltax R  cell width in X direction        
c         deltay R  cell width in Y direction        
c         depth  R  layer depths
c         mapscl R  map scale factor
c         tempk  R  temperature
c         press  R  pressure
c         saconc R  tracer concentrations 
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     1.  Fixed bug by eliminating unused argument (avtime)
c     2.  Added grid number to recptors defined by cell index
c     3.  Fixed bug in calculating the timing weight factor
c     4.  Added map scale factor (08/02/2007)
c         Removed model spc conc (08/02/2007)
c     5.  Fixed bug that was applying gas conversion factor to
c         all tracer species.
c     6.  Fixed for MPI
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer   igrd
      integer   numcol
      integer   numrow
      integer   numlay
      integer   ncols
      integer   nrows
      integer   nlays
      integer   ioff
      integer   joff
      integer   nspsa
      real      dtime
      real      deltax(nrows)
      real      deltay
      real      depth(numcol,numrow,numlay)
      real      mapscl(numcol,numrow)
      real      tempk(numcol,numrow,numlay)
      real      press(numcol,numrow,numlay)
      real      saconc(numcol,numrow,numlay,nspsa)
c
c----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer icl, jcl, kcl, ircp, ispc
      real    volume, volsum
      real    cncnow, cnvfac, timewt
c
      real sasum(MXTRSP)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- if no receptor file is provided, just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
c  --- calculte the time average weighting for running average
c
      timewt = (dtime / dtout) / 60.
c
c  --- loop over all receptors ---
c
      do 10 ircp=1,nrecep
c
c  --- if receptor is not a WALL OF CELLS type, skip it ---
c
          if( idrcp(ircp) .NE. IDWAL ) goto 10
c
c   --- skip if receptor grid is not this grid ---
c
          if( igrdrcp(ircp) .NE. igrd ) goto 10
c
c  --- initialize the sums to zero ---
c
          volsum = 0.
          volrcp(ircp) = 0.
          do ispc=1,nspsa
             sasum(ispc) = 0.
          enddo
c
c  --- loop over layers ---
c
          do kcl=kwalbg(ircp),kwalnd(ircp)
c
c  ---- loop over all cells ---
c
              do jcl=jwalbg(ircp),jwalnd(ircp)
                 do 20 icl=iwalbg(ircp),iwalnd(ircp)
c
c  --- slip the boundary cells ---
c
                    if( icl-ioff .LT. ia .OR. icl-ioff .GT. iz ) goto 20
                    if( jcl-joff .LT. ja .OR. jcl-joff .GT. jz ) goto 20
c
c  ---- calculate the total volume for this cell and the 
c       conversion factor to ppm ---
c
                    volume = deltax(jcl) * deltay * depth(icl-ioff,jcl-joff,kcl)
     &                                        / (mapscl(icl-ioff,jcl-joff)**2)
                    volsum = volsum + volume
                    volrcp(ircp) = volrcp(ircp) + volume
c
c   --- loop over tracer species --
c
                    do ispc=1,nspsa
                       cnvfac = 1.0
                       if( .NOT. lgas_out_ppm .AND. lsagas(ispc) ) convfac = sa_mole_weight(ispc)
                       if( lsagas(ispc) .AND. lgas_out_ppm ) cnvfac = 
     &                     densfac*( 273./tempk(icl-ioff,jcl-joff,kcl)*
     &                                    press(icl-ioff,jcl-joff,kcl)/1013) 
                       sasum(ispc) = sasum(ispc) + volume * 
     &                           saconc(icl-ioff,jcl-joff,kcl,ispc) / cnvfac
                    enddo
c
c   --- next cell ---
c
   20            continue
              enddo
c
c   --- next layer ---
c
          enddo
c
c  ---- add concs to the running average ---
c
          do ispc=1,nspsa
              cncnow = 0.
              if( .NOT. lmpi ) then
                 if( volsum .GT. 0. ) cncnow = sasum(ispc) / volsum
                 conrcp(ispc,ircp) = cncnow * timewt + conrcp(ispc,ircp)
              else
                 conrcp(ispc,ircp) = sasum(ispc) * timewt + conrcp(ispc,ircp)
              endif
          enddo
c
c  --- next receptor ----
c
   10 continue
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine nesting(numprocs,iproc_id,lupdtdep,nsteps)
      use grid
      use grid_nodes
      use camxcom
      use camxfld
      use tracer
      use procan
c
c----CAMx v7.40 260801
c
c     NESTING is the driver for grid nesting algorithm.  It does the 
c     following tasks in a recursive order:
c       1. determines boundary conditions for children grids
c       2. calls EMISTRNS for each grid
c       3. call PIGEVOL for each grid
c       4. calls CHEMRXN for each grid 
c       5. aggregates concentrations on children grids to parent grid
c     Chemistry and transport are performed for each grid on their own
c     time step. Up to 4 generations of grid nesting are currently allowed.
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        10/12/04     New routine PIGEVOL added for PiG growth/chemistry
c
c     Input arguments:
c        numprocs    number of processors
c        iproc_id    process ID for this processor
c        lupdtdep    flag to determine if dep date should be updated
c        nsteps      number of steps at this time in the simulation
c
c     Output arguments:
c        none
c
c     Subroutines Called:
c        SETBC
c        EMISTRNS
c        PIGEVOL
c        CHEMRXN
c        AGGR00
c        FGAVRG
c        CHRTIME
c
c     Called by:
c        CAMx
c
      include "camx.prm"
      include "flags.inc"
c
      integer     numprocs, iproc_id, nsteps
      logical     lupdtdep(*)
      character*8 chtime, chdate
c
      integer iparnt(20),igrd0(20)
c
c-----Entry point
c
c-----Computation for children grids
c
      do igen=1,20
        iparnt(igen)=0
        igrd0(igen)=0
      enddo
c
c-----Generation 2
c
      igen=1
      iparnt(igen+1)=1
      if( lmpi .AND. iproc_id .GT. 0 ) then
        do ngr=1,nchdrn(iparnt(igen+1))
          call node_send_nbc(idchdrn(ngr,iparnt(igen+1)),
     &                                   iparnt(igen+1))
          call node_get_nbc (idchdrn(ngr,iparnt(igen+1)),
     &                                   iparnt(igen+1))
          if( ltrace .OR. lddm .OR. lhddm ) then
              call node_send_nbc_pt(idchdrn(ngr,iparnt(igen+1)),
     &                                          iparnt(igen+1))
              call node_get_nbc_pt (idchdrn(ngr,iparnt(igen+1)),
     &                                          iparnt(igen+1))
          endif
        enddo
      else if (.not. lmpi) then
        call setbc(iparnt(igen+1))
      endif
      mch2=nchdrn(iparnt(igen+1))
      do 100 ic2=1,mch2
          igen=2
          igrd0(igen)=idchdrn(ic2,iparnt(igen))
          igrd = igrd0(igen)
          call newgrid(igrd)
c
c-----Perform emissions and transport for generation 2
c
          do 99 it2=1,ntim(igrd)
            if( .NOT. lmpi .OR. iproc_id .GT. 0 ) 
     &                              call fgavrg(iproc_id,igrd,nsteps,0.)
            call chrtime(timec(igrd),datec(igrd),chtime,chdate)
            call emistrns(igrd,chtime,chdate,numprocs,
     &                                     iproc_id,lupdtdep(igrd))
c
c-----Generation 3
c
            iparnt(igen+1)=igrd0(igen)
            if( lmpi .AND. iproc_id .GT. 0 ) then
              do ngr=1,nchdrn(iparnt(igen+1))
                 call node_send_nbc(idchdrn(ngr,iparnt(igen+1)),
     &                                         iparnt(igen+1))
                 call node_get_nbc (idchdrn(ngr,iparnt(igen+1)),
     &                                         iparnt(igen+1))
                 if( ltrace .OR. lddm .OR. lhddm ) then
                   call node_send_nbc_pt(idchdrn(ngr,iparnt(igen+1)),
     &                                                 iparnt(igen+1))
                   call node_get_nbc_pt(idchdrn(ngr,iparnt(igen+1)),
     &                                                  iparnt(igen+1))
                 endif
              enddo
            else if (.not. lmpi) then
              call setbc(iparnt(igen+1))
            endif
            mch3=nchdrn(iparnt(igen+1))
            do 90 ic3=1,mch3
              igen=3
              igrd0(igen)=idchdrn(ic3,iparnt(igen))
              igrd = igrd0(igen)
              call newgrid(igrd)
c
c-----Perform emissions and transport for generation 3
c
              do 89 it3=1,ntim(igrd)
                if( .NOT. lmpi .OR. iproc_id .GT. 0 ) 
     &                              call fgavrg(iproc_id,igrd,nsteps,0.)
                call chrtime(timec(igrd),datec(igrd),
     &                     chtime,chdate)
                call emistrns(igrd,chtime,chdate,numprocs,
     &                                         iproc_id,lupdtdep(igrd))
c
c-----Generation 4
c
                iparnt(igen+1)=igrd0(igen)
                if( lmpi .AND. iproc_id .GT. 0 ) then
                  do ngr=1,nchdrn(iparnt(igen+1))
                    call node_send_nbc(idchdrn(ngr,iparnt(igen+1)),
     &                                         iparnt(igen+1))
                    call node_get_nbc (idchdrn(ngr,iparnt(igen+1)),
     &                                         iparnt(igen+1))
                     if( ltrace .OR. lddm .OR. lhddm ) then
                         call node_send_nbc_pt(
     &                      idchdrn(ngr,iparnt(igen+1)),iparnt(igen+1))
                         call node_get_nbc_pt(
     &                      idchdrn(ngr,iparnt(igen+1)),iparnt(igen+1))
                     endif
                  enddo
                else if (.not. lmpi) then
                  call setbc(iparnt(igen+1))
                endif
                mch4=nchdrn(iparnt(igen+1))
                do 80 ic4=1,mch4
                  igen=4
                  igrd0(igen)=idchdrn(ic4,iparnt(igen))
                  igrd = igrd0(igen)
                  call newgrid(igrd)
c
c-----Perform emissions and transport for generation 4
c
                  do 79 it4=1,ntim(igrd)
                    if( .NOT. lmpi .OR. iproc_id .GT. 0 ) 
     &                              call fgavrg(iproc_id,igrd,nsteps,0.)
                    call chrtime(timec(igrd),datec(igrd),
     &                                              chtime,chdate)
                    call emistrns(igrd,chtime,chdate,numprocs,
     &                                     iproc_id,lupdtdep(igrd))
c
c-----Generation X: more generations would be added here
c
c-----Perform chemistry for generation 4
c
                    igen=4
                    igrd = igrd0(igen)
                    call newgrid(igrd)
                    call uptime(timec(igrd),datec(igrd),deltat(igrd))
                    if( ipigflg .NE. 0 .AND. (.NOT. lmpi 
     &                                  .OR. iproc_id .GT. 0) ) 
     &                                       call pigevol(igrd,iproc_id)
                    if( ipigflg .NE. 0 .AND. lmpi ) then
                         call nodes_pig_pass(igrd,numprocs,iproc_id)
                    endif 
                    if( .NOT. lmpi .OR. iproc_id .GT. 0 ) then
                       call chemrxn(igrd,iproc_id)
                       call fgavrg(iproc_id,igrd,nsteps,2.)
                    endif
  79              continue
                  icode = 3
                  if (mch4.eq.1) then
                    icode = 0
                  elseif (ic4.eq.1) then
                    icode = 1
                  elseif (ic4.eq.mch4) then
                    icode = 2
                  endif
                  if( lmpi .AND. iproc_id .GT. 0 ) then
                    call mpi_feedback(igrd0(igen),iparnt(igen),icode)
                  else if( .NOT. lmpi) then
                    call aggr00(igrd0(igen),iparnt(igen),icode)
                  endif
c
  80            continue
c
c-----Perform chemistry for generation 3
c
                igen=3
                igrd = igrd0(igen)
                call newgrid(igrd)
                call uptime(timec(igrd),datec(igrd),deltat(igrd))
                if( ipigflg .NE. 0 .AND. (.NOT. lmpi 
     &                                  .OR. iproc_id .GT. 0) ) 
     &                                       call pigevol(igrd,iproc_id)
                if( ipigflg .NE. 0 .AND. lmpi ) then
                     call nodes_pig_pass(igrd,numprocs,iproc_id)
                endif 
                if( .NOT. lmpi .OR. iproc_id .GT. 0 ) then
                   call chemrxn(igrd,iproc_id)
                   call fgavrg(iproc_id,igrd,nsteps,2.)
                endif
  89          continue
              icode = 3
              if (mch3.eq.1) then
                icode = 0
              elseif (ic3.eq.1) then
                icode = 1
              elseif (ic3.eq.mch3) then
                icode = 2
              endif
              if( lmpi .AND. iproc_id .GT. 0 ) then
                 call mpi_feedback(igrd0(igen),iparnt(igen),icode)
              else if( .NOT. lmpi) then
                 call aggr00(igrd0(igen),iparnt(igen),icode)
              endif
c
  90        continue
c
c-----Perform chemistry for generation 2
c
            igen=2
            igrd = igrd0(igen)
            call newgrid(igrd)
            call uptime(timec(igrd),datec(igrd),deltat(igrd))
            if( ipigflg .NE. 0 .AND. (.NOT. lmpi .OR. iproc_id .GT. 0) ) 
     &                                       call pigevol(igrd,iproc_id)
            if (ipigflg .NE. 0 .AND. lmpi) then
                 call nodes_pig_pass(igrd,numprocs,iproc_id)
            endif 
            if( .NOT. lmpi .OR. iproc_id .GT. 0 ) then
               call chemrxn(igrd,iproc_id)
               call fgavrg(iproc_id,igrd,nsteps,2.)
            endif
  99      continue
          icode = 3
          if (mch2.eq.1) then
            icode = 0
          elseif (ic2.eq.1) then
            icode = 1
          elseif (ic2.eq.mch2) then
            icode = 2
          endif
          if( lmpi .AND. iproc_id .GT. 0 ) then
             call mpi_feedback(igrd0(igen),iparnt(igen),icode)
          else if( .NOT. lmpi) then
             call aggr00(igrd0(igen),iparnt(igen),icode)
          endif
c
 100  continue
c
      call newgrid(1)
c
      return
      end

c**** RDRCPRT
c
      subroutine rdrcprt()
      use filunit
      use grid
      use procan
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads the receptor definition file and stores all of
c   the receptor data in common arrays to be used by the RTRAC
c   version of the CAMx.
c
c      Copyright Ramboll
c
c     Argument description:
c      Inputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     05/27/96   --gwilson--    Original development
c     04/02/03   --gwilson--    Added grid number to recptors defined by
c                               cell index
c         
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 line
      character*15  rcptmp
      integer       irec, ierr, idtmp, icel, jcel, igrd, n2d
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- if there is no receptor file, just return ---
c
      if( .NOT. lrcpfil ) goto 9999
c
      irec = 0
      lwalls = .FALSE.
c
c  --- open the file ---
c
      open(unit=iorrcp,file=rcpfil,ERR=7000,status='UNKNOWN')
c
c  --- initialize the number of receptors ----
c
      nrcprt = 0
c
c  --- read the data as character strings since we don't know what
c      type of receptor it is ---
c
  111 continue
      irec = irec + 1
      read(iorrcp,'(A)',IOSTAT=ierr,END=222) line
      if( ierr .NE. 0 ) then
         write(iout,'(//,a)') 'ERROR in RDRCPRT:'
         write(iout,'(/,1X,A,A,I5)') 'Reading the receptor ',
     &                    'definition file for RTRAC at record: ',irec
         call camxerr()
      endif
c
c  ---- find out what kind of receptor is being provided ---
c
      rcptmp = line(1:15)
      if( rcptmp .EQ. CDCEL ) then
          idtmp = IDCEL 
      else
          write(iout,'(//,a)') 'ERROR in RDRCPRT:'
          write(iout,'(/,1X,A,A,A)') 'Invalid receptor ',
     &       'code found in RTRAC receptor definition file: ',idtmp
          write(iout,'(1X,A,A)') 'Line read: ',line
          write(iout,'(1X,A)') 'Code must be one of the following:'
          write(iout,'(10X,A)') CDCEL
          call camxerr()
      endif
c
c   --- if it is a SINGLE CELL type just read the cell indexes ---
c
      if( idtmp .EQ. IDCEL ) then
          read(line(31:60),'(3I10)',IOSTAT=ierr) igrd, icel, jcel
          if( ierr .NE. 0 ) then
             write(iout,'(//,a)') 'ERROR in RDRCPRT:'
             write(iout,'(/,1X,A,A,A)') 'Reading cell indexes ',
     &                      'from receptor definition file.  Line read:'
             write(iout,'(A)') line(:istrln(line))
             call camxerr()
          endif
c
c  --- check for validity of receptor ---
c
          if( igrd .LT. 0 .OR. igrd .GT. ngrid ) then
             write(iout,'(//,A)') 'ERROR in RDRCPRT:'
             write(iout,'(1X,2A)') 
     &          'Invalid grid index specified in receptor definition.',
     &                                                  '  Line read: '
             write(iout,'(A)') line(:istrln(line))
          endif
          if( icel .LE. 0 .OR. icel .GT. ncol(igrd) .OR. 
     &                    jcel .LE. 0 .OR. jcel .GT. nrow(igrd) ) then
             write(iout,'(//,a)') 'ERROR in RDRCPRT:'
             write(iout,'(1X,A)') 
     &          'Invalid cell index specified in receptor definition.'
             write(iout,'(1X,2A)') 'Cell is outside specified domain. ',
     &                                                    'Line read: '
             write(iout,'(A)') line(:istrln(line))
          endif
          n2d = icel + (jcel-1)*ncol(igrd)
          if( idfin( iptr2d(igrd)-1+n2d ) .GT. 0 ) then
             write(iout,'(//,a)') 'ERROR in RDRCPRT:'
             write(iout,'(1X,A)') 
     &          'Invalid cell index specified in receptor definition.'
             write(iout,'(1X,2A)')'Cell cannot be contained in a nest.',
     &                                                    'Line read: ' 
             write(iout,'(A)') line(:istrln(line))
          endif
c
c  --- cell is valid, fill array with entire column ---
c
          do k=1,nlay(igrd)
             nrcprt = nrcprt + 1
             if( nrcprt .GT. MXRTCEL ) then
                write(iout,'(//,a)') 'ERROR in RDRCPRT:'
                write(iout,'(/,1X,A,A,I5)') 'Number of receptors in ',
     &              'receptor definition file exceeds maximum: ',MXRTCEL
                write(iout,'(1X,2A)') 'Note that each specified ',
     &                'receptor represents an entire column of cells.'
                write(iout,'(1X,A)') 'Increase the paramater MXRTCEL.'
                call camxerr()
             endif
             n3d = icel + ncol(igrd)*(jcel-1) + 
     &                               ncol(igrd)*nrow(igrd)*(k-1)
             ipacl_3d ( iptr3d(igrd)-1+n3d ) = nrcprt
             idomrt(nrcprt) = igrd
             ircprt(nrcprt) = icel
             jrcprt(nrcprt) = jcel
             krcprt(nrcprt) = k
          enddo
      endif
c      
c  --- get next record ---
c
      goto 111
c      
c  --- close file and return to calling routine ---
c
  222 continue
      close(iorrcp)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in RDRCPRT:'
      write(iout,'(/,1X,2A)') 'Cannot open input file: ',
     &                                         rcpfil(:istrln(rcpfil))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c*** READARSA.F
c
      subroutine readarsa(igrid,idate,btim,nox,noy,nlay_ems,
     &                                            nspsa,dx,dy,emisar)
      use filunit
      use grid
      use bndary
      use camxcom
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads one hour of emissions from each of the surface
c   emissions files and calculates the NOx and VOC levels.  It then
c   places these emissions in the appropriate place in the gridded
c   array used for tracer emissions.  The tracer to which the NOx and
c   VOC emissions is assigned depends on the source group and the
c   source region.
c
c      Copyright Ramboll
c
c     Argument declarations:
c        Outputs:
c          emisar    R  array to store the tracer emissions
c        Inputs:
c          igrid     I  grid number for this grid
c          idate     I  date of current hour (YYJJJ)
c          btim      R  time of current hour
c          nox       I  number of X cells in grid
c          noy       I  number of Y cells in grid
c          nlays_ems I  number of layers in emissions files
c          nspsa     I  number of Y cells in grid
c          dx        R  cell width in X direction
c          dy        R  cell width in Y direction
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     06/06/96   --gwilson--    Original development
c     01/09/97   --gwilson--    Fixed a bug in fineding the source
c                               region in the fine grid
c     01/12/97   --gwilson--    Now checks for negative emissions in
c                               leftover group and exits if found
c     02/01/97   --gwilson--    Put fuzz factor of 0.1 ppb to determine
c                               if emissions are truly negative.
c     02/03/97   --gwilson--    Put code to ignore emissions in the
c     11/06/01   --cemery--     Input dates are now Julian
c     07/19/02   --gwilson--    Seperate source area map for each grids
c     12/04/02   --gyarwood--   Improved message for negative leftover
c     03/01/16   --gwilson--    Added partial source area map
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   igrid
      integer   idate
      real      btim
      integer   nox
      integer   noy
      integer   nlay_ems
      integer   nspsa
      real*4    dx(noy)
      real*4    dy
      real      emisar(nox,noy,nlay_ems,nspsa)
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c   FUZZ  R  fuzz factor used to determine if emissions are truly < 0.
c
      real   FUZZ
c
      parameter( FUZZ = -0.0001 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer      ndate, imap, itim, ipart, isoa
      integer      i, j, k, l
      real         ttime, frac
c
      real, allocatable, dimension(:,:,:,:) :: lefcls
      real, allocatable, dimension(:,:,:,:) :: emscls
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- allocate the temporary space ---
c
      allocate( lefcls(soap3_ntrcls,nox,noy,nlay_ems) )
      allocate( emscls(soap3_ntrcls,nox,noy,nlay_ems) )
c
c   --- set the date and times ---
c
      ndate = idate
      ttime = btim/100.0
c
c   --- if up to time for releasing a new timing tracer, bump up
c       counter for number of tracer species ---
c
      if( igrid .EQ. 1 .AND. ntrtim .GT. 0 ) then
          if( MOD( INT(ttime), INT(24/ntrtim) ) .EQ. 0 ) then
              nreles = nreles + 1
              nsaspc = nsaspc + 2 * nregin
          endif
      endif
c
c   --- initialize emissions to zero ---
c
      emisar = 0.
c
c  --- for each group, call routine to read the emissions for
c      the group ----
c
      do igroup = 0,ngroup
         call rdargrp(igrid,ndate,ttime*100.,nox,noy,nlay_ems,
     &                                       soap3_ntrcls,igroup,emscls)
         call ncf_rdargrp(igrid,ndate,ttime*100,nox,noy,nlay_ems,
     &                                       soap3_ntrcls,igroup,emscls)
c
c  ---  if doing source groups calculate the left-over and put emissions 
c       into proper place in the emissions  array ---
c
         if( ngroup .GT. 0 ) then
            do 10 j=2,noy-1
               do 20 i=2,nox-1
c
c  --- get the region for this cell from mapping array ----
c
                  do ipart=1,npartial(igroup,igrid)
                     imap = igrmap(igroup,ipart,igrid,i,j)
                     frac = frcmap(igroup,ipart,igrid,i,j)
                     if( (imap .LE. 0 .AND. frac .GT. 0.) .OR. imap .GT. nregin ) goto 20
c
c  --- calculate the leftover emissions to use in last source group ---
c
                     if( igroup .EQ. 0 ) then
                        do k=1,nlay_ems
                           do icls=1,soap3_ntrcls
                              lefcls(icls,i,j,k) = emscls(icls,i,j,k) * frac
                           enddo
                        enddo
                     else
                        do k=1,nlay_ems
                           do icls=1,soap3_ntrcls
                              lefcls(icls,i,j,k) = lefcls(icls,i,j,k) -
     &                                              emscls(icls,i,j,k) * frac
                           enddo
c
c  --- put emissions into position in gridded tracer emissions array ---
c
                           do icls=1,ntrcls
                              ipos = iemcls(icls)-1 + imap+(igroup-1)*nregin
                              emisar(i,j,k,ipos) = emisar(i,j,k,ipos) + 
     &                                             emscls(icls,i,j,k) * frac
                           enddo
                           if( luse_soap3 .AND. lsoa ) then
                             do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                                ipos = soap3_iemcls(isoa)-1 + imap+(igroup-1)*nregin
                                icls = ntrcls + isoa - IDX_SOAP_POA_OP + 1
                                emisar(i,j,k,ipos) = emisar(i,j,k,ipos) + 
     &                                             emscls(icls,i,j,k) * frac
                             enddo
                           endif
                        enddo
                     endif
                  enddo
   20          continue
   10        continue
c
c  --- only one group, just load emissions into arrays from
c      postion 0 in gridded array ----
c
         else
             do 30 j=2,noy-1
                 do 40 i=2,nox-1
c
c  --- get the region for this cell from mapping array ----
c
                    do ipart=1,npartial(igroup,igrid)
                        imap = igrmap(0,ipart,igrid,i,j)
                        frac = frcmap(0,ipart,igrid,i,j)
                        if( (imap .LE. 0 .AND. frac .GT. 0.) .OR. imap .GT. nregin ) goto 40
c
c   --- put emissions in array at correct offset ---
c
                        do k=1,nlay_ems
                           do icls=1,ntrcls
                              ipos = iemcls(icls) - 1 + imap
                              emisar(i,j,k,ipos) = emisar(i,j,k,ipos ) + 
     &                                             emscls(icls,i,j,k) * frac
                            enddo
                            if( luse_soap3 .AND. lsoa ) then
                               do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                                 ipos = soap3_iemcls(isoa) - 1 + imap
                                 icls = ntrcls + isoa - IDX_SOAP_POA_OP + 1
                                 emisar(i,j,k,ipos) = emisar(i,j,k,ipos ) + 
     &                                             emscls(icls,i,j,k) * frac
                               enddo
                            endif
                        enddo
                     enddo
   40            continue
   30        continue
          endif
c
c  --- read emissions for the next group ---
c
      enddo
c
c  --- put leftover emissions in last group ----
c
      if( ngroup .GT. 0 .AND. leftovr_area ) then
          do 50 j=2,noy-1
            do 60 i=2,nox-1
c
c  --- get the region for this cell from mapping array ----
c
                imap = igrmap(0,1,igrid,i,j)
                frac = frcmap(0,1,igrid,i,j)
                if( (imap .LE. 0 .AND. frac .GT. 0.) .OR. imap .GT. nregin ) goto 60
c
c   ---- make sure leftover group is not negative ---
c
                do k=1,nlay_ems
                   do icls=1,soap3_ntrcls
                      if( lefcls(icls,i,j,k) .LT. 0. ) then
                        if( lefcls(icls,i,j,k) .GT. FUZZ ) then
                            lefcls(icls,i,j,k) = 0.
                         else
                            write(iout,'(//,A)') 'ERROR in READARSA:'
                            write(iout,'(/,4A,I3,A,I3,A,I3,2A,I3)')
     &                             'Negative ',clsnam(idxcls(icls)),
     &                          ' emissions calculated in leftover group ',
     &                                        'in cell: (',i,',',j,',',k,') ',
     &                                         'in Grid: ', igrid
                            write(iout,'(A,F20.6)')'   Value = ',
     &                                           lefcls(icls,i,j,k)
                            write(iout,'(A,I2,A,F20.6)') ' group ',
     &                                  igroup,' = ', emscls(icls,i,j,k)
                            call camxerr()
                         endif
                      endif
                   enddo
                   do icls=1,ntrcls
                      ipos = iemcls(icls) - 1 + imap + ngroup * nregin
                      emisar(i,j,k,ipos) = emisar(i,j,k,ipos ) + 
     &                                       lefcls(icls,i,j,k) * frac
                   enddo
                   if( luse_soap3 .AND. lsoa ) then
                      do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                         ipos = soap3_iemcls(isoa) - 1 + imap + ngroup * nregin
                         icls = ntrcls + isoa - IDX_SOAP_POA_OP + 1
                         emisar(i,j,k,ipos) = emisar(i,j,k,ipos ) + 
     &                                       lefcls(icls,i,j,k) * frac
                      enddo
                   endif
                enddo
   60        continue
   50     continue
       endif
c
c   --- deallocate the temporary space ---
c
      deallocate( lefcls )
      deallocate( emscls )
c
      return
      end

C=====================================================================
C
C   DDM-PM SUBROUTINES FOR ISORROPIA
C
C   Subroutines included in this file:
C     DDMISRINI
C     DDMISRPIA
C     DDMISRDRY
C     DDMISRLIQ
C     DDMDIFACT
C     DDMKMFUL
C     DDMMKBI
C     DDMDIFZSR
C     DDMISRMDR
C     DDMCALCHA
C     DDMCALCNA
C     DDMCALCNHA
C     DDMCALCNH3
C     DDMISRSAVH
C
C   Dependent upon:
C     tracer.com -> camx.prm  - for MXFDDM, NDDMSP & LDDM
C     ddmisrpia.inc
C     isrpia.inc
C
C   Log:
C     03/03/2005  bkoo - original development
C     06/25/2008  bkoo - changes due to ISORROPIA v1.7 (03/26/07):
C                        1. LN10 -> double precision (DDMDIFACT)
C                        2. upper bound of IONIC changed to 500 (DDMDIFACT) -> 100
C                        3. GAMA bounded between 10^-11 and 10^11 (DDMDIFACT) -> 10^-5 ~ 10^5
C                        4. temperature correction bug fix (DDMKMFUL)
C     09/19/2013  bkoo - revised for excluding mineral dust nitrate
C     12/07/2014  bkoo - several modifications to enhance robustness
C     10/26/2018  bkoo - updated for revised Ca scaling
C
C=====================================================================

      SUBROUTINE DDMISRINI (LNO3ISR,fCA_PRM,fCA_CRS,
     &                      CONVFAC,WTMOL,SDDM,NFAM,NSEN,NWTMOL,IOUT)

      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      INTEGER   NFAM, NSEN, NWTMOL, IOUT
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      WTMOL(NWTMOL)             ! Molecular weight array
      REAL      fCA_PRM,fCA_CRS           ! mass fraction of Ca on FPRM/FCRS
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac
      LOGICAL   LNO3ISR                   ! flag to indicate non-zero nitrate for isorropia

      INTEGER   I, J

      DO J = 1, NFAM
C     LOADDMPM has initialized SDDM rows for non-model species to zero
        SINI(jTNA ,J) =   SDDM(J,jdpNA  )/WTMOL(5)  *1.E-6
        SINI(jTSO4,J) = ( SDDM(J,jdpSULF)*CONVFAC + 
     &                    SDDM(J,jdpPSO4)/WTMOL(1) )*1.E-6
        SINI(jTNH4,J) = ( SDDM(J,jdpNH3 )*CONVFAC + 
     &                    SDDM(J,jdpPNH4)/WTMOL(2) )*1.E-6
        SINI(jTNO3,J) = ( SDDM(J,jdpHNO3)*CONVFAC + 
     &                    SDDM(J,jdpPNO3)/WTMOL(3) )*1.E-6
        IF ( LNO3ISR ) THEN
          SINI(jTNO3,J) = SINI(jTNO3,J) -
     &                  ( fCA_PRM*SDDM(J,jdpFPRM)
     &                  + fCA_CRS*SDDM(J,jdpFCRS) )/WTMOL(8)*1.E-6
        ELSE
          SINI(jTNO3,J) = 0.0
        ENDIF
        SINI(jTCL ,J) = ( SDDM(J,jdpHCL )*CONVFAC + 
     &                    SDDM(J,jdpPCL )/WTMOL(4) )*1.E-6
        DO I = 1, NSENS
          XMAT(I,J) = 0.0                 ! Initialize the solution matrix
        ENDDO
      ENDDO
      LMDRH = .FALSE.                     ! Initialize LMDRH flag
      IPAR = IOUT                         ! Unit number of log file

      RETURN
      END
C     END OF SUBROUTINE DDMISRINI


      SUBROUTINE DDMISRPIA (LNO3ISR,fCA_PRM,fCA_CRS,CONVFAC,
     &                      WTMOL,SDDM,NFAM,NSEN,NWTMOL,IERR,IOUT)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      INTEGER   NFAM, NSEN, NWTMOL, IERR, IOUT
      REAL      SDDM(NFAM,NSEN)           ! [ppm]/[p] for gas; [ug/m3]/[p] for PM
      REAL      WTMOL(NWTMOL)             ! Molecular weight array
      REAL      fCA_PRM,fCA_CRS           ! mass fraction of Ca on FPRM/FCRS
      REAL      CONVFAC                   ! umol/m3 = ppm * convfac
      LOGICAL   LNO3ISR                   ! flag to indicate non-zero nitrate for isorropia

CCC   REAL*8    TMPH
      CHARACTER SC*1                      ! The first character of SCASE
      INTEGER   J
C
C     Initialize error flag
C
      IERR = 1
C
C     Check for a trivial solution
C
      SC = SCASE(1:1)
      IF (SC.EQ.'?') THEN                 ! No aerosol mass
        IERR = 0                          ! -> no change in sensitivities
        RETURN
      ENDIF
C
C     MDRH region
C
      IF ( LMDRH ) THEN
        IF ( IPAR.LT.0 ) THEN             ! Check error from DDMISRMDR
          IERR = IPAR
          RETURN
        ENDIF
CCC     IF (SC.EQ.'B') THEN
CCC       CALL DDMCALCNH3
CCC     ELSEIF (SC.EQ.'E') THEN
CCC       TMPH      = MOLAL(jH)
CCC       MOLAL(jH) = SAVH
CCC       CALL DDMCALCNA
CCC       MOLAL(jH) = TMPH
CCC       CALL DDMCALCNH3
CCC     ELSEIF (SC.EQ.'I') THEN
CCC       TMPH      = MOLAL(jH)
CCC       MOLAL(jH) = SAVH
CCC       CALL DDMCALCNHA
CCC       MOLAL(jH) = TMPH
CCC       CALL DDMCALCNH3
CCC     ENDIF
CCC   This is not always working - Let's make it simple
        GOTO 100
      ENDIF
C
C     Solid only phase
C
      IF ( WATER.LE.TINY ) THEN           ! Dry

10      CONTINUE
        DO J = 1, NDDMSP
          CALL DDMISRDRY (SINI(1,J),XMAT(1,J),IERR,IOUT)
          IF (IERR.LT.0) RETURN
        ENDDO

        GOTO 100
      ENDIF
C
C     Liquid & solid phase
C
      IF ( IONIC.LT.TINY2 ) GOTO 10

CCC      MOLAL(jH     ) = MAX(MOLAL(jH     ), TINY)
CCC      MOLAL(jHSO4  ) = MAX(MOLAL(jHSO4  ), TINY)
      CALL DDMISRLIQ (XMAT,IERR,IOUT)
      IF (IERR.LT.0) RETURN

100   CONTINUE
C
C     Assign the solution
C
      DO J = 1, NFAM
        SDDM(J,jdpSULF) =  0.0
        SDDM(J,jdpPSO4) =  SINI(jTSO4,J)*WTMOL(1)*1.E6
        SDDM(J,jdpNH3 ) =  XMAT(jNH3 ,J)/CONVFAC*1.E6
        SDDM(J,jdpPNH4) = (SINI(jTNH4,J) - XMAT(jNH3 ,J))*WTMOL(2)*1.E6
        IF ( LNO3ISR ) THEN
          SDDM(J,jdpHNO3) =  XMAT(jHNO3,J)/CONVFAC*1.E6
          SDDM(J,jdpPNO3) = (SINI(jTNO3,J) - XMAT(jHNO3,J)
     &                       + (fCA_PRM*SDDM(J,jdpFPRM)
     &                         +fCA_CRS*SDDM(J,jdpFCRS))/WTMOL(8)*1.E-6)
     &                                                  *WTMOL(3)*1.E6
        ELSE
          SDDM(J,jdpPNO3) = SDDM(J,jdpPNO3)
     &                    + SDDM(J,jdpHNO3)*CONVFAC*WTMOL(3)
          SDDM(J,jdpHNO3) = 0.0
        ENDIF
        SDDM(J,jdpHCL ) =  XMAT(jHCL ,J)/CONVFAC*1.E6
        SDDM(J,jdpPCL ) = (SINI(jTCL ,J) - XMAT(jHCL ,J))*WTMOL(4)*1.E6
        SDDM(J,jdpPH2O) =  XMAT(jH2O ,J)*1.E9
        SDDM(J,jdpPH2O) = MIN( MAX( SDDM(J,jdpPH2O), -1.E3 ), 1.E3 ) ! cbk: cap water sens
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMISRPIA


      SUBROUTINE DDMISRDRY (SI,XVEC,IERR,IOUT)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL      SI(NINPT)                 ! Initial Sensitivities of total
      REAL      XVEC(NSENS)               ! Solution vector X
      INTEGER   IERR, IOUT

      CHARACTER SC*1
      REAL*8    OMPS, ALF, THETA2, FRNA, FRNO3, FRCL, FRSO4
      REAL      DOMPS, DZE, DALF, DFRNA, DFRNO3, DFRCL

      SC = SCASE(1:1)
      IF     (SC.EQ.'A') THEN
        XVEC(jNH42S4) = SI(jTSO4)
        XVEC(jNH3)    = SI(jTNH4) -2.*SI(jTSO4)
      ELSEIF (SC.EQ.'B' .OR. SC.EQ.'E') THEN
        IF (3.D0*W(jTSO4) .LE. 2.D0*W(jTNH4)) THEN
          XVEC(jLC)     = 2.*SI(jTSO4) -   SI(jTNH4)
          XVEC(jNH42S4) = 2.*SI(jTNH4) -3.*SI(jTSO4)
        ELSE
          XVEC(jLC)     =    SI(jTNH4) -   SI(jTSO4)
          XVEC(jNH4HS4) = 3.*SI(jTSO4) -2.*SI(jTNH4)
        ENDIF
        IF (SC.EQ.'E') XVEC(jHNO3) = SI(jTNO3)
      ELSEIF (SC.EQ.'D') THEN
        XVEC(jNH42S4) = SI(jTSO4)
        OMPS = W(jTNH4) -2.D0*W(jTSO4) -W(jTNO3)
        DOMPS=SI(jTNH4) -2. *SI(jTSO4)-SI(jTNO3)
        IF (OMPS.GE.ZERO) THEN
          DZE = -DOMPS*GHNO3 / (2.D0*GHNO3 +OMPS)
          IF (CNH4NO3.LE.ZERO) DZE = SI(jTNO3)
          XVEC(jNH4NO3) = SI(jTNO3) -DZE
          XVEC(jNH3)    = DOMPS     +DZE
          XVEC(jHNO3)   =            DZE
        ELSE
          DZE = DOMPS*GNH3 / (2.D0*GNH3 -OMPS)
          IF (CNH4NO3.LE.ZERO) DZE = SI(jTNH4) -2.*SI(jTSO4)
          XVEC(jNH4NO3) = SI(jTNH4) -2.*SI(jTSO4) -DZE
          XVEC(jNH3)    =                          DZE
          XVEC(jHNO3)   = -DOMPS                  +DZE
        ENDIF
      ELSEIF (SC.EQ.'G') THEN
        XVEC(jNA2SO4) = .5*SI(jTNA)
        XVEC(jNH42S4) = SI(jTSO4) -XVEC(jNA2SO4)
        ALF = W(jTNH4) -2.D0*CNH42S4
        DALF=SI(jTNH4) -2.*XVEC(jNH42S4)
        IF (CNH4NO3.GT.ZERO .AND. CNH4CL.GT.ZERO) THEN
          THETA2 = XK10/XK6
          XVEC(jNH4CL)  = SI(jTCL) + ( DALF-SI(jTNO3)-SI(jTCL) )*GHCL /
     &                  ( ALF-W(jTNO3)-W(jTCL)+2.D0*(ONE+THETA2)*GHCL )
          XVEC(jNH4NO3) = SI(jTNO3) - THETA2*( SI(jTCL)-XVEC(jNH4CL) )
        ELSEIF (CNH4CL.GT.ZERO) THEN
          XVEC(jNH4CL)  = (DALF*GHCL + SI(jTCL)*GNH3)/(GHCL + GNH3)
          XVEC(jNH4NO3) = 0.0
        ELSEIF (CNH4NO3.GT.ZERO) THEN
          XVEC(jNH4CL)  = 0.0
          XVEC(jNH4NO3) = (DALF*GHNO3 + SI(jTNO3)*GNH3)/(GHNO3 + GNH3)
        ELSE
          XVEC(jNH4CL)  = 0.0
          XVEC(jNH4NO3) = 0.0
        ENDIF
        XVEC(jNH3)    = DALF     -XVEC(jNH4CL) -XVEC(jNH4NO3)
        XVEC(jHCL)    = SI(jTCL) -XVEC(jNH4CL)
        XVEC(jHNO3)   = SI(jTNO3)              -XVEC(jNH4NO3)
      ELSEIF (SC.EQ.'H') THEN
        XVEC(jNA2SO4) = SI(jTSO4)
        FRNA = W(jTNA) -2.D0*W(jTSO4)
        DFRNA=SI(jTNA) -2. *SI(jTSO4)
        IF (FRNA.GE.W(jTNO3)) THEN
          XVEC(jNANO3)  = SI(jTNO3)
          FRNO3 = ZERO
          DFRNO3= 0.0
          IF (FRNA-W(jTNO3).GE.W(jTCL)) THEN
            XVEC(jNACL) = SI(jTCL)
            FRCL = ZERO
            DFRCL= 0.0
          ELSE
            XVEC(jNACL) = DFRNA -SI(jTNO3)
            FRCL = W(jTCL) +W(jTNO3) -FRNA
            DFRCL=SI(jTCL)+SI(jTNO3)-DFRNA
          ENDIF
        ELSE
          XVEC(jNANO3)  = DFRNA
          FRNO3 = W(jTNO3) -FRNA
          DFRNO3=SI(jTNO3)-DFRNA
          FRCL  = W(jTCL)
          DFRCL =SI(jTCL)
        ENDIF
        IF (CNH4NO3.GT.ZERO .AND. CNH4CL.GT.ZERO) THEN
          THETA2 = XK10/XK6
          XVEC(jNH4CL)  = DFRCL + ( SI(jTNH4)-DFRNO3-DFRCL )*GHCL /
     &                  ( W(jTNH4)-FRNO3-FRCL+2.D0*(ONE+THETA2)*GHCL )
          XVEC(jNH4NO3) = DFRNO3 - THETA2*( DFRCL-XVEC(jNH4CL) )
        ELSEIF (CNH4CL.GT.ZERO) THEN
          XVEC(jNH4CL)  = (SI(jTNH4)*GHCL + DFRCL*GNH3)/(GHCL + GNH3)
          XVEC(jNH4NO3) = 0.0
        ELSEIF (CNH4NO3.GT.ZERO) THEN
          XVEC(jNH4CL)  = 0.0
          XVEC(jNH4NO3) = (SI(jTNH4)*GHNO3 + DFRNO3*GNH3)/(GHNO3+GNH3)
        ELSE
          XVEC(jNH4CL)  = 0.0
          XVEC(jNH4NO3) = 0.0
        ENDIF
        XVEC(jNH3)    = SI(jTNH4) -XVEC(jNH4CL) -XVEC(jNH4NO3)
        XVEC(jHCL)    = DFRCL     -XVEC(jNH4CL)
        XVEC(jHNO3)   = DFRNO3                  -XVEC(jNH4NO3)
      ELSEIF (SC.EQ.'I') THEN
        XVEC(jNA2SO4) = .5*SI(jTNA)
        FRSO4 = W(jTSO4) -0.5D0*W(jTNA) -2.D0*W(jTNH4)/3.D0
        IF (FRSO4.LE.TINY) THEN
          XVEC(jLC)     = 2.*SI(jTSO4) -SI(jTNA) -SI(jTNH4)
          XVEC(jNH42S4) = 2.*SI(jTNH4) -3.*SI(jTSO4) +1.5*SI(jTNA)
        ELSE
          IF (FRSO4.LE.W(jTNH4)/3.D0) THEN
            XVEC(jNH4HS4) = 3.*SI(jTSO4) -1.5*SI(jTNA) -2.*SI(jTNH4)
            XVEC(jLC)     = SI(jTNH4) -SI(jTSO4) +.5*SI(jTNA)
          ELSE
            XVEC(jNH4HS4) = SI(jTNH4)
            IF (0.5D0*W(jTNA).GT.TINY) THEN
              XVEC(jNAHSO4) = 2.*SI(jTSO4) -SI(jTNA) -2.*SI(jTNH4)
              XVEC(jNA2SO4) = SI(jTNH4) +SI(jTNA) -SI(jTSO4)
            ENDIF
          ENDIF
        ENDIF
        XVEC(jHNO3) = SI(jTNO3)
        XVEC(jHCL)  = SI(jTCL)
      ELSE
        WRITE(IOUT,'(//,A)') 'ERROR in DDMISRDRY:'
        WRITE(IOUT,'(A,A)')  ' Case not supported - ',SCASE
        IERR = -1
        RETURN
      ENDIF

      RETURN
      END
C     END OF SUBROUTINE DDMISRDRY


      SUBROUTINE DDMISRLIQ (XLIQ,IERR,IOUT)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL      XLIQ(NSENS,MXFDDM)        ! Solution matrix for wet aerosols
      INTEGER   IERR, IOUT

      CHARACTER SC*1
      LOGICAL   LSEQ(NSENS)               ! If true, the eqn is solved
      LOGICAL   LSEN(NSENS)               ! If true, the sensitivity is solved
      REAL      DELGAMA(NIONSP1,NPAIR)    ! del GAMA by del Y(A)
      REAL      AMAT(NSENS,NSENS)         ! Left-hand side matrix A
                                          ! Right-hand side vector B -> XLIQ
      REAL      AA(NSENS,NSENS),BB(NSENS) ! These are passed to DDMEQNSLV solely
      INTEGER   IPVT(NSENS)               ! to allow their size to be adjustable
      LOGICAL   LALFA                     ! If true, calculate DALFA
      REAL*8    CX, C1, C2
CCC   REAL*8    A1, A2, A3, XSUM1, XSUM2, XSUM3
      INTEGER   I, J, K, NDIM, iEQ

      COMMON /SOLUT/ CHI1, CHI2, CHI3, CHI4, CHI5, CHI6, CHI7, CHI8,
     &               PSI1, PSI2, PSI3, PSI4, PSI5, PSI6, PSI7, PSI8,
     &               A__1, A__2, A__3, A__4, A__5, A__6, A__7, A__8
c$omp threadprivate(/SOLUT/)
C
C     Initialize arrays
C
      DO I = 1, NSENS
        LSEQ(I) = .TRUE.
        LSEN(I) = .TRUE.
        DO J = 1, NSENS
          AMAT(J,I) = 0.0
        ENDDO
      ENDDO
      LALFA = .FALSE.
C
C     Select eqns & sensitivities to solve
C
      SC = SCASE(1:1)
      IF     (SC.EQ.'A' .OR. SC.EQ.'B' .OR. SC.EQ.'C') THEN ! Na,Cl,NO3=0
        CALL DDMEQNSUB (LSEQ(iMBNA ),LSEN(jNA  ))
        CALL DDMEQNSUB (LSEQ(iMBCL ),LSEN(jCL  ))
        CALL DDMEQNSUB (LSEQ(iMBNO3),LSEN(jNO3 ))
        CALL DDMEQNSUB (LSEQ(iK3   ),LSEN(jHCL ))
        CALL DDMEQNSUB (LSEQ(iK4   ),LSEN(jHNO3))
      ELSEIF (SC.EQ.'D' .OR. SC.EQ.'E' .OR. SC.EQ.'F') THEN ! Na,Cl=0
        CALL DDMEQNSUB (LSEQ(iMBNA ),LSEN(jNA  ))
        CALL DDMEQNSUB (LSEQ(iMBCL ),LSEN(jCL  ))
        CALL DDMEQNSUB (LSEQ(iK3   ),LSEN(jHCL ))
      ELSEIF (SC.EQ.'G') THEN
        IF (SCASE.EQ.'G1 ; SUBCASE 2' .OR.
     &      SCASE.EQ.'G2 ; SUBCASE 1' .OR.
     &      SCASE.EQ.'G2 ; SUBCASE 3' .OR.
     &      SCASE.EQ.'G3 ; SUBCASE 1') THEN
          CALL DDMEQNSUB (LSEQ(iK5 ),LSEN(jNA  ))
          CNA2SO4 = 0.5D0*W(jTNA)
          MOLAL(jSO4) = MAX(MOLAL(jSO4) - 0.5D0*MOLAL(jNA ), ZERO)
          MOLAL(jNA ) = ZERO
        ENDIF
      ELSEIF (SC.EQ.'H') THEN
        IF (PSI5.LT.2.D0*TINY .OR. PSI4.LT.5.D-9)
     &                     CALL DDMEQNSUB (LSEQ(iK2   ),LSEN(jNH4 ))
        IF (GHNO3.LE.TINY) CALL DDMEQNSUB (LSEQ(iK4   ),LSEN(jHNO3)) ! Na takes all HNO3?
CCC      ELSEIF (SC.EQ.'I' .OR. SC.EQ.'J') THEN                ! CALCNHA can give TINY to NO3-/CL-
CCC        IF (MOLAL(jNO3).LE.TINY) CALL DDMEQNSUB (LSEQ(iK4),LSEN(jNO3))
CCC        IF (MOLAL(jCL ).LE.TINY) CALL DDMEQNSUB (LSEQ(iK3),LSEN(jCL ))
      ENDIF
      IF (CNH42S4.LE.ZERO) CALL DDMEQNSUB (LSEQ(iK7 ),LSEN(jNH42S4))
      IF (CNH4HS4.LE.ZERO) CALL DDMEQNSUB (LSEQ(iK12),LSEN(jNH4HS4))
      IF (CNACL  .LE.ZERO) CALL DDMEQNSUB (LSEQ(iK8 ),LSEN(jNACL  ))
      IF (CNA2SO4.LE.ZERO) CALL DDMEQNSUB (LSEQ(iK5 ),LSEN(jNA2SO4))
      IF (CNANO3 .LE.ZERO) CALL DDMEQNSUB (LSEQ(iK9 ),LSEN(jNANO3 ))
      IF (CNH4NO3.LE.ZERO) CALL DDMEQNSUB (LSEQ(iK10),LSEN(jNH4NO3))
      IF (CNH4CL .LE.ZERO) CALL DDMEQNSUB (LSEQ(iK6 ),LSEN(jNH4CL ))
      IF (CNAHSO4.LE.ZERO) CALL DDMEQNSUB (LSEQ(iK11),LSEN(jNAHSO4))
      IF (CLC    .LE.ZERO) CALL DDMEQNSUB (LSEQ(iK13),LSEN(jLC    ))
CCC      IF ( LMDRH ) THEN
CCC        IF (SC.EQ.'B' .OR. SC.EQ.'E' .OR. SC.EQ.'I') THEN
        IF (SC.EQ.'B' .OR. SC.EQ.'C' .OR.
     &      SC.EQ.'E' .OR. SC.EQ.'F' .OR.
     &      SC.EQ.'I' .OR. SC.EQ.'J') THEN ! ignore sensitivities of minor species
          CALL DDMEQNSUB (LSEQ(iMBCL ),LSEN(jCL  ))
          CALL DDMEQNSUB (LSEQ(iMBNO3),LSEN(jNO3 ))
          CALL DDMEQNSUB (LSEQ(iK3   ),LSEN(jHCL ))
          CALL DDMEQNSUB (LSEQ(iK4   ),LSEN(jHNO3))
          CALL DDMEQNSUB (LSEQ(iK2   ),LSEN(jNH3 ))
          LALFA = .TRUE.
        ENDIF
CCC      ENDIF
C     Get the dimension
      NDIM = 0
      DO I = 1, NSENS
        IF ( LSEQ(I) ) NDIM = NDIM + 1
      ENDDO
ccc      do ii = 1, nsens                            ! debug
ccc      if (lseq(ii)) write(*,*)'LSEQ:',ii,lseq(ii) ! debug
ccc      enddo                                       ! debug
C====================================================================
C     Fill the matrix A and constant vector B
C====================================================================
C
C     1. Equlibrium reactions
C
      CALL DDMDIFACT (DELGAMA)
      CX = 1.     ! Equlibrium equations are now normalized
C
C     K1
C
      iEQ = iK1
CCC   IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jH)/WATER*MOLAL(jSO4)/MOLAL(jHSO4) *
CX1     &       GAMA(mH2SO4)*(GAMA(mH2SO4)/GAMA(mHHSO4))**2.
        C1 =  3.*CX/GAMA(mH2SO4)
        C2 = -2.*CX/GAMA(mHHSO4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mH2SO4) + C2*DELGAMA(K,mHHSO4)
        ENDDO
        AMAT(jH   ,iEQ) = AMAT(jH   ,iEQ) + CX/MAX(MOLAL(jH),TINY)
        AMAT(jSO4 ,iEQ) = AMAT(jSO4 ,iEQ) + CX/MAX(MOLAL(jSO4),TINY)
        AMAT(jHSO4,iEQ) = AMAT(jHSO4,iEQ) - CX/MAX(MOLAL(jHSO4),TINY)
        AMAT(jH2O ,iEQ) = AMAT(jH2O ,iEQ) - CX/WATER
CCC   ENDIF
C
C     K2
C
      iEQ = iK2
      IF ( LSEQ(iEQ) ) THEN
        IF (SC.EQ.'A') THEN
CX1        CX = MOLAL(jNH4)/MOLAL(jH)/GNH3 *
CX1     &       (GAMA(mNH4HS4)/GAMA(mHHSO4))**2. * XKW/R/TEMP
        C1 =  2.*CX/GAMA(mNH4HS4)
        C2 = -2.*CX/GAMA(mHHSO4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNH4HS4) + C2*DELGAMA(K,mHHSO4)
        ENDDO
        ELSE
CX1        CX = MOLAL(jNH4)/MOLAL(jH)/GNH3 *
CX1     &       (GAMA(mNH4NO3)/GAMA(mHNO3))**2. * XKW/R/TEMP
        C1 =  2.*CX/GAMA(mNH4NO3)
        C2 = -2.*CX/GAMA(mHNO3)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNH4NO3) + C2*DELGAMA(K,mHNO3)
        ENDDO
        ENDIF
        AMAT(jNH4,iEQ) = AMAT(jNH4,iEQ) + CX/MAX(MOLAL(jNH4),TINY)
        AMAT(jH  ,iEQ) = AMAT(jH  ,iEQ) - CX/MAX(MOLAL(jH),TINY)
        AMAT(jNH3,iEQ) =                - CX/GNH3
      ENDIF
C
C     K3
C
      iEQ = iK3
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jH)/WATER*MOLAL(jCL)/WATER/GHCL *
CX1     &       GAMA(mHCL)**2. /R/TEMP
        C1 = 2.*CX/GAMA(mHCL)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mHCL)
        ENDDO
        AMAT(jH  ,iEQ) = AMAT(jH  ,iEQ) +    CX/MAX(MOLAL(jH),TINY)
        AMAT(jCL ,iEQ) = AMAT(jCL ,iEQ) +    CX/MAX(MOLAL(jCL),TINY)
        AMAT(jHCL,iEQ) =                -    CX/GHCL
        AMAT(jH2O,iEQ) = AMAT(jH2O,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K4
C
      iEQ = iK4
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jH)/WATER*MOLAL(jNO3)/WATER/GHNO3 *
CX1     &       GAMA(mHNO3)**2. /R/TEMP
        C1 = 2.*CX/GAMA(mHNO3)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mHNO3)
        ENDDO
        AMAT(jH   ,iEQ) = AMAT(jH   ,iEQ) +    CX/MAX(MOLAL(jH),TINY)
        AMAT(jNO3 ,iEQ) = AMAT(jNO3 ,iEQ) +    CX/MAX(MOLAL(jNO3),TINY)
        AMAT(jHNO3,iEQ) =                 -    CX/GHNO3
        AMAT(jH2O ,iEQ) = AMAT(jH2O ,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K5
C
      iEQ = iK5
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNA)/WATER*MOLAL(jNA)/WATER*MOLAL(jSO4)/WATER *
CX1     &       GAMA(mNA2SO4)**3.
        C1 = 3.*CX/GAMA(mNA2SO4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNA2SO4)
        ENDDO
        AMAT(jNA ,iEQ) = AMAT(jNA ,iEQ) + 2.*CX/MAX(MOLAL(jNA),TINY)
        AMAT(jSO4,iEQ) = AMAT(jSO4,iEQ) +    CX/MAX(MOLAL(jSO4),TINY)
        AMAT(jH2O,iEQ) = AMAT(jH2O,iEQ) - 3.*CX/WATER
      ENDIF
C
C     K6
C
      iEQ = iK6
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = GNH3*GHCL * (R*TEMP)**2.
        AMAT(jNH3,iEQ) = CX/GNH3
        AMAT(jHCL,iEQ) = CX/GHCL
      ENDIF
C
C     K7
C
      iEQ = iK7
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNH4)/WATER*MOLAL(jNH4)/WATER*MOLAL(jSO4)/WATER *
CX1     &       GAMA(mNH42S4)**3.
        C1 = 3.*CX/GAMA(mNH42S4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNH42S4)
        ENDDO
        AMAT(jNH4,iEQ) = AMAT(jNH4,iEQ) + 2.*CX/MAX(MOLAL(jNH4),TINY)
        AMAT(jSO4,iEQ) = AMAT(jSO4,iEQ) +    CX/MAX(MOLAL(jSO4),TINY)
        AMAT(jH2O,iEQ) = AMAT(jH2O,iEQ) - 3.*CX/WATER
      ENDIF
C
C     K8
C
      iEQ = iK8
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNA)/WATER*MOLAL(jCL)/WATER *
CX1     &       GAMA(mNACL)**2.
        C1 = 2.*CX/GAMA(mNACL)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNACL)
        ENDDO
        AMAT(jNA ,iEQ) = AMAT(jNA ,iEQ) +    CX/MAX(MOLAL(jNA),TINY)
        AMAT(jCL ,iEQ) = AMAT(jCL ,iEQ) +    CX/MAX(MOLAL(jCL),TINY)
        AMAT(jH2O,iEQ) = AMAT(jH2O,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K9
C
      iEQ = iK9
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNA)/WATER*MOLAL(jNO3)/WATER *
CX1     &       GAMA(mNANO3)**2.
        C1 = 2.*CX/GAMA(mNANO3)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNANO3)
        ENDDO
        AMAT(jNA ,iEQ) = AMAT(jNA ,iEQ) +    CX/MAX(MOLAL(jNA),TINY)
        AMAT(jNO3,iEQ) = AMAT(jNO3,iEQ) +    CX/MAX(MOLAL(jNO3),TINY)
        AMAT(jH2O,iEQ) = AMAT(jH2O,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K10
C
      iEQ = iK10
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = GNH3*GHNO3 * (R*TEMP)**2.
        AMAT(jNH3 ,iEQ) = CX/GNH3
        AMAT(jHNO3,iEQ) = CX/GHNO3
      ENDIF
C
C     K11
C
      iEQ = iK11
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNA)/WATER*MOLAL(jHSO4)/WATER *
CX1     &       GAMA(mNAHSO4)**2.
        C1 = 2.*CX/GAMA(mNAHSO4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNAHSO4)
        ENDDO
        AMAT(jNA  ,iEQ) = AMAT(jNA  ,iEQ) +    CX/MAX(MOLAL(jNA),TINY)
        AMAT(jHSO4,iEQ) = AMAT(jHSO4,iEQ) +    CX/MAX(MOLAL(jHSO4),TINY)
        AMAT(jH2O ,iEQ) = AMAT(jH2O ,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K12
C
      iEQ = iK12
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = MOLAL(jNH4)/WATER*MOLAL(jHSO4)/WATER *
CX1     &       GAMA(mNH4HS4)**2.
        C1 = 2.*CX/GAMA(mNH4HS4)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mNH4HS4)
        ENDDO
        AMAT(jNH4 ,iEQ) = AMAT(jNH4 ,iEQ) +    CX/MAX(MOLAL(jNH4),TINY)
        AMAT(jHSO4,iEQ) = AMAT(jHSO4,iEQ) +    CX/MAX(MOLAL(jHSO4),TINY)
        AMAT(jH2O ,iEQ) = AMAT(jH2O ,iEQ) - 2.*CX/WATER
      ENDIF
C
C     K13
C
      iEQ = iK13
      IF ( LSEQ(iEQ) ) THEN
CX1        CX = (MOLAL(jNH4)/WATER)**3. * 
CX1     &       (MOLAL(jHSO4)/WATER*MOLAL(jSO4)/WATER) *
CX1     &       GAMA(mLC)**5.
        C1 = 5.*CX/GAMA(mLC)
        DO K = 1, NIONSP1
          AMAT(K,iEQ) = C1*DELGAMA(K,mLC)
        ENDDO
        AMAT(jNH4 ,iEQ) = AMAT(jNH4 ,iEQ) + 3.*CX/MAX(MOLAL(jNH4),TINY)
        AMAT(jHSO4,iEQ) = AMAT(jHSO4,iEQ) +    CX/MAX(MOLAL(jHSO4),TINY)
        AMAT(jSO4 ,iEQ) = AMAT(jSO4 ,iEQ) +    CX/MAX(MOLAL(jSO4),TINY)
        AMAT(jH2O ,iEQ) = AMAT(jH2O ,iEQ) - 5.*CX/WATER
      ENDIF
C
C     2. Mass balances
C
      iEQ = iMBNA
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XLIQ(      iEQ,J) = SINI(jTNA,J)
        ENDDO
        AMAT(jNA    ,iEQ) = 1.
        AMAT(jNACL  ,iEQ) = 1.
        AMAT(jNA2SO4,iEQ) = 2.
        AMAT(jNANO3 ,iEQ) = 1.
        AMAT(jNAHSO4,iEQ) = 1.
      ENDIF

      iEQ = iMBSO4
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XLIQ(      iEQ,J) = SINI(jTSO4,J)
        ENDDO
        AMAT(jSO4   ,iEQ) = 1.
        AMAT(jHSO4  ,iEQ) = 1.
        AMAT(jNH42S4,iEQ) = 1.
        AMAT(jNH4HS4,iEQ) = 1.
        AMAT(jNA2SO4,iEQ) = 1.
        AMAT(jNAHSO4,iEQ) = 1.
        AMAT(jLC    ,iEQ) = 2.
CCC   ENDIF

      iEQ = iMBNH4
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XLIQ(      iEQ,J) = SINI(jTNH4,J)
        ENDDO
        AMAT(jNH3   ,iEQ) = 1.
        AMAT(jNH4   ,iEQ) = 1.
        AMAT(jNH42S4,iEQ) = 2.
        AMAT(jNH4HS4,iEQ) = 1.
        AMAT(jNH4NO3,iEQ) = 1.
        AMAT(jNH4CL ,iEQ) = 1.
        AMAT(jLC    ,iEQ) = 3.
CCC   ENDIF

      iEQ = iMBNO3
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XLIQ(      iEQ,J) = SINI(jTNO3,J)
        ENDDO
        AMAT(jHNO3  ,iEQ) = 1.
        AMAT(jNO3   ,iEQ) = 1.
        AMAT(jNANO3 ,iEQ) = 1.
        AMAT(jNH4NO3,iEQ) = 1.
      ENDIF

      iEQ = iMBCL
      IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          XLIQ(      iEQ,J) = SINI(jTCL,J)
        ENDDO
        AMAT(jHCL   ,iEQ) = 1.
        AMAT(jCL    ,iEQ) = 1.
        AMAT(jNACL  ,iEQ) = 1.
        AMAT(jNH4CL ,iEQ) = 1.
      ENDIF
C
C     3. Charge balances
C
      iEQ = iCB
CCC   IF ( LSEQ(iEQ) ) THEN
        AMAT(jH   ,iEQ) =  1. + XKW*RH*(WATER/MAX(MOLAL(jH),TINY))**2.
        AMAT(jNA  ,iEQ) =  1.
        AMAT(jNH4 ,iEQ) =  1.
        AMAT(jSO4 ,iEQ) = -2.
        AMAT(jHSO4,iEQ) = -1.
        AMAT(jNO3 ,iEQ) = -1.
        AMAT(jCL  ,iEQ) = -1.
        AMAT(jH2O ,iEQ) = -2.*XKW*RH*WATER/MAX(MOLAL(jH),TINY)
CCC   ENDIF
C
C     4. ZSR relationship
C
      iEQ = iZSR
CCC   IF ( LSEQ(iEQ) ) THEN
        DO J = 1, NDDMSP
          CALL DDMDIFZSR (SINI(1,J),AMAT(1,iEQ),XLIQ(iEQ,J),IERR,IOUT)
          IF (IERR.LT.0) RETURN
        ENDDO
CCC   ENDIF
C====================================================================
C
C     Solve the sensitivity eqns
C
      CALL DDMEQNSLV (NSENS,LSEQ,LSEN,AMAT,NDDMSP,XLIQ,
     &                NDIM,AA,BB,IPVT,IERR,IOUT)
      IF (IERR.LT.0) THEN
        WRITE(IOUT,'(A)') ' Called by DDMISRLIQ'
        RETURN
      ENDIF
C
C     Calculate DALFA for minor species equilibria
C
      IF ( LALFA ) THEN
CCC     A1 = XK3*R*TEMP*(WATER/GAMA(mHCL))**2.0
CCC     A2 = XK4*R*TEMP*(WATER/GAMA(mHNO3))**2.0
CCC     A3 = (XKW/XK2)/(R*TEMP)*(GAMA(mNH4NO3)/GAMA(mHNO3))**2.0
CCC     DO J = 1, NDDMSP
CCC       XSUM1 = 0.0
CCC       XSUM2 = 0.0
CCC       XSUM3 = 0.0
CCC       DO K = 1, NIONSP1
CCC         XSUM1 = XSUM1 + DELGAMA(K,mHCL   )*XLIQ(K,J)
CCC         XSUM2 = XSUM2 + DELGAMA(K,mHNO3  )*XLIQ(K,J)
CCC         XSUM3 = XSUM3 + DELGAMA(K,mNH4NO3)*XLIQ(K,J)
CCC       ENDDO
CCC       DALFA(1,J) = 2.*A1*( XLIQ(jH2O,J)/WATER -XSUM1/GAMA(mHCL ) )
CCC       DALFA(2,J) = 2.*A2*( XLIQ(jH2O,J)/WATER -XSUM2/GAMA(mHNO3) )
CCC       DALFA(3,J) = 2.*A3*( XSUM3/GAMA(mNH4NO3)-XSUM2/GAMA(mHNO3) )
CCC     ENDDO
CCC   This is not always working - Let's make it simple
        DO J = 1, NDDMSP
          XLIQ(jHCL ,J) = SINI(jTCL ,J)
          XLIQ(jHNO3,J) = SINI(jTNO3,J)
          XLIQ(jNH3 ,J) = 0.0
        ENDDO
      ENDIF

      RETURN
      END
C     END OF SUBROUTINE DDMISRLIQ


      SUBROUTINE DDMDIFACT (DELGAMA)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    LN10                      ! Natural log of 10 (see CALCACT)
      PARAMETER (LN10=2.30258509299404568402D0)

      REAL      DELI(NIONSP1)             ! del IONIC by del Y(A)
      REAL      G0(NPAIR)                 ! Common log of binary activity coefficients
      REAL      DELG0(NIONSP1,NPAIR)      ! del G0 by del Y(A)

      REAL      ZPL,ZMI,AGAMA,SION,H,CH,HD
      REAL*8    XPL,XMI,XIJ,YJI,DELXIJ,DELYJI
      REAL      DELF1(NIONSP1,3),DELF2(NIONSP1,4)

      REAL      DELGAMA(NIONSP1,NPAIR)    ! del GAMA by del Y(A)
      INTEGER   IJMAP(3,4),I,J,K
C
C     Ionic strength
C
      IF (IONIC.GE.100.d0) THEN           ! IONIC is limited in (TINY, 100.d0) in ISORROPIA
        DO I = 1, NIONSP1
          DELI(I) = 0.0
        ENDDO
      ELSE
        DELI(jH2O) = 0.0
        DO I = 1, NIONS
          DELI(I) = 0.5*Z(I)*Z(I)/WATER
          DELI(jH2O) = DELI(jH2O) + MOLAL(I)*Z(I)*Z(I)
        ENDDO
        DELI(jH2O) = -0.5*DELI(jH2O)/(WATER*WATER)
      ENDIF
C
C     Binary activity coefficients (Kusik and Meissner method)
C
      CALL DDMKMFUL (NIONSP1,NPAIR,IONIC,SNGL(TEMP),DELI,G0,DELG0)
C
C     Mapping of IJMAP
C
      IJMAP(1,1) = mHCL
      IJMAP(1,2) = mH2SO4
      IJMAP(1,3) = mHHSO4
      IJMAP(1,4) = mHNO3
      IJMAP(2,1) = mNACL
      IJMAP(2,2) = mNA2SO4
      IJMAP(2,3) = mNAHSO4
      IJMAP(2,4) = mNANO3
      IJMAP(3,1) = mNH4CL
      IJMAP(3,2) = mNH42S4
      IJMAP(3,3) = mNH4HS4
      IJMAP(3,4) = mNH4NO3
C
C     Multicomponent activity coefficients (Bromley's method)
C
      AGAMA = 0.511*(298.0/TEMP)**1.5     ! Debye Huckel const. at T
      SION  = SQRT(IONIC)
      H     = AGAMA*SION/(1+SION)
      HD    = 0.5*AGAMA/(SION*(1.+SION)*(1.+SION))

      DO K = 1, NIONSP1
        DO 100 I=1,3
           DELF1(K,I)=0.0
           DELF2(K,I)=0.0
100     CONTINUE
        DELF2(K,4)=0.0
      ENDDO

      DO 110 I=1,3
         ZPL = Z(I)
         XPL = MOLAL(I)/WATER
         DO 110 J=1,4
            ZMI   = Z(J+3)
            XMI   = MOLAL(J+3)/WATER
            CH    = 0.25*(ZPL+ZMI)*(ZPL+ZMI)/IONIC
            XIJ   = CH*XPL
            YJI   = CH*XMI

            DO K = 1, NIONSP1
              DELXIJ = -XPL*DELI(K)/IONIC
              DELYJI = -XMI*DELI(K)/IONIC
              IF (K.EQ.I) THEN
                DELXIJ = DELXIJ + 1./WATER
              ELSEIF (K.EQ.J+3) THEN
                DELYJI = DELYJI + 1./WATER
              ELSEIF (K.EQ.jH2O) THEN
                DELXIJ = DELXIJ - XPL/WATER
                DELYJI = DELYJI - XMI/WATER
              ENDIF
              DELXIJ = CH*DELXIJ
              DELYJI = CH*DELYJI

              DELF1(K,I) = DELF1(K,I)
     &                   + G0(IJMAP(I,J)) * DELYJI
     &                   + YJI * DELG0(K,IJMAP(I,J))
     &                   + ZPL*ZMI*HD * YJI * DELI(K)
     &                   + ZPL*ZMI*H * DELYJI
              DELF2(K,J) = DELF2(K,J)
     &                   + G0(IJMAP(I,J)) * DELXIJ
     &                   + XIJ * DELG0(K,IJMAP(I,J))
     &                   + ZPL*ZMI*HD * XIJ * DELI(K)
     &                   + ZPL*ZMI*H * DELXIJ
            ENDDO

110   CONTINUE
C
C     del log10(GAMA)
C
      DO 120 I=1,3
         ZPL = Z(I)
         DO 120 J=1,4
            ZMI = Z(J+3)

            DO K = 1, NIONSP1
               DELGAMA(K,IJMAP(I,J)) = ZPL*ZMI * (
     &                  (DELF1(K,I)/ZPL + DELF2(K,J)/ZMI) / (ZPL+ZMI)
     &                               - HD * DELI(K) )
            ENDDO

120   CONTINUE

      DO K = 1, NIONSP1
         DELGAMA(K,mLC) = 0.20 * ( 3.0*DELGAMA(K,mNH42S4)
     &                           + 2.0*DELGAMA(K,mNH4HS4) )
      ENDDO
C
C     Convert del log10(GAMA) to del GAMA
C
      DO I = 1, NPAIR
         IF (GAMA(I).LE.1.d-5 .OR. GAMA(I).GE.1.d5) THEN
            DO K = 1, NIONSP1
               DELGAMA(K,I) = 0.0
            ENDDO
         ELSE
            DO K = 1, NIONSP1
               DELGAMA(K,I) = LN10 * GAMA(I) * DELGAMA(K,I)
            ENDDO
         ENDIF
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMDIFACT


      SUBROUTINE DDMKMFUL (N,NPAIRS,IONIC,TEMP,DELI,G0,DELG0)

      INTEGER   N, NPAIRS
      REAL      IONIC, TEMP, DELI(N), G0(NPAIRS), DELG0(N,NPAIRS)
      REAL      SION, CUBI, TI, CF1, CF2, CF2D

      INTEGER   NPAIRD, I, K
      PARAMETER (NPAIRD=10)               ! Number of ion pairs whose Q value is available
      INTEGER   IG(NPAIRD)
      DATA IG / 1,2,3,4,5,6,7,8,10,11 /
      REAL      ZI(NPAIRD)                ! Mapping of Q to the internal order of ion pairs
      DATA ZI / 1., 2., 1., 2., 1., 1., 2., 1., 1., 1. /
      REAL      Q(NPAIRD)                 ! Kusik-Meissner parameters (see KMFUL)
      DATA Q  / 2.23,-0.19,-0.39,-0.25,-1.15,0.82,-0.1,8.0,2.6,6.0 /
C
      SION = SQRT(IONIC)
      CUBI = IONIC*IONIC*IONIC
C
C     Coefficients at 25 oC
C
      DO I = 1, NPAIRD
         CALL DDMMKBI(N,Q(I),IONIC,SION,CUBI,ZI(I),G0(IG(I)),DELI,
     &                                          DELG0(1,IG(I)))
      ENDDO
C
C     Correct for T other than 298 K
C
      TI  = TEMP-273.0
      IF (ABS(TI-25.0) .GT. 1.0) THEN
         CF1 = 1.125-0.005*TI
         CF2 = (CF1-1.)*(0.039*IONIC**0.92-0.41*SION/(1.+SION))
         CF2D = (CF1-1.)*( .03588/IONIC**.08
     &                    -.205/(SION*(1.+SION)*(1.+SION)) )
         DO I = 1, NPAIRD
            G0(IG(I)) = CF1*G0(IG(I)) - CF2*ZI(I)
            DO K = 1, N
               DELG0(K,IG(I)) = CF1*DELG0(K,IG(I)) - ZI(I)*CF2D*DELI(K)
            ENDDO
         ENDDO
      ENDIF
C
      G0( 9) = G0( 6) + G0( 8) - G0(11)
      G0(12) = G0( 1) + G0( 8) - G0(11)
      DO K = 1, N
         DELG0(K, 9) = DELG0(K, 6) + DELG0(K, 8) - DELG0(K,11)
         DELG0(K,12) = DELG0(K, 1) + DELG0(K, 8) - DELG0(K,11)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMKMFUL


      SUBROUTINE DDMMKBI (N,Q,IONIC,SION,CUBI,ZIP,G,DELI,DELG)
C
      REAL      LN10                      ! Natural log of 10 (see INIT1,INIT2,INIT3)
      PARAMETER (LN10=2.3025851)
      INTEGER   N
      REAL      Q, IONIC, SION, CUBI, ZIP, G, DELI(N), DELG(N)

      REAL      B, C, XX, BI, XX1, XX2, XX3, XX4
      INTEGER   K
C
      B=.75-.065*Q
      C= 1.0
      IF (IONIC.LT.6.0) C=1.+.055*Q*EXP(-.023*CUBI)
      XX=-0.5107*SION/(1.+C*SION)
      BI=(1.+B*(1.+.1*IONIC)**Q-B)
      G =ZIP*ALOG10(BI) + ZIP*XX

      XX1 = .1*B*Q*(1.+.1*IONIC)**(Q-1.)/(BI*LN10)
      XX2 = 0.5/SION+.003795*Q*CUBI*EXP(-.023*CUBI)
      XX3 = (1.+C*SION)*(1.+C*SION)
      XX4 = ZIP*(XX1-.5107*XX2/XX3)
      DO K = 1, N
         DELG(K) = XX4 * DELI(K)
      ENDDO
C
      RETURN
      END
C     END OF SUBROUTINE DDMMKBI


      SUBROUTINE DDMDIFZSR (SI,AVEC,CONST,IERR,IOUT)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL      SI(NINPT)                 ! Initial Sensitivities of total
      REAL      AVEC(NSENS), CONST
      REAL      TVEC(NSENS)               ! Temporary solution vector for case I
      INTEGER   IERR, IOUT

      CHARACTER SC*1
      REAL*8    SO4I, HSO4I, AML5, FRNH4, FRNA, FRNO3, FRCL
      REAL      DFRNA
      INTEGER   I

      AVEC(jH2O) = 1.

      SC = SCASE(1:1)
      IF     (SC.EQ.'A') THEN
        AVEC(jSO4   ) = -1./M0(mNH42S4)
        AVEC(jHSO4  ) = -1./M0(mNH42S4)
      ELSEIF (SC.EQ.'C' .OR. SC.EQ.'F' .OR. SC.EQ.'J') THEN
        AVEC(jSO4   ) = -1./M0(mH2SO4 )
        AVEC(jHSO4  ) = -1./M0(mH2SO4 )
        AVEC(jNH4   ) =  1./M0(mH2SO4 ) -1./M0(mNH4HS4)
        AVEC(jNA    ) =  1./M0(mH2SO4 ) -1./M0(mNAHSO4)
      ELSEIF (SC.EQ.'B' .OR. SC.EQ.'E') THEN
        SO4I  = MOLAL(jSO4 ) -MOLAL(jH)
        HSO4I = MOLAL(jHSO4) +MOLAL(jH)
        IF (SO4I.LT.HSO4I) THEN
          AVEC(jHSO4) = -1./M0(mNH4HS4)
          AVEC(jSO4 ) =  1./M0(mNH4HS4) -1./M0(mLC)
          AVEC(jH   ) = -2./M0(mNH4HS4) +1./M0(mLC)
        ELSE
          AVEC(jSO4 ) = -1./M0(mNH42S4)
          AVEC(jHSO4) =  1./M0(mNH42S4) -1./M0(mLC)
          AVEC(jH   ) =  2./M0(mNH42S4) -1./M0(mLC)
        ENDIF
      ELSEIF (SC.EQ.'D') THEN
        AVEC(jSO4   ) = -1./M0(mNH42S4)
        AVEC(jHSO4  ) = -1./M0(mNH42S4)
        AML5 = MOLAL(jNH4)-2.D0*(MOLAL(jSO4)+MOLAL(jHSO4))
        IF (AML5.LT.MOLAL(jNO3)) THEN
          AVEC(jNH4 ) =             -1./M0(mNH4NO3)
          AVEC(jSO4 ) = AVEC(jSO4 ) +2./M0(mNH4NO3)
          AVEC(jHSO4) = AVEC(jHSO4) +2./M0(mNH4NO3)
        ELSE
          AVEC(jNO3 ) =             -1./M0(mNH4NO3)
        ENDIF
      ELSEIF (SC.EQ.'G') THEN
        AVEC(jSO4   ) = -1./M0(mNH42S4)
        AVEC(jHSO4  ) = -1./M0(mNH42S4)
        AVEC(jNA    ) =  .5/M0(mNH42S4) -.5/M0(mNA2SO4)
        FRNH4 = MOLAL(jNH4)+MOLAL(jNA)-2.D0*(MOLAL(jSO4)+MOLAL(jHSO4))
        IF (FRNH4.LT.MOLAL(jNO3)) THEN
          AVEC(jNH4 ) =               -1./M0(mNH4NO3)
          AVEC(jNA  ) = AVEC(jNA  )   -1./M0(mNH4NO3)
          AVEC(jSO4 ) = AVEC(jSO4 )   +2./M0(mNH4NO3)
          AVEC(jHSO4) = AVEC(jHSO4)   +2./M0(mNH4NO3)
        ELSE
          AVEC(jNO3 ) =               -1./M0(mNH4NO3)
          FRNH4 = FRNH4 -MOLAL(jNO3)
          IF (FRNH4.LT.MOLAL(jCL)) THEN
            AVEC(jNH4 ) =             -1./M0(mNH4CL)
            AVEC(jNA  ) = AVEC(jNA  ) -1./M0(mNH4CL)
            AVEC(jSO4 ) = AVEC(jSO4 ) +2./M0(mNH4CL)
            AVEC(jHSO4) = AVEC(jHSO4) +2./M0(mNH4CL)
            AVEC(jNO3 ) = AVEC(jNO3 ) +1./M0(mNH4CL)
          ELSE
            AVEC(jCL  ) =             -1./M0(mNH4CL)
          ENDIF
        ENDIF
      ELSEIF (SC.EQ.'H') THEN
        CONST   = SI(jTSO4)/M0(mNA2SO4)
        AVEC(jNA2SO4) =  1./M0(mNA2SO4)
        FRNA = W(jTNA) -2.D0*W(jTSO4)
        DFRNA=SI(jTNA) -2. *SI(jTSO4)
        IF (FRNA.LT.W(jTNO3)) THEN
          CONST = CONST +DFRNA/M0(mNANO3)
          AVEC(jNANO3) =    1./M0(mNANO3)
          FRNO3 = MOLAL(jNO3) -FRNA +CNANO3
          IF (FRNO3.GT.1.D2*TINY) THEN
            IF (FRNO3.LT.MOLAL(jNH4)) THEN
              CONST = CONST              -DFRNA/M0(mNH4NO3)
              AVEC(jNO3  ) =                -1./M0(mNH4NO3)
              AVEC(jNANO3) = AVEC(jNANO3)   -1./M0(mNH4NO3)
              FRNH4 = MOLAL(jNH4) -FRNO3
              IF (FRNH4.LT.MOLAL(jCL)) THEN
                CONST = CONST            +DFRNA/M0(mNH4CL)
                AVEC(jNH4  ) =              -1./M0(mNH4CL)
                AVEC(jNO3  ) = AVEC(jNO3  ) +1./M0(mNH4CL)
                AVEC(jNANO3) = AVEC(jNANO3) +1./M0(mNH4CL)
              ELSE
                AVEC(jCL   ) =              -1./M0(mNH4CL)
              ENDIF
            ELSE
              AVEC(jNH4  ) =                -1./M0(mNH4NO3)
            ENDIF
          ELSE
            FRNH4 = MOLAL(jNH4) -FRNO3
            IF (FRNH4.GT.ZERO) THEN
              IF (MOLAL(jCL).LT.FRNH4) THEN
                AVEC(jCL   ) =              -1./M0(mNH4CL)
              ELSE
                AVEC(jNH4  ) =              -1./M0(mNH4CL)
              ENDIF
            ENDIF
          ENDIF
        ELSE
          CONST = CONST +SI(jTNO3)/M0(mNANO3)
          AVEC(jNANO3) =        1./M0(mNANO3)
          FRNA = FRNA -W(jTNO3)
          DFRNA=DFRNA-SI(jTNO3)
          IF (FRNA.LT.W(jTCL)) THEN
            CONST = CONST +DFRNA/M0(mNACL)
            AVEC(jNACL) =     1./M0(mNACL)
            FRCL = MOLAL(jCL) -FRNA +CNACL
            FRNH4= MOLAL(jNH4) -TINY
            IF (FRNH4.GT.ZERO) THEN
              IF (FRCL.LT.FRNH4) THEN
                CONST = CONST            -DFRNA/M0(mNH4CL)
                AVEC(jCL  ) =               -1./M0(mNH4CL)
                AVEC(jNACL) = AVEC(jNACL)   -1./M0(mNH4CL)
              ELSE
                AVEC(jNH4  ) =              -1./M0(mNH4CL)
              ENDIF
            ENDIF
          ELSE
            CONST = CONST +SI(jTCL)/M0(mNACL)
            AVEC(jNACL) =        1./M0(mNACL)
          ENDIF
        ENDIF
      ELSEIF (SC.EQ.'I') THEN
        ! Get dY/dp from solid-only case
        DO I = 1, NSENS
          TVEC(I) = 0.0
        ENDDO
        CALL DDMISRDRY (SI,TVEC,IERR,IOUT)
        IF (IERR.LT.0) RETURN
        ! dE/dp = dY/dp(from solid-only case) - dY/dp(from current case)
        CONST = TVEC(jNA2SO4)/M0(mNA2SO4) +TVEC(jNAHSO4)/M0(mNAHSO4)
     &         +TVEC(jNH42S4)/M0(mNH42S4) +TVEC(jNH4HS4)/M0(mNH4HS4)
     &         +TVEC(jLC)    /M0(mLC)
        AVEC(jNA2SO4) = 1./M0(mNA2SO4)
        AVEC(jNAHSO4) = 1./M0(mNAHSO4)
        AVEC(jNH42S4) = 1./M0(mNH42S4)
        AVEC(jNH4HS4) = 1./M0(mNH4HS4)
        AVEC(jLC)     = 1./M0(mLC)
      ELSE
        WRITE(IOUT,'(//,A)') 'ERROR in DDMDIFZSR:'
        WRITE(IOUT,'(A,A)')  ' Case not supported - ',SCASE
        IERR = -1
        RETURN
      ENDIF

      RETURN
      END
C     END OF SUBROUTINE DDMDIFZSR


      SUBROUTINE DDMISRMDR (CMDRH,WF)

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    WF
      CHARACTER CMDRH*1                   ! 'D' - dry case; 'L' - saturated liquid case

      REAL      XSAT(NSENS,MXFDDM)        ! Saturated liquid solution of MDRH region
      REAL      DDAMSUL, DDSOSUL, DDAMBIS, DDSOBIS, DDLC, DDAMNIT,
     &          DDAMCHL, DDSONIT, DDSOCHL, DDAMG, DDHAG, DDNAG
      REAL*8    ONEMWF
      INTEGER   IERR, IOUT, I, J
C
C     Initial check
C
      IF ( .NOT.LDDM ) RETURN             ! Check if DDM is being used
      IF ( IPAR.LT.0 ) RETURN             ! Check error from the previous call
      IF ( SCASE.EQ.'G2 ; SUBCASE 3' ) RETURN   ! Skip [G2 ; SUBCASE 3]
C
C     Initialize error flag & unit number of log file
C
      IERR = 1
      IOUT = IPAR
C
C     Solutions of 'dry' and 'saturated liquid' cases
C
      IF (CMDRH.EQ.'D') THEN              ! Dry case
        LMDRH = .TRUE.                    ! Set LMDRH flag
        DO J = 1, NDDMSP
          CALL DDMISRDRY (SINI(1,J),XMAT(1,J),IERR,IOUT)
          IF (IERR.LT.0) GOTO 900
        ENDDO
      ELSE                                ! Saturated liquid case
        IF ( IONIC.LT.TINY2 ) RETURN
        DO J = 1, NDDMSP
          DO I = 1, NSENS
            XSAT(I,J) = 0.0               ! Initialize the solution matrix
          ENDDO
        ENDDO
CCC        MOLAL(jH     ) = MAX(MOLAL(jH     ), TINY)
CCC        MOLAL(jHSO4  ) = MAX(MOLAL(jHSO4  ), TINY)
        CALL DDMISRLIQ (XSAT,IERR,IOUT)
        IF (IERR.LT.0) GOTO 900
C
C     Sum of two weighted solutions
C
        ONEMWF  = ONE - WF
        IF (SCASE(1:1).EQ.'B') THEN ! cbk=> ( MOLAL(5) and MOLAL(6) are differently assigned 
          DO J = 1, NDDMSP
            XSAT(jHSO4,J) = 0.0
          ENDDO
        ENDIF                       ! cbk<=   in CALCB2A2 and CALCB1B than in CALCMDRH. Why? )
        DO J = 1, NDDMSP
C     Sensitivities of salt dissolutions
          DDAMSUL = XMAT(jNH42S4,J) - XSAT(jNH42S4,J)
          DDSOSUL = XMAT(jNA2SO4,J) - XSAT(jNA2SO4,J)
          DDAMBIS = XMAT(jNH4HS4,J) - XSAT(jNH4HS4,J)
          DDSOBIS = XMAT(jNAHSO4,J) - XSAT(jNAHSO4,J)
          DDLC    = XMAT(jLC    ,J) - XSAT(jLC    ,J)
          DDAMNIT = XMAT(jNH4NO3,J) - XSAT(jNH4NO3,J)
          DDAMCHL = XMAT(jNH4CL ,J) - XSAT(jNH4CL ,J)
          DDSONIT = XMAT(jNANO3 ,J) - XSAT(jNANO3 ,J)
          DDSOCHL = XMAT(jNACL  ,J) - XSAT(jNACL  ,J)
C     Sensitivities of gas dissolutions
          DDAMG   = XMAT(jNH3   ,J) - XSAT(jNH3   ,J)
          DDHAG   = XMAT(jHCL   ,J) - XSAT(jHCL   ,J)
          DDNAG   = XMAT(jHNO3  ,J) - XSAT(jHNO3  ,J)
C     Sensitivities at MDRH
          XMAT(jH   ,J) = ONEMWF*XSAT(jH   ,J)
          XMAT(jNA  ,J) = ONEMWF*( 2.*DDSOSUL +DDSOBIS +DDSONIT
     &                                                 +DDSOCHL )
          XMAT(jNH4 ,J) = ONEMWF*( 2.*DDAMSUL +DDAMBIS +3.*DDLC
     &                               +DDAMNIT +DDAMCHL +DDAMG   )
          XMAT(jCL  ,J) = ONEMWF*(    DDAMCHL +DDSOCHL +DDHAG   )
          XMAT(jSO4 ,J) = ONEMWF*(    DDAMSUL +DDSOSUL +DDLC
     &                               -XSAT(jHSO4,J)             )
          XMAT(jHSO4,J) = ONEMWF*(    DDAMBIS +DDSOBIS +DDLC
     &                               +XSAT(jHSO4,J)             )
          XMAT(jNO3 ,J) = ONEMWF*(    DDAMNIT +DDSONIT +DDNAG   )
          XMAT(jH2O ,J) = ONEMWF*XSAT(jH2O ,J)
          DO I = jH2O + 1, NSENS
            XMAT(I,J) = WF*XMAT(I,J) +ONEMWF*XSAT(I,J)
          ENDDO
        ENDDO
      ENDIF

      RETURN

900   CONTINUE
      WRITE(IOUT,'(A)')' The above error occurred in the MDRH region'
      IPAR = IERR
      RETURN

      END
C     END OF SUBROUTINE DDMISRMDR


      SUBROUTINE DDMCALCHA

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    ALFA
      INTEGER   J

      IF (WATER.GT.TINY) THEN
        ALFA = XK3*R*TEMP*(WATER/GAMA(mHCL))**2.0
        DO J = 1, NDDMSP
          XMAT(jCL  ,J) = ( SINI(jTCL,J)*ALFA -XMAT(jH,J)*MOLAL(jCL)
     &                     +GHCL*DALFA(1,J) ) /
     &                    ( MOLAL(jCL) +MOLAL(jH) +ALFA )
        ENDDO
      ENDIF
      DO J = 1, NDDMSP
        XMAT(jHCL ,J) = SINI(jTCL ,J) -XMAT(jCL,J)
        XMAT(jH   ,J) = XMAT(jH   ,J) +XMAT(jCL,J)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMCALCHA


      SUBROUTINE DDMCALCNA

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    ALFA
      INTEGER   J

      IF (WATER.GT.TINY) THEN
        ALFA = XK4*R*TEMP*(WATER/GAMA(mHNO3))**2.0
        DO J = 1, NDDMSP
          XMAT(jNO3 ,J) = ( SINI(jTNO3,J)*ALFA -XMAT(jH,J)*MOLAL(jNO3)
     &                     +GHNO3*DALFA(2,J) ) /
     &                    ( MOLAL(jNO3) +MOLAL(jH) +ALFA )
        ENDDO
      ENDIF
      DO J = 1, NDDMSP
        XMAT(jHNO3,J) = SINI(jTNO3,J) -XMAT(jNO3,J)
        XMAT(jH   ,J) = XMAT(jH   ,J) +XMAT(jNO3,J)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMCALCNA


      SUBROUTINE DDMCALCNHA

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    ALFA1, ALFA2, X2NU, X2DE
      INTEGER   J

      IF (W(jTCL).LE.TINY .AND. W(jTNO3).LE.TINY) THEN
        RETURN
      ELSEIF (W(jTCL).LE.TINY) THEN
        CALL DDMCALCNA
        RETURN
      ELSEIF (W(jTNO3).LE.TINY) THEN
        CALL DDMCALCHA
        RETURN
      ENDIF

      IF (WATER.GT.TINY) THEN
        ALFA1 = XK3*R*TEMP*(WATER/GAMA(mHCL ))**2.0 ! HCL
        ALFA2 = XK4*R*TEMP*(WATER/GAMA(mHNO3))**2.0 ! HNO3
        DO J = 1, NDDMSP
          X2NU = SINI(jTNO3,J)*ALFA2 -XMAT(jH,J)*MOLAL(jNO3)
     &          +GHNO3*DALFA(2,J)
          X2DE = MOLAL(jNO3) +MOLAL(jH) +ALFA2
          XMAT(jCL  ,J) = ( SINI(jTCL,J)*ALFA1 +GHCL*DALFA(1,J)
     &                     -MOLAL(jCL)*(XMAT(jH,J) +X2NU/X2DE) ) /
     &                    ( MOLAL(jCL) +MOLAL(jH) +ALFA1
     &                     -MOLAL(jCL)*MOLAL(jNO3)/X2DE )
          XMAT(jNO3 ,J) = ( X2NU -MOLAL(jNO3)*XMAT(jCL,J) ) / X2DE
        ENDDO
      ENDIF
      DO J = 1, NDDMSP
        XMAT(jHCL ,J) = SINI(jTCL ,J) -XMAT(jCL ,J)
        XMAT(jHNO3,J) = SINI(jTNO3,J) -XMAT(jNO3,J)
        XMAT(jH   ,J) = XMAT(jH   ,J) +XMAT(jCL ,J) +XMAT(jNO3,J)
      ENDDO

      RETURN
      END
C     END OF SUBROUTINE DDMCALCNHA


      SUBROUTINE DDMCALCNH3

      use tracer
      INCLUDE 'isrpia.inc'
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'

      REAL*8    ALFA
      INTEGER   J

      IF (WATER.GT.TINY) THEN
        ALFA = (XKW/XK2)/(R*TEMP)*(GAMA(mNH4NO3)/GAMA(mHNO3))**2.0
        DO J = 1, NDDMSP
          XMAT(jNH3 ,J) = ( XMAT(jNH4,J)*ALFA -XMAT(jH,J)*GNH3
     &                     +MOLAL(jNH4)*DALFA(3,J) ) /
     &                    ( GNH3 +MOLAL(jH) +ALFA )
          XMAT(jNH4 ,J) = XMAT(jNH4 ,J) -XMAT(jNH3,J)
          XMAT(jH   ,J) = XMAT(jH   ,J) +XMAT(jNH3,J)
        ENDDO
      ENDIF

      RETURN
      END
C     END OF SUBROUTINE DDMCALCNH3


      SUBROUTINE DDMISRSAVH (H)
      use tracer
      INCLUDE 'camx.prm'
cbk      INCLUDE 'tracer.com'
      INCLUDE 'ddmisrpia.inc'
      REAL*8    H
      SAVH = H
      RETURN
      END
C     END OF SUBROUTINE DDMISRSAVH

c**** NCF_SET_EMISS_MAPPING
c
      subroutine ncf_set_emiss_mapping(iounit,action)
      use filunit
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine checks which species are in the file and adds them to
c   the master emissions species list. It also sets the array for
c   the index of species into this file.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         iounit        I NCF file ID
c         action        C string that describes file being read
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson-- Original development
c     11/21/25   --gwilson-- Changed the way lemmap works - it now points the other direction
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'vbs.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit
      character*(*) action
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
      integer NUMVBS
      parameter( NUMVBS = 11 )
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*20  this_var(NUM_SOAP_SPECIES), this_mod_species
      integer ispc, ierr, this_varid, i
      logical lfound
c
      integer isoa
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(/,A)') TRIM(action)
      call flush(idiag)
c
      this_var = soap3_spec_names
c
c   --- loop ober species in list ----
c
      do ispc=1,nspec
         this_mod_species = spname(ispc)
c
c   --- seek this species ---
c
         if( luse_soap3 ) then
             do isoa=1,NUM_SOAP_SPECIES
                 if( this_mod_species .EQ. soap3_spec_names(isoa) 
     &                 .AND. this_mod_species(1:4) .NE. 'HOA ' ) 
     &                       this_mod_species = soap2_spec_names(isoa) 
             enddo
         endif
         ierr = nf_inq_varid(iounit,this_mod_species,this_varid)
         if( ierr .NE. NF_NOERR .AND. luse_soap3 .AND. 
     &                   spname(ispc)(1:4) .EQ. 'HOA ') then
             this_mod_species = 'POA'
             ierr = nf_inq_varid(iounit,this_mod_species,this_varid)
         endif
         if( ierr .EQ. NF_NOERR ) then
c
c   --- echo that species was found in this file ---
c
            write(idiag,'(2A)') '   --- Found species: ',TRIM(spname(ispc))
            call flush(idiag)
c
c   --- now check if this species is already in master list ---
c
            lfound = .FALSE.
            do i=1,nemspc
              if(this_mod_species .EQ. emspcname(i) ) then
                 lfound = .TRUE.
                 if( emspcname(i)(1:4) .EQ. 'POA ' .AND. 
     &                          khoa .NE. nspec+1 ) lemmap(i) = khoa
              endif
            enddo
            if( .NOT. lfound ) then
              nemspc = nemspc + 1
              emspcname(nemspc) = this_mod_species
              lemmap(nemspc) = ispc
              if( .NOT. luse_soap3 .AND. 
     &                 emspcname(nemspc)(1:4) .EQ. 'POA '.AND.  
     &                          khoa .NE. nspec+1 ) lemmap(nemspc) = khoa
            endif
         endif
c
c  --- next species ---
c
      enddo
c
c  --- update mapping for HOA species
c
      if( luse_soap3 ) then
         do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
           lfound = .FALSE.
            do i=1,nemspc
              if(soap_emiss_names(isoa) .EQ. emspcname(i) ) then
                lfound = .TRUE.
                idx_ems_soap3(isoa) = i
                lemmap(i) = khoa
              endif
            enddo
            if( .NOT. lfound ) then
              nemspc = nemspc + 1
              emspcname(nemspc) = soap_emiss_names(isoa)
              idx_ems_soap3(isoa) = nemspc
              lemmap(nemspc) = khoa
            endif
         enddo
         lfound = .FALSE.
         do i=1,nemspc
            if(emspcname(i)(1:5) .EQ. 'HOA ' ) idx_ems_hoa = i
            if(emspcname(i)(1:5) .EQ. 'SVOA ' ) then
              lfound = .TRUE.
              if( ksvoa .NE. nspec+1 ) lemmap(i) = ksvoa
              idx_ems_svoa = i
            endif
         enddo
         if( .NOT. lfound ) then
            nemspc = nemspc + 1
            emspcname(nemspc) = 'SVOA       '
            if( ksvoa .NE. nspec+1 ) lemmap(nemspc) = ksvoa
            idx_ems_svoa = nemspc
         endif
      endif
c
c  --- if doing inline emissions, add species needed ---
c
      if( lixemis ) then
         do i=1,nemspc
            if(emspcname(i)(1:4) .EQ. 'HOI ' ) then
              lfound = .TRUE.
              if( khoi .NE. nspec+1 ) lemmap(i) = khoi
            endif
         enddo
         if( .NOT. lfound ) then
            nemspc = nemspc + 1
            emspcname(nemspc) = 'HOI        '
            if( khoi .NE. nspec+1 ) lemmap(nemspc) = khoi
         endif 
         do i=1,nemspc
            if(emspcname(i)(1:3) .EQ. 'I2 ' ) then
              lfound = .TRUE.
              if( ki2 .NE. nspec+1 ) lemmap(i) = ki2
            endif
         enddo
         if( .NOT. lfound ) then
            nemspc = nemspc + 1
            emspcname(nemspc) = 'I2         '
            if( ki2 .NE. nspec+1 ) lemmap(nemspc) = ki2
         endif 
      endif
c
c  --- do VBS or SOAP3 as a separate case ---
c
      if( lvbs .AND. LVBSPREPROC ) then
         do ispc=1,NUMVBS
            ierr = nf_inq_varid(iounit,this_var(ispc),this_varid)
            if( ierr .NE. NF_NOERR  ) cycle
            lfound = .FALSE.
            do i=1,nemspc
              if(this_var(ispc) .EQ. emspcname(i) ) then
                 lfound = .TRUE.
                 lemmap(i) = ispc
                 idx_ems_hoa = i
                 if( luse_soap3 .AND. khoa .NE. nspec+1 ) lemmap(i) = khoa
              endif
            enddo
            if( .NOT. lfound ) then
              nemspc = nemspc + 1
              emspcname(nemspc) = this_var(ispc)
              lemmap(nemspc) = ispc
              idx_ems_hoa = nemspc
              if( luse_soap3 .AND. khoa .NE. nspec+1 ) lemmap(nemspc) = khoa
            endif
c
c   --- echo that species was found in this file ---
c
            write(idiag,'(2A)') '   --- Found species: ',TRIM(this_var(ispc))
            call flush(idiag)
         enddo
      endif
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

c*** CLCEWT
c
      subroutine clcewt(jdate,etim)
      use filunit
      use grid
      use chmstry
      use bndary
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine calculates the weighted reactivity factor for VOC
c   species in each of the source groups.  All of the emissions for the
c   group are read and the emissions are weighted by reactivity factor
c   and summed up.
c
c      Copyright Ramboll
c
c     Argument description:
c        jdate   I   ending date of simulation (YYJJJ)
c        etim    R   ending time of simulation
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/04/96   --gwilson--    Original development
c     10/10/96   --gwilson--    Added code to output emissions and 
c                               reactivity for each grouping.
c     12/08/96   --gwilson--    Added code to set the index into tracer
c                               species list for the PiG sources
c     12/12/96   --gwilson--    Fixed bug in reporting total NOx Tons
c     01/09/97   --gwilson--    Fixed (another) bug in reporting total 
c                               NOx Tons
c     01/12/97   --gwilson--    Fixed bug in calculating the source
c                               region in the fine grid
c     11/06/01   --cemery--     Input dates are now Julian
c     10/28/09   --gwilson--    Made the large local arrays
c                               allocatable to avoid memory issues
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   jdate
      real      etim
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c  CVTTON   R   conversion factor for grams to tons
c
      real   CVTTON
c
      parameter( CVTTON = 907184.7 )
c
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer idx
      integer i, j, ndlast, ncola, nrowa
      integer ncount, ioff, icls, itrc, soap3_nspec
      logical lerror
      real    sumtrc, sumkoh, summir, yldhvoc, yldlvoc, sumcls, difmax, diff
      real    ttlast, sumyld, allmax
c
      real    tonems(MXTRSP), tolerance_val
      real, parameter :: SMALL = 1.e-12

      real, allocatable, dimension(:,:) :: emssum
      real, allocatable, dimension(:,:) :: emsbas
      real, allocatable, dimension(:,:) :: emsoth

      real*8, allocatable, dimension(:,:,:) :: emslft
      real*8, allocatable, dimension(:,:,:) :: emstot

      logical lemit(MXALCLS)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      tolerance_val = 0.0017
c
c  --- allocate the local arrays ---
c
      soap3_nspec = nspec
      if( luse_soap3 .AND. lsoa ) soap3_nspec = 
     &                 nspec+(IDX_SOAP_POA_BB-IDX_SOAP_POA_OP+1)
      
      allocate( emssum(soap3_nspec,soap3_ntotsp) )
      allocate( emsbas(soap3_nspec,soap3_ntotsp) )
      allocate( emsoth(soap3_nspec,soap3_ntotsp) )
c
      ncola = maxval( ncol(1:ngrid) )
      nrowa = maxval( nrow(1:ngrid) )
      allocate( emslft(ncola,nrowa,soap3_nspec) )
      allocate( emstot(ncola,nrowa,soap3_nspec) )
c
c   --- set the date and times ---
c
      lerror = .FALSE.
      ndlast = jdate 
      ttlast = etim/100.0
      if( ttlast .EQ. 0.0 ) then
         ttlast = 24.0
         ndlast = ndlast - 1 
      endif
c
c   --- initialize the array to zero ---
c
      tonems = 0.
      emssum = 0.
      emsbas = 0.
      emsoth = 0.
      emstot = 0.
      emslft = 0.
      lemit = .FALSE.
c
c   --- loop over all of the groups ----
c
      call sumgrps(ncola,nrowa,soap3_nspec,soap3_nsaspc,ndlast,ttlast*100.,emstot,
     &                           emslft,emsbas,emsoth,emssum,lemit)
      call ncf_sumgrps(ncola,nrowa,soap3_nspec,soap3_nsaspc,ndlast,ttlast,emstot,
     &                           emslft,emsbas,emsoth,emssum,lemit)
c
c  --- check that all emissions are accounted for (could have some
c      machine fuzz) ----
c
      allmax = -99999999.
      do idx=1,soap3_nspec
         difmax = -99999999.
         do j=2,nrow(1)-1
            do i=2,ncol(1)-1
               if( emstot(i,j,idx) .NE. 0. ) then 
                  diff = ABS( (emstot(i,j,idx) - 
     &                        emslft(i,j,idx)) / emstot(i,j,idx) )
                  if( diff .GT. difmax ) then
                      imax = i
                      jmax = j
                      difmax = diff
                  endif
                  allmax = MAX(diff,allmax)
               endif
               if( emstot(i,j,idx) .LE. 0. .AND. emslft(i,j,idx) .GT. 0. ) then
                  diff = 100.
                  if( diff .GT. difmax ) then
                      imax = i
                      jmax = j
                      difmax = diff
                  endif
                  allmax = MAX(diff,allmax)
               endif

            enddo
         enddo
         if( .NOT. leftovr_area .AND. (difmax .GT. tolerance_val)
     &                                       .AND. .NOT. lerror ) then
             write(iout,'(//,a)') 'ERROR in CLCEWT:'
             if( emslft(imax,jmax,idx) .LT. emstot(imax,jmax,idx) ) then
                 write(iout,'(/,1X,2A)') 'There is a significant amount ',
     &             'of emissions unaccounted for in source groupings.'
                 write(iout,'(1X,2A)') 'You should turn on the ',
     &            'Use_Gridded_Leftover_Group group flag in job script.'
             else
                 write(iout,'(/,1X,2A)') 'There is an inconsistency between ',
     &             'model emissions and source group emissions.'
                 write(iout,'(1X,2A)') 'Please check all of your emissions files.'
             endif
             write(iout,'(1X,2A)') 'See the .diag file for an ',
     &                                             'emissions table.'
             if( idx .LE. nspec ) then
                 write(iout,'(/,A,A)') 'Species: ',spname(idx)
             else
                 write(iout,'(/,A,A)') 'Species: ',soap_emiss_names(idx-nspec+IDX_SOAP_POA_OP-1)
             endif
             write(iout,'(A,2I5)') 'Cell Index: ',imax,jmax
             write(iout,'(A,E11.5)') 'Value in regular model files  : ',
     &                                            emstot(imax,jmax,idx) 
             write(iout,'(A,E11.5)') 'Value in emissions group files: ',
     &                                            emslft(imax,jmax,idx) 
             lerror = .TRUE.
         endif
      enddo
      if( leftovr_area .AND. (allmax .LE. 0.0005) .AND. .NOT. lerror ) then
          write(iout,'(//,a)') 'ERROR in CLCEWT:'
          write(iout,'(/,1X,2A)') 'The "leftover" emissions group ',
     &                       'has an insignificant amount of emissions.'
          write(iout,'(1X,2A)') 'You should turn off the ',
     &                        '"leftover_area group" flag in job script.'
          write(iout,'(1X,2A)') 'See the .diag file for an ',
     &                                                'emissions table.'
          lerror = .TRUE.
      endif
c
c  --- all emissions are summed, calculate the weghted fraction ----
c
      do icls=1,ntrcls
        do 10 i=iptcls(icls),nptcls(icls)
c
c   --- ignore if this is an initial condition or boundary condition
c       tracer ---
c
           if( ptname(i)(7:8) .EQ. 'IC' ) goto 10
           if( ptname(i)(7:8) .EQ. 'BC' ) goto 10
c
c   --- find the class for this species ---
c
           sumtrc = SMALL
           sumkoh = SMALL
           summir = SMALL
           sumyld = SMALL
           yldhvoc = 0.
           yldlvoc = 0.
           do idx=1,nspec
              if( emssum(idx,i) .GT. 0 ) then
                 sumtrc = sumtrc + emssum(idx,i) * trspmap(idx,icls)
                 sumkoh = sumkoh + emssum(idx,i) * rkohrt(idx) * 
     &                                           trspmap(idx,icls)
                 summir = summir + emssum(idx,i) * rmirrt(idx) * 
     &                                           trspmap(idx,icls)
                 if( yhratmap(idx,icls) .GT. 0. .OR.
     &               ylratmap(idx,icls) .GT. 0. ) then
                    sumyld = sumyld + emssum(idx,i)
                    yldhvoc = yldhvoc + emssum(idx,i) * yhratmap(idx,icls)
                    yldlvoc = yldlvoc + emssum(idx,i) * ylratmap(idx,icls)
                 endif
                 if( trspmap(idx,icls) .GT. 0. ) tonems(i) = 
     &                  tonems(i) + emssum(idx,i) * mwspec(idx) / CVTTON
              endif
           enddo
           if( sumtrc .GT. SMALL ) then
              wtkoh(i) = sumkoh / sumtrc
              wtmir(i) = summir / sumtrc
           else
              wtkoh(i) = 0.
              wtmir(i) = 0.
           endif
           if( sumyld .GT. SMALL ) then
              yhrates(i) = yldhvoc / sumyld
              ylrates(i) = yldlvoc / sumyld
           else
              yhrates(i) = 0.
              ylrates(i) = 0.
           endif
  10    continue
      enddo
      idx = nspec
      do icls=ntrcls+1,soap3_ntrcls
        iclass = icls - ntrcls + (IDX_SOAP_POA_OP-1)
        idx = idx + 1 
        do i=soap3_iptcls(iclass),soap3_nptcls(iclass)
c
c   --- ignore if this is an initial condition or boundary condition
c       tracer ---
c
           if( ptname(i)(7:8) .EQ. 'IC' ) goto 10
           if( ptname(i)(7:8) .EQ. 'BC' ) goto 10
c
c   --- find the class for this species ---
c
           sumtrc = 0.
           sumkoh = 0.
           summir = 0.
           sumyld = 0.
           yldhvoc = 0.
           yldlvoc = 0.
           tonems(i) = tonems(i) + emssum(idx,i) / CVTTON
        enddo
      enddo
c
c  --- calculate the "leftover" group from lump sums ---
c
      if( leftovr_area ) then
         do icls=1,ntrcls
            do i=1,nregin
               sumtrc = 0.
               sumkoh = 0.
               summir = 0.
               sumyld = 0.
               yldhvoc = 0.
               yldlvoc = 0.
               do idx=1,nspec
                  itrc = iemcls(icls) - 1 + i + ngroup*nregin
                  diff = emsbas(idx,itrc) - emsoth(idx,itrc)
                  if( diff .GT. 0. ) then
                      sumtrc = sumtrc + diff * trspmap(idx,icls)
                      sumkoh = sumkoh + diff * rkohrt(idx) * 
     &                                            trspmap(idx,icls)
                      summir = summir + diff * rmirrt(idx) * 
     &                                            trspmap(idx,icls)
                      if( yhratmap(idx,icls) .GT. 0. .OR.
     &                    ylratmap(idx,icls) .GT. 0. ) then
                         sumyld = sumyld + diff
                         yldhvoc = yldhvoc + diff * yhratmap(idx,icls)
                         yldlvoc = yldlvoc + diff * ylratmap(idx,icls)
                      endif
                      if( trspmap(idx,icls) .GT. 0. ) tonems(itrc) = 
     &                      tonems(itrc) + diff * mwspec(idx) / CVTTON
                  endif
                enddo
                if( sumtrc .GT. SMALL) then
                    wtkoh(itrc) = sumkoh / sumtrc
                    wtmir(itrc) = summir / sumtrc
                else
                    wtkoh(itrc) = 0.
                    wtmir(itrc) = 0.
                endif
                if( sumyld .GT. SMALL) then
                    yhrates(itrc) = yldhvoc / sumyld
                    ylrates(itrc) = yldlvoc / sumyld
                else
                    yhrates(itrc) = 0.
                    ylrates(itrc) = 0.
                endif
            enddo
         enddo
         idx = nspec
         do icls=ntrcls+1,soap3_ntrcls
            iclass = icls - ntrcls + (IDX_SOAP_POA_OP-1)
            idx = idx + 1 
            do i=1,nregin
               itrc = soap3_iemcls(iclass) - 1 + i + ngroup*nregin
               diff = emsbas(idx,itrc) - emsoth(idx,itrc)
               tonems(itrc) = tonems(itrc) + diff / CVTTON
                wtkoh(itrc) = 0.
                wtmir(itrc) = 0.
                yhrates(itrc) = 0.
                ylrates(itrc) = 0.
            enddo
         enddo
      endif
c
c  --- echo the data if doing ozone ---
c
      do icls=1,soap3_ntrcls
          if( idxcls(icls) .EQ. ITROON .OR.
     &        idxcls(icls) .EQ. ITROOV ) CYCLE 
          if( ngroup .EQ. 0 ) then
              ioff = 0
              ncount = 0
          else
              if( leftovr_area ) then
                  ncount = ngroup + 1
              else
                  ncount = ngroup
              endif
              ioff = 1
          endif
          iclass = icls
          if( icls .GT. ntrcls ) iclass = icls - ntrcls + (IDX_SOAP_POA_OP-1)
          do i=ioff,ncount
             if( lemit(icls) ) then
                write(idiag,9000) 'Species   ','Group ','Region ',
     &                  '     Average ','Emissions' 
                write(idiag,9001)' ','Reactivity','(Tons)'
                write(idiag,9002) ('-',j=1,60)
                sumcls = 0.
                do j=1,nregin
                   if( i .GT. 0 ) then
                      itrc = iemcls(icls) - 1 + j + (i-1)*nregin
                      if( icls .GT. ntrcls ) itrc = soap3_iemcls(iclass) - 1 + j + (i-1)*nregin
                   else
                      itrc = iemcls(icls) - 1 + j
                      if( icls .GT. ntrcls ) itrc = soap3_iemcls(iclass) - 1 + j
                   endif
                   if( icls .LE. ntrcls ) then
                       if( tonems(itrc) .LE. 0. ) then
                          write(idiag,9003) ptname(itrc),i,j,
     &                                       wtkoh(itrc),tonems(itrc)
                       else if( tonems(itrc) .GT. 0. .AND.
     &                                   tonems(itrc) .LE. 0.01 ) then
                          write(idiag,9006) ptname(itrc),i,j,
     &                                       wtkoh(itrc),tonems(itrc)
                       else if( tonems(itrc) .GT. 0.01 .AND.
     &                                     tonems(itrc) .LE. 10. ) then
                      write(idiag,9004) ptname(itrc),i,j,
     &                                       wtkoh(itrc),tonems(itrc)
                       else if( tonems(itrc) .GT. 10. .AND. 
     &                                  tonems(itrc) .LE. 999999.) then
                          write(idiag,9005) ptname(itrc),i,j,
     &                                       wtkoh(itrc),tonems(itrc)
                       else 
                          write(idiag,9006) ptname(itrc),i,j,
     &                                       wtkoh(itrc),tonems(itrc)
                       endif
                   else
                       if( tonems(itrc) .LE. 0. ) then
                          write(idiag,9003) ptname(itrc),i,j,
     &                                       0.,tonems(itrc)
                       else if( tonems(itrc) .GT. 0. .AND.
     &                                   tonems(itrc) .LE. 0.01 ) then
                          write(idiag,9006) ptname(itrc),i,j,
     &                                       0.,tonems(itrc)
                       else if( tonems(itrc) .GT. 0.01 .AND.
     &                                     tonems(itrc) .LE. 10. ) then
                      write(idiag,9004) ptname(itrc),i,j,
     &                                       0.,tonems(itrc)
                       else if( tonems(itrc) .GT. 10. .AND. 
     &                                  tonems(itrc) .LE. 999999.) then
                          write(idiag,9005) ptname(itrc),i,j,
     &                                       0.,tonems(itrc)
                       else 
                          write(idiag,9006) ptname(itrc),i,j,
     &                                       0.,tonems(itrc)
                       endif
                   endif
                   sumcls = sumcls + tonems(itrc)
                enddo
                write(idiag,9002) ('-',j=1,60)
                if( sumcls .LE. 0. ) then
                   write(idiag,9013) 'Total',0.,sumcls
                else if( sumcls .GT. 0. .AND. sumcls .LE. 10. ) then
                   write(idiag,9014) 'Total',0.,sumcls
                else if( sumcls .GT. 10. .AND. sumcls .LE. 999999.) then
                   write(idiag,9015) 'Total',0.,sumcls
                else
                   write(idiag,9016) 'Total',0.,sumcls
                endif
             endif
          enddo
       enddo
       write(idiag,'(//)')
c
c  --- deallocate the local arrays ---
c
      deallocate( emssum )
      deallocate( emsbas )
      deallocate( emsoth )
c
      deallocate( emslft )
      deallocate( emstot )
c
c  --- return to the calling routine ---
c
      if( lerror ) call camxerr()
      goto 9999
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,1X,A10,3X,A,3X,A,3X,A13,4X,A)
 9001 format(1X,A10,25X,A10,3X,A10,3X,A10,3X,A10)
 9002 format(100(A1))
 9003 format(1X,A10,4X,I3,5X,I3,6X,F10.1,3X,F10.0)
 9004 format(1X,A10,4X,I3,5X,I3,6X,F10.1,3X,F10.3)
 9005 format(1X,A10,4X,I3,5X,I3,6X,F10.1,3X,F10.1)
 9006 format(1X,A10,4X,I3,5X,I3,6X,F10.1,3X,E10.4)
 9013 format(1X,A10,21X,F10.1,3X,F10.0)
 9014 format(1X,A10,21X,F10.1,3X,F10.3)
 9015 format(1X,A10,21X,F10.1,3X,F10.1)
 9016 format(1X,A10,21X,F10.1,3X,E10.4)
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

C***** RDARGRP
c
      subroutine ncf_rdargrp(igrid,ndate,ttime,nox,noy,nlay_ems,
     &                                          numcls,igroup,emscls)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
      implicit none
c
c      Copyright Ramboll
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      integer ndate
      real    ttime
      integer nox
      integer noy
      integer nlay_ems
      integer numcls
      integer igroup
      real    emscls(numcls,nox,noy,nlay_ems)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname, action
      character*10  this_var
      character*4   iname(10)
      integer       idx_poa_xx(IDX_SOAP_POA_OP:IDX_SOAP_POA_BB), this_class
      integer       ispc, num_emsfiles, idxfile, this_dat
      integer       iounit, iseg, i, j, k, nlays_in, buffer_offset
      integer       data_start(4), data_count(4), itmp, jtmp
      integer       icls, ierr, this_date, this_varid, isoa
      integer       this_time_tflag, this_time_etflag, this_tstep
      integer       iemspec
      real          this_time
      logical       use_this_file
c
      real, allocatable, dimension(:,:,:) :: emsgrd
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if( .NOT. larsrc ) goto 9999
      idx_poa_xx = -9
      icls = ntrcls
      if( luse_soap3 ) then
         do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
            icls = icls + 1
            do iemspec = 1,nemspc
               if( emspcname(iemspec) .EQ. soap_emiss_names(isoa) )
     &                                       idx_poa_xx(isoa) = iemspec
            enddo
         enddo
      endif
c
c   --- skip if filename not supplied ---
c
      num_emsfiles = num_iortem(igrid,igroup)
      if( igroup .EQ. 0 ) num_emsfiles = nemiss_files(igrid)
c
c   --- loop over all files ---
c
      do 10 idxfile=1,num_emsfiles
        use_this_file = .TRUE.
c
c   --- set the unit number for surface emissions file ---
c
        if( igroup .EQ. 0 ) then
            iounit = iarem(igrid,idxfile)
            write(fname,'(A,I10)') 'EMISSIONS -- UNIT ',iarem(igrid,idxfile)
            if( .NOT. is_netcdf_iarem(igrid,idxfile) ) use_this_file = .FALSE.
            write(action,'(2A,I3,A,I3)') 'Reading the NetCDF ',
     &                              'gridded emissions file. Grid: ',
     &                                           igrid,' File: ',idxfile
            buffer_offset = buffer_offset_iarem(igrid,idxfile)
        else
            iounit = iortem(igrid,igroup,idxfile)
            fname = temfil(igrid,igroup,idxfile)
            if( .NOT. is_netcdf_iortem(igrid,igroup,idxfile) ) use_this_file = .FALSE.
            write(action,'(2A,I3,A,I3,A,I3)') 'Reading the SA NetCDF ',
     &                     'gridded emissions file. Grid: ',igrid,
     &                                    ' Group: ',igroup,' File: ',idxfile
            buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
        endif
        if( .NOT. use_this_file ) cycle
c
c   ---- get the number of layers in this file ---
c
        this_var = 'NLAYS'
        ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NLAYS', nlays_in)
        if( ierr .NE. NF_NOERR ) goto 7000
c
c   --- allocate the local array ---
c
        allocate( emsgrd(nox-2*buffer_offset,noy-2*buffer_offset,nlays_in) )
c
c   --- if number of layers is not 1 make sure it matches grid ---
c
        if( nlays_in .NE. 1 .AND. nlays_in .NE. nlay(igrid) ) goto 7001
c
c   --- set the indexes for what to read ---
c
        data_start(1) = 1
        data_count(1) = nox-2*buffer_offset
        data_start(2) = 1
        data_count(2) = noy-2*buffer_offset
        data_start(3) = 1
        data_count(3) = nlays_in
c
c  ---- get the index for timestep containing this time ----
c
        this_date = ndate
        this_time = ttime
        this_tstep = ncf_get_tstep(iounit,action,
     &              ndate,ttime,this_time_tflag,this_time_etflag,
     &                                                       le1day,.TRUE.)
        data_start(4) = this_tstep
        data_count(4) = 1
c
c  ---- loop over the list of emissions spcies ---
c
        do iemspec=1,nemspc
            if( lemmap(iemspec) .LE. 0 ) cycle
            emsgrd = 0.
            ispc = iemspec
            this_var = emspcname(iemspec)
c
c  --- load data into temporary arrray ---
c
            ierr = nf_inq_varid(iounit, this_var, this_varid)
            if( ierr .NE. NF_NOERR) cycle
            ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                               data_count,emsgrd)
            if( ierr .NE. NF_NOERR) goto 7002
c
c ---- convert the units ---
c
            emsgrd = emsgrd / (60.*dtems)
c
c--- if this is a POA_XX species set the flag for it ---
c
            if( lsoa .AND. this_var(1:4) .EQ. 'POA ') ispc = idx_poa_xx(IDX_SOAP_POA_AV)
c
c   --- skip if the species is a not used for SA ---
c
            if( .NOT. lusespc(lemmap(iemspec)) ) cycle
c
c   --- load the species into the cells in tracer array ----
c
            if( this_var(1:4) .NE. 'POA ' .AND. this_var(1:4) .NE. 'POA_' ) then
               do icls=1,ntrcls
                  this_class = icls
                  do k=1,nlays_in
                     do j=1+buffer_offset,noy-buffer_offset
                        jtmp = j-buffer_offset
                        do i=1+buffer_offset,nox-buffer_offset
                          itmp = i-buffer_offset
c
c   --- load into the tracer emissions array ---
c
                          emscls(this_class,i,j,k) = emscls(this_class,i,j,k) +
     &                        emsgrd(itmp,jtmp,k) * trspmap(lemmap(ispc),this_class)
                        enddo
                     enddo
                  enddo
               enddo
            endif
c
c --- now handle POA ---
c
            if( emspcname(iemspec)(1:4) .EQ. 'POA ' .AND. lsoa ) then
               this_class = ntrcls + IDX_SOAP_POA_AV - IDX_SOAP_POA_OP + 1
               do k=1,nlays_in
                  do j=1+buffer_offset,noy-buffer_offset
                     jtmp = j-buffer_offset
                     do i=1+buffer_offset,nox-buffer_offset
                       itmp = i-buffer_offset
                       emscls(this_class,i,j,k) = emscls(this_class,i,j,k) +
     &                                                     emsgrd(itmp,jtmp,k)
                     enddo
                  enddo
               enddo
            endif
        enddo
c
c   --- if doing SOAP3 now look for SOAP3 species and process separately ---
c
        icls = ntrcls
        if( luse_soap3 .AND. lsoa ) then
           do ispc=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
             icls = icls + 1
c
c  --- load data into temporary arrray ---
c
             this_var = soap_emiss_names(ispc)
             ierr = nf_inq_varid(iounit, this_var, this_varid)
             if( ierr .NE. NF_NOERR) cycle
             emsgrd = 0.
             ierr = nf_get_vara_real(iounit,this_varid,data_start,
     &                                              data_count,emsgrd)
             if( ierr .NE. NF_NOERR) goto 7001
             if( idx_poa_xx(ispc) .LE. 0 ) cycle
c
c ---- convert the units ---
c
             emsgrd = emsgrd / (60.*dtems)

c   --- load the species into the cells in tracer array ----
c
             do k=1,nlays_in
              do j=1+buffer_offset,noy-buffer_offset
                 jtmp = j-buffer_offset
                 do i=1+buffer_offset,nox-buffer_offset
                   itmp = i-buffer_offset
c
c   --- load into the tracer emissions array ---
c
                    emscls(icls,i,j,k) = emscls(icls,i,j,k) +
     &                                           emsgrd(itmp,jtmp,k)
                 enddo
              enddo
             enddo
           enddo
        endif
c
c  --- next file in grid/group ---
c
        deallocate( emsgrd )
 10   continue
c
      goto 9999
c
c----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARGRP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARGRP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Number of layers does not match: '
      write(iout,'(A,I4)') 'User supplied: ',nlays_in
      write(iout,'(A,I4)') 'Value in file: ',nlay(igrid)
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDARGRP:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 9999 continue
c
      return
      end

      subroutine finwind(ncol,nrow,nlay,io,jo,nmesh,ncolf,
     &                   nrowf,nlayf,windu,windv,winduf,windvf)
c
c----CAMx v7.40 260801
c
c     FINWIND estimates wind speed for a fine grid from its parent
c
c      Copyright Ramboll
c
c     Modifications:
c        11/06/01  Input dates are now Julian
c        11/04/09  Removed setting nest grid boundary winds from parent
c        11/05/12  Removed vertical nesting
c
c     Input arguments:
c        ncol              number of columns on parent grid
c        nrow              number of rows on parent grid
c        nlay              number of layers on parent grid
c        io,jo             parent starting grid cell indices
c        nmesh             fine grid meshing factor
c        ncolf             number of columns on fine grid
c        nrowf             number of rows on fine grid
c        nlayf             number of layers on fine grid
c        windu             u-component wind speed on parent grid (m/s)
c        windv             v-component wind speed on parent grid (m/s)
c
c     Output arguments:
c        winduf            u-component wind speed on fine grid (m/s)
c        windvf            v-component wind speed on fine grid (m/s)
c
c     Subroutine called:
C        none
c
c     Called by:
c        STARTUP
c        INTRPDAT
c
      implicit none
      integer ncol,nrow,nlay,io,jo,nmesh,ncolf,nrowf,nlayf
      real    windu(ncol,nrow,nlay)
      real    windv(ncol,nrow,nlay)
      real    winduf(ncolf,nrowf,nlayf)
      real    windvf(ncolf,nrowf,nlayf)
c
      integer kp,kg,i,ii,j,jj,i1,j1
      real du,dv
c
c-----Entry point
c
c-----Assign wind speed to the fine grid: mass is conserved
c
      do 50 kp = 1,nlay
          kg = kp
c
c-----Use the wind where it available from the parent grid
c
          do j = 2,nrowf-1
            do i = 1,ncolf-1,nmesh
              ii = io - 1 + (i-1)/nmesh
              jj = jo + (j-2)/nmesh
              winduf(i,j,kg) = windu(ii,jj,kp)
            enddo
          enddo
c
          do j = 1,nrowf-1,nmesh
            do i = 2,ncolf-1
              ii = io + (i-2)/nmesh
              jj = jo - 1 + (j-1)/nmesh
              windvf(i,j,kg) = windv(ii,jj,kp)
            enddo
          enddo
c
c-----Interpolate in between
c
          do j = 2,nrowf-1
            do i = 1,ncolf-nmesh,nmesh
              du = (winduf(i+nmesh,j,kg)-winduf(i,j,kg))/nmesh
              do i1 = i+1,i+nmesh-1
                winduf(i1,j,kg) = winduf(i1-1,j,kg) + du
              enddo
            enddo
          enddo
c
          do j = 1,nrowf-nmesh,nmesh
            do i = 2,ncolf-1
              dv = (windvf(i,j+nmesh,kg)-windvf(i,j,kg))/nmesh
              do j1 = j+1,j+nmesh-1
                windvf(i,j1,kg) = windvf(i,j1-1,kg) + dv
              enddo
            enddo
          enddo
c
  50  continue
c
      return
      end

      subroutine luassgn(ncol,nrow,nlu,io,jo,nmesh,ncolf,nrowf,fsurf,
     &                   fsurff)
c
c----CAMx v7.40 260801
c
c     LUASSGN assigns land use value for fine grid from that of its 
c     parent grid
c
c      Copyright Ramboll
c          
c     Modfications:
c        none
c
c     Input arguments:
c        ncol                number of columns
c        nrow                number of rows
c        nlu                 number of landuse categories
c        io                  starting i index for the fine grid
c        jo                  starting j index for the fine grid
c        nmesh               mesh number
c        ncolf               number of columns in fine grid
c        nrowf               number of rows in fine grid
c        fsurf               cell centered variable on coarse grid
c
c     Output arguments:
c        fsurff              cell centered variable on coarse grid
c
c     Routines called:
c        none
c
c     Called by:
c        STARTUP
c
      dimension fsurf(ncol,nrow,nlu),fsurff(ncolf,nrowf,nlu)
c
      do 50 l = 1,nlu
        do 40 jfin = 2,nrowf-1
          j = (jfin - 2)/nmesh + jo
          do 30 ifin = 2,ncolf-1
            i = (ifin - 2)/nmesh + io
            fsurff(ifin,jfin,l) = fsurf(i,j,l)
  30      continue
  40    continue
  50  continue
c
      return
      end

      SUBROUTINE HGGASCHEM ( CHG0, CHG2, CO3, CH2O2, COH, CBR,
     &                       CBRO, TEMP, PRES, DELT )
C
c----CAMx v7.40 260801
C
C   HGGASCHEM performs the Hg gas-phase chemistry calculations.
C
C     Copyright 2003
C     AER, Inc.
C 
C Revision History: 
C***********************************************************************
C   Version 1.0 written March 2003 by Prakash Karamchandani, AER       *
C                                                                      *
C   Updated May 2011 by PK, Ramboll:                                   **
C      Add Hg(0)oxidation by bromine species (Br, BrO)                 *
C      Remove Cl2, HCl reactions (unimportant)                         *
C*********************************************************************** 
C
C  Called by:  CHEMDRIV
C
C*********************************************************************** 

      IMPLICIT NONE

C Includes:

      INCLUDE 'hggaschm.prm'  ! Hg gas-phase chemistry parameters

C Arguments:

      REAL  CHG0      ! Hg(0) concentration, ppm (Input/Output)
      REAL  CHG2      ! Hg(2) concentration, ppm (Input/Output)

      REAL  CO3       ! O3 concentration, ppm (Input only)
      REAL  CH2O2     ! H2O2 concentration, ppm (Input only)
      REAL  COH       ! OH concentration, ppm (Input only)
      REAL  CBR       ! Br concentration, ppm (Input only)
      REAL  CBRO      ! BrO concentration, ppm (Input only)

      REAL  TEMP      ! Temperature, K (Input only)
      REAL  PRES      ! Pressure, mb (Input only)
      REAL  DELT      ! Chemistry time step, seconds (Input only)

! Local variables

! Standard atmosphere in mb
      REAL, PARAMETER :: STDATMMB = 1013.25

! Pressure in atmospheres
      REAL PRES_ATM

! Conv. factor for rate constants (from (mol/cc)-1 s-1 to ppm-1 s-1)
      REAL  CFACT

! Local rate constants (ppm-1 s-1 units)
      REAL  RKO3L, RKOHL, RKH2O2L, RKBRL

! Local rate constants for individual bromine species reactions
      REAL*8 :: RK1, RK2, RK3, RK4, RK5

! Effective 1st order rate constant for Hg(0) -> Hg(2)
      REAL  RKHG0L

! Decrease in Hg(0) conc. due to chemistry
      REAL  DHG0
C-----------------------------------------------------------------------

! Convert 2nd-order rate constants from mol/cc-s units to ppm-s units
      PRES_ATM = PRES / STDATMMB
      CFACT    = COEF1 * PRES_ATM / TEMP

      RKO3L   = RKO3 * CFACT
      RKOHL   = RKOH * CFACT
      RKH2O2L = RKH2O2 * CFACT

! Rate constants for bromine reactions in ppm-sec units
      RK1 = RK1BR*PRES_ATM*(TEMP/298.0)**(-1.86) * CFACT
      RK2 = RK2BR*EXP(-8357.0/TEMP)
      RK3 = RK3BR*(TEMP/298.0)**(-0.57) * CFACT
      RK4 = RK4BR*(TEMP/298.0)**(-0.57) * CFACT
      RK5 = RKBRO * CFACT  ! No temperature dependence info available
C
C --- Calculate effective first-order rate constant for bromine reactions
      RKBRL = RK1*CBR * (RK3*CBR + RK4*COH) /
     &            (RK2 + RK3*CBR + RK4*COH) + RK5*CBRO

! Calculate effective 1st-order rate constant for Hg(0) to Hg(2) oxidation
! assuming that oxidant species concentrations are constant
      RKHG0L = (RKO3L*CO3 + RKOHL*COH + RKH2O2L*CH2O2 + RKBRL)

! Decrease in Hg(0) conc. due to gas-phase oxidation
      DHG0 = CHG0 * ( 1. - EXP( -RKHG0L * DELT ) )

      CHG0 = CHG0 - DHG0
      CHG2 = CHG2 + DHG0

      RETURN
      END

      subroutine pigsampl(m1,m2,m3,ioff,joff,lrtrac,igrd,lgrd,
     &                    nsp,nav,nxs,nys,nrow,meshnst,inst1,jnst1,dt,
     &                    delx,dely,deltax,deltay,tempk,press,conc,cncsmp)
      use camxcom
      use chmstry
      use pigsty
      use tracer
      use rtracchm
      use node_mod
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGSAMPL increments the time-averaged concentrations on PiG/RTRAC
c     sampling grids.
c
c      Copyright Ramboll
c
c     Modifications: 
c        8/2/05       Generalized to sample regular model species or
c                     RTRAC species.
c        6/22/07      Temperature/pressure arrays interpolated to sampling
c                     grid for smoother results in complex terrain.
c       06/04/09      Added sigmax
c       10/29/15      Fixed MPI-related bugs, revised vertical sampling 
c                     criterion to be 10 m (rather than layer 1)
c
c     Input arguments:
c        m1                 number of columns in this slice
c        m2                 number of row in this slice
c        m3                 number of layers in this slice
c        ioff               X offset of slice in full domain
c        joff               Y offset of slice in full domain
c        lrtrac             Rtrac flag
c        igrd               nested grid index
c        lgrd               sampling grid index
c        nsp                number of species in input field
c        nav                number of species in output average field
c        nxs                number of sampling grid columns
c        nys                number of sampling grid rows
c        nrow               number of computational grid rows
c        meshnst            meshing factor for computational grid
c        inst1              starting I index of comp grid rel to master grid 
c        jnst1              starting J index of comp grid rel to master grid 
c        dt                 time step for computational grid concentration (s)
c        delx               master x-grid spacing in input units (km or deg)
c        dely               master y-grid spacing in input units (km or deg)
c        deltax             computational grid spacing in x (m)
c        deltay             computational grid spacing in y (m)
c        tempk              computational grid temperature field (K)
c        press              computational grid pressure field (mb)
c        conc               instantaneous gridded concentration (gas=umol/m3,
c                                                                other=ug/m3)
c        cncsmp             average sampling grid concentration (gas=ppm,
c                                                                other=ug/m3)
c
c     Output arguments:
c        cncsmp             average sampling grid concentration (gas=ppm,
c                                                                other=ug/m3)
c
c     Routines Called:
c        PIGCOORD
c        SMPL1PUF
c
c     Called by:
c        CAMx
c
      include "camx.prm"
      include "flags.inc"
c
      integer MXOUT
      parameter (MXOUT = MAX(MXSPEC,MXTRSP))

      integer m1
      integer m2
      integer m3
      integer ioff
      integer joff
      logical lrtrac
      integer igrd
      integer lgrd
      integer nsp
      integer nav
      integer nxs
      integer nys
      integer nrow
      integer meshnst
      integer inst1
      integer jnst1
      real    dt
      real    delx
      real    dely
      real    deltax(nrow)
      real    deltay
      real    tempk(m1,m2,m3)
      real    press(m1,m2,m3)
      real    conc(m1,m2,m3,nsp)
      real    cncsmp(nxs,nys,nav)
c
      real convfac(MXCOLSMP,MXROWSMP,MXOUT)
      real avcnc(MXCOLSMP,MXROWSMP,MXOUT)
      real pmass(MXOUT)
      real bndlow(MXOUT)
c
      integer l,mfac,jc,j,ic,i,n,nr,idum,jj,ng,ll,pgrd
      real dtfact,yc,xc,yf,xf,
     &     dcdx1,dcdx2,c1,c2,dcdy,xpig,ypig,fpigx,fpigy,bpigx,bpigy,
     &     xpmin,xpmax,ypmin,ypmax,xmax,ymax,xlen,sigxx,pdepth
      real deltaxs,deltays,tsmp,psmp
c
      common /compigsampl/ convfac, avcnc
c
c-----Entry point
c
      avcnc = 0.
      dtfact = dt/(dtout*60.)
      mfac = meshsmp(lgrd)/meshnst
      jj = (jsmp1(lgrd) - jnst1)*meshnst + 2
      deltaxs = deltax(jj)/mfac
      jj = jj-joff
      deltays = deltay/mfac
c
c-----Interpolate gridded concentration fields from host computational 
c     grid to sampling grid, and define conc units conversion factor 
c
      jc = (jsmp1(lgrd) - jnst1)*meshnst + 2
      jc = jc-joff
      yc = 0.5
      do 10 j = 1,nys
        ic = (ismp1(lgrd) - inst1)*meshnst + 2
        ic = ic-ioff
        xc = 0.5
        yf = (j - 0.5)/float(mfac)
        if (yc.le.yf) then
          jc = jc + 1
          yc = yc + 1.
        endif
        do 20 i = 1,nxs
          xf = (i - 0.5)/float(mfac)
          if (xc.le.xf) then
            ic = ic + 1
            xc = xc + 1.
          endif
c
c  --- calculate the conversion factor for only cells in 
c      this slice ----
c
          if( ic .GE. ia .AND. ic .LE. iz .AND. jc .GE. ja
     &                                    .AND. jc .LE. jz ) then
             dcdx1 = (tempk(ic,jc-1,1) - tempk(ic-1,jc-1,1))
             dcdx2 = (tempk(ic,jc,1) - tempk(ic-1,jc,1))
             c1 = tempk(ic,jc-1,1) - dcdx1*(xc - xf)
             c2 = tempk(ic,jc,1) - dcdx2*(xc - xf)
             dcdy = (c2 - c1)
             tsmp = c2 - dcdy*(yc - yf)
             dcdx1 = (press(ic,jc-1,1) - press(ic-1,jc-1,1))
             dcdx2 = (press(ic,jc,1) - press(ic-1,jc,1))
             c1 = press(ic,jc-1,1) - dcdx1*(xc - xf)
             c2 = press(ic,jc,1) - dcdx2*(xc - xf)
             dcdy = (c2 - c1)
             psmp = c2 - dcdy*(yc - yf)
             do l = 1,nav
               if (lrtrac) then
                 ng = nrtgas
                 ll = l
               else
                 ng = ngas
                 ll = lavmap(l)
               endif
               if (ll.gt.ng) then 
                 convfac(i,j,l) = 1.
               else
                 convfac(i,j,l) = densfac*(273./tsmp)*(psmp/1013.)
               endif
c
c  --- add background for cells within the computation domain
c      of this slice ----
c
               if( ic .GE. ia .AND. ic .LE. iz .AND. jc .GE. ja 
     &                                         .AND. jc .LE. jz ) then
                 if (lbckgrd) then
                   dcdx1 = (conc(ic,jc-1,1,ll) - conc(ic-1,jc-1,1,ll))
                   dcdx2 = (conc(ic,jc,1,ll) - conc(ic-1,jc,1,ll))
                   c1 = conc(ic,jc-1,1,ll) - dcdx1*(xc - xf)
                   c2 = conc(ic,jc,1,ll) - dcdx2*(xc - xf)
                   dcdy = (c2 - c1)
                   avcnc(i,j,l) = (c2 - dcdy*(yc - yf))/convfac(i,j,l)
                 else
                   avcnc(i,j,l) = 0.
                 endif
               endif
             enddo
          endif
 20     continue
 10   continue
c
c-----Start puff loop
c
      do 50 n = 1,npig
c
c-----Locate the pig in the grid; consider only puffs extending below 10 m
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,pgrd)
        if (igrd.ne.pgrd) goto 50
        if( puffbot(n) .GT. 10. ) goto 50
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
       
        if( i .LT. ia .OR. i .GT. iz ) goto 50
        if( j .LT. ja .OR. j .GT. jz ) goto 50
c
c-----Determine puff location relative to origin of sampling grid
c     and convert to meters
c
        fpigx = xpigf(n) - (ismp1(lgrd) - 1)*delx
        fpigy = ypigf(n) - (jsmp1(lgrd) - 1)*dely
        bpigx = xpigb(n) - (ismp1(lgrd) - 1)*delx
        bpigy = ypigb(n) - (jsmp1(lgrd) - 1)*dely

        fpigx = fpigx/delx*meshnst*deltax(j+joff)
        fpigy = fpigy/dely*meshnst*deltay
        bpigx = bpigx/delx*meshnst*deltax(j+joff)
        bpigy = bpigy/dely*meshnst*deltay
c
c-----Check if puff is not in or near the current sampling grid
c
        xpmax =  3.*sigx(n) + amax1(fpigx,bpigx)
        xpmin = -3.*sigx(n) + amin1(fpigx,bpigx)
        ypmax =  3.*sigy(n) + amax1(fpigy,bpigy)
        ypmin = -3.*sigy(n) + amin1(fpigy,bpigy)
        xmax = nxs*deltaxs
        ymax = nys*deltays
        if (xpmin .GT. xmax .OR. xpmax .LT. 0. .OR.
     &      ypmin .GT. ymax .OR. ypmax .LT. 0.) goto 50
c
c-----We should sample this one; load additional parameters for sampling
c
        xlen  = sqrt((fpigx - bpigx)**2 + (fpigy - bpigy)**2)
        sigxx = xlen/3. + sigx(n)
        pdepth = pufftop(n)
        do l = 1,nav
          pmass(l) = 0.
          do nr = 1,nreactr
            if (lrtrac) then
              pmass(l) = pmass(l) + puffrt(l,nr,n)
              bndlow(l) = rtlbnd(l)
            else
              ll = lavmap(l)
              pmass(l) = pmass(l) + puffmass(ll,nr,n)
              bndlow(l) = bdnl(ll)
            endif
          enddo
        enddo
c
        call smpl1puf(lbckgrd,MXCOLSMP,MXROWSMP,MXOUT,nxs,nys,
     &                nav,ismp1(lgrd),jsmp1(lgrd),mfac,meshnst,
     &                inst1,jnst1,ia,iz,ja,jz,ioff,joff,deltaxs,
     &                deltays,sigxx,sigy(n),fpigx,bpigx,fpigy,bpigy,
     &                pdepth,pmass,bndlow,convfac,avcnc)
  50  continue
c
c-----Increment running average 
c
      do l = 1,nav
        do 60 j = 1,nys
          do i = 1,nxs
            cncsmp(i,j,l) = cncsmp(i,j,l) + dtfact*avcnc(i,j,l)
          enddo
  60    continue
      enddo
c 
      return
      end

      subroutine pspgeo(iway,stdlon,cenlat,truelat1,xp,yp,lon,lat)
!
!----CAMx v7.40 260801
!
!     PSPGEO performs Polar Stereographic to geodetic (lat/lon) translation.
!     Code based on MODULE_LLXY.F from WRF v3.3.
!
!      Portions Copyright Ramboll
!
!     Modifications:
!        none
!
!     Routines called:
!        none
!
!     Called by:
!        GRDPREP
!
      implicit none
      real, parameter :: PI = 3.141592653589793
      real, parameter :: DEG_PER_RAD = 180./PI
      real, parameter :: RAD_PER_DEG = PI/180.
      real, parameter :: REARTH = 6370.
!
!-----Arguments
!
      integer          :: iway     ! Conversion direction
                                   ! 0 = geodetic to Polar Stereographic
                                   ! 1 = Polar Stereographic to geodetic
      real             :: stdlon   ! Longitude parallel to y-axis (-180->180E)
                                   ! Also used at (0,0) point
      real             :: cenlat   ! Latitude at (0,0) point (-90->+90)
      real             :: truelat1 ! True latitude (-90 -> 90 degrees N)
      real             :: xp       ! Cartesian X coordinate (km)
      real             :: yp       ! Cartesian Y coordinate (km)
      real             :: lat      ! Latitude (-90->90 deg N)
      real             :: lon      ! Longitude (-180->180 E)
!
!-----Locals
!
      real             :: hemi     ! 1 for NH, -1 for SH
      real             :: polex    ! Computed x-location of pole point
      real             :: poley    ! Computed y-location of pole point
      real             :: r0       ! Computed radius to (0,0) point
      real             :: rm
      real             :: ala,ala1
      real             :: alo,alo1
      real             :: reflon
      real             :: scale_top
      real             :: xx,yy
      real             :: gi2, r2
      real             :: arccos
!
!-----Entry point
!  
      if (truelat1 .LT. 0.) then
        hemi = -1.0
      else
        hemi = 1.0
      endif
!
!-----Compute the reference longitude by rotating 90 degrees to the east
!     to find the longitude line parallel to the positive x-axis.
!
      reflon = stdlon + 90.
! 
!-----Compute numerator term of map scale factor
!
      scale_top = 1. + hemi*SIN(truelat1*RAD_PER_DEG)
!  
!-----Compute radius to our known (0,0) point
!
      ala1 = cenlat*RAD_PER_DEG
      r0 = REARTH*COS(ala1)*scale_top/(1. + hemi*SIN(ala1))
      alo1 = (stdlon - reflon)*RAD_PER_DEG
      polex = -r0*COS(alo1)
      poley = -hemi*r0*SIN(alo1)
!
!-------------------------------------------------------------------------------
!     Calculate lat/lon from x/y
!-------------------------------------------------------------------------------
!
      if (iway .EQ. 1) then
!
!-----Compute radius to point of interest
!
        xx = xp - polex
        yy = (yp - poley)*hemi
        r2 = xx**2 + yy**2
! 
!-----Now the magic code
!
        if (r2 .EQ. 0.) then 
          lat = hemi*90.
          lon = reflon
        else
          gi2 = (REARTH*scale_top)**2.
          lat = DEG_PER_RAD*hemi*ASIN((gi2 - r2)/(gi2 + r2))
          arccos = ACOS(xx/SQRT(r2))
          if (yy .GT. 0) then
            lon = reflon + DEG_PER_RAD*arccos
          else
            lon = reflon - DEG_PER_RAD*arccos
          endif
        endif
!
!-----Convert to a -180 -> 180 East convention
!
        if (lon .GT.  180.) lon = lon - 360.
        if (lon .LT. -180.) lon = lon + 360.
!
!-------------------------------------------------------------------------------
!     Calculate x/y from lat/lon
!-------------------------------------------------------------------------------
!
      else
!
!-----Find radius to desired point
!
        ala = lat*RAD_PER_DEG
        rm = REARTH*COS(ala)*scale_top/(1. + hemi*SIN(ala))
        alo = (lon - reflon)*RAD_PER_DEG
        xp = polex + rm*COS(alo)
        yp = poley + hemi*rm*SIN(alo)
      endif
!
      return
      end 

c**** NCF_SET_SPECIES_MAPPING
c
      subroutine ncf_set_species_mapping(iounit,action,
     &       species_names_model,nspecies_model,nspecies_map,lmap_array)
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine checks the inputs species list and finds the species
c   inside the file. If the species is found the mapping is addigned
c   accordingly.
c   the simulation period and that there is gridded data for each
c   tome period that will be accessed.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         iounit              I NCF file ID
c         action              C string that describes file being read
c         species_names_model C arrays of species names to map into
c         nspecies_model      I number of species in list
c       Outputs:
c         lmap_array          I NetCDF variable if for each species
c         nspecies_map        I number of species mapped 
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer       iounit
      character*(*) action
      character*10  species_names_model(*)
      integer       nspecies_model
      integer       nspecies_map
      integer       lmap_array(*)
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer ispc, ierr, this_varid, iems, ilen, isoap
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      write(idiag,'(/,A)') TRIM(action)
      call flush(idiag)
c
c   --- loop over species in list ----
c
      do ispc=1,nspecies_model
         lmap_array(ispc) = 0
         this_varid = 0
c
c   --- seek this species ---
c
         ilen = istrln(species_names_model(ispc))
         ierr = nf_inq_varid(iounit,
     &               species_names_model(ispc)(:ilen),this_varid)
         if( ierr .EQ. NF_NOERR  ) then
            lmap_array(ispc) = this_varid
c
c   --- echo that species was found in this file ---
c
            write(idiag,'(2A)') '   --- Found species: ',TRIM(species_names_model(ispc))
            call flush(idiag)

         else
            if( luse_soap3 ) then
               do isoap=1,NUM_SOAP_SPECIES
                  if( species_names_model(ispc) .NE. soap3_spec_names(isoap) ) cycle
                  ilen = istrln(soap2_spec_names(isoap))
                  ierr = nf_inq_varid(iounit,
     &                  soap2_spec_names(isoap)(:ilen),this_varid)
                  if( ierr .EQ. NF_NOERR  ) then
                     lmap_array(ispc) = this_varid
c
c   --- echo that species was found in this file ---
c
                     write(idiag,'(2A)') '   --- Found species: ',TRIM(soap2_spec_names(isoap))
                     call flush(idiag)
                  endif
               enddo
            endif
          endif
      enddo
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end
 

C*** CAMXFLD
c
      Module camxfld
      include 'camxfld.inc'
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This allocates the dynamic memory arrays in the CAMXFLD.COM
c        include file.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c       08/08/14    Added new snow cover input fields
c       10/13/17    Added aerosol pH field (APH)
c       10/16/17    Added time-weighted NO2 photolysis rate field (AJNO2)
c       07/23/18    Added emiss flux of Bi-Di NH3 drydep (eflxnh3)
c-----------------------------------------------------------------------
c
      Contains
c
c-----------------------------------------------------------------------
c    BEGIN SUBROUTINE ALLOC_CAMXFLD
c-----------------------------------------------------------------------
c      
         subroutine alloc_camxfld(numgrds,numcols,numrows,numlays,
     &                       numspcs,numavg,numdeps,numsmspc,avg_3d)                            
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
         use camx_includes
         implicit none
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine allocates the met and concentration fields that depend
c    on grid size and number of species. This version is called by the
c    master node, which needs space for the entire domain.    

c    Argument descriptions:
c     Input:  
c        numgrds    I  number of grids
c        numcols    I  number of cells in the X direction
c        numrows    I  number of cells in the Y direction
c        numlays    I  number of cells in the Z direction
c        numspcs    I  number of modeled species
c        numavg     I  number of species requested for output
c        numdeps    I  number of species in deposition array
c        numsmspc   I  number of surface model species
c        avg_3d     L  flag that determines if doing 3-D averages
c     Output:  
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
         integer :: numgrds
         integer :: numcols(numgrds)
         integer :: numrows(numgrds)
         integer :: numlays(numgrds)
         integer :: numspcs
         integer :: numavg
         integer :: numdeps
         integer :: numsmspc
         logical :: avg_3d(numgrds)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
         integer :: mvec2d
         integer :: mvec3d
         integer :: mvec1lay
         integer :: mvec4d
         integer :: mvec2a
         integer :: mvec3a
         integer :: mveclu
         integer :: mvecdp
         integer :: mvecsm
         integer :: mvecavg
         integer :: mvecedge
         integer :: mveccig
         integer :: i, j
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  -- calculate the size of the arrays ---
c
         mvec2d = 0
         mvec3d = 0
         mvecavg = 0
         mveccig = 0
         do i=1,numgrds
            mvec2d = mvec2d + numrows(i) * numcols(i)
            mvec3d = mvec3d + numrows(i) * numcols(i) * numlays(i)
            mveccig = mveccig + 2*numlays(i)*numlays(i)*numrows(i)*numcols(i)
            if( avg_3d(i) ) then
               mvecavg = mvecavg + numrows(i) * numcols(i) *
     &                                          numlays(i) * numavg
            else
               mvecavg = mvecavg + numrows(i) * numcols(i) * numavg
            endif
         enddo
         mvec1lay = mvec2d * numspcs
         mvec4d = mvec3d * numspcs
         mvec2a = MAXVAL(numrows(1:numgrds))*MAXVAL(numcols(1:numgrds))
         mvec3a = MAXVAL(numrows(1:numgrds))*
     &              MAXVAL(numcols(1:numgrds))*MAXVAL(numlays(1:numgrds))
         mveclu = MAX(mvec2d * nlu,1)
         mvecdp = mvec2d * (numdeps*3 + 2)
         mvecsm = mvec2d * numsmspc
         mvecscr=mvec3a*numspcs+ex_scratch
         mvecscr_dp=mvec2a*(3*numdeps+2) + ex_scratch
         mvecedge = MAX(numrows(1),numcols(1))
c
c ---- allocate the arrays that are 2-D fields ---
c
         allocate( cellon (mvec2d) )
         allocate( cellat (mvec2d) )
         allocate( mapscl (mvec2d) )
         allocate( tsurf  (mvec2d) )
         allocate( topo   (mvec2d) )
         allocate( lai    (mvec2d) )
         allocate( pspt   (mvec2d) )
         allocate( sfcz0  (mvec2d) )
         allocate( snow   (mvec2d) )
         allocate( snowage(mvec2d) )
         allocate( snowrat(mvec2d) )
         allocate( snowfrc(mvec2d) )
         allocate( snowalb(mvec2d) )
         allocate( albedo (mvec2d) )
c
c ---- allocate the logical arrays related with LAI
c
         allocate( lrdlai (numgrds) )
c
c --- allocate the 3-D fields that do not depend on species ---
c
         allocate( windu  (mvec3d) )
         allocate( windv  (mvec3d) )
         allocate( pupt   (mvec3d) )
         allocate( pvpt   (mvec3d) )
         allocate( tempk  (mvec3d) )
         allocate( ptpt   (mvec3d) )
         allocate( press  (mvec3d) )
         allocate( pppt   (mvec3d) )
         allocate( height (mvec3d) )
         allocate( phpt   (mvec3d) )
         allocate( rkv    (mvec3d) )
         allocate( pkpt   (mvec3d) )
         allocate( water  (mvec3d) )
         allocate( pwpt   (mvec3d) )
cae         allocate( fcloud (mvec3d) )
         allocate( depth  (mvec3d) )
         allocate( rkx    (mvec3d) )
         allocate( rky    (mvec3d) )
         allocate( cwc    (mvec3d) )
         allocate( pwr    (mvec3d) )
         allocate( pws    (mvec3d) )
         allocate( pwg    (mvec3d) )
         allocate( cod    (mvec3d) )
         allocate( cldtrns(mvec3d) )
         allocate( cph    (mvec3d) )
         allocate( aph    (mvec3d) )
         allocate( ajno2  (mvec3d) )
         allocate( cigfrc (mvec2d) )
         allocate( cigtim (mvec2d) )
         allocate( cigwtr (mvec3d) )
         allocate( cigph  (mvec3d) )
         allocate( cigpcp (mvec3d) )
         allocate( cigent (mvec3d) )
         allocate( cigdet (mvec3d) )
         allocate( cigmas (mveccig) )
c
c  --- allocate arrays for edge cells concentratons ---
c
         allocate( bndconc(4,mvecedge,numlays(1),numspcs) )
c
c  --- allocate arrays that depend on some kind if species number ---
c
         allocate( ctop   (mvec1lay) )
c
         allocate( conc   (mvec4d) )
c
         allocate( fluxtmp( MAXVAL(numrows(1:numgrds)),
     &                      MAXVAL(numcols(1:numgrds)),
     &                      MAXVAL(numlays(1:numgrds)), numspcs ) )
c
         allocate( avcnc  (mvecavg) )
c
         allocate( entrn  (mvec3d) )
         allocate( dilut  (mvec3d) )
c
         allocate( vdep   (mvec1lay) )
         allocate( fsurf  (mveclu) )
         allocate( depfld (mvecdp) )
         allocate( eflxnh3(mvec2d) )
c
         if (lsrfmod) then
           allocate( solmas (mvecsm) )
           allocate( vegmas (mvecsm) )
           allocate( reemis (mvecsm) )
         else
           allocate( solmas (1) )
           allocate( vegmas (1) )
           allocate( reemis (1) )
         endif
c
c  --- allocate the arrays used for scratch ---
c
         allocate( scr1(mvecscr) )
         allocate( scr1_dp(mvecscr_dp) )
c
c   --- allocate arrays used for mass summary ---
c
         allocate( xmass   (numspcs,numgrds)    )
         allocate( xmass0  (numspcs,numgrds)    )
         allocate( armass  (numspcs,numgrds)    )
         allocate( ptmass  (numspcs,numgrds)    )
         allocate( fluxes  (numspcs*11,numgrds) )
         allocate( xmschem (numspcs,numgrds)    )
         allocate( xmsold  (numspcs,numgrds)    )
         allocate( resid   (numspcs,numgrds)    )
         allocate( xmsfin  (numspcs,numgrds)    )
         allocate( xmstmp  (numspcs,numgrds)    )
         allocate( pigdump (numspcs,numgrds)    )
         allocate( pgmserr (numspcs,numgrds)    )
c
         allocate( tarmass (numspcs,numgrds)    )
         allocate( tptmass (numspcs,numgrds)    )
         allocate( tfluxes (numspcs*12,numgrds) )
         allocate( tresid  (numspcs,numgrds)    )
         allocate( txmschem(numspcs,numgrds)    )
         allocate( txmsfin (numspcs,numgrds)    )
c
c  --- initialize to zero ---
c
         do j=1,numgrds
           do i=1,numspcs
             xmass(i,j) = 0.
             xmass0(i,j) = 0.
             armass(i,j) = 0.
             ptmass(i,j) = 0.
             xmschem(i,j) = 0.
             xmsold(i,j) = 0.
             resid(i,j) = 0.
             xmsfin(i,j) = 0.
             xmstmp(i,j) = 0.
             pigdump(i,j) = 0.
             pgmserr(i,j) = 0.
             tarmass(i,j) = 0.
             tptmass(i,j) = 0.
             tresid(i,j) = 0.
             txmschem(i,j) = 0.
           enddo
           do i=1,numspcs*11
             fluxes(i,j) = 0.
           enddo
           do i=1,numspcs*12
             tfluxes(i,j) = 0.
           enddo
         enddo

         aph = 0.0
         ajno2 = 0.0
         eflxnh3 = 0.0
c
c  --- allocate the fields used to walk the met ---
c
         allocate( hnxt    (mvec3d) )
         allocate( pnxt    (mvec3d) )
         allocate( unxt    (mvec3d) )
         allocate( vnxt    (mvec3d) )
         allocate( tnxt    (mvec3d) )
         allocate( tsnxt   (mvec3d) )
         allocate( knxt    (mvec3d) )
         allocate( wnxt    (mvec3d) )
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
         return
         end subroutine
c
c-----------------------------------------------------------------------
c    END SUBROUTINE ALLOC_CAMXFLD
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN SUBROUTINE ALLOC_CAMXFLD_NODE
c-----------------------------------------------------------------------
c
         subroutine alloc_camxfld_node(numspcs, numgrds, numavg,
     &            numdeps, numsmspc, numcols, numrows, numlays, avg_3d,
     &                                      numbndry_cols,numbndry_rows)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
         use camx_includes
         use node_mod
c
         implicit none
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine allocates the met and concentration fields that depend
c    on grid size and number of species. This version is called by the
c    compute nodes, which need space for the just the slice.
c
c    Argument descriptions:
c     Input:  
c        numspcs    I  number of modeled species
c        numgrds    I  number of grids
c        numavg     I  number of species requested for output
c        numdeps    I  number of depositions species
c        numsmspc   I  number of surface model species
c        numcols    I  number of cells in the X direction
c        numrows    I  number of cells in the Y direction
c        numlays    I  number of cells in the Z direction
c        avg_3d     L  flag that determines if doing 3-D averages
c        numbndry_cols  I  number of columns in boundary array
c        numbndry_rows  I  number of columns in boundary array
c     Output:  
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c                    
         integer :: numspcs
         integer :: numgrds
         integer :: numavg
         integer :: numdeps
         integer :: numsmspc
         integer :: numcols(numgrds)
         integer :: numrows(numgrds)
         integer :: numlays(numgrds)
         logical :: avg_3d(numgrds)
         integer :: numbndry_cols
         integer :: numbndry_rows
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
         integer :: mvec2d
         integer :: mvec3d
         integer :: mvec1lay
         integer :: mvec4d
         integer :: mvec2a
         integer :: mvec3a
         integer :: mveclu
         integer :: mvecdp
         integer :: mvecsm
         integer :: mvecavg
         integer :: mvecedge
         integer :: mveccig
         integer :: i, j
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  -- calculate the size of the arrays ---
c
         mvec2d = 0
         mvec3d = 0
         mvecavg = 0
         mveccig = 0
         do i=1,numgrds
            mvec2d = mvec2d + mmyp(i) * mmxp(i)
            mvec3d = mvec3d + mmyp(i) * mmxp(i) * mmzp(i)
            mveccig = mveccig + 2*mmzp(i)*mmzp(i)*mmyp(i)*mmxp(i)
            if( avg_3d(i) ) then
               mvecavg = mvecavg + mmyp(i) * mmxp(i) * mmzp(i) * numavg
            else
               mvecavg = mvecavg + mmyp(i) * mmxp(i) * numavg
            endif
         enddo
         mvec1lay = mvec2d * numspcs
         mvec4d = mvec3d * numspcs
         mvec2a = MAXVAL(mmxp(1:numgrds))*MAXVAL(mmyp(1:numgrds))
         mvec3a = MAXVAL(mmxp(1:numgrds))*
     &                MAXVAL(mmyp(1:numgrds))*MAXVAL(mmzp(1:numgrds))
         mveclu = MAX(mvec2d * nlu,1)
         mvecdp = mvec2d * (numdeps*3 + 2)
         mvecsm = mvec2d * numsmspc
         mvecscr=mvec3a*numspcs+ex_scratch
         mvecscr_dp=mvec2a*(3*numdeps+2) + ex_scratch
         mvecedge = MAX(numbndry_rows,numbndry_cols)
c
c ---- allocate the arrays that are 2-D fields ---
c
         allocate( cellon (mvec2d) )
         allocate( cellat (mvec2d) )
         allocate( mapscl (mvec2d) )
         allocate( tsurf  (mvec2d) )
         allocate( topo   (mvec2d) )
         allocate( lai    (mvec2d) )
         allocate( pspt   (mvec2d) )
         allocate( sfcz0  (mvec2d) )
         allocate( snow   (mvec2d) )
         allocate( snowage(mvec2d) )
         allocate( snowrat(mvec2d) )
         allocate( snowfrc(mvec2d) )
         allocate( snowalb(mvec2d) )
         allocate( albedo (mvec2d) )
c
c ---- allocate the logical arrays related with LAI
c
         allocate( lrdlai (numgrds) )
c
c --- allocate the 3-D fields that do not depend on species ---
c
         allocate( windu  (mvec3d) )
         allocate( windv  (mvec3d) )
         allocate( pupt   (mvec3d) )
         allocate( pvpt   (mvec3d) )
         allocate( tempk  (mvec3d) )
         allocate( ptpt   (mvec3d) )
         allocate( press  (mvec3d) )
         allocate( pppt   (mvec3d) )
         allocate( height (mvec3d) )
         allocate( phpt   (mvec3d) )
         allocate( rkv    (mvec3d) )
         allocate( pkpt   (mvec3d) )
         allocate( water  (mvec3d) )
         allocate( pwpt   (mvec3d) )
cae         allocate( fcloud (mvec3d) )
         allocate( depth  (mvec3d) )
         allocate( rkx    (mvec3d) )
         allocate( rky    (mvec3d) )
         allocate( cwc    (mvec3d) )
         allocate( pwr    (mvec3d) )
         allocate( pws    (mvec3d) )
         allocate( pwg    (mvec3d) )
         allocate( cod    (mvec3d) )
         allocate( cldtrns(mvec3d) )
         allocate( cph    (mvec3d) )
         allocate( aph    (mvec3d) )
         allocate( ajno2  (mvec3d) )
         allocate( cigfrc (mvec2d) )
         allocate( cigtim (mvec2d) )
         allocate( cigwtr (mvec3d) )
         allocate( cigph  (mvec3d) )
         allocate( cigpcp (mvec3d) )
         allocate( cigent (mvec3d) )
         allocate( cigdet (mvec3d) )
         allocate( cigmas (mveccig) )
c
c  --- allocate arrays for edge cells concentratons ---
c
         allocate( bndconc(4,mvecedge,numlays(1),numspcs) )
c
c  --- allocate arrays that depend on some kine if species number ---
c
         allocate( ctop (mvec1lay) )
c
         allocate( conc   (mvec4d) )
c
         allocate( fluxtmp (MAXVAL(mmxp(1:numgrds)),
     &                      MAXVAL(mmyp(1:numgrds)),
     &                      MAXVAL(mmzp(1:numgrds)), numspcs ) )
c
         allocate( avcnc  (mvecavg) )
c
         allocate( entrn  (mvec3d) )
         allocate( dilut  (mvec3d) )
c
         allocate( vdep   (mvec1lay) )
         allocate( fsurf  (mveclu) )
         allocate( depfld (mvecdp) )
         allocate( eflxnh3(mvec2d) )
c
         if (lsrfmod) then
           allocate( solmas (mvecsm) )
           allocate( vegmas (mvecsm) )
           allocate( reemis (mvecsm) )
         else
           allocate( solmas (1) )
           allocate( vegmas (1) )
           allocate( reemis (1) )
         endif
c
c  --- allocate the arrays used for scratch ---
c
         allocate( scr1(mvecscr) )
         allocate( scr1_dp(mvecscr_dp) )
c
c   --- allocate arrays used for mass summary ---
c
         allocate( xmass   (numspcs,numgrds)    )
         allocate( xmass0  (numspcs,numgrds)    )
         allocate( armass  (numspcs,numgrds)    )
         allocate( ptmass  (numspcs,numgrds)    )
         allocate( fluxes  (numspcs*11,numgrds) )
         allocate( xmschem (numspcs,numgrds)    )
         allocate( xmsold  (numspcs,numgrds)    )
         allocate( resid   (numspcs,numgrds)    )
         allocate( xmsfin  (numspcs,numgrds)    )
         allocate( xmstmp  (numspcs,numgrds)    )
         allocate( pigdump (numspcs,numgrds)    )
         allocate( pgmserr (numspcs,numgrds)    )
c
         allocate( tarmass (numspcs,numgrds)    )
         allocate( tptmass (numspcs,numgrds)    )
         allocate( tfluxes (numspcs*12,numgrds) )
         allocate( tresid  (numspcs,numgrds)    )
         allocate( txmschem(numspcs,numgrds)    )
         allocate( txmsfin (numspcs,numgrds)    )
c
c  --- initialize to zero ---
c
         do j=1,numgrds
           do i=1,numspcs
             xmass(i,j) = 0.
             xmass0(i,j) = 0.
             armass(i,j) = 0.
             ptmass(i,j) = 0.
             xmschem(i,j) = 0.
             xmsold(i,j) = 0.
             resid(i,j) = 0.
             xmsfin(i,j) = 0.
             xmstmp(i,j) = 0.
             pigdump(i,j) = 0.
             pgmserr(i,j) = 0.
             tarmass(i,j) = 0.
             tptmass(i,j) = 0.
             tresid(i,j) = 0.
             txmschem(i,j) = 0.
           enddo
           do i=1,numspcs*11
             fluxes(i,j) = 0.
           enddo
           do i=1,numspcs*12
             tfluxes(i,j) = 0.
           enddo
         enddo

         aph = 0.0
         ajno2 = 0.0
         eflxnh3 = 0.0
c
c  --- allocate the fields used to walk the met ---
c
         allocate( hnxt    (mvec3d) )
         allocate( pnxt    (mvec3d) )
         allocate( unxt    (mvec3d) )
         allocate( vnxt    (mvec3d) )
         allocate( tnxt    (mvec3d) )
         allocate( tsnxt   (mvec3d) )
         allocate( knxt    (mvec3d) )
         allocate( wnxt    (mvec3d) )
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
         return
         end subroutine
c
c-----------------------------------------------------------------------
c    END SUBROUTINE ALLOC_CAMXFLD_NODE
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN SUBROUTINE ALLOC_EMISS_ARRAY
c-----------------------------------------------------------------------
c      
         subroutine alloc_emiss_array(numgrds,numcols,numrows,
     &                                             numlays_ems,numemiss)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
         use camx_includes
         implicit none
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    This routine allocates the emissions array

c    Argument descriptions:
c     Input:  
c        numgrds    I  number of grids
c        numcols    I  number of cells in the X direction
c        numrows    I  number of cells in the Y direction
c        numlays    I  number of cells in the Z direction
c        numemiss   I  number of emissions species
c     Output:  
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
         integer :: numgrds
         integer :: numcols(numgrds)
         integer :: numrows(numgrds)
         integer :: numlays_ems
         integer :: numemiss
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
         integer :: mvec3d
         integer :: mvecem
         integer :: i
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  -- calculate the size of the arrays ---
c
         mvec3d = 0
         do i=1,numgrds
            mvec3d = mvec3d + numrows(i) * numcols(i) * numlays_ems
         enddo
         mvecem = mvec3d * numemiss
c
c ---- allocate the arrays that are 2-D fields ---
c
         allocate( aremis (mvecem) )
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
         return
         end subroutine
c
c-----------------------------------------------------------------------
c    END SUBROUTINE ALLOC_EMISS_ARRAY
c-----------------------------------------------------------------------
c
      end Module

c**** KRTC
c
      subroutine krtc(temp, pres)
      use rtcmcchm
c 
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c 
c     KRTC calculates temperature/pressure-dependent rate constants
c     for the RTRAC CMC solver.  The rate expressions follow the
c     CAMx conventions
c
c     The expression types supported are:
c       Type 1 Temperature independent
c       Type 2 UAM/OZIPM format Arrhenius
c       Type 3 Generalized temperature dependent
c       Type 4 Troe teperature/pressure dependent
c       Type 5 Equilibrium constant ratio to another reaction
c       Type 6 Lindemann-Hinshelwood used for OH + HNO3
c       Type 7 k = k1 + k2[M] used for OH + CO and HO2 self-reaction
c 
c      Copyright Ramboll
c
c     Argument description:
c      Inputs:
c       temp         R     temperature (K)
c       pres         R     pressure (mbar)
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    07/06/07   --gyarwood--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      implicit none
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      real    temp, pres
c 
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      double precision darren
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      real*8   cf1
      parameter (cf1 = 2.462d13)
c
      integer  i, iord, ityp, iref
      real*8   cf, cfm, ppmpres, factor, dtemp, dpres, t2h
      real*8   rktmp, rk0, rk1, rk2, rk3, ratio
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      dtemp = DBLE(temp)
      dpres = DBLE(pres)
c
c --- Conversions from molecule cm-3 to ppm and from hr to min to sec
c       cf1 from gas law: (n/V) = NP/RT
c       cf1 = (6.022e23 * 1.013e5 * 1e-12 ) / (8.314 * 298.0)
c     The cf1 conversion is at 298 K and 1013 mb and the
c     adjustment "factor" below generalises to other conditions
c
      if( itunit .EQ. 1 ) then
         t2h = 3600.0D0
      elseif( itunit .EQ. 2 ) then
         t2h = 60.0D0
      else
         t2h = 1.0D0
      endif
c
      do i = 1,nrxnrtc
        ityp = ityprtc(i)
        iord = MAX(1, nrct(i))
        if (icunit .EQ. 1) then
          cf  = cf1**DBLE((iord-1))
          cfm = cf1**DBLE((iord))
        else
          cf  = 1.0D0
          cfm = 1.0D0
        endif
        ppmpres = 1.0D6*dpres/1013.0D0
        factor = ( (298.D0/dtemp)*(pres/1013.D0) )**DBLE((iord-1))
c
c --- For reference: function darren(a,ea,b,tref,temp)
c                    darren = a*((temp/tref)**b)*dexp(-ea/temp)
c
        if (ityp.EQ.1) then
c         Type 1 Temperature independent
          rkrtc(i) = DBLE(rkprmrtc(i,1))*cf*t2h
        elseif (ityp.EQ.2) then
c         Type 2 UAM/OZIPM format Arrhenius
          rktmp = DBLE(rkprmrtc(i,2))*(1.0D0/298.0D0 - 1.0D0/dtemp)
          rkrtc(i) = DBLE(rkprmrtc(i,1))*DEXP(rktmp)*cf*t2h
        elseif (ityp.eq.3) then
c         Type 3 Generalized temperature dependent
          rkrtc(i) = darren(DBLE(rkprmrtc(i,1)), DBLE(rkprmrtc(i,2)),
     &            DBLE(rkprmrtc(i,3)), DBLE(rkprmrtc(i,4)),dtemp)*cf*t2h
        elseif (ityp.eq.4) then
c         Type 4 Troe teperature/pressure dependent
          rk0 = darren(DBLE(rkprmrtc(i,1)), DBLE(rkprmrtc(i,2)),
     &      DBLE(rkprmrtc(i,3)), DBLE(rkprmrtc(i,4)),dtemp)*cfm*ppmpres
          ratio = rk0/(darren(DBLE(rkprmrtc(i,5)), DBLE(rkprmrtc(i,6)),
     &      DBLE(rkprmrtc(i,7)), DBLE(rkprmrtc(i,8)),dtemp)*cf)
          rkrtc(i) = 
     &      (rk0/(1.D0+ratio))*DBLE(rkprmrtc(i,9))**(1.D0/(1.D0+
     &      (0.43429D0*dlog(ratio)/DBLE(rkprmrtc(i,10)))**2.0D0))*t2h
        elseif (ityp.eq.5) then
c         Type 5 Equilibrium constant ratio to another reaction
          factor = 1.D0
          iref = nint(rkprmrtc(i,1))
          if (icunit .EQ. 1)
     &       cf  = cf1**(MAX(1, nrct(iref))-iord)
          rktmp = darren(DBLE(rkprmrtc(i,2)), DBLE(rkprmrtc(i,3)),
     &            DBLE(rkprmrtc(i,4)), DBLE(rkprmrtc(i,5)),dtemp)*cf
          rkrtc(i) = rkrtc(iref) / rktmp 
        elseif (ityp.eq.6) then
c         Type 6 Lindemann-Hinshelwood used for OH + HNO3
          rk1 = darren(DBLE(rkprmrtc(i,1)), DBLE(rkprmrtc(i,2)),
     &          DBLE(rkprmrtc(i,3)), DBLE(rkprmrtc(i,4)),dtemp)*cf
          rk2 = darren(DBLE(rkprmrtc(i,5)), DBLE(rkprmrtc(i,6)),
     &          DBLE(rkprmrtc(i,7)), DBLE(rkprmrtc(i,8)),dtemp)*cf
          rk3 = darren(DBLE(rkprmrtc(i,9)), DBLE(rkprmrtc(i,10)),
     &          DBLE(rkprmrtc(i,11)), DBLE(rkprmrtc(i,12)),dtemp)*cfm
          rkrtc(i) = ( rk1 + (rk3*ppmpres /
     &          (1.D0 + (rk3*ppmpres / rk2) ) ) )*t2h
        elseif (ityp.eq.7) then
c         Type 7 k = k1 + k2[M] used for OH + CO and HO2 self-reaction
          rk1 = darren(DBLE(rkprmrtc(i,1)), DBLE(rkprmrtc(i,2)),
     &          DBLE(rkprmrtc(i,3)), DBLE(rkprmrtc(i,4)),dtemp)*cf
          rk2 = darren(DBLE(rkprmrtc(i,5)), DBLE(rkprmrtc(i,6)),
     &          DBLE(rkprmrtc(i,7)), DBLE(rkprmrtc(i,8)),dtemp)*cfm
          rkrtc(i) = ( rk1 + rk2*ppmpres )*t2h
        endif
        rkrtc(i) =  rkrtc(i)*factor
        srkrtc(i) =  SNGL( rkrtc(i) )
      enddo
c
      return
      end

      subroutine ironwet(nspc,n,dx,dy,mapscl,cwc,pwr,pws,pwg,cph,
     &                   temp,press,puffvol,conpig,conbck,depth,dt,
     &                   depfld,flxwet)
      use camxcom
      use chmstry
      use pigsty
      implicit none
c
c----CAMx v7.40 260801
c
c     IRONWET calculates wet deposition for a given IRON PiG puff.
c     Material is depleted (+ puff increment) or added (- puff increment)
c     over the entire volume of the puff using a simplified scavenging
c     mechanism.
c
c      Copyright Ramboll
c
c     Modifications:
c        8/31/06         Added map scale factor
c        5/12/08         Revised deposited liquid concentration to use
c                        correct rainfall volume
c       12/22/09         Corrected equilibrium gas concentration in rain
c        7/26/13         Improved for new GREASD chemistry
c       12/07/14         Modified for VBS
c       06/06/16         Scavenging modifications following WETDEP mods
c       08/16/21         Fixed calculation errors in wet deposition
c                        liquid concentration
c
c     Input arguments:
c        nspc                number of species
c        n                   puff index
c        dx                  grid cell size in x-direction (m)
c        dy                  grid cell size in y-direction (m)
c        mapscl              map scale factor
c        cwc                 cloud water content (g/m3)
c        pwr                 rain water content (g/m3)
c        pws                 snow water content (g/m3)
c        pwg                 graupel water content (g/m3)
c        cph                 cloud water pH
c        temp                temperature (K)
c        press               pressure (mb)
c        puffvol             puff volume (m3)
c        conpig              puff increment (umol/m3,ug/m3)
c        conbck              background concentration (umol/m3,ug/m3)
c        depth               puff depth (m)
c        dt                  time step (s)
c        depfld              wet deposited mass (mol/ha, g/ha)
c                            and surface liquid concentrations (mol/l, g/l)
c        flxwet              deposition mass flux (umol, ug)
c  
c     Output arguments:
c        depfld              wet deposited mass (mol/ha, g/ha)
c                            and surface liquid concentrations (mol/l, g/l)
c        flxwet              deposition mass flux (umol, ug)
c
c     Routines Called:
c        HENRYFNC
c        SCAVRAT
c
c     Called by:
c        PIGDRIVE
c
      include 'camx.prm'
      include 'flags.inc'
c
      integer nspc
      integer n
      real cwc,pwr,pws,pwg,cph,temp,press,puffvol,depth,
     &     dt,dx,dy,mapscl
      real depfld(*)
      real conpig(MXSPEC+1,MXRECTR)
      real conbck(MXSPEC+1)
      real*8 flxwet(*)
c
      integer nr,l,isemptyf,isemptyc
      real rd,rhoh2o,rr,volrat,rhoair,convfac,cmin,conc,
     &     hlaw,dscav,gscav,ascav,delm,qtf,qtc,vtf,vtc,psize,psizec,
     &     ascavf,ascavc,roprta,cph2o,pwc,rconst,cwat,pwat,pwtr,delc
      real area, volume
      real drpvel,ceqc,ceqp
      real fdep(MXSPEC)
      logical lcloud,lgraupl
c
      data rd /287./         ! Dry air gas constant (J/K/kg)
      data rhoh2o /1.e6/     ! water density (g/m3)
      data rconst /8.206e-2/ ! gas constant (l.atm/mol.K)
c
c-----Entry point
c
      do l = 1,nspec
        depfld(l) = 0.
        depfld(nspec+l) = 0.
        flxwet(l) = 0.
      enddo
c
      pwc = pwr + pws + pwg
      volrat = pwc/rhoh2o                 ! drop volume/air volume
      rr     = (volrat/1.0e-7)**1.27      ! rainfall rate (mm/hr)
c
      lcloud = .false.
      lgraupl = .false.
      if (cwc .ge. cwmin) lcloud = .true.
      if (pwg .ge. cwmin) lgraupl = .true.
      rhoair = 100.*press/(rd*temp)
      cwat = cwc
      pwtr = pwc
      if (temp.lt.273.)
     &  cwat = max(0.,cwc*(temp - tamin)/(273. - tamin))
c
c-----Loop over puff reactors
c
      do 10 nr = 1,nreactr
c
c-----Calculate scavenging for soluble gas species
c
        do 40 l = nrad+1,ngas
          if( henry0(l) .LT. 1.e-6 ) goto 40
          convfac = densfac*(273./temp)*(press/1013.)
          cmin = bdnl(l)*convfac
          conc = MAX(cmin,conpig(l,nr) + conbck(l))
          call henryfnc(l,henry0(l),tfact(l),temp,cph,knh3,khno3,
     &                  kso2,hlaw)
          hlaw = hlaw*rconst*temp
          ceqc = conc*(1. - 1./(1. + hlaw*cwat/rhoh2o))
          call henryfnc(l,henry0(l),tfact(l),temp,5.,knh3,khno3,
     &                  kso2,hlaw)
          hlaw = hlaw*rconst*temp
          pwat = pwtr
          if (temp.lt.273. .and. rscale(l).gt.0.) pwat = 0.
          ceqp = (conc - ceqc)*(1. - 1./(1. + hlaw*pwat/rhoh2o))
c
          call scavrat(.false.,lcloud,lgraupl,tamin,rr,temp,rhoair,
     &                 diffrat(l),0.,0.,dscav,gscav,ascav,drpvel)
c
          delc = ceqc*(1. - exp(-dscav*dt)) +
     &           ceqp*(1. - exp(-gscav*dt))
          delc = min(delc,conc-cmin)
          delc = MAX(0.,delc*MAX(0.,conpig(l,nr))/conc)
          delm = delc*puffvol/float(nreactr)
          puffmass(l,nr,n) = puffmass(l,nr,n) - delm
c
          flxwet(l) = flxwet(l) - DBLE(delm)
          area = dx*dy/mapscl**2
          volume = 1.e-3*rr*area
          depfld(l) = depfld(l) + 1.e-2*delm/area
          depfld(nspec+l) = depfld(nspec+l) +
     &                      1.e-9*(delm/volume)
 40     continue
c
c-----Calculate scavenging for particulate species
c
        if (naero .gt. 0) then
c
c-----Recalculate particle size for wet diameter (CF scheme)
c
          if (lchem .AND. aeropt.eq.'CF') then
            isemptyf = 1
            isemptyc = 1
            qtf = 0. ! fine dry total mass
            qtc = 0. ! coarse dry total mass
            vtf = 0. ! fine dry total volume
            vtc = 0. ! coarse dry total volume
            do l = ngas+1,nspec
              conc = MAX(bdnl(l),conpig(l,nr) + conbck(l))
              if (dcut(l,2) .lt. (dcut(kph2o,2)+1.e-5)) then   ! fine
                if (l .ne. kph2o) then
                  if (conc.gt.bdnl(l)) isemptyf = 0
                  qtf = qtf + conc
                  vtf = vtf + conc/roprt(l)
                endif
              else                                             ! coarse
                if (conc.gt.bdnl(l)) isemptyc = 0
                qtc = qtc + conc
                vtc = vtc + conc/roprt(l)
                psizec = sqrt(dcut(l,1)*dcut(l,2))
              endif
            enddo
c
            ascavf = 0.
            if (isemptyf.eq.0) then
              cph2o = amax1(bdnl(kph2o),conpig(kph2o,nr))
              roprta = (qtf + cph2o)/(vtf + cph2o/roprt(kph2o))
              psize = sqrt(dcut(kph2o,1)*dcut(kph2o,2))
              psize = 1.e-6*psize*
     &                (1. + cph2o/roprt(kph2o)/vtf)**0.33333
              if (psize.lt.2.5e-6) psize = psize*10.
              call scavrat(.true.,lcloud,lgraupl,tamin,rr,temp,
     &                 rhoair,0.,psize,roprta,dscav,gscav,ascavf,drpvel)
            endif
c
            ascavc = 0.
            if (isemptyc.eq.0) then
              roprta = qtc/vtc
              psize = psizec*1.e-6
              call scavrat(.true.,lcloud,lgraupl,tamin,rr,temp,
     &                 rhoair,0.,psize,roprta,dscav,gscav,ascavc,drpvel)
            endif
c
            do l = ngas+1,nspec
              if (dcut(l,2) .lt. (dcut(kph2o,2)+1.e-5)) then
                fdep(l) = 1. - exp(-ascavf*dt)
              else
                fdep(l) = 1. - exp(-ascavc*dt)
              endif
            enddo
c
c-----Other scheme
c
          else
            do l = ngas+1,nspec
               psize = 1.e-6*sqrt(dcut(l,1)*dcut(l,2))
               if (psize.lt.2.5e-6) psize = psize*10.
               call scavrat(.true.,lcloud,lgraupl,tamin,rr,temp,
     &                rhoair,0.,psize,roprt(l),dscav,gscav,ascav,drpvel)
               fdep(l) = 1. - exp(-ascav*dt)
             enddo
          endif

          do 50 l = ngas+1,nspec
            delm = MAX(0.,puffmass(l,nr,n)*fdep(l))
            puffmass(l,nr,n) = puffmass(l,nr,n) - delm
c
            flxwet(l) = flxwet(l) - DBLE(delm)
            area = dx*dy/mapscl**2
            volume = 1.e-3*rr*area
            depfld(l) = depfld(l) + 1.e-2*delm/area
            depfld(nspec+l) = depfld(nspec+l) +
     &                      1.e-9*delm/volume
 50       continue
c
        endif
c
 10   continue
c
      return
      end

c**** FILSPDDM
c
      subroutine filspddm(iaffec,caffec,cinflu,srcnam,
     &                               iptfam,ngrps,nregs,lout,topfac )
      use filunit
      use chmstry
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills the array of species names for DDM species.  It
c   loads all of the names for a given family.  The argument variables
c   determine which family is to be filled.
c     Argument definitions:
c      Outputs:
c         iptfam   I  pointer into array of current species name
c      Inputs:
c         iaffec   I  value indicating order of affected species   
c         caffec   C  name of affected species 
c         cinflu   C  name of influencing species
c         srcnam   C  name of the source of the influence
c         ngrps    I  number of groups to use (0 for IC/BC)
c         nregs    I  number of regions to use (0 for IC/BC)
c         lout     L  flag for determing if the affected species is
c                     to be output to average file
c         topfac   R  value to load in the top boundary factor array
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     03/23/99   --gwilson--    Original development
c     07/16/07   --bkoo--       Revised for HDDM
c                               Added HRVOC
c     06/11/08   --bkoo--       Added rate constant sensitivity
c     11/12/09   --gwilson--    Added initialization of factor for
c                               applying new type of top boundary
c     08/23/13   --bkoo--       Added PM species for DDM
c     01/07/14   --bkoo--       Revised naming system for short names
c     08/09/18   --bkoo--       Added rate term sensitivity
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
       integer      iaffec
       character*10 caffec
       character*10 cinflu
       character*10 srcnam
       integer      iptfam
       integer      ngrps
       integer      nregs
       logical      lout 
       real         topfac
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
!bk       integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
       integer iinflu, igrp, ireg
       real    this_molwt
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- HDDM sensitivity names
c
      if ( srcnam .EQ. 'HDDM' ) then
         iptfam = iptfam + 1
         ptop_fac(iptfam) = topfac
         lsamap(iptfam) = iptfam
         ptlong(iptfam)(1:4) = caffec(1:4)
         ptlong(iptfam)(5:8) = srcnam(1:4)

         ! Here, ngrps passes the index of the current HDDM sens group
         iphddm(1,ngrps) = 0
         iphddm(2,ngrps) = 0
         do i = 1, nddmsp - nhddm
            if (ptlong(i)(5:14).EQ.hddmsp(1,ngrps)) iphddm(1,ngrps) = i
            if (ptlong(i)(5:14).EQ.hddmsp(2,ngrps)) iphddm(2,ngrps) = i
         enddo
         if (iphddm(1,ngrps).EQ.0 .OR. iphddm(2,ngrps).EQ.0 ) goto 7001

         write(ptlong(iptfam)( 9:11),'(I3.3)') iphddm(1,ngrps)
         write(ptlong(iptfam)(12:14),'(I3.3)') iphddm(2,ngrps)

         write(ptname(iptfam)(1:3),'(I3.3)') iaffec
         ptname(iptfam)(4:4) = srcnam(1:1)
         ptname(iptfam)(5:7) = ptlong(iptfam)( 9:11)
         ptname(iptfam)(8:10)= ptlong(iptfam)(12:14)
c
c  --- set the flag for outputing this species to average file ---
c
         loutsa(iptfam) = lout
c
c  --- replace all blanks with underscores ---
c
         do i=1,14
            if( ptlong(iptfam)(i:i) .EQ. ' ' )
     &                                   ptlong(iptfam)(i:i) = '_'
         enddo
         do i=1,10
            if( ptname(iptfam)(i:i) .EQ. ' ' )
     &                                   ptname(iptfam)(i:i) = '_'
         enddo
         write(idiag,9002) caffec, hddmsp(1,ngrps),'&',hddmsp(2,ngrps),
     &                                  ptlong(iptfam), ptname(iptfam)
c
         if( lcdfout ) then
            ddmdesc(iptfam) = 'Second order sensitivity of '//
     &                        TRIM(caffec)//' to '//
     &                        TRIM(hddmsp(1,ngrps))//'&'//
     &                        TRIM(hddmsp(2,ngrps))
         endif
c
         goto 9999
      endif
c
c  --- Rate constant or rate term sensitivity names
c
      if ( srcnam .EQ. 'RATE' .OR. srcnam .EQ. 'TERM' ) then
         iptfam = iptfam + 1
         lsamap(iptfam) = iptfam
         ptop_fac(iptfam) = topfac
         ptlong(iptfam)(1:4) = caffec(1:4)
         ptlong(iptfam)(5:10) = srcnam(1:4)
         ptlong(iptfam)(11:14) = cinflu(1:4)
         write(ptname(iptfam)(1:3),'(I3.3)') iaffec
         ptname(iptfam)(4:7) = srcnam(1:4)
         ! Here, ngrps passes the index of the current Rate constant/term sens group
         write(ptname(iptfam)(8:10),'(I3.3)') ngrps
c
c  --- set the flag for outputing this species to average file ---
c
         loutsa(iptfam) = lout
c
c  --- replace all blanks with underscores ---
c
         do i=1,14
            if( ptlong(iptfam)(i:i) .EQ. ' ' )
     &                                   ptlong(iptfam)(i:i) = '_'
         enddo
         do i=1,10
            if( ptname(iptfam)(i:i) .EQ. ' ' )
     &                                   ptname(iptfam)(i:i) = '_'
         enddo
         write(idiag,9001) caffec, cinflu, srcnam, 'N/A', 'N/A', 
     &                                  ptlong(iptfam), ptname(iptfam)
         if( lcdfout ) then
            ddmdesc(iptfam) = 'Sensitivity of '//TRIM(caffec)//
     &                        ' to '//TRIM(srcnam)//' '//TRIM(cinflu)
         endif

         goto 9999
      endif
c
c  --- find the integer value for this influencing species ---
c
      iinflu = 0
      do i=1,nspec
         if( cinflu .EQ. spname(i) ) iinflu = i
      enddo
      if( cinflu .EQ. NAMALL ) then
          iinflu = IDALL
      else if( cinflu .EQ. NAMVOC ) then
          iinflu = IDVOC
      else if( cinflu .EQ. NAMNOX ) then
          iinflu = IDNOX
      else if( cinflu .EQ. NAMHRV ) then
          iinflu = IDHRV
      else if( iinflu .EQ. 0 ) then
          goto 7000
      endif
      this_molwt = 1.0
      if( iinflu .LE. ngas .and. iinflu .GT. 0 ) 
     &                this_molwt = mole_weight(iinflu)
c
c  --- if there are groups loop over them --- 
c
      if( ngrps .GT. 0 .OR. nregs .GT. 0 ) then
         do ireg = 1,nregs
            do igrp = 1,ngrps
c
c  --- incrament the counter for position of species ---
c
                iptfam = iptfam + 1
c
c  --- set the flag for outputing this species to average file ---
c
                loutsa(iptfam) = lout
                ptop_fac(iptfam) = topfac
c
c  --- fill in the parts that depend on region ---
c
                lsamap(iptfam) = iptfam
                ptlong(iptfam)(1:4) = caffec(1:4)
                ptlong(iptfam)(5:6) = srcnam(1:2)
                write(ptlong(iptfam)(7:8),'(I2.2)') igrp
                write(ptlong(iptfam)(9:10),'(I2.2)') ireg
                ptlong(iptfam)(11:14) = cinflu(1:4)
                write(ptname(iptfam)(1:3),'(I3.3)') iaffec
                write(ptname(iptfam)(4:5),'(I2.2)') igrp
                write(ptname(iptfam)(6:7),'(I2.2)') ireg
                if( iinflu .GT. 0 ) then
                    write(ptname(iptfam)(8:10),'(I3.3)') iinflu
                else
                    ptname(iptfam)(8:10) = cinflu(1:3)
                endif
                sa_mole_weight(iptfam) = this_molwt
c
c  --- replace all blanks with underscores ---
c
                do i=1,14
                   if( ptlong(iptfam)(i:i) .EQ. ' ' ) 
     &                                   ptlong(iptfam)(i:i) = '_'
                enddo
                do i=1,10
                   if( ptname(iptfam)(i:i) .EQ. ' ' ) 
     &                                   ptname(iptfam)(i:i) = '_'
                enddo
c
c  --- echo the information to the output file ---
c
                write(idiag,9000) caffec, cinflu, srcnam, igrp, ireg, 
     &                                  ptlong(iptfam), ptname(iptfam)
                if( lcdfout ) then
                   write(ddmdesc(iptfam),'(7A,I2.2,A,I2.2)') 'Sensitivity of ',
     &                       TRIM(caffec),' to ',TRIM(srcnam),' ',TRIM(cinflu),
     &                                                    ' G=',igrp,' R=',ireg
                endif
            enddo
         enddo
c
c   --- if there are no groups or regions treat it differently ---
c
      else
         iptfam = iptfam + 1 
         lsamap(iptfam) = iptfam
         ptop_fac(iptfam) = topfac
         ptlong(iptfam)(1:4) = caffec(1:4)
         ptlong(iptfam)(5:10) = srcnam(1:5)
         ptlong(iptfam)(11:14) = cinflu(1:4)
         write(ptname(iptfam)(1:3),'(I3.3)') iaffec
         ptname(iptfam)(4:4) = srcnam(1:1)
         ptname(iptfam)(5:7) = srcnam(3:5)
         if( iinflu .GT. 0 ) then
             write(ptname(iptfam)(8:10),'(I3.3)') iinflu
         else
             ptname(iptfam)(8:10) = cinflu(1:3)
         endif
c
c  --- set the flag for outputing this species to average file ---
c
         loutsa(iptfam) = lout
c
c  --- replace all blanks with underscores ---
c
         do i=1,14
            if( ptlong(iptfam)(i:i) .EQ. ' ' ) 
     &                                   ptlong(iptfam)(i:i) = '_'
         enddo
         do i=1,10
            if( ptname(iptfam)(i:i) .EQ. ' ' ) 
     &                                   ptname(iptfam)(i:i) = '_'
         enddo
         write(idiag,9001) caffec, cinflu, srcnam, 'N/A', 'N/A', 
     &                                  ptlong(iptfam), ptname(iptfam)
         if( lcdfout ) then
              write(ddmdesc(iptfam),'(6A)') 'Sensitivity of ',
     &                  TRIM(caffec),' to ',TRIM(srcnam),' ',TRIM(cinflu)
         endif

      endif
      goto 9999
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(1X,A,3X,A,4X,A,I5,2X,I5,4X,A,2X,A)
 9001 format(1X,A,3X,A,4X,A,A5,2X,A5,4X,A,2X,A)
 9002 format(1X,A,3X,A,1X,A1,1X,A,17X,A,2X,A)
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in FILSPDDM:' 
      write(iout,'(/,1X,3A,/,2A)') 
     &          'ERROR: The species name: /',cinflu,'/',
     &          ' was used as a DDM species name but does not match',
     &          ' any modeled species.'
      call camxerr()
 7001 continue
      write(iout,'(//,A)') 'ERROR in FILSPDDM:'
      write(iout,'(/,1X,2A,/,5X,A,/,5X,A)')
     &           'ERROR: HDDM requires both of the following 1st order',
     &           ' sensitivity parameters:',
     &           hddmsp(1,ngrps),hddmsp(2,ngrps)
      write(iout,'(/,1X,2A,/,A)') 'Please make sure that',
     &         ' the following DDM namelist variables are consistent',
     &        ' with the HDDM parameters: '
      write(iout,'(10X,A)') 'Number_of_IC_Species_Groups'
      write(iout,'(10X,A)') 'Number_of_BC_Species_Groups'
      write(iout,'(10X,A)') 'Number_of_EM_Species_Groups'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine rdmethdr(iunit,filtype,igrid,begtim,begdate,endtim,
     &                    enddate,ncl,nrw,nly,xomod,yomod,
     &                    dxmod,dymod,iout,nvar)
      use grid
c 
c----CAMx v7.40 260801
c 
c     RDMETHDR reads the header of binary meteorological files,
c     and checks that all projection/grid information and variable lists
c     are consistent with the current run.
c                           
c      Copyright Ramboll
c           
c     Modifications: 
c       07/23/19   Staggered wind flag is now grid-specific
c 
c     Input arguments: 
c        iunit               input file unit
c        filtype             File type label
c        igrid               grid index
c        begtim              model start time (HHMM) 
c        begdate             model start date (YYJJJ) 
c        endtim              model end time (HHMM) 
c        enddate             model end date (YYJJJ)
c        ncl                 number of grid columns
c        nrw                 number of grid rows
c        nly                 number of grid layers
c        xomod               X-origin for grid (km or deg)
c        yomod               Y-origin for grid (km or deg)
c        dxmod               X-grid size (km or deg)
c        dymod               Y-grid size (km or deg)
c        iout                output message file unit
c             
c     Output arguments: 
c        nvar                Number of variables on file
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        SRFPREP
c        METINIT
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      character*200 filname
      character*10 filtype
      integer iunit,iout,igrid,begdate,enddate,ncl,nrw,nly
      integer nvar
      real begtim,endtim
      real xomod,yomod,dxmod,dymod
c
      character*4 fname(10),note(60),varnam(10,MXVAR)
      character*10 namsrf(NLUZ03),
     &             nam3d(NUM3DMET),
     &             nam2d(NUM2DMET),
     &             namkv(NUMKVMET),
     &             namcld(NUMCLDMET)
      character*10 filnote,varname(MXVAR)
      integer itz,idat1,idat2,iutm,nx,ny,nz,iproj,istag
      integer ical
      integer l,ll,lll,n
      real tim1,tim2,plon,plat,orgx,orgy,dxin,dyin,t1,t2
c
      integer istrln
c
      data namsrf   /'WATER     ',
     &               'ICE       ',
     &               'LAKE      ',
     &               'ENEEDL    ',
     &               'EBROAD    ',
     &               'DNEEDL    ',
     &               'DBROAD    ',
     &               'TBROAD    ',
     &               'DDECID    ',
     &               'ESHRUB    ',
     &               'DSHRUB    ',
     &               'TSHRUB    ',
     &               'SGRASS    ',
     &               'LGRASS    ',
     &               'CROPS     ',
     &               'RICE      ',
     &               'SUGAR     ',
     &               'MAIZE     ',
     &               'COTTON    ',
     &               'ICROPS    ',
     &               'URBAN     ',
     &               'TUNDRA    ',
     &               'SWAMP     ',
     &               'DESERT    ',
     &               'MWOOD     ',
     &               'TFOREST   '/
      data nam3d    /'ZGRID_M   ',
     &               'PRESS_MB  ',
     &               'TEMP_K    ',
     &               'HUMID_PPM ',
     &               'UWIND_MpS ',
     &               'VWIND_MpS '/
      data nam2d    /'TSURF_K   '/
      data namkv    /'KV_M2pS   '/
      data namcld   /'CLODW_GpM3',
     &               'RAINW_GpM3',
     &               'SNOWW_GpM3',
     &               'GRPLW_GpM3',
     &               'CLOUDOD   '/
c
c-----Entry point
c
c
c-----Get name of file attached to this unitnumber ---
c
      inquire(unit=iunit,name=filname)
c
c-----Read 1st header record and check inputs 
c             
      rewind(iunit)
      read(iunit,ERR=300) fname,note,itz,nvar,idat1,tim1,idat2,tim2
      write(filnote,'(10a1)') (note(n),n=1,10) 
c
      do n=1,10
        if( ichar(filnote(n:n)) .EQ. 0 ) filnote(n:n) = ' '
      enddo
      if (filnote.ne.filtype) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') 'grid #: ',igrid
        write(iout,*) 'Mismatch in file type.'
        write(iout,*) 'File contains: ',filnote
        write(iout,*) 'Expecting: ',filtype
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        write(iout,*) 'NOTE: Some file formats changed with this version.'
        write(iout,*) 'Make sure you are using the new format.'
        call camxerr()
      endif   
      if (filnote.ne.'SURFACE   ' .and. itz.ne.itzon) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') 'grid #: ',igrid
        write(iout,'(a)') 'Mismatch in time zone'
        write(iout,*) 'File contains: ',itz
        write(iout,*) 'Expecting: ',itzon
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif
c
c  --- make sure that endtime check passes for cloud file ---
c
      if( filnote .EQ. 'CLDMET    ' ) then
          if( INT(tim2) .EQ. 24 ) then
            idat2 = idat2 + 1 
            tim2 = 0.
            if( MOD(idat2,1000) .GT. 365 ) then
               if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
                  if( MOD(idat2,1000) .EQ. 367 )
     &                    idat2 = (INT(idat2/1000)+1)*1000 + 1
               else
                  idat2 = (INT(idat2/1000)+1)*1000 + 1
               endif
            endif
          endif
          tim2 = tim2 + 1.
      endif
      if( INT(tim2) .EQ. 24 ) then
         idat2 = idat2 + 1
         tim2 = 0.
         if( MOD(idat2,1000) .GT. 365 ) then 
            if( MOD(INT(idat2/1000),4) .EQ. 0 ) then 
               if( MOD(idat2,1000) .EQ. 367 )
     &                    idat2 = (INT(idat2/1000)+1)*1000 + 1
            else
               idat2 = (INT(idat2/1000)+1)*1000 + 1 
            endif
         endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if (idat1.gt.begdate) then 
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)')  '    grid #: ',igrid
        write(iout,'(a,a)')    '   filtype: ',filtype
        write(iout,'(a,a)') filnote,'start date > simulation start date'
        ical = idat1
        call caldate(ical)
        write(iout,'(a,a,2i10)') filnote,':',idat1,ical
        ical = begdate
        call caldate(ical)
        write(iout,'(a,2i10)')  'Sim start :',begdate,ical
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (idat1.eq.begdate .and. tim1.gt.begtim) then 
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)')  '    grid #: ',igrid
        write(iout,'(a,a)')    '   filtype: ',filtype
        write(iout,'(a,a)') filnote,'start time > simulation start time'
        write(iout,'(a,a,f10.2)') filnote,':',tim1
        write(iout,'(a,f10.2)')  'Sim start :',begtim
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (idat2.lt.enddate) then 
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)')  '    grid #: ',igrid
        write(iout,'(a,a)')    '   filtype: ',filtype
        write(iout,'(a,a)') filnote,'end date < simulation end date'
        ical = idat2
        call caldate(ical)
        write(iout,'(a,a,2i10)') filnote,':',idat2,ical
        ical = begdate
        call caldate(ical)
        write(iout,'(a,2i10)')  '  Sim end :',enddate,ical
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (idat2.eq.enddate .and. tim2.lt.endtim) then 
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)')  '    grid #: ',igrid
        write(iout,'(a,a)')    '   filtype: ',filtype
        write(iout,'(a,a)') filnote,'end time < simulation end time'
        write(iout,'(a,a,f10.2)') filnote,':',tim2
        write(iout,'(a,f10.2)')  '  Sim end :',endtim
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif 
c
      if (nvar.gt.MXVAR) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') ' grid #: ',igrid
        write(iout,'(a,a)')   'filtype: ',filtype
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,'(a,i10)') 'Number of variables exceeds:',MXVAR
        write(iout,'(a,i10)') 'Number of variables read   :',nvar
        write(iout,'(2a)') 'Increase parameter MXVAR in RDMETHDR.F ',
     &                                               'and re-compile'
        write(iout,*)
        call camxerr()
      endif
c 
c-----Read 2nd header record and check inputs 
c 
      read(iunit) plon,plat,iutm,orgx,orgy,dxin,dyin,nx,ny,nz,iproj,
     &            istag,t1,t2
      if (.NOT.llatlon) then
        orgx = orgx/1000.
        orgy = orgy/1000.
        dxin = dxin/1000.
        dyin = dyin/1000.
      endif
c
      if (filtype.eq.'3DMET') then
        lstagw(igrid) = .true.
        if (istag.eq.0) lstagw(igrid) = .false.
        if (igrid.gt.1) then
          if (lstagw(igrid) .NEQV. lstagw(1)) then
            write(iout,'(//,a)') 'WARNING in RDMETHDR:'
            write(iout,'(a,i10)') '   grid #: ',igrid
            write(iout,'(a,a)')   '  File type: ',filnote
            write(iout,*) 
     &        'Mismatch in staggered wind flag with master grid'
            write(iout,*) '      Master grid stagger is: ',lstagw(1)
            write(iout,*) '      Nested grid stagger is: ',lstagw(igrid)
            write(iout,*) 'Filename is: '
            write(iout,*) filname(:istrln(filname))
            write(iout,*)
          endif
        endif
      endif
c
      if (llatlon    .and. iproj.ne.0) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is Lat/Lon, met projection should be 0'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (lutm   .and. iproj.ne.1) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is UTM, met projection should be 1'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (lambrt .and. iproj.ne.2) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is Lambert, met projection should be 2'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (lrpolar .and. iproj.ne.3) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is Rotated Polar, met projection should be 3'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (lpolar .and. iproj.ne.4) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is Polar, met projection should be 4'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      elseif (lmerc .and. iproj.ne.5) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx grid is Mercator, met projection should be 5'
        write(iout,*) 'Met file projection is: ',iproj
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif
c
      if (iproj .eq. 1 .and. iutm .ne. iuzon) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,'(a,i10)') '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,*) 'CAMx UTM zone does not match zone from met file'
        write(iout,*) 'Met file UTM zone is: ',iutm
        write(iout,*) '    CAMx UTM zone is: ',iuzon
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif
      if (iproj.ge.2) then
        if (abs(plon-polelon).gt.0.001 .or. abs(plat-polelat).gt.0.001) then
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,'(a,i10)') '   grid #: ',igrid
          write(iout,'(a,a)')   '  File type: ',filnote
          write(iout,*) 'CAMx pole does not match met file'
          write(iout,*) 'Met file pole is: ',plon,plat
          write(iout,*) '    CAMx pole is: ',polelon,polelat
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
        endif
        if (iproj.eq.2 .or. iproj.eq.4 .or. iproj.eq.5) then
          if (abs(t1-tlat1).gt.0.001 .or. abs(t2-tlat2).gt.0.001) then
          if (abs(t1-tlat2).gt.0.001 .or. abs(t2-tlat1).gt.0.001) then
            write(iout,'(//,a)') 'ERROR in RDMETHDR:'
            write(iout,'(a,i10)') '   grid #: ',igrid
            write(iout,'(a,a)')   '  File type: ',filnote
            write(iout,*) 'CAMx true lats do not match met file'
            write(iout,*) 'Met file true lats are: ',t1,t2
            write(iout,*) '    CAMx true lats are: ',tlat1,tlat2
            write(iout,*) 'Filename is: '
            write(iout,*) filname(:istrln(filname))
            write(iout,*)
            call camxerr()
          endif
          endif
        endif
      endif
c
      if (abs(orgx-xomod).gt.0.001 .or. abs(orgy-yomod).gt.0.001) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,*)'Met origin not equal to model origin'
        write(iout,'(a,i10)')   '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,'(a,2f12.4)')' Met file: ',orgx,orgy
        write(iout,'(a,2f12.4)')'    model: ',xomod,yomod
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif
      if (abs(dxin-dxmod).gt.0.001 .or. abs(dyin-dymod).gt.0.001) then
        write(iout,'(//,a)') 'ERROR in RDMETHDR:'
        write(iout,*)'Met cell size not equal to model cell size'
        write(iout,'(a,i10)')   '   grid #: ',igrid
        write(iout,'(a,a)')   '  File type: ',filnote
        write(iout,'(a,2f10.4)')' Met file: ',dxin,dyin
        write(iout,'(a,2f10.4)')'    model: ',dxmod,dymod
        write(iout,*) 'Filename is: '
        write(iout,*) filname(:istrln(filname))
        write(iout,*)
        call camxerr()
      endif
      if (filnote.eq.'2DMET' .or. filnote.eq.'SURFACE') then
        if (nx.ne.ncl .or. ny.ne.nrw) then
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'Met grid size not equal to model grid size '
          write(iout,*)       '   grid #: ',igrid
          write(iout,'(a,a)')   '  File type: ',filnote
          write(iout,*)' Met file: ',nx,ny
          write(iout,*)'    model: ',ncl,nrw
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
        endif 
      else
        if (nx.ne.ncl .or. ny.ne.nrw .or. nz.ne.nly) then
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'Met grid size not equal to model grid size '
          write(iout,*)       '   grid #: ',igrid
          write(iout,'(a,a)')   '  File type: ',filnote
          write(iout,*)' Met file: ',nx,ny,nz
          write(iout,*)'    model: ',ncl,nrw,nly
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
        endif 
      endif
c
c-----Read 3rd & 4th header 
c 
      read(iunit)
      read(iunit) ((varnam(n,l),n=1,10),l=1,nvar) 
      do l = 1,nvar
        write(varname(l),'(10a1)') (varnam(n,l),n=1,10)
      enddo
c 
c-----Check variable names against required fields
c 
      if (filnote.eq.'3DMET') then
        do 100 l = 1,NUM3DMET
          do ll = 1,nvar
            if (varname(ll).eq.nam3d(l)) goto 100
          enddo
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'3D Met file does not have the required field:'
          write(iout,*)'   grid #: ',igrid
          write(iout,*)' Variable: ',nam3d(l)
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
 100    continue
      endif
      if (filnote.eq.'2DMET') then
        do 101 l = 1,NUM2DMET
          do ll = 1,nvar
            if (varname(ll).eq.nam2d(l)) goto 101
          enddo
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'2D Met file does not have the required field:'
          write(iout,*)'   grid #: ',igrid
          write(iout,*)' Variable: ',nam2d(l)
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
 101    continue
      endif
      if (filnote.eq.'KVMET') then
        do 102 l = 1,NUMKVMET
          do ll = 1,nvar
            if (varname(ll).eq.namkv(l)) goto 102
          enddo
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'VDiff file does not have the required field:'
          write(iout,*)'   grid #: ',igrid
          write(iout,*)' Variable: ',namkv(ll)
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
 102    continue
      endif
      if (filnote.eq.'CLDMET') then
        do 103 l = 1,NUMCLDMET
          do ll = 1,nvar
            if (varname(ll).eq.namcld(l)) goto 103
          enddo
          write(iout,'(//,a)') 'ERROR in RDMETHDR:'
          write(iout,*)'Cloud file does not have the required field:'
          write(iout,*)'   grid #: ',igrid
          write(iout,*)' Variable: ',namcld(ll)
          write(iout,*) 'Filename is: '
          write(iout,*) filname(:istrln(filname))
          write(iout,*)
          call camxerr()
 103    continue
      endif
      if (filnote.eq.'SURFACE') then
        do 105 l = 1,NLUZ03
          do ll = 1,nvar
            if (varname(ll).eq.namsrf(l)) goto 105
          enddo
          goto 200
 105    continue
      endif
c
      return
c
 200  continue
      write(iout,'(//,a)') 'ERROR in RDMETHDR:'
      write(iout,*)'   grid #: ',igrid
      write(iout,*) 'Filename is: '
      write(iout,*) filname(:istrln(filname))
      write(iout,*)'Surface file does not have the required field:'
      write(iout,*) namsrf(l)
      write(iout,*)'The surface file needs 26 landuse types:'
      do lll = 1,NLUZ03
        write(iout,*) namsrf(lll)
      enddo
      call camxerr()
c
 300  continue
      write(iout,'(//,a)') 'ERROR in RDMETHDR:'
      write(iout,*)'Could not read header of met file.'
      write(iout,*)'   grid #: ',igrid
      write(iout,*) 'Expecting: ',filtype
      write(iout,*) 'Filename is: '
      write(iout,*) filname(:istrln(filname))
      write(iout,*)
      write(iout,*) 'NOTE: Some file formats changed with this version.'
      write(iout,*) 'Make sure you are using the new format.'
      call camxerr()
c
      end

      SUBROUTINE HGAQSCHEM ( CHG0, CHG2, CO3, CSO2, COH, CHO2, CHCL,
     &                       CCL2, CPM, CPH, LWC, TEMP, PRES, DELT,
     &                       SO2H, SO2TMP, O3H, O3TMP )

C
c----CAMx v7.40 260801
C
C   HGAQSCHEM performs the Hg aqueous-phase chemistry calculations.
C
C     Copyright 2003
C     AER, Inc.
C 
C Revision History: 
C***********************************************************************
C   Version 1.0 written March 2003 by Prakash Karamchandani, AER       *
C   Code updated August 2003 to use Henry's Law and SO2 dissociation   *
C   constants consistent with those used in the CAMx aqueous-phase     *
C   chemistry module                                                   *
C*********************************************************************** 
C
C  Called by:  CHEMDRIV
C
C*********************************************************************** 

      IMPLICIT NONE

C Includes:

      INCLUDE 'hgaqschm.prm'  ! Hg aqueous-phase chemistry parameters

C Arguments:

      REAL  CHG0      ! Hg(0) concentration, ppm (Input/Output)
      REAL  CHG2      ! Hg(2) concentration, ppm (Input/Output)

      REAL  CO3       ! O3 concentration, ppm (Input only)
      REAL  CSO2      ! SO2 concentration, ppm (Input only)
      REAL  COH       ! OH concentration, ppm (Input only)
      REAL  CHO2      ! HO2 concentration, ppm (Input only)
      REAL  CHCL      ! HCL concentration, ppm (Input only)
      REAL  CCL2      ! CL2 concentration, ppm (Input only)
      REAL  CPM       ! Total PM concentration, ug/m3 (Input only)

      REAL  CPH       ! Cloudwater pH (Input only)
      REAL  LWC       ! Liquid water content, g/m3 (Input only)
      REAL  TEMP      ! Temperature, K (Input only)
      REAL  PRES      ! Pressure, mb (Input only)
      REAL  DELT      ! Chemistry time step, seconds (Input only)

      REAL SO2H       ! Henry's Law constant for SO2, M/atm (Input only)
      REAL O3H        ! Henry's Law constant for O3, M/atm (Input only)
      REAL SO2TMP     ! SO2 Henry's Law temperature dependence (Input only)
      REAL O3TMP      ! O3 Henry's Law temperature dependence (Input only)

! Local variables

! Standard atmosphere in mb
      REAL        STDATMMB
      PARAMETER ( STDATMMB = 1013.25 )

! Pressure in atmospheres
      REAL PRES_ATM

! Conv. factor from ppm to atmospheres
      REAL  CFACT

! Conversion factor (M to atm), liter-atm/mole
      REAL  XL

! Henry's Law constant for OH and HO2, M/atm
      REAL OHH, HO2H

! Temperature in K and Centigrade and inverse temperature (K-1)
      REAL  TEMPK, TEMPC, TEMPI

! Double precision local variables (for accuracy):

      DOUBLE PRECISION  Y00   ! Initial total Hg(0) partial pressure, atm
      DOUBLE PRECISION  Y20   ! Initial total Hg(2) partial pressure, atm

      DOUBLE PRECISION  Z0T   ! Final total Hg(0) partial pressure, atm
      DOUBLE PRECISION  Z2T   ! Final total Hg(2) partial pressure, atm

! --- Local concentration array
      DOUBLE PRECISION  Y( NUMSP )
!     Y(1)         [Hg(0)]-Gaseous (variable), atm
!     Y(2)         [Hg(2)]-Gaseous (variable), atm
!     Y(3)         [O3]-Gaseous (constant), atm
!     Y(4)         [Cl2]-Gaseous (constant), atm
!     Y(5)         [HCl]-Gaseous (constant), atm
!     Y(6)         [SO2]-Gaseous (constant), atm
!     Y(7)         [OH]-Aqueous (constant), M
!     Y(8)         [HO2]-Aqueous (constant), M

      DOUBLE PRECISION  PM  ! PM10 conc. (g/L)

! --- Intermediate variables for calculating Hg(2) complexes with SO2
! --- in solution and their reaction rates
      DOUBLE PRECISION  CON1, CON2, CON3, CON4, CON51, CON52

! --- Intermediate variables for calculating Hg(2) concentrations in
! --- solution as Hg(2)2+, HgCl2 and Hg(OH)2 and total Hg(2)
      DOUBLE PRECISION  CON5, CON6, CON7, TOTHG

! --- Aqueous concentrations (M) of dissociation products of Cl2,
! --- HOCL and OCL-
      DOUBLE PRECISION  CONHOCL, CONOCL

! --- Aqueous concentrations (M) of HCl and Cl2
      DOUBLE PRECISION  CONHCL, CONCL

! --- Intermediate variables for calculating Cl species distribution
! --- in solution
      DOUBLE PRECISION  THCL, TCL2, CA, CB, CC, CD, AA, AB, AC, AD

! --- Aqueous equilibrium constants for SO2 and HSO3
! --- SO2       <=>  H+ + HSO3-       (M)
! --- HSO3-     <=>  SO3-- + H+       (M)
      DOUBLE PRECISION  EKSO2, EKHSO3

! --- Henry's Law constants (M/atm)
      DOUBLE PRECISION  HNRHG0, HNRHGCL2, HNRHGOH2
      DOUBLE PRECISION  HNRSO2, HNRO3, HNRHCL, HNRCL2

! --- H+ concentration, OH- concentration
      DOUBLE PRECISION  PHCON, POHCON

      DOUBLE PRECISION  RLCONV  ! Conversion factor (M to atm)

! --- Chemistry parameters
      DOUBLE PRECISION  DT   ! Chemistry time step, sec
      DOUBLE PRECISION  ALPHA1, ALPHA2, ALPH12 ! Intermediate variables
      DOUBLE PRECISION  DENOM1, DENOM2

! --- Temperature-dependent rate for HGSO3 reaction
      DOUBLE PRECISION  RKHGSO3I

! --- Assign values to local variables

! --- Local copy of temperature (don't allow temperature to go below
! --- freezing)
      TEMPK = MAX( TEMP , REAL(TZERO) )

! --- Inverse temperature
      TEMPI = 1.0 / TEMPK

! --- Calculate partial pressures in atm.
      PRES_ATM = PRES / STDATMMB
      CFACT    = 1.E-6 * PRES_ATM

! --- XL is the conversion factor from M (moles/liter of water) to atm
      XL = ( LWC / H2ODENS ) * ( MOLVOL * TEMPK / TZERO )

      Y00 = CHG0 * CFACT
      Y20 = CHG2 * CFACT

      Y( KO3G  ) = CO3  * CFACT
      Y( KSO2G ) = CSO2 * CFACT
      Y( KHCLG ) = CHCL * CFACT
      Y( KCL2G ) = CCL2 * CFACT

! --- Calculate liquid-phase concs of OH and HO2 radicals

! --- Henry's Law constants for OH and HO2
! --- Values below are from Jacobson's book (1999)
      OHH  =   25. * EXP( 17.72 * ( 298.15 * TEMPI - 1.0 ) )
      HO2H = 2000. * EXP( 22.28 * ( 298.15 * TEMPI - 1.0 ) )

! --- Since liquid-phase chemistry of OH and HO2 radicals is not explicitly
! --- simulated in CAMx, assume that in-cloud processes remove 50% of OH and
! --- 90% of HO2
      Y( KOHAQ )  = COH  * CFACT * OHH  * 0.5 / ( 1.0 + OHH  * XL )
      Y( KHO2AQ ) = CHO2 * CFACT * HO2H * 0.1 / ( 1.0 + HO2H * XL )

! --- H+ and OH- aqueous concentrations in moles/liter
      PHCON  = 10. ** ( -CPH )
      POHCON = 10. ** ( CPH - 14 )

! --- concentration of PM in g/L of water
      PM = CPM * H2ODENS * 1.E-9 / LWC  ! No need to check if LWC = 0. since
                                        ! this routine is not called if
                                        ! LWC < LWMIN

! --- Assign some double precision variables

! --- Conversion factor from M to atm.
      RLCONV = XL

! --- Chemistry time step
      DT = DELT

! --- Henry's Law constants for SO2 and O3
      HNRO3  = O3H*exp(O3TMP*(1./298. - 1./tempk))
      HNRSO2 = SO2H*exp(SO2TMP*(1./298. - 1./tempk))
      EKSO2  = 10.**(853./tempk)/54950.
      EKHSO3 = 10.**(621.9/tempk)/1.897e+9

! --- Henry's Law constants for Hg(0), HgCl2, Hg(OH)2, HCl and Cl2
! --- (Not available from CAMx)
! --- Special expression for Hg(0) Henry's Law constant
      HNRHG0 = 54.78775913129319 * EXP( -55.7339 + 9540.36 * TEMPI +
     &                                 16.0477 * ALOG( TEMPK / 100. ) )
      HNRHGCL2 = 1.4E6
      HNRHGOH2 = 1.2E4

      HNRHCL   = 1.1

! --- Special expression for Cl2 Henry's Law constant
      TEMPC = TEMPK - TZERO
      HNRCL2 = 0.149 + TEMPC * ( -3.59E-03 +
     &                   TEMPC * ( 2.5E-05 + TEMPC * 5.67E-08 ) )

! --- Gas-liquid partitioning of reactant species
      Y( KO3G ) = Y( KO3G ) / ( 1.0 + RLCONV * HNRO3 )

! --- Calculate distribution of chlorine species
      IF ( RLCONV .GT. 0. ) THEN  ! Check for RLCONV not really required
                                  ! since this routine is only called for
                                  ! liquid water >= lwmin
         THCL = Y( KHCLG ) / RLCONV
         TCL2 = 2. * Y( KCL2G ) / RLCONV
C
C Calculate subcomponents
         CA = 2. * ( 1.0 + PHCON / EKHOCL )
         CB = 2. * ( 1.0 + 1.0 / ( HNRCL2 * RLCONV ) ) * PHCON**2. /
     &        EKCL2 / EKHOCL
         CC = 1.0 + PHCON / EKHCL * ( 1.0 + 1.0 / ( HNRHCL * RLCONV ) )
         CD = TCL2 * (1.0 + PHCON / EKHOCL )
C
C Solve quadratic equation
         AA = CB * CC
         AB = CA * CC - CB * THCL
         AC = -( CD + CA * THCL )
         AD = AB * AB - 4. * AA * AC

         CONCL = ( -AB + SQRT( AD ) ) / (2. * AA )
         CONHCL = CONCL * PHCON / EKHCL
         Y( KHCLG ) = CONHCL / HNRHCL
         Y( KCL2G ) = 0.5 * TCL2 / (1. / ( RLCONV ) + HNRCL2 *
     &                ( 1.0 + EKCL2 / ( EKHCL * HNRHCL * Y( KHCLG ) ) *
     &                ( 1.0 + EKHOCL / PHCON ) ) )

      END IF  ! ( RLCONV > 0. )

! --- Calculate partitioning of S(IV), assuming that mercury sulfites
! --- are negligible compared to other sulfite ions.
      Y( KSO2G ) = Y( KSO2G ) / ( 1.0 + RLCONV * HNRSO2 * ( 1.0 +
     &             EKSO2 / PHCON * ( 1.0 + EKHSO3 / PHCON ) ) )

! --- Calculate constants
      CON2 = EKHGSO3 * EKSO2 * EKHSO3 * HNRSO2 / ( PHCON * PHCON )
      CON3 = EKHGSO3 * EKHGSO32 * ( EKSO2 * EKSO2 ) * 
     &          ( EKHSO3 * EKHSO3 ) * ( HNRSO2 * HNRSO2 ) / ( PHCON**4 )
      CON5 = ( 1.0 + Y( KSO2G ) * ( CON2 + CON3 * Y( KSO2G ) ) )
      CON6 = ( ( EKHCL * HNRHCL * Y( KHCLG ) / PHCON )**2 ) / EKHGCL2
      CON7 = ( POHCON * POHCON ) / EKHGOH2
      CONHOCL = HNRCL2 * Y( KCL2G ) * EKCL2 / 
     &                                  ( EKHCL * HNRHCL * Y( KHCLG ) )
      CONOCL = CONHOCL * EKHOCL / PHCON

      CON51 = CON2 * Y( KSO2G )
      CON52 = CON3 * Y( KSO2G ) * Y( KSO2G )
      DENOM1 = ( 1.0 + RLCONV * HNRHG0 )
      TOTHG = CON5 + ( CON51 + CON52 ) * EKP * PM + ( CON6 + CON7 ) *
     2        ( 1.0 + EKP * PM )
      DENOM2 = CON6 / HNRHGCL2 + CON7 / HNRHGOH2 + RLCONV * TOTHG

! --- Hg aqueous chemistry calculations for time-step DT

! --- Calculate HGSO3 reaction rate (Van Loon et al., 2000)
      RKHGSO3I = RKHGSO3 * EXP( -105000. / 8.3 * ( TEMPI - TREFI ) )

      CON1 = RKHGSO32 * CON3
      CON4 = RKHGSO3I * CON2

      ALPHA1 = ( RLCONV * HNRHG0 * ( RKO3 * HNRO3 * Y( KO3G ) +
     &                               RKOH * Y( KOHAQ ) +
     &                               RKHOCL * CONHOCL +
     &                               RKOCL * CONOCL ) ) / DENOM1

      ALPHA2 =  RLCONV / DENOM2 * ( CON1 * ( Y( KSO2G ) * Y( KSO2G ) ) +
     &          CON4 * Y( KSO2G ) + RKHO2 * Y( KHO2AQ ) *
     &          ( CON5 + CON6 + CON7 ) )

      ALPH12 = ALPHA1 + ALPHA2

! --- Calculate analytical solution
      Z0T = ALPHA2 * ( Y00 + Y20 ) / ALPH12 *
     &      (1.0 - EXP( -ALPH12 * DT ) ) + Y00 * EXP( -ALPH12 * DT )
      Z2T = Y00 + Y20 - Z0T

      CHG0 = Z0T / CFACT
      CHG2 = Z2T / CFACT

      RETURN
      END

      subroutine strato3(m1,m2,nlayer,ia,iz,ja,jz,ibcon,igrd,nspc,
     &                   imapnest,height,tempk,press,conc,topo,ctop)
      use chmstry
      use grid
      use tracer
c
c----CAMx v7.40 260801
c
c     STRATO3 replaces O3 concentrations in all layers above the locally-
c     diagnosed tropopause based on a linear O3 gradient between the top
c     BC (model top) and a fixed value of 100 ppb at the top of the layer
c     containing the tropopause.
c
c      Copyright Ramboll
c
c     Modifications:
c        05/11/20   Modified the ozone interpolation over altitude
c                   from linear to an exponential power of 2.5,
c                   convert altitude from AGL to MSL
c        None
c
c     Input arguments:
c        m1                number of columns in slice/domain
c        m2                number of rows in slice/domain
c        nlayer            number of layers
c        ia,iz             row start/end index
c        ja,jz             column start/end index
c        ibcon             MPI slice boundary flag
c        igrd              grid index
c        nspc              number of species
c        imapnest          map of nested grids in this grid
c        height            layer interface heights (m)
c        tempk             temperature (K)
c        press             pressure (mb)
c        conc              species concentrations (umol/m3)
c        topo              terrain elevation (m)
c        ctop              top concentrations above model (ppm)
c
c     Output arguments:
c        conc              species concentrations (umol/m3)
c
c     Routines Called:
c        None   
c
c     Called by:
c        EMISTRNS
c
      implicit none
      include "camx.prm"
      include "camx.inc"
c
      integer      m1,m2,ia,iz,ja,jz,ibcon
      integer      nlayer
      integer      nspc
      integer      igrd
      real         conc(m1,m2,nlayer,nspc)
      real         ctop(m1,m2,nspc)
      real         topo(m1,m2)
      real         tempk(m1,m2,nlayer)
      real         press(m1,m2,nlayer)
      real         height(m1,m2,nlayer)
      integer      imapnest(m1,m2)

      integer j,i,k,ktrop
      integer m_zi1,m_zi2,m_zj1,m_zj2
      integer idxcel,idx,lsao3
      real convfac
      real tropo3, topo3
      real do3dz
      real ztop
      real c1d(MXLAYER)
      real z1d(MXLAYER)
      real t1d(MXLAYER)
      real p1d(MXLAYER)
c
c-----Entry point
c
c-----Set grid point limits
c
      m_zi1= ia-1
      m_zi2= iz+1
      m_zj1= ja-1
      m_zj2= jz+1

      if(btest(ibcon,0)) m_zi1 = ia
      if(btest(ibcon,1)) m_zi2 = iz
      if(btest(ibcon,2)) m_zj1 = ja
      if(btest(ibcon,3)) m_zj2 = jz
c
      do 60 j = m_zj1, m_zj2   !2,nrow-1
        do 50 i = m_zi1, m_zi2  !2,ncol-1
c
c-----Skip cells occupied by child grids
c
          if (imapnest(i,j).gt.igrd) goto 50

          do k = 1,nlayer
            z1d(k) = topo(i,j) + height(i,j,k)
            t1d(k) = tempk(i,j,k)
            p1d(k) = press(i,j,k)
            c1d(k) = conc(i,j,k,ko3)
          enddo

c-----Diagnose tropopause

          call findtrop(nlayer,t1d,z1d,ktrop)
          if (ktrop.eq.nlayer) cycle

c-----Interpolate TC ozone to the layers above the tropopause
          
          tropo3 = 0.100
          topo3  = ctop(i,j,ko3)
          ztop = z1d(nlayer)
          do3dz = (topo3 - tropo3)/(ztop - z1d(ktrop))**2.5
          do k = ktrop+1,nlayer
            convfac = densfac*(273./t1d(k))*(p1d(k)/1013.)
            conc(i,j,k,ko3) = tropo3 + 
     &                   do3dz*((z1d(k) + z1d(k-1))/2. - z1d(ktrop))**2.5
            conc(i,j,k,ko3) = conc(i,j,k,ko3)*convfac
c
c=================== Source Apportionment Begin  =====================
c
c  --- Re-allocate new stratospheric ozone to O3N+O3V top BC tracers,
c      set all other O3N+O3V tracers to zero (lower bound) ---
c
            if( ltrace .AND. lozone ) then

              idxcel =  ipsa3d(igrd)-1 + 
     &                  DBLE(i) + 
     &                  DBLE(m1)*DBLE(j-1) + 
     &                  DBLE(m1)*DBLE(m2)*DBLE(k-1)
              do lsao3 = iptcls(idxipt(ITRO3N)),nptcls(idxipt(ITRO3V))
                idx = idxcel + 
     &                DBLE(m1)*DBLE(m2)*DBLE(nlayer)*DBLE(lsao3-1)
                if( (lbndry .AND. ptname(lsao3)(4:6) .EQ. 'TOP') .OR.
     &           (.NOT.lbndry .AND. ptname(lsao3)(7:8) .EQ. 'BC') )then
                  ptconc(idx) = 0.5*conc(i,j,k,ko3)
                else
                  ptconc(idx) = BNDLPT
                endif
              enddo

            endif
c
c=================== Source Apportionment End  =======================
c
          enddo
c
  50    continue
  60  continue
c
      return
      end

      subroutine interp2d(ncol,nrow,nlay,io,jo,nmesh,ncolf,nrowf,
     &                    cval,fval)
c
c----CAMx v7.40 260801
c
c     INTERP2D horizontally interpolates a coarse grid field to a
c     fine grid
c
c      Copyright Ramboll
c          
c     Modifications:
c        none
c
c     Input arguments:
c        ncol              number of columns in parent grid
c        nrow              number of rows in parent grid 
c        nlay              number of layers in parent grid
c        io                starting i index for the fine grid
c        jo                starting j index for the fine grid
c        nmesh             mesh number
c        ncolf             number of columns in fine grid
c        nrowf             number of rows in fine grid
c        cval              cell centered value on coarse grid
c
c     Output arguments:
c        fval              cell centered value on fine grid
c
c     Subroutine called:
c        none
c
c     Called by:
c        STARTUP
c        INTRPDAT
c        INTRPCNC
c
      real cval(ncol,nrow,nlay)
      real fval(ncolf,nrowf,nlay)
c
c-----Entry point
c
      do 50 k = 1,nlay
        jc = jo
        yc = float(jc - jo + 1) - 0.5
        do j = 1,nrowf
          ic = io
          xc = float(ic - io + 1) - 0.5
          yf = (j - 1.5)/float(nmesh)
          if (yc.le.yf) then
              jc = jc + 1
              yc = float(jc - jo + 1) - 0.5
          endif
          do i = 1,ncolf
            xf = (i - 1.5)/float(nmesh)
            if (xc.le.xf) then
              ic = ic + 1
              xc = float(ic - io + 1) - 0.5
            endif
            dcdx1 = (cval(ic,jc-1,k) - cval(ic-1,jc-1,k))
            dcdx2 = (cval(ic,jc,k) - cval(ic-1,jc,k))
            c1 = cval(ic,jc-1,k) - dcdx1*(xc - xf)
            c2 = cval(ic,jc,k) - dcdx2*(xc - xf)
            dcdy = (c2 - c1)
            fval(i,j,k) = c2 - dcdy*(yc - yf)
          enddo
        enddo
c
  50  continue
c
      return
      end

      subroutine hr_xo4(y0,y1,yh,H2O,M,O2,CH4,H2,ny,rk,r,nr,dt)
      implicit none
c
c----CAMx v7.40 260801
c
c     HR_XO4 solves halogen oxides by EBI iterations
c
c      Copyright Ramboll
c
c     Created by the CMC v7.4
c
c     Mechanism is CB6r4 + SQT + GLY/MGLY SOA
c
c --- Subroutines Called:
c        none
c
c --- Called by:
c        EBISOLV
c
c --- Argument definitions:
c        y0  - initial Conc for this step (ppm)
c        yh  - current Conc iteration (ppm)
c        y1  - next Conc iteration (ppm)
c        H2O - water vapor Conc (ppm)
c        M   - total gas Conc (ppm)
c        O2  - oxygen Conc (ppm)
c        CH4 - methane Conc (ppm)
c        H2  - hydrogen Conc (ppm)
c        ny  - dimension of y0, y1 and yh
c        rk  - rate constants (ppm-n hr-1)
c        r   - reaction rates (hr-1)
c        nr  - dimension of rk and r
c        dt  - time step (hr)
c
c --- Includes:
      include "camx.prm"
      include "chmdat.inc"
      include "ddmchm.inc"
c
c --- Arguments:
      integer ny, nr
      real y0(ny+1), y1(ny+1), yh(ny+1)
      real rk(nr), r(nr)
      real H2O, M, O2, CH4, H2, dt
c
c --- Local variables:
      real N2
      integer iter, nit
      real TINY
      parameter (TINY = 1.0E-20)
      real gainI, lossI
      real gainIO, lossIO
      real gainOIO, lossOIO
      real r209, r210, r211, r212, r213, r214, r215, r216, r217, r218
      real r219, r220, r221, r223
c
c --- Entry Point
c
      N2 = M - O2
      r209 = r(209)
      r210 = r(210)
      r221 = r(221)
      r223 = r(223)
c
      nit = 2
c
      do iter = 1,nit
c
c --- Update reaction rates that change with iteration of y1
c
      r211 = rk(211)*y1(lI)*yh(lO3)
      r212 = rk(212)*y1(lIO)
      r213 = rk(213)*y1(lIO)*y1(lIO)
      r214 = rk(214)*y1(lIO)*yh(lHO2)
      r215 = rk(215)*y1(lIO)*yh(lNO)
      r216 = rk(216)*y1(lIO)*yh(lNO2)
      r217 = rk(217)*y1(lOIO)
      r218 = rk(218)*y1(lOIO)*yh(lOH)
      r219 = rk(219)*y1(lOIO)*y1(lIO)
      r220 = rk(220)*y1(lOIO)*yh(lNO)
c
c --- Gain and loss terms for the XO species
c
      gainI = 0.0
     &       + ( 2.000)*r209
     &       +          r210
     &       +          r212
     &       + ( 0.400)*r213
     &       +          r215
     &       +          r217
     &       +          r221
     &       +          r223
c
      lossI = 0.0
     &       +          r211
c
      gainIO = 0.0
     &       +          r211
     &       +          r220
c
      lossIO = 0.0
     &       +          r212
     &       + ( 2.000)*r213
     &       +          r214
     &       +          r215
     &       +          r216
     &       +          r219
c
      gainOIO = 0.0
     &       + ( 0.400)*r213
     &       +          r221
c
      lossOIO = 0.0
     &       +          r217
     &       +          r218
     &       +          r219
     &       +          r220
c
c --- EBI solution for the XO species
c
      y1(lI) = MIN(1.0, MAX(TINY,(y0(lI) + gainI*dt)
     &                         / (1.0 + lossI*dt/y1(lI))))
c
      y1(lIO) = MIN(1.0, MAX(TINY,(y0(lIO) + gainIO*dt)
     &                         / (1.0 + lossIO*dt/y1(lIO))))
c
      y1(lOIO) = MIN(1.0, MAX(TINY,(y0(lOIO) + gainOIO*dt)
     &                         / (1.0 + lossOIO*dt/y1(lOIO))))
c
      enddo ! Iterations
c
      return
      end

      subroutine getunit(iounit)
      use filunit
c
c----CAMx v7.40 260801
c
c     GETUNIT incraments the I/O unit number, checks that it is not
c     already attached to a file and returns an unused unit number.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        none
c
c     Output arguments:
c        iounit
c
c     Routines called:
c        none
c
c     Called by:
c         READNML
c         OPENFILS
c         STARTDDM
c         STARTSA
c         STARTRT
c
      include 'camx.prm'
c
      integer iounit
c
      logical lused
c
c-----Entry point
c
c
c  --- incrament the global unit number variable ---
c
  111 continue
      icur_unit = icur_unit + 1
c
c  --- check if this unit is attached to a file ---
c
      inquire(unit=icur_unit,opened=lused)
c
c  --- if it is already used, go back and bump it up ---
c
      if( lused ) goto 111
c
c  --- set the output variable and return ---
c
      iounit = icur_unit
      return
      end

      subroutine par_decomp(nxp,nyp,nest_factor,nodes,                   
     &                      work,workrow,nblocks,workload,workblock,workcol,
     &                      jrows,jrow,ixb,ixe,iyb,iye                      )
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine decomposes grid domains of size (nnxp,nnyp) into
c        a number, specified by nodes, of rectangular subdomains.  The
c        convention is followed that any internal boundaries (between
c        subdomains) that are parallel to the x-axis run continuously
c        across the full domain, while boundaries parallel to the y-axis
c        may or may not run the full distance across the domain.  For
c        convenience, regions of the domain bounded by adjacent
c        east-west internal boundaries are termed "slabs", while smaller
c        divisions within each slab are termed "blocks".  Each block is
c        required to have a minimum dimension of 6 by 6 grid cells.  If
c        this cannot be satisfied with the given input parameters, the
c        subroutine stops.
c
c        Estimate the number of slabs to be used (aslabs), and compute a
c        final nearest integer value (nslabs) which is limited to
c        allowable values. Zero out array for accumulating number of
c        columns for each node.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c      integer :: jrows(*)   the number of rows in each slab
c      integer :: jrow (*)   the index of the southernmost row in each slab
c     Output:  
c
c    Called by:
c       DOMAIN_DECOMP
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c       03/15/09     Added code for deposition output for tracers
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: nxp
      integer :: nyp
      integer :: nest_factor
      integer :: nodes
c
      real    :: work(nxp,*)
      real    :: workrow(*)
c
      integer :: nblocks(*)
c
      real    :: workload(*)
      real    :: workblock(*)
      real    :: workcol(*)
c
      integer :: jrows(*)
      integer :: jrow (*)
      integer :: ixb(*)
      integer :: ixe(*)
      integer :: iyb(*)
      integer :: iye(*)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
c  --- default relspeed = 1.0 for nodes of uniform speed. ---
c
      real    :: relspeed(256)
      data       relspeed/256*1./
c
      integer :: inode
      integer :: i
      integer :: j
      integer :: islab
      integer :: nslabs
      integer :: min_blocks
      integer :: nbigslabs
      integer :: iblock
      integer :: jnode
      integer :: knode
      integer :: ii
      integer :: jj
c
      real    :: anodes
      real    :: aslabs
      real    :: totspeed
      real    :: workdom
      real    :: workaccum
      real    :: worksofar
      real    :: slabspeed
      real    :: workslab
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c            
      anodes = float(nodes)
      aslabs = sqrt(anodes * float(nyp) / float(nxp))
      nslabs = min(nodes,max(1,nint(aslabs)))
      totspeed = 0.
c
      do inode = 1,nodes
         ixe(inode) = 0
         totspeed = totspeed + relspeed(inode)
      enddo
c
c  --- Compute total work load over each row and over entire domain. ---
c
      workdom = 0.
      do j = 1,nyp
         workrow(j) = 0.
         do i = 1,nxp
            workrow(j) = workrow(j) + work(i,j)
         enddo
         workdom = workdom + workrow(j)
      enddo
      workrow(2) = workrow(2) + workrow(1)
      workrow(nyp-1) = workrow(nyp-1) + workrow(nyp)
c
c  --- Determine number of blocks and the average workload for each slab. ---
c
      min_blocks = nodes / nslabs
      nbigslabs = nodes - min_blocks * nslabs
      inode = 0
      do islab = 1,nslabs
         workload(islab) = 0.
         nblocks(islab) = min_blocks
         if (islab .le. nbigslabs) nblocks(islab) = min_blocks + 1
         do iblock = 1,nblocks(islab)
            inode = inode + 1
            workload(islab) = workload(islab) + 
     &                                     workdom * relspeed(inode) / totspeed
         enddo
      enddo
c
c  --- Assign all j-rows to their respective slabs in a way 
c      that balances the work load among slabs according to
c      their respective numbers of nodes (blocks). ---
c
      do islab = 1,nslabs
         jrows(islab) = 0
      enddo
      workaccum = 0.
      worksofar = 0.
      islab = 0
c
      do j = 2,nyp-1,nest_factor
         do jj=0,nest_factor-1
            workaccum = workaccum + workrow(j+jj)
         enddo
         if (workaccum - .5 * workrow(j+jj) .gt. worksofar .and.
     &                                                  islab .lt. nslabs) then
            islab = islab + 1
            jrow(islab) = j
            worksofar = worksofar + workload(islab)
         endif
         jrows(islab) = jrows(islab) + nest_factor
      enddo
c
      inode = 0
      jnode = 0
      knode = 0
      do islab = 1,nslabs
c
c  --- Compute the total work load for each slab
c      and for each i-column in the slab. ---
c
         slabspeed = 0.
         workslab = 0.
         do i = 1,nxp
            workcol(i) = 0.
            do j = jrow(islab),jrow(islab)+jrows(islab)-1
               workcol(i) = workcol(i) + work(i,j)
            enddo
            workslab = workslab + workcol(i)
         enddo
         workcol(2) = workcol(2) + workcol(1)
         workcol(nxp-1) = workcol(nxp-1) + workcol(nxp)
c
c  --- Determine average workload for each block. ---
c
         do iblock = 1,nblocks(islab)
            jnode = jnode + 1
            slabspeed = slabspeed + relspeed(jnode)
         enddo
         do iblock = 1,nblocks(islab)
            knode = knode + 1
            workblock(iblock) = workslab * relspeed(knode) / slabspeed
         enddo
c
c  --- Assign the i-columns of each slab to their respective blocks in
c      a way that balances the work load among the blocks.  The array
c      ncols counts the number of i-columns on each node, and the array
c      ncol is the index of the westernmost i-column on each node. ---
c
         workaccum = 0.
         worksofar = 0.
         iblock = 0
c
         do i = 2,nxp-1,nest_factor
            do ii=0,nest_factor-1
               workaccum = workaccum + workcol(i+ii)
            enddo
            if (workaccum - .5 * workcol(i+ii) .gt. worksofar .and.
     &                                         iblock .lt. nblocks(islab)) then
               iblock = iblock + 1
c
c  --- defining node variables here ---
c
               inode = inode + 1
               iyb(inode) = jrow(islab)
               ixb(inode) = i
               iye(inode) = iyb(inode) + jrows(islab) - 1
               worksofar = worksofar + workblock(iblock)
            endif
            ixe(inode) = ixe(inode) + nest_factor
         enddo
      enddo
c
c  --- defining node variable here ---
c
      do jnode = 1,nodes
         ixe(jnode) = ixb(jnode) + ixe(jnode) - 1
      enddo
c
c  --- Check to make sure that each subdomain has at least 2 interior
c      rows and columns. ---
c
      do jnode = 1,nodes
         if (iye(jnode) - iyb(jnode) .lt. 1 .or. 
     &                                     ixe(jnode) - ixb(jnode) .lt. 1) then
           write(*,*) 'grid:',nxp,nyp,
     &                '  subdomain too small on node ',jnode
           write(*,*) '(ixb,ixe,iyb,iye) = ',
     &                ixb(jnode),ixe(jnode),iyb(jnode),iye(jnode)
            stop 'small_nodes'
         endif
      enddo
c                                                                           
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine par_decomp:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine PAR_est_time:
c-----------------------------------------------------------------------
c
c    Called by:
c       DOMAIN_DECOMP
c
      subroutine PAR_est_time(nxp,nyp,isnest,work,cput,init)
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: nxp
      integer :: nyp
      integer :: isnest(nxp,nyp)
c
      real    :: work(nxp,nyp)
      real    :: cput(nxp,nyp)
c
      integer :: init
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: i
      integer :: j
c
      real    :: bfact
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- Sample routine to fill work elements with values proportional
c      to the time required to perform model operations. ---
c
      if (init==1) then
         do j = 2,nyp-1
            do i = 2,nxp-1
               work(i,j) = 1.
            enddo
         enddo
      else
         do j = 2,nyp-1
            do i = 2,nxp-1
               work(i,j) = cput(i,j)
            enddo
         enddo
      endif
c
c  --- Fill real boundaries with .2 of interior points ---
c
      bfact=.2
      do j = 1,nyp
         work(1,j) = bfact * work(2,j)
         work(nxp,j) = bfact * work(nxp-1,j)
      enddo
      do i = 1,nxp
         work(i,1) = bfact * work(i,2)
         work(i,nyp) = bfact * work(i,nyp-1)
      enddo
c
c  --- If the cell is in a nest we don't as much work ---
c
      bfact=.2
      do i=2,nxp-1
         do j=2,nyp-1
            if (isnest(i,j) .gt. 0) then
               work(i,j) = bfact * work(i,j)
            endif
         enddo
      enddo
c
      return
      end
c
c-----------------------------------------------------------------------
c    END subroutine PAR_est_time:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    BEGIN subroutine PAR_node_paths:
c-----------------------------------------------------------------------
c
      subroutine PAR_node_paths(mxgrids,ngrids,nnxp,nnyp,
     &                          nxtnest,mxmachs,ibcflags,ipaths)
c
c-----------------------------------------------------------------------
c    Modules used:
c-----------------------------------------------------------------------
c
c    Called by:
c       DOMAIN_DECOMP
c
      use master_mod
c
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c     Output:  
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: mxgrids
      integer :: ngrids
      integer :: nnxp(*)
      integer :: nnyp(*)
      integer :: nxtnest(*)
      integer :: mxmachs
      integer :: ibcflags(mxmachs,*)
      integer :: ipaths(5,7,mxgrids,mxmachs,mxmachs)
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ngr
      integer :: isend_type
      integer :: idn
      integer :: isn
      integer :: i
      integer :: j
      integer :: info
      integer :: icm
      integer :: ibeg
      integer :: jbeg
      integer :: iend
      integer :: jend
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- Zero out ipaths array ---
c
      do ngr=1,ngrids
         do isend_type = 1,6
            do idn=1,nmachines
               do isn = 1,nmachines
                  iget_paths_master(isend_type,ngr,isn,idn) = 0
                  do info = 1,5
                     ipaths(info,isend_type,ngr,idn,isn) = 0
                  enddo
               enddo
            enddo
         enddo
      enddo
      do ngr=1,ngrids
         icm = nxtnest(ngr)
         do idn=1,nmachines
            do isn = 1,nmachines
               if (isn .eq. idn) go to 6
c
c  --- Long timestep overlap regions ---
c               
               if (nxbeg(idn,ngr) .gt. ixe(isn,ngr) .or. 
     &                     nybeg(idn,ngr) .gt. iye(isn,ngr) .or. 
     &                             nxend(idn,ngr) .lt. ixb(isn,ngr) .or. 
     &                                nyend(idn,ngr) .lt. iyb(isn,ngr)) go to 6
               iget_paths_master(1,ngr,isn,idn) = machnum(isn)
               ipaths(1,1,ngr,idn,isn)=max(ixb(isn,ngr),nxbeg(idn,ngr))
               ipaths(2,1,ngr,idn,isn)=min(ixe(isn,ngr),nxend(idn,ngr))
               ipaths(3,1,ngr,idn,isn)=max(iyb(isn,ngr),nybeg(idn,ngr))
               ipaths(4,1,ngr,idn,isn)=min(iye(isn,ngr),nyend(idn,ngr))
               ipaths(5,1,ngr,idn,isn)=machnum(idn)
c
c  --- Expand ipaths to include [coarse] grid external boundary points. ---
c
               if (ipaths(1,1,ngr,idn,isn) .eq. 2)
     &                                      ipaths(1,1,ngr,idn,isn) = 1
               if (ipaths(2,1,ngr,idn,isn) .eq. nnxp(ngr)-1)
     &                                      ipaths(2,1,ngr,idn,isn) = nnxp(ngr)
               if (ipaths(3,1,ngr,idn,isn) .eq. 2)
     &                                      ipaths(3,1,ngr,idn,isn) = 1
               if (ipaths(4,1,ngr,idn,isn) .eq. nnyp(ngr)-1)
     &                                      ipaths(4,1,ngr,idn,isn) = nnyp(ngr)
    6 continue
c
c  --- Coarse grid to fine grid interpolation communication ---
c
               if (icm == 0) goto 16
               if (ipm(ixb(idn,ngr)-1,ngr)-2 .gt. ixe(isn,icm).or.  
     &               jpm(iyb(idn,ngr)-1,ngr)-2 .gt. iye(isn,icm).or.  
     &                  ipm(ixe(idn,ngr)+1,ngr)+1 .lt. ixb(isn,icm).or.  
     &                    jpm(iye(idn,ngr)+1,ngr)+1 .lt. iyb(isn,icm)) go to 16
               iget_paths_master(5,ngr,isn,idn) = machnum(isn)
               ipaths(1,5,ngr,idn,isn) = max(ixb(isn,icm),  
     &                                            ipm(ixb(idn,ngr)-1,ngr)-2)
               ipaths(2,5,ngr,idn,isn) = min(ixe(isn,icm),
     &                                            ipm(ixe(idn,ngr)+1,ngr)+1)
               ipaths(3,5,ngr,idn,isn) = max(iyb(isn,icm),
     &                                            jpm(iyb(idn,ngr)-1,ngr)-2)
               ipaths(4,5,ngr,idn,isn) = min(iye(isn,icm),
     &                                            jpm(iye(idn,ngr)+1,ngr)+1)
               ipaths(5,5,ngr,idn,isn) = machnum(idn)
   16 continue
c
               if (icm .GT. 0) then
                  ibeg = nxbegc(idn,icm)+ixoff(idn,icm)
                  jbeg = nybegc(idn,icm)+iyoff(idn,icm)
                  iend = nxendc(idn,icm)+ixoff(idn,icm)
                  jend = nyendc(idn,icm)+iyoff(idn,icm)
                  if (ibeg .gt. ipm(ixe(isn,ngr)+1,ngr).or.  
     &                  jbeg .gt. jpm(iye(isn,ngr)+1,ngr).or.  
     &                    iend .lt. ipm(ixb(isn,ngr)-1,ngr).or.  
     &                      jend .lt. jpm(iyb(isn,ngr)-1,ngr)) go to 26
                  iget_paths_master(6,ngr,isn,idn) = machnum(isn)
                  ipaths(1,6,ngr,idn,isn) = max(ipm(ixb(isn,ngr),ngr),
     &                                                        nxbeg(idn,icm)+1)
                  ipaths(2,6,ngr,idn,isn) = min(ipm(ixe(isn,ngr),ngr),
     &                                                        nxend(idn,icm)-1)
                  ipaths(3,6,ngr,idn,isn) = max(jpm(iyb(isn,ngr),ngr),
     &                                                        nybeg(idn,icm)+1)
                  ipaths(4,6,ngr,idn,isn) = min(jpm(iye(isn,ngr),ngr),
     &                                                        nyend(idn,icm)-1)
                  ipaths(5,6,ngr,idn,isn) = machnum(idn)
               else
                  iget_paths_master(6,ngr,isn,idn) = machnum(isn)
                  ipaths(1,6,ngr,idn,isn) = ipm(ixb(isn,ngr),ngr) 
                  ipaths(2,6,ngr,idn,isn) = ipm(ixe(isn,ngr),ngr)  
                  ipaths(3,6,ngr,idn,isn) = jpm(iyb(isn,ngr),ngr)  
                  ipaths(4,6,ngr,idn,isn) = jpm(iye(isn,ngr),ngr)  
                  ipaths(5,6,ngr,idn,isn) = machnum(idn)
               endif
c
               do i = ixb(isn,ngr),ixe(isn,ngr)
                  if (ipm(i,ngr) .eq. ipaths(1,6,ngr,idn,isn)) then
                     ipaths(1,7,ngr,idn,isn) = i
                     go to 21
                  endif
               enddo
   21 continue
c
               do i = ixe(isn,ngr),ixb(isn,ngr),-1
                  if (ipm(i,ngr) .eq. ipaths(2,6,ngr,idn,isn)) then
                     ipaths(2,7,ngr,idn,isn) = i
                     go to 22
                  endif
               enddo
   22 continue
c
               do j = iyb(isn,ngr),iye(isn,ngr)
                  if (jpm(j,ngr) .eq. ipaths(3,6,ngr,idn,isn)) then
                     ipaths(3,7,ngr,idn,isn) = j
                     go to 23
                  endif
               enddo
   23 continue
c
               do j = iye(isn,ngr),iyb(isn,ngr),-1
                  if (jpm(j,ngr) .eq. ipaths(4,6,ngr,idn,isn)) then
                     ipaths(4,7,ngr,idn,isn) = j
                     go to 24
                  endif
               enddo
   24 continue
c
   26 continue
            enddo
         enddo
      enddo
c
      return
      end

      subroutine ncf_sumgrps(numcols,numrows,nspmod,nsptrac,ndlast,ttlast,
     &                      emstot,emslft,emsbas,emsoth,emssum,lemit)
      use filunit
      use grid
      use chmstry
      use ptemiss
      use tracer
      implicit none
c
c      Copyright Ramboll
c
c
c----CAMx v7.40 260801
c
c     
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c    01/15/21  --gwilson-- Fixed bug in reading/accessing 3D files
c     
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'flags.inc'
      include 'soap.inc'
      include 'soap3.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_get_tstep
c
c-----------------------------------------------------------------------
c    Argument Declarations:
c-----------------------------------------------------------------------
c
      integer numcols
      integer numrows
      integer nspmod
      integer nsptrac
      integer ndlast
      real    ttlast
      real*8  emstot(numcols,numrows,nspmod)
      real*8  emslft(numcols,numrows,nspmod)
      real    emsbas(nspmod,nsptrac)
      real    emsoth(nspmod,nsptrac)
      real    emssum(nspmod,nsptrac)
      logical lemit(*)
c
c-----------------------------------------------------------------------
c    Local Variables:
c-----------------------------------------------------------------------
c
      character*200 fname, action
      character*10  this_var
      integer       this_date, iounit, igroup, this_tstep, isoa
      integer       iseg, idum, ispc, i, j, k, itmp, jtmp
      integer       igrid, idxfile, ierr, nlays_in, this_varid
      integer       this_time_tflag, this_time_etflag, buffer_offset
      integer       this_dimid, numpts, num_emsfiles, num_ptsfiles
      integer       data_start2(2), data_count2(2)
      integer       data_start4(4), data_count4(4)
      real          this_time
      logical       lpass, in_simulation
c
      real,    allocatable, dimension(:,:,:) ::  emstmp
      real,    allocatable, dimension(:,:,:) ::  emsgrd
      real,    allocatable, dimension(:)     ::  emspnt
      integer, allocatable, dimension(:)     ::  sa_region
      integer, allocatable, dimension(:)     ::  idcompact
      integer, allocatable, dimension(:)     ::  izcel
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over all of the groups ----
c
      do 20 igroup=0,ngroup
c
c   --- only process if filename is supplied for group ---
c
         do 25 igrid=1,ngrid
            num_emsfiles = num_iortem(igrid,igroup)
            if( igroup .EQ. 0 ) num_emsfiles = nemiss_files(igrid)
            do 26 idxfile=1,num_emsfiles
              if( .NOT. larsrc) goto 26
c
c   --- set the unit number for surface emissions file ---
c
              lpass = .FALSE.
              if( igroup .EQ. 0 ) then
                  if( .NOT. is_netcdf_iarem(igrid,idxfile) ) goto 26
                  iounit = iarem(igrid,idxfile)
                  write(fname,'(A,I8)') 'EMISSIONS -- UNIT ',
     &                                                iarem(igrid,idxfile)
                  write(action,'(2A,I3,A,I3)') 'Reading the NetCDF ',
     &                              'gridded emissions file. Grid: ',
     &                                           igrid,' File: ',idxfile
                  buffer_offset = buffer_offset_iarem(igrid,idxfile)
              else
                  if( .NOT. is_netcdf_iortem(igrid,igroup,idxfile) ) goto 26
                  iounit = iortem(igrid,igroup,idxfile)
                  fname = temfil(igrid,igroup,idxfile)
                  write(action,'(2A,I3,A,I3,A,I3)') 'Reading the SA NetCDF ',
     &                     'gridded emissions file. Grid: ',igrid,
     &                                    ' Group: ',igroup,' File: ',idxfile
                  buffer_offset = buffer_offset_iortem(igrid,igroup,idxfile)
              endif
c
c   ---- get the number of layers in this file ---
c
              this_var = 'NLAYS'
              ierr = nf_get_att_int(iounit, NF_GLOBAL, 'NLAYS', nlays_in)
              if( ierr .NE. NF_NOERR ) goto 7000
c
c  ---- allocate the temporary array ---
c
              allocate( emstmp(ncol(igrid)-2*buffer_offset,nrow(igrid)-2*buffer_offset,nlays_in) )
              allocate( emsgrd(ncol(igrid),nrow(igrid),nlays_in) )
c
c   --- if number of layers is not 1 make sure it matches grid ---
c
              if( nlays_in .NE. 1 .AND. 
     &                            nlays_in .NE. nlay(igrid) ) goto 7001
c
c   --- set the indexes for what to read ---
c
              data_start4(1) = 1
              data_count4(1) = ncol(igrid)-2*buffer_offset
              data_start4(2) = 1
              data_count4(2) = nrow(igrid)-2*buffer_offset
              data_start4(3) = 1
              data_count4(3) = nlays_in
c
c   --- loop over time in this simulation ---
c
              this_date = date
              this_time = time
              in_simulation = .TRUE.
              do while( in_simulation ) 
c
c  ---- get the index for timestep containing this time ----
c
                 this_tstep = ncf_get_tstep(iounit,action,
     &              this_date,this_time,this_time_tflag,this_time_etflag,
     &                                                         le1day,.TRUE.)
                 data_start4(4) = this_tstep
                 data_count4(4) = 1
c
c  ---- loop over the list of emissions spcies ---
c
                 do ispc=1,nspmod
                     if( ispc .LE. nspec ) then
                       this_var = spname(ispc)
                       do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                         if( this_var .EQ. soap_emiss_names(isoa) ) 
     &                               this_var = soap_emiss_names(isoa)
                       enddo
                     else
                       this_var = soap_emiss_names(ispc-nspec-1+IDX_SOAP_POA_OP)
                     endif
                     ierr = nf_inq_varid(iounit, this_var, this_varid)
                     if( ierr .NE. NF_NOERR) cycle
                     ierr = nf_get_vara_real(iounit,this_varid,data_start4,
     &                                               data_count4,emstmp)
                     if( ierr .NE. NF_NOERR) goto 7003
c
                     do k=1,nlays_in
                        do j=1+buffer_offset,nrow(igrid)-buffer_offset
                            jtmp = j-buffer_offset
                            do i=1+buffer_offset,ncol(igrid)-buffer_offset
                              itmp = i-buffer_offset
                              emsgrd(i,j,k) = emstmp(itmp,jtmp,k)
                           enddo
                        enddo
                     enddo
                     call sum1grd(numcols,numrows,ncol(igrid),nrow(igrid),nlays_in,
     &                             nspec,nspmod,nsptrac,igroup,igrid,ispc,this_var,
     &                               emssum,emsgrd,emsbas,emsoth,emslft,emstot,lemit)
                 enddo
c
c  --- update time and check if still in simulation ---
c
                 this_time = this_time/100.
                 call uptime(this_time,this_date,dtems)
                 if(this_time .GE. 24.) then
                   this_time  = this_time - 24.
                   this_date = this_date + 1
                   if( MOD(this_date,1000) .GT. 365 ) then
                      if( MOD(INT(this_date/1000),4) .EQ. 0 ) then
                         if( MOD(this_date,1000) .EQ. 367 )
     &                           this_date = (INT(this_date/1000)+1)*1000 + 1
                      else
                         this_date = (INT(this_date/1000)+1)*1000 + 1
                      endif
                   endif
                 endif
                 if( this_date .GT. ndlast ) in_simulation = .FALSE.
                 if( this_date .EQ. ndlast .AND. this_time .GE. ttlast ) 
     &                                           in_simulation = .FALSE.
                 this_time = this_time*100.
            enddo   !--- end while
c
            deallocate( emsgrd )
            deallocate( emstmp )
c
   26       continue 
   25    continue 
c
c   --- only process if filename is supplied for group ---
c
         num_ptsfiles = num_iortpt(igroup)
         if( igroup .EQ. 0 ) num_ptsfiles = npoint_files
         do idxfile=1,num_ptsfiles
            if( .NOT. ltptfl(igroup,idxfile) .OR. .NOT. lptsrc ) cycle
c
c   --- set the unit number for elevated points emissions file ---
c
            lpass = .FALSE.
            if( igroup .EQ. 0 ) then
                if( .NOT. is_netcdf_iptem(idxfile) ) cycle
                iounit = iptem(idxfile)
                write(fname,'(A,I8)') 'PTSOURCE -- UNIT ',iptem(idxfile)
            else
                if( .NOT. is_netcdf_iortpt(igroup,idxfile) ) cycle
                iounit = iortpt(igroup,idxfile)
                fname = tptfil(igroup,idxfile)
            endif
c
c --- get the number of points (used as dimension for columns) ---
c
            ierr = nf_inq_dimid(iounit, "COL", this_dimid )
            if( ierr .NE. NF_NOERR ) goto 7002
            ierr = nf_inq_dimlen(iounit,this_dimid,numpts)
            if( ierr .NE. NF_NOERR ) goto 7002
c
c ---- allocate array for emissions ----
c
            allocate( emspnt(numpts) )
            allocate( sa_region(numpts) )
            allocate( idcompact(numpts) )
            allocate( izcel(numpts) )
            izcel = 0
            do i=1,numpts
               idcompact(i) = i
            enddo
c
c  --- get the region override for the sources ---
c
            this_var = "saoverride"
            ierr = nf_inq_varid(iounit,this_var,this_varid)
            if( ierr .NE. NF_NOERR ) goto 7004
            ierr = nf_get_var_int(iounit,this_varid,sa_region)
            if( ierr .NE. NF_NOERR ) goto 7003
            izcel = 0
            do i=1,numpts
              if( sa_region(i) .GT. 0 ) izcel(i) = -sa_region(i)
            enddo
c
c   --- loop over time in this simulation ---
c
            this_date = date
            this_time = time
            in_simulation = .TRUE.
            do while( in_simulation )
c
c  ---- get the index for timestep containing this time ----
c
               this_tstep = ncf_get_tstep(iounit,action,
     &              this_date,this_time,this_time_tflag,this_time_etflag,
     &                                                       le1day,.TRUE.)
               data_start2(1) = 1
               data_count2(1) = numpts
               data_start2(2) = this_tstep
               data_count2(2) = 1
c
c  ---- loop over the list of emissions species ---
c
               do ispc=1,nspmod
                 if( ispc .LE. nspec ) then
                     this_var = spname(ispc)
                     do isoa=IDX_SOAP_POA_OP,IDX_SOAP_POA_BB
                       if( this_var .EQ. soap_emiss_names(isoa) ) 
     &                               this_var = soap_emiss_names(isoa)
                     enddo
                 else
                     this_var = soap_emiss_names(ispc-nspec-1+IDX_SOAP_POA_OP)
                 endif
                 ierr = nf_inq_varid(iounit, this_var, this_varid)
                 if( ierr .NE. NF_NOERR) cycle
                 ierr = nf_get_vara_real(iounit,this_varid,data_start2,
     &                                               data_count2,emspnt)
                 call sum1pnt(numcols,numrows,nspec,nspmod,nsptrac,igroup,idxfile,
     &                  ispc,this_var,nptsrc,emsbas,emsoth,emslft,emstot,emspnt,
     &                                       emssum,izcel,idcompact,lemit)
               enddo
c
c  --- update time and check if still in simulation ---
c
               this_time = this_time/100.
               call uptime(this_time,this_date,dtems)
               if(this_time .GE. 24.) then
                 this_time  = this_time - 24.
                 this_date = this_date + 1
                 if( MOD(this_date,1000) .GT. 365 ) then
                    if( MOD(INT(this_date/1000),4) .EQ. 0 ) then
                       if( MOD(this_date,1000) .EQ. 367 )
     &                           this_date = (INT(this_date/1000)+1)*1000 + 1
                    else
                       this_date = (INT(this_date/1000)+1)*1000 + 1
                    endif
                 endif
               endif
               if( this_date .GT. ndlast ) in_simulation = .FALSE.
               if( this_date .EQ. ndlast .AND. this_time .GE. ttlast )
     &                                           in_simulation = .FALSE.
               this_time = this_time*100.
            enddo   !--- end while
c
c  --- deallocate local arrays ---
c
            deallocate( emspnt )
            deallocate( sa_region )
            deallocate( idcompact )
            deallocate( izcel )
c
c  --- next file ---
c
         enddo
c
c  --- get the next group ---
c
  20  continue
      return
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_SUMGRPS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_SUMGRPS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Number of layers does not match: '
      write(iout,'(A,I4)') 'User supplied: ',nlays_in
      write(iout,'(A,I4)') 'Value in file: ',nlay(igrid)
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_SUMGRPS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (COL)'
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in NCF_SUMGRPS:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7004 continue
      write(*,'(//,a)') 'ERROR in NCF_SUMGRPS:'
      write(*,'(A)') action(:istrln(action))
      write(*,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
      end

      subroutine edge_pass(nodeedge,iarray,nbytes,mpi_type,itag,
     &                                             numprocs,iproc_id)
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c        This routine will do the actual passing of data from node zero
c        to the process nodes.  The array in the argument list will be
c        passed, using the number of bytes and the type specified.
c        This version is used for sending edge cell boundary conditions
c        and so only passes when the slice has edge cells.
c-----------------------------------------------------------------------
c
c    Argument descriptions:
c     Input:  
c        nodeedge            true if slice has any edge cells
c        iarray              array containing the data - scalar 
c                            variables are of length 1
c        nbytes              the number of bytes to pass
c        mpi_type            the MPI code for the variable type
c        itag                the tag ID for this transfer
c        numprocs            the number of processes
c        iproc_id            the process ID for this processor
c     Output:  
c
c    Called by:
c       BNDRY_UPDT
c    Subroutines called:
c       MPI_SEND
c       MPI_RECV
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'mpif.h'
c     
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer :: nbytes
      integer :: mpi_type
      integer :: itag
      integer :: numprocs
      integer :: iproc_id
c
      logical :: nodeedge(numprocs)
      real    :: iarray(nbytes)
c
c     
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer :: ierr
      integer :: i
      integer :: status(MPI_STATUS_SIZE)
c     
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
      if (.NOT. lmpi .AND. iproc_id .GT. 0) return
c
c  --- process ID zero sends all of the messages,
c      to all of the other processes ---
c
      if (iproc_id .EQ. 0) then
         do i=1,numprocs 
            if( nodeedge(i) ) then
                 call MPI_SEND(iarray,nbytes,mpi_type,i,itag,
     &                                            MPI_COMM_WORLD,ierr)
            endif
         enddo
c
c  --- if this is a compute process, allocate the data structures
c      and wait for the data to arrive ---
c
      else
         if( nodeedge(iproc_id) ) then
              call MPI_RECV(iarray,nbytes,mpi_type,0,itag,
     &                                    MPI_COMM_WORLD,status,ierr)
          endif
      endif
      itag = itag + 1
c
      end

c*** CHEMRT
c
      subroutine chemrt(numcol,numrow,numlay,igrid,icell,jcell,kcell, 
     &                  i0,j0,pcell,tcell,cold,cnew,oh,o3,no3,dtime,
     &                  irt_cel)
      use chmstry
      use camxcom
      use grid
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c   Description:
c     This routine performs chemistry adjustments on the reactive
c     tracer gasses using information from the host chemistry solution.  
c
c      Copyright Ramboll
c
c   Argument descriptions:
c     Inputs:
c       numcol  I number of columns in this slice
c       numrow  I number of rows in this slice
c       numlay  I number of layers in this slice
c       igrid   I  number of the grid containing the cell
c       icell   I  X index of the cell
c       jcell   I  Y index of the cell
c       kcell   I  Z index of the cell
c       pcell   R  cell pressure (mb)
c       tcell   R  cell temperature (K)
c       cold    R  species concentrations before host chemistry (umol/m3)
c       cnew    R  species concentrations after host chemistry (umol/m3)
c       oh      R  OH radical concentration (ppm)
c       o3      R  ozone concentration (ppm)
c       no3     R  no3 radical concentration (ppm)
c       dtime   R  time step (hours)
c       irt_cel I  index for RTRAC receptor cells
c
c-----------------------------------------------------------------------
c   LOG:
c-----------------------------------------------------------------------
c
c     01/16/02   --gwilson--    Original development
c     11/12/03   --cemery--     Added secondary RTRAC species to primary
c                               RTRAC species
c     09/22/08   --gyarwood--   Delete CONVFAC from calculation of RTRAC
c                               species secondary to a regular species
c     11/06/12   --gwilson--    Fixed receptors for MPI
c     04/05/21   --cemery--     Input reaction rates are molecular units
c                               and converted to ppm units here
c
c-----------------------------------------------------------------------
c   Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      integer numcol
      integer numrow
      integer numlay
      integer igrid
      integer icell
      integer jcell
      integer kcell
      real    pcell
      real    tcell
      real    cold(*)
      real    cnew(*)
      real    oh
      real    o3
      real    no3
      real    dtime
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      integer   i
      integer*8 idx
      integer*8 idxcel
      real      factor
      real      prod
      real      rkoh
      real      rko3
      real      rkno3
      real      rkspc
c
      real drate(MXTRSP)
      real rtnew(MXTRSP)
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c --- calculate the index of the cell in the grid ---
c
      idxcel = DBLE(ipsa3d(igrid)-1) + DBLE(icell) + DBLE(numcol) * 
     &          DBLE(jcell-1) + DBLE(numcol) * DBLE(numrow) * DBLE(kcell-1)
      do i=1,nrtrac
         idx = idxcel + DBLE(numcol) * DBLE(numrow) *
     &                                      DBLE(numlay) * DBLE(i-1)
         ptconc(idx) = max(ptconc(idx),rtlbnd(i))
      enddo
c
c --- factor is a temp/press adjustment for second order
c     rate constants that convert from cm3 molec-1 sec-1 to
c     ppm-1 min-1, also convert to per hour ---
c
      factor = 60.*pcell*100./(8.314*tcell)*6.022E+23/1.0E12 * 60.
c
c --- calculate the total decay rate and any secondary production
c     rate for each tracer.  get host photolysis rates from rk in the
c     chmstry.inc include file ---
c
      do i=1,nrtgas
         if( jnum(i) .GT. 0 ) then
            rkspc = rk(jnum(i))
         else
            rkspc = 0.0
         endif 
         rkoh  = arrhen(aoh(i),eaoh(i),boh(i),troh(i),tcell) * factor
         rko3  = arrhen(ao3(i),eao3(i),bo3(i),tro3(i),tcell) * factor
         rkno3 = arrhen(ano3(i),eano3(i),bno3(i),trno3(i),tcell)
     &           * factor
         drate(i) = oh*rkoh + o3*rko3 + no3*rkno3 + rkspc*rtjfact(i)
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                      DBLE(numlay) * DBLE(i-1)
         rtnew(i) = ptconc(idx)*EXP(-drate(i)*dtime)
         rtnew(i) = MAX(rtlbnd(i),rtnew(i))
         prod = 0.0
         if( lsecnd(i) )then
            if( lreg(i) ) then
               prod = cnew(ksec(i)) - cold(ksec(i))*EXP(-drate(i)*dtime)
               prod = MAX(prod,0.0)
            else
               idk = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                              DBLE(numlay) * DBLE(ksec(i)-1)
               prod = AMAX1(ptconc(idk) - rtnew(ksec(i)),0.0)
            endif
         endif
         rtnew(i) = rtnew(i) + prod
      enddo
c
      do i = 1,nrtgas
         idx = idxcel + DBLE(numcol) * DBLE(numrow) * 
     &                                DBLE(numlay) * DBLE(i-1)
         ptconc(idx) = rtnew(i)
      enddo
c
c --- if this is a receptor cell, accumulate average decay rates
c
      if( lrcpfil .AND. irt_cel .GT. 0 ) then 
         do i=1,nrtgas
            rcpdcy(irt_cel, i) = rcpdcy(irt_cel,i) + 
     &                              drate(i)*dtime/(dtout/60.)
         enddo
      endif
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
      return
      end
c
      function arrhen(a,ea,b,tref,temp)
c
c --- Calculate a rate constant using k = A*(T/Tref)^B*exp(-Ea/T)
c
      real arrhen
c
      arrhen = a
      if( tref .NE. 0. ) arrhen = a*((temp/tref)**b)*exp(-ea/temp)
c
      end

      subroutine drydep(m1,m2,m3,itzon,
     &                  tsurf,cellat,cellon,lrdlai,lai,
     &                  pwc,cwc,height,press,windu,windv,cod,
     &                  water,fsurf,tempk,snow,icdocn,conc,vdep,eflxnh3)
      use filunit
      use chmstry
      use bndary
      use camxcom
c
      implicit none

c
c----CAMx v7.40 260801
c 
c     DRYDEP is the driver for the calculation of gridded dry deposition 
c     velocities for a given grid. Deposition velocities are calculated for
c     each gas species and for each aerosol size bin, weighted by the
c     fractional land use specified for each cell.
c 
c      Copyright Ramboll
c           
c     Modifications:
c        4/4/00    Added aerosol deposition as f(size)
c        4/4/01    Fixed a few bugs in the call for VD_AER
c        1/9/02    Aerosol size and density now species-dependent
c        3/26/03   Added scaling factor to surface resistance (provided
c                  on chemparam file), and zero dry deposition for 
c                  insoluble gases
c        4/9/03    Removed rain, added precip and cloud water contents:
c                  surfaces can now be rain-wetted, fog-wetted, or dew-wetted
c        6/6/03    Protect against divide by zero with totland
c        6/11/03   Use optional surface roughness length, if available
c        7/21/03   Use optional drought stress and snow cover, if available;
c                  Introduced latitude-dependent specification of season;
c                  Revised solar flux calculation to use RADM cloud adjustment
c        8/18/03   Relate drought stress to Palmer Drought Index
c        4/21/04   Incorporated sectional PM
c        11/19/04  Incorporated season-dependent roughness length
c        05/11/09  Now checks that chemistry is on before accessing the
c                  kph2o pointer.
c        8/10/09   Added the Zhang et al (2003) dry deposition option
c        02/11/11  Removed optional roughness from AHO
c        04/02/12  Removed drought stress and snow flag; AHO
c                  file is now just ozone column
c        04/17/12  Special handling of Hg dep to ocean surface
c        08/11/14  Snow cover changed to water equivalent depth
c        12/07/14  Modified for VBS
c        07/23/18  Updated for Bi-Di NH3 drydep
c
c     Input arguments:
c        itzon               time zone
c        tsurf               surface temperature field (K)
c        cellat              cell centroid latitude (deg)
c        cellon              cell centroid longitude (deg)
c        lrdlai              flag that LAI data were read
c        lai                 gridded LAI data from file
c        pwc                 precipitation water content (g/m3)
c        cwc                 cloud water content (g/m3)
c        height              layer interface height field (m)
c        press               layer pressure field (mb)
c        windu               layer U-component wind field (m/s)
c        windv               layer V-component wind field (m/s)
c        cod                 cloud optical depth field (unitless)
c        water               layer water vapor field (ppm)
c        fsurf               fractional landuse cover field (fraction)
c        tempk               layer temperature field (K)
c        snow                snow cover water equivalent (m)
c        icdocn              gridded ocean mask
c        conc                concentration field (umol/m3, ug/m3)
c             
c     Output arguments: 
c        vdep                species-dependent deposition velocity field (m/s)
c        eflxnh3             emiss flux of Bi-Di NH3 drydep (umol/m2-s)
c             
c     Routines called: 
c        CALDATE
c        GETZNTH
c        MICROMET
c        VD_GAS
c        VD_AER
c        HENRYFNC
c             
c     Called by: 
c        EMISTRNS 
c 
      include 'camx.prm'
      include 'deposit.inc'
      include 'camx_aero.inc'
      include 'flags.inc'
c
      integer :: itzon, idate, month, i, j, k, m, mbin, latbin, isesn
      real    :: zenith, deltaz, temp0, prss0, ucomp, vcomp, wind
      real    :: qwatr, ev, es, rh, dew, totland, z0, ustar, el
      real    :: psih, wstar, henso2, henry, vd, qtf, qtc, vtf, vtc
      real    :: diamc, vdf, roprta, diam, vdc, kwtr, pbl, zl
      real    :: qt, vt
      real    :: convfac, conc_nh3, fnet
      integer :: iwet, l, iflgso2, iflgo3, iflgnh3, isemptyf, isemptyc
      integer :: isec, iaero, isempty
      integer :: m1,m2,m3,iday,iyear
      real, dimension(m1,m2) :: tsurf, cellat, cellon, lai, snow
      integer, dimension(m1,m2) :: icdocn
      integer, dimension(12) :: nday
      real, dimension(m1,m2,m3) :: height
      real, dimension(m1,m2,m3) :: press, windu, windv, cod,
     &                             water, tempk, pwc, cwc
      real, dimension(m1,m2,NLU) :: fsurf
      real, dimension(m1,m2,nspec) :: vdep
      real, dimension(m1,m2,m3,nspec) :: conc
      real, dimension(m1,m2) :: eflxnh3
      real, parameter :: eflxnh3_fac(NLUZ03) = (/      ! flag to shut off Bi-Di NH3 re-emissions
     &                                            1.0, !  water
     &                                            1.0, !  ice
     &                                            1.0, !  inland lake
     &                                            1.0, !  evergreen needleleaf trees
     &                                            1.0, !  evergreen broadleaf trees
     &                                            1.0, !  deciduous needleleaf trees
     &                                            1.0, !  deciduous broadleaf trees
     &                                            1.0, !  tropical broadleaf trees
     &                                            1.0, !  drought deciduous trees
     &                                            1.0, !  evergreen broadleaf shrub
     &                                            1.0, !  deciduous shrubs
     &                                            1.0, !  thorn shrubs
     &                                            1.0, !  short grass and forbs
     &                                            1.0, !  long grass
     &                                            0.0, !  crops
     &                                            0.0, !  rice
     &                                            0.0, !  sugar
     &                                            0.0, !  maize
     &                                            0.0, !  cotton
     &                                            0.0, !  irrigated crops
     &                                            1.0, !  urban
     &                                            1.0, !  tundra
     &                                            1.0, !  swamp
     &                                            1.0, !  desert
     &                                            1.0, !  mixed wood forests
     &                                            1.0  !  transitional forest
     &                                          /)

      real lai_ref_intpl,rlai,ref_lai,lai_f,pi
      real tau,ctrns,fcld
      real*8 coszen,solflux
      logical lstable
      logical ldark,lrdlai
c
      data nday/31,28,31,30,31,30,31,31,30,31,30,31/
c
c-----Entry point
c
      pi = 3.1415927
      idate = date
      call caldate(idate)
      iyear = idate/10000
      month = (idate - 10000*iyear)/100
      if (mod(iyear,4).eq.0) nday(2)=29
      iday = idate - 100*(idate/100)
c
c-----Loop over rows and columns
c
c$omp parallel default(shared)
c$omp&  private(i,j,mbin,latbin,isesn,ref_lai,m,lai_ref_intpl,
c$omp&          rlai,zenith,ldark,coszen,tau,k,ctrns,fcld,
c$omp&          solflux,deltaz,temp0,prss0,
c$omp&          ucomp,vcomp,wind,qwatr,ev,es,rh,iwet,dew,
c$omp&          l,totland,z0,lai_f,ustar,el,psih,wstar,lstable,zl,
c$omp&          henso2,henry,iflgso2,iflgo3,iflgnh3,vd,isemptyf,isemptyc,qtf,
c$omp&          qtc,vtf,vtc,diamc,vdf,roprta,diam,vdc,kwtr,isec,qt,vt,
c$omp&          convfac,conc_nh3,fnet,
c$omp&          iaero,isempty)
c$omp do schedule(static)
c
      do 30 j = 2,m2-1 
        do 20 i = 2,m1-1
c
c-----Determine season
c
          mbin = month
          if (cellat(i,j).lt.0.) then
            mbin = mod(month+6,12)
            if (mbin.eq.0) mbin = 12
          endif
          latbin = 1
          if (abs(cellat(i,j)).gt.20.) then
            latbin = 2
          elseif (abs(cellat(i,j)).gt.35.) then
            latbin = 3
          elseif (abs(cellat(i,j)).gt.50.) then
            latbin = 4
          elseif (abs(cellat(i,j)).gt.75.) then
            latbin = 5
          endif
          if ((cellat(i,j).gt.50. .and. cellat(i,j).lt.75.) .and.
     &        (cellon(i,j).gt.-15. .and. cellon(i,j).lt.15.)) latbin = 3
          isesn = iseason(latbin,mbin)
c
c-----Use input snow cover to set season, if specified
c
          if (snow(i,j).ge.0.001) isesn = 4    ! Snow cover check > 1 cm
c
c-----Determine cell-average relative LAI
c
          if (lrdlai) then
            ref_lai = 0.
            do m = 1,NLU
              lai_ref_intpl = lai_ref(m,mbin) + 
     &                    float(min(nday(mbin),iday))/float(nday(mbin))*
     &                    (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              ref_lai = ref_lai + fsurf(i,j,m)*lai_ref_intpl
            enddo
            rlai = lai(i,j)/(ref_lai + 1.e-10)
          endif
c
c-----Calculate solar flux
c
          call getznth(cellat(i,j),cellon(i,j),time,date,itzon,
     &                 zenith,ldark)
          coszen = cos(DBLE(zenith)*DBLE(pi)/180.)
          tau = cod(i,j,m3)
          do k = m3-1,1,-1
            tau = tau + cod(i,j,k)
          enddo
          if (tau.lt.5.) then
            ctrns = 1.
            fcld  = 0.
          else
            ctrns = (5. - exp(-tau))/(4. + 0.42*tau)
            fcld  = 1.
          endif
          ctrns = 1.6*ctrns*coszen

          solflux = (990.*coszen - 30.)*
     &              (1. - fcld*(1. - ctrns))
          solflux = dmax1(DBLE(0.),solflux)
c
c-----Load local met variables
c
          deltaz = height(i,j,1)/2.
          temp0 = tsurf(i,j) - 273.15
          prss0 = press(i,j,1) - 2.*deltaz*(press(i,j,2) - 
     &                            press(i,j,1))/height(i,j,2)
          ucomp = (windu(i,j,1) + windu(i-1,j,1))/2.
          vcomp = (windv(i,j,1) + windv(i,j-1,1))/2.
          wind = sqrt(ucomp**2. + vcomp**2.)
          wind = amax1(0.1,wind)
c
c-----Determine surface wetness
c
          qwatr = 1.e-6*water(i,j,1)*18./28.8
          ev = qwatr*prss0/(qwatr + eps) 
          es = e0*exp((lv/rv)*(1./273. - 1./tsurf(i,j))) 
          rh = amin1(1.,ev/es)
          iwet = 0
          if (pwc(i,j,1).gt.cwmin) then
            iwet = 2
          elseif (cwc(i,j,1).gt.cwmin) then
            iwet = 1
          else
            dew = (1. - rh)*(wind + 0.6) 
            if (dew.lt.0.19) iwet = 1
          endif
c
c-----Loop over land use; surface roughness for water is dependent on
c     wind speed
c
          do l = 1,nspec
            vdep(i,j,l) = 0.
          enddo
          totland = 0.
          if (lbidinh3) then
            convfac = densfac*(273./tempk(i,j,1))*(press(i,j,1)/1013.)
            conc_nh3 = MAX( conc(i,j,1,knh3), bdnl(knh3)*convfac )*17.0 ! [ug/m3]
            eflxnh3(i,j) = 0.0
          endif
c
          do 10 m = 1,NLU
            if (fsurf(i,j,m).lt.0.01) goto 10
            totland = totland + fsurf(i,j,m)
c
c-----Set surface roughness for Wesely (1989) scheme
c
            if (idrydep.eq.1) then
              z0 = z0lu(m,isesn)
              if (m.eq.7) z0 = amax1(z0,2.0e-6*wind**2.5)
c
c-----Set surface roughness and LAI for Zhang (2003) scheme
c
            else
              lai_f = lai_ref(m,mbin) +
     &                float(min(nday(mbin),iday))/float(nday(mbin))*
     &                (lai_ref(m,mbin+1) - lai_ref(m,mbin))
              if (lrdlai) then
                lai_f = lai_f*rlai
                lai_f = amin1(lai_ref(m,15),lai_f)
                lai_f = amax1(lai_ref(m,14),lai_f)
              endif
              if (m.eq.1 .or. m.eq.3) then
                z0 = 2.0e-6*wind**2.5
              else 
                if (z02(m).gt.z01(m)) then
                  z0 = z01(m) + (lai_f - lai_ref(m,14))/
     &                          (lai_ref(m,15) - lai_ref(m,14))*
     &                          (z02(m) - z01(m))
                else
                  z0 = z01(m)
                endif
              endif
            endif
c
c-----Get surface layer micrometeorological parameters for this cell and
c     landuse type
c 
            call micromet(tempk(i,j,1),tsurf(i,j),press(i,j,1),prss0,
     &                    deltaz,wind,z0,pbl,ustar,el,psih,wstar,lstable)
            zl = deltaz/el
            if (zl.lt.0.) then
              zl = min(-5.,zl)
            else
              zl = max(5.,zl)
            endif 
c
c-----Loop over GAS species, and calculate deposition velocity for this cell,
c     landuse, and current species.
c     Use input drought stress code, if specified
c
            call henryfnc(0,henso20,tfactso2,tsurf(i,j),7.,1,1,1,henso2)
            do 40 l = nrad+1,ngas
              if (henry0(l).gt.1.e-6) then
                call henryfnc(l,henry0(l),tfact(l),tsurf(i,j),7.,knh3,
     &                        khno3,kso2,henry)
                iflgso2 = 0
                iflgo3 = 0
                iflgnh3 = 0
                if (l.eq.kso2) then
                  iflgso2 = 1
                  henry = henso2
                endif
                if (l.eq.ko3) iflgo3 = 1
                if (lbidinh3 .and. l.eq.knh3) iflgnh3 = 1
                if (idrydep .eq. 1) then   ! Use Wesely (1989) algorithm
                  call vd_gas(m,0,iwet,iflgso2,iflgo3,z0,
     &                     deltaz,psih,ustar,diffrat(l),henry,henso2,
     &                     f0(l),rscale(l),temp0,dstress(0),solflux,
     &                     rj(m,isesn),rlu(m,isesn),rac(m,isesn),
     &                     rlcs(m,isesn),rlco(m,isesn),rgss(m,isesn),
     &                     rgso(m,isesn),icdocn(i,j),vd)
                elseif (idrydep .eq. 2) then ! Use Zhang (2003) algorithm
                  call vd_gas_zhang(deltaz,zl,z0,ustar,tempk(i,j,1),
     &                   tsurf(i,j),solflux,rh,fcld,
     &                   pwc(i,j,1),coszen,m,snow(i,j),iflgo3,iflgnh3,conc_nh3,
     &                   henry,henso2,f0(l),diffrat(l),rscale(l),lai_f,vd,fnet)
                  if (iflgnh3.eq.1)                          ! [umol/m2-s]
     &              eflxnh3(i,j) = eflxnh3(i,j) + (fnet/17.0)*fsurf(i,j,m)
                endif
              else
                vd = 0.
              endif
              if (spname(l).eq.'HG0       ' .AND. icdocn(i,j).eq.1 .AND.
     &            ((idrydep.eq.1 .and. m.eq.7) .OR.
     &             (idrydep.eq.2 .and. m.eq.1)))
     &          vd = 0.
              vdep(i,j,l) = vdep(i,j,l) + vd*fsurf(i,j,m)
 40         continue
c
c-----Loop over AEROSOL size bins, and calculate deposition velocity for
c     this cell and landuse
c
            if (naero .gt. 0) then
c
c-----Recalculate particle size for wet diameter
c
c
c-----CF 2-bin scheme
c
              if (lchem .AND. aeropt.eq.'CF') then
                isemptyf = 1
                isemptyc = 1
                qtf = 0. ! fine dry total mass
                qtc = 0. ! coarse dry total mass
                vtf = 0. ! fine dry total volume
                vtc = 0. ! coarse dry total volume
                do l = ngas+1,nspec
                  if (dcut(l,2).lt.(dcut(kph2o,2)+1.e-5)) then     !fine
                    if (l.ne.kph2o) then
                      if (conc(i,j,1,l).gt.bdnl(l)) isemptyf = 0
                      qtf = qtf + conc(i,j,1,l)
                      vtf = vtf + conc(i,j,1,l)/roprt(l)
                    endif
                  else                                             !coarse
                    if (conc(i,j,1,l).gt.bdnl(l)) isemptyc = 0
                    qtc = qtc + conc(i,j,1,l)
                    vtc = vtc + conc(i,j,1,l)/roprt(l)
                    diamc = sqrt(dcut(l,1)*dcut(l,2))
                  endif
                enddo
                vdf = 0.
                if (isemptyf.eq.0) then
                  roprta = (qtf + conc(i,j,1,kph2o)) / 
     &                     (vtf + conc(i,j,1,kph2o)/roprt(kph2o))
                  diam = sqrt(dcut(kph2o,1)*dcut(kph2o,2))
                  diam = 1.e-6*diam*(1. + 
     &                   conc(i,j,1,kph2o)/roprt(kph2o)/vtf)**0.33333
                  if (idrydep.eq.1) then     ! Use Wesely (1989) algorithm
                    call vd_aer(z0,deltaz,psih,ustar,diam,roprta,
     &                        tsurf(i,j),vdf)
                  elseif (idrydep.eq.2) then ! Use Zhang (2001) algorithm
                     call vd_aer_zhang(deltaz,zl,z0,ustar,diam,roprta,
     &                           tsurf(i,j),tempk(i,j,1),m,lai_f,vdf)
                  endif
                endif
                vdc = 0.
                if (isemptyc.eq.0) then
                  roprta = qtc/vtc
                  diam = 1.e-6*diamc
                  if (idrydep.eq.1) then     ! Use Wesely (1989) algorithm
                    call vd_aer(z0,deltaz,psih,ustar,diam,roprta,
     &                        tsurf(i,j),vdc)
                  elseif (idrydep.eq.2) then ! Use Zhang (2001) algorithm
                     call vd_aer_zhang(deltaz,zl,z0,ustar,diam,roprta,
     &                           tsurf(i,j),tempk(i,j,1),m,lai_f,vdc)
                  endif
                endif
                do l = ngas+1,nspec
                  if (dcut(l,2).lt.(dcut(kph2o,2)+1.e-5)) then
                    vdep(i,j,l) = vdep(i,j,l) + vdf*fsurf(i,j,m)
                  else
                    vdep(i,j,l) = vdep(i,j,l) + vdc*fsurf(i,j,m)
                  endif
                enddo
c
c-----Other scheme
c
              else
                do l = ngas+1,nspec
                  diam = 1.e-6*sqrt(dcut(l,1)*dcut(l,2))
                  if (idrydep.eq.1) then     ! Use Wesely (1989) algorithm
                    call vd_aer(z0,deltaz,psih,ustar,diam,roprt(l),
     &                        tsurf(i,j),vd)
                  elseif (idrydep.eq.2) then ! Use Zhang (2001) algorithm
                     call vd_aer_zhang(deltaz,zl,z0,ustar,diam,roprt(l),
     &                           tsurf(i,j),tempk(i,j,1),m,lai_f,vd)
                  endif
                  vdep(i,j,l) = vdep(i,j,l) + vd*fsurf(i,j,m)
                enddo
              endif
            endif
 10       continue
c
c-----Calculate final landuse-weighted deposition velocities
c
          totland = amax1(totland, 0.01)
          do l = 1,nspec
            vdep(i,j,l) = vdep(i,j,l)/totland
          enddo
          if (lbidinh3) eflxnh3(i,j) = eflxnh3(i,j)/totland
c
 20     continue
 30   continue
c
c$omp end parallel
c
      return
      end

      subroutine initipr(linit,iproc_id,igrid,nospec,ncol,nrow,nlay,conc)
      use chmstry
      use bndary
      use procan
      use node_mod
c
c----CAMx v7.40 260801
c
c     Loads the initial values for the Integrated Process 
c     Analysis (IPR) data for the Process Anaylsis algorithm.  
c     For each sub-domain cell, either the array element for 
c     initial value or final value (depneding on the input flag
c     LINIT) is loaded from the gridded concentration array to
c     the process analysis array.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        igrid               grid index
c        iproc_id            process ID (MPI)
c        nospec              number of species
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        conc                concentration field (umol/m3)
c
c     Output arguments:
c
c
c     Routines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
      logical linit
      real    conc(ncol,nrow,nlay,nospec)
c
c-----Entry point
c
c  --- loop over all all species ---
c
      do ispc=1,nospec
c
c --- skip if not in this grid, otherwise get cell indexes ---
c
          do 10 icel=1,npa_cels
            if( ipanst(icel) .NE. igrid ) goto 10
            irx = ipax(icel)
            iry = ipay(icel)
            irz = ipaz(icel)
c
c   --- skip if this cell is not in the computational domain ---
c
            if( iproc_id .GT. 0 )  then
               irx = irx - mi0(igrid)
               iry = iry - mj0(igrid)
               if( irx .LT. mia(igrid) .OR. irx .GT. miz(igrid) .OR. 
     &           iry .LT. mja(igrid) .OR. iry .GT. mjz(igrid) ) goto 10
            endif
c
c  --- if initializing, load into initial position ---
c
            if (linit) then
                cipr(IPR_INIT,icel,ispc) = conc(irx,iry,irz,ispc)
c
c  --- otherwise, load into final position ---
c
            else
                cipr(IPR_FINAL,icel,ispc) = conc(irx,iry,irz,ispc)
            endif
   10     continue
c
c  --- next species ---
c
      enddo
c
      return
      end

c**** RDBCRT.F
c
      subroutine rdbcrt(nsteps,nox,noy,noz,nspas,saconc,tpgrd,prgrd)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use rtracchm
      use tracer
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fills one hour of boundary conditions for the RTRAC
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  tracer concentrations
c       Inputs:
c           nsteps   I  number of steps already performed
c           nox      I  number of X cells in the grid
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspas    I  number of tracer species
c           tpgrd    I  3-D temperature field
c           prgrd    I  3-D pressure field
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/21/02   --gwilson--    Original development
c     11/4/09    -cemery-       Removed input top concentrations
c     03/02/10    -gwilson-     Fixed bug in loading from local array -
c                               was using wrong index
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nsteps
      integer   nox
      integer   noy
      integer   noz
      integer   nspas
      real      saconc(nox,noy,noz,nspas)
      real      tpgrd(nox,noy,noz)
      real      prgrd(nox,noy,noz)
c
c-----------------------------------------------------------------------
c    Local variables:
c----------------------------------------------------------------------
c
      character*200 action
      character*10 bnfil, cfile, cspec
      character*4  ifile(10), note(60), ispec(10)
      integer      ispc, iedge
      integer      iseg, nspc, idat1, idat2
      integer      izone, nx, ny, nz, imod
      integer      i, j, k
      real         tim1, tim2, orgx, orgy, utmx, utmy, dx, dy
      logical      lexist, luse
c
      real conwst(MXLAYER,MXCELLS)
      real conest(MXLAYER,MXCELLS)
      real consth(MXLAYER,MXCELLS)
      real connth(MXLAYER,MXCELLS)
c
c-----------------------------------------------------------------------
c    Data statements:
c-----------------------------------------------------------------------
c
      data bnfil /'BOUNDARY'/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- if no BC file provided then we skip to the end ---
c
      if( .NOT. lbcfil ) goto 9999
c
c  --- open the BC ---
c
      inquire(file=bcfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening RTRAC Boundary Conditions file.'
      ierr = ncf_chkfile(iorbc,bcfil,action,bnfil)
      if( ierr .EQ. ISUCES ) then
         call  nobinary()
         open(file=bcfil,unit=iorbc,status='UNKNOWN',
     &                                   form='UNFORMATTED',ERR=7001)
      else
         return
      endif
c
c  --- initialize the boundary conditions to lower bound ---
c
      do ispc=1,ntotsp
        do k=1,noz
          do j=1,noy
            saconc(1,j,k,ispc) = rtlbnd(ispc)
            saconc(nox,j,k,ispc) = rtlbnd(ispc)
          enddo
          do i=1,nox
            saconc(i,1,k,ispc) = rtlbnd(ispc)
            saconc(i,noy,k,ispc) = rtlbnd(ispc)
          enddo
        enddo
      enddo
c
c  --- read 1st BC header record and check inputs ---
c
      read(iorbc,ERR=7002) ifile,note,iseg,nspc,idat1,tim1,idat2,tim2
      if( INT(tim2) .EQ. 24 ) then
        idat2 = idat2 + 1
        tim2 = 0.
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                       idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      write(cfile,'(10A1)') (ifile(i),i=1,10)
      if( cfile .NE. bnfil ) goto 7003
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      if( idat1 .GT. date .AND. .NOT. le1day ) goto 7004
      if( idat1 .EQ. date .AND. tim1 .GT. time
     &                              .AND. .NOT. le1day ) goto 7004
c
c  --- read 2nd BC header record and check inputs ---
c
      read(iorbc,ERR=7002) orgx,orgy,izone,utmx,utmy,dx,dy,nx,ny,nz
      if( .NOT. llatlon ) then
        dx = dx/1000.
        dy = dy/1000.
      endif
      if( nx .NE. ncol(1) .OR. ny .NE. nrow(1) 
     &                                .OR. nz .NE. nlay(1) ) goto 7005
c
c  --- skip the next 6 records ---
c
      read(iorbc,ERR=7002)
      read(iorbc,ERR=7002) 
      do i=1,4
        read(iorbc,ERR=7002) 
      enddo
c
c  --- read the date and time and make sure it is the correct hour ---
c
  111 continue
      read(iorbc,ERR=7007,END=7006) idat1, tim1, idat2, tim2
      tim1 = tim1*100
      tim2 = tim2*100
      if( INT(tim2) .EQ. 24 ) then
        tim2 = 0.
        idat2 = idat2 + 1
      endif
      if( (idat1 .LT. date .OR. 
     &       (idat1 .EQ. date .AND. tim1 .LE. time)) .AND.
     &            (idat2 .GT. date .OR. 
     &                (idat2 .EQ. date .AND. tim2 .GT. time))) then
c
c  --- read the concentrations for each species ---
c
         do ispc=1,nspc
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((conwst(k,j),k=1,nz),j=1,ny)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((conest(k,j),k=1,nz),j=1,ny)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((consth(k,i),k=1,nz),i=1,nx)
            read(iorbc,ERR=7007,END=7006) iseg, (ispec(i),i=1,10),iedge,
     &                                     ((connth(k,i),k=1,nz),i=1,nx)
            write(cspec,'(10A1)') ispec
c
c  --- find this species in the modeled species list ---
c
            luse = .FALSE.
            do imod=1,ntotsp
               if( cspec .EQ. ptname(imod) ) then
                  luse = .TRUE.
                  do k=1,nz
                     do j=1,ny
c
c  --- get the conversion factor to umol/m3 ---
c
                        if( imod .LE. nrtgas ) then
                           convfac = densfac*273./
     &                               tpgrd(1,j,k)*prgrd(1,j,k)/1013.
                        else
                           convfac = 1.0
                        endif
c
c  --- load the west boundary ---
c
                        saconc(1,j,k,imod) = conwst(k,j) * convfac
                        if( saconc(1,j,k,imod) .LT. rtlbnd(imod) )
     &                              saconc(1,j,k,imod) = rtlbnd(imod)
c
c  --- load the east boundary ---
c
c  --- get the conversion factor to umol/m3 ---
c
                        if( imod .LE. nrtgas ) then
                             convfac = densfac*273./
     &                               tpgrd(nox,j,k)*prgrd(nox,j,k)/1013.
                        else
                             convfac = 1.0
                        endif
                        saconc(nox,j,k,imod) = conest(k,j) * convfac
                        if( saconc(nox,j,k,imod) .LT. rtlbnd(imod) )
     &                               saconc(nox,j,k,imod) = rtlbnd(imod)
                     enddo
c
c  --- load the south boundary ---
c
                     do i=1,nx
c
c  --- get the conversion factor to umol/m3 ---
c
                        if( imod .LE. nrtgas ) then
                           convfac = densfac*273./
     &                               tpgrd(i,1,k)*prgrd(i,1,k)/1013.
                        else
                           convfac = 1.0
                        endif
                        saconc(i,1,k,imod) = consth(k,i) * convfac
                        if( saconc(i,1,k,imod) .LT. rtlbnd(imod) )
     &                               saconc(i,1,k,imod) = rtlbnd(imod)
c
c  --- load the east boundary ---
c
c  --- get the conversion factor to umol/m3 ---
c
                       if( imod .LE. nrtgas ) then
                           convfac = densfac*273./
     &                              tpgrd(i,noy,k)*prgrd(i,noy,k)/1013.
                       else
                           convfac = 1.0
                       endif
                       saconc(i,noy,k,imod) = connth(k,i) * convfac
                       if( saconc(i,noy,k,imod) .LT. rtlbnd(imod) )
     &                               saconc(i,noy,k,imod) = rtlbnd(imod)
                     enddo
c
c  --- get the next layer ---
c
                  enddo
c
c  --- check the next modeled species ---
c
               endif
            enddo
c
c  --- if not found in model species list, write a message ----   
c   
            if( .NOT. luse .AND. nsteps .EQ. 1 ) then
                write(idiag,'(1X,4A)') 'Species in RTRAC ',     
     &              'boundary conditions file: ',cspec(:istrln(cspec)),
     &                      ' not found in species list ... Skipping.'
            endif
c
c  --- read next species worth of data ---
c
         enddo
c
c  --- if not the right hour, read through it ---
c
      else
         do ispc=1,nspc
            do i=1,4
               read(iorbc,ERR=7007) 
            enddo
         enddo
         goto 111
      endif
c
c  --- finally got the right hour, close the file ---
c
      close(iorbc)
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  BC file for RTRAC does not exist: ',
     &                                             bcfil(:istrln(bcfil))
      call camxerr()
c
 7001 continue 
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  Opening BC file for RTRAC: ',
     &                                            bcfil(:istrln(bcfil))
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  Reading header of BC file for RTRAC: ',
     &                                            bcfil(:istrln(bcfil))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  BC input file for RTRAC is not labelled ',
     &                                                 'BOUNDARY.'
      call camxerr()
c
 7004 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  BC input file for RTRAC is not for ',
     &                                            'corect time period.'
      write(iout,*) '   ***  Episode ***'
      write(iout,'(a,i10.5)') 'Date   : ',date
      write(iout,'(a,f10.1)') 'Time   : ',time
      write(iout,*) '   ***  BC File ***'
      write(iout,'(a,i10.5)') 'Date   : ',idat1
      write(iout,'(a,f10.1)') 'Time   : ',tim1
      call camxerr()
c
 7005 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  BC input file does not appear to be for ',
     &                ' the correct grid.' 
      write(iout,*) '   ***  Coarse Grid ***'
      write(iout,*) 'No. of Cells : (',ncol(1),',',nrow(1),')'
      write(iout,*) 'No. of layers:  ',nlay(1)
      write(iout,*) '   ***  BC File ***'
      write(iout,*) 'No. of Cells : (',nx,',',ny,')'
      write(iout,*) 'No. of layers:  ',nz
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  Premature end-of-file reached in BC file ',
     &                                                      'for RTRAC.'
      write(iout,*) 'Make sure the file contains the correct date/time.'
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in RDBCRT:'
      write(iout,*) 'ERROR:  Reading BC file for RTRAC: ',
     &                                          bcfil(:istrln(bcfil))
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine soap(ntot,mw,caer,cgas,csatT,cpx,
     &                iout,igrdchm,ichm,jchm,kchm,ierr)
      implicit none
c
c**********************************************************************
c                                                                     * 
c                                                                     * 
c  SOAP - A SUBROUTINE TO CALCULATE GAS-AEROSOL PARTITIONING OF       *
c                     SECONDARY ORGANIC SPECIES                       *
c                                                                     *
c                           DEVELOPED BY:                             *
c                                                                     * 
c                           ROSS STRADER                              *
c            DEPARTMENT OF CIVIL/ENVIRONMENTAL ENGINEERING            *
c             CARNEGIE MELLON UNIVERSITY, 5000 FORBES AVE             *
c                   PITTSBURGH, PENNSYLVANIA, 15213                   *
c                                                                     * 
c                               AND                                   *
c                                                                     * 
c                         SPYROS N. PANDIS                            *
c       DEPARTMENTS OF CHEMICAL ENGINEERING AND ENGINEERING AND       *
c                          PUBLIC POLICY                              *
c             CARNEGIE MELLON UNIVERSITY, 5000 FORBES AVE             *
c                   PITTSBURGH, PENNSYLVANIA, 15213                   *
c                                                                     * 
c                                                                     * 
c                                                                     * 
c                                                                     * 
c      ASSOCIATED SUBROUTINES:                                        *
c      CALC       - CALCULATES THE MOLE FRACTION OF EACH SOLUTION-    *
c                   FORMING COMPOUND IN THE PSEUDO-IDEAL SOLUTION     * 
c                   (AEROSOL PHASE)                                   *
c      FCN        - NONLINEAR SYSTEM TO BE SOLVED BY HYBRD            *
c      RNDNUM     - GENERATES RANDOM NUMBERS                          *
c      HYBRD      - SOLVES A SYSTEM OF NONLINEAR EQUATIONS            *
c                                                                     * 
c                                                                     * 
c**********************************************************************
c                                                                     * 
c                                                                     * 
c     THIS MODEL USES A PSEUDO-IDEAL SOLUTION THEORY TO PARTITION     *
c     SECONDARY ORGANIC SPECIES BETWEEN THE AEROSOL AND GAS PHASE.    *
c     THE THEORY IS OUTLINED IN:                                      * 
c                                                                     * 
c     STRADER, R. (1998), 'EVALUATION OF SECONDARY ORGANIC AEROSOL    *
c          FORMATION IN WINTER,' M.S. THESIS, DEPT. OF CIVIL/         *
c          ENVIRONMENTAL ENGINEERING, CARNEGIE MELLON UNIVERSITY      *
c                                                                     * 
c                                                                     * 
c**********************************************************************
c
c
c  MODIFICATIONS
c
c     Jan 2003 -gyarwood- Revised for CAMx
c     01/20/03 -bkoo-     Revised for CAMx
c     03/09/03 -bkoo-     Revised for new SOAP driver
c     05/27/05 -bkoo-     Revised for new bi-section solver
c     12/29/06 -bkoo-     Revised for the updated SOA scheme
c     04/13/10 -bkoo-     Approximate solutions if POA is dominant
c     08/23/13 -bkoo-     Revised for DDM-PM
c     03/18/14 -bkoo-     Revised for benzene SOA
c     08/25/16 -bkoo-     Updated for new SOAP
c     10/30/19 -gyarwood- Relax xtol and revise convergence tests at 99
c
c DEFINITION OF VARIABLES:
c
c  INPUTS
c
c     ntot    - total number of CG/SOA pairs
c     mw      - molecular weights of SOA species (g/mole)
c     caer    - aerosol-phase concentrations of SOA species (ug/m3)
c     cgas    - gas-phase concentrations of CG species (ug/m3)
c     csatT   - saturation concentrations of CG/SOA pairs at current T (ug/m3)
c     cpx     - pre-existing OA mass (mole)
c     iout    - standard output file unit
c     igrdchm - index for grid containing the grid cell
c     ichm    - i index of grid cell
c     jchm    - j index of grid cell
c     kchm    - k index of grid cell
c
c   OUTPUTS
c
c     caer    - aerosol-phase concentrations of SOA species (ug/m3)
c     cgas    - gas-phase concentrations of CG species (ug/m3)
c     ierr    - ierr > 0 signals an error
c
c   VARIABLES USED WITHIN SOAP
c
c     i       - counter
c     icont   - counter
c     sum     - counter
c     nsol    - total number of solution-forming SOA species
c     smw     - molecular weights of solution-forming SOA species (g/mole)
c     scaer   - aerosol-phase concentrations of solution-forming SOA species (ug/m3)
c     scgas   - gas-phase concentrations of solution-forming SOA species (ug/m3)
c     scsat   - saturation concentrations of solution-forming SOA species (ug/m3)
c     sctot   - total concentrations of solution-forming SOA species (ug/m3)
c     znum    - counter for number of iterations
c     conmin  - use simple solution for species below this level (ug/m3)
c     cpxmin  - no pre-existing organics if cpx < cpxmin (mole) 
c     xtol    - error tolerance for bi-section method
c
c***********************************************************************
c
c VARIABLE DECLARATION
c
      real, parameter :: conmin  = 1.e-6
      real, parameter :: cpxmin  = 1.e-10
      real, parameter :: xtola   = 1.e-8
      real, parameter :: xtolr   = 1.e-5

      integer :: ntot, ierr
      real, dimension(ntot) :: mw, caer, cgas, ctot, csatT,
     &                         smw, scaer, scgas, sctot, scsat
      integer, dimension(ntot) :: idx

      real    :: cpx, sum
      integer :: iout, igrdchm, ichm, jchm, kchm
      integer :: i, icont, nsol, znum

      real    :: bb, cc, xend, fend, xmid, fmid, dx
      real    :: caer_in(ntot), cgas_in(ntot)

      logical, save :: lfirsttime = .true.
c
c***********************************************************************
c
c Entry point
c
      ierr = 0
      caer_in = caer
      cgas_in = cgas

!      if (lfirsttime) then
!        lfirsttime = .false.
!      endif

      do i=1,ntot
        ctot(i) = caer(i) + cgas(i)
      enddo
c
c CALCULATE AEROSOL-PHASE CONCENTRATION (CAER) AND GAS-PHASE 
c CONCENTRATION (CGAS) FOR NON-SOLUTION-FORMING COMPOUNDS
c COMPOUNDS THAT HAVE A CONCENTRATION OF LESS THAN conmin ARE IGN0RED
c MAP COMPOUNDS THAT FORM SOLUTIONS ONTO ARRAYS
c
      icont=0
      do i=1,ntot
         if (ctot(i).lt.conmin) then
            cgas(i) = ctot(i)
            caer(i) = 0.0
c
c========================= DDM Begin ===================================
c
            CALL DDMSOATRV (ctot(i),csatT(i),0.0,0.0,0.0,i,2,iout)
c
c========================== DDM End ====================================
c
         else
            icont=icont+1
            idx(icont) = i
            smw(icont)=mw(i)
            scsat(icont)=csatT(i)
            sctot(icont)=ctot(i)
            scaer(icont)=caer(i)
         endif
      enddo
      nsol=icont
c
c Check for a trivial solution
c
      if (nsol.eq.0) goto 1000
      if (nsol.eq.1) then
         if (cpx.lt.cpxmin) then
           scgas(1) = amin1(sctot(1), scsat(1))
           scaer(1) = sctot(1) - scgas(1)
c
c========================= DDM Begin ===================================
c
           CALL DDMSOATRV (sctot(1),scsat(1),0.0,0.0,0.0,idx(1),1,iout)
c
c========================== DDM End ====================================
c
         else ! This case has an analytical solution
           bb = scsat(1)-sctot(1)+cpx*smw(1)
           cc = -sctot(1)*cpx*smw(1)
           scaer(1) = amin1( sctot(1), .5*(-bb+SQRT(bb*bb-4.*cc)) )
           scgas(1) = sctot(1) - scaer(1)
c
c========================= DDM Begin ===================================
c
           CALL DDMSOATRV (sctot(1),scsat(1),
     &                     cpx,smw(1),scaer(1),idx(1),3,iout)
c
c========================== DDM End ====================================
c
         endif
         goto 900
      endif
      sum=0.0
      do i=1,nsol
         sum = sum + sctot(i)/scsat(i)
      enddo
      if (cpx.lt.cpxmin .and. sum.le.1.0) then
         do i=1,nsol
            scgas(i)=sctot(i)
            scaer(i)=0.0
c
c========================= DDM Begin ===================================
c
            CALL DDMSOATRV (sctot(i),scsat(i),0.0,0.0,0.0,idx(i),2,iout)
c
c========================== DDM End ====================================
c
         enddo
         goto 900
      endif
c
c Find the solution using a bi-section method (approach from max)
c
      xend = 0.0
      do i = 1, nsol
        xend = xend + sctot(i)/smw(i)
      enddo
      xend = xend + cpx
      call spfcn (nsol,sctot,scsat,scaer,smw,cpx,xend,fend)
      if ( abs(fend).le.xtola .OR.
     &    (xend-cpx).lt.cpx*xtolr ) goto 99       ! converged, no iteration needed
      if (fend.gt.cpx*xtolr) then
        write (iout,'(//,a)') ' ERROR in SOAP:'   ! first iteration will diverge
        write (iout,'(/,a)') ' ERROR: positive end point'
        write (iout,'(a,2e15.7)') 'xend,fend ',xend,fend
        goto 50
      endif
      dx = xend - cpx
      do znum = 1, 200
        dx = 0.5 * dx
        xmid = xend - dx
        call spfcn (nsol,sctot,scsat,scaer,smw,cpx,xmid,fmid)
        if (abs(fmid).le.xtola .or.
     &      dx.le.max(xtola,xtolr*xmid)) goto 100 ! converged after iteration
        if (fmid.lt.0.0) xend = xmid
      enddo
      write (iout,'(//,a)') ' ERROR in SOAP:'     ! failed to converge
      write (iout,'(/,a)') ' ERROR: max number of iterations reached'
      write (iout,'(a,2e15.7)') ' xmid,fmid ',xmid,fmid
 50   write (iout,'(a,i10,a,3i4)') ' Grid = ', igrdchm,
     &                 ' cell(i,j,k) = ', ichm, jchm, kchm
      write (iout,'(a5,5a)')
     &       ' spec','  gas in[ug/m3]','    aerosol in[ug/m3]',
     &           '     total[ug/m3]','    aerosol[ug/m3]','      c* [ug/m3]'
      write (iout,'(i5,5e18.7)')
     &       (idx(i),cgas_in(i),caer_in(i),sctot(i),scaer(i),scsat(i),i=1,nsol)
      write (iout,'(a,e15.7)') ' cpx ',cpx
      ierr = 1
      return
c
c Converged
c
  99  xmid = xend
 100  continue
      do i=1,nsol
         scaer(i) = amin1( sctot(i), scaer(i) )
         scgas(i) = sctot(i) - scaer(i)
      enddo
c
c========================= DDM Begin ===================================
c
      CALL DDMSOAAP (sctot,scsat,smw,xmid,nsol,idx,iout)
c
c========================== DDM End ====================================
c
c REMAP COMPOUNDS THAT FORM SOLUTIONS BACK ONTO ORIGINAL ARRAYS
c      
 900  continue
      do i=1,nsol
         caer(idx(i))=scaer(i)
         cgas(idx(i))=scgas(i)
      enddo
c
c Return point
c
 1000 continue
c
      return
      end

      subroutine wrtpig(idatpig,timpig)
      use filunit
      use pigsty
      use chmstry
      use tracer
      use rtracchm
      implicit none
c
c----CAMx v7.40 260801
c
c     WRTPIG writes pig parameters and state variables for restart 
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        07/05/02   Added code to accomodate IRON-PiG
c        02/16/05   Added code to accomodate RTRAC mass
c        08/25/05   Added write of GREASD-OSAT region/group pointers
c        02/02/06   Removed GREASD-PiG specific file formats; both PiG options
c                   use the IRON file formats
c        06/04/09   Added sigmax
c
c     Input arguments:
c        idatpig             model date (YYJJJ)
c        timpig              model time
c
c     Output arguments:
c        none
c
c     Subroutines called:
c        none
c
c     Called by:
c        CAMx
c
      include "camx.prm"
c
      integer idatpig,n,i,nr
      real timpig
c
c-----Entry point
c
      write(ipig) idatpig,timpig,npig,nreactr
c
      if (ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                                    tectyp .EQ. RTCMC) ) then
        write(ipig) (ingrd(n),idpig(n),xpigf(n),xpigb(n),ypigf(n),
     &            ypigb(n),zpig(n),axisy(n),axisz(n),sigy(n),sigx(n),
     &            sigz(n),pufftop(n),puffbot(n),htfms(n),htfmb(n),
     &            vtfms(n),vtfmb(n),agepigf(n),agepigb(n),fmspig(n),
     &            ((puffmass(i,nr,n),i=1,nspec),nr=1,nreactr),n=1,npig),
     &            (((puffrt(i,nr,n),i=1,nrtrac),nr=1,nreactr),n=1,npig)
      else
          write(ipig) (ingrd(n),idpig(n),xpigf(n),xpigb(n),ypigf(n),
     &             ypigb(n),zpig(n),axisy(n),axisz(n),sigy(n),sigx(n),
     &             sigz(n),pufftop(n),puffbot(n),htfms(n),htfmb(n),
     &             vtfms(n),vtfmb(n),agepigf(n),agepigb(n),fmspig(n),
     &             ipufmap(n),ipufgrp(n),
     &             ((puffmass(i,nr,n),i=1,nspec),nr=1,nreactr),n=1,npig)
      endif
c
      return
      end

      subroutine pigdrive(m1,m2,m3,ioff,joff,
     &                    igrd,iptr2d,ncol,nrow,nlay,nspcs,nspdep,
     &                    itzon,dt,dx,dy,delx,dely,meshfac,mapscl,
     &                    height,rkv,tempk,tsurf,press,water,windu,
     &                    windv,cldtrns,cwc,pwr,pws,pwg,cph,cellat,
     &                    cellon,topo,sfcz0,albedo,vdep,conc,pigdump,
     &                    pgmserr,fluxes,depfld,ipsa2d,ipsa3d,ipsadep,
     &                    ipa_cel,iproc_id)
      use camxcom
      use filunit
      use chmstry
      use o3colmap
      use pigsty
      use tracer
      use procan
      use rtracchm
      use rtcmcchm
      use node_mod
      implicit none
c
c----CAMx v7.40 260801
c
c     PIGDRIVE is the driver program for the PiG submodel.
c     It performs chemistry, puff growth, and mass dumping.
c
c      Copyright Ramboll
c
c     Modifications:
c        02/02/06        Renamed PIGDRIVE from IRONDRIV
c        8/31/06         Added map scale factor
c        01/08/07        Added Stage 3 criteria for Mech6 (CB05)
c                        Added ETOH,MTBE,MBUT rxns to Stage 3 criteria for Mech5
c        06/22/07        Removed termination check for puffs extending to
c                        surface layer
c        07/11/07        Added code for RTCMC probing tool
c        02/21/08        Added coupling time for puff aerosol chemistry
c        03/10/08        Added avgcnc and acgrad to calls to IRONCHEM
c        03/31/08        Added average puff age when killed
c        05/14/08        Improved handling of puff PM increments
c        08/04/08        Added IPR code for PiG changes (lost starting at v4.40)
c        11/02/08        Removed z0 calculation to SRFRUF routine
c        04/15/09        Modifications to support OSAT/PSAT deposition output
c        06/17/09        Restructured puff sigmas to improve impacts of
c                        vertical directional shear on puff growth
c        05/28/10        Added mechanism 7 (CB6)
c        07/14/10        Added code for in-line TUV cloud adjustment
c        04/02/12        Removed RADM cloud adjustment option, cloud/aerosol
c                        adjustments now always done with in-line TUV; AHO
c                        file is now just ozone column
c        04/04/12        Introduced 4-dim interpolation of J values over
c                        zenith, height, albedo, terrain
c        04/12/12        Added T and P adjustments to photolysis rates
c        07/20/12        Added Mechanism 1 (CB06 with Iodine chemistry)
c        10/08/12        Added Mechanism 2 (CB6r1)
c        07/31/13        Restructured to improve GREASD PiG chemistry,
c                        wet dep, and dumping
c        10/14/13        Added pressure to KHETERO call
c        06/27/14        Added Mechanism 3 (CB6r2h)
c        08/11/14        Albedo now includes effects of snow
c        11/11/14        Added Mechanism 4 (CB6r3)
c        12/07/14        Modified for VBS
c        02/10/16        Updated for OSAT3
c        02/21/20        Added Mechanism 1 (CB6r5) -rlb-
c        03/24/21        Added Mechanism 7 (CB7)
c        02/15/22        Added Mechansim 9 (RACM2s21)
c
c     Input arguments:
c        m1                  number of columns in this slice
c        m2                  number of rows in this slice
c        m3                  number of layers in this slice
c        ioff                X offset of this slice in complete domain
c        ioff                Y offset of this slice in complete domain
c        igrd                grid index 
c        iptr2d              pointers into vectors for 2-D fields
c        ncol                number of columns
c        nrow                number of rows
c        nlay                number of layers
c        nspcs               number of species
c        nspdep              number of species in deposition array
c        itzon               time zone 
c        dt                  time step (s)
c        dx                  cell size in x-direction (m)
c        dy                  cell size in y-direction (m)
c        delx                cell size in x-direction (km or deg)
c        dely                cell size in y-direction (km or deg)
c        meshfac             grid meshing factor relative to master grid
c        mapscl              map scale factor
c        height              gridded layer height (m)
c        rkv                 gridded vertical diffusivity (m2/s)
c        tempk               gridded temperature (K)
c        tsurf               gridded surface temperature (K)
c        press               gridded pressure (mb)
c        water               gridded water vapor concentration (ppm)
c        windu               gridded x-component windspeed (m/s)
c        windv               gridded y-component windspeed (m/s)
c        cldtrns             gridded energy transmission coefficient (fraction)
c        cwc                 gridded cloud water (g/m3)
c        pwr                 gridded precip rain (g/m3)
c        pws                 gridded precip snow (g/m3)
c        pwg                 gridded precip graupel (g/m3)
c        cph                 gridded cloud water pH
c        cellat              gridded cell centroid latitude (deg)
c        cellon              gridded cell centroid longitude (deg)
c        topo                gridded cell terrain altitude (m MSL)
c        sfcz0               gridded cell surface roughness (m)
c        albedo              gridded cell surface albedo
c        vdep                gridded species deposition velocity (m/s)
c        conc                species concentration in the grid (umol/m3,ug/m3)
c        ipa_cel             gridded array to identify if cell is
c                            in a IPRM sub-domain
c        iproc_id            process ID for this slice
c
c     Output arguments:
c        conc                species concentration in the grid (umol/m3,ug/m3)
c        pigdump             PiG dumped mass (umol)
c        pgmserr             PiG dumping mass error (umol)
c        fluxes              boundary mass fluxes (umol, ug)
c        depfld              2-D array of wet deposited mass (mol/ha, g/ha)
c                            and surface liquid concentrations (mol/l, g/l)
c
c     Subroutines Called:
c        PIGCOORD
c        VIRTDUMP
c        KTHERM
c        GETZNTH
c        KPHOTO
c        KHETERO
c        NOXCHEM
c        IRONCHEM
c        CALDATE
c        PIGGROW 
c
c     Called by:
c        PIGEVOL
c
      include "camx.prm"
      include "flags.inc"
      include "deposit.inc"
      include 'chmdbg.inc'
      include 'camx_aero.inc'
c
c
      integer m1
      integer m2
      integer m3
      integer ioff
      integer joff
      integer igrd
      integer iptr2d
      integer ncol
      integer nrow
      integer nlay
      integer nspcs
      integer nspdep
      integer itzon
      real    dt
      real    dx(nrow)
      real    dy
      real    delx
      real    dely
      integer meshfac
      real    mapscl(m1,m2)
      real    height(m1,m2,m3)
      real    rkv(m1,m2,m3)
      real    tempk(m1,m2,m3)
      real    tsurf(m1,m2)
      real    press(m1,m2,m3)
      real    water(m1,m2,m3)
      real    windu(m1,m2,m3)
      real    windv(m1,m2,m3)
      real    cldtrns(m1,m2,m3)
      real    cwc(m1,m2,m3)
      real    pwr(m1,m2,m3)
      real    pws(m1,m2,m3)
      real    pwg(m1,m2,m3)
      real    cph(m1,m2,m3)
      real    cellat(m1,m2)
      real    cellon(m1,m2)
      real    topo(m1,m2)
      real    sfcz0(m1,m2)
      real    albedo(m1,m2)
      real    vdep(m1,m2,nspcs)
      real    conc(m1,m2,m3,nspcs)
      real*8  pigdump(*)
      real*8  pgmserr(*)
      real*8  fluxes(nspcs,11)
      real    depfld(m1,m2,nspdep)
      integer ipsa2d
      integer*8 ipsa3d
      integer ipsadep
      integer iproc_id
c
c======================== Process Analysis Begin ===============================
c
      integer ipa_cel(ncol,nrow,nlay)
c
c========================= Process Analysis End ================================
c
      logical ldarkp,ldump,lvdmp(MXPIG),lkill(MXPIG),lstage3
      logical lchemp
      real*8  flxdry(MXSPEC), flxwet(MXSPEC), puff_flux(MXPIG,MXSPEC)
      real    puff_dep(MXPIG,2*MXSPEC)
      real    conpig(MXSPEC+1,MXRECTR), conback(MXSPEC+1)
      real    connew(MXSPEC+1)
      real    dumpmass(MXSPEC), pconc(MXLAYER)
      real    volvec(MXLAYER), wtfac(MXLAYER), pcvfac(MXLAYER)
      real    pcorrec(MXLAYER,MXSPEC), othrpuf(MXLAYER,MXSPEC)
      real    pbdnl(MXLAYER)
      real    depth(MXLAYER), rkpig(MXLAYER), vd(MXSPEC)
      real    dpfl(2*MXSPEC)
      real    delconc(MXLAYER,MXSPEC+1),avgcnc(MXSPEC+1)
      real    sendum(1,1)
c
      integer n,nj,nz,i,j,k,kk,kkk,l,ll,is,ierr,
     &        kpb,kpt,ij,iozon,nr,idum,
     &        idxcel,noxcnt,
     &        hinox(MXRECTR),ierr1,ierr2,aero_flag
      integer ipa_idx
      integer kohso2,kohco,kohno2
      real areamx,pufscl,delt,dtpig,tpuff,wpuff,ppuff,sumwt,
     &     deplyr,alb,trn,
     &     hght,ctrns,zenith,convfac,volpuff,uu,vv,wind,press0,
     &     delms,rctdmp,volfac,tmass,tvol,resid,negconc,
     &     z0,bmass,hshear,vshear,dudx,dudy,dudz,dvdx,
     &     dvdy,dvdz,avgup,avgum,avgvp,avgvm,dz,zzp,zzm,cwpuff,
     &     phpuff,dtchem,totgas
      real xpig,ypig,xdist,ydist,xlen,axisx,pi,test,atm,o2,ch4,h2
      real pufang,shrang
      real pufno(MXRECTR),pufno2(MXRECTR)
c
      common /pigdrivdat/ puff_flux, puff_dep
c
c======================== Source Apportion Begin =======================
c
      integer*8 idx
      real    rtcon(MXTRSP),rtdump(MXTRSP)
      real    dpflrt(MXTRSP),vdrt(MXTRSP)
      real*8  flxdryrt(MXTRSP)
c
c========================= Source Apportion End ========================
c
      pi = 3.1415927
      atm = 1.e6
      O2  = 2.095e5
      CH4 = 1.75
      H2  = 0.50
c
c-----Entry point
c
      do i=1,MXSPEC+1
        avgcnc(i) = 0.
      enddo
      do i=1,MXPIG
        do j=1,MXSPEC
          puff_flux(i,j) = 0.
          puff_dep(i,j) = 0.
          puff_dep(i,MXSPEC+j) = 0.
        enddo
      enddo 
c
c-----Is PiG to do chemistry?
c
      lchemp = .false.
      if (lchem .and. idmech.ne.10) lchemp = .true.
c
c-----Check for negative incoming CONC values and initialize puff overlap
c     array VPCONC
c
      do is = 1,nspec
        do k = 1,nlay
          do j = 1,m2
            do i = 1,m1
              vpconc(i,j,k,is) = 0.
              if (conc(i,j,k,is) .lt. 0.) then
                write(iout,'(/,a)') 
     &             'Start of PIGDRIVE ...negative value in grid conc'
                write(iout,*) 'species, grid, i, j, k: ',is,igrd,i,j,k
                call flush(iout)
                call camxerr()
              endif
            enddo
          enddo
        enddo
      enddo
      do n = 1,npig
        lkill(n) = .false.
      enddo
c
c-----Perform dry deposition
c       
      if (ldry) then
        do 10 n = 1,npig
        if( lmpi ) Lslice(igrd,iproc_id,n) = 0
c
c-----Skip puffs that are not in the current grid
c
          if (ingrd(n).ne.igrd) goto 10
c
c-----Perform deposition once for new puffs over their age
c
          if (lnewg(n)) then
            delt = (agepigf(n) + agepigb(n))/2.
c
c-----Perform deposition for old puffs over current grid's timestep
c
          else
            delt = dt
          endif
c
          xpig = (xpigf(n) + xpigb(n))/2.
          ypig = (ypigf(n) + ypigb(n))/2.
          call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
          i = i-ioff
          j = j-joff
          if( i .LT. ia .OR. i .GT. iz ) goto 10
          if( j .LT. ja .OR. j .GT. jz ) goto 10
          if( lmpi ) Lslice(igrd,iproc_id,n) = 1
c
          if(puffbot(n) .GE.
     &            amax1(10.,height(i,j,1)/2.)) goto 10
          dz = height(i,j,1) - puffbot(n)
          do l = 1,nspec
            vd(l) = vdep(i,j,l)
            flxdry(l) = 0.
            dpfl(l) = 0.
          enddo
c
          call irondry(nrad,nspec,nreactr,dx(j+joff),dy,dz,mapscl(i,j),
     &                 delt,puffmass(1,1,n),axisz(n),vd,dpfl,flxdry)
c
          do 11 l = 1,nspec
            fluxes(l,11) = fluxes(l,11) + flxdry(l)
            do ll = 1,ndepspc
              if (l .eq. ldepmap(ll)) then
                depfld(i,j,ll) = depfld(i,j,ll) + dpfl(l)
                goto 11
              endif
            enddo
 11       continue
c
c======================== Source Apportion Begin =======================
c
          if (ltrace ) then
             if ( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC) then
                do l = 1,nrtrac
                  idx = DBLE(ipsa2d-1) + 
     &                DBLE(i) + DBLE(m1)*DBLE(j-1) + 
     &                            DBLE(m1)*DBLE(m2)*DBLE(l-1)
                  vdrt(l) = vdeprt(idx)
                enddo
                call irondry(0,nrtrac,nreactr,dx(j+joff),dy,dz,
     &                       mapscl(i,j),delt,puffrt(1,1,n),axisz(n),
     &                       vdrt,dpflrt,flxdryrt)
             else
                if( lptdepout ) then
                   call pigdrysa(m1,m2,m3,nrad,nspec,notimespc,i,j,n,
     &                           dpfl,ptconc(ipsa3d),ptdryfld(ipsadep))
                endif
             endif
          endif
c
c========================= Source Apportion End ========================
c
 10     continue
      endif
c
c-----Perform chemistry and wet deposition
c
      if (.not.lchemp .AND. .not.lwet) goto 101
c
c-----Aerosol timing parameters:
c     time_aero : time to call aerosol routine (HHMM)
c     date_aero : date to call aerosol routine (YYJJJ)
c
      aero_flag = 0
      if( lchemp .AND. naero.GT.0 .AND. aeropt.EQ.'CF' ) then
         aero_flag = 1
      endif
c
c-----Treat overlapping puffs via a virtual dump of "large" puffs
c 
      do 20 n = 1,npig
        lvdmp(n) = .false.
        if (ingrd(n).ne.igrd .or. .not.loverlap) goto 20
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
        if( i .LT. ia .OR. i .GT. iz ) goto 20
        if( j .LT. ja .OR. j .GT. jz ) goto 20
        if( lmpi ) Lslice(igrd,iproc_id,n) = 1
c
        xdist = (xpigf(n) - xpigb(n))/delx*dx(j+joff)*meshfac
        ydist = (ypigf(n) - ypigb(n))/dely*dy*meshfac
        xlen  = sqrt(xdist**2 + ydist**2)
        axisx = xlen + 3.*sigx(n)
        pufscl = pi*(axisx/2.)*(1.5*sigy(n))
c
        if (DXYMAX .gt. 0.) then
          areamx = DXYMAX*DXYMAX
        elseif (DXYMAX .lt. 0.) then
          areamx = MIN(DXYMAX*DXYMAX,dx(j+joff)*dy)
        else
          areamx = dx(j+joff)*dy
        endif
        if (pufscl .ge. FLEAK*areamx) then
          lvdmp(n) = .true.
          call virtdump(m1,m2,m3,i0,j0,n,ncol,nrow,nlay,nspec,i,j,
     &                  dx(j+joff),dy,mapscl,height,tempk,press,pcorrec)
          do is = nrad+1,nspec
            do kk = 1,nlay
              vpconc(i,j,kk,is) = vpconc(i,j,kk,is) + pcorrec(kk,is)
            enddo
          enddo
        endif
 20   continue
c
c-----CHEMISTRY + WET DEP loop
c
c$omp parallel default(shared)
c$omp&  private(n,delt,dtpig,xpig,ypig,i,j,idum,k,xdist,ydist,xlen,
c$omp&          axisx,volpuff,kpb,kpt,kk,pcorrec,is,othrpuf,
c$omp&          wtfac,sumwt,deplyr,tpuff,ppuff,wpuff,cwpuff,
c$omp&          phpuff,conback,convfac,
c$omp&          connew,nr,conpig,l,dpfl,flxwet,
c$omp&          noxcnt,hinox,ij,iozon,trn,alb,hght,
c$omp&          ctrns,zenith,ldarkp,lstage3,test,
c$omp&          ierr1,ierr2,rtcon,avgcnc,nj,
c$omp&          dtchem,nz,ierr,totgas,pufno,pufno2,kohso2,kohco,kohno2)
c
c$omp do schedule(dynamic)
c
      do 100 n = 1,npig
c
c-----Skip puffs that are not in the current grid
c
        if (ingrd(n) .ne. igrd) goto 100
c
c-----Perform chemistry once for new puffs over their age
c
        if (lnewg(n)) then
          delt = (agepigf(n) + agepigb(n))/2.
c
c-----Perform chemistry for old puffs over current grid's timestep
c
        else
          delt = dt 
        endif 
        dtpig = min( (agepigf(n) + agepigb(n))/(2.*3600.),
     &                aero_dt(igrd)+(dt/3600.) )
c
c-----Locate the puff in the grid
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
        if( i .LT. ia .OR. i .GT. iz ) goto 100
        if( j .LT. ja .OR. j .GT. jz ) goto 100
        if( lmpi ) Lslice(igrd,iproc_id,n) = 1
c
        do k = 1,nlay
          if( height(i,j,k ) .GT. zpig(n)) goto 25
        enddo
        k = nlay
c
  25    xdist = (xpigf(n) - xpigb(n))/delx*dx(j+joff)*meshfac
        ydist = (ypigf(n) - ypigb(n))/dely*dy*meshfac
        xlen  = sqrt(xdist**2 + ydist**2)
        axisx = xlen + 3.*sigx(n)
        volpuff = pi*axisx*axisy(n)*axisz(n)/6.
c
c-----Find layers containing top and bottom of puff
c
        kpb = 1
        kpt = nlay
        do kk = 1,nlay
          if( height(i,j,kk) .GE. pufftop(n) ) then
            kpt = kk
            goto 26
          endif
        enddo
  26    continue
        do kk = nlay,1,-1
          if( height(i,j,kk) .LE. puffbot(n) ) then
            kpb = kk + 1
            goto 27
          endif
        enddo
  27    continue
c
c-----Get overlap vector for this puff if it contributed to the 
c     virtual dump above (subtract out its contribution to VPCONC).
c     Otherwise, do not apply any puff overlap
c
        if (lvdmp(n)) then
          call virtdump(m1,m2,m3,i0,j0,n,ncol,nrow,nlay,nspec,i,j,
     &                  dx(j+joff),dy,mapscl,height,tempk,press,pcorrec)
          do is = nrad+1,nspec
            do kk = kpb,kpt
              othrpuf(kk,is) = vpconc(i,j,kk,is) - pcorrec(kk,is)
            enddo
          enddo
        else
          do is = nrad+1,nspec
            do kk = kpb,kpt
              othrpuf(kk,is) = 0.
            enddo
          enddo
        endif
c 
c-----Average temp, press, water, and background concs (=overlap+gridded)
c     over layers contained in this puff; define layer weighting as the 
c     depth of puff coverage weighted by density
c
        if (kpb .eq. kpt) then
          wtfac(kpb) = 1.
        else
          sumwt = 0.
          deplyr = pufftop(n) - height(i,j,kpt-1)
          wtfac(kpt) = deplyr*press(i,j,kpt)/tempk(i,j,kpt)
          sumwt = sumwt + wtfac(kpt)
c
          deplyr = height(i,j,kpb) - puffbot(n)
          wtfac(kpb) = deplyr*press(i,j,kpb)/tempk(i,j,kpb)
          sumwt = sumwt + wtfac(kpb)
c
          do kk = kpb+1,kpt-1
            deplyr = height(i,j,kk) - height(i,j,kk-1)
            wtfac(kk) = deplyr*press(i,j,kk)/tempk(i,j,kk)
            sumwt = sumwt + wtfac(kk)
          enddo
c
          do kk = kpb,kpt
            wtfac(kk) = wtfac(kk)/sumwt
          enddo
        endif
c
        tpuff = 0.
        ppuff = 0.
        wpuff = 0.
        cwpuff = 0.
        phpuff = 0.
        do is = nrad+1,nspec+1
          conback(is) = 0.
        enddo
        do kk = kpb,kpt
          tpuff = tpuff + wtfac(kk)*tempk(i,j,kk)
          ppuff = ppuff + wtfac(kk)*press(i,j,kk)
          wpuff = wpuff + wtfac(kk)*water(i,j,kk)
          cwpuff = cwpuff + wtfac(kk)*cwc(i,j,kk)
          phpuff = phpuff + wtfac(kk)*cph(i,j,kk)
          do is = nrad+1,nspec
            conback(is) = conback(is) + wtfac(kk)*
     &                    (othrpuf(kk,is) + conc(i,j,kk,is))
          enddo
        enddo
        convfac = densfac*(273./tpuff)*(ppuff/1013.)
        do is = nrad+1,nspec
          if (is.le.ngas) conback(is) = conback(is)/convfac
          conback(is) = amax1(bdnl(is),conback(is))
          connew(is) = conback(is)
        enddo
        connew(nspec+1) = 0.
c
c-----Perform wet deposition
c
        if (lwet .AND. (pwr(i,j,1).ge.cwmin .or.
     &                  pws(i,j,1).ge.cwmin .or.
     &                  pwg(i,j,1).ge.cwmin)) then
c
          do nr = 1,nreactr
            do is = nrad+1,nspec
              conpig(is,nr) = puffmass(is,nr,n)/(volpuff/float(nreactr))
              if (is.le.ngas) conpig(is,nr) = conpig(is,nr)/convfac
            enddo
          enddo
c
          call ironwet(nspec,n,dx(j+joff),dy,mapscl(i,j),cwpuff,
     &                 pwr(i,j,1),pws(i,j,1),pwg(i,j,1),phpuff,tpuff,
     &                 ppuff,volpuff,conpig,conback,axisz(n),delt,dpfl,
     &                 flxwet)
c
          do l = nrad+1,nspec
            puff_flux(n,l) = puff_flux(n,l) + flxwet(l)
            puff_dep(n,l) = puff_dep(n,l) + dpfl(l)
            puff_dep(n,MXSPEC+l) = puff_dep(n,MXSPEC+l)
     &                                             + dpfl(nspec+l)
          enddo
c
c======================== Source Apportion Begin =======================
c
c  --- if doing tracer depostion, call the routine
c      to aadd to tracer arrays ---
c
          if( lptdepout ) then
             call pigwetsa(m1,m2,m3,nrad,nspec,notimespc,i,j,kpb,kpt,n,
     &                           dpfl,ptconc(ipsa3d),ptwetfld(ipsadep))
          endif
c
c======================== Source Apportion Begin =======================
c
        endif
c
c-----Perform chemistry
c
        if (.not.lchemp) goto 100
c
c-----Add background concentrations (CONBACK) to puff increments in
c     each reactor to get total concentration (CONPIG).
c     Background radicals taken from nominal pig center (no averaging)
c     Puff radicals taken from last time step to use as initial guess
c
        do nr = 1,nreactr
          totgas = 0.
          do is = nrad+1,nspec
            conpig(is,nr) = puffmass(is,nr,n)/(volpuff/float(nreactr))
            if (is.le.ngas) then
              conpig(is,nr) = conpig(is,nr)/convfac
              totgas = totgas + abs(conpig(is,nr))
            endif
            conpig(is,nr) = max(bdnl(is),conback(is) + conpig(is,nr))
          enddo
          if (totgas.lt.0.001) goto 100
          pufno(nr)  = conpig(kno,nr)  - conback(kno)
          pufno2(nr) = conpig(kno2,nr) - conback(kno2)
        enddo
        do nr = 1,nreactr
          conpig(nspec+1,nr) = 0.
        enddo
        if (lchemp) then
          do nr = 1,nreactr
            do l = 1,nrad
              conback(l) = conc(i,j,k,l)
              connew(l) = conback(l)
              conpig(l,nr) = puffmass(l,nr,n) ! puffmass(radical) in ppm
            enddo
          enddo
        endif
c
c-----Determine if any puff reactors have high NOx values
c
        noxcnt = 0
        do nr = 1,nreactr
          hinox(nr) = 0
          if (conpig(kno,nr) + conpig(kno2,nr) .gt. 0.2) then
            noxcnt = noxcnt + 1
            hinox(nr) = 1
          endif
        enddo
c
c-----Determine thermal rate constants
c
        call ktherm(tpuff,ppuff)
c
c-----Load local values of ozone, albedo, terrain ht, zenith angle, altitude
c
        call getznth(cellat(i,j),cellon(i,j),timec(igrd),datec(igrd),
     &               itzon,zenith,ldarkp)
c
        alb   = albedo(i,j)
        ij = i + (j - 1)*m1
        iozon = icdozn(iptr2d - 1 + ij)
c
        trn = topo(i,j)/1000.
        hght = height(i,j,k)/2000.
        if (k.gt.1) hght = (height(i,j,k) + height(i,j,k-1))/2000.
        ctrns = 0.
        if (.not.ldarkp) ctrns = cldtrns(i,j,k)
c
c-----Determine photolysis rates through interpolation of look-up table
c
        call kphoto(iozon,alb,trn,hght,zenith,ctrns,ldarkp,tpuff,ppuff)
c
c-----Determine if any GREASD puff reactors are in Stage 3 chemistry
c
        if (ipigflg.EQ.GRESPIG) then
          lstage3 = .false.
          do nr = 1,nreactr
            if (idmech.eq.5) then
              kohso2 = 44
              kohco  = 29
              kohno2 = 25
            elseif (idmech.eq.3) then
              kohso2 = 52
              kohco  = 123
              kohno2 = 45
            elseif (idmech.eq.7) then
              kohso2 = 51
              kohco  = 50
              kohno2 = 41
            elseif (idmech.eq.9) then
              kohso2 = 69
              kohco  = 70
              kohno2 = 56
            elseif (idmech.eq.1 .or. idmech.eq.4) then
              kohso2 = 52
              kohco  = 120
              kohno2 = 45
            else
              write(iout,'(/,a)')
     &         'In PIGDRIVE, selected mechanism not implemented for PiG'
              write(iout,'(a,i3)') 'Mechanism: ',idmech
              call flush(iout)
              call camxerr()
            endif
            test = 0.
            if( pufno2(nr) .NE. 0. ) 
     &            test = (rk(kohso2)*conpig(kSO2,nr) +
     &              rk(kohco)*conpig(kCO,nr))  /
     &             (rk(kohno2)*pufno2(nr))
            if (.not.ldarkp .AND. test.gt.1. .AND.
     &          pufno2(nr).gt.pufno(nr)) lstage3 = .true.
            if (pufno2(nr).lt.conback(kNO2)) lstage3 = .true.
c
            if (conpig(kNO2,nr).le.0. .OR. conpig(kNO,nr).le.0. .OR.
     &                                              lstage3) then
              lkill(n) = .true.
              nkill(5) = nkill(5) + 1
              goto 100
            endif
c
          enddo
        endif
c
c-----For IRONCHEM, perform chemistry for CONBACK if total NOx
c     (puff+background) is less than 200 ppb.
c     All reactors use same background, save results in CONNEW
c
        if (ipigflg .EQ. IRONPIG) then
          igrdchm = -n
          ichm    = i + ioff
          jchm    = j + joff
          kchm    = 0
          ierr1   = 0
          ierr2   = 0
          tchm = tpuff
          wchm = wpuff
          ldchm = ldarkp
c
c-----Calculate the rate constant for heterogeneous hydrolysis of N2O5
c
          call khetero(tpuff,ppuff,wpuff,conback,.FALSE.,1,sendum)
c
          if (noxcnt .ne. nreactr) then
            call ironchem(delt,dtpig,aero_flag,wpuff,tpuff,ppuff,cwpuff,
     &                    phpuff,ldarkp,connew,conback,avgcnc,convfac,
     &                    ierr1,ierr2)
            if (ierr1 .ne. 0) then
              lkill(n) = .true.
              nkill(3) = nkill(3) + 1
c             write(idiag,*)'Dumping puff ',n,': bad background LSODE'
              goto 100
            endif
          endif
        endif
c
c-----Loop over reactors, perform chemistry for CONPIG.
c     Check for NOx concentrations > 200 ppb; if found, use the 
c     reduced chemistry module
c
        do nr = 1,nreactr
          igrdchm = -n
          ichm    = i + ioff
          jchm    = j + joff
          kchm    = -nr
          ierr1   = 0
          ierr2   = 0
          tchm = tpuff
          wchm = wpuff
          ldchm = ldarkp
c
c-----Calculate the rate constant for heterogeneous hydrolysis of N2O5
c
          call khetero(tpuff,ppuff,wpuff,conpig(1,nr),.FALSE.,1,sendum)
c
c-----For GREASD PiG, remove background except for oxidants (O3,H2O2,FORM,CO)
c
          if (ipigflg.EQ.GRESPIG) then
            do is = nrad+1,nspec
              conpig(is,nr) = conpig(is,nr) - conback(is)
            enddo
            conpig(ko3,nr)   = MAX(bdnl(ko3),
     &                             conpig(ko3,nr) + conback(ko3))
            conpig(kh2o2,nr) = MAX(bdnl(kh2o2),
     &                             conpig(kh2o2,nr) + conback(kh2o2))
            conpig(kco,nr)   = MAX(bdnl(kco),
     &                             conpig(kco,nr) + conback(kco))
            if (idmech.eq.5 .or. idmech.eq.9) then
              conpig(khcho,nr)   = MAX(bdnl(khcho),
     &                             conpig(khcho,nr) + conback(khcho))
            else
              conpig(kform,nr)   = MAX(bdnl(kform),
     &                             conpig(kform,nr) + conback(kform))
            endif
          endif
c
          if (hinox(nr) .eq. 1) then
            call noxchem(delt,bdnl(ko3),bdnl(kno),conpig(kno,nr),
     &                   conpig(kno2,nr),conpig(ko3,nr),rk(ipigrxn))
          else
            call ironchem(delt,dtpig,aero_flag,wpuff,tpuff,ppuff,cwpuff,
     &                    phpuff,ldarkp,conpig(1,nr),conback,avgcnc,
     &                    convfac,ierr1,ierr2)
            if (ierr1 .ne. 0) then
              lkill(n) = .true.
              nkill(4) = nkill(4) + 1
c             write(idiag,*)'Dumping puff ',n,': bad puff LSODE'
              goto 100
            endif
            if (ierr2 .ne. 0) then
              lkill(n) = .true.
              nkill(9) = nkill(9) + 1
c             write(idiag,*)'Dumping puff ',n,': bad puff PM'
              goto 100
            endif
          endif
c
c======================== Source Apportion Begin =======================
c
c-----Original RTRAC
c
          if( ltrace .AND. tectyp .EQ. RTRAC .AND.
     &        (nrtherm .GT. 0 .OR. nrtphot .GT. 0) ) then
             do is = 1,nrtgas
               rtcon(is) = puffrt(is,nr,n)/(volpuff/float(nreactr))
               rtcon(is) = rtcon(is)/convfac
             enddo
             if (hinox(nr) .eq. 1) then
               avgcnc(koh)  = conpig(koh,nr)
               avgcnc(kno3) = conpig(kno3,nr)
               avgcnc(ko3)  = conpig(ko3,nr)
             endif
             dtchem = delt/3600.
             call pigchmrt(ppuff,tpuff,avgcnc(koh),avgcnc(ko3),
     &                     avgcnc(kno3),dtchem,rtcon)
             do is = 1,nrtgas
               rtcon(is) = rtcon(is)*convfac
               puffrt(is,nr,n) = rtcon(is)*volpuff/float(nreactr)
             enddo
          endif
c
c-----RTCMC
c
          if( ltrace .AND. tectyp .EQ. RTCMC ) then
             if( ktype .EQ. 1 ) then
                call krtc(tpuff,ppuff)
             else
                call ksci(tpuff,ppuff)
             endif
             if( njschm .GT. 0 ) then
                 do nj = 1,njschm
                    srkrtc(ijschm(nj)) = 0.
                    do nz = nzschm,1,-1
                       if( zenith .LE. zenschm(nz) )
     &                    srkrtc(ijschm(nj)) = rjschm(nz,nj)
                    enddo
                    rkrtc(ijschm(nj))  = DBLE( srkrtc(ijschm(nj)) )
                 enddo
             endif
             do is = 1,nrtgas
               rtcon(is) = puffrt(is,nr,n)/(volpuff/float(nreactr))
               rtcon(is) = rtcon(is)/convfac
             enddo
             if (hinox(nr) .eq. 1) then
               do is = 1,nspec
                 avgcnc(is)  = conpig(is,nr)
               enddo
             endif
             dtchem = delt/3600.
             if( isolv .EQ. 1) then
                call dlsdrv(dtchem,wpuff,atm,O2,CH4,H2,avgcnc,
     &                      rtcon,ierr,.true.)
             elseif( isolv .EQ. 2) then
                call slsdrv(dtchem,wpuff,atm,O2,CH4,H2,avgcnc,
     &                      rtcon,ierr,.true.)
             elseif( isolv .EQ. 3) then
                call rbkdrv(dtchem,wpuff,atm,O2,CH4,H2,avgcnc,
     &                      rtcon,ierr,.true.)
             endif
             do is = 1,nrtgas
               rtcon(is) = rtcon(is)*convfac
               puffrt(is,nr,n) = rtcon(is)*volpuff/float(nreactr)
             enddo
          endif
c
c========================= Source Apportion End ========================
c
c
c-----Subtract off the new background to get new increment.
c     CONPIG and PUFFMASS can be negative again
c
          if (ipigflg.EQ.IRONPIG) then
            do is = nrad+1,nspec
              if (hinox(nr).eq.1) then
                conpig(is,nr) = conpig(is,nr) - conback(is)
              else
                conpig(is,nr) = conpig(is,nr) - connew(is)
              endif
            enddo
          else
            conpig(kO3,nr)   = conpig(kO3,nr)   - connew(kO3)
            conpig(kh2o2,nr) = conpig(kh2o2,nr) - connew(kh2o2)
            conpig(kco,nr)   = conpig(kco,nr)   - connew(kco)
            if (idmech.eq.5 .or. idmech.eq.9) then
              conpig(khcho,nr) = conpig(khcho,nr) - connew(khcho)
            else
              conpig(kform,nr) = conpig(kform,nr) - connew(kform)
            endif
          endif
          do is = nrad+1,nspec
            if (is.le.ngas) conpig(is,nr) = conpig(is,nr)*convfac
            puffmass(is,nr,n) = conpig(is,nr)*volpuff/float(nreactr)
          enddo
          do l = 1,nrad
            puffmass(l,nr,n) = conpig(l,nr) ! puffmass(radical) in ppm
          enddo
        enddo
 100  continue
c
c  --- end of parallelized loop ---
c
c$omp end parallel
c
c  --- put the fluxes and wet deposition into the totals array ---
c
      do 110 n = 1,npig
        if( ingrd(n) .EQ. igrd ) goto 110
c
c-----Locate the puff in the grid
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
        if( i .LT. ia .OR. i .GT. iz ) goto 110
        if( j .LT. ja .OR. j .GT. jz ) goto 110
c
c---- accumulate in totals array ---
c
        do 111 l=1,nspec
          fluxes(l,11) = fluxes(l,11) + puff_flux(n,l)
          do ll=1,ndepspc
             if( l .EQ. ldepmap(ll) ) then
                depfld(i,j,ndepspc+ll) = depfld(i,j,ndepspc+ll) + 
     &                                                    puff_dep(n,l)
                depfld(i,j,2*ndepspc+ll) = depfld(i,j,2*ndepspc+ll) +
     &                                              puff_dep(n,MXSPEC+l)
     &                                    
                goto 111
             endif
          enddo
  111   continue
  110 continue
c
c-----End CHEMISTRY loop
c
c-----Start GROWTH and DUMPING loop
c
 101  continue
      do 200 n = 1,npig
c
c-----Skip puffs that are not in the current grid
c
        if (ingrd(n) .ne. igrd) goto 200
c
c-----Perform growth once for new puffs over their age
c
        if (lnewg(n)) then
          delt = (agepigf(n) + agepigb(n))/2.
c
c-----Perform growth for old puffs over current grid's timestep
c
        else
          delt = dt 
        endif 
c
c-----Locate the pig in the grid
c
        xpig = (xpigf(n) + xpigb(n))/2.
        ypig = (ypigf(n) + ypigb(n))/2.
        call pigcoord(xpig,ypig,i,j,idum)
c
c--- adjust cell index and skip if PiG not in this slice ---
c
        i = i-ioff
        j = j-joff
        if( i .LT. ia .OR. i .GT. iz ) goto 200
        if( j .LT. ja .OR. j .GT. jz ) goto 200
        if( lmpi ) Lslice(igrd,iproc_id,n) = 1

        idxcel =  i + m1*(j-1)
        do k = 1,nlay
          if( height(i,j,k) .gt. zpig(n) ) goto 15
        enddo
        k = nlay
  15    xdist = (xpigf(n) - xpigb(n))/delx*dx(j+joff)*meshfac
        ydist = (ypigf(n) - ypigb(n))/dely*dy*meshfac
        xlen  = sqrt(xdist**2 + ydist**2)
        pufang = atan(ydist/(xdist+1.e-10))
c
c-----Find layers containing top and bottom of puff
c
        kpb = 1
        kpt = nlay
        do kk = 1,nlay
          if( height(i,j,kk) .GE. pufftop(n) ) then
            kpt = kk
            goto 151
          endif
        enddo
  151   continue
        do kk = nlay,1,-1
          if( height(i,j,kk) .LE. puffbot(n) ) then
            kpb = kk + 1
            goto 152
          endif
        enddo
  152   continue
c
c-----Get the drivers on puff growth
c
c-----Resolved shear metrics: use deformation for net horizontal shear
c
        dudx = (windu(i,j,k) - windu(i-1,j,k))/dx(j+joff)
        dvdy = (windv(i,j,k) - windv(i,j-1,k))/dy
        avgup = (windu(i,j,k) + windu(i,j+1,k) + windu(i-1,j,k) + 
     &           windu(i-1,j+1,k))/4.
        avgum = (windu(i,j,k) + windu(i,j-1,k) + windu(i-1,j,k) + 
     &           windu(i-1,j-1,k))/4.
        dudy = (avgup - avgum)/dy
        avgvp = (windv(i,j,k) + windv(i+1,j,k) + windv(i,j-1,k) + 
     &           windv(i+1,j-1,k))/4.
        avgvm = (windv(i,j,k) + windv(i-1,j,k) + windv(i,j-1,k) + 
     &           windv(i-1,j-1,k))/4.
        dvdx = (avgvp - avgvm)/dx(j+joff)
        hshear = sqrt((dudy + dvdx)**2 + (dudx - dvdy)**2)
c
        dudz = 0.
        dvdz = 0.
        dz = height(i,j,k)
        if (k.gt.1) dz = height(i,j,k) - height(i,j,k-1)
        if( axisz(n) .gt. dz .and. kpt-kpb .ge. 1 ) then
          zzp = (height(i,j,kpt) + height(i,j,kpt-1))/2.
          zzm = height(i,j,kpb)/2.
          if (kpb.gt.1) zzm = (height(i,j,kpb) + height(i,j,kpb-1))/2.
          avgup = (windu(i,j,kpt) + windu(i-1,j,kpt))/2.
          avgum = (windu(i,j,kpb) + windu(i-1,j,kpb))/2.
          dudz = (avgup - avgum)/(zzp - zzm)
          avgvp = (windv(i,j,kpt) + windv(i,j-1,kpt))/2.
          avgvm = (windv(i,j,kpb) + windv(i,j-1,kpb))/2.
          dvdz = (avgvp - avgvm)/(zzp - zzm)
        endif
        vshear = sqrt(dudz**2 + dvdz**2)
        shrang = atan(dvdz/(dudz+1.e-10))
c
c-----Surface layer met
c
        uu = 0.5*(windu(i,j,1) + windu(i-1,j,1))
        vv = 0.5*(windv(i,j,1) + windv(i,j-1,1))
        wind = sqrt(uu*uu + vv*vv)
        do kk = 1,nlay
          depth(kk) = height(i,j,kk)
          if (kk.gt.1) depth(kk) = height(i,j,kk) - height(i,j,kk-1)
          rkpig(kk) = rkv(i,j,kk)
        enddo
        press0 = press(i,j,1) -  depth(1)*(press(i,j,2) - 
     &                                   press(i,j,1))/height(i,j,2)
        z0 = sfcz0(i,j)
c
c-----Calculate new puff size and fraction of mass that has leaked (DELMS)
c
        if (DXYMAX .gt. 0.) then
          areamx = DXYMAX*DXYMAX
        elseif (DXYMAX .lt. 0.) then
          areamx = MIN(DXYMAX*DXYMAX,dx(j+joff)*dy)
        else
          areamx = dx(j+joff)*dy
        endif
        ldump = .false.
        call piggrow(n,nlay,k,delt,xlen,areamx,
     &               height(i,j,nlay),wind,
     &               tempk(i,j,1),tsurf(i,j),press(i,j,1),press0,rkpig,
     &               depth,z0,hshear,vshear,pufang,shrang,delms,ldump)
c
c-----Skip dumping if it's a new puff
c
        if (lnewg(n) .and. .not.lkill(n)) goto 40
c
c-----Find layers containing top and bottom of puff
c
        kpb = 1       
        kpt = nlay
        do kk = 1,nlay
          if (height(i,j,kk) .GE. pufftop(n)) then
            kpt = kk     
            goto 16
          endif       
        enddo
  16    continue
        do kk = nlay,1,-1
          if (height(i,j,kk) .LE. puffbot(n)) then
            kpb = kk + 1
            goto 17
          endif
        enddo
  17    continue
c
c-----Revise vertical averaging to account for growth; define layer weighting 
c     as the depth of puff coverage weighted by density
c
        if (kpb .eq. kpt) then
          wtfac(kpb) = 1.
        else
          sumwt = 0.
          deplyr = pufftop(n) - height(i,j,kpt-1)
          wtfac(kpt) = deplyr*press(i,j,kpt)/tempk(i,j,kpt)
          sumwt = sumwt + wtfac(kpt)

          deplyr = height(i,j,kpb) - puffbot(n)
          wtfac(kpb)= deplyr*press(i,j,kpb)/tempk(i,j,kpb)
          sumwt = sumwt + wtfac(kpb)
c
          do kk = kpb+1,kpt-1
            deplyr = height(i,j,kk) - height(i,j,kk-1)
            wtfac(kk) = deplyr*press(i,j,kk)/tempk(i,j,kk)
            sumwt = sumwt + wtfac(kk)
          enddo

          do kk = kpb,kpt
            wtfac(kk) = wtfac(kk)/sumwt
          enddo
        endif
c
        do kk = 1,nlay
          deplyr = height(i,j,1)
          if (kk.gt.1) deplyr = height(i,j,kk) - height(i,j,kk-1)
          volvec(kk) = deplyr*dx(j+joff)*dy/mapscl(i,j)**2
          pcvfac(kk) = densfac*(273./tempk(i,j,kk))*
     &                         (press(i,j,kk)/1013.)
        enddo
c
c-----First check for a full dump
c     Slaughter the puff if its horizontal size exceeds AREAMX
c     Slaughter the puff if remaining mass fraction < 0.1
c     Slaughter the puff according to chemistry flags
c
        axisx = xlen + 3.*sigx(n)
        pufscl = pi*(axisx/2.)*(1.5*sigy(n))
c
        if (lkill(n) .OR. pufscl.GT.areamx .OR. fmspig(n).lt.0.1) then
          if (.not.lkill(n)) then
            if (pufscl.gt.areamx) then
              nkill(1) = nkill(1) + 1
            elseif (fmspig(n).lt.0.1) then
              nkill(2) = nkill(2) + 1
            endif
          endif
          ingrd(n) = 0
          ldump = .true.
c
          do is = nrad+1,nspec
            dumpmass(is) = 0.
            do nr = 1,nreactr
              dumpmass(is) = dumpmass(is) + puffmass(is,nr,n)
              puffmass(is,nr,n) = 0.
            enddo
          enddo
          pigage(igrd) = pigage(igrd) + agepigf(n)
          nage(igrd) = nage(igrd) + 1
c
c======================== Source Apportion Begin =======================
c
          if( ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                      tectyp .EQ. RTCMC) ) then
             do is = 1,nrtrac
               rtdump(is) = 0.
               do nr = 1,nreactr
                 rtdump(is) = rtdump(is) + puffrt(is,nr,n)
                 puffrt(is,nr,n) = 0.
               enddo
             enddo
          endif
c
c========================= Source Apportion End ========================
c
          goto 60
        endif
c
c-----If no full dump, check for leakage
c     (LDUMP and DELMS were set in PIGGROW)
c
        if (ldump) then
          do is = nrad+1,nspec
            dumpmass(is) = 0.
            do nr = 1,nreactr
              rctdmp = puffmass(is,nr,n)*delms
              dumpmass(is) = dumpmass(is) + rctdmp
              puffmass(is,nr,n) = puffmass(is,nr,n) - rctdmp
            enddo
          enddo
c
c======================== Source Apportion Begin =======================
c
          if( ltrace .AND. (tectyp .EQ. RTRAC .OR.
     &                      tectyp .EQ. RTCMC) ) then
             do is = 1,nrtrac
               rtdump(is) = 0.
               do nr = 1,nreactr
                 rctdmp = puffrt(is,nr,n)*delms
                 rtdump(is) = rtdump(is) + rctdmp
                 puffrt(is,nr,n) = puffrt(is,nr,n) - rctdmp
               enddo
             enddo
          endif
c
c========================= Source Apportion End ========================
c
        endif
c
c-----Update total dumped mass 
c
 60     if (ldump) then
          do is = nrad+1,nspec
            pigdump(is) = pigdump(is) + DBLE(dumpmass(is))
          enddo
          delconc = 0.0 ! must be initialized
c
c-----Dump DUMPMASS into grid; allocate mass in proportion to layer densities
c     among layers contained within this puff
c
          do 300 is = nrad+1,nspec
            if (dumpmass(is).eq.0.) goto 300
            do kk = kpb,kpt
              volfac = wtfac(kk)/volvec(kk)
              pconc(kk) = conc(i,j,kk,is) + dumpmass(is)*volfac
              if (is.le.ngas) then
                pbdnl(kk) = bdnl(is)*pcvfac(kk)
              else
                pbdnl(kk) = bdnl(is)
              endif
c
c-----Woops! DUMPMASS leads to negative grid concentration
c
              if (pconc(kk) .lt. pbdnl(kk)) then
                tmass = 0.
                bmass = 0.
                tvol = 0.
                do kkk = kpb,kpt
                  tmass = tmass + conc(i,j,kkk,is)*volvec(kkk)
                  tvol  = tvol + volvec(kkk)
                  if (is.le.ngas) then
                    pbdnl(kkk) = bdnl(is)*pcvfac(kkk)
                  else
                    pbdnl(kkk) = bdnl(is)
                  endif
                  bmass = bmass + pbdnl(kkk)*volvec(kkk)
                enddo
                resid = tmass + dumpmass(is)
c
c-----Try spreading any positive residual mass evenly over layers contained 
c     within puff depth (if there is enough grid mass)
c
                if (resid .ge. bmass) then
                  do kkk = kpb,kpt
                    pconc(kkk) = resid/tvol
                  enddo
                  goto 301
c
c-----Not enough grid mass for a postive residual. Set grid conc to lower
c     bound and add negative mass increment to tracking array
c
                else
                  negconc = pconc(kk) - pbdnl(kk)
                  pgmserr(is) = pgmserr(is) + DBLE(negconc*volvec(kk))
                  pconc(kk) = pbdnl(kk)
                endif
              endif
            enddo
 301        do kk = kpb,kpt
              delconc(kk,is) = pconc(kk) - conc(i,j,kk,is)
              conc(i,j,kk,is) = pconc(kk)
c
c======================== Process Analysis Begin ====================================
c
              if( lipr ) then
                if( i .GE. ia .AND. i .LE. iz .AND. j .GE. ja
     &                                         .AND. j .LE. jz ) then
                     if( ipa_cel(i+i0,j+j0,kk) .GT. 0 ) then
                       ipa_idx = ipa_cel(i+i0,j+j0,kk)
                       cipr(IPR_PIGEMIS, ipa_idx, is) =
     &                   cipr(IPR_PIGEMIS, ipa_idx, is) + delconc(kk,is)
                     endif
                endif
              endif
c
c========================= Process Analysis End ================================
c
            enddo
 300      continue
c
c======================== Source Apportion Begin =======================
c
          if( ltrace ) then
c
c-----Update RTRAC tracer concentration in the grid ---
c
            if( tectyp .EQ. RTRAC .OR. tectyp .EQ. RTCMC ) then
              do is = 1,nrtrac
                do kk = kpb,kpt
                  volfac = wtfac(kk)/volvec(kk)
                  idx = DBLE(ipsa3d-1) + DBLE(i) + 
     &               DBLE(m1)*DBLE(j-1) + DBLE(m1)*DBLE(m2)*DBLE(kk-1) + 
     &                            DBLE(m1)*DBLE(m2)*DBLE(nlay)*DBLE(is-1)
                  ptconc(idx) = ptconc(idx) + rtdump(is)*volfac
                enddo
              enddo
c
c-----Call routine to update SA tracer concentration in the grid ---
c
            else
              call pigdumpsa(m1,m2,m3,nrad,nspec,ntotsp,
     &                       i,j,kpb,kpt,n,delconc,ptconc(ipsa3d) )
            endif
          endif
c
c========================= Source Apportion End ========================
c
        endif
c
c-----Reset ldump and set LNEWG to false
c
 40     continue
        ldump = .false.
        lnewg(n) = .false.
c
c-----End GROWTH and DUMPING loop
c
 200  continue
c
      return
      end

      subroutine intrpdat
      use filunit
      use grid
      use camxcom
      use camxfld
      use o3colmap
c
c----CAMx v7.40 260801
c
c     INTRPDAT generates fine grid met data fields from parent grids for those
c     fields not read.  Also determines time-rate of change for all 
c     time-interpolated variables.
c
c      Copyright Ramboll
c
c     Modifications:
c        8/30/02    Modifications for combined cloud/rain file, and to allow
c                   water vapor and cloud/rain files to be read for each nest
c        3/3/04     Added checks for interpolating water fields  
c                   if either chemistry, dry dep or wet dep is on
c       10/12/04    Water vapor and vertical diffusivity fields are now
c                   time-interpolated
c        6/21/05    Added new rain, snow, and graupel fields
c       11/04/09    Removed setting nest grid boundary winds from parent
c       01/04/11    Revised for new met input format
c       04/02/12    Removed RADM cloud adjustment option, cloud/aerosol
c                   adjustments now always done with in-line TUV;
c       11/05/12    Removed vertical nesting
c       08/08/14    Added new snow cover input fields
c
c     Input arguments:
c        none
c
c     Output arguments:
c        none
c
c     Subroutine called:
c        INTERP2D
c        FINWIND
c        TIMRATES
c
c     Called by:
c        TSTEP_INIT
c
      implicit none
      include "camx.prm"
      include "flags.inc"
c
      integer ip,ic,igrd
c
c-----Entry point
c
      do 100 ip = 1,ngrid
        do 99 ic = 1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          if (i3dmet(igrd).eq.0) then
c
c-----Vertical grid structure
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Assigning heights from parent grid',
     &                             time, date,' grid',igrd
            call rassgn3d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    hnxt(iptr3d(ip)),hnxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                    height(iptr3d(igrd)),hnxt(iptr3d(igrd)),
     &                    phpt(iptr3d(igrd)))
c
c-----Wind field
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating winds from parent grid',
     &                             time, date,' grid',igrd
            call finwind(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                 j1(igrd),nmesh(igrd),ncol(igrd),
     &                 nrow(igrd),nlay(igrd),unxt(iptr3d(ip)),
     &                 vnxt(iptr3d(ip)),
     &                 unxt(iptr3d(igrd)),vnxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                  windu(iptr3d(igrd)),unxt(iptr3d(igrd)),
     &                  pupt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                  windv(iptr3d(igrd)),vnxt(iptr3d(igrd)),
     &                  pvpt(iptr3d(igrd)))
c
c-----Pressure
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating pressure from parent grid',
     &                             time, date,' grid',igrd
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    pnxt(iptr3d(ip)),pnxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                    press(iptr3d(igrd)),pnxt(iptr3d(igrd)),
     &                    pppt(iptr3d(igrd)))
c
c-----Temperature
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating temps from parent grid',
     &                             time, date,' grid',igrd
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    tnxt(iptr3d(ip)),tnxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                    tempk(iptr3d(igrd)),tnxt(iptr3d(igrd)),
     &                    ptpt(iptr3d(igrd)) )
c
c-----Water vapor
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating humidity from parent grid',
     &                                  time, date,' grid',igrd
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                    j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    wnxt(iptr3d(ip)),wnxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                    water(iptr3d(igrd)),wnxt(iptr3d(igrd)),
     &                    pwpt(iptr3d(igrd)) )
          endif
c
c-----Vertical diffusion coefficient
c
          if (ikv(igrd).eq.0) then
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating VDiff from parent grid',
     &                             time, date,' grid',igrd
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    knxt(iptr3d(ip)),knxt(iptr3d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),nlay(igrd),
     &                    rkv(iptr3d(igrd)),knxt(iptr3d(igrd)),
     &                    pkpt(iptr3d(igrd)))
          endif
c
c-----Surface temperature
c
          if (i2dmet(igrd).eq.0) then
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating sfc temp from parent grid',
     &                             time, date,' grid',igrd
            call interp2d(ncol(ip),nrow(ip),1,i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    tsnxt(iptr2d(ip)),tsnxt(iptr2d(igrd)) )
            call timrates(ncol(igrd),nrow(igrd),1,
     &                    tsurf(iptr2d(igrd)),tsnxt(iptr2d(igrd)),
     &                    pspt(iptr2d(igrd)) )
c
c----Snow cover
c
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                'Assigning snowcover from parent grid',
     &                                  time, date,' grid',igrd
            call rassgn2d(ncol(ip),nrow(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    snow(iptr2d(ip)),snow(iptr2d(igrd)))
            call rassgn2d(ncol(ip),nrow(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    snowage(iptr2d(ip)),snowage(iptr2d(igrd)))
            call rassgn2d(ncol(ip),nrow(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    snowrat(iptr2d(ip)),snowrat(iptr2d(igrd)))
          endif
c
c-----Cloud/rain
c
          if (.NOT. is_netcdf_i3dmet(igrd) .and. icld(igrd).eq.0) then
            write(iout,'(a40,f7.0,i8.5,a,i3)')
     &                 'Interpolating clouds from parent grid',
     &                             time, date,' grid',igrd
            call rassgn3d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),j1(igrd),
     &                    nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    cod(iptr3d(ip)),cod(iptr3d(igrd)) )
c
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                    j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    cwc(iptr3d(ip)),cwc(iptr3d(igrd)) )
c
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                    j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    pwr(iptr3d(ip)),pwr(iptr3d(igrd)) )
c
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                    j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    pws(iptr3d(ip)),pws(iptr3d(igrd)) )
c
            call interp2d(ncol(ip),nrow(ip),nlay(ip),i1(igrd),
     &                    j1(igrd),nmesh(igrd),ncol(igrd),nrow(igrd),
     &                    pwg(iptr3d(ip)),pwg(iptr3d(igrd)) )
          endif
c
  99    continue
 100  continue
c
      return
      end

      subroutine timestep()
      use grid
      use bndary
      use camxfld
      use camxcom
      use pigsty
c
c----CAMx v7.40 260801
c
c     TIMESTEP computes the time step size for each grid 
c
c      Copyright Ramboll
c
c     Modifications:
c        11/30/99  Removed timestep calculation for horizontal diffusion
c        1/25/02   Revised I/O frequencies and max time step to minutes,
c                  added code to check winds at next update time to ensure
c                  CFL stability throughout period
c        4/10/03   Now calculating max timestep by layer, AND
c                  DTMAX moved from control file to parameter defined here
c        10/12/04  Added determination of finest grid timestep for PiG
c                  initialization and transport
c
c     Input arguments:
c        none
c
c     Output Arguments:
c        none
c
c     Routines called:
c        GETDELT
c
c     Called by:
c        TSTEP_INIT
c
      implicit none
      include "camx.prm"
c
      integer igrd,kmax,k,nsteps,ip,ic,n
      real dtmx,dtio,dtmin
      real dtmx1(MXLAYER)
      real dtmx2(MXLAYER)
      real dtlay(MXLAYER)
c
c-----Entry point
c
c-----Coarse grid: maximum time step size according to stability criterion
c
      igrd = 1
      call getdelt(ncol(1),nrow(1),nlay(1),deltax(1,1),deltay(1),
     &             windu(1),windv(1),height(1),mapscl(1),dtmx1,kmax)
      call getdelt(ncol(1),nrow(1),nlay(1),deltax(1,1),deltay(1),
     &             unxt(1),vnxt(1),hnxt(1),mapscl(1),dtmx2,kmax)
c
c-----Make sure an integer number of coarse grid time steps are to be
c     completed each hour and between I/O times
c
      dtio = 60.*amin1(60.,dtinp,dtems,dtout)
      dtmx = dtio
     
      do k = 1,nlay(1)
        dtlay(k) = amin1(dtmx1(k),dtmx2(k),dtio,60.*dtmax)
        if (k.le.kmax) dtmx = amin1(dtmx,dtlay(k))
      enddo
      nsteps = INT( 0.999*dtio/dtmx ) + 1
      deltat(1) = dtio/FLOAT( nsteps )
c
c-----Number of advection steps per layer in coarse grid
c
      do k = 1,nlay(1)
        nadv(k,1) = INT( 0.999*deltat(1)/dtlay(k) ) + 1
      enddo
c
c-----Fine grids: make sure an integer number of fine grid time steps 
c     are to be completed between coarser grid steps
c
      ntimcrs(1) = 1
      do ip = 1,ngrid
        do ic = 1,nchdrn(ip)
          igrd = idchdrn(ic,ip)
          call getdelt(ncol(igrd),nrow(igrd),nlay(igrd),
     &                 deltax(1,igrd),deltay(igrd),windu(iptr3d(igrd)),
     &                 windv(iptr3d(igrd)),height(iptr3d(igrd)),
     &                 mapscl(iptr2d(igrd)),dtmx1,kmax)
          call getdelt(ncol(igrd),nrow(igrd),nlay(igrd),
     &                 deltax(1,igrd),deltay(igrd),unxt(iptr3d(igrd)),
     &                 vnxt(iptr3d(igrd)),hnxt(iptr3d(igrd)),
     &                 mapscl(iptr2d(igrd)),dtmx2,kmax)
          dtmx = deltat(ip)
          do k = 1,nlay(igrd)
            dtlay(k) = amin1(dtmx1(k),dtmx2(k),deltat(ip))
            if (k.le.kmax) dtmx = amin1(dtmx,dtlay(k))
          enddo
          ntim(igrd) = INT( 0.999*deltat(ip)/dtmx ) + 1
          ntimcrs(igrd) = ntim(igrd)*ntimcrs(ip)
          deltat(igrd) = deltat(ip)/FLOAT( ntim(igrd) )
c
c-----Number of advection steps per layer in this fine grid
c
          do k = 1,nlay(igrd)
            nadv(k,igrd) = INT( 0.999*deltat(igrd)/dtlay(k) ) + 1
          enddo
c
        enddo
      enddo
c
c-----Determine which grid has the smallest timestep for PiG
 
c
      dtmin = 3600.
      do n = 1,ngrid
        if (deltat(n).lt.dtmin) then
          dtmin = deltat(n)
          ipigint = n
        endif
      enddo
c
      return
      end

      subroutine ncf_rdpthdr(begtim,begdate,endtim,enddate)
      use filunit
      use ptemiss
      use tracer
      use chmstry
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     NCF_RDPTHDR reads the header information from the global section
c     of the NetCDF point source file and checks for consistency with 
c     model simulation.
c
c      Copyright Ramboll
c
c      Argument description:
c       Inputs:
c         begtim  R model begin time
c         begdat  I model begin date (YYJJJ)
c         endtim  R model end time
c         enddate I model end date (YYJJJ)
c       Outputs:
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     02/20/17   --gwilson--    Original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declarations:
c-----------------------------------------------------------------------
c
      real    begtim
      integer begdate
      real    endtim
      integer enddate
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action, fname
      character*10  pntfil, name_in, this_var
      integer       this_dimid, idxfile, ierr, this_varid, tmpmap(MXSPEC)
      integer       i
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data pntfil /'PTSOURCE  '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c   --- loop over number of files ---
c
      do idxfile=1,npoint_files
         if( .NOT. is_netcdf_iptem(idxfile) ) cycle
         write(action,'(A,I3,A)') 'Reading the NetCDF point source file ',idxfile,' '
         write(fname,'(A,I6)') 'PTSOURCE -- UNIT ',iptem(idxfile)
         nptspc(idxfile) = MXSPEC
c
c --- get the type of file to make sure it is a point source file ---
c
         this_var = 'CAMx_NAME'
         ierr = nf_get_att_text(iptem(idxfile), NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) then
            this_var = 'NAME'
            ierr = nf_get_att_text(iptem(idxfile), NF_GLOBAL, this_var, name_in)
            if( ierr .NE. NF_NOERR ) goto 7007
         endif
         if( name_in(:8) .NE. pntfil(:8) ) goto 7001
c
c --- call routine to make sure file spans the episode ---
c
         call ncf_chk_tstep(iptem(idxfile),action,begdate,begtim,
     &                                        enddate,endtim,le1day)
c
c --- call routine to setup species mappping array ---
c
         call ncf_set_emiss_mapping(iptem(idxfile),action)
c
c --- get the number of points (used as dimension for columns) ---
c
         ierr = nf_inq_dimid(iptem(idxfile), "COL", this_dimid )
         if( ierr .NE. NF_NOERR ) goto 7002
         ierr = nf_inq_dimlen(iptem(idxfile),this_dimid, 
     &                                    nptsrc_files(idxfile))
         if( ierr .NE. NF_NOERR ) goto 7002
c
      enddo
c
c-----------------------------------------------------------------------
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get necessary global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',pntfil(:istrln(pntfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension value for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7006 continue
      write(iout,'(//,a)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7007 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDPTHDR:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

      subroutine paconv(m1,m2,m3,dt,ncol,nrow,nlay,nspav,nspc,lspmap,
     &                                   lgassp,tempk,press,ipa_cel)
      use chmstry
      use bndary
      use camxcom
      use procan
      use rtracchm
      use tracer
      use node_mod
c
c----CAMx v7.40 260801
c
c     This routine calculates and stores the concentration conversion 
c     factor and stores it in the process analysis array.
c     
c      Copyright Ramboll
c
c     Modifications: 
c
c     Input arguments:
c        dt                 time step for present grid concentration (s)
c        ncol               number of columns
c        nrow               number of rows
c        nlay               number of layers in instantaneous array
c        nspav              number of average species
c        nspc               number of species in conc array
c        lspmap             mapping array for average species
c        lgassp             true if species is gas
c        tempk              temperature field (K)
c        press              pressure field (mb)
c        ipa_cel            gridded array to identify if cell is
c                            in a IPRM sub-domain
c
c     Output arguments:
c                                                          other=ug/m3)
c
c     Routines Called:
c        none
c
c     Called by:
c        AVGALL
c        FGAVRG
c
      include "camx.prm"
      include "flags.inc"
 
      integer m1,m2,m3
c
c========================= Process Analysis Begin ==============================
c
      integer ipa_cel(ncol,nrow,nlay)
c
c========================= Process Analysis End ==============================
c
      logical lgassp(nspc)
      real    tempk(m1,m2,m3),press(m1,m2,m3)
      integer lspmap(*)
c
c-----Entry point
c
c-----Increment running average
c
      dtfact = dt/(dtout*60.)
      do 40 l = 1,nspav
        lsp = lspmap(l) 
        convfac = 1.
        if( .NOT. lgas_out_ppm .AND. lgassp(lsp) ) convfac = mole_weight(lsp)
        do j = 2,m2-1
          do i = 2,m1-1
c
            do k=1,nlay
               if( lgassp(lsp) .AND. lgas_out_ppm ) then
                   tmp = 273./tempk(i,j,k)*press(i,j,k)/1013.
                   convfac = 1./(densfac*tmp)
               endif
               if( i .GE. ia .and. i .LE. iz .AND.      
     &                           j .GE. ja .AND. j .LE. jz ) then
                    if( ipa_cel(i+i0,j+j0,k) .GT. 0 ) then
                           ipa_idx = ipa_cel(i+i0,j+j0,k) 
c
c-----Save the units conversion factor for use in IPR post-processing
c
                           cipr(IPR_CONV, ipa_idx, lsp) = 
     &                             cipr(IPR_CONV, ipa_idx, lsp)
     &                                           + convfac * dtfact
                    endif
              endif
            enddo
          enddo
        enddo
  40  continue
c
      return
      end

      subroutine rd_sa_bcfile( )
      use tracer
      use grid
      use camxfld
      use filunit
      implicit none
c 
c----CAMx v7.40 260801
c 
c     RD_SA_BCFILE reads and cycles through the source apportionment BC
c     file to the current time/date, and loads coarse grid boundary 
c     concentrations. The first time it reads the through the header
c     records to get to the first hour.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
      include 'camx.inc'
c
c     Argument delcarations:
c
c     Local Variables
c
      character*10 spcname
      integer      idat1, idat2, ncells, nz, i, j, k, lbc, itr, n
      integer      nc, idum, iedge, n3d, n4d
      real         tim1, tim2, convfac
c
      real,        allocatable, dimension(:,:,:,:) :: bctmp
      character*4, allocatable, dimension(:,:)     :: bcspec
c
c-----Entry point
c
      ncells = MAX(ncol(1),nrow(1))
      nz = nlay(1)
      allocate( bctmp(ncells,nz,4,num_iorbc) )
      allocate( bcspec(10,num_iorbc) )
c
c-----If this is the first time, read through the header records ---
c
      if( lrd_sa_bc_hdr ) then
        lrd_sa_bc_hdr = .FALSE.
        rewind(iorbc)
        do i=1,8
          read(iorbc)
        enddo
      endif
c
c-----Read through coarse grid concentration records until current time/date
c
 100  read(iorbc,end=900) idat1,tim1,idat2,tim2
      if (INT(tim2) .EQ. 24) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      do lbc = 1,num_iorbc
        do n = 1,4
          nc = nrow(1)
          if (n.gt.2) nc = ncol(1)
          read(iorbc) idum,(bcspec(j,lbc),j=1,10),iedge,
     &              ((bctmp(i,k,n,lbc),k=1,nz),i=1,nc) 
        enddo
      enddo
      write(iout,'(a40,2(f7.0,i8.5))')
     &  'Read SA boundary condition file at ',tim1,idat1,tim2,idat2
      call flush(iout)
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.gt.time))) then
c
c-----Load boundary concentrations; convert gasses from ppm to umol/m3,
c     PM stays at ug/m3
c
        do lbc = 1,num_iorbc
          write(spcname,'(10A1)') (bcspec(i,lbc),i=1,10)
          do itr = 1,ntotsp
             if( spcname .NE. ptname(itr) ) cycle
             do k = 1,nz
                do j = 2,nrow(1)-1
                  i = 1
                  n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
                  n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
                  if( lsagas(itr) ) then
                    convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                  else
                    convfac = 1.
                  endif
                  ptconc(n4d) = MAX(BNDLPT,bctmp(j,k,1,lbc))*convfac
                  i = ncol(1)
                  n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1)
                  n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
                  if( lsagas(itr) ) then
                    convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                  else
                    convfac = 1.
                  endif
                  ptconc(n4d) = MAX(BNDLPT,bctmp(j,k,2,lbc))*convfac
                enddo
c
                do i = 2,ncol(1)-1
                  j = 1
                  n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
                  n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
                  if( lsagas(itr) ) then
                    convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                  else
                    convfac = 1.
                  endif
                  ptconc(n4d) = MAX(BNDLPT,bctmp(i,k,3,lbc))*convfac
c
                  j = nrow(1)
                  n3d = i + ncol(1)*(j - 1) + ncol(1)*nrow(1)*(k - 1) 
                  n4d = n3d + ncol(1)*nrow(1)*nlay(1)*(itr - 1)
                  if( lsagas(itr) ) then
                    convfac = densfac*273./tempk(n3d)*press(n3d)/1013.
                  else
                    convfac = 1.
                  endif
                  ptconc(n4d) = MAX(BNDLPT,bctmp(i,k,4,lbc))*convfac
                enddo
             enddo
           enddo
        enddo
        goto 999
      else
        goto 100
      endif
c
c-----Set next boundary update time
c
      sa_bndtim = tim2
      sa_bnddate = idat2
c
c-----End of BC file reached
c
 900  continue
      write(iout,'(//,a)') 'ERROR in RD_SA_BCFILE :'
      write(iout,*)'Premature End of source apportionment BC file reached.'
      write(iout,*)'Make sure boundary file contains simulation ',
     &                                               'time period.'
      call camxerr()
c
 999  continue
c
c  --- dealocate the local array ---
c
      deallocate( bctmp )
      deallocate( bcspec )
      return
      end

*** NCF_EMPREPRT
c
      subroutine ncf_empreprt(igrid,begtim,begdate,endtim,enddate,buffer_offset)
      use ptemiss
      use grid
      use tracer
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine reads the emissions files for the RTRAC and moves the 
c   file pointer to the first hour to be used in this run.
c
c      Copyright Ramboll
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c      09/09/19   --gwilson-- original development
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer igrid
      real    begtim
      integer begdate
      real    endtim
      integer enddate
      integer buffer_offset
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
c
c-----------------------------------------------------------------------
c    Local parameters:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action, fname
      character*10  emfil, pntfil, name_in, this_var
      integer       ierr, iounit, this_dimid, this_varid, ipt
      integer       idxpt_base, igrd, ii, jj, numpts
      logical       lno_buffer_cells
c
      real,    allocatable, dimension(:) :: xlocin
      real,    allocatable, dimension(:) :: ylocin
      real,    allocatable, dimension(:) :: hstkin
      real,    allocatable, dimension(:) :: dstkin
      real,    allocatable, dimension(:) :: tstkin
      real,    allocatable, dimension(:) :: vstkin
      real,    allocatable, dimension(:) :: iarray
c
c-----------------------------------------------------------------------
c    Data statments:
c-----------------------------------------------------------------------
c
      data emfil /'EMISSIONS '/
      data pntfil /'PTSOURCE  '/
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c
c   --- only read if surface emissions file is supplied ---
c
      if( .NOT. is_netcdf_iortem(igrid,1,1) ) goto 111
      if( .NOT. ltemfl(igrid,1,1) ) goto 111
      if( .NOT. larsrc ) goto 111

      iounit = iortem(igrid,1,1)
      fname = temfil(igrid,1,1)
      write(action,'(2A,I3)') 'Reading the NetCDF gridded RTRAC emissions ',
     &                                              'file for grid: ',igrid
c
c --- get the type of file to make sure it is a emissions file ---
c
      this_var = 'CAMx_NAME'
      name_in = ' '
      ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7006
      endif
      if( name_in(:9) .NE. emfil(:9) ) goto 7001
c
c --- call routine to make sure grid defintion is consistent ---
c
      lno_buffer_cells = .TRUE.
      if( igrd .EQ. 1 ) lno_buffer_cells = .FALSE.
      call ncf_chk_griddef(iounit,action,igrid,.FALSE.,.TRUE.,
     &                         lno_buffer_cells,.FALSE.,buffer_offset)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iounit,action,begdate,begtim,enddate,endtim,le1day)
c
c   --- only read if elevated point source emissions file is supplied ---
c
  111 continue
      if( .NOT. is_netcdf_iortpt(1,1) ) goto 9999
      if( .NOT. ltptfl(1,1) ) goto 9999
      if( .NOT. lptsrc ) goto 9999
c
c   --- process the file ----
c
      action = 'Reading NetCDF point source file for RTRAC.'
      iounit = iortpt(1,1)
      fname = tptfil(1,1)
c
c --- get the type of file to make sure it is a point source file ---
c
      this_var = 'CAMx_NAME'
      name_in = ' '
      ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(iounit, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7000
      endif
      if( name_in(:istrln(name_in)) .NE. pntfil(:istrln(pntfil)) ) goto 7003
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(iounit,action,begdate,begtim,
     &                                        enddate,endtim,le1day)
c
c --- get the number of points (used as dimension for columns) ---
c
      ierr = nf_inq_dimid(iounit, "COL", this_dimid )
      if( ierr .NE. NF_NOERR ) goto 7002
      ierr = nf_inq_dimlen(iounit,this_dimid,
     &                                    nptsrc_safile(1,1))
      if( ierr .NE. NF_NOERR ) goto 7002
      numpts = nptsrc - nptsrc_safile(1,1)
c
c  --- allocate the local arrays ---
c
      allocate( xlocin(nptsrc_safile(1,1)) )
      allocate( ylocin(nptsrc_safile(1,1)) )
      allocate( hstkin(nptsrc_safile(1,1)) )
      allocate( dstkin(nptsrc_safile(1,1)) )
      allocate( tstkin(nptsrc_safile(1,1)) )
      allocate( vstkin(nptsrc_safile(1,1)) )
      allocate( iarray(nptsrc_safile(1,1)) )
c
      this_var = "xcoord"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,xlocin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
      this_var = "ycoord"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,ylocin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
c --- get pig flag ---
c
      this_var = "pigflag"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_int(iounit,this_varid,iarray)
      if( ierr .NE. NF_NOERR ) goto 7005
c
      this_var = "stkheight"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,hstkin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
      this_var = "stkdiam"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,dstkin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
      this_var = "stktemp"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,tstkin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
      this_var = "stkspeed"
      ierr = nf_inq_varid(iounit,this_var,this_varid)
      if( ierr .NE. NF_NOERR ) goto 7004
      ierr = nf_get_var_real(iounit,this_varid,vstkin)
      if( ierr .NE. NF_NOERR ) goto 7005
c
c  --- make sure this source is in the base inventory and flag it ---
c
      do ipt=1,nptsrc_safile(1,1)
          vstkin(ipt) = vstkin(ipt)/3600.
          numpts = numpts + 1 
          if (llatlon) then
            xstk(numpts,1) = xlocin(ipt) - xorg
            ystk(numpts,1) = ylocin(ipt) - yorg
          else
            xstk(numpts,1) = xlocin(ipt)/1000. - xorg
            ystk(numpts,1) = ylocin(ipt)/1000. - yorg
          endif
          do igrd = 2,ngrid
             xstk(numpts,igrd) = xstk(numpts,1) - (inst1(igrd) - 1)*delx
             ystk(numpts,igrd) = ystk(numpts,1) - (jnst1(igrd) - 1)*dely
             ii = 2 + FLOOR(xstk(numpts,igrd)/delx*FLOAT( meshold(igrd) ) )
             jj = 2 + FLOOR(ystk(numpts,igrd)/dely*FLOAT( meshold(igrd) ) )
             if (ii.gt.1 .and. ii.lt.ncol(igrd) .and.
     &                    jj.gt.1 .and. jj.lt.nrow(igrd)) then
                nosrc(igrd) = nosrc(igrd) + 1
                idsrc(nosrc(igrd),igrd) = numpts
                isrc(nosrc(igrd),igrd) = ii
                jsrc(nosrc(igrd),igrd) = jj
             endif
          enddo
          xloc(numpts) = xlocin(ipt)
          yloc(numpts) = ylocin(ipt)
          xlocpt(numpts) = xlocin(ipt)
          ylocpt(numpts) = ylocin(ipt)
          hstk(numpts) = hstkin(ipt)
          dstk(numpts) = ABS(dstkin(ipt))
          tstk(numpts) = tstkin(ipt)
          vstk(numpts) = vstkin(ipt)
          lpiglet(numpts) = .FALSE.
          idx_point_in_list(1,1,ipt) = numpts
          if( iarray(ipt) .GT. 0 ) lpiglet(numpts) = .TRUE.
      enddo
c
c  --- deallocate the local arrays ---
c
      deallocate( xlocin )
      deallocate( ylocin )
      deallocate( hstkin )
      deallocate( dstkin )
      deallocate( tstkin )
      deallocate( vstkin )
      deallocate( iarray )
c
c  ---- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot get necessary global attribute: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',emfil(:istrln(emfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Cannot find the dimension id for number ',
     &                                      'of point sources (NCOL)'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(A)') 'Input file is not the correct type.'
      write(iout,'(2A)') 'Looking for type: ',pntfil(:istrln(emfil))
      write(iout,'(2A)') 'Found in file   : ',name_in(:istrln(name_in))
      call camxerr()
c
 7004 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot find variable id for: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7005 continue
      write(iout,'(//,a)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Cannot read data for variable: ',
     &                                      this_var(:istrln(this_var))
      write(iout,'(1X,2A)') 'File: ',fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7006 continue
      write(iout,'(//,A)') 'ERROR in NCF_EMPREPRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end

      subroutine getznth(lat,lon,time,date,itzon,zenith,ldark)
c
c----CAMx v7.40 260801
c
c     GETZNTH calculates solar zenith and sets the darkness flag
c
c     Based on equations given by Paltridge and Platt [1976]
c        "Radiative Processes in Meteorology and Climatology",
c         Elsevier, pp. 62,63.
c     Fourier coefficients originally from:
c        Spencer, J.W., 1971, Fourier series representation of the position 
c        of the sun, Search, 2:172.
c     NOTE: this approximate program has no changes from year to year.
c
c      Copyright Ramboll
c
c     Modifications:
c        none
c
c     Input arguments:
c        lat                 latitude (deg) 
c        lon                 longitude (deg)
c        time                Current simulation time (HHMM)
c        date                Current simulaiton date (YYJJJ)
c        itzon               Model time zone (5=EST,6=CST,7=MST,8=PST)
c
c     Output arguments: 
c        zenith              solar zenith angle (90 if zenith > 88)
c        ldark                darkness flag
c
c     Routines Called:
c        none
c
c     Called by:
c        CHEMDRIV
c        DRYDEP
c
      implicit none

      real pi,dr
      parameter (pi=3.14159265) 
      parameter (dr=pi/180.0)
c
      real lat,lon,time,zenith
      integer date,itzon
      real ut,lbut,lzut
      real rlt
      real d, tz, rdecl, eqr, eqh, zpt
      real csz, zr
      real sintz, costz, sin2tz, cos2tz, sin3tz, cos3tz
      integer iyear, ijd
      logical ldark
c
c-----Entry point
c
c-----Convert to radians
c
      rlt = lat*dr
c
c-----Parse date and convert date and time to Greenwich
c
      iyear = date/1000
      ijd   = mod(date,1000)
      ut = aint(time/100.) + amod(time,100.)/60. + float(itzon)
      if (ut .ge. 24.) then
        ut = ut - 24.
        ijd = ijd + 1
        if ((ijd.gt.365 .and. mod(iyear,4).ne.0) .or.
     &      (ijd.gt.366 .and. mod(iyear,4).eq.0)) ijd = 1
      endif
c
c-----Calculate decimal Julian day from start of year:
c
      d = float(ijd-1) + ut/24.
c
c-----Equation 3.8 for "day-angle"
c
      tz = 2.*pi*d/365.
c
c-----Calculate sine and cosine from addition theoremes for 
c     better performance;  the computation of sin2tz,
c     sin3tz, cos2tz and cos3tz is about 5-6 times faster
c     than the evaluation of the intrinsic functions 
c
c     It is SIN(x+y) = SIN(x)*COS(y)+COS(x)*SIN(y)
c     and   COS(x+y) = COS(x)*COS(y)-SIN(x)*SIN(y)
c
c     sintz  = SIN(tz)      costz  = COS(tz)
c     sin2tz = SIN(2.*tz)   cos2tz = SIN(2.*tz)
c     sin3tz = SIN(3.*tz)   cos3tz = COS(3.*tz)
c
      sintz = SIN(tz)
      costz = COS(tz)
      sin2tz = 2.*sintz*costz
      cos2tz = costz*costz-sintz*sintz
      sin3tz = sintz*cos2tz + costz*sin2tz
      cos3tz = costz*cos2tz - sintz*sin2tz
c
c----Equation 3.7 for declination in radians
c
      rdecl = 0.006918 - 0.399912*costz  + 0.070257*sintz 
     &                 - 0.006758*cos2tz + 0.000907*sin2tz    
     &                 - 0.002697*cos3tz + 0.001480*sin3tz
c
c-----Equation 3.11 for Equation of time  in radians
c
      eqr   = 0.000075 + 0.001868*costz  - 0.032077*sintz
     $		       - 0.014615*cos2tz - 0.040849*sin2tz
c
c-----Convert equation of time to hours:
c
      eqh = eqr*24./(2.*pi) 
c
c-----Calculate local hour angle (hours):
c
      lbut = 12. - eqh - lon*24./360 
c
c-----Convert to angle from UT
c
      lzut = 15.*(ut - lbut)
      zpt = lzut*dr
c
c-----Equation 2.4 for cosine of zenith angle 
c
      csz = sin(rlt)*sin(rdecl) + cos(rlt)*cos(rdecl)*cos(zpt)
      csz = MAX(MIN(csz,1.0),-1.0)
      zr = acos(csz)
      zenith = zr/dr
      ldark = .false.
      if (zenith.gt.88.) then
        zenith = 90.
        ldark = .true.
      endif
c
      return
      end

      subroutine rdsumbc(idtnow,timnow,jdlast,ttlast,
     &                                   ncolx,nrowy,nlays,consum)
      use filunit
      use grid
      use chmstry
      use bndary
      use camxcom
      use tracer
c
c      Copyright Ramboll
c
c
c----CAMx v7.40 260801
c
c     11/20/03   --gwilson--    Fixed bug when using the species map
c                               to get the index of modeled species
c     11/02/05   --gwilson--    Added common block for large local
c                               arrays that were causing segfault in
c                               OMP mode.
c     10/28/09   --gwilson--    Made the large local arrays
c                               allocatable to avoid memory issues
c     11/4/09    -cemery-       Removed input top concentrations
c     01/4/11    -cemery-       Revised for new met input format
c
c
      include 'camx.prm'
c
      character*4 iname(10)
      character*4 fname(10),note(60)
      character*10 filnote
      real        consum(MXSPEC,0:IDXBTP)
      logical     lfound,lfrst
      integer     ncola, nrowa, nlaya
      integer     nvar
c
      real, allocatable, dimension(:) :: height
      real, allocatable, dimension(:) :: depth

      real conwst(MXLAYER,MXCELLS)
      real conest(MXLAYER,MXCELLS)
      real consth(MXLAYER,MXCELLS)
      real connth(MXLAYER,MXCELLS)
c
c---- Entry point ---
c
c  --- allocate the local arrays ---
c
      ncola = maxval( ncol(1:ngrid) )
      nrowa = maxval( nrow(1:ngrid) )
      nlaya = maxval( nlay(1:ngrid) )
      allocate( height(ncola*nrowa*nspec) )
      allocate( depth(ncola*nrowa*nspec) )
c
      ibgdhp = 0
      btimhp = 0 
      ibegbc = 0
      btimbc = 0.
      iendbc = 0
      etimbc = 0.
c
c   --- initialize the array to zero ---
c
      do i=1,nspec
        do j=0,IDXBTP 
          consum(i,j) = 0.
        enddo
      enddo
c
c   --- read the 3D met file to get the layer heights ----
c
      if( .NOT. is_netcdf_i3dmet(1) ) then
         rewind(i3dmet(1))
         read(i3dmet(1),ERR=7001) fname,note,idum,nvar
         write(filnote,'(10a1)') (note(n),n=1,10)
         if (filnote.ne.'3DMET     ') then
           write(iout,'(//,a)') 'ERROR in RDSUMBC:'
           write(iout,*) 'Mismatch in file type.'
           write(iout,*) 'File is:'
           write(iout,*) filnote
           write(iout,*) 'Expecting:'
           write(iout,*) '3DMET'
           write(iout,*)
           call camxerr()
         endif
         do n = 1,3
           read(i3dmet(1),ERR=7001)
         enddo
      endif
c
  333 continue
      if( is_netcdf_i3dmet(1) ) then
         call ncf_getdepth(nvar,ncolx,nrowy,nlays,ibgdhp,idtnow,btimhp,timnow,
     &              i3dmet(1),height,depth)
      else
         call getdepth(nvar,ncolx,nrowy,nlays,ibgdhp,idtnow,btimhp,timnow,
     &              i3dmet(1),height,depth)
      endif
c
c   --- read boundary conditions for this hour ----
c
      read(ibc,ERR=7002) ibegbc, btimbc, iendbc, etimbc
      lfound = .TRUE.
      if( ibegbc .EQ. idtnow .AND. btimbc .GT. timnow ) lfound = .FALSE.
      if( btimbc .EQ. 0. ) then
         ibegbc = ibegbc - 1
         btimbc = 24.0
      endif
      if( etimbc .EQ. 0. ) then
         iendbc = iendbc - 1
         etimbc = 24.0
      endif
      if( ibegbc .EQ. idtnow .AND. etimbc .LT. timnow ) lfound = .FALSE.
      if( ibegbc .EQ. idtnow .AND. iendbc .GT. idtnow ) lfound = .TRUE.
      if( ibegbc .GT. idtnow ) lfound = .FALSE.
      do 70 ispc=1,nbcspc
          read(ibc,ERR=7002,END=7003) iseg, (iname(i),i=1,10), iedge,
     &                         ((conwst(izcl,j),izcl=1,nlays),j=1,nrowy)
          read(ibc,ERR=7002,END=7003) iseg, (iname(i),i=1,10), iedge,
     &                         ((conest(izcl,j),izcl=1,nlays),j=1,nrowy)
          read(ibc,ERR=7002,END=7003) iseg, (iname(i),i=1,10), iedge,
     &                         ((consth(izcl,i),izcl=1,nlays),i=1,ncolx)
          read(ibc,ERR=7002,END=7003) iseg, (iname(i),i=1,10), iedge,
     &                         ((connth(izcl,i),izcl=1,nlays),i=1,ncolx)
c
c   --- if record does not span this hour, skip it ----
c
          if( .NOT. lfound ) goto 70
c
c   --- if the species is a not modelled or not a VOC species skip it ---
c
          idx = 0
          do i=1,nspec
            if( lbcmap(i) .EQ. ispc ) idx = i
          enddo
          if( idx .LE. 0 ) goto 70
          if( .NOT. (lvocsp(idx) .OR. lvocsoa(idx)) ) goto 70
          call sumwt4(idx,ncolx,nrowy,nlays,depth,conwst,conest,
     &                                          consth,connth,consum)
c
c   --- if record does not span this hour, skip it ----
c
c   --- next species ---
c
   70 continue
c
c   --- chack date and time, if it is still in the episode
c       go back to read the next hour ----
c
      if( lfound ) then
         timnow = timnow + 1.0
         if( timnow .GT. 24.0 ) then
             idtnow = idtnow + 1
             timnow = 0.0
             if( MOD(idtnow,1000) .GT. 365 ) then
                if( MOD(INT(idtnow/1000),4) .EQ. 0 ) then
                   if( MOD(idtnow,1000) .EQ. 367 )
     &                     idtnow = (INT(idtnow/1000)+1)*1000 + 1
                else
                   idtnow = (INT(idtnow/1000)+1)*1000 + 1
                endif
             endif
         endif
      endif
      if( idtnow .GT. jdlast .OR. 
     &          (idtnow .EQ. jdlast .AND. timnow .GE. ttlast) ) goto 444
c
c  --- check if we need to back up the boundary conditions file, that is
c      does the record just read contain this hour ----
c
      if( idtnow .LT. iendbc .OR. 
     &           (idtnow .EQ. iendbc .AND.  timnow .LT. etimbc ) ) then
         do 81 i=1,nbcspc*4
            backspace(ibc)
   81    continue
         backspace(ibc)
      endif
c
c  --- process next hour ----
c
      goto 333
c
c  --- all concentrations are summed, return ---
c
  444 continue
c
c  --- deallocate the local arrays ---
c
      deallocate( height )
      deallocate( depth )
c
      ibgdhp = 0
c
c   ---- rewind files to be used again by the regular model ---
c
      rewind(ibc)
      rewind(i3dmet(1))
      return
c
 7001 continue
      write(iout,'(//,a)') 'ERROR in RDSUMBC:'
      write(iout,'(/,1X,A)') 'Reading 3D Met file'
      call camxerr()
c
 7002 continue
      write(iout,'(//,a)') 'ERROR in RDSUMBC:'
      write(iout,'(/,1X,A)') 'Reading boundary conditions. '
      call camxerr()
c
 7003 continue
      write(iout,'(//,a)') 'ERROR in RDSUMBC:'
      write(iout,'(/,1X,2A)') 'Premature end-of-file reading ',
     &                                         'boundary conditions.'
      call camxerr()
      end

      subroutine hgadsorb(temp,chg2,chgiip,chgiipc,fseas,
     &                    safine,sacoarse)
c
c----CAMx v7.40 260801
c
c    HGADSORB calculates adsorption of gas-phase Hg(2) on fine and coarse
c    primary PM
c
c      Copyright Ramboll
c
c     Modifications:
c        06/02/11  Original development
c
      implicit none
c
c-----Arguments:
c
      real, intent( in    ) :: temp     ! Temperature (deg K)
      real, intent( inout ) :: chg2     ! Hg(2) concentration (ug/m3)
      real, intent( inout ) :: chgiip   ! HgIIP concentration (ug/m3)
      real, intent( inout ) :: chgiipc  ! HgIIPC concentration (ug/m3)
      real, intent( in    ) :: fseas    ! Seasalt fraction of fine PM
      real, intent( in    ) :: safine   ! Fine PM surface area (m2/m3)
      real, intent( in    ) :: sacoarse ! Coarse PM surface area (m2/m3)
c
c-----Constants:
c     Temperature dependence for adsorption coefficient
c
      real, parameter :: TEMPCOEF = 4250.
c
c-----Locals:
c
      real :: kadsorb1, kadsorb2     ! Adsorption coefficients
      real :: keff_fine, keff_coarse ! Effective adsorption coefficient
      real :: chg2t                  ! Total Hg(2) (gas+adsorbed)
c
c-----Calculate total Hg(2) (Combine gas-phase Hg(2) with previously adsorbed
c     Hg(2))
c     Note: In current implementation, gas-phase Hg(2) is actually total Hg(2)
c           and HGIIP/HGIIPC are set to zero in calling routine. Thus, no need
c           to calculate total Hg(2), but kept for flexibility
c
      chg2t = chg2 + chgiip + chgiipc
c
c-----Calculate adsorption coefficients
c
      kadsorb1 = 10.**(TEMPCOEF/temp - 10.)   ! Adsorption to urban PM
      kadsorb2 = kadsorb1 * 10.               ! Adsorption to seasalt
c
c-----Calculate adsorption using different coefficients for urban PM and seasalt PM
c     Effective coefficient
c
      keff_fine   = (kadsorb1*( 1.-fseas ) + kadsorb2*fseas)*safine
      keff_coarse =  kadsorb1 * sacoarse

      chgiip  = chg2t*keff_fine/(1.0+keff_fine+keff_coarse)
      chgiipc = chg2t*keff_coarse/(1.0+keff_fine+keff_coarse)
      chg2    = chg2t - (chgiip + chgiipc)

      return
      end

      subroutine henryfnc(ispc,hlaw0,tfact,temp,ph,knh3,khno3,kso2,hlaw)
c
c----CAMx v7.40 260801
c 
c     HENRYFNC calculates temperature and dissociation adjustments to
c     baseline Henry's Law constants. 
c 
c      Copyright Ramboll
c           
c     Modifications:
c        None
c
c     Input arguments:
c        ispc                Species index
c        hlaw0               Baseline Henry's Law constant @298K (M/atm)
c        tfact               temperature factor
c        temp                ambient temperature (K)
c        ph                  pH of liquid
c        knh3                pointer to NH3
c        khno3               pointer to HNO3
c        kso2                pointer to SO2
c             
c     Output arguments: 
c        hlaw                Adjusted Henry's Law constant (M/atm)
c             
c     Routines called: 
c        None
c             
c     Called by: 
c        WETDEP
c        DRYDEP
c 
      implicit none
      integer ispc,knh3,khno3,kso2
      real hlaw0,tfact,temp,ph,hlaw

      real diss1,diss2
c
      hlaw = hlaw0*exp(tfact*(1./298. - 1./temp))
      if (ispc.eq.knh3) then
        diss1 = 10.**(-189.1/temp - 4.117)
        diss2 = 10.**(-5839.5/temp - 9.7618*alog(temp) + 61.206)
        hlaw = hlaw*(1. + (diss1/diss2)*10.**(-ph))
      elseif (ispc.eq.khno3) then
        diss1 = 15.4
        hlaw = hlaw*(1. + diss1/(10.**(-ph)))
      elseif (ispc.eq.kso2) then
        diss1 = 10.**(853./temp)/54950.
        diss2 = 10.**(621.9/temp)/1.897e+9
        hlaw = hlaw*(1. + diss1/(10.**(-ph)) + 
     &                    diss1*diss2/(10.**(-2.*ph)))
      endif

      return
      end

      subroutine bc1grd(nspec,ncol,nrow,nlay,ncolf,nrowf,nlayf,i1,j1,
     &                  nmesh,conc,concf)
c
c----CAMx v7.40 260801
c
c     BC1GRD sets up boundary conditions for one fine grid using 
c     concentrations of its parent grid
c
c      Copyright Ramboll
c          
c     Modifications:
c        8/23/06           Fixed indexing bug for CG cells
c       11/05/12           Removed vertical nesting
c
c     Input arguments:
c        nspec             Number of species
c        ncol              Number of columns on the parent grid
c        nrow              Number of rows on the parent grid
c        nlay              Number of layers on the parent grid
c        ncolf             Number of columns on the fine grid
c        nrowf             Number of rows on the fine grid
c        nlayf             Number of layers on the fine grid
c        i1                Starting i-index of fine grid
c        j1                Starting j-index of fine grid
c        nmesh             meshing factor relative to parent grid
c        conc              concentration on the coarse grid (umol/m3)
c
c     Output arguments:
c        concf             concentration on the fine grid (umol/m3)
c
c     Routines called:
c        none
c
c     Called by:
c        SETBC 
c
      dimension conc(ncol,nrow,nlay,nspec),
     &          concf(ncolf,nrowf,nlayf,nspec)
c
c-----Entry point
c
      do 30 ispc = 1,nspec
        do 20 kp=1,nlay
            kg = kp
c
c-----Southern boundary
c
            j = 1
            jj = j1 - 1
            do i = 2,ncolf-1
              ii = i1 + (i-2)/nmesh
              concf(i,j,kg,ispc) = conc(ii,jj,kp,ispc)
            enddo
c
c-----Northern boundary
c
            j = nrowf
            jj = j1 + (nrowf-2)/nmesh
            do i = 2,ncolf-1
              ii = i1 + (i-2)/nmesh
              concf(i,j,kg,ispc) = conc(ii,jj,kp,ispc)
            enddo
c
c-----Western boundary
c
            i =1
            ii = i1 - 1
            do j = 2,nrowf-1
              jj = j1 + (j-2)/nmesh
              concf(i,j,kg,ispc) = conc(ii,jj,kp,ispc)
            enddo
c
c-----Eastern boundary
c
            i = ncolf
            ii = i1 + (ncolf-2)/nmesh
            do j = 2,nrowf-1
              jj = j1 + (j-2)/nmesh
              concf(i,j,kg,ispc) = conc(ii,jj,kp,ispc)
            enddo
c
  20    continue
c
  30  continue
c
      return
      end

      subroutine srfprep(igrd,ncol,nrow,orgx,orgy,dxmod,dymod,
     &                   fsurf,topo,lai,lrdlai,icdocn)
      use filunit
      use bndary
      use camx_includes
c
c----CAMx v7.40 260801
c
c     SRFPREP reads the surface/landuse files for all grids and initializes the
c     landuse field arrays.  Landuse is mapped to all nested grids that
c     are not supplied with a surface file
c                          
c      Copyright Ramboll
c          
c     Modifications:
c        6/6/03       check input data for consistency
c        7/7/03       now skips everthing if file not supplied
c        4/27/06      Added read of optional topo field
c        7/5/07       Added read of optional LAI field
c        1/04/11      Revised for new met input format
c        02/11/11     Albedo codes are now set here (not in AHOPREP)
c        08/08/14     Albedo moved to separate routine to account for snow
c        08/04/16     Ocean flag is set here for Z03 water (index 1) > 0.
c
c     Input arguments:
c        igrd                grid index
c        ncol                number of columns
c        nrow                number of rows
c        orgx                grid x-origin (km or deg)
c        orgy                grid y-origin (km or deg)
c        dxmod               grid spacing in x-direction (km or deg)
c        dymod               grid spacing in y-direction (km or deg)
c
c     Output arguments:
c        fsurf               fractional landuse field
c        topo                topographic elevation (m MSL, optional)
c        lai                 lead area index field (optional)
c        lrdlai              flag indicating if LAI was read
c        icdocn              ocean cell flag
c
c     Routines Called:
c        JSTLFT
c        TOUPPER
c
c     Called by:
c        STARTUP
c
      implicit none
c
      integer igrd,ncol,nrow
      integer icdocn(ncol,nrow)
      real orgx,orgy,dxmod,dymod
      real fsurf(ncol,nrow,nlu),topo(ncol,nrow),lai(ncol,nrow)
      logical lrdlai
c
      character*10 namsrf(NLUZ03),namevar(MXVAR)
      character*4 namvar(10)
      integer i,j,iunit,m,n,l,idum,i1,i2,ifresh
      integer lumap(NLUZ03)
      integer mapvar(NLUZ03)
      real areatot
      real arr2d(MXCELLS,MXCELLS,MXVAR)
c
      common /arr2dat/ arr2d
c
      data namsrf   /'WATER     ',
     &               'ICE       ',
     &               'LAKE      ',
     &               'ENEEDL    ',
     &               'EBROAD    ',
     &               'DNEEDL    ',
     &               'DBROAD    ',
     &               'TBROAD    ',
     &               'DDECID    ',
     &               'ESHRUB    ',
     &               'DSHRUB    ',
     &               'TSHRUB    ',
     &               'SGRASS    ',
     &               'LGRASS    ',
     &               'CROPS     ',
     &               'RICE      ',
     &               'SUGAR     ',
     &               'MAIZE     ',
     &               'COTTON    ',
     &               'ICROPS    ',
     &               'URBAN     ',
     &               'TUNDRA    ',
     &               'SWAMP     ',
     &               'DESERT    ',
     &               'MWOOD     ',
     &               'TFOREST   '/
      data lumap / 7, 8, 7, 5, 5, 4, 4, 5, 4, 3,
     &             3, 3, 3,10, 2, 2, 2, 2, 2, 2,
     &             1,11, 9, 8, 6, 6/
c
c-----Entry point
c
      lrdlai = .false.
c
c-----Skip if file not provided
c
      do j = 1,nrow
        do i = 1,ncol
          topo(i,j) = 0.
          lai(i,j)  = 0.
        enddo
      enddo
      iunit = isurf(igrd)
      if (iunit .LE. 0) goto 9999
c
c-----Read surface file header
c
      call rdmethdr(iunit,'SURFACE   ',igrd,0.,0,0.,0,ncol,nrow,1,
     &              orgx,orgy,dxmod,dymod,iout,nsrfvar(igrd))
c
c-----Read variable fields
c
      read(iunit,end=7000)
      do n = 1,nsrfvar(igrd)
        read(iunit,end=7000) idum,(namvar(m),m=1,10),
     &                       ((arr2d(i,j,n),i=1,ncol),j=1,nrow)
        write(namevar(n),'(10a1)') (namvar(m),m=1,10)
      enddo
      write(iout,'(a40,15x,a,i3)') 'Read LU field',' grid',igrd
c
c-----Load landuse fractions depending on selected dry dep algorithm
c
      do n = 1,nlu
        do j = 1,nrow
          do i = 1,ncol
            fsurf(i,j,n) = 0.
          enddo
        enddo
      enddo
      do n = 1,NLUZ03
        do l = 1,nsrfvar(igrd)
          if (namevar(l).eq.namsrf(n)) then
            mapvar(n) = l
          endif
        enddo
      enddo

      ifresh = 0
      do j = 1,nrow
        do i = 1,ncol
          icdocn(i,j) = 0
          if (arr2d(i,j,mapvar(1)).gt.0.) icdocn(i,j) = 1
          if (arr2d(i,j,mapvar(3)).gt.0.) ifresh = 1
        enddo
      enddo
      if (ifresh.eq.0 .AND. lixemis) goto 7002
72    continue

      do n = 1,NLUZ03
        do j = 1,nrow
          do i = 1,ncol
            if (idrydep.eq.2) then
              fsurf(i,j,n) = arr2d(i,j,mapvar(n))
            else
              fsurf(i,j,lumap(n)) = fsurf(i,j,lumap(n)) + 
     &                              arr2d(i,j,mapvar(n))
            endif
          enddo
        enddo
      enddo
c
      do l = 1,nsrfvar(igrd)
        if (namevar(l).eq.'LAI') then
          do j = 1,nrow
            do i = 1,ncol
              lai(i,j) = arr2d(i,j,l)
            enddo
          enddo
          write(iout,'(a40,15x,a,i3)') 'Read LAI field',' grid',igrd
          lrdlai = .true.
        elseif (namevar(l).eq.'TOPO_M') then
          do j = 1,nrow
            do i = 1,ncol
              topo(i,j) = arr2d(i,j,l)
            enddo
          enddo
          write(iout,'(a40,15x,a,i3)') 'Read TOPO field',' grid',igrd
        endif
      enddo
c
c-----Check that the LU data are reasonable and adjust out
c     minor inconsistencies
c
      do j = 1,nrow
        do i = 1,ncol
           areatot = 0.0
           do l = 1,nlu
             areatot = areatot + fsurf(i,j,l)
           enddo
           if (areatot.lt.0.95 .or. areatot.gt.1.05) goto 7001
           do l = 1,nlu
             fsurf(i,j,l) = fsurf(i,j,l)/areatot
           enddo
         enddo
      enddo
c10   continue
c
 9999 return
c
c-----Error in landuse fractions
c
 7000 continue
      write(iout,'(//,a)')'ERROR in SRFPREP:'
      write(iout,'(A,I5)') 'Reading surface file for grid:',igrd
      write(iout,*)'End of input file reached.  Make sure the file '
      write(iout,*)'is in the correct format and contains: ',
     &              nsrfvar(igrd)
      write(iout,*)'variable fields.'
      write(iout,*)
      call camxerr()
c
 7001 write(iout,'(//,A)') 'ERROR in SRFPREP:'
      write(iout,'(/,2A)') 'Sum of landuse fractions differs from 1.0 ',
     &                     'by more than 5%'
      write(iout,'(A,i3,a,2i4)') 
     &       'Grid = ', igrd, '  Cell(i,j) = ', i, j
      write(iout,'(A)') 'Table of input landuse data follows:'
      write(iout,'(/,A)') ' Class    Fraction'
      write(iout,'(i6,F10.3)') (l,fsurf(i,j,l),l=1,nlu)
      write(iout,'(A6,F10.3)') 'Total', areatot
      write(iout,'(/,A)') 'Check your input landuse data file'
      call camxerr()
c
 7002 write(iout,'(//,A)') 'WARNING in SRFPREP:'
      write(iout,'(A)') 'No fresh water coverage found in LU file'
      write(iout,'(A,i3,a,2i4)') 'Grid = ', igrd
      write(iout,'(2A)') 'If you are running with in-line halogen',
     &                     ' emissions, halogens will be emitted'
      write(iout,'(A)') 'for all water bodies.'
      write(iout,'(2A)') 'Use the WATERMASK program to convert your LU',
     &                   ' file to differentiate between'
      write(iout,'(A,//)') 'ocean and fresh water bodies.'
      write(*,'(//,A)') 'WARNING in SRFPREP:'
      write(*,'(A)') 'No fresh water coverage found in LU file'
      write(*,'(A,i3,a,2i4)') 'Grid = ', igrd
      write(*,'(2A)') 'If you are running with in-line halogen',
     &                     ' emissions, halogens will be emitted'
      write(*,'(A)') 'for all water bodies.'
      write(*,'(2A)') 'Use the WATERMASK program to convert your LU',
     &                   ' file to differentiate between'
      write(*,'(A,//)') 'ocean and fresh water bodies.'
      goto 72
       
      end

      subroutine rd_sa_tcfile()
      use tracer
      use grid
      use camxfld
      use filunit
      implicit none
c 
c----CAMx v7.40 260801
c 
c     RD_SA_TCFILE reads and cycles through the source apportionment TC
c     file to the current time/date, and loads top concentrations into
c     the tracer array.
c 
c      Copyright Ramboll
c           
c     Modifications: 
c        none
c 
c     Input arguments: 
c             
c     Output arguments: 
c             
c     Routines Called: 
c        none
c             
c     Called by: 
c        CAMx
c
      include 'camx.prm'
      include 'camx.inc'
c
c     Argument delcarations:
c
c     Local Variables
c
      character*10 spcname
      character*4  tcspec(10)
      integer      idat1, idat2, ncells, nz, i, j, k, ltc, itr, n
      integer      nc, idum, n3d
      real         tim1, tim2
c
      real,    allocatable, dimension(:,:) :: tctmp
c
c-----Entry point
c
      nz = nlay(1)
      allocate( tctmp(ncol(1),nrow(1)) )
c
c-----If this is the first time, read through the header records ---
c
      if( lrd_sa_tc_hdr ) then
        lrd_sa_tc_hdr = .FALSE.
        rewind(iortc)
        do i=1,8
          read(iortc)
        enddo
      endif
c
c-----Read through coarse grid concentration records until current time/date
c
 100  read(iortc,end=900) idat1,tim1,idat2,tim2
      if (INT(tim2) .EQ. 24) then
        tim2 = 0.
        idat2 = idat2 + 1
        if( MOD(idat2,1000) .GT. 365 ) then
           if( MOD(INT(idat2/1000),4) .EQ. 0 ) then
              if( MOD(idat2,1000) .EQ. 367 )
     &                     idat2 = (INT(idat2/1000)+1)*1000 + 1
           else
              idat2 = (INT(idat2/1000)+1)*1000 + 1
           endif
        endif
      endif
      tim1 = 100.*tim1
      tim2 = 100.*tim2
      write(iout,'(a40,2(f7.0,i8.5))')
     &  'Read SA top concentrations condition file at ',tim1,idat1,tim2,idat2
      call flush(iout)
      if ((idat1.lt.date .or. (idat1.eq.date .and. tim1.le.time)) .and.
     &    (idat2.gt.date .or. (idat2.eq.date .and. tim2.gt.time))) then
c
c-----read the data for each species and load into the proper place in SA
c     grdded concnetration array ---
c
         do ltc = 1,num_iorbc
            read(iortc) idum,(tcspec(n),n=1,10),
     &                  ((tctmp(i,j),i=1,ncol(1)),j=1,nrow(1))
            write(spcname,'(10A1)') (tcspec(n),n=1,10)
            do itr = 1,ntotsp
               if( spcname .NE. ptname(itr) ) cycle
               do j=1,nrow(1)
                  do i = 1,ncol(1)
                    n3d = i + ncol(1)*(j-1) + ncol(1)*nrow(1)*(itr - 1)
                    pttop(n3d) = BNDLPT
                    pttop(n3d) = amax1(pttop(n3d),tctmp(i,j))
                  enddo
                enddo
            enddo
         enddo
         goto 999
      else
        goto 100
      endif
c
c-----End of TC file reached
c
 900  continue
      write(iout,'(//,a)') 'ERROR in RD_TA_BCFILE :'
      write(iout,*)'Premature End of source apportionment TC file reached.'
      write(iout,*)'Make sure boundary file contains simulation ',
     &                                               'time period.'
      call camxerr()
c
 999  continue
c
c  --- dealocate the local array ---
c
      deallocate( tctmp )
      return
      end

      subroutine zrates(m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon,igrid,
     &                  ncol,nrow,nlay,nadv,deltat,dx,dy,
     &                  depth,phpt,pppt,ptpt,windu,windv,tempk,press,
     &                  mapscl,dilut,entrn,rhorat,lvupsolv)
      use bndary
c 
c----CAMx v7.40 260801
c  
c     ZRATES calculates new vertical velocity and dilution/entrainment
c     rates resulting from the time-varying vertical grid.
c 
c      Copyright Ramboll
c 
c     Modifications:
c        4/26/99   Added Piecewise Parabolic Method for horizontal advection
c        12/3/99   A dummy atmospheric density is added above the top of
c                  the model based upon an extrapolation to an overlying
c                  layer of the same thickness as the top model layer
c        9/26/01   Revised the calculation of vertical velocity (W) to be
c                  consistent with the way the implicit solver uses W
c        4/10/03   X/Y advection now uses layer-dependent timestep
c       10/13/03   area weighting applied to winds rather than density
c        3/06/06   Revised top BC approach; removed top dummy layer
c        4/09/09   Improved definition of atmospheric density at top of model
c       11/04/09   Revised vertical advection solver technique, now
c                  employs zero-gradient top boundary condition
c        3/12/10   Removed X/Y advection order flip
c        8/13/10   Calculating top BC only at met update times
c                            
c     Input arguments:  
c        igrid               grid index 
c        ncol                number of columns 
c        nrow                number of rows 
c        nlay                number of layers
c        nadv                number of sub-steps per timestep
c        deltat              timestep (s)
c        dx                  cell size in x direction (m)
c        dy                  cell size in y direction (m)
c        depth               layer depth (m) 
c        phpt                time-rate change of layer interface height (m/s)
c        pppt                time-rate change of pressure (mb/s)
c        ptpt                time-rate change of temperature (K/s)
c        windu               u-component windspeed (m/s)
c        windv               v-component windspeed (m/s)
c        tempk               temperature (k)
c        press               pressure (mb)
c        mapscl              map-scale factor at cell centroid
c             
c     Output arguments:  
c        dilut               dilution rate (m/s) 
c        entrn               entrainment rate (m/s) 
c        rhorat              density scaling above the model top (unitless)
c        lvupsolv            3-D flag to use upstream donor solver
c             
c     Routines Called:  
c        none 
c             
c     Called by:  
c        EMISTRNS 
c 
      implicit none
      include 'camx.prm'
      include 'flags.inc'
c
      integer :: m1,m2,m3,i0,j0,ia,iz,ja,jz,ibcon
      integer :: m_xi1,m_xi2,m_xj1,m_xj2
      integer :: m_yi1,m_yi2,m_yj1,m_yj2
      integer :: m_zi1,m_zi2,m_zj1,m_zj2
c
      integer ncol,nrow,nlay,igrid
      integer nadv(nlay)

      real, dimension(m1,m2,m3) :: windu,windv,tempk,
     &                             press,dilut,entrn,pppt,ptpt
      real, dimension(m1,m2,m3) :: depth, phpt
      real, dimension(m1,m2) :: rhorat
      real :: mapscl(m1,m2),dx(nrow)
      real deltat,dy
      logical lvupsolv(m1,m2,m3)
c
      integer i,j,k,istep,num1d
      real dtuse,pnxt,tnxt,ttop,ptop,dtdz,tavg,
     &     rhow,drhodt
c
      real rho(MXCELLS,MXCELLS,MXLAYER)
      real rhon(MXCELLS,MXCELLS,MXLAYER)
      real rhotop(MXCELLS,MXCELLS)
      real c1d(MXCELLS)
      real v1d(MXCELLS)
      real a1d(MXCELLS)
      real av1d(MXCELLS)
      real area(MXCELLS)
      real flxarr(MXCELLS)
      real rhonxt(MXLAYER)
      real rhoscl(MXLAYER)
      real windw(MXLAYER)
      real fpc(MXCELLS)
      real fmc(MXCELLS)
c
      common /comzratres/ rho, rhon, rhotop
c
c-----Entry point 
c
      num1d = MAX(m1,m2,m3)
c
c-----Set grid point limits
c
      m_xi1= ia-1           ! x-adv, west  i-bound
      m_xi2= iz+1           ! x-adv, east  i-bound
      m_xj1= 1              ! x-adv, south j-bound
      m_xj2= m2             ! x-adv, north j-bound
      m_yi1= ia-1           ! y-adv, west  i-bound
      m_yi2= iz+1           ! y-adv, east  i-bound
      m_yj1= ja-1           ! y-adv, south j-bound
      m_yj2= jz+1           ! y-adv, north j-bound
      m_zi1= ia-1
      m_zi2= iz+1
      m_zj1= ja-1
      m_zj2= jz+1
      if(btest(ibcon,0)) then
         m_xi1 = ia
         m_yi1 = ia
         m_zi1 = ia
      endif
      if(btest(ibcon,1)) then
         m_xi2 = iz
         m_yi2 = iz
         m_zi2 = iz
      endif
      if(btest(ibcon,2)) then
         m_xj1 = ja
         m_yj1 = ja
         m_zj1 = ja
      endif
      if(btest(ibcon,3)) then
         m_xj2 = jz
         m_yj2 = jz
         m_zj2 = jz
      endif
c
      do k = 1,m3
        do j = 1,m2
          do i = 1,m1
            lvupsolv(i,j,k) = .false.
          enddo
        enddo
      enddo
c
      do 30 k = 1,nlay
c
c-----Load current atmospheric density (rho) and advected density (rhon)
c
        do j = 1,m2
          do i = 1,m1
            rho(i,j,k) = press(i,j,k)/tempk(i,j,k)
            rhon(i,j,k) = rho(i,j,k)
            if (k.eq.nlay) then
              dtdz = 2.*(tempk(i,j,nlay) - tempk(i,j,nlay-1))/
     &                          (depth(i,j,nlay) + depth(i,j,nlay-1))
              ttop = tempk(i,j,nlay) + dtdz*depth(i,j,nlay)/2.
              tavg = (ttop + tempk(i,j,nlay))/2.
              ptop = press(i,j,nlay)*
     &               exp(-9.8*depth(i,j,nlay)/(2.*287.*tavg))
              rhotop(i,j) = ptop/ttop
              rhorat(i,j) = rhotop(i,j)/rho(i,j,nlay)
            endif
          enddo
        enddo
c
c-----Determine atmospheric density flux in x-direction
c
 100    continue
c
        do 10 j = m_xj1, m_xj2
          do i = 1,m1
            area(i) = dy*depth(i,j,k)
          enddo
          do i = 1,m1-1 
            av1d(i) = dy*(depth(i,j,k) + depth(i+1,j,k))/
     &                (mapscl(i,j) + mapscl(i+1,j))
            v1d(i) = windu(i,j,k)
            a1d(i) = mapscl(i,j)*mapscl(i,j)/area(i)
            c1d(i) = rhon(i,j,k)
          enddo
          av1d(m1) = dy*depth(m1,j,k)/mapscl(m1,j)
          v1d(m1) = windu(m1,j,k)
          a1d(m1) = mapscl(m1,j)*mapscl(m1,j)/area(m1)
          c1d(m1) = rhon(m1,j,k)
c
          dtuse = deltat/nadv(k)
          do istep = 1,nadv(k)
            if (iadvct.eq.2) then
              call hadvbot(m1,dtuse,dx(j+j0),c1d,v1d,a1d,av1d,flxarr,
     &                     fpc,fmc,num1d)
            elseif( iadvct .eq. 3) then
              call hadvppm(m1,dtuse,dx(j+j0),c1d,v1d,a1d,av1d,flxarr,
     &                     num1d)
            endif
c
            do i = 1,m1-1
              if (i.gt.1) rhon(i,j,k) = c1d(i)
            enddo
          enddo
c 
 10     continue
c
c  --- end of parallelized loop ---
c
c-----Determine atmospheric density flux in y-direction
c
 200    continue
c
        do 20 i = m_yi1, m_yi2 
c
          do j = 1,m2
            area(j) = dx(j+j0)*depth(i,j,k)
          enddo
          do j = 1,m2-1
            av1d(j) = (dx(j+j0)*depth(i,j,k) + 
     &                 dx(j+j0+1)*depth(i,j+1,k))/
     &                (mapscl(i,j) + mapscl(i,j+1))
            v1d(j) = windv(i,j,k)
            a1d(j) = mapscl(i,j)*mapscl(i,j)/area(j)
            c1d(j) = rhon(i,j,k)
          enddo
          av1d(m2) = dx(m2+j0)*depth(i,m2,k)/mapscl(i,m2)
          v1d(m2) = windv(i,m2,k)
          a1d(m2) = mapscl(i,m2)*mapscl(i,m2)/area(m2)
          c1d(m2) = rhon(i,m2,k)
c
          dtuse = deltat/nadv(k) 
          do istep = 1,nadv(k)
            if (iadvct.eq.2) then
              call hadvbot(m2,dtuse,dy,c1d,v1d,a1d,av1d,flxarr,
     &                     fpc,fmc,num1d)
            elseif( iadvct .eq. 3) then
              call hadvppm(m2,dtuse,dy,c1d,v1d,a1d,av1d,flxarr,num1d)
            endif
c 
            do j = 1,m2-1
              if (j.gt.1) rhon(i,j,k) = c1d(j)
            enddo
          enddo
c
 20     continue
c
c  --- end of parallelized loop ---
c
 30   continue
c
c-----Loop over grid to calculate vertical velocity, dilution and
c     entrainment rates
c             
      do 60 j = m_zj1, m_zj2
        do 50 i = m_zi1, m_zi2
c
c-----Get density at end of timestep
c
          do k = 1,nlay
            pnxt = press(i,j,k) + deltat*pppt(i,j,k)
            tnxt = tempk(i,j,k) + deltat*ptpt(i,j,k)
            rhonxt(k) = pnxt/tnxt
          enddo
c
c-----Calculate actual density tendency and diagnose vertical velocity
c
          rhow = 0.
          do 40 k = 1,nlay 
            drhodt = (rhonxt(k) - rhon(i,j,k))/deltat
            rhow = rhow - depth(i,j,k)*drhodt
            if (k.ge.nlay-1) then
              if (rhow.ge.0.) then
                rhoscl(k) = rhonxt(k)
              else
                if (k.eq.nlay) then
                  rhoscl(k) = rhotop(i,j)
                else
                  rhoscl(k) = rhonxt(k+1)
                endif
              endif
            else
              rhoscl(k) = (rhonxt(k)*depth(i,j,k+1) +  
     &                          rhonxt(k+1)*depth(i,j,k))/
     &                               (depth(i,j,k+1) + depth(i,j,k))
            endif
            windw(k) = rhow/rhoscl(k)
 40       continue 
c
c-----Calculate entrainment and dilution rates
c
          do 42 k = 1,nlay
            dilut(i,j,k) = phpt(i,j,k)
            if (k.gt.1) dilut(i,j,k) = phpt(i,j,k) - phpt(i,j,k-1) 
            entrn(i,j,k) = phpt(i,j,k) - windw(k)
 42       continue 
 50     continue
 60   continue 
c
      return
      end

c**** STARTRT
c
      subroutine startrt(iounit,nopen)
      use grid
      use pigsty
      use procan
      use filunit
      use tracer
      use rtracchm
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c     This routine loads all of the files needed for the reactive 
c     tracer algorithm (RTRAC)
c
c      Copyright Ramboll
c
c     Argument description:
c        Inputs:
c          iounit     I   unit number for output
c        Outputs:   
c          nopen    I   number of files opened
c
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c     01/16/02   --gwilson--   Original development
c     11/10/03   --cemery--    Added sampling grid I/O
c     10/06/04   --cemery--    Restructured for namelist input
c      8/02/05   --cemery--    Included specific option flag for Rtrac
c                              sampling grid
c      8/23/06   --cemery--    Instantaneous restart files reduced to 1
c                              per grid type
c      8/25/06   --cemery--    Surface output files now all UAM format,
c                              one file per grid
c     10/29/09   --cemery--    Added optional RTRAC surface model
c      11/4/09   --cemery--    Removed input top concentrations
c     05/07/12   --cemery--    Added flexi-nesting flag
c     03/01/16   --cemery--    Added partial source area map
c     02/15/21   --gwilson--   Add initialization of number of emissions files
c     08/26/21   --cemery--    Surface file doubles as (default) dep
c                              output or (flagged) surface model output
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'flags.inc'
      include 'namelist.inc'
      include 'chmdat.inc'
      include 'rtracsrf.inc'
      include 'netcdf.inc'
c
c-----------------------------------------------------------------------
c    Argument declaration:
c-----------------------------------------------------------------------
c
      integer   iounit
      integer   nopen
c
c-----------------------------------------------------------------------
c    External functions:
c-----------------------------------------------------------------------
c
      integer istrln
      integer ncf_chkfile
      integer ncf_get_nlayers
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 fname
      character*80 action
      character*10 cname
      integer      i, j, n, ierr
      logical      lexist
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c
c   --- if option is turned off, just return ---
c
      if( .NOT. ltrace .OR. 
     &         (tectyp .NE. RTRAC .AND. tectyp .NE. RTCMC) ) goto 9999
      nchar = istrln( flrtsa )
c
c   --- only one emission group for RTRAC ----
c
      ngroup = 1
c
c   --- call routine to allocate all of the data ---
c
      call alloc_tracer(ngroup,ngrid,ncol,nrow,nlay,nspec)
      call alloc_tracer_full(1,ngrid,ncol,nrow)
      call alloc_rtrac_cel(ngrid,ncol,nrow,nlay)
      do j=1,ngrid
          num_iortem(j,0) = 0
          num_iortpt(0) = 0
          num_iortem(j,1) = 1
          num_iortpt(1) = 1
          num_iortem(j,2) = 0
          num_iortpt(2) = 0
      enddo
c
c   --- intialize first time through to true ---
c
      lfirst = .TRUE.
      write(iounit,'(/,A,/)') 
     &            '           **** RTRAC Files ****'
c
c   --- chemistry parameters file ---
c
      action = 'Opening RTRAC Chemistry Parameters file.'
      chmfil = RT_Chemistry_Parameters
      fname = chmfil
      inquire(file=chmfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      nopen =  nopen + 1
      call getunit(iorchm)
      write(iounit,9000) 'RTRAC Chemistry Parameters file      (unit):',
     &                                                          iorchm
      write(iounit,9002) chmfil(:istrln(chmfil))
c
c   --- receptor definition file ----
c
      rcpfil = RT_Receptor_Definitions
      if( rcpfil .NE. ' ' ) then
         action = 'Opening RTRAC Receptor Definition file.'
         fname = rcpfil
         inquire(file=rcpfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorrcp)
         write(iounit,9000) 
     &         'RTRAC Receptor Definition file       (unit):',iorrcp
         write(iounit,9002) rcpfil(:istrln(rcpfil))
         lrcpfil = .TRUE.
      else
         write(iounit,9000) 'No RTRAC Receptor Definition file provided.'
         lrcpfil = .FALSE.
      endif
c
c   --- instantaneous file used for initialization ---
c
      if( lrstrt ) then
         action = 'Opening RTRAC master grid Restart file.'
         inifil(IDXCRS) = RT_Master_Restart
         fname = inifil(IDXCRS)
         inquire(file=inifil(IDXCRS),exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorini(IDXCRS))
         write(iounit,9000)'RTRAC master grid Restart file       (unit):',
     &                                                    iorini(IDXCRS)
         write(iounit,9002) inifil(IDXCRS)(:istrln(inifil(IDXCRS)))
c
         if( ngrid .GT. 1 ) then
            action = 'Opening RTRAC nested grid Restart file.'
            inifil(IDXFIN) = RT_Nested_Restart
            if( inifil(IDXFIN) .NE. ' ' ) then
               fname = inifil(IDXFIN)
               inquire(file=inifil(IDXFIN),exist=lexist)
               if( .NOT. lexist ) goto 7000
               nopen =  nopen + 1
               call getunit(iorini(IDXFIN))
               write(iounit,9000)
     &                 'RTRAC nested grid Restart file       (unit):',
     &                                                    iorini(IDXFIN)
               write(iounit,9002) inifil(IDXFIN)(:istrln(inifil(IDXFIN)))
            elseif (.not.lflexi) then
               goto 7003
            endif
         endif
      else
c
c   --- initial conditions file ---	
c
         action = 'Opening RTRAC Initial Conditions file.'
         icfil = RT_Initial_Conditions
         fname = icfil
         if( fname .EQ. ' ' ) then
            licfil = .FALSE.
            write(iounit,9003)
     &              'RTRAC Initial Conditions file        (unit):',
     &                                             ' Not supplied'
         else
            inquire(file=icfil,exist=lexist)
            if( .NOT. lexist ) goto 7000
            nopen =  nopen + 1
            call getunit(ioric)
            write(iounit,9000)
     &              'RTRAC Initial Conditions file        (unit):',ioric
            write(iounit,9002) icfil(:istrln(icfil))
            licfil = .TRUE.
         endif
      endif
c
c   --- boundary conditions file ---
c
      action = 'Opening RTRAC Boundary Conditions file.'
      bcfil = RT_Boundary_Conditions
      fname = bcfil
      if( fname .EQ. ' ' ) then
         lbcfil = .FALSE.
         write(iounit,9003)'RTRAC Boundary Conditions file       (unit):',
     &                                                  ' Not supplied'
      else
         inquire(file=bcfil,exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen =  nopen + 1
         call getunit(iorbc)
         write(iounit,9000)'RTRAC Boundary Conditions file       (unit):',
     &                                                             iorbc
         write(iounit,9002) bcfil(:istrln(bcfil))
         lbcfil = .TRUE.
      endif
c
c   --- allocate arrays for filenames ---
c
      call alloc_tracer_emfiles(1,ngrid,nemiss_files,npoint_files,
     &                                      num_iortem,num_iortpt,nspec)
c
c   --- surface emissions file --- 
c
      nlayers_ems = 1
      do 10 j = 1,ngrid
          action = 'Opening RTRAC Gridded Emissions file.'
          temfil(j,1,1) = RT_Emiss_Grid(j)
          fname = temfil(j,1,1)
          if( fname .EQ. ' ') then
             if (j.eq.1 .OR. lflexi .OR. .NOT.ltemfl(1,1,1)) then
               ltemfl(j,1,1) = .FALSE.
               write(iounit,9004)
     &               'Gridded Emissions for grid # ',j,'           :',
     &                                                ' Not supplied'
             else
               goto 7004
             endif
          else
             ltemfl(j,1,1) = .TRUE.
             inquire(file=temfil(j,1,1),exist=lexist)
             if( .NOT. lexist ) goto 7000
             nopen = nopen + 1
             call getunit(iortem(j,1,1))
             cname = 'EMISSIONS '
             ierr = ncf_chkfile(iortem(j,1,1),temfil(j,1,1),action,cname)
             if( ierr .EQ. ISUCES ) then
               call nobinary()
               is_netcdf_iortem(j,1,1) = .FALSE.
               open(unit=iortem(j,1,1),file=temfil(j,1,1),
     &                    ERR=7001,form='UNFORMATTED',status='UNKNOWN')
             else
               is_netcdf_iortem(j,1,1) = .TRUE.
               ierr = nf_open(fname,NF_NOWRITE,iortem(j,1,1))
               if( ierr .NE. NF_NOERR ) goto 7001
               nlayers_ems = MAX(nlayers_ems,ncf_get_nlayers(iortem(j,1,1),fname,action))
             endif
             write(iounit,9005)
     &               'Gridded Emissions for grid # ',j,'      (unit):',
     &                                                      iortem(j,1,1)
             write(iounit,9002) temfil(j,1,1)(:istrln(temfil(j,1,1)))
          endif
   10 continue
c
c   --- elevated point source emissions ----
c
      tptfil(1,1) = RT_Point_Sources
      fname = tptfil(1,1)
      action = 'Opening RTRAC Point Source file.'
      if( fname .EQ. ' ' ) then
         ltptfl(1,1) = .FALSE.
         write(iounit,9003)
     &                   'Point Source Emissions                     :',
     &                                                  ' Not supplied'
      else
         ltptfl(1,1) = .TRUE.
         inquire(file=tptfil(1,1),exist=lexist)
         if( .NOT. lexist ) goto 7000
         nopen = nopen + 1
         call getunit(iortpt(1,1))
         cname = 'PTSOURCE  '
         ierr = ncf_chkfile(iortpt(1,1),tptfil(1,1),action,cname)
         if( ierr .EQ. ISUCES ) then
           call nobinary()
           is_netcdf_iortpt(1,1) = .FALSE.
           open(unit=iortpt(1,1),file=tptfil(1,1),ERR=7001,
     &                     form='UNFORMATTED',status='UNKNOWN')
         else
           is_netcdf_iortpt(1,1) = .TRUE.
           ierr = nf_open(tptfil(1,1),NF_NOWRITE,iortpt(1,1))
           if( ierr .NE. NF_NOERR ) goto 7001
         endif
         write(iounit,9000)'Point Source Emissions               (unit):',
     &                                                         iortpt(1,1)
         write(iounit,9002) tptfil(1,1)(:istrln(tptfil(1,1)))
      endif
c
c   --- input surface model mass file ---
c
      if (lsrfmodrt) then
        do j = 1,ngrid
          action = 'Opening input RTRAC Surface Model file.'
          rtsrfin(j) = RT_Srfmod_Grid(j)
          fname = rtsrfin(j)
          if( fname .EQ. ' ' ) then
             write(iounit,9004)
     &               'RTRAC Surface Mass for grid # ',j,'           :',
     &                                                ' Not supplied'
             write(iounit,*) 'This file is required when',
     &                     ' RT_Surface_Model = T'
             call camxerr()
          else
             inquire(file=rtsrfin(j),exist=lexist)
             if( .NOT. lexist ) goto 7000
             nopen = nopen + 1
             call getunit(iorrtsrf(j))
             write(iounit,9005)
     &               'RTRAC Surface Mass for grid # ',j,'      (unit):',
     &                                                     iorrtsrf(j)
             write(iounit,9002) rtsrfin(j)(:istrln(rtsrfin(j)))
          endif
        enddo
      endif
c
c   --- output filenames ---
c
      do 20 i=IDXCRS,IDXFIN
         if( i .EQ. IDXFIN .AND. ngrid .EQ. 1 ) goto 20
c
c   --- output instantaneous file ---
c
         confil(i) = flrtsa
         if( i .EQ. IDXCRS ) then
            confil(i)(nchar+1:) = '.rt.inst'
         else
            confil(i)(nchar+1:) = '.rt.finst'
         endif
         fname = confil(i)
         nopen = nopen + 1
         call getunit(iowcon(i))
         open(unit=iowcon(i),file=confil(i),ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
         if( i .EQ. IDXCRS ) then
            write(iounit,9000)
     &                  'RTRAC INST file for master grid      (unit):',
     &                                                        iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         else
            write(iounit,9000)
     &                  'RTRAC INST file for nested grids     (unit):',
     &                                                        iowcon(i)
            write(iounit,9002) confil(i)(:istrln(confil(i)))
         endif
   20 continue
c
c    ---- surface concentrations file ----
c
      do n = 1,ngrid
         sfcfil(n) = ' '
         fname = flrtsa
         if( .NOT. lcdfout ) then
            write(fname(nchar+1:),'(a,i2.2)') '.rt.grd',n
            sfcfil(n) = fname
            nopen = nopen + 1
            call getunit(iowsfc(n))
            open(unit=iowsfc(n),file=sfcfil(n),ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
            write(iounit,9000)
     &                  'RTRAC output Surface file            (unit):',
     &                                                        iowsfc(n)
            write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
          else
            write(fname(nchar+1:),'(a,i2.2,a)') '.rt.grd',n,'.nc'
            sfcfil(n) = fname
            nopen = nopen + 1
            action = 'Opening RTRAC output Surface file.'
            call ncf_createfile(fname,action,iowsfc(n))
            write(iounit,9000) 'RTRAC output Surface file:'
            write(iounit,9002) sfcfil(n)(:istrln(sfcfil(n)))
          endif
      enddo
c
c    ---- surface model mass file ----
c
      do n = 1,ngrid
         rtsrfout(n) = ' '
         fname = flrtsa
         if( .NOT. lcdfout ) then
            if (lsrfmodrt) then
              write(fname(nchar+1:),'(a,i2.2)') '.rt.srf',n
            else
              write(fname(nchar+1:),'(a,i2.2)') '.rt.dep',n
            endif
            rtsrfout(n) = fname
            nopen = nopen + 1
            call getunit(iowrtsrf(n))
            open(unit=iowrtsrf(n),file=rtsrfout(n),ERR=7002,
     &                            form='UNFORMATTED',status='UNKNOWN')
            write(iounit,9000)
     &                  'RTRAC output Surface Mass file       (unit):',
     &                                                      iowrtsrf(n)
            write(iounit,9002) rtsrfout(n)(:istrln(rtsrfout(n)))
         else
            if (lsrfmodrt) then
              write(fname(nchar+1:),'(a,i2.2)') '.rt.srf',n,'.nc'
            else
              write(fname(nchar+1:),'(a,i2.2,a)') '.rt.dep',n,'.nc'
            endif
            rtsrfout(n) = fname
            nopen = nopen + 1
            action = 'Opening RTRAC output Surface mass file.'
            call ncf_createfile(fname,action,iowrtsrf(n))
            write(iounit,9000) 'RTRAC output Surface Mass file:'
            write(iounit,9002) rtsrfout(n)(:istrln(rtsrfout(n)))
         endif
      enddo
c
c    ---- receptor output file ----
c
      if( lrcpfil ) then
         avgfil(1:) = flrtsa
         avgfil(nchar+1:) = '.rt.receptor'
         fname = avgfil
         nopen = nopen + 1
         call getunit(iowrcp)
         open(unit=iowrcp,file=avgfil,ERR=7002,form='FORMATTED',
     &                                               status='UNKNOWN')
         write(iounit,9000) 
     &          'RTRAC Receptor decay rate file       (unit):',iowrcp
         write(iounit,9002) avgfil(:istrln(avgfil))
      endif
c
c    ---- sampling grid concentration file ----
c
      if( lsample .AND. lsmptrc ) then
         do n = 1,nsample
           smpfil(n)(1:) = flrtsa
           if( .NOT. lcdfout ) then
              smpfil(n)(nchar+1:) = '.rt.smp'
              write(smpfil(n)(nchar+8:),'(i2.2)') n
              fname = smpfil(n)
              nopen = nopen + 1
              call getunit(iowsmp(n))
              open(unit=iowsmp(n),file=smpfil(n),ERR=7002,
     &                          form='UNFORMATTED',status='UNKNOWN')
              write(iounit,9000)
     &                 'RTRAC/PiG Sampling Grid output file  (unit):',
     &                                                       iowsmp(n)
              write(iounit,9002) smpfil(n)(:istrln(smpfil(n)))
           else
              smpfil(n)(nchar+1:) = '.rt.smp'
              write(smpfil(n)(nchar+8:),'(i2.2,a)') n,'.nc'
              fname = smpfil(n)
              nopen = nopen + 1
              action = 'Opening RTRAC PiG Sampling grid output file.'
              call ncf_createfile(fname,action,iowsmp(n))
              write(iounit,9000) 'RTRAC/PiG Sampling Grid output file:'
              write(iounit,9002) smpfil(n)(:istrln(smpfil(n)))
           endif
         enddo
      endif
c
c  --- return to calling routine ---
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
 9000 format(/,A,I8)
 9002 format(2A)
 9003 format(/,2A)
 9004 format(/,A,I3,2A)
 9005 format(/,A,I3,A,I8)
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue
      write(iounit,'(//,A)') 'ERROR in STARTRT:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Input file does not exist: ',
     &                                           fname(:istrln(fname))
      call camxerr()
c
 7001 continue
      write(iounit,'(//,A)') 'ERROR in STARTRT:'
      write(iounit,'(A)') action(:istrln(action))
      write(iounit,'(/,1X,2A)') 'Cannot open input file: ',
     &                                           fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iounit,'(//,A)') 'ERROR in STARTRT:'
      write(iounit,'(/,1X,2A)') 'Cannot open output file: ',
     &                                           fname(:istrln(fname))
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7003 continue
      write(iounit,'(//,A)') 'ERROR in STARTRT:'
      write(iounit,'(/,1X,3A,/,A)') 'Nested grid restart file for ',
     &                     tectyp(:istrln(tectyp)),' not supplied.',
     &                  ' Set Flexi_Nest = .true. to ignore this file.'
      call camxerr()
c
 7004 continue
      write(iounit,'(//,A)') 'ERROR in STARTRT:'
      write(iounit,'(/,1X,3A,/,A)') 'Nested grid emissions file for ',
     &                     tectyp(:istrln(tectyp)),' not supplied.',
     &                  ' Set Flexi_Nest = .true. to ignore this file.'
      call camxerr()
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
      return
      end

c**** NCF_RDICRT.F
c
      subroutine ncf_rdicrt(nox,noy,noz,nspsa,saconc)
      use tracer
      use grid
      use chmstry
      use rtracchm
      use filunit
      implicit none
c
c----CAMx v7.40 260801
c
c-----------------------------------------------------------------------
c    Description:
c-----------------------------------------------------------------------
c
c   This routine fils one hour of initial conditions for the RTRAC
c   species. It then places these concentrations in the  appropriate 
c   place in the gridded array used for tracer concentrations.  
c   The values are left in PPM so that they can be interpolated to
c   the nests in a later step. This version is for NetCDF files.
c
c      Copyright Ramboll
c
c      Argument description:
c       Outputs:
c           saconc   R  tracer concentrations
c       Inputs:
c           noy      I  number of Y cells in the grid
c           noz      I  number of layers in the grid
c           nspsa    I  number of tracer species
c       
c-----------------------------------------------------------------------
c    LOG:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Include files:
c-----------------------------------------------------------------------
c
      include 'camx.prm'
      include 'camx.inc'
      include 'netcdf.inc'         
c
c-----------------------------------------------------------------------
c    Arguement declarations:
c-----------------------------------------------------------------------
c
      integer   nox
      integer   noy
      integer   noz
      integer   nspsa
      real      saconc(nox,noy,noz,nspsa)
c
c-----------------------------------------------------------------------
c   External functions:
c-----------------------------------------------------------------------
c
      integer ncf_chkfile
      integer ncf_get_tstep
      integer istrln
c
c-----------------------------------------------------------------------
c    Local variables:
c-----------------------------------------------------------------------
c
      character*200 action
      character*10  aqfil, cfile, this_var, name_in
      integer       ierr, jerr, this_tstep, i, j, k, ispc
      integer       data_start(4), data_count(4), this_varid
      integer       iicdate_time_tflag, iicdate_time_etflag
      integer       irt, ifirst, itmp
      logical       lexist, luse
c
      real, allocatable, dimension(:,:,:) :: cinit
c
c-----------------------------------------------------------------------
c    Entry point:
c-----------------------------------------------------------------------
c
c  --- if no IC file provided then we skip to the end ---
c
      if( .NOT. licfil ) goto 9999
c
c  --- open the IC ---
c
      inquire(file=icfil,exist=lexist)
      if( .NOT. lexist ) goto 7000
      action = 'Opening RTRAC Initial Conditions file.'
      aqfil = 'AIRQUALITY'
      ierr = ncf_chkfile(ioric,icfil,action,aqfil)
      if( ierr .NE. ISUCES ) then
         jerr = nf_open(icfil,NF_NOWRITE,ioric)
         if( jerr .NE. NF_NOERR ) goto 7001
         aqfil = 'INITIAL   '
      else
         return
      endif
c
c  --- initailize to lower bound ---
c
      do ispc=1,nspsa
         do k=1,noz
            do j=1,noy
               do i=1,nox
                    saconc(i,j,k,ispc) = rtlbnd(ispc)
               enddo
            enddo
         enddo
      enddo
c
c --- get the type of file to make sure it is a IC file ---
c
      this_var = 'CAMx_NAME'
      name_in = ' '
      ierr = nf_get_att_text(ioric, NF_GLOBAL, this_var, name_in)
      if( ierr .NE. NF_NOERR ) then
         this_var = 'NAME'
         ierr = nf_get_att_text(ioric, NF_GLOBAL, this_var, name_in)
         if( ierr .NE. NF_NOERR ) goto 7003
      endif
      if( name_in(:10) .NE. aqfil(:10) ) goto 7002
c
c --- call routine to make sure grid defintion is consistent ---
c
      call ncf_chk_griddef(ioric,action,1,.TRUE.,.TRUE.,.FALSE.,.FALSE.,itmp)
c
c --- call routine to make sure file spans the episode ---
c
      call ncf_chk_tstep(ioric,action,begdate,begtim,begdate,begtim,.FALSE.)
c
c  --- call routine to zero out the array ---
c
      allocate( cinit(ncol(1),nrow(1),nlay(1)) )
c
c  --- set the parameters for how to read the this data ---
c
      data_start(1) = 1
      data_count(1) = ncol(1)
      data_start(2) = 1
      data_count(2) = nrow(1)
      data_start(3) = 1
      data_count(3) = nlay(1)
c
c  --- get the timestep for the first hour ---
c
      this_tstep = ncf_get_tstep(ioric,action,begdate,begtim,
     &          iicdate_time_tflag,iicdate_time_etflag,.FALSE.,.TRUE.)
      data_start(4) = this_tstep
      data_count(4) = 1
c
c  --- read the concentrations for each species ---
c
      do ispc=1,ntotsp
c
c  ---- load this species into local array ---
c
         this_var = ptname(ispc)
         ierr = nf_inq_varid(ioric,this_var,this_varid)
         if( ierr .NE. NF_NOERR ) cycle
         ierr = nf_get_vara_real(ioric,this_varid,data_start,data_count,cinit)
         if( ierr .NE. NF_NOERR) then
           write(iout,'(//,a)') 'ERROR in NCF_RDICRT:'
           write(iout,*)'Cannot read initial conditions data for species: ',
     &                                   ptname(ispc)(:istrln(ptname(ispc)))
           write(iout,'(A,I5)') 'NetCDF error code: ',ierr
           call camxerr()
         endif
c
c  --- put into global array ---
c
         do k=1,nlay(1)
            do j=2,nrow(1)-1
               do i=2,ncol(1)-1
                 if( cinit(i,j,k) .GE. rtlbnd(ispc) )
     &                       saconc(i,j,k,ispc) = cinit(i,j,k)
               enddo
            enddo
         enddo
c
c  --- check the next RTRAC species ---
c
      enddo
c
      goto 9999
c
c-----------------------------------------------------------------------
c    Error messages:
c-----------------------------------------------------------------------
c
 7000 continue 
      write(iout,'(//,A)') 'ERROR in NCF_RDICRT:'
      write(iout,*) 'ERROR:  IC file for RTRAC does not exist: ',
     &                                             icfil(:istrln(icfil))
      call camxerr()
c
 7001 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDICRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)') 'Could not open file: ',
     &                                   icfil(:istrln(icfil))
      write(iout,'(3A)') 'If this is a NCF file, check that its',
     &                   ' format is consistent with the NCF library',
     &                   ' used to build CAMx.'
      write(iout,'(2A)') 'The CAMx makefile supports netCDF3-Classic,',
     &                   ' and netCDF4 compressed or uncompressed.'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
 7002 continue
      write(iout,'(//,A)') 'ERROR in NCF_RDICRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Filetype is not correct.'
      write(iout,'(2A)',ERR=9999) 'Expecting    : ',aqfil(:istrln(aqfil))
      write(iout,'(2A)',ERR=9999) 'Value in file: ',name_in(:istrln(name_in))
      call camxerr()
c
 7003 continue
      write(iout,'(//,A)') 'ERROR in NCF__RDICRT:'
      write(iout,'(A)') action(:istrln(action))
      write(iout,'(2A)',ERR=9999) 'Cannot find global variable for ',
     &                                       'type of file: CAMx_NAME'
      write(iout,'(A,I5)') 'NetCDF error code: ',ierr
      call camxerr()
c
c-----------------------------------------------------------------------
c    Format statements:
c-----------------------------------------------------------------------
c
c-----------------------------------------------------------------------
c    Return point:
c-----------------------------------------------------------------------
c
 9999 continue
c
      return
      end
